#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 3212
#define SYMBOL_COUNT 309
#define ALIAS_COUNT 8
#define TOKEN_COUNT 142
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 38
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_await = 25,
  anon_sym_in = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  sym_jsx_text = 48,
  sym_jsx_identifier = 49,
  anon_sym_DOT = 50,
  anon_sym_class = 51,
  anon_sym_async = 52,
  anon_sym_function = 53,
  anon_sym_EQ_GT = 54,
  anon_sym_new = 55,
  anon_sym_PLUS_EQ = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_STAR_EQ = 58,
  anon_sym_SLASH_EQ = 59,
  anon_sym_PERCENT_EQ = 60,
  anon_sym_CARET_EQ = 61,
  anon_sym_AMP_EQ = 62,
  anon_sym_PIPE_EQ = 63,
  anon_sym_GT_GT_EQ = 64,
  anon_sym_GT_GT_GT_EQ = 65,
  anon_sym_LT_LT_EQ = 66,
  anon_sym_STAR_STAR_EQ = 67,
  anon_sym_DOT_DOT_DOT = 68,
  anon_sym_QMARK = 69,
  anon_sym_AMP_AMP = 70,
  anon_sym_PIPE_PIPE = 71,
  anon_sym_GT_GT = 72,
  anon_sym_GT_GT_GT = 73,
  anon_sym_LT_LT = 74,
  anon_sym_AMP = 75,
  anon_sym_CARET = 76,
  anon_sym_PIPE = 77,
  anon_sym_PLUS = 78,
  anon_sym_DASH = 79,
  anon_sym_PERCENT = 80,
  anon_sym_STAR_STAR = 81,
  anon_sym_LT_EQ = 82,
  anon_sym_EQ_EQ = 83,
  anon_sym_EQ_EQ_EQ = 84,
  anon_sym_BANG_EQ = 85,
  anon_sym_BANG_EQ_EQ = 86,
  anon_sym_GT_EQ = 87,
  anon_sym_instanceof = 88,
  anon_sym_BANG = 89,
  anon_sym_TILDE = 90,
  anon_sym_void = 91,
  anon_sym_delete = 92,
  anon_sym_PLUS_PLUS = 93,
  anon_sym_DASH_DASH = 94,
  anon_sym_DQUOTE = 95,
  aux_sym_string_token1 = 96,
  anon_sym_SQUOTE = 97,
  aux_sym_string_token2 = 98,
  sym_escape_sequence = 99,
  sym_comment = 100,
  anon_sym_BQUOTE = 101,
  anon_sym_DOLLAR_LBRACE = 102,
  anon_sym_SLASH2 = 103,
  sym_regex_pattern = 104,
  sym_regex_flags = 105,
  sym_number = 106,
  anon_sym_target = 107,
  sym_this = 108,
  sym_super = 109,
  sym_true = 110,
  sym_false = 111,
  sym_null = 112,
  sym_undefined = 113,
  anon_sym_AT = 114,
  anon_sym_static = 115,
  anon_sym_abstract = 116,
  anon_sym_get = 117,
  anon_sym_set = 118,
  anon_sym_declare = 119,
  anon_sym_public = 120,
  anon_sym_private = 121,
  anon_sym_protected = 122,
  anon_sym_module = 123,
  anon_sym_any = 124,
  anon_sym_number = 125,
  anon_sym_boolean = 126,
  anon_sym_string = 127,
  anon_sym_symbol = 128,
  anon_sym_require = 129,
  anon_sym_implements = 130,
  anon_sym_global = 131,
  anon_sym_interface = 132,
  anon_sym_extends = 133,
  anon_sym_enum = 134,
  sym_readonly = 135,
  anon_sym_is = 136,
  anon_sym_keyof = 137,
  anon_sym_LBRACE_PIPE = 138,
  anon_sym_PIPE_RBRACE = 139,
  sym__automatic_semicolon = 140,
  sym__template_chars = 141,
  sym_program = 142,
  sym_export_statement = 143,
  sym_export_clause = 144,
  sym__import_export_specifier = 145,
  sym__declaration = 146,
  sym_import = 147,
  sym_import_statement = 148,
  sym_import_clause = 149,
  sym__from_clause = 150,
  sym_namespace_import = 151,
  sym_named_imports = 152,
  sym_expression_statement = 153,
  sym_variable_declaration = 154,
  sym_lexical_declaration = 155,
  sym_variable_declarator = 156,
  sym_statement_block = 157,
  sym_if_statement = 158,
  sym_switch_statement = 159,
  sym_for_statement = 160,
  sym_for_in_statement = 161,
  sym__for_header = 162,
  sym_while_statement = 163,
  sym_do_statement = 164,
  sym_try_statement = 165,
  sym_with_statement = 166,
  sym_break_statement = 167,
  sym_continue_statement = 168,
  sym_debugger_statement = 169,
  sym_return_statement = 170,
  sym_throw_statement = 171,
  sym_empty_statement = 172,
  sym_labeled_statement = 173,
  sym_switch_body = 174,
  sym_switch_case = 175,
  sym_switch_default = 176,
  sym_catch_clause = 177,
  sym_finally_clause = 178,
  sym_parenthesized_expression = 179,
  sym__expression = 180,
  sym_yield_expression = 181,
  sym_object = 182,
  sym_assignment_pattern = 183,
  sym_array = 184,
  sym_jsx_element = 185,
  sym_jsx_fragment = 186,
  sym_jsx_expression = 187,
  sym_jsx_opening_element = 188,
  sym_nested_identifier = 189,
  sym_jsx_namespace_name = 190,
  sym_jsx_closing_element = 191,
  sym_jsx_self_closing_element = 192,
  sym_jsx_attribute = 193,
  sym_class = 194,
  sym_class_declaration = 195,
  sym_class_heritage = 196,
  sym_function = 197,
  sym_function_declaration = 198,
  sym_generator_function = 199,
  sym_generator_function_declaration = 200,
  sym_arrow_function = 201,
  sym__call_signature = 202,
  sym_call_expression = 203,
  sym_new_expression = 204,
  sym_await_expression = 205,
  sym_member_expression = 206,
  sym_subscript_expression = 207,
  sym_assignment_expression = 208,
  sym_augmented_assignment_expression = 209,
  sym__initializer = 210,
  sym_spread_element = 211,
  sym_ternary_expression = 212,
  sym_binary_expression = 213,
  sym_unary_expression = 214,
  sym_update_expression = 215,
  sym_sequence_expression = 216,
  sym_string = 217,
  sym_template_string = 218,
  sym_template_substitution = 219,
  sym_regex = 220,
  sym_meta_property = 221,
  sym_arguments = 222,
  sym_decorator = 223,
  sym_decorator_member_expression = 224,
  sym_decorator_call_expression = 225,
  sym_class_body = 226,
  sym_public_field_definition = 227,
  sym_formal_parameters = 228,
  sym_rest_parameter = 229,
  sym_method_definition = 230,
  sym_pair = 231,
  sym__property_name = 232,
  sym_computed_property_name = 233,
  sym_non_null_expression = 234,
  sym_method_signature = 235,
  sym_abstract_method_signature = 236,
  sym_function_signature = 237,
  sym_as_expression = 238,
  sym_import_require_clause = 239,
  sym_implements_clause = 240,
  sym_ambient_declaration = 241,
  sym_abstract_class_declaration = 242,
  sym_module = 243,
  sym_internal_module = 244,
  sym__module = 245,
  sym_import_alias = 246,
  sym_nested_type_identifier = 247,
  sym_interface_declaration = 248,
  sym_extends_clause = 249,
  sym_enum_declaration = 250,
  sym_enum_body = 251,
  sym_enum_assignment = 252,
  sym_type_alias_declaration = 253,
  sym_accessibility_modifier = 254,
  sym_required_parameter = 255,
  sym_optional_parameter = 256,
  sym__parameter_name = 257,
  sym_type_annotation = 258,
  sym__type = 259,
  sym_constructor_type = 260,
  sym__primary_type = 261,
  sym_generic_type = 262,
  sym_type_predicate = 263,
  sym_type_query = 264,
  sym_index_type_query = 265,
  sym_lookup_type = 266,
  sym_mapped_type_clause = 267,
  sym_literal_type = 268,
  sym__number = 269,
  sym_existential_type = 270,
  sym_flow_maybe_type = 271,
  sym_parenthesized_type = 272,
  sym_predefined_type = 273,
  sym_type_arguments = 274,
  sym_object_type = 275,
  sym_call_signature = 276,
  sym_property_signature = 277,
  sym_type_parameters = 278,
  sym_type_parameter = 279,
  sym_default_type = 280,
  sym_constraint = 281,
  sym_construct_signature = 282,
  sym_index_signature = 283,
  sym_array_type = 284,
  sym_tuple_type = 285,
  sym_union_type = 286,
  sym_intersection_type = 287,
  sym_function_type = 288,
  aux_sym_program_repeat1 = 289,
  aux_sym_export_statement_repeat1 = 290,
  aux_sym_export_clause_repeat1 = 291,
  aux_sym_named_imports_repeat1 = 292,
  aux_sym_variable_declaration_repeat1 = 293,
  aux_sym_switch_body_repeat1 = 294,
  aux_sym_object_repeat1 = 295,
  aux_sym_array_repeat1 = 296,
  aux_sym_jsx_element_repeat1 = 297,
  aux_sym_jsx_opening_element_repeat1 = 298,
  aux_sym_string_repeat1 = 299,
  aux_sym_string_repeat2 = 300,
  aux_sym_template_string_repeat1 = 301,
  aux_sym_class_body_repeat1 = 302,
  aux_sym_formal_parameters_repeat1 = 303,
  aux_sym_implements_clause_repeat1 = 304,
  aux_sym_extends_clause_repeat1 = 305,
  aux_sym_enum_body_repeat1 = 306,
  aux_sym_object_type_repeat1 = 307,
  aux_sym_type_parameters_repeat1 = 308,
  alias_sym_array_pattern = 309,
  alias_sym_export_specifier = 310,
  alias_sym_import_specifier = 311,
  alias_sym_object_pattern = 312,
  alias_sym_property_identifier = 313,
  alias_sym_shorthand_property_identifier = 314,
  alias_sym_statement_identifier = 315,
  alias_sym_type_identifier = 316,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_jsx_opening_element_repeat1] = "jsx_opening_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constructor = 10,
  field_declaration = 11,
  field_decorator = 12,
  field_finalizer = 13,
  field_flags = 14,
  field_function = 15,
  field_handler = 16,
  field_increment = 17,
  field_index = 18,
  field_initializer = 19,
  field_key = 20,
  field_label = 21,
  field_left = 22,
  field_module = 23,
  field_name = 24,
  field_object = 25,
  field_open_tag = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_return_type = 32,
  field_right = 33,
  field_source = 34,
  field_type = 35,
  field_type_arguments = 36,
  field_type_parameters = 37,
  field_value = 38,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 2},
  [25] = {.index = 24, .length = 1},
  [26] = {.index = 25, .length = 2},
  [27] = {.index = 27, .length = 2},
  [28] = {.index = 29, .length = 2},
  [30] = {.index = 31, .length = 2},
  [31] = {.index = 33, .length = 2},
  [32] = {.index = 31, .length = 2},
  [33] = {.index = 33, .length = 2},
  [34] = {.index = 31, .length = 2},
  [35] = {.index = 33, .length = 2},
  [36] = {.index = 35, .length = 2},
  [37] = {.index = 37, .length = 2},
  [38] = {.index = 39, .length = 3},
  [41] = {.index = 42, .length = 1},
  [42] = {.index = 43, .length = 2},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 49, .length = 2},
  [46] = {.index = 51, .length = 1},
  [47] = {.index = 52, .length = 1},
  [48] = {.index = 53, .length = 1},
  [49] = {.index = 54, .length = 1},
  [50] = {.index = 55, .length = 2},
  [52] = {.index = 57, .length = 1},
  [53] = {.index = 58, .length = 2},
  [54] = {.index = 60, .length = 4},
  [55] = {.index = 64, .length = 2},
  [56] = {.index = 64, .length = 2},
  [57] = {.index = 22, .length = 2},
  [58] = {.index = 25, .length = 2},
  [59] = {.index = 27, .length = 2},
  [60] = {.index = 66, .length = 3},
  [61] = {.index = 10, .length = 2},
  [62] = {.index = 55, .length = 2},
  [63] = {.index = 69, .length = 3},
  [64] = {.index = 22, .length = 2},
  [65] = {.index = 22, .length = 2},
  [66] = {.index = 72, .length = 2},
  [67] = {.index = 74, .length = 4},
  [68] = {.index = 78, .length = 3},
  [69] = {.index = 81, .length = 2},
  [70] = {.index = 83, .length = 1},
  [71] = {.index = 84, .length = 1},
  [72] = {.index = 85, .length = 1},
  [73] = {.index = 86, .length = 2},
  [74] = {.index = 22, .length = 2},
  [75] = {.index = 88, .length = 2},
  [76] = {.index = 90, .length = 5},
  [77] = {.index = 86, .length = 2},
  [78] = {.index = 95, .length = 1},
  [79] = {.index = 96, .length = 3},
  [80] = {.index = 96, .length = 3},
  [81] = {.index = 96, .length = 3},
  [82] = {.index = 99, .length = 2},
  [83] = {.index = 101, .length = 3},
  [87] = {.index = 104, .length = 1},
  [88] = {.index = 105, .length = 3},
  [89] = {.index = 108, .length = 2},
  [90] = {.index = 110, .length = 2},
  [91] = {.index = 112, .length = 2},
  [92] = {.index = 114, .length = 2},
  [93] = {.index = 116, .length = 4},
  [94] = {.index = 120, .length = 2},
  [95] = {.index = 122, .length = 3},
  [96] = {.index = 125, .length = 3},
  [97] = {.index = 128, .length = 2},
  [98] = {.index = 130, .length = 2},
  [99] = {.index = 132, .length = 4},
  [100] = {.index = 130, .length = 2},
  [101] = {.index = 136, .length = 4},
  [102] = {.index = 140, .length = 4},
  [103] = {.index = 144, .length = 5},
  [104] = {.index = 149, .length = 2},
  [105] = {.index = 99, .length = 2},
  [106] = {.index = 151, .length = 3},
  [107] = {.index = 154, .length = 2},
  [108] = {.index = 156, .length = 3},
  [109] = {.index = 159, .length = 2},
  [110] = {.index = 161, .length = 5},
  [111] = {.index = 166, .length = 2},
  [112] = {.index = 168, .length = 1},
  [113] = {.index = 169, .length = 3},
  [114] = {.index = 172, .length = 1},
  [115] = {.index = 173, .length = 1},
  [116] = {.index = 174, .length = 1},
  [117] = {.index = 175, .length = 2},
  [118] = {.index = 177, .length = 3},
  [119] = {.index = 180, .length = 1},
  [120] = {.index = 181, .length = 2},
  [121] = {.index = 183, .length = 2},
  [122] = {.index = 185, .length = 4},
  [123] = {.index = 189, .length = 2},
  [124] = {.index = 191, .length = 2},
  [125] = {.index = 193, .length = 3},
  [126] = {.index = 196, .length = 2},
  [127] = {.index = 198, .length = 4},
  [128] = {.index = 202, .length = 4},
  [129] = {.index = 206, .length = 5},
  [130] = {.index = 211, .length = 2},
  [131] = {.index = 213, .length = 3},
  [132] = {.index = 216, .length = 3},
  [133] = {.index = 219, .length = 2},
  [134] = {.index = 221, .length = 3},
  [135] = {.index = 224, .length = 4},
  [136] = {.index = 228, .length = 3},
  [137] = {.index = 231, .length = 2},
  [138] = {.index = 233, .length = 5},
  [139] = {.index = 238, .length = 3},
  [140] = {.index = 241, .length = 2},
  [141] = {.index = 241, .length = 2},
  [142] = {.index = 243, .length = 3},
  [143] = {.index = 241, .length = 2},
  [144] = {.index = 241, .length = 2},
  [145] = {.index = 246, .length = 2},
  [146] = {.index = 248, .length = 4},
  [147] = {.index = 252, .length = 2},
  [148] = {.index = 254, .length = 2},
  [149] = {.index = 256, .length = 2},
  [150] = {.index = 258, .length = 2},
  [151] = {.index = 260, .length = 3},
  [152] = {.index = 263, .length = 3},
  [153] = {.index = 266, .length = 1},
  [154] = {.index = 267, .length = 5},
  [155] = {.index = 272, .length = 3},
  [157] = {.index = 275, .length = 4},
  [158] = {.index = 279, .length = 5},
  [159] = {.index = 284, .length = 2},
  [160] = {.index = 284, .length = 2},
  [161] = {.index = 284, .length = 2},
  [162] = {.index = 284, .length = 2},
  [163] = {.index = 286, .length = 4},
  [164] = {.index = 290, .length = 2},
  [165] = {.index = 290, .length = 2},
  [166] = {.index = 290, .length = 2},
  [167] = {.index = 292, .length = 4},
  [168] = {.index = 296, .length = 4},
  [169] = {.index = 300, .length = 2},
  [170] = {.index = 302, .length = 2},
  [171] = {.index = 304, .length = 3},
  [172] = {.index = 307, .length = 3},
  [173] = {.index = 310, .length = 2},
  [174] = {.index = 312, .length = 2},
  [175] = {.index = 314, .length = 5},
  [176] = {.index = 319, .length = 5},
  [177] = {.index = 324, .length = 4},
  [178] = {.index = 328, .length = 4},
  [179] = {.index = 332, .length = 3},
  [180] = {.index = 335, .length = 2},
  [181] = {.index = 337, .length = 2},
  [182] = {.index = 339, .length = 3},
  [183] = {.index = 342, .length = 5},
  [184] = {.index = 347, .length = 5},
  [185] = {.index = 352, .length = 4},
  [186] = {.index = 356, .length = 4},
  [187] = {.index = 360, .length = 3},
  [188] = {.index = 363, .length = 5},
  [189] = {.index = 368, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_arguments, 1},
    {field_function, 0},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [16] =
    {field_parameters, 0},
    {field_return_type, 1},
  [18] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [20] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [22] =
    {field_left, 0},
    {field_right, 2},
  [24] =
    {field_label, 0},
  [25] =
    {field_object, 0},
    {field_property, 2},
  [27] =
    {field_body, 2},
    {field_parameter, 0},
  [29] =
    {field_body, 1},
    {field_name, 0},
  [31] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [33] =
    {field_name, 0},
    {field_type, 1},
  [35] =
    {field_condition, 1},
    {field_consequence, 2},
  [37] =
    {field_body, 2},
    {field_value, 1},
  [39] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [42] =
    {field_value, 1, .inherited = true},
  [43] =
    {field_body, 2},
    {field_condition, 1},
  [45] =
    {field_body, 1},
    {field_handler, 2},
  [47] =
    {field_body, 1},
    {field_finalizer, 2},
  [49] =
    {field_body, 2},
    {field_object, 1},
  [51] =
    {field_label, 1},
  [52] =
    {field_name, 1},
  [53] =
    {field_attribute, 0},
  [54] =
    {field_pattern, 1},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_body, 2},
  [58] =
    {field_body, 2},
    {field_type_parameters, 1},
  [60] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [64] =
    {field_arguments, 2},
    {field_constructor, 1},
  [66] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [69] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [72] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [74] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [78] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [81] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [83] =
    {field_source, 1},
  [84] =
    {field_source, 2, .inherited = true},
  [85] =
    {field_value, 2},
  [86] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [88] =
    {field_key, 0},
    {field_value, 2},
  [90] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [95] =
    {field_value, 1},
  [96] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [99] =
    {field_body, 3},
    {field_name, 2},
  [101] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [104] =
    {field_value, 2, .inherited = true},
  [105] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [108] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [110] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [112] =
    {field_name, 1},
    {field_type_arguments, 2},
  [114] =
    {field_flags, 3},
    {field_pattern, 1},
  [116] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [120] =
    {field_body, 3},
    {field_name, 1},
  [122] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [125] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [128] =
    {field_body, 3},
    {field_type_parameters, 1},
  [130] =
    {field_body, 3},
    {field_parameter, 1},
  [132] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [136] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [140] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [144] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [149] =
    {field_index, 2},
    {field_object, 0},
  [151] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [154] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [156] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [159] =
    {field_alias, 2},
    {field_name, 0},
  [161] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [166] =
    {field_name, 1},
    {field_value, 3},
  [168] =
    {field_source, 3, .inherited = true},
  [169] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [172] =
    {field_decorator, 1, .inherited = true},
  [173] =
    {field_decorator, 2, .inherited = true},
  [174] =
    {field_value, 3, .inherited = true},
  [175] =
    {field_body, 1},
    {field_condition, 3},
  [177] =
    {field_attribute, 3, .inherited = true},
    {field_name, 1},
    {field_type_arguments, 2},
  [180] =
    {field_name, 2},
  [181] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [183] =
    {field_name, 1},
    {field_type, 2},
  [185] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [189] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [191] =
    {field_name, 0},
    {field_type, 2},
  [193] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [196] =
    {field_module, 0},
    {field_name, 2},
  [198] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [202] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [206] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [211] =
    {field_body, 4},
    {field_name, 2},
  [213] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [216] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [219] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [221] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [224] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [228] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [231] =
    {field_alias, 3},
    {field_name, 1},
  [233] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [238] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [241] =
    {field_left, 1},
    {field_right, 3},
  [243] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [246] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [248] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [252] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [254] =
    {field_name, 2},
    {field_type, 3},
  [256] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [258] =
    {field_name, 1},
    {field_type, 3},
  [260] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [263] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [266] =
    {field_name, 3},
  [267] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [272] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [275] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [279] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [284] =
    {field_left, 2},
    {field_right, 4},
  [286] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [290] =
    {field_body, 4},
    {field_parameter, 2},
  [292] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [296] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [300] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [302] =
    {field_name, 2},
    {field_type, 4},
  [304] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [307] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [310] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [312] =
    {field_name, 3},
    {field_type, 4},
  [314] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [319] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [324] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [328] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [332] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [335] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [337] =
    {field_name, 3},
    {field_type, 5},
  [339] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [342] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [347] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [352] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [356] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [360] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [363] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [368] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[190][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = sym_identifier,
  },
  [24] = {
    [0] = sym_identifier,
  },
  [25] = {
    [0] = alias_sym_statement_identifier,
  },
  [26] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [29] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_object_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [35] = {
    [0] = alias_sym_array_pattern,
  },
  [39] = {
    [1] = alias_sym_object_pattern,
  },
  [40] = {
    [1] = alias_sym_array_pattern,
  },
  [46] = {
    [1] = alias_sym_statement_identifier,
  },
  [50] = {
    [1] = alias_sym_type_identifier,
  },
  [51] = {
    [1] = alias_sym_type_identifier,
  },
  [55] = {
    [1] = sym_identifier,
  },
  [58] = {
    [2] = alias_sym_property_identifier,
  },
  [61] = {
    [0] = sym_identifier,
  },
  [64] = {
    [0] = alias_sym_object_pattern,
  },
  [65] = {
    [0] = alias_sym_array_pattern,
  },
  [73] = {
    [1] = alias_sym_export_specifier,
  },
  [74] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [77] = {
    [1] = alias_sym_import_specifier,
  },
  [80] = {
    [0] = alias_sym_object_pattern,
  },
  [81] = {
    [0] = alias_sym_array_pattern,
  },
  [84] = {
    [2] = sym_identifier,
  },
  [85] = {
    [2] = alias_sym_object_pattern,
  },
  [86] = {
    [2] = alias_sym_array_pattern,
  },
  [94] = {
    [1] = alias_sym_type_identifier,
  },
  [95] = {
    [1] = alias_sym_type_identifier,
  },
  [98] = {
    [1] = sym_identifier,
  },
  [105] = {
    [2] = alias_sym_type_identifier,
  },
  [106] = {
    [2] = alias_sym_type_identifier,
  },
  [111] = {
    [1] = alias_sym_type_identifier,
  },
  [125] = {
    [1] = alias_sym_type_identifier,
  },
  [126] = {
    [2] = alias_sym_type_identifier,
  },
  [130] = {
    [2] = alias_sym_type_identifier,
  },
  [131] = {
    [2] = alias_sym_type_identifier,
  },
  [134] = {
    [2] = alias_sym_type_identifier,
  },
  [135] = {
    [2] = alias_sym_type_identifier,
  },
  [139] = {
    [1] = alias_sym_type_identifier,
  },
  [140] = {
    [1] = sym_identifier,
  },
  [143] = {
    [1] = alias_sym_object_pattern,
  },
  [144] = {
    [1] = alias_sym_array_pattern,
  },
  [155] = {
    [2] = alias_sym_type_identifier,
  },
  [156] = {
    [3] = alias_sym_property_identifier,
  },
  [157] = {
    [2] = alias_sym_type_identifier,
  },
  [159] = {
    [2] = sym_identifier,
  },
  [161] = {
    [2] = alias_sym_object_pattern,
  },
  [162] = {
    [2] = alias_sym_array_pattern,
  },
  [165] = {
    [2] = alias_sym_object_pattern,
  },
  [166] = {
    [2] = alias_sym_array_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0) ADVANCE(67);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '$') ADVANCE(196);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(181);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0) ADVANCE(197);
      END_STATE();
    case 1:
      if (lookahead == 0) ADVANCE(67);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '$') ADVANCE(196);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0) ADVANCE(197);
      END_STATE();
    case 2:
      if (lookahead == 0) ADVANCE(67);
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(133);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(197);
      END_STATE();
    case 3:
      if (lookahead == 0) ADVANCE(67);
      if (lookahead == '!') ADVANCE(151);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(134);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(197);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(25)
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(168);
      if (lookahead != 0) ADVANCE(169);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(164);
      if (lookahead == '\r') ADVANCE(171);
      if (lookahead == 'u') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(21)
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(7);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0) ADVANCE(162);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(157);
      if (lookahead == '\r') ADVANCE(172);
      if (lookahead == 'u') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(31)
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '[') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(182);
      if (lookahead != 0) ADVANCE(183);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(131);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(197);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(126);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(91);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(88);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '^') ADVANCE(128);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(130);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(197);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(100);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(197);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == ';') ADVANCE(80);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '}') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(152);
      if (lookahead == '%') ADVANCE(141);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(86);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '>') ADVANCE(89);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(68);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(151);
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '~') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(197);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(181);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '@') ADVANCE(198);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(197);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '?') ADVANCE(115);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '{') ADVANCE(75);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(195);
      if (lookahead != 0 &&
          (lookahead < '!' || '~' < lookahead)) ADVANCE(197);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(156);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      END_STATE();
    case 22:
      if (lookahead == '$') ADVANCE(38);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(37);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      END_STATE();
    case 23:
      if (lookahead == '$') ADVANCE(38);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '(') ADVANCE(78);
      if (lookahead == ')') ADVANCE(79);
      if (lookahead == ',') ADVANCE(76);
      if (lookahead == '.') ADVANCE(98);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == ':') ADVANCE(81);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(87);
      if (lookahead == '[') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(83);
      if (lookahead == '`') ADVANCE(179);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(24)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(195);
      if (lookahead != 0 &&
          (lookahead < '!' || '~' < lookahead)) ADVANCE(197);
      END_STATE();
    case 25:
      if (lookahead == '\'') ADVANCE(163);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(25)
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(178);
      END_STATE();
    case 27:
      if (lookahead == '*') ADVANCE(27);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead != 0) ADVANCE(28);
      END_STATE();
    case 28:
      if (lookahead == '*') ADVANCE(27);
      if (lookahead != 0) ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(114);
      END_STATE();
    case 31:
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(31)
      END_STATE();
    case 32:
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '<') ADVANCE(84);
      if (lookahead == '{') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 33:
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 34:
      if (lookahead == '\\') ADVANCE(65);
      if (lookahead == ']') ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(34);
      END_STATE();
    case 35:
      if (lookahead == 'u') ADVANCE(39);
      if (lookahead == 'x') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(175);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(180);
      END_STATE();
    case 39:
      if (lookahead == '{') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 40:
      if (lookahead == '{') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 41:
      if (lookahead == '{') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 42:
      if (lookahead == '}') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == '}') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 44:
      if (lookahead == '}') ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 46:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(188);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(189);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(187);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(191);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(197);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(170);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(190);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(173);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(42);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 62:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 63:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 64:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 65:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(34);
      END_STATE();
    case 66:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(183);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(68);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(143);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(146);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(199);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(178);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(94);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(93);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(28);
      if (lookahead != 0) ADVANCE(94);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(93);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(28);
      if (lookahead != 0) ADVANCE(94);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(92);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(97);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(116);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '|') ADVANCE(117);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '|') ADVANCE(117);
      if (lookahead == '}') ADVANCE(200);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(117);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(117);
      if (lookahead == '}') ADVANCE(200);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(200);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(154);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(154);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(155);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(155);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(160);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(167);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(166);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(164);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(157);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(170);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(174);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(178);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(28);
      if (lookahead == '/') ADVANCE(178);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(26);
      if (lookahead == '[') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(183);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(36);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == '0') ADVANCE(191);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(46);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(45);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(47);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(54);
      if (lookahead == '_') ADVANCE(50);
      if (lookahead == 'n') ADVANCE(185);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(187);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(194);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(45);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(187);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(185);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(54);
      if (lookahead == 'n') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(190);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(50);
      if (lookahead == 'n') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(45);
      if (lookahead == '_') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(193);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(195);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == '{') ADVANCE(180);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(82);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(88);
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'q') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'y') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w') ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y') ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's') ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 3},
  [2] = {.lex_state = 3},
  [3] = {.lex_state = 3},
  [4] = {.lex_state = 3},
  [5] = {.lex_state = 3},
  [6] = {.lex_state = 3},
  [7] = {.lex_state = 3},
  [8] = {.lex_state = 3},
  [9] = {.lex_state = 3},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 3},
  [12] = {.lex_state = 3},
  [13] = {.lex_state = 3},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 3},
  [16] = {.lex_state = 3},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 3},
  [19] = {.lex_state = 3},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 3},
  [22] = {.lex_state = 3},
  [23] = {.lex_state = 3},
  [24] = {.lex_state = 3},
  [25] = {.lex_state = 3},
  [26] = {.lex_state = 3},
  [27] = {.lex_state = 3},
  [28] = {.lex_state = 3},
  [29] = {.lex_state = 3},
  [30] = {.lex_state = 3},
  [31] = {.lex_state = 3},
  [32] = {.lex_state = 3},
  [33] = {.lex_state = 3},
  [34] = {.lex_state = 3},
  [35] = {.lex_state = 3},
  [36] = {.lex_state = 3},
  [37] = {.lex_state = 3},
  [38] = {.lex_state = 3},
  [39] = {.lex_state = 3},
  [40] = {.lex_state = 3},
  [41] = {.lex_state = 3},
  [42] = {.lex_state = 3},
  [43] = {.lex_state = 3},
  [44] = {.lex_state = 3},
  [45] = {.lex_state = 3},
  [46] = {.lex_state = 3},
  [47] = {.lex_state = 3},
  [48] = {.lex_state = 3},
  [49] = {.lex_state = 3},
  [50] = {.lex_state = 3},
  [51] = {.lex_state = 3},
  [52] = {.lex_state = 3},
  [53] = {.lex_state = 3},
  [54] = {.lex_state = 3},
  [55] = {.lex_state = 3},
  [56] = {.lex_state = 3},
  [57] = {.lex_state = 9, .external_lex_state = 2},
  [58] = {.lex_state = 9, .external_lex_state = 2},
  [59] = {.lex_state = 9, .external_lex_state = 2},
  [60] = {.lex_state = 9, .external_lex_state = 3},
  [61] = {.lex_state = 9, .external_lex_state = 2},
  [62] = {.lex_state = 9, .external_lex_state = 3},
  [63] = {.lex_state = 9, .external_lex_state = 2},
  [64] = {.lex_state = 9, .external_lex_state = 3},
  [65] = {.lex_state = 9, .external_lex_state = 3},
  [66] = {.lex_state = 9, .external_lex_state = 2},
  [67] = {.lex_state = 9, .external_lex_state = 3},
  [68] = {.lex_state = 9, .external_lex_state = 2},
  [69] = {.lex_state = 9, .external_lex_state = 2},
  [70] = {.lex_state = 9, .external_lex_state = 2},
  [71] = {.lex_state = 9, .external_lex_state = 2},
  [72] = {.lex_state = 9, .external_lex_state = 2},
  [73] = {.lex_state = 9, .external_lex_state = 3},
  [74] = {.lex_state = 9, .external_lex_state = 2},
  [75] = {.lex_state = 10, .external_lex_state = 3},
  [76] = {.lex_state = 9, .external_lex_state = 3},
  [77] = {.lex_state = 9, .external_lex_state = 3},
  [78] = {.lex_state = 9, .external_lex_state = 3},
  [79] = {.lex_state = 9, .external_lex_state = 3},
  [80] = {.lex_state = 9, .external_lex_state = 3},
  [81] = {.lex_state = 9, .external_lex_state = 2},
  [82] = {.lex_state = 9, .external_lex_state = 2},
  [83] = {.lex_state = 9, .external_lex_state = 3},
  [84] = {.lex_state = 10, .external_lex_state = 3},
  [85] = {.lex_state = 9, .external_lex_state = 3},
  [86] = {.lex_state = 9, .external_lex_state = 3},
  [87] = {.lex_state = 9, .external_lex_state = 3},
  [88] = {.lex_state = 10, .external_lex_state = 3},
  [89] = {.lex_state = 9, .external_lex_state = 3},
  [90] = {.lex_state = 9, .external_lex_state = 3},
  [91] = {.lex_state = 17},
  [92] = {.lex_state = 17},
  [93] = {.lex_state = 17},
  [94] = {.lex_state = 17},
  [95] = {.lex_state = 17},
  [96] = {.lex_state = 17},
  [97] = {.lex_state = 17},
  [98] = {.lex_state = 17},
  [99] = {.lex_state = 17},
  [100] = {.lex_state = 17},
  [101] = {.lex_state = 17},
  [102] = {.lex_state = 17},
  [103] = {.lex_state = 17},
  [104] = {.lex_state = 17},
  [105] = {.lex_state = 2, .external_lex_state = 3},
  [106] = {.lex_state = 17},
  [107] = {.lex_state = 17},
  [108] = {.lex_state = 2, .external_lex_state = 2},
  [109] = {.lex_state = 2, .external_lex_state = 3},
  [110] = {.lex_state = 2, .external_lex_state = 3},
  [111] = {.lex_state = 2, .external_lex_state = 2},
  [112] = {.lex_state = 11, .external_lex_state = 3},
  [113] = {.lex_state = 2, .external_lex_state = 2},
  [114] = {.lex_state = 2, .external_lex_state = 2},
  [115] = {.lex_state = 2, .external_lex_state = 2},
  [116] = {.lex_state = 2, .external_lex_state = 2},
  [117] = {.lex_state = 2, .external_lex_state = 2},
  [118] = {.lex_state = 2, .external_lex_state = 2},
  [119] = {.lex_state = 2, .external_lex_state = 2},
  [120] = {.lex_state = 2, .external_lex_state = 2},
  [121] = {.lex_state = 2, .external_lex_state = 2},
  [122] = {.lex_state = 2, .external_lex_state = 2},
  [123] = {.lex_state = 2, .external_lex_state = 2},
  [124] = {.lex_state = 2, .external_lex_state = 2},
  [125] = {.lex_state = 2, .external_lex_state = 2},
  [126] = {.lex_state = 2, .external_lex_state = 2},
  [127] = {.lex_state = 2, .external_lex_state = 2},
  [128] = {.lex_state = 2, .external_lex_state = 2},
  [129] = {.lex_state = 2, .external_lex_state = 2},
  [130] = {.lex_state = 2, .external_lex_state = 2},
  [131] = {.lex_state = 2, .external_lex_state = 2},
  [132] = {.lex_state = 2, .external_lex_state = 2},
  [133] = {.lex_state = 2, .external_lex_state = 2},
  [134] = {.lex_state = 2, .external_lex_state = 2},
  [135] = {.lex_state = 2, .external_lex_state = 2},
  [136] = {.lex_state = 2, .external_lex_state = 2},
  [137] = {.lex_state = 2, .external_lex_state = 2},
  [138] = {.lex_state = 2, .external_lex_state = 2},
  [139] = {.lex_state = 2, .external_lex_state = 2},
  [140] = {.lex_state = 3},
  [141] = {.lex_state = 3},
  [142] = {.lex_state = 3},
  [143] = {.lex_state = 3},
  [144] = {.lex_state = 3},
  [145] = {.lex_state = 3},
  [146] = {.lex_state = 3},
  [147] = {.lex_state = 3},
  [148] = {.lex_state = 3},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 3},
  [151] = {.lex_state = 3},
  [152] = {.lex_state = 3},
  [153] = {.lex_state = 3},
  [154] = {.lex_state = 3},
  [155] = {.lex_state = 3},
  [156] = {.lex_state = 3},
  [157] = {.lex_state = 3},
  [158] = {.lex_state = 3},
  [159] = {.lex_state = 3},
  [160] = {.lex_state = 3},
  [161] = {.lex_state = 3},
  [162] = {.lex_state = 3},
  [163] = {.lex_state = 3},
  [164] = {.lex_state = 3},
  [165] = {.lex_state = 3},
  [166] = {.lex_state = 3},
  [167] = {.lex_state = 3},
  [168] = {.lex_state = 3},
  [169] = {.lex_state = 3},
  [170] = {.lex_state = 3, .external_lex_state = 4},
  [171] = {.lex_state = 3},
  [172] = {.lex_state = 3},
  [173] = {.lex_state = 3},
  [174] = {.lex_state = 3},
  [175] = {.lex_state = 3},
  [176] = {.lex_state = 3},
  [177] = {.lex_state = 3},
  [178] = {.lex_state = 3},
  [179] = {.lex_state = 3},
  [180] = {.lex_state = 3},
  [181] = {.lex_state = 3},
  [182] = {.lex_state = 3},
  [183] = {.lex_state = 3},
  [184] = {.lex_state = 3},
  [185] = {.lex_state = 3},
  [186] = {.lex_state = 3},
  [187] = {.lex_state = 3},
  [188] = {.lex_state = 3},
  [189] = {.lex_state = 3},
  [190] = {.lex_state = 3},
  [191] = {.lex_state = 3},
  [192] = {.lex_state = 3},
  [193] = {.lex_state = 3},
  [194] = {.lex_state = 3},
  [195] = {.lex_state = 3},
  [196] = {.lex_state = 9, .external_lex_state = 2},
  [197] = {.lex_state = 3},
  [198] = {.lex_state = 3},
  [199] = {.lex_state = 3},
  [200] = {.lex_state = 3},
  [201] = {.lex_state = 3},
  [202] = {.lex_state = 3},
  [203] = {.lex_state = 3},
  [204] = {.lex_state = 3},
  [205] = {.lex_state = 3},
  [206] = {.lex_state = 3},
  [207] = {.lex_state = 3},
  [208] = {.lex_state = 3},
  [209] = {.lex_state = 3},
  [210] = {.lex_state = 3},
  [211] = {.lex_state = 3},
  [212] = {.lex_state = 3},
  [213] = {.lex_state = 3},
  [214] = {.lex_state = 3},
  [215] = {.lex_state = 3},
  [216] = {.lex_state = 3},
  [217] = {.lex_state = 3},
  [218] = {.lex_state = 3},
  [219] = {.lex_state = 3},
  [220] = {.lex_state = 3},
  [221] = {.lex_state = 3},
  [222] = {.lex_state = 3},
  [223] = {.lex_state = 3},
  [224] = {.lex_state = 3},
  [225] = {.lex_state = 3},
  [226] = {.lex_state = 3},
  [227] = {.lex_state = 3},
  [228] = {.lex_state = 3},
  [229] = {.lex_state = 3},
  [230] = {.lex_state = 3},
  [231] = {.lex_state = 3},
  [232] = {.lex_state = 3},
  [233] = {.lex_state = 3},
  [234] = {.lex_state = 3},
  [235] = {.lex_state = 3},
  [236] = {.lex_state = 3},
  [237] = {.lex_state = 3},
  [238] = {.lex_state = 3},
  [239] = {.lex_state = 9, .external_lex_state = 2},
  [240] = {.lex_state = 3},
  [241] = {.lex_state = 3},
  [242] = {.lex_state = 3},
  [243] = {.lex_state = 3},
  [244] = {.lex_state = 3},
  [245] = {.lex_state = 3},
  [246] = {.lex_state = 9, .external_lex_state = 2},
  [247] = {.lex_state = 3},
  [248] = {.lex_state = 3},
  [249] = {.lex_state = 3},
  [250] = {.lex_state = 3},
  [251] = {.lex_state = 3},
  [252] = {.lex_state = 3},
  [253] = {.lex_state = 3},
  [254] = {.lex_state = 3},
  [255] = {.lex_state = 3},
  [256] = {.lex_state = 3},
  [257] = {.lex_state = 3},
  [258] = {.lex_state = 3},
  [259] = {.lex_state = 3},
  [260] = {.lex_state = 3},
  [261] = {.lex_state = 3},
  [262] = {.lex_state = 3},
  [263] = {.lex_state = 3},
  [264] = {.lex_state = 3},
  [265] = {.lex_state = 3},
  [266] = {.lex_state = 3},
  [267] = {.lex_state = 3},
  [268] = {.lex_state = 3},
  [269] = {.lex_state = 3},
  [270] = {.lex_state = 3},
  [271] = {.lex_state = 3},
  [272] = {.lex_state = 3},
  [273] = {.lex_state = 3},
  [274] = {.lex_state = 3},
  [275] = {.lex_state = 3},
  [276] = {.lex_state = 3},
  [277] = {.lex_state = 3},
  [278] = {.lex_state = 3},
  [279] = {.lex_state = 3},
  [280] = {.lex_state = 3},
  [281] = {.lex_state = 3},
  [282] = {.lex_state = 3},
  [283] = {.lex_state = 3},
  [284] = {.lex_state = 3},
  [285] = {.lex_state = 3},
  [286] = {.lex_state = 3},
  [287] = {.lex_state = 3},
  [288] = {.lex_state = 3},
  [289] = {.lex_state = 3},
  [290] = {.lex_state = 3},
  [291] = {.lex_state = 3},
  [292] = {.lex_state = 3},
  [293] = {.lex_state = 3},
  [294] = {.lex_state = 3},
  [295] = {.lex_state = 3},
  [296] = {.lex_state = 3},
  [297] = {.lex_state = 3},
  [298] = {.lex_state = 3},
  [299] = {.lex_state = 3},
  [300] = {.lex_state = 3},
  [301] = {.lex_state = 3},
  [302] = {.lex_state = 3},
  [303] = {.lex_state = 3},
  [304] = {.lex_state = 3},
  [305] = {.lex_state = 3},
  [306] = {.lex_state = 3},
  [307] = {.lex_state = 3},
  [308] = {.lex_state = 3},
  [309] = {.lex_state = 3},
  [310] = {.lex_state = 3},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 3},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 3},
  [316] = {.lex_state = 3},
  [317] = {.lex_state = 3},
  [318] = {.lex_state = 3},
  [319] = {.lex_state = 3},
  [320] = {.lex_state = 3},
  [321] = {.lex_state = 3},
  [322] = {.lex_state = 3},
  [323] = {.lex_state = 3},
  [324] = {.lex_state = 3},
  [325] = {.lex_state = 3},
  [326] = {.lex_state = 3},
  [327] = {.lex_state = 3},
  [328] = {.lex_state = 3},
  [329] = {.lex_state = 3},
  [330] = {.lex_state = 3},
  [331] = {.lex_state = 3},
  [332] = {.lex_state = 3},
  [333] = {.lex_state = 3},
  [334] = {.lex_state = 3},
  [335] = {.lex_state = 3},
  [336] = {.lex_state = 3},
  [337] = {.lex_state = 3},
  [338] = {.lex_state = 3},
  [339] = {.lex_state = 3},
  [340] = {.lex_state = 3},
  [341] = {.lex_state = 3},
  [342] = {.lex_state = 3},
  [343] = {.lex_state = 3},
  [344] = {.lex_state = 3},
  [345] = {.lex_state = 3},
  [346] = {.lex_state = 3},
  [347] = {.lex_state = 3},
  [348] = {.lex_state = 3},
  [349] = {.lex_state = 3},
  [350] = {.lex_state = 3},
  [351] = {.lex_state = 3},
  [352] = {.lex_state = 3},
  [353] = {.lex_state = 3},
  [354] = {.lex_state = 3},
  [355] = {.lex_state = 3},
  [356] = {.lex_state = 3},
  [357] = {.lex_state = 3},
  [358] = {.lex_state = 3},
  [359] = {.lex_state = 3},
  [360] = {.lex_state = 3},
  [361] = {.lex_state = 3},
  [362] = {.lex_state = 3},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 3},
  [366] = {.lex_state = 3},
  [367] = {.lex_state = 3},
  [368] = {.lex_state = 3},
  [369] = {.lex_state = 3},
  [370] = {.lex_state = 3},
  [371] = {.lex_state = 3},
  [372] = {.lex_state = 3},
  [373] = {.lex_state = 3},
  [374] = {.lex_state = 3},
  [375] = {.lex_state = 3},
  [376] = {.lex_state = 3},
  [377] = {.lex_state = 3},
  [378] = {.lex_state = 3},
  [379] = {.lex_state = 3},
  [380] = {.lex_state = 3},
  [381] = {.lex_state = 3},
  [382] = {.lex_state = 3},
  [383] = {.lex_state = 3},
  [384] = {.lex_state = 3},
  [385] = {.lex_state = 3},
  [386] = {.lex_state = 3},
  [387] = {.lex_state = 3},
  [388] = {.lex_state = 3},
  [389] = {.lex_state = 3},
  [390] = {.lex_state = 3},
  [391] = {.lex_state = 3},
  [392] = {.lex_state = 3},
  [393] = {.lex_state = 3},
  [394] = {.lex_state = 3},
  [395] = {.lex_state = 3},
  [396] = {.lex_state = 3},
  [397] = {.lex_state = 3},
  [398] = {.lex_state = 3},
  [399] = {.lex_state = 3},
  [400] = {.lex_state = 3},
  [401] = {.lex_state = 3},
  [402] = {.lex_state = 3},
  [403] = {.lex_state = 3},
  [404] = {.lex_state = 3},
  [405] = {.lex_state = 3},
  [406] = {.lex_state = 3},
  [407] = {.lex_state = 3},
  [408] = {.lex_state = 3},
  [409] = {.lex_state = 3},
  [410] = {.lex_state = 3},
  [411] = {.lex_state = 9, .external_lex_state = 2},
  [412] = {.lex_state = 9, .external_lex_state = 2},
  [413] = {.lex_state = 9, .external_lex_state = 2},
  [414] = {.lex_state = 9, .external_lex_state = 2},
  [415] = {.lex_state = 9, .external_lex_state = 2},
  [416] = {.lex_state = 9, .external_lex_state = 2},
  [417] = {.lex_state = 3},
  [418] = {.lex_state = 3},
  [419] = {.lex_state = 9, .external_lex_state = 2},
  [420] = {.lex_state = 9, .external_lex_state = 2},
  [421] = {.lex_state = 9, .external_lex_state = 2},
  [422] = {.lex_state = 3},
  [423] = {.lex_state = 3},
  [424] = {.lex_state = 9, .external_lex_state = 2},
  [425] = {.lex_state = 3},
  [426] = {.lex_state = 3},
  [427] = {.lex_state = 9, .external_lex_state = 2},
  [428] = {.lex_state = 9, .external_lex_state = 2},
  [429] = {.lex_state = 3},
  [430] = {.lex_state = 3},
  [431] = {.lex_state = 3},
  [432] = {.lex_state = 3},
  [433] = {.lex_state = 3},
  [434] = {.lex_state = 3},
  [435] = {.lex_state = 3},
  [436] = {.lex_state = 3},
  [437] = {.lex_state = 3},
  [438] = {.lex_state = 3},
  [439] = {.lex_state = 3},
  [440] = {.lex_state = 3},
  [441] = {.lex_state = 3},
  [442] = {.lex_state = 3},
  [443] = {.lex_state = 3},
  [444] = {.lex_state = 3},
  [445] = {.lex_state = 3},
  [446] = {.lex_state = 3},
  [447] = {.lex_state = 3},
  [448] = {.lex_state = 3},
  [449] = {.lex_state = 3},
  [450] = {.lex_state = 9, .external_lex_state = 2},
  [451] = {.lex_state = 9, .external_lex_state = 2},
  [452] = {.lex_state = 3},
  [453] = {.lex_state = 9, .external_lex_state = 2},
  [454] = {.lex_state = 9, .external_lex_state = 2},
  [455] = {.lex_state = 9, .external_lex_state = 2},
  [456] = {.lex_state = 9, .external_lex_state = 2},
  [457] = {.lex_state = 9, .external_lex_state = 2},
  [458] = {.lex_state = 9, .external_lex_state = 2},
  [459] = {.lex_state = 9, .external_lex_state = 2},
  [460] = {.lex_state = 3},
  [461] = {.lex_state = 3},
  [462] = {.lex_state = 3, .external_lex_state = 4},
  [463] = {.lex_state = 3, .external_lex_state = 4},
  [464] = {.lex_state = 3},
  [465] = {.lex_state = 3},
  [466] = {.lex_state = 3, .external_lex_state = 4},
  [467] = {.lex_state = 3, .external_lex_state = 4},
  [468] = {.lex_state = 9, .external_lex_state = 3},
  [469] = {.lex_state = 18},
  [470] = {.lex_state = 3, .external_lex_state = 4},
  [471] = {.lex_state = 3},
  [472] = {.lex_state = 3, .external_lex_state = 4},
  [473] = {.lex_state = 3},
  [474] = {.lex_state = 3, .external_lex_state = 4},
  [475] = {.lex_state = 18},
  [476] = {.lex_state = 3},
  [477] = {.lex_state = 18},
  [478] = {.lex_state = 3},
  [479] = {.lex_state = 3},
  [480] = {.lex_state = 3, .external_lex_state = 4},
  [481] = {.lex_state = 18},
  [482] = {.lex_state = 18},
  [483] = {.lex_state = 9, .external_lex_state = 2},
  [484] = {.lex_state = 3},
  [485] = {.lex_state = 3},
  [486] = {.lex_state = 3},
  [487] = {.lex_state = 9, .external_lex_state = 3},
  [488] = {.lex_state = 3},
  [489] = {.lex_state = 3},
  [490] = {.lex_state = 3},
  [491] = {.lex_state = 3},
  [492] = {.lex_state = 9, .external_lex_state = 2},
  [493] = {.lex_state = 3},
  [494] = {.lex_state = 9, .external_lex_state = 2},
  [495] = {.lex_state = 9, .external_lex_state = 2},
  [496] = {.lex_state = 3, .external_lex_state = 4},
  [497] = {.lex_state = 9, .external_lex_state = 2},
  [498] = {.lex_state = 9, .external_lex_state = 2},
  [499] = {.lex_state = 3},
  [500] = {.lex_state = 9, .external_lex_state = 2},
  [501] = {.lex_state = 3, .external_lex_state = 4},
  [502] = {.lex_state = 3, .external_lex_state = 4},
  [503] = {.lex_state = 3, .external_lex_state = 4},
  [504] = {.lex_state = 9, .external_lex_state = 2},
  [505] = {.lex_state = 3},
  [506] = {.lex_state = 9, .external_lex_state = 2},
  [507] = {.lex_state = 3, .external_lex_state = 4},
  [508] = {.lex_state = 3, .external_lex_state = 4},
  [509] = {.lex_state = 3},
  [510] = {.lex_state = 9, .external_lex_state = 3},
  [511] = {.lex_state = 3},
  [512] = {.lex_state = 3, .external_lex_state = 4},
  [513] = {.lex_state = 3, .external_lex_state = 4},
  [514] = {.lex_state = 3, .external_lex_state = 4},
  [515] = {.lex_state = 3, .external_lex_state = 4},
  [516] = {.lex_state = 9, .external_lex_state = 3},
  [517] = {.lex_state = 3},
  [518] = {.lex_state = 10, .external_lex_state = 3},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 3, .external_lex_state = 4},
  [521] = {.lex_state = 3, .external_lex_state = 4},
  [522] = {.lex_state = 3},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 3},
  [525] = {.lex_state = 3},
  [526] = {.lex_state = 3},
  [527] = {.lex_state = 3},
  [528] = {.lex_state = 9, .external_lex_state = 3},
  [529] = {.lex_state = 3},
  [530] = {.lex_state = 3},
  [531] = {.lex_state = 3},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 3},
  [534] = {.lex_state = 3},
  [535] = {.lex_state = 3},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 3},
  [538] = {.lex_state = 3},
  [539] = {.lex_state = 3},
  [540] = {.lex_state = 3},
  [541] = {.lex_state = 3},
  [542] = {.lex_state = 3},
  [543] = {.lex_state = 3},
  [544] = {.lex_state = 3},
  [545] = {.lex_state = 3},
  [546] = {.lex_state = 3},
  [547] = {.lex_state = 3},
  [548] = {.lex_state = 3},
  [549] = {.lex_state = 9, .external_lex_state = 2},
  [550] = {.lex_state = 3},
  [551] = {.lex_state = 9, .external_lex_state = 3},
  [552] = {.lex_state = 3},
  [553] = {.lex_state = 3},
  [554] = {.lex_state = 3},
  [555] = {.lex_state = 3},
  [556] = {.lex_state = 3},
  [557] = {.lex_state = 3},
  [558] = {.lex_state = 3},
  [559] = {.lex_state = 3},
  [560] = {.lex_state = 3},
  [561] = {.lex_state = 3},
  [562] = {.lex_state = 3},
  [563] = {.lex_state = 3},
  [564] = {.lex_state = 3},
  [565] = {.lex_state = 3},
  [566] = {.lex_state = 9, .external_lex_state = 3},
  [567] = {.lex_state = 3},
  [568] = {.lex_state = 9, .external_lex_state = 3},
  [569] = {.lex_state = 3},
  [570] = {.lex_state = 3},
  [571] = {.lex_state = 9, .external_lex_state = 3},
  [572] = {.lex_state = 10, .external_lex_state = 3},
  [573] = {.lex_state = 3},
  [574] = {.lex_state = 3},
  [575] = {.lex_state = 3},
  [576] = {.lex_state = 3},
  [577] = {.lex_state = 3},
  [578] = {.lex_state = 3},
  [579] = {.lex_state = 3},
  [580] = {.lex_state = 3},
  [581] = {.lex_state = 3},
  [582] = {.lex_state = 3},
  [583] = {.lex_state = 9, .external_lex_state = 3},
  [584] = {.lex_state = 3},
  [585] = {.lex_state = 3},
  [586] = {.lex_state = 3},
  [587] = {.lex_state = 3},
  [588] = {.lex_state = 3},
  [589] = {.lex_state = 3},
  [590] = {.lex_state = 3},
  [591] = {.lex_state = 3},
  [592] = {.lex_state = 3},
  [593] = {.lex_state = 3},
  [594] = {.lex_state = 3},
  [595] = {.lex_state = 3},
  [596] = {.lex_state = 9, .external_lex_state = 3},
  [597] = {.lex_state = 3},
  [598] = {.lex_state = 3},
  [599] = {.lex_state = 3},
  [600] = {.lex_state = 3},
  [601] = {.lex_state = 3},
  [602] = {.lex_state = 3},
  [603] = {.lex_state = 3},
  [604] = {.lex_state = 3},
  [605] = {.lex_state = 3},
  [606] = {.lex_state = 3},
  [607] = {.lex_state = 3},
  [608] = {.lex_state = 9, .external_lex_state = 3},
  [609] = {.lex_state = 9, .external_lex_state = 2},
  [610] = {.lex_state = 9, .external_lex_state = 3},
  [611] = {.lex_state = 9, .external_lex_state = 3},
  [612] = {.lex_state = 9, .external_lex_state = 3},
  [613] = {.lex_state = 9, .external_lex_state = 3},
  [614] = {.lex_state = 3},
  [615] = {.lex_state = 3},
  [616] = {.lex_state = 3},
  [617] = {.lex_state = 3},
  [618] = {.lex_state = 3},
  [619] = {.lex_state = 3},
  [620] = {.lex_state = 3},
  [621] = {.lex_state = 3},
  [622] = {.lex_state = 3},
  [623] = {.lex_state = 3},
  [624] = {.lex_state = 9, .external_lex_state = 2},
  [625] = {.lex_state = 9, .external_lex_state = 2},
  [626] = {.lex_state = 9, .external_lex_state = 2},
  [627] = {.lex_state = 9, .external_lex_state = 2},
  [628] = {.lex_state = 9, .external_lex_state = 3},
  [629] = {.lex_state = 9, .external_lex_state = 2},
  [630] = {.lex_state = 9, .external_lex_state = 2},
  [631] = {.lex_state = 9, .external_lex_state = 2},
  [632] = {.lex_state = 9, .external_lex_state = 3},
  [633] = {.lex_state = 9, .external_lex_state = 3},
  [634] = {.lex_state = 9, .external_lex_state = 2},
  [635] = {.lex_state = 3},
  [636] = {.lex_state = 3},
  [637] = {.lex_state = 3},
  [638] = {.lex_state = 3},
  [639] = {.lex_state = 10, .external_lex_state = 3},
  [640] = {.lex_state = 9, .external_lex_state = 2},
  [641] = {.lex_state = 9, .external_lex_state = 2},
  [642] = {.lex_state = 3},
  [643] = {.lex_state = 9, .external_lex_state = 2},
  [644] = {.lex_state = 9, .external_lex_state = 3},
  [645] = {.lex_state = 3},
  [646] = {.lex_state = 9, .external_lex_state = 2},
  [647] = {.lex_state = 9, .external_lex_state = 2},
  [648] = {.lex_state = 9, .external_lex_state = 2},
  [649] = {.lex_state = 9, .external_lex_state = 2},
  [650] = {.lex_state = 3},
  [651] = {.lex_state = 10, .external_lex_state = 3},
  [652] = {.lex_state = 9, .external_lex_state = 2},
  [653] = {.lex_state = 9, .external_lex_state = 3},
  [654] = {.lex_state = 9, .external_lex_state = 3},
  [655] = {.lex_state = 9, .external_lex_state = 3},
  [656] = {.lex_state = 9, .external_lex_state = 3},
  [657] = {.lex_state = 9, .external_lex_state = 3},
  [658] = {.lex_state = 9, .external_lex_state = 3},
  [659] = {.lex_state = 9, .external_lex_state = 2},
  [660] = {.lex_state = 18},
  [661] = {.lex_state = 9, .external_lex_state = 2},
  [662] = {.lex_state = 9, .external_lex_state = 3},
  [663] = {.lex_state = 9, .external_lex_state = 3},
  [664] = {.lex_state = 18},
  [665] = {.lex_state = 9, .external_lex_state = 3},
  [666] = {.lex_state = 3},
  [667] = {.lex_state = 9, .external_lex_state = 3},
  [668] = {.lex_state = 9, .external_lex_state = 3},
  [669] = {.lex_state = 3},
  [670] = {.lex_state = 9, .external_lex_state = 3},
  [671] = {.lex_state = 9, .external_lex_state = 2},
  [672] = {.lex_state = 9, .external_lex_state = 2},
  [673] = {.lex_state = 9, .external_lex_state = 2},
  [674] = {.lex_state = 9, .external_lex_state = 3},
  [675] = {.lex_state = 9, .external_lex_state = 3},
  [676] = {.lex_state = 9, .external_lex_state = 3},
  [677] = {.lex_state = 9, .external_lex_state = 2},
  [678] = {.lex_state = 18},
  [679] = {.lex_state = 18},
  [680] = {.lex_state = 18},
  [681] = {.lex_state = 9, .external_lex_state = 2},
  [682] = {.lex_state = 18},
  [683] = {.lex_state = 18},
  [684] = {.lex_state = 18},
  [685] = {.lex_state = 20},
  [686] = {.lex_state = 9, .external_lex_state = 2},
  [687] = {.lex_state = 18},
  [688] = {.lex_state = 18},
  [689] = {.lex_state = 18},
  [690] = {.lex_state = 18},
  [691] = {.lex_state = 9, .external_lex_state = 3},
  [692] = {.lex_state = 9, .external_lex_state = 2},
  [693] = {.lex_state = 18},
  [694] = {.lex_state = 9, .external_lex_state = 3},
  [695] = {.lex_state = 18},
  [696] = {.lex_state = 9, .external_lex_state = 2},
  [697] = {.lex_state = 9, .external_lex_state = 2},
  [698] = {.lex_state = 9, .external_lex_state = 2},
  [699] = {.lex_state = 18},
  [700] = {.lex_state = 18},
  [701] = {.lex_state = 18},
  [702] = {.lex_state = 9, .external_lex_state = 3},
  [703] = {.lex_state = 9, .external_lex_state = 3},
  [704] = {.lex_state = 18},
  [705] = {.lex_state = 18},
  [706] = {.lex_state = 9, .external_lex_state = 2},
  [707] = {.lex_state = 18},
  [708] = {.lex_state = 18},
  [709] = {.lex_state = 18},
  [710] = {.lex_state = 9, .external_lex_state = 3},
  [711] = {.lex_state = 9, .external_lex_state = 3},
  [712] = {.lex_state = 18},
  [713] = {.lex_state = 18},
  [714] = {.lex_state = 18},
  [715] = {.lex_state = 18},
  [716] = {.lex_state = 18},
  [717] = {.lex_state = 18},
  [718] = {.lex_state = 18},
  [719] = {.lex_state = 18},
  [720] = {.lex_state = 10, .external_lex_state = 3},
  [721] = {.lex_state = 18},
  [722] = {.lex_state = 18},
  [723] = {.lex_state = 9, .external_lex_state = 2},
  [724] = {.lex_state = 18},
  [725] = {.lex_state = 18},
  [726] = {.lex_state = 18},
  [727] = {.lex_state = 18},
  [728] = {.lex_state = 18},
  [729] = {.lex_state = 9, .external_lex_state = 2},
  [730] = {.lex_state = 18},
  [731] = {.lex_state = 18},
  [732] = {.lex_state = 18},
  [733] = {.lex_state = 18},
  [734] = {.lex_state = 9, .external_lex_state = 3},
  [735] = {.lex_state = 18},
  [736] = {.lex_state = 18},
  [737] = {.lex_state = 18},
  [738] = {.lex_state = 18},
  [739] = {.lex_state = 18},
  [740] = {.lex_state = 18},
  [741] = {.lex_state = 18},
  [742] = {.lex_state = 18},
  [743] = {.lex_state = 18},
  [744] = {.lex_state = 18},
  [745] = {.lex_state = 9, .external_lex_state = 3},
  [746] = {.lex_state = 18},
  [747] = {.lex_state = 18},
  [748] = {.lex_state = 18},
  [749] = {.lex_state = 18},
  [750] = {.lex_state = 18},
  [751] = {.lex_state = 9, .external_lex_state = 3},
  [752] = {.lex_state = 18},
  [753] = {.lex_state = 18},
  [754] = {.lex_state = 18},
  [755] = {.lex_state = 18},
  [756] = {.lex_state = 18},
  [757] = {.lex_state = 18},
  [758] = {.lex_state = 18},
  [759] = {.lex_state = 18},
  [760] = {.lex_state = 18},
  [761] = {.lex_state = 18},
  [762] = {.lex_state = 18},
  [763] = {.lex_state = 18},
  [764] = {.lex_state = 18},
  [765] = {.lex_state = 18},
  [766] = {.lex_state = 18},
  [767] = {.lex_state = 18},
  [768] = {.lex_state = 18},
  [769] = {.lex_state = 18},
  [770] = {.lex_state = 18},
  [771] = {.lex_state = 18},
  [772] = {.lex_state = 18},
  [773] = {.lex_state = 18},
  [774] = {.lex_state = 18},
  [775] = {.lex_state = 18},
  [776] = {.lex_state = 18},
  [777] = {.lex_state = 18},
  [778] = {.lex_state = 18},
  [779] = {.lex_state = 9, .external_lex_state = 2},
  [780] = {.lex_state = 18},
  [781] = {.lex_state = 9, .external_lex_state = 2},
  [782] = {.lex_state = 18},
  [783] = {.lex_state = 9, .external_lex_state = 3},
  [784] = {.lex_state = 18},
  [785] = {.lex_state = 18},
  [786] = {.lex_state = 18},
  [787] = {.lex_state = 18},
  [788] = {.lex_state = 18},
  [789] = {.lex_state = 18},
  [790] = {.lex_state = 18},
  [791] = {.lex_state = 9, .external_lex_state = 2},
  [792] = {.lex_state = 18},
  [793] = {.lex_state = 18},
  [794] = {.lex_state = 9, .external_lex_state = 2},
  [795] = {.lex_state = 18},
  [796] = {.lex_state = 18},
  [797] = {.lex_state = 18},
  [798] = {.lex_state = 18},
  [799] = {.lex_state = 18},
  [800] = {.lex_state = 18},
  [801] = {.lex_state = 18},
  [802] = {.lex_state = 9, .external_lex_state = 2},
  [803] = {.lex_state = 18},
  [804] = {.lex_state = 18},
  [805] = {.lex_state = 18},
  [806] = {.lex_state = 9, .external_lex_state = 3},
  [807] = {.lex_state = 18},
  [808] = {.lex_state = 10, .external_lex_state = 3},
  [809] = {.lex_state = 9, .external_lex_state = 3},
  [810] = {.lex_state = 18},
  [811] = {.lex_state = 18},
  [812] = {.lex_state = 18},
  [813] = {.lex_state = 18},
  [814] = {.lex_state = 18},
  [815] = {.lex_state = 18},
  [816] = {.lex_state = 18},
  [817] = {.lex_state = 9, .external_lex_state = 2},
  [818] = {.lex_state = 18},
  [819] = {.lex_state = 18},
  [820] = {.lex_state = 9, .external_lex_state = 3},
  [821] = {.lex_state = 18},
  [822] = {.lex_state = 18},
  [823] = {.lex_state = 18},
  [824] = {.lex_state = 10, .external_lex_state = 3},
  [825] = {.lex_state = 9, .external_lex_state = 3},
  [826] = {.lex_state = 9, .external_lex_state = 2},
  [827] = {.lex_state = 9, .external_lex_state = 3},
  [828] = {.lex_state = 9, .external_lex_state = 2},
  [829] = {.lex_state = 9, .external_lex_state = 2},
  [830] = {.lex_state = 9, .external_lex_state = 2},
  [831] = {.lex_state = 9, .external_lex_state = 2},
  [832] = {.lex_state = 9, .external_lex_state = 2},
  [833] = {.lex_state = 9, .external_lex_state = 3},
  [834] = {.lex_state = 9, .external_lex_state = 2},
  [835] = {.lex_state = 9, .external_lex_state = 2},
  [836] = {.lex_state = 9, .external_lex_state = 2},
  [837] = {.lex_state = 9, .external_lex_state = 3},
  [838] = {.lex_state = 9, .external_lex_state = 3},
  [839] = {.lex_state = 9, .external_lex_state = 2},
  [840] = {.lex_state = 9, .external_lex_state = 2},
  [841] = {.lex_state = 9, .external_lex_state = 3},
  [842] = {.lex_state = 9, .external_lex_state = 3},
  [843] = {.lex_state = 9, .external_lex_state = 2},
  [844] = {.lex_state = 9, .external_lex_state = 2},
  [845] = {.lex_state = 9, .external_lex_state = 2},
  [846] = {.lex_state = 9, .external_lex_state = 2},
  [847] = {.lex_state = 9, .external_lex_state = 2},
  [848] = {.lex_state = 9, .external_lex_state = 3},
  [849] = {.lex_state = 9, .external_lex_state = 2},
  [850] = {.lex_state = 9, .external_lex_state = 3},
  [851] = {.lex_state = 9, .external_lex_state = 3},
  [852] = {.lex_state = 10, .external_lex_state = 3},
  [853] = {.lex_state = 9, .external_lex_state = 2},
  [854] = {.lex_state = 9, .external_lex_state = 2},
  [855] = {.lex_state = 9, .external_lex_state = 2},
  [856] = {.lex_state = 9, .external_lex_state = 2},
  [857] = {.lex_state = 9, .external_lex_state = 2},
  [858] = {.lex_state = 10, .external_lex_state = 3},
  [859] = {.lex_state = 10, .external_lex_state = 3},
  [860] = {.lex_state = 9, .external_lex_state = 2},
  [861] = {.lex_state = 9, .external_lex_state = 3},
  [862] = {.lex_state = 9, .external_lex_state = 3},
  [863] = {.lex_state = 10, .external_lex_state = 3},
  [864] = {.lex_state = 9, .external_lex_state = 3},
  [865] = {.lex_state = 9, .external_lex_state = 2},
  [866] = {.lex_state = 9, .external_lex_state = 3},
  [867] = {.lex_state = 9, .external_lex_state = 3},
  [868] = {.lex_state = 9, .external_lex_state = 3},
  [869] = {.lex_state = 9, .external_lex_state = 2},
  [870] = {.lex_state = 9, .external_lex_state = 3},
  [871] = {.lex_state = 9, .external_lex_state = 2},
  [872] = {.lex_state = 9, .external_lex_state = 3},
  [873] = {.lex_state = 9, .external_lex_state = 2},
  [874] = {.lex_state = 9, .external_lex_state = 3},
  [875] = {.lex_state = 9, .external_lex_state = 2},
  [876] = {.lex_state = 10, .external_lex_state = 3},
  [877] = {.lex_state = 9, .external_lex_state = 3},
  [878] = {.lex_state = 9, .external_lex_state = 3},
  [879] = {.lex_state = 9, .external_lex_state = 2},
  [880] = {.lex_state = 10, .external_lex_state = 3},
  [881] = {.lex_state = 9, .external_lex_state = 2},
  [882] = {.lex_state = 9, .external_lex_state = 3},
  [883] = {.lex_state = 9, .external_lex_state = 3},
  [884] = {.lex_state = 9, .external_lex_state = 3},
  [885] = {.lex_state = 9, .external_lex_state = 3},
  [886] = {.lex_state = 9, .external_lex_state = 2},
  [887] = {.lex_state = 10, .external_lex_state = 3},
  [888] = {.lex_state = 9, .external_lex_state = 3},
  [889] = {.lex_state = 9, .external_lex_state = 3},
  [890] = {.lex_state = 9, .external_lex_state = 3},
  [891] = {.lex_state = 9, .external_lex_state = 3},
  [892] = {.lex_state = 9, .external_lex_state = 3},
  [893] = {.lex_state = 10, .external_lex_state = 3},
  [894] = {.lex_state = 9, .external_lex_state = 2},
  [895] = {.lex_state = 10, .external_lex_state = 3},
  [896] = {.lex_state = 10, .external_lex_state = 3},
  [897] = {.lex_state = 9, .external_lex_state = 2},
  [898] = {.lex_state = 10, .external_lex_state = 3},
  [899] = {.lex_state = 10, .external_lex_state = 3},
  [900] = {.lex_state = 9, .external_lex_state = 3},
  [901] = {.lex_state = 9, .external_lex_state = 3},
  [902] = {.lex_state = 10, .external_lex_state = 3},
  [903] = {.lex_state = 9, .external_lex_state = 3},
  [904] = {.lex_state = 9, .external_lex_state = 3},
  [905] = {.lex_state = 9, .external_lex_state = 2},
  [906] = {.lex_state = 9, .external_lex_state = 2},
  [907] = {.lex_state = 10, .external_lex_state = 3},
  [908] = {.lex_state = 10, .external_lex_state = 3},
  [909] = {.lex_state = 9, .external_lex_state = 3},
  [910] = {.lex_state = 10, .external_lex_state = 3},
  [911] = {.lex_state = 10, .external_lex_state = 3},
  [912] = {.lex_state = 9, .external_lex_state = 3},
  [913] = {.lex_state = 3},
  [914] = {.lex_state = 9, .external_lex_state = 3},
  [915] = {.lex_state = 3},
  [916] = {.lex_state = 3, .external_lex_state = 4},
  [917] = {.lex_state = 3, .external_lex_state = 4},
  [918] = {.lex_state = 3},
  [919] = {.lex_state = 9, .external_lex_state = 3},
  [920] = {.lex_state = 9, .external_lex_state = 3},
  [921] = {.lex_state = 3, .external_lex_state = 4},
  [922] = {.lex_state = 9, .external_lex_state = 2},
  [923] = {.lex_state = 3},
  [924] = {.lex_state = 3, .external_lex_state = 4},
  [925] = {.lex_state = 9, .external_lex_state = 3},
  [926] = {.lex_state = 3},
  [927] = {.lex_state = 9, .external_lex_state = 3},
  [928] = {.lex_state = 2, .external_lex_state = 2},
  [929] = {.lex_state = 3, .external_lex_state = 4},
  [930] = {.lex_state = 9, .external_lex_state = 3},
  [931] = {.lex_state = 3, .external_lex_state = 4},
  [932] = {.lex_state = 9, .external_lex_state = 3},
  [933] = {.lex_state = 3},
  [934] = {.lex_state = 3},
  [935] = {.lex_state = 3},
  [936] = {.lex_state = 3},
  [937] = {.lex_state = 3},
  [938] = {.lex_state = 3},
  [939] = {.lex_state = 3},
  [940] = {.lex_state = 3},
  [941] = {.lex_state = 3},
  [942] = {.lex_state = 3},
  [943] = {.lex_state = 3},
  [944] = {.lex_state = 3},
  [945] = {.lex_state = 3},
  [946] = {.lex_state = 3},
  [947] = {.lex_state = 3},
  [948] = {.lex_state = 3},
  [949] = {.lex_state = 3},
  [950] = {.lex_state = 3},
  [951] = {.lex_state = 3},
  [952] = {.lex_state = 3},
  [953] = {.lex_state = 3},
  [954] = {.lex_state = 2, .external_lex_state = 3},
  [955] = {.lex_state = 2, .external_lex_state = 3},
  [956] = {.lex_state = 2, .external_lex_state = 3},
  [957] = {.lex_state = 2, .external_lex_state = 3},
  [958] = {.lex_state = 2, .external_lex_state = 3},
  [959] = {.lex_state = 2, .external_lex_state = 3},
  [960] = {.lex_state = 2, .external_lex_state = 3},
  [961] = {.lex_state = 2, .external_lex_state = 3},
  [962] = {.lex_state = 2, .external_lex_state = 3},
  [963] = {.lex_state = 2, .external_lex_state = 3},
  [964] = {.lex_state = 2, .external_lex_state = 3},
  [965] = {.lex_state = 2, .external_lex_state = 2},
  [966] = {.lex_state = 2, .external_lex_state = 2},
  [967] = {.lex_state = 2, .external_lex_state = 3},
  [968] = {.lex_state = 2, .external_lex_state = 3},
  [969] = {.lex_state = 2, .external_lex_state = 2},
  [970] = {.lex_state = 2, .external_lex_state = 3},
  [971] = {.lex_state = 2, .external_lex_state = 3},
  [972] = {.lex_state = 2, .external_lex_state = 3},
  [973] = {.lex_state = 2, .external_lex_state = 3},
  [974] = {.lex_state = 2, .external_lex_state = 3},
  [975] = {.lex_state = 2, .external_lex_state = 3},
  [976] = {.lex_state = 2, .external_lex_state = 3},
  [977] = {.lex_state = 2, .external_lex_state = 3},
  [978] = {.lex_state = 2, .external_lex_state = 3},
  [979] = {.lex_state = 18},
  [980] = {.lex_state = 18},
  [981] = {.lex_state = 2, .external_lex_state = 3},
  [982] = {.lex_state = 2, .external_lex_state = 2},
  [983] = {.lex_state = 2, .external_lex_state = 3},
  [984] = {.lex_state = 2, .external_lex_state = 3},
  [985] = {.lex_state = 2, .external_lex_state = 3},
  [986] = {.lex_state = 2, .external_lex_state = 3},
  [987] = {.lex_state = 2, .external_lex_state = 3},
  [988] = {.lex_state = 2, .external_lex_state = 3},
  [989] = {.lex_state = 2, .external_lex_state = 3},
  [990] = {.lex_state = 2, .external_lex_state = 3},
  [991] = {.lex_state = 18},
  [992] = {.lex_state = 2, .external_lex_state = 3},
  [993] = {.lex_state = 2, .external_lex_state = 2},
  [994] = {.lex_state = 2, .external_lex_state = 3},
  [995] = {.lex_state = 2, .external_lex_state = 3},
  [996] = {.lex_state = 2, .external_lex_state = 3},
  [997] = {.lex_state = 18},
  [998] = {.lex_state = 18},
  [999] = {.lex_state = 2, .external_lex_state = 3},
  [1000] = {.lex_state = 2, .external_lex_state = 3},
  [1001] = {.lex_state = 2, .external_lex_state = 3},
  [1002] = {.lex_state = 2, .external_lex_state = 3},
  [1003] = {.lex_state = 18},
  [1004] = {.lex_state = 2, .external_lex_state = 3},
  [1005] = {.lex_state = 2, .external_lex_state = 3},
  [1006] = {.lex_state = 2, .external_lex_state = 2},
  [1007] = {.lex_state = 2, .external_lex_state = 3},
  [1008] = {.lex_state = 2, .external_lex_state = 3},
  [1009] = {.lex_state = 2, .external_lex_state = 3},
  [1010] = {.lex_state = 2, .external_lex_state = 3},
  [1011] = {.lex_state = 2, .external_lex_state = 2},
  [1012] = {.lex_state = 2, .external_lex_state = 2},
  [1013] = {.lex_state = 18},
  [1014] = {.lex_state = 2, .external_lex_state = 3},
  [1015] = {.lex_state = 2, .external_lex_state = 3},
  [1016] = {.lex_state = 2, .external_lex_state = 3},
  [1017] = {.lex_state = 2, .external_lex_state = 3},
  [1018] = {.lex_state = 2, .external_lex_state = 2},
  [1019] = {.lex_state = 2, .external_lex_state = 3},
  [1020] = {.lex_state = 2, .external_lex_state = 3},
  [1021] = {.lex_state = 2, .external_lex_state = 3},
  [1022] = {.lex_state = 2, .external_lex_state = 2},
  [1023] = {.lex_state = 11, .external_lex_state = 3},
  [1024] = {.lex_state = 2, .external_lex_state = 3},
  [1025] = {.lex_state = 2, .external_lex_state = 3},
  [1026] = {.lex_state = 2, .external_lex_state = 2},
  [1027] = {.lex_state = 2, .external_lex_state = 3},
  [1028] = {.lex_state = 2, .external_lex_state = 3},
  [1029] = {.lex_state = 3},
  [1030] = {.lex_state = 3},
  [1031] = {.lex_state = 2, .external_lex_state = 3},
  [1032] = {.lex_state = 2, .external_lex_state = 3},
  [1033] = {.lex_state = 2, .external_lex_state = 3},
  [1034] = {.lex_state = 2, .external_lex_state = 3},
  [1035] = {.lex_state = 2, .external_lex_state = 3},
  [1036] = {.lex_state = 2, .external_lex_state = 3},
  [1037] = {.lex_state = 2, .external_lex_state = 3},
  [1038] = {.lex_state = 2, .external_lex_state = 3},
  [1039] = {.lex_state = 2, .external_lex_state = 3},
  [1040] = {.lex_state = 2, .external_lex_state = 3},
  [1041] = {.lex_state = 2, .external_lex_state = 3},
  [1042] = {.lex_state = 2, .external_lex_state = 3},
  [1043] = {.lex_state = 2, .external_lex_state = 3},
  [1044] = {.lex_state = 3},
  [1045] = {.lex_state = 2, .external_lex_state = 3},
  [1046] = {.lex_state = 2, .external_lex_state = 2},
  [1047] = {.lex_state = 2, .external_lex_state = 3},
  [1048] = {.lex_state = 2, .external_lex_state = 3},
  [1049] = {.lex_state = 2, .external_lex_state = 3},
  [1050] = {.lex_state = 2, .external_lex_state = 3},
  [1051] = {.lex_state = 2, .external_lex_state = 3},
  [1052] = {.lex_state = 2, .external_lex_state = 2},
  [1053] = {.lex_state = 2, .external_lex_state = 3},
  [1054] = {.lex_state = 2, .external_lex_state = 3},
  [1055] = {.lex_state = 2, .external_lex_state = 3},
  [1056] = {.lex_state = 2, .external_lex_state = 3},
  [1057] = {.lex_state = 2, .external_lex_state = 3},
  [1058] = {.lex_state = 2, .external_lex_state = 3},
  [1059] = {.lex_state = 2, .external_lex_state = 2},
  [1060] = {.lex_state = 2, .external_lex_state = 3},
  [1061] = {.lex_state = 2, .external_lex_state = 3},
  [1062] = {.lex_state = 2, .external_lex_state = 3},
  [1063] = {.lex_state = 2, .external_lex_state = 3},
  [1064] = {.lex_state = 2, .external_lex_state = 3},
  [1065] = {.lex_state = 2, .external_lex_state = 3},
  [1066] = {.lex_state = 2, .external_lex_state = 2},
  [1067] = {.lex_state = 2, .external_lex_state = 2},
  [1068] = {.lex_state = 2, .external_lex_state = 2},
  [1069] = {.lex_state = 2, .external_lex_state = 2},
  [1070] = {.lex_state = 2, .external_lex_state = 3},
  [1071] = {.lex_state = 2, .external_lex_state = 3},
  [1072] = {.lex_state = 2, .external_lex_state = 3},
  [1073] = {.lex_state = 2, .external_lex_state = 3},
  [1074] = {.lex_state = 2, .external_lex_state = 3},
  [1075] = {.lex_state = 2, .external_lex_state = 2},
  [1076] = {.lex_state = 2, .external_lex_state = 3},
  [1077] = {.lex_state = 2, .external_lex_state = 2},
  [1078] = {.lex_state = 2, .external_lex_state = 3},
  [1079] = {.lex_state = 2, .external_lex_state = 3},
  [1080] = {.lex_state = 2, .external_lex_state = 3},
  [1081] = {.lex_state = 2, .external_lex_state = 3},
  [1082] = {.lex_state = 2, .external_lex_state = 3},
  [1083] = {.lex_state = 2, .external_lex_state = 2},
  [1084] = {.lex_state = 2, .external_lex_state = 3},
  [1085] = {.lex_state = 2, .external_lex_state = 3},
  [1086] = {.lex_state = 2, .external_lex_state = 3},
  [1087] = {.lex_state = 2, .external_lex_state = 3},
  [1088] = {.lex_state = 2, .external_lex_state = 3},
  [1089] = {.lex_state = 2, .external_lex_state = 3},
  [1090] = {.lex_state = 2, .external_lex_state = 3},
  [1091] = {.lex_state = 2, .external_lex_state = 3},
  [1092] = {.lex_state = 2, .external_lex_state = 3},
  [1093] = {.lex_state = 2, .external_lex_state = 3},
  [1094] = {.lex_state = 2, .external_lex_state = 3},
  [1095] = {.lex_state = 2, .external_lex_state = 2},
  [1096] = {.lex_state = 2, .external_lex_state = 2},
  [1097] = {.lex_state = 2, .external_lex_state = 3},
  [1098] = {.lex_state = 2, .external_lex_state = 2},
  [1099] = {.lex_state = 2, .external_lex_state = 2},
  [1100] = {.lex_state = 2, .external_lex_state = 3},
  [1101] = {.lex_state = 2, .external_lex_state = 3},
  [1102] = {.lex_state = 2, .external_lex_state = 3},
  [1103] = {.lex_state = 2, .external_lex_state = 3},
  [1104] = {.lex_state = 2, .external_lex_state = 2},
  [1105] = {.lex_state = 3},
  [1106] = {.lex_state = 2, .external_lex_state = 2},
  [1107] = {.lex_state = 2, .external_lex_state = 2},
  [1108] = {.lex_state = 2, .external_lex_state = 2},
  [1109] = {.lex_state = 2, .external_lex_state = 2},
  [1110] = {.lex_state = 2, .external_lex_state = 2},
  [1111] = {.lex_state = 2, .external_lex_state = 2},
  [1112] = {.lex_state = 2, .external_lex_state = 2},
  [1113] = {.lex_state = 2, .external_lex_state = 2},
  [1114] = {.lex_state = 2, .external_lex_state = 2},
  [1115] = {.lex_state = 2, .external_lex_state = 2},
  [1116] = {.lex_state = 2, .external_lex_state = 2},
  [1117] = {.lex_state = 2, .external_lex_state = 2},
  [1118] = {.lex_state = 2, .external_lex_state = 2},
  [1119] = {.lex_state = 2, .external_lex_state = 2},
  [1120] = {.lex_state = 2, .external_lex_state = 2},
  [1121] = {.lex_state = 2, .external_lex_state = 2},
  [1122] = {.lex_state = 2, .external_lex_state = 2},
  [1123] = {.lex_state = 2, .external_lex_state = 2},
  [1124] = {.lex_state = 2, .external_lex_state = 3},
  [1125] = {.lex_state = 2, .external_lex_state = 3},
  [1126] = {.lex_state = 2, .external_lex_state = 3},
  [1127] = {.lex_state = 2, .external_lex_state = 2},
  [1128] = {.lex_state = 2, .external_lex_state = 2},
  [1129] = {.lex_state = 2, .external_lex_state = 2},
  [1130] = {.lex_state = 2, .external_lex_state = 3},
  [1131] = {.lex_state = 2, .external_lex_state = 3},
  [1132] = {.lex_state = 2, .external_lex_state = 2},
  [1133] = {.lex_state = 2, .external_lex_state = 3},
  [1134] = {.lex_state = 2, .external_lex_state = 3},
  [1135] = {.lex_state = 2, .external_lex_state = 3},
  [1136] = {.lex_state = 2, .external_lex_state = 3},
  [1137] = {.lex_state = 2, .external_lex_state = 3},
  [1138] = {.lex_state = 2, .external_lex_state = 3},
  [1139] = {.lex_state = 2, .external_lex_state = 3},
  [1140] = {.lex_state = 3},
  [1141] = {.lex_state = 2, .external_lex_state = 3},
  [1142] = {.lex_state = 2, .external_lex_state = 3},
  [1143] = {.lex_state = 2, .external_lex_state = 3},
  [1144] = {.lex_state = 2, .external_lex_state = 3},
  [1145] = {.lex_state = 2, .external_lex_state = 3},
  [1146] = {.lex_state = 2, .external_lex_state = 3},
  [1147] = {.lex_state = 2, .external_lex_state = 3},
  [1148] = {.lex_state = 2, .external_lex_state = 3},
  [1149] = {.lex_state = 2, .external_lex_state = 2},
  [1150] = {.lex_state = 2, .external_lex_state = 3},
  [1151] = {.lex_state = 2, .external_lex_state = 3},
  [1152] = {.lex_state = 2, .external_lex_state = 3},
  [1153] = {.lex_state = 2, .external_lex_state = 3},
  [1154] = {.lex_state = 2, .external_lex_state = 3},
  [1155] = {.lex_state = 2, .external_lex_state = 3},
  [1156] = {.lex_state = 2, .external_lex_state = 3},
  [1157] = {.lex_state = 2, .external_lex_state = 2},
  [1158] = {.lex_state = 2, .external_lex_state = 3},
  [1159] = {.lex_state = 2, .external_lex_state = 3},
  [1160] = {.lex_state = 2, .external_lex_state = 3},
  [1161] = {.lex_state = 2, .external_lex_state = 3},
  [1162] = {.lex_state = 2, .external_lex_state = 3},
  [1163] = {.lex_state = 2, .external_lex_state = 2},
  [1164] = {.lex_state = 2, .external_lex_state = 3},
  [1165] = {.lex_state = 2, .external_lex_state = 3},
  [1166] = {.lex_state = 2, .external_lex_state = 3},
  [1167] = {.lex_state = 2, .external_lex_state = 3},
  [1168] = {.lex_state = 2, .external_lex_state = 3},
  [1169] = {.lex_state = 2, .external_lex_state = 3},
  [1170] = {.lex_state = 2, .external_lex_state = 3},
  [1171] = {.lex_state = 2, .external_lex_state = 3},
  [1172] = {.lex_state = 2, .external_lex_state = 3},
  [1173] = {.lex_state = 2, .external_lex_state = 3},
  [1174] = {.lex_state = 2, .external_lex_state = 3},
  [1175] = {.lex_state = 3, .external_lex_state = 4},
  [1176] = {.lex_state = 2, .external_lex_state = 3},
  [1177] = {.lex_state = 2, .external_lex_state = 3},
  [1178] = {.lex_state = 2, .external_lex_state = 3},
  [1179] = {.lex_state = 2, .external_lex_state = 3},
  [1180] = {.lex_state = 2, .external_lex_state = 3},
  [1181] = {.lex_state = 11, .external_lex_state = 3},
  [1182] = {.lex_state = 2, .external_lex_state = 3},
  [1183] = {.lex_state = 2, .external_lex_state = 3},
  [1184] = {.lex_state = 2, .external_lex_state = 3},
  [1185] = {.lex_state = 12, .external_lex_state = 3},
  [1186] = {.lex_state = 2, .external_lex_state = 3},
  [1187] = {.lex_state = 2, .external_lex_state = 3},
  [1188] = {.lex_state = 2, .external_lex_state = 3},
  [1189] = {.lex_state = 2, .external_lex_state = 3},
  [1190] = {.lex_state = 2, .external_lex_state = 3},
  [1191] = {.lex_state = 11, .external_lex_state = 3},
  [1192] = {.lex_state = 3},
  [1193] = {.lex_state = 2, .external_lex_state = 3},
  [1194] = {.lex_state = 2, .external_lex_state = 3},
  [1195] = {.lex_state = 2, .external_lex_state = 3},
  [1196] = {.lex_state = 2, .external_lex_state = 3},
  [1197] = {.lex_state = 2, .external_lex_state = 3},
  [1198] = {.lex_state = 2, .external_lex_state = 2},
  [1199] = {.lex_state = 2, .external_lex_state = 3},
  [1200] = {.lex_state = 3, .external_lex_state = 4},
  [1201] = {.lex_state = 2, .external_lex_state = 3},
  [1202] = {.lex_state = 3, .external_lex_state = 4},
  [1203] = {.lex_state = 3, .external_lex_state = 4},
  [1204] = {.lex_state = 11, .external_lex_state = 3},
  [1205] = {.lex_state = 11, .external_lex_state = 3},
  [1206] = {.lex_state = 2, .external_lex_state = 2},
  [1207] = {.lex_state = 2, .external_lex_state = 3},
  [1208] = {.lex_state = 3},
  [1209] = {.lex_state = 2, .external_lex_state = 3},
  [1210] = {.lex_state = 3},
  [1211] = {.lex_state = 2, .external_lex_state = 3},
  [1212] = {.lex_state = 3},
  [1213] = {.lex_state = 2, .external_lex_state = 3},
  [1214] = {.lex_state = 2, .external_lex_state = 3},
  [1215] = {.lex_state = 2, .external_lex_state = 3},
  [1216] = {.lex_state = 2, .external_lex_state = 2},
  [1217] = {.lex_state = 3},
  [1218] = {.lex_state = 3},
  [1219] = {.lex_state = 2, .external_lex_state = 3},
  [1220] = {.lex_state = 2, .external_lex_state = 3},
  [1221] = {.lex_state = 3},
  [1222] = {.lex_state = 3},
  [1223] = {.lex_state = 2, .external_lex_state = 2},
  [1224] = {.lex_state = 3},
  [1225] = {.lex_state = 11, .external_lex_state = 3},
  [1226] = {.lex_state = 2, .external_lex_state = 3},
  [1227] = {.lex_state = 2, .external_lex_state = 3},
  [1228] = {.lex_state = 2, .external_lex_state = 3},
  [1229] = {.lex_state = 2, .external_lex_state = 3},
  [1230] = {.lex_state = 2, .external_lex_state = 3},
  [1231] = {.lex_state = 2, .external_lex_state = 3},
  [1232] = {.lex_state = 2, .external_lex_state = 3},
  [1233] = {.lex_state = 2, .external_lex_state = 3},
  [1234] = {.lex_state = 2, .external_lex_state = 3},
  [1235] = {.lex_state = 2, .external_lex_state = 3},
  [1236] = {.lex_state = 2, .external_lex_state = 3},
  [1237] = {.lex_state = 3, .external_lex_state = 4},
  [1238] = {.lex_state = 11, .external_lex_state = 3},
  [1239] = {.lex_state = 2, .external_lex_state = 3},
  [1240] = {.lex_state = 2, .external_lex_state = 3},
  [1241] = {.lex_state = 2, .external_lex_state = 3},
  [1242] = {.lex_state = 2, .external_lex_state = 3},
  [1243] = {.lex_state = 11, .external_lex_state = 3},
  [1244] = {.lex_state = 2, .external_lex_state = 3},
  [1245] = {.lex_state = 2, .external_lex_state = 3},
  [1246] = {.lex_state = 2, .external_lex_state = 3},
  [1247] = {.lex_state = 2, .external_lex_state = 3},
  [1248] = {.lex_state = 11, .external_lex_state = 3},
  [1249] = {.lex_state = 11, .external_lex_state = 3},
  [1250] = {.lex_state = 2, .external_lex_state = 2},
  [1251] = {.lex_state = 11, .external_lex_state = 3},
  [1252] = {.lex_state = 11, .external_lex_state = 3},
  [1253] = {.lex_state = 2, .external_lex_state = 2},
  [1254] = {.lex_state = 3, .external_lex_state = 4},
  [1255] = {.lex_state = 3},
  [1256] = {.lex_state = 3},
  [1257] = {.lex_state = 2, .external_lex_state = 2},
  [1258] = {.lex_state = 11, .external_lex_state = 3},
  [1259] = {.lex_state = 11, .external_lex_state = 3},
  [1260] = {.lex_state = 3, .external_lex_state = 4},
  [1261] = {.lex_state = 11, .external_lex_state = 3},
  [1262] = {.lex_state = 3, .external_lex_state = 4},
  [1263] = {.lex_state = 3, .external_lex_state = 4},
  [1264] = {.lex_state = 11, .external_lex_state = 3},
  [1265] = {.lex_state = 11, .external_lex_state = 3},
  [1266] = {.lex_state = 2, .external_lex_state = 2},
  [1267] = {.lex_state = 11, .external_lex_state = 3},
  [1268] = {.lex_state = 11, .external_lex_state = 3},
  [1269] = {.lex_state = 2, .external_lex_state = 3},
  [1270] = {.lex_state = 2, .external_lex_state = 2},
  [1271] = {.lex_state = 2, .external_lex_state = 3},
  [1272] = {.lex_state = 2, .external_lex_state = 3},
  [1273] = {.lex_state = 2, .external_lex_state = 2},
  [1274] = {.lex_state = 11, .external_lex_state = 3},
  [1275] = {.lex_state = 2, .external_lex_state = 2},
  [1276] = {.lex_state = 2, .external_lex_state = 3},
  [1277] = {.lex_state = 2, .external_lex_state = 3},
  [1278] = {.lex_state = 3, .external_lex_state = 4},
  [1279] = {.lex_state = 3, .external_lex_state = 4},
  [1280] = {.lex_state = 2, .external_lex_state = 2},
  [1281] = {.lex_state = 2, .external_lex_state = 2},
  [1282] = {.lex_state = 2, .external_lex_state = 3},
  [1283] = {.lex_state = 11, .external_lex_state = 3},
  [1284] = {.lex_state = 11, .external_lex_state = 3},
  [1285] = {.lex_state = 11, .external_lex_state = 3},
  [1286] = {.lex_state = 2, .external_lex_state = 2},
  [1287] = {.lex_state = 11, .external_lex_state = 3},
  [1288] = {.lex_state = 2, .external_lex_state = 3},
  [1289] = {.lex_state = 3, .external_lex_state = 4},
  [1290] = {.lex_state = 2, .external_lex_state = 2},
  [1291] = {.lex_state = 2, .external_lex_state = 3},
  [1292] = {.lex_state = 2, .external_lex_state = 2},
  [1293] = {.lex_state = 2, .external_lex_state = 2},
  [1294] = {.lex_state = 2, .external_lex_state = 3},
  [1295] = {.lex_state = 2, .external_lex_state = 3},
  [1296] = {.lex_state = 2, .external_lex_state = 2},
  [1297] = {.lex_state = 2, .external_lex_state = 3},
  [1298] = {.lex_state = 2, .external_lex_state = 3},
  [1299] = {.lex_state = 2, .external_lex_state = 3},
  [1300] = {.lex_state = 2, .external_lex_state = 3},
  [1301] = {.lex_state = 3},
  [1302] = {.lex_state = 2, .external_lex_state = 2},
  [1303] = {.lex_state = 11, .external_lex_state = 3},
  [1304] = {.lex_state = 3},
  [1305] = {.lex_state = 11, .external_lex_state = 3},
  [1306] = {.lex_state = 11, .external_lex_state = 3},
  [1307] = {.lex_state = 2, .external_lex_state = 3},
  [1308] = {.lex_state = 11, .external_lex_state = 3},
  [1309] = {.lex_state = 2, .external_lex_state = 3},
  [1310] = {.lex_state = 2, .external_lex_state = 3},
  [1311] = {.lex_state = 11, .external_lex_state = 3},
  [1312] = {.lex_state = 2, .external_lex_state = 2},
  [1313] = {.lex_state = 11, .external_lex_state = 3},
  [1314] = {.lex_state = 2, .external_lex_state = 2},
  [1315] = {.lex_state = 11, .external_lex_state = 3},
  [1316] = {.lex_state = 2, .external_lex_state = 3},
  [1317] = {.lex_state = 3},
  [1318] = {.lex_state = 2, .external_lex_state = 2},
  [1319] = {.lex_state = 2, .external_lex_state = 3},
  [1320] = {.lex_state = 2, .external_lex_state = 2},
  [1321] = {.lex_state = 3, .external_lex_state = 4},
  [1322] = {.lex_state = 11, .external_lex_state = 3},
  [1323] = {.lex_state = 11, .external_lex_state = 3},
  [1324] = {.lex_state = 2, .external_lex_state = 2},
  [1325] = {.lex_state = 2, .external_lex_state = 2},
  [1326] = {.lex_state = 2, .external_lex_state = 2},
  [1327] = {.lex_state = 2, .external_lex_state = 2},
  [1328] = {.lex_state = 2, .external_lex_state = 2},
  [1329] = {.lex_state = 2, .external_lex_state = 2},
  [1330] = {.lex_state = 2, .external_lex_state = 3},
  [1331] = {.lex_state = 2, .external_lex_state = 2},
  [1332] = {.lex_state = 2, .external_lex_state = 3},
  [1333] = {.lex_state = 2, .external_lex_state = 2},
  [1334] = {.lex_state = 2, .external_lex_state = 3},
  [1335] = {.lex_state = 2, .external_lex_state = 2},
  [1336] = {.lex_state = 2, .external_lex_state = 2},
  [1337] = {.lex_state = 2, .external_lex_state = 3},
  [1338] = {.lex_state = 2, .external_lex_state = 3},
  [1339] = {.lex_state = 2, .external_lex_state = 2},
  [1340] = {.lex_state = 2, .external_lex_state = 3},
  [1341] = {.lex_state = 2, .external_lex_state = 2},
  [1342] = {.lex_state = 2, .external_lex_state = 2},
  [1343] = {.lex_state = 2, .external_lex_state = 2},
  [1344] = {.lex_state = 2, .external_lex_state = 3},
  [1345] = {.lex_state = 2, .external_lex_state = 2},
  [1346] = {.lex_state = 2, .external_lex_state = 2},
  [1347] = {.lex_state = 2, .external_lex_state = 2},
  [1348] = {.lex_state = 2, .external_lex_state = 2},
  [1349] = {.lex_state = 2, .external_lex_state = 2},
  [1350] = {.lex_state = 2, .external_lex_state = 2},
  [1351] = {.lex_state = 2, .external_lex_state = 2},
  [1352] = {.lex_state = 2, .external_lex_state = 3},
  [1353] = {.lex_state = 11, .external_lex_state = 3},
  [1354] = {.lex_state = 2, .external_lex_state = 2},
  [1355] = {.lex_state = 2, .external_lex_state = 2},
  [1356] = {.lex_state = 2, .external_lex_state = 2},
  [1357] = {.lex_state = 2, .external_lex_state = 2},
  [1358] = {.lex_state = 2, .external_lex_state = 2},
  [1359] = {.lex_state = 2, .external_lex_state = 2},
  [1360] = {.lex_state = 2, .external_lex_state = 2},
  [1361] = {.lex_state = 2, .external_lex_state = 2},
  [1362] = {.lex_state = 2, .external_lex_state = 2},
  [1363] = {.lex_state = 2, .external_lex_state = 3},
  [1364] = {.lex_state = 2, .external_lex_state = 2},
  [1365] = {.lex_state = 2, .external_lex_state = 2},
  [1366] = {.lex_state = 3, .external_lex_state = 4},
  [1367] = {.lex_state = 2, .external_lex_state = 3},
  [1368] = {.lex_state = 2, .external_lex_state = 2},
  [1369] = {.lex_state = 2, .external_lex_state = 2},
  [1370] = {.lex_state = 2, .external_lex_state = 3},
  [1371] = {.lex_state = 2, .external_lex_state = 2},
  [1372] = {.lex_state = 2, .external_lex_state = 2},
  [1373] = {.lex_state = 2, .external_lex_state = 2},
  [1374] = {.lex_state = 3, .external_lex_state = 4},
  [1375] = {.lex_state = 2, .external_lex_state = 2},
  [1376] = {.lex_state = 2, .external_lex_state = 3},
  [1377] = {.lex_state = 2, .external_lex_state = 3},
  [1378] = {.lex_state = 2, .external_lex_state = 2},
  [1379] = {.lex_state = 2, .external_lex_state = 2},
  [1380] = {.lex_state = 3, .external_lex_state = 4},
  [1381] = {.lex_state = 2, .external_lex_state = 2},
  [1382] = {.lex_state = 2, .external_lex_state = 2},
  [1383] = {.lex_state = 3, .external_lex_state = 4},
  [1384] = {.lex_state = 2, .external_lex_state = 3},
  [1385] = {.lex_state = 3, .external_lex_state = 4},
  [1386] = {.lex_state = 2, .external_lex_state = 2},
  [1387] = {.lex_state = 2, .external_lex_state = 3},
  [1388] = {.lex_state = 2, .external_lex_state = 2},
  [1389] = {.lex_state = 2, .external_lex_state = 2},
  [1390] = {.lex_state = 2, .external_lex_state = 3},
  [1391] = {.lex_state = 3, .external_lex_state = 4},
  [1392] = {.lex_state = 2, .external_lex_state = 3},
  [1393] = {.lex_state = 11, .external_lex_state = 2},
  [1394] = {.lex_state = 2, .external_lex_state = 2},
  [1395] = {.lex_state = 3, .external_lex_state = 4},
  [1396] = {.lex_state = 2, .external_lex_state = 2},
  [1397] = {.lex_state = 2, .external_lex_state = 3},
  [1398] = {.lex_state = 2, .external_lex_state = 2},
  [1399] = {.lex_state = 2, .external_lex_state = 3},
  [1400] = {.lex_state = 2, .external_lex_state = 2},
  [1401] = {.lex_state = 2, .external_lex_state = 2},
  [1402] = {.lex_state = 2, .external_lex_state = 2},
  [1403] = {.lex_state = 3, .external_lex_state = 4},
  [1404] = {.lex_state = 2, .external_lex_state = 3},
  [1405] = {.lex_state = 2, .external_lex_state = 3},
  [1406] = {.lex_state = 11, .external_lex_state = 3},
  [1407] = {.lex_state = 2, .external_lex_state = 3},
  [1408] = {.lex_state = 12, .external_lex_state = 2},
  [1409] = {.lex_state = 2, .external_lex_state = 2},
  [1410] = {.lex_state = 2, .external_lex_state = 3},
  [1411] = {.lex_state = 2, .external_lex_state = 2},
  [1412] = {.lex_state = 2, .external_lex_state = 2},
  [1413] = {.lex_state = 11, .external_lex_state = 3},
  [1414] = {.lex_state = 11, .external_lex_state = 3},
  [1415] = {.lex_state = 11, .external_lex_state = 3},
  [1416] = {.lex_state = 11, .external_lex_state = 3},
  [1417] = {.lex_state = 2, .external_lex_state = 2},
  [1418] = {.lex_state = 2, .external_lex_state = 3},
  [1419] = {.lex_state = 2, .external_lex_state = 2},
  [1420] = {.lex_state = 2, .external_lex_state = 3},
  [1421] = {.lex_state = 2, .external_lex_state = 2},
  [1422] = {.lex_state = 2, .external_lex_state = 2},
  [1423] = {.lex_state = 3, .external_lex_state = 4},
  [1424] = {.lex_state = 3, .external_lex_state = 4},
  [1425] = {.lex_state = 3, .external_lex_state = 4},
  [1426] = {.lex_state = 3, .external_lex_state = 4},
  [1427] = {.lex_state = 3, .external_lex_state = 4},
  [1428] = {.lex_state = 3, .external_lex_state = 4},
  [1429] = {.lex_state = 2, .external_lex_state = 2},
  [1430] = {.lex_state = 2, .external_lex_state = 2},
  [1431] = {.lex_state = 2, .external_lex_state = 2},
  [1432] = {.lex_state = 2, .external_lex_state = 2},
  [1433] = {.lex_state = 2, .external_lex_state = 2},
  [1434] = {.lex_state = 2, .external_lex_state = 2},
  [1435] = {.lex_state = 3, .external_lex_state = 4},
  [1436] = {.lex_state = 2, .external_lex_state = 2},
  [1437] = {.lex_state = 2, .external_lex_state = 2},
  [1438] = {.lex_state = 2, .external_lex_state = 2},
  [1439] = {.lex_state = 2, .external_lex_state = 2},
  [1440] = {.lex_state = 2, .external_lex_state = 2},
  [1441] = {.lex_state = 11, .external_lex_state = 3},
  [1442] = {.lex_state = 11, .external_lex_state = 2},
  [1443] = {.lex_state = 3, .external_lex_state = 4},
  [1444] = {.lex_state = 3, .external_lex_state = 4},
  [1445] = {.lex_state = 11, .external_lex_state = 3},
  [1446] = {.lex_state = 11, .external_lex_state = 3},
  [1447] = {.lex_state = 3, .external_lex_state = 4},
  [1448] = {.lex_state = 11, .external_lex_state = 3},
  [1449] = {.lex_state = 3, .external_lex_state = 4},
  [1450] = {.lex_state = 2, .external_lex_state = 3},
  [1451] = {.lex_state = 2, .external_lex_state = 3},
  [1452] = {.lex_state = 2, .external_lex_state = 2},
  [1453] = {.lex_state = 11, .external_lex_state = 3},
  [1454] = {.lex_state = 3, .external_lex_state = 4},
  [1455] = {.lex_state = 2, .external_lex_state = 2},
  [1456] = {.lex_state = 11, .external_lex_state = 3},
  [1457] = {.lex_state = 2, .external_lex_state = 2},
  [1458] = {.lex_state = 2, .external_lex_state = 2},
  [1459] = {.lex_state = 12, .external_lex_state = 3},
  [1460] = {.lex_state = 3, .external_lex_state = 4},
  [1461] = {.lex_state = 2, .external_lex_state = 2},
  [1462] = {.lex_state = 11, .external_lex_state = 3},
  [1463] = {.lex_state = 2, .external_lex_state = 3},
  [1464] = {.lex_state = 2, .external_lex_state = 3},
  [1465] = {.lex_state = 2, .external_lex_state = 2},
  [1466] = {.lex_state = 2, .external_lex_state = 2},
  [1467] = {.lex_state = 11, .external_lex_state = 2},
  [1468] = {.lex_state = 2, .external_lex_state = 2},
  [1469] = {.lex_state = 2, .external_lex_state = 2},
  [1470] = {.lex_state = 2, .external_lex_state = 2},
  [1471] = {.lex_state = 2, .external_lex_state = 2},
  [1472] = {.lex_state = 2, .external_lex_state = 2},
  [1473] = {.lex_state = 2, .external_lex_state = 3},
  [1474] = {.lex_state = 2, .external_lex_state = 2},
  [1475] = {.lex_state = 3, .external_lex_state = 4},
  [1476] = {.lex_state = 11, .external_lex_state = 3},
  [1477] = {.lex_state = 2, .external_lex_state = 2},
  [1478] = {.lex_state = 2, .external_lex_state = 2},
  [1479] = {.lex_state = 2, .external_lex_state = 2},
  [1480] = {.lex_state = 2, .external_lex_state = 2},
  [1481] = {.lex_state = 2, .external_lex_state = 2},
  [1482] = {.lex_state = 2, .external_lex_state = 3},
  [1483] = {.lex_state = 2, .external_lex_state = 3},
  [1484] = {.lex_state = 2, .external_lex_state = 3},
  [1485] = {.lex_state = 3, .external_lex_state = 4},
  [1486] = {.lex_state = 2, .external_lex_state = 3},
  [1487] = {.lex_state = 2, .external_lex_state = 2},
  [1488] = {.lex_state = 2, .external_lex_state = 2},
  [1489] = {.lex_state = 3, .external_lex_state = 4},
  [1490] = {.lex_state = 2, .external_lex_state = 2},
  [1491] = {.lex_state = 2, .external_lex_state = 2},
  [1492] = {.lex_state = 2, .external_lex_state = 2},
  [1493] = {.lex_state = 2, .external_lex_state = 3},
  [1494] = {.lex_state = 11, .external_lex_state = 3},
  [1495] = {.lex_state = 2, .external_lex_state = 2},
  [1496] = {.lex_state = 2, .external_lex_state = 2},
  [1497] = {.lex_state = 2, .external_lex_state = 3},
  [1498] = {.lex_state = 3, .external_lex_state = 4},
  [1499] = {.lex_state = 2, .external_lex_state = 3},
  [1500] = {.lex_state = 2, .external_lex_state = 2},
  [1501] = {.lex_state = 3, .external_lex_state = 4},
  [1502] = {.lex_state = 2, .external_lex_state = 2},
  [1503] = {.lex_state = 2, .external_lex_state = 2},
  [1504] = {.lex_state = 2, .external_lex_state = 3},
  [1505] = {.lex_state = 2, .external_lex_state = 2},
  [1506] = {.lex_state = 2, .external_lex_state = 3},
  [1507] = {.lex_state = 2, .external_lex_state = 2},
  [1508] = {.lex_state = 2, .external_lex_state = 2},
  [1509] = {.lex_state = 2, .external_lex_state = 3},
  [1510] = {.lex_state = 2, .external_lex_state = 3},
  [1511] = {.lex_state = 2, .external_lex_state = 3},
  [1512] = {.lex_state = 2, .external_lex_state = 2},
  [1513] = {.lex_state = 2, .external_lex_state = 2},
  [1514] = {.lex_state = 2, .external_lex_state = 2},
  [1515] = {.lex_state = 2, .external_lex_state = 2},
  [1516] = {.lex_state = 2, .external_lex_state = 2},
  [1517] = {.lex_state = 2, .external_lex_state = 2},
  [1518] = {.lex_state = 11, .external_lex_state = 3},
  [1519] = {.lex_state = 2, .external_lex_state = 2},
  [1520] = {.lex_state = 2, .external_lex_state = 2},
  [1521] = {.lex_state = 2, .external_lex_state = 2},
  [1522] = {.lex_state = 11, .external_lex_state = 3},
  [1523] = {.lex_state = 2, .external_lex_state = 2},
  [1524] = {.lex_state = 2, .external_lex_state = 3},
  [1525] = {.lex_state = 2, .external_lex_state = 2},
  [1526] = {.lex_state = 2, .external_lex_state = 2},
  [1527] = {.lex_state = 2, .external_lex_state = 2},
  [1528] = {.lex_state = 2, .external_lex_state = 2},
  [1529] = {.lex_state = 2, .external_lex_state = 2},
  [1530] = {.lex_state = 2, .external_lex_state = 2},
  [1531] = {.lex_state = 2, .external_lex_state = 2},
  [1532] = {.lex_state = 2, .external_lex_state = 2},
  [1533] = {.lex_state = 2, .external_lex_state = 2},
  [1534] = {.lex_state = 2, .external_lex_state = 2},
  [1535] = {.lex_state = 2, .external_lex_state = 2},
  [1536] = {.lex_state = 2, .external_lex_state = 2},
  [1537] = {.lex_state = 3, .external_lex_state = 4},
  [1538] = {.lex_state = 14, .external_lex_state = 3},
  [1539] = {.lex_state = 2, .external_lex_state = 3},
  [1540] = {.lex_state = 2, .external_lex_state = 2},
  [1541] = {.lex_state = 2, .external_lex_state = 2},
  [1542] = {.lex_state = 2, .external_lex_state = 2},
  [1543] = {.lex_state = 2, .external_lex_state = 2},
  [1544] = {.lex_state = 2, .external_lex_state = 2},
  [1545] = {.lex_state = 2, .external_lex_state = 2},
  [1546] = {.lex_state = 2, .external_lex_state = 2},
  [1547] = {.lex_state = 3, .external_lex_state = 4},
  [1548] = {.lex_state = 2, .external_lex_state = 2},
  [1549] = {.lex_state = 2, .external_lex_state = 2},
  [1550] = {.lex_state = 2, .external_lex_state = 2},
  [1551] = {.lex_state = 2, .external_lex_state = 3},
  [1552] = {.lex_state = 2, .external_lex_state = 3},
  [1553] = {.lex_state = 3, .external_lex_state = 4},
  [1554] = {.lex_state = 2, .external_lex_state = 2},
  [1555] = {.lex_state = 2, .external_lex_state = 2},
  [1556] = {.lex_state = 2, .external_lex_state = 2},
  [1557] = {.lex_state = 2, .external_lex_state = 2},
  [1558] = {.lex_state = 2, .external_lex_state = 2},
  [1559] = {.lex_state = 3, .external_lex_state = 4},
  [1560] = {.lex_state = 2, .external_lex_state = 3},
  [1561] = {.lex_state = 3, .external_lex_state = 4},
  [1562] = {.lex_state = 3, .external_lex_state = 4},
  [1563] = {.lex_state = 3, .external_lex_state = 4},
  [1564] = {.lex_state = 2, .external_lex_state = 2},
  [1565] = {.lex_state = 2, .external_lex_state = 2},
  [1566] = {.lex_state = 2, .external_lex_state = 2},
  [1567] = {.lex_state = 2, .external_lex_state = 2},
  [1568] = {.lex_state = 2, .external_lex_state = 2},
  [1569] = {.lex_state = 2, .external_lex_state = 2},
  [1570] = {.lex_state = 2, .external_lex_state = 2},
  [1571] = {.lex_state = 2, .external_lex_state = 2},
  [1572] = {.lex_state = 2, .external_lex_state = 2},
  [1573] = {.lex_state = 11, .external_lex_state = 3},
  [1574] = {.lex_state = 11, .external_lex_state = 3},
  [1575] = {.lex_state = 11, .external_lex_state = 3},
  [1576] = {.lex_state = 11, .external_lex_state = 3},
  [1577] = {.lex_state = 3, .external_lex_state = 4},
  [1578] = {.lex_state = 11, .external_lex_state = 3},
  [1579] = {.lex_state = 3, .external_lex_state = 4},
  [1580] = {.lex_state = 11, .external_lex_state = 3},
  [1581] = {.lex_state = 2, .external_lex_state = 3},
  [1582] = {.lex_state = 11, .external_lex_state = 3},
  [1583] = {.lex_state = 11, .external_lex_state = 3},
  [1584] = {.lex_state = 3, .external_lex_state = 4},
  [1585] = {.lex_state = 3},
  [1586] = {.lex_state = 11, .external_lex_state = 3},
  [1587] = {.lex_state = 11, .external_lex_state = 3},
  [1588] = {.lex_state = 3},
  [1589] = {.lex_state = 11, .external_lex_state = 3},
  [1590] = {.lex_state = 3},
  [1591] = {.lex_state = 2, .external_lex_state = 3},
  [1592] = {.lex_state = 11, .external_lex_state = 3},
  [1593] = {.lex_state = 11, .external_lex_state = 3},
  [1594] = {.lex_state = 11, .external_lex_state = 3},
  [1595] = {.lex_state = 11, .external_lex_state = 3},
  [1596] = {.lex_state = 11, .external_lex_state = 3},
  [1597] = {.lex_state = 11, .external_lex_state = 3},
  [1598] = {.lex_state = 2, .external_lex_state = 3},
  [1599] = {.lex_state = 11, .external_lex_state = 3},
  [1600] = {.lex_state = 3, .external_lex_state = 4},
  [1601] = {.lex_state = 11, .external_lex_state = 3},
  [1602] = {.lex_state = 2, .external_lex_state = 3},
  [1603] = {.lex_state = 11, .external_lex_state = 3},
  [1604] = {.lex_state = 11, .external_lex_state = 3},
  [1605] = {.lex_state = 11, .external_lex_state = 3},
  [1606] = {.lex_state = 11, .external_lex_state = 3},
  [1607] = {.lex_state = 11, .external_lex_state = 3},
  [1608] = {.lex_state = 11, .external_lex_state = 3},
  [1609] = {.lex_state = 11, .external_lex_state = 3},
  [1610] = {.lex_state = 3, .external_lex_state = 4},
  [1611] = {.lex_state = 11, .external_lex_state = 3},
  [1612] = {.lex_state = 11, .external_lex_state = 3},
  [1613] = {.lex_state = 11, .external_lex_state = 3},
  [1614] = {.lex_state = 11, .external_lex_state = 3},
  [1615] = {.lex_state = 11, .external_lex_state = 3},
  [1616] = {.lex_state = 11, .external_lex_state = 3},
  [1617] = {.lex_state = 11, .external_lex_state = 3},
  [1618] = {.lex_state = 11, .external_lex_state = 3},
  [1619] = {.lex_state = 11, .external_lex_state = 3},
  [1620] = {.lex_state = 11, .external_lex_state = 3},
  [1621] = {.lex_state = 11, .external_lex_state = 3},
  [1622] = {.lex_state = 11, .external_lex_state = 3},
  [1623] = {.lex_state = 11, .external_lex_state = 3},
  [1624] = {.lex_state = 3, .external_lex_state = 4},
  [1625] = {.lex_state = 2, .external_lex_state = 2},
  [1626] = {.lex_state = 3, .external_lex_state = 4},
  [1627] = {.lex_state = 11, .external_lex_state = 3},
  [1628] = {.lex_state = 11, .external_lex_state = 3},
  [1629] = {.lex_state = 3, .external_lex_state = 4},
  [1630] = {.lex_state = 11, .external_lex_state = 3},
  [1631] = {.lex_state = 11, .external_lex_state = 3},
  [1632] = {.lex_state = 11, .external_lex_state = 3},
  [1633] = {.lex_state = 11, .external_lex_state = 3},
  [1634] = {.lex_state = 11, .external_lex_state = 3},
  [1635] = {.lex_state = 11, .external_lex_state = 3},
  [1636] = {.lex_state = 3, .external_lex_state = 4},
  [1637] = {.lex_state = 11, .external_lex_state = 3},
  [1638] = {.lex_state = 11, .external_lex_state = 3},
  [1639] = {.lex_state = 11, .external_lex_state = 3},
  [1640] = {.lex_state = 11, .external_lex_state = 3},
  [1641] = {.lex_state = 11, .external_lex_state = 3},
  [1642] = {.lex_state = 11, .external_lex_state = 3},
  [1643] = {.lex_state = 11, .external_lex_state = 3},
  [1644] = {.lex_state = 11, .external_lex_state = 3},
  [1645] = {.lex_state = 11, .external_lex_state = 3},
  [1646] = {.lex_state = 11, .external_lex_state = 3},
  [1647] = {.lex_state = 3, .external_lex_state = 4},
  [1648] = {.lex_state = 11, .external_lex_state = 3},
  [1649] = {.lex_state = 11, .external_lex_state = 3},
  [1650] = {.lex_state = 11, .external_lex_state = 3},
  [1651] = {.lex_state = 11, .external_lex_state = 3},
  [1652] = {.lex_state = 2, .external_lex_state = 3},
  [1653] = {.lex_state = 11, .external_lex_state = 3},
  [1654] = {.lex_state = 11, .external_lex_state = 3},
  [1655] = {.lex_state = 11, .external_lex_state = 3},
  [1656] = {.lex_state = 11, .external_lex_state = 3},
  [1657] = {.lex_state = 11, .external_lex_state = 3},
  [1658] = {.lex_state = 11, .external_lex_state = 3},
  [1659] = {.lex_state = 11, .external_lex_state = 3},
  [1660] = {.lex_state = 11, .external_lex_state = 3},
  [1661] = {.lex_state = 11, .external_lex_state = 3},
  [1662] = {.lex_state = 11, .external_lex_state = 3},
  [1663] = {.lex_state = 2, .external_lex_state = 3},
  [1664] = {.lex_state = 11, .external_lex_state = 3},
  [1665] = {.lex_state = 2, .external_lex_state = 2},
  [1666] = {.lex_state = 11, .external_lex_state = 3},
  [1667] = {.lex_state = 3, .external_lex_state = 4},
  [1668] = {.lex_state = 11, .external_lex_state = 3},
  [1669] = {.lex_state = 11, .external_lex_state = 3},
  [1670] = {.lex_state = 11, .external_lex_state = 3},
  [1671] = {.lex_state = 3, .external_lex_state = 4},
  [1672] = {.lex_state = 11, .external_lex_state = 3},
  [1673] = {.lex_state = 11, .external_lex_state = 3},
  [1674] = {.lex_state = 3, .external_lex_state = 4},
  [1675] = {.lex_state = 11, .external_lex_state = 3},
  [1676] = {.lex_state = 3},
  [1677] = {.lex_state = 3},
  [1678] = {.lex_state = 3, .external_lex_state = 4},
  [1679] = {.lex_state = 3},
  [1680] = {.lex_state = 3},
  [1681] = {.lex_state = 3},
  [1682] = {.lex_state = 3},
  [1683] = {.lex_state = 11, .external_lex_state = 3},
  [1684] = {.lex_state = 11, .external_lex_state = 3},
  [1685] = {.lex_state = 11, .external_lex_state = 3},
  [1686] = {.lex_state = 3, .external_lex_state = 4},
  [1687] = {.lex_state = 2, .external_lex_state = 3},
  [1688] = {.lex_state = 3},
  [1689] = {.lex_state = 3},
  [1690] = {.lex_state = 11, .external_lex_state = 3},
  [1691] = {.lex_state = 11, .external_lex_state = 3},
  [1692] = {.lex_state = 11, .external_lex_state = 3},
  [1693] = {.lex_state = 11, .external_lex_state = 3},
  [1694] = {.lex_state = 3},
  [1695] = {.lex_state = 11, .external_lex_state = 3},
  [1696] = {.lex_state = 11, .external_lex_state = 3},
  [1697] = {.lex_state = 11, .external_lex_state = 3},
  [1698] = {.lex_state = 3, .external_lex_state = 4},
  [1699] = {.lex_state = 11, .external_lex_state = 3},
  [1700] = {.lex_state = 3, .external_lex_state = 4},
  [1701] = {.lex_state = 3, .external_lex_state = 4},
  [1702] = {.lex_state = 11, .external_lex_state = 3},
  [1703] = {.lex_state = 11, .external_lex_state = 3},
  [1704] = {.lex_state = 2, .external_lex_state = 3},
  [1705] = {.lex_state = 11, .external_lex_state = 3},
  [1706] = {.lex_state = 11, .external_lex_state = 3},
  [1707] = {.lex_state = 2, .external_lex_state = 2},
  [1708] = {.lex_state = 11, .external_lex_state = 3},
  [1709] = {.lex_state = 2, .external_lex_state = 2},
  [1710] = {.lex_state = 3, .external_lex_state = 4},
  [1711] = {.lex_state = 11, .external_lex_state = 3},
  [1712] = {.lex_state = 11, .external_lex_state = 3},
  [1713] = {.lex_state = 3},
  [1714] = {.lex_state = 11, .external_lex_state = 3},
  [1715] = {.lex_state = 11, .external_lex_state = 3},
  [1716] = {.lex_state = 3},
  [1717] = {.lex_state = 3},
  [1718] = {.lex_state = 3},
  [1719] = {.lex_state = 3},
  [1720] = {.lex_state = 2, .external_lex_state = 3},
  [1721] = {.lex_state = 2, .external_lex_state = 3},
  [1722] = {.lex_state = 3},
  [1723] = {.lex_state = 2, .external_lex_state = 3},
  [1724] = {.lex_state = 2, .external_lex_state = 3},
  [1725] = {.lex_state = 3},
  [1726] = {.lex_state = 3},
  [1727] = {.lex_state = 3, .external_lex_state = 4},
  [1728] = {.lex_state = 3},
  [1729] = {.lex_state = 2, .external_lex_state = 3},
  [1730] = {.lex_state = 3},
  [1731] = {.lex_state = 2, .external_lex_state = 3},
  [1732] = {.lex_state = 3},
  [1733] = {.lex_state = 3},
  [1734] = {.lex_state = 3},
  [1735] = {.lex_state = 2, .external_lex_state = 3},
  [1736] = {.lex_state = 3},
  [1737] = {.lex_state = 3},
  [1738] = {.lex_state = 3},
  [1739] = {.lex_state = 3},
  [1740] = {.lex_state = 3},
  [1741] = {.lex_state = 3},
  [1742] = {.lex_state = 3},
  [1743] = {.lex_state = 3},
  [1744] = {.lex_state = 3},
  [1745] = {.lex_state = 3},
  [1746] = {.lex_state = 3},
  [1747] = {.lex_state = 3},
  [1748] = {.lex_state = 3},
  [1749] = {.lex_state = 3},
  [1750] = {.lex_state = 3},
  [1751] = {.lex_state = 3},
  [1752] = {.lex_state = 3},
  [1753] = {.lex_state = 3},
  [1754] = {.lex_state = 3},
  [1755] = {.lex_state = 3},
  [1756] = {.lex_state = 3},
  [1757] = {.lex_state = 3},
  [1758] = {.lex_state = 3},
  [1759] = {.lex_state = 3},
  [1760] = {.lex_state = 3},
  [1761] = {.lex_state = 3},
  [1762] = {.lex_state = 3},
  [1763] = {.lex_state = 3},
  [1764] = {.lex_state = 3},
  [1765] = {.lex_state = 3},
  [1766] = {.lex_state = 3},
  [1767] = {.lex_state = 3},
  [1768] = {.lex_state = 3},
  [1769] = {.lex_state = 3},
  [1770] = {.lex_state = 3},
  [1771] = {.lex_state = 3},
  [1772] = {.lex_state = 3},
  [1773] = {.lex_state = 3},
  [1774] = {.lex_state = 3},
  [1775] = {.lex_state = 3},
  [1776] = {.lex_state = 3},
  [1777] = {.lex_state = 3},
  [1778] = {.lex_state = 3},
  [1779] = {.lex_state = 3},
  [1780] = {.lex_state = 3},
  [1781] = {.lex_state = 3, .external_lex_state = 4},
  [1782] = {.lex_state = 3},
  [1783] = {.lex_state = 3},
  [1784] = {.lex_state = 3},
  [1785] = {.lex_state = 3, .external_lex_state = 4},
  [1786] = {.lex_state = 3, .external_lex_state = 4},
  [1787] = {.lex_state = 3},
  [1788] = {.lex_state = 3, .external_lex_state = 4},
  [1789] = {.lex_state = 3},
  [1790] = {.lex_state = 3},
  [1791] = {.lex_state = 3, .external_lex_state = 4},
  [1792] = {.lex_state = 3, .external_lex_state = 4},
  [1793] = {.lex_state = 3, .external_lex_state = 4},
  [1794] = {.lex_state = 3},
  [1795] = {.lex_state = 3, .external_lex_state = 4},
  [1796] = {.lex_state = 3, .external_lex_state = 4},
  [1797] = {.lex_state = 3},
  [1798] = {.lex_state = 3, .external_lex_state = 4},
  [1799] = {.lex_state = 3},
  [1800] = {.lex_state = 3, .external_lex_state = 4},
  [1801] = {.lex_state = 3, .external_lex_state = 4},
  [1802] = {.lex_state = 3},
  [1803] = {.lex_state = 3},
  [1804] = {.lex_state = 3},
  [1805] = {.lex_state = 3},
  [1806] = {.lex_state = 3, .external_lex_state = 4},
  [1807] = {.lex_state = 3},
  [1808] = {.lex_state = 3, .external_lex_state = 4},
  [1809] = {.lex_state = 3},
  [1810] = {.lex_state = 3, .external_lex_state = 4},
  [1811] = {.lex_state = 3, .external_lex_state = 4},
  [1812] = {.lex_state = 3, .external_lex_state = 4},
  [1813] = {.lex_state = 3},
  [1814] = {.lex_state = 3},
  [1815] = {.lex_state = 3},
  [1816] = {.lex_state = 3},
  [1817] = {.lex_state = 3},
  [1818] = {.lex_state = 3},
  [1819] = {.lex_state = 3},
  [1820] = {.lex_state = 3},
  [1821] = {.lex_state = 3},
  [1822] = {.lex_state = 3},
  [1823] = {.lex_state = 3},
  [1824] = {.lex_state = 3},
  [1825] = {.lex_state = 3},
  [1826] = {.lex_state = 3},
  [1827] = {.lex_state = 3},
  [1828] = {.lex_state = 3},
  [1829] = {.lex_state = 3},
  [1830] = {.lex_state = 3},
  [1831] = {.lex_state = 3},
  [1832] = {.lex_state = 3},
  [1833] = {.lex_state = 3},
  [1834] = {.lex_state = 3},
  [1835] = {.lex_state = 3},
  [1836] = {.lex_state = 3},
  [1837] = {.lex_state = 3},
  [1838] = {.lex_state = 3},
  [1839] = {.lex_state = 3},
  [1840] = {.lex_state = 3},
  [1841] = {.lex_state = 3},
  [1842] = {.lex_state = 3},
  [1843] = {.lex_state = 3},
  [1844] = {.lex_state = 3},
  [1845] = {.lex_state = 3},
  [1846] = {.lex_state = 3},
  [1847] = {.lex_state = 3},
  [1848] = {.lex_state = 3},
  [1849] = {.lex_state = 3},
  [1850] = {.lex_state = 3},
  [1851] = {.lex_state = 3},
  [1852] = {.lex_state = 3},
  [1853] = {.lex_state = 3},
  [1854] = {.lex_state = 3},
  [1855] = {.lex_state = 3},
  [1856] = {.lex_state = 3},
  [1857] = {.lex_state = 24},
  [1858] = {.lex_state = 24},
  [1859] = {.lex_state = 24},
  [1860] = {.lex_state = 24},
  [1861] = {.lex_state = 24},
  [1862] = {.lex_state = 24},
  [1863] = {.lex_state = 24},
  [1864] = {.lex_state = 3, .external_lex_state = 4},
  [1865] = {.lex_state = 3, .external_lex_state = 4},
  [1866] = {.lex_state = 3},
  [1867] = {.lex_state = 3, .external_lex_state = 4},
  [1868] = {.lex_state = 3, .external_lex_state = 4},
  [1869] = {.lex_state = 24},
  [1870] = {.lex_state = 3, .external_lex_state = 4},
  [1871] = {.lex_state = 3, .external_lex_state = 4},
  [1872] = {.lex_state = 3, .external_lex_state = 4},
  [1873] = {.lex_state = 3, .external_lex_state = 4},
  [1874] = {.lex_state = 3, .external_lex_state = 4},
  [1875] = {.lex_state = 3, .external_lex_state = 4},
  [1876] = {.lex_state = 3, .external_lex_state = 4},
  [1877] = {.lex_state = 3, .external_lex_state = 4},
  [1878] = {.lex_state = 24},
  [1879] = {.lex_state = 24},
  [1880] = {.lex_state = 3, .external_lex_state = 4},
  [1881] = {.lex_state = 3, .external_lex_state = 4},
  [1882] = {.lex_state = 3, .external_lex_state = 4},
  [1883] = {.lex_state = 3, .external_lex_state = 4},
  [1884] = {.lex_state = 3, .external_lex_state = 4},
  [1885] = {.lex_state = 3},
  [1886] = {.lex_state = 3, .external_lex_state = 4},
  [1887] = {.lex_state = 3, .external_lex_state = 4},
  [1888] = {.lex_state = 24},
  [1889] = {.lex_state = 24},
  [1890] = {.lex_state = 3, .external_lex_state = 4},
  [1891] = {.lex_state = 3, .external_lex_state = 4},
  [1892] = {.lex_state = 3, .external_lex_state = 4},
  [1893] = {.lex_state = 3},
  [1894] = {.lex_state = 3, .external_lex_state = 4},
  [1895] = {.lex_state = 3},
  [1896] = {.lex_state = 3, .external_lex_state = 4},
  [1897] = {.lex_state = 3, .external_lex_state = 4},
  [1898] = {.lex_state = 24},
  [1899] = {.lex_state = 3, .external_lex_state = 4},
  [1900] = {.lex_state = 3, .external_lex_state = 4},
  [1901] = {.lex_state = 24},
  [1902] = {.lex_state = 3, .external_lex_state = 4},
  [1903] = {.lex_state = 3, .external_lex_state = 4},
  [1904] = {.lex_state = 3, .external_lex_state = 4},
  [1905] = {.lex_state = 3, .external_lex_state = 4},
  [1906] = {.lex_state = 24},
  [1907] = {.lex_state = 3, .external_lex_state = 4},
  [1908] = {.lex_state = 3, .external_lex_state = 4},
  [1909] = {.lex_state = 3, .external_lex_state = 4},
  [1910] = {.lex_state = 3},
  [1911] = {.lex_state = 3, .external_lex_state = 4},
  [1912] = {.lex_state = 3, .external_lex_state = 4},
  [1913] = {.lex_state = 3},
  [1914] = {.lex_state = 3},
  [1915] = {.lex_state = 3, .external_lex_state = 4},
  [1916] = {.lex_state = 3, .external_lex_state = 4},
  [1917] = {.lex_state = 3, .external_lex_state = 4},
  [1918] = {.lex_state = 3},
  [1919] = {.lex_state = 3},
  [1920] = {.lex_state = 3, .external_lex_state = 4},
  [1921] = {.lex_state = 3, .external_lex_state = 4},
  [1922] = {.lex_state = 3, .external_lex_state = 4},
  [1923] = {.lex_state = 3, .external_lex_state = 4},
  [1924] = {.lex_state = 3},
  [1925] = {.lex_state = 3, .external_lex_state = 4},
  [1926] = {.lex_state = 3},
  [1927] = {.lex_state = 3},
  [1928] = {.lex_state = 3, .external_lex_state = 4},
  [1929] = {.lex_state = 24},
  [1930] = {.lex_state = 3},
  [1931] = {.lex_state = 3, .external_lex_state = 4},
  [1932] = {.lex_state = 3, .external_lex_state = 4},
  [1933] = {.lex_state = 3, .external_lex_state = 4},
  [1934] = {.lex_state = 3, .external_lex_state = 4},
  [1935] = {.lex_state = 3, .external_lex_state = 4},
  [1936] = {.lex_state = 3, .external_lex_state = 4},
  [1937] = {.lex_state = 3, .external_lex_state = 4},
  [1938] = {.lex_state = 3, .external_lex_state = 4},
  [1939] = {.lex_state = 3, .external_lex_state = 4},
  [1940] = {.lex_state = 3, .external_lex_state = 4},
  [1941] = {.lex_state = 3, .external_lex_state = 4},
  [1942] = {.lex_state = 3, .external_lex_state = 4},
  [1943] = {.lex_state = 3, .external_lex_state = 4},
  [1944] = {.lex_state = 3, .external_lex_state = 4},
  [1945] = {.lex_state = 24},
  [1946] = {.lex_state = 3},
  [1947] = {.lex_state = 3, .external_lex_state = 4},
  [1948] = {.lex_state = 3, .external_lex_state = 4},
  [1949] = {.lex_state = 3},
  [1950] = {.lex_state = 3, .external_lex_state = 4},
  [1951] = {.lex_state = 3, .external_lex_state = 4},
  [1952] = {.lex_state = 3, .external_lex_state = 4},
  [1953] = {.lex_state = 3, .external_lex_state = 4},
  [1954] = {.lex_state = 3, .external_lex_state = 4},
  [1955] = {.lex_state = 3},
  [1956] = {.lex_state = 24},
  [1957] = {.lex_state = 3},
  [1958] = {.lex_state = 3, .external_lex_state = 4},
  [1959] = {.lex_state = 3},
  [1960] = {.lex_state = 3},
  [1961] = {.lex_state = 24},
  [1962] = {.lex_state = 3, .external_lex_state = 4},
  [1963] = {.lex_state = 3},
  [1964] = {.lex_state = 3},
  [1965] = {.lex_state = 3, .external_lex_state = 4},
  [1966] = {.lex_state = 3, .external_lex_state = 4},
  [1967] = {.lex_state = 24},
  [1968] = {.lex_state = 3, .external_lex_state = 4},
  [1969] = {.lex_state = 3, .external_lex_state = 4},
  [1970] = {.lex_state = 3, .external_lex_state = 4},
  [1971] = {.lex_state = 3, .external_lex_state = 4},
  [1972] = {.lex_state = 3, .external_lex_state = 4},
  [1973] = {.lex_state = 3},
  [1974] = {.lex_state = 24},
  [1975] = {.lex_state = 32},
  [1976] = {.lex_state = 3},
  [1977] = {.lex_state = 24},
  [1978] = {.lex_state = 3},
  [1979] = {.lex_state = 32},
  [1980] = {.lex_state = 3},
  [1981] = {.lex_state = 24},
  [1982] = {.lex_state = 24},
  [1983] = {.lex_state = 3},
  [1984] = {.lex_state = 3},
  [1985] = {.lex_state = 32},
  [1986] = {.lex_state = 32},
  [1987] = {.lex_state = 32},
  [1988] = {.lex_state = 3},
  [1989] = {.lex_state = 24},
  [1990] = {.lex_state = 3, .external_lex_state = 4},
  [1991] = {.lex_state = 3},
  [1992] = {.lex_state = 3},
  [1993] = {.lex_state = 32},
  [1994] = {.lex_state = 24},
  [1995] = {.lex_state = 3, .external_lex_state = 4},
  [1996] = {.lex_state = 3},
  [1997] = {.lex_state = 3},
  [1998] = {.lex_state = 3},
  [1999] = {.lex_state = 24},
  [2000] = {.lex_state = 32},
  [2001] = {.lex_state = 32},
  [2002] = {.lex_state = 3},
  [2003] = {.lex_state = 32},
  [2004] = {.lex_state = 32},
  [2005] = {.lex_state = 3},
  [2006] = {.lex_state = 24},
  [2007] = {.lex_state = 3},
  [2008] = {.lex_state = 24},
  [2009] = {.lex_state = 3},
  [2010] = {.lex_state = 3, .external_lex_state = 4},
  [2011] = {.lex_state = 3},
  [2012] = {.lex_state = 3},
  [2013] = {.lex_state = 24},
  [2014] = {.lex_state = 24},
  [2015] = {.lex_state = 32},
  [2016] = {.lex_state = 24},
  [2017] = {.lex_state = 3},
  [2018] = {.lex_state = 3, .external_lex_state = 4},
  [2019] = {.lex_state = 3},
  [2020] = {.lex_state = 32},
  [2021] = {.lex_state = 32},
  [2022] = {.lex_state = 32},
  [2023] = {.lex_state = 3},
  [2024] = {.lex_state = 32},
  [2025] = {.lex_state = 32},
  [2026] = {.lex_state = 32},
  [2027] = {.lex_state = 3},
  [2028] = {.lex_state = 3},
  [2029] = {.lex_state = 3},
  [2030] = {.lex_state = 3, .external_lex_state = 4},
  [2031] = {.lex_state = 3},
  [2032] = {.lex_state = 32},
  [2033] = {.lex_state = 32},
  [2034] = {.lex_state = 3, .external_lex_state = 4},
  [2035] = {.lex_state = 24},
  [2036] = {.lex_state = 3},
  [2037] = {.lex_state = 3},
  [2038] = {.lex_state = 3},
  [2039] = {.lex_state = 3},
  [2040] = {.lex_state = 3},
  [2041] = {.lex_state = 3},
  [2042] = {.lex_state = 3},
  [2043] = {.lex_state = 3},
  [2044] = {.lex_state = 3},
  [2045] = {.lex_state = 3, .external_lex_state = 4},
  [2046] = {.lex_state = 3},
  [2047] = {.lex_state = 0, .external_lex_state = 4},
  [2048] = {.lex_state = 3},
  [2049] = {.lex_state = 3},
  [2050] = {.lex_state = 3},
  [2051] = {.lex_state = 0, .external_lex_state = 4},
  [2052] = {.lex_state = 3, .external_lex_state = 4},
  [2053] = {.lex_state = 3},
  [2054] = {.lex_state = 3, .external_lex_state = 4},
  [2055] = {.lex_state = 3},
  [2056] = {.lex_state = 3, .external_lex_state = 4},
  [2057] = {.lex_state = 3},
  [2058] = {.lex_state = 3},
  [2059] = {.lex_state = 3},
  [2060] = {.lex_state = 3},
  [2061] = {.lex_state = 17},
  [2062] = {.lex_state = 3},
  [2063] = {.lex_state = 3},
  [2064] = {.lex_state = 3, .external_lex_state = 4},
  [2065] = {.lex_state = 0, .external_lex_state = 4},
  [2066] = {.lex_state = 3},
  [2067] = {.lex_state = 0, .external_lex_state = 4},
  [2068] = {.lex_state = 0, .external_lex_state = 4},
  [2069] = {.lex_state = 0, .external_lex_state = 4},
  [2070] = {.lex_state = 3, .external_lex_state = 4},
  [2071] = {.lex_state = 3, .external_lex_state = 4},
  [2072] = {.lex_state = 0, .external_lex_state = 4},
  [2073] = {.lex_state = 3, .external_lex_state = 4},
  [2074] = {.lex_state = 0, .external_lex_state = 4},
  [2075] = {.lex_state = 3, .external_lex_state = 4},
  [2076] = {.lex_state = 0},
  [2077] = {.lex_state = 3},
  [2078] = {.lex_state = 3},
  [2079] = {.lex_state = 3},
  [2080] = {.lex_state = 3, .external_lex_state = 4},
  [2081] = {.lex_state = 3, .external_lex_state = 4},
  [2082] = {.lex_state = 3},
  [2083] = {.lex_state = 3},
  [2084] = {.lex_state = 3},
  [2085] = {.lex_state = 3, .external_lex_state = 4},
  [2086] = {.lex_state = 3},
  [2087] = {.lex_state = 3},
  [2088] = {.lex_state = 3},
  [2089] = {.lex_state = 3},
  [2090] = {.lex_state = 3},
  [2091] = {.lex_state = 3},
  [2092] = {.lex_state = 3, .external_lex_state = 4},
  [2093] = {.lex_state = 3, .external_lex_state = 4},
  [2094] = {.lex_state = 3},
  [2095] = {.lex_state = 3},
  [2096] = {.lex_state = 17},
  [2097] = {.lex_state = 3},
  [2098] = {.lex_state = 3, .external_lex_state = 4},
  [2099] = {.lex_state = 3},
  [2100] = {.lex_state = 3},
  [2101] = {.lex_state = 3, .external_lex_state = 4},
  [2102] = {.lex_state = 3},
  [2103] = {.lex_state = 24},
  [2104] = {.lex_state = 3, .external_lex_state = 4},
  [2105] = {.lex_state = 3, .external_lex_state = 4},
  [2106] = {.lex_state = 3},
  [2107] = {.lex_state = 0, .external_lex_state = 4},
  [2108] = {.lex_state = 3},
  [2109] = {.lex_state = 3},
  [2110] = {.lex_state = 3},
  [2111] = {.lex_state = 3, .external_lex_state = 4},
  [2112] = {.lex_state = 3},
  [2113] = {.lex_state = 3},
  [2114] = {.lex_state = 3},
  [2115] = {.lex_state = 22, .external_lex_state = 5},
  [2116] = {.lex_state = 24},
  [2117] = {.lex_state = 0, .external_lex_state = 4},
  [2118] = {.lex_state = 0, .external_lex_state = 4},
  [2119] = {.lex_state = 3},
  [2120] = {.lex_state = 0, .external_lex_state = 4},
  [2121] = {.lex_state = 3},
  [2122] = {.lex_state = 3},
  [2123] = {.lex_state = 0, .external_lex_state = 4},
  [2124] = {.lex_state = 3},
  [2125] = {.lex_state = 0, .external_lex_state = 4},
  [2126] = {.lex_state = 0, .external_lex_state = 4},
  [2127] = {.lex_state = 3},
  [2128] = {.lex_state = 3},
  [2129] = {.lex_state = 3},
  [2130] = {.lex_state = 3},
  [2131] = {.lex_state = 0, .external_lex_state = 4},
  [2132] = {.lex_state = 17},
  [2133] = {.lex_state = 3},
  [2134] = {.lex_state = 3},
  [2135] = {.lex_state = 0, .external_lex_state = 4},
  [2136] = {.lex_state = 0, .external_lex_state = 4},
  [2137] = {.lex_state = 20},
  [2138] = {.lex_state = 0, .external_lex_state = 4},
  [2139] = {.lex_state = 3},
  [2140] = {.lex_state = 0, .external_lex_state = 4},
  [2141] = {.lex_state = 0, .external_lex_state = 4},
  [2142] = {.lex_state = 22, .external_lex_state = 5},
  [2143] = {.lex_state = 3},
  [2144] = {.lex_state = 3},
  [2145] = {.lex_state = 22, .external_lex_state = 5},
  [2146] = {.lex_state = 0},
  [2147] = {.lex_state = 3},
  [2148] = {.lex_state = 3},
  [2149] = {.lex_state = 3},
  [2150] = {.lex_state = 3},
  [2151] = {.lex_state = 3},
  [2152] = {.lex_state = 0, .external_lex_state = 4},
  [2153] = {.lex_state = 0, .external_lex_state = 4},
  [2154] = {.lex_state = 22, .external_lex_state = 5},
  [2155] = {.lex_state = 3},
  [2156] = {.lex_state = 3},
  [2157] = {.lex_state = 20},
  [2158] = {.lex_state = 3},
  [2159] = {.lex_state = 3},
  [2160] = {.lex_state = 3},
  [2161] = {.lex_state = 3},
  [2162] = {.lex_state = 3},
  [2163] = {.lex_state = 0, .external_lex_state = 4},
  [2164] = {.lex_state = 3, .external_lex_state = 4},
  [2165] = {.lex_state = 3},
  [2166] = {.lex_state = 0, .external_lex_state = 4},
  [2167] = {.lex_state = 3},
  [2168] = {.lex_state = 3},
  [2169] = {.lex_state = 3},
  [2170] = {.lex_state = 20},
  [2171] = {.lex_state = 0, .external_lex_state = 4},
  [2172] = {.lex_state = 0, .external_lex_state = 4},
  [2173] = {.lex_state = 3},
  [2174] = {.lex_state = 0, .external_lex_state = 4},
  [2175] = {.lex_state = 0, .external_lex_state = 4},
  [2176] = {.lex_state = 3},
  [2177] = {.lex_state = 24},
  [2178] = {.lex_state = 3},
  [2179] = {.lex_state = 3},
  [2180] = {.lex_state = 3},
  [2181] = {.lex_state = 3},
  [2182] = {.lex_state = 22, .external_lex_state = 5},
  [2183] = {.lex_state = 3},
  [2184] = {.lex_state = 3},
  [2185] = {.lex_state = 0, .external_lex_state = 4},
  [2186] = {.lex_state = 3},
  [2187] = {.lex_state = 3},
  [2188] = {.lex_state = 3},
  [2189] = {.lex_state = 3},
  [2190] = {.lex_state = 22, .external_lex_state = 5},
  [2191] = {.lex_state = 3},
  [2192] = {.lex_state = 3},
  [2193] = {.lex_state = 3, .external_lex_state = 4},
  [2194] = {.lex_state = 3},
  [2195] = {.lex_state = 3},
  [2196] = {.lex_state = 3},
  [2197] = {.lex_state = 3},
  [2198] = {.lex_state = 3},
  [2199] = {.lex_state = 3},
  [2200] = {.lex_state = 22, .external_lex_state = 5},
  [2201] = {.lex_state = 3},
  [2202] = {.lex_state = 3},
  [2203] = {.lex_state = 0, .external_lex_state = 4},
  [2204] = {.lex_state = 3},
  [2205] = {.lex_state = 3},
  [2206] = {.lex_state = 3},
  [2207] = {.lex_state = 3},
  [2208] = {.lex_state = 24},
  [2209] = {.lex_state = 3},
  [2210] = {.lex_state = 0, .external_lex_state = 4},
  [2211] = {.lex_state = 3},
  [2212] = {.lex_state = 0, .external_lex_state = 4},
  [2213] = {.lex_state = 0, .external_lex_state = 4},
  [2214] = {.lex_state = 0, .external_lex_state = 4},
  [2215] = {.lex_state = 0, .external_lex_state = 4},
  [2216] = {.lex_state = 0, .external_lex_state = 4},
  [2217] = {.lex_state = 3},
  [2218] = {.lex_state = 0, .external_lex_state = 4},
  [2219] = {.lex_state = 0, .external_lex_state = 4},
  [2220] = {.lex_state = 0, .external_lex_state = 4},
  [2221] = {.lex_state = 3, .external_lex_state = 4},
  [2222] = {.lex_state = 3},
  [2223] = {.lex_state = 3},
  [2224] = {.lex_state = 3},
  [2225] = {.lex_state = 17},
  [2226] = {.lex_state = 0, .external_lex_state = 4},
  [2227] = {.lex_state = 3},
  [2228] = {.lex_state = 0, .external_lex_state = 4},
  [2229] = {.lex_state = 0, .external_lex_state = 4},
  [2230] = {.lex_state = 0, .external_lex_state = 4},
  [2231] = {.lex_state = 3},
  [2232] = {.lex_state = 3},
  [2233] = {.lex_state = 3},
  [2234] = {.lex_state = 20},
  [2235] = {.lex_state = 0, .external_lex_state = 4},
  [2236] = {.lex_state = 3},
  [2237] = {.lex_state = 0, .external_lex_state = 4},
  [2238] = {.lex_state = 20},
  [2239] = {.lex_state = 3},
  [2240] = {.lex_state = 3},
  [2241] = {.lex_state = 0, .external_lex_state = 4},
  [2242] = {.lex_state = 0, .external_lex_state = 4},
  [2243] = {.lex_state = 3},
  [2244] = {.lex_state = 0, .external_lex_state = 4},
  [2245] = {.lex_state = 0, .external_lex_state = 4},
  [2246] = {.lex_state = 3},
  [2247] = {.lex_state = 0, .external_lex_state = 4},
  [2248] = {.lex_state = 3},
  [2249] = {.lex_state = 0, .external_lex_state = 4},
  [2250] = {.lex_state = 3},
  [2251] = {.lex_state = 0, .external_lex_state = 4},
  [2252] = {.lex_state = 0, .external_lex_state = 4},
  [2253] = {.lex_state = 20},
  [2254] = {.lex_state = 0, .external_lex_state = 4},
  [2255] = {.lex_state = 3},
  [2256] = {.lex_state = 0, .external_lex_state = 4},
  [2257] = {.lex_state = 3, .external_lex_state = 4},
  [2258] = {.lex_state = 3},
  [2259] = {.lex_state = 0, .external_lex_state = 4},
  [2260] = {.lex_state = 24},
  [2261] = {.lex_state = 0, .external_lex_state = 4},
  [2262] = {.lex_state = 3},
  [2263] = {.lex_state = 24},
  [2264] = {.lex_state = 3},
  [2265] = {.lex_state = 20},
  [2266] = {.lex_state = 0, .external_lex_state = 4},
  [2267] = {.lex_state = 10},
  [2268] = {.lex_state = 3},
  [2269] = {.lex_state = 0, .external_lex_state = 4},
  [2270] = {.lex_state = 3},
  [2271] = {.lex_state = 0, .external_lex_state = 4},
  [2272] = {.lex_state = 0, .external_lex_state = 4},
  [2273] = {.lex_state = 3},
  [2274] = {.lex_state = 3, .external_lex_state = 4},
  [2275] = {.lex_state = 3},
  [2276] = {.lex_state = 3, .external_lex_state = 4},
  [2277] = {.lex_state = 20},
  [2278] = {.lex_state = 0, .external_lex_state = 4},
  [2279] = {.lex_state = 0, .external_lex_state = 4},
  [2280] = {.lex_state = 0, .external_lex_state = 4},
  [2281] = {.lex_state = 0, .external_lex_state = 4},
  [2282] = {.lex_state = 3},
  [2283] = {.lex_state = 3},
  [2284] = {.lex_state = 3},
  [2285] = {.lex_state = 0, .external_lex_state = 4},
  [2286] = {.lex_state = 0, .external_lex_state = 4},
  [2287] = {.lex_state = 0, .external_lex_state = 4},
  [2288] = {.lex_state = 0, .external_lex_state = 4},
  [2289] = {.lex_state = 0, .external_lex_state = 4},
  [2290] = {.lex_state = 0, .external_lex_state = 4},
  [2291] = {.lex_state = 20},
  [2292] = {.lex_state = 0, .external_lex_state = 4},
  [2293] = {.lex_state = 3},
  [2294] = {.lex_state = 0, .external_lex_state = 4},
  [2295] = {.lex_state = 3},
  [2296] = {.lex_state = 0},
  [2297] = {.lex_state = 0, .external_lex_state = 4},
  [2298] = {.lex_state = 3},
  [2299] = {.lex_state = 0, .external_lex_state = 4},
  [2300] = {.lex_state = 0, .external_lex_state = 4},
  [2301] = {.lex_state = 3},
  [2302] = {.lex_state = 0, .external_lex_state = 4},
  [2303] = {.lex_state = 0, .external_lex_state = 4},
  [2304] = {.lex_state = 0},
  [2305] = {.lex_state = 0},
  [2306] = {.lex_state = 0},
  [2307] = {.lex_state = 3},
  [2308] = {.lex_state = 0},
  [2309] = {.lex_state = 3},
  [2310] = {.lex_state = 0, .external_lex_state = 4},
  [2311] = {.lex_state = 0, .external_lex_state = 4},
  [2312] = {.lex_state = 17},
  [2313] = {.lex_state = 20},
  [2314] = {.lex_state = 0, .external_lex_state = 4},
  [2315] = {.lex_state = 3},
  [2316] = {.lex_state = 3},
  [2317] = {.lex_state = 20},
  [2318] = {.lex_state = 0, .external_lex_state = 4},
  [2319] = {.lex_state = 20},
  [2320] = {.lex_state = 3, .external_lex_state = 4},
  [2321] = {.lex_state = 3},
  [2322] = {.lex_state = 3},
  [2323] = {.lex_state = 3},
  [2324] = {.lex_state = 0, .external_lex_state = 4},
  [2325] = {.lex_state = 0, .external_lex_state = 4},
  [2326] = {.lex_state = 3},
  [2327] = {.lex_state = 3},
  [2328] = {.lex_state = 3},
  [2329] = {.lex_state = 24},
  [2330] = {.lex_state = 20},
  [2331] = {.lex_state = 0},
  [2332] = {.lex_state = 3},
  [2333] = {.lex_state = 3, .external_lex_state = 4},
  [2334] = {.lex_state = 3},
  [2335] = {.lex_state = 0, .external_lex_state = 4},
  [2336] = {.lex_state = 24},
  [2337] = {.lex_state = 3},
  [2338] = {.lex_state = 0, .external_lex_state = 4},
  [2339] = {.lex_state = 0, .external_lex_state = 4},
  [2340] = {.lex_state = 3},
  [2341] = {.lex_state = 0, .external_lex_state = 4},
  [2342] = {.lex_state = 10},
  [2343] = {.lex_state = 0, .external_lex_state = 4},
  [2344] = {.lex_state = 0, .external_lex_state = 4},
  [2345] = {.lex_state = 3},
  [2346] = {.lex_state = 3},
  [2347] = {.lex_state = 3},
  [2348] = {.lex_state = 3},
  [2349] = {.lex_state = 20},
  [2350] = {.lex_state = 0, .external_lex_state = 4},
  [2351] = {.lex_state = 0, .external_lex_state = 4},
  [2352] = {.lex_state = 0, .external_lex_state = 4},
  [2353] = {.lex_state = 20},
  [2354] = {.lex_state = 3},
  [2355] = {.lex_state = 3},
  [2356] = {.lex_state = 0, .external_lex_state = 4},
  [2357] = {.lex_state = 0, .external_lex_state = 4},
  [2358] = {.lex_state = 0, .external_lex_state = 4},
  [2359] = {.lex_state = 0, .external_lex_state = 4},
  [2360] = {.lex_state = 3},
  [2361] = {.lex_state = 3},
  [2362] = {.lex_state = 0, .external_lex_state = 4},
  [2363] = {.lex_state = 3},
  [2364] = {.lex_state = 0, .external_lex_state = 4},
  [2365] = {.lex_state = 24},
  [2366] = {.lex_state = 3, .external_lex_state = 4},
  [2367] = {.lex_state = 0, .external_lex_state = 4},
  [2368] = {.lex_state = 3},
  [2369] = {.lex_state = 0},
  [2370] = {.lex_state = 0, .external_lex_state = 4},
  [2371] = {.lex_state = 0, .external_lex_state = 4},
  [2372] = {.lex_state = 0, .external_lex_state = 4},
  [2373] = {.lex_state = 3},
  [2374] = {.lex_state = 24},
  [2375] = {.lex_state = 3},
  [2376] = {.lex_state = 0, .external_lex_state = 4},
  [2377] = {.lex_state = 3},
  [2378] = {.lex_state = 0, .external_lex_state = 4},
  [2379] = {.lex_state = 0, .external_lex_state = 4},
  [2380] = {.lex_state = 0, .external_lex_state = 4},
  [2381] = {.lex_state = 0},
  [2382] = {.lex_state = 3, .external_lex_state = 4},
  [2383] = {.lex_state = 0},
  [2384] = {.lex_state = 0, .external_lex_state = 4},
  [2385] = {.lex_state = 3},
  [2386] = {.lex_state = 0, .external_lex_state = 4},
  [2387] = {.lex_state = 3, .external_lex_state = 4},
  [2388] = {.lex_state = 3},
  [2389] = {.lex_state = 3},
  [2390] = {.lex_state = 0, .external_lex_state = 4},
  [2391] = {.lex_state = 3},
  [2392] = {.lex_state = 3},
  [2393] = {.lex_state = 3},
  [2394] = {.lex_state = 0, .external_lex_state = 4},
  [2395] = {.lex_state = 24},
  [2396] = {.lex_state = 0},
  [2397] = {.lex_state = 0},
  [2398] = {.lex_state = 0},
  [2399] = {.lex_state = 3},
  [2400] = {.lex_state = 3},
  [2401] = {.lex_state = 24},
  [2402] = {.lex_state = 0, .external_lex_state = 4},
  [2403] = {.lex_state = 0, .external_lex_state = 4},
  [2404] = {.lex_state = 3},
  [2405] = {.lex_state = 3},
  [2406] = {.lex_state = 3, .external_lex_state = 4},
  [2407] = {.lex_state = 0, .external_lex_state = 4},
  [2408] = {.lex_state = 0, .external_lex_state = 4},
  [2409] = {.lex_state = 3},
  [2410] = {.lex_state = 0, .external_lex_state = 4},
  [2411] = {.lex_state = 0, .external_lex_state = 4},
  [2412] = {.lex_state = 3},
  [2413] = {.lex_state = 3},
  [2414] = {.lex_state = 3},
  [2415] = {.lex_state = 0},
  [2416] = {.lex_state = 3, .external_lex_state = 4},
  [2417] = {.lex_state = 0, .external_lex_state = 4},
  [2418] = {.lex_state = 3},
  [2419] = {.lex_state = 3},
  [2420] = {.lex_state = 0, .external_lex_state = 4},
  [2421] = {.lex_state = 3},
  [2422] = {.lex_state = 3, .external_lex_state = 4},
  [2423] = {.lex_state = 20},
  [2424] = {.lex_state = 3},
  [2425] = {.lex_state = 0},
  [2426] = {.lex_state = 24},
  [2427] = {.lex_state = 0},
  [2428] = {.lex_state = 0, .external_lex_state = 4},
  [2429] = {.lex_state = 0},
  [2430] = {.lex_state = 20},
  [2431] = {.lex_state = 24},
  [2432] = {.lex_state = 0, .external_lex_state = 4},
  [2433] = {.lex_state = 0},
  [2434] = {.lex_state = 0},
  [2435] = {.lex_state = 0, .external_lex_state = 4},
  [2436] = {.lex_state = 0, .external_lex_state = 4},
  [2437] = {.lex_state = 0},
  [2438] = {.lex_state = 3},
  [2439] = {.lex_state = 0, .external_lex_state = 4},
  [2440] = {.lex_state = 3},
  [2441] = {.lex_state = 0},
  [2442] = {.lex_state = 3},
  [2443] = {.lex_state = 0, .external_lex_state = 4},
  [2444] = {.lex_state = 24},
  [2445] = {.lex_state = 0, .external_lex_state = 4},
  [2446] = {.lex_state = 0},
  [2447] = {.lex_state = 24},
  [2448] = {.lex_state = 24},
  [2449] = {.lex_state = 0, .external_lex_state = 4},
  [2450] = {.lex_state = 3},
  [2451] = {.lex_state = 3, .external_lex_state = 4},
  [2452] = {.lex_state = 4},
  [2453] = {.lex_state = 6},
  [2454] = {.lex_state = 6},
  [2455] = {.lex_state = 6},
  [2456] = {.lex_state = 3},
  [2457] = {.lex_state = 3},
  [2458] = {.lex_state = 20},
  [2459] = {.lex_state = 20},
  [2460] = {.lex_state = 3},
  [2461] = {.lex_state = 3},
  [2462] = {.lex_state = 3},
  [2463] = {.lex_state = 3},
  [2464] = {.lex_state = 4},
  [2465] = {.lex_state = 3, .external_lex_state = 4},
  [2466] = {.lex_state = 6},
  [2467] = {.lex_state = 0},
  [2468] = {.lex_state = 0},
  [2469] = {.lex_state = 0, .external_lex_state = 4},
  [2470] = {.lex_state = 0},
  [2471] = {.lex_state = 4},
  [2472] = {.lex_state = 0, .external_lex_state = 4},
  [2473] = {.lex_state = 6},
  [2474] = {.lex_state = 4},
  [2475] = {.lex_state = 6},
  [2476] = {.lex_state = 0, .external_lex_state = 4},
  [2477] = {.lex_state = 6},
  [2478] = {.lex_state = 0},
  [2479] = {.lex_state = 4},
  [2480] = {.lex_state = 0},
  [2481] = {.lex_state = 6},
  [2482] = {.lex_state = 3},
  [2483] = {.lex_state = 4},
  [2484] = {.lex_state = 3},
  [2485] = {.lex_state = 3},
  [2486] = {.lex_state = 6},
  [2487] = {.lex_state = 0, .external_lex_state = 4},
  [2488] = {.lex_state = 6},
  [2489] = {.lex_state = 4},
  [2490] = {.lex_state = 3, .external_lex_state = 4},
  [2491] = {.lex_state = 3, .external_lex_state = 4},
  [2492] = {.lex_state = 6},
  [2493] = {.lex_state = 4},
  [2494] = {.lex_state = 4},
  [2495] = {.lex_state = 3},
  [2496] = {.lex_state = 0},
  [2497] = {.lex_state = 4},
  [2498] = {.lex_state = 6},
  [2499] = {.lex_state = 3},
  [2500] = {.lex_state = 4},
  [2501] = {.lex_state = 3, .external_lex_state = 4},
  [2502] = {.lex_state = 3, .external_lex_state = 4},
  [2503] = {.lex_state = 0},
  [2504] = {.lex_state = 3},
  [2505] = {.lex_state = 3, .external_lex_state = 4},
  [2506] = {.lex_state = 3},
  [2507] = {.lex_state = 3},
  [2508] = {.lex_state = 3},
  [2509] = {.lex_state = 3},
  [2510] = {.lex_state = 3},
  [2511] = {.lex_state = 20},
  [2512] = {.lex_state = 4},
  [2513] = {.lex_state = 3, .external_lex_state = 4},
  [2514] = {.lex_state = 6},
  [2515] = {.lex_state = 0},
  [2516] = {.lex_state = 4},
  [2517] = {.lex_state = 0},
  [2518] = {.lex_state = 3},
  [2519] = {.lex_state = 3, .external_lex_state = 4},
  [2520] = {.lex_state = 0, .external_lex_state = 4},
  [2521] = {.lex_state = 3, .external_lex_state = 4},
  [2522] = {.lex_state = 3, .external_lex_state = 4},
  [2523] = {.lex_state = 3},
  [2524] = {.lex_state = 0, .external_lex_state = 4},
  [2525] = {.lex_state = 20},
  [2526] = {.lex_state = 3},
  [2527] = {.lex_state = 3},
  [2528] = {.lex_state = 3},
  [2529] = {.lex_state = 3, .external_lex_state = 4},
  [2530] = {.lex_state = 3},
  [2531] = {.lex_state = 3},
  [2532] = {.lex_state = 3},
  [2533] = {.lex_state = 20},
  [2534] = {.lex_state = 22, .external_lex_state = 5},
  [2535] = {.lex_state = 0},
  [2536] = {.lex_state = 0},
  [2537] = {.lex_state = 3},
  [2538] = {.lex_state = 6},
  [2539] = {.lex_state = 4},
  [2540] = {.lex_state = 3},
  [2541] = {.lex_state = 0},
  [2542] = {.lex_state = 0, .external_lex_state = 4},
  [2543] = {.lex_state = 0, .external_lex_state = 4},
  [2544] = {.lex_state = 3, .external_lex_state = 4},
  [2545] = {.lex_state = 20},
  [2546] = {.lex_state = 3, .external_lex_state = 4},
  [2547] = {.lex_state = 3},
  [2548] = {.lex_state = 0},
  [2549] = {.lex_state = 4},
  [2550] = {.lex_state = 6},
  [2551] = {.lex_state = 3, .external_lex_state = 4},
  [2552] = {.lex_state = 3},
  [2553] = {.lex_state = 0},
  [2554] = {.lex_state = 3},
  [2555] = {.lex_state = 0, .external_lex_state = 4},
  [2556] = {.lex_state = 3},
  [2557] = {.lex_state = 0, .external_lex_state = 4},
  [2558] = {.lex_state = 0, .external_lex_state = 4},
  [2559] = {.lex_state = 0, .external_lex_state = 4},
  [2560] = {.lex_state = 3, .external_lex_state = 4},
  [2561] = {.lex_state = 0, .external_lex_state = 4},
  [2562] = {.lex_state = 0, .external_lex_state = 4},
  [2563] = {.lex_state = 3},
  [2564] = {.lex_state = 0},
  [2565] = {.lex_state = 0, .external_lex_state = 4},
  [2566] = {.lex_state = 3},
  [2567] = {.lex_state = 0, .external_lex_state = 4},
  [2568] = {.lex_state = 0, .external_lex_state = 4},
  [2569] = {.lex_state = 0, .external_lex_state = 4},
  [2570] = {.lex_state = 3},
  [2571] = {.lex_state = 3, .external_lex_state = 4},
  [2572] = {.lex_state = 0, .external_lex_state = 4},
  [2573] = {.lex_state = 3},
  [2574] = {.lex_state = 0},
  [2575] = {.lex_state = 3},
  [2576] = {.lex_state = 0, .external_lex_state = 4},
  [2577] = {.lex_state = 0, .external_lex_state = 4},
  [2578] = {.lex_state = 0, .external_lex_state = 4},
  [2579] = {.lex_state = 0, .external_lex_state = 4},
  [2580] = {.lex_state = 3},
  [2581] = {.lex_state = 0, .external_lex_state = 4},
  [2582] = {.lex_state = 0, .external_lex_state = 4},
  [2583] = {.lex_state = 3},
  [2584] = {.lex_state = 3},
  [2585] = {.lex_state = 0},
  [2586] = {.lex_state = 32},
  [2587] = {.lex_state = 0},
  [2588] = {.lex_state = 3, .external_lex_state = 4},
  [2589] = {.lex_state = 0},
  [2590] = {.lex_state = 3},
  [2591] = {.lex_state = 0},
  [2592] = {.lex_state = 3},
  [2593] = {.lex_state = 0},
  [2594] = {.lex_state = 0},
  [2595] = {.lex_state = 3},
  [2596] = {.lex_state = 0},
  [2597] = {.lex_state = 0},
  [2598] = {.lex_state = 10},
  [2599] = {.lex_state = 0},
  [2600] = {.lex_state = 0, .external_lex_state = 4},
  [2601] = {.lex_state = 0, .external_lex_state = 4},
  [2602] = {.lex_state = 0},
  [2603] = {.lex_state = 0},
  [2604] = {.lex_state = 0, .external_lex_state = 4},
  [2605] = {.lex_state = 0},
  [2606] = {.lex_state = 0},
  [2607] = {.lex_state = 32},
  [2608] = {.lex_state = 0},
  [2609] = {.lex_state = 10},
  [2610] = {.lex_state = 0},
  [2611] = {.lex_state = 3},
  [2612] = {.lex_state = 3},
  [2613] = {.lex_state = 3},
  [2614] = {.lex_state = 0},
  [2615] = {.lex_state = 0},
  [2616] = {.lex_state = 3},
  [2617] = {.lex_state = 0},
  [2618] = {.lex_state = 0, .external_lex_state = 4},
  [2619] = {.lex_state = 0},
  [2620] = {.lex_state = 0},
  [2621] = {.lex_state = 3},
  [2622] = {.lex_state = 0},
  [2623] = {.lex_state = 3},
  [2624] = {.lex_state = 0},
  [2625] = {.lex_state = 3},
  [2626] = {.lex_state = 0},
  [2627] = {.lex_state = 3},
  [2628] = {.lex_state = 10},
  [2629] = {.lex_state = 0},
  [2630] = {.lex_state = 3},
  [2631] = {.lex_state = 3},
  [2632] = {.lex_state = 0},
  [2633] = {.lex_state = 3},
  [2634] = {.lex_state = 3},
  [2635] = {.lex_state = 32},
  [2636] = {.lex_state = 0},
  [2637] = {.lex_state = 32},
  [2638] = {.lex_state = 0},
  [2639] = {.lex_state = 0},
  [2640] = {.lex_state = 0},
  [2641] = {.lex_state = 0},
  [2642] = {.lex_state = 3},
  [2643] = {.lex_state = 0},
  [2644] = {.lex_state = 0},
  [2645] = {.lex_state = 0},
  [2646] = {.lex_state = 0},
  [2647] = {.lex_state = 0},
  [2648] = {.lex_state = 3},
  [2649] = {.lex_state = 0},
  [2650] = {.lex_state = 32},
  [2651] = {.lex_state = 32},
  [2652] = {.lex_state = 3},
  [2653] = {.lex_state = 32},
  [2654] = {.lex_state = 3},
  [2655] = {.lex_state = 32},
  [2656] = {.lex_state = 0},
  [2657] = {.lex_state = 0},
  [2658] = {.lex_state = 0},
  [2659] = {.lex_state = 0},
  [2660] = {.lex_state = 0},
  [2661] = {.lex_state = 3},
  [2662] = {.lex_state = 3},
  [2663] = {.lex_state = 0, .external_lex_state = 4},
  [2664] = {.lex_state = 0},
  [2665] = {.lex_state = 0},
  [2666] = {.lex_state = 0, .external_lex_state = 4},
  [2667] = {.lex_state = 0},
  [2668] = {.lex_state = 0},
  [2669] = {.lex_state = 0, .external_lex_state = 4},
  [2670] = {.lex_state = 3},
  [2671] = {.lex_state = 0},
  [2672] = {.lex_state = 0},
  [2673] = {.lex_state = 3},
  [2674] = {.lex_state = 0},
  [2675] = {.lex_state = 32},
  [2676] = {.lex_state = 32},
  [2677] = {.lex_state = 0},
  [2678] = {.lex_state = 3},
  [2679] = {.lex_state = 0},
  [2680] = {.lex_state = 3},
  [2681] = {.lex_state = 3},
  [2682] = {.lex_state = 0, .external_lex_state = 4},
  [2683] = {.lex_state = 0, .external_lex_state = 4},
  [2684] = {.lex_state = 0, .external_lex_state = 4},
  [2685] = {.lex_state = 0, .external_lex_state = 4},
  [2686] = {.lex_state = 3},
  [2687] = {.lex_state = 0},
  [2688] = {.lex_state = 0},
  [2689] = {.lex_state = 0},
  [2690] = {.lex_state = 0},
  [2691] = {.lex_state = 0},
  [2692] = {.lex_state = 0},
  [2693] = {.lex_state = 0},
  [2694] = {.lex_state = 3, .external_lex_state = 4},
  [2695] = {.lex_state = 3},
  [2696] = {.lex_state = 3},
  [2697] = {.lex_state = 3},
  [2698] = {.lex_state = 3, .external_lex_state = 4},
  [2699] = {.lex_state = 0},
  [2700] = {.lex_state = 0},
  [2701] = {.lex_state = 32},
  [2702] = {.lex_state = 0},
  [2703] = {.lex_state = 0},
  [2704] = {.lex_state = 0},
  [2705] = {.lex_state = 3},
  [2706] = {.lex_state = 0},
  [2707] = {.lex_state = 0},
  [2708] = {.lex_state = 0},
  [2709] = {.lex_state = 0},
  [2710] = {.lex_state = 0},
  [2711] = {.lex_state = 0},
  [2712] = {.lex_state = 3},
  [2713] = {.lex_state = 0},
  [2714] = {.lex_state = 3, .external_lex_state = 4},
  [2715] = {.lex_state = 3},
  [2716] = {.lex_state = 0},
  [2717] = {.lex_state = 3},
  [2718] = {.lex_state = 0},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 0},
  [2721] = {.lex_state = 0},
  [2722] = {.lex_state = 0},
  [2723] = {.lex_state = 0},
  [2724] = {.lex_state = 0},
  [2725] = {.lex_state = 3},
  [2726] = {.lex_state = 0},
  [2727] = {.lex_state = 0},
  [2728] = {.lex_state = 3},
  [2729] = {.lex_state = 3},
  [2730] = {.lex_state = 0, .external_lex_state = 4},
  [2731] = {.lex_state = 0},
  [2732] = {.lex_state = 0},
  [2733] = {.lex_state = 0},
  [2734] = {.lex_state = 0},
  [2735] = {.lex_state = 0},
  [2736] = {.lex_state = 0, .external_lex_state = 4},
  [2737] = {.lex_state = 0},
  [2738] = {.lex_state = 3},
  [2739] = {.lex_state = 0, .external_lex_state = 4},
  [2740] = {.lex_state = 3},
  [2741] = {.lex_state = 0},
  [2742] = {.lex_state = 3},
  [2743] = {.lex_state = 3},
  [2744] = {.lex_state = 0},
  [2745] = {.lex_state = 3},
  [2746] = {.lex_state = 0},
  [2747] = {.lex_state = 3},
  [2748] = {.lex_state = 0},
  [2749] = {.lex_state = 3},
  [2750] = {.lex_state = 0, .external_lex_state = 4},
  [2751] = {.lex_state = 3},
  [2752] = {.lex_state = 0},
  [2753] = {.lex_state = 3},
  [2754] = {.lex_state = 0},
  [2755] = {.lex_state = 3},
  [2756] = {.lex_state = 3},
  [2757] = {.lex_state = 3},
  [2758] = {.lex_state = 3},
  [2759] = {.lex_state = 3},
  [2760] = {.lex_state = 3},
  [2761] = {.lex_state = 3},
  [2762] = {.lex_state = 0},
  [2763] = {.lex_state = 3},
  [2764] = {.lex_state = 0},
  [2765] = {.lex_state = 0},
  [2766] = {.lex_state = 0},
  [2767] = {.lex_state = 0},
  [2768] = {.lex_state = 3},
  [2769] = {.lex_state = 0},
  [2770] = {.lex_state = 3},
  [2771] = {.lex_state = 3},
  [2772] = {.lex_state = 0},
  [2773] = {.lex_state = 0},
  [2774] = {.lex_state = 0},
  [2775] = {.lex_state = 3},
  [2776] = {.lex_state = 0, .external_lex_state = 4},
  [2777] = {.lex_state = 3},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 3},
  [2780] = {.lex_state = 0, .external_lex_state = 4},
  [2781] = {.lex_state = 3},
  [2782] = {.lex_state = 0},
  [2783] = {.lex_state = 0},
  [2784] = {.lex_state = 0},
  [2785] = {.lex_state = 3},
  [2786] = {.lex_state = 3},
  [2787] = {.lex_state = 3},
  [2788] = {.lex_state = 3},
  [2789] = {.lex_state = 3},
  [2790] = {.lex_state = 3},
  [2791] = {.lex_state = 0},
  [2792] = {.lex_state = 3},
  [2793] = {.lex_state = 0},
  [2794] = {.lex_state = 3},
  [2795] = {.lex_state = 3},
  [2796] = {.lex_state = 3},
  [2797] = {.lex_state = 3},
  [2798] = {.lex_state = 3},
  [2799] = {.lex_state = 3},
  [2800] = {.lex_state = 3},
  [2801] = {.lex_state = 3},
  [2802] = {.lex_state = 3},
  [2803] = {.lex_state = 0, .external_lex_state = 4},
  [2804] = {.lex_state = 3},
  [2805] = {.lex_state = 3},
  [2806] = {.lex_state = 0},
  [2807] = {.lex_state = 0, .external_lex_state = 4},
  [2808] = {.lex_state = 3},
  [2809] = {.lex_state = 0},
  [2810] = {.lex_state = 3},
  [2811] = {.lex_state = 3},
  [2812] = {.lex_state = 3},
  [2813] = {.lex_state = 3},
  [2814] = {.lex_state = 3},
  [2815] = {.lex_state = 0},
  [2816] = {.lex_state = 0},
  [2817] = {.lex_state = 0},
  [2818] = {.lex_state = 0},
  [2819] = {.lex_state = 3},
  [2820] = {.lex_state = 0},
  [2821] = {.lex_state = 3},
  [2822] = {.lex_state = 0},
  [2823] = {.lex_state = 3},
  [2824] = {.lex_state = 3},
  [2825] = {.lex_state = 3},
  [2826] = {.lex_state = 0, .external_lex_state = 4},
  [2827] = {.lex_state = 3},
  [2828] = {.lex_state = 0, .external_lex_state = 4},
  [2829] = {.lex_state = 0},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 3},
  [2833] = {.lex_state = 3},
  [2834] = {.lex_state = 3},
  [2835] = {.lex_state = 3},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 3},
  [2838] = {.lex_state = 20},
  [2839] = {.lex_state = 3},
  [2840] = {.lex_state = 3},
  [2841] = {.lex_state = 3},
  [2842] = {.lex_state = 3},
  [2843] = {.lex_state = 3},
  [2844] = {.lex_state = 0},
  [2845] = {.lex_state = 3},
  [2846] = {.lex_state = 0},
  [2847] = {.lex_state = 3},
  [2848] = {.lex_state = 3},
  [2849] = {.lex_state = 0},
  [2850] = {.lex_state = 3},
  [2851] = {.lex_state = 3},
  [2852] = {.lex_state = 3},
  [2853] = {.lex_state = 3},
  [2854] = {.lex_state = 3},
  [2855] = {.lex_state = 3},
  [2856] = {.lex_state = 3},
  [2857] = {.lex_state = 0},
  [2858] = {.lex_state = 3},
  [2859] = {.lex_state = 3},
  [2860] = {.lex_state = 3},
  [2861] = {.lex_state = 0},
  [2862] = {.lex_state = 3},
  [2863] = {.lex_state = 3},
  [2864] = {.lex_state = 3},
  [2865] = {.lex_state = 0},
  [2866] = {.lex_state = 3},
  [2867] = {.lex_state = 3},
  [2868] = {.lex_state = 3},
  [2869] = {.lex_state = 0},
  [2870] = {.lex_state = 3},
  [2871] = {.lex_state = 3},
  [2872] = {.lex_state = 3},
  [2873] = {.lex_state = 3},
  [2874] = {.lex_state = 3},
  [2875] = {.lex_state = 3},
  [2876] = {.lex_state = 3},
  [2877] = {.lex_state = 3},
  [2878] = {.lex_state = 3},
  [2879] = {.lex_state = 3},
  [2880] = {.lex_state = 0},
  [2881] = {.lex_state = 3},
  [2882] = {.lex_state = 0},
  [2883] = {.lex_state = 0, .external_lex_state = 4},
  [2884] = {.lex_state = 3},
  [2885] = {.lex_state = 0, .external_lex_state = 4},
  [2886] = {.lex_state = 3},
  [2887] = {.lex_state = 0},
  [2888] = {.lex_state = 3},
  [2889] = {.lex_state = 0},
  [2890] = {.lex_state = 0},
  [2891] = {.lex_state = 3},
  [2892] = {.lex_state = 0},
  [2893] = {.lex_state = 3},
  [2894] = {.lex_state = 3},
  [2895] = {.lex_state = 3},
  [2896] = {.lex_state = 0, .external_lex_state = 4},
  [2897] = {.lex_state = 0, .external_lex_state = 4},
  [2898] = {.lex_state = 0},
  [2899] = {.lex_state = 3},
  [2900] = {.lex_state = 3},
  [2901] = {.lex_state = 0},
  [2902] = {.lex_state = 3},
  [2903] = {.lex_state = 0},
  [2904] = {.lex_state = 3},
  [2905] = {.lex_state = 3},
  [2906] = {.lex_state = 3},
  [2907] = {.lex_state = 0},
  [2908] = {.lex_state = 3},
  [2909] = {.lex_state = 3},
  [2910] = {.lex_state = 0},
  [2911] = {.lex_state = 3},
  [2912] = {.lex_state = 0},
  [2913] = {.lex_state = 0},
  [2914] = {.lex_state = 3},
  [2915] = {.lex_state = 3},
  [2916] = {.lex_state = 0},
  [2917] = {.lex_state = 3},
  [2918] = {.lex_state = 3},
  [2919] = {.lex_state = 0},
  [2920] = {.lex_state = 3},
  [2921] = {.lex_state = 3},
  [2922] = {.lex_state = 3},
  [2923] = {.lex_state = 0},
  [2924] = {.lex_state = 3},
  [2925] = {.lex_state = 0},
  [2926] = {.lex_state = 3},
  [2927] = {.lex_state = 0, .external_lex_state = 4},
  [2928] = {.lex_state = 3},
  [2929] = {.lex_state = 3},
  [2930] = {.lex_state = 3},
  [2931] = {.lex_state = 3},
  [2932] = {.lex_state = 0, .external_lex_state = 4},
  [2933] = {.lex_state = 3},
  [2934] = {.lex_state = 3},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 0},
  [2937] = {.lex_state = 3},
  [2938] = {.lex_state = 0},
  [2939] = {.lex_state = 3},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 3},
  [2942] = {.lex_state = 0},
  [2943] = {.lex_state = 3},
  [2944] = {.lex_state = 3},
  [2945] = {.lex_state = 3},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 0, .external_lex_state = 4},
  [2948] = {.lex_state = 0, .external_lex_state = 4},
  [2949] = {.lex_state = 0},
  [2950] = {.lex_state = 0},
  [2951] = {.lex_state = 3},
  [2952] = {.lex_state = 0},
  [2953] = {.lex_state = 0, .external_lex_state = 4},
  [2954] = {.lex_state = 3},
  [2955] = {.lex_state = 0, .external_lex_state = 4},
  [2956] = {.lex_state = 0, .external_lex_state = 4},
  [2957] = {.lex_state = 3},
  [2958] = {.lex_state = 0},
  [2959] = {.lex_state = 3},
  [2960] = {.lex_state = 3},
  [2961] = {.lex_state = 3},
  [2962] = {.lex_state = 3},
  [2963] = {.lex_state = 3},
  [2964] = {.lex_state = 0},
  [2965] = {.lex_state = 3},
  [2966] = {.lex_state = 0},
  [2967] = {.lex_state = 0, .external_lex_state = 4},
  [2968] = {.lex_state = 3},
  [2969] = {.lex_state = 3},
  [2970] = {.lex_state = 0, .external_lex_state = 4},
  [2971] = {.lex_state = 3},
  [2972] = {.lex_state = 3},
  [2973] = {.lex_state = 3},
  [2974] = {.lex_state = 0},
  [2975] = {.lex_state = 0},
  [2976] = {.lex_state = 3},
  [2977] = {.lex_state = 0},
  [2978] = {.lex_state = 0},
  [2979] = {.lex_state = 18},
  [2980] = {.lex_state = 3},
  [2981] = {.lex_state = 3},
  [2982] = {.lex_state = 0},
  [2983] = {.lex_state = 3},
  [2984] = {.lex_state = 3},
  [2985] = {.lex_state = 0},
  [2986] = {.lex_state = 0},
  [2987] = {.lex_state = 3},
  [2988] = {.lex_state = 0},
  [2989] = {.lex_state = 0},
  [2990] = {.lex_state = 8},
  [2991] = {.lex_state = 0},
  [2992] = {.lex_state = 3},
  [2993] = {.lex_state = 0},
  [2994] = {.lex_state = 3},
  [2995] = {.lex_state = 3},
  [2996] = {.lex_state = 3},
  [2997] = {.lex_state = 3},
  [2998] = {.lex_state = 3},
  [2999] = {.lex_state = 0},
  [3000] = {.lex_state = 0},
  [3001] = {.lex_state = 0},
  [3002] = {.lex_state = 0},
  [3003] = {.lex_state = 0},
  [3004] = {.lex_state = 0},
  [3005] = {.lex_state = 0},
  [3006] = {.lex_state = 3},
  [3007] = {.lex_state = 3},
  [3008] = {.lex_state = 3},
  [3009] = {.lex_state = 3},
  [3010] = {.lex_state = 0},
  [3011] = {.lex_state = 3},
  [3012] = {.lex_state = 0},
  [3013] = {.lex_state = 0},
  [3014] = {.lex_state = 0},
  [3015] = {.lex_state = 0},
  [3016] = {.lex_state = 3},
  [3017] = {.lex_state = 3},
  [3018] = {.lex_state = 3},
  [3019] = {.lex_state = 0},
  [3020] = {.lex_state = 0},
  [3021] = {.lex_state = 3},
  [3022] = {.lex_state = 3},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 0},
  [3025] = {.lex_state = 0},
  [3026] = {.lex_state = 0},
  [3027] = {.lex_state = 3},
  [3028] = {.lex_state = 3},
  [3029] = {.lex_state = 3},
  [3030] = {.lex_state = 0},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 0},
  [3033] = {.lex_state = 0},
  [3034] = {.lex_state = 3},
  [3035] = {.lex_state = 0},
  [3036] = {.lex_state = 3},
  [3037] = {.lex_state = 0},
  [3038] = {.lex_state = 0},
  [3039] = {.lex_state = 3},
  [3040] = {.lex_state = 3},
  [3041] = {.lex_state = 3},
  [3042] = {.lex_state = 8},
  [3043] = {.lex_state = 3},
  [3044] = {.lex_state = 3},
  [3045] = {.lex_state = 3},
  [3046] = {.lex_state = 3},
  [3047] = {.lex_state = 0},
  [3048] = {.lex_state = 3},
  [3049] = {.lex_state = 3},
  [3050] = {.lex_state = 3},
  [3051] = {.lex_state = 3},
  [3052] = {.lex_state = 0},
  [3053] = {.lex_state = 0},
  [3054] = {.lex_state = 3},
  [3055] = {.lex_state = 3},
  [3056] = {.lex_state = 0},
  [3057] = {.lex_state = 0},
  [3058] = {.lex_state = 0},
  [3059] = {.lex_state = 0},
  [3060] = {.lex_state = 3},
  [3061] = {.lex_state = 0},
  [3062] = {.lex_state = 3},
  [3063] = {.lex_state = 3},
  [3064] = {.lex_state = 3},
  [3065] = {.lex_state = 0},
  [3066] = {.lex_state = 0},
  [3067] = {.lex_state = 0},
  [3068] = {.lex_state = 0},
  [3069] = {.lex_state = 0},
  [3070] = {.lex_state = 3},
  [3071] = {.lex_state = 0},
  [3072] = {.lex_state = 3},
  [3073] = {.lex_state = 3},
  [3074] = {.lex_state = 0},
  [3075] = {.lex_state = 0},
  [3076] = {.lex_state = 0},
  [3077] = {.lex_state = 3},
  [3078] = {.lex_state = 0},
  [3079] = {.lex_state = 0},
  [3080] = {.lex_state = 0},
  [3081] = {.lex_state = 3},
  [3082] = {.lex_state = 3},
  [3083] = {.lex_state = 0},
  [3084] = {.lex_state = 0},
  [3085] = {.lex_state = 3},
  [3086] = {.lex_state = 3},
  [3087] = {.lex_state = 0},
  [3088] = {.lex_state = 3},
  [3089] = {.lex_state = 3},
  [3090] = {.lex_state = 0},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 0},
  [3093] = {.lex_state = 3},
  [3094] = {.lex_state = 18},
  [3095] = {.lex_state = 3},
  [3096] = {.lex_state = 18},
  [3097] = {.lex_state = 0},
  [3098] = {.lex_state = 3},
  [3099] = {.lex_state = 18},
  [3100] = {.lex_state = 0},
  [3101] = {.lex_state = 0},
  [3102] = {.lex_state = 0},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 3},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 0},
  [3107] = {.lex_state = 0},
  [3108] = {.lex_state = 0},
  [3109] = {.lex_state = 3},
  [3110] = {.lex_state = 3},
  [3111] = {.lex_state = 0},
  [3112] = {.lex_state = 0},
  [3113] = {.lex_state = 0},
  [3114] = {.lex_state = 0},
  [3115] = {.lex_state = 3},
  [3116] = {.lex_state = 0},
  [3117] = {.lex_state = 3},
  [3118] = {.lex_state = 3},
  [3119] = {.lex_state = 3},
  [3120] = {.lex_state = 3},
  [3121] = {.lex_state = 3},
  [3122] = {.lex_state = 3},
  [3123] = {.lex_state = 3},
  [3124] = {.lex_state = 0},
  [3125] = {.lex_state = 3},
  [3126] = {.lex_state = 0},
  [3127] = {.lex_state = 3},
  [3128] = {.lex_state = 3},
  [3129] = {.lex_state = 3},
  [3130] = {.lex_state = 3},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 3},
  [3133] = {.lex_state = 0},
  [3134] = {.lex_state = 0},
  [3135] = {.lex_state = 0},
  [3136] = {.lex_state = 0},
  [3137] = {.lex_state = 0},
  [3138] = {.lex_state = 0},
  [3139] = {.lex_state = 0},
  [3140] = {.lex_state = 3},
  [3141] = {.lex_state = 0},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 0},
  [3144] = {.lex_state = 0},
  [3145] = {.lex_state = 0},
  [3146] = {.lex_state = 0},
  [3147] = {.lex_state = 3},
  [3148] = {.lex_state = 0},
  [3149] = {.lex_state = 3},
  [3150] = {.lex_state = 3},
  [3151] = {.lex_state = 3},
  [3152] = {.lex_state = 0},
  [3153] = {.lex_state = 3},
  [3154] = {.lex_state = 0},
  [3155] = {.lex_state = 0},
  [3156] = {.lex_state = 3},
  [3157] = {.lex_state = 3},
  [3158] = {.lex_state = 0},
  [3159] = {.lex_state = 0},
  [3160] = {.lex_state = 3},
  [3161] = {.lex_state = 3},
  [3162] = {.lex_state = 3},
  [3163] = {.lex_state = 3},
  [3164] = {.lex_state = 0},
  [3165] = {.lex_state = 3},
  [3166] = {.lex_state = 3},
  [3167] = {.lex_state = 3},
  [3168] = {.lex_state = 0},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 0},
  [3171] = {.lex_state = 0},
  [3172] = {.lex_state = 8},
  [3173] = {.lex_state = 0},
  [3174] = {.lex_state = 3},
  [3175] = {.lex_state = 0},
  [3176] = {.lex_state = 0},
  [3177] = {.lex_state = 0},
  [3178] = {.lex_state = 3},
  [3179] = {.lex_state = 0},
  [3180] = {.lex_state = 3},
  [3181] = {.lex_state = 0},
  [3182] = {.lex_state = 3},
  [3183] = {.lex_state = 0},
  [3184] = {.lex_state = 3},
  [3185] = {.lex_state = 3},
  [3186] = {.lex_state = 0},
  [3187] = {.lex_state = 3},
  [3188] = {.lex_state = 0},
  [3189] = {.lex_state = 3},
  [3190] = {.lex_state = 0},
  [3191] = {.lex_state = 3},
  [3192] = {.lex_state = 3},
  [3193] = {.lex_state = 0},
  [3194] = {.lex_state = 3},
  [3195] = {.lex_state = 3},
  [3196] = {.lex_state = 3},
  [3197] = {.lex_state = 3},
  [3198] = {.lex_state = 3},
  [3199] = {.lex_state = 3},
  [3200] = {.lex_state = 8},
  [3201] = {.lex_state = 3},
  [3202] = {.lex_state = 3},
  [3203] = {.lex_state = 3},
  [3204] = {.lex_state = 3},
  [3205] = {.lex_state = 3},
  [3206] = {.lex_state = 3},
  [3207] = {.lex_state = 3},
  [3208] = {.lex_state = 3},
  [3209] = {.lex_state = 3},
  [3210] = {.lex_state = 3},
  [3211] = {.lex_state = 3},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(3159),
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(12),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(12),
    [sym_abstract_class_declaration] = STATE(12),
    [sym_module] = STATE(12),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(12),
    [sym_interface_declaration] = STATE(12),
    [sym_enum_declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(12),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [2] = {
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(24),
    [sym_lexical_declaration] = STATE(24),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2668),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(24),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(24),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(24),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2668),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2668),
    [sym_pair] = STATE(2668),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(24),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(24),
    [sym_abstract_class_declaration] = STATE(24),
    [sym_module] = STATE(24),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(24),
    [sym_interface_declaration] = STATE(24),
    [sym_enum_declaration] = STATE(24),
    [sym_type_alias_declaration] = STATE(24),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [3] = {
    [sym_export_statement] = STATE(18),
    [sym__declaration] = STATE(18),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(18),
    [sym_lexical_declaration] = STATE(18),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2606),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(18),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(18),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(18),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2606),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2606),
    [sym_pair] = STATE(2606),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(18),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(18),
    [sym_abstract_class_declaration] = STATE(18),
    [sym_module] = STATE(18),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(18),
    [sym_interface_declaration] = STATE(18),
    [sym_enum_declaration] = STATE(18),
    [sym_type_alias_declaration] = STATE(18),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2610),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(153),
    [anon_sym_type] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(159),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(161),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(163),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_public] = ACTIONS(167),
    [anon_sym_private] = ACTIONS(167),
    [anon_sym_protected] = ACTIONS(167),
    [anon_sym_module] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(171),
    [anon_sym_number] = ACTIONS(171),
    [anon_sym_boolean] = ACTIONS(171),
    [anon_sym_string] = ACTIONS(171),
    [anon_sym_symbol] = ACTIONS(171),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(173),
  },
  [4] = {
    [sym_export_statement] = STATE(16),
    [sym__declaration] = STATE(16),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(16),
    [sym_lexical_declaration] = STATE(16),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2606),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(16),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(16),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(16),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2606),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2606),
    [sym_pair] = STATE(2606),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(16),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(16),
    [sym_abstract_class_declaration] = STATE(16),
    [sym_module] = STATE(16),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(16),
    [sym_interface_declaration] = STATE(16),
    [sym_enum_declaration] = STATE(16),
    [sym_type_alias_declaration] = STATE(16),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2610),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(175),
    [anon_sym_type] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(159),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(161),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(163),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_public] = ACTIONS(167),
    [anon_sym_private] = ACTIONS(167),
    [anon_sym_protected] = ACTIONS(167),
    [anon_sym_module] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(171),
    [anon_sym_number] = ACTIONS(171),
    [anon_sym_boolean] = ACTIONS(171),
    [anon_sym_string] = ACTIONS(171),
    [anon_sym_symbol] = ACTIONS(171),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(173),
  },
  [5] = {
    [sym_export_statement] = STATE(15),
    [sym__declaration] = STATE(15),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(15),
    [sym_lexical_declaration] = STATE(15),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2656),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(15),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(15),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(15),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2656),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2656),
    [sym_pair] = STATE(2656),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(15),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(15),
    [sym_abstract_class_declaration] = STATE(15),
    [sym_module] = STATE(15),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_type_alias_declaration] = STATE(15),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_export] = ACTIONS(179),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(181),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_type] = ACTIONS(185),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(187),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(189),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(191),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(193),
    [anon_sym_set] = ACTIONS(193),
    [anon_sym_declare] = ACTIONS(195),
    [anon_sym_public] = ACTIONS(197),
    [anon_sym_private] = ACTIONS(197),
    [anon_sym_protected] = ACTIONS(197),
    [anon_sym_module] = ACTIONS(199),
    [anon_sym_any] = ACTIONS(201),
    [anon_sym_number] = ACTIONS(201),
    [anon_sym_boolean] = ACTIONS(201),
    [anon_sym_string] = ACTIONS(201),
    [anon_sym_symbol] = ACTIONS(201),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(203),
  },
  [6] = {
    [sym_export_statement] = STATE(16),
    [sym__declaration] = STATE(16),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(16),
    [sym_lexical_declaration] = STATE(16),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1471),
    [sym_assignment_pattern] = STATE(2606),
    [sym_array] = STATE(1479),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(16),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(16),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(16),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_spread_element] = STATE(2606),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_method_definition] = STATE(2606),
    [sym_pair] = STATE(2606),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(16),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(16),
    [sym_abstract_class_declaration] = STATE(16),
    [sym_module] = STATE(16),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(16),
    [sym_interface_declaration] = STATE(16),
    [sym_enum_declaration] = STATE(16),
    [sym_type_alias_declaration] = STATE(16),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [aux_sym_object_repeat1] = STATE(2610),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(205),
    [anon_sym_type] = ACTIONS(155),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(159),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(161),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(163),
    [anon_sym_set] = ACTIONS(163),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_public] = ACTIONS(167),
    [anon_sym_private] = ACTIONS(167),
    [anon_sym_protected] = ACTIONS(167),
    [anon_sym_module] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(171),
    [anon_sym_number] = ACTIONS(171),
    [anon_sym_boolean] = ACTIONS(171),
    [anon_sym_string] = ACTIONS(171),
    [anon_sym_symbol] = ACTIONS(171),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(173),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_export] = ACTIONS(212),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_namespace] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_type] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(226),
    [anon_sym_import] = ACTIONS(229),
    [anon_sym_var] = ACTIONS(232),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(244),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_await] = ACTIONS(253),
    [anon_sym_while] = ACTIONS(256),
    [anon_sym_do] = ACTIONS(259),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_with] = ACTIONS(265),
    [anon_sym_break] = ACTIONS(268),
    [anon_sym_continue] = ACTIONS(271),
    [anon_sym_debugger] = ACTIONS(274),
    [anon_sym_return] = ACTIONS(277),
    [anon_sym_throw] = ACTIONS(280),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_new] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_BANG] = ACTIONS(313),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_void] = ACTIONS(316),
    [anon_sym_delete] = ACTIONS(226),
    [anon_sym_PLUS_PLUS] = ACTIONS(319),
    [anon_sym_DASH_DASH] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(322),
    [anon_sym_SQUOTE] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(328),
    [sym_number] = ACTIONS(331),
    [sym_this] = ACTIONS(334),
    [sym_super] = ACTIONS(337),
    [sym_true] = ACTIONS(334),
    [sym_false] = ACTIONS(334),
    [sym_null] = ACTIONS(334),
    [sym_undefined] = ACTIONS(334),
    [anon_sym_AT] = ACTIONS(340),
    [anon_sym_static] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(346),
    [anon_sym_get] = ACTIONS(343),
    [anon_sym_set] = ACTIONS(343),
    [anon_sym_declare] = ACTIONS(349),
    [anon_sym_public] = ACTIONS(343),
    [anon_sym_private] = ACTIONS(343),
    [anon_sym_protected] = ACTIONS(343),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_any] = ACTIONS(343),
    [anon_sym_number] = ACTIONS(343),
    [anon_sym_boolean] = ACTIONS(343),
    [anon_sym_string] = ACTIONS(343),
    [anon_sym_symbol] = ACTIONS(343),
    [anon_sym_interface] = ACTIONS(355),
    [anon_sym_enum] = ACTIONS(358),
    [sym_readonly] = ACTIONS(343),
  },
  [8] = {
    [sym_export_statement] = STATE(9),
    [sym__declaration] = STATE(9),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(9),
    [sym_lexical_declaration] = STATE(9),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(9),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(9),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(9),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(9),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(9),
    [sym_abstract_class_declaration] = STATE(9),
    [sym_module] = STATE(9),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(9),
    [sym_interface_declaration] = STATE(9),
    [sym_enum_declaration] = STATE(9),
    [sym_type_alias_declaration] = STATE(9),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(361),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [9] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [10] = {
    [sym_export_statement] = STATE(11),
    [sym__declaration] = STATE(11),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(11),
    [sym_lexical_declaration] = STATE(11),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(11),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(11),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(11),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(11),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(11),
    [sym_abstract_class_declaration] = STATE(11),
    [sym_module] = STATE(11),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(11),
    [sym_interface_declaration] = STATE(11),
    [sym_enum_declaration] = STATE(11),
    [sym_type_alias_declaration] = STATE(11),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [11] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(373),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [12] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [13] = {
    [sym_export_statement] = STATE(15),
    [sym__declaration] = STATE(15),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(15),
    [sym_lexical_declaration] = STATE(15),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(15),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(15),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(15),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(15),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(15),
    [sym_abstract_class_declaration] = STATE(15),
    [sym_module] = STATE(15),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_type_alias_declaration] = STATE(15),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [14] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(20),
    [sym_lexical_declaration] = STATE(20),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(20),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(20),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(20),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(20),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(20),
    [sym_abstract_class_declaration] = STATE(20),
    [sym_module] = STATE(20),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(20),
    [sym_interface_declaration] = STATE(20),
    [sym_enum_declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(20),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(381),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [15] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [16] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(385),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [17] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(25),
    [sym_lexical_declaration] = STATE(25),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(25),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(25),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(25),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(25),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(25),
    [sym_abstract_class_declaration] = STATE(25),
    [sym_module] = STATE(25),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(25),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(377),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [18] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [19] = {
    [sym_export_statement] = STATE(21),
    [sym__declaration] = STATE(21),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(21),
    [sym_expression_statement] = STATE(21),
    [sym_variable_declaration] = STATE(21),
    [sym_lexical_declaration] = STATE(21),
    [sym_statement_block] = STATE(21),
    [sym_if_statement] = STATE(21),
    [sym_switch_statement] = STATE(21),
    [sym_for_statement] = STATE(21),
    [sym_for_in_statement] = STATE(21),
    [sym_while_statement] = STATE(21),
    [sym_do_statement] = STATE(21),
    [sym_try_statement] = STATE(21),
    [sym_with_statement] = STATE(21),
    [sym_break_statement] = STATE(21),
    [sym_continue_statement] = STATE(21),
    [sym_debugger_statement] = STATE(21),
    [sym_return_statement] = STATE(21),
    [sym_throw_statement] = STATE(21),
    [sym_empty_statement] = STATE(21),
    [sym_labeled_statement] = STATE(21),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(21),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(21),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(21),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(21),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(21),
    [sym_abstract_class_declaration] = STATE(21),
    [sym_module] = STATE(21),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(21),
    [sym_interface_declaration] = STATE(21),
    [sym_enum_declaration] = STATE(21),
    [sym_type_alias_declaration] = STATE(21),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(21),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [20] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [21] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [22] = {
    [sym_export_statement] = STATE(18),
    [sym__declaration] = STATE(18),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(18),
    [sym_expression_statement] = STATE(18),
    [sym_variable_declaration] = STATE(18),
    [sym_lexical_declaration] = STATE(18),
    [sym_statement_block] = STATE(18),
    [sym_if_statement] = STATE(18),
    [sym_switch_statement] = STATE(18),
    [sym_for_statement] = STATE(18),
    [sym_for_in_statement] = STATE(18),
    [sym_while_statement] = STATE(18),
    [sym_do_statement] = STATE(18),
    [sym_try_statement] = STATE(18),
    [sym_with_statement] = STATE(18),
    [sym_break_statement] = STATE(18),
    [sym_continue_statement] = STATE(18),
    [sym_debugger_statement] = STATE(18),
    [sym_return_statement] = STATE(18),
    [sym_throw_statement] = STATE(18),
    [sym_empty_statement] = STATE(18),
    [sym_labeled_statement] = STATE(18),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(18),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(18),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(18),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(18),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(18),
    [sym_abstract_class_declaration] = STATE(18),
    [sym_module] = STATE(18),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(18),
    [sym_interface_declaration] = STATE(18),
    [sym_enum_declaration] = STATE(18),
    [sym_type_alias_declaration] = STATE(18),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(18),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [23] = {
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(24),
    [sym_lexical_declaration] = STATE(24),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(24),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(24),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(24),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(24),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(24),
    [sym_abstract_class_declaration] = STATE(24),
    [sym_module] = STATE(24),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(24),
    [sym_interface_declaration] = STATE(24),
    [sym_enum_declaration] = STATE(24),
    [sym_type_alias_declaration] = STATE(24),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [24] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [25] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [ts_builtin_sym_end] = ACTIONS(401),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [26] = {
    [sym_export_statement] = STATE(16),
    [sym__declaration] = STATE(16),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(16),
    [sym_lexical_declaration] = STATE(16),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(16),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(16),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(16),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(16),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(16),
    [sym_abstract_class_declaration] = STATE(16),
    [sym_module] = STATE(16),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(16),
    [sym_interface_declaration] = STATE(16),
    [sym_enum_declaration] = STATE(16),
    [sym_type_alias_declaration] = STATE(16),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(16),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [27] = {
    [sym_export_statement] = STATE(28),
    [sym__declaration] = STATE(28),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(28),
    [sym_lexical_declaration] = STATE(28),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(28),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(28),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(28),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(28),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(28),
    [sym_abstract_class_declaration] = STATE(28),
    [sym_module] = STATE(28),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(28),
    [sym_interface_declaration] = STATE(28),
    [sym_enum_declaration] = STATE(28),
    [sym_type_alias_declaration] = STATE(28),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(28),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [28] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(7),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [29] = {
    [sym_export_statement] = STATE(556),
    [sym__declaration] = STATE(556),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(556),
    [sym_expression_statement] = STATE(556),
    [sym_variable_declaration] = STATE(556),
    [sym_lexical_declaration] = STATE(556),
    [sym_statement_block] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_switch_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_for_in_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_do_statement] = STATE(556),
    [sym_try_statement] = STATE(556),
    [sym_with_statement] = STATE(556),
    [sym_break_statement] = STATE(556),
    [sym_continue_statement] = STATE(556),
    [sym_debugger_statement] = STATE(556),
    [sym_return_statement] = STATE(556),
    [sym_throw_statement] = STATE(556),
    [sym_empty_statement] = STATE(556),
    [sym_labeled_statement] = STATE(556),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(556),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(556),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(556),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(556),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(556),
    [sym_abstract_class_declaration] = STATE(556),
    [sym_module] = STATE(556),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(556),
    [sym_interface_declaration] = STATE(556),
    [sym_enum_declaration] = STATE(556),
    [sym_type_alias_declaration] = STATE(556),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [30] = {
    [sym_export_statement] = STATE(560),
    [sym__declaration] = STATE(560),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_lexical_declaration] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_debugger_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(560),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(560),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(560),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(560),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(560),
    [sym_abstract_class_declaration] = STATE(560),
    [sym_module] = STATE(560),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(560),
    [sym_interface_declaration] = STATE(560),
    [sym_enum_declaration] = STATE(560),
    [sym_type_alias_declaration] = STATE(560),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [31] = {
    [sym_export_statement] = STATE(525),
    [sym__declaration] = STATE(525),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(525),
    [sym_expression_statement] = STATE(525),
    [sym_variable_declaration] = STATE(525),
    [sym_lexical_declaration] = STATE(525),
    [sym_statement_block] = STATE(525),
    [sym_if_statement] = STATE(525),
    [sym_switch_statement] = STATE(525),
    [sym_for_statement] = STATE(525),
    [sym_for_in_statement] = STATE(525),
    [sym_while_statement] = STATE(525),
    [sym_do_statement] = STATE(525),
    [sym_try_statement] = STATE(525),
    [sym_with_statement] = STATE(525),
    [sym_break_statement] = STATE(525),
    [sym_continue_statement] = STATE(525),
    [sym_debugger_statement] = STATE(525),
    [sym_return_statement] = STATE(525),
    [sym_throw_statement] = STATE(525),
    [sym_empty_statement] = STATE(525),
    [sym_labeled_statement] = STATE(525),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(525),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(525),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(525),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(525),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(525),
    [sym_abstract_class_declaration] = STATE(525),
    [sym_module] = STATE(525),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(525),
    [sym_interface_declaration] = STATE(525),
    [sym_enum_declaration] = STATE(525),
    [sym_type_alias_declaration] = STATE(525),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [32] = {
    [sym_export_statement] = STATE(606),
    [sym__declaration] = STATE(606),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(606),
    [sym_expression_statement] = STATE(606),
    [sym_variable_declaration] = STATE(606),
    [sym_lexical_declaration] = STATE(606),
    [sym_statement_block] = STATE(606),
    [sym_if_statement] = STATE(606),
    [sym_switch_statement] = STATE(606),
    [sym_for_statement] = STATE(606),
    [sym_for_in_statement] = STATE(606),
    [sym_while_statement] = STATE(606),
    [sym_do_statement] = STATE(606),
    [sym_try_statement] = STATE(606),
    [sym_with_statement] = STATE(606),
    [sym_break_statement] = STATE(606),
    [sym_continue_statement] = STATE(606),
    [sym_debugger_statement] = STATE(606),
    [sym_return_statement] = STATE(606),
    [sym_throw_statement] = STATE(606),
    [sym_empty_statement] = STATE(606),
    [sym_labeled_statement] = STATE(606),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(606),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(606),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(606),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(606),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(606),
    [sym_abstract_class_declaration] = STATE(606),
    [sym_module] = STATE(606),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(606),
    [sym_interface_declaration] = STATE(606),
    [sym_enum_declaration] = STATE(606),
    [sym_type_alias_declaration] = STATE(606),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [33] = {
    [sym_export_statement] = STATE(602),
    [sym__declaration] = STATE(602),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(602),
    [sym_expression_statement] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_statement_block] = STATE(602),
    [sym_if_statement] = STATE(602),
    [sym_switch_statement] = STATE(602),
    [sym_for_statement] = STATE(602),
    [sym_for_in_statement] = STATE(602),
    [sym_while_statement] = STATE(602),
    [sym_do_statement] = STATE(602),
    [sym_try_statement] = STATE(602),
    [sym_with_statement] = STATE(602),
    [sym_break_statement] = STATE(602),
    [sym_continue_statement] = STATE(602),
    [sym_debugger_statement] = STATE(602),
    [sym_return_statement] = STATE(602),
    [sym_throw_statement] = STATE(602),
    [sym_empty_statement] = STATE(602),
    [sym_labeled_statement] = STATE(602),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(602),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(602),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(602),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [34] = {
    [sym_export_statement] = STATE(560),
    [sym__declaration] = STATE(560),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_lexical_declaration] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_debugger_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(560),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(560),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(560),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(560),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(560),
    [sym_abstract_class_declaration] = STATE(560),
    [sym_module] = STATE(560),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(560),
    [sym_interface_declaration] = STATE(560),
    [sym_enum_declaration] = STATE(560),
    [sym_type_alias_declaration] = STATE(560),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [35] = {
    [sym_export_statement] = STATE(525),
    [sym__declaration] = STATE(525),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(525),
    [sym_expression_statement] = STATE(525),
    [sym_variable_declaration] = STATE(525),
    [sym_lexical_declaration] = STATE(525),
    [sym_statement_block] = STATE(525),
    [sym_if_statement] = STATE(525),
    [sym_switch_statement] = STATE(525),
    [sym_for_statement] = STATE(525),
    [sym_for_in_statement] = STATE(525),
    [sym_while_statement] = STATE(525),
    [sym_do_statement] = STATE(525),
    [sym_try_statement] = STATE(525),
    [sym_with_statement] = STATE(525),
    [sym_break_statement] = STATE(525),
    [sym_continue_statement] = STATE(525),
    [sym_debugger_statement] = STATE(525),
    [sym_return_statement] = STATE(525),
    [sym_throw_statement] = STATE(525),
    [sym_empty_statement] = STATE(525),
    [sym_labeled_statement] = STATE(525),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(525),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(525),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(525),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(525),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(525),
    [sym_abstract_class_declaration] = STATE(525),
    [sym_module] = STATE(525),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(525),
    [sym_interface_declaration] = STATE(525),
    [sym_enum_declaration] = STATE(525),
    [sym_type_alias_declaration] = STATE(525),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [36] = {
    [sym_export_statement] = STATE(602),
    [sym__declaration] = STATE(602),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(602),
    [sym_expression_statement] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_statement_block] = STATE(602),
    [sym_if_statement] = STATE(602),
    [sym_switch_statement] = STATE(602),
    [sym_for_statement] = STATE(602),
    [sym_for_in_statement] = STATE(602),
    [sym_while_statement] = STATE(602),
    [sym_do_statement] = STATE(602),
    [sym_try_statement] = STATE(602),
    [sym_with_statement] = STATE(602),
    [sym_break_statement] = STATE(602),
    [sym_continue_statement] = STATE(602),
    [sym_debugger_statement] = STATE(602),
    [sym_return_statement] = STATE(602),
    [sym_throw_statement] = STATE(602),
    [sym_empty_statement] = STATE(602),
    [sym_labeled_statement] = STATE(602),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(602),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(602),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(602),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [37] = {
    [sym_export_statement] = STATE(2827),
    [sym__declaration] = STATE(2827),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(2827),
    [sym_expression_statement] = STATE(2827),
    [sym_variable_declaration] = STATE(2827),
    [sym_lexical_declaration] = STATE(2827),
    [sym_statement_block] = STATE(2827),
    [sym_if_statement] = STATE(2827),
    [sym_switch_statement] = STATE(2827),
    [sym_for_statement] = STATE(2827),
    [sym_for_in_statement] = STATE(2827),
    [sym_while_statement] = STATE(2827),
    [sym_do_statement] = STATE(2827),
    [sym_try_statement] = STATE(2827),
    [sym_with_statement] = STATE(2827),
    [sym_break_statement] = STATE(2827),
    [sym_continue_statement] = STATE(2827),
    [sym_debugger_statement] = STATE(2827),
    [sym_return_statement] = STATE(2827),
    [sym_throw_statement] = STATE(2827),
    [sym_empty_statement] = STATE(2827),
    [sym_labeled_statement] = STATE(2827),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(2827),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(2827),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(2827),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(2827),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(2827),
    [sym_abstract_class_declaration] = STATE(2827),
    [sym_module] = STATE(2827),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(2827),
    [sym_interface_declaration] = STATE(2827),
    [sym_enum_declaration] = STATE(2827),
    [sym_type_alias_declaration] = STATE(2827),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [38] = {
    [sym_export_statement] = STATE(2800),
    [sym__declaration] = STATE(2800),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(2800),
    [sym_expression_statement] = STATE(2800),
    [sym_variable_declaration] = STATE(2800),
    [sym_lexical_declaration] = STATE(2800),
    [sym_statement_block] = STATE(2800),
    [sym_if_statement] = STATE(2800),
    [sym_switch_statement] = STATE(2800),
    [sym_for_statement] = STATE(2800),
    [sym_for_in_statement] = STATE(2800),
    [sym_while_statement] = STATE(2800),
    [sym_do_statement] = STATE(2800),
    [sym_try_statement] = STATE(2800),
    [sym_with_statement] = STATE(2800),
    [sym_break_statement] = STATE(2800),
    [sym_continue_statement] = STATE(2800),
    [sym_debugger_statement] = STATE(2800),
    [sym_return_statement] = STATE(2800),
    [sym_throw_statement] = STATE(2800),
    [sym_empty_statement] = STATE(2800),
    [sym_labeled_statement] = STATE(2800),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(2800),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(2800),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(2800),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(2800),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(2800),
    [sym_abstract_class_declaration] = STATE(2800),
    [sym_module] = STATE(2800),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(2800),
    [sym_interface_declaration] = STATE(2800),
    [sym_enum_declaration] = STATE(2800),
    [sym_type_alias_declaration] = STATE(2800),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [39] = {
    [sym_export_statement] = STATE(580),
    [sym__declaration] = STATE(580),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(580),
    [sym_expression_statement] = STATE(580),
    [sym_variable_declaration] = STATE(580),
    [sym_lexical_declaration] = STATE(580),
    [sym_statement_block] = STATE(580),
    [sym_if_statement] = STATE(580),
    [sym_switch_statement] = STATE(580),
    [sym_for_statement] = STATE(580),
    [sym_for_in_statement] = STATE(580),
    [sym_while_statement] = STATE(580),
    [sym_do_statement] = STATE(580),
    [sym_try_statement] = STATE(580),
    [sym_with_statement] = STATE(580),
    [sym_break_statement] = STATE(580),
    [sym_continue_statement] = STATE(580),
    [sym_debugger_statement] = STATE(580),
    [sym_return_statement] = STATE(580),
    [sym_throw_statement] = STATE(580),
    [sym_empty_statement] = STATE(580),
    [sym_labeled_statement] = STATE(580),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(580),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(580),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(580),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(580),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(580),
    [sym_abstract_class_declaration] = STATE(580),
    [sym_module] = STATE(580),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(580),
    [sym_interface_declaration] = STATE(580),
    [sym_enum_declaration] = STATE(580),
    [sym_type_alias_declaration] = STATE(580),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [40] = {
    [sym_export_statement] = STATE(593),
    [sym__declaration] = STATE(593),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(593),
    [sym_expression_statement] = STATE(593),
    [sym_variable_declaration] = STATE(593),
    [sym_lexical_declaration] = STATE(593),
    [sym_statement_block] = STATE(593),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(593),
    [sym_for_statement] = STATE(593),
    [sym_for_in_statement] = STATE(593),
    [sym_while_statement] = STATE(593),
    [sym_do_statement] = STATE(593),
    [sym_try_statement] = STATE(593),
    [sym_with_statement] = STATE(593),
    [sym_break_statement] = STATE(593),
    [sym_continue_statement] = STATE(593),
    [sym_debugger_statement] = STATE(593),
    [sym_return_statement] = STATE(593),
    [sym_throw_statement] = STATE(593),
    [sym_empty_statement] = STATE(593),
    [sym_labeled_statement] = STATE(593),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(593),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(593),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(593),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(593),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(593),
    [sym_abstract_class_declaration] = STATE(593),
    [sym_module] = STATE(593),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(593),
    [sym_interface_declaration] = STATE(593),
    [sym_enum_declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(593),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [41] = {
    [sym_export_statement] = STATE(569),
    [sym__declaration] = STATE(569),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_variable_declaration] = STATE(569),
    [sym_lexical_declaration] = STATE(569),
    [sym_statement_block] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_for_in_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_with_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_debugger_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_empty_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(569),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(569),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(569),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(569),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(569),
    [sym_abstract_class_declaration] = STATE(569),
    [sym_module] = STATE(569),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(569),
    [sym_interface_declaration] = STATE(569),
    [sym_enum_declaration] = STATE(569),
    [sym_type_alias_declaration] = STATE(569),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [42] = {
    [sym_export_statement] = STATE(556),
    [sym__declaration] = STATE(556),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(556),
    [sym_expression_statement] = STATE(556),
    [sym_variable_declaration] = STATE(556),
    [sym_lexical_declaration] = STATE(556),
    [sym_statement_block] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_switch_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_for_in_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_do_statement] = STATE(556),
    [sym_try_statement] = STATE(556),
    [sym_with_statement] = STATE(556),
    [sym_break_statement] = STATE(556),
    [sym_continue_statement] = STATE(556),
    [sym_debugger_statement] = STATE(556),
    [sym_return_statement] = STATE(556),
    [sym_throw_statement] = STATE(556),
    [sym_empty_statement] = STATE(556),
    [sym_labeled_statement] = STATE(556),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(556),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(556),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(556),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(556),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(556),
    [sym_abstract_class_declaration] = STATE(556),
    [sym_module] = STATE(556),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(556),
    [sym_interface_declaration] = STATE(556),
    [sym_enum_declaration] = STATE(556),
    [sym_type_alias_declaration] = STATE(556),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [43] = {
    [sym_export_statement] = STATE(606),
    [sym__declaration] = STATE(606),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(606),
    [sym_expression_statement] = STATE(606),
    [sym_variable_declaration] = STATE(606),
    [sym_lexical_declaration] = STATE(606),
    [sym_statement_block] = STATE(606),
    [sym_if_statement] = STATE(606),
    [sym_switch_statement] = STATE(606),
    [sym_for_statement] = STATE(606),
    [sym_for_in_statement] = STATE(606),
    [sym_while_statement] = STATE(606),
    [sym_do_statement] = STATE(606),
    [sym_try_statement] = STATE(606),
    [sym_with_statement] = STATE(606),
    [sym_break_statement] = STATE(606),
    [sym_continue_statement] = STATE(606),
    [sym_debugger_statement] = STATE(606),
    [sym_return_statement] = STATE(606),
    [sym_throw_statement] = STATE(606),
    [sym_empty_statement] = STATE(606),
    [sym_labeled_statement] = STATE(606),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(606),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(606),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(606),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(606),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(606),
    [sym_abstract_class_declaration] = STATE(606),
    [sym_module] = STATE(606),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(606),
    [sym_interface_declaration] = STATE(606),
    [sym_enum_declaration] = STATE(606),
    [sym_type_alias_declaration] = STATE(606),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [44] = {
    [sym_export_statement] = STATE(525),
    [sym__declaration] = STATE(525),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(525),
    [sym_expression_statement] = STATE(525),
    [sym_variable_declaration] = STATE(525),
    [sym_lexical_declaration] = STATE(525),
    [sym_statement_block] = STATE(525),
    [sym_if_statement] = STATE(525),
    [sym_switch_statement] = STATE(525),
    [sym_for_statement] = STATE(525),
    [sym_for_in_statement] = STATE(525),
    [sym_while_statement] = STATE(525),
    [sym_do_statement] = STATE(525),
    [sym_try_statement] = STATE(525),
    [sym_with_statement] = STATE(525),
    [sym_break_statement] = STATE(525),
    [sym_continue_statement] = STATE(525),
    [sym_debugger_statement] = STATE(525),
    [sym_return_statement] = STATE(525),
    [sym_throw_statement] = STATE(525),
    [sym_empty_statement] = STATE(525),
    [sym_labeled_statement] = STATE(525),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(525),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(525),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(525),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(525),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(525),
    [sym_abstract_class_declaration] = STATE(525),
    [sym_module] = STATE(525),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(525),
    [sym_interface_declaration] = STATE(525),
    [sym_enum_declaration] = STATE(525),
    [sym_type_alias_declaration] = STATE(525),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [45] = {
    [sym_export_statement] = STATE(569),
    [sym__declaration] = STATE(569),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_variable_declaration] = STATE(569),
    [sym_lexical_declaration] = STATE(569),
    [sym_statement_block] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_for_in_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_with_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_debugger_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_empty_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(569),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(569),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(569),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(569),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(569),
    [sym_abstract_class_declaration] = STATE(569),
    [sym_module] = STATE(569),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(569),
    [sym_interface_declaration] = STATE(569),
    [sym_enum_declaration] = STATE(569),
    [sym_type_alias_declaration] = STATE(569),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [46] = {
    [sym_export_statement] = STATE(556),
    [sym__declaration] = STATE(556),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(556),
    [sym_expression_statement] = STATE(556),
    [sym_variable_declaration] = STATE(556),
    [sym_lexical_declaration] = STATE(556),
    [sym_statement_block] = STATE(556),
    [sym_if_statement] = STATE(556),
    [sym_switch_statement] = STATE(556),
    [sym_for_statement] = STATE(556),
    [sym_for_in_statement] = STATE(556),
    [sym_while_statement] = STATE(556),
    [sym_do_statement] = STATE(556),
    [sym_try_statement] = STATE(556),
    [sym_with_statement] = STATE(556),
    [sym_break_statement] = STATE(556),
    [sym_continue_statement] = STATE(556),
    [sym_debugger_statement] = STATE(556),
    [sym_return_statement] = STATE(556),
    [sym_throw_statement] = STATE(556),
    [sym_empty_statement] = STATE(556),
    [sym_labeled_statement] = STATE(556),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(556),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(556),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(556),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(556),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(556),
    [sym_abstract_class_declaration] = STATE(556),
    [sym_module] = STATE(556),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(556),
    [sym_interface_declaration] = STATE(556),
    [sym_enum_declaration] = STATE(556),
    [sym_type_alias_declaration] = STATE(556),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [47] = {
    [sym_export_statement] = STATE(569),
    [sym__declaration] = STATE(569),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_variable_declaration] = STATE(569),
    [sym_lexical_declaration] = STATE(569),
    [sym_statement_block] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_for_in_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_with_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_debugger_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_empty_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(569),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(569),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(569),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(569),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(569),
    [sym_abstract_class_declaration] = STATE(569),
    [sym_module] = STATE(569),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(569),
    [sym_interface_declaration] = STATE(569),
    [sym_enum_declaration] = STATE(569),
    [sym_type_alias_declaration] = STATE(569),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [48] = {
    [sym_export_statement] = STATE(542),
    [sym__declaration] = STATE(542),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(542),
    [sym_expression_statement] = STATE(542),
    [sym_variable_declaration] = STATE(542),
    [sym_lexical_declaration] = STATE(542),
    [sym_statement_block] = STATE(542),
    [sym_if_statement] = STATE(542),
    [sym_switch_statement] = STATE(542),
    [sym_for_statement] = STATE(542),
    [sym_for_in_statement] = STATE(542),
    [sym_while_statement] = STATE(542),
    [sym_do_statement] = STATE(542),
    [sym_try_statement] = STATE(542),
    [sym_with_statement] = STATE(542),
    [sym_break_statement] = STATE(542),
    [sym_continue_statement] = STATE(542),
    [sym_debugger_statement] = STATE(542),
    [sym_return_statement] = STATE(542),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(542),
    [sym_labeled_statement] = STATE(542),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(542),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(542),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(542),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(542),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(542),
    [sym_abstract_class_declaration] = STATE(542),
    [sym_module] = STATE(542),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(542),
    [sym_interface_declaration] = STATE(542),
    [sym_enum_declaration] = STATE(542),
    [sym_type_alias_declaration] = STATE(542),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [49] = {
    [sym_export_statement] = STATE(606),
    [sym__declaration] = STATE(606),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(606),
    [sym_expression_statement] = STATE(606),
    [sym_variable_declaration] = STATE(606),
    [sym_lexical_declaration] = STATE(606),
    [sym_statement_block] = STATE(606),
    [sym_if_statement] = STATE(606),
    [sym_switch_statement] = STATE(606),
    [sym_for_statement] = STATE(606),
    [sym_for_in_statement] = STATE(606),
    [sym_while_statement] = STATE(606),
    [sym_do_statement] = STATE(606),
    [sym_try_statement] = STATE(606),
    [sym_with_statement] = STATE(606),
    [sym_break_statement] = STATE(606),
    [sym_continue_statement] = STATE(606),
    [sym_debugger_statement] = STATE(606),
    [sym_return_statement] = STATE(606),
    [sym_throw_statement] = STATE(606),
    [sym_empty_statement] = STATE(606),
    [sym_labeled_statement] = STATE(606),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(606),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(606),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(606),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(606),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(606),
    [sym_abstract_class_declaration] = STATE(606),
    [sym_module] = STATE(606),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(606),
    [sym_interface_declaration] = STATE(606),
    [sym_enum_declaration] = STATE(606),
    [sym_type_alias_declaration] = STATE(606),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [50] = {
    [sym_export_statement] = STATE(560),
    [sym__declaration] = STATE(560),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(560),
    [sym_expression_statement] = STATE(560),
    [sym_variable_declaration] = STATE(560),
    [sym_lexical_declaration] = STATE(560),
    [sym_statement_block] = STATE(560),
    [sym_if_statement] = STATE(560),
    [sym_switch_statement] = STATE(560),
    [sym_for_statement] = STATE(560),
    [sym_for_in_statement] = STATE(560),
    [sym_while_statement] = STATE(560),
    [sym_do_statement] = STATE(560),
    [sym_try_statement] = STATE(560),
    [sym_with_statement] = STATE(560),
    [sym_break_statement] = STATE(560),
    [sym_continue_statement] = STATE(560),
    [sym_debugger_statement] = STATE(560),
    [sym_return_statement] = STATE(560),
    [sym_throw_statement] = STATE(560),
    [sym_empty_statement] = STATE(560),
    [sym_labeled_statement] = STATE(560),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(560),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(560),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(560),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(560),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(560),
    [sym_abstract_class_declaration] = STATE(560),
    [sym_module] = STATE(560),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(560),
    [sym_interface_declaration] = STATE(560),
    [sym_enum_declaration] = STATE(560),
    [sym_type_alias_declaration] = STATE(560),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [51] = {
    [sym_export_statement] = STATE(602),
    [sym__declaration] = STATE(602),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(602),
    [sym_expression_statement] = STATE(602),
    [sym_variable_declaration] = STATE(602),
    [sym_lexical_declaration] = STATE(602),
    [sym_statement_block] = STATE(602),
    [sym_if_statement] = STATE(602),
    [sym_switch_statement] = STATE(602),
    [sym_for_statement] = STATE(602),
    [sym_for_in_statement] = STATE(602),
    [sym_while_statement] = STATE(602),
    [sym_do_statement] = STATE(602),
    [sym_try_statement] = STATE(602),
    [sym_with_statement] = STATE(602),
    [sym_break_statement] = STATE(602),
    [sym_continue_statement] = STATE(602),
    [sym_debugger_statement] = STATE(602),
    [sym_return_statement] = STATE(602),
    [sym_throw_statement] = STATE(602),
    [sym_empty_statement] = STATE(602),
    [sym_labeled_statement] = STATE(602),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(602),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(602),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(602),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(602),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(602),
    [sym_abstract_class_declaration] = STATE(602),
    [sym_module] = STATE(602),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(602),
    [sym_interface_declaration] = STATE(602),
    [sym_enum_declaration] = STATE(602),
    [sym_type_alias_declaration] = STATE(602),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [52] = {
    [sym_export_statement] = STATE(593),
    [sym__declaration] = STATE(593),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(593),
    [sym_expression_statement] = STATE(593),
    [sym_variable_declaration] = STATE(593),
    [sym_lexical_declaration] = STATE(593),
    [sym_statement_block] = STATE(593),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(593),
    [sym_for_statement] = STATE(593),
    [sym_for_in_statement] = STATE(593),
    [sym_while_statement] = STATE(593),
    [sym_do_statement] = STATE(593),
    [sym_try_statement] = STATE(593),
    [sym_with_statement] = STATE(593),
    [sym_break_statement] = STATE(593),
    [sym_continue_statement] = STATE(593),
    [sym_debugger_statement] = STATE(593),
    [sym_return_statement] = STATE(593),
    [sym_throw_statement] = STATE(593),
    [sym_empty_statement] = STATE(593),
    [sym_labeled_statement] = STATE(593),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(593),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(593),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(593),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(593),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(593),
    [sym_abstract_class_declaration] = STATE(593),
    [sym_module] = STATE(593),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(593),
    [sym_interface_declaration] = STATE(593),
    [sym_enum_declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(593),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [53] = {
    [sym_export_statement] = STATE(542),
    [sym__declaration] = STATE(542),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(542),
    [sym_expression_statement] = STATE(542),
    [sym_variable_declaration] = STATE(542),
    [sym_lexical_declaration] = STATE(542),
    [sym_statement_block] = STATE(542),
    [sym_if_statement] = STATE(542),
    [sym_switch_statement] = STATE(542),
    [sym_for_statement] = STATE(542),
    [sym_for_in_statement] = STATE(542),
    [sym_while_statement] = STATE(542),
    [sym_do_statement] = STATE(542),
    [sym_try_statement] = STATE(542),
    [sym_with_statement] = STATE(542),
    [sym_break_statement] = STATE(542),
    [sym_continue_statement] = STATE(542),
    [sym_debugger_statement] = STATE(542),
    [sym_return_statement] = STATE(542),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(542),
    [sym_labeled_statement] = STATE(542),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(542),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(542),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(542),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(542),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(542),
    [sym_abstract_class_declaration] = STATE(542),
    [sym_module] = STATE(542),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(542),
    [sym_interface_declaration] = STATE(542),
    [sym_enum_declaration] = STATE(542),
    [sym_type_alias_declaration] = STATE(542),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2418),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [54] = {
    [sym_export_statement] = STATE(593),
    [sym__declaration] = STATE(593),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(593),
    [sym_expression_statement] = STATE(593),
    [sym_variable_declaration] = STATE(593),
    [sym_lexical_declaration] = STATE(593),
    [sym_statement_block] = STATE(593),
    [sym_if_statement] = STATE(593),
    [sym_switch_statement] = STATE(593),
    [sym_for_statement] = STATE(593),
    [sym_for_in_statement] = STATE(593),
    [sym_while_statement] = STATE(593),
    [sym_do_statement] = STATE(593),
    [sym_try_statement] = STATE(593),
    [sym_with_statement] = STATE(593),
    [sym_break_statement] = STATE(593),
    [sym_continue_statement] = STATE(593),
    [sym_debugger_statement] = STATE(593),
    [sym_return_statement] = STATE(593),
    [sym_throw_statement] = STATE(593),
    [sym_empty_statement] = STATE(593),
    [sym_labeled_statement] = STATE(593),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(593),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(593),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(593),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(593),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(593),
    [sym_abstract_class_declaration] = STATE(593),
    [sym_module] = STATE(593),
    [sym_internal_module] = STATE(132),
    [sym_import_alias] = STATE(593),
    [sym_interface_declaration] = STATE(593),
    [sym_enum_declaration] = STATE(593),
    [sym_type_alias_declaration] = STATE(593),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2354),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [55] = {
    [sym_export_statement] = STATE(3006),
    [sym__declaration] = STATE(3006),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(3006),
    [sym_expression_statement] = STATE(3006),
    [sym_variable_declaration] = STATE(3006),
    [sym_lexical_declaration] = STATE(3006),
    [sym_statement_block] = STATE(3006),
    [sym_if_statement] = STATE(3006),
    [sym_switch_statement] = STATE(3006),
    [sym_for_statement] = STATE(3006),
    [sym_for_in_statement] = STATE(3006),
    [sym_while_statement] = STATE(3006),
    [sym_do_statement] = STATE(3006),
    [sym_try_statement] = STATE(3006),
    [sym_with_statement] = STATE(3006),
    [sym_break_statement] = STATE(3006),
    [sym_continue_statement] = STATE(3006),
    [sym_debugger_statement] = STATE(3006),
    [sym_return_statement] = STATE(3006),
    [sym_throw_statement] = STATE(3006),
    [sym_empty_statement] = STATE(3006),
    [sym_labeled_statement] = STATE(3006),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(3006),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(3006),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(3006),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(3006),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(3006),
    [sym_abstract_class_declaration] = STATE(3006),
    [sym_module] = STATE(3006),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(3006),
    [sym_interface_declaration] = STATE(3006),
    [sym_enum_declaration] = STATE(3006),
    [sym_type_alias_declaration] = STATE(3006),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [56] = {
    [sym_export_statement] = STATE(542),
    [sym__declaration] = STATE(542),
    [sym_import] = STATE(1270),
    [sym_import_statement] = STATE(542),
    [sym_expression_statement] = STATE(542),
    [sym_variable_declaration] = STATE(542),
    [sym_lexical_declaration] = STATE(542),
    [sym_statement_block] = STATE(542),
    [sym_if_statement] = STATE(542),
    [sym_switch_statement] = STATE(542),
    [sym_for_statement] = STATE(542),
    [sym_for_in_statement] = STATE(542),
    [sym_while_statement] = STATE(542),
    [sym_do_statement] = STATE(542),
    [sym_try_statement] = STATE(542),
    [sym_with_statement] = STATE(542),
    [sym_break_statement] = STATE(542),
    [sym_continue_statement] = STATE(542),
    [sym_debugger_statement] = STATE(542),
    [sym_return_statement] = STATE(542),
    [sym_throw_statement] = STATE(542),
    [sym_empty_statement] = STATE(542),
    [sym_labeled_statement] = STATE(542),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_class_declaration] = STATE(542),
    [sym_function] = STATE(1157),
    [sym_function_declaration] = STATE(542),
    [sym_generator_function] = STATE(1270),
    [sym_generator_function_declaration] = STATE(542),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_function_signature] = STATE(542),
    [sym_as_expression] = STATE(1270),
    [sym_ambient_declaration] = STATE(542),
    [sym_abstract_class_declaration] = STATE(542),
    [sym_module] = STATE(542),
    [sym_internal_module] = STATE(1324),
    [sym_import_alias] = STATE(542),
    [sym_interface_declaration] = STATE(542),
    [sym_enum_declaration] = STATE(542),
    [sym_type_alias_declaration] = STATE(542),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2392),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(461),
    [anon_sym_set] = ACTIONS(461),
    [anon_sym_declare] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(461),
    [anon_sym_private] = ACTIONS(461),
    [anon_sym_protected] = ACTIONS(461),
    [anon_sym_module] = ACTIONS(465),
    [anon_sym_any] = ACTIONS(461),
    [anon_sym_number] = ACTIONS(461),
    [anon_sym_boolean] = ACTIONS(461),
    [anon_sym_string] = ACTIONS(461),
    [anon_sym_symbol] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(461),
  },
  [57] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [58] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [59] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [60] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1033),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [61] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1534),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [62] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [63] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_PIPE_RBRACE] = ACTIONS(617),
    [sym__automatic_semicolon] = ACTIONS(617),
  },
  [64] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [65] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1033),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [66] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [67] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [68] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [69] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [70] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [71] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [72] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [73] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [74] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1534),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [75] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1589),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
  },
  [76] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(654),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [77] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [78] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [79] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [80] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_arguments] = STATE(1033),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [anon_sym_implements] = ACTIONS(521),
    [sym_readonly] = ACTIONS(519),
  },
  [81] = {
    [sym_import] = STATE(1369),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1369),
    [sym_arrow_function] = STATE(1369),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1369),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_null] = ACTIONS(694),
    [sym_undefined] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [82] = {
    [sym_import] = STATE(1369),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1369),
    [sym_arrow_function] = STATE(1369),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1369),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_null] = ACTIONS(694),
    [sym_undefined] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [83] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [84] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(748),
    [sym_this] = ACTIONS(750),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_undefined] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [85] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [86] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS_EQ] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(774),
    [anon_sym_STAR_EQ] = ACTIONS(774),
    [anon_sym_SLASH_EQ] = ACTIONS(774),
    [anon_sym_PERCENT_EQ] = ACTIONS(774),
    [anon_sym_CARET_EQ] = ACTIONS(774),
    [anon_sym_AMP_EQ] = ACTIONS(774),
    [anon_sym_PIPE_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_LT_EQ] = ACTIONS(774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(786),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_implements] = ACTIONS(471),
    [sym_readonly] = ACTIONS(756),
  },
  [87] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS_EQ] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(774),
    [anon_sym_STAR_EQ] = ACTIONS(774),
    [anon_sym_SLASH_EQ] = ACTIONS(774),
    [anon_sym_PERCENT_EQ] = ACTIONS(774),
    [anon_sym_CARET_EQ] = ACTIONS(774),
    [anon_sym_AMP_EQ] = ACTIONS(774),
    [anon_sym_PIPE_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_LT_EQ] = ACTIONS(774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(786),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_implements] = ACTIONS(471),
    [sym_readonly] = ACTIONS(756),
  },
  [88] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(644),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(748),
    [sym_this] = ACTIONS(750),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_undefined] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [89] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [90] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(790),
    [anon_sym_of] = ACTIONS(793),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [91] = {
    [sym_import] = STATE(1043),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1043),
    [sym_yield_expression] = STATE(1043),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1043),
    [sym_jsx_fragment] = STATE(1043),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1043),
    [sym_class] = STATE(1043),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1043),
    [sym_arrow_function] = STATE(1043),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1043),
    [sym_new_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1043),
    [sym_augmented_assignment_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_update_expression] = STATE(1043),
    [sym_sequence_expression] = STATE(2978),
    [sym_string] = STATE(1704),
    [sym_template_string] = STATE(1043),
    [sym_regex] = STATE(1043),
    [sym_meta_property] = STATE(1043),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1043),
    [sym_as_expression] = STATE(1043),
    [sym_internal_module] = STATE(1043),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(831),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(835),
    [sym_false] = ACTIONS(835),
    [sym_null] = ACTIONS(837),
    [sym_undefined] = ACTIONS(837),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [92] = {
    [sym_import] = STATE(1031),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1031),
    [sym_yield_expression] = STATE(1031),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1031),
    [sym_jsx_fragment] = STATE(1031),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1031),
    [sym_class] = STATE(1031),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1031),
    [sym_arrow_function] = STATE(1031),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1031),
    [sym_new_expression] = STATE(1031),
    [sym_await_expression] = STATE(1031),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1031),
    [sym_augmented_assignment_expression] = STATE(1031),
    [sym_ternary_expression] = STATE(1031),
    [sym_binary_expression] = STATE(1031),
    [sym_unary_expression] = STATE(1031),
    [sym_update_expression] = STATE(1031),
    [sym_sequence_expression] = STATE(2977),
    [sym_string] = STATE(1704),
    [sym_template_string] = STATE(1031),
    [sym_regex] = STATE(1031),
    [sym_meta_property] = STATE(1031),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1031),
    [sym_as_expression] = STATE(1031),
    [sym_internal_module] = STATE(1031),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(831),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(835),
    [sym_false] = ACTIONS(835),
    [sym_null] = ACTIONS(849),
    [sym_undefined] = ACTIONS(849),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [93] = {
    [sym_import] = STATE(1124),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1124),
    [sym_jsx_fragment] = STATE(1124),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1124),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_sequence_expression] = STATE(3013),
    [sym_string] = STATE(1704),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(831),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(835),
    [sym_false] = ACTIONS(835),
    [sym_null] = ACTIONS(851),
    [sym_undefined] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [94] = {
    [sym_import] = STATE(1043),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1043),
    [sym_yield_expression] = STATE(1043),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1043),
    [sym_jsx_fragment] = STATE(1043),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1043),
    [sym_class] = STATE(1043),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1043),
    [sym_arrow_function] = STATE(1043),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1043),
    [sym_new_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1043),
    [sym_augmented_assignment_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_update_expression] = STATE(1043),
    [sym_sequence_expression] = STATE(2978),
    [sym_string] = STATE(1704),
    [sym_template_string] = STATE(1043),
    [sym_regex] = STATE(1043),
    [sym_meta_property] = STATE(1043),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1043),
    [sym_as_expression] = STATE(1043),
    [sym_internal_module] = STATE(1043),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2580),
    [sym_constructor_type] = STATE(2580),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2580),
    [sym_intersection_type] = STATE(2580),
    [sym_function_type] = STATE(2580),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(795),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(805),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(829),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(831),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(835),
    [sym_false] = ACTIONS(835),
    [sym_null] = ACTIONS(837),
    [sym_undefined] = ACTIONS(837),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(843),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [95] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1219),
    [sym_jsx_fragment] = STATE(1219),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1219),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_spread_element] = STATE(2659),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2385),
    [sym_constructor_type] = STATE(2385),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2385),
    [sym_intersection_type] = STATE(2385),
    [sym_function_type] = STATE(2385),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2657),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(873),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [96] = {
    [sym_import] = STATE(1220),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1220),
    [sym_jsx_fragment] = STATE(1220),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1220),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1220),
    [sym_arrow_function] = STATE(1220),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2664),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2385),
    [sym_constructor_type] = STATE(2385),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2385),
    [sym_intersection_type] = STATE(2385),
    [sym_function_type] = STATE(2385),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2665),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(877),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(879),
    [sym_undefined] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [97] = {
    [sym_import] = STATE(1207),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1207),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1207),
    [sym_jsx_fragment] = STATE(1207),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1207),
    [sym_class] = STATE(1207),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1207),
    [sym_arrow_function] = STATE(1207),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1207),
    [sym_new_expression] = STATE(1207),
    [sym_await_expression] = STATE(1207),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1207),
    [sym_augmented_assignment_expression] = STATE(1207),
    [sym_spread_element] = STATE(2593),
    [sym_ternary_expression] = STATE(1207),
    [sym_binary_expression] = STATE(1207),
    [sym_unary_expression] = STATE(1207),
    [sym_update_expression] = STATE(1207),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1207),
    [sym_regex] = STATE(1207),
    [sym_meta_property] = STATE(1207),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1207),
    [sym_as_expression] = STATE(1207),
    [sym_internal_module] = STATE(1207),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2385),
    [sym_constructor_type] = STATE(2385),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2385),
    [sym_intersection_type] = STATE(2385),
    [sym_function_type] = STATE(2385),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(883),
    [sym_undefined] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [98] = {
    [sym_import] = STATE(1269),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1269),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1269),
    [sym_jsx_fragment] = STATE(1269),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1269),
    [sym_class] = STATE(1269),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1269),
    [sym_arrow_function] = STATE(1269),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1269),
    [sym_new_expression] = STATE(1269),
    [sym_await_expression] = STATE(1269),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1269),
    [sym_augmented_assignment_expression] = STATE(1269),
    [sym_spread_element] = STATE(2646),
    [sym_ternary_expression] = STATE(1269),
    [sym_binary_expression] = STATE(1269),
    [sym_unary_expression] = STATE(1269),
    [sym_update_expression] = STATE(1269),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1269),
    [sym_regex] = STATE(1269),
    [sym_meta_property] = STATE(1269),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1269),
    [sym_as_expression] = STATE(1269),
    [sym_internal_module] = STATE(1269),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2385),
    [sym_constructor_type] = STATE(2385),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2385),
    [sym_intersection_type] = STATE(2385),
    [sym_function_type] = STATE(2385),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2647),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(887),
    [sym_undefined] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [99] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1219),
    [sym_jsx_fragment] = STATE(1219),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1219),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_spread_element] = STATE(2659),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1735),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2295),
    [sym_constructor_type] = STATE(2295),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2295),
    [sym_intersection_type] = STATE(2295),
    [sym_function_type] = STATE(2295),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2657),
    [sym_identifier] = ACTIONS(853),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(855),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(873),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [100] = {
    [sym_import] = STATE(983),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(983),
    [sym_arrow_function] = STATE(983),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(983),
    [sym_new_expression] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_string] = STATE(1045),
    [sym_template_string] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(893),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(897),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(899),
    [sym_this] = ACTIONS(901),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(903),
    [sym_false] = ACTIONS(903),
    [sym_null] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(907),
    [anon_sym_number] = ACTIONS(907),
    [anon_sym_boolean] = ACTIONS(907),
    [anon_sym_string] = ACTIONS(907),
    [anon_sym_symbol] = ACTIONS(907),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [101] = {
    [sym_import] = STATE(1106),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1106),
    [sym_yield_expression] = STATE(1106),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1106),
    [sym_jsx_fragment] = STATE(1106),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1106),
    [sym_class] = STATE(1106),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1106),
    [sym_arrow_function] = STATE(1106),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1106),
    [sym_new_expression] = STATE(1106),
    [sym_await_expression] = STATE(1106),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1106),
    [sym_augmented_assignment_expression] = STATE(1106),
    [sym_ternary_expression] = STATE(1106),
    [sym_binary_expression] = STATE(1106),
    [sym_unary_expression] = STATE(1106),
    [sym_update_expression] = STATE(1106),
    [sym_string] = STATE(1488),
    [sym_template_string] = STATE(1106),
    [sym_regex] = STATE(1106),
    [sym_meta_property] = STATE(1106),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1106),
    [sym_as_expression] = STATE(1106),
    [sym_internal_module] = STATE(1106),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(909),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(913),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(923),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(925),
    [sym_this] = ACTIONS(927),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(929),
    [sym_false] = ACTIONS(929),
    [sym_null] = ACTIONS(931),
    [sym_undefined] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
    [sym_readonly] = ACTIONS(469),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [102] = {
    [sym_import] = STATE(1239),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1239),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1239),
    [sym_jsx_fragment] = STATE(1239),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1239),
    [sym_class] = STATE(1239),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1239),
    [sym_arrow_function] = STATE(1239),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1239),
    [sym_new_expression] = STATE(1239),
    [sym_await_expression] = STATE(1239),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1239),
    [sym_augmented_assignment_expression] = STATE(1239),
    [sym_ternary_expression] = STATE(1239),
    [sym_binary_expression] = STATE(1239),
    [sym_unary_expression] = STATE(1239),
    [sym_update_expression] = STATE(1239),
    [sym_string] = STATE(1451),
    [sym_template_string] = STATE(1239),
    [sym_regex] = STATE(1239),
    [sym_meta_property] = STATE(1239),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1239),
    [sym_as_expression] = STATE(1239),
    [sym_internal_module] = STATE(1239),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(937),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(943),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(945),
    [sym_this] = ACTIONS(947),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(949),
    [sym_false] = ACTIONS(949),
    [sym_null] = ACTIONS(951),
    [sym_undefined] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(953),
    [anon_sym_number] = ACTIONS(953),
    [anon_sym_boolean] = ACTIONS(953),
    [anon_sym_string] = ACTIONS(953),
    [anon_sym_symbol] = ACTIONS(953),
    [sym_readonly] = ACTIONS(519),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [103] = {
    [sym_import] = STATE(1363),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1363),
    [sym_yield_expression] = STATE(1363),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1363),
    [sym_jsx_fragment] = STATE(1363),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(2982),
    [sym_jsx_self_closing_element] = STATE(1363),
    [sym_class] = STATE(1363),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1363),
    [sym_arrow_function] = STATE(1363),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1363),
    [sym_new_expression] = STATE(1363),
    [sym_await_expression] = STATE(1363),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1363),
    [sym_augmented_assignment_expression] = STATE(1363),
    [sym_ternary_expression] = STATE(1363),
    [sym_binary_expression] = STATE(1363),
    [sym_unary_expression] = STATE(1363),
    [sym_update_expression] = STATE(1363),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1363),
    [sym_regex] = STATE(1363),
    [sym_meta_property] = STATE(1363),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2746),
    [sym_non_null_expression] = STATE(1363),
    [sym_as_expression] = STATE(1363),
    [sym_internal_module] = STATE(1363),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(2010),
    [sym_constructor_type] = STATE(2010),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2846),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(2010),
    [sym_intersection_type] = STATE(2010),
    [sym_function_type] = STATE(2010),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(955),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(961),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(963),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(967),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(977),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(979),
    [sym_this] = ACTIONS(981),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(987),
    [anon_sym_number] = ACTIONS(987),
    [anon_sym_boolean] = ACTIONS(987),
    [anon_sym_string] = ACTIONS(987),
    [anon_sym_symbol] = ACTIONS(987),
    [sym_readonly] = ACTIONS(569),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [104] = {
    [sym_import] = STATE(1258),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1258),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1258),
    [sym_jsx_fragment] = STATE(1258),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1258),
    [sym_class] = STATE(1258),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1258),
    [sym_arrow_function] = STATE(1258),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1258),
    [sym_new_expression] = STATE(1258),
    [sym_await_expression] = STATE(1258),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1258),
    [sym_augmented_assignment_expression] = STATE(1258),
    [sym_ternary_expression] = STATE(1258),
    [sym_binary_expression] = STATE(1258),
    [sym_unary_expression] = STATE(1258),
    [sym_update_expression] = STATE(1258),
    [sym_string] = STATE(1603),
    [sym_template_string] = STATE(1258),
    [sym_regex] = STATE(1258),
    [sym_meta_property] = STATE(1258),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1258),
    [sym_as_expression] = STATE(1258),
    [sym_internal_module] = STATE(1258),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(995),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(1005),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1007),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1011),
    [sym_this] = ACTIONS(1013),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1015),
    [sym_false] = ACTIONS(1015),
    [sym_null] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(1019),
    [anon_sym_number] = ACTIONS(1019),
    [anon_sym_boolean] = ACTIONS(1019),
    [anon_sym_string] = ACTIONS(1019),
    [anon_sym_symbol] = ACTIONS(1019),
    [sym_readonly] = ACTIONS(698),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [105] = {
    [sym_import] = STATE(1008),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1008),
    [sym_yield_expression] = STATE(1008),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1008),
    [sym_jsx_fragment] = STATE(1008),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1008),
    [sym_class] = STATE(1008),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1008),
    [sym_arrow_function] = STATE(1008),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1008),
    [sym_new_expression] = STATE(1008),
    [sym_await_expression] = STATE(1008),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1008),
    [sym_augmented_assignment_expression] = STATE(1008),
    [sym_ternary_expression] = STATE(1008),
    [sym_binary_expression] = STATE(1008),
    [sym_unary_expression] = STATE(1008),
    [sym_update_expression] = STATE(1008),
    [sym_string] = STATE(1008),
    [sym_template_string] = STATE(1008),
    [sym_regex] = STATE(1008),
    [sym_meta_property] = STATE(1008),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1008),
    [sym_as_expression] = STATE(1008),
    [sym_internal_module] = STATE(1008),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_STAR] = ACTIONS(1021),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_COLON] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_null] = ACTIONS(1029),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [106] = {
    [sym_import] = STATE(1177),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1177),
    [sym_yield_expression] = STATE(1177),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1177),
    [sym_jsx_fragment] = STATE(1177),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1177),
    [sym_class] = STATE(1177),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1177),
    [sym_arrow_function] = STATE(1177),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1177),
    [sym_new_expression] = STATE(1177),
    [sym_await_expression] = STATE(1177),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1177),
    [sym_augmented_assignment_expression] = STATE(1177),
    [sym_ternary_expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_unary_expression] = STATE(1177),
    [sym_update_expression] = STATE(1177),
    [sym_string] = STATE(1045),
    [sym_template_string] = STATE(1177),
    [sym_regex] = STATE(1177),
    [sym_meta_property] = STATE(1177),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1177),
    [sym_as_expression] = STATE(1177),
    [sym_internal_module] = STATE(1177),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1031),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(1039),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(899),
    [sym_this] = ACTIONS(901),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(903),
    [sym_false] = ACTIONS(903),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(1043),
    [anon_sym_number] = ACTIONS(1043),
    [anon_sym_boolean] = ACTIONS(1043),
    [anon_sym_string] = ACTIONS(1043),
    [anon_sym_symbol] = ACTIONS(1043),
    [sym_readonly] = ACTIONS(756),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [107] = {
    [sym_import] = STATE(1364),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1364),
    [sym_jsx_fragment] = STATE(1364),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1364),
    [sym_class] = STATE(1364),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1364),
    [sym_arrow_function] = STATE(1364),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_string] = STATE(1625),
    [sym_template_string] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2702),
    [sym_non_null_expression] = STATE(1364),
    [sym_as_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2887),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(911),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(1047),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(915),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(917),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1055),
    [sym_this] = ACTIONS(1057),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(1063),
    [anon_sym_number] = ACTIONS(1063),
    [anon_sym_boolean] = ACTIONS(1063),
    [anon_sym_string] = ACTIONS(1063),
    [anon_sym_symbol] = ACTIONS(1063),
    [sym_readonly] = ACTIONS(664),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [108] = {
    [sym_import] = STATE(1119),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1119),
    [sym_yield_expression] = STATE(1119),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1119),
    [sym_jsx_fragment] = STATE(1119),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1119),
    [sym_class] = STATE(1119),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1119),
    [sym_arrow_function] = STATE(1119),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1119),
    [sym_new_expression] = STATE(1119),
    [sym_await_expression] = STATE(1119),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1119),
    [sym_augmented_assignment_expression] = STATE(1119),
    [sym_ternary_expression] = STATE(1119),
    [sym_binary_expression] = STATE(1119),
    [sym_unary_expression] = STATE(1119),
    [sym_update_expression] = STATE(1119),
    [sym_string] = STATE(1119),
    [sym_template_string] = STATE(1119),
    [sym_regex] = STATE(1119),
    [sym_meta_property] = STATE(1119),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1119),
    [sym_as_expression] = STATE(1119),
    [sym_internal_module] = STATE(1119),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1067),
    [sym_this] = ACTIONS(1069),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_null] = ACTIONS(1069),
    [sym_undefined] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(1025),
  },
  [109] = {
    [sym_import] = STATE(1276),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1276),
    [sym_yield_expression] = STATE(1276),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1276),
    [sym_jsx_fragment] = STATE(1276),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1276),
    [sym_class] = STATE(1276),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1276),
    [sym_arrow_function] = STATE(1276),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1276),
    [sym_new_expression] = STATE(1276),
    [sym_await_expression] = STATE(1276),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1276),
    [sym_augmented_assignment_expression] = STATE(1276),
    [sym_ternary_expression] = STATE(1276),
    [sym_binary_expression] = STATE(1276),
    [sym_unary_expression] = STATE(1276),
    [sym_update_expression] = STATE(1276),
    [sym_string] = STATE(1276),
    [sym_template_string] = STATE(1276),
    [sym_regex] = STATE(1276),
    [sym_meta_property] = STATE(1276),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1276),
    [sym_as_expression] = STATE(1276),
    [sym_internal_module] = STATE(1276),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_COLON] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(630),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [110] = {
    [sym_import] = STATE(1294),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1294),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1294),
    [sym_jsx_fragment] = STATE(1294),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1294),
    [sym_class] = STATE(1294),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1294),
    [sym_arrow_function] = STATE(1294),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1294),
    [sym_new_expression] = STATE(1294),
    [sym_await_expression] = STATE(1294),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1294),
    [sym_augmented_assignment_expression] = STATE(1294),
    [sym_ternary_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_update_expression] = STATE(1294),
    [sym_string] = STATE(1294),
    [sym_template_string] = STATE(1294),
    [sym_regex] = STATE(1294),
    [sym_meta_property] = STATE(1294),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1294),
    [sym_as_expression] = STATE(1294),
    [sym_internal_module] = STATE(1294),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(778),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1079),
    [sym_this] = ACTIONS(1081),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1081),
    [sym_false] = ACTIONS(1081),
    [sym_null] = ACTIONS(1081),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [anon_sym_implements] = ACTIONS(1023),
    [sym_readonly] = ACTIONS(756),
  },
  [111] = {
    [sym_import] = STATE(1358),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1358),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1358),
    [sym_jsx_fragment] = STATE(1358),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1358),
    [sym_class] = STATE(1358),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1358),
    [sym_arrow_function] = STATE(1358),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1358),
    [sym_new_expression] = STATE(1358),
    [sym_await_expression] = STATE(1358),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1358),
    [sym_augmented_assignment_expression] = STATE(1358),
    [sym_ternary_expression] = STATE(1358),
    [sym_binary_expression] = STATE(1358),
    [sym_unary_expression] = STATE(1358),
    [sym_update_expression] = STATE(1358),
    [sym_string] = STATE(1358),
    [sym_template_string] = STATE(1358),
    [sym_regex] = STATE(1358),
    [sym_meta_property] = STATE(1358),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1358),
    [sym_as_expression] = STATE(1358),
    [sym_internal_module] = STATE(1358),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(684),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1085),
    [sym_this] = ACTIONS(1087),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1087),
    [sym_false] = ACTIONS(1087),
    [sym_null] = ACTIONS(1087),
    [sym_undefined] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
    [sym__automatic_semicolon] = ACTIONS(1025),
  },
  [112] = {
    [sym_import] = STATE(1315),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1315),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1315),
    [sym_jsx_fragment] = STATE(1315),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1315),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1315),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1315),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1315),
    [sym_augmented_assignment_expression] = STATE(1315),
    [sym_ternary_expression] = STATE(1315),
    [sym_binary_expression] = STATE(1315),
    [sym_unary_expression] = STATE(1315),
    [sym_update_expression] = STATE(1315),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1315),
    [sym_as_expression] = STATE(1315),
    [sym_internal_module] = STATE(1315),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_as] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(718),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_STAR_STAR] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1023),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1023),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1023),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1091),
    [sym_this] = ACTIONS(1093),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1093),
    [sym_false] = ACTIONS(1093),
    [sym_null] = ACTIONS(1093),
    [sym_undefined] = ACTIONS(1093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1025),
  },
  [113] = {
    [sym_statement_block] = STATE(126),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_default] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_var] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_for] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1097),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_do] = ACTIONS(1097),
    [anon_sym_try] = ACTIONS(1097),
    [anon_sym_with] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [anon_sym_debugger] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_throw] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1097),
    [anon_sym_yield] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1101),
    [anon_sym_class] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_number] = ACTIONS(1095),
    [sym_this] = ACTIONS(1097),
    [sym_super] = ACTIONS(1097),
    [sym_true] = ACTIONS(1097),
    [sym_false] = ACTIONS(1097),
    [sym_null] = ACTIONS(1097),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_abstract] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_interface] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [sym_readonly] = ACTIONS(1097),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [114] = {
    [sym_statement_block] = STATE(126),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_default] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_var] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_for] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1097),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_do] = ACTIONS(1097),
    [anon_sym_try] = ACTIONS(1097),
    [anon_sym_with] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [anon_sym_debugger] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_throw] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1097),
    [anon_sym_yield] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1097),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_number] = ACTIONS(1095),
    [sym_this] = ACTIONS(1097),
    [sym_super] = ACTIONS(1097),
    [sym_true] = ACTIONS(1097),
    [sym_false] = ACTIONS(1097),
    [sym_null] = ACTIONS(1097),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_abstract] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_interface] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [sym_readonly] = ACTIONS(1097),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_default] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_typeof] = ACTIONS(1105),
    [anon_sym_import] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_let] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1105),
    [anon_sym_try] = ACTIONS(1105),
    [anon_sym_with] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1105),
    [anon_sym_continue] = ACTIONS(1105),
    [anon_sym_debugger] = ACTIONS(1105),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_case] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(1105),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_function] = ACTIONS(1105),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1107),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_delete] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym_number] = ACTIONS(1103),
    [sym_this] = ACTIONS(1105),
    [sym_super] = ACTIONS(1105),
    [sym_true] = ACTIONS(1105),
    [sym_false] = ACTIONS(1105),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_static] = ACTIONS(1105),
    [anon_sym_abstract] = ACTIONS(1105),
    [anon_sym_get] = ACTIONS(1105),
    [anon_sym_set] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1105),
    [anon_sym_private] = ACTIONS(1105),
    [anon_sym_protected] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1105),
    [anon_sym_any] = ACTIONS(1105),
    [anon_sym_number] = ACTIONS(1105),
    [anon_sym_boolean] = ACTIONS(1105),
    [anon_sym_string] = ACTIONS(1105),
    [anon_sym_symbol] = ACTIONS(1105),
    [anon_sym_interface] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [sym_readonly] = ACTIONS(1105),
    [sym__automatic_semicolon] = ACTIONS(1111),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_default] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(1117),
    [anon_sym_namespace] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1115),
    [anon_sym_typeof] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1115),
    [anon_sym_var] = ACTIONS(1115),
    [anon_sym_let] = ACTIONS(1115),
    [anon_sym_const] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_switch] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_await] = ACTIONS(1115),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_do] = ACTIONS(1115),
    [anon_sym_try] = ACTIONS(1115),
    [anon_sym_with] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_debugger] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_throw] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1113),
    [anon_sym_case] = ACTIONS(1115),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_DOT] = ACTIONS(1117),
    [anon_sym_class] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_function] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1119),
    [anon_sym_LT_LT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_STAR_STAR] = ACTIONS(1119),
    [anon_sym_LT_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1119),
    [anon_sym_GT_EQ] = ACTIONS(1119),
    [anon_sym_instanceof] = ACTIONS(1117),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1113),
    [anon_sym_void] = ACTIONS(1115),
    [anon_sym_delete] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym_number] = ACTIONS(1113),
    [sym_this] = ACTIONS(1115),
    [sym_super] = ACTIONS(1115),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_undefined] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1113),
    [anon_sym_static] = ACTIONS(1115),
    [anon_sym_abstract] = ACTIONS(1115),
    [anon_sym_get] = ACTIONS(1115),
    [anon_sym_set] = ACTIONS(1115),
    [anon_sym_declare] = ACTIONS(1115),
    [anon_sym_public] = ACTIONS(1115),
    [anon_sym_private] = ACTIONS(1115),
    [anon_sym_protected] = ACTIONS(1115),
    [anon_sym_module] = ACTIONS(1115),
    [anon_sym_any] = ACTIONS(1115),
    [anon_sym_number] = ACTIONS(1115),
    [anon_sym_boolean] = ACTIONS(1115),
    [anon_sym_string] = ACTIONS(1115),
    [anon_sym_symbol] = ACTIONS(1115),
    [anon_sym_interface] = ACTIONS(1115),
    [anon_sym_enum] = ACTIONS(1115),
    [sym_readonly] = ACTIONS(1115),
    [sym__automatic_semicolon] = ACTIONS(1121),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(1123),
    [sym_identifier] = ACTIONS(1125),
    [anon_sym_export] = ACTIONS(1125),
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1129),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_type] = ACTIONS(1125),
    [anon_sym_typeof] = ACTIONS(1125),
    [anon_sym_import] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(1125),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_const] = ACTIONS(1125),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_else] = ACTIONS(1125),
    [anon_sym_switch] = ACTIONS(1125),
    [anon_sym_for] = ACTIONS(1125),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_await] = ACTIONS(1125),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_with] = ACTIONS(1125),
    [anon_sym_break] = ACTIONS(1125),
    [anon_sym_continue] = ACTIONS(1125),
    [anon_sym_debugger] = ACTIONS(1125),
    [anon_sym_return] = ACTIONS(1125),
    [anon_sym_throw] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_yield] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_class] = ACTIONS(1125),
    [anon_sym_async] = ACTIONS(1125),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_new] = ACTIONS(1125),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1127),
    [anon_sym_GT_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_STAR_STAR] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1129),
    [anon_sym_instanceof] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym_number] = ACTIONS(1123),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1125),
    [anon_sym_abstract] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1125),
    [anon_sym_set] = ACTIONS(1125),
    [anon_sym_declare] = ACTIONS(1125),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_module] = ACTIONS(1125),
    [anon_sym_any] = ACTIONS(1125),
    [anon_sym_number] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1125),
    [anon_sym_symbol] = ACTIONS(1125),
    [anon_sym_interface] = ACTIONS(1125),
    [anon_sym_enum] = ACTIONS(1125),
    [sym_readonly] = ACTIONS(1125),
    [sym__automatic_semicolon] = ACTIONS(1131),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(1137),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(1139),
    [sym_identifier] = ACTIONS(1141),
    [anon_sym_export] = ACTIONS(1141),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_default] = ACTIONS(1141),
    [anon_sym_as] = ACTIONS(1143),
    [anon_sym_namespace] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_type] = ACTIONS(1141),
    [anon_sym_typeof] = ACTIONS(1141),
    [anon_sym_import] = ACTIONS(1141),
    [anon_sym_var] = ACTIONS(1141),
    [anon_sym_let] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_else] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1139),
    [anon_sym_await] = ACTIONS(1141),
    [anon_sym_in] = ACTIONS(1143),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_do] = ACTIONS(1141),
    [anon_sym_try] = ACTIONS(1141),
    [anon_sym_with] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_debugger] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym_case] = ACTIONS(1141),
    [anon_sym_yield] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [anon_sym_LT] = ACTIONS(1141),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_SLASH] = ACTIONS(1141),
    [anon_sym_DOT] = ACTIONS(1143),
    [anon_sym_class] = ACTIONS(1141),
    [anon_sym_async] = ACTIONS(1141),
    [anon_sym_function] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1141),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AMP_AMP] = ACTIONS(1145),
    [anon_sym_PIPE_PIPE] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [anon_sym_GT_GT_GT] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_STAR_STAR] = ACTIONS(1145),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1143),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_instanceof] = ACTIONS(1143),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1141),
    [anon_sym_delete] = ACTIONS(1141),
    [anon_sym_PLUS_PLUS] = ACTIONS(1139),
    [anon_sym_DASH_DASH] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1139),
    [sym_number] = ACTIONS(1139),
    [sym_this] = ACTIONS(1141),
    [sym_super] = ACTIONS(1141),
    [sym_true] = ACTIONS(1141),
    [sym_false] = ACTIONS(1141),
    [sym_null] = ACTIONS(1141),
    [sym_undefined] = ACTIONS(1141),
    [anon_sym_AT] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1141),
    [anon_sym_abstract] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(1141),
    [anon_sym_set] = ACTIONS(1141),
    [anon_sym_declare] = ACTIONS(1141),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_module] = ACTIONS(1141),
    [anon_sym_any] = ACTIONS(1141),
    [anon_sym_number] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1141),
    [anon_sym_symbol] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [sym_readonly] = ACTIONS(1141),
    [sym__automatic_semicolon] = ACTIONS(1147),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_export] = ACTIONS(1151),
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_default] = ACTIONS(1151),
    [anon_sym_as] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(1151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_import] = ACTIONS(1151),
    [anon_sym_var] = ACTIONS(1151),
    [anon_sym_let] = ACTIONS(1151),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1151),
    [anon_sym_else] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1151),
    [anon_sym_for] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1151),
    [anon_sym_in] = ACTIONS(1151),
    [anon_sym_while] = ACTIONS(1151),
    [anon_sym_do] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1151),
    [anon_sym_with] = ACTIONS(1151),
    [anon_sym_break] = ACTIONS(1151),
    [anon_sym_continue] = ACTIONS(1151),
    [anon_sym_debugger] = ACTIONS(1151),
    [anon_sym_return] = ACTIONS(1151),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1151),
    [anon_sym_yield] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_class] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(1151),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_AMP_AMP] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1149),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_GT_GT_GT] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_CARET] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_PERCENT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1149),
    [anon_sym_GT_EQ] = ACTIONS(1149),
    [anon_sym_instanceof] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1149),
    [anon_sym_void] = ACTIONS(1151),
    [anon_sym_delete] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_SQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym_number] = ACTIONS(1149),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(1151),
    [sym_true] = ACTIONS(1151),
    [sym_false] = ACTIONS(1151),
    [sym_null] = ACTIONS(1151),
    [sym_undefined] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1151),
    [anon_sym_abstract] = ACTIONS(1151),
    [anon_sym_get] = ACTIONS(1151),
    [anon_sym_set] = ACTIONS(1151),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1151),
    [anon_sym_private] = ACTIONS(1151),
    [anon_sym_protected] = ACTIONS(1151),
    [anon_sym_module] = ACTIONS(1151),
    [anon_sym_any] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1151),
    [anon_sym_boolean] = ACTIONS(1151),
    [anon_sym_string] = ACTIONS(1151),
    [anon_sym_symbol] = ACTIONS(1151),
    [anon_sym_interface] = ACTIONS(1151),
    [anon_sym_enum] = ACTIONS(1151),
    [sym_readonly] = ACTIONS(1151),
    [sym__automatic_semicolon] = ACTIONS(1149),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(1153),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(1155),
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_default] = ACTIONS(1155),
    [anon_sym_as] = ACTIONS(1157),
    [anon_sym_namespace] = ACTIONS(1155),
    [anon_sym_LBRACE] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_type] = ACTIONS(1155),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(1155),
    [anon_sym_let] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1155),
    [anon_sym_else] = ACTIONS(1155),
    [anon_sym_switch] = ACTIONS(1155),
    [anon_sym_for] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_await] = ACTIONS(1155),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_do] = ACTIONS(1155),
    [anon_sym_try] = ACTIONS(1155),
    [anon_sym_with] = ACTIONS(1155),
    [anon_sym_break] = ACTIONS(1155),
    [anon_sym_continue] = ACTIONS(1155),
    [anon_sym_debugger] = ACTIONS(1155),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_throw] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym_case] = ACTIONS(1155),
    [anon_sym_yield] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_class] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1155),
    [anon_sym_function] = ACTIONS(1155),
    [anon_sym_new] = ACTIONS(1155),
    [anon_sym_QMARK] = ACTIONS(1159),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_instanceof] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_DQUOTE] = ACTIONS(1153),
    [anon_sym_SQUOTE] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1153),
    [sym_number] = ACTIONS(1153),
    [sym_this] = ACTIONS(1155),
    [sym_super] = ACTIONS(1155),
    [sym_true] = ACTIONS(1155),
    [sym_false] = ACTIONS(1155),
    [sym_null] = ACTIONS(1155),
    [sym_undefined] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1153),
    [anon_sym_static] = ACTIONS(1155),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_get] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1155),
    [anon_sym_declare] = ACTIONS(1155),
    [anon_sym_public] = ACTIONS(1155),
    [anon_sym_private] = ACTIONS(1155),
    [anon_sym_protected] = ACTIONS(1155),
    [anon_sym_module] = ACTIONS(1155),
    [anon_sym_any] = ACTIONS(1155),
    [anon_sym_number] = ACTIONS(1155),
    [anon_sym_boolean] = ACTIONS(1155),
    [anon_sym_string] = ACTIONS(1155),
    [anon_sym_symbol] = ACTIONS(1155),
    [anon_sym_interface] = ACTIONS(1155),
    [anon_sym_enum] = ACTIONS(1155),
    [sym_readonly] = ACTIONS(1155),
    [sym__automatic_semicolon] = ACTIONS(1161),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_export] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1165),
    [anon_sym_namespace] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1165),
    [anon_sym_typeof] = ACTIONS(1165),
    [anon_sym_import] = ACTIONS(1165),
    [anon_sym_var] = ACTIONS(1165),
    [anon_sym_let] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_try] = ACTIONS(1165),
    [anon_sym_with] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_debugger] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_class] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_new] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_instanceof] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_void] = ACTIONS(1165),
    [anon_sym_delete] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [sym_number] = ACTIONS(1163),
    [sym_this] = ACTIONS(1165),
    [sym_super] = ACTIONS(1165),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_null] = ACTIONS(1165),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_abstract] = ACTIONS(1165),
    [anon_sym_get] = ACTIONS(1165),
    [anon_sym_set] = ACTIONS(1165),
    [anon_sym_declare] = ACTIONS(1165),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_module] = ACTIONS(1165),
    [anon_sym_any] = ACTIONS(1165),
    [anon_sym_number] = ACTIONS(1165),
    [anon_sym_boolean] = ACTIONS(1165),
    [anon_sym_string] = ACTIONS(1165),
    [anon_sym_symbol] = ACTIONS(1165),
    [anon_sym_interface] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [sym_readonly] = ACTIONS(1165),
    [sym__automatic_semicolon] = ACTIONS(1163),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1167),
    [sym_identifier] = ACTIONS(1169),
    [anon_sym_export] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_as] = ACTIONS(1169),
    [anon_sym_namespace] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_type] = ACTIONS(1169),
    [anon_sym_typeof] = ACTIONS(1169),
    [anon_sym_import] = ACTIONS(1169),
    [anon_sym_var] = ACTIONS(1169),
    [anon_sym_let] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_await] = ACTIONS(1169),
    [anon_sym_in] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_do] = ACTIONS(1169),
    [anon_sym_try] = ACTIONS(1169),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [anon_sym_debugger] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_throw] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_yield] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1169),
    [anon_sym_function] = ACTIONS(1169),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_TILDE] = ACTIONS(1167),
    [anon_sym_void] = ACTIONS(1169),
    [anon_sym_delete] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1167),
    [sym_this] = ACTIONS(1169),
    [sym_super] = ACTIONS(1169),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [sym_null] = ACTIONS(1169),
    [sym_undefined] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1167),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_abstract] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(1169),
    [anon_sym_set] = ACTIONS(1169),
    [anon_sym_declare] = ACTIONS(1169),
    [anon_sym_public] = ACTIONS(1169),
    [anon_sym_private] = ACTIONS(1169),
    [anon_sym_protected] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1169),
    [anon_sym_any] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_boolean] = ACTIONS(1169),
    [anon_sym_string] = ACTIONS(1169),
    [anon_sym_symbol] = ACTIONS(1169),
    [anon_sym_interface] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [sym_readonly] = ACTIONS(1169),
    [sym__automatic_semicolon] = ACTIONS(1167),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1171),
    [sym_identifier] = ACTIONS(1173),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1175),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_typeof] = ACTIONS(1173),
    [anon_sym_import] = ACTIONS(1173),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_let] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_await] = ACTIONS(1173),
    [anon_sym_in] = ACTIONS(1175),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_try] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_debugger] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_throw] = ACTIONS(1173),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1175),
    [anon_sym_class] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1173),
    [anon_sym_new] = ACTIONS(1173),
    [anon_sym_QMARK] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(1175),
    [anon_sym_GT_GT_GT] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1177),
    [anon_sym_STAR_STAR] = ACTIONS(1177),
    [anon_sym_LT_EQ] = ACTIONS(1177),
    [anon_sym_EQ_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1177),
    [anon_sym_BANG_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1177),
    [anon_sym_GT_EQ] = ACTIONS(1177),
    [anon_sym_instanceof] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_delete] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [sym_number] = ACTIONS(1171),
    [sym_this] = ACTIONS(1173),
    [sym_super] = ACTIONS(1173),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_AT] = ACTIONS(1171),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_abstract] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_interface] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [sym_readonly] = ACTIONS(1173),
    [sym__automatic_semicolon] = ACTIONS(1179),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1181),
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_export] = ACTIONS(1183),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1183),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1183),
    [anon_sym_typeof] = ACTIONS(1183),
    [anon_sym_import] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(1183),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_const] = ACTIONS(1183),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_switch] = ACTIONS(1183),
    [anon_sym_for] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_try] = ACTIONS(1183),
    [anon_sym_with] = ACTIONS(1183),
    [anon_sym_break] = ACTIONS(1183),
    [anon_sym_continue] = ACTIONS(1183),
    [anon_sym_debugger] = ACTIONS(1183),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_throw] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1183),
    [anon_sym_async] = ACTIONS(1183),
    [anon_sym_function] = ACTIONS(1183),
    [anon_sym_new] = ACTIONS(1183),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1181),
    [anon_sym_void] = ACTIONS(1183),
    [anon_sym_delete] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [sym_number] = ACTIONS(1181),
    [sym_this] = ACTIONS(1183),
    [sym_super] = ACTIONS(1183),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_AT] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1183),
    [anon_sym_abstract] = ACTIONS(1183),
    [anon_sym_get] = ACTIONS(1183),
    [anon_sym_set] = ACTIONS(1183),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(1183),
    [anon_sym_private] = ACTIONS(1183),
    [anon_sym_protected] = ACTIONS(1183),
    [anon_sym_module] = ACTIONS(1183),
    [anon_sym_any] = ACTIONS(1183),
    [anon_sym_number] = ACTIONS(1183),
    [anon_sym_boolean] = ACTIONS(1183),
    [anon_sym_string] = ACTIONS(1183),
    [anon_sym_symbol] = ACTIONS(1183),
    [anon_sym_interface] = ACTIONS(1183),
    [anon_sym_enum] = ACTIONS(1183),
    [sym_readonly] = ACTIONS(1183),
    [sym__automatic_semicolon] = ACTIONS(1181),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [sym_identifier] = ACTIONS(1187),
    [anon_sym_export] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_as] = ACTIONS(1189),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1191),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1187),
    [anon_sym_import] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(1187),
    [anon_sym_let] = ACTIONS(1187),
    [anon_sym_const] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_for] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1187),
    [anon_sym_in] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_do] = ACTIONS(1187),
    [anon_sym_try] = ACTIONS(1187),
    [anon_sym_with] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_continue] = ACTIONS(1187),
    [anon_sym_debugger] = ACTIONS(1187),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1187),
    [anon_sym_yield] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1189),
    [anon_sym_class] = ACTIONS(1187),
    [anon_sym_async] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(1187),
    [anon_sym_new] = ACTIONS(1187),
    [anon_sym_QMARK] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_GT_GT_GT] = ACTIONS(1191),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1191),
    [anon_sym_STAR_STAR] = ACTIONS(1191),
    [anon_sym_LT_EQ] = ACTIONS(1191),
    [anon_sym_EQ_EQ] = ACTIONS(1189),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1191),
    [anon_sym_BANG_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1191),
    [anon_sym_GT_EQ] = ACTIONS(1191),
    [anon_sym_instanceof] = ACTIONS(1189),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_TILDE] = ACTIONS(1185),
    [anon_sym_void] = ACTIONS(1187),
    [anon_sym_delete] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym_number] = ACTIONS(1185),
    [sym_this] = ACTIONS(1187),
    [sym_super] = ACTIONS(1187),
    [sym_true] = ACTIONS(1187),
    [sym_false] = ACTIONS(1187),
    [sym_null] = ACTIONS(1187),
    [sym_undefined] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1187),
    [anon_sym_abstract] = ACTIONS(1187),
    [anon_sym_get] = ACTIONS(1187),
    [anon_sym_set] = ACTIONS(1187),
    [anon_sym_declare] = ACTIONS(1187),
    [anon_sym_public] = ACTIONS(1187),
    [anon_sym_private] = ACTIONS(1187),
    [anon_sym_protected] = ACTIONS(1187),
    [anon_sym_module] = ACTIONS(1187),
    [anon_sym_any] = ACTIONS(1187),
    [anon_sym_number] = ACTIONS(1187),
    [anon_sym_boolean] = ACTIONS(1187),
    [anon_sym_string] = ACTIONS(1187),
    [anon_sym_symbol] = ACTIONS(1187),
    [anon_sym_interface] = ACTIONS(1187),
    [anon_sym_enum] = ACTIONS(1187),
    [sym_readonly] = ACTIONS(1187),
    [sym__automatic_semicolon] = ACTIONS(1193),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(1197),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_in] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1197),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1197),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
    [sym__automatic_semicolon] = ACTIONS(1195),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1203),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1203),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym_readonly] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1207),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1211),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_default] = ACTIONS(1211),
    [anon_sym_as] = ACTIONS(1211),
    [anon_sym_namespace] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_type] = ACTIONS(1211),
    [anon_sym_typeof] = ACTIONS(1211),
    [anon_sym_import] = ACTIONS(1211),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1211),
    [anon_sym_const] = ACTIONS(1211),
    [anon_sym_if] = ACTIONS(1211),
    [anon_sym_else] = ACTIONS(1211),
    [anon_sym_switch] = ACTIONS(1211),
    [anon_sym_for] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_await] = ACTIONS(1211),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_while] = ACTIONS(1211),
    [anon_sym_do] = ACTIONS(1211),
    [anon_sym_try] = ACTIONS(1211),
    [anon_sym_with] = ACTIONS(1211),
    [anon_sym_break] = ACTIONS(1211),
    [anon_sym_continue] = ACTIONS(1211),
    [anon_sym_debugger] = ACTIONS(1211),
    [anon_sym_return] = ACTIONS(1211),
    [anon_sym_throw] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1211),
    [anon_sym_yield] = ACTIONS(1211),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_DOT] = ACTIONS(1211),
    [anon_sym_class] = ACTIONS(1211),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_function] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1211),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1211),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_void] = ACTIONS(1211),
    [anon_sym_delete] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym_number] = ACTIONS(1209),
    [sym_this] = ACTIONS(1211),
    [sym_super] = ACTIONS(1211),
    [sym_true] = ACTIONS(1211),
    [sym_false] = ACTIONS(1211),
    [sym_null] = ACTIONS(1211),
    [sym_undefined] = ACTIONS(1211),
    [anon_sym_AT] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1211),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1211),
    [anon_sym_declare] = ACTIONS(1211),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_module] = ACTIONS(1211),
    [anon_sym_any] = ACTIONS(1211),
    [anon_sym_number] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1211),
    [anon_sym_symbol] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1211),
    [anon_sym_enum] = ACTIONS(1211),
    [sym_readonly] = ACTIONS(1211),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_default] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1215),
    [anon_sym_namespace] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1215),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_let] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_do] = ACTIONS(1215),
    [anon_sym_try] = ACTIONS(1215),
    [anon_sym_with] = ACTIONS(1215),
    [anon_sym_break] = ACTIONS(1215),
    [anon_sym_continue] = ACTIONS(1215),
    [anon_sym_debugger] = ACTIONS(1215),
    [anon_sym_return] = ACTIONS(1215),
    [anon_sym_throw] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1215),
    [anon_sym_yield] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_class] = ACTIONS(1215),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(1215),
    [anon_sym_new] = ACTIONS(1215),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_AMP_AMP] = ACTIONS(1213),
    [anon_sym_PIPE_PIPE] = ACTIONS(1213),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1213),
    [anon_sym_LT_LT] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1213),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1213),
    [anon_sym_STAR_STAR] = ACTIONS(1213),
    [anon_sym_LT_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1213),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [anon_sym_instanceof] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1213),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [sym_number] = ACTIONS(1213),
    [sym_this] = ACTIONS(1215),
    [sym_super] = ACTIONS(1215),
    [sym_true] = ACTIONS(1215),
    [sym_false] = ACTIONS(1215),
    [sym_null] = ACTIONS(1215),
    [sym_undefined] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1215),
    [anon_sym_abstract] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(1215),
    [anon_sym_set] = ACTIONS(1215),
    [anon_sym_declare] = ACTIONS(1215),
    [anon_sym_public] = ACTIONS(1215),
    [anon_sym_private] = ACTIONS(1215),
    [anon_sym_protected] = ACTIONS(1215),
    [anon_sym_module] = ACTIONS(1215),
    [anon_sym_any] = ACTIONS(1215),
    [anon_sym_number] = ACTIONS(1215),
    [anon_sym_boolean] = ACTIONS(1215),
    [anon_sym_string] = ACTIONS(1215),
    [anon_sym_symbol] = ACTIONS(1215),
    [anon_sym_interface] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [sym_readonly] = ACTIONS(1215),
    [sym__automatic_semicolon] = ACTIONS(1213),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1217),
    [sym_identifier] = ACTIONS(1219),
    [anon_sym_export] = ACTIONS(1219),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_default] = ACTIONS(1219),
    [anon_sym_as] = ACTIONS(1221),
    [anon_sym_namespace] = ACTIONS(1219),
    [anon_sym_LBRACE] = ACTIONS(1217),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1217),
    [anon_sym_type] = ACTIONS(1219),
    [anon_sym_typeof] = ACTIONS(1219),
    [anon_sym_import] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1219),
    [anon_sym_let] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_if] = ACTIONS(1219),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_switch] = ACTIONS(1219),
    [anon_sym_for] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1219),
    [anon_sym_do] = ACTIONS(1219),
    [anon_sym_try] = ACTIONS(1219),
    [anon_sym_with] = ACTIONS(1219),
    [anon_sym_break] = ACTIONS(1219),
    [anon_sym_continue] = ACTIONS(1219),
    [anon_sym_debugger] = ACTIONS(1219),
    [anon_sym_return] = ACTIONS(1219),
    [anon_sym_throw] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1217),
    [anon_sym_case] = ACTIONS(1219),
    [anon_sym_yield] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1217),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1219),
    [anon_sym_DOT] = ACTIONS(1221),
    [anon_sym_class] = ACTIONS(1219),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_function] = ACTIONS(1219),
    [anon_sym_new] = ACTIONS(1219),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1219),
    [anon_sym_DASH] = ACTIONS(1219),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1217),
    [anon_sym_void] = ACTIONS(1219),
    [anon_sym_delete] = ACTIONS(1219),
    [anon_sym_PLUS_PLUS] = ACTIONS(1217),
    [anon_sym_DASH_DASH] = ACTIONS(1217),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [anon_sym_SQUOTE] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1217),
    [sym_number] = ACTIONS(1217),
    [sym_this] = ACTIONS(1219),
    [sym_super] = ACTIONS(1219),
    [sym_true] = ACTIONS(1219),
    [sym_false] = ACTIONS(1219),
    [sym_null] = ACTIONS(1219),
    [sym_undefined] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(1217),
    [anon_sym_static] = ACTIONS(1219),
    [anon_sym_abstract] = ACTIONS(1219),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
    [anon_sym_declare] = ACTIONS(1219),
    [anon_sym_public] = ACTIONS(1219),
    [anon_sym_private] = ACTIONS(1219),
    [anon_sym_protected] = ACTIONS(1219),
    [anon_sym_module] = ACTIONS(1219),
    [anon_sym_any] = ACTIONS(1219),
    [anon_sym_number] = ACTIONS(1219),
    [anon_sym_boolean] = ACTIONS(1219),
    [anon_sym_string] = ACTIONS(1219),
    [anon_sym_symbol] = ACTIONS(1219),
    [anon_sym_interface] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [sym_readonly] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_export] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_default] = ACTIONS(1227),
    [anon_sym_as] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_type] = ACTIONS(1227),
    [anon_sym_typeof] = ACTIONS(1227),
    [anon_sym_import] = ACTIONS(1227),
    [anon_sym_var] = ACTIONS(1227),
    [anon_sym_let] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1227),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_await] = ACTIONS(1227),
    [anon_sym_in] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_try] = ACTIONS(1227),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_debugger] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_throw] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1229),
    [anon_sym_class] = ACTIONS(1227),
    [anon_sym_async] = ACTIONS(1227),
    [anon_sym_function] = ACTIONS(1227),
    [anon_sym_new] = ACTIONS(1227),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_TILDE] = ACTIONS(1225),
    [anon_sym_void] = ACTIONS(1227),
    [anon_sym_delete] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1225),
    [sym_this] = ACTIONS(1227),
    [sym_super] = ACTIONS(1227),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [sym_null] = ACTIONS(1227),
    [sym_undefined] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(1225),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_abstract] = ACTIONS(1227),
    [anon_sym_get] = ACTIONS(1227),
    [anon_sym_set] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1227),
    [anon_sym_public] = ACTIONS(1227),
    [anon_sym_private] = ACTIONS(1227),
    [anon_sym_protected] = ACTIONS(1227),
    [anon_sym_module] = ACTIONS(1227),
    [anon_sym_any] = ACTIONS(1227),
    [anon_sym_number] = ACTIONS(1227),
    [anon_sym_boolean] = ACTIONS(1227),
    [anon_sym_string] = ACTIONS(1227),
    [anon_sym_symbol] = ACTIONS(1227),
    [anon_sym_interface] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [sym_readonly] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_export] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1237),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_typeof] = ACTIONS(1237),
    [anon_sym_import] = ACTIONS(1237),
    [anon_sym_var] = ACTIONS(1237),
    [anon_sym_let] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_await] = ACTIONS(1237),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_try] = ACTIONS(1237),
    [anon_sym_with] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_debugger] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_yield] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1237),
    [anon_sym_function] = ACTIONS(1237),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_void] = ACTIONS(1237),
    [anon_sym_delete] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [sym_number] = ACTIONS(1235),
    [sym_this] = ACTIONS(1237),
    [sym_super] = ACTIONS(1237),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [sym_null] = ACTIONS(1237),
    [sym_undefined] = ACTIONS(1237),
    [anon_sym_AT] = ACTIONS(1235),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_abstract] = ACTIONS(1237),
    [anon_sym_get] = ACTIONS(1237),
    [anon_sym_set] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_protected] = ACTIONS(1237),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_any] = ACTIONS(1237),
    [anon_sym_number] = ACTIONS(1237),
    [anon_sym_boolean] = ACTIONS(1237),
    [anon_sym_string] = ACTIONS(1237),
    [anon_sym_symbol] = ACTIONS(1237),
    [anon_sym_interface] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [sym_readonly] = ACTIONS(1237),
    [sym__automatic_semicolon] = ACTIONS(1235),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_default] = ACTIONS(1105),
    [anon_sym_as] = ACTIONS(1105),
    [anon_sym_namespace] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_typeof] = ACTIONS(1105),
    [anon_sym_import] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_let] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1105),
    [anon_sym_try] = ACTIONS(1105),
    [anon_sym_with] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1105),
    [anon_sym_continue] = ACTIONS(1105),
    [anon_sym_debugger] = ACTIONS(1105),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_case] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_class] = ACTIONS(1105),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_function] = ACTIONS(1105),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_delete] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym_number] = ACTIONS(1103),
    [sym_this] = ACTIONS(1105),
    [sym_super] = ACTIONS(1105),
    [sym_true] = ACTIONS(1105),
    [sym_false] = ACTIONS(1105),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_static] = ACTIONS(1105),
    [anon_sym_abstract] = ACTIONS(1105),
    [anon_sym_get] = ACTIONS(1105),
    [anon_sym_set] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1105),
    [anon_sym_private] = ACTIONS(1105),
    [anon_sym_protected] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1105),
    [anon_sym_any] = ACTIONS(1105),
    [anon_sym_number] = ACTIONS(1105),
    [anon_sym_boolean] = ACTIONS(1105),
    [anon_sym_string] = ACTIONS(1105),
    [anon_sym_symbol] = ACTIONS(1105),
    [anon_sym_interface] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [sym_readonly] = ACTIONS(1105),
    [sym__automatic_semicolon] = ACTIONS(1239),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(1241),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(1243),
    [anon_sym_STAR] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1243),
    [anon_sym_as] = ACTIONS(1245),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(1243),
    [anon_sym_import] = ACTIONS(1243),
    [anon_sym_var] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1243),
    [anon_sym_const] = ACTIONS(1243),
    [anon_sym_if] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1243),
    [anon_sym_switch] = ACTIONS(1243),
    [anon_sym_for] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_await] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1243),
    [anon_sym_do] = ACTIONS(1243),
    [anon_sym_try] = ACTIONS(1243),
    [anon_sym_with] = ACTIONS(1243),
    [anon_sym_break] = ACTIONS(1243),
    [anon_sym_continue] = ACTIONS(1243),
    [anon_sym_debugger] = ACTIONS(1243),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_throw] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_DOT] = ACTIONS(1245),
    [anon_sym_class] = ACTIONS(1243),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1243),
    [anon_sym_new] = ACTIONS(1243),
    [anon_sym_QMARK] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_GT_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_CARET] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_PERCENT] = ACTIONS(1247),
    [anon_sym_STAR_STAR] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1247),
    [anon_sym_EQ_EQ] = ACTIONS(1245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1247),
    [anon_sym_GT_EQ] = ACTIONS(1247),
    [anon_sym_instanceof] = ACTIONS(1245),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1243),
    [anon_sym_delete] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1241),
    [anon_sym_SQUOTE] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_super] = ACTIONS(1243),
    [sym_true] = ACTIONS(1243),
    [sym_false] = ACTIONS(1243),
    [sym_null] = ACTIONS(1243),
    [sym_undefined] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1243),
    [anon_sym_abstract] = ACTIONS(1243),
    [anon_sym_get] = ACTIONS(1243),
    [anon_sym_set] = ACTIONS(1243),
    [anon_sym_declare] = ACTIONS(1243),
    [anon_sym_public] = ACTIONS(1243),
    [anon_sym_private] = ACTIONS(1243),
    [anon_sym_protected] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1243),
    [anon_sym_any] = ACTIONS(1243),
    [anon_sym_number] = ACTIONS(1243),
    [anon_sym_boolean] = ACTIONS(1243),
    [anon_sym_string] = ACTIONS(1243),
    [anon_sym_symbol] = ACTIONS(1243),
    [anon_sym_interface] = ACTIONS(1243),
    [anon_sym_enum] = ACTIONS(1243),
    [sym_readonly] = ACTIONS(1243),
    [sym__automatic_semicolon] = ACTIONS(1249),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(1251),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_as] = ACTIONS(1255),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_var] = ACTIONS(1253),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_in] = ACTIONS(1255),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_with] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_debugger] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1255),
    [anon_sym_class] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1253),
    [anon_sym_new] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_GT_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1253),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [sym_number] = ACTIONS(1251),
    [sym_this] = ACTIONS(1253),
    [sym_super] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_null] = ACTIONS(1253),
    [sym_undefined] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1251),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_interface] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [sym_readonly] = ACTIONS(1253),
    [sym__automatic_semicolon] = ACTIONS(1259),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(1261),
    [sym_identifier] = ACTIONS(1263),
    [anon_sym_export] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_as] = ACTIONS(1265),
    [anon_sym_namespace] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_type] = ACTIONS(1263),
    [anon_sym_typeof] = ACTIONS(1263),
    [anon_sym_import] = ACTIONS(1263),
    [anon_sym_var] = ACTIONS(1263),
    [anon_sym_let] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [anon_sym_await] = ACTIONS(1263),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1263),
    [anon_sym_with] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_debugger] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_throw] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_yield] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1265),
    [anon_sym_class] = ACTIONS(1263),
    [anon_sym_async] = ACTIONS(1263),
    [anon_sym_function] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_QMARK] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_GT_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1267),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1267),
    [anon_sym_GT_EQ] = ACTIONS(1267),
    [anon_sym_instanceof] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_void] = ACTIONS(1263),
    [anon_sym_delete] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [sym_number] = ACTIONS(1261),
    [sym_this] = ACTIONS(1263),
    [sym_super] = ACTIONS(1263),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_undefined] = ACTIONS(1263),
    [anon_sym_AT] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_abstract] = ACTIONS(1263),
    [anon_sym_get] = ACTIONS(1263),
    [anon_sym_set] = ACTIONS(1263),
    [anon_sym_declare] = ACTIONS(1263),
    [anon_sym_public] = ACTIONS(1263),
    [anon_sym_private] = ACTIONS(1263),
    [anon_sym_protected] = ACTIONS(1263),
    [anon_sym_module] = ACTIONS(1263),
    [anon_sym_any] = ACTIONS(1263),
    [anon_sym_number] = ACTIONS(1263),
    [anon_sym_boolean] = ACTIONS(1263),
    [anon_sym_string] = ACTIONS(1263),
    [anon_sym_symbol] = ACTIONS(1263),
    [anon_sym_interface] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [sym_readonly] = ACTIONS(1263),
    [sym__automatic_semicolon] = ACTIONS(1269),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(1271),
    [sym_identifier] = ACTIONS(1273),
    [anon_sym_export] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_as] = ACTIONS(1275),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_type] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(1273),
    [anon_sym_import] = ACTIONS(1273),
    [anon_sym_var] = ACTIONS(1273),
    [anon_sym_let] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_await] = ACTIONS(1273),
    [anon_sym_in] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_try] = ACTIONS(1273),
    [anon_sym_with] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_debugger] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_class] = ACTIONS(1273),
    [anon_sym_async] = ACTIONS(1273),
    [anon_sym_function] = ACTIONS(1273),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1277),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_PIPE_PIPE] = ACTIONS(1277),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_GT_GT_GT] = ACTIONS(1277),
    [anon_sym_LT_LT] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_LT_EQ] = ACTIONS(1277),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1277),
    [anon_sym_BANG_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1277),
    [anon_sym_instanceof] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1273),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_void] = ACTIONS(1273),
    [anon_sym_delete] = ACTIONS(1273),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [sym_number] = ACTIONS(1271),
    [sym_this] = ACTIONS(1273),
    [sym_super] = ACTIONS(1273),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [sym_null] = ACTIONS(1273),
    [sym_undefined] = ACTIONS(1273),
    [anon_sym_AT] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_abstract] = ACTIONS(1273),
    [anon_sym_get] = ACTIONS(1273),
    [anon_sym_set] = ACTIONS(1273),
    [anon_sym_declare] = ACTIONS(1273),
    [anon_sym_public] = ACTIONS(1273),
    [anon_sym_private] = ACTIONS(1273),
    [anon_sym_protected] = ACTIONS(1273),
    [anon_sym_module] = ACTIONS(1273),
    [anon_sym_any] = ACTIONS(1273),
    [anon_sym_number] = ACTIONS(1273),
    [anon_sym_boolean] = ACTIONS(1273),
    [anon_sym_string] = ACTIONS(1273),
    [anon_sym_symbol] = ACTIONS(1273),
    [anon_sym_interface] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [sym_readonly] = ACTIONS(1273),
    [sym__automatic_semicolon] = ACTIONS(1279),
  },
  [140] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_empty_statement] = STATE(164),
    [sym_parenthesized_expression] = STATE(875),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1378),
    [sym_array] = STATE(1382),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(875),
    [sym_subscript_expression] = STATE(875),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_namespace] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(1287),
    [anon_sym_let] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_get] = ACTIONS(1283),
    [anon_sym_set] = ACTIONS(1283),
    [anon_sym_declare] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1283),
    [anon_sym_private] = ACTIONS(1283),
    [anon_sym_protected] = ACTIONS(1283),
    [anon_sym_module] = ACTIONS(1283),
    [anon_sym_any] = ACTIONS(1283),
    [anon_sym_number] = ACTIONS(1283),
    [anon_sym_boolean] = ACTIONS(1283),
    [anon_sym_string] = ACTIONS(1283),
    [anon_sym_symbol] = ACTIONS(1283),
    [sym_readonly] = ACTIONS(1283),
  },
  [141] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(161),
    [sym_variable_declaration] = STATE(161),
    [sym_lexical_declaration] = STATE(161),
    [sym_empty_statement] = STATE(161),
    [sym_parenthesized_expression] = STATE(875),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1378),
    [sym_array] = STATE(1382),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(875),
    [sym_subscript_expression] = STATE(875),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_namespace] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(1287),
    [anon_sym_let] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_get] = ACTIONS(1283),
    [anon_sym_set] = ACTIONS(1283),
    [anon_sym_declare] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1283),
    [anon_sym_private] = ACTIONS(1283),
    [anon_sym_protected] = ACTIONS(1283),
    [anon_sym_module] = ACTIONS(1283),
    [anon_sym_any] = ACTIONS(1283),
    [anon_sym_number] = ACTIONS(1283),
    [anon_sym_boolean] = ACTIONS(1283),
    [anon_sym_string] = ACTIONS(1283),
    [anon_sym_symbol] = ACTIONS(1283),
    [sym_readonly] = ACTIONS(1283),
  },
  [142] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(162),
    [sym_variable_declaration] = STATE(162),
    [sym_lexical_declaration] = STATE(162),
    [sym_empty_statement] = STATE(162),
    [sym_parenthesized_expression] = STATE(875),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1378),
    [sym_array] = STATE(1382),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(875),
    [sym_subscript_expression] = STATE(875),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_namespace] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1283),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(1287),
    [anon_sym_let] = ACTIONS(1289),
    [anon_sym_const] = ACTIONS(1289),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1293),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_get] = ACTIONS(1283),
    [anon_sym_set] = ACTIONS(1283),
    [anon_sym_declare] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1283),
    [anon_sym_private] = ACTIONS(1283),
    [anon_sym_protected] = ACTIONS(1283),
    [anon_sym_module] = ACTIONS(1283),
    [anon_sym_any] = ACTIONS(1283),
    [anon_sym_number] = ACTIONS(1283),
    [anon_sym_boolean] = ACTIONS(1283),
    [anon_sym_string] = ACTIONS(1283),
    [anon_sym_symbol] = ACTIONS(1283),
    [sym_readonly] = ACTIONS(1283),
  },
  [143] = {
    [sym_import] = STATE(1124),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1124),
    [sym_jsx_fragment] = STATE(1124),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1124),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1124),
    [sym_arrow_function] = STATE(1124),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_sequence_expression] = STATE(3013),
    [sym_string] = STATE(1124),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1124),
    [sym_as_expression] = STATE(1124),
    [sym_internal_module] = STATE(1124),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(1297),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1299),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_null] = ACTIONS(851),
    [sym_undefined] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
    [sym_readonly] = ACTIONS(843),
  },
  [144] = {
    [sym_import] = STATE(1031),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1031),
    [sym_yield_expression] = STATE(1031),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1031),
    [sym_jsx_fragment] = STATE(1031),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1031),
    [sym_class] = STATE(1031),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1031),
    [sym_arrow_function] = STATE(1031),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1031),
    [sym_new_expression] = STATE(1031),
    [sym_await_expression] = STATE(1031),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1031),
    [sym_augmented_assignment_expression] = STATE(1031),
    [sym_ternary_expression] = STATE(1031),
    [sym_binary_expression] = STATE(1031),
    [sym_unary_expression] = STATE(1031),
    [sym_update_expression] = STATE(1031),
    [sym_sequence_expression] = STATE(2977),
    [sym_string] = STATE(1031),
    [sym_template_string] = STATE(1031),
    [sym_regex] = STATE(1031),
    [sym_meta_property] = STATE(1031),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1031),
    [sym_as_expression] = STATE(1031),
    [sym_internal_module] = STATE(1031),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(1297),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1303),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(849),
    [sym_false] = ACTIONS(849),
    [sym_null] = ACTIONS(849),
    [sym_undefined] = ACTIONS(849),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
    [sym_readonly] = ACTIONS(843),
  },
  [145] = {
    [sym_import] = STATE(1043),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1043),
    [sym_yield_expression] = STATE(1043),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1493),
    [sym_jsx_element] = STATE(1043),
    [sym_jsx_fragment] = STATE(1043),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1043),
    [sym_class] = STATE(1043),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1043),
    [sym_arrow_function] = STATE(1043),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1043),
    [sym_new_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1043),
    [sym_augmented_assignment_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_update_expression] = STATE(1043),
    [sym_sequence_expression] = STATE(2978),
    [sym_string] = STATE(1043),
    [sym_template_string] = STATE(1043),
    [sym_regex] = STATE(1043),
    [sym_meta_property] = STATE(1043),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_rest_parameter] = STATE(2632),
    [sym_non_null_expression] = STATE(1043),
    [sym_as_expression] = STATE(1043),
    [sym_internal_module] = STATE(1043),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(1722),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_export] = ACTIONS(797),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(797),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(1297),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1305),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(837),
    [sym_false] = ACTIONS(837),
    [sym_null] = ACTIONS(837),
    [sym_undefined] = ACTIONS(837),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(797),
    [anon_sym_get] = ACTIONS(797),
    [anon_sym_set] = ACTIONS(797),
    [anon_sym_declare] = ACTIONS(797),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(797),
    [anon_sym_any] = ACTIONS(797),
    [anon_sym_number] = ACTIONS(797),
    [anon_sym_boolean] = ACTIONS(797),
    [anon_sym_string] = ACTIONS(797),
    [anon_sym_symbol] = ACTIONS(797),
    [sym_readonly] = ACTIONS(843),
  },
  [146] = {
    [sym_import] = STATE(1214),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1214),
    [sym_yield_expression] = STATE(1214),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1214),
    [sym_jsx_fragment] = STATE(1214),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1214),
    [sym_class] = STATE(1214),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1214),
    [sym_arrow_function] = STATE(1214),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1214),
    [sym_new_expression] = STATE(1214),
    [sym_await_expression] = STATE(1214),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1214),
    [sym_augmented_assignment_expression] = STATE(1214),
    [sym_spread_element] = STATE(2593),
    [sym_ternary_expression] = STATE(1214),
    [sym_binary_expression] = STATE(1214),
    [sym_unary_expression] = STATE(1214),
    [sym_update_expression] = STATE(1214),
    [sym_string] = STATE(1214),
    [sym_template_string] = STATE(1214),
    [sym_regex] = STATE(1214),
    [sym_meta_property] = STATE(1214),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1214),
    [sym_as_expression] = STATE(1214),
    [sym_internal_module] = STATE(1214),
    [sym_mapped_type_clause] = STATE(2985),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(1307),
    [anon_sym_export] = ACTIONS(1309),
    [anon_sym_namespace] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(1309),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1313),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(1315),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1317),
    [sym_this] = ACTIONS(1319),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1319),
    [sym_false] = ACTIONS(1319),
    [sym_null] = ACTIONS(1319),
    [sym_undefined] = ACTIONS(1319),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_get] = ACTIONS(1309),
    [anon_sym_set] = ACTIONS(1309),
    [anon_sym_declare] = ACTIONS(1309),
    [anon_sym_public] = ACTIONS(1309),
    [anon_sym_private] = ACTIONS(1309),
    [anon_sym_protected] = ACTIONS(1309),
    [anon_sym_module] = ACTIONS(1309),
    [anon_sym_any] = ACTIONS(1309),
    [anon_sym_number] = ACTIONS(1309),
    [anon_sym_boolean] = ACTIONS(1309),
    [anon_sym_string] = ACTIONS(1309),
    [anon_sym_symbol] = ACTIONS(1309),
    [sym_readonly] = ACTIONS(1309),
  },
  [147] = {
    [sym_import] = STATE(1300),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1300),
    [sym_yield_expression] = STATE(1300),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1300),
    [sym_jsx_fragment] = STATE(1300),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1300),
    [sym_class] = STATE(1300),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1300),
    [sym_arrow_function] = STATE(1300),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1300),
    [sym_new_expression] = STATE(1300),
    [sym_await_expression] = STATE(1300),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1300),
    [sym_augmented_assignment_expression] = STATE(1300),
    [sym_spread_element] = STATE(2727),
    [sym_ternary_expression] = STATE(1300),
    [sym_binary_expression] = STATE(1300),
    [sym_unary_expression] = STATE(1300),
    [sym_update_expression] = STATE(1300),
    [sym_string] = STATE(1300),
    [sym_template_string] = STATE(1300),
    [sym_regex] = STATE(1300),
    [sym_meta_property] = STATE(1300),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1300),
    [sym_as_expression] = STATE(1300),
    [sym_internal_module] = STATE(1300),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2726),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1321),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1323),
    [sym_this] = ACTIONS(1325),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1325),
    [sym_false] = ACTIONS(1325),
    [sym_null] = ACTIONS(1325),
    [sym_undefined] = ACTIONS(1325),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [148] = {
    [sym_import] = STATE(1319),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1319),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1319),
    [sym_jsx_fragment] = STATE(1319),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1319),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1319),
    [sym_arrow_function] = STATE(1319),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1319),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1319),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1319),
    [sym_augmented_assignment_expression] = STATE(1319),
    [sym_spread_element] = STATE(2709),
    [sym_ternary_expression] = STATE(1319),
    [sym_binary_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1319),
    [sym_update_expression] = STATE(1319),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1319),
    [sym_as_expression] = STATE(1319),
    [sym_internal_module] = STATE(1319),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2710),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(1327),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1329),
    [sym_this] = ACTIONS(1331),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1331),
    [sym_false] = ACTIONS(1331),
    [sym_null] = ACTIONS(1331),
    [sym_undefined] = ACTIONS(1331),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [149] = {
    [sym_import] = STATE(1307),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1307),
    [sym_jsx_fragment] = STATE(1307),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1307),
    [sym_class] = STATE(1307),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1307),
    [sym_arrow_function] = STATE(1307),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1307),
    [sym_new_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1307),
    [sym_augmented_assignment_expression] = STATE(1307),
    [sym_spread_element] = STATE(2593),
    [sym_ternary_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_unary_expression] = STATE(1307),
    [sym_update_expression] = STATE(1307),
    [sym_string] = STATE(1307),
    [sym_template_string] = STATE(1307),
    [sym_regex] = STATE(1307),
    [sym_meta_property] = STATE(1307),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1307),
    [sym_as_expression] = STATE(1307),
    [sym_internal_module] = STATE(1307),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1333),
    [sym_this] = ACTIONS(1335),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1335),
    [sym_false] = ACTIONS(1335),
    [sym_null] = ACTIONS(1335),
    [sym_undefined] = ACTIONS(1335),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [150] = {
    [sym_import] = STATE(1219),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1219),
    [sym_yield_expression] = STATE(1219),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1219),
    [sym_jsx_fragment] = STATE(1219),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1219),
    [sym_class] = STATE(1219),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1219),
    [sym_arrow_function] = STATE(1219),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1219),
    [sym_new_expression] = STATE(1219),
    [sym_await_expression] = STATE(1219),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1219),
    [sym_augmented_assignment_expression] = STATE(1219),
    [sym_spread_element] = STATE(2659),
    [sym_ternary_expression] = STATE(1219),
    [sym_binary_expression] = STATE(1219),
    [sym_unary_expression] = STATE(1219),
    [sym_update_expression] = STATE(1219),
    [sym_string] = STATE(1219),
    [sym_template_string] = STATE(1219),
    [sym_regex] = STATE(1219),
    [sym_meta_property] = STATE(1219),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1219),
    [sym_as_expression] = STATE(1219),
    [sym_internal_module] = STATE(1219),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2657),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1337),
    [sym_this] = ACTIONS(873),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(873),
    [sym_false] = ACTIONS(873),
    [sym_null] = ACTIONS(873),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [151] = {
    [sym_import] = STATE(1209),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1209),
    [sym_yield_expression] = STATE(1209),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1209),
    [sym_jsx_fragment] = STATE(1209),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1209),
    [sym_class] = STATE(1209),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1209),
    [sym_arrow_function] = STATE(1209),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1209),
    [sym_new_expression] = STATE(1209),
    [sym_await_expression] = STATE(1209),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1209),
    [sym_augmented_assignment_expression] = STATE(1209),
    [sym_spread_element] = STATE(2597),
    [sym_ternary_expression] = STATE(1209),
    [sym_binary_expression] = STATE(1209),
    [sym_unary_expression] = STATE(1209),
    [sym_update_expression] = STATE(1209),
    [sym_string] = STATE(1209),
    [sym_template_string] = STATE(1209),
    [sym_regex] = STATE(1209),
    [sym_meta_property] = STATE(1209),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1209),
    [sym_as_expression] = STATE(1209),
    [sym_internal_module] = STATE(1209),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2596),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1341),
    [sym_this] = ACTIONS(1343),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1343),
    [sym_false] = ACTIONS(1343),
    [sym_null] = ACTIONS(1343),
    [sym_undefined] = ACTIONS(1343),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [152] = {
    [sym_import] = STATE(1211),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1211),
    [sym_yield_expression] = STATE(1211),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1211),
    [sym_jsx_fragment] = STATE(1211),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1211),
    [sym_class] = STATE(1211),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1211),
    [sym_arrow_function] = STATE(1211),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1211),
    [sym_new_expression] = STATE(1211),
    [sym_await_expression] = STATE(1211),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1211),
    [sym_augmented_assignment_expression] = STATE(1211),
    [sym_spread_element] = STATE(2614),
    [sym_ternary_expression] = STATE(1211),
    [sym_binary_expression] = STATE(1211),
    [sym_unary_expression] = STATE(1211),
    [sym_update_expression] = STATE(1211),
    [sym_string] = STATE(1211),
    [sym_template_string] = STATE(1211),
    [sym_regex] = STATE(1211),
    [sym_meta_property] = STATE(1211),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1211),
    [sym_as_expression] = STATE(1211),
    [sym_internal_module] = STATE(1211),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2615),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1345),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1347),
    [sym_this] = ACTIONS(1349),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1349),
    [sym_false] = ACTIONS(1349),
    [sym_null] = ACTIONS(1349),
    [sym_undefined] = ACTIONS(1349),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [153] = {
    [sym_import] = STATE(1410),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1410),
    [sym_yield_expression] = STATE(1410),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1410),
    [sym_jsx_fragment] = STATE(1410),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1410),
    [sym_class] = STATE(1410),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1410),
    [sym_arrow_function] = STATE(1410),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1410),
    [sym_new_expression] = STATE(1410),
    [sym_await_expression] = STATE(1410),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1410),
    [sym_augmented_assignment_expression] = STATE(1410),
    [sym_spread_element] = STATE(2617),
    [sym_ternary_expression] = STATE(1410),
    [sym_binary_expression] = STATE(1410),
    [sym_unary_expression] = STATE(1410),
    [sym_update_expression] = STATE(1410),
    [sym_sequence_expression] = STATE(2480),
    [sym_string] = STATE(1410),
    [sym_template_string] = STATE(1410),
    [sym_regex] = STATE(1410),
    [sym_meta_property] = STATE(1410),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1410),
    [sym_as_expression] = STATE(1410),
    [sym_internal_module] = STATE(1410),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1353),
    [sym_this] = ACTIONS(1355),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1355),
    [sym_false] = ACTIONS(1355),
    [sym_null] = ACTIONS(1355),
    [sym_undefined] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [154] = {
    [sym_import] = STATE(1207),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1207),
    [sym_yield_expression] = STATE(1207),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1207),
    [sym_jsx_fragment] = STATE(1207),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1207),
    [sym_class] = STATE(1207),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1207),
    [sym_arrow_function] = STATE(1207),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1207),
    [sym_new_expression] = STATE(1207),
    [sym_await_expression] = STATE(1207),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1207),
    [sym_augmented_assignment_expression] = STATE(1207),
    [sym_spread_element] = STATE(2593),
    [sym_ternary_expression] = STATE(1207),
    [sym_binary_expression] = STATE(1207),
    [sym_unary_expression] = STATE(1207),
    [sym_update_expression] = STATE(1207),
    [sym_string] = STATE(1207),
    [sym_template_string] = STATE(1207),
    [sym_regex] = STATE(1207),
    [sym_meta_property] = STATE(1207),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1207),
    [sym_as_expression] = STATE(1207),
    [sym_internal_module] = STATE(1207),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2594),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1357),
    [sym_this] = ACTIONS(883),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(883),
    [sym_false] = ACTIONS(883),
    [sym_null] = ACTIONS(883),
    [sym_undefined] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [155] = {
    [sym_import] = STATE(1213),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1213),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1213),
    [sym_jsx_fragment] = STATE(1213),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1213),
    [sym_class] = STATE(1213),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1213),
    [sym_arrow_function] = STATE(1213),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1213),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1213),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_spread_element] = STATE(2617),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1213),
    [sym_template_string] = STATE(1213),
    [sym_regex] = STATE(1213),
    [sym_meta_property] = STATE(1213),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1213),
    [sym_as_expression] = STATE(1213),
    [sym_internal_module] = STATE(1213),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1359),
    [sym_this] = ACTIONS(1361),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1361),
    [sym_false] = ACTIONS(1361),
    [sym_null] = ACTIONS(1361),
    [sym_undefined] = ACTIONS(1361),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [156] = {
    [sym_import] = STATE(1295),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1295),
    [sym_yield_expression] = STATE(1295),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1295),
    [sym_jsx_fragment] = STATE(1295),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1295),
    [sym_class] = STATE(1295),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1295),
    [sym_arrow_function] = STATE(1295),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1295),
    [sym_new_expression] = STATE(1295),
    [sym_await_expression] = STATE(1295),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1295),
    [sym_augmented_assignment_expression] = STATE(1295),
    [sym_spread_element] = STATE(2731),
    [sym_ternary_expression] = STATE(1295),
    [sym_binary_expression] = STATE(1295),
    [sym_unary_expression] = STATE(1295),
    [sym_update_expression] = STATE(1295),
    [sym_string] = STATE(1295),
    [sym_template_string] = STATE(1295),
    [sym_regex] = STATE(1295),
    [sym_meta_property] = STATE(1295),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1295),
    [sym_as_expression] = STATE(1295),
    [sym_internal_module] = STATE(1295),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2732),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1363),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1365),
    [sym_this] = ACTIONS(1367),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1367),
    [sym_false] = ACTIONS(1367),
    [sym_null] = ACTIONS(1367),
    [sym_undefined] = ACTIONS(1367),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [157] = {
    [sym_import] = STATE(1220),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1220),
    [sym_jsx_fragment] = STATE(1220),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1220),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1220),
    [sym_arrow_function] = STATE(1220),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_spread_element] = STATE(2664),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2665),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(877),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1369),
    [sym_this] = ACTIONS(879),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(879),
    [sym_false] = ACTIONS(879),
    [sym_null] = ACTIONS(879),
    [sym_undefined] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [158] = {
    [sym_import] = STATE(1299),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1299),
    [sym_yield_expression] = STATE(1299),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1299),
    [sym_jsx_fragment] = STATE(1299),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1299),
    [sym_class] = STATE(1299),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1299),
    [sym_arrow_function] = STATE(1299),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1299),
    [sym_new_expression] = STATE(1299),
    [sym_await_expression] = STATE(1299),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1299),
    [sym_augmented_assignment_expression] = STATE(1299),
    [sym_spread_element] = STATE(2646),
    [sym_ternary_expression] = STATE(1299),
    [sym_binary_expression] = STATE(1299),
    [sym_unary_expression] = STATE(1299),
    [sym_update_expression] = STATE(1299),
    [sym_string] = STATE(1299),
    [sym_template_string] = STATE(1299),
    [sym_regex] = STATE(1299),
    [sym_meta_property] = STATE(1299),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1299),
    [sym_as_expression] = STATE(1299),
    [sym_internal_module] = STATE(1299),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2647),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1371),
    [sym_this] = ACTIONS(1373),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1373),
    [sym_false] = ACTIONS(1373),
    [sym_null] = ACTIONS(1373),
    [sym_undefined] = ACTIONS(1373),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [159] = {
    [sym_import] = STATE(1269),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1269),
    [sym_yield_expression] = STATE(1269),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1269),
    [sym_jsx_fragment] = STATE(1269),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1269),
    [sym_class] = STATE(1269),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1269),
    [sym_arrow_function] = STATE(1269),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1269),
    [sym_new_expression] = STATE(1269),
    [sym_await_expression] = STATE(1269),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1269),
    [sym_augmented_assignment_expression] = STATE(1269),
    [sym_spread_element] = STATE(2646),
    [sym_ternary_expression] = STATE(1269),
    [sym_binary_expression] = STATE(1269),
    [sym_unary_expression] = STATE(1269),
    [sym_update_expression] = STATE(1269),
    [sym_string] = STATE(1269),
    [sym_template_string] = STATE(1269),
    [sym_regex] = STATE(1269),
    [sym_meta_property] = STATE(1269),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1269),
    [sym_as_expression] = STATE(1269),
    [sym_internal_module] = STATE(1269),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [aux_sym_array_repeat1] = STATE(2647),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_RBRACK] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1375),
    [sym_this] = ACTIONS(887),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(887),
    [sym_false] = ACTIONS(887),
    [sym_null] = ACTIONS(887),
    [sym_undefined] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [160] = {
    [sym_import] = STATE(1352),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1352),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1352),
    [sym_jsx_fragment] = STATE(1352),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1352),
    [sym_class] = STATE(1352),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1352),
    [sym_arrow_function] = STATE(1352),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1352),
    [sym_new_expression] = STATE(1352),
    [sym_await_expression] = STATE(1352),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1352),
    [sym_augmented_assignment_expression] = STATE(1352),
    [sym_spread_element] = STATE(3175),
    [sym_ternary_expression] = STATE(1352),
    [sym_binary_expression] = STATE(1352),
    [sym_unary_expression] = STATE(1352),
    [sym_update_expression] = STATE(1352),
    [sym_sequence_expression] = STATE(3175),
    [sym_string] = STATE(1352),
    [sym_template_string] = STATE(1352),
    [sym_regex] = STATE(1352),
    [sym_meta_property] = STATE(1352),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1352),
    [sym_as_expression] = STATE(1352),
    [sym_internal_module] = STATE(1352),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1381),
    [sym_this] = ACTIONS(1383),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1383),
    [sym_false] = ACTIONS(1383),
    [sym_null] = ACTIONS(1383),
    [sym_undefined] = ACTIONS(1383),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [161] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(171),
    [sym_empty_statement] = STATE(171),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [162] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(172),
    [sym_empty_statement] = STATE(172),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [163] = {
    [sym_import] = STATE(1337),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1337),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1337),
    [sym_jsx_fragment] = STATE(1337),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1337),
    [sym_class] = STATE(1337),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1337),
    [sym_arrow_function] = STATE(1337),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1337),
    [sym_new_expression] = STATE(1337),
    [sym_await_expression] = STATE(1337),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1337),
    [sym_augmented_assignment_expression] = STATE(1337),
    [sym_spread_element] = STATE(3078),
    [sym_ternary_expression] = STATE(1337),
    [sym_binary_expression] = STATE(1337),
    [sym_unary_expression] = STATE(1337),
    [sym_update_expression] = STATE(1337),
    [sym_sequence_expression] = STATE(3078),
    [sym_string] = STATE(1337),
    [sym_template_string] = STATE(1337),
    [sym_regex] = STATE(1337),
    [sym_meta_property] = STATE(1337),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1337),
    [sym_as_expression] = STATE(1337),
    [sym_internal_module] = STATE(1337),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(1385),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1387),
    [sym_this] = ACTIONS(1389),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1389),
    [sym_false] = ACTIONS(1389),
    [sym_null] = ACTIONS(1389),
    [sym_undefined] = ACTIONS(1389),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [164] = {
    [sym_import] = STATE(1270),
    [sym_expression_statement] = STATE(173),
    [sym_empty_statement] = STATE(173),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1270),
    [sym_jsx_fragment] = STATE(1270),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_sequence_expression] = STATE(2826),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [165] = {
    [sym_import] = STATE(1265),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1265),
    [sym_yield_expression] = STATE(1265),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1265),
    [sym_jsx_fragment] = STATE(1265),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_nested_identifier] = STATE(3069),
    [sym_jsx_self_closing_element] = STATE(1265),
    [sym_class] = STATE(1265),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1265),
    [sym_arrow_function] = STATE(1265),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1265),
    [sym_new_expression] = STATE(1265),
    [sym_await_expression] = STATE(1265),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1265),
    [sym_augmented_assignment_expression] = STATE(1265),
    [sym_ternary_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_update_expression] = STATE(1265),
    [sym_string] = STATE(1265),
    [sym_template_string] = STATE(1265),
    [sym_regex] = STATE(1265),
    [sym_meta_property] = STATE(1265),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1265),
    [sym_as_expression] = STATE(1265),
    [sym_internal_module] = STATE(1265),
    [sym_nested_type_identifier] = STATE(2312),
    [sym_generic_type] = STATE(2622),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1391),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1395),
    [sym_this] = ACTIONS(1397),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1397),
    [sym_false] = ACTIONS(1397),
    [sym_null] = ACTIONS(1397),
    [sym_undefined] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [166] = {
    [sym_import] = STATE(1215),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1215),
    [sym_yield_expression] = STATE(1215),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1215),
    [sym_jsx_fragment] = STATE(1215),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1215),
    [sym_class] = STATE(1215),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1215),
    [sym_arrow_function] = STATE(1215),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1215),
    [sym_new_expression] = STATE(1215),
    [sym_await_expression] = STATE(1215),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1215),
    [sym_augmented_assignment_expression] = STATE(1215),
    [sym_ternary_expression] = STATE(1215),
    [sym_binary_expression] = STATE(1215),
    [sym_unary_expression] = STATE(1215),
    [sym_update_expression] = STATE(1215),
    [sym_string] = STATE(1215),
    [sym_template_string] = STATE(1215),
    [sym_regex] = STATE(1215),
    [sym_meta_property] = STATE(1215),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1215),
    [sym_as_expression] = STATE(1215),
    [sym_internal_module] = STATE(1215),
    [sym_nested_type_identifier] = STATE(2301),
    [sym_generic_type] = STATE(2592),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1399),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1401),
    [sym_this] = ACTIONS(1403),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1403),
    [sym_false] = ACTIONS(1403),
    [sym_null] = ACTIONS(1403),
    [sym_undefined] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [167] = {
    [sym_import] = STATE(1591),
    [sym_parenthesized_expression] = STATE(930),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(1721),
    [sym_array] = STATE(1720),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1591),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1591),
    [sym_arrow_function] = STATE(1591),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1591),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(930),
    [sym_subscript_expression] = STATE(930),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1591),
    [sym_template_string] = STATE(1591),
    [sym_regex] = STATE(1591),
    [sym_meta_property] = STATE(1591),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1405),
    [anon_sym_export] = ACTIONS(1407),
    [anon_sym_namespace] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1407),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_var] = ACTIONS(1411),
    [anon_sym_let] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1415),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1417),
    [sym_this] = ACTIONS(1419),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_null] = ACTIONS(1419),
    [sym_undefined] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1407),
    [anon_sym_get] = ACTIONS(1407),
    [anon_sym_set] = ACTIONS(1407),
    [anon_sym_declare] = ACTIONS(1407),
    [anon_sym_public] = ACTIONS(1407),
    [anon_sym_private] = ACTIONS(1407),
    [anon_sym_protected] = ACTIONS(1407),
    [anon_sym_module] = ACTIONS(1407),
    [anon_sym_any] = ACTIONS(1407),
    [anon_sym_number] = ACTIONS(1407),
    [anon_sym_boolean] = ACTIONS(1407),
    [anon_sym_string] = ACTIONS(1407),
    [anon_sym_symbol] = ACTIONS(1407),
    [sym_readonly] = ACTIONS(1407),
  },
  [168] = {
    [sym_import] = STATE(1071),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1071),
    [sym_yield_expression] = STATE(1071),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1071),
    [sym_jsx_fragment] = STATE(1071),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(3014),
    [sym_jsx_self_closing_element] = STATE(1071),
    [sym_class] = STATE(1071),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1071),
    [sym_arrow_function] = STATE(1071),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1071),
    [sym_new_expression] = STATE(1071),
    [sym_await_expression] = STATE(1071),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1071),
    [sym_augmented_assignment_expression] = STATE(1071),
    [sym_ternary_expression] = STATE(1071),
    [sym_binary_expression] = STATE(1071),
    [sym_unary_expression] = STATE(1071),
    [sym_update_expression] = STATE(1071),
    [sym_string] = STATE(1071),
    [sym_template_string] = STATE(1071),
    [sym_regex] = STATE(1071),
    [sym_meta_property] = STATE(1071),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1071),
    [sym_as_expression] = STATE(1071),
    [sym_internal_module] = STATE(1071),
    [sym_nested_type_identifier] = STATE(2155),
    [sym_generic_type] = STATE(2457),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1423),
    [sym_this] = ACTIONS(1425),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1425),
    [sym_false] = ACTIONS(1425),
    [sym_null] = ACTIONS(1425),
    [sym_undefined] = ACTIONS(1425),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [169] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1023),
    [sym_jsx_fragment] = STATE(1023),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_nested_identifier] = STATE(3069),
    [sym_jsx_self_closing_element] = STATE(1023),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_nested_type_identifier] = STATE(2132),
    [sym_generic_type] = STATE(2515),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1427),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1429),
    [sym_this] = ACTIONS(1431),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1431),
    [sym_false] = ACTIONS(1431),
    [sym_null] = ACTIONS(1431),
    [sym_undefined] = ACTIONS(1431),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [170] = {
    [sym_import] = STATE(1293),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1293),
    [sym_jsx_fragment] = STATE(1293),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1293),
    [sym_class] = STATE(1293),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1293),
    [sym_arrow_function] = STATE(1293),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1293),
    [sym_new_expression] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_sequence_expression] = STATE(2953),
    [sym_string] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1435),
    [sym_this] = ACTIONS(1437),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1437),
    [sym_false] = ACTIONS(1437),
    [sym_null] = ACTIONS(1437),
    [sym_undefined] = ACTIONS(1437),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
    [sym__automatic_semicolon] = ACTIONS(1433),
  },
  [171] = {
    [sym_import] = STATE(1387),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1387),
    [sym_yield_expression] = STATE(1387),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1387),
    [sym_jsx_fragment] = STATE(1387),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1387),
    [sym_class] = STATE(1387),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1387),
    [sym_arrow_function] = STATE(1387),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1387),
    [sym_new_expression] = STATE(1387),
    [sym_await_expression] = STATE(1387),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1387),
    [sym_augmented_assignment_expression] = STATE(1387),
    [sym_ternary_expression] = STATE(1387),
    [sym_binary_expression] = STATE(1387),
    [sym_unary_expression] = STATE(1387),
    [sym_update_expression] = STATE(1387),
    [sym_sequence_expression] = STATE(3179),
    [sym_string] = STATE(1387),
    [sym_template_string] = STATE(1387),
    [sym_regex] = STATE(1387),
    [sym_meta_property] = STATE(1387),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1387),
    [sym_as_expression] = STATE(1387),
    [sym_internal_module] = STATE(1387),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1441),
    [sym_this] = ACTIONS(1443),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1443),
    [sym_false] = ACTIONS(1443),
    [sym_null] = ACTIONS(1443),
    [sym_undefined] = ACTIONS(1443),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [172] = {
    [sym_import] = STATE(1397),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1397),
    [sym_yield_expression] = STATE(1397),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1397),
    [sym_jsx_fragment] = STATE(1397),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1397),
    [sym_class] = STATE(1397),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1397),
    [sym_arrow_function] = STATE(1397),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1397),
    [sym_new_expression] = STATE(1397),
    [sym_await_expression] = STATE(1397),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1397),
    [sym_augmented_assignment_expression] = STATE(1397),
    [sym_ternary_expression] = STATE(1397),
    [sym_binary_expression] = STATE(1397),
    [sym_unary_expression] = STATE(1397),
    [sym_update_expression] = STATE(1397),
    [sym_sequence_expression] = STATE(3058),
    [sym_string] = STATE(1397),
    [sym_template_string] = STATE(1397),
    [sym_regex] = STATE(1397),
    [sym_meta_property] = STATE(1397),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1397),
    [sym_as_expression] = STATE(1397),
    [sym_internal_module] = STATE(1397),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1445),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1447),
    [sym_this] = ACTIONS(1449),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1449),
    [sym_false] = ACTIONS(1449),
    [sym_null] = ACTIONS(1449),
    [sym_undefined] = ACTIONS(1449),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [173] = {
    [sym_import] = STATE(1384),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1384),
    [sym_yield_expression] = STATE(1384),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1384),
    [sym_jsx_fragment] = STATE(1384),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1384),
    [sym_class] = STATE(1384),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1384),
    [sym_arrow_function] = STATE(1384),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1384),
    [sym_new_expression] = STATE(1384),
    [sym_await_expression] = STATE(1384),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1384),
    [sym_augmented_assignment_expression] = STATE(1384),
    [sym_ternary_expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_unary_expression] = STATE(1384),
    [sym_update_expression] = STATE(1384),
    [sym_sequence_expression] = STATE(3092),
    [sym_string] = STATE(1384),
    [sym_template_string] = STATE(1384),
    [sym_regex] = STATE(1384),
    [sym_meta_property] = STATE(1384),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1384),
    [sym_as_expression] = STATE(1384),
    [sym_internal_module] = STATE(1384),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(1451),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1453),
    [sym_this] = ACTIONS(1455),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1455),
    [sym_false] = ACTIONS(1455),
    [sym_null] = ACTIONS(1455),
    [sym_undefined] = ACTIONS(1455),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [174] = {
    [sym_import] = STATE(1128),
    [sym_statement_block] = STATE(1437),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1128),
    [sym_yield_expression] = STATE(1128),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1128),
    [sym_jsx_fragment] = STATE(1128),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1128),
    [sym_class] = STATE(1128),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1128),
    [sym_arrow_function] = STATE(1128),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1128),
    [sym_new_expression] = STATE(1128),
    [sym_await_expression] = STATE(1128),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1128),
    [sym_augmented_assignment_expression] = STATE(1128),
    [sym_ternary_expression] = STATE(1128),
    [sym_binary_expression] = STATE(1128),
    [sym_unary_expression] = STATE(1128),
    [sym_update_expression] = STATE(1128),
    [sym_string] = STATE(1128),
    [sym_template_string] = STATE(1128),
    [sym_regex] = STATE(1128),
    [sym_meta_property] = STATE(1128),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1128),
    [sym_as_expression] = STATE(1128),
    [sym_internal_module] = STATE(1128),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1459),
    [sym_this] = ACTIONS(1461),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1461),
    [sym_false] = ACTIONS(1461),
    [sym_null] = ACTIONS(1461),
    [sym_undefined] = ACTIONS(1461),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [175] = {
    [sym_import] = STATE(1404),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1404),
    [sym_yield_expression] = STATE(1404),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1404),
    [sym_jsx_fragment] = STATE(1404),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1404),
    [sym_class] = STATE(1404),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1404),
    [sym_arrow_function] = STATE(1404),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1404),
    [sym_new_expression] = STATE(1404),
    [sym_await_expression] = STATE(1404),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1404),
    [sym_augmented_assignment_expression] = STATE(1404),
    [sym_ternary_expression] = STATE(1404),
    [sym_binary_expression] = STATE(1404),
    [sym_unary_expression] = STATE(1404),
    [sym_update_expression] = STATE(1404),
    [sym_sequence_expression] = STATE(3057),
    [sym_string] = STATE(1404),
    [sym_template_string] = STATE(1404),
    [sym_regex] = STATE(1404),
    [sym_meta_property] = STATE(1404),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1404),
    [sym_as_expression] = STATE(1404),
    [sym_internal_module] = STATE(1404),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1463),
    [sym_this] = ACTIONS(1465),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1465),
    [sym_false] = ACTIONS(1465),
    [sym_null] = ACTIONS(1465),
    [sym_undefined] = ACTIONS(1465),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [176] = {
    [sym_import] = STATE(1405),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1405),
    [sym_yield_expression] = STATE(1405),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1405),
    [sym_jsx_fragment] = STATE(1405),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1405),
    [sym_class] = STATE(1405),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1405),
    [sym_arrow_function] = STATE(1405),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1405),
    [sym_new_expression] = STATE(1405),
    [sym_await_expression] = STATE(1405),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1405),
    [sym_augmented_assignment_expression] = STATE(1405),
    [sym_ternary_expression] = STATE(1405),
    [sym_binary_expression] = STATE(1405),
    [sym_unary_expression] = STATE(1405),
    [sym_update_expression] = STATE(1405),
    [sym_sequence_expression] = STATE(3056),
    [sym_string] = STATE(1405),
    [sym_template_string] = STATE(1405),
    [sym_regex] = STATE(1405),
    [sym_meta_property] = STATE(1405),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1405),
    [sym_as_expression] = STATE(1405),
    [sym_internal_module] = STATE(1405),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1467),
    [sym_this] = ACTIONS(1469),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1469),
    [sym_false] = ACTIONS(1469),
    [sym_null] = ACTIONS(1469),
    [sym_undefined] = ACTIONS(1469),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [177] = {
    [sym_import] = STATE(1494),
    [sym_parenthesized_expression] = STATE(876),
    [sym__expression] = STATE(1687),
    [sym_yield_expression] = STATE(1687),
    [sym_object] = STATE(1322),
    [sym_array] = STATE(1323),
    [sym_jsx_element] = STATE(1687),
    [sym_jsx_fragment] = STATE(1687),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1687),
    [sym_class] = STATE(1494),
    [sym_function] = STATE(1313),
    [sym_generator_function] = STATE(1494),
    [sym_arrow_function] = STATE(1494),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1687),
    [sym_new_expression] = STATE(1494),
    [sym_await_expression] = STATE(1687),
    [sym_member_expression] = STATE(876),
    [sym_subscript_expression] = STATE(876),
    [sym_assignment_expression] = STATE(1687),
    [sym_augmented_assignment_expression] = STATE(1687),
    [sym_ternary_expression] = STATE(1687),
    [sym_binary_expression] = STATE(1687),
    [sym_unary_expression] = STATE(1687),
    [sym_update_expression] = STATE(1687),
    [sym_string] = STATE(1494),
    [sym_template_string] = STATE(1494),
    [sym_regex] = STATE(1494),
    [sym_meta_property] = STATE(1494),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1687),
    [sym_as_expression] = STATE(1687),
    [sym_internal_module] = STATE(1687),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1471),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1483),
    [sym_this] = ACTIONS(1485),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [sym_null] = ACTIONS(1485),
    [sym_undefined] = ACTIONS(1485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [sym_readonly] = ACTIONS(1473),
  },
  [178] = {
    [sym_import] = STATE(1286),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1286),
    [sym_jsx_fragment] = STATE(1286),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1286),
    [sym_class] = STATE(1286),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1286),
    [sym_arrow_function] = STATE(1286),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1286),
    [sym_new_expression] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_sequence_expression] = STATE(2956),
    [sym_string] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1489),
    [sym_this] = ACTIONS(1491),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1491),
    [sym_false] = ACTIONS(1491),
    [sym_null] = ACTIONS(1491),
    [sym_undefined] = ACTIONS(1491),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [179] = {
    [sym_import] = STATE(1019),
    [sym_statement_block] = STATE(1056),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1019),
    [sym_yield_expression] = STATE(1019),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1019),
    [sym_jsx_fragment] = STATE(1019),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1019),
    [sym_class] = STATE(1019),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1019),
    [sym_arrow_function] = STATE(1019),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1019),
    [sym_new_expression] = STATE(1019),
    [sym_await_expression] = STATE(1019),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1019),
    [sym_augmented_assignment_expression] = STATE(1019),
    [sym_ternary_expression] = STATE(1019),
    [sym_binary_expression] = STATE(1019),
    [sym_unary_expression] = STATE(1019),
    [sym_update_expression] = STATE(1019),
    [sym_string] = STATE(1019),
    [sym_template_string] = STATE(1019),
    [sym_regex] = STATE(1019),
    [sym_meta_property] = STATE(1019),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1019),
    [sym_as_expression] = STATE(1019),
    [sym_internal_module] = STATE(1019),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1495),
    [sym_this] = ACTIONS(1497),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1497),
    [sym_false] = ACTIONS(1497),
    [sym_null] = ACTIONS(1497),
    [sym_undefined] = ACTIONS(1497),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [180] = {
    [sym_import] = STATE(1524),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1524),
    [sym_yield_expression] = STATE(1524),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1524),
    [sym_jsx_fragment] = STATE(1524),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1524),
    [sym_class] = STATE(1524),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1524),
    [sym_arrow_function] = STATE(1524),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1524),
    [sym_new_expression] = STATE(1524),
    [sym_await_expression] = STATE(1524),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1524),
    [sym_augmented_assignment_expression] = STATE(1524),
    [sym_ternary_expression] = STATE(1524),
    [sym_binary_expression] = STATE(1524),
    [sym_unary_expression] = STATE(1524),
    [sym_update_expression] = STATE(1524),
    [sym_string] = STATE(1524),
    [sym_template_string] = STATE(1524),
    [sym_regex] = STATE(1524),
    [sym_meta_property] = STATE(1524),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1524),
    [sym_as_expression] = STATE(1524),
    [sym_internal_module] = STATE(1524),
    [sym_mapped_type_clause] = STATE(2985),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1499),
    [anon_sym_export] = ACTIONS(1501),
    [anon_sym_namespace] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1501),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1505),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1507),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1509),
    [sym_this] = ACTIONS(1511),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1511),
    [sym_false] = ACTIONS(1511),
    [sym_null] = ACTIONS(1511),
    [sym_undefined] = ACTIONS(1511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_get] = ACTIONS(1501),
    [anon_sym_set] = ACTIONS(1501),
    [anon_sym_declare] = ACTIONS(1501),
    [anon_sym_public] = ACTIONS(1501),
    [anon_sym_private] = ACTIONS(1501),
    [anon_sym_protected] = ACTIONS(1501),
    [anon_sym_module] = ACTIONS(1501),
    [anon_sym_any] = ACTIONS(1501),
    [anon_sym_number] = ACTIONS(1501),
    [anon_sym_boolean] = ACTIONS(1501),
    [anon_sym_string] = ACTIONS(1501),
    [anon_sym_symbol] = ACTIONS(1501),
    [sym_readonly] = ACTIONS(1501),
  },
  [181] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1513),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [182] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1525),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [sym_readonly] = ACTIONS(1517),
  },
  [183] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1917),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [184] = {
    [sym_import] = STATE(1407),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1407),
    [sym_yield_expression] = STATE(1407),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1407),
    [sym_jsx_fragment] = STATE(1407),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1407),
    [sym_class] = STATE(1407),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1407),
    [sym_arrow_function] = STATE(1407),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1407),
    [sym_new_expression] = STATE(1407),
    [sym_await_expression] = STATE(1407),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1407),
    [sym_augmented_assignment_expression] = STATE(1407),
    [sym_ternary_expression] = STATE(1407),
    [sym_binary_expression] = STATE(1407),
    [sym_unary_expression] = STATE(1407),
    [sym_update_expression] = STATE(1407),
    [sym_sequence_expression] = STATE(3052),
    [sym_string] = STATE(1407),
    [sym_template_string] = STATE(1407),
    [sym_regex] = STATE(1407),
    [sym_meta_property] = STATE(1407),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1407),
    [sym_as_expression] = STATE(1407),
    [sym_internal_module] = STATE(1407),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1533),
    [sym_this] = ACTIONS(1535),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1535),
    [sym_false] = ACTIONS(1535),
    [sym_null] = ACTIONS(1535),
    [sym_undefined] = ACTIONS(1535),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [185] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1663),
    [sym_yield_expression] = STATE(1663),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1266),
    [sym_jsx_element] = STATE(1663),
    [sym_jsx_fragment] = STATE(1663),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1663),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(1099),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1663),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1663),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1663),
    [sym_augmented_assignment_expression] = STATE(1663),
    [sym_ternary_expression] = STATE(1663),
    [sym_binary_expression] = STATE(1663),
    [sym_unary_expression] = STATE(1663),
    [sym_update_expression] = STATE(1663),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1663),
    [sym_as_expression] = STATE(1663),
    [sym_internal_module] = STATE(1663),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_get] = ACTIONS(1539),
    [anon_sym_set] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_public] = ACTIONS(1539),
    [anon_sym_private] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [sym_readonly] = ACTIONS(1539),
  },
  [186] = {
    [sym_import] = STATE(1326),
    [sym_statement_block] = STATE(1500),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1326),
    [sym_jsx_fragment] = STATE(1326),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1326),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1326),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1555),
    [sym_this] = ACTIONS(1557),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1557),
    [sym_undefined] = ACTIONS(1557),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [187] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1559),
    [anon_sym_export] = ACTIONS(1561),
    [anon_sym_namespace] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1565),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1567),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_get] = ACTIONS(1561),
    [anon_sym_set] = ACTIONS(1561),
    [anon_sym_declare] = ACTIONS(1561),
    [anon_sym_public] = ACTIONS(1561),
    [anon_sym_private] = ACTIONS(1561),
    [anon_sym_protected] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_any] = ACTIONS(1561),
    [anon_sym_number] = ACTIONS(1561),
    [anon_sym_boolean] = ACTIONS(1561),
    [anon_sym_string] = ACTIONS(1561),
    [anon_sym_symbol] = ACTIONS(1561),
    [sym_readonly] = ACTIONS(1561),
  },
  [188] = {
    [sym_import] = STATE(1103),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1103),
    [sym_yield_expression] = STATE(1103),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1103),
    [sym_jsx_fragment] = STATE(1103),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1103),
    [sym_class] = STATE(1103),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1103),
    [sym_arrow_function] = STATE(1103),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1103),
    [sym_new_expression] = STATE(1103),
    [sym_await_expression] = STATE(1103),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1103),
    [sym_augmented_assignment_expression] = STATE(1103),
    [sym_ternary_expression] = STATE(1103),
    [sym_binary_expression] = STATE(1103),
    [sym_unary_expression] = STATE(1103),
    [sym_update_expression] = STATE(1103),
    [sym_sequence_expression] = STATE(3084),
    [sym_string] = STATE(1103),
    [sym_template_string] = STATE(1103),
    [sym_regex] = STATE(1103),
    [sym_meta_property] = STATE(1103),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1103),
    [sym_as_expression] = STATE(1103),
    [sym_internal_module] = STATE(1103),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1569),
    [sym_this] = ACTIONS(1571),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1571),
    [sym_false] = ACTIONS(1571),
    [sym_null] = ACTIONS(1571),
    [sym_undefined] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [189] = {
    [sym_import] = STATE(1195),
    [sym_statement_block] = STATE(1048),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1195),
    [sym_yield_expression] = STATE(1195),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1195),
    [sym_jsx_fragment] = STATE(1195),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1195),
    [sym_class] = STATE(1195),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1195),
    [sym_arrow_function] = STATE(1195),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1195),
    [sym_new_expression] = STATE(1195),
    [sym_await_expression] = STATE(1195),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1195),
    [sym_augmented_assignment_expression] = STATE(1195),
    [sym_ternary_expression] = STATE(1195),
    [sym_binary_expression] = STATE(1195),
    [sym_unary_expression] = STATE(1195),
    [sym_update_expression] = STATE(1195),
    [sym_string] = STATE(1195),
    [sym_template_string] = STATE(1195),
    [sym_regex] = STATE(1195),
    [sym_meta_property] = STATE(1195),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1195),
    [sym_as_expression] = STATE(1195),
    [sym_internal_module] = STATE(1195),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1573),
    [sym_this] = ACTIONS(1575),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1575),
    [sym_false] = ACTIONS(1575),
    [sym_null] = ACTIONS(1575),
    [sym_undefined] = ACTIONS(1575),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [190] = {
    [sym_import] = STATE(1196),
    [sym_statement_block] = STATE(1056),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1196),
    [sym_yield_expression] = STATE(1196),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1196),
    [sym_jsx_fragment] = STATE(1196),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1196),
    [sym_class] = STATE(1196),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1196),
    [sym_arrow_function] = STATE(1196),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1196),
    [sym_new_expression] = STATE(1196),
    [sym_await_expression] = STATE(1196),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1196),
    [sym_augmented_assignment_expression] = STATE(1196),
    [sym_ternary_expression] = STATE(1196),
    [sym_binary_expression] = STATE(1196),
    [sym_unary_expression] = STATE(1196),
    [sym_update_expression] = STATE(1196),
    [sym_string] = STATE(1196),
    [sym_template_string] = STATE(1196),
    [sym_regex] = STATE(1196),
    [sym_meta_property] = STATE(1196),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1196),
    [sym_as_expression] = STATE(1196),
    [sym_internal_module] = STATE(1196),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1577),
    [sym_this] = ACTIONS(1579),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1579),
    [sym_false] = ACTIONS(1579),
    [sym_null] = ACTIONS(1579),
    [sym_undefined] = ACTIONS(1579),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [191] = {
    [sym_import] = STATE(1228),
    [sym_statement_block] = STATE(1060),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1228),
    [sym_yield_expression] = STATE(1228),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1228),
    [sym_jsx_fragment] = STATE(1228),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1228),
    [sym_class] = STATE(1228),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1228),
    [sym_arrow_function] = STATE(1228),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1228),
    [sym_new_expression] = STATE(1228),
    [sym_await_expression] = STATE(1228),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1228),
    [sym_augmented_assignment_expression] = STATE(1228),
    [sym_ternary_expression] = STATE(1228),
    [sym_binary_expression] = STATE(1228),
    [sym_unary_expression] = STATE(1228),
    [sym_update_expression] = STATE(1228),
    [sym_string] = STATE(1228),
    [sym_template_string] = STATE(1228),
    [sym_regex] = STATE(1228),
    [sym_meta_property] = STATE(1228),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1228),
    [sym_as_expression] = STATE(1228),
    [sym_internal_module] = STATE(1228),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1581),
    [sym_this] = ACTIONS(1583),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1583),
    [sym_false] = ACTIONS(1583),
    [sym_null] = ACTIONS(1583),
    [sym_undefined] = ACTIONS(1583),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [192] = {
    [sym_import] = STATE(1197),
    [sym_statement_block] = STATE(1060),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1197),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1197),
    [sym_jsx_fragment] = STATE(1197),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1197),
    [sym_class] = STATE(1197),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1197),
    [sym_arrow_function] = STATE(1197),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1197),
    [sym_new_expression] = STATE(1197),
    [sym_await_expression] = STATE(1197),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1197),
    [sym_augmented_assignment_expression] = STATE(1197),
    [sym_ternary_expression] = STATE(1197),
    [sym_binary_expression] = STATE(1197),
    [sym_unary_expression] = STATE(1197),
    [sym_update_expression] = STATE(1197),
    [sym_string] = STATE(1197),
    [sym_template_string] = STATE(1197),
    [sym_regex] = STATE(1197),
    [sym_meta_property] = STATE(1197),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1197),
    [sym_as_expression] = STATE(1197),
    [sym_internal_module] = STATE(1197),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1585),
    [sym_this] = ACTIONS(1587),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1587),
    [sym_false] = ACTIONS(1587),
    [sym_null] = ACTIONS(1587),
    [sym_undefined] = ACTIONS(1587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [193] = {
    [sym_import] = STATE(1199),
    [sym_statement_block] = STATE(1064),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1199),
    [sym_yield_expression] = STATE(1199),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1199),
    [sym_jsx_fragment] = STATE(1199),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1199),
    [sym_class] = STATE(1199),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1199),
    [sym_arrow_function] = STATE(1199),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1199),
    [sym_new_expression] = STATE(1199),
    [sym_await_expression] = STATE(1199),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1199),
    [sym_augmented_assignment_expression] = STATE(1199),
    [sym_ternary_expression] = STATE(1199),
    [sym_binary_expression] = STATE(1199),
    [sym_unary_expression] = STATE(1199),
    [sym_update_expression] = STATE(1199),
    [sym_string] = STATE(1199),
    [sym_template_string] = STATE(1199),
    [sym_regex] = STATE(1199),
    [sym_meta_property] = STATE(1199),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1199),
    [sym_as_expression] = STATE(1199),
    [sym_internal_module] = STATE(1199),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1589),
    [sym_this] = ACTIONS(1591),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1591),
    [sym_false] = ACTIONS(1591),
    [sym_null] = ACTIONS(1591),
    [sym_undefined] = ACTIONS(1591),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [194] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1593),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(786),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [195] = {
    [sym_import] = STATE(1399),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1399),
    [sym_yield_expression] = STATE(1399),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1399),
    [sym_jsx_fragment] = STATE(1399),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1399),
    [sym_class] = STATE(1399),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1399),
    [sym_arrow_function] = STATE(1399),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1399),
    [sym_new_expression] = STATE(1399),
    [sym_await_expression] = STATE(1399),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1399),
    [sym_augmented_assignment_expression] = STATE(1399),
    [sym_ternary_expression] = STATE(1399),
    [sym_binary_expression] = STATE(1399),
    [sym_unary_expression] = STATE(1399),
    [sym_update_expression] = STATE(1399),
    [sym_sequence_expression] = STATE(3101),
    [sym_string] = STATE(1399),
    [sym_template_string] = STATE(1399),
    [sym_regex] = STATE(1399),
    [sym_meta_property] = STATE(1399),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1399),
    [sym_as_expression] = STATE(1399),
    [sym_internal_module] = STATE(1399),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1595),
    [sym_this] = ACTIONS(1597),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1597),
    [sym_false] = ACTIONS(1597),
    [sym_null] = ACTIONS(1597),
    [sym_undefined] = ACTIONS(1597),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [196] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2671),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [197] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1559),
    [anon_sym_export] = ACTIONS(1561),
    [anon_sym_namespace] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1565),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1567),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1561),
    [anon_sym_get] = ACTIONS(1561),
    [anon_sym_set] = ACTIONS(1561),
    [anon_sym_declare] = ACTIONS(1561),
    [anon_sym_public] = ACTIONS(1561),
    [anon_sym_private] = ACTIONS(1561),
    [anon_sym_protected] = ACTIONS(1561),
    [anon_sym_module] = ACTIONS(1561),
    [anon_sym_any] = ACTIONS(1561),
    [anon_sym_number] = ACTIONS(1561),
    [anon_sym_boolean] = ACTIONS(1561),
    [anon_sym_string] = ACTIONS(1561),
    [anon_sym_symbol] = ACTIONS(1561),
    [sym_readonly] = ACTIONS(1561),
  },
  [198] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1642),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(748),
    [sym_this] = ACTIONS(750),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_undefined] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [199] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2733),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2869),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1525),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [sym_readonly] = ACTIONS(1517),
  },
  [200] = {
    [sym_import] = STATE(1392),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1392),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1392),
    [sym_jsx_fragment] = STATE(1392),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1392),
    [sym_class] = STATE(1392),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1392),
    [sym_arrow_function] = STATE(1392),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1392),
    [sym_new_expression] = STATE(1392),
    [sym_await_expression] = STATE(1392),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1392),
    [sym_augmented_assignment_expression] = STATE(1392),
    [sym_ternary_expression] = STATE(1392),
    [sym_binary_expression] = STATE(1392),
    [sym_unary_expression] = STATE(1392),
    [sym_update_expression] = STATE(1392),
    [sym_sequence_expression] = STATE(3091),
    [sym_string] = STATE(1392),
    [sym_template_string] = STATE(1392),
    [sym_regex] = STATE(1392),
    [sym_meta_property] = STATE(1392),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1392),
    [sym_as_expression] = STATE(1392),
    [sym_internal_module] = STATE(1392),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1644),
    [sym_this] = ACTIONS(1646),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1646),
    [sym_false] = ACTIONS(1646),
    [sym_null] = ACTIONS(1646),
    [sym_undefined] = ACTIONS(1646),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [201] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1648),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1650),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1656),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1650),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
    [anon_sym_declare] = ACTIONS(1650),
    [anon_sym_public] = ACTIONS(1650),
    [anon_sym_private] = ACTIONS(1650),
    [anon_sym_protected] = ACTIONS(1650),
    [anon_sym_module] = ACTIONS(1650),
    [anon_sym_any] = ACTIONS(1650),
    [anon_sym_number] = ACTIONS(1650),
    [anon_sym_boolean] = ACTIONS(1650),
    [anon_sym_string] = ACTIONS(1650),
    [anon_sym_symbol] = ACTIONS(1650),
    [sym_readonly] = ACTIONS(1650),
  },
  [202] = {
    [sym_import] = STATE(1591),
    [sym_variable_declarator] = STATE(2520),
    [sym_parenthesized_expression] = STATE(932),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(1006),
    [sym_array] = STATE(1018),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1591),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1591),
    [sym_arrow_function] = STATE(1591),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1591),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(932),
    [sym_subscript_expression] = STATE(932),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1591),
    [sym_template_string] = STATE(1591),
    [sym_regex] = STATE(1591),
    [sym_meta_property] = STATE(1591),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(1660),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1660),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1666),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1417),
    [sym_this] = ACTIONS(1419),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_null] = ACTIONS(1419),
    [sym_undefined] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_get] = ACTIONS(1660),
    [anon_sym_set] = ACTIONS(1660),
    [anon_sym_declare] = ACTIONS(1660),
    [anon_sym_public] = ACTIONS(1660),
    [anon_sym_private] = ACTIONS(1660),
    [anon_sym_protected] = ACTIONS(1660),
    [anon_sym_module] = ACTIONS(1660),
    [anon_sym_any] = ACTIONS(1660),
    [anon_sym_number] = ACTIONS(1660),
    [anon_sym_boolean] = ACTIONS(1660),
    [anon_sym_string] = ACTIONS(1660),
    [anon_sym_symbol] = ACTIONS(1660),
    [sym_readonly] = ACTIONS(1660),
  },
  [203] = {
    [sym_import] = STATE(1591),
    [sym_variable_declarator] = STATE(2472),
    [sym_parenthesized_expression] = STATE(932),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(1006),
    [sym_array] = STATE(1018),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1591),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1591),
    [sym_arrow_function] = STATE(1591),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1591),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(932),
    [sym_subscript_expression] = STATE(932),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1591),
    [sym_template_string] = STATE(1591),
    [sym_regex] = STATE(1591),
    [sym_meta_property] = STATE(1591),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1658),
    [anon_sym_export] = ACTIONS(1660),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1660),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1666),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1417),
    [sym_this] = ACTIONS(1419),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_null] = ACTIONS(1419),
    [sym_undefined] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_get] = ACTIONS(1660),
    [anon_sym_set] = ACTIONS(1660),
    [anon_sym_declare] = ACTIONS(1660),
    [anon_sym_public] = ACTIONS(1660),
    [anon_sym_private] = ACTIONS(1660),
    [anon_sym_protected] = ACTIONS(1660),
    [anon_sym_module] = ACTIONS(1660),
    [anon_sym_any] = ACTIONS(1660),
    [anon_sym_number] = ACTIONS(1660),
    [anon_sym_boolean] = ACTIONS(1660),
    [anon_sym_string] = ACTIONS(1660),
    [anon_sym_symbol] = ACTIONS(1660),
    [sym_readonly] = ACTIONS(1660),
  },
  [204] = {
    [sym_import] = STATE(1390),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1390),
    [sym_yield_expression] = STATE(1390),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1390),
    [sym_jsx_fragment] = STATE(1390),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1390),
    [sym_class] = STATE(1390),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1390),
    [sym_arrow_function] = STATE(1390),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1390),
    [sym_new_expression] = STATE(1390),
    [sym_await_expression] = STATE(1390),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1390),
    [sym_augmented_assignment_expression] = STATE(1390),
    [sym_ternary_expression] = STATE(1390),
    [sym_binary_expression] = STATE(1390),
    [sym_unary_expression] = STATE(1390),
    [sym_update_expression] = STATE(1390),
    [sym_sequence_expression] = STATE(3061),
    [sym_string] = STATE(1390),
    [sym_template_string] = STATE(1390),
    [sym_regex] = STATE(1390),
    [sym_meta_property] = STATE(1390),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1390),
    [sym_as_expression] = STATE(1390),
    [sym_internal_module] = STATE(1390),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1668),
    [sym_this] = ACTIONS(1670),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1670),
    [sym_false] = ACTIONS(1670),
    [sym_null] = ACTIONS(1670),
    [sym_undefined] = ACTIONS(1670),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [205] = {
    [sym_import] = STATE(1127),
    [sym_statement_block] = STATE(1438),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1127),
    [sym_yield_expression] = STATE(1127),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1127),
    [sym_jsx_fragment] = STATE(1127),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1127),
    [sym_class] = STATE(1127),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1127),
    [sym_arrow_function] = STATE(1127),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1127),
    [sym_new_expression] = STATE(1127),
    [sym_await_expression] = STATE(1127),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1127),
    [sym_augmented_assignment_expression] = STATE(1127),
    [sym_ternary_expression] = STATE(1127),
    [sym_binary_expression] = STATE(1127),
    [sym_unary_expression] = STATE(1127),
    [sym_update_expression] = STATE(1127),
    [sym_string] = STATE(1127),
    [sym_template_string] = STATE(1127),
    [sym_regex] = STATE(1127),
    [sym_meta_property] = STATE(1127),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1127),
    [sym_as_expression] = STATE(1127),
    [sym_internal_module] = STATE(1127),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1672),
    [sym_this] = ACTIONS(1674),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1674),
    [sym_false] = ACTIONS(1674),
    [sym_null] = ACTIONS(1674),
    [sym_undefined] = ACTIONS(1674),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [206] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1676),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [207] = {
    [sym_import] = STATE(1181),
    [sym_statement_block] = STATE(1668),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1181),
    [sym_yield_expression] = STATE(1181),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1181),
    [sym_jsx_fragment] = STATE(1181),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1181),
    [sym_class] = STATE(1181),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1181),
    [sym_arrow_function] = STATE(1181),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1181),
    [sym_new_expression] = STATE(1181),
    [sym_await_expression] = STATE(1181),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1181),
    [sym_augmented_assignment_expression] = STATE(1181),
    [sym_ternary_expression] = STATE(1181),
    [sym_binary_expression] = STATE(1181),
    [sym_unary_expression] = STATE(1181),
    [sym_update_expression] = STATE(1181),
    [sym_string] = STATE(1181),
    [sym_template_string] = STATE(1181),
    [sym_regex] = STATE(1181),
    [sym_meta_property] = STATE(1181),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1181),
    [sym_as_expression] = STATE(1181),
    [sym_internal_module] = STATE(1181),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1680),
    [sym_this] = ACTIONS(1682),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1682),
    [sym_false] = ACTIONS(1682),
    [sym_null] = ACTIONS(1682),
    [sym_undefined] = ACTIONS(1682),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [208] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1684),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [209] = {
    [sym_import] = STATE(972),
    [sym_statement_block] = STATE(1051),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(972),
    [sym_yield_expression] = STATE(972),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(972),
    [sym_jsx_fragment] = STATE(972),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(972),
    [sym_class] = STATE(972),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(972),
    [sym_arrow_function] = STATE(972),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(972),
    [sym_new_expression] = STATE(972),
    [sym_await_expression] = STATE(972),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(972),
    [sym_augmented_assignment_expression] = STATE(972),
    [sym_ternary_expression] = STATE(972),
    [sym_binary_expression] = STATE(972),
    [sym_unary_expression] = STATE(972),
    [sym_update_expression] = STATE(972),
    [sym_string] = STATE(972),
    [sym_template_string] = STATE(972),
    [sym_regex] = STATE(972),
    [sym_meta_property] = STATE(972),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(972),
    [sym_as_expression] = STATE(972),
    [sym_internal_module] = STATE(972),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1686),
    [sym_this] = ACTIONS(1688),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_undefined] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [210] = {
    [sym_import] = STATE(1180),
    [sym_statement_block] = STATE(1038),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1180),
    [sym_yield_expression] = STATE(1180),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1180),
    [sym_jsx_fragment] = STATE(1180),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1180),
    [sym_class] = STATE(1180),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1180),
    [sym_arrow_function] = STATE(1180),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1180),
    [sym_new_expression] = STATE(1180),
    [sym_await_expression] = STATE(1180),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1180),
    [sym_augmented_assignment_expression] = STATE(1180),
    [sym_ternary_expression] = STATE(1180),
    [sym_binary_expression] = STATE(1180),
    [sym_unary_expression] = STATE(1180),
    [sym_update_expression] = STATE(1180),
    [sym_string] = STATE(1180),
    [sym_template_string] = STATE(1180),
    [sym_regex] = STATE(1180),
    [sym_meta_property] = STATE(1180),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1180),
    [sym_as_expression] = STATE(1180),
    [sym_internal_module] = STATE(1180),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1690),
    [sym_this] = ACTIONS(1692),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_null] = ACTIONS(1692),
    [sym_undefined] = ACTIONS(1692),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [211] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1648),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_namespace] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1650),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1654),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1656),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1650),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
    [anon_sym_declare] = ACTIONS(1650),
    [anon_sym_public] = ACTIONS(1650),
    [anon_sym_private] = ACTIONS(1650),
    [anon_sym_protected] = ACTIONS(1650),
    [anon_sym_module] = ACTIONS(1650),
    [anon_sym_any] = ACTIONS(1650),
    [anon_sym_number] = ACTIONS(1650),
    [anon_sym_boolean] = ACTIONS(1650),
    [anon_sym_string] = ACTIONS(1650),
    [anon_sym_symbol] = ACTIONS(1650),
    [sym_readonly] = ACTIONS(1650),
  },
  [212] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1694),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [213] = {
    [sym_import] = STATE(1227),
    [sym_statement_block] = STATE(1064),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1227),
    [sym_yield_expression] = STATE(1227),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1227),
    [sym_jsx_fragment] = STATE(1227),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1227),
    [sym_class] = STATE(1227),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1227),
    [sym_arrow_function] = STATE(1227),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1227),
    [sym_new_expression] = STATE(1227),
    [sym_await_expression] = STATE(1227),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1227),
    [sym_augmented_assignment_expression] = STATE(1227),
    [sym_ternary_expression] = STATE(1227),
    [sym_binary_expression] = STATE(1227),
    [sym_unary_expression] = STATE(1227),
    [sym_update_expression] = STATE(1227),
    [sym_string] = STATE(1227),
    [sym_template_string] = STATE(1227),
    [sym_regex] = STATE(1227),
    [sym_meta_property] = STATE(1227),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1227),
    [sym_as_expression] = STATE(1227),
    [sym_internal_module] = STATE(1227),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1696),
    [sym_this] = ACTIONS(1698),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1698),
    [sym_false] = ACTIONS(1698),
    [sym_null] = ACTIONS(1698),
    [sym_undefined] = ACTIONS(1698),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [214] = {
    [sym_import] = STATE(1129),
    [sym_statement_block] = STATE(1434),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1129),
    [sym_yield_expression] = STATE(1129),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1129),
    [sym_jsx_fragment] = STATE(1129),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1129),
    [sym_class] = STATE(1129),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1129),
    [sym_arrow_function] = STATE(1129),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1129),
    [sym_new_expression] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1129),
    [sym_augmented_assignment_expression] = STATE(1129),
    [sym_ternary_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_update_expression] = STATE(1129),
    [sym_string] = STATE(1129),
    [sym_template_string] = STATE(1129),
    [sym_regex] = STATE(1129),
    [sym_meta_property] = STATE(1129),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1129),
    [sym_as_expression] = STATE(1129),
    [sym_internal_module] = STATE(1129),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1700),
    [sym_this] = ACTIONS(1702),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1702),
    [sym_false] = ACTIONS(1702),
    [sym_null] = ACTIONS(1702),
    [sym_undefined] = ACTIONS(1702),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [215] = {
    [sym_import] = STATE(977),
    [sym_statement_block] = STATE(1064),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(977),
    [sym_yield_expression] = STATE(977),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(977),
    [sym_jsx_fragment] = STATE(977),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(977),
    [sym_class] = STATE(977),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(977),
    [sym_arrow_function] = STATE(977),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(977),
    [sym_new_expression] = STATE(977),
    [sym_await_expression] = STATE(977),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(977),
    [sym_augmented_assignment_expression] = STATE(977),
    [sym_ternary_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_update_expression] = STATE(977),
    [sym_string] = STATE(977),
    [sym_template_string] = STATE(977),
    [sym_regex] = STATE(977),
    [sym_meta_property] = STATE(977),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(977),
    [sym_as_expression] = STATE(977),
    [sym_internal_module] = STATE(977),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1704),
    [sym_this] = ACTIONS(1706),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1706),
    [sym_false] = ACTIONS(1706),
    [sym_null] = ACTIONS(1706),
    [sym_undefined] = ACTIONS(1706),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [216] = {
    [sym_import] = STATE(1186),
    [sym_statement_block] = STATE(1051),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1186),
    [sym_yield_expression] = STATE(1186),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1186),
    [sym_jsx_fragment] = STATE(1186),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1186),
    [sym_class] = STATE(1186),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1186),
    [sym_arrow_function] = STATE(1186),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1186),
    [sym_new_expression] = STATE(1186),
    [sym_await_expression] = STATE(1186),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1186),
    [sym_augmented_assignment_expression] = STATE(1186),
    [sym_ternary_expression] = STATE(1186),
    [sym_binary_expression] = STATE(1186),
    [sym_unary_expression] = STATE(1186),
    [sym_update_expression] = STATE(1186),
    [sym_string] = STATE(1186),
    [sym_template_string] = STATE(1186),
    [sym_regex] = STATE(1186),
    [sym_meta_property] = STATE(1186),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1186),
    [sym_as_expression] = STATE(1186),
    [sym_internal_module] = STATE(1186),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1708),
    [sym_this] = ACTIONS(1710),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1710),
    [sym_false] = ACTIONS(1710),
    [sym_null] = ACTIONS(1710),
    [sym_undefined] = ACTIONS(1710),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [217] = {
    [sym_import] = STATE(1330),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1330),
    [sym_yield_expression] = STATE(1330),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1330),
    [sym_jsx_fragment] = STATE(1330),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1330),
    [sym_class] = STATE(1330),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1330),
    [sym_arrow_function] = STATE(1330),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1330),
    [sym_new_expression] = STATE(1330),
    [sym_await_expression] = STATE(1330),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1330),
    [sym_augmented_assignment_expression] = STATE(1330),
    [sym_ternary_expression] = STATE(1330),
    [sym_binary_expression] = STATE(1330),
    [sym_unary_expression] = STATE(1330),
    [sym_update_expression] = STATE(1330),
    [sym_sequence_expression] = STATE(3139),
    [sym_string] = STATE(1330),
    [sym_template_string] = STATE(1330),
    [sym_regex] = STATE(1330),
    [sym_meta_property] = STATE(1330),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1330),
    [sym_as_expression] = STATE(1330),
    [sym_internal_module] = STATE(1330),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1712),
    [sym_this] = ACTIONS(1714),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1714),
    [sym_false] = ACTIONS(1714),
    [sym_null] = ACTIONS(1714),
    [sym_undefined] = ACTIONS(1714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [218] = {
    [sym_import] = STATE(1334),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1334),
    [sym_yield_expression] = STATE(1334),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1334),
    [sym_jsx_fragment] = STATE(1334),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1334),
    [sym_class] = STATE(1334),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1334),
    [sym_arrow_function] = STATE(1334),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1334),
    [sym_new_expression] = STATE(1334),
    [sym_await_expression] = STATE(1334),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1334),
    [sym_augmented_assignment_expression] = STATE(1334),
    [sym_ternary_expression] = STATE(1334),
    [sym_binary_expression] = STATE(1334),
    [sym_unary_expression] = STATE(1334),
    [sym_update_expression] = STATE(1334),
    [sym_sequence_expression] = STATE(3138),
    [sym_string] = STATE(1334),
    [sym_template_string] = STATE(1334),
    [sym_regex] = STATE(1334),
    [sym_meta_property] = STATE(1334),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1334),
    [sym_as_expression] = STATE(1334),
    [sym_internal_module] = STATE(1334),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1716),
    [sym_this] = ACTIONS(1718),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1718),
    [sym_false] = ACTIONS(1718),
    [sym_null] = ACTIONS(1718),
    [sym_undefined] = ACTIONS(1718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [219] = {
    [sym_import] = STATE(1229),
    [sym_statement_block] = STATE(1056),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1229),
    [sym_yield_expression] = STATE(1229),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1229),
    [sym_jsx_fragment] = STATE(1229),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1229),
    [sym_class] = STATE(1229),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1229),
    [sym_arrow_function] = STATE(1229),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1229),
    [sym_new_expression] = STATE(1229),
    [sym_await_expression] = STATE(1229),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1229),
    [sym_augmented_assignment_expression] = STATE(1229),
    [sym_ternary_expression] = STATE(1229),
    [sym_binary_expression] = STATE(1229),
    [sym_unary_expression] = STATE(1229),
    [sym_update_expression] = STATE(1229),
    [sym_string] = STATE(1229),
    [sym_template_string] = STATE(1229),
    [sym_regex] = STATE(1229),
    [sym_meta_property] = STATE(1229),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1229),
    [sym_as_expression] = STATE(1229),
    [sym_internal_module] = STATE(1229),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1720),
    [sym_this] = ACTIONS(1722),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1722),
    [sym_false] = ACTIONS(1722),
    [sym_null] = ACTIONS(1722),
    [sym_undefined] = ACTIONS(1722),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [220] = {
    [sym_import] = STATE(1340),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1340),
    [sym_yield_expression] = STATE(1340),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1340),
    [sym_jsx_fragment] = STATE(1340),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1340),
    [sym_class] = STATE(1340),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1340),
    [sym_arrow_function] = STATE(1340),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1340),
    [sym_new_expression] = STATE(1340),
    [sym_await_expression] = STATE(1340),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1340),
    [sym_augmented_assignment_expression] = STATE(1340),
    [sym_ternary_expression] = STATE(1340),
    [sym_binary_expression] = STATE(1340),
    [sym_unary_expression] = STATE(1340),
    [sym_update_expression] = STATE(1340),
    [sym_sequence_expression] = STATE(3135),
    [sym_string] = STATE(1340),
    [sym_template_string] = STATE(1340),
    [sym_regex] = STATE(1340),
    [sym_meta_property] = STATE(1340),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1340),
    [sym_as_expression] = STATE(1340),
    [sym_internal_module] = STATE(1340),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1724),
    [sym_this] = ACTIONS(1726),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1726),
    [sym_false] = ACTIONS(1726),
    [sym_null] = ACTIONS(1726),
    [sym_undefined] = ACTIONS(1726),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [221] = {
    [sym_import] = STATE(1021),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1021),
    [sym_yield_expression] = STATE(1021),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1021),
    [sym_jsx_fragment] = STATE(1021),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1021),
    [sym_class] = STATE(1021),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1021),
    [sym_arrow_function] = STATE(1021),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1021),
    [sym_new_expression] = STATE(1021),
    [sym_await_expression] = STATE(1021),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1021),
    [sym_augmented_assignment_expression] = STATE(1021),
    [sym_ternary_expression] = STATE(1021),
    [sym_binary_expression] = STATE(1021),
    [sym_unary_expression] = STATE(1021),
    [sym_update_expression] = STATE(1021),
    [sym_sequence_expression] = STATE(3106),
    [sym_string] = STATE(1021),
    [sym_template_string] = STATE(1021),
    [sym_regex] = STATE(1021),
    [sym_meta_property] = STATE(1021),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1021),
    [sym_as_expression] = STATE(1021),
    [sym_internal_module] = STATE(1021),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1728),
    [sym_this] = ACTIONS(1730),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_null] = ACTIONS(1730),
    [sym_undefined] = ACTIONS(1730),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [222] = {
    [sym_import] = STATE(1230),
    [sym_statement_block] = STATE(1048),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1230),
    [sym_yield_expression] = STATE(1230),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1230),
    [sym_jsx_fragment] = STATE(1230),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1230),
    [sym_class] = STATE(1230),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1230),
    [sym_arrow_function] = STATE(1230),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1230),
    [sym_new_expression] = STATE(1230),
    [sym_await_expression] = STATE(1230),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1230),
    [sym_augmented_assignment_expression] = STATE(1230),
    [sym_ternary_expression] = STATE(1230),
    [sym_binary_expression] = STATE(1230),
    [sym_unary_expression] = STATE(1230),
    [sym_update_expression] = STATE(1230),
    [sym_string] = STATE(1230),
    [sym_template_string] = STATE(1230),
    [sym_regex] = STATE(1230),
    [sym_meta_property] = STATE(1230),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1230),
    [sym_as_expression] = STATE(1230),
    [sym_internal_module] = STATE(1230),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1732),
    [sym_this] = ACTIONS(1734),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1734),
    [sym_false] = ACTIONS(1734),
    [sym_null] = ACTIONS(1734),
    [sym_undefined] = ACTIONS(1734),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [223] = {
    [sym_import] = STATE(1205),
    [sym_statement_block] = STATE(1593),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1205),
    [sym_yield_expression] = STATE(1205),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1205),
    [sym_jsx_fragment] = STATE(1205),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1205),
    [sym_class] = STATE(1205),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1205),
    [sym_arrow_function] = STATE(1205),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1205),
    [sym_new_expression] = STATE(1205),
    [sym_await_expression] = STATE(1205),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1205),
    [sym_augmented_assignment_expression] = STATE(1205),
    [sym_ternary_expression] = STATE(1205),
    [sym_binary_expression] = STATE(1205),
    [sym_unary_expression] = STATE(1205),
    [sym_update_expression] = STATE(1205),
    [sym_string] = STATE(1205),
    [sym_template_string] = STATE(1205),
    [sym_regex] = STATE(1205),
    [sym_meta_property] = STATE(1205),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1205),
    [sym_as_expression] = STATE(1205),
    [sym_internal_module] = STATE(1205),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1736),
    [sym_this] = ACTIONS(1738),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1738),
    [sym_false] = ACTIONS(1738),
    [sym_null] = ACTIONS(1738),
    [sym_undefined] = ACTIONS(1738),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [224] = {
    [sym_import] = STATE(1335),
    [sym_statement_block] = STATE(1508),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1335),
    [sym_yield_expression] = STATE(1335),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1335),
    [sym_jsx_fragment] = STATE(1335),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1335),
    [sym_class] = STATE(1335),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1335),
    [sym_arrow_function] = STATE(1335),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1335),
    [sym_new_expression] = STATE(1335),
    [sym_await_expression] = STATE(1335),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1335),
    [sym_augmented_assignment_expression] = STATE(1335),
    [sym_ternary_expression] = STATE(1335),
    [sym_binary_expression] = STATE(1335),
    [sym_unary_expression] = STATE(1335),
    [sym_update_expression] = STATE(1335),
    [sym_string] = STATE(1335),
    [sym_template_string] = STATE(1335),
    [sym_regex] = STATE(1335),
    [sym_meta_property] = STATE(1335),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1335),
    [sym_as_expression] = STATE(1335),
    [sym_internal_module] = STATE(1335),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1740),
    [sym_this] = ACTIONS(1742),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_null] = ACTIONS(1742),
    [sym_undefined] = ACTIONS(1742),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [225] = {
    [sym_import] = STATE(1344),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1344),
    [sym_yield_expression] = STATE(1344),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1344),
    [sym_jsx_fragment] = STATE(1344),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1344),
    [sym_class] = STATE(1344),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1344),
    [sym_arrow_function] = STATE(1344),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1344),
    [sym_new_expression] = STATE(1344),
    [sym_await_expression] = STATE(1344),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1344),
    [sym_augmented_assignment_expression] = STATE(1344),
    [sym_ternary_expression] = STATE(1344),
    [sym_binary_expression] = STATE(1344),
    [sym_unary_expression] = STATE(1344),
    [sym_update_expression] = STATE(1344),
    [sym_sequence_expression] = STATE(3134),
    [sym_string] = STATE(1344),
    [sym_template_string] = STATE(1344),
    [sym_regex] = STATE(1344),
    [sym_meta_property] = STATE(1344),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1344),
    [sym_as_expression] = STATE(1344),
    [sym_internal_module] = STATE(1344),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1744),
    [sym_this] = ACTIONS(1746),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_undefined] = ACTIONS(1746),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [226] = {
    [sym_import] = STATE(973),
    [sym_statement_block] = STATE(1048),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(973),
    [sym_yield_expression] = STATE(973),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(973),
    [sym_jsx_fragment] = STATE(973),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(973),
    [sym_class] = STATE(973),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(973),
    [sym_arrow_function] = STATE(973),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(973),
    [sym_new_expression] = STATE(973),
    [sym_await_expression] = STATE(973),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(973),
    [sym_augmented_assignment_expression] = STATE(973),
    [sym_ternary_expression] = STATE(973),
    [sym_binary_expression] = STATE(973),
    [sym_unary_expression] = STATE(973),
    [sym_update_expression] = STATE(973),
    [sym_string] = STATE(973),
    [sym_template_string] = STATE(973),
    [sym_regex] = STATE(973),
    [sym_meta_property] = STATE(973),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(973),
    [sym_as_expression] = STATE(973),
    [sym_internal_module] = STATE(973),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1748),
    [sym_this] = ACTIONS(1750),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1750),
    [sym_false] = ACTIONS(1750),
    [sym_null] = ACTIONS(1750),
    [sym_undefined] = ACTIONS(1750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [227] = {
    [sym_import] = STATE(1338),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1338),
    [sym_yield_expression] = STATE(1338),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1338),
    [sym_jsx_fragment] = STATE(1338),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1338),
    [sym_class] = STATE(1338),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1338),
    [sym_arrow_function] = STATE(1338),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1338),
    [sym_new_expression] = STATE(1338),
    [sym_await_expression] = STATE(1338),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1338),
    [sym_augmented_assignment_expression] = STATE(1338),
    [sym_ternary_expression] = STATE(1338),
    [sym_binary_expression] = STATE(1338),
    [sym_unary_expression] = STATE(1338),
    [sym_update_expression] = STATE(1338),
    [sym_sequence_expression] = STATE(3173),
    [sym_string] = STATE(1338),
    [sym_template_string] = STATE(1338),
    [sym_regex] = STATE(1338),
    [sym_meta_property] = STATE(1338),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1338),
    [sym_as_expression] = STATE(1338),
    [sym_internal_module] = STATE(1338),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1752),
    [sym_this] = ACTIONS(1754),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1754),
    [sym_false] = ACTIONS(1754),
    [sym_null] = ACTIONS(1754),
    [sym_undefined] = ACTIONS(1754),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [228] = {
    [sym_import] = STATE(1354),
    [sym_statement_block] = STATE(1478),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1354),
    [sym_yield_expression] = STATE(1354),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1354),
    [sym_jsx_fragment] = STATE(1354),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1354),
    [sym_class] = STATE(1354),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1354),
    [sym_arrow_function] = STATE(1354),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1354),
    [sym_new_expression] = STATE(1354),
    [sym_await_expression] = STATE(1354),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1354),
    [sym_augmented_assignment_expression] = STATE(1354),
    [sym_ternary_expression] = STATE(1354),
    [sym_binary_expression] = STATE(1354),
    [sym_unary_expression] = STATE(1354),
    [sym_update_expression] = STATE(1354),
    [sym_string] = STATE(1354),
    [sym_template_string] = STATE(1354),
    [sym_regex] = STATE(1354),
    [sym_meta_property] = STATE(1354),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1354),
    [sym_as_expression] = STATE(1354),
    [sym_internal_module] = STATE(1354),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1756),
    [sym_this] = ACTIONS(1758),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1758),
    [sym_false] = ACTIONS(1758),
    [sym_null] = ACTIONS(1758),
    [sym_undefined] = ACTIONS(1758),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [229] = {
    [sym_import] = STATE(1017),
    [sym_statement_block] = STATE(1060),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1017),
    [sym_yield_expression] = STATE(1017),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1017),
    [sym_jsx_fragment] = STATE(1017),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1017),
    [sym_class] = STATE(1017),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1017),
    [sym_arrow_function] = STATE(1017),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1017),
    [sym_new_expression] = STATE(1017),
    [sym_await_expression] = STATE(1017),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1017),
    [sym_augmented_assignment_expression] = STATE(1017),
    [sym_ternary_expression] = STATE(1017),
    [sym_binary_expression] = STATE(1017),
    [sym_unary_expression] = STATE(1017),
    [sym_update_expression] = STATE(1017),
    [sym_string] = STATE(1017),
    [sym_template_string] = STATE(1017),
    [sym_regex] = STATE(1017),
    [sym_meta_property] = STATE(1017),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1017),
    [sym_as_expression] = STATE(1017),
    [sym_internal_module] = STATE(1017),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1760),
    [sym_this] = ACTIONS(1762),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1762),
    [sym_false] = ACTIONS(1762),
    [sym_null] = ACTIONS(1762),
    [sym_undefined] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [230] = {
    [sym_import] = STATE(1284),
    [sym_statement_block] = STATE(1714),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1284),
    [sym_yield_expression] = STATE(1284),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1284),
    [sym_jsx_fragment] = STATE(1284),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1284),
    [sym_class] = STATE(1284),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1284),
    [sym_arrow_function] = STATE(1284),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1284),
    [sym_new_expression] = STATE(1284),
    [sym_await_expression] = STATE(1284),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1284),
    [sym_augmented_assignment_expression] = STATE(1284),
    [sym_ternary_expression] = STATE(1284),
    [sym_binary_expression] = STATE(1284),
    [sym_unary_expression] = STATE(1284),
    [sym_update_expression] = STATE(1284),
    [sym_string] = STATE(1284),
    [sym_template_string] = STATE(1284),
    [sym_regex] = STATE(1284),
    [sym_meta_property] = STATE(1284),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1284),
    [sym_as_expression] = STATE(1284),
    [sym_internal_module] = STATE(1284),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1764),
    [sym_this] = ACTIONS(1766),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1766),
    [sym_false] = ACTIONS(1766),
    [sym_null] = ACTIONS(1766),
    [sym_undefined] = ACTIONS(1766),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [231] = {
    [sym_import] = STATE(1371),
    [sym_statement_block] = STATE(1434),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1371),
    [sym_yield_expression] = STATE(1371),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1371),
    [sym_jsx_fragment] = STATE(1371),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1371),
    [sym_class] = STATE(1371),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1371),
    [sym_arrow_function] = STATE(1371),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1371),
    [sym_new_expression] = STATE(1371),
    [sym_await_expression] = STATE(1371),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1371),
    [sym_augmented_assignment_expression] = STATE(1371),
    [sym_ternary_expression] = STATE(1371),
    [sym_binary_expression] = STATE(1371),
    [sym_unary_expression] = STATE(1371),
    [sym_update_expression] = STATE(1371),
    [sym_string] = STATE(1371),
    [sym_template_string] = STATE(1371),
    [sym_regex] = STATE(1371),
    [sym_meta_property] = STATE(1371),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1371),
    [sym_as_expression] = STATE(1371),
    [sym_internal_module] = STATE(1371),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1768),
    [sym_this] = ACTIONS(1770),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1770),
    [sym_false] = ACTIONS(1770),
    [sym_null] = ACTIONS(1770),
    [sym_undefined] = ACTIONS(1770),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [232] = {
    [sym_import] = STATE(1372),
    [sym_statement_block] = STATE(1437),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1372),
    [sym_yield_expression] = STATE(1372),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1372),
    [sym_jsx_fragment] = STATE(1372),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1372),
    [sym_class] = STATE(1372),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1372),
    [sym_arrow_function] = STATE(1372),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1372),
    [sym_new_expression] = STATE(1372),
    [sym_await_expression] = STATE(1372),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1372),
    [sym_augmented_assignment_expression] = STATE(1372),
    [sym_ternary_expression] = STATE(1372),
    [sym_binary_expression] = STATE(1372),
    [sym_unary_expression] = STATE(1372),
    [sym_update_expression] = STATE(1372),
    [sym_string] = STATE(1372),
    [sym_template_string] = STATE(1372),
    [sym_regex] = STATE(1372),
    [sym_meta_property] = STATE(1372),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1372),
    [sym_as_expression] = STATE(1372),
    [sym_internal_module] = STATE(1372),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1772),
    [sym_this] = ACTIONS(1774),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1774),
    [sym_false] = ACTIONS(1774),
    [sym_null] = ACTIONS(1774),
    [sym_undefined] = ACTIONS(1774),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [233] = {
    [sym_import] = STATE(1370),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1370),
    [sym_yield_expression] = STATE(1370),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1370),
    [sym_jsx_fragment] = STATE(1370),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1370),
    [sym_class] = STATE(1370),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1370),
    [sym_arrow_function] = STATE(1370),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1370),
    [sym_new_expression] = STATE(1370),
    [sym_await_expression] = STATE(1370),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1370),
    [sym_augmented_assignment_expression] = STATE(1370),
    [sym_ternary_expression] = STATE(1370),
    [sym_binary_expression] = STATE(1370),
    [sym_unary_expression] = STATE(1370),
    [sym_update_expression] = STATE(1370),
    [sym_sequence_expression] = STATE(3186),
    [sym_string] = STATE(1370),
    [sym_template_string] = STATE(1370),
    [sym_regex] = STATE(1370),
    [sym_meta_property] = STATE(1370),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1370),
    [sym_as_expression] = STATE(1370),
    [sym_internal_module] = STATE(1370),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1776),
    [sym_this] = ACTIONS(1778),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1778),
    [sym_false] = ACTIONS(1778),
    [sym_null] = ACTIONS(1778),
    [sym_undefined] = ACTIONS(1778),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [234] = {
    [sym_import] = STATE(1373),
    [sym_statement_block] = STATE(1438),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1373),
    [sym_yield_expression] = STATE(1373),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1373),
    [sym_jsx_fragment] = STATE(1373),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1373),
    [sym_class] = STATE(1373),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1373),
    [sym_arrow_function] = STATE(1373),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1373),
    [sym_new_expression] = STATE(1373),
    [sym_await_expression] = STATE(1373),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1373),
    [sym_augmented_assignment_expression] = STATE(1373),
    [sym_ternary_expression] = STATE(1373),
    [sym_binary_expression] = STATE(1373),
    [sym_unary_expression] = STATE(1373),
    [sym_update_expression] = STATE(1373),
    [sym_string] = STATE(1373),
    [sym_template_string] = STATE(1373),
    [sym_regex] = STATE(1373),
    [sym_meta_property] = STATE(1373),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1373),
    [sym_as_expression] = STATE(1373),
    [sym_internal_module] = STATE(1373),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1780),
    [sym_this] = ACTIONS(1782),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1782),
    [sym_false] = ACTIONS(1782),
    [sym_null] = ACTIONS(1782),
    [sym_undefined] = ACTIONS(1782),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [235] = {
    [sym_import] = STATE(1369),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1369),
    [sym_arrow_function] = STATE(1369),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1369),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1784),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_null] = ACTIONS(694),
    [sym_undefined] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [236] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1663),
    [sym_yield_expression] = STATE(1663),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1266),
    [sym_jsx_element] = STATE(1663),
    [sym_jsx_fragment] = STATE(1663),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1663),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(1099),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1663),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1663),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1663),
    [sym_augmented_assignment_expression] = STATE(1663),
    [sym_ternary_expression] = STATE(1663),
    [sym_binary_expression] = STATE(1663),
    [sym_unary_expression] = STATE(1663),
    [sym_update_expression] = STATE(1663),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1663),
    [sym_as_expression] = STATE(1663),
    [sym_internal_module] = STATE(1663),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1794),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [sym_readonly] = ACTIONS(1788),
  },
  [237] = {
    [sym_import] = STATE(1083),
    [sym_statement_block] = STATE(1508),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1083),
    [sym_yield_expression] = STATE(1083),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1083),
    [sym_jsx_fragment] = STATE(1083),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1083),
    [sym_class] = STATE(1083),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1083),
    [sym_arrow_function] = STATE(1083),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1083),
    [sym_new_expression] = STATE(1083),
    [sym_await_expression] = STATE(1083),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1083),
    [sym_augmented_assignment_expression] = STATE(1083),
    [sym_ternary_expression] = STATE(1083),
    [sym_binary_expression] = STATE(1083),
    [sym_unary_expression] = STATE(1083),
    [sym_update_expression] = STATE(1083),
    [sym_string] = STATE(1083),
    [sym_template_string] = STATE(1083),
    [sym_regex] = STATE(1083),
    [sym_meta_property] = STATE(1083),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1083),
    [sym_as_expression] = STATE(1083),
    [sym_internal_module] = STATE(1083),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1796),
    [sym_this] = ACTIONS(1798),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1798),
    [sym_false] = ACTIONS(1798),
    [sym_null] = ACTIONS(1798),
    [sym_undefined] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [238] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1663),
    [sym_yield_expression] = STATE(1663),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1266),
    [sym_jsx_element] = STATE(1663),
    [sym_jsx_fragment] = STATE(1663),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1663),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(1099),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1663),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1663),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1663),
    [sym_augmented_assignment_expression] = STATE(1663),
    [sym_ternary_expression] = STATE(1663),
    [sym_binary_expression] = STATE(1663),
    [sym_unary_expression] = STATE(1663),
    [sym_update_expression] = STATE(1663),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1663),
    [sym_as_expression] = STATE(1663),
    [sym_internal_module] = STATE(1663),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1786),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_namespace] = ACTIONS(1790),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1792),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1794),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [sym_readonly] = ACTIONS(1788),
  },
  [239] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2718),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [240] = {
    [sym_import] = STATE(1332),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1332),
    [sym_yield_expression] = STATE(1332),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1332),
    [sym_jsx_fragment] = STATE(1332),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1332),
    [sym_class] = STATE(1332),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1332),
    [sym_arrow_function] = STATE(1332),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1332),
    [sym_new_expression] = STATE(1332),
    [sym_await_expression] = STATE(1332),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1332),
    [sym_augmented_assignment_expression] = STATE(1332),
    [sym_ternary_expression] = STATE(1332),
    [sym_binary_expression] = STATE(1332),
    [sym_unary_expression] = STATE(1332),
    [sym_update_expression] = STATE(1332),
    [sym_sequence_expression] = STATE(3141),
    [sym_string] = STATE(1332),
    [sym_template_string] = STATE(1332),
    [sym_regex] = STATE(1332),
    [sym_meta_property] = STATE(1332),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1332),
    [sym_as_expression] = STATE(1332),
    [sym_internal_module] = STATE(1332),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1800),
    [sym_this] = ACTIONS(1802),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1802),
    [sym_false] = ACTIONS(1802),
    [sym_null] = ACTIONS(1802),
    [sym_undefined] = ACTIONS(1802),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [241] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_nested_identifier] = STATE(1895),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1804),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [242] = {
    [sym_import] = STATE(1204),
    [sym_statement_block] = STATE(1599),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1204),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1204),
    [sym_jsx_fragment] = STATE(1204),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1204),
    [sym_class] = STATE(1204),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1204),
    [sym_arrow_function] = STATE(1204),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1204),
    [sym_new_expression] = STATE(1204),
    [sym_await_expression] = STATE(1204),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1204),
    [sym_augmented_assignment_expression] = STATE(1204),
    [sym_ternary_expression] = STATE(1204),
    [sym_binary_expression] = STATE(1204),
    [sym_unary_expression] = STATE(1204),
    [sym_update_expression] = STATE(1204),
    [sym_string] = STATE(1204),
    [sym_template_string] = STATE(1204),
    [sym_regex] = STATE(1204),
    [sym_meta_property] = STATE(1204),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1204),
    [sym_as_expression] = STATE(1204),
    [sym_internal_module] = STATE(1204),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1806),
    [sym_this] = ACTIONS(1808),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1808),
    [sym_false] = ACTIONS(1808),
    [sym_null] = ACTIONS(1808),
    [sym_undefined] = ACTIONS(1808),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [243] = {
    [sym_import] = STATE(1386),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1663),
    [sym_yield_expression] = STATE(1663),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1266),
    [sym_jsx_element] = STATE(1663),
    [sym_jsx_fragment] = STATE(1663),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1663),
    [sym_class] = STATE(1386),
    [sym_function] = STATE(1099),
    [sym_generator_function] = STATE(1386),
    [sym_arrow_function] = STATE(1386),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1663),
    [sym_new_expression] = STATE(1386),
    [sym_await_expression] = STATE(1663),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1663),
    [sym_augmented_assignment_expression] = STATE(1663),
    [sym_ternary_expression] = STATE(1663),
    [sym_binary_expression] = STATE(1663),
    [sym_unary_expression] = STATE(1663),
    [sym_update_expression] = STATE(1663),
    [sym_string] = STATE(1386),
    [sym_template_string] = STATE(1386),
    [sym_regex] = STATE(1386),
    [sym_meta_property] = STATE(1386),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1663),
    [sym_as_expression] = STATE(1663),
    [sym_internal_module] = STATE(1663),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(1545),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1549),
    [sym_this] = ACTIONS(1551),
    [sym_super] = ACTIONS(1553),
    [sym_true] = ACTIONS(1551),
    [sym_false] = ACTIONS(1551),
    [sym_null] = ACTIONS(1551),
    [sym_undefined] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_get] = ACTIONS(1539),
    [anon_sym_set] = ACTIONS(1539),
    [anon_sym_declare] = ACTIONS(1539),
    [anon_sym_public] = ACTIONS(1539),
    [anon_sym_private] = ACTIONS(1539),
    [anon_sym_protected] = ACTIONS(1539),
    [anon_sym_module] = ACTIONS(1539),
    [anon_sym_any] = ACTIONS(1539),
    [anon_sym_number] = ACTIONS(1539),
    [anon_sym_boolean] = ACTIONS(1539),
    [anon_sym_string] = ACTIONS(1539),
    [anon_sym_symbol] = ACTIONS(1539),
    [sym_readonly] = ACTIONS(1539),
  },
  [244] = {
    [sym_import] = STATE(1241),
    [sym_statement_block] = STATE(1038),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1241),
    [sym_yield_expression] = STATE(1241),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1241),
    [sym_jsx_fragment] = STATE(1241),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1241),
    [sym_class] = STATE(1241),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1241),
    [sym_arrow_function] = STATE(1241),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1241),
    [sym_new_expression] = STATE(1241),
    [sym_await_expression] = STATE(1241),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1241),
    [sym_augmented_assignment_expression] = STATE(1241),
    [sym_ternary_expression] = STATE(1241),
    [sym_binary_expression] = STATE(1241),
    [sym_unary_expression] = STATE(1241),
    [sym_update_expression] = STATE(1241),
    [sym_string] = STATE(1241),
    [sym_template_string] = STATE(1241),
    [sym_regex] = STATE(1241),
    [sym_meta_property] = STATE(1241),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1241),
    [sym_as_expression] = STATE(1241),
    [sym_internal_module] = STATE(1241),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1810),
    [sym_this] = ACTIONS(1812),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1812),
    [sym_false] = ACTIONS(1812),
    [sym_null] = ACTIONS(1812),
    [sym_undefined] = ACTIONS(1812),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [245] = {
    [sym_import] = STATE(1069),
    [sym_statement_block] = STATE(1500),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1069),
    [sym_yield_expression] = STATE(1069),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1069),
    [sym_jsx_fragment] = STATE(1069),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1069),
    [sym_class] = STATE(1069),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1069),
    [sym_arrow_function] = STATE(1069),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1069),
    [sym_new_expression] = STATE(1069),
    [sym_await_expression] = STATE(1069),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1069),
    [sym_augmented_assignment_expression] = STATE(1069),
    [sym_ternary_expression] = STATE(1069),
    [sym_binary_expression] = STATE(1069),
    [sym_unary_expression] = STATE(1069),
    [sym_update_expression] = STATE(1069),
    [sym_string] = STATE(1069),
    [sym_template_string] = STATE(1069),
    [sym_regex] = STATE(1069),
    [sym_meta_property] = STATE(1069),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1069),
    [sym_as_expression] = STATE(1069),
    [sym_internal_module] = STATE(1069),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1814),
    [sym_this] = ACTIONS(1816),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1816),
    [sym_false] = ACTIONS(1816),
    [sym_null] = ACTIONS(1816),
    [sym_undefined] = ACTIONS(1816),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [246] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2645),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(1603),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [247] = {
    [sym_import] = STATE(984),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(984),
    [sym_yield_expression] = STATE(984),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(984),
    [sym_jsx_fragment] = STATE(984),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(984),
    [sym_class] = STATE(984),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(984),
    [sym_arrow_function] = STATE(984),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(984),
    [sym_new_expression] = STATE(984),
    [sym_await_expression] = STATE(984),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(984),
    [sym_augmented_assignment_expression] = STATE(984),
    [sym_ternary_expression] = STATE(984),
    [sym_binary_expression] = STATE(984),
    [sym_unary_expression] = STATE(984),
    [sym_update_expression] = STATE(984),
    [sym_sequence_expression] = STATE(2480),
    [sym_string] = STATE(984),
    [sym_template_string] = STATE(984),
    [sym_regex] = STATE(984),
    [sym_meta_property] = STATE(984),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(984),
    [sym_as_expression] = STATE(984),
    [sym_internal_module] = STATE(984),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1818),
    [sym_this] = ACTIONS(1820),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1820),
    [sym_false] = ACTIONS(1820),
    [sym_null] = ACTIONS(1820),
    [sym_undefined] = ACTIONS(1820),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [248] = {
    [sym_import] = STATE(1007),
    [sym_parenthesized_expression] = STATE(670),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(958),
    [sym_array] = STATE(964),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1007),
    [sym_function] = STATE(954),
    [sym_generator_function] = STATE(1007),
    [sym_arrow_function] = STATE(1007),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1007),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(670),
    [sym_subscript_expression] = STATE(670),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1007),
    [sym_template_string] = STATE(1007),
    [sym_regex] = STATE(1007),
    [sym_meta_property] = STATE(1007),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_export] = ACTIONS(1517),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1517),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1525),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1529),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1529),
    [sym_false] = ACTIONS(1529),
    [sym_null] = ACTIONS(1529),
    [sym_undefined] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(1517),
    [anon_sym_set] = ACTIONS(1517),
    [anon_sym_declare] = ACTIONS(1517),
    [anon_sym_public] = ACTIONS(1517),
    [anon_sym_private] = ACTIONS(1517),
    [anon_sym_protected] = ACTIONS(1517),
    [anon_sym_module] = ACTIONS(1517),
    [anon_sym_any] = ACTIONS(1517),
    [anon_sym_number] = ACTIONS(1517),
    [anon_sym_boolean] = ACTIONS(1517),
    [anon_sym_string] = ACTIONS(1517),
    [anon_sym_symbol] = ACTIONS(1517),
    [sym_readonly] = ACTIONS(1517),
  },
  [249] = {
    [sym_import] = STATE(989),
    [sym_statement_block] = STATE(1038),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(989),
    [sym_yield_expression] = STATE(989),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(989),
    [sym_jsx_fragment] = STATE(989),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(989),
    [sym_class] = STATE(989),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(989),
    [sym_arrow_function] = STATE(989),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(989),
    [sym_new_expression] = STATE(989),
    [sym_await_expression] = STATE(989),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(989),
    [sym_augmented_assignment_expression] = STATE(989),
    [sym_ternary_expression] = STATE(989),
    [sym_binary_expression] = STATE(989),
    [sym_unary_expression] = STATE(989),
    [sym_update_expression] = STATE(989),
    [sym_string] = STATE(989),
    [sym_template_string] = STATE(989),
    [sym_regex] = STATE(989),
    [sym_meta_property] = STATE(989),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(989),
    [sym_as_expression] = STATE(989),
    [sym_internal_module] = STATE(989),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1822),
    [sym_this] = ACTIONS(1824),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1824),
    [sym_false] = ACTIONS(1824),
    [sym_null] = ACTIONS(1824),
    [sym_undefined] = ACTIONS(1824),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [250] = {
    [sym_import] = STATE(1494),
    [sym_parenthesized_expression] = STATE(876),
    [sym__expression] = STATE(1687),
    [sym_yield_expression] = STATE(1687),
    [sym_object] = STATE(1322),
    [sym_array] = STATE(1323),
    [sym_jsx_element] = STATE(1687),
    [sym_jsx_fragment] = STATE(1687),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1687),
    [sym_class] = STATE(1494),
    [sym_function] = STATE(1313),
    [sym_generator_function] = STATE(1494),
    [sym_arrow_function] = STATE(1494),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1687),
    [sym_new_expression] = STATE(1494),
    [sym_await_expression] = STATE(1687),
    [sym_member_expression] = STATE(876),
    [sym_subscript_expression] = STATE(876),
    [sym_assignment_expression] = STATE(1687),
    [sym_augmented_assignment_expression] = STATE(1687),
    [sym_ternary_expression] = STATE(1687),
    [sym_binary_expression] = STATE(1687),
    [sym_unary_expression] = STATE(1687),
    [sym_update_expression] = STATE(1687),
    [sym_string] = STATE(1494),
    [sym_template_string] = STATE(1494),
    [sym_regex] = STATE(1494),
    [sym_meta_property] = STATE(1494),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2638),
    [sym_non_null_expression] = STATE(1687),
    [sym_as_expression] = STATE(1687),
    [sym_internal_module] = STATE(1687),
    [sym_type_parameters] = STATE(2949),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(1471),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_DOT] = ACTIONS(1477),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(1479),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1483),
    [sym_this] = ACTIONS(1485),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1485),
    [sym_false] = ACTIONS(1485),
    [sym_null] = ACTIONS(1485),
    [sym_undefined] = ACTIONS(1485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [sym_readonly] = ACTIONS(1473),
  },
  [251] = {
    [sym_import] = STATE(1246),
    [sym_statement_block] = STATE(1051),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1246),
    [sym_yield_expression] = STATE(1246),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1246),
    [sym_jsx_fragment] = STATE(1246),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1246),
    [sym_class] = STATE(1246),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1246),
    [sym_arrow_function] = STATE(1246),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1246),
    [sym_new_expression] = STATE(1246),
    [sym_await_expression] = STATE(1246),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1246),
    [sym_augmented_assignment_expression] = STATE(1246),
    [sym_ternary_expression] = STATE(1246),
    [sym_binary_expression] = STATE(1246),
    [sym_unary_expression] = STATE(1246),
    [sym_update_expression] = STATE(1246),
    [sym_string] = STATE(1246),
    [sym_template_string] = STATE(1246),
    [sym_regex] = STATE(1246),
    [sym_meta_property] = STATE(1246),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1246),
    [sym_as_expression] = STATE(1246),
    [sym_internal_module] = STATE(1246),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1826),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [sym_undefined] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [252] = {
    [sym_import] = STATE(1113),
    [sym_statement_block] = STATE(1478),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1113),
    [sym_yield_expression] = STATE(1113),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1113),
    [sym_jsx_fragment] = STATE(1113),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1113),
    [sym_class] = STATE(1113),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1113),
    [sym_arrow_function] = STATE(1113),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1113),
    [sym_new_expression] = STATE(1113),
    [sym_await_expression] = STATE(1113),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1113),
    [sym_augmented_assignment_expression] = STATE(1113),
    [sym_ternary_expression] = STATE(1113),
    [sym_binary_expression] = STATE(1113),
    [sym_unary_expression] = STATE(1113),
    [sym_update_expression] = STATE(1113),
    [sym_string] = STATE(1113),
    [sym_template_string] = STATE(1113),
    [sym_regex] = STATE(1113),
    [sym_meta_property] = STATE(1113),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1113),
    [sym_as_expression] = STATE(1113),
    [sym_internal_module] = STATE(1113),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1830),
    [sym_this] = ACTIONS(1832),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1832),
    [sym_false] = ACTIONS(1832),
    [sym_null] = ACTIONS(1832),
    [sym_undefined] = ACTIONS(1832),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [253] = {
    [sym_import] = STATE(1267),
    [sym_statement_block] = STATE(1576),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1267),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1267),
    [sym_jsx_fragment] = STATE(1267),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1267),
    [sym_class] = STATE(1267),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1267),
    [sym_arrow_function] = STATE(1267),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1267),
    [sym_new_expression] = STATE(1267),
    [sym_await_expression] = STATE(1267),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1267),
    [sym_augmented_assignment_expression] = STATE(1267),
    [sym_ternary_expression] = STATE(1267),
    [sym_binary_expression] = STATE(1267),
    [sym_unary_expression] = STATE(1267),
    [sym_update_expression] = STATE(1267),
    [sym_string] = STATE(1267),
    [sym_template_string] = STATE(1267),
    [sym_regex] = STATE(1267),
    [sym_meta_property] = STATE(1267),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1267),
    [sym_as_expression] = STATE(1267),
    [sym_internal_module] = STATE(1267),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1834),
    [sym_this] = ACTIONS(1836),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1836),
    [sym_false] = ACTIONS(1836),
    [sym_null] = ACTIONS(1836),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [254] = {
    [sym_import] = STATE(1312),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1312),
    [sym_yield_expression] = STATE(1312),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1312),
    [sym_jsx_fragment] = STATE(1312),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1312),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1312),
    [sym_arrow_function] = STATE(1312),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1312),
    [sym_await_expression] = STATE(1312),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1312),
    [sym_augmented_assignment_expression] = STATE(1312),
    [sym_ternary_expression] = STATE(1312),
    [sym_binary_expression] = STATE(1312),
    [sym_unary_expression] = STATE(1312),
    [sym_update_expression] = STATE(1312),
    [sym_sequence_expression] = STATE(2883),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1312),
    [sym_as_expression] = STATE(1312),
    [sym_internal_module] = STATE(1312),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(1840),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1840),
    [sym_false] = ACTIONS(1840),
    [sym_null] = ACTIONS(1840),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [255] = {
    [sym_import] = STATE(1225),
    [sym_statement_block] = STATE(1582),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1225),
    [sym_yield_expression] = STATE(1225),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1225),
    [sym_jsx_fragment] = STATE(1225),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1225),
    [sym_class] = STATE(1225),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1225),
    [sym_arrow_function] = STATE(1225),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1225),
    [sym_new_expression] = STATE(1225),
    [sym_await_expression] = STATE(1225),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1225),
    [sym_augmented_assignment_expression] = STATE(1225),
    [sym_ternary_expression] = STATE(1225),
    [sym_binary_expression] = STATE(1225),
    [sym_unary_expression] = STATE(1225),
    [sym_update_expression] = STATE(1225),
    [sym_string] = STATE(1225),
    [sym_template_string] = STATE(1225),
    [sym_regex] = STATE(1225),
    [sym_meta_property] = STATE(1225),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1225),
    [sym_as_expression] = STATE(1225),
    [sym_internal_module] = STATE(1225),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1678),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1842),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [256] = {
    [sym_import] = STATE(1328),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1328),
    [sym_yield_expression] = STATE(1328),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1328),
    [sym_jsx_fragment] = STATE(1328),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1328),
    [sym_class] = STATE(1328),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1328),
    [sym_arrow_function] = STATE(1328),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_await_expression] = STATE(1328),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1328),
    [sym_augmented_assignment_expression] = STATE(1328),
    [sym_ternary_expression] = STATE(1328),
    [sym_binary_expression] = STATE(1328),
    [sym_unary_expression] = STATE(1328),
    [sym_update_expression] = STATE(1328),
    [sym_string] = STATE(1328),
    [sym_template_string] = STATE(1328),
    [sym_regex] = STATE(1328),
    [sym_meta_property] = STATE(1328),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1328),
    [sym_as_expression] = STATE(1328),
    [sym_internal_module] = STATE(1328),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1846),
    [sym_this] = ACTIONS(1848),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [257] = {
    [sym_import] = STATE(1365),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1365),
    [sym_yield_expression] = STATE(1365),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1365),
    [sym_jsx_fragment] = STATE(1365),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1365),
    [sym_class] = STATE(1365),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1365),
    [sym_arrow_function] = STATE(1365),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1365),
    [sym_new_expression] = STATE(1365),
    [sym_await_expression] = STATE(1365),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1365),
    [sym_augmented_assignment_expression] = STATE(1365),
    [sym_ternary_expression] = STATE(1365),
    [sym_binary_expression] = STATE(1365),
    [sym_unary_expression] = STATE(1365),
    [sym_update_expression] = STATE(1365),
    [sym_string] = STATE(1365),
    [sym_template_string] = STATE(1365),
    [sym_regex] = STATE(1365),
    [sym_meta_property] = STATE(1365),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1365),
    [sym_as_expression] = STATE(1365),
    [sym_internal_module] = STATE(1365),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1850),
    [sym_this] = ACTIONS(1852),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1852),
    [sym_false] = ACTIONS(1852),
    [sym_null] = ACTIONS(1852),
    [sym_undefined] = ACTIONS(1852),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [258] = {
    [sym_import] = STATE(1106),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1106),
    [sym_yield_expression] = STATE(1106),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1106),
    [sym_jsx_fragment] = STATE(1106),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1106),
    [sym_class] = STATE(1106),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1106),
    [sym_arrow_function] = STATE(1106),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1106),
    [sym_new_expression] = STATE(1106),
    [sym_await_expression] = STATE(1106),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1106),
    [sym_augmented_assignment_expression] = STATE(1106),
    [sym_ternary_expression] = STATE(1106),
    [sym_binary_expression] = STATE(1106),
    [sym_unary_expression] = STATE(1106),
    [sym_update_expression] = STATE(1106),
    [sym_string] = STATE(1106),
    [sym_template_string] = STATE(1106),
    [sym_regex] = STATE(1106),
    [sym_meta_property] = STATE(1106),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1106),
    [sym_as_expression] = STATE(1106),
    [sym_internal_module] = STATE(1106),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1854),
    [sym_this] = ACTIONS(931),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(931),
    [sym_false] = ACTIONS(931),
    [sym_null] = ACTIONS(931),
    [sym_undefined] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [259] = {
    [sym_import] = STATE(1077),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1077),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1077),
    [sym_jsx_fragment] = STATE(1077),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1077),
    [sym_class] = STATE(1077),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1077),
    [sym_arrow_function] = STATE(1077),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1077),
    [sym_new_expression] = STATE(1077),
    [sym_await_expression] = STATE(1077),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1077),
    [sym_augmented_assignment_expression] = STATE(1077),
    [sym_ternary_expression] = STATE(1077),
    [sym_binary_expression] = STATE(1077),
    [sym_unary_expression] = STATE(1077),
    [sym_update_expression] = STATE(1077),
    [sym_string] = STATE(1077),
    [sym_template_string] = STATE(1077),
    [sym_regex] = STATE(1077),
    [sym_meta_property] = STATE(1077),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1077),
    [sym_as_expression] = STATE(1077),
    [sym_internal_module] = STATE(1077),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1856),
    [sym_this] = ACTIONS(1858),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1858),
    [sym_false] = ACTIONS(1858),
    [sym_null] = ACTIONS(1858),
    [sym_undefined] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [260] = {
    [sym_import] = STATE(1486),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1486),
    [sym_yield_expression] = STATE(1486),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1486),
    [sym_jsx_fragment] = STATE(1486),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1486),
    [sym_class] = STATE(1486),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1486),
    [sym_arrow_function] = STATE(1486),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1486),
    [sym_new_expression] = STATE(1486),
    [sym_await_expression] = STATE(1486),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1486),
    [sym_augmented_assignment_expression] = STATE(1486),
    [sym_ternary_expression] = STATE(1486),
    [sym_binary_expression] = STATE(1486),
    [sym_unary_expression] = STATE(1486),
    [sym_update_expression] = STATE(1486),
    [sym_string] = STATE(1486),
    [sym_template_string] = STATE(1486),
    [sym_regex] = STATE(1486),
    [sym_meta_property] = STATE(1486),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1486),
    [sym_as_expression] = STATE(1486),
    [sym_internal_module] = STATE(1486),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1860),
    [sym_this] = ACTIONS(1862),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1862),
    [sym_false] = ACTIONS(1862),
    [sym_null] = ACTIONS(1862),
    [sym_undefined] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [261] = {
    [sym_import] = STATE(1107),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1107),
    [sym_yield_expression] = STATE(1107),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1107),
    [sym_jsx_fragment] = STATE(1107),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1107),
    [sym_class] = STATE(1107),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1107),
    [sym_arrow_function] = STATE(1107),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1107),
    [sym_new_expression] = STATE(1107),
    [sym_await_expression] = STATE(1107),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1107),
    [sym_augmented_assignment_expression] = STATE(1107),
    [sym_ternary_expression] = STATE(1107),
    [sym_binary_expression] = STATE(1107),
    [sym_unary_expression] = STATE(1107),
    [sym_update_expression] = STATE(1107),
    [sym_string] = STATE(1107),
    [sym_template_string] = STATE(1107),
    [sym_regex] = STATE(1107),
    [sym_meta_property] = STATE(1107),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1107),
    [sym_as_expression] = STATE(1107),
    [sym_internal_module] = STATE(1107),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1864),
    [sym_this] = ACTIONS(1866),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1866),
    [sym_false] = ACTIONS(1866),
    [sym_null] = ACTIONS(1866),
    [sym_undefined] = ACTIONS(1866),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [262] = {
    [sym_import] = STATE(1108),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1108),
    [sym_yield_expression] = STATE(1108),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1108),
    [sym_jsx_fragment] = STATE(1108),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1108),
    [sym_class] = STATE(1108),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1108),
    [sym_arrow_function] = STATE(1108),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1108),
    [sym_new_expression] = STATE(1108),
    [sym_await_expression] = STATE(1108),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1108),
    [sym_augmented_assignment_expression] = STATE(1108),
    [sym_ternary_expression] = STATE(1108),
    [sym_binary_expression] = STATE(1108),
    [sym_unary_expression] = STATE(1108),
    [sym_update_expression] = STATE(1108),
    [sym_string] = STATE(1108),
    [sym_template_string] = STATE(1108),
    [sym_regex] = STATE(1108),
    [sym_meta_property] = STATE(1108),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1108),
    [sym_as_expression] = STATE(1108),
    [sym_internal_module] = STATE(1108),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1868),
    [sym_this] = ACTIONS(1870),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1870),
    [sym_false] = ACTIONS(1870),
    [sym_null] = ACTIONS(1870),
    [sym_undefined] = ACTIONS(1870),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [263] = {
    [sym_import] = STATE(1109),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1109),
    [sym_yield_expression] = STATE(1109),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1109),
    [sym_jsx_fragment] = STATE(1109),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1109),
    [sym_class] = STATE(1109),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1109),
    [sym_arrow_function] = STATE(1109),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1109),
    [sym_new_expression] = STATE(1109),
    [sym_await_expression] = STATE(1109),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1109),
    [sym_augmented_assignment_expression] = STATE(1109),
    [sym_ternary_expression] = STATE(1109),
    [sym_binary_expression] = STATE(1109),
    [sym_unary_expression] = STATE(1109),
    [sym_update_expression] = STATE(1109),
    [sym_string] = STATE(1109),
    [sym_template_string] = STATE(1109),
    [sym_regex] = STATE(1109),
    [sym_meta_property] = STATE(1109),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1109),
    [sym_as_expression] = STATE(1109),
    [sym_internal_module] = STATE(1109),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1872),
    [sym_this] = ACTIONS(1874),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1874),
    [sym_false] = ACTIONS(1874),
    [sym_null] = ACTIONS(1874),
    [sym_undefined] = ACTIONS(1874),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [264] = {
    [sym_import] = STATE(1110),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1110),
    [sym_yield_expression] = STATE(1110),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1110),
    [sym_jsx_fragment] = STATE(1110),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1110),
    [sym_class] = STATE(1110),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1110),
    [sym_arrow_function] = STATE(1110),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1110),
    [sym_new_expression] = STATE(1110),
    [sym_await_expression] = STATE(1110),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1110),
    [sym_augmented_assignment_expression] = STATE(1110),
    [sym_ternary_expression] = STATE(1110),
    [sym_binary_expression] = STATE(1110),
    [sym_unary_expression] = STATE(1110),
    [sym_update_expression] = STATE(1110),
    [sym_string] = STATE(1110),
    [sym_template_string] = STATE(1110),
    [sym_regex] = STATE(1110),
    [sym_meta_property] = STATE(1110),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1110),
    [sym_as_expression] = STATE(1110),
    [sym_internal_module] = STATE(1110),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1876),
    [sym_this] = ACTIONS(1878),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1878),
    [sym_false] = ACTIONS(1878),
    [sym_null] = ACTIONS(1878),
    [sym_undefined] = ACTIONS(1878),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [265] = {
    [sym_import] = STATE(1356),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1356),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1356),
    [sym_jsx_fragment] = STATE(1356),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1356),
    [sym_class] = STATE(1356),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1356),
    [sym_arrow_function] = STATE(1356),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1356),
    [sym_new_expression] = STATE(1356),
    [sym_await_expression] = STATE(1356),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1356),
    [sym_augmented_assignment_expression] = STATE(1356),
    [sym_ternary_expression] = STATE(1356),
    [sym_binary_expression] = STATE(1356),
    [sym_unary_expression] = STATE(1356),
    [sym_update_expression] = STATE(1356),
    [sym_string] = STATE(1356),
    [sym_template_string] = STATE(1356),
    [sym_regex] = STATE(1356),
    [sym_meta_property] = STATE(1356),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1356),
    [sym_as_expression] = STATE(1356),
    [sym_internal_module] = STATE(1356),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1880),
    [sym_this] = ACTIONS(1882),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1882),
    [sym_false] = ACTIONS(1882),
    [sym_null] = ACTIONS(1882),
    [sym_undefined] = ACTIONS(1882),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [266] = {
    [sym_import] = STATE(1132),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1132),
    [sym_yield_expression] = STATE(1132),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1132),
    [sym_jsx_fragment] = STATE(1132),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1132),
    [sym_class] = STATE(1132),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1132),
    [sym_arrow_function] = STATE(1132),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1132),
    [sym_new_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1132),
    [sym_augmented_assignment_expression] = STATE(1132),
    [sym_ternary_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_update_expression] = STATE(1132),
    [sym_string] = STATE(1132),
    [sym_template_string] = STATE(1132),
    [sym_regex] = STATE(1132),
    [sym_meta_property] = STATE(1132),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1132),
    [sym_as_expression] = STATE(1132),
    [sym_internal_module] = STATE(1132),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(511),
    [sym_false] = ACTIONS(511),
    [sym_null] = ACTIONS(511),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [267] = {
    [sym_import] = STATE(1111),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1111),
    [sym_yield_expression] = STATE(1111),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1111),
    [sym_jsx_fragment] = STATE(1111),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1111),
    [sym_class] = STATE(1111),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1111),
    [sym_arrow_function] = STATE(1111),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1111),
    [sym_new_expression] = STATE(1111),
    [sym_await_expression] = STATE(1111),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1111),
    [sym_augmented_assignment_expression] = STATE(1111),
    [sym_ternary_expression] = STATE(1111),
    [sym_binary_expression] = STATE(1111),
    [sym_unary_expression] = STATE(1111),
    [sym_update_expression] = STATE(1111),
    [sym_string] = STATE(1111),
    [sym_template_string] = STATE(1111),
    [sym_regex] = STATE(1111),
    [sym_meta_property] = STATE(1111),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1111),
    [sym_as_expression] = STATE(1111),
    [sym_internal_module] = STATE(1111),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1884),
    [sym_this] = ACTIONS(1886),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1886),
    [sym_false] = ACTIONS(1886),
    [sym_null] = ACTIONS(1886),
    [sym_undefined] = ACTIONS(1886),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [268] = {
    [sym_import] = STATE(1112),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1112),
    [sym_yield_expression] = STATE(1112),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1112),
    [sym_jsx_fragment] = STATE(1112),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1112),
    [sym_class] = STATE(1112),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1112),
    [sym_arrow_function] = STATE(1112),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1112),
    [sym_new_expression] = STATE(1112),
    [sym_await_expression] = STATE(1112),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1112),
    [sym_augmented_assignment_expression] = STATE(1112),
    [sym_ternary_expression] = STATE(1112),
    [sym_binary_expression] = STATE(1112),
    [sym_unary_expression] = STATE(1112),
    [sym_update_expression] = STATE(1112),
    [sym_string] = STATE(1112),
    [sym_template_string] = STATE(1112),
    [sym_regex] = STATE(1112),
    [sym_meta_property] = STATE(1112),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1112),
    [sym_as_expression] = STATE(1112),
    [sym_internal_module] = STATE(1112),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1888),
    [sym_this] = ACTIONS(1890),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1890),
    [sym_false] = ACTIONS(1890),
    [sym_null] = ACTIONS(1890),
    [sym_undefined] = ACTIONS(1890),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [269] = {
    [sym_import] = STATE(1104),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1104),
    [sym_yield_expression] = STATE(1104),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1104),
    [sym_jsx_fragment] = STATE(1104),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1104),
    [sym_class] = STATE(1104),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1104),
    [sym_arrow_function] = STATE(1104),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1104),
    [sym_new_expression] = STATE(1104),
    [sym_await_expression] = STATE(1104),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1104),
    [sym_augmented_assignment_expression] = STATE(1104),
    [sym_ternary_expression] = STATE(1104),
    [sym_binary_expression] = STATE(1104),
    [sym_unary_expression] = STATE(1104),
    [sym_update_expression] = STATE(1104),
    [sym_string] = STATE(1104),
    [sym_template_string] = STATE(1104),
    [sym_regex] = STATE(1104),
    [sym_meta_property] = STATE(1104),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1104),
    [sym_as_expression] = STATE(1104),
    [sym_internal_module] = STATE(1104),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1892),
    [sym_this] = ACTIONS(1894),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1894),
    [sym_false] = ACTIONS(1894),
    [sym_null] = ACTIONS(1894),
    [sym_undefined] = ACTIONS(1894),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [270] = {
    [sym_import] = STATE(1369),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1369),
    [sym_arrow_function] = STATE(1369),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1369),
    [sym_as_expression] = STATE(1369),
    [sym_internal_module] = STATE(1369),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_null] = ACTIONS(694),
    [sym_undefined] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [271] = {
    [sym_import] = STATE(1247),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1247),
    [sym_yield_expression] = STATE(1247),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1247),
    [sym_jsx_fragment] = STATE(1247),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1247),
    [sym_class] = STATE(1247),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1247),
    [sym_arrow_function] = STATE(1247),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1247),
    [sym_new_expression] = STATE(1247),
    [sym_await_expression] = STATE(1247),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1247),
    [sym_augmented_assignment_expression] = STATE(1247),
    [sym_ternary_expression] = STATE(1247),
    [sym_binary_expression] = STATE(1247),
    [sym_unary_expression] = STATE(1247),
    [sym_update_expression] = STATE(1247),
    [sym_string] = STATE(1247),
    [sym_template_string] = STATE(1247),
    [sym_regex] = STATE(1247),
    [sym_meta_property] = STATE(1247),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1247),
    [sym_as_expression] = STATE(1247),
    [sym_internal_module] = STATE(1247),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1896),
    [sym_this] = ACTIONS(1898),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1898),
    [sym_false] = ACTIONS(1898),
    [sym_null] = ACTIONS(1898),
    [sym_undefined] = ACTIONS(1898),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [272] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1245),
    [sym_jsx_fragment] = STATE(1245),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1245),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1900),
    [sym_this] = ACTIONS(1902),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1902),
    [sym_false] = ACTIONS(1902),
    [sym_null] = ACTIONS(1902),
    [sym_undefined] = ACTIONS(1902),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [273] = {
    [sym_import] = STATE(1098),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1098),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1098),
    [sym_jsx_fragment] = STATE(1098),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1098),
    [sym_class] = STATE(1098),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1098),
    [sym_arrow_function] = STATE(1098),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1098),
    [sym_new_expression] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1098),
    [sym_augmented_assignment_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_unary_expression] = STATE(1098),
    [sym_update_expression] = STATE(1098),
    [sym_string] = STATE(1098),
    [sym_template_string] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_meta_property] = STATE(1098),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1098),
    [sym_as_expression] = STATE(1098),
    [sym_internal_module] = STATE(1098),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1904),
    [sym_this] = ACTIONS(1906),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [274] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(988),
    [sym_jsx_fragment] = STATE(988),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(988),
    [sym_class] = STATE(988),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1908),
    [sym_this] = ACTIONS(1910),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [sym_null] = ACTIONS(1910),
    [sym_undefined] = ACTIONS(1910),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [275] = {
    [sym_import] = STATE(1244),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1244),
    [sym_yield_expression] = STATE(1244),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1244),
    [sym_jsx_fragment] = STATE(1244),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1244),
    [sym_class] = STATE(1244),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1244),
    [sym_arrow_function] = STATE(1244),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1244),
    [sym_new_expression] = STATE(1244),
    [sym_await_expression] = STATE(1244),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1244),
    [sym_augmented_assignment_expression] = STATE(1244),
    [sym_ternary_expression] = STATE(1244),
    [sym_binary_expression] = STATE(1244),
    [sym_unary_expression] = STATE(1244),
    [sym_update_expression] = STATE(1244),
    [sym_string] = STATE(1244),
    [sym_template_string] = STATE(1244),
    [sym_regex] = STATE(1244),
    [sym_meta_property] = STATE(1244),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1244),
    [sym_as_expression] = STATE(1244),
    [sym_internal_module] = STATE(1244),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1912),
    [sym_this] = ACTIONS(1914),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1914),
    [sym_false] = ACTIONS(1914),
    [sym_null] = ACTIONS(1914),
    [sym_undefined] = ACTIONS(1914),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [276] = {
    [sym_import] = STATE(957),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(957),
    [sym_jsx_fragment] = STATE(957),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(957),
    [sym_class] = STATE(957),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(957),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1916),
    [sym_this] = ACTIONS(1918),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [sym_null] = ACTIONS(1918),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [277] = {
    [sym_import] = STATE(1292),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1292),
    [sym_jsx_fragment] = STATE(1292),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1292),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1920),
    [sym_this] = ACTIONS(1922),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1922),
    [sym_false] = ACTIONS(1922),
    [sym_null] = ACTIONS(1922),
    [sym_undefined] = ACTIONS(1922),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [278] = {
    [sym_import] = STATE(1298),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1298),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1298),
    [sym_jsx_fragment] = STATE(1298),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1298),
    [sym_class] = STATE(1298),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1298),
    [sym_arrow_function] = STATE(1298),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1298),
    [sym_new_expression] = STATE(1298),
    [sym_await_expression] = STATE(1298),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1298),
    [sym_augmented_assignment_expression] = STATE(1298),
    [sym_ternary_expression] = STATE(1298),
    [sym_binary_expression] = STATE(1298),
    [sym_unary_expression] = STATE(1298),
    [sym_update_expression] = STATE(1298),
    [sym_string] = STATE(1298),
    [sym_template_string] = STATE(1298),
    [sym_regex] = STATE(1298),
    [sym_meta_property] = STATE(1298),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1298),
    [sym_as_expression] = STATE(1298),
    [sym_internal_module] = STATE(1298),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1924),
    [sym_this] = ACTIONS(1926),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1926),
    [sym_false] = ACTIONS(1926),
    [sym_null] = ACTIONS(1926),
    [sym_undefined] = ACTIONS(1926),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [279] = {
    [sym_import] = STATE(1297),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1297),
    [sym_jsx_fragment] = STATE(1297),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1297),
    [sym_class] = STATE(1297),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1297),
    [sym_arrow_function] = STATE(1297),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1297),
    [sym_new_expression] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_string] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1928),
    [sym_this] = ACTIONS(1930),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [280] = {
    [sym_import] = STATE(1560),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1560),
    [sym_yield_expression] = STATE(1560),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1560),
    [sym_jsx_fragment] = STATE(1560),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1560),
    [sym_class] = STATE(1560),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1560),
    [sym_arrow_function] = STATE(1560),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1560),
    [sym_new_expression] = STATE(1560),
    [sym_await_expression] = STATE(1560),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1560),
    [sym_augmented_assignment_expression] = STATE(1560),
    [sym_ternary_expression] = STATE(1560),
    [sym_binary_expression] = STATE(1560),
    [sym_unary_expression] = STATE(1560),
    [sym_update_expression] = STATE(1560),
    [sym_string] = STATE(1560),
    [sym_template_string] = STATE(1560),
    [sym_regex] = STATE(1560),
    [sym_meta_property] = STATE(1560),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1560),
    [sym_as_expression] = STATE(1560),
    [sym_internal_module] = STATE(1560),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1932),
    [sym_this] = ACTIONS(1934),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1934),
    [sym_false] = ACTIONS(1934),
    [sym_null] = ACTIONS(1934),
    [sym_undefined] = ACTIONS(1934),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [281] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1936),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [282] = {
    [sym_import] = STATE(1296),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1296),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1296),
    [sym_jsx_fragment] = STATE(1296),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1296),
    [sym_class] = STATE(1296),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1296),
    [sym_arrow_function] = STATE(1296),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1296),
    [sym_new_expression] = STATE(1296),
    [sym_await_expression] = STATE(1296),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1296),
    [sym_augmented_assignment_expression] = STATE(1296),
    [sym_ternary_expression] = STATE(1296),
    [sym_binary_expression] = STATE(1296),
    [sym_unary_expression] = STATE(1296),
    [sym_update_expression] = STATE(1296),
    [sym_string] = STATE(1296),
    [sym_template_string] = STATE(1296),
    [sym_regex] = STATE(1296),
    [sym_meta_property] = STATE(1296),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1296),
    [sym_as_expression] = STATE(1296),
    [sym_internal_module] = STATE(1296),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1940),
    [sym_this] = ACTIONS(1942),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [sym_null] = ACTIONS(1942),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [283] = {
    [sym_import] = STATE(1355),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1355),
    [sym_yield_expression] = STATE(1355),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1355),
    [sym_jsx_fragment] = STATE(1355),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1355),
    [sym_class] = STATE(1355),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1355),
    [sym_arrow_function] = STATE(1355),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1355),
    [sym_new_expression] = STATE(1355),
    [sym_await_expression] = STATE(1355),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1355),
    [sym_augmented_assignment_expression] = STATE(1355),
    [sym_ternary_expression] = STATE(1355),
    [sym_binary_expression] = STATE(1355),
    [sym_unary_expression] = STATE(1355),
    [sym_update_expression] = STATE(1355),
    [sym_string] = STATE(1355),
    [sym_template_string] = STATE(1355),
    [sym_regex] = STATE(1355),
    [sym_meta_property] = STATE(1355),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1355),
    [sym_as_expression] = STATE(1355),
    [sym_internal_module] = STATE(1355),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1944),
    [sym_this] = ACTIONS(1946),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1946),
    [sym_false] = ACTIONS(1946),
    [sym_null] = ACTIONS(1946),
    [sym_undefined] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [284] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1948),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [285] = {
    [sym_import] = STATE(986),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(986),
    [sym_yield_expression] = STATE(986),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(986),
    [sym_jsx_fragment] = STATE(986),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(986),
    [sym_class] = STATE(986),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(986),
    [sym_arrow_function] = STATE(986),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(986),
    [sym_new_expression] = STATE(986),
    [sym_await_expression] = STATE(986),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(986),
    [sym_augmented_assignment_expression] = STATE(986),
    [sym_ternary_expression] = STATE(986),
    [sym_binary_expression] = STATE(986),
    [sym_unary_expression] = STATE(986),
    [sym_update_expression] = STATE(986),
    [sym_string] = STATE(986),
    [sym_template_string] = STATE(986),
    [sym_regex] = STATE(986),
    [sym_meta_property] = STATE(986),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(986),
    [sym_as_expression] = STATE(986),
    [sym_internal_module] = STATE(986),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1950),
    [sym_this] = ACTIONS(1952),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1952),
    [sym_false] = ACTIONS(1952),
    [sym_null] = ACTIONS(1952),
    [sym_undefined] = ACTIONS(1952),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [286] = {
    [sym_import] = STATE(1379),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1379),
    [sym_yield_expression] = STATE(1379),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1379),
    [sym_jsx_fragment] = STATE(1379),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1379),
    [sym_class] = STATE(1379),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1379),
    [sym_arrow_function] = STATE(1379),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1379),
    [sym_new_expression] = STATE(1379),
    [sym_await_expression] = STATE(1379),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1379),
    [sym_augmented_assignment_expression] = STATE(1379),
    [sym_ternary_expression] = STATE(1379),
    [sym_binary_expression] = STATE(1379),
    [sym_unary_expression] = STATE(1379),
    [sym_update_expression] = STATE(1379),
    [sym_string] = STATE(1379),
    [sym_template_string] = STATE(1379),
    [sym_regex] = STATE(1379),
    [sym_meta_property] = STATE(1379),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1379),
    [sym_as_expression] = STATE(1379),
    [sym_internal_module] = STATE(1379),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1954),
    [sym_this] = ACTIONS(1956),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1956),
    [sym_false] = ACTIONS(1956),
    [sym_null] = ACTIONS(1956),
    [sym_undefined] = ACTIONS(1956),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [287] = {
    [sym_import] = STATE(1311),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1311),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1311),
    [sym_jsx_fragment] = STATE(1311),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1311),
    [sym_class] = STATE(1311),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1311),
    [sym_arrow_function] = STATE(1311),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1311),
    [sym_new_expression] = STATE(1311),
    [sym_await_expression] = STATE(1311),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1311),
    [sym_augmented_assignment_expression] = STATE(1311),
    [sym_ternary_expression] = STATE(1311),
    [sym_binary_expression] = STATE(1311),
    [sym_unary_expression] = STATE(1311),
    [sym_update_expression] = STATE(1311),
    [sym_string] = STATE(1311),
    [sym_template_string] = STATE(1311),
    [sym_regex] = STATE(1311),
    [sym_meta_property] = STATE(1311),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1311),
    [sym_as_expression] = STATE(1311),
    [sym_internal_module] = STATE(1311),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1958),
    [sym_this] = ACTIONS(1960),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1960),
    [sym_false] = ACTIONS(1960),
    [sym_null] = ACTIONS(1960),
    [sym_undefined] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [288] = {
    [sym_import] = STATE(1463),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1463),
    [sym_yield_expression] = STATE(1463),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1463),
    [sym_jsx_fragment] = STATE(1463),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1463),
    [sym_class] = STATE(1463),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1463),
    [sym_arrow_function] = STATE(1463),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1463),
    [sym_new_expression] = STATE(1463),
    [sym_await_expression] = STATE(1463),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1463),
    [sym_augmented_assignment_expression] = STATE(1463),
    [sym_ternary_expression] = STATE(1463),
    [sym_binary_expression] = STATE(1463),
    [sym_unary_expression] = STATE(1463),
    [sym_update_expression] = STATE(1463),
    [sym_string] = STATE(1463),
    [sym_template_string] = STATE(1463),
    [sym_regex] = STATE(1463),
    [sym_meta_property] = STATE(1463),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1463),
    [sym_as_expression] = STATE(1463),
    [sym_internal_module] = STATE(1463),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1962),
    [sym_this] = ACTIONS(1964),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [sym_null] = ACTIONS(1964),
    [sym_undefined] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [289] = {
    [sym_import] = STATE(983),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(983),
    [sym_yield_expression] = STATE(983),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(983),
    [sym_jsx_fragment] = STATE(983),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(983),
    [sym_class] = STATE(983),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(983),
    [sym_arrow_function] = STATE(983),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(983),
    [sym_new_expression] = STATE(983),
    [sym_await_expression] = STATE(983),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(983),
    [sym_augmented_assignment_expression] = STATE(983),
    [sym_ternary_expression] = STATE(983),
    [sym_binary_expression] = STATE(983),
    [sym_unary_expression] = STATE(983),
    [sym_update_expression] = STATE(983),
    [sym_string] = STATE(983),
    [sym_template_string] = STATE(983),
    [sym_regex] = STATE(983),
    [sym_meta_property] = STATE(983),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(983),
    [sym_as_expression] = STATE(983),
    [sym_internal_module] = STATE(983),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1966),
    [sym_this] = ACTIONS(905),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [sym_null] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [290] = {
    [sym_import] = STATE(1001),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1001),
    [sym_yield_expression] = STATE(1001),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1001),
    [sym_jsx_fragment] = STATE(1001),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1001),
    [sym_class] = STATE(1001),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1001),
    [sym_arrow_function] = STATE(1001),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1001),
    [sym_new_expression] = STATE(1001),
    [sym_await_expression] = STATE(1001),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1001),
    [sym_augmented_assignment_expression] = STATE(1001),
    [sym_ternary_expression] = STATE(1001),
    [sym_binary_expression] = STATE(1001),
    [sym_unary_expression] = STATE(1001),
    [sym_update_expression] = STATE(1001),
    [sym_string] = STATE(1001),
    [sym_template_string] = STATE(1001),
    [sym_regex] = STATE(1001),
    [sym_meta_property] = STATE(1001),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1001),
    [sym_as_expression] = STATE(1001),
    [sym_internal_module] = STATE(1001),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1968),
    [sym_this] = ACTIONS(1970),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1970),
    [sym_false] = ACTIONS(1970),
    [sym_null] = ACTIONS(1970),
    [sym_undefined] = ACTIONS(1970),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [291] = {
    [sym_import] = STATE(1242),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1242),
    [sym_yield_expression] = STATE(1242),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1242),
    [sym_jsx_fragment] = STATE(1242),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1242),
    [sym_class] = STATE(1242),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1242),
    [sym_arrow_function] = STATE(1242),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1242),
    [sym_new_expression] = STATE(1242),
    [sym_await_expression] = STATE(1242),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1242),
    [sym_augmented_assignment_expression] = STATE(1242),
    [sym_ternary_expression] = STATE(1242),
    [sym_binary_expression] = STATE(1242),
    [sym_unary_expression] = STATE(1242),
    [sym_update_expression] = STATE(1242),
    [sym_string] = STATE(1242),
    [sym_template_string] = STATE(1242),
    [sym_regex] = STATE(1242),
    [sym_meta_property] = STATE(1242),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1242),
    [sym_as_expression] = STATE(1242),
    [sym_internal_module] = STATE(1242),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1972),
    [sym_this] = ACTIONS(1974),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [sym_null] = ACTIONS(1974),
    [sym_undefined] = ACTIONS(1974),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [292] = {
    [sym_import] = STATE(1283),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1283),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1283),
    [sym_jsx_fragment] = STATE(1283),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1283),
    [sym_class] = STATE(1283),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1283),
    [sym_arrow_function] = STATE(1283),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1283),
    [sym_new_expression] = STATE(1283),
    [sym_await_expression] = STATE(1283),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1283),
    [sym_augmented_assignment_expression] = STATE(1283),
    [sym_ternary_expression] = STATE(1283),
    [sym_binary_expression] = STATE(1283),
    [sym_unary_expression] = STATE(1283),
    [sym_update_expression] = STATE(1283),
    [sym_string] = STATE(1283),
    [sym_template_string] = STATE(1283),
    [sym_regex] = STATE(1283),
    [sym_meta_property] = STATE(1283),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1283),
    [sym_as_expression] = STATE(1283),
    [sym_internal_module] = STATE(1283),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(1976),
    [sym_this] = ACTIONS(1978),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1978),
    [sym_false] = ACTIONS(1978),
    [sym_null] = ACTIONS(1978),
    [sym_undefined] = ACTIONS(1978),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [293] = {
    [sym_import] = STATE(1188),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1188),
    [sym_yield_expression] = STATE(1188),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1188),
    [sym_jsx_fragment] = STATE(1188),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1188),
    [sym_class] = STATE(1188),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1188),
    [sym_arrow_function] = STATE(1188),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1188),
    [sym_new_expression] = STATE(1188),
    [sym_await_expression] = STATE(1188),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1188),
    [sym_augmented_assignment_expression] = STATE(1188),
    [sym_ternary_expression] = STATE(1188),
    [sym_binary_expression] = STATE(1188),
    [sym_unary_expression] = STATE(1188),
    [sym_update_expression] = STATE(1188),
    [sym_string] = STATE(1188),
    [sym_template_string] = STATE(1188),
    [sym_regex] = STATE(1188),
    [sym_meta_property] = STATE(1188),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1188),
    [sym_as_expression] = STATE(1188),
    [sym_internal_module] = STATE(1188),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1980),
    [sym_this] = ACTIONS(1982),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1982),
    [sym_false] = ACTIONS(1982),
    [sym_null] = ACTIONS(1982),
    [sym_undefined] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [294] = {
    [sym_import] = STATE(976),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(976),
    [sym_yield_expression] = STATE(976),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(976),
    [sym_jsx_fragment] = STATE(976),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(976),
    [sym_class] = STATE(976),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(976),
    [sym_arrow_function] = STATE(976),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(976),
    [sym_new_expression] = STATE(976),
    [sym_await_expression] = STATE(976),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_update_expression] = STATE(976),
    [sym_string] = STATE(976),
    [sym_template_string] = STATE(976),
    [sym_regex] = STATE(976),
    [sym_meta_property] = STATE(976),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(976),
    [sym_as_expression] = STATE(976),
    [sym_internal_module] = STATE(976),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1984),
    [sym_this] = ACTIONS(1986),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1986),
    [sym_false] = ACTIONS(1986),
    [sym_null] = ACTIONS(1986),
    [sym_undefined] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [295] = {
    [sym_import] = STATE(1302),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1302),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1302),
    [sym_jsx_fragment] = STATE(1302),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1302),
    [sym_class] = STATE(1302),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1302),
    [sym_arrow_function] = STATE(1302),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1302),
    [sym_new_expression] = STATE(1302),
    [sym_await_expression] = STATE(1302),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1302),
    [sym_augmented_assignment_expression] = STATE(1302),
    [sym_ternary_expression] = STATE(1302),
    [sym_binary_expression] = STATE(1302),
    [sym_unary_expression] = STATE(1302),
    [sym_update_expression] = STATE(1302),
    [sym_string] = STATE(1302),
    [sym_template_string] = STATE(1302),
    [sym_regex] = STATE(1302),
    [sym_meta_property] = STATE(1302),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1302),
    [sym_as_expression] = STATE(1302),
    [sym_internal_module] = STATE(1302),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1988),
    [sym_this] = ACTIONS(1990),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_undefined] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [296] = {
    [sym_import] = STATE(1189),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1189),
    [sym_yield_expression] = STATE(1189),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1189),
    [sym_jsx_fragment] = STATE(1189),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1189),
    [sym_class] = STATE(1189),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1189),
    [sym_arrow_function] = STATE(1189),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1189),
    [sym_new_expression] = STATE(1189),
    [sym_await_expression] = STATE(1189),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1189),
    [sym_augmented_assignment_expression] = STATE(1189),
    [sym_ternary_expression] = STATE(1189),
    [sym_binary_expression] = STATE(1189),
    [sym_unary_expression] = STATE(1189),
    [sym_update_expression] = STATE(1189),
    [sym_string] = STATE(1189),
    [sym_template_string] = STATE(1189),
    [sym_regex] = STATE(1189),
    [sym_meta_property] = STATE(1189),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1189),
    [sym_as_expression] = STATE(1189),
    [sym_internal_module] = STATE(1189),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(1994),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1994),
    [sym_false] = ACTIONS(1994),
    [sym_null] = ACTIONS(1994),
    [sym_undefined] = ACTIONS(1994),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [297] = {
    [sym_import] = STATE(1174),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1174),
    [sym_yield_expression] = STATE(1174),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1174),
    [sym_jsx_fragment] = STATE(1174),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1174),
    [sym_class] = STATE(1174),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1174),
    [sym_arrow_function] = STATE(1174),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1174),
    [sym_new_expression] = STATE(1174),
    [sym_await_expression] = STATE(1174),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1174),
    [sym_augmented_assignment_expression] = STATE(1174),
    [sym_ternary_expression] = STATE(1174),
    [sym_binary_expression] = STATE(1174),
    [sym_unary_expression] = STATE(1174),
    [sym_update_expression] = STATE(1174),
    [sym_string] = STATE(1174),
    [sym_template_string] = STATE(1174),
    [sym_regex] = STATE(1174),
    [sym_meta_property] = STATE(1174),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1174),
    [sym_as_expression] = STATE(1174),
    [sym_internal_module] = STATE(1174),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1996),
    [sym_this] = ACTIONS(1998),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1998),
    [sym_false] = ACTIONS(1998),
    [sym_null] = ACTIONS(1998),
    [sym_undefined] = ACTIONS(1998),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [298] = {
    [sym_import] = STATE(1240),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1240),
    [sym_yield_expression] = STATE(1240),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1240),
    [sym_jsx_fragment] = STATE(1240),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1240),
    [sym_class] = STATE(1240),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1240),
    [sym_arrow_function] = STATE(1240),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1240),
    [sym_new_expression] = STATE(1240),
    [sym_await_expression] = STATE(1240),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1240),
    [sym_augmented_assignment_expression] = STATE(1240),
    [sym_ternary_expression] = STATE(1240),
    [sym_binary_expression] = STATE(1240),
    [sym_unary_expression] = STATE(1240),
    [sym_update_expression] = STATE(1240),
    [sym_string] = STATE(1240),
    [sym_template_string] = STATE(1240),
    [sym_regex] = STATE(1240),
    [sym_meta_property] = STATE(1240),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1240),
    [sym_as_expression] = STATE(1240),
    [sym_internal_module] = STATE(1240),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2000),
    [sym_this] = ACTIONS(2002),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2002),
    [sym_false] = ACTIONS(2002),
    [sym_null] = ACTIONS(2002),
    [sym_undefined] = ACTIONS(2002),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [299] = {
    [sym_import] = STATE(1375),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1375),
    [sym_yield_expression] = STATE(1375),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1375),
    [sym_jsx_fragment] = STATE(1375),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1375),
    [sym_class] = STATE(1375),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1375),
    [sym_arrow_function] = STATE(1375),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1375),
    [sym_new_expression] = STATE(1375),
    [sym_await_expression] = STATE(1375),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1375),
    [sym_augmented_assignment_expression] = STATE(1375),
    [sym_ternary_expression] = STATE(1375),
    [sym_binary_expression] = STATE(1375),
    [sym_unary_expression] = STATE(1375),
    [sym_update_expression] = STATE(1375),
    [sym_string] = STATE(1375),
    [sym_template_string] = STATE(1375),
    [sym_regex] = STATE(1375),
    [sym_meta_property] = STATE(1375),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1375),
    [sym_as_expression] = STATE(1375),
    [sym_internal_module] = STATE(1375),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2004),
    [sym_this] = ACTIONS(2006),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2006),
    [sym_false] = ACTIONS(2006),
    [sym_null] = ACTIONS(2006),
    [sym_undefined] = ACTIONS(2006),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [300] = {
    [sym_import] = STATE(1193),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1193),
    [sym_yield_expression] = STATE(1193),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1193),
    [sym_jsx_fragment] = STATE(1193),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1193),
    [sym_class] = STATE(1193),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1193),
    [sym_arrow_function] = STATE(1193),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1193),
    [sym_new_expression] = STATE(1193),
    [sym_await_expression] = STATE(1193),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1193),
    [sym_augmented_assignment_expression] = STATE(1193),
    [sym_ternary_expression] = STATE(1193),
    [sym_binary_expression] = STATE(1193),
    [sym_unary_expression] = STATE(1193),
    [sym_update_expression] = STATE(1193),
    [sym_string] = STATE(1193),
    [sym_template_string] = STATE(1193),
    [sym_regex] = STATE(1193),
    [sym_meta_property] = STATE(1193),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1193),
    [sym_as_expression] = STATE(1193),
    [sym_internal_module] = STATE(1193),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2008),
    [sym_this] = ACTIONS(2010),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2010),
    [sym_false] = ACTIONS(2010),
    [sym_null] = ACTIONS(2010),
    [sym_undefined] = ACTIONS(2010),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [301] = {
    [sym_import] = STATE(975),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(975),
    [sym_yield_expression] = STATE(975),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(975),
    [sym_jsx_fragment] = STATE(975),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(975),
    [sym_class] = STATE(975),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(975),
    [sym_arrow_function] = STATE(975),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(975),
    [sym_new_expression] = STATE(975),
    [sym_await_expression] = STATE(975),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(975),
    [sym_augmented_assignment_expression] = STATE(975),
    [sym_ternary_expression] = STATE(975),
    [sym_binary_expression] = STATE(975),
    [sym_unary_expression] = STATE(975),
    [sym_update_expression] = STATE(975),
    [sym_string] = STATE(975),
    [sym_template_string] = STATE(975),
    [sym_regex] = STATE(975),
    [sym_meta_property] = STATE(975),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(975),
    [sym_as_expression] = STATE(975),
    [sym_internal_module] = STATE(975),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2012),
    [sym_this] = ACTIONS(2014),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2014),
    [sym_false] = ACTIONS(2014),
    [sym_null] = ACTIONS(2014),
    [sym_undefined] = ACTIONS(2014),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [302] = {
    [sym_import] = STATE(1191),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1191),
    [sym_yield_expression] = STATE(1191),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1191),
    [sym_jsx_fragment] = STATE(1191),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1191),
    [sym_class] = STATE(1191),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1191),
    [sym_arrow_function] = STATE(1191),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1191),
    [sym_new_expression] = STATE(1191),
    [sym_await_expression] = STATE(1191),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1191),
    [sym_augmented_assignment_expression] = STATE(1191),
    [sym_ternary_expression] = STATE(1191),
    [sym_binary_expression] = STATE(1191),
    [sym_unary_expression] = STATE(1191),
    [sym_update_expression] = STATE(1191),
    [sym_string] = STATE(1191),
    [sym_template_string] = STATE(1191),
    [sym_regex] = STATE(1191),
    [sym_meta_property] = STATE(1191),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1191),
    [sym_as_expression] = STATE(1191),
    [sym_internal_module] = STATE(1191),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2016),
    [sym_this] = ACTIONS(2018),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_undefined] = ACTIONS(2018),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [303] = {
    [sym_import] = STATE(1356),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1356),
    [sym_yield_expression] = STATE(1356),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1356),
    [sym_jsx_fragment] = STATE(1356),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1356),
    [sym_class] = STATE(1356),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1356),
    [sym_arrow_function] = STATE(1356),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1356),
    [sym_new_expression] = STATE(1356),
    [sym_await_expression] = STATE(1356),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1356),
    [sym_augmented_assignment_expression] = STATE(1356),
    [sym_ternary_expression] = STATE(1356),
    [sym_binary_expression] = STATE(1356),
    [sym_unary_expression] = STATE(1356),
    [sym_update_expression] = STATE(1356),
    [sym_string] = STATE(1356),
    [sym_template_string] = STATE(1356),
    [sym_regex] = STATE(1356),
    [sym_meta_property] = STATE(1356),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1356),
    [sym_as_expression] = STATE(1356),
    [sym_internal_module] = STATE(1356),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1904),
    [sym_this] = ACTIONS(1882),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1882),
    [sym_false] = ACTIONS(1882),
    [sym_null] = ACTIONS(1882),
    [sym_undefined] = ACTIONS(1882),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [304] = {
    [sym_import] = STATE(994),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(994),
    [sym_yield_expression] = STATE(994),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(994),
    [sym_jsx_fragment] = STATE(994),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(994),
    [sym_class] = STATE(994),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(994),
    [sym_arrow_function] = STATE(994),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(994),
    [sym_new_expression] = STATE(994),
    [sym_await_expression] = STATE(994),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(994),
    [sym_augmented_assignment_expression] = STATE(994),
    [sym_ternary_expression] = STATE(994),
    [sym_binary_expression] = STATE(994),
    [sym_unary_expression] = STATE(994),
    [sym_update_expression] = STATE(994),
    [sym_string] = STATE(994),
    [sym_template_string] = STATE(994),
    [sym_regex] = STATE(994),
    [sym_meta_property] = STATE(994),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(994),
    [sym_as_expression] = STATE(994),
    [sym_internal_module] = STATE(994),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2020),
    [sym_this] = ACTIONS(2022),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2022),
    [sym_false] = ACTIONS(2022),
    [sym_null] = ACTIONS(2022),
    [sym_undefined] = ACTIONS(2022),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [305] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1122),
    [sym_jsx_fragment] = STATE(1122),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1122),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2024),
    [sym_this] = ACTIONS(2026),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2026),
    [sym_false] = ACTIONS(2026),
    [sym_null] = ACTIONS(2026),
    [sym_undefined] = ACTIONS(2026),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [306] = {
    [sym_import] = STATE(1114),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1114),
    [sym_jsx_fragment] = STATE(1114),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1114),
    [sym_class] = STATE(1114),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_ternary_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_update_expression] = STATE(1114),
    [sym_string] = STATE(1114),
    [sym_template_string] = STATE(1114),
    [sym_regex] = STATE(1114),
    [sym_meta_property] = STATE(1114),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1114),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2030),
    [sym_this] = ACTIONS(2032),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [307] = {
    [sym_import] = STATE(974),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(974),
    [sym_yield_expression] = STATE(974),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(974),
    [sym_jsx_fragment] = STATE(974),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(974),
    [sym_class] = STATE(974),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(974),
    [sym_arrow_function] = STATE(974),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(974),
    [sym_new_expression] = STATE(974),
    [sym_await_expression] = STATE(974),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(974),
    [sym_augmented_assignment_expression] = STATE(974),
    [sym_ternary_expression] = STATE(974),
    [sym_binary_expression] = STATE(974),
    [sym_unary_expression] = STATE(974),
    [sym_update_expression] = STATE(974),
    [sym_string] = STATE(974),
    [sym_template_string] = STATE(974),
    [sym_regex] = STATE(974),
    [sym_meta_property] = STATE(974),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(974),
    [sym_as_expression] = STATE(974),
    [sym_internal_module] = STATE(974),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2034),
    [sym_this] = ACTIONS(2036),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2036),
    [sym_false] = ACTIONS(2036),
    [sym_null] = ACTIONS(2036),
    [sym_undefined] = ACTIONS(2036),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [308] = {
    [sym_import] = STATE(1239),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1239),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1239),
    [sym_jsx_fragment] = STATE(1239),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1239),
    [sym_class] = STATE(1239),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1239),
    [sym_arrow_function] = STATE(1239),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1239),
    [sym_new_expression] = STATE(1239),
    [sym_await_expression] = STATE(1239),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1239),
    [sym_augmented_assignment_expression] = STATE(1239),
    [sym_ternary_expression] = STATE(1239),
    [sym_binary_expression] = STATE(1239),
    [sym_unary_expression] = STATE(1239),
    [sym_update_expression] = STATE(1239),
    [sym_string] = STATE(1239),
    [sym_template_string] = STATE(1239),
    [sym_regex] = STATE(1239),
    [sym_meta_property] = STATE(1239),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1239),
    [sym_as_expression] = STATE(1239),
    [sym_internal_module] = STATE(1239),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2038),
    [sym_this] = ACTIONS(951),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(951),
    [sym_false] = ACTIONS(951),
    [sym_null] = ACTIONS(951),
    [sym_undefined] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [309] = {
    [sym_import] = STATE(1075),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1075),
    [sym_yield_expression] = STATE(1075),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1075),
    [sym_jsx_fragment] = STATE(1075),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1075),
    [sym_class] = STATE(1075),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1075),
    [sym_arrow_function] = STATE(1075),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1075),
    [sym_new_expression] = STATE(1075),
    [sym_await_expression] = STATE(1075),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1075),
    [sym_augmented_assignment_expression] = STATE(1075),
    [sym_ternary_expression] = STATE(1075),
    [sym_binary_expression] = STATE(1075),
    [sym_unary_expression] = STATE(1075),
    [sym_update_expression] = STATE(1075),
    [sym_string] = STATE(1075),
    [sym_template_string] = STATE(1075),
    [sym_regex] = STATE(1075),
    [sym_meta_property] = STATE(1075),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1075),
    [sym_as_expression] = STATE(1075),
    [sym_internal_module] = STATE(1075),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2040),
    [sym_this] = ACTIONS(2042),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2042),
    [sym_false] = ACTIONS(2042),
    [sym_null] = ACTIONS(2042),
    [sym_undefined] = ACTIONS(2042),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [310] = {
    [sym_import] = STATE(1464),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1464),
    [sym_yield_expression] = STATE(1464),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1464),
    [sym_jsx_fragment] = STATE(1464),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1464),
    [sym_class] = STATE(1464),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1464),
    [sym_arrow_function] = STATE(1464),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1464),
    [sym_new_expression] = STATE(1464),
    [sym_await_expression] = STATE(1464),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1464),
    [sym_augmented_assignment_expression] = STATE(1464),
    [sym_ternary_expression] = STATE(1464),
    [sym_binary_expression] = STATE(1464),
    [sym_unary_expression] = STATE(1464),
    [sym_update_expression] = STATE(1464),
    [sym_string] = STATE(1464),
    [sym_template_string] = STATE(1464),
    [sym_regex] = STATE(1464),
    [sym_meta_property] = STATE(1464),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1464),
    [sym_as_expression] = STATE(1464),
    [sym_internal_module] = STATE(1464),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2044),
    [sym_this] = ACTIONS(2046),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2046),
    [sym_false] = ACTIONS(2046),
    [sym_null] = ACTIONS(2046),
    [sym_undefined] = ACTIONS(2046),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [311] = {
    [sym_import] = STATE(1236),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1236),
    [sym_yield_expression] = STATE(1236),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1236),
    [sym_jsx_fragment] = STATE(1236),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1236),
    [sym_class] = STATE(1236),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1236),
    [sym_arrow_function] = STATE(1236),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1236),
    [sym_new_expression] = STATE(1236),
    [sym_await_expression] = STATE(1236),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1236),
    [sym_augmented_assignment_expression] = STATE(1236),
    [sym_ternary_expression] = STATE(1236),
    [sym_binary_expression] = STATE(1236),
    [sym_unary_expression] = STATE(1236),
    [sym_update_expression] = STATE(1236),
    [sym_string] = STATE(1236),
    [sym_template_string] = STATE(1236),
    [sym_regex] = STATE(1236),
    [sym_meta_property] = STATE(1236),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1236),
    [sym_as_expression] = STATE(1236),
    [sym_internal_module] = STATE(1236),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2048),
    [sym_this] = ACTIONS(2050),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2050),
    [sym_false] = ACTIONS(2050),
    [sym_null] = ACTIONS(2050),
    [sym_undefined] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [312] = {
    [sym_import] = STATE(1114),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1114),
    [sym_yield_expression] = STATE(1114),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1114),
    [sym_jsx_fragment] = STATE(1114),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1114),
    [sym_class] = STATE(1114),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1114),
    [sym_arrow_function] = STATE(1114),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1114),
    [sym_new_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(1114),
    [sym_ternary_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_update_expression] = STATE(1114),
    [sym_string] = STATE(1114),
    [sym_template_string] = STATE(1114),
    [sym_regex] = STATE(1114),
    [sym_meta_property] = STATE(1114),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1114),
    [sym_as_expression] = STATE(1114),
    [sym_internal_module] = STATE(1114),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2030),
    [sym_this] = ACTIONS(2032),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2032),
    [sym_false] = ACTIONS(2032),
    [sym_null] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [313] = {
    [sym_import] = STATE(1235),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1235),
    [sym_yield_expression] = STATE(1235),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1235),
    [sym_jsx_fragment] = STATE(1235),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1235),
    [sym_class] = STATE(1235),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1235),
    [sym_arrow_function] = STATE(1235),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1235),
    [sym_new_expression] = STATE(1235),
    [sym_await_expression] = STATE(1235),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1235),
    [sym_augmented_assignment_expression] = STATE(1235),
    [sym_ternary_expression] = STATE(1235),
    [sym_binary_expression] = STATE(1235),
    [sym_unary_expression] = STATE(1235),
    [sym_update_expression] = STATE(1235),
    [sym_string] = STATE(1235),
    [sym_template_string] = STATE(1235),
    [sym_regex] = STATE(1235),
    [sym_meta_property] = STATE(1235),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1235),
    [sym_as_expression] = STATE(1235),
    [sym_internal_module] = STATE(1235),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2052),
    [sym_this] = ACTIONS(2054),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_undefined] = ACTIONS(2054),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [314] = {
    [sym_import] = STATE(995),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(995),
    [sym_yield_expression] = STATE(995),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(995),
    [sym_jsx_fragment] = STATE(995),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(995),
    [sym_class] = STATE(995),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(995),
    [sym_arrow_function] = STATE(995),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(995),
    [sym_new_expression] = STATE(995),
    [sym_await_expression] = STATE(995),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(995),
    [sym_augmented_assignment_expression] = STATE(995),
    [sym_ternary_expression] = STATE(995),
    [sym_binary_expression] = STATE(995),
    [sym_unary_expression] = STATE(995),
    [sym_update_expression] = STATE(995),
    [sym_string] = STATE(995),
    [sym_template_string] = STATE(995),
    [sym_regex] = STATE(995),
    [sym_meta_property] = STATE(995),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(995),
    [sym_as_expression] = STATE(995),
    [sym_internal_module] = STATE(995),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2056),
    [sym_this] = ACTIONS(2058),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2058),
    [sym_false] = ACTIONS(2058),
    [sym_null] = ACTIONS(2058),
    [sym_undefined] = ACTIONS(2058),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [315] = {
    [sym_import] = STATE(957),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(957),
    [sym_jsx_fragment] = STATE(957),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(957),
    [sym_class] = STATE(957),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(957),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1916),
    [sym_this] = ACTIONS(1918),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [sym_null] = ACTIONS(1918),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [316] = {
    [sym_import] = STATE(1234),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1234),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1234),
    [sym_jsx_fragment] = STATE(1234),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1234),
    [sym_class] = STATE(1234),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1234),
    [sym_arrow_function] = STATE(1234),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1234),
    [sym_new_expression] = STATE(1234),
    [sym_await_expression] = STATE(1234),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1234),
    [sym_augmented_assignment_expression] = STATE(1234),
    [sym_ternary_expression] = STATE(1234),
    [sym_binary_expression] = STATE(1234),
    [sym_unary_expression] = STATE(1234),
    [sym_update_expression] = STATE(1234),
    [sym_string] = STATE(1234),
    [sym_template_string] = STATE(1234),
    [sym_regex] = STATE(1234),
    [sym_meta_property] = STATE(1234),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1234),
    [sym_as_expression] = STATE(1234),
    [sym_internal_module] = STATE(1234),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2060),
    [sym_this] = ACTIONS(2062),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2062),
    [sym_false] = ACTIONS(2062),
    [sym_null] = ACTIONS(2062),
    [sym_undefined] = ACTIONS(2062),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [317] = {
    [sym_import] = STATE(1524),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1524),
    [sym_yield_expression] = STATE(1524),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1524),
    [sym_jsx_fragment] = STATE(1524),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1524),
    [sym_class] = STATE(1524),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1524),
    [sym_arrow_function] = STATE(1524),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1524),
    [sym_new_expression] = STATE(1524),
    [sym_await_expression] = STATE(1524),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1524),
    [sym_augmented_assignment_expression] = STATE(1524),
    [sym_ternary_expression] = STATE(1524),
    [sym_binary_expression] = STATE(1524),
    [sym_unary_expression] = STATE(1524),
    [sym_update_expression] = STATE(1524),
    [sym_string] = STATE(1524),
    [sym_template_string] = STATE(1524),
    [sym_regex] = STATE(1524),
    [sym_meta_property] = STATE(1524),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1524),
    [sym_as_expression] = STATE(1524),
    [sym_internal_module] = STATE(1524),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1509),
    [sym_this] = ACTIONS(1511),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1511),
    [sym_false] = ACTIONS(1511),
    [sym_null] = ACTIONS(1511),
    [sym_undefined] = ACTIONS(1511),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [318] = {
    [sym_import] = STATE(1233),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1233),
    [sym_yield_expression] = STATE(1233),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1233),
    [sym_jsx_fragment] = STATE(1233),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1233),
    [sym_class] = STATE(1233),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1233),
    [sym_arrow_function] = STATE(1233),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1233),
    [sym_new_expression] = STATE(1233),
    [sym_await_expression] = STATE(1233),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1233),
    [sym_augmented_assignment_expression] = STATE(1233),
    [sym_ternary_expression] = STATE(1233),
    [sym_binary_expression] = STATE(1233),
    [sym_unary_expression] = STATE(1233),
    [sym_update_expression] = STATE(1233),
    [sym_string] = STATE(1233),
    [sym_template_string] = STATE(1233),
    [sym_regex] = STATE(1233),
    [sym_meta_property] = STATE(1233),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1233),
    [sym_as_expression] = STATE(1233),
    [sym_internal_module] = STATE(1233),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2064),
    [sym_this] = ACTIONS(2066),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2066),
    [sym_false] = ACTIONS(2066),
    [sym_null] = ACTIONS(2066),
    [sym_undefined] = ACTIONS(2066),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [319] = {
    [sym_import] = STATE(1351),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1351),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1351),
    [sym_jsx_fragment] = STATE(1351),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1351),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1351),
    [sym_arrow_function] = STATE(1351),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1351),
    [sym_await_expression] = STATE(1351),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1351),
    [sym_augmented_assignment_expression] = STATE(1351),
    [sym_ternary_expression] = STATE(1351),
    [sym_binary_expression] = STATE(1351),
    [sym_unary_expression] = STATE(1351),
    [sym_update_expression] = STATE(1351),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1351),
    [sym_as_expression] = STATE(1351),
    [sym_internal_module] = STATE(1351),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2068),
    [sym_this] = ACTIONS(2070),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2070),
    [sym_false] = ACTIONS(2070),
    [sym_null] = ACTIONS(2070),
    [sym_undefined] = ACTIONS(2070),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [320] = {
    [sym_import] = STATE(1350),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1350),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1350),
    [sym_jsx_fragment] = STATE(1350),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1350),
    [sym_class] = STATE(1350),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1350),
    [sym_arrow_function] = STATE(1350),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1350),
    [sym_new_expression] = STATE(1350),
    [sym_await_expression] = STATE(1350),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1350),
    [sym_augmented_assignment_expression] = STATE(1350),
    [sym_ternary_expression] = STATE(1350),
    [sym_binary_expression] = STATE(1350),
    [sym_unary_expression] = STATE(1350),
    [sym_update_expression] = STATE(1350),
    [sym_string] = STATE(1350),
    [sym_template_string] = STATE(1350),
    [sym_regex] = STATE(1350),
    [sym_meta_property] = STATE(1350),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1350),
    [sym_as_expression] = STATE(1350),
    [sym_internal_module] = STATE(1350),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2072),
    [sym_this] = ACTIONS(2074),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2074),
    [sym_false] = ACTIONS(2074),
    [sym_null] = ACTIONS(2074),
    [sym_undefined] = ACTIONS(2074),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [321] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1349),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1349),
    [sym_jsx_fragment] = STATE(1349),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1349),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1349),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1349),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1349),
    [sym_augmented_assignment_expression] = STATE(1349),
    [sym_ternary_expression] = STATE(1349),
    [sym_binary_expression] = STATE(1349),
    [sym_unary_expression] = STATE(1349),
    [sym_update_expression] = STATE(1349),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1349),
    [sym_as_expression] = STATE(1349),
    [sym_internal_module] = STATE(1349),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2076),
    [sym_this] = ACTIONS(2078),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2078),
    [sym_false] = ACTIONS(2078),
    [sym_null] = ACTIONS(2078),
    [sym_undefined] = ACTIONS(2078),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [322] = {
    [sym_import] = STATE(978),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(978),
    [sym_yield_expression] = STATE(978),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(978),
    [sym_jsx_fragment] = STATE(978),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(978),
    [sym_class] = STATE(978),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(978),
    [sym_arrow_function] = STATE(978),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(978),
    [sym_new_expression] = STATE(978),
    [sym_await_expression] = STATE(978),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(978),
    [sym_augmented_assignment_expression] = STATE(978),
    [sym_ternary_expression] = STATE(978),
    [sym_binary_expression] = STATE(978),
    [sym_unary_expression] = STATE(978),
    [sym_update_expression] = STATE(978),
    [sym_string] = STATE(978),
    [sym_template_string] = STATE(978),
    [sym_regex] = STATE(978),
    [sym_meta_property] = STATE(978),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(978),
    [sym_as_expression] = STATE(978),
    [sym_internal_module] = STATE(978),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2080),
    [sym_this] = ACTIONS(2082),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2082),
    [sym_false] = ACTIONS(2082),
    [sym_null] = ACTIONS(2082),
    [sym_undefined] = ACTIONS(2082),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [323] = {
    [sym_import] = STATE(1347),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1347),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1347),
    [sym_jsx_fragment] = STATE(1347),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1347),
    [sym_class] = STATE(1347),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1347),
    [sym_arrow_function] = STATE(1347),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1347),
    [sym_new_expression] = STATE(1347),
    [sym_await_expression] = STATE(1347),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1347),
    [sym_augmented_assignment_expression] = STATE(1347),
    [sym_ternary_expression] = STATE(1347),
    [sym_binary_expression] = STATE(1347),
    [sym_unary_expression] = STATE(1347),
    [sym_update_expression] = STATE(1347),
    [sym_string] = STATE(1347),
    [sym_template_string] = STATE(1347),
    [sym_regex] = STATE(1347),
    [sym_meta_property] = STATE(1347),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1347),
    [sym_as_expression] = STATE(1347),
    [sym_internal_module] = STATE(1347),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2084),
    [sym_this] = ACTIONS(2086),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2086),
    [sym_false] = ACTIONS(2086),
    [sym_null] = ACTIONS(2086),
    [sym_undefined] = ACTIONS(2086),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [324] = {
    [sym_import] = STATE(1346),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1346),
    [sym_yield_expression] = STATE(1346),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1346),
    [sym_jsx_fragment] = STATE(1346),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1346),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1346),
    [sym_await_expression] = STATE(1346),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1346),
    [sym_augmented_assignment_expression] = STATE(1346),
    [sym_ternary_expression] = STATE(1346),
    [sym_binary_expression] = STATE(1346),
    [sym_unary_expression] = STATE(1346),
    [sym_update_expression] = STATE(1346),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1346),
    [sym_as_expression] = STATE(1346),
    [sym_internal_module] = STATE(1346),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2088),
    [sym_this] = ACTIONS(2090),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2090),
    [sym_false] = ACTIONS(2090),
    [sym_null] = ACTIONS(2090),
    [sym_undefined] = ACTIONS(2090),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [325] = {
    [sym_import] = STATE(1343),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1343),
    [sym_yield_expression] = STATE(1343),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1343),
    [sym_jsx_fragment] = STATE(1343),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1343),
    [sym_class] = STATE(1343),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1343),
    [sym_arrow_function] = STATE(1343),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1343),
    [sym_new_expression] = STATE(1343),
    [sym_await_expression] = STATE(1343),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1343),
    [sym_augmented_assignment_expression] = STATE(1343),
    [sym_ternary_expression] = STATE(1343),
    [sym_binary_expression] = STATE(1343),
    [sym_unary_expression] = STATE(1343),
    [sym_update_expression] = STATE(1343),
    [sym_string] = STATE(1343),
    [sym_template_string] = STATE(1343),
    [sym_regex] = STATE(1343),
    [sym_meta_property] = STATE(1343),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1343),
    [sym_as_expression] = STATE(1343),
    [sym_internal_module] = STATE(1343),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2092),
    [sym_this] = ACTIONS(2094),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [sym_null] = ACTIONS(2094),
    [sym_undefined] = ACTIONS(2094),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [326] = {
    [sym_import] = STATE(1509),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1509),
    [sym_yield_expression] = STATE(1509),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1509),
    [sym_jsx_fragment] = STATE(1509),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1509),
    [sym_class] = STATE(1509),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1509),
    [sym_arrow_function] = STATE(1509),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1509),
    [sym_new_expression] = STATE(1509),
    [sym_await_expression] = STATE(1509),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1509),
    [sym_augmented_assignment_expression] = STATE(1509),
    [sym_ternary_expression] = STATE(1509),
    [sym_binary_expression] = STATE(1509),
    [sym_unary_expression] = STATE(1509),
    [sym_update_expression] = STATE(1509),
    [sym_string] = STATE(1509),
    [sym_template_string] = STATE(1509),
    [sym_regex] = STATE(1509),
    [sym_meta_property] = STATE(1509),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1509),
    [sym_as_expression] = STATE(1509),
    [sym_internal_module] = STATE(1509),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2096),
    [sym_this] = ACTIONS(2098),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2098),
    [sym_false] = ACTIONS(2098),
    [sym_null] = ACTIONS(2098),
    [sym_undefined] = ACTIONS(2098),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [327] = {
    [sym_import] = STATE(1364),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1364),
    [sym_jsx_fragment] = STATE(1364),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1364),
    [sym_class] = STATE(1364),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1364),
    [sym_arrow_function] = STATE(1364),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_string] = STATE(1364),
    [sym_template_string] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1364),
    [sym_as_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2100),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [328] = {
    [sym_import] = STATE(1004),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1004),
    [sym_yield_expression] = STATE(1004),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1004),
    [sym_jsx_fragment] = STATE(1004),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1004),
    [sym_class] = STATE(1004),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1004),
    [sym_arrow_function] = STATE(1004),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1004),
    [sym_new_expression] = STATE(1004),
    [sym_await_expression] = STATE(1004),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1004),
    [sym_augmented_assignment_expression] = STATE(1004),
    [sym_ternary_expression] = STATE(1004),
    [sym_binary_expression] = STATE(1004),
    [sym_unary_expression] = STATE(1004),
    [sym_update_expression] = STATE(1004),
    [sym_string] = STATE(1004),
    [sym_template_string] = STATE(1004),
    [sym_regex] = STATE(1004),
    [sym_meta_property] = STATE(1004),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1004),
    [sym_as_expression] = STATE(1004),
    [sym_internal_module] = STATE(1004),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2104),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2104),
    [sym_false] = ACTIONS(2104),
    [sym_null] = ACTIONS(2104),
    [sym_undefined] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [329] = {
    [sym_import] = STATE(1116),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1116),
    [sym_yield_expression] = STATE(1116),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1116),
    [sym_jsx_fragment] = STATE(1116),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1116),
    [sym_class] = STATE(1116),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1116),
    [sym_arrow_function] = STATE(1116),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1116),
    [sym_new_expression] = STATE(1116),
    [sym_await_expression] = STATE(1116),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1116),
    [sym_augmented_assignment_expression] = STATE(1116),
    [sym_ternary_expression] = STATE(1116),
    [sym_binary_expression] = STATE(1116),
    [sym_unary_expression] = STATE(1116),
    [sym_update_expression] = STATE(1116),
    [sym_string] = STATE(1116),
    [sym_template_string] = STATE(1116),
    [sym_regex] = STATE(1116),
    [sym_meta_property] = STATE(1116),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1116),
    [sym_as_expression] = STATE(1116),
    [sym_internal_module] = STATE(1116),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2106),
    [sym_this] = ACTIONS(2108),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2108),
    [sym_false] = ACTIONS(2108),
    [sym_null] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [330] = {
    [sym_import] = STATE(1339),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1339),
    [sym_yield_expression] = STATE(1339),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1339),
    [sym_jsx_fragment] = STATE(1339),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1339),
    [sym_class] = STATE(1339),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1339),
    [sym_arrow_function] = STATE(1339),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1339),
    [sym_new_expression] = STATE(1339),
    [sym_await_expression] = STATE(1339),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1339),
    [sym_augmented_assignment_expression] = STATE(1339),
    [sym_ternary_expression] = STATE(1339),
    [sym_binary_expression] = STATE(1339),
    [sym_unary_expression] = STATE(1339),
    [sym_update_expression] = STATE(1339),
    [sym_string] = STATE(1339),
    [sym_template_string] = STATE(1339),
    [sym_regex] = STATE(1339),
    [sym_meta_property] = STATE(1339),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1339),
    [sym_as_expression] = STATE(1339),
    [sym_internal_module] = STATE(1339),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2110),
    [sym_this] = ACTIONS(2112),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2112),
    [sym_false] = ACTIONS(2112),
    [sym_null] = ACTIONS(2112),
    [sym_undefined] = ACTIONS(2112),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [331] = {
    [sym_import] = STATE(1015),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1015),
    [sym_yield_expression] = STATE(1015),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1015),
    [sym_jsx_fragment] = STATE(1015),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1015),
    [sym_class] = STATE(1015),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1015),
    [sym_arrow_function] = STATE(1015),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1015),
    [sym_new_expression] = STATE(1015),
    [sym_await_expression] = STATE(1015),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1015),
    [sym_augmented_assignment_expression] = STATE(1015),
    [sym_ternary_expression] = STATE(1015),
    [sym_binary_expression] = STATE(1015),
    [sym_unary_expression] = STATE(1015),
    [sym_update_expression] = STATE(1015),
    [sym_string] = STATE(1015),
    [sym_template_string] = STATE(1015),
    [sym_regex] = STATE(1015),
    [sym_meta_property] = STATE(1015),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1015),
    [sym_as_expression] = STATE(1015),
    [sym_internal_module] = STATE(1015),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2114),
    [sym_this] = ACTIONS(2116),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2116),
    [sym_false] = ACTIONS(2116),
    [sym_null] = ACTIONS(2116),
    [sym_undefined] = ACTIONS(2116),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [332] = {
    [sym_import] = STATE(1176),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1176),
    [sym_yield_expression] = STATE(1176),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1176),
    [sym_jsx_fragment] = STATE(1176),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1176),
    [sym_class] = STATE(1176),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1176),
    [sym_arrow_function] = STATE(1176),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1176),
    [sym_new_expression] = STATE(1176),
    [sym_await_expression] = STATE(1176),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1176),
    [sym_augmented_assignment_expression] = STATE(1176),
    [sym_ternary_expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_unary_expression] = STATE(1176),
    [sym_update_expression] = STATE(1176),
    [sym_string] = STATE(1176),
    [sym_template_string] = STATE(1176),
    [sym_regex] = STATE(1176),
    [sym_meta_property] = STATE(1176),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1176),
    [sym_as_expression] = STATE(1176),
    [sym_internal_module] = STATE(1176),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2118),
    [sym_this] = ACTIONS(2120),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2120),
    [sym_false] = ACTIONS(2120),
    [sym_null] = ACTIONS(2120),
    [sym_undefined] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [333] = {
    [sym_import] = STATE(1117),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1117),
    [sym_yield_expression] = STATE(1117),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1117),
    [sym_jsx_fragment] = STATE(1117),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1117),
    [sym_class] = STATE(1117),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1117),
    [sym_arrow_function] = STATE(1117),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1117),
    [sym_new_expression] = STATE(1117),
    [sym_await_expression] = STATE(1117),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1117),
    [sym_augmented_assignment_expression] = STATE(1117),
    [sym_ternary_expression] = STATE(1117),
    [sym_binary_expression] = STATE(1117),
    [sym_unary_expression] = STATE(1117),
    [sym_update_expression] = STATE(1117),
    [sym_string] = STATE(1117),
    [sym_template_string] = STATE(1117),
    [sym_regex] = STATE(1117),
    [sym_meta_property] = STATE(1117),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1117),
    [sym_as_expression] = STATE(1117),
    [sym_internal_module] = STATE(1117),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2122),
    [sym_this] = ACTIONS(2124),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2124),
    [sym_false] = ACTIONS(2124),
    [sym_null] = ACTIONS(2124),
    [sym_undefined] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [334] = {
    [sym_import] = STATE(1285),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1285),
    [sym_yield_expression] = STATE(1285),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1285),
    [sym_jsx_fragment] = STATE(1285),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1285),
    [sym_class] = STATE(1285),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1285),
    [sym_arrow_function] = STATE(1285),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1285),
    [sym_new_expression] = STATE(1285),
    [sym_await_expression] = STATE(1285),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1285),
    [sym_augmented_assignment_expression] = STATE(1285),
    [sym_ternary_expression] = STATE(1285),
    [sym_binary_expression] = STATE(1285),
    [sym_unary_expression] = STATE(1285),
    [sym_update_expression] = STATE(1285),
    [sym_string] = STATE(1285),
    [sym_template_string] = STATE(1285),
    [sym_regex] = STATE(1285),
    [sym_meta_property] = STATE(1285),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1285),
    [sym_as_expression] = STATE(1285),
    [sym_internal_module] = STATE(1285),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2126),
    [sym_this] = ACTIONS(2128),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2128),
    [sym_false] = ACTIONS(2128),
    [sym_null] = ACTIONS(2128),
    [sym_undefined] = ACTIONS(2128),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [335] = {
    [sym_import] = STATE(1336),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1336),
    [sym_yield_expression] = STATE(1336),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1336),
    [sym_jsx_fragment] = STATE(1336),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1336),
    [sym_class] = STATE(1336),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1336),
    [sym_arrow_function] = STATE(1336),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1336),
    [sym_new_expression] = STATE(1336),
    [sym_await_expression] = STATE(1336),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1336),
    [sym_augmented_assignment_expression] = STATE(1336),
    [sym_ternary_expression] = STATE(1336),
    [sym_binary_expression] = STATE(1336),
    [sym_unary_expression] = STATE(1336),
    [sym_update_expression] = STATE(1336),
    [sym_string] = STATE(1336),
    [sym_template_string] = STATE(1336),
    [sym_regex] = STATE(1336),
    [sym_meta_property] = STATE(1336),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1336),
    [sym_as_expression] = STATE(1336),
    [sym_internal_module] = STATE(1336),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2130),
    [sym_this] = ACTIONS(2132),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2132),
    [sym_false] = ACTIONS(2132),
    [sym_null] = ACTIONS(2132),
    [sym_undefined] = ACTIONS(2132),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [336] = {
    [sym_import] = STATE(1121),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1121),
    [sym_jsx_fragment] = STATE(1121),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1121),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1121),
    [sym_arrow_function] = STATE(1121),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1121),
    [sym_as_expression] = STATE(1121),
    [sym_internal_module] = STATE(1121),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2134),
    [sym_this] = ACTIONS(2136),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2136),
    [sym_false] = ACTIONS(2136),
    [sym_null] = ACTIONS(2136),
    [sym_undefined] = ACTIONS(2136),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [337] = {
    [sym_import] = STATE(1363),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1363),
    [sym_yield_expression] = STATE(1363),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1363),
    [sym_jsx_fragment] = STATE(1363),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1363),
    [sym_class] = STATE(1363),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1363),
    [sym_arrow_function] = STATE(1363),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1363),
    [sym_new_expression] = STATE(1363),
    [sym_await_expression] = STATE(1363),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1363),
    [sym_augmented_assignment_expression] = STATE(1363),
    [sym_ternary_expression] = STATE(1363),
    [sym_binary_expression] = STATE(1363),
    [sym_unary_expression] = STATE(1363),
    [sym_update_expression] = STATE(1363),
    [sym_string] = STATE(1363),
    [sym_template_string] = STATE(1363),
    [sym_regex] = STATE(1363),
    [sym_meta_property] = STATE(1363),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1363),
    [sym_as_expression] = STATE(1363),
    [sym_internal_module] = STATE(1363),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2138),
    [sym_this] = ACTIONS(985),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [338] = {
    [sym_import] = STATE(1095),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1095),
    [sym_yield_expression] = STATE(1095),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1095),
    [sym_jsx_fragment] = STATE(1095),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1095),
    [sym_class] = STATE(1095),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1095),
    [sym_arrow_function] = STATE(1095),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1095),
    [sym_new_expression] = STATE(1095),
    [sym_await_expression] = STATE(1095),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1095),
    [sym_augmented_assignment_expression] = STATE(1095),
    [sym_ternary_expression] = STATE(1095),
    [sym_binary_expression] = STATE(1095),
    [sym_unary_expression] = STATE(1095),
    [sym_update_expression] = STATE(1095),
    [sym_string] = STATE(1095),
    [sym_template_string] = STATE(1095),
    [sym_regex] = STATE(1095),
    [sym_meta_property] = STATE(1095),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1095),
    [sym_as_expression] = STATE(1095),
    [sym_internal_module] = STATE(1095),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2140),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [339] = {
    [sym_import] = STATE(1333),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1333),
    [sym_yield_expression] = STATE(1333),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1333),
    [sym_jsx_fragment] = STATE(1333),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1333),
    [sym_class] = STATE(1333),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1333),
    [sym_arrow_function] = STATE(1333),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_await_expression] = STATE(1333),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1333),
    [sym_augmented_assignment_expression] = STATE(1333),
    [sym_ternary_expression] = STATE(1333),
    [sym_binary_expression] = STATE(1333),
    [sym_unary_expression] = STATE(1333),
    [sym_update_expression] = STATE(1333),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1333),
    [sym_regex] = STATE(1333),
    [sym_meta_property] = STATE(1333),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1333),
    [sym_as_expression] = STATE(1333),
    [sym_internal_module] = STATE(1333),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2144),
    [sym_this] = ACTIONS(2146),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2146),
    [sym_false] = ACTIONS(2146),
    [sym_null] = ACTIONS(2146),
    [sym_undefined] = ACTIONS(2146),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [340] = {
    [sym_import] = STATE(1232),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1232),
    [sym_yield_expression] = STATE(1232),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1232),
    [sym_jsx_fragment] = STATE(1232),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1232),
    [sym_class] = STATE(1232),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1232),
    [sym_arrow_function] = STATE(1232),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1232),
    [sym_new_expression] = STATE(1232),
    [sym_await_expression] = STATE(1232),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1232),
    [sym_augmented_assignment_expression] = STATE(1232),
    [sym_ternary_expression] = STATE(1232),
    [sym_binary_expression] = STATE(1232),
    [sym_unary_expression] = STATE(1232),
    [sym_update_expression] = STATE(1232),
    [sym_string] = STATE(1232),
    [sym_template_string] = STATE(1232),
    [sym_regex] = STATE(1232),
    [sym_meta_property] = STATE(1232),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1232),
    [sym_as_expression] = STATE(1232),
    [sym_internal_module] = STATE(1232),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2148),
    [sym_this] = ACTIONS(2150),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2150),
    [sym_false] = ACTIONS(2150),
    [sym_null] = ACTIONS(2150),
    [sym_undefined] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [341] = {
    [sym_import] = STATE(1005),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1005),
    [sym_yield_expression] = STATE(1005),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1005),
    [sym_jsx_fragment] = STATE(1005),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1005),
    [sym_class] = STATE(1005),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1005),
    [sym_arrow_function] = STATE(1005),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1005),
    [sym_new_expression] = STATE(1005),
    [sym_await_expression] = STATE(1005),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1005),
    [sym_augmented_assignment_expression] = STATE(1005),
    [sym_ternary_expression] = STATE(1005),
    [sym_binary_expression] = STATE(1005),
    [sym_unary_expression] = STATE(1005),
    [sym_update_expression] = STATE(1005),
    [sym_string] = STATE(1005),
    [sym_template_string] = STATE(1005),
    [sym_regex] = STATE(1005),
    [sym_meta_property] = STATE(1005),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1005),
    [sym_as_expression] = STATE(1005),
    [sym_internal_module] = STATE(1005),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2152),
    [sym_this] = ACTIONS(2154),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2154),
    [sym_false] = ACTIONS(2154),
    [sym_null] = ACTIONS(2154),
    [sym_undefined] = ACTIONS(2154),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [342] = {
    [sym_import] = STATE(1177),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1177),
    [sym_yield_expression] = STATE(1177),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1177),
    [sym_jsx_fragment] = STATE(1177),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1177),
    [sym_class] = STATE(1177),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1177),
    [sym_arrow_function] = STATE(1177),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1177),
    [sym_new_expression] = STATE(1177),
    [sym_await_expression] = STATE(1177),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1177),
    [sym_augmented_assignment_expression] = STATE(1177),
    [sym_ternary_expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_unary_expression] = STATE(1177),
    [sym_update_expression] = STATE(1177),
    [sym_string] = STATE(1177),
    [sym_template_string] = STATE(1177),
    [sym_regex] = STATE(1177),
    [sym_meta_property] = STATE(1177),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1177),
    [sym_as_expression] = STATE(1177),
    [sym_internal_module] = STATE(1177),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2156),
    [sym_this] = ACTIONS(1041),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [343] = {
    [sym_import] = STATE(1367),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1367),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1367),
    [sym_jsx_fragment] = STATE(1367),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1367),
    [sym_class] = STATE(1367),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1367),
    [sym_arrow_function] = STATE(1367),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1367),
    [sym_new_expression] = STATE(1367),
    [sym_await_expression] = STATE(1367),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1367),
    [sym_augmented_assignment_expression] = STATE(1367),
    [sym_ternary_expression] = STATE(1367),
    [sym_binary_expression] = STATE(1367),
    [sym_unary_expression] = STATE(1367),
    [sym_update_expression] = STATE(1367),
    [sym_string] = STATE(1367),
    [sym_template_string] = STATE(1367),
    [sym_regex] = STATE(1367),
    [sym_meta_property] = STATE(1367),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1367),
    [sym_as_expression] = STATE(1367),
    [sym_internal_module] = STATE(1367),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(2158),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2160),
    [sym_this] = ACTIONS(2162),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_null] = ACTIONS(2162),
    [sym_undefined] = ACTIONS(2162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [344] = {
    [sym_import] = STATE(1178),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1178),
    [sym_yield_expression] = STATE(1178),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1178),
    [sym_jsx_fragment] = STATE(1178),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1178),
    [sym_class] = STATE(1178),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1178),
    [sym_arrow_function] = STATE(1178),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1178),
    [sym_new_expression] = STATE(1178),
    [sym_await_expression] = STATE(1178),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1178),
    [sym_augmented_assignment_expression] = STATE(1178),
    [sym_ternary_expression] = STATE(1178),
    [sym_binary_expression] = STATE(1178),
    [sym_unary_expression] = STATE(1178),
    [sym_update_expression] = STATE(1178),
    [sym_string] = STATE(1178),
    [sym_template_string] = STATE(1178),
    [sym_regex] = STATE(1178),
    [sym_meta_property] = STATE(1178),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1178),
    [sym_as_expression] = STATE(1178),
    [sym_internal_module] = STATE(1178),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2164),
    [sym_this] = ACTIONS(2166),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2166),
    [sym_false] = ACTIONS(2166),
    [sym_null] = ACTIONS(2166),
    [sym_undefined] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [345] = {
    [sym_import] = STATE(1179),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1179),
    [sym_yield_expression] = STATE(1179),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1179),
    [sym_jsx_fragment] = STATE(1179),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1179),
    [sym_class] = STATE(1179),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1179),
    [sym_arrow_function] = STATE(1179),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1179),
    [sym_new_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1179),
    [sym_augmented_assignment_expression] = STATE(1179),
    [sym_ternary_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_update_expression] = STATE(1179),
    [sym_string] = STATE(1179),
    [sym_template_string] = STATE(1179),
    [sym_regex] = STATE(1179),
    [sym_meta_property] = STATE(1179),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1179),
    [sym_as_expression] = STATE(1179),
    [sym_internal_module] = STATE(1179),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2168),
    [sym_this] = ACTIONS(2170),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2170),
    [sym_false] = ACTIONS(2170),
    [sym_null] = ACTIONS(2170),
    [sym_undefined] = ACTIONS(2170),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [346] = {
    [sym_import] = STATE(1506),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1506),
    [sym_yield_expression] = STATE(1506),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1506),
    [sym_jsx_fragment] = STATE(1506),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1506),
    [sym_class] = STATE(1506),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1506),
    [sym_arrow_function] = STATE(1506),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1506),
    [sym_new_expression] = STATE(1506),
    [sym_await_expression] = STATE(1506),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1506),
    [sym_augmented_assignment_expression] = STATE(1506),
    [sym_ternary_expression] = STATE(1506),
    [sym_binary_expression] = STATE(1506),
    [sym_unary_expression] = STATE(1506),
    [sym_update_expression] = STATE(1506),
    [sym_string] = STATE(1506),
    [sym_template_string] = STATE(1506),
    [sym_regex] = STATE(1506),
    [sym_meta_property] = STATE(1506),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1506),
    [sym_as_expression] = STATE(1506),
    [sym_internal_module] = STATE(1506),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2172),
    [sym_this] = ACTIONS(2174),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2174),
    [sym_false] = ACTIONS(2174),
    [sym_null] = ACTIONS(2174),
    [sym_undefined] = ACTIONS(2174),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [347] = {
    [sym_import] = STATE(1329),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1329),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1329),
    [sym_jsx_fragment] = STATE(1329),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1329),
    [sym_class] = STATE(1329),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1329),
    [sym_arrow_function] = STATE(1329),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1329),
    [sym_new_expression] = STATE(1329),
    [sym_await_expression] = STATE(1329),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1329),
    [sym_augmented_assignment_expression] = STATE(1329),
    [sym_ternary_expression] = STATE(1329),
    [sym_binary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1329),
    [sym_update_expression] = STATE(1329),
    [sym_string] = STATE(1329),
    [sym_template_string] = STATE(1329),
    [sym_regex] = STATE(1329),
    [sym_meta_property] = STATE(1329),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1329),
    [sym_as_expression] = STATE(1329),
    [sym_internal_module] = STATE(1329),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2176),
    [sym_this] = ACTIONS(2178),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2178),
    [sym_false] = ACTIONS(2178),
    [sym_null] = ACTIONS(2178),
    [sym_undefined] = ACTIONS(2178),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [348] = {
    [sym_import] = STATE(1231),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1231),
    [sym_yield_expression] = STATE(1231),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1231),
    [sym_jsx_fragment] = STATE(1231),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1231),
    [sym_class] = STATE(1231),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1231),
    [sym_arrow_function] = STATE(1231),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1231),
    [sym_new_expression] = STATE(1231),
    [sym_await_expression] = STATE(1231),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1231),
    [sym_augmented_assignment_expression] = STATE(1231),
    [sym_ternary_expression] = STATE(1231),
    [sym_binary_expression] = STATE(1231),
    [sym_unary_expression] = STATE(1231),
    [sym_update_expression] = STATE(1231),
    [sym_string] = STATE(1231),
    [sym_template_string] = STATE(1231),
    [sym_regex] = STATE(1231),
    [sym_meta_property] = STATE(1231),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1231),
    [sym_as_expression] = STATE(1231),
    [sym_internal_module] = STATE(1231),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2180),
    [sym_this] = ACTIONS(2182),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2182),
    [sym_false] = ACTIONS(2182),
    [sym_null] = ACTIONS(2182),
    [sym_undefined] = ACTIONS(2182),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [349] = {
    [sym_import] = STATE(1068),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1068),
    [sym_yield_expression] = STATE(1068),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1068),
    [sym_jsx_fragment] = STATE(1068),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1068),
    [sym_class] = STATE(1068),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1068),
    [sym_arrow_function] = STATE(1068),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1068),
    [sym_new_expression] = STATE(1068),
    [sym_await_expression] = STATE(1068),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1068),
    [sym_augmented_assignment_expression] = STATE(1068),
    [sym_ternary_expression] = STATE(1068),
    [sym_binary_expression] = STATE(1068),
    [sym_unary_expression] = STATE(1068),
    [sym_update_expression] = STATE(1068),
    [sym_string] = STATE(1068),
    [sym_template_string] = STATE(1068),
    [sym_regex] = STATE(1068),
    [sym_meta_property] = STATE(1068),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1068),
    [sym_as_expression] = STATE(1068),
    [sym_internal_module] = STATE(1068),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2184),
    [sym_this] = ACTIONS(2186),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2186),
    [sym_false] = ACTIONS(2186),
    [sym_null] = ACTIONS(2186),
    [sym_undefined] = ACTIONS(2186),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [350] = {
    [sym_import] = STATE(1291),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1291),
    [sym_yield_expression] = STATE(1291),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1291),
    [sym_jsx_fragment] = STATE(1291),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1291),
    [sym_class] = STATE(1291),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1291),
    [sym_arrow_function] = STATE(1291),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1291),
    [sym_new_expression] = STATE(1291),
    [sym_await_expression] = STATE(1291),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1291),
    [sym_augmented_assignment_expression] = STATE(1291),
    [sym_ternary_expression] = STATE(1291),
    [sym_binary_expression] = STATE(1291),
    [sym_unary_expression] = STATE(1291),
    [sym_update_expression] = STATE(1291),
    [sym_string] = STATE(1291),
    [sym_template_string] = STATE(1291),
    [sym_regex] = STATE(1291),
    [sym_meta_property] = STATE(1291),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1291),
    [sym_as_expression] = STATE(1291),
    [sym_internal_module] = STATE(1291),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2188),
    [sym_this] = ACTIONS(2190),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2190),
    [sym_false] = ACTIONS(2190),
    [sym_null] = ACTIONS(2190),
    [sym_undefined] = ACTIONS(2190),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [351] = {
    [sym_import] = STATE(1123),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1123),
    [sym_yield_expression] = STATE(1123),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1123),
    [sym_jsx_fragment] = STATE(1123),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1123),
    [sym_class] = STATE(1123),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1123),
    [sym_arrow_function] = STATE(1123),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1123),
    [sym_new_expression] = STATE(1123),
    [sym_await_expression] = STATE(1123),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1123),
    [sym_augmented_assignment_expression] = STATE(1123),
    [sym_ternary_expression] = STATE(1123),
    [sym_binary_expression] = STATE(1123),
    [sym_unary_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_string] = STATE(1123),
    [sym_template_string] = STATE(1123),
    [sym_regex] = STATE(1123),
    [sym_meta_property] = STATE(1123),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1123),
    [sym_as_expression] = STATE(1123),
    [sym_internal_module] = STATE(1123),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2192),
    [sym_this] = ACTIONS(2194),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2194),
    [sym_false] = ACTIONS(2194),
    [sym_null] = ACTIONS(2194),
    [sym_undefined] = ACTIONS(2194),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [352] = {
    [sym_import] = STATE(1591),
    [sym_parenthesized_expression] = STATE(932),
    [sym__expression] = STATE(1591),
    [sym_yield_expression] = STATE(1591),
    [sym_object] = STATE(1731),
    [sym_array] = STATE(1729),
    [sym_jsx_element] = STATE(1591),
    [sym_jsx_fragment] = STATE(1591),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1591),
    [sym_class] = STATE(1591),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1591),
    [sym_arrow_function] = STATE(1591),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1591),
    [sym_new_expression] = STATE(1591),
    [sym_await_expression] = STATE(1591),
    [sym_member_expression] = STATE(932),
    [sym_subscript_expression] = STATE(932),
    [sym_assignment_expression] = STATE(1591),
    [sym_augmented_assignment_expression] = STATE(1591),
    [sym_ternary_expression] = STATE(1591),
    [sym_binary_expression] = STATE(1591),
    [sym_unary_expression] = STATE(1591),
    [sym_update_expression] = STATE(1591),
    [sym_string] = STATE(1591),
    [sym_template_string] = STATE(1591),
    [sym_regex] = STATE(1591),
    [sym_meta_property] = STATE(1591),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1591),
    [sym_as_expression] = STATE(1591),
    [sym_internal_module] = STATE(1591),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_export] = ACTIONS(1660),
    [anon_sym_namespace] = ACTIONS(1662),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(1660),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(1664),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(1666),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1417),
    [sym_this] = ACTIONS(1419),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1419),
    [sym_false] = ACTIONS(1419),
    [sym_null] = ACTIONS(1419),
    [sym_undefined] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1660),
    [anon_sym_get] = ACTIONS(1660),
    [anon_sym_set] = ACTIONS(1660),
    [anon_sym_declare] = ACTIONS(1660),
    [anon_sym_public] = ACTIONS(1660),
    [anon_sym_private] = ACTIONS(1660),
    [anon_sym_protected] = ACTIONS(1660),
    [anon_sym_module] = ACTIONS(1660),
    [anon_sym_any] = ACTIONS(1660),
    [anon_sym_number] = ACTIONS(1660),
    [anon_sym_boolean] = ACTIONS(1660),
    [anon_sym_string] = ACTIONS(1660),
    [anon_sym_symbol] = ACTIONS(1660),
    [sym_readonly] = ACTIONS(1660),
  },
  [353] = {
    [sym_import] = STATE(1182),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1182),
    [sym_yield_expression] = STATE(1182),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1182),
    [sym_jsx_fragment] = STATE(1182),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1182),
    [sym_class] = STATE(1182),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1182),
    [sym_arrow_function] = STATE(1182),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1182),
    [sym_new_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1182),
    [sym_augmented_assignment_expression] = STATE(1182),
    [sym_ternary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_update_expression] = STATE(1182),
    [sym_string] = STATE(1182),
    [sym_template_string] = STATE(1182),
    [sym_regex] = STATE(1182),
    [sym_meta_property] = STATE(1182),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1182),
    [sym_as_expression] = STATE(1182),
    [sym_internal_module] = STATE(1182),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [354] = {
    [sym_import] = STATE(1325),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1325),
    [sym_yield_expression] = STATE(1325),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1325),
    [sym_jsx_fragment] = STATE(1325),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1325),
    [sym_class] = STATE(1325),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1325),
    [sym_arrow_function] = STATE(1325),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1325),
    [sym_new_expression] = STATE(1325),
    [sym_await_expression] = STATE(1325),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1325),
    [sym_augmented_assignment_expression] = STATE(1325),
    [sym_ternary_expression] = STATE(1325),
    [sym_binary_expression] = STATE(1325),
    [sym_unary_expression] = STATE(1325),
    [sym_update_expression] = STATE(1325),
    [sym_string] = STATE(1325),
    [sym_template_string] = STATE(1325),
    [sym_regex] = STATE(1325),
    [sym_meta_property] = STATE(1325),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1325),
    [sym_as_expression] = STATE(1325),
    [sym_internal_module] = STATE(1325),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [355] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(786),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [356] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2206),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [357] = {
    [sym_import] = STATE(1504),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1504),
    [sym_yield_expression] = STATE(1504),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1504),
    [sym_jsx_fragment] = STATE(1504),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1504),
    [sym_class] = STATE(1504),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1504),
    [sym_arrow_function] = STATE(1504),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1504),
    [sym_new_expression] = STATE(1504),
    [sym_await_expression] = STATE(1504),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1504),
    [sym_augmented_assignment_expression] = STATE(1504),
    [sym_ternary_expression] = STATE(1504),
    [sym_binary_expression] = STATE(1504),
    [sym_unary_expression] = STATE(1504),
    [sym_update_expression] = STATE(1504),
    [sym_string] = STATE(1504),
    [sym_template_string] = STATE(1504),
    [sym_regex] = STATE(1504),
    [sym_meta_property] = STATE(1504),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1504),
    [sym_as_expression] = STATE(1504),
    [sym_internal_module] = STATE(1504),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2208),
    [sym_this] = ACTIONS(2210),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [sym_null] = ACTIONS(2210),
    [sym_undefined] = ACTIONS(2210),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [358] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2212),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [359] = {
    [sym_import] = STATE(1331),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1331),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1331),
    [sym_jsx_fragment] = STATE(1331),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1331),
    [sym_class] = STATE(1331),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1331),
    [sym_arrow_function] = STATE(1331),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1331),
    [sym_new_expression] = STATE(1331),
    [sym_await_expression] = STATE(1331),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1331),
    [sym_augmented_assignment_expression] = STATE(1331),
    [sym_ternary_expression] = STATE(1331),
    [sym_binary_expression] = STATE(1331),
    [sym_unary_expression] = STATE(1331),
    [sym_update_expression] = STATE(1331),
    [sym_string] = STATE(1331),
    [sym_template_string] = STATE(1331),
    [sym_regex] = STATE(1331),
    [sym_meta_property] = STATE(1331),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1331),
    [sym_as_expression] = STATE(1331),
    [sym_internal_module] = STATE(1331),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2214),
    [sym_this] = ACTIONS(2216),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2216),
    [sym_false] = ACTIONS(2216),
    [sym_null] = ACTIONS(2216),
    [sym_undefined] = ACTIONS(2216),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [360] = {
    [sym_import] = STATE(1201),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1201),
    [sym_yield_expression] = STATE(1201),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1201),
    [sym_jsx_fragment] = STATE(1201),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1201),
    [sym_class] = STATE(1201),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1201),
    [sym_arrow_function] = STATE(1201),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1201),
    [sym_new_expression] = STATE(1201),
    [sym_await_expression] = STATE(1201),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1201),
    [sym_augmented_assignment_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(1201),
    [sym_binary_expression] = STATE(1201),
    [sym_unary_expression] = STATE(1201),
    [sym_update_expression] = STATE(1201),
    [sym_string] = STATE(1201),
    [sym_template_string] = STATE(1201),
    [sym_regex] = STATE(1201),
    [sym_meta_property] = STATE(1201),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1201),
    [sym_as_expression] = STATE(1201),
    [sym_internal_module] = STATE(1201),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2218),
    [sym_this] = ACTIONS(2220),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [361] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(748),
    [sym_this] = ACTIONS(750),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_null] = ACTIONS(750),
    [sym_undefined] = ACTIONS(750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [362] = {
    [sym_import] = STATE(1306),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1306),
    [sym_yield_expression] = STATE(1306),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1306),
    [sym_jsx_fragment] = STATE(1306),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1306),
    [sym_class] = STATE(1306),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1306),
    [sym_arrow_function] = STATE(1306),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1306),
    [sym_new_expression] = STATE(1306),
    [sym_await_expression] = STATE(1306),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1306),
    [sym_augmented_assignment_expression] = STATE(1306),
    [sym_ternary_expression] = STATE(1306),
    [sym_binary_expression] = STATE(1306),
    [sym_unary_expression] = STATE(1306),
    [sym_update_expression] = STATE(1306),
    [sym_string] = STATE(1306),
    [sym_template_string] = STATE(1306),
    [sym_regex] = STATE(1306),
    [sym_meta_property] = STATE(1306),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1306),
    [sym_as_expression] = STATE(1306),
    [sym_internal_module] = STATE(1306),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2222),
    [sym_this] = ACTIONS(2224),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_undefined] = ACTIONS(2224),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [363] = {
    [sym_import] = STATE(1000),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1000),
    [sym_yield_expression] = STATE(1000),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1000),
    [sym_jsx_fragment] = STATE(1000),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1000),
    [sym_class] = STATE(1000),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1000),
    [sym_arrow_function] = STATE(1000),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1000),
    [sym_new_expression] = STATE(1000),
    [sym_await_expression] = STATE(1000),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1000),
    [sym_augmented_assignment_expression] = STATE(1000),
    [sym_ternary_expression] = STATE(1000),
    [sym_binary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym_update_expression] = STATE(1000),
    [sym_string] = STATE(1000),
    [sym_template_string] = STATE(1000),
    [sym_regex] = STATE(1000),
    [sym_meta_property] = STATE(1000),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1000),
    [sym_as_expression] = STATE(1000),
    [sym_internal_module] = STATE(1000),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2226),
    [sym_this] = ACTIONS(2228),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_undefined] = ACTIONS(2228),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [364] = {
    [sym_import] = STATE(1009),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1009),
    [sym_yield_expression] = STATE(1009),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1009),
    [sym_jsx_fragment] = STATE(1009),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1009),
    [sym_class] = STATE(1009),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1009),
    [sym_arrow_function] = STATE(1009),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1009),
    [sym_new_expression] = STATE(1009),
    [sym_await_expression] = STATE(1009),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1009),
    [sym_augmented_assignment_expression] = STATE(1009),
    [sym_ternary_expression] = STATE(1009),
    [sym_binary_expression] = STATE(1009),
    [sym_unary_expression] = STATE(1009),
    [sym_update_expression] = STATE(1009),
    [sym_string] = STATE(1009),
    [sym_template_string] = STATE(1009),
    [sym_regex] = STATE(1009),
    [sym_meta_property] = STATE(1009),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1009),
    [sym_as_expression] = STATE(1009),
    [sym_internal_module] = STATE(1009),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2230),
    [sym_this] = ACTIONS(2232),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [sym_null] = ACTIONS(2232),
    [sym_undefined] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [365] = {
    [sym_import] = STATE(1098),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1098),
    [sym_yield_expression] = STATE(1098),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1098),
    [sym_jsx_fragment] = STATE(1098),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1098),
    [sym_class] = STATE(1098),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1098),
    [sym_arrow_function] = STATE(1098),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1098),
    [sym_new_expression] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1098),
    [sym_augmented_assignment_expression] = STATE(1098),
    [sym_ternary_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_unary_expression] = STATE(1098),
    [sym_update_expression] = STATE(1098),
    [sym_string] = STATE(1098),
    [sym_template_string] = STATE(1098),
    [sym_regex] = STATE(1098),
    [sym_meta_property] = STATE(1098),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1098),
    [sym_as_expression] = STATE(1098),
    [sym_internal_module] = STATE(1098),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2234),
    [sym_this] = ACTIONS(1906),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [366] = {
    [sym_import] = STATE(1096),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1096),
    [sym_yield_expression] = STATE(1096),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1096),
    [sym_jsx_fragment] = STATE(1096),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1096),
    [sym_class] = STATE(1096),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1096),
    [sym_arrow_function] = STATE(1096),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1096),
    [sym_new_expression] = STATE(1096),
    [sym_await_expression] = STATE(1096),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1096),
    [sym_augmented_assignment_expression] = STATE(1096),
    [sym_ternary_expression] = STATE(1096),
    [sym_binary_expression] = STATE(1096),
    [sym_unary_expression] = STATE(1096),
    [sym_update_expression] = STATE(1096),
    [sym_string] = STATE(1096),
    [sym_template_string] = STATE(1096),
    [sym_regex] = STATE(1096),
    [sym_meta_property] = STATE(1096),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1096),
    [sym_as_expression] = STATE(1096),
    [sym_internal_module] = STATE(1096),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2236),
    [sym_this] = ACTIONS(2238),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2238),
    [sym_false] = ACTIONS(2238),
    [sym_null] = ACTIONS(2238),
    [sym_undefined] = ACTIONS(2238),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [367] = {
    [sym_import] = STATE(1250),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1250),
    [sym_yield_expression] = STATE(1250),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1250),
    [sym_jsx_fragment] = STATE(1250),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1250),
    [sym_class] = STATE(1250),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1250),
    [sym_arrow_function] = STATE(1250),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1250),
    [sym_new_expression] = STATE(1250),
    [sym_await_expression] = STATE(1250),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1250),
    [sym_augmented_assignment_expression] = STATE(1250),
    [sym_ternary_expression] = STATE(1250),
    [sym_binary_expression] = STATE(1250),
    [sym_unary_expression] = STATE(1250),
    [sym_update_expression] = STATE(1250),
    [sym_string] = STATE(1250),
    [sym_template_string] = STATE(1250),
    [sym_regex] = STATE(1250),
    [sym_meta_property] = STATE(1250),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1250),
    [sym_as_expression] = STATE(1250),
    [sym_internal_module] = STATE(1250),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2240),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [368] = {
    [sym_import] = STATE(1183),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1183),
    [sym_yield_expression] = STATE(1183),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1183),
    [sym_jsx_fragment] = STATE(1183),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1183),
    [sym_class] = STATE(1183),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1183),
    [sym_arrow_function] = STATE(1183),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1183),
    [sym_new_expression] = STATE(1183),
    [sym_await_expression] = STATE(1183),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1183),
    [sym_augmented_assignment_expression] = STATE(1183),
    [sym_ternary_expression] = STATE(1183),
    [sym_binary_expression] = STATE(1183),
    [sym_unary_expression] = STATE(1183),
    [sym_update_expression] = STATE(1183),
    [sym_string] = STATE(1183),
    [sym_template_string] = STATE(1183),
    [sym_regex] = STATE(1183),
    [sym_meta_property] = STATE(1183),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1183),
    [sym_as_expression] = STATE(1183),
    [sym_internal_module] = STATE(1183),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2244),
    [sym_this] = ACTIONS(2246),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2246),
    [sym_false] = ACTIONS(2246),
    [sym_null] = ACTIONS(2246),
    [sym_undefined] = ACTIONS(2246),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [369] = {
    [sym_import] = STATE(1061),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1061),
    [sym_yield_expression] = STATE(1061),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1061),
    [sym_jsx_fragment] = STATE(1061),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1061),
    [sym_class] = STATE(1061),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1061),
    [sym_arrow_function] = STATE(1061),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1061),
    [sym_new_expression] = STATE(1061),
    [sym_await_expression] = STATE(1061),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1061),
    [sym_augmented_assignment_expression] = STATE(1061),
    [sym_ternary_expression] = STATE(1061),
    [sym_binary_expression] = STATE(1061),
    [sym_unary_expression] = STATE(1061),
    [sym_update_expression] = STATE(1061),
    [sym_string] = STATE(1061),
    [sym_template_string] = STATE(1061),
    [sym_regex] = STATE(1061),
    [sym_meta_property] = STATE(1061),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1061),
    [sym_as_expression] = STATE(1061),
    [sym_internal_module] = STATE(1061),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(2248),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [370] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [371] = {
    [sym_import] = STATE(1359),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1359),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1359),
    [sym_jsx_fragment] = STATE(1359),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1359),
    [sym_class] = STATE(1359),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1359),
    [sym_arrow_function] = STATE(1359),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1359),
    [sym_new_expression] = STATE(1359),
    [sym_await_expression] = STATE(1359),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1359),
    [sym_augmented_assignment_expression] = STATE(1359),
    [sym_ternary_expression] = STATE(1359),
    [sym_binary_expression] = STATE(1359),
    [sym_unary_expression] = STATE(1359),
    [sym_update_expression] = STATE(1359),
    [sym_string] = STATE(1359),
    [sym_template_string] = STATE(1359),
    [sym_regex] = STATE(1359),
    [sym_meta_property] = STATE(1359),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1359),
    [sym_as_expression] = STATE(1359),
    [sym_internal_module] = STATE(1359),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [372] = {
    [sym_import] = STATE(1274),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1274),
    [sym_yield_expression] = STATE(1274),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1274),
    [sym_jsx_fragment] = STATE(1274),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1274),
    [sym_class] = STATE(1274),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1274),
    [sym_arrow_function] = STATE(1274),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1274),
    [sym_new_expression] = STATE(1274),
    [sym_await_expression] = STATE(1274),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1274),
    [sym_augmented_assignment_expression] = STATE(1274),
    [sym_ternary_expression] = STATE(1274),
    [sym_binary_expression] = STATE(1274),
    [sym_unary_expression] = STATE(1274),
    [sym_update_expression] = STATE(1274),
    [sym_string] = STATE(1274),
    [sym_template_string] = STATE(1274),
    [sym_regex] = STATE(1274),
    [sym_meta_property] = STATE(1274),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1274),
    [sym_as_expression] = STATE(1274),
    [sym_internal_module] = STATE(1274),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2258),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [373] = {
    [sym_import] = STATE(1272),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1272),
    [sym_yield_expression] = STATE(1272),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1272),
    [sym_jsx_fragment] = STATE(1272),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1272),
    [sym_class] = STATE(1272),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1272),
    [sym_arrow_function] = STATE(1272),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1272),
    [sym_new_expression] = STATE(1272),
    [sym_await_expression] = STATE(1272),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1272),
    [sym_augmented_assignment_expression] = STATE(1272),
    [sym_ternary_expression] = STATE(1272),
    [sym_binary_expression] = STATE(1272),
    [sym_unary_expression] = STATE(1272),
    [sym_update_expression] = STATE(1272),
    [sym_string] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_regex] = STATE(1272),
    [sym_meta_property] = STATE(1272),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1272),
    [sym_as_expression] = STATE(1272),
    [sym_internal_module] = STATE(1272),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1936),
    [sym_this] = ACTIONS(2262),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [sym_null] = ACTIONS(2262),
    [sym_undefined] = ACTIONS(2262),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [374] = {
    [sym_import] = STATE(1095),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1095),
    [sym_yield_expression] = STATE(1095),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1095),
    [sym_jsx_fragment] = STATE(1095),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1095),
    [sym_class] = STATE(1095),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1095),
    [sym_arrow_function] = STATE(1095),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1095),
    [sym_new_expression] = STATE(1095),
    [sym_await_expression] = STATE(1095),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1095),
    [sym_augmented_assignment_expression] = STATE(1095),
    [sym_ternary_expression] = STATE(1095),
    [sym_binary_expression] = STATE(1095),
    [sym_unary_expression] = STATE(1095),
    [sym_update_expression] = STATE(1095),
    [sym_string] = STATE(1095),
    [sym_template_string] = STATE(1095),
    [sym_regex] = STATE(1095),
    [sym_meta_property] = STATE(1095),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1095),
    [sym_as_expression] = STATE(1095),
    [sym_internal_module] = STATE(1095),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2140),
    [sym_this] = ACTIONS(2142),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_null] = ACTIONS(2142),
    [sym_undefined] = ACTIONS(2142),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [375] = {
    [sym_import] = STATE(1268),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1268),
    [sym_yield_expression] = STATE(1268),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1268),
    [sym_jsx_fragment] = STATE(1268),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1268),
    [sym_class] = STATE(1268),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1268),
    [sym_arrow_function] = STATE(1268),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1268),
    [sym_new_expression] = STATE(1268),
    [sym_await_expression] = STATE(1268),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1268),
    [sym_augmented_assignment_expression] = STATE(1268),
    [sym_ternary_expression] = STATE(1268),
    [sym_binary_expression] = STATE(1268),
    [sym_unary_expression] = STATE(1268),
    [sym_update_expression] = STATE(1268),
    [sym_string] = STATE(1268),
    [sym_template_string] = STATE(1268),
    [sym_regex] = STATE(1268),
    [sym_meta_property] = STATE(1268),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1268),
    [sym_as_expression] = STATE(1268),
    [sym_internal_module] = STATE(1268),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2264),
    [sym_this] = ACTIONS(2266),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2266),
    [sym_false] = ACTIONS(2266),
    [sym_null] = ACTIONS(2266),
    [sym_undefined] = ACTIONS(2266),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [376] = {
    [sym_import] = STATE(1311),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1311),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1311),
    [sym_jsx_fragment] = STATE(1311),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1311),
    [sym_class] = STATE(1311),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1311),
    [sym_arrow_function] = STATE(1311),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1311),
    [sym_new_expression] = STATE(1311),
    [sym_await_expression] = STATE(1311),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1311),
    [sym_augmented_assignment_expression] = STATE(1311),
    [sym_ternary_expression] = STATE(1311),
    [sym_binary_expression] = STATE(1311),
    [sym_unary_expression] = STATE(1311),
    [sym_update_expression] = STATE(1311),
    [sym_string] = STATE(1311),
    [sym_template_string] = STATE(1311),
    [sym_regex] = STATE(1311),
    [sym_meta_property] = STATE(1311),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1311),
    [sym_as_expression] = STATE(1311),
    [sym_internal_module] = STATE(1311),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2268),
    [sym_this] = ACTIONS(1960),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1960),
    [sym_false] = ACTIONS(1960),
    [sym_null] = ACTIONS(1960),
    [sym_undefined] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [377] = {
    [sym_import] = STATE(1308),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1308),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1308),
    [sym_jsx_fragment] = STATE(1308),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1308),
    [sym_class] = STATE(1308),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1308),
    [sym_arrow_function] = STATE(1308),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1308),
    [sym_new_expression] = STATE(1308),
    [sym_await_expression] = STATE(1308),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1308),
    [sym_augmented_assignment_expression] = STATE(1308),
    [sym_ternary_expression] = STATE(1308),
    [sym_binary_expression] = STATE(1308),
    [sym_unary_expression] = STATE(1308),
    [sym_update_expression] = STATE(1308),
    [sym_string] = STATE(1308),
    [sym_template_string] = STATE(1308),
    [sym_regex] = STATE(1308),
    [sym_meta_property] = STATE(1308),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1308),
    [sym_as_expression] = STATE(1308),
    [sym_internal_module] = STATE(1308),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2270),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [378] = {
    [sym_import] = STATE(1077),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1077),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1077),
    [sym_jsx_fragment] = STATE(1077),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1077),
    [sym_class] = STATE(1077),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1077),
    [sym_arrow_function] = STATE(1077),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1077),
    [sym_new_expression] = STATE(1077),
    [sym_await_expression] = STATE(1077),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1077),
    [sym_augmented_assignment_expression] = STATE(1077),
    [sym_ternary_expression] = STATE(1077),
    [sym_binary_expression] = STATE(1077),
    [sym_unary_expression] = STATE(1077),
    [sym_update_expression] = STATE(1077),
    [sym_string] = STATE(1077),
    [sym_template_string] = STATE(1077),
    [sym_regex] = STATE(1077),
    [sym_meta_property] = STATE(1077),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1077),
    [sym_as_expression] = STATE(1077),
    [sym_internal_module] = STATE(1077),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(2028),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1856),
    [sym_this] = ACTIONS(1858),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1858),
    [sym_false] = ACTIONS(1858),
    [sym_null] = ACTIONS(1858),
    [sym_undefined] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [379] = {
    [sym_import] = STATE(1226),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1226),
    [sym_yield_expression] = STATE(1226),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1226),
    [sym_jsx_fragment] = STATE(1226),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1226),
    [sym_class] = STATE(1226),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1226),
    [sym_arrow_function] = STATE(1226),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1226),
    [sym_new_expression] = STATE(1226),
    [sym_await_expression] = STATE(1226),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1226),
    [sym_augmented_assignment_expression] = STATE(1226),
    [sym_ternary_expression] = STATE(1226),
    [sym_binary_expression] = STATE(1226),
    [sym_unary_expression] = STATE(1226),
    [sym_update_expression] = STATE(1226),
    [sym_string] = STATE(1226),
    [sym_template_string] = STATE(1226),
    [sym_regex] = STATE(1226),
    [sym_meta_property] = STATE(1226),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1226),
    [sym_as_expression] = STATE(1226),
    [sym_internal_module] = STATE(1226),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(2276),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [sym_null] = ACTIONS(2276),
    [sym_undefined] = ACTIONS(2276),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [380] = {
    [sym_import] = STATE(1261),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1261),
    [sym_yield_expression] = STATE(1261),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1261),
    [sym_jsx_fragment] = STATE(1261),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1261),
    [sym_class] = STATE(1261),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1261),
    [sym_arrow_function] = STATE(1261),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1261),
    [sym_new_expression] = STATE(1261),
    [sym_await_expression] = STATE(1261),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1261),
    [sym_ternary_expression] = STATE(1261),
    [sym_binary_expression] = STATE(1261),
    [sym_unary_expression] = STATE(1261),
    [sym_update_expression] = STATE(1261),
    [sym_string] = STATE(1261),
    [sym_template_string] = STATE(1261),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1261),
    [sym_as_expression] = STATE(1261),
    [sym_internal_module] = STATE(1261),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [381] = {
    [sym_import] = STATE(1297),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1297),
    [sym_jsx_fragment] = STATE(1297),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1297),
    [sym_class] = STATE(1297),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1297),
    [sym_arrow_function] = STATE(1297),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1297),
    [sym_new_expression] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_string] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1936),
    [sym_this] = ACTIONS(1930),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1930),
    [sym_false] = ACTIONS(1930),
    [sym_null] = ACTIONS(1930),
    [sym_undefined] = ACTIONS(1930),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [382] = {
    [sym_import] = STATE(1194),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1194),
    [sym_yield_expression] = STATE(1194),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1194),
    [sym_jsx_fragment] = STATE(1194),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1194),
    [sym_class] = STATE(1194),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1194),
    [sym_arrow_function] = STATE(1194),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1194),
    [sym_new_expression] = STATE(1194),
    [sym_await_expression] = STATE(1194),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1194),
    [sym_augmented_assignment_expression] = STATE(1194),
    [sym_ternary_expression] = STATE(1194),
    [sym_binary_expression] = STATE(1194),
    [sym_unary_expression] = STATE(1194),
    [sym_update_expression] = STATE(1194),
    [sym_string] = STATE(1194),
    [sym_template_string] = STATE(1194),
    [sym_regex] = STATE(1194),
    [sym_meta_property] = STATE(1194),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1194),
    [sym_as_expression] = STATE(1194),
    [sym_internal_module] = STATE(1194),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2282),
    [sym_this] = ACTIONS(2284),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [sym_null] = ACTIONS(2284),
    [sym_undefined] = ACTIONS(2284),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [383] = {
    [sym_import] = STATE(1316),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1316),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1316),
    [sym_jsx_fragment] = STATE(1316),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1316),
    [sym_class] = STATE(1316),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1316),
    [sym_arrow_function] = STATE(1316),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1316),
    [sym_new_expression] = STATE(1316),
    [sym_await_expression] = STATE(1316),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1316),
    [sym_augmented_assignment_expression] = STATE(1316),
    [sym_ternary_expression] = STATE(1316),
    [sym_binary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1316),
    [sym_update_expression] = STATE(1316),
    [sym_string] = STATE(1316),
    [sym_template_string] = STATE(1316),
    [sym_regex] = STATE(1316),
    [sym_meta_property] = STATE(1316),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1316),
    [sym_as_expression] = STATE(1316),
    [sym_internal_module] = STATE(1316),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2286),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [384] = {
    [sym_import] = STATE(1061),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1061),
    [sym_yield_expression] = STATE(1061),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1061),
    [sym_jsx_fragment] = STATE(1061),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1061),
    [sym_class] = STATE(1061),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1061),
    [sym_arrow_function] = STATE(1061),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1061),
    [sym_new_expression] = STATE(1061),
    [sym_await_expression] = STATE(1061),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1061),
    [sym_augmented_assignment_expression] = STATE(1061),
    [sym_ternary_expression] = STATE(1061),
    [sym_binary_expression] = STATE(1061),
    [sym_unary_expression] = STATE(1061),
    [sym_update_expression] = STATE(1061),
    [sym_string] = STATE(1061),
    [sym_template_string] = STATE(1061),
    [sym_regex] = STATE(1061),
    [sym_meta_property] = STATE(1061),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1061),
    [sym_as_expression] = STATE(1061),
    [sym_internal_module] = STATE(1061),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [385] = {
    [sym_import] = STATE(1014),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1014),
    [sym_yield_expression] = STATE(1014),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1014),
    [sym_jsx_fragment] = STATE(1014),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1014),
    [sym_class] = STATE(1014),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1014),
    [sym_arrow_function] = STATE(1014),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1014),
    [sym_new_expression] = STATE(1014),
    [sym_await_expression] = STATE(1014),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1014),
    [sym_augmented_assignment_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym_update_expression] = STATE(1014),
    [sym_string] = STATE(1014),
    [sym_template_string] = STATE(1014),
    [sym_regex] = STATE(1014),
    [sym_meta_property] = STATE(1014),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1014),
    [sym_as_expression] = STATE(1014),
    [sym_internal_module] = STATE(1014),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2290),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [386] = {
    [sym_import] = STATE(1282),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1282),
    [sym_yield_expression] = STATE(1282),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1282),
    [sym_jsx_fragment] = STATE(1282),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1282),
    [sym_class] = STATE(1282),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1282),
    [sym_arrow_function] = STATE(1282),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1282),
    [sym_new_expression] = STATE(1282),
    [sym_await_expression] = STATE(1282),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1282),
    [sym_augmented_assignment_expression] = STATE(1282),
    [sym_ternary_expression] = STATE(1282),
    [sym_binary_expression] = STATE(1282),
    [sym_unary_expression] = STATE(1282),
    [sym_update_expression] = STATE(1282),
    [sym_string] = STATE(1282),
    [sym_template_string] = STATE(1282),
    [sym_regex] = STATE(1282),
    [sym_meta_property] = STATE(1282),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1282),
    [sym_as_expression] = STATE(1282),
    [sym_internal_module] = STATE(1282),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(561),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_null] = ACTIONS(563),
    [sym_undefined] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [387] = {
    [sym_import] = STATE(1305),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1305),
    [sym_yield_expression] = STATE(1305),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1305),
    [sym_jsx_fragment] = STATE(1305),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1305),
    [sym_class] = STATE(1305),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1305),
    [sym_arrow_function] = STATE(1305),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1305),
    [sym_new_expression] = STATE(1305),
    [sym_await_expression] = STATE(1305),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1305),
    [sym_augmented_assignment_expression] = STATE(1305),
    [sym_ternary_expression] = STATE(1305),
    [sym_binary_expression] = STATE(1305),
    [sym_unary_expression] = STATE(1305),
    [sym_update_expression] = STATE(1305),
    [sym_string] = STATE(1305),
    [sym_template_string] = STATE(1305),
    [sym_regex] = STATE(1305),
    [sym_meta_property] = STATE(1305),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1305),
    [sym_as_expression] = STATE(1305),
    [sym_internal_module] = STATE(1305),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2294),
    [sym_this] = ACTIONS(2296),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2296),
    [sym_false] = ACTIONS(2296),
    [sym_null] = ACTIONS(2296),
    [sym_undefined] = ACTIONS(2296),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [388] = {
    [sym_import] = STATE(1277),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1277),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1277),
    [sym_jsx_fragment] = STATE(1277),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1277),
    [sym_class] = STATE(1277),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1277),
    [sym_arrow_function] = STATE(1277),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1277),
    [sym_new_expression] = STATE(1277),
    [sym_await_expression] = STATE(1277),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1277),
    [sym_augmented_assignment_expression] = STATE(1277),
    [sym_ternary_expression] = STATE(1277),
    [sym_binary_expression] = STATE(1277),
    [sym_unary_expression] = STATE(1277),
    [sym_update_expression] = STATE(1277),
    [sym_string] = STATE(1277),
    [sym_template_string] = STATE(1277),
    [sym_regex] = STATE(1277),
    [sym_meta_property] = STATE(1277),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1277),
    [sym_as_expression] = STATE(1277),
    [sym_internal_module] = STATE(1277),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2298),
    [sym_this] = ACTIONS(2300),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2300),
    [sym_false] = ACTIONS(2300),
    [sym_null] = ACTIONS(2300),
    [sym_undefined] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [389] = {
    [sym_import] = STATE(1259),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1259),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1259),
    [sym_jsx_fragment] = STATE(1259),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1259),
    [sym_class] = STATE(1259),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1259),
    [sym_arrow_function] = STATE(1259),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1259),
    [sym_new_expression] = STATE(1259),
    [sym_await_expression] = STATE(1259),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1259),
    [sym_augmented_assignment_expression] = STATE(1259),
    [sym_ternary_expression] = STATE(1259),
    [sym_binary_expression] = STATE(1259),
    [sym_unary_expression] = STATE(1259),
    [sym_update_expression] = STATE(1259),
    [sym_string] = STATE(1259),
    [sym_template_string] = STATE(1259),
    [sym_regex] = STATE(1259),
    [sym_meta_property] = STATE(1259),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1259),
    [sym_as_expression] = STATE(1259),
    [sym_internal_module] = STATE(1259),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2302),
    [sym_this] = ACTIONS(2304),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2304),
    [sym_false] = ACTIONS(2304),
    [sym_null] = ACTIONS(2304),
    [sym_undefined] = ACTIONS(2304),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [390] = {
    [sym_import] = STATE(1258),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1258),
    [sym_yield_expression] = STATE(1258),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1258),
    [sym_jsx_fragment] = STATE(1258),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1258),
    [sym_class] = STATE(1258),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1258),
    [sym_arrow_function] = STATE(1258),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1258),
    [sym_new_expression] = STATE(1258),
    [sym_await_expression] = STATE(1258),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1258),
    [sym_augmented_assignment_expression] = STATE(1258),
    [sym_ternary_expression] = STATE(1258),
    [sym_binary_expression] = STATE(1258),
    [sym_unary_expression] = STATE(1258),
    [sym_update_expression] = STATE(1258),
    [sym_string] = STATE(1258),
    [sym_template_string] = STATE(1258),
    [sym_regex] = STATE(1258),
    [sym_meta_property] = STATE(1258),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1258),
    [sym_as_expression] = STATE(1258),
    [sym_internal_module] = STATE(1258),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2306),
    [sym_this] = ACTIONS(1017),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(1017),
    [sym_false] = ACTIONS(1017),
    [sym_null] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [391] = {
    [sym_import] = STATE(1190),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1190),
    [sym_yield_expression] = STATE(1190),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1190),
    [sym_jsx_fragment] = STATE(1190),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1190),
    [sym_class] = STATE(1190),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1190),
    [sym_arrow_function] = STATE(1190),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1190),
    [sym_new_expression] = STATE(1190),
    [sym_await_expression] = STATE(1190),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1190),
    [sym_augmented_assignment_expression] = STATE(1190),
    [sym_ternary_expression] = STATE(1190),
    [sym_binary_expression] = STATE(1190),
    [sym_unary_expression] = STATE(1190),
    [sym_update_expression] = STATE(1190),
    [sym_string] = STATE(1190),
    [sym_template_string] = STATE(1190),
    [sym_regex] = STATE(1190),
    [sym_meta_property] = STATE(1190),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1190),
    [sym_as_expression] = STATE(1190),
    [sym_internal_module] = STATE(1190),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2308),
    [sym_this] = ACTIONS(2310),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [sym_null] = ACTIONS(2310),
    [sym_undefined] = ACTIONS(2310),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [392] = {
    [sym_import] = STATE(1327),
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_object] = STATE(1707),
    [sym_array] = STATE(1709),
    [sym_jsx_element] = STATE(1327),
    [sym_jsx_fragment] = STATE(1327),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1327),
    [sym_class] = STATE(1327),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1327),
    [sym_arrow_function] = STATE(1327),
    [sym__call_signature] = STATE(2975),
    [sym_call_expression] = STATE(1327),
    [sym_new_expression] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(922),
    [sym_subscript_expression] = STATE(922),
    [sym_assignment_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_string] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_meta_property] = STATE(1327),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(662),
    [anon_sym_export] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_typeof] = ACTIONS(670),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(672),
    [anon_sym_yield] = ACTIONS(674),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(678),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_BANG] = ACTIONS(686),
    [anon_sym_TILDE] = ACTIONS(686),
    [anon_sym_void] = ACTIONS(688),
    [anon_sym_delete] = ACTIONS(670),
    [anon_sym_PLUS_PLUS] = ACTIONS(690),
    [anon_sym_DASH_DASH] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2312),
    [sym_this] = ACTIONS(2314),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [sym_null] = ACTIONS(2314),
    [sym_undefined] = ACTIONS(2314),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_get] = ACTIONS(664),
    [anon_sym_set] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_module] = ACTIONS(664),
    [anon_sym_any] = ACTIONS(664),
    [anon_sym_number] = ACTIONS(664),
    [anon_sym_boolean] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_symbol] = ACTIONS(664),
    [sym_readonly] = ACTIONS(664),
  },
  [393] = {
    [sym_import] = STATE(1252),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1252),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1252),
    [sym_jsx_fragment] = STATE(1252),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1252),
    [sym_class] = STATE(1252),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1252),
    [sym_arrow_function] = STATE(1252),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1252),
    [sym_new_expression] = STATE(1252),
    [sym_await_expression] = STATE(1252),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1252),
    [sym_augmented_assignment_expression] = STATE(1252),
    [sym_ternary_expression] = STATE(1252),
    [sym_binary_expression] = STATE(1252),
    [sym_unary_expression] = STATE(1252),
    [sym_update_expression] = STATE(1252),
    [sym_string] = STATE(1252),
    [sym_template_string] = STATE(1252),
    [sym_regex] = STATE(1252),
    [sym_meta_property] = STATE(1252),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1252),
    [sym_as_expression] = STATE(1252),
    [sym_internal_module] = STATE(1252),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2316),
    [sym_this] = ACTIONS(2318),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_undefined] = ACTIONS(2318),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [394] = {
    [sym_import] = STATE(1418),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1418),
    [sym_yield_expression] = STATE(1418),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1418),
    [sym_jsx_fragment] = STATE(1418),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1418),
    [sym_class] = STATE(1418),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1418),
    [sym_arrow_function] = STATE(1418),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1418),
    [sym_new_expression] = STATE(1418),
    [sym_await_expression] = STATE(1418),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1418),
    [sym_augmented_assignment_expression] = STATE(1418),
    [sym_ternary_expression] = STATE(1418),
    [sym_binary_expression] = STATE(1418),
    [sym_unary_expression] = STATE(1418),
    [sym_update_expression] = STATE(1418),
    [sym_string] = STATE(1418),
    [sym_template_string] = STATE(1418),
    [sym_regex] = STATE(1418),
    [sym_meta_property] = STATE(1418),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1418),
    [sym_as_expression] = STATE(1418),
    [sym_internal_module] = STATE(1418),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2320),
    [sym_this] = ACTIONS(2322),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [sym_null] = ACTIONS(2322),
    [sym_undefined] = ACTIONS(2322),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [395] = {
    [sym_import] = STATE(1251),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1251),
    [sym_yield_expression] = STATE(1251),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1251),
    [sym_jsx_fragment] = STATE(1251),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1251),
    [sym_class] = STATE(1251),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1251),
    [sym_arrow_function] = STATE(1251),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1251),
    [sym_new_expression] = STATE(1251),
    [sym_await_expression] = STATE(1251),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1251),
    [sym_augmented_assignment_expression] = STATE(1251),
    [sym_ternary_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_unary_expression] = STATE(1251),
    [sym_update_expression] = STATE(1251),
    [sym_string] = STATE(1251),
    [sym_template_string] = STATE(1251),
    [sym_regex] = STATE(1251),
    [sym_meta_property] = STATE(1251),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1251),
    [sym_as_expression] = STATE(1251),
    [sym_internal_module] = STATE(1251),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2324),
    [sym_this] = ACTIONS(2326),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [sym_null] = ACTIONS(2326),
    [sym_undefined] = ACTIONS(2326),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [396] = {
    [sym_import] = STATE(957),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(957),
    [sym_jsx_fragment] = STATE(957),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(957),
    [sym_class] = STATE(957),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(957),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(1916),
    [sym_this] = ACTIONS(1918),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [sym_null] = ACTIONS(1918),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [397] = {
    [sym_import] = STATE(1271),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1271),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1271),
    [sym_jsx_fragment] = STATE(1271),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1271),
    [sym_class] = STATE(1271),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1271),
    [sym_arrow_function] = STATE(1271),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_ternary_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_update_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_regex] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2328),
    [sym_this] = ACTIONS(2330),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [sym_null] = ACTIONS(2330),
    [sym_undefined] = ACTIONS(2330),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [398] = {
    [sym_import] = STATE(1272),
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(1272),
    [sym_yield_expression] = STATE(1272),
    [sym_object] = STATE(1551),
    [sym_array] = STATE(1552),
    [sym_jsx_element] = STATE(1272),
    [sym_jsx_fragment] = STATE(1272),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1272),
    [sym_class] = STATE(1272),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1272),
    [sym_arrow_function] = STATE(1272),
    [sym__call_signature] = STATE(3030),
    [sym_call_expression] = STATE(1272),
    [sym_new_expression] = STATE(1272),
    [sym_await_expression] = STATE(1272),
    [sym_member_expression] = STATE(891),
    [sym_subscript_expression] = STATE(891),
    [sym_assignment_expression] = STATE(1272),
    [sym_augmented_assignment_expression] = STATE(1272),
    [sym_ternary_expression] = STATE(1272),
    [sym_binary_expression] = STATE(1272),
    [sym_unary_expression] = STATE(1272),
    [sym_update_expression] = STATE(1272),
    [sym_string] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_regex] = STATE(1272),
    [sym_meta_property] = STATE(1272),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1272),
    [sym_as_expression] = STATE(1272),
    [sym_internal_module] = STATE(1272),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_namespace] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(519),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(537),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(543),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_void] = ACTIONS(555),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2332),
    [sym_this] = ACTIONS(2262),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [sym_null] = ACTIONS(2262),
    [sym_undefined] = ACTIONS(2262),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
    [anon_sym_declare] = ACTIONS(519),
    [anon_sym_public] = ACTIONS(519),
    [anon_sym_private] = ACTIONS(519),
    [anon_sym_protected] = ACTIONS(519),
    [anon_sym_module] = ACTIONS(519),
    [anon_sym_any] = ACTIONS(519),
    [anon_sym_number] = ACTIONS(519),
    [anon_sym_boolean] = ACTIONS(519),
    [anon_sym_string] = ACTIONS(519),
    [anon_sym_symbol] = ACTIONS(519),
    [sym_readonly] = ACTIONS(519),
  },
  [399] = {
    [sym_import] = STATE(1238),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1238),
    [sym_yield_expression] = STATE(1238),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1238),
    [sym_jsx_fragment] = STATE(1238),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1238),
    [sym_class] = STATE(1238),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1238),
    [sym_arrow_function] = STATE(1238),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1238),
    [sym_new_expression] = STATE(1238),
    [sym_await_expression] = STATE(1238),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1238),
    [sym_augmented_assignment_expression] = STATE(1238),
    [sym_ternary_expression] = STATE(1238),
    [sym_binary_expression] = STATE(1238),
    [sym_unary_expression] = STATE(1238),
    [sym_update_expression] = STATE(1238),
    [sym_string] = STATE(1238),
    [sym_template_string] = STATE(1238),
    [sym_regex] = STATE(1238),
    [sym_meta_property] = STATE(1238),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1238),
    [sym_as_expression] = STATE(1238),
    [sym_internal_module] = STATE(1238),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2334),
    [sym_this] = ACTIONS(2336),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2336),
    [sym_false] = ACTIONS(2336),
    [sym_null] = ACTIONS(2336),
    [sym_undefined] = ACTIONS(2336),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [400] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1243),
    [sym_yield_expression] = STATE(1243),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1243),
    [sym_jsx_fragment] = STATE(1243),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1243),
    [sym_class] = STATE(1243),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1243),
    [sym_arrow_function] = STATE(1243),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1243),
    [sym_new_expression] = STATE(1243),
    [sym_await_expression] = STATE(1243),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1243),
    [sym_augmented_assignment_expression] = STATE(1243),
    [sym_ternary_expression] = STATE(1243),
    [sym_binary_expression] = STATE(1243),
    [sym_unary_expression] = STATE(1243),
    [sym_update_expression] = STATE(1243),
    [sym_string] = STATE(1243),
    [sym_template_string] = STATE(1243),
    [sym_regex] = STATE(1243),
    [sym_meta_property] = STATE(1243),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1243),
    [sym_as_expression] = STATE(1243),
    [sym_internal_module] = STATE(1243),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2338),
    [sym_this] = ACTIONS(2340),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2340),
    [sym_false] = ACTIONS(2340),
    [sym_null] = ACTIONS(2340),
    [sym_undefined] = ACTIONS(2340),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [401] = {
    [sym_import] = STATE(1248),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1248),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1248),
    [sym_jsx_fragment] = STATE(1248),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1248),
    [sym_class] = STATE(1248),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1248),
    [sym_arrow_function] = STATE(1248),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1248),
    [sym_new_expression] = STATE(1248),
    [sym_await_expression] = STATE(1248),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1248),
    [sym_augmented_assignment_expression] = STATE(1248),
    [sym_ternary_expression] = STATE(1248),
    [sym_binary_expression] = STATE(1248),
    [sym_unary_expression] = STATE(1248),
    [sym_update_expression] = STATE(1248),
    [sym_string] = STATE(1248),
    [sym_template_string] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_meta_property] = STATE(1248),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1248),
    [sym_as_expression] = STATE(1248),
    [sym_internal_module] = STATE(1248),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2344),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_undefined] = ACTIONS(2344),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [402] = {
    [sym_import] = STATE(1184),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1184),
    [sym_yield_expression] = STATE(1184),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1184),
    [sym_jsx_fragment] = STATE(1184),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1184),
    [sym_class] = STATE(1184),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1184),
    [sym_arrow_function] = STATE(1184),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1184),
    [sym_new_expression] = STATE(1184),
    [sym_await_expression] = STATE(1184),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1184),
    [sym_augmented_assignment_expression] = STATE(1184),
    [sym_ternary_expression] = STATE(1184),
    [sym_binary_expression] = STATE(1184),
    [sym_unary_expression] = STATE(1184),
    [sym_update_expression] = STATE(1184),
    [sym_string] = STATE(1184),
    [sym_template_string] = STATE(1184),
    [sym_regex] = STATE(1184),
    [sym_meta_property] = STATE(1184),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1184),
    [sym_as_expression] = STATE(1184),
    [sym_internal_module] = STATE(1184),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2346),
    [sym_this] = ACTIONS(2348),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2348),
    [sym_false] = ACTIONS(2348),
    [sym_null] = ACTIONS(2348),
    [sym_undefined] = ACTIONS(2348),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [403] = {
    [sym_import] = STATE(1377),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1377),
    [sym_yield_expression] = STATE(1377),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1377),
    [sym_jsx_fragment] = STATE(1377),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1377),
    [sym_class] = STATE(1377),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1377),
    [sym_arrow_function] = STATE(1377),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1377),
    [sym_new_expression] = STATE(1377),
    [sym_await_expression] = STATE(1377),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1377),
    [sym_augmented_assignment_expression] = STATE(1377),
    [sym_ternary_expression] = STATE(1377),
    [sym_binary_expression] = STATE(1377),
    [sym_unary_expression] = STATE(1377),
    [sym_update_expression] = STATE(1377),
    [sym_string] = STATE(1377),
    [sym_template_string] = STATE(1377),
    [sym_regex] = STATE(1377),
    [sym_meta_property] = STATE(1377),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1377),
    [sym_as_expression] = STATE(1377),
    [sym_internal_module] = STATE(1377),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2350),
    [sym_this] = ACTIONS(2352),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2352),
    [sym_false] = ACTIONS(2352),
    [sym_null] = ACTIONS(2352),
    [sym_undefined] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [404] = {
    [sym_import] = STATE(1187),
    [sym_parenthesized_expression] = STATE(892),
    [sym__expression] = STATE(1187),
    [sym_yield_expression] = STATE(1187),
    [sym_object] = STATE(1510),
    [sym_array] = STATE(1511),
    [sym_jsx_element] = STATE(1187),
    [sym_jsx_fragment] = STATE(1187),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1187),
    [sym_class] = STATE(1187),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1187),
    [sym_arrow_function] = STATE(1187),
    [sym__call_signature] = STATE(3005),
    [sym_call_expression] = STATE(1187),
    [sym_new_expression] = STATE(1187),
    [sym_await_expression] = STATE(1187),
    [sym_member_expression] = STATE(892),
    [sym_subscript_expression] = STATE(892),
    [sym_assignment_expression] = STATE(1187),
    [sym_augmented_assignment_expression] = STATE(1187),
    [sym_ternary_expression] = STATE(1187),
    [sym_binary_expression] = STATE(1187),
    [sym_unary_expression] = STATE(1187),
    [sym_update_expression] = STATE(1187),
    [sym_string] = STATE(1187),
    [sym_template_string] = STATE(1187),
    [sym_regex] = STATE(1187),
    [sym_meta_property] = STATE(1187),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1187),
    [sym_as_expression] = STATE(1187),
    [sym_internal_module] = STATE(1187),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_export] = ACTIONS(756),
    [anon_sym_namespace] = ACTIONS(760),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_typeof] = ACTIONS(762),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(764),
    [anon_sym_yield] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(772),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_BANG] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(782),
    [anon_sym_delete] = ACTIONS(762),
    [anon_sym_PLUS_PLUS] = ACTIONS(784),
    [anon_sym_DASH_DASH] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2354),
    [sym_this] = ACTIONS(2356),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2356),
    [sym_false] = ACTIONS(2356),
    [sym_null] = ACTIONS(2356),
    [sym_undefined] = ACTIONS(2356),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(756),
    [anon_sym_get] = ACTIONS(756),
    [anon_sym_set] = ACTIONS(756),
    [anon_sym_declare] = ACTIONS(756),
    [anon_sym_public] = ACTIONS(756),
    [anon_sym_private] = ACTIONS(756),
    [anon_sym_protected] = ACTIONS(756),
    [anon_sym_module] = ACTIONS(756),
    [anon_sym_any] = ACTIONS(756),
    [anon_sym_number] = ACTIONS(756),
    [anon_sym_boolean] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_symbol] = ACTIONS(756),
    [sym_readonly] = ACTIONS(756),
  },
  [405] = {
    [sym_import] = STATE(1376),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1376),
    [sym_yield_expression] = STATE(1376),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1376),
    [sym_jsx_fragment] = STATE(1376),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1376),
    [sym_class] = STATE(1376),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1376),
    [sym_arrow_function] = STATE(1376),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1376),
    [sym_new_expression] = STATE(1376),
    [sym_await_expression] = STATE(1376),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1376),
    [sym_augmented_assignment_expression] = STATE(1376),
    [sym_ternary_expression] = STATE(1376),
    [sym_binary_expression] = STATE(1376),
    [sym_unary_expression] = STATE(1376),
    [sym_update_expression] = STATE(1376),
    [sym_string] = STATE(1376),
    [sym_template_string] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_meta_property] = STATE(1376),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1376),
    [sym_as_expression] = STATE(1376),
    [sym_internal_module] = STATE(1376),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2358),
    [sym_this] = ACTIONS(2360),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2360),
    [sym_false] = ACTIONS(2360),
    [sym_null] = ACTIONS(2360),
    [sym_undefined] = ACTIONS(2360),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [406] = {
    [sym_import] = STATE(1367),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1367),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1367),
    [sym_jsx_fragment] = STATE(1367),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1367),
    [sym_class] = STATE(1367),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1367),
    [sym_arrow_function] = STATE(1367),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1367),
    [sym_new_expression] = STATE(1367),
    [sym_await_expression] = STATE(1367),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1367),
    [sym_augmented_assignment_expression] = STATE(1367),
    [sym_ternary_expression] = STATE(1367),
    [sym_binary_expression] = STATE(1367),
    [sym_unary_expression] = STATE(1367),
    [sym_update_expression] = STATE(1367),
    [sym_string] = STATE(1367),
    [sym_template_string] = STATE(1367),
    [sym_regex] = STATE(1367),
    [sym_meta_property] = STATE(1367),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1367),
    [sym_as_expression] = STATE(1367),
    [sym_internal_module] = STATE(1367),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2160),
    [sym_this] = ACTIONS(2162),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(2162),
    [sym_false] = ACTIONS(2162),
    [sym_null] = ACTIONS(2162),
    [sym_undefined] = ACTIONS(2162),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [407] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(850),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1309),
    [sym_array] = STATE(1310),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(1979),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(956),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(3075),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(850),
    [sym_subscript_expression] = STATE(850),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2506),
    [sym_identifier] = ACTIONS(567),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_namespace] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_type] = ACTIONS(569),
    [anon_sym_typeof] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(582),
    [anon_sym_yield] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(593),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(597),
    [anon_sym_PLUS] = ACTIONS(601),
    [anon_sym_DASH] = ACTIONS(601),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_void] = ACTIONS(607),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(2362),
    [sym_this] = ACTIONS(1938),
    [sym_super] = ACTIONS(565),
    [sym_true] = ACTIONS(1938),
    [sym_false] = ACTIONS(1938),
    [sym_null] = ACTIONS(1938),
    [sym_undefined] = ACTIONS(1938),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(569),
    [anon_sym_get] = ACTIONS(569),
    [anon_sym_set] = ACTIONS(569),
    [anon_sym_declare] = ACTIONS(569),
    [anon_sym_public] = ACTIONS(569),
    [anon_sym_private] = ACTIONS(569),
    [anon_sym_protected] = ACTIONS(569),
    [anon_sym_module] = ACTIONS(569),
    [anon_sym_any] = ACTIONS(569),
    [anon_sym_number] = ACTIONS(569),
    [anon_sym_boolean] = ACTIONS(569),
    [anon_sym_string] = ACTIONS(569),
    [anon_sym_symbol] = ACTIONS(569),
    [sym_readonly] = ACTIONS(569),
  },
  [408] = {
    [sym_import] = STATE(1026),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1026),
    [sym_yield_expression] = STATE(1026),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1026),
    [sym_jsx_fragment] = STATE(1026),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1026),
    [sym_class] = STATE(1026),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1026),
    [sym_arrow_function] = STATE(1026),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1026),
    [sym_new_expression] = STATE(1026),
    [sym_await_expression] = STATE(1026),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1026),
    [sym_augmented_assignment_expression] = STATE(1026),
    [sym_ternary_expression] = STATE(1026),
    [sym_binary_expression] = STATE(1026),
    [sym_unary_expression] = STATE(1026),
    [sym_update_expression] = STATE(1026),
    [sym_string] = STATE(1026),
    [sym_template_string] = STATE(1026),
    [sym_regex] = STATE(1026),
    [sym_meta_property] = STATE(1026),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1026),
    [sym_as_expression] = STATE(1026),
    [sym_internal_module] = STATE(1026),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2364),
    [sym_this] = ACTIONS(2366),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [sym_null] = ACTIONS(2366),
    [sym_undefined] = ACTIONS(2366),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [409] = {
    [sym_import] = STATE(1249),
    [sym_parenthesized_expression] = STATE(893),
    [sym__expression] = STATE(1249),
    [sym_yield_expression] = STATE(1249),
    [sym_object] = STATE(1522),
    [sym_array] = STATE(1518),
    [sym_jsx_element] = STATE(1249),
    [sym_jsx_fragment] = STATE(1249),
    [sym_jsx_opening_element] = STATE(1986),
    [sym_jsx_self_closing_element] = STATE(1249),
    [sym_class] = STATE(1249),
    [sym_function] = STATE(1287),
    [sym_generator_function] = STATE(1249),
    [sym_arrow_function] = STATE(1249),
    [sym__call_signature] = STATE(3038),
    [sym_call_expression] = STATE(1249),
    [sym_new_expression] = STATE(1249),
    [sym_await_expression] = STATE(1249),
    [sym_member_expression] = STATE(893),
    [sym_subscript_expression] = STATE(893),
    [sym_assignment_expression] = STATE(1249),
    [sym_augmented_assignment_expression] = STATE(1249),
    [sym_ternary_expression] = STATE(1249),
    [sym_binary_expression] = STATE(1249),
    [sym_unary_expression] = STATE(1249),
    [sym_update_expression] = STATE(1249),
    [sym_string] = STATE(1249),
    [sym_template_string] = STATE(1249),
    [sym_regex] = STATE(1249),
    [sym_meta_property] = STATE(1249),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1249),
    [sym_as_expression] = STATE(1249),
    [sym_internal_module] = STATE(1249),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2462),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_export] = ACTIONS(698),
    [anon_sym_namespace] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_typeof] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(708),
    [anon_sym_LPAREN] = ACTIONS(710),
    [anon_sym_await] = ACTIONS(712),
    [anon_sym_yield] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(1003),
    [anon_sym_SLASH] = ACTIONS(720),
    [anon_sym_class] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(724),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_new] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_TILDE] = ACTIONS(736),
    [anon_sym_void] = ACTIONS(738),
    [anon_sym_delete] = ACTIONS(706),
    [anon_sym_PLUS_PLUS] = ACTIONS(740),
    [anon_sym_DASH_DASH] = ACTIONS(740),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(2368),
    [sym_this] = ACTIONS(2370),
    [sym_super] = ACTIONS(752),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [sym_null] = ACTIONS(2370),
    [sym_undefined] = ACTIONS(2370),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
    [anon_sym_declare] = ACTIONS(698),
    [anon_sym_public] = ACTIONS(698),
    [anon_sym_private] = ACTIONS(698),
    [anon_sym_protected] = ACTIONS(698),
    [anon_sym_module] = ACTIONS(698),
    [anon_sym_any] = ACTIONS(698),
    [anon_sym_number] = ACTIONS(698),
    [anon_sym_boolean] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_symbol] = ACTIONS(698),
    [sym_readonly] = ACTIONS(698),
  },
  [410] = {
    [sym_import] = STATE(1066),
    [sym_parenthesized_expression] = STATE(871),
    [sym__expression] = STATE(1066),
    [sym_yield_expression] = STATE(1066),
    [sym_object] = STATE(1320),
    [sym_array] = STATE(1360),
    [sym_jsx_element] = STATE(1066),
    [sym_jsx_fragment] = STATE(1066),
    [sym_jsx_opening_element] = STATE(2003),
    [sym_jsx_self_closing_element] = STATE(1066),
    [sym_class] = STATE(1066),
    [sym_function] = STATE(1157),
    [sym_generator_function] = STATE(1066),
    [sym_arrow_function] = STATE(1066),
    [sym__call_signature] = STATE(3152),
    [sym_call_expression] = STATE(1066),
    [sym_new_expression] = STATE(1066),
    [sym_await_expression] = STATE(1066),
    [sym_member_expression] = STATE(871),
    [sym_subscript_expression] = STATE(871),
    [sym_assignment_expression] = STATE(1066),
    [sym_augmented_assignment_expression] = STATE(1066),
    [sym_ternary_expression] = STATE(1066),
    [sym_binary_expression] = STATE(1066),
    [sym_unary_expression] = STATE(1066),
    [sym_update_expression] = STATE(1066),
    [sym_string] = STATE(1066),
    [sym_template_string] = STATE(1066),
    [sym_regex] = STATE(1066),
    [sym_meta_property] = STATE(1066),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2527),
    [sym_non_null_expression] = STATE(1066),
    [sym_as_expression] = STATE(1066),
    [sym_internal_module] = STATE(1066),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_export_statement_repeat1] = STATE(2499),
    [sym_identifier] = ACTIONS(467),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_namespace] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_type] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(492),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2372),
    [sym_this] = ACTIONS(2374),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [sym_null] = ACTIONS(2374),
    [sym_undefined] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [anon_sym_declare] = ACTIONS(469),
    [anon_sym_public] = ACTIONS(469),
    [anon_sym_private] = ACTIONS(469),
    [anon_sym_protected] = ACTIONS(469),
    [anon_sym_module] = ACTIONS(469),
    [anon_sym_any] = ACTIONS(469),
    [anon_sym_number] = ACTIONS(469),
    [anon_sym_boolean] = ACTIONS(469),
    [anon_sym_string] = ACTIONS(469),
    [anon_sym_symbol] = ACTIONS(469),
    [sym_readonly] = ACTIONS(469),
  },
  [411] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2671),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [412] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2645),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [413] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [414] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [aux_sym_object_repeat1] = STATE(2718),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [415] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2386),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [416] = {
    [sym_export_clause] = STATE(2505),
    [sym__declaration] = STATE(557),
    [sym_variable_declaration] = STATE(557),
    [sym_lexical_declaration] = STATE(557),
    [sym_class_declaration] = STATE(557),
    [sym_function_declaration] = STATE(557),
    [sym_generator_function_declaration] = STATE(557),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(557),
    [sym_ambient_declaration] = STATE(557),
    [sym_abstract_class_declaration] = STATE(557),
    [sym_module] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_import_alias] = STATE(557),
    [sym_interface_declaration] = STATE(557),
    [sym_enum_declaration] = STATE(557),
    [sym_type_alias_declaration] = STATE(557),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1601),
    [anon_sym_EQ] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(1605),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [417] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_export] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_namespace] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1165),
    [anon_sym_typeof] = ACTIONS(1165),
    [anon_sym_import] = ACTIONS(1165),
    [anon_sym_var] = ACTIONS(1165),
    [anon_sym_let] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_do] = ACTIONS(1165),
    [anon_sym_try] = ACTIONS(1165),
    [anon_sym_with] = ACTIONS(1165),
    [anon_sym_break] = ACTIONS(1165),
    [anon_sym_continue] = ACTIONS(1165),
    [anon_sym_debugger] = ACTIONS(1165),
    [anon_sym_return] = ACTIONS(1165),
    [anon_sym_throw] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_case] = ACTIONS(1165),
    [anon_sym_yield] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_class] = ACTIONS(1165),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_EQ_GT] = ACTIONS(1163),
    [anon_sym_new] = ACTIONS(1165),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1163),
    [anon_sym_void] = ACTIONS(1165),
    [anon_sym_delete] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [sym_number] = ACTIONS(1163),
    [sym_this] = ACTIONS(1165),
    [sym_super] = ACTIONS(1165),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_null] = ACTIONS(1165),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
    [anon_sym_static] = ACTIONS(1165),
    [anon_sym_abstract] = ACTIONS(1165),
    [anon_sym_get] = ACTIONS(1165),
    [anon_sym_set] = ACTIONS(1165),
    [anon_sym_declare] = ACTIONS(1165),
    [anon_sym_public] = ACTIONS(1165),
    [anon_sym_private] = ACTIONS(1165),
    [anon_sym_protected] = ACTIONS(1165),
    [anon_sym_module] = ACTIONS(1165),
    [anon_sym_any] = ACTIONS(1165),
    [anon_sym_number] = ACTIONS(1165),
    [anon_sym_boolean] = ACTIONS(1165),
    [anon_sym_string] = ACTIONS(1165),
    [anon_sym_symbol] = ACTIONS(1165),
    [anon_sym_interface] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [sym_readonly] = ACTIONS(1165),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(1167),
    [sym_identifier] = ACTIONS(1169),
    [anon_sym_export] = ACTIONS(1169),
    [anon_sym_default] = ACTIONS(1169),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_namespace] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_type] = ACTIONS(1169),
    [anon_sym_typeof] = ACTIONS(1169),
    [anon_sym_import] = ACTIONS(1169),
    [anon_sym_var] = ACTIONS(1169),
    [anon_sym_let] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(1167),
    [anon_sym_await] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_do] = ACTIONS(1169),
    [anon_sym_try] = ACTIONS(1169),
    [anon_sym_with] = ACTIONS(1169),
    [anon_sym_break] = ACTIONS(1169),
    [anon_sym_continue] = ACTIONS(1169),
    [anon_sym_debugger] = ACTIONS(1169),
    [anon_sym_return] = ACTIONS(1169),
    [anon_sym_throw] = ACTIONS(1169),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_case] = ACTIONS(1169),
    [anon_sym_yield] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_RBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(1167),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_class] = ACTIONS(1169),
    [anon_sym_async] = ACTIONS(1169),
    [anon_sym_function] = ACTIONS(1169),
    [anon_sym_EQ_GT] = ACTIONS(1167),
    [anon_sym_new] = ACTIONS(1169),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1167),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1167),
    [anon_sym_TILDE] = ACTIONS(1167),
    [anon_sym_void] = ACTIONS(1169),
    [anon_sym_delete] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym_number] = ACTIONS(1167),
    [sym_this] = ACTIONS(1169),
    [sym_super] = ACTIONS(1169),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [sym_null] = ACTIONS(1169),
    [sym_undefined] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1167),
    [anon_sym_static] = ACTIONS(1169),
    [anon_sym_abstract] = ACTIONS(1169),
    [anon_sym_get] = ACTIONS(1169),
    [anon_sym_set] = ACTIONS(1169),
    [anon_sym_declare] = ACTIONS(1169),
    [anon_sym_public] = ACTIONS(1169),
    [anon_sym_private] = ACTIONS(1169),
    [anon_sym_protected] = ACTIONS(1169),
    [anon_sym_module] = ACTIONS(1169),
    [anon_sym_any] = ACTIONS(1169),
    [anon_sym_number] = ACTIONS(1169),
    [anon_sym_boolean] = ACTIONS(1169),
    [anon_sym_string] = ACTIONS(1169),
    [anon_sym_symbol] = ACTIONS(1169),
    [anon_sym_interface] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [sym_readonly] = ACTIONS(1169),
  },
  [419] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [420] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2392),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [421] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2396),
    [anon_sym_export] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_EQ] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_type] = ACTIONS(2396),
    [anon_sym_typeof] = ACTIONS(2396),
    [anon_sym_import] = ACTIONS(2396),
    [anon_sym_var] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_else] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_RPAREN] = ACTIONS(2394),
    [anon_sym_await] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_with] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_debugger] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_RBRACK] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2396),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_function] = ACTIONS(2396),
    [anon_sym_EQ_GT] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_void] = ACTIONS(2396),
    [anon_sym_delete] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2394),
    [sym_number] = ACTIONS(2394),
    [sym_this] = ACTIONS(2396),
    [sym_super] = ACTIONS(2396),
    [sym_true] = ACTIONS(2396),
    [sym_false] = ACTIONS(2396),
    [sym_null] = ACTIONS(2396),
    [sym_undefined] = ACTIONS(2396),
    [anon_sym_AT] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_abstract] = ACTIONS(2396),
    [anon_sym_get] = ACTIONS(2396),
    [anon_sym_set] = ACTIONS(2396),
    [anon_sym_declare] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_module] = ACTIONS(2396),
    [anon_sym_any] = ACTIONS(2396),
    [anon_sym_number] = ACTIONS(2396),
    [anon_sym_boolean] = ACTIONS(2396),
    [anon_sym_string] = ACTIONS(2396),
    [anon_sym_symbol] = ACTIONS(2396),
    [anon_sym_implements] = ACTIONS(2396),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [sym_readonly] = ACTIONS(2396),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_export] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_EQ] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_typeof] = ACTIONS(2400),
    [anon_sym_import] = ACTIONS(2400),
    [anon_sym_var] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_else] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_RPAREN] = ACTIONS(2398),
    [anon_sym_await] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_with] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_debugger] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_RBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_GT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_function] = ACTIONS(2400),
    [anon_sym_EQ_GT] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_void] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [sym_number] = ACTIONS(2398),
    [sym_this] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [sym_null] = ACTIONS(2400),
    [sym_undefined] = ACTIONS(2400),
    [anon_sym_AT] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_abstract] = ACTIONS(2400),
    [anon_sym_get] = ACTIONS(2400),
    [anon_sym_set] = ACTIONS(2400),
    [anon_sym_declare] = ACTIONS(2400),
    [anon_sym_public] = ACTIONS(2400),
    [anon_sym_private] = ACTIONS(2400),
    [anon_sym_protected] = ACTIONS(2400),
    [anon_sym_module] = ACTIONS(2400),
    [anon_sym_any] = ACTIONS(2400),
    [anon_sym_number] = ACTIONS(2400),
    [anon_sym_boolean] = ACTIONS(2400),
    [anon_sym_string] = ACTIONS(2400),
    [anon_sym_symbol] = ACTIONS(2400),
    [anon_sym_implements] = ACTIONS(2400),
    [anon_sym_interface] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [sym_readonly] = ACTIONS(2400),
  },
  [424] = {
    [sym__call_signature] = STATE(3025),
    [sym_string] = STATE(2197),
    [sym_formal_parameters] = STATE(2527),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2409),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2428),
    [anon_sym_set] = ACTIONS(2428),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [sym_readonly] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(2430),
    [sym_identifier] = ACTIONS(2432),
    [anon_sym_export] = ACTIONS(2432),
    [anon_sym_default] = ACTIONS(2432),
    [anon_sym_EQ] = ACTIONS(2432),
    [anon_sym_namespace] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_type] = ACTIONS(2432),
    [anon_sym_typeof] = ACTIONS(2432),
    [anon_sym_import] = ACTIONS(2432),
    [anon_sym_var] = ACTIONS(2432),
    [anon_sym_let] = ACTIONS(2432),
    [anon_sym_const] = ACTIONS(2432),
    [anon_sym_if] = ACTIONS(2432),
    [anon_sym_else] = ACTIONS(2432),
    [anon_sym_switch] = ACTIONS(2432),
    [anon_sym_for] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2430),
    [anon_sym_await] = ACTIONS(2432),
    [anon_sym_while] = ACTIONS(2432),
    [anon_sym_do] = ACTIONS(2432),
    [anon_sym_try] = ACTIONS(2432),
    [anon_sym_with] = ACTIONS(2432),
    [anon_sym_break] = ACTIONS(2432),
    [anon_sym_continue] = ACTIONS(2432),
    [anon_sym_debugger] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2432),
    [anon_sym_throw] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(2432),
    [anon_sym_yield] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_RBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_class] = ACTIONS(2432),
    [anon_sym_async] = ACTIONS(2432),
    [anon_sym_function] = ACTIONS(2432),
    [anon_sym_EQ_GT] = ACTIONS(2430),
    [anon_sym_new] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2430),
    [anon_sym_void] = ACTIONS(2432),
    [anon_sym_delete] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [anon_sym_DQUOTE] = ACTIONS(2430),
    [anon_sym_SQUOTE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [sym_number] = ACTIONS(2430),
    [sym_this] = ACTIONS(2432),
    [sym_super] = ACTIONS(2432),
    [sym_true] = ACTIONS(2432),
    [sym_false] = ACTIONS(2432),
    [sym_null] = ACTIONS(2432),
    [sym_undefined] = ACTIONS(2432),
    [anon_sym_AT] = ACTIONS(2430),
    [anon_sym_static] = ACTIONS(2432),
    [anon_sym_abstract] = ACTIONS(2432),
    [anon_sym_get] = ACTIONS(2432),
    [anon_sym_set] = ACTIONS(2432),
    [anon_sym_declare] = ACTIONS(2432),
    [anon_sym_public] = ACTIONS(2432),
    [anon_sym_private] = ACTIONS(2432),
    [anon_sym_protected] = ACTIONS(2432),
    [anon_sym_module] = ACTIONS(2432),
    [anon_sym_any] = ACTIONS(2432),
    [anon_sym_number] = ACTIONS(2432),
    [anon_sym_boolean] = ACTIONS(2432),
    [anon_sym_string] = ACTIONS(2432),
    [anon_sym_symbol] = ACTIONS(2432),
    [anon_sym_implements] = ACTIONS(2432),
    [anon_sym_interface] = ACTIONS(2432),
    [anon_sym_enum] = ACTIONS(2432),
    [sym_readonly] = ACTIONS(2432),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(2434),
    [sym_identifier] = ACTIONS(2436),
    [anon_sym_export] = ACTIONS(2436),
    [anon_sym_default] = ACTIONS(2436),
    [anon_sym_EQ] = ACTIONS(2436),
    [anon_sym_namespace] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_type] = ACTIONS(2436),
    [anon_sym_typeof] = ACTIONS(2436),
    [anon_sym_import] = ACTIONS(2436),
    [anon_sym_var] = ACTIONS(2436),
    [anon_sym_let] = ACTIONS(2436),
    [anon_sym_const] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(2436),
    [anon_sym_else] = ACTIONS(2436),
    [anon_sym_switch] = ACTIONS(2436),
    [anon_sym_for] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_RPAREN] = ACTIONS(2434),
    [anon_sym_await] = ACTIONS(2436),
    [anon_sym_while] = ACTIONS(2436),
    [anon_sym_do] = ACTIONS(2436),
    [anon_sym_try] = ACTIONS(2436),
    [anon_sym_with] = ACTIONS(2436),
    [anon_sym_break] = ACTIONS(2436),
    [anon_sym_continue] = ACTIONS(2436),
    [anon_sym_debugger] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2436),
    [anon_sym_throw] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(2436),
    [anon_sym_yield] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [anon_sym_RBRACK] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(2438),
    [anon_sym_class] = ACTIONS(2436),
    [anon_sym_async] = ACTIONS(2436),
    [anon_sym_function] = ACTIONS(2436),
    [anon_sym_EQ_GT] = ACTIONS(2434),
    [anon_sym_new] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2434),
    [anon_sym_void] = ACTIONS(2436),
    [anon_sym_delete] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [anon_sym_DQUOTE] = ACTIONS(2434),
    [anon_sym_SQUOTE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [sym_number] = ACTIONS(2434),
    [sym_this] = ACTIONS(2436),
    [sym_super] = ACTIONS(2436),
    [sym_true] = ACTIONS(2436),
    [sym_false] = ACTIONS(2436),
    [sym_null] = ACTIONS(2436),
    [sym_undefined] = ACTIONS(2436),
    [anon_sym_AT] = ACTIONS(2434),
    [anon_sym_static] = ACTIONS(2436),
    [anon_sym_abstract] = ACTIONS(2436),
    [anon_sym_get] = ACTIONS(2436),
    [anon_sym_set] = ACTIONS(2436),
    [anon_sym_declare] = ACTIONS(2436),
    [anon_sym_public] = ACTIONS(2436),
    [anon_sym_private] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(2436),
    [anon_sym_module] = ACTIONS(2436),
    [anon_sym_any] = ACTIONS(2436),
    [anon_sym_number] = ACTIONS(2436),
    [anon_sym_boolean] = ACTIONS(2436),
    [anon_sym_string] = ACTIONS(2436),
    [anon_sym_symbol] = ACTIONS(2436),
    [anon_sym_interface] = ACTIONS(2436),
    [anon_sym_enum] = ACTIONS(2436),
    [sym_readonly] = ACTIONS(2436),
  },
  [427] = {
    [sym__call_signature] = STATE(3025),
    [sym_string] = STATE(2197),
    [sym_formal_parameters] = STATE(2527),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2409),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2428),
    [anon_sym_set] = ACTIONS(2428),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [sym_readonly] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [428] = {
    [sym__call_signature] = STATE(3025),
    [sym_string] = STATE(2197),
    [sym_formal_parameters] = STATE(2527),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_type_parameters] = STATE(2830),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2409),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2428),
    [anon_sym_set] = ACTIONS(2428),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [sym_readonly] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(2440),
    [sym_identifier] = ACTIONS(2442),
    [anon_sym_export] = ACTIONS(2442),
    [anon_sym_default] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2442),
    [anon_sym_namespace] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_COMMA] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_type] = ACTIONS(2442),
    [anon_sym_typeof] = ACTIONS(2442),
    [anon_sym_import] = ACTIONS(2442),
    [anon_sym_var] = ACTIONS(2442),
    [anon_sym_let] = ACTIONS(2442),
    [anon_sym_const] = ACTIONS(2442),
    [anon_sym_if] = ACTIONS(2442),
    [anon_sym_else] = ACTIONS(2442),
    [anon_sym_switch] = ACTIONS(2442),
    [anon_sym_for] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_RPAREN] = ACTIONS(2440),
    [anon_sym_await] = ACTIONS(2442),
    [anon_sym_while] = ACTIONS(2442),
    [anon_sym_do] = ACTIONS(2442),
    [anon_sym_try] = ACTIONS(2442),
    [anon_sym_with] = ACTIONS(2442),
    [anon_sym_break] = ACTIONS(2442),
    [anon_sym_continue] = ACTIONS(2442),
    [anon_sym_debugger] = ACTIONS(2442),
    [anon_sym_return] = ACTIONS(2442),
    [anon_sym_throw] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_case] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_RBRACK] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2440),
    [anon_sym_SLASH] = ACTIONS(2442),
    [anon_sym_class] = ACTIONS(2442),
    [anon_sym_async] = ACTIONS(2442),
    [anon_sym_function] = ACTIONS(2442),
    [anon_sym_EQ_GT] = ACTIONS(2440),
    [anon_sym_new] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_TILDE] = ACTIONS(2440),
    [anon_sym_void] = ACTIONS(2442),
    [anon_sym_delete] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2440),
    [anon_sym_DASH_DASH] = ACTIONS(2440),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2440),
    [sym_number] = ACTIONS(2440),
    [sym_this] = ACTIONS(2442),
    [sym_super] = ACTIONS(2442),
    [sym_true] = ACTIONS(2442),
    [sym_false] = ACTIONS(2442),
    [sym_null] = ACTIONS(2442),
    [sym_undefined] = ACTIONS(2442),
    [anon_sym_AT] = ACTIONS(2440),
    [anon_sym_static] = ACTIONS(2442),
    [anon_sym_abstract] = ACTIONS(2442),
    [anon_sym_get] = ACTIONS(2442),
    [anon_sym_set] = ACTIONS(2442),
    [anon_sym_declare] = ACTIONS(2442),
    [anon_sym_public] = ACTIONS(2442),
    [anon_sym_private] = ACTIONS(2442),
    [anon_sym_protected] = ACTIONS(2442),
    [anon_sym_module] = ACTIONS(2442),
    [anon_sym_any] = ACTIONS(2442),
    [anon_sym_number] = ACTIONS(2442),
    [anon_sym_boolean] = ACTIONS(2442),
    [anon_sym_string] = ACTIONS(2442),
    [anon_sym_symbol] = ACTIONS(2442),
    [anon_sym_interface] = ACTIONS(2442),
    [anon_sym_enum] = ACTIONS(2442),
    [sym_readonly] = ACTIONS(2442),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(2444),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_export] = ACTIONS(2446),
    [anon_sym_default] = ACTIONS(2446),
    [anon_sym_EQ] = ACTIONS(2446),
    [anon_sym_namespace] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_type] = ACTIONS(2446),
    [anon_sym_typeof] = ACTIONS(2446),
    [anon_sym_import] = ACTIONS(2446),
    [anon_sym_var] = ACTIONS(2446),
    [anon_sym_let] = ACTIONS(2446),
    [anon_sym_const] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_else] = ACTIONS(2446),
    [anon_sym_switch] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2444),
    [anon_sym_await] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_do] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_with] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_debugger] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_throw] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_case] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2446),
    [anon_sym_class] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_function] = ACTIONS(2446),
    [anon_sym_EQ_GT] = ACTIONS(2444),
    [anon_sym_new] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(2446),
    [anon_sym_delete] = ACTIONS(2446),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2444),
    [anon_sym_SQUOTE] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2444),
    [sym_number] = ACTIONS(2444),
    [sym_this] = ACTIONS(2446),
    [sym_super] = ACTIONS(2446),
    [sym_true] = ACTIONS(2446),
    [sym_false] = ACTIONS(2446),
    [sym_null] = ACTIONS(2446),
    [sym_undefined] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(2444),
    [anon_sym_static] = ACTIONS(2446),
    [anon_sym_abstract] = ACTIONS(2446),
    [anon_sym_get] = ACTIONS(2446),
    [anon_sym_set] = ACTIONS(2446),
    [anon_sym_declare] = ACTIONS(2446),
    [anon_sym_public] = ACTIONS(2446),
    [anon_sym_private] = ACTIONS(2446),
    [anon_sym_protected] = ACTIONS(2446),
    [anon_sym_module] = ACTIONS(2446),
    [anon_sym_any] = ACTIONS(2446),
    [anon_sym_number] = ACTIONS(2446),
    [anon_sym_boolean] = ACTIONS(2446),
    [anon_sym_string] = ACTIONS(2446),
    [anon_sym_symbol] = ACTIONS(2446),
    [anon_sym_interface] = ACTIONS(2446),
    [anon_sym_enum] = ACTIONS(2446),
    [sym_readonly] = ACTIONS(2446),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(2448),
    [sym_identifier] = ACTIONS(2450),
    [anon_sym_export] = ACTIONS(2450),
    [anon_sym_default] = ACTIONS(2450),
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_namespace] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_type] = ACTIONS(2450),
    [anon_sym_typeof] = ACTIONS(2450),
    [anon_sym_import] = ACTIONS(2450),
    [anon_sym_var] = ACTIONS(2450),
    [anon_sym_let] = ACTIONS(2450),
    [anon_sym_const] = ACTIONS(2450),
    [anon_sym_if] = ACTIONS(2450),
    [anon_sym_else] = ACTIONS(2450),
    [anon_sym_switch] = ACTIONS(2450),
    [anon_sym_for] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_await] = ACTIONS(2450),
    [anon_sym_while] = ACTIONS(2450),
    [anon_sym_do] = ACTIONS(2450),
    [anon_sym_try] = ACTIONS(2450),
    [anon_sym_with] = ACTIONS(2450),
    [anon_sym_break] = ACTIONS(2450),
    [anon_sym_continue] = ACTIONS(2450),
    [anon_sym_debugger] = ACTIONS(2450),
    [anon_sym_return] = ACTIONS(2450),
    [anon_sym_throw] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_case] = ACTIONS(2450),
    [anon_sym_yield] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_RBRACK] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(2450),
    [anon_sym_class] = ACTIONS(2450),
    [anon_sym_async] = ACTIONS(2450),
    [anon_sym_function] = ACTIONS(2450),
    [anon_sym_EQ_GT] = ACTIONS(2448),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2448),
    [anon_sym_void] = ACTIONS(2450),
    [anon_sym_delete] = ACTIONS(2450),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_DQUOTE] = ACTIONS(2448),
    [anon_sym_SQUOTE] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2448),
    [sym_number] = ACTIONS(2448),
    [sym_this] = ACTIONS(2450),
    [sym_super] = ACTIONS(2450),
    [sym_true] = ACTIONS(2450),
    [sym_false] = ACTIONS(2450),
    [sym_null] = ACTIONS(2450),
    [sym_undefined] = ACTIONS(2450),
    [anon_sym_AT] = ACTIONS(2448),
    [anon_sym_static] = ACTIONS(2450),
    [anon_sym_abstract] = ACTIONS(2450),
    [anon_sym_get] = ACTIONS(2450),
    [anon_sym_set] = ACTIONS(2450),
    [anon_sym_declare] = ACTIONS(2450),
    [anon_sym_public] = ACTIONS(2450),
    [anon_sym_private] = ACTIONS(2450),
    [anon_sym_protected] = ACTIONS(2450),
    [anon_sym_module] = ACTIONS(2450),
    [anon_sym_any] = ACTIONS(2450),
    [anon_sym_number] = ACTIONS(2450),
    [anon_sym_boolean] = ACTIONS(2450),
    [anon_sym_string] = ACTIONS(2450),
    [anon_sym_symbol] = ACTIONS(2450),
    [anon_sym_interface] = ACTIONS(2450),
    [anon_sym_enum] = ACTIONS(2450),
    [sym_readonly] = ACTIONS(2450),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(2452),
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_export] = ACTIONS(2454),
    [anon_sym_default] = ACTIONS(2454),
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_typeof] = ACTIONS(2454),
    [anon_sym_import] = ACTIONS(2454),
    [anon_sym_var] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_const] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_else] = ACTIONS(2454),
    [anon_sym_switch] = ACTIONS(2454),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_RPAREN] = ACTIONS(2452),
    [anon_sym_await] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_with] = ACTIONS(2454),
    [anon_sym_break] = ACTIONS(2454),
    [anon_sym_continue] = ACTIONS(2454),
    [anon_sym_debugger] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_throw] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_case] = ACTIONS(2454),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_class] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_EQ_GT] = ACTIONS(2452),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [anon_sym_void] = ACTIONS(2454),
    [anon_sym_delete] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2452),
    [sym_number] = ACTIONS(2452),
    [sym_this] = ACTIONS(2454),
    [sym_super] = ACTIONS(2454),
    [sym_true] = ACTIONS(2454),
    [sym_false] = ACTIONS(2454),
    [sym_null] = ACTIONS(2454),
    [sym_undefined] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_abstract] = ACTIONS(2454),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_declare] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_module] = ACTIONS(2454),
    [anon_sym_any] = ACTIONS(2454),
    [anon_sym_number] = ACTIONS(2454),
    [anon_sym_boolean] = ACTIONS(2454),
    [anon_sym_string] = ACTIONS(2454),
    [anon_sym_symbol] = ACTIONS(2454),
    [anon_sym_interface] = ACTIONS(2454),
    [anon_sym_enum] = ACTIONS(2454),
    [sym_readonly] = ACTIONS(2454),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(2456),
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_default] = ACTIONS(2458),
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_else] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_RPAREN] = ACTIONS(2456),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_case] = ACTIONS(2458),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_RBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_EQ_GT] = ACTIONS(2456),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_TILDE] = ACTIONS(2456),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2456),
    [anon_sym_DASH_DASH] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2456),
    [anon_sym_SQUOTE] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2456),
    [sym_number] = ACTIONS(2456),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2456),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
    [sym_readonly] = ACTIONS(2458),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(2460),
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_export] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_type] = ACTIONS(2462),
    [anon_sym_typeof] = ACTIONS(2462),
    [anon_sym_import] = ACTIONS(2462),
    [anon_sym_var] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_else] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_RPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_with] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_debugger] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_RBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_GT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_async] = ACTIONS(2462),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_EQ_GT] = ACTIONS(2460),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2462),
    [sym_super] = ACTIONS(2462),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [sym_null] = ACTIONS(2462),
    [sym_undefined] = ACTIONS(2462),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_abstract] = ACTIONS(2462),
    [anon_sym_get] = ACTIONS(2462),
    [anon_sym_set] = ACTIONS(2462),
    [anon_sym_declare] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_module] = ACTIONS(2462),
    [anon_sym_any] = ACTIONS(2462),
    [anon_sym_number] = ACTIONS(2462),
    [anon_sym_boolean] = ACTIONS(2462),
    [anon_sym_string] = ACTIONS(2462),
    [anon_sym_symbol] = ACTIONS(2462),
    [anon_sym_interface] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [sym_readonly] = ACTIONS(2462),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(2464),
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_export] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_type] = ACTIONS(2466),
    [anon_sym_typeof] = ACTIONS(2466),
    [anon_sym_import] = ACTIONS(2466),
    [anon_sym_var] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_await] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_with] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_debugger] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_case] = ACTIONS(2466),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_RBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_EQ_GT] = ACTIONS(2464),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_void] = ACTIONS(2466),
    [anon_sym_delete] = ACTIONS(2466),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [sym_number] = ACTIONS(2464),
    [sym_this] = ACTIONS(2466),
    [sym_super] = ACTIONS(2466),
    [sym_true] = ACTIONS(2466),
    [sym_false] = ACTIONS(2466),
    [sym_null] = ACTIONS(2466),
    [sym_undefined] = ACTIONS(2466),
    [anon_sym_AT] = ACTIONS(2464),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_abstract] = ACTIONS(2466),
    [anon_sym_get] = ACTIONS(2466),
    [anon_sym_set] = ACTIONS(2466),
    [anon_sym_declare] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_module] = ACTIONS(2466),
    [anon_sym_any] = ACTIONS(2466),
    [anon_sym_number] = ACTIONS(2466),
    [anon_sym_boolean] = ACTIONS(2466),
    [anon_sym_string] = ACTIONS(2466),
    [anon_sym_symbol] = ACTIONS(2466),
    [anon_sym_interface] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [sym_readonly] = ACTIONS(2466),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(2468),
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_export] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_type] = ACTIONS(2470),
    [anon_sym_typeof] = ACTIONS(2470),
    [anon_sym_import] = ACTIONS(2470),
    [anon_sym_var] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_else] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_RPAREN] = ACTIONS(2468),
    [anon_sym_await] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_debugger] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_RBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_EQ_GT] = ACTIONS(2468),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_void] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [sym_number] = ACTIONS(2468),
    [sym_this] = ACTIONS(2470),
    [sym_super] = ACTIONS(2470),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [sym_null] = ACTIONS(2470),
    [sym_undefined] = ACTIONS(2470),
    [anon_sym_AT] = ACTIONS(2468),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_abstract] = ACTIONS(2470),
    [anon_sym_get] = ACTIONS(2470),
    [anon_sym_set] = ACTIONS(2470),
    [anon_sym_declare] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2470),
    [anon_sym_any] = ACTIONS(2470),
    [anon_sym_number] = ACTIONS(2470),
    [anon_sym_boolean] = ACTIONS(2470),
    [anon_sym_string] = ACTIONS(2470),
    [anon_sym_symbol] = ACTIONS(2470),
    [anon_sym_interface] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [sym_readonly] = ACTIONS(2470),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_export] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_EQ] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2474),
    [anon_sym_typeof] = ACTIONS(2474),
    [anon_sym_import] = ACTIONS(2474),
    [anon_sym_var] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_await] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_debugger] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_EQ_GT] = ACTIONS(2472),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_void] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [sym_number] = ACTIONS(2472),
    [sym_this] = ACTIONS(2474),
    [sym_super] = ACTIONS(2474),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [sym_null] = ACTIONS(2474),
    [sym_undefined] = ACTIONS(2474),
    [anon_sym_AT] = ACTIONS(2472),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_get] = ACTIONS(2474),
    [anon_sym_set] = ACTIONS(2474),
    [anon_sym_declare] = ACTIONS(2474),
    [anon_sym_public] = ACTIONS(2474),
    [anon_sym_private] = ACTIONS(2474),
    [anon_sym_protected] = ACTIONS(2474),
    [anon_sym_module] = ACTIONS(2474),
    [anon_sym_any] = ACTIONS(2474),
    [anon_sym_number] = ACTIONS(2474),
    [anon_sym_boolean] = ACTIONS(2474),
    [anon_sym_string] = ACTIONS(2474),
    [anon_sym_symbol] = ACTIONS(2474),
    [anon_sym_interface] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [sym_readonly] = ACTIONS(2474),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(2476),
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_export] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_namespace] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_type] = ACTIONS(2478),
    [anon_sym_typeof] = ACTIONS(2478),
    [anon_sym_import] = ACTIONS(2478),
    [anon_sym_var] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_else] = ACTIONS(2478),
    [anon_sym_switch] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_RPAREN] = ACTIONS(2476),
    [anon_sym_await] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_do] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [anon_sym_with] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_debugger] = ACTIONS(2478),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_throw] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_case] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_GT] = ACTIONS(2476),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_class] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_function] = ACTIONS(2478),
    [anon_sym_EQ_GT] = ACTIONS(2476),
    [anon_sym_new] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_TILDE] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [sym_number] = ACTIONS(2476),
    [sym_this] = ACTIONS(2478),
    [sym_super] = ACTIONS(2478),
    [sym_true] = ACTIONS(2478),
    [sym_false] = ACTIONS(2478),
    [sym_null] = ACTIONS(2478),
    [sym_undefined] = ACTIONS(2478),
    [anon_sym_AT] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_abstract] = ACTIONS(2478),
    [anon_sym_get] = ACTIONS(2478),
    [anon_sym_set] = ACTIONS(2478),
    [anon_sym_declare] = ACTIONS(2478),
    [anon_sym_public] = ACTIONS(2478),
    [anon_sym_private] = ACTIONS(2478),
    [anon_sym_protected] = ACTIONS(2478),
    [anon_sym_module] = ACTIONS(2478),
    [anon_sym_any] = ACTIONS(2478),
    [anon_sym_number] = ACTIONS(2478),
    [anon_sym_boolean] = ACTIONS(2478),
    [anon_sym_string] = ACTIONS(2478),
    [anon_sym_symbol] = ACTIONS(2478),
    [anon_sym_interface] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
    [sym_readonly] = ACTIONS(2478),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(2480),
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_RPAREN] = ACTIONS(2480),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_RBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2480),
    [anon_sym_GT] = ACTIONS(2480),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_EQ_GT] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [sym_number] = ACTIONS(2480),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [sym_readonly] = ACTIONS(2482),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(2486),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_typeof] = ACTIONS(2488),
    [anon_sym_import] = ACTIONS(2488),
    [anon_sym_var] = ACTIONS(2488),
    [anon_sym_let] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_else] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_RPAREN] = ACTIONS(2486),
    [anon_sym_await] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_with] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_debugger] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_yield] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_RBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(2486),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_function] = ACTIONS(2488),
    [anon_sym_EQ_GT] = ACTIONS(2486),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2486),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [sym_number] = ACTIONS(2486),
    [sym_this] = ACTIONS(2488),
    [sym_super] = ACTIONS(2488),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [sym_null] = ACTIONS(2488),
    [sym_undefined] = ACTIONS(2488),
    [anon_sym_AT] = ACTIONS(2486),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_abstract] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_interface] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2488),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(2490),
    [sym_identifier] = ACTIONS(2492),
    [anon_sym_export] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_EQ] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_type] = ACTIONS(2492),
    [anon_sym_typeof] = ACTIONS(2492),
    [anon_sym_import] = ACTIONS(2492),
    [anon_sym_var] = ACTIONS(2492),
    [anon_sym_let] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_else] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_await] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_with] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_debugger] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_yield] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_RBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(2490),
    [anon_sym_GT] = ACTIONS(2490),
    [anon_sym_SLASH] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_async] = ACTIONS(2492),
    [anon_sym_function] = ACTIONS(2492),
    [anon_sym_EQ_GT] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PIPE] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_void] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2490),
    [sym_number] = ACTIONS(2490),
    [sym_this] = ACTIONS(2492),
    [sym_super] = ACTIONS(2492),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [sym_null] = ACTIONS(2492),
    [sym_undefined] = ACTIONS(2492),
    [anon_sym_AT] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_abstract] = ACTIONS(2492),
    [anon_sym_get] = ACTIONS(2492),
    [anon_sym_set] = ACTIONS(2492),
    [anon_sym_declare] = ACTIONS(2492),
    [anon_sym_public] = ACTIONS(2492),
    [anon_sym_private] = ACTIONS(2492),
    [anon_sym_protected] = ACTIONS(2492),
    [anon_sym_module] = ACTIONS(2492),
    [anon_sym_any] = ACTIONS(2492),
    [anon_sym_number] = ACTIONS(2492),
    [anon_sym_boolean] = ACTIONS(2492),
    [anon_sym_string] = ACTIONS(2492),
    [anon_sym_symbol] = ACTIONS(2492),
    [anon_sym_interface] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [sym_readonly] = ACTIONS(2492),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(2494),
    [sym_identifier] = ACTIONS(2496),
    [anon_sym_export] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_EQ] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_type] = ACTIONS(2496),
    [anon_sym_typeof] = ACTIONS(2496),
    [anon_sym_import] = ACTIONS(2496),
    [anon_sym_var] = ACTIONS(2496),
    [anon_sym_let] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_else] = ACTIONS(2496),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2494),
    [anon_sym_await] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_with] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_debugger] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_yield] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [anon_sym_RBRACK] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_SLASH] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_async] = ACTIONS(2496),
    [anon_sym_function] = ACTIONS(2496),
    [anon_sym_EQ_GT] = ACTIONS(2494),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_void] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2494),
    [sym_number] = ACTIONS(2494),
    [sym_this] = ACTIONS(2496),
    [sym_super] = ACTIONS(2496),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [sym_null] = ACTIONS(2496),
    [sym_undefined] = ACTIONS(2496),
    [anon_sym_AT] = ACTIONS(2494),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_abstract] = ACTIONS(2496),
    [anon_sym_get] = ACTIONS(2496),
    [anon_sym_set] = ACTIONS(2496),
    [anon_sym_declare] = ACTIONS(2496),
    [anon_sym_public] = ACTIONS(2496),
    [anon_sym_private] = ACTIONS(2496),
    [anon_sym_protected] = ACTIONS(2496),
    [anon_sym_module] = ACTIONS(2496),
    [anon_sym_any] = ACTIONS(2496),
    [anon_sym_number] = ACTIONS(2496),
    [anon_sym_boolean] = ACTIONS(2496),
    [anon_sym_string] = ACTIONS(2496),
    [anon_sym_symbol] = ACTIONS(2496),
    [anon_sym_interface] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [sym_readonly] = ACTIONS(2496),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(2498),
    [sym_identifier] = ACTIONS(2500),
    [anon_sym_export] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_EQ] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_type] = ACTIONS(2500),
    [anon_sym_typeof] = ACTIONS(2500),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_var] = ACTIONS(2500),
    [anon_sym_let] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_else] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_RPAREN] = ACTIONS(2498),
    [anon_sym_await] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_with] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_debugger] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_yield] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_RBRACK] = ACTIONS(2498),
    [anon_sym_LT] = ACTIONS(2498),
    [anon_sym_GT] = ACTIONS(2498),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_async] = ACTIONS(2500),
    [anon_sym_function] = ACTIONS(2500),
    [anon_sym_EQ_GT] = ACTIONS(2498),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_PIPE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_void] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2498),
    [sym_number] = ACTIONS(2498),
    [sym_this] = ACTIONS(2500),
    [sym_super] = ACTIONS(2500),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [sym_null] = ACTIONS(2500),
    [sym_undefined] = ACTIONS(2500),
    [anon_sym_AT] = ACTIONS(2498),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_abstract] = ACTIONS(2500),
    [anon_sym_get] = ACTIONS(2500),
    [anon_sym_set] = ACTIONS(2500),
    [anon_sym_declare] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_module] = ACTIONS(2500),
    [anon_sym_any] = ACTIONS(2500),
    [anon_sym_number] = ACTIONS(2500),
    [anon_sym_boolean] = ACTIONS(2500),
    [anon_sym_string] = ACTIONS(2500),
    [anon_sym_symbol] = ACTIONS(2500),
    [anon_sym_interface] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [sym_readonly] = ACTIONS(2500),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2504),
    [anon_sym_export] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_EQ] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_type] = ACTIONS(2504),
    [anon_sym_typeof] = ACTIONS(2504),
    [anon_sym_import] = ACTIONS(2504),
    [anon_sym_var] = ACTIONS(2504),
    [anon_sym_let] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_with] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_debugger] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_yield] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_SLASH] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_async] = ACTIONS(2504),
    [anon_sym_function] = ACTIONS(2504),
    [anon_sym_EQ_GT] = ACTIONS(2502),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_AMP] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_void] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [sym_number] = ACTIONS(2502),
    [sym_this] = ACTIONS(2504),
    [sym_super] = ACTIONS(2504),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [sym_null] = ACTIONS(2504),
    [sym_undefined] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(2502),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_abstract] = ACTIONS(2504),
    [anon_sym_get] = ACTIONS(2504),
    [anon_sym_set] = ACTIONS(2504),
    [anon_sym_declare] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_module] = ACTIONS(2504),
    [anon_sym_any] = ACTIONS(2504),
    [anon_sym_number] = ACTIONS(2504),
    [anon_sym_boolean] = ACTIONS(2504),
    [anon_sym_string] = ACTIONS(2504),
    [anon_sym_symbol] = ACTIONS(2504),
    [anon_sym_interface] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [sym_readonly] = ACTIONS(2504),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(2508),
    [anon_sym_export] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_namespace] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_type] = ACTIONS(2508),
    [anon_sym_typeof] = ACTIONS(2508),
    [anon_sym_import] = ACTIONS(2508),
    [anon_sym_var] = ACTIONS(2508),
    [anon_sym_let] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_else] = ACTIONS(2508),
    [anon_sym_switch] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_await] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [anon_sym_with] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_debugger] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_throw] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_case] = ACTIONS(2508),
    [anon_sym_yield] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_async] = ACTIONS(2508),
    [anon_sym_function] = ACTIONS(2508),
    [anon_sym_EQ_GT] = ACTIONS(2506),
    [anon_sym_new] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_void] = ACTIONS(2508),
    [anon_sym_delete] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [sym_number] = ACTIONS(2506),
    [sym_this] = ACTIONS(2508),
    [sym_super] = ACTIONS(2508),
    [sym_true] = ACTIONS(2508),
    [sym_false] = ACTIONS(2508),
    [sym_null] = ACTIONS(2508),
    [sym_undefined] = ACTIONS(2508),
    [anon_sym_AT] = ACTIONS(2506),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_abstract] = ACTIONS(2508),
    [anon_sym_get] = ACTIONS(2508),
    [anon_sym_set] = ACTIONS(2508),
    [anon_sym_declare] = ACTIONS(2508),
    [anon_sym_public] = ACTIONS(2508),
    [anon_sym_private] = ACTIONS(2508),
    [anon_sym_protected] = ACTIONS(2508),
    [anon_sym_module] = ACTIONS(2508),
    [anon_sym_any] = ACTIONS(2508),
    [anon_sym_number] = ACTIONS(2508),
    [anon_sym_boolean] = ACTIONS(2508),
    [anon_sym_string] = ACTIONS(2508),
    [anon_sym_symbol] = ACTIONS(2508),
    [anon_sym_interface] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [sym_readonly] = ACTIONS(2508),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(617),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_namespace] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_type] = ACTIONS(2510),
    [anon_sym_typeof] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_var] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_else] = ACTIONS(2510),
    [anon_sym_switch] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_await] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_with] = ACTIONS(2510),
    [anon_sym_break] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(2510),
    [anon_sym_debugger] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_throw] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_case] = ACTIONS(2510),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(617),
    [anon_sym_GT] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_async] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_EQ_GT] = ACTIONS(617),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_void] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(617),
    [anon_sym_DASH_DASH] = ACTIONS(617),
    [anon_sym_DQUOTE] = ACTIONS(617),
    [anon_sym_SQUOTE] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [sym_number] = ACTIONS(617),
    [sym_this] = ACTIONS(2510),
    [sym_super] = ACTIONS(2510),
    [sym_true] = ACTIONS(2510),
    [sym_false] = ACTIONS(2510),
    [sym_null] = ACTIONS(2510),
    [sym_undefined] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(617),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_get] = ACTIONS(2510),
    [anon_sym_set] = ACTIONS(2510),
    [anon_sym_declare] = ACTIONS(2510),
    [anon_sym_public] = ACTIONS(2510),
    [anon_sym_private] = ACTIONS(2510),
    [anon_sym_protected] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_any] = ACTIONS(2510),
    [anon_sym_number] = ACTIONS(2510),
    [anon_sym_boolean] = ACTIONS(2510),
    [anon_sym_string] = ACTIONS(2510),
    [anon_sym_symbol] = ACTIONS(2510),
    [anon_sym_interface] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [sym_readonly] = ACTIONS(2510),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(2512),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_default] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_case] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2512),
    [anon_sym_GT] = ACTIONS(2512),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_EQ_GT] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [sym_number] = ACTIONS(2512),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
    [sym_readonly] = ACTIONS(2514),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(2516),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_default] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2518),
    [anon_sym_namespace] = ACTIONS(2518),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_type] = ACTIONS(2518),
    [anon_sym_typeof] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_var] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_switch] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_RPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_with] = ACTIONS(2518),
    [anon_sym_break] = ACTIONS(2518),
    [anon_sym_continue] = ACTIONS(2518),
    [anon_sym_debugger] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_throw] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_case] = ACTIONS(2518),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_RBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2516),
    [anon_sym_GT] = ACTIONS(2516),
    [anon_sym_SLASH] = ACTIONS(2518),
    [anon_sym_class] = ACTIONS(2518),
    [anon_sym_async] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_EQ_GT] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2518),
    [anon_sym_delete] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2518),
    [sym_super] = ACTIONS(2518),
    [sym_true] = ACTIONS(2518),
    [sym_false] = ACTIONS(2518),
    [sym_null] = ACTIONS(2518),
    [sym_undefined] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_get] = ACTIONS(2518),
    [anon_sym_set] = ACTIONS(2518),
    [anon_sym_declare] = ACTIONS(2518),
    [anon_sym_public] = ACTIONS(2518),
    [anon_sym_private] = ACTIONS(2518),
    [anon_sym_protected] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_any] = ACTIONS(2518),
    [anon_sym_number] = ACTIONS(2518),
    [anon_sym_boolean] = ACTIONS(2518),
    [anon_sym_string] = ACTIONS(2518),
    [anon_sym_symbol] = ACTIONS(2518),
    [anon_sym_interface] = ACTIONS(2518),
    [anon_sym_enum] = ACTIONS(2518),
    [sym_readonly] = ACTIONS(2518),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(2520),
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_default] = ACTIONS(2522),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_namespace] = ACTIONS(2522),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_type] = ACTIONS(2522),
    [anon_sym_typeof] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_var] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_switch] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_await] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_with] = ACTIONS(2522),
    [anon_sym_break] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(2522),
    [anon_sym_debugger] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_throw] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_case] = ACTIONS(2522),
    [anon_sym_yield] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_RBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2520),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_SLASH] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_EQ_GT] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2520),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_void] = ACTIONS(2522),
    [anon_sym_delete] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [sym_number] = ACTIONS(2520),
    [sym_this] = ACTIONS(2522),
    [sym_super] = ACTIONS(2522),
    [sym_true] = ACTIONS(2522),
    [sym_false] = ACTIONS(2522),
    [sym_null] = ACTIONS(2522),
    [sym_undefined] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_get] = ACTIONS(2522),
    [anon_sym_set] = ACTIONS(2522),
    [anon_sym_declare] = ACTIONS(2522),
    [anon_sym_public] = ACTIONS(2522),
    [anon_sym_private] = ACTIONS(2522),
    [anon_sym_protected] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_interface] = ACTIONS(2522),
    [anon_sym_enum] = ACTIONS(2522),
    [sym_readonly] = ACTIONS(2522),
  },
  [450] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [451] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [452] = {
    [sym_type_arguments] = STATE(425),
    [ts_builtin_sym_end] = ACTIONS(2532),
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_default] = ACTIONS(2534),
    [anon_sym_namespace] = ACTIONS(2534),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_type] = ACTIONS(2534),
    [anon_sym_typeof] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_var] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_switch] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_await] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_with] = ACTIONS(2534),
    [anon_sym_break] = ACTIONS(2534),
    [anon_sym_continue] = ACTIONS(2534),
    [anon_sym_debugger] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_throw] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2534),
    [anon_sym_yield] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(2438),
    [anon_sym_class] = ACTIONS(2534),
    [anon_sym_async] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_new] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_TILDE] = ACTIONS(2532),
    [anon_sym_void] = ACTIONS(2534),
    [anon_sym_delete] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [sym_number] = ACTIONS(2532),
    [sym_this] = ACTIONS(2534),
    [sym_super] = ACTIONS(2534),
    [sym_true] = ACTIONS(2534),
    [sym_false] = ACTIONS(2534),
    [sym_null] = ACTIONS(2534),
    [sym_undefined] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_get] = ACTIONS(2534),
    [anon_sym_set] = ACTIONS(2534),
    [anon_sym_declare] = ACTIONS(2534),
    [anon_sym_public] = ACTIONS(2534),
    [anon_sym_private] = ACTIONS(2534),
    [anon_sym_protected] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_any] = ACTIONS(2534),
    [anon_sym_number] = ACTIONS(2534),
    [anon_sym_boolean] = ACTIONS(2534),
    [anon_sym_string] = ACTIONS(2534),
    [anon_sym_symbol] = ACTIONS(2534),
    [anon_sym_interface] = ACTIONS(2534),
    [anon_sym_enum] = ACTIONS(2534),
    [sym_readonly] = ACTIONS(2534),
    [anon_sym_is] = ACTIONS(2539),
  },
  [453] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [454] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [455] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [456] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [457] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [458] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [459] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(2541),
    [sym_identifier] = ACTIONS(2543),
    [anon_sym_export] = ACTIONS(2543),
    [anon_sym_default] = ACTIONS(2543),
    [anon_sym_namespace] = ACTIONS(2543),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(2541),
    [anon_sym_RBRACE] = ACTIONS(2541),
    [anon_sym_type] = ACTIONS(2543),
    [anon_sym_typeof] = ACTIONS(2543),
    [anon_sym_import] = ACTIONS(2543),
    [anon_sym_var] = ACTIONS(2543),
    [anon_sym_let] = ACTIONS(2543),
    [anon_sym_const] = ACTIONS(2543),
    [anon_sym_if] = ACTIONS(2543),
    [anon_sym_else] = ACTIONS(2543),
    [anon_sym_switch] = ACTIONS(2543),
    [anon_sym_for] = ACTIONS(2543),
    [anon_sym_LPAREN] = ACTIONS(2541),
    [anon_sym_await] = ACTIONS(2543),
    [anon_sym_while] = ACTIONS(2543),
    [anon_sym_do] = ACTIONS(2543),
    [anon_sym_try] = ACTIONS(2543),
    [anon_sym_with] = ACTIONS(2543),
    [anon_sym_break] = ACTIONS(2543),
    [anon_sym_continue] = ACTIONS(2543),
    [anon_sym_debugger] = ACTIONS(2543),
    [anon_sym_return] = ACTIONS(2543),
    [anon_sym_throw] = ACTIONS(2543),
    [anon_sym_SEMI] = ACTIONS(2541),
    [anon_sym_case] = ACTIONS(2543),
    [anon_sym_yield] = ACTIONS(2543),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_LT] = ACTIONS(2541),
    [anon_sym_SLASH] = ACTIONS(2543),
    [anon_sym_class] = ACTIONS(2543),
    [anon_sym_async] = ACTIONS(2543),
    [anon_sym_function] = ACTIONS(2543),
    [anon_sym_new] = ACTIONS(2543),
    [anon_sym_AMP] = ACTIONS(2541),
    [anon_sym_PIPE] = ACTIONS(2541),
    [anon_sym_PLUS] = ACTIONS(2543),
    [anon_sym_DASH] = ACTIONS(2543),
    [anon_sym_BANG] = ACTIONS(2541),
    [anon_sym_TILDE] = ACTIONS(2541),
    [anon_sym_void] = ACTIONS(2543),
    [anon_sym_delete] = ACTIONS(2543),
    [anon_sym_PLUS_PLUS] = ACTIONS(2541),
    [anon_sym_DASH_DASH] = ACTIONS(2541),
    [anon_sym_DQUOTE] = ACTIONS(2541),
    [anon_sym_SQUOTE] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [sym_number] = ACTIONS(2541),
    [sym_this] = ACTIONS(2543),
    [sym_super] = ACTIONS(2543),
    [sym_true] = ACTIONS(2543),
    [sym_false] = ACTIONS(2543),
    [sym_null] = ACTIONS(2543),
    [sym_undefined] = ACTIONS(2543),
    [anon_sym_AT] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2543),
    [anon_sym_abstract] = ACTIONS(2543),
    [anon_sym_get] = ACTIONS(2543),
    [anon_sym_set] = ACTIONS(2543),
    [anon_sym_declare] = ACTIONS(2543),
    [anon_sym_public] = ACTIONS(2543),
    [anon_sym_private] = ACTIONS(2543),
    [anon_sym_protected] = ACTIONS(2543),
    [anon_sym_module] = ACTIONS(2543),
    [anon_sym_any] = ACTIONS(2543),
    [anon_sym_number] = ACTIONS(2543),
    [anon_sym_boolean] = ACTIONS(2543),
    [anon_sym_string] = ACTIONS(2543),
    [anon_sym_symbol] = ACTIONS(2543),
    [anon_sym_implements] = ACTIONS(2543),
    [anon_sym_interface] = ACTIONS(2543),
    [anon_sym_enum] = ACTIONS(2543),
    [sym_readonly] = ACTIONS(2543),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(2545),
    [sym_identifier] = ACTIONS(2547),
    [anon_sym_export] = ACTIONS(2547),
    [anon_sym_default] = ACTIONS(2547),
    [anon_sym_namespace] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(2545),
    [anon_sym_type] = ACTIONS(2547),
    [anon_sym_typeof] = ACTIONS(2547),
    [anon_sym_import] = ACTIONS(2547),
    [anon_sym_var] = ACTIONS(2547),
    [anon_sym_let] = ACTIONS(2547),
    [anon_sym_const] = ACTIONS(2547),
    [anon_sym_if] = ACTIONS(2547),
    [anon_sym_else] = ACTIONS(2547),
    [anon_sym_switch] = ACTIONS(2547),
    [anon_sym_for] = ACTIONS(2547),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_await] = ACTIONS(2547),
    [anon_sym_while] = ACTIONS(2547),
    [anon_sym_do] = ACTIONS(2547),
    [anon_sym_try] = ACTIONS(2547),
    [anon_sym_with] = ACTIONS(2547),
    [anon_sym_break] = ACTIONS(2547),
    [anon_sym_continue] = ACTIONS(2547),
    [anon_sym_debugger] = ACTIONS(2547),
    [anon_sym_return] = ACTIONS(2547),
    [anon_sym_throw] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2545),
    [anon_sym_case] = ACTIONS(2547),
    [anon_sym_yield] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_LT] = ACTIONS(2545),
    [anon_sym_SLASH] = ACTIONS(2547),
    [anon_sym_class] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2547),
    [anon_sym_function] = ACTIONS(2547),
    [anon_sym_new] = ACTIONS(2547),
    [anon_sym_AMP] = ACTIONS(2545),
    [anon_sym_PIPE] = ACTIONS(2545),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_BANG] = ACTIONS(2545),
    [anon_sym_TILDE] = ACTIONS(2545),
    [anon_sym_void] = ACTIONS(2547),
    [anon_sym_delete] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(2545),
    [anon_sym_DASH_DASH] = ACTIONS(2545),
    [anon_sym_DQUOTE] = ACTIONS(2545),
    [anon_sym_SQUOTE] = ACTIONS(2545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2545),
    [sym_number] = ACTIONS(2545),
    [sym_this] = ACTIONS(2547),
    [sym_super] = ACTIONS(2547),
    [sym_true] = ACTIONS(2547),
    [sym_false] = ACTIONS(2547),
    [sym_null] = ACTIONS(2547),
    [sym_undefined] = ACTIONS(2547),
    [anon_sym_AT] = ACTIONS(2545),
    [anon_sym_static] = ACTIONS(2547),
    [anon_sym_abstract] = ACTIONS(2547),
    [anon_sym_get] = ACTIONS(2547),
    [anon_sym_set] = ACTIONS(2547),
    [anon_sym_declare] = ACTIONS(2547),
    [anon_sym_public] = ACTIONS(2547),
    [anon_sym_private] = ACTIONS(2547),
    [anon_sym_protected] = ACTIONS(2547),
    [anon_sym_module] = ACTIONS(2547),
    [anon_sym_any] = ACTIONS(2547),
    [anon_sym_number] = ACTIONS(2547),
    [anon_sym_boolean] = ACTIONS(2547),
    [anon_sym_string] = ACTIONS(2547),
    [anon_sym_symbol] = ACTIONS(2547),
    [anon_sym_implements] = ACTIONS(2547),
    [anon_sym_interface] = ACTIONS(2547),
    [anon_sym_enum] = ACTIONS(2547),
    [sym_readonly] = ACTIONS(2547),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_catch] = ACTIONS(1135),
    [anon_sym_finally] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(2549),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_default] = ACTIONS(1105),
    [anon_sym_namespace] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_typeof] = ACTIONS(1105),
    [anon_sym_import] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_let] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1105),
    [anon_sym_try] = ACTIONS(1105),
    [anon_sym_with] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1105),
    [anon_sym_continue] = ACTIONS(1105),
    [anon_sym_debugger] = ACTIONS(1105),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_case] = ACTIONS(1105),
    [anon_sym_catch] = ACTIONS(1105),
    [anon_sym_finally] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_class] = ACTIONS(1105),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_function] = ACTIONS(1105),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_delete] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym_number] = ACTIONS(1103),
    [sym_this] = ACTIONS(1105),
    [sym_super] = ACTIONS(1105),
    [sym_true] = ACTIONS(1105),
    [sym_false] = ACTIONS(1105),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_static] = ACTIONS(1105),
    [anon_sym_abstract] = ACTIONS(1105),
    [anon_sym_get] = ACTIONS(1105),
    [anon_sym_set] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1105),
    [anon_sym_private] = ACTIONS(1105),
    [anon_sym_protected] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1105),
    [anon_sym_any] = ACTIONS(1105),
    [anon_sym_number] = ACTIONS(1105),
    [anon_sym_boolean] = ACTIONS(1105),
    [anon_sym_string] = ACTIONS(1105),
    [anon_sym_symbol] = ACTIONS(1105),
    [anon_sym_interface] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [sym_readonly] = ACTIONS(1105),
    [sym__automatic_semicolon] = ACTIONS(1111),
  },
  [464] = {
    [sym_catch_clause] = STATE(490),
    [sym_finally_clause] = STATE(607),
    [ts_builtin_sym_end] = ACTIONS(2551),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_export] = ACTIONS(2553),
    [anon_sym_default] = ACTIONS(2553),
    [anon_sym_namespace] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2551),
    [anon_sym_RBRACE] = ACTIONS(2551),
    [anon_sym_type] = ACTIONS(2553),
    [anon_sym_typeof] = ACTIONS(2553),
    [anon_sym_import] = ACTIONS(2553),
    [anon_sym_var] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_else] = ACTIONS(2553),
    [anon_sym_switch] = ACTIONS(2553),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_await] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_with] = ACTIONS(2553),
    [anon_sym_break] = ACTIONS(2553),
    [anon_sym_continue] = ACTIONS(2553),
    [anon_sym_debugger] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_throw] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_case] = ACTIONS(2553),
    [anon_sym_catch] = ACTIONS(2555),
    [anon_sym_finally] = ACTIONS(2557),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2551),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_BANG] = ACTIONS(2551),
    [anon_sym_TILDE] = ACTIONS(2551),
    [anon_sym_void] = ACTIONS(2553),
    [anon_sym_delete] = ACTIONS(2553),
    [anon_sym_PLUS_PLUS] = ACTIONS(2551),
    [anon_sym_DASH_DASH] = ACTIONS(2551),
    [anon_sym_DQUOTE] = ACTIONS(2551),
    [anon_sym_SQUOTE] = ACTIONS(2551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2551),
    [sym_number] = ACTIONS(2551),
    [sym_this] = ACTIONS(2553),
    [sym_super] = ACTIONS(2553),
    [sym_true] = ACTIONS(2553),
    [sym_false] = ACTIONS(2553),
    [sym_null] = ACTIONS(2553),
    [sym_undefined] = ACTIONS(2553),
    [anon_sym_AT] = ACTIONS(2551),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_abstract] = ACTIONS(2553),
    [anon_sym_get] = ACTIONS(2553),
    [anon_sym_set] = ACTIONS(2553),
    [anon_sym_declare] = ACTIONS(2553),
    [anon_sym_public] = ACTIONS(2553),
    [anon_sym_private] = ACTIONS(2553),
    [anon_sym_protected] = ACTIONS(2553),
    [anon_sym_module] = ACTIONS(2553),
    [anon_sym_any] = ACTIONS(2553),
    [anon_sym_number] = ACTIONS(2553),
    [anon_sym_boolean] = ACTIONS(2553),
    [anon_sym_string] = ACTIONS(2553),
    [anon_sym_symbol] = ACTIONS(2553),
    [anon_sym_interface] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [sym_readonly] = ACTIONS(2553),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(2559),
    [sym_identifier] = ACTIONS(2561),
    [anon_sym_export] = ACTIONS(2561),
    [anon_sym_default] = ACTIONS(2561),
    [anon_sym_namespace] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(2559),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_RBRACE] = ACTIONS(2559),
    [anon_sym_type] = ACTIONS(2561),
    [anon_sym_typeof] = ACTIONS(2561),
    [anon_sym_import] = ACTIONS(2561),
    [anon_sym_var] = ACTIONS(2561),
    [anon_sym_let] = ACTIONS(2561),
    [anon_sym_const] = ACTIONS(2561),
    [anon_sym_if] = ACTIONS(2561),
    [anon_sym_else] = ACTIONS(2561),
    [anon_sym_switch] = ACTIONS(2561),
    [anon_sym_for] = ACTIONS(2561),
    [anon_sym_LPAREN] = ACTIONS(2559),
    [anon_sym_await] = ACTIONS(2561),
    [anon_sym_while] = ACTIONS(2561),
    [anon_sym_do] = ACTIONS(2561),
    [anon_sym_try] = ACTIONS(2561),
    [anon_sym_with] = ACTIONS(2561),
    [anon_sym_break] = ACTIONS(2561),
    [anon_sym_continue] = ACTIONS(2561),
    [anon_sym_debugger] = ACTIONS(2561),
    [anon_sym_return] = ACTIONS(2561),
    [anon_sym_throw] = ACTIONS(2561),
    [anon_sym_SEMI] = ACTIONS(2559),
    [anon_sym_case] = ACTIONS(2561),
    [anon_sym_yield] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2559),
    [anon_sym_SLASH] = ACTIONS(2561),
    [anon_sym_class] = ACTIONS(2561),
    [anon_sym_async] = ACTIONS(2561),
    [anon_sym_function] = ACTIONS(2561),
    [anon_sym_new] = ACTIONS(2561),
    [anon_sym_AMP] = ACTIONS(2559),
    [anon_sym_PIPE] = ACTIONS(2559),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_BANG] = ACTIONS(2559),
    [anon_sym_TILDE] = ACTIONS(2559),
    [anon_sym_void] = ACTIONS(2561),
    [anon_sym_delete] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(2559),
    [anon_sym_DASH_DASH] = ACTIONS(2559),
    [anon_sym_DQUOTE] = ACTIONS(2559),
    [anon_sym_SQUOTE] = ACTIONS(2559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2559),
    [sym_number] = ACTIONS(2559),
    [sym_this] = ACTIONS(2561),
    [sym_super] = ACTIONS(2561),
    [sym_true] = ACTIONS(2561),
    [sym_false] = ACTIONS(2561),
    [sym_null] = ACTIONS(2561),
    [sym_undefined] = ACTIONS(2561),
    [anon_sym_AT] = ACTIONS(2559),
    [anon_sym_static] = ACTIONS(2561),
    [anon_sym_abstract] = ACTIONS(2561),
    [anon_sym_get] = ACTIONS(2561),
    [anon_sym_set] = ACTIONS(2561),
    [anon_sym_declare] = ACTIONS(2561),
    [anon_sym_public] = ACTIONS(2561),
    [anon_sym_private] = ACTIONS(2561),
    [anon_sym_protected] = ACTIONS(2561),
    [anon_sym_module] = ACTIONS(2561),
    [anon_sym_any] = ACTIONS(2561),
    [anon_sym_number] = ACTIONS(2561),
    [anon_sym_boolean] = ACTIONS(2561),
    [anon_sym_string] = ACTIONS(2561),
    [anon_sym_symbol] = ACTIONS(2561),
    [anon_sym_implements] = ACTIONS(2561),
    [anon_sym_interface] = ACTIONS(2561),
    [anon_sym_enum] = ACTIONS(2561),
    [sym_readonly] = ACTIONS(2561),
  },
  [466] = {
    [ts_builtin_sym_end] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_export] = ACTIONS(1151),
    [anon_sym_default] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(1151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_import] = ACTIONS(1151),
    [anon_sym_var] = ACTIONS(1151),
    [anon_sym_let] = ACTIONS(1151),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1151),
    [anon_sym_else] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1151),
    [anon_sym_for] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1151),
    [anon_sym_while] = ACTIONS(1151),
    [anon_sym_do] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1151),
    [anon_sym_with] = ACTIONS(1151),
    [anon_sym_break] = ACTIONS(1151),
    [anon_sym_continue] = ACTIONS(1151),
    [anon_sym_debugger] = ACTIONS(1151),
    [anon_sym_return] = ACTIONS(1151),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1151),
    [anon_sym_yield] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_class] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(1151),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1149),
    [anon_sym_void] = ACTIONS(1151),
    [anon_sym_delete] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_SQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym_number] = ACTIONS(1149),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(1151),
    [sym_true] = ACTIONS(1151),
    [sym_false] = ACTIONS(1151),
    [sym_null] = ACTIONS(1151),
    [sym_undefined] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1151),
    [anon_sym_abstract] = ACTIONS(1151),
    [anon_sym_get] = ACTIONS(1151),
    [anon_sym_set] = ACTIONS(1151),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1151),
    [anon_sym_private] = ACTIONS(1151),
    [anon_sym_protected] = ACTIONS(1151),
    [anon_sym_module] = ACTIONS(1151),
    [anon_sym_any] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1151),
    [anon_sym_boolean] = ACTIONS(1151),
    [anon_sym_string] = ACTIONS(1151),
    [anon_sym_symbol] = ACTIONS(1151),
    [anon_sym_interface] = ACTIONS(1151),
    [anon_sym_enum] = ACTIONS(1151),
    [sym_readonly] = ACTIONS(1151),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1149),
    [sym__automatic_semicolon] = ACTIONS(1149),
  },
  [467] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_default] = ACTIONS(1215),
    [anon_sym_namespace] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1215),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_let] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_do] = ACTIONS(1215),
    [anon_sym_try] = ACTIONS(1215),
    [anon_sym_with] = ACTIONS(1215),
    [anon_sym_break] = ACTIONS(1215),
    [anon_sym_continue] = ACTIONS(1215),
    [anon_sym_debugger] = ACTIONS(1215),
    [anon_sym_return] = ACTIONS(1215),
    [anon_sym_throw] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1215),
    [anon_sym_yield] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_class] = ACTIONS(1215),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(1215),
    [anon_sym_new] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [sym_number] = ACTIONS(1213),
    [sym_this] = ACTIONS(1215),
    [sym_super] = ACTIONS(1215),
    [sym_true] = ACTIONS(1215),
    [sym_false] = ACTIONS(1215),
    [sym_null] = ACTIONS(1215),
    [sym_undefined] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1215),
    [anon_sym_abstract] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(1215),
    [anon_sym_set] = ACTIONS(1215),
    [anon_sym_declare] = ACTIONS(1215),
    [anon_sym_public] = ACTIONS(1215),
    [anon_sym_private] = ACTIONS(1215),
    [anon_sym_protected] = ACTIONS(1215),
    [anon_sym_module] = ACTIONS(1215),
    [anon_sym_any] = ACTIONS(1215),
    [anon_sym_number] = ACTIONS(1215),
    [anon_sym_boolean] = ACTIONS(1215),
    [anon_sym_string] = ACTIONS(1215),
    [anon_sym_symbol] = ACTIONS(1215),
    [anon_sym_interface] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [sym_readonly] = ACTIONS(1215),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1213),
    [sym__automatic_semicolon] = ACTIONS(1213),
  },
  [468] = {
    [sym__call_signature] = STATE(3113),
    [sym_arguments] = STATE(1033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [469] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2686),
    [sym_constructor_type] = STATE(2686),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2686),
    [sym_intersection_type] = STATE(2686),
    [sym_function_type] = STATE(2686),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(1103),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_default] = ACTIONS(1105),
    [anon_sym_namespace] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_typeof] = ACTIONS(1105),
    [anon_sym_import] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_let] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_do] = ACTIONS(1105),
    [anon_sym_try] = ACTIONS(1105),
    [anon_sym_with] = ACTIONS(1105),
    [anon_sym_break] = ACTIONS(1105),
    [anon_sym_continue] = ACTIONS(1105),
    [anon_sym_debugger] = ACTIONS(1105),
    [anon_sym_return] = ACTIONS(1105),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_case] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_class] = ACTIONS(1105),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_function] = ACTIONS(1105),
    [anon_sym_new] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_TILDE] = ACTIONS(1103),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_delete] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym_number] = ACTIONS(1103),
    [sym_this] = ACTIONS(1105),
    [sym_super] = ACTIONS(1105),
    [sym_true] = ACTIONS(1105),
    [sym_false] = ACTIONS(1105),
    [sym_null] = ACTIONS(1105),
    [sym_undefined] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_static] = ACTIONS(1105),
    [anon_sym_abstract] = ACTIONS(1105),
    [anon_sym_get] = ACTIONS(1105),
    [anon_sym_set] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1105),
    [anon_sym_private] = ACTIONS(1105),
    [anon_sym_protected] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1105),
    [anon_sym_any] = ACTIONS(1105),
    [anon_sym_number] = ACTIONS(1105),
    [anon_sym_boolean] = ACTIONS(1105),
    [anon_sym_string] = ACTIONS(1105),
    [anon_sym_symbol] = ACTIONS(1105),
    [anon_sym_interface] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [sym_readonly] = ACTIONS(1105),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(2601),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_default] = ACTIONS(1215),
    [anon_sym_namespace] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1215),
    [anon_sym_typeof] = ACTIONS(1215),
    [anon_sym_import] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_let] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_await] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_do] = ACTIONS(1215),
    [anon_sym_try] = ACTIONS(1215),
    [anon_sym_with] = ACTIONS(1215),
    [anon_sym_break] = ACTIONS(1215),
    [anon_sym_continue] = ACTIONS(1215),
    [anon_sym_debugger] = ACTIONS(1215),
    [anon_sym_return] = ACTIONS(1215),
    [anon_sym_throw] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_case] = ACTIONS(1215),
    [anon_sym_catch] = ACTIONS(1215),
    [anon_sym_finally] = ACTIONS(1215),
    [anon_sym_yield] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_class] = ACTIONS(1215),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_function] = ACTIONS(1215),
    [anon_sym_new] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_TILDE] = ACTIONS(1213),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_delete] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [sym_number] = ACTIONS(1213),
    [sym_this] = ACTIONS(1215),
    [sym_super] = ACTIONS(1215),
    [sym_true] = ACTIONS(1215),
    [sym_false] = ACTIONS(1215),
    [sym_null] = ACTIONS(1215),
    [sym_undefined] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1215),
    [anon_sym_abstract] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(1215),
    [anon_sym_set] = ACTIONS(1215),
    [anon_sym_declare] = ACTIONS(1215),
    [anon_sym_public] = ACTIONS(1215),
    [anon_sym_private] = ACTIONS(1215),
    [anon_sym_protected] = ACTIONS(1215),
    [anon_sym_module] = ACTIONS(1215),
    [anon_sym_any] = ACTIONS(1215),
    [anon_sym_number] = ACTIONS(1215),
    [anon_sym_boolean] = ACTIONS(1215),
    [anon_sym_string] = ACTIONS(1215),
    [anon_sym_symbol] = ACTIONS(1215),
    [anon_sym_interface] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [sym_readonly] = ACTIONS(1215),
  },
  [472] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1195),
    [sym__automatic_semicolon] = ACTIONS(1195),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(1235),
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_export] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_type] = ACTIONS(1237),
    [anon_sym_typeof] = ACTIONS(1237),
    [anon_sym_import] = ACTIONS(1237),
    [anon_sym_var] = ACTIONS(1237),
    [anon_sym_let] = ACTIONS(1237),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_await] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_do] = ACTIONS(1237),
    [anon_sym_try] = ACTIONS(1237),
    [anon_sym_with] = ACTIONS(1237),
    [anon_sym_break] = ACTIONS(1237),
    [anon_sym_continue] = ACTIONS(1237),
    [anon_sym_debugger] = ACTIONS(1237),
    [anon_sym_return] = ACTIONS(1237),
    [anon_sym_throw] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_yield] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_class] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1237),
    [anon_sym_function] = ACTIONS(1237),
    [anon_sym_new] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_void] = ACTIONS(1237),
    [anon_sym_delete] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_SQUOTE] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [sym_number] = ACTIONS(1235),
    [sym_this] = ACTIONS(1237),
    [sym_super] = ACTIONS(1237),
    [sym_true] = ACTIONS(1237),
    [sym_false] = ACTIONS(1237),
    [sym_null] = ACTIONS(1237),
    [sym_undefined] = ACTIONS(1237),
    [anon_sym_AT] = ACTIONS(1235),
    [anon_sym_static] = ACTIONS(1237),
    [anon_sym_abstract] = ACTIONS(1237),
    [anon_sym_get] = ACTIONS(1237),
    [anon_sym_set] = ACTIONS(1237),
    [anon_sym_declare] = ACTIONS(1237),
    [anon_sym_public] = ACTIONS(1237),
    [anon_sym_private] = ACTIONS(1237),
    [anon_sym_protected] = ACTIONS(1237),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_any] = ACTIONS(1237),
    [anon_sym_number] = ACTIONS(1237),
    [anon_sym_boolean] = ACTIONS(1237),
    [anon_sym_string] = ACTIONS(1237),
    [anon_sym_symbol] = ACTIONS(1237),
    [anon_sym_interface] = ACTIONS(1237),
    [anon_sym_enum] = ACTIONS(1237),
    [sym_readonly] = ACTIONS(1237),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(2603),
  },
  [475] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(2605),
    [sym_identifier] = ACTIONS(2607),
    [anon_sym_export] = ACTIONS(2607),
    [anon_sym_default] = ACTIONS(2607),
    [anon_sym_namespace] = ACTIONS(2607),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(2605),
    [anon_sym_type] = ACTIONS(2607),
    [anon_sym_typeof] = ACTIONS(2607),
    [anon_sym_import] = ACTIONS(2607),
    [anon_sym_var] = ACTIONS(2607),
    [anon_sym_let] = ACTIONS(2607),
    [anon_sym_const] = ACTIONS(2607),
    [anon_sym_if] = ACTIONS(2607),
    [anon_sym_else] = ACTIONS(2607),
    [anon_sym_switch] = ACTIONS(2607),
    [anon_sym_for] = ACTIONS(2607),
    [anon_sym_LPAREN] = ACTIONS(2605),
    [anon_sym_await] = ACTIONS(2607),
    [anon_sym_while] = ACTIONS(2607),
    [anon_sym_do] = ACTIONS(2607),
    [anon_sym_try] = ACTIONS(2607),
    [anon_sym_with] = ACTIONS(2607),
    [anon_sym_break] = ACTIONS(2607),
    [anon_sym_continue] = ACTIONS(2607),
    [anon_sym_debugger] = ACTIONS(2607),
    [anon_sym_return] = ACTIONS(2607),
    [anon_sym_throw] = ACTIONS(2607),
    [anon_sym_SEMI] = ACTIONS(2605),
    [anon_sym_case] = ACTIONS(2607),
    [anon_sym_yield] = ACTIONS(2607),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(2605),
    [anon_sym_SLASH] = ACTIONS(2607),
    [anon_sym_DOT] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2607),
    [anon_sym_async] = ACTIONS(2607),
    [anon_sym_function] = ACTIONS(2607),
    [anon_sym_new] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2605),
    [anon_sym_TILDE] = ACTIONS(2605),
    [anon_sym_void] = ACTIONS(2607),
    [anon_sym_delete] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2605),
    [anon_sym_DQUOTE] = ACTIONS(2605),
    [anon_sym_SQUOTE] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2605),
    [sym_number] = ACTIONS(2605),
    [sym_this] = ACTIONS(2607),
    [sym_super] = ACTIONS(2607),
    [sym_true] = ACTIONS(2607),
    [sym_false] = ACTIONS(2607),
    [sym_null] = ACTIONS(2607),
    [sym_undefined] = ACTIONS(2607),
    [anon_sym_AT] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2607),
    [anon_sym_abstract] = ACTIONS(2607),
    [anon_sym_get] = ACTIONS(2607),
    [anon_sym_set] = ACTIONS(2607),
    [anon_sym_declare] = ACTIONS(2607),
    [anon_sym_public] = ACTIONS(2607),
    [anon_sym_private] = ACTIONS(2607),
    [anon_sym_protected] = ACTIONS(2607),
    [anon_sym_module] = ACTIONS(2607),
    [anon_sym_any] = ACTIONS(2607),
    [anon_sym_number] = ACTIONS(2607),
    [anon_sym_boolean] = ACTIONS(2607),
    [anon_sym_string] = ACTIONS(2607),
    [anon_sym_symbol] = ACTIONS(2607),
    [anon_sym_interface] = ACTIONS(2607),
    [anon_sym_enum] = ACTIONS(2607),
    [sym_readonly] = ACTIONS(2607),
  },
  [477] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2747),
    [sym_constructor_type] = STATE(2747),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2747),
    [sym_intersection_type] = STATE(2747),
    [sym_function_type] = STATE(2747),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_catch] = ACTIONS(1135),
    [anon_sym_finally] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
  },
  [479] = {
    [sym_type_arguments] = STATE(423),
    [ts_builtin_sym_end] = ACTIONS(2611),
    [sym_identifier] = ACTIONS(2613),
    [anon_sym_export] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_type] = ACTIONS(2613),
    [anon_sym_typeof] = ACTIONS(2613),
    [anon_sym_import] = ACTIONS(2613),
    [anon_sym_var] = ACTIONS(2613),
    [anon_sym_let] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2613),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_LPAREN] = ACTIONS(2611),
    [anon_sym_await] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_with] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_debugger] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_yield] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(2615),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_async] = ACTIONS(2613),
    [anon_sym_function] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_void] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2611),
    [sym_number] = ACTIONS(2611),
    [sym_this] = ACTIONS(2613),
    [sym_super] = ACTIONS(2613),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [sym_null] = ACTIONS(2613),
    [sym_undefined] = ACTIONS(2613),
    [anon_sym_AT] = ACTIONS(2611),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_abstract] = ACTIONS(2613),
    [anon_sym_get] = ACTIONS(2613),
    [anon_sym_set] = ACTIONS(2613),
    [anon_sym_declare] = ACTIONS(2613),
    [anon_sym_public] = ACTIONS(2613),
    [anon_sym_private] = ACTIONS(2613),
    [anon_sym_protected] = ACTIONS(2613),
    [anon_sym_module] = ACTIONS(2613),
    [anon_sym_any] = ACTIONS(2613),
    [anon_sym_number] = ACTIONS(2613),
    [anon_sym_boolean] = ACTIONS(2613),
    [anon_sym_string] = ACTIONS(2613),
    [anon_sym_symbol] = ACTIONS(2613),
    [anon_sym_interface] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [sym_readonly] = ACTIONS(2613),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1133),
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_default] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_typeof] = ACTIONS(1135),
    [anon_sym_import] = ACTIONS(1135),
    [anon_sym_var] = ACTIONS(1135),
    [anon_sym_let] = ACTIONS(1135),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_await] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_do] = ACTIONS(1135),
    [anon_sym_try] = ACTIONS(1135),
    [anon_sym_with] = ACTIONS(1135),
    [anon_sym_break] = ACTIONS(1135),
    [anon_sym_continue] = ACTIONS(1135),
    [anon_sym_debugger] = ACTIONS(1135),
    [anon_sym_return] = ACTIONS(1135),
    [anon_sym_throw] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_case] = ACTIONS(1135),
    [anon_sym_yield] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_class] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_function] = ACTIONS(1135),
    [anon_sym_new] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1133),
    [anon_sym_TILDE] = ACTIONS(1133),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_delete] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym_number] = ACTIONS(1133),
    [sym_this] = ACTIONS(1135),
    [sym_super] = ACTIONS(1135),
    [sym_true] = ACTIONS(1135),
    [sym_false] = ACTIONS(1135),
    [sym_null] = ACTIONS(1135),
    [sym_undefined] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_interface] = ACTIONS(1135),
    [anon_sym_enum] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [481] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2580),
    [sym_constructor_type] = STATE(2580),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2580),
    [sym_intersection_type] = STATE(2580),
    [sym_function_type] = STATE(2580),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [482] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(3026),
    [sym_rest_parameter] = STATE(2632),
    [sym_nested_type_identifier] = STATE(1885),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [sym__type] = STATE(2621),
    [sym_constructor_type] = STATE(2621),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2621),
    [sym_intersection_type] = STATE(2621),
    [sym_function_type] = STATE(2621),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(2571),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(2589),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(2593),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2589),
    [anon_sym_number] = ACTIONS(2589),
    [anon_sym_boolean] = ACTIONS(2589),
    [anon_sym_string] = ACTIONS(2589),
    [anon_sym_symbol] = ACTIONS(2589),
    [sym_readonly] = ACTIONS(2599),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [483] = {
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(2622),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_export] = ACTIONS(2624),
    [anon_sym_default] = ACTIONS(2624),
    [anon_sym_namespace] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2624),
    [anon_sym_typeof] = ACTIONS(2624),
    [anon_sym_import] = ACTIONS(2624),
    [anon_sym_var] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_switch] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_await] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_with] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_continue] = ACTIONS(2624),
    [anon_sym_debugger] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_throw] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_async] = ACTIONS(2624),
    [anon_sym_function] = ACTIONS(2624),
    [anon_sym_new] = ACTIONS(2624),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2624),
    [anon_sym_delete] = ACTIONS(2624),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [anon_sym_DQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [sym_number] = ACTIONS(2622),
    [sym_this] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_null] = ACTIONS(2624),
    [sym_undefined] = ACTIONS(2624),
    [anon_sym_AT] = ACTIONS(2622),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_abstract] = ACTIONS(2624),
    [anon_sym_get] = ACTIONS(2624),
    [anon_sym_set] = ACTIONS(2624),
    [anon_sym_declare] = ACTIONS(2624),
    [anon_sym_public] = ACTIONS(2624),
    [anon_sym_private] = ACTIONS(2624),
    [anon_sym_protected] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_any] = ACTIONS(2624),
    [anon_sym_number] = ACTIONS(2624),
    [anon_sym_boolean] = ACTIONS(2624),
    [anon_sym_string] = ACTIONS(2624),
    [anon_sym_symbol] = ACTIONS(2624),
    [anon_sym_interface] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [sym_readonly] = ACTIONS(2624),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(2632),
    [anon_sym_default] = ACTIONS(2632),
    [anon_sym_namespace] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_type] = ACTIONS(2632),
    [anon_sym_typeof] = ACTIONS(2632),
    [anon_sym_import] = ACTIONS(2632),
    [anon_sym_var] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_switch] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_await] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_with] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_continue] = ACTIONS(2632),
    [anon_sym_debugger] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_throw] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_async] = ACTIONS(2632),
    [anon_sym_function] = ACTIONS(2632),
    [anon_sym_new] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_void] = ACTIONS(2632),
    [anon_sym_delete] = ACTIONS(2632),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2630),
    [sym_number] = ACTIONS(2630),
    [sym_this] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_null] = ACTIONS(2632),
    [sym_undefined] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_abstract] = ACTIONS(2632),
    [anon_sym_get] = ACTIONS(2632),
    [anon_sym_set] = ACTIONS(2632),
    [anon_sym_declare] = ACTIONS(2632),
    [anon_sym_public] = ACTIONS(2632),
    [anon_sym_private] = ACTIONS(2632),
    [anon_sym_protected] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_any] = ACTIONS(2632),
    [anon_sym_number] = ACTIONS(2632),
    [anon_sym_boolean] = ACTIONS(2632),
    [anon_sym_string] = ACTIONS(2632),
    [anon_sym_symbol] = ACTIONS(2632),
    [anon_sym_interface] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [sym_readonly] = ACTIONS(2632),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2636),
    [anon_sym_default] = ACTIONS(2636),
    [anon_sym_namespace] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_type] = ACTIONS(2636),
    [anon_sym_typeof] = ACTIONS(2636),
    [anon_sym_import] = ACTIONS(2636),
    [anon_sym_var] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2636),
    [anon_sym_switch] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_await] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_with] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_continue] = ACTIONS(2636),
    [anon_sym_debugger] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_throw] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_async] = ACTIONS(2636),
    [anon_sym_function] = ACTIONS(2636),
    [anon_sym_new] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_void] = ACTIONS(2636),
    [anon_sym_delete] = ACTIONS(2636),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2634),
    [sym_number] = ACTIONS(2634),
    [sym_this] = ACTIONS(2636),
    [sym_super] = ACTIONS(2636),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [sym_null] = ACTIONS(2636),
    [sym_undefined] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2634),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_abstract] = ACTIONS(2636),
    [anon_sym_get] = ACTIONS(2636),
    [anon_sym_set] = ACTIONS(2636),
    [anon_sym_declare] = ACTIONS(2636),
    [anon_sym_public] = ACTIONS(2636),
    [anon_sym_private] = ACTIONS(2636),
    [anon_sym_protected] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_any] = ACTIONS(2636),
    [anon_sym_number] = ACTIONS(2636),
    [anon_sym_boolean] = ACTIONS(2636),
    [anon_sym_string] = ACTIONS(2636),
    [anon_sym_symbol] = ACTIONS(2636),
    [anon_sym_interface] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [sym_readonly] = ACTIONS(2636),
  },
  [487] = {
    [sym__call_signature] = STATE(3113),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(2644),
    [sym_identifier] = ACTIONS(2646),
    [anon_sym_export] = ACTIONS(2646),
    [anon_sym_default] = ACTIONS(2646),
    [anon_sym_namespace] = ACTIONS(2646),
    [anon_sym_LBRACE] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_type] = ACTIONS(2646),
    [anon_sym_typeof] = ACTIONS(2646),
    [anon_sym_import] = ACTIONS(2646),
    [anon_sym_var] = ACTIONS(2646),
    [anon_sym_let] = ACTIONS(2646),
    [anon_sym_const] = ACTIONS(2646),
    [anon_sym_if] = ACTIONS(2646),
    [anon_sym_else] = ACTIONS(2646),
    [anon_sym_switch] = ACTIONS(2646),
    [anon_sym_for] = ACTIONS(2646),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_await] = ACTIONS(2646),
    [anon_sym_while] = ACTIONS(2646),
    [anon_sym_do] = ACTIONS(2646),
    [anon_sym_try] = ACTIONS(2646),
    [anon_sym_with] = ACTIONS(2646),
    [anon_sym_break] = ACTIONS(2646),
    [anon_sym_continue] = ACTIONS(2646),
    [anon_sym_debugger] = ACTIONS(2646),
    [anon_sym_return] = ACTIONS(2646),
    [anon_sym_throw] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2646),
    [anon_sym_yield] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_class] = ACTIONS(2646),
    [anon_sym_async] = ACTIONS(2646),
    [anon_sym_function] = ACTIONS(2646),
    [anon_sym_new] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_TILDE] = ACTIONS(2644),
    [anon_sym_void] = ACTIONS(2646),
    [anon_sym_delete] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_SQUOTE] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [sym_number] = ACTIONS(2644),
    [sym_this] = ACTIONS(2646),
    [sym_super] = ACTIONS(2646),
    [sym_true] = ACTIONS(2646),
    [sym_false] = ACTIONS(2646),
    [sym_null] = ACTIONS(2646),
    [sym_undefined] = ACTIONS(2646),
    [anon_sym_AT] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2646),
    [anon_sym_abstract] = ACTIONS(2646),
    [anon_sym_get] = ACTIONS(2646),
    [anon_sym_set] = ACTIONS(2646),
    [anon_sym_declare] = ACTIONS(2646),
    [anon_sym_public] = ACTIONS(2646),
    [anon_sym_private] = ACTIONS(2646),
    [anon_sym_protected] = ACTIONS(2646),
    [anon_sym_module] = ACTIONS(2646),
    [anon_sym_any] = ACTIONS(2646),
    [anon_sym_number] = ACTIONS(2646),
    [anon_sym_boolean] = ACTIONS(2646),
    [anon_sym_string] = ACTIONS(2646),
    [anon_sym_symbol] = ACTIONS(2646),
    [anon_sym_interface] = ACTIONS(2646),
    [anon_sym_enum] = ACTIONS(2646),
    [sym_readonly] = ACTIONS(2646),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(2648),
    [sym_identifier] = ACTIONS(2650),
    [anon_sym_export] = ACTIONS(2650),
    [anon_sym_default] = ACTIONS(2650),
    [anon_sym_namespace] = ACTIONS(2650),
    [anon_sym_LBRACE] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2648),
    [anon_sym_type] = ACTIONS(2650),
    [anon_sym_typeof] = ACTIONS(2650),
    [anon_sym_import] = ACTIONS(2650),
    [anon_sym_var] = ACTIONS(2650),
    [anon_sym_let] = ACTIONS(2650),
    [anon_sym_const] = ACTIONS(2650),
    [anon_sym_if] = ACTIONS(2650),
    [anon_sym_else] = ACTIONS(2650),
    [anon_sym_switch] = ACTIONS(2650),
    [anon_sym_for] = ACTIONS(2650),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_await] = ACTIONS(2650),
    [anon_sym_while] = ACTIONS(2650),
    [anon_sym_do] = ACTIONS(2650),
    [anon_sym_try] = ACTIONS(2650),
    [anon_sym_with] = ACTIONS(2650),
    [anon_sym_break] = ACTIONS(2650),
    [anon_sym_continue] = ACTIONS(2650),
    [anon_sym_debugger] = ACTIONS(2650),
    [anon_sym_return] = ACTIONS(2650),
    [anon_sym_throw] = ACTIONS(2650),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_case] = ACTIONS(2650),
    [anon_sym_yield] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_SLASH] = ACTIONS(2650),
    [anon_sym_class] = ACTIONS(2650),
    [anon_sym_async] = ACTIONS(2650),
    [anon_sym_function] = ACTIONS(2650),
    [anon_sym_new] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_void] = ACTIONS(2650),
    [anon_sym_delete] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2648),
    [anon_sym_DQUOTE] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [sym_number] = ACTIONS(2648),
    [sym_this] = ACTIONS(2650),
    [sym_super] = ACTIONS(2650),
    [sym_true] = ACTIONS(2650),
    [sym_false] = ACTIONS(2650),
    [sym_null] = ACTIONS(2650),
    [sym_undefined] = ACTIONS(2650),
    [anon_sym_AT] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2650),
    [anon_sym_abstract] = ACTIONS(2650),
    [anon_sym_get] = ACTIONS(2650),
    [anon_sym_set] = ACTIONS(2650),
    [anon_sym_declare] = ACTIONS(2650),
    [anon_sym_public] = ACTIONS(2650),
    [anon_sym_private] = ACTIONS(2650),
    [anon_sym_protected] = ACTIONS(2650),
    [anon_sym_module] = ACTIONS(2650),
    [anon_sym_any] = ACTIONS(2650),
    [anon_sym_number] = ACTIONS(2650),
    [anon_sym_boolean] = ACTIONS(2650),
    [anon_sym_string] = ACTIONS(2650),
    [anon_sym_symbol] = ACTIONS(2650),
    [anon_sym_interface] = ACTIONS(2650),
    [anon_sym_enum] = ACTIONS(2650),
    [sym_readonly] = ACTIONS(2650),
  },
  [490] = {
    [sym_finally_clause] = STATE(536),
    [ts_builtin_sym_end] = ACTIONS(2652),
    [sym_identifier] = ACTIONS(2654),
    [anon_sym_export] = ACTIONS(2654),
    [anon_sym_default] = ACTIONS(2654),
    [anon_sym_namespace] = ACTIONS(2654),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_type] = ACTIONS(2654),
    [anon_sym_typeof] = ACTIONS(2654),
    [anon_sym_import] = ACTIONS(2654),
    [anon_sym_var] = ACTIONS(2654),
    [anon_sym_let] = ACTIONS(2654),
    [anon_sym_const] = ACTIONS(2654),
    [anon_sym_if] = ACTIONS(2654),
    [anon_sym_else] = ACTIONS(2654),
    [anon_sym_switch] = ACTIONS(2654),
    [anon_sym_for] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2652),
    [anon_sym_await] = ACTIONS(2654),
    [anon_sym_while] = ACTIONS(2654),
    [anon_sym_do] = ACTIONS(2654),
    [anon_sym_try] = ACTIONS(2654),
    [anon_sym_with] = ACTIONS(2654),
    [anon_sym_break] = ACTIONS(2654),
    [anon_sym_continue] = ACTIONS(2654),
    [anon_sym_debugger] = ACTIONS(2654),
    [anon_sym_return] = ACTIONS(2654),
    [anon_sym_throw] = ACTIONS(2654),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_case] = ACTIONS(2654),
    [anon_sym_finally] = ACTIONS(2557),
    [anon_sym_yield] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_LT] = ACTIONS(2652),
    [anon_sym_SLASH] = ACTIONS(2654),
    [anon_sym_class] = ACTIONS(2654),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_function] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2654),
    [anon_sym_PLUS] = ACTIONS(2654),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2652),
    [anon_sym_TILDE] = ACTIONS(2652),
    [anon_sym_void] = ACTIONS(2654),
    [anon_sym_delete] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2652),
    [anon_sym_SQUOTE] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2652),
    [sym_number] = ACTIONS(2652),
    [sym_this] = ACTIONS(2654),
    [sym_super] = ACTIONS(2654),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_null] = ACTIONS(2654),
    [sym_undefined] = ACTIONS(2654),
    [anon_sym_AT] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2654),
    [anon_sym_abstract] = ACTIONS(2654),
    [anon_sym_get] = ACTIONS(2654),
    [anon_sym_set] = ACTIONS(2654),
    [anon_sym_declare] = ACTIONS(2654),
    [anon_sym_public] = ACTIONS(2654),
    [anon_sym_private] = ACTIONS(2654),
    [anon_sym_protected] = ACTIONS(2654),
    [anon_sym_module] = ACTIONS(2654),
    [anon_sym_any] = ACTIONS(2654),
    [anon_sym_number] = ACTIONS(2654),
    [anon_sym_boolean] = ACTIONS(2654),
    [anon_sym_string] = ACTIONS(2654),
    [anon_sym_symbol] = ACTIONS(2654),
    [anon_sym_interface] = ACTIONS(2654),
    [anon_sym_enum] = ACTIONS(2654),
    [sym_readonly] = ACTIONS(2654),
  },
  [491] = {
    [sym_statement_block] = STATE(582),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_default] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_var] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_for] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_do] = ACTIONS(1097),
    [anon_sym_try] = ACTIONS(1097),
    [anon_sym_with] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [anon_sym_debugger] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_throw] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1097),
    [anon_sym_yield] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_number] = ACTIONS(1095),
    [sym_this] = ACTIONS(1097),
    [sym_super] = ACTIONS(1097),
    [sym_true] = ACTIONS(1097),
    [sym_false] = ACTIONS(1097),
    [sym_null] = ACTIONS(1097),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_abstract] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_interface] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [sym_readonly] = ACTIONS(1097),
  },
  [492] = {
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(2658),
    [sym_identifier] = ACTIONS(2660),
    [anon_sym_export] = ACTIONS(2660),
    [anon_sym_default] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2658),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_typeof] = ACTIONS(2660),
    [anon_sym_import] = ACTIONS(2660),
    [anon_sym_var] = ACTIONS(2660),
    [anon_sym_let] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2660),
    [anon_sym_else] = ACTIONS(2660),
    [anon_sym_switch] = ACTIONS(2660),
    [anon_sym_for] = ACTIONS(2660),
    [anon_sym_LPAREN] = ACTIONS(2658),
    [anon_sym_await] = ACTIONS(2660),
    [anon_sym_while] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_try] = ACTIONS(2660),
    [anon_sym_with] = ACTIONS(2660),
    [anon_sym_break] = ACTIONS(2660),
    [anon_sym_continue] = ACTIONS(2660),
    [anon_sym_debugger] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(2660),
    [anon_sym_throw] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_case] = ACTIONS(2660),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_async] = ACTIONS(2660),
    [anon_sym_function] = ACTIONS(2660),
    [anon_sym_new] = ACTIONS(2660),
    [anon_sym_AMP] = ACTIONS(2626),
    [anon_sym_PIPE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2660),
    [anon_sym_DASH] = ACTIONS(2660),
    [anon_sym_BANG] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_void] = ACTIONS(2660),
    [anon_sym_delete] = ACTIONS(2660),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [sym_number] = ACTIONS(2658),
    [sym_this] = ACTIONS(2660),
    [sym_super] = ACTIONS(2660),
    [sym_true] = ACTIONS(2660),
    [sym_false] = ACTIONS(2660),
    [sym_null] = ACTIONS(2660),
    [sym_undefined] = ACTIONS(2660),
    [anon_sym_AT] = ACTIONS(2658),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_abstract] = ACTIONS(2660),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2660),
    [anon_sym_private] = ACTIONS(2660),
    [anon_sym_protected] = ACTIONS(2660),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_interface] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [sym_readonly] = ACTIONS(2660),
  },
  [494] = {
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [495] = {
    [sym__call_signature] = STATE(3025),
    [sym_arguments] = STATE(1534),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1139),
    [sym_identifier] = ACTIONS(1141),
    [anon_sym_export] = ACTIONS(1141),
    [anon_sym_default] = ACTIONS(1141),
    [anon_sym_namespace] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_type] = ACTIONS(1141),
    [anon_sym_typeof] = ACTIONS(1141),
    [anon_sym_import] = ACTIONS(1141),
    [anon_sym_var] = ACTIONS(1141),
    [anon_sym_let] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_else] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1139),
    [anon_sym_await] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_do] = ACTIONS(1141),
    [anon_sym_try] = ACTIONS(1141),
    [anon_sym_with] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [anon_sym_debugger] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_throw] = ACTIONS(1141),
    [anon_sym_SEMI] = ACTIONS(1139),
    [anon_sym_case] = ACTIONS(1141),
    [anon_sym_yield] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [anon_sym_LT] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1141),
    [anon_sym_class] = ACTIONS(1141),
    [anon_sym_async] = ACTIONS(1141),
    [anon_sym_function] = ACTIONS(1141),
    [anon_sym_new] = ACTIONS(1141),
    [anon_sym_PLUS] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(1141),
    [anon_sym_BANG] = ACTIONS(1139),
    [anon_sym_TILDE] = ACTIONS(1139),
    [anon_sym_void] = ACTIONS(1141),
    [anon_sym_delete] = ACTIONS(1141),
    [anon_sym_PLUS_PLUS] = ACTIONS(1139),
    [anon_sym_DASH_DASH] = ACTIONS(1139),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1139),
    [sym_number] = ACTIONS(1139),
    [sym_this] = ACTIONS(1141),
    [sym_super] = ACTIONS(1141),
    [sym_true] = ACTIONS(1141),
    [sym_false] = ACTIONS(1141),
    [sym_null] = ACTIONS(1141),
    [sym_undefined] = ACTIONS(1141),
    [anon_sym_AT] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1141),
    [anon_sym_abstract] = ACTIONS(1141),
    [anon_sym_get] = ACTIONS(1141),
    [anon_sym_set] = ACTIONS(1141),
    [anon_sym_declare] = ACTIONS(1141),
    [anon_sym_public] = ACTIONS(1141),
    [anon_sym_private] = ACTIONS(1141),
    [anon_sym_protected] = ACTIONS(1141),
    [anon_sym_module] = ACTIONS(1141),
    [anon_sym_any] = ACTIONS(1141),
    [anon_sym_number] = ACTIONS(1141),
    [anon_sym_boolean] = ACTIONS(1141),
    [anon_sym_string] = ACTIONS(1141),
    [anon_sym_symbol] = ACTIONS(1141),
    [anon_sym_interface] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [sym_readonly] = ACTIONS(1141),
    [sym__automatic_semicolon] = ACTIONS(1147),
  },
  [497] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2668),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [498] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2420),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(2670),
    [sym_identifier] = ACTIONS(2672),
    [anon_sym_export] = ACTIONS(2672),
    [anon_sym_default] = ACTIONS(2672),
    [anon_sym_namespace] = ACTIONS(2672),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_type] = ACTIONS(2672),
    [anon_sym_typeof] = ACTIONS(2672),
    [anon_sym_import] = ACTIONS(2672),
    [anon_sym_var] = ACTIONS(2672),
    [anon_sym_let] = ACTIONS(2672),
    [anon_sym_const] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2672),
    [anon_sym_else] = ACTIONS(2672),
    [anon_sym_switch] = ACTIONS(2672),
    [anon_sym_for] = ACTIONS(2672),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_RPAREN] = ACTIONS(2670),
    [anon_sym_await] = ACTIONS(2672),
    [anon_sym_while] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2672),
    [anon_sym_with] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2672),
    [anon_sym_continue] = ACTIONS(2672),
    [anon_sym_debugger] = ACTIONS(2672),
    [anon_sym_return] = ACTIONS(2672),
    [anon_sym_throw] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_case] = ACTIONS(2672),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2670),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_SLASH] = ACTIONS(2672),
    [anon_sym_class] = ACTIONS(2672),
    [anon_sym_async] = ACTIONS(2672),
    [anon_sym_function] = ACTIONS(2672),
    [anon_sym_new] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2672),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_void] = ACTIONS(2672),
    [anon_sym_delete] = ACTIONS(2672),
    [anon_sym_PLUS_PLUS] = ACTIONS(2670),
    [anon_sym_DASH_DASH] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2670),
    [sym_number] = ACTIONS(2670),
    [sym_this] = ACTIONS(2672),
    [sym_super] = ACTIONS(2672),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [sym_null] = ACTIONS(2672),
    [sym_undefined] = ACTIONS(2672),
    [anon_sym_AT] = ACTIONS(2670),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_abstract] = ACTIONS(2672),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_declare] = ACTIONS(2672),
    [anon_sym_public] = ACTIONS(2672),
    [anon_sym_private] = ACTIONS(2672),
    [anon_sym_protected] = ACTIONS(2672),
    [anon_sym_module] = ACTIONS(2672),
    [anon_sym_any] = ACTIONS(2672),
    [anon_sym_number] = ACTIONS(2672),
    [anon_sym_boolean] = ACTIONS(2672),
    [anon_sym_string] = ACTIONS(2672),
    [anon_sym_symbol] = ACTIONS(2672),
    [anon_sym_interface] = ACTIONS(2672),
    [anon_sym_enum] = ACTIONS(2672),
    [sym_readonly] = ACTIONS(2672),
  },
  [500] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2668),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [sym_identifier] = ACTIONS(1187),
    [anon_sym_export] = ACTIONS(1187),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1187),
    [anon_sym_import] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(1187),
    [anon_sym_let] = ACTIONS(1187),
    [anon_sym_const] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_for] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1187),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_do] = ACTIONS(1187),
    [anon_sym_try] = ACTIONS(1187),
    [anon_sym_with] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_continue] = ACTIONS(1187),
    [anon_sym_debugger] = ACTIONS(1187),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1187),
    [anon_sym_yield] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_class] = ACTIONS(1187),
    [anon_sym_async] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(1187),
    [anon_sym_new] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1185),
    [anon_sym_TILDE] = ACTIONS(1185),
    [anon_sym_void] = ACTIONS(1187),
    [anon_sym_delete] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym_number] = ACTIONS(1185),
    [sym_this] = ACTIONS(1187),
    [sym_super] = ACTIONS(1187),
    [sym_true] = ACTIONS(1187),
    [sym_false] = ACTIONS(1187),
    [sym_null] = ACTIONS(1187),
    [sym_undefined] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1187),
    [anon_sym_abstract] = ACTIONS(1187),
    [anon_sym_get] = ACTIONS(1187),
    [anon_sym_set] = ACTIONS(1187),
    [anon_sym_declare] = ACTIONS(1187),
    [anon_sym_public] = ACTIONS(1187),
    [anon_sym_private] = ACTIONS(1187),
    [anon_sym_protected] = ACTIONS(1187),
    [anon_sym_module] = ACTIONS(1187),
    [anon_sym_any] = ACTIONS(1187),
    [anon_sym_number] = ACTIONS(1187),
    [anon_sym_boolean] = ACTIONS(1187),
    [anon_sym_string] = ACTIONS(1187),
    [anon_sym_symbol] = ACTIONS(1187),
    [anon_sym_interface] = ACTIONS(1187),
    [anon_sym_enum] = ACTIONS(1187),
    [sym_readonly] = ACTIONS(1187),
    [sym__automatic_semicolon] = ACTIONS(1193),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1153),
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_export] = ACTIONS(1155),
    [anon_sym_default] = ACTIONS(1155),
    [anon_sym_namespace] = ACTIONS(1155),
    [anon_sym_LBRACE] = ACTIONS(1153),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_type] = ACTIONS(1155),
    [anon_sym_typeof] = ACTIONS(1155),
    [anon_sym_import] = ACTIONS(1155),
    [anon_sym_var] = ACTIONS(1155),
    [anon_sym_let] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1155),
    [anon_sym_else] = ACTIONS(1155),
    [anon_sym_switch] = ACTIONS(1155),
    [anon_sym_for] = ACTIONS(1155),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_await] = ACTIONS(1155),
    [anon_sym_while] = ACTIONS(1155),
    [anon_sym_do] = ACTIONS(1155),
    [anon_sym_try] = ACTIONS(1155),
    [anon_sym_with] = ACTIONS(1155),
    [anon_sym_break] = ACTIONS(1155),
    [anon_sym_continue] = ACTIONS(1155),
    [anon_sym_debugger] = ACTIONS(1155),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_throw] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym_case] = ACTIONS(1155),
    [anon_sym_yield] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1153),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_class] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1155),
    [anon_sym_function] = ACTIONS(1155),
    [anon_sym_new] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1153),
    [anon_sym_void] = ACTIONS(1155),
    [anon_sym_delete] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [anon_sym_DQUOTE] = ACTIONS(1153),
    [anon_sym_SQUOTE] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1153),
    [sym_number] = ACTIONS(1153),
    [sym_this] = ACTIONS(1155),
    [sym_super] = ACTIONS(1155),
    [sym_true] = ACTIONS(1155),
    [sym_false] = ACTIONS(1155),
    [sym_null] = ACTIONS(1155),
    [sym_undefined] = ACTIONS(1155),
    [anon_sym_AT] = ACTIONS(1153),
    [anon_sym_static] = ACTIONS(1155),
    [anon_sym_abstract] = ACTIONS(1155),
    [anon_sym_get] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1155),
    [anon_sym_declare] = ACTIONS(1155),
    [anon_sym_public] = ACTIONS(1155),
    [anon_sym_private] = ACTIONS(1155),
    [anon_sym_protected] = ACTIONS(1155),
    [anon_sym_module] = ACTIONS(1155),
    [anon_sym_any] = ACTIONS(1155),
    [anon_sym_number] = ACTIONS(1155),
    [anon_sym_boolean] = ACTIONS(1155),
    [anon_sym_string] = ACTIONS(1155),
    [anon_sym_symbol] = ACTIONS(1155),
    [anon_sym_interface] = ACTIONS(1155),
    [anon_sym_enum] = ACTIONS(1155),
    [sym_readonly] = ACTIONS(1155),
    [sym__automatic_semicolon] = ACTIONS(1161),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1171),
    [sym_identifier] = ACTIONS(1173),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_typeof] = ACTIONS(1173),
    [anon_sym_import] = ACTIONS(1173),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_let] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_await] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_try] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_debugger] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_throw] = ACTIONS(1173),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1171),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_class] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1173),
    [anon_sym_new] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_BANG] = ACTIONS(1171),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_delete] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [sym_number] = ACTIONS(1171),
    [sym_this] = ACTIONS(1173),
    [sym_super] = ACTIONS(1173),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_AT] = ACTIONS(1171),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_abstract] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_interface] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [sym_readonly] = ACTIONS(1173),
    [sym__automatic_semicolon] = ACTIONS(1179),
  },
  [504] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(2674),
    [sym_identifier] = ACTIONS(2676),
    [anon_sym_export] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2674),
    [anon_sym_RBRACE] = ACTIONS(2674),
    [anon_sym_type] = ACTIONS(2676),
    [anon_sym_typeof] = ACTIONS(2676),
    [anon_sym_import] = ACTIONS(2676),
    [anon_sym_var] = ACTIONS(2676),
    [anon_sym_let] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_else] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_LPAREN] = ACTIONS(2674),
    [anon_sym_await] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_with] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_debugger] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_finally] = ACTIONS(2676),
    [anon_sym_yield] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2674),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_SLASH] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_async] = ACTIONS(2676),
    [anon_sym_function] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_BANG] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_void] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_PLUS_PLUS] = ACTIONS(2674),
    [anon_sym_DASH_DASH] = ACTIONS(2674),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2674),
    [sym_number] = ACTIONS(2674),
    [sym_this] = ACTIONS(2676),
    [sym_super] = ACTIONS(2676),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [sym_null] = ACTIONS(2676),
    [sym_undefined] = ACTIONS(2676),
    [anon_sym_AT] = ACTIONS(2674),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_abstract] = ACTIONS(2676),
    [anon_sym_get] = ACTIONS(2676),
    [anon_sym_set] = ACTIONS(2676),
    [anon_sym_declare] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2676),
    [anon_sym_any] = ACTIONS(2676),
    [anon_sym_number] = ACTIONS(2676),
    [anon_sym_boolean] = ACTIONS(2676),
    [anon_sym_string] = ACTIONS(2676),
    [anon_sym_symbol] = ACTIONS(2676),
    [anon_sym_interface] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [sym_readonly] = ACTIONS(2676),
  },
  [506] = {
    [sym__call_signature] = STATE(3025),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(1271),
    [sym_identifier] = ACTIONS(1273),
    [anon_sym_export] = ACTIONS(1273),
    [anon_sym_default] = ACTIONS(1273),
    [anon_sym_namespace] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_type] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(1273),
    [anon_sym_import] = ACTIONS(1273),
    [anon_sym_var] = ACTIONS(1273),
    [anon_sym_let] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_else] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1273),
    [anon_sym_for] = ACTIONS(1273),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [anon_sym_await] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_do] = ACTIONS(1273),
    [anon_sym_try] = ACTIONS(1273),
    [anon_sym_with] = ACTIONS(1273),
    [anon_sym_break] = ACTIONS(1273),
    [anon_sym_continue] = ACTIONS(1273),
    [anon_sym_debugger] = ACTIONS(1273),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_throw] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_case] = ACTIONS(1273),
    [anon_sym_yield] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_class] = ACTIONS(1273),
    [anon_sym_async] = ACTIONS(1273),
    [anon_sym_function] = ACTIONS(1273),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_TILDE] = ACTIONS(1271),
    [anon_sym_void] = ACTIONS(1273),
    [anon_sym_delete] = ACTIONS(1273),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_SQUOTE] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [sym_number] = ACTIONS(1271),
    [sym_this] = ACTIONS(1273),
    [sym_super] = ACTIONS(1273),
    [sym_true] = ACTIONS(1273),
    [sym_false] = ACTIONS(1273),
    [sym_null] = ACTIONS(1273),
    [sym_undefined] = ACTIONS(1273),
    [anon_sym_AT] = ACTIONS(1271),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_abstract] = ACTIONS(1273),
    [anon_sym_get] = ACTIONS(1273),
    [anon_sym_set] = ACTIONS(1273),
    [anon_sym_declare] = ACTIONS(1273),
    [anon_sym_public] = ACTIONS(1273),
    [anon_sym_private] = ACTIONS(1273),
    [anon_sym_protected] = ACTIONS(1273),
    [anon_sym_module] = ACTIONS(1273),
    [anon_sym_any] = ACTIONS(1273),
    [anon_sym_number] = ACTIONS(1273),
    [anon_sym_boolean] = ACTIONS(1273),
    [anon_sym_string] = ACTIONS(1273),
    [anon_sym_symbol] = ACTIONS(1273),
    [anon_sym_interface] = ACTIONS(1273),
    [anon_sym_enum] = ACTIONS(1273),
    [sym_readonly] = ACTIONS(1273),
    [sym__automatic_semicolon] = ACTIONS(1279),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_export] = ACTIONS(1227),
    [anon_sym_default] = ACTIONS(1227),
    [anon_sym_namespace] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_type] = ACTIONS(1227),
    [anon_sym_typeof] = ACTIONS(1227),
    [anon_sym_import] = ACTIONS(1227),
    [anon_sym_var] = ACTIONS(1227),
    [anon_sym_let] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1227),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_await] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_do] = ACTIONS(1227),
    [anon_sym_try] = ACTIONS(1227),
    [anon_sym_with] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [anon_sym_debugger] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_throw] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_case] = ACTIONS(1227),
    [anon_sym_yield] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_class] = ACTIONS(1227),
    [anon_sym_async] = ACTIONS(1227),
    [anon_sym_function] = ACTIONS(1227),
    [anon_sym_new] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1225),
    [anon_sym_TILDE] = ACTIONS(1225),
    [anon_sym_void] = ACTIONS(1227),
    [anon_sym_delete] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym_number] = ACTIONS(1225),
    [sym_this] = ACTIONS(1227),
    [sym_super] = ACTIONS(1227),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [sym_null] = ACTIONS(1227),
    [sym_undefined] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(1225),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_abstract] = ACTIONS(1227),
    [anon_sym_get] = ACTIONS(1227),
    [anon_sym_set] = ACTIONS(1227),
    [anon_sym_declare] = ACTIONS(1227),
    [anon_sym_public] = ACTIONS(1227),
    [anon_sym_private] = ACTIONS(1227),
    [anon_sym_protected] = ACTIONS(1227),
    [anon_sym_module] = ACTIONS(1227),
    [anon_sym_any] = ACTIONS(1227),
    [anon_sym_number] = ACTIONS(1227),
    [anon_sym_boolean] = ACTIONS(1227),
    [anon_sym_string] = ACTIONS(1227),
    [anon_sym_symbol] = ACTIONS(1227),
    [anon_sym_interface] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [sym_readonly] = ACTIONS(1227),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [509] = {
    [sym_statement_block] = STATE(582),
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_export] = ACTIONS(1097),
    [anon_sym_default] = ACTIONS(1097),
    [anon_sym_namespace] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_type] = ACTIONS(1097),
    [anon_sym_typeof] = ACTIONS(1097),
    [anon_sym_import] = ACTIONS(1097),
    [anon_sym_var] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_const] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_for] = ACTIONS(1097),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_await] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1097),
    [anon_sym_do] = ACTIONS(1097),
    [anon_sym_try] = ACTIONS(1097),
    [anon_sym_with] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [anon_sym_debugger] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_throw] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1097),
    [anon_sym_yield] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_class] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_new] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_void] = ACTIONS(1097),
    [anon_sym_delete] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym_number] = ACTIONS(1095),
    [sym_this] = ACTIONS(1097),
    [sym_super] = ACTIONS(1097),
    [sym_true] = ACTIONS(1097),
    [sym_false] = ACTIONS(1097),
    [sym_null] = ACTIONS(1097),
    [sym_undefined] = ACTIONS(1097),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_static] = ACTIONS(1097),
    [anon_sym_abstract] = ACTIONS(1097),
    [anon_sym_get] = ACTIONS(1097),
    [anon_sym_set] = ACTIONS(1097),
    [anon_sym_declare] = ACTIONS(1097),
    [anon_sym_public] = ACTIONS(1097),
    [anon_sym_private] = ACTIONS(1097),
    [anon_sym_protected] = ACTIONS(1097),
    [anon_sym_module] = ACTIONS(1097),
    [anon_sym_any] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_boolean] = ACTIONS(1097),
    [anon_sym_string] = ACTIONS(1097),
    [anon_sym_symbol] = ACTIONS(1097),
    [anon_sym_interface] = ACTIONS(1097),
    [anon_sym_enum] = ACTIONS(1097),
    [sym_readonly] = ACTIONS(1097),
  },
  [510] = {
    [sym__call_signature] = STATE(3001),
    [sym_arguments] = STATE(1033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [anon_sym_implements] = ACTIONS(521),
    [sym_readonly] = ACTIONS(2680),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(2682),
    [sym_identifier] = ACTIONS(2684),
    [anon_sym_export] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2684),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_RBRACE] = ACTIONS(2682),
    [anon_sym_type] = ACTIONS(2684),
    [anon_sym_typeof] = ACTIONS(2684),
    [anon_sym_import] = ACTIONS(2684),
    [anon_sym_var] = ACTIONS(2684),
    [anon_sym_let] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2684),
    [anon_sym_else] = ACTIONS(2684),
    [anon_sym_switch] = ACTIONS(2684),
    [anon_sym_for] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(2682),
    [anon_sym_await] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2684),
    [anon_sym_do] = ACTIONS(2684),
    [anon_sym_try] = ACTIONS(2684),
    [anon_sym_with] = ACTIONS(2684),
    [anon_sym_break] = ACTIONS(2684),
    [anon_sym_continue] = ACTIONS(2684),
    [anon_sym_debugger] = ACTIONS(2684),
    [anon_sym_return] = ACTIONS(2684),
    [anon_sym_throw] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym_case] = ACTIONS(2684),
    [anon_sym_finally] = ACTIONS(2684),
    [anon_sym_yield] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2682),
    [anon_sym_LT] = ACTIONS(2682),
    [anon_sym_SLASH] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_async] = ACTIONS(2684),
    [anon_sym_function] = ACTIONS(2684),
    [anon_sym_new] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2684),
    [anon_sym_DASH] = ACTIONS(2684),
    [anon_sym_BANG] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2682),
    [anon_sym_void] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(2684),
    [anon_sym_PLUS_PLUS] = ACTIONS(2682),
    [anon_sym_DASH_DASH] = ACTIONS(2682),
    [anon_sym_DQUOTE] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2682),
    [sym_number] = ACTIONS(2682),
    [sym_this] = ACTIONS(2684),
    [sym_super] = ACTIONS(2684),
    [sym_true] = ACTIONS(2684),
    [sym_false] = ACTIONS(2684),
    [sym_null] = ACTIONS(2684),
    [sym_undefined] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2682),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_abstract] = ACTIONS(2684),
    [anon_sym_get] = ACTIONS(2684),
    [anon_sym_set] = ACTIONS(2684),
    [anon_sym_declare] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2684),
    [anon_sym_any] = ACTIONS(2684),
    [anon_sym_number] = ACTIONS(2684),
    [anon_sym_boolean] = ACTIONS(2684),
    [anon_sym_string] = ACTIONS(2684),
    [anon_sym_symbol] = ACTIONS(2684),
    [anon_sym_interface] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [sym_readonly] = ACTIONS(2684),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1123),
    [sym_identifier] = ACTIONS(1125),
    [anon_sym_export] = ACTIONS(1125),
    [anon_sym_default] = ACTIONS(1125),
    [anon_sym_namespace] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_type] = ACTIONS(1125),
    [anon_sym_typeof] = ACTIONS(1125),
    [anon_sym_import] = ACTIONS(1125),
    [anon_sym_var] = ACTIONS(1125),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_const] = ACTIONS(1125),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_else] = ACTIONS(1125),
    [anon_sym_switch] = ACTIONS(1125),
    [anon_sym_for] = ACTIONS(1125),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_await] = ACTIONS(1125),
    [anon_sym_while] = ACTIONS(1125),
    [anon_sym_do] = ACTIONS(1125),
    [anon_sym_try] = ACTIONS(1125),
    [anon_sym_with] = ACTIONS(1125),
    [anon_sym_break] = ACTIONS(1125),
    [anon_sym_continue] = ACTIONS(1125),
    [anon_sym_debugger] = ACTIONS(1125),
    [anon_sym_return] = ACTIONS(1125),
    [anon_sym_throw] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_case] = ACTIONS(1125),
    [anon_sym_yield] = ACTIONS(1125),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_SLASH] = ACTIONS(1125),
    [anon_sym_class] = ACTIONS(1125),
    [anon_sym_async] = ACTIONS(1125),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_new] = ACTIONS(1125),
    [anon_sym_PLUS] = ACTIONS(1125),
    [anon_sym_DASH] = ACTIONS(1125),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_TILDE] = ACTIONS(1123),
    [anon_sym_void] = ACTIONS(1125),
    [anon_sym_delete] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1123),
    [anon_sym_SQUOTE] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym_number] = ACTIONS(1123),
    [sym_this] = ACTIONS(1125),
    [sym_super] = ACTIONS(1125),
    [sym_true] = ACTIONS(1125),
    [sym_false] = ACTIONS(1125),
    [sym_null] = ACTIONS(1125),
    [sym_undefined] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_static] = ACTIONS(1125),
    [anon_sym_abstract] = ACTIONS(1125),
    [anon_sym_get] = ACTIONS(1125),
    [anon_sym_set] = ACTIONS(1125),
    [anon_sym_declare] = ACTIONS(1125),
    [anon_sym_public] = ACTIONS(1125),
    [anon_sym_private] = ACTIONS(1125),
    [anon_sym_protected] = ACTIONS(1125),
    [anon_sym_module] = ACTIONS(1125),
    [anon_sym_any] = ACTIONS(1125),
    [anon_sym_number] = ACTIONS(1125),
    [anon_sym_boolean] = ACTIONS(1125),
    [anon_sym_string] = ACTIONS(1125),
    [anon_sym_symbol] = ACTIONS(1125),
    [anon_sym_interface] = ACTIONS(1125),
    [anon_sym_enum] = ACTIONS(1125),
    [sym_readonly] = ACTIONS(1125),
    [sym__automatic_semicolon] = ACTIONS(1131),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1261),
    [sym_identifier] = ACTIONS(1263),
    [anon_sym_export] = ACTIONS(1263),
    [anon_sym_default] = ACTIONS(1263),
    [anon_sym_namespace] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_type] = ACTIONS(1263),
    [anon_sym_typeof] = ACTIONS(1263),
    [anon_sym_import] = ACTIONS(1263),
    [anon_sym_var] = ACTIONS(1263),
    [anon_sym_let] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [anon_sym_await] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_do] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1263),
    [anon_sym_with] = ACTIONS(1263),
    [anon_sym_break] = ACTIONS(1263),
    [anon_sym_continue] = ACTIONS(1263),
    [anon_sym_debugger] = ACTIONS(1263),
    [anon_sym_return] = ACTIONS(1263),
    [anon_sym_throw] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_case] = ACTIONS(1263),
    [anon_sym_yield] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_class] = ACTIONS(1263),
    [anon_sym_async] = ACTIONS(1263),
    [anon_sym_function] = ACTIONS(1263),
    [anon_sym_new] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1261),
    [anon_sym_TILDE] = ACTIONS(1261),
    [anon_sym_void] = ACTIONS(1263),
    [anon_sym_delete] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [sym_number] = ACTIONS(1261),
    [sym_this] = ACTIONS(1263),
    [sym_super] = ACTIONS(1263),
    [sym_true] = ACTIONS(1263),
    [sym_false] = ACTIONS(1263),
    [sym_null] = ACTIONS(1263),
    [sym_undefined] = ACTIONS(1263),
    [anon_sym_AT] = ACTIONS(1261),
    [anon_sym_static] = ACTIONS(1263),
    [anon_sym_abstract] = ACTIONS(1263),
    [anon_sym_get] = ACTIONS(1263),
    [anon_sym_set] = ACTIONS(1263),
    [anon_sym_declare] = ACTIONS(1263),
    [anon_sym_public] = ACTIONS(1263),
    [anon_sym_private] = ACTIONS(1263),
    [anon_sym_protected] = ACTIONS(1263),
    [anon_sym_module] = ACTIONS(1263),
    [anon_sym_any] = ACTIONS(1263),
    [anon_sym_number] = ACTIONS(1263),
    [anon_sym_boolean] = ACTIONS(1263),
    [anon_sym_string] = ACTIONS(1263),
    [anon_sym_symbol] = ACTIONS(1263),
    [anon_sym_interface] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [sym_readonly] = ACTIONS(1263),
    [sym__automatic_semicolon] = ACTIONS(1269),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1251),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_export] = ACTIONS(1253),
    [anon_sym_default] = ACTIONS(1253),
    [anon_sym_namespace] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_type] = ACTIONS(1253),
    [anon_sym_typeof] = ACTIONS(1253),
    [anon_sym_import] = ACTIONS(1253),
    [anon_sym_var] = ACTIONS(1253),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1253),
    [anon_sym_for] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1251),
    [anon_sym_await] = ACTIONS(1253),
    [anon_sym_while] = ACTIONS(1253),
    [anon_sym_do] = ACTIONS(1253),
    [anon_sym_try] = ACTIONS(1253),
    [anon_sym_with] = ACTIONS(1253),
    [anon_sym_break] = ACTIONS(1253),
    [anon_sym_continue] = ACTIONS(1253),
    [anon_sym_debugger] = ACTIONS(1253),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_throw] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1251),
    [anon_sym_case] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1251),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_SLASH] = ACTIONS(1253),
    [anon_sym_class] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1253),
    [anon_sym_new] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_void] = ACTIONS(1253),
    [anon_sym_delete] = ACTIONS(1253),
    [anon_sym_PLUS_PLUS] = ACTIONS(1251),
    [anon_sym_DASH_DASH] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1251),
    [anon_sym_SQUOTE] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1251),
    [sym_number] = ACTIONS(1251),
    [sym_this] = ACTIONS(1253),
    [sym_super] = ACTIONS(1253),
    [sym_true] = ACTIONS(1253),
    [sym_false] = ACTIONS(1253),
    [sym_null] = ACTIONS(1253),
    [sym_undefined] = ACTIONS(1253),
    [anon_sym_AT] = ACTIONS(1251),
    [anon_sym_static] = ACTIONS(1253),
    [anon_sym_abstract] = ACTIONS(1253),
    [anon_sym_get] = ACTIONS(1253),
    [anon_sym_set] = ACTIONS(1253),
    [anon_sym_declare] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1253),
    [anon_sym_private] = ACTIONS(1253),
    [anon_sym_protected] = ACTIONS(1253),
    [anon_sym_module] = ACTIONS(1253),
    [anon_sym_any] = ACTIONS(1253),
    [anon_sym_number] = ACTIONS(1253),
    [anon_sym_boolean] = ACTIONS(1253),
    [anon_sym_string] = ACTIONS(1253),
    [anon_sym_symbol] = ACTIONS(1253),
    [anon_sym_interface] = ACTIONS(1253),
    [anon_sym_enum] = ACTIONS(1253),
    [sym_readonly] = ACTIONS(1253),
    [sym__automatic_semicolon] = ACTIONS(1259),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(1241),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(1243),
    [anon_sym_default] = ACTIONS(1243),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(1243),
    [anon_sym_import] = ACTIONS(1243),
    [anon_sym_var] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1243),
    [anon_sym_const] = ACTIONS(1243),
    [anon_sym_if] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1243),
    [anon_sym_switch] = ACTIONS(1243),
    [anon_sym_for] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_await] = ACTIONS(1243),
    [anon_sym_while] = ACTIONS(1243),
    [anon_sym_do] = ACTIONS(1243),
    [anon_sym_try] = ACTIONS(1243),
    [anon_sym_with] = ACTIONS(1243),
    [anon_sym_break] = ACTIONS(1243),
    [anon_sym_continue] = ACTIONS(1243),
    [anon_sym_debugger] = ACTIONS(1243),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_throw] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_class] = ACTIONS(1243),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1243),
    [anon_sym_new] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1243),
    [anon_sym_delete] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1241),
    [anon_sym_SQUOTE] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_super] = ACTIONS(1243),
    [sym_true] = ACTIONS(1243),
    [sym_false] = ACTIONS(1243),
    [sym_null] = ACTIONS(1243),
    [sym_undefined] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1243),
    [anon_sym_abstract] = ACTIONS(1243),
    [anon_sym_get] = ACTIONS(1243),
    [anon_sym_set] = ACTIONS(1243),
    [anon_sym_declare] = ACTIONS(1243),
    [anon_sym_public] = ACTIONS(1243),
    [anon_sym_private] = ACTIONS(1243),
    [anon_sym_protected] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1243),
    [anon_sym_any] = ACTIONS(1243),
    [anon_sym_number] = ACTIONS(1243),
    [anon_sym_boolean] = ACTIONS(1243),
    [anon_sym_string] = ACTIONS(1243),
    [anon_sym_symbol] = ACTIONS(1243),
    [anon_sym_interface] = ACTIONS(1243),
    [anon_sym_enum] = ACTIONS(1243),
    [sym_readonly] = ACTIONS(1243),
    [sym__automatic_semicolon] = ACTIONS(1249),
  },
  [516] = {
    [sym__call_signature] = STATE(3033),
    [sym_arguments] = STATE(1033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_export] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2690),
    [anon_sym_RBRACE] = ACTIONS(2690),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_typeof] = ACTIONS(2692),
    [anon_sym_import] = ACTIONS(2692),
    [anon_sym_var] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_else] = ACTIONS(2692),
    [anon_sym_switch] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_LPAREN] = ACTIONS(2690),
    [anon_sym_await] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_with] = ACTIONS(2692),
    [anon_sym_break] = ACTIONS(2692),
    [anon_sym_continue] = ACTIONS(2692),
    [anon_sym_debugger] = ACTIONS(2692),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_throw] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_finally] = ACTIONS(2692),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_SLASH] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_async] = ACTIONS(2692),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_BANG] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [anon_sym_void] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2690),
    [sym_number] = ACTIONS(2690),
    [sym_this] = ACTIONS(2692),
    [sym_super] = ACTIONS(2692),
    [sym_true] = ACTIONS(2692),
    [sym_false] = ACTIONS(2692),
    [sym_null] = ACTIONS(2692),
    [sym_undefined] = ACTIONS(2692),
    [anon_sym_AT] = ACTIONS(2690),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_abstract] = ACTIONS(2692),
    [anon_sym_get] = ACTIONS(2692),
    [anon_sym_set] = ACTIONS(2692),
    [anon_sym_declare] = ACTIONS(2692),
    [anon_sym_public] = ACTIONS(2692),
    [anon_sym_private] = ACTIONS(2692),
    [anon_sym_protected] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_any] = ACTIONS(2692),
    [anon_sym_number] = ACTIONS(2692),
    [anon_sym_boolean] = ACTIONS(2692),
    [anon_sym_string] = ACTIONS(2692),
    [anon_sym_symbol] = ACTIONS(2692),
    [anon_sym_interface] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [sym_readonly] = ACTIONS(2692),
  },
  [518] = {
    [sym__call_signature] = STATE(2989),
    [sym_arguments] = STATE(1589),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_export] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2696),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_async] = ACTIONS(2696),
    [anon_sym_function] = ACTIONS(2700),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2696),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2696),
    [anon_sym_get] = ACTIONS(2696),
    [anon_sym_set] = ACTIONS(2696),
    [anon_sym_declare] = ACTIONS(2696),
    [anon_sym_public] = ACTIONS(2696),
    [anon_sym_private] = ACTIONS(2696),
    [anon_sym_protected] = ACTIONS(2696),
    [anon_sym_module] = ACTIONS(2696),
    [anon_sym_any] = ACTIONS(2696),
    [anon_sym_number] = ACTIONS(2696),
    [anon_sym_boolean] = ACTIONS(2696),
    [anon_sym_string] = ACTIONS(2696),
    [anon_sym_symbol] = ACTIONS(2696),
    [sym_readonly] = ACTIONS(2696),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(2702),
    [sym_identifier] = ACTIONS(2704),
    [anon_sym_export] = ACTIONS(2704),
    [anon_sym_default] = ACTIONS(2704),
    [anon_sym_namespace] = ACTIONS(2704),
    [anon_sym_LBRACE] = ACTIONS(2702),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_type] = ACTIONS(2704),
    [anon_sym_typeof] = ACTIONS(2704),
    [anon_sym_import] = ACTIONS(2704),
    [anon_sym_var] = ACTIONS(2704),
    [anon_sym_let] = ACTIONS(2704),
    [anon_sym_const] = ACTIONS(2704),
    [anon_sym_if] = ACTIONS(2704),
    [anon_sym_else] = ACTIONS(2704),
    [anon_sym_switch] = ACTIONS(2704),
    [anon_sym_for] = ACTIONS(2704),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [anon_sym_await] = ACTIONS(2704),
    [anon_sym_while] = ACTIONS(2704),
    [anon_sym_do] = ACTIONS(2704),
    [anon_sym_try] = ACTIONS(2704),
    [anon_sym_with] = ACTIONS(2704),
    [anon_sym_break] = ACTIONS(2704),
    [anon_sym_continue] = ACTIONS(2704),
    [anon_sym_debugger] = ACTIONS(2704),
    [anon_sym_return] = ACTIONS(2704),
    [anon_sym_throw] = ACTIONS(2704),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_case] = ACTIONS(2704),
    [anon_sym_yield] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_SLASH] = ACTIONS(2704),
    [anon_sym_class] = ACTIONS(2704),
    [anon_sym_async] = ACTIONS(2704),
    [anon_sym_function] = ACTIONS(2704),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_BANG] = ACTIONS(2702),
    [anon_sym_TILDE] = ACTIONS(2702),
    [anon_sym_void] = ACTIONS(2704),
    [anon_sym_delete] = ACTIONS(2704),
    [anon_sym_PLUS_PLUS] = ACTIONS(2702),
    [anon_sym_DASH_DASH] = ACTIONS(2702),
    [anon_sym_DQUOTE] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2702),
    [sym_number] = ACTIONS(2702),
    [sym_this] = ACTIONS(2704),
    [sym_super] = ACTIONS(2704),
    [sym_true] = ACTIONS(2704),
    [sym_false] = ACTIONS(2704),
    [sym_null] = ACTIONS(2704),
    [sym_undefined] = ACTIONS(2704),
    [anon_sym_AT] = ACTIONS(2702),
    [anon_sym_static] = ACTIONS(2704),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_get] = ACTIONS(2704),
    [anon_sym_set] = ACTIONS(2704),
    [anon_sym_declare] = ACTIONS(2704),
    [anon_sym_public] = ACTIONS(2704),
    [anon_sym_private] = ACTIONS(2704),
    [anon_sym_protected] = ACTIONS(2704),
    [anon_sym_module] = ACTIONS(2704),
    [anon_sym_any] = ACTIONS(2704),
    [anon_sym_number] = ACTIONS(2704),
    [anon_sym_boolean] = ACTIONS(2704),
    [anon_sym_string] = ACTIONS(2704),
    [anon_sym_symbol] = ACTIONS(2704),
    [anon_sym_interface] = ACTIONS(2704),
    [anon_sym_enum] = ACTIONS(2704),
    [sym_readonly] = ACTIONS(2704),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym_readonly] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1207),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(1115),
    [anon_sym_default] = ACTIONS(1115),
    [anon_sym_namespace] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1115),
    [anon_sym_typeof] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1115),
    [anon_sym_var] = ACTIONS(1115),
    [anon_sym_let] = ACTIONS(1115),
    [anon_sym_const] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_switch] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_await] = ACTIONS(1115),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_do] = ACTIONS(1115),
    [anon_sym_try] = ACTIONS(1115),
    [anon_sym_with] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_debugger] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_throw] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1113),
    [anon_sym_case] = ACTIONS(1115),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_class] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_function] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1113),
    [anon_sym_void] = ACTIONS(1115),
    [anon_sym_delete] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym_number] = ACTIONS(1113),
    [sym_this] = ACTIONS(1115),
    [sym_super] = ACTIONS(1115),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_undefined] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1113),
    [anon_sym_static] = ACTIONS(1115),
    [anon_sym_abstract] = ACTIONS(1115),
    [anon_sym_get] = ACTIONS(1115),
    [anon_sym_set] = ACTIONS(1115),
    [anon_sym_declare] = ACTIONS(1115),
    [anon_sym_public] = ACTIONS(1115),
    [anon_sym_private] = ACTIONS(1115),
    [anon_sym_protected] = ACTIONS(1115),
    [anon_sym_module] = ACTIONS(1115),
    [anon_sym_any] = ACTIONS(1115),
    [anon_sym_number] = ACTIONS(1115),
    [anon_sym_boolean] = ACTIONS(1115),
    [anon_sym_string] = ACTIONS(1115),
    [anon_sym_symbol] = ACTIONS(1115),
    [anon_sym_interface] = ACTIONS(1115),
    [anon_sym_enum] = ACTIONS(1115),
    [sym_readonly] = ACTIONS(1115),
    [sym__automatic_semicolon] = ACTIONS(1121),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(2706),
    [sym_identifier] = ACTIONS(2708),
    [anon_sym_export] = ACTIONS(2708),
    [anon_sym_default] = ACTIONS(2708),
    [anon_sym_namespace] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(2706),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_type] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2708),
    [anon_sym_import] = ACTIONS(2708),
    [anon_sym_var] = ACTIONS(2708),
    [anon_sym_let] = ACTIONS(2708),
    [anon_sym_const] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2708),
    [anon_sym_else] = ACTIONS(2708),
    [anon_sym_switch] = ACTIONS(2708),
    [anon_sym_for] = ACTIONS(2708),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_await] = ACTIONS(2708),
    [anon_sym_while] = ACTIONS(2708),
    [anon_sym_do] = ACTIONS(2708),
    [anon_sym_try] = ACTIONS(2708),
    [anon_sym_with] = ACTIONS(2708),
    [anon_sym_break] = ACTIONS(2708),
    [anon_sym_continue] = ACTIONS(2708),
    [anon_sym_debugger] = ACTIONS(2708),
    [anon_sym_return] = ACTIONS(2708),
    [anon_sym_throw] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2706),
    [anon_sym_case] = ACTIONS(2708),
    [anon_sym_finally] = ACTIONS(2708),
    [anon_sym_yield] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2706),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_class] = ACTIONS(2708),
    [anon_sym_async] = ACTIONS(2708),
    [anon_sym_function] = ACTIONS(2708),
    [anon_sym_new] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_BANG] = ACTIONS(2706),
    [anon_sym_TILDE] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2708),
    [anon_sym_delete] = ACTIONS(2708),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_DQUOTE] = ACTIONS(2706),
    [anon_sym_SQUOTE] = ACTIONS(2706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2706),
    [sym_number] = ACTIONS(2706),
    [sym_this] = ACTIONS(2708),
    [sym_super] = ACTIONS(2708),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_null] = ACTIONS(2708),
    [sym_undefined] = ACTIONS(2708),
    [anon_sym_AT] = ACTIONS(2706),
    [anon_sym_static] = ACTIONS(2708),
    [anon_sym_abstract] = ACTIONS(2708),
    [anon_sym_get] = ACTIONS(2708),
    [anon_sym_set] = ACTIONS(2708),
    [anon_sym_declare] = ACTIONS(2708),
    [anon_sym_public] = ACTIONS(2708),
    [anon_sym_private] = ACTIONS(2708),
    [anon_sym_protected] = ACTIONS(2708),
    [anon_sym_module] = ACTIONS(2708),
    [anon_sym_any] = ACTIONS(2708),
    [anon_sym_number] = ACTIONS(2708),
    [anon_sym_boolean] = ACTIONS(2708),
    [anon_sym_string] = ACTIONS(2708),
    [anon_sym_symbol] = ACTIONS(2708),
    [anon_sym_interface] = ACTIONS(2708),
    [anon_sym_enum] = ACTIONS(2708),
    [sym_readonly] = ACTIONS(2708),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_export] = ACTIONS(2712),
    [anon_sym_default] = ACTIONS(2712),
    [anon_sym_namespace] = ACTIONS(2712),
    [anon_sym_LBRACE] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_type] = ACTIONS(2712),
    [anon_sym_typeof] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2712),
    [anon_sym_var] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_else] = ACTIONS(2712),
    [anon_sym_switch] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [anon_sym_do] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [anon_sym_with] = ACTIONS(2712),
    [anon_sym_break] = ACTIONS(2712),
    [anon_sym_continue] = ACTIONS(2712),
    [anon_sym_debugger] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_throw] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2710),
    [anon_sym_case] = ACTIONS(2712),
    [anon_sym_yield] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2710),
    [anon_sym_LT] = ACTIONS(2710),
    [anon_sym_SLASH] = ACTIONS(2712),
    [anon_sym_class] = ACTIONS(2712),
    [anon_sym_async] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(2712),
    [anon_sym_new] = ACTIONS(2712),
    [anon_sym_PLUS] = ACTIONS(2712),
    [anon_sym_DASH] = ACTIONS(2712),
    [anon_sym_BANG] = ACTIONS(2710),
    [anon_sym_TILDE] = ACTIONS(2710),
    [anon_sym_void] = ACTIONS(2712),
    [anon_sym_delete] = ACTIONS(2712),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_SQUOTE] = ACTIONS(2710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [sym_number] = ACTIONS(2710),
    [sym_this] = ACTIONS(2712),
    [sym_super] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_null] = ACTIONS(2712),
    [sym_undefined] = ACTIONS(2712),
    [anon_sym_AT] = ACTIONS(2710),
    [anon_sym_static] = ACTIONS(2712),
    [anon_sym_abstract] = ACTIONS(2712),
    [anon_sym_get] = ACTIONS(2712),
    [anon_sym_set] = ACTIONS(2712),
    [anon_sym_declare] = ACTIONS(2712),
    [anon_sym_public] = ACTIONS(2712),
    [anon_sym_private] = ACTIONS(2712),
    [anon_sym_protected] = ACTIONS(2712),
    [anon_sym_module] = ACTIONS(2712),
    [anon_sym_any] = ACTIONS(2712),
    [anon_sym_number] = ACTIONS(2712),
    [anon_sym_boolean] = ACTIONS(2712),
    [anon_sym_string] = ACTIONS(2712),
    [anon_sym_symbol] = ACTIONS(2712),
    [anon_sym_interface] = ACTIONS(2712),
    [anon_sym_enum] = ACTIONS(2712),
    [sym_readonly] = ACTIONS(2712),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(2714),
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_default] = ACTIONS(2716),
    [anon_sym_namespace] = ACTIONS(2716),
    [anon_sym_LBRACE] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_var] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_else] = ACTIONS(2716),
    [anon_sym_switch] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_await] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [anon_sym_do] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_with] = ACTIONS(2716),
    [anon_sym_break] = ACTIONS(2716),
    [anon_sym_continue] = ACTIONS(2716),
    [anon_sym_debugger] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_throw] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_case] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2716),
    [anon_sym_class] = ACTIONS(2716),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [anon_sym_new] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_BANG] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2714),
    [anon_sym_void] = ACTIONS(2716),
    [anon_sym_delete] = ACTIONS(2716),
    [anon_sym_PLUS_PLUS] = ACTIONS(2714),
    [anon_sym_DASH_DASH] = ACTIONS(2714),
    [anon_sym_DQUOTE] = ACTIONS(2714),
    [anon_sym_SQUOTE] = ACTIONS(2714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2714),
    [sym_number] = ACTIONS(2714),
    [sym_this] = ACTIONS(2716),
    [sym_super] = ACTIONS(2716),
    [sym_true] = ACTIONS(2716),
    [sym_false] = ACTIONS(2716),
    [sym_null] = ACTIONS(2716),
    [sym_undefined] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2714),
    [anon_sym_static] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_get] = ACTIONS(2716),
    [anon_sym_set] = ACTIONS(2716),
    [anon_sym_declare] = ACTIONS(2716),
    [anon_sym_public] = ACTIONS(2716),
    [anon_sym_private] = ACTIONS(2716),
    [anon_sym_protected] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_any] = ACTIONS(2716),
    [anon_sym_number] = ACTIONS(2716),
    [anon_sym_boolean] = ACTIONS(2716),
    [anon_sym_string] = ACTIONS(2716),
    [anon_sym_symbol] = ACTIONS(2716),
    [anon_sym_interface] = ACTIONS(2716),
    [anon_sym_enum] = ACTIONS(2716),
    [sym_readonly] = ACTIONS(2716),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(2718),
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_default] = ACTIONS(2720),
    [anon_sym_namespace] = ACTIONS(2720),
    [anon_sym_LBRACE] = ACTIONS(2718),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2720),
    [anon_sym_typeof] = ACTIONS(2720),
    [anon_sym_import] = ACTIONS(2720),
    [anon_sym_var] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_else] = ACTIONS(2720),
    [anon_sym_switch] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_LPAREN] = ACTIONS(2718),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [anon_sym_do] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [anon_sym_with] = ACTIONS(2720),
    [anon_sym_break] = ACTIONS(2720),
    [anon_sym_continue] = ACTIONS(2720),
    [anon_sym_debugger] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_throw] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2718),
    [anon_sym_case] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_LT] = ACTIONS(2718),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_class] = ACTIONS(2720),
    [anon_sym_async] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(2720),
    [anon_sym_new] = ACTIONS(2720),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_DASH] = ACTIONS(2720),
    [anon_sym_BANG] = ACTIONS(2718),
    [anon_sym_TILDE] = ACTIONS(2718),
    [anon_sym_void] = ACTIONS(2720),
    [anon_sym_delete] = ACTIONS(2720),
    [anon_sym_PLUS_PLUS] = ACTIONS(2718),
    [anon_sym_DASH_DASH] = ACTIONS(2718),
    [anon_sym_DQUOTE] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(2718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2718),
    [sym_number] = ACTIONS(2718),
    [sym_this] = ACTIONS(2720),
    [sym_super] = ACTIONS(2720),
    [sym_true] = ACTIONS(2720),
    [sym_false] = ACTIONS(2720),
    [sym_null] = ACTIONS(2720),
    [sym_undefined] = ACTIONS(2720),
    [anon_sym_AT] = ACTIONS(2718),
    [anon_sym_static] = ACTIONS(2720),
    [anon_sym_abstract] = ACTIONS(2720),
    [anon_sym_get] = ACTIONS(2720),
    [anon_sym_set] = ACTIONS(2720),
    [anon_sym_declare] = ACTIONS(2720),
    [anon_sym_public] = ACTIONS(2720),
    [anon_sym_private] = ACTIONS(2720),
    [anon_sym_protected] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_any] = ACTIONS(2720),
    [anon_sym_number] = ACTIONS(2720),
    [anon_sym_boolean] = ACTIONS(2720),
    [anon_sym_string] = ACTIONS(2720),
    [anon_sym_symbol] = ACTIONS(2720),
    [anon_sym_interface] = ACTIONS(2720),
    [anon_sym_enum] = ACTIONS(2720),
    [sym_readonly] = ACTIONS(2720),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(2722),
    [sym_identifier] = ACTIONS(2724),
    [anon_sym_export] = ACTIONS(2724),
    [anon_sym_default] = ACTIONS(2724),
    [anon_sym_namespace] = ACTIONS(2724),
    [anon_sym_LBRACE] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_type] = ACTIONS(2724),
    [anon_sym_typeof] = ACTIONS(2724),
    [anon_sym_import] = ACTIONS(2724),
    [anon_sym_var] = ACTIONS(2724),
    [anon_sym_let] = ACTIONS(2724),
    [anon_sym_const] = ACTIONS(2724),
    [anon_sym_if] = ACTIONS(2724),
    [anon_sym_else] = ACTIONS(2724),
    [anon_sym_switch] = ACTIONS(2724),
    [anon_sym_for] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_await] = ACTIONS(2724),
    [anon_sym_while] = ACTIONS(2724),
    [anon_sym_do] = ACTIONS(2724),
    [anon_sym_try] = ACTIONS(2724),
    [anon_sym_with] = ACTIONS(2724),
    [anon_sym_break] = ACTIONS(2724),
    [anon_sym_continue] = ACTIONS(2724),
    [anon_sym_debugger] = ACTIONS(2724),
    [anon_sym_return] = ACTIONS(2724),
    [anon_sym_throw] = ACTIONS(2724),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_case] = ACTIONS(2724),
    [anon_sym_yield] = ACTIONS(2724),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_SLASH] = ACTIONS(2724),
    [anon_sym_class] = ACTIONS(2724),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(2724),
    [anon_sym_new] = ACTIONS(2724),
    [anon_sym_PLUS] = ACTIONS(2724),
    [anon_sym_DASH] = ACTIONS(2724),
    [anon_sym_BANG] = ACTIONS(2722),
    [anon_sym_TILDE] = ACTIONS(2722),
    [anon_sym_void] = ACTIONS(2724),
    [anon_sym_delete] = ACTIONS(2724),
    [anon_sym_PLUS_PLUS] = ACTIONS(2722),
    [anon_sym_DASH_DASH] = ACTIONS(2722),
    [anon_sym_DQUOTE] = ACTIONS(2722),
    [anon_sym_SQUOTE] = ACTIONS(2722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2722),
    [sym_number] = ACTIONS(2722),
    [sym_this] = ACTIONS(2724),
    [sym_super] = ACTIONS(2724),
    [sym_true] = ACTIONS(2724),
    [sym_false] = ACTIONS(2724),
    [sym_null] = ACTIONS(2724),
    [sym_undefined] = ACTIONS(2724),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_static] = ACTIONS(2724),
    [anon_sym_abstract] = ACTIONS(2724),
    [anon_sym_get] = ACTIONS(2724),
    [anon_sym_set] = ACTIONS(2724),
    [anon_sym_declare] = ACTIONS(2724),
    [anon_sym_public] = ACTIONS(2724),
    [anon_sym_private] = ACTIONS(2724),
    [anon_sym_protected] = ACTIONS(2724),
    [anon_sym_module] = ACTIONS(2724),
    [anon_sym_any] = ACTIONS(2724),
    [anon_sym_number] = ACTIONS(2724),
    [anon_sym_boolean] = ACTIONS(2724),
    [anon_sym_string] = ACTIONS(2724),
    [anon_sym_symbol] = ACTIONS(2724),
    [anon_sym_interface] = ACTIONS(2724),
    [anon_sym_enum] = ACTIONS(2724),
    [sym_readonly] = ACTIONS(2724),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(2726),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_default] = ACTIONS(2728),
    [anon_sym_namespace] = ACTIONS(2728),
    [anon_sym_LBRACE] = ACTIONS(2726),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_typeof] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_var] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_else] = ACTIONS(2728),
    [anon_sym_switch] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_await] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [anon_sym_do] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_with] = ACTIONS(2728),
    [anon_sym_break] = ACTIONS(2728),
    [anon_sym_continue] = ACTIONS(2728),
    [anon_sym_debugger] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_throw] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_case] = ACTIONS(2728),
    [anon_sym_yield] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2726),
    [anon_sym_SLASH] = ACTIONS(2728),
    [anon_sym_class] = ACTIONS(2728),
    [anon_sym_async] = ACTIONS(2728),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2726),
    [anon_sym_TILDE] = ACTIONS(2726),
    [anon_sym_void] = ACTIONS(2728),
    [anon_sym_delete] = ACTIONS(2728),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_DQUOTE] = ACTIONS(2726),
    [anon_sym_SQUOTE] = ACTIONS(2726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [sym_number] = ACTIONS(2726),
    [sym_this] = ACTIONS(2728),
    [sym_super] = ACTIONS(2728),
    [sym_true] = ACTIONS(2728),
    [sym_false] = ACTIONS(2728),
    [sym_null] = ACTIONS(2728),
    [sym_undefined] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2726),
    [anon_sym_static] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_get] = ACTIONS(2728),
    [anon_sym_set] = ACTIONS(2728),
    [anon_sym_declare] = ACTIONS(2728),
    [anon_sym_public] = ACTIONS(2728),
    [anon_sym_private] = ACTIONS(2728),
    [anon_sym_protected] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_any] = ACTIONS(2728),
    [anon_sym_number] = ACTIONS(2728),
    [anon_sym_boolean] = ACTIONS(2728),
    [anon_sym_string] = ACTIONS(2728),
    [anon_sym_symbol] = ACTIONS(2728),
    [anon_sym_interface] = ACTIONS(2728),
    [anon_sym_enum] = ACTIONS(2728),
    [sym_readonly] = ACTIONS(2728),
  },
  [528] = {
    [sym__call_signature] = STATE(3001),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(774),
    [anon_sym_STAR_EQ] = ACTIONS(774),
    [anon_sym_SLASH_EQ] = ACTIONS(774),
    [anon_sym_PERCENT_EQ] = ACTIONS(774),
    [anon_sym_CARET_EQ] = ACTIONS(774),
    [anon_sym_AMP_EQ] = ACTIONS(774),
    [anon_sym_PIPE_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_LT_EQ] = ACTIONS(774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [anon_sym_implements] = ACTIONS(471),
    [sym_readonly] = ACTIONS(2680),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(2730),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_default] = ACTIONS(2732),
    [anon_sym_namespace] = ACTIONS(2732),
    [anon_sym_LBRACE] = ACTIONS(2730),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_type] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2732),
    [anon_sym_import] = ACTIONS(2732),
    [anon_sym_var] = ACTIONS(2732),
    [anon_sym_let] = ACTIONS(2732),
    [anon_sym_const] = ACTIONS(2732),
    [anon_sym_if] = ACTIONS(2732),
    [anon_sym_else] = ACTIONS(2732),
    [anon_sym_switch] = ACTIONS(2732),
    [anon_sym_for] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(2730),
    [anon_sym_await] = ACTIONS(2732),
    [anon_sym_while] = ACTIONS(2732),
    [anon_sym_do] = ACTIONS(2732),
    [anon_sym_try] = ACTIONS(2732),
    [anon_sym_with] = ACTIONS(2732),
    [anon_sym_break] = ACTIONS(2732),
    [anon_sym_continue] = ACTIONS(2732),
    [anon_sym_debugger] = ACTIONS(2732),
    [anon_sym_return] = ACTIONS(2732),
    [anon_sym_throw] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2730),
    [anon_sym_case] = ACTIONS(2732),
    [anon_sym_yield] = ACTIONS(2732),
    [anon_sym_LBRACK] = ACTIONS(2730),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_SLASH] = ACTIONS(2732),
    [anon_sym_class] = ACTIONS(2732),
    [anon_sym_async] = ACTIONS(2732),
    [anon_sym_function] = ACTIONS(2732),
    [anon_sym_new] = ACTIONS(2732),
    [anon_sym_PLUS] = ACTIONS(2732),
    [anon_sym_DASH] = ACTIONS(2732),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_TILDE] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2732),
    [anon_sym_delete] = ACTIONS(2732),
    [anon_sym_PLUS_PLUS] = ACTIONS(2730),
    [anon_sym_DASH_DASH] = ACTIONS(2730),
    [anon_sym_DQUOTE] = ACTIONS(2730),
    [anon_sym_SQUOTE] = ACTIONS(2730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [sym_number] = ACTIONS(2730),
    [sym_this] = ACTIONS(2732),
    [sym_super] = ACTIONS(2732),
    [sym_true] = ACTIONS(2732),
    [sym_false] = ACTIONS(2732),
    [sym_null] = ACTIONS(2732),
    [sym_undefined] = ACTIONS(2732),
    [anon_sym_AT] = ACTIONS(2730),
    [anon_sym_static] = ACTIONS(2732),
    [anon_sym_abstract] = ACTIONS(2732),
    [anon_sym_get] = ACTIONS(2732),
    [anon_sym_set] = ACTIONS(2732),
    [anon_sym_declare] = ACTIONS(2732),
    [anon_sym_public] = ACTIONS(2732),
    [anon_sym_private] = ACTIONS(2732),
    [anon_sym_protected] = ACTIONS(2732),
    [anon_sym_module] = ACTIONS(2732),
    [anon_sym_any] = ACTIONS(2732),
    [anon_sym_number] = ACTIONS(2732),
    [anon_sym_boolean] = ACTIONS(2732),
    [anon_sym_string] = ACTIONS(2732),
    [anon_sym_symbol] = ACTIONS(2732),
    [anon_sym_interface] = ACTIONS(2732),
    [anon_sym_enum] = ACTIONS(2732),
    [sym_readonly] = ACTIONS(2732),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(2734),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_default] = ACTIONS(2736),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_typeof] = ACTIONS(2736),
    [anon_sym_import] = ACTIONS(2736),
    [anon_sym_var] = ACTIONS(2736),
    [anon_sym_let] = ACTIONS(2736),
    [anon_sym_const] = ACTIONS(2736),
    [anon_sym_if] = ACTIONS(2736),
    [anon_sym_else] = ACTIONS(2736),
    [anon_sym_switch] = ACTIONS(2736),
    [anon_sym_for] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [anon_sym_await] = ACTIONS(2736),
    [anon_sym_while] = ACTIONS(2736),
    [anon_sym_do] = ACTIONS(2736),
    [anon_sym_try] = ACTIONS(2736),
    [anon_sym_with] = ACTIONS(2736),
    [anon_sym_break] = ACTIONS(2736),
    [anon_sym_continue] = ACTIONS(2736),
    [anon_sym_debugger] = ACTIONS(2736),
    [anon_sym_return] = ACTIONS(2736),
    [anon_sym_throw] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_case] = ACTIONS(2736),
    [anon_sym_yield] = ACTIONS(2736),
    [anon_sym_LBRACK] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2736),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2736),
    [anon_sym_new] = ACTIONS(2736),
    [anon_sym_PLUS] = ACTIONS(2736),
    [anon_sym_DASH] = ACTIONS(2736),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_TILDE] = ACTIONS(2734),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_delete] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [sym_number] = ACTIONS(2734),
    [sym_this] = ACTIONS(2736),
    [sym_super] = ACTIONS(2736),
    [sym_true] = ACTIONS(2736),
    [sym_false] = ACTIONS(2736),
    [sym_null] = ACTIONS(2736),
    [sym_undefined] = ACTIONS(2736),
    [anon_sym_AT] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_abstract] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
    [anon_sym_interface] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2736),
    [sym_readonly] = ACTIONS(2736),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(2738),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2740),
    [anon_sym_default] = ACTIONS(2740),
    [anon_sym_namespace] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_type] = ACTIONS(2740),
    [anon_sym_typeof] = ACTIONS(2740),
    [anon_sym_import] = ACTIONS(2740),
    [anon_sym_var] = ACTIONS(2740),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2740),
    [anon_sym_if] = ACTIONS(2740),
    [anon_sym_else] = ACTIONS(2740),
    [anon_sym_switch] = ACTIONS(2740),
    [anon_sym_for] = ACTIONS(2740),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_await] = ACTIONS(2740),
    [anon_sym_while] = ACTIONS(2740),
    [anon_sym_do] = ACTIONS(2740),
    [anon_sym_try] = ACTIONS(2740),
    [anon_sym_with] = ACTIONS(2740),
    [anon_sym_break] = ACTIONS(2740),
    [anon_sym_continue] = ACTIONS(2740),
    [anon_sym_debugger] = ACTIONS(2740),
    [anon_sym_return] = ACTIONS(2740),
    [anon_sym_throw] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_case] = ACTIONS(2740),
    [anon_sym_yield] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_SLASH] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_async] = ACTIONS(2740),
    [anon_sym_function] = ACTIONS(2740),
    [anon_sym_new] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2738),
    [anon_sym_TILDE] = ACTIONS(2738),
    [anon_sym_void] = ACTIONS(2740),
    [anon_sym_delete] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2738),
    [anon_sym_DASH_DASH] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [sym_number] = ACTIONS(2738),
    [sym_this] = ACTIONS(2740),
    [sym_super] = ACTIONS(2740),
    [sym_true] = ACTIONS(2740),
    [sym_false] = ACTIONS(2740),
    [sym_null] = ACTIONS(2740),
    [sym_undefined] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(2738),
    [anon_sym_static] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2740),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2740),
    [anon_sym_public] = ACTIONS(2740),
    [anon_sym_private] = ACTIONS(2740),
    [anon_sym_protected] = ACTIONS(2740),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_any] = ACTIONS(2740),
    [anon_sym_number] = ACTIONS(2740),
    [anon_sym_boolean] = ACTIONS(2740),
    [anon_sym_string] = ACTIONS(2740),
    [anon_sym_symbol] = ACTIONS(2740),
    [anon_sym_interface] = ACTIONS(2740),
    [anon_sym_enum] = ACTIONS(2740),
    [sym_readonly] = ACTIONS(2740),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2742),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_type] = ACTIONS(2744),
    [anon_sym_typeof] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2742),
    [anon_sym_await] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_with] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_debugger] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_yield] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_BANG] = ACTIONS(2742),
    [anon_sym_TILDE] = ACTIONS(2742),
    [anon_sym_void] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_PLUS_PLUS] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2742),
    [anon_sym_DQUOTE] = ACTIONS(2742),
    [anon_sym_SQUOTE] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2742),
    [sym_number] = ACTIONS(2742),
    [sym_this] = ACTIONS(2744),
    [sym_super] = ACTIONS(2744),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_undefined] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_get] = ACTIONS(2744),
    [anon_sym_set] = ACTIONS(2744),
    [anon_sym_declare] = ACTIONS(2744),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_any] = ACTIONS(2744),
    [anon_sym_number] = ACTIONS(2744),
    [anon_sym_boolean] = ACTIONS(2744),
    [anon_sym_string] = ACTIONS(2744),
    [anon_sym_symbol] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [sym_readonly] = ACTIONS(2744),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_export] = ACTIONS(2748),
    [anon_sym_default] = ACTIONS(2748),
    [anon_sym_namespace] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_type] = ACTIONS(2748),
    [anon_sym_typeof] = ACTIONS(2748),
    [anon_sym_import] = ACTIONS(2748),
    [anon_sym_var] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_const] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_switch] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_await] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_break] = ACTIONS(2748),
    [anon_sym_continue] = ACTIONS(2748),
    [anon_sym_debugger] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_throw] = ACTIONS(2748),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_case] = ACTIONS(2748),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_SLASH] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2748),
    [anon_sym_async] = ACTIONS(2748),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_void] = ACTIONS(2748),
    [anon_sym_delete] = ACTIONS(2748),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [sym_number] = ACTIONS(2746),
    [sym_this] = ACTIONS(2748),
    [sym_super] = ACTIONS(2748),
    [sym_true] = ACTIONS(2748),
    [sym_false] = ACTIONS(2748),
    [sym_null] = ACTIONS(2748),
    [sym_undefined] = ACTIONS(2748),
    [anon_sym_AT] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2748),
    [anon_sym_abstract] = ACTIONS(2748),
    [anon_sym_get] = ACTIONS(2748),
    [anon_sym_set] = ACTIONS(2748),
    [anon_sym_declare] = ACTIONS(2748),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_module] = ACTIONS(2748),
    [anon_sym_any] = ACTIONS(2748),
    [anon_sym_number] = ACTIONS(2748),
    [anon_sym_boolean] = ACTIONS(2748),
    [anon_sym_string] = ACTIONS(2748),
    [anon_sym_symbol] = ACTIONS(2748),
    [anon_sym_interface] = ACTIONS(2748),
    [anon_sym_enum] = ACTIONS(2748),
    [sym_readonly] = ACTIONS(2748),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(2752),
    [anon_sym_export] = ACTIONS(2752),
    [anon_sym_default] = ACTIONS(2752),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_type] = ACTIONS(2752),
    [anon_sym_typeof] = ACTIONS(2752),
    [anon_sym_import] = ACTIONS(2752),
    [anon_sym_var] = ACTIONS(2752),
    [anon_sym_let] = ACTIONS(2752),
    [anon_sym_const] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2752),
    [anon_sym_else] = ACTIONS(2752),
    [anon_sym_switch] = ACTIONS(2752),
    [anon_sym_for] = ACTIONS(2752),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_await] = ACTIONS(2752),
    [anon_sym_while] = ACTIONS(2752),
    [anon_sym_do] = ACTIONS(2752),
    [anon_sym_try] = ACTIONS(2752),
    [anon_sym_with] = ACTIONS(2752),
    [anon_sym_break] = ACTIONS(2752),
    [anon_sym_continue] = ACTIONS(2752),
    [anon_sym_debugger] = ACTIONS(2752),
    [anon_sym_return] = ACTIONS(2752),
    [anon_sym_throw] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_case] = ACTIONS(2752),
    [anon_sym_yield] = ACTIONS(2752),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_SLASH] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2752),
    [anon_sym_async] = ACTIONS(2752),
    [anon_sym_function] = ACTIONS(2752),
    [anon_sym_new] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2752),
    [anon_sym_BANG] = ACTIONS(2750),
    [anon_sym_TILDE] = ACTIONS(2750),
    [anon_sym_void] = ACTIONS(2752),
    [anon_sym_delete] = ACTIONS(2752),
    [anon_sym_PLUS_PLUS] = ACTIONS(2750),
    [anon_sym_DASH_DASH] = ACTIONS(2750),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2750),
    [sym_number] = ACTIONS(2750),
    [sym_this] = ACTIONS(2752),
    [sym_super] = ACTIONS(2752),
    [sym_true] = ACTIONS(2752),
    [sym_false] = ACTIONS(2752),
    [sym_null] = ACTIONS(2752),
    [sym_undefined] = ACTIONS(2752),
    [anon_sym_AT] = ACTIONS(2750),
    [anon_sym_static] = ACTIONS(2752),
    [anon_sym_abstract] = ACTIONS(2752),
    [anon_sym_get] = ACTIONS(2752),
    [anon_sym_set] = ACTIONS(2752),
    [anon_sym_declare] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2752),
    [anon_sym_private] = ACTIONS(2752),
    [anon_sym_protected] = ACTIONS(2752),
    [anon_sym_module] = ACTIONS(2752),
    [anon_sym_any] = ACTIONS(2752),
    [anon_sym_number] = ACTIONS(2752),
    [anon_sym_boolean] = ACTIONS(2752),
    [anon_sym_string] = ACTIONS(2752),
    [anon_sym_symbol] = ACTIONS(2752),
    [anon_sym_interface] = ACTIONS(2752),
    [anon_sym_enum] = ACTIONS(2752),
    [sym_readonly] = ACTIONS(2752),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(2754),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_export] = ACTIONS(2756),
    [anon_sym_default] = ACTIONS(2756),
    [anon_sym_namespace] = ACTIONS(2756),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_type] = ACTIONS(2756),
    [anon_sym_typeof] = ACTIONS(2756),
    [anon_sym_import] = ACTIONS(2756),
    [anon_sym_var] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_else] = ACTIONS(2756),
    [anon_sym_switch] = ACTIONS(2756),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_await] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_break] = ACTIONS(2756),
    [anon_sym_continue] = ACTIONS(2756),
    [anon_sym_debugger] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_throw] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_case] = ACTIONS(2756),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_SLASH] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2756),
    [anon_sym_async] = ACTIONS(2756),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_BANG] = ACTIONS(2754),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_void] = ACTIONS(2756),
    [anon_sym_delete] = ACTIONS(2756),
    [anon_sym_PLUS_PLUS] = ACTIONS(2754),
    [anon_sym_DASH_DASH] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [sym_number] = ACTIONS(2754),
    [sym_this] = ACTIONS(2756),
    [sym_super] = ACTIONS(2756),
    [sym_true] = ACTIONS(2756),
    [sym_false] = ACTIONS(2756),
    [sym_null] = ACTIONS(2756),
    [sym_undefined] = ACTIONS(2756),
    [anon_sym_AT] = ACTIONS(2754),
    [anon_sym_static] = ACTIONS(2756),
    [anon_sym_abstract] = ACTIONS(2756),
    [anon_sym_get] = ACTIONS(2756),
    [anon_sym_set] = ACTIONS(2756),
    [anon_sym_declare] = ACTIONS(2756),
    [anon_sym_public] = ACTIONS(2756),
    [anon_sym_private] = ACTIONS(2756),
    [anon_sym_protected] = ACTIONS(2756),
    [anon_sym_module] = ACTIONS(2756),
    [anon_sym_any] = ACTIONS(2756),
    [anon_sym_number] = ACTIONS(2756),
    [anon_sym_boolean] = ACTIONS(2756),
    [anon_sym_string] = ACTIONS(2756),
    [anon_sym_symbol] = ACTIONS(2756),
    [anon_sym_interface] = ACTIONS(2756),
    [anon_sym_enum] = ACTIONS(2756),
    [sym_readonly] = ACTIONS(2756),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(2758),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_export] = ACTIONS(2760),
    [anon_sym_default] = ACTIONS(2760),
    [anon_sym_namespace] = ACTIONS(2760),
    [anon_sym_LBRACE] = ACTIONS(2758),
    [anon_sym_RBRACE] = ACTIONS(2758),
    [anon_sym_type] = ACTIONS(2760),
    [anon_sym_typeof] = ACTIONS(2760),
    [anon_sym_import] = ACTIONS(2760),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_const] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_else] = ACTIONS(2760),
    [anon_sym_switch] = ACTIONS(2760),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_await] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_break] = ACTIONS(2760),
    [anon_sym_continue] = ACTIONS(2760),
    [anon_sym_debugger] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_throw] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_case] = ACTIONS(2760),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_SLASH] = ACTIONS(2760),
    [anon_sym_class] = ACTIONS(2760),
    [anon_sym_async] = ACTIONS(2760),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_BANG] = ACTIONS(2758),
    [anon_sym_TILDE] = ACTIONS(2758),
    [anon_sym_void] = ACTIONS(2760),
    [anon_sym_delete] = ACTIONS(2760),
    [anon_sym_PLUS_PLUS] = ACTIONS(2758),
    [anon_sym_DASH_DASH] = ACTIONS(2758),
    [anon_sym_DQUOTE] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2758),
    [sym_number] = ACTIONS(2758),
    [sym_this] = ACTIONS(2760),
    [sym_super] = ACTIONS(2760),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_null] = ACTIONS(2760),
    [sym_undefined] = ACTIONS(2760),
    [anon_sym_AT] = ACTIONS(2758),
    [anon_sym_static] = ACTIONS(2760),
    [anon_sym_abstract] = ACTIONS(2760),
    [anon_sym_get] = ACTIONS(2760),
    [anon_sym_set] = ACTIONS(2760),
    [anon_sym_declare] = ACTIONS(2760),
    [anon_sym_public] = ACTIONS(2760),
    [anon_sym_private] = ACTIONS(2760),
    [anon_sym_protected] = ACTIONS(2760),
    [anon_sym_module] = ACTIONS(2760),
    [anon_sym_any] = ACTIONS(2760),
    [anon_sym_number] = ACTIONS(2760),
    [anon_sym_boolean] = ACTIONS(2760),
    [anon_sym_string] = ACTIONS(2760),
    [anon_sym_symbol] = ACTIONS(2760),
    [anon_sym_interface] = ACTIONS(2760),
    [anon_sym_enum] = ACTIONS(2760),
    [sym_readonly] = ACTIONS(2760),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(2762),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_export] = ACTIONS(2764),
    [anon_sym_default] = ACTIONS(2764),
    [anon_sym_namespace] = ACTIONS(2764),
    [anon_sym_LBRACE] = ACTIONS(2762),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_type] = ACTIONS(2764),
    [anon_sym_typeof] = ACTIONS(2764),
    [anon_sym_import] = ACTIONS(2764),
    [anon_sym_var] = ACTIONS(2764),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_else] = ACTIONS(2764),
    [anon_sym_switch] = ACTIONS(2764),
    [anon_sym_for] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_await] = ACTIONS(2764),
    [anon_sym_while] = ACTIONS(2764),
    [anon_sym_do] = ACTIONS(2764),
    [anon_sym_try] = ACTIONS(2764),
    [anon_sym_with] = ACTIONS(2764),
    [anon_sym_break] = ACTIONS(2764),
    [anon_sym_continue] = ACTIONS(2764),
    [anon_sym_debugger] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(2764),
    [anon_sym_throw] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_case] = ACTIONS(2764),
    [anon_sym_yield] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(2764),
    [anon_sym_class] = ACTIONS(2764),
    [anon_sym_async] = ACTIONS(2764),
    [anon_sym_function] = ACTIONS(2764),
    [anon_sym_new] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(2762),
    [anon_sym_TILDE] = ACTIONS(2762),
    [anon_sym_void] = ACTIONS(2764),
    [anon_sym_delete] = ACTIONS(2764),
    [anon_sym_PLUS_PLUS] = ACTIONS(2762),
    [anon_sym_DASH_DASH] = ACTIONS(2762),
    [anon_sym_DQUOTE] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2762),
    [sym_number] = ACTIONS(2762),
    [sym_this] = ACTIONS(2764),
    [sym_super] = ACTIONS(2764),
    [sym_true] = ACTIONS(2764),
    [sym_false] = ACTIONS(2764),
    [sym_null] = ACTIONS(2764),
    [sym_undefined] = ACTIONS(2764),
    [anon_sym_AT] = ACTIONS(2762),
    [anon_sym_static] = ACTIONS(2764),
    [anon_sym_abstract] = ACTIONS(2764),
    [anon_sym_get] = ACTIONS(2764),
    [anon_sym_set] = ACTIONS(2764),
    [anon_sym_declare] = ACTIONS(2764),
    [anon_sym_public] = ACTIONS(2764),
    [anon_sym_private] = ACTIONS(2764),
    [anon_sym_protected] = ACTIONS(2764),
    [anon_sym_module] = ACTIONS(2764),
    [anon_sym_any] = ACTIONS(2764),
    [anon_sym_number] = ACTIONS(2764),
    [anon_sym_boolean] = ACTIONS(2764),
    [anon_sym_string] = ACTIONS(2764),
    [anon_sym_symbol] = ACTIONS(2764),
    [anon_sym_interface] = ACTIONS(2764),
    [anon_sym_enum] = ACTIONS(2764),
    [sym_readonly] = ACTIONS(2764),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(2766),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_export] = ACTIONS(2768),
    [anon_sym_default] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_typeof] = ACTIONS(2768),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_var] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_else] = ACTIONS(2768),
    [anon_sym_switch] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_await] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_break] = ACTIONS(2768),
    [anon_sym_continue] = ACTIONS(2768),
    [anon_sym_debugger] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_throw] = ACTIONS(2768),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_case] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_SLASH] = ACTIONS(2768),
    [anon_sym_class] = ACTIONS(2768),
    [anon_sym_async] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_BANG] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2766),
    [anon_sym_void] = ACTIONS(2768),
    [anon_sym_delete] = ACTIONS(2768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2766),
    [anon_sym_DASH_DASH] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2766),
    [sym_number] = ACTIONS(2766),
    [sym_this] = ACTIONS(2768),
    [sym_super] = ACTIONS(2768),
    [sym_true] = ACTIONS(2768),
    [sym_false] = ACTIONS(2768),
    [sym_null] = ACTIONS(2768),
    [sym_undefined] = ACTIONS(2768),
    [anon_sym_AT] = ACTIONS(2766),
    [anon_sym_static] = ACTIONS(2768),
    [anon_sym_abstract] = ACTIONS(2768),
    [anon_sym_get] = ACTIONS(2768),
    [anon_sym_set] = ACTIONS(2768),
    [anon_sym_declare] = ACTIONS(2768),
    [anon_sym_public] = ACTIONS(2768),
    [anon_sym_private] = ACTIONS(2768),
    [anon_sym_protected] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_any] = ACTIONS(2768),
    [anon_sym_number] = ACTIONS(2768),
    [anon_sym_boolean] = ACTIONS(2768),
    [anon_sym_string] = ACTIONS(2768),
    [anon_sym_symbol] = ACTIONS(2768),
    [anon_sym_interface] = ACTIONS(2768),
    [anon_sym_enum] = ACTIONS(2768),
    [sym_readonly] = ACTIONS(2768),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_default] = ACTIONS(2772),
    [anon_sym_namespace] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_type] = ACTIONS(2772),
    [anon_sym_typeof] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_var] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2772),
    [anon_sym_switch] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_await] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [anon_sym_do] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_with] = ACTIONS(2772),
    [anon_sym_break] = ACTIONS(2772),
    [anon_sym_continue] = ACTIONS(2772),
    [anon_sym_debugger] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_throw] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_case] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2772),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_DASH] = ACTIONS(2772),
    [anon_sym_BANG] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [anon_sym_void] = ACTIONS(2772),
    [anon_sym_delete] = ACTIONS(2772),
    [anon_sym_PLUS_PLUS] = ACTIONS(2770),
    [anon_sym_DASH_DASH] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2770),
    [sym_number] = ACTIONS(2770),
    [sym_this] = ACTIONS(2772),
    [sym_super] = ACTIONS(2772),
    [sym_true] = ACTIONS(2772),
    [sym_false] = ACTIONS(2772),
    [sym_null] = ACTIONS(2772),
    [sym_undefined] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2770),
    [anon_sym_static] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_get] = ACTIONS(2772),
    [anon_sym_set] = ACTIONS(2772),
    [anon_sym_declare] = ACTIONS(2772),
    [anon_sym_public] = ACTIONS(2772),
    [anon_sym_private] = ACTIONS(2772),
    [anon_sym_protected] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_any] = ACTIONS(2772),
    [anon_sym_number] = ACTIONS(2772),
    [anon_sym_boolean] = ACTIONS(2772),
    [anon_sym_string] = ACTIONS(2772),
    [anon_sym_symbol] = ACTIONS(2772),
    [anon_sym_interface] = ACTIONS(2772),
    [anon_sym_enum] = ACTIONS(2772),
    [sym_readonly] = ACTIONS(2772),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(2774),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_export] = ACTIONS(2776),
    [anon_sym_default] = ACTIONS(2776),
    [anon_sym_namespace] = ACTIONS(2776),
    [anon_sym_LBRACE] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_type] = ACTIONS(2776),
    [anon_sym_typeof] = ACTIONS(2776),
    [anon_sym_import] = ACTIONS(2776),
    [anon_sym_var] = ACTIONS(2776),
    [anon_sym_let] = ACTIONS(2776),
    [anon_sym_const] = ACTIONS(2776),
    [anon_sym_if] = ACTIONS(2776),
    [anon_sym_else] = ACTIONS(2776),
    [anon_sym_switch] = ACTIONS(2776),
    [anon_sym_for] = ACTIONS(2776),
    [anon_sym_LPAREN] = ACTIONS(2774),
    [anon_sym_await] = ACTIONS(2776),
    [anon_sym_while] = ACTIONS(2776),
    [anon_sym_do] = ACTIONS(2776),
    [anon_sym_try] = ACTIONS(2776),
    [anon_sym_with] = ACTIONS(2776),
    [anon_sym_break] = ACTIONS(2776),
    [anon_sym_continue] = ACTIONS(2776),
    [anon_sym_debugger] = ACTIONS(2776),
    [anon_sym_return] = ACTIONS(2776),
    [anon_sym_throw] = ACTIONS(2776),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_case] = ACTIONS(2776),
    [anon_sym_yield] = ACTIONS(2776),
    [anon_sym_LBRACK] = ACTIONS(2774),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2776),
    [anon_sym_class] = ACTIONS(2776),
    [anon_sym_async] = ACTIONS(2776),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_new] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2776),
    [anon_sym_DASH] = ACTIONS(2776),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2774),
    [anon_sym_void] = ACTIONS(2776),
    [anon_sym_delete] = ACTIONS(2776),
    [anon_sym_PLUS_PLUS] = ACTIONS(2774),
    [anon_sym_DASH_DASH] = ACTIONS(2774),
    [anon_sym_DQUOTE] = ACTIONS(2774),
    [anon_sym_SQUOTE] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2774),
    [sym_number] = ACTIONS(2774),
    [sym_this] = ACTIONS(2776),
    [sym_super] = ACTIONS(2776),
    [sym_true] = ACTIONS(2776),
    [sym_false] = ACTIONS(2776),
    [sym_null] = ACTIONS(2776),
    [sym_undefined] = ACTIONS(2776),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_static] = ACTIONS(2776),
    [anon_sym_abstract] = ACTIONS(2776),
    [anon_sym_get] = ACTIONS(2776),
    [anon_sym_set] = ACTIONS(2776),
    [anon_sym_declare] = ACTIONS(2776),
    [anon_sym_public] = ACTIONS(2776),
    [anon_sym_private] = ACTIONS(2776),
    [anon_sym_protected] = ACTIONS(2776),
    [anon_sym_module] = ACTIONS(2776),
    [anon_sym_any] = ACTIONS(2776),
    [anon_sym_number] = ACTIONS(2776),
    [anon_sym_boolean] = ACTIONS(2776),
    [anon_sym_string] = ACTIONS(2776),
    [anon_sym_symbol] = ACTIONS(2776),
    [anon_sym_interface] = ACTIONS(2776),
    [anon_sym_enum] = ACTIONS(2776),
    [sym_readonly] = ACTIONS(2776),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(2778),
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_export] = ACTIONS(2780),
    [anon_sym_default] = ACTIONS(2780),
    [anon_sym_namespace] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_type] = ACTIONS(2780),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_import] = ACTIONS(2780),
    [anon_sym_var] = ACTIONS(2780),
    [anon_sym_let] = ACTIONS(2780),
    [anon_sym_const] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_switch] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2778),
    [anon_sym_await] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_try] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_break] = ACTIONS(2780),
    [anon_sym_continue] = ACTIONS(2780),
    [anon_sym_debugger] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_throw] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_case] = ACTIONS(2780),
    [anon_sym_yield] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_SLASH] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_function] = ACTIONS(2780),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2778),
    [anon_sym_TILDE] = ACTIONS(2778),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_delete] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2778),
    [anon_sym_DASH_DASH] = ACTIONS(2778),
    [anon_sym_DQUOTE] = ACTIONS(2778),
    [anon_sym_SQUOTE] = ACTIONS(2778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2778),
    [sym_number] = ACTIONS(2778),
    [sym_this] = ACTIONS(2780),
    [sym_super] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_AT] = ACTIONS(2778),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2780),
    [anon_sym_set] = ACTIONS(2780),
    [anon_sym_declare] = ACTIONS(2780),
    [anon_sym_public] = ACTIONS(2780),
    [anon_sym_private] = ACTIONS(2780),
    [anon_sym_protected] = ACTIONS(2780),
    [anon_sym_module] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_interface] = ACTIONS(2780),
    [anon_sym_enum] = ACTIONS(2780),
    [sym_readonly] = ACTIONS(2780),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(2782),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_default] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_var] = ACTIONS(2784),
    [anon_sym_let] = ACTIONS(2784),
    [anon_sym_const] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2784),
    [anon_sym_switch] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2784),
    [anon_sym_with] = ACTIONS(2784),
    [anon_sym_break] = ACTIONS(2784),
    [anon_sym_continue] = ACTIONS(2784),
    [anon_sym_debugger] = ACTIONS(2784),
    [anon_sym_return] = ACTIONS(2784),
    [anon_sym_throw] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_case] = ACTIONS(2784),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2784),
    [anon_sym_enum] = ACTIONS(2784),
    [sym_readonly] = ACTIONS(2784),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(2786),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_default] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_var] = ACTIONS(2788),
    [anon_sym_let] = ACTIONS(2788),
    [anon_sym_const] = ACTIONS(2788),
    [anon_sym_if] = ACTIONS(2788),
    [anon_sym_else] = ACTIONS(2788),
    [anon_sym_switch] = ACTIONS(2788),
    [anon_sym_for] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_while] = ACTIONS(2788),
    [anon_sym_do] = ACTIONS(2788),
    [anon_sym_try] = ACTIONS(2788),
    [anon_sym_with] = ACTIONS(2788),
    [anon_sym_break] = ACTIONS(2788),
    [anon_sym_continue] = ACTIONS(2788),
    [anon_sym_debugger] = ACTIONS(2788),
    [anon_sym_return] = ACTIONS(2788),
    [anon_sym_throw] = ACTIONS(2788),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_case] = ACTIONS(2788),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_abstract] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_interface] = ACTIONS(2788),
    [anon_sym_enum] = ACTIONS(2788),
    [sym_readonly] = ACTIONS(2788),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(2790),
    [sym_identifier] = ACTIONS(2792),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_default] = ACTIONS(2792),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_typeof] = ACTIONS(2792),
    [anon_sym_import] = ACTIONS(2792),
    [anon_sym_var] = ACTIONS(2792),
    [anon_sym_let] = ACTIONS(2792),
    [anon_sym_const] = ACTIONS(2792),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_else] = ACTIONS(2792),
    [anon_sym_switch] = ACTIONS(2792),
    [anon_sym_for] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(2790),
    [anon_sym_await] = ACTIONS(2792),
    [anon_sym_while] = ACTIONS(2792),
    [anon_sym_do] = ACTIONS(2792),
    [anon_sym_try] = ACTIONS(2792),
    [anon_sym_with] = ACTIONS(2792),
    [anon_sym_break] = ACTIONS(2792),
    [anon_sym_continue] = ACTIONS(2792),
    [anon_sym_debugger] = ACTIONS(2792),
    [anon_sym_return] = ACTIONS(2792),
    [anon_sym_throw] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2790),
    [anon_sym_case] = ACTIONS(2792),
    [anon_sym_yield] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_SLASH] = ACTIONS(2792),
    [anon_sym_class] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_function] = ACTIONS(2792),
    [anon_sym_new] = ACTIONS(2792),
    [anon_sym_PLUS] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_TILDE] = ACTIONS(2790),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_delete] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2790),
    [anon_sym_DASH_DASH] = ACTIONS(2790),
    [anon_sym_DQUOTE] = ACTIONS(2790),
    [anon_sym_SQUOTE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2790),
    [sym_number] = ACTIONS(2790),
    [sym_this] = ACTIONS(2792),
    [sym_super] = ACTIONS(2792),
    [sym_true] = ACTIONS(2792),
    [sym_false] = ACTIONS(2792),
    [sym_null] = ACTIONS(2792),
    [sym_undefined] = ACTIONS(2792),
    [anon_sym_AT] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_abstract] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [anon_sym_interface] = ACTIONS(2792),
    [anon_sym_enum] = ACTIONS(2792),
    [sym_readonly] = ACTIONS(2792),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(2796),
    [anon_sym_export] = ACTIONS(2796),
    [anon_sym_default] = ACTIONS(2796),
    [anon_sym_namespace] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2796),
    [anon_sym_typeof] = ACTIONS(2796),
    [anon_sym_import] = ACTIONS(2796),
    [anon_sym_var] = ACTIONS(2796),
    [anon_sym_let] = ACTIONS(2796),
    [anon_sym_const] = ACTIONS(2796),
    [anon_sym_if] = ACTIONS(2796),
    [anon_sym_else] = ACTIONS(2796),
    [anon_sym_switch] = ACTIONS(2796),
    [anon_sym_for] = ACTIONS(2796),
    [anon_sym_LPAREN] = ACTIONS(2794),
    [anon_sym_await] = ACTIONS(2796),
    [anon_sym_while] = ACTIONS(2796),
    [anon_sym_do] = ACTIONS(2796),
    [anon_sym_try] = ACTIONS(2796),
    [anon_sym_with] = ACTIONS(2796),
    [anon_sym_break] = ACTIONS(2796),
    [anon_sym_continue] = ACTIONS(2796),
    [anon_sym_debugger] = ACTIONS(2796),
    [anon_sym_return] = ACTIONS(2796),
    [anon_sym_throw] = ACTIONS(2796),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2796),
    [anon_sym_yield] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_SLASH] = ACTIONS(2796),
    [anon_sym_class] = ACTIONS(2796),
    [anon_sym_async] = ACTIONS(2796),
    [anon_sym_function] = ACTIONS(2796),
    [anon_sym_new] = ACTIONS(2796),
    [anon_sym_PLUS] = ACTIONS(2796),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_TILDE] = ACTIONS(2794),
    [anon_sym_void] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(2796),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2794),
    [sym_number] = ACTIONS(2794),
    [sym_this] = ACTIONS(2796),
    [sym_super] = ACTIONS(2796),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_null] = ACTIONS(2796),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_AT] = ACTIONS(2794),
    [anon_sym_static] = ACTIONS(2796),
    [anon_sym_abstract] = ACTIONS(2796),
    [anon_sym_get] = ACTIONS(2796),
    [anon_sym_set] = ACTIONS(2796),
    [anon_sym_declare] = ACTIONS(2796),
    [anon_sym_public] = ACTIONS(2796),
    [anon_sym_private] = ACTIONS(2796),
    [anon_sym_protected] = ACTIONS(2796),
    [anon_sym_module] = ACTIONS(2796),
    [anon_sym_any] = ACTIONS(2796),
    [anon_sym_number] = ACTIONS(2796),
    [anon_sym_boolean] = ACTIONS(2796),
    [anon_sym_string] = ACTIONS(2796),
    [anon_sym_symbol] = ACTIONS(2796),
    [anon_sym_interface] = ACTIONS(2796),
    [anon_sym_enum] = ACTIONS(2796),
    [sym_readonly] = ACTIONS(2796),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(2798),
    [sym_identifier] = ACTIONS(2800),
    [anon_sym_export] = ACTIONS(2800),
    [anon_sym_default] = ACTIONS(2800),
    [anon_sym_namespace] = ACTIONS(2800),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_type] = ACTIONS(2800),
    [anon_sym_typeof] = ACTIONS(2800),
    [anon_sym_import] = ACTIONS(2800),
    [anon_sym_var] = ACTIONS(2800),
    [anon_sym_let] = ACTIONS(2800),
    [anon_sym_const] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(2800),
    [anon_sym_else] = ACTIONS(2800),
    [anon_sym_switch] = ACTIONS(2800),
    [anon_sym_for] = ACTIONS(2800),
    [anon_sym_LPAREN] = ACTIONS(2798),
    [anon_sym_await] = ACTIONS(2800),
    [anon_sym_while] = ACTIONS(2800),
    [anon_sym_do] = ACTIONS(2800),
    [anon_sym_try] = ACTIONS(2800),
    [anon_sym_with] = ACTIONS(2800),
    [anon_sym_break] = ACTIONS(2800),
    [anon_sym_continue] = ACTIONS(2800),
    [anon_sym_debugger] = ACTIONS(2800),
    [anon_sym_return] = ACTIONS(2800),
    [anon_sym_throw] = ACTIONS(2800),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_case] = ACTIONS(2800),
    [anon_sym_yield] = ACTIONS(2800),
    [anon_sym_LBRACK] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_SLASH] = ACTIONS(2800),
    [anon_sym_class] = ACTIONS(2800),
    [anon_sym_async] = ACTIONS(2800),
    [anon_sym_function] = ACTIONS(2800),
    [anon_sym_new] = ACTIONS(2800),
    [anon_sym_PLUS] = ACTIONS(2800),
    [anon_sym_DASH] = ACTIONS(2800),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_TILDE] = ACTIONS(2798),
    [anon_sym_void] = ACTIONS(2800),
    [anon_sym_delete] = ACTIONS(2800),
    [anon_sym_PLUS_PLUS] = ACTIONS(2798),
    [anon_sym_DASH_DASH] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2798),
    [anon_sym_SQUOTE] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2798),
    [sym_number] = ACTIONS(2798),
    [sym_this] = ACTIONS(2800),
    [sym_super] = ACTIONS(2800),
    [sym_true] = ACTIONS(2800),
    [sym_false] = ACTIONS(2800),
    [sym_null] = ACTIONS(2800),
    [sym_undefined] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2798),
    [anon_sym_static] = ACTIONS(2800),
    [anon_sym_abstract] = ACTIONS(2800),
    [anon_sym_get] = ACTIONS(2800),
    [anon_sym_set] = ACTIONS(2800),
    [anon_sym_declare] = ACTIONS(2800),
    [anon_sym_public] = ACTIONS(2800),
    [anon_sym_private] = ACTIONS(2800),
    [anon_sym_protected] = ACTIONS(2800),
    [anon_sym_module] = ACTIONS(2800),
    [anon_sym_any] = ACTIONS(2800),
    [anon_sym_number] = ACTIONS(2800),
    [anon_sym_boolean] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2800),
    [anon_sym_symbol] = ACTIONS(2800),
    [anon_sym_interface] = ACTIONS(2800),
    [anon_sym_enum] = ACTIONS(2800),
    [sym_readonly] = ACTIONS(2800),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(2802),
    [sym_identifier] = ACTIONS(2804),
    [anon_sym_export] = ACTIONS(2804),
    [anon_sym_default] = ACTIONS(2804),
    [anon_sym_namespace] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_type] = ACTIONS(2804),
    [anon_sym_typeof] = ACTIONS(2804),
    [anon_sym_import] = ACTIONS(2804),
    [anon_sym_var] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(2804),
    [anon_sym_const] = ACTIONS(2804),
    [anon_sym_if] = ACTIONS(2804),
    [anon_sym_else] = ACTIONS(2804),
    [anon_sym_switch] = ACTIONS(2804),
    [anon_sym_for] = ACTIONS(2804),
    [anon_sym_LPAREN] = ACTIONS(2802),
    [anon_sym_await] = ACTIONS(2804),
    [anon_sym_while] = ACTIONS(2804),
    [anon_sym_do] = ACTIONS(2804),
    [anon_sym_try] = ACTIONS(2804),
    [anon_sym_with] = ACTIONS(2804),
    [anon_sym_break] = ACTIONS(2804),
    [anon_sym_continue] = ACTIONS(2804),
    [anon_sym_debugger] = ACTIONS(2804),
    [anon_sym_return] = ACTIONS(2804),
    [anon_sym_throw] = ACTIONS(2804),
    [anon_sym_SEMI] = ACTIONS(2802),
    [anon_sym_case] = ACTIONS(2804),
    [anon_sym_yield] = ACTIONS(2804),
    [anon_sym_LBRACK] = ACTIONS(2802),
    [anon_sym_LT] = ACTIONS(2802),
    [anon_sym_SLASH] = ACTIONS(2804),
    [anon_sym_class] = ACTIONS(2804),
    [anon_sym_async] = ACTIONS(2804),
    [anon_sym_function] = ACTIONS(2804),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_PLUS] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [anon_sym_BANG] = ACTIONS(2802),
    [anon_sym_TILDE] = ACTIONS(2802),
    [anon_sym_void] = ACTIONS(2804),
    [anon_sym_delete] = ACTIONS(2804),
    [anon_sym_PLUS_PLUS] = ACTIONS(2802),
    [anon_sym_DASH_DASH] = ACTIONS(2802),
    [anon_sym_DQUOTE] = ACTIONS(2802),
    [anon_sym_SQUOTE] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2802),
    [sym_number] = ACTIONS(2802),
    [sym_this] = ACTIONS(2804),
    [sym_super] = ACTIONS(2804),
    [sym_true] = ACTIONS(2804),
    [sym_false] = ACTIONS(2804),
    [sym_null] = ACTIONS(2804),
    [sym_undefined] = ACTIONS(2804),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_static] = ACTIONS(2804),
    [anon_sym_abstract] = ACTIONS(2804),
    [anon_sym_get] = ACTIONS(2804),
    [anon_sym_set] = ACTIONS(2804),
    [anon_sym_declare] = ACTIONS(2804),
    [anon_sym_public] = ACTIONS(2804),
    [anon_sym_private] = ACTIONS(2804),
    [anon_sym_protected] = ACTIONS(2804),
    [anon_sym_module] = ACTIONS(2804),
    [anon_sym_any] = ACTIONS(2804),
    [anon_sym_number] = ACTIONS(2804),
    [anon_sym_boolean] = ACTIONS(2804),
    [anon_sym_string] = ACTIONS(2804),
    [anon_sym_symbol] = ACTIONS(2804),
    [anon_sym_interface] = ACTIONS(2804),
    [anon_sym_enum] = ACTIONS(2804),
    [sym_readonly] = ACTIONS(2804),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1211),
    [anon_sym_default] = ACTIONS(1211),
    [anon_sym_namespace] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_type] = ACTIONS(1211),
    [anon_sym_typeof] = ACTIONS(1211),
    [anon_sym_import] = ACTIONS(1211),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1211),
    [anon_sym_const] = ACTIONS(1211),
    [anon_sym_if] = ACTIONS(1211),
    [anon_sym_else] = ACTIONS(1211),
    [anon_sym_switch] = ACTIONS(1211),
    [anon_sym_for] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_await] = ACTIONS(1211),
    [anon_sym_while] = ACTIONS(1211),
    [anon_sym_do] = ACTIONS(1211),
    [anon_sym_try] = ACTIONS(1211),
    [anon_sym_with] = ACTIONS(1211),
    [anon_sym_break] = ACTIONS(1211),
    [anon_sym_continue] = ACTIONS(1211),
    [anon_sym_debugger] = ACTIONS(1211),
    [anon_sym_return] = ACTIONS(1211),
    [anon_sym_throw] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1211),
    [anon_sym_yield] = ACTIONS(1211),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1209),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_class] = ACTIONS(1211),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_function] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1211),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_void] = ACTIONS(1211),
    [anon_sym_delete] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym_number] = ACTIONS(1209),
    [sym_this] = ACTIONS(1211),
    [sym_super] = ACTIONS(1211),
    [sym_true] = ACTIONS(1211),
    [sym_false] = ACTIONS(1211),
    [sym_null] = ACTIONS(1211),
    [sym_undefined] = ACTIONS(1211),
    [anon_sym_AT] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1211),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1211),
    [anon_sym_declare] = ACTIONS(1211),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_module] = ACTIONS(1211),
    [anon_sym_any] = ACTIONS(1211),
    [anon_sym_number] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1211),
    [anon_sym_symbol] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1211),
    [anon_sym_enum] = ACTIONS(1211),
    [sym_readonly] = ACTIONS(1211),
  },
  [549] = {
    [sym__call_signature] = STATE(3108),
    [sym_arguments] = STATE(1534),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2806),
    [anon_sym_export] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_namespace] = ACTIONS(2808),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_void] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2808),
    [anon_sym_set] = ACTIONS(2808),
    [anon_sym_declare] = ACTIONS(2808),
    [anon_sym_public] = ACTIONS(2808),
    [anon_sym_private] = ACTIONS(2808),
    [anon_sym_protected] = ACTIONS(2808),
    [anon_sym_module] = ACTIONS(2808),
    [anon_sym_any] = ACTIONS(2808),
    [anon_sym_number] = ACTIONS(2808),
    [anon_sym_boolean] = ACTIONS(2808),
    [anon_sym_string] = ACTIONS(2808),
    [anon_sym_symbol] = ACTIONS(2808),
    [sym_readonly] = ACTIONS(2808),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(2810),
    [sym_identifier] = ACTIONS(2812),
    [anon_sym_export] = ACTIONS(2812),
    [anon_sym_default] = ACTIONS(2812),
    [anon_sym_namespace] = ACTIONS(2812),
    [anon_sym_LBRACE] = ACTIONS(2810),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_type] = ACTIONS(2812),
    [anon_sym_typeof] = ACTIONS(2812),
    [anon_sym_import] = ACTIONS(2812),
    [anon_sym_var] = ACTIONS(2812),
    [anon_sym_let] = ACTIONS(2812),
    [anon_sym_const] = ACTIONS(2812),
    [anon_sym_if] = ACTIONS(2812),
    [anon_sym_else] = ACTIONS(2812),
    [anon_sym_switch] = ACTIONS(2812),
    [anon_sym_for] = ACTIONS(2812),
    [anon_sym_LPAREN] = ACTIONS(2810),
    [anon_sym_await] = ACTIONS(2812),
    [anon_sym_while] = ACTIONS(2812),
    [anon_sym_do] = ACTIONS(2812),
    [anon_sym_try] = ACTIONS(2812),
    [anon_sym_with] = ACTIONS(2812),
    [anon_sym_break] = ACTIONS(2812),
    [anon_sym_continue] = ACTIONS(2812),
    [anon_sym_debugger] = ACTIONS(2812),
    [anon_sym_return] = ACTIONS(2812),
    [anon_sym_throw] = ACTIONS(2812),
    [anon_sym_SEMI] = ACTIONS(2810),
    [anon_sym_case] = ACTIONS(2812),
    [anon_sym_yield] = ACTIONS(2812),
    [anon_sym_LBRACK] = ACTIONS(2810),
    [anon_sym_LT] = ACTIONS(2810),
    [anon_sym_SLASH] = ACTIONS(2812),
    [anon_sym_class] = ACTIONS(2812),
    [anon_sym_async] = ACTIONS(2812),
    [anon_sym_function] = ACTIONS(2812),
    [anon_sym_new] = ACTIONS(2812),
    [anon_sym_PLUS] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [anon_sym_BANG] = ACTIONS(2810),
    [anon_sym_TILDE] = ACTIONS(2810),
    [anon_sym_void] = ACTIONS(2812),
    [anon_sym_delete] = ACTIONS(2812),
    [anon_sym_PLUS_PLUS] = ACTIONS(2810),
    [anon_sym_DASH_DASH] = ACTIONS(2810),
    [anon_sym_DQUOTE] = ACTIONS(2810),
    [anon_sym_SQUOTE] = ACTIONS(2810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2810),
    [sym_number] = ACTIONS(2810),
    [sym_this] = ACTIONS(2812),
    [sym_super] = ACTIONS(2812),
    [sym_true] = ACTIONS(2812),
    [sym_false] = ACTIONS(2812),
    [sym_null] = ACTIONS(2812),
    [sym_undefined] = ACTIONS(2812),
    [anon_sym_AT] = ACTIONS(2810),
    [anon_sym_static] = ACTIONS(2812),
    [anon_sym_abstract] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2812),
    [anon_sym_set] = ACTIONS(2812),
    [anon_sym_declare] = ACTIONS(2812),
    [anon_sym_public] = ACTIONS(2812),
    [anon_sym_private] = ACTIONS(2812),
    [anon_sym_protected] = ACTIONS(2812),
    [anon_sym_module] = ACTIONS(2812),
    [anon_sym_any] = ACTIONS(2812),
    [anon_sym_number] = ACTIONS(2812),
    [anon_sym_boolean] = ACTIONS(2812),
    [anon_sym_string] = ACTIONS(2812),
    [anon_sym_symbol] = ACTIONS(2812),
    [anon_sym_interface] = ACTIONS(2812),
    [anon_sym_enum] = ACTIONS(2812),
    [sym_readonly] = ACTIONS(2812),
  },
  [551] = {
    [sym__call_signature] = STATE(3033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(2814),
    [sym_identifier] = ACTIONS(2816),
    [anon_sym_export] = ACTIONS(2816),
    [anon_sym_default] = ACTIONS(2816),
    [anon_sym_namespace] = ACTIONS(2816),
    [anon_sym_LBRACE] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_type] = ACTIONS(2816),
    [anon_sym_typeof] = ACTIONS(2816),
    [anon_sym_import] = ACTIONS(2816),
    [anon_sym_var] = ACTIONS(2816),
    [anon_sym_let] = ACTIONS(2816),
    [anon_sym_const] = ACTIONS(2816),
    [anon_sym_if] = ACTIONS(2816),
    [anon_sym_else] = ACTIONS(2816),
    [anon_sym_switch] = ACTIONS(2816),
    [anon_sym_for] = ACTIONS(2816),
    [anon_sym_LPAREN] = ACTIONS(2814),
    [anon_sym_await] = ACTIONS(2816),
    [anon_sym_while] = ACTIONS(2816),
    [anon_sym_do] = ACTIONS(2816),
    [anon_sym_try] = ACTIONS(2816),
    [anon_sym_with] = ACTIONS(2816),
    [anon_sym_break] = ACTIONS(2816),
    [anon_sym_continue] = ACTIONS(2816),
    [anon_sym_debugger] = ACTIONS(2816),
    [anon_sym_return] = ACTIONS(2816),
    [anon_sym_throw] = ACTIONS(2816),
    [anon_sym_SEMI] = ACTIONS(2814),
    [anon_sym_case] = ACTIONS(2816),
    [anon_sym_yield] = ACTIONS(2816),
    [anon_sym_LBRACK] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2814),
    [anon_sym_SLASH] = ACTIONS(2816),
    [anon_sym_class] = ACTIONS(2816),
    [anon_sym_async] = ACTIONS(2816),
    [anon_sym_function] = ACTIONS(2816),
    [anon_sym_new] = ACTIONS(2816),
    [anon_sym_PLUS] = ACTIONS(2816),
    [anon_sym_DASH] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2814),
    [anon_sym_TILDE] = ACTIONS(2814),
    [anon_sym_void] = ACTIONS(2816),
    [anon_sym_delete] = ACTIONS(2816),
    [anon_sym_PLUS_PLUS] = ACTIONS(2814),
    [anon_sym_DASH_DASH] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [anon_sym_SQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_number] = ACTIONS(2814),
    [sym_this] = ACTIONS(2816),
    [sym_super] = ACTIONS(2816),
    [sym_true] = ACTIONS(2816),
    [sym_false] = ACTIONS(2816),
    [sym_null] = ACTIONS(2816),
    [sym_undefined] = ACTIONS(2816),
    [anon_sym_AT] = ACTIONS(2814),
    [anon_sym_static] = ACTIONS(2816),
    [anon_sym_abstract] = ACTIONS(2816),
    [anon_sym_get] = ACTIONS(2816),
    [anon_sym_set] = ACTIONS(2816),
    [anon_sym_declare] = ACTIONS(2816),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_module] = ACTIONS(2816),
    [anon_sym_any] = ACTIONS(2816),
    [anon_sym_number] = ACTIONS(2816),
    [anon_sym_boolean] = ACTIONS(2816),
    [anon_sym_string] = ACTIONS(2816),
    [anon_sym_symbol] = ACTIONS(2816),
    [anon_sym_interface] = ACTIONS(2816),
    [anon_sym_enum] = ACTIONS(2816),
    [sym_readonly] = ACTIONS(2816),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(2818),
    [sym_identifier] = ACTIONS(2820),
    [anon_sym_export] = ACTIONS(2820),
    [anon_sym_default] = ACTIONS(2820),
    [anon_sym_namespace] = ACTIONS(2820),
    [anon_sym_LBRACE] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_type] = ACTIONS(2820),
    [anon_sym_typeof] = ACTIONS(2820),
    [anon_sym_import] = ACTIONS(2820),
    [anon_sym_var] = ACTIONS(2820),
    [anon_sym_let] = ACTIONS(2820),
    [anon_sym_const] = ACTIONS(2820),
    [anon_sym_if] = ACTIONS(2820),
    [anon_sym_else] = ACTIONS(2820),
    [anon_sym_switch] = ACTIONS(2820),
    [anon_sym_for] = ACTIONS(2820),
    [anon_sym_LPAREN] = ACTIONS(2818),
    [anon_sym_await] = ACTIONS(2820),
    [anon_sym_while] = ACTIONS(2820),
    [anon_sym_do] = ACTIONS(2820),
    [anon_sym_try] = ACTIONS(2820),
    [anon_sym_with] = ACTIONS(2820),
    [anon_sym_break] = ACTIONS(2820),
    [anon_sym_continue] = ACTIONS(2820),
    [anon_sym_debugger] = ACTIONS(2820),
    [anon_sym_return] = ACTIONS(2820),
    [anon_sym_throw] = ACTIONS(2820),
    [anon_sym_SEMI] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2820),
    [anon_sym_yield] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_SLASH] = ACTIONS(2820),
    [anon_sym_class] = ACTIONS(2820),
    [anon_sym_async] = ACTIONS(2820),
    [anon_sym_function] = ACTIONS(2820),
    [anon_sym_new] = ACTIONS(2820),
    [anon_sym_PLUS] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_TILDE] = ACTIONS(2818),
    [anon_sym_void] = ACTIONS(2820),
    [anon_sym_delete] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [anon_sym_SQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_number] = ACTIONS(2818),
    [sym_this] = ACTIONS(2820),
    [sym_super] = ACTIONS(2820),
    [sym_true] = ACTIONS(2820),
    [sym_false] = ACTIONS(2820),
    [sym_null] = ACTIONS(2820),
    [sym_undefined] = ACTIONS(2820),
    [anon_sym_AT] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2820),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_get] = ACTIONS(2820),
    [anon_sym_set] = ACTIONS(2820),
    [anon_sym_declare] = ACTIONS(2820),
    [anon_sym_public] = ACTIONS(2820),
    [anon_sym_private] = ACTIONS(2820),
    [anon_sym_protected] = ACTIONS(2820),
    [anon_sym_module] = ACTIONS(2820),
    [anon_sym_any] = ACTIONS(2820),
    [anon_sym_number] = ACTIONS(2820),
    [anon_sym_boolean] = ACTIONS(2820),
    [anon_sym_string] = ACTIONS(2820),
    [anon_sym_symbol] = ACTIONS(2820),
    [anon_sym_interface] = ACTIONS(2820),
    [anon_sym_enum] = ACTIONS(2820),
    [sym_readonly] = ACTIONS(2820),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_export] = ACTIONS(1151),
    [anon_sym_default] = ACTIONS(1151),
    [anon_sym_namespace] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_type] = ACTIONS(1151),
    [anon_sym_typeof] = ACTIONS(1151),
    [anon_sym_import] = ACTIONS(1151),
    [anon_sym_var] = ACTIONS(1151),
    [anon_sym_let] = ACTIONS(1151),
    [anon_sym_const] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1151),
    [anon_sym_else] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1151),
    [anon_sym_for] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_await] = ACTIONS(1151),
    [anon_sym_while] = ACTIONS(1151),
    [anon_sym_do] = ACTIONS(1151),
    [anon_sym_try] = ACTIONS(1151),
    [anon_sym_with] = ACTIONS(1151),
    [anon_sym_break] = ACTIONS(1151),
    [anon_sym_continue] = ACTIONS(1151),
    [anon_sym_debugger] = ACTIONS(1151),
    [anon_sym_return] = ACTIONS(1151),
    [anon_sym_throw] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_case] = ACTIONS(1151),
    [anon_sym_yield] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1149),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_class] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(1151),
    [anon_sym_new] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1149),
    [anon_sym_void] = ACTIONS(1151),
    [anon_sym_delete] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_SQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym_number] = ACTIONS(1149),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(1151),
    [sym_true] = ACTIONS(1151),
    [sym_false] = ACTIONS(1151),
    [sym_null] = ACTIONS(1151),
    [sym_undefined] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(1149),
    [anon_sym_static] = ACTIONS(1151),
    [anon_sym_abstract] = ACTIONS(1151),
    [anon_sym_get] = ACTIONS(1151),
    [anon_sym_set] = ACTIONS(1151),
    [anon_sym_declare] = ACTIONS(1151),
    [anon_sym_public] = ACTIONS(1151),
    [anon_sym_private] = ACTIONS(1151),
    [anon_sym_protected] = ACTIONS(1151),
    [anon_sym_module] = ACTIONS(1151),
    [anon_sym_any] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1151),
    [anon_sym_boolean] = ACTIONS(1151),
    [anon_sym_string] = ACTIONS(1151),
    [anon_sym_symbol] = ACTIONS(1151),
    [anon_sym_interface] = ACTIONS(1151),
    [anon_sym_enum] = ACTIONS(1151),
    [sym_readonly] = ACTIONS(1151),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_export] = ACTIONS(2824),
    [anon_sym_default] = ACTIONS(2824),
    [anon_sym_namespace] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_type] = ACTIONS(2824),
    [anon_sym_typeof] = ACTIONS(2824),
    [anon_sym_import] = ACTIONS(2824),
    [anon_sym_var] = ACTIONS(2824),
    [anon_sym_let] = ACTIONS(2824),
    [anon_sym_const] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_else] = ACTIONS(2824),
    [anon_sym_switch] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_await] = ACTIONS(2824),
    [anon_sym_while] = ACTIONS(2824),
    [anon_sym_do] = ACTIONS(2824),
    [anon_sym_try] = ACTIONS(2824),
    [anon_sym_with] = ACTIONS(2824),
    [anon_sym_break] = ACTIONS(2824),
    [anon_sym_continue] = ACTIONS(2824),
    [anon_sym_debugger] = ACTIONS(2824),
    [anon_sym_return] = ACTIONS(2824),
    [anon_sym_throw] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2824),
    [anon_sym_yield] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_LT] = ACTIONS(2822),
    [anon_sym_SLASH] = ACTIONS(2824),
    [anon_sym_class] = ACTIONS(2824),
    [anon_sym_async] = ACTIONS(2824),
    [anon_sym_function] = ACTIONS(2824),
    [anon_sym_new] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2822),
    [anon_sym_TILDE] = ACTIONS(2822),
    [anon_sym_void] = ACTIONS(2824),
    [anon_sym_delete] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2822),
    [anon_sym_DQUOTE] = ACTIONS(2822),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2822),
    [sym_number] = ACTIONS(2822),
    [sym_this] = ACTIONS(2824),
    [sym_super] = ACTIONS(2824),
    [sym_true] = ACTIONS(2824),
    [sym_false] = ACTIONS(2824),
    [sym_null] = ACTIONS(2824),
    [sym_undefined] = ACTIONS(2824),
    [anon_sym_AT] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2824),
    [anon_sym_abstract] = ACTIONS(2824),
    [anon_sym_get] = ACTIONS(2824),
    [anon_sym_set] = ACTIONS(2824),
    [anon_sym_declare] = ACTIONS(2824),
    [anon_sym_public] = ACTIONS(2824),
    [anon_sym_private] = ACTIONS(2824),
    [anon_sym_protected] = ACTIONS(2824),
    [anon_sym_module] = ACTIONS(2824),
    [anon_sym_any] = ACTIONS(2824),
    [anon_sym_number] = ACTIONS(2824),
    [anon_sym_boolean] = ACTIONS(2824),
    [anon_sym_string] = ACTIONS(2824),
    [anon_sym_symbol] = ACTIONS(2824),
    [anon_sym_interface] = ACTIONS(2824),
    [anon_sym_enum] = ACTIONS(2824),
    [sym_readonly] = ACTIONS(2824),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(2826),
    [sym_identifier] = ACTIONS(2828),
    [anon_sym_export] = ACTIONS(2828),
    [anon_sym_default] = ACTIONS(2828),
    [anon_sym_namespace] = ACTIONS(2828),
    [anon_sym_LBRACE] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2828),
    [anon_sym_typeof] = ACTIONS(2828),
    [anon_sym_import] = ACTIONS(2828),
    [anon_sym_var] = ACTIONS(2828),
    [anon_sym_let] = ACTIONS(2828),
    [anon_sym_const] = ACTIONS(2828),
    [anon_sym_if] = ACTIONS(2828),
    [anon_sym_else] = ACTIONS(2828),
    [anon_sym_switch] = ACTIONS(2828),
    [anon_sym_for] = ACTIONS(2828),
    [anon_sym_LPAREN] = ACTIONS(2826),
    [anon_sym_await] = ACTIONS(2828),
    [anon_sym_while] = ACTIONS(2828),
    [anon_sym_do] = ACTIONS(2828),
    [anon_sym_try] = ACTIONS(2828),
    [anon_sym_with] = ACTIONS(2828),
    [anon_sym_break] = ACTIONS(2828),
    [anon_sym_continue] = ACTIONS(2828),
    [anon_sym_debugger] = ACTIONS(2828),
    [anon_sym_return] = ACTIONS(2828),
    [anon_sym_throw] = ACTIONS(2828),
    [anon_sym_SEMI] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2828),
    [anon_sym_yield] = ACTIONS(2828),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2828),
    [anon_sym_class] = ACTIONS(2828),
    [anon_sym_async] = ACTIONS(2828),
    [anon_sym_function] = ACTIONS(2828),
    [anon_sym_new] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2826),
    [anon_sym_TILDE] = ACTIONS(2826),
    [anon_sym_void] = ACTIONS(2828),
    [anon_sym_delete] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2826),
    [anon_sym_DQUOTE] = ACTIONS(2826),
    [anon_sym_SQUOTE] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2826),
    [sym_number] = ACTIONS(2826),
    [sym_this] = ACTIONS(2828),
    [sym_super] = ACTIONS(2828),
    [sym_true] = ACTIONS(2828),
    [sym_false] = ACTIONS(2828),
    [sym_null] = ACTIONS(2828),
    [sym_undefined] = ACTIONS(2828),
    [anon_sym_AT] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2828),
    [anon_sym_abstract] = ACTIONS(2828),
    [anon_sym_get] = ACTIONS(2828),
    [anon_sym_set] = ACTIONS(2828),
    [anon_sym_declare] = ACTIONS(2828),
    [anon_sym_public] = ACTIONS(2828),
    [anon_sym_private] = ACTIONS(2828),
    [anon_sym_protected] = ACTIONS(2828),
    [anon_sym_module] = ACTIONS(2828),
    [anon_sym_any] = ACTIONS(2828),
    [anon_sym_number] = ACTIONS(2828),
    [anon_sym_boolean] = ACTIONS(2828),
    [anon_sym_string] = ACTIONS(2828),
    [anon_sym_symbol] = ACTIONS(2828),
    [anon_sym_interface] = ACTIONS(2828),
    [anon_sym_enum] = ACTIONS(2828),
    [sym_readonly] = ACTIONS(2828),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(2830),
    [sym_identifier] = ACTIONS(2832),
    [anon_sym_export] = ACTIONS(2832),
    [anon_sym_default] = ACTIONS(2832),
    [anon_sym_namespace] = ACTIONS(2832),
    [anon_sym_LBRACE] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_type] = ACTIONS(2832),
    [anon_sym_typeof] = ACTIONS(2832),
    [anon_sym_import] = ACTIONS(2832),
    [anon_sym_var] = ACTIONS(2832),
    [anon_sym_let] = ACTIONS(2832),
    [anon_sym_const] = ACTIONS(2832),
    [anon_sym_if] = ACTIONS(2832),
    [anon_sym_else] = ACTIONS(2832),
    [anon_sym_switch] = ACTIONS(2832),
    [anon_sym_for] = ACTIONS(2832),
    [anon_sym_LPAREN] = ACTIONS(2830),
    [anon_sym_await] = ACTIONS(2832),
    [anon_sym_while] = ACTIONS(2832),
    [anon_sym_do] = ACTIONS(2832),
    [anon_sym_try] = ACTIONS(2832),
    [anon_sym_with] = ACTIONS(2832),
    [anon_sym_break] = ACTIONS(2832),
    [anon_sym_continue] = ACTIONS(2832),
    [anon_sym_debugger] = ACTIONS(2832),
    [anon_sym_return] = ACTIONS(2832),
    [anon_sym_throw] = ACTIONS(2832),
    [anon_sym_SEMI] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2832),
    [anon_sym_yield] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_LT] = ACTIONS(2830),
    [anon_sym_SLASH] = ACTIONS(2832),
    [anon_sym_class] = ACTIONS(2832),
    [anon_sym_async] = ACTIONS(2832),
    [anon_sym_function] = ACTIONS(2832),
    [anon_sym_new] = ACTIONS(2832),
    [anon_sym_PLUS] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_void] = ACTIONS(2832),
    [anon_sym_delete] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2830),
    [anon_sym_DQUOTE] = ACTIONS(2830),
    [anon_sym_SQUOTE] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2830),
    [sym_number] = ACTIONS(2830),
    [sym_this] = ACTIONS(2832),
    [sym_super] = ACTIONS(2832),
    [sym_true] = ACTIONS(2832),
    [sym_false] = ACTIONS(2832),
    [sym_null] = ACTIONS(2832),
    [sym_undefined] = ACTIONS(2832),
    [anon_sym_AT] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2832),
    [anon_sym_abstract] = ACTIONS(2832),
    [anon_sym_get] = ACTIONS(2832),
    [anon_sym_set] = ACTIONS(2832),
    [anon_sym_declare] = ACTIONS(2832),
    [anon_sym_public] = ACTIONS(2832),
    [anon_sym_private] = ACTIONS(2832),
    [anon_sym_protected] = ACTIONS(2832),
    [anon_sym_module] = ACTIONS(2832),
    [anon_sym_any] = ACTIONS(2832),
    [anon_sym_number] = ACTIONS(2832),
    [anon_sym_boolean] = ACTIONS(2832),
    [anon_sym_string] = ACTIONS(2832),
    [anon_sym_symbol] = ACTIONS(2832),
    [anon_sym_interface] = ACTIONS(2832),
    [anon_sym_enum] = ACTIONS(2832),
    [sym_readonly] = ACTIONS(2832),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(2834),
    [sym_identifier] = ACTIONS(2836),
    [anon_sym_export] = ACTIONS(2836),
    [anon_sym_default] = ACTIONS(2836),
    [anon_sym_namespace] = ACTIONS(2836),
    [anon_sym_LBRACE] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_type] = ACTIONS(2836),
    [anon_sym_typeof] = ACTIONS(2836),
    [anon_sym_import] = ACTIONS(2836),
    [anon_sym_var] = ACTIONS(2836),
    [anon_sym_let] = ACTIONS(2836),
    [anon_sym_const] = ACTIONS(2836),
    [anon_sym_if] = ACTIONS(2836),
    [anon_sym_else] = ACTIONS(2836),
    [anon_sym_switch] = ACTIONS(2836),
    [anon_sym_for] = ACTIONS(2836),
    [anon_sym_LPAREN] = ACTIONS(2834),
    [anon_sym_await] = ACTIONS(2836),
    [anon_sym_while] = ACTIONS(2836),
    [anon_sym_do] = ACTIONS(2836),
    [anon_sym_try] = ACTIONS(2836),
    [anon_sym_with] = ACTIONS(2836),
    [anon_sym_break] = ACTIONS(2836),
    [anon_sym_continue] = ACTIONS(2836),
    [anon_sym_debugger] = ACTIONS(2836),
    [anon_sym_return] = ACTIONS(2836),
    [anon_sym_throw] = ACTIONS(2836),
    [anon_sym_SEMI] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2836),
    [anon_sym_yield] = ACTIONS(2836),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_LT] = ACTIONS(2834),
    [anon_sym_SLASH] = ACTIONS(2836),
    [anon_sym_class] = ACTIONS(2836),
    [anon_sym_async] = ACTIONS(2836),
    [anon_sym_function] = ACTIONS(2836),
    [anon_sym_new] = ACTIONS(2836),
    [anon_sym_PLUS] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2834),
    [anon_sym_TILDE] = ACTIONS(2834),
    [anon_sym_void] = ACTIONS(2836),
    [anon_sym_delete] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2834),
    [anon_sym_DQUOTE] = ACTIONS(2834),
    [anon_sym_SQUOTE] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2834),
    [sym_number] = ACTIONS(2834),
    [sym_this] = ACTIONS(2836),
    [sym_super] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_null] = ACTIONS(2836),
    [sym_undefined] = ACTIONS(2836),
    [anon_sym_AT] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2836),
    [anon_sym_abstract] = ACTIONS(2836),
    [anon_sym_get] = ACTIONS(2836),
    [anon_sym_set] = ACTIONS(2836),
    [anon_sym_declare] = ACTIONS(2836),
    [anon_sym_public] = ACTIONS(2836),
    [anon_sym_private] = ACTIONS(2836),
    [anon_sym_protected] = ACTIONS(2836),
    [anon_sym_module] = ACTIONS(2836),
    [anon_sym_any] = ACTIONS(2836),
    [anon_sym_number] = ACTIONS(2836),
    [anon_sym_boolean] = ACTIONS(2836),
    [anon_sym_string] = ACTIONS(2836),
    [anon_sym_symbol] = ACTIONS(2836),
    [anon_sym_interface] = ACTIONS(2836),
    [anon_sym_enum] = ACTIONS(2836),
    [sym_readonly] = ACTIONS(2836),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(2838),
    [sym_identifier] = ACTIONS(2840),
    [anon_sym_export] = ACTIONS(2840),
    [anon_sym_default] = ACTIONS(2840),
    [anon_sym_namespace] = ACTIONS(2840),
    [anon_sym_LBRACE] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_type] = ACTIONS(2840),
    [anon_sym_typeof] = ACTIONS(2840),
    [anon_sym_import] = ACTIONS(2840),
    [anon_sym_var] = ACTIONS(2840),
    [anon_sym_let] = ACTIONS(2840),
    [anon_sym_const] = ACTIONS(2840),
    [anon_sym_if] = ACTIONS(2840),
    [anon_sym_else] = ACTIONS(2840),
    [anon_sym_switch] = ACTIONS(2840),
    [anon_sym_for] = ACTIONS(2840),
    [anon_sym_LPAREN] = ACTIONS(2838),
    [anon_sym_await] = ACTIONS(2840),
    [anon_sym_while] = ACTIONS(2840),
    [anon_sym_do] = ACTIONS(2840),
    [anon_sym_try] = ACTIONS(2840),
    [anon_sym_with] = ACTIONS(2840),
    [anon_sym_break] = ACTIONS(2840),
    [anon_sym_continue] = ACTIONS(2840),
    [anon_sym_debugger] = ACTIONS(2840),
    [anon_sym_return] = ACTIONS(2840),
    [anon_sym_throw] = ACTIONS(2840),
    [anon_sym_SEMI] = ACTIONS(2838),
    [anon_sym_case] = ACTIONS(2840),
    [anon_sym_yield] = ACTIONS(2840),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_LT] = ACTIONS(2838),
    [anon_sym_SLASH] = ACTIONS(2840),
    [anon_sym_class] = ACTIONS(2840),
    [anon_sym_async] = ACTIONS(2840),
    [anon_sym_function] = ACTIONS(2840),
    [anon_sym_new] = ACTIONS(2840),
    [anon_sym_PLUS] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_TILDE] = ACTIONS(2838),
    [anon_sym_void] = ACTIONS(2840),
    [anon_sym_delete] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2838),
    [anon_sym_DQUOTE] = ACTIONS(2838),
    [anon_sym_SQUOTE] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2838),
    [sym_number] = ACTIONS(2838),
    [sym_this] = ACTIONS(2840),
    [sym_super] = ACTIONS(2840),
    [sym_true] = ACTIONS(2840),
    [sym_false] = ACTIONS(2840),
    [sym_null] = ACTIONS(2840),
    [sym_undefined] = ACTIONS(2840),
    [anon_sym_AT] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2840),
    [anon_sym_abstract] = ACTIONS(2840),
    [anon_sym_get] = ACTIONS(2840),
    [anon_sym_set] = ACTIONS(2840),
    [anon_sym_declare] = ACTIONS(2840),
    [anon_sym_public] = ACTIONS(2840),
    [anon_sym_private] = ACTIONS(2840),
    [anon_sym_protected] = ACTIONS(2840),
    [anon_sym_module] = ACTIONS(2840),
    [anon_sym_any] = ACTIONS(2840),
    [anon_sym_number] = ACTIONS(2840),
    [anon_sym_boolean] = ACTIONS(2840),
    [anon_sym_string] = ACTIONS(2840),
    [anon_sym_symbol] = ACTIONS(2840),
    [anon_sym_interface] = ACTIONS(2840),
    [anon_sym_enum] = ACTIONS(2840),
    [sym_readonly] = ACTIONS(2840),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(2842),
    [sym_identifier] = ACTIONS(2844),
    [anon_sym_export] = ACTIONS(2844),
    [anon_sym_default] = ACTIONS(2844),
    [anon_sym_namespace] = ACTIONS(2844),
    [anon_sym_LBRACE] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2842),
    [anon_sym_type] = ACTIONS(2844),
    [anon_sym_typeof] = ACTIONS(2844),
    [anon_sym_import] = ACTIONS(2844),
    [anon_sym_var] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_const] = ACTIONS(2844),
    [anon_sym_if] = ACTIONS(2844),
    [anon_sym_else] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_for] = ACTIONS(2844),
    [anon_sym_LPAREN] = ACTIONS(2842),
    [anon_sym_await] = ACTIONS(2844),
    [anon_sym_while] = ACTIONS(2844),
    [anon_sym_do] = ACTIONS(2844),
    [anon_sym_try] = ACTIONS(2844),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_break] = ACTIONS(2844),
    [anon_sym_continue] = ACTIONS(2844),
    [anon_sym_debugger] = ACTIONS(2844),
    [anon_sym_return] = ACTIONS(2844),
    [anon_sym_throw] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_LT] = ACTIONS(2842),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_class] = ACTIONS(2844),
    [anon_sym_async] = ACTIONS(2844),
    [anon_sym_function] = ACTIONS(2844),
    [anon_sym_new] = ACTIONS(2844),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2842),
    [anon_sym_TILDE] = ACTIONS(2842),
    [anon_sym_void] = ACTIONS(2844),
    [anon_sym_delete] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2842),
    [anon_sym_DQUOTE] = ACTIONS(2842),
    [anon_sym_SQUOTE] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2842),
    [sym_number] = ACTIONS(2842),
    [sym_this] = ACTIONS(2844),
    [sym_super] = ACTIONS(2844),
    [sym_true] = ACTIONS(2844),
    [sym_false] = ACTIONS(2844),
    [sym_null] = ACTIONS(2844),
    [sym_undefined] = ACTIONS(2844),
    [anon_sym_AT] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2844),
    [anon_sym_abstract] = ACTIONS(2844),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_declare] = ACTIONS(2844),
    [anon_sym_public] = ACTIONS(2844),
    [anon_sym_private] = ACTIONS(2844),
    [anon_sym_protected] = ACTIONS(2844),
    [anon_sym_module] = ACTIONS(2844),
    [anon_sym_any] = ACTIONS(2844),
    [anon_sym_number] = ACTIONS(2844),
    [anon_sym_boolean] = ACTIONS(2844),
    [anon_sym_string] = ACTIONS(2844),
    [anon_sym_symbol] = ACTIONS(2844),
    [anon_sym_interface] = ACTIONS(2844),
    [anon_sym_enum] = ACTIONS(2844),
    [sym_readonly] = ACTIONS(2844),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(2846),
    [sym_identifier] = ACTIONS(2848),
    [anon_sym_export] = ACTIONS(2848),
    [anon_sym_default] = ACTIONS(2848),
    [anon_sym_namespace] = ACTIONS(2848),
    [anon_sym_LBRACE] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_type] = ACTIONS(2848),
    [anon_sym_typeof] = ACTIONS(2848),
    [anon_sym_import] = ACTIONS(2848),
    [anon_sym_var] = ACTIONS(2848),
    [anon_sym_let] = ACTIONS(2848),
    [anon_sym_const] = ACTIONS(2848),
    [anon_sym_if] = ACTIONS(2848),
    [anon_sym_else] = ACTIONS(2848),
    [anon_sym_switch] = ACTIONS(2848),
    [anon_sym_for] = ACTIONS(2848),
    [anon_sym_LPAREN] = ACTIONS(2846),
    [anon_sym_await] = ACTIONS(2848),
    [anon_sym_while] = ACTIONS(2848),
    [anon_sym_do] = ACTIONS(2848),
    [anon_sym_try] = ACTIONS(2848),
    [anon_sym_with] = ACTIONS(2848),
    [anon_sym_break] = ACTIONS(2848),
    [anon_sym_continue] = ACTIONS(2848),
    [anon_sym_debugger] = ACTIONS(2848),
    [anon_sym_return] = ACTIONS(2848),
    [anon_sym_throw] = ACTIONS(2848),
    [anon_sym_SEMI] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2848),
    [anon_sym_yield] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_LT] = ACTIONS(2846),
    [anon_sym_SLASH] = ACTIONS(2848),
    [anon_sym_class] = ACTIONS(2848),
    [anon_sym_async] = ACTIONS(2848),
    [anon_sym_function] = ACTIONS(2848),
    [anon_sym_new] = ACTIONS(2848),
    [anon_sym_PLUS] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2846),
    [anon_sym_TILDE] = ACTIONS(2846),
    [anon_sym_void] = ACTIONS(2848),
    [anon_sym_delete] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2846),
    [anon_sym_DQUOTE] = ACTIONS(2846),
    [anon_sym_SQUOTE] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2846),
    [sym_number] = ACTIONS(2846),
    [sym_this] = ACTIONS(2848),
    [sym_super] = ACTIONS(2848),
    [sym_true] = ACTIONS(2848),
    [sym_false] = ACTIONS(2848),
    [sym_null] = ACTIONS(2848),
    [sym_undefined] = ACTIONS(2848),
    [anon_sym_AT] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2848),
    [anon_sym_abstract] = ACTIONS(2848),
    [anon_sym_get] = ACTIONS(2848),
    [anon_sym_set] = ACTIONS(2848),
    [anon_sym_declare] = ACTIONS(2848),
    [anon_sym_public] = ACTIONS(2848),
    [anon_sym_private] = ACTIONS(2848),
    [anon_sym_protected] = ACTIONS(2848),
    [anon_sym_module] = ACTIONS(2848),
    [anon_sym_any] = ACTIONS(2848),
    [anon_sym_number] = ACTIONS(2848),
    [anon_sym_boolean] = ACTIONS(2848),
    [anon_sym_string] = ACTIONS(2848),
    [anon_sym_symbol] = ACTIONS(2848),
    [anon_sym_interface] = ACTIONS(2848),
    [anon_sym_enum] = ACTIONS(2848),
    [sym_readonly] = ACTIONS(2848),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(2850),
    [sym_identifier] = ACTIONS(2852),
    [anon_sym_export] = ACTIONS(2852),
    [anon_sym_default] = ACTIONS(2852),
    [anon_sym_namespace] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_type] = ACTIONS(2852),
    [anon_sym_typeof] = ACTIONS(2852),
    [anon_sym_import] = ACTIONS(2852),
    [anon_sym_var] = ACTIONS(2852),
    [anon_sym_let] = ACTIONS(2852),
    [anon_sym_const] = ACTIONS(2852),
    [anon_sym_if] = ACTIONS(2852),
    [anon_sym_else] = ACTIONS(2852),
    [anon_sym_switch] = ACTIONS(2852),
    [anon_sym_for] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2850),
    [anon_sym_await] = ACTIONS(2852),
    [anon_sym_while] = ACTIONS(2852),
    [anon_sym_do] = ACTIONS(2852),
    [anon_sym_try] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2852),
    [anon_sym_break] = ACTIONS(2852),
    [anon_sym_continue] = ACTIONS(2852),
    [anon_sym_debugger] = ACTIONS(2852),
    [anon_sym_return] = ACTIONS(2852),
    [anon_sym_throw] = ACTIONS(2852),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2852),
    [anon_sym_yield] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_SLASH] = ACTIONS(2852),
    [anon_sym_class] = ACTIONS(2852),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_function] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2850),
    [anon_sym_TILDE] = ACTIONS(2850),
    [anon_sym_void] = ACTIONS(2852),
    [anon_sym_delete] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2850),
    [anon_sym_DQUOTE] = ACTIONS(2850),
    [anon_sym_SQUOTE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2850),
    [sym_number] = ACTIONS(2850),
    [sym_this] = ACTIONS(2852),
    [sym_super] = ACTIONS(2852),
    [sym_true] = ACTIONS(2852),
    [sym_false] = ACTIONS(2852),
    [sym_null] = ACTIONS(2852),
    [sym_undefined] = ACTIONS(2852),
    [anon_sym_AT] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2852),
    [anon_sym_abstract] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2852),
    [anon_sym_set] = ACTIONS(2852),
    [anon_sym_declare] = ACTIONS(2852),
    [anon_sym_public] = ACTIONS(2852),
    [anon_sym_private] = ACTIONS(2852),
    [anon_sym_protected] = ACTIONS(2852),
    [anon_sym_module] = ACTIONS(2852),
    [anon_sym_any] = ACTIONS(2852),
    [anon_sym_number] = ACTIONS(2852),
    [anon_sym_boolean] = ACTIONS(2852),
    [anon_sym_string] = ACTIONS(2852),
    [anon_sym_symbol] = ACTIONS(2852),
    [anon_sym_interface] = ACTIONS(2852),
    [anon_sym_enum] = ACTIONS(2852),
    [sym_readonly] = ACTIONS(2852),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(2854),
    [sym_identifier] = ACTIONS(2856),
    [anon_sym_export] = ACTIONS(2856),
    [anon_sym_default] = ACTIONS(2856),
    [anon_sym_namespace] = ACTIONS(2856),
    [anon_sym_LBRACE] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_type] = ACTIONS(2856),
    [anon_sym_typeof] = ACTIONS(2856),
    [anon_sym_import] = ACTIONS(2856),
    [anon_sym_var] = ACTIONS(2856),
    [anon_sym_let] = ACTIONS(2856),
    [anon_sym_const] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_else] = ACTIONS(2856),
    [anon_sym_switch] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2854),
    [anon_sym_await] = ACTIONS(2856),
    [anon_sym_while] = ACTIONS(2856),
    [anon_sym_do] = ACTIONS(2856),
    [anon_sym_try] = ACTIONS(2856),
    [anon_sym_with] = ACTIONS(2856),
    [anon_sym_break] = ACTIONS(2856),
    [anon_sym_continue] = ACTIONS(2856),
    [anon_sym_debugger] = ACTIONS(2856),
    [anon_sym_return] = ACTIONS(2856),
    [anon_sym_throw] = ACTIONS(2856),
    [anon_sym_SEMI] = ACTIONS(2854),
    [anon_sym_case] = ACTIONS(2856),
    [anon_sym_yield] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2854),
    [anon_sym_LT] = ACTIONS(2854),
    [anon_sym_SLASH] = ACTIONS(2856),
    [anon_sym_class] = ACTIONS(2856),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_function] = ACTIONS(2856),
    [anon_sym_new] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2854),
    [anon_sym_TILDE] = ACTIONS(2854),
    [anon_sym_void] = ACTIONS(2856),
    [anon_sym_delete] = ACTIONS(2856),
    [anon_sym_PLUS_PLUS] = ACTIONS(2854),
    [anon_sym_DASH_DASH] = ACTIONS(2854),
    [anon_sym_DQUOTE] = ACTIONS(2854),
    [anon_sym_SQUOTE] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2854),
    [sym_number] = ACTIONS(2854),
    [sym_this] = ACTIONS(2856),
    [sym_super] = ACTIONS(2856),
    [sym_true] = ACTIONS(2856),
    [sym_false] = ACTIONS(2856),
    [sym_null] = ACTIONS(2856),
    [sym_undefined] = ACTIONS(2856),
    [anon_sym_AT] = ACTIONS(2854),
    [anon_sym_static] = ACTIONS(2856),
    [anon_sym_abstract] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2856),
    [anon_sym_set] = ACTIONS(2856),
    [anon_sym_declare] = ACTIONS(2856),
    [anon_sym_public] = ACTIONS(2856),
    [anon_sym_private] = ACTIONS(2856),
    [anon_sym_protected] = ACTIONS(2856),
    [anon_sym_module] = ACTIONS(2856),
    [anon_sym_any] = ACTIONS(2856),
    [anon_sym_number] = ACTIONS(2856),
    [anon_sym_boolean] = ACTIONS(2856),
    [anon_sym_string] = ACTIONS(2856),
    [anon_sym_symbol] = ACTIONS(2856),
    [anon_sym_interface] = ACTIONS(2856),
    [anon_sym_enum] = ACTIONS(2856),
    [sym_readonly] = ACTIONS(2856),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(2858),
    [sym_identifier] = ACTIONS(2860),
    [anon_sym_export] = ACTIONS(2860),
    [anon_sym_default] = ACTIONS(2860),
    [anon_sym_namespace] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_type] = ACTIONS(2860),
    [anon_sym_typeof] = ACTIONS(2860),
    [anon_sym_import] = ACTIONS(2860),
    [anon_sym_var] = ACTIONS(2860),
    [anon_sym_let] = ACTIONS(2860),
    [anon_sym_const] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2860),
    [anon_sym_else] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2860),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_await] = ACTIONS(2860),
    [anon_sym_while] = ACTIONS(2860),
    [anon_sym_do] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2860),
    [anon_sym_with] = ACTIONS(2860),
    [anon_sym_break] = ACTIONS(2860),
    [anon_sym_continue] = ACTIONS(2860),
    [anon_sym_debugger] = ACTIONS(2860),
    [anon_sym_return] = ACTIONS(2860),
    [anon_sym_throw] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_case] = ACTIONS(2860),
    [anon_sym_yield] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2858),
    [anon_sym_SLASH] = ACTIONS(2860),
    [anon_sym_class] = ACTIONS(2860),
    [anon_sym_async] = ACTIONS(2860),
    [anon_sym_function] = ACTIONS(2860),
    [anon_sym_new] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_void] = ACTIONS(2860),
    [anon_sym_delete] = ACTIONS(2860),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_DQUOTE] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2858),
    [sym_number] = ACTIONS(2858),
    [sym_this] = ACTIONS(2860),
    [sym_super] = ACTIONS(2860),
    [sym_true] = ACTIONS(2860),
    [sym_false] = ACTIONS(2860),
    [sym_null] = ACTIONS(2860),
    [sym_undefined] = ACTIONS(2860),
    [anon_sym_AT] = ACTIONS(2858),
    [anon_sym_static] = ACTIONS(2860),
    [anon_sym_abstract] = ACTIONS(2860),
    [anon_sym_get] = ACTIONS(2860),
    [anon_sym_set] = ACTIONS(2860),
    [anon_sym_declare] = ACTIONS(2860),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_module] = ACTIONS(2860),
    [anon_sym_any] = ACTIONS(2860),
    [anon_sym_number] = ACTIONS(2860),
    [anon_sym_boolean] = ACTIONS(2860),
    [anon_sym_string] = ACTIONS(2860),
    [anon_sym_symbol] = ACTIONS(2860),
    [anon_sym_interface] = ACTIONS(2860),
    [anon_sym_enum] = ACTIONS(2860),
    [sym_readonly] = ACTIONS(2860),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(2862),
    [sym_identifier] = ACTIONS(2864),
    [anon_sym_export] = ACTIONS(2864),
    [anon_sym_default] = ACTIONS(2864),
    [anon_sym_namespace] = ACTIONS(2864),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_type] = ACTIONS(2864),
    [anon_sym_typeof] = ACTIONS(2864),
    [anon_sym_import] = ACTIONS(2864),
    [anon_sym_var] = ACTIONS(2864),
    [anon_sym_let] = ACTIONS(2864),
    [anon_sym_const] = ACTIONS(2864),
    [anon_sym_if] = ACTIONS(2864),
    [anon_sym_else] = ACTIONS(2864),
    [anon_sym_switch] = ACTIONS(2864),
    [anon_sym_for] = ACTIONS(2864),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_await] = ACTIONS(2864),
    [anon_sym_while] = ACTIONS(2864),
    [anon_sym_do] = ACTIONS(2864),
    [anon_sym_try] = ACTIONS(2864),
    [anon_sym_with] = ACTIONS(2864),
    [anon_sym_break] = ACTIONS(2864),
    [anon_sym_continue] = ACTIONS(2864),
    [anon_sym_debugger] = ACTIONS(2864),
    [anon_sym_return] = ACTIONS(2864),
    [anon_sym_throw] = ACTIONS(2864),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_case] = ACTIONS(2864),
    [anon_sym_yield] = ACTIONS(2864),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_LT] = ACTIONS(2862),
    [anon_sym_SLASH] = ACTIONS(2864),
    [anon_sym_class] = ACTIONS(2864),
    [anon_sym_async] = ACTIONS(2864),
    [anon_sym_function] = ACTIONS(2864),
    [anon_sym_new] = ACTIONS(2864),
    [anon_sym_PLUS] = ACTIONS(2864),
    [anon_sym_DASH] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2862),
    [anon_sym_TILDE] = ACTIONS(2862),
    [anon_sym_void] = ACTIONS(2864),
    [anon_sym_delete] = ACTIONS(2864),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_DQUOTE] = ACTIONS(2862),
    [anon_sym_SQUOTE] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [sym_number] = ACTIONS(2862),
    [sym_this] = ACTIONS(2864),
    [sym_super] = ACTIONS(2864),
    [sym_true] = ACTIONS(2864),
    [sym_false] = ACTIONS(2864),
    [sym_null] = ACTIONS(2864),
    [sym_undefined] = ACTIONS(2864),
    [anon_sym_AT] = ACTIONS(2862),
    [anon_sym_static] = ACTIONS(2864),
    [anon_sym_abstract] = ACTIONS(2864),
    [anon_sym_get] = ACTIONS(2864),
    [anon_sym_set] = ACTIONS(2864),
    [anon_sym_declare] = ACTIONS(2864),
    [anon_sym_public] = ACTIONS(2864),
    [anon_sym_private] = ACTIONS(2864),
    [anon_sym_protected] = ACTIONS(2864),
    [anon_sym_module] = ACTIONS(2864),
    [anon_sym_any] = ACTIONS(2864),
    [anon_sym_number] = ACTIONS(2864),
    [anon_sym_boolean] = ACTIONS(2864),
    [anon_sym_string] = ACTIONS(2864),
    [anon_sym_symbol] = ACTIONS(2864),
    [anon_sym_interface] = ACTIONS(2864),
    [anon_sym_enum] = ACTIONS(2864),
    [sym_readonly] = ACTIONS(2864),
  },
  [566] = {
    [sym__call_signature] = STATE(3113),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(2866),
    [sym_identifier] = ACTIONS(2868),
    [anon_sym_export] = ACTIONS(2868),
    [anon_sym_default] = ACTIONS(2868),
    [anon_sym_namespace] = ACTIONS(2868),
    [anon_sym_LBRACE] = ACTIONS(2866),
    [anon_sym_RBRACE] = ACTIONS(2866),
    [anon_sym_type] = ACTIONS(2868),
    [anon_sym_typeof] = ACTIONS(2868),
    [anon_sym_import] = ACTIONS(2868),
    [anon_sym_var] = ACTIONS(2868),
    [anon_sym_let] = ACTIONS(2868),
    [anon_sym_const] = ACTIONS(2868),
    [anon_sym_if] = ACTIONS(2868),
    [anon_sym_else] = ACTIONS(2868),
    [anon_sym_switch] = ACTIONS(2868),
    [anon_sym_for] = ACTIONS(2868),
    [anon_sym_LPAREN] = ACTIONS(2866),
    [anon_sym_await] = ACTIONS(2868),
    [anon_sym_while] = ACTIONS(2868),
    [anon_sym_do] = ACTIONS(2868),
    [anon_sym_try] = ACTIONS(2868),
    [anon_sym_with] = ACTIONS(2868),
    [anon_sym_break] = ACTIONS(2868),
    [anon_sym_continue] = ACTIONS(2868),
    [anon_sym_debugger] = ACTIONS(2868),
    [anon_sym_return] = ACTIONS(2868),
    [anon_sym_throw] = ACTIONS(2868),
    [anon_sym_SEMI] = ACTIONS(2866),
    [anon_sym_case] = ACTIONS(2868),
    [anon_sym_yield] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(2866),
    [anon_sym_SLASH] = ACTIONS(2868),
    [anon_sym_class] = ACTIONS(2868),
    [anon_sym_async] = ACTIONS(2868),
    [anon_sym_function] = ACTIONS(2868),
    [anon_sym_new] = ACTIONS(2868),
    [anon_sym_PLUS] = ACTIONS(2868),
    [anon_sym_DASH] = ACTIONS(2868),
    [anon_sym_BANG] = ACTIONS(2866),
    [anon_sym_TILDE] = ACTIONS(2866),
    [anon_sym_void] = ACTIONS(2868),
    [anon_sym_delete] = ACTIONS(2868),
    [anon_sym_PLUS_PLUS] = ACTIONS(2866),
    [anon_sym_DASH_DASH] = ACTIONS(2866),
    [anon_sym_DQUOTE] = ACTIONS(2866),
    [anon_sym_SQUOTE] = ACTIONS(2866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2866),
    [sym_number] = ACTIONS(2866),
    [sym_this] = ACTIONS(2868),
    [sym_super] = ACTIONS(2868),
    [sym_true] = ACTIONS(2868),
    [sym_false] = ACTIONS(2868),
    [sym_null] = ACTIONS(2868),
    [sym_undefined] = ACTIONS(2868),
    [anon_sym_AT] = ACTIONS(2866),
    [anon_sym_static] = ACTIONS(2868),
    [anon_sym_abstract] = ACTIONS(2868),
    [anon_sym_get] = ACTIONS(2868),
    [anon_sym_set] = ACTIONS(2868),
    [anon_sym_declare] = ACTIONS(2868),
    [anon_sym_public] = ACTIONS(2868),
    [anon_sym_private] = ACTIONS(2868),
    [anon_sym_protected] = ACTIONS(2868),
    [anon_sym_module] = ACTIONS(2868),
    [anon_sym_any] = ACTIONS(2868),
    [anon_sym_number] = ACTIONS(2868),
    [anon_sym_boolean] = ACTIONS(2868),
    [anon_sym_string] = ACTIONS(2868),
    [anon_sym_symbol] = ACTIONS(2868),
    [anon_sym_interface] = ACTIONS(2868),
    [anon_sym_enum] = ACTIONS(2868),
    [sym_readonly] = ACTIONS(2868),
  },
  [568] = {
    [sym__call_signature] = STATE(3113),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(2870),
    [sym_identifier] = ACTIONS(2872),
    [anon_sym_export] = ACTIONS(2872),
    [anon_sym_default] = ACTIONS(2872),
    [anon_sym_namespace] = ACTIONS(2872),
    [anon_sym_LBRACE] = ACTIONS(2870),
    [anon_sym_RBRACE] = ACTIONS(2870),
    [anon_sym_type] = ACTIONS(2872),
    [anon_sym_typeof] = ACTIONS(2872),
    [anon_sym_import] = ACTIONS(2872),
    [anon_sym_var] = ACTIONS(2872),
    [anon_sym_let] = ACTIONS(2872),
    [anon_sym_const] = ACTIONS(2872),
    [anon_sym_if] = ACTIONS(2872),
    [anon_sym_else] = ACTIONS(2872),
    [anon_sym_switch] = ACTIONS(2872),
    [anon_sym_for] = ACTIONS(2872),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_await] = ACTIONS(2872),
    [anon_sym_while] = ACTIONS(2872),
    [anon_sym_do] = ACTIONS(2872),
    [anon_sym_try] = ACTIONS(2872),
    [anon_sym_with] = ACTIONS(2872),
    [anon_sym_break] = ACTIONS(2872),
    [anon_sym_continue] = ACTIONS(2872),
    [anon_sym_debugger] = ACTIONS(2872),
    [anon_sym_return] = ACTIONS(2872),
    [anon_sym_throw] = ACTIONS(2872),
    [anon_sym_SEMI] = ACTIONS(2870),
    [anon_sym_case] = ACTIONS(2872),
    [anon_sym_yield] = ACTIONS(2872),
    [anon_sym_LBRACK] = ACTIONS(2870),
    [anon_sym_LT] = ACTIONS(2870),
    [anon_sym_SLASH] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2872),
    [anon_sym_async] = ACTIONS(2872),
    [anon_sym_function] = ACTIONS(2872),
    [anon_sym_new] = ACTIONS(2872),
    [anon_sym_PLUS] = ACTIONS(2872),
    [anon_sym_DASH] = ACTIONS(2872),
    [anon_sym_BANG] = ACTIONS(2870),
    [anon_sym_TILDE] = ACTIONS(2870),
    [anon_sym_void] = ACTIONS(2872),
    [anon_sym_delete] = ACTIONS(2872),
    [anon_sym_PLUS_PLUS] = ACTIONS(2870),
    [anon_sym_DASH_DASH] = ACTIONS(2870),
    [anon_sym_DQUOTE] = ACTIONS(2870),
    [anon_sym_SQUOTE] = ACTIONS(2870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2870),
    [sym_number] = ACTIONS(2870),
    [sym_this] = ACTIONS(2872),
    [sym_super] = ACTIONS(2872),
    [sym_true] = ACTIONS(2872),
    [sym_false] = ACTIONS(2872),
    [sym_null] = ACTIONS(2872),
    [sym_undefined] = ACTIONS(2872),
    [anon_sym_AT] = ACTIONS(2870),
    [anon_sym_static] = ACTIONS(2872),
    [anon_sym_abstract] = ACTIONS(2872),
    [anon_sym_get] = ACTIONS(2872),
    [anon_sym_set] = ACTIONS(2872),
    [anon_sym_declare] = ACTIONS(2872),
    [anon_sym_public] = ACTIONS(2872),
    [anon_sym_private] = ACTIONS(2872),
    [anon_sym_protected] = ACTIONS(2872),
    [anon_sym_module] = ACTIONS(2872),
    [anon_sym_any] = ACTIONS(2872),
    [anon_sym_number] = ACTIONS(2872),
    [anon_sym_boolean] = ACTIONS(2872),
    [anon_sym_string] = ACTIONS(2872),
    [anon_sym_symbol] = ACTIONS(2872),
    [anon_sym_interface] = ACTIONS(2872),
    [anon_sym_enum] = ACTIONS(2872),
    [sym_readonly] = ACTIONS(2872),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(2874),
    [sym_identifier] = ACTIONS(2876),
    [anon_sym_export] = ACTIONS(2876),
    [anon_sym_default] = ACTIONS(2876),
    [anon_sym_namespace] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2874),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_type] = ACTIONS(2876),
    [anon_sym_typeof] = ACTIONS(2876),
    [anon_sym_import] = ACTIONS(2876),
    [anon_sym_var] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2876),
    [anon_sym_const] = ACTIONS(2876),
    [anon_sym_if] = ACTIONS(2876),
    [anon_sym_else] = ACTIONS(2876),
    [anon_sym_switch] = ACTIONS(2876),
    [anon_sym_for] = ACTIONS(2876),
    [anon_sym_LPAREN] = ACTIONS(2874),
    [anon_sym_await] = ACTIONS(2876),
    [anon_sym_while] = ACTIONS(2876),
    [anon_sym_do] = ACTIONS(2876),
    [anon_sym_try] = ACTIONS(2876),
    [anon_sym_with] = ACTIONS(2876),
    [anon_sym_break] = ACTIONS(2876),
    [anon_sym_continue] = ACTIONS(2876),
    [anon_sym_debugger] = ACTIONS(2876),
    [anon_sym_return] = ACTIONS(2876),
    [anon_sym_throw] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2874),
    [anon_sym_case] = ACTIONS(2876),
    [anon_sym_yield] = ACTIONS(2876),
    [anon_sym_LBRACK] = ACTIONS(2874),
    [anon_sym_LT] = ACTIONS(2874),
    [anon_sym_SLASH] = ACTIONS(2876),
    [anon_sym_class] = ACTIONS(2876),
    [anon_sym_async] = ACTIONS(2876),
    [anon_sym_function] = ACTIONS(2876),
    [anon_sym_new] = ACTIONS(2876),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_BANG] = ACTIONS(2874),
    [anon_sym_TILDE] = ACTIONS(2874),
    [anon_sym_void] = ACTIONS(2876),
    [anon_sym_delete] = ACTIONS(2876),
    [anon_sym_PLUS_PLUS] = ACTIONS(2874),
    [anon_sym_DASH_DASH] = ACTIONS(2874),
    [anon_sym_DQUOTE] = ACTIONS(2874),
    [anon_sym_SQUOTE] = ACTIONS(2874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2874),
    [sym_number] = ACTIONS(2874),
    [sym_this] = ACTIONS(2876),
    [sym_super] = ACTIONS(2876),
    [sym_true] = ACTIONS(2876),
    [sym_false] = ACTIONS(2876),
    [sym_null] = ACTIONS(2876),
    [sym_undefined] = ACTIONS(2876),
    [anon_sym_AT] = ACTIONS(2874),
    [anon_sym_static] = ACTIONS(2876),
    [anon_sym_abstract] = ACTIONS(2876),
    [anon_sym_get] = ACTIONS(2876),
    [anon_sym_set] = ACTIONS(2876),
    [anon_sym_declare] = ACTIONS(2876),
    [anon_sym_public] = ACTIONS(2876),
    [anon_sym_private] = ACTIONS(2876),
    [anon_sym_protected] = ACTIONS(2876),
    [anon_sym_module] = ACTIONS(2876),
    [anon_sym_any] = ACTIONS(2876),
    [anon_sym_number] = ACTIONS(2876),
    [anon_sym_boolean] = ACTIONS(2876),
    [anon_sym_string] = ACTIONS(2876),
    [anon_sym_symbol] = ACTIONS(2876),
    [anon_sym_interface] = ACTIONS(2876),
    [anon_sym_enum] = ACTIONS(2876),
    [sym_readonly] = ACTIONS(2876),
  },
  [571] = {
    [sym_object] = STATE(2429),
    [sym_array] = STATE(2433),
    [sym_identifier] = ACTIONS(2878),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [sym_readonly] = ACTIONS(2880),
  },
  [572] = {
    [sym__call_signature] = STATE(2989),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_export] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2696),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_async] = ACTIONS(2696),
    [anon_sym_function] = ACTIONS(2700),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2696),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2696),
    [anon_sym_get] = ACTIONS(2696),
    [anon_sym_set] = ACTIONS(2696),
    [anon_sym_declare] = ACTIONS(2696),
    [anon_sym_public] = ACTIONS(2696),
    [anon_sym_private] = ACTIONS(2696),
    [anon_sym_protected] = ACTIONS(2696),
    [anon_sym_module] = ACTIONS(2696),
    [anon_sym_any] = ACTIONS(2696),
    [anon_sym_number] = ACTIONS(2696),
    [anon_sym_boolean] = ACTIONS(2696),
    [anon_sym_string] = ACTIONS(2696),
    [anon_sym_symbol] = ACTIONS(2696),
    [sym_readonly] = ACTIONS(2696),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_default] = ACTIONS(2889),
    [anon_sym_namespace] = ACTIONS(2889),
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_type] = ACTIONS(2889),
    [anon_sym_typeof] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_var] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_switch] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_await] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_with] = ACTIONS(2889),
    [anon_sym_break] = ACTIONS(2889),
    [anon_sym_continue] = ACTIONS(2889),
    [anon_sym_debugger] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_throw] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_case] = ACTIONS(2889),
    [anon_sym_yield] = ACTIONS(2889),
    [anon_sym_LBRACK] = ACTIONS(2887),
    [anon_sym_LT] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(2889),
    [anon_sym_class] = ACTIONS(2889),
    [anon_sym_async] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_new] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_DASH] = ACTIONS(2889),
    [anon_sym_BANG] = ACTIONS(2887),
    [anon_sym_TILDE] = ACTIONS(2887),
    [anon_sym_void] = ACTIONS(2889),
    [anon_sym_delete] = ACTIONS(2889),
    [anon_sym_PLUS_PLUS] = ACTIONS(2887),
    [anon_sym_DASH_DASH] = ACTIONS(2887),
    [anon_sym_DQUOTE] = ACTIONS(2887),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2887),
    [sym_number] = ACTIONS(2887),
    [sym_this] = ACTIONS(2889),
    [sym_super] = ACTIONS(2889),
    [sym_true] = ACTIONS(2889),
    [sym_false] = ACTIONS(2889),
    [sym_null] = ACTIONS(2889),
    [sym_undefined] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2887),
    [anon_sym_static] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_get] = ACTIONS(2889),
    [anon_sym_set] = ACTIONS(2889),
    [anon_sym_declare] = ACTIONS(2889),
    [anon_sym_public] = ACTIONS(2889),
    [anon_sym_private] = ACTIONS(2889),
    [anon_sym_protected] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_any] = ACTIONS(2889),
    [anon_sym_number] = ACTIONS(2889),
    [anon_sym_boolean] = ACTIONS(2889),
    [anon_sym_string] = ACTIONS(2889),
    [anon_sym_symbol] = ACTIONS(2889),
    [anon_sym_interface] = ACTIONS(2889),
    [anon_sym_enum] = ACTIONS(2889),
    [sym_readonly] = ACTIONS(2889),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(2891),
    [sym_identifier] = ACTIONS(2893),
    [anon_sym_export] = ACTIONS(2893),
    [anon_sym_default] = ACTIONS(2893),
    [anon_sym_namespace] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_type] = ACTIONS(2893),
    [anon_sym_typeof] = ACTIONS(2893),
    [anon_sym_import] = ACTIONS(2893),
    [anon_sym_var] = ACTIONS(2893),
    [anon_sym_let] = ACTIONS(2893),
    [anon_sym_const] = ACTIONS(2893),
    [anon_sym_if] = ACTIONS(2893),
    [anon_sym_else] = ACTIONS(2893),
    [anon_sym_switch] = ACTIONS(2893),
    [anon_sym_for] = ACTIONS(2893),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_await] = ACTIONS(2893),
    [anon_sym_while] = ACTIONS(2893),
    [anon_sym_do] = ACTIONS(2893),
    [anon_sym_try] = ACTIONS(2893),
    [anon_sym_with] = ACTIONS(2893),
    [anon_sym_break] = ACTIONS(2893),
    [anon_sym_continue] = ACTIONS(2893),
    [anon_sym_debugger] = ACTIONS(2893),
    [anon_sym_return] = ACTIONS(2893),
    [anon_sym_throw] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_case] = ACTIONS(2893),
    [anon_sym_yield] = ACTIONS(2893),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2891),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_class] = ACTIONS(2893),
    [anon_sym_async] = ACTIONS(2893),
    [anon_sym_function] = ACTIONS(2893),
    [anon_sym_new] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_BANG] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2891),
    [anon_sym_void] = ACTIONS(2893),
    [anon_sym_delete] = ACTIONS(2893),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [anon_sym_DQUOTE] = ACTIONS(2891),
    [anon_sym_SQUOTE] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2891),
    [sym_number] = ACTIONS(2891),
    [sym_this] = ACTIONS(2893),
    [sym_super] = ACTIONS(2893),
    [sym_true] = ACTIONS(2893),
    [sym_false] = ACTIONS(2893),
    [sym_null] = ACTIONS(2893),
    [sym_undefined] = ACTIONS(2893),
    [anon_sym_AT] = ACTIONS(2891),
    [anon_sym_static] = ACTIONS(2893),
    [anon_sym_abstract] = ACTIONS(2893),
    [anon_sym_get] = ACTIONS(2893),
    [anon_sym_set] = ACTIONS(2893),
    [anon_sym_declare] = ACTIONS(2893),
    [anon_sym_public] = ACTIONS(2893),
    [anon_sym_private] = ACTIONS(2893),
    [anon_sym_protected] = ACTIONS(2893),
    [anon_sym_module] = ACTIONS(2893),
    [anon_sym_any] = ACTIONS(2893),
    [anon_sym_number] = ACTIONS(2893),
    [anon_sym_boolean] = ACTIONS(2893),
    [anon_sym_string] = ACTIONS(2893),
    [anon_sym_symbol] = ACTIONS(2893),
    [anon_sym_interface] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2893),
    [sym_readonly] = ACTIONS(2893),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(2895),
    [sym_identifier] = ACTIONS(2897),
    [anon_sym_export] = ACTIONS(2897),
    [anon_sym_default] = ACTIONS(2897),
    [anon_sym_namespace] = ACTIONS(2897),
    [anon_sym_LBRACE] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_type] = ACTIONS(2897),
    [anon_sym_typeof] = ACTIONS(2897),
    [anon_sym_import] = ACTIONS(2897),
    [anon_sym_var] = ACTIONS(2897),
    [anon_sym_let] = ACTIONS(2897),
    [anon_sym_const] = ACTIONS(2897),
    [anon_sym_if] = ACTIONS(2897),
    [anon_sym_else] = ACTIONS(2897),
    [anon_sym_switch] = ACTIONS(2897),
    [anon_sym_for] = ACTIONS(2897),
    [anon_sym_LPAREN] = ACTIONS(2895),
    [anon_sym_await] = ACTIONS(2897),
    [anon_sym_while] = ACTIONS(2897),
    [anon_sym_do] = ACTIONS(2897),
    [anon_sym_try] = ACTIONS(2897),
    [anon_sym_with] = ACTIONS(2897),
    [anon_sym_break] = ACTIONS(2897),
    [anon_sym_continue] = ACTIONS(2897),
    [anon_sym_debugger] = ACTIONS(2897),
    [anon_sym_return] = ACTIONS(2897),
    [anon_sym_throw] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_case] = ACTIONS(2897),
    [anon_sym_yield] = ACTIONS(2897),
    [anon_sym_LBRACK] = ACTIONS(2895),
    [anon_sym_LT] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2897),
    [anon_sym_class] = ACTIONS(2897),
    [anon_sym_async] = ACTIONS(2897),
    [anon_sym_function] = ACTIONS(2897),
    [anon_sym_new] = ACTIONS(2897),
    [anon_sym_PLUS] = ACTIONS(2897),
    [anon_sym_DASH] = ACTIONS(2897),
    [anon_sym_BANG] = ACTIONS(2895),
    [anon_sym_TILDE] = ACTIONS(2895),
    [anon_sym_void] = ACTIONS(2897),
    [anon_sym_delete] = ACTIONS(2897),
    [anon_sym_PLUS_PLUS] = ACTIONS(2895),
    [anon_sym_DASH_DASH] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2895),
    [anon_sym_SQUOTE] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2895),
    [sym_number] = ACTIONS(2895),
    [sym_this] = ACTIONS(2897),
    [sym_super] = ACTIONS(2897),
    [sym_true] = ACTIONS(2897),
    [sym_false] = ACTIONS(2897),
    [sym_null] = ACTIONS(2897),
    [sym_undefined] = ACTIONS(2897),
    [anon_sym_AT] = ACTIONS(2895),
    [anon_sym_static] = ACTIONS(2897),
    [anon_sym_abstract] = ACTIONS(2897),
    [anon_sym_get] = ACTIONS(2897),
    [anon_sym_set] = ACTIONS(2897),
    [anon_sym_declare] = ACTIONS(2897),
    [anon_sym_public] = ACTIONS(2897),
    [anon_sym_private] = ACTIONS(2897),
    [anon_sym_protected] = ACTIONS(2897),
    [anon_sym_module] = ACTIONS(2897),
    [anon_sym_any] = ACTIONS(2897),
    [anon_sym_number] = ACTIONS(2897),
    [anon_sym_boolean] = ACTIONS(2897),
    [anon_sym_string] = ACTIONS(2897),
    [anon_sym_symbol] = ACTIONS(2897),
    [anon_sym_interface] = ACTIONS(2897),
    [anon_sym_enum] = ACTIONS(2897),
    [sym_readonly] = ACTIONS(2897),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(2899),
    [sym_identifier] = ACTIONS(2901),
    [anon_sym_export] = ACTIONS(2901),
    [anon_sym_default] = ACTIONS(2901),
    [anon_sym_namespace] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [anon_sym_type] = ACTIONS(2901),
    [anon_sym_typeof] = ACTIONS(2901),
    [anon_sym_import] = ACTIONS(2901),
    [anon_sym_var] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_const] = ACTIONS(2901),
    [anon_sym_if] = ACTIONS(2901),
    [anon_sym_else] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_for] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_await] = ACTIONS(2901),
    [anon_sym_while] = ACTIONS(2901),
    [anon_sym_do] = ACTIONS(2901),
    [anon_sym_try] = ACTIONS(2901),
    [anon_sym_with] = ACTIONS(2901),
    [anon_sym_break] = ACTIONS(2901),
    [anon_sym_continue] = ACTIONS(2901),
    [anon_sym_debugger] = ACTIONS(2901),
    [anon_sym_return] = ACTIONS(2901),
    [anon_sym_throw] = ACTIONS(2901),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_case] = ACTIONS(2901),
    [anon_sym_yield] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_SLASH] = ACTIONS(2901),
    [anon_sym_class] = ACTIONS(2901),
    [anon_sym_async] = ACTIONS(2901),
    [anon_sym_function] = ACTIONS(2901),
    [anon_sym_new] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2901),
    [anon_sym_DASH] = ACTIONS(2901),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_TILDE] = ACTIONS(2899),
    [anon_sym_void] = ACTIONS(2901),
    [anon_sym_delete] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2899),
    [anon_sym_DASH_DASH] = ACTIONS(2899),
    [anon_sym_DQUOTE] = ACTIONS(2899),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2899),
    [sym_number] = ACTIONS(2899),
    [sym_this] = ACTIONS(2901),
    [sym_super] = ACTIONS(2901),
    [sym_true] = ACTIONS(2901),
    [sym_false] = ACTIONS(2901),
    [sym_null] = ACTIONS(2901),
    [sym_undefined] = ACTIONS(2901),
    [anon_sym_AT] = ACTIONS(2899),
    [anon_sym_static] = ACTIONS(2901),
    [anon_sym_abstract] = ACTIONS(2901),
    [anon_sym_get] = ACTIONS(2901),
    [anon_sym_set] = ACTIONS(2901),
    [anon_sym_declare] = ACTIONS(2901),
    [anon_sym_public] = ACTIONS(2901),
    [anon_sym_private] = ACTIONS(2901),
    [anon_sym_protected] = ACTIONS(2901),
    [anon_sym_module] = ACTIONS(2901),
    [anon_sym_any] = ACTIONS(2901),
    [anon_sym_number] = ACTIONS(2901),
    [anon_sym_boolean] = ACTIONS(2901),
    [anon_sym_string] = ACTIONS(2901),
    [anon_sym_symbol] = ACTIONS(2901),
    [anon_sym_interface] = ACTIONS(2901),
    [anon_sym_enum] = ACTIONS(2901),
    [sym_readonly] = ACTIONS(2901),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(2903),
    [sym_identifier] = ACTIONS(2905),
    [anon_sym_export] = ACTIONS(2905),
    [anon_sym_default] = ACTIONS(2905),
    [anon_sym_namespace] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2903),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [anon_sym_type] = ACTIONS(2905),
    [anon_sym_typeof] = ACTIONS(2905),
    [anon_sym_import] = ACTIONS(2905),
    [anon_sym_var] = ACTIONS(2905),
    [anon_sym_let] = ACTIONS(2905),
    [anon_sym_const] = ACTIONS(2905),
    [anon_sym_if] = ACTIONS(2905),
    [anon_sym_else] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_for] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2903),
    [anon_sym_await] = ACTIONS(2905),
    [anon_sym_while] = ACTIONS(2905),
    [anon_sym_do] = ACTIONS(2905),
    [anon_sym_try] = ACTIONS(2905),
    [anon_sym_with] = ACTIONS(2905),
    [anon_sym_break] = ACTIONS(2905),
    [anon_sym_continue] = ACTIONS(2905),
    [anon_sym_debugger] = ACTIONS(2905),
    [anon_sym_return] = ACTIONS(2905),
    [anon_sym_throw] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_case] = ACTIONS(2905),
    [anon_sym_yield] = ACTIONS(2905),
    [anon_sym_LBRACK] = ACTIONS(2903),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_SLASH] = ACTIONS(2905),
    [anon_sym_class] = ACTIONS(2905),
    [anon_sym_async] = ACTIONS(2905),
    [anon_sym_function] = ACTIONS(2905),
    [anon_sym_new] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2905),
    [anon_sym_DASH] = ACTIONS(2905),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_TILDE] = ACTIONS(2903),
    [anon_sym_void] = ACTIONS(2905),
    [anon_sym_delete] = ACTIONS(2905),
    [anon_sym_PLUS_PLUS] = ACTIONS(2903),
    [anon_sym_DASH_DASH] = ACTIONS(2903),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [anon_sym_SQUOTE] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2903),
    [sym_number] = ACTIONS(2903),
    [sym_this] = ACTIONS(2905),
    [sym_super] = ACTIONS(2905),
    [sym_true] = ACTIONS(2905),
    [sym_false] = ACTIONS(2905),
    [sym_null] = ACTIONS(2905),
    [sym_undefined] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2903),
    [anon_sym_static] = ACTIONS(2905),
    [anon_sym_abstract] = ACTIONS(2905),
    [anon_sym_get] = ACTIONS(2905),
    [anon_sym_set] = ACTIONS(2905),
    [anon_sym_declare] = ACTIONS(2905),
    [anon_sym_public] = ACTIONS(2905),
    [anon_sym_private] = ACTIONS(2905),
    [anon_sym_protected] = ACTIONS(2905),
    [anon_sym_module] = ACTIONS(2905),
    [anon_sym_any] = ACTIONS(2905),
    [anon_sym_number] = ACTIONS(2905),
    [anon_sym_boolean] = ACTIONS(2905),
    [anon_sym_string] = ACTIONS(2905),
    [anon_sym_symbol] = ACTIONS(2905),
    [anon_sym_interface] = ACTIONS(2905),
    [anon_sym_enum] = ACTIONS(2905),
    [sym_readonly] = ACTIONS(2905),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(2907),
    [sym_identifier] = ACTIONS(2909),
    [anon_sym_export] = ACTIONS(2909),
    [anon_sym_default] = ACTIONS(2909),
    [anon_sym_namespace] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_RBRACE] = ACTIONS(2907),
    [anon_sym_type] = ACTIONS(2909),
    [anon_sym_typeof] = ACTIONS(2909),
    [anon_sym_import] = ACTIONS(2909),
    [anon_sym_var] = ACTIONS(2909),
    [anon_sym_let] = ACTIONS(2909),
    [anon_sym_const] = ACTIONS(2909),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_else] = ACTIONS(2909),
    [anon_sym_switch] = ACTIONS(2909),
    [anon_sym_for] = ACTIONS(2909),
    [anon_sym_LPAREN] = ACTIONS(2907),
    [anon_sym_await] = ACTIONS(2909),
    [anon_sym_while] = ACTIONS(2909),
    [anon_sym_do] = ACTIONS(2909),
    [anon_sym_try] = ACTIONS(2909),
    [anon_sym_with] = ACTIONS(2909),
    [anon_sym_break] = ACTIONS(2909),
    [anon_sym_continue] = ACTIONS(2909),
    [anon_sym_debugger] = ACTIONS(2909),
    [anon_sym_return] = ACTIONS(2909),
    [anon_sym_throw] = ACTIONS(2909),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_case] = ACTIONS(2909),
    [anon_sym_yield] = ACTIONS(2909),
    [anon_sym_LBRACK] = ACTIONS(2907),
    [anon_sym_LT] = ACTIONS(2907),
    [anon_sym_SLASH] = ACTIONS(2909),
    [anon_sym_class] = ACTIONS(2909),
    [anon_sym_async] = ACTIONS(2909),
    [anon_sym_function] = ACTIONS(2909),
    [anon_sym_new] = ACTIONS(2909),
    [anon_sym_PLUS] = ACTIONS(2909),
    [anon_sym_DASH] = ACTIONS(2909),
    [anon_sym_BANG] = ACTIONS(2907),
    [anon_sym_TILDE] = ACTIONS(2907),
    [anon_sym_void] = ACTIONS(2909),
    [anon_sym_delete] = ACTIONS(2909),
    [anon_sym_PLUS_PLUS] = ACTIONS(2907),
    [anon_sym_DASH_DASH] = ACTIONS(2907),
    [anon_sym_DQUOTE] = ACTIONS(2907),
    [anon_sym_SQUOTE] = ACTIONS(2907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2907),
    [sym_number] = ACTIONS(2907),
    [sym_this] = ACTIONS(2909),
    [sym_super] = ACTIONS(2909),
    [sym_true] = ACTIONS(2909),
    [sym_false] = ACTIONS(2909),
    [sym_null] = ACTIONS(2909),
    [sym_undefined] = ACTIONS(2909),
    [anon_sym_AT] = ACTIONS(2907),
    [anon_sym_static] = ACTIONS(2909),
    [anon_sym_abstract] = ACTIONS(2909),
    [anon_sym_get] = ACTIONS(2909),
    [anon_sym_set] = ACTIONS(2909),
    [anon_sym_declare] = ACTIONS(2909),
    [anon_sym_public] = ACTIONS(2909),
    [anon_sym_private] = ACTIONS(2909),
    [anon_sym_protected] = ACTIONS(2909),
    [anon_sym_module] = ACTIONS(2909),
    [anon_sym_any] = ACTIONS(2909),
    [anon_sym_number] = ACTIONS(2909),
    [anon_sym_boolean] = ACTIONS(2909),
    [anon_sym_string] = ACTIONS(2909),
    [anon_sym_symbol] = ACTIONS(2909),
    [anon_sym_interface] = ACTIONS(2909),
    [anon_sym_enum] = ACTIONS(2909),
    [sym_readonly] = ACTIONS(2909),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(1195),
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [anon_sym_default] = ACTIONS(1197),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(1197),
    [anon_sym_import] = ACTIONS(1197),
    [anon_sym_var] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_const] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_for] = ACTIONS(1197),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_do] = ACTIONS(1197),
    [anon_sym_try] = ACTIONS(1197),
    [anon_sym_with] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [anon_sym_debugger] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_throw] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_case] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_new] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_TILDE] = ACTIONS(1195),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_delete] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym_number] = ACTIONS(1195),
    [sym_this] = ACTIONS(1197),
    [sym_super] = ACTIONS(1197),
    [sym_true] = ACTIONS(1197),
    [sym_false] = ACTIONS(1197),
    [sym_null] = ACTIONS(1197),
    [sym_undefined] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(1195),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_abstract] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1197),
    [anon_sym_protected] = ACTIONS(1197),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_interface] = ACTIONS(1197),
    [anon_sym_enum] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(1197),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(2911),
    [sym_identifier] = ACTIONS(2913),
    [anon_sym_export] = ACTIONS(2913),
    [anon_sym_default] = ACTIONS(2913),
    [anon_sym_namespace] = ACTIONS(2913),
    [anon_sym_LBRACE] = ACTIONS(2911),
    [anon_sym_RBRACE] = ACTIONS(2911),
    [anon_sym_type] = ACTIONS(2913),
    [anon_sym_typeof] = ACTIONS(2913),
    [anon_sym_import] = ACTIONS(2913),
    [anon_sym_var] = ACTIONS(2913),
    [anon_sym_let] = ACTIONS(2913),
    [anon_sym_const] = ACTIONS(2913),
    [anon_sym_if] = ACTIONS(2913),
    [anon_sym_else] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2913),
    [anon_sym_for] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2911),
    [anon_sym_await] = ACTIONS(2913),
    [anon_sym_while] = ACTIONS(2913),
    [anon_sym_do] = ACTIONS(2913),
    [anon_sym_try] = ACTIONS(2913),
    [anon_sym_with] = ACTIONS(2913),
    [anon_sym_break] = ACTIONS(2913),
    [anon_sym_continue] = ACTIONS(2913),
    [anon_sym_debugger] = ACTIONS(2913),
    [anon_sym_return] = ACTIONS(2913),
    [anon_sym_throw] = ACTIONS(2913),
    [anon_sym_SEMI] = ACTIONS(2911),
    [anon_sym_case] = ACTIONS(2913),
    [anon_sym_yield] = ACTIONS(2913),
    [anon_sym_LBRACK] = ACTIONS(2911),
    [anon_sym_LT] = ACTIONS(2911),
    [anon_sym_SLASH] = ACTIONS(2913),
    [anon_sym_class] = ACTIONS(2913),
    [anon_sym_async] = ACTIONS(2913),
    [anon_sym_function] = ACTIONS(2913),
    [anon_sym_new] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2913),
    [anon_sym_DASH] = ACTIONS(2913),
    [anon_sym_BANG] = ACTIONS(2911),
    [anon_sym_TILDE] = ACTIONS(2911),
    [anon_sym_void] = ACTIONS(2913),
    [anon_sym_delete] = ACTIONS(2913),
    [anon_sym_PLUS_PLUS] = ACTIONS(2911),
    [anon_sym_DASH_DASH] = ACTIONS(2911),
    [anon_sym_DQUOTE] = ACTIONS(2911),
    [anon_sym_SQUOTE] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2911),
    [sym_number] = ACTIONS(2911),
    [sym_this] = ACTIONS(2913),
    [sym_super] = ACTIONS(2913),
    [sym_true] = ACTIONS(2913),
    [sym_false] = ACTIONS(2913),
    [sym_null] = ACTIONS(2913),
    [sym_undefined] = ACTIONS(2913),
    [anon_sym_AT] = ACTIONS(2911),
    [anon_sym_static] = ACTIONS(2913),
    [anon_sym_abstract] = ACTIONS(2913),
    [anon_sym_get] = ACTIONS(2913),
    [anon_sym_set] = ACTIONS(2913),
    [anon_sym_declare] = ACTIONS(2913),
    [anon_sym_public] = ACTIONS(2913),
    [anon_sym_private] = ACTIONS(2913),
    [anon_sym_protected] = ACTIONS(2913),
    [anon_sym_module] = ACTIONS(2913),
    [anon_sym_any] = ACTIONS(2913),
    [anon_sym_number] = ACTIONS(2913),
    [anon_sym_boolean] = ACTIONS(2913),
    [anon_sym_string] = ACTIONS(2913),
    [anon_sym_symbol] = ACTIONS(2913),
    [anon_sym_interface] = ACTIONS(2913),
    [anon_sym_enum] = ACTIONS(2913),
    [sym_readonly] = ACTIONS(2913),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(2917),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_export] = ACTIONS(2919),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_type] = ACTIONS(2919),
    [anon_sym_typeof] = ACTIONS(2919),
    [anon_sym_import] = ACTIONS(2919),
    [anon_sym_var] = ACTIONS(2919),
    [anon_sym_let] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_else] = ACTIONS(2919),
    [anon_sym_switch] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_await] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_with] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_debugger] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_throw] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_case] = ACTIONS(2919),
    [anon_sym_yield] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_async] = ACTIONS(2919),
    [anon_sym_function] = ACTIONS(2919),
    [anon_sym_new] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_void] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2917),
    [sym_number] = ACTIONS(2917),
    [sym_this] = ACTIONS(2919),
    [sym_super] = ACTIONS(2919),
    [sym_true] = ACTIONS(2919),
    [sym_false] = ACTIONS(2919),
    [sym_null] = ACTIONS(2919),
    [sym_undefined] = ACTIONS(2919),
    [anon_sym_AT] = ACTIONS(2917),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_abstract] = ACTIONS(2919),
    [anon_sym_get] = ACTIONS(2919),
    [anon_sym_set] = ACTIONS(2919),
    [anon_sym_declare] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_module] = ACTIONS(2919),
    [anon_sym_any] = ACTIONS(2919),
    [anon_sym_number] = ACTIONS(2919),
    [anon_sym_boolean] = ACTIONS(2919),
    [anon_sym_string] = ACTIONS(2919),
    [anon_sym_symbol] = ACTIONS(2919),
    [anon_sym_interface] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [sym_readonly] = ACTIONS(2919),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(1181),
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_export] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(1183),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_type] = ACTIONS(1183),
    [anon_sym_typeof] = ACTIONS(1183),
    [anon_sym_import] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(1183),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_const] = ACTIONS(1183),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_switch] = ACTIONS(1183),
    [anon_sym_for] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1183),
    [anon_sym_do] = ACTIONS(1183),
    [anon_sym_try] = ACTIONS(1183),
    [anon_sym_with] = ACTIONS(1183),
    [anon_sym_break] = ACTIONS(1183),
    [anon_sym_continue] = ACTIONS(1183),
    [anon_sym_debugger] = ACTIONS(1183),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_throw] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_case] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1181),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1183),
    [anon_sym_async] = ACTIONS(1183),
    [anon_sym_function] = ACTIONS(1183),
    [anon_sym_new] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1181),
    [anon_sym_TILDE] = ACTIONS(1181),
    [anon_sym_void] = ACTIONS(1183),
    [anon_sym_delete] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [sym_number] = ACTIONS(1181),
    [sym_this] = ACTIONS(1183),
    [sym_super] = ACTIONS(1183),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_null] = ACTIONS(1183),
    [sym_undefined] = ACTIONS(1183),
    [anon_sym_AT] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1183),
    [anon_sym_abstract] = ACTIONS(1183),
    [anon_sym_get] = ACTIONS(1183),
    [anon_sym_set] = ACTIONS(1183),
    [anon_sym_declare] = ACTIONS(1183),
    [anon_sym_public] = ACTIONS(1183),
    [anon_sym_private] = ACTIONS(1183),
    [anon_sym_protected] = ACTIONS(1183),
    [anon_sym_module] = ACTIONS(1183),
    [anon_sym_any] = ACTIONS(1183),
    [anon_sym_number] = ACTIONS(1183),
    [anon_sym_boolean] = ACTIONS(1183),
    [anon_sym_string] = ACTIONS(1183),
    [anon_sym_symbol] = ACTIONS(1183),
    [anon_sym_interface] = ACTIONS(1183),
    [anon_sym_enum] = ACTIONS(1183),
    [sym_readonly] = ACTIONS(1183),
  },
  [583] = {
    [sym_object] = STATE(2429),
    [sym_array] = STATE(2433),
    [sym_identifier] = ACTIONS(2878),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [sym_readonly] = ACTIONS(2880),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(2921),
    [sym_identifier] = ACTIONS(2923),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_default] = ACTIONS(2923),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_type] = ACTIONS(2923),
    [anon_sym_typeof] = ACTIONS(2923),
    [anon_sym_import] = ACTIONS(2923),
    [anon_sym_var] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_await] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_debugger] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_throw] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_case] = ACTIONS(2923),
    [anon_sym_yield] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_async] = ACTIONS(2923),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_new] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_void] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2921),
    [sym_number] = ACTIONS(2921),
    [sym_this] = ACTIONS(2923),
    [sym_super] = ACTIONS(2923),
    [sym_true] = ACTIONS(2923),
    [sym_false] = ACTIONS(2923),
    [sym_null] = ACTIONS(2923),
    [sym_undefined] = ACTIONS(2923),
    [anon_sym_AT] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_abstract] = ACTIONS(2923),
    [anon_sym_get] = ACTIONS(2923),
    [anon_sym_set] = ACTIONS(2923),
    [anon_sym_declare] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_any] = ACTIONS(2923),
    [anon_sym_number] = ACTIONS(2923),
    [anon_sym_boolean] = ACTIONS(2923),
    [anon_sym_string] = ACTIONS(2923),
    [anon_sym_symbol] = ACTIONS(2923),
    [anon_sym_interface] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [sym_readonly] = ACTIONS(2923),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(2925),
    [sym_identifier] = ACTIONS(2927),
    [anon_sym_export] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_type] = ACTIONS(2927),
    [anon_sym_typeof] = ACTIONS(2927),
    [anon_sym_import] = ACTIONS(2927),
    [anon_sym_var] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_await] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_debugger] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_yield] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_async] = ACTIONS(2927),
    [anon_sym_function] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_void] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2925),
    [sym_number] = ACTIONS(2925),
    [sym_this] = ACTIONS(2927),
    [sym_super] = ACTIONS(2927),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_undefined] = ACTIONS(2927),
    [anon_sym_AT] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_abstract] = ACTIONS(2927),
    [anon_sym_get] = ACTIONS(2927),
    [anon_sym_set] = ACTIONS(2927),
    [anon_sym_declare] = ACTIONS(2927),
    [anon_sym_public] = ACTIONS(2927),
    [anon_sym_private] = ACTIONS(2927),
    [anon_sym_protected] = ACTIONS(2927),
    [anon_sym_module] = ACTIONS(2927),
    [anon_sym_any] = ACTIONS(2927),
    [anon_sym_number] = ACTIONS(2927),
    [anon_sym_boolean] = ACTIONS(2927),
    [anon_sym_string] = ACTIONS(2927),
    [anon_sym_symbol] = ACTIONS(2927),
    [anon_sym_interface] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [sym_readonly] = ACTIONS(2927),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(2929),
    [sym_identifier] = ACTIONS(2931),
    [anon_sym_export] = ACTIONS(2931),
    [anon_sym_default] = ACTIONS(2931),
    [anon_sym_namespace] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_type] = ACTIONS(2931),
    [anon_sym_typeof] = ACTIONS(2931),
    [anon_sym_import] = ACTIONS(2931),
    [anon_sym_var] = ACTIONS(2931),
    [anon_sym_let] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_else] = ACTIONS(2931),
    [anon_sym_switch] = ACTIONS(2931),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(2929),
    [anon_sym_await] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_try] = ACTIONS(2931),
    [anon_sym_with] = ACTIONS(2931),
    [anon_sym_break] = ACTIONS(2931),
    [anon_sym_continue] = ACTIONS(2931),
    [anon_sym_debugger] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2931),
    [anon_sym_throw] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_case] = ACTIONS(2931),
    [anon_sym_yield] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_async] = ACTIONS(2931),
    [anon_sym_function] = ACTIONS(2931),
    [anon_sym_new] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_void] = ACTIONS(2931),
    [anon_sym_delete] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2929),
    [sym_number] = ACTIONS(2929),
    [sym_this] = ACTIONS(2931),
    [sym_super] = ACTIONS(2931),
    [sym_true] = ACTIONS(2931),
    [sym_false] = ACTIONS(2931),
    [sym_null] = ACTIONS(2931),
    [sym_undefined] = ACTIONS(2931),
    [anon_sym_AT] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_abstract] = ACTIONS(2931),
    [anon_sym_get] = ACTIONS(2931),
    [anon_sym_set] = ACTIONS(2931),
    [anon_sym_declare] = ACTIONS(2931),
    [anon_sym_public] = ACTIONS(2931),
    [anon_sym_private] = ACTIONS(2931),
    [anon_sym_protected] = ACTIONS(2931),
    [anon_sym_module] = ACTIONS(2931),
    [anon_sym_any] = ACTIONS(2931),
    [anon_sym_number] = ACTIONS(2931),
    [anon_sym_boolean] = ACTIONS(2931),
    [anon_sym_string] = ACTIONS(2931),
    [anon_sym_symbol] = ACTIONS(2931),
    [anon_sym_interface] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [sym_readonly] = ACTIONS(2931),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(2933),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2935),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_import] = ACTIONS(2935),
    [anon_sym_var] = ACTIONS(2935),
    [anon_sym_let] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_else] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2933),
    [anon_sym_await] = ACTIONS(2935),
    [anon_sym_while] = ACTIONS(2935),
    [anon_sym_do] = ACTIONS(2935),
    [anon_sym_try] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_debugger] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_throw] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_case] = ACTIONS(2935),
    [anon_sym_yield] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_async] = ACTIONS(2935),
    [anon_sym_function] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_void] = ACTIONS(2935),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2933),
    [anon_sym_SQUOTE] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2933),
    [sym_number] = ACTIONS(2933),
    [sym_this] = ACTIONS(2935),
    [sym_super] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_null] = ACTIONS(2935),
    [sym_undefined] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(2933),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_abstract] = ACTIONS(2935),
    [anon_sym_get] = ACTIONS(2935),
    [anon_sym_set] = ACTIONS(2935),
    [anon_sym_declare] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2935),
    [anon_sym_private] = ACTIONS(2935),
    [anon_sym_protected] = ACTIONS(2935),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_any] = ACTIONS(2935),
    [anon_sym_number] = ACTIONS(2935),
    [anon_sym_boolean] = ACTIONS(2935),
    [anon_sym_string] = ACTIONS(2935),
    [anon_sym_symbol] = ACTIONS(2935),
    [anon_sym_interface] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [sym_readonly] = ACTIONS(2935),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(2937),
    [sym_identifier] = ACTIONS(2939),
    [anon_sym_export] = ACTIONS(2939),
    [anon_sym_default] = ACTIONS(2939),
    [anon_sym_namespace] = ACTIONS(2939),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_RBRACE] = ACTIONS(2937),
    [anon_sym_type] = ACTIONS(2939),
    [anon_sym_typeof] = ACTIONS(2939),
    [anon_sym_import] = ACTIONS(2939),
    [anon_sym_var] = ACTIONS(2939),
    [anon_sym_let] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(2939),
    [anon_sym_else] = ACTIONS(2939),
    [anon_sym_switch] = ACTIONS(2939),
    [anon_sym_for] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2939),
    [anon_sym_while] = ACTIONS(2939),
    [anon_sym_do] = ACTIONS(2939),
    [anon_sym_try] = ACTIONS(2939),
    [anon_sym_with] = ACTIONS(2939),
    [anon_sym_break] = ACTIONS(2939),
    [anon_sym_continue] = ACTIONS(2939),
    [anon_sym_debugger] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2939),
    [anon_sym_throw] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym_case] = ACTIONS(2939),
    [anon_sym_yield] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_async] = ACTIONS(2939),
    [anon_sym_function] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2939),
    [anon_sym_DASH] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_delete] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2937),
    [anon_sym_DASH_DASH] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2937),
    [sym_number] = ACTIONS(2937),
    [sym_this] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_true] = ACTIONS(2939),
    [sym_false] = ACTIONS(2939),
    [sym_null] = ACTIONS(2939),
    [sym_undefined] = ACTIONS(2939),
    [anon_sym_AT] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_abstract] = ACTIONS(2939),
    [anon_sym_get] = ACTIONS(2939),
    [anon_sym_set] = ACTIONS(2939),
    [anon_sym_declare] = ACTIONS(2939),
    [anon_sym_public] = ACTIONS(2939),
    [anon_sym_private] = ACTIONS(2939),
    [anon_sym_protected] = ACTIONS(2939),
    [anon_sym_module] = ACTIONS(2939),
    [anon_sym_any] = ACTIONS(2939),
    [anon_sym_number] = ACTIONS(2939),
    [anon_sym_boolean] = ACTIONS(2939),
    [anon_sym_string] = ACTIONS(2939),
    [anon_sym_symbol] = ACTIONS(2939),
    [anon_sym_interface] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [sym_readonly] = ACTIONS(2939),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(2941),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_export] = ACTIONS(2943),
    [anon_sym_default] = ACTIONS(2943),
    [anon_sym_namespace] = ACTIONS(2943),
    [anon_sym_LBRACE] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2941),
    [anon_sym_type] = ACTIONS(2943),
    [anon_sym_typeof] = ACTIONS(2943),
    [anon_sym_import] = ACTIONS(2943),
    [anon_sym_var] = ACTIONS(2943),
    [anon_sym_let] = ACTIONS(2943),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_else] = ACTIONS(2943),
    [anon_sym_switch] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2941),
    [anon_sym_await] = ACTIONS(2943),
    [anon_sym_while] = ACTIONS(2943),
    [anon_sym_do] = ACTIONS(2943),
    [anon_sym_try] = ACTIONS(2943),
    [anon_sym_with] = ACTIONS(2943),
    [anon_sym_break] = ACTIONS(2943),
    [anon_sym_continue] = ACTIONS(2943),
    [anon_sym_debugger] = ACTIONS(2943),
    [anon_sym_return] = ACTIONS(2943),
    [anon_sym_throw] = ACTIONS(2943),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym_case] = ACTIONS(2943),
    [anon_sym_yield] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_LT] = ACTIONS(2941),
    [anon_sym_SLASH] = ACTIONS(2943),
    [anon_sym_class] = ACTIONS(2943),
    [anon_sym_async] = ACTIONS(2943),
    [anon_sym_function] = ACTIONS(2943),
    [anon_sym_new] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_DASH] = ACTIONS(2943),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_void] = ACTIONS(2943),
    [anon_sym_delete] = ACTIONS(2943),
    [anon_sym_PLUS_PLUS] = ACTIONS(2941),
    [anon_sym_DASH_DASH] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [anon_sym_SQUOTE] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [sym_number] = ACTIONS(2941),
    [sym_this] = ACTIONS(2943),
    [sym_super] = ACTIONS(2943),
    [sym_true] = ACTIONS(2943),
    [sym_false] = ACTIONS(2943),
    [sym_null] = ACTIONS(2943),
    [sym_undefined] = ACTIONS(2943),
    [anon_sym_AT] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2943),
    [anon_sym_abstract] = ACTIONS(2943),
    [anon_sym_get] = ACTIONS(2943),
    [anon_sym_set] = ACTIONS(2943),
    [anon_sym_declare] = ACTIONS(2943),
    [anon_sym_public] = ACTIONS(2943),
    [anon_sym_private] = ACTIONS(2943),
    [anon_sym_protected] = ACTIONS(2943),
    [anon_sym_module] = ACTIONS(2943),
    [anon_sym_any] = ACTIONS(2943),
    [anon_sym_number] = ACTIONS(2943),
    [anon_sym_boolean] = ACTIONS(2943),
    [anon_sym_string] = ACTIONS(2943),
    [anon_sym_symbol] = ACTIONS(2943),
    [anon_sym_interface] = ACTIONS(2943),
    [anon_sym_enum] = ACTIONS(2943),
    [sym_readonly] = ACTIONS(2943),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2945),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(2947),
    [anon_sym_default] = ACTIONS(2947),
    [anon_sym_namespace] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_type] = ACTIONS(2947),
    [anon_sym_typeof] = ACTIONS(2947),
    [anon_sym_import] = ACTIONS(2947),
    [anon_sym_var] = ACTIONS(2947),
    [anon_sym_let] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_else] = ACTIONS(2947),
    [anon_sym_switch] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2945),
    [anon_sym_await] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_try] = ACTIONS(2947),
    [anon_sym_with] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_debugger] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_throw] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym_case] = ACTIONS(2947),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_class] = ACTIONS(2947),
    [anon_sym_async] = ACTIONS(2947),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_TILDE] = ACTIONS(2945),
    [anon_sym_void] = ACTIONS(2947),
    [anon_sym_delete] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [sym_number] = ACTIONS(2945),
    [sym_this] = ACTIONS(2947),
    [sym_super] = ACTIONS(2947),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [sym_null] = ACTIONS(2947),
    [sym_undefined] = ACTIONS(2947),
    [anon_sym_AT] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2947),
    [anon_sym_abstract] = ACTIONS(2947),
    [anon_sym_get] = ACTIONS(2947),
    [anon_sym_set] = ACTIONS(2947),
    [anon_sym_declare] = ACTIONS(2947),
    [anon_sym_public] = ACTIONS(2947),
    [anon_sym_private] = ACTIONS(2947),
    [anon_sym_protected] = ACTIONS(2947),
    [anon_sym_module] = ACTIONS(2947),
    [anon_sym_any] = ACTIONS(2947),
    [anon_sym_number] = ACTIONS(2947),
    [anon_sym_boolean] = ACTIONS(2947),
    [anon_sym_string] = ACTIONS(2947),
    [anon_sym_symbol] = ACTIONS(2947),
    [anon_sym_interface] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2947),
    [sym_readonly] = ACTIONS(2947),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(2949),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_export] = ACTIONS(2951),
    [anon_sym_default] = ACTIONS(2951),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2949),
    [anon_sym_type] = ACTIONS(2951),
    [anon_sym_typeof] = ACTIONS(2951),
    [anon_sym_import] = ACTIONS(2951),
    [anon_sym_var] = ACTIONS(2951),
    [anon_sym_let] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_else] = ACTIONS(2951),
    [anon_sym_switch] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2949),
    [anon_sym_await] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2951),
    [anon_sym_do] = ACTIONS(2951),
    [anon_sym_try] = ACTIONS(2951),
    [anon_sym_with] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_debugger] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_throw] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym_case] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_class] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_function] = ACTIONS(2951),
    [anon_sym_new] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2951),
    [anon_sym_delete] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2949),
    [anon_sym_DASH_DASH] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2949),
    [sym_number] = ACTIONS(2949),
    [sym_this] = ACTIONS(2951),
    [sym_super] = ACTIONS(2951),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [sym_null] = ACTIONS(2951),
    [sym_undefined] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2951),
    [anon_sym_abstract] = ACTIONS(2951),
    [anon_sym_get] = ACTIONS(2951),
    [anon_sym_set] = ACTIONS(2951),
    [anon_sym_declare] = ACTIONS(2951),
    [anon_sym_public] = ACTIONS(2951),
    [anon_sym_private] = ACTIONS(2951),
    [anon_sym_protected] = ACTIONS(2951),
    [anon_sym_module] = ACTIONS(2951),
    [anon_sym_any] = ACTIONS(2951),
    [anon_sym_number] = ACTIONS(2951),
    [anon_sym_boolean] = ACTIONS(2951),
    [anon_sym_string] = ACTIONS(2951),
    [anon_sym_symbol] = ACTIONS(2951),
    [anon_sym_interface] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2951),
    [sym_readonly] = ACTIONS(2951),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(2953),
    [sym_identifier] = ACTIONS(2955),
    [anon_sym_export] = ACTIONS(2955),
    [anon_sym_default] = ACTIONS(2955),
    [anon_sym_namespace] = ACTIONS(2955),
    [anon_sym_LBRACE] = ACTIONS(2953),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_type] = ACTIONS(2955),
    [anon_sym_typeof] = ACTIONS(2955),
    [anon_sym_import] = ACTIONS(2955),
    [anon_sym_var] = ACTIONS(2955),
    [anon_sym_let] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2955),
    [anon_sym_else] = ACTIONS(2955),
    [anon_sym_switch] = ACTIONS(2955),
    [anon_sym_for] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2953),
    [anon_sym_await] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2955),
    [anon_sym_do] = ACTIONS(2955),
    [anon_sym_try] = ACTIONS(2955),
    [anon_sym_with] = ACTIONS(2955),
    [anon_sym_break] = ACTIONS(2955),
    [anon_sym_continue] = ACTIONS(2955),
    [anon_sym_debugger] = ACTIONS(2955),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_throw] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2953),
    [anon_sym_case] = ACTIONS(2955),
    [anon_sym_yield] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2953),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_SLASH] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_async] = ACTIONS(2955),
    [anon_sym_function] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_DASH] = ACTIONS(2955),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_TILDE] = ACTIONS(2953),
    [anon_sym_void] = ACTIONS(2955),
    [anon_sym_delete] = ACTIONS(2955),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(2953),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2953),
    [sym_number] = ACTIONS(2953),
    [sym_this] = ACTIONS(2955),
    [sym_super] = ACTIONS(2955),
    [sym_true] = ACTIONS(2955),
    [sym_false] = ACTIONS(2955),
    [sym_null] = ACTIONS(2955),
    [sym_undefined] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_abstract] = ACTIONS(2955),
    [anon_sym_get] = ACTIONS(2955),
    [anon_sym_set] = ACTIONS(2955),
    [anon_sym_declare] = ACTIONS(2955),
    [anon_sym_public] = ACTIONS(2955),
    [anon_sym_private] = ACTIONS(2955),
    [anon_sym_protected] = ACTIONS(2955),
    [anon_sym_module] = ACTIONS(2955),
    [anon_sym_any] = ACTIONS(2955),
    [anon_sym_number] = ACTIONS(2955),
    [anon_sym_boolean] = ACTIONS(2955),
    [anon_sym_string] = ACTIONS(2955),
    [anon_sym_symbol] = ACTIONS(2955),
    [anon_sym_interface] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [sym_readonly] = ACTIONS(2955),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2957),
    [sym_identifier] = ACTIONS(2959),
    [anon_sym_export] = ACTIONS(2959),
    [anon_sym_default] = ACTIONS(2959),
    [anon_sym_namespace] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2957),
    [anon_sym_RBRACE] = ACTIONS(2957),
    [anon_sym_type] = ACTIONS(2959),
    [anon_sym_typeof] = ACTIONS(2959),
    [anon_sym_import] = ACTIONS(2959),
    [anon_sym_var] = ACTIONS(2959),
    [anon_sym_let] = ACTIONS(2959),
    [anon_sym_const] = ACTIONS(2959),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_else] = ACTIONS(2959),
    [anon_sym_switch] = ACTIONS(2959),
    [anon_sym_for] = ACTIONS(2959),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [anon_sym_await] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_try] = ACTIONS(2959),
    [anon_sym_with] = ACTIONS(2959),
    [anon_sym_break] = ACTIONS(2959),
    [anon_sym_continue] = ACTIONS(2959),
    [anon_sym_debugger] = ACTIONS(2959),
    [anon_sym_return] = ACTIONS(2959),
    [anon_sym_throw] = ACTIONS(2959),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym_case] = ACTIONS(2959),
    [anon_sym_yield] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2959),
    [anon_sym_class] = ACTIONS(2959),
    [anon_sym_async] = ACTIONS(2959),
    [anon_sym_function] = ACTIONS(2959),
    [anon_sym_new] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_TILDE] = ACTIONS(2957),
    [anon_sym_void] = ACTIONS(2959),
    [anon_sym_delete] = ACTIONS(2959),
    [anon_sym_PLUS_PLUS] = ACTIONS(2957),
    [anon_sym_DASH_DASH] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2957),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2957),
    [sym_number] = ACTIONS(2957),
    [sym_this] = ACTIONS(2959),
    [sym_super] = ACTIONS(2959),
    [sym_true] = ACTIONS(2959),
    [sym_false] = ACTIONS(2959),
    [sym_null] = ACTIONS(2959),
    [sym_undefined] = ACTIONS(2959),
    [anon_sym_AT] = ACTIONS(2957),
    [anon_sym_static] = ACTIONS(2959),
    [anon_sym_abstract] = ACTIONS(2959),
    [anon_sym_get] = ACTIONS(2959),
    [anon_sym_set] = ACTIONS(2959),
    [anon_sym_declare] = ACTIONS(2959),
    [anon_sym_public] = ACTIONS(2959),
    [anon_sym_private] = ACTIONS(2959),
    [anon_sym_protected] = ACTIONS(2959),
    [anon_sym_module] = ACTIONS(2959),
    [anon_sym_any] = ACTIONS(2959),
    [anon_sym_number] = ACTIONS(2959),
    [anon_sym_boolean] = ACTIONS(2959),
    [anon_sym_string] = ACTIONS(2959),
    [anon_sym_symbol] = ACTIONS(2959),
    [anon_sym_interface] = ACTIONS(2959),
    [anon_sym_enum] = ACTIONS(2959),
    [sym_readonly] = ACTIONS(2959),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(2961),
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_export] = ACTIONS(2963),
    [anon_sym_default] = ACTIONS(2963),
    [anon_sym_namespace] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2961),
    [anon_sym_RBRACE] = ACTIONS(2961),
    [anon_sym_type] = ACTIONS(2963),
    [anon_sym_typeof] = ACTIONS(2963),
    [anon_sym_import] = ACTIONS(2963),
    [anon_sym_var] = ACTIONS(2963),
    [anon_sym_let] = ACTIONS(2963),
    [anon_sym_const] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_switch] = ACTIONS(2963),
    [anon_sym_for] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_await] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_try] = ACTIONS(2963),
    [anon_sym_with] = ACTIONS(2963),
    [anon_sym_break] = ACTIONS(2963),
    [anon_sym_continue] = ACTIONS(2963),
    [anon_sym_debugger] = ACTIONS(2963),
    [anon_sym_return] = ACTIONS(2963),
    [anon_sym_throw] = ACTIONS(2963),
    [anon_sym_SEMI] = ACTIONS(2961),
    [anon_sym_case] = ACTIONS(2963),
    [anon_sym_yield] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2963),
    [anon_sym_class] = ACTIONS(2963),
    [anon_sym_async] = ACTIONS(2963),
    [anon_sym_function] = ACTIONS(2963),
    [anon_sym_new] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_DASH] = ACTIONS(2963),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2961),
    [anon_sym_void] = ACTIONS(2963),
    [anon_sym_delete] = ACTIONS(2963),
    [anon_sym_PLUS_PLUS] = ACTIONS(2961),
    [anon_sym_DASH_DASH] = ACTIONS(2961),
    [anon_sym_DQUOTE] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2961),
    [sym_number] = ACTIONS(2961),
    [sym_this] = ACTIONS(2963),
    [sym_super] = ACTIONS(2963),
    [sym_true] = ACTIONS(2963),
    [sym_false] = ACTIONS(2963),
    [sym_null] = ACTIONS(2963),
    [sym_undefined] = ACTIONS(2963),
    [anon_sym_AT] = ACTIONS(2961),
    [anon_sym_static] = ACTIONS(2963),
    [anon_sym_abstract] = ACTIONS(2963),
    [anon_sym_get] = ACTIONS(2963),
    [anon_sym_set] = ACTIONS(2963),
    [anon_sym_declare] = ACTIONS(2963),
    [anon_sym_public] = ACTIONS(2963),
    [anon_sym_private] = ACTIONS(2963),
    [anon_sym_protected] = ACTIONS(2963),
    [anon_sym_module] = ACTIONS(2963),
    [anon_sym_any] = ACTIONS(2963),
    [anon_sym_number] = ACTIONS(2963),
    [anon_sym_boolean] = ACTIONS(2963),
    [anon_sym_string] = ACTIONS(2963),
    [anon_sym_symbol] = ACTIONS(2963),
    [anon_sym_interface] = ACTIONS(2963),
    [anon_sym_enum] = ACTIONS(2963),
    [sym_readonly] = ACTIONS(2963),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(2965),
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_export] = ACTIONS(2967),
    [anon_sym_default] = ACTIONS(2967),
    [anon_sym_namespace] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2965),
    [anon_sym_RBRACE] = ACTIONS(2965),
    [anon_sym_type] = ACTIONS(2967),
    [anon_sym_typeof] = ACTIONS(2967),
    [anon_sym_import] = ACTIONS(2967),
    [anon_sym_var] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_switch] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2965),
    [anon_sym_await] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_with] = ACTIONS(2967),
    [anon_sym_break] = ACTIONS(2967),
    [anon_sym_continue] = ACTIONS(2967),
    [anon_sym_debugger] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_throw] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2965),
    [anon_sym_case] = ACTIONS(2967),
    [anon_sym_yield] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_class] = ACTIONS(2967),
    [anon_sym_async] = ACTIONS(2967),
    [anon_sym_function] = ACTIONS(2967),
    [anon_sym_new] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2967),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_TILDE] = ACTIONS(2965),
    [anon_sym_void] = ACTIONS(2967),
    [anon_sym_delete] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2965),
    [anon_sym_DASH_DASH] = ACTIONS(2965),
    [anon_sym_DQUOTE] = ACTIONS(2965),
    [anon_sym_SQUOTE] = ACTIONS(2965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2965),
    [sym_number] = ACTIONS(2965),
    [sym_this] = ACTIONS(2967),
    [sym_super] = ACTIONS(2967),
    [sym_true] = ACTIONS(2967),
    [sym_false] = ACTIONS(2967),
    [sym_null] = ACTIONS(2967),
    [sym_undefined] = ACTIONS(2967),
    [anon_sym_AT] = ACTIONS(2965),
    [anon_sym_static] = ACTIONS(2967),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_get] = ACTIONS(2967),
    [anon_sym_set] = ACTIONS(2967),
    [anon_sym_declare] = ACTIONS(2967),
    [anon_sym_public] = ACTIONS(2967),
    [anon_sym_private] = ACTIONS(2967),
    [anon_sym_protected] = ACTIONS(2967),
    [anon_sym_module] = ACTIONS(2967),
    [anon_sym_any] = ACTIONS(2967),
    [anon_sym_number] = ACTIONS(2967),
    [anon_sym_boolean] = ACTIONS(2967),
    [anon_sym_string] = ACTIONS(2967),
    [anon_sym_symbol] = ACTIONS(2967),
    [anon_sym_interface] = ACTIONS(2967),
    [anon_sym_enum] = ACTIONS(2967),
    [sym_readonly] = ACTIONS(2967),
  },
  [596] = {
    [sym__call_signature] = STATE(3113),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2565),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2565),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2565),
    [anon_sym_get] = ACTIONS(2565),
    [anon_sym_set] = ACTIONS(2565),
    [anon_sym_declare] = ACTIONS(2565),
    [anon_sym_public] = ACTIONS(2565),
    [anon_sym_private] = ACTIONS(2565),
    [anon_sym_protected] = ACTIONS(2565),
    [anon_sym_module] = ACTIONS(2565),
    [anon_sym_any] = ACTIONS(2565),
    [anon_sym_number] = ACTIONS(2565),
    [anon_sym_boolean] = ACTIONS(2565),
    [anon_sym_string] = ACTIONS(2565),
    [anon_sym_symbol] = ACTIONS(2565),
    [sym_readonly] = ACTIONS(2565),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(2969),
    [sym_identifier] = ACTIONS(2971),
    [anon_sym_export] = ACTIONS(2971),
    [anon_sym_default] = ACTIONS(2971),
    [anon_sym_namespace] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_type] = ACTIONS(2971),
    [anon_sym_typeof] = ACTIONS(2971),
    [anon_sym_import] = ACTIONS(2971),
    [anon_sym_var] = ACTIONS(2971),
    [anon_sym_let] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_else] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_await] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [anon_sym_do] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_with] = ACTIONS(2971),
    [anon_sym_break] = ACTIONS(2971),
    [anon_sym_continue] = ACTIONS(2971),
    [anon_sym_debugger] = ACTIONS(2971),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_throw] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_case] = ACTIONS(2971),
    [anon_sym_yield] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2971),
    [anon_sym_class] = ACTIONS(2971),
    [anon_sym_async] = ACTIONS(2971),
    [anon_sym_function] = ACTIONS(2971),
    [anon_sym_new] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_BANG] = ACTIONS(2969),
    [anon_sym_TILDE] = ACTIONS(2969),
    [anon_sym_void] = ACTIONS(2971),
    [anon_sym_delete] = ACTIONS(2971),
    [anon_sym_PLUS_PLUS] = ACTIONS(2969),
    [anon_sym_DASH_DASH] = ACTIONS(2969),
    [anon_sym_DQUOTE] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2969),
    [sym_number] = ACTIONS(2969),
    [sym_this] = ACTIONS(2971),
    [sym_super] = ACTIONS(2971),
    [sym_true] = ACTIONS(2971),
    [sym_false] = ACTIONS(2971),
    [sym_null] = ACTIONS(2971),
    [sym_undefined] = ACTIONS(2971),
    [anon_sym_AT] = ACTIONS(2969),
    [anon_sym_static] = ACTIONS(2971),
    [anon_sym_abstract] = ACTIONS(2971),
    [anon_sym_get] = ACTIONS(2971),
    [anon_sym_set] = ACTIONS(2971),
    [anon_sym_declare] = ACTIONS(2971),
    [anon_sym_public] = ACTIONS(2971),
    [anon_sym_private] = ACTIONS(2971),
    [anon_sym_protected] = ACTIONS(2971),
    [anon_sym_module] = ACTIONS(2971),
    [anon_sym_any] = ACTIONS(2971),
    [anon_sym_number] = ACTIONS(2971),
    [anon_sym_boolean] = ACTIONS(2971),
    [anon_sym_string] = ACTIONS(2971),
    [anon_sym_symbol] = ACTIONS(2971),
    [anon_sym_interface] = ACTIONS(2971),
    [anon_sym_enum] = ACTIONS(2971),
    [sym_readonly] = ACTIONS(2971),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(2973),
    [sym_identifier] = ACTIONS(2975),
    [anon_sym_export] = ACTIONS(2975),
    [anon_sym_default] = ACTIONS(2975),
    [anon_sym_namespace] = ACTIONS(2975),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_type] = ACTIONS(2975),
    [anon_sym_typeof] = ACTIONS(2975),
    [anon_sym_import] = ACTIONS(2975),
    [anon_sym_var] = ACTIONS(2975),
    [anon_sym_let] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_else] = ACTIONS(2975),
    [anon_sym_switch] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_await] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_with] = ACTIONS(2975),
    [anon_sym_break] = ACTIONS(2975),
    [anon_sym_continue] = ACTIONS(2975),
    [anon_sym_debugger] = ACTIONS(2975),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_throw] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_case] = ACTIONS(2975),
    [anon_sym_yield] = ACTIONS(2975),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_LT] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2975),
    [anon_sym_class] = ACTIONS(2975),
    [anon_sym_async] = ACTIONS(2975),
    [anon_sym_function] = ACTIONS(2975),
    [anon_sym_new] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_DASH] = ACTIONS(2975),
    [anon_sym_BANG] = ACTIONS(2973),
    [anon_sym_TILDE] = ACTIONS(2973),
    [anon_sym_void] = ACTIONS(2975),
    [anon_sym_delete] = ACTIONS(2975),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_DQUOTE] = ACTIONS(2973),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2973),
    [sym_number] = ACTIONS(2973),
    [sym_this] = ACTIONS(2975),
    [sym_super] = ACTIONS(2975),
    [sym_true] = ACTIONS(2975),
    [sym_false] = ACTIONS(2975),
    [sym_null] = ACTIONS(2975),
    [sym_undefined] = ACTIONS(2975),
    [anon_sym_AT] = ACTIONS(2973),
    [anon_sym_static] = ACTIONS(2975),
    [anon_sym_abstract] = ACTIONS(2975),
    [anon_sym_get] = ACTIONS(2975),
    [anon_sym_set] = ACTIONS(2975),
    [anon_sym_declare] = ACTIONS(2975),
    [anon_sym_public] = ACTIONS(2975),
    [anon_sym_private] = ACTIONS(2975),
    [anon_sym_protected] = ACTIONS(2975),
    [anon_sym_module] = ACTIONS(2975),
    [anon_sym_any] = ACTIONS(2975),
    [anon_sym_number] = ACTIONS(2975),
    [anon_sym_boolean] = ACTIONS(2975),
    [anon_sym_string] = ACTIONS(2975),
    [anon_sym_symbol] = ACTIONS(2975),
    [anon_sym_interface] = ACTIONS(2975),
    [anon_sym_enum] = ACTIONS(2975),
    [sym_readonly] = ACTIONS(2975),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(2977),
    [sym_identifier] = ACTIONS(2979),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_default] = ACTIONS(2979),
    [anon_sym_namespace] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2977),
    [anon_sym_type] = ACTIONS(2979),
    [anon_sym_typeof] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2979),
    [anon_sym_var] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_else] = ACTIONS(2979),
    [anon_sym_switch] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_await] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [anon_sym_do] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2979),
    [anon_sym_break] = ACTIONS(2979),
    [anon_sym_continue] = ACTIONS(2979),
    [anon_sym_debugger] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_throw] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_case] = ACTIONS(2979),
    [anon_sym_yield] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2979),
    [anon_sym_class] = ACTIONS(2979),
    [anon_sym_async] = ACTIONS(2979),
    [anon_sym_function] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_DASH] = ACTIONS(2979),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_TILDE] = ACTIONS(2977),
    [anon_sym_void] = ACTIONS(2979),
    [anon_sym_delete] = ACTIONS(2979),
    [anon_sym_PLUS_PLUS] = ACTIONS(2977),
    [anon_sym_DASH_DASH] = ACTIONS(2977),
    [anon_sym_DQUOTE] = ACTIONS(2977),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2977),
    [sym_number] = ACTIONS(2977),
    [sym_this] = ACTIONS(2979),
    [sym_super] = ACTIONS(2979),
    [sym_true] = ACTIONS(2979),
    [sym_false] = ACTIONS(2979),
    [sym_null] = ACTIONS(2979),
    [sym_undefined] = ACTIONS(2979),
    [anon_sym_AT] = ACTIONS(2977),
    [anon_sym_static] = ACTIONS(2979),
    [anon_sym_abstract] = ACTIONS(2979),
    [anon_sym_get] = ACTIONS(2979),
    [anon_sym_set] = ACTIONS(2979),
    [anon_sym_declare] = ACTIONS(2979),
    [anon_sym_public] = ACTIONS(2979),
    [anon_sym_private] = ACTIONS(2979),
    [anon_sym_protected] = ACTIONS(2979),
    [anon_sym_module] = ACTIONS(2979),
    [anon_sym_any] = ACTIONS(2979),
    [anon_sym_number] = ACTIONS(2979),
    [anon_sym_boolean] = ACTIONS(2979),
    [anon_sym_string] = ACTIONS(2979),
    [anon_sym_symbol] = ACTIONS(2979),
    [anon_sym_interface] = ACTIONS(2979),
    [anon_sym_enum] = ACTIONS(2979),
    [sym_readonly] = ACTIONS(2979),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2981),
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_default] = ACTIONS(2983),
    [anon_sym_namespace] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_type] = ACTIONS(2983),
    [anon_sym_typeof] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_var] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_switch] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_await] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_with] = ACTIONS(2983),
    [anon_sym_break] = ACTIONS(2983),
    [anon_sym_continue] = ACTIONS(2983),
    [anon_sym_debugger] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_throw] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_case] = ACTIONS(2983),
    [anon_sym_yield] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2981),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2983),
    [anon_sym_class] = ACTIONS(2983),
    [anon_sym_async] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_new] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(2983),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_TILDE] = ACTIONS(2981),
    [anon_sym_void] = ACTIONS(2983),
    [anon_sym_delete] = ACTIONS(2983),
    [anon_sym_PLUS_PLUS] = ACTIONS(2981),
    [anon_sym_DASH_DASH] = ACTIONS(2981),
    [anon_sym_DQUOTE] = ACTIONS(2981),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2981),
    [sym_number] = ACTIONS(2981),
    [sym_this] = ACTIONS(2983),
    [sym_super] = ACTIONS(2983),
    [sym_true] = ACTIONS(2983),
    [sym_false] = ACTIONS(2983),
    [sym_null] = ACTIONS(2983),
    [sym_undefined] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2981),
    [anon_sym_static] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_get] = ACTIONS(2983),
    [anon_sym_set] = ACTIONS(2983),
    [anon_sym_declare] = ACTIONS(2983),
    [anon_sym_public] = ACTIONS(2983),
    [anon_sym_private] = ACTIONS(2983),
    [anon_sym_protected] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_any] = ACTIONS(2983),
    [anon_sym_number] = ACTIONS(2983),
    [anon_sym_boolean] = ACTIONS(2983),
    [anon_sym_string] = ACTIONS(2983),
    [anon_sym_symbol] = ACTIONS(2983),
    [anon_sym_interface] = ACTIONS(2983),
    [anon_sym_enum] = ACTIONS(2983),
    [sym_readonly] = ACTIONS(2983),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(2985),
    [sym_identifier] = ACTIONS(2987),
    [anon_sym_export] = ACTIONS(2987),
    [anon_sym_default] = ACTIONS(2987),
    [anon_sym_namespace] = ACTIONS(2987),
    [anon_sym_LBRACE] = ACTIONS(2985),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_type] = ACTIONS(2987),
    [anon_sym_typeof] = ACTIONS(2987),
    [anon_sym_import] = ACTIONS(2987),
    [anon_sym_var] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_const] = ACTIONS(2987),
    [anon_sym_if] = ACTIONS(2987),
    [anon_sym_else] = ACTIONS(2987),
    [anon_sym_switch] = ACTIONS(2987),
    [anon_sym_for] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_await] = ACTIONS(2987),
    [anon_sym_while] = ACTIONS(2987),
    [anon_sym_do] = ACTIONS(2987),
    [anon_sym_try] = ACTIONS(2987),
    [anon_sym_with] = ACTIONS(2987),
    [anon_sym_break] = ACTIONS(2987),
    [anon_sym_continue] = ACTIONS(2987),
    [anon_sym_debugger] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2987),
    [anon_sym_throw] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_case] = ACTIONS(2987),
    [anon_sym_yield] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2987),
    [anon_sym_class] = ACTIONS(2987),
    [anon_sym_async] = ACTIONS(2987),
    [anon_sym_function] = ACTIONS(2987),
    [anon_sym_new] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2985),
    [anon_sym_TILDE] = ACTIONS(2985),
    [anon_sym_void] = ACTIONS(2987),
    [anon_sym_delete] = ACTIONS(2987),
    [anon_sym_PLUS_PLUS] = ACTIONS(2985),
    [anon_sym_DASH_DASH] = ACTIONS(2985),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_SQUOTE] = ACTIONS(2985),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2985),
    [sym_number] = ACTIONS(2985),
    [sym_this] = ACTIONS(2987),
    [sym_super] = ACTIONS(2987),
    [sym_true] = ACTIONS(2987),
    [sym_false] = ACTIONS(2987),
    [sym_null] = ACTIONS(2987),
    [sym_undefined] = ACTIONS(2987),
    [anon_sym_AT] = ACTIONS(2985),
    [anon_sym_static] = ACTIONS(2987),
    [anon_sym_abstract] = ACTIONS(2987),
    [anon_sym_get] = ACTIONS(2987),
    [anon_sym_set] = ACTIONS(2987),
    [anon_sym_declare] = ACTIONS(2987),
    [anon_sym_public] = ACTIONS(2987),
    [anon_sym_private] = ACTIONS(2987),
    [anon_sym_protected] = ACTIONS(2987),
    [anon_sym_module] = ACTIONS(2987),
    [anon_sym_any] = ACTIONS(2987),
    [anon_sym_number] = ACTIONS(2987),
    [anon_sym_boolean] = ACTIONS(2987),
    [anon_sym_string] = ACTIONS(2987),
    [anon_sym_symbol] = ACTIONS(2987),
    [anon_sym_interface] = ACTIONS(2987),
    [anon_sym_enum] = ACTIONS(2987),
    [sym_readonly] = ACTIONS(2987),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(2989),
    [sym_identifier] = ACTIONS(2991),
    [anon_sym_export] = ACTIONS(2991),
    [anon_sym_default] = ACTIONS(2991),
    [anon_sym_namespace] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_type] = ACTIONS(2991),
    [anon_sym_typeof] = ACTIONS(2991),
    [anon_sym_import] = ACTIONS(2991),
    [anon_sym_var] = ACTIONS(2991),
    [anon_sym_let] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2991),
    [anon_sym_if] = ACTIONS(2991),
    [anon_sym_else] = ACTIONS(2991),
    [anon_sym_switch] = ACTIONS(2991),
    [anon_sym_for] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym_await] = ACTIONS(2991),
    [anon_sym_while] = ACTIONS(2991),
    [anon_sym_do] = ACTIONS(2991),
    [anon_sym_try] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2991),
    [anon_sym_break] = ACTIONS(2991),
    [anon_sym_continue] = ACTIONS(2991),
    [anon_sym_debugger] = ACTIONS(2991),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_throw] = ACTIONS(2991),
    [anon_sym_SEMI] = ACTIONS(2989),
    [anon_sym_case] = ACTIONS(2991),
    [anon_sym_yield] = ACTIONS(2991),
    [anon_sym_LBRACK] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2991),
    [anon_sym_class] = ACTIONS(2991),
    [anon_sym_async] = ACTIONS(2991),
    [anon_sym_function] = ACTIONS(2991),
    [anon_sym_new] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2991),
    [anon_sym_DASH] = ACTIONS(2991),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_TILDE] = ACTIONS(2989),
    [anon_sym_void] = ACTIONS(2991),
    [anon_sym_delete] = ACTIONS(2991),
    [anon_sym_PLUS_PLUS] = ACTIONS(2989),
    [anon_sym_DASH_DASH] = ACTIONS(2989),
    [anon_sym_DQUOTE] = ACTIONS(2989),
    [anon_sym_SQUOTE] = ACTIONS(2989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2989),
    [sym_number] = ACTIONS(2989),
    [sym_this] = ACTIONS(2991),
    [sym_super] = ACTIONS(2991),
    [sym_true] = ACTIONS(2991),
    [sym_false] = ACTIONS(2991),
    [sym_null] = ACTIONS(2991),
    [sym_undefined] = ACTIONS(2991),
    [anon_sym_AT] = ACTIONS(2989),
    [anon_sym_static] = ACTIONS(2991),
    [anon_sym_abstract] = ACTIONS(2991),
    [anon_sym_get] = ACTIONS(2991),
    [anon_sym_set] = ACTIONS(2991),
    [anon_sym_declare] = ACTIONS(2991),
    [anon_sym_public] = ACTIONS(2991),
    [anon_sym_private] = ACTIONS(2991),
    [anon_sym_protected] = ACTIONS(2991),
    [anon_sym_module] = ACTIONS(2991),
    [anon_sym_any] = ACTIONS(2991),
    [anon_sym_number] = ACTIONS(2991),
    [anon_sym_boolean] = ACTIONS(2991),
    [anon_sym_string] = ACTIONS(2991),
    [anon_sym_symbol] = ACTIONS(2991),
    [anon_sym_interface] = ACTIONS(2991),
    [anon_sym_enum] = ACTIONS(2991),
    [sym_readonly] = ACTIONS(2991),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(2993),
    [sym_identifier] = ACTIONS(2995),
    [anon_sym_export] = ACTIONS(2995),
    [anon_sym_default] = ACTIONS(2995),
    [anon_sym_namespace] = ACTIONS(2995),
    [anon_sym_LBRACE] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_type] = ACTIONS(2995),
    [anon_sym_typeof] = ACTIONS(2995),
    [anon_sym_import] = ACTIONS(2995),
    [anon_sym_var] = ACTIONS(2995),
    [anon_sym_let] = ACTIONS(2995),
    [anon_sym_const] = ACTIONS(2995),
    [anon_sym_if] = ACTIONS(2995),
    [anon_sym_else] = ACTIONS(2995),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_for] = ACTIONS(2995),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_await] = ACTIONS(2995),
    [anon_sym_while] = ACTIONS(2995),
    [anon_sym_do] = ACTIONS(2995),
    [anon_sym_try] = ACTIONS(2995),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_break] = ACTIONS(2995),
    [anon_sym_continue] = ACTIONS(2995),
    [anon_sym_debugger] = ACTIONS(2995),
    [anon_sym_return] = ACTIONS(2995),
    [anon_sym_throw] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_case] = ACTIONS(2995),
    [anon_sym_yield] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_LT] = ACTIONS(2993),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_class] = ACTIONS(2995),
    [anon_sym_async] = ACTIONS(2995),
    [anon_sym_function] = ACTIONS(2995),
    [anon_sym_new] = ACTIONS(2995),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2993),
    [anon_sym_TILDE] = ACTIONS(2993),
    [anon_sym_void] = ACTIONS(2995),
    [anon_sym_delete] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2993),
    [sym_number] = ACTIONS(2993),
    [sym_this] = ACTIONS(2995),
    [sym_super] = ACTIONS(2995),
    [sym_true] = ACTIONS(2995),
    [sym_false] = ACTIONS(2995),
    [sym_null] = ACTIONS(2995),
    [sym_undefined] = ACTIONS(2995),
    [anon_sym_AT] = ACTIONS(2993),
    [anon_sym_static] = ACTIONS(2995),
    [anon_sym_abstract] = ACTIONS(2995),
    [anon_sym_get] = ACTIONS(2995),
    [anon_sym_set] = ACTIONS(2995),
    [anon_sym_declare] = ACTIONS(2995),
    [anon_sym_public] = ACTIONS(2995),
    [anon_sym_private] = ACTIONS(2995),
    [anon_sym_protected] = ACTIONS(2995),
    [anon_sym_module] = ACTIONS(2995),
    [anon_sym_any] = ACTIONS(2995),
    [anon_sym_number] = ACTIONS(2995),
    [anon_sym_boolean] = ACTIONS(2995),
    [anon_sym_string] = ACTIONS(2995),
    [anon_sym_symbol] = ACTIONS(2995),
    [anon_sym_interface] = ACTIONS(2995),
    [anon_sym_enum] = ACTIONS(2995),
    [sym_readonly] = ACTIONS(2995),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(2997),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_export] = ACTIONS(2999),
    [anon_sym_default] = ACTIONS(2999),
    [anon_sym_namespace] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(2997),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [anon_sym_type] = ACTIONS(2999),
    [anon_sym_typeof] = ACTIONS(2999),
    [anon_sym_import] = ACTIONS(2999),
    [anon_sym_var] = ACTIONS(2999),
    [anon_sym_let] = ACTIONS(2999),
    [anon_sym_const] = ACTIONS(2999),
    [anon_sym_if] = ACTIONS(2999),
    [anon_sym_else] = ACTIONS(2999),
    [anon_sym_switch] = ACTIONS(2999),
    [anon_sym_for] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2997),
    [anon_sym_await] = ACTIONS(2999),
    [anon_sym_while] = ACTIONS(2999),
    [anon_sym_do] = ACTIONS(2999),
    [anon_sym_try] = ACTIONS(2999),
    [anon_sym_with] = ACTIONS(2999),
    [anon_sym_break] = ACTIONS(2999),
    [anon_sym_continue] = ACTIONS(2999),
    [anon_sym_debugger] = ACTIONS(2999),
    [anon_sym_return] = ACTIONS(2999),
    [anon_sym_throw] = ACTIONS(2999),
    [anon_sym_SEMI] = ACTIONS(2997),
    [anon_sym_case] = ACTIONS(2999),
    [anon_sym_yield] = ACTIONS(2999),
    [anon_sym_LBRACK] = ACTIONS(2997),
    [anon_sym_LT] = ACTIONS(2997),
    [anon_sym_SLASH] = ACTIONS(2999),
    [anon_sym_class] = ACTIONS(2999),
    [anon_sym_async] = ACTIONS(2999),
    [anon_sym_function] = ACTIONS(2999),
    [anon_sym_new] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(2999),
    [anon_sym_DASH] = ACTIONS(2999),
    [anon_sym_BANG] = ACTIONS(2997),
    [anon_sym_TILDE] = ACTIONS(2997),
    [anon_sym_void] = ACTIONS(2999),
    [anon_sym_delete] = ACTIONS(2999),
    [anon_sym_PLUS_PLUS] = ACTIONS(2997),
    [anon_sym_DASH_DASH] = ACTIONS(2997),
    [anon_sym_DQUOTE] = ACTIONS(2997),
    [anon_sym_SQUOTE] = ACTIONS(2997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2997),
    [sym_number] = ACTIONS(2997),
    [sym_this] = ACTIONS(2999),
    [sym_super] = ACTIONS(2999),
    [sym_true] = ACTIONS(2999),
    [sym_false] = ACTIONS(2999),
    [sym_null] = ACTIONS(2999),
    [sym_undefined] = ACTIONS(2999),
    [anon_sym_AT] = ACTIONS(2997),
    [anon_sym_static] = ACTIONS(2999),
    [anon_sym_abstract] = ACTIONS(2999),
    [anon_sym_get] = ACTIONS(2999),
    [anon_sym_set] = ACTIONS(2999),
    [anon_sym_declare] = ACTIONS(2999),
    [anon_sym_public] = ACTIONS(2999),
    [anon_sym_private] = ACTIONS(2999),
    [anon_sym_protected] = ACTIONS(2999),
    [anon_sym_module] = ACTIONS(2999),
    [anon_sym_any] = ACTIONS(2999),
    [anon_sym_number] = ACTIONS(2999),
    [anon_sym_boolean] = ACTIONS(2999),
    [anon_sym_string] = ACTIONS(2999),
    [anon_sym_symbol] = ACTIONS(2999),
    [anon_sym_interface] = ACTIONS(2999),
    [anon_sym_enum] = ACTIONS(2999),
    [sym_readonly] = ACTIONS(2999),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(3001),
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_export] = ACTIONS(3003),
    [anon_sym_default] = ACTIONS(3003),
    [anon_sym_namespace] = ACTIONS(3003),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_RBRACE] = ACTIONS(3001),
    [anon_sym_type] = ACTIONS(3003),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_import] = ACTIONS(3003),
    [anon_sym_var] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_const] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_else] = ACTIONS(3003),
    [anon_sym_switch] = ACTIONS(3003),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym_await] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [anon_sym_do] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_with] = ACTIONS(3003),
    [anon_sym_break] = ACTIONS(3003),
    [anon_sym_continue] = ACTIONS(3003),
    [anon_sym_debugger] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_throw] = ACTIONS(3003),
    [anon_sym_SEMI] = ACTIONS(3001),
    [anon_sym_case] = ACTIONS(3003),
    [anon_sym_yield] = ACTIONS(3003),
    [anon_sym_LBRACK] = ACTIONS(3001),
    [anon_sym_LT] = ACTIONS(3001),
    [anon_sym_SLASH] = ACTIONS(3003),
    [anon_sym_class] = ACTIONS(3003),
    [anon_sym_async] = ACTIONS(3003),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_new] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_DASH] = ACTIONS(3003),
    [anon_sym_BANG] = ACTIONS(3001),
    [anon_sym_TILDE] = ACTIONS(3001),
    [anon_sym_void] = ACTIONS(3003),
    [anon_sym_delete] = ACTIONS(3003),
    [anon_sym_PLUS_PLUS] = ACTIONS(3001),
    [anon_sym_DASH_DASH] = ACTIONS(3001),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3001),
    [sym_number] = ACTIONS(3001),
    [sym_this] = ACTIONS(3003),
    [sym_super] = ACTIONS(3003),
    [sym_true] = ACTIONS(3003),
    [sym_false] = ACTIONS(3003),
    [sym_null] = ACTIONS(3003),
    [sym_undefined] = ACTIONS(3003),
    [anon_sym_AT] = ACTIONS(3001),
    [anon_sym_static] = ACTIONS(3003),
    [anon_sym_abstract] = ACTIONS(3003),
    [anon_sym_get] = ACTIONS(3003),
    [anon_sym_set] = ACTIONS(3003),
    [anon_sym_declare] = ACTIONS(3003),
    [anon_sym_public] = ACTIONS(3003),
    [anon_sym_private] = ACTIONS(3003),
    [anon_sym_protected] = ACTIONS(3003),
    [anon_sym_module] = ACTIONS(3003),
    [anon_sym_any] = ACTIONS(3003),
    [anon_sym_number] = ACTIONS(3003),
    [anon_sym_boolean] = ACTIONS(3003),
    [anon_sym_string] = ACTIONS(3003),
    [anon_sym_symbol] = ACTIONS(3003),
    [anon_sym_interface] = ACTIONS(3003),
    [anon_sym_enum] = ACTIONS(3003),
    [sym_readonly] = ACTIONS(3003),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(3005),
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_export] = ACTIONS(3007),
    [anon_sym_default] = ACTIONS(3007),
    [anon_sym_namespace] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3005),
    [anon_sym_RBRACE] = ACTIONS(3005),
    [anon_sym_type] = ACTIONS(3007),
    [anon_sym_typeof] = ACTIONS(3007),
    [anon_sym_import] = ACTIONS(3007),
    [anon_sym_var] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_const] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_else] = ACTIONS(3007),
    [anon_sym_switch] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_await] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [anon_sym_do] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_with] = ACTIONS(3007),
    [anon_sym_break] = ACTIONS(3007),
    [anon_sym_continue] = ACTIONS(3007),
    [anon_sym_debugger] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_throw] = ACTIONS(3007),
    [anon_sym_SEMI] = ACTIONS(3005),
    [anon_sym_case] = ACTIONS(3007),
    [anon_sym_yield] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_SLASH] = ACTIONS(3007),
    [anon_sym_class] = ACTIONS(3007),
    [anon_sym_async] = ACTIONS(3007),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_new] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3005),
    [anon_sym_TILDE] = ACTIONS(3005),
    [anon_sym_void] = ACTIONS(3007),
    [anon_sym_delete] = ACTIONS(3007),
    [anon_sym_PLUS_PLUS] = ACTIONS(3005),
    [anon_sym_DASH_DASH] = ACTIONS(3005),
    [anon_sym_DQUOTE] = ACTIONS(3005),
    [anon_sym_SQUOTE] = ACTIONS(3005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3005),
    [sym_number] = ACTIONS(3005),
    [sym_this] = ACTIONS(3007),
    [sym_super] = ACTIONS(3007),
    [sym_true] = ACTIONS(3007),
    [sym_false] = ACTIONS(3007),
    [sym_null] = ACTIONS(3007),
    [sym_undefined] = ACTIONS(3007),
    [anon_sym_AT] = ACTIONS(3005),
    [anon_sym_static] = ACTIONS(3007),
    [anon_sym_abstract] = ACTIONS(3007),
    [anon_sym_get] = ACTIONS(3007),
    [anon_sym_set] = ACTIONS(3007),
    [anon_sym_declare] = ACTIONS(3007),
    [anon_sym_public] = ACTIONS(3007),
    [anon_sym_private] = ACTIONS(3007),
    [anon_sym_protected] = ACTIONS(3007),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_any] = ACTIONS(3007),
    [anon_sym_number] = ACTIONS(3007),
    [anon_sym_boolean] = ACTIONS(3007),
    [anon_sym_string] = ACTIONS(3007),
    [anon_sym_symbol] = ACTIONS(3007),
    [anon_sym_interface] = ACTIONS(3007),
    [anon_sym_enum] = ACTIONS(3007),
    [sym_readonly] = ACTIONS(3007),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(3009),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_export] = ACTIONS(3011),
    [anon_sym_default] = ACTIONS(3011),
    [anon_sym_namespace] = ACTIONS(3011),
    [anon_sym_LBRACE] = ACTIONS(3009),
    [anon_sym_RBRACE] = ACTIONS(3009),
    [anon_sym_type] = ACTIONS(3011),
    [anon_sym_typeof] = ACTIONS(3011),
    [anon_sym_import] = ACTIONS(3011),
    [anon_sym_var] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_const] = ACTIONS(3011),
    [anon_sym_if] = ACTIONS(3011),
    [anon_sym_else] = ACTIONS(3011),
    [anon_sym_switch] = ACTIONS(3011),
    [anon_sym_for] = ACTIONS(3011),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_await] = ACTIONS(3011),
    [anon_sym_while] = ACTIONS(3011),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_try] = ACTIONS(3011),
    [anon_sym_with] = ACTIONS(3011),
    [anon_sym_break] = ACTIONS(3011),
    [anon_sym_continue] = ACTIONS(3011),
    [anon_sym_debugger] = ACTIONS(3011),
    [anon_sym_return] = ACTIONS(3011),
    [anon_sym_throw] = ACTIONS(3011),
    [anon_sym_SEMI] = ACTIONS(3009),
    [anon_sym_case] = ACTIONS(3011),
    [anon_sym_yield] = ACTIONS(3011),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_SLASH] = ACTIONS(3011),
    [anon_sym_class] = ACTIONS(3011),
    [anon_sym_async] = ACTIONS(3011),
    [anon_sym_function] = ACTIONS(3011),
    [anon_sym_new] = ACTIONS(3011),
    [anon_sym_PLUS] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3011),
    [anon_sym_BANG] = ACTIONS(3009),
    [anon_sym_TILDE] = ACTIONS(3009),
    [anon_sym_void] = ACTIONS(3011),
    [anon_sym_delete] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3009),
    [anon_sym_DASH_DASH] = ACTIONS(3009),
    [anon_sym_DQUOTE] = ACTIONS(3009),
    [anon_sym_SQUOTE] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3009),
    [sym_number] = ACTIONS(3009),
    [sym_this] = ACTIONS(3011),
    [sym_super] = ACTIONS(3011),
    [sym_true] = ACTIONS(3011),
    [sym_false] = ACTIONS(3011),
    [sym_null] = ACTIONS(3011),
    [sym_undefined] = ACTIONS(3011),
    [anon_sym_AT] = ACTIONS(3009),
    [anon_sym_static] = ACTIONS(3011),
    [anon_sym_abstract] = ACTIONS(3011),
    [anon_sym_get] = ACTIONS(3011),
    [anon_sym_set] = ACTIONS(3011),
    [anon_sym_declare] = ACTIONS(3011),
    [anon_sym_public] = ACTIONS(3011),
    [anon_sym_private] = ACTIONS(3011),
    [anon_sym_protected] = ACTIONS(3011),
    [anon_sym_module] = ACTIONS(3011),
    [anon_sym_any] = ACTIONS(3011),
    [anon_sym_number] = ACTIONS(3011),
    [anon_sym_boolean] = ACTIONS(3011),
    [anon_sym_string] = ACTIONS(3011),
    [anon_sym_symbol] = ACTIONS(3011),
    [anon_sym_interface] = ACTIONS(3011),
    [anon_sym_enum] = ACTIONS(3011),
    [sym_readonly] = ACTIONS(3011),
  },
  [608] = {
    [sym__call_signature] = STATE(3033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [609] = {
    [sym__call_signature] = STATE(3108),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2806),
    [anon_sym_export] = ACTIONS(2808),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2808),
    [anon_sym_type] = ACTIONS(2808),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_async] = ACTIONS(2808),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2808),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2808),
    [anon_sym_get] = ACTIONS(2808),
    [anon_sym_set] = ACTIONS(2808),
    [anon_sym_declare] = ACTIONS(2808),
    [anon_sym_public] = ACTIONS(2808),
    [anon_sym_private] = ACTIONS(2808),
    [anon_sym_protected] = ACTIONS(2808),
    [anon_sym_module] = ACTIONS(2808),
    [anon_sym_any] = ACTIONS(2808),
    [anon_sym_number] = ACTIONS(2808),
    [anon_sym_boolean] = ACTIONS(2808),
    [anon_sym_string] = ACTIONS(2808),
    [anon_sym_symbol] = ACTIONS(2808),
    [sym_readonly] = ACTIONS(2808),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [610] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2618),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [611] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym_this] = ACTIONS(2618),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [612] = {
    [sym__call_signature] = STATE(3033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(790),
    [anon_sym_of] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [613] = {
    [sym__call_signature] = STATE(3033),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(2641),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2569),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [614] = {
    [sym_identifier] = ACTIONS(3013),
    [anon_sym_export] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_type] = ACTIONS(3013),
    [anon_sym_typeof] = ACTIONS(3013),
    [anon_sym_import] = ACTIONS(3013),
    [anon_sym_var] = ACTIONS(3013),
    [anon_sym_let] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_await] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_with] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_debugger] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_yield] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3015),
    [anon_sym_SLASH] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_async] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [sym_number] = ACTIONS(3015),
    [sym_this] = ACTIONS(3013),
    [sym_super] = ACTIONS(3013),
    [sym_true] = ACTIONS(3013),
    [sym_false] = ACTIONS(3013),
    [sym_null] = ACTIONS(3013),
    [sym_undefined] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(3015),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(3013),
    [anon_sym_get] = ACTIONS(3013),
    [anon_sym_set] = ACTIONS(3013),
    [anon_sym_declare] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3013),
    [anon_sym_private] = ACTIONS(3013),
    [anon_sym_protected] = ACTIONS(3013),
    [anon_sym_module] = ACTIONS(3013),
    [anon_sym_any] = ACTIONS(3013),
    [anon_sym_number] = ACTIONS(3013),
    [anon_sym_boolean] = ACTIONS(3013),
    [anon_sym_string] = ACTIONS(3013),
    [anon_sym_symbol] = ACTIONS(3013),
    [anon_sym_interface] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [sym_readonly] = ACTIONS(3013),
  },
  [615] = {
    [sym_identifier] = ACTIONS(3017),
    [anon_sym_export] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_type] = ACTIONS(3017),
    [anon_sym_typeof] = ACTIONS(3017),
    [anon_sym_import] = ACTIONS(3017),
    [anon_sym_var] = ACTIONS(3017),
    [anon_sym_let] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3017),
    [anon_sym_if] = ACTIONS(3017),
    [anon_sym_switch] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_await] = ACTIONS(3017),
    [anon_sym_while] = ACTIONS(3017),
    [anon_sym_do] = ACTIONS(3017),
    [anon_sym_try] = ACTIONS(3017),
    [anon_sym_with] = ACTIONS(3017),
    [anon_sym_break] = ACTIONS(3017),
    [anon_sym_continue] = ACTIONS(3017),
    [anon_sym_debugger] = ACTIONS(3017),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_throw] = ACTIONS(3017),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_yield] = ACTIONS(3017),
    [anon_sym_LBRACK] = ACTIONS(3019),
    [anon_sym_LT] = ACTIONS(3019),
    [anon_sym_SLASH] = ACTIONS(3017),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_async] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3017),
    [anon_sym_DASH] = ACTIONS(3017),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_delete] = ACTIONS(3017),
    [anon_sym_PLUS_PLUS] = ACTIONS(3019),
    [anon_sym_DASH_DASH] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3019),
    [sym_number] = ACTIONS(3019),
    [sym_this] = ACTIONS(3017),
    [sym_super] = ACTIONS(3017),
    [sym_true] = ACTIONS(3017),
    [sym_false] = ACTIONS(3017),
    [sym_null] = ACTIONS(3017),
    [sym_undefined] = ACTIONS(3017),
    [anon_sym_AT] = ACTIONS(3019),
    [anon_sym_static] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3017),
    [anon_sym_get] = ACTIONS(3017),
    [anon_sym_set] = ACTIONS(3017),
    [anon_sym_declare] = ACTIONS(3017),
    [anon_sym_public] = ACTIONS(3017),
    [anon_sym_private] = ACTIONS(3017),
    [anon_sym_protected] = ACTIONS(3017),
    [anon_sym_module] = ACTIONS(3017),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_interface] = ACTIONS(3017),
    [anon_sym_enum] = ACTIONS(3017),
    [sym_readonly] = ACTIONS(3017),
  },
  [616] = {
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_type] = ACTIONS(3021),
    [anon_sym_typeof] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_var] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_await] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_with] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_debugger] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_yield] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(3023),
    [anon_sym_SLASH] = ACTIONS(3021),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_async] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_void] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3023),
    [sym_this] = ACTIONS(3021),
    [sym_super] = ACTIONS(3021),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [sym_null] = ACTIONS(3021),
    [sym_undefined] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_get] = ACTIONS(3021),
    [anon_sym_set] = ACTIONS(3021),
    [anon_sym_declare] = ACTIONS(3021),
    [anon_sym_public] = ACTIONS(3021),
    [anon_sym_private] = ACTIONS(3021),
    [anon_sym_protected] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_any] = ACTIONS(3021),
    [anon_sym_number] = ACTIONS(3021),
    [anon_sym_boolean] = ACTIONS(3021),
    [anon_sym_string] = ACTIONS(3021),
    [anon_sym_symbol] = ACTIONS(3021),
    [anon_sym_interface] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [sym_readonly] = ACTIONS(3021),
  },
  [617] = {
    [sym_identifier] = ACTIONS(3025),
    [anon_sym_export] = ACTIONS(3025),
    [anon_sym_namespace] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_type] = ACTIONS(3025),
    [anon_sym_typeof] = ACTIONS(3025),
    [anon_sym_import] = ACTIONS(3025),
    [anon_sym_var] = ACTIONS(3025),
    [anon_sym_let] = ACTIONS(3025),
    [anon_sym_const] = ACTIONS(3025),
    [anon_sym_if] = ACTIONS(3025),
    [anon_sym_switch] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_await] = ACTIONS(3025),
    [anon_sym_while] = ACTIONS(3025),
    [anon_sym_do] = ACTIONS(3025),
    [anon_sym_try] = ACTIONS(3025),
    [anon_sym_with] = ACTIONS(3025),
    [anon_sym_break] = ACTIONS(3025),
    [anon_sym_continue] = ACTIONS(3025),
    [anon_sym_debugger] = ACTIONS(3025),
    [anon_sym_return] = ACTIONS(3025),
    [anon_sym_throw] = ACTIONS(3025),
    [anon_sym_SEMI] = ACTIONS(3027),
    [anon_sym_yield] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(3027),
    [anon_sym_SLASH] = ACTIONS(3025),
    [anon_sym_class] = ACTIONS(3025),
    [anon_sym_async] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_DASH] = ACTIONS(3025),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_void] = ACTIONS(3025),
    [anon_sym_delete] = ACTIONS(3025),
    [anon_sym_PLUS_PLUS] = ACTIONS(3027),
    [anon_sym_DASH_DASH] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3027),
    [sym_number] = ACTIONS(3027),
    [sym_this] = ACTIONS(3025),
    [sym_super] = ACTIONS(3025),
    [sym_true] = ACTIONS(3025),
    [sym_false] = ACTIONS(3025),
    [sym_null] = ACTIONS(3025),
    [sym_undefined] = ACTIONS(3025),
    [anon_sym_AT] = ACTIONS(3027),
    [anon_sym_static] = ACTIONS(3025),
    [anon_sym_abstract] = ACTIONS(3025),
    [anon_sym_get] = ACTIONS(3025),
    [anon_sym_set] = ACTIONS(3025),
    [anon_sym_declare] = ACTIONS(3025),
    [anon_sym_public] = ACTIONS(3025),
    [anon_sym_private] = ACTIONS(3025),
    [anon_sym_protected] = ACTIONS(3025),
    [anon_sym_module] = ACTIONS(3025),
    [anon_sym_any] = ACTIONS(3025),
    [anon_sym_number] = ACTIONS(3025),
    [anon_sym_boolean] = ACTIONS(3025),
    [anon_sym_string] = ACTIONS(3025),
    [anon_sym_symbol] = ACTIONS(3025),
    [anon_sym_interface] = ACTIONS(3025),
    [anon_sym_enum] = ACTIONS(3025),
    [sym_readonly] = ACTIONS(3025),
  },
  [618] = {
    [sym_identifier] = ACTIONS(3029),
    [anon_sym_export] = ACTIONS(3029),
    [anon_sym_namespace] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_type] = ACTIONS(3029),
    [anon_sym_typeof] = ACTIONS(3029),
    [anon_sym_import] = ACTIONS(3029),
    [anon_sym_var] = ACTIONS(3029),
    [anon_sym_let] = ACTIONS(3029),
    [anon_sym_const] = ACTIONS(3029),
    [anon_sym_if] = ACTIONS(3029),
    [anon_sym_switch] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_await] = ACTIONS(3029),
    [anon_sym_while] = ACTIONS(3029),
    [anon_sym_do] = ACTIONS(3029),
    [anon_sym_try] = ACTIONS(3029),
    [anon_sym_with] = ACTIONS(3029),
    [anon_sym_break] = ACTIONS(3029),
    [anon_sym_continue] = ACTIONS(3029),
    [anon_sym_debugger] = ACTIONS(3029),
    [anon_sym_return] = ACTIONS(3029),
    [anon_sym_throw] = ACTIONS(3029),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym_yield] = ACTIONS(3029),
    [anon_sym_LBRACK] = ACTIONS(3031),
    [anon_sym_LT] = ACTIONS(3031),
    [anon_sym_SLASH] = ACTIONS(3029),
    [anon_sym_class] = ACTIONS(3029),
    [anon_sym_async] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3029),
    [anon_sym_DASH] = ACTIONS(3029),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3029),
    [anon_sym_delete] = ACTIONS(3029),
    [anon_sym_PLUS_PLUS] = ACTIONS(3031),
    [anon_sym_DASH_DASH] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3031),
    [sym_number] = ACTIONS(3031),
    [sym_this] = ACTIONS(3029),
    [sym_super] = ACTIONS(3029),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_AT] = ACTIONS(3031),
    [anon_sym_static] = ACTIONS(3029),
    [anon_sym_abstract] = ACTIONS(3029),
    [anon_sym_get] = ACTIONS(3029),
    [anon_sym_set] = ACTIONS(3029),
    [anon_sym_declare] = ACTIONS(3029),
    [anon_sym_public] = ACTIONS(3029),
    [anon_sym_private] = ACTIONS(3029),
    [anon_sym_protected] = ACTIONS(3029),
    [anon_sym_module] = ACTIONS(3029),
    [anon_sym_any] = ACTIONS(3029),
    [anon_sym_number] = ACTIONS(3029),
    [anon_sym_boolean] = ACTIONS(3029),
    [anon_sym_string] = ACTIONS(3029),
    [anon_sym_symbol] = ACTIONS(3029),
    [anon_sym_interface] = ACTIONS(3029),
    [anon_sym_enum] = ACTIONS(3029),
    [sym_readonly] = ACTIONS(3029),
  },
  [619] = {
    [sym_identifier] = ACTIONS(3033),
    [anon_sym_export] = ACTIONS(3033),
    [anon_sym_namespace] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_type] = ACTIONS(3033),
    [anon_sym_typeof] = ACTIONS(3033),
    [anon_sym_import] = ACTIONS(3033),
    [anon_sym_var] = ACTIONS(3033),
    [anon_sym_let] = ACTIONS(3033),
    [anon_sym_const] = ACTIONS(3033),
    [anon_sym_if] = ACTIONS(3033),
    [anon_sym_switch] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_await] = ACTIONS(3033),
    [anon_sym_while] = ACTIONS(3033),
    [anon_sym_do] = ACTIONS(3033),
    [anon_sym_try] = ACTIONS(3033),
    [anon_sym_with] = ACTIONS(3033),
    [anon_sym_break] = ACTIONS(3033),
    [anon_sym_continue] = ACTIONS(3033),
    [anon_sym_debugger] = ACTIONS(3033),
    [anon_sym_return] = ACTIONS(3033),
    [anon_sym_throw] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_yield] = ACTIONS(3033),
    [anon_sym_LBRACK] = ACTIONS(3035),
    [anon_sym_LT] = ACTIONS(3035),
    [anon_sym_SLASH] = ACTIONS(3033),
    [anon_sym_class] = ACTIONS(3033),
    [anon_sym_async] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3033),
    [anon_sym_PLUS] = ACTIONS(3033),
    [anon_sym_DASH] = ACTIONS(3033),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3035),
    [anon_sym_void] = ACTIONS(3033),
    [anon_sym_delete] = ACTIONS(3033),
    [anon_sym_PLUS_PLUS] = ACTIONS(3035),
    [anon_sym_DASH_DASH] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3035),
    [sym_number] = ACTIONS(3035),
    [sym_this] = ACTIONS(3033),
    [sym_super] = ACTIONS(3033),
    [sym_true] = ACTIONS(3033),
    [sym_false] = ACTIONS(3033),
    [sym_null] = ACTIONS(3033),
    [sym_undefined] = ACTIONS(3033),
    [anon_sym_AT] = ACTIONS(3035),
    [anon_sym_static] = ACTIONS(3033),
    [anon_sym_abstract] = ACTIONS(3033),
    [anon_sym_get] = ACTIONS(3033),
    [anon_sym_set] = ACTIONS(3033),
    [anon_sym_declare] = ACTIONS(3033),
    [anon_sym_public] = ACTIONS(3033),
    [anon_sym_private] = ACTIONS(3033),
    [anon_sym_protected] = ACTIONS(3033),
    [anon_sym_module] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3033),
    [anon_sym_number] = ACTIONS(3033),
    [anon_sym_boolean] = ACTIONS(3033),
    [anon_sym_string] = ACTIONS(3033),
    [anon_sym_symbol] = ACTIONS(3033),
    [anon_sym_interface] = ACTIONS(3033),
    [anon_sym_enum] = ACTIONS(3033),
    [sym_readonly] = ACTIONS(3033),
  },
  [620] = {
    [sym_identifier] = ACTIONS(3037),
    [anon_sym_export] = ACTIONS(3037),
    [anon_sym_namespace] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_type] = ACTIONS(3037),
    [anon_sym_typeof] = ACTIONS(3037),
    [anon_sym_import] = ACTIONS(3037),
    [anon_sym_var] = ACTIONS(3037),
    [anon_sym_let] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3037),
    [anon_sym_if] = ACTIONS(3037),
    [anon_sym_switch] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_await] = ACTIONS(3037),
    [anon_sym_while] = ACTIONS(3037),
    [anon_sym_do] = ACTIONS(3037),
    [anon_sym_try] = ACTIONS(3037),
    [anon_sym_with] = ACTIONS(3037),
    [anon_sym_break] = ACTIONS(3037),
    [anon_sym_continue] = ACTIONS(3037),
    [anon_sym_debugger] = ACTIONS(3037),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_throw] = ACTIONS(3037),
    [anon_sym_SEMI] = ACTIONS(3039),
    [anon_sym_yield] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LT] = ACTIONS(3039),
    [anon_sym_SLASH] = ACTIONS(3037),
    [anon_sym_class] = ACTIONS(3037),
    [anon_sym_async] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3037),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_DASH] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3039),
    [anon_sym_void] = ACTIONS(3037),
    [anon_sym_delete] = ACTIONS(3037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_SQUOTE] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3039),
    [sym_number] = ACTIONS(3039),
    [sym_this] = ACTIONS(3037),
    [sym_super] = ACTIONS(3037),
    [sym_true] = ACTIONS(3037),
    [sym_false] = ACTIONS(3037),
    [sym_null] = ACTIONS(3037),
    [sym_undefined] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(3039),
    [anon_sym_static] = ACTIONS(3037),
    [anon_sym_abstract] = ACTIONS(3037),
    [anon_sym_get] = ACTIONS(3037),
    [anon_sym_set] = ACTIONS(3037),
    [anon_sym_declare] = ACTIONS(3037),
    [anon_sym_public] = ACTIONS(3037),
    [anon_sym_private] = ACTIONS(3037),
    [anon_sym_protected] = ACTIONS(3037),
    [anon_sym_module] = ACTIONS(3037),
    [anon_sym_any] = ACTIONS(3037),
    [anon_sym_number] = ACTIONS(3037),
    [anon_sym_boolean] = ACTIONS(3037),
    [anon_sym_string] = ACTIONS(3037),
    [anon_sym_symbol] = ACTIONS(3037),
    [anon_sym_interface] = ACTIONS(3037),
    [anon_sym_enum] = ACTIONS(3037),
    [sym_readonly] = ACTIONS(3037),
  },
  [621] = {
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_export] = ACTIONS(3041),
    [anon_sym_namespace] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_type] = ACTIONS(3041),
    [anon_sym_typeof] = ACTIONS(3041),
    [anon_sym_import] = ACTIONS(3041),
    [anon_sym_var] = ACTIONS(3041),
    [anon_sym_let] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_switch] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_await] = ACTIONS(3041),
    [anon_sym_while] = ACTIONS(3041),
    [anon_sym_do] = ACTIONS(3041),
    [anon_sym_try] = ACTIONS(3041),
    [anon_sym_with] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_debugger] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_throw] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_yield] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_class] = ACTIONS(3041),
    [anon_sym_async] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_void] = ACTIONS(3041),
    [anon_sym_delete] = ACTIONS(3041),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3043),
    [sym_number] = ACTIONS(3043),
    [sym_this] = ACTIONS(3041),
    [sym_super] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_null] = ACTIONS(3041),
    [sym_undefined] = ACTIONS(3041),
    [anon_sym_AT] = ACTIONS(3043),
    [anon_sym_static] = ACTIONS(3041),
    [anon_sym_abstract] = ACTIONS(3041),
    [anon_sym_get] = ACTIONS(3041),
    [anon_sym_set] = ACTIONS(3041),
    [anon_sym_declare] = ACTIONS(3041),
    [anon_sym_public] = ACTIONS(3041),
    [anon_sym_private] = ACTIONS(3041),
    [anon_sym_protected] = ACTIONS(3041),
    [anon_sym_module] = ACTIONS(3041),
    [anon_sym_any] = ACTIONS(3041),
    [anon_sym_number] = ACTIONS(3041),
    [anon_sym_boolean] = ACTIONS(3041),
    [anon_sym_string] = ACTIONS(3041),
    [anon_sym_symbol] = ACTIONS(3041),
    [anon_sym_interface] = ACTIONS(3041),
    [anon_sym_enum] = ACTIONS(3041),
    [sym_readonly] = ACTIONS(3041),
  },
  [622] = {
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_export] = ACTIONS(3045),
    [anon_sym_namespace] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_type] = ACTIONS(3045),
    [anon_sym_typeof] = ACTIONS(3045),
    [anon_sym_import] = ACTIONS(3045),
    [anon_sym_var] = ACTIONS(3045),
    [anon_sym_let] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_switch] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_await] = ACTIONS(3045),
    [anon_sym_while] = ACTIONS(3045),
    [anon_sym_do] = ACTIONS(3045),
    [anon_sym_try] = ACTIONS(3045),
    [anon_sym_with] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_debugger] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_throw] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_yield] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LT] = ACTIONS(3047),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_class] = ACTIONS(3045),
    [anon_sym_async] = ACTIONS(3045),
    [anon_sym_function] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_void] = ACTIONS(3045),
    [anon_sym_delete] = ACTIONS(3045),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3047),
    [sym_number] = ACTIONS(3047),
    [sym_this] = ACTIONS(3045),
    [sym_super] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_null] = ACTIONS(3045),
    [sym_undefined] = ACTIONS(3045),
    [anon_sym_AT] = ACTIONS(3047),
    [anon_sym_static] = ACTIONS(3045),
    [anon_sym_abstract] = ACTIONS(3045),
    [anon_sym_get] = ACTIONS(3045),
    [anon_sym_set] = ACTIONS(3045),
    [anon_sym_declare] = ACTIONS(3045),
    [anon_sym_public] = ACTIONS(3045),
    [anon_sym_private] = ACTIONS(3045),
    [anon_sym_protected] = ACTIONS(3045),
    [anon_sym_module] = ACTIONS(3045),
    [anon_sym_any] = ACTIONS(3045),
    [anon_sym_number] = ACTIONS(3045),
    [anon_sym_boolean] = ACTIONS(3045),
    [anon_sym_string] = ACTIONS(3045),
    [anon_sym_symbol] = ACTIONS(3045),
    [anon_sym_interface] = ACTIONS(3045),
    [anon_sym_enum] = ACTIONS(3045),
    [sym_readonly] = ACTIONS(3045),
  },
  [623] = {
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_typeof] = ACTIONS(3049),
    [anon_sym_import] = ACTIONS(3049),
    [anon_sym_var] = ACTIONS(3049),
    [anon_sym_let] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_await] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_with] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_debugger] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_throw] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym_yield] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LT] = ACTIONS(3051),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_class] = ACTIONS(3049),
    [anon_sym_async] = ACTIONS(3049),
    [anon_sym_function] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3051),
    [anon_sym_void] = ACTIONS(3049),
    [anon_sym_delete] = ACTIONS(3049),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3051),
    [sym_number] = ACTIONS(3051),
    [sym_this] = ACTIONS(3049),
    [sym_super] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_undefined] = ACTIONS(3049),
    [anon_sym_AT] = ACTIONS(3051),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_abstract] = ACTIONS(3049),
    [anon_sym_get] = ACTIONS(3049),
    [anon_sym_set] = ACTIONS(3049),
    [anon_sym_declare] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3049),
    [anon_sym_private] = ACTIONS(3049),
    [anon_sym_protected] = ACTIONS(3049),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_any] = ACTIONS(3049),
    [anon_sym_number] = ACTIONS(3049),
    [anon_sym_boolean] = ACTIONS(3049),
    [anon_sym_string] = ACTIONS(3049),
    [anon_sym_symbol] = ACTIONS(3049),
    [anon_sym_interface] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [sym_readonly] = ACTIONS(3049),
  },
  [624] = {
    [sym_nested_identifier] = STATE(491),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [625] = {
    [sym_nested_identifier] = STATE(491),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [626] = {
    [sym_nested_identifier] = STATE(113),
    [sym_string] = STATE(114),
    [sym__module] = STATE(130),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [627] = {
    [sym_nested_identifier] = STATE(491),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [628] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym_arguments] = STATE(1033),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
  },
  [629] = {
    [sym_nested_identifier] = STATE(113),
    [sym_string] = STATE(114),
    [sym__module] = STATE(130),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [630] = {
    [sym_nested_identifier] = STATE(113),
    [sym_string] = STATE(114),
    [sym__module] = STATE(130),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [631] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym_arguments] = STATE(1534),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [632] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [633] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym_arguments] = STATE(1033),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_implements] = ACTIONS(521),
  },
  [634] = {
    [sym_nested_identifier] = STATE(1011),
    [sym_string] = STATE(1012),
    [sym__module] = STATE(1290),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [635] = {
    [sym_export_statement] = STATE(2152),
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2585),
    [sym_array] = STATE(3170),
    [sym__call_signature] = STATE(2436),
    [sym_spread_element] = STATE(2585),
    [sym_string] = STATE(1880),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym_method_definition] = STATE(2585),
    [sym_pair] = STATE(2585),
    [sym__property_name] = STATE(1880),
    [sym_computed_property_name] = STATE(1880),
    [sym_method_signature] = STATE(2152),
    [sym_accessibility_modifier] = STATE(1826),
    [sym_call_signature] = STATE(2152),
    [sym_property_signature] = STATE(2152),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2152),
    [sym_index_signature] = STATE(2152),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [aux_sym_object_repeat1] = STATE(2587),
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_type] = ACTIONS(3069),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3085),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_get] = ACTIONS(3097),
    [anon_sym_set] = ACTIONS(3097),
    [anon_sym_declare] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(3099),
    [anon_sym_private] = ACTIONS(3099),
    [anon_sym_protected] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3069),
    [anon_sym_any] = ACTIONS(3069),
    [anon_sym_number] = ACTIONS(3069),
    [anon_sym_boolean] = ACTIONS(3069),
    [anon_sym_string] = ACTIONS(3069),
    [anon_sym_symbol] = ACTIONS(3069),
    [sym_readonly] = ACTIONS(3101),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3103),
  },
  [636] = {
    [sym_export_statement] = STATE(2152),
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2606),
    [sym_array] = STATE(3170),
    [sym__call_signature] = STATE(2436),
    [sym_spread_element] = STATE(2606),
    [sym_string] = STATE(1880),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym_method_definition] = STATE(2606),
    [sym_pair] = STATE(2606),
    [sym__property_name] = STATE(1880),
    [sym_computed_property_name] = STATE(1880),
    [sym_method_signature] = STATE(2152),
    [sym_accessibility_modifier] = STATE(1826),
    [sym_call_signature] = STATE(2152),
    [sym_property_signature] = STATE(2152),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2152),
    [sym_index_signature] = STATE(2152),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [aux_sym_object_repeat1] = STATE(2610),
    [sym_identifier] = ACTIONS(3105),
    [anon_sym_export] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3109),
    [anon_sym_type] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3105),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3113),
    [anon_sym_get] = ACTIONS(3115),
    [anon_sym_set] = ACTIONS(3115),
    [anon_sym_declare] = ACTIONS(3105),
    [anon_sym_public] = ACTIONS(3117),
    [anon_sym_private] = ACTIONS(3117),
    [anon_sym_protected] = ACTIONS(3117),
    [anon_sym_module] = ACTIONS(3105),
    [anon_sym_any] = ACTIONS(3105),
    [anon_sym_number] = ACTIONS(3105),
    [anon_sym_boolean] = ACTIONS(3105),
    [anon_sym_string] = ACTIONS(3105),
    [anon_sym_symbol] = ACTIONS(3105),
    [sym_readonly] = ACTIONS(3119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3103),
  },
  [637] = {
    [sym_export_statement] = STATE(2152),
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2668),
    [sym_array] = STATE(3170),
    [sym__call_signature] = STATE(2436),
    [sym_spread_element] = STATE(2668),
    [sym_string] = STATE(1880),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym_method_definition] = STATE(2668),
    [sym_pair] = STATE(2668),
    [sym__property_name] = STATE(1880),
    [sym_computed_property_name] = STATE(1880),
    [sym_method_signature] = STATE(2152),
    [sym_accessibility_modifier] = STATE(1826),
    [sym_call_signature] = STATE(2152),
    [sym_property_signature] = STATE(2152),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2152),
    [sym_index_signature] = STATE(2152),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [aux_sym_object_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(3121),
    [anon_sym_export] = ACTIONS(3123),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3125),
    [anon_sym_type] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3127),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3129),
    [anon_sym_get] = ACTIONS(3131),
    [anon_sym_set] = ACTIONS(3131),
    [anon_sym_declare] = ACTIONS(3121),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_module] = ACTIONS(3121),
    [anon_sym_any] = ACTIONS(3121),
    [anon_sym_number] = ACTIONS(3121),
    [anon_sym_boolean] = ACTIONS(3121),
    [anon_sym_string] = ACTIONS(3121),
    [anon_sym_symbol] = ACTIONS(3121),
    [sym_readonly] = ACTIONS(3135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3103),
  },
  [638] = {
    [sym_export_statement] = STATE(2131),
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2668),
    [sym_array] = STATE(3170),
    [sym__call_signature] = STATE(2436),
    [sym_spread_element] = STATE(2668),
    [sym_string] = STATE(1880),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym_method_definition] = STATE(2668),
    [sym_pair] = STATE(2668),
    [sym__property_name] = STATE(1880),
    [sym_computed_property_name] = STATE(1880),
    [sym_method_signature] = STATE(2131),
    [sym_accessibility_modifier] = STATE(1826),
    [sym_call_signature] = STATE(2131),
    [sym_property_signature] = STATE(2131),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2131),
    [sym_index_signature] = STATE(2131),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [aux_sym_object_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(3121),
    [anon_sym_export] = ACTIONS(3123),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_type] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3127),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3129),
    [anon_sym_get] = ACTIONS(3131),
    [anon_sym_set] = ACTIONS(3131),
    [anon_sym_declare] = ACTIONS(3121),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_module] = ACTIONS(3121),
    [anon_sym_any] = ACTIONS(3121),
    [anon_sym_number] = ACTIONS(3121),
    [anon_sym_boolean] = ACTIONS(3121),
    [anon_sym_string] = ACTIONS(3121),
    [anon_sym_symbol] = ACTIONS(3121),
    [sym_readonly] = ACTIONS(3135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3143),
  },
  [639] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym_arguments] = STATE(1589),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
  },
  [640] = {
    [sym_nested_identifier] = STATE(1011),
    [sym_string] = STATE(1012),
    [sym__module] = STATE(1290),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [641] = {
    [sym_nested_identifier] = STATE(1011),
    [sym_string] = STATE(1012),
    [sym__module] = STATE(1290),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [642] = {
    [sym_export_statement] = STATE(2152),
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2668),
    [sym_array] = STATE(3170),
    [sym__call_signature] = STATE(2436),
    [sym_spread_element] = STATE(2668),
    [sym_string] = STATE(1880),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym_method_definition] = STATE(2668),
    [sym_pair] = STATE(2668),
    [sym__property_name] = STATE(1880),
    [sym_computed_property_name] = STATE(1880),
    [sym_method_signature] = STATE(2152),
    [sym_accessibility_modifier] = STATE(1826),
    [sym_call_signature] = STATE(2152),
    [sym_property_signature] = STATE(2152),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2152),
    [sym_index_signature] = STATE(2152),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [aux_sym_object_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(3121),
    [anon_sym_export] = ACTIONS(3123),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3147),
    [anon_sym_type] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3127),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3129),
    [anon_sym_get] = ACTIONS(3131),
    [anon_sym_set] = ACTIONS(3131),
    [anon_sym_declare] = ACTIONS(3121),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_module] = ACTIONS(3121),
    [anon_sym_any] = ACTIONS(3121),
    [anon_sym_number] = ACTIONS(3121),
    [anon_sym_boolean] = ACTIONS(3121),
    [anon_sym_string] = ACTIONS(3121),
    [anon_sym_symbol] = ACTIONS(3121),
    [sym_readonly] = ACTIONS(3135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3103),
  },
  [643] = {
    [sym_nested_identifier] = STATE(491),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [sym_identifier] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [644] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym_arguments] = STATE(1033),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
  },
  [645] = {
    [sym_export_statement] = STATE(2152),
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2656),
    [sym_array] = STATE(3170),
    [sym__call_signature] = STATE(2436),
    [sym_spread_element] = STATE(2656),
    [sym_string] = STATE(1880),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym_method_definition] = STATE(2656),
    [sym_pair] = STATE(2656),
    [sym__property_name] = STATE(1880),
    [sym_computed_property_name] = STATE(1880),
    [sym_method_signature] = STATE(2152),
    [sym_accessibility_modifier] = STATE(1826),
    [sym_call_signature] = STATE(2152),
    [sym_property_signature] = STATE(2152),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2152),
    [sym_index_signature] = STATE(2152),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [aux_sym_object_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(3149),
    [anon_sym_export] = ACTIONS(3151),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3149),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_type] = ACTIONS(3149),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3155),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3149),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3157),
    [anon_sym_get] = ACTIONS(3159),
    [anon_sym_set] = ACTIONS(3159),
    [anon_sym_declare] = ACTIONS(3149),
    [anon_sym_public] = ACTIONS(3161),
    [anon_sym_private] = ACTIONS(3161),
    [anon_sym_protected] = ACTIONS(3161),
    [anon_sym_module] = ACTIONS(3149),
    [anon_sym_any] = ACTIONS(3149),
    [anon_sym_number] = ACTIONS(3149),
    [anon_sym_boolean] = ACTIONS(3149),
    [anon_sym_string] = ACTIONS(3149),
    [anon_sym_symbol] = ACTIONS(3149),
    [sym_readonly] = ACTIONS(3163),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3103),
  },
  [646] = {
    [sym_nested_identifier] = STATE(491),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [sym_identifier] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [647] = {
    [sym_nested_identifier] = STATE(1011),
    [sym_string] = STATE(1012),
    [sym__module] = STATE(1290),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [648] = {
    [sym_nested_identifier] = STATE(2484),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [sym_identifier] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [649] = {
    [sym_nested_identifier] = STATE(113),
    [sym_string] = STATE(114),
    [sym__module] = STATE(130),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [650] = {
    [sym_export_statement] = STATE(2152),
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2668),
    [sym_array] = STATE(3170),
    [sym__call_signature] = STATE(2436),
    [sym_spread_element] = STATE(2668),
    [sym_string] = STATE(1880),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym_method_definition] = STATE(2668),
    [sym_pair] = STATE(2668),
    [sym__property_name] = STATE(1880),
    [sym_computed_property_name] = STATE(1880),
    [sym_method_signature] = STATE(2152),
    [sym_accessibility_modifier] = STATE(1826),
    [sym_call_signature] = STATE(2152),
    [sym_property_signature] = STATE(2152),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2152),
    [sym_index_signature] = STATE(2152),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [aux_sym_object_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(3121),
    [anon_sym_export] = ACTIONS(3123),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3121),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_type] = ACTIONS(3121),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3127),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3129),
    [anon_sym_get] = ACTIONS(3131),
    [anon_sym_set] = ACTIONS(3131),
    [anon_sym_declare] = ACTIONS(3121),
    [anon_sym_public] = ACTIONS(3133),
    [anon_sym_private] = ACTIONS(3133),
    [anon_sym_protected] = ACTIONS(3133),
    [anon_sym_module] = ACTIONS(3121),
    [anon_sym_any] = ACTIONS(3121),
    [anon_sym_number] = ACTIONS(3121),
    [anon_sym_boolean] = ACTIONS(3121),
    [anon_sym_string] = ACTIONS(3121),
    [anon_sym_symbol] = ACTIONS(3121),
    [sym_readonly] = ACTIONS(3135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3103),
  },
  [651] = {
    [sym_nested_identifier] = STATE(1416),
    [sym_string] = STATE(1415),
    [sym__module] = STATE(1631),
    [sym_identifier] = ACTIONS(3169),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [652] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym_arguments] = STATE(1534),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [653] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(774),
    [anon_sym_STAR_EQ] = ACTIONS(774),
    [anon_sym_SLASH_EQ] = ACTIONS(774),
    [anon_sym_PERCENT_EQ] = ACTIONS(774),
    [anon_sym_CARET_EQ] = ACTIONS(774),
    [anon_sym_AMP_EQ] = ACTIONS(774),
    [anon_sym_PIPE_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_LT_EQ] = ACTIONS(774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_implements] = ACTIONS(471),
  },
  [654] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [655] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [656] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [657] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [658] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [659] = {
    [sym_nested_identifier] = STATE(1011),
    [sym_string] = STATE(1012),
    [sym__module] = STATE(1290),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [660] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_template_string] = STATE(1627),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1601),
    [sym_constructor_type] = STATE(1601),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1601),
    [sym_intersection_type] = STATE(1601),
    [sym_function_type] = STATE(1601),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [661] = {
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [662] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3209),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_RPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_of] = ACTIONS(3209),
    [anon_sym_COLON] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_RBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3209),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_implements] = ACTIONS(3209),
  },
  [663] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [664] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_template_string] = STATE(1041),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1042),
    [sym_constructor_type] = STATE(1042),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1042),
    [sym_intersection_type] = STATE(1042),
    [sym_function_type] = STATE(1042),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [665] = {
    [anon_sym_STAR] = ACTIONS(3013),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_RPAREN] = ACTIONS(3015),
    [anon_sym_in] = ACTIONS(3013),
    [anon_sym_of] = ACTIONS(3015),
    [anon_sym_COLON] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_RBRACK] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_GT] = ACTIONS(3013),
    [anon_sym_SLASH] = ACTIONS(3013),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_PLUS_EQ] = ACTIONS(3015),
    [anon_sym_DASH_EQ] = ACTIONS(3015),
    [anon_sym_STAR_EQ] = ACTIONS(3015),
    [anon_sym_SLASH_EQ] = ACTIONS(3015),
    [anon_sym_PERCENT_EQ] = ACTIONS(3015),
    [anon_sym_CARET_EQ] = ACTIONS(3015),
    [anon_sym_AMP_EQ] = ACTIONS(3015),
    [anon_sym_PIPE_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_LT_LT_EQ] = ACTIONS(3015),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_GT_GT] = ACTIONS(3013),
    [anon_sym_GT_GT_GT] = ACTIONS(3013),
    [anon_sym_LT_LT] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_CARET] = ACTIONS(3013),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_PERCENT] = ACTIONS(3013),
    [anon_sym_STAR_STAR] = ACTIONS(3013),
    [anon_sym_LT_EQ] = ACTIONS(3015),
    [anon_sym_EQ_EQ] = ACTIONS(3013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3013),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3015),
    [anon_sym_GT_EQ] = ACTIONS(3015),
    [anon_sym_instanceof] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [anon_sym_implements] = ACTIONS(3015),
  },
  [666] = {
    [sym_export_statement] = STATE(2118),
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2815),
    [sym_array] = STATE(3170),
    [sym__call_signature] = STATE(2436),
    [sym_spread_element] = STATE(2815),
    [sym_string] = STATE(1880),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym_method_definition] = STATE(2815),
    [sym_pair] = STATE(2815),
    [sym__property_name] = STATE(1880),
    [sym_computed_property_name] = STATE(1880),
    [sym_method_signature] = STATE(2118),
    [sym_accessibility_modifier] = STATE(1826),
    [sym_call_signature] = STATE(2118),
    [sym_property_signature] = STATE(2118),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2118),
    [sym_index_signature] = STATE(2118),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3245),
    [anon_sym_export] = ACTIONS(3247),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3253),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3257),
    [anon_sym_private] = ACTIONS(3257),
    [anon_sym_protected] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3245),
    [anon_sym_any] = ACTIONS(3245),
    [anon_sym_number] = ACTIONS(3245),
    [anon_sym_boolean] = ACTIONS(3245),
    [anon_sym_string] = ACTIONS(3245),
    [anon_sym_symbol] = ACTIONS(3245),
    [sym_readonly] = ACTIONS(3259),
  },
  [667] = {
    [anon_sym_STAR] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3261),
    [anon_sym_as] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3263),
    [anon_sym_COMMA] = ACTIONS(3263),
    [anon_sym_RBRACE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_RPAREN] = ACTIONS(3263),
    [anon_sym_in] = ACTIONS(3261),
    [anon_sym_of] = ACTIONS(3263),
    [anon_sym_COLON] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_RBRACK] = ACTIONS(3263),
    [anon_sym_LT] = ACTIONS(3261),
    [anon_sym_GT] = ACTIONS(3261),
    [anon_sym_SLASH] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3263),
    [anon_sym_PLUS_EQ] = ACTIONS(3263),
    [anon_sym_DASH_EQ] = ACTIONS(3263),
    [anon_sym_STAR_EQ] = ACTIONS(3263),
    [anon_sym_SLASH_EQ] = ACTIONS(3263),
    [anon_sym_PERCENT_EQ] = ACTIONS(3263),
    [anon_sym_CARET_EQ] = ACTIONS(3263),
    [anon_sym_AMP_EQ] = ACTIONS(3263),
    [anon_sym_PIPE_EQ] = ACTIONS(3263),
    [anon_sym_GT_GT_EQ] = ACTIONS(3263),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3263),
    [anon_sym_LT_LT_EQ] = ACTIONS(3263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3263),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP_AMP] = ACTIONS(3263),
    [anon_sym_PIPE_PIPE] = ACTIONS(3263),
    [anon_sym_GT_GT] = ACTIONS(3261),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3263),
    [anon_sym_EQ_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3263),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3263),
    [anon_sym_GT_EQ] = ACTIONS(3263),
    [anon_sym_instanceof] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3263),
    [anon_sym_DASH_DASH] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3263),
    [anon_sym_implements] = ACTIONS(3263),
  },
  [668] = {
    [sym_nested_identifier] = STATE(999),
    [sym_string] = STATE(996),
    [sym__module] = STATE(1139),
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(790),
    [anon_sym_of] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [669] = {
    [sym_export_statement] = STATE(2125),
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2815),
    [sym_array] = STATE(3170),
    [sym__call_signature] = STATE(2436),
    [sym_spread_element] = STATE(2815),
    [sym_string] = STATE(1880),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym_method_definition] = STATE(2815),
    [sym_pair] = STATE(2815),
    [sym__property_name] = STATE(1880),
    [sym_computed_property_name] = STATE(1880),
    [sym_method_signature] = STATE(2125),
    [sym_accessibility_modifier] = STATE(1826),
    [sym_call_signature] = STATE(2125),
    [sym_property_signature] = STATE(2125),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2125),
    [sym_index_signature] = STATE(2125),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3245),
    [anon_sym_export] = ACTIONS(3247),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_namespace] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3251),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3245),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3253),
    [anon_sym_get] = ACTIONS(3255),
    [anon_sym_set] = ACTIONS(3255),
    [anon_sym_declare] = ACTIONS(3245),
    [anon_sym_public] = ACTIONS(3257),
    [anon_sym_private] = ACTIONS(3257),
    [anon_sym_protected] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(3245),
    [anon_sym_any] = ACTIONS(3245),
    [anon_sym_number] = ACTIONS(3245),
    [anon_sym_boolean] = ACTIONS(3245),
    [anon_sym_string] = ACTIONS(3245),
    [anon_sym_symbol] = ACTIONS(3245),
    [sym_readonly] = ACTIONS(3259),
  },
  [670] = {
    [sym_arguments] = STATE(1035),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_COLON] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_RBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3265),
    [anon_sym_LT_LT] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3265),
    [anon_sym_STAR_STAR] = ACTIONS(3265),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_implements] = ACTIONS(3269),
  },
  [671] = {
    [sym__initializer] = STATE(2750),
    [sym_type_annotation] = STATE(2341),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3273),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3275),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3277),
    [anon_sym_of] = ACTIONS(3280),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(3275),
  },
  [672] = {
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [673] = {
    [sym_type_arguments] = STATE(1933),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3296),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_is] = ACTIONS(3305),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2532),
    [sym__automatic_semicolon] = ACTIONS(2532),
  },
  [674] = {
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_as] = ACTIONS(3039),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_RBRACE] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_in] = ACTIONS(3037),
    [anon_sym_of] = ACTIONS(3039),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_RBRACK] = ACTIONS(3039),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_GT] = ACTIONS(3037),
    [anon_sym_SLASH] = ACTIONS(3037),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_PLUS_EQ] = ACTIONS(3039),
    [anon_sym_DASH_EQ] = ACTIONS(3039),
    [anon_sym_STAR_EQ] = ACTIONS(3039),
    [anon_sym_SLASH_EQ] = ACTIONS(3039),
    [anon_sym_PERCENT_EQ] = ACTIONS(3039),
    [anon_sym_CARET_EQ] = ACTIONS(3039),
    [anon_sym_AMP_EQ] = ACTIONS(3039),
    [anon_sym_PIPE_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_LT_LT_EQ] = ACTIONS(3039),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_GT_GT] = ACTIONS(3037),
    [anon_sym_GT_GT_GT] = ACTIONS(3037),
    [anon_sym_LT_LT] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_CARET] = ACTIONS(3037),
    [anon_sym_PIPE] = ACTIONS(3037),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_DASH] = ACTIONS(3037),
    [anon_sym_PERCENT] = ACTIONS(3037),
    [anon_sym_STAR_STAR] = ACTIONS(3037),
    [anon_sym_LT_EQ] = ACTIONS(3039),
    [anon_sym_EQ_EQ] = ACTIONS(3037),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3037),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3039),
    [anon_sym_GT_EQ] = ACTIONS(3039),
    [anon_sym_instanceof] = ACTIONS(3039),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3039),
    [anon_sym_implements] = ACTIONS(3039),
  },
  [675] = {
    [anon_sym_STAR] = ACTIONS(3307),
    [anon_sym_EQ] = ACTIONS(3307),
    [anon_sym_as] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_COMMA] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_RPAREN] = ACTIONS(3309),
    [anon_sym_in] = ACTIONS(3307),
    [anon_sym_of] = ACTIONS(3309),
    [anon_sym_COLON] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_RBRACK] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3307),
    [anon_sym_SLASH] = ACTIONS(3307),
    [anon_sym_DOT] = ACTIONS(3309),
    [anon_sym_PLUS_EQ] = ACTIONS(3309),
    [anon_sym_DASH_EQ] = ACTIONS(3309),
    [anon_sym_STAR_EQ] = ACTIONS(3309),
    [anon_sym_SLASH_EQ] = ACTIONS(3309),
    [anon_sym_PERCENT_EQ] = ACTIONS(3309),
    [anon_sym_CARET_EQ] = ACTIONS(3309),
    [anon_sym_AMP_EQ] = ACTIONS(3309),
    [anon_sym_PIPE_EQ] = ACTIONS(3309),
    [anon_sym_GT_GT_EQ] = ACTIONS(3309),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3309),
    [anon_sym_LT_LT_EQ] = ACTIONS(3309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3309),
    [anon_sym_QMARK] = ACTIONS(3309),
    [anon_sym_AMP_AMP] = ACTIONS(3309),
    [anon_sym_PIPE_PIPE] = ACTIONS(3309),
    [anon_sym_GT_GT] = ACTIONS(3307),
    [anon_sym_GT_GT_GT] = ACTIONS(3307),
    [anon_sym_LT_LT] = ACTIONS(3307),
    [anon_sym_AMP] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_PIPE] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3307),
    [anon_sym_PERCENT] = ACTIONS(3307),
    [anon_sym_STAR_STAR] = ACTIONS(3307),
    [anon_sym_LT_EQ] = ACTIONS(3309),
    [anon_sym_EQ_EQ] = ACTIONS(3307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3309),
    [anon_sym_BANG_EQ] = ACTIONS(3307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3309),
    [anon_sym_GT_EQ] = ACTIONS(3309),
    [anon_sym_instanceof] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3307),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3309),
    [anon_sym_implements] = ACTIONS(3309),
  },
  [676] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_is] = ACTIONS(3316),
  },
  [677] = {
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [678] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_template_string] = STATE(1496),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1491),
    [sym_constructor_type] = STATE(1491),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1491),
    [sym_intersection_type] = STATE(1491),
    [sym_function_type] = STATE(1491),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [679] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2566),
    [sym_constructor_type] = STATE(2566),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2566),
    [sym_intersection_type] = STATE(2566),
    [sym_function_type] = STATE(2566),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_RBRACK] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [680] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3364),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [681] = {
    [aux_sym_object_repeat1] = STATE(2645),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [682] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3366),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [683] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [684] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3370),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [685] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2363),
    [sym_constructor_type] = STATE(2363),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2363),
    [sym_intersection_type] = STATE(2363),
    [sym_function_type] = STATE(2363),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_jsx_identifier] = ACTIONS(3374),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [686] = {
    [aux_sym_object_repeat1] = STATE(2671),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3376),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3381),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [687] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2595),
    [sym_constructor_type] = STATE(2595),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2595),
    [sym_intersection_type] = STATE(2595),
    [sym_function_type] = STATE(2595),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_RBRACK] = ACTIONS(3390),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [688] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3392),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [689] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3394),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [690] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3396),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [691] = {
    [sym_arguments] = STATE(1035),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_COLON] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_RBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3265),
    [anon_sym_LT_LT] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3265),
    [anon_sym_STAR_STAR] = ACTIONS(3265),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
  },
  [692] = {
    [aux_sym_object_repeat1] = STATE(2645),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3376),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3381),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [693] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3398),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [694] = {
    [anon_sym_STAR] = ACTIONS(3400),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_as] = ACTIONS(3402),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_COLON] = ACTIONS(3402),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_RBRACK] = ACTIONS(3402),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_PLUS_EQ] = ACTIONS(3015),
    [anon_sym_DASH_EQ] = ACTIONS(3015),
    [anon_sym_STAR_EQ] = ACTIONS(3015),
    [anon_sym_SLASH_EQ] = ACTIONS(3015),
    [anon_sym_PERCENT_EQ] = ACTIONS(3015),
    [anon_sym_CARET_EQ] = ACTIONS(3015),
    [anon_sym_AMP_EQ] = ACTIONS(3015),
    [anon_sym_PIPE_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_LT_LT_EQ] = ACTIONS(3015),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_GT_GT] = ACTIONS(3400),
    [anon_sym_GT_GT_GT] = ACTIONS(3400),
    [anon_sym_LT_LT] = ACTIONS(3400),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3400),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3400),
    [anon_sym_STAR_STAR] = ACTIONS(3400),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_EQ_EQ] = ACTIONS(3400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_instanceof] = ACTIONS(3402),
    [anon_sym_BANG] = ACTIONS(3400),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3402),
    [anon_sym_implements] = ACTIONS(3402),
  },
  [695] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3404),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [696] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3290),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3408),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_is] = ACTIONS(3316),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [697] = {
    [aux_sym_object_repeat1] = STATE(2718),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3376),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3381),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [698] = {
    [aux_sym_object_repeat1] = STATE(2671),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [699] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3410),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [700] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2642),
    [sym_constructor_type] = STATE(2642),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2642),
    [sym_intersection_type] = STATE(2642),
    [sym_function_type] = STATE(2642),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_RBRACK] = ACTIONS(3412),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [701] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3414),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [702] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_RPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_COLON] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3416),
    [anon_sym_RBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_implements] = ACTIONS(3209),
  },
  [703] = {
    [sym_arguments] = STATE(1033),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(529),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
  },
  [704] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3425),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [705] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [706] = {
    [aux_sym_object_repeat1] = STATE(2718),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [707] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2705),
    [sym_constructor_type] = STATE(2705),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2705),
    [sym_intersection_type] = STATE(2705),
    [sym_function_type] = STATE(2705),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_RBRACK] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [708] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2717),
    [sym_constructor_type] = STATE(2717),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2717),
    [sym_intersection_type] = STATE(2717),
    [sym_function_type] = STATE(2717),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_RBRACK] = ACTIONS(3431),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [709] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_GT] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [710] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_RPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_COLON] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_RBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_implements] = ACTIONS(3209),
  },
  [711] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_is] = ACTIONS(3316),
  },
  [712] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(2346),
    [sym_constructor_type] = STATE(2346),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2346),
    [sym_intersection_type] = STATE(2346),
    [sym_function_type] = STATE(2346),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [713] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(2519),
    [sym_constructor_type] = STATE(2519),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(2519),
    [sym_intersection_type] = STATE(2519),
    [sym_function_type] = STATE(2519),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [714] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(1913),
    [sym_constructor_type] = STATE(1913),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(1913),
    [sym_intersection_type] = STATE(1913),
    [sym_function_type] = STATE(1913),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [715] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2621),
    [sym_constructor_type] = STATE(2621),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2621),
    [sym_intersection_type] = STATE(2621),
    [sym_function_type] = STATE(2621),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [716] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1515),
    [sym_constructor_type] = STATE(1515),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1515),
    [sym_intersection_type] = STATE(1515),
    [sym_function_type] = STATE(1515),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [717] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1134),
    [sym_constructor_type] = STATE(1134),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1134),
    [sym_intersection_type] = STATE(1134),
    [sym_function_type] = STATE(1134),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [718] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(1914),
    [sym_constructor_type] = STATE(1914),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(1914),
    [sym_intersection_type] = STATE(1914),
    [sym_function_type] = STATE(1914),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [719] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1516),
    [sym_constructor_type] = STATE(1516),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1516),
    [sym_intersection_type] = STATE(1516),
    [sym_function_type] = STATE(1516),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [720] = {
    [sym_type_arguments] = STATE(2687),
    [aux_sym_extends_clause_repeat1] = STATE(2467),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_EQ_GT] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3487),
    [anon_sym_DASH_EQ] = ACTIONS(3487),
    [anon_sym_STAR_EQ] = ACTIONS(3487),
    [anon_sym_SLASH_EQ] = ACTIONS(3487),
    [anon_sym_PERCENT_EQ] = ACTIONS(3487),
    [anon_sym_CARET_EQ] = ACTIONS(3487),
    [anon_sym_AMP_EQ] = ACTIONS(3487),
    [anon_sym_PIPE_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_LT_LT_EQ] = ACTIONS(3487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3489),
  },
  [721] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2485),
    [sym_constructor_type] = STATE(2485),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2485),
    [sym_intersection_type] = STATE(2485),
    [sym_function_type] = STATE(2485),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [722] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2363),
    [sym_constructor_type] = STATE(2363),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2363),
    [sym_intersection_type] = STATE(2363),
    [sym_function_type] = STATE(2363),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [723] = {
    [sym_identifier] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [724] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1136),
    [sym_constructor_type] = STATE(1136),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1136),
    [sym_intersection_type] = STATE(1136),
    [sym_function_type] = STATE(1136),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [725] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(1919),
    [sym_constructor_type] = STATE(1919),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(1919),
    [sym_intersection_type] = STATE(1919),
    [sym_function_type] = STATE(1919),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [726] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2686),
    [sym_constructor_type] = STATE(2686),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2686),
    [sym_intersection_type] = STATE(2686),
    [sym_function_type] = STATE(2686),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [727] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2580),
    [sym_constructor_type] = STATE(2580),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2580),
    [sym_intersection_type] = STATE(2580),
    [sym_function_type] = STATE(2580),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [728] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2385),
    [sym_constructor_type] = STATE(2385),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2385),
    [sym_intersection_type] = STATE(2385),
    [sym_function_type] = STATE(2385),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [729] = {
    [sym_identifier] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [730] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1171),
    [sym_constructor_type] = STATE(1171),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1171),
    [sym_intersection_type] = STATE(1171),
    [sym_function_type] = STATE(1171),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [731] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1170),
    [sym_constructor_type] = STATE(1170),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1170),
    [sym_intersection_type] = STATE(1170),
    [sym_function_type] = STATE(1170),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [732] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(447),
    [sym_constructor_type] = STATE(447),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(447),
    [sym_intersection_type] = STATE(447),
    [sym_function_type] = STATE(447),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [733] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1169),
    [sym_constructor_type] = STATE(1169),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1169),
    [sym_intersection_type] = STATE(1169),
    [sym_function_type] = STATE(1169),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [734] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [735] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2583),
    [sym_constructor_type] = STATE(2583),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2583),
    [sym_intersection_type] = STATE(2583),
    [sym_function_type] = STATE(2583),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [736] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(493),
    [sym_constructor_type] = STATE(493),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(493),
    [sym_intersection_type] = STATE(493),
    [sym_function_type] = STATE(493),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [737] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(445),
    [sym_constructor_type] = STATE(445),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(445),
    [sym_intersection_type] = STATE(445),
    [sym_function_type] = STATE(445),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [738] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1568),
    [sym_constructor_type] = STATE(1568),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1568),
    [sym_intersection_type] = STATE(1568),
    [sym_function_type] = STATE(1568),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [739] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1168),
    [sym_constructor_type] = STATE(1168),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1168),
    [sym_intersection_type] = STATE(1168),
    [sym_function_type] = STATE(1168),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [740] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1569),
    [sym_constructor_type] = STATE(1569),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1569),
    [sym_intersection_type] = STATE(1569),
    [sym_function_type] = STATE(1569),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [741] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1570),
    [sym_constructor_type] = STATE(1570),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1570),
    [sym_intersection_type] = STATE(1570),
    [sym_function_type] = STATE(1570),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [742] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(445),
    [sym_constructor_type] = STATE(445),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(445),
    [sym_intersection_type] = STATE(445),
    [sym_function_type] = STATE(445),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [743] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(447),
    [sym_constructor_type] = STATE(447),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(447),
    [sym_intersection_type] = STATE(447),
    [sym_function_type] = STATE(447),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [744] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1571),
    [sym_constructor_type] = STATE(1571),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1571),
    [sym_intersection_type] = STATE(1571),
    [sym_function_type] = STATE(1571),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [745] = {
    [sym_type_arguments] = STATE(425),
    [aux_sym_extends_clause_repeat1] = STATE(2495),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3501),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(3489),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3505),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3508),
    [anon_sym_EQ_GT] = ACTIONS(3510),
    [anon_sym_PLUS_EQ] = ACTIONS(3512),
    [anon_sym_DASH_EQ] = ACTIONS(3512),
    [anon_sym_STAR_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_PERCENT_EQ] = ACTIONS(3512),
    [anon_sym_CARET_EQ] = ACTIONS(3512),
    [anon_sym_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_LT_LT_EQ] = ACTIONS(3512),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3512),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(3489),
  },
  [746] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(2546),
    [sym_constructor_type] = STATE(2546),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(2546),
    [sym_intersection_type] = STATE(2546),
    [sym_function_type] = STATE(2546),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [747] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2264),
    [sym_constructor_type] = STATE(2264),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2264),
    [sym_intersection_type] = STATE(2264),
    [sym_function_type] = STATE(2264),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [748] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2309),
    [sym_constructor_type] = STATE(2309),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2309),
    [sym_intersection_type] = STATE(2309),
    [sym_function_type] = STATE(2309),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [749] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(2490),
    [sym_constructor_type] = STATE(2490),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(2490),
    [sym_intersection_type] = STATE(2490),
    [sym_function_type] = STATE(2490),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [750] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2345),
    [sym_constructor_type] = STATE(2345),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2345),
    [sym_intersection_type] = STATE(2345),
    [sym_function_type] = STATE(2345),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [751] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3514),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [752] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(2360),
    [sym_constructor_type] = STATE(2360),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2360),
    [sym_intersection_type] = STATE(2360),
    [sym_function_type] = STATE(2360),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [753] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(434),
    [sym_constructor_type] = STATE(434),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(434),
    [sym_intersection_type] = STATE(434),
    [sym_function_type] = STATE(434),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [754] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(448),
    [sym_constructor_type] = STATE(448),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(448),
    [sym_intersection_type] = STATE(448),
    [sym_function_type] = STATE(448),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [755] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2361),
    [sym_constructor_type] = STATE(2361),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2361),
    [sym_intersection_type] = STATE(2361),
    [sym_function_type] = STATE(2361),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [756] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1155),
    [sym_constructor_type] = STATE(1155),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1155),
    [sym_intersection_type] = STATE(1155),
    [sym_function_type] = STATE(1155),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [757] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1154),
    [sym_constructor_type] = STATE(1154),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1154),
    [sym_intersection_type] = STATE(1154),
    [sym_function_type] = STATE(1154),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [758] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(2404),
    [sym_constructor_type] = STATE(2404),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2404),
    [sym_intersection_type] = STATE(2404),
    [sym_function_type] = STATE(2404),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [759] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(2405),
    [sym_constructor_type] = STATE(2405),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2405),
    [sym_intersection_type] = STATE(2405),
    [sym_function_type] = STATE(2405),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [760] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(2413),
    [sym_constructor_type] = STATE(2413),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2413),
    [sym_intersection_type] = STATE(2413),
    [sym_function_type] = STATE(2413),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [761] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2747),
    [sym_constructor_type] = STATE(2747),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2747),
    [sym_intersection_type] = STATE(2747),
    [sym_function_type] = STATE(2747),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [762] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2099),
    [sym_constructor_type] = STATE(2099),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2099),
    [sym_intersection_type] = STATE(2099),
    [sym_function_type] = STATE(2099),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [763] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2438),
    [sym_constructor_type] = STATE(2438),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2438),
    [sym_intersection_type] = STATE(2438),
    [sym_function_type] = STATE(2438),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [764] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(445),
    [sym_constructor_type] = STATE(445),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(445),
    [sym_intersection_type] = STATE(445),
    [sym_function_type] = STATE(445),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [765] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2442),
    [sym_constructor_type] = STATE(2442),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2442),
    [sym_intersection_type] = STATE(2442),
    [sym_function_type] = STATE(2442),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [766] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(447),
    [sym_constructor_type] = STATE(447),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(447),
    [sym_intersection_type] = STATE(447),
    [sym_function_type] = STATE(447),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [767] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1544),
    [sym_constructor_type] = STATE(1544),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1544),
    [sym_intersection_type] = STATE(1544),
    [sym_function_type] = STATE(1544),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [768] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1540),
    [sym_constructor_type] = STATE(1540),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1540),
    [sym_intersection_type] = STATE(1540),
    [sym_function_type] = STATE(1540),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [769] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2623),
    [sym_constructor_type] = STATE(2623),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2623),
    [sym_intersection_type] = STATE(2623),
    [sym_function_type] = STATE(2623),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [770] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2227),
    [sym_constructor_type] = STATE(2227),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2227),
    [sym_intersection_type] = STATE(2227),
    [sym_function_type] = STATE(2227),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [771] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(1923),
    [sym_constructor_type] = STATE(1923),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(1923),
    [sym_intersection_type] = STATE(1923),
    [sym_function_type] = STATE(1923),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [772] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(2071),
    [sym_constructor_type] = STATE(2071),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(2071),
    [sym_intersection_type] = STATE(2071),
    [sym_function_type] = STATE(2071),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [773] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_formal_parameters] = STATE(3168),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__type] = STATE(1532),
    [sym_constructor_type] = STATE(1532),
    [sym__primary_type] = STATE(1433),
    [sym_generic_type] = STATE(1433),
    [sym_type_predicate] = STATE(1433),
    [sym_type_query] = STATE(1433),
    [sym_index_type_query] = STATE(1433),
    [sym_lookup_type] = STATE(1433),
    [sym_literal_type] = STATE(1433),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1433),
    [sym_flow_maybe_type] = STATE(1433),
    [sym_parenthesized_type] = STATE(1433),
    [sym_predefined_type] = STATE(1433),
    [sym_object_type] = STATE(1433),
    [sym_type_parameters] = STATE(2836),
    [sym_array_type] = STATE(1433),
    [sym_tuple_type] = STATE(1433),
    [sym_union_type] = STATE(1532),
    [sym_intersection_type] = STATE(1532),
    [sym_function_type] = STATE(1532),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3344),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [774] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(1966),
    [sym_constructor_type] = STATE(1966),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(1966),
    [sym_intersection_type] = STATE(1966),
    [sym_function_type] = STATE(1966),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [775] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(1952),
    [sym_constructor_type] = STATE(1952),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(1952),
    [sym_intersection_type] = STATE(1952),
    [sym_function_type] = STATE(1952),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [776] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2654),
    [sym_constructor_type] = STATE(2654),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2654),
    [sym_intersection_type] = STATE(2654),
    [sym_function_type] = STATE(2654),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [777] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2355),
    [sym_constructor_type] = STATE(2355),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2355),
    [sym_intersection_type] = STATE(2355),
    [sym_function_type] = STATE(2355),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [778] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(2010),
    [sym_constructor_type] = STATE(2010),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(2010),
    [sym_intersection_type] = STATE(2010),
    [sym_function_type] = STATE(2010),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [779] = {
    [sym_arguments] = STATE(1528),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3265),
    [anon_sym_LT_LT] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3265),
    [anon_sym_STAR_STAR] = ACTIONS(3265),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym__automatic_semicolon] = ACTIONS(3269),
  },
  [780] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_formal_parameters] = STATE(3067),
    [sym_nested_type_identifier] = STATE(985),
    [sym__type] = STATE(1138),
    [sym_constructor_type] = STATE(1138),
    [sym__primary_type] = STATE(1147),
    [sym_generic_type] = STATE(1147),
    [sym_type_predicate] = STATE(1147),
    [sym_type_query] = STATE(1147),
    [sym_index_type_query] = STATE(1147),
    [sym_lookup_type] = STATE(1147),
    [sym_literal_type] = STATE(1147),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1147),
    [sym_flow_maybe_type] = STATE(1147),
    [sym_parenthesized_type] = STATE(1147),
    [sym_predefined_type] = STATE(1147),
    [sym_object_type] = STATE(1147),
    [sym_type_parameters] = STATE(2913),
    [sym_array_type] = STATE(1147),
    [sym_tuple_type] = STATE(1147),
    [sym_union_type] = STATE(1138),
    [sym_intersection_type] = STATE(1138),
    [sym_function_type] = STATE(1138),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [781] = {
    [sym_arguments] = STATE(1534),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [782] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(1910),
    [sym_constructor_type] = STATE(1910),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(1910),
    [sym_intersection_type] = STATE(1910),
    [sym_function_type] = STATE(1910),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [783] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3501),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3510),
    [anon_sym_PLUS_EQ] = ACTIONS(3512),
    [anon_sym_DASH_EQ] = ACTIONS(3512),
    [anon_sym_STAR_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_PERCENT_EQ] = ACTIONS(3512),
    [anon_sym_CARET_EQ] = ACTIONS(3512),
    [anon_sym_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_LT_LT_EQ] = ACTIONS(3512),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3512),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(1223),
    [anon_sym_is] = ACTIONS(3316),
  },
  [784] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2348),
    [sym_constructor_type] = STATE(2348),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2348),
    [sym_intersection_type] = STATE(2348),
    [sym_function_type] = STATE(2348),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [785] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3124),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__type] = STATE(2450),
    [sym_constructor_type] = STATE(2450),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2766),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2450),
    [sym_intersection_type] = STATE(2450),
    [sym_function_type] = STATE(2450),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3444),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [786] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(1918),
    [sym_constructor_type] = STATE(1918),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(1918),
    [sym_intersection_type] = STATE(1918),
    [sym_function_type] = STATE(1918),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [787] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2440),
    [sym_constructor_type] = STATE(2440),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2440),
    [sym_intersection_type] = STATE(2440),
    [sym_function_type] = STATE(2440),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [788] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2169),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2169),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [789] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(434),
    [sym_constructor_type] = STATE(434),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(434),
    [sym_intersection_type] = STATE(434),
    [sym_function_type] = STATE(434),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [790] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(448),
    [sym_constructor_type] = STATE(448),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(448),
    [sym_intersection_type] = STATE(448),
    [sym_function_type] = STATE(448),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [791] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(575),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_PIPE_RBRACE] = ACTIONS(617),
    [sym__automatic_semicolon] = ACTIONS(617),
  },
  [792] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1614),
    [sym_constructor_type] = STATE(1614),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1614),
    [sym_intersection_type] = STATE(1614),
    [sym_function_type] = STATE(1614),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [793] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1615),
    [sym_constructor_type] = STATE(1615),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1615),
    [sym_intersection_type] = STATE(1615),
    [sym_function_type] = STATE(1615),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [794] = {
    [sym_identifier] = ACTIONS(3205),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [795] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1616),
    [sym_constructor_type] = STATE(1616),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1616),
    [sym_intersection_type] = STATE(1616),
    [sym_function_type] = STATE(1616),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [796] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(1938),
    [sym_constructor_type] = STATE(1938),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(1938),
    [sym_intersection_type] = STATE(1938),
    [sym_function_type] = STATE(1938),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [797] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(1965),
    [sym_constructor_type] = STATE(1965),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(1965),
    [sym_intersection_type] = STATE(1965),
    [sym_function_type] = STATE(1965),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [798] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(1958),
    [sym_constructor_type] = STATE(1958),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(1958),
    [sym_intersection_type] = STATE(1958),
    [sym_function_type] = STATE(1958),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [799] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(1953),
    [sym_constructor_type] = STATE(1953),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(1953),
    [sym_intersection_type] = STATE(1953),
    [sym_function_type] = STATE(1953),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [800] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2316),
    [sym_constructor_type] = STATE(2316),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2316),
    [sym_intersection_type] = STATE(2316),
    [sym_function_type] = STATE(2316),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [801] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3026),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__type] = STATE(2295),
    [sym_constructor_type] = STATE(2295),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2912),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(2295),
    [sym_intersection_type] = STATE(2295),
    [sym_function_type] = STATE(2295),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_PIPE] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [802] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3516),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2605),
    [sym__automatic_semicolon] = ACTIONS(2605),
  },
  [803] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1642),
    [sym_constructor_type] = STATE(1642),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1642),
    [sym_intersection_type] = STATE(1642),
    [sym_function_type] = STATE(1642),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [804] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1643),
    [sym_constructor_type] = STATE(1643),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1643),
    [sym_intersection_type] = STATE(1643),
    [sym_function_type] = STATE(1643),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [805] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1617),
    [sym_constructor_type] = STATE(1617),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1617),
    [sym_intersection_type] = STATE(1617),
    [sym_function_type] = STATE(1617),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [806] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [807] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1618),
    [sym_constructor_type] = STATE(1618),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1618),
    [sym_intersection_type] = STATE(1618),
    [sym_function_type] = STATE(1618),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [808] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3518),
    [anon_sym_EQ_GT] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3487),
    [anon_sym_DASH_EQ] = ACTIONS(3487),
    [anon_sym_STAR_EQ] = ACTIONS(3487),
    [anon_sym_SLASH_EQ] = ACTIONS(3487),
    [anon_sym_PERCENT_EQ] = ACTIONS(3487),
    [anon_sym_CARET_EQ] = ACTIONS(3487),
    [anon_sym_AMP_EQ] = ACTIONS(3487),
    [anon_sym_PIPE_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_LT_LT_EQ] = ACTIONS(3487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_is] = ACTIONS(3316),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [809] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(3526),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3530),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_is] = ACTIONS(3316),
  },
  [810] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(489),
    [sym_constructor_type] = STATE(489),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(489),
    [sym_intersection_type] = STATE(489),
    [sym_function_type] = STATE(489),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [811] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(2451),
    [sym_constructor_type] = STATE(2451),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(2451),
    [sym_intersection_type] = STATE(2451),
    [sym_function_type] = STATE(2451),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [812] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(484),
    [sym_constructor_type] = STATE(484),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(484),
    [sym_intersection_type] = STATE(484),
    [sym_function_type] = STATE(484),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [813] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(485),
    [sym_constructor_type] = STATE(485),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(485),
    [sym_intersection_type] = STATE(485),
    [sym_function_type] = STATE(485),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [814] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1657),
    [sym_constructor_type] = STATE(1657),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1657),
    [sym_intersection_type] = STATE(1657),
    [sym_function_type] = STATE(1657),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [815] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(1936),
    [sym_constructor_type] = STATE(1936),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(1936),
    [sym_intersection_type] = STATE(1936),
    [sym_function_type] = STATE(1936),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [816] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_formal_parameters] = STATE(3131),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__type] = STATE(1656),
    [sym_constructor_type] = STATE(1656),
    [sym__primary_type] = STATE(1574),
    [sym_generic_type] = STATE(1574),
    [sym_type_predicate] = STATE(1574),
    [sym_type_query] = STATE(1574),
    [sym_index_type_query] = STATE(1574),
    [sym_lookup_type] = STATE(1574),
    [sym_literal_type] = STATE(1574),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1574),
    [sym_flow_maybe_type] = STATE(1574),
    [sym_parenthesized_type] = STATE(1574),
    [sym_predefined_type] = STATE(1574),
    [sym_object_type] = STATE(1574),
    [sym_type_parameters] = STATE(2890),
    [sym_array_type] = STATE(1574),
    [sym_tuple_type] = STATE(1574),
    [sym_union_type] = STATE(1656),
    [sym_intersection_type] = STATE(1656),
    [sym_function_type] = STATE(1656),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_AMP] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3197),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [817] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3532),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(3302),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3534),
    [anon_sym_EQ_GT] = ACTIONS(3536),
    [anon_sym_PLUS_EQ] = ACTIONS(3538),
    [anon_sym_DASH_EQ] = ACTIONS(3538),
    [anon_sym_STAR_EQ] = ACTIONS(3538),
    [anon_sym_SLASH_EQ] = ACTIONS(3538),
    [anon_sym_PERCENT_EQ] = ACTIONS(3538),
    [anon_sym_CARET_EQ] = ACTIONS(3538),
    [anon_sym_AMP_EQ] = ACTIONS(3538),
    [anon_sym_PIPE_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_LT_LT_EQ] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3538),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_is] = ACTIONS(3316),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [818] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_formal_parameters] = STATE(3080),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__type] = STATE(1935),
    [sym_constructor_type] = STATE(1935),
    [sym__primary_type] = STATE(1968),
    [sym_generic_type] = STATE(1968),
    [sym_type_predicate] = STATE(1968),
    [sym_type_query] = STATE(1968),
    [sym_index_type_query] = STATE(1968),
    [sym_lookup_type] = STATE(1968),
    [sym_literal_type] = STATE(1968),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1968),
    [sym_flow_maybe_type] = STATE(1968),
    [sym_parenthesized_type] = STATE(1968),
    [sym_predefined_type] = STATE(1968),
    [sym_object_type] = STATE(1968),
    [sym_type_parameters] = STATE(2966),
    [sym_array_type] = STATE(1968),
    [sym_tuple_type] = STATE(1968),
    [sym_union_type] = STATE(1935),
    [sym_intersection_type] = STATE(1935),
    [sym_function_type] = STATE(1935),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_AMP] = ACTIONS(971),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3470),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [819] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(448),
    [sym_constructor_type] = STATE(448),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(448),
    [sym_intersection_type] = STATE(448),
    [sym_function_type] = STATE(448),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [820] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [821] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(434),
    [sym_constructor_type] = STATE(434),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(434),
    [sym_intersection_type] = STATE(434),
    [sym_function_type] = STATE(434),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [822] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(486),
    [sym_constructor_type] = STATE(486),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(486),
    [sym_intersection_type] = STATE(486),
    [sym_function_type] = STATE(486),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [823] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_formal_parameters] = STATE(3148),
    [sym_nested_type_identifier] = STATE(479),
    [sym__type] = STATE(488),
    [sym_constructor_type] = STATE(488),
    [sym__primary_type] = STATE(439),
    [sym_generic_type] = STATE(439),
    [sym_type_predicate] = STATE(439),
    [sym_type_query] = STATE(439),
    [sym_index_type_query] = STATE(439),
    [sym_lookup_type] = STATE(439),
    [sym_literal_type] = STATE(439),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(439),
    [sym_flow_maybe_type] = STATE(439),
    [sym_parenthesized_type] = STATE(439),
    [sym_predefined_type] = STATE(439),
    [sym_object_type] = STATE(439),
    [sym_type_parameters] = STATE(2901),
    [sym_array_type] = STATE(439),
    [sym_tuple_type] = STATE(439),
    [sym_union_type] = STATE(488),
    [sym_intersection_type] = STATE(488),
    [sym_function_type] = STATE(488),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_new] = ACTIONS(3493),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_AMP] = ACTIONS(3497),
    [anon_sym_PIPE] = ACTIONS(3499),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3362),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [824] = {
    [sym_type_arguments] = STATE(2687),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(3540),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3483),
    [anon_sym_EQ_GT] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3487),
    [anon_sym_DASH_EQ] = ACTIONS(3487),
    [anon_sym_STAR_EQ] = ACTIONS(3487),
    [anon_sym_SLASH_EQ] = ACTIONS(3487),
    [anon_sym_PERCENT_EQ] = ACTIONS(3487),
    [anon_sym_CARET_EQ] = ACTIONS(3487),
    [anon_sym_AMP_EQ] = ACTIONS(3487),
    [anon_sym_PIPE_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_LT_LT_EQ] = ACTIONS(3487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3542),
  },
  [825] = {
    [sym_arguments] = STATE(1033),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(529),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_COLON] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_RBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
  },
  [826] = {
    [anon_sym_STAR] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3261),
    [anon_sym_as] = ACTIONS(3263),
    [anon_sym_COMMA] = ACTIONS(3263),
    [anon_sym_RBRACE] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_in] = ACTIONS(3261),
    [anon_sym_of] = ACTIONS(3263),
    [anon_sym_SEMI] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_LT] = ACTIONS(3261),
    [anon_sym_GT] = ACTIONS(3261),
    [anon_sym_SLASH] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3263),
    [anon_sym_PLUS_EQ] = ACTIONS(3263),
    [anon_sym_DASH_EQ] = ACTIONS(3263),
    [anon_sym_STAR_EQ] = ACTIONS(3263),
    [anon_sym_SLASH_EQ] = ACTIONS(3263),
    [anon_sym_PERCENT_EQ] = ACTIONS(3263),
    [anon_sym_CARET_EQ] = ACTIONS(3263),
    [anon_sym_AMP_EQ] = ACTIONS(3263),
    [anon_sym_PIPE_EQ] = ACTIONS(3263),
    [anon_sym_GT_GT_EQ] = ACTIONS(3263),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3263),
    [anon_sym_LT_LT_EQ] = ACTIONS(3263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3263),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP_AMP] = ACTIONS(3263),
    [anon_sym_PIPE_PIPE] = ACTIONS(3263),
    [anon_sym_GT_GT] = ACTIONS(3261),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3263),
    [anon_sym_EQ_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3263),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3263),
    [anon_sym_GT_EQ] = ACTIONS(3263),
    [anon_sym_instanceof] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3263),
    [anon_sym_DASH_DASH] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3263),
    [sym__automatic_semicolon] = ACTIONS(3263),
  },
  [827] = {
    [sym_arguments] = STATE(1035),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_COLON] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_RBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3265),
    [anon_sym_LT_LT] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3265),
    [anon_sym_STAR_STAR] = ACTIONS(3265),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
  },
  [828] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [829] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [830] = {
    [anon_sym_STAR] = ACTIONS(3013),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_in] = ACTIONS(3013),
    [anon_sym_of] = ACTIONS(3015),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_GT] = ACTIONS(3013),
    [anon_sym_SLASH] = ACTIONS(3013),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_PLUS_EQ] = ACTIONS(3015),
    [anon_sym_DASH_EQ] = ACTIONS(3015),
    [anon_sym_STAR_EQ] = ACTIONS(3015),
    [anon_sym_SLASH_EQ] = ACTIONS(3015),
    [anon_sym_PERCENT_EQ] = ACTIONS(3015),
    [anon_sym_CARET_EQ] = ACTIONS(3015),
    [anon_sym_AMP_EQ] = ACTIONS(3015),
    [anon_sym_PIPE_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_LT_LT_EQ] = ACTIONS(3015),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_GT_GT] = ACTIONS(3013),
    [anon_sym_GT_GT_GT] = ACTIONS(3013),
    [anon_sym_LT_LT] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_CARET] = ACTIONS(3013),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_PERCENT] = ACTIONS(3013),
    [anon_sym_STAR_STAR] = ACTIONS(3013),
    [anon_sym_LT_EQ] = ACTIONS(3015),
    [anon_sym_EQ_EQ] = ACTIONS(3013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3013),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3015),
    [anon_sym_GT_EQ] = ACTIONS(3015),
    [anon_sym_instanceof] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [sym__automatic_semicolon] = ACTIONS(3015),
  },
  [831] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [832] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [833] = {
    [sym_type_annotation] = STATE(2940),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(3544),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [834] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [835] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3549),
    [anon_sym_of] = ACTIONS(3552),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [836] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(3554),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [837] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [838] = {
    [sym_arguments] = STATE(1035),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3510),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3265),
    [anon_sym_LT_LT] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3265),
    [anon_sym_STAR_STAR] = ACTIONS(3265),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_implements] = ACTIONS(3269),
  },
  [839] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_COLON] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [840] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(3556),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(3556),
  },
  [841] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3501),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(3542),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3505),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3508),
    [anon_sym_EQ_GT] = ACTIONS(3510),
    [anon_sym_PLUS_EQ] = ACTIONS(3512),
    [anon_sym_DASH_EQ] = ACTIONS(3512),
    [anon_sym_STAR_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_PERCENT_EQ] = ACTIONS(3512),
    [anon_sym_CARET_EQ] = ACTIONS(3512),
    [anon_sym_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_LT_LT_EQ] = ACTIONS(3512),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3512),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(3542),
  },
  [842] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3290),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(3290),
    [anon_sym_RBRACK] = ACTIONS(3290),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3558),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_is] = ACTIONS(3316),
  },
  [843] = {
    [anon_sym_STAR] = ACTIONS(3307),
    [anon_sym_EQ] = ACTIONS(3307),
    [anon_sym_as] = ACTIONS(3309),
    [anon_sym_COMMA] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_in] = ACTIONS(3307),
    [anon_sym_of] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3307),
    [anon_sym_SLASH] = ACTIONS(3307),
    [anon_sym_DOT] = ACTIONS(3309),
    [anon_sym_PLUS_EQ] = ACTIONS(3309),
    [anon_sym_DASH_EQ] = ACTIONS(3309),
    [anon_sym_STAR_EQ] = ACTIONS(3309),
    [anon_sym_SLASH_EQ] = ACTIONS(3309),
    [anon_sym_PERCENT_EQ] = ACTIONS(3309),
    [anon_sym_CARET_EQ] = ACTIONS(3309),
    [anon_sym_AMP_EQ] = ACTIONS(3309),
    [anon_sym_PIPE_EQ] = ACTIONS(3309),
    [anon_sym_GT_GT_EQ] = ACTIONS(3309),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3309),
    [anon_sym_LT_LT_EQ] = ACTIONS(3309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3309),
    [anon_sym_QMARK] = ACTIONS(3309),
    [anon_sym_AMP_AMP] = ACTIONS(3309),
    [anon_sym_PIPE_PIPE] = ACTIONS(3309),
    [anon_sym_GT_GT] = ACTIONS(3307),
    [anon_sym_GT_GT_GT] = ACTIONS(3307),
    [anon_sym_LT_LT] = ACTIONS(3307),
    [anon_sym_AMP] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_PIPE] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3307),
    [anon_sym_PERCENT] = ACTIONS(3307),
    [anon_sym_STAR_STAR] = ACTIONS(3307),
    [anon_sym_LT_EQ] = ACTIONS(3309),
    [anon_sym_EQ_EQ] = ACTIONS(3307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3309),
    [anon_sym_BANG_EQ] = ACTIONS(3307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3309),
    [anon_sym_GT_EQ] = ACTIONS(3309),
    [anon_sym_instanceof] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3307),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3309),
    [sym__automatic_semicolon] = ACTIONS(3309),
  },
  [844] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(3560),
  },
  [845] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3562),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [846] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3209),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_of] = ACTIONS(3209),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3209),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [sym__automatic_semicolon] = ACTIONS(3209),
  },
  [847] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [848] = {
    [sym_arguments] = STATE(1033),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_implements] = ACTIONS(529),
  },
  [849] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_RBRACE] = ACTIONS(3416),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(3416),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2394),
    [sym__automatic_semicolon] = ACTIONS(2394),
  },
  [850] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [851] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3564),
    [anon_sym_EQ_GT] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [852] = {
    [sym_arguments] = STATE(1586),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_EQ_GT] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3265),
    [anon_sym_LT_LT] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3265),
    [anon_sym_STAR_STAR] = ACTIONS(3265),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3269),
  },
  [853] = {
    [sym_arguments] = STATE(1528),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3265),
    [anon_sym_LT_LT] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3265),
    [anon_sym_STAR_STAR] = ACTIONS(3265),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym__automatic_semicolon] = ACTIONS(3269),
  },
  [854] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [855] = {
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_as] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_RBRACE] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_in] = ACTIONS(3037),
    [anon_sym_of] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_GT] = ACTIONS(3037),
    [anon_sym_SLASH] = ACTIONS(3037),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_PLUS_EQ] = ACTIONS(3039),
    [anon_sym_DASH_EQ] = ACTIONS(3039),
    [anon_sym_STAR_EQ] = ACTIONS(3039),
    [anon_sym_SLASH_EQ] = ACTIONS(3039),
    [anon_sym_PERCENT_EQ] = ACTIONS(3039),
    [anon_sym_CARET_EQ] = ACTIONS(3039),
    [anon_sym_AMP_EQ] = ACTIONS(3039),
    [anon_sym_PIPE_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_LT_LT_EQ] = ACTIONS(3039),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_GT_GT] = ACTIONS(3037),
    [anon_sym_GT_GT_GT] = ACTIONS(3037),
    [anon_sym_LT_LT] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_CARET] = ACTIONS(3037),
    [anon_sym_PIPE] = ACTIONS(3037),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_DASH] = ACTIONS(3037),
    [anon_sym_PERCENT] = ACTIONS(3037),
    [anon_sym_STAR_STAR] = ACTIONS(3037),
    [anon_sym_LT_EQ] = ACTIONS(3039),
    [anon_sym_EQ_EQ] = ACTIONS(3037),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3037),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3039),
    [anon_sym_GT_EQ] = ACTIONS(3039),
    [anon_sym_instanceof] = ACTIONS(3039),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3039),
    [sym__automatic_semicolon] = ACTIONS(3039),
  },
  [856] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_RBRACE] = ACTIONS(3422),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1235),
  },
  [857] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(621),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(500),
    [anon_sym_DASH_EQ] = ACTIONS(500),
    [anon_sym_STAR_EQ] = ACTIONS(500),
    [anon_sym_SLASH_EQ] = ACTIONS(500),
    [anon_sym_PERCENT_EQ] = ACTIONS(500),
    [anon_sym_CARET_EQ] = ACTIONS(500),
    [anon_sym_AMP_EQ] = ACTIONS(500),
    [anon_sym_PIPE_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(500),
    [anon_sym_LT_LT_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(500),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [858] = {
    [sym_arguments] = STATE(1589),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(529),
  },
  [859] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_EQ_GT] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3487),
    [anon_sym_DASH_EQ] = ACTIONS(3487),
    [anon_sym_STAR_EQ] = ACTIONS(3487),
    [anon_sym_SLASH_EQ] = ACTIONS(3487),
    [anon_sym_PERCENT_EQ] = ACTIONS(3487),
    [anon_sym_CARET_EQ] = ACTIONS(3487),
    [anon_sym_AMP_EQ] = ACTIONS(3487),
    [anon_sym_PIPE_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_LT_LT_EQ] = ACTIONS(3487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [860] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3532),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3568),
    [anon_sym_EQ_GT] = ACTIONS(3536),
    [anon_sym_PLUS_EQ] = ACTIONS(3538),
    [anon_sym_DASH_EQ] = ACTIONS(3538),
    [anon_sym_STAR_EQ] = ACTIONS(3538),
    [anon_sym_SLASH_EQ] = ACTIONS(3538),
    [anon_sym_PERCENT_EQ] = ACTIONS(3538),
    [anon_sym_CARET_EQ] = ACTIONS(3538),
    [anon_sym_AMP_EQ] = ACTIONS(3538),
    [anon_sym_PIPE_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_LT_LT_EQ] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3538),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [861] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [862] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(654),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [863] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [864] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [865] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [sym__automatic_semicolon] = ACTIONS(3209),
  },
  [866] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [867] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3501),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3514),
    [anon_sym_EQ_GT] = ACTIONS(3510),
    [anon_sym_PLUS_EQ] = ACTIONS(3512),
    [anon_sym_DASH_EQ] = ACTIONS(3512),
    [anon_sym_STAR_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_PERCENT_EQ] = ACTIONS(3512),
    [anon_sym_CARET_EQ] = ACTIONS(3512),
    [anon_sym_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_LT_LT_EQ] = ACTIONS(3512),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3512),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [868] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_LBRACE] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(774),
    [anon_sym_STAR_EQ] = ACTIONS(774),
    [anon_sym_SLASH_EQ] = ACTIONS(774),
    [anon_sym_PERCENT_EQ] = ACTIONS(774),
    [anon_sym_CARET_EQ] = ACTIONS(774),
    [anon_sym_AMP_EQ] = ACTIONS(774),
    [anon_sym_PIPE_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_LT_EQ] = ACTIONS(774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_implements] = ACTIONS(479),
  },
  [869] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [870] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(651),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [871] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [872] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_COLON] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_RBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
  },
  [873] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3416),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [sym__automatic_semicolon] = ACTIONS(3209),
  },
  [874] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3501),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3510),
    [anon_sym_PLUS_EQ] = ACTIONS(3512),
    [anon_sym_DASH_EQ] = ACTIONS(3512),
    [anon_sym_STAR_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_PERCENT_EQ] = ACTIONS(3512),
    [anon_sym_CARET_EQ] = ACTIONS(3512),
    [anon_sym_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_LT_LT_EQ] = ACTIONS(3512),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3512),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [875] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3549),
    [anon_sym_of] = ACTIONS(3552),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(3388),
    [anon_sym_DASH_EQ] = ACTIONS(3388),
    [anon_sym_STAR_EQ] = ACTIONS(3388),
    [anon_sym_SLASH_EQ] = ACTIONS(3388),
    [anon_sym_PERCENT_EQ] = ACTIONS(3388),
    [anon_sym_CARET_EQ] = ACTIONS(3388),
    [anon_sym_AMP_EQ] = ACTIONS(3388),
    [anon_sym_PIPE_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3388),
    [anon_sym_LT_LT_EQ] = ACTIONS(3388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [876] = {
    [sym_arguments] = STATE(1586),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3265),
    [anon_sym_LT_LT] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3265),
    [anon_sym_STAR_STAR] = ACTIONS(3265),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3269),
  },
  [877] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(2605),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3570),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [878] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [879] = {
    [anon_sym_STAR] = ACTIONS(3400),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_as] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_PLUS_EQ] = ACTIONS(3015),
    [anon_sym_DASH_EQ] = ACTIONS(3015),
    [anon_sym_STAR_EQ] = ACTIONS(3015),
    [anon_sym_SLASH_EQ] = ACTIONS(3015),
    [anon_sym_PERCENT_EQ] = ACTIONS(3015),
    [anon_sym_CARET_EQ] = ACTIONS(3015),
    [anon_sym_AMP_EQ] = ACTIONS(3015),
    [anon_sym_PIPE_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_LT_LT_EQ] = ACTIONS(3015),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_GT_GT] = ACTIONS(3400),
    [anon_sym_GT_GT_GT] = ACTIONS(3400),
    [anon_sym_LT_LT] = ACTIONS(3400),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3400),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3400),
    [anon_sym_STAR_STAR] = ACTIONS(3400),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_EQ_EQ] = ACTIONS(3400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_instanceof] = ACTIONS(3402),
    [anon_sym_BANG] = ACTIONS(3400),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3402),
    [sym__automatic_semicolon] = ACTIONS(3402),
  },
  [880] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3572),
    [anon_sym_EQ_GT] = ACTIONS(3485),
    [anon_sym_PLUS_EQ] = ACTIONS(3487),
    [anon_sym_DASH_EQ] = ACTIONS(3487),
    [anon_sym_STAR_EQ] = ACTIONS(3487),
    [anon_sym_SLASH_EQ] = ACTIONS(3487),
    [anon_sym_PERCENT_EQ] = ACTIONS(3487),
    [anon_sym_CARET_EQ] = ACTIONS(3487),
    [anon_sym_AMP_EQ] = ACTIONS(3487),
    [anon_sym_PIPE_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_LT_LT_EQ] = ACTIONS(3487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [881] = {
    [sym_arguments] = STATE(1528),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3536),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3265),
    [anon_sym_LT_LT] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3265),
    [anon_sym_STAR_STAR] = ACTIONS(3265),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym__automatic_semicolon] = ACTIONS(3269),
  },
  [882] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [883] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(758),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_LBRACE] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(660),
    [anon_sym_PLUS_EQ] = ACTIONS(774),
    [anon_sym_DASH_EQ] = ACTIONS(774),
    [anon_sym_STAR_EQ] = ACTIONS(774),
    [anon_sym_SLASH_EQ] = ACTIONS(774),
    [anon_sym_PERCENT_EQ] = ACTIONS(774),
    [anon_sym_CARET_EQ] = ACTIONS(774),
    [anon_sym_AMP_EQ] = ACTIONS(774),
    [anon_sym_PIPE_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(774),
    [anon_sym_LT_LT_EQ] = ACTIONS(774),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(774),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_implements] = ACTIONS(479),
  },
  [884] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3574),
    [anon_sym_COLON] = ACTIONS(3576),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [885] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(3578),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [886] = {
    [sym_arguments] = STATE(1534),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(529),
    [anon_sym_PIPE_PIPE] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(529),
    [anon_sym_GT_EQ] = ACTIONS(529),
    [anon_sym_instanceof] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym__automatic_semicolon] = ACTIONS(529),
  },
  [887] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_COMMA] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_EQ_GT] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(730),
    [anon_sym_DASH_EQ] = ACTIONS(730),
    [anon_sym_STAR_EQ] = ACTIONS(730),
    [anon_sym_SLASH_EQ] = ACTIONS(730),
    [anon_sym_PERCENT_EQ] = ACTIONS(730),
    [anon_sym_CARET_EQ] = ACTIONS(730),
    [anon_sym_AMP_EQ] = ACTIONS(730),
    [anon_sym_PIPE_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(730),
    [anon_sym_LT_LT_EQ] = ACTIONS(730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(730),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [anon_sym_LBRACE_PIPE] = ACTIONS(479),
  },
  [888] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_COLON] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3416),
    [anon_sym_RBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
  },
  [889] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_RPAREN] = ACTIONS(3416),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_COLON] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3416),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
  },
  [890] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_RPAREN] = ACTIONS(3422),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_COLON] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
  },
  [891] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [892] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3501),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(3512),
    [anon_sym_DASH_EQ] = ACTIONS(3512),
    [anon_sym_STAR_EQ] = ACTIONS(3512),
    [anon_sym_SLASH_EQ] = ACTIONS(3512),
    [anon_sym_PERCENT_EQ] = ACTIONS(3512),
    [anon_sym_CARET_EQ] = ACTIONS(3512),
    [anon_sym_AMP_EQ] = ACTIONS(3512),
    [anon_sym_PIPE_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3512),
    [anon_sym_LT_LT_EQ] = ACTIONS(3512),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3512),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [893] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3474),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(3487),
    [anon_sym_DASH_EQ] = ACTIONS(3487),
    [anon_sym_STAR_EQ] = ACTIONS(3487),
    [anon_sym_SLASH_EQ] = ACTIONS(3487),
    [anon_sym_PERCENT_EQ] = ACTIONS(3487),
    [anon_sym_CARET_EQ] = ACTIONS(3487),
    [anon_sym_AMP_EQ] = ACTIONS(3487),
    [anon_sym_PIPE_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3487),
    [anon_sym_LT_LT_EQ] = ACTIONS(3487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3487),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [894] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(1624),
    [anon_sym_EQ_GT] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
    [sym__automatic_semicolon] = ACTIONS(479),
  },
  [895] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3416),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3209),
  },
  [896] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_COMMA] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3209),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3209),
  },
  [897] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3532),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_EQ_GT] = ACTIONS(3536),
    [anon_sym_PLUS_EQ] = ACTIONS(3538),
    [anon_sym_DASH_EQ] = ACTIONS(3538),
    [anon_sym_STAR_EQ] = ACTIONS(3538),
    [anon_sym_SLASH_EQ] = ACTIONS(3538),
    [anon_sym_PERCENT_EQ] = ACTIONS(3538),
    [anon_sym_CARET_EQ] = ACTIONS(3538),
    [anon_sym_AMP_EQ] = ACTIONS(3538),
    [anon_sym_PIPE_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_LT_LT_EQ] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3538),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [898] = {
    [anon_sym_STAR] = ACTIONS(3400),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_as] = ACTIONS(3402),
    [anon_sym_LBRACE] = ACTIONS(3400),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_PLUS_EQ] = ACTIONS(3015),
    [anon_sym_DASH_EQ] = ACTIONS(3015),
    [anon_sym_STAR_EQ] = ACTIONS(3015),
    [anon_sym_SLASH_EQ] = ACTIONS(3015),
    [anon_sym_PERCENT_EQ] = ACTIONS(3015),
    [anon_sym_CARET_EQ] = ACTIONS(3015),
    [anon_sym_AMP_EQ] = ACTIONS(3015),
    [anon_sym_PIPE_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_LT_LT_EQ] = ACTIONS(3015),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_GT_GT] = ACTIONS(3400),
    [anon_sym_GT_GT_GT] = ACTIONS(3400),
    [anon_sym_LT_LT] = ACTIONS(3400),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3400),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3400),
    [anon_sym_STAR_STAR] = ACTIONS(3400),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_EQ_EQ] = ACTIONS(3400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_instanceof] = ACTIONS(3402),
    [anon_sym_BANG] = ACTIONS(3400),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3402),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3402),
  },
  [899] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3209),
  },
  [900] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(575),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(575),
    [anon_sym_RBRACK] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(547),
    [anon_sym_PLUS_EQ] = ACTIONS(599),
    [anon_sym_DASH_EQ] = ACTIONS(599),
    [anon_sym_STAR_EQ] = ACTIONS(599),
    [anon_sym_SLASH_EQ] = ACTIONS(599),
    [anon_sym_PERCENT_EQ] = ACTIONS(599),
    [anon_sym_CARET_EQ] = ACTIONS(599),
    [anon_sym_AMP_EQ] = ACTIONS(599),
    [anon_sym_PIPE_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(599),
    [anon_sym_LT_LT_EQ] = ACTIONS(599),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(599),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [901] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3288),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_RBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3580),
    [anon_sym_EQ_GT] = ACTIONS(3298),
    [anon_sym_PLUS_EQ] = ACTIONS(3300),
    [anon_sym_DASH_EQ] = ACTIONS(3300),
    [anon_sym_STAR_EQ] = ACTIONS(3300),
    [anon_sym_SLASH_EQ] = ACTIONS(3300),
    [anon_sym_PERCENT_EQ] = ACTIONS(3300),
    [anon_sym_CARET_EQ] = ACTIONS(3300),
    [anon_sym_AMP_EQ] = ACTIONS(3300),
    [anon_sym_PIPE_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3300),
    [anon_sym_LT_LT_EQ] = ACTIONS(3300),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3300),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [902] = {
    [anon_sym_STAR] = ACTIONS(3307),
    [anon_sym_EQ] = ACTIONS(3307),
    [anon_sym_as] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3307),
    [anon_sym_COMMA] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_in] = ACTIONS(3307),
    [anon_sym_LBRACK] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3307),
    [anon_sym_SLASH] = ACTIONS(3307),
    [anon_sym_DOT] = ACTIONS(3309),
    [anon_sym_PLUS_EQ] = ACTIONS(3309),
    [anon_sym_DASH_EQ] = ACTIONS(3309),
    [anon_sym_STAR_EQ] = ACTIONS(3309),
    [anon_sym_SLASH_EQ] = ACTIONS(3309),
    [anon_sym_PERCENT_EQ] = ACTIONS(3309),
    [anon_sym_CARET_EQ] = ACTIONS(3309),
    [anon_sym_AMP_EQ] = ACTIONS(3309),
    [anon_sym_PIPE_EQ] = ACTIONS(3309),
    [anon_sym_GT_GT_EQ] = ACTIONS(3309),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3309),
    [anon_sym_LT_LT_EQ] = ACTIONS(3309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3309),
    [anon_sym_QMARK] = ACTIONS(3309),
    [anon_sym_AMP_AMP] = ACTIONS(3309),
    [anon_sym_PIPE_PIPE] = ACTIONS(3309),
    [anon_sym_GT_GT] = ACTIONS(3307),
    [anon_sym_GT_GT_GT] = ACTIONS(3307),
    [anon_sym_LT_LT] = ACTIONS(3307),
    [anon_sym_AMP] = ACTIONS(3307),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_PIPE] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3307),
    [anon_sym_PERCENT] = ACTIONS(3307),
    [anon_sym_STAR_STAR] = ACTIONS(3307),
    [anon_sym_LT_EQ] = ACTIONS(3309),
    [anon_sym_EQ_EQ] = ACTIONS(3307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3309),
    [anon_sym_BANG_EQ] = ACTIONS(3307),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3309),
    [anon_sym_GT_EQ] = ACTIONS(3309),
    [anon_sym_instanceof] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3307),
    [anon_sym_PLUS_PLUS] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3309),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3309),
  },
  [903] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3574),
    [anon_sym_COLON] = ACTIONS(3576),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [904] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3416),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_implements] = ACTIONS(3416),
  },
  [905] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3416),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [sym__automatic_semicolon] = ACTIONS(3209),
  },
  [906] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [sym__automatic_semicolon] = ACTIONS(3209),
  },
  [907] = {
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_as] = ACTIONS(3039),
    [anon_sym_LBRACE] = ACTIONS(3037),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_in] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_GT] = ACTIONS(3037),
    [anon_sym_SLASH] = ACTIONS(3037),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_PLUS_EQ] = ACTIONS(3039),
    [anon_sym_DASH_EQ] = ACTIONS(3039),
    [anon_sym_STAR_EQ] = ACTIONS(3039),
    [anon_sym_SLASH_EQ] = ACTIONS(3039),
    [anon_sym_PERCENT_EQ] = ACTIONS(3039),
    [anon_sym_CARET_EQ] = ACTIONS(3039),
    [anon_sym_AMP_EQ] = ACTIONS(3039),
    [anon_sym_PIPE_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_LT_LT_EQ] = ACTIONS(3039),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_GT_GT] = ACTIONS(3037),
    [anon_sym_GT_GT_GT] = ACTIONS(3037),
    [anon_sym_LT_LT] = ACTIONS(3037),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_CARET] = ACTIONS(3037),
    [anon_sym_PIPE] = ACTIONS(3037),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_DASH] = ACTIONS(3037),
    [anon_sym_PERCENT] = ACTIONS(3037),
    [anon_sym_STAR_STAR] = ACTIONS(3037),
    [anon_sym_LT_EQ] = ACTIONS(3039),
    [anon_sym_EQ_EQ] = ACTIONS(3037),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3039),
    [anon_sym_BANG_EQ] = ACTIONS(3037),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3039),
    [anon_sym_GT_EQ] = ACTIONS(3039),
    [anon_sym_instanceof] = ACTIONS(3039),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3039),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3039),
  },
  [908] = {
    [anon_sym_STAR] = ACTIONS(3261),
    [anon_sym_EQ] = ACTIONS(3261),
    [anon_sym_as] = ACTIONS(3263),
    [anon_sym_LBRACE] = ACTIONS(3261),
    [anon_sym_COMMA] = ACTIONS(3263),
    [anon_sym_LPAREN] = ACTIONS(3263),
    [anon_sym_in] = ACTIONS(3261),
    [anon_sym_LBRACK] = ACTIONS(3263),
    [anon_sym_LT] = ACTIONS(3261),
    [anon_sym_GT] = ACTIONS(3261),
    [anon_sym_SLASH] = ACTIONS(3261),
    [anon_sym_DOT] = ACTIONS(3263),
    [anon_sym_PLUS_EQ] = ACTIONS(3263),
    [anon_sym_DASH_EQ] = ACTIONS(3263),
    [anon_sym_STAR_EQ] = ACTIONS(3263),
    [anon_sym_SLASH_EQ] = ACTIONS(3263),
    [anon_sym_PERCENT_EQ] = ACTIONS(3263),
    [anon_sym_CARET_EQ] = ACTIONS(3263),
    [anon_sym_AMP_EQ] = ACTIONS(3263),
    [anon_sym_PIPE_EQ] = ACTIONS(3263),
    [anon_sym_GT_GT_EQ] = ACTIONS(3263),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3263),
    [anon_sym_LT_LT_EQ] = ACTIONS(3263),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3263),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP_AMP] = ACTIONS(3263),
    [anon_sym_PIPE_PIPE] = ACTIONS(3263),
    [anon_sym_GT_GT] = ACTIONS(3261),
    [anon_sym_GT_GT_GT] = ACTIONS(3261),
    [anon_sym_LT_LT] = ACTIONS(3261),
    [anon_sym_AMP] = ACTIONS(3261),
    [anon_sym_CARET] = ACTIONS(3261),
    [anon_sym_PIPE] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3261),
    [anon_sym_DASH] = ACTIONS(3261),
    [anon_sym_PERCENT] = ACTIONS(3261),
    [anon_sym_STAR_STAR] = ACTIONS(3261),
    [anon_sym_LT_EQ] = ACTIONS(3263),
    [anon_sym_EQ_EQ] = ACTIONS(3261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3263),
    [anon_sym_BANG_EQ] = ACTIONS(3261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3263),
    [anon_sym_GT_EQ] = ACTIONS(3263),
    [anon_sym_instanceof] = ACTIONS(3263),
    [anon_sym_BANG] = ACTIONS(3261),
    [anon_sym_PLUS_PLUS] = ACTIONS(3263),
    [anon_sym_DASH_DASH] = ACTIONS(3263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3263),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3263),
  },
  [909] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_RBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [910] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3416),
  },
  [911] = {
    [anon_sym_STAR] = ACTIONS(3013),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_as] = ACTIONS(3015),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_in] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3015),
    [anon_sym_LT] = ACTIONS(3013),
    [anon_sym_GT] = ACTIONS(3013),
    [anon_sym_SLASH] = ACTIONS(3013),
    [anon_sym_DOT] = ACTIONS(3015),
    [anon_sym_PLUS_EQ] = ACTIONS(3015),
    [anon_sym_DASH_EQ] = ACTIONS(3015),
    [anon_sym_STAR_EQ] = ACTIONS(3015),
    [anon_sym_SLASH_EQ] = ACTIONS(3015),
    [anon_sym_PERCENT_EQ] = ACTIONS(3015),
    [anon_sym_CARET_EQ] = ACTIONS(3015),
    [anon_sym_AMP_EQ] = ACTIONS(3015),
    [anon_sym_PIPE_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3015),
    [anon_sym_LT_LT_EQ] = ACTIONS(3015),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_GT_GT] = ACTIONS(3013),
    [anon_sym_GT_GT_GT] = ACTIONS(3013),
    [anon_sym_LT_LT] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_CARET] = ACTIONS(3013),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_PERCENT] = ACTIONS(3013),
    [anon_sym_STAR_STAR] = ACTIONS(3013),
    [anon_sym_LT_EQ] = ACTIONS(3015),
    [anon_sym_EQ_EQ] = ACTIONS(3013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3015),
    [anon_sym_BANG_EQ] = ACTIONS(3013),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3015),
    [anon_sym_GT_EQ] = ACTIONS(3015),
    [anon_sym_instanceof] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3015),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3015),
  },
  [912] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(623),
    [anon_sym_of] = ACTIONS(3554),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [913] = {
    [sym_export_statement] = STATE(2152),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2152),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2152),
    [sym_property_signature] = STATE(2152),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2152),
    [sym_index_signature] = STATE(2152),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_RBRACE] = ACTIONS(3103),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3103),
  },
  [914] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3416),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3416),
    [anon_sym_RBRACK] = ACTIONS(3416),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3419),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
  },
  [915] = {
    [sym_export_statement] = STATE(2136),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2136),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2136),
    [sym_property_signature] = STATE(2136),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2136),
    [sym_index_signature] = STATE(2136),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3602),
    [anon_sym_RBRACE] = ACTIONS(3604),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3604),
  },
  [916] = {
    [sym_export_clause] = STATE(2501),
    [sym__declaration] = STATE(2219),
    [sym_variable_declaration] = STATE(2219),
    [sym_lexical_declaration] = STATE(2219),
    [sym_class_declaration] = STATE(2219),
    [sym_function_declaration] = STATE(2219),
    [sym_generator_function_declaration] = STATE(2219),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(2219),
    [sym_ambient_declaration] = STATE(2219),
    [sym_abstract_class_declaration] = STATE(2219),
    [sym_module] = STATE(2219),
    [sym_internal_module] = STATE(2219),
    [sym_import_alias] = STATE(2219),
    [sym_interface_declaration] = STATE(2219),
    [sym_enum_declaration] = STATE(2219),
    [sym_type_alias_declaration] = STATE(2219),
    [aux_sym_export_statement_repeat1] = STATE(2526),
    [aux_sym_object_repeat1] = STATE(2602),
    [anon_sym_STAR] = ACTIONS(3606),
    [anon_sym_default] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_as] = ACTIONS(3612),
    [anon_sym_namespace] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3620),
    [anon_sym_var] = ACTIONS(3622),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_const] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_class] = ACTIONS(3628),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_function] = ACTIONS(3632),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3634),
    [anon_sym_declare] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(3638),
    [anon_sym_interface] = ACTIONS(3640),
    [anon_sym_enum] = ACTIONS(3642),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [917] = {
    [sym_export_clause] = STATE(2501),
    [sym__declaration] = STATE(2219),
    [sym_variable_declaration] = STATE(2219),
    [sym_lexical_declaration] = STATE(2219),
    [sym_class_declaration] = STATE(2219),
    [sym_function_declaration] = STATE(2219),
    [sym_generator_function_declaration] = STATE(2219),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(2219),
    [sym_ambient_declaration] = STATE(2219),
    [sym_abstract_class_declaration] = STATE(2219),
    [sym_module] = STATE(2219),
    [sym_internal_module] = STATE(2219),
    [sym_import_alias] = STATE(2219),
    [sym_interface_declaration] = STATE(2219),
    [sym_enum_declaration] = STATE(2219),
    [sym_type_alias_declaration] = STATE(2219),
    [aux_sym_export_statement_repeat1] = STATE(2526),
    [aux_sym_object_repeat1] = STATE(2671),
    [anon_sym_STAR] = ACTIONS(3606),
    [anon_sym_default] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_as] = ACTIONS(3612),
    [anon_sym_namespace] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3620),
    [anon_sym_var] = ACTIONS(3622),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_const] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_class] = ACTIONS(3628),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_function] = ACTIONS(3632),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3634),
    [anon_sym_declare] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(3638),
    [anon_sym_interface] = ACTIONS(3640),
    [anon_sym_enum] = ACTIONS(3642),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [918] = {
    [sym_export_statement] = STATE(2131),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2131),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2131),
    [sym_property_signature] = STATE(2131),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2131),
    [sym_index_signature] = STATE(2131),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_RBRACE] = ACTIONS(3143),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3143),
  },
  [919] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3549),
    [anon_sym_of] = ACTIONS(3552),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [920] = {
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(523),
    [anon_sym_as] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(790),
    [anon_sym_of] = ACTIONS(3644),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(471),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(2567),
    [anon_sym_EQ_GT] = ACTIONS(619),
    [anon_sym_PLUS_EQ] = ACTIONS(551),
    [anon_sym_DASH_EQ] = ACTIONS(551),
    [anon_sym_STAR_EQ] = ACTIONS(551),
    [anon_sym_SLASH_EQ] = ACTIONS(551),
    [anon_sym_PERCENT_EQ] = ACTIONS(551),
    [anon_sym_CARET_EQ] = ACTIONS(551),
    [anon_sym_AMP_EQ] = ACTIONS(551),
    [anon_sym_PIPE_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(551),
    [anon_sym_LT_LT_EQ] = ACTIONS(551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(551),
    [anon_sym_QMARK] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(479),
    [anon_sym_PIPE_PIPE] = ACTIONS(479),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_PERCENT] = ACTIONS(471),
    [anon_sym_STAR_STAR] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(479),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(479),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(479),
    [anon_sym_GT_EQ] = ACTIONS(479),
    [anon_sym_instanceof] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(471),
    [anon_sym_PLUS_PLUS] = ACTIONS(479),
    [anon_sym_DASH_DASH] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(479),
  },
  [921] = {
    [sym_export_clause] = STATE(2501),
    [sym__declaration] = STATE(2219),
    [sym_variable_declaration] = STATE(2219),
    [sym_lexical_declaration] = STATE(2219),
    [sym_class_declaration] = STATE(2219),
    [sym_function_declaration] = STATE(2219),
    [sym_generator_function_declaration] = STATE(2219),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(2219),
    [sym_ambient_declaration] = STATE(2219),
    [sym_abstract_class_declaration] = STATE(2219),
    [sym_module] = STATE(2219),
    [sym_internal_module] = STATE(2219),
    [sym_import_alias] = STATE(2219),
    [sym_interface_declaration] = STATE(2219),
    [sym_enum_declaration] = STATE(2219),
    [sym_type_alias_declaration] = STATE(2219),
    [aux_sym_export_statement_repeat1] = STATE(2526),
    [aux_sym_object_repeat1] = STATE(2718),
    [anon_sym_STAR] = ACTIONS(3606),
    [anon_sym_default] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_as] = ACTIONS(3612),
    [anon_sym_namespace] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3620),
    [anon_sym_var] = ACTIONS(3622),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_const] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_class] = ACTIONS(3628),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_function] = ACTIONS(3632),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3634),
    [anon_sym_declare] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(3638),
    [anon_sym_interface] = ACTIONS(3640),
    [anon_sym_enum] = ACTIONS(3642),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [922] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3532),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(3538),
    [anon_sym_DASH_EQ] = ACTIONS(3538),
    [anon_sym_STAR_EQ] = ACTIONS(3538),
    [anon_sym_SLASH_EQ] = ACTIONS(3538),
    [anon_sym_PERCENT_EQ] = ACTIONS(3538),
    [anon_sym_CARET_EQ] = ACTIONS(3538),
    [anon_sym_AMP_EQ] = ACTIONS(3538),
    [anon_sym_PIPE_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_LT_LT_EQ] = ACTIONS(3538),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3538),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [923] = {
    [sym_export_statement] = STATE(2153),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2153),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2153),
    [sym_property_signature] = STATE(2153),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2153),
    [sym_index_signature] = STATE(2153),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3646),
    [anon_sym_RBRACE] = ACTIONS(3648),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3646),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3648),
  },
  [924] = {
    [sym_export_clause] = STATE(2501),
    [sym__declaration] = STATE(2219),
    [sym_variable_declaration] = STATE(2219),
    [sym_lexical_declaration] = STATE(2219),
    [sym_class_declaration] = STATE(2219),
    [sym_function_declaration] = STATE(2219),
    [sym_generator_function_declaration] = STATE(2219),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(2219),
    [sym_ambient_declaration] = STATE(2219),
    [sym_abstract_class_declaration] = STATE(2219),
    [sym_module] = STATE(2219),
    [sym_internal_module] = STATE(2219),
    [sym_import_alias] = STATE(2219),
    [sym_interface_declaration] = STATE(2219),
    [sym_enum_declaration] = STATE(2219),
    [sym_type_alias_declaration] = STATE(2219),
    [aux_sym_export_statement_repeat1] = STATE(2526),
    [aux_sym_object_repeat1] = STATE(2645),
    [anon_sym_STAR] = ACTIONS(3606),
    [anon_sym_default] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_as] = ACTIONS(3612),
    [anon_sym_namespace] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3620),
    [anon_sym_var] = ACTIONS(3622),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_const] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_class] = ACTIONS(3628),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_function] = ACTIONS(3632),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3634),
    [anon_sym_declare] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(3638),
    [anon_sym_interface] = ACTIONS(3640),
    [anon_sym_enum] = ACTIONS(3642),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [925] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3277),
    [anon_sym_of] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_EQ_GT] = ACTIONS(3286),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [926] = {
    [sym_export_statement] = STATE(2185),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2185),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2185),
    [sym_property_signature] = STATE(2185),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2185),
    [sym_index_signature] = STATE(2185),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3650),
    [anon_sym_RBRACE] = ACTIONS(3652),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3650),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3652),
  },
  [927] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_RBRACK] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3422),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
  },
  [928] = {
    [sym_import_clause] = STATE(2930),
    [sym_namespace_import] = STATE(3028),
    [sym_named_imports] = STATE(3028),
    [sym_string] = STATE(2932),
    [sym_import_require_clause] = STATE(2932),
    [sym_identifier] = ACTIONS(3654),
    [anon_sym_STAR] = ACTIONS(3656),
    [anon_sym_as] = ACTIONS(3658),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_type] = ACTIONS(3664),
    [anon_sym_typeof] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3658),
    [anon_sym_SEMI] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_GT] = ACTIONS(3658),
    [anon_sym_SLASH] = ACTIONS(3658),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3658),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3658),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_STAR_STAR] = ACTIONS(3662),
    [anon_sym_LT_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3658),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ] = ACTIONS(3658),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3662),
    [anon_sym_GT_EQ] = ACTIONS(3662),
    [anon_sym_instanceof] = ACTIONS(3658),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_PLUS_PLUS] = ACTIONS(3662),
    [anon_sym_DASH_DASH] = ACTIONS(3662),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3662),
    [sym__automatic_semicolon] = ACTIONS(3662),
  },
  [929] = {
    [sym_export_clause] = STATE(2501),
    [sym__declaration] = STATE(2219),
    [sym_variable_declaration] = STATE(2219),
    [sym_lexical_declaration] = STATE(2219),
    [sym_class_declaration] = STATE(2219),
    [sym_function_declaration] = STATE(2219),
    [sym_generator_function_declaration] = STATE(2219),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(2219),
    [sym_ambient_declaration] = STATE(2219),
    [sym_abstract_class_declaration] = STATE(2219),
    [sym_module] = STATE(2219),
    [sym_internal_module] = STATE(2219),
    [sym_import_alias] = STATE(2219),
    [sym_interface_declaration] = STATE(2219),
    [sym_enum_declaration] = STATE(2219),
    [sym_type_alias_declaration] = STATE(2219),
    [aux_sym_export_statement_repeat1] = STATE(2526),
    [anon_sym_STAR] = ACTIONS(3606),
    [anon_sym_default] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3666),
    [anon_sym_as] = ACTIONS(3612),
    [anon_sym_namespace] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3620),
    [anon_sym_var] = ACTIONS(3622),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_const] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_class] = ACTIONS(3628),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_function] = ACTIONS(3632),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3634),
    [anon_sym_declare] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(3638),
    [anon_sym_interface] = ACTIONS(3640),
    [anon_sym_enum] = ACTIONS(3642),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [930] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3549),
    [anon_sym_of] = ACTIONS(3552),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [931] = {
    [sym_export_clause] = STATE(2501),
    [sym__declaration] = STATE(2219),
    [sym_variable_declaration] = STATE(2219),
    [sym_lexical_declaration] = STATE(2219),
    [sym_class_declaration] = STATE(2219),
    [sym_function_declaration] = STATE(2219),
    [sym_generator_function_declaration] = STATE(2219),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(2219),
    [sym_ambient_declaration] = STATE(2219),
    [sym_abstract_class_declaration] = STATE(2219),
    [sym_module] = STATE(2219),
    [sym_internal_module] = STATE(2219),
    [sym_import_alias] = STATE(2219),
    [sym_interface_declaration] = STATE(2219),
    [sym_enum_declaration] = STATE(2219),
    [sym_type_alias_declaration] = STATE(2219),
    [aux_sym_export_statement_repeat1] = STATE(2526),
    [anon_sym_STAR] = ACTIONS(3606),
    [anon_sym_default] = ACTIONS(3608),
    [anon_sym_EQ] = ACTIONS(3610),
    [anon_sym_as] = ACTIONS(3612),
    [anon_sym_namespace] = ACTIONS(3614),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3620),
    [anon_sym_var] = ACTIONS(3622),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_const] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_class] = ACTIONS(3628),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_function] = ACTIONS(3632),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3634),
    [anon_sym_declare] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(3638),
    [anon_sym_interface] = ACTIONS(3640),
    [anon_sym_enum] = ACTIONS(3642),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [932] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3277),
    [anon_sym_of] = ACTIONS(3280),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_PLUS_EQ] = ACTIONS(3271),
    [anon_sym_DASH_EQ] = ACTIONS(3271),
    [anon_sym_STAR_EQ] = ACTIONS(3271),
    [anon_sym_SLASH_EQ] = ACTIONS(3271),
    [anon_sym_PERCENT_EQ] = ACTIONS(3271),
    [anon_sym_CARET_EQ] = ACTIONS(3271),
    [anon_sym_AMP_EQ] = ACTIONS(3271),
    [anon_sym_PIPE_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3271),
    [anon_sym_LT_LT_EQ] = ACTIONS(3271),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [933] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3671),
  },
  [934] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3673),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3673),
  },
  [935] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3675),
  },
  [936] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3677),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3677),
  },
  [937] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3679),
  },
  [938] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3681),
  },
  [939] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3683),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3683),
  },
  [940] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3685),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3685),
  },
  [941] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3687),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3687),
  },
  [942] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3689),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3689),
  },
  [943] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3691),
  },
  [944] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3693),
  },
  [945] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3695),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3695),
  },
  [946] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3697),
  },
  [947] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3699),
  },
  [948] = {
    [sym_export_statement] = STATE(2175),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2175),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2175),
    [sym_property_signature] = STATE(2175),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2175),
    [sym_index_signature] = STATE(2175),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
  },
  [949] = {
    [sym_export_statement] = STATE(2138),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2138),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2138),
    [sym_property_signature] = STATE(2138),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2138),
    [sym_index_signature] = STATE(2138),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
  },
  [950] = {
    [sym_export_statement] = STATE(2118),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2118),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2118),
    [sym_property_signature] = STATE(2118),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2118),
    [sym_index_signature] = STATE(2118),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
  },
  [951] = {
    [sym_export_statement] = STATE(2230),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2230),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2230),
    [sym_property_signature] = STATE(2230),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2230),
    [sym_index_signature] = STATE(2230),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
  },
  [952] = {
    [sym_export_statement] = STATE(2125),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2125),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2125),
    [sym_property_signature] = STATE(2125),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2125),
    [sym_index_signature] = STATE(2125),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
  },
  [953] = {
    [sym_export_statement] = STATE(2163),
    [sym__call_signature] = STATE(2436),
    [sym_string] = STATE(1884),
    [sym_decorator] = STATE(1854),
    [sym_formal_parameters] = STATE(2034),
    [sym__property_name] = STATE(1884),
    [sym_computed_property_name] = STATE(1884),
    [sym_method_signature] = STATE(2163),
    [sym_accessibility_modifier] = STATE(1824),
    [sym_call_signature] = STATE(2163),
    [sym_property_signature] = STATE(2163),
    [sym_type_parameters] = STATE(2892),
    [sym_construct_signature] = STATE(2163),
    [sym_index_signature] = STATE(2163),
    [aux_sym_export_statement_repeat1] = STATE(2456),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3584),
    [anon_sym_STAR] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_async] = ACTIONS(3590),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3592),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3594),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3600),
  },
  [954] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1036),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_COLON] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_RBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_implements] = ACTIONS(3269),
  },
  [955] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [956] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [957] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3709),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_RPAREN] = ACTIONS(3709),
    [anon_sym_in] = ACTIONS(3705),
    [anon_sym_COLON] = ACTIONS(3709),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3709),
    [anon_sym_LT] = ACTIONS(3705),
    [anon_sym_GT] = ACTIONS(3705),
    [anon_sym_SLASH] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_GT_GT] = ACTIONS(3705),
    [anon_sym_GT_GT_GT] = ACTIONS(3709),
    [anon_sym_LT_LT] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_CARET] = ACTIONS(3709),
    [anon_sym_PIPE] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_STAR_STAR] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_EQ_EQ] = ACTIONS(3705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_instanceof] = ACTIONS(3709),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3709),
    [anon_sym_implements] = ACTIONS(3709),
  },
  [958] = {
    [sym_arguments] = STATE(1035),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_COLON] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_RBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_implements] = ACTIONS(3269),
  },
  [959] = {
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_EQ] = ACTIONS(3713),
    [anon_sym_as] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_RPAREN] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3713),
    [anon_sym_of] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_RBRACK] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3713),
    [anon_sym_GT] = ACTIONS(3713),
    [anon_sym_SLASH] = ACTIONS(3713),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_GT_GT] = ACTIONS(3713),
    [anon_sym_GT_GT_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(3713),
    [anon_sym_CARET] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(3713),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_EQ_EQ] = ACTIONS(3713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3715),
    [anon_sym_BANG_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3715),
    [anon_sym_instanceof] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [anon_sym_implements] = ACTIONS(3715),
  },
  [960] = {
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3717),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3717),
    [anon_sym_of] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_RBRACK] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3717),
    [anon_sym_GT] = ACTIONS(3717),
    [anon_sym_SLASH] = ACTIONS(3717),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3717),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_AMP] = ACTIONS(3717),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3717),
    [anon_sym_PLUS] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3717),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_STAR_STAR] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3717),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_instanceof] = ACTIONS(3719),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3719),
    [anon_sym_implements] = ACTIONS(3719),
  },
  [961] = {
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3723),
    [anon_sym_COMMA] = ACTIONS(3723),
    [anon_sym_RBRACE] = ACTIONS(3723),
    [anon_sym_LPAREN] = ACTIONS(3723),
    [anon_sym_RPAREN] = ACTIONS(3723),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_of] = ACTIONS(3723),
    [anon_sym_COLON] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [anon_sym_RBRACK] = ACTIONS(3723),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3723),
    [anon_sym_QMARK] = ACTIONS(3723),
    [anon_sym_AMP_AMP] = ACTIONS(3723),
    [anon_sym_PIPE_PIPE] = ACTIONS(3723),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3723),
    [anon_sym_LT_LT] = ACTIONS(3723),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3723),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3723),
    [anon_sym_STAR_STAR] = ACTIONS(3723),
    [anon_sym_LT_EQ] = ACTIONS(3723),
    [anon_sym_EQ_EQ] = ACTIONS(3721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3723),
    [anon_sym_BANG_EQ] = ACTIONS(3721),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3723),
    [anon_sym_GT_EQ] = ACTIONS(3723),
    [anon_sym_instanceof] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(3723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3723),
    [anon_sym_implements] = ACTIONS(3723),
  },
  [962] = {
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_EQ] = ACTIONS(3725),
    [anon_sym_as] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(3727),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(3725),
    [anon_sym_of] = ACTIONS(3727),
    [anon_sym_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_RBRACK] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3725),
    [anon_sym_GT] = ACTIONS(3725),
    [anon_sym_SLASH] = ACTIONS(3725),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_QMARK] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_GT_GT] = ACTIONS(3725),
    [anon_sym_GT_GT_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_CARET] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_EQ_EQ] = ACTIONS(3725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3727),
    [anon_sym_BANG_EQ] = ACTIONS(3725),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3727),
    [anon_sym_instanceof] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3727),
    [anon_sym_implements] = ACTIONS(3727),
  },
  [963] = {
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_EQ] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_of] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_RBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3729),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3731),
    [anon_sym_implements] = ACTIONS(3731),
  },
  [964] = {
    [sym_arguments] = STATE(1035),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3733),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_COLON] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_RBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_implements] = ACTIONS(3269),
  },
  [965] = {
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_else] = ACTIONS(1167),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_in] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1167),
    [sym__automatic_semicolon] = ACTIONS(1167),
  },
  [966] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1103),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_COLON] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_implements] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(3735),
  },
  [967] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_of] = ACTIONS(1109),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_implements] = ACTIONS(1109),
  },
  [968] = {
    [sym_type_arguments] = STATE(1158),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_as] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_RPAREN] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_COLON] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_RBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(3737),
    [anon_sym_GT] = ACTIONS(2534),
    [anon_sym_SLASH] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(3740),
    [anon_sym_QMARK] = ACTIONS(2532),
    [anon_sym_AMP_AMP] = ACTIONS(2532),
    [anon_sym_PIPE_PIPE] = ACTIONS(2532),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_GT_GT_GT] = ACTIONS(2532),
    [anon_sym_LT_LT] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2534),
    [anon_sym_CARET] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_PERCENT] = ACTIONS(2532),
    [anon_sym_STAR_STAR] = ACTIONS(2532),
    [anon_sym_LT_EQ] = ACTIONS(2532),
    [anon_sym_EQ_EQ] = ACTIONS(2534),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2532),
    [anon_sym_BANG_EQ] = ACTIONS(2534),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2532),
    [anon_sym_GT_EQ] = ACTIONS(2532),
    [anon_sym_instanceof] = ACTIONS(2532),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [anon_sym_implements] = ACTIONS(2532),
    [anon_sym_is] = ACTIONS(3742),
  },
  [969] = {
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_else] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_instanceof] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1163),
    [sym__automatic_semicolon] = ACTIONS(1163),
  },
  [970] = {
    [anon_sym_STAR] = ACTIONS(3744),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_as] = ACTIONS(3746),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3746),
    [anon_sym_RBRACE] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_RPAREN] = ACTIONS(3746),
    [anon_sym_in] = ACTIONS(3744),
    [anon_sym_of] = ACTIONS(3746),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_RBRACK] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_GT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3744),
    [anon_sym_GT_GT_GT] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_PIPE] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_STAR_STAR] = ACTIONS(3746),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3746),
    [anon_sym_instanceof] = ACTIONS(3746),
    [anon_sym_BANG] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3746),
    [anon_sym_implements] = ACTIONS(3746),
  },
  [971] = {
    [anon_sym_STAR] = ACTIONS(3748),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_as] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [anon_sym_LPAREN] = ACTIONS(3750),
    [anon_sym_RPAREN] = ACTIONS(3750),
    [anon_sym_in] = ACTIONS(3748),
    [anon_sym_of] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [anon_sym_RBRACK] = ACTIONS(3750),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_GT] = ACTIONS(3748),
    [anon_sym_SLASH] = ACTIONS(3748),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_QMARK] = ACTIONS(3750),
    [anon_sym_AMP_AMP] = ACTIONS(3750),
    [anon_sym_PIPE_PIPE] = ACTIONS(3750),
    [anon_sym_GT_GT] = ACTIONS(3748),
    [anon_sym_GT_GT_GT] = ACTIONS(3750),
    [anon_sym_LT_LT] = ACTIONS(3750),
    [anon_sym_AMP] = ACTIONS(3748),
    [anon_sym_CARET] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3748),
    [anon_sym_PLUS] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3748),
    [anon_sym_PERCENT] = ACTIONS(3750),
    [anon_sym_STAR_STAR] = ACTIONS(3750),
    [anon_sym_LT_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ] = ACTIONS(3748),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ] = ACTIONS(3748),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3750),
    [anon_sym_GT_EQ] = ACTIONS(3750),
    [anon_sym_instanceof] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3748),
    [anon_sym_PLUS_PLUS] = ACTIONS(3750),
    [anon_sym_DASH_DASH] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3750),
    [anon_sym_implements] = ACTIONS(3750),
  },
  [972] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3754),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3754),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [973] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3782),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3782),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [974] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [975] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [976] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [977] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [978] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3793),
    [anon_sym_RBRACE] = ACTIONS(3793),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3793),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3793),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3793),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [979] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_nested_type_identifier] = STATE(2044),
    [sym__primary_type] = STATE(449),
    [sym_generic_type] = STATE(449),
    [sym_type_predicate] = STATE(449),
    [sym_type_query] = STATE(449),
    [sym_index_type_query] = STATE(449),
    [sym_lookup_type] = STATE(449),
    [sym_literal_type] = STATE(449),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(449),
    [sym_flow_maybe_type] = STATE(449),
    [sym_parenthesized_type] = STATE(449),
    [sym_predefined_type] = STATE(449),
    [sym_object_type] = STATE(449),
    [sym_array_type] = STATE(449),
    [sym_tuple_type] = STATE(449),
    [sym_identifier] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(3446),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3797),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [980] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_nested_type_identifier] = STATE(1885),
    [sym__primary_type] = STATE(449),
    [sym_generic_type] = STATE(449),
    [sym_type_predicate] = STATE(449),
    [sym_type_query] = STATE(449),
    [sym_index_type_query] = STATE(449),
    [sym_lookup_type] = STATE(449),
    [sym_literal_type] = STATE(449),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(449),
    [sym_flow_maybe_type] = STATE(449),
    [sym_parenthesized_type] = STATE(449),
    [sym_predefined_type] = STATE(449),
    [sym_object_type] = STATE(449),
    [sym_array_type] = STATE(449),
    [sym_tuple_type] = STATE(449),
    [sym_identifier] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3797),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [981] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_RBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_implements] = ACTIONS(1109),
  },
  [982] = {
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_implements] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(3799),
  },
  [983] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [984] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_RBRACE] = ACTIONS(3803),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3803),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3803),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [985] = {
    [sym_type_arguments] = STATE(1161),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_as] = ACTIONS(2611),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_COMMA] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2611),
    [anon_sym_RPAREN] = ACTIONS(2611),
    [anon_sym_in] = ACTIONS(2613),
    [anon_sym_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_RBRACK] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(3805),
    [anon_sym_GT] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_DOT] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2611),
    [anon_sym_GT_GT] = ACTIONS(2613),
    [anon_sym_GT_GT_GT] = ACTIONS(2611),
    [anon_sym_LT_LT] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PERCENT] = ACTIONS(2611),
    [anon_sym_STAR_STAR] = ACTIONS(2611),
    [anon_sym_LT_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(2613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2611),
    [anon_sym_BANG_EQ] = ACTIONS(2613),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2611),
    [anon_sym_GT_EQ] = ACTIONS(2611),
    [anon_sym_instanceof] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2613),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2611),
    [anon_sym_implements] = ACTIONS(2611),
  },
  [986] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [987] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_annotation] = STATE(3003),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2741),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3808),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3810),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [988] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3812),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3812),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3812),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [989] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3814),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3814),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [990] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3818),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3818),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [991] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_string] = STATE(1146),
    [sym_nested_type_identifier] = STATE(985),
    [sym__primary_type] = STATE(1153),
    [sym_generic_type] = STATE(1153),
    [sym_type_predicate] = STATE(1153),
    [sym_type_query] = STATE(1153),
    [sym_index_type_query] = STATE(1153),
    [sym_lookup_type] = STATE(1153),
    [sym_literal_type] = STATE(1153),
    [sym__number] = STATE(1146),
    [sym_existential_type] = STATE(1153),
    [sym_flow_maybe_type] = STATE(1153),
    [sym_parenthesized_type] = STATE(1153),
    [sym_predefined_type] = STATE(1153),
    [sym_object_type] = STATE(1153),
    [sym_array_type] = STATE(1153),
    [sym_tuple_type] = STATE(1153),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3823),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(559),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3825),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [992] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_annotation] = STATE(3003),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2629),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3808),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3827),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [993] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_as] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1103),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_COLON] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_implements] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(3735),
  },
  [994] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3829),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3829),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3829),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [995] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3784),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [996] = {
    [sym_statement_block] = STATE(1142),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_COLON] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_RBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_implements] = ACTIONS(1095),
  },
  [997] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_string] = STATE(436),
    [sym_nested_type_identifier] = STATE(479),
    [sym__primary_type] = STATE(449),
    [sym_generic_type] = STATE(449),
    [sym_type_predicate] = STATE(449),
    [sym_type_query] = STATE(449),
    [sym_index_type_query] = STATE(449),
    [sym_lookup_type] = STATE(449),
    [sym_literal_type] = STATE(449),
    [sym__number] = STATE(436),
    [sym_existential_type] = STATE(449),
    [sym_flow_maybe_type] = STATE(449),
    [sym_parenthesized_type] = STATE(449),
    [sym_predefined_type] = STATE(449),
    [sym_object_type] = STATE(449),
    [sym_array_type] = STATE(449),
    [sym_tuple_type] = STATE(449),
    [sym_identifier] = ACTIONS(3491),
    [anon_sym_STAR] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_typeof] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3356),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_PLUS] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2587),
    [anon_sym_void] = ACTIONS(3360),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2591),
    [sym_this] = ACTIONS(3797),
    [sym_true] = ACTIONS(2595),
    [sym_false] = ACTIONS(2595),
    [anon_sym_any] = ACTIONS(3360),
    [anon_sym_number] = ACTIONS(3360),
    [anon_sym_boolean] = ACTIONS(3360),
    [anon_sym_string] = ACTIONS(3360),
    [anon_sym_symbol] = ACTIONS(3360),
    [anon_sym_keyof] = ACTIONS(845),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [998] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_string] = STATE(1669),
    [sym_nested_type_identifier] = STATE(1462),
    [sym__primary_type] = STATE(1658),
    [sym_generic_type] = STATE(1658),
    [sym_type_predicate] = STATE(1658),
    [sym_type_query] = STATE(1658),
    [sym_index_type_query] = STATE(1658),
    [sym_lookup_type] = STATE(1658),
    [sym_literal_type] = STATE(1658),
    [sym__number] = STATE(1669),
    [sym_existential_type] = STATE(1658),
    [sym_flow_maybe_type] = STATE(1658),
    [sym_parenthesized_type] = STATE(1658),
    [sym_predefined_type] = STATE(1658),
    [sym_object_type] = STATE(1658),
    [sym_array_type] = STATE(1658),
    [sym_tuple_type] = STATE(1658),
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_LBRACE] = ACTIONS(3175),
    [anon_sym_typeof] = ACTIONS(3177),
    [anon_sym_LPAREN] = ACTIONS(3833),
    [anon_sym_LBRACK] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_PLUS] = ACTIONS(3191),
    [anon_sym_DASH] = ACTIONS(3191),
    [anon_sym_void] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(742),
    [anon_sym_SQUOTE] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3195),
    [sym_this] = ACTIONS(3835),
    [sym_true] = ACTIONS(3199),
    [sym_false] = ACTIONS(3199),
    [anon_sym_any] = ACTIONS(3193),
    [anon_sym_number] = ACTIONS(3193),
    [anon_sym_boolean] = ACTIONS(3193),
    [anon_sym_string] = ACTIONS(3193),
    [anon_sym_symbol] = ACTIONS(3193),
    [anon_sym_keyof] = ACTIONS(3201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3203),
  },
  [999] = {
    [sym_statement_block] = STATE(1142),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_COLON] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_RBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(3837),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_implements] = ACTIONS(1095),
  },
  [1000] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_RBRACE] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3839),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1001] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3818),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3818),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1002] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3818),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3818),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3816),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1003] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_string] = STATE(1971),
    [sym_nested_type_identifier] = STATE(1899),
    [sym__primary_type] = STATE(1937),
    [sym_generic_type] = STATE(1937),
    [sym_type_predicate] = STATE(1937),
    [sym_type_query] = STATE(1937),
    [sym_index_type_query] = STATE(1937),
    [sym_lookup_type] = STATE(1937),
    [sym_literal_type] = STATE(1937),
    [sym__number] = STATE(1971),
    [sym_existential_type] = STATE(1937),
    [sym_flow_maybe_type] = STATE(1937),
    [sym_parenthesized_type] = STATE(1937),
    [sym_predefined_type] = STATE(1937),
    [sym_object_type] = STATE(1937),
    [sym_array_type] = STATE(1937),
    [sym_tuple_type] = STATE(1937),
    [sym_identifier] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_typeof] = ACTIONS(3456),
    [anon_sym_LPAREN] = ACTIONS(3841),
    [anon_sym_LBRACK] = ACTIONS(3460),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_void] = ACTIONS(3466),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3468),
    [sym_this] = ACTIONS(3843),
    [sym_true] = ACTIONS(3472),
    [sym_false] = ACTIONS(3472),
    [anon_sym_any] = ACTIONS(3466),
    [anon_sym_number] = ACTIONS(3466),
    [anon_sym_boolean] = ACTIONS(3466),
    [anon_sym_string] = ACTIONS(3466),
    [anon_sym_symbol] = ACTIONS(3466),
    [anon_sym_keyof] = ACTIONS(989),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [1004] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3845),
    [anon_sym_RBRACE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3845),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3845),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1005] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3847),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3847),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3847),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1006] = {
    [sym__initializer] = STATE(2739),
    [sym_type_annotation] = STATE(2351),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3849),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3851),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_of] = ACTIONS(3856),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(3851),
  },
  [1007] = {
    [sym_arguments] = STATE(1035),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_COLON] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_RBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_implements] = ACTIONS(3269),
  },
  [1008] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3858),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3858),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3858),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1009] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3860),
    [anon_sym_RBRACE] = ACTIONS(3860),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3860),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3860),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3860),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1010] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_annotation] = STATE(3003),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2649),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3808),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3862),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1011] = {
    [sym_statement_block] = STATE(1281),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(3866),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [1012] = {
    [sym_statement_block] = STATE(1281),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [1013] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_string] = STATE(1432),
    [sym_nested_type_identifier] = STATE(1401),
    [sym__primary_type] = STATE(1514),
    [sym_generic_type] = STATE(1514),
    [sym_type_predicate] = STATE(1514),
    [sym_type_query] = STATE(1514),
    [sym_index_type_query] = STATE(1514),
    [sym_lookup_type] = STATE(1514),
    [sym_literal_type] = STATE(1514),
    [sym__number] = STATE(1432),
    [sym_existential_type] = STATE(1514),
    [sym_flow_maybe_type] = STATE(1514),
    [sym_parenthesized_type] = STATE(1514),
    [sym_predefined_type] = STATE(1514),
    [sym_object_type] = STATE(1514),
    [sym_array_type] = STATE(1514),
    [sym_tuple_type] = STATE(1514),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_typeof] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_QMARK] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_void] = ACTIONS(3340),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3342),
    [sym_this] = ACTIONS(3870),
    [sym_true] = ACTIONS(3346),
    [sym_false] = ACTIONS(3346),
    [anon_sym_any] = ACTIONS(3340),
    [anon_sym_number] = ACTIONS(3340),
    [anon_sym_boolean] = ACTIONS(3340),
    [anon_sym_string] = ACTIONS(3340),
    [anon_sym_symbol] = ACTIONS(3340),
    [anon_sym_keyof] = ACTIONS(3348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3350),
  },
  [1014] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3872),
    [anon_sym_RBRACE] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3872),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3872),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3872),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1015] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3874),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3874),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1016] = {
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_as] = ACTIONS(3878),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3878),
    [anon_sym_RBRACE] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_RPAREN] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3876),
    [anon_sym_COLON] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_RBRACK] = ACTIONS(3878),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3876),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_EQ_GT] = ACTIONS(3880),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_GT_GT] = ACTIONS(3876),
    [anon_sym_GT_GT_GT] = ACTIONS(3878),
    [anon_sym_LT_LT] = ACTIONS(3878),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_CARET] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_LT_EQ] = ACTIONS(3878),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3878),
    [anon_sym_GT_EQ] = ACTIONS(3878),
    [anon_sym_instanceof] = ACTIONS(3878),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3878),
    [anon_sym_implements] = ACTIONS(3878),
  },
  [1017] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3882),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3882),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3882),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1018] = {
    [sym__initializer] = STATE(2730),
    [sym_type_annotation] = STATE(2356),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3884),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3888),
    [anon_sym_of] = ACTIONS(3891),
    [anon_sym_SEMI] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(3886),
  },
  [1019] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3893),
    [anon_sym_RBRACE] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1020] = {
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_as] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3897),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_RBRACE] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3897),
    [anon_sym_RPAREN] = ACTIONS(3897),
    [anon_sym_in] = ACTIONS(3895),
    [anon_sym_COLON] = ACTIONS(3897),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_SLASH] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3897),
    [anon_sym_QMARK] = ACTIONS(3897),
    [anon_sym_AMP_AMP] = ACTIONS(3897),
    [anon_sym_PIPE_PIPE] = ACTIONS(3897),
    [anon_sym_GT_GT] = ACTIONS(3895),
    [anon_sym_GT_GT_GT] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_CARET] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3897),
    [anon_sym_STAR_STAR] = ACTIONS(3897),
    [anon_sym_LT_EQ] = ACTIONS(3897),
    [anon_sym_EQ_EQ] = ACTIONS(3895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3897),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3897),
    [anon_sym_GT_EQ] = ACTIONS(3897),
    [anon_sym_instanceof] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(3895),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3897),
    [anon_sym_implements] = ACTIONS(3897),
  },
  [1021] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_annotation] = STATE(3083),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3899),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1022] = {
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_EQ] = ACTIONS(3713),
    [anon_sym_as] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3713),
    [anon_sym_of] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(3715),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3713),
    [anon_sym_GT] = ACTIONS(3713),
    [anon_sym_SLASH] = ACTIONS(3713),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_GT_GT] = ACTIONS(3713),
    [anon_sym_GT_GT_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(3713),
    [anon_sym_CARET] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(3713),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_EQ_EQ] = ACTIONS(3713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3715),
    [anon_sym_BANG_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3715),
    [anon_sym_instanceof] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym__automatic_semicolon] = ACTIONS(3715),
  },
  [1023] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [aux_sym_extends_clause_repeat1] = STATE(2535),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3905),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
  },
  [1024] = {
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_as] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_RPAREN] = ACTIONS(1149),
    [anon_sym_in] = ACTIONS(1151),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_RBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_AMP_AMP] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1149),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_GT_GT_GT] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_CARET] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_PERCENT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1149),
    [anon_sym_GT_EQ] = ACTIONS(1149),
    [anon_sym_instanceof] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [anon_sym_implements] = ACTIONS(1149),
  },
  [1025] = {
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_as] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3939),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_RBRACE] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3939),
    [anon_sym_RPAREN] = ACTIONS(3939),
    [anon_sym_in] = ACTIONS(3937),
    [anon_sym_COLON] = ACTIONS(3939),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_RBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3937),
    [anon_sym_GT] = ACTIONS(3937),
    [anon_sym_SLASH] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_GT_GT] = ACTIONS(3937),
    [anon_sym_GT_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_LT] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_CARET] = ACTIONS(3939),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3939),
    [anon_sym_STAR_STAR] = ACTIONS(3939),
    [anon_sym_LT_EQ] = ACTIONS(3939),
    [anon_sym_EQ_EQ] = ACTIONS(3937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3939),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3939),
    [anon_sym_GT_EQ] = ACTIONS(3939),
    [anon_sym_instanceof] = ACTIONS(3939),
    [anon_sym_BANG] = ACTIONS(3937),
    [anon_sym_PLUS_PLUS] = ACTIONS(3939),
    [anon_sym_DASH_DASH] = ACTIONS(3939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_implements] = ACTIONS(3939),
  },
  [1026] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3872),
    [anon_sym_RBRACE] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3872),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3872),
  },
  [1027] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(3976),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [1028] = {
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_as] = ACTIONS(3981),
    [anon_sym_LBRACE] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(3981),
    [anon_sym_RPAREN] = ACTIONS(3981),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_RBRACK] = ACTIONS(3981),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_DOT] = ACTIONS(3981),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_STAR_STAR] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_instanceof] = ACTIONS(3981),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3981),
    [anon_sym_implements] = ACTIONS(3981),
  },
  [1029] = {
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2656),
    [sym_array] = STATE(3170),
    [sym_spread_element] = STATE(2656),
    [sym_string] = STATE(2055),
    [sym_method_definition] = STATE(2656),
    [sym_pair] = STATE(2656),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_accessibility_modifier] = STATE(1827),
    [aux_sym_object_repeat1] = STATE(2658),
    [sym_identifier] = ACTIONS(3983),
    [anon_sym_export] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_type] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_async] = ACTIONS(3989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3983),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3991),
    [anon_sym_static] = ACTIONS(3993),
    [anon_sym_get] = ACTIONS(3995),
    [anon_sym_set] = ACTIONS(3995),
    [anon_sym_declare] = ACTIONS(3983),
    [anon_sym_public] = ACTIONS(3997),
    [anon_sym_private] = ACTIONS(3997),
    [anon_sym_protected] = ACTIONS(3997),
    [anon_sym_module] = ACTIONS(3983),
    [anon_sym_any] = ACTIONS(3983),
    [anon_sym_number] = ACTIONS(3983),
    [anon_sym_boolean] = ACTIONS(3983),
    [anon_sym_string] = ACTIONS(3983),
    [anon_sym_symbol] = ACTIONS(3983),
    [sym_readonly] = ACTIONS(3999),
  },
  [1030] = {
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2585),
    [sym_array] = STATE(3170),
    [sym_spread_element] = STATE(2585),
    [sym_string] = STATE(2055),
    [sym_method_definition] = STATE(2585),
    [sym_pair] = STATE(2585),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_accessibility_modifier] = STATE(1827),
    [aux_sym_object_repeat1] = STATE(2587),
    [sym_identifier] = ACTIONS(4001),
    [anon_sym_export] = ACTIONS(4001),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4003),
    [anon_sym_type] = ACTIONS(4001),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_async] = ACTIONS(4005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4001),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3991),
    [anon_sym_static] = ACTIONS(4007),
    [anon_sym_get] = ACTIONS(4009),
    [anon_sym_set] = ACTIONS(4009),
    [anon_sym_declare] = ACTIONS(4001),
    [anon_sym_public] = ACTIONS(4011),
    [anon_sym_private] = ACTIONS(4011),
    [anon_sym_protected] = ACTIONS(4011),
    [anon_sym_module] = ACTIONS(4001),
    [anon_sym_any] = ACTIONS(4001),
    [anon_sym_number] = ACTIONS(4001),
    [anon_sym_boolean] = ACTIONS(4001),
    [anon_sym_string] = ACTIONS(4001),
    [anon_sym_symbol] = ACTIONS(4001),
    [sym_readonly] = ACTIONS(4013),
  },
  [1031] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_annotation] = STATE(2986),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4015),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1032] = {
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_as] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_LPAREN] = ACTIONS(4019),
    [anon_sym_RPAREN] = ACTIONS(4019),
    [anon_sym_in] = ACTIONS(4017),
    [anon_sym_COLON] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4019),
    [anon_sym_RBRACK] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_DOT] = ACTIONS(4019),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym_GT_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4019),
    [anon_sym_STAR_STAR] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4019),
    [anon_sym_EQ_EQ] = ACTIONS(4017),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4017),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4019),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_instanceof] = ACTIONS(4019),
    [anon_sym_BANG] = ACTIONS(4017),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_implements] = ACTIONS(4019),
  },
  [1033] = {
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_as] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_RPAREN] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4021),
    [anon_sym_COLON] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_RBRACK] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_DOT] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym_GT_GT_GT] = ACTIONS(4023),
    [anon_sym_LT_LT] = ACTIONS(4023),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4023),
    [anon_sym_STAR_STAR] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4021),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4023),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_instanceof] = ACTIONS(4023),
    [anon_sym_BANG] = ACTIONS(4021),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4023),
    [anon_sym_implements] = ACTIONS(4023),
  },
  [1034] = {
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_LBRACE] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4027),
    [anon_sym_RBRACE] = ACTIONS(4027),
    [anon_sym_LPAREN] = ACTIONS(4027),
    [anon_sym_RPAREN] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_LBRACK] = ACTIONS(4027),
    [anon_sym_RBRACK] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_AMP_AMP] = ACTIONS(4027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_STAR_STAR] = ACTIONS(4027),
    [anon_sym_LT_EQ] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4027),
    [anon_sym_BANG_EQ] = ACTIONS(4025),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4027),
    [anon_sym_GT_EQ] = ACTIONS(4027),
    [anon_sym_instanceof] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4025),
    [anon_sym_PLUS_PLUS] = ACTIONS(4027),
    [anon_sym_DASH_DASH] = ACTIONS(4027),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4027),
    [anon_sym_implements] = ACTIONS(4027),
  },
  [1035] = {
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_as] = ACTIONS(4031),
    [anon_sym_LBRACE] = ACTIONS(4031),
    [anon_sym_COMMA] = ACTIONS(4031),
    [anon_sym_RBRACE] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_RPAREN] = ACTIONS(4031),
    [anon_sym_in] = ACTIONS(4029),
    [anon_sym_COLON] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_RBRACK] = ACTIONS(4031),
    [anon_sym_LT] = ACTIONS(4029),
    [anon_sym_GT] = ACTIONS(4029),
    [anon_sym_SLASH] = ACTIONS(4029),
    [anon_sym_DOT] = ACTIONS(4031),
    [anon_sym_QMARK] = ACTIONS(4031),
    [anon_sym_AMP_AMP] = ACTIONS(4031),
    [anon_sym_PIPE_PIPE] = ACTIONS(4031),
    [anon_sym_GT_GT] = ACTIONS(4029),
    [anon_sym_GT_GT_GT] = ACTIONS(4031),
    [anon_sym_LT_LT] = ACTIONS(4031),
    [anon_sym_AMP] = ACTIONS(4029),
    [anon_sym_CARET] = ACTIONS(4031),
    [anon_sym_PIPE] = ACTIONS(4029),
    [anon_sym_PLUS] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4029),
    [anon_sym_PERCENT] = ACTIONS(4031),
    [anon_sym_STAR_STAR] = ACTIONS(4031),
    [anon_sym_LT_EQ] = ACTIONS(4031),
    [anon_sym_EQ_EQ] = ACTIONS(4029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4031),
    [anon_sym_BANG_EQ] = ACTIONS(4029),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4031),
    [anon_sym_GT_EQ] = ACTIONS(4031),
    [anon_sym_instanceof] = ACTIONS(4031),
    [anon_sym_BANG] = ACTIONS(4029),
    [anon_sym_PLUS_PLUS] = ACTIONS(4031),
    [anon_sym_DASH_DASH] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4031),
    [anon_sym_implements] = ACTIONS(4031),
  },
  [1036] = {
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_as] = ACTIONS(4031),
    [anon_sym_LBRACE] = ACTIONS(4031),
    [anon_sym_COMMA] = ACTIONS(4031),
    [anon_sym_RBRACE] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_RPAREN] = ACTIONS(4031),
    [anon_sym_in] = ACTIONS(4029),
    [anon_sym_COLON] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_RBRACK] = ACTIONS(4031),
    [anon_sym_LT] = ACTIONS(4029),
    [anon_sym_GT] = ACTIONS(4029),
    [anon_sym_SLASH] = ACTIONS(4029),
    [anon_sym_DOT] = ACTIONS(4031),
    [anon_sym_QMARK] = ACTIONS(4031),
    [anon_sym_AMP_AMP] = ACTIONS(4031),
    [anon_sym_PIPE_PIPE] = ACTIONS(4031),
    [anon_sym_GT_GT] = ACTIONS(4029),
    [anon_sym_GT_GT_GT] = ACTIONS(4031),
    [anon_sym_LT_LT] = ACTIONS(4031),
    [anon_sym_AMP] = ACTIONS(4029),
    [anon_sym_CARET] = ACTIONS(4031),
    [anon_sym_PIPE] = ACTIONS(4029),
    [anon_sym_PLUS] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4029),
    [anon_sym_PERCENT] = ACTIONS(4031),
    [anon_sym_STAR_STAR] = ACTIONS(4031),
    [anon_sym_LT_EQ] = ACTIONS(4031),
    [anon_sym_EQ_EQ] = ACTIONS(4029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4031),
    [anon_sym_BANG_EQ] = ACTIONS(4029),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4031),
    [anon_sym_GT_EQ] = ACTIONS(4031),
    [anon_sym_instanceof] = ACTIONS(4031),
    [anon_sym_BANG] = ACTIONS(4029),
    [anon_sym_PLUS_PLUS] = ACTIONS(4031),
    [anon_sym_DASH_DASH] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4031),
    [anon_sym_implements] = ACTIONS(4031),
  },
  [1037] = {
    [anon_sym_STAR] = ACTIONS(4033),
    [anon_sym_as] = ACTIONS(4035),
    [anon_sym_LBRACE] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LPAREN] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4035),
    [anon_sym_in] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_RBRACK] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4033),
    [anon_sym_GT] = ACTIONS(4033),
    [anon_sym_SLASH] = ACTIONS(4033),
    [anon_sym_DOT] = ACTIONS(4035),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_GT_GT_GT] = ACTIONS(4035),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4033),
    [anon_sym_CARET] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4033),
    [anon_sym_DASH] = ACTIONS(4033),
    [anon_sym_PERCENT] = ACTIONS(4035),
    [anon_sym_STAR_STAR] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4035),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_instanceof] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4035),
    [anon_sym_implements] = ACTIONS(4035),
  },
  [1038] = {
    [anon_sym_STAR] = ACTIONS(4037),
    [anon_sym_as] = ACTIONS(3814),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_RPAREN] = ACTIONS(3814),
    [anon_sym_in] = ACTIONS(4037),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_RBRACK] = ACTIONS(3814),
    [anon_sym_LT] = ACTIONS(4037),
    [anon_sym_GT] = ACTIONS(4037),
    [anon_sym_SLASH] = ACTIONS(4037),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_GT_GT] = ACTIONS(4037),
    [anon_sym_GT_GT_GT] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_PIPE] = ACTIONS(4037),
    [anon_sym_PLUS] = ACTIONS(4037),
    [anon_sym_DASH] = ACTIONS(4037),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_STAR_STAR] = ACTIONS(3814),
    [anon_sym_LT_EQ] = ACTIONS(3814),
    [anon_sym_EQ_EQ] = ACTIONS(4037),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(4037),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3814),
    [anon_sym_GT_EQ] = ACTIONS(3814),
    [anon_sym_instanceof] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(4037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3814),
    [anon_sym_implements] = ACTIONS(3814),
  },
  [1039] = {
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_as] = ACTIONS(3878),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3878),
    [anon_sym_RBRACE] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_RPAREN] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3876),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_RBRACK] = ACTIONS(3878),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3876),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_GT_GT] = ACTIONS(3876),
    [anon_sym_GT_GT_GT] = ACTIONS(3878),
    [anon_sym_LT_LT] = ACTIONS(3878),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_CARET] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_LT_EQ] = ACTIONS(3878),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3878),
    [anon_sym_GT_EQ] = ACTIONS(3878),
    [anon_sym_instanceof] = ACTIONS(3878),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3878),
    [anon_sym_implements] = ACTIONS(3878),
  },
  [1040] = {
    [anon_sym_STAR] = ACTIONS(4039),
    [anon_sym_as] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(4041),
    [anon_sym_COMMA] = ACTIONS(4041),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_LPAREN] = ACTIONS(4041),
    [anon_sym_RPAREN] = ACTIONS(4041),
    [anon_sym_in] = ACTIONS(4039),
    [anon_sym_COLON] = ACTIONS(4041),
    [anon_sym_LBRACK] = ACTIONS(4041),
    [anon_sym_RBRACK] = ACTIONS(4041),
    [anon_sym_LT] = ACTIONS(4039),
    [anon_sym_GT] = ACTIONS(4039),
    [anon_sym_SLASH] = ACTIONS(4039),
    [anon_sym_DOT] = ACTIONS(4041),
    [anon_sym_QMARK] = ACTIONS(4041),
    [anon_sym_AMP_AMP] = ACTIONS(4041),
    [anon_sym_PIPE_PIPE] = ACTIONS(4041),
    [anon_sym_GT_GT] = ACTIONS(4039),
    [anon_sym_GT_GT_GT] = ACTIONS(4041),
    [anon_sym_LT_LT] = ACTIONS(4041),
    [anon_sym_AMP] = ACTIONS(4039),
    [anon_sym_CARET] = ACTIONS(4041),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4039),
    [anon_sym_DASH] = ACTIONS(4039),
    [anon_sym_PERCENT] = ACTIONS(4041),
    [anon_sym_STAR_STAR] = ACTIONS(4041),
    [anon_sym_LT_EQ] = ACTIONS(4041),
    [anon_sym_EQ_EQ] = ACTIONS(4039),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4041),
    [anon_sym_BANG_EQ] = ACTIONS(4039),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4041),
    [anon_sym_GT_EQ] = ACTIONS(4041),
    [anon_sym_instanceof] = ACTIONS(4041),
    [anon_sym_BANG] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4041),
    [anon_sym_DASH_DASH] = ACTIONS(4041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4041),
    [anon_sym_implements] = ACTIONS(4041),
  },
  [1041] = {
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_as] = ACTIONS(4045),
    [anon_sym_LBRACE] = ACTIONS(4045),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_RBRACE] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [anon_sym_RPAREN] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4043),
    [anon_sym_COLON] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_RBRACK] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4043),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_QMARK] = ACTIONS(4045),
    [anon_sym_AMP_AMP] = ACTIONS(4045),
    [anon_sym_PIPE_PIPE] = ACTIONS(4045),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_GT_GT_GT] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_STAR_STAR] = ACTIONS(4045),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4045),
    [anon_sym_BANG_EQ] = ACTIONS(4043),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4045),
    [anon_sym_instanceof] = ACTIONS(4045),
    [anon_sym_BANG] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [anon_sym_implements] = ACTIONS(4045),
  },
  [1042] = {
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_as] = ACTIONS(4045),
    [anon_sym_LBRACE] = ACTIONS(4045),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_RBRACE] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [anon_sym_RPAREN] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4043),
    [anon_sym_COLON] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_RBRACK] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4043),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_QMARK] = ACTIONS(4045),
    [anon_sym_AMP_AMP] = ACTIONS(4045),
    [anon_sym_PIPE_PIPE] = ACTIONS(4045),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_GT_GT_GT] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_STAR_STAR] = ACTIONS(4045),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4045),
    [anon_sym_BANG_EQ] = ACTIONS(4043),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4045),
    [anon_sym_instanceof] = ACTIONS(4045),
    [anon_sym_BANG] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [anon_sym_implements] = ACTIONS(4045),
  },
  [1043] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_annotation] = STATE(3003),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4047),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1044] = {
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2668),
    [sym_array] = STATE(3170),
    [sym_spread_element] = STATE(2668),
    [sym_string] = STATE(2055),
    [sym_method_definition] = STATE(2668),
    [sym_pair] = STATE(2668),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_accessibility_modifier] = STATE(1827),
    [aux_sym_object_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(4049),
    [anon_sym_export] = ACTIONS(4049),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4049),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4051),
    [anon_sym_type] = ACTIONS(4049),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_async] = ACTIONS(4053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4049),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3991),
    [anon_sym_static] = ACTIONS(4055),
    [anon_sym_get] = ACTIONS(4057),
    [anon_sym_set] = ACTIONS(4057),
    [anon_sym_declare] = ACTIONS(4049),
    [anon_sym_public] = ACTIONS(4059),
    [anon_sym_private] = ACTIONS(4059),
    [anon_sym_protected] = ACTIONS(4059),
    [anon_sym_module] = ACTIONS(4049),
    [anon_sym_any] = ACTIONS(4049),
    [anon_sym_number] = ACTIONS(4049),
    [anon_sym_boolean] = ACTIONS(4049),
    [anon_sym_string] = ACTIONS(4049),
    [anon_sym_symbol] = ACTIONS(4049),
    [sym_readonly] = ACTIONS(4061),
  },
  [1045] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [1046] = {
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3723),
    [anon_sym_COMMA] = ACTIONS(3723),
    [anon_sym_RBRACE] = ACTIONS(3723),
    [anon_sym_LPAREN] = ACTIONS(3723),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_of] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3723),
    [anon_sym_COLON] = ACTIONS(3723),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3723),
    [anon_sym_QMARK] = ACTIONS(3723),
    [anon_sym_AMP_AMP] = ACTIONS(3723),
    [anon_sym_PIPE_PIPE] = ACTIONS(3723),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3723),
    [anon_sym_LT_LT] = ACTIONS(3723),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3723),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3723),
    [anon_sym_STAR_STAR] = ACTIONS(3723),
    [anon_sym_LT_EQ] = ACTIONS(3723),
    [anon_sym_EQ_EQ] = ACTIONS(3721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3723),
    [anon_sym_BANG_EQ] = ACTIONS(3721),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3723),
    [anon_sym_GT_EQ] = ACTIONS(3723),
    [anon_sym_instanceof] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(3723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3723),
    [sym__automatic_semicolon] = ACTIONS(3723),
  },
  [1047] = {
    [anon_sym_STAR] = ACTIONS(4069),
    [anon_sym_as] = ACTIONS(4071),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(4071),
    [anon_sym_RPAREN] = ACTIONS(4071),
    [anon_sym_in] = ACTIONS(4069),
    [anon_sym_COLON] = ACTIONS(4071),
    [anon_sym_LBRACK] = ACTIONS(4071),
    [anon_sym_RBRACK] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_SLASH] = ACTIONS(4069),
    [anon_sym_DOT] = ACTIONS(4071),
    [anon_sym_QMARK] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_GT_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4069),
    [anon_sym_CARET] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_PERCENT] = ACTIONS(4071),
    [anon_sym_STAR_STAR] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4071),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_instanceof] = ACTIONS(4071),
    [anon_sym_BANG] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_implements] = ACTIONS(4071),
  },
  [1048] = {
    [anon_sym_STAR] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(3782),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_RPAREN] = ACTIONS(3782),
    [anon_sym_in] = ACTIONS(4073),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_RBRACK] = ACTIONS(3782),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_SLASH] = ACTIONS(4073),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_GT_GT] = ACTIONS(4073),
    [anon_sym_GT_GT_GT] = ACTIONS(3782),
    [anon_sym_LT_LT] = ACTIONS(3782),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_STAR_STAR] = ACTIONS(3782),
    [anon_sym_LT_EQ] = ACTIONS(3782),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(4073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3782),
    [anon_sym_GT_EQ] = ACTIONS(3782),
    [anon_sym_instanceof] = ACTIONS(3782),
    [anon_sym_BANG] = ACTIONS(4073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3782),
    [anon_sym_DASH_DASH] = ACTIONS(3782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3782),
    [anon_sym_implements] = ACTIONS(3782),
  },
  [1049] = {
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_RBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [anon_sym_implements] = ACTIONS(1205),
  },
  [1050] = {
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_LBRACE] = ACTIONS(4077),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_RPAREN] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
    [anon_sym_COLON] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(4077),
    [anon_sym_RBRACK] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4075),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [anon_sym_implements] = ACTIONS(4077),
  },
  [1051] = {
    [anon_sym_STAR] = ACTIONS(4079),
    [anon_sym_as] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3754),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_RPAREN] = ACTIONS(3754),
    [anon_sym_in] = ACTIONS(4079),
    [anon_sym_COLON] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [anon_sym_RBRACK] = ACTIONS(3754),
    [anon_sym_LT] = ACTIONS(4079),
    [anon_sym_GT] = ACTIONS(4079),
    [anon_sym_SLASH] = ACTIONS(4079),
    [anon_sym_DOT] = ACTIONS(3754),
    [anon_sym_QMARK] = ACTIONS(3754),
    [anon_sym_AMP_AMP] = ACTIONS(3754),
    [anon_sym_PIPE_PIPE] = ACTIONS(3754),
    [anon_sym_GT_GT] = ACTIONS(4079),
    [anon_sym_GT_GT_GT] = ACTIONS(3754),
    [anon_sym_LT_LT] = ACTIONS(3754),
    [anon_sym_AMP] = ACTIONS(4079),
    [anon_sym_CARET] = ACTIONS(3754),
    [anon_sym_PIPE] = ACTIONS(4079),
    [anon_sym_PLUS] = ACTIONS(4079),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_PERCENT] = ACTIONS(3754),
    [anon_sym_STAR_STAR] = ACTIONS(3754),
    [anon_sym_LT_EQ] = ACTIONS(3754),
    [anon_sym_EQ_EQ] = ACTIONS(4079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3754),
    [anon_sym_BANG_EQ] = ACTIONS(4079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3754),
    [anon_sym_GT_EQ] = ACTIONS(3754),
    [anon_sym_instanceof] = ACTIONS(3754),
    [anon_sym_BANG] = ACTIONS(4079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3754),
    [anon_sym_DASH_DASH] = ACTIONS(3754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3754),
    [anon_sym_implements] = ACTIONS(3754),
  },
  [1052] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_of] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [1053] = {
    [anon_sym_STAR] = ACTIONS(4081),
    [anon_sym_as] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_RPAREN] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4081),
    [anon_sym_COLON] = ACTIONS(4083),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_RBRACK] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4081),
    [anon_sym_GT] = ACTIONS(4081),
    [anon_sym_SLASH] = ACTIONS(4081),
    [anon_sym_DOT] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE] = ACTIONS(4083),
    [anon_sym_GT_GT] = ACTIONS(4081),
    [anon_sym_GT_GT_GT] = ACTIONS(4083),
    [anon_sym_LT_LT] = ACTIONS(4083),
    [anon_sym_AMP] = ACTIONS(4081),
    [anon_sym_CARET] = ACTIONS(4083),
    [anon_sym_PIPE] = ACTIONS(4081),
    [anon_sym_PLUS] = ACTIONS(4081),
    [anon_sym_DASH] = ACTIONS(4081),
    [anon_sym_PERCENT] = ACTIONS(4083),
    [anon_sym_STAR_STAR] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_EQ_EQ] = ACTIONS(4081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4083),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_instanceof] = ACTIONS(4083),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_PLUS_PLUS] = ACTIONS(4083),
    [anon_sym_DASH_DASH] = ACTIONS(4083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4083),
    [anon_sym_implements] = ACTIONS(4083),
  },
  [1054] = {
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1197),
    [anon_sym_COLON] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1197),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1197),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [anon_sym_implements] = ACTIONS(1195),
  },
  [1055] = {
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_RPAREN] = ACTIONS(4087),
    [anon_sym_in] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_RBRACK] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_DOT] = ACTIONS(4087),
    [anon_sym_QMARK] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4087),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_STAR_STAR] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4085),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_instanceof] = ACTIONS(4087),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4087),
    [anon_sym_implements] = ACTIONS(4087),
  },
  [1056] = {
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(3893),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3893),
    [anon_sym_RBRACE] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_RPAREN] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(4089),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_RBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_LT] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(3893),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_STAR_STAR] = ACTIONS(3893),
    [anon_sym_LT_EQ] = ACTIONS(3893),
    [anon_sym_EQ_EQ] = ACTIONS(4089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(4089),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3893),
    [anon_sym_GT_EQ] = ACTIONS(3893),
    [anon_sym_instanceof] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3893),
    [anon_sym_DASH_DASH] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_implements] = ACTIONS(3893),
  },
  [1057] = {
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(4093),
    [anon_sym_LBRACE] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4093),
    [anon_sym_RBRACE] = ACTIONS(4093),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_RPAREN] = ACTIONS(4093),
    [anon_sym_in] = ACTIONS(4091),
    [anon_sym_COLON] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_RBRACK] = ACTIONS(4093),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_GT] = ACTIONS(4091),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4093),
    [anon_sym_LT_LT] = ACTIONS(4093),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_CARET] = ACTIONS(4093),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_PLUS] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4091),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_STAR_STAR] = ACTIONS(4093),
    [anon_sym_LT_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ] = ACTIONS(4091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4093),
    [anon_sym_GT_EQ] = ACTIONS(4093),
    [anon_sym_instanceof] = ACTIONS(4093),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_PLUS_PLUS] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4093),
    [anon_sym_implements] = ACTIONS(4093),
  },
  [1058] = {
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4097),
    [anon_sym_COMMA] = ACTIONS(4097),
    [anon_sym_RBRACE] = ACTIONS(4097),
    [anon_sym_LPAREN] = ACTIONS(4097),
    [anon_sym_RPAREN] = ACTIONS(4097),
    [anon_sym_in] = ACTIONS(4095),
    [anon_sym_COLON] = ACTIONS(4097),
    [anon_sym_LBRACK] = ACTIONS(4097),
    [anon_sym_RBRACK] = ACTIONS(4097),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_SLASH] = ACTIONS(4095),
    [anon_sym_DOT] = ACTIONS(4097),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4097),
    [anon_sym_PIPE_PIPE] = ACTIONS(4097),
    [anon_sym_GT_GT] = ACTIONS(4095),
    [anon_sym_GT_GT_GT] = ACTIONS(4097),
    [anon_sym_LT_LT] = ACTIONS(4097),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym_CARET] = ACTIONS(4097),
    [anon_sym_PIPE] = ACTIONS(4095),
    [anon_sym_PLUS] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4095),
    [anon_sym_PERCENT] = ACTIONS(4097),
    [anon_sym_STAR_STAR] = ACTIONS(4097),
    [anon_sym_LT_EQ] = ACTIONS(4097),
    [anon_sym_EQ_EQ] = ACTIONS(4095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4097),
    [anon_sym_BANG_EQ] = ACTIONS(4095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4097),
    [anon_sym_GT_EQ] = ACTIONS(4097),
    [anon_sym_instanceof] = ACTIONS(4097),
    [anon_sym_BANG] = ACTIONS(4095),
    [anon_sym_PLUS_PLUS] = ACTIONS(4097),
    [anon_sym_DASH_DASH] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4097),
    [anon_sym_implements] = ACTIONS(4097),
  },
  [1059] = {
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3717),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3717),
    [anon_sym_of] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3717),
    [anon_sym_GT] = ACTIONS(3717),
    [anon_sym_SLASH] = ACTIONS(3717),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3717),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_AMP] = ACTIONS(3717),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3717),
    [anon_sym_PLUS] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3717),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_STAR_STAR] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3717),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_instanceof] = ACTIONS(3719),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3719),
    [sym__automatic_semicolon] = ACTIONS(3719),
  },
  [1060] = {
    [anon_sym_STAR] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(3882),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3882),
    [anon_sym_RPAREN] = ACTIONS(3882),
    [anon_sym_in] = ACTIONS(4099),
    [anon_sym_COLON] = ACTIONS(3882),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_RBRACK] = ACTIONS(3882),
    [anon_sym_LT] = ACTIONS(4099),
    [anon_sym_GT] = ACTIONS(4099),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_DOT] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3882),
    [anon_sym_AMP_AMP] = ACTIONS(3882),
    [anon_sym_PIPE_PIPE] = ACTIONS(3882),
    [anon_sym_GT_GT] = ACTIONS(4099),
    [anon_sym_GT_GT_GT] = ACTIONS(3882),
    [anon_sym_LT_LT] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(4099),
    [anon_sym_CARET] = ACTIONS(3882),
    [anon_sym_PIPE] = ACTIONS(4099),
    [anon_sym_PLUS] = ACTIONS(4099),
    [anon_sym_DASH] = ACTIONS(4099),
    [anon_sym_PERCENT] = ACTIONS(3882),
    [anon_sym_STAR_STAR] = ACTIONS(3882),
    [anon_sym_LT_EQ] = ACTIONS(3882),
    [anon_sym_EQ_EQ] = ACTIONS(4099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3882),
    [anon_sym_BANG_EQ] = ACTIONS(4099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3882),
    [anon_sym_GT_EQ] = ACTIONS(3882),
    [anon_sym_instanceof] = ACTIONS(3882),
    [anon_sym_BANG] = ACTIONS(4099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3882),
    [anon_sym_implements] = ACTIONS(3882),
  },
  [1061] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(4101),
    [anon_sym_RBRACE] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4101),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4101),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1062] = {
    [anon_sym_STAR] = ACTIONS(4103),
    [anon_sym_as] = ACTIONS(4105),
    [anon_sym_LBRACE] = ACTIONS(4105),
    [anon_sym_COMMA] = ACTIONS(4105),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_LPAREN] = ACTIONS(4105),
    [anon_sym_RPAREN] = ACTIONS(4105),
    [anon_sym_in] = ACTIONS(4103),
    [anon_sym_COLON] = ACTIONS(4105),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_RBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4103),
    [anon_sym_GT] = ACTIONS(4103),
    [anon_sym_SLASH] = ACTIONS(4103),
    [anon_sym_DOT] = ACTIONS(4105),
    [anon_sym_QMARK] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_GT_GT_GT] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_AMP] = ACTIONS(4103),
    [anon_sym_CARET] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4103),
    [anon_sym_PLUS] = ACTIONS(4103),
    [anon_sym_DASH] = ACTIONS(4103),
    [anon_sym_PERCENT] = ACTIONS(4105),
    [anon_sym_STAR_STAR] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_BANG_EQ] = ACTIONS(4103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4105),
    [anon_sym_GT_EQ] = ACTIONS(4105),
    [anon_sym_instanceof] = ACTIONS(4105),
    [anon_sym_BANG] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4105),
    [anon_sym_DASH_DASH] = ACTIONS(4105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4105),
    [anon_sym_implements] = ACTIONS(4105),
  },
  [1063] = {
    [anon_sym_STAR] = ACTIONS(4107),
    [anon_sym_as] = ACTIONS(4109),
    [anon_sym_LBRACE] = ACTIONS(4109),
    [anon_sym_COMMA] = ACTIONS(4109),
    [anon_sym_RBRACE] = ACTIONS(4109),
    [anon_sym_LPAREN] = ACTIONS(4109),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [anon_sym_in] = ACTIONS(4107),
    [anon_sym_COLON] = ACTIONS(4109),
    [anon_sym_LBRACK] = ACTIONS(4109),
    [anon_sym_RBRACK] = ACTIONS(4109),
    [anon_sym_LT] = ACTIONS(4107),
    [anon_sym_GT] = ACTIONS(4107),
    [anon_sym_SLASH] = ACTIONS(4107),
    [anon_sym_DOT] = ACTIONS(4109),
    [anon_sym_QMARK] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_GT_GT_GT] = ACTIONS(4109),
    [anon_sym_LT_LT] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4107),
    [anon_sym_CARET] = ACTIONS(4109),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4107),
    [anon_sym_DASH] = ACTIONS(4107),
    [anon_sym_PERCENT] = ACTIONS(4109),
    [anon_sym_STAR_STAR] = ACTIONS(4109),
    [anon_sym_LT_EQ] = ACTIONS(4109),
    [anon_sym_EQ_EQ] = ACTIONS(4107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4109),
    [anon_sym_GT_EQ] = ACTIONS(4109),
    [anon_sym_instanceof] = ACTIONS(4109),
    [anon_sym_BANG] = ACTIONS(4107),
    [anon_sym_PLUS_PLUS] = ACTIONS(4109),
    [anon_sym_DASH_DASH] = ACTIONS(4109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [anon_sym_implements] = ACTIONS(4109),
  },
  [1064] = {
    [anon_sym_STAR] = ACTIONS(4111),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3791),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3791),
    [anon_sym_RPAREN] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(4111),
    [anon_sym_COLON] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3791),
    [anon_sym_RBRACK] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(4111),
    [anon_sym_GT] = ACTIONS(4111),
    [anon_sym_SLASH] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3791),
    [anon_sym_AMP_AMP] = ACTIONS(3791),
    [anon_sym_PIPE_PIPE] = ACTIONS(3791),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_GT_GT_GT] = ACTIONS(3791),
    [anon_sym_LT_LT] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(3791),
    [anon_sym_PIPE] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_STAR_STAR] = ACTIONS(3791),
    [anon_sym_LT_EQ] = ACTIONS(3791),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3791),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3791),
    [anon_sym_GT_EQ] = ACTIONS(3791),
    [anon_sym_instanceof] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(4111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3791),
    [anon_sym_implements] = ACTIONS(3791),
  },
  [1065] = {
    [anon_sym_STAR] = ACTIONS(2442),
    [anon_sym_as] = ACTIONS(2440),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_COMMA] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_RPAREN] = ACTIONS(2440),
    [anon_sym_in] = ACTIONS(2442),
    [anon_sym_COLON] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_RBRACK] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_GT] = ACTIONS(2442),
    [anon_sym_SLASH] = ACTIONS(2442),
    [anon_sym_DOT] = ACTIONS(2440),
    [anon_sym_QMARK] = ACTIONS(2440),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE_PIPE] = ACTIONS(2440),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_GT_GT_GT] = ACTIONS(2440),
    [anon_sym_LT_LT] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_PERCENT] = ACTIONS(2440),
    [anon_sym_STAR_STAR] = ACTIONS(2440),
    [anon_sym_LT_EQ] = ACTIONS(2440),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2440),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2440),
    [anon_sym_GT_EQ] = ACTIONS(2440),
    [anon_sym_instanceof] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2440),
    [anon_sym_DASH_DASH] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2440),
    [anon_sym_implements] = ACTIONS(2440),
  },
  [1066] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_RBRACE] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3839),
  },
  [1067] = {
    [anon_sym_STAR] = ACTIONS(3748),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_as] = ACTIONS(3750),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [anon_sym_LPAREN] = ACTIONS(3750),
    [anon_sym_in] = ACTIONS(3748),
    [anon_sym_of] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_GT] = ACTIONS(3748),
    [anon_sym_SLASH] = ACTIONS(3748),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_QMARK] = ACTIONS(3750),
    [anon_sym_AMP_AMP] = ACTIONS(3750),
    [anon_sym_PIPE_PIPE] = ACTIONS(3750),
    [anon_sym_GT_GT] = ACTIONS(3748),
    [anon_sym_GT_GT_GT] = ACTIONS(3750),
    [anon_sym_LT_LT] = ACTIONS(3750),
    [anon_sym_AMP] = ACTIONS(3748),
    [anon_sym_CARET] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3748),
    [anon_sym_PLUS] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3748),
    [anon_sym_PERCENT] = ACTIONS(3750),
    [anon_sym_STAR_STAR] = ACTIONS(3750),
    [anon_sym_LT_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ] = ACTIONS(3748),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ] = ACTIONS(3748),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3750),
    [anon_sym_GT_EQ] = ACTIONS(3750),
    [anon_sym_instanceof] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3748),
    [anon_sym_PLUS_PLUS] = ACTIONS(3750),
    [anon_sym_DASH_DASH] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3750),
    [sym__automatic_semicolon] = ACTIONS(3750),
  },
  [1068] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3793),
    [anon_sym_RBRACE] = ACTIONS(3793),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3793),
  },
  [1069] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3754),
  },
  [1070] = {
    [anon_sym_STAR] = ACTIONS(3400),
    [anon_sym_as] = ACTIONS(3402),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_COLON] = ACTIONS(3402),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_RBRACK] = ACTIONS(3402),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_QMARK] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_GT_GT] = ACTIONS(3400),
    [anon_sym_GT_GT_GT] = ACTIONS(3402),
    [anon_sym_LT_LT] = ACTIONS(3402),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3402),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3402),
    [anon_sym_STAR_STAR] = ACTIONS(3402),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_EQ_EQ] = ACTIONS(3400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_instanceof] = ACTIONS(3402),
    [anon_sym_BANG] = ACTIONS(3400),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3402),
    [anon_sym_implements] = ACTIONS(3402),
  },
  [1071] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_extends_clause_repeat1] = STATE(2507),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3935),
  },
  [1072] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [1073] = {
    [anon_sym_STAR] = ACTIONS(4137),
    [anon_sym_as] = ACTIONS(4139),
    [anon_sym_LBRACE] = ACTIONS(4139),
    [anon_sym_COMMA] = ACTIONS(4139),
    [anon_sym_RBRACE] = ACTIONS(4139),
    [anon_sym_LPAREN] = ACTIONS(4139),
    [anon_sym_RPAREN] = ACTIONS(4139),
    [anon_sym_in] = ACTIONS(4137),
    [anon_sym_COLON] = ACTIONS(4139),
    [anon_sym_LBRACK] = ACTIONS(4139),
    [anon_sym_RBRACK] = ACTIONS(4139),
    [anon_sym_LT] = ACTIONS(4137),
    [anon_sym_GT] = ACTIONS(4137),
    [anon_sym_SLASH] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4139),
    [anon_sym_QMARK] = ACTIONS(4139),
    [anon_sym_AMP_AMP] = ACTIONS(4139),
    [anon_sym_PIPE_PIPE] = ACTIONS(4139),
    [anon_sym_GT_GT] = ACTIONS(4137),
    [anon_sym_GT_GT_GT] = ACTIONS(4139),
    [anon_sym_LT_LT] = ACTIONS(4139),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_CARET] = ACTIONS(4139),
    [anon_sym_PIPE] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4139),
    [anon_sym_STAR_STAR] = ACTIONS(4139),
    [anon_sym_LT_EQ] = ACTIONS(4139),
    [anon_sym_EQ_EQ] = ACTIONS(4137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4139),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4139),
    [anon_sym_GT_EQ] = ACTIONS(4139),
    [anon_sym_instanceof] = ACTIONS(4139),
    [anon_sym_BANG] = ACTIONS(4137),
    [anon_sym_PLUS_PLUS] = ACTIONS(4139),
    [anon_sym_DASH_DASH] = ACTIONS(4139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4139),
    [anon_sym_implements] = ACTIONS(4139),
  },
  [1074] = {
    [anon_sym_STAR] = ACTIONS(4141),
    [anon_sym_as] = ACTIONS(4143),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_COMMA] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4143),
    [anon_sym_LPAREN] = ACTIONS(4143),
    [anon_sym_RPAREN] = ACTIONS(4143),
    [anon_sym_in] = ACTIONS(4141),
    [anon_sym_COLON] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(4143),
    [anon_sym_RBRACK] = ACTIONS(4143),
    [anon_sym_LT] = ACTIONS(4141),
    [anon_sym_GT] = ACTIONS(4141),
    [anon_sym_SLASH] = ACTIONS(4141),
    [anon_sym_DOT] = ACTIONS(4143),
    [anon_sym_QMARK] = ACTIONS(4143),
    [anon_sym_AMP_AMP] = ACTIONS(4143),
    [anon_sym_PIPE_PIPE] = ACTIONS(4143),
    [anon_sym_GT_GT] = ACTIONS(4141),
    [anon_sym_GT_GT_GT] = ACTIONS(4143),
    [anon_sym_LT_LT] = ACTIONS(4143),
    [anon_sym_AMP] = ACTIONS(4141),
    [anon_sym_CARET] = ACTIONS(4143),
    [anon_sym_PIPE] = ACTIONS(4141),
    [anon_sym_PLUS] = ACTIONS(4141),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_PERCENT] = ACTIONS(4143),
    [anon_sym_STAR_STAR] = ACTIONS(4143),
    [anon_sym_LT_EQ] = ACTIONS(4143),
    [anon_sym_EQ_EQ] = ACTIONS(4141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4143),
    [anon_sym_BANG_EQ] = ACTIONS(4141),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4143),
    [anon_sym_GT_EQ] = ACTIONS(4143),
    [anon_sym_instanceof] = ACTIONS(4143),
    [anon_sym_BANG] = ACTIONS(4141),
    [anon_sym_PLUS_PLUS] = ACTIONS(4143),
    [anon_sym_DASH_DASH] = ACTIONS(4143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4143),
    [anon_sym_implements] = ACTIONS(4143),
  },
  [1075] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3829),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3829),
  },
  [1076] = {
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_as] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_COMMA] = ACTIONS(1191),
    [anon_sym_RBRACE] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_RPAREN] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(1189),
    [anon_sym_COLON] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1191),
    [anon_sym_RBRACK] = ACTIONS(1191),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1191),
    [anon_sym_QMARK] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_GT_GT_GT] = ACTIONS(1191),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PERCENT] = ACTIONS(1191),
    [anon_sym_STAR_STAR] = ACTIONS(1191),
    [anon_sym_LT_EQ] = ACTIONS(1191),
    [anon_sym_EQ_EQ] = ACTIONS(1189),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1191),
    [anon_sym_BANG_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1191),
    [anon_sym_GT_EQ] = ACTIONS(1191),
    [anon_sym_instanceof] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1191),
    [anon_sym_implements] = ACTIONS(1191),
  },
  [1077] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3847),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3847),
  },
  [1078] = {
    [anon_sym_STAR] = ACTIONS(4145),
    [anon_sym_as] = ACTIONS(4147),
    [anon_sym_LBRACE] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_RPAREN] = ACTIONS(4147),
    [anon_sym_in] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_RBRACK] = ACTIONS(4147),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_GT] = ACTIONS(4145),
    [anon_sym_SLASH] = ACTIONS(4145),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_GT_GT] = ACTIONS(4145),
    [anon_sym_GT_GT_GT] = ACTIONS(4147),
    [anon_sym_LT_LT] = ACTIONS(4147),
    [anon_sym_AMP] = ACTIONS(4145),
    [anon_sym_CARET] = ACTIONS(4147),
    [anon_sym_PIPE] = ACTIONS(4145),
    [anon_sym_PLUS] = ACTIONS(4145),
    [anon_sym_DASH] = ACTIONS(4145),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_STAR_STAR] = ACTIONS(4147),
    [anon_sym_LT_EQ] = ACTIONS(4147),
    [anon_sym_EQ_EQ] = ACTIONS(4145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4147),
    [anon_sym_GT_EQ] = ACTIONS(4147),
    [anon_sym_instanceof] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4145),
    [anon_sym_PLUS_PLUS] = ACTIONS(4147),
    [anon_sym_DASH_DASH] = ACTIONS(4147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4147),
    [anon_sym_implements] = ACTIONS(4147),
  },
  [1079] = {
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_as] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_RPAREN] = ACTIONS(1145),
    [anon_sym_in] = ACTIONS(1143),
    [anon_sym_COLON] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_RBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1143),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_SLASH] = ACTIONS(1143),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AMP_AMP] = ACTIONS(1145),
    [anon_sym_PIPE_PIPE] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [anon_sym_GT_GT_GT] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_STAR_STAR] = ACTIONS(1145),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1143),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_instanceof] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_implements] = ACTIONS(1145),
  },
  [1080] = {
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1231),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_RPAREN] = ACTIONS(1231),
    [anon_sym_in] = ACTIONS(1229),
    [anon_sym_COLON] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_RBRACK] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1231),
    [anon_sym_DASH_DASH] = ACTIONS(1231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1231),
    [anon_sym_implements] = ACTIONS(1231),
  },
  [1081] = {
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1277),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_RPAREN] = ACTIONS(1277),
    [anon_sym_in] = ACTIONS(1275),
    [anon_sym_COLON] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_RBRACK] = ACTIONS(1277),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_DOT] = ACTIONS(1277),
    [anon_sym_QMARK] = ACTIONS(1277),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_PIPE_PIPE] = ACTIONS(1277),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_GT_GT_GT] = ACTIONS(1277),
    [anon_sym_LT_LT] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_LT_EQ] = ACTIONS(1277),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1277),
    [anon_sym_BANG_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1277),
    [anon_sym_instanceof] = ACTIONS(1277),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1277),
    [anon_sym_implements] = ACTIONS(1277),
  },
  [1082] = {
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_as] = ACTIONS(4151),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4151),
    [anon_sym_RBRACE] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_RPAREN] = ACTIONS(4151),
    [anon_sym_in] = ACTIONS(4149),
    [anon_sym_COLON] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_RBRACK] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(4149),
    [anon_sym_SLASH] = ACTIONS(4149),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4149),
    [anon_sym_GT_GT_GT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4149),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_PIPE] = ACTIONS(4149),
    [anon_sym_PLUS] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4149),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_STAR_STAR] = ACTIONS(4151),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_EQ_EQ] = ACTIONS(4149),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4149),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4151),
    [anon_sym_instanceof] = ACTIONS(4151),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_PLUS_PLUS] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4151),
    [anon_sym_implements] = ACTIONS(4151),
  },
  [1083] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3814),
  },
  [1084] = {
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_as] = ACTIONS(4155),
    [anon_sym_LBRACE] = ACTIONS(4155),
    [anon_sym_COMMA] = ACTIONS(4155),
    [anon_sym_RBRACE] = ACTIONS(4155),
    [anon_sym_LPAREN] = ACTIONS(4155),
    [anon_sym_RPAREN] = ACTIONS(4155),
    [anon_sym_in] = ACTIONS(4153),
    [anon_sym_COLON] = ACTIONS(4155),
    [anon_sym_LBRACK] = ACTIONS(4155),
    [anon_sym_RBRACK] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4153),
    [anon_sym_GT] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4153),
    [anon_sym_DOT] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4155),
    [anon_sym_AMP_AMP] = ACTIONS(4155),
    [anon_sym_PIPE_PIPE] = ACTIONS(4155),
    [anon_sym_GT_GT] = ACTIONS(4153),
    [anon_sym_GT_GT_GT] = ACTIONS(4155),
    [anon_sym_LT_LT] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_CARET] = ACTIONS(4155),
    [anon_sym_PIPE] = ACTIONS(4153),
    [anon_sym_PLUS] = ACTIONS(4153),
    [anon_sym_DASH] = ACTIONS(4153),
    [anon_sym_PERCENT] = ACTIONS(4155),
    [anon_sym_STAR_STAR] = ACTIONS(4155),
    [anon_sym_LT_EQ] = ACTIONS(4155),
    [anon_sym_EQ_EQ] = ACTIONS(4153),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4155),
    [anon_sym_BANG_EQ] = ACTIONS(4153),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4155),
    [anon_sym_GT_EQ] = ACTIONS(4155),
    [anon_sym_instanceof] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4153),
    [anon_sym_PLUS_PLUS] = ACTIONS(4155),
    [anon_sym_DASH_DASH] = ACTIONS(4155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4155),
    [anon_sym_implements] = ACTIONS(4155),
  },
  [1085] = {
    [anon_sym_STAR] = ACTIONS(4157),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(4159),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(4159),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4159),
    [anon_sym_RBRACK] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4157),
    [anon_sym_GT] = ACTIONS(4157),
    [anon_sym_SLASH] = ACTIONS(4157),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4157),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4157),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4157),
    [anon_sym_DASH] = ACTIONS(4157),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_STAR_STAR] = ACTIONS(4159),
    [anon_sym_LT_EQ] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4159),
    [anon_sym_BANG_EQ] = ACTIONS(4157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4159),
    [anon_sym_GT_EQ] = ACTIONS(4159),
    [anon_sym_instanceof] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4157),
    [anon_sym_PLUS_PLUS] = ACTIONS(4159),
    [anon_sym_DASH_DASH] = ACTIONS(4159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_implements] = ACTIONS(4159),
  },
  [1086] = {
    [anon_sym_STAR] = ACTIONS(4161),
    [anon_sym_as] = ACTIONS(4163),
    [anon_sym_LBRACE] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(4163),
    [anon_sym_RBRACE] = ACTIONS(4163),
    [anon_sym_LPAREN] = ACTIONS(4163),
    [anon_sym_RPAREN] = ACTIONS(4163),
    [anon_sym_in] = ACTIONS(4161),
    [anon_sym_COLON] = ACTIONS(4163),
    [anon_sym_LBRACK] = ACTIONS(4163),
    [anon_sym_RBRACK] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_SLASH] = ACTIONS(4161),
    [anon_sym_DOT] = ACTIONS(4163),
    [anon_sym_QMARK] = ACTIONS(4163),
    [anon_sym_AMP_AMP] = ACTIONS(4163),
    [anon_sym_PIPE_PIPE] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_GT_GT_GT] = ACTIONS(4163),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_CARET] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4161),
    [anon_sym_PERCENT] = ACTIONS(4163),
    [anon_sym_STAR_STAR] = ACTIONS(4163),
    [anon_sym_LT_EQ] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4163),
    [anon_sym_BANG_EQ] = ACTIONS(4161),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4163),
    [anon_sym_GT_EQ] = ACTIONS(4163),
    [anon_sym_instanceof] = ACTIONS(4163),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_PLUS_PLUS] = ACTIONS(4163),
    [anon_sym_DASH_DASH] = ACTIONS(4163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4163),
    [anon_sym_implements] = ACTIONS(4163),
  },
  [1087] = {
    [anon_sym_STAR] = ACTIONS(4165),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [anon_sym_in] = ACTIONS(4165),
    [anon_sym_COLON] = ACTIONS(4167),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_RBRACK] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4165),
    [anon_sym_GT] = ACTIONS(4165),
    [anon_sym_SLASH] = ACTIONS(4165),
    [anon_sym_DOT] = ACTIONS(4167),
    [anon_sym_QMARK] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_GT_GT] = ACTIONS(4165),
    [anon_sym_GT_GT_GT] = ACTIONS(4167),
    [anon_sym_LT_LT] = ACTIONS(4167),
    [anon_sym_AMP] = ACTIONS(4165),
    [anon_sym_CARET] = ACTIONS(4167),
    [anon_sym_PIPE] = ACTIONS(4165),
    [anon_sym_PLUS] = ACTIONS(4165),
    [anon_sym_DASH] = ACTIONS(4165),
    [anon_sym_PERCENT] = ACTIONS(4167),
    [anon_sym_STAR_STAR] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_EQ_EQ] = ACTIONS(4165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_instanceof] = ACTIONS(4167),
    [anon_sym_BANG] = ACTIONS(4165),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4167),
    [anon_sym_implements] = ACTIONS(4167),
  },
  [1088] = {
    [anon_sym_STAR] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4171),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_RPAREN] = ACTIONS(4171),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_COLON] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_RBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_DOT] = ACTIONS(4171),
    [anon_sym_QMARK] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4171),
    [anon_sym_LT_LT] = ACTIONS(4171),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_CARET] = ACTIONS(4171),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_instanceof] = ACTIONS(4171),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4171),
    [anon_sym_implements] = ACTIONS(4171),
  },
  [1089] = {
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_as] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_RBRACE] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_RPAREN] = ACTIONS(4175),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_COLON] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_RBRACK] = ACTIONS(4175),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_DOT] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(4175),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4175),
    [anon_sym_LT_LT] = ACTIONS(4175),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4175),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_STAR_STAR] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_EQ_EQ] = ACTIONS(4173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_instanceof] = ACTIONS(4175),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4175),
    [anon_sym_implements] = ACTIONS(4175),
  },
  [1090] = {
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1129),
    [anon_sym_COMMA] = ACTIONS(1129),
    [anon_sym_RBRACE] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1129),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_COLON] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_RBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1127),
    [anon_sym_GT_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_STAR_STAR] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1129),
    [anon_sym_instanceof] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_implements] = ACTIONS(1129),
  },
  [1091] = {
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_as] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_COLON] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(1267),
    [anon_sym_RBRACK] = ACTIONS(1267),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1267),
    [anon_sym_QMARK] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_GT_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1267),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1267),
    [anon_sym_GT_EQ] = ACTIONS(1267),
    [anon_sym_instanceof] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [anon_sym_implements] = ACTIONS(1267),
  },
  [1092] = {
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_in] = ACTIONS(1255),
    [anon_sym_COLON] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_DOT] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_GT_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_implements] = ACTIONS(1257),
  },
  [1093] = {
    [anon_sym_STAR] = ACTIONS(1245),
    [anon_sym_as] = ACTIONS(1247),
    [anon_sym_LBRACE] = ACTIONS(1247),
    [anon_sym_COMMA] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_RPAREN] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_COLON] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(1247),
    [anon_sym_RBRACK] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1245),
    [anon_sym_GT] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1245),
    [anon_sym_DOT] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_GT_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_CARET] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PERCENT] = ACTIONS(1247),
    [anon_sym_STAR_STAR] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1247),
    [anon_sym_EQ_EQ] = ACTIONS(1245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1247),
    [anon_sym_GT_EQ] = ACTIONS(1247),
    [anon_sym_instanceof] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1245),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1247),
    [anon_sym_implements] = ACTIONS(1247),
  },
  [1094] = {
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_COLON] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_RBRACK] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1119),
    [anon_sym_LT_LT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_STAR_STAR] = ACTIONS(1119),
    [anon_sym_LT_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1119),
    [anon_sym_GT_EQ] = ACTIONS(1119),
    [anon_sym_instanceof] = ACTIONS(1119),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1119),
    [anon_sym_DASH_DASH] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_implements] = ACTIONS(1119),
  },
  [1095] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_in] = ACTIONS(3705),
    [anon_sym_SEMI] = ACTIONS(3709),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3705),
    [anon_sym_GT] = ACTIONS(3705),
    [anon_sym_SLASH] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_GT_GT] = ACTIONS(3705),
    [anon_sym_GT_GT_GT] = ACTIONS(3709),
    [anon_sym_LT_LT] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_CARET] = ACTIONS(3709),
    [anon_sym_PIPE] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_STAR_STAR] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_EQ_EQ] = ACTIONS(3705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_instanceof] = ACTIONS(3709),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3709),
    [sym__automatic_semicolon] = ACTIONS(3709),
  },
  [1096] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4177),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3818),
  },
  [1097] = {
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4182),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_RBRACE] = ACTIONS(4182),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_RPAREN] = ACTIONS(4182),
    [anon_sym_in] = ACTIONS(4180),
    [anon_sym_COLON] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_RBRACK] = ACTIONS(4182),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4182),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4182),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_STAR_STAR] = ACTIONS(4182),
    [anon_sym_LT_EQ] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4182),
    [anon_sym_GT_EQ] = ACTIONS(4182),
    [anon_sym_instanceof] = ACTIONS(4182),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4182),
    [anon_sym_implements] = ACTIONS(4182),
  },
  [1098] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4177),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3816),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3818),
  },
  [1099] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1527),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym__automatic_semicolon] = ACTIONS(3269),
  },
  [1100] = {
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_COLON] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_RBRACK] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1159),
    [anon_sym_QMARK] = ACTIONS(1159),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_instanceof] = ACTIONS(1159),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1159),
    [anon_sym_implements] = ACTIONS(1159),
  },
  [1101] = {
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(1177),
    [anon_sym_in] = ACTIONS(1175),
    [anon_sym_COLON] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1177),
    [anon_sym_RBRACK] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(1175),
    [anon_sym_GT] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1175),
    [anon_sym_DOT] = ACTIONS(1177),
    [anon_sym_QMARK] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(1175),
    [anon_sym_GT_GT_GT] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_PLUS] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1175),
    [anon_sym_PERCENT] = ACTIONS(1177),
    [anon_sym_STAR_STAR] = ACTIONS(1177),
    [anon_sym_LT_EQ] = ACTIONS(1177),
    [anon_sym_EQ_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1177),
    [anon_sym_BANG_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1177),
    [anon_sym_GT_EQ] = ACTIONS(1177),
    [anon_sym_instanceof] = ACTIONS(1177),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1177),
    [anon_sym_DASH_DASH] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [anon_sym_implements] = ACTIONS(1177),
  },
  [1102] = {
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_RPAREN] = ACTIONS(4186),
    [anon_sym_in] = ACTIONS(4184),
    [anon_sym_COLON] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_RBRACK] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_GT] = ACTIONS(4184),
    [anon_sym_SLASH] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_GT_GT] = ACTIONS(4184),
    [anon_sym_GT_GT_GT] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4186),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_CARET] = ACTIONS(4186),
    [anon_sym_PIPE] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4184),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_STAR_STAR] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_instanceof] = ACTIONS(4186),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4186),
    [anon_sym_implements] = ACTIONS(4186),
  },
  [1103] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_annotation] = STATE(3144),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4188),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1104] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1105] = {
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2704),
    [sym_array] = STATE(3170),
    [sym_spread_element] = STATE(2704),
    [sym_string] = STATE(2055),
    [sym_method_definition] = STATE(2704),
    [sym_pair] = STATE(2704),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_accessibility_modifier] = STATE(1827),
    [aux_sym_object_repeat1] = STATE(2706),
    [sym_identifier] = ACTIONS(4193),
    [anon_sym_export] = ACTIONS(4193),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4193),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4195),
    [anon_sym_type] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_async] = ACTIONS(4197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4193),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3991),
    [anon_sym_static] = ACTIONS(4199),
    [anon_sym_get] = ACTIONS(4201),
    [anon_sym_set] = ACTIONS(4201),
    [anon_sym_declare] = ACTIONS(4193),
    [anon_sym_public] = ACTIONS(4203),
    [anon_sym_private] = ACTIONS(4203),
    [anon_sym_protected] = ACTIONS(4203),
    [anon_sym_module] = ACTIONS(4193),
    [anon_sym_any] = ACTIONS(4193),
    [anon_sym_number] = ACTIONS(4193),
    [anon_sym_boolean] = ACTIONS(4193),
    [anon_sym_string] = ACTIONS(4193),
    [anon_sym_symbol] = ACTIONS(4193),
    [sym_readonly] = ACTIONS(4205),
  },
  [1106] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1107] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1108] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1109] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1110] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4190),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1111] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3845),
    [anon_sym_RBRACE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3845),
  },
  [1112] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3874),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3874),
  },
  [1113] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3782),
  },
  [1114] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4207),
    [anon_sym_RBRACE] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3847),
  },
  [1115] = {
    [anon_sym_STAR] = ACTIONS(3744),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_as] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3746),
    [anon_sym_RBRACE] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_in] = ACTIONS(3744),
    [anon_sym_of] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3746),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_GT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3744),
    [anon_sym_GT_GT_GT] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_PIPE] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_STAR_STAR] = ACTIONS(3746),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3746),
    [anon_sym_instanceof] = ACTIONS(3746),
    [anon_sym_BANG] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3746),
    [sym__automatic_semicolon] = ACTIONS(3746),
  },
  [1116] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4212),
    [anon_sym_RBRACE] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3829),
  },
  [1117] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4215),
    [anon_sym_RBRACE] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3845),
  },
  [1118] = {
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_EQ] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_of] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3729),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3731),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [1119] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3858),
  },
  [1120] = {
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_EQ] = ACTIONS(3725),
    [anon_sym_as] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(3725),
    [anon_sym_of] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym_COLON] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3725),
    [anon_sym_GT] = ACTIONS(3725),
    [anon_sym_SLASH] = ACTIONS(3725),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_QMARK] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_GT_GT] = ACTIONS(3725),
    [anon_sym_GT_GT_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_CARET] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_EQ_EQ] = ACTIONS(3725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3727),
    [anon_sym_BANG_EQ] = ACTIONS(3725),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3727),
    [anon_sym_instanceof] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3727),
    [sym__automatic_semicolon] = ACTIONS(3727),
  },
  [1121] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4220),
    [anon_sym_RBRACE] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3874),
  },
  [1122] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3812),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3812),
  },
  [1123] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3860),
    [anon_sym_RBRACE] = ACTIONS(3860),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3860),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3860),
  },
  [1124] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_annotation] = STATE(3020),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4225),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1125] = {
    [anon_sym_STAR] = ACTIONS(3658),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_RBRACE] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3662),
    [anon_sym_RPAREN] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3658),
    [anon_sym_COLON] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3662),
    [anon_sym_RBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_GT] = ACTIONS(3658),
    [anon_sym_SLASH] = ACTIONS(3658),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3658),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3658),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_STAR_STAR] = ACTIONS(3662),
    [anon_sym_LT_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3658),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ] = ACTIONS(3658),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3662),
    [anon_sym_GT_EQ] = ACTIONS(3662),
    [anon_sym_instanceof] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_PLUS_PLUS] = ACTIONS(3662),
    [anon_sym_DASH_DASH] = ACTIONS(3662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3662),
    [anon_sym_implements] = ACTIONS(3662),
  },
  [1126] = {
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_COLON] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_RBRACK] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_implements] = ACTIONS(1235),
  },
  [1127] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3791),
  },
  [1128] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3882),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3882),
  },
  [1129] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3893),
    [anon_sym_RBRACE] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3893),
  },
  [1130] = {
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_as] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_RPAREN] = ACTIONS(2498),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_RBRACK] = ACTIONS(2498),
    [anon_sym_LT] = ACTIONS(2500),
    [anon_sym_GT] = ACTIONS(2500),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_DOT] = ACTIONS(2498),
    [anon_sym_QMARK] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2498),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_GT_GT_GT] = ACTIONS(2498),
    [anon_sym_LT_LT] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_CARET] = ACTIONS(2498),
    [anon_sym_PIPE] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2498),
    [anon_sym_STAR_STAR] = ACTIONS(2498),
    [anon_sym_LT_EQ] = ACTIONS(2498),
    [anon_sym_EQ_EQ] = ACTIONS(2500),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2498),
    [anon_sym_BANG_EQ] = ACTIONS(2500),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2498),
    [anon_sym_GT_EQ] = ACTIONS(2498),
    [anon_sym_instanceof] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2498),
    [anon_sym_implements] = ACTIONS(2498),
  },
  [1131] = {
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_as] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_COLON] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_RBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_PIPE_PIPE] = ACTIONS(2472),
    [anon_sym_GT_GT] = ACTIONS(2474),
    [anon_sym_GT_GT_GT] = ACTIONS(2472),
    [anon_sym_LT_LT] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_CARET] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2472),
    [anon_sym_STAR_STAR] = ACTIONS(2472),
    [anon_sym_LT_EQ] = ACTIONS(2472),
    [anon_sym_EQ_EQ] = ACTIONS(2474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2472),
    [anon_sym_GT_EQ] = ACTIONS(2472),
    [anon_sym_instanceof] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [anon_sym_implements] = ACTIONS(2472),
  },
  [1132] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4177),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3818),
  },
  [1133] = {
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_as] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2559),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_RBRACE] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2559),
    [anon_sym_RPAREN] = ACTIONS(2559),
    [anon_sym_in] = ACTIONS(2561),
    [anon_sym_COLON] = ACTIONS(2559),
    [anon_sym_LBRACK] = ACTIONS(2559),
    [anon_sym_RBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2561),
    [anon_sym_GT] = ACTIONS(2561),
    [anon_sym_SLASH] = ACTIONS(2561),
    [anon_sym_DOT] = ACTIONS(2559),
    [anon_sym_QMARK] = ACTIONS(2559),
    [anon_sym_AMP_AMP] = ACTIONS(2559),
    [anon_sym_PIPE_PIPE] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2559),
    [anon_sym_LT_LT] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_CARET] = ACTIONS(2559),
    [anon_sym_PIPE] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_STAR_STAR] = ACTIONS(2559),
    [anon_sym_LT_EQ] = ACTIONS(2559),
    [anon_sym_EQ_EQ] = ACTIONS(2561),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2559),
    [anon_sym_BANG_EQ] = ACTIONS(2561),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2559),
    [anon_sym_GT_EQ] = ACTIONS(2559),
    [anon_sym_instanceof] = ACTIONS(2559),
    [anon_sym_BANG] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(2559),
    [anon_sym_DASH_DASH] = ACTIONS(2559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2559),
    [anon_sym_implements] = ACTIONS(2559),
  },
  [1134] = {
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_as] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_RPAREN] = ACTIONS(2622),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_COLON] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_RBRACK] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_GT_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(4229),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2622),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_implements] = ACTIONS(2622),
  },
  [1135] = {
    [anon_sym_STAR] = ACTIONS(2458),
    [anon_sym_as] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_RPAREN] = ACTIONS(2456),
    [anon_sym_in] = ACTIONS(2458),
    [anon_sym_COLON] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_RBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_GT] = ACTIONS(2458),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_DOT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2458),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_CARET] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_STAR_STAR] = ACTIONS(2456),
    [anon_sym_LT_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2458),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ] = ACTIONS(2458),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2456),
    [anon_sym_GT_EQ] = ACTIONS(2456),
    [anon_sym_instanceof] = ACTIONS(2456),
    [anon_sym_BANG] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2456),
    [anon_sym_DASH_DASH] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2456),
    [anon_sym_implements] = ACTIONS(2456),
  },
  [1136] = {
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_as] = ACTIONS(2630),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_COLON] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(4229),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_BANG_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2630),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_instanceof] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2630),
    [anon_sym_implements] = ACTIONS(2630),
  },
  [1137] = {
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_as] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_RPAREN] = ACTIONS(2452),
    [anon_sym_in] = ACTIONS(2454),
    [anon_sym_COLON] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2452),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2452),
    [anon_sym_STAR_STAR] = ACTIONS(2452),
    [anon_sym_LT_EQ] = ACTIONS(2452),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2452),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2452),
    [anon_sym_GT_EQ] = ACTIONS(2452),
    [anon_sym_instanceof] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2452),
    [anon_sym_implements] = ACTIONS(2452),
  },
  [1138] = {
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_as] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_RPAREN] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2650),
    [anon_sym_COLON] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_RBRACK] = ACTIONS(2648),
    [anon_sym_LT] = ACTIONS(2650),
    [anon_sym_GT] = ACTIONS(2650),
    [anon_sym_SLASH] = ACTIONS(2650),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2650),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(4229),
    [anon_sym_PLUS] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_STAR_STAR] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2650),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2648),
    [anon_sym_instanceof] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [anon_sym_implements] = ACTIONS(2648),
  },
  [1139] = {
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1211),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_implements] = ACTIONS(1209),
  },
  [1140] = {
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2606),
    [sym_array] = STATE(3170),
    [sym_spread_element] = STATE(2606),
    [sym_string] = STATE(2055),
    [sym_method_definition] = STATE(2606),
    [sym_pair] = STATE(2606),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_accessibility_modifier] = STATE(1827),
    [aux_sym_object_repeat1] = STATE(2610),
    [sym_identifier] = ACTIONS(4231),
    [anon_sym_export] = ACTIONS(4231),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4231),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4233),
    [anon_sym_type] = ACTIONS(4231),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_async] = ACTIONS(4235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4231),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3991),
    [anon_sym_static] = ACTIONS(4237),
    [anon_sym_get] = ACTIONS(4239),
    [anon_sym_set] = ACTIONS(4239),
    [anon_sym_declare] = ACTIONS(4231),
    [anon_sym_public] = ACTIONS(4241),
    [anon_sym_private] = ACTIONS(4241),
    [anon_sym_protected] = ACTIONS(4241),
    [anon_sym_module] = ACTIONS(4231),
    [anon_sym_any] = ACTIONS(4231),
    [anon_sym_number] = ACTIONS(4231),
    [anon_sym_boolean] = ACTIONS(4231),
    [anon_sym_string] = ACTIONS(4231),
    [anon_sym_symbol] = ACTIONS(4231),
    [sym_readonly] = ACTIONS(4243),
  },
  [1141] = {
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(1167),
    [anon_sym_in] = ACTIONS(1169),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_RBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [anon_sym_implements] = ACTIONS(1167),
  },
  [1142] = {
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_RPAREN] = ACTIONS(1181),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_COLON] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [anon_sym_implements] = ACTIONS(1181),
  },
  [1143] = {
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_RBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_implements] = ACTIONS(1133),
  },
  [1144] = {
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_as] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2504),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2504),
    [anon_sym_GT_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_CARET] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PERCENT] = ACTIONS(2502),
    [anon_sym_STAR_STAR] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2504),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2502),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_instanceof] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_implements] = ACTIONS(2502),
  },
  [1145] = {
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_as] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(617),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_COLON] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_RBRACK] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(617),
    [anon_sym_QMARK] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_GT_GT] = ACTIONS(2510),
    [anon_sym_GT_GT_GT] = ACTIONS(617),
    [anon_sym_LT_LT] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_CARET] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(617),
    [anon_sym_STAR_STAR] = ACTIONS(617),
    [anon_sym_LT_EQ] = ACTIONS(617),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(617),
    [anon_sym_instanceof] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(617),
    [anon_sym_DASH_DASH] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [anon_sym_implements] = ACTIONS(617),
  },
  [1146] = {
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_RPAREN] = ACTIONS(2468),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_COLON] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_RBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2468),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(2468),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_GT_GT_GT] = ACTIONS(2468),
    [anon_sym_LT_LT] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2468),
    [anon_sym_STAR_STAR] = ACTIONS(2468),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_implements] = ACTIONS(2468),
  },
  [1147] = {
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_as] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_RPAREN] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2482),
    [anon_sym_COLON] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(4245),
    [anon_sym_RBRACK] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_GT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_QMARK] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_GT_GT] = ACTIONS(2482),
    [anon_sym_GT_GT_GT] = ACTIONS(2480),
    [anon_sym_LT_LT] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_CARET] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PERCENT] = ACTIONS(2480),
    [anon_sym_STAR_STAR] = ACTIONS(2480),
    [anon_sym_LT_EQ] = ACTIONS(2480),
    [anon_sym_EQ_EQ] = ACTIONS(2482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2480),
    [anon_sym_BANG_EQ] = ACTIONS(2482),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2480),
    [anon_sym_GT_EQ] = ACTIONS(2480),
    [anon_sym_instanceof] = ACTIONS(2480),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [anon_sym_implements] = ACTIONS(2480),
  },
  [1148] = {
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_instanceof] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [anon_sym_implements] = ACTIONS(1163),
  },
  [1149] = {
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1235),
  },
  [1150] = {
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_RPAREN] = ACTIONS(1213),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1213),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_AMP_AMP] = ACTIONS(1213),
    [anon_sym_PIPE_PIPE] = ACTIONS(1213),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1213),
    [anon_sym_LT_LT] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1213),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1213),
    [anon_sym_STAR_STAR] = ACTIONS(1213),
    [anon_sym_LT_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1213),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [anon_sym_instanceof] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [anon_sym_implements] = ACTIONS(1213),
  },
  [1151] = {
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_as] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_RBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_GT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(2492),
    [anon_sym_DOT] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_GT_GT_GT] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(2490),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PERCENT] = ACTIONS(2490),
    [anon_sym_STAR_STAR] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2490),
    [anon_sym_EQ_EQ] = ACTIONS(2492),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2492),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2490),
    [anon_sym_GT_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2490),
    [anon_sym_implements] = ACTIONS(2490),
  },
  [1152] = {
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_as] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(2605),
    [anon_sym_RPAREN] = ACTIONS(2605),
    [anon_sym_in] = ACTIONS(2607),
    [anon_sym_COLON] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_RBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(2607),
    [anon_sym_GT] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(2607),
    [anon_sym_DOT] = ACTIONS(3837),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(2605),
    [anon_sym_GT_GT] = ACTIONS(2607),
    [anon_sym_GT_GT_GT] = ACTIONS(2605),
    [anon_sym_LT_LT] = ACTIONS(2605),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_PERCENT] = ACTIONS(2605),
    [anon_sym_STAR_STAR] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(2605),
    [anon_sym_EQ_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(2607),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2605),
    [anon_sym_GT_EQ] = ACTIONS(2605),
    [anon_sym_instanceof] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2605),
    [anon_sym_implements] = ACTIONS(2605),
  },
  [1153] = {
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_as] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_COLON] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(4245),
    [anon_sym_RBRACK] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_SLASH] = ACTIONS(2522),
    [anon_sym_DOT] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_GT_GT] = ACTIONS(2522),
    [anon_sym_GT_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
    [anon_sym_CARET] = ACTIONS(2520),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_PERCENT] = ACTIONS(2520),
    [anon_sym_STAR_STAR] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2520),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2520),
    [anon_sym_BANG_EQ] = ACTIONS(2522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2520),
    [anon_sym_GT_EQ] = ACTIONS(2520),
    [anon_sym_instanceof] = ACTIONS(2520),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_implements] = ACTIONS(2520),
  },
  [1154] = {
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_as] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2512),
    [anon_sym_QMARK] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_GT_GT] = ACTIONS(2514),
    [anon_sym_GT_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2512),
    [anon_sym_STAR_STAR] = ACTIONS(2512),
    [anon_sym_LT_EQ] = ACTIONS(2512),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2512),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2512),
    [anon_sym_GT_EQ] = ACTIONS(2512),
    [anon_sym_instanceof] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_implements] = ACTIONS(2512),
  },
  [1155] = {
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_as] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_RBRACK] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_GT_GT_GT] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_STAR_STAR] = ACTIONS(2506),
    [anon_sym_LT_EQ] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2508),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2508),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2506),
    [anon_sym_GT_EQ] = ACTIONS(2506),
    [anon_sym_instanceof] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_implements] = ACTIONS(2506),
  },
  [1156] = {
    [anon_sym_STAR] = ACTIONS(2446),
    [anon_sym_as] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2444),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_COLON] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2446),
    [anon_sym_DOT] = ACTIONS(2444),
    [anon_sym_QMARK] = ACTIONS(2444),
    [anon_sym_AMP_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2446),
    [anon_sym_GT_GT_GT] = ACTIONS(2444),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_PERCENT] = ACTIONS(2444),
    [anon_sym_STAR_STAR] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2444),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2444),
    [anon_sym_GT_EQ] = ACTIONS(2444),
    [anon_sym_instanceof] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2444),
    [anon_sym_implements] = ACTIONS(2444),
  },
  [1157] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1158] = {
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2430),
    [anon_sym_in] = ACTIONS(2432),
    [anon_sym_COLON] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_RBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2432),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2430),
    [anon_sym_PIPE_PIPE] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2432),
    [anon_sym_GT_GT_GT] = ACTIONS(2430),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_CARET] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_STAR_STAR] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2430),
    [anon_sym_BANG_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2430),
    [anon_sym_instanceof] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [anon_sym_implements] = ACTIONS(2430),
  },
  [1159] = {
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_RPAREN] = ACTIONS(2434),
    [anon_sym_in] = ACTIONS(2436),
    [anon_sym_COLON] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [anon_sym_RBRACK] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2436),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(3740),
    [anon_sym_QMARK] = ACTIONS(2434),
    [anon_sym_AMP_AMP] = ACTIONS(2434),
    [anon_sym_PIPE_PIPE] = ACTIONS(2434),
    [anon_sym_GT_GT] = ACTIONS(2436),
    [anon_sym_GT_GT_GT] = ACTIONS(2434),
    [anon_sym_LT_LT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_CARET] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2434),
    [anon_sym_STAR_STAR] = ACTIONS(2434),
    [anon_sym_LT_EQ] = ACTIONS(2434),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2434),
    [anon_sym_BANG_EQ] = ACTIONS(2436),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2434),
    [anon_sym_GT_EQ] = ACTIONS(2434),
    [anon_sym_instanceof] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [anon_sym_implements] = ACTIONS(2434),
  },
  [1160] = {
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_as] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_RPAREN] = ACTIONS(2476),
    [anon_sym_in] = ACTIONS(2478),
    [anon_sym_COLON] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_GT_GT_GT] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2476),
    [anon_sym_STAR_STAR] = ACTIONS(2476),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_EQ_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_instanceof] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [anon_sym_implements] = ACTIONS(2476),
  },
  [1161] = {
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_as] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_RPAREN] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2400),
    [anon_sym_COLON] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_RBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2400),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_DOT] = ACTIONS(2398),
    [anon_sym_QMARK] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_PIPE_PIPE] = ACTIONS(2398),
    [anon_sym_GT_GT] = ACTIONS(2400),
    [anon_sym_GT_GT_GT] = ACTIONS(2398),
    [anon_sym_LT_LT] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_CARET] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_STAR_STAR] = ACTIONS(2398),
    [anon_sym_LT_EQ] = ACTIONS(2398),
    [anon_sym_EQ_EQ] = ACTIONS(2400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2398),
    [anon_sym_BANG_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2398),
    [anon_sym_GT_EQ] = ACTIONS(2398),
    [anon_sym_instanceof] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [anon_sym_implements] = ACTIONS(2398),
  },
  [1162] = {
    [anon_sym_STAR] = ACTIONS(2547),
    [anon_sym_as] = ACTIONS(2545),
    [anon_sym_LBRACE] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_RPAREN] = ACTIONS(2545),
    [anon_sym_in] = ACTIONS(2547),
    [anon_sym_COLON] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_RBRACK] = ACTIONS(2545),
    [anon_sym_LT] = ACTIONS(2547),
    [anon_sym_GT] = ACTIONS(2547),
    [anon_sym_SLASH] = ACTIONS(2547),
    [anon_sym_DOT] = ACTIONS(2545),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_AMP_AMP] = ACTIONS(2545),
    [anon_sym_PIPE_PIPE] = ACTIONS(2545),
    [anon_sym_GT_GT] = ACTIONS(2547),
    [anon_sym_GT_GT_GT] = ACTIONS(2545),
    [anon_sym_LT_LT] = ACTIONS(2545),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_CARET] = ACTIONS(2545),
    [anon_sym_PIPE] = ACTIONS(2547),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_PERCENT] = ACTIONS(2545),
    [anon_sym_STAR_STAR] = ACTIONS(2545),
    [anon_sym_LT_EQ] = ACTIONS(2545),
    [anon_sym_EQ_EQ] = ACTIONS(2547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2545),
    [anon_sym_BANG_EQ] = ACTIONS(2547),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2545),
    [anon_sym_GT_EQ] = ACTIONS(2545),
    [anon_sym_instanceof] = ACTIONS(2545),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(2545),
    [anon_sym_DASH_DASH] = ACTIONS(2545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2545),
    [anon_sym_implements] = ACTIONS(2545),
  },
  [1163] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1164] = {
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_as] = ACTIONS(2448),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_RPAREN] = ACTIONS(2448),
    [anon_sym_in] = ACTIONS(2450),
    [anon_sym_COLON] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_RBRACK] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2450),
    [anon_sym_DOT] = ACTIONS(2448),
    [anon_sym_QMARK] = ACTIONS(2448),
    [anon_sym_AMP_AMP] = ACTIONS(2448),
    [anon_sym_PIPE_PIPE] = ACTIONS(2448),
    [anon_sym_GT_GT] = ACTIONS(2450),
    [anon_sym_GT_GT_GT] = ACTIONS(2448),
    [anon_sym_LT_LT] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(2448),
    [anon_sym_PIPE] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2448),
    [anon_sym_STAR_STAR] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2448),
    [anon_sym_EQ_EQ] = ACTIONS(2450),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ] = ACTIONS(2450),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2448),
    [anon_sym_GT_EQ] = ACTIONS(2448),
    [anon_sym_instanceof] = ACTIONS(2448),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2448),
    [anon_sym_implements] = ACTIONS(2448),
  },
  [1165] = {
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_RPAREN] = ACTIONS(2486),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_RBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2486),
    [anon_sym_GT_GT] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2486),
    [anon_sym_LT_LT] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_CARET] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2486),
    [anon_sym_STAR_STAR] = ACTIONS(2486),
    [anon_sym_LT_EQ] = ACTIONS(2486),
    [anon_sym_EQ_EQ] = ACTIONS(2488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2486),
    [anon_sym_BANG_EQ] = ACTIONS(2488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2486),
    [anon_sym_GT_EQ] = ACTIONS(2486),
    [anon_sym_instanceof] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [anon_sym_implements] = ACTIONS(2486),
  },
  [1166] = {
    [anon_sym_STAR] = ACTIONS(2496),
    [anon_sym_as] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2494),
    [anon_sym_in] = ACTIONS(2496),
    [anon_sym_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [anon_sym_RBRACK] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2496),
    [anon_sym_GT] = ACTIONS(2496),
    [anon_sym_SLASH] = ACTIONS(2496),
    [anon_sym_DOT] = ACTIONS(2494),
    [anon_sym_QMARK] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2496),
    [anon_sym_GT_GT_GT] = ACTIONS(2494),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_CARET] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PERCENT] = ACTIONS(2494),
    [anon_sym_STAR_STAR] = ACTIONS(2494),
    [anon_sym_LT_EQ] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2494),
    [anon_sym_BANG_EQ] = ACTIONS(2496),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2494),
    [anon_sym_GT_EQ] = ACTIONS(2494),
    [anon_sym_instanceof] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2494),
    [anon_sym_implements] = ACTIONS(2494),
  },
  [1167] = {
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_as] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_RPAREN] = ACTIONS(2394),
    [anon_sym_in] = ACTIONS(2396),
    [anon_sym_COLON] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_RBRACK] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2396),
    [anon_sym_GT] = ACTIONS(2396),
    [anon_sym_SLASH] = ACTIONS(2396),
    [anon_sym_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_PIPE_PIPE] = ACTIONS(2394),
    [anon_sym_GT_GT] = ACTIONS(2396),
    [anon_sym_GT_GT_GT] = ACTIONS(2394),
    [anon_sym_LT_LT] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_CARET] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_PERCENT] = ACTIONS(2394),
    [anon_sym_STAR_STAR] = ACTIONS(2394),
    [anon_sym_LT_EQ] = ACTIONS(2394),
    [anon_sym_EQ_EQ] = ACTIONS(2396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2394),
    [anon_sym_BANG_EQ] = ACTIONS(2396),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2394),
    [anon_sym_GT_EQ] = ACTIONS(2394),
    [anon_sym_instanceof] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2394),
    [anon_sym_implements] = ACTIONS(2394),
  },
  [1168] = {
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_as] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2646),
    [anon_sym_COLON] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_RBRACK] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_GT_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(4229),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_STAR_STAR] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_instanceof] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_implements] = ACTIONS(2644),
  },
  [1169] = {
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_as] = ACTIONS(2634),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_COLON] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2636),
    [anon_sym_GT] = ACTIONS(2636),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_GT_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(4229),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_STAR_STAR] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2634),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_instanceof] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2634),
    [anon_sym_implements] = ACTIONS(2634),
  },
  [1170] = {
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_as] = ACTIONS(2460),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_RPAREN] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_COLON] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_RBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_GT] = ACTIONS(2462),
    [anon_sym_SLASH] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2460),
    [anon_sym_QMARK] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_GT_GT_GT] = ACTIONS(2460),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2460),
    [anon_sym_STAR_STAR] = ACTIONS(2460),
    [anon_sym_LT_EQ] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2460),
    [anon_sym_GT_EQ] = ACTIONS(2460),
    [anon_sym_instanceof] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [anon_sym_implements] = ACTIONS(2460),
  },
  [1171] = {
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_as] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_RPAREN] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_COLON] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_RBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2518),
    [anon_sym_GT] = ACTIONS(2518),
    [anon_sym_SLASH] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2516),
    [anon_sym_QMARK] = ACTIONS(2516),
    [anon_sym_AMP_AMP] = ACTIONS(2516),
    [anon_sym_PIPE_PIPE] = ACTIONS(2516),
    [anon_sym_GT_GT] = ACTIONS(2518),
    [anon_sym_GT_GT_GT] = ACTIONS(2516),
    [anon_sym_LT_LT] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2516),
    [anon_sym_STAR_STAR] = ACTIONS(2516),
    [anon_sym_LT_EQ] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2516),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2516),
    [anon_sym_GT_EQ] = ACTIONS(2516),
    [anon_sym_instanceof] = ACTIONS(2516),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [anon_sym_implements] = ACTIONS(2516),
  },
  [1172] = {
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_as] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_RBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_SLASH] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2466),
    [anon_sym_GT_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_CARET] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2464),
    [anon_sym_STAR_STAR] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2466),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_implements] = ACTIONS(2464),
  },
  [1173] = {
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_as] = ACTIONS(2541),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(2541),
    [anon_sym_RBRACE] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(2541),
    [anon_sym_RPAREN] = ACTIONS(2541),
    [anon_sym_in] = ACTIONS(2543),
    [anon_sym_COLON] = ACTIONS(2541),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_RBRACK] = ACTIONS(2541),
    [anon_sym_LT] = ACTIONS(2543),
    [anon_sym_GT] = ACTIONS(2543),
    [anon_sym_SLASH] = ACTIONS(2543),
    [anon_sym_DOT] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(2541),
    [anon_sym_AMP_AMP] = ACTIONS(2541),
    [anon_sym_PIPE_PIPE] = ACTIONS(2541),
    [anon_sym_GT_GT] = ACTIONS(2543),
    [anon_sym_GT_GT_GT] = ACTIONS(2541),
    [anon_sym_LT_LT] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(2543),
    [anon_sym_CARET] = ACTIONS(2541),
    [anon_sym_PIPE] = ACTIONS(2543),
    [anon_sym_PLUS] = ACTIONS(2543),
    [anon_sym_DASH] = ACTIONS(2543),
    [anon_sym_PERCENT] = ACTIONS(2541),
    [anon_sym_STAR_STAR] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_EQ_EQ] = ACTIONS(2543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2541),
    [anon_sym_BANG_EQ] = ACTIONS(2543),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2541),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_instanceof] = ACTIONS(2541),
    [anon_sym_BANG] = ACTIONS(2543),
    [anon_sym_PLUS_PLUS] = ACTIONS(2541),
    [anon_sym_DASH_DASH] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_implements] = ACTIONS(2541),
  },
  [1174] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3812),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3812),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1175] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1176] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3784),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3784),
  },
  [1177] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3784),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3784),
  },
  [1178] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3784),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4286),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3784),
  },
  [1179] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_COMMA] = ACTIONS(3812),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3812),
  },
  [1180] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3814),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1181] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3791),
  },
  [1182] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3829),
    [anon_sym_COMMA] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3829),
  },
  [1183] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3872),
    [anon_sym_COMMA] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3872),
  },
  [1184] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_COMMA] = ACTIONS(3793),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3793),
  },
  [1185] = {
    [anon_sym_STAR] = ACTIONS(4289),
    [anon_sym_as] = ACTIONS(4289),
    [anon_sym_COMMA] = ACTIONS(4291),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_LPAREN] = ACTIONS(4291),
    [anon_sym_RPAREN] = ACTIONS(4291),
    [anon_sym_in] = ACTIONS(4289),
    [anon_sym_COLON] = ACTIONS(4291),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_RBRACK] = ACTIONS(4291),
    [anon_sym_LT] = ACTIONS(4289),
    [anon_sym_GT] = ACTIONS(4289),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_DOT] = ACTIONS(4291),
    [anon_sym_QMARK] = ACTIONS(4291),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4289),
    [anon_sym_PLUS] = ACTIONS(4289),
    [anon_sym_DASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_STAR_STAR] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4289),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4289),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_instanceof] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4289),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4291),
    [sym_regex_flags] = ACTIONS(4293),
  },
  [1186] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3754),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1187] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3847),
    [anon_sym_COMMA] = ACTIONS(3847),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3847),
  },
  [1188] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3784),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4286),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3784),
  },
  [1189] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3784),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4286),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3784),
  },
  [1190] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3845),
    [anon_sym_COMMA] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3845),
  },
  [1191] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4295),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3839),
  },
  [1192] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1222),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1222),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4299),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1193] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3784),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3784),
  },
  [1194] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_COMMA] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3874),
  },
  [1195] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3782),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1196] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1197] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3882),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3882),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1198] = {
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_as] = ACTIONS(1149),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_else] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_in] = ACTIONS(1151),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_SEMI] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_AMP_AMP] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1149),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_GT_GT_GT] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_CARET] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_PERCENT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1149),
    [anon_sym_GT_EQ] = ACTIONS(1149),
    [anon_sym_instanceof] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [sym__automatic_semicolon] = ACTIONS(1149),
  },
  [1199] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1200] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1201] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3839),
    [anon_sym_COMMA] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3839),
  },
  [1202] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4313),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1203] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4319),
    [anon_sym_set] = ACTIONS(4319),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1204] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3893),
  },
  [1205] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3882),
  },
  [1206] = {
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_else] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(4321),
  },
  [1207] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2605),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4323),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1208] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1210),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1210),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4325),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1209] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2574),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4327),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1210] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1218),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1211] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2629),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4331),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1212] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1218),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4333),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1213] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4335),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1214] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2605),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4337),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1215] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(4339),
  },
  [1216] = {
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1133),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_else] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [1217] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1212),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1212),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4341),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1218] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1218),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(4343),
    [anon_sym_export] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(4346),
    [anon_sym_namespace] = ACTIONS(4343),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_type] = ACTIONS(4343),
    [anon_sym_LBRACK] = ACTIONS(4351),
    [anon_sym_async] = ACTIONS(4354),
    [anon_sym_void] = ACTIONS(4343),
    [anon_sym_DQUOTE] = ACTIONS(4357),
    [anon_sym_SQUOTE] = ACTIONS(4360),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4363),
    [anon_sym_AT] = ACTIONS(4366),
    [anon_sym_static] = ACTIONS(4369),
    [anon_sym_abstract] = ACTIONS(4372),
    [anon_sym_get] = ACTIONS(4375),
    [anon_sym_set] = ACTIONS(4375),
    [anon_sym_declare] = ACTIONS(4343),
    [anon_sym_public] = ACTIONS(4378),
    [anon_sym_private] = ACTIONS(4378),
    [anon_sym_protected] = ACTIONS(4378),
    [anon_sym_module] = ACTIONS(4343),
    [anon_sym_any] = ACTIONS(4343),
    [anon_sym_number] = ACTIONS(4343),
    [anon_sym_boolean] = ACTIONS(4343),
    [anon_sym_string] = ACTIONS(4343),
    [anon_sym_symbol] = ACTIONS(4343),
    [sym_readonly] = ACTIONS(4381),
  },
  [1219] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2624),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4384),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1220] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2674),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4386),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1221] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1224),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1224),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4388),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1222] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1218),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4390),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1223] = {
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_else] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1197),
    [anon_sym_while] = ACTIONS(1195),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1197),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1197),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym__automatic_semicolon] = ACTIONS(1195),
  },
  [1224] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1218),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4392),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1225] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4073),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3782),
  },
  [1226] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3839),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3839),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1227] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3791),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3791),
  },
  [1228] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3882),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3882),
  },
  [1229] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3893),
  },
  [1230] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3782),
  },
  [1231] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3874),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1232] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3845),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1233] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1234] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1235] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1236] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1237] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1238] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4397),
    [anon_sym_COMMA] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3874),
  },
  [1239] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1240] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_COLON] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(4394),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1241] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3814),
  },
  [1242] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3829),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1243] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4399),
    [anon_sym_COMMA] = ACTIONS(3845),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3845),
  },
  [1244] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3872),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3872),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1245] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3793),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3793),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3793),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1246] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3754),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3754),
  },
  [1247] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3847),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1248] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(4401),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
  },
  [1249] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(4401),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
  },
  [1250] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4404),
  },
  [1251] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
  },
  [1252] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
  },
  [1253] = {
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_as] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3878),
    [anon_sym_RBRACE] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3876),
    [anon_sym_SEMI] = ACTIONS(3878),
    [anon_sym_COLON] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3876),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_EQ_GT] = ACTIONS(3880),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_GT_GT] = ACTIONS(3876),
    [anon_sym_GT_GT_GT] = ACTIONS(3878),
    [anon_sym_LT_LT] = ACTIONS(3878),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_CARET] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_LT_EQ] = ACTIONS(3878),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3878),
    [anon_sym_GT_EQ] = ACTIONS(3878),
    [anon_sym_instanceof] = ACTIONS(3878),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3878),
    [sym__automatic_semicolon] = ACTIONS(3878),
  },
  [1254] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4313),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1255] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1256),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1256),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1256] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1218),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4408),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1257] = {
    [sym_arguments] = STATE(1528),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym__automatic_semicolon] = ACTIONS(3269),
  },
  [1258] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
  },
  [1259] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(4401),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3784),
  },
  [1260] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1261] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(3812),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3812),
  },
  [1262] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4313),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1263] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4319),
    [anon_sym_set] = ACTIONS(4319),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1264] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [1265] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4412),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4339),
  },
  [1266] = {
    [sym_arguments] = STATE(1528),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3733),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym__automatic_semicolon] = ACTIONS(3269),
  },
  [1267] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4037),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3814),
  },
  [1268] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4414),
    [anon_sym_COMMA] = ACTIONS(3829),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3829),
  },
  [1269] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2608),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4416),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1270] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4418),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(4420),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4420),
  },
  [1271] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3818),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1272] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3818),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3816),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1273] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2490),
    [sym__automatic_semicolon] = ACTIONS(2490),
  },
  [1274] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4425),
    [anon_sym_COMMA] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3872),
  },
  [1275] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_as] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(4427),
  },
  [1276] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3858),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3858),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1277] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3860),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(3860),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3860),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1278] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4319),
    [anon_sym_set] = ACTIONS(4319),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1279] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4313),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1280] = {
    [sym_type_arguments] = STATE(1519),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_as] = ACTIONS(2532),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(4429),
    [anon_sym_GT] = ACTIONS(2534),
    [anon_sym_SLASH] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(4432),
    [anon_sym_QMARK] = ACTIONS(2532),
    [anon_sym_AMP_AMP] = ACTIONS(2532),
    [anon_sym_PIPE_PIPE] = ACTIONS(2532),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_GT_GT_GT] = ACTIONS(2532),
    [anon_sym_LT_LT] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2534),
    [anon_sym_CARET] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_PERCENT] = ACTIONS(2532),
    [anon_sym_STAR_STAR] = ACTIONS(2532),
    [anon_sym_LT_EQ] = ACTIONS(2532),
    [anon_sym_EQ_EQ] = ACTIONS(2534),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2532),
    [anon_sym_BANG_EQ] = ACTIONS(2534),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2532),
    [anon_sym_GT_EQ] = ACTIONS(2532),
    [anon_sym_instanceof] = ACTIONS(2532),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [anon_sym_is] = ACTIONS(4434),
    [sym__automatic_semicolon] = ACTIONS(2532),
  },
  [1281] = {
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1181),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [sym__automatic_semicolon] = ACTIONS(1181),
  },
  [1282] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(3818),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1283] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4436),
    [anon_sym_COMMA] = ACTIONS(3793),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3793),
  },
  [1284] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4079),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3754),
  },
  [1285] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_COMMA] = ACTIONS(3847),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3847),
  },
  [1286] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4418),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(4440),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4440),
  },
  [1287] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [1288] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4442),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3818),
  },
  [1289] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4319),
    [anon_sym_set] = ACTIONS(4319),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1290] = {
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_else] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_while] = ACTIONS(1209),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1211),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [1291] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3860),
    [anon_sym_COMMA] = ACTIONS(3860),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3860),
  },
  [1292] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4404),
  },
  [1293] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4418),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(4445),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4445),
  },
  [1294] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4113),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3858),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_SLASH] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4119),
    [anon_sym_AMP_AMP] = ACTIONS(4121),
    [anon_sym_PIPE_PIPE] = ACTIONS(4123),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_GT_GT_GT] = ACTIONS(4125),
    [anon_sym_LT_LT] = ACTIONS(4125),
    [anon_sym_AMP] = ACTIONS(4127),
    [anon_sym_CARET] = ACTIONS(4123),
    [anon_sym_PIPE] = ACTIONS(4129),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_STAR_STAR] = ACTIONS(4133),
    [anon_sym_LT_EQ] = ACTIONS(4135),
    [anon_sym_EQ_EQ] = ACTIONS(4115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4135),
    [anon_sym_BANG_EQ] = ACTIONS(4115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4135),
    [anon_sym_GT_EQ] = ACTIONS(4135),
    [anon_sym_instanceof] = ACTIONS(4135),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3858),
  },
  [1295] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2741),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4447),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1296] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4404),
  },
  [1297] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4442),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3816),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3818),
  },
  [1298] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4442),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
    [anon_sym_implements] = ACTIONS(3818),
  },
  [1299] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2608),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4449),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1300] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2649),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4451),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1301] = {
    [sym_object] = STATE(3169),
    [sym_assignment_pattern] = STATE(2815),
    [sym_array] = STATE(3170),
    [sym_spread_element] = STATE(2815),
    [sym_string] = STATE(2055),
    [sym_method_definition] = STATE(2815),
    [sym_pair] = STATE(2815),
    [sym__property_name] = STATE(2055),
    [sym_computed_property_name] = STATE(2055),
    [sym_accessibility_modifier] = STATE(1827),
    [sym_identifier] = ACTIONS(4453),
    [anon_sym_export] = ACTIONS(4453),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(3249),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_type] = ACTIONS(4453),
    [anon_sym_LBRACK] = ACTIONS(3987),
    [anon_sym_async] = ACTIONS(4455),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4453),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3991),
    [anon_sym_static] = ACTIONS(4457),
    [anon_sym_get] = ACTIONS(4459),
    [anon_sym_set] = ACTIONS(4459),
    [anon_sym_declare] = ACTIONS(4453),
    [anon_sym_public] = ACTIONS(4461),
    [anon_sym_private] = ACTIONS(4461),
    [anon_sym_protected] = ACTIONS(4461),
    [anon_sym_module] = ACTIONS(4453),
    [anon_sym_any] = ACTIONS(4453),
    [anon_sym_number] = ACTIONS(4453),
    [anon_sym_boolean] = ACTIONS(4453),
    [anon_sym_string] = ACTIONS(4453),
    [anon_sym_symbol] = ACTIONS(4453),
    [sym_readonly] = ACTIONS(4463),
  },
  [1302] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4404),
  },
  [1303] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3816),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3818),
  },
  [1304] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1218),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1218),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4468),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1305] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3705),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3709),
    [anon_sym_LPAREN] = ACTIONS(3709),
    [anon_sym_in] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3705),
    [anon_sym_GT] = ACTIONS(3705),
    [anon_sym_SLASH] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3709),
    [anon_sym_AMP_AMP] = ACTIONS(3709),
    [anon_sym_PIPE_PIPE] = ACTIONS(3709),
    [anon_sym_GT_GT] = ACTIONS(3705),
    [anon_sym_GT_GT_GT] = ACTIONS(3709),
    [anon_sym_LT_LT] = ACTIONS(3709),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_CARET] = ACTIONS(3709),
    [anon_sym_PIPE] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3709),
    [anon_sym_STAR_STAR] = ACTIONS(3709),
    [anon_sym_LT_EQ] = ACTIONS(3709),
    [anon_sym_EQ_EQ] = ACTIONS(3705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3709),
    [anon_sym_BANG_EQ] = ACTIONS(3705),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3709),
    [anon_sym_GT_EQ] = ACTIONS(3709),
    [anon_sym_instanceof] = ACTIONS(3709),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3709),
    [anon_sym_DASH_DASH] = ACTIONS(3709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3709),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3709),
  },
  [1306] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4470),
    [anon_sym_COMMA] = ACTIONS(3860),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3860),
  },
  [1307] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2605),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4472),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1308] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3816),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3818),
  },
  [1309] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4474),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1310] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4476),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1311] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(3816),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(4465),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3816),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3818),
  },
  [1312] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3941),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_COMMA] = ACTIONS(4418),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3945),
    [anon_sym_SEMI] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3949),
    [anon_sym_GT] = ACTIONS(3945),
    [anon_sym_SLASH] = ACTIONS(3941),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3951),
    [anon_sym_AMP_AMP] = ACTIONS(3953),
    [anon_sym_PIPE_PIPE] = ACTIONS(3955),
    [anon_sym_GT_GT] = ACTIONS(3941),
    [anon_sym_GT_GT_GT] = ACTIONS(3957),
    [anon_sym_LT_LT] = ACTIONS(3957),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(3955),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ] = ACTIONS(3945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ] = ACTIONS(3945),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3967),
    [anon_sym_GT_EQ] = ACTIONS(3967),
    [anon_sym_instanceof] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3803),
  },
  [1313] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1583),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3269),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3269),
  },
  [1314] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [sym__automatic_semicolon] = ACTIONS(1111),
  },
  [1315] = {
    [sym_template_string] = STATE(1703),
    [sym_arguments] = STATE(1703),
    [sym_type_arguments] = STATE(2478),
    [anon_sym_STAR] = ACTIONS(3901),
    [anon_sym_as] = ACTIONS(3903),
    [anon_sym_LBRACE] = ACTIONS(4478),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3911),
    [anon_sym_GT] = ACTIONS(3907),
    [anon_sym_SLASH] = ACTIONS(3901),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(3913),
    [anon_sym_AMP_AMP] = ACTIONS(3915),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3901),
    [anon_sym_GT_GT_GT] = ACTIONS(3919),
    [anon_sym_LT_LT] = ACTIONS(3919),
    [anon_sym_AMP] = ACTIONS(3921),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3925),
    [anon_sym_DASH] = ACTIONS(3925),
    [anon_sym_PERCENT] = ACTIONS(3919),
    [anon_sym_STAR_STAR] = ACTIONS(3927),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3931),
    [anon_sym_PLUS_PLUS] = ACTIONS(3933),
    [anon_sym_DASH_DASH] = ACTIONS(3933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3858),
  },
  [1316] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(4404),
    [anon_sym_RBRACE] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4404),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1317] = {
    [sym_string] = STATE(1871),
    [sym_decorator] = STATE(1304),
    [sym_public_field_definition] = STATE(2663),
    [sym_method_definition] = STATE(1781),
    [sym__property_name] = STATE(1871),
    [sym_computed_property_name] = STATE(1871),
    [sym_method_signature] = STATE(2663),
    [sym_abstract_method_signature] = STATE(2663),
    [sym_accessibility_modifier] = STATE(1814),
    [sym_index_signature] = STATE(2663),
    [aux_sym_class_body_repeat1] = STATE(1304),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4297),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(4480),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_async] = ACTIONS(4301),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4303),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4305),
    [anon_sym_abstract] = ACTIONS(4307),
    [anon_sym_get] = ACTIONS(4309),
    [anon_sym_set] = ACTIONS(4309),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3598),
    [anon_sym_private] = ACTIONS(3598),
    [anon_sym_protected] = ACTIONS(3598),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4311),
  },
  [1318] = {
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_else] = ACTIONS(1213),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1213),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1213),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_AMP_AMP] = ACTIONS(1213),
    [anon_sym_PIPE_PIPE] = ACTIONS(1213),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1213),
    [anon_sym_LT_LT] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1213),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1213),
    [anon_sym_STAR_STAR] = ACTIONS(1213),
    [anon_sym_LT_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1213),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [anon_sym_instanceof] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [sym__automatic_semicolon] = ACTIONS(1213),
  },
  [1319] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [aux_sym_array_repeat1] = STATE(2724),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1320] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1321] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1322] = {
    [sym_arguments] = STATE(1586),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3269),
  },
  [1323] = {
    [sym_arguments] = STATE(1586),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_EQ] = ACTIONS(3733),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3269),
  },
  [1324] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1217),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1325] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3847),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3847),
  },
  [1326] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3754),
  },
  [1327] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4510),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4510),
  },
  [1328] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3793),
  },
  [1329] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3872),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3872),
  },
  [1330] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4512),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1331] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4514),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4514),
  },
  [1332] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4516),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1333] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3829),
  },
  [1334] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4518),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1335] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3814),
  },
  [1336] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3812),
  },
  [1337] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_RBRACE] = ACTIONS(4520),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1338] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4522),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1339] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4524),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1340] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4527),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1341] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [1342] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(4427),
  },
  [1343] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1344] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4529),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1345] = {
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_as] = ACTIONS(1191),
    [anon_sym_COMMA] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(1189),
    [anon_sym_while] = ACTIONS(1185),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1191),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1191),
    [anon_sym_QMARK] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_GT_GT_GT] = ACTIONS(1191),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PERCENT] = ACTIONS(1191),
    [anon_sym_STAR_STAR] = ACTIONS(1191),
    [anon_sym_LT_EQ] = ACTIONS(1191),
    [anon_sym_EQ_EQ] = ACTIONS(1189),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1191),
    [anon_sym_BANG_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1191),
    [anon_sym_GT_EQ] = ACTIONS(1191),
    [anon_sym_instanceof] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1191),
    [sym__automatic_semicolon] = ACTIONS(1193),
  },
  [1346] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1347] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4524),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1348] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2468),
    [sym__automatic_semicolon] = ACTIONS(2468),
  },
  [1349] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3786),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4524),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3786),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(3786),
    [anon_sym_GT_GT_GT] = ACTIONS(3784),
    [anon_sym_LT_LT] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3786),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1350] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3845),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3845),
  },
  [1351] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3874),
  },
  [1352] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_RBRACE] = ACTIONS(4531),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1353] = {
    [sym_type_arguments] = STATE(1622),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_as] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(4533),
    [anon_sym_GT] = ACTIONS(2534),
    [anon_sym_SLASH] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_QMARK] = ACTIONS(2532),
    [anon_sym_AMP_AMP] = ACTIONS(2532),
    [anon_sym_PIPE_PIPE] = ACTIONS(2532),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_GT_GT_GT] = ACTIONS(2532),
    [anon_sym_LT_LT] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2534),
    [anon_sym_CARET] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_PERCENT] = ACTIONS(2532),
    [anon_sym_STAR_STAR] = ACTIONS(2532),
    [anon_sym_LT_EQ] = ACTIONS(2532),
    [anon_sym_EQ_EQ] = ACTIONS(2534),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2532),
    [anon_sym_BANG_EQ] = ACTIONS(2534),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2532),
    [anon_sym_GT_EQ] = ACTIONS(2532),
    [anon_sym_instanceof] = ACTIONS(2532),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [anon_sym_is] = ACTIONS(4538),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2532),
  },
  [1354] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3782),
  },
  [1355] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3818),
  },
  [1356] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3816),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3818),
  },
  [1357] = {
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_as] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_else] = ACTIONS(1139),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_in] = ACTIONS(1143),
    [anon_sym_while] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1143),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_SLASH] = ACTIONS(1143),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AMP_AMP] = ACTIONS(1145),
    [anon_sym_PIPE_PIPE] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [anon_sym_GT_GT_GT] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_STAR_STAR] = ACTIONS(1145),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1143),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_instanceof] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [sym__automatic_semicolon] = ACTIONS(1147),
  },
  [1358] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3858),
  },
  [1359] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3860),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3860),
  },
  [1360] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4543),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1361] = {
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_EQ] = ACTIONS(3713),
    [anon_sym_as] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(4545),
    [anon_sym_in] = ACTIONS(3713),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(4550),
    [anon_sym_GT] = ACTIONS(3713),
    [anon_sym_SLASH] = ACTIONS(3713),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(4545),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_GT_GT] = ACTIONS(3713),
    [anon_sym_GT_GT_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(3713),
    [anon_sym_CARET] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(3713),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_EQ_EQ] = ACTIONS(3713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3715),
    [anon_sym_BANG_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3715),
    [anon_sym_instanceof] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [sym__automatic_semicolon] = ACTIONS(3715),
  },
  [1362] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2611),
    [sym__automatic_semicolon] = ACTIONS(2611),
  },
  [1363] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(4553),
    [anon_sym_RBRACE] = ACTIONS(4553),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1364] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3786),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3784),
    [anon_sym_AMP_AMP] = ACTIONS(3784),
    [anon_sym_PIPE_PIPE] = ACTIONS(3784),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_CARET] = ACTIONS(3784),
    [anon_sym_PIPE] = ACTIONS(3786),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(3784),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3784),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3784),
    [anon_sym_GT_EQ] = ACTIONS(3784),
    [anon_sym_instanceof] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3784),
  },
  [1365] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4555),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4555),
  },
  [1366] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4313),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1367] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(4210),
    [anon_sym_RBRACE] = ACTIONS(4210),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1368] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2444),
    [sym__automatic_semicolon] = ACTIONS(2444),
  },
  [1369] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3816),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3816),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3816),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3816),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3816),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3816),
    [anon_sym_PLUS] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3816),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3816),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3818),
  },
  [1370] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1371] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3893),
  },
  [1372] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3882),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3882),
  },
  [1373] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3791),
  },
  [1374] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1375] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4559),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4559),
  },
  [1376] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(4218),
    [anon_sym_RBRACE] = ACTIONS(4218),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1377] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(4223),
    [anon_sym_RBRACE] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1378] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4484),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(4561),
    [anon_sym_of] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1379] = {
    [sym_template_string] = STATE(1461),
    [sym_arguments] = STATE(1461),
    [sym_type_arguments] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(4486),
    [anon_sym_as] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(3839),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4490),
    [anon_sym_GT] = ACTIONS(4488),
    [anon_sym_SLASH] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4486),
    [anon_sym_GT_GT_GT] = ACTIONS(4498),
    [anon_sym_LT_LT] = ACTIONS(4498),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4502),
    [anon_sym_PLUS] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_PERCENT] = ACTIONS(4498),
    [anon_sym_STAR_STAR] = ACTIONS(4506),
    [anon_sym_LT_EQ] = ACTIONS(4508),
    [anon_sym_EQ_EQ] = ACTIONS(4488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4508),
    [anon_sym_BANG_EQ] = ACTIONS(4488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4508),
    [anon_sym_GT_EQ] = ACTIONS(4508),
    [anon_sym_instanceof] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3839),
  },
  [1380] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1381] = {
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_in] = ACTIONS(1175),
    [anon_sym_while] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(1175),
    [anon_sym_GT] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1175),
    [anon_sym_DOT] = ACTIONS(1177),
    [anon_sym_QMARK] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(1175),
    [anon_sym_GT_GT_GT] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_PLUS] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1175),
    [anon_sym_PERCENT] = ACTIONS(1177),
    [anon_sym_STAR_STAR] = ACTIONS(1177),
    [anon_sym_LT_EQ] = ACTIONS(1177),
    [anon_sym_EQ_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1177),
    [anon_sym_BANG_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1177),
    [anon_sym_GT_EQ] = ACTIONS(1177),
    [anon_sym_instanceof] = ACTIONS(1177),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1177),
    [anon_sym_DASH_DASH] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym__automatic_semicolon] = ACTIONS(1179),
  },
  [1382] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4543),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(4566),
    [anon_sym_of] = ACTIONS(4569),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1383] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1384] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4571),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1385] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4319),
    [anon_sym_set] = ACTIONS(4319),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1386] = {
    [sym_arguments] = STATE(1528),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_SEMI] = ACTIONS(3269),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [sym__automatic_semicolon] = ACTIONS(3269),
  },
  [1387] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4573),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1388] = {
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_else] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1159),
    [anon_sym_QMARK] = ACTIONS(1159),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_instanceof] = ACTIONS(1159),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1159),
    [sym__automatic_semicolon] = ACTIONS(1161),
  },
  [1389] = {
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_else] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_in] = ACTIONS(1229),
    [anon_sym_while] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1231),
    [anon_sym_DASH_DASH] = ACTIONS(1231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1231),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [1390] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4575),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1391] = {
    [sym_string] = STATE(1872),
    [sym__property_name] = STATE(1872),
    [sym_computed_property_name] = STATE(1872),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4577),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4579),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4581),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_abstract] = ACTIONS(4583),
    [anon_sym_get] = ACTIONS(4585),
    [anon_sym_set] = ACTIONS(4585),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1392] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4587),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1393] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(4589),
  },
  [1394] = {
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_else] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_while] = ACTIONS(1113),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1119),
    [anon_sym_LT_LT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_STAR_STAR] = ACTIONS(1119),
    [anon_sym_LT_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1119),
    [anon_sym_GT_EQ] = ACTIONS(1119),
    [anon_sym_instanceof] = ACTIONS(1119),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1119),
    [anon_sym_DASH_DASH] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym__automatic_semicolon] = ACTIONS(1121),
  },
  [1395] = {
    [sym_string] = STATE(1867),
    [sym__property_name] = STATE(1867),
    [sym_computed_property_name] = STATE(1867),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4591),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4593),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4595),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_abstract] = ACTIONS(4597),
    [anon_sym_get] = ACTIONS(4599),
    [anon_sym_set] = ACTIONS(4599),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1396] = {
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(1277),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_else] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_in] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_DOT] = ACTIONS(1277),
    [anon_sym_QMARK] = ACTIONS(1277),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_PIPE_PIPE] = ACTIONS(1277),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_GT_GT_GT] = ACTIONS(1277),
    [anon_sym_LT_LT] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_LT_EQ] = ACTIONS(1277),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1277),
    [anon_sym_BANG_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1277),
    [anon_sym_instanceof] = ACTIONS(1277),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1277),
    [sym__automatic_semicolon] = ACTIONS(1279),
  },
  [1397] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4601),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1398] = {
    [anon_sym_STAR] = ACTIONS(1245),
    [anon_sym_as] = ACTIONS(1247),
    [anon_sym_COMMA] = ACTIONS(1247),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1245),
    [anon_sym_GT] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1245),
    [anon_sym_DOT] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_GT_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_CARET] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PERCENT] = ACTIONS(1247),
    [anon_sym_STAR_STAR] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1247),
    [anon_sym_EQ_EQ] = ACTIONS(1245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1247),
    [anon_sym_GT_EQ] = ACTIONS(1247),
    [anon_sym_instanceof] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1245),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1247),
    [sym__automatic_semicolon] = ACTIONS(1249),
  },
  [1399] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4603),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1400] = {
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_else] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_in] = ACTIONS(1255),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_DOT] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_GT_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [sym__automatic_semicolon] = ACTIONS(1259),
  },
  [1401] = {
    [sym_type_arguments] = STATE(1523),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_as] = ACTIONS(2611),
    [anon_sym_COMMA] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2611),
    [anon_sym_in] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(4605),
    [anon_sym_GT] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_DOT] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2611),
    [anon_sym_GT_GT] = ACTIONS(2613),
    [anon_sym_GT_GT_GT] = ACTIONS(2611),
    [anon_sym_LT_LT] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PERCENT] = ACTIONS(2611),
    [anon_sym_STAR_STAR] = ACTIONS(2611),
    [anon_sym_LT_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(2613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2611),
    [anon_sym_BANG_EQ] = ACTIONS(2613),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2611),
    [anon_sym_GT_EQ] = ACTIONS(2611),
    [anon_sym_instanceof] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2613),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2611),
    [sym__automatic_semicolon] = ACTIONS(2611),
  },
  [1402] = {
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_as] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_while] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(1267),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1267),
    [anon_sym_QMARK] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_GT_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1267),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1267),
    [anon_sym_GT_EQ] = ACTIONS(1267),
    [anon_sym_instanceof] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [sym__automatic_semicolon] = ACTIONS(1269),
  },
  [1403] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1404] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1405] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4610),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1406] = {
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_as] = ACTIONS(3878),
    [anon_sym_LBRACE] = ACTIONS(3876),
    [anon_sym_COMMA] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3876),
    [anon_sym_COLON] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3876),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_EQ_GT] = ACTIONS(3880),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_GT_GT] = ACTIONS(3876),
    [anon_sym_GT_GT_GT] = ACTIONS(3878),
    [anon_sym_LT_LT] = ACTIONS(3878),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_CARET] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_LT_EQ] = ACTIONS(3878),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3878),
    [anon_sym_GT_EQ] = ACTIONS(3878),
    [anon_sym_instanceof] = ACTIONS(3878),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3878),
  },
  [1407] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3801),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(4612),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1408] = {
    [anon_sym_STAR] = ACTIONS(4289),
    [anon_sym_as] = ACTIONS(4289),
    [anon_sym_COMMA] = ACTIONS(4291),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_LPAREN] = ACTIONS(4291),
    [anon_sym_in] = ACTIONS(4289),
    [anon_sym_SEMI] = ACTIONS(4291),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_LT] = ACTIONS(4289),
    [anon_sym_GT] = ACTIONS(4289),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_DOT] = ACTIONS(4291),
    [anon_sym_QMARK] = ACTIONS(4291),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4289),
    [anon_sym_PLUS] = ACTIONS(4289),
    [anon_sym_DASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_STAR_STAR] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4289),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4289),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_instanceof] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4289),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4291),
    [sym_regex_flags] = ACTIONS(4614),
    [sym__automatic_semicolon] = ACTIONS(4291),
  },
  [1409] = {
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(1129),
    [anon_sym_COMMA] = ACTIONS(1129),
    [anon_sym_else] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1129),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1127),
    [anon_sym_GT_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_STAR_STAR] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1129),
    [anon_sym_instanceof] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [sym__automatic_semicolon] = ACTIONS(1131),
  },
  [1410] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(3752),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(3758),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3752),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3764),
    [anon_sym_GT_GT] = ACTIONS(3752),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3764),
    [anon_sym_PIPE] = ACTIONS(3770),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3776),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3776),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3776),
    [anon_sym_GT_EQ] = ACTIONS(3776),
    [anon_sym_instanceof] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1411] = {
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [sym__automatic_semicolon] = ACTIONS(1207),
  },
  [1412] = {
    [anon_sym_STAR] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4171),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_SEMI] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_DOT] = ACTIONS(4171),
    [anon_sym_QMARK] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4171),
    [anon_sym_LT_LT] = ACTIONS(4171),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_CARET] = ACTIONS(4171),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_instanceof] = ACTIONS(4171),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4171),
    [sym__automatic_semicolon] = ACTIONS(4171),
  },
  [1413] = {
    [anon_sym_STAR] = ACTIONS(3748),
    [anon_sym_EQ] = ACTIONS(3748),
    [anon_sym_as] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(3748),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_LPAREN] = ACTIONS(3750),
    [anon_sym_in] = ACTIONS(3748),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [anon_sym_LT] = ACTIONS(3748),
    [anon_sym_GT] = ACTIONS(3748),
    [anon_sym_SLASH] = ACTIONS(3748),
    [anon_sym_DOT] = ACTIONS(3750),
    [anon_sym_QMARK] = ACTIONS(3750),
    [anon_sym_AMP_AMP] = ACTIONS(3750),
    [anon_sym_PIPE_PIPE] = ACTIONS(3750),
    [anon_sym_GT_GT] = ACTIONS(3748),
    [anon_sym_GT_GT_GT] = ACTIONS(3750),
    [anon_sym_LT_LT] = ACTIONS(3750),
    [anon_sym_AMP] = ACTIONS(3748),
    [anon_sym_CARET] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3748),
    [anon_sym_PLUS] = ACTIONS(3748),
    [anon_sym_DASH] = ACTIONS(3748),
    [anon_sym_PERCENT] = ACTIONS(3750),
    [anon_sym_STAR_STAR] = ACTIONS(3750),
    [anon_sym_LT_EQ] = ACTIONS(3750),
    [anon_sym_EQ_EQ] = ACTIONS(3748),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ] = ACTIONS(3748),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3750),
    [anon_sym_GT_EQ] = ACTIONS(3750),
    [anon_sym_instanceof] = ACTIONS(3750),
    [anon_sym_BANG] = ACTIONS(3748),
    [anon_sym_PLUS_PLUS] = ACTIONS(3750),
    [anon_sym_DASH_DASH] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3750),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3750),
  },
  [1414] = {
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_EQ] = ACTIONS(3729),
    [anon_sym_as] = ACTIONS(3731),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_LPAREN] = ACTIONS(3731),
    [anon_sym_in] = ACTIONS(3729),
    [anon_sym_LBRACK] = ACTIONS(3731),
    [anon_sym_LT] = ACTIONS(3729),
    [anon_sym_GT] = ACTIONS(3729),
    [anon_sym_SLASH] = ACTIONS(3729),
    [anon_sym_DOT] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3731),
    [anon_sym_AMP_AMP] = ACTIONS(3731),
    [anon_sym_PIPE_PIPE] = ACTIONS(3731),
    [anon_sym_GT_GT] = ACTIONS(3729),
    [anon_sym_GT_GT_GT] = ACTIONS(3731),
    [anon_sym_LT_LT] = ACTIONS(3731),
    [anon_sym_AMP] = ACTIONS(3729),
    [anon_sym_CARET] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(3729),
    [anon_sym_PLUS] = ACTIONS(3729),
    [anon_sym_DASH] = ACTIONS(3729),
    [anon_sym_PERCENT] = ACTIONS(3731),
    [anon_sym_STAR_STAR] = ACTIONS(3731),
    [anon_sym_LT_EQ] = ACTIONS(3731),
    [anon_sym_EQ_EQ] = ACTIONS(3729),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3731),
    [anon_sym_BANG_EQ] = ACTIONS(3729),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3731),
    [anon_sym_GT_EQ] = ACTIONS(3731),
    [anon_sym_instanceof] = ACTIONS(3731),
    [anon_sym_BANG] = ACTIONS(3729),
    [anon_sym_PLUS_PLUS] = ACTIONS(3731),
    [anon_sym_DASH_DASH] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3731),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3731),
  },
  [1415] = {
    [sym_statement_block] = STATE(1630),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(4616),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1095),
  },
  [1416] = {
    [sym_statement_block] = STATE(1630),
    [anon_sym_STAR] = ACTIONS(1097),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(4616),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1097),
    [anon_sym_GT] = ACTIONS(1097),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1095),
  },
  [1417] = {
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_in] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_GT] = ACTIONS(4184),
    [anon_sym_SLASH] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_GT_GT] = ACTIONS(4184),
    [anon_sym_GT_GT_GT] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4186),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_CARET] = ACTIONS(4186),
    [anon_sym_PIPE] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4184),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_STAR_STAR] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_instanceof] = ACTIONS(4186),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4186),
    [sym__automatic_semicolon] = ACTIONS(4186),
  },
  [1418] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(4620),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1419] = {
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
    [anon_sym_SEMI] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4075),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [sym__automatic_semicolon] = ACTIONS(4077),
  },
  [1420] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
  },
  [1421] = {
    [anon_sym_STAR] = ACTIONS(4165),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_in] = ACTIONS(4165),
    [anon_sym_SEMI] = ACTIONS(4167),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4165),
    [anon_sym_GT] = ACTIONS(4165),
    [anon_sym_SLASH] = ACTIONS(4165),
    [anon_sym_DOT] = ACTIONS(4167),
    [anon_sym_QMARK] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_GT_GT] = ACTIONS(4165),
    [anon_sym_GT_GT_GT] = ACTIONS(4167),
    [anon_sym_LT_LT] = ACTIONS(4167),
    [anon_sym_AMP] = ACTIONS(4165),
    [anon_sym_CARET] = ACTIONS(4167),
    [anon_sym_PIPE] = ACTIONS(4165),
    [anon_sym_PLUS] = ACTIONS(4165),
    [anon_sym_DASH] = ACTIONS(4165),
    [anon_sym_PERCENT] = ACTIONS(4167),
    [anon_sym_STAR_STAR] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_EQ_EQ] = ACTIONS(4165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_instanceof] = ACTIONS(4167),
    [anon_sym_BANG] = ACTIONS(4165),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4167),
    [sym__automatic_semicolon] = ACTIONS(4167),
  },
  [1422] = {
    [anon_sym_STAR] = ACTIONS(4081),
    [anon_sym_as] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4081),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4081),
    [anon_sym_GT] = ACTIONS(4081),
    [anon_sym_SLASH] = ACTIONS(4081),
    [anon_sym_DOT] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE] = ACTIONS(4083),
    [anon_sym_GT_GT] = ACTIONS(4081),
    [anon_sym_GT_GT_GT] = ACTIONS(4083),
    [anon_sym_LT_LT] = ACTIONS(4083),
    [anon_sym_AMP] = ACTIONS(4081),
    [anon_sym_CARET] = ACTIONS(4083),
    [anon_sym_PIPE] = ACTIONS(4081),
    [anon_sym_PLUS] = ACTIONS(4081),
    [anon_sym_DASH] = ACTIONS(4081),
    [anon_sym_PERCENT] = ACTIONS(4083),
    [anon_sym_STAR_STAR] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_EQ_EQ] = ACTIONS(4081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4083),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_instanceof] = ACTIONS(4083),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_PLUS_PLUS] = ACTIONS(4083),
    [anon_sym_DASH_DASH] = ACTIONS(4083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4083),
    [sym__automatic_semicolon] = ACTIONS(4083),
  },
  [1423] = {
    [sym_string] = STATE(2156),
    [sym__property_name] = STATE(2156),
    [sym_computed_property_name] = STATE(2156),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4577),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4622),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4624),
    [anon_sym_set] = ACTIONS(4624),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1424] = {
    [sym_string] = STATE(1872),
    [sym__property_name] = STATE(1872),
    [sym_computed_property_name] = STATE(1872),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4577),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4579),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4581),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4585),
    [anon_sym_set] = ACTIONS(4585),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1425] = {
    [sym_string] = STATE(1872),
    [sym__property_name] = STATE(1872),
    [sym_computed_property_name] = STATE(1872),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4577),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4579),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4581),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4585),
    [anon_sym_set] = ACTIONS(4585),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4626),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1426] = {
    [sym_string] = STATE(2124),
    [sym__property_name] = STATE(2124),
    [sym_computed_property_name] = STATE(2124),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4628),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4630),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4632),
    [anon_sym_set] = ACTIONS(4632),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1427] = {
    [sym_string] = STATE(1876),
    [sym__property_name] = STATE(1876),
    [sym_computed_property_name] = STATE(1876),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4628),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4634),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4636),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4638),
    [anon_sym_set] = ACTIONS(4638),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4640),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1428] = {
    [sym_string] = STATE(1876),
    [sym__property_name] = STATE(1876),
    [sym_computed_property_name] = STATE(1876),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4628),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4634),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4636),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4638),
    [anon_sym_set] = ACTIONS(4638),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1429] = {
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_as] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2504),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2504),
    [anon_sym_GT_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_CARET] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PERCENT] = ACTIONS(2502),
    [anon_sym_STAR_STAR] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2504),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2502),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_instanceof] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [sym__automatic_semicolon] = ACTIONS(2502),
  },
  [1430] = {
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_in] = ACTIONS(4085),
    [anon_sym_SEMI] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_DOT] = ACTIONS(4087),
    [anon_sym_QMARK] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4087),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_STAR_STAR] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4085),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_instanceof] = ACTIONS(4087),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4087),
    [sym__automatic_semicolon] = ACTIONS(4087),
  },
  [1431] = {
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_as] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(617),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(617),
    [anon_sym_QMARK] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_GT_GT] = ACTIONS(2510),
    [anon_sym_GT_GT_GT] = ACTIONS(617),
    [anon_sym_LT_LT] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_CARET] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(617),
    [anon_sym_STAR_STAR] = ACTIONS(617),
    [anon_sym_LT_EQ] = ACTIONS(617),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(617),
    [anon_sym_instanceof] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(617),
    [anon_sym_DASH_DASH] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [sym__automatic_semicolon] = ACTIONS(617),
  },
  [1432] = {
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2468),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(2468),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_GT_GT_GT] = ACTIONS(2468),
    [anon_sym_LT_LT] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2468),
    [anon_sym_STAR_STAR] = ACTIONS(2468),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [sym__automatic_semicolon] = ACTIONS(2468),
  },
  [1433] = {
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_as] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(4642),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_GT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_QMARK] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_GT_GT] = ACTIONS(2482),
    [anon_sym_GT_GT_GT] = ACTIONS(2480),
    [anon_sym_LT_LT] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_CARET] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PERCENT] = ACTIONS(2480),
    [anon_sym_STAR_STAR] = ACTIONS(2480),
    [anon_sym_LT_EQ] = ACTIONS(2480),
    [anon_sym_EQ_EQ] = ACTIONS(2482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2480),
    [anon_sym_BANG_EQ] = ACTIONS(2482),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2480),
    [anon_sym_GT_EQ] = ACTIONS(2480),
    [anon_sym_instanceof] = ACTIONS(2480),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [sym__automatic_semicolon] = ACTIONS(2480),
  },
  [1434] = {
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(3893),
    [anon_sym_COMMA] = ACTIONS(3893),
    [anon_sym_RBRACE] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(4089),
    [anon_sym_SEMI] = ACTIONS(3893),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_LT] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(3893),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_STAR_STAR] = ACTIONS(3893),
    [anon_sym_LT_EQ] = ACTIONS(3893),
    [anon_sym_EQ_EQ] = ACTIONS(4089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(4089),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3893),
    [anon_sym_GT_EQ] = ACTIONS(3893),
    [anon_sym_instanceof] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3893),
    [anon_sym_DASH_DASH] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [sym__automatic_semicolon] = ACTIONS(3893),
  },
  [1435] = {
    [sym_string] = STATE(1881),
    [sym__property_name] = STATE(1881),
    [sym_computed_property_name] = STATE(1881),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4644),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4646),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4648),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4650),
    [anon_sym_set] = ACTIONS(4650),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4652),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1436] = {
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(4093),
    [anon_sym_COMMA] = ACTIONS(4093),
    [anon_sym_RBRACE] = ACTIONS(4093),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_in] = ACTIONS(4091),
    [anon_sym_SEMI] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_GT] = ACTIONS(4091),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4093),
    [anon_sym_LT_LT] = ACTIONS(4093),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_CARET] = ACTIONS(4093),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_PLUS] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4091),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_STAR_STAR] = ACTIONS(4093),
    [anon_sym_LT_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ] = ACTIONS(4091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4093),
    [anon_sym_GT_EQ] = ACTIONS(4093),
    [anon_sym_instanceof] = ACTIONS(4093),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_PLUS_PLUS] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4093),
    [sym__automatic_semicolon] = ACTIONS(4093),
  },
  [1437] = {
    [anon_sym_STAR] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(3882),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3882),
    [anon_sym_in] = ACTIONS(4099),
    [anon_sym_SEMI] = ACTIONS(3882),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LT] = ACTIONS(4099),
    [anon_sym_GT] = ACTIONS(4099),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_DOT] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3882),
    [anon_sym_AMP_AMP] = ACTIONS(3882),
    [anon_sym_PIPE_PIPE] = ACTIONS(3882),
    [anon_sym_GT_GT] = ACTIONS(4099),
    [anon_sym_GT_GT_GT] = ACTIONS(3882),
    [anon_sym_LT_LT] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(4099),
    [anon_sym_CARET] = ACTIONS(3882),
    [anon_sym_PIPE] = ACTIONS(4099),
    [anon_sym_PLUS] = ACTIONS(4099),
    [anon_sym_DASH] = ACTIONS(4099),
    [anon_sym_PERCENT] = ACTIONS(3882),
    [anon_sym_STAR_STAR] = ACTIONS(3882),
    [anon_sym_LT_EQ] = ACTIONS(3882),
    [anon_sym_EQ_EQ] = ACTIONS(4099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3882),
    [anon_sym_BANG_EQ] = ACTIONS(4099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3882),
    [anon_sym_GT_EQ] = ACTIONS(3882),
    [anon_sym_instanceof] = ACTIONS(3882),
    [anon_sym_BANG] = ACTIONS(4099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3882),
    [sym__automatic_semicolon] = ACTIONS(3882),
  },
  [1438] = {
    [anon_sym_STAR] = ACTIONS(4111),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_RBRACE] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(4111),
    [anon_sym_SEMI] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(4111),
    [anon_sym_GT] = ACTIONS(4111),
    [anon_sym_SLASH] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3791),
    [anon_sym_AMP_AMP] = ACTIONS(3791),
    [anon_sym_PIPE_PIPE] = ACTIONS(3791),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_GT_GT_GT] = ACTIONS(3791),
    [anon_sym_LT_LT] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(3791),
    [anon_sym_PIPE] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_STAR_STAR] = ACTIONS(3791),
    [anon_sym_LT_EQ] = ACTIONS(3791),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3791),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3791),
    [anon_sym_GT_EQ] = ACTIONS(3791),
    [anon_sym_instanceof] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(4111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3791),
    [sym__automatic_semicolon] = ACTIONS(3791),
  },
  [1439] = {
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_as] = ACTIONS(3897),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_RBRACE] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3897),
    [anon_sym_in] = ACTIONS(3895),
    [anon_sym_SEMI] = ACTIONS(3897),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_SLASH] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3897),
    [anon_sym_QMARK] = ACTIONS(3897),
    [anon_sym_AMP_AMP] = ACTIONS(3897),
    [anon_sym_PIPE_PIPE] = ACTIONS(3897),
    [anon_sym_GT_GT] = ACTIONS(3895),
    [anon_sym_GT_GT_GT] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_CARET] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3897),
    [anon_sym_STAR_STAR] = ACTIONS(3897),
    [anon_sym_LT_EQ] = ACTIONS(3897),
    [anon_sym_EQ_EQ] = ACTIONS(3895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3897),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3897),
    [anon_sym_GT_EQ] = ACTIONS(3897),
    [anon_sym_instanceof] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(3895),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3897),
    [sym__automatic_semicolon] = ACTIONS(3897),
  },
  [1440] = {
    [anon_sym_STAR] = ACTIONS(4039),
    [anon_sym_as] = ACTIONS(4041),
    [anon_sym_COMMA] = ACTIONS(4041),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_LPAREN] = ACTIONS(4041),
    [anon_sym_in] = ACTIONS(4039),
    [anon_sym_SEMI] = ACTIONS(4041),
    [anon_sym_LBRACK] = ACTIONS(4041),
    [anon_sym_LT] = ACTIONS(4039),
    [anon_sym_GT] = ACTIONS(4039),
    [anon_sym_SLASH] = ACTIONS(4039),
    [anon_sym_DOT] = ACTIONS(4041),
    [anon_sym_QMARK] = ACTIONS(4041),
    [anon_sym_AMP_AMP] = ACTIONS(4041),
    [anon_sym_PIPE_PIPE] = ACTIONS(4041),
    [anon_sym_GT_GT] = ACTIONS(4039),
    [anon_sym_GT_GT_GT] = ACTIONS(4041),
    [anon_sym_LT_LT] = ACTIONS(4041),
    [anon_sym_AMP] = ACTIONS(4039),
    [anon_sym_CARET] = ACTIONS(4041),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4039),
    [anon_sym_DASH] = ACTIONS(4039),
    [anon_sym_PERCENT] = ACTIONS(4041),
    [anon_sym_STAR_STAR] = ACTIONS(4041),
    [anon_sym_LT_EQ] = ACTIONS(4041),
    [anon_sym_EQ_EQ] = ACTIONS(4039),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4041),
    [anon_sym_BANG_EQ] = ACTIONS(4039),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4041),
    [anon_sym_GT_EQ] = ACTIONS(4041),
    [anon_sym_instanceof] = ACTIONS(4041),
    [anon_sym_BANG] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4041),
    [anon_sym_DASH_DASH] = ACTIONS(4041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4041),
    [sym__automatic_semicolon] = ACTIONS(4041),
  },
  [1441] = {
    [anon_sym_STAR] = ACTIONS(3717),
    [anon_sym_EQ] = ACTIONS(3717),
    [anon_sym_as] = ACTIONS(3719),
    [anon_sym_LBRACE] = ACTIONS(3717),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_LPAREN] = ACTIONS(3719),
    [anon_sym_in] = ACTIONS(3717),
    [anon_sym_LBRACK] = ACTIONS(3719),
    [anon_sym_LT] = ACTIONS(3717),
    [anon_sym_GT] = ACTIONS(3717),
    [anon_sym_SLASH] = ACTIONS(3717),
    [anon_sym_DOT] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3719),
    [anon_sym_AMP_AMP] = ACTIONS(3719),
    [anon_sym_PIPE_PIPE] = ACTIONS(3719),
    [anon_sym_GT_GT] = ACTIONS(3717),
    [anon_sym_GT_GT_GT] = ACTIONS(3719),
    [anon_sym_LT_LT] = ACTIONS(3719),
    [anon_sym_AMP] = ACTIONS(3717),
    [anon_sym_CARET] = ACTIONS(3719),
    [anon_sym_PIPE] = ACTIONS(3717),
    [anon_sym_PLUS] = ACTIONS(3717),
    [anon_sym_DASH] = ACTIONS(3717),
    [anon_sym_PERCENT] = ACTIONS(3719),
    [anon_sym_STAR_STAR] = ACTIONS(3719),
    [anon_sym_LT_EQ] = ACTIONS(3719),
    [anon_sym_EQ_EQ] = ACTIONS(3717),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3719),
    [anon_sym_BANG_EQ] = ACTIONS(3717),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3719),
    [anon_sym_GT_EQ] = ACTIONS(3719),
    [anon_sym_instanceof] = ACTIONS(3719),
    [anon_sym_BANG] = ACTIONS(3717),
    [anon_sym_PLUS_PLUS] = ACTIONS(3719),
    [anon_sym_DASH_DASH] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3719),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3719),
  },
  [1442] = {
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1133),
    [sym__automatic_semicolon] = ACTIONS(4654),
  },
  [1443] = {
    [sym_string] = STATE(1881),
    [sym__property_name] = STATE(1881),
    [sym_computed_property_name] = STATE(1881),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4644),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4646),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4648),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4650),
    [anon_sym_set] = ACTIONS(4650),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1444] = {
    [sym_string] = STATE(2134),
    [sym__property_name] = STATE(2134),
    [sym_computed_property_name] = STATE(2134),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4644),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4656),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4658),
    [anon_sym_set] = ACTIONS(4658),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1445] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1109),
  },
  [1446] = {
    [anon_sym_STAR] = ACTIONS(3713),
    [anon_sym_EQ] = ACTIONS(3713),
    [anon_sym_as] = ACTIONS(3715),
    [anon_sym_LBRACE] = ACTIONS(3713),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(3715),
    [anon_sym_in] = ACTIONS(3713),
    [anon_sym_LBRACK] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3713),
    [anon_sym_GT] = ACTIONS(3713),
    [anon_sym_SLASH] = ACTIONS(3713),
    [anon_sym_DOT] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3715),
    [anon_sym_AMP_AMP] = ACTIONS(3715),
    [anon_sym_PIPE_PIPE] = ACTIONS(3715),
    [anon_sym_GT_GT] = ACTIONS(3713),
    [anon_sym_GT_GT_GT] = ACTIONS(3715),
    [anon_sym_LT_LT] = ACTIONS(3715),
    [anon_sym_AMP] = ACTIONS(3713),
    [anon_sym_CARET] = ACTIONS(3715),
    [anon_sym_PIPE] = ACTIONS(3713),
    [anon_sym_PLUS] = ACTIONS(3713),
    [anon_sym_DASH] = ACTIONS(3713),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_STAR_STAR] = ACTIONS(3715),
    [anon_sym_LT_EQ] = ACTIONS(3715),
    [anon_sym_EQ_EQ] = ACTIONS(3713),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3715),
    [anon_sym_BANG_EQ] = ACTIONS(3713),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3715),
    [anon_sym_GT_EQ] = ACTIONS(3715),
    [anon_sym_instanceof] = ACTIONS(3715),
    [anon_sym_BANG] = ACTIONS(3713),
    [anon_sym_PLUS_PLUS] = ACTIONS(3715),
    [anon_sym_DASH_DASH] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3715),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3715),
  },
  [1447] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1448] = {
    [anon_sym_STAR] = ACTIONS(3744),
    [anon_sym_EQ] = ACTIONS(3744),
    [anon_sym_as] = ACTIONS(3746),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_COMMA] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3746),
    [anon_sym_in] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3744),
    [anon_sym_GT] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3744),
    [anon_sym_GT_GT_GT] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_PIPE] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [anon_sym_STAR_STAR] = ACTIONS(3746),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3746),
    [anon_sym_instanceof] = ACTIONS(3746),
    [anon_sym_BANG] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3746),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3746),
  },
  [1449] = {
    [sym_string] = STATE(1883),
    [sym__property_name] = STATE(1883),
    [sym_computed_property_name] = STATE(1883),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4660),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4662),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4664),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4666),
    [anon_sym_set] = ACTIONS(4666),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1450] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(3976),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1451] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1452] = {
    [anon_sym_STAR] = ACTIONS(3400),
    [anon_sym_as] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_QMARK] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_GT_GT] = ACTIONS(3400),
    [anon_sym_GT_GT_GT] = ACTIONS(3402),
    [anon_sym_LT_LT] = ACTIONS(3402),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3402),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3402),
    [anon_sym_STAR_STAR] = ACTIONS(3402),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_EQ_EQ] = ACTIONS(3400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_instanceof] = ACTIONS(3402),
    [anon_sym_BANG] = ACTIONS(3400),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3402),
    [sym__automatic_semicolon] = ACTIONS(3402),
  },
  [1453] = {
    [anon_sym_STAR] = ACTIONS(3721),
    [anon_sym_EQ] = ACTIONS(3721),
    [anon_sym_as] = ACTIONS(3723),
    [anon_sym_LBRACE] = ACTIONS(3721),
    [anon_sym_COMMA] = ACTIONS(3723),
    [anon_sym_LPAREN] = ACTIONS(3723),
    [anon_sym_in] = ACTIONS(3721),
    [anon_sym_LBRACK] = ACTIONS(3723),
    [anon_sym_LT] = ACTIONS(3721),
    [anon_sym_GT] = ACTIONS(3721),
    [anon_sym_SLASH] = ACTIONS(3721),
    [anon_sym_DOT] = ACTIONS(3723),
    [anon_sym_QMARK] = ACTIONS(3723),
    [anon_sym_AMP_AMP] = ACTIONS(3723),
    [anon_sym_PIPE_PIPE] = ACTIONS(3723),
    [anon_sym_GT_GT] = ACTIONS(3721),
    [anon_sym_GT_GT_GT] = ACTIONS(3723),
    [anon_sym_LT_LT] = ACTIONS(3723),
    [anon_sym_AMP] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3723),
    [anon_sym_PIPE] = ACTIONS(3721),
    [anon_sym_PLUS] = ACTIONS(3721),
    [anon_sym_DASH] = ACTIONS(3721),
    [anon_sym_PERCENT] = ACTIONS(3723),
    [anon_sym_STAR_STAR] = ACTIONS(3723),
    [anon_sym_LT_EQ] = ACTIONS(3723),
    [anon_sym_EQ_EQ] = ACTIONS(3721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3723),
    [anon_sym_BANG_EQ] = ACTIONS(3721),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3723),
    [anon_sym_GT_EQ] = ACTIONS(3723),
    [anon_sym_instanceof] = ACTIONS(3723),
    [anon_sym_BANG] = ACTIONS(3721),
    [anon_sym_PLUS_PLUS] = ACTIONS(3723),
    [anon_sym_DASH_DASH] = ACTIONS(3723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3723),
  },
  [1454] = {
    [sym_string] = STATE(1883),
    [sym__property_name] = STATE(1883),
    [sym_computed_property_name] = STATE(1883),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4660),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4662),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4664),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4666),
    [anon_sym_set] = ACTIONS(4666),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4668),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1455] = {
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [sym__automatic_semicolon] = ACTIONS(1205),
  },
  [1456] = {
    [anon_sym_STAR] = ACTIONS(3725),
    [anon_sym_EQ] = ACTIONS(3725),
    [anon_sym_as] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(3727),
    [anon_sym_in] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3725),
    [anon_sym_GT] = ACTIONS(3725),
    [anon_sym_SLASH] = ACTIONS(3725),
    [anon_sym_DOT] = ACTIONS(3727),
    [anon_sym_QMARK] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3727),
    [anon_sym_PIPE_PIPE] = ACTIONS(3727),
    [anon_sym_GT_GT] = ACTIONS(3725),
    [anon_sym_GT_GT_GT] = ACTIONS(3727),
    [anon_sym_LT_LT] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3725),
    [anon_sym_CARET] = ACTIONS(3727),
    [anon_sym_PIPE] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3727),
    [anon_sym_STAR_STAR] = ACTIONS(3727),
    [anon_sym_LT_EQ] = ACTIONS(3727),
    [anon_sym_EQ_EQ] = ACTIONS(3725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3727),
    [anon_sym_BANG_EQ] = ACTIONS(3725),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3727),
    [anon_sym_instanceof] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3727),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3727),
  },
  [1457] = {
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_as] = ACTIONS(4175),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_RBRACE] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_SEMI] = ACTIONS(4175),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_DOT] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(4175),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4175),
    [anon_sym_LT_LT] = ACTIONS(4175),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4175),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_STAR_STAR] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_EQ_EQ] = ACTIONS(4173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_instanceof] = ACTIONS(4175),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4175),
    [sym__automatic_semicolon] = ACTIONS(4175),
  },
  [1458] = {
    [anon_sym_STAR] = ACTIONS(4161),
    [anon_sym_as] = ACTIONS(4163),
    [anon_sym_COMMA] = ACTIONS(4163),
    [anon_sym_RBRACE] = ACTIONS(4163),
    [anon_sym_LPAREN] = ACTIONS(4163),
    [anon_sym_in] = ACTIONS(4161),
    [anon_sym_SEMI] = ACTIONS(4163),
    [anon_sym_LBRACK] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_SLASH] = ACTIONS(4161),
    [anon_sym_DOT] = ACTIONS(4163),
    [anon_sym_QMARK] = ACTIONS(4163),
    [anon_sym_AMP_AMP] = ACTIONS(4163),
    [anon_sym_PIPE_PIPE] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_GT_GT_GT] = ACTIONS(4163),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_CARET] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4161),
    [anon_sym_PERCENT] = ACTIONS(4163),
    [anon_sym_STAR_STAR] = ACTIONS(4163),
    [anon_sym_LT_EQ] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4163),
    [anon_sym_BANG_EQ] = ACTIONS(4161),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4163),
    [anon_sym_GT_EQ] = ACTIONS(4163),
    [anon_sym_instanceof] = ACTIONS(4163),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_PLUS_PLUS] = ACTIONS(4163),
    [anon_sym_DASH_DASH] = ACTIONS(4163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4163),
    [sym__automatic_semicolon] = ACTIONS(4163),
  },
  [1459] = {
    [anon_sym_STAR] = ACTIONS(4289),
    [anon_sym_as] = ACTIONS(4289),
    [anon_sym_LBRACE] = ACTIONS(4291),
    [anon_sym_COMMA] = ACTIONS(4291),
    [anon_sym_LPAREN] = ACTIONS(4291),
    [anon_sym_in] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_LT] = ACTIONS(4289),
    [anon_sym_GT] = ACTIONS(4289),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_DOT] = ACTIONS(4291),
    [anon_sym_QMARK] = ACTIONS(4291),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4289),
    [anon_sym_PLUS] = ACTIONS(4289),
    [anon_sym_DASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_STAR_STAR] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4289),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4289),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_instanceof] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4289),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4291),
    [sym_regex_flags] = ACTIONS(4293),
    [anon_sym_implements] = ACTIONS(4289),
  },
  [1460] = {
    [sym_string] = STATE(1873),
    [sym__property_name] = STATE(1873),
    [sym_computed_property_name] = STATE(1873),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4670),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4672),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4674),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4676),
    [anon_sym_set] = ACTIONS(4676),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1461] = {
    [anon_sym_STAR] = ACTIONS(4145),
    [anon_sym_as] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_in] = ACTIONS(4145),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_GT] = ACTIONS(4145),
    [anon_sym_SLASH] = ACTIONS(4145),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_GT_GT] = ACTIONS(4145),
    [anon_sym_GT_GT_GT] = ACTIONS(4147),
    [anon_sym_LT_LT] = ACTIONS(4147),
    [anon_sym_AMP] = ACTIONS(4145),
    [anon_sym_CARET] = ACTIONS(4147),
    [anon_sym_PIPE] = ACTIONS(4145),
    [anon_sym_PLUS] = ACTIONS(4145),
    [anon_sym_DASH] = ACTIONS(4145),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_STAR_STAR] = ACTIONS(4147),
    [anon_sym_LT_EQ] = ACTIONS(4147),
    [anon_sym_EQ_EQ] = ACTIONS(4145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4147),
    [anon_sym_GT_EQ] = ACTIONS(4147),
    [anon_sym_instanceof] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4145),
    [anon_sym_PLUS_PLUS] = ACTIONS(4147),
    [anon_sym_DASH_DASH] = ACTIONS(4147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4147),
    [sym__automatic_semicolon] = ACTIONS(4147),
  },
  [1462] = {
    [sym_type_arguments] = STATE(1621),
    [anon_sym_STAR] = ACTIONS(2613),
    [anon_sym_as] = ACTIONS(2611),
    [anon_sym_LBRACE] = ACTIONS(2613),
    [anon_sym_COMMA] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2611),
    [anon_sym_in] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(4678),
    [anon_sym_GT] = ACTIONS(2613),
    [anon_sym_SLASH] = ACTIONS(2613),
    [anon_sym_DOT] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_PIPE_PIPE] = ACTIONS(2611),
    [anon_sym_GT_GT] = ACTIONS(2613),
    [anon_sym_GT_GT_GT] = ACTIONS(2611),
    [anon_sym_LT_LT] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_CARET] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PERCENT] = ACTIONS(2611),
    [anon_sym_STAR_STAR] = ACTIONS(2611),
    [anon_sym_LT_EQ] = ACTIONS(2611),
    [anon_sym_EQ_EQ] = ACTIONS(2613),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2611),
    [anon_sym_BANG_EQ] = ACTIONS(2613),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2611),
    [anon_sym_GT_EQ] = ACTIONS(2611),
    [anon_sym_instanceof] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2613),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2611),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2611),
  },
  [1463] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(4681),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1464] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4683),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1465] = {
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(1129),
    [anon_sym_COMMA] = ACTIONS(1129),
    [anon_sym_RBRACE] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1129),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1127),
    [anon_sym_GT_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_STAR_STAR] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1129),
    [anon_sym_instanceof] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [sym__automatic_semicolon] = ACTIONS(1129),
  },
  [1466] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(4685),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(4688),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(4690),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4685),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1467] = {
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_as] = ACTIONS(1103),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_COMMA] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1103),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_QMARK] = ACTIONS(1103),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_GT_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_STAR_STAR] = ACTIONS(1103),
    [anon_sym_LT_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1103),
    [anon_sym_GT_EQ] = ACTIONS(1103),
    [anon_sym_instanceof] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1103),
    [anon_sym_DASH_DASH] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1103),
    [sym__automatic_semicolon] = ACTIONS(4589),
  },
  [1468] = {
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_as] = ACTIONS(1267),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(1267),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1267),
    [anon_sym_QMARK] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_GT_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1267),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1267),
    [anon_sym_GT_EQ] = ACTIONS(1267),
    [anon_sym_instanceof] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [sym__automatic_semicolon] = ACTIONS(1267),
  },
  [1469] = {
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_in] = ACTIONS(1255),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_DOT] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_GT_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [sym__automatic_semicolon] = ACTIONS(1257),
  },
  [1470] = {
    [anon_sym_STAR] = ACTIONS(1245),
    [anon_sym_as] = ACTIONS(1247),
    [anon_sym_COMMA] = ACTIONS(1247),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1245),
    [anon_sym_GT] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1245),
    [anon_sym_DOT] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_GT_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_CARET] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PERCENT] = ACTIONS(1247),
    [anon_sym_STAR_STAR] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1247),
    [anon_sym_EQ_EQ] = ACTIONS(1245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1247),
    [anon_sym_GT_EQ] = ACTIONS(1247),
    [anon_sym_instanceof] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1245),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1247),
    [sym__automatic_semicolon] = ACTIONS(1247),
  },
  [1471] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1472] = {
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1119),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1119),
    [anon_sym_LT_LT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_STAR_STAR] = ACTIONS(1119),
    [anon_sym_LT_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1119),
    [anon_sym_GT_EQ] = ACTIONS(1119),
    [anon_sym_instanceof] = ACTIONS(1119),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1119),
    [anon_sym_DASH_DASH] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [sym__automatic_semicolon] = ACTIONS(1119),
  },
  [1473] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1474] = {
    [anon_sym_STAR] = ACTIONS(4103),
    [anon_sym_as] = ACTIONS(4105),
    [anon_sym_COMMA] = ACTIONS(4105),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_LPAREN] = ACTIONS(4105),
    [anon_sym_in] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4103),
    [anon_sym_GT] = ACTIONS(4103),
    [anon_sym_SLASH] = ACTIONS(4103),
    [anon_sym_DOT] = ACTIONS(4105),
    [anon_sym_QMARK] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_GT_GT_GT] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_AMP] = ACTIONS(4103),
    [anon_sym_CARET] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4103),
    [anon_sym_PLUS] = ACTIONS(4103),
    [anon_sym_DASH] = ACTIONS(4103),
    [anon_sym_PERCENT] = ACTIONS(4105),
    [anon_sym_STAR_STAR] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_BANG_EQ] = ACTIONS(4103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4105),
    [anon_sym_GT_EQ] = ACTIONS(4105),
    [anon_sym_instanceof] = ACTIONS(4105),
    [anon_sym_BANG] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4105),
    [anon_sym_DASH_DASH] = ACTIONS(4105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4105),
    [sym__automatic_semicolon] = ACTIONS(4105),
  },
  [1475] = {
    [sym_string] = STATE(2201),
    [sym__property_name] = STATE(2201),
    [sym_computed_property_name] = STATE(2201),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4670),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4703),
    [anon_sym_set] = ACTIONS(4703),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1476] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1109),
  },
  [1477] = {
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(4097),
    [anon_sym_COMMA] = ACTIONS(4097),
    [anon_sym_RBRACE] = ACTIONS(4097),
    [anon_sym_LPAREN] = ACTIONS(4097),
    [anon_sym_in] = ACTIONS(4095),
    [anon_sym_SEMI] = ACTIONS(4097),
    [anon_sym_LBRACK] = ACTIONS(4097),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_SLASH] = ACTIONS(4095),
    [anon_sym_DOT] = ACTIONS(4097),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4097),
    [anon_sym_PIPE_PIPE] = ACTIONS(4097),
    [anon_sym_GT_GT] = ACTIONS(4095),
    [anon_sym_GT_GT_GT] = ACTIONS(4097),
    [anon_sym_LT_LT] = ACTIONS(4097),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym_CARET] = ACTIONS(4097),
    [anon_sym_PIPE] = ACTIONS(4095),
    [anon_sym_PLUS] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4095),
    [anon_sym_PERCENT] = ACTIONS(4097),
    [anon_sym_STAR_STAR] = ACTIONS(4097),
    [anon_sym_LT_EQ] = ACTIONS(4097),
    [anon_sym_EQ_EQ] = ACTIONS(4095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4097),
    [anon_sym_BANG_EQ] = ACTIONS(4095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4097),
    [anon_sym_GT_EQ] = ACTIONS(4097),
    [anon_sym_instanceof] = ACTIONS(4097),
    [anon_sym_BANG] = ACTIONS(4095),
    [anon_sym_PLUS_PLUS] = ACTIONS(4097),
    [anon_sym_DASH_DASH] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4097),
    [sym__automatic_semicolon] = ACTIONS(4097),
  },
  [1478] = {
    [anon_sym_STAR] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(3782),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_in] = ACTIONS(4073),
    [anon_sym_SEMI] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_SLASH] = ACTIONS(4073),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_GT_GT] = ACTIONS(4073),
    [anon_sym_GT_GT_GT] = ACTIONS(3782),
    [anon_sym_LT_LT] = ACTIONS(3782),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_STAR_STAR] = ACTIONS(3782),
    [anon_sym_LT_EQ] = ACTIONS(3782),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(4073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3782),
    [anon_sym_GT_EQ] = ACTIONS(3782),
    [anon_sym_instanceof] = ACTIONS(3782),
    [anon_sym_BANG] = ACTIONS(4073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3782),
    [anon_sym_DASH_DASH] = ACTIONS(3782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3782),
    [sym__automatic_semicolon] = ACTIONS(3782),
  },
  [1479] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4705),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1480] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1481] = {
    [anon_sym_STAR] = ACTIONS(4069),
    [anon_sym_as] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(4071),
    [anon_sym_in] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(4071),
    [anon_sym_LBRACK] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_SLASH] = ACTIONS(4069),
    [anon_sym_DOT] = ACTIONS(4071),
    [anon_sym_QMARK] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_GT_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4069),
    [anon_sym_CARET] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_PERCENT] = ACTIONS(4071),
    [anon_sym_STAR_STAR] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4071),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_instanceof] = ACTIONS(4071),
    [anon_sym_BANG] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [sym__automatic_semicolon] = ACTIONS(4071),
  },
  [1482] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(4710),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(4710),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4710),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1483] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4715),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(4718),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(4718),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(4721),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4718),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1484] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(3578),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1485] = {
    [sym_string] = STATE(2180),
    [sym__property_name] = STATE(2180),
    [sym_computed_property_name] = STATE(2180),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4660),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4723),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4725),
    [anon_sym_set] = ACTIONS(4725),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1486] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(4727),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1487] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(3976),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1488] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1489] = {
    [sym_string] = STATE(2167),
    [sym__property_name] = STATE(2167),
    [sym_computed_property_name] = STATE(2167),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4729),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4731),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4733),
    [anon_sym_set] = ACTIONS(4733),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1490] = {
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4182),
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_RBRACE] = ACTIONS(4182),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_in] = ACTIONS(4180),
    [anon_sym_SEMI] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4182),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4182),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_STAR_STAR] = ACTIONS(4182),
    [anon_sym_LT_EQ] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4182),
    [anon_sym_GT_EQ] = ACTIONS(4182),
    [anon_sym_instanceof] = ACTIONS(4182),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4182),
    [sym__automatic_semicolon] = ACTIONS(4182),
  },
  [1491] = {
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_as] = ACTIONS(4045),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_RBRACE] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4043),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_QMARK] = ACTIONS(4045),
    [anon_sym_AMP_AMP] = ACTIONS(4045),
    [anon_sym_PIPE_PIPE] = ACTIONS(4045),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_GT_GT_GT] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_STAR_STAR] = ACTIONS(4045),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4045),
    [anon_sym_BANG_EQ] = ACTIONS(4043),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4045),
    [anon_sym_instanceof] = ACTIONS(4045),
    [anon_sym_BANG] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym__automatic_semicolon] = ACTIONS(4045),
  },
  [1492] = {
    [anon_sym_STAR] = ACTIONS(4137),
    [anon_sym_as] = ACTIONS(4139),
    [anon_sym_COMMA] = ACTIONS(4139),
    [anon_sym_RBRACE] = ACTIONS(4139),
    [anon_sym_LPAREN] = ACTIONS(4139),
    [anon_sym_in] = ACTIONS(4137),
    [anon_sym_SEMI] = ACTIONS(4139),
    [anon_sym_LBRACK] = ACTIONS(4139),
    [anon_sym_LT] = ACTIONS(4137),
    [anon_sym_GT] = ACTIONS(4137),
    [anon_sym_SLASH] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4139),
    [anon_sym_QMARK] = ACTIONS(4139),
    [anon_sym_AMP_AMP] = ACTIONS(4139),
    [anon_sym_PIPE_PIPE] = ACTIONS(4139),
    [anon_sym_GT_GT] = ACTIONS(4137),
    [anon_sym_GT_GT_GT] = ACTIONS(4139),
    [anon_sym_LT_LT] = ACTIONS(4139),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_CARET] = ACTIONS(4139),
    [anon_sym_PIPE] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4139),
    [anon_sym_STAR_STAR] = ACTIONS(4139),
    [anon_sym_LT_EQ] = ACTIONS(4139),
    [anon_sym_EQ_EQ] = ACTIONS(4137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4139),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4139),
    [anon_sym_GT_EQ] = ACTIONS(4139),
    [anon_sym_instanceof] = ACTIONS(4139),
    [anon_sym_BANG] = ACTIONS(4137),
    [anon_sym_PLUS_PLUS] = ACTIONS(4139),
    [anon_sym_DASH_DASH] = ACTIONS(4139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4139),
    [sym__automatic_semicolon] = ACTIONS(4139),
  },
  [1493] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(4710),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(4710),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(4710),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4710),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1494] = {
    [sym_arguments] = STATE(1586),
    [anon_sym_STAR] = ACTIONS(3265),
    [anon_sym_as] = ACTIONS(3269),
    [anon_sym_LBRACE] = ACTIONS(3265),
    [anon_sym_COMMA] = ACTIONS(3269),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3265),
    [anon_sym_GT] = ACTIONS(3265),
    [anon_sym_SLASH] = ACTIONS(3265),
    [anon_sym_DOT] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(3269),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_GT_GT] = ACTIONS(3265),
    [anon_sym_GT_GT_GT] = ACTIONS(3269),
    [anon_sym_LT_LT] = ACTIONS(3269),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_CARET] = ACTIONS(3269),
    [anon_sym_PIPE] = ACTIONS(3265),
    [anon_sym_PLUS] = ACTIONS(3265),
    [anon_sym_DASH] = ACTIONS(3265),
    [anon_sym_PERCENT] = ACTIONS(3269),
    [anon_sym_STAR_STAR] = ACTIONS(3269),
    [anon_sym_LT_EQ] = ACTIONS(3269),
    [anon_sym_EQ_EQ] = ACTIONS(3265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3269),
    [anon_sym_BANG_EQ] = ACTIONS(3265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3269),
    [anon_sym_GT_EQ] = ACTIONS(3269),
    [anon_sym_instanceof] = ACTIONS(3269),
    [anon_sym_BANG] = ACTIONS(3265),
    [anon_sym_PLUS_PLUS] = ACTIONS(3269),
    [anon_sym_DASH_DASH] = ACTIONS(3269),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3269),
  },
  [1495] = {
    [anon_sym_STAR] = ACTIONS(4141),
    [anon_sym_as] = ACTIONS(4143),
    [anon_sym_COMMA] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4143),
    [anon_sym_LPAREN] = ACTIONS(4143),
    [anon_sym_in] = ACTIONS(4141),
    [anon_sym_SEMI] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(4143),
    [anon_sym_LT] = ACTIONS(4141),
    [anon_sym_GT] = ACTIONS(4141),
    [anon_sym_SLASH] = ACTIONS(4141),
    [anon_sym_DOT] = ACTIONS(4143),
    [anon_sym_QMARK] = ACTIONS(4143),
    [anon_sym_AMP_AMP] = ACTIONS(4143),
    [anon_sym_PIPE_PIPE] = ACTIONS(4143),
    [anon_sym_GT_GT] = ACTIONS(4141),
    [anon_sym_GT_GT_GT] = ACTIONS(4143),
    [anon_sym_LT_LT] = ACTIONS(4143),
    [anon_sym_AMP] = ACTIONS(4141),
    [anon_sym_CARET] = ACTIONS(4143),
    [anon_sym_PIPE] = ACTIONS(4141),
    [anon_sym_PLUS] = ACTIONS(4141),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_PERCENT] = ACTIONS(4143),
    [anon_sym_STAR_STAR] = ACTIONS(4143),
    [anon_sym_LT_EQ] = ACTIONS(4143),
    [anon_sym_EQ_EQ] = ACTIONS(4141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4143),
    [anon_sym_BANG_EQ] = ACTIONS(4141),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4143),
    [anon_sym_GT_EQ] = ACTIONS(4143),
    [anon_sym_instanceof] = ACTIONS(4143),
    [anon_sym_BANG] = ACTIONS(4141),
    [anon_sym_PLUS_PLUS] = ACTIONS(4143),
    [anon_sym_DASH_DASH] = ACTIONS(4143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4143),
    [sym__automatic_semicolon] = ACTIONS(4143),
  },
  [1496] = {
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_as] = ACTIONS(4045),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_RBRACE] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4045),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4043),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_QMARK] = ACTIONS(4045),
    [anon_sym_AMP_AMP] = ACTIONS(4045),
    [anon_sym_PIPE_PIPE] = ACTIONS(4045),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_GT_GT_GT] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_STAR_STAR] = ACTIONS(4045),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4045),
    [anon_sym_BANG_EQ] = ACTIONS(4043),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4045),
    [anon_sym_instanceof] = ACTIONS(4045),
    [anon_sym_BANG] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [sym__automatic_semicolon] = ACTIONS(4045),
  },
  [1497] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4715),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(4718),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(4718),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(4718),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(4718),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1498] = {
    [sym_string] = STATE(2114),
    [sym__property_name] = STATE(2114),
    [sym_computed_property_name] = STATE(2114),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4735),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4737),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4739),
    [anon_sym_set] = ACTIONS(4739),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1499] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4695),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1500] = {
    [anon_sym_STAR] = ACTIONS(4079),
    [anon_sym_as] = ACTIONS(3754),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_in] = ACTIONS(4079),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [anon_sym_LT] = ACTIONS(4079),
    [anon_sym_GT] = ACTIONS(4079),
    [anon_sym_SLASH] = ACTIONS(4079),
    [anon_sym_DOT] = ACTIONS(3754),
    [anon_sym_QMARK] = ACTIONS(3754),
    [anon_sym_AMP_AMP] = ACTIONS(3754),
    [anon_sym_PIPE_PIPE] = ACTIONS(3754),
    [anon_sym_GT_GT] = ACTIONS(4079),
    [anon_sym_GT_GT_GT] = ACTIONS(3754),
    [anon_sym_LT_LT] = ACTIONS(3754),
    [anon_sym_AMP] = ACTIONS(4079),
    [anon_sym_CARET] = ACTIONS(3754),
    [anon_sym_PIPE] = ACTIONS(4079),
    [anon_sym_PLUS] = ACTIONS(4079),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_PERCENT] = ACTIONS(3754),
    [anon_sym_STAR_STAR] = ACTIONS(3754),
    [anon_sym_LT_EQ] = ACTIONS(3754),
    [anon_sym_EQ_EQ] = ACTIONS(4079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3754),
    [anon_sym_BANG_EQ] = ACTIONS(4079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3754),
    [anon_sym_GT_EQ] = ACTIONS(3754),
    [anon_sym_instanceof] = ACTIONS(3754),
    [anon_sym_BANG] = ACTIONS(4079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3754),
    [anon_sym_DASH_DASH] = ACTIONS(3754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3754),
    [sym__automatic_semicolon] = ACTIONS(3754),
  },
  [1501] = {
    [sym_string] = STATE(1877),
    [sym__property_name] = STATE(1877),
    [sym_computed_property_name] = STATE(1877),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4741),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4743),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4745),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4747),
    [anon_sym_set] = ACTIONS(4747),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1502] = {
    [anon_sym_STAR] = ACTIONS(4107),
    [anon_sym_as] = ACTIONS(4109),
    [anon_sym_COMMA] = ACTIONS(4109),
    [anon_sym_RBRACE] = ACTIONS(4109),
    [anon_sym_LPAREN] = ACTIONS(4109),
    [anon_sym_in] = ACTIONS(4107),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LBRACK] = ACTIONS(4109),
    [anon_sym_LT] = ACTIONS(4107),
    [anon_sym_GT] = ACTIONS(4107),
    [anon_sym_SLASH] = ACTIONS(4107),
    [anon_sym_DOT] = ACTIONS(4109),
    [anon_sym_QMARK] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_GT_GT_GT] = ACTIONS(4109),
    [anon_sym_LT_LT] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4107),
    [anon_sym_CARET] = ACTIONS(4109),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4107),
    [anon_sym_DASH] = ACTIONS(4107),
    [anon_sym_PERCENT] = ACTIONS(4109),
    [anon_sym_STAR_STAR] = ACTIONS(4109),
    [anon_sym_LT_EQ] = ACTIONS(4109),
    [anon_sym_EQ_EQ] = ACTIONS(4107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4109),
    [anon_sym_GT_EQ] = ACTIONS(4109),
    [anon_sym_instanceof] = ACTIONS(4109),
    [anon_sym_BANG] = ACTIONS(4107),
    [anon_sym_PLUS_PLUS] = ACTIONS(4109),
    [anon_sym_DASH_DASH] = ACTIONS(4109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [sym__automatic_semicolon] = ACTIONS(4109),
  },
  [1503] = {
    [anon_sym_STAR] = ACTIONS(4157),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4157),
    [anon_sym_SEMI] = ACTIONS(4159),
    [anon_sym_LBRACK] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4157),
    [anon_sym_GT] = ACTIONS(4157),
    [anon_sym_SLASH] = ACTIONS(4157),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4157),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4157),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4157),
    [anon_sym_DASH] = ACTIONS(4157),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_STAR_STAR] = ACTIONS(4159),
    [anon_sym_LT_EQ] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4159),
    [anon_sym_BANG_EQ] = ACTIONS(4157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4159),
    [anon_sym_GT_EQ] = ACTIONS(4159),
    [anon_sym_instanceof] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4157),
    [anon_sym_PLUS_PLUS] = ACTIONS(4159),
    [anon_sym_DASH_DASH] = ACTIONS(4159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [sym__automatic_semicolon] = ACTIONS(4159),
  },
  [1504] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(4101),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1505] = {
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_as] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3878),
    [anon_sym_RBRACE] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3876),
    [anon_sym_SEMI] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3876),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_GT_GT] = ACTIONS(3876),
    [anon_sym_GT_GT_GT] = ACTIONS(3878),
    [anon_sym_LT_LT] = ACTIONS(3878),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_CARET] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_LT_EQ] = ACTIONS(3878),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3878),
    [anon_sym_GT_EQ] = ACTIONS(3878),
    [anon_sym_instanceof] = ACTIONS(3878),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3878),
    [sym__automatic_semicolon] = ACTIONS(3878),
  },
  [1506] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(4749),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1507] = {
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_as] = ACTIONS(4155),
    [anon_sym_COMMA] = ACTIONS(4155),
    [anon_sym_RBRACE] = ACTIONS(4155),
    [anon_sym_LPAREN] = ACTIONS(4155),
    [anon_sym_in] = ACTIONS(4153),
    [anon_sym_SEMI] = ACTIONS(4155),
    [anon_sym_LBRACK] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4153),
    [anon_sym_GT] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4153),
    [anon_sym_DOT] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4155),
    [anon_sym_AMP_AMP] = ACTIONS(4155),
    [anon_sym_PIPE_PIPE] = ACTIONS(4155),
    [anon_sym_GT_GT] = ACTIONS(4153),
    [anon_sym_GT_GT_GT] = ACTIONS(4155),
    [anon_sym_LT_LT] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_CARET] = ACTIONS(4155),
    [anon_sym_PIPE] = ACTIONS(4153),
    [anon_sym_PLUS] = ACTIONS(4153),
    [anon_sym_DASH] = ACTIONS(4153),
    [anon_sym_PERCENT] = ACTIONS(4155),
    [anon_sym_STAR_STAR] = ACTIONS(4155),
    [anon_sym_LT_EQ] = ACTIONS(4155),
    [anon_sym_EQ_EQ] = ACTIONS(4153),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4155),
    [anon_sym_BANG_EQ] = ACTIONS(4153),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4155),
    [anon_sym_GT_EQ] = ACTIONS(4155),
    [anon_sym_instanceof] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4153),
    [anon_sym_PLUS_PLUS] = ACTIONS(4155),
    [anon_sym_DASH_DASH] = ACTIONS(4155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4155),
    [sym__automatic_semicolon] = ACTIONS(4155),
  },
  [1508] = {
    [anon_sym_STAR] = ACTIONS(4037),
    [anon_sym_as] = ACTIONS(3814),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_in] = ACTIONS(4037),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LT] = ACTIONS(4037),
    [anon_sym_GT] = ACTIONS(4037),
    [anon_sym_SLASH] = ACTIONS(4037),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_GT_GT] = ACTIONS(4037),
    [anon_sym_GT_GT_GT] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_PIPE] = ACTIONS(4037),
    [anon_sym_PLUS] = ACTIONS(4037),
    [anon_sym_DASH] = ACTIONS(4037),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_STAR_STAR] = ACTIONS(3814),
    [anon_sym_LT_EQ] = ACTIONS(3814),
    [anon_sym_EQ_EQ] = ACTIONS(4037),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(4037),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3814),
    [anon_sym_GT_EQ] = ACTIONS(3814),
    [anon_sym_instanceof] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(4037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3814),
    [sym__automatic_semicolon] = ACTIONS(3814),
  },
  [1509] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(4751),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1510] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4753),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [1511] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4755),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_implements] = ACTIONS(1223),
  },
  [1512] = {
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_as] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_GT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(2492),
    [anon_sym_DOT] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_GT_GT_GT] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(2490),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PERCENT] = ACTIONS(2490),
    [anon_sym_STAR_STAR] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2490),
    [anon_sym_EQ_EQ] = ACTIONS(2492),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2492),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2490),
    [anon_sym_GT_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2490),
    [sym__automatic_semicolon] = ACTIONS(2490),
  },
  [1513] = {
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_as] = ACTIONS(2605),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(2605),
    [anon_sym_in] = ACTIONS(2607),
    [anon_sym_SEMI] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(2607),
    [anon_sym_GT] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(2607),
    [anon_sym_DOT] = ACTIONS(3866),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(2605),
    [anon_sym_GT_GT] = ACTIONS(2607),
    [anon_sym_GT_GT_GT] = ACTIONS(2605),
    [anon_sym_LT_LT] = ACTIONS(2605),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_PERCENT] = ACTIONS(2605),
    [anon_sym_STAR_STAR] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(2605),
    [anon_sym_EQ_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(2607),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2605),
    [anon_sym_GT_EQ] = ACTIONS(2605),
    [anon_sym_instanceof] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2605),
    [sym__automatic_semicolon] = ACTIONS(2605),
  },
  [1514] = {
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_as] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(4642),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_SLASH] = ACTIONS(2522),
    [anon_sym_DOT] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_GT_GT] = ACTIONS(2522),
    [anon_sym_GT_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
    [anon_sym_CARET] = ACTIONS(2520),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_PERCENT] = ACTIONS(2520),
    [anon_sym_STAR_STAR] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2520),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2520),
    [anon_sym_BANG_EQ] = ACTIONS(2522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2520),
    [anon_sym_GT_EQ] = ACTIONS(2520),
    [anon_sym_instanceof] = ACTIONS(2520),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [sym__automatic_semicolon] = ACTIONS(2520),
  },
  [1515] = {
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_as] = ACTIONS(2512),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2512),
    [anon_sym_QMARK] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_GT_GT] = ACTIONS(2514),
    [anon_sym_GT_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2512),
    [anon_sym_STAR_STAR] = ACTIONS(2512),
    [anon_sym_LT_EQ] = ACTIONS(2512),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2512),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2512),
    [anon_sym_GT_EQ] = ACTIONS(2512),
    [anon_sym_instanceof] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [sym__automatic_semicolon] = ACTIONS(2512),
  },
  [1516] = {
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_as] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_GT_GT_GT] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_STAR_STAR] = ACTIONS(2506),
    [anon_sym_LT_EQ] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2508),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2508),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2506),
    [anon_sym_GT_EQ] = ACTIONS(2506),
    [anon_sym_instanceof] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [sym__automatic_semicolon] = ACTIONS(2506),
  },
  [1517] = {
    [anon_sym_STAR] = ACTIONS(2446),
    [anon_sym_as] = ACTIONS(2444),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2446),
    [anon_sym_DOT] = ACTIONS(2444),
    [anon_sym_QMARK] = ACTIONS(2444),
    [anon_sym_AMP_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2446),
    [anon_sym_GT_GT_GT] = ACTIONS(2444),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_PERCENT] = ACTIONS(2444),
    [anon_sym_STAR_STAR] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2444),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2444),
    [anon_sym_GT_EQ] = ACTIONS(2444),
    [anon_sym_instanceof] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2444),
    [sym__automatic_semicolon] = ACTIONS(2444),
  },
  [1518] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4757),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [1519] = {
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_in] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2432),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2430),
    [anon_sym_PIPE_PIPE] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2432),
    [anon_sym_GT_GT_GT] = ACTIONS(2430),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_CARET] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_STAR_STAR] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2430),
    [anon_sym_BANG_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2430),
    [anon_sym_instanceof] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [sym__automatic_semicolon] = ACTIONS(2430),
  },
  [1520] = {
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_in] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2436),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(4432),
    [anon_sym_QMARK] = ACTIONS(2434),
    [anon_sym_AMP_AMP] = ACTIONS(2434),
    [anon_sym_PIPE_PIPE] = ACTIONS(2434),
    [anon_sym_GT_GT] = ACTIONS(2436),
    [anon_sym_GT_GT_GT] = ACTIONS(2434),
    [anon_sym_LT_LT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_CARET] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2434),
    [anon_sym_STAR_STAR] = ACTIONS(2434),
    [anon_sym_LT_EQ] = ACTIONS(2434),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2434),
    [anon_sym_BANG_EQ] = ACTIONS(2436),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2434),
    [anon_sym_GT_EQ] = ACTIONS(2434),
    [anon_sym_instanceof] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [sym__automatic_semicolon] = ACTIONS(2434),
  },
  [1521] = {
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_as] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_in] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_GT_GT_GT] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2476),
    [anon_sym_STAR_STAR] = ACTIONS(2476),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_EQ_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_instanceof] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [sym__automatic_semicolon] = ACTIONS(2476),
  },
  [1522] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4759),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [1523] = {
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_as] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2400),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_DOT] = ACTIONS(2398),
    [anon_sym_QMARK] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_PIPE_PIPE] = ACTIONS(2398),
    [anon_sym_GT_GT] = ACTIONS(2400),
    [anon_sym_GT_GT_GT] = ACTIONS(2398),
    [anon_sym_LT_LT] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_CARET] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_STAR_STAR] = ACTIONS(2398),
    [anon_sym_LT_EQ] = ACTIONS(2398),
    [anon_sym_EQ_EQ] = ACTIONS(2400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2398),
    [anon_sym_BANG_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2398),
    [anon_sym_GT_EQ] = ACTIONS(2398),
    [anon_sym_instanceof] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [sym__automatic_semicolon] = ACTIONS(2398),
  },
  [1524] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_RBRACK] = ACTIONS(4761),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1525] = {
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_as] = ACTIONS(4151),
    [anon_sym_COMMA] = ACTIONS(4151),
    [anon_sym_RBRACE] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_in] = ACTIONS(4149),
    [anon_sym_SEMI] = ACTIONS(4151),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(4149),
    [anon_sym_SLASH] = ACTIONS(4149),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4149),
    [anon_sym_GT_GT_GT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4149),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_PIPE] = ACTIONS(4149),
    [anon_sym_PLUS] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4149),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_STAR_STAR] = ACTIONS(4151),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_EQ_EQ] = ACTIONS(4149),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4149),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4151),
    [anon_sym_instanceof] = ACTIONS(4151),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_PLUS_PLUS] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4151),
    [sym__automatic_semicolon] = ACTIONS(4151),
  },
  [1526] = {
    [anon_sym_STAR] = ACTIONS(4033),
    [anon_sym_as] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LPAREN] = ACTIONS(4035),
    [anon_sym_in] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4033),
    [anon_sym_GT] = ACTIONS(4033),
    [anon_sym_SLASH] = ACTIONS(4033),
    [anon_sym_DOT] = ACTIONS(4035),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_GT_GT_GT] = ACTIONS(4035),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4033),
    [anon_sym_CARET] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4033),
    [anon_sym_DASH] = ACTIONS(4033),
    [anon_sym_PERCENT] = ACTIONS(4035),
    [anon_sym_STAR_STAR] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4035),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_instanceof] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4035),
    [sym__automatic_semicolon] = ACTIONS(4035),
  },
  [1527] = {
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_as] = ACTIONS(4031),
    [anon_sym_COMMA] = ACTIONS(4031),
    [anon_sym_RBRACE] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_in] = ACTIONS(4029),
    [anon_sym_SEMI] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_LT] = ACTIONS(4029),
    [anon_sym_GT] = ACTIONS(4029),
    [anon_sym_SLASH] = ACTIONS(4029),
    [anon_sym_DOT] = ACTIONS(4031),
    [anon_sym_QMARK] = ACTIONS(4031),
    [anon_sym_AMP_AMP] = ACTIONS(4031),
    [anon_sym_PIPE_PIPE] = ACTIONS(4031),
    [anon_sym_GT_GT] = ACTIONS(4029),
    [anon_sym_GT_GT_GT] = ACTIONS(4031),
    [anon_sym_LT_LT] = ACTIONS(4031),
    [anon_sym_AMP] = ACTIONS(4029),
    [anon_sym_CARET] = ACTIONS(4031),
    [anon_sym_PIPE] = ACTIONS(4029),
    [anon_sym_PLUS] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4029),
    [anon_sym_PERCENT] = ACTIONS(4031),
    [anon_sym_STAR_STAR] = ACTIONS(4031),
    [anon_sym_LT_EQ] = ACTIONS(4031),
    [anon_sym_EQ_EQ] = ACTIONS(4029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4031),
    [anon_sym_BANG_EQ] = ACTIONS(4029),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4031),
    [anon_sym_GT_EQ] = ACTIONS(4031),
    [anon_sym_instanceof] = ACTIONS(4031),
    [anon_sym_BANG] = ACTIONS(4029),
    [anon_sym_PLUS_PLUS] = ACTIONS(4031),
    [anon_sym_DASH_DASH] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4031),
    [sym__automatic_semicolon] = ACTIONS(4031),
  },
  [1528] = {
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_as] = ACTIONS(4031),
    [anon_sym_COMMA] = ACTIONS(4031),
    [anon_sym_RBRACE] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_in] = ACTIONS(4029),
    [anon_sym_SEMI] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_LT] = ACTIONS(4029),
    [anon_sym_GT] = ACTIONS(4029),
    [anon_sym_SLASH] = ACTIONS(4029),
    [anon_sym_DOT] = ACTIONS(4031),
    [anon_sym_QMARK] = ACTIONS(4031),
    [anon_sym_AMP_AMP] = ACTIONS(4031),
    [anon_sym_PIPE_PIPE] = ACTIONS(4031),
    [anon_sym_GT_GT] = ACTIONS(4029),
    [anon_sym_GT_GT_GT] = ACTIONS(4031),
    [anon_sym_LT_LT] = ACTIONS(4031),
    [anon_sym_AMP] = ACTIONS(4029),
    [anon_sym_CARET] = ACTIONS(4031),
    [anon_sym_PIPE] = ACTIONS(4029),
    [anon_sym_PLUS] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4029),
    [anon_sym_PERCENT] = ACTIONS(4031),
    [anon_sym_STAR_STAR] = ACTIONS(4031),
    [anon_sym_LT_EQ] = ACTIONS(4031),
    [anon_sym_EQ_EQ] = ACTIONS(4029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4031),
    [anon_sym_BANG_EQ] = ACTIONS(4029),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4031),
    [anon_sym_GT_EQ] = ACTIONS(4031),
    [anon_sym_instanceof] = ACTIONS(4031),
    [anon_sym_BANG] = ACTIONS(4029),
    [anon_sym_PLUS_PLUS] = ACTIONS(4031),
    [anon_sym_DASH_DASH] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4031),
    [sym__automatic_semicolon] = ACTIONS(4031),
  },
  [1529] = {
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(4027),
    [anon_sym_RBRACE] = ACTIONS(4027),
    [anon_sym_LPAREN] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4025),
    [anon_sym_SEMI] = ACTIONS(4027),
    [anon_sym_LBRACK] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_AMP_AMP] = ACTIONS(4027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_STAR_STAR] = ACTIONS(4027),
    [anon_sym_LT_EQ] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4027),
    [anon_sym_BANG_EQ] = ACTIONS(4025),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4027),
    [anon_sym_GT_EQ] = ACTIONS(4027),
    [anon_sym_instanceof] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4025),
    [anon_sym_PLUS_PLUS] = ACTIONS(4027),
    [anon_sym_DASH_DASH] = ACTIONS(4027),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4027),
    [sym__automatic_semicolon] = ACTIONS(4027),
  },
  [1530] = {
    [anon_sym_STAR] = ACTIONS(3658),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_RBRACE] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3658),
    [anon_sym_SEMI] = ACTIONS(3662),
    [anon_sym_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_GT] = ACTIONS(3658),
    [anon_sym_SLASH] = ACTIONS(3658),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3658),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3658),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_STAR_STAR] = ACTIONS(3662),
    [anon_sym_LT_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3658),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ] = ACTIONS(3658),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3662),
    [anon_sym_GT_EQ] = ACTIONS(3662),
    [anon_sym_instanceof] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_PLUS_PLUS] = ACTIONS(3662),
    [anon_sym_DASH_DASH] = ACTIONS(3662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3662),
    [sym__automatic_semicolon] = ACTIONS(3662),
  },
  [1531] = {
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_as] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_LT] = ACTIONS(2500),
    [anon_sym_GT] = ACTIONS(2500),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_DOT] = ACTIONS(2498),
    [anon_sym_QMARK] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2498),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_GT_GT_GT] = ACTIONS(2498),
    [anon_sym_LT_LT] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_CARET] = ACTIONS(2498),
    [anon_sym_PIPE] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2498),
    [anon_sym_STAR_STAR] = ACTIONS(2498),
    [anon_sym_LT_EQ] = ACTIONS(2498),
    [anon_sym_EQ_EQ] = ACTIONS(2500),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2498),
    [anon_sym_BANG_EQ] = ACTIONS(2500),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2498),
    [anon_sym_GT_EQ] = ACTIONS(2498),
    [anon_sym_instanceof] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2498),
    [sym__automatic_semicolon] = ACTIONS(2498),
  },
  [1532] = {
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_as] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2650),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_LT] = ACTIONS(2650),
    [anon_sym_GT] = ACTIONS(2650),
    [anon_sym_SLASH] = ACTIONS(2650),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2650),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_AMP] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_PLUS] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_STAR_STAR] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2650),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2648),
    [anon_sym_instanceof] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [sym__automatic_semicolon] = ACTIONS(2648),
  },
  [1533] = {
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_as] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_PIPE_PIPE] = ACTIONS(2472),
    [anon_sym_GT_GT] = ACTIONS(2474),
    [anon_sym_GT_GT_GT] = ACTIONS(2472),
    [anon_sym_LT_LT] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_CARET] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2472),
    [anon_sym_STAR_STAR] = ACTIONS(2472),
    [anon_sym_LT_EQ] = ACTIONS(2472),
    [anon_sym_EQ_EQ] = ACTIONS(2474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2472),
    [anon_sym_GT_EQ] = ACTIONS(2472),
    [anon_sym_instanceof] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [sym__automatic_semicolon] = ACTIONS(2472),
  },
  [1534] = {
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_as] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4021),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_DOT] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym_GT_GT_GT] = ACTIONS(4023),
    [anon_sym_LT_LT] = ACTIONS(4023),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4023),
    [anon_sym_STAR_STAR] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4021),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4023),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_instanceof] = ACTIONS(4023),
    [anon_sym_BANG] = ACTIONS(4021),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4023),
    [sym__automatic_semicolon] = ACTIONS(4023),
  },
  [1535] = {
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_as] = ACTIONS(4019),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_LPAREN] = ACTIONS(4019),
    [anon_sym_in] = ACTIONS(4017),
    [anon_sym_SEMI] = ACTIONS(4019),
    [anon_sym_LBRACK] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_DOT] = ACTIONS(4019),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym_GT_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4019),
    [anon_sym_STAR_STAR] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4019),
    [anon_sym_EQ_EQ] = ACTIONS(4017),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4017),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4019),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_instanceof] = ACTIONS(4019),
    [anon_sym_BANG] = ACTIONS(4017),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [sym__automatic_semicolon] = ACTIONS(4019),
  },
  [1536] = {
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_as] = ACTIONS(2559),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_RBRACE] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2559),
    [anon_sym_in] = ACTIONS(2561),
    [anon_sym_SEMI] = ACTIONS(2559),
    [anon_sym_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2561),
    [anon_sym_GT] = ACTIONS(2561),
    [anon_sym_SLASH] = ACTIONS(2561),
    [anon_sym_DOT] = ACTIONS(2559),
    [anon_sym_QMARK] = ACTIONS(2559),
    [anon_sym_AMP_AMP] = ACTIONS(2559),
    [anon_sym_PIPE_PIPE] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2559),
    [anon_sym_LT_LT] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_CARET] = ACTIONS(2559),
    [anon_sym_PIPE] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_STAR_STAR] = ACTIONS(2559),
    [anon_sym_LT_EQ] = ACTIONS(2559),
    [anon_sym_EQ_EQ] = ACTIONS(2561),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2559),
    [anon_sym_BANG_EQ] = ACTIONS(2561),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2559),
    [anon_sym_GT_EQ] = ACTIONS(2559),
    [anon_sym_instanceof] = ACTIONS(2559),
    [anon_sym_BANG] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(2559),
    [anon_sym_DASH_DASH] = ACTIONS(2559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2559),
    [sym__automatic_semicolon] = ACTIONS(2559),
  },
  [1537] = {
    [sym_string] = STATE(2186),
    [sym__property_name] = STATE(2186),
    [sym_computed_property_name] = STATE(2186),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4767),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4769),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4771),
    [anon_sym_set] = ACTIONS(4771),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1538] = {
    [anon_sym_STAR] = ACTIONS(4289),
    [anon_sym_as] = ACTIONS(4289),
    [anon_sym_LBRACE] = ACTIONS(4289),
    [anon_sym_COMMA] = ACTIONS(4291),
    [anon_sym_LPAREN] = ACTIONS(4291),
    [anon_sym_in] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(4291),
    [anon_sym_LT] = ACTIONS(4289),
    [anon_sym_GT] = ACTIONS(4289),
    [anon_sym_SLASH] = ACTIONS(4289),
    [anon_sym_DOT] = ACTIONS(4291),
    [anon_sym_QMARK] = ACTIONS(4291),
    [anon_sym_AMP_AMP] = ACTIONS(4291),
    [anon_sym_PIPE_PIPE] = ACTIONS(4291),
    [anon_sym_GT_GT] = ACTIONS(4289),
    [anon_sym_GT_GT_GT] = ACTIONS(4291),
    [anon_sym_LT_LT] = ACTIONS(4291),
    [anon_sym_AMP] = ACTIONS(4289),
    [anon_sym_CARET] = ACTIONS(4291),
    [anon_sym_PIPE] = ACTIONS(4289),
    [anon_sym_PLUS] = ACTIONS(4289),
    [anon_sym_DASH] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4291),
    [anon_sym_STAR_STAR] = ACTIONS(4291),
    [anon_sym_LT_EQ] = ACTIONS(4291),
    [anon_sym_EQ_EQ] = ACTIONS(4289),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4291),
    [anon_sym_BANG_EQ] = ACTIONS(4289),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4291),
    [anon_sym_GT_EQ] = ACTIONS(4291),
    [anon_sym_instanceof] = ACTIONS(4289),
    [anon_sym_BANG] = ACTIONS(4289),
    [anon_sym_PLUS_PLUS] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4291),
    [sym_regex_flags] = ACTIONS(4773),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4291),
  },
  [1539] = {
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_as] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_RPAREN] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3876),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3876),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_EQ_GT] = ACTIONS(3880),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_GT_GT] = ACTIONS(3876),
    [anon_sym_GT_GT_GT] = ACTIONS(3878),
    [anon_sym_LT_LT] = ACTIONS(3878),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_CARET] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_LT_EQ] = ACTIONS(3878),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3878),
    [anon_sym_GT_EQ] = ACTIONS(3878),
    [anon_sym_instanceof] = ACTIONS(3878),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3878),
  },
  [1540] = {
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_as] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_GT_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2622),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [sym__automatic_semicolon] = ACTIONS(2622),
  },
  [1541] = {
    [anon_sym_STAR] = ACTIONS(2458),
    [anon_sym_as] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_in] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_GT] = ACTIONS(2458),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_DOT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2458),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_CARET] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_STAR_STAR] = ACTIONS(2456),
    [anon_sym_LT_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2458),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ] = ACTIONS(2458),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2456),
    [anon_sym_GT_EQ] = ACTIONS(2456),
    [anon_sym_instanceof] = ACTIONS(2456),
    [anon_sym_BANG] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2456),
    [anon_sym_DASH_DASH] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2456),
    [sym__automatic_semicolon] = ACTIONS(2456),
  },
  [1542] = {
    [anon_sym_STAR] = ACTIONS(2547),
    [anon_sym_as] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_in] = ACTIONS(2547),
    [anon_sym_SEMI] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_LT] = ACTIONS(2547),
    [anon_sym_GT] = ACTIONS(2547),
    [anon_sym_SLASH] = ACTIONS(2547),
    [anon_sym_DOT] = ACTIONS(2545),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_AMP_AMP] = ACTIONS(2545),
    [anon_sym_PIPE_PIPE] = ACTIONS(2545),
    [anon_sym_GT_GT] = ACTIONS(2547),
    [anon_sym_GT_GT_GT] = ACTIONS(2545),
    [anon_sym_LT_LT] = ACTIONS(2545),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_CARET] = ACTIONS(2545),
    [anon_sym_PIPE] = ACTIONS(2547),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_PERCENT] = ACTIONS(2545),
    [anon_sym_STAR_STAR] = ACTIONS(2545),
    [anon_sym_LT_EQ] = ACTIONS(2545),
    [anon_sym_EQ_EQ] = ACTIONS(2547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2545),
    [anon_sym_BANG_EQ] = ACTIONS(2547),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2545),
    [anon_sym_GT_EQ] = ACTIONS(2545),
    [anon_sym_instanceof] = ACTIONS(2545),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(2545),
    [anon_sym_DASH_DASH] = ACTIONS(2545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2545),
    [sym__automatic_semicolon] = ACTIONS(2545),
  },
  [1543] = {
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_as] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(3981),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_SEMI] = ACTIONS(3981),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_DOT] = ACTIONS(3981),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_STAR_STAR] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_instanceof] = ACTIONS(3981),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3981),
    [sym__automatic_semicolon] = ACTIONS(3981),
  },
  [1544] = {
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_as] = ACTIONS(2630),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_BANG_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2630),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_instanceof] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2630),
    [sym__automatic_semicolon] = ACTIONS(2630),
  },
  [1545] = {
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_as] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_in] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2452),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2452),
    [anon_sym_STAR_STAR] = ACTIONS(2452),
    [anon_sym_LT_EQ] = ACTIONS(2452),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2452),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2452),
    [anon_sym_GT_EQ] = ACTIONS(2452),
    [anon_sym_instanceof] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2452),
    [sym__automatic_semicolon] = ACTIONS(2452),
  },
  [1546] = {
    [anon_sym_STAR] = ACTIONS(2442),
    [anon_sym_as] = ACTIONS(2440),
    [anon_sym_COMMA] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_in] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_GT] = ACTIONS(2442),
    [anon_sym_SLASH] = ACTIONS(2442),
    [anon_sym_DOT] = ACTIONS(2440),
    [anon_sym_QMARK] = ACTIONS(2440),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE_PIPE] = ACTIONS(2440),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_GT_GT_GT] = ACTIONS(2440),
    [anon_sym_LT_LT] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_PERCENT] = ACTIONS(2440),
    [anon_sym_STAR_STAR] = ACTIONS(2440),
    [anon_sym_LT_EQ] = ACTIONS(2440),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2440),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2440),
    [anon_sym_GT_EQ] = ACTIONS(2440),
    [anon_sym_instanceof] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2440),
    [anon_sym_DASH_DASH] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2440),
    [sym__automatic_semicolon] = ACTIONS(2440),
  },
  [1547] = {
    [sym_string] = STATE(2150),
    [sym__property_name] = STATE(2150),
    [sym_computed_property_name] = STATE(2150),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4775),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4777),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4779),
    [anon_sym_set] = ACTIONS(4779),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1548] = {
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_as] = ACTIONS(1191),
    [anon_sym_COMMA] = ACTIONS(1191),
    [anon_sym_RBRACE] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1191),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1191),
    [anon_sym_QMARK] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_GT_GT_GT] = ACTIONS(1191),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PERCENT] = ACTIONS(1191),
    [anon_sym_STAR_STAR] = ACTIONS(1191),
    [anon_sym_LT_EQ] = ACTIONS(1191),
    [anon_sym_EQ_EQ] = ACTIONS(1189),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1191),
    [anon_sym_BANG_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1191),
    [anon_sym_GT_EQ] = ACTIONS(1191),
    [anon_sym_instanceof] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1191),
    [sym__automatic_semicolon] = ACTIONS(1191),
  },
  [1549] = {
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_as] = ACTIONS(3939),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_RBRACE] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3939),
    [anon_sym_in] = ACTIONS(3937),
    [anon_sym_SEMI] = ACTIONS(3939),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3937),
    [anon_sym_GT] = ACTIONS(3937),
    [anon_sym_SLASH] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_GT_GT] = ACTIONS(3937),
    [anon_sym_GT_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_LT] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_CARET] = ACTIONS(3939),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3939),
    [anon_sym_STAR_STAR] = ACTIONS(3939),
    [anon_sym_LT_EQ] = ACTIONS(3939),
    [anon_sym_EQ_EQ] = ACTIONS(3937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3939),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3939),
    [anon_sym_GT_EQ] = ACTIONS(3939),
    [anon_sym_instanceof] = ACTIONS(3939),
    [anon_sym_BANG] = ACTIONS(3937),
    [anon_sym_PLUS_PLUS] = ACTIONS(3939),
    [anon_sym_DASH_DASH] = ACTIONS(3939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [sym__automatic_semicolon] = ACTIONS(3939),
  },
  [1550] = {
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_as] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_in] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1143),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_SLASH] = ACTIONS(1143),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AMP_AMP] = ACTIONS(1145),
    [anon_sym_PIPE_PIPE] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [anon_sym_GT_GT_GT] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_STAR_STAR] = ACTIONS(1145),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1143),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_instanceof] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [sym__automatic_semicolon] = ACTIONS(1145),
  },
  [1551] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1552] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3733),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_RBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1553] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_abstract] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1554] = {
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(1177),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_in] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(1175),
    [anon_sym_GT] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1175),
    [anon_sym_DOT] = ACTIONS(1177),
    [anon_sym_QMARK] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(1175),
    [anon_sym_GT_GT_GT] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_PLUS] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1175),
    [anon_sym_PERCENT] = ACTIONS(1177),
    [anon_sym_STAR_STAR] = ACTIONS(1177),
    [anon_sym_LT_EQ] = ACTIONS(1177),
    [anon_sym_EQ_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1177),
    [anon_sym_BANG_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1177),
    [anon_sym_GT_EQ] = ACTIONS(1177),
    [anon_sym_instanceof] = ACTIONS(1177),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1177),
    [anon_sym_DASH_DASH] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [sym__automatic_semicolon] = ACTIONS(1177),
  },
  [1555] = {
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_in] = ACTIONS(1229),
    [anon_sym_SEMI] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1231),
    [anon_sym_DASH_DASH] = ACTIONS(1231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1231),
    [sym__automatic_semicolon] = ACTIONS(1231),
  },
  [1556] = {
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_as] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(2541),
    [anon_sym_RBRACE] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(2541),
    [anon_sym_in] = ACTIONS(2543),
    [anon_sym_SEMI] = ACTIONS(2541),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_LT] = ACTIONS(2543),
    [anon_sym_GT] = ACTIONS(2543),
    [anon_sym_SLASH] = ACTIONS(2543),
    [anon_sym_DOT] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(2541),
    [anon_sym_AMP_AMP] = ACTIONS(2541),
    [anon_sym_PIPE_PIPE] = ACTIONS(2541),
    [anon_sym_GT_GT] = ACTIONS(2543),
    [anon_sym_GT_GT_GT] = ACTIONS(2541),
    [anon_sym_LT_LT] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(2543),
    [anon_sym_CARET] = ACTIONS(2541),
    [anon_sym_PIPE] = ACTIONS(2543),
    [anon_sym_PLUS] = ACTIONS(2543),
    [anon_sym_DASH] = ACTIONS(2543),
    [anon_sym_PERCENT] = ACTIONS(2541),
    [anon_sym_STAR_STAR] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_EQ_EQ] = ACTIONS(2543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2541),
    [anon_sym_BANG_EQ] = ACTIONS(2543),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2541),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_instanceof] = ACTIONS(2541),
    [anon_sym_BANG] = ACTIONS(2543),
    [anon_sym_PLUS_PLUS] = ACTIONS(2541),
    [anon_sym_DASH_DASH] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [sym__automatic_semicolon] = ACTIONS(2541),
  },
  [1557] = {
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(1277),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_in] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_DOT] = ACTIONS(1277),
    [anon_sym_QMARK] = ACTIONS(1277),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_PIPE_PIPE] = ACTIONS(1277),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_GT_GT_GT] = ACTIONS(1277),
    [anon_sym_LT_LT] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_LT_EQ] = ACTIONS(1277),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1277),
    [anon_sym_BANG_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1277),
    [anon_sym_instanceof] = ACTIONS(1277),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1277),
    [sym__automatic_semicolon] = ACTIONS(1277),
  },
  [1558] = {
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_SEMI] = ACTIONS(1159),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1159),
    [anon_sym_QMARK] = ACTIONS(1159),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_instanceof] = ACTIONS(1159),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1159),
    [sym__automatic_semicolon] = ACTIONS(1159),
  },
  [1559] = {
    [sym_string] = STATE(1867),
    [sym__property_name] = STATE(1867),
    [sym_computed_property_name] = STATE(1867),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4591),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4593),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4595),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4599),
    [anon_sym_set] = ACTIONS(4599),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4781),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1560] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_COLON] = ACTIONS(4783),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1561] = {
    [sym_string] = STATE(2165),
    [sym__property_name] = STATE(2165),
    [sym_computed_property_name] = STATE(2165),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4591),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4785),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4787),
    [anon_sym_set] = ACTIONS(4787),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1562] = {
    [sym_string] = STATE(2161),
    [sym__property_name] = STATE(2161),
    [sym_computed_property_name] = STATE(2161),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4741),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4789),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4791),
    [anon_sym_set] = ACTIONS(4791),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1563] = {
    [sym_string] = STATE(1882),
    [sym__property_name] = STATE(1882),
    [sym_computed_property_name] = STATE(1882),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4729),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4793),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4795),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(4797),
    [anon_sym_set] = ACTIONS(4797),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1564] = {
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_as] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_in] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2450),
    [anon_sym_DOT] = ACTIONS(2448),
    [anon_sym_QMARK] = ACTIONS(2448),
    [anon_sym_AMP_AMP] = ACTIONS(2448),
    [anon_sym_PIPE_PIPE] = ACTIONS(2448),
    [anon_sym_GT_GT] = ACTIONS(2450),
    [anon_sym_GT_GT_GT] = ACTIONS(2448),
    [anon_sym_LT_LT] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(2448),
    [anon_sym_PIPE] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2448),
    [anon_sym_STAR_STAR] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2448),
    [anon_sym_EQ_EQ] = ACTIONS(2450),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ] = ACTIONS(2450),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2448),
    [anon_sym_GT_EQ] = ACTIONS(2448),
    [anon_sym_instanceof] = ACTIONS(2448),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2448),
    [sym__automatic_semicolon] = ACTIONS(2448),
  },
  [1565] = {
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2486),
    [anon_sym_GT_GT] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2486),
    [anon_sym_LT_LT] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_CARET] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2486),
    [anon_sym_STAR_STAR] = ACTIONS(2486),
    [anon_sym_LT_EQ] = ACTIONS(2486),
    [anon_sym_EQ_EQ] = ACTIONS(2488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2486),
    [anon_sym_BANG_EQ] = ACTIONS(2488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2486),
    [anon_sym_GT_EQ] = ACTIONS(2486),
    [anon_sym_instanceof] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [sym__automatic_semicolon] = ACTIONS(2486),
  },
  [1566] = {
    [anon_sym_STAR] = ACTIONS(2496),
    [anon_sym_as] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_in] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2496),
    [anon_sym_GT] = ACTIONS(2496),
    [anon_sym_SLASH] = ACTIONS(2496),
    [anon_sym_DOT] = ACTIONS(2494),
    [anon_sym_QMARK] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2496),
    [anon_sym_GT_GT_GT] = ACTIONS(2494),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_CARET] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PERCENT] = ACTIONS(2494),
    [anon_sym_STAR_STAR] = ACTIONS(2494),
    [anon_sym_LT_EQ] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2494),
    [anon_sym_BANG_EQ] = ACTIONS(2496),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2494),
    [anon_sym_GT_EQ] = ACTIONS(2494),
    [anon_sym_instanceof] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2494),
    [sym__automatic_semicolon] = ACTIONS(2494),
  },
  [1567] = {
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_as] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_in] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2396),
    [anon_sym_GT] = ACTIONS(2396),
    [anon_sym_SLASH] = ACTIONS(2396),
    [anon_sym_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_PIPE_PIPE] = ACTIONS(2394),
    [anon_sym_GT_GT] = ACTIONS(2396),
    [anon_sym_GT_GT_GT] = ACTIONS(2394),
    [anon_sym_LT_LT] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_CARET] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_PERCENT] = ACTIONS(2394),
    [anon_sym_STAR_STAR] = ACTIONS(2394),
    [anon_sym_LT_EQ] = ACTIONS(2394),
    [anon_sym_EQ_EQ] = ACTIONS(2396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2394),
    [anon_sym_BANG_EQ] = ACTIONS(2396),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2394),
    [anon_sym_GT_EQ] = ACTIONS(2394),
    [anon_sym_instanceof] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2394),
    [sym__automatic_semicolon] = ACTIONS(2394),
  },
  [1568] = {
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_as] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_GT_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_STAR_STAR] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_instanceof] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [sym__automatic_semicolon] = ACTIONS(2644),
  },
  [1569] = {
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_as] = ACTIONS(2634),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2636),
    [anon_sym_GT] = ACTIONS(2636),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_GT_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(4763),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(4765),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_STAR_STAR] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2634),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_instanceof] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2634),
    [sym__automatic_semicolon] = ACTIONS(2634),
  },
  [1570] = {
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_as] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_GT] = ACTIONS(2462),
    [anon_sym_SLASH] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2460),
    [anon_sym_QMARK] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_GT_GT_GT] = ACTIONS(2460),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2460),
    [anon_sym_STAR_STAR] = ACTIONS(2460),
    [anon_sym_LT_EQ] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2460),
    [anon_sym_GT_EQ] = ACTIONS(2460),
    [anon_sym_instanceof] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym__automatic_semicolon] = ACTIONS(2460),
  },
  [1571] = {
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_as] = ACTIONS(2516),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2518),
    [anon_sym_GT] = ACTIONS(2518),
    [anon_sym_SLASH] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2516),
    [anon_sym_QMARK] = ACTIONS(2516),
    [anon_sym_AMP_AMP] = ACTIONS(2516),
    [anon_sym_PIPE_PIPE] = ACTIONS(2516),
    [anon_sym_GT_GT] = ACTIONS(2518),
    [anon_sym_GT_GT_GT] = ACTIONS(2516),
    [anon_sym_LT_LT] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2516),
    [anon_sym_STAR_STAR] = ACTIONS(2516),
    [anon_sym_LT_EQ] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2516),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2516),
    [anon_sym_GT_EQ] = ACTIONS(2516),
    [anon_sym_instanceof] = ACTIONS(2516),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym__automatic_semicolon] = ACTIONS(2516),
  },
  [1572] = {
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_as] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_SLASH] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2466),
    [anon_sym_GT_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_CARET] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2464),
    [anon_sym_STAR_STAR] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2466),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [sym__automatic_semicolon] = ACTIONS(2464),
  },
  [1573] = {
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1119),
    [anon_sym_in] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1119),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_SLASH] = ACTIONS(1117),
    [anon_sym_DOT] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_AMP_AMP] = ACTIONS(1119),
    [anon_sym_PIPE_PIPE] = ACTIONS(1119),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_GT_GT_GT] = ACTIONS(1119),
    [anon_sym_LT_LT] = ACTIONS(1119),
    [anon_sym_AMP] = ACTIONS(1117),
    [anon_sym_CARET] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1117),
    [anon_sym_PLUS] = ACTIONS(1117),
    [anon_sym_DASH] = ACTIONS(1117),
    [anon_sym_PERCENT] = ACTIONS(1119),
    [anon_sym_STAR_STAR] = ACTIONS(1119),
    [anon_sym_LT_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1119),
    [anon_sym_GT_EQ] = ACTIONS(1119),
    [anon_sym_instanceof] = ACTIONS(1119),
    [anon_sym_BANG] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1119),
    [anon_sym_DASH_DASH] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1119),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1119),
  },
  [1574] = {
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_as] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(4799),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_GT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_QMARK] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_GT_GT] = ACTIONS(2482),
    [anon_sym_GT_GT_GT] = ACTIONS(2480),
    [anon_sym_LT_LT] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_CARET] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_PERCENT] = ACTIONS(2480),
    [anon_sym_STAR_STAR] = ACTIONS(2480),
    [anon_sym_LT_EQ] = ACTIONS(2480),
    [anon_sym_EQ_EQ] = ACTIONS(2482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2480),
    [anon_sym_BANG_EQ] = ACTIONS(2482),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2480),
    [anon_sym_GT_EQ] = ACTIONS(2480),
    [anon_sym_instanceof] = ACTIONS(2480),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2480),
  },
  [1575] = {
    [anon_sym_STAR] = ACTIONS(4081),
    [anon_sym_as] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4081),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4081),
    [anon_sym_GT] = ACTIONS(4081),
    [anon_sym_SLASH] = ACTIONS(4081),
    [anon_sym_DOT] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE] = ACTIONS(4083),
    [anon_sym_GT_GT] = ACTIONS(4081),
    [anon_sym_GT_GT_GT] = ACTIONS(4083),
    [anon_sym_LT_LT] = ACTIONS(4083),
    [anon_sym_AMP] = ACTIONS(4081),
    [anon_sym_CARET] = ACTIONS(4083),
    [anon_sym_PIPE] = ACTIONS(4081),
    [anon_sym_PLUS] = ACTIONS(4081),
    [anon_sym_DASH] = ACTIONS(4081),
    [anon_sym_PERCENT] = ACTIONS(4083),
    [anon_sym_STAR_STAR] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_EQ_EQ] = ACTIONS(4081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4083),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_instanceof] = ACTIONS(4083),
    [anon_sym_BANG] = ACTIONS(4081),
    [anon_sym_PLUS_PLUS] = ACTIONS(4083),
    [anon_sym_DASH_DASH] = ACTIONS(4083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4083),
  },
  [1576] = {
    [anon_sym_STAR] = ACTIONS(4037),
    [anon_sym_as] = ACTIONS(3814),
    [anon_sym_LBRACE] = ACTIONS(4037),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_in] = ACTIONS(4037),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LT] = ACTIONS(4037),
    [anon_sym_GT] = ACTIONS(4037),
    [anon_sym_SLASH] = ACTIONS(4037),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_GT_GT] = ACTIONS(4037),
    [anon_sym_GT_GT_GT] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3814),
    [anon_sym_AMP] = ACTIONS(4037),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_PIPE] = ACTIONS(4037),
    [anon_sym_PLUS] = ACTIONS(4037),
    [anon_sym_DASH] = ACTIONS(4037),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_STAR_STAR] = ACTIONS(3814),
    [anon_sym_LT_EQ] = ACTIONS(3814),
    [anon_sym_EQ_EQ] = ACTIONS(4037),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(4037),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3814),
    [anon_sym_GT_EQ] = ACTIONS(3814),
    [anon_sym_instanceof] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(4037),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3814),
  },
  [1577] = {
    [sym_string] = STATE(2165),
    [sym__property_name] = STATE(2165),
    [sym_computed_property_name] = STATE(2165),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4785),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1578] = {
    [anon_sym_STAR] = ACTIONS(3895),
    [anon_sym_as] = ACTIONS(3897),
    [anon_sym_LBRACE] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3897),
    [anon_sym_LPAREN] = ACTIONS(3897),
    [anon_sym_in] = ACTIONS(3895),
    [anon_sym_LBRACK] = ACTIONS(3897),
    [anon_sym_LT] = ACTIONS(3895),
    [anon_sym_GT] = ACTIONS(3895),
    [anon_sym_SLASH] = ACTIONS(3895),
    [anon_sym_DOT] = ACTIONS(3897),
    [anon_sym_QMARK] = ACTIONS(3897),
    [anon_sym_AMP_AMP] = ACTIONS(3897),
    [anon_sym_PIPE_PIPE] = ACTIONS(3897),
    [anon_sym_GT_GT] = ACTIONS(3895),
    [anon_sym_GT_GT_GT] = ACTIONS(3897),
    [anon_sym_LT_LT] = ACTIONS(3897),
    [anon_sym_AMP] = ACTIONS(3895),
    [anon_sym_CARET] = ACTIONS(3897),
    [anon_sym_PIPE] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(3895),
    [anon_sym_DASH] = ACTIONS(3895),
    [anon_sym_PERCENT] = ACTIONS(3897),
    [anon_sym_STAR_STAR] = ACTIONS(3897),
    [anon_sym_LT_EQ] = ACTIONS(3897),
    [anon_sym_EQ_EQ] = ACTIONS(3895),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3897),
    [anon_sym_BANG_EQ] = ACTIONS(3895),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3897),
    [anon_sym_GT_EQ] = ACTIONS(3897),
    [anon_sym_instanceof] = ACTIONS(3897),
    [anon_sym_BANG] = ACTIONS(3895),
    [anon_sym_PLUS_PLUS] = ACTIONS(3897),
    [anon_sym_DASH_DASH] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3897),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3897),
  },
  [1579] = {
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1580] = {
    [anon_sym_STAR] = ACTIONS(4033),
    [anon_sym_as] = ACTIONS(4035),
    [anon_sym_LBRACE] = ACTIONS(4033),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN] = ACTIONS(4035),
    [anon_sym_in] = ACTIONS(4033),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4033),
    [anon_sym_GT] = ACTIONS(4033),
    [anon_sym_SLASH] = ACTIONS(4033),
    [anon_sym_DOT] = ACTIONS(4035),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_GT_GT_GT] = ACTIONS(4035),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4033),
    [anon_sym_CARET] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4033),
    [anon_sym_DASH] = ACTIONS(4033),
    [anon_sym_PERCENT] = ACTIONS(4035),
    [anon_sym_STAR_STAR] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4035),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_instanceof] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4035),
  },
  [1581] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1582] = {
    [anon_sym_STAR] = ACTIONS(4073),
    [anon_sym_as] = ACTIONS(3782),
    [anon_sym_LBRACE] = ACTIONS(4073),
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_in] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [anon_sym_LT] = ACTIONS(4073),
    [anon_sym_GT] = ACTIONS(4073),
    [anon_sym_SLASH] = ACTIONS(4073),
    [anon_sym_DOT] = ACTIONS(3782),
    [anon_sym_QMARK] = ACTIONS(3782),
    [anon_sym_AMP_AMP] = ACTIONS(3782),
    [anon_sym_PIPE_PIPE] = ACTIONS(3782),
    [anon_sym_GT_GT] = ACTIONS(4073),
    [anon_sym_GT_GT_GT] = ACTIONS(3782),
    [anon_sym_LT_LT] = ACTIONS(3782),
    [anon_sym_AMP] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PIPE] = ACTIONS(4073),
    [anon_sym_PLUS] = ACTIONS(4073),
    [anon_sym_DASH] = ACTIONS(4073),
    [anon_sym_PERCENT] = ACTIONS(3782),
    [anon_sym_STAR_STAR] = ACTIONS(3782),
    [anon_sym_LT_EQ] = ACTIONS(3782),
    [anon_sym_EQ_EQ] = ACTIONS(4073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3782),
    [anon_sym_BANG_EQ] = ACTIONS(4073),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3782),
    [anon_sym_GT_EQ] = ACTIONS(3782),
    [anon_sym_instanceof] = ACTIONS(3782),
    [anon_sym_BANG] = ACTIONS(4073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3782),
    [anon_sym_DASH_DASH] = ACTIONS(3782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3782),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3782),
  },
  [1583] = {
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_as] = ACTIONS(4031),
    [anon_sym_LBRACE] = ACTIONS(4029),
    [anon_sym_COMMA] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_in] = ACTIONS(4029),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_LT] = ACTIONS(4029),
    [anon_sym_GT] = ACTIONS(4029),
    [anon_sym_SLASH] = ACTIONS(4029),
    [anon_sym_DOT] = ACTIONS(4031),
    [anon_sym_QMARK] = ACTIONS(4031),
    [anon_sym_AMP_AMP] = ACTIONS(4031),
    [anon_sym_PIPE_PIPE] = ACTIONS(4031),
    [anon_sym_GT_GT] = ACTIONS(4029),
    [anon_sym_GT_GT_GT] = ACTIONS(4031),
    [anon_sym_LT_LT] = ACTIONS(4031),
    [anon_sym_AMP] = ACTIONS(4029),
    [anon_sym_CARET] = ACTIONS(4031),
    [anon_sym_PIPE] = ACTIONS(4029),
    [anon_sym_PLUS] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4029),
    [anon_sym_PERCENT] = ACTIONS(4031),
    [anon_sym_STAR_STAR] = ACTIONS(4031),
    [anon_sym_LT_EQ] = ACTIONS(4031),
    [anon_sym_EQ_EQ] = ACTIONS(4029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4031),
    [anon_sym_BANG_EQ] = ACTIONS(4029),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4031),
    [anon_sym_GT_EQ] = ACTIONS(4031),
    [anon_sym_instanceof] = ACTIONS(4031),
    [anon_sym_BANG] = ACTIONS(4029),
    [anon_sym_PLUS_PLUS] = ACTIONS(4031),
    [anon_sym_DASH_DASH] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4031),
  },
  [1584] = {
    [sym_string] = STATE(2201),
    [sym__property_name] = STATE(2201),
    [sym_computed_property_name] = STATE(2201),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1585] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1586] = {
    [anon_sym_STAR] = ACTIONS(4029),
    [anon_sym_as] = ACTIONS(4031),
    [anon_sym_LBRACE] = ACTIONS(4029),
    [anon_sym_COMMA] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(4031),
    [anon_sym_in] = ACTIONS(4029),
    [anon_sym_LBRACK] = ACTIONS(4031),
    [anon_sym_LT] = ACTIONS(4029),
    [anon_sym_GT] = ACTIONS(4029),
    [anon_sym_SLASH] = ACTIONS(4029),
    [anon_sym_DOT] = ACTIONS(4031),
    [anon_sym_QMARK] = ACTIONS(4031),
    [anon_sym_AMP_AMP] = ACTIONS(4031),
    [anon_sym_PIPE_PIPE] = ACTIONS(4031),
    [anon_sym_GT_GT] = ACTIONS(4029),
    [anon_sym_GT_GT_GT] = ACTIONS(4031),
    [anon_sym_LT_LT] = ACTIONS(4031),
    [anon_sym_AMP] = ACTIONS(4029),
    [anon_sym_CARET] = ACTIONS(4031),
    [anon_sym_PIPE] = ACTIONS(4029),
    [anon_sym_PLUS] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4029),
    [anon_sym_PERCENT] = ACTIONS(4031),
    [anon_sym_STAR_STAR] = ACTIONS(4031),
    [anon_sym_LT_EQ] = ACTIONS(4031),
    [anon_sym_EQ_EQ] = ACTIONS(4029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4031),
    [anon_sym_BANG_EQ] = ACTIONS(4029),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4031),
    [anon_sym_GT_EQ] = ACTIONS(4031),
    [anon_sym_instanceof] = ACTIONS(4031),
    [anon_sym_BANG] = ACTIONS(4029),
    [anon_sym_PLUS_PLUS] = ACTIONS(4031),
    [anon_sym_DASH_DASH] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4031),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4031),
  },
  [1587] = {
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_as] = ACTIONS(4027),
    [anon_sym_LBRACE] = ACTIONS(4025),
    [anon_sym_COMMA] = ACTIONS(4027),
    [anon_sym_LPAREN] = ACTIONS(4027),
    [anon_sym_in] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4027),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_DOT] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(4027),
    [anon_sym_AMP_AMP] = ACTIONS(4027),
    [anon_sym_PIPE_PIPE] = ACTIONS(4027),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_GT_GT_GT] = ACTIONS(4027),
    [anon_sym_LT_LT] = ACTIONS(4027),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_CARET] = ACTIONS(4027),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4027),
    [anon_sym_STAR_STAR] = ACTIONS(4027),
    [anon_sym_LT_EQ] = ACTIONS(4027),
    [anon_sym_EQ_EQ] = ACTIONS(4025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4027),
    [anon_sym_BANG_EQ] = ACTIONS(4025),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4027),
    [anon_sym_GT_EQ] = ACTIONS(4027),
    [anon_sym_instanceof] = ACTIONS(4027),
    [anon_sym_BANG] = ACTIONS(4025),
    [anon_sym_PLUS_PLUS] = ACTIONS(4027),
    [anon_sym_DASH_DASH] = ACTIONS(4027),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4027),
  },
  [1588] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
  },
  [1589] = {
    [anon_sym_STAR] = ACTIONS(4021),
    [anon_sym_as] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4021),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4021),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4021),
    [anon_sym_GT] = ACTIONS(4021),
    [anon_sym_SLASH] = ACTIONS(4021),
    [anon_sym_DOT] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE] = ACTIONS(4023),
    [anon_sym_GT_GT] = ACTIONS(4021),
    [anon_sym_GT_GT_GT] = ACTIONS(4023),
    [anon_sym_LT_LT] = ACTIONS(4023),
    [anon_sym_AMP] = ACTIONS(4021),
    [anon_sym_CARET] = ACTIONS(4023),
    [anon_sym_PIPE] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_PERCENT] = ACTIONS(4023),
    [anon_sym_STAR_STAR] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_EQ_EQ] = ACTIONS(4021),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4021),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4023),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_instanceof] = ACTIONS(4023),
    [anon_sym_BANG] = ACTIONS(4021),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4023),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4023),
  },
  [1590] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1591] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(3701),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1592] = {
    [anon_sym_STAR] = ACTIONS(4017),
    [anon_sym_as] = ACTIONS(4019),
    [anon_sym_LBRACE] = ACTIONS(4017),
    [anon_sym_COMMA] = ACTIONS(4019),
    [anon_sym_LPAREN] = ACTIONS(4019),
    [anon_sym_in] = ACTIONS(4017),
    [anon_sym_LBRACK] = ACTIONS(4019),
    [anon_sym_LT] = ACTIONS(4017),
    [anon_sym_GT] = ACTIONS(4017),
    [anon_sym_SLASH] = ACTIONS(4017),
    [anon_sym_DOT] = ACTIONS(4019),
    [anon_sym_QMARK] = ACTIONS(4019),
    [anon_sym_AMP_AMP] = ACTIONS(4019),
    [anon_sym_PIPE_PIPE] = ACTIONS(4019),
    [anon_sym_GT_GT] = ACTIONS(4017),
    [anon_sym_GT_GT_GT] = ACTIONS(4019),
    [anon_sym_LT_LT] = ACTIONS(4019),
    [anon_sym_AMP] = ACTIONS(4017),
    [anon_sym_CARET] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(4017),
    [anon_sym_PLUS] = ACTIONS(4017),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_PERCENT] = ACTIONS(4019),
    [anon_sym_STAR_STAR] = ACTIONS(4019),
    [anon_sym_LT_EQ] = ACTIONS(4019),
    [anon_sym_EQ_EQ] = ACTIONS(4017),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4019),
    [anon_sym_BANG_EQ] = ACTIONS(4017),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4019),
    [anon_sym_GT_EQ] = ACTIONS(4019),
    [anon_sym_instanceof] = ACTIONS(4019),
    [anon_sym_BANG] = ACTIONS(4017),
    [anon_sym_PLUS_PLUS] = ACTIONS(4019),
    [anon_sym_DASH_DASH] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4019),
  },
  [1593] = {
    [anon_sym_STAR] = ACTIONS(4099),
    [anon_sym_as] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(4099),
    [anon_sym_COMMA] = ACTIONS(3882),
    [anon_sym_LPAREN] = ACTIONS(3882),
    [anon_sym_in] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_LT] = ACTIONS(4099),
    [anon_sym_GT] = ACTIONS(4099),
    [anon_sym_SLASH] = ACTIONS(4099),
    [anon_sym_DOT] = ACTIONS(3882),
    [anon_sym_QMARK] = ACTIONS(3882),
    [anon_sym_AMP_AMP] = ACTIONS(3882),
    [anon_sym_PIPE_PIPE] = ACTIONS(3882),
    [anon_sym_GT_GT] = ACTIONS(4099),
    [anon_sym_GT_GT_GT] = ACTIONS(3882),
    [anon_sym_LT_LT] = ACTIONS(3882),
    [anon_sym_AMP] = ACTIONS(4099),
    [anon_sym_CARET] = ACTIONS(3882),
    [anon_sym_PIPE] = ACTIONS(4099),
    [anon_sym_PLUS] = ACTIONS(4099),
    [anon_sym_DASH] = ACTIONS(4099),
    [anon_sym_PERCENT] = ACTIONS(3882),
    [anon_sym_STAR_STAR] = ACTIONS(3882),
    [anon_sym_LT_EQ] = ACTIONS(3882),
    [anon_sym_EQ_EQ] = ACTIONS(4099),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3882),
    [anon_sym_BANG_EQ] = ACTIONS(4099),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3882),
    [anon_sym_GT_EQ] = ACTIONS(3882),
    [anon_sym_instanceof] = ACTIONS(3882),
    [anon_sym_BANG] = ACTIONS(4099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3882),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3882),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3882),
  },
  [1594] = {
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(4093),
    [anon_sym_LBRACE] = ACTIONS(4091),
    [anon_sym_COMMA] = ACTIONS(4093),
    [anon_sym_LPAREN] = ACTIONS(4093),
    [anon_sym_in] = ACTIONS(4091),
    [anon_sym_LBRACK] = ACTIONS(4093),
    [anon_sym_LT] = ACTIONS(4091),
    [anon_sym_GT] = ACTIONS(4091),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4093),
    [anon_sym_AMP_AMP] = ACTIONS(4093),
    [anon_sym_PIPE_PIPE] = ACTIONS(4093),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4093),
    [anon_sym_LT_LT] = ACTIONS(4093),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_CARET] = ACTIONS(4093),
    [anon_sym_PIPE] = ACTIONS(4091),
    [anon_sym_PLUS] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4091),
    [anon_sym_PERCENT] = ACTIONS(4093),
    [anon_sym_STAR_STAR] = ACTIONS(4093),
    [anon_sym_LT_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ] = ACTIONS(4091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ] = ACTIONS(4091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4093),
    [anon_sym_GT_EQ] = ACTIONS(4093),
    [anon_sym_instanceof] = ACTIONS(4093),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_PLUS_PLUS] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4093),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4093),
  },
  [1595] = {
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_as] = ACTIONS(3981),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(3981),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [anon_sym_DOT] = ACTIONS(3981),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_STAR_STAR] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_instanceof] = ACTIONS(3981),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3981),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3981),
  },
  [1596] = {
    [anon_sym_STAR] = ACTIONS(3937),
    [anon_sym_as] = ACTIONS(3939),
    [anon_sym_LBRACE] = ACTIONS(3937),
    [anon_sym_COMMA] = ACTIONS(3939),
    [anon_sym_LPAREN] = ACTIONS(3939),
    [anon_sym_in] = ACTIONS(3937),
    [anon_sym_LBRACK] = ACTIONS(3939),
    [anon_sym_LT] = ACTIONS(3937),
    [anon_sym_GT] = ACTIONS(3937),
    [anon_sym_SLASH] = ACTIONS(3937),
    [anon_sym_DOT] = ACTIONS(3939),
    [anon_sym_QMARK] = ACTIONS(3939),
    [anon_sym_AMP_AMP] = ACTIONS(3939),
    [anon_sym_PIPE_PIPE] = ACTIONS(3939),
    [anon_sym_GT_GT] = ACTIONS(3937),
    [anon_sym_GT_GT_GT] = ACTIONS(3939),
    [anon_sym_LT_LT] = ACTIONS(3939),
    [anon_sym_AMP] = ACTIONS(3937),
    [anon_sym_CARET] = ACTIONS(3939),
    [anon_sym_PIPE] = ACTIONS(3937),
    [anon_sym_PLUS] = ACTIONS(3937),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_PERCENT] = ACTIONS(3939),
    [anon_sym_STAR_STAR] = ACTIONS(3939),
    [anon_sym_LT_EQ] = ACTIONS(3939),
    [anon_sym_EQ_EQ] = ACTIONS(3937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3939),
    [anon_sym_BANG_EQ] = ACTIONS(3937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3939),
    [anon_sym_GT_EQ] = ACTIONS(3939),
    [anon_sym_instanceof] = ACTIONS(3939),
    [anon_sym_BANG] = ACTIONS(3937),
    [anon_sym_PLUS_PLUS] = ACTIONS(3939),
    [anon_sym_DASH_DASH] = ACTIONS(3939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3939),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3939),
  },
  [1597] = {
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1205),
  },
  [1598] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(2444),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1599] = {
    [anon_sym_STAR] = ACTIONS(4089),
    [anon_sym_as] = ACTIONS(3893),
    [anon_sym_LBRACE] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(3893),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [anon_sym_in] = ACTIONS(4089),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [anon_sym_LT] = ACTIONS(4089),
    [anon_sym_GT] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_DOT] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3893),
    [anon_sym_AMP_AMP] = ACTIONS(3893),
    [anon_sym_PIPE_PIPE] = ACTIONS(3893),
    [anon_sym_GT_GT] = ACTIONS(4089),
    [anon_sym_GT_GT_GT] = ACTIONS(3893),
    [anon_sym_LT_LT] = ACTIONS(3893),
    [anon_sym_AMP] = ACTIONS(4089),
    [anon_sym_CARET] = ACTIONS(3893),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_PLUS] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(3893),
    [anon_sym_STAR_STAR] = ACTIONS(3893),
    [anon_sym_LT_EQ] = ACTIONS(3893),
    [anon_sym_EQ_EQ] = ACTIONS(4089),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3893),
    [anon_sym_BANG_EQ] = ACTIONS(4089),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3893),
    [anon_sym_GT_EQ] = ACTIONS(3893),
    [anon_sym_instanceof] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3893),
    [anon_sym_DASH_DASH] = ACTIONS(3893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3893),
  },
  [1600] = {
    [sym_string] = STATE(1990),
    [sym__property_name] = STATE(1990),
    [sym_computed_property_name] = STATE(1990),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4803),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(3582),
    [anon_sym_set] = ACTIONS(3582),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1601] = {
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_as] = ACTIONS(4045),
    [anon_sym_LBRACE] = ACTIONS(4043),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4043),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4043),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_QMARK] = ACTIONS(4045),
    [anon_sym_AMP_AMP] = ACTIONS(4045),
    [anon_sym_PIPE_PIPE] = ACTIONS(4045),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_GT_GT_GT] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_STAR_STAR] = ACTIONS(4045),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4045),
    [anon_sym_BANG_EQ] = ACTIONS(4043),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4045),
    [anon_sym_instanceof] = ACTIONS(4045),
    [anon_sym_BANG] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4045),
  },
  [1602] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(3703),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1603] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [1604] = {
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_as] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2561),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2559),
    [anon_sym_in] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2559),
    [anon_sym_LT] = ACTIONS(2561),
    [anon_sym_GT] = ACTIONS(2561),
    [anon_sym_SLASH] = ACTIONS(2561),
    [anon_sym_DOT] = ACTIONS(2559),
    [anon_sym_QMARK] = ACTIONS(2559),
    [anon_sym_AMP_AMP] = ACTIONS(2559),
    [anon_sym_PIPE_PIPE] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2559),
    [anon_sym_LT_LT] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2561),
    [anon_sym_CARET] = ACTIONS(2559),
    [anon_sym_PIPE] = ACTIONS(2561),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_DASH] = ACTIONS(2561),
    [anon_sym_PERCENT] = ACTIONS(2559),
    [anon_sym_STAR_STAR] = ACTIONS(2559),
    [anon_sym_LT_EQ] = ACTIONS(2559),
    [anon_sym_EQ_EQ] = ACTIONS(2561),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2559),
    [anon_sym_BANG_EQ] = ACTIONS(2561),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2559),
    [anon_sym_GT_EQ] = ACTIONS(2559),
    [anon_sym_instanceof] = ACTIONS(2559),
    [anon_sym_BANG] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(2559),
    [anon_sym_DASH_DASH] = ACTIONS(2559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
  },
  [1605] = {
    [anon_sym_STAR] = ACTIONS(2543),
    [anon_sym_as] = ACTIONS(2541),
    [anon_sym_LBRACE] = ACTIONS(2543),
    [anon_sym_COMMA] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(2541),
    [anon_sym_in] = ACTIONS(2543),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_LT] = ACTIONS(2543),
    [anon_sym_GT] = ACTIONS(2543),
    [anon_sym_SLASH] = ACTIONS(2543),
    [anon_sym_DOT] = ACTIONS(2541),
    [anon_sym_QMARK] = ACTIONS(2541),
    [anon_sym_AMP_AMP] = ACTIONS(2541),
    [anon_sym_PIPE_PIPE] = ACTIONS(2541),
    [anon_sym_GT_GT] = ACTIONS(2543),
    [anon_sym_GT_GT_GT] = ACTIONS(2541),
    [anon_sym_LT_LT] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(2543),
    [anon_sym_CARET] = ACTIONS(2541),
    [anon_sym_PIPE] = ACTIONS(2543),
    [anon_sym_PLUS] = ACTIONS(2543),
    [anon_sym_DASH] = ACTIONS(2543),
    [anon_sym_PERCENT] = ACTIONS(2541),
    [anon_sym_STAR_STAR] = ACTIONS(2541),
    [anon_sym_LT_EQ] = ACTIONS(2541),
    [anon_sym_EQ_EQ] = ACTIONS(2543),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2541),
    [anon_sym_BANG_EQ] = ACTIONS(2543),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2541),
    [anon_sym_GT_EQ] = ACTIONS(2541),
    [anon_sym_instanceof] = ACTIONS(2541),
    [anon_sym_BANG] = ACTIONS(2543),
    [anon_sym_PLUS_PLUS] = ACTIONS(2541),
    [anon_sym_DASH_DASH] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2541),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2541),
  },
  [1606] = {
    [anon_sym_STAR] = ACTIONS(2547),
    [anon_sym_as] = ACTIONS(2545),
    [anon_sym_LBRACE] = ACTIONS(2547),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_in] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_LT] = ACTIONS(2547),
    [anon_sym_GT] = ACTIONS(2547),
    [anon_sym_SLASH] = ACTIONS(2547),
    [anon_sym_DOT] = ACTIONS(2545),
    [anon_sym_QMARK] = ACTIONS(2545),
    [anon_sym_AMP_AMP] = ACTIONS(2545),
    [anon_sym_PIPE_PIPE] = ACTIONS(2545),
    [anon_sym_GT_GT] = ACTIONS(2547),
    [anon_sym_GT_GT_GT] = ACTIONS(2545),
    [anon_sym_LT_LT] = ACTIONS(2545),
    [anon_sym_AMP] = ACTIONS(2547),
    [anon_sym_CARET] = ACTIONS(2545),
    [anon_sym_PIPE] = ACTIONS(2547),
    [anon_sym_PLUS] = ACTIONS(2547),
    [anon_sym_DASH] = ACTIONS(2547),
    [anon_sym_PERCENT] = ACTIONS(2545),
    [anon_sym_STAR_STAR] = ACTIONS(2545),
    [anon_sym_LT_EQ] = ACTIONS(2545),
    [anon_sym_EQ_EQ] = ACTIONS(2547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2545),
    [anon_sym_BANG_EQ] = ACTIONS(2547),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2545),
    [anon_sym_GT_EQ] = ACTIONS(2545),
    [anon_sym_instanceof] = ACTIONS(2545),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_PLUS_PLUS] = ACTIONS(2545),
    [anon_sym_DASH_DASH] = ACTIONS(2545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2545),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2545),
  },
  [1607] = {
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_as] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_in] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1213),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_AMP_AMP] = ACTIONS(1213),
    [anon_sym_PIPE_PIPE] = ACTIONS(1213),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_GT_GT_GT] = ACTIONS(1213),
    [anon_sym_LT_LT] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1213),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1213),
    [anon_sym_STAR_STAR] = ACTIONS(1213),
    [anon_sym_LT_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1213),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [anon_sym_instanceof] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_DASH_DASH] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1213),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1213),
  },
  [1608] = {
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_GT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1235),
    [anon_sym_AMP_AMP] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_GT_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1235),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1235),
  },
  [1609] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(3976),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [1610] = {
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1611] = {
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AMP_AMP] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_instanceof] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_DASH_DASH] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1163),
  },
  [1612] = {
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_as] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1133),
    [anon_sym_in] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1135),
    [anon_sym_DOT] = ACTIONS(1133),
    [anon_sym_QMARK] = ACTIONS(1133),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1135),
    [anon_sym_GT_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_PLUS] = ACTIONS(1135),
    [anon_sym_DASH] = ACTIONS(1135),
    [anon_sym_PERCENT] = ACTIONS(1133),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_LT_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1133),
    [anon_sym_GT_EQ] = ACTIONS(1133),
    [anon_sym_instanceof] = ACTIONS(1133),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_PLUS_PLUS] = ACTIONS(1133),
    [anon_sym_DASH_DASH] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1133),
  },
  [1613] = {
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_LBRACE] = ACTIONS(1169),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_in] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1167),
  },
  [1614] = {
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_as] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_LT] = ACTIONS(2650),
    [anon_sym_GT] = ACTIONS(2650),
    [anon_sym_SLASH] = ACTIONS(2650),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_GT_GT] = ACTIONS(2650),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_AMP] = ACTIONS(4805),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_STAR_STAR] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2650),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2648),
    [anon_sym_instanceof] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2648),
  },
  [1615] = {
    [anon_sym_STAR] = ACTIONS(2624),
    [anon_sym_as] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2624),
    [anon_sym_GT] = ACTIONS(2624),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_GT_GT] = ACTIONS(2624),
    [anon_sym_GT_GT_GT] = ACTIONS(2622),
    [anon_sym_LT_LT] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(4805),
    [anon_sym_CARET] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_PERCENT] = ACTIONS(2622),
    [anon_sym_STAR_STAR] = ACTIONS(2622),
    [anon_sym_LT_EQ] = ACTIONS(2622),
    [anon_sym_EQ_EQ] = ACTIONS(2624),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2622),
    [anon_sym_BANG_EQ] = ACTIONS(2624),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2622),
    [anon_sym_GT_EQ] = ACTIONS(2622),
    [anon_sym_instanceof] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2622),
  },
  [1616] = {
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_as] = ACTIONS(2630),
    [anon_sym_LBRACE] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LT] = ACTIONS(2632),
    [anon_sym_GT] = ACTIONS(2632),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_GT_GT] = ACTIONS(2632),
    [anon_sym_GT_GT_GT] = ACTIONS(2630),
    [anon_sym_LT_LT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(4805),
    [anon_sym_CARET] = ACTIONS(2630),
    [anon_sym_PIPE] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_PERCENT] = ACTIONS(2630),
    [anon_sym_STAR_STAR] = ACTIONS(2630),
    [anon_sym_LT_EQ] = ACTIONS(2630),
    [anon_sym_EQ_EQ] = ACTIONS(2632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2630),
    [anon_sym_BANG_EQ] = ACTIONS(2632),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2630),
    [anon_sym_GT_EQ] = ACTIONS(2630),
    [anon_sym_instanceof] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2630),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2630),
  },
  [1617] = {
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_as] = ACTIONS(2634),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2636),
    [anon_sym_GT] = ACTIONS(2636),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_GT_GT] = ACTIONS(2636),
    [anon_sym_GT_GT_GT] = ACTIONS(2634),
    [anon_sym_LT_LT] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(4805),
    [anon_sym_CARET] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_PERCENT] = ACTIONS(2634),
    [anon_sym_STAR_STAR] = ACTIONS(2634),
    [anon_sym_LT_EQ] = ACTIONS(2634),
    [anon_sym_EQ_EQ] = ACTIONS(2636),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2634),
    [anon_sym_BANG_EQ] = ACTIONS(2636),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2634),
    [anon_sym_GT_EQ] = ACTIONS(2634),
    [anon_sym_instanceof] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2634),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2634),
  },
  [1618] = {
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_as] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_COMMA] = ACTIONS(2644),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2646),
    [anon_sym_GT] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_DOT] = ACTIONS(2644),
    [anon_sym_QMARK] = ACTIONS(2644),
    [anon_sym_AMP_AMP] = ACTIONS(2644),
    [anon_sym_PIPE_PIPE] = ACTIONS(2644),
    [anon_sym_GT_GT] = ACTIONS(2646),
    [anon_sym_GT_GT_GT] = ACTIONS(2644),
    [anon_sym_LT_LT] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(4805),
    [anon_sym_CARET] = ACTIONS(2644),
    [anon_sym_PIPE] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2646),
    [anon_sym_PERCENT] = ACTIONS(2644),
    [anon_sym_STAR_STAR] = ACTIONS(2644),
    [anon_sym_LT_EQ] = ACTIONS(2644),
    [anon_sym_EQ_EQ] = ACTIONS(2646),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2644),
    [anon_sym_BANG_EQ] = ACTIONS(2646),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2644),
    [anon_sym_GT_EQ] = ACTIONS(2644),
    [anon_sym_instanceof] = ACTIONS(2644),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2644),
  },
  [1619] = {
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_as] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_in] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2396),
    [anon_sym_GT] = ACTIONS(2396),
    [anon_sym_SLASH] = ACTIONS(2396),
    [anon_sym_DOT] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2394),
    [anon_sym_PIPE_PIPE] = ACTIONS(2394),
    [anon_sym_GT_GT] = ACTIONS(2396),
    [anon_sym_GT_GT_GT] = ACTIONS(2394),
    [anon_sym_LT_LT] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_CARET] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_PERCENT] = ACTIONS(2394),
    [anon_sym_STAR_STAR] = ACTIONS(2394),
    [anon_sym_LT_EQ] = ACTIONS(2394),
    [anon_sym_EQ_EQ] = ACTIONS(2396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2394),
    [anon_sym_BANG_EQ] = ACTIONS(2396),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2394),
    [anon_sym_GT_EQ] = ACTIONS(2394),
    [anon_sym_instanceof] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2394),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2394),
  },
  [1620] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1223),
  },
  [1621] = {
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_as] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2400),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_DOT] = ACTIONS(2398),
    [anon_sym_QMARK] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_PIPE_PIPE] = ACTIONS(2398),
    [anon_sym_GT_GT] = ACTIONS(2400),
    [anon_sym_GT_GT_GT] = ACTIONS(2398),
    [anon_sym_LT_LT] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_CARET] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_STAR_STAR] = ACTIONS(2398),
    [anon_sym_LT_EQ] = ACTIONS(2398),
    [anon_sym_EQ_EQ] = ACTIONS(2400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2398),
    [anon_sym_BANG_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2398),
    [anon_sym_GT_EQ] = ACTIONS(2398),
    [anon_sym_instanceof] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2398),
  },
  [1622] = {
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2430),
    [anon_sym_in] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_LT] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2432),
    [anon_sym_SLASH] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2430),
    [anon_sym_PIPE_PIPE] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2432),
    [anon_sym_GT_GT_GT] = ACTIONS(2430),
    [anon_sym_LT_LT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_CARET] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2432),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_STAR_STAR] = ACTIONS(2430),
    [anon_sym_LT_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ] = ACTIONS(2432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2430),
    [anon_sym_BANG_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2430),
    [anon_sym_instanceof] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2430),
    [anon_sym_DASH_DASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2430),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2430),
  },
  [1623] = {
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1197),
    [anon_sym_SLASH] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1197),
    [anon_sym_DASH] = ACTIONS(1197),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1197),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1197),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1195),
  },
  [1624] = {
    [sym_string] = STATE(2150),
    [sym__property_name] = STATE(2150),
    [sym_computed_property_name] = STATE(2150),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4777),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1625] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1626] = {
    [sym_string] = STATE(2161),
    [sym__property_name] = STATE(2161),
    [sym_computed_property_name] = STATE(2161),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4789),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1627] = {
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_as] = ACTIONS(4045),
    [anon_sym_LBRACE] = ACTIONS(4043),
    [anon_sym_COMMA] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(4045),
    [anon_sym_in] = ACTIONS(4043),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_LT] = ACTIONS(4043),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_DOT] = ACTIONS(4045),
    [anon_sym_QMARK] = ACTIONS(4045),
    [anon_sym_AMP_AMP] = ACTIONS(4045),
    [anon_sym_PIPE_PIPE] = ACTIONS(4045),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_GT_GT_GT] = ACTIONS(4045),
    [anon_sym_LT_LT] = ACTIONS(4045),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4045),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4045),
    [anon_sym_STAR_STAR] = ACTIONS(4045),
    [anon_sym_LT_EQ] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4043),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4045),
    [anon_sym_BANG_EQ] = ACTIONS(4043),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4045),
    [anon_sym_GT_EQ] = ACTIONS(4045),
    [anon_sym_instanceof] = ACTIONS(4045),
    [anon_sym_BANG] = ACTIONS(4043),
    [anon_sym_PLUS_PLUS] = ACTIONS(4045),
    [anon_sym_DASH_DASH] = ACTIONS(4045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4045),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4045),
  },
  [1628] = {
    [anon_sym_STAR] = ACTIONS(1151),
    [anon_sym_as] = ACTIONS(1149),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_COMMA] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1149),
    [anon_sym_in] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1149),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_GT] = ACTIONS(1151),
    [anon_sym_SLASH] = ACTIONS(1151),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_QMARK] = ACTIONS(1149),
    [anon_sym_AMP_AMP] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(1149),
    [anon_sym_GT_GT] = ACTIONS(1151),
    [anon_sym_GT_GT_GT] = ACTIONS(1149),
    [anon_sym_LT_LT] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1151),
    [anon_sym_CARET] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1151),
    [anon_sym_PLUS] = ACTIONS(1151),
    [anon_sym_DASH] = ACTIONS(1151),
    [anon_sym_PERCENT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(1149),
    [anon_sym_LT_EQ] = ACTIONS(1149),
    [anon_sym_EQ_EQ] = ACTIONS(1151),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1149),
    [anon_sym_BANG_EQ] = ACTIONS(1151),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1149),
    [anon_sym_GT_EQ] = ACTIONS(1149),
    [anon_sym_instanceof] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_PLUS_PLUS] = ACTIONS(1149),
    [anon_sym_DASH_DASH] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1149),
  },
  [1629] = {
    [sym_string] = STATE(2139),
    [sym__property_name] = STATE(2139),
    [sym_computed_property_name] = STATE(2139),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4809),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1630] = {
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_as] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_in] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1183),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1183),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1181),
  },
  [1631] = {
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_as] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1211),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_in] = ACTIONS(1211),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_DOT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_AMP_AMP] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_GT_GT] = ACTIONS(1211),
    [anon_sym_GT_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1211),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_instanceof] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1209),
  },
  [1632] = {
    [anon_sym_STAR] = ACTIONS(4039),
    [anon_sym_as] = ACTIONS(4041),
    [anon_sym_LBRACE] = ACTIONS(4039),
    [anon_sym_COMMA] = ACTIONS(4041),
    [anon_sym_LPAREN] = ACTIONS(4041),
    [anon_sym_in] = ACTIONS(4039),
    [anon_sym_LBRACK] = ACTIONS(4041),
    [anon_sym_LT] = ACTIONS(4039),
    [anon_sym_GT] = ACTIONS(4039),
    [anon_sym_SLASH] = ACTIONS(4039),
    [anon_sym_DOT] = ACTIONS(4041),
    [anon_sym_QMARK] = ACTIONS(4041),
    [anon_sym_AMP_AMP] = ACTIONS(4041),
    [anon_sym_PIPE_PIPE] = ACTIONS(4041),
    [anon_sym_GT_GT] = ACTIONS(4039),
    [anon_sym_GT_GT_GT] = ACTIONS(4041),
    [anon_sym_LT_LT] = ACTIONS(4041),
    [anon_sym_AMP] = ACTIONS(4039),
    [anon_sym_CARET] = ACTIONS(4041),
    [anon_sym_PIPE] = ACTIONS(4039),
    [anon_sym_PLUS] = ACTIONS(4039),
    [anon_sym_DASH] = ACTIONS(4039),
    [anon_sym_PERCENT] = ACTIONS(4041),
    [anon_sym_STAR_STAR] = ACTIONS(4041),
    [anon_sym_LT_EQ] = ACTIONS(4041),
    [anon_sym_EQ_EQ] = ACTIONS(4039),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4041),
    [anon_sym_BANG_EQ] = ACTIONS(4039),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4041),
    [anon_sym_GT_EQ] = ACTIONS(4041),
    [anon_sym_instanceof] = ACTIONS(4041),
    [anon_sym_BANG] = ACTIONS(4039),
    [anon_sym_PLUS_PLUS] = ACTIONS(4041),
    [anon_sym_DASH_DASH] = ACTIONS(4041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4041),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4041),
  },
  [1633] = {
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_as] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2500),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_LT] = ACTIONS(2500),
    [anon_sym_GT] = ACTIONS(2500),
    [anon_sym_SLASH] = ACTIONS(2500),
    [anon_sym_DOT] = ACTIONS(2498),
    [anon_sym_QMARK] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2498),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_GT_GT_GT] = ACTIONS(2498),
    [anon_sym_LT_LT] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_CARET] = ACTIONS(2498),
    [anon_sym_PIPE] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PERCENT] = ACTIONS(2498),
    [anon_sym_STAR_STAR] = ACTIONS(2498),
    [anon_sym_LT_EQ] = ACTIONS(2498),
    [anon_sym_EQ_EQ] = ACTIONS(2500),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2498),
    [anon_sym_BANG_EQ] = ACTIONS(2500),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2498),
    [anon_sym_GT_EQ] = ACTIONS(2498),
    [anon_sym_instanceof] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2498),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2498),
  },
  [1634] = {
    [anon_sym_STAR] = ACTIONS(2474),
    [anon_sym_as] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_DOT] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_PIPE_PIPE] = ACTIONS(2472),
    [anon_sym_GT_GT] = ACTIONS(2474),
    [anon_sym_GT_GT_GT] = ACTIONS(2472),
    [anon_sym_LT_LT] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_CARET] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PERCENT] = ACTIONS(2472),
    [anon_sym_STAR_STAR] = ACTIONS(2472),
    [anon_sym_LT_EQ] = ACTIONS(2472),
    [anon_sym_EQ_EQ] = ACTIONS(2474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ] = ACTIONS(2474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2472),
    [anon_sym_GT_EQ] = ACTIONS(2472),
    [anon_sym_instanceof] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2472),
  },
  [1635] = {
    [anon_sym_STAR] = ACTIONS(2458),
    [anon_sym_as] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_in] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_GT] = ACTIONS(2458),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_DOT] = ACTIONS(2456),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2456),
    [anon_sym_PIPE_PIPE] = ACTIONS(2456),
    [anon_sym_GT_GT] = ACTIONS(2458),
    [anon_sym_GT_GT_GT] = ACTIONS(2456),
    [anon_sym_LT_LT] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_CARET] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_PERCENT] = ACTIONS(2456),
    [anon_sym_STAR_STAR] = ACTIONS(2456),
    [anon_sym_LT_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ] = ACTIONS(2458),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ] = ACTIONS(2458),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2456),
    [anon_sym_GT_EQ] = ACTIONS(2456),
    [anon_sym_instanceof] = ACTIONS(2456),
    [anon_sym_BANG] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2456),
    [anon_sym_DASH_DASH] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2456),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2456),
  },
  [1636] = {
    [sym_string] = STATE(2134),
    [sym__property_name] = STATE(2134),
    [sym_computed_property_name] = STATE(2134),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4656),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1637] = {
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_as] = ACTIONS(4087),
    [anon_sym_LBRACE] = ACTIONS(4085),
    [anon_sym_COMMA] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4087),
    [anon_sym_in] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4087),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_DOT] = ACTIONS(4087),
    [anon_sym_QMARK] = ACTIONS(4087),
    [anon_sym_AMP_AMP] = ACTIONS(4087),
    [anon_sym_PIPE_PIPE] = ACTIONS(4087),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_GT_GT_GT] = ACTIONS(4087),
    [anon_sym_LT_LT] = ACTIONS(4087),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_CARET] = ACTIONS(4087),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4087),
    [anon_sym_STAR_STAR] = ACTIONS(4087),
    [anon_sym_LT_EQ] = ACTIONS(4087),
    [anon_sym_EQ_EQ] = ACTIONS(4085),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4087),
    [anon_sym_BANG_EQ] = ACTIONS(4085),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4087),
    [anon_sym_GT_EQ] = ACTIONS(4087),
    [anon_sym_instanceof] = ACTIONS(4087),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_PLUS_PLUS] = ACTIONS(4087),
    [anon_sym_DASH_DASH] = ACTIONS(4087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4087),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4087),
  },
  [1638] = {
    [anon_sym_STAR] = ACTIONS(2454),
    [anon_sym_as] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_in] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(2452),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_AMP_AMP] = ACTIONS(2452),
    [anon_sym_PIPE_PIPE] = ACTIONS(2452),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2452),
    [anon_sym_LT_LT] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_CARET] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_PERCENT] = ACTIONS(2452),
    [anon_sym_STAR_STAR] = ACTIONS(2452),
    [anon_sym_LT_EQ] = ACTIONS(2452),
    [anon_sym_EQ_EQ] = ACTIONS(2454),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2452),
    [anon_sym_BANG_EQ] = ACTIONS(2454),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2452),
    [anon_sym_GT_EQ] = ACTIONS(2452),
    [anon_sym_instanceof] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2452),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2452),
  },
  [1639] = {
    [anon_sym_STAR] = ACTIONS(2442),
    [anon_sym_as] = ACTIONS(2440),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_in] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_GT] = ACTIONS(2442),
    [anon_sym_SLASH] = ACTIONS(2442),
    [anon_sym_DOT] = ACTIONS(2440),
    [anon_sym_QMARK] = ACTIONS(2440),
    [anon_sym_AMP_AMP] = ACTIONS(2440),
    [anon_sym_PIPE_PIPE] = ACTIONS(2440),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_GT_GT_GT] = ACTIONS(2440),
    [anon_sym_LT_LT] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2442),
    [anon_sym_CARET] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_PERCENT] = ACTIONS(2440),
    [anon_sym_STAR_STAR] = ACTIONS(2440),
    [anon_sym_LT_EQ] = ACTIONS(2440),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2440),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2440),
    [anon_sym_GT_EQ] = ACTIONS(2440),
    [anon_sym_instanceof] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2440),
    [anon_sym_DASH_DASH] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2440),
  },
  [1640] = {
    [anon_sym_STAR] = ACTIONS(4169),
    [anon_sym_as] = ACTIONS(4171),
    [anon_sym_LBRACE] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(4171),
    [anon_sym_LPAREN] = ACTIONS(4171),
    [anon_sym_in] = ACTIONS(4169),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(4169),
    [anon_sym_GT] = ACTIONS(4169),
    [anon_sym_SLASH] = ACTIONS(4169),
    [anon_sym_DOT] = ACTIONS(4171),
    [anon_sym_QMARK] = ACTIONS(4171),
    [anon_sym_AMP_AMP] = ACTIONS(4171),
    [anon_sym_PIPE_PIPE] = ACTIONS(4171),
    [anon_sym_GT_GT] = ACTIONS(4169),
    [anon_sym_GT_GT_GT] = ACTIONS(4171),
    [anon_sym_LT_LT] = ACTIONS(4171),
    [anon_sym_AMP] = ACTIONS(4169),
    [anon_sym_CARET] = ACTIONS(4171),
    [anon_sym_PIPE] = ACTIONS(4169),
    [anon_sym_PLUS] = ACTIONS(4169),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_PERCENT] = ACTIONS(4171),
    [anon_sym_STAR_STAR] = ACTIONS(4171),
    [anon_sym_LT_EQ] = ACTIONS(4171),
    [anon_sym_EQ_EQ] = ACTIONS(4169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4171),
    [anon_sym_BANG_EQ] = ACTIONS(4169),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4171),
    [anon_sym_GT_EQ] = ACTIONS(4171),
    [anon_sym_instanceof] = ACTIONS(4171),
    [anon_sym_BANG] = ACTIONS(4169),
    [anon_sym_PLUS_PLUS] = ACTIONS(4171),
    [anon_sym_DASH_DASH] = ACTIONS(4171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4171),
  },
  [1641] = {
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_as] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_SLASH] = ACTIONS(2466),
    [anon_sym_DOT] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_GT_GT] = ACTIONS(2466),
    [anon_sym_GT_GT_GT] = ACTIONS(2464),
    [anon_sym_LT_LT] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_CARET] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2464),
    [anon_sym_STAR_STAR] = ACTIONS(2464),
    [anon_sym_LT_EQ] = ACTIONS(2464),
    [anon_sym_EQ_EQ] = ACTIONS(2466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ] = ACTIONS(2466),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2464),
    [anon_sym_GT_EQ] = ACTIONS(2464),
    [anon_sym_instanceof] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2466),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2464),
  },
  [1642] = {
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_as] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2518),
    [anon_sym_GT] = ACTIONS(2518),
    [anon_sym_SLASH] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2516),
    [anon_sym_QMARK] = ACTIONS(2516),
    [anon_sym_AMP_AMP] = ACTIONS(2516),
    [anon_sym_PIPE_PIPE] = ACTIONS(2516),
    [anon_sym_GT_GT] = ACTIONS(2518),
    [anon_sym_GT_GT_GT] = ACTIONS(2516),
    [anon_sym_LT_LT] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2518),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_PERCENT] = ACTIONS(2516),
    [anon_sym_STAR_STAR] = ACTIONS(2516),
    [anon_sym_LT_EQ] = ACTIONS(2516),
    [anon_sym_EQ_EQ] = ACTIONS(2518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2516),
    [anon_sym_BANG_EQ] = ACTIONS(2518),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2516),
    [anon_sym_GT_EQ] = ACTIONS(2516),
    [anon_sym_instanceof] = ACTIONS(2516),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2516),
  },
  [1643] = {
    [anon_sym_STAR] = ACTIONS(2462),
    [anon_sym_as] = ACTIONS(2460),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_GT] = ACTIONS(2462),
    [anon_sym_SLASH] = ACTIONS(2462),
    [anon_sym_DOT] = ACTIONS(2460),
    [anon_sym_QMARK] = ACTIONS(2460),
    [anon_sym_AMP_AMP] = ACTIONS(2460),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2462),
    [anon_sym_GT_GT_GT] = ACTIONS(2460),
    [anon_sym_LT_LT] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2460),
    [anon_sym_STAR_STAR] = ACTIONS(2460),
    [anon_sym_LT_EQ] = ACTIONS(2460),
    [anon_sym_EQ_EQ] = ACTIONS(2462),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2460),
    [anon_sym_GT_EQ] = ACTIONS(2460),
    [anon_sym_instanceof] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2460),
  },
  [1644] = {
    [anon_sym_STAR] = ACTIONS(4137),
    [anon_sym_as] = ACTIONS(4139),
    [anon_sym_LBRACE] = ACTIONS(4137),
    [anon_sym_COMMA] = ACTIONS(4139),
    [anon_sym_LPAREN] = ACTIONS(4139),
    [anon_sym_in] = ACTIONS(4137),
    [anon_sym_LBRACK] = ACTIONS(4139),
    [anon_sym_LT] = ACTIONS(4137),
    [anon_sym_GT] = ACTIONS(4137),
    [anon_sym_SLASH] = ACTIONS(4137),
    [anon_sym_DOT] = ACTIONS(4139),
    [anon_sym_QMARK] = ACTIONS(4139),
    [anon_sym_AMP_AMP] = ACTIONS(4139),
    [anon_sym_PIPE_PIPE] = ACTIONS(4139),
    [anon_sym_GT_GT] = ACTIONS(4137),
    [anon_sym_GT_GT_GT] = ACTIONS(4139),
    [anon_sym_LT_LT] = ACTIONS(4139),
    [anon_sym_AMP] = ACTIONS(4137),
    [anon_sym_CARET] = ACTIONS(4139),
    [anon_sym_PIPE] = ACTIONS(4137),
    [anon_sym_PLUS] = ACTIONS(4137),
    [anon_sym_DASH] = ACTIONS(4137),
    [anon_sym_PERCENT] = ACTIONS(4139),
    [anon_sym_STAR_STAR] = ACTIONS(4139),
    [anon_sym_LT_EQ] = ACTIONS(4139),
    [anon_sym_EQ_EQ] = ACTIONS(4137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4139),
    [anon_sym_BANG_EQ] = ACTIONS(4137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4139),
    [anon_sym_GT_EQ] = ACTIONS(4139),
    [anon_sym_instanceof] = ACTIONS(4139),
    [anon_sym_BANG] = ACTIONS(4137),
    [anon_sym_PLUS_PLUS] = ACTIONS(4139),
    [anon_sym_DASH_DASH] = ACTIONS(4139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4139),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4139),
  },
  [1645] = {
    [anon_sym_STAR] = ACTIONS(2496),
    [anon_sym_as] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_in] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2496),
    [anon_sym_GT] = ACTIONS(2496),
    [anon_sym_SLASH] = ACTIONS(2496),
    [anon_sym_DOT] = ACTIONS(2494),
    [anon_sym_QMARK] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2496),
    [anon_sym_GT_GT_GT] = ACTIONS(2494),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_CARET] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PERCENT] = ACTIONS(2494),
    [anon_sym_STAR_STAR] = ACTIONS(2494),
    [anon_sym_LT_EQ] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2494),
    [anon_sym_BANG_EQ] = ACTIONS(2496),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2494),
    [anon_sym_GT_EQ] = ACTIONS(2494),
    [anon_sym_instanceof] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2494),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2494),
  },
  [1646] = {
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(2488),
    [anon_sym_GT] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2486),
    [anon_sym_GT_GT] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2486),
    [anon_sym_LT_LT] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_CARET] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2486),
    [anon_sym_STAR_STAR] = ACTIONS(2486),
    [anon_sym_LT_EQ] = ACTIONS(2486),
    [anon_sym_EQ_EQ] = ACTIONS(2488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2486),
    [anon_sym_BANG_EQ] = ACTIONS(2488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2486),
    [anon_sym_GT_EQ] = ACTIONS(2486),
    [anon_sym_instanceof] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2486),
  },
  [1647] = {
    [sym_string] = STATE(2186),
    [sym__property_name] = STATE(2186),
    [sym_computed_property_name] = STATE(2186),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4769),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1648] = {
    [anon_sym_STAR] = ACTIONS(4141),
    [anon_sym_as] = ACTIONS(4143),
    [anon_sym_LBRACE] = ACTIONS(4141),
    [anon_sym_COMMA] = ACTIONS(4143),
    [anon_sym_LPAREN] = ACTIONS(4143),
    [anon_sym_in] = ACTIONS(4141),
    [anon_sym_LBRACK] = ACTIONS(4143),
    [anon_sym_LT] = ACTIONS(4141),
    [anon_sym_GT] = ACTIONS(4141),
    [anon_sym_SLASH] = ACTIONS(4141),
    [anon_sym_DOT] = ACTIONS(4143),
    [anon_sym_QMARK] = ACTIONS(4143),
    [anon_sym_AMP_AMP] = ACTIONS(4143),
    [anon_sym_PIPE_PIPE] = ACTIONS(4143),
    [anon_sym_GT_GT] = ACTIONS(4141),
    [anon_sym_GT_GT_GT] = ACTIONS(4143),
    [anon_sym_LT_LT] = ACTIONS(4143),
    [anon_sym_AMP] = ACTIONS(4141),
    [anon_sym_CARET] = ACTIONS(4143),
    [anon_sym_PIPE] = ACTIONS(4141),
    [anon_sym_PLUS] = ACTIONS(4141),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_PERCENT] = ACTIONS(4143),
    [anon_sym_STAR_STAR] = ACTIONS(4143),
    [anon_sym_LT_EQ] = ACTIONS(4143),
    [anon_sym_EQ_EQ] = ACTIONS(4141),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4143),
    [anon_sym_BANG_EQ] = ACTIONS(4141),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4143),
    [anon_sym_GT_EQ] = ACTIONS(4143),
    [anon_sym_instanceof] = ACTIONS(4143),
    [anon_sym_BANG] = ACTIONS(4141),
    [anon_sym_PLUS_PLUS] = ACTIONS(4143),
    [anon_sym_DASH_DASH] = ACTIONS(4143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4143),
  },
  [1649] = {
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_as] = ACTIONS(2448),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_in] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2450),
    [anon_sym_DOT] = ACTIONS(2448),
    [anon_sym_QMARK] = ACTIONS(2448),
    [anon_sym_AMP_AMP] = ACTIONS(2448),
    [anon_sym_PIPE_PIPE] = ACTIONS(2448),
    [anon_sym_GT_GT] = ACTIONS(2450),
    [anon_sym_GT_GT_GT] = ACTIONS(2448),
    [anon_sym_LT_LT] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_CARET] = ACTIONS(2448),
    [anon_sym_PIPE] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_PERCENT] = ACTIONS(2448),
    [anon_sym_STAR_STAR] = ACTIONS(2448),
    [anon_sym_LT_EQ] = ACTIONS(2448),
    [anon_sym_EQ_EQ] = ACTIONS(2450),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ] = ACTIONS(2450),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2448),
    [anon_sym_GT_EQ] = ACTIONS(2448),
    [anon_sym_instanceof] = ACTIONS(2448),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2448),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2448),
  },
  [1650] = {
    [anon_sym_STAR] = ACTIONS(4153),
    [anon_sym_as] = ACTIONS(4155),
    [anon_sym_LBRACE] = ACTIONS(4153),
    [anon_sym_COMMA] = ACTIONS(4155),
    [anon_sym_LPAREN] = ACTIONS(4155),
    [anon_sym_in] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(4155),
    [anon_sym_LT] = ACTIONS(4153),
    [anon_sym_GT] = ACTIONS(4153),
    [anon_sym_SLASH] = ACTIONS(4153),
    [anon_sym_DOT] = ACTIONS(4155),
    [anon_sym_QMARK] = ACTIONS(4155),
    [anon_sym_AMP_AMP] = ACTIONS(4155),
    [anon_sym_PIPE_PIPE] = ACTIONS(4155),
    [anon_sym_GT_GT] = ACTIONS(4153),
    [anon_sym_GT_GT_GT] = ACTIONS(4155),
    [anon_sym_LT_LT] = ACTIONS(4155),
    [anon_sym_AMP] = ACTIONS(4153),
    [anon_sym_CARET] = ACTIONS(4155),
    [anon_sym_PIPE] = ACTIONS(4153),
    [anon_sym_PLUS] = ACTIONS(4153),
    [anon_sym_DASH] = ACTIONS(4153),
    [anon_sym_PERCENT] = ACTIONS(4155),
    [anon_sym_STAR_STAR] = ACTIONS(4155),
    [anon_sym_LT_EQ] = ACTIONS(4155),
    [anon_sym_EQ_EQ] = ACTIONS(4153),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4155),
    [anon_sym_BANG_EQ] = ACTIONS(4153),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4155),
    [anon_sym_GT_EQ] = ACTIONS(4155),
    [anon_sym_instanceof] = ACTIONS(4155),
    [anon_sym_BANG] = ACTIONS(4153),
    [anon_sym_PLUS_PLUS] = ACTIONS(4155),
    [anon_sym_DASH_DASH] = ACTIONS(4155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4155),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4155),
  },
  [1651] = {
    [anon_sym_STAR] = ACTIONS(1189),
    [anon_sym_as] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(1191),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_GT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1191),
    [anon_sym_QMARK] = ACTIONS(1191),
    [anon_sym_AMP_AMP] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_GT_GT_GT] = ACTIONS(1191),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1189),
    [anon_sym_DASH] = ACTIONS(1189),
    [anon_sym_PERCENT] = ACTIONS(1191),
    [anon_sym_STAR_STAR] = ACTIONS(1191),
    [anon_sym_LT_EQ] = ACTIONS(1191),
    [anon_sym_EQ_EQ] = ACTIONS(1189),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1191),
    [anon_sym_BANG_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1191),
    [anon_sym_GT_EQ] = ACTIONS(1191),
    [anon_sym_instanceof] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_PLUS_PLUS] = ACTIONS(1191),
    [anon_sym_DASH_DASH] = ACTIONS(1191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1191),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1191),
  },
  [1652] = {
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_RBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
  },
  [1653] = {
    [anon_sym_STAR] = ACTIONS(2478),
    [anon_sym_as] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_in] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_DOT] = ACTIONS(2476),
    [anon_sym_QMARK] = ACTIONS(2476),
    [anon_sym_AMP_AMP] = ACTIONS(2476),
    [anon_sym_PIPE_PIPE] = ACTIONS(2476),
    [anon_sym_GT_GT] = ACTIONS(2478),
    [anon_sym_GT_GT_GT] = ACTIONS(2476),
    [anon_sym_LT_LT] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_CARET] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2476),
    [anon_sym_STAR_STAR] = ACTIONS(2476),
    [anon_sym_LT_EQ] = ACTIONS(2476),
    [anon_sym_EQ_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2476),
    [anon_sym_GT_EQ] = ACTIONS(2476),
    [anon_sym_instanceof] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2476),
  },
  [1654] = {
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2434),
    [anon_sym_in] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2436),
    [anon_sym_SLASH] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_QMARK] = ACTIONS(2434),
    [anon_sym_AMP_AMP] = ACTIONS(2434),
    [anon_sym_PIPE_PIPE] = ACTIONS(2434),
    [anon_sym_GT_GT] = ACTIONS(2436),
    [anon_sym_GT_GT_GT] = ACTIONS(2434),
    [anon_sym_LT_LT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_CARET] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2434),
    [anon_sym_STAR_STAR] = ACTIONS(2434),
    [anon_sym_LT_EQ] = ACTIONS(2434),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2434),
    [anon_sym_BANG_EQ] = ACTIONS(2436),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2434),
    [anon_sym_GT_EQ] = ACTIONS(2434),
    [anon_sym_instanceof] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2434),
    [anon_sym_DASH_DASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2434),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2434),
  },
  [1655] = {
    [anon_sym_STAR] = ACTIONS(2446),
    [anon_sym_as] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2446),
    [anon_sym_DOT] = ACTIONS(2444),
    [anon_sym_QMARK] = ACTIONS(2444),
    [anon_sym_AMP_AMP] = ACTIONS(2444),
    [anon_sym_PIPE_PIPE] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2446),
    [anon_sym_GT_GT_GT] = ACTIONS(2444),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_PERCENT] = ACTIONS(2444),
    [anon_sym_STAR_STAR] = ACTIONS(2444),
    [anon_sym_LT_EQ] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2444),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2444),
    [anon_sym_GT_EQ] = ACTIONS(2444),
    [anon_sym_instanceof] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2444),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2444),
  },
  [1656] = {
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_as] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_LT] = ACTIONS(2508),
    [anon_sym_GT] = ACTIONS(2508),
    [anon_sym_SLASH] = ACTIONS(2508),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_GT_GT] = ACTIONS(2508),
    [anon_sym_GT_GT_GT] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PERCENT] = ACTIONS(2506),
    [anon_sym_STAR_STAR] = ACTIONS(2506),
    [anon_sym_LT_EQ] = ACTIONS(2506),
    [anon_sym_EQ_EQ] = ACTIONS(2508),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2506),
    [anon_sym_BANG_EQ] = ACTIONS(2508),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2506),
    [anon_sym_GT_EQ] = ACTIONS(2506),
    [anon_sym_instanceof] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2506),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2506),
  },
  [1657] = {
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_as] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2512),
    [anon_sym_QMARK] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_GT_GT] = ACTIONS(2514),
    [anon_sym_GT_GT_GT] = ACTIONS(2512),
    [anon_sym_LT_LT] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2514),
    [anon_sym_CARET] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_PERCENT] = ACTIONS(2512),
    [anon_sym_STAR_STAR] = ACTIONS(2512),
    [anon_sym_LT_EQ] = ACTIONS(2512),
    [anon_sym_EQ_EQ] = ACTIONS(2514),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2512),
    [anon_sym_BANG_EQ] = ACTIONS(2514),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2512),
    [anon_sym_GT_EQ] = ACTIONS(2512),
    [anon_sym_instanceof] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2512),
  },
  [1658] = {
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_as] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2522),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(4799),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_GT] = ACTIONS(2522),
    [anon_sym_SLASH] = ACTIONS(2522),
    [anon_sym_DOT] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_GT_GT] = ACTIONS(2522),
    [anon_sym_GT_GT_GT] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2522),
    [anon_sym_CARET] = ACTIONS(2520),
    [anon_sym_PIPE] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_PERCENT] = ACTIONS(2520),
    [anon_sym_STAR_STAR] = ACTIONS(2520),
    [anon_sym_LT_EQ] = ACTIONS(2520),
    [anon_sym_EQ_EQ] = ACTIONS(2522),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2520),
    [anon_sym_BANG_EQ] = ACTIONS(2522),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2520),
    [anon_sym_GT_EQ] = ACTIONS(2520),
    [anon_sym_instanceof] = ACTIONS(2520),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2520),
  },
  [1659] = {
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_as] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(2607),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_LPAREN] = ACTIONS(2605),
    [anon_sym_in] = ACTIONS(2607),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_LT] = ACTIONS(2607),
    [anon_sym_GT] = ACTIONS(2607),
    [anon_sym_SLASH] = ACTIONS(2607),
    [anon_sym_DOT] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(2605),
    [anon_sym_AMP_AMP] = ACTIONS(2605),
    [anon_sym_PIPE_PIPE] = ACTIONS(2605),
    [anon_sym_GT_GT] = ACTIONS(2607),
    [anon_sym_GT_GT_GT] = ACTIONS(2605),
    [anon_sym_LT_LT] = ACTIONS(2605),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_CARET] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PLUS] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2607),
    [anon_sym_PERCENT] = ACTIONS(2605),
    [anon_sym_STAR_STAR] = ACTIONS(2605),
    [anon_sym_LT_EQ] = ACTIONS(2605),
    [anon_sym_EQ_EQ] = ACTIONS(2607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2605),
    [anon_sym_BANG_EQ] = ACTIONS(2607),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2605),
    [anon_sym_GT_EQ] = ACTIONS(2605),
    [anon_sym_instanceof] = ACTIONS(2605),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2605),
  },
  [1660] = {
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_as] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_LT] = ACTIONS(2492),
    [anon_sym_GT] = ACTIONS(2492),
    [anon_sym_SLASH] = ACTIONS(2492),
    [anon_sym_DOT] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_GT_GT_GT] = ACTIONS(2490),
    [anon_sym_LT_LT] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(2490),
    [anon_sym_PIPE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PERCENT] = ACTIONS(2490),
    [anon_sym_STAR_STAR] = ACTIONS(2490),
    [anon_sym_LT_EQ] = ACTIONS(2490),
    [anon_sym_EQ_EQ] = ACTIONS(2492),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2490),
    [anon_sym_BANG_EQ] = ACTIONS(2492),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2490),
    [anon_sym_GT_EQ] = ACTIONS(2490),
    [anon_sym_instanceof] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2490),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2490),
  },
  [1661] = {
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_LBRACE] = ACTIONS(4075),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
    [anon_sym_LBRACK] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4075),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4077),
  },
  [1662] = {
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_as] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1143),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_in] = ACTIONS(1143),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1143),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_SLASH] = ACTIONS(1143),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_AMP_AMP] = ACTIONS(1145),
    [anon_sym_PIPE_PIPE] = ACTIONS(1145),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [anon_sym_GT_GT_GT] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_STAR_STAR] = ACTIONS(1145),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1143),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_instanceof] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1145),
    [anon_sym_DASH_DASH] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1145),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1145),
  },
  [1663] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(3947),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1664] = {
    [anon_sym_STAR] = ACTIONS(4069),
    [anon_sym_as] = ACTIONS(4071),
    [anon_sym_LBRACE] = ACTIONS(4069),
    [anon_sym_COMMA] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(4071),
    [anon_sym_in] = ACTIONS(4069),
    [anon_sym_LBRACK] = ACTIONS(4071),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_SLASH] = ACTIONS(4069),
    [anon_sym_DOT] = ACTIONS(4071),
    [anon_sym_QMARK] = ACTIONS(4071),
    [anon_sym_AMP_AMP] = ACTIONS(4071),
    [anon_sym_PIPE_PIPE] = ACTIONS(4071),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_GT_GT_GT] = ACTIONS(4071),
    [anon_sym_LT_LT] = ACTIONS(4071),
    [anon_sym_AMP] = ACTIONS(4069),
    [anon_sym_CARET] = ACTIONS(4071),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_PERCENT] = ACTIONS(4071),
    [anon_sym_STAR_STAR] = ACTIONS(4071),
    [anon_sym_LT_EQ] = ACTIONS(4071),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4071),
    [anon_sym_GT_EQ] = ACTIONS(4071),
    [anon_sym_instanceof] = ACTIONS(4071),
    [anon_sym_BANG] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(4071),
    [anon_sym_DASH_DASH] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4071),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4071),
  },
  [1665] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(3976),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1666] = {
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1231),
    [anon_sym_in] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_GT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_QMARK] = ACTIONS(1231),
    [anon_sym_AMP_AMP] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_GT_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1229),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1231),
    [anon_sym_GT_EQ] = ACTIONS(1231),
    [anon_sym_instanceof] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_PLUS_PLUS] = ACTIONS(1231),
    [anon_sym_DASH_DASH] = ACTIONS(1231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1231),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1231),
  },
  [1667] = {
    [sym_string] = STATE(2156),
    [sym__property_name] = STATE(2156),
    [sym_computed_property_name] = STATE(2156),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4622),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1668] = {
    [anon_sym_STAR] = ACTIONS(4111),
    [anon_sym_as] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(4111),
    [anon_sym_COMMA] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3791),
    [anon_sym_in] = ACTIONS(4111),
    [anon_sym_LBRACK] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(4111),
    [anon_sym_GT] = ACTIONS(4111),
    [anon_sym_SLASH] = ACTIONS(4111),
    [anon_sym_DOT] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3791),
    [anon_sym_AMP_AMP] = ACTIONS(3791),
    [anon_sym_PIPE_PIPE] = ACTIONS(3791),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_GT_GT_GT] = ACTIONS(3791),
    [anon_sym_LT_LT] = ACTIONS(3791),
    [anon_sym_AMP] = ACTIONS(4111),
    [anon_sym_CARET] = ACTIONS(3791),
    [anon_sym_PIPE] = ACTIONS(4111),
    [anon_sym_PLUS] = ACTIONS(4111),
    [anon_sym_DASH] = ACTIONS(4111),
    [anon_sym_PERCENT] = ACTIONS(3791),
    [anon_sym_STAR_STAR] = ACTIONS(3791),
    [anon_sym_LT_EQ] = ACTIONS(3791),
    [anon_sym_EQ_EQ] = ACTIONS(4111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3791),
    [anon_sym_BANG_EQ] = ACTIONS(4111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3791),
    [anon_sym_GT_EQ] = ACTIONS(3791),
    [anon_sym_instanceof] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(4111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3791),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3791),
  },
  [1669] = {
    [anon_sym_STAR] = ACTIONS(2470),
    [anon_sym_as] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_DOT] = ACTIONS(2468),
    [anon_sym_QMARK] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_PIPE_PIPE] = ACTIONS(2468),
    [anon_sym_GT_GT] = ACTIONS(2470),
    [anon_sym_GT_GT_GT] = ACTIONS(2468),
    [anon_sym_LT_LT] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_CARET] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PERCENT] = ACTIONS(2468),
    [anon_sym_STAR_STAR] = ACTIONS(2468),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2470),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2468),
  },
  [1670] = {
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_as] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_LPAREN] = ACTIONS(617),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_LT] = ACTIONS(2510),
    [anon_sym_GT] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(617),
    [anon_sym_QMARK] = ACTIONS(617),
    [anon_sym_AMP_AMP] = ACTIONS(617),
    [anon_sym_PIPE_PIPE] = ACTIONS(617),
    [anon_sym_GT_GT] = ACTIONS(2510),
    [anon_sym_GT_GT_GT] = ACTIONS(617),
    [anon_sym_LT_LT] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_CARET] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PERCENT] = ACTIONS(617),
    [anon_sym_STAR_STAR] = ACTIONS(617),
    [anon_sym_LT_EQ] = ACTIONS(617),
    [anon_sym_EQ_EQ] = ACTIONS(2510),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(617),
    [anon_sym_BANG_EQ] = ACTIONS(2510),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(617),
    [anon_sym_GT_EQ] = ACTIONS(617),
    [anon_sym_instanceof] = ACTIONS(617),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(617),
    [anon_sym_DASH_DASH] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [anon_sym_LBRACE_PIPE] = ACTIONS(617),
  },
  [1671] = {
    [sym_string] = STATE(2180),
    [sym__property_name] = STATE(2180),
    [sym_computed_property_name] = STATE(2180),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4723),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1672] = {
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_as] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_in] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_DOT] = ACTIONS(1277),
    [anon_sym_QMARK] = ACTIONS(1277),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_PIPE_PIPE] = ACTIONS(1277),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_GT_GT_GT] = ACTIONS(1277),
    [anon_sym_LT_LT] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_LT_EQ] = ACTIONS(1277),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1277),
    [anon_sym_BANG_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1277),
    [anon_sym_instanceof] = ACTIONS(1277),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1277),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1277),
  },
  [1673] = {
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_as] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2504),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2504),
    [anon_sym_GT_GT_GT] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_CARET] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PERCENT] = ACTIONS(2502),
    [anon_sym_STAR_STAR] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2504),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2502),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_instanceof] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2502),
  },
  [1674] = {
    [sym_string] = STATE(2167),
    [sym__property_name] = STATE(2167),
    [sym_computed_property_name] = STATE(2167),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4731),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1675] = {
    [anon_sym_STAR] = ACTIONS(3658),
    [anon_sym_as] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(3658),
    [anon_sym_COMMA] = ACTIONS(3662),
    [anon_sym_LPAREN] = ACTIONS(3662),
    [anon_sym_in] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3662),
    [anon_sym_LT] = ACTIONS(3658),
    [anon_sym_GT] = ACTIONS(3658),
    [anon_sym_SLASH] = ACTIONS(3658),
    [anon_sym_DOT] = ACTIONS(3662),
    [anon_sym_QMARK] = ACTIONS(3662),
    [anon_sym_AMP_AMP] = ACTIONS(3662),
    [anon_sym_PIPE_PIPE] = ACTIONS(3662),
    [anon_sym_GT_GT] = ACTIONS(3658),
    [anon_sym_GT_GT_GT] = ACTIONS(3662),
    [anon_sym_LT_LT] = ACTIONS(3662),
    [anon_sym_AMP] = ACTIONS(3658),
    [anon_sym_CARET] = ACTIONS(3662),
    [anon_sym_PIPE] = ACTIONS(3658),
    [anon_sym_PLUS] = ACTIONS(3658),
    [anon_sym_DASH] = ACTIONS(3658),
    [anon_sym_PERCENT] = ACTIONS(3662),
    [anon_sym_STAR_STAR] = ACTIONS(3662),
    [anon_sym_LT_EQ] = ACTIONS(3662),
    [anon_sym_EQ_EQ] = ACTIONS(3658),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3662),
    [anon_sym_BANG_EQ] = ACTIONS(3658),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3662),
    [anon_sym_GT_EQ] = ACTIONS(3662),
    [anon_sym_instanceof] = ACTIONS(3662),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_PLUS_PLUS] = ACTIONS(3662),
    [anon_sym_DASH_DASH] = ACTIONS(3662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3662),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3662),
  },
  [1676] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1677] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1678] = {
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1679] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
  },
  [1680] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
  },
  [1681] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1682] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1683] = {
    [anon_sym_STAR] = ACTIONS(4157),
    [anon_sym_as] = ACTIONS(4159),
    [anon_sym_LBRACE] = ACTIONS(4157),
    [anon_sym_COMMA] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4157),
    [anon_sym_LBRACK] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4157),
    [anon_sym_GT] = ACTIONS(4157),
    [anon_sym_SLASH] = ACTIONS(4157),
    [anon_sym_DOT] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_GT_GT] = ACTIONS(4157),
    [anon_sym_GT_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4157),
    [anon_sym_CARET] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4157),
    [anon_sym_PLUS] = ACTIONS(4157),
    [anon_sym_DASH] = ACTIONS(4157),
    [anon_sym_PERCENT] = ACTIONS(4159),
    [anon_sym_STAR_STAR] = ACTIONS(4159),
    [anon_sym_LT_EQ] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4159),
    [anon_sym_BANG_EQ] = ACTIONS(4157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4159),
    [anon_sym_GT_EQ] = ACTIONS(4159),
    [anon_sym_instanceof] = ACTIONS(4159),
    [anon_sym_BANG] = ACTIONS(4157),
    [anon_sym_PLUS_PLUS] = ACTIONS(4159),
    [anon_sym_DASH_DASH] = ACTIONS(4159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4159),
  },
  [1684] = {
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_as] = ACTIONS(4186),
    [anon_sym_LBRACE] = ACTIONS(4184),
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_in] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_LT] = ACTIONS(4184),
    [anon_sym_GT] = ACTIONS(4184),
    [anon_sym_SLASH] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4186),
    [anon_sym_QMARK] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_GT_GT] = ACTIONS(4184),
    [anon_sym_GT_GT_GT] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4186),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_CARET] = ACTIONS(4186),
    [anon_sym_PIPE] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4184),
    [anon_sym_PERCENT] = ACTIONS(4186),
    [anon_sym_STAR_STAR] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ] = ACTIONS(4184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_BANG_EQ] = ACTIONS(4184),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4186),
    [anon_sym_GT_EQ] = ACTIONS(4186),
    [anon_sym_instanceof] = ACTIONS(4186),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_PLUS_PLUS] = ACTIONS(4186),
    [anon_sym_DASH_DASH] = ACTIONS(4186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4186),
  },
  [1685] = {
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_as] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(4095),
    [anon_sym_COMMA] = ACTIONS(4097),
    [anon_sym_LPAREN] = ACTIONS(4097),
    [anon_sym_in] = ACTIONS(4095),
    [anon_sym_LBRACK] = ACTIONS(4097),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4095),
    [anon_sym_SLASH] = ACTIONS(4095),
    [anon_sym_DOT] = ACTIONS(4097),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4097),
    [anon_sym_PIPE_PIPE] = ACTIONS(4097),
    [anon_sym_GT_GT] = ACTIONS(4095),
    [anon_sym_GT_GT_GT] = ACTIONS(4097),
    [anon_sym_LT_LT] = ACTIONS(4097),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym_CARET] = ACTIONS(4097),
    [anon_sym_PIPE] = ACTIONS(4095),
    [anon_sym_PLUS] = ACTIONS(4095),
    [anon_sym_DASH] = ACTIONS(4095),
    [anon_sym_PERCENT] = ACTIONS(4097),
    [anon_sym_STAR_STAR] = ACTIONS(4097),
    [anon_sym_LT_EQ] = ACTIONS(4097),
    [anon_sym_EQ_EQ] = ACTIONS(4095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4097),
    [anon_sym_BANG_EQ] = ACTIONS(4095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4097),
    [anon_sym_GT_EQ] = ACTIONS(4097),
    [anon_sym_instanceof] = ACTIONS(4097),
    [anon_sym_BANG] = ACTIONS(4095),
    [anon_sym_PLUS_PLUS] = ACTIONS(4097),
    [anon_sym_DASH_DASH] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4097),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4097),
  },
  [1686] = {
    [sym_string] = STATE(2114),
    [sym__property_name] = STATE(2114),
    [sym_computed_property_name] = STATE(2114),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4737),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1687] = {
    [sym_template_string] = STATE(1078),
    [sym_arguments] = STATE(1078),
    [sym_type_arguments] = STATE(2548),
    [anon_sym_STAR] = ACTIONS(4250),
    [anon_sym_as] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(3909),
    [anon_sym_LT] = ACTIONS(4254),
    [anon_sym_GT] = ACTIONS(4252),
    [anon_sym_SLASH] = ACTIONS(4250),
    [anon_sym_DOT] = ACTIONS(3566),
    [anon_sym_QMARK] = ACTIONS(4256),
    [anon_sym_AMP_AMP] = ACTIONS(4258),
    [anon_sym_PIPE_PIPE] = ACTIONS(4260),
    [anon_sym_GT_GT] = ACTIONS(4250),
    [anon_sym_GT_GT_GT] = ACTIONS(4262),
    [anon_sym_LT_LT] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_CARET] = ACTIONS(4260),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_PLUS] = ACTIONS(4268),
    [anon_sym_DASH] = ACTIONS(4268),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [anon_sym_STAR_STAR] = ACTIONS(4270),
    [anon_sym_LT_EQ] = ACTIONS(4272),
    [anon_sym_EQ_EQ] = ACTIONS(4252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4272),
    [anon_sym_BANG_EQ] = ACTIONS(4252),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4272),
    [anon_sym_GT_EQ] = ACTIONS(4272),
    [anon_sym_instanceof] = ACTIONS(4272),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_PLUS_PLUS] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [1688] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2719),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1689] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2719),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
  },
  [1690] = {
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_as] = ACTIONS(4182),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_in] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_LT] = ACTIONS(4180),
    [anon_sym_GT] = ACTIONS(4180),
    [anon_sym_SLASH] = ACTIONS(4180),
    [anon_sym_DOT] = ACTIONS(4182),
    [anon_sym_QMARK] = ACTIONS(4182),
    [anon_sym_AMP_AMP] = ACTIONS(4182),
    [anon_sym_PIPE_PIPE] = ACTIONS(4182),
    [anon_sym_GT_GT] = ACTIONS(4180),
    [anon_sym_GT_GT_GT] = ACTIONS(4182),
    [anon_sym_LT_LT] = ACTIONS(4182),
    [anon_sym_AMP] = ACTIONS(4180),
    [anon_sym_CARET] = ACTIONS(4182),
    [anon_sym_PIPE] = ACTIONS(4180),
    [anon_sym_PLUS] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [anon_sym_PERCENT] = ACTIONS(4182),
    [anon_sym_STAR_STAR] = ACTIONS(4182),
    [anon_sym_LT_EQ] = ACTIONS(4182),
    [anon_sym_EQ_EQ] = ACTIONS(4180),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4182),
    [anon_sym_BANG_EQ] = ACTIONS(4180),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4182),
    [anon_sym_GT_EQ] = ACTIONS(4182),
    [anon_sym_instanceof] = ACTIONS(4182),
    [anon_sym_BANG] = ACTIONS(4180),
    [anon_sym_PLUS_PLUS] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4182),
  },
  [1691] = {
    [anon_sym_STAR] = ACTIONS(4165),
    [anon_sym_as] = ACTIONS(4167),
    [anon_sym_LBRACE] = ACTIONS(4165),
    [anon_sym_COMMA] = ACTIONS(4167),
    [anon_sym_LPAREN] = ACTIONS(4167),
    [anon_sym_in] = ACTIONS(4165),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_LT] = ACTIONS(4165),
    [anon_sym_GT] = ACTIONS(4165),
    [anon_sym_SLASH] = ACTIONS(4165),
    [anon_sym_DOT] = ACTIONS(4167),
    [anon_sym_QMARK] = ACTIONS(4167),
    [anon_sym_AMP_AMP] = ACTIONS(4167),
    [anon_sym_PIPE_PIPE] = ACTIONS(4167),
    [anon_sym_GT_GT] = ACTIONS(4165),
    [anon_sym_GT_GT_GT] = ACTIONS(4167),
    [anon_sym_LT_LT] = ACTIONS(4167),
    [anon_sym_AMP] = ACTIONS(4165),
    [anon_sym_CARET] = ACTIONS(4167),
    [anon_sym_PIPE] = ACTIONS(4165),
    [anon_sym_PLUS] = ACTIONS(4165),
    [anon_sym_DASH] = ACTIONS(4165),
    [anon_sym_PERCENT] = ACTIONS(4167),
    [anon_sym_STAR_STAR] = ACTIONS(4167),
    [anon_sym_LT_EQ] = ACTIONS(4167),
    [anon_sym_EQ_EQ] = ACTIONS(4165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4167),
    [anon_sym_BANG_EQ] = ACTIONS(4165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4167),
    [anon_sym_GT_EQ] = ACTIONS(4167),
    [anon_sym_instanceof] = ACTIONS(4167),
    [anon_sym_BANG] = ACTIONS(4165),
    [anon_sym_PLUS_PLUS] = ACTIONS(4167),
    [anon_sym_DASH_DASH] = ACTIONS(4167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4167),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4167),
  },
  [1692] = {
    [anon_sym_STAR] = ACTIONS(4173),
    [anon_sym_as] = ACTIONS(4175),
    [anon_sym_LBRACE] = ACTIONS(4173),
    [anon_sym_COMMA] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(4175),
    [anon_sym_in] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(4175),
    [anon_sym_LT] = ACTIONS(4173),
    [anon_sym_GT] = ACTIONS(4173),
    [anon_sym_SLASH] = ACTIONS(4173),
    [anon_sym_DOT] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(4175),
    [anon_sym_AMP_AMP] = ACTIONS(4175),
    [anon_sym_PIPE_PIPE] = ACTIONS(4175),
    [anon_sym_GT_GT] = ACTIONS(4173),
    [anon_sym_GT_GT_GT] = ACTIONS(4175),
    [anon_sym_LT_LT] = ACTIONS(4175),
    [anon_sym_AMP] = ACTIONS(4173),
    [anon_sym_CARET] = ACTIONS(4175),
    [anon_sym_PIPE] = ACTIONS(4173),
    [anon_sym_PLUS] = ACTIONS(4173),
    [anon_sym_DASH] = ACTIONS(4173),
    [anon_sym_PERCENT] = ACTIONS(4175),
    [anon_sym_STAR_STAR] = ACTIONS(4175),
    [anon_sym_LT_EQ] = ACTIONS(4175),
    [anon_sym_EQ_EQ] = ACTIONS(4173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4175),
    [anon_sym_BANG_EQ] = ACTIONS(4173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4175),
    [anon_sym_GT_EQ] = ACTIONS(4175),
    [anon_sym_instanceof] = ACTIONS(4175),
    [anon_sym_BANG] = ACTIONS(4173),
    [anon_sym_PLUS_PLUS] = ACTIONS(4175),
    [anon_sym_DASH_DASH] = ACTIONS(4175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4175),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4175),
  },
  [1693] = {
    [anon_sym_STAR] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1129),
    [anon_sym_in] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1129),
    [anon_sym_QMARK] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1127),
    [anon_sym_GT_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1127),
    [anon_sym_CARET] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_PERCENT] = ACTIONS(1129),
    [anon_sym_STAR_STAR] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ] = ACTIONS(1127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ] = ACTIONS(1127),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1129),
    [anon_sym_GT_EQ] = ACTIONS(1129),
    [anon_sym_instanceof] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1129),
    [anon_sym_DASH_DASH] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1129),
  },
  [1694] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2719),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1695] = {
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_as] = ACTIONS(4151),
    [anon_sym_LBRACE] = ACTIONS(4149),
    [anon_sym_COMMA] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(4151),
    [anon_sym_in] = ACTIONS(4149),
    [anon_sym_LBRACK] = ACTIONS(4151),
    [anon_sym_LT] = ACTIONS(4149),
    [anon_sym_GT] = ACTIONS(4149),
    [anon_sym_SLASH] = ACTIONS(4149),
    [anon_sym_DOT] = ACTIONS(4151),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_AMP_AMP] = ACTIONS(4151),
    [anon_sym_PIPE_PIPE] = ACTIONS(4151),
    [anon_sym_GT_GT] = ACTIONS(4149),
    [anon_sym_GT_GT_GT] = ACTIONS(4151),
    [anon_sym_LT_LT] = ACTIONS(4151),
    [anon_sym_AMP] = ACTIONS(4149),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_PIPE] = ACTIONS(4149),
    [anon_sym_PLUS] = ACTIONS(4149),
    [anon_sym_DASH] = ACTIONS(4149),
    [anon_sym_PERCENT] = ACTIONS(4151),
    [anon_sym_STAR_STAR] = ACTIONS(4151),
    [anon_sym_LT_EQ] = ACTIONS(4151),
    [anon_sym_EQ_EQ] = ACTIONS(4149),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4151),
    [anon_sym_BANG_EQ] = ACTIONS(4149),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4151),
    [anon_sym_GT_EQ] = ACTIONS(4151),
    [anon_sym_instanceof] = ACTIONS(4151),
    [anon_sym_BANG] = ACTIONS(4149),
    [anon_sym_PLUS_PLUS] = ACTIONS(4151),
    [anon_sym_DASH_DASH] = ACTIONS(4151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4151),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4151),
  },
  [1696] = {
    [anon_sym_STAR] = ACTIONS(1265),
    [anon_sym_as] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1267),
    [anon_sym_in] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1267),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_GT] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1267),
    [anon_sym_QMARK] = ACTIONS(1267),
    [anon_sym_AMP_AMP] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_GT_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1265),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_STAR_STAR] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1267),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1267),
    [anon_sym_GT_EQ] = ACTIONS(1267),
    [anon_sym_instanceof] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_PLUS_PLUS] = ACTIONS(1267),
    [anon_sym_DASH_DASH] = ACTIONS(1267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1267),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1267),
  },
  [1697] = {
    [anon_sym_STAR] = ACTIONS(3400),
    [anon_sym_as] = ACTIONS(3402),
    [anon_sym_LBRACE] = ACTIONS(3400),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3402),
    [anon_sym_QMARK] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_GT_GT] = ACTIONS(3400),
    [anon_sym_GT_GT_GT] = ACTIONS(3402),
    [anon_sym_LT_LT] = ACTIONS(3402),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3402),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3402),
    [anon_sym_STAR_STAR] = ACTIONS(3402),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_EQ_EQ] = ACTIONS(3400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_instanceof] = ACTIONS(3402),
    [anon_sym_BANG] = ACTIONS(3400),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3402),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3402),
  },
  [1698] = {
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1699] = {
    [anon_sym_STAR] = ACTIONS(4161),
    [anon_sym_as] = ACTIONS(4163),
    [anon_sym_LBRACE] = ACTIONS(4161),
    [anon_sym_COMMA] = ACTIONS(4163),
    [anon_sym_LPAREN] = ACTIONS(4163),
    [anon_sym_in] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_SLASH] = ACTIONS(4161),
    [anon_sym_DOT] = ACTIONS(4163),
    [anon_sym_QMARK] = ACTIONS(4163),
    [anon_sym_AMP_AMP] = ACTIONS(4163),
    [anon_sym_PIPE_PIPE] = ACTIONS(4163),
    [anon_sym_GT_GT] = ACTIONS(4161),
    [anon_sym_GT_GT_GT] = ACTIONS(4163),
    [anon_sym_LT_LT] = ACTIONS(4163),
    [anon_sym_AMP] = ACTIONS(4161),
    [anon_sym_CARET] = ACTIONS(4163),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4161),
    [anon_sym_PERCENT] = ACTIONS(4163),
    [anon_sym_STAR_STAR] = ACTIONS(4163),
    [anon_sym_LT_EQ] = ACTIONS(4163),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4163),
    [anon_sym_BANG_EQ] = ACTIONS(4161),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4163),
    [anon_sym_GT_EQ] = ACTIONS(4163),
    [anon_sym_instanceof] = ACTIONS(4163),
    [anon_sym_BANG] = ACTIONS(4161),
    [anon_sym_PLUS_PLUS] = ACTIONS(4163),
    [anon_sym_DASH_DASH] = ACTIONS(4163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4163),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4163),
  },
  [1700] = {
    [sym_string] = STATE(2149),
    [sym__property_name] = STATE(2149),
    [sym_computed_property_name] = STATE(2149),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4813),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1701] = {
    [sym_string] = STATE(1995),
    [sym__property_name] = STATE(1995),
    [sym_computed_property_name] = STATE(1995),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(3582),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4815),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(3582),
    [anon_sym_set] = ACTIONS(3582),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1702] = {
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_as] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_in] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_DOT] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_GT_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1255),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_instanceof] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1257),
  },
  [1703] = {
    [anon_sym_STAR] = ACTIONS(4145),
    [anon_sym_as] = ACTIONS(4147),
    [anon_sym_LBRACE] = ACTIONS(4145),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(4147),
    [anon_sym_in] = ACTIONS(4145),
    [anon_sym_LBRACK] = ACTIONS(4147),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_GT] = ACTIONS(4145),
    [anon_sym_SLASH] = ACTIONS(4145),
    [anon_sym_DOT] = ACTIONS(4147),
    [anon_sym_QMARK] = ACTIONS(4147),
    [anon_sym_AMP_AMP] = ACTIONS(4147),
    [anon_sym_PIPE_PIPE] = ACTIONS(4147),
    [anon_sym_GT_GT] = ACTIONS(4145),
    [anon_sym_GT_GT_GT] = ACTIONS(4147),
    [anon_sym_LT_LT] = ACTIONS(4147),
    [anon_sym_AMP] = ACTIONS(4145),
    [anon_sym_CARET] = ACTIONS(4147),
    [anon_sym_PIPE] = ACTIONS(4145),
    [anon_sym_PLUS] = ACTIONS(4145),
    [anon_sym_DASH] = ACTIONS(4145),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_STAR_STAR] = ACTIONS(4147),
    [anon_sym_LT_EQ] = ACTIONS(4147),
    [anon_sym_EQ_EQ] = ACTIONS(4145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4147),
    [anon_sym_BANG_EQ] = ACTIONS(4145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4147),
    [anon_sym_GT_EQ] = ACTIONS(4147),
    [anon_sym_instanceof] = ACTIONS(4147),
    [anon_sym_BANG] = ACTIONS(4145),
    [anon_sym_PLUS_PLUS] = ACTIONS(4147),
    [anon_sym_DASH_DASH] = ACTIONS(4147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4147),
  },
  [1704] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_RPAREN] = ACTIONS(4063),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_COLON] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1705] = {
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_as] = ACTIONS(3878),
    [anon_sym_LBRACE] = ACTIONS(3876),
    [anon_sym_COMMA] = ACTIONS(3878),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_LT] = ACTIONS(3876),
    [anon_sym_GT] = ACTIONS(3876),
    [anon_sym_SLASH] = ACTIONS(3876),
    [anon_sym_DOT] = ACTIONS(3878),
    [anon_sym_QMARK] = ACTIONS(3878),
    [anon_sym_AMP_AMP] = ACTIONS(3878),
    [anon_sym_PIPE_PIPE] = ACTIONS(3878),
    [anon_sym_GT_GT] = ACTIONS(3876),
    [anon_sym_GT_GT_GT] = ACTIONS(3878),
    [anon_sym_LT_LT] = ACTIONS(3878),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_CARET] = ACTIONS(3878),
    [anon_sym_PIPE] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_PERCENT] = ACTIONS(3878),
    [anon_sym_STAR_STAR] = ACTIONS(3878),
    [anon_sym_LT_EQ] = ACTIONS(3878),
    [anon_sym_EQ_EQ] = ACTIONS(3876),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3878),
    [anon_sym_BANG_EQ] = ACTIONS(3876),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3878),
    [anon_sym_GT_EQ] = ACTIONS(3878),
    [anon_sym_instanceof] = ACTIONS(3878),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3878),
  },
  [1706] = {
    [anon_sym_STAR] = ACTIONS(1245),
    [anon_sym_as] = ACTIONS(1247),
    [anon_sym_LBRACE] = ACTIONS(1245),
    [anon_sym_COMMA] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1247),
    [anon_sym_in] = ACTIONS(1245),
    [anon_sym_LBRACK] = ACTIONS(1247),
    [anon_sym_LT] = ACTIONS(1245),
    [anon_sym_GT] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1245),
    [anon_sym_DOT] = ACTIONS(1247),
    [anon_sym_QMARK] = ACTIONS(1247),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_GT_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_CARET] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1245),
    [anon_sym_DASH] = ACTIONS(1245),
    [anon_sym_PERCENT] = ACTIONS(1247),
    [anon_sym_STAR_STAR] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1247),
    [anon_sym_EQ_EQ] = ACTIONS(1245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1247),
    [anon_sym_BANG_EQ] = ACTIONS(1245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1247),
    [anon_sym_GT_EQ] = ACTIONS(1247),
    [anon_sym_instanceof] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1245),
    [anon_sym_PLUS_PLUS] = ACTIONS(1247),
    [anon_sym_DASH_DASH] = ACTIONS(1247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1247),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1247),
  },
  [1707] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4817),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1708] = {
    [anon_sym_STAR] = ACTIONS(1157),
    [anon_sym_as] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_in] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_LT] = ACTIONS(1157),
    [anon_sym_GT] = ACTIONS(1157),
    [anon_sym_SLASH] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1159),
    [anon_sym_QMARK] = ACTIONS(1159),
    [anon_sym_AMP_AMP] = ACTIONS(1159),
    [anon_sym_PIPE_PIPE] = ACTIONS(1159),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_GT_GT_GT] = ACTIONS(1159),
    [anon_sym_LT_LT] = ACTIONS(1159),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_CARET] = ACTIONS(1159),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_PLUS] = ACTIONS(1157),
    [anon_sym_DASH] = ACTIONS(1157),
    [anon_sym_PERCENT] = ACTIONS(1159),
    [anon_sym_STAR_STAR] = ACTIONS(1159),
    [anon_sym_LT_EQ] = ACTIONS(1159),
    [anon_sym_EQ_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1159),
    [anon_sym_BANG_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1159),
    [anon_sym_GT_EQ] = ACTIONS(1159),
    [anon_sym_instanceof] = ACTIONS(1159),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_PLUS_PLUS] = ACTIONS(1159),
    [anon_sym_DASH_DASH] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1159),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1159),
  },
  [1709] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(4819),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
    [sym__automatic_semicolon] = ACTIONS(1223),
  },
  [1710] = {
    [sym_string] = STATE(2124),
    [sym__property_name] = STATE(2124),
    [sym_computed_property_name] = STATE(2124),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4630),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1711] = {
    [anon_sym_STAR] = ACTIONS(4107),
    [anon_sym_as] = ACTIONS(4109),
    [anon_sym_LBRACE] = ACTIONS(4107),
    [anon_sym_COMMA] = ACTIONS(4109),
    [anon_sym_LPAREN] = ACTIONS(4109),
    [anon_sym_in] = ACTIONS(4107),
    [anon_sym_LBRACK] = ACTIONS(4109),
    [anon_sym_LT] = ACTIONS(4107),
    [anon_sym_GT] = ACTIONS(4107),
    [anon_sym_SLASH] = ACTIONS(4107),
    [anon_sym_DOT] = ACTIONS(4109),
    [anon_sym_QMARK] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_GT_GT_GT] = ACTIONS(4109),
    [anon_sym_LT_LT] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4107),
    [anon_sym_CARET] = ACTIONS(4109),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4107),
    [anon_sym_DASH] = ACTIONS(4107),
    [anon_sym_PERCENT] = ACTIONS(4109),
    [anon_sym_STAR_STAR] = ACTIONS(4109),
    [anon_sym_LT_EQ] = ACTIONS(4109),
    [anon_sym_EQ_EQ] = ACTIONS(4107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4109),
    [anon_sym_BANG_EQ] = ACTIONS(4107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4109),
    [anon_sym_GT_EQ] = ACTIONS(4109),
    [anon_sym_instanceof] = ACTIONS(4109),
    [anon_sym_BANG] = ACTIONS(4107),
    [anon_sym_PLUS_PLUS] = ACTIONS(4109),
    [anon_sym_DASH_DASH] = ACTIONS(4109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4109),
  },
  [1712] = {
    [anon_sym_STAR] = ACTIONS(4103),
    [anon_sym_as] = ACTIONS(4105),
    [anon_sym_LBRACE] = ACTIONS(4103),
    [anon_sym_COMMA] = ACTIONS(4105),
    [anon_sym_LPAREN] = ACTIONS(4105),
    [anon_sym_in] = ACTIONS(4103),
    [anon_sym_LBRACK] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4103),
    [anon_sym_GT] = ACTIONS(4103),
    [anon_sym_SLASH] = ACTIONS(4103),
    [anon_sym_DOT] = ACTIONS(4105),
    [anon_sym_QMARK] = ACTIONS(4105),
    [anon_sym_AMP_AMP] = ACTIONS(4105),
    [anon_sym_PIPE_PIPE] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_GT_GT_GT] = ACTIONS(4105),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_AMP] = ACTIONS(4103),
    [anon_sym_CARET] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4103),
    [anon_sym_PLUS] = ACTIONS(4103),
    [anon_sym_DASH] = ACTIONS(4103),
    [anon_sym_PERCENT] = ACTIONS(4105),
    [anon_sym_STAR_STAR] = ACTIONS(4105),
    [anon_sym_LT_EQ] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4105),
    [anon_sym_BANG_EQ] = ACTIONS(4103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4105),
    [anon_sym_GT_EQ] = ACTIONS(4105),
    [anon_sym_instanceof] = ACTIONS(4105),
    [anon_sym_BANG] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4105),
    [anon_sym_DASH_DASH] = ACTIONS(4105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4105),
  },
  [1713] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1714] = {
    [anon_sym_STAR] = ACTIONS(4079),
    [anon_sym_as] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(4079),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_in] = ACTIONS(4079),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [anon_sym_LT] = ACTIONS(4079),
    [anon_sym_GT] = ACTIONS(4079),
    [anon_sym_SLASH] = ACTIONS(4079),
    [anon_sym_DOT] = ACTIONS(3754),
    [anon_sym_QMARK] = ACTIONS(3754),
    [anon_sym_AMP_AMP] = ACTIONS(3754),
    [anon_sym_PIPE_PIPE] = ACTIONS(3754),
    [anon_sym_GT_GT] = ACTIONS(4079),
    [anon_sym_GT_GT_GT] = ACTIONS(3754),
    [anon_sym_LT_LT] = ACTIONS(3754),
    [anon_sym_AMP] = ACTIONS(4079),
    [anon_sym_CARET] = ACTIONS(3754),
    [anon_sym_PIPE] = ACTIONS(4079),
    [anon_sym_PLUS] = ACTIONS(4079),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_PERCENT] = ACTIONS(3754),
    [anon_sym_STAR_STAR] = ACTIONS(3754),
    [anon_sym_LT_EQ] = ACTIONS(3754),
    [anon_sym_EQ_EQ] = ACTIONS(4079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3754),
    [anon_sym_BANG_EQ] = ACTIONS(4079),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3754),
    [anon_sym_GT_EQ] = ACTIONS(3754),
    [anon_sym_instanceof] = ACTIONS(3754),
    [anon_sym_BANG] = ACTIONS(4079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3754),
    [anon_sym_DASH_DASH] = ACTIONS(3754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3754),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3754),
  },
  [1715] = {
    [anon_sym_STAR] = ACTIONS(1175),
    [anon_sym_as] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_COMMA] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_in] = ACTIONS(1175),
    [anon_sym_LBRACK] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(1175),
    [anon_sym_GT] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1175),
    [anon_sym_DOT] = ACTIONS(1177),
    [anon_sym_QMARK] = ACTIONS(1177),
    [anon_sym_AMP_AMP] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(1175),
    [anon_sym_GT_GT_GT] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1175),
    [anon_sym_PLUS] = ACTIONS(1175),
    [anon_sym_DASH] = ACTIONS(1175),
    [anon_sym_PERCENT] = ACTIONS(1177),
    [anon_sym_STAR_STAR] = ACTIONS(1177),
    [anon_sym_LT_EQ] = ACTIONS(1177),
    [anon_sym_EQ_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1177),
    [anon_sym_BANG_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1177),
    [anon_sym_GT_EQ] = ACTIONS(1177),
    [anon_sym_instanceof] = ACTIONS(1177),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_PLUS_PLUS] = ACTIONS(1177),
    [anon_sym_DASH_DASH] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1177),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1177),
  },
  [1716] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
  },
  [1717] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1718] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2942),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2942),
    [sym_optional_parameter] = STATE(2942),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1749),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(4825),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1719] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1720] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3733),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(4566),
    [anon_sym_of] = ACTIONS(4569),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1721] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(4561),
    [anon_sym_of] = ACTIONS(4564),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1722] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2643),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2643),
    [sym_optional_parameter] = STATE(2643),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_class] = ACTIONS(4829),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1723] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(3973),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(3973),
    [anon_sym_RBRACK] = ACTIONS(3973),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(3976),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(3976),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1724] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1725] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2942),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2942),
    [sym_optional_parameter] = STATE(2942),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1749),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(4831),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1726] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2719),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1727] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1728] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2942),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2942),
    [sym_optional_parameter] = STATE(2942),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1749),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(4833),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1729] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3733),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3888),
    [anon_sym_of] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1730] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1731] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(3711),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(3853),
    [anon_sym_of] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(1223),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1732] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2942),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2942),
    [sym_optional_parameter] = STATE(2942),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1749),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(4835),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1733] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1734] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2632),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2632),
    [sym_optional_parameter] = STATE(2632),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1750),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1735] = {
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_in] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_RBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_QMARK] = ACTIONS(1223),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_GT_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(4066),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1223),
    [anon_sym_GT_EQ] = ACTIONS(1223),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1223),
    [anon_sym_DASH_DASH] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1223),
  },
  [1736] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2942),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2942),
    [sym_optional_parameter] = STATE(2942),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1749),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1737] = {
    [sym_arguments] = STATE(1766),
    [sym_identifier] = ACTIONS(4839),
    [anon_sym_export] = ACTIONS(4839),
    [anon_sym_STAR] = ACTIONS(4841),
    [anon_sym_namespace] = ACTIONS(4839),
    [anon_sym_LBRACE] = ACTIONS(4841),
    [anon_sym_RBRACE] = ACTIONS(4841),
    [anon_sym_type] = ACTIONS(4839),
    [anon_sym_LPAREN] = ACTIONS(4843),
    [anon_sym_LBRACK] = ACTIONS(4841),
    [anon_sym_DOT] = ACTIONS(4845),
    [anon_sym_class] = ACTIONS(4839),
    [anon_sym_async] = ACTIONS(4839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4841),
    [anon_sym_void] = ACTIONS(4839),
    [anon_sym_DQUOTE] = ACTIONS(4841),
    [anon_sym_SQUOTE] = ACTIONS(4841),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4841),
    [sym_this] = ACTIONS(4839),
    [anon_sym_AT] = ACTIONS(4841),
    [anon_sym_static] = ACTIONS(4839),
    [anon_sym_abstract] = ACTIONS(4839),
    [anon_sym_get] = ACTIONS(4839),
    [anon_sym_set] = ACTIONS(4839),
    [anon_sym_declare] = ACTIONS(4839),
    [anon_sym_public] = ACTIONS(4839),
    [anon_sym_private] = ACTIONS(4839),
    [anon_sym_protected] = ACTIONS(4839),
    [anon_sym_module] = ACTIONS(4839),
    [anon_sym_any] = ACTIONS(4839),
    [anon_sym_number] = ACTIONS(4839),
    [anon_sym_boolean] = ACTIONS(4839),
    [anon_sym_string] = ACTIONS(4839),
    [anon_sym_symbol] = ACTIONS(4839),
    [sym_readonly] = ACTIONS(4839),
  },
  [1738] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(4847),
    [anon_sym_RBRACE] = ACTIONS(4847),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1739] = {
    [sym_arguments] = STATE(1769),
    [sym_identifier] = ACTIONS(4849),
    [anon_sym_export] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4851),
    [anon_sym_namespace] = ACTIONS(4849),
    [anon_sym_LBRACE] = ACTIONS(4851),
    [anon_sym_RBRACE] = ACTIONS(4851),
    [anon_sym_type] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(4843),
    [anon_sym_LBRACK] = ACTIONS(4851),
    [anon_sym_DOT] = ACTIONS(4853),
    [anon_sym_class] = ACTIONS(4849),
    [anon_sym_async] = ACTIONS(4849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4851),
    [anon_sym_void] = ACTIONS(4849),
    [anon_sym_DQUOTE] = ACTIONS(4851),
    [anon_sym_SQUOTE] = ACTIONS(4851),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4851),
    [sym_this] = ACTIONS(4849),
    [anon_sym_AT] = ACTIONS(4851),
    [anon_sym_static] = ACTIONS(4849),
    [anon_sym_abstract] = ACTIONS(4849),
    [anon_sym_get] = ACTIONS(4849),
    [anon_sym_set] = ACTIONS(4849),
    [anon_sym_declare] = ACTIONS(4849),
    [anon_sym_public] = ACTIONS(4849),
    [anon_sym_private] = ACTIONS(4849),
    [anon_sym_protected] = ACTIONS(4849),
    [anon_sym_module] = ACTIONS(4849),
    [anon_sym_any] = ACTIONS(4849),
    [anon_sym_number] = ACTIONS(4849),
    [anon_sym_boolean] = ACTIONS(4849),
    [anon_sym_string] = ACTIONS(4849),
    [anon_sym_symbol] = ACTIONS(4849),
    [sym_readonly] = ACTIONS(4849),
  },
  [1740] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1741] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(4847),
    [anon_sym_RBRACE] = ACTIONS(4847),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
  },
  [1742] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2942),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2942),
    [sym_optional_parameter] = STATE(2942),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1749),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(4855),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1743] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(4847),
    [anon_sym_RBRACE] = ACTIONS(4847),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1744] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2707),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2707),
    [sym_optional_parameter] = STATE(2707),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1748),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(4857),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1745] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(4847),
    [anon_sym_RBRACE] = ACTIONS(4847),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1746] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2942),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2942),
    [sym_optional_parameter] = STATE(2942),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1749),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1747] = {
    [sym_identifier] = ACTIONS(4859),
    [anon_sym_export] = ACTIONS(4859),
    [anon_sym_STAR] = ACTIONS(4861),
    [anon_sym_namespace] = ACTIONS(4859),
    [anon_sym_LBRACE] = ACTIONS(4861),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_type] = ACTIONS(4859),
    [anon_sym_LPAREN] = ACTIONS(4861),
    [anon_sym_LBRACK] = ACTIONS(4861),
    [anon_sym_DOT] = ACTIONS(4859),
    [anon_sym_class] = ACTIONS(4859),
    [anon_sym_async] = ACTIONS(4859),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4861),
    [anon_sym_void] = ACTIONS(4859),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_SQUOTE] = ACTIONS(4861),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4861),
    [sym_this] = ACTIONS(4859),
    [anon_sym_AT] = ACTIONS(4861),
    [anon_sym_static] = ACTIONS(4859),
    [anon_sym_abstract] = ACTIONS(4859),
    [anon_sym_get] = ACTIONS(4859),
    [anon_sym_set] = ACTIONS(4859),
    [anon_sym_declare] = ACTIONS(4859),
    [anon_sym_public] = ACTIONS(4859),
    [anon_sym_private] = ACTIONS(4859),
    [anon_sym_protected] = ACTIONS(4859),
    [anon_sym_module] = ACTIONS(4859),
    [anon_sym_any] = ACTIONS(4859),
    [anon_sym_number] = ACTIONS(4859),
    [anon_sym_boolean] = ACTIONS(4859),
    [anon_sym_string] = ACTIONS(4859),
    [anon_sym_symbol] = ACTIONS(4859),
    [sym_readonly] = ACTIONS(4859),
  },
  [1748] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2723),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2723),
    [sym_optional_parameter] = STATE(2723),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1749] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2907),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2907),
    [sym_optional_parameter] = STATE(2907),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1750] = {
    [sym_object] = STATE(2381),
    [sym_array] = STATE(2369),
    [sym_decorator] = STATE(1854),
    [sym_rest_parameter] = STATE(2643),
    [sym_accessibility_modifier] = STATE(1855),
    [sym_required_parameter] = STATE(2643),
    [sym_optional_parameter] = STATE(2643),
    [sym__parameter_name] = STATE(2076),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [sym_identifier] = ACTIONS(4823),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(819),
    [anon_sym_void] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2597),
    [anon_sym_private] = ACTIONS(2597),
    [anon_sym_protected] = ACTIONS(2597),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [sym_readonly] = ACTIONS(2599),
  },
  [1751] = {
    [sym_identifier] = ACTIONS(4863),
    [anon_sym_export] = ACTIONS(4863),
    [anon_sym_STAR] = ACTIONS(4865),
    [anon_sym_namespace] = ACTIONS(4863),
    [anon_sym_LBRACE] = ACTIONS(4865),
    [anon_sym_RBRACE] = ACTIONS(4865),
    [anon_sym_type] = ACTIONS(4863),
    [anon_sym_LPAREN] = ACTIONS(4865),
    [anon_sym_LBRACK] = ACTIONS(4865),
    [anon_sym_DOT] = ACTIONS(4863),
    [anon_sym_class] = ACTIONS(4863),
    [anon_sym_async] = ACTIONS(4863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4865),
    [anon_sym_void] = ACTIONS(4863),
    [anon_sym_DQUOTE] = ACTIONS(4865),
    [anon_sym_SQUOTE] = ACTIONS(4865),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4865),
    [sym_this] = ACTIONS(4863),
    [anon_sym_AT] = ACTIONS(4865),
    [anon_sym_static] = ACTIONS(4863),
    [anon_sym_abstract] = ACTIONS(4863),
    [anon_sym_get] = ACTIONS(4863),
    [anon_sym_set] = ACTIONS(4863),
    [anon_sym_declare] = ACTIONS(4863),
    [anon_sym_public] = ACTIONS(4863),
    [anon_sym_private] = ACTIONS(4863),
    [anon_sym_protected] = ACTIONS(4863),
    [anon_sym_module] = ACTIONS(4863),
    [anon_sym_any] = ACTIONS(4863),
    [anon_sym_number] = ACTIONS(4863),
    [anon_sym_boolean] = ACTIONS(4863),
    [anon_sym_string] = ACTIONS(4863),
    [anon_sym_symbol] = ACTIONS(4863),
    [sym_readonly] = ACTIONS(4863),
  },
  [1752] = {
    [sym__declaration] = STATE(2384),
    [sym_variable_declaration] = STATE(2384),
    [sym_lexical_declaration] = STATE(2384),
    [sym_class_declaration] = STATE(2384),
    [sym_function_declaration] = STATE(2384),
    [sym_generator_function_declaration] = STATE(2384),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(2384),
    [sym_ambient_declaration] = STATE(2384),
    [sym_abstract_class_declaration] = STATE(2384),
    [sym_module] = STATE(2384),
    [sym_internal_module] = STATE(2384),
    [sym_import_alias] = STATE(2384),
    [sym_interface_declaration] = STATE(2384),
    [sym_enum_declaration] = STATE(2384),
    [sym_type_alias_declaration] = STATE(2384),
    [aux_sym_export_statement_repeat1] = STATE(2526),
    [anon_sym_namespace] = ACTIONS(3614),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3620),
    [anon_sym_var] = ACTIONS(3622),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_const] = ACTIONS(3626),
    [anon_sym_class] = ACTIONS(3628),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_function] = ACTIONS(3632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3634),
    [anon_sym_declare] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(4867),
    [anon_sym_global] = ACTIONS(4869),
    [anon_sym_interface] = ACTIONS(3640),
    [anon_sym_enum] = ACTIONS(3642),
  },
  [1753] = {
    [sym__declaration] = STATE(585),
    [sym_variable_declaration] = STATE(585),
    [sym_lexical_declaration] = STATE(585),
    [sym_class_declaration] = STATE(585),
    [sym_function_declaration] = STATE(585),
    [sym_generator_function_declaration] = STATE(585),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(585),
    [sym_ambient_declaration] = STATE(585),
    [sym_abstract_class_declaration] = STATE(585),
    [sym_module] = STATE(585),
    [sym_internal_module] = STATE(585),
    [sym_import_alias] = STATE(585),
    [sym_interface_declaration] = STATE(585),
    [sym_enum_declaration] = STATE(585),
    [sym_type_alias_declaration] = STATE(585),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_default] = ACTIONS(4871),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
  },
  [1754] = {
    [sym__declaration] = STATE(2370),
    [sym_variable_declaration] = STATE(2370),
    [sym_lexical_declaration] = STATE(2370),
    [sym_class_declaration] = STATE(2370),
    [sym_function_declaration] = STATE(2370),
    [sym_generator_function_declaration] = STATE(2370),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(2370),
    [sym_ambient_declaration] = STATE(2370),
    [sym_abstract_class_declaration] = STATE(2370),
    [sym_module] = STATE(2370),
    [sym_internal_module] = STATE(2370),
    [sym_import_alias] = STATE(2370),
    [sym_interface_declaration] = STATE(2370),
    [sym_enum_declaration] = STATE(2370),
    [sym_type_alias_declaration] = STATE(2370),
    [aux_sym_export_statement_repeat1] = STATE(2526),
    [anon_sym_default] = ACTIONS(4873),
    [anon_sym_namespace] = ACTIONS(3614),
    [anon_sym_type] = ACTIONS(3618),
    [anon_sym_import] = ACTIONS(3620),
    [anon_sym_var] = ACTIONS(3622),
    [anon_sym_let] = ACTIONS(3624),
    [anon_sym_const] = ACTIONS(3626),
    [anon_sym_class] = ACTIONS(3628),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_function] = ACTIONS(3632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3634),
    [anon_sym_declare] = ACTIONS(3636),
    [anon_sym_module] = ACTIONS(3638),
    [anon_sym_interface] = ACTIONS(3640),
    [anon_sym_enum] = ACTIONS(3642),
  },
  [1755] = {
    [sym__declaration] = STATE(585),
    [sym_variable_declaration] = STATE(585),
    [sym_lexical_declaration] = STATE(585),
    [sym_class_declaration] = STATE(585),
    [sym_function_declaration] = STATE(585),
    [sym_generator_function_declaration] = STATE(585),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(585),
    [sym_ambient_declaration] = STATE(585),
    [sym_abstract_class_declaration] = STATE(585),
    [sym_module] = STATE(585),
    [sym_internal_module] = STATE(585),
    [sym_import_alias] = STATE(585),
    [sym_interface_declaration] = STATE(585),
    [sym_enum_declaration] = STATE(585),
    [sym_type_alias_declaration] = STATE(585),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_default] = ACTIONS(4871),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2386),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
  },
  [1756] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(1634),
    [anon_sym_module] = ACTIONS(2376),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
  },
  [1757] = {
    [aux_sym_object_repeat1] = STATE(2602),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [1758] = {
    [aux_sym_object_repeat1] = STATE(2671),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [1759] = {
    [aux_sym_object_repeat1] = STATE(2718),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [1760] = {
    [aux_sym_object_repeat1] = STATE(2645),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [1761] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2384),
    [anon_sym_module] = ACTIONS(2392),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
  },
  [1762] = {
    [aux_sym_object_repeat1] = STATE(2719),
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [1763] = {
    [sym__declaration] = STATE(535),
    [sym_variable_declaration] = STATE(535),
    [sym_lexical_declaration] = STATE(535),
    [sym_class_declaration] = STATE(535),
    [sym_function_declaration] = STATE(535),
    [sym_generator_function_declaration] = STATE(535),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(535),
    [sym_ambient_declaration] = STATE(535),
    [sym_abstract_class_declaration] = STATE(535),
    [sym_module] = STATE(535),
    [sym_internal_module] = STATE(535),
    [sym_import_alias] = STATE(535),
    [sym_interface_declaration] = STATE(535),
    [sym_enum_declaration] = STATE(535),
    [sym_type_alias_declaration] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
  },
  [1764] = {
    [sym__declaration] = STATE(585),
    [sym_variable_declaration] = STATE(585),
    [sym_lexical_declaration] = STATE(585),
    [sym_class_declaration] = STATE(585),
    [sym_function_declaration] = STATE(585),
    [sym_generator_function_declaration] = STATE(585),
    [sym_decorator] = STATE(1854),
    [sym_function_signature] = STATE(585),
    [sym_ambient_declaration] = STATE(585),
    [sym_abstract_class_declaration] = STATE(585),
    [sym_module] = STATE(585),
    [sym_internal_module] = STATE(585),
    [sym_import_alias] = STATE(585),
    [sym_interface_declaration] = STATE(585),
    [sym_enum_declaration] = STATE(585),
    [sym_type_alias_declaration] = STATE(585),
    [aux_sym_export_statement_repeat1] = STATE(2528),
    [anon_sym_default] = ACTIONS(4871),
    [anon_sym_namespace] = ACTIONS(1607),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1617),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_class] = ACTIONS(1626),
    [anon_sym_async] = ACTIONS(1628),
    [anon_sym_function] = ACTIONS(1630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_declare] = ACTIONS(2388),
    [anon_sym_module] = ACTIONS(1636),
    [anon_sym_interface] = ACTIONS(1638),
    [anon_sym_enum] = ACTIONS(1640),
  },
  [1765] = {
    [sym_identifier] = ACTIONS(4849),
    [anon_sym_export] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4851),
    [anon_sym_namespace] = ACTIONS(4849),
    [anon_sym_LBRACE] = ACTIONS(4851),
    [anon_sym_RBRACE] = ACTIONS(4851),
    [anon_sym_type] = ACTIONS(4849),
    [anon_sym_LBRACK] = ACTIONS(4851),
    [anon_sym_class] = ACTIONS(4849),
    [anon_sym_async] = ACTIONS(4849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4851),
    [anon_sym_void] = ACTIONS(4849),
    [anon_sym_DQUOTE] = ACTIONS(4851),
    [anon_sym_SQUOTE] = ACTIONS(4851),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4851),
    [sym_this] = ACTIONS(4849),
    [anon_sym_AT] = ACTIONS(4851),
    [anon_sym_static] = ACTIONS(4849),
    [anon_sym_abstract] = ACTIONS(4849),
    [anon_sym_get] = ACTIONS(4849),
    [anon_sym_set] = ACTIONS(4849),
    [anon_sym_declare] = ACTIONS(4849),
    [anon_sym_public] = ACTIONS(4849),
    [anon_sym_private] = ACTIONS(4849),
    [anon_sym_protected] = ACTIONS(4849),
    [anon_sym_module] = ACTIONS(4849),
    [anon_sym_any] = ACTIONS(4849),
    [anon_sym_number] = ACTIONS(4849),
    [anon_sym_boolean] = ACTIONS(4849),
    [anon_sym_string] = ACTIONS(4849),
    [anon_sym_symbol] = ACTIONS(4849),
    [sym_readonly] = ACTIONS(4849),
  },
  [1766] = {
    [sym_identifier] = ACTIONS(4875),
    [anon_sym_export] = ACTIONS(4875),
    [anon_sym_STAR] = ACTIONS(4877),
    [anon_sym_namespace] = ACTIONS(4875),
    [anon_sym_LBRACE] = ACTIONS(4877),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [anon_sym_type] = ACTIONS(4875),
    [anon_sym_LBRACK] = ACTIONS(4877),
    [anon_sym_class] = ACTIONS(4875),
    [anon_sym_async] = ACTIONS(4875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4877),
    [anon_sym_void] = ACTIONS(4875),
    [anon_sym_DQUOTE] = ACTIONS(4877),
    [anon_sym_SQUOTE] = ACTIONS(4877),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4877),
    [sym_this] = ACTIONS(4875),
    [anon_sym_AT] = ACTIONS(4877),
    [anon_sym_static] = ACTIONS(4875),
    [anon_sym_abstract] = ACTIONS(4875),
    [anon_sym_get] = ACTIONS(4875),
    [anon_sym_set] = ACTIONS(4875),
    [anon_sym_declare] = ACTIONS(4875),
    [anon_sym_public] = ACTIONS(4875),
    [anon_sym_private] = ACTIONS(4875),
    [anon_sym_protected] = ACTIONS(4875),
    [anon_sym_module] = ACTIONS(4875),
    [anon_sym_any] = ACTIONS(4875),
    [anon_sym_number] = ACTIONS(4875),
    [anon_sym_boolean] = ACTIONS(4875),
    [anon_sym_string] = ACTIONS(4875),
    [anon_sym_symbol] = ACTIONS(4875),
    [sym_readonly] = ACTIONS(4875),
  },
  [1767] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(4847),
    [anon_sym_RBRACE] = ACTIONS(4847),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [1768] = {
    [sym_identifier] = ACTIONS(3400),
    [anon_sym_export] = ACTIONS(3400),
    [anon_sym_STAR] = ACTIONS(3402),
    [anon_sym_namespace] = ACTIONS(3400),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_type] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_class] = ACTIONS(3400),
    [anon_sym_async] = ACTIONS(3400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3402),
    [anon_sym_void] = ACTIONS(3400),
    [anon_sym_DQUOTE] = ACTIONS(3402),
    [anon_sym_SQUOTE] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3402),
    [sym_this] = ACTIONS(3400),
    [anon_sym_AT] = ACTIONS(3402),
    [anon_sym_static] = ACTIONS(3400),
    [anon_sym_abstract] = ACTIONS(3400),
    [anon_sym_get] = ACTIONS(3400),
    [anon_sym_set] = ACTIONS(3400),
    [anon_sym_declare] = ACTIONS(3400),
    [anon_sym_public] = ACTIONS(3400),
    [anon_sym_private] = ACTIONS(3400),
    [anon_sym_protected] = ACTIONS(3400),
    [anon_sym_module] = ACTIONS(3400),
    [anon_sym_any] = ACTIONS(3400),
    [anon_sym_number] = ACTIONS(3400),
    [anon_sym_boolean] = ACTIONS(3400),
    [anon_sym_string] = ACTIONS(3400),
    [anon_sym_symbol] = ACTIONS(3400),
    [sym_readonly] = ACTIONS(3400),
  },
  [1769] = {
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_export] = ACTIONS(4879),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_namespace] = ACTIONS(4879),
    [anon_sym_LBRACE] = ACTIONS(4881),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_type] = ACTIONS(4879),
    [anon_sym_LBRACK] = ACTIONS(4881),
    [anon_sym_class] = ACTIONS(4879),
    [anon_sym_async] = ACTIONS(4879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4881),
    [anon_sym_void] = ACTIONS(4879),
    [anon_sym_DQUOTE] = ACTIONS(4881),
    [anon_sym_SQUOTE] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4881),
    [sym_this] = ACTIONS(4879),
    [anon_sym_AT] = ACTIONS(4881),
    [anon_sym_static] = ACTIONS(4879),
    [anon_sym_abstract] = ACTIONS(4879),
    [anon_sym_get] = ACTIONS(4879),
    [anon_sym_set] = ACTIONS(4879),
    [anon_sym_declare] = ACTIONS(4879),
    [anon_sym_public] = ACTIONS(4879),
    [anon_sym_private] = ACTIONS(4879),
    [anon_sym_protected] = ACTIONS(4879),
    [anon_sym_module] = ACTIONS(4879),
    [anon_sym_any] = ACTIONS(4879),
    [anon_sym_number] = ACTIONS(4879),
    [anon_sym_boolean] = ACTIONS(4879),
    [anon_sym_string] = ACTIONS(4879),
    [anon_sym_symbol] = ACTIONS(4879),
    [sym_readonly] = ACTIONS(4879),
  },
  [1770] = {
    [sym_identifier] = ACTIONS(4165),
    [anon_sym_export] = ACTIONS(4165),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_namespace] = ACTIONS(4165),
    [anon_sym_LBRACE] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4167),
    [anon_sym_type] = ACTIONS(4165),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_class] = ACTIONS(4165),
    [anon_sym_async] = ACTIONS(4165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4167),
    [anon_sym_void] = ACTIONS(4165),
    [anon_sym_DQUOTE] = ACTIONS(4167),
    [anon_sym_SQUOTE] = ACTIONS(4167),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4167),
    [sym_this] = ACTIONS(4165),
    [anon_sym_AT] = ACTIONS(4167),
    [anon_sym_static] = ACTIONS(4165),
    [anon_sym_abstract] = ACTIONS(4165),
    [anon_sym_get] = ACTIONS(4165),
    [anon_sym_set] = ACTIONS(4165),
    [anon_sym_declare] = ACTIONS(4165),
    [anon_sym_public] = ACTIONS(4165),
    [anon_sym_private] = ACTIONS(4165),
    [anon_sym_protected] = ACTIONS(4165),
    [anon_sym_module] = ACTIONS(4165),
    [anon_sym_any] = ACTIONS(4165),
    [anon_sym_number] = ACTIONS(4165),
    [anon_sym_boolean] = ACTIONS(4165),
    [anon_sym_string] = ACTIONS(4165),
    [anon_sym_symbol] = ACTIONS(4165),
    [sym_readonly] = ACTIONS(4165),
  },
  [1771] = {
    [sym_identifier] = ACTIONS(3876),
    [anon_sym_export] = ACTIONS(3876),
    [anon_sym_STAR] = ACTIONS(3878),
    [anon_sym_namespace] = ACTIONS(3876),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_RBRACE] = ACTIONS(3878),
    [anon_sym_type] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_class] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(3876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3878),
    [anon_sym_void] = ACTIONS(3876),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_SQUOTE] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3878),
    [sym_this] = ACTIONS(3876),
    [anon_sym_AT] = ACTIONS(3878),
    [anon_sym_static] = ACTIONS(3876),
    [anon_sym_abstract] = ACTIONS(3876),
    [anon_sym_get] = ACTIONS(3876),
    [anon_sym_set] = ACTIONS(3876),
    [anon_sym_declare] = ACTIONS(3876),
    [anon_sym_public] = ACTIONS(3876),
    [anon_sym_private] = ACTIONS(3876),
    [anon_sym_protected] = ACTIONS(3876),
    [anon_sym_module] = ACTIONS(3876),
    [anon_sym_any] = ACTIONS(3876),
    [anon_sym_number] = ACTIONS(3876),
    [anon_sym_boolean] = ACTIONS(3876),
    [anon_sym_string] = ACTIONS(3876),
    [anon_sym_symbol] = ACTIONS(3876),
    [sym_readonly] = ACTIONS(3876),
  },
  [1772] = {
    [sym_string] = STATE(2160),
    [sym__property_name] = STATE(2160),
    [sym_computed_property_name] = STATE(2160),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4883),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4885),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4887),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4889),
    [anon_sym_set] = ACTIONS(4889),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(4891),
  },
  [1773] = {
    [sym_string] = STATE(2119),
    [sym__property_name] = STATE(2119),
    [sym_computed_property_name] = STATE(2119),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4893),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4895),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4897),
    [anon_sym_set] = ACTIONS(4897),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1774] = {
    [sym_string] = STATE(2195),
    [sym__property_name] = STATE(2195),
    [sym_computed_property_name] = STATE(2195),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4899),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4901),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4903),
    [anon_sym_set] = ACTIONS(4903),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1775] = {
    [sym_string] = STATE(2160),
    [sym__property_name] = STATE(2160),
    [sym_computed_property_name] = STATE(2160),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(4905),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4887),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1776] = {
    [sym_string] = STATE(2195),
    [sym__property_name] = STATE(2195),
    [sym_computed_property_name] = STATE(2195),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4899),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4907),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4901),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4903),
    [anon_sym_set] = ACTIONS(4903),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1777] = {
    [sym_string] = STATE(2160),
    [sym__property_name] = STATE(2160),
    [sym_computed_property_name] = STATE(2160),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4883),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4887),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4889),
    [anon_sym_set] = ACTIONS(4889),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1778] = {
    [sym_string] = STATE(2160),
    [sym__property_name] = STATE(2160),
    [sym_computed_property_name] = STATE(2160),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4883),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(4885),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4887),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(4889),
    [anon_sym_set] = ACTIONS(4889),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1779] = {
    [sym_string] = STATE(2134),
    [sym__property_name] = STATE(2134),
    [sym_computed_property_name] = STATE(2134),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4656),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1780] = {
    [sym_string] = STATE(2156),
    [sym__property_name] = STATE(2156),
    [sym_computed_property_name] = STATE(2156),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4622),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1781] = {
    [sym_identifier] = ACTIONS(4909),
    [anon_sym_export] = ACTIONS(4909),
    [anon_sym_STAR] = ACTIONS(4911),
    [anon_sym_namespace] = ACTIONS(4909),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [anon_sym_type] = ACTIONS(4909),
    [anon_sym_SEMI] = ACTIONS(4913),
    [anon_sym_LBRACK] = ACTIONS(4911),
    [anon_sym_async] = ACTIONS(4909),
    [anon_sym_void] = ACTIONS(4909),
    [anon_sym_DQUOTE] = ACTIONS(4911),
    [anon_sym_SQUOTE] = ACTIONS(4911),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4911),
    [anon_sym_AT] = ACTIONS(4911),
    [anon_sym_static] = ACTIONS(4909),
    [anon_sym_abstract] = ACTIONS(4909),
    [anon_sym_get] = ACTIONS(4909),
    [anon_sym_set] = ACTIONS(4909),
    [anon_sym_declare] = ACTIONS(4909),
    [anon_sym_public] = ACTIONS(4909),
    [anon_sym_private] = ACTIONS(4909),
    [anon_sym_protected] = ACTIONS(4909),
    [anon_sym_module] = ACTIONS(4909),
    [anon_sym_any] = ACTIONS(4909),
    [anon_sym_number] = ACTIONS(4909),
    [anon_sym_boolean] = ACTIONS(4909),
    [anon_sym_string] = ACTIONS(4909),
    [anon_sym_symbol] = ACTIONS(4909),
    [sym_readonly] = ACTIONS(4909),
    [sym__automatic_semicolon] = ACTIONS(4913),
  },
  [1782] = {
    [sym_string] = STATE(2114),
    [sym__property_name] = STATE(2114),
    [sym_computed_property_name] = STATE(2114),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4737),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1783] = {
    [sym_string] = STATE(2201),
    [sym__property_name] = STATE(2201),
    [sym_computed_property_name] = STATE(2201),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1784] = {
    [sym_object] = STATE(2306),
    [sym_array] = STATE(2308),
    [sym_identifier] = ACTIONS(4915),
    [anon_sym_export] = ACTIONS(4917),
    [anon_sym_EQ] = ACTIONS(4919),
    [anon_sym_namespace] = ACTIONS(4917),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(4919),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RPAREN] = ACTIONS(4919),
    [anon_sym_COLON] = ACTIONS(4919),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(4917),
    [anon_sym_QMARK] = ACTIONS(4919),
    [anon_sym_void] = ACTIONS(4917),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4915),
    [anon_sym_static] = ACTIONS(4917),
    [anon_sym_get] = ACTIONS(4917),
    [anon_sym_set] = ACTIONS(4917),
    [anon_sym_declare] = ACTIONS(4917),
    [anon_sym_public] = ACTIONS(4917),
    [anon_sym_private] = ACTIONS(4917),
    [anon_sym_protected] = ACTIONS(4917),
    [anon_sym_module] = ACTIONS(4917),
    [anon_sym_any] = ACTIONS(4917),
    [anon_sym_number] = ACTIONS(4917),
    [anon_sym_boolean] = ACTIONS(4917),
    [anon_sym_string] = ACTIONS(4917),
    [anon_sym_symbol] = ACTIONS(4917),
    [sym_readonly] = ACTIONS(4917),
  },
  [1785] = {
    [sym_identifier] = ACTIONS(4921),
    [anon_sym_export] = ACTIONS(4921),
    [anon_sym_STAR] = ACTIONS(4923),
    [anon_sym_namespace] = ACTIONS(4921),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [anon_sym_type] = ACTIONS(4921),
    [anon_sym_SEMI] = ACTIONS(4923),
    [anon_sym_LBRACK] = ACTIONS(4923),
    [anon_sym_async] = ACTIONS(4921),
    [anon_sym_void] = ACTIONS(4921),
    [anon_sym_DQUOTE] = ACTIONS(4923),
    [anon_sym_SQUOTE] = ACTIONS(4923),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4923),
    [anon_sym_AT] = ACTIONS(4923),
    [anon_sym_static] = ACTIONS(4921),
    [anon_sym_abstract] = ACTIONS(4921),
    [anon_sym_get] = ACTIONS(4921),
    [anon_sym_set] = ACTIONS(4921),
    [anon_sym_declare] = ACTIONS(4921),
    [anon_sym_public] = ACTIONS(4921),
    [anon_sym_private] = ACTIONS(4921),
    [anon_sym_protected] = ACTIONS(4921),
    [anon_sym_module] = ACTIONS(4921),
    [anon_sym_any] = ACTIONS(4921),
    [anon_sym_number] = ACTIONS(4921),
    [anon_sym_boolean] = ACTIONS(4921),
    [anon_sym_string] = ACTIONS(4921),
    [anon_sym_symbol] = ACTIONS(4921),
    [sym_readonly] = ACTIONS(4921),
    [sym__automatic_semicolon] = ACTIONS(4923),
  },
  [1786] = {
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [1787] = {
    [sym_string] = STATE(2150),
    [sym__property_name] = STATE(2150),
    [sym_computed_property_name] = STATE(2150),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4777),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1788] = {
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_export] = ACTIONS(4925),
    [anon_sym_STAR] = ACTIONS(4927),
    [anon_sym_namespace] = ACTIONS(4925),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_type] = ACTIONS(4925),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_LBRACK] = ACTIONS(4927),
    [anon_sym_async] = ACTIONS(4925),
    [anon_sym_void] = ACTIONS(4925),
    [anon_sym_DQUOTE] = ACTIONS(4927),
    [anon_sym_SQUOTE] = ACTIONS(4927),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4927),
    [anon_sym_AT] = ACTIONS(4927),
    [anon_sym_static] = ACTIONS(4925),
    [anon_sym_abstract] = ACTIONS(4925),
    [anon_sym_get] = ACTIONS(4925),
    [anon_sym_set] = ACTIONS(4925),
    [anon_sym_declare] = ACTIONS(4925),
    [anon_sym_public] = ACTIONS(4925),
    [anon_sym_private] = ACTIONS(4925),
    [anon_sym_protected] = ACTIONS(4925),
    [anon_sym_module] = ACTIONS(4925),
    [anon_sym_any] = ACTIONS(4925),
    [anon_sym_number] = ACTIONS(4925),
    [anon_sym_boolean] = ACTIONS(4925),
    [anon_sym_string] = ACTIONS(4925),
    [anon_sym_symbol] = ACTIONS(4925),
    [sym_readonly] = ACTIONS(4925),
    [sym__automatic_semicolon] = ACTIONS(4927),
  },
  [1789] = {
    [sym_string] = STATE(2192),
    [sym__property_name] = STATE(2192),
    [sym_computed_property_name] = STATE(2192),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4929),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1790] = {
    [sym_string] = STATE(2119),
    [sym__property_name] = STATE(2119),
    [sym_computed_property_name] = STATE(2119),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4895),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1791] = {
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1103),
    [anon_sym_namespace] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_void] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1103),
    [anon_sym_static] = ACTIONS(1105),
    [anon_sym_abstract] = ACTIONS(1105),
    [anon_sym_get] = ACTIONS(1105),
    [anon_sym_set] = ACTIONS(1105),
    [anon_sym_declare] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1105),
    [anon_sym_private] = ACTIONS(1105),
    [anon_sym_protected] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1105),
    [anon_sym_any] = ACTIONS(1105),
    [anon_sym_number] = ACTIONS(1105),
    [anon_sym_boolean] = ACTIONS(1105),
    [anon_sym_string] = ACTIONS(1105),
    [anon_sym_symbol] = ACTIONS(1105),
    [sym_readonly] = ACTIONS(1105),
    [sym__automatic_semicolon] = ACTIONS(4931),
  },
  [1792] = {
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_STAR] = ACTIONS(1213),
    [anon_sym_namespace] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_type] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_void] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1213),
    [anon_sym_AT] = ACTIONS(1213),
    [anon_sym_static] = ACTIONS(1215),
    [anon_sym_abstract] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(1215),
    [anon_sym_set] = ACTIONS(1215),
    [anon_sym_declare] = ACTIONS(1215),
    [anon_sym_public] = ACTIONS(1215),
    [anon_sym_private] = ACTIONS(1215),
    [anon_sym_protected] = ACTIONS(1215),
    [anon_sym_module] = ACTIONS(1215),
    [anon_sym_any] = ACTIONS(1215),
    [anon_sym_number] = ACTIONS(1215),
    [anon_sym_boolean] = ACTIONS(1215),
    [anon_sym_string] = ACTIONS(1215),
    [anon_sym_symbol] = ACTIONS(1215),
    [sym_readonly] = ACTIONS(1215),
    [sym__automatic_semicolon] = ACTIONS(1213),
  },
  [1793] = {
    [sym_identifier] = ACTIONS(4933),
    [anon_sym_export] = ACTIONS(4933),
    [anon_sym_STAR] = ACTIONS(4935),
    [anon_sym_namespace] = ACTIONS(4933),
    [anon_sym_RBRACE] = ACTIONS(4935),
    [anon_sym_type] = ACTIONS(4933),
    [anon_sym_SEMI] = ACTIONS(4935),
    [anon_sym_LBRACK] = ACTIONS(4935),
    [anon_sym_async] = ACTIONS(4933),
    [anon_sym_void] = ACTIONS(4933),
    [anon_sym_DQUOTE] = ACTIONS(4935),
    [anon_sym_SQUOTE] = ACTIONS(4935),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4935),
    [anon_sym_AT] = ACTIONS(4935),
    [anon_sym_static] = ACTIONS(4933),
    [anon_sym_abstract] = ACTIONS(4933),
    [anon_sym_get] = ACTIONS(4933),
    [anon_sym_set] = ACTIONS(4933),
    [anon_sym_declare] = ACTIONS(4933),
    [anon_sym_public] = ACTIONS(4933),
    [anon_sym_private] = ACTIONS(4933),
    [anon_sym_protected] = ACTIONS(4933),
    [anon_sym_module] = ACTIONS(4933),
    [anon_sym_any] = ACTIONS(4933),
    [anon_sym_number] = ACTIONS(4933),
    [anon_sym_boolean] = ACTIONS(4933),
    [anon_sym_string] = ACTIONS(4933),
    [anon_sym_symbol] = ACTIONS(4933),
    [sym_readonly] = ACTIONS(4933),
    [sym__automatic_semicolon] = ACTIONS(4935),
  },
  [1794] = {
    [sym_string] = STATE(2184),
    [sym__property_name] = STATE(2184),
    [sym_computed_property_name] = STATE(2184),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4937),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1795] = {
    [sym_identifier] = ACTIONS(4939),
    [anon_sym_export] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4941),
    [anon_sym_namespace] = ACTIONS(4939),
    [anon_sym_RBRACE] = ACTIONS(4941),
    [anon_sym_type] = ACTIONS(4939),
    [anon_sym_SEMI] = ACTIONS(4941),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_async] = ACTIONS(4939),
    [anon_sym_void] = ACTIONS(4939),
    [anon_sym_DQUOTE] = ACTIONS(4941),
    [anon_sym_SQUOTE] = ACTIONS(4941),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4941),
    [anon_sym_AT] = ACTIONS(4941),
    [anon_sym_static] = ACTIONS(4939),
    [anon_sym_abstract] = ACTIONS(4939),
    [anon_sym_get] = ACTIONS(4939),
    [anon_sym_set] = ACTIONS(4939),
    [anon_sym_declare] = ACTIONS(4939),
    [anon_sym_public] = ACTIONS(4939),
    [anon_sym_private] = ACTIONS(4939),
    [anon_sym_protected] = ACTIONS(4939),
    [anon_sym_module] = ACTIONS(4939),
    [anon_sym_any] = ACTIONS(4939),
    [anon_sym_number] = ACTIONS(4939),
    [anon_sym_boolean] = ACTIONS(4939),
    [anon_sym_string] = ACTIONS(4939),
    [anon_sym_symbol] = ACTIONS(4939),
    [sym_readonly] = ACTIONS(4939),
    [sym__automatic_semicolon] = ACTIONS(4941),
  },
  [1796] = {
    [sym_identifier] = ACTIONS(4943),
    [anon_sym_export] = ACTIONS(4943),
    [anon_sym_STAR] = ACTIONS(4945),
    [anon_sym_namespace] = ACTIONS(4943),
    [anon_sym_RBRACE] = ACTIONS(4945),
    [anon_sym_type] = ACTIONS(4943),
    [anon_sym_SEMI] = ACTIONS(4945),
    [anon_sym_LBRACK] = ACTIONS(4945),
    [anon_sym_async] = ACTIONS(4943),
    [anon_sym_void] = ACTIONS(4943),
    [anon_sym_DQUOTE] = ACTIONS(4945),
    [anon_sym_SQUOTE] = ACTIONS(4945),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4945),
    [anon_sym_AT] = ACTIONS(4945),
    [anon_sym_static] = ACTIONS(4943),
    [anon_sym_abstract] = ACTIONS(4943),
    [anon_sym_get] = ACTIONS(4943),
    [anon_sym_set] = ACTIONS(4943),
    [anon_sym_declare] = ACTIONS(4943),
    [anon_sym_public] = ACTIONS(4943),
    [anon_sym_private] = ACTIONS(4943),
    [anon_sym_protected] = ACTIONS(4943),
    [anon_sym_module] = ACTIONS(4943),
    [anon_sym_any] = ACTIONS(4943),
    [anon_sym_number] = ACTIONS(4943),
    [anon_sym_boolean] = ACTIONS(4943),
    [anon_sym_string] = ACTIONS(4943),
    [anon_sym_symbol] = ACTIONS(4943),
    [sym_readonly] = ACTIONS(4943),
    [sym__automatic_semicolon] = ACTIONS(4945),
  },
  [1797] = {
    [sym_string] = STATE(2161),
    [sym__property_name] = STATE(2161),
    [sym_computed_property_name] = STATE(2161),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4789),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1798] = {
    [sym_identifier] = ACTIONS(4947),
    [anon_sym_export] = ACTIONS(4947),
    [anon_sym_STAR] = ACTIONS(4949),
    [anon_sym_namespace] = ACTIONS(4947),
    [anon_sym_RBRACE] = ACTIONS(4949),
    [anon_sym_type] = ACTIONS(4947),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_LBRACK] = ACTIONS(4949),
    [anon_sym_async] = ACTIONS(4947),
    [anon_sym_void] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4949),
    [anon_sym_SQUOTE] = ACTIONS(4949),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4949),
    [anon_sym_AT] = ACTIONS(4949),
    [anon_sym_static] = ACTIONS(4947),
    [anon_sym_abstract] = ACTIONS(4947),
    [anon_sym_get] = ACTIONS(4947),
    [anon_sym_set] = ACTIONS(4947),
    [anon_sym_declare] = ACTIONS(4947),
    [anon_sym_public] = ACTIONS(4947),
    [anon_sym_private] = ACTIONS(4947),
    [anon_sym_protected] = ACTIONS(4947),
    [anon_sym_module] = ACTIONS(4947),
    [anon_sym_any] = ACTIONS(4947),
    [anon_sym_number] = ACTIONS(4947),
    [anon_sym_boolean] = ACTIONS(4947),
    [anon_sym_string] = ACTIONS(4947),
    [anon_sym_symbol] = ACTIONS(4947),
    [sym_readonly] = ACTIONS(4947),
    [sym__automatic_semicolon] = ACTIONS(4949),
  },
  [1799] = {
    [sym_object] = STATE(2429),
    [sym_array] = STATE(2433),
    [sym_identifier] = ACTIONS(2878),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_EQ] = ACTIONS(658),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_QMARK] = ACTIONS(658),
    [anon_sym_void] = ACTIONS(2880),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [sym_readonly] = ACTIONS(2880),
  },
  [1800] = {
    [sym_identifier] = ACTIONS(4951),
    [anon_sym_export] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4953),
    [anon_sym_namespace] = ACTIONS(4951),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_type] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4953),
    [anon_sym_LBRACK] = ACTIONS(4953),
    [anon_sym_async] = ACTIONS(4951),
    [anon_sym_void] = ACTIONS(4951),
    [anon_sym_DQUOTE] = ACTIONS(4953),
    [anon_sym_SQUOTE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4953),
    [anon_sym_AT] = ACTIONS(4953),
    [anon_sym_static] = ACTIONS(4951),
    [anon_sym_abstract] = ACTIONS(4951),
    [anon_sym_get] = ACTIONS(4951),
    [anon_sym_set] = ACTIONS(4951),
    [anon_sym_declare] = ACTIONS(4951),
    [anon_sym_public] = ACTIONS(4951),
    [anon_sym_private] = ACTIONS(4951),
    [anon_sym_protected] = ACTIONS(4951),
    [anon_sym_module] = ACTIONS(4951),
    [anon_sym_any] = ACTIONS(4951),
    [anon_sym_number] = ACTIONS(4951),
    [anon_sym_boolean] = ACTIONS(4951),
    [anon_sym_string] = ACTIONS(4951),
    [anon_sym_symbol] = ACTIONS(4951),
    [sym_readonly] = ACTIONS(4951),
    [sym__automatic_semicolon] = ACTIONS(4953),
  },
  [1801] = {
    [sym_identifier] = ACTIONS(4955),
    [anon_sym_export] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4957),
    [anon_sym_namespace] = ACTIONS(4955),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_type] = ACTIONS(4955),
    [anon_sym_SEMI] = ACTIONS(4957),
    [anon_sym_LBRACK] = ACTIONS(4957),
    [anon_sym_async] = ACTIONS(4955),
    [anon_sym_void] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4957),
    [anon_sym_SQUOTE] = ACTIONS(4957),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4957),
    [anon_sym_AT] = ACTIONS(4957),
    [anon_sym_static] = ACTIONS(4955),
    [anon_sym_abstract] = ACTIONS(4955),
    [anon_sym_get] = ACTIONS(4955),
    [anon_sym_set] = ACTIONS(4955),
    [anon_sym_declare] = ACTIONS(4955),
    [anon_sym_public] = ACTIONS(4955),
    [anon_sym_private] = ACTIONS(4955),
    [anon_sym_protected] = ACTIONS(4955),
    [anon_sym_module] = ACTIONS(4955),
    [anon_sym_any] = ACTIONS(4955),
    [anon_sym_number] = ACTIONS(4955),
    [anon_sym_boolean] = ACTIONS(4955),
    [anon_sym_string] = ACTIONS(4955),
    [anon_sym_symbol] = ACTIONS(4955),
    [sym_readonly] = ACTIONS(4955),
    [sym__automatic_semicolon] = ACTIONS(4957),
  },
  [1802] = {
    [sym_string] = STATE(2167),
    [sym__property_name] = STATE(2167),
    [sym_computed_property_name] = STATE(2167),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4731),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1803] = {
    [sym_string] = STATE(2133),
    [sym__property_name] = STATE(2133),
    [sym_computed_property_name] = STATE(2133),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4959),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1804] = {
    [sym_string] = STATE(2147),
    [sym__property_name] = STATE(2147),
    [sym_computed_property_name] = STATE(2147),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4961),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1805] = {
    [sym_string] = STATE(2180),
    [sym__property_name] = STATE(2180),
    [sym_computed_property_name] = STATE(2180),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4723),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1806] = {
    [sym_identifier] = ACTIONS(4963),
    [anon_sym_export] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4965),
    [anon_sym_namespace] = ACTIONS(4963),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_type] = ACTIONS(4963),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_async] = ACTIONS(4963),
    [anon_sym_void] = ACTIONS(4963),
    [anon_sym_DQUOTE] = ACTIONS(4965),
    [anon_sym_SQUOTE] = ACTIONS(4965),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4965),
    [anon_sym_AT] = ACTIONS(4965),
    [anon_sym_static] = ACTIONS(4963),
    [anon_sym_abstract] = ACTIONS(4963),
    [anon_sym_get] = ACTIONS(4963),
    [anon_sym_set] = ACTIONS(4963),
    [anon_sym_declare] = ACTIONS(4963),
    [anon_sym_public] = ACTIONS(4963),
    [anon_sym_private] = ACTIONS(4963),
    [anon_sym_protected] = ACTIONS(4963),
    [anon_sym_module] = ACTIONS(4963),
    [anon_sym_any] = ACTIONS(4963),
    [anon_sym_number] = ACTIONS(4963),
    [anon_sym_boolean] = ACTIONS(4963),
    [anon_sym_string] = ACTIONS(4963),
    [anon_sym_symbol] = ACTIONS(4963),
    [sym_readonly] = ACTIONS(4963),
    [sym__automatic_semicolon] = ACTIONS(4965),
  },
  [1807] = {
    [sym_string] = STATE(2160),
    [sym__property_name] = STATE(2160),
    [sym_computed_property_name] = STATE(2160),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4887),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1808] = {
    [sym_identifier] = ACTIONS(4967),
    [anon_sym_export] = ACTIONS(4967),
    [anon_sym_STAR] = ACTIONS(4969),
    [anon_sym_namespace] = ACTIONS(4967),
    [anon_sym_RBRACE] = ACTIONS(4969),
    [anon_sym_type] = ACTIONS(4967),
    [anon_sym_SEMI] = ACTIONS(4969),
    [anon_sym_LBRACK] = ACTIONS(4969),
    [anon_sym_async] = ACTIONS(4967),
    [anon_sym_void] = ACTIONS(4967),
    [anon_sym_DQUOTE] = ACTIONS(4969),
    [anon_sym_SQUOTE] = ACTIONS(4969),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4969),
    [anon_sym_AT] = ACTIONS(4969),
    [anon_sym_static] = ACTIONS(4967),
    [anon_sym_abstract] = ACTIONS(4967),
    [anon_sym_get] = ACTIONS(4967),
    [anon_sym_set] = ACTIONS(4967),
    [anon_sym_declare] = ACTIONS(4967),
    [anon_sym_public] = ACTIONS(4967),
    [anon_sym_private] = ACTIONS(4967),
    [anon_sym_protected] = ACTIONS(4967),
    [anon_sym_module] = ACTIONS(4967),
    [anon_sym_any] = ACTIONS(4967),
    [anon_sym_number] = ACTIONS(4967),
    [anon_sym_boolean] = ACTIONS(4967),
    [anon_sym_string] = ACTIONS(4967),
    [anon_sym_symbol] = ACTIONS(4967),
    [sym_readonly] = ACTIONS(4967),
    [sym__automatic_semicolon] = ACTIONS(4969),
  },
  [1809] = {
    [sym_string] = STATE(2186),
    [sym__property_name] = STATE(2186),
    [sym_computed_property_name] = STATE(2186),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4769),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1810] = {
    [sym_identifier] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_STAR] = ACTIONS(1133),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1133),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1133),
    [anon_sym_SQUOTE] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_abstract] = ACTIONS(1135),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(4971),
  },
  [1811] = {
    [sym_identifier] = ACTIONS(4973),
    [anon_sym_export] = ACTIONS(4973),
    [anon_sym_STAR] = ACTIONS(4975),
    [anon_sym_namespace] = ACTIONS(4973),
    [anon_sym_RBRACE] = ACTIONS(4975),
    [anon_sym_type] = ACTIONS(4973),
    [anon_sym_SEMI] = ACTIONS(4975),
    [anon_sym_LBRACK] = ACTIONS(4975),
    [anon_sym_async] = ACTIONS(4973),
    [anon_sym_void] = ACTIONS(4973),
    [anon_sym_DQUOTE] = ACTIONS(4975),
    [anon_sym_SQUOTE] = ACTIONS(4975),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4975),
    [anon_sym_AT] = ACTIONS(4975),
    [anon_sym_static] = ACTIONS(4973),
    [anon_sym_abstract] = ACTIONS(4973),
    [anon_sym_get] = ACTIONS(4973),
    [anon_sym_set] = ACTIONS(4973),
    [anon_sym_declare] = ACTIONS(4973),
    [anon_sym_public] = ACTIONS(4973),
    [anon_sym_private] = ACTIONS(4973),
    [anon_sym_protected] = ACTIONS(4973),
    [anon_sym_module] = ACTIONS(4973),
    [anon_sym_any] = ACTIONS(4973),
    [anon_sym_number] = ACTIONS(4973),
    [anon_sym_boolean] = ACTIONS(4973),
    [anon_sym_string] = ACTIONS(4973),
    [anon_sym_symbol] = ACTIONS(4973),
    [sym_readonly] = ACTIONS(4973),
    [sym__automatic_semicolon] = ACTIONS(4975),
  },
  [1812] = {
    [sym_identifier] = ACTIONS(4977),
    [anon_sym_export] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4979),
    [anon_sym_namespace] = ACTIONS(4977),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [anon_sym_type] = ACTIONS(4977),
    [anon_sym_SEMI] = ACTIONS(4979),
    [anon_sym_LBRACK] = ACTIONS(4979),
    [anon_sym_async] = ACTIONS(4977),
    [anon_sym_void] = ACTIONS(4977),
    [anon_sym_DQUOTE] = ACTIONS(4979),
    [anon_sym_SQUOTE] = ACTIONS(4979),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4979),
    [anon_sym_AT] = ACTIONS(4979),
    [anon_sym_static] = ACTIONS(4977),
    [anon_sym_abstract] = ACTIONS(4977),
    [anon_sym_get] = ACTIONS(4977),
    [anon_sym_set] = ACTIONS(4977),
    [anon_sym_declare] = ACTIONS(4977),
    [anon_sym_public] = ACTIONS(4977),
    [anon_sym_private] = ACTIONS(4977),
    [anon_sym_protected] = ACTIONS(4977),
    [anon_sym_module] = ACTIONS(4977),
    [anon_sym_any] = ACTIONS(4977),
    [anon_sym_number] = ACTIONS(4977),
    [anon_sym_boolean] = ACTIONS(4977),
    [anon_sym_string] = ACTIONS(4977),
    [anon_sym_symbol] = ACTIONS(4977),
    [sym_readonly] = ACTIONS(4977),
    [sym__automatic_semicolon] = ACTIONS(4979),
  },
  [1813] = {
    [sym_string] = STATE(2195),
    [sym__property_name] = STATE(2195),
    [sym_computed_property_name] = STATE(2195),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4901),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1814] = {
    [sym_string] = STATE(1867),
    [sym__property_name] = STATE(1867),
    [sym_computed_property_name] = STATE(1867),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4591),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_async] = ACTIONS(4593),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4595),
    [anon_sym_static] = ACTIONS(4981),
    [anon_sym_abstract] = ACTIONS(4983),
    [anon_sym_get] = ACTIONS(4599),
    [anon_sym_set] = ACTIONS(4599),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4985),
  },
  [1815] = {
    [sym_string] = STATE(2536),
    [sym__property_name] = STATE(2536),
    [sym_computed_property_name] = STATE(2536),
    [sym_enum_assignment] = STATE(2831),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1816] = {
    [sym_string] = STATE(2331),
    [sym__property_name] = STATE(2331),
    [sym_computed_property_name] = STATE(2331),
    [sym_enum_assignment] = STATE(2737),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4993),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1817] = {
    [sym_string] = STATE(2536),
    [sym__property_name] = STATE(2536),
    [sym_computed_property_name] = STATE(2536),
    [sym_enum_assignment] = STATE(2831),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(4995),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1818] = {
    [sym_string] = STATE(2427),
    [sym__property_name] = STATE(2427),
    [sym_computed_property_name] = STATE(2427),
    [sym_enum_assignment] = STATE(2641),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(4997),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4999),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1819] = {
    [sym_string] = STATE(2536),
    [sym__property_name] = STATE(2536),
    [sym_computed_property_name] = STATE(2536),
    [sym_enum_assignment] = STATE(2831),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(5001),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1820] = {
    [sym_string] = STATE(2536),
    [sym__property_name] = STATE(2536),
    [sym_computed_property_name] = STATE(2536),
    [sym_enum_assignment] = STATE(2831),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1821] = {
    [sym_string] = STATE(1870),
    [sym__property_name] = STATE(1870),
    [sym_computed_property_name] = STATE(1870),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(5005),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_async] = ACTIONS(3582),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(5007),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(5009),
    [anon_sym_set] = ACTIONS(5009),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(5011),
  },
  [1822] = {
    [sym_string] = STATE(1868),
    [sym__property_name] = STATE(1868),
    [sym_computed_property_name] = STATE(1868),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(5013),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_async] = ACTIONS(3582),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(5015),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(5017),
    [anon_sym_set] = ACTIONS(5017),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(5019),
  },
  [1823] = {
    [sym_identifier] = ACTIONS(5021),
    [anon_sym_export] = ACTIONS(5021),
    [anon_sym_STAR] = ACTIONS(4349),
    [anon_sym_namespace] = ACTIONS(5021),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_type] = ACTIONS(5021),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_async] = ACTIONS(5021),
    [anon_sym_void] = ACTIONS(5021),
    [anon_sym_DQUOTE] = ACTIONS(4349),
    [anon_sym_SQUOTE] = ACTIONS(4349),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4349),
    [anon_sym_AT] = ACTIONS(4349),
    [anon_sym_static] = ACTIONS(5021),
    [anon_sym_abstract] = ACTIONS(5021),
    [anon_sym_get] = ACTIONS(5021),
    [anon_sym_set] = ACTIONS(5021),
    [anon_sym_declare] = ACTIONS(5021),
    [anon_sym_public] = ACTIONS(5021),
    [anon_sym_private] = ACTIONS(5021),
    [anon_sym_protected] = ACTIONS(5021),
    [anon_sym_module] = ACTIONS(5021),
    [anon_sym_any] = ACTIONS(5021),
    [anon_sym_number] = ACTIONS(5021),
    [anon_sym_boolean] = ACTIONS(5021),
    [anon_sym_string] = ACTIONS(5021),
    [anon_sym_symbol] = ACTIONS(5021),
    [sym_readonly] = ACTIONS(5021),
  },
  [1824] = {
    [sym_string] = STATE(1876),
    [sym__property_name] = STATE(1876),
    [sym_computed_property_name] = STATE(1876),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4628),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_async] = ACTIONS(4634),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4636),
    [anon_sym_static] = ACTIONS(5023),
    [anon_sym_get] = ACTIONS(4638),
    [anon_sym_set] = ACTIONS(4638),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4640),
  },
  [1825] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym_export] = ACTIONS(5025),
    [anon_sym_namespace] = ACTIONS(5025),
    [anon_sym_LBRACE] = ACTIONS(5027),
    [anon_sym_type] = ACTIONS(5025),
    [anon_sym_LBRACK] = ACTIONS(5027),
    [anon_sym_class] = ACTIONS(5025),
    [anon_sym_async] = ACTIONS(5025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5027),
    [anon_sym_void] = ACTIONS(5025),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(5025),
    [anon_sym_AT] = ACTIONS(5029),
    [anon_sym_static] = ACTIONS(5025),
    [anon_sym_get] = ACTIONS(5025),
    [anon_sym_set] = ACTIONS(5025),
    [anon_sym_declare] = ACTIONS(5025),
    [anon_sym_public] = ACTIONS(5025),
    [anon_sym_private] = ACTIONS(5025),
    [anon_sym_protected] = ACTIONS(5025),
    [anon_sym_module] = ACTIONS(5025),
    [anon_sym_any] = ACTIONS(5025),
    [anon_sym_number] = ACTIONS(5025),
    [anon_sym_boolean] = ACTIONS(5025),
    [anon_sym_string] = ACTIONS(5025),
    [anon_sym_symbol] = ACTIONS(5025),
    [sym_readonly] = ACTIONS(5025),
  },
  [1826] = {
    [sym_string] = STATE(1875),
    [sym__property_name] = STATE(1875),
    [sym_computed_property_name] = STATE(1875),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4282),
    [anon_sym_static] = ACTIONS(5032),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(4313),
  },
  [1827] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(4801),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(5034),
    [anon_sym_get] = ACTIONS(2528),
    [anon_sym_set] = ACTIONS(2528),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2530),
  },
  [1828] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(658),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(658),
    [anon_sym_void] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(2618),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [sym_readonly] = ACTIONS(2618),
  },
  [1829] = {
    [sym_string] = STATE(2536),
    [sym__property_name] = STATE(2536),
    [sym_computed_property_name] = STATE(2536),
    [sym_enum_assignment] = STATE(2831),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4989),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1830] = {
    [sym_string] = STATE(2167),
    [sym__property_name] = STATE(2167),
    [sym_computed_property_name] = STATE(2167),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4731),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1831] = {
    [sym_string] = STATE(2139),
    [sym__property_name] = STATE(2139),
    [sym_computed_property_name] = STATE(2139),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4809),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1832] = {
    [sym_string] = STATE(2160),
    [sym__property_name] = STATE(2160),
    [sym_computed_property_name] = STATE(2160),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4887),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1833] = {
    [sym_string] = STATE(2195),
    [sym__property_name] = STATE(2195),
    [sym_computed_property_name] = STATE(2195),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4901),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1834] = {
    [sym_string] = STATE(2192),
    [sym__property_name] = STATE(2192),
    [sym_computed_property_name] = STATE(2192),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4929),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1835] = {
    [sym_string] = STATE(2180),
    [sym__property_name] = STATE(2180),
    [sym_computed_property_name] = STATE(2180),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4723),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1836] = {
    [sym_string] = STATE(2156),
    [sym__property_name] = STATE(2156),
    [sym_computed_property_name] = STATE(2156),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4622),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1837] = {
    [sym_string] = STATE(2188),
    [sym__property_name] = STATE(2188),
    [sym_computed_property_name] = STATE(2188),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4317),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1838] = {
    [sym_string] = STATE(2147),
    [sym__property_name] = STATE(2147),
    [sym_computed_property_name] = STATE(2147),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4961),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1839] = {
    [sym_string] = STATE(2133),
    [sym__property_name] = STATE(2133),
    [sym_computed_property_name] = STATE(2133),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4959),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1840] = {
    [sym_string] = STATE(2186),
    [sym__property_name] = STATE(2186),
    [sym_computed_property_name] = STATE(2186),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4769),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1841] = {
    [sym_string] = STATE(2161),
    [sym__property_name] = STATE(2161),
    [sym_computed_property_name] = STATE(2161),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4789),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1842] = {
    [sym_string] = STATE(2149),
    [sym__property_name] = STATE(2149),
    [sym_computed_property_name] = STATE(2149),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4813),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1843] = {
    [sym_string] = STATE(2124),
    [sym__property_name] = STATE(2124),
    [sym_computed_property_name] = STATE(2124),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4630),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1844] = {
    [sym_string] = STATE(2165),
    [sym__property_name] = STATE(2165),
    [sym_computed_property_name] = STATE(2165),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4785),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1845] = {
    [sym_string] = STATE(2119),
    [sym__property_name] = STATE(2119),
    [sym_computed_property_name] = STATE(2119),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4895),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1846] = {
    [sym_string] = STATE(2184),
    [sym__property_name] = STATE(2184),
    [sym_computed_property_name] = STATE(2184),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4937),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1847] = {
    [sym_string] = STATE(1995),
    [sym__property_name] = STATE(1995),
    [sym_computed_property_name] = STATE(1995),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_async] = ACTIONS(3582),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4815),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(3582),
    [anon_sym_set] = ACTIONS(3582),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
  },
  [1848] = {
    [sym_string] = STATE(2197),
    [sym__property_name] = STATE(2197),
    [sym_computed_property_name] = STATE(2197),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1849] = {
    [sym_string] = STATE(2150),
    [sym__property_name] = STATE(2150),
    [sym_computed_property_name] = STATE(2150),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4777),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1850] = {
    [sym_string] = STATE(2114),
    [sym__property_name] = STATE(2114),
    [sym_computed_property_name] = STATE(2114),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4737),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1851] = {
    [sym_string] = STATE(2201),
    [sym__property_name] = STATE(2201),
    [sym_computed_property_name] = STATE(2201),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4701),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1852] = {
    [sym_string] = STATE(2134),
    [sym__property_name] = STATE(2134),
    [sym_computed_property_name] = STATE(2134),
    [sym_identifier] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_type] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(4315),
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4656),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2524),
    [anon_sym_set] = ACTIONS(2524),
    [anon_sym_declare] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_any] = ACTIONS(2524),
    [anon_sym_number] = ACTIONS(2524),
    [anon_sym_boolean] = ACTIONS(2524),
    [anon_sym_string] = ACTIONS(2524),
    [anon_sym_symbol] = ACTIONS(2524),
    [sym_readonly] = ACTIONS(2524),
  },
  [1853] = {
    [sym_string] = STATE(1990),
    [sym__property_name] = STATE(1990),
    [sym_computed_property_name] = STATE(1990),
    [sym_identifier] = ACTIONS(3582),
    [anon_sym_export] = ACTIONS(3582),
    [anon_sym_namespace] = ACTIONS(3582),
    [anon_sym_type] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_async] = ACTIONS(3582),
    [anon_sym_void] = ACTIONS(3582),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4803),
    [anon_sym_static] = ACTIONS(3582),
    [anon_sym_get] = ACTIONS(3582),
    [anon_sym_set] = ACTIONS(3582),
    [anon_sym_declare] = ACTIONS(3582),
    [anon_sym_public] = ACTIONS(3582),
    [anon_sym_private] = ACTIONS(3582),
    [anon_sym_protected] = ACTIONS(3582),
    [anon_sym_module] = ACTIONS(3582),
    [anon_sym_any] = ACTIONS(3582),
    [anon_sym_number] = ACTIONS(3582),
    [anon_sym_boolean] = ACTIONS(3582),
    [anon_sym_string] = ACTIONS(3582),
    [anon_sym_symbol] = ACTIONS(3582),
    [sym_readonly] = ACTIONS(3582),
  },
  [1854] = {
    [sym_identifier] = ACTIONS(5036),
    [anon_sym_export] = ACTIONS(5036),
    [anon_sym_namespace] = ACTIONS(5036),
    [anon_sym_LBRACE] = ACTIONS(5038),
    [anon_sym_type] = ACTIONS(5036),
    [anon_sym_LBRACK] = ACTIONS(5038),
    [anon_sym_class] = ACTIONS(5036),
    [anon_sym_async] = ACTIONS(5036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5038),
    [anon_sym_void] = ACTIONS(5036),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(5036),
    [anon_sym_AT] = ACTIONS(5038),
    [anon_sym_static] = ACTIONS(5036),
    [anon_sym_get] = ACTIONS(5036),
    [anon_sym_set] = ACTIONS(5036),
    [anon_sym_declare] = ACTIONS(5036),
    [anon_sym_public] = ACTIONS(5036),
    [anon_sym_private] = ACTIONS(5036),
    [anon_sym_protected] = ACTIONS(5036),
    [anon_sym_module] = ACTIONS(5036),
    [anon_sym_any] = ACTIONS(5036),
    [anon_sym_number] = ACTIONS(5036),
    [anon_sym_boolean] = ACTIONS(5036),
    [anon_sym_string] = ACTIONS(5036),
    [anon_sym_symbol] = ACTIONS(5036),
    [sym_readonly] = ACTIONS(5036),
  },
  [1855] = {
    [sym_object] = STATE(2429),
    [sym_array] = STATE(2433),
    [sym_identifier] = ACTIONS(2878),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_void] = ACTIONS(2880),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(2878),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [sym_readonly] = ACTIONS(5040),
  },
  [1856] = {
    [sym_decorator_member_expression] = STATE(1739),
    [sym_decorator_call_expression] = STATE(1765),
    [sym_identifier] = ACTIONS(5042),
    [anon_sym_export] = ACTIONS(5044),
    [anon_sym_namespace] = ACTIONS(5044),
    [anon_sym_type] = ACTIONS(5044),
    [anon_sym_async] = ACTIONS(5044),
    [anon_sym_void] = ACTIONS(5044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(5044),
    [anon_sym_get] = ACTIONS(5044),
    [anon_sym_set] = ACTIONS(5044),
    [anon_sym_declare] = ACTIONS(5044),
    [anon_sym_public] = ACTIONS(5044),
    [anon_sym_private] = ACTIONS(5044),
    [anon_sym_protected] = ACTIONS(5044),
    [anon_sym_module] = ACTIONS(5044),
    [anon_sym_any] = ACTIONS(5044),
    [anon_sym_number] = ACTIONS(5044),
    [anon_sym_boolean] = ACTIONS(5044),
    [anon_sym_string] = ACTIONS(5044),
    [anon_sym_symbol] = ACTIONS(5044),
    [sym_readonly] = ACTIONS(5044),
  },
  [1857] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [sym_default_type] = STATE(2798),
    [sym_constraint] = STATE(2532),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1974),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_EQ] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_COLON] = ACTIONS(5054),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5058),
    [anon_sym_SLASH] = ACTIONS(5061),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5067),
  },
  [1858] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [sym_default_type] = STATE(2798),
    [sym_constraint] = STATE(2532),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2013),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_EQ] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_COLON] = ACTIONS(5054),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5058),
    [anon_sym_SLASH] = ACTIONS(5069),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5067),
  },
  [1859] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [sym_default_type] = STATE(2798),
    [sym_constraint] = STATE(2532),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1977),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_EQ] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_COLON] = ACTIONS(5054),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5058),
    [anon_sym_SLASH] = ACTIONS(5071),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5067),
  },
  [1860] = {
    [sym_identifier] = ACTIONS(1237),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_RPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_RBRACK] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1237),
    [sym_jsx_identifier] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_EQ_GT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
  },
  [1861] = {
    [sym_identifier] = ACTIONS(2543),
    [anon_sym_EQ] = ACTIONS(2543),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(2541),
    [anon_sym_LPAREN] = ACTIONS(2541),
    [anon_sym_RPAREN] = ACTIONS(2541),
    [anon_sym_while] = ACTIONS(2543),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_RBRACK] = ACTIONS(2541),
    [anon_sym_GT] = ACTIONS(2541),
    [sym_jsx_identifier] = ACTIONS(2541),
    [anon_sym_EQ_GT] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(2541),
    [anon_sym_PIPE] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2541),
  },
  [1862] = {
    [sym_identifier] = ACTIONS(2547),
    [anon_sym_EQ] = ACTIONS(2547),
    [anon_sym_LBRACE] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2545),
    [anon_sym_RPAREN] = ACTIONS(2545),
    [anon_sym_while] = ACTIONS(2547),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_RBRACK] = ACTIONS(2545),
    [anon_sym_GT] = ACTIONS(2545),
    [sym_jsx_identifier] = ACTIONS(2545),
    [anon_sym_EQ_GT] = ACTIONS(2545),
    [anon_sym_AMP] = ACTIONS(2545),
    [anon_sym_PIPE] = ACTIONS(2545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2545),
  },
  [1863] = {
    [sym_identifier] = ACTIONS(2561),
    [anon_sym_EQ] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(2559),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_LPAREN] = ACTIONS(2559),
    [anon_sym_RPAREN] = ACTIONS(2559),
    [anon_sym_while] = ACTIONS(2561),
    [anon_sym_LBRACK] = ACTIONS(2559),
    [anon_sym_RBRACK] = ACTIONS(2559),
    [anon_sym_GT] = ACTIONS(2559),
    [sym_jsx_identifier] = ACTIONS(2559),
    [anon_sym_EQ_GT] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2559),
    [anon_sym_PIPE] = ACTIONS(2559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2559),
  },
  [1864] = {
    [anon_sym_EQ] = ACTIONS(1167),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1167),
    [sym__automatic_semicolon] = ACTIONS(1167),
  },
  [1865] = {
    [anon_sym_EQ] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1163),
    [sym__automatic_semicolon] = ACTIONS(1163),
  },
  [1866] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_EQ] = ACTIONS(2534),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_RPAREN] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_RBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(2532),
    [anon_sym_DOT] = ACTIONS(5073),
    [anon_sym_EQ_GT] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3316),
  },
  [1867] = {
    [sym__call_signature] = STATE(2422),
    [sym__initializer] = STATE(2604),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2428),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5077),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5081),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5077),
  },
  [1868] = {
    [sym__call_signature] = STATE(2569),
    [sym__initializer] = STATE(2582),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2386),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5083),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5083),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5085),
    [anon_sym_BANG] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5083),
  },
  [1869] = {
    [sym_type_arguments] = STATE(425),
    [sym_identifier] = ACTIONS(5089),
    [anon_sym_EQ] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(5091),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5093),
    [anon_sym_SLASH] = ACTIONS(5089),
    [sym_jsx_identifier] = ACTIONS(5091),
    [anon_sym_DOT] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(5096),
  },
  [1870] = {
    [sym__call_signature] = STATE(2601),
    [sym__initializer] = STATE(2604),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2428),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5077),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_BANG] = ACTIONS(5081),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5077),
  },
  [1871] = {
    [sym__call_signature] = STATE(2406),
    [sym__initializer] = STATE(2666),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2407),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5100),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5102),
    [anon_sym_BANG] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5100),
  },
  [1872] = {
    [sym__call_signature] = STATE(2221),
    [sym__initializer] = STATE(2582),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2386),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5083),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5083),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5106),
    [anon_sym_BANG] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5083),
  },
  [1873] = {
    [sym__call_signature] = STATE(2416),
    [sym__initializer] = STATE(2562),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2420),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5108),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5108),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5110),
    [anon_sym_BANG] = ACTIONS(5112),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5108),
  },
  [1874] = {
    [sym_type_arguments] = STATE(1933),
    [anon_sym_EQ] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(5114),
    [anon_sym_DOT] = ACTIONS(5116),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3305),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2532),
    [sym__automatic_semicolon] = ACTIONS(2532),
  },
  [1875] = {
    [sym__call_signature] = STATE(2056),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2215),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5118),
    [anon_sym_RBRACE] = ACTIONS(5118),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5118),
    [sym__automatic_semicolon] = ACTIONS(5118),
  },
  [1876] = {
    [sym__call_signature] = STATE(2344),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2215),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5118),
    [anon_sym_RBRACE] = ACTIONS(5118),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5118),
    [sym__automatic_semicolon] = ACTIONS(5118),
  },
  [1877] = {
    [sym__call_signature] = STATE(2292),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2279),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5124),
    [sym__automatic_semicolon] = ACTIONS(5124),
  },
  [1878] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1989),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [1879] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2014),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5134),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [1880] = {
    [sym__call_signature] = STATE(2105),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2281),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5136),
    [anon_sym_RBRACE] = ACTIONS(5136),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5136),
    [anon_sym_COLON] = ACTIONS(5138),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5136),
    [sym__automatic_semicolon] = ACTIONS(5136),
  },
  [1881] = {
    [sym__call_signature] = STATE(2411),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2403),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5142),
    [anon_sym_RBRACE] = ACTIONS(5142),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5142),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5142),
    [sym__automatic_semicolon] = ACTIONS(5142),
  },
  [1882] = {
    [sym__call_signature] = STATE(2111),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2279),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5124),
    [sym__automatic_semicolon] = ACTIONS(5124),
  },
  [1883] = {
    [sym__call_signature] = STATE(2080),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2403),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5142),
    [anon_sym_RBRACE] = ACTIONS(5142),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5142),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5142),
    [sym__automatic_semicolon] = ACTIONS(5142),
  },
  [1884] = {
    [sym__call_signature] = STATE(2272),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2281),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5136),
    [anon_sym_RBRACE] = ACTIONS(5136),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5136),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5136),
    [sym__automatic_semicolon] = ACTIONS(5136),
  },
  [1885] = {
    [sym_type_arguments] = STATE(423),
    [anon_sym_EQ] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_COMMA] = ACTIONS(2611),
    [anon_sym_RPAREN] = ACTIONS(2611),
    [anon_sym_while] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_RBRACK] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(2611),
    [anon_sym_EQ_GT] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
  },
  [1886] = {
    [sym__call_signature] = STATE(2366),
    [sym__initializer] = STATE(2555),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2311),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5152),
  },
  [1887] = {
    [sym__call_signature] = STATE(2075),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2402),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5154),
    [anon_sym_RBRACE] = ACTIONS(5154),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5154),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5154),
    [sym__automatic_semicolon] = ACTIONS(5154),
  },
  [1888] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1974),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5061),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [1889] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2014),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5134),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [1890] = {
    [sym__call_signature] = STATE(2271),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2259),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5156),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5156),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5156),
    [sym__automatic_semicolon] = ACTIONS(5156),
  },
  [1891] = {
    [sym__call_signature] = STATE(2104),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2259),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5156),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5156),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5156),
    [sym__automatic_semicolon] = ACTIONS(5156),
  },
  [1892] = {
    [sym__call_signature] = STATE(2333),
    [sym__initializer] = STATE(2577),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2314),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5158),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5158),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5158),
  },
  [1893] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_EQ] = ACTIONS(3578),
    [anon_sym_COMMA] = ACTIONS(3578),
    [anon_sym_RPAREN] = ACTIONS(5160),
    [anon_sym_COLON] = ACTIONS(3578),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_DOT] = ACTIONS(5073),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3316),
  },
  [1894] = {
    [sym__call_signature] = STATE(2064),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2285),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5163),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5163),
    [sym__automatic_semicolon] = ACTIONS(5163),
  },
  [1895] = {
    [anon_sym_EQ] = ACTIONS(2607),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_RPAREN] = ACTIONS(2605),
    [anon_sym_while] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_RBRACK] = ACTIONS(2605),
    [anon_sym_GT] = ACTIONS(2605),
    [anon_sym_DOT] = ACTIONS(5065),
    [anon_sym_EQ_GT] = ACTIONS(2605),
    [anon_sym_AMP] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
  },
  [1896] = {
    [sym__call_signature] = STATE(2237),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2241),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5165),
    [anon_sym_RBRACE] = ACTIONS(5165),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5165),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5165),
    [sym__automatic_semicolon] = ACTIONS(5165),
  },
  [1897] = {
    [sym__call_signature] = STATE(2568),
    [sym__initializer] = STATE(2555),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2311),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5152),
  },
  [1898] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2013),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5069),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [1899] = {
    [sym_type_arguments] = STATE(1931),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_COMMA] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(5114),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2611),
    [sym__automatic_semicolon] = ACTIONS(2611),
  },
  [1900] = {
    [sym__call_signature] = STATE(2382),
    [sym__initializer] = STATE(2618),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2359),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5167),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5167),
  },
  [1901] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1977),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5071),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [1902] = {
    [sym__call_signature] = STATE(2417),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2402),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5154),
    [anon_sym_RBRACE] = ACTIONS(5154),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5154),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5154),
    [sym__automatic_semicolon] = ACTIONS(5154),
  },
  [1903] = {
    [sym__call_signature] = STATE(2387),
    [sym__initializer] = STATE(2557),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2435),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5169),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5169),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5169),
  },
  [1904] = {
    [sym__call_signature] = STATE(2561),
    [sym__initializer] = STATE(2557),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2435),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5169),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5169),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5169),
  },
  [1905] = {
    [sym__call_signature] = STATE(2310),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2285),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5163),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5163),
    [sym__automatic_semicolon] = ACTIONS(5163),
  },
  [1906] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [sym_type_arguments] = STATE(2016),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1989),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5056),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [sym_jsx_identifier] = ACTIONS(5063),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [1907] = {
    [sym__call_signature] = STATE(2052),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_annotation] = STATE(2241),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_COMMA] = ACTIONS(5165),
    [anon_sym_RBRACE] = ACTIONS(5165),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(5165),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5165),
    [sym__automatic_semicolon] = ACTIONS(5165),
  },
  [1908] = {
    [anon_sym_EQ] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2394),
    [sym__automatic_semicolon] = ACTIONS(2394),
  },
  [1909] = {
    [aux_sym_object_repeat1] = STATE(2602),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1910] = {
    [anon_sym_EQ] = ACTIONS(2646),
    [anon_sym_LBRACE] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_RBRACK] = ACTIONS(2644),
    [anon_sym_GT] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [1911] = {
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [anon_sym_BANG] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1912] = {
    [aux_sym_object_repeat1] = STATE(2718),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1913] = {
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_RPAREN] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_RBRACK] = ACTIONS(2622),
    [anon_sym_GT] = ACTIONS(2622),
    [anon_sym_EQ_GT] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [1914] = {
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_GT] = ACTIONS(2630),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [1915] = {
    [aux_sym_object_repeat1] = STATE(2645),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1916] = {
    [aux_sym_object_repeat1] = STATE(2671),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1917] = {
    [anon_sym_EQ] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(2605),
    [anon_sym_COMMA] = ACTIONS(2605),
    [anon_sym_RBRACE] = ACTIONS(2605),
    [anon_sym_SEMI] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_DOT] = ACTIONS(5175),
    [anon_sym_AMP] = ACTIONS(2605),
    [anon_sym_PIPE] = ACTIONS(2607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2605),
    [sym__automatic_semicolon] = ACTIONS(2605),
  },
  [1918] = {
    [anon_sym_EQ] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_while] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [1919] = {
    [anon_sym_EQ] = ACTIONS(2650),
    [anon_sym_LBRACE] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_RPAREN] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_RBRACK] = ACTIONS(2648),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_EQ_GT] = ACTIONS(2648),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [1920] = {
    [anon_sym_EQ] = ACTIONS(4548),
    [anon_sym_COMMA] = ACTIONS(4548),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_LPAREN] = ACTIONS(4548),
    [anon_sym_SEMI] = ACTIONS(4548),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_QMARK] = ACTIONS(4548),
    [anon_sym_BANG] = ACTIONS(4548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4548),
    [sym__automatic_semicolon] = ACTIONS(4548),
  },
  [1921] = {
    [anon_sym_EQ] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2434),
    [anon_sym_RBRACE] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2434),
    [anon_sym_DOT] = ACTIONS(5116),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2434),
    [sym__automatic_semicolon] = ACTIONS(2434),
  },
  [1922] = {
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1235),
  },
  [1923] = {
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2648),
    [sym__automatic_semicolon] = ACTIONS(2648),
  },
  [1924] = {
    [sym_class_heritage] = STATE(2951),
    [sym_class_body] = STATE(1417),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2060),
    [sym_identifier] = ACTIONS(5181),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1925] = {
    [anon_sym_EQ] = ACTIONS(2448),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_PIPE] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2448),
    [sym__automatic_semicolon] = ACTIONS(2448),
  },
  [1926] = {
    [sym_class_heritage] = STATE(2858),
    [sym_class_body] = STATE(1102),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2066),
    [sym_identifier] = ACTIONS(5189),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1927] = {
    [sym_class_heritage] = STATE(2864),
    [sym_class_body] = STATE(1596),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2094),
    [sym_identifier] = ACTIONS(5193),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1928] = {
    [anon_sym_EQ] = ACTIONS(2545),
    [anon_sym_LBRACE] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(2545),
    [anon_sym_SEMI] = ACTIONS(2545),
    [anon_sym_LBRACK] = ACTIONS(2545),
    [anon_sym_AMP] = ACTIONS(2545),
    [anon_sym_PIPE] = ACTIONS(2547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2545),
    [sym__automatic_semicolon] = ACTIONS(2545),
  },
  [1929] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1989),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1930] = {
    [sym_class_heritage] = STATE(2895),
    [sym_class_body] = STATE(1549),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2109),
    [sym_identifier] = ACTIONS(5197),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1931] = {
    [anon_sym_EQ] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2398),
    [sym__automatic_semicolon] = ACTIONS(2398),
  },
  [1932] = {
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_PIPE] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2476),
    [sym__automatic_semicolon] = ACTIONS(2476),
  },
  [1933] = {
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2430),
    [anon_sym_RBRACE] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_PIPE] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2430),
    [sym__automatic_semicolon] = ACTIONS(2430),
  },
  [1934] = {
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_COMMA] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2444),
    [sym__automatic_semicolon] = ACTIONS(2444),
  },
  [1935] = {
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PIPE] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2506),
    [sym__automatic_semicolon] = ACTIONS(2506),
  },
  [1936] = {
    [anon_sym_EQ] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_PIPE] = ACTIONS(2514),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2512),
    [sym__automatic_semicolon] = ACTIONS(2512),
  },
  [1937] = {
    [anon_sym_EQ] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_PIPE] = ACTIONS(2522),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2520),
    [sym__automatic_semicolon] = ACTIONS(2520),
  },
  [1938] = {
    [anon_sym_EQ] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_PIPE] = ACTIONS(2518),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2516),
    [sym__automatic_semicolon] = ACTIONS(2516),
  },
  [1939] = {
    [anon_sym_EQ] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PIPE] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2490),
    [sym__automatic_semicolon] = ACTIONS(2490),
  },
  [1940] = {
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2502),
    [sym__automatic_semicolon] = ACTIONS(2502),
  },
  [1941] = {
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_PIPE] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2464),
    [sym__automatic_semicolon] = ACTIONS(2464),
  },
  [1942] = {
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2494),
    [sym__automatic_semicolon] = ACTIONS(2494),
  },
  [1943] = {
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(4548),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_LPAREN] = ACTIONS(4548),
    [anon_sym_SEMI] = ACTIONS(4548),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_QMARK] = ACTIONS(4548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4548),
    [sym__automatic_semicolon] = ACTIONS(4548),
  },
  [1944] = {
    [anon_sym_EQ] = ACTIONS(2541),
    [anon_sym_LBRACE] = ACTIONS(2541),
    [anon_sym_COMMA] = ACTIONS(2541),
    [anon_sym_RBRACE] = ACTIONS(2541),
    [anon_sym_SEMI] = ACTIONS(2541),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_AMP] = ACTIONS(2541),
    [anon_sym_PIPE] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2541),
    [sym__automatic_semicolon] = ACTIONS(2541),
  },
  [1945] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2014),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5134),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1946] = {
    [sym_class_heritage] = STATE(2804),
    [sym_class_body] = STATE(1025),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2083),
    [sym_identifier] = ACTIONS(5201),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1947] = {
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_PIPE] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2472),
    [sym__automatic_semicolon] = ACTIONS(2472),
  },
  [1948] = {
    [anon_sym_EQ] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2486),
    [sym__automatic_semicolon] = ACTIONS(2486),
  },
  [1949] = {
    [sym_class_heritage] = STATE(2973),
    [sym_class_body] = STATE(1684),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2078),
    [sym_identifier] = ACTIONS(5203),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1950] = {
    [anon_sym_EQ] = ACTIONS(2440),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_COMMA] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_PIPE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2440),
    [sym__automatic_semicolon] = ACTIONS(2440),
  },
  [1951] = {
    [anon_sym_EQ] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_PIPE] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2452),
    [sym__automatic_semicolon] = ACTIONS(2452),
  },
  [1952] = {
    [anon_sym_EQ] = ACTIONS(2630),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2630),
    [sym__automatic_semicolon] = ACTIONS(2630),
  },
  [1953] = {
    [anon_sym_EQ] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2644),
    [anon_sym_COMMA] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2644),
    [sym__automatic_semicolon] = ACTIONS(2644),
  },
  [1954] = {
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_PIPE] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2456),
    [sym__automatic_semicolon] = ACTIONS(2456),
  },
  [1955] = {
    [sym_class_heritage] = STATE(2951),
    [sym_class_body] = STATE(1417),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2060),
    [sym_identifier] = ACTIONS(5205),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1956] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1974),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5061),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1957] = {
    [sym_class_heritage] = STATE(2895),
    [sym_class_body] = STATE(1549),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2109),
    [sym_identifier] = ACTIONS(5207),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1958] = {
    [anon_sym_EQ] = ACTIONS(2634),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2634),
    [sym__automatic_semicolon] = ACTIONS(2634),
  },
  [1959] = {
    [sym_jsx_element] = STATE(2263),
    [sym_jsx_fragment] = STATE(2263),
    [sym_jsx_expression] = STATE(2263),
    [sym_jsx_opening_element] = STATE(1975),
    [sym_jsx_self_closing_element] = STATE(2263),
    [sym_string] = STATE(2263),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5209),
    [anon_sym_DQUOTE] = ACTIONS(5211),
    [anon_sym_SQUOTE] = ACTIONS(5213),
    [sym_comment] = ACTIONS(3),
  },
  [1960] = {
    [sym_jsx_element] = STATE(2260),
    [sym_jsx_fragment] = STATE(2260),
    [sym_jsx_expression] = STATE(2260),
    [sym_jsx_opening_element] = STATE(1975),
    [sym_jsx_self_closing_element] = STATE(2260),
    [sym_string] = STATE(2260),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_LT] = ACTIONS(5209),
    [anon_sym_DQUOTE] = ACTIONS(5211),
    [anon_sym_SQUOTE] = ACTIONS(5213),
    [sym_comment] = ACTIONS(3),
  },
  [1961] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1977),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5071),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1962] = {
    [anon_sym_EQ] = ACTIONS(2559),
    [anon_sym_LBRACE] = ACTIONS(2559),
    [anon_sym_COMMA] = ACTIONS(2559),
    [anon_sym_RBRACE] = ACTIONS(2559),
    [anon_sym_SEMI] = ACTIONS(2559),
    [anon_sym_LBRACK] = ACTIONS(2559),
    [anon_sym_AMP] = ACTIONS(2559),
    [anon_sym_PIPE] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2559),
    [sym__automatic_semicolon] = ACTIONS(2559),
  },
  [1963] = {
    [sym_class_heritage] = STATE(2951),
    [sym_class_body] = STATE(1417),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2060),
    [sym_identifier] = ACTIONS(5215),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1964] = {
    [sym_class_heritage] = STATE(2895),
    [sym_class_body] = STATE(1549),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2109),
    [sym_identifier] = ACTIONS(5217),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5185),
    [anon_sym_extends] = ACTIONS(5187),
  },
  [1965] = {
    [anon_sym_EQ] = ACTIONS(2460),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2460),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2460),
    [sym__automatic_semicolon] = ACTIONS(2460),
  },
  [1966] = {
    [anon_sym_EQ] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2622),
    [sym__automatic_semicolon] = ACTIONS(2622),
  },
  [1967] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2013),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5069),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1968] = {
    [anon_sym_EQ] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(5199),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_PIPE] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2480),
    [sym__automatic_semicolon] = ACTIONS(2480),
  },
  [1969] = {
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(3668),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(3616),
  },
  [1970] = {
    [anon_sym_EQ] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2498),
    [anon_sym_PIPE] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2498),
    [sym__automatic_semicolon] = ACTIONS(2498),
  },
  [1971] = {
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2468),
    [sym__automatic_semicolon] = ACTIONS(2468),
  },
  [1972] = {
    [anon_sym_EQ] = ACTIONS(617),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_COMMA] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(617),
    [sym__automatic_semicolon] = ACTIONS(617),
  },
  [1973] = {
    [sym_import_clause] = STATE(2777),
    [sym_namespace_import] = STATE(3028),
    [sym_named_imports] = STATE(3028),
    [sym_string] = STATE(2776),
    [sym_import_require_clause] = STATE(2776),
    [sym_identifier] = ACTIONS(5219),
    [anon_sym_STAR] = ACTIONS(5221),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
  },
  [1974] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1999),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5223),
    [anon_sym_SLASH] = ACTIONS(5225),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1975] = {
    [sym_jsx_element] = STATE(2000),
    [sym_jsx_expression] = STATE(2000),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(2447),
    [sym_jsx_self_closing_element] = STATE(2000),
    [aux_sym_jsx_element_repeat1] = STATE(2000),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5229),
    [sym_jsx_text] = ACTIONS(5231),
    [sym_comment] = ACTIONS(5233),
  },
  [1976] = {
    [sym_class_heritage] = STATE(2917),
    [sym_class_body] = STATE(1455),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2057),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1977] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1999),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5223),
    [anon_sym_SLASH] = ACTIONS(5239),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1978] = {
    [sym_class_heritage] = STATE(2968),
    [sym_class_body] = STATE(129),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2059),
    [anon_sym_LBRACE] = ACTIONS(5241),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1979] = {
    [sym_jsx_element] = STATE(2001),
    [sym_jsx_expression] = STATE(2001),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(1058),
    [sym_jsx_self_closing_element] = STATE(2001),
    [aux_sym_jsx_element_repeat1] = STATE(2001),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5243),
    [sym_jsx_text] = ACTIONS(5245),
    [sym_comment] = ACTIONS(5233),
  },
  [1980] = {
    [sym_class_heritage] = STATE(2929),
    [sym_class_body] = STATE(507),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2043),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1981] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2013),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5069),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1982] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1974),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5061),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1983] = {
    [sym_class_heritage] = STATE(2823),
    [sym_class_body] = STATE(1081),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2058),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1984] = {
    [sym_class_heritage] = STATE(2794),
    [sym_class_body] = STATE(1672),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2110),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1985] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(1481),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5249),
    [sym_jsx_text] = ACTIONS(5251),
    [sym_comment] = ACTIONS(5233),
  },
  [1986] = {
    [sym_jsx_element] = STATE(1987),
    [sym_jsx_expression] = STATE(1987),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(1685),
    [sym_jsx_self_closing_element] = STATE(1987),
    [aux_sym_jsx_element_repeat1] = STATE(1987),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5253),
    [sym_jsx_text] = ACTIONS(5255),
    [sym_comment] = ACTIONS(5233),
  },
  [1987] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(1664),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5253),
    [sym_jsx_text] = ACTIONS(5251),
    [sym_comment] = ACTIONS(5233),
  },
  [1988] = {
    [sym_class_heritage] = STATE(2758),
    [sym_class_body] = STATE(2226),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2038),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1989] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1999),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5223),
    [anon_sym_SLASH] = ACTIONS(5257),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1990] = {
    [sym__initializer] = STATE(2562),
    [sym_type_annotation] = STATE(2420),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5108),
    [anon_sym_SEMI] = ACTIONS(5108),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_QMARK] = ACTIONS(5112),
    [anon_sym_BANG] = ACTIONS(5112),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5108),
  },
  [1991] = {
    [sym_class_heritage] = STATE(2856),
    [sym_class_body] = STATE(1597),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2100),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1992] = {
    [sym_class_heritage] = STATE(2763),
    [sym_class_body] = STATE(1396),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2082),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1993] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(2650),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5259),
    [sym_jsx_text] = ACTIONS(5251),
    [sym_comment] = ACTIONS(5233),
  },
  [1994] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1977),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5071),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [1995] = {
    [sym__initializer] = STATE(2582),
    [sym_type_annotation] = STATE(2386),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5083),
    [anon_sym_SEMI] = ACTIONS(5083),
    [anon_sym_COLON] = ACTIONS(3282),
    [anon_sym_QMARK] = ACTIONS(5087),
    [anon_sym_BANG] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5083),
  },
  [1996] = {
    [sym_class_heritage] = STATE(2906),
    [sym_class_body] = STATE(520),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2106),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1997] = {
    [sym_class_heritage] = STATE(2825),
    [sym_class_body] = STATE(1411),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2091),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1998] = {
    [sym_class_heritage] = STATE(2957),
    [sym_class_body] = STATE(587),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2112),
    [anon_sym_LBRACE] = ACTIONS(5261),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [1999] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1999),
    [sym_identifier] = ACTIONS(5263),
    [anon_sym_LBRACE] = ACTIONS(5266),
    [anon_sym_GT] = ACTIONS(5269),
    [anon_sym_SLASH] = ACTIONS(5271),
    [sym_jsx_identifier] = ACTIONS(5273),
    [sym_comment] = ACTIONS(3),
  },
  [2000] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(2401),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5229),
    [sym_jsx_text] = ACTIONS(5251),
    [sym_comment] = ACTIONS(5233),
  },
  [2001] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(1047),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5243),
    [sym_jsx_text] = ACTIONS(5251),
    [sym_comment] = ACTIONS(5233),
  },
  [2002] = {
    [sym_class_heritage] = STATE(2802),
    [sym_class_body] = STATE(2352),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2087),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2003] = {
    [sym_jsx_element] = STATE(1985),
    [sym_jsx_expression] = STATE(1985),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(1477),
    [sym_jsx_self_closing_element] = STATE(1985),
    [aux_sym_jsx_element_repeat1] = STATE(1985),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5249),
    [sym_jsx_text] = ACTIONS(5276),
    [sym_comment] = ACTIONS(5233),
  },
  [2004] = {
    [sym_jsx_element] = STATE(1993),
    [sym_jsx_expression] = STATE(1993),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_closing_element] = STATE(2637),
    [sym_jsx_self_closing_element] = STATE(1993),
    [aux_sym_jsx_element_repeat1] = STATE(1993),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5259),
    [sym_jsx_text] = ACTIONS(5278),
    [sym_comment] = ACTIONS(5233),
  },
  [2005] = {
    [sym_class_heritage] = STATE(2920),
    [sym_class_body] = STATE(1557),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2042),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2006] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2014),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5134),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2007] = {
    [sym_class_heritage] = STATE(2801),
    [sym_class_body] = STATE(1049),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2102),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2008] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1989),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5130),
    [anon_sym_SLASH] = ACTIONS(5132),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2009] = {
    [sym_type_arguments] = STATE(425),
    [anon_sym_else] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(5280),
    [anon_sym_DOT] = ACTIONS(5073),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_PIPE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(5282),
  },
  [2010] = {
    [anon_sym_EQ] = ACTIONS(5284),
    [anon_sym_LBRACE] = ACTIONS(5284),
    [anon_sym_COMMA] = ACTIONS(5284),
    [anon_sym_RBRACE] = ACTIONS(5284),
    [anon_sym_SEMI] = ACTIONS(5284),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5284),
    [sym__automatic_semicolon] = ACTIONS(5284),
  },
  [2011] = {
    [sym_class_heritage] = STATE(2971),
    [sym_class_body] = STATE(139),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2039),
    [anon_sym_LBRACE] = ACTIONS(5241),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2012] = {
    [sym_class_heritage] = STATE(2786),
    [sym_class_body] = STATE(2339),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [sym_type_parameters] = STATE(2090),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2013] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1999),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5223),
    [anon_sym_SLASH] = ACTIONS(5286),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2014] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1999),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5223),
    [anon_sym_SLASH] = ACTIONS(5288),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2015] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5290),
    [sym_jsx_text] = ACTIONS(5251),
    [sym_comment] = ACTIONS(5233),
  },
  [2016] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(2035),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5292),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2017] = {
    [aux_sym_object_repeat1] = STATE(2719),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [2018] = {
    [sym_type_annotation] = STATE(2164),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_COMMA] = ACTIONS(5294),
    [anon_sym_RBRACE] = ACTIONS(5294),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5294),
    [sym__automatic_semicolon] = ACTIONS(5294),
  },
  [2019] = {
    [aux_sym_object_repeat1] = STATE(2718),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [2020] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5296),
    [anon_sym_LT] = ACTIONS(5299),
    [sym_jsx_text] = ACTIONS(5302),
    [sym_comment] = ACTIONS(5233),
  },
  [2021] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5305),
    [sym_jsx_text] = ACTIONS(5251),
    [sym_comment] = ACTIONS(5233),
  },
  [2022] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5307),
    [sym_jsx_text] = ACTIONS(5251),
    [sym_comment] = ACTIONS(5233),
  },
  [2023] = {
    [anon_sym_EQ] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_PIPE] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
  },
  [2024] = {
    [sym_jsx_element] = STATE(2025),
    [sym_jsx_expression] = STATE(2025),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_self_closing_element] = STATE(2025),
    [aux_sym_jsx_element_repeat1] = STATE(2025),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5309),
    [sym_jsx_text] = ACTIONS(5311),
    [sym_comment] = ACTIONS(5233),
  },
  [2025] = {
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_expression] = STATE(2020),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_self_closing_element] = STATE(2020),
    [aux_sym_jsx_element_repeat1] = STATE(2020),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5313),
    [sym_jsx_text] = ACTIONS(5251),
    [sym_comment] = ACTIONS(5233),
  },
  [2026] = {
    [sym_jsx_element] = STATE(2022),
    [sym_jsx_expression] = STATE(2022),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_self_closing_element] = STATE(2022),
    [aux_sym_jsx_element_repeat1] = STATE(2022),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5315),
    [sym_jsx_text] = ACTIONS(5317),
    [sym_comment] = ACTIONS(5233),
  },
  [2027] = {
    [aux_sym_object_repeat1] = STATE(2671),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [2028] = {
    [aux_sym_object_repeat1] = STATE(2645),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [2029] = {
    [anon_sym_EQ] = ACTIONS(3578),
    [anon_sym_COMMA] = ACTIONS(3578),
    [anon_sym_RPAREN] = ACTIONS(5319),
    [anon_sym_COLON] = ACTIONS(3578),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_QMARK] = ACTIONS(3578),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
  },
  [2030] = {
    [sym_statement_block] = STATE(2244),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1095),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [2031] = {
    [anon_sym_EQ] = ACTIONS(658),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_RPAREN] = ACTIONS(5324),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_QMARK] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(617),
    [anon_sym_PIPE] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
  },
  [2032] = {
    [sym_jsx_element] = STATE(2021),
    [sym_jsx_expression] = STATE(2021),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_self_closing_element] = STATE(2021),
    [aux_sym_jsx_element_repeat1] = STATE(2021),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5327),
    [sym_jsx_text] = ACTIONS(5329),
    [sym_comment] = ACTIONS(5233),
  },
  [2033] = {
    [sym_jsx_element] = STATE(2015),
    [sym_jsx_expression] = STATE(2015),
    [sym_jsx_opening_element] = STATE(2004),
    [sym_jsx_self_closing_element] = STATE(2015),
    [aux_sym_jsx_element_repeat1] = STATE(2015),
    [anon_sym_LBRACE] = ACTIONS(5227),
    [anon_sym_LT] = ACTIONS(5331),
    [sym_jsx_text] = ACTIONS(5333),
    [sym_comment] = ACTIONS(5233),
  },
  [2034] = {
    [sym_type_annotation] = STATE(2193),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COMMA] = ACTIONS(5335),
    [anon_sym_RBRACE] = ACTIONS(5335),
    [anon_sym_SEMI] = ACTIONS(5335),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5335),
    [sym__automatic_semicolon] = ACTIONS(5335),
  },
  [2035] = {
    [sym_jsx_expression] = STATE(2444),
    [sym_jsx_namespace_name] = STATE(2116),
    [sym_jsx_attribute] = STATE(2444),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1999),
    [sym_identifier] = ACTIONS(5046),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_GT] = ACTIONS(5337),
    [sym_jsx_identifier] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2036] = {
    [aux_sym_object_repeat1] = STATE(2602),
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [2037] = {
    [sym_default_type] = STATE(2798),
    [sym_constraint] = STATE(2532),
    [anon_sym_EQ] = ACTIONS(5048),
    [anon_sym_COMMA] = ACTIONS(5052),
    [anon_sym_COLON] = ACTIONS(5339),
    [anon_sym_GT] = ACTIONS(5052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5339),
  },
  [2038] = {
    [sym_class_heritage] = STATE(2878),
    [sym_class_body] = STATE(2251),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2039] = {
    [sym_class_heritage] = STATE(2859),
    [sym_class_body] = STATE(116),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2040] = {
    [sym_nested_identifier] = STATE(2484),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [sym_identifier] = ACTIONS(5341),
    [anon_sym_DOT] = ACTIONS(5343),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [2041] = {
    [sym__call_signature] = STATE(2893),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5345),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2042] = {
    [sym_class_heritage] = STATE(2840),
    [sym_class_body] = STATE(1472),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2043] = {
    [sym_class_heritage] = STATE(2852),
    [sym_class_body] = STATE(521),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2044] = {
    [sym_type_arguments] = STATE(423),
    [anon_sym_else] = ACTIONS(2611),
    [anon_sym_while] = ACTIONS(2611),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_LT] = ACTIONS(5280),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_PIPE] = ACTIONS(2611),
    [sym_comment] = ACTIONS(3),
  },
  [2045] = {
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_COMMA] = ACTIONS(5351),
    [anon_sym_RBRACE] = ACTIONS(5351),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym_COLON] = ACTIONS(5351),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5351),
    [sym__automatic_semicolon] = ACTIONS(5351),
  },
  [2046] = {
    [sym_predefined_type] = STATE(3145),
    [anon_sym_void] = ACTIONS(5353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(5353),
    [anon_sym_number] = ACTIONS(5353),
    [anon_sym_boolean] = ACTIONS(5353),
    [anon_sym_string] = ACTIONS(5353),
    [anon_sym_symbol] = ACTIONS(5353),
  },
  [2047] = {
    [sym__initializer] = STATE(2577),
    [sym_type_annotation] = STATE(2314),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5158),
    [anon_sym_SEMI] = ACTIONS(5158),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5158),
  },
  [2048] = {
    [sym__call_signature] = STATE(2931),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5355),
    [anon_sym_STAR] = ACTIONS(5357),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2049] = {
    [sym__call_signature] = STATE(2893),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5359),
    [anon_sym_STAR] = ACTIONS(5361),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2050] = {
    [sym_predefined_type] = STATE(3087),
    [anon_sym_void] = ACTIONS(5353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(5353),
    [anon_sym_number] = ACTIONS(5353),
    [anon_sym_boolean] = ACTIONS(5353),
    [anon_sym_string] = ACTIONS(5353),
    [anon_sym_symbol] = ACTIONS(5353),
  },
  [2051] = {
    [sym__initializer] = STATE(2750),
    [sym_type_annotation] = STATE(2341),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(3275),
    [anon_sym_SEMI] = ACTIONS(3275),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3275),
  },
  [2052] = {
    [sym_statement_block] = STATE(2923),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5363),
    [sym__automatic_semicolon] = ACTIONS(5363),
  },
  [2053] = {
    [anon_sym_EQ] = ACTIONS(4276),
    [anon_sym_COMMA] = ACTIONS(4847),
    [anon_sym_RBRACE] = ACTIONS(4847),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_COLON] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [2054] = {
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_COMMA] = ACTIONS(5365),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [anon_sym_SEMI] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5365),
    [sym__automatic_semicolon] = ACTIONS(5365),
  },
  [2055] = {
    [sym__call_signature] = STATE(2805),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_COLON] = ACTIONS(5367),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5369),
    [sym_comment] = ACTIONS(3),
  },
  [2056] = {
    [sym_statement_block] = STATE(2925),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5371),
    [anon_sym_RBRACE] = ACTIONS(5371),
    [anon_sym_SEMI] = ACTIONS(5371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5371),
    [sym__automatic_semicolon] = ACTIONS(5371),
  },
  [2057] = {
    [sym_class_heritage] = STATE(2922),
    [sym_class_body] = STATE(1550),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2058] = {
    [sym_class_heritage] = STATE(2884),
    [sym_class_body] = STATE(1094),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2059] = {
    [sym_class_heritage] = STATE(2969),
    [sym_class_body] = STATE(119),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2060] = {
    [sym_class_heritage] = STATE(2972),
    [sym_class_body] = STATE(1543),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2061] = {
    [sym_extends_clause] = STATE(2748),
    [sym_object_type] = STATE(2212),
    [sym_type_parameters] = STATE(2267),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [anon_sym_LT] = ACTIONS(5373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5375),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [2062] = {
    [sym__call_signature] = STATE(2962),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5377),
    [anon_sym_STAR] = ACTIONS(5379),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2063] = {
    [sym_nested_identifier] = STATE(2030),
    [sym_string] = STATE(2070),
    [sym__module] = STATE(2372),
    [sym_identifier] = ACTIONS(5381),
    [anon_sym_DOT] = ACTIONS(5383),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
  },
  [2064] = {
    [sym_statement_block] = STATE(2767),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5385),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_SEMI] = ACTIONS(5385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5385),
    [sym__automatic_semicolon] = ACTIONS(5385),
  },
  [2065] = {
    [sym__initializer] = STATE(2555),
    [sym_type_annotation] = STATE(2311),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5152),
  },
  [2066] = {
    [sym_class_heritage] = STATE(2813),
    [sym_class_body] = STATE(1028),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2067] = {
    [sym__initializer] = STATE(2739),
    [sym_type_annotation] = STATE(2351),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(3851),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3851),
  },
  [2068] = {
    [sym__initializer] = STATE(2730),
    [sym_type_annotation] = STATE(2356),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3886),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3886),
  },
  [2069] = {
    [sym__initializer] = STATE(2557),
    [sym_type_annotation] = STATE(2435),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5169),
    [anon_sym_SEMI] = ACTIONS(5169),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5169),
  },
  [2070] = {
    [sym_statement_block] = STATE(2244),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1095),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [2071] = {
    [anon_sym_COMMA] = ACTIONS(2658),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2658),
    [sym__automatic_semicolon] = ACTIONS(2658),
  },
  [2072] = {
    [sym__initializer] = STATE(2618),
    [sym_type_annotation] = STATE(2359),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_SEMI] = ACTIONS(5167),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5167),
  },
  [2073] = {
    [anon_sym_LBRACE] = ACTIONS(5387),
    [anon_sym_COMMA] = ACTIONS(5387),
    [anon_sym_RBRACE] = ACTIONS(5387),
    [anon_sym_SEMI] = ACTIONS(5387),
    [anon_sym_COLON] = ACTIONS(5387),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5387),
    [sym__automatic_semicolon] = ACTIONS(5387),
  },
  [2074] = {
    [sym_type_annotation] = STATE(2325),
    [anon_sym_COMMA] = ACTIONS(5389),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_SEMI] = ACTIONS(5389),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5389),
    [sym__automatic_semicolon] = ACTIONS(5389),
  },
  [2075] = {
    [sym_statement_block] = STATE(2849),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5391),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_SEMI] = ACTIONS(5391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5391),
    [sym__automatic_semicolon] = ACTIONS(5391),
  },
  [2076] = {
    [sym__initializer] = STATE(2964),
    [sym_type_annotation] = STATE(2468),
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5395),
    [anon_sym_RPAREN] = ACTIONS(5395),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_QMARK] = ACTIONS(5397),
    [sym_comment] = ACTIONS(3),
  },
  [2077] = {
    [sym__call_signature] = STATE(2893),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5399),
    [anon_sym_STAR] = ACTIONS(5401),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2078] = {
    [sym_class_heritage] = STATE(2876),
    [sym_class_body] = STATE(1595),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2079] = {
    [sym__call_signature] = STATE(2874),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5403),
    [anon_sym_STAR] = ACTIONS(5405),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2080] = {
    [sym_statement_block] = STATE(2844),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_SEMI] = ACTIONS(5407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5407),
    [sym__automatic_semicolon] = ACTIONS(5407),
  },
  [2081] = {
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_RBRACE] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3880),
    [sym__automatic_semicolon] = ACTIONS(3880),
  },
  [2082] = {
    [sym_class_heritage] = STATE(2875),
    [sym_class_body] = STATE(1394),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2083] = {
    [sym_class_heritage] = STATE(2761),
    [sym_class_body] = STATE(1074),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2084] = {
    [sym__call_signature] = STATE(2931),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5411),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2085] = {
    [sym_statement_block] = STATE(2829),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5413),
    [anon_sym_RBRACE] = ACTIONS(5413),
    [anon_sym_SEMI] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5413),
    [sym__automatic_semicolon] = ACTIONS(5413),
  },
  [2086] = {
    [sym_variable_declarator] = STATE(2476),
    [sym_object] = STATE(2067),
    [sym_array] = STATE(2068),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LBRACE] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(5421),
  },
  [2087] = {
    [sym_class_heritage] = STATE(2759),
    [sym_class_body] = STATE(2220),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2088] = {
    [sym__call_signature] = STATE(2812),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_STAR] = ACTIONS(5425),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2089] = {
    [sym__call_signature] = STATE(2931),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5427),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2090] = {
    [sym_class_heritage] = STATE(2868),
    [sym_class_body] = STATE(2266),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2091] = {
    [sym_class_heritage] = STATE(2796),
    [sym_class_body] = STATE(1357),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2092] = {
    [sym_statement_block] = STATE(2822),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5431),
    [anon_sym_RBRACE] = ACTIONS(5431),
    [anon_sym_SEMI] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5431),
    [sym__automatic_semicolon] = ACTIONS(5431),
  },
  [2093] = {
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym_COLON] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5433),
    [sym__automatic_semicolon] = ACTIONS(5433),
  },
  [2094] = {
    [sym_class_heritage] = STATE(2775),
    [sym_class_body] = STATE(1648),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2095] = {
    [sym_nested_identifier] = STATE(491),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_DOT] = ACTIONS(5437),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [2096] = {
    [sym_extends_clause] = STATE(2708),
    [sym_object_type] = STATE(543),
    [sym_type_parameters] = STATE(2342),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [anon_sym_LT] = ACTIONS(5373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5375),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [2097] = {
    [sym_nested_identifier] = STATE(491),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_DOT] = ACTIONS(5439),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [2098] = {
    [sym_statement_block] = STATE(2820),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5441),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_SEMI] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5441),
    [sym__automatic_semicolon] = ACTIONS(5441),
  },
  [2099] = {
    [anon_sym_EQ] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5284),
    [anon_sym_COMMA] = ACTIONS(5284),
    [anon_sym_RPAREN] = ACTIONS(5284),
    [anon_sym_EQ_GT] = ACTIONS(5284),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2100] = {
    [sym_class_heritage] = STATE(2789),
    [sym_class_body] = STATE(1662),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2101] = {
    [sym_statement_block] = STATE(2818),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5445),
    [sym__automatic_semicolon] = ACTIONS(5445),
  },
  [2102] = {
    [sym_class_heritage] = STATE(2757),
    [sym_class_body] = STATE(1079),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2103] = {
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_EQ] = ACTIONS(5449),
    [anon_sym_LBRACE] = ACTIONS(5451),
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(5451),
    [anon_sym_SLASH] = ACTIONS(5447),
    [sym_jsx_identifier] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
  },
  [2104] = {
    [sym_statement_block] = STATE(2809),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5453),
    [anon_sym_RBRACE] = ACTIONS(5453),
    [anon_sym_SEMI] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5453),
    [sym__automatic_semicolon] = ACTIONS(5453),
  },
  [2105] = {
    [sym_statement_block] = STATE(2916),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5455),
    [anon_sym_RBRACE] = ACTIONS(5455),
    [anon_sym_SEMI] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5455),
    [sym__automatic_semicolon] = ACTIONS(5455),
  },
  [2106] = {
    [sym_class_heritage] = STATE(2934),
    [sym_class_body] = STATE(496),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2107] = {
    [sym_type_annotation] = STATE(2410),
    [anon_sym_COMMA] = ACTIONS(5457),
    [anon_sym_RBRACE] = ACTIONS(5457),
    [anon_sym_SEMI] = ACTIONS(5457),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5457),
    [sym__automatic_semicolon] = ACTIONS(5457),
  },
  [2108] = {
    [sym_variable_declarator] = STATE(2520),
    [sym_object] = STATE(2067),
    [sym_array] = STATE(2068),
    [sym_identifier] = ACTIONS(5415),
    [anon_sym_LBRACE] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(5459),
  },
  [2109] = {
    [sym_class_heritage] = STATE(2939),
    [sym_class_body] = STATE(1495),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2110] = {
    [sym_class_heritage] = STATE(2797),
    [sym_class_body] = STATE(1573),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2111] = {
    [sym_statement_block] = STATE(2778),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(5461),
    [anon_sym_RBRACE] = ACTIONS(5461),
    [anon_sym_SEMI] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5461),
    [sym__automatic_semicolon] = ACTIONS(5461),
  },
  [2112] = {
    [sym_class_heritage] = STATE(2866),
    [sym_class_body] = STATE(561),
    [sym_implements_clause] = STATE(3008),
    [sym_extends_clause] = STATE(2678),
    [anon_sym_LBRACE] = ACTIONS(5261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
    [anon_sym_extends] = ACTIONS(5237),
  },
  [2113] = {
    [sym__call_signature] = STATE(2854),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5463),
    [anon_sym_STAR] = ACTIONS(5465),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2114] = {
    [sym__call_signature] = STATE(2101),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5467),
    [sym_comment] = ACTIONS(3),
  },
  [2115] = {
    [sym_template_substitution] = STATE(2190),
    [aux_sym_template_string_repeat1] = STATE(2190),
    [sym_escape_sequence] = ACTIONS(5469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5473),
    [sym__template_chars] = ACTIONS(5469),
  },
  [2116] = {
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_EQ] = ACTIONS(5477),
    [anon_sym_LBRACE] = ACTIONS(5479),
    [anon_sym_GT] = ACTIONS(5479),
    [anon_sym_SLASH] = ACTIONS(5475),
    [sym_jsx_identifier] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
  },
  [2117] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5481),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_SEMI] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3693),
    [sym__automatic_semicolon] = ACTIONS(5481),
  },
  [2118] = {
    [aux_sym_object_type_repeat1] = STATE(2123),
    [anon_sym_COMMA] = ACTIONS(5481),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_SEMI] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3693),
    [sym__automatic_semicolon] = ACTIONS(5481),
  },
  [2119] = {
    [sym__call_signature] = STATE(2779),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
  },
  [2120] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5485),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_SEMI] = ACTIONS(5485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5488),
    [sym__automatic_semicolon] = ACTIONS(5485),
  },
  [2121] = {
    [sym_variable_declarator] = STATE(2520),
    [sym_object] = STATE(2067),
    [sym_array] = STATE(2068),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACE] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
  },
  [2122] = {
    [sym_variable_declarator] = STATE(2472),
    [sym_object] = STATE(2067),
    [sym_array] = STATE(2068),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACE] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
  },
  [2123] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5492),
    [anon_sym_RBRACE] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(5492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3699),
    [sym__automatic_semicolon] = ACTIONS(5492),
  },
  [2124] = {
    [sym__call_signature] = STATE(2344),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5494),
    [sym_comment] = ACTIONS(3),
  },
  [2125] = {
    [aux_sym_object_type_repeat1] = STATE(2135),
    [anon_sym_COMMA] = ACTIONS(5496),
    [anon_sym_RBRACE] = ACTIONS(3687),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3687),
    [sym__automatic_semicolon] = ACTIONS(5496),
  },
  [2126] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5496),
    [anon_sym_RBRACE] = ACTIONS(3687),
    [anon_sym_SEMI] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3687),
    [sym__automatic_semicolon] = ACTIONS(5496),
  },
  [2127] = {
    [sym__import_export_specifier] = STATE(2716),
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_COMMA] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_typeof] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
  },
  [2128] = {
    [sym__call_signature] = STATE(2808),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2129] = {
    [sym_nested_identifier] = STATE(491),
    [sym_string] = STATE(509),
    [sym__module] = STATE(548),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [2130] = {
    [sym_switch_case] = STATE(2130),
    [sym_switch_default] = STATE(2130),
    [aux_sym_switch_body_repeat1] = STATE(2130),
    [anon_sym_default] = ACTIONS(5508),
    [anon_sym_RBRACE] = ACTIONS(5511),
    [anon_sym_case] = ACTIONS(5513),
    [sym_comment] = ACTIONS(3),
  },
  [2131] = {
    [aux_sym_object_type_repeat1] = STATE(2117),
    [anon_sym_COMMA] = ACTIONS(5516),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_SEMI] = ACTIONS(5516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5518),
    [sym__automatic_semicolon] = ACTIONS(5516),
  },
  [2132] = {
    [sym_type_arguments] = STATE(2689),
    [aux_sym_extends_clause_repeat1] = STATE(2535),
    [anon_sym_LBRACE] = ACTIONS(3905),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(5520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
  },
  [2133] = {
    [sym__call_signature] = STATE(2819),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
  },
  [2134] = {
    [sym__call_signature] = STATE(2411),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5524),
    [sym_comment] = ACTIONS(3),
  },
  [2135] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3695),
    [sym__automatic_semicolon] = ACTIONS(5526),
  },
  [2136] = {
    [aux_sym_object_type_repeat1] = STATE(2140),
    [anon_sym_COMMA] = ACTIONS(5528),
    [anon_sym_RBRACE] = ACTIONS(5530),
    [anon_sym_SEMI] = ACTIONS(5528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5530),
    [sym__automatic_semicolon] = ACTIONS(5528),
  },
  [2137] = {
    [sym_nested_identifier] = STATE(1898),
    [sym_jsx_namespace_name] = STATE(1981),
    [sym_type_parameter] = STATE(2661),
    [sym_identifier] = ACTIONS(5532),
    [anon_sym_GT] = ACTIONS(5534),
    [sym_jsx_identifier] = ACTIONS(5536),
    [sym_comment] = ACTIONS(3),
  },
  [2138] = {
    [aux_sym_object_type_repeat1] = STATE(2141),
    [anon_sym_COMMA] = ACTIONS(5538),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(5538),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3691),
    [sym__automatic_semicolon] = ACTIONS(5538),
  },
  [2139] = {
    [sym__call_signature] = STATE(2565),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5540),
    [sym_comment] = ACTIONS(3),
  },
  [2140] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5538),
    [anon_sym_RBRACE] = ACTIONS(3691),
    [anon_sym_SEMI] = ACTIONS(5538),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3691),
    [sym__automatic_semicolon] = ACTIONS(5538),
  },
  [2141] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5542),
    [anon_sym_RBRACE] = ACTIONS(3689),
    [anon_sym_SEMI] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3689),
    [sym__automatic_semicolon] = ACTIONS(5542),
  },
  [2142] = {
    [sym_template_substitution] = STATE(2190),
    [aux_sym_template_string_repeat1] = STATE(2190),
    [sym_escape_sequence] = ACTIONS(5469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5473),
    [sym__template_chars] = ACTIONS(5469),
  },
  [2143] = {
    [sym__call_signature] = STATE(2873),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5546),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2144] = {
    [sym_nested_identifier] = STATE(491),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [sym_identifier] = ACTIONS(5435),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [2145] = {
    [sym_template_substitution] = STATE(2200),
    [aux_sym_template_string_repeat1] = STATE(2200),
    [sym_escape_sequence] = ACTIONS(5548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5473),
    [sym__template_chars] = ACTIONS(5548),
  },
  [2146] = {
    [sym__initializer] = STATE(2946),
    [sym_type_annotation] = STATE(2503),
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5552),
    [anon_sym_RPAREN] = ACTIONS(5552),
    [anon_sym_COLON] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
  },
  [2147] = {
    [sym__call_signature] = STATE(2092),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5554),
    [sym_comment] = ACTIONS(3),
  },
  [2148] = {
    [sym_nested_identifier] = STATE(2030),
    [sym_string] = STATE(2070),
    [sym__module] = STATE(2302),
    [sym_identifier] = ACTIONS(5381),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
  },
  [2149] = {
    [sym__call_signature] = STATE(2569),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5556),
    [sym_comment] = ACTIONS(3),
  },
  [2150] = {
    [sym__call_signature] = STATE(2320),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
  },
  [2151] = {
    [sym_nested_identifier] = STATE(2030),
    [sym_string] = STATE(2070),
    [sym__module] = STATE(2372),
    [sym_identifier] = ACTIONS(5381),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
  },
  [2152] = {
    [aux_sym_object_type_repeat1] = STATE(2126),
    [anon_sym_COMMA] = ACTIONS(5560),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [anon_sym_SEMI] = ACTIONS(5560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5562),
    [sym__automatic_semicolon] = ACTIONS(5560),
  },
  [2153] = {
    [aux_sym_object_type_repeat1] = STATE(2171),
    [anon_sym_COMMA] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_SEMI] = ACTIONS(5564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5566),
    [sym__automatic_semicolon] = ACTIONS(5564),
  },
  [2154] = {
    [sym_template_substitution] = STATE(2142),
    [aux_sym_template_string_repeat1] = STATE(2142),
    [sym_escape_sequence] = ACTIONS(5568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5473),
    [sym__template_chars] = ACTIONS(5568),
  },
  [2155] = {
    [sym_type_arguments] = STATE(423),
    [aux_sym_extends_clause_repeat1] = STATE(2507),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_LT] = ACTIONS(5280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(3935),
  },
  [2156] = {
    [sym__call_signature] = STATE(2221),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5572),
    [sym_comment] = ACTIONS(3),
  },
  [2157] = {
    [sym_nested_identifier] = STATE(1888),
    [sym_jsx_namespace_name] = STATE(1982),
    [sym_type_parameter] = STATE(2661),
    [sym_identifier] = ACTIONS(5574),
    [anon_sym_GT] = ACTIONS(5576),
    [sym_jsx_identifier] = ACTIONS(5578),
    [sym_comment] = ACTIONS(3),
  },
  [2158] = {
    [sym__call_signature] = STATE(2756),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5580),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2159] = {
    [sym__call_signature] = STATE(2756),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5582),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2160] = {
    [sym__call_signature] = STATE(2924),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5584),
    [sym_comment] = ACTIONS(3),
  },
  [2161] = {
    [sym__call_signature] = STATE(2292),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
  },
  [2162] = {
    [anon_sym_EQ] = ACTIONS(4548),
    [anon_sym_COMMA] = ACTIONS(4548),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_LPAREN] = ACTIONS(4548),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_QMARK] = ACTIONS(4548),
    [sym_comment] = ACTIONS(3),
  },
  [2163] = {
    [aux_sym_object_type_repeat1] = STATE(2172),
    [anon_sym_COMMA] = ACTIONS(5588),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_SEMI] = ACTIONS(5588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3675),
    [sym__automatic_semicolon] = ACTIONS(5588),
  },
  [2164] = {
    [anon_sym_LBRACE] = ACTIONS(5590),
    [anon_sym_COMMA] = ACTIONS(5590),
    [anon_sym_RBRACE] = ACTIONS(5590),
    [anon_sym_SEMI] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5590),
    [sym__automatic_semicolon] = ACTIONS(5590),
  },
  [2165] = {
    [sym__call_signature] = STATE(2422),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
  },
  [2166] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(3683),
    [anon_sym_SEMI] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3683),
    [sym__automatic_semicolon] = ACTIONS(5594),
  },
  [2167] = {
    [sym__call_signature] = STATE(2111),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5596),
    [sym_comment] = ACTIONS(3),
  },
  [2168] = {
    [sym_nested_identifier] = STATE(2484),
    [sym_string] = STATE(509),
    [sym__module] = STATE(548),
    [sym_identifier] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [2169] = {
    [anon_sym_LBRACE] = ACTIONS(5598),
    [anon_sym_COMMA] = ACTIONS(5598),
    [anon_sym_RBRACK] = ACTIONS(5598),
    [anon_sym_GT] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2170] = {
    [sym_nested_identifier] = STATE(1901),
    [sym_jsx_namespace_name] = STATE(1994),
    [sym_type_parameter] = STATE(2661),
    [sym_identifier] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5602),
    [sym_jsx_identifier] = ACTIONS(5604),
    [sym_comment] = ACTIONS(3),
  },
  [2171] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5588),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_SEMI] = ACTIONS(5588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3675),
    [sym__automatic_semicolon] = ACTIONS(5588),
  },
  [2172] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5606),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_SEMI] = ACTIONS(5606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3697),
    [sym__automatic_semicolon] = ACTIONS(5606),
  },
  [2173] = {
    [sym_switch_case] = STATE(2187),
    [sym_switch_default] = STATE(2187),
    [aux_sym_switch_body_repeat1] = STATE(2187),
    [anon_sym_default] = ACTIONS(5608),
    [anon_sym_RBRACE] = ACTIONS(5610),
    [anon_sym_case] = ACTIONS(5612),
    [sym_comment] = ACTIONS(3),
  },
  [2174] = {
    [aux_sym_object_type_repeat1] = STATE(2120),
    [anon_sym_COMMA] = ACTIONS(5614),
    [anon_sym_RBRACE] = ACTIONS(3685),
    [anon_sym_SEMI] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3685),
    [sym__automatic_semicolon] = ACTIONS(5614),
  },
  [2175] = {
    [aux_sym_object_type_repeat1] = STATE(2166),
    [anon_sym_COMMA] = ACTIONS(5614),
    [anon_sym_RBRACE] = ACTIONS(3685),
    [anon_sym_SEMI] = ACTIONS(5614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3685),
    [sym__automatic_semicolon] = ACTIONS(5614),
  },
  [2176] = {
    [sym__import_export_specifier] = STATE(2744),
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_COMMA] = ACTIONS(5616),
    [anon_sym_RBRACE] = ACTIONS(5618),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_typeof] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
  },
  [2177] = {
    [sym_identifier] = ACTIONS(5089),
    [anon_sym_EQ] = ACTIONS(5091),
    [anon_sym_LBRACE] = ACTIONS(5091),
    [anon_sym_GT] = ACTIONS(5091),
    [anon_sym_SLASH] = ACTIONS(5089),
    [sym_jsx_identifier] = ACTIONS(5091),
    [sym_comment] = ACTIONS(3),
  },
  [2178] = {
    [sym_variable_declarator] = STATE(2684),
    [sym_object] = STATE(2067),
    [sym_array] = STATE(2068),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACE] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
  },
  [2179] = {
    [sym_variable_declarator] = STATE(2469),
    [sym_object] = STATE(2067),
    [sym_array] = STATE(2068),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACE] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
  },
  [2180] = {
    [sym__call_signature] = STATE(2080),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
  },
  [2181] = {
    [sym_variable_declarator] = STATE(2476),
    [sym_object] = STATE(2067),
    [sym_array] = STATE(2068),
    [sym_identifier] = ACTIONS(5490),
    [anon_sym_LBRACE] = ACTIONS(5417),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
  },
  [2182] = {
    [sym_template_substitution] = STATE(2115),
    [aux_sym_template_string_repeat1] = STATE(2115),
    [sym_escape_sequence] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5473),
    [sym__template_chars] = ACTIONS(5622),
  },
  [2183] = {
    [sym__call_signature] = STATE(2888),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2184] = {
    [sym__call_signature] = STATE(2274),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
  },
  [2185] = {
    [aux_sym_object_type_repeat1] = STATE(2174),
    [anon_sym_COMMA] = ACTIONS(5630),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5632),
    [sym__automatic_semicolon] = ACTIONS(5630),
  },
  [2186] = {
    [sym__call_signature] = STATE(2269),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5634),
    [sym_comment] = ACTIONS(3),
  },
  [2187] = {
    [sym_switch_case] = STATE(2130),
    [sym_switch_default] = STATE(2130),
    [aux_sym_switch_body_repeat1] = STATE(2130),
    [anon_sym_default] = ACTIONS(5608),
    [anon_sym_RBRACE] = ACTIONS(5636),
    [anon_sym_case] = ACTIONS(5612),
    [sym_comment] = ACTIONS(3),
  },
  [2188] = {
    [sym__call_signature] = STATE(2056),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5638),
    [sym_comment] = ACTIONS(3),
  },
  [2189] = {
    [sym__call_signature] = STATE(2888),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2190] = {
    [sym_template_substitution] = STATE(2190),
    [aux_sym_template_string_repeat1] = STATE(2190),
    [sym_escape_sequence] = ACTIONS(5642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5647),
    [sym__template_chars] = ACTIONS(5642),
  },
  [2191] = {
    [sym_nested_identifier] = STATE(2484),
    [sym_string] = STATE(509),
    [sym__module] = STATE(534),
    [sym_identifier] = ACTIONS(5341),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [2192] = {
    [sym__call_signature] = STATE(2247),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5650),
    [sym_comment] = ACTIONS(3),
  },
  [2193] = {
    [anon_sym_LBRACE] = ACTIONS(5652),
    [anon_sym_COMMA] = ACTIONS(5652),
    [anon_sym_RBRACE] = ACTIONS(5652),
    [anon_sym_SEMI] = ACTIONS(5652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5652),
    [sym__automatic_semicolon] = ACTIONS(5652),
  },
  [2194] = {
    [sym__call_signature] = STATE(2888),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5654),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2195] = {
    [sym__call_signature] = STATE(2843),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5656),
    [sym_comment] = ACTIONS(3),
  },
  [2196] = {
    [sym__call_signature] = STATE(2788),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5658),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2197] = {
    [sym__call_signature] = STATE(2841),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5660),
    [sym_comment] = ACTIONS(3),
  },
  [2198] = {
    [sym__call_signature] = STATE(2811),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2199] = {
    [anon_sym_EQ] = ACTIONS(3616),
    [anon_sym_COMMA] = ACTIONS(3616),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [2200] = {
    [sym_template_substitution] = STATE(2190),
    [aux_sym_template_string_repeat1] = STATE(2190),
    [sym_escape_sequence] = ACTIONS(5469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5473),
    [sym__template_chars] = ACTIONS(5469),
  },
  [2201] = {
    [sym__call_signature] = STATE(2416),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(5666),
    [sym_comment] = ACTIONS(3),
  },
  [2202] = {
    [sym__call_signature] = STATE(2756),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [sym_identifier] = ACTIONS(5668),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2203] = {
    [anon_sym_COMMA] = ACTIONS(5670),
    [anon_sym_RBRACE] = ACTIONS(5670),
    [anon_sym_SEMI] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5670),
    [sym__automatic_semicolon] = ACTIONS(5670),
  },
  [2204] = {
    [sym__call_signature] = STATE(2098),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2205] = {
    [sym__call_signature] = STATE(2965),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2206] = {
    [sym__call_signature] = STATE(2387),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2207] = {
    [sym__call_signature] = STATE(2795),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2208] = {
    [sym_identifier] = ACTIONS(5672),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5674),
    [anon_sym_SLASH] = ACTIONS(5672),
    [sym_jsx_identifier] = ACTIONS(5674),
    [sym_comment] = ACTIONS(3),
  },
  [2209] = {
    [sym__call_signature] = STATE(2491),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2210] = {
    [anon_sym_COMMA] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_SEMI] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2858),
    [sym__automatic_semicolon] = ACTIONS(2858),
  },
  [2211] = {
    [anon_sym_EQ] = ACTIONS(5676),
    [anon_sym_LBRACE] = ACTIONS(5676),
    [anon_sym_LPAREN] = ACTIONS(5676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5676),
    [anon_sym_extends] = ACTIONS(5676),
  },
  [2212] = {
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_SEMI] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2786),
    [sym__automatic_semicolon] = ACTIONS(2786),
  },
  [2213] = {
    [anon_sym_COMMA] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2778),
    [sym__automatic_semicolon] = ACTIONS(2778),
  },
  [2214] = {
    [anon_sym_COMMA] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_SEMI] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2814),
    [sym__automatic_semicolon] = ACTIONS(2814),
  },
  [2215] = {
    [anon_sym_COMMA] = ACTIONS(5678),
    [anon_sym_RBRACE] = ACTIONS(5678),
    [anon_sym_SEMI] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5678),
    [sym__automatic_semicolon] = ACTIONS(5678),
  },
  [2216] = {
    [anon_sym_COMMA] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_SEMI] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2738),
    [sym__automatic_semicolon] = ACTIONS(2738),
  },
  [2217] = {
    [sym__call_signature] = STATE(2787),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2218] = {
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1171),
    [sym__automatic_semicolon] = ACTIONS(1171),
  },
  [2219] = {
    [anon_sym_COMMA] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2830),
    [sym__automatic_semicolon] = ACTIONS(2830),
  },
  [2220] = {
    [anon_sym_COMMA] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1139),
    [sym__automatic_semicolon] = ACTIONS(1139),
  },
  [2221] = {
    [sym_statement_block] = STATE(1788),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_SEMI] = ACTIONS(5407),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5407),
  },
  [2222] = {
    [sym__call_signature] = STATE(2921),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2223] = {
    [sym__call_signature] = STATE(2909),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2224] = {
    [sym__call_signature] = STATE(2502),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2225] = {
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_COMMA] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_DOT] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2394),
  },
  [2226] = {
    [anon_sym_COMMA] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1271),
    [sym__automatic_semicolon] = ACTIONS(1271),
  },
  [2227] = {
    [aux_sym_implements_clause_repeat1] = STATE(2648),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2228] = {
    [anon_sym_COMMA] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_SEMI] = ACTIONS(2766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2766),
    [sym__automatic_semicolon] = ACTIONS(2766),
  },
  [2229] = {
    [anon_sym_COMMA] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2746),
    [sym__automatic_semicolon] = ACTIONS(2746),
  },
  [2230] = {
    [anon_sym_COMMA] = ACTIONS(5488),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_SEMI] = ACTIONS(5488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5488),
    [sym__automatic_semicolon] = ACTIONS(5488),
  },
  [2231] = {
    [sym__call_signature] = STATE(2842),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2232] = {
    [sym__call_signature] = STATE(2933),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2233] = {
    [sym__import_export_specifier] = STATE(2919),
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_typeof] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
  },
  [2234] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5690),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2235] = {
    [anon_sym_COMMA] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_SEMI] = ACTIONS(2981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2981),
    [sym__automatic_semicolon] = ACTIONS(2981),
  },
  [2236] = {
    [sym__call_signature] = STATE(2792),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2237] = {
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5363),
    [sym__automatic_semicolon] = ACTIONS(5363),
  },
  [2238] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5694),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2239] = {
    [sym__call_signature] = STATE(2799),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2240] = {
    [sym__call_signature] = STATE(2845),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2241] = {
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_SEMI] = ACTIONS(5696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5696),
    [sym__automatic_semicolon] = ACTIONS(5696),
  },
  [2242] = {
    [anon_sym_COMMA] = ACTIONS(2965),
    [anon_sym_RBRACE] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2965),
    [sym__automatic_semicolon] = ACTIONS(2965),
  },
  [2243] = {
    [sym__call_signature] = STATE(2271),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2244] = {
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_SEMI] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1181),
    [sym__automatic_semicolon] = ACTIONS(1181),
  },
  [2245] = {
    [anon_sym_COMMA] = ACTIONS(5413),
    [anon_sym_RBRACE] = ACTIONS(5413),
    [anon_sym_SEMI] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5413),
    [sym__automatic_semicolon] = ACTIONS(5413),
  },
  [2246] = {
    [sym__call_signature] = STATE(2522),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2247] = {
    [anon_sym_COMMA] = ACTIONS(5431),
    [anon_sym_RBRACE] = ACTIONS(5431),
    [anon_sym_SEMI] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5431),
    [sym__automatic_semicolon] = ACTIONS(5431),
  },
  [2248] = {
    [sym__call_signature] = STATE(2521),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2249] = {
    [anon_sym_COMMA] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2838),
    [sym__automatic_semicolon] = ACTIONS(2838),
  },
  [2250] = {
    [sym__call_signature] = STATE(2245),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2251] = {
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_SEMI] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1113),
    [sym__automatic_semicolon] = ACTIONS(1113),
  },
  [2252] = {
    [anon_sym_COMMA] = ACTIONS(2854),
    [anon_sym_RBRACE] = ACTIONS(2854),
    [anon_sym_SEMI] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2854),
    [sym__automatic_semicolon] = ACTIONS(2854),
  },
  [2253] = {
    [sym_nested_identifier] = STATE(1889),
    [sym_jsx_namespace_name] = STATE(2006),
    [sym_identifier] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5700),
    [sym_jsx_identifier] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
  },
  [2254] = {
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1241),
    [sym__automatic_semicolon] = ACTIONS(1241),
  },
  [2255] = {
    [sym__call_signature] = STATE(2871),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2256] = {
    [anon_sym_COMMA] = ACTIONS(5441),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_SEMI] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5441),
    [sym__automatic_semicolon] = ACTIONS(5441),
  },
  [2257] = {
    [sym_statement_block] = STATE(1811),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5413),
    [anon_sym_SEMI] = ACTIONS(5413),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5413),
  },
  [2258] = {
    [sym__call_signature] = STATE(2790),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2259] = {
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [anon_sym_SEMI] = ACTIONS(5704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5704),
    [sym__automatic_semicolon] = ACTIONS(5704),
  },
  [2260] = {
    [sym_identifier] = ACTIONS(5706),
    [anon_sym_LBRACE] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_SLASH] = ACTIONS(5706),
    [sym_jsx_identifier] = ACTIONS(5708),
    [sym_comment] = ACTIONS(3),
  },
  [2261] = {
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [2262] = {
    [sym__call_signature] = STATE(2544),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2263] = {
    [sym_identifier] = ACTIONS(5710),
    [anon_sym_LBRACE] = ACTIONS(5712),
    [anon_sym_GT] = ACTIONS(5712),
    [anon_sym_SLASH] = ACTIONS(5710),
    [sym_jsx_identifier] = ACTIONS(5712),
    [sym_comment] = ACTIONS(3),
  },
  [2264] = {
    [aux_sym_implements_clause_repeat1] = STATE(2740),
    [anon_sym_COMMA] = ACTIONS(5714),
    [anon_sym_GT] = ACTIONS(5716),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2265] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5718),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2266] = {
    [anon_sym_COMMA] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2846),
    [sym__automatic_semicolon] = ACTIONS(2846),
  },
  [2267] = {
    [sym_extends_clause] = STATE(2734),
    [sym_object_type] = STATE(2394),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5375),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [2268] = {
    [sym__call_signature] = STATE(2465),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2269] = {
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5445),
    [sym__automatic_semicolon] = ACTIONS(5445),
  },
  [2270] = {
    [sym__call_signature] = STATE(2256),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2271] = {
    [anon_sym_COMMA] = ACTIONS(5453),
    [anon_sym_RBRACE] = ACTIONS(5453),
    [anon_sym_SEMI] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5453),
    [sym__automatic_semicolon] = ACTIONS(5453),
  },
  [2272] = {
    [anon_sym_COMMA] = ACTIONS(5455),
    [anon_sym_RBRACE] = ACTIONS(5455),
    [anon_sym_SEMI] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5455),
    [sym__automatic_semicolon] = ACTIONS(5455),
  },
  [2273] = {
    [sym__call_signature] = STATE(2915),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2274] = {
    [sym_statement_block] = STATE(1800),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5431),
    [anon_sym_SEMI] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5431),
  },
  [2275] = {
    [sym__call_signature] = STATE(2257),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2276] = {
    [sym_statement_block] = STATE(1796),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5441),
    [anon_sym_SEMI] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5441),
  },
  [2277] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5720),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2278] = {
    [anon_sym_COMMA] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2834),
    [sym__automatic_semicolon] = ACTIONS(2834),
  },
  [2279] = {
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_RBRACE] = ACTIONS(5722),
    [anon_sym_SEMI] = ACTIONS(5722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5722),
    [sym__automatic_semicolon] = ACTIONS(5722),
  },
  [2280] = {
    [anon_sym_EQ] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3727),
    [anon_sym_COLON] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3727),
  },
  [2281] = {
    [anon_sym_COMMA] = ACTIONS(5724),
    [anon_sym_RBRACE] = ACTIONS(5724),
    [anon_sym_SEMI] = ACTIONS(5724),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5724),
    [sym__automatic_semicolon] = ACTIONS(5724),
  },
  [2282] = {
    [sym__call_signature] = STATE(2867),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2283] = {
    [anon_sym_EQ] = ACTIONS(5726),
    [anon_sym_LBRACE] = ACTIONS(5726),
    [anon_sym_LPAREN] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5726),
    [anon_sym_extends] = ACTIONS(5726),
  },
  [2284] = {
    [sym__import_export_specifier] = STATE(2935),
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5728),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_typeof] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
  },
  [2285] = {
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_SEMI] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5730),
    [sym__automatic_semicolon] = ACTIONS(5730),
  },
  [2286] = {
    [anon_sym_COMMA] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2714),
    [sym__automatic_semicolon] = ACTIONS(2714),
  },
  [2287] = {
    [anon_sym_COMMA] = ACTIONS(5732),
    [anon_sym_RBRACE] = ACTIONS(5732),
    [anon_sym_SEMI] = ACTIONS(5732),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5732),
    [sym__automatic_semicolon] = ACTIONS(5732),
  },
  [2288] = {
    [anon_sym_COMMA] = ACTIONS(2730),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_SEMI] = ACTIONS(2730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2730),
    [sym__automatic_semicolon] = ACTIONS(2730),
  },
  [2289] = {
    [anon_sym_COMMA] = ACTIONS(2802),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_SEMI] = ACTIONS(2802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2802),
    [sym__automatic_semicolon] = ACTIONS(2802),
  },
  [2290] = {
    [anon_sym_COMMA] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_SEMI] = ACTIONS(2710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2710),
    [sym__automatic_semicolon] = ACTIONS(2710),
  },
  [2291] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5734),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2292] = {
    [anon_sym_COMMA] = ACTIONS(5461),
    [anon_sym_RBRACE] = ACTIONS(5461),
    [anon_sym_SEMI] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5461),
    [sym__automatic_semicolon] = ACTIONS(5461),
  },
  [2293] = {
    [sym__call_signature] = STATE(2814),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2294] = {
    [anon_sym_EQ] = ACTIONS(3750),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3750),
  },
  [2295] = {
    [aux_sym_implements_clause_repeat1] = STATE(2564),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2296] = {
    [anon_sym_EQ] = ACTIONS(4919),
    [anon_sym_COMMA] = ACTIONS(4919),
    [anon_sym_RPAREN] = ACTIONS(4919),
    [anon_sym_COLON] = ACTIONS(4919),
    [anon_sym_QMARK] = ACTIONS(4919),
    [sym_comment] = ACTIONS(3),
  },
  [2297] = {
    [anon_sym_COMMA] = ACTIONS(2874),
    [anon_sym_RBRACE] = ACTIONS(2874),
    [anon_sym_SEMI] = ACTIONS(2874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2874),
    [sym__automatic_semicolon] = ACTIONS(2874),
  },
  [2298] = {
    [sym__call_signature] = STATE(2529),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2299] = {
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_SEMI] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2794),
    [sym__automatic_semicolon] = ACTIONS(2794),
  },
  [2300] = {
    [anon_sym_COMMA] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2891),
    [sym__automatic_semicolon] = ACTIONS(2891),
  },
  [2301] = {
    [sym_type_arguments] = STATE(423),
    [anon_sym_LBRACE] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LT] = ACTIONS(5280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4339),
  },
  [2302] = {
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_SEMI] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [2303] = {
    [anon_sym_EQ] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_SEMI] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3719),
  },
  [2304] = {
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5740),
    [anon_sym_RPAREN] = ACTIONS(5740),
    [anon_sym_COLON] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5740),
    [sym_comment] = ACTIONS(3),
  },
  [2305] = {
    [anon_sym_EQ] = ACTIONS(5742),
    [anon_sym_COMMA] = ACTIONS(5742),
    [anon_sym_RPAREN] = ACTIONS(5742),
    [anon_sym_COLON] = ACTIONS(5742),
    [anon_sym_QMARK] = ACTIONS(5742),
    [sym_comment] = ACTIONS(3),
  },
  [2306] = {
    [anon_sym_EQ] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_RPAREN] = ACTIONS(5744),
    [anon_sym_COLON] = ACTIONS(5744),
    [anon_sym_QMARK] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
  },
  [2307] = {
    [sym__call_signature] = STATE(2926),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2308] = {
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_COLON] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
  },
  [2309] = {
    [aux_sym_implements_clause_repeat1] = STATE(2721),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(5748),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2310] = {
    [anon_sym_COMMA] = ACTIONS(5385),
    [anon_sym_RBRACE] = ACTIONS(5385),
    [anon_sym_SEMI] = ACTIONS(5385),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5385),
    [sym__automatic_semicolon] = ACTIONS(5385),
  },
  [2311] = {
    [sym__initializer] = STATE(2559),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_SEMI] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5750),
  },
  [2312] = {
    [sym_type_arguments] = STATE(2689),
    [anon_sym_LBRACE] = ACTIONS(4412),
    [anon_sym_COMMA] = ACTIONS(4339),
    [anon_sym_LT] = ACTIONS(5520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4339),
  },
  [2313] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5752),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2314] = {
    [sym__initializer] = STATE(2581),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5754),
    [anon_sym_SEMI] = ACTIONS(5754),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5754),
  },
  [2315] = {
    [sym__call_signature] = STATE(2755),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2316] = {
    [aux_sym_implements_clause_repeat1] = STATE(2573),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2317] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5760),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2318] = {
    [anon_sym_EQ] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [2319] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5762),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2320] = {
    [sym_statement_block] = STATE(1795),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5445),
  },
  [2321] = {
    [sym__call_signature] = STATE(2276),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2322] = {
    [sym__import_export_specifier] = STATE(2919),
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5764),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_typeof] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
  },
  [2323] = {
    [sym_object] = STATE(3068),
    [sym_array] = STATE(3071),
    [sym_identifier] = ACTIONS(5766),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_LBRACK] = ACTIONS(4827),
    [sym_comment] = ACTIONS(3),
  },
  [2324] = {
    [anon_sym_EQ] = ACTIONS(3723),
    [anon_sym_COMMA] = ACTIONS(3723),
    [anon_sym_SEMI] = ACTIONS(3723),
    [anon_sym_COLON] = ACTIONS(3723),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3723),
  },
  [2325] = {
    [anon_sym_COMMA] = ACTIONS(5457),
    [anon_sym_RBRACE] = ACTIONS(5457),
    [anon_sym_SEMI] = ACTIONS(5457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5457),
    [sym__automatic_semicolon] = ACTIONS(5457),
  },
  [2326] = {
    [sym__call_signature] = STATE(2879),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2327] = {
    [sym__call_signature] = STATE(2918),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2328] = {
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(4548),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_QMARK] = ACTIONS(4548),
    [sym_comment] = ACTIONS(3),
  },
  [2329] = {
    [sym_identifier] = ACTIONS(4169),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_GT] = ACTIONS(4171),
    [anon_sym_SLASH] = ACTIONS(4169),
    [sym_jsx_identifier] = ACTIONS(4171),
    [sym_comment] = ACTIONS(3),
  },
  [2330] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5768),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2331] = {
    [sym__initializer] = STATE(2865),
    [aux_sym_enum_body_repeat1] = STATE(2713),
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5770),
    [anon_sym_RBRACE] = ACTIONS(5772),
    [sym_comment] = ACTIONS(3),
  },
  [2332] = {
    [sym__call_signature] = STATE(2855),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2333] = {
    [sym_statement_block] = STATE(1793),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5453),
    [anon_sym_SEMI] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5453),
  },
  [2334] = {
    [sym__call_signature] = STATE(2768),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2335] = {
    [anon_sym_COMMA] = ACTIONS(5774),
    [anon_sym_RBRACE] = ACTIONS(5774),
    [anon_sym_SEMI] = ACTIONS(5774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5774),
    [sym__automatic_semicolon] = ACTIONS(5774),
  },
  [2336] = {
    [sym_identifier] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(1167),
    [anon_sym_SLASH] = ACTIONS(1169),
    [sym_jsx_identifier] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
  },
  [2337] = {
    [sym__call_signature] = STATE(2821),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2338] = {
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3746),
    [anon_sym_COLON] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3746),
  },
  [2339] = {
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2933),
    [sym__automatic_semicolon] = ACTIONS(2933),
  },
  [2340] = {
    [sym__call_signature] = STATE(2075),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2341] = {
    [sym__initializer] = STATE(2685),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5776),
    [anon_sym_SEMI] = ACTIONS(5776),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5776),
  },
  [2342] = {
    [sym_extends_clause] = STATE(2644),
    [sym_object_type] = STATE(597),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5375),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [2343] = {
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_SEMI] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1185),
    [sym__automatic_semicolon] = ACTIONS(1185),
  },
  [2344] = {
    [anon_sym_COMMA] = ACTIONS(5371),
    [anon_sym_RBRACE] = ACTIONS(5371),
    [anon_sym_SEMI] = ACTIONS(5371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5371),
    [sym__automatic_semicolon] = ACTIONS(5371),
  },
  [2345] = {
    [aux_sym_implements_clause_repeat1] = STATE(2742),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_GT] = ACTIONS(5780),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2346] = {
    [anon_sym_else] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_PIPE] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
  },
  [2347] = {
    [sym__call_signature] = STATE(2417),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2348] = {
    [aux_sym_implements_clause_repeat1] = STATE(2631),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2349] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5790),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2350] = {
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1225),
    [sym__automatic_semicolon] = ACTIONS(5792),
  },
  [2351] = {
    [sym__initializer] = STATE(2683),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_SEMI] = ACTIONS(5794),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5794),
  },
  [2352] = {
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1199),
    [sym__automatic_semicolon] = ACTIONS(1199),
  },
  [2353] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5796),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2354] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [anon_sym_export] = ACTIONS(5798),
    [anon_sym_class] = ACTIONS(5800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2355] = {
    [aux_sym_implements_clause_repeat1] = STATE(2640),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(5802),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2356] = {
    [sym__initializer] = STATE(2682),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5804),
    [anon_sym_SEMI] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5804),
  },
  [2357] = {
    [anon_sym_COMMA] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(2798),
    [anon_sym_SEMI] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2798),
    [sym__automatic_semicolon] = ACTIONS(2798),
  },
  [2358] = {
    [anon_sym_COMMA] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2949),
    [sym__automatic_semicolon] = ACTIONS(2949),
  },
  [2359] = {
    [sym__initializer] = STATE(2567),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_SEMI] = ACTIONS(5806),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5806),
  },
  [2360] = {
    [anon_sym_else] = ACTIONS(2634),
    [anon_sym_while] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_PIPE] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
  },
  [2361] = {
    [aux_sym_implements_clause_repeat1] = STATE(2728),
    [anon_sym_COMMA] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5810),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2362] = {
    [anon_sym_COMMA] = ACTIONS(2810),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_SEMI] = ACTIONS(2810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2810),
    [sym__automatic_semicolon] = ACTIONS(2810),
  },
  [2363] = {
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_COMMA] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2364] = {
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2953),
    [sym__automatic_semicolon] = ACTIONS(2953),
  },
  [2365] = {
    [sym_identifier] = ACTIONS(4153),
    [anon_sym_LBRACE] = ACTIONS(4155),
    [anon_sym_GT] = ACTIONS(4155),
    [anon_sym_SLASH] = ACTIONS(4153),
    [sym_jsx_identifier] = ACTIONS(4155),
    [sym_comment] = ACTIONS(3),
  },
  [2366] = {
    [sym_statement_block] = STATE(1785),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5391),
    [anon_sym_SEMI] = ACTIONS(5391),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5391),
  },
  [2367] = {
    [anon_sym_COMMA] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2945),
    [sym__automatic_semicolon] = ACTIONS(2945),
  },
  [2368] = {
    [sym__import_export_specifier] = STATE(2935),
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5814),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_typeof] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
  },
  [2369] = {
    [anon_sym_EQ] = ACTIONS(4713),
    [anon_sym_COMMA] = ACTIONS(4713),
    [anon_sym_RPAREN] = ACTIONS(4713),
    [anon_sym_COLON] = ACTIONS(4713),
    [anon_sym_QMARK] = ACTIONS(4713),
    [sym_comment] = ACTIONS(3),
  },
  [2370] = {
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2925),
    [sym__automatic_semicolon] = ACTIONS(2925),
  },
  [2371] = {
    [anon_sym_COMMA] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2887),
    [sym__automatic_semicolon] = ACTIONS(2887),
  },
  [2372] = {
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2750),
    [sym__automatic_semicolon] = ACTIONS(2750),
  },
  [2373] = {
    [anon_sym_EQ] = ACTIONS(5816),
    [anon_sym_LBRACE] = ACTIONS(5816),
    [anon_sym_LPAREN] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5816),
    [anon_sym_extends] = ACTIONS(5816),
  },
  [2374] = {
    [sym_identifier] = ACTIONS(4149),
    [anon_sym_LBRACE] = ACTIONS(4151),
    [anon_sym_GT] = ACTIONS(4151),
    [anon_sym_SLASH] = ACTIONS(4149),
    [sym_jsx_identifier] = ACTIONS(4151),
    [sym_comment] = ACTIONS(3),
  },
  [2375] = {
    [sym__call_signature] = STATE(2832),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2376] = {
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_RBRACE] = ACTIONS(2895),
    [anon_sym_SEMI] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2895),
    [sym__automatic_semicolon] = ACTIONS(2895),
  },
  [2377] = {
    [sym__call_signature] = STATE(2561),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2378] = {
    [anon_sym_COMMA] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_SEMI] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2818),
    [sym__automatic_semicolon] = ACTIONS(2818),
  },
  [2379] = {
    [anon_sym_COMMA] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1261),
    [sym__automatic_semicolon] = ACTIONS(5818),
  },
  [2380] = {
    [anon_sym_COMMA] = ACTIONS(1251),
    [anon_sym_RBRACE] = ACTIONS(1251),
    [anon_sym_SEMI] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1251),
    [sym__automatic_semicolon] = ACTIONS(5820),
  },
  [2381] = {
    [anon_sym_EQ] = ACTIONS(4721),
    [anon_sym_COMMA] = ACTIONS(4721),
    [anon_sym_RPAREN] = ACTIONS(4721),
    [anon_sym_COLON] = ACTIONS(4721),
    [anon_sym_QMARK] = ACTIONS(4721),
    [sym_comment] = ACTIONS(3),
  },
  [2382] = {
    [sym_statement_block] = STATE(1801),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5363),
  },
  [2383] = {
    [anon_sym_EQ] = ACTIONS(658),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_QMARK] = ACTIONS(658),
    [sym_comment] = ACTIONS(3),
  },
  [2384] = {
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2754),
    [sym__automatic_semicolon] = ACTIONS(2754),
  },
  [2385] = {
    [aux_sym_implements_clause_repeat1] = STATE(2599),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2386] = {
    [sym__initializer] = STATE(2558),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5824),
  },
  [2387] = {
    [sym_statement_block] = STATE(1812),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5385),
    [anon_sym_SEMI] = ACTIONS(5385),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5385),
  },
  [2388] = {
    [sym__call_signature] = STATE(2064),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2389] = {
    [sym__call_signature] = STATE(2881),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2390] = {
    [anon_sym_COMMA] = ACTIONS(1153),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_SEMI] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1153),
    [sym__automatic_semicolon] = ACTIONS(5826),
  },
  [2391] = {
    [sym__call_signature] = STATE(2085),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2392] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [anon_sym_export] = ACTIONS(5828),
    [anon_sym_class] = ACTIONS(5830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2393] = {
    [sym__call_signature] = STATE(2810),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2394] = {
    [anon_sym_COMMA] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2969),
    [sym__automatic_semicolon] = ACTIONS(2969),
  },
  [2395] = {
    [sym_identifier] = ACTIONS(4075),
    [anon_sym_LBRACE] = ACTIONS(4077),
    [anon_sym_GT] = ACTIONS(4077),
    [anon_sym_SLASH] = ACTIONS(4075),
    [sym_jsx_identifier] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
  },
  [2396] = {
    [anon_sym_EQ] = ACTIONS(3727),
    [anon_sym_COMMA] = ACTIONS(3727),
    [anon_sym_RPAREN] = ACTIONS(3727),
    [anon_sym_COLON] = ACTIONS(3727),
    [anon_sym_QMARK] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
  },
  [2397] = {
    [anon_sym_EQ] = ACTIONS(3723),
    [anon_sym_COMMA] = ACTIONS(3723),
    [anon_sym_RPAREN] = ACTIONS(3723),
    [anon_sym_COLON] = ACTIONS(3723),
    [anon_sym_QMARK] = ACTIONS(3723),
    [sym_comment] = ACTIONS(3),
  },
  [2398] = {
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3746),
    [anon_sym_RPAREN] = ACTIONS(3746),
    [anon_sym_COLON] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
  },
  [2399] = {
    [sym__call_signature] = STATE(2333),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2400] = {
    [sym__call_signature] = STATE(2963),
    [sym_formal_parameters] = STATE(2527),
    [sym_type_parameters] = STATE(2830),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2401] = {
    [sym_identifier] = ACTIONS(4069),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_SLASH] = ACTIONS(4069),
    [sym_jsx_identifier] = ACTIONS(4071),
    [sym_comment] = ACTIONS(3),
  },
  [2402] = {
    [anon_sym_COMMA] = ACTIONS(5832),
    [anon_sym_RBRACE] = ACTIONS(5832),
    [anon_sym_SEMI] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5832),
    [sym__automatic_semicolon] = ACTIONS(5832),
  },
  [2403] = {
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [anon_sym_SEMI] = ACTIONS(5834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5834),
    [sym__automatic_semicolon] = ACTIONS(5834),
  },
  [2404] = {
    [anon_sym_else] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_PIPE] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
  },
  [2405] = {
    [anon_sym_else] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_PIPE] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
  },
  [2406] = {
    [sym_statement_block] = STATE(1798),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5455),
    [anon_sym_SEMI] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5455),
  },
  [2407] = {
    [sym__initializer] = STATE(2600),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5836),
    [anon_sym_SEMI] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5836),
  },
  [2408] = {
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(2973),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2973),
    [sym__automatic_semicolon] = ACTIONS(2973),
  },
  [2409] = {
    [sym__call_signature] = STATE(2513),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2410] = {
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_RBRACE] = ACTIONS(5838),
    [anon_sym_SEMI] = ACTIONS(5838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5838),
    [sym__automatic_semicolon] = ACTIONS(5838),
  },
  [2411] = {
    [anon_sym_COMMA] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5407),
    [anon_sym_SEMI] = ACTIONS(5407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5407),
    [sym__automatic_semicolon] = ACTIONS(5407),
  },
  [2412] = {
    [sym__call_signature] = STATE(2104),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2413] = {
    [anon_sym_else] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_PIPE] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
  },
  [2414] = {
    [sym__call_signature] = STATE(2310),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2415] = {
    [anon_sym_EQ] = ACTIONS(5840),
    [anon_sym_COMMA] = ACTIONS(5840),
    [anon_sym_RPAREN] = ACTIONS(5840),
    [anon_sym_COLON] = ACTIONS(5840),
    [anon_sym_QMARK] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
  },
  [2416] = {
    [sym_statement_block] = STATE(1808),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5461),
    [anon_sym_SEMI] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5461),
  },
  [2417] = {
    [anon_sym_COMMA] = ACTIONS(5391),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_SEMI] = ACTIONS(5391),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5391),
    [sym__automatic_semicolon] = ACTIONS(5391),
  },
  [2418] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [anon_sym_export] = ACTIONS(5842),
    [anon_sym_class] = ACTIONS(5830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2419] = {
    [sym__call_signature] = STATE(2579),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2420] = {
    [sym__initializer] = STATE(2578),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5844),
    [anon_sym_SEMI] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5844),
  },
  [2421] = {
    [sym__call_signature] = STATE(2366),
    [sym_formal_parameters] = STATE(2034),
    [sym_type_parameters] = STATE(2892),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2422] = {
    [sym_statement_block] = STATE(1806),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_COMMA] = ACTIONS(5371),
    [anon_sym_SEMI] = ACTIONS(5371),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5371),
  },
  [2423] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5846),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2424] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_LBRACE] = ACTIONS(5598),
    [anon_sym_COMMA] = ACTIONS(5848),
    [anon_sym_RBRACK] = ACTIONS(5598),
    [anon_sym_GT] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
  },
  [2425] = {
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_RPAREN] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
  },
  [2426] = {
    [sym_identifier] = ACTIONS(5851),
    [anon_sym_LBRACE] = ACTIONS(5853),
    [anon_sym_GT] = ACTIONS(5853),
    [anon_sym_SLASH] = ACTIONS(5851),
    [sym_jsx_identifier] = ACTIONS(5853),
    [sym_comment] = ACTIONS(3),
  },
  [2427] = {
    [sym__initializer] = STATE(2865),
    [aux_sym_enum_body_repeat1] = STATE(2591),
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5855),
    [anon_sym_RBRACE] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
  },
  [2428] = {
    [sym__initializer] = STATE(2572),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_SEMI] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5859),
  },
  [2429] = {
    [anon_sym_EQ] = ACTIONS(5861),
    [anon_sym_COMMA] = ACTIONS(5861),
    [anon_sym_RPAREN] = ACTIONS(5861),
    [anon_sym_COLON] = ACTIONS(5861),
    [anon_sym_QMARK] = ACTIONS(5861),
    [sym_comment] = ACTIONS(3),
  },
  [2430] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [anon_sym_SLASH] = ACTIONS(5863),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2431] = {
    [sym_identifier] = ACTIONS(4180),
    [anon_sym_LBRACE] = ACTIONS(4182),
    [anon_sym_GT] = ACTIONS(4182),
    [anon_sym_SLASH] = ACTIONS(4180),
    [sym_jsx_identifier] = ACTIONS(4182),
    [sym_comment] = ACTIONS(3),
  },
  [2432] = {
    [anon_sym_EQ] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_SEMI] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3731),
  },
  [2433] = {
    [anon_sym_EQ] = ACTIONS(5865),
    [anon_sym_COMMA] = ACTIONS(5865),
    [anon_sym_RPAREN] = ACTIONS(5865),
    [anon_sym_COLON] = ACTIONS(5865),
    [anon_sym_QMARK] = ACTIONS(5865),
    [sym_comment] = ACTIONS(3),
  },
  [2434] = {
    [anon_sym_EQ] = ACTIONS(3731),
    [anon_sym_COMMA] = ACTIONS(3731),
    [anon_sym_RPAREN] = ACTIONS(3731),
    [anon_sym_COLON] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3731),
    [sym_comment] = ACTIONS(3),
  },
  [2435] = {
    [sym__initializer] = STATE(2576),
    [anon_sym_EQ] = ACTIONS(5075),
    [anon_sym_COMMA] = ACTIONS(5867),
    [anon_sym_SEMI] = ACTIONS(5867),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5867),
  },
  [2436] = {
    [anon_sym_COMMA] = ACTIONS(5869),
    [anon_sym_RBRACE] = ACTIONS(5869),
    [anon_sym_SEMI] = ACTIONS(5869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5869),
    [sym__automatic_semicolon] = ACTIONS(5869),
  },
  [2437] = {
    [anon_sym_EQ] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
  },
  [2438] = {
    [aux_sym_implements_clause_repeat1] = STATE(2703),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(5871),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2439] = {
    [anon_sym_COMMA] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2850),
    [sym__automatic_semicolon] = ACTIONS(2850),
  },
  [2440] = {
    [aux_sym_implements_clause_repeat1] = STATE(2652),
    [anon_sym_LBRACE] = ACTIONS(5873),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2441] = {
    [anon_sym_EQ] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(3719),
    [anon_sym_RPAREN] = ACTIONS(3719),
    [anon_sym_COLON] = ACTIONS(3719),
    [anon_sym_QMARK] = ACTIONS(3719),
    [sym_comment] = ACTIONS(3),
  },
  [2442] = {
    [aux_sym_implements_clause_repeat1] = STATE(2695),
    [anon_sym_COMMA] = ACTIONS(5875),
    [anon_sym_GT] = ACTIONS(5877),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2443] = {
    [anon_sym_COMMA] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_SEMI] = ACTIONS(2722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2722),
    [sym__automatic_semicolon] = ACTIONS(2722),
  },
  [2444] = {
    [sym_identifier] = ACTIONS(5879),
    [anon_sym_LBRACE] = ACTIONS(5881),
    [anon_sym_GT] = ACTIONS(5881),
    [anon_sym_SLASH] = ACTIONS(5879),
    [sym_jsx_identifier] = ACTIONS(5881),
    [sym_comment] = ACTIONS(3),
  },
  [2445] = {
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3715),
  },
  [2446] = {
    [anon_sym_EQ] = ACTIONS(3750),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_RPAREN] = ACTIONS(3750),
    [anon_sym_COLON] = ACTIONS(3750),
    [anon_sym_QMARK] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
  },
  [2447] = {
    [sym_identifier] = ACTIONS(4095),
    [anon_sym_LBRACE] = ACTIONS(4097),
    [anon_sym_GT] = ACTIONS(4097),
    [anon_sym_SLASH] = ACTIONS(4095),
    [sym_jsx_identifier] = ACTIONS(4097),
    [sym_comment] = ACTIONS(3),
  },
  [2448] = {
    [sym_identifier] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1165),
    [sym_jsx_identifier] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
  },
  [2449] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2524),
    [anon_sym_COMMA] = ACTIONS(5883),
    [anon_sym_SEMI] = ACTIONS(5885),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5885),
  },
  [2450] = {
    [anon_sym_else] = ACTIONS(2658),
    [anon_sym_while] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_PIPE] = ACTIONS(5784),
    [sym_comment] = ACTIONS(3),
  },
  [2451] = {
    [anon_sym_SEMI] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5887),
  },
  [2452] = {
    [aux_sym_string_repeat2] = STATE(2474),
    [anon_sym_SQUOTE] = ACTIONS(5891),
    [aux_sym_string_token2] = ACTIONS(5893),
    [sym_escape_sequence] = ACTIONS(5895),
    [sym_comment] = ACTIONS(5233),
  },
  [2453] = {
    [aux_sym_string_repeat1] = STATE(2455),
    [anon_sym_DQUOTE] = ACTIONS(5897),
    [aux_sym_string_token1] = ACTIONS(5899),
    [sym_escape_sequence] = ACTIONS(5901),
    [sym_comment] = ACTIONS(5233),
  },
  [2454] = {
    [aux_sym_string_repeat1] = STATE(2473),
    [anon_sym_DQUOTE] = ACTIONS(5891),
    [aux_sym_string_token1] = ACTIONS(5903),
    [sym_escape_sequence] = ACTIONS(5905),
    [sym_comment] = ACTIONS(5233),
  },
  [2455] = {
    [aux_sym_string_repeat1] = STATE(2455),
    [anon_sym_DQUOTE] = ACTIONS(5907),
    [aux_sym_string_token1] = ACTIONS(5909),
    [sym_escape_sequence] = ACTIONS(5912),
    [sym_comment] = ACTIONS(5233),
  },
  [2456] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [anon_sym_export] = ACTIONS(5915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2457] = {
    [aux_sym_extends_clause_repeat1] = STATE(2507),
    [anon_sym_LBRACE] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(3935),
  },
  [2458] = {
    [sym_nested_identifier] = STATE(1906),
    [sym_jsx_namespace_name] = STATE(2008),
    [sym_identifier] = ACTIONS(5688),
    [sym_jsx_identifier] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
  },
  [2459] = {
    [sym_nested_identifier] = STATE(2944),
    [sym_jsx_namespace_name] = STATE(3011),
    [sym_identifier] = ACTIONS(5917),
    [sym_jsx_identifier] = ACTIONS(5919),
    [sym_comment] = ACTIONS(3),
  },
  [2460] = {
    [sym_formal_parameters] = STATE(3102),
    [sym_type_parameters] = STATE(2974),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2461] = {
    [sym_formal_parameters] = STATE(3047),
    [sym_type_parameters] = STATE(2910),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2462] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [anon_sym_class] = ACTIONS(5921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2463] = {
    [aux_sym_extends_clause_repeat1] = STATE(2463),
    [anon_sym_LBRACE] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4339),
  },
  [2464] = {
    [aux_sym_string_repeat2] = STATE(2500),
    [anon_sym_SQUOTE] = ACTIONS(5926),
    [aux_sym_string_token2] = ACTIONS(5928),
    [sym_escape_sequence] = ACTIONS(5930),
    [sym_comment] = ACTIONS(5233),
  },
  [2465] = {
    [sym_statement_block] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5932),
  },
  [2466] = {
    [aux_sym_string_repeat1] = STATE(2453),
    [anon_sym_DQUOTE] = ACTIONS(5926),
    [aux_sym_string_token1] = ACTIONS(5934),
    [sym_escape_sequence] = ACTIONS(5936),
    [sym_comment] = ACTIONS(5233),
  },
  [2467] = {
    [aux_sym_extends_clause_repeat1] = STATE(2517),
    [anon_sym_LBRACE] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5940),
  },
  [2468] = {
    [sym__initializer] = STATE(2952),
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_RPAREN] = ACTIONS(5942),
    [sym_comment] = ACTIONS(3),
  },
  [2469] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2543),
    [anon_sym_COMMA] = ACTIONS(5883),
    [anon_sym_SEMI] = ACTIONS(5944),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5944),
  },
  [2470] = {
    [sym_type_annotation] = STATE(2940),
    [anon_sym_COMMA] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(5946),
    [anon_sym_COLON] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
  },
  [2471] = {
    [aux_sym_string_repeat2] = STATE(2549),
    [anon_sym_SQUOTE] = ACTIONS(5948),
    [aux_sym_string_token2] = ACTIONS(5950),
    [sym_escape_sequence] = ACTIONS(5952),
    [sym_comment] = ACTIONS(5233),
  },
  [2472] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2449),
    [anon_sym_COMMA] = ACTIONS(5883),
    [anon_sym_SEMI] = ACTIONS(5954),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5954),
  },
  [2473] = {
    [aux_sym_string_repeat1] = STATE(2455),
    [anon_sym_DQUOTE] = ACTIONS(5956),
    [aux_sym_string_token1] = ACTIONS(5899),
    [sym_escape_sequence] = ACTIONS(5901),
    [sym_comment] = ACTIONS(5233),
  },
  [2474] = {
    [aux_sym_string_repeat2] = STATE(2516),
    [anon_sym_SQUOTE] = ACTIONS(5956),
    [aux_sym_string_token2] = ACTIONS(5958),
    [sym_escape_sequence] = ACTIONS(5960),
    [sym_comment] = ACTIONS(5233),
  },
  [2475] = {
    [aux_sym_string_repeat1] = STATE(2550),
    [anon_sym_DQUOTE] = ACTIONS(5948),
    [aux_sym_string_token1] = ACTIONS(5962),
    [sym_escape_sequence] = ACTIONS(5964),
    [sym_comment] = ACTIONS(5233),
  },
  [2476] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2542),
    [anon_sym_COMMA] = ACTIONS(5883),
    [anon_sym_SEMI] = ACTIONS(5966),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5966),
  },
  [2477] = {
    [aux_sym_string_repeat1] = STATE(2481),
    [anon_sym_DQUOTE] = ACTIONS(5968),
    [aux_sym_string_token1] = ACTIONS(5970),
    [sym_escape_sequence] = ACTIONS(5972),
    [sym_comment] = ACTIONS(5233),
  },
  [2478] = {
    [sym_template_string] = STATE(1632),
    [sym_arguments] = STATE(1632),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(746),
  },
  [2479] = {
    [aux_sym_string_repeat2] = STATE(2483),
    [anon_sym_SQUOTE] = ACTIONS(5968),
    [aux_sym_string_token2] = ACTIONS(5974),
    [sym_escape_sequence] = ACTIONS(5976),
    [sym_comment] = ACTIONS(5233),
  },
  [2480] = {
    [anon_sym_RBRACE] = ACTIONS(3803),
    [anon_sym_RPAREN] = ACTIONS(3803),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_RBRACK] = ACTIONS(3803),
    [sym_comment] = ACTIONS(3),
  },
  [2481] = {
    [aux_sym_string_repeat1] = STATE(2455),
    [anon_sym_DQUOTE] = ACTIONS(5978),
    [aux_sym_string_token1] = ACTIONS(5899),
    [sym_escape_sequence] = ACTIONS(5901),
    [sym_comment] = ACTIONS(5233),
  },
  [2482] = {
    [sym_type_annotation] = STATE(2891),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(5294),
    [sym_comment] = ACTIONS(3),
  },
  [2483] = {
    [aux_sym_string_repeat2] = STATE(2516),
    [anon_sym_SQUOTE] = ACTIONS(5978),
    [aux_sym_string_token2] = ACTIONS(5958),
    [sym_escape_sequence] = ACTIONS(5960),
    [sym_comment] = ACTIONS(5233),
  },
  [2484] = {
    [sym_statement_block] = STATE(582),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2485] = {
    [anon_sym_COMMA] = ACTIONS(5980),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2486] = {
    [aux_sym_string_repeat1] = STATE(2538),
    [anon_sym_DQUOTE] = ACTIONS(5982),
    [aux_sym_string_token1] = ACTIONS(5984),
    [sym_escape_sequence] = ACTIONS(5986),
    [sym_comment] = ACTIONS(5233),
  },
  [2487] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2524),
    [anon_sym_COMMA] = ACTIONS(5883),
    [anon_sym_SEMI] = ACTIONS(5988),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5988),
  },
  [2488] = {
    [aux_sym_string_repeat1] = STATE(2492),
    [anon_sym_DQUOTE] = ACTIONS(5990),
    [aux_sym_string_token1] = ACTIONS(5992),
    [sym_escape_sequence] = ACTIONS(5994),
    [sym_comment] = ACTIONS(5233),
  },
  [2489] = {
    [aux_sym_string_repeat2] = STATE(2493),
    [anon_sym_SQUOTE] = ACTIONS(5990),
    [aux_sym_string_token2] = ACTIONS(5996),
    [sym_escape_sequence] = ACTIONS(5998),
    [sym_comment] = ACTIONS(5233),
  },
  [2490] = {
    [anon_sym_SEMI] = ACTIONS(6000),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6000),
  },
  [2491] = {
    [sym_statement_block] = STATE(2379),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [anon_sym_SEMI] = ACTIONS(6002),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6002),
  },
  [2492] = {
    [aux_sym_string_repeat1] = STATE(2455),
    [anon_sym_DQUOTE] = ACTIONS(6004),
    [aux_sym_string_token1] = ACTIONS(5899),
    [sym_escape_sequence] = ACTIONS(5901),
    [sym_comment] = ACTIONS(5233),
  },
  [2493] = {
    [aux_sym_string_repeat2] = STATE(2516),
    [anon_sym_SQUOTE] = ACTIONS(6004),
    [aux_sym_string_token2] = ACTIONS(5958),
    [sym_escape_sequence] = ACTIONS(5960),
    [sym_comment] = ACTIONS(5233),
  },
  [2494] = {
    [aux_sym_string_repeat2] = STATE(2539),
    [anon_sym_SQUOTE] = ACTIONS(5982),
    [aux_sym_string_token2] = ACTIONS(6006),
    [sym_escape_sequence] = ACTIONS(6008),
    [sym_comment] = ACTIONS(5233),
  },
  [2495] = {
    [aux_sym_extends_clause_repeat1] = STATE(2463),
    [anon_sym_LBRACE] = ACTIONS(5940),
    [anon_sym_COMMA] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5940),
  },
  [2496] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(6010),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [anon_sym_RBRACK] = ACTIONS(4335),
    [sym_comment] = ACTIONS(3),
  },
  [2497] = {
    [aux_sym_string_repeat2] = STATE(2516),
    [anon_sym_SQUOTE] = ACTIONS(6013),
    [aux_sym_string_token2] = ACTIONS(5958),
    [sym_escape_sequence] = ACTIONS(5960),
    [sym_comment] = ACTIONS(5233),
  },
  [2498] = {
    [aux_sym_string_repeat1] = STATE(2455),
    [anon_sym_DQUOTE] = ACTIONS(6013),
    [aux_sym_string_token1] = ACTIONS(5899),
    [sym_escape_sequence] = ACTIONS(5901),
    [sym_comment] = ACTIONS(5233),
  },
  [2499] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [anon_sym_class] = ACTIONS(6015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2500] = {
    [aux_sym_string_repeat2] = STATE(2516),
    [anon_sym_SQUOTE] = ACTIONS(5897),
    [aux_sym_string_token2] = ACTIONS(5958),
    [sym_escape_sequence] = ACTIONS(5960),
    [sym_comment] = ACTIONS(5233),
  },
  [2501] = {
    [sym__from_clause] = STATE(2828),
    [anon_sym_from] = ACTIONS(6017),
    [anon_sym_SEMI] = ACTIONS(6019),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6019),
  },
  [2502] = {
    [sym_statement_block] = STATE(1402),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [anon_sym_SEMI] = ACTIONS(6021),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6021),
  },
  [2503] = {
    [sym__initializer] = STATE(2903),
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(6023),
    [anon_sym_RPAREN] = ACTIONS(6023),
    [sym_comment] = ACTIONS(3),
  },
  [2504] = {
    [sym_namespace_import] = STATE(3034),
    [sym_named_imports] = STATE(3034),
    [anon_sym_STAR] = ACTIONS(5221),
    [anon_sym_LBRACE] = ACTIONS(3660),
    [sym_comment] = ACTIONS(3),
  },
  [2505] = {
    [sym__from_clause] = STATE(2885),
    [anon_sym_from] = ACTIONS(6017),
    [anon_sym_SEMI] = ACTIONS(6025),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6025),
  },
  [2506] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [anon_sym_class] = ACTIONS(6027),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2507] = {
    [aux_sym_extends_clause_repeat1] = STATE(2463),
    [anon_sym_LBRACE] = ACTIONS(6029),
    [anon_sym_COMMA] = ACTIONS(3503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(6029),
  },
  [2508] = {
    [sym_formal_parameters] = STATE(3146),
    [sym_type_parameters] = STATE(2889),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2509] = {
    [sym__import_export_specifier] = STATE(2919),
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_typeof] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
  },
  [2510] = {
    [sym_formal_parameters] = STATE(3158),
    [sym_type_parameters] = STATE(2958),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2511] = {
    [sym_nested_identifier] = STATE(2760),
    [sym_jsx_namespace_name] = STATE(3209),
    [sym_identifier] = ACTIONS(6031),
    [sym_jsx_identifier] = ACTIONS(6033),
    [sym_comment] = ACTIONS(3),
  },
  [2512] = {
    [aux_sym_string_repeat2] = STATE(2497),
    [anon_sym_SQUOTE] = ACTIONS(6035),
    [aux_sym_string_token2] = ACTIONS(6037),
    [sym_escape_sequence] = ACTIONS(6039),
    [sym_comment] = ACTIONS(5233),
  },
  [2513] = {
    [sym_statement_block] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(6021),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6021),
  },
  [2514] = {
    [aux_sym_string_repeat1] = STATE(2498),
    [anon_sym_DQUOTE] = ACTIONS(6035),
    [aux_sym_string_token1] = ACTIONS(6041),
    [sym_escape_sequence] = ACTIONS(6043),
    [sym_comment] = ACTIONS(5233),
  },
  [2515] = {
    [aux_sym_extends_clause_repeat1] = STATE(2535),
    [anon_sym_LBRACE] = ACTIONS(3905),
    [anon_sym_COMMA] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3935),
  },
  [2516] = {
    [aux_sym_string_repeat2] = STATE(2516),
    [anon_sym_SQUOTE] = ACTIONS(6045),
    [aux_sym_string_token2] = ACTIONS(6047),
    [sym_escape_sequence] = ACTIONS(6050),
    [sym_comment] = ACTIONS(5233),
  },
  [2517] = {
    [aux_sym_extends_clause_repeat1] = STATE(2517),
    [anon_sym_LBRACE] = ACTIONS(4412),
    [anon_sym_COMMA] = ACTIONS(6053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4339),
  },
  [2518] = {
    [sym_formal_parameters] = STATE(2074),
    [sym_type_parameters] = STATE(2880),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2519] = {
    [anon_sym_SEMI] = ACTIONS(6056),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6056),
  },
  [2520] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2487),
    [anon_sym_COMMA] = ACTIONS(5883),
    [anon_sym_SEMI] = ACTIONS(6058),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6058),
  },
  [2521] = {
    [sym_statement_block] = STATE(2350),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [anon_sym_SEMI] = ACTIONS(6060),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6060),
  },
  [2522] = {
    [sym_statement_block] = STATE(513),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [anon_sym_SEMI] = ACTIONS(6021),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6021),
  },
  [2523] = {
    [sym_formal_parameters] = STATE(3136),
    [sym_type_parameters] = STATE(2765),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2524] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2524),
    [anon_sym_COMMA] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6065),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6065),
  },
  [2525] = {
    [sym_nested_identifier] = STATE(2943),
    [sym_jsx_namespace_name] = STATE(3009),
    [sym_identifier] = ACTIONS(6067),
    [sym_jsx_identifier] = ACTIONS(6069),
    [sym_comment] = ACTIONS(3),
  },
  [2526] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [anon_sym_class] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2527] = {
    [sym_type_annotation] = STATE(2899),
    [anon_sym_LBRACE] = ACTIONS(5335),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(5335),
    [sym_comment] = ACTIONS(3),
  },
  [2528] = {
    [sym_decorator] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(1825),
    [anon_sym_class] = ACTIONS(6073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2529] = {
    [sym_statement_block] = STATE(1389),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [anon_sym_SEMI] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5932),
  },
  [2530] = {
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_EQ_GT] = ACTIONS(6075),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [2531] = {
    [anon_sym_LPAREN] = ACTIONS(3616),
    [anon_sym_LT] = ACTIONS(3616),
    [anon_sym_EQ_GT] = ACTIONS(4905),
    [anon_sym_QMARK] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [2532] = {
    [sym_default_type] = STATE(2960),
    [anon_sym_EQ] = ACTIONS(5048),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
  },
  [2533] = {
    [sym_nested_identifier] = STATE(2900),
    [sym_jsx_namespace_name] = STATE(3073),
    [sym_identifier] = ACTIONS(6079),
    [sym_jsx_identifier] = ACTIONS(6081),
    [sym_comment] = ACTIONS(3),
  },
  [2534] = {
    [sym_escape_sequence] = ACTIONS(6083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(6083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6083),
    [sym__template_chars] = ACTIONS(6083),
  },
  [2535] = {
    [aux_sym_extends_clause_repeat1] = STATE(2517),
    [anon_sym_LBRACE] = ACTIONS(6085),
    [anon_sym_COMMA] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(6029),
  },
  [2536] = {
    [sym__initializer] = STATE(2865),
    [anon_sym_EQ] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_RBRACE] = ACTIONS(6087),
    [sym_comment] = ACTIONS(3),
  },
  [2537] = {
    [sym_formal_parameters] = STATE(3037),
    [sym_type_parameters] = STATE(2898),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2538] = {
    [aux_sym_string_repeat1] = STATE(2455),
    [anon_sym_DQUOTE] = ACTIONS(6089),
    [aux_sym_string_token1] = ACTIONS(5899),
    [sym_escape_sequence] = ACTIONS(5901),
    [sym_comment] = ACTIONS(5233),
  },
  [2539] = {
    [aux_sym_string_repeat2] = STATE(2516),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [aux_sym_string_token2] = ACTIONS(5958),
    [sym_escape_sequence] = ACTIONS(5960),
    [sym_comment] = ACTIONS(5233),
  },
  [2540] = {
    [sym_formal_parameters] = STATE(3181),
    [sym_type_parameters] = STATE(2861),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2541] = {
    [sym_template_string] = STATE(1440),
    [sym_arguments] = STATE(1440),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
  },
  [2542] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2524),
    [anon_sym_COMMA] = ACTIONS(5883),
    [anon_sym_SEMI] = ACTIONS(6091),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6091),
  },
  [2543] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2524),
    [anon_sym_COMMA] = ACTIONS(5883),
    [anon_sym_SEMI] = ACTIONS(6093),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6093),
  },
  [2544] = {
    [sym_statement_block] = STATE(508),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [anon_sym_SEMI] = ACTIONS(5932),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5932),
  },
  [2545] = {
    [sym_nested_identifier] = STATE(2770),
    [sym_jsx_namespace_name] = STATE(3208),
    [sym_identifier] = ACTIONS(6095),
    [sym_jsx_identifier] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2546] = {
    [anon_sym_SEMI] = ACTIONS(6099),
    [anon_sym_AMP] = ACTIONS(5177),
    [anon_sym_PIPE] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6099),
  },
  [2547] = {
    [sym__import_export_specifier] = STATE(2935),
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_type] = ACTIONS(5504),
    [anon_sym_typeof] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
  },
  [2548] = {
    [sym_template_string] = STATE(1040),
    [sym_arguments] = STATE(1040),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(611),
  },
  [2549] = {
    [aux_sym_string_repeat2] = STATE(2516),
    [anon_sym_SQUOTE] = ACTIONS(6101),
    [aux_sym_string_token2] = ACTIONS(5958),
    [sym_escape_sequence] = ACTIONS(5960),
    [sym_comment] = ACTIONS(5233),
  },
  [2550] = {
    [aux_sym_string_repeat1] = STATE(2455),
    [anon_sym_DQUOTE] = ACTIONS(6101),
    [aux_sym_string_token1] = ACTIONS(5899),
    [sym_escape_sequence] = ACTIONS(5901),
    [sym_comment] = ACTIONS(5233),
  },
  [2551] = {
    [anon_sym_from] = ACTIONS(6103),
    [anon_sym_SEMI] = ACTIONS(6103),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6103),
  },
  [2552] = {
    [sym__for_header] = STATE(36),
    [anon_sym_LPAREN] = ACTIONS(6105),
    [anon_sym_await] = ACTIONS(6107),
    [sym_comment] = ACTIONS(3),
  },
  [2553] = {
    [aux_sym_enum_body_repeat1] = STATE(2553),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_RBRACE] = ACTIONS(6087),
    [sym_comment] = ACTIONS(3),
  },
  [2554] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6112),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2555] = {
    [anon_sym_COMMA] = ACTIONS(6114),
    [anon_sym_SEMI] = ACTIONS(6114),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6114),
  },
  [2556] = {
    [sym__for_header] = STATE(33),
    [anon_sym_LPAREN] = ACTIONS(6116),
    [anon_sym_await] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
  },
  [2557] = {
    [anon_sym_COMMA] = ACTIONS(6120),
    [anon_sym_SEMI] = ACTIONS(6120),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6120),
  },
  [2558] = {
    [anon_sym_COMMA] = ACTIONS(6122),
    [anon_sym_SEMI] = ACTIONS(6122),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6122),
  },
  [2559] = {
    [anon_sym_COMMA] = ACTIONS(6124),
    [anon_sym_SEMI] = ACTIONS(6124),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6124),
  },
  [2560] = {
    [sym_identifier] = ACTIONS(6126),
    [anon_sym_SEMI] = ACTIONS(6128),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6128),
  },
  [2561] = {
    [anon_sym_COMMA] = ACTIONS(6130),
    [anon_sym_SEMI] = ACTIONS(6130),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6130),
  },
  [2562] = {
    [anon_sym_COMMA] = ACTIONS(6132),
    [anon_sym_SEMI] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6132),
  },
  [2563] = {
    [aux_sym_type_parameters_repeat1] = STATE(2670),
    [anon_sym_COMMA] = ACTIONS(6134),
    [anon_sym_GT] = ACTIONS(6136),
    [sym_comment] = ACTIONS(3),
  },
  [2564] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(6138),
    [sym_comment] = ACTIONS(3),
  },
  [2565] = {
    [anon_sym_COMMA] = ACTIONS(6140),
    [anon_sym_SEMI] = ACTIONS(6140),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6140),
  },
  [2566] = {
    [anon_sym_RBRACK] = ACTIONS(6142),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2567] = {
    [anon_sym_COMMA] = ACTIONS(6144),
    [anon_sym_SEMI] = ACTIONS(6144),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6144),
  },
  [2568] = {
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_SEMI] = ACTIONS(6146),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6146),
  },
  [2569] = {
    [anon_sym_COMMA] = ACTIONS(6148),
    [anon_sym_SEMI] = ACTIONS(6148),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6148),
  },
  [2570] = {
    [sym_type_parameter] = STATE(2961),
    [sym_identifier] = ACTIONS(6150),
    [anon_sym_GT] = ACTIONS(6136),
    [sym_comment] = ACTIONS(3),
  },
  [2571] = {
    [sym_identifier] = ACTIONS(6152),
    [anon_sym_SEMI] = ACTIONS(6154),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6154),
  },
  [2572] = {
    [anon_sym_COMMA] = ACTIONS(6156),
    [anon_sym_SEMI] = ACTIONS(6156),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6156),
  },
  [2573] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_GT] = ACTIONS(3366),
    [sym_comment] = ACTIONS(3),
  },
  [2574] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [sym_comment] = ACTIONS(3),
  },
  [2575] = {
    [sym__for_header] = STATE(51),
    [anon_sym_LPAREN] = ACTIONS(6162),
    [anon_sym_await] = ACTIONS(6164),
    [sym_comment] = ACTIONS(3),
  },
  [2576] = {
    [anon_sym_COMMA] = ACTIONS(6166),
    [anon_sym_SEMI] = ACTIONS(6166),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6166),
  },
  [2577] = {
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_SEMI] = ACTIONS(6168),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6168),
  },
  [2578] = {
    [anon_sym_COMMA] = ACTIONS(6170),
    [anon_sym_SEMI] = ACTIONS(6170),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6170),
  },
  [2579] = {
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_SEMI] = ACTIONS(6172),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6172),
  },
  [2580] = {
    [anon_sym_RPAREN] = ACTIONS(6174),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2581] = {
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_SEMI] = ACTIONS(6176),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6176),
  },
  [2582] = {
    [anon_sym_COMMA] = ACTIONS(6178),
    [anon_sym_SEMI] = ACTIONS(6178),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6178),
  },
  [2583] = {
    [anon_sym_RBRACK] = ACTIONS(6180),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2584] = {
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_EQ_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
  },
  [2585] = {
    [aux_sym_object_repeat1] = STATE(2603),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6182),
    [sym_comment] = ACTIONS(3),
  },
  [2586] = {
    [anon_sym_LBRACE] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6184),
    [sym_jsx_text] = ACTIONS(6184),
    [sym_comment] = ACTIONS(5233),
  },
  [2587] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6182),
    [sym_comment] = ACTIONS(3),
  },
  [2588] = {
    [anon_sym_from] = ACTIONS(6186),
    [anon_sym_SEMI] = ACTIONS(6186),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6186),
  },
  [2589] = {
    [sym_type_annotation] = STATE(2891),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(6188),
    [sym_comment] = ACTIONS(3),
  },
  [2590] = {
    [sym_type_parameters] = STATE(3116),
    [anon_sym_EQ] = ACTIONS(6191),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2591] = {
    [aux_sym_enum_body_repeat1] = STATE(2553),
    [anon_sym_COMMA] = ACTIONS(6193),
    [anon_sym_RBRACE] = ACTIONS(5001),
    [sym_comment] = ACTIONS(3),
  },
  [2592] = {
    [anon_sym_LBRACE] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(4339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4339),
  },
  [2593] = {
    [aux_sym_array_repeat1] = STATE(2605),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4323),
    [sym_comment] = ACTIONS(3),
  },
  [2594] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4323),
    [sym_comment] = ACTIONS(3),
  },
  [2595] = {
    [anon_sym_RBRACK] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2596] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
  },
  [2597] = {
    [aux_sym_array_repeat1] = STATE(2574),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
  },
  [2598] = {
    [anon_sym_LBRACE] = ACTIONS(6197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5676),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5676),
  },
  [2599] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(6199),
    [sym_comment] = ACTIONS(3),
  },
  [2600] = {
    [anon_sym_COMMA] = ACTIONS(6201),
    [anon_sym_SEMI] = ACTIONS(6201),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6201),
  },
  [2601] = {
    [anon_sym_COMMA] = ACTIONS(6203),
    [anon_sym_SEMI] = ACTIONS(6203),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6203),
  },
  [2602] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6205),
    [sym_comment] = ACTIONS(3),
  },
  [2603] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6207),
    [sym_comment] = ACTIONS(3),
  },
  [2604] = {
    [anon_sym_COMMA] = ACTIONS(6209),
    [anon_sym_SEMI] = ACTIONS(6209),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6209),
  },
  [2605] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(6211),
    [sym_comment] = ACTIONS(3),
  },
  [2606] = {
    [aux_sym_object_repeat1] = STATE(2754),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6213),
    [sym_comment] = ACTIONS(3),
  },
  [2607] = {
    [anon_sym_LBRACE] = ACTIONS(6215),
    [anon_sym_LT] = ACTIONS(6215),
    [sym_jsx_text] = ACTIONS(6215),
    [sym_comment] = ACTIONS(5233),
  },
  [2608] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(6217),
    [sym_comment] = ACTIONS(3),
  },
  [2609] = {
    [anon_sym_LBRACE] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5816),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5816),
  },
  [2610] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6213),
    [sym_comment] = ACTIONS(3),
  },
  [2611] = {
    [sym_nested_identifier] = STATE(3053),
    [sym_nested_type_identifier] = STATE(1160),
    [sym_identifier] = ACTIONS(6221),
    [sym_comment] = ACTIONS(3),
  },
  [2612] = {
    [sym_type_parameters] = STATE(3176),
    [anon_sym_EQ] = ACTIONS(6223),
    [anon_sym_LT] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [2613] = {
    [sym_nested_identifier] = STATE(2982),
    [sym_nested_type_identifier] = STATE(1932),
    [sym_identifier] = ACTIONS(6225),
    [sym_comment] = ACTIONS(3),
  },
  [2614] = {
    [aux_sym_array_repeat1] = STATE(2629),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(4331),
    [sym_comment] = ACTIONS(3),
  },
  [2615] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(4331),
    [sym_comment] = ACTIONS(3),
  },
  [2616] = {
    [anon_sym_LBRACE] = ACTIONS(5365),
    [anon_sym_COLON] = ACTIONS(5365),
    [anon_sym_EQ_GT] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
  },
  [2617] = {
    [anon_sym_COMMA] = ACTIONS(4335),
    [anon_sym_RPAREN] = ACTIONS(4335),
    [anon_sym_RBRACK] = ACTIONS(4335),
    [sym_comment] = ACTIONS(3),
  },
  [2618] = {
    [anon_sym_COMMA] = ACTIONS(6227),
    [anon_sym_SEMI] = ACTIONS(6227),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6227),
  },
  [2619] = {
    [sym_string] = STATE(3133),
    [anon_sym_DQUOTE] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [2620] = {
    [aux_sym_named_imports_repeat1] = STATE(2620),
    [anon_sym_COMMA] = ACTIONS(6229),
    [anon_sym_RBRACE] = ACTIONS(6232),
    [sym_comment] = ACTIONS(3),
  },
  [2621] = {
    [anon_sym_RPAREN] = ACTIONS(6234),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2622] = {
    [anon_sym_LBRACE] = ACTIONS(4412),
    [anon_sym_COMMA] = ACTIONS(4339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4339),
  },
  [2623] = {
    [anon_sym_while] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2624] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [sym_comment] = ACTIONS(3),
  },
  [2625] = {
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_from] = ACTIONS(6242),
    [sym_comment] = ACTIONS(3),
  },
  [2626] = {
    [aux_sym_export_clause_repeat1] = STATE(2626),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_RBRACE] = ACTIONS(6247),
    [sym_comment] = ACTIONS(3),
  },
  [2627] = {
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_COLON] = ACTIONS(3880),
    [anon_sym_EQ_GT] = ACTIONS(3880),
    [sym_comment] = ACTIONS(3),
  },
  [2628] = {
    [anon_sym_LBRACE] = ACTIONS(6249),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5726),
  },
  [2629] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(6251),
    [sym_comment] = ACTIONS(3),
  },
  [2630] = {
    [sym_statement_block] = STATE(511),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
  },
  [2631] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(6255),
    [anon_sym_GT] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
  },
  [2632] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2660),
    [anon_sym_COMMA] = ACTIONS(6257),
    [anon_sym_RPAREN] = ACTIONS(6259),
    [sym_comment] = ACTIONS(3),
  },
  [2633] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2634] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6263),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2635] = {
    [anon_sym_LBRACE] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5672),
    [sym_jsx_text] = ACTIONS(5672),
    [sym_comment] = ACTIONS(5233),
  },
  [2636] = {
    [sym_type_annotation] = STATE(2891),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(6265),
    [sym_comment] = ACTIONS(3),
  },
  [2637] = {
    [anon_sym_LBRACE] = ACTIONS(4095),
    [anon_sym_LT] = ACTIONS(4095),
    [sym_jsx_text] = ACTIONS(4095),
    [sym_comment] = ACTIONS(5233),
  },
  [2638] = {
    [sym_type_annotation] = STATE(2899),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(6268),
    [sym_comment] = ACTIONS(3),
  },
  [2639] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6271),
    [sym_comment] = ACTIONS(3),
  },
  [2640] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(6273),
    [sym_comment] = ACTIONS(3),
  },
  [2641] = {
    [aux_sym_enum_body_repeat1] = STATE(2591),
    [anon_sym_COMMA] = ACTIONS(5855),
    [anon_sym_RBRACE] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
  },
  [2642] = {
    [anon_sym_RBRACK] = ACTIONS(6275),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2643] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2677),
    [anon_sym_COMMA] = ACTIONS(6277),
    [anon_sym_RPAREN] = ACTIONS(4831),
    [sym_comment] = ACTIONS(3),
  },
  [2644] = {
    [sym_object_type] = STATE(553),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [2645] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6279),
    [sym_comment] = ACTIONS(3),
  },
  [2646] = {
    [aux_sym_array_repeat1] = STATE(2608),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4416),
    [sym_comment] = ACTIONS(3),
  },
  [2647] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4416),
    [sym_comment] = ACTIONS(3),
  },
  [2648] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(6281),
    [anon_sym_GT] = ACTIONS(3368),
    [sym_comment] = ACTIONS(3),
  },
  [2649] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(6283),
    [sym_comment] = ACTIONS(3),
  },
  [2650] = {
    [anon_sym_LBRACE] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4069),
    [sym_jsx_text] = ACTIONS(4069),
    [sym_comment] = ACTIONS(5233),
  },
  [2651] = {
    [anon_sym_LBRACE] = ACTIONS(4075),
    [anon_sym_LT] = ACTIONS(4075),
    [sym_jsx_text] = ACTIONS(4075),
    [sym_comment] = ACTIONS(5233),
  },
  [2652] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_LBRACE] = ACTIONS(6285),
    [anon_sym_COMMA] = ACTIONS(5736),
    [sym_comment] = ACTIONS(3),
  },
  [2653] = {
    [anon_sym_LBRACE] = ACTIONS(4153),
    [anon_sym_LT] = ACTIONS(4153),
    [sym_jsx_text] = ACTIONS(4153),
    [sym_comment] = ACTIONS(5233),
  },
  [2654] = {
    [anon_sym_RPAREN] = ACTIONS(6287),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2655] = {
    [anon_sym_LBRACE] = ACTIONS(4169),
    [anon_sym_LT] = ACTIONS(4169),
    [sym_jsx_text] = ACTIONS(4169),
    [sym_comment] = ACTIONS(5233),
  },
  [2656] = {
    [aux_sym_object_repeat1] = STATE(2672),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6289),
    [sym_comment] = ACTIONS(3),
  },
  [2657] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4384),
    [sym_comment] = ACTIONS(3),
  },
  [2658] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6289),
    [sym_comment] = ACTIONS(3),
  },
  [2659] = {
    [aux_sym_array_repeat1] = STATE(2624),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4384),
    [sym_comment] = ACTIONS(3),
  },
  [2660] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2679),
    [anon_sym_COMMA] = ACTIONS(6277),
    [anon_sym_RPAREN] = ACTIONS(4831),
    [sym_comment] = ACTIONS(3),
  },
  [2661] = {
    [aux_sym_type_parameters_repeat1] = STATE(2563),
    [anon_sym_COMMA] = ACTIONS(6291),
    [anon_sym_GT] = ACTIONS(6293),
    [sym_comment] = ACTIONS(3),
  },
  [2662] = {
    [anon_sym_LBRACE] = ACTIONS(5351),
    [anon_sym_COLON] = ACTIONS(5351),
    [anon_sym_EQ_GT] = ACTIONS(5351),
    [sym_comment] = ACTIONS(3),
  },
  [2663] = {
    [anon_sym_COMMA] = ACTIONS(4913),
    [anon_sym_SEMI] = ACTIONS(4913),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4913),
  },
  [2664] = {
    [aux_sym_array_repeat1] = STATE(2674),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4386),
    [sym_comment] = ACTIONS(3),
  },
  [2665] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4386),
    [sym_comment] = ACTIONS(3),
  },
  [2666] = {
    [anon_sym_COMMA] = ACTIONS(6295),
    [anon_sym_SEMI] = ACTIONS(6295),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6295),
  },
  [2667] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6297),
    [sym_comment] = ACTIONS(3),
  },
  [2668] = {
    [aux_sym_object_repeat1] = STATE(2639),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6297),
    [sym_comment] = ACTIONS(3),
  },
  [2669] = {
    [anon_sym_SEMI] = ACTIONS(6299),
    [anon_sym_DOT] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6299),
  },
  [2670] = {
    [aux_sym_type_parameters_repeat1] = STATE(2670),
    [anon_sym_COMMA] = ACTIONS(6301),
    [anon_sym_GT] = ACTIONS(6304),
    [sym_comment] = ACTIONS(3),
  },
  [2671] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6306),
    [sym_comment] = ACTIONS(3),
  },
  [2672] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6308),
    [sym_comment] = ACTIONS(3),
  },
  [2673] = {
    [sym_type_parameter] = STATE(2961),
    [sym_identifier] = ACTIONS(6150),
    [anon_sym_GT] = ACTIONS(6310),
    [sym_comment] = ACTIONS(3),
  },
  [2674] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [sym_comment] = ACTIONS(3),
  },
  [2675] = {
    [anon_sym_LBRACE] = ACTIONS(6314),
    [anon_sym_LT] = ACTIONS(6314),
    [sym_jsx_text] = ACTIONS(6314),
    [sym_comment] = ACTIONS(5233),
  },
  [2676] = {
    [anon_sym_LBRACE] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6316),
    [sym_jsx_text] = ACTIONS(6316),
    [sym_comment] = ACTIONS(5233),
  },
  [2677] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2679),
    [anon_sym_COMMA] = ACTIONS(6318),
    [anon_sym_RPAREN] = ACTIONS(4833),
    [sym_comment] = ACTIONS(3),
  },
  [2678] = {
    [sym_implements_clause] = STATE(3064),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5235),
  },
  [2679] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2679),
    [anon_sym_COMMA] = ACTIONS(6322),
    [anon_sym_RPAREN] = ACTIONS(6325),
    [sym_comment] = ACTIONS(3),
  },
  [2680] = {
    [sym_nested_identifier] = STATE(3076),
    [sym_nested_type_identifier] = STATE(1653),
    [sym_identifier] = ACTIONS(6327),
    [sym_comment] = ACTIONS(3),
  },
  [2681] = {
    [anon_sym_LBRACE] = ACTIONS(5387),
    [anon_sym_COLON] = ACTIONS(5387),
    [anon_sym_EQ_GT] = ACTIONS(5387),
    [sym_comment] = ACTIONS(3),
  },
  [2682] = {
    [anon_sym_COMMA] = ACTIONS(6329),
    [anon_sym_SEMI] = ACTIONS(6329),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6329),
  },
  [2683] = {
    [anon_sym_COMMA] = ACTIONS(6331),
    [anon_sym_SEMI] = ACTIONS(6331),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6331),
  },
  [2684] = {
    [anon_sym_COMMA] = ACTIONS(6065),
    [anon_sym_SEMI] = ACTIONS(6065),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6065),
  },
  [2685] = {
    [anon_sym_COMMA] = ACTIONS(6333),
    [anon_sym_SEMI] = ACTIONS(6333),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6333),
  },
  [2686] = {
    [anon_sym_RPAREN] = ACTIONS(6335),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2687] = {
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_COMMA] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2430),
  },
  [2688] = {
    [aux_sym_named_imports_repeat1] = STATE(2620),
    [anon_sym_COMMA] = ACTIONS(6337),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
  },
  [2689] = {
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2398),
  },
  [2690] = {
    [anon_sym_LBRACE] = ACTIONS(2547),
    [anon_sym_COMMA] = ACTIONS(2545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2545),
  },
  [2691] = {
    [anon_sym_LBRACE] = ACTIONS(2543),
    [anon_sym_COMMA] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2541),
  },
  [2692] = {
    [anon_sym_LBRACE] = ACTIONS(2561),
    [anon_sym_COMMA] = ACTIONS(2559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2559),
  },
  [2693] = {
    [aux_sym_export_clause_repeat1] = STATE(2626),
    [anon_sym_COMMA] = ACTIONS(6339),
    [anon_sym_RBRACE] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
  },
  [2694] = {
    [anon_sym_from] = ACTIONS(6341),
    [anon_sym_SEMI] = ACTIONS(6341),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6341),
  },
  [2695] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(6343),
    [anon_sym_GT] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
  },
  [2696] = {
    [anon_sym_as] = ACTIONS(6345),
    [anon_sym_COMMA] = ACTIONS(6347),
    [anon_sym_RBRACE] = ACTIONS(6347),
    [sym_comment] = ACTIONS(3),
  },
  [2697] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6349),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2698] = {
    [anon_sym_from] = ACTIONS(6351),
    [anon_sym_SEMI] = ACTIONS(6351),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6351),
  },
  [2699] = {
    [sym_string] = STATE(2896),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
  },
  [2700] = {
    [sym_type_annotation] = STATE(2891),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(6353),
    [sym_comment] = ACTIONS(3),
  },
  [2701] = {
    [anon_sym_LBRACE] = ACTIONS(5851),
    [anon_sym_LT] = ACTIONS(5851),
    [sym_jsx_text] = ACTIONS(5851),
    [sym_comment] = ACTIONS(5233),
  },
  [2702] = {
    [sym_type_annotation] = STATE(2899),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(6356),
    [sym_comment] = ACTIONS(3),
  },
  [2703] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
  },
  [2704] = {
    [aux_sym_object_repeat1] = STATE(2720),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6361),
    [sym_comment] = ACTIONS(3),
  },
  [2705] = {
    [anon_sym_RBRACK] = ACTIONS(6363),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2706] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6361),
    [sym_comment] = ACTIONS(3),
  },
  [2707] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2722),
    [anon_sym_COMMA] = ACTIONS(6365),
    [anon_sym_RPAREN] = ACTIONS(6367),
    [sym_comment] = ACTIONS(3),
  },
  [2708] = {
    [sym_object_type] = STATE(592),
    [anon_sym_LBRACE] = ACTIONS(3354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(847),
  },
  [2709] = {
    [aux_sym_array_repeat1] = STATE(2724),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [sym_comment] = ACTIONS(3),
  },
  [2710] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(4482),
    [sym_comment] = ACTIONS(3),
  },
  [2711] = {
    [sym_type_annotation] = STATE(2891),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
  },
  [2712] = {
    [aux_sym_type_parameters_repeat1] = STATE(2725),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_GT] = ACTIONS(6374),
    [sym_comment] = ACTIONS(3),
  },
  [2713] = {
    [aux_sym_enum_body_repeat1] = STATE(2553),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_RBRACE] = ACTIONS(4995),
    [sym_comment] = ACTIONS(3),
  },
  [2714] = {
    [anon_sym_from] = ACTIONS(6378),
    [anon_sym_SEMI] = ACTIONS(6378),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6378),
  },
  [2715] = {
    [anon_sym_as] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6382),
    [anon_sym_RBRACE] = ACTIONS(6382),
    [sym_comment] = ACTIONS(3),
  },
  [2716] = {
    [aux_sym_export_clause_repeat1] = STATE(2693),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_RBRACE] = ACTIONS(6386),
    [sym_comment] = ACTIONS(3),
  },
  [2717] = {
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2718] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6390),
    [sym_comment] = ACTIONS(3),
  },
  [2719] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6392),
    [sym_comment] = ACTIONS(3),
  },
  [2720] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6394),
    [sym_comment] = ACTIONS(3),
  },
  [2721] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [sym_comment] = ACTIONS(3),
  },
  [2722] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2679),
    [anon_sym_COMMA] = ACTIONS(6398),
    [anon_sym_RPAREN] = ACTIONS(4855),
    [sym_comment] = ACTIONS(3),
  },
  [2723] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2735),
    [anon_sym_COMMA] = ACTIONS(6398),
    [anon_sym_RPAREN] = ACTIONS(4855),
    [sym_comment] = ACTIONS(3),
  },
  [2724] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [sym_comment] = ACTIONS(3),
  },
  [2725] = {
    [aux_sym_type_parameters_repeat1] = STATE(2670),
    [anon_sym_COMMA] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6404),
    [sym_comment] = ACTIONS(3),
  },
  [2726] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
  },
  [2727] = {
    [aux_sym_array_repeat1] = STATE(2649),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
  },
  [2728] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(3394),
    [sym_comment] = ACTIONS(3),
  },
  [2729] = {
    [sym_nested_identifier] = STATE(3143),
    [sym_nested_type_identifier] = STATE(1521),
    [sym_identifier] = ACTIONS(6408),
    [sym_comment] = ACTIONS(3),
  },
  [2730] = {
    [anon_sym_COMMA] = ACTIONS(6410),
    [anon_sym_SEMI] = ACTIONS(6410),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6410),
  },
  [2731] = {
    [aux_sym_array_repeat1] = STATE(2741),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(4447),
    [sym_comment] = ACTIONS(3),
  },
  [2732] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(4447),
    [sym_comment] = ACTIONS(3),
  },
  [2733] = {
    [sym_type_annotation] = STATE(2899),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(6412),
    [sym_comment] = ACTIONS(3),
  },
  [2734] = {
    [sym_object_type] = STATE(2378),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [2735] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2679),
    [anon_sym_COMMA] = ACTIONS(6415),
    [anon_sym_RPAREN] = ACTIONS(4837),
    [sym_comment] = ACTIONS(3),
  },
  [2736] = {
    [anon_sym_SEMI] = ACTIONS(6417),
    [anon_sym_DOT] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6417),
  },
  [2737] = {
    [aux_sym_enum_body_repeat1] = STATE(2713),
    [anon_sym_COMMA] = ACTIONS(5770),
    [anon_sym_RBRACE] = ACTIONS(5772),
    [sym_comment] = ACTIONS(3),
  },
  [2738] = {
    [sym_nested_identifier] = STATE(2669),
    [sym_identifier] = ACTIONS(6419),
    [sym_comment] = ACTIONS(3),
    [anon_sym_require] = ACTIONS(6421),
  },
  [2739] = {
    [anon_sym_COMMA] = ACTIONS(6423),
    [anon_sym_SEMI] = ACTIONS(6423),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6423),
  },
  [2740] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(6425),
    [anon_sym_GT] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
  },
  [2741] = {
    [aux_sym_array_repeat1] = STATE(2496),
    [anon_sym_COMMA] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(6427),
    [sym_comment] = ACTIONS(3),
  },
  [2742] = {
    [aux_sym_implements_clause_repeat1] = STATE(2424),
    [anon_sym_COMMA] = ACTIONS(6429),
    [anon_sym_GT] = ACTIONS(3398),
    [sym_comment] = ACTIONS(3),
  },
  [2743] = {
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_from] = ACTIONS(6242),
    [sym_comment] = ACTIONS(3),
  },
  [2744] = {
    [aux_sym_named_imports_repeat1] = STATE(2688),
    [anon_sym_COMMA] = ACTIONS(6433),
    [anon_sym_RBRACE] = ACTIONS(6435),
    [sym_comment] = ACTIONS(3),
  },
  [2745] = {
    [sym_nested_identifier] = STATE(3014),
    [sym_nested_type_identifier] = STATE(438),
    [sym_identifier] = ACTIONS(6437),
    [sym_comment] = ACTIONS(3),
  },
  [2746] = {
    [sym_type_annotation] = STATE(2899),
    [anon_sym_COLON] = ACTIONS(3547),
    [anon_sym_EQ_GT] = ACTIONS(6439),
    [sym_comment] = ACTIONS(3),
  },
  [2747] = {
    [anon_sym_RPAREN] = ACTIONS(6442),
    [anon_sym_AMP] = ACTIONS(5171),
    [anon_sym_PIPE] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2748] = {
    [sym_object_type] = STATE(2364),
    [anon_sym_LBRACE] = ACTIONS(3454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(991),
  },
  [2749] = {
    [sym_type_parameter] = STATE(2961),
    [sym_identifier] = ACTIONS(6150),
    [anon_sym_GT] = ACTIONS(6444),
    [sym_comment] = ACTIONS(3),
  },
  [2750] = {
    [anon_sym_COMMA] = ACTIONS(6446),
    [anon_sym_SEMI] = ACTIONS(6446),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6446),
  },
  [2751] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6448),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2752] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(6450),
    [anon_sym_RBRACE] = ACTIONS(6453),
    [sym_comment] = ACTIONS(3),
  },
  [2753] = {
    [sym_type_parameter] = STATE(2961),
    [sym_identifier] = ACTIONS(6150),
    [anon_sym_GT] = ACTIONS(6404),
    [sym_comment] = ACTIONS(3),
  },
  [2754] = {
    [aux_sym_object_repeat1] = STATE(2752),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
  },
  [2755] = {
    [sym_statement_block] = STATE(1388),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2756] = {
    [sym_statement_block] = STATE(1503),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2757] = {
    [sym_class_body] = STATE(1090),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
  },
  [2758] = {
    [sym_class_body] = STATE(2254),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2759] = {
    [sym_class_body] = STATE(2261),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2760] = {
    [anon_sym_GT] = ACTIONS(6112),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2761] = {
    [sym_class_body] = STATE(1089),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
  },
  [2762] = {
    [sym_parenthesized_expression] = STATE(38),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2763] = {
    [sym_class_body] = STATE(1398),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2764] = {
    [sym_parenthesized_expression] = STATE(39),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2765] = {
    [sym_formal_parameters] = STATE(3142),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2766] = {
    [sym_formal_parameters] = STATE(3137),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2767] = {
    [anon_sym_COMMA] = ACTIONS(4979),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [sym_comment] = ACTIONS(3),
  },
  [2768] = {
    [sym_statement_block] = STATE(2809),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2769] = {
    [sym_parenthesized_expression] = STATE(2937),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2770] = {
    [anon_sym_GT] = ACTIONS(6448),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2771] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6448),
    [sym_comment] = ACTIONS(3),
  },
  [2772] = {
    [sym_parenthesized_expression] = STATE(37),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2773] = {
    [sym_parenthesized_expression] = STATE(34),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2774] = {
    [sym_parenthesized_expression] = STATE(32),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2775] = {
    [sym_class_body] = STATE(1692),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
  },
  [2776] = {
    [anon_sym_SEMI] = ACTIONS(6459),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6459),
  },
  [2777] = {
    [sym__from_clause] = STATE(2927),
    [anon_sym_from] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
  },
  [2778] = {
    [anon_sym_COMMA] = ACTIONS(4969),
    [anon_sym_RBRACE] = ACTIONS(4969),
    [sym_comment] = ACTIONS(3),
  },
  [2779] = {
    [sym_statement_block] = STATE(2818),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2780] = {
    [anon_sym_SEMI] = ACTIONS(6461),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6461),
  },
  [2781] = {
    [sym__from_clause] = STATE(2828),
    [anon_sym_from] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
  },
  [2782] = {
    [sym_type_annotation] = STATE(2335),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
  },
  [2783] = {
    [sym_type_annotation] = STATE(2203),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
  },
  [2784] = {
    [sym_parenthesized_expression] = STATE(50),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2785] = {
    [sym_statement_block] = STATE(464),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2786] = {
    [sym_class_body] = STATE(2439),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2787] = {
    [sym_statement_block] = STATE(1400),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2788] = {
    [sym_statement_block] = STATE(1085),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
  },
  [2789] = {
    [sym_class_body] = STATE(1693),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
  },
  [2790] = {
    [sym_statement_block] = STATE(1696),
    [anon_sym_LBRACE] = ACTIONS(6463),
    [sym_comment] = ACTIONS(3),
  },
  [2791] = {
    [sym_parenthesized_expression] = STATE(43),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2792] = {
    [sym_statement_block] = STATE(1702),
    [anon_sym_LBRACE] = ACTIONS(6463),
    [sym_comment] = ACTIONS(3),
  },
  [2793] = {
    [sym__for_header] = STATE(42),
    [anon_sym_LPAREN] = ACTIONS(6465),
    [sym_comment] = ACTIONS(3),
  },
  [2794] = {
    [sym_class_body] = STATE(1706),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
  },
  [2795] = {
    [sym_statement_block] = STATE(1708),
    [anon_sym_LBRACE] = ACTIONS(6463),
    [sym_comment] = ACTIONS(3),
  },
  [2796] = {
    [sym_class_body] = STATE(1409),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2797] = {
    [sym_class_body] = STATE(1715),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
  },
  [2798] = {
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
  },
  [2799] = {
    [sym_statement_block] = STATE(1080),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
  },
  [2800] = {
    [anon_sym_else] = ACTIONS(6467),
    [anon_sym_while] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
  },
  [2801] = {
    [sym_class_body] = STATE(1076),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
  },
  [2802] = {
    [sym_class_body] = STATE(2343),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2803] = {
    [anon_sym_SEMI] = ACTIONS(6469),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6469),
  },
  [2804] = {
    [sym_class_body] = STATE(1073),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
  },
  [2805] = {
    [sym_statement_block] = STATE(2916),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2806] = {
    [sym__for_header] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(6465),
    [sym_comment] = ACTIONS(3),
  },
  [2807] = {
    [anon_sym_SEMI] = ACTIONS(6471),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6471),
  },
  [2808] = {
    [sym_statement_block] = STATE(1683),
    [anon_sym_LBRACE] = ACTIONS(6463),
    [sym_comment] = ACTIONS(3),
  },
  [2809] = {
    [anon_sym_COMMA] = ACTIONS(4935),
    [anon_sym_RBRACE] = ACTIONS(4935),
    [sym_comment] = ACTIONS(3),
  },
  [2810] = {
    [sym_statement_block] = STATE(1092),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
  },
  [2811] = {
    [sym_statement_block] = STATE(1020),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
  },
  [2812] = {
    [sym_statement_block] = STATE(1057),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
  },
  [2813] = {
    [sym_class_body] = STATE(1055),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
  },
  [2814] = {
    [sym_statement_block] = STATE(2820),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2815] = {
    [anon_sym_COMMA] = ACTIONS(6453),
    [anon_sym_RBRACE] = ACTIONS(6453),
    [sym_comment] = ACTIONS(3),
  },
  [2816] = {
    [sym_parenthesized_expression] = STATE(49),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2817] = {
    [sym_parenthesized_expression] = STATE(30),
    [anon_sym_LPAREN] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2818] = {
    [anon_sym_COMMA] = ACTIONS(4941),
    [anon_sym_RBRACE] = ACTIONS(4941),
    [sym_comment] = ACTIONS(3),
  },
  [2819] = {
    [sym_statement_block] = STATE(2822),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2820] = {
    [anon_sym_COMMA] = ACTIONS(4945),
    [anon_sym_RBRACE] = ACTIONS(4945),
    [sym_comment] = ACTIONS(3),
  },
  [2821] = {
    [sym_statement_block] = STATE(2829),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2822] = {
    [anon_sym_COMMA] = ACTIONS(4953),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
  },
  [2823] = {
    [sym_class_body] = STATE(1093),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
  },
  [2824] = {
    [sym_nested_identifier] = STATE(1513),
    [sym_identifier] = ACTIONS(6473),
    [sym_comment] = ACTIONS(3),
  },
  [2825] = {
    [sym_class_body] = STATE(1345),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2826] = {
    [anon_sym_SEMI] = ACTIONS(4420),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4420),
  },
  [2827] = {
    [anon_sym_else] = ACTIONS(6475),
    [anon_sym_while] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
  },
  [2828] = {
    [anon_sym_SEMI] = ACTIONS(3556),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3556),
  },
  [2829] = {
    [anon_sym_COMMA] = ACTIONS(4975),
    [anon_sym_RBRACE] = ACTIONS(4975),
    [sym_comment] = ACTIONS(3),
  },
  [2830] = {
    [sym_formal_parameters] = STATE(2482),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2831] = {
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_RBRACE] = ACTIONS(6087),
    [sym_comment] = ACTIONS(3),
  },
  [2832] = {
    [sym_statement_block] = STATE(1666),
    [anon_sym_LBRACE] = ACTIONS(6463),
    [sym_comment] = ACTIONS(3),
  },
  [2833] = {
    [sym_statement_block] = STATE(505),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2834] = {
    [sym_statement_block] = STATE(517),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2835] = {
    [sym_statement_block] = STATE(522),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2836] = {
    [sym_formal_parameters] = STATE(3188),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2837] = {
    [sym_enum_body] = STATE(2286),
    [anon_sym_LBRACE] = ACTIONS(6477),
    [sym_comment] = ACTIONS(3),
  },
  [2838] = {
    [sym_identifier] = ACTIONS(6479),
    [sym_jsx_identifier] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
  },
  [2839] = {
    [sym__from_clause] = STATE(2885),
    [anon_sym_from] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
  },
  [2840] = {
    [sym_class_body] = STATE(1554),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2841] = {
    [sym_statement_block] = STATE(2925),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2842] = {
    [sym_statement_block] = STATE(1558),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2843] = {
    [sym_statement_block] = STATE(2778),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2844] = {
    [anon_sym_COMMA] = ACTIONS(4927),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [sym_comment] = ACTIONS(3),
  },
  [2845] = {
    [sym_statement_block] = STATE(2767),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2846] = {
    [sym_formal_parameters] = STATE(2700),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2847] = {
    [sym_nested_identifier] = STATE(476),
    [sym_identifier] = ACTIONS(6481),
    [sym_comment] = ACTIONS(3),
  },
  [2848] = {
    [sym_enum_body] = STATE(2357),
    [anon_sym_LBRACE] = ACTIONS(6477),
    [sym_comment] = ACTIONS(3),
  },
  [2849] = {
    [anon_sym_COMMA] = ACTIONS(4923),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [sym_comment] = ACTIONS(3),
  },
  [2850] = {
    [sym_nested_identifier] = STATE(2736),
    [sym_identifier] = ACTIONS(6483),
    [sym_comment] = ACTIONS(3),
  },
  [2851] = {
    [sym_statement_block] = STATE(2213),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [sym_comment] = ACTIONS(3),
  },
  [2852] = {
    [sym_class_body] = STATE(503),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2853] = {
    [sym_identifier] = ACTIONS(6485),
    [anon_sym_STAR] = ACTIONS(6487),
    [sym_comment] = ACTIONS(3),
  },
  [2854] = {
    [sym_statement_block] = STATE(1032),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
  },
  [2855] = {
    [sym_statement_block] = STATE(502),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [sym_comment] = ACTIONS(3),
  },
  [2856] = {
    [sym_class_body] = STATE(1651),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
  },
  [2857] = {
    [anon_sym_COMMA] = ACTIONS(6489),
    [anon_sym_RBRACE] = ACTIONS(6489),
    [sym_comment] = ACTIONS(3),
  },
  [2858] = {
    [sym_class_body] = STATE(1025),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
  },
  [2859] = {
    [sym_class_body] = STATE(125),
    [anon_sym_LBRACE] = ACTIONS(5241),
    [sym_comment] = ACTIONS(3),
  },
  [2860] = {
    [sym_identifier] = ACTIONS(6491),
    [anon_sym_STAR] = ACTIONS(6493),
    [sym_comment] = ACTIONS(3),
  },
  [2861] = {
    [sym_formal_parameters] = STATE(3126),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2862] = {
    [sym_type_parameter] = STATE(2712),
    [sym_identifier] = ACTIONS(6150),
    [sym_comment] = ACTIONS(3),
  },
  [2863] = {
    [sym_identifier] = ACTIONS(6495),
    [anon_sym_STAR] = ACTIONS(6497),
    [sym_comment] = ACTIONS(3),
  },
  [2864] = {
    [sym_class_body] = STATE(1644),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
  },
  [2865] = {
    [anon_sym_COMMA] = ACTIONS(6499),
    [anon_sym_RBRACE] = ACTIONS(6499),
    [sym_comment] = ACTIONS(3),
  },
  [2866] = {
    [sym_class_body] = STATE(552),
    [anon_sym_LBRACE] = ACTIONS(5261),
    [sym_comment] = ACTIONS(3),
  },
  [2867] = {
    [sym_statement_block] = STATE(121),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
  },
  [2868] = {
    [sym_class_body] = STATE(2214),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2869] = {
    [sym_formal_parameters] = STATE(2711),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2870] = {
    [sym_identifier] = ACTIONS(6501),
    [anon_sym_STAR] = ACTIONS(6503),
    [sym_comment] = ACTIONS(3),
  },
  [2871] = {
    [sym_statement_block] = STATE(2380),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [sym_comment] = ACTIONS(3),
  },
  [2872] = {
    [sym_enum_body] = STATE(524),
    [anon_sym_LBRACE] = ACTIONS(6505),
    [sym_comment] = ACTIONS(3),
  },
  [2873] = {
    [sym_statement_block] = STATE(1578),
    [anon_sym_LBRACE] = ACTIONS(6463),
    [sym_comment] = ACTIONS(3),
  },
  [2874] = {
    [sym_statement_block] = STATE(1594),
    [anon_sym_LBRACE] = ACTIONS(6463),
    [sym_comment] = ACTIONS(3),
  },
  [2875] = {
    [sym_class_body] = STATE(1381),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2876] = {
    [sym_class_body] = STATE(1637),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
  },
  [2877] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(3),
  },
  [2878] = {
    [sym_class_body] = STATE(2218),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2879] = {
    [sym_statement_block] = STATE(1100),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
  },
  [2880] = {
    [sym_formal_parameters] = STATE(2107),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
  },
  [2881] = {
    [sym_statement_block] = STATE(2390),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [sym_comment] = ACTIONS(3),
  },
  [2882] = {
    [sym_type_annotation] = STATE(2287),
    [anon_sym_COLON] = ACTIONS(3282),
    [sym_comment] = ACTIONS(3),
  },
  [2883] = {
    [anon_sym_SEMI] = ACTIONS(3803),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3803),
  },
  [2884] = {
    [sym_class_body] = STATE(1101),
    [anon_sym_LBRACE] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
  },
  [2885] = {
    [anon_sym_SEMI] = ACTIONS(3560),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3560),
  },
  [2886] = {
    [sym_type_parameter] = STATE(2961),
    [sym_identifier] = ACTIONS(6150),
    [sym_comment] = ACTIONS(3),
  },
  [2887] = {
    [sym_formal_parameters] = STATE(2636),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2888] = {
    [sym_statement_block] = STATE(1439),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2889] = {
    [sym_formal_parameters] = STATE(3154),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2890] = {
    [sym_formal_parameters] = STATE(3171),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2891] = {
    [anon_sym_LBRACE] = ACTIONS(5590),
    [anon_sym_EQ_GT] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
  },
  [2892] = {
    [sym_formal_parameters] = STATE(2018),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
  },
  [2893] = {
    [sym_statement_block] = STATE(1436),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2894] = {
    [sym_nested_identifier] = STATE(1152),
    [sym_identifier] = ACTIONS(6507),
    [sym_comment] = ACTIONS(3),
  },
  [2895] = {
    [sym_class_body] = STATE(1492),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2896] = {
    [anon_sym_SEMI] = ACTIONS(6509),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6509),
  },
  [2897] = {
    [anon_sym_SEMI] = ACTIONS(6511),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6511),
  },
  [2898] = {
    [sym_formal_parameters] = STATE(3079),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2899] = {
    [anon_sym_LBRACE] = ACTIONS(5652),
    [anon_sym_EQ_GT] = ACTIONS(5652),
    [sym_comment] = ACTIONS(3),
  },
  [2900] = {
    [anon_sym_GT] = ACTIONS(6349),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2901] = {
    [sym_formal_parameters] = STATE(3059),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2902] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6349),
    [sym_comment] = ACTIONS(3),
  },
  [2903] = {
    [anon_sym_COMMA] = ACTIONS(6513),
    [anon_sym_RPAREN] = ACTIONS(6513),
    [sym_comment] = ACTIONS(3),
  },
  [2904] = {
    [sym_nested_identifier] = STATE(2669),
    [sym_identifier] = ACTIONS(6515),
    [sym_comment] = ACTIONS(3),
  },
  [2905] = {
    [sym_type_parameter] = STATE(2661),
    [sym_identifier] = ACTIONS(6150),
    [sym_comment] = ACTIONS(3),
  },
  [2906] = {
    [sym_class_body] = STATE(501),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2907] = {
    [anon_sym_COMMA] = ACTIONS(6517),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [sym_comment] = ACTIONS(3),
  },
  [2908] = {
    [sym_enum_body] = STATE(546),
    [anon_sym_LBRACE] = ACTIONS(6505),
    [sym_comment] = ACTIONS(3),
  },
  [2909] = {
    [sym_statement_block] = STATE(1469),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2910] = {
    [sym_formal_parameters] = STATE(3000),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2911] = {
    [sym_statement_block] = STATE(541),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2912] = {
    [sym_formal_parameters] = STATE(2991),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2913] = {
    [sym_formal_parameters] = STATE(3024),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2914] = {
    [sym_nested_identifier] = STATE(1917),
    [sym_identifier] = ACTIONS(6519),
    [sym_comment] = ACTIONS(3),
  },
  [2915] = {
    [sym_statement_block] = STATE(2923),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2916] = {
    [anon_sym_COMMA] = ACTIONS(4949),
    [anon_sym_RBRACE] = ACTIONS(4949),
    [sym_comment] = ACTIONS(3),
  },
  [2917] = {
    [sym_class_body] = STATE(1548),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2918] = {
    [sym_statement_block] = STATE(1555),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2919] = {
    [anon_sym_COMMA] = ACTIONS(6521),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [sym_comment] = ACTIONS(3),
  },
  [2920] = {
    [sym_class_body] = STATE(1470),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2921] = {
    [sym_statement_block] = STATE(1468),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2922] = {
    [sym_class_body] = STATE(1465),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2923] = {
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [sym_comment] = ACTIONS(3),
  },
  [2924] = {
    [sym_statement_block] = STATE(2844),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2925] = {
    [anon_sym_COMMA] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [sym_comment] = ACTIONS(3),
  },
  [2926] = {
    [sym_statement_block] = STATE(2849),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2927] = {
    [anon_sym_SEMI] = ACTIONS(6523),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6523),
  },
  [2928] = {
    [sym_statement_block] = STATE(539),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
  },
  [2929] = {
    [sym_class_body] = STATE(515),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2930] = {
    [sym__from_clause] = STATE(2776),
    [anon_sym_from] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
  },
  [2931] = {
    [sym_statement_block] = STATE(1535),
    [anon_sym_LBRACE] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [2932] = {
    [anon_sym_SEMI] = ACTIONS(6525),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6525),
  },
  [2933] = {
    [sym_statement_block] = STATE(514),
    [anon_sym_LBRACE] = ACTIONS(5322),
    [sym_comment] = ACTIONS(3),
  },
  [2934] = {
    [sym_class_body] = STATE(512),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [sym_comment] = ACTIONS(3),
  },
  [2935] = {
    [anon_sym_COMMA] = ACTIONS(6527),
    [anon_sym_RBRACE] = ACTIONS(6527),
    [sym_comment] = ACTIONS(3),
  },
  [2936] = {
    [anon_sym_COMMA] = ACTIONS(6529),
    [anon_sym_RBRACE] = ACTIONS(6529),
    [sym_comment] = ACTIONS(3),
  },
  [2937] = {
    [sym_switch_body] = STATE(584),
    [anon_sym_LBRACE] = ACTIONS(6531),
    [sym_comment] = ACTIONS(3),
  },
  [2938] = {
    [sym__for_header] = STATE(29),
    [anon_sym_LPAREN] = ACTIONS(6465),
    [sym_comment] = ACTIONS(3),
  },
  [2939] = {
    [sym_class_body] = STATE(1457),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2940] = {
    [anon_sym_COMMA] = ACTIONS(6533),
    [anon_sym_RPAREN] = ACTIONS(6533),
    [sym_comment] = ACTIONS(3),
  },
  [2941] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6261),
    [sym_comment] = ACTIONS(3),
  },
  [2942] = {
    [anon_sym_COMMA] = ACTIONS(6535),
    [anon_sym_RPAREN] = ACTIONS(6535),
    [sym_comment] = ACTIONS(3),
  },
  [2943] = {
    [anon_sym_GT] = ACTIONS(6261),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2944] = {
    [anon_sym_GT] = ACTIONS(6263),
    [anon_sym_DOT] = ACTIONS(5065),
    [sym_comment] = ACTIONS(3),
  },
  [2945] = {
    [anon_sym_COLON] = ACTIONS(5128),
    [anon_sym_GT] = ACTIONS(6263),
    [sym_comment] = ACTIONS(3),
  },
  [2946] = {
    [anon_sym_COMMA] = ACTIONS(6537),
    [anon_sym_RPAREN] = ACTIONS(6537),
    [sym_comment] = ACTIONS(3),
  },
  [2947] = {
    [anon_sym_SEMI] = ACTIONS(6539),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6539),
  },
  [2948] = {
    [anon_sym_SEMI] = ACTIONS(6541),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6541),
  },
  [2949] = {
    [sym_formal_parameters] = STATE(2589),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2950] = {
    [sym_parenthesized_expression] = STATE(2955),
    [anon_sym_LPAREN] = ACTIONS(6543),
    [sym_comment] = ACTIONS(3),
  },
  [2951] = {
    [sym_class_body] = STATE(1549),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2952] = {
    [anon_sym_COMMA] = ACTIONS(6545),
    [anon_sym_RPAREN] = ACTIONS(6545),
    [sym_comment] = ACTIONS(3),
  },
  [2953] = {
    [anon_sym_SEMI] = ACTIONS(4445),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4445),
  },
  [2954] = {
    [sym_nested_identifier] = STATE(1659),
    [sym_identifier] = ACTIONS(6547),
    [sym_comment] = ACTIONS(3),
  },
  [2955] = {
    [anon_sym_SEMI] = ACTIONS(6549),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6549),
  },
  [2956] = {
    [anon_sym_SEMI] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4440),
  },
  [2957] = {
    [sym_class_body] = STATE(562),
    [anon_sym_LBRACE] = ACTIONS(5261),
    [sym_comment] = ACTIONS(3),
  },
  [2958] = {
    [sym_formal_parameters] = STATE(3183),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2959] = {
    [sym_nested_identifier] = STATE(1895),
    [sym_identifier] = ACTIONS(6551),
    [sym_comment] = ACTIONS(3),
  },
  [2960] = {
    [anon_sym_COMMA] = ACTIONS(6553),
    [anon_sym_GT] = ACTIONS(6553),
    [sym_comment] = ACTIONS(3),
  },
  [2961] = {
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_GT] = ACTIONS(6304),
    [sym_comment] = ACTIONS(3),
  },
  [2962] = {
    [sym_statement_block] = STATE(1592),
    [anon_sym_LBRACE] = ACTIONS(6463),
    [sym_comment] = ACTIONS(3),
  },
  [2963] = {
    [sym_statement_block] = STATE(137),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
  },
  [2964] = {
    [anon_sym_COMMA] = ACTIONS(6555),
    [anon_sym_RPAREN] = ACTIONS(6555),
    [sym_comment] = ACTIONS(3),
  },
  [2965] = {
    [sym_statement_block] = STATE(1091),
    [anon_sym_LBRACE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(3),
  },
  [2966] = {
    [sym_formal_parameters] = STATE(3164),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2967] = {
    [anon_sym_SEMI] = ACTIONS(3039),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3039),
  },
  [2968] = {
    [sym_class_body] = STATE(127),
    [anon_sym_LBRACE] = ACTIONS(5241),
    [sym_comment] = ACTIONS(3),
  },
  [2969] = {
    [sym_class_body] = STATE(117),
    [anon_sym_LBRACE] = ACTIONS(5241),
    [sym_comment] = ACTIONS(3),
  },
  [2970] = {
    [anon_sym_SEMI] = ACTIONS(3015),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3015),
  },
  [2971] = {
    [sym_class_body] = STATE(136),
    [anon_sym_LBRACE] = ACTIONS(5241),
    [sym_comment] = ACTIONS(3),
  },
  [2972] = {
    [sym_class_body] = STATE(1430),
    [anon_sym_LBRACE] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2973] = {
    [sym_class_body] = STATE(1596),
    [anon_sym_LBRACE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
  },
  [2974] = {
    [sym_formal_parameters] = STATE(3090),
    [anon_sym_LPAREN] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
  },
  [2975] = {
    [anon_sym_EQ_GT] = ACTIONS(6557),
    [sym_comment] = ACTIONS(3),
  },
  [2976] = {
    [sym_identifier] = ACTIONS(6559),
    [sym_comment] = ACTIONS(3),
  },
  [2977] = {
    [anon_sym_RPAREN] = ACTIONS(4015),
    [sym_comment] = ACTIONS(3),
  },
  [2978] = {
    [anon_sym_RPAREN] = ACTIONS(4047),
    [sym_comment] = ACTIONS(3),
  },
  [2979] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6561),
  },
  [2980] = {
    [sym_identifier] = ACTIONS(6563),
    [sym_comment] = ACTIONS(3),
  },
  [2981] = {
    [sym_identifier] = ACTIONS(6565),
    [sym_comment] = ACTIONS(3),
  },
  [2982] = {
    [anon_sym_DOT] = ACTIONS(5116),
    [sym_comment] = ACTIONS(3),
  },
  [2983] = {
    [sym_identifier] = ACTIONS(6567),
    [sym_comment] = ACTIONS(3),
  },
  [2984] = {
    [sym_identifier] = ACTIONS(6569),
    [sym_comment] = ACTIONS(3),
  },
  [2985] = {
    [anon_sym_RBRACK] = ACTIONS(6571),
    [sym_comment] = ACTIONS(3),
  },
  [2986] = {
    [anon_sym_RPAREN] = ACTIONS(6573),
    [sym_comment] = ACTIONS(3),
  },
  [2987] = {
    [anon_sym_GT] = ACTIONS(6575),
    [sym_comment] = ACTIONS(3),
  },
  [2988] = {
    [anon_sym_EQ_GT] = ACTIONS(6577),
    [sym_comment] = ACTIONS(3),
  },
  [2989] = {
    [anon_sym_EQ_GT] = ACTIONS(6579),
    [sym_comment] = ACTIONS(3),
  },
  [2990] = {
    [sym_comment] = ACTIONS(5233),
    [sym_regex_pattern] = ACTIONS(6581),
  },
  [2991] = {
    [anon_sym_EQ_GT] = ACTIONS(6583),
    [sym_comment] = ACTIONS(3),
  },
  [2992] = {
    [sym_identifier] = ACTIONS(6585),
    [sym_comment] = ACTIONS(3),
  },
  [2993] = {
    [anon_sym_COLON] = ACTIONS(6587),
    [sym_comment] = ACTIONS(3),
  },
  [2994] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_target] = ACTIONS(6589),
  },
  [2995] = {
    [sym_identifier] = ACTIONS(6591),
    [sym_comment] = ACTIONS(3),
  },
  [2996] = {
    [sym_identifier] = ACTIONS(6593),
    [sym_comment] = ACTIONS(3),
  },
  [2997] = {
    [anon_sym_GT] = ACTIONS(6595),
    [sym_comment] = ACTIONS(3),
  },
  [2998] = {
    [sym_identifier] = ACTIONS(6597),
    [sym_comment] = ACTIONS(3),
  },
  [2999] = {
    [anon_sym_COLON] = ACTIONS(6599),
    [sym_comment] = ACTIONS(3),
  },
  [3000] = {
    [anon_sym_EQ_GT] = ACTIONS(6601),
    [sym_comment] = ACTIONS(3),
  },
  [3001] = {
    [anon_sym_EQ_GT] = ACTIONS(6603),
    [sym_comment] = ACTIONS(3),
  },
  [3002] = {
    [anon_sym_EQ_GT] = ACTIONS(6605),
    [sym_comment] = ACTIONS(3),
  },
  [3003] = {
    [anon_sym_RPAREN] = ACTIONS(6607),
    [sym_comment] = ACTIONS(3),
  },
  [3004] = {
    [anon_sym_EQ_GT] = ACTIONS(6609),
    [sym_comment] = ACTIONS(3),
  },
  [3005] = {
    [anon_sym_EQ_GT] = ACTIONS(6611),
    [sym_comment] = ACTIONS(3),
  },
  [3006] = {
    [anon_sym_while] = ACTIONS(6613),
    [sym_comment] = ACTIONS(3),
  },
  [3007] = {
    [anon_sym_GT] = ACTIONS(6615),
    [sym_comment] = ACTIONS(3),
  },
  [3008] = {
    [anon_sym_LBRACE] = ACTIONS(6320),
    [sym_comment] = ACTIONS(3),
  },
  [3009] = {
    [anon_sym_GT] = ACTIONS(6261),
    [sym_comment] = ACTIONS(3),
  },
  [3010] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6617),
  },
  [3011] = {
    [anon_sym_GT] = ACTIONS(6263),
    [sym_comment] = ACTIONS(3),
  },
  [3012] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6619),
  },
  [3013] = {
    [anon_sym_RPAREN] = ACTIONS(4225),
    [sym_comment] = ACTIONS(3),
  },
  [3014] = {
    [anon_sym_DOT] = ACTIONS(5073),
    [sym_comment] = ACTIONS(3),
  },
  [3015] = {
    [anon_sym_EQ_GT] = ACTIONS(4905),
    [sym_comment] = ACTIONS(3),
  },
  [3016] = {
    [sym_identifier] = ACTIONS(6621),
    [sym_comment] = ACTIONS(3),
  },
  [3017] = {
    [sym_identifier] = ACTIONS(6623),
    [sym_comment] = ACTIONS(3),
  },
  [3018] = {
    [sym_identifier] = ACTIONS(6625),
    [sym_comment] = ACTIONS(3),
  },
  [3019] = {
    [anon_sym_COLON] = ACTIONS(6627),
    [sym_comment] = ACTIONS(3),
  },
  [3020] = {
    [anon_sym_RPAREN] = ACTIONS(6629),
    [sym_comment] = ACTIONS(3),
  },
  [3021] = {
    [sym_identifier] = ACTIONS(6631),
    [sym_comment] = ACTIONS(3),
  },
  [3022] = {
    [anon_sym_GT] = ACTIONS(6633),
    [sym_comment] = ACTIONS(3),
  },
  [3023] = {
    [anon_sym_EQ_GT] = ACTIONS(6075),
    [sym_comment] = ACTIONS(3),
  },
  [3024] = {
    [anon_sym_EQ_GT] = ACTIONS(6635),
    [sym_comment] = ACTIONS(3),
  },
  [3025] = {
    [anon_sym_EQ_GT] = ACTIONS(6637),
    [sym_comment] = ACTIONS(3),
  },
  [3026] = {
    [anon_sym_EQ_GT] = ACTIONS(6639),
    [sym_comment] = ACTIONS(3),
  },
  [3027] = {
    [sym_identifier] = ACTIONS(6641),
    [sym_comment] = ACTIONS(3),
  },
  [3028] = {
    [anon_sym_from] = ACTIONS(6242),
    [sym_comment] = ACTIONS(3),
  },
  [3029] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_target] = ACTIONS(6643),
  },
  [3030] = {
    [anon_sym_EQ_GT] = ACTIONS(6645),
    [sym_comment] = ACTIONS(3),
  },
  [3031] = {
    [anon_sym_EQ_GT] = ACTIONS(6647),
    [sym_comment] = ACTIONS(3),
  },
  [3032] = {
    [anon_sym_EQ_GT] = ACTIONS(6649),
    [sym_comment] = ACTIONS(3),
  },
  [3033] = {
    [anon_sym_EQ_GT] = ACTIONS(6651),
    [sym_comment] = ACTIONS(3),
  },
  [3034] = {
    [anon_sym_from] = ACTIONS(6653),
    [sym_comment] = ACTIONS(3),
  },
  [3035] = {
    [anon_sym_LPAREN] = ACTIONS(6655),
    [sym_comment] = ACTIONS(3),
  },
  [3036] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_require] = ACTIONS(6657),
  },
  [3037] = {
    [anon_sym_EQ_GT] = ACTIONS(6659),
    [sym_comment] = ACTIONS(3),
  },
  [3038] = {
    [anon_sym_EQ_GT] = ACTIONS(6661),
    [sym_comment] = ACTIONS(3),
  },
  [3039] = {
    [sym_identifier] = ACTIONS(6663),
    [sym_comment] = ACTIONS(3),
  },
  [3040] = {
    [sym_identifier] = ACTIONS(6665),
    [sym_comment] = ACTIONS(3),
  },
  [3041] = {
    [anon_sym_from] = ACTIONS(6667),
    [sym_comment] = ACTIONS(3),
  },
  [3042] = {
    [sym_comment] = ACTIONS(5233),
    [sym_regex_pattern] = ACTIONS(6669),
  },
  [3043] = {
    [sym_identifier] = ACTIONS(6671),
    [sym_comment] = ACTIONS(3),
  },
  [3044] = {
    [anon_sym_from] = ACTIONS(6673),
    [sym_comment] = ACTIONS(3),
  },
  [3045] = {
    [anon_sym_from] = ACTIONS(6675),
    [sym_comment] = ACTIONS(3),
  },
  [3046] = {
    [anon_sym_from] = ACTIONS(6677),
    [sym_comment] = ACTIONS(3),
  },
  [3047] = {
    [anon_sym_EQ_GT] = ACTIONS(6679),
    [sym_comment] = ACTIONS(3),
  },
  [3048] = {
    [anon_sym_GT] = ACTIONS(6681),
    [sym_comment] = ACTIONS(3),
  },
  [3049] = {
    [anon_sym_GT] = ACTIONS(6683),
    [sym_comment] = ACTIONS(3),
  },
  [3050] = {
    [anon_sym_as] = ACTIONS(6685),
    [sym_comment] = ACTIONS(3),
  },
  [3051] = {
    [anon_sym_GT] = ACTIONS(6687),
    [sym_comment] = ACTIONS(3),
  },
  [3052] = {
    [anon_sym_COLON] = ACTIONS(4612),
    [sym_comment] = ACTIONS(3),
  },
  [3053] = {
    [anon_sym_DOT] = ACTIONS(3740),
    [sym_comment] = ACTIONS(3),
  },
  [3054] = {
    [sym_identifier] = ACTIONS(6689),
    [sym_comment] = ACTIONS(3),
  },
  [3055] = {
    [sym_identifier] = ACTIONS(6691),
    [sym_comment] = ACTIONS(3),
  },
  [3056] = {
    [anon_sym_RPAREN] = ACTIONS(4610),
    [sym_comment] = ACTIONS(3),
  },
  [3057] = {
    [anon_sym_RPAREN] = ACTIONS(4608),
    [sym_comment] = ACTIONS(3),
  },
  [3058] = {
    [anon_sym_RPAREN] = ACTIONS(4601),
    [sym_comment] = ACTIONS(3),
  },
  [3059] = {
    [anon_sym_EQ_GT] = ACTIONS(6693),
    [sym_comment] = ACTIONS(3),
  },
  [3060] = {
    [sym_identifier] = ACTIONS(6695),
    [sym_comment] = ACTIONS(3),
  },
  [3061] = {
    [anon_sym_RPAREN] = ACTIONS(4575),
    [sym_comment] = ACTIONS(3),
  },
  [3062] = {
    [sym_identifier] = ACTIONS(6697),
    [sym_comment] = ACTIONS(3),
  },
  [3063] = {
    [anon_sym_GT] = ACTIONS(6699),
    [sym_comment] = ACTIONS(3),
  },
  [3064] = {
    [anon_sym_LBRACE] = ACTIONS(6701),
    [sym_comment] = ACTIONS(3),
  },
  [3065] = {
    [anon_sym_RPAREN] = ACTIONS(6703),
    [sym_comment] = ACTIONS(3),
  },
  [3066] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6705),
  },
  [3067] = {
    [anon_sym_EQ_GT] = ACTIONS(6707),
    [sym_comment] = ACTIONS(3),
  },
  [3068] = {
    [anon_sym_RPAREN] = ACTIONS(6709),
    [sym_comment] = ACTIONS(3),
  },
  [3069] = {
    [anon_sym_DOT] = ACTIONS(6711),
    [sym_comment] = ACTIONS(3),
  },
  [3070] = {
    [sym_identifier] = ACTIONS(6713),
    [sym_comment] = ACTIONS(3),
  },
  [3071] = {
    [anon_sym_RPAREN] = ACTIONS(6715),
    [sym_comment] = ACTIONS(3),
  },
  [3072] = {
    [anon_sym_GT] = ACTIONS(6717),
    [sym_comment] = ACTIONS(3),
  },
  [3073] = {
    [anon_sym_GT] = ACTIONS(6349),
    [sym_comment] = ACTIONS(3),
  },
  [3074] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6719),
  },
  [3075] = {
    [anon_sym_EQ_GT] = ACTIONS(6721),
    [sym_comment] = ACTIONS(3),
  },
  [3076] = {
    [anon_sym_DOT] = ACTIONS(4536),
    [sym_comment] = ACTIONS(3),
  },
  [3077] = {
    [sym_identifier] = ACTIONS(6723),
    [sym_comment] = ACTIONS(3),
  },
  [3078] = {
    [anon_sym_RBRACE] = ACTIONS(4520),
    [sym_comment] = ACTIONS(3),
  },
  [3079] = {
    [anon_sym_EQ_GT] = ACTIONS(6725),
    [sym_comment] = ACTIONS(3),
  },
  [3080] = {
    [anon_sym_EQ_GT] = ACTIONS(6727),
    [sym_comment] = ACTIONS(3),
  },
  [3081] = {
    [sym_identifier] = ACTIONS(6729),
    [sym_comment] = ACTIONS(3),
  },
  [3082] = {
    [anon_sym_GT] = ACTIONS(6731),
    [sym_comment] = ACTIONS(3),
  },
  [3083] = {
    [anon_sym_RPAREN] = ACTIONS(6733),
    [sym_comment] = ACTIONS(3),
  },
  [3084] = {
    [anon_sym_RPAREN] = ACTIONS(4188),
    [sym_comment] = ACTIONS(3),
  },
  [3085] = {
    [sym_identifier] = ACTIONS(6735),
    [sym_comment] = ACTIONS(3),
  },
  [3086] = {
    [sym_identifier] = ACTIONS(6737),
    [sym_comment] = ACTIONS(3),
  },
  [3087] = {
    [anon_sym_RBRACK] = ACTIONS(6739),
    [sym_comment] = ACTIONS(3),
  },
  [3088] = {
    [sym_identifier] = ACTIONS(6741),
    [sym_comment] = ACTIONS(3),
  },
  [3089] = {
    [anon_sym_class] = ACTIONS(6743),
    [sym_comment] = ACTIONS(3),
  },
  [3090] = {
    [anon_sym_EQ_GT] = ACTIONS(6745),
    [sym_comment] = ACTIONS(3),
  },
  [3091] = {
    [anon_sym_RPAREN] = ACTIONS(4587),
    [sym_comment] = ACTIONS(3),
  },
  [3092] = {
    [anon_sym_RPAREN] = ACTIONS(4571),
    [sym_comment] = ACTIONS(3),
  },
  [3093] = {
    [sym_identifier] = ACTIONS(6747),
    [sym_comment] = ACTIONS(3),
  },
  [3094] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6749),
  },
  [3095] = {
    [sym_identifier] = ACTIONS(6751),
    [sym_comment] = ACTIONS(3),
  },
  [3096] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6753),
  },
  [3097] = {
    [anon_sym_RBRACE] = ACTIONS(6755),
    [sym_comment] = ACTIONS(3),
  },
  [3098] = {
    [sym_identifier] = ACTIONS(6757),
    [sym_comment] = ACTIONS(3),
  },
  [3099] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6759),
  },
  [3100] = {
    [anon_sym_COLON] = ACTIONS(6761),
    [sym_comment] = ACTIONS(3),
  },
  [3101] = {
    [anon_sym_RBRACK] = ACTIONS(4603),
    [sym_comment] = ACTIONS(3),
  },
  [3102] = {
    [anon_sym_EQ_GT] = ACTIONS(6763),
    [sym_comment] = ACTIONS(3),
  },
  [3103] = {
    [anon_sym_EQ] = ACTIONS(6765),
    [sym_comment] = ACTIONS(3),
  },
  [3104] = {
    [sym_identifier] = ACTIONS(6767),
    [sym_comment] = ACTIONS(3),
  },
  [3105] = {
    [anon_sym_EQ_GT] = ACTIONS(6769),
    [sym_comment] = ACTIONS(3),
  },
  [3106] = {
    [anon_sym_RPAREN] = ACTIONS(3899),
    [sym_comment] = ACTIONS(3),
  },
  [3107] = {
    [anon_sym_EQ_GT] = ACTIONS(6771),
    [sym_comment] = ACTIONS(3),
  },
  [3108] = {
    [anon_sym_EQ_GT] = ACTIONS(6773),
    [sym_comment] = ACTIONS(3),
  },
  [3109] = {
    [sym_identifier] = ACTIONS(6775),
    [sym_comment] = ACTIONS(3),
  },
  [3110] = {
    [anon_sym_function] = ACTIONS(6777),
    [sym_comment] = ACTIONS(3),
  },
  [3111] = {
    [anon_sym_EQ_GT] = ACTIONS(6779),
    [sym_comment] = ACTIONS(3),
  },
  [3112] = {
    [anon_sym_EQ_GT] = ACTIONS(6781),
    [sym_comment] = ACTIONS(3),
  },
  [3113] = {
    [anon_sym_EQ_GT] = ACTIONS(6783),
    [sym_comment] = ACTIONS(3),
  },
  [3114] = {
    [anon_sym_EQ] = ACTIONS(6785),
    [sym_comment] = ACTIONS(3),
  },
  [3115] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_target] = ACTIONS(6787),
  },
  [3116] = {
    [anon_sym_EQ] = ACTIONS(6789),
    [sym_comment] = ACTIONS(3),
  },
  [3117] = {
    [sym_identifier] = ACTIONS(6791),
    [sym_comment] = ACTIONS(3),
  },
  [3118] = {
    [sym_identifier] = ACTIONS(6793),
    [sym_comment] = ACTIONS(3),
  },
  [3119] = {
    [sym_identifier] = ACTIONS(6795),
    [sym_comment] = ACTIONS(3),
  },
  [3120] = {
    [sym_identifier] = ACTIONS(6797),
    [sym_comment] = ACTIONS(3),
  },
  [3121] = {
    [sym_identifier] = ACTIONS(6799),
    [sym_comment] = ACTIONS(3),
  },
  [3122] = {
    [sym_identifier] = ACTIONS(6801),
    [sym_comment] = ACTIONS(3),
  },
  [3123] = {
    [sym_identifier] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
  },
  [3124] = {
    [anon_sym_EQ_GT] = ACTIONS(6805),
    [sym_comment] = ACTIONS(3),
  },
  [3125] = {
    [sym_identifier] = ACTIONS(6807),
    [sym_comment] = ACTIONS(3),
  },
  [3126] = {
    [anon_sym_EQ_GT] = ACTIONS(6809),
    [sym_comment] = ACTIONS(3),
  },
  [3127] = {
    [anon_sym_namespace] = ACTIONS(6811),
    [sym_comment] = ACTIONS(3),
  },
  [3128] = {
    [sym_identifier] = ACTIONS(6813),
    [sym_comment] = ACTIONS(3),
  },
  [3129] = {
    [sym_identifier] = ACTIONS(6815),
    [sym_comment] = ACTIONS(3),
  },
  [3130] = {
    [anon_sym_namespace] = ACTIONS(6817),
    [sym_comment] = ACTIONS(3),
  },
  [3131] = {
    [anon_sym_EQ_GT] = ACTIONS(6819),
    [sym_comment] = ACTIONS(3),
  },
  [3132] = {
    [anon_sym_from] = ACTIONS(6821),
    [sym_comment] = ACTIONS(3),
  },
  [3133] = {
    [anon_sym_RPAREN] = ACTIONS(6823),
    [sym_comment] = ACTIONS(3),
  },
  [3134] = {
    [anon_sym_RPAREN] = ACTIONS(4529),
    [sym_comment] = ACTIONS(3),
  },
  [3135] = {
    [anon_sym_RPAREN] = ACTIONS(4527),
    [sym_comment] = ACTIONS(3),
  },
  [3136] = {
    [anon_sym_EQ_GT] = ACTIONS(6825),
    [sym_comment] = ACTIONS(3),
  },
  [3137] = {
    [anon_sym_EQ_GT] = ACTIONS(6827),
    [sym_comment] = ACTIONS(3),
  },
  [3138] = {
    [anon_sym_RPAREN] = ACTIONS(4518),
    [sym_comment] = ACTIONS(3),
  },
  [3139] = {
    [anon_sym_RPAREN] = ACTIONS(4512),
    [sym_comment] = ACTIONS(3),
  },
  [3140] = {
    [anon_sym_GT] = ACTIONS(6829),
    [sym_comment] = ACTIONS(3),
  },
  [3141] = {
    [anon_sym_RBRACK] = ACTIONS(4516),
    [sym_comment] = ACTIONS(3),
  },
  [3142] = {
    [anon_sym_EQ_GT] = ACTIONS(6831),
    [sym_comment] = ACTIONS(3),
  },
  [3143] = {
    [anon_sym_DOT] = ACTIONS(4432),
    [sym_comment] = ACTIONS(3),
  },
  [3144] = {
    [anon_sym_RPAREN] = ACTIONS(6833),
    [sym_comment] = ACTIONS(3),
  },
  [3145] = {
    [anon_sym_RBRACK] = ACTIONS(6835),
    [sym_comment] = ACTIONS(3),
  },
  [3146] = {
    [anon_sym_EQ_GT] = ACTIONS(6837),
    [sym_comment] = ACTIONS(3),
  },
  [3147] = {
    [sym_identifier] = ACTIONS(6839),
    [sym_comment] = ACTIONS(3),
  },
  [3148] = {
    [anon_sym_EQ_GT] = ACTIONS(6841),
    [sym_comment] = ACTIONS(3),
  },
  [3149] = {
    [anon_sym_GT] = ACTIONS(6843),
    [sym_comment] = ACTIONS(3),
  },
  [3150] = {
    [anon_sym_GT] = ACTIONS(6845),
    [sym_comment] = ACTIONS(3),
  },
  [3151] = {
    [sym_identifier] = ACTIONS(6847),
    [sym_comment] = ACTIONS(3),
  },
  [3152] = {
    [anon_sym_EQ_GT] = ACTIONS(6849),
    [sym_comment] = ACTIONS(3),
  },
  [3153] = {
    [anon_sym_GT] = ACTIONS(6851),
    [sym_comment] = ACTIONS(3),
  },
  [3154] = {
    [anon_sym_EQ_GT] = ACTIONS(6853),
    [sym_comment] = ACTIONS(3),
  },
  [3155] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6855),
  },
  [3156] = {
    [sym_identifier] = ACTIONS(6857),
    [sym_comment] = ACTIONS(3),
  },
  [3157] = {
    [anon_sym_GT] = ACTIONS(6859),
    [sym_comment] = ACTIONS(3),
  },
  [3158] = {
    [anon_sym_EQ_GT] = ACTIONS(6861),
    [sym_comment] = ACTIONS(3),
  },
  [3159] = {
    [ts_builtin_sym_end] = ACTIONS(6863),
    [sym_comment] = ACTIONS(3),
  },
  [3160] = {
    [sym_identifier] = ACTIONS(6865),
    [sym_comment] = ACTIONS(3),
  },
  [3161] = {
    [sym_identifier] = ACTIONS(6867),
    [sym_comment] = ACTIONS(3),
  },
  [3162] = {
    [anon_sym_class] = ACTIONS(6869),
    [sym_comment] = ACTIONS(3),
  },
  [3163] = {
    [sym_identifier] = ACTIONS(6871),
    [sym_comment] = ACTIONS(3),
  },
  [3164] = {
    [anon_sym_EQ_GT] = ACTIONS(6873),
    [sym_comment] = ACTIONS(3),
  },
  [3165] = {
    [sym_identifier] = ACTIONS(6875),
    [sym_comment] = ACTIONS(3),
  },
  [3166] = {
    [sym_identifier] = ACTIONS(6877),
    [sym_comment] = ACTIONS(3),
  },
  [3167] = {
    [sym_identifier] = ACTIONS(6879),
    [sym_comment] = ACTIONS(3),
  },
  [3168] = {
    [anon_sym_EQ_GT] = ACTIONS(6881),
    [sym_comment] = ACTIONS(3),
  },
  [3169] = {
    [anon_sym_EQ] = ACTIONS(6883),
    [sym_comment] = ACTIONS(3),
  },
  [3170] = {
    [anon_sym_EQ] = ACTIONS(6885),
    [sym_comment] = ACTIONS(3),
  },
  [3171] = {
    [anon_sym_EQ_GT] = ACTIONS(6887),
    [sym_comment] = ACTIONS(3),
  },
  [3172] = {
    [sym_comment] = ACTIONS(5233),
    [sym_regex_pattern] = ACTIONS(6889),
  },
  [3173] = {
    [anon_sym_RBRACK] = ACTIONS(4522),
    [sym_comment] = ACTIONS(3),
  },
  [3174] = {
    [sym_identifier] = ACTIONS(6891),
    [sym_comment] = ACTIONS(3),
  },
  [3175] = {
    [anon_sym_RBRACE] = ACTIONS(4531),
    [sym_comment] = ACTIONS(3),
  },
  [3176] = {
    [anon_sym_EQ] = ACTIONS(6893),
    [sym_comment] = ACTIONS(3),
  },
  [3177] = {
    [anon_sym_EQ_GT] = ACTIONS(6895),
    [sym_comment] = ACTIONS(3),
  },
  [3178] = {
    [anon_sym_GT] = ACTIONS(6897),
    [sym_comment] = ACTIONS(3),
  },
  [3179] = {
    [anon_sym_RPAREN] = ACTIONS(4573),
    [sym_comment] = ACTIONS(3),
  },
  [3180] = {
    [anon_sym_GT] = ACTIONS(6899),
    [sym_comment] = ACTIONS(3),
  },
  [3181] = {
    [anon_sym_EQ_GT] = ACTIONS(6901),
    [sym_comment] = ACTIONS(3),
  },
  [3182] = {
    [sym_identifier] = ACTIONS(6903),
    [sym_comment] = ACTIONS(3),
  },
  [3183] = {
    [anon_sym_EQ_GT] = ACTIONS(6905),
    [sym_comment] = ACTIONS(3),
  },
  [3184] = {
    [anon_sym_GT] = ACTIONS(6907),
    [sym_comment] = ACTIONS(3),
  },
  [3185] = {
    [sym_identifier] = ACTIONS(6909),
    [sym_comment] = ACTIONS(3),
  },
  [3186] = {
    [anon_sym_RBRACE] = ACTIONS(4557),
    [sym_comment] = ACTIONS(3),
  },
  [3187] = {
    [sym_identifier] = ACTIONS(6911),
    [sym_comment] = ACTIONS(3),
  },
  [3188] = {
    [anon_sym_EQ_GT] = ACTIONS(6913),
    [sym_comment] = ACTIONS(3),
  },
  [3189] = {
    [sym_identifier] = ACTIONS(6915),
    [sym_comment] = ACTIONS(3),
  },
  [3190] = {
    [anon_sym_COLON] = ACTIONS(6917),
    [sym_comment] = ACTIONS(3),
  },
  [3191] = {
    [sym_identifier] = ACTIONS(6919),
    [sym_comment] = ACTIONS(3),
  },
  [3192] = {
    [sym_identifier] = ACTIONS(6921),
    [sym_comment] = ACTIONS(3),
  },
  [3193] = {
    [anon_sym_RBRACE] = ACTIONS(6923),
    [sym_comment] = ACTIONS(3),
  },
  [3194] = {
    [sym_identifier] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
  },
  [3195] = {
    [sym_identifier] = ACTIONS(6927),
    [sym_comment] = ACTIONS(3),
  },
  [3196] = {
    [sym_identifier] = ACTIONS(6929),
    [sym_comment] = ACTIONS(3),
  },
  [3197] = {
    [sym_identifier] = ACTIONS(6931),
    [sym_comment] = ACTIONS(3),
  },
  [3198] = {
    [anon_sym_function] = ACTIONS(6933),
    [sym_comment] = ACTIONS(3),
  },
  [3199] = {
    [anon_sym_from] = ACTIONS(6935),
    [sym_comment] = ACTIONS(3),
  },
  [3200] = {
    [sym_comment] = ACTIONS(5233),
    [sym_regex_pattern] = ACTIONS(6937),
  },
  [3201] = {
    [sym_identifier] = ACTIONS(6939),
    [sym_comment] = ACTIONS(3),
  },
  [3202] = {
    [sym_identifier] = ACTIONS(6941),
    [sym_comment] = ACTIONS(3),
  },
  [3203] = {
    [sym_identifier] = ACTIONS(6943),
    [sym_comment] = ACTIONS(3),
  },
  [3204] = {
    [sym_identifier] = ACTIONS(6945),
    [sym_comment] = ACTIONS(3),
  },
  [3205] = {
    [sym_identifier] = ACTIONS(6947),
    [sym_comment] = ACTIONS(3),
  },
  [3206] = {
    [sym_identifier] = ACTIONS(6949),
    [sym_comment] = ACTIONS(3),
  },
  [3207] = {
    [sym_identifier] = ACTIONS(6951),
    [sym_comment] = ACTIONS(3),
  },
  [3208] = {
    [anon_sym_GT] = ACTIONS(6448),
    [sym_comment] = ACTIONS(3),
  },
  [3209] = {
    [anon_sym_GT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(3),
  },
  [3210] = {
    [sym_identifier] = ACTIONS(6953),
    [sym_comment] = ACTIONS(3),
  },
  [3211] = {
    [sym_identifier] = ACTIONS(6955),
    [sym_comment] = ACTIONS(3),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(831),
  [9] = {.count = 1, .reusable = true}, SHIFT(17),
  [11] = {.count = 1, .reusable = false}, SHIFT(413),
  [13] = {.count = 1, .reusable = false}, SHIFT(649),
  [15] = {.count = 1, .reusable = true}, SHIFT(4),
  [17] = {.count = 1, .reusable = false}, SHIFT(794),
  [19] = {.count = 1, .reusable = false}, SHIFT(266),
  [21] = {.count = 1, .reusable = false}, SHIFT(928),
  [23] = {.count = 1, .reusable = false}, SHIFT(2122),
  [25] = {.count = 1, .reusable = false}, SHIFT(2121),
  [27] = {.count = 1, .reusable = false}, SHIFT(2108),
  [29] = {.count = 1, .reusable = false}, SHIFT(2764),
  [31] = {.count = 1, .reusable = false}, SHIFT(2769),
  [33] = {.count = 1, .reusable = false}, SHIFT(2556),
  [35] = {.count = 1, .reusable = true}, SHIFT(143),
  [37] = {.count = 1, .reusable = false}, SHIFT(351),
  [39] = {.count = 1, .reusable = false}, SHIFT(2784),
  [41] = {.count = 1, .reusable = false}, SHIFT(55),
  [43] = {.count = 1, .reusable = false}, SHIFT(2785),
  [45] = {.count = 1, .reusable = false}, SHIFT(2791),
  [47] = {.count = 1, .reusable = false}, SHIFT(2560),
  [49] = {.count = 1, .reusable = false}, SHIFT(2571),
  [51] = {.count = 1, .reusable = false}, SHIFT(2807),
  [53] = {.count = 1, .reusable = false}, SHIFT(170),
  [55] = {.count = 1, .reusable = false}, SHIFT(178),
  [57] = {.count = 1, .reusable = true}, SHIFT(499),
  [59] = {.count = 1, .reusable = false}, SHIFT(108),
  [61] = {.count = 1, .reusable = true}, SHIFT(159),
  [63] = {.count = 1, .reusable = true}, SHIFT(2170),
  [65] = {.count = 1, .reusable = false}, SHIFT(3172),
  [67] = {.count = 1, .reusable = false}, SHIFT(1924),
  [69] = {.count = 1, .reusable = false}, SHIFT(498),
  [71] = {.count = 1, .reusable = false}, SHIFT(2048),
  [73] = {.count = 1, .reusable = false}, SHIFT(185),
  [75] = {.count = 1, .reusable = false}, SHIFT(365),
  [77] = {.count = 1, .reusable = true}, SHIFT(366),
  [79] = {.count = 1, .reusable = false}, SHIFT(69),
  [81] = {.count = 1, .reusable = true}, SHIFT(374),
  [83] = {.count = 1, .reusable = true}, SHIFT(2486),
  [85] = {.count = 1, .reusable = true}, SHIFT(2494),
  [87] = {.count = 1, .reusable = true}, SHIFT(2182),
  [89] = {.count = 1, .reusable = true}, SHIFT(1270),
  [91] = {.count = 1, .reusable = false}, SHIFT(1270),
  [93] = {.count = 1, .reusable = false}, SHIFT(1163),
  [95] = {.count = 1, .reusable = true}, SHIFT(1856),
  [97] = {.count = 1, .reusable = false}, SHIFT(832),
  [99] = {.count = 1, .reusable = false}, SHIFT(3162),
  [101] = {.count = 1, .reusable = false}, SHIFT(421),
  [103] = {.count = 1, .reusable = false}, SHIFT(643),
  [105] = {.count = 1, .reusable = false}, SHIFT(3161),
  [107] = {.count = 1, .reusable = false}, SHIFT(3160),
  [109] = {.count = 1, .reusable = false}, SHIFT(692),
  [111] = {.count = 1, .reusable = false}, SHIFT(246),
  [113] = {.count = 1, .reusable = true}, SHIFT(1848),
  [115] = {.count = 1, .reusable = false}, SHIFT(626),
  [117] = {.count = 1, .reusable = true}, SHIFT(1301),
  [119] = {.count = 1, .reusable = true}, SHIFT(966),
  [121] = {.count = 1, .reusable = false}, SHIFT(661),
  [123] = {.count = 1, .reusable = true}, SHIFT(158),
  [125] = {.count = 1, .reusable = false}, SHIFT(427),
  [127] = {.count = 1, .reusable = true}, SHIFT(384),
  [129] = {.count = 1, .reusable = false}, SHIFT(57),
  [131] = {.count = 1, .reusable = true}, SHIFT(1466),
  [133] = {.count = 1, .reusable = false}, SHIFT(457),
  [135] = {.count = 1, .reusable = false}, SHIFT(455),
  [137] = {.count = 1, .reusable = false}, SHIFT(412),
  [139] = {.count = 1, .reusable = false}, SHIFT(492),
  [141] = {.count = 1, .reusable = false}, SHIFT(625),
  [143] = {.count = 1, .reusable = false}, SHIFT(681),
  [145] = {.count = 1, .reusable = false}, SHIFT(459),
  [147] = {.count = 1, .reusable = false}, SHIFT(697),
  [149] = {.count = 1, .reusable = false}, SHIFT(239),
  [151] = {.count = 1, .reusable = false}, SHIFT(629),
  [153] = {.count = 1, .reusable = true}, SHIFT(1342),
  [155] = {.count = 1, .reusable = false}, SHIFT(677),
  [157] = {.count = 1, .reusable = false}, SHIFT(428),
  [159] = {.count = 1, .reusable = false}, SHIFT(59),
  [161] = {.count = 1, .reusable = false}, SHIFT(450),
  [163] = {.count = 1, .reusable = false}, SHIFT(453),
  [165] = {.count = 1, .reusable = false}, SHIFT(414),
  [167] = {.count = 1, .reusable = false}, SHIFT(494),
  [169] = {.count = 1, .reusable = false}, SHIFT(627),
  [171] = {.count = 1, .reusable = false}, SHIFT(706),
  [173] = {.count = 1, .reusable = false}, SHIFT(458),
  [175] = {.count = 1, .reusable = true}, SHIFT(115),
  [177] = {.count = 1, .reusable = false}, SHIFT(686),
  [179] = {.count = 1, .reusable = false}, SHIFT(196),
  [181] = {.count = 1, .reusable = false}, SHIFT(630),
  [183] = {.count = 1, .reusable = true}, SHIFT(1393),
  [185] = {.count = 1, .reusable = false}, SHIFT(672),
  [187] = {.count = 1, .reusable = false}, SHIFT(424),
  [189] = {.count = 1, .reusable = false}, SHIFT(58),
  [191] = {.count = 1, .reusable = false}, SHIFT(456),
  [193] = {.count = 1, .reusable = false}, SHIFT(454),
  [195] = {.count = 1, .reusable = false}, SHIFT(411),
  [197] = {.count = 1, .reusable = false}, SHIFT(483),
  [199] = {.count = 1, .reusable = false}, SHIFT(624),
  [201] = {.count = 1, .reusable = false}, SHIFT(698),
  [203] = {.count = 1, .reusable = false}, SHIFT(451),
  [205] = {.count = 1, .reusable = true}, SHIFT(1314),
  [207] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [209] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(831),
  [212] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(413),
  [215] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [217] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(649),
  [220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [223] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(794),
  [226] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(266),
  [229] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(928),
  [232] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2122),
  [235] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2121),
  [238] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2108),
  [241] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2764),
  [244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2769),
  [247] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2556),
  [250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(143),
  [253] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(351),
  [256] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2784),
  [259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(55),
  [262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2785),
  [265] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2791),
  [268] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2560),
  [271] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2571),
  [274] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2807),
  [277] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(170),
  [280] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(178),
  [283] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(499),
  [286] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(108),
  [289] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(159),
  [292] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2170),
  [295] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3172),
  [298] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1924),
  [301] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(498),
  [304] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2048),
  [307] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(185),
  [310] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(365),
  [313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(366),
  [316] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(69),
  [319] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(374),
  [322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2486),
  [325] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2494),
  [328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2182),
  [331] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1270),
  [334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1270),
  [337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1163),
  [340] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1856),
  [343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(832),
  [346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3162),
  [349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(421),
  [352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(643),
  [355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3161),
  [358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3160),
  [361] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3, .production_id = 78),
  [363] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3, .production_id = 78),
  [365] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4, .production_id = 78),
  [367] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4, .production_id = 78),
  [369] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [371] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [373] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [375] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [377] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [379] = {.count = 1, .reusable = true}, SHIFT(1467),
  [381] = {.count = 1, .reusable = true}, SHIFT(1791),
  [383] = {.count = 1, .reusable = true}, SHIFT(1442),
  [385] = {.count = 1, .reusable = true}, SHIFT(462),
  [387] = {.count = 1, .reusable = true}, SHIFT(1206),
  [389] = {.count = 1, .reusable = true}, SHIFT(470),
  [391] = {.count = 1, .reusable = true}, SHIFT(1810),
  [393] = {.count = 1, .reusable = true}, SHIFT(474),
  [395] = {.count = 1, .reusable = true}, SHIFT(1275),
  [397] = {.count = 1, .reusable = true}, SHIFT(993),
  [399] = {.count = 1, .reusable = true}, SHIFT(982),
  [401] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [403] = {.count = 1, .reusable = true}, SHIFT(463),
  [405] = {.count = 1, .reusable = true}, SHIFT(135),
  [407] = {.count = 1, .reusable = true}, SHIFT(118),
  [409] = {.count = 1, .reusable = false}, SHIFT(829),
  [411] = {.count = 1, .reusable = false}, SHIFT(416),
  [413] = {.count = 1, .reusable = false}, SHIFT(647),
  [415] = {.count = 1, .reusable = true}, SHIFT(6),
  [417] = {.count = 1, .reusable = false}, SHIFT(723),
  [419] = {.count = 1, .reusable = false}, SHIFT(2762),
  [421] = {.count = 1, .reusable = false}, SHIFT(2575),
  [423] = {.count = 1, .reusable = false}, SHIFT(2817),
  [425] = {.count = 1, .reusable = false}, SHIFT(2816),
  [427] = {.count = 1, .reusable = false}, SHIFT(1963),
  [429] = {.count = 1, .reusable = false}, SHIFT(500),
  [431] = {.count = 1, .reusable = false}, SHIFT(2084),
  [433] = {.count = 1, .reusable = false}, SHIFT(71),
  [435] = {.count = 1, .reusable = false}, SHIFT(828),
  [437] = {.count = 1, .reusable = false}, SHIFT(419),
  [439] = {.count = 1, .reusable = false}, SHIFT(646),
  [441] = {.count = 1, .reusable = false}, SHIFT(834),
  [443] = {.count = 1, .reusable = false}, SHIFT(415),
  [445] = {.count = 1, .reusable = false}, SHIFT(640),
  [447] = {.count = 1, .reusable = false}, SHIFT(729),
  [449] = {.count = 1, .reusable = false}, SHIFT(2772),
  [451] = {.count = 1, .reusable = false}, SHIFT(2552),
  [453] = {.count = 1, .reusable = false}, SHIFT(2773),
  [455] = {.count = 1, .reusable = false}, SHIFT(2774),
  [457] = {.count = 1, .reusable = false}, SHIFT(497),
  [459] = {.count = 1, .reusable = false}, SHIFT(70),
  [461] = {.count = 1, .reusable = false}, SHIFT(839),
  [463] = {.count = 1, .reusable = false}, SHIFT(420),
  [465] = {.count = 1, .reusable = false}, SHIFT(648),
  [467] = {.count = 1, .reusable = false}, SHIFT(847),
  [469] = {.count = 1, .reusable = false}, SHIFT(857),
  [471] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [473] = {.count = 1, .reusable = false}, SHIFT(312),
  [475] = {.count = 1, .reusable = false}, SHIFT(634),
  [477] = {.count = 1, .reusable = true}, SHIFT(1140),
  [479] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [481] = {.count = 1, .reusable = true}, SHIFT(971),
  [483] = {.count = 1, .reusable = false}, SHIFT(1530),
  [485] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(48),
  [488] = {.count = 1, .reusable = false}, SHIFT(2170),
  [490] = {.count = 1, .reusable = false}, SHIFT(2976),
  [492] = {.count = 1, .reusable = false}, SHIFT(1955),
  [494] = {.count = 1, .reusable = false}, SHIFT(506),
  [496] = {.count = 1, .reusable = false}, SHIFT(2089),
  [498] = {.count = 1, .reusable = true}, SHIFT(245),
  [500] = {.count = 1, .reusable = true}, SHIFT(349),
  [502] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [505] = {.count = 1, .reusable = false}, SHIFT(366),
  [507] = {.count = 1, .reusable = false}, SHIFT(72),
  [509] = {.count = 1, .reusable = true}, SHIFT(1132),
  [511] = {.count = 1, .reusable = false}, SHIFT(1132),
  [513] = {.count = 1, .reusable = true}, SHIFT(1413),
  [515] = {.count = 1, .reusable = true}, SHIFT(1067),
  [517] = {.count = 1, .reusable = false}, SHIFT(866),
  [519] = {.count = 1, .reusable = false}, SHIFT(878),
  [521] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [523] = {.count = 1, .reusable = false}, SHIFT(271),
  [525] = {.count = 1, .reusable = false}, SHIFT(657),
  [527] = {.count = 1, .reusable = true}, SHIFT(1044),
  [529] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [531] = {.count = 1, .reusable = false}, SHIFT(386),
  [533] = {.count = 1, .reusable = false}, SHIFT(1125),
  [535] = {.count = 1, .reusable = false}, SHIFT(388),
  [537] = {.count = 1, .reusable = false}, SHIFT(109),
  [539] = {.count = 1, .reusable = false}, SHIFT(3077),
  [541] = {.count = 1, .reusable = false}, SHIFT(1926),
  [543] = {.count = 1, .reusable = false}, SHIFT(551),
  [545] = {.count = 1, .reusable = false}, SHIFT(2113),
  [547] = {.count = 1, .reusable = true}, SHIFT(209),
  [549] = {.count = 1, .reusable = false}, SHIFT(201),
  [551] = {.count = 1, .reusable = true}, SHIFT(272),
  [553] = {.count = 1, .reusable = true}, SHIFT(397),
  [555] = {.count = 1, .reusable = false}, SHIFT(79),
  [557] = {.count = 1, .reusable = true}, SHIFT(2514),
  [559] = {.count = 1, .reusable = true}, SHIFT(2512),
  [561] = {.count = 1, .reusable = true}, SHIFT(1282),
  [563] = {.count = 1, .reusable = false}, SHIFT(1282),
  [565] = {.count = 1, .reusable = false}, SHIFT(955),
  [567] = {.count = 1, .reusable = false}, SHIFT(820),
  [569] = {.count = 1, .reusable = false}, SHIFT(806),
  [571] = {.count = 1, .reusable = false}, SHIFT(341),
  [573] = {.count = 1, .reusable = false}, SHIFT(632),
  [575] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [578] = {.count = 1, .reusable = false}, SHIFT(370),
  [580] = {.count = 1, .reusable = true}, SHIFT(145),
  [582] = {.count = 1, .reusable = false}, SHIFT(364),
  [584] = {.count = 1, .reusable = false}, SHIFT(105),
  [586] = {.count = 1, .reusable = true}, SHIFT(150),
  [588] = {.count = 1, .reusable = false}, SHIFT(2137),
  [590] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [593] = {.count = 1, .reusable = false}, SHIFT(3200),
  [595] = {.count = 1, .reusable = false}, SHIFT(487),
  [597] = {.count = 1, .reusable = false}, SHIFT(248),
  [599] = {.count = 1, .reusable = true}, SHIFT(322),
  [601] = {.count = 1, .reusable = false}, SHIFT(284),
  [603] = {.count = 1, .reusable = false}, SHIFT(290),
  [605] = {.count = 1, .reusable = true}, SHIFT(290),
  [607] = {.count = 1, .reusable = false}, SHIFT(64),
  [609] = {.count = 1, .reusable = true}, SHIFT(315),
  [611] = {.count = 1, .reusable = true}, SHIFT(2145),
  [613] = {.count = 1, .reusable = true}, SHIFT(990),
  [615] = {.count = 1, .reusable = false}, SHIFT(990),
  [617] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [619] = {.count = 1, .reusable = true}, SHIFT(216),
  [621] = {.count = 1, .reusable = false}, SHIFT(259),
  [623] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(176),
  [626] = {.count = 1, .reusable = false}, SHIFT(176),
  [628] = {.count = 1, .reusable = false}, SHIFT(398),
  [630] = {.count = 1, .reusable = false}, SHIFT(397),
  [632] = {.count = 1, .reusable = true}, SHIFT(396),
  [634] = {.count = 1, .reusable = true}, SHIFT(48),
  [636] = {.count = 1, .reusable = true}, SHIFT(56),
  [638] = {.count = 1, .reusable = true}, SHIFT(53),
  [640] = {.count = 1, .reusable = true}, SHIFT(2046),
  [642] = {.count = 1, .reusable = true}, SHIFT(186),
  [644] = {.count = 1, .reusable = false}, SHIFT(3027),
  [646] = {.count = 1, .reusable = true}, SHIFT(230),
  [648] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(341),
  [651] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [654] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [658] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [660] = {.count = 1, .reusable = true}, SHIFT(251),
  [662] = {.count = 1, .reusable = false}, SHIFT(897),
  [664] = {.count = 1, .reusable = false}, SHIFT(894),
  [666] = {.count = 1, .reusable = false}, SHIFT(354),
  [668] = {.count = 1, .reusable = false}, SHIFT(659),
  [670] = {.count = 1, .reusable = false}, SHIFT(270),
  [672] = {.count = 1, .reusable = false}, SHIFT(371),
  [674] = {.count = 1, .reusable = false}, SHIFT(111),
  [676] = {.count = 1, .reusable = false}, SHIFT(609),
  [678] = {.count = 1, .reusable = false}, SHIFT(236),
  [680] = {.count = 1, .reusable = true}, SHIFT(256),
  [682] = {.count = 1, .reusable = false}, SHIFT(265),
  [684] = {.count = 1, .reusable = false}, SHIFT(283),
  [686] = {.count = 1, .reusable = true}, SHIFT(283),
  [688] = {.count = 1, .reusable = false}, SHIFT(82),
  [690] = {.count = 1, .reusable = true}, SHIFT(338),
  [692] = {.count = 1, .reusable = true}, SHIFT(1369),
  [694] = {.count = 1, .reusable = false}, SHIFT(1369),
  [696] = {.count = 1, .reusable = false}, SHIFT(859),
  [698] = {.count = 1, .reusable = false}, SHIFT(887),
  [700] = {.count = 1, .reusable = false}, SHIFT(334),
  [702] = {.count = 1, .reusable = false}, SHIFT(651),
  [704] = {.count = 1, .reusable = false}, SHIFT(1029),
  [706] = {.count = 1, .reusable = false}, SHIFT(361),
  [708] = {.count = 1, .reusable = false}, SHIFT(1675),
  [710] = {.count = 1, .reusable = true}, SHIFT(144),
  [712] = {.count = 1, .reusable = false}, SHIFT(362),
  [714] = {.count = 1, .reusable = false}, SHIFT(112),
  [716] = {.count = 1, .reusable = true}, SHIFT(157),
  [718] = {.count = 1, .reusable = false}, SHIFT(2157),
  [720] = {.count = 1, .reusable = false}, SHIFT(3042),
  [722] = {.count = 1, .reusable = false}, SHIFT(1949),
  [724] = {.count = 1, .reusable = false}, SHIFT(572),
  [726] = {.count = 1, .reusable = false}, SHIFT(2062),
  [728] = {.count = 1, .reusable = false}, SHIFT(177),
  [730] = {.count = 1, .reusable = true}, SHIFT(292),
  [732] = {.count = 1, .reusable = false}, SHIFT(287),
  [734] = {.count = 1, .reusable = false}, SHIFT(377),
  [736] = {.count = 1, .reusable = true}, SHIFT(377),
  [738] = {.count = 1, .reusable = false}, SHIFT(88),
  [740] = {.count = 1, .reusable = true}, SHIFT(387),
  [742] = {.count = 1, .reusable = true}, SHIFT(2477),
  [744] = {.count = 1, .reusable = true}, SHIFT(2479),
  [746] = {.count = 1, .reusable = true}, SHIFT(2154),
  [748] = {.count = 1, .reusable = true}, SHIFT(1303),
  [750] = {.count = 1, .reusable = false}, SHIFT(1303),
  [752] = {.count = 1, .reusable = false}, SHIFT(1264),
  [754] = {.count = 1, .reusable = false}, SHIFT(874),
  [756] = {.count = 1, .reusable = false}, SHIFT(868),
  [758] = {.count = 1, .reusable = false}, SHIFT(404),
  [760] = {.count = 1, .reusable = false}, SHIFT(653),
  [762] = {.count = 1, .reusable = false}, SHIFT(355),
  [764] = {.count = 1, .reusable = false}, SHIFT(350),
  [766] = {.count = 1, .reusable = false}, SHIFT(110),
  [768] = {.count = 1, .reusable = false}, SHIFT(2990),
  [770] = {.count = 1, .reusable = false}, SHIFT(528),
  [772] = {.count = 1, .reusable = false}, SHIFT(197),
  [774] = {.count = 1, .reusable = true}, SHIFT(402),
  [776] = {.count = 1, .reusable = false}, SHIFT(279),
  [778] = {.count = 1, .reusable = false}, SHIFT(278),
  [780] = {.count = 1, .reusable = true}, SHIFT(278),
  [782] = {.count = 1, .reusable = false}, SHIFT(87),
  [784] = {.count = 1, .reusable = true}, SHIFT(276),
  [786] = {.count = 1, .reusable = true}, SHIFT(1288),
  [788] = {.count = 1, .reusable = false}, SHIFT(1288),
  [790] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(225),
  [793] = {.count = 1, .reusable = false}, SHIFT(225),
  [795] = {.count = 1, .reusable = false}, SHIFT(809),
  [797] = {.count = 1, .reusable = false}, SHIFT(870),
  [799] = {.count = 1, .reusable = true}, SHIFT(444),
  [801] = {.count = 1, .reusable = false}, SHIFT(654),
  [803] = {.count = 1, .reusable = false}, SHIFT(637),
  [805] = {.count = 1, .reusable = false}, SHIFT(206),
  [807] = {.count = 1, .reusable = true}, SHIFT(91),
  [809] = {.count = 1, .reusable = true}, SHIFT(2627),
  [811] = {.count = 1, .reusable = true}, SHIFT(95),
  [813] = {.count = 1, .reusable = true}, SHIFT(2137),
  [815] = {.count = 1, .reusable = false}, SHIFT(566),
  [817] = {.count = 1, .reusable = false}, SHIFT(182),
  [819] = {.count = 1, .reusable = true}, SHIFT(3017),
  [821] = {.count = 1, .reusable = true}, SHIFT(980),
  [823] = {.count = 1, .reusable = true}, SHIFT(732),
  [825] = {.count = 1, .reusable = true}, SHIFT(737),
  [827] = {.count = 1, .reusable = false}, SHIFT(356),
  [829] = {.count = 1, .reusable = false}, SHIFT(76),
  [831] = {.count = 1, .reusable = true}, SHIFT(1704),
  [833] = {.count = 1, .reusable = false}, SHIFT(1473),
  [835] = {.count = 1, .reusable = false}, SHIFT(1704),
  [837] = {.count = 1, .reusable = false}, SHIFT(1043),
  [839] = {.count = 1, .reusable = false}, SHIFT(611),
  [841] = {.count = 1, .reusable = false}, SHIFT(862),
  [843] = {.count = 1, .reusable = false}, SHIFT(571),
  [845] = {.count = 1, .reusable = false}, SHIFT(2745),
  [847] = {.count = 1, .reusable = true}, SHIFT(913),
  [849] = {.count = 1, .reusable = false}, SHIFT(1031),
  [851] = {.count = 1, .reusable = false}, SHIFT(1124),
  [853] = {.count = 1, .reusable = false}, SHIFT(842),
  [855] = {.count = 1, .reusable = false}, SHIFT(650),
  [857] = {.count = 1, .reusable = true}, SHIFT(155),
  [859] = {.count = 1, .reusable = false}, SHIFT(208),
  [861] = {.count = 1, .reusable = true}, SHIFT(963),
  [863] = {.count = 1, .reusable = false}, SHIFT(358),
  [865] = {.count = 1, .reusable = false}, SHIFT(83),
  [867] = {.count = 1, .reusable = true}, SHIFT(1735),
  [869] = {.count = 1, .reusable = false}, SHIFT(1723),
  [871] = {.count = 1, .reusable = false}, SHIFT(1735),
  [873] = {.count = 1, .reusable = false}, SHIFT(1219),
  [875] = {.count = 1, .reusable = false}, SHIFT(900),
  [877] = {.count = 1, .reusable = true}, SHIFT(1414),
  [879] = {.count = 1, .reusable = false}, SHIFT(1220),
  [881] = {.count = 1, .reusable = true}, SHIFT(2434),
  [883] = {.count = 1, .reusable = false}, SHIFT(1207),
  [885] = {.count = 1, .reusable = true}, SHIFT(1118),
  [887] = {.count = 1, .reusable = false}, SHIFT(1269),
  [889] = {.count = 1, .reusable = false}, SHIFT(676),
  [891] = {.count = 1, .reusable = false}, SHIFT(642),
  [893] = {.count = 1, .reusable = false}, SHIFT(181),
  [895] = {.count = 1, .reusable = false}, SHIFT(281),
  [897] = {.count = 1, .reusable = false}, SHIFT(62),
  [899] = {.count = 1, .reusable = true}, SHIFT(1045),
  [901] = {.count = 1, .reusable = false}, SHIFT(1027),
  [903] = {.count = 1, .reusable = false}, SHIFT(1045),
  [905] = {.count = 1, .reusable = false}, SHIFT(983),
  [907] = {.count = 1, .reusable = false}, SHIFT(734),
  [909] = {.count = 1, .reusable = false}, SHIFT(696),
  [911] = {.count = 1, .reusable = false}, SHIFT(636),
  [913] = {.count = 1, .reusable = false}, SHIFT(241),
  [915] = {.count = 1, .reusable = true}, SHIFT(93),
  [917] = {.count = 1, .reusable = true}, SHIFT(98),
  [919] = {.count = 1, .reusable = false}, SHIFT(243),
  [921] = {.count = 1, .reusable = false}, SHIFT(273),
  [923] = {.count = 1, .reusable = false}, SHIFT(68),
  [925] = {.count = 1, .reusable = true}, SHIFT(1488),
  [927] = {.count = 1, .reusable = false}, SHIFT(1487),
  [929] = {.count = 1, .reusable = false}, SHIFT(1488),
  [931] = {.count = 1, .reusable = false}, SHIFT(1106),
  [933] = {.count = 1, .reusable = false}, SHIFT(854),
  [935] = {.count = 1, .reusable = false}, SHIFT(711),
  [937] = {.count = 1, .reusable = false}, SHIFT(212),
  [939] = {.count = 1, .reusable = false}, SHIFT(211),
  [941] = {.count = 1, .reusable = false}, SHIFT(373),
  [943] = {.count = 1, .reusable = false}, SHIFT(67),
  [945] = {.count = 1, .reusable = true}, SHIFT(1451),
  [947] = {.count = 1, .reusable = false}, SHIFT(1450),
  [949] = {.count = 1, .reusable = false}, SHIFT(1451),
  [951] = {.count = 1, .reusable = false}, SHIFT(1239),
  [953] = {.count = 1, .reusable = false}, SHIFT(837),
  [955] = {.count = 1, .reusable = false}, SHIFT(673),
  [957] = {.count = 1, .reusable = true}, SHIFT(1940),
  [959] = {.count = 1, .reusable = false}, SHIFT(638),
  [961] = {.count = 1, .reusable = false}, SHIFT(183),
  [963] = {.count = 1, .reusable = true}, SHIFT(94),
  [965] = {.count = 1, .reusable = true}, SHIFT(99),
  [967] = {.count = 1, .reusable = false}, SHIFT(199),
  [969] = {.count = 1, .reusable = true}, SHIFT(1003),
  [971] = {.count = 1, .reusable = true}, SHIFT(815),
  [973] = {.count = 1, .reusable = true}, SHIFT(818),
  [975] = {.count = 1, .reusable = false}, SHIFT(407),
  [977] = {.count = 1, .reusable = false}, SHIFT(63),
  [979] = {.count = 1, .reusable = true}, SHIFT(1348),
  [981] = {.count = 1, .reusable = false}, SHIFT(1362),
  [983] = {.count = 1, .reusable = false}, SHIFT(1348),
  [985] = {.count = 1, .reusable = false}, SHIFT(1363),
  [987] = {.count = 1, .reusable = false}, SHIFT(791),
  [989] = {.count = 1, .reusable = false}, SHIFT(2613),
  [991] = {.count = 1, .reusable = true}, SHIFT(918),
  [993] = {.count = 1, .reusable = false}, SHIFT(808),
  [995] = {.count = 1, .reusable = false}, SHIFT(645),
  [997] = {.count = 1, .reusable = false}, SHIFT(198),
  [999] = {.count = 1, .reusable = true}, SHIFT(92),
  [1001] = {.count = 1, .reusable = true}, SHIFT(96),
  [1003] = {.count = 1, .reusable = true}, SHIFT(2157),
  [1005] = {.count = 1, .reusable = false}, SHIFT(250),
  [1007] = {.count = 1, .reusable = false}, SHIFT(376),
  [1009] = {.count = 1, .reusable = false}, SHIFT(84),
  [1011] = {.count = 1, .reusable = true}, SHIFT(1603),
  [1013] = {.count = 1, .reusable = false}, SHIFT(1609),
  [1015] = {.count = 1, .reusable = false}, SHIFT(1603),
  [1017] = {.count = 1, .reusable = false}, SHIFT(1258),
  [1019] = {.count = 1, .reusable = false}, SHIFT(863),
  [1021] = {.count = 1, .reusable = false}, SHIFT(385),
  [1023] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [1025] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [1027] = {.count = 1, .reusable = true}, SHIFT(1008),
  [1029] = {.count = 1, .reusable = false}, SHIFT(1008),
  [1031] = {.count = 1, .reusable = false}, SHIFT(783),
  [1033] = {.count = 1, .reusable = false}, SHIFT(194),
  [1035] = {.count = 1, .reusable = false}, SHIFT(187),
  [1037] = {.count = 1, .reusable = false}, SHIFT(381),
  [1039] = {.count = 1, .reusable = false}, SHIFT(86),
  [1041] = {.count = 1, .reusable = false}, SHIFT(1177),
  [1043] = {.count = 1, .reusable = false}, SHIFT(883),
  [1045] = {.count = 1, .reusable = false}, SHIFT(817),
  [1047] = {.count = 1, .reusable = false}, SHIFT(235),
  [1049] = {.count = 1, .reusable = false}, SHIFT(238),
  [1051] = {.count = 1, .reusable = false}, SHIFT(303),
  [1053] = {.count = 1, .reusable = false}, SHIFT(81),
  [1055] = {.count = 1, .reusable = true}, SHIFT(1625),
  [1057] = {.count = 1, .reusable = false}, SHIFT(1665),
  [1059] = {.count = 1, .reusable = false}, SHIFT(1625),
  [1061] = {.count = 1, .reusable = false}, SHIFT(1364),
  [1063] = {.count = 1, .reusable = false}, SHIFT(869),
  [1065] = {.count = 1, .reusable = false}, SHIFT(408),
  [1067] = {.count = 1, .reusable = true}, SHIFT(1119),
  [1069] = {.count = 1, .reusable = false}, SHIFT(1119),
  [1071] = {.count = 1, .reusable = false}, SHIFT(275),
  [1073] = {.count = 1, .reusable = true}, SHIFT(1276),
  [1075] = {.count = 1, .reusable = false}, SHIFT(1276),
  [1077] = {.count = 1, .reusable = false}, SHIFT(368),
  [1079] = {.count = 1, .reusable = true}, SHIFT(1294),
  [1081] = {.count = 1, .reusable = false}, SHIFT(1294),
  [1083] = {.count = 1, .reusable = false}, SHIFT(347),
  [1085] = {.count = 1, .reusable = true}, SHIFT(1358),
  [1087] = {.count = 1, .reusable = false}, SHIFT(1358),
  [1089] = {.count = 1, .reusable = false}, SHIFT(372),
  [1091] = {.count = 1, .reusable = true}, SHIFT(1315),
  [1093] = {.count = 1, .reusable = false}, SHIFT(1315),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1, .production_id = 5),
  [1097] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1, .production_id = 5),
  [1099] = {.count = 1, .reusable = true}, SHIFT(27),
  [1101] = {.count = 1, .reusable = false}, SHIFT(3125),
  [1103] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1105] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1107] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1109] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1111] = {.count = 1, .reusable = true}, SHIFT(478),
  [1113] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 135),
  [1115] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 135),
  [1117] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 135),
  [1119] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 135),
  [1121] = {.count = 1, .reusable = true}, SHIFT(577),
  [1123] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 125),
  [1125] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 125),
  [1127] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 125),
  [1129] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 125),
  [1131] = {.count = 1, .reusable = true}, SHIFT(599),
  [1133] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [1135] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [1137] = {.count = 1, .reusable = true}, SHIFT(131),
  [1139] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 95),
  [1141] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 95),
  [1143] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 95),
  [1145] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 95),
  [1147] = {.count = 1, .reusable = true}, SHIFT(581),
  [1149] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [1151] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [1153] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 154),
  [1155] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 154),
  [1157] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 6, .production_id = 154),
  [1159] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 6, .production_id = 154),
  [1161] = {.count = 1, .reusable = true}, SHIFT(538),
  [1163] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1165] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1167] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1169] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1171] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 157),
  [1173] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 157),
  [1175] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .production_id = 157),
  [1177] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .production_id = 157),
  [1179] = {.count = 1, .reusable = true}, SHIFT(532),
  [1181] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2, .production_id = 28),
  [1183] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2, .production_id = 28),
  [1185] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 94),
  [1187] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 94),
  [1189] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 94),
  [1191] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 94),
  [1193] = {.count = 1, .reusable = true}, SHIFT(576),
  [1195] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [1197] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [1199] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 3, .production_id = 50),
  [1201] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 3, .production_id = 50),
  [1203] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 50),
  [1205] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 50),
  [1207] = {.count = 1, .reusable = true}, SHIFT(530),
  [1209] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1211] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1213] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 4),
  [1215] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 4),
  [1217] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [1219] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [1221] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1223] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1225] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 4, .production_id = 103),
  [1227] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 4, .production_id = 103),
  [1229] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 103),
  [1231] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 103),
  [1233] = {.count = 1, .reusable = true}, SHIFT(600),
  [1235] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [1237] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [1239] = {.count = 1, .reusable = true}, SHIFT(122),
  [1241] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 134),
  [1243] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 134),
  [1245] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 134),
  [1247] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 134),
  [1249] = {.count = 1, .reusable = true}, SHIFT(540),
  [1251] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 5, .production_id = 129),
  [1253] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 5, .production_id = 129),
  [1255] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [1257] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 129),
  [1259] = {.count = 1, .reusable = true}, SHIFT(558),
  [1261] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 129),
  [1263] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 129),
  [1265] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5, .production_id = 129),
  [1267] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5, .production_id = 129),
  [1269] = {.count = 1, .reusable = true}, SHIFT(559),
  [1271] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 106),
  [1273] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 106),
  [1275] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 106),
  [1277] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 106),
  [1279] = {.count = 1, .reusable = true}, SHIFT(544),
  [1281] = {.count = 1, .reusable = false}, SHIFT(835),
  [1283] = {.count = 1, .reusable = false}, SHIFT(836),
  [1285] = {.count = 1, .reusable = false}, SHIFT(641),
  [1287] = {.count = 1, .reusable = false}, SHIFT(203),
  [1289] = {.count = 1, .reusable = false}, SHIFT(202),
  [1291] = {.count = 1, .reusable = false}, SHIFT(504),
  [1293] = {.count = 1, .reusable = false}, SHIFT(66),
  [1295] = {.count = 1, .reusable = false}, SHIFT(861),
  [1297] = {.count = 1, .reusable = false}, SHIFT(77),
  [1299] = {.count = 1, .reusable = true}, SHIFT(1124),
  [1301] = {.count = 1, .reusable = false}, SHIFT(1499),
  [1303] = {.count = 1, .reusable = true}, SHIFT(1031),
  [1305] = {.count = 1, .reusable = true}, SHIFT(1043),
  [1307] = {.count = 1, .reusable = false}, SHIFT(884),
  [1309] = {.count = 1, .reusable = false}, SHIFT(882),
  [1311] = {.count = 1, .reusable = false}, SHIFT(656),
  [1313] = {.count = 1, .reusable = false}, SHIFT(568),
  [1315] = {.count = 1, .reusable = false}, SHIFT(73),
  [1317] = {.count = 1, .reusable = true}, SHIFT(1214),
  [1319] = {.count = 1, .reusable = false}, SHIFT(1214),
  [1321] = {.count = 1, .reusable = true}, SHIFT(1505),
  [1323] = {.count = 1, .reusable = true}, SHIFT(1300),
  [1325] = {.count = 1, .reusable = false}, SHIFT(1300),
  [1327] = {.count = 1, .reusable = true}, SHIFT(2432),
  [1329] = {.count = 1, .reusable = true}, SHIFT(1319),
  [1331] = {.count = 1, .reusable = false}, SHIFT(1319),
  [1333] = {.count = 1, .reusable = true}, SHIFT(1307),
  [1335] = {.count = 1, .reusable = false}, SHIFT(1307),
  [1337] = {.count = 1, .reusable = true}, SHIFT(1219),
  [1339] = {.count = 1, .reusable = true}, SHIFT(1771),
  [1341] = {.count = 1, .reusable = true}, SHIFT(1209),
  [1343] = {.count = 1, .reusable = false}, SHIFT(1209),
  [1345] = {.count = 1, .reusable = true}, SHIFT(1705),
  [1347] = {.count = 1, .reusable = true}, SHIFT(1211),
  [1349] = {.count = 1, .reusable = false}, SHIFT(1211),
  [1351] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [1353] = {.count = 1, .reusable = true}, SHIFT(1410),
  [1355] = {.count = 1, .reusable = false}, SHIFT(1410),
  [1357] = {.count = 1, .reusable = true}, SHIFT(1207),
  [1359] = {.count = 1, .reusable = true}, SHIFT(1213),
  [1361] = {.count = 1, .reusable = false}, SHIFT(1213),
  [1363] = {.count = 1, .reusable = true}, SHIFT(1039),
  [1365] = {.count = 1, .reusable = true}, SHIFT(1295),
  [1367] = {.count = 1, .reusable = false}, SHIFT(1295),
  [1369] = {.count = 1, .reusable = true}, SHIFT(1220),
  [1371] = {.count = 1, .reusable = true}, SHIFT(1299),
  [1373] = {.count = 1, .reusable = false}, SHIFT(1299),
  [1375] = {.count = 1, .reusable = true}, SHIFT(1269),
  [1377] = {.count = 1, .reusable = true}, SHIFT(2426),
  [1379] = {.count = 1, .reusable = true}, SHIFT(357),
  [1381] = {.count = 1, .reusable = true}, SHIFT(1352),
  [1383] = {.count = 1, .reusable = false}, SHIFT(1352),
  [1385] = {.count = 1, .reusable = true}, SHIFT(2701),
  [1387] = {.count = 1, .reusable = true}, SHIFT(1337),
  [1389] = {.count = 1, .reusable = false}, SHIFT(1337),
  [1391] = {.count = 1, .reusable = false}, SHIFT(824),
  [1393] = {.count = 1, .reusable = true}, SHIFT(1029),
  [1395] = {.count = 1, .reusable = true}, SHIFT(1265),
  [1397] = {.count = 1, .reusable = false}, SHIFT(1265),
  [1399] = {.count = 1, .reusable = false}, SHIFT(841),
  [1401] = {.count = 1, .reusable = true}, SHIFT(1215),
  [1403] = {.count = 1, .reusable = false}, SHIFT(1215),
  [1405] = {.count = 1, .reusable = false}, SHIFT(919),
  [1407] = {.count = 1, .reusable = false}, SHIFT(912),
  [1409] = {.count = 1, .reusable = false}, SHIFT(663),
  [1411] = {.count = 1, .reusable = false}, SHIFT(352),
  [1413] = {.count = 1, .reusable = false}, SHIFT(613),
  [1415] = {.count = 1, .reusable = false}, SHIFT(89),
  [1417] = {.count = 1, .reusable = true}, SHIFT(1591),
  [1419] = {.count = 1, .reusable = false}, SHIFT(1591),
  [1421] = {.count = 1, .reusable = false}, SHIFT(745),
  [1423] = {.count = 1, .reusable = true}, SHIFT(1071),
  [1425] = {.count = 1, .reusable = false}, SHIFT(1071),
  [1427] = {.count = 1, .reusable = false}, SHIFT(720),
  [1429] = {.count = 1, .reusable = true}, SHIFT(1023),
  [1431] = {.count = 1, .reusable = false}, SHIFT(1023),
  [1433] = {.count = 1, .reusable = true}, SHIFT(594),
  [1435] = {.count = 1, .reusable = true}, SHIFT(1293),
  [1437] = {.count = 1, .reusable = false}, SHIFT(1293),
  [1439] = {.count = 1, .reusable = true}, SHIFT(41),
  [1441] = {.count = 1, .reusable = true}, SHIFT(1387),
  [1443] = {.count = 1, .reusable = false}, SHIFT(1387),
  [1445] = {.count = 1, .reusable = true}, SHIFT(45),
  [1447] = {.count = 1, .reusable = true}, SHIFT(1397),
  [1449] = {.count = 1, .reusable = false}, SHIFT(1397),
  [1451] = {.count = 1, .reusable = true}, SHIFT(47),
  [1453] = {.count = 1, .reusable = true}, SHIFT(1384),
  [1455] = {.count = 1, .reusable = false}, SHIFT(1384),
  [1457] = {.count = 1, .reusable = true}, SHIFT(3),
  [1459] = {.count = 1, .reusable = true}, SHIFT(1128),
  [1461] = {.count = 1, .reusable = false}, SHIFT(1128),
  [1463] = {.count = 1, .reusable = true}, SHIFT(1404),
  [1465] = {.count = 1, .reusable = false}, SHIFT(1404),
  [1467] = {.count = 1, .reusable = true}, SHIFT(1405),
  [1469] = {.count = 1, .reusable = false}, SHIFT(1405),
  [1471] = {.count = 1, .reusable = false}, SHIFT(852),
  [1473] = {.count = 1, .reusable = false}, SHIFT(858),
  [1475] = {.count = 1, .reusable = false}, SHIFT(639),
  [1477] = {.count = 1, .reusable = false}, SHIFT(2994),
  [1479] = {.count = 1, .reusable = false}, SHIFT(518),
  [1481] = {.count = 1, .reusable = false}, SHIFT(75),
  [1483] = {.count = 1, .reusable = true}, SHIFT(1494),
  [1485] = {.count = 1, .reusable = false}, SHIFT(1494),
  [1487] = {.count = 1, .reusable = false}, SHIFT(1602),
  [1489] = {.count = 1, .reusable = true}, SHIFT(1286),
  [1491] = {.count = 1, .reusable = false}, SHIFT(1286),
  [1493] = {.count = 1, .reusable = true}, SHIFT(2),
  [1495] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1497] = {.count = 1, .reusable = false}, SHIFT(1019),
  [1499] = {.count = 1, .reusable = false}, SHIFT(903),
  [1501] = {.count = 1, .reusable = false}, SHIFT(909),
  [1503] = {.count = 1, .reusable = false}, SHIFT(658),
  [1505] = {.count = 1, .reusable = false}, SHIFT(608),
  [1507] = {.count = 1, .reusable = false}, SHIFT(85),
  [1509] = {.count = 1, .reusable = true}, SHIFT(1524),
  [1511] = {.count = 1, .reusable = false}, SHIFT(1524),
  [1513] = {.count = 1, .reusable = false}, SHIFT(751),
  [1515] = {.count = 1, .reusable = false}, SHIFT(691),
  [1517] = {.count = 1, .reusable = false}, SHIFT(703),
  [1519] = {.count = 1, .reusable = false}, SHIFT(628),
  [1521] = {.count = 1, .reusable = false}, SHIFT(3115),
  [1523] = {.count = 1, .reusable = false}, SHIFT(468),
  [1525] = {.count = 1, .reusable = false}, SHIFT(60),
  [1527] = {.count = 1, .reusable = true}, SHIFT(1007),
  [1529] = {.count = 1, .reusable = false}, SHIFT(1007),
  [1531] = {.count = 1, .reusable = false}, SHIFT(802),
  [1533] = {.count = 1, .reusable = true}, SHIFT(1407),
  [1535] = {.count = 1, .reusable = false}, SHIFT(1407),
  [1537] = {.count = 1, .reusable = false}, SHIFT(779),
  [1539] = {.count = 1, .reusable = false}, SHIFT(781),
  [1541] = {.count = 1, .reusable = false}, SHIFT(631),
  [1543] = {.count = 1, .reusable = false}, SHIFT(3029),
  [1545] = {.count = 1, .reusable = false}, SHIFT(495),
  [1547] = {.count = 1, .reusable = false}, SHIFT(61),
  [1549] = {.count = 1, .reusable = true}, SHIFT(1386),
  [1551] = {.count = 1, .reusable = false}, SHIFT(1386),
  [1553] = {.count = 1, .reusable = false}, SHIFT(1581),
  [1555] = {.count = 1, .reusable = true}, SHIFT(1326),
  [1557] = {.count = 1, .reusable = false}, SHIFT(1326),
  [1559] = {.count = 1, .reusable = false}, SHIFT(838),
  [1561] = {.count = 1, .reusable = false}, SHIFT(848),
  [1563] = {.count = 1, .reusable = false}, SHIFT(633),
  [1565] = {.count = 1, .reusable = false}, SHIFT(510),
  [1567] = {.count = 1, .reusable = false}, SHIFT(80),
  [1569] = {.count = 1, .reusable = true}, SHIFT(1103),
  [1571] = {.count = 1, .reusable = false}, SHIFT(1103),
  [1573] = {.count = 1, .reusable = true}, SHIFT(1195),
  [1575] = {.count = 1, .reusable = false}, SHIFT(1195),
  [1577] = {.count = 1, .reusable = true}, SHIFT(1196),
  [1579] = {.count = 1, .reusable = false}, SHIFT(1196),
  [1581] = {.count = 1, .reusable = true}, SHIFT(1228),
  [1583] = {.count = 1, .reusable = false}, SHIFT(1228),
  [1585] = {.count = 1, .reusable = true}, SHIFT(1197),
  [1587] = {.count = 1, .reusable = false}, SHIFT(1197),
  [1589] = {.count = 1, .reusable = true}, SHIFT(1199),
  [1591] = {.count = 1, .reusable = false}, SHIFT(1199),
  [1593] = {.count = 1, .reusable = false}, SHIFT(867),
  [1595] = {.count = 1, .reusable = true}, SHIFT(1399),
  [1597] = {.count = 1, .reusable = false}, SHIFT(1399),
  [1599] = {.count = 1, .reusable = false}, SHIFT(2839),
  [1601] = {.count = 1, .reusable = true}, SHIFT(392),
  [1603] = {.count = 1, .reusable = false}, SHIFT(306),
  [1605] = {.count = 1, .reusable = false}, SHIFT(3130),
  [1607] = {.count = 1, .reusable = true}, SHIFT(2129),
  [1609] = {.count = 1, .reusable = true}, SHIFT(2127),
  [1611] = {.count = 1, .reusable = true}, SHIFT(3123),
  [1613] = {.count = 1, .reusable = true}, SHIFT(3122),
  [1615] = {.count = 1, .reusable = true}, SHIFT(2122),
  [1617] = {.count = 1, .reusable = true}, SHIFT(2121),
  [1619] = {.count = 1, .reusable = true}, SHIFT(2108),
  [1621] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1624] = {.count = 1, .reusable = true}, SHIFT(2976),
  [1626] = {.count = 1, .reusable = true}, SHIFT(3117),
  [1628] = {.count = 1, .reusable = true}, SHIFT(3110),
  [1630] = {.count = 1, .reusable = true}, SHIFT(2863),
  [1632] = {.count = 1, .reusable = true}, SHIFT(3162),
  [1634] = {.count = 1, .reusable = true}, SHIFT(1756),
  [1636] = {.count = 1, .reusable = true}, SHIFT(2144),
  [1638] = {.count = 1, .reusable = true}, SHIFT(3161),
  [1640] = {.count = 1, .reusable = true}, SHIFT(3160),
  [1642] = {.count = 1, .reusable = false}, SHIFT(880),
  [1644] = {.count = 1, .reusable = true}, SHIFT(1392),
  [1646] = {.count = 1, .reusable = false}, SHIFT(1392),
  [1648] = {.count = 1, .reusable = false}, SHIFT(827),
  [1650] = {.count = 1, .reusable = false}, SHIFT(825),
  [1652] = {.count = 1, .reusable = false}, SHIFT(644),
  [1654] = {.count = 1, .reusable = false}, SHIFT(516),
  [1656] = {.count = 1, .reusable = false}, SHIFT(65),
  [1658] = {.count = 1, .reusable = false}, SHIFT(671),
  [1660] = {.count = 1, .reusable = false}, SHIFT(920),
  [1662] = {.count = 1, .reusable = false}, SHIFT(668),
  [1664] = {.count = 1, .reusable = false}, SHIFT(612),
  [1666] = {.count = 1, .reusable = false}, SHIFT(90),
  [1668] = {.count = 1, .reusable = true}, SHIFT(1390),
  [1670] = {.count = 1, .reusable = false}, SHIFT(1390),
  [1672] = {.count = 1, .reusable = true}, SHIFT(1127),
  [1674] = {.count = 1, .reusable = false}, SHIFT(1127),
  [1676] = {.count = 1, .reusable = false}, SHIFT(877),
  [1678] = {.count = 1, .reusable = true}, SHIFT(5),
  [1680] = {.count = 1, .reusable = true}, SHIFT(1181),
  [1682] = {.count = 1, .reusable = false}, SHIFT(1181),
  [1684] = {.count = 1, .reusable = false}, SHIFT(901),
  [1686] = {.count = 1, .reusable = true}, SHIFT(972),
  [1688] = {.count = 1, .reusable = false}, SHIFT(972),
  [1690] = {.count = 1, .reusable = true}, SHIFT(1180),
  [1692] = {.count = 1, .reusable = false}, SHIFT(1180),
  [1694] = {.count = 1, .reusable = false}, SHIFT(851),
  [1696] = {.count = 1, .reusable = true}, SHIFT(1227),
  [1698] = {.count = 1, .reusable = false}, SHIFT(1227),
  [1700] = {.count = 1, .reusable = true}, SHIFT(1129),
  [1702] = {.count = 1, .reusable = false}, SHIFT(1129),
  [1704] = {.count = 1, .reusable = true}, SHIFT(977),
  [1706] = {.count = 1, .reusable = false}, SHIFT(977),
  [1708] = {.count = 1, .reusable = true}, SHIFT(1186),
  [1710] = {.count = 1, .reusable = false}, SHIFT(1186),
  [1712] = {.count = 1, .reusable = true}, SHIFT(1330),
  [1714] = {.count = 1, .reusable = false}, SHIFT(1330),
  [1716] = {.count = 1, .reusable = true}, SHIFT(1334),
  [1718] = {.count = 1, .reusable = false}, SHIFT(1334),
  [1720] = {.count = 1, .reusable = true}, SHIFT(1229),
  [1722] = {.count = 1, .reusable = false}, SHIFT(1229),
  [1724] = {.count = 1, .reusable = true}, SHIFT(1340),
  [1726] = {.count = 1, .reusable = false}, SHIFT(1340),
  [1728] = {.count = 1, .reusable = true}, SHIFT(1021),
  [1730] = {.count = 1, .reusable = false}, SHIFT(1021),
  [1732] = {.count = 1, .reusable = true}, SHIFT(1230),
  [1734] = {.count = 1, .reusable = false}, SHIFT(1230),
  [1736] = {.count = 1, .reusable = true}, SHIFT(1205),
  [1738] = {.count = 1, .reusable = false}, SHIFT(1205),
  [1740] = {.count = 1, .reusable = true}, SHIFT(1335),
  [1742] = {.count = 1, .reusable = false}, SHIFT(1335),
  [1744] = {.count = 1, .reusable = true}, SHIFT(1344),
  [1746] = {.count = 1, .reusable = false}, SHIFT(1344),
  [1748] = {.count = 1, .reusable = true}, SHIFT(973),
  [1750] = {.count = 1, .reusable = false}, SHIFT(973),
  [1752] = {.count = 1, .reusable = true}, SHIFT(1338),
  [1754] = {.count = 1, .reusable = false}, SHIFT(1338),
  [1756] = {.count = 1, .reusable = true}, SHIFT(1354),
  [1758] = {.count = 1, .reusable = false}, SHIFT(1354),
  [1760] = {.count = 1, .reusable = true}, SHIFT(1017),
  [1762] = {.count = 1, .reusable = false}, SHIFT(1017),
  [1764] = {.count = 1, .reusable = true}, SHIFT(1284),
  [1766] = {.count = 1, .reusable = false}, SHIFT(1284),
  [1768] = {.count = 1, .reusable = true}, SHIFT(1371),
  [1770] = {.count = 1, .reusable = false}, SHIFT(1371),
  [1772] = {.count = 1, .reusable = true}, SHIFT(1372),
  [1774] = {.count = 1, .reusable = false}, SHIFT(1372),
  [1776] = {.count = 1, .reusable = true}, SHIFT(1370),
  [1778] = {.count = 1, .reusable = false}, SHIFT(1370),
  [1780] = {.count = 1, .reusable = true}, SHIFT(1373),
  [1782] = {.count = 1, .reusable = false}, SHIFT(1373),
  [1784] = {.count = 1, .reusable = false}, SHIFT(860),
  [1786] = {.count = 1, .reusable = false}, SHIFT(881),
  [1788] = {.count = 1, .reusable = false}, SHIFT(886),
  [1790] = {.count = 1, .reusable = false}, SHIFT(652),
  [1792] = {.count = 1, .reusable = false}, SHIFT(549),
  [1794] = {.count = 1, .reusable = false}, SHIFT(74),
  [1796] = {.count = 1, .reusable = true}, SHIFT(1083),
  [1798] = {.count = 1, .reusable = false}, SHIFT(1083),
  [1800] = {.count = 1, .reusable = true}, SHIFT(1332),
  [1802] = {.count = 1, .reusable = false}, SHIFT(1332),
  [1804] = {.count = 1, .reusable = false}, SHIFT(845),
  [1806] = {.count = 1, .reusable = true}, SHIFT(1204),
  [1808] = {.count = 1, .reusable = false}, SHIFT(1204),
  [1810] = {.count = 1, .reusable = true}, SHIFT(1241),
  [1812] = {.count = 1, .reusable = false}, SHIFT(1241),
  [1814] = {.count = 1, .reusable = true}, SHIFT(1069),
  [1816] = {.count = 1, .reusable = false}, SHIFT(1069),
  [1818] = {.count = 1, .reusable = true}, SHIFT(984),
  [1820] = {.count = 1, .reusable = false}, SHIFT(984),
  [1822] = {.count = 1, .reusable = true}, SHIFT(989),
  [1824] = {.count = 1, .reusable = false}, SHIFT(989),
  [1826] = {.count = 1, .reusable = true}, SHIFT(1246),
  [1828] = {.count = 1, .reusable = false}, SHIFT(1246),
  [1830] = {.count = 1, .reusable = true}, SHIFT(1113),
  [1832] = {.count = 1, .reusable = false}, SHIFT(1113),
  [1834] = {.count = 1, .reusable = true}, SHIFT(1267),
  [1836] = {.count = 1, .reusable = false}, SHIFT(1267),
  [1838] = {.count = 1, .reusable = true}, SHIFT(1312),
  [1840] = {.count = 1, .reusable = false}, SHIFT(1312),
  [1842] = {.count = 1, .reusable = true}, SHIFT(1225),
  [1844] = {.count = 1, .reusable = false}, SHIFT(1225),
  [1846] = {.count = 1, .reusable = true}, SHIFT(1328),
  [1848] = {.count = 1, .reusable = false}, SHIFT(1328),
  [1850] = {.count = 1, .reusable = true}, SHIFT(1365),
  [1852] = {.count = 1, .reusable = false}, SHIFT(1365),
  [1854] = {.count = 1, .reusable = true}, SHIFT(1106),
  [1856] = {.count = 1, .reusable = true}, SHIFT(1077),
  [1858] = {.count = 1, .reusable = false}, SHIFT(1077),
  [1860] = {.count = 1, .reusable = true}, SHIFT(1486),
  [1862] = {.count = 1, .reusable = false}, SHIFT(1486),
  [1864] = {.count = 1, .reusable = true}, SHIFT(1107),
  [1866] = {.count = 1, .reusable = false}, SHIFT(1107),
  [1868] = {.count = 1, .reusable = true}, SHIFT(1108),
  [1870] = {.count = 1, .reusable = false}, SHIFT(1108),
  [1872] = {.count = 1, .reusable = true}, SHIFT(1109),
  [1874] = {.count = 1, .reusable = false}, SHIFT(1109),
  [1876] = {.count = 1, .reusable = true}, SHIFT(1110),
  [1878] = {.count = 1, .reusable = false}, SHIFT(1110),
  [1880] = {.count = 1, .reusable = true}, SHIFT(1356),
  [1882] = {.count = 1, .reusable = false}, SHIFT(1356),
  [1884] = {.count = 1, .reusable = true}, SHIFT(1111),
  [1886] = {.count = 1, .reusable = false}, SHIFT(1111),
  [1888] = {.count = 1, .reusable = true}, SHIFT(1112),
  [1890] = {.count = 1, .reusable = false}, SHIFT(1112),
  [1892] = {.count = 1, .reusable = true}, SHIFT(1104),
  [1894] = {.count = 1, .reusable = false}, SHIFT(1104),
  [1896] = {.count = 1, .reusable = true}, SHIFT(1247),
  [1898] = {.count = 1, .reusable = false}, SHIFT(1247),
  [1900] = {.count = 1, .reusable = true}, SHIFT(1245),
  [1902] = {.count = 1, .reusable = false}, SHIFT(1245),
  [1904] = {.count = 1, .reusable = true}, SHIFT(1480),
  [1906] = {.count = 1, .reusable = false}, SHIFT(1098),
  [1908] = {.count = 1, .reusable = true}, SHIFT(988),
  [1910] = {.count = 1, .reusable = false}, SHIFT(988),
  [1912] = {.count = 1, .reusable = true}, SHIFT(1244),
  [1914] = {.count = 1, .reusable = false}, SHIFT(1244),
  [1916] = {.count = 1, .reusable = true}, SHIFT(957),
  [1918] = {.count = 1, .reusable = false}, SHIFT(957),
  [1920] = {.count = 1, .reusable = true}, SHIFT(1292),
  [1922] = {.count = 1, .reusable = false}, SHIFT(1292),
  [1924] = {.count = 1, .reusable = true}, SHIFT(1298),
  [1926] = {.count = 1, .reusable = false}, SHIFT(1298),
  [1928] = {.count = 1, .reusable = true}, SHIFT(1297),
  [1930] = {.count = 1, .reusable = false}, SHIFT(1297),
  [1932] = {.count = 1, .reusable = true}, SHIFT(1560),
  [1934] = {.count = 1, .reusable = false}, SHIFT(1560),
  [1936] = {.count = 1, .reusable = true}, SHIFT(1072),
  [1938] = {.count = 1, .reusable = false}, SHIFT(1002),
  [1940] = {.count = 1, .reusable = true}, SHIFT(1296),
  [1942] = {.count = 1, .reusable = false}, SHIFT(1296),
  [1944] = {.count = 1, .reusable = true}, SHIFT(1355),
  [1946] = {.count = 1, .reusable = false}, SHIFT(1355),
  [1948] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1950] = {.count = 1, .reusable = true}, SHIFT(986),
  [1952] = {.count = 1, .reusable = false}, SHIFT(986),
  [1954] = {.count = 1, .reusable = true}, SHIFT(1379),
  [1956] = {.count = 1, .reusable = false}, SHIFT(1379),
  [1958] = {.count = 1, .reusable = true}, SHIFT(1311),
  [1960] = {.count = 1, .reusable = false}, SHIFT(1311),
  [1962] = {.count = 1, .reusable = true}, SHIFT(1463),
  [1964] = {.count = 1, .reusable = false}, SHIFT(1463),
  [1966] = {.count = 1, .reusable = true}, SHIFT(983),
  [1968] = {.count = 1, .reusable = true}, SHIFT(1001),
  [1970] = {.count = 1, .reusable = false}, SHIFT(1001),
  [1972] = {.count = 1, .reusable = true}, SHIFT(1242),
  [1974] = {.count = 1, .reusable = false}, SHIFT(1242),
  [1976] = {.count = 1, .reusable = true}, SHIFT(1283),
  [1978] = {.count = 1, .reusable = false}, SHIFT(1283),
  [1980] = {.count = 1, .reusable = true}, SHIFT(1188),
  [1982] = {.count = 1, .reusable = false}, SHIFT(1188),
  [1984] = {.count = 1, .reusable = true}, SHIFT(976),
  [1986] = {.count = 1, .reusable = false}, SHIFT(976),
  [1988] = {.count = 1, .reusable = true}, SHIFT(1302),
  [1990] = {.count = 1, .reusable = false}, SHIFT(1302),
  [1992] = {.count = 1, .reusable = true}, SHIFT(1189),
  [1994] = {.count = 1, .reusable = false}, SHIFT(1189),
  [1996] = {.count = 1, .reusable = true}, SHIFT(1174),
  [1998] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2000] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2002] = {.count = 1, .reusable = false}, SHIFT(1240),
  [2004] = {.count = 1, .reusable = true}, SHIFT(1375),
  [2006] = {.count = 1, .reusable = false}, SHIFT(1375),
  [2008] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2010] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2012] = {.count = 1, .reusable = true}, SHIFT(975),
  [2014] = {.count = 1, .reusable = false}, SHIFT(975),
  [2016] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2018] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2020] = {.count = 1, .reusable = true}, SHIFT(994),
  [2022] = {.count = 1, .reusable = false}, SHIFT(994),
  [2024] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2026] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2028] = {.count = 1, .reusable = false}, SHIFT(844),
  [2030] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2032] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2034] = {.count = 1, .reusable = true}, SHIFT(974),
  [2036] = {.count = 1, .reusable = false}, SHIFT(974),
  [2038] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2040] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2042] = {.count = 1, .reusable = false}, SHIFT(1075),
  [2044] = {.count = 1, .reusable = true}, SHIFT(1464),
  [2046] = {.count = 1, .reusable = false}, SHIFT(1464),
  [2048] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2050] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2052] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2054] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2056] = {.count = 1, .reusable = true}, SHIFT(995),
  [2058] = {.count = 1, .reusable = false}, SHIFT(995),
  [2060] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2062] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2064] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2066] = {.count = 1, .reusable = false}, SHIFT(1233),
  [2068] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2070] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2072] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2074] = {.count = 1, .reusable = false}, SHIFT(1350),
  [2076] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2078] = {.count = 1, .reusable = false}, SHIFT(1349),
  [2080] = {.count = 1, .reusable = true}, SHIFT(978),
  [2082] = {.count = 1, .reusable = false}, SHIFT(978),
  [2084] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2086] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2088] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2090] = {.count = 1, .reusable = false}, SHIFT(1346),
  [2092] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2094] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2096] = {.count = 1, .reusable = true}, SHIFT(1509),
  [2098] = {.count = 1, .reusable = false}, SHIFT(1509),
  [2100] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2102] = {.count = 1, .reusable = true}, SHIFT(1004),
  [2104] = {.count = 1, .reusable = false}, SHIFT(1004),
  [2106] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2108] = {.count = 1, .reusable = false}, SHIFT(1116),
  [2110] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2112] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2114] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2116] = {.count = 1, .reusable = false}, SHIFT(1015),
  [2118] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2120] = {.count = 1, .reusable = false}, SHIFT(1176),
  [2122] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2124] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2126] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2128] = {.count = 1, .reusable = false}, SHIFT(1285),
  [2130] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2132] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2134] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2136] = {.count = 1, .reusable = false}, SHIFT(1121),
  [2138] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2140] = {.count = 1, .reusable = true}, SHIFT(1095),
  [2142] = {.count = 1, .reusable = false}, SHIFT(1095),
  [2144] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2146] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2148] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2150] = {.count = 1, .reusable = false}, SHIFT(1232),
  [2152] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2154] = {.count = 1, .reusable = false}, SHIFT(1005),
  [2156] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2158] = {.count = 1, .reusable = false}, SHIFT(840),
  [2160] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2162] = {.count = 1, .reusable = false}, SHIFT(1367),
  [2164] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2166] = {.count = 1, .reusable = false}, SHIFT(1178),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2170] = {.count = 1, .reusable = false}, SHIFT(1179),
  [2172] = {.count = 1, .reusable = true}, SHIFT(1506),
  [2174] = {.count = 1, .reusable = false}, SHIFT(1506),
  [2176] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2178] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2180] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2182] = {.count = 1, .reusable = false}, SHIFT(1231),
  [2184] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2186] = {.count = 1, .reusable = false}, SHIFT(1068),
  [2188] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2190] = {.count = 1, .reusable = false}, SHIFT(1291),
  [2192] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2194] = {.count = 1, .reusable = false}, SHIFT(1123),
  [2196] = {.count = 1, .reusable = false}, SHIFT(925),
  [2198] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2200] = {.count = 1, .reusable = false}, SHIFT(1182),
  [2202] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2204] = {.count = 1, .reusable = false}, SHIFT(1325),
  [2206] = {.count = 1, .reusable = true}, SHIFT(1598),
  [2208] = {.count = 1, .reusable = true}, SHIFT(1504),
  [2210] = {.count = 1, .reusable = false}, SHIFT(1504),
  [2212] = {.count = 1, .reusable = true}, SHIFT(1724),
  [2214] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2216] = {.count = 1, .reusable = false}, SHIFT(1331),
  [2218] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2220] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2222] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2224] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2226] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2228] = {.count = 1, .reusable = false}, SHIFT(1000),
  [2230] = {.count = 1, .reusable = true}, SHIFT(1009),
  [2232] = {.count = 1, .reusable = false}, SHIFT(1009),
  [2234] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2236] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2238] = {.count = 1, .reusable = false}, SHIFT(1096),
  [2240] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2242] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2244] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2246] = {.count = 1, .reusable = false}, SHIFT(1183),
  [2248] = {.count = 1, .reusable = false}, SHIFT(833),
  [2250] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2252] = {.count = 1, .reusable = false}, SHIFT(1061),
  [2254] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2256] = {.count = 1, .reusable = false}, SHIFT(1359),
  [2258] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2260] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2262] = {.count = 1, .reusable = false}, SHIFT(1272),
  [2264] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2266] = {.count = 1, .reusable = false}, SHIFT(1268),
  [2268] = {.count = 1, .reusable = true}, SHIFT(1620),
  [2270] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2272] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2274] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2276] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2278] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2280] = {.count = 1, .reusable = false}, SHIFT(1261),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2284] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2286] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2288] = {.count = 1, .reusable = false}, SHIFT(1316),
  [2290] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2292] = {.count = 1, .reusable = false}, SHIFT(1014),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2296] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2298] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2300] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2302] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2304] = {.count = 1, .reusable = false}, SHIFT(1259),
  [2306] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2308] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2310] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2312] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2314] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2316] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2318] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2320] = {.count = 1, .reusable = true}, SHIFT(1418),
  [2322] = {.count = 1, .reusable = false}, SHIFT(1418),
  [2324] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2326] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2328] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2330] = {.count = 1, .reusable = false}, SHIFT(1271),
  [2332] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2334] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2336] = {.count = 1, .reusable = false}, SHIFT(1238),
  [2338] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2340] = {.count = 1, .reusable = false}, SHIFT(1243),
  [2342] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2344] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2346] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2348] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2350] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2352] = {.count = 1, .reusable = false}, SHIFT(1377),
  [2354] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2356] = {.count = 1, .reusable = false}, SHIFT(1187),
  [2358] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2360] = {.count = 1, .reusable = false}, SHIFT(1376),
  [2362] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2364] = {.count = 1, .reusable = true}, SHIFT(1026),
  [2366] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2368] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2370] = {.count = 1, .reusable = false}, SHIFT(1249),
  [2372] = {.count = 1, .reusable = true}, SHIFT(1066),
  [2374] = {.count = 1, .reusable = false}, SHIFT(1066),
  [2376] = {.count = 1, .reusable = true}, SHIFT(2095),
  [2378] = {.count = 1, .reusable = true}, SHIFT(2911),
  [2380] = {.count = 1, .reusable = false}, SHIFT(378),
  [2382] = {.count = 1, .reusable = true}, SHIFT(2168),
  [2384] = {.count = 1, .reusable = true}, SHIFT(1761),
  [2386] = {.count = 1, .reusable = true}, SHIFT(2191),
  [2388] = {.count = 1, .reusable = true}, SHIFT(1763),
  [2390] = {.count = 1, .reusable = true}, SHIFT(2097),
  [2392] = {.count = 1, .reusable = true}, SHIFT(2040),
  [2394] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [2396] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [2398] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [2400] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [2402] = {.count = 1, .reusable = false}, SHIFT(2530),
  [2404] = {.count = 1, .reusable = false}, SHIFT(2531),
  [2406] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1832),
  [2409] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1734),
  [2413] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(310),
  [2416] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2905),
  [2420] = {.count = 1, .reusable = false}, SHIFT(2049),
  [2422] = {.count = 1, .reusable = true}, SHIFT(2466),
  [2424] = {.count = 1, .reusable = true}, SHIFT(2464),
  [2426] = {.count = 1, .reusable = true}, SHIFT(2197),
  [2428] = {.count = 1, .reusable = false}, SHIFT(1775),
  [2430] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2432] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2434] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .production_id = 51),
  [2436] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .production_id = 51),
  [2438] = {.count = 1, .reusable = false}, SHIFT(2981),
  [2440] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [2442] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [2444] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2),
  [2446] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2),
  [2448] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [2450] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [2452] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [2454] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [2456] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [2458] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [2460] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [2462] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [2464] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [2466] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [2468] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [2470] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [2472] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [2474] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [2476] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [2478] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [2480] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [2482] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [2484] = {.count = 1, .reusable = true}, SHIFT(687),
  [2486] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [2488] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [2490] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [2492] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [2494] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [2496] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [2498] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6),
  [2500] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6),
  [2502] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [2504] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [2506] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [2508] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [2510] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [2512] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [2514] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [2516] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [2518] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [2520] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [2522] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [2524] = {.count = 1, .reusable = false}, SHIFT(2199),
  [2526] = {.count = 1, .reusable = false}, SHIFT(1777),
  [2528] = {.count = 1, .reusable = false}, SHIFT(1807),
  [2530] = {.count = 1, .reusable = false}, SHIFT(1778),
  [2532] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2534] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2536] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(747),
  [2539] = {.count = 1, .reusable = false}, SHIFT(823),
  [2541] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [2543] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [2545] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [2547] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [2549] = {.count = 1, .reusable = true}, SHIFT(471),
  [2551] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2553] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2555] = {.count = 1, .reusable = false}, SHIFT(2630),
  [2557] = {.count = 1, .reusable = false}, SHIFT(2928),
  [2559] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [2561] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [2563] = {.count = 1, .reusable = false}, SHIFT(3112),
  [2565] = {.count = 1, .reusable = false}, SHIFT(3111),
  [2567] = {.count = 1, .reusable = true}, SHIFT(3077),
  [2569] = {.count = 1, .reusable = false}, SHIFT(2088),
  [2571] = {.count = 1, .reusable = false}, SHIFT(1893),
  [2573] = {.count = 1, .reusable = false}, SHIFT(2383),
  [2575] = {.count = 1, .reusable = false}, SHIFT(635),
  [2577] = {.count = 1, .reusable = false}, SHIFT(2959),
  [2579] = {.count = 1, .reusable = true}, SHIFT(475),
  [2581] = {.count = 1, .reusable = true}, SHIFT(97),
  [2583] = {.count = 1, .reusable = true}, SHIFT(2905),
  [2585] = {.count = 1, .reusable = false}, SHIFT(2460),
  [2587] = {.count = 1, .reusable = true}, SHIFT(3012),
  [2589] = {.count = 1, .reusable = false}, SHIFT(2031),
  [2591] = {.count = 1, .reusable = true}, SHIFT(436),
  [2593] = {.count = 1, .reusable = false}, SHIFT(2029),
  [2595] = {.count = 1, .reusable = false}, SHIFT(436),
  [2597] = {.count = 1, .reusable = false}, SHIFT(1828),
  [2599] = {.count = 1, .reusable = false}, SHIFT(1799),
  [2601] = {.count = 1, .reusable = true}, SHIFT(480),
  [2603] = {.count = 1, .reusable = true}, SHIFT(467),
  [2605] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [2607] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [2609] = {.count = 1, .reusable = false}, SHIFT(2996),
  [2611] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [2613] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [2615] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(747),
  [2618] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [2620] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [2622] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [2624] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [2626] = {.count = 1, .reusable = true}, SHIFT(821),
  [2628] = {.count = 1, .reusable = true}, SHIFT(819),
  [2630] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [2632] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [2634] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [2636] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [2638] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1734),
  [2641] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(2905),
  [2644] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [2646] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [2648] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [2650] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [2652] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2654] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2656] = {.count = 1, .reusable = true}, SHIFT(26),
  [2658] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .production_id = 156),
  [2660] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .production_id = 156),
  [2662] = {.count = 1, .reusable = false}, SHIFT(3023),
  [2664] = {.count = 1, .reusable = false}, SHIFT(3015),
  [2666] = {.count = 1, .reusable = false}, SHIFT(2077),
  [2668] = {.count = 1, .reusable = false}, SHIFT(2041),
  [2670] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [2672] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [2674] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [2676] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [2678] = {.count = 1, .reusable = false}, SHIFT(3002),
  [2680] = {.count = 1, .reusable = false}, SHIFT(3004),
  [2682] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2684] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2686] = {.count = 1, .reusable = false}, SHIFT(3032),
  [2688] = {.count = 1, .reusable = false}, SHIFT(3031),
  [2690] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 165),
  [2692] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 165),
  [2694] = {.count = 1, .reusable = false}, SHIFT(2988),
  [2696] = {.count = 1, .reusable = false}, SHIFT(3177),
  [2698] = {.count = 1, .reusable = true}, SHIFT(3027),
  [2700] = {.count = 1, .reusable = false}, SHIFT(2079),
  [2702] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [2704] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [2706] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 164),
  [2708] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 164),
  [2710] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [2712] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [2714] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2716] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4, .production_id = 82),
  [2718] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 113),
  [2720] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 113),
  [2722] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [2724] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [2726] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5, .production_id = 112),
  [2728] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5, .production_id = 112),
  [2730] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .production_id = 111),
  [2732] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .production_id = 111),
  [2734] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 50),
  [2736] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 50),
  [2738] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [2740] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [2742] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7, .production_id = 157),
  [2744] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7, .production_id = 157),
  [2746] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [2748] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [2750] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2, .production_id = 6),
  [2752] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2, .production_id = 6),
  [2754] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [2756] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [2758] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 88),
  [2760] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 88),
  [2762] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [2764] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [2766] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 7, .production_id = 154),
  [2768] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 7, .production_id = 154),
  [2770] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2772] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2774] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [2776] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [2778] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2780] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 25),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 25),
  [2786] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 50),
  [2788] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 50),
  [2790] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 106),
  [2792] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 106),
  [2794] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5, .production_id = 133),
  [2796] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5, .production_id = 133),
  [2798] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [2800] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3, .production_id = 62),
  [2802] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [2804] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [2806] = {.count = 1, .reusable = false}, SHIFT(3107),
  [2808] = {.count = 1, .reusable = false}, SHIFT(3105),
  [2810] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [2812] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [2814] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 155),
  [2816] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 155),
  [2818] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .production_id = 125),
  [2820] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .production_id = 125),
  [2822] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5, .production_id = 117),
  [2824] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5, .production_id = 117),
  [2826] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 4, .production_id = 83),
  [2828] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 4, .production_id = 83),
  [2830] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2832] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2834] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 129),
  [2836] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 129),
  [2838] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 6, .production_id = 129),
  [2840] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 6, .production_id = 129),
  [2842] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3, .production_id = 42),
  [2844] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3, .production_id = 42),
  [2846] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 131),
  [2848] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 131),
  [2850] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 130),
  [2852] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 130),
  [2854] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5, .production_id = 128),
  [2856] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5, .production_id = 128),
  [2858] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4, .production_id = 102),
  [2860] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4, .production_id = 102),
  [2862] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [2864] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [2866] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [2868] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [2870] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 142),
  [2872] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 142),
  [2874] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2876] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2878] = {.count = 1, .reusable = false}, SHIFT(2415),
  [2880] = {.count = 1, .reusable = false}, SHIFT(2296),
  [2882] = {.count = 1, .reusable = true}, SHIFT(1030),
  [2884] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(154),
  [2887] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [2889] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [2891] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [2893] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [2895] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [2897] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [2899] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [2901] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 94),
  [2903] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [2905] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [2907] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2909] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2911] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [2913] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3, .production_id = 36),
  [2915] = {.count = 1, .reusable = false}, SHIFT(35),
  [2917] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [2919] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 95),
  [2921] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2923] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3, .production_id = 37),
  [2925] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2927] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3, .production_id = 69),
  [2929] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [2931] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [2933] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 105),
  [2935] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 105),
  [2937] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [2939] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [2941] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [2943] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [2945] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2947] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 71),
  [2949] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2951] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 72),
  [2953] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 94),
  [2955] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 94),
  [2957] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 163),
  [2959] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 163),
  [2961] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [2963] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [2965] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .production_id = 139),
  [2967] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .production_id = 139),
  [2969] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 95),
  [2971] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 95),
  [2973] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [2975] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [2977] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 125),
  [2979] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 125),
  [2981] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 103),
  [2983] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 103),
  [2985] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [2987] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [2989] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [2991] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 3, .production_id = 38),
  [2993] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2995] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2997] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .production_id = 46),
  [2999] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .production_id = 46),
  [3001] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .production_id = 46),
  [3003] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .production_id = 46),
  [3005] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3, .production_id = 45),
  [3007] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3, .production_id = 45),
  [3009] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [3011] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 44),
  [3013] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [3015] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [3017] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 162),
  [3019] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 162),
  [3021] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 141),
  [3023] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 141),
  [3025] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 161),
  [3027] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 161),
  [3029] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 140),
  [3031] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 140),
  [3033] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 160),
  [3035] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 160),
  [3037] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [3039] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [3041] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 144),
  [3043] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 144),
  [3045] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 143),
  [3047] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 143),
  [3049] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 159),
  [3051] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 159),
  [3053] = {.count = 1, .reusable = false}, SHIFT(491),
  [3055] = {.count = 1, .reusable = false}, SHIFT(113),
  [3057] = {.count = 1, .reusable = true}, SHIFT(2475),
  [3059] = {.count = 1, .reusable = true}, SHIFT(2471),
  [3061] = {.count = 1, .reusable = false}, SHIFT(999),
  [3063] = {.count = 1, .reusable = true}, SHIFT(156),
  [3065] = {.count = 1, .reusable = true}, SHIFT(147),
  [3067] = {.count = 1, .reusable = false}, SHIFT(1011),
  [3069] = {.count = 1, .reusable = false}, SHIFT(1909),
  [3071] = {.count = 1, .reusable = false}, SHIFT(916),
  [3073] = {.count = 1, .reusable = true}, SHIFT(1837),
  [3075] = {.count = 1, .reusable = true}, SHIFT(669),
  [3077] = {.count = 1, .reusable = true}, SHIFT(2023),
  [3079] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3081] = {.count = 1, .reusable = true}, SHIFT(952),
  [3083] = {.count = 1, .reusable = true}, SHIFT(146),
  [3085] = {.count = 1, .reusable = false}, SHIFT(1203),
  [3087] = {.count = 1, .reusable = false}, SHIFT(2518),
  [3089] = {.count = 1, .reusable = true}, SHIFT(2454),
  [3091] = {.count = 1, .reusable = true}, SHIFT(2452),
  [3093] = {.count = 1, .reusable = true}, SHIFT(1880),
  [3095] = {.count = 1, .reusable = false}, SHIFT(1202),
  [3097] = {.count = 1, .reusable = false}, SHIFT(1403),
  [3099] = {.count = 1, .reusable = false}, SHIFT(1698),
  [3101] = {.count = 1, .reusable = false}, SHIFT(1200),
  [3103] = {.count = 1, .reusable = true}, SHIFT(441),
  [3105] = {.count = 1, .reusable = false}, SHIFT(1912),
  [3107] = {.count = 1, .reusable = false}, SHIFT(921),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1341),
  [3111] = {.count = 1, .reusable = false}, SHIFT(1278),
  [3113] = {.count = 1, .reusable = false}, SHIFT(1279),
  [3115] = {.count = 1, .reusable = false}, SHIFT(1321),
  [3117] = {.count = 1, .reusable = false}, SHIFT(1678),
  [3119] = {.count = 1, .reusable = false}, SHIFT(1175),
  [3121] = {.count = 1, .reusable = false}, SHIFT(1915),
  [3123] = {.count = 1, .reusable = false}, SHIFT(924),
  [3125] = {.count = 1, .reusable = true}, SHIFT(1420),
  [3127] = {.count = 1, .reusable = false}, SHIFT(1263),
  [3129] = {.count = 1, .reusable = false}, SHIFT(1262),
  [3131] = {.count = 1, .reusable = false}, SHIFT(1374),
  [3133] = {.count = 1, .reusable = false}, SHIFT(1579),
  [3135] = {.count = 1, .reusable = false}, SHIFT(1260),
  [3137] = {.count = 1, .reusable = true}, SHIFT(666),
  [3139] = {.count = 1, .reusable = true}, SHIFT(1273),
  [3141] = {.count = 1, .reusable = true}, SHIFT(950),
  [3143] = {.count = 1, .reusable = true}, SHIFT(1939),
  [3145] = {.count = 1, .reusable = true}, SHIFT(152),
  [3147] = {.count = 1, .reusable = true}, SHIFT(981),
  [3149] = {.count = 1, .reusable = false}, SHIFT(1916),
  [3151] = {.count = 1, .reusable = false}, SHIFT(917),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3155] = {.count = 1, .reusable = false}, SHIFT(1289),
  [3157] = {.count = 1, .reusable = false}, SHIFT(1254),
  [3159] = {.count = 1, .reusable = false}, SHIFT(1383),
  [3161] = {.count = 1, .reusable = false}, SHIFT(1610),
  [3163] = {.count = 1, .reusable = false}, SHIFT(1237),
  [3165] = {.count = 1, .reusable = false}, SHIFT(2484),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3169] = {.count = 1, .reusable = false}, SHIFT(1416),
  [3171] = {.count = 1, .reusable = false}, SHIFT(1353),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3175] = {.count = 1, .reusable = false}, SHIFT(923),
  [3177] = {.count = 1, .reusable = false}, SHIFT(2954),
  [3179] = {.count = 1, .reusable = true}, SHIFT(469),
  [3181] = {.count = 1, .reusable = true}, SHIFT(763),
  [3183] = {.count = 1, .reusable = false}, SHIFT(2508),
  [3185] = {.count = 1, .reusable = true}, SHIFT(998),
  [3187] = {.count = 1, .reusable = true}, SHIFT(814),
  [3189] = {.count = 1, .reusable = true}, SHIFT(816),
  [3191] = {.count = 1, .reusable = true}, SHIFT(3010),
  [3193] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3195] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3197] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3199] = {.count = 1, .reusable = false}, SHIFT(1669),
  [3201] = {.count = 1, .reusable = false}, SHIFT(2680),
  [3203] = {.count = 1, .reusable = true}, SHIFT(923),
  [3205] = {.count = 1, .reusable = false}, SHIFT(2612),
  [3207] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [3209] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 58),
  [3211] = {.count = 1, .reusable = false}, SHIFT(968),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1144),
  [3215] = {.count = 1, .reusable = false}, SHIFT(915),
  [3217] = {.count = 1, .reusable = false}, SHIFT(2894),
  [3219] = {.count = 1, .reusable = true}, SHIFT(482),
  [3221] = {.count = 1, .reusable = true}, SHIFT(777),
  [3223] = {.count = 1, .reusable = false}, SHIFT(2461),
  [3225] = {.count = 1, .reusable = true}, SHIFT(991),
  [3227] = {.count = 1, .reusable = true}, SHIFT(757),
  [3229] = {.count = 1, .reusable = true}, SHIFT(756),
  [3231] = {.count = 1, .reusable = true}, SHIFT(3074),
  [3233] = {.count = 1, .reusable = false}, SHIFT(1145),
  [3235] = {.count = 1, .reusable = true}, SHIFT(1146),
  [3237] = {.count = 1, .reusable = false}, SHIFT(1147),
  [3239] = {.count = 1, .reusable = false}, SHIFT(1146),
  [3241] = {.count = 1, .reusable = false}, SHIFT(2611),
  [3243] = {.count = 1, .reusable = true}, SHIFT(915),
  [3245] = {.count = 1, .reusable = false}, SHIFT(1969),
  [3247] = {.count = 1, .reusable = false}, SHIFT(931),
  [3249] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [3251] = {.count = 1, .reusable = false}, SHIFT(1385),
  [3253] = {.count = 1, .reusable = false}, SHIFT(1366),
  [3255] = {.count = 1, .reusable = false}, SHIFT(1447),
  [3257] = {.count = 1, .reusable = false}, SHIFT(1727),
  [3259] = {.count = 1, .reusable = false}, SHIFT(1380),
  [3261] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4, .production_id = 104),
  [3263] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4, .production_id = 104),
  [3265] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3267] = {.count = 1, .reusable = false}, SHIFT(291),
  [3269] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3271] = {.count = 1, .reusable = true}, SHIFT(297),
  [3273] = {.count = 1, .reusable = false}, SHIFT(277),
  [3275] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [3277] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(220),
  [3280] = {.count = 1, .reusable = true}, SHIFT(220),
  [3282] = {.count = 1, .reusable = true}, SHIFT(778),
  [3284] = {.count = 1, .reusable = true}, SHIFT(3118),
  [3286] = {.count = 1, .reusable = true}, SHIFT(210),
  [3288] = {.count = 1, .reusable = false}, SHIFT(304),
  [3290] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3293] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(784),
  [3296] = {.count = 1, .reusable = true}, SHIFT(3201),
  [3298] = {.count = 1, .reusable = true}, SHIFT(249),
  [3300] = {.count = 1, .reusable = true}, SHIFT(274),
  [3302] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3305] = {.count = 1, .reusable = true}, SHIFT(799),
  [3307] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 26),
  [3309] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 26),
  [3311] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(770),
  [3314] = {.count = 1, .reusable = true}, SHIFT(3167),
  [3316] = {.count = 1, .reusable = true}, SHIFT(782),
  [3318] = {.count = 1, .reusable = false}, SHIFT(1280),
  [3320] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3322] = {.count = 1, .reusable = false}, SHIFT(926),
  [3324] = {.count = 1, .reusable = false}, SHIFT(2824),
  [3326] = {.count = 1, .reusable = true}, SHIFT(477),
  [3328] = {.count = 1, .reusable = true}, SHIFT(748),
  [3330] = {.count = 1, .reusable = false}, SHIFT(2540),
  [3332] = {.count = 1, .reusable = true}, SHIFT(1013),
  [3334] = {.count = 1, .reusable = true}, SHIFT(716),
  [3336] = {.count = 1, .reusable = true}, SHIFT(719),
  [3338] = {.count = 1, .reusable = true}, SHIFT(3155),
  [3340] = {.count = 1, .reusable = false}, SHIFT(1431),
  [3342] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3344] = {.count = 1, .reusable = false}, SHIFT(1433),
  [3346] = {.count = 1, .reusable = false}, SHIFT(1432),
  [3348] = {.count = 1, .reusable = false}, SHIFT(2729),
  [3350] = {.count = 1, .reusable = true}, SHIFT(926),
  [3352] = {.count = 1, .reusable = false}, SHIFT(1866),
  [3354] = {.count = 1, .reusable = false}, SHIFT(913),
  [3356] = {.count = 1, .reusable = true}, SHIFT(728),
  [3358] = {.count = 1, .reusable = true}, SHIFT(1941),
  [3360] = {.count = 1, .reusable = false}, SHIFT(446),
  [3362] = {.count = 1, .reusable = false}, SHIFT(439),
  [3364] = {.count = 1, .reusable = true}, SHIFT(1133),
  [3366] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3368] = {.count = 1, .reusable = true}, SHIFT(1861),
  [3370] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3372] = {.count = 1, .reusable = false}, SHIFT(1869),
  [3374] = {.count = 1, .reusable = true}, SHIFT(2177),
  [3376] = {.count = 1, .reusable = false}, SHIFT(329),
  [3378] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3381] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3384] = {.count = 1, .reusable = true}, SHIFT(3043),
  [3386] = {.count = 1, .reusable = true}, SHIFT(237),
  [3388] = {.count = 1, .reusable = true}, SHIFT(305),
  [3390] = {.count = 1, .reusable = true}, SHIFT(435),
  [3392] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3394] = {.count = 1, .reusable = true}, SHIFT(2691),
  [3396] = {.count = 1, .reusable = true}, SHIFT(2692),
  [3398] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3400] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [3402] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [3404] = {.count = 1, .reusable = true}, SHIFT(465),
  [3406] = {.count = 1, .reusable = false}, SHIFT(309),
  [3408] = {.count = 1, .reusable = true}, SHIFT(3189),
  [3410] = {.count = 1, .reusable = true}, SHIFT(460),
  [3412] = {.count = 1, .reusable = true}, SHIFT(1172),
  [3414] = {.count = 1, .reusable = true}, SHIFT(1944),
  [3416] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [3419] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 58), REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [3422] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [3425] = {.count = 1, .reusable = true}, SHIFT(1863),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1173),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1962),
  [3435] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 58),
  [3438] = {.count = 1, .reusable = true}, SHIFT(3018),
  [3440] = {.count = 1, .reusable = false}, SHIFT(2009),
  [3442] = {.count = 1, .reusable = false}, SHIFT(2847),
  [3444] = {.count = 1, .reusable = false}, SHIFT(2523),
  [3446] = {.count = 1, .reusable = true}, SHIFT(979),
  [3448] = {.count = 1, .reusable = true}, SHIFT(743),
  [3450] = {.count = 1, .reusable = true}, SHIFT(742),
  [3452] = {.count = 1, .reusable = false}, SHIFT(1874),
  [3454] = {.count = 1, .reusable = false}, SHIFT(918),
  [3456] = {.count = 1, .reusable = false}, SHIFT(2914),
  [3458] = {.count = 1, .reusable = true}, SHIFT(481),
  [3460] = {.count = 1, .reusable = true}, SHIFT(801),
  [3462] = {.count = 1, .reusable = false}, SHIFT(2510),
  [3464] = {.count = 1, .reusable = true}, SHIFT(3066),
  [3466] = {.count = 1, .reusable = false}, SHIFT(1972),
  [3468] = {.count = 1, .reusable = true}, SHIFT(1971),
  [3470] = {.count = 1, .reusable = false}, SHIFT(1968),
  [3472] = {.count = 1, .reusable = false}, SHIFT(1971),
  [3474] = {.count = 1, .reusable = false}, SHIFT(375),
  [3476] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2, .production_id = 51),
  [3478] = {.count = 1, .reusable = true}, SHIFT(165),
  [3480] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(755),
  [3483] = {.count = 1, .reusable = true}, SHIFT(3060),
  [3485] = {.count = 1, .reusable = true}, SHIFT(253),
  [3487] = {.count = 1, .reusable = true}, SHIFT(380),
  [3489] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2, .production_id = 51),
  [3491] = {.count = 1, .reusable = false}, SHIFT(452),
  [3493] = {.count = 1, .reusable = false}, SHIFT(2537),
  [3495] = {.count = 1, .reusable = true}, SHIFT(997),
  [3497] = {.count = 1, .reusable = true}, SHIFT(766),
  [3499] = {.count = 1, .reusable = true}, SHIFT(764),
  [3501] = {.count = 1, .reusable = false}, SHIFT(353),
  [3503] = {.count = 1, .reusable = true}, SHIFT(166),
  [3505] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(747),
  [3508] = {.count = 1, .reusable = true}, SHIFT(2980),
  [3510] = {.count = 1, .reusable = true}, SHIFT(244),
  [3512] = {.count = 1, .reusable = true}, SHIFT(345),
  [3514] = {.count = 1, .reusable = true}, SHIFT(3121),
  [3516] = {.count = 1, .reusable = true}, SHIFT(3204),
  [3518] = {.count = 1, .reusable = true}, SHIFT(3202),
  [3520] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1), SHIFT(304),
  [3523] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3526] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3530] = {.count = 1, .reusable = true}, SHIFT(3151),
  [3532] = {.count = 1, .reusable = false}, SHIFT(339),
  [3534] = {.count = 1, .reusable = true}, SHIFT(3205),
  [3536] = {.count = 1, .reusable = true}, SHIFT(224),
  [3538] = {.count = 1, .reusable = true}, SHIFT(335),
  [3540] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 51),
  [3542] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 51),
  [3544] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3547] = {.count = 1, .reusable = true}, SHIFT(762),
  [3549] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(175),
  [3552] = {.count = 1, .reusable = true}, SHIFT(175),
  [3554] = {.count = 1, .reusable = true}, SHIFT(176),
  [3556] = {.count = 1, .reusable = true}, SHIFT(2367),
  [3558] = {.count = 1, .reusable = true}, SHIFT(3210),
  [3560] = {.count = 1, .reusable = true}, SHIFT(590),
  [3562] = {.count = 1, .reusable = true}, SHIFT(3104),
  [3564] = {.count = 1, .reusable = true}, SHIFT(3182),
  [3566] = {.count = 1, .reusable = true}, SHIFT(2995),
  [3568] = {.count = 1, .reusable = true}, SHIFT(3165),
  [3570] = {.count = 1, .reusable = true}, SHIFT(2998),
  [3572] = {.count = 1, .reusable = true}, SHIFT(3207),
  [3574] = {.count = 1, .reusable = false}, SHIFT(735),
  [3576] = {.count = 1, .reusable = true}, SHIFT(2050),
  [3578] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1),
  [3580] = {.count = 1, .reusable = true}, SHIFT(3081),
  [3582] = {.count = 1, .reusable = false}, SHIFT(1911),
  [3584] = {.count = 1, .reusable = false}, SHIFT(929),
  [3586] = {.count = 1, .reusable = true}, SHIFT(1843),
  [3588] = {.count = 1, .reusable = true}, SHIFT(180),
  [3590] = {.count = 1, .reusable = false}, SHIFT(1426),
  [3592] = {.count = 1, .reusable = true}, SHIFT(1884),
  [3594] = {.count = 1, .reusable = false}, SHIFT(1427),
  [3596] = {.count = 1, .reusable = false}, SHIFT(1710),
  [3598] = {.count = 1, .reusable = false}, SHIFT(1553),
  [3600] = {.count = 1, .reusable = false}, SHIFT(1428),
  [3602] = {.count = 1, .reusable = true}, SHIFT(949),
  [3604] = {.count = 1, .reusable = true}, SHIFT(1151),
  [3606] = {.count = 1, .reusable = true}, SHIFT(2781),
  [3608] = {.count = 1, .reusable = true}, SHIFT(257),
  [3610] = {.count = 1, .reusable = true}, SHIFT(343),
  [3612] = {.count = 1, .reusable = false}, SHIFT(3127),
  [3614] = {.count = 1, .reusable = true}, SHIFT(2148),
  [3616] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3618] = {.count = 1, .reusable = true}, SHIFT(3196),
  [3620] = {.count = 1, .reusable = true}, SHIFT(3197),
  [3622] = {.count = 1, .reusable = true}, SHIFT(2179),
  [3624] = {.count = 1, .reusable = true}, SHIFT(2181),
  [3626] = {.count = 1, .reusable = true}, SHIFT(2086),
  [3628] = {.count = 1, .reusable = true}, SHIFT(3192),
  [3630] = {.count = 1, .reusable = true}, SHIFT(3198),
  [3632] = {.count = 1, .reusable = true}, SHIFT(2870),
  [3634] = {.count = 1, .reusable = true}, SHIFT(3089),
  [3636] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3638] = {.count = 1, .reusable = true}, SHIFT(2151),
  [3640] = {.count = 1, .reusable = true}, SHIFT(3195),
  [3642] = {.count = 1, .reusable = true}, SHIFT(3194),
  [3644] = {.count = 1, .reusable = true}, SHIFT(225),
  [3646] = {.count = 1, .reusable = true}, SHIFT(953),
  [3648] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3650] = {.count = 1, .reusable = true}, SHIFT(948),
  [3652] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3654] = {.count = 1, .reusable = false}, SHIFT(2625),
  [3656] = {.count = 1, .reusable = false}, SHIFT(3050),
  [3658] = {.count = 1, .reusable = false}, REDUCE(sym_import, 1),
  [3660] = {.count = 1, .reusable = true}, SHIFT(2176),
  [3662] = {.count = 1, .reusable = true}, REDUCE(sym_import, 1),
  [3664] = {.count = 1, .reusable = false}, SHIFT(1973),
  [3666] = {.count = 1, .reusable = true}, SHIFT(3086),
  [3668] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 29),
  [3671] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3673] = {.count = 1, .reusable = true}, SHIFT(1130),
  [3675] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3677] = {.count = 1, .reusable = true}, SHIFT(443),
  [3679] = {.count = 1, .reusable = true}, SHIFT(1970),
  [3681] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3687] = {.count = 1, .reusable = true}, SHIFT(429),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1131),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1065),
  [3693] = {.count = 1, .reusable = true}, SHIFT(1950),
  [3695] = {.count = 1, .reusable = true}, SHIFT(437),
  [3697] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3699] = {.count = 1, .reusable = true}, SHIFT(1947),
  [3701] = {.count = 1, .reusable = true}, SHIFT(227),
  [3703] = {.count = 1, .reusable = false}, SHIFT(770),
  [3705] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3707] = {.count = 1, .reusable = true}, SHIFT(664),
  [3709] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3711] = {.count = 1, .reusable = false}, SHIFT(340),
  [3713] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3715] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3717] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [3719] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [3721] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [3723] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [3725] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [3727] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [3729] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [3731] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [3733] = {.count = 1, .reusable = false}, SHIFT(348),
  [3735] = {.count = 1, .reusable = true}, SHIFT(1143),
  [3737] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(765),
  [3740] = {.count = 1, .reusable = true}, SHIFT(3039),
  [3742] = {.count = 1, .reusable = true}, SHIFT(739),
  [3744] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .production_id = 29),
  [3746] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .production_id = 29),
  [3748] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .production_id = 29),
  [3750] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .production_id = 29),
  [3752] = {.count = 1, .reusable = false}, SHIFT(285),
  [3754] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [3756] = {.count = 1, .reusable = false}, SHIFT(289),
  [3758] = {.count = 1, .reusable = false}, SHIFT(100),
  [3760] = {.count = 1, .reusable = true}, SHIFT(326),
  [3762] = {.count = 1, .reusable = true}, SHIFT(294),
  [3764] = {.count = 1, .reusable = true}, SHIFT(301),
  [3766] = {.count = 1, .reusable = true}, SHIFT(285),
  [3768] = {.count = 1, .reusable = false}, SHIFT(294),
  [3770] = {.count = 1, .reusable = false}, SHIFT(301),
  [3772] = {.count = 1, .reusable = false}, SHIFT(307),
  [3774] = {.count = 1, .reusable = true}, SHIFT(314),
  [3776] = {.count = 1, .reusable = true}, SHIFT(289),
  [3778] = {.count = 1, .reusable = false}, SHIFT(1063),
  [3780] = {.count = 1, .reusable = true}, SHIFT(1062),
  [3782] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [3784] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3786] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63),
  [3788] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(100),
  [3791] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 101),
  [3793] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 24),
  [3795] = {.count = 1, .reusable = true}, SHIFT(776),
  [3797] = {.count = 1, .reusable = false}, SHIFT(449),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1150),
  [3801] = {.count = 1, .reusable = true}, SHIFT(247),
  [3803] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3, .production_id = 57),
  [3805] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(765),
  [3808] = {.count = 1, .reusable = true}, SHIFT(153),
  [3810] = {.count = 1, .reusable = true}, SHIFT(694),
  [3812] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 57),
  [3814] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [3816] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3818] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3820] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(100),
  [3823] = {.count = 1, .reusable = true}, SHIFT(715),
  [3825] = {.count = 1, .reusable = false}, SHIFT(1153),
  [3827] = {.count = 1, .reusable = true}, SHIFT(898),
  [3829] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [3831] = {.count = 1, .reusable = true}, SHIFT(23),
  [3833] = {.count = 1, .reusable = true}, SHIFT(726),
  [3835] = {.count = 1, .reusable = false}, SHIFT(1658),
  [3837] = {.count = 1, .reusable = true}, SHIFT(2983),
  [3839] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5, .production_id = 132),
  [3841] = {.count = 1, .reusable = true}, SHIFT(727),
  [3843] = {.count = 1, .reusable = false}, SHIFT(1937),
  [3845] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [3847] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [3849] = {.count = 1, .reusable = false}, SHIFT(282),
  [3851] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [3853] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(218),
  [3856] = {.count = 1, .reusable = true}, SHIFT(218),
  [3858] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [3860] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [3862] = {.count = 1, .reusable = true}, SHIFT(879),
  [3864] = {.count = 1, .reusable = true}, SHIFT(22),
  [3866] = {.count = 1, .reusable = true}, SHIFT(2992),
  [3868] = {.count = 1, .reusable = true}, SHIFT(761),
  [3870] = {.count = 1, .reusable = false}, SHIFT(1514),
  [3872] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 3),
  [3874] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [3876] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [3878] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [3880] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [3882] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 100),
  [3884] = {.count = 1, .reusable = false}, SHIFT(295),
  [3886] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3888] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(217),
  [3891] = {.count = 1, .reusable = true}, SHIFT(217),
  [3893] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 98),
  [3895] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4, .production_id = 99),
  [3897] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4, .production_id = 99),
  [3899] = {.count = 1, .reusable = true}, SHIFT(2970),
  [3901] = {.count = 1, .reusable = false}, SHIFT(389),
  [3903] = {.count = 1, .reusable = true}, SHIFT(660),
  [3905] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [3907] = {.count = 1, .reusable = false}, SHIFT(390),
  [3909] = {.count = 1, .reusable = true}, SHIFT(195),
  [3911] = {.count = 1, .reusable = false}, SHIFT(104),
  [3913] = {.count = 1, .reusable = true}, SHIFT(280),
  [3915] = {.count = 1, .reusable = true}, SHIFT(393),
  [3917] = {.count = 1, .reusable = true}, SHIFT(395),
  [3919] = {.count = 1, .reusable = true}, SHIFT(389),
  [3921] = {.count = 1, .reusable = false}, SHIFT(393),
  [3923] = {.count = 1, .reusable = false}, SHIFT(395),
  [3925] = {.count = 1, .reusable = false}, SHIFT(409),
  [3927] = {.count = 1, .reusable = true}, SHIFT(401),
  [3929] = {.count = 1, .reusable = true}, SHIFT(390),
  [3931] = {.count = 1, .reusable = false}, SHIFT(1711),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3935] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [3937] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 52),
  [3939] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 52),
  [3941] = {.count = 1, .reusable = false}, SHIFT(269),
  [3943] = {.count = 1, .reusable = true}, SHIFT(678),
  [3945] = {.count = 1, .reusable = false}, SHIFT(258),
  [3947] = {.count = 1, .reusable = true}, SHIFT(240),
  [3949] = {.count = 1, .reusable = false}, SHIFT(101),
  [3951] = {.count = 1, .reusable = true}, SHIFT(260),
  [3953] = {.count = 1, .reusable = true}, SHIFT(261),
  [3955] = {.count = 1, .reusable = true}, SHIFT(262),
  [3957] = {.count = 1, .reusable = true}, SHIFT(269),
  [3959] = {.count = 1, .reusable = false}, SHIFT(261),
  [3961] = {.count = 1, .reusable = false}, SHIFT(262),
  [3963] = {.count = 1, .reusable = false}, SHIFT(263),
  [3965] = {.count = 1, .reusable = true}, SHIFT(264),
  [3967] = {.count = 1, .reusable = true}, SHIFT(258),
  [3969] = {.count = 1, .reusable = false}, SHIFT(1502),
  [3971] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3973] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3976] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [3979] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 53),
  [3981] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 53),
  [3983] = {.count = 1, .reusable = false}, SHIFT(2027),
  [3985] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3987] = {.count = 1, .reusable = true}, SHIFT(149),
  [3989] = {.count = 1, .reusable = false}, SHIFT(1681),
  [3991] = {.count = 1, .reusable = true}, SHIFT(2055),
  [3993] = {.count = 1, .reusable = false}, SHIFT(1680),
  [3995] = {.count = 1, .reusable = false}, SHIFT(1730),
  [3997] = {.count = 1, .reusable = false}, SHIFT(1758),
  [3999] = {.count = 1, .reusable = false}, SHIFT(1677),
  [4001] = {.count = 1, .reusable = false}, SHIFT(2036),
  [4003] = {.count = 1, .reusable = true}, SHIFT(2437),
  [4005] = {.count = 1, .reusable = false}, SHIFT(1717),
  [4007] = {.count = 1, .reusable = false}, SHIFT(1716),
  [4009] = {.count = 1, .reusable = false}, SHIFT(1740),
  [4011] = {.count = 1, .reusable = false}, SHIFT(1757),
  [4013] = {.count = 1, .reusable = false}, SHIFT(1713),
  [4015] = {.count = 1, .reusable = true}, SHIFT(911),
  [4017] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3, .production_id = 54),
  [4019] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3, .production_id = 54),
  [4021] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [4023] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 55),
  [4025] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [4027] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [4029] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [4031] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 56),
  [4033] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [4035] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [4037] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 59),
  [4039] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [4041] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3, .production_id = 60),
  [4043] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [4045] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [4047] = {.count = 1, .reusable = true}, SHIFT(665),
  [4049] = {.count = 1, .reusable = false}, SHIFT(2028),
  [4051] = {.count = 1, .reusable = true}, SHIFT(967),
  [4053] = {.count = 1, .reusable = false}, SHIFT(1682),
  [4055] = {.count = 1, .reusable = false}, SHIFT(1679),
  [4057] = {.count = 1, .reusable = false}, SHIFT(1719),
  [4059] = {.count = 1, .reusable = false}, SHIFT(1760),
  [4061] = {.count = 1, .reusable = false}, SHIFT(1676),
  [4063] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4066] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4069] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 3, .production_id = 66),
  [4071] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 3, .production_id = 66),
  [4073] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 67),
  [4075] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 47),
  [4077] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 47),
  [4079] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [4081] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4, .production_id = 92),
  [4083] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4, .production_id = 92),
  [4085] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 97),
  [4087] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 97),
  [4089] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 98),
  [4091] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 99),
  [4093] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 99),
  [4095] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 2, .production_id = 20),
  [4097] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 2, .production_id = 20),
  [4099] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 100),
  [4101] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [4103] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [4105] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [4107] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [4109] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [4111] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 101),
  [4113] = {.count = 1, .reusable = false}, SHIFT(344),
  [4115] = {.count = 1, .reusable = false}, SHIFT(342),
  [4117] = {.count = 1, .reusable = false}, SHIFT(106),
  [4119] = {.count = 1, .reusable = true}, SHIFT(346),
  [4121] = {.count = 1, .reusable = true}, SHIFT(332),
  [4123] = {.count = 1, .reusable = true}, SHIFT(300),
  [4125] = {.count = 1, .reusable = true}, SHIFT(344),
  [4127] = {.count = 1, .reusable = false}, SHIFT(332),
  [4129] = {.count = 1, .reusable = false}, SHIFT(300),
  [4131] = {.count = 1, .reusable = false}, SHIFT(296),
  [4133] = {.count = 1, .reusable = true}, SHIFT(293),
  [4135] = {.count = 1, .reusable = true}, SHIFT(342),
  [4137] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 107),
  [4139] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 107),
  [4141] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 108),
  [4143] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 108),
  [4145] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4147] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [4149] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 5),
  [4151] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 5),
  [4153] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 89),
  [4155] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 89),
  [4157] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 127),
  [4159] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 127),
  [4161] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [4163] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [4165] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [4167] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [4169] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_closing_element, 4, .production_id = 119),
  [4171] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_closing_element, 4, .production_id = 119),
  [4173] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 136),
  [4175] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 136),
  [4177] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(101),
  [4180] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 6),
  [4182] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 6),
  [4184] = {.count = 1, .reusable = false}, REDUCE(sym_class, 2, .production_id = 13),
  [4186] = {.count = 1, .reusable = true}, REDUCE(sym_class, 2, .production_id = 13),
  [4188] = {.count = 1, .reusable = true}, SHIFT(614),
  [4190] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(101),
  [4193] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4195] = {.count = 1, .reusable = true}, SHIFT(2318),
  [4197] = {.count = 1, .reusable = false}, SHIFT(1688),
  [4199] = {.count = 1, .reusable = false}, SHIFT(1689),
  [4201] = {.count = 1, .reusable = false}, SHIFT(1726),
  [4203] = {.count = 1, .reusable = false}, SHIFT(1762),
  [4205] = {.count = 1, .reusable = false}, SHIFT(1694),
  [4207] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 74), REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [4210] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 74),
  [4212] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 74), REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [4215] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64), REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4218] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64),
  [4220] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 65), REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [4223] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 65),
  [4225] = {.count = 1, .reusable = true}, SHIFT(830),
  [4227] = {.count = 1, .reusable = false}, SHIFT(731),
  [4229] = {.count = 1, .reusable = false}, SHIFT(730),
  [4231] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4233] = {.count = 1, .reusable = true}, SHIFT(1052),
  [4235] = {.count = 1, .reusable = false}, SHIFT(1590),
  [4237] = {.count = 1, .reusable = false}, SHIFT(1588),
  [4239] = {.count = 1, .reusable = false}, SHIFT(1733),
  [4241] = {.count = 1, .reusable = false}, SHIFT(1759),
  [4243] = {.count = 1, .reusable = false}, SHIFT(1585),
  [4245] = {.count = 1, .reusable = true}, SHIFT(700),
  [4247] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 126),
  [4250] = {.count = 1, .reusable = false}, SHIFT(298),
  [4252] = {.count = 1, .reusable = false}, SHIFT(308),
  [4254] = {.count = 1, .reusable = false}, SHIFT(102),
  [4256] = {.count = 1, .reusable = true}, SHIFT(394),
  [4258] = {.count = 1, .reusable = true}, SHIFT(311),
  [4260] = {.count = 1, .reusable = true}, SHIFT(313),
  [4262] = {.count = 1, .reusable = true}, SHIFT(298),
  [4264] = {.count = 1, .reusable = false}, SHIFT(311),
  [4266] = {.count = 1, .reusable = false}, SHIFT(313),
  [4268] = {.count = 1, .reusable = false}, SHIFT(316),
  [4270] = {.count = 1, .reusable = true}, SHIFT(318),
  [4272] = {.count = 1, .reusable = true}, SHIFT(308),
  [4274] = {.count = 1, .reusable = true}, SHIFT(1835),
  [4276] = {.count = 1, .reusable = true}, SHIFT(406),
  [4278] = {.count = 1, .reusable = true}, SHIFT(317),
  [4280] = {.count = 1, .reusable = false}, SHIFT(1485),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4284] = {.count = 1, .reusable = false}, SHIFT(1671),
  [4286] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(106),
  [4289] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 49),
  [4291] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 49),
  [4293] = {.count = 1, .reusable = false}, SHIFT(1053),
  [4295] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5, .production_id = 132),
  [4297] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4299] = {.count = 1, .reusable = true}, SHIFT(1198),
  [4301] = {.count = 1, .reusable = false}, SHIFT(1561),
  [4303] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4305] = {.count = 1, .reusable = false}, SHIFT(1559),
  [4307] = {.count = 1, .reusable = false}, SHIFT(1821),
  [4309] = {.count = 1, .reusable = false}, SHIFT(1577),
  [4311] = {.count = 1, .reusable = false}, SHIFT(1395),
  [4313] = {.count = 1, .reusable = false}, SHIFT(1449),
  [4315] = {.count = 1, .reusable = true}, SHIFT(310),
  [4317] = {.count = 1, .reusable = true}, SHIFT(2188),
  [4319] = {.count = 1, .reusable = false}, SHIFT(1805),
  [4321] = {.count = 1, .reusable = true}, SHIFT(1318),
  [4323] = {.count = 1, .reusable = true}, SHIFT(2425),
  [4325] = {.count = 1, .reusable = true}, SHIFT(466),
  [4327] = {.count = 1, .reusable = true}, SHIFT(1768),
  [4329] = {.count = 1, .reusable = true}, SHIFT(472),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1697),
  [4333] = {.count = 1, .reusable = true}, SHIFT(128),
  [4335] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [4337] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4339] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4341] = {.count = 1, .reusable = true}, SHIFT(120),
  [4343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1911),
  [4346] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1844),
  [4349] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4351] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(180),
  [4354] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1561),
  [4357] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2454),
  [4360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2452),
  [4363] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1871),
  [4366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1856),
  [4369] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1559),
  [4372] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1821),
  [4375] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1577),
  [4378] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1553),
  [4381] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1395),
  [4384] = {.count = 1, .reusable = true}, SHIFT(959),
  [4386] = {.count = 1, .reusable = true}, SHIFT(1446),
  [4388] = {.count = 1, .reusable = true}, SHIFT(554),
  [4390] = {.count = 1, .reusable = true}, SHIFT(1223),
  [4392] = {.count = 1, .reusable = true}, SHIFT(579),
  [4394] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(102),
  [4397] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 65),
  [4399] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4401] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(104),
  [4404] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2, .production_id = 78),
  [4406] = {.count = 1, .reusable = true}, SHIFT(1628),
  [4408] = {.count = 1, .reusable = true}, SHIFT(1623),
  [4410] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 57),
  [4412] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4414] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 57),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1022),
  [4418] = {.count = 1, .reusable = true}, SHIFT(254),
  [4420] = {.count = 1, .reusable = true}, SHIFT(519),
  [4422] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(102),
  [4425] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 3),
  [4427] = {.count = 1, .reusable = true}, SHIFT(1216),
  [4429] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(800),
  [4432] = {.count = 1, .reusable = true}, SHIFT(3185),
  [4434] = {.count = 1, .reusable = true}, SHIFT(738),
  [4436] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 24),
  [4438] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [4440] = {.count = 1, .reusable = true}, SHIFT(601),
  [4442] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(106),
  [4445] = {.count = 1, .reusable = true}, SHIFT(603),
  [4447] = {.count = 1, .reusable = true}, SHIFT(1070),
  [4449] = {.count = 1, .reusable = true}, SHIFT(1361),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1452),
  [4453] = {.count = 1, .reusable = false}, SHIFT(2053),
  [4455] = {.count = 1, .reusable = false}, SHIFT(1743),
  [4457] = {.count = 1, .reusable = false}, SHIFT(1741),
  [4459] = {.count = 1, .reusable = false}, SHIFT(1745),
  [4461] = {.count = 1, .reusable = false}, SHIFT(1767),
  [4463] = {.count = 1, .reusable = false}, SHIFT(1738),
  [4465] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(104),
  [4468] = {.count = 1, .reusable = true}, SHIFT(1054),
  [4470] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [4472] = {.count = 1, .reusable = true}, SHIFT(2328),
  [4474] = {.count = 1, .reusable = false}, SHIFT(328),
  [4476] = {.count = 1, .reusable = false}, SHIFT(331),
  [4478] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [4480] = {.count = 1, .reusable = true}, SHIFT(1024),
  [4482] = {.count = 1, .reusable = true}, SHIFT(2445),
  [4484] = {.count = 1, .reusable = false}, SHIFT(267),
  [4486] = {.count = 1, .reusable = false}, SHIFT(330),
  [4488] = {.count = 1, .reusable = false}, SHIFT(327),
  [4490] = {.count = 1, .reusable = false}, SHIFT(107),
  [4492] = {.count = 1, .reusable = true}, SHIFT(288),
  [4494] = {.count = 1, .reusable = true}, SHIFT(325),
  [4496] = {.count = 1, .reusable = true}, SHIFT(324),
  [4498] = {.count = 1, .reusable = true}, SHIFT(330),
  [4500] = {.count = 1, .reusable = false}, SHIFT(325),
  [4502] = {.count = 1, .reusable = false}, SHIFT(324),
  [4504] = {.count = 1, .reusable = false}, SHIFT(323),
  [4506] = {.count = 1, .reusable = true}, SHIFT(321),
  [4508] = {.count = 1, .reusable = true}, SHIFT(327),
  [4510] = {.count = 1, .reusable = true}, SHIFT(591),
  [4512] = {.count = 1, .reusable = true}, SHIFT(615),
  [4514] = {.count = 1, .reusable = true}, SHIFT(545),
  [4516] = {.count = 1, .reusable = true}, SHIFT(826),
  [4518] = {.count = 1, .reusable = true}, SHIFT(617),
  [4520] = {.count = 1, .reusable = true}, SHIFT(2635),
  [4522] = {.count = 1, .reusable = true}, SHIFT(667),
  [4524] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 63), SHIFT(107),
  [4527] = {.count = 1, .reusable = true}, SHIFT(619),
  [4529] = {.count = 1, .reusable = true}, SHIFT(623),
  [4531] = {.count = 1, .reusable = true}, SHIFT(2208),
  [4533] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(750),
  [4536] = {.count = 1, .reusable = true}, SHIFT(3147),
  [4538] = {.count = 1, .reusable = true}, SHIFT(807),
  [4540] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(107),
  [4543] = {.count = 1, .reusable = false}, SHIFT(268),
  [4545] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4548] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [4550] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4553] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 75),
  [4555] = {.count = 1, .reusable = true}, SHIFT(2358),
  [4557] = {.count = 1, .reusable = true}, SHIFT(2534),
  [4559] = {.count = 1, .reusable = true}, SHIFT(2299),
  [4561] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(200),
  [4564] = {.count = 1, .reusable = true}, SHIFT(200),
  [4566] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(204),
  [4569] = {.count = 1, .reusable = true}, SHIFT(204),
  [4571] = {.count = 1, .reusable = true}, SHIFT(52),
  [4573] = {.count = 1, .reusable = true}, SHIFT(40),
  [4575] = {.count = 1, .reusable = true}, SHIFT(621),
  [4577] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4579] = {.count = 1, .reusable = false}, SHIFT(1475),
  [4581] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4583] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4585] = {.count = 1, .reusable = false}, SHIFT(1584),
  [4587] = {.count = 1, .reusable = true}, SHIFT(622),
  [4589] = {.count = 1, .reusable = true}, SHIFT(1612),
  [4591] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4593] = {.count = 1, .reusable = false}, SHIFT(1423),
  [4595] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4597] = {.count = 1, .reusable = false}, SHIFT(1847),
  [4599] = {.count = 1, .reusable = false}, SHIFT(1667),
  [4601] = {.count = 1, .reusable = true}, SHIFT(54),
  [4603] = {.count = 1, .reusable = true}, SHIFT(908),
  [4605] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(800),
  [4608] = {.count = 1, .reusable = true}, SHIFT(616),
  [4610] = {.count = 1, .reusable = true}, SHIFT(618),
  [4612] = {.count = 1, .reusable = true}, SHIFT(8),
  [4614] = {.count = 1, .reusable = false}, SHIFT(1422),
  [4616] = {.count = 1, .reusable = false}, SHIFT(13),
  [4618] = {.count = 1, .reusable = true}, SHIFT(3211),
  [4620] = {.count = 1, .reusable = true}, SHIFT(379),
  [4622] = {.count = 1, .reusable = true}, SHIFT(2156),
  [4624] = {.count = 1, .reusable = false}, SHIFT(1783),
  [4626] = {.count = 1, .reusable = false}, SHIFT(1460),
  [4628] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4630] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4632] = {.count = 1, .reusable = false}, SHIFT(1779),
  [4634] = {.count = 1, .reusable = false}, SHIFT(1444),
  [4636] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4638] = {.count = 1, .reusable = false}, SHIFT(1636),
  [4640] = {.count = 1, .reusable = false}, SHIFT(1443),
  [4642] = {.count = 1, .reusable = true}, SHIFT(708),
  [4644] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4646] = {.count = 1, .reusable = false}, SHIFT(1562),
  [4648] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4650] = {.count = 1, .reusable = false}, SHIFT(1626),
  [4652] = {.count = 1, .reusable = false}, SHIFT(1501),
  [4654] = {.count = 1, .reusable = true}, SHIFT(1607),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2134),
  [4658] = {.count = 1, .reusable = false}, SHIFT(1797),
  [4660] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4662] = {.count = 1, .reusable = false}, SHIFT(1489),
  [4664] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4666] = {.count = 1, .reusable = false}, SHIFT(1674),
  [4668] = {.count = 1, .reusable = false}, SHIFT(1563),
  [4670] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4672] = {.count = 1, .reusable = false}, SHIFT(1547),
  [4674] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4676] = {.count = 1, .reusable = false}, SHIFT(1624),
  [4678] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(750),
  [4681] = {.count = 1, .reusable = true}, SHIFT(286),
  [4683] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4685] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4688] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [4690] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4693] = {.count = 1, .reusable = false}, SHIFT(333),
  [4695] = {.count = 1, .reusable = false}, REDUCE(sym__parameter_name, 1),
  [4697] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4703] = {.count = 1, .reusable = false}, SHIFT(1787),
  [4705] = {.count = 1, .reusable = false}, SHIFT(336),
  [4707] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(331),
  [4710] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4713] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4715] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(328),
  [4718] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4721] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2180),
  [4725] = {.count = 1, .reusable = false}, SHIFT(1802),
  [4727] = {.count = 1, .reusable = true}, SHIFT(410),
  [4729] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4733] = {.count = 1, .reusable = false}, SHIFT(1782),
  [4735] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4737] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4739] = {.count = 1, .reusable = false}, SHIFT(1804),
  [4741] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4743] = {.count = 1, .reusable = false}, SHIFT(1537),
  [4745] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4747] = {.count = 1, .reusable = false}, SHIFT(1647),
  [4749] = {.count = 1, .reusable = true}, SHIFT(360),
  [4751] = {.count = 1, .reusable = true}, SHIFT(363),
  [4753] = {.count = 1, .reusable = false}, SHIFT(391),
  [4755] = {.count = 1, .reusable = false}, SHIFT(382),
  [4757] = {.count = 1, .reusable = false}, SHIFT(399),
  [4759] = {.count = 1, .reusable = false}, SHIFT(400),
  [4761] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4763] = {.count = 1, .reusable = false}, SHIFT(741),
  [4765] = {.count = 1, .reusable = false}, SHIFT(744),
  [4767] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4769] = {.count = 1, .reusable = true}, SHIFT(2186),
  [4771] = {.count = 1, .reusable = false}, SHIFT(1789),
  [4773] = {.count = 1, .reusable = false}, SHIFT(1575),
  [4775] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4777] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4779] = {.count = 1, .reusable = false}, SHIFT(1794),
  [4781] = {.count = 1, .reusable = false}, SHIFT(1424),
  [4783] = {.count = 1, .reusable = true}, SHIFT(302),
  [4785] = {.count = 1, .reusable = true}, SHIFT(2165),
  [4787] = {.count = 1, .reusable = false}, SHIFT(1780),
  [4789] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4791] = {.count = 1, .reusable = false}, SHIFT(1809),
  [4793] = {.count = 1, .reusable = false}, SHIFT(1498),
  [4795] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4797] = {.count = 1, .reusable = false}, SHIFT(1686),
  [4799] = {.count = 1, .reusable = true}, SHIFT(707),
  [4801] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4803] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4805] = {.count = 1, .reusable = false}, SHIFT(804),
  [4807] = {.count = 1, .reusable = false}, SHIFT(803),
  [4809] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4811] = {.count = 1, .reusable = true}, SHIFT(2294),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2149),
  [4815] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4817] = {.count = 1, .reusable = false}, SHIFT(320),
  [4819] = {.count = 1, .reusable = false}, SHIFT(319),
  [4821] = {.count = 1, .reusable = true}, SHIFT(2446),
  [4823] = {.count = 1, .reusable = false}, SHIFT(2076),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2584),
  [4827] = {.count = 1, .reusable = true}, SHIFT(154),
  [4829] = {.count = 1, .reusable = false}, SHIFT(1946),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2681),
  [4833] = {.count = 1, .reusable = true}, SHIFT(2616),
  [4835] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4837] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4839] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4841] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4843] = {.count = 1, .reusable = true}, SHIFT(151),
  [4845] = {.count = 1, .reusable = false}, SHIFT(3095),
  [4847] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 29),
  [4849] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [4851] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [4853] = {.count = 1, .reusable = false}, SHIFT(3120),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4859] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [4861] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 58),
  [4863] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 26),
  [4865] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 26),
  [4867] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4869] = {.count = 1, .reusable = true}, SHIFT(2851),
  [4871] = {.count = 1, .reusable = true}, SHIFT(359),
  [4873] = {.count = 1, .reusable = true}, SHIFT(299),
  [4875] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 61),
  [4877] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 61),
  [4879] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4881] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4883] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4885] = {.count = 1, .reusable = false}, SHIFT(1774),
  [4887] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4889] = {.count = 1, .reusable = false}, SHIFT(1813),
  [4891] = {.count = 1, .reusable = false}, SHIFT(1776),
  [4893] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4895] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4897] = {.count = 1, .reusable = false}, SHIFT(1803),
  [4899] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4901] = {.count = 1, .reusable = true}, SHIFT(2195),
  [4903] = {.count = 1, .reusable = false}, SHIFT(1790),
  [4905] = {.count = 1, .reusable = true}, SHIFT(214),
  [4907] = {.count = 1, .reusable = false}, SHIFT(1773),
  [4909] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4911] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4913] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4915] = {.count = 1, .reusable = false}, SHIFT(2305),
  [4917] = {.count = 1, .reusable = false}, SHIFT(2304),
  [4919] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 18),
  [4921] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 138),
  [4923] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 138),
  [4925] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 129),
  [4927] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 129),
  [4929] = {.count = 1, .reusable = true}, SHIFT(2192),
  [4931] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4933] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 175),
  [4935] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 175),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2184),
  [4939] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 176),
  [4941] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 176),
  [4943] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 183),
  [4945] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 183),
  [4947] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3, .production_id = 76),
  [4949] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3, .production_id = 76),
  [4951] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 184),
  [4953] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 184),
  [4955] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 110),
  [4957] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 110),
  [4959] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4961] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4963] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 103),
  [4965] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 103),
  [4967] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 154),
  [4969] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 154),
  [4971] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4973] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9, .production_id = 188),
  [4975] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9, .production_id = 188),
  [4977] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 158),
  [4979] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 158),
  [4981] = {.count = 1, .reusable = false}, SHIFT(1425),
  [4983] = {.count = 1, .reusable = false}, SHIFT(1822),
  [4985] = {.count = 1, .reusable = false}, SHIFT(1391),
  [4987] = {.count = 1, .reusable = true}, SHIFT(2229),
  [4989] = {.count = 1, .reusable = true}, SHIFT(2536),
  [4991] = {.count = 1, .reusable = true}, SHIFT(2408),
  [4993] = {.count = 1, .reusable = true}, SHIFT(2331),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2216),
  [4997] = {.count = 1, .reusable = true}, SHIFT(598),
  [4999] = {.count = 1, .reusable = true}, SHIFT(2427),
  [5001] = {.count = 1, .reusable = true}, SHIFT(531),
  [5003] = {.count = 1, .reusable = true}, SHIFT(533),
  [5005] = {.count = 1, .reusable = true}, SHIFT(1842),
  [5007] = {.count = 1, .reusable = true}, SHIFT(1870),
  [5009] = {.count = 1, .reusable = false}, SHIFT(1700),
  [5011] = {.count = 1, .reusable = false}, SHIFT(1701),
  [5013] = {.count = 1, .reusable = true}, SHIFT(1831),
  [5015] = {.count = 1, .reusable = true}, SHIFT(1868),
  [5017] = {.count = 1, .reusable = false}, SHIFT(1629),
  [5019] = {.count = 1, .reusable = false}, SHIFT(1600),
  [5021] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5023] = {.count = 1, .reusable = false}, SHIFT(1435),
  [5025] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [5027] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23),
  [5029] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 23), SHIFT_REPEAT(1856),
  [5032] = {.count = 1, .reusable = false}, SHIFT(1454),
  [5034] = {.count = 1, .reusable = false}, SHIFT(1772),
  [5036] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [5038] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [5040] = {.count = 1, .reusable = false}, SHIFT(1784),
  [5042] = {.count = 1, .reusable = false}, SHIFT(1739),
  [5044] = {.count = 1, .reusable = false}, SHIFT(1737),
  [5046] = {.count = 1, .reusable = false}, SHIFT(2103),
  [5048] = {.count = 1, .reusable = true}, SHIFT(721),
  [5050] = {.count = 1, .reusable = true}, SHIFT(160),
  [5052] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5054] = {.count = 1, .reusable = true}, SHIFT(685),
  [5056] = {.count = 1, .reusable = true}, SHIFT(770),
  [5058] = {.count = 2, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 14), SHIFT(2586),
  [5061] = {.count = 1, .reusable = false}, SHIFT(3082),
  [5063] = {.count = 1, .reusable = true}, SHIFT(2103),
  [5065] = {.count = 1, .reusable = true}, SHIFT(3129),
  [5067] = {.count = 1, .reusable = false}, SHIFT(722),
  [5069] = {.count = 1, .reusable = false}, SHIFT(3150),
  [5071] = {.count = 1, .reusable = false}, SHIFT(3157),
  [5073] = {.count = 1, .reusable = true}, SHIFT(2981),
  [5075] = {.count = 1, .reusable = true}, SHIFT(367),
  [5077] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 47),
  [5079] = {.count = 1, .reusable = true}, SHIFT(1886),
  [5081] = {.count = 1, .reusable = true}, SHIFT(2065),
  [5083] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 119),
  [5085] = {.count = 1, .reusable = true}, SHIFT(1904),
  [5087] = {.count = 1, .reusable = true}, SHIFT(2069),
  [5089] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_namespace_name, 3),
  [5091] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_namespace_name, 3),
  [5093] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_jsx_namespace_name, 3),
  [5096] = {.count = 1, .reusable = false}, SHIFT(782),
  [5098] = {.count = 1, .reusable = true}, SHIFT(1897),
  [5100] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [5102] = {.count = 1, .reusable = true}, SHIFT(1900),
  [5104] = {.count = 1, .reusable = true}, SHIFT(2072),
  [5106] = {.count = 1, .reusable = true}, SHIFT(1903),
  [5108] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 153),
  [5110] = {.count = 1, .reusable = true}, SHIFT(1892),
  [5112] = {.count = 1, .reusable = true}, SHIFT(2047),
  [5114] = {.count = 1, .reusable = true}, SHIFT(784),
  [5116] = {.count = 1, .reusable = true}, SHIFT(3163),
  [5118] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 47),
  [5120] = {.count = 1, .reusable = true}, SHIFT(1887),
  [5122] = {.count = 1, .reusable = true}, SHIFT(1902),
  [5124] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 153),
  [5126] = {.count = 1, .reusable = true}, SHIFT(1890),
  [5128] = {.count = 1, .reusable = true}, SHIFT(2838),
  [5130] = {.count = 1, .reusable = true}, SHIFT(2586),
  [5132] = {.count = 1, .reusable = false}, SHIFT(3048),
  [5134] = {.count = 1, .reusable = false}, SHIFT(2987),
  [5136] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [5138] = {.count = 1, .reusable = true}, SHIFT(103),
  [5140] = {.count = 1, .reusable = true}, SHIFT(1907),
  [5142] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 119),
  [5144] = {.count = 1, .reusable = true}, SHIFT(1905),
  [5146] = {.count = 1, .reusable = true}, SHIFT(1891),
  [5148] = {.count = 1, .reusable = true}, SHIFT(1894),
  [5150] = {.count = 1, .reusable = true}, SHIFT(1896),
  [5152] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 47),
  [5154] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 47),
  [5156] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 153),
  [5158] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 153),
  [5160] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [5163] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 119),
  [5165] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5167] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5169] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 119),
  [5171] = {.count = 1, .reusable = true}, SHIFT(789),
  [5173] = {.count = 1, .reusable = true}, SHIFT(790),
  [5175] = {.count = 1, .reusable = true}, SHIFT(3093),
  [5177] = {.count = 1, .reusable = true}, SHIFT(797),
  [5179] = {.count = 1, .reusable = false}, SHIFT(796),
  [5181] = {.count = 1, .reusable = false}, SHIFT(1978),
  [5183] = {.count = 1, .reusable = true}, SHIFT(1192),
  [5185] = {.count = 1, .reusable = false}, SHIFT(787),
  [5187] = {.count = 1, .reusable = false}, SHIFT(168),
  [5189] = {.count = 1, .reusable = false}, SHIFT(2007),
  [5191] = {.count = 1, .reusable = true}, SHIFT(1317),
  [5193] = {.count = 1, .reusable = false}, SHIFT(1984),
  [5195] = {.count = 1, .reusable = true}, SHIFT(1255),
  [5197] = {.count = 1, .reusable = false}, SHIFT(1992),
  [5199] = {.count = 1, .reusable = true}, SHIFT(679),
  [5201] = {.count = 1, .reusable = false}, SHIFT(1983),
  [5203] = {.count = 1, .reusable = false}, SHIFT(1991),
  [5205] = {.count = 1, .reusable = false}, SHIFT(1976),
  [5207] = {.count = 1, .reusable = false}, SHIFT(2011),
  [5209] = {.count = 1, .reusable = true}, SHIFT(2253),
  [5211] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5213] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5215] = {.count = 1, .reusable = false}, SHIFT(1997),
  [5217] = {.count = 1, .reusable = false}, SHIFT(2005),
  [5219] = {.count = 1, .reusable = true}, SHIFT(2743),
  [5221] = {.count = 1, .reusable = true}, SHIFT(3050),
  [5223] = {.count = 1, .reusable = true}, SHIFT(2676),
  [5225] = {.count = 1, .reusable = false}, SHIFT(3051),
  [5227] = {.count = 1, .reusable = false}, SHIFT(163),
  [5229] = {.count = 1, .reusable = false}, SHIFT(2291),
  [5231] = {.count = 1, .reusable = false}, SHIFT(2000),
  [5233] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5235] = {.count = 1, .reusable = true}, SHIFT(787),
  [5237] = {.count = 1, .reusable = true}, SHIFT(168),
  [5239] = {.count = 1, .reusable = false}, SHIFT(2997),
  [5241] = {.count = 1, .reusable = true}, SHIFT(1217),
  [5243] = {.count = 1, .reusable = false}, SHIFT(2265),
  [5245] = {.count = 1, .reusable = false}, SHIFT(2001),
  [5247] = {.count = 1, .reusable = true}, SHIFT(1208),
  [5249] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5251] = {.count = 1, .reusable = false}, SHIFT(2020),
  [5253] = {.count = 1, .reusable = false}, SHIFT(2319),
  [5255] = {.count = 1, .reusable = false}, SHIFT(1987),
  [5257] = {.count = 1, .reusable = false}, SHIFT(3153),
  [5259] = {.count = 1, .reusable = false}, SHIFT(2430),
  [5261] = {.count = 1, .reusable = true}, SHIFT(1221),
  [5263] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90), SHIFT_REPEAT(2103),
  [5266] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90), SHIFT_REPEAT(160),
  [5269] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90),
  [5271] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90),
  [5273] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 90), SHIFT_REPEAT(2103),
  [5276] = {.count = 1, .reusable = false}, SHIFT(1985),
  [5278] = {.count = 1, .reusable = false}, SHIFT(1993),
  [5280] = {.count = 1, .reusable = true}, SHIFT(747),
  [5282] = {.count = 1, .reusable = true}, SHIFT(712),
  [5284] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [5286] = {.count = 1, .reusable = false}, SHIFT(3180),
  [5288] = {.count = 1, .reusable = false}, SHIFT(3022),
  [5290] = {.count = 1, .reusable = false}, SHIFT(2234),
  [5292] = {.count = 1, .reusable = true}, SHIFT(2675),
  [5294] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22),
  [5296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(163),
  [5299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2458),
  [5302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(2020),
  [5305] = {.count = 1, .reusable = false}, SHIFT(2330),
  [5307] = {.count = 1, .reusable = false}, SHIFT(2423),
  [5309] = {.count = 1, .reusable = false}, SHIFT(2238),
  [5311] = {.count = 1, .reusable = false}, SHIFT(2025),
  [5313] = {.count = 1, .reusable = false}, SHIFT(2277),
  [5315] = {.count = 1, .reusable = false}, SHIFT(2349),
  [5317] = {.count = 1, .reusable = false}, SHIFT(2022),
  [5319] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [5322] = {.count = 1, .reusable = true}, SHIFT(19),
  [5324] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [5327] = {.count = 1, .reusable = false}, SHIFT(2317),
  [5329] = {.count = 1, .reusable = false}, SHIFT(2021),
  [5331] = {.count = 1, .reusable = false}, SHIFT(2353),
  [5333] = {.count = 1, .reusable = false}, SHIFT(2015),
  [5335] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5339] = {.count = 1, .reusable = true}, SHIFT(722),
  [5341] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5343] = {.count = 1, .reusable = true}, SHIFT(3128),
  [5345] = {.count = 1, .reusable = true}, SHIFT(2224),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2159),
  [5349] = {.count = 1, .reusable = true}, SHIFT(1734),
  [5351] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [5353] = {.count = 1, .reusable = true}, SHIFT(446),
  [5355] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5357] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5361] = {.count = 1, .reusable = true}, SHIFT(2158),
  [5363] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 122),
  [5365] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5, .production_id = 115),
  [5367] = {.count = 1, .reusable = true}, SHIFT(337),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2273),
  [5371] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 102),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2862),
  [5375] = {.count = 1, .reusable = true}, SHIFT(169),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2143),
  [5381] = {.count = 1, .reusable = true}, SHIFT(2030),
  [5383] = {.count = 1, .reusable = true}, SHIFT(3055),
  [5385] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 167),
  [5387] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [5389] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [5391] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 146),
  [5393] = {.count = 1, .reusable = true}, SHIFT(383),
  [5395] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [5397] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5399] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5401] = {.count = 1, .reusable = true}, SHIFT(2202),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2258),
  [5405] = {.count = 1, .reusable = true}, SHIFT(2128),
  [5407] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 128),
  [5409] = {.count = 1, .reusable = true}, SHIFT(2298),
  [5411] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5413] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8, .production_id = 189),
  [5415] = {.count = 1, .reusable = false}, SHIFT(2051),
  [5417] = {.count = 1, .reusable = true}, SHIFT(1105),
  [5419] = {.count = 1, .reusable = true}, SHIFT(148),
  [5421] = {.count = 1, .reusable = false}, SHIFT(3187),
  [5423] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5425] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5427] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5429] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5431] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 186),
  [5433] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6, .production_id = 145),
  [5435] = {.count = 1, .reusable = true}, SHIFT(491),
  [5437] = {.count = 1, .reusable = true}, SHIFT(3088),
  [5439] = {.count = 1, .reusable = true}, SHIFT(2984),
  [5441] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 185),
  [5443] = {.count = 1, .reusable = false}, REDUCE(sym_type_annotation, 2),
  [5445] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 178),
  [5447] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5449] = {.count = 1, .reusable = true}, SHIFT(1960),
  [5451] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1, .production_id = 7),
  [5453] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 177),
  [5455] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2, .production_id = 93),
  [5457] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [5459] = {.count = 1, .reusable = false}, SHIFT(3021),
  [5461] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 168),
  [5463] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5465] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5469] = {.count = 1, .reusable = true}, SHIFT(2190),
  [5471] = {.count = 1, .reusable = true}, SHIFT(1526),
  [5473] = {.count = 1, .reusable = true}, SHIFT(233),
  [5475] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1),
  [5477] = {.count = 1, .reusable = true}, SHIFT(1959),
  [5479] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1),
  [5481] = {.count = 1, .reusable = true}, SHIFT(947),
  [5483] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5485] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(951),
  [5488] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [5490] = {.count = 1, .reusable = true}, SHIFT(2051),
  [5492] = {.count = 1, .reusable = true}, SHIFT(937),
  [5494] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5496] = {.count = 1, .reusable = true}, SHIFT(945),
  [5498] = {.count = 1, .reusable = false}, SHIFT(2715),
  [5500] = {.count = 1, .reusable = true}, SHIFT(3097),
  [5502] = {.count = 1, .reusable = true}, SHIFT(2714),
  [5504] = {.count = 1, .reusable = false}, SHIFT(3098),
  [5506] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5508] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(3019),
  [5511] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5513] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(184),
  [5516] = {.count = 1, .reusable = true}, SHIFT(944),
  [5518] = {.count = 1, .reusable = true}, SHIFT(1925),
  [5520] = {.count = 1, .reusable = true}, SHIFT(755),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2337),
  [5524] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5526] = {.count = 1, .reusable = true}, SHIFT(936),
  [5528] = {.count = 1, .reusable = true}, SHIFT(943),
  [5530] = {.count = 1, .reusable = true}, SHIFT(1164),
  [5532] = {.count = 1, .reusable = false}, SHIFT(1858),
  [5534] = {.count = 1, .reusable = true}, SHIFT(2024),
  [5536] = {.count = 1, .reusable = true}, SHIFT(1967),
  [5538] = {.count = 1, .reusable = true}, SHIFT(942),
  [5540] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5542] = {.count = 1, .reusable = true}, SHIFT(934),
  [5544] = {.count = 1, .reusable = true}, SHIFT(1580),
  [5546] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5548] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5550] = {.count = 1, .reusable = true}, SHIFT(1086),
  [5552] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [5554] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5556] = {.count = 1, .reusable = true}, SHIFT(2377),
  [5558] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5560] = {.count = 1, .reusable = true}, SHIFT(941),
  [5562] = {.count = 1, .reusable = true}, SHIFT(431),
  [5564] = {.count = 1, .reusable = true}, SHIFT(935),
  [5566] = {.count = 1, .reusable = true}, SHIFT(1649),
  [5568] = {.count = 1, .reusable = true}, SHIFT(2142),
  [5570] = {.count = 1, .reusable = true}, SHIFT(1699),
  [5572] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5574] = {.count = 1, .reusable = false}, SHIFT(1857),
  [5576] = {.count = 1, .reusable = true}, SHIFT(2033),
  [5578] = {.count = 1, .reusable = true}, SHIFT(1956),
  [5580] = {.count = 1, .reusable = true}, SHIFT(2282),
  [5582] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5584] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5588] = {.count = 1, .reusable = true}, SHIFT(946),
  [5590] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 3, .production_id = 68),
  [5592] = {.count = 1, .reusable = true}, SHIFT(2421),
  [5594] = {.count = 1, .reusable = true}, SHIFT(938),
  [5596] = {.count = 1, .reusable = true}, SHIFT(2412),
  [5598] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5600] = {.count = 1, .reusable = false}, SHIFT(1859),
  [5602] = {.count = 1, .reusable = true}, SHIFT(2032),
  [5604] = {.count = 1, .reusable = true}, SHIFT(1961),
  [5606] = {.count = 1, .reusable = true}, SHIFT(933),
  [5608] = {.count = 1, .reusable = true}, SHIFT(3019),
  [5610] = {.count = 1, .reusable = true}, SHIFT(567),
  [5612] = {.count = 1, .reusable = true}, SHIFT(184),
  [5614] = {.count = 1, .reusable = true}, SHIFT(939),
  [5616] = {.count = 1, .reusable = true}, SHIFT(3193),
  [5618] = {.count = 1, .reusable = true}, SHIFT(3199),
  [5620] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5622] = {.count = 1, .reusable = true}, SHIFT(2115),
  [5624] = {.count = 1, .reusable = true}, SHIFT(1458),
  [5626] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2275),
  [5630] = {.count = 1, .reusable = true}, SHIFT(940),
  [5632] = {.count = 1, .reusable = true}, SHIFT(1564),
  [5634] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5636] = {.count = 1, .reusable = true}, SHIFT(537),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2340),
  [5640] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5642] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2190),
  [5645] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5647] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(233),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2250),
  [5652] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2217),
  [5656] = {.count = 1, .reusable = true}, SHIFT(2334),
  [5658] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5660] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5664] = {.count = 1, .reusable = true}, SHIFT(1037),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5668] = {.count = 1, .reusable = true}, SHIFT(2231),
  [5670] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [5672] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 3),
  [5674] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 3),
  [5676] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [5678] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 121),
  [5680] = {.count = 1, .reusable = true}, SHIFT(14),
  [5682] = {.count = 1, .reusable = true}, SHIFT(683),
  [5684] = {.count = 1, .reusable = true}, SHIFT(1862),
  [5686] = {.count = 1, .reusable = true}, SHIFT(3045),
  [5688] = {.count = 1, .reusable = false}, SHIFT(1878),
  [5690] = {.count = 1, .reusable = false}, SHIFT(3184),
  [5692] = {.count = 1, .reusable = true}, SHIFT(1929),
  [5694] = {.count = 1, .reusable = false}, SHIFT(3178),
  [5696] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 124),
  [5698] = {.count = 1, .reusable = false}, SHIFT(1879),
  [5700] = {.count = 1, .reusable = true}, SHIFT(2026),
  [5702] = {.count = 1, .reusable = true}, SHIFT(1945),
  [5704] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6, .production_id = 181),
  [5706] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [5708] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3, .production_id = 7),
  [5710] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3),
  [5712] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3),
  [5714] = {.count = 1, .reusable = true}, SHIFT(699),
  [5716] = {.count = 1, .reusable = true}, SHIFT(461),
  [5718] = {.count = 1, .reusable = false}, SHIFT(2545),
  [5720] = {.count = 1, .reusable = false}, SHIFT(3140),
  [5722] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 174),
  [5724] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 31),
  [5726] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [5728] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5730] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 170),
  [5732] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [5734] = {.count = 1, .reusable = false}, SHIFT(2533),
  [5736] = {.count = 1, .reusable = true}, SHIFT(788),
  [5738] = {.count = 1, .reusable = true}, SHIFT(1942),
  [5740] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 84),
  [5742] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3),
  [5744] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 85),
  [5746] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 86),
  [5748] = {.count = 1, .reusable = true}, SHIFT(1566),
  [5750] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 150),
  [5752] = {.count = 1, .reusable = false}, SHIFT(2459),
  [5754] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 181),
  [5756] = {.count = 1, .reusable = true}, SHIFT(682),
  [5758] = {.count = 1, .reusable = true}, SHIFT(1542),
  [5760] = {.count = 1, .reusable = false}, SHIFT(3049),
  [5762] = {.count = 1, .reusable = false}, SHIFT(2525),
  [5764] = {.count = 1, .reusable = true}, SHIFT(3132),
  [5766] = {.count = 1, .reusable = true}, SHIFT(3065),
  [5768] = {.count = 1, .reusable = false}, SHIFT(3072),
  [5770] = {.count = 1, .reusable = true}, SHIFT(1817),
  [5772] = {.count = 1, .reusable = true}, SHIFT(2362),
  [5774] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .production_id = 18),
  [5776] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [5778] = {.count = 1, .reusable = true}, SHIFT(693),
  [5780] = {.count = 1, .reusable = true}, SHIFT(1606),
  [5782] = {.count = 1, .reusable = true}, SHIFT(753),
  [5784] = {.count = 1, .reusable = true}, SHIFT(754),
  [5786] = {.count = 1, .reusable = true}, SHIFT(701),
  [5788] = {.count = 1, .reusable = true}, SHIFT(1928),
  [5790] = {.count = 1, .reusable = false}, SHIFT(3063),
  [5792] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5794] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [5796] = {.count = 1, .reusable = false}, SHIFT(3149),
  [5798] = {.count = 1, .reusable = true}, SHIFT(1753),
  [5800] = {.count = 1, .reusable = true}, SHIFT(1957),
  [5802] = {.count = 1, .reusable = true}, SHIFT(1166),
  [5804] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 35),
  [5806] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 124),
  [5808] = {.count = 1, .reusable = true}, SHIFT(689),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2690),
  [5812] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [5814] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5816] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5820] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5822] = {.count = 1, .reusable = true}, SHIFT(442),
  [5824] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 148),
  [5826] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5828] = {.count = 1, .reusable = true}, SHIFT(1755),
  [5830] = {.count = 1, .reusable = true}, SHIFT(1930),
  [5832] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 150),
  [5834] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 148),
  [5836] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 31),
  [5838] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [5840] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2),
  [5842] = {.count = 1, .reusable = true}, SHIFT(1764),
  [5844] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 174),
  [5846] = {.count = 1, .reusable = false}, SHIFT(3007),
  [5848] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(788),
  [5851] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 2),
  [5853] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 2),
  [5855] = {.count = 1, .reusable = true}, SHIFT(1819),
  [5857] = {.count = 1, .reusable = true}, SHIFT(550),
  [5859] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 121),
  [5861] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [5863] = {.count = 1, .reusable = false}, SHIFT(2511),
  [5865] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 40),
  [5867] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 170),
  [5869] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 1, .production_id = 96),
  [5871] = {.count = 1, .reusable = true}, SHIFT(1645),
  [5873] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [5875] = {.count = 1, .reusable = true}, SHIFT(705),
  [5877] = {.count = 1, .reusable = true}, SHIFT(1162),
  [5879] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 48),
  [5881] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 48),
  [5883] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5885] = {.count = 1, .reusable = true}, SHIFT(574),
  [5887] = {.count = 1, .reusable = true}, SHIFT(595),
  [5889] = {.count = 1, .reusable = true}, SHIFT(796),
  [5891] = {.count = 1, .reusable = false}, SHIFT(1864),
  [5893] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5895] = {.count = 1, .reusable = false}, SHIFT(2474),
  [5897] = {.count = 1, .reusable = false}, SHIFT(417),
  [5899] = {.count = 1, .reusable = true}, SHIFT(2455),
  [5901] = {.count = 1, .reusable = false}, SHIFT(2455),
  [5903] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5905] = {.count = 1, .reusable = false}, SHIFT(2473),
  [5907] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [5909] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2455),
  [5912] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2455),
  [5915] = {.count = 1, .reusable = true}, SHIFT(1754),
  [5917] = {.count = 1, .reusable = false}, SHIFT(2634),
  [5919] = {.count = 1, .reusable = true}, SHIFT(2945),
  [5921] = {.count = 1, .reusable = true}, SHIFT(1927),
  [5923] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(166),
  [5926] = {.count = 1, .reusable = false}, SHIFT(418),
  [5928] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5930] = {.count = 1, .reusable = false}, SHIFT(2500),
  [5932] = {.count = 1, .reusable = true}, SHIFT(564),
  [5934] = {.count = 1, .reusable = true}, SHIFT(2453),
  [5936] = {.count = 1, .reusable = false}, SHIFT(2453),
  [5938] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3, .production_id = 51),
  [5940] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3, .production_id = 51),
  [5942] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [5944] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5946] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [5948] = {.count = 1, .reusable = false}, SHIFT(124),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5952] = {.count = 1, .reusable = false}, SHIFT(2549),
  [5954] = {.count = 1, .reusable = true}, SHIFT(573),
  [5956] = {.count = 1, .reusable = false}, SHIFT(1865),
  [5958] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5960] = {.count = 1, .reusable = false}, SHIFT(2516),
  [5962] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5964] = {.count = 1, .reusable = false}, SHIFT(2550),
  [5966] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5968] = {.count = 1, .reusable = false}, SHIFT(1613),
  [5970] = {.count = 1, .reusable = true}, SHIFT(2481),
  [5972] = {.count = 1, .reusable = false}, SHIFT(2481),
  [5974] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5976] = {.count = 1, .reusable = false}, SHIFT(2483),
  [5978] = {.count = 1, .reusable = false}, SHIFT(1611),
  [5980] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [5982] = {.count = 1, .reusable = false}, SHIFT(965),
  [5984] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5986] = {.count = 1, .reusable = false}, SHIFT(2538),
  [5988] = {.count = 1, .reusable = true}, SHIFT(570),
  [5990] = {.count = 1, .reusable = false}, SHIFT(2336),
  [5992] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5994] = {.count = 1, .reusable = false}, SHIFT(2492),
  [5996] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5998] = {.count = 1, .reusable = false}, SHIFT(2493),
  [6000] = {.count = 1, .reusable = true}, SHIFT(2242),
  [6002] = {.count = 1, .reusable = true}, SHIFT(2252),
  [6004] = {.count = 1, .reusable = false}, SHIFT(2448),
  [6006] = {.count = 1, .reusable = true}, SHIFT(2539),
  [6008] = {.count = 1, .reusable = false}, SHIFT(2539),
  [6010] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(155),
  [6013] = {.count = 1, .reusable = false}, SHIFT(1148),
  [6015] = {.count = 1, .reusable = true}, SHIFT(1964),
  [6017] = {.count = 1, .reusable = true}, SHIFT(2699),
  [6019] = {.count = 1, .reusable = true}, SHIFT(2289),
  [6021] = {.count = 1, .reusable = true}, SHIFT(563),
  [6023] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [6025] = {.count = 1, .reusable = true}, SHIFT(547),
  [6027] = {.count = 1, .reusable = true}, SHIFT(1946),
  [6029] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [6031] = {.count = 1, .reusable = false}, SHIFT(2554),
  [6033] = {.count = 1, .reusable = true}, SHIFT(2877),
  [6035] = {.count = 1, .reusable = false}, SHIFT(1141),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2497),
  [6039] = {.count = 1, .reusable = false}, SHIFT(2497),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2498),
  [6043] = {.count = 1, .reusable = false}, SHIFT(2498),
  [6045] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [6047] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2516),
  [6050] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2516),
  [6053] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(165),
  [6056] = {.count = 1, .reusable = true}, SHIFT(2288),
  [6058] = {.count = 1, .reusable = true}, SHIFT(575),
  [6060] = {.count = 1, .reusable = true}, SHIFT(2210),
  [6062] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2178),
  [6065] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6067] = {.count = 1, .reusable = false}, SHIFT(2633),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2941),
  [6071] = {.count = 1, .reusable = true}, SHIFT(3156),
  [6073] = {.count = 1, .reusable = true}, SHIFT(3119),
  [6075] = {.count = 1, .reusable = true}, SHIFT(174),
  [6077] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .production_id = 14),
  [6079] = {.count = 1, .reusable = false}, SHIFT(2697),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6083] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [6085] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [6087] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [6089] = {.count = 1, .reusable = false}, SHIFT(969),
  [6091] = {.count = 1, .reusable = true}, SHIFT(2297),
  [6093] = {.count = 1, .reusable = true}, SHIFT(2300),
  [6095] = {.count = 1, .reusable = false}, SHIFT(2751),
  [6097] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6099] = {.count = 1, .reusable = true}, SHIFT(529),
  [6101] = {.count = 1, .reusable = false}, SHIFT(123),
  [6103] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .production_id = 73),
  [6105] = {.count = 1, .reusable = true}, SHIFT(140),
  [6107] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6109] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1829),
  [6112] = {.count = 1, .reusable = true}, SHIFT(2655),
  [6114] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 149),
  [6116] = {.count = 1, .reusable = true}, SHIFT(142),
  [6118] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6120] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 169),
  [6122] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 171),
  [6124] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 172),
  [6126] = {.count = 1, .reusable = true}, SHIFT(2947),
  [6128] = {.count = 1, .reusable = true}, SHIFT(586),
  [6130] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 167),
  [6132] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 173),
  [6134] = {.count = 1, .reusable = true}, SHIFT(2673),
  [6136] = {.count = 1, .reusable = true}, SHIFT(2373),
  [6138] = {.count = 1, .reusable = true}, SHIFT(1951),
  [6140] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 168),
  [6142] = {.count = 1, .reusable = true}, SHIFT(1954),
  [6144] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 152),
  [6146] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 146),
  [6148] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 128),
  [6150] = {.count = 1, .reusable = true}, SHIFT(2037),
  [6152] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6154] = {.count = 1, .reusable = true}, SHIFT(588),
  [6156] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 151),
  [6158] = {.count = 1, .reusable = true}, SHIFT(684),
  [6160] = {.count = 1, .reusable = true}, SHIFT(1770),
  [6162] = {.count = 1, .reusable = true}, SHIFT(141),
  [6164] = {.count = 1, .reusable = true}, SHIFT(2806),
  [6166] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 179),
  [6168] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 180),
  [6170] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 182),
  [6172] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6, .production_id = 177),
  [6174] = {.count = 1, .reusable = true}, SHIFT(1948),
  [6176] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7, .production_id = 187),
  [6178] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 147),
  [6180] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type_clause, 3, .production_id = 14),
  [6182] = {.count = 1, .reusable = true}, SHIFT(2441),
  [6184] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 47),
  [6186] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .production_id = 73),
  [6188] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(725),
  [6191] = {.count = 1, .reusable = true}, SHIFT(713),
  [6193] = {.count = 1, .reusable = true}, SHIFT(1820),
  [6195] = {.count = 1, .reusable = true}, SHIFT(433),
  [6197] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [6199] = {.count = 1, .reusable = true}, SHIFT(432),
  [6201] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 79),
  [6203] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3, .production_id = 102),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2398),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2397),
  [6209] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 120),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2396),
  [6213] = {.count = 1, .reusable = true}, SHIFT(1059),
  [6215] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 5, .dynamic_precedence = -1, .production_id = 118),
  [6217] = {.count = 1, .reusable = true}, SHIFT(1120),
  [6219] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [6221] = {.count = 1, .reusable = true}, SHIFT(1159),
  [6223] = {.count = 1, .reusable = true}, SHIFT(746),
  [6225] = {.count = 1, .reusable = true}, SHIFT(1921),
  [6227] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 123),
  [6229] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2509),
  [6232] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [6234] = {.count = 1, .reusable = true}, SHIFT(1165),
  [6236] = {.count = 1, .reusable = true}, SHIFT(962),
  [6238] = {.count = 1, .reusable = true}, SHIFT(2738),
  [6240] = {.count = 1, .reusable = true}, SHIFT(2504),
  [6242] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [6244] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2547),
  [6247] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [6249] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [6251] = {.count = 1, .reusable = true}, SHIFT(1691),
  [6253] = {.count = 1, .reusable = true}, SHIFT(2323),
  [6255] = {.count = 1, .reusable = true}, SHIFT(709),
  [6257] = {.count = 1, .reusable = true}, SHIFT(1725),
  [6259] = {.count = 1, .reusable = true}, SHIFT(2662),
  [6261] = {.count = 1, .reusable = true}, SHIFT(1640),
  [6263] = {.count = 1, .reusable = true}, SHIFT(1412),
  [6265] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(714),
  [6268] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(718),
  [6271] = {.count = 1, .reusable = true}, SHIFT(961),
  [6273] = {.count = 1, .reusable = true}, SHIFT(1137),
  [6275] = {.count = 1, .reusable = true}, SHIFT(1135),
  [6277] = {.count = 1, .reusable = true}, SHIFT(1728),
  [6279] = {.count = 1, .reusable = true}, SHIFT(970),
  [6281] = {.count = 1, .reusable = true}, SHIFT(704),
  [6283] = {.count = 1, .reusable = true}, SHIFT(1421),
  [6285] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [6287] = {.count = 1, .reusable = true}, SHIFT(440),
  [6289] = {.count = 1, .reusable = true}, SHIFT(1441),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2570),
  [6293] = {.count = 1, .reusable = true}, SHIFT(2211),
  [6295] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [6297] = {.count = 1, .reusable = true}, SHIFT(960),
  [6299] = {.count = 1, .reusable = true}, SHIFT(526),
  [6301] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2886),
  [6304] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [6306] = {.count = 1, .reusable = true}, SHIFT(1448),
  [6308] = {.count = 1, .reusable = true}, SHIFT(1453),
  [6310] = {.count = 1, .reusable = true}, SHIFT(2283),
  [6312] = {.count = 1, .reusable = true}, SHIFT(1456),
  [6314] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 91),
  [6316] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 89),
  [6318] = {.count = 1, .reusable = true}, SHIFT(1718),
  [6320] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [6322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(1746),
  [6325] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 23),
  [6327] = {.count = 1, .reusable = true}, SHIFT(1654),
  [6329] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 81),
  [6331] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 80),
  [6333] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 79),
  [6335] = {.count = 1, .reusable = true}, SHIFT(1646),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2322),
  [6339] = {.count = 1, .reusable = true}, SHIFT(2284),
  [6341] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .production_id = 73),
  [6343] = {.count = 1, .reusable = true}, SHIFT(680),
  [6345] = {.count = 1, .reusable = true}, SHIFT(3016),
  [6347] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2, .production_id = 47),
  [6349] = {.count = 1, .reusable = true}, SHIFT(2329),
  [6351] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [6353] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(774),
  [6356] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(786),
  [6359] = {.count = 1, .reusable = true}, SHIFT(1638),
  [6361] = {.count = 1, .reusable = true}, SHIFT(2303),
  [6363] = {.count = 1, .reusable = true}, SHIFT(1635),
  [6365] = {.count = 1, .reusable = true}, SHIFT(1742),
  [6367] = {.count = 1, .reusable = true}, SHIFT(2045),
  [6369] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 22), SHIFT(771),
  [6372] = {.count = 1, .reusable = true}, SHIFT(2753),
  [6374] = {.count = 1, .reusable = true}, SHIFT(2598),
  [6376] = {.count = 1, .reusable = true}, SHIFT(1815),
  [6378] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [6380] = {.count = 1, .reusable = true}, SHIFT(3070),
  [6382] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [6384] = {.count = 1, .reusable = true}, SHIFT(2368),
  [6386] = {.count = 1, .reusable = true}, SHIFT(2694),
  [6388] = {.count = 1, .reusable = true}, SHIFT(1541),
  [6390] = {.count = 1, .reusable = true}, SHIFT(1115),
  [6392] = {.count = 1, .reusable = true}, SHIFT(2338),
  [6394] = {.count = 1, .reusable = true}, SHIFT(2324),
  [6396] = {.count = 1, .reusable = true}, SHIFT(1545),
  [6398] = {.count = 1, .reusable = true}, SHIFT(1736),
  [6400] = {.count = 1, .reusable = true}, SHIFT(2280),
  [6402] = {.count = 1, .reusable = true}, SHIFT(2749),
  [6404] = {.count = 1, .reusable = true}, SHIFT(2609),
  [6406] = {.count = 1, .reusable = true}, SHIFT(690),
  [6408] = {.count = 1, .reusable = true}, SHIFT(1520),
  [6410] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [6412] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(775),
  [6415] = {.count = 1, .reusable = true}, SHIFT(1732),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2443),
  [6419] = {.count = 1, .reusable = false}, SHIFT(2669),
  [6421] = {.count = 1, .reusable = false}, SHIFT(3035),
  [6423] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [6425] = {.count = 1, .reusable = true}, SHIFT(695),
  [6427] = {.count = 1, .reusable = true}, SHIFT(1087),
  [6429] = {.count = 1, .reusable = true}, SHIFT(688),
  [6431] = {.count = 1, .reusable = true}, SHIFT(3036),
  [6433] = {.count = 1, .reusable = true}, SHIFT(2233),
  [6435] = {.count = 1, .reusable = true}, SHIFT(3041),
  [6437] = {.count = 1, .reusable = true}, SHIFT(426),
  [6439] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(798),
  [6442] = {.count = 1, .reusable = true}, SHIFT(1565),
  [6444] = {.count = 1, .reusable = true}, SHIFT(2628),
  [6446] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [6448] = {.count = 1, .reusable = true}, SHIFT(1088),
  [6450] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1301),
  [6453] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [6455] = {.count = 1, .reusable = true}, SHIFT(1046),
  [6457] = {.count = 1, .reusable = true}, SHIFT(188),
  [6459] = {.count = 1, .reusable = true}, SHIFT(578),
  [6461] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [6463] = {.count = 1, .reusable = true}, SHIFT(13),
  [6465] = {.count = 1, .reusable = true}, SHIFT(167),
  [6467] = {.count = 1, .reusable = true}, SHIFT(44),
  [6469] = {.count = 1, .reusable = true}, SHIFT(2290),
  [6471] = {.count = 1, .reusable = true}, SHIFT(589),
  [6473] = {.count = 1, .reusable = true}, SHIFT(1513),
  [6475] = {.count = 1, .reusable = true}, SHIFT(31),
  [6477] = {.count = 1, .reusable = true}, SHIFT(1816),
  [6479] = {.count = 1, .reusable = false}, SHIFT(2177),
  [6481] = {.count = 1, .reusable = true}, SHIFT(476),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2736),
  [6485] = {.count = 1, .reusable = true}, SHIFT(2209),
  [6487] = {.count = 1, .reusable = true}, SHIFT(3206),
  [6489] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4, .production_id = 137),
  [6491] = {.count = 1, .reusable = true}, SHIFT(2246),
  [6493] = {.count = 1, .reusable = true}, SHIFT(3062),
  [6495] = {.count = 1, .reusable = true}, SHIFT(2262),
  [6497] = {.count = 1, .reusable = true}, SHIFT(3109),
  [6499] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2, .production_id = 41),
  [6501] = {.count = 1, .reusable = true}, SHIFT(2248),
  [6503] = {.count = 1, .reusable = true}, SHIFT(3203),
  [6505] = {.count = 1, .reusable = true}, SHIFT(1818),
  [6507] = {.count = 1, .reusable = true}, SHIFT(1152),
  [6509] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2, .production_id = 70),
  [6511] = {.count = 1, .reusable = true}, SHIFT(523),
  [6513] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 116),
  [6515] = {.count = 1, .reusable = true}, SHIFT(2669),
  [6517] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 114),
  [6519] = {.count = 1, .reusable = true}, SHIFT(1917),
  [6521] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 77),
  [6523] = {.count = 1, .reusable = true}, SHIFT(527),
  [6525] = {.count = 1, .reusable = true}, SHIFT(565),
  [6527] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 73),
  [6529] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3, .production_id = 109),
  [6531] = {.count = 1, .reusable = true}, SHIFT(2173),
  [6533] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [6535] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6537] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 87),
  [6539] = {.count = 1, .reusable = true}, SHIFT(605),
  [6541] = {.count = 1, .reusable = true}, SHIFT(604),
  [6543] = {.count = 1, .reusable = true}, SHIFT(221),
  [6545] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 87),
  [6547] = {.count = 1, .reusable = true}, SHIFT(1659),
  [6549] = {.count = 1, .reusable = true}, SHIFT(555),
  [6551] = {.count = 1, .reusable = true}, SHIFT(1895),
  [6553] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .production_id = 14),
  [6555] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 41),
  [6557] = {.count = 1, .reusable = true}, SHIFT(228),
  [6559] = {.count = 1, .reusable = true}, SHIFT(843),
  [6561] = {.count = 1, .reusable = false}, SHIFT(1408),
  [6563] = {.count = 1, .reusable = true}, SHIFT(904),
  [6565] = {.count = 1, .reusable = true}, SHIFT(422),
  [6567] = {.count = 1, .reusable = true}, SHIFT(1126),
  [6569] = {.count = 1, .reusable = true}, SHIFT(2999),
  [6571] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6573] = {.count = 1, .reusable = true}, SHIFT(907),
  [6575] = {.count = 1, .reusable = true}, SHIFT(2395),
  [6577] = {.count = 1, .reusable = true}, SHIFT(223),
  [6579] = {.count = 1, .reusable = true}, SHIFT(207),
  [6581] = {.count = 1, .reusable = false}, SHIFT(3094),
  [6583] = {.count = 1, .reusable = true}, SHIFT(714),
  [6585] = {.count = 1, .reusable = true}, SHIFT(1149),
  [6587] = {.count = 1, .reusable = true}, SHIFT(736),
  [6589] = {.count = 1, .reusable = true}, SHIFT(1587),
  [6591] = {.count = 1, .reusable = true}, SHIFT(896),
  [6593] = {.count = 1, .reusable = true}, SHIFT(473),
  [6595] = {.count = 1, .reusable = true}, SHIFT(1507),
  [6597] = {.count = 1, .reusable = true}, SHIFT(890),
  [6599] = {.count = 1, .reusable = true}, SHIFT(785),
  [6601] = {.count = 1, .reusable = true}, SHIFT(780),
  [6603] = {.count = 1, .reusable = true}, SHIFT(213),
  [6605] = {.count = 1, .reusable = true}, SHIFT(191),
  [6607] = {.count = 1, .reusable = true}, SHIFT(674),
  [6609] = {.count = 1, .reusable = true}, SHIFT(219),
  [6611] = {.count = 1, .reusable = true}, SHIFT(222),
  [6613] = {.count = 1, .reusable = true}, SHIFT(2950),
  [6615] = {.count = 1, .reusable = true}, SHIFT(2431),
  [6617] = {.count = 1, .reusable = true}, SHIFT(1655),
  [6619] = {.count = 1, .reusable = true}, SHIFT(430),
  [6621] = {.count = 1, .reusable = true}, SHIFT(2857),
  [6623] = {.count = 1, .reusable = true}, SHIFT(2470),
  [6625] = {.count = 1, .reusable = true}, SHIFT(888),
  [6627] = {.count = 1, .reusable = true}, SHIFT(10),
  [6629] = {.count = 1, .reusable = true}, SHIFT(855),
  [6631] = {.count = 1, .reusable = true}, SHIFT(2872),
  [6633] = {.count = 1, .reusable = true}, SHIFT(2365),
  [6635] = {.count = 1, .reusable = true}, SHIFT(717),
  [6637] = {.count = 1, .reusable = true}, SHIFT(205),
  [6639] = {.count = 1, .reusable = true}, SHIFT(786),
  [6641] = {.count = 1, .reusable = true}, SHIFT(902),
  [6643] = {.count = 1, .reusable = true}, SHIFT(1529),
  [6645] = {.count = 1, .reusable = true}, SHIFT(189),
  [6647] = {.count = 1, .reusable = true}, SHIFT(190),
  [6649] = {.count = 1, .reusable = true}, SHIFT(192),
  [6651] = {.count = 1, .reusable = true}, SHIFT(193),
  [6653] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [6655] = {.count = 1, .reusable = true}, SHIFT(2619),
  [6657] = {.count = 1, .reusable = true}, SHIFT(3035),
  [6659] = {.count = 1, .reusable = true}, SHIFT(813),
  [6661] = {.count = 1, .reusable = true}, SHIFT(255),
  [6663] = {.count = 1, .reusable = true}, SHIFT(1167),
  [6665] = {.count = 1, .reusable = true}, SHIFT(2225),
  [6667] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .production_id = 77),
  [6669] = {.count = 1, .reusable = false}, SHIFT(3096),
  [6671] = {.count = 1, .reusable = true}, SHIFT(846),
  [6673] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [6675] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .production_id = 77),
  [6677] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [6679] = {.count = 1, .reusable = true}, SHIFT(724),
  [6681] = {.count = 1, .reusable = true}, SHIFT(2651),
  [6683] = {.count = 1, .reusable = true}, SHIFT(1525),
  [6685] = {.count = 1, .reusable = true}, SHIFT(3191),
  [6687] = {.count = 1, .reusable = true}, SHIFT(1650),
  [6689] = {.count = 1, .reusable = true}, SHIFT(1998),
  [6691] = {.count = 1, .reusable = true}, SHIFT(3100),
  [6693] = {.count = 1, .reusable = true}, SHIFT(812),
  [6695] = {.count = 1, .reusable = true}, SHIFT(910),
  [6697] = {.count = 1, .reusable = true}, SHIFT(2332),
  [6699] = {.count = 1, .reusable = true}, SHIFT(2374),
  [6701] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [6703] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6705] = {.count = 1, .reusable = true}, SHIFT(1934),
  [6707] = {.count = 1, .reusable = true}, SHIFT(733),
  [6709] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6711] = {.count = 1, .reusable = true}, SHIFT(3040),
  [6713] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6715] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6717] = {.count = 1, .reusable = true}, SHIFT(1490),
  [6719] = {.count = 1, .reusable = true}, SHIFT(1156),
  [6721] = {.count = 1, .reusable = true}, SHIFT(226),
  [6723] = {.count = 1, .reusable = true}, SHIFT(675),
  [6725] = {.count = 1, .reusable = true}, SHIFT(810),
  [6727] = {.count = 1, .reusable = true}, SHIFT(798),
  [6729] = {.count = 1, .reusable = true}, SHIFT(927),
  [6731] = {.count = 1, .reusable = true}, SHIFT(1661),
  [6733] = {.count = 1, .reusable = true}, SHIFT(2967),
  [6735] = {.count = 1, .reusable = true}, SHIFT(2897),
  [6737] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6739] = {.count = 1, .reusable = true}, SHIFT(2783),
  [6741] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6743] = {.count = 1, .reusable = true}, SHIFT(3174),
  [6745] = {.count = 1, .reusable = true}, SHIFT(725),
  [6747] = {.count = 1, .reusable = true}, SHIFT(1922),
  [6749] = {.count = 1, .reusable = false}, SHIFT(1459),
  [6751] = {.count = 1, .reusable = true}, SHIFT(1751),
  [6753] = {.count = 1, .reusable = false}, SHIFT(1538),
  [6755] = {.count = 1, .reusable = true}, SHIFT(2698),
  [6757] = {.count = 1, .reusable = true}, SHIFT(2696),
  [6759] = {.count = 1, .reusable = false}, SHIFT(1185),
  [6761] = {.count = 1, .reusable = true}, SHIFT(772),
  [6763] = {.count = 1, .reusable = true}, SHIFT(718),
  [6765] = {.count = 1, .reusable = true}, SHIFT(2904),
  [6767] = {.count = 1, .reusable = true}, SHIFT(865),
  [6769] = {.count = 1, .reusable = true}, SHIFT(231),
  [6771] = {.count = 1, .reusable = true}, SHIFT(232),
  [6773] = {.count = 1, .reusable = true}, SHIFT(234),
  [6775] = {.count = 1, .reusable = true}, SHIFT(2232),
  [6777] = {.count = 1, .reusable = true}, SHIFT(2860),
  [6779] = {.count = 1, .reusable = true}, SHIFT(179),
  [6781] = {.count = 1, .reusable = true}, SHIFT(229),
  [6783] = {.count = 1, .reusable = true}, SHIFT(215),
  [6785] = {.count = 1, .reusable = true}, SHIFT(2850),
  [6787] = {.count = 1, .reusable = true}, SHIFT(1034),
  [6789] = {.count = 1, .reusable = true}, SHIFT(749),
  [6791] = {.count = 1, .reusable = true}, SHIFT(1996),
  [6793] = {.count = 1, .reusable = true}, SHIFT(662),
  [6795] = {.count = 1, .reusable = true}, SHIFT(1980),
  [6797] = {.count = 1, .reusable = true}, SHIFT(1747),
  [6799] = {.count = 1, .reusable = true}, SHIFT(710),
  [6801] = {.count = 1, .reusable = true}, SHIFT(3103),
  [6803] = {.count = 1, .reusable = true}, SHIFT(2612),
  [6805] = {.count = 1, .reusable = true}, SHIFT(752),
  [6807] = {.count = 1, .reusable = true}, SHIFT(134),
  [6809] = {.count = 1, .reusable = true}, SHIFT(773),
  [6811] = {.count = 1, .reusable = true}, SHIFT(3166),
  [6813] = {.count = 1, .reusable = true}, SHIFT(3190),
  [6815] = {.count = 1, .reusable = true}, SHIFT(1860),
  [6817] = {.count = 1, .reusable = true}, SHIFT(3085),
  [6819] = {.count = 1, .reusable = true}, SHIFT(805),
  [6821] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .production_id = 77),
  [6823] = {.count = 1, .reusable = true}, SHIFT(2780),
  [6825] = {.count = 1, .reusable = true}, SHIFT(758),
  [6827] = {.count = 1, .reusable = true}, SHIFT(759),
  [6829] = {.count = 1, .reusable = true}, SHIFT(1097),
  [6831] = {.count = 1, .reusable = true}, SHIFT(760),
  [6833] = {.count = 1, .reusable = true}, SHIFT(620),
  [6835] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6837] = {.count = 1, .reusable = true}, SHIFT(795),
  [6839] = {.count = 1, .reusable = true}, SHIFT(1619),
  [6841] = {.count = 1, .reusable = true}, SHIFT(822),
  [6843] = {.count = 1, .reusable = true}, SHIFT(1695),
  [6845] = {.count = 1, .reusable = true}, SHIFT(1050),
  [6847] = {.count = 1, .reusable = true}, SHIFT(889),
  [6849] = {.count = 1, .reusable = true}, SHIFT(252),
  [6851] = {.count = 1, .reusable = true}, SHIFT(2653),
  [6853] = {.count = 1, .reusable = true}, SHIFT(792),
  [6855] = {.count = 1, .reusable = true}, SHIFT(1517),
  [6857] = {.count = 1, .reusable = true}, SHIFT(1988),
  [6859] = {.count = 1, .reusable = true}, SHIFT(1419),
  [6861] = {.count = 1, .reusable = true}, SHIFT(775),
  [6863] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [6865] = {.count = 1, .reusable = true}, SHIFT(2908),
  [6867] = {.count = 1, .reusable = true}, SHIFT(2096),
  [6869] = {.count = 1, .reusable = true}, SHIFT(3054),
  [6871] = {.count = 1, .reusable = true}, SHIFT(1908),
  [6873] = {.count = 1, .reusable = true}, SHIFT(774),
  [6875] = {.count = 1, .reusable = true}, SHIFT(906),
  [6877] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6879] = {.count = 1, .reusable = true}, SHIFT(702),
  [6881] = {.count = 1, .reusable = true}, SHIFT(740),
  [6883] = {.count = 1, .reusable = true}, SHIFT(405),
  [6885] = {.count = 1, .reusable = true}, SHIFT(403),
  [6887] = {.count = 1, .reusable = true}, SHIFT(793),
  [6889] = {.count = 1, .reusable = false}, SHIFT(2979),
  [6891] = {.count = 1, .reusable = true}, SHIFT(2012),
  [6893] = {.count = 1, .reusable = true}, SHIFT(811),
  [6895] = {.count = 1, .reusable = true}, SHIFT(242),
  [6897] = {.count = 1, .reusable = true}, SHIFT(1082),
  [6899] = {.count = 1, .reusable = true}, SHIFT(1084),
  [6901] = {.count = 1, .reusable = true}, SHIFT(767),
  [6903] = {.count = 1, .reusable = true}, SHIFT(872),
  [6905] = {.count = 1, .reusable = true}, SHIFT(771),
  [6907] = {.count = 1, .reusable = true}, SHIFT(1690),
  [6909] = {.count = 1, .reusable = true}, SHIFT(1567),
  [6911] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6913] = {.count = 1, .reusable = true}, SHIFT(768),
  [6915] = {.count = 1, .reusable = true}, SHIFT(873),
  [6917] = {.count = 1, .reusable = true}, SHIFT(769),
  [6919] = {.count = 1, .reusable = true}, SHIFT(3046),
  [6921] = {.count = 1, .reusable = true}, SHIFT(2002),
  [6923] = {.count = 1, .reusable = true}, SHIFT(3044),
  [6925] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6927] = {.count = 1, .reusable = true}, SHIFT(2061),
  [6929] = {.count = 1, .reusable = true}, SHIFT(2590),
  [6931] = {.count = 1, .reusable = true}, SHIFT(3114),
  [6933] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6935] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [6937] = {.count = 1, .reusable = false}, SHIFT(3099),
  [6939] = {.count = 1, .reusable = true}, SHIFT(849),
  [6941] = {.count = 1, .reusable = true}, SHIFT(895),
  [6943] = {.count = 1, .reusable = true}, SHIFT(2255),
  [6945] = {.count = 1, .reusable = true}, SHIFT(856),
  [6947] = {.count = 1, .reusable = true}, SHIFT(905),
  [6949] = {.count = 1, .reusable = true}, SHIFT(2389),
  [6951] = {.count = 1, .reusable = true}, SHIFT(899),
  [6953] = {.count = 1, .reusable = true}, SHIFT(914),
  [6955] = {.count = 1, .reusable = true}, SHIFT(1608),
};

void *tree_sitter_tsx_external_scanner_create(void);
void tree_sitter_tsx_external_scanner_destroy(void *);
bool tree_sitter_tsx_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_tsx_external_scanner_serialize(void *, char *);
void tree_sitter_tsx_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_tsx(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_tsx_external_scanner_create,
      tree_sitter_tsx_external_scanner_destroy,
      tree_sitter_tsx_external_scanner_scan,
      tree_sitter_tsx_external_scanner_serialize,
      tree_sitter_tsx_external_scanner_deserialize,
    },
  };
  return &language;
}
