#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 2973
#define SYMBOL_COUNT 298
#define ALIAS_COUNT 8
#define TOKEN_COUNT 140
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_await = 25,
  anon_sym_in = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  anon_sym_DOT = 48,
  anon_sym_class = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_new = 53,
  anon_sym_PLUS_EQ = 54,
  anon_sym_DASH_EQ = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH_EQ = 57,
  anon_sym_PERCENT_EQ = 58,
  anon_sym_CARET_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PIPE_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_GT_GT_GT_EQ = 63,
  anon_sym_LT_LT_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_DOT_DOT_DOT = 66,
  anon_sym_QMARK = 67,
  anon_sym_AMP_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_GT_GT = 70,
  anon_sym_GT_GT_GT = 71,
  anon_sym_LT_LT = 72,
  anon_sym_AMP = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_PLUS = 76,
  anon_sym_DASH = 77,
  anon_sym_PERCENT = 78,
  anon_sym_STAR_STAR = 79,
  anon_sym_LT_EQ = 80,
  anon_sym_EQ_EQ = 81,
  anon_sym_EQ_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_BANG_EQ_EQ = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_instanceof = 86,
  anon_sym_BANG = 87,
  anon_sym_TILDE = 88,
  anon_sym_void = 89,
  anon_sym_delete = 90,
  anon_sym_PLUS_PLUS = 91,
  anon_sym_DASH_DASH = 92,
  anon_sym_DQUOTE = 93,
  aux_sym_string_token1 = 94,
  anon_sym_SQUOTE = 95,
  aux_sym_string_token2 = 96,
  sym_escape_sequence = 97,
  sym_comment = 98,
  anon_sym_BQUOTE = 99,
  anon_sym_DOLLAR_LBRACE = 100,
  anon_sym_SLASH2 = 101,
  sym_regex_pattern = 102,
  sym_regex_flags = 103,
  sym_number = 104,
  anon_sym_target = 105,
  sym_this = 106,
  sym_super = 107,
  sym_true = 108,
  sym_false = 109,
  sym_null = 110,
  sym_undefined = 111,
  anon_sym_AT = 112,
  anon_sym_static = 113,
  anon_sym_abstract = 114,
  anon_sym_get = 115,
  anon_sym_set = 116,
  anon_sym_declare = 117,
  anon_sym_public = 118,
  anon_sym_private = 119,
  anon_sym_protected = 120,
  anon_sym_module = 121,
  anon_sym_any = 122,
  anon_sym_number = 123,
  anon_sym_boolean = 124,
  anon_sym_string = 125,
  anon_sym_symbol = 126,
  anon_sym_require = 127,
  anon_sym_implements = 128,
  anon_sym_global = 129,
  anon_sym_interface = 130,
  anon_sym_extends = 131,
  anon_sym_enum = 132,
  sym_readonly = 133,
  anon_sym_is = 134,
  anon_sym_keyof = 135,
  anon_sym_LBRACE_PIPE = 136,
  anon_sym_PIPE_RBRACE = 137,
  sym__automatic_semicolon = 138,
  sym__template_chars = 139,
  sym_program = 140,
  sym_export_statement = 141,
  sym_export_clause = 142,
  sym__import_export_specifier = 143,
  sym__declaration = 144,
  sym_import = 145,
  sym_import_statement = 146,
  sym_import_clause = 147,
  sym__from_clause = 148,
  sym_namespace_import = 149,
  sym_named_imports = 150,
  sym_expression_statement = 151,
  sym_variable_declaration = 152,
  sym_lexical_declaration = 153,
  sym_variable_declarator = 154,
  sym_statement_block = 155,
  sym_if_statement = 156,
  sym_switch_statement = 157,
  sym_for_statement = 158,
  sym_for_in_statement = 159,
  sym__for_header = 160,
  sym_while_statement = 161,
  sym_do_statement = 162,
  sym_try_statement = 163,
  sym_with_statement = 164,
  sym_break_statement = 165,
  sym_continue_statement = 166,
  sym_debugger_statement = 167,
  sym_return_statement = 168,
  sym_throw_statement = 169,
  sym_empty_statement = 170,
  sym_labeled_statement = 171,
  sym_switch_body = 172,
  sym_switch_case = 173,
  sym_switch_default = 174,
  sym_catch_clause = 175,
  sym_finally_clause = 176,
  sym_parenthesized_expression = 177,
  sym__expression = 178,
  sym_yield_expression = 179,
  sym_object = 180,
  sym_assignment_pattern = 181,
  sym_array = 182,
  sym_nested_identifier = 183,
  sym_class = 184,
  sym_class_declaration = 185,
  sym_class_heritage = 186,
  sym_function = 187,
  sym_function_declaration = 188,
  sym_generator_function = 189,
  sym_generator_function_declaration = 190,
  sym_arrow_function = 191,
  sym__call_signature = 192,
  sym_call_expression = 193,
  sym_new_expression = 194,
  sym_await_expression = 195,
  sym_member_expression = 196,
  sym_subscript_expression = 197,
  sym_assignment_expression = 198,
  sym_augmented_assignment_expression = 199,
  sym__initializer = 200,
  sym_spread_element = 201,
  sym_ternary_expression = 202,
  sym_binary_expression = 203,
  sym_unary_expression = 204,
  sym_update_expression = 205,
  sym_sequence_expression = 206,
  sym_string = 207,
  sym_template_string = 208,
  sym_template_substitution = 209,
  sym_regex = 210,
  sym_meta_property = 211,
  sym_arguments = 212,
  sym_decorator = 213,
  sym_decorator_member_expression = 214,
  sym_decorator_call_expression = 215,
  sym_class_body = 216,
  sym_public_field_definition = 217,
  sym_formal_parameters = 218,
  sym_rest_parameter = 219,
  sym_method_definition = 220,
  sym_pair = 221,
  sym__property_name = 222,
  sym_computed_property_name = 223,
  sym_non_null_expression = 224,
  sym_method_signature = 225,
  sym_abstract_method_signature = 226,
  sym_function_signature = 227,
  sym_type_assertion = 228,
  sym_as_expression = 229,
  sym_import_require_clause = 230,
  sym_implements_clause = 231,
  sym_ambient_declaration = 232,
  sym_abstract_class_declaration = 233,
  sym_module = 234,
  sym_internal_module = 235,
  sym__module = 236,
  sym_import_alias = 237,
  sym_nested_type_identifier = 238,
  sym_interface_declaration = 239,
  sym_extends_clause = 240,
  sym_enum_declaration = 241,
  sym_enum_body = 242,
  sym_enum_assignment = 243,
  sym_type_alias_declaration = 244,
  sym_accessibility_modifier = 245,
  sym_required_parameter = 246,
  sym_optional_parameter = 247,
  sym__parameter_name = 248,
  sym_type_annotation = 249,
  sym__type = 250,
  sym_constructor_type = 251,
  sym__primary_type = 252,
  sym_generic_type = 253,
  sym_type_predicate = 254,
  sym_type_query = 255,
  sym_index_type_query = 256,
  sym_lookup_type = 257,
  sym_mapped_type_clause = 258,
  sym_literal_type = 259,
  sym__number = 260,
  sym_existential_type = 261,
  sym_flow_maybe_type = 262,
  sym_parenthesized_type = 263,
  sym_predefined_type = 264,
  sym_type_arguments = 265,
  sym_object_type = 266,
  sym_call_signature = 267,
  sym_property_signature = 268,
  sym_type_parameters = 269,
  sym_type_parameter = 270,
  sym_default_type = 271,
  sym_constraint = 272,
  sym_construct_signature = 273,
  sym_index_signature = 274,
  sym_array_type = 275,
  sym_tuple_type = 276,
  sym_union_type = 277,
  sym_intersection_type = 278,
  sym_function_type = 279,
  aux_sym_program_repeat1 = 280,
  aux_sym_export_statement_repeat1 = 281,
  aux_sym_export_clause_repeat1 = 282,
  aux_sym_named_imports_repeat1 = 283,
  aux_sym_variable_declaration_repeat1 = 284,
  aux_sym_switch_body_repeat1 = 285,
  aux_sym_object_repeat1 = 286,
  aux_sym_array_repeat1 = 287,
  aux_sym_string_repeat1 = 288,
  aux_sym_string_repeat2 = 289,
  aux_sym_template_string_repeat1 = 290,
  aux_sym_class_body_repeat1 = 291,
  aux_sym_formal_parameters_repeat1 = 292,
  aux_sym_implements_clause_repeat1 = 293,
  aux_sym_extends_clause_repeat1 = 294,
  aux_sym_enum_body_repeat1 = 295,
  aux_sym_object_type_repeat1 = 296,
  aux_sym_type_parameters_repeat1 = 297,
  alias_sym_array_pattern = 298,
  alias_sym_export_specifier = 299,
  alias_sym_import_specifier = 300,
  alias_sym_object_pattern = 301,
  alias_sym_property_identifier = 302,
  alias_sym_shorthand_property_identifier = 303,
  alias_sym_statement_identifier = 304,
  alias_sym_type_identifier = 305,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constructor = 8,
  field_declaration = 9,
  field_decorator = 10,
  field_finalizer = 11,
  field_flags = 12,
  field_function = 13,
  field_handler = 14,
  field_increment = 15,
  field_index = 16,
  field_initializer = 17,
  field_key = 18,
  field_label = 19,
  field_left = 20,
  field_module = 21,
  field_name = 22,
  field_object = 23,
  field_operator = 24,
  field_parameter = 25,
  field_parameters = 26,
  field_pattern = 27,
  field_property = 28,
  field_return_type = 29,
  field_right = 30,
  field_source = 31,
  field_type = 32,
  field_type_arguments = 33,
  field_type_parameters = 34,
  field_value = 35,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 3, .length = 1},
  [10] = {.index = 3, .length = 1},
  [13] = {.index = 8, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 9, .length = 1},
  [17] = {.index = 10, .length = 2},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 1},
  [25] = {.index = 23, .length = 2},
  [26] = {.index = 25, .length = 2},
  [27] = {.index = 27, .length = 2},
  [29] = {.index = 29, .length = 2},
  [30] = {.index = 31, .length = 2},
  [31] = {.index = 29, .length = 2},
  [32] = {.index = 31, .length = 2},
  [33] = {.index = 29, .length = 2},
  [34] = {.index = 31, .length = 2},
  [35] = {.index = 33, .length = 2},
  [36] = {.index = 35, .length = 2},
  [37] = {.index = 37, .length = 3},
  [40] = {.index = 40, .length = 1},
  [41] = {.index = 41, .length = 2},
  [42] = {.index = 43, .length = 2},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 49, .length = 1},
  [46] = {.index = 50, .length = 3},
  [48] = {.index = 53, .length = 1},
  [49] = {.index = 54, .length = 2},
  [50] = {.index = 56, .length = 1},
  [51] = {.index = 57, .length = 2},
  [52] = {.index = 59, .length = 4},
  [53] = {.index = 63, .length = 2},
  [54] = {.index = 63, .length = 2},
  [55] = {.index = 20, .length = 2},
  [56] = {.index = 23, .length = 2},
  [57] = {.index = 25, .length = 2},
  [58] = {.index = 65, .length = 3},
  [59] = {.index = 10, .length = 2},
  [60] = {.index = 54, .length = 2},
  [61] = {.index = 68, .length = 3},
  [62] = {.index = 20, .length = 2},
  [63] = {.index = 20, .length = 2},
  [64] = {.index = 71, .length = 4},
  [65] = {.index = 75, .length = 3},
  [66] = {.index = 78, .length = 2},
  [67] = {.index = 80, .length = 1},
  [68] = {.index = 81, .length = 1},
  [69] = {.index = 82, .length = 1},
  [70] = {.index = 83, .length = 1},
  [71] = {.index = 84, .length = 2},
  [72] = {.index = 20, .length = 2},
  [73] = {.index = 86, .length = 2},
  [74] = {.index = 88, .length = 5},
  [75] = {.index = 84, .length = 2},
  [76] = {.index = 93, .length = 1},
  [77] = {.index = 94, .length = 3},
  [78] = {.index = 94, .length = 3},
  [79] = {.index = 94, .length = 3},
  [80] = {.index = 97, .length = 2},
  [81] = {.index = 99, .length = 3},
  [85] = {.index = 102, .length = 1},
  [86] = {.index = 103, .length = 3},
  [87] = {.index = 106, .length = 4},
  [88] = {.index = 110, .length = 2},
  [89] = {.index = 112, .length = 2},
  [90] = {.index = 114, .length = 2},
  [91] = {.index = 116, .length = 3},
  [92] = {.index = 119, .length = 2},
  [93] = {.index = 121, .length = 2},
  [94] = {.index = 123, .length = 4},
  [95] = {.index = 121, .length = 2},
  [96] = {.index = 127, .length = 4},
  [97] = {.index = 131, .length = 4},
  [98] = {.index = 135, .length = 5},
  [99] = {.index = 140, .length = 2},
  [100] = {.index = 97, .length = 2},
  [101] = {.index = 142, .length = 3},
  [102] = {.index = 145, .length = 2},
  [103] = {.index = 147, .length = 3},
  [104] = {.index = 150, .length = 2},
  [105] = {.index = 152, .length = 5},
  [106] = {.index = 157, .length = 2},
  [107] = {.index = 159, .length = 1},
  [108] = {.index = 160, .length = 3},
  [109] = {.index = 163, .length = 1},
  [110] = {.index = 164, .length = 1},
  [111] = {.index = 165, .length = 1},
  [112] = {.index = 166, .length = 2},
  [113] = {.index = 168, .length = 1},
  [114] = {.index = 169, .length = 2},
  [115] = {.index = 171, .length = 4},
  [116] = {.index = 175, .length = 2},
  [117] = {.index = 177, .length = 2},
  [118] = {.index = 179, .length = 2},
  [119] = {.index = 181, .length = 3},
  [120] = {.index = 184, .length = 4},
  [121] = {.index = 188, .length = 4},
  [122] = {.index = 192, .length = 5},
  [123] = {.index = 197, .length = 2},
  [124] = {.index = 199, .length = 3},
  [125] = {.index = 202, .length = 3},
  [126] = {.index = 205, .length = 2},
  [127] = {.index = 207, .length = 3},
  [128] = {.index = 210, .length = 4},
  [129] = {.index = 214, .length = 3},
  [130] = {.index = 217, .length = 2},
  [131] = {.index = 219, .length = 5},
  [132] = {.index = 224, .length = 3},
  [133] = {.index = 227, .length = 2},
  [134] = {.index = 227, .length = 2},
  [135] = {.index = 229, .length = 3},
  [136] = {.index = 227, .length = 2},
  [137] = {.index = 227, .length = 2},
  [138] = {.index = 232, .length = 2},
  [139] = {.index = 234, .length = 4},
  [140] = {.index = 238, .length = 2},
  [141] = {.index = 240, .length = 2},
  [142] = {.index = 242, .length = 1},
  [143] = {.index = 243, .length = 2},
  [144] = {.index = 245, .length = 2},
  [145] = {.index = 247, .length = 3},
  [146] = {.index = 250, .length = 3},
  [147] = {.index = 253, .length = 5},
  [148] = {.index = 258, .length = 3},
  [150] = {.index = 261, .length = 4},
  [151] = {.index = 265, .length = 5},
  [152] = {.index = 270, .length = 2},
  [153] = {.index = 270, .length = 2},
  [154] = {.index = 270, .length = 2},
  [155] = {.index = 270, .length = 2},
  [156] = {.index = 272, .length = 4},
  [157] = {.index = 276, .length = 2},
  [158] = {.index = 276, .length = 2},
  [159] = {.index = 276, .length = 2},
  [160] = {.index = 278, .length = 4},
  [161] = {.index = 282, .length = 4},
  [162] = {.index = 286, .length = 2},
  [163] = {.index = 288, .length = 2},
  [164] = {.index = 290, .length = 2},
  [165] = {.index = 292, .length = 3},
  [166] = {.index = 295, .length = 3},
  [167] = {.index = 298, .length = 2},
  [168] = {.index = 300, .length = 5},
  [169] = {.index = 305, .length = 5},
  [170] = {.index = 310, .length = 4},
  [171] = {.index = 314, .length = 4},
  [172] = {.index = 318, .length = 2},
  [173] = {.index = 320, .length = 3},
  [174] = {.index = 323, .length = 2},
  [175] = {.index = 325, .length = 3},
  [176] = {.index = 328, .length = 5},
  [177] = {.index = 333, .length = 5},
  [178] = {.index = 338, .length = 4},
  [179] = {.index = 342, .length = 4},
  [180] = {.index = 346, .length = 3},
  [181] = {.index = 349, .length = 5},
  [182] = {.index = 354, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_parameters, 0},
  [2] =
    {field_declaration, 1},
  [3] =
    {field_name, 0},
  [4] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [6] =
    {field_argument, 1},
    {field_operator, 0},
  [8] =
    {field_body, 1},
  [9] =
    {field_constructor, 1},
  [10] =
    {field_arguments, 1},
    {field_function, 0},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_parameters, 0},
    {field_return_type, 1},
  [16] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [18] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [20] =
    {field_left, 0},
    {field_right, 2},
  [22] =
    {field_label, 0},
  [23] =
    {field_object, 0},
    {field_property, 2},
  [25] =
    {field_body, 2},
    {field_parameter, 0},
  [27] =
    {field_body, 1},
    {field_name, 0},
  [29] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [31] =
    {field_name, 0},
    {field_type, 1},
  [33] =
    {field_condition, 1},
    {field_consequence, 2},
  [35] =
    {field_body, 2},
    {field_value, 1},
  [37] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [40] =
    {field_value, 1, .inherited = true},
  [41] =
    {field_body, 2},
    {field_condition, 1},
  [43] =
    {field_body, 1},
    {field_handler, 2},
  [45] =
    {field_body, 1},
    {field_finalizer, 2},
  [47] =
    {field_body, 2},
    {field_object, 1},
  [49] =
    {field_label, 1},
  [50] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [53] =
    {field_pattern, 1},
  [54] =
    {field_body, 2},
    {field_name, 1},
  [56] =
    {field_body, 2},
  [57] =
    {field_body, 2},
    {field_type_parameters, 1},
  [59] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [63] =
    {field_arguments, 2},
    {field_constructor, 1},
  [65] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [68] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [71] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [75] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [78] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [80] =
    {field_source, 1},
  [81] =
    {field_source, 2, .inherited = true},
  [82] =
    {field_value, 2},
  [83] =
    {field_name, 1},
  [84] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [86] =
    {field_key, 0},
    {field_value, 2},
  [88] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [93] =
    {field_value, 1},
  [94] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [97] =
    {field_body, 3},
    {field_name, 2},
  [99] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [102] =
    {field_value, 2, .inherited = true},
  [103] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [106] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [110] =
    {field_module, 0},
    {field_name, 2},
  [112] =
    {field_flags, 3},
    {field_pattern, 1},
  [114] =
    {field_body, 3},
    {field_name, 1},
  [116] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [119] =
    {field_body, 3},
    {field_type_parameters, 1},
  [121] =
    {field_body, 3},
    {field_parameter, 1},
  [123] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [127] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [131] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [135] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [140] =
    {field_index, 2},
    {field_object, 0},
  [142] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [145] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [147] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [150] =
    {field_alias, 2},
    {field_name, 0},
  [152] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [157] =
    {field_name, 1},
    {field_value, 3},
  [159] =
    {field_source, 3, .inherited = true},
  [160] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [163] =
    {field_decorator, 1, .inherited = true},
  [164] =
    {field_decorator, 2, .inherited = true},
  [165] =
    {field_value, 3, .inherited = true},
  [166] =
    {field_body, 1},
    {field_condition, 3},
  [168] =
    {field_name, 2},
  [169] =
    {field_name, 1},
    {field_type, 2},
  [171] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [175] =
    {field_name, 0},
    {field_type, 2},
  [177] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [179] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [181] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [184] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [188] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [192] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [197] =
    {field_body, 4},
    {field_name, 2},
  [199] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [202] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [205] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [207] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [210] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [214] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [217] =
    {field_alias, 3},
    {field_name, 1},
  [219] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [224] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [227] =
    {field_left, 1},
    {field_right, 3},
  [229] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [232] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [234] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [238] =
    {field_name, 2},
    {field_type, 3},
  [240] =
    {field_name, 1},
    {field_type, 3},
  [242] =
    {field_name, 3},
  [243] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [245] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [247] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [250] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [253] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [258] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [261] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [265] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [270] =
    {field_left, 2},
    {field_right, 4},
  [272] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [276] =
    {field_body, 4},
    {field_parameter, 2},
  [278] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [282] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [286] =
    {field_name, 2},
    {field_type, 4},
  [288] =
    {field_name, 3},
    {field_type, 4},
  [290] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [292] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [295] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [298] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [300] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [305] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [310] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [314] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [318] =
    {field_name, 3},
    {field_type, 5},
  [320] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [323] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [325] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [328] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [333] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [338] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [342] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [346] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [349] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [354] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[183][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = alias_sym_object_pattern,
  },
  [10] = {
    [0] = alias_sym_array_pattern,
  },
  [11] = {
    [0] = alias_sym_object_pattern,
  },
  [12] = {
    [0] = alias_sym_array_pattern,
  },
  [14] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [1] = sym_identifier,
  },
  [18] = {
    [1] = sym_identifier,
  },
  [23] = {
    [0] = sym_identifier,
  },
  [24] = {
    [0] = alias_sym_statement_identifier,
  },
  [25] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [26] = {
    [0] = sym_identifier,
  },
  [28] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [31] = {
    [0] = alias_sym_object_pattern,
  },
  [32] = {
    [0] = alias_sym_object_pattern,
  },
  [33] = {
    [0] = alias_sym_array_pattern,
  },
  [34] = {
    [0] = alias_sym_array_pattern,
  },
  [38] = {
    [1] = alias_sym_object_pattern,
  },
  [39] = {
    [1] = alias_sym_array_pattern,
  },
  [45] = {
    [1] = alias_sym_statement_identifier,
  },
  [47] = {
    [1] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [53] = {
    [1] = sym_identifier,
  },
  [56] = {
    [2] = alias_sym_property_identifier,
  },
  [59] = {
    [0] = sym_identifier,
  },
  [62] = {
    [0] = alias_sym_object_pattern,
  },
  [63] = {
    [0] = alias_sym_array_pattern,
  },
  [71] = {
    [1] = alias_sym_export_specifier,
  },
  [72] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [75] = {
    [1] = alias_sym_import_specifier,
  },
  [78] = {
    [0] = alias_sym_object_pattern,
  },
  [79] = {
    [0] = alias_sym_array_pattern,
  },
  [82] = {
    [2] = sym_identifier,
  },
  [83] = {
    [2] = alias_sym_object_pattern,
  },
  [84] = {
    [2] = alias_sym_array_pattern,
  },
  [88] = {
    [2] = alias_sym_type_identifier,
  },
  [90] = {
    [1] = alias_sym_type_identifier,
  },
  [91] = {
    [1] = alias_sym_type_identifier,
  },
  [93] = {
    [1] = sym_identifier,
  },
  [100] = {
    [2] = alias_sym_type_identifier,
  },
  [101] = {
    [2] = alias_sym_type_identifier,
  },
  [106] = {
    [1] = alias_sym_type_identifier,
  },
  [119] = {
    [1] = alias_sym_type_identifier,
  },
  [123] = {
    [2] = alias_sym_type_identifier,
  },
  [124] = {
    [2] = alias_sym_type_identifier,
  },
  [127] = {
    [2] = alias_sym_type_identifier,
  },
  [128] = {
    [2] = alias_sym_type_identifier,
  },
  [132] = {
    [1] = alias_sym_type_identifier,
  },
  [133] = {
    [1] = sym_identifier,
  },
  [136] = {
    [1] = alias_sym_object_pattern,
  },
  [137] = {
    [1] = alias_sym_array_pattern,
  },
  [148] = {
    [2] = alias_sym_type_identifier,
  },
  [149] = {
    [3] = alias_sym_property_identifier,
  },
  [150] = {
    [2] = alias_sym_type_identifier,
  },
  [152] = {
    [2] = sym_identifier,
  },
  [154] = {
    [2] = alias_sym_object_pattern,
  },
  [155] = {
    [2] = alias_sym_array_pattern,
  },
  [158] = {
    [2] = alias_sym_object_pattern,
  },
  [159] = {
    [2] = alias_sym_array_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0) ADVANCE(64);
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '$') ADVANCE(185);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(32);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0) ADVANCE(186);
      END_STATE();
    case 1:
      if (lookahead == 0) ADVANCE(64);
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '$') ADVANCE(185);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0) ADVANCE(186);
      END_STATE();
    case 2:
      if (lookahead == 0) ADVANCE(64);
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(186);
      END_STATE();
    case 3:
      if (lookahead == 0) ADVANCE(64);
      if (lookahead == '!') ADVANCE(142);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(186);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(23)
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '/') ADVANCE(156);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(159);
      if (lookahead != 0) ADVANCE(160);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(155);
      if (lookahead == '\r') ADVANCE(162);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(20)
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '\\') ADVANCE(7);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(152);
      if (lookahead != 0) ADVANCE(153);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(148);
      if (lookahead == '\r') ADVANCE(163);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(29)
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(172);
      if (lookahead != 0) ADVANCE(173);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(122);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(186);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(133);
      if (lookahead == '&') ADVANCE(117);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(128);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == '<') ADVANCE(82);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(85);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(119);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(121);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(186);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(186);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == ':') ADVANCE(78);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(71);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(143);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(116);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(83);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(86);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '^') ADVANCE(118);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != ']' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(65);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(142);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(127);
      if (lookahead == ',') ADVANCE(73);
      if (lookahead == '-') ADVANCE(130);
      if (lookahead == '.') ADVANCE(90);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '~') ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(186);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '(') ADVANCE(75);
      if (lookahead == ')') ADVANCE(76);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '0') ADVANCE(176);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(106);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(79);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == ']') ADVANCE(80);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '|') ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      END_STATE();
    case 21:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      END_STATE();
    case 22:
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '`') ADVANCE(169);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(105);
      END_STATE();
    case 29:
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(29)
      END_STATE();
    case 30:
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 31:
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == ']') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 33:
      if (lookahead == 'u') ADVANCE(37);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(166);
      if (lookahead != 0) ADVANCE(161);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(170);
      END_STATE();
    case 36:
      if (lookahead == '{') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 37:
      if (lookahead == '{') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(61);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(56);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 39:
      if (lookahead == '}') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 43:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(178);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(179);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(177);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(181);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(186);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(161);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(164);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 58:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 59:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 60:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      END_STATE();
    case 61:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(59);
      END_STATE();
    case 62:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(31);
      END_STATE();
    case 63:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(135);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(134);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(137);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(188);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(114);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(113);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(109);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(110);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(112);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(111);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(107);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(107);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '|') ADVANCE(108);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '|') ADVANCE(108);
      if (lookahead == '}') ADVANCE(189);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(108);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(108);
      if (lookahead == '}') ADVANCE(189);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(189);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(145);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(145);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(146);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(146);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(151);
      if (lookahead == '/') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '/') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(158);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(157);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(155);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(148);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(161);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(165);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(26);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(24);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(173);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(33);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == '0') ADVANCE(181);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(43);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(44);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(51);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(175);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(175);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(47);
      if (lookahead == 'n') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(181);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (lookahead == '_') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead == '{') ADVANCE(170);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(82);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(88);
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'q') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'y') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w') ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y') ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's') ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 3},
  [2] = {.lex_state = 3},
  [3] = {.lex_state = 3},
  [4] = {.lex_state = 3},
  [5] = {.lex_state = 3},
  [6] = {.lex_state = 3},
  [7] = {.lex_state = 3},
  [8] = {.lex_state = 3},
  [9] = {.lex_state = 3},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 3},
  [12] = {.lex_state = 3},
  [13] = {.lex_state = 3},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 3},
  [16] = {.lex_state = 3},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 3},
  [19] = {.lex_state = 3},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 3},
  [22] = {.lex_state = 3},
  [23] = {.lex_state = 3},
  [24] = {.lex_state = 3},
  [25] = {.lex_state = 3},
  [26] = {.lex_state = 3},
  [27] = {.lex_state = 3},
  [28] = {.lex_state = 3},
  [29] = {.lex_state = 3},
  [30] = {.lex_state = 3},
  [31] = {.lex_state = 3},
  [32] = {.lex_state = 3},
  [33] = {.lex_state = 3},
  [34] = {.lex_state = 3},
  [35] = {.lex_state = 3},
  [36] = {.lex_state = 3},
  [37] = {.lex_state = 3},
  [38] = {.lex_state = 3},
  [39] = {.lex_state = 3},
  [40] = {.lex_state = 3},
  [41] = {.lex_state = 3},
  [42] = {.lex_state = 3},
  [43] = {.lex_state = 3},
  [44] = {.lex_state = 3},
  [45] = {.lex_state = 3},
  [46] = {.lex_state = 3},
  [47] = {.lex_state = 3},
  [48] = {.lex_state = 9, .external_lex_state = 2},
  [49] = {.lex_state = 9, .external_lex_state = 3},
  [50] = {.lex_state = 9, .external_lex_state = 2},
  [51] = {.lex_state = 9, .external_lex_state = 2},
  [52] = {.lex_state = 9, .external_lex_state = 3},
  [53] = {.lex_state = 9, .external_lex_state = 3},
  [54] = {.lex_state = 9, .external_lex_state = 2},
  [55] = {.lex_state = 9, .external_lex_state = 2},
  [56] = {.lex_state = 9, .external_lex_state = 2},
  [57] = {.lex_state = 9, .external_lex_state = 2},
  [58] = {.lex_state = 9, .external_lex_state = 2},
  [59] = {.lex_state = 9, .external_lex_state = 2},
  [60] = {.lex_state = 9, .external_lex_state = 2},
  [61] = {.lex_state = 9, .external_lex_state = 3},
  [62] = {.lex_state = 9, .external_lex_state = 3},
  [63] = {.lex_state = 9, .external_lex_state = 2},
  [64] = {.lex_state = 9, .external_lex_state = 3},
  [65] = {.lex_state = 9, .external_lex_state = 3},
  [66] = {.lex_state = 10, .external_lex_state = 3},
  [67] = {.lex_state = 9, .external_lex_state = 3},
  [68] = {.lex_state = 9, .external_lex_state = 3},
  [69] = {.lex_state = 9, .external_lex_state = 3},
  [70] = {.lex_state = 9, .external_lex_state = 2},
  [71] = {.lex_state = 10, .external_lex_state = 3},
  [72] = {.lex_state = 9, .external_lex_state = 3},
  [73] = {.lex_state = 9, .external_lex_state = 3},
  [74] = {.lex_state = 9, .external_lex_state = 2},
  [75] = {.lex_state = 9, .external_lex_state = 3},
  [76] = {.lex_state = 10, .external_lex_state = 3},
  [77] = {.lex_state = 9, .external_lex_state = 3},
  [78] = {.lex_state = 9, .external_lex_state = 3},
  [79] = {.lex_state = 9, .external_lex_state = 3},
  [80] = {.lex_state = 9, .external_lex_state = 3},
  [81] = {.lex_state = 17},
  [82] = {.lex_state = 17},
  [83] = {.lex_state = 17},
  [84] = {.lex_state = 17},
  [85] = {.lex_state = 17},
  [86] = {.lex_state = 17},
  [87] = {.lex_state = 17},
  [88] = {.lex_state = 17},
  [89] = {.lex_state = 17},
  [90] = {.lex_state = 17},
  [91] = {.lex_state = 17},
  [92] = {.lex_state = 17},
  [93] = {.lex_state = 17},
  [94] = {.lex_state = 17},
  [95] = {.lex_state = 2, .external_lex_state = 3},
  [96] = {.lex_state = 17},
  [97] = {.lex_state = 17},
  [98] = {.lex_state = 2, .external_lex_state = 2},
  [99] = {.lex_state = 2, .external_lex_state = 3},
  [100] = {.lex_state = 11, .external_lex_state = 3},
  [101] = {.lex_state = 2, .external_lex_state = 2},
  [102] = {.lex_state = 2, .external_lex_state = 3},
  [103] = {.lex_state = 2, .external_lex_state = 2},
  [104] = {.lex_state = 2, .external_lex_state = 2},
  [105] = {.lex_state = 2, .external_lex_state = 2},
  [106] = {.lex_state = 2, .external_lex_state = 2},
  [107] = {.lex_state = 2, .external_lex_state = 2},
  [108] = {.lex_state = 2, .external_lex_state = 2},
  [109] = {.lex_state = 2, .external_lex_state = 2},
  [110] = {.lex_state = 2, .external_lex_state = 2},
  [111] = {.lex_state = 2, .external_lex_state = 2},
  [112] = {.lex_state = 2, .external_lex_state = 2},
  [113] = {.lex_state = 2, .external_lex_state = 2},
  [114] = {.lex_state = 2, .external_lex_state = 2},
  [115] = {.lex_state = 2, .external_lex_state = 2},
  [116] = {.lex_state = 2, .external_lex_state = 2},
  [117] = {.lex_state = 2, .external_lex_state = 2},
  [118] = {.lex_state = 2, .external_lex_state = 2},
  [119] = {.lex_state = 2, .external_lex_state = 2},
  [120] = {.lex_state = 2, .external_lex_state = 2},
  [121] = {.lex_state = 2, .external_lex_state = 2},
  [122] = {.lex_state = 2, .external_lex_state = 2},
  [123] = {.lex_state = 2, .external_lex_state = 2},
  [124] = {.lex_state = 2, .external_lex_state = 2},
  [125] = {.lex_state = 2, .external_lex_state = 2},
  [126] = {.lex_state = 2, .external_lex_state = 2},
  [127] = {.lex_state = 2, .external_lex_state = 2},
  [128] = {.lex_state = 2, .external_lex_state = 2},
  [129] = {.lex_state = 2, .external_lex_state = 2},
  [130] = {.lex_state = 3},
  [131] = {.lex_state = 3},
  [132] = {.lex_state = 3},
  [133] = {.lex_state = 3},
  [134] = {.lex_state = 3},
  [135] = {.lex_state = 3},
  [136] = {.lex_state = 3},
  [137] = {.lex_state = 3},
  [138] = {.lex_state = 3},
  [139] = {.lex_state = 3},
  [140] = {.lex_state = 3},
  [141] = {.lex_state = 3},
  [142] = {.lex_state = 3},
  [143] = {.lex_state = 3},
  [144] = {.lex_state = 3},
  [145] = {.lex_state = 3},
  [146] = {.lex_state = 3},
  [147] = {.lex_state = 3},
  [148] = {.lex_state = 3},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 3},
  [151] = {.lex_state = 3},
  [152] = {.lex_state = 9, .external_lex_state = 2},
  [153] = {.lex_state = 3},
  [154] = {.lex_state = 3, .external_lex_state = 4},
  [155] = {.lex_state = 3},
  [156] = {.lex_state = 3},
  [157] = {.lex_state = 3},
  [158] = {.lex_state = 9, .external_lex_state = 2},
  [159] = {.lex_state = 9, .external_lex_state = 2},
  [160] = {.lex_state = 3},
  [161] = {.lex_state = 3},
  [162] = {.lex_state = 3},
  [163] = {.lex_state = 3},
  [164] = {.lex_state = 3},
  [165] = {.lex_state = 3},
  [166] = {.lex_state = 3},
  [167] = {.lex_state = 3},
  [168] = {.lex_state = 3},
  [169] = {.lex_state = 3},
  [170] = {.lex_state = 3},
  [171] = {.lex_state = 3},
  [172] = {.lex_state = 3},
  [173] = {.lex_state = 3},
  [174] = {.lex_state = 3},
  [175] = {.lex_state = 3},
  [176] = {.lex_state = 3},
  [177] = {.lex_state = 3},
  [178] = {.lex_state = 3},
  [179] = {.lex_state = 3},
  [180] = {.lex_state = 9, .external_lex_state = 2},
  [181] = {.lex_state = 3},
  [182] = {.lex_state = 3},
  [183] = {.lex_state = 3},
  [184] = {.lex_state = 3},
  [185] = {.lex_state = 3},
  [186] = {.lex_state = 3},
  [187] = {.lex_state = 3},
  [188] = {.lex_state = 3},
  [189] = {.lex_state = 3},
  [190] = {.lex_state = 3},
  [191] = {.lex_state = 3},
  [192] = {.lex_state = 3},
  [193] = {.lex_state = 3},
  [194] = {.lex_state = 3},
  [195] = {.lex_state = 3},
  [196] = {.lex_state = 9, .external_lex_state = 2},
  [197] = {.lex_state = 3},
  [198] = {.lex_state = 3},
  [199] = {.lex_state = 3},
  [200] = {.lex_state = 3},
  [201] = {.lex_state = 3},
  [202] = {.lex_state = 3},
  [203] = {.lex_state = 3},
  [204] = {.lex_state = 3},
  [205] = {.lex_state = 3},
  [206] = {.lex_state = 3},
  [207] = {.lex_state = 3},
  [208] = {.lex_state = 3},
  [209] = {.lex_state = 3},
  [210] = {.lex_state = 3},
  [211] = {.lex_state = 3},
  [212] = {.lex_state = 9, .external_lex_state = 2},
  [213] = {.lex_state = 3},
  [214] = {.lex_state = 3},
  [215] = {.lex_state = 3},
  [216] = {.lex_state = 9, .external_lex_state = 2},
  [217] = {.lex_state = 3},
  [218] = {.lex_state = 3},
  [219] = {.lex_state = 3},
  [220] = {.lex_state = 3},
  [221] = {.lex_state = 9, .external_lex_state = 2},
  [222] = {.lex_state = 3},
  [223] = {.lex_state = 3},
  [224] = {.lex_state = 3},
  [225] = {.lex_state = 3},
  [226] = {.lex_state = 3},
  [227] = {.lex_state = 3},
  [228] = {.lex_state = 3},
  [229] = {.lex_state = 3},
  [230] = {.lex_state = 3},
  [231] = {.lex_state = 3},
  [232] = {.lex_state = 3},
  [233] = {.lex_state = 3},
  [234] = {.lex_state = 3},
  [235] = {.lex_state = 3},
  [236] = {.lex_state = 3},
  [237] = {.lex_state = 3},
  [238] = {.lex_state = 3},
  [239] = {.lex_state = 3},
  [240] = {.lex_state = 3},
  [241] = {.lex_state = 3},
  [242] = {.lex_state = 3},
  [243] = {.lex_state = 3},
  [244] = {.lex_state = 3},
  [245] = {.lex_state = 3},
  [246] = {.lex_state = 3},
  [247] = {.lex_state = 3},
  [248] = {.lex_state = 3},
  [249] = {.lex_state = 3},
  [250] = {.lex_state = 3},
  [251] = {.lex_state = 3},
  [252] = {.lex_state = 3},
  [253] = {.lex_state = 3},
  [254] = {.lex_state = 3},
  [255] = {.lex_state = 3},
  [256] = {.lex_state = 3},
  [257] = {.lex_state = 3},
  [258] = {.lex_state = 3},
  [259] = {.lex_state = 3},
  [260] = {.lex_state = 3},
  [261] = {.lex_state = 3},
  [262] = {.lex_state = 3},
  [263] = {.lex_state = 3},
  [264] = {.lex_state = 3},
  [265] = {.lex_state = 3},
  [266] = {.lex_state = 3},
  [267] = {.lex_state = 3},
  [268] = {.lex_state = 3},
  [269] = {.lex_state = 3},
  [270] = {.lex_state = 3},
  [271] = {.lex_state = 3},
  [272] = {.lex_state = 3},
  [273] = {.lex_state = 3},
  [274] = {.lex_state = 3},
  [275] = {.lex_state = 3},
  [276] = {.lex_state = 3},
  [277] = {.lex_state = 3},
  [278] = {.lex_state = 3},
  [279] = {.lex_state = 3},
  [280] = {.lex_state = 3},
  [281] = {.lex_state = 3},
  [282] = {.lex_state = 3},
  [283] = {.lex_state = 3},
  [284] = {.lex_state = 3},
  [285] = {.lex_state = 3},
  [286] = {.lex_state = 3},
  [287] = {.lex_state = 3},
  [288] = {.lex_state = 3},
  [289] = {.lex_state = 3},
  [290] = {.lex_state = 3},
  [291] = {.lex_state = 3},
  [292] = {.lex_state = 3},
  [293] = {.lex_state = 3},
  [294] = {.lex_state = 3},
  [295] = {.lex_state = 3},
  [296] = {.lex_state = 3},
  [297] = {.lex_state = 3},
  [298] = {.lex_state = 3},
  [299] = {.lex_state = 3},
  [300] = {.lex_state = 3},
  [301] = {.lex_state = 3},
  [302] = {.lex_state = 3},
  [303] = {.lex_state = 3},
  [304] = {.lex_state = 3},
  [305] = {.lex_state = 3},
  [306] = {.lex_state = 3},
  [307] = {.lex_state = 3},
  [308] = {.lex_state = 3},
  [309] = {.lex_state = 3},
  [310] = {.lex_state = 3},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 3},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 3},
  [316] = {.lex_state = 3},
  [317] = {.lex_state = 3},
  [318] = {.lex_state = 3},
  [319] = {.lex_state = 3},
  [320] = {.lex_state = 3},
  [321] = {.lex_state = 3},
  [322] = {.lex_state = 3},
  [323] = {.lex_state = 3},
  [324] = {.lex_state = 3},
  [325] = {.lex_state = 3},
  [326] = {.lex_state = 3},
  [327] = {.lex_state = 3},
  [328] = {.lex_state = 3},
  [329] = {.lex_state = 3},
  [330] = {.lex_state = 3},
  [331] = {.lex_state = 3},
  [332] = {.lex_state = 3},
  [333] = {.lex_state = 3},
  [334] = {.lex_state = 3},
  [335] = {.lex_state = 3},
  [336] = {.lex_state = 3},
  [337] = {.lex_state = 3},
  [338] = {.lex_state = 3},
  [339] = {.lex_state = 3},
  [340] = {.lex_state = 3},
  [341] = {.lex_state = 3},
  [342] = {.lex_state = 3},
  [343] = {.lex_state = 3},
  [344] = {.lex_state = 3},
  [345] = {.lex_state = 3},
  [346] = {.lex_state = 3},
  [347] = {.lex_state = 3},
  [348] = {.lex_state = 3},
  [349] = {.lex_state = 3},
  [350] = {.lex_state = 3},
  [351] = {.lex_state = 3},
  [352] = {.lex_state = 3},
  [353] = {.lex_state = 3},
  [354] = {.lex_state = 3},
  [355] = {.lex_state = 3},
  [356] = {.lex_state = 3},
  [357] = {.lex_state = 3},
  [358] = {.lex_state = 3},
  [359] = {.lex_state = 3},
  [360] = {.lex_state = 3},
  [361] = {.lex_state = 3},
  [362] = {.lex_state = 3},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 3},
  [366] = {.lex_state = 3},
  [367] = {.lex_state = 3},
  [368] = {.lex_state = 3},
  [369] = {.lex_state = 3},
  [370] = {.lex_state = 3},
  [371] = {.lex_state = 3},
  [372] = {.lex_state = 3},
  [373] = {.lex_state = 3},
  [374] = {.lex_state = 3},
  [375] = {.lex_state = 3},
  [376] = {.lex_state = 3},
  [377] = {.lex_state = 3},
  [378] = {.lex_state = 3},
  [379] = {.lex_state = 3},
  [380] = {.lex_state = 3},
  [381] = {.lex_state = 3},
  [382] = {.lex_state = 3},
  [383] = {.lex_state = 3},
  [384] = {.lex_state = 3},
  [385] = {.lex_state = 3},
  [386] = {.lex_state = 3},
  [387] = {.lex_state = 3},
  [388] = {.lex_state = 3},
  [389] = {.lex_state = 3},
  [390] = {.lex_state = 3},
  [391] = {.lex_state = 3},
  [392] = {.lex_state = 3},
  [393] = {.lex_state = 3},
  [394] = {.lex_state = 3},
  [395] = {.lex_state = 3},
  [396] = {.lex_state = 3},
  [397] = {.lex_state = 3},
  [398] = {.lex_state = 3},
  [399] = {.lex_state = 3},
  [400] = {.lex_state = 3},
  [401] = {.lex_state = 3},
  [402] = {.lex_state = 3},
  [403] = {.lex_state = 3},
  [404] = {.lex_state = 3},
  [405] = {.lex_state = 3},
  [406] = {.lex_state = 3},
  [407] = {.lex_state = 9, .external_lex_state = 2},
  [408] = {.lex_state = 9, .external_lex_state = 2},
  [409] = {.lex_state = 3},
  [410] = {.lex_state = 3},
  [411] = {.lex_state = 3},
  [412] = {.lex_state = 3},
  [413] = {.lex_state = 9, .external_lex_state = 2},
  [414] = {.lex_state = 3},
  [415] = {.lex_state = 3},
  [416] = {.lex_state = 3},
  [417] = {.lex_state = 3},
  [418] = {.lex_state = 3},
  [419] = {.lex_state = 9, .external_lex_state = 2},
  [420] = {.lex_state = 3},
  [421] = {.lex_state = 9, .external_lex_state = 2},
  [422] = {.lex_state = 3},
  [423] = {.lex_state = 3},
  [424] = {.lex_state = 3},
  [425] = {.lex_state = 3},
  [426] = {.lex_state = 3},
  [427] = {.lex_state = 3},
  [428] = {.lex_state = 3},
  [429] = {.lex_state = 3},
  [430] = {.lex_state = 3},
  [431] = {.lex_state = 3},
  [432] = {.lex_state = 3},
  [433] = {.lex_state = 3},
  [434] = {.lex_state = 3},
  [435] = {.lex_state = 3},
  [436] = {.lex_state = 3},
  [437] = {.lex_state = 3},
  [438] = {.lex_state = 3},
  [439] = {.lex_state = 3},
  [440] = {.lex_state = 3},
  [441] = {.lex_state = 3},
  [442] = {.lex_state = 3},
  [443] = {.lex_state = 3},
  [444] = {.lex_state = 9, .external_lex_state = 2},
  [445] = {.lex_state = 9, .external_lex_state = 2},
  [446] = {.lex_state = 9, .external_lex_state = 2},
  [447] = {.lex_state = 9, .external_lex_state = 2},
  [448] = {.lex_state = 9, .external_lex_state = 2},
  [449] = {.lex_state = 9, .external_lex_state = 2},
  [450] = {.lex_state = 9, .external_lex_state = 2},
  [451] = {.lex_state = 9, .external_lex_state = 2},
  [452] = {.lex_state = 9, .external_lex_state = 2},
  [453] = {.lex_state = 3, .external_lex_state = 4},
  [454] = {.lex_state = 3, .external_lex_state = 4},
  [455] = {.lex_state = 3},
  [456] = {.lex_state = 18},
  [457] = {.lex_state = 18},
  [458] = {.lex_state = 9, .external_lex_state = 3},
  [459] = {.lex_state = 3},
  [460] = {.lex_state = 3, .external_lex_state = 4},
  [461] = {.lex_state = 18},
  [462] = {.lex_state = 3, .external_lex_state = 4},
  [463] = {.lex_state = 3, .external_lex_state = 4},
  [464] = {.lex_state = 3, .external_lex_state = 4},
  [465] = {.lex_state = 18},
  [466] = {.lex_state = 3},
  [467] = {.lex_state = 3},
  [468] = {.lex_state = 3, .external_lex_state = 4},
  [469] = {.lex_state = 18},
  [470] = {.lex_state = 3, .external_lex_state = 4},
  [471] = {.lex_state = 3},
  [472] = {.lex_state = 9, .external_lex_state = 2},
  [473] = {.lex_state = 9, .external_lex_state = 2},
  [474] = {.lex_state = 3},
  [475] = {.lex_state = 9, .external_lex_state = 2},
  [476] = {.lex_state = 9, .external_lex_state = 3},
  [477] = {.lex_state = 3},
  [478] = {.lex_state = 3},
  [479] = {.lex_state = 3},
  [480] = {.lex_state = 3},
  [481] = {.lex_state = 3},
  [482] = {.lex_state = 3},
  [483] = {.lex_state = 9, .external_lex_state = 2},
  [484] = {.lex_state = 9, .external_lex_state = 3},
  [485] = {.lex_state = 3, .external_lex_state = 4},
  [486] = {.lex_state = 3, .external_lex_state = 4},
  [487] = {.lex_state = 9, .external_lex_state = 2},
  [488] = {.lex_state = 3},
  [489] = {.lex_state = 9, .external_lex_state = 2},
  [490] = {.lex_state = 3},
  [491] = {.lex_state = 3, .external_lex_state = 4},
  [492] = {.lex_state = 3},
  [493] = {.lex_state = 3},
  [494] = {.lex_state = 3, .external_lex_state = 4},
  [495] = {.lex_state = 3, .external_lex_state = 4},
  [496] = {.lex_state = 3, .external_lex_state = 4},
  [497] = {.lex_state = 9, .external_lex_state = 2},
  [498] = {.lex_state = 3, .external_lex_state = 4},
  [499] = {.lex_state = 3, .external_lex_state = 4},
  [500] = {.lex_state = 3},
  [501] = {.lex_state = 9, .external_lex_state = 2},
  [502] = {.lex_state = 3, .external_lex_state = 4},
  [503] = {.lex_state = 3, .external_lex_state = 4},
  [504] = {.lex_state = 3, .external_lex_state = 4},
  [505] = {.lex_state = 10, .external_lex_state = 3},
  [506] = {.lex_state = 3},
  [507] = {.lex_state = 3},
  [508] = {.lex_state = 3, .external_lex_state = 4},
  [509] = {.lex_state = 3},
  [510] = {.lex_state = 3},
  [511] = {.lex_state = 3},
  [512] = {.lex_state = 3},
  [513] = {.lex_state = 3},
  [514] = {.lex_state = 3},
  [515] = {.lex_state = 3},
  [516] = {.lex_state = 3},
  [517] = {.lex_state = 3},
  [518] = {.lex_state = 3},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 3},
  [521] = {.lex_state = 3},
  [522] = {.lex_state = 3},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 3},
  [525] = {.lex_state = 3},
  [526] = {.lex_state = 3},
  [527] = {.lex_state = 9, .external_lex_state = 3},
  [528] = {.lex_state = 3},
  [529] = {.lex_state = 9, .external_lex_state = 3},
  [530] = {.lex_state = 3},
  [531] = {.lex_state = 3},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 3},
  [534] = {.lex_state = 3},
  [535] = {.lex_state = 3},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 3},
  [538] = {.lex_state = 3},
  [539] = {.lex_state = 3},
  [540] = {.lex_state = 3},
  [541] = {.lex_state = 3},
  [542] = {.lex_state = 3},
  [543] = {.lex_state = 3},
  [544] = {.lex_state = 9, .external_lex_state = 3},
  [545] = {.lex_state = 3},
  [546] = {.lex_state = 3},
  [547] = {.lex_state = 3},
  [548] = {.lex_state = 3},
  [549] = {.lex_state = 9, .external_lex_state = 3},
  [550] = {.lex_state = 3},
  [551] = {.lex_state = 3},
  [552] = {.lex_state = 3},
  [553] = {.lex_state = 3},
  [554] = {.lex_state = 9, .external_lex_state = 3},
  [555] = {.lex_state = 3},
  [556] = {.lex_state = 3},
  [557] = {.lex_state = 9, .external_lex_state = 3},
  [558] = {.lex_state = 3},
  [559] = {.lex_state = 3},
  [560] = {.lex_state = 3},
  [561] = {.lex_state = 9, .external_lex_state = 3},
  [562] = {.lex_state = 9, .external_lex_state = 2},
  [563] = {.lex_state = 3},
  [564] = {.lex_state = 3},
  [565] = {.lex_state = 3},
  [566] = {.lex_state = 3},
  [567] = {.lex_state = 3},
  [568] = {.lex_state = 3},
  [569] = {.lex_state = 3},
  [570] = {.lex_state = 3},
  [571] = {.lex_state = 3},
  [572] = {.lex_state = 3},
  [573] = {.lex_state = 3},
  [574] = {.lex_state = 10, .external_lex_state = 3},
  [575] = {.lex_state = 3},
  [576] = {.lex_state = 3},
  [577] = {.lex_state = 3},
  [578] = {.lex_state = 3},
  [579] = {.lex_state = 3},
  [580] = {.lex_state = 3},
  [581] = {.lex_state = 3},
  [582] = {.lex_state = 3},
  [583] = {.lex_state = 3},
  [584] = {.lex_state = 3},
  [585] = {.lex_state = 3},
  [586] = {.lex_state = 3},
  [587] = {.lex_state = 3},
  [588] = {.lex_state = 3},
  [589] = {.lex_state = 3},
  [590] = {.lex_state = 3},
  [591] = {.lex_state = 3},
  [592] = {.lex_state = 3},
  [593] = {.lex_state = 3},
  [594] = {.lex_state = 9, .external_lex_state = 2},
  [595] = {.lex_state = 9, .external_lex_state = 3},
  [596] = {.lex_state = 9, .external_lex_state = 3},
  [597] = {.lex_state = 9, .external_lex_state = 3},
  [598] = {.lex_state = 9, .external_lex_state = 3},
  [599] = {.lex_state = 9, .external_lex_state = 3},
  [600] = {.lex_state = 9, .external_lex_state = 3},
  [601] = {.lex_state = 3},
  [602] = {.lex_state = 3},
  [603] = {.lex_state = 3},
  [604] = {.lex_state = 3},
  [605] = {.lex_state = 3},
  [606] = {.lex_state = 3},
  [607] = {.lex_state = 3},
  [608] = {.lex_state = 3},
  [609] = {.lex_state = 3},
  [610] = {.lex_state = 3},
  [611] = {.lex_state = 9, .external_lex_state = 2},
  [612] = {.lex_state = 9, .external_lex_state = 2},
  [613] = {.lex_state = 9, .external_lex_state = 2},
  [614] = {.lex_state = 9, .external_lex_state = 2},
  [615] = {.lex_state = 9, .external_lex_state = 2},
  [616] = {.lex_state = 9, .external_lex_state = 3},
  [617] = {.lex_state = 9, .external_lex_state = 2},
  [618] = {.lex_state = 9, .external_lex_state = 2},
  [619] = {.lex_state = 9, .external_lex_state = 3},
  [620] = {.lex_state = 9, .external_lex_state = 2},
  [621] = {.lex_state = 9, .external_lex_state = 3},
  [622] = {.lex_state = 9, .external_lex_state = 2},
  [623] = {.lex_state = 9, .external_lex_state = 2},
  [624] = {.lex_state = 3},
  [625] = {.lex_state = 3},
  [626] = {.lex_state = 9, .external_lex_state = 2},
  [627] = {.lex_state = 3},
  [628] = {.lex_state = 9, .external_lex_state = 2},
  [629] = {.lex_state = 3},
  [630] = {.lex_state = 3},
  [631] = {.lex_state = 10, .external_lex_state = 3},
  [632] = {.lex_state = 3},
  [633] = {.lex_state = 3},
  [634] = {.lex_state = 9, .external_lex_state = 2},
  [635] = {.lex_state = 9, .external_lex_state = 3},
  [636] = {.lex_state = 9, .external_lex_state = 3},
  [637] = {.lex_state = 9, .external_lex_state = 3},
  [638] = {.lex_state = 9, .external_lex_state = 3},
  [639] = {.lex_state = 9, .external_lex_state = 2},
  [640] = {.lex_state = 9, .external_lex_state = 3},
  [641] = {.lex_state = 10, .external_lex_state = 3},
  [642] = {.lex_state = 9, .external_lex_state = 3},
  [643] = {.lex_state = 9, .external_lex_state = 2},
  [644] = {.lex_state = 9, .external_lex_state = 3},
  [645] = {.lex_state = 18},
  [646] = {.lex_state = 3},
  [647] = {.lex_state = 9, .external_lex_state = 2},
  [648] = {.lex_state = 9, .external_lex_state = 3},
  [649] = {.lex_state = 9, .external_lex_state = 3},
  [650] = {.lex_state = 9, .external_lex_state = 2},
  [651] = {.lex_state = 9, .external_lex_state = 2},
  [652] = {.lex_state = 9, .external_lex_state = 3},
  [653] = {.lex_state = 9, .external_lex_state = 2},
  [654] = {.lex_state = 9, .external_lex_state = 3},
  [655] = {.lex_state = 9, .external_lex_state = 3},
  [656] = {.lex_state = 3},
  [657] = {.lex_state = 18},
  [658] = {.lex_state = 9, .external_lex_state = 3},
  [659] = {.lex_state = 9, .external_lex_state = 3},
  [660] = {.lex_state = 9, .external_lex_state = 2},
  [661] = {.lex_state = 18},
  [662] = {.lex_state = 9, .external_lex_state = 3},
  [663] = {.lex_state = 9, .external_lex_state = 3},
  [664] = {.lex_state = 9, .external_lex_state = 2},
  [665] = {.lex_state = 18},
  [666] = {.lex_state = 9, .external_lex_state = 2},
  [667] = {.lex_state = 18},
  [668] = {.lex_state = 18},
  [669] = {.lex_state = 18},
  [670] = {.lex_state = 18},
  [671] = {.lex_state = 9, .external_lex_state = 3},
  [672] = {.lex_state = 18},
  [673] = {.lex_state = 18},
  [674] = {.lex_state = 18},
  [675] = {.lex_state = 18},
  [676] = {.lex_state = 18},
  [677] = {.lex_state = 18},
  [678] = {.lex_state = 18},
  [679] = {.lex_state = 9, .external_lex_state = 2},
  [680] = {.lex_state = 9, .external_lex_state = 2},
  [681] = {.lex_state = 18},
  [682] = {.lex_state = 9, .external_lex_state = 3},
  [683] = {.lex_state = 9, .external_lex_state = 2},
  [684] = {.lex_state = 18},
  [685] = {.lex_state = 9, .external_lex_state = 2},
  [686] = {.lex_state = 18},
  [687] = {.lex_state = 18},
  [688] = {.lex_state = 9, .external_lex_state = 3},
  [689] = {.lex_state = 9, .external_lex_state = 3},
  [690] = {.lex_state = 9, .external_lex_state = 2},
  [691] = {.lex_state = 18},
  [692] = {.lex_state = 9, .external_lex_state = 3},
  [693] = {.lex_state = 18},
  [694] = {.lex_state = 18},
  [695] = {.lex_state = 18},
  [696] = {.lex_state = 18},
  [697] = {.lex_state = 18},
  [698] = {.lex_state = 18},
  [699] = {.lex_state = 18},
  [700] = {.lex_state = 18},
  [701] = {.lex_state = 18},
  [702] = {.lex_state = 18},
  [703] = {.lex_state = 18},
  [704] = {.lex_state = 18},
  [705] = {.lex_state = 18},
  [706] = {.lex_state = 18},
  [707] = {.lex_state = 18},
  [708] = {.lex_state = 18},
  [709] = {.lex_state = 18},
  [710] = {.lex_state = 18},
  [711] = {.lex_state = 18},
  [712] = {.lex_state = 18},
  [713] = {.lex_state = 9, .external_lex_state = 2},
  [714] = {.lex_state = 18},
  [715] = {.lex_state = 9, .external_lex_state = 3},
  [716] = {.lex_state = 18},
  [717] = {.lex_state = 9, .external_lex_state = 3},
  [718] = {.lex_state = 18},
  [719] = {.lex_state = 18},
  [720] = {.lex_state = 9, .external_lex_state = 2},
  [721] = {.lex_state = 18},
  [722] = {.lex_state = 18},
  [723] = {.lex_state = 18},
  [724] = {.lex_state = 10, .external_lex_state = 3},
  [725] = {.lex_state = 18},
  [726] = {.lex_state = 18},
  [727] = {.lex_state = 18},
  [728] = {.lex_state = 18},
  [729] = {.lex_state = 18},
  [730] = {.lex_state = 18},
  [731] = {.lex_state = 9, .external_lex_state = 2},
  [732] = {.lex_state = 18},
  [733] = {.lex_state = 18},
  [734] = {.lex_state = 18},
  [735] = {.lex_state = 18},
  [736] = {.lex_state = 18},
  [737] = {.lex_state = 18},
  [738] = {.lex_state = 18},
  [739] = {.lex_state = 18},
  [740] = {.lex_state = 18},
  [741] = {.lex_state = 18},
  [742] = {.lex_state = 9, .external_lex_state = 2},
  [743] = {.lex_state = 18},
  [744] = {.lex_state = 18},
  [745] = {.lex_state = 9, .external_lex_state = 3},
  [746] = {.lex_state = 18},
  [747] = {.lex_state = 18},
  [748] = {.lex_state = 18},
  [749] = {.lex_state = 9, .external_lex_state = 2},
  [750] = {.lex_state = 18},
  [751] = {.lex_state = 18},
  [752] = {.lex_state = 18},
  [753] = {.lex_state = 9, .external_lex_state = 3},
  [754] = {.lex_state = 18},
  [755] = {.lex_state = 18},
  [756] = {.lex_state = 18},
  [757] = {.lex_state = 18},
  [758] = {.lex_state = 18},
  [759] = {.lex_state = 18},
  [760] = {.lex_state = 18},
  [761] = {.lex_state = 18},
  [762] = {.lex_state = 9, .external_lex_state = 2},
  [763] = {.lex_state = 18},
  [764] = {.lex_state = 18},
  [765] = {.lex_state = 18},
  [766] = {.lex_state = 9, .external_lex_state = 3},
  [767] = {.lex_state = 9, .external_lex_state = 2},
  [768] = {.lex_state = 18},
  [769] = {.lex_state = 18},
  [770] = {.lex_state = 18},
  [771] = {.lex_state = 18},
  [772] = {.lex_state = 18},
  [773] = {.lex_state = 9, .external_lex_state = 3},
  [774] = {.lex_state = 18},
  [775] = {.lex_state = 18},
  [776] = {.lex_state = 18},
  [777] = {.lex_state = 18},
  [778] = {.lex_state = 9, .external_lex_state = 3},
  [779] = {.lex_state = 18},
  [780] = {.lex_state = 18},
  [781] = {.lex_state = 9, .external_lex_state = 3},
  [782] = {.lex_state = 18},
  [783] = {.lex_state = 18},
  [784] = {.lex_state = 18},
  [785] = {.lex_state = 18},
  [786] = {.lex_state = 18},
  [787] = {.lex_state = 18},
  [788] = {.lex_state = 18},
  [789] = {.lex_state = 18},
  [790] = {.lex_state = 10, .external_lex_state = 3},
  [791] = {.lex_state = 18},
  [792] = {.lex_state = 18},
  [793] = {.lex_state = 18},
  [794] = {.lex_state = 18},
  [795] = {.lex_state = 9, .external_lex_state = 2},
  [796] = {.lex_state = 9, .external_lex_state = 2},
  [797] = {.lex_state = 10, .external_lex_state = 3},
  [798] = {.lex_state = 9, .external_lex_state = 2},
  [799] = {.lex_state = 9, .external_lex_state = 2},
  [800] = {.lex_state = 10, .external_lex_state = 3},
  [801] = {.lex_state = 9, .external_lex_state = 3},
  [802] = {.lex_state = 9, .external_lex_state = 2},
  [803] = {.lex_state = 9, .external_lex_state = 3},
  [804] = {.lex_state = 9, .external_lex_state = 2},
  [805] = {.lex_state = 9, .external_lex_state = 2},
  [806] = {.lex_state = 9, .external_lex_state = 2},
  [807] = {.lex_state = 9, .external_lex_state = 2},
  [808] = {.lex_state = 9, .external_lex_state = 2},
  [809] = {.lex_state = 9, .external_lex_state = 3},
  [810] = {.lex_state = 9, .external_lex_state = 2},
  [811] = {.lex_state = 9, .external_lex_state = 2},
  [812] = {.lex_state = 9, .external_lex_state = 2},
  [813] = {.lex_state = 9, .external_lex_state = 3},
  [814] = {.lex_state = 9, .external_lex_state = 2},
  [815] = {.lex_state = 9, .external_lex_state = 2},
  [816] = {.lex_state = 9, .external_lex_state = 2},
  [817] = {.lex_state = 9, .external_lex_state = 2},
  [818] = {.lex_state = 9, .external_lex_state = 2},
  [819] = {.lex_state = 9, .external_lex_state = 3},
  [820] = {.lex_state = 10, .external_lex_state = 3},
  [821] = {.lex_state = 9, .external_lex_state = 2},
  [822] = {.lex_state = 9, .external_lex_state = 3},
  [823] = {.lex_state = 9, .external_lex_state = 2},
  [824] = {.lex_state = 9, .external_lex_state = 2},
  [825] = {.lex_state = 9, .external_lex_state = 2},
  [826] = {.lex_state = 9, .external_lex_state = 3},
  [827] = {.lex_state = 9, .external_lex_state = 3},
  [828] = {.lex_state = 10, .external_lex_state = 3},
  [829] = {.lex_state = 9, .external_lex_state = 3},
  [830] = {.lex_state = 9, .external_lex_state = 2},
  [831] = {.lex_state = 10, .external_lex_state = 3},
  [832] = {.lex_state = 9, .external_lex_state = 3},
  [833] = {.lex_state = 9, .external_lex_state = 2},
  [834] = {.lex_state = 9, .external_lex_state = 2},
  [835] = {.lex_state = 9, .external_lex_state = 2},
  [836] = {.lex_state = 9, .external_lex_state = 3},
  [837] = {.lex_state = 9, .external_lex_state = 2},
  [838] = {.lex_state = 9, .external_lex_state = 3},
  [839] = {.lex_state = 9, .external_lex_state = 3},
  [840] = {.lex_state = 9, .external_lex_state = 2},
  [841] = {.lex_state = 10, .external_lex_state = 3},
  [842] = {.lex_state = 9, .external_lex_state = 3},
  [843] = {.lex_state = 9, .external_lex_state = 2},
  [844] = {.lex_state = 9, .external_lex_state = 3},
  [845] = {.lex_state = 9, .external_lex_state = 3},
  [846] = {.lex_state = 10, .external_lex_state = 3},
  [847] = {.lex_state = 9, .external_lex_state = 3},
  [848] = {.lex_state = 9, .external_lex_state = 3},
  [849] = {.lex_state = 9, .external_lex_state = 3},
  [850] = {.lex_state = 9, .external_lex_state = 3},
  [851] = {.lex_state = 9, .external_lex_state = 3},
  [852] = {.lex_state = 9, .external_lex_state = 3},
  [853] = {.lex_state = 10, .external_lex_state = 3},
  [854] = {.lex_state = 10, .external_lex_state = 3},
  [855] = {.lex_state = 9, .external_lex_state = 3},
  [856] = {.lex_state = 9, .external_lex_state = 2},
  [857] = {.lex_state = 9, .external_lex_state = 3},
  [858] = {.lex_state = 10, .external_lex_state = 3},
  [859] = {.lex_state = 9, .external_lex_state = 3},
  [860] = {.lex_state = 9, .external_lex_state = 3},
  [861] = {.lex_state = 10, .external_lex_state = 3},
  [862] = {.lex_state = 9, .external_lex_state = 3},
  [863] = {.lex_state = 10, .external_lex_state = 3},
  [864] = {.lex_state = 10, .external_lex_state = 3},
  [865] = {.lex_state = 9, .external_lex_state = 2},
  [866] = {.lex_state = 10, .external_lex_state = 3},
  [867] = {.lex_state = 10, .external_lex_state = 3},
  [868] = {.lex_state = 9, .external_lex_state = 3},
  [869] = {.lex_state = 9, .external_lex_state = 3},
  [870] = {.lex_state = 9, .external_lex_state = 2},
  [871] = {.lex_state = 9, .external_lex_state = 3},
  [872] = {.lex_state = 10, .external_lex_state = 3},
  [873] = {.lex_state = 9, .external_lex_state = 3},
  [874] = {.lex_state = 9, .external_lex_state = 3},
  [875] = {.lex_state = 9, .external_lex_state = 2},
  [876] = {.lex_state = 10, .external_lex_state = 3},
  [877] = {.lex_state = 10, .external_lex_state = 3},
  [878] = {.lex_state = 9, .external_lex_state = 3},
  [879] = {.lex_state = 9, .external_lex_state = 3},
  [880] = {.lex_state = 3},
  [881] = {.lex_state = 3, .external_lex_state = 4},
  [882] = {.lex_state = 9, .external_lex_state = 2},
  [883] = {.lex_state = 3, .external_lex_state = 4},
  [884] = {.lex_state = 3, .external_lex_state = 4},
  [885] = {.lex_state = 9, .external_lex_state = 3},
  [886] = {.lex_state = 3},
  [887] = {.lex_state = 3},
  [888] = {.lex_state = 9, .external_lex_state = 3},
  [889] = {.lex_state = 9, .external_lex_state = 3},
  [890] = {.lex_state = 3},
  [891] = {.lex_state = 9, .external_lex_state = 3},
  [892] = {.lex_state = 9, .external_lex_state = 3},
  [893] = {.lex_state = 3},
  [894] = {.lex_state = 9, .external_lex_state = 3},
  [895] = {.lex_state = 3, .external_lex_state = 4},
  [896] = {.lex_state = 9, .external_lex_state = 3},
  [897] = {.lex_state = 9, .external_lex_state = 3},
  [898] = {.lex_state = 3, .external_lex_state = 4},
  [899] = {.lex_state = 9, .external_lex_state = 3},
  [900] = {.lex_state = 3, .external_lex_state = 4},
  [901] = {.lex_state = 2, .external_lex_state = 2},
  [902] = {.lex_state = 3},
  [903] = {.lex_state = 3},
  [904] = {.lex_state = 3},
  [905] = {.lex_state = 3},
  [906] = {.lex_state = 3},
  [907] = {.lex_state = 3},
  [908] = {.lex_state = 3},
  [909] = {.lex_state = 3},
  [910] = {.lex_state = 3},
  [911] = {.lex_state = 3},
  [912] = {.lex_state = 3},
  [913] = {.lex_state = 3},
  [914] = {.lex_state = 3},
  [915] = {.lex_state = 3},
  [916] = {.lex_state = 3},
  [917] = {.lex_state = 3},
  [918] = {.lex_state = 3},
  [919] = {.lex_state = 3},
  [920] = {.lex_state = 3},
  [921] = {.lex_state = 3},
  [922] = {.lex_state = 3},
  [923] = {.lex_state = 2, .external_lex_state = 3},
  [924] = {.lex_state = 2, .external_lex_state = 3},
  [925] = {.lex_state = 2, .external_lex_state = 3},
  [926] = {.lex_state = 2, .external_lex_state = 3},
  [927] = {.lex_state = 2, .external_lex_state = 3},
  [928] = {.lex_state = 2, .external_lex_state = 2},
  [929] = {.lex_state = 2, .external_lex_state = 3},
  [930] = {.lex_state = 2, .external_lex_state = 2},
  [931] = {.lex_state = 2, .external_lex_state = 3},
  [932] = {.lex_state = 2, .external_lex_state = 3},
  [933] = {.lex_state = 2, .external_lex_state = 3},
  [934] = {.lex_state = 2, .external_lex_state = 3},
  [935] = {.lex_state = 2, .external_lex_state = 3},
  [936] = {.lex_state = 2, .external_lex_state = 2},
  [937] = {.lex_state = 2, .external_lex_state = 3},
  [938] = {.lex_state = 2, .external_lex_state = 3},
  [939] = {.lex_state = 2, .external_lex_state = 3},
  [940] = {.lex_state = 2, .external_lex_state = 3},
  [941] = {.lex_state = 2, .external_lex_state = 3},
  [942] = {.lex_state = 2, .external_lex_state = 3},
  [943] = {.lex_state = 18},
  [944] = {.lex_state = 2, .external_lex_state = 3},
  [945] = {.lex_state = 2, .external_lex_state = 3},
  [946] = {.lex_state = 18},
  [947] = {.lex_state = 18},
  [948] = {.lex_state = 2, .external_lex_state = 3},
  [949] = {.lex_state = 2, .external_lex_state = 3},
  [950] = {.lex_state = 2, .external_lex_state = 3},
  [951] = {.lex_state = 2, .external_lex_state = 3},
  [952] = {.lex_state = 2, .external_lex_state = 3},
  [953] = {.lex_state = 2, .external_lex_state = 3},
  [954] = {.lex_state = 2, .external_lex_state = 3},
  [955] = {.lex_state = 2, .external_lex_state = 3},
  [956] = {.lex_state = 2, .external_lex_state = 3},
  [957] = {.lex_state = 2, .external_lex_state = 3},
  [958] = {.lex_state = 2, .external_lex_state = 2},
  [959] = {.lex_state = 2, .external_lex_state = 3},
  [960] = {.lex_state = 2, .external_lex_state = 3},
  [961] = {.lex_state = 2, .external_lex_state = 3},
  [962] = {.lex_state = 2, .external_lex_state = 3},
  [963] = {.lex_state = 2, .external_lex_state = 3},
  [964] = {.lex_state = 18},
  [965] = {.lex_state = 2, .external_lex_state = 2},
  [966] = {.lex_state = 2, .external_lex_state = 3},
  [967] = {.lex_state = 2, .external_lex_state = 3},
  [968] = {.lex_state = 2, .external_lex_state = 3},
  [969] = {.lex_state = 2, .external_lex_state = 3},
  [970] = {.lex_state = 2, .external_lex_state = 3},
  [971] = {.lex_state = 2, .external_lex_state = 3},
  [972] = {.lex_state = 2, .external_lex_state = 3},
  [973] = {.lex_state = 2, .external_lex_state = 3},
  [974] = {.lex_state = 2, .external_lex_state = 3},
  [975] = {.lex_state = 2, .external_lex_state = 3},
  [976] = {.lex_state = 2, .external_lex_state = 3},
  [977] = {.lex_state = 2, .external_lex_state = 3},
  [978] = {.lex_state = 18},
  [979] = {.lex_state = 2, .external_lex_state = 3},
  [980] = {.lex_state = 2, .external_lex_state = 3},
  [981] = {.lex_state = 2, .external_lex_state = 3},
  [982] = {.lex_state = 2, .external_lex_state = 2},
  [983] = {.lex_state = 2, .external_lex_state = 2},
  [984] = {.lex_state = 2, .external_lex_state = 2},
  [985] = {.lex_state = 2, .external_lex_state = 2},
  [986] = {.lex_state = 2, .external_lex_state = 3},
  [987] = {.lex_state = 18},
  [988] = {.lex_state = 2, .external_lex_state = 3},
  [989] = {.lex_state = 2, .external_lex_state = 3},
  [990] = {.lex_state = 2, .external_lex_state = 3},
  [991] = {.lex_state = 2, .external_lex_state = 2},
  [992] = {.lex_state = 2, .external_lex_state = 3},
  [993] = {.lex_state = 2, .external_lex_state = 3},
  [994] = {.lex_state = 2, .external_lex_state = 3},
  [995] = {.lex_state = 2, .external_lex_state = 3},
  [996] = {.lex_state = 2, .external_lex_state = 3},
  [997] = {.lex_state = 2, .external_lex_state = 3},
  [998] = {.lex_state = 2, .external_lex_state = 2},
  [999] = {.lex_state = 2, .external_lex_state = 2},
  [1000] = {.lex_state = 2, .external_lex_state = 2},
  [1001] = {.lex_state = 2, .external_lex_state = 2},
  [1002] = {.lex_state = 2, .external_lex_state = 2},
  [1003] = {.lex_state = 2, .external_lex_state = 3},
  [1004] = {.lex_state = 2, .external_lex_state = 2},
  [1005] = {.lex_state = 2, .external_lex_state = 3},
  [1006] = {.lex_state = 2, .external_lex_state = 3},
  [1007] = {.lex_state = 2, .external_lex_state = 3},
  [1008] = {.lex_state = 2, .external_lex_state = 3},
  [1009] = {.lex_state = 2, .external_lex_state = 3},
  [1010] = {.lex_state = 2, .external_lex_state = 3},
  [1011] = {.lex_state = 3},
  [1012] = {.lex_state = 2, .external_lex_state = 3},
  [1013] = {.lex_state = 2, .external_lex_state = 3},
  [1014] = {.lex_state = 2, .external_lex_state = 3},
  [1015] = {.lex_state = 2, .external_lex_state = 3},
  [1016] = {.lex_state = 2, .external_lex_state = 3},
  [1017] = {.lex_state = 2, .external_lex_state = 3},
  [1018] = {.lex_state = 2, .external_lex_state = 3},
  [1019] = {.lex_state = 2, .external_lex_state = 3},
  [1020] = {.lex_state = 2, .external_lex_state = 2},
  [1021] = {.lex_state = 2, .external_lex_state = 3},
  [1022] = {.lex_state = 2, .external_lex_state = 2},
  [1023] = {.lex_state = 2, .external_lex_state = 2},
  [1024] = {.lex_state = 2, .external_lex_state = 3},
  [1025] = {.lex_state = 2, .external_lex_state = 3},
  [1026] = {.lex_state = 2, .external_lex_state = 3},
  [1027] = {.lex_state = 2, .external_lex_state = 3},
  [1028] = {.lex_state = 2, .external_lex_state = 3},
  [1029] = {.lex_state = 2, .external_lex_state = 3},
  [1030] = {.lex_state = 2, .external_lex_state = 3},
  [1031] = {.lex_state = 2, .external_lex_state = 3},
  [1032] = {.lex_state = 2, .external_lex_state = 2},
  [1033] = {.lex_state = 2, .external_lex_state = 3},
  [1034] = {.lex_state = 2, .external_lex_state = 3},
  [1035] = {.lex_state = 2, .external_lex_state = 3},
  [1036] = {.lex_state = 2, .external_lex_state = 3},
  [1037] = {.lex_state = 2, .external_lex_state = 2},
  [1038] = {.lex_state = 2, .external_lex_state = 2},
  [1039] = {.lex_state = 2, .external_lex_state = 3},
  [1040] = {.lex_state = 2, .external_lex_state = 3},
  [1041] = {.lex_state = 2, .external_lex_state = 2},
  [1042] = {.lex_state = 2, .external_lex_state = 3},
  [1043] = {.lex_state = 2, .external_lex_state = 3},
  [1044] = {.lex_state = 2, .external_lex_state = 2},
  [1045] = {.lex_state = 2, .external_lex_state = 2},
  [1046] = {.lex_state = 2, .external_lex_state = 3},
  [1047] = {.lex_state = 2, .external_lex_state = 2},
  [1048] = {.lex_state = 2, .external_lex_state = 3},
  [1049] = {.lex_state = 2, .external_lex_state = 2},
  [1050] = {.lex_state = 2, .external_lex_state = 2},
  [1051] = {.lex_state = 2, .external_lex_state = 2},
  [1052] = {.lex_state = 2, .external_lex_state = 3},
  [1053] = {.lex_state = 2, .external_lex_state = 2},
  [1054] = {.lex_state = 2, .external_lex_state = 3},
  [1055] = {.lex_state = 2, .external_lex_state = 2},
  [1056] = {.lex_state = 2, .external_lex_state = 3},
  [1057] = {.lex_state = 2, .external_lex_state = 3},
  [1058] = {.lex_state = 2, .external_lex_state = 3},
  [1059] = {.lex_state = 2, .external_lex_state = 2},
  [1060] = {.lex_state = 2, .external_lex_state = 2},
  [1061] = {.lex_state = 2, .external_lex_state = 2},
  [1062] = {.lex_state = 2, .external_lex_state = 2},
  [1063] = {.lex_state = 2, .external_lex_state = 2},
  [1064] = {.lex_state = 2, .external_lex_state = 3},
  [1065] = {.lex_state = 2, .external_lex_state = 3},
  [1066] = {.lex_state = 2, .external_lex_state = 2},
  [1067] = {.lex_state = 2, .external_lex_state = 3},
  [1068] = {.lex_state = 2, .external_lex_state = 3},
  [1069] = {.lex_state = 2, .external_lex_state = 3},
  [1070] = {.lex_state = 2, .external_lex_state = 3},
  [1071] = {.lex_state = 2, .external_lex_state = 3},
  [1072] = {.lex_state = 2, .external_lex_state = 3},
  [1073] = {.lex_state = 2, .external_lex_state = 3},
  [1074] = {.lex_state = 2, .external_lex_state = 3},
  [1075] = {.lex_state = 2, .external_lex_state = 3},
  [1076] = {.lex_state = 2, .external_lex_state = 2},
  [1077] = {.lex_state = 2, .external_lex_state = 3},
  [1078] = {.lex_state = 2, .external_lex_state = 3},
  [1079] = {.lex_state = 2, .external_lex_state = 2},
  [1080] = {.lex_state = 2, .external_lex_state = 3},
  [1081] = {.lex_state = 2, .external_lex_state = 3},
  [1082] = {.lex_state = 2, .external_lex_state = 3},
  [1083] = {.lex_state = 11, .external_lex_state = 3},
  [1084] = {.lex_state = 2, .external_lex_state = 3},
  [1085] = {.lex_state = 2, .external_lex_state = 3},
  [1086] = {.lex_state = 2, .external_lex_state = 3},
  [1087] = {.lex_state = 2, .external_lex_state = 2},
  [1088] = {.lex_state = 2, .external_lex_state = 3},
  [1089] = {.lex_state = 2, .external_lex_state = 3},
  [1090] = {.lex_state = 2, .external_lex_state = 2},
  [1091] = {.lex_state = 2, .external_lex_state = 3},
  [1092] = {.lex_state = 2, .external_lex_state = 2},
  [1093] = {.lex_state = 2, .external_lex_state = 3},
  [1094] = {.lex_state = 2, .external_lex_state = 3},
  [1095] = {.lex_state = 2, .external_lex_state = 3},
  [1096] = {.lex_state = 2, .external_lex_state = 3},
  [1097] = {.lex_state = 3},
  [1098] = {.lex_state = 2, .external_lex_state = 3},
  [1099] = {.lex_state = 2, .external_lex_state = 3},
  [1100] = {.lex_state = 2, .external_lex_state = 2},
  [1101] = {.lex_state = 2, .external_lex_state = 3},
  [1102] = {.lex_state = 2, .external_lex_state = 2},
  [1103] = {.lex_state = 2, .external_lex_state = 3},
  [1104] = {.lex_state = 2, .external_lex_state = 3},
  [1105] = {.lex_state = 2, .external_lex_state = 3},
  [1106] = {.lex_state = 3},
  [1107] = {.lex_state = 2, .external_lex_state = 2},
  [1108] = {.lex_state = 2, .external_lex_state = 3},
  [1109] = {.lex_state = 2, .external_lex_state = 3},
  [1110] = {.lex_state = 2, .external_lex_state = 2},
  [1111] = {.lex_state = 2, .external_lex_state = 3},
  [1112] = {.lex_state = 2, .external_lex_state = 3},
  [1113] = {.lex_state = 2, .external_lex_state = 3},
  [1114] = {.lex_state = 2, .external_lex_state = 3},
  [1115] = {.lex_state = 2, .external_lex_state = 3},
  [1116] = {.lex_state = 2, .external_lex_state = 3},
  [1117] = {.lex_state = 2, .external_lex_state = 3},
  [1118] = {.lex_state = 2, .external_lex_state = 2},
  [1119] = {.lex_state = 2, .external_lex_state = 2},
  [1120] = {.lex_state = 2, .external_lex_state = 3},
  [1121] = {.lex_state = 2, .external_lex_state = 3},
  [1122] = {.lex_state = 2, .external_lex_state = 2},
  [1123] = {.lex_state = 2, .external_lex_state = 3},
  [1124] = {.lex_state = 2, .external_lex_state = 3},
  [1125] = {.lex_state = 2, .external_lex_state = 3},
  [1126] = {.lex_state = 2, .external_lex_state = 3},
  [1127] = {.lex_state = 2, .external_lex_state = 2},
  [1128] = {.lex_state = 3},
  [1129] = {.lex_state = 2, .external_lex_state = 3},
  [1130] = {.lex_state = 2, .external_lex_state = 3},
  [1131] = {.lex_state = 2, .external_lex_state = 2},
  [1132] = {.lex_state = 2, .external_lex_state = 3},
  [1133] = {.lex_state = 2, .external_lex_state = 3},
  [1134] = {.lex_state = 2, .external_lex_state = 2},
  [1135] = {.lex_state = 3},
  [1136] = {.lex_state = 2, .external_lex_state = 3},
  [1137] = {.lex_state = 2, .external_lex_state = 2},
  [1138] = {.lex_state = 3},
  [1139] = {.lex_state = 2, .external_lex_state = 3},
  [1140] = {.lex_state = 11, .external_lex_state = 3},
  [1141] = {.lex_state = 3, .external_lex_state = 4},
  [1142] = {.lex_state = 11, .external_lex_state = 3},
  [1143] = {.lex_state = 2, .external_lex_state = 3},
  [1144] = {.lex_state = 2, .external_lex_state = 3},
  [1145] = {.lex_state = 2, .external_lex_state = 3},
  [1146] = {.lex_state = 2, .external_lex_state = 3},
  [1147] = {.lex_state = 11, .external_lex_state = 3},
  [1148] = {.lex_state = 2, .external_lex_state = 2},
  [1149] = {.lex_state = 11, .external_lex_state = 3},
  [1150] = {.lex_state = 11, .external_lex_state = 3},
  [1151] = {.lex_state = 11, .external_lex_state = 3},
  [1152] = {.lex_state = 11, .external_lex_state = 3},
  [1153] = {.lex_state = 11, .external_lex_state = 3},
  [1154] = {.lex_state = 3, .external_lex_state = 4},
  [1155] = {.lex_state = 3},
  [1156] = {.lex_state = 2, .external_lex_state = 2},
  [1157] = {.lex_state = 2, .external_lex_state = 3},
  [1158] = {.lex_state = 2, .external_lex_state = 2},
  [1159] = {.lex_state = 2, .external_lex_state = 2},
  [1160] = {.lex_state = 2, .external_lex_state = 3},
  [1161] = {.lex_state = 2, .external_lex_state = 3},
  [1162] = {.lex_state = 2, .external_lex_state = 3},
  [1163] = {.lex_state = 2, .external_lex_state = 3},
  [1164] = {.lex_state = 2, .external_lex_state = 3},
  [1165] = {.lex_state = 2, .external_lex_state = 3},
  [1166] = {.lex_state = 3, .external_lex_state = 4},
  [1167] = {.lex_state = 3, .external_lex_state = 4},
  [1168] = {.lex_state = 3},
  [1169] = {.lex_state = 11, .external_lex_state = 3},
  [1170] = {.lex_state = 3, .external_lex_state = 4},
  [1171] = {.lex_state = 2, .external_lex_state = 2},
  [1172] = {.lex_state = 3, .external_lex_state = 4},
  [1173] = {.lex_state = 2, .external_lex_state = 3},
  [1174] = {.lex_state = 3, .external_lex_state = 4},
  [1175] = {.lex_state = 11, .external_lex_state = 3},
  [1176] = {.lex_state = 2, .external_lex_state = 2},
  [1177] = {.lex_state = 2, .external_lex_state = 2},
  [1178] = {.lex_state = 3, .external_lex_state = 4},
  [1179] = {.lex_state = 3, .external_lex_state = 4},
  [1180] = {.lex_state = 2, .external_lex_state = 2},
  [1181] = {.lex_state = 2, .external_lex_state = 3},
  [1182] = {.lex_state = 2, .external_lex_state = 3},
  [1183] = {.lex_state = 2, .external_lex_state = 3},
  [1184] = {.lex_state = 2, .external_lex_state = 2},
  [1185] = {.lex_state = 2, .external_lex_state = 3},
  [1186] = {.lex_state = 11, .external_lex_state = 3},
  [1187] = {.lex_state = 3},
  [1188] = {.lex_state = 3, .external_lex_state = 4},
  [1189] = {.lex_state = 3, .external_lex_state = 4},
  [1190] = {.lex_state = 3, .external_lex_state = 4},
  [1191] = {.lex_state = 3},
  [1192] = {.lex_state = 2, .external_lex_state = 2},
  [1193] = {.lex_state = 2, .external_lex_state = 2},
  [1194] = {.lex_state = 12, .external_lex_state = 3},
  [1195] = {.lex_state = 2, .external_lex_state = 3},
  [1196] = {.lex_state = 3},
  [1197] = {.lex_state = 2, .external_lex_state = 2},
  [1198] = {.lex_state = 11, .external_lex_state = 3},
  [1199] = {.lex_state = 3},
  [1200] = {.lex_state = 11, .external_lex_state = 3},
  [1201] = {.lex_state = 11, .external_lex_state = 3},
  [1202] = {.lex_state = 11, .external_lex_state = 3},
  [1203] = {.lex_state = 2, .external_lex_state = 3},
  [1204] = {.lex_state = 11, .external_lex_state = 3},
  [1205] = {.lex_state = 11, .external_lex_state = 3},
  [1206] = {.lex_state = 2, .external_lex_state = 2},
  [1207] = {.lex_state = 3},
  [1208] = {.lex_state = 2, .external_lex_state = 3},
  [1209] = {.lex_state = 11, .external_lex_state = 3},
  [1210] = {.lex_state = 3},
  [1211] = {.lex_state = 2, .external_lex_state = 3},
  [1212] = {.lex_state = 2, .external_lex_state = 3},
  [1213] = {.lex_state = 2, .external_lex_state = 3},
  [1214] = {.lex_state = 3},
  [1215] = {.lex_state = 2, .external_lex_state = 2},
  [1216] = {.lex_state = 3},
  [1217] = {.lex_state = 2, .external_lex_state = 2},
  [1218] = {.lex_state = 2, .external_lex_state = 3},
  [1219] = {.lex_state = 3},
  [1220] = {.lex_state = 2, .external_lex_state = 3},
  [1221] = {.lex_state = 11, .external_lex_state = 3},
  [1222] = {.lex_state = 11, .external_lex_state = 3},
  [1223] = {.lex_state = 2, .external_lex_state = 3},
  [1224] = {.lex_state = 11, .external_lex_state = 3},
  [1225] = {.lex_state = 11, .external_lex_state = 3},
  [1226] = {.lex_state = 2, .external_lex_state = 3},
  [1227] = {.lex_state = 2, .external_lex_state = 2},
  [1228] = {.lex_state = 3},
  [1229] = {.lex_state = 3},
  [1230] = {.lex_state = 2, .external_lex_state = 3},
  [1231] = {.lex_state = 11, .external_lex_state = 3},
  [1232] = {.lex_state = 2, .external_lex_state = 3},
  [1233] = {.lex_state = 2, .external_lex_state = 3},
  [1234] = {.lex_state = 11, .external_lex_state = 3},
  [1235] = {.lex_state = 11, .external_lex_state = 3},
  [1236] = {.lex_state = 11, .external_lex_state = 3},
  [1237] = {.lex_state = 2, .external_lex_state = 2},
  [1238] = {.lex_state = 2, .external_lex_state = 2},
  [1239] = {.lex_state = 11, .external_lex_state = 3},
  [1240] = {.lex_state = 2, .external_lex_state = 2},
  [1241] = {.lex_state = 2, .external_lex_state = 3},
  [1242] = {.lex_state = 2, .external_lex_state = 3},
  [1243] = {.lex_state = 2, .external_lex_state = 3},
  [1244] = {.lex_state = 2, .external_lex_state = 3},
  [1245] = {.lex_state = 11, .external_lex_state = 3},
  [1246] = {.lex_state = 11, .external_lex_state = 3},
  [1247] = {.lex_state = 11, .external_lex_state = 3},
  [1248] = {.lex_state = 2, .external_lex_state = 3},
  [1249] = {.lex_state = 11, .external_lex_state = 3},
  [1250] = {.lex_state = 2, .external_lex_state = 3},
  [1251] = {.lex_state = 2, .external_lex_state = 3},
  [1252] = {.lex_state = 2, .external_lex_state = 3},
  [1253] = {.lex_state = 2, .external_lex_state = 2},
  [1254] = {.lex_state = 2, .external_lex_state = 2},
  [1255] = {.lex_state = 2, .external_lex_state = 3},
  [1256] = {.lex_state = 2, .external_lex_state = 3},
  [1257] = {.lex_state = 2, .external_lex_state = 3},
  [1258] = {.lex_state = 2, .external_lex_state = 3},
  [1259] = {.lex_state = 2, .external_lex_state = 2},
  [1260] = {.lex_state = 2, .external_lex_state = 2},
  [1261] = {.lex_state = 2, .external_lex_state = 2},
  [1262] = {.lex_state = 2, .external_lex_state = 2},
  [1263] = {.lex_state = 2, .external_lex_state = 3},
  [1264] = {.lex_state = 2, .external_lex_state = 3},
  [1265] = {.lex_state = 2, .external_lex_state = 3},
  [1266] = {.lex_state = 2, .external_lex_state = 3},
  [1267] = {.lex_state = 2, .external_lex_state = 3},
  [1268] = {.lex_state = 3, .external_lex_state = 4},
  [1269] = {.lex_state = 2, .external_lex_state = 2},
  [1270] = {.lex_state = 2, .external_lex_state = 3},
  [1271] = {.lex_state = 11, .external_lex_state = 2},
  [1272] = {.lex_state = 2, .external_lex_state = 3},
  [1273] = {.lex_state = 11, .external_lex_state = 3},
  [1274] = {.lex_state = 11, .external_lex_state = 3},
  [1275] = {.lex_state = 2, .external_lex_state = 2},
  [1276] = {.lex_state = 11, .external_lex_state = 3},
  [1277] = {.lex_state = 2, .external_lex_state = 3},
  [1278] = {.lex_state = 2, .external_lex_state = 3},
  [1279] = {.lex_state = 2, .external_lex_state = 3},
  [1280] = {.lex_state = 2, .external_lex_state = 2},
  [1281] = {.lex_state = 2, .external_lex_state = 2},
  [1282] = {.lex_state = 3, .external_lex_state = 4},
  [1283] = {.lex_state = 2, .external_lex_state = 3},
  [1284] = {.lex_state = 12, .external_lex_state = 2},
  [1285] = {.lex_state = 2, .external_lex_state = 3},
  [1286] = {.lex_state = 2, .external_lex_state = 3},
  [1287] = {.lex_state = 2, .external_lex_state = 2},
  [1288] = {.lex_state = 2, .external_lex_state = 2},
  [1289] = {.lex_state = 2, .external_lex_state = 3},
  [1290] = {.lex_state = 2, .external_lex_state = 2},
  [1291] = {.lex_state = 11, .external_lex_state = 3},
  [1292] = {.lex_state = 2, .external_lex_state = 2},
  [1293] = {.lex_state = 2, .external_lex_state = 2},
  [1294] = {.lex_state = 2, .external_lex_state = 3},
  [1295] = {.lex_state = 2, .external_lex_state = 2},
  [1296] = {.lex_state = 2, .external_lex_state = 3},
  [1297] = {.lex_state = 2, .external_lex_state = 3},
  [1298] = {.lex_state = 2, .external_lex_state = 2},
  [1299] = {.lex_state = 2, .external_lex_state = 2},
  [1300] = {.lex_state = 2, .external_lex_state = 2},
  [1301] = {.lex_state = 2, .external_lex_state = 2},
  [1302] = {.lex_state = 2, .external_lex_state = 2},
  [1303] = {.lex_state = 2, .external_lex_state = 2},
  [1304] = {.lex_state = 2, .external_lex_state = 2},
  [1305] = {.lex_state = 2, .external_lex_state = 2},
  [1306] = {.lex_state = 2, .external_lex_state = 2},
  [1307] = {.lex_state = 2, .external_lex_state = 2},
  [1308] = {.lex_state = 2, .external_lex_state = 2},
  [1309] = {.lex_state = 2, .external_lex_state = 2},
  [1310] = {.lex_state = 2, .external_lex_state = 2},
  [1311] = {.lex_state = 2, .external_lex_state = 3},
  [1312] = {.lex_state = 2, .external_lex_state = 2},
  [1313] = {.lex_state = 2, .external_lex_state = 2},
  [1314] = {.lex_state = 2, .external_lex_state = 2},
  [1315] = {.lex_state = 2, .external_lex_state = 2},
  [1316] = {.lex_state = 2, .external_lex_state = 2},
  [1317] = {.lex_state = 2, .external_lex_state = 2},
  [1318] = {.lex_state = 3, .external_lex_state = 4},
  [1319] = {.lex_state = 2, .external_lex_state = 2},
  [1320] = {.lex_state = 2, .external_lex_state = 3},
  [1321] = {.lex_state = 2, .external_lex_state = 2},
  [1322] = {.lex_state = 2, .external_lex_state = 2},
  [1323] = {.lex_state = 2, .external_lex_state = 2},
  [1324] = {.lex_state = 2, .external_lex_state = 3},
  [1325] = {.lex_state = 2, .external_lex_state = 2},
  [1326] = {.lex_state = 2, .external_lex_state = 3},
  [1327] = {.lex_state = 2, .external_lex_state = 3},
  [1328] = {.lex_state = 2, .external_lex_state = 3},
  [1329] = {.lex_state = 2, .external_lex_state = 3},
  [1330] = {.lex_state = 2, .external_lex_state = 2},
  [1331] = {.lex_state = 2, .external_lex_state = 2},
  [1332] = {.lex_state = 3, .external_lex_state = 4},
  [1333] = {.lex_state = 2, .external_lex_state = 2},
  [1334] = {.lex_state = 3, .external_lex_state = 4},
  [1335] = {.lex_state = 2, .external_lex_state = 3},
  [1336] = {.lex_state = 3, .external_lex_state = 4},
  [1337] = {.lex_state = 2, .external_lex_state = 3},
  [1338] = {.lex_state = 3, .external_lex_state = 4},
  [1339] = {.lex_state = 2, .external_lex_state = 3},
  [1340] = {.lex_state = 2, .external_lex_state = 3},
  [1341] = {.lex_state = 2, .external_lex_state = 2},
  [1342] = {.lex_state = 2, .external_lex_state = 2},
  [1343] = {.lex_state = 2, .external_lex_state = 2},
  [1344] = {.lex_state = 3, .external_lex_state = 4},
  [1345] = {.lex_state = 2, .external_lex_state = 2},
  [1346] = {.lex_state = 2, .external_lex_state = 2},
  [1347] = {.lex_state = 2, .external_lex_state = 2},
  [1348] = {.lex_state = 2, .external_lex_state = 2},
  [1349] = {.lex_state = 2, .external_lex_state = 3},
  [1350] = {.lex_state = 2, .external_lex_state = 3},
  [1351] = {.lex_state = 2, .external_lex_state = 3},
  [1352] = {.lex_state = 2, .external_lex_state = 3},
  [1353] = {.lex_state = 2, .external_lex_state = 3},
  [1354] = {.lex_state = 2, .external_lex_state = 2},
  [1355] = {.lex_state = 2, .external_lex_state = 3},
  [1356] = {.lex_state = 3, .external_lex_state = 4},
  [1357] = {.lex_state = 2, .external_lex_state = 3},
  [1358] = {.lex_state = 2, .external_lex_state = 3},
  [1359] = {.lex_state = 2, .external_lex_state = 3},
  [1360] = {.lex_state = 2, .external_lex_state = 3},
  [1361] = {.lex_state = 2, .external_lex_state = 3},
  [1362] = {.lex_state = 2, .external_lex_state = 3},
  [1363] = {.lex_state = 2, .external_lex_state = 2},
  [1364] = {.lex_state = 2, .external_lex_state = 2},
  [1365] = {.lex_state = 2, .external_lex_state = 3},
  [1366] = {.lex_state = 2, .external_lex_state = 3},
  [1367] = {.lex_state = 2, .external_lex_state = 3},
  [1368] = {.lex_state = 2, .external_lex_state = 3},
  [1369] = {.lex_state = 2, .external_lex_state = 2},
  [1370] = {.lex_state = 2, .external_lex_state = 3},
  [1371] = {.lex_state = 2, .external_lex_state = 2},
  [1372] = {.lex_state = 2, .external_lex_state = 2},
  [1373] = {.lex_state = 2, .external_lex_state = 2},
  [1374] = {.lex_state = 2, .external_lex_state = 2},
  [1375] = {.lex_state = 2, .external_lex_state = 2},
  [1376] = {.lex_state = 2, .external_lex_state = 2},
  [1377] = {.lex_state = 2, .external_lex_state = 3},
  [1378] = {.lex_state = 2, .external_lex_state = 2},
  [1379] = {.lex_state = 2, .external_lex_state = 2},
  [1380] = {.lex_state = 2, .external_lex_state = 2},
  [1381] = {.lex_state = 2, .external_lex_state = 2},
  [1382] = {.lex_state = 2, .external_lex_state = 2},
  [1383] = {.lex_state = 2, .external_lex_state = 2},
  [1384] = {.lex_state = 2, .external_lex_state = 2},
  [1385] = {.lex_state = 2, .external_lex_state = 2},
  [1386] = {.lex_state = 2, .external_lex_state = 2},
  [1387] = {.lex_state = 2, .external_lex_state = 2},
  [1388] = {.lex_state = 11, .external_lex_state = 3},
  [1389] = {.lex_state = 2, .external_lex_state = 2},
  [1390] = {.lex_state = 2, .external_lex_state = 2},
  [1391] = {.lex_state = 2, .external_lex_state = 2},
  [1392] = {.lex_state = 3, .external_lex_state = 4},
  [1393] = {.lex_state = 2, .external_lex_state = 2},
  [1394] = {.lex_state = 2, .external_lex_state = 2},
  [1395] = {.lex_state = 2, .external_lex_state = 2},
  [1396] = {.lex_state = 2, .external_lex_state = 3},
  [1397] = {.lex_state = 2, .external_lex_state = 2},
  [1398] = {.lex_state = 2, .external_lex_state = 2},
  [1399] = {.lex_state = 2, .external_lex_state = 2},
  [1400] = {.lex_state = 2, .external_lex_state = 2},
  [1401] = {.lex_state = 2, .external_lex_state = 2},
  [1402] = {.lex_state = 2, .external_lex_state = 2},
  [1403] = {.lex_state = 2, .external_lex_state = 2},
  [1404] = {.lex_state = 2, .external_lex_state = 3},
  [1405] = {.lex_state = 2, .external_lex_state = 3},
  [1406] = {.lex_state = 2, .external_lex_state = 3},
  [1407] = {.lex_state = 2, .external_lex_state = 2},
  [1408] = {.lex_state = 2, .external_lex_state = 3},
  [1409] = {.lex_state = 2, .external_lex_state = 2},
  [1410] = {.lex_state = 11, .external_lex_state = 3},
  [1411] = {.lex_state = 2, .external_lex_state = 2},
  [1412] = {.lex_state = 2, .external_lex_state = 2},
  [1413] = {.lex_state = 2, .external_lex_state = 2},
  [1414] = {.lex_state = 2, .external_lex_state = 2},
  [1415] = {.lex_state = 12, .external_lex_state = 3},
  [1416] = {.lex_state = 11, .external_lex_state = 3},
  [1417] = {.lex_state = 2, .external_lex_state = 2},
  [1418] = {.lex_state = 11, .external_lex_state = 3},
  [1419] = {.lex_state = 11, .external_lex_state = 2},
  [1420] = {.lex_state = 11, .external_lex_state = 3},
  [1421] = {.lex_state = 11, .external_lex_state = 3},
  [1422] = {.lex_state = 2, .external_lex_state = 2},
  [1423] = {.lex_state = 2, .external_lex_state = 2},
  [1424] = {.lex_state = 11, .external_lex_state = 3},
  [1425] = {.lex_state = 3, .external_lex_state = 4},
  [1426] = {.lex_state = 11, .external_lex_state = 3},
  [1427] = {.lex_state = 2, .external_lex_state = 3},
  [1428] = {.lex_state = 2, .external_lex_state = 2},
  [1429] = {.lex_state = 2, .external_lex_state = 2},
  [1430] = {.lex_state = 3, .external_lex_state = 4},
  [1431] = {.lex_state = 2, .external_lex_state = 2},
  [1432] = {.lex_state = 3, .external_lex_state = 4},
  [1433] = {.lex_state = 2, .external_lex_state = 2},
  [1434] = {.lex_state = 11, .external_lex_state = 3},
  [1435] = {.lex_state = 11, .external_lex_state = 3},
  [1436] = {.lex_state = 2, .external_lex_state = 2},
  [1437] = {.lex_state = 11, .external_lex_state = 3},
  [1438] = {.lex_state = 2, .external_lex_state = 2},
  [1439] = {.lex_state = 2, .external_lex_state = 2},
  [1440] = {.lex_state = 2, .external_lex_state = 2},
  [1441] = {.lex_state = 2, .external_lex_state = 2},
  [1442] = {.lex_state = 11, .external_lex_state = 3},
  [1443] = {.lex_state = 2, .external_lex_state = 2},
  [1444] = {.lex_state = 11, .external_lex_state = 2},
  [1445] = {.lex_state = 2, .external_lex_state = 2},
  [1446] = {.lex_state = 3, .external_lex_state = 4},
  [1447] = {.lex_state = 11, .external_lex_state = 3},
  [1448] = {.lex_state = 3, .external_lex_state = 4},
  [1449] = {.lex_state = 3, .external_lex_state = 4},
  [1450] = {.lex_state = 3, .external_lex_state = 4},
  [1451] = {.lex_state = 11, .external_lex_state = 3},
  [1452] = {.lex_state = 11, .external_lex_state = 3},
  [1453] = {.lex_state = 3, .external_lex_state = 4},
  [1454] = {.lex_state = 3, .external_lex_state = 4},
  [1455] = {.lex_state = 3, .external_lex_state = 4},
  [1456] = {.lex_state = 2, .external_lex_state = 2},
  [1457] = {.lex_state = 3, .external_lex_state = 4},
  [1458] = {.lex_state = 2, .external_lex_state = 3},
  [1459] = {.lex_state = 2, .external_lex_state = 3},
  [1460] = {.lex_state = 2, .external_lex_state = 2},
  [1461] = {.lex_state = 2, .external_lex_state = 2},
  [1462] = {.lex_state = 14, .external_lex_state = 3},
  [1463] = {.lex_state = 3, .external_lex_state = 4},
  [1464] = {.lex_state = 2, .external_lex_state = 2},
  [1465] = {.lex_state = 2, .external_lex_state = 2},
  [1466] = {.lex_state = 2, .external_lex_state = 3},
  [1467] = {.lex_state = 3, .external_lex_state = 4},
  [1468] = {.lex_state = 3, .external_lex_state = 4},
  [1469] = {.lex_state = 2, .external_lex_state = 2},
  [1470] = {.lex_state = 2, .external_lex_state = 2},
  [1471] = {.lex_state = 2, .external_lex_state = 2},
  [1472] = {.lex_state = 2, .external_lex_state = 2},
  [1473] = {.lex_state = 2, .external_lex_state = 2},
  [1474] = {.lex_state = 2, .external_lex_state = 2},
  [1475] = {.lex_state = 2, .external_lex_state = 2},
  [1476] = {.lex_state = 2, .external_lex_state = 2},
  [1477] = {.lex_state = 2, .external_lex_state = 2},
  [1478] = {.lex_state = 2, .external_lex_state = 2},
  [1479] = {.lex_state = 2, .external_lex_state = 2},
  [1480] = {.lex_state = 2, .external_lex_state = 2},
  [1481] = {.lex_state = 2, .external_lex_state = 2},
  [1482] = {.lex_state = 2, .external_lex_state = 2},
  [1483] = {.lex_state = 2, .external_lex_state = 2},
  [1484] = {.lex_state = 2, .external_lex_state = 2},
  [1485] = {.lex_state = 2, .external_lex_state = 2},
  [1486] = {.lex_state = 3, .external_lex_state = 4},
  [1487] = {.lex_state = 2, .external_lex_state = 2},
  [1488] = {.lex_state = 2, .external_lex_state = 2},
  [1489] = {.lex_state = 2, .external_lex_state = 2},
  [1490] = {.lex_state = 3, .external_lex_state = 4},
  [1491] = {.lex_state = 2, .external_lex_state = 2},
  [1492] = {.lex_state = 2, .external_lex_state = 2},
  [1493] = {.lex_state = 3, .external_lex_state = 4},
  [1494] = {.lex_state = 2, .external_lex_state = 2},
  [1495] = {.lex_state = 2, .external_lex_state = 2},
  [1496] = {.lex_state = 2, .external_lex_state = 3},
  [1497] = {.lex_state = 2, .external_lex_state = 3},
  [1498] = {.lex_state = 2, .external_lex_state = 3},
  [1499] = {.lex_state = 2, .external_lex_state = 3},
  [1500] = {.lex_state = 3, .external_lex_state = 4},
  [1501] = {.lex_state = 3, .external_lex_state = 4},
  [1502] = {.lex_state = 2, .external_lex_state = 2},
  [1503] = {.lex_state = 2, .external_lex_state = 3},
  [1504] = {.lex_state = 2, .external_lex_state = 2},
  [1505] = {.lex_state = 2, .external_lex_state = 2},
  [1506] = {.lex_state = 2, .external_lex_state = 2},
  [1507] = {.lex_state = 2, .external_lex_state = 3},
  [1508] = {.lex_state = 3, .external_lex_state = 4},
  [1509] = {.lex_state = 2, .external_lex_state = 3},
  [1510] = {.lex_state = 3, .external_lex_state = 4},
  [1511] = {.lex_state = 3, .external_lex_state = 4},
  [1512] = {.lex_state = 3, .external_lex_state = 4},
  [1513] = {.lex_state = 3, .external_lex_state = 4},
  [1514] = {.lex_state = 2, .external_lex_state = 3},
  [1515] = {.lex_state = 2, .external_lex_state = 3},
  [1516] = {.lex_state = 2, .external_lex_state = 2},
  [1517] = {.lex_state = 2, .external_lex_state = 2},
  [1518] = {.lex_state = 2, .external_lex_state = 2},
  [1519] = {.lex_state = 2, .external_lex_state = 2},
  [1520] = {.lex_state = 2, .external_lex_state = 2},
  [1521] = {.lex_state = 2, .external_lex_state = 2},
  [1522] = {.lex_state = 3, .external_lex_state = 4},
  [1523] = {.lex_state = 11, .external_lex_state = 3},
  [1524] = {.lex_state = 3, .external_lex_state = 4},
  [1525] = {.lex_state = 11, .external_lex_state = 3},
  [1526] = {.lex_state = 3},
  [1527] = {.lex_state = 3, .external_lex_state = 4},
  [1528] = {.lex_state = 2, .external_lex_state = 3},
  [1529] = {.lex_state = 11, .external_lex_state = 3},
  [1530] = {.lex_state = 3},
  [1531] = {.lex_state = 11, .external_lex_state = 3},
  [1532] = {.lex_state = 2, .external_lex_state = 3},
  [1533] = {.lex_state = 3, .external_lex_state = 4},
  [1534] = {.lex_state = 3, .external_lex_state = 4},
  [1535] = {.lex_state = 11, .external_lex_state = 3},
  [1536] = {.lex_state = 3},
  [1537] = {.lex_state = 11, .external_lex_state = 3},
  [1538] = {.lex_state = 11, .external_lex_state = 3},
  [1539] = {.lex_state = 11, .external_lex_state = 3},
  [1540] = {.lex_state = 11, .external_lex_state = 3},
  [1541] = {.lex_state = 3, .external_lex_state = 4},
  [1542] = {.lex_state = 11, .external_lex_state = 3},
  [1543] = {.lex_state = 11, .external_lex_state = 3},
  [1544] = {.lex_state = 3},
  [1545] = {.lex_state = 11, .external_lex_state = 3},
  [1546] = {.lex_state = 11, .external_lex_state = 3},
  [1547] = {.lex_state = 11, .external_lex_state = 3},
  [1548] = {.lex_state = 2, .external_lex_state = 3},
  [1549] = {.lex_state = 3, .external_lex_state = 4},
  [1550] = {.lex_state = 11, .external_lex_state = 3},
  [1551] = {.lex_state = 11, .external_lex_state = 3},
  [1552] = {.lex_state = 3, .external_lex_state = 4},
  [1553] = {.lex_state = 11, .external_lex_state = 3},
  [1554] = {.lex_state = 11, .external_lex_state = 3},
  [1555] = {.lex_state = 11, .external_lex_state = 3},
  [1556] = {.lex_state = 3, .external_lex_state = 4},
  [1557] = {.lex_state = 11, .external_lex_state = 3},
  [1558] = {.lex_state = 11, .external_lex_state = 3},
  [1559] = {.lex_state = 3, .external_lex_state = 4},
  [1560] = {.lex_state = 11, .external_lex_state = 3},
  [1561] = {.lex_state = 11, .external_lex_state = 3},
  [1562] = {.lex_state = 2, .external_lex_state = 3},
  [1563] = {.lex_state = 11, .external_lex_state = 3},
  [1564] = {.lex_state = 11, .external_lex_state = 3},
  [1565] = {.lex_state = 11, .external_lex_state = 3},
  [1566] = {.lex_state = 11, .external_lex_state = 3},
  [1567] = {.lex_state = 3, .external_lex_state = 4},
  [1568] = {.lex_state = 11, .external_lex_state = 3},
  [1569] = {.lex_state = 11, .external_lex_state = 3},
  [1570] = {.lex_state = 11, .external_lex_state = 3},
  [1571] = {.lex_state = 11, .external_lex_state = 3},
  [1572] = {.lex_state = 11, .external_lex_state = 3},
  [1573] = {.lex_state = 11, .external_lex_state = 3},
  [1574] = {.lex_state = 3, .external_lex_state = 4},
  [1575] = {.lex_state = 3},
  [1576] = {.lex_state = 3, .external_lex_state = 4},
  [1577] = {.lex_state = 3},
  [1578] = {.lex_state = 11, .external_lex_state = 3},
  [1579] = {.lex_state = 11, .external_lex_state = 3},
  [1580] = {.lex_state = 3, .external_lex_state = 4},
  [1581] = {.lex_state = 11, .external_lex_state = 3},
  [1582] = {.lex_state = 3, .external_lex_state = 4},
  [1583] = {.lex_state = 11, .external_lex_state = 3},
  [1584] = {.lex_state = 11, .external_lex_state = 3},
  [1585] = {.lex_state = 11, .external_lex_state = 3},
  [1586] = {.lex_state = 11, .external_lex_state = 3},
  [1587] = {.lex_state = 11, .external_lex_state = 3},
  [1588] = {.lex_state = 11, .external_lex_state = 3},
  [1589] = {.lex_state = 11, .external_lex_state = 3},
  [1590] = {.lex_state = 3},
  [1591] = {.lex_state = 11, .external_lex_state = 3},
  [1592] = {.lex_state = 11, .external_lex_state = 3},
  [1593] = {.lex_state = 11, .external_lex_state = 3},
  [1594] = {.lex_state = 11, .external_lex_state = 3},
  [1595] = {.lex_state = 11, .external_lex_state = 3},
  [1596] = {.lex_state = 3},
  [1597] = {.lex_state = 3},
  [1598] = {.lex_state = 11, .external_lex_state = 3},
  [1599] = {.lex_state = 11, .external_lex_state = 3},
  [1600] = {.lex_state = 11, .external_lex_state = 3},
  [1601] = {.lex_state = 11, .external_lex_state = 3},
  [1602] = {.lex_state = 2, .external_lex_state = 2},
  [1603] = {.lex_state = 11, .external_lex_state = 3},
  [1604] = {.lex_state = 11, .external_lex_state = 3},
  [1605] = {.lex_state = 3, .external_lex_state = 4},
  [1606] = {.lex_state = 11, .external_lex_state = 3},
  [1607] = {.lex_state = 2, .external_lex_state = 3},
  [1608] = {.lex_state = 11, .external_lex_state = 3},
  [1609] = {.lex_state = 11, .external_lex_state = 3},
  [1610] = {.lex_state = 2, .external_lex_state = 3},
  [1611] = {.lex_state = 2, .external_lex_state = 2},
  [1612] = {.lex_state = 11, .external_lex_state = 3},
  [1613] = {.lex_state = 11, .external_lex_state = 3},
  [1614] = {.lex_state = 3},
  [1615] = {.lex_state = 3},
  [1616] = {.lex_state = 11, .external_lex_state = 3},
  [1617] = {.lex_state = 11, .external_lex_state = 3},
  [1618] = {.lex_state = 3, .external_lex_state = 4},
  [1619] = {.lex_state = 11, .external_lex_state = 3},
  [1620] = {.lex_state = 11, .external_lex_state = 3},
  [1621] = {.lex_state = 11, .external_lex_state = 3},
  [1622] = {.lex_state = 11, .external_lex_state = 3},
  [1623] = {.lex_state = 11, .external_lex_state = 3},
  [1624] = {.lex_state = 11, .external_lex_state = 3},
  [1625] = {.lex_state = 3, .external_lex_state = 4},
  [1626] = {.lex_state = 11, .external_lex_state = 3},
  [1627] = {.lex_state = 11, .external_lex_state = 3},
  [1628] = {.lex_state = 11, .external_lex_state = 3},
  [1629] = {.lex_state = 2, .external_lex_state = 3},
  [1630] = {.lex_state = 11, .external_lex_state = 3},
  [1631] = {.lex_state = 11, .external_lex_state = 3},
  [1632] = {.lex_state = 11, .external_lex_state = 3},
  [1633] = {.lex_state = 3},
  [1634] = {.lex_state = 11, .external_lex_state = 3},
  [1635] = {.lex_state = 11, .external_lex_state = 3},
  [1636] = {.lex_state = 11, .external_lex_state = 3},
  [1637] = {.lex_state = 11, .external_lex_state = 3},
  [1638] = {.lex_state = 11, .external_lex_state = 3},
  [1639] = {.lex_state = 11, .external_lex_state = 3},
  [1640] = {.lex_state = 11, .external_lex_state = 3},
  [1641] = {.lex_state = 3},
  [1642] = {.lex_state = 3},
  [1643] = {.lex_state = 3},
  [1644] = {.lex_state = 3, .external_lex_state = 4},
  [1645] = {.lex_state = 2, .external_lex_state = 3},
  [1646] = {.lex_state = 11, .external_lex_state = 3},
  [1647] = {.lex_state = 2, .external_lex_state = 3},
  [1648] = {.lex_state = 11, .external_lex_state = 3},
  [1649] = {.lex_state = 11, .external_lex_state = 3},
  [1650] = {.lex_state = 2, .external_lex_state = 3},
  [1651] = {.lex_state = 11, .external_lex_state = 3},
  [1652] = {.lex_state = 11, .external_lex_state = 3},
  [1653] = {.lex_state = 11, .external_lex_state = 3},
  [1654] = {.lex_state = 11, .external_lex_state = 3},
  [1655] = {.lex_state = 11, .external_lex_state = 3},
  [1656] = {.lex_state = 2, .external_lex_state = 3},
  [1657] = {.lex_state = 2, .external_lex_state = 2},
  [1658] = {.lex_state = 11, .external_lex_state = 3},
  [1659] = {.lex_state = 11, .external_lex_state = 3},
  [1660] = {.lex_state = 2, .external_lex_state = 3},
  [1661] = {.lex_state = 11, .external_lex_state = 3},
  [1662] = {.lex_state = 2, .external_lex_state = 2},
  [1663] = {.lex_state = 11, .external_lex_state = 3},
  [1664] = {.lex_state = 2, .external_lex_state = 3},
  [1665] = {.lex_state = 3},
  [1666] = {.lex_state = 3},
  [1667] = {.lex_state = 3},
  [1668] = {.lex_state = 2, .external_lex_state = 3},
  [1669] = {.lex_state = 3},
  [1670] = {.lex_state = 3},
  [1671] = {.lex_state = 2, .external_lex_state = 3},
  [1672] = {.lex_state = 2, .external_lex_state = 3},
  [1673] = {.lex_state = 3},
  [1674] = {.lex_state = 3},
  [1675] = {.lex_state = 3, .external_lex_state = 4},
  [1676] = {.lex_state = 2, .external_lex_state = 3},
  [1677] = {.lex_state = 3},
  [1678] = {.lex_state = 3},
  [1679] = {.lex_state = 2, .external_lex_state = 3},
  [1680] = {.lex_state = 3},
  [1681] = {.lex_state = 2, .external_lex_state = 3},
  [1682] = {.lex_state = 3},
  [1683] = {.lex_state = 3},
  [1684] = {.lex_state = 3},
  [1685] = {.lex_state = 3},
  [1686] = {.lex_state = 3},
  [1687] = {.lex_state = 3},
  [1688] = {.lex_state = 3},
  [1689] = {.lex_state = 3},
  [1690] = {.lex_state = 3},
  [1691] = {.lex_state = 3},
  [1692] = {.lex_state = 3},
  [1693] = {.lex_state = 3},
  [1694] = {.lex_state = 3},
  [1695] = {.lex_state = 3},
  [1696] = {.lex_state = 3},
  [1697] = {.lex_state = 3},
  [1698] = {.lex_state = 3},
  [1699] = {.lex_state = 3},
  [1700] = {.lex_state = 3},
  [1701] = {.lex_state = 3},
  [1702] = {.lex_state = 3},
  [1703] = {.lex_state = 3},
  [1704] = {.lex_state = 3},
  [1705] = {.lex_state = 3},
  [1706] = {.lex_state = 3},
  [1707] = {.lex_state = 3},
  [1708] = {.lex_state = 3},
  [1709] = {.lex_state = 3},
  [1710] = {.lex_state = 3},
  [1711] = {.lex_state = 3},
  [1712] = {.lex_state = 3},
  [1713] = {.lex_state = 3},
  [1714] = {.lex_state = 3},
  [1715] = {.lex_state = 3},
  [1716] = {.lex_state = 3},
  [1717] = {.lex_state = 3},
  [1718] = {.lex_state = 3},
  [1719] = {.lex_state = 3},
  [1720] = {.lex_state = 3},
  [1721] = {.lex_state = 3},
  [1722] = {.lex_state = 3},
  [1723] = {.lex_state = 3, .external_lex_state = 4},
  [1724] = {.lex_state = 3, .external_lex_state = 4},
  [1725] = {.lex_state = 3},
  [1726] = {.lex_state = 3},
  [1727] = {.lex_state = 3},
  [1728] = {.lex_state = 3},
  [1729] = {.lex_state = 3},
  [1730] = {.lex_state = 3, .external_lex_state = 4},
  [1731] = {.lex_state = 3, .external_lex_state = 4},
  [1732] = {.lex_state = 3, .external_lex_state = 4},
  [1733] = {.lex_state = 3, .external_lex_state = 4},
  [1734] = {.lex_state = 3, .external_lex_state = 4},
  [1735] = {.lex_state = 3},
  [1736] = {.lex_state = 3, .external_lex_state = 4},
  [1737] = {.lex_state = 3},
  [1738] = {.lex_state = 3},
  [1739] = {.lex_state = 3},
  [1740] = {.lex_state = 3, .external_lex_state = 4},
  [1741] = {.lex_state = 3, .external_lex_state = 4},
  [1742] = {.lex_state = 3},
  [1743] = {.lex_state = 3},
  [1744] = {.lex_state = 3, .external_lex_state = 4},
  [1745] = {.lex_state = 3},
  [1746] = {.lex_state = 3, .external_lex_state = 4},
  [1747] = {.lex_state = 3, .external_lex_state = 4},
  [1748] = {.lex_state = 3, .external_lex_state = 4},
  [1749] = {.lex_state = 3, .external_lex_state = 4},
  [1750] = {.lex_state = 3},
  [1751] = {.lex_state = 3, .external_lex_state = 4},
  [1752] = {.lex_state = 3, .external_lex_state = 4},
  [1753] = {.lex_state = 3},
  [1754] = {.lex_state = 3},
  [1755] = {.lex_state = 3},
  [1756] = {.lex_state = 3},
  [1757] = {.lex_state = 3},
  [1758] = {.lex_state = 3},
  [1759] = {.lex_state = 3},
  [1760] = {.lex_state = 3},
  [1761] = {.lex_state = 3},
  [1762] = {.lex_state = 3},
  [1763] = {.lex_state = 3},
  [1764] = {.lex_state = 3},
  [1765] = {.lex_state = 3},
  [1766] = {.lex_state = 3},
  [1767] = {.lex_state = 3},
  [1768] = {.lex_state = 3},
  [1769] = {.lex_state = 3},
  [1770] = {.lex_state = 3},
  [1771] = {.lex_state = 3},
  [1772] = {.lex_state = 3},
  [1773] = {.lex_state = 3},
  [1774] = {.lex_state = 3},
  [1775] = {.lex_state = 3},
  [1776] = {.lex_state = 3},
  [1777] = {.lex_state = 3},
  [1778] = {.lex_state = 3},
  [1779] = {.lex_state = 3},
  [1780] = {.lex_state = 3},
  [1781] = {.lex_state = 3},
  [1782] = {.lex_state = 3},
  [1783] = {.lex_state = 3},
  [1784] = {.lex_state = 3},
  [1785] = {.lex_state = 3},
  [1786] = {.lex_state = 3},
  [1787] = {.lex_state = 3},
  [1788] = {.lex_state = 3},
  [1789] = {.lex_state = 3},
  [1790] = {.lex_state = 3},
  [1791] = {.lex_state = 3},
  [1792] = {.lex_state = 3},
  [1793] = {.lex_state = 3},
  [1794] = {.lex_state = 3},
  [1795] = {.lex_state = 3},
  [1796] = {.lex_state = 3},
  [1797] = {.lex_state = 3},
  [1798] = {.lex_state = 3},
  [1799] = {.lex_state = 3},
  [1800] = {.lex_state = 3},
  [1801] = {.lex_state = 3},
  [1802] = {.lex_state = 3, .external_lex_state = 4},
  [1803] = {.lex_state = 3, .external_lex_state = 4},
  [1804] = {.lex_state = 3, .external_lex_state = 4},
  [1805] = {.lex_state = 3},
  [1806] = {.lex_state = 3, .external_lex_state = 4},
  [1807] = {.lex_state = 3},
  [1808] = {.lex_state = 3, .external_lex_state = 4},
  [1809] = {.lex_state = 3, .external_lex_state = 4},
  [1810] = {.lex_state = 3, .external_lex_state = 4},
  [1811] = {.lex_state = 3, .external_lex_state = 4},
  [1812] = {.lex_state = 3, .external_lex_state = 4},
  [1813] = {.lex_state = 3, .external_lex_state = 4},
  [1814] = {.lex_state = 3, .external_lex_state = 4},
  [1815] = {.lex_state = 3, .external_lex_state = 4},
  [1816] = {.lex_state = 3, .external_lex_state = 4},
  [1817] = {.lex_state = 3, .external_lex_state = 4},
  [1818] = {.lex_state = 3, .external_lex_state = 4},
  [1819] = {.lex_state = 3, .external_lex_state = 4},
  [1820] = {.lex_state = 3, .external_lex_state = 4},
  [1821] = {.lex_state = 3, .external_lex_state = 4},
  [1822] = {.lex_state = 3, .external_lex_state = 4},
  [1823] = {.lex_state = 3, .external_lex_state = 4},
  [1824] = {.lex_state = 3, .external_lex_state = 4},
  [1825] = {.lex_state = 3, .external_lex_state = 4},
  [1826] = {.lex_state = 3, .external_lex_state = 4},
  [1827] = {.lex_state = 3, .external_lex_state = 4},
  [1828] = {.lex_state = 3},
  [1829] = {.lex_state = 3},
  [1830] = {.lex_state = 3},
  [1831] = {.lex_state = 3},
  [1832] = {.lex_state = 3, .external_lex_state = 4},
  [1833] = {.lex_state = 3, .external_lex_state = 4},
  [1834] = {.lex_state = 3},
  [1835] = {.lex_state = 3, .external_lex_state = 4},
  [1836] = {.lex_state = 3, .external_lex_state = 4},
  [1837] = {.lex_state = 3, .external_lex_state = 4},
  [1838] = {.lex_state = 3, .external_lex_state = 4},
  [1839] = {.lex_state = 3, .external_lex_state = 4},
  [1840] = {.lex_state = 3},
  [1841] = {.lex_state = 3, .external_lex_state = 4},
  [1842] = {.lex_state = 3, .external_lex_state = 4},
  [1843] = {.lex_state = 3, .external_lex_state = 4},
  [1844] = {.lex_state = 3, .external_lex_state = 4},
  [1845] = {.lex_state = 3, .external_lex_state = 4},
  [1846] = {.lex_state = 3, .external_lex_state = 4},
  [1847] = {.lex_state = 3, .external_lex_state = 4},
  [1848] = {.lex_state = 3, .external_lex_state = 4},
  [1849] = {.lex_state = 3, .external_lex_state = 4},
  [1850] = {.lex_state = 3, .external_lex_state = 4},
  [1851] = {.lex_state = 3, .external_lex_state = 4},
  [1852] = {.lex_state = 3, .external_lex_state = 4},
  [1853] = {.lex_state = 3, .external_lex_state = 4},
  [1854] = {.lex_state = 3, .external_lex_state = 4},
  [1855] = {.lex_state = 3, .external_lex_state = 4},
  [1856] = {.lex_state = 3, .external_lex_state = 4},
  [1857] = {.lex_state = 3, .external_lex_state = 4},
  [1858] = {.lex_state = 3, .external_lex_state = 4},
  [1859] = {.lex_state = 3, .external_lex_state = 4},
  [1860] = {.lex_state = 3},
  [1861] = {.lex_state = 3, .external_lex_state = 4},
  [1862] = {.lex_state = 3, .external_lex_state = 4},
  [1863] = {.lex_state = 3, .external_lex_state = 4},
  [1864] = {.lex_state = 3, .external_lex_state = 4},
  [1865] = {.lex_state = 3, .external_lex_state = 4},
  [1866] = {.lex_state = 3, .external_lex_state = 4},
  [1867] = {.lex_state = 3, .external_lex_state = 4},
  [1868] = {.lex_state = 3},
  [1869] = {.lex_state = 3},
  [1870] = {.lex_state = 3, .external_lex_state = 4},
  [1871] = {.lex_state = 3, .external_lex_state = 4},
  [1872] = {.lex_state = 3},
  [1873] = {.lex_state = 3, .external_lex_state = 4},
  [1874] = {.lex_state = 3},
  [1875] = {.lex_state = 3, .external_lex_state = 4},
  [1876] = {.lex_state = 3, .external_lex_state = 4},
  [1877] = {.lex_state = 3, .external_lex_state = 4},
  [1878] = {.lex_state = 3, .external_lex_state = 4},
  [1879] = {.lex_state = 3, .external_lex_state = 4},
  [1880] = {.lex_state = 3, .external_lex_state = 4},
  [1881] = {.lex_state = 3},
  [1882] = {.lex_state = 3, .external_lex_state = 4},
  [1883] = {.lex_state = 3},
  [1884] = {.lex_state = 3},
  [1885] = {.lex_state = 3},
  [1886] = {.lex_state = 3, .external_lex_state = 4},
  [1887] = {.lex_state = 3, .external_lex_state = 4},
  [1888] = {.lex_state = 3, .external_lex_state = 4},
  [1889] = {.lex_state = 3},
  [1890] = {.lex_state = 3, .external_lex_state = 4},
  [1891] = {.lex_state = 3, .external_lex_state = 4},
  [1892] = {.lex_state = 3, .external_lex_state = 4},
  [1893] = {.lex_state = 3, .external_lex_state = 4},
  [1894] = {.lex_state = 3},
  [1895] = {.lex_state = 3, .external_lex_state = 4},
  [1896] = {.lex_state = 3},
  [1897] = {.lex_state = 3},
  [1898] = {.lex_state = 3},
  [1899] = {.lex_state = 3, .external_lex_state = 4},
  [1900] = {.lex_state = 3},
  [1901] = {.lex_state = 3},
  [1902] = {.lex_state = 3},
  [1903] = {.lex_state = 3},
  [1904] = {.lex_state = 3, .external_lex_state = 4},
  [1905] = {.lex_state = 3},
  [1906] = {.lex_state = 3},
  [1907] = {.lex_state = 3},
  [1908] = {.lex_state = 3},
  [1909] = {.lex_state = 3},
  [1910] = {.lex_state = 3},
  [1911] = {.lex_state = 3},
  [1912] = {.lex_state = 3},
  [1913] = {.lex_state = 3, .external_lex_state = 4},
  [1914] = {.lex_state = 3},
  [1915] = {.lex_state = 3},
  [1916] = {.lex_state = 3},
  [1917] = {.lex_state = 3},
  [1918] = {.lex_state = 3, .external_lex_state = 4},
  [1919] = {.lex_state = 3},
  [1920] = {.lex_state = 3, .external_lex_state = 4},
  [1921] = {.lex_state = 3},
  [1922] = {.lex_state = 3, .external_lex_state = 4},
  [1923] = {.lex_state = 3},
  [1924] = {.lex_state = 3},
  [1925] = {.lex_state = 3},
  [1926] = {.lex_state = 3},
  [1927] = {.lex_state = 3},
  [1928] = {.lex_state = 3},
  [1929] = {.lex_state = 3},
  [1930] = {.lex_state = 3},
  [1931] = {.lex_state = 3},
  [1932] = {.lex_state = 3},
  [1933] = {.lex_state = 17},
  [1934] = {.lex_state = 3, .external_lex_state = 4},
  [1935] = {.lex_state = 3, .external_lex_state = 4},
  [1936] = {.lex_state = 3, .external_lex_state = 4},
  [1937] = {.lex_state = 3},
  [1938] = {.lex_state = 0, .external_lex_state = 4},
  [1939] = {.lex_state = 3, .external_lex_state = 4},
  [1940] = {.lex_state = 3},
  [1941] = {.lex_state = 0, .external_lex_state = 4},
  [1942] = {.lex_state = 3, .external_lex_state = 4},
  [1943] = {.lex_state = 3},
  [1944] = {.lex_state = 3},
  [1945] = {.lex_state = 3},
  [1946] = {.lex_state = 3},
  [1947] = {.lex_state = 0},
  [1948] = {.lex_state = 3},
  [1949] = {.lex_state = 3},
  [1950] = {.lex_state = 3},
  [1951] = {.lex_state = 3},
  [1952] = {.lex_state = 0, .external_lex_state = 4},
  [1953] = {.lex_state = 3},
  [1954] = {.lex_state = 3},
  [1955] = {.lex_state = 3},
  [1956] = {.lex_state = 3},
  [1957] = {.lex_state = 3},
  [1958] = {.lex_state = 0, .external_lex_state = 4},
  [1959] = {.lex_state = 0, .external_lex_state = 4},
  [1960] = {.lex_state = 3},
  [1961] = {.lex_state = 3},
  [1962] = {.lex_state = 3},
  [1963] = {.lex_state = 3, .external_lex_state = 4},
  [1964] = {.lex_state = 0, .external_lex_state = 4},
  [1965] = {.lex_state = 3},
  [1966] = {.lex_state = 3},
  [1967] = {.lex_state = 3},
  [1968] = {.lex_state = 3},
  [1969] = {.lex_state = 17},
  [1970] = {.lex_state = 3, .external_lex_state = 4},
  [1971] = {.lex_state = 3},
  [1972] = {.lex_state = 3, .external_lex_state = 4},
  [1973] = {.lex_state = 3, .external_lex_state = 4},
  [1974] = {.lex_state = 3, .external_lex_state = 4},
  [1975] = {.lex_state = 3, .external_lex_state = 4},
  [1976] = {.lex_state = 3, .external_lex_state = 4},
  [1977] = {.lex_state = 3, .external_lex_state = 4},
  [1978] = {.lex_state = 3, .external_lex_state = 4},
  [1979] = {.lex_state = 3},
  [1980] = {.lex_state = 3, .external_lex_state = 4},
  [1981] = {.lex_state = 3, .external_lex_state = 4},
  [1982] = {.lex_state = 3, .external_lex_state = 4},
  [1983] = {.lex_state = 3, .external_lex_state = 4},
  [1984] = {.lex_state = 3},
  [1985] = {.lex_state = 3, .external_lex_state = 4},
  [1986] = {.lex_state = 0, .external_lex_state = 4},
  [1987] = {.lex_state = 3},
  [1988] = {.lex_state = 0, .external_lex_state = 4},
  [1989] = {.lex_state = 3},
  [1990] = {.lex_state = 0, .external_lex_state = 4},
  [1991] = {.lex_state = 3},
  [1992] = {.lex_state = 3},
  [1993] = {.lex_state = 3},
  [1994] = {.lex_state = 3},
  [1995] = {.lex_state = 3},
  [1996] = {.lex_state = 3},
  [1997] = {.lex_state = 3},
  [1998] = {.lex_state = 3},
  [1999] = {.lex_state = 3},
  [2000] = {.lex_state = 3},
  [2001] = {.lex_state = 0, .external_lex_state = 4},
  [2002] = {.lex_state = 3},
  [2003] = {.lex_state = 3},
  [2004] = {.lex_state = 0, .external_lex_state = 4},
  [2005] = {.lex_state = 0, .external_lex_state = 4},
  [2006] = {.lex_state = 3},
  [2007] = {.lex_state = 0, .external_lex_state = 4},
  [2008] = {.lex_state = 3},
  [2009] = {.lex_state = 3},
  [2010] = {.lex_state = 3},
  [2011] = {.lex_state = 3},
  [2012] = {.lex_state = 0, .external_lex_state = 4},
  [2013] = {.lex_state = 3},
  [2014] = {.lex_state = 21, .external_lex_state = 5},
  [2015] = {.lex_state = 3},
  [2016] = {.lex_state = 3},
  [2017] = {.lex_state = 3, .external_lex_state = 4},
  [2018] = {.lex_state = 3},
  [2019] = {.lex_state = 3},
  [2020] = {.lex_state = 21, .external_lex_state = 5},
  [2021] = {.lex_state = 3},
  [2022] = {.lex_state = 0, .external_lex_state = 4},
  [2023] = {.lex_state = 0},
  [2024] = {.lex_state = 3},
  [2025] = {.lex_state = 3},
  [2026] = {.lex_state = 3, .external_lex_state = 4},
  [2027] = {.lex_state = 3},
  [2028] = {.lex_state = 21, .external_lex_state = 5},
  [2029] = {.lex_state = 0, .external_lex_state = 4},
  [2030] = {.lex_state = 0, .external_lex_state = 4},
  [2031] = {.lex_state = 0, .external_lex_state = 4},
  [2032] = {.lex_state = 0, .external_lex_state = 4},
  [2033] = {.lex_state = 3},
  [2034] = {.lex_state = 3},
  [2035] = {.lex_state = 0, .external_lex_state = 4},
  [2036] = {.lex_state = 0, .external_lex_state = 4},
  [2037] = {.lex_state = 3},
  [2038] = {.lex_state = 0, .external_lex_state = 4},
  [2039] = {.lex_state = 0, .external_lex_state = 4},
  [2040] = {.lex_state = 0, .external_lex_state = 4},
  [2041] = {.lex_state = 3},
  [2042] = {.lex_state = 3},
  [2043] = {.lex_state = 0, .external_lex_state = 4},
  [2044] = {.lex_state = 3},
  [2045] = {.lex_state = 3},
  [2046] = {.lex_state = 3},
  [2047] = {.lex_state = 3},
  [2048] = {.lex_state = 3},
  [2049] = {.lex_state = 3},
  [2050] = {.lex_state = 3},
  [2051] = {.lex_state = 0, .external_lex_state = 4},
  [2052] = {.lex_state = 0, .external_lex_state = 4},
  [2053] = {.lex_state = 3},
  [2054] = {.lex_state = 3},
  [2055] = {.lex_state = 3},
  [2056] = {.lex_state = 3},
  [2057] = {.lex_state = 3},
  [2058] = {.lex_state = 3},
  [2059] = {.lex_state = 21, .external_lex_state = 5},
  [2060] = {.lex_state = 3},
  [2061] = {.lex_state = 3},
  [2062] = {.lex_state = 3},
  [2063] = {.lex_state = 3},
  [2064] = {.lex_state = 3},
  [2065] = {.lex_state = 0, .external_lex_state = 4},
  [2066] = {.lex_state = 3},
  [2067] = {.lex_state = 21, .external_lex_state = 5},
  [2068] = {.lex_state = 17},
  [2069] = {.lex_state = 3},
  [2070] = {.lex_state = 3},
  [2071] = {.lex_state = 3},
  [2072] = {.lex_state = 3},
  [2073] = {.lex_state = 3},
  [2074] = {.lex_state = 3},
  [2075] = {.lex_state = 0, .external_lex_state = 4},
  [2076] = {.lex_state = 21, .external_lex_state = 5},
  [2077] = {.lex_state = 21, .external_lex_state = 5},
  [2078] = {.lex_state = 3},
  [2079] = {.lex_state = 3},
  [2080] = {.lex_state = 3},
  [2081] = {.lex_state = 0, .external_lex_state = 4},
  [2082] = {.lex_state = 0},
  [2083] = {.lex_state = 0, .external_lex_state = 4},
  [2084] = {.lex_state = 0, .external_lex_state = 4},
  [2085] = {.lex_state = 3},
  [2086] = {.lex_state = 0, .external_lex_state = 4},
  [2087] = {.lex_state = 3, .external_lex_state = 4},
  [2088] = {.lex_state = 3},
  [2089] = {.lex_state = 0, .external_lex_state = 4},
  [2090] = {.lex_state = 3},
  [2091] = {.lex_state = 3},
  [2092] = {.lex_state = 0, .external_lex_state = 4},
  [2093] = {.lex_state = 0, .external_lex_state = 4},
  [2094] = {.lex_state = 3},
  [2095] = {.lex_state = 3},
  [2096] = {.lex_state = 3},
  [2097] = {.lex_state = 3},
  [2098] = {.lex_state = 3},
  [2099] = {.lex_state = 3},
  [2100] = {.lex_state = 3},
  [2101] = {.lex_state = 0, .external_lex_state = 4},
  [2102] = {.lex_state = 0, .external_lex_state = 4},
  [2103] = {.lex_state = 3},
  [2104] = {.lex_state = 0, .external_lex_state = 4},
  [2105] = {.lex_state = 3},
  [2106] = {.lex_state = 3},
  [2107] = {.lex_state = 3},
  [2108] = {.lex_state = 0, .external_lex_state = 4},
  [2109] = {.lex_state = 0, .external_lex_state = 4},
  [2110] = {.lex_state = 3},
  [2111] = {.lex_state = 3},
  [2112] = {.lex_state = 3},
  [2113] = {.lex_state = 3},
  [2114] = {.lex_state = 0, .external_lex_state = 4},
  [2115] = {.lex_state = 0, .external_lex_state = 4},
  [2116] = {.lex_state = 3},
  [2117] = {.lex_state = 3},
  [2118] = {.lex_state = 0},
  [2119] = {.lex_state = 3},
  [2120] = {.lex_state = 10},
  [2121] = {.lex_state = 0, .external_lex_state = 4},
  [2122] = {.lex_state = 0, .external_lex_state = 4},
  [2123] = {.lex_state = 0, .external_lex_state = 4},
  [2124] = {.lex_state = 3},
  [2125] = {.lex_state = 0, .external_lex_state = 4},
  [2126] = {.lex_state = 0},
  [2127] = {.lex_state = 3},
  [2128] = {.lex_state = 3},
  [2129] = {.lex_state = 3},
  [2130] = {.lex_state = 0, .external_lex_state = 4},
  [2131] = {.lex_state = 3},
  [2132] = {.lex_state = 3},
  [2133] = {.lex_state = 0, .external_lex_state = 4},
  [2134] = {.lex_state = 0, .external_lex_state = 4},
  [2135] = {.lex_state = 0},
  [2136] = {.lex_state = 0, .external_lex_state = 4},
  [2137] = {.lex_state = 0, .external_lex_state = 4},
  [2138] = {.lex_state = 3},
  [2139] = {.lex_state = 3},
  [2140] = {.lex_state = 3},
  [2141] = {.lex_state = 0, .external_lex_state = 4},
  [2142] = {.lex_state = 3},
  [2143] = {.lex_state = 0, .external_lex_state = 4},
  [2144] = {.lex_state = 3},
  [2145] = {.lex_state = 0, .external_lex_state = 4},
  [2146] = {.lex_state = 3},
  [2147] = {.lex_state = 0, .external_lex_state = 4},
  [2148] = {.lex_state = 0, .external_lex_state = 4},
  [2149] = {.lex_state = 3},
  [2150] = {.lex_state = 0, .external_lex_state = 4},
  [2151] = {.lex_state = 3},
  [2152] = {.lex_state = 0, .external_lex_state = 4},
  [2153] = {.lex_state = 3, .external_lex_state = 4},
  [2154] = {.lex_state = 3},
  [2155] = {.lex_state = 0},
  [2156] = {.lex_state = 0},
  [2157] = {.lex_state = 0},
  [2158] = {.lex_state = 0, .external_lex_state = 4},
  [2159] = {.lex_state = 0},
  [2160] = {.lex_state = 3, .external_lex_state = 4},
  [2161] = {.lex_state = 0, .external_lex_state = 4},
  [2162] = {.lex_state = 17},
  [2163] = {.lex_state = 0, .external_lex_state = 4},
  [2164] = {.lex_state = 0, .external_lex_state = 4},
  [2165] = {.lex_state = 0, .external_lex_state = 4},
  [2166] = {.lex_state = 0},
  [2167] = {.lex_state = 0, .external_lex_state = 4},
  [2168] = {.lex_state = 3},
  [2169] = {.lex_state = 0, .external_lex_state = 4},
  [2170] = {.lex_state = 0},
  [2171] = {.lex_state = 3},
  [2172] = {.lex_state = 0},
  [2173] = {.lex_state = 3},
  [2174] = {.lex_state = 3, .external_lex_state = 4},
  [2175] = {.lex_state = 3},
  [2176] = {.lex_state = 3, .external_lex_state = 4},
  [2177] = {.lex_state = 3},
  [2178] = {.lex_state = 0, .external_lex_state = 4},
  [2179] = {.lex_state = 3, .external_lex_state = 4},
  [2180] = {.lex_state = 0},
  [2181] = {.lex_state = 0, .external_lex_state = 4},
  [2182] = {.lex_state = 0, .external_lex_state = 4},
  [2183] = {.lex_state = 0, .external_lex_state = 4},
  [2184] = {.lex_state = 0, .external_lex_state = 4},
  [2185] = {.lex_state = 0, .external_lex_state = 4},
  [2186] = {.lex_state = 0, .external_lex_state = 4},
  [2187] = {.lex_state = 3},
  [2188] = {.lex_state = 0, .external_lex_state = 4},
  [2189] = {.lex_state = 0, .external_lex_state = 4},
  [2190] = {.lex_state = 3, .external_lex_state = 4},
  [2191] = {.lex_state = 3},
  [2192] = {.lex_state = 3},
  [2193] = {.lex_state = 0, .external_lex_state = 4},
  [2194] = {.lex_state = 3, .external_lex_state = 4},
  [2195] = {.lex_state = 3},
  [2196] = {.lex_state = 3},
  [2197] = {.lex_state = 0, .external_lex_state = 4},
  [2198] = {.lex_state = 10},
  [2199] = {.lex_state = 0},
  [2200] = {.lex_state = 3},
  [2201] = {.lex_state = 3},
  [2202] = {.lex_state = 0, .external_lex_state = 4},
  [2203] = {.lex_state = 0, .external_lex_state = 4},
  [2204] = {.lex_state = 0, .external_lex_state = 4},
  [2205] = {.lex_state = 0, .external_lex_state = 4},
  [2206] = {.lex_state = 3},
  [2207] = {.lex_state = 3},
  [2208] = {.lex_state = 0, .external_lex_state = 4},
  [2209] = {.lex_state = 0, .external_lex_state = 4},
  [2210] = {.lex_state = 0, .external_lex_state = 4},
  [2211] = {.lex_state = 3},
  [2212] = {.lex_state = 3},
  [2213] = {.lex_state = 3},
  [2214] = {.lex_state = 3},
  [2215] = {.lex_state = 3},
  [2216] = {.lex_state = 0, .external_lex_state = 4},
  [2217] = {.lex_state = 0, .external_lex_state = 4},
  [2218] = {.lex_state = 0, .external_lex_state = 4},
  [2219] = {.lex_state = 0, .external_lex_state = 4},
  [2220] = {.lex_state = 0, .external_lex_state = 4},
  [2221] = {.lex_state = 0, .external_lex_state = 4},
  [2222] = {.lex_state = 0, .external_lex_state = 4},
  [2223] = {.lex_state = 0, .external_lex_state = 4},
  [2224] = {.lex_state = 3},
  [2225] = {.lex_state = 0, .external_lex_state = 4},
  [2226] = {.lex_state = 0, .external_lex_state = 4},
  [2227] = {.lex_state = 0, .external_lex_state = 4},
  [2228] = {.lex_state = 0, .external_lex_state = 4},
  [2229] = {.lex_state = 3, .external_lex_state = 4},
  [2230] = {.lex_state = 3},
  [2231] = {.lex_state = 0, .external_lex_state = 4},
  [2232] = {.lex_state = 0, .external_lex_state = 4},
  [2233] = {.lex_state = 3},
  [2234] = {.lex_state = 3},
  [2235] = {.lex_state = 0, .external_lex_state = 4},
  [2236] = {.lex_state = 3},
  [2237] = {.lex_state = 3},
  [2238] = {.lex_state = 0, .external_lex_state = 4},
  [2239] = {.lex_state = 0, .external_lex_state = 4},
  [2240] = {.lex_state = 3},
  [2241] = {.lex_state = 0, .external_lex_state = 4},
  [2242] = {.lex_state = 3, .external_lex_state = 4},
  [2243] = {.lex_state = 3},
  [2244] = {.lex_state = 3},
  [2245] = {.lex_state = 3},
  [2246] = {.lex_state = 17},
  [2247] = {.lex_state = 0, .external_lex_state = 4},
  [2248] = {.lex_state = 0, .external_lex_state = 4},
  [2249] = {.lex_state = 3},
  [2250] = {.lex_state = 0},
  [2251] = {.lex_state = 3},
  [2252] = {.lex_state = 0, .external_lex_state = 4},
  [2253] = {.lex_state = 0, .external_lex_state = 4},
  [2254] = {.lex_state = 3, .external_lex_state = 4},
  [2255] = {.lex_state = 3},
  [2256] = {.lex_state = 3},
  [2257] = {.lex_state = 0},
  [2258] = {.lex_state = 0, .external_lex_state = 4},
  [2259] = {.lex_state = 3},
  [2260] = {.lex_state = 0, .external_lex_state = 4},
  [2261] = {.lex_state = 0, .external_lex_state = 4},
  [2262] = {.lex_state = 0, .external_lex_state = 4},
  [2263] = {.lex_state = 0, .external_lex_state = 4},
  [2264] = {.lex_state = 3, .external_lex_state = 4},
  [2265] = {.lex_state = 0, .external_lex_state = 4},
  [2266] = {.lex_state = 0, .external_lex_state = 4},
  [2267] = {.lex_state = 0, .external_lex_state = 4},
  [2268] = {.lex_state = 0, .external_lex_state = 4},
  [2269] = {.lex_state = 0},
  [2270] = {.lex_state = 0, .external_lex_state = 4},
  [2271] = {.lex_state = 0},
  [2272] = {.lex_state = 0},
  [2273] = {.lex_state = 0, .external_lex_state = 4},
  [2274] = {.lex_state = 0},
  [2275] = {.lex_state = 0, .external_lex_state = 4},
  [2276] = {.lex_state = 3},
  [2277] = {.lex_state = 0, .external_lex_state = 4},
  [2278] = {.lex_state = 0, .external_lex_state = 4},
  [2279] = {.lex_state = 3},
  [2280] = {.lex_state = 3},
  [2281] = {.lex_state = 0, .external_lex_state = 4},
  [2282] = {.lex_state = 0, .external_lex_state = 4},
  [2283] = {.lex_state = 3},
  [2284] = {.lex_state = 0, .external_lex_state = 4},
  [2285] = {.lex_state = 3},
  [2286] = {.lex_state = 0},
  [2287] = {.lex_state = 0, .external_lex_state = 4},
  [2288] = {.lex_state = 0, .external_lex_state = 4},
  [2289] = {.lex_state = 0, .external_lex_state = 4},
  [2290] = {.lex_state = 3},
  [2291] = {.lex_state = 0, .external_lex_state = 4},
  [2292] = {.lex_state = 0},
  [2293] = {.lex_state = 0, .external_lex_state = 4},
  [2294] = {.lex_state = 3},
  [2295] = {.lex_state = 4},
  [2296] = {.lex_state = 6},
  [2297] = {.lex_state = 0},
  [2298] = {.lex_state = 3},
  [2299] = {.lex_state = 3, .external_lex_state = 4},
  [2300] = {.lex_state = 4},
  [2301] = {.lex_state = 3},
  [2302] = {.lex_state = 3},
  [2303] = {.lex_state = 3, .external_lex_state = 4},
  [2304] = {.lex_state = 6},
  [2305] = {.lex_state = 3},
  [2306] = {.lex_state = 3, .external_lex_state = 4},
  [2307] = {.lex_state = 3},
  [2308] = {.lex_state = 6},
  [2309] = {.lex_state = 0, .external_lex_state = 4},
  [2310] = {.lex_state = 4},
  [2311] = {.lex_state = 3, .external_lex_state = 4},
  [2312] = {.lex_state = 3},
  [2313] = {.lex_state = 3},
  [2314] = {.lex_state = 0},
  [2315] = {.lex_state = 6},
  [2316] = {.lex_state = 3, .external_lex_state = 4},
  [2317] = {.lex_state = 4},
  [2318] = {.lex_state = 6},
  [2319] = {.lex_state = 4},
  [2320] = {.lex_state = 6},
  [2321] = {.lex_state = 4},
  [2322] = {.lex_state = 3, .external_lex_state = 4},
  [2323] = {.lex_state = 3, .external_lex_state = 4},
  [2324] = {.lex_state = 3},
  [2325] = {.lex_state = 3},
  [2326] = {.lex_state = 0},
  [2327] = {.lex_state = 0, .external_lex_state = 4},
  [2328] = {.lex_state = 3, .external_lex_state = 4},
  [2329] = {.lex_state = 3},
  [2330] = {.lex_state = 3, .external_lex_state = 4},
  [2331] = {.lex_state = 3, .external_lex_state = 4},
  [2332] = {.lex_state = 0},
  [2333] = {.lex_state = 4},
  [2334] = {.lex_state = 3},
  [2335] = {.lex_state = 3},
  [2336] = {.lex_state = 0},
  [2337] = {.lex_state = 3},
  [2338] = {.lex_state = 0},
  [2339] = {.lex_state = 6},
  [2340] = {.lex_state = 3, .external_lex_state = 4},
  [2341] = {.lex_state = 3},
  [2342] = {.lex_state = 6},
  [2343] = {.lex_state = 6},
  [2344] = {.lex_state = 4},
  [2345] = {.lex_state = 3},
  [2346] = {.lex_state = 21, .external_lex_state = 5},
  [2347] = {.lex_state = 3},
  [2348] = {.lex_state = 4},
  [2349] = {.lex_state = 0},
  [2350] = {.lex_state = 0},
  [2351] = {.lex_state = 0},
  [2352] = {.lex_state = 3, .external_lex_state = 4},
  [2353] = {.lex_state = 3},
  [2354] = {.lex_state = 0, .external_lex_state = 4},
  [2355] = {.lex_state = 0},
  [2356] = {.lex_state = 0, .external_lex_state = 4},
  [2357] = {.lex_state = 4},
  [2358] = {.lex_state = 0},
  [2359] = {.lex_state = 6},
  [2360] = {.lex_state = 3, .external_lex_state = 4},
  [2361] = {.lex_state = 0},
  [2362] = {.lex_state = 0, .external_lex_state = 4},
  [2363] = {.lex_state = 0, .external_lex_state = 4},
  [2364] = {.lex_state = 4},
  [2365] = {.lex_state = 6},
  [2366] = {.lex_state = 4},
  [2367] = {.lex_state = 6},
  [2368] = {.lex_state = 3, .external_lex_state = 4},
  [2369] = {.lex_state = 3},
  [2370] = {.lex_state = 3},
  [2371] = {.lex_state = 3},
  [2372] = {.lex_state = 3},
  [2373] = {.lex_state = 3},
  [2374] = {.lex_state = 0},
  [2375] = {.lex_state = 3},
  [2376] = {.lex_state = 0, .external_lex_state = 4},
  [2377] = {.lex_state = 3},
  [2378] = {.lex_state = 0, .external_lex_state = 4},
  [2379] = {.lex_state = 3},
  [2380] = {.lex_state = 6},
  [2381] = {.lex_state = 4},
  [2382] = {.lex_state = 3},
  [2383] = {.lex_state = 0},
  [2384] = {.lex_state = 3},
  [2385] = {.lex_state = 0},
  [2386] = {.lex_state = 0},
  [2387] = {.lex_state = 0},
  [2388] = {.lex_state = 0},
  [2389] = {.lex_state = 3},
  [2390] = {.lex_state = 3},
  [2391] = {.lex_state = 0, .external_lex_state = 4},
  [2392] = {.lex_state = 0},
  [2393] = {.lex_state = 3},
  [2394] = {.lex_state = 3},
  [2395] = {.lex_state = 0},
  [2396] = {.lex_state = 0},
  [2397] = {.lex_state = 0, .external_lex_state = 4},
  [2398] = {.lex_state = 0},
  [2399] = {.lex_state = 3},
  [2400] = {.lex_state = 3, .external_lex_state = 4},
  [2401] = {.lex_state = 0},
  [2402] = {.lex_state = 0},
  [2403] = {.lex_state = 0},
  [2404] = {.lex_state = 3},
  [2405] = {.lex_state = 3},
  [2406] = {.lex_state = 3},
  [2407] = {.lex_state = 0},
  [2408] = {.lex_state = 0},
  [2409] = {.lex_state = 3},
  [2410] = {.lex_state = 0, .external_lex_state = 4},
  [2411] = {.lex_state = 0},
  [2412] = {.lex_state = 3},
  [2413] = {.lex_state = 0},
  [2414] = {.lex_state = 0},
  [2415] = {.lex_state = 0, .external_lex_state = 4},
  [2416] = {.lex_state = 0},
  [2417] = {.lex_state = 3},
  [2418] = {.lex_state = 3},
  [2419] = {.lex_state = 0, .external_lex_state = 4},
  [2420] = {.lex_state = 0},
  [2421] = {.lex_state = 0},
  [2422] = {.lex_state = 0},
  [2423] = {.lex_state = 0},
  [2424] = {.lex_state = 0, .external_lex_state = 4},
  [2425] = {.lex_state = 0, .external_lex_state = 4},
  [2426] = {.lex_state = 0},
  [2427] = {.lex_state = 0, .external_lex_state = 4},
  [2428] = {.lex_state = 0, .external_lex_state = 4},
  [2429] = {.lex_state = 0, .external_lex_state = 4},
  [2430] = {.lex_state = 3},
  [2431] = {.lex_state = 0},
  [2432] = {.lex_state = 0},
  [2433] = {.lex_state = 0, .external_lex_state = 4},
  [2434] = {.lex_state = 0},
  [2435] = {.lex_state = 0},
  [2436] = {.lex_state = 0},
  [2437] = {.lex_state = 0},
  [2438] = {.lex_state = 3},
  [2439] = {.lex_state = 3},
  [2440] = {.lex_state = 0},
  [2441] = {.lex_state = 0, .external_lex_state = 4},
  [2442] = {.lex_state = 0},
  [2443] = {.lex_state = 0, .external_lex_state = 4},
  [2444] = {.lex_state = 3, .external_lex_state = 4},
  [2445] = {.lex_state = 0},
  [2446] = {.lex_state = 0, .external_lex_state = 4},
  [2447] = {.lex_state = 0},
  [2448] = {.lex_state = 10},
  [2449] = {.lex_state = 0},
  [2450] = {.lex_state = 0},
  [2451] = {.lex_state = 0, .external_lex_state = 4},
  [2452] = {.lex_state = 0},
  [2453] = {.lex_state = 10},
  [2454] = {.lex_state = 0},
  [2455] = {.lex_state = 0, .external_lex_state = 4},
  [2456] = {.lex_state = 0},
  [2457] = {.lex_state = 0},
  [2458] = {.lex_state = 0, .external_lex_state = 4},
  [2459] = {.lex_state = 0},
  [2460] = {.lex_state = 0, .external_lex_state = 4},
  [2461] = {.lex_state = 0},
  [2462] = {.lex_state = 3},
  [2463] = {.lex_state = 3},
  [2464] = {.lex_state = 0},
  [2465] = {.lex_state = 0, .external_lex_state = 4},
  [2466] = {.lex_state = 3},
  [2467] = {.lex_state = 3},
  [2468] = {.lex_state = 0},
  [2469] = {.lex_state = 3},
  [2470] = {.lex_state = 3},
  [2471] = {.lex_state = 0},
  [2472] = {.lex_state = 3},
  [2473] = {.lex_state = 3, .external_lex_state = 4},
  [2474] = {.lex_state = 3},
  [2475] = {.lex_state = 0},
  [2476] = {.lex_state = 3},
  [2477] = {.lex_state = 3},
  [2478] = {.lex_state = 0},
  [2479] = {.lex_state = 0},
  [2480] = {.lex_state = 0},
  [2481] = {.lex_state = 0},
  [2482] = {.lex_state = 0, .external_lex_state = 4},
  [2483] = {.lex_state = 0, .external_lex_state = 4},
  [2484] = {.lex_state = 0},
  [2485] = {.lex_state = 0, .external_lex_state = 4},
  [2486] = {.lex_state = 0},
  [2487] = {.lex_state = 0},
  [2488] = {.lex_state = 3},
  [2489] = {.lex_state = 3},
  [2490] = {.lex_state = 3, .external_lex_state = 4},
  [2491] = {.lex_state = 3},
  [2492] = {.lex_state = 0},
  [2493] = {.lex_state = 0},
  [2494] = {.lex_state = 3},
  [2495] = {.lex_state = 0},
  [2496] = {.lex_state = 0, .external_lex_state = 4},
  [2497] = {.lex_state = 3},
  [2498] = {.lex_state = 0},
  [2499] = {.lex_state = 0, .external_lex_state = 4},
  [2500] = {.lex_state = 0},
  [2501] = {.lex_state = 3},
  [2502] = {.lex_state = 0, .external_lex_state = 4},
  [2503] = {.lex_state = 0},
  [2504] = {.lex_state = 0},
  [2505] = {.lex_state = 0, .external_lex_state = 4},
  [2506] = {.lex_state = 3},
  [2507] = {.lex_state = 0},
  [2508] = {.lex_state = 0},
  [2509] = {.lex_state = 3, .external_lex_state = 4},
  [2510] = {.lex_state = 0},
  [2511] = {.lex_state = 0},
  [2512] = {.lex_state = 0},
  [2513] = {.lex_state = 3},
  [2514] = {.lex_state = 0},
  [2515] = {.lex_state = 0},
  [2516] = {.lex_state = 3},
  [2517] = {.lex_state = 3},
  [2518] = {.lex_state = 0},
  [2519] = {.lex_state = 0, .external_lex_state = 4},
  [2520] = {.lex_state = 0},
  [2521] = {.lex_state = 0},
  [2522] = {.lex_state = 0},
  [2523] = {.lex_state = 3},
  [2524] = {.lex_state = 0, .external_lex_state = 4},
  [2525] = {.lex_state = 0},
  [2526] = {.lex_state = 0},
  [2527] = {.lex_state = 0},
  [2528] = {.lex_state = 3, .external_lex_state = 4},
  [2529] = {.lex_state = 3},
  [2530] = {.lex_state = 0},
  [2531] = {.lex_state = 0},
  [2532] = {.lex_state = 0},
  [2533] = {.lex_state = 0, .external_lex_state = 4},
  [2534] = {.lex_state = 3},
  [2535] = {.lex_state = 0},
  [2536] = {.lex_state = 0},
  [2537] = {.lex_state = 0},
  [2538] = {.lex_state = 0},
  [2539] = {.lex_state = 0},
  [2540] = {.lex_state = 0, .external_lex_state = 4},
  [2541] = {.lex_state = 0},
  [2542] = {.lex_state = 3},
  [2543] = {.lex_state = 3},
  [2544] = {.lex_state = 3},
  [2545] = {.lex_state = 3},
  [2546] = {.lex_state = 3},
  [2547] = {.lex_state = 0},
  [2548] = {.lex_state = 3},
  [2549] = {.lex_state = 3},
  [2550] = {.lex_state = 0, .external_lex_state = 4},
  [2551] = {.lex_state = 0},
  [2552] = {.lex_state = 0},
  [2553] = {.lex_state = 3},
  [2554] = {.lex_state = 0},
  [2555] = {.lex_state = 0},
  [2556] = {.lex_state = 0},
  [2557] = {.lex_state = 0},
  [2558] = {.lex_state = 0},
  [2559] = {.lex_state = 0, .external_lex_state = 4},
  [2560] = {.lex_state = 3, .external_lex_state = 4},
  [2561] = {.lex_state = 10},
  [2562] = {.lex_state = 3},
  [2563] = {.lex_state = 0},
  [2564] = {.lex_state = 0},
  [2565] = {.lex_state = 0},
  [2566] = {.lex_state = 0},
  [2567] = {.lex_state = 3},
  [2568] = {.lex_state = 0},
  [2569] = {.lex_state = 0},
  [2570] = {.lex_state = 3},
  [2571] = {.lex_state = 3},
  [2572] = {.lex_state = 0},
  [2573] = {.lex_state = 3},
  [2574] = {.lex_state = 3},
  [2575] = {.lex_state = 3},
  [2576] = {.lex_state = 0},
  [2577] = {.lex_state = 3},
  [2578] = {.lex_state = 3},
  [2579] = {.lex_state = 0},
  [2580] = {.lex_state = 0},
  [2581] = {.lex_state = 3},
  [2582] = {.lex_state = 0},
  [2583] = {.lex_state = 3},
  [2584] = {.lex_state = 3},
  [2585] = {.lex_state = 3},
  [2586] = {.lex_state = 0},
  [2587] = {.lex_state = 3},
  [2588] = {.lex_state = 0},
  [2589] = {.lex_state = 3},
  [2590] = {.lex_state = 0, .external_lex_state = 4},
  [2591] = {.lex_state = 3},
  [2592] = {.lex_state = 0, .external_lex_state = 4},
  [2593] = {.lex_state = 0, .external_lex_state = 4},
  [2594] = {.lex_state = 3},
  [2595] = {.lex_state = 3},
  [2596] = {.lex_state = 0},
  [2597] = {.lex_state = 0},
  [2598] = {.lex_state = 3},
  [2599] = {.lex_state = 3},
  [2600] = {.lex_state = 3},
  [2601] = {.lex_state = 0},
  [2602] = {.lex_state = 3},
  [2603] = {.lex_state = 3},
  [2604] = {.lex_state = 3},
  [2605] = {.lex_state = 3},
  [2606] = {.lex_state = 3},
  [2607] = {.lex_state = 0},
  [2608] = {.lex_state = 3},
  [2609] = {.lex_state = 0, .external_lex_state = 4},
  [2610] = {.lex_state = 3},
  [2611] = {.lex_state = 0},
  [2612] = {.lex_state = 0},
  [2613] = {.lex_state = 3},
  [2614] = {.lex_state = 3},
  [2615] = {.lex_state = 0, .external_lex_state = 4},
  [2616] = {.lex_state = 3},
  [2617] = {.lex_state = 3},
  [2618] = {.lex_state = 3},
  [2619] = {.lex_state = 3},
  [2620] = {.lex_state = 0},
  [2621] = {.lex_state = 0},
  [2622] = {.lex_state = 3},
  [2623] = {.lex_state = 0},
  [2624] = {.lex_state = 3},
  [2625] = {.lex_state = 3},
  [2626] = {.lex_state = 3},
  [2627] = {.lex_state = 3},
  [2628] = {.lex_state = 3},
  [2629] = {.lex_state = 0},
  [2630] = {.lex_state = 3},
  [2631] = {.lex_state = 0, .external_lex_state = 4},
  [2632] = {.lex_state = 0},
  [2633] = {.lex_state = 0},
  [2634] = {.lex_state = 3},
  [2635] = {.lex_state = 0},
  [2636] = {.lex_state = 3},
  [2637] = {.lex_state = 0, .external_lex_state = 4},
  [2638] = {.lex_state = 3},
  [2639] = {.lex_state = 0},
  [2640] = {.lex_state = 3},
  [2641] = {.lex_state = 0},
  [2642] = {.lex_state = 3},
  [2643] = {.lex_state = 0},
  [2644] = {.lex_state = 3},
  [2645] = {.lex_state = 3},
  [2646] = {.lex_state = 0},
  [2647] = {.lex_state = 3},
  [2648] = {.lex_state = 3},
  [2649] = {.lex_state = 0, .external_lex_state = 4},
  [2650] = {.lex_state = 3},
  [2651] = {.lex_state = 3},
  [2652] = {.lex_state = 3},
  [2653] = {.lex_state = 3},
  [2654] = {.lex_state = 0},
  [2655] = {.lex_state = 3},
  [2656] = {.lex_state = 3},
  [2657] = {.lex_state = 3},
  [2658] = {.lex_state = 0},
  [2659] = {.lex_state = 0},
  [2660] = {.lex_state = 0},
  [2661] = {.lex_state = 0},
  [2662] = {.lex_state = 3},
  [2663] = {.lex_state = 0},
  [2664] = {.lex_state = 3},
  [2665] = {.lex_state = 3},
  [2666] = {.lex_state = 3},
  [2667] = {.lex_state = 0},
  [2668] = {.lex_state = 3},
  [2669] = {.lex_state = 0, .external_lex_state = 4},
  [2670] = {.lex_state = 3},
  [2671] = {.lex_state = 3},
  [2672] = {.lex_state = 3},
  [2673] = {.lex_state = 3},
  [2674] = {.lex_state = 3},
  [2675] = {.lex_state = 3},
  [2676] = {.lex_state = 3},
  [2677] = {.lex_state = 0, .external_lex_state = 4},
  [2678] = {.lex_state = 0},
  [2679] = {.lex_state = 3},
  [2680] = {.lex_state = 0},
  [2681] = {.lex_state = 0},
  [2682] = {.lex_state = 3},
  [2683] = {.lex_state = 3},
  [2684] = {.lex_state = 3},
  [2685] = {.lex_state = 3},
  [2686] = {.lex_state = 3},
  [2687] = {.lex_state = 3},
  [2688] = {.lex_state = 3},
  [2689] = {.lex_state = 0},
  [2690] = {.lex_state = 0},
  [2691] = {.lex_state = 3},
  [2692] = {.lex_state = 0, .external_lex_state = 4},
  [2693] = {.lex_state = 3},
  [2694] = {.lex_state = 3},
  [2695] = {.lex_state = 3},
  [2696] = {.lex_state = 3},
  [2697] = {.lex_state = 0},
  [2698] = {.lex_state = 3},
  [2699] = {.lex_state = 3},
  [2700] = {.lex_state = 3},
  [2701] = {.lex_state = 0},
  [2702] = {.lex_state = 3},
  [2703] = {.lex_state = 3},
  [2704] = {.lex_state = 0},
  [2705] = {.lex_state = 0, .external_lex_state = 4},
  [2706] = {.lex_state = 0, .external_lex_state = 4},
  [2707] = {.lex_state = 3},
  [2708] = {.lex_state = 0, .external_lex_state = 4},
  [2709] = {.lex_state = 3},
  [2710] = {.lex_state = 0, .external_lex_state = 4},
  [2711] = {.lex_state = 3},
  [2712] = {.lex_state = 3},
  [2713] = {.lex_state = 3},
  [2714] = {.lex_state = 3},
  [2715] = {.lex_state = 3},
  [2716] = {.lex_state = 3},
  [2717] = {.lex_state = 0},
  [2718] = {.lex_state = 0},
  [2719] = {.lex_state = 3},
  [2720] = {.lex_state = 3},
  [2721] = {.lex_state = 3},
  [2722] = {.lex_state = 3},
  [2723] = {.lex_state = 3},
  [2724] = {.lex_state = 3},
  [2725] = {.lex_state = 3},
  [2726] = {.lex_state = 0},
  [2727] = {.lex_state = 3},
  [2728] = {.lex_state = 3},
  [2729] = {.lex_state = 3},
  [2730] = {.lex_state = 3},
  [2731] = {.lex_state = 3},
  [2732] = {.lex_state = 3},
  [2733] = {.lex_state = 0},
  [2734] = {.lex_state = 3},
  [2735] = {.lex_state = 3},
  [2736] = {.lex_state = 3},
  [2737] = {.lex_state = 3},
  [2738] = {.lex_state = 0, .external_lex_state = 4},
  [2739] = {.lex_state = 3},
  [2740] = {.lex_state = 3},
  [2741] = {.lex_state = 0},
  [2742] = {.lex_state = 0},
  [2743] = {.lex_state = 3},
  [2744] = {.lex_state = 3},
  [2745] = {.lex_state = 0, .external_lex_state = 4},
  [2746] = {.lex_state = 3},
  [2747] = {.lex_state = 3},
  [2748] = {.lex_state = 0},
  [2749] = {.lex_state = 0},
  [2750] = {.lex_state = 3},
  [2751] = {.lex_state = 0},
  [2752] = {.lex_state = 0},
  [2753] = {.lex_state = 3},
  [2754] = {.lex_state = 3},
  [2755] = {.lex_state = 0},
  [2756] = {.lex_state = 0},
  [2757] = {.lex_state = 0},
  [2758] = {.lex_state = 3},
  [2759] = {.lex_state = 0},
  [2760] = {.lex_state = 3},
  [2761] = {.lex_state = 3},
  [2762] = {.lex_state = 0},
  [2763] = {.lex_state = 3},
  [2764] = {.lex_state = 3},
  [2765] = {.lex_state = 0},
  [2766] = {.lex_state = 0, .external_lex_state = 4},
  [2767] = {.lex_state = 0},
  [2768] = {.lex_state = 0, .external_lex_state = 4},
  [2769] = {.lex_state = 3},
  [2770] = {.lex_state = 3},
  [2771] = {.lex_state = 0},
  [2772] = {.lex_state = 0},
  [2773] = {.lex_state = 3},
  [2774] = {.lex_state = 0},
  [2775] = {.lex_state = 18},
  [2776] = {.lex_state = 0},
  [2777] = {.lex_state = 0},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 3},
  [2780] = {.lex_state = 3},
  [2781] = {.lex_state = 3},
  [2782] = {.lex_state = 3},
  [2783] = {.lex_state = 3},
  [2784] = {.lex_state = 3},
  [2785] = {.lex_state = 3},
  [2786] = {.lex_state = 3},
  [2787] = {.lex_state = 0},
  [2788] = {.lex_state = 3},
  [2789] = {.lex_state = 0},
  [2790] = {.lex_state = 0},
  [2791] = {.lex_state = 3},
  [2792] = {.lex_state = 0},
  [2793] = {.lex_state = 3},
  [2794] = {.lex_state = 0},
  [2795] = {.lex_state = 3},
  [2796] = {.lex_state = 3},
  [2797] = {.lex_state = 3},
  [2798] = {.lex_state = 3},
  [2799] = {.lex_state = 0},
  [2800] = {.lex_state = 0},
  [2801] = {.lex_state = 0},
  [2802] = {.lex_state = 0},
  [2803] = {.lex_state = 3},
  [2804] = {.lex_state = 0},
  [2805] = {.lex_state = 3},
  [2806] = {.lex_state = 8},
  [2807] = {.lex_state = 0},
  [2808] = {.lex_state = 8},
  [2809] = {.lex_state = 3},
  [2810] = {.lex_state = 3},
  [2811] = {.lex_state = 3},
  [2812] = {.lex_state = 0},
  [2813] = {.lex_state = 3},
  [2814] = {.lex_state = 3},
  [2815] = {.lex_state = 3},
  [2816] = {.lex_state = 3},
  [2817] = {.lex_state = 3},
  [2818] = {.lex_state = 3},
  [2819] = {.lex_state = 3},
  [2820] = {.lex_state = 0},
  [2821] = {.lex_state = 0},
  [2822] = {.lex_state = 3},
  [2823] = {.lex_state = 0},
  [2824] = {.lex_state = 0},
  [2825] = {.lex_state = 0},
  [2826] = {.lex_state = 3},
  [2827] = {.lex_state = 0},
  [2828] = {.lex_state = 3},
  [2829] = {.lex_state = 3},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 3},
  [2832] = {.lex_state = 3},
  [2833] = {.lex_state = 3},
  [2834] = {.lex_state = 0},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 3},
  [2838] = {.lex_state = 3},
  [2839] = {.lex_state = 0},
  [2840] = {.lex_state = 0},
  [2841] = {.lex_state = 3},
  [2842] = {.lex_state = 0},
  [2843] = {.lex_state = 0},
  [2844] = {.lex_state = 0},
  [2845] = {.lex_state = 0},
  [2846] = {.lex_state = 0},
  [2847] = {.lex_state = 3},
  [2848] = {.lex_state = 3},
  [2849] = {.lex_state = 0},
  [2850] = {.lex_state = 0},
  [2851] = {.lex_state = 0},
  [2852] = {.lex_state = 3},
  [2853] = {.lex_state = 0},
  [2854] = {.lex_state = 0},
  [2855] = {.lex_state = 3},
  [2856] = {.lex_state = 18},
  [2857] = {.lex_state = 0},
  [2858] = {.lex_state = 0},
  [2859] = {.lex_state = 0},
  [2860] = {.lex_state = 0},
  [2861] = {.lex_state = 0},
  [2862] = {.lex_state = 0},
  [2863] = {.lex_state = 3},
  [2864] = {.lex_state = 0},
  [2865] = {.lex_state = 3},
  [2866] = {.lex_state = 3},
  [2867] = {.lex_state = 3},
  [2868] = {.lex_state = 0},
  [2869] = {.lex_state = 3},
  [2870] = {.lex_state = 3},
  [2871] = {.lex_state = 0},
  [2872] = {.lex_state = 0},
  [2873] = {.lex_state = 0},
  [2874] = {.lex_state = 0},
  [2875] = {.lex_state = 3},
  [2876] = {.lex_state = 8},
  [2877] = {.lex_state = 3},
  [2878] = {.lex_state = 0},
  [2879] = {.lex_state = 0},
  [2880] = {.lex_state = 0},
  [2881] = {.lex_state = 0},
  [2882] = {.lex_state = 3},
  [2883] = {.lex_state = 3},
  [2884] = {.lex_state = 3},
  [2885] = {.lex_state = 0},
  [2886] = {.lex_state = 0},
  [2887] = {.lex_state = 3},
  [2888] = {.lex_state = 0},
  [2889] = {.lex_state = 3},
  [2890] = {.lex_state = 3},
  [2891] = {.lex_state = 0},
  [2892] = {.lex_state = 0},
  [2893] = {.lex_state = 0},
  [2894] = {.lex_state = 0},
  [2895] = {.lex_state = 18},
  [2896] = {.lex_state = 0},
  [2897] = {.lex_state = 0},
  [2898] = {.lex_state = 0},
  [2899] = {.lex_state = 0},
  [2900] = {.lex_state = 3},
  [2901] = {.lex_state = 0},
  [2902] = {.lex_state = 3},
  [2903] = {.lex_state = 0},
  [2904] = {.lex_state = 0},
  [2905] = {.lex_state = 3},
  [2906] = {.lex_state = 0},
  [2907] = {.lex_state = 0},
  [2908] = {.lex_state = 3},
  [2909] = {.lex_state = 0},
  [2910] = {.lex_state = 3},
  [2911] = {.lex_state = 0},
  [2912] = {.lex_state = 3},
  [2913] = {.lex_state = 0},
  [2914] = {.lex_state = 0},
  [2915] = {.lex_state = 0},
  [2916] = {.lex_state = 3},
  [2917] = {.lex_state = 0},
  [2918] = {.lex_state = 0},
  [2919] = {.lex_state = 0},
  [2920] = {.lex_state = 0},
  [2921] = {.lex_state = 0},
  [2922] = {.lex_state = 3},
  [2923] = {.lex_state = 0},
  [2924] = {.lex_state = 0},
  [2925] = {.lex_state = 0},
  [2926] = {.lex_state = 0},
  [2927] = {.lex_state = 0},
  [2928] = {.lex_state = 0},
  [2929] = {.lex_state = 3},
  [2930] = {.lex_state = 0},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 3},
  [2933] = {.lex_state = 3},
  [2934] = {.lex_state = 3},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 0},
  [2937] = {.lex_state = 0},
  [2938] = {.lex_state = 18},
  [2939] = {.lex_state = 0},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 0},
  [2942] = {.lex_state = 0},
  [2943] = {.lex_state = 3},
  [2944] = {.lex_state = 3},
  [2945] = {.lex_state = 3},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 3},
  [2948] = {.lex_state = 0},
  [2949] = {.lex_state = 3},
  [2950] = {.lex_state = 8},
  [2951] = {.lex_state = 0},
  [2952] = {.lex_state = 3},
  [2953] = {.lex_state = 3},
  [2954] = {.lex_state = 3},
  [2955] = {.lex_state = 0},
  [2956] = {.lex_state = 3},
  [2957] = {.lex_state = 3},
  [2958] = {.lex_state = 0},
  [2959] = {.lex_state = 3},
  [2960] = {.lex_state = 3},
  [2961] = {.lex_state = 3},
  [2962] = {.lex_state = 3},
  [2963] = {.lex_state = 0},
  [2964] = {.lex_state = 3},
  [2965] = {.lex_state = 3},
  [2966] = {.lex_state = 3},
  [2967] = {.lex_state = 3},
  [2968] = {.lex_state = 0},
  [2969] = {.lex_state = 3},
  [2970] = {.lex_state = 0},
  [2971] = {.lex_state = 3},
  [2972] = {.lex_state = 3},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token_PIPE_PIPE = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(2906),
    [sym_export_statement] = STATE(24),
    [sym__declaration] = STATE(24),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(24),
    [sym_expression_statement] = STATE(24),
    [sym_variable_declaration] = STATE(24),
    [sym_lexical_declaration] = STATE(24),
    [sym_statement_block] = STATE(24),
    [sym_if_statement] = STATE(24),
    [sym_switch_statement] = STATE(24),
    [sym_for_statement] = STATE(24),
    [sym_for_in_statement] = STATE(24),
    [sym_while_statement] = STATE(24),
    [sym_do_statement] = STATE(24),
    [sym_try_statement] = STATE(24),
    [sym_with_statement] = STATE(24),
    [sym_break_statement] = STATE(24),
    [sym_continue_statement] = STATE(24),
    [sym_debugger_statement] = STATE(24),
    [sym_return_statement] = STATE(24),
    [sym_throw_statement] = STATE(24),
    [sym_empty_statement] = STATE(24),
    [sym_labeled_statement] = STATE(24),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(24),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(24),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(24),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(24),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(24),
    [sym_abstract_class_declaration] = STATE(24),
    [sym_module] = STATE(24),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(24),
    [sym_interface_declaration] = STATE(24),
    [sym_enum_declaration] = STATE(24),
    [sym_type_alias_declaration] = STATE(24),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(24),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [2] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(23),
    [sym_lexical_declaration] = STATE(23),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1505),
    [sym_assignment_pattern] = STATE(2500),
    [sym_array] = STATE(1504),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(23),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(23),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(23),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_spread_element] = STATE(2500),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1506),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_method_definition] = STATE(2500),
    [sym_pair] = STATE(2500),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(23),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(23),
    [sym_abstract_class_declaration] = STATE(23),
    [sym_module] = STATE(23),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(23),
    [sym_interface_declaration] = STATE(23),
    [sym_enum_declaration] = STATE(23),
    [sym_type_alias_declaration] = STATE(23),
    [sym_accessibility_modifier] = STATE(1769),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(119),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [3] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(23),
    [sym_lexical_declaration] = STATE(23),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1505),
    [sym_assignment_pattern] = STATE(2500),
    [sym_array] = STATE(1504),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(23),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(23),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(23),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_spread_element] = STATE(2500),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1506),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_method_definition] = STATE(2500),
    [sym_pair] = STATE(2500),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(23),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(23),
    [sym_abstract_class_declaration] = STATE(23),
    [sym_module] = STATE(23),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(23),
    [sym_interface_declaration] = STATE(23),
    [sym_enum_declaration] = STATE(23),
    [sym_type_alias_declaration] = STATE(23),
    [sym_accessibility_modifier] = STATE(1769),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [4] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(20),
    [sym_lexical_declaration] = STATE(20),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1505),
    [sym_assignment_pattern] = STATE(2432),
    [sym_array] = STATE(1504),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(20),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(20),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(20),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_spread_element] = STATE(2432),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1506),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_method_definition] = STATE(2432),
    [sym_pair] = STATE(2432),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(20),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(20),
    [sym_abstract_class_declaration] = STATE(20),
    [sym_module] = STATE(20),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(20),
    [sym_interface_declaration] = STATE(20),
    [sym_enum_declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(20),
    [sym_accessibility_modifier] = STATE(1769),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [aux_sym_object_repeat1] = STATE(2431),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_export] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_type] = ACTIONS(157),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(161),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(163),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(165),
    [anon_sym_set] = ACTIONS(165),
    [anon_sym_declare] = ACTIONS(167),
    [anon_sym_public] = ACTIONS(169),
    [anon_sym_private] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(171),
    [anon_sym_any] = ACTIONS(173),
    [anon_sym_number] = ACTIONS(173),
    [anon_sym_boolean] = ACTIONS(173),
    [anon_sym_string] = ACTIONS(173),
    [anon_sym_symbol] = ACTIONS(173),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(175),
  },
  [5] = {
    [sym_export_statement] = STATE(17),
    [sym__declaration] = STATE(17),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(17),
    [sym_lexical_declaration] = STATE(17),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1505),
    [sym_assignment_pattern] = STATE(2500),
    [sym_array] = STATE(1504),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(17),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(17),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(17),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_spread_element] = STATE(2500),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1506),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_method_definition] = STATE(2500),
    [sym_pair] = STATE(2500),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(17),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(17),
    [sym_abstract_class_declaration] = STATE(17),
    [sym_module] = STATE(17),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(17),
    [sym_interface_declaration] = STATE(17),
    [sym_enum_declaration] = STATE(17),
    [sym_type_alias_declaration] = STATE(17),
    [sym_accessibility_modifier] = STATE(1769),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(177),
    [anon_sym_type] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(125),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(129),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(135),
    [anon_sym_set] = ACTIONS(135),
    [anon_sym_declare] = ACTIONS(137),
    [anon_sym_public] = ACTIONS(139),
    [anon_sym_private] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(139),
    [anon_sym_module] = ACTIONS(141),
    [anon_sym_any] = ACTIONS(143),
    [anon_sym_number] = ACTIONS(143),
    [anon_sym_boolean] = ACTIONS(143),
    [anon_sym_string] = ACTIONS(143),
    [anon_sym_symbol] = ACTIONS(143),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(145),
  },
  [6] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(25),
    [sym_lexical_declaration] = STATE(25),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1505),
    [sym_assignment_pattern] = STATE(2526),
    [sym_array] = STATE(1504),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(25),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(25),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(25),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_spread_element] = STATE(2526),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1506),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_method_definition] = STATE(2526),
    [sym_pair] = STATE(2526),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(25),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(25),
    [sym_abstract_class_declaration] = STATE(25),
    [sym_module] = STATE(25),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(25),
    [sym_accessibility_modifier] = STATE(1769),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [aux_sym_object_repeat1] = STATE(2527),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_export] = ACTIONS(181),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(183),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(185),
    [anon_sym_type] = ACTIONS(187),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(189),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(191),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(131),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(193),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(195),
    [anon_sym_set] = ACTIONS(195),
    [anon_sym_declare] = ACTIONS(197),
    [anon_sym_public] = ACTIONS(199),
    [anon_sym_private] = ACTIONS(199),
    [anon_sym_protected] = ACTIONS(199),
    [anon_sym_module] = ACTIONS(201),
    [anon_sym_any] = ACTIONS(203),
    [anon_sym_number] = ACTIONS(203),
    [anon_sym_boolean] = ACTIONS(203),
    [anon_sym_string] = ACTIONS(203),
    [anon_sym_symbol] = ACTIONS(203),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(205),
  },
  [7] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [ts_builtin_sym_end] = ACTIONS(207),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_export] = ACTIONS(212),
    [anon_sym_default] = ACTIONS(215),
    [anon_sym_namespace] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_type] = ACTIONS(223),
    [anon_sym_typeof] = ACTIONS(226),
    [anon_sym_import] = ACTIONS(229),
    [anon_sym_var] = ACTIONS(232),
    [anon_sym_let] = ACTIONS(235),
    [anon_sym_const] = ACTIONS(238),
    [anon_sym_if] = ACTIONS(241),
    [anon_sym_switch] = ACTIONS(244),
    [anon_sym_for] = ACTIONS(247),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_await] = ACTIONS(253),
    [anon_sym_while] = ACTIONS(256),
    [anon_sym_do] = ACTIONS(259),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_with] = ACTIONS(265),
    [anon_sym_break] = ACTIONS(268),
    [anon_sym_continue] = ACTIONS(271),
    [anon_sym_debugger] = ACTIONS(274),
    [anon_sym_return] = ACTIONS(277),
    [anon_sym_throw] = ACTIONS(280),
    [anon_sym_SEMI] = ACTIONS(283),
    [anon_sym_case] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_LBRACK] = ACTIONS(289),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_SLASH] = ACTIONS(295),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_new] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_BANG] = ACTIONS(313),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_void] = ACTIONS(316),
    [anon_sym_delete] = ACTIONS(226),
    [anon_sym_PLUS_PLUS] = ACTIONS(319),
    [anon_sym_DASH_DASH] = ACTIONS(319),
    [anon_sym_DQUOTE] = ACTIONS(322),
    [anon_sym_SQUOTE] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(328),
    [sym_number] = ACTIONS(331),
    [sym_this] = ACTIONS(334),
    [sym_super] = ACTIONS(337),
    [sym_true] = ACTIONS(334),
    [sym_false] = ACTIONS(334),
    [sym_null] = ACTIONS(334),
    [sym_undefined] = ACTIONS(334),
    [anon_sym_AT] = ACTIONS(340),
    [anon_sym_static] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(346),
    [anon_sym_get] = ACTIONS(343),
    [anon_sym_set] = ACTIONS(343),
    [anon_sym_declare] = ACTIONS(349),
    [anon_sym_public] = ACTIONS(343),
    [anon_sym_private] = ACTIONS(343),
    [anon_sym_protected] = ACTIONS(343),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_any] = ACTIONS(343),
    [anon_sym_number] = ACTIONS(343),
    [anon_sym_boolean] = ACTIONS(343),
    [anon_sym_string] = ACTIONS(343),
    [anon_sym_symbol] = ACTIONS(343),
    [anon_sym_interface] = ACTIONS(355),
    [anon_sym_enum] = ACTIONS(358),
    [sym_readonly] = ACTIONS(343),
  },
  [8] = {
    [sym_export_statement] = STATE(11),
    [sym__declaration] = STATE(11),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(11),
    [sym_lexical_declaration] = STATE(11),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(11),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(11),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(11),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(11),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(11),
    [sym_abstract_class_declaration] = STATE(11),
    [sym_module] = STATE(11),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(11),
    [sym_interface_declaration] = STATE(11),
    [sym_enum_declaration] = STATE(11),
    [sym_type_alias_declaration] = STATE(11),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(361),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [9] = {
    [sym_export_statement] = STATE(10),
    [sym__declaration] = STATE(10),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(10),
    [sym_expression_statement] = STATE(10),
    [sym_variable_declaration] = STATE(10),
    [sym_lexical_declaration] = STATE(10),
    [sym_statement_block] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_switch_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_for_in_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_do_statement] = STATE(10),
    [sym_try_statement] = STATE(10),
    [sym_with_statement] = STATE(10),
    [sym_break_statement] = STATE(10),
    [sym_continue_statement] = STATE(10),
    [sym_debugger_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_throw_statement] = STATE(10),
    [sym_empty_statement] = STATE(10),
    [sym_labeled_statement] = STATE(10),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(10),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(10),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(10),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(10),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(10),
    [sym_abstract_class_declaration] = STATE(10),
    [sym_module] = STATE(10),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(10),
    [sym_interface_declaration] = STATE(10),
    [sym_enum_declaration] = STATE(10),
    [sym_type_alias_declaration] = STATE(10),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [10] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [11] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(373),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_case] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [12] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [13] = {
    [sym_export_statement] = STATE(15),
    [sym__declaration] = STATE(15),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(15),
    [sym_expression_statement] = STATE(15),
    [sym_variable_declaration] = STATE(15),
    [sym_lexical_declaration] = STATE(15),
    [sym_statement_block] = STATE(15),
    [sym_if_statement] = STATE(15),
    [sym_switch_statement] = STATE(15),
    [sym_for_statement] = STATE(15),
    [sym_for_in_statement] = STATE(15),
    [sym_while_statement] = STATE(15),
    [sym_do_statement] = STATE(15),
    [sym_try_statement] = STATE(15),
    [sym_with_statement] = STATE(15),
    [sym_break_statement] = STATE(15),
    [sym_continue_statement] = STATE(15),
    [sym_debugger_statement] = STATE(15),
    [sym_return_statement] = STATE(15),
    [sym_throw_statement] = STATE(15),
    [sym_empty_statement] = STATE(15),
    [sym_labeled_statement] = STATE(15),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(15),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(15),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(15),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(15),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(15),
    [sym_abstract_class_declaration] = STATE(15),
    [sym_module] = STATE(15),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(15),
    [sym_interface_declaration] = STATE(15),
    [sym_enum_declaration] = STATE(15),
    [sym_type_alias_declaration] = STATE(15),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(15),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [14] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [ts_builtin_sym_end] = ACTIONS(381),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [15] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [16] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(14),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(14),
    [sym_abstract_class_declaration] = STATE(14),
    [sym_module] = STATE(14),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(14),
    [sym_interface_declaration] = STATE(14),
    [sym_enum_declaration] = STATE(14),
    [sym_type_alias_declaration] = STATE(14),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [ts_builtin_sym_end] = ACTIONS(385),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [17] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [18] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(23),
    [sym_lexical_declaration] = STATE(23),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(23),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(23),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(23),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(23),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(23),
    [sym_abstract_class_declaration] = STATE(23),
    [sym_module] = STATE(23),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(23),
    [sym_interface_declaration] = STATE(23),
    [sym_enum_declaration] = STATE(23),
    [sym_type_alias_declaration] = STATE(23),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [19] = {
    [sym_export_statement] = STATE(17),
    [sym__declaration] = STATE(17),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(17),
    [sym_lexical_declaration] = STATE(17),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(17),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(17),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(17),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(17),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(17),
    [sym_abstract_class_declaration] = STATE(17),
    [sym_module] = STATE(17),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(17),
    [sym_interface_declaration] = STATE(17),
    [sym_enum_declaration] = STATE(17),
    [sym_type_alias_declaration] = STATE(17),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [20] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [21] = {
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(22),
    [sym_lexical_declaration] = STATE(22),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(22),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(22),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(22),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(22),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(22),
    [sym_abstract_class_declaration] = STATE(22),
    [sym_module] = STATE(22),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(22),
    [sym_interface_declaration] = STATE(22),
    [sym_enum_declaration] = STATE(22),
    [sym_type_alias_declaration] = STATE(22),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [22] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [23] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [24] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [ts_builtin_sym_end] = ACTIONS(385),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [25] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(7),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(7),
    [sym_abstract_class_declaration] = STATE(7),
    [sym_module] = STATE(7),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(7),
    [sym_interface_declaration] = STATE(7),
    [sym_enum_declaration] = STATE(7),
    [sym_type_alias_declaration] = STATE(7),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [26] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(12),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(12),
    [sym_abstract_class_declaration] = STATE(12),
    [sym_module] = STATE(12),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(12),
    [sym_interface_declaration] = STATE(12),
    [sym_enum_declaration] = STATE(12),
    [sym_type_alias_declaration] = STATE(12),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [27] = {
    [sym_export_statement] = STATE(20),
    [sym__declaration] = STATE(20),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(20),
    [sym_expression_statement] = STATE(20),
    [sym_variable_declaration] = STATE(20),
    [sym_lexical_declaration] = STATE(20),
    [sym_statement_block] = STATE(20),
    [sym_if_statement] = STATE(20),
    [sym_switch_statement] = STATE(20),
    [sym_for_statement] = STATE(20),
    [sym_for_in_statement] = STATE(20),
    [sym_while_statement] = STATE(20),
    [sym_do_statement] = STATE(20),
    [sym_try_statement] = STATE(20),
    [sym_with_statement] = STATE(20),
    [sym_break_statement] = STATE(20),
    [sym_continue_statement] = STATE(20),
    [sym_debugger_statement] = STATE(20),
    [sym_return_statement] = STATE(20),
    [sym_throw_statement] = STATE(20),
    [sym_empty_statement] = STATE(20),
    [sym_labeled_statement] = STATE(20),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(20),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(20),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(20),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(20),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(20),
    [sym_abstract_class_declaration] = STATE(20),
    [sym_module] = STATE(20),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(20),
    [sym_interface_declaration] = STATE(20),
    [sym_enum_declaration] = STATE(20),
    [sym_type_alias_declaration] = STATE(20),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(20),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [28] = {
    [sym_export_statement] = STATE(25),
    [sym__declaration] = STATE(25),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(25),
    [sym_lexical_declaration] = STATE(25),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(25),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(25),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(25),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(25),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(25),
    [sym_abstract_class_declaration] = STATE(25),
    [sym_module] = STATE(25),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(25),
    [sym_interface_declaration] = STATE(25),
    [sym_enum_declaration] = STATE(25),
    [sym_type_alias_declaration] = STATE(25),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_program_repeat1] = STATE(25),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [29] = {
    [sym_export_statement] = STATE(555),
    [sym__declaration] = STATE(555),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(555),
    [sym_expression_statement] = STATE(555),
    [sym_variable_declaration] = STATE(555),
    [sym_lexical_declaration] = STATE(555),
    [sym_statement_block] = STATE(555),
    [sym_if_statement] = STATE(555),
    [sym_switch_statement] = STATE(555),
    [sym_for_statement] = STATE(555),
    [sym_for_in_statement] = STATE(555),
    [sym_while_statement] = STATE(555),
    [sym_do_statement] = STATE(555),
    [sym_try_statement] = STATE(555),
    [sym_with_statement] = STATE(555),
    [sym_break_statement] = STATE(555),
    [sym_continue_statement] = STATE(555),
    [sym_debugger_statement] = STATE(555),
    [sym_return_statement] = STATE(555),
    [sym_throw_statement] = STATE(555),
    [sym_empty_statement] = STATE(555),
    [sym_labeled_statement] = STATE(555),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(555),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(555),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(555),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(555),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(555),
    [sym_abstract_class_declaration] = STATE(555),
    [sym_module] = STATE(555),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(555),
    [sym_interface_declaration] = STATE(555),
    [sym_enum_declaration] = STATE(555),
    [sym_type_alias_declaration] = STATE(555),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [30] = {
    [sym_export_statement] = STATE(558),
    [sym__declaration] = STATE(558),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(558),
    [sym_expression_statement] = STATE(558),
    [sym_variable_declaration] = STATE(558),
    [sym_lexical_declaration] = STATE(558),
    [sym_statement_block] = STATE(558),
    [sym_if_statement] = STATE(558),
    [sym_switch_statement] = STATE(558),
    [sym_for_statement] = STATE(558),
    [sym_for_in_statement] = STATE(558),
    [sym_while_statement] = STATE(558),
    [sym_do_statement] = STATE(558),
    [sym_try_statement] = STATE(558),
    [sym_with_statement] = STATE(558),
    [sym_break_statement] = STATE(558),
    [sym_continue_statement] = STATE(558),
    [sym_debugger_statement] = STATE(558),
    [sym_return_statement] = STATE(558),
    [sym_throw_statement] = STATE(558),
    [sym_empty_statement] = STATE(558),
    [sym_labeled_statement] = STATE(558),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(558),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(558),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(558),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(558),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(558),
    [sym_abstract_class_declaration] = STATE(558),
    [sym_module] = STATE(558),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(558),
    [sym_interface_declaration] = STATE(558),
    [sym_enum_declaration] = STATE(558),
    [sym_type_alias_declaration] = STATE(558),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [31] = {
    [sym_export_statement] = STATE(521),
    [sym__declaration] = STATE(521),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(521),
    [sym_expression_statement] = STATE(521),
    [sym_variable_declaration] = STATE(521),
    [sym_lexical_declaration] = STATE(521),
    [sym_statement_block] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_switch_statement] = STATE(521),
    [sym_for_statement] = STATE(521),
    [sym_for_in_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_do_statement] = STATE(521),
    [sym_try_statement] = STATE(521),
    [sym_with_statement] = STATE(521),
    [sym_break_statement] = STATE(521),
    [sym_continue_statement] = STATE(521),
    [sym_debugger_statement] = STATE(521),
    [sym_return_statement] = STATE(521),
    [sym_throw_statement] = STATE(521),
    [sym_empty_statement] = STATE(521),
    [sym_labeled_statement] = STATE(521),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(521),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(521),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(521),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(521),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(521),
    [sym_abstract_class_declaration] = STATE(521),
    [sym_module] = STATE(521),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(521),
    [sym_interface_declaration] = STATE(521),
    [sym_enum_declaration] = STATE(521),
    [sym_type_alias_declaration] = STATE(521),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [32] = {
    [sym_export_statement] = STATE(555),
    [sym__declaration] = STATE(555),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(555),
    [sym_expression_statement] = STATE(555),
    [sym_variable_declaration] = STATE(555),
    [sym_lexical_declaration] = STATE(555),
    [sym_statement_block] = STATE(555),
    [sym_if_statement] = STATE(555),
    [sym_switch_statement] = STATE(555),
    [sym_for_statement] = STATE(555),
    [sym_for_in_statement] = STATE(555),
    [sym_while_statement] = STATE(555),
    [sym_do_statement] = STATE(555),
    [sym_try_statement] = STATE(555),
    [sym_with_statement] = STATE(555),
    [sym_break_statement] = STATE(555),
    [sym_continue_statement] = STATE(555),
    [sym_debugger_statement] = STATE(555),
    [sym_return_statement] = STATE(555),
    [sym_throw_statement] = STATE(555),
    [sym_empty_statement] = STATE(555),
    [sym_labeled_statement] = STATE(555),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(555),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(555),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(555),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(555),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(555),
    [sym_abstract_class_declaration] = STATE(555),
    [sym_module] = STATE(555),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(555),
    [sym_interface_declaration] = STATE(555),
    [sym_enum_declaration] = STATE(555),
    [sym_type_alias_declaration] = STATE(555),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [33] = {
    [sym_export_statement] = STATE(558),
    [sym__declaration] = STATE(558),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(558),
    [sym_expression_statement] = STATE(558),
    [sym_variable_declaration] = STATE(558),
    [sym_lexical_declaration] = STATE(558),
    [sym_statement_block] = STATE(558),
    [sym_if_statement] = STATE(558),
    [sym_switch_statement] = STATE(558),
    [sym_for_statement] = STATE(558),
    [sym_for_in_statement] = STATE(558),
    [sym_while_statement] = STATE(558),
    [sym_do_statement] = STATE(558),
    [sym_try_statement] = STATE(558),
    [sym_with_statement] = STATE(558),
    [sym_break_statement] = STATE(558),
    [sym_continue_statement] = STATE(558),
    [sym_debugger_statement] = STATE(558),
    [sym_return_statement] = STATE(558),
    [sym_throw_statement] = STATE(558),
    [sym_empty_statement] = STATE(558),
    [sym_labeled_statement] = STATE(558),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(558),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(558),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(558),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(558),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(558),
    [sym_abstract_class_declaration] = STATE(558),
    [sym_module] = STATE(558),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(558),
    [sym_interface_declaration] = STATE(558),
    [sym_enum_declaration] = STATE(558),
    [sym_type_alias_declaration] = STATE(558),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [34] = {
    [sym_export_statement] = STATE(564),
    [sym__declaration] = STATE(564),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(564),
    [sym_expression_statement] = STATE(564),
    [sym_variable_declaration] = STATE(564),
    [sym_lexical_declaration] = STATE(564),
    [sym_statement_block] = STATE(564),
    [sym_if_statement] = STATE(564),
    [sym_switch_statement] = STATE(564),
    [sym_for_statement] = STATE(564),
    [sym_for_in_statement] = STATE(564),
    [sym_while_statement] = STATE(564),
    [sym_do_statement] = STATE(564),
    [sym_try_statement] = STATE(564),
    [sym_with_statement] = STATE(564),
    [sym_break_statement] = STATE(564),
    [sym_continue_statement] = STATE(564),
    [sym_debugger_statement] = STATE(564),
    [sym_return_statement] = STATE(564),
    [sym_throw_statement] = STATE(564),
    [sym_empty_statement] = STATE(564),
    [sym_labeled_statement] = STATE(564),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(564),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(564),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(564),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(564),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(564),
    [sym_abstract_class_declaration] = STATE(564),
    [sym_module] = STATE(564),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(564),
    [sym_interface_declaration] = STATE(564),
    [sym_enum_declaration] = STATE(564),
    [sym_type_alias_declaration] = STATE(564),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [35] = {
    [sym_export_statement] = STATE(564),
    [sym__declaration] = STATE(564),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(564),
    [sym_expression_statement] = STATE(564),
    [sym_variable_declaration] = STATE(564),
    [sym_lexical_declaration] = STATE(564),
    [sym_statement_block] = STATE(564),
    [sym_if_statement] = STATE(564),
    [sym_switch_statement] = STATE(564),
    [sym_for_statement] = STATE(564),
    [sym_for_in_statement] = STATE(564),
    [sym_while_statement] = STATE(564),
    [sym_do_statement] = STATE(564),
    [sym_try_statement] = STATE(564),
    [sym_with_statement] = STATE(564),
    [sym_break_statement] = STATE(564),
    [sym_continue_statement] = STATE(564),
    [sym_debugger_statement] = STATE(564),
    [sym_return_statement] = STATE(564),
    [sym_throw_statement] = STATE(564),
    [sym_empty_statement] = STATE(564),
    [sym_labeled_statement] = STATE(564),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(564),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(564),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(564),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(564),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(564),
    [sym_abstract_class_declaration] = STATE(564),
    [sym_module] = STATE(564),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(564),
    [sym_interface_declaration] = STATE(564),
    [sym_enum_declaration] = STATE(564),
    [sym_type_alias_declaration] = STATE(564),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [36] = {
    [sym_export_statement] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(511),
    [sym_expression_statement] = STATE(511),
    [sym_variable_declaration] = STATE(511),
    [sym_lexical_declaration] = STATE(511),
    [sym_statement_block] = STATE(511),
    [sym_if_statement] = STATE(511),
    [sym_switch_statement] = STATE(511),
    [sym_for_statement] = STATE(511),
    [sym_for_in_statement] = STATE(511),
    [sym_while_statement] = STATE(511),
    [sym_do_statement] = STATE(511),
    [sym_try_statement] = STATE(511),
    [sym_with_statement] = STATE(511),
    [sym_break_statement] = STATE(511),
    [sym_continue_statement] = STATE(511),
    [sym_debugger_statement] = STATE(511),
    [sym_return_statement] = STATE(511),
    [sym_throw_statement] = STATE(511),
    [sym_empty_statement] = STATE(511),
    [sym_labeled_statement] = STATE(511),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(511),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(511),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(511),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(511),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(511),
    [sym_abstract_class_declaration] = STATE(511),
    [sym_module] = STATE(511),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(511),
    [sym_interface_declaration] = STATE(511),
    [sym_enum_declaration] = STATE(511),
    [sym_type_alias_declaration] = STATE(511),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [37] = {
    [sym_export_statement] = STATE(519),
    [sym__declaration] = STATE(519),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(519),
    [sym_expression_statement] = STATE(519),
    [sym_variable_declaration] = STATE(519),
    [sym_lexical_declaration] = STATE(519),
    [sym_statement_block] = STATE(519),
    [sym_if_statement] = STATE(519),
    [sym_switch_statement] = STATE(519),
    [sym_for_statement] = STATE(519),
    [sym_for_in_statement] = STATE(519),
    [sym_while_statement] = STATE(519),
    [sym_do_statement] = STATE(519),
    [sym_try_statement] = STATE(519),
    [sym_with_statement] = STATE(519),
    [sym_break_statement] = STATE(519),
    [sym_continue_statement] = STATE(519),
    [sym_debugger_statement] = STATE(519),
    [sym_return_statement] = STATE(519),
    [sym_throw_statement] = STATE(519),
    [sym_empty_statement] = STATE(519),
    [sym_labeled_statement] = STATE(519),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(519),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(519),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(519),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(519),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(519),
    [sym_abstract_class_declaration] = STATE(519),
    [sym_module] = STATE(519),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(519),
    [sym_interface_declaration] = STATE(519),
    [sym_enum_declaration] = STATE(519),
    [sym_type_alias_declaration] = STATE(519),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [38] = {
    [sym_export_statement] = STATE(539),
    [sym__declaration] = STATE(539),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_variable_declaration] = STATE(539),
    [sym_lexical_declaration] = STATE(539),
    [sym_statement_block] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_for_in_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_with_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_debugger_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_empty_statement] = STATE(539),
    [sym_labeled_statement] = STATE(539),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(539),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(539),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(539),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(539),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(539),
    [sym_abstract_class_declaration] = STATE(539),
    [sym_module] = STATE(539),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(539),
    [sym_interface_declaration] = STATE(539),
    [sym_enum_declaration] = STATE(539),
    [sym_type_alias_declaration] = STATE(539),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [39] = {
    [sym_export_statement] = STATE(2702),
    [sym__declaration] = STATE(2702),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(2702),
    [sym_expression_statement] = STATE(2702),
    [sym_variable_declaration] = STATE(2702),
    [sym_lexical_declaration] = STATE(2702),
    [sym_statement_block] = STATE(2702),
    [sym_if_statement] = STATE(2702),
    [sym_switch_statement] = STATE(2702),
    [sym_for_statement] = STATE(2702),
    [sym_for_in_statement] = STATE(2702),
    [sym_while_statement] = STATE(2702),
    [sym_do_statement] = STATE(2702),
    [sym_try_statement] = STATE(2702),
    [sym_with_statement] = STATE(2702),
    [sym_break_statement] = STATE(2702),
    [sym_continue_statement] = STATE(2702),
    [sym_debugger_statement] = STATE(2702),
    [sym_return_statement] = STATE(2702),
    [sym_throw_statement] = STATE(2702),
    [sym_empty_statement] = STATE(2702),
    [sym_labeled_statement] = STATE(2702),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(2702),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(2702),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(2702),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(2702),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(2702),
    [sym_abstract_class_declaration] = STATE(2702),
    [sym_module] = STATE(2702),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(2702),
    [sym_interface_declaration] = STATE(2702),
    [sym_enum_declaration] = STATE(2702),
    [sym_type_alias_declaration] = STATE(2702),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [40] = {
    [sym_export_statement] = STATE(569),
    [sym__declaration] = STATE(569),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(569),
    [sym_expression_statement] = STATE(569),
    [sym_variable_declaration] = STATE(569),
    [sym_lexical_declaration] = STATE(569),
    [sym_statement_block] = STATE(569),
    [sym_if_statement] = STATE(569),
    [sym_switch_statement] = STATE(569),
    [sym_for_statement] = STATE(569),
    [sym_for_in_statement] = STATE(569),
    [sym_while_statement] = STATE(569),
    [sym_do_statement] = STATE(569),
    [sym_try_statement] = STATE(569),
    [sym_with_statement] = STATE(569),
    [sym_break_statement] = STATE(569),
    [sym_continue_statement] = STATE(569),
    [sym_debugger_statement] = STATE(569),
    [sym_return_statement] = STATE(569),
    [sym_throw_statement] = STATE(569),
    [sym_empty_statement] = STATE(569),
    [sym_labeled_statement] = STATE(569),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(569),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(569),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(569),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(569),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(569),
    [sym_abstract_class_declaration] = STATE(569),
    [sym_module] = STATE(569),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(569),
    [sym_interface_declaration] = STATE(569),
    [sym_enum_declaration] = STATE(569),
    [sym_type_alias_declaration] = STATE(569),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [41] = {
    [sym_export_statement] = STATE(521),
    [sym__declaration] = STATE(521),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(521),
    [sym_expression_statement] = STATE(521),
    [sym_variable_declaration] = STATE(521),
    [sym_lexical_declaration] = STATE(521),
    [sym_statement_block] = STATE(521),
    [sym_if_statement] = STATE(521),
    [sym_switch_statement] = STATE(521),
    [sym_for_statement] = STATE(521),
    [sym_for_in_statement] = STATE(521),
    [sym_while_statement] = STATE(521),
    [sym_do_statement] = STATE(521),
    [sym_try_statement] = STATE(521),
    [sym_with_statement] = STATE(521),
    [sym_break_statement] = STATE(521),
    [sym_continue_statement] = STATE(521),
    [sym_debugger_statement] = STATE(521),
    [sym_return_statement] = STATE(521),
    [sym_throw_statement] = STATE(521),
    [sym_empty_statement] = STATE(521),
    [sym_labeled_statement] = STATE(521),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(521),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(521),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(521),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(521),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(521),
    [sym_abstract_class_declaration] = STATE(521),
    [sym_module] = STATE(521),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(521),
    [sym_interface_declaration] = STATE(521),
    [sym_enum_declaration] = STATE(521),
    [sym_type_alias_declaration] = STATE(521),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [42] = {
    [sym_export_statement] = STATE(519),
    [sym__declaration] = STATE(519),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(519),
    [sym_expression_statement] = STATE(519),
    [sym_variable_declaration] = STATE(519),
    [sym_lexical_declaration] = STATE(519),
    [sym_statement_block] = STATE(519),
    [sym_if_statement] = STATE(519),
    [sym_switch_statement] = STATE(519),
    [sym_for_statement] = STATE(519),
    [sym_for_in_statement] = STATE(519),
    [sym_while_statement] = STATE(519),
    [sym_do_statement] = STATE(519),
    [sym_try_statement] = STATE(519),
    [sym_with_statement] = STATE(519),
    [sym_break_statement] = STATE(519),
    [sym_continue_statement] = STATE(519),
    [sym_debugger_statement] = STATE(519),
    [sym_return_statement] = STATE(519),
    [sym_throw_statement] = STATE(519),
    [sym_empty_statement] = STATE(519),
    [sym_labeled_statement] = STATE(519),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(519),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(519),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(519),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(519),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(519),
    [sym_abstract_class_declaration] = STATE(519),
    [sym_module] = STATE(519),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(519),
    [sym_interface_declaration] = STATE(519),
    [sym_enum_declaration] = STATE(519),
    [sym_type_alias_declaration] = STATE(519),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [43] = {
    [sym_export_statement] = STATE(543),
    [sym__declaration] = STATE(543),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(543),
    [sym_expression_statement] = STATE(543),
    [sym_variable_declaration] = STATE(543),
    [sym_lexical_declaration] = STATE(543),
    [sym_statement_block] = STATE(543),
    [sym_if_statement] = STATE(543),
    [sym_switch_statement] = STATE(543),
    [sym_for_statement] = STATE(543),
    [sym_for_in_statement] = STATE(543),
    [sym_while_statement] = STATE(543),
    [sym_do_statement] = STATE(543),
    [sym_try_statement] = STATE(543),
    [sym_with_statement] = STATE(543),
    [sym_break_statement] = STATE(543),
    [sym_continue_statement] = STATE(543),
    [sym_debugger_statement] = STATE(543),
    [sym_return_statement] = STATE(543),
    [sym_throw_statement] = STATE(543),
    [sym_empty_statement] = STATE(543),
    [sym_labeled_statement] = STATE(543),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(543),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(543),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(543),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(543),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(543),
    [sym_abstract_class_declaration] = STATE(543),
    [sym_module] = STATE(543),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(543),
    [sym_interface_declaration] = STATE(543),
    [sym_enum_declaration] = STATE(543),
    [sym_type_alias_declaration] = STATE(543),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [44] = {
    [sym_export_statement] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(511),
    [sym_expression_statement] = STATE(511),
    [sym_variable_declaration] = STATE(511),
    [sym_lexical_declaration] = STATE(511),
    [sym_statement_block] = STATE(511),
    [sym_if_statement] = STATE(511),
    [sym_switch_statement] = STATE(511),
    [sym_for_statement] = STATE(511),
    [sym_for_in_statement] = STATE(511),
    [sym_while_statement] = STATE(511),
    [sym_do_statement] = STATE(511),
    [sym_try_statement] = STATE(511),
    [sym_with_statement] = STATE(511),
    [sym_break_statement] = STATE(511),
    [sym_continue_statement] = STATE(511),
    [sym_debugger_statement] = STATE(511),
    [sym_return_statement] = STATE(511),
    [sym_throw_statement] = STATE(511),
    [sym_empty_statement] = STATE(511),
    [sym_labeled_statement] = STATE(511),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(511),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(511),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(511),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(511),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(511),
    [sym_abstract_class_declaration] = STATE(511),
    [sym_module] = STATE(511),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(511),
    [sym_interface_declaration] = STATE(511),
    [sym_enum_declaration] = STATE(511),
    [sym_type_alias_declaration] = STATE(511),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [45] = {
    [sym_export_statement] = STATE(543),
    [sym__declaration] = STATE(543),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(543),
    [sym_expression_statement] = STATE(543),
    [sym_variable_declaration] = STATE(543),
    [sym_lexical_declaration] = STATE(543),
    [sym_statement_block] = STATE(543),
    [sym_if_statement] = STATE(543),
    [sym_switch_statement] = STATE(543),
    [sym_for_statement] = STATE(543),
    [sym_for_in_statement] = STATE(543),
    [sym_while_statement] = STATE(543),
    [sym_do_statement] = STATE(543),
    [sym_try_statement] = STATE(543),
    [sym_with_statement] = STATE(543),
    [sym_break_statement] = STATE(543),
    [sym_continue_statement] = STATE(543),
    [sym_debugger_statement] = STATE(543),
    [sym_return_statement] = STATE(543),
    [sym_throw_statement] = STATE(543),
    [sym_empty_statement] = STATE(543),
    [sym_labeled_statement] = STATE(543),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(543),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(543),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(543),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(543),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(543),
    [sym_abstract_class_declaration] = STATE(543),
    [sym_module] = STATE(543),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(543),
    [sym_interface_declaration] = STATE(543),
    [sym_enum_declaration] = STATE(543),
    [sym_type_alias_declaration] = STATE(543),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [46] = {
    [sym_export_statement] = STATE(539),
    [sym__declaration] = STATE(539),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_variable_declaration] = STATE(539),
    [sym_lexical_declaration] = STATE(539),
    [sym_statement_block] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_for_in_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_with_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_debugger_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_empty_statement] = STATE(539),
    [sym_labeled_statement] = STATE(539),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(539),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(539),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(539),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(539),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(539),
    [sym_abstract_class_declaration] = STATE(539),
    [sym_module] = STATE(539),
    [sym_internal_module] = STATE(112),
    [sym_import_alias] = STATE(539),
    [sym_interface_declaration] = STATE(539),
    [sym_enum_declaration] = STATE(539),
    [sym_type_alias_declaration] = STATE(539),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2096),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_type] = ACTIONS(17),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(45),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(67),
    [anon_sym_async] = ACTIONS(69),
    [anon_sym_function] = ACTIONS(71),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(79),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(97),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(97),
    [anon_sym_set] = ACTIONS(97),
    [anon_sym_declare] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(97),
    [anon_sym_private] = ACTIONS(97),
    [anon_sym_protected] = ACTIONS(97),
    [anon_sym_module] = ACTIONS(103),
    [anon_sym_any] = ACTIONS(97),
    [anon_sym_number] = ACTIONS(97),
    [anon_sym_boolean] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(97),
    [anon_sym_symbol] = ACTIONS(97),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(97),
  },
  [47] = {
    [sym_export_statement] = STATE(2781),
    [sym__declaration] = STATE(2781),
    [sym_import] = STATE(1148),
    [sym_import_statement] = STATE(2781),
    [sym_expression_statement] = STATE(2781),
    [sym_variable_declaration] = STATE(2781),
    [sym_lexical_declaration] = STATE(2781),
    [sym_statement_block] = STATE(2781),
    [sym_if_statement] = STATE(2781),
    [sym_switch_statement] = STATE(2781),
    [sym_for_statement] = STATE(2781),
    [sym_for_in_statement] = STATE(2781),
    [sym_while_statement] = STATE(2781),
    [sym_do_statement] = STATE(2781),
    [sym_try_statement] = STATE(2781),
    [sym_with_statement] = STATE(2781),
    [sym_break_statement] = STATE(2781),
    [sym_continue_statement] = STATE(2781),
    [sym_debugger_statement] = STATE(2781),
    [sym_return_statement] = STATE(2781),
    [sym_throw_statement] = STATE(2781),
    [sym_empty_statement] = STATE(2781),
    [sym_labeled_statement] = STATE(2781),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_class_declaration] = STATE(2781),
    [sym_function] = STATE(1004),
    [sym_function_declaration] = STATE(2781),
    [sym_generator_function] = STATE(1148),
    [sym_generator_function_declaration] = STATE(2781),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_function_signature] = STATE(2781),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_ambient_declaration] = STATE(2781),
    [sym_abstract_class_declaration] = STATE(2781),
    [sym_module] = STATE(2781),
    [sym_internal_module] = STATE(1261),
    [sym_import_alias] = STATE(2781),
    [sym_interface_declaration] = STATE(2781),
    [sym_enum_declaration] = STATE(2781),
    [sym_type_alias_declaration] = STATE(2781),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2251),
    [sym_identifier] = ACTIONS(409),
    [anon_sym_export] = ACTIONS(411),
    [anon_sym_namespace] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(21),
    [anon_sym_var] = ACTIONS(23),
    [anon_sym_let] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(31),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(41),
    [anon_sym_try] = ACTIONS(43),
    [anon_sym_with] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_continue] = ACTIONS(49),
    [anon_sym_debugger] = ACTIONS(51),
    [anon_sym_return] = ACTIONS(53),
    [anon_sym_throw] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(431),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(433),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(99),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(437),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_interface] = ACTIONS(105),
    [anon_sym_enum] = ACTIONS(107),
    [sym_readonly] = ACTIONS(435),
  },
  [48] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [49] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_arguments] = STATE(1108),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(499),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [50] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [51] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [52] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [53] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [54] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_arguments] = STATE(1440),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [55] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_PIPE_RBRACE] = ACTIONS(589),
    [sym__automatic_semicolon] = ACTIONS(589),
  },
  [56] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [57] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [58] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [59] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [60] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [61] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [62] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_arguments] = STATE(1108),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [anon_sym_implements] = ACTIONS(491),
    [sym_readonly] = ACTIONS(489),
  },
  [63] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_arguments] = STATE(1440),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [64] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_arguments] = STATE(1108),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(499),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [65] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [66] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_arguments] = STATE(1568),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(620),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [67] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(626),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [68] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [69] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [70] = {
    [sym_import] = STATE(1301),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1301),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1301),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1301),
    [sym_arrow_function] = STATE(1301),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1301),
    [sym_new_expression] = STATE(1301),
    [sym_await_expression] = STATE(1301),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1301),
    [sym_augmented_assignment_expression] = STATE(1301),
    [sym_ternary_expression] = STATE(1301),
    [sym_binary_expression] = STATE(1301),
    [sym_unary_expression] = STATE(1301),
    [sym_update_expression] = STATE(1301),
    [sym_string] = STATE(1301),
    [sym_template_string] = STATE(1301),
    [sym_regex] = STATE(1301),
    [sym_meta_property] = STATE(1301),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1301),
    [sym_type_assertion] = STATE(1301),
    [sym_as_expression] = STATE(1301),
    [sym_internal_module] = STATE(1301),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(650),
    [anon_sym_STAR_EQ] = ACTIONS(650),
    [anon_sym_SLASH_EQ] = ACTIONS(650),
    [anon_sym_PERCENT_EQ] = ACTIONS(650),
    [anon_sym_CARET_EQ] = ACTIONS(650),
    [anon_sym_AMP_EQ] = ACTIONS(650),
    [anon_sym_PIPE_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_LT_LT_EQ] = ACTIONS(650),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(662),
    [sym_this] = ACTIONS(664),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(664),
    [sym_false] = ACTIONS(664),
    [sym_null] = ACTIONS(664),
    [sym_undefined] = ACTIONS(664),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [71] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1222),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1222),
    [sym_arrow_function] = STATE(1222),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1222),
    [sym_new_expression] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_string] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1222),
    [sym_type_assertion] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(620),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(716),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_undefined] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [72] = {
    [sym_import] = STATE(1165),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1165),
    [sym_yield_expression] = STATE(1165),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1165),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1165),
    [sym_arrow_function] = STATE(1165),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1165),
    [sym_new_expression] = STATE(1165),
    [sym_await_expression] = STATE(1165),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1165),
    [sym_augmented_assignment_expression] = STATE(1165),
    [sym_ternary_expression] = STATE(1165),
    [sym_binary_expression] = STATE(1165),
    [sym_unary_expression] = STATE(1165),
    [sym_update_expression] = STATE(1165),
    [sym_string] = STATE(1165),
    [sym_template_string] = STATE(1165),
    [sym_regex] = STATE(1165),
    [sym_meta_property] = STATE(1165),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1165),
    [sym_as_expression] = STATE(1165),
    [sym_internal_module] = STATE(1165),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(754),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_undefined] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [anon_sym_implements] = ACTIONS(445),
    [sym_readonly] = ACTIONS(724),
  },
  [73] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(626),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [74] = {
    [sym_import] = STATE(1301),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1301),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1301),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1301),
    [sym_arrow_function] = STATE(1301),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1301),
    [sym_new_expression] = STATE(1301),
    [sym_await_expression] = STATE(1301),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1301),
    [sym_augmented_assignment_expression] = STATE(1301),
    [sym_ternary_expression] = STATE(1301),
    [sym_binary_expression] = STATE(1301),
    [sym_unary_expression] = STATE(1301),
    [sym_update_expression] = STATE(1301),
    [sym_string] = STATE(1301),
    [sym_template_string] = STATE(1301),
    [sym_regex] = STATE(1301),
    [sym_meta_property] = STATE(1301),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1301),
    [sym_type_assertion] = STATE(1301),
    [sym_as_expression] = STATE(1301),
    [sym_internal_module] = STATE(1301),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS_EQ] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(650),
    [anon_sym_STAR_EQ] = ACTIONS(650),
    [anon_sym_SLASH_EQ] = ACTIONS(650),
    [anon_sym_PERCENT_EQ] = ACTIONS(650),
    [anon_sym_CARET_EQ] = ACTIONS(650),
    [anon_sym_AMP_EQ] = ACTIONS(650),
    [anon_sym_PIPE_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_LT_LT_EQ] = ACTIONS(650),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(662),
    [sym_this] = ACTIONS(664),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(664),
    [sym_false] = ACTIONS(664),
    [sym_null] = ACTIONS(664),
    [sym_undefined] = ACTIONS(664),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [75] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(626),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [76] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1222),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1222),
    [sym_arrow_function] = STATE(1222),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1222),
    [sym_new_expression] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_string] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1222),
    [sym_type_assertion] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(620),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(716),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_undefined] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [77] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [78] = {
    [sym_import] = STATE(1165),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1165),
    [sym_yield_expression] = STATE(1165),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1165),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1165),
    [sym_arrow_function] = STATE(1165),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1165),
    [sym_new_expression] = STATE(1165),
    [sym_await_expression] = STATE(1165),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1165),
    [sym_augmented_assignment_expression] = STATE(1165),
    [sym_ternary_expression] = STATE(1165),
    [sym_binary_expression] = STATE(1165),
    [sym_unary_expression] = STATE(1165),
    [sym_update_expression] = STATE(1165),
    [sym_string] = STATE(1165),
    [sym_template_string] = STATE(1165),
    [sym_regex] = STATE(1165),
    [sym_meta_property] = STATE(1165),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1165),
    [sym_as_expression] = STATE(1165),
    [sym_internal_module] = STATE(1165),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(754),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_undefined] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [anon_sym_implements] = ACTIONS(445),
    [sym_readonly] = ACTIONS(724),
  },
  [79] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(626),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [80] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_of] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(626),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [81] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1496),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(990),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_sequence_expression] = STATE(2898),
    [sym_string] = STATE(1610),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_rest_parameter] = STATE(2461),
    [sym_non_null_expression] = STATE(990),
    [sym_type_assertion] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_nested_type_identifier] = STATE(1805),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym__type] = STATE(2406),
    [sym_constructor_type] = STATE(2406),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2406),
    [sym_intersection_type] = STATE(2406),
    [sym_function_type] = STATE(2406),
    [aux_sym_export_statement_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(795),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(803),
    [sym_undefined] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(805),
    [anon_sym_private] = ACTIONS(805),
    [anon_sym_protected] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(807),
    [anon_sym_number] = ACTIONS(807),
    [anon_sym_boolean] = ACTIONS(807),
    [anon_sym_string] = ACTIONS(807),
    [anon_sym_symbol] = ACTIONS(807),
    [sym_readonly] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [82] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1496),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(990),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_sequence_expression] = STATE(2898),
    [sym_string] = STATE(1610),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_rest_parameter] = STATE(2461),
    [sym_non_null_expression] = STATE(990),
    [sym_type_assertion] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_nested_type_identifier] = STATE(1805),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym__type] = STATE(2404),
    [sym_constructor_type] = STATE(2404),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2404),
    [sym_intersection_type] = STATE(2404),
    [sym_function_type] = STATE(2404),
    [aux_sym_export_statement_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(795),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(803),
    [sym_undefined] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(805),
    [anon_sym_private] = ACTIONS(805),
    [anon_sym_protected] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(807),
    [anon_sym_number] = ACTIONS(807),
    [anon_sym_boolean] = ACTIONS(807),
    [anon_sym_string] = ACTIONS(807),
    [anon_sym_symbol] = ACTIONS(807),
    [sym_readonly] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [83] = {
    [sym_import] = STATE(1096),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1096),
    [sym_yield_expression] = STATE(1096),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1496),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1096),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1096),
    [sym_arrow_function] = STATE(1096),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1096),
    [sym_new_expression] = STATE(1096),
    [sym_await_expression] = STATE(1096),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1096),
    [sym_augmented_assignment_expression] = STATE(1096),
    [sym_ternary_expression] = STATE(1096),
    [sym_binary_expression] = STATE(1096),
    [sym_unary_expression] = STATE(1096),
    [sym_update_expression] = STATE(1096),
    [sym_sequence_expression] = STATE(2845),
    [sym_string] = STATE(1610),
    [sym_template_string] = STATE(1096),
    [sym_regex] = STATE(1096),
    [sym_meta_property] = STATE(1096),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_rest_parameter] = STATE(2461),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1096),
    [sym_as_expression] = STATE(1096),
    [sym_internal_module] = STATE(1096),
    [sym_nested_type_identifier] = STATE(1805),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym__type] = STATE(2404),
    [sym_constructor_type] = STATE(2404),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2404),
    [sym_intersection_type] = STATE(2404),
    [sym_function_type] = STATE(2404),
    [aux_sym_export_statement_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(795),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(815),
    [sym_undefined] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(805),
    [anon_sym_private] = ACTIONS(805),
    [anon_sym_protected] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(807),
    [anon_sym_number] = ACTIONS(807),
    [anon_sym_boolean] = ACTIONS(807),
    [anon_sym_string] = ACTIONS(807),
    [anon_sym_symbol] = ACTIONS(807),
    [sym_readonly] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [84] = {
    [sym_import] = STATE(1027),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1027),
    [sym_yield_expression] = STATE(1027),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1496),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1027),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1027),
    [sym_arrow_function] = STATE(1027),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1027),
    [sym_new_expression] = STATE(1027),
    [sym_await_expression] = STATE(1027),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1027),
    [sym_augmented_assignment_expression] = STATE(1027),
    [sym_ternary_expression] = STATE(1027),
    [sym_binary_expression] = STATE(1027),
    [sym_unary_expression] = STATE(1027),
    [sym_update_expression] = STATE(1027),
    [sym_sequence_expression] = STATE(2787),
    [sym_string] = STATE(1610),
    [sym_template_string] = STATE(1027),
    [sym_regex] = STATE(1027),
    [sym_meta_property] = STATE(1027),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_rest_parameter] = STATE(2461),
    [sym_non_null_expression] = STATE(1027),
    [sym_type_assertion] = STATE(1027),
    [sym_as_expression] = STATE(1027),
    [sym_internal_module] = STATE(1027),
    [sym_nested_type_identifier] = STATE(1805),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym__type] = STATE(2404),
    [sym_constructor_type] = STATE(2404),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2404),
    [sym_intersection_type] = STATE(2404),
    [sym_function_type] = STATE(2404),
    [aux_sym_export_statement_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(763),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(795),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(797),
    [sym_this] = ACTIONS(799),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(817),
    [sym_undefined] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(805),
    [anon_sym_private] = ACTIONS(805),
    [anon_sym_protected] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(807),
    [anon_sym_number] = ACTIONS(807),
    [anon_sym_boolean] = ACTIONS(807),
    [anon_sym_string] = ACTIONS(807),
    [anon_sym_symbol] = ACTIONS(807),
    [sym_readonly] = ACTIONS(809),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [85] = {
    [sym_import] = STATE(1139),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1139),
    [sym_yield_expression] = STATE(1139),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1139),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1139),
    [sym_arrow_function] = STATE(1139),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1139),
    [sym_new_expression] = STATE(1139),
    [sym_await_expression] = STATE(1139),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1139),
    [sym_augmented_assignment_expression] = STATE(1139),
    [sym_spread_element] = STATE(2414),
    [sym_ternary_expression] = STATE(1139),
    [sym_binary_expression] = STATE(1139),
    [sym_unary_expression] = STATE(1139),
    [sym_update_expression] = STATE(1139),
    [sym_string] = STATE(1672),
    [sym_template_string] = STATE(1139),
    [sym_regex] = STATE(1139),
    [sym_meta_property] = STATE(1139),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1139),
    [sym_type_assertion] = STATE(1139),
    [sym_as_expression] = STATE(1139),
    [sym_internal_module] = STATE(1139),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2111),
    [sym_constructor_type] = STATE(2111),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2111),
    [sym_intersection_type] = STATE(2111),
    [sym_function_type] = STATE(2111),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2407),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(825),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(827),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(833),
    [sym_this] = ACTIONS(835),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(837),
    [sym_false] = ACTIONS(837),
    [sym_null] = ACTIONS(839),
    [sym_undefined] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [86] = {
    [sym_import] = STATE(1139),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1139),
    [sym_yield_expression] = STATE(1139),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1139),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1139),
    [sym_arrow_function] = STATE(1139),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1139),
    [sym_new_expression] = STATE(1139),
    [sym_await_expression] = STATE(1139),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1139),
    [sym_augmented_assignment_expression] = STATE(1139),
    [sym_spread_element] = STATE(2414),
    [sym_ternary_expression] = STATE(1139),
    [sym_binary_expression] = STATE(1139),
    [sym_unary_expression] = STATE(1139),
    [sym_update_expression] = STATE(1139),
    [sym_string] = STATE(1672),
    [sym_template_string] = STATE(1139),
    [sym_regex] = STATE(1139),
    [sym_meta_property] = STATE(1139),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1139),
    [sym_type_assertion] = STATE(1139),
    [sym_as_expression] = STATE(1139),
    [sym_internal_module] = STATE(1139),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2097),
    [sym_constructor_type] = STATE(2097),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2097),
    [sym_intersection_type] = STATE(2097),
    [sym_function_type] = STATE(2097),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2407),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(825),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(827),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(833),
    [sym_this] = ACTIONS(835),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(837),
    [sym_false] = ACTIONS(837),
    [sym_null] = ACTIONS(839),
    [sym_undefined] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [87] = {
    [sym_import] = STATE(1185),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1185),
    [sym_yield_expression] = STATE(1185),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1185),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1185),
    [sym_arrow_function] = STATE(1185),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1185),
    [sym_new_expression] = STATE(1185),
    [sym_await_expression] = STATE(1185),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1185),
    [sym_augmented_assignment_expression] = STATE(1185),
    [sym_spread_element] = STATE(2387),
    [sym_ternary_expression] = STATE(1185),
    [sym_binary_expression] = STATE(1185),
    [sym_unary_expression] = STATE(1185),
    [sym_update_expression] = STATE(1185),
    [sym_string] = STATE(1672),
    [sym_template_string] = STATE(1185),
    [sym_regex] = STATE(1185),
    [sym_meta_property] = STATE(1185),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1185),
    [sym_type_assertion] = STATE(1185),
    [sym_as_expression] = STATE(1185),
    [sym_internal_module] = STATE(1185),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2097),
    [sym_constructor_type] = STATE(2097),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2097),
    [sym_intersection_type] = STATE(2097),
    [sym_function_type] = STATE(2097),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2388),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(825),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(833),
    [sym_this] = ACTIONS(835),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(837),
    [sym_false] = ACTIONS(837),
    [sym_null] = ACTIONS(845),
    [sym_undefined] = ACTIONS(845),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [88] = {
    [sym_import] = STATE(1233),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1233),
    [sym_yield_expression] = STATE(1233),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1233),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1233),
    [sym_arrow_function] = STATE(1233),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1233),
    [sym_new_expression] = STATE(1233),
    [sym_await_expression] = STATE(1233),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1233),
    [sym_augmented_assignment_expression] = STATE(1233),
    [sym_spread_element] = STATE(2492),
    [sym_ternary_expression] = STATE(1233),
    [sym_binary_expression] = STATE(1233),
    [sym_unary_expression] = STATE(1233),
    [sym_update_expression] = STATE(1233),
    [sym_string] = STATE(1672),
    [sym_template_string] = STATE(1233),
    [sym_regex] = STATE(1233),
    [sym_meta_property] = STATE(1233),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1233),
    [sym_type_assertion] = STATE(1233),
    [sym_as_expression] = STATE(1233),
    [sym_internal_module] = STATE(1233),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2097),
    [sym_constructor_type] = STATE(2097),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2097),
    [sym_intersection_type] = STATE(2097),
    [sym_function_type] = STATE(2097),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2493),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(825),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(833),
    [sym_this] = ACTIONS(835),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(837),
    [sym_false] = ACTIONS(837),
    [sym_null] = ACTIONS(849),
    [sym_undefined] = ACTIONS(849),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [89] = {
    [sym_import] = STATE(1218),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1218),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1218),
    [sym_arrow_function] = STATE(1218),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1218),
    [sym_new_expression] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_spread_element] = STATE(2530),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_string] = STATE(1672),
    [sym_template_string] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1218),
    [sym_type_assertion] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2097),
    [sym_constructor_type] = STATE(2097),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2097),
    [sym_intersection_type] = STATE(2097),
    [sym_function_type] = STATE(2097),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2531),
    [sym_identifier] = ACTIONS(819),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(825),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(829),
    [anon_sym_DASH] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(831),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(833),
    [sym_this] = ACTIONS(835),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(837),
    [sym_false] = ACTIONS(837),
    [sym_null] = ACTIONS(853),
    [sym_undefined] = ACTIONS(853),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(841),
    [anon_sym_number] = ACTIONS(841),
    [anon_sym_boolean] = ACTIONS(841),
    [anon_sym_string] = ACTIONS(841),
    [anon_sym_symbol] = ACTIONS(841),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [90] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1243),
    [sym_yield_expression] = STATE(1243),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1243),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1243),
    [sym_arrow_function] = STATE(1243),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1243),
    [sym_new_expression] = STATE(1243),
    [sym_await_expression] = STATE(1243),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1243),
    [sym_augmented_assignment_expression] = STATE(1243),
    [sym_ternary_expression] = STATE(1243),
    [sym_binary_expression] = STATE(1243),
    [sym_unary_expression] = STATE(1243),
    [sym_update_expression] = STATE(1243),
    [sym_string] = STATE(1124),
    [sym_template_string] = STATE(1243),
    [sym_regex] = STATE(1243),
    [sym_meta_property] = STATE(1243),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1243),
    [sym_type_assertion] = STATE(1243),
    [sym_as_expression] = STATE(1243),
    [sym_internal_module] = STATE(1243),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2090),
    [sym_constructor_type] = STATE(2090),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(309),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2090),
    [sym_intersection_type] = STATE(2090),
    [sym_function_type] = STATE(2090),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(865),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(873),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(875),
    [anon_sym_number] = ACTIONS(875),
    [anon_sym_boolean] = ACTIONS(875),
    [anon_sym_string] = ACTIONS(875),
    [anon_sym_symbol] = ACTIONS(875),
    [sym_readonly] = ACTIONS(724),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [91] = {
    [sym_import] = STATE(1316),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1316),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1316),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1316),
    [sym_arrow_function] = STATE(1316),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1316),
    [sym_new_expression] = STATE(1316),
    [sym_await_expression] = STATE(1316),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1316),
    [sym_augmented_assignment_expression] = STATE(1316),
    [sym_ternary_expression] = STATE(1316),
    [sym_binary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1316),
    [sym_update_expression] = STATE(1316),
    [sym_string] = STATE(1602),
    [sym_template_string] = STATE(1316),
    [sym_regex] = STATE(1316),
    [sym_meta_property] = STATE(1316),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1316),
    [sym_type_assertion] = STATE(1316),
    [sym_as_expression] = STATE(1316),
    [sym_internal_module] = STATE(1316),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2090),
    [sym_constructor_type] = STATE(2090),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(339),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2090),
    [sym_intersection_type] = STATE(2090),
    [sym_function_type] = STATE(2090),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(877),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(881),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(883),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(891),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(893),
    [sym_this] = ACTIONS(895),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(897),
    [sym_false] = ACTIONS(897),
    [sym_null] = ACTIONS(899),
    [sym_undefined] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(901),
    [anon_sym_number] = ACTIONS(901),
    [anon_sym_boolean] = ACTIONS(901),
    [anon_sym_string] = ACTIONS(901),
    [anon_sym_symbol] = ACTIONS(901),
    [sym_readonly] = ACTIONS(634),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [92] = {
    [sym_import] = STATE(953),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(953),
    [sym_yield_expression] = STATE(953),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(953),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(953),
    [sym_arrow_function] = STATE(953),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(953),
    [sym_new_expression] = STATE(953),
    [sym_await_expression] = STATE(953),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(953),
    [sym_augmented_assignment_expression] = STATE(953),
    [sym_ternary_expression] = STATE(953),
    [sym_binary_expression] = STATE(953),
    [sym_unary_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_string] = STATE(1124),
    [sym_template_string] = STATE(953),
    [sym_regex] = STATE(953),
    [sym_meta_property] = STATE(953),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(953),
    [sym_type_assertion] = STATE(953),
    [sym_as_expression] = STATE(953),
    [sym_internal_module] = STATE(953),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2090),
    [sym_constructor_type] = STATE(2090),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2090),
    [sym_intersection_type] = STATE(2090),
    [sym_function_type] = STATE(2090),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(903),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(905),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_DASH] = ACTIONS(907),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(909),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_null] = ACTIONS(911),
    [sym_undefined] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_boolean] = ACTIONS(913),
    [anon_sym_string] = ACTIONS(913),
    [anon_sym_symbol] = ACTIONS(913),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [93] = {
    [sym_import] = STATE(1100),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1100),
    [sym_yield_expression] = STATE(1100),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1100),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1100),
    [sym_arrow_function] = STATE(1100),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1100),
    [sym_new_expression] = STATE(1100),
    [sym_await_expression] = STATE(1100),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1100),
    [sym_augmented_assignment_expression] = STATE(1100),
    [sym_ternary_expression] = STATE(1100),
    [sym_binary_expression] = STATE(1100),
    [sym_unary_expression] = STATE(1100),
    [sym_update_expression] = STATE(1100),
    [sym_string] = STATE(1409),
    [sym_template_string] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_meta_property] = STATE(1100),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1100),
    [sym_as_expression] = STATE(1100),
    [sym_internal_module] = STATE(1100),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2090),
    [sym_constructor_type] = STATE(2090),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(382),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2090),
    [sym_intersection_type] = STATE(2090),
    [sym_function_type] = STATE(2090),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(915),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(917),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(883),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(919),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(921),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(923),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(925),
    [sym_this] = ACTIONS(927),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(929),
    [sym_false] = ACTIONS(929),
    [sym_null] = ACTIONS(931),
    [sym_undefined] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(933),
    [anon_sym_number] = ACTIONS(933),
    [anon_sym_boolean] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_symbol] = ACTIONS(933),
    [sym_readonly] = ACTIONS(443),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [94] = {
    [sym_import] = STATE(1297),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(2812),
    [sym_class] = STATE(1297),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1297),
    [sym_arrow_function] = STATE(1297),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1297),
    [sym_new_expression] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_string] = STATE(1280),
    [sym_template_string] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2468),
    [sym_non_null_expression] = STATE(1297),
    [sym_type_assertion] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1899),
    [sym_constructor_type] = STATE(1899),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_type_arguments] = STATE(376),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2623),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1899),
    [sym_intersection_type] = STATE(1899),
    [sym_function_type] = STATE(1899),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(935),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(941),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(943),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(945),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(955),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(957),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(959),
    [sym_this] = ACTIONS(961),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(963),
    [sym_false] = ACTIONS(963),
    [sym_null] = ACTIONS(965),
    [sym_undefined] = ACTIONS(965),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(967),
    [anon_sym_number] = ACTIONS(967),
    [anon_sym_boolean] = ACTIONS(967),
    [anon_sym_string] = ACTIONS(967),
    [anon_sym_symbol] = ACTIONS(967),
    [sym_readonly] = ACTIONS(543),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [95] = {
    [sym_import] = STATE(974),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(974),
    [sym_yield_expression] = STATE(974),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(974),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(974),
    [sym_arrow_function] = STATE(974),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(974),
    [sym_new_expression] = STATE(974),
    [sym_await_expression] = STATE(974),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(974),
    [sym_augmented_assignment_expression] = STATE(974),
    [sym_ternary_expression] = STATE(974),
    [sym_binary_expression] = STATE(974),
    [sym_unary_expression] = STATE(974),
    [sym_update_expression] = STATE(974),
    [sym_string] = STATE(974),
    [sym_template_string] = STATE(974),
    [sym_regex] = STATE(974),
    [sym_meta_property] = STATE(974),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(974),
    [sym_type_assertion] = STATE(974),
    [sym_as_expression] = STATE(974),
    [sym_internal_module] = STATE(974),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_STAR] = ACTIONS(973),
    [anon_sym_as] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_in] = ACTIONS(975),
    [anon_sym_COLON] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(975),
    [anon_sym_GT_GT_GT] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_instanceof] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(575),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(979),
    [sym_this] = ACTIONS(981),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(981),
    [sym_false] = ACTIONS(981),
    [sym_null] = ACTIONS(981),
    [sym_undefined] = ACTIONS(981),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [96] = {
    [sym_import] = STATE(1201),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1201),
    [sym_yield_expression] = STATE(1201),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1201),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1201),
    [sym_arrow_function] = STATE(1201),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1201),
    [sym_new_expression] = STATE(1201),
    [sym_await_expression] = STATE(1201),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1201),
    [sym_augmented_assignment_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(1201),
    [sym_binary_expression] = STATE(1201),
    [sym_unary_expression] = STATE(1201),
    [sym_update_expression] = STATE(1201),
    [sym_string] = STATE(1616),
    [sym_template_string] = STATE(1201),
    [sym_regex] = STATE(1201),
    [sym_meta_property] = STATE(1201),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1201),
    [sym_type_assertion] = STATE(1201),
    [sym_as_expression] = STATE(1201),
    [sym_internal_module] = STATE(1201),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2090),
    [sym_constructor_type] = STATE(2090),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(321),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2090),
    [sym_intersection_type] = STATE(2090),
    [sym_function_type] = STATE(2090),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(983),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(987),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(989),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(993),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(997),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(999),
    [sym_this] = ACTIONS(1001),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1003),
    [sym_false] = ACTIONS(1003),
    [sym_null] = ACTIONS(1005),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(1007),
    [anon_sym_number] = ACTIONS(1007),
    [anon_sym_boolean] = ACTIONS(1007),
    [anon_sym_string] = ACTIONS(1007),
    [anon_sym_symbol] = ACTIONS(1007),
    [sym_readonly] = ACTIONS(668),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [97] = {
    [sym_import] = STATE(1359),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1359),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1359),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1359),
    [sym_arrow_function] = STATE(1359),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1359),
    [sym_new_expression] = STATE(1359),
    [sym_await_expression] = STATE(1359),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1359),
    [sym_augmented_assignment_expression] = STATE(1359),
    [sym_ternary_expression] = STATE(1359),
    [sym_binary_expression] = STATE(1359),
    [sym_unary_expression] = STATE(1359),
    [sym_update_expression] = STATE(1359),
    [sym_string] = STATE(1647),
    [sym_template_string] = STATE(1359),
    [sym_regex] = STATE(1359),
    [sym_meta_property] = STATE(1359),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2566),
    [sym_non_null_expression] = STATE(1359),
    [sym_type_assertion] = STATE(1359),
    [sym_as_expression] = STATE(1359),
    [sym_internal_module] = STATE(1359),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2090),
    [sym_constructor_type] = STATE(2090),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_type_arguments] = STATE(272),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2607),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2090),
    [sym_intersection_type] = STATE(2090),
    [sym_function_type] = STATE(2090),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(1011),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(1013),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_DASH] = ACTIONS(1015),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1017),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1019),
    [sym_this] = ACTIONS(1021),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1025),
    [sym_undefined] = ACTIONS(1025),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1027),
    [anon_sym_boolean] = ACTIONS(1027),
    [anon_sym_string] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1027),
    [sym_readonly] = ACTIONS(489),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [98] = {
    [sym_import] = STATE(1037),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1037),
    [sym_yield_expression] = STATE(1037),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1037),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1037),
    [sym_arrow_function] = STATE(1037),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1037),
    [sym_new_expression] = STATE(1037),
    [sym_await_expression] = STATE(1037),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1037),
    [sym_augmented_assignment_expression] = STATE(1037),
    [sym_ternary_expression] = STATE(1037),
    [sym_binary_expression] = STATE(1037),
    [sym_unary_expression] = STATE(1037),
    [sym_update_expression] = STATE(1037),
    [sym_string] = STATE(1037),
    [sym_template_string] = STATE(1037),
    [sym_regex] = STATE(1037),
    [sym_meta_property] = STATE(1037),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1037),
    [sym_type_assertion] = STATE(1037),
    [sym_as_expression] = STATE(1037),
    [sym_internal_module] = STATE(1037),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_as] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(975),
    [anon_sym_GT_GT_GT] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_instanceof] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1031),
    [sym_this] = ACTIONS(1033),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1033),
    [sym_false] = ACTIONS(1033),
    [sym_null] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1033),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(977),
  },
  [99] = {
    [sym_import] = STATE(1327),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1327),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1327),
    [sym_arrow_function] = STATE(1327),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1327),
    [sym_new_expression] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_string] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_meta_property] = STATE(1327),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1327),
    [sym_type_assertion] = STATE(1327),
    [sym_as_expression] = STATE(1327),
    [sym_internal_module] = STATE(1327),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(1035),
    [anon_sym_as] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_in] = ACTIONS(975),
    [anon_sym_COLON] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(975),
    [anon_sym_GT_GT_GT] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_instanceof] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(626),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1037),
    [sym_this] = ACTIONS(1039),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1039),
    [sym_false] = ACTIONS(1039),
    [sym_null] = ACTIONS(1039),
    [sym_undefined] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [100] = {
    [sym_import] = STATE(1225),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1225),
    [sym_yield_expression] = STATE(1225),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1225),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1225),
    [sym_arrow_function] = STATE(1225),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1225),
    [sym_new_expression] = STATE(1225),
    [sym_await_expression] = STATE(1225),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1225),
    [sym_augmented_assignment_expression] = STATE(1225),
    [sym_ternary_expression] = STATE(1225),
    [sym_binary_expression] = STATE(1225),
    [sym_unary_expression] = STATE(1225),
    [sym_update_expression] = STATE(1225),
    [sym_string] = STATE(1225),
    [sym_template_string] = STATE(1225),
    [sym_regex] = STATE(1225),
    [sym_meta_property] = STATE(1225),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1225),
    [sym_type_assertion] = STATE(1225),
    [sym_as_expression] = STATE(1225),
    [sym_internal_module] = STATE(1225),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_as] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_in] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(975),
    [anon_sym_GT_GT_GT] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_instanceof] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1043),
    [sym_this] = ACTIONS(1045),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1045),
    [sym_false] = ACTIONS(1045),
    [sym_null] = ACTIONS(1045),
    [sym_undefined] = ACTIONS(1045),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
    [anon_sym_LBRACE_PIPE] = ACTIONS(977),
  },
  [101] = {
    [sym_import] = STATE(1303),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1303),
    [sym_arrow_function] = STATE(1303),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1303),
    [sym_type_assertion] = STATE(1303),
    [sym_as_expression] = STATE(1303),
    [sym_internal_module] = STATE(1303),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(1047),
    [anon_sym_as] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_in] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(975),
    [anon_sym_GT_GT_GT] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_instanceof] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1049),
    [sym_this] = ACTIONS(1051),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_undefined] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
    [sym__automatic_semicolon] = ACTIONS(977),
  },
  [102] = {
    [sym_import] = STATE(1162),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1162),
    [sym_yield_expression] = STATE(1162),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1162),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1162),
    [sym_arrow_function] = STATE(1162),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1162),
    [sym_new_expression] = STATE(1162),
    [sym_await_expression] = STATE(1162),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1162),
    [sym_augmented_assignment_expression] = STATE(1162),
    [sym_ternary_expression] = STATE(1162),
    [sym_binary_expression] = STATE(1162),
    [sym_unary_expression] = STATE(1162),
    [sym_update_expression] = STATE(1162),
    [sym_string] = STATE(1162),
    [sym_template_string] = STATE(1162),
    [sym_regex] = STATE(1162),
    [sym_meta_property] = STATE(1162),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1162),
    [sym_type_assertion] = STATE(1162),
    [sym_as_expression] = STATE(1162),
    [sym_internal_module] = STATE(1162),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_as] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_in] = ACTIONS(975),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_GT_GT] = ACTIONS(975),
    [anon_sym_GT_GT_GT] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(975),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(975),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_instanceof] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(746),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1055),
    [sym_this] = ACTIONS(1057),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1057),
    [sym_false] = ACTIONS(1057),
    [sym_null] = ACTIONS(1057),
    [sym_undefined] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [anon_sym_implements] = ACTIONS(975),
    [sym_readonly] = ACTIONS(724),
  },
  [103] = {
    [sym_statement_block] = STATE(121),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_default] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_let] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_await] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_do] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_debugger] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_throw] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_case] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_function] = ACTIONS(1061),
    [anon_sym_new] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym_number] = ACTIONS(1059),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(1061),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_abstract] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_interface] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(1059),
  },
  [104] = {
    [sym_statement_block] = STATE(121),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_default] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_let] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_await] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_do] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_debugger] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_throw] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_case] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_function] = ACTIONS(1061),
    [anon_sym_new] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym_number] = ACTIONS(1059),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(1061),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_abstract] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_interface] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(1059),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_default] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1071),
    [anon_sym_namespace] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1069),
    [anon_sym_typeof] = ACTIONS(1069),
    [anon_sym_import] = ACTIONS(1069),
    [anon_sym_var] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1069),
    [anon_sym_switch] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_await] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1069),
    [anon_sym_do] = ACTIONS(1069),
    [anon_sym_try] = ACTIONS(1069),
    [anon_sym_with] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1069),
    [anon_sym_continue] = ACTIONS(1069),
    [anon_sym_debugger] = ACTIONS(1069),
    [anon_sym_return] = ACTIONS(1069),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_case] = ACTIONS(1069),
    [anon_sym_yield] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1071),
    [anon_sym_class] = ACTIONS(1069),
    [anon_sym_async] = ACTIONS(1069),
    [anon_sym_function] = ACTIONS(1069),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1071),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_void] = ACTIONS(1069),
    [anon_sym_delete] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_SQUOTE] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym_number] = ACTIONS(1067),
    [sym_this] = ACTIONS(1069),
    [sym_super] = ACTIONS(1069),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_null] = ACTIONS(1069),
    [sym_undefined] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_static] = ACTIONS(1069),
    [anon_sym_abstract] = ACTIONS(1069),
    [anon_sym_get] = ACTIONS(1069),
    [anon_sym_set] = ACTIONS(1069),
    [anon_sym_declare] = ACTIONS(1069),
    [anon_sym_public] = ACTIONS(1069),
    [anon_sym_private] = ACTIONS(1069),
    [anon_sym_protected] = ACTIONS(1069),
    [anon_sym_module] = ACTIONS(1069),
    [anon_sym_any] = ACTIONS(1069),
    [anon_sym_number] = ACTIONS(1069),
    [anon_sym_boolean] = ACTIONS(1069),
    [anon_sym_string] = ACTIONS(1069),
    [anon_sym_symbol] = ACTIONS(1069),
    [anon_sym_interface] = ACTIONS(1069),
    [anon_sym_enum] = ACTIONS(1069),
    [sym_readonly] = ACTIONS(1069),
    [sym__automatic_semicolon] = ACTIONS(1075),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(1077),
    [sym_identifier] = ACTIONS(1079),
    [anon_sym_export] = ACTIONS(1079),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_default] = ACTIONS(1079),
    [anon_sym_as] = ACTIONS(1081),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_COMMA] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_type] = ACTIONS(1079),
    [anon_sym_typeof] = ACTIONS(1079),
    [anon_sym_import] = ACTIONS(1079),
    [anon_sym_var] = ACTIONS(1079),
    [anon_sym_let] = ACTIONS(1079),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1079),
    [anon_sym_switch] = ACTIONS(1079),
    [anon_sym_for] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_in] = ACTIONS(1081),
    [anon_sym_while] = ACTIONS(1079),
    [anon_sym_do] = ACTIONS(1079),
    [anon_sym_try] = ACTIONS(1079),
    [anon_sym_with] = ACTIONS(1079),
    [anon_sym_break] = ACTIONS(1079),
    [anon_sym_continue] = ACTIONS(1079),
    [anon_sym_debugger] = ACTIONS(1079),
    [anon_sym_return] = ACTIONS(1079),
    [anon_sym_throw] = ACTIONS(1079),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_case] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1079),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_DOT] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(1079),
    [anon_sym_async] = ACTIONS(1079),
    [anon_sym_function] = ACTIONS(1079),
    [anon_sym_new] = ACTIONS(1079),
    [anon_sym_QMARK] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_STAR_STAR] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1083),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_TILDE] = ACTIONS(1077),
    [anon_sym_void] = ACTIONS(1079),
    [anon_sym_delete] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1077),
    [anon_sym_SQUOTE] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [sym_number] = ACTIONS(1077),
    [sym_this] = ACTIONS(1079),
    [sym_super] = ACTIONS(1079),
    [sym_true] = ACTIONS(1079),
    [sym_false] = ACTIONS(1079),
    [sym_null] = ACTIONS(1079),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1079),
    [anon_sym_abstract] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(1079),
    [anon_sym_set] = ACTIONS(1079),
    [anon_sym_declare] = ACTIONS(1079),
    [anon_sym_public] = ACTIONS(1079),
    [anon_sym_private] = ACTIONS(1079),
    [anon_sym_protected] = ACTIONS(1079),
    [anon_sym_module] = ACTIONS(1079),
    [anon_sym_any] = ACTIONS(1079),
    [anon_sym_number] = ACTIONS(1079),
    [anon_sym_boolean] = ACTIONS(1079),
    [anon_sym_string] = ACTIONS(1079),
    [anon_sym_symbol] = ACTIONS(1079),
    [anon_sym_interface] = ACTIONS(1079),
    [anon_sym_enum] = ACTIONS(1079),
    [sym_readonly] = ACTIONS(1079),
    [sym__automatic_semicolon] = ACTIONS(1085),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_default] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1069),
    [anon_sym_namespace] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1069),
    [anon_sym_typeof] = ACTIONS(1069),
    [anon_sym_import] = ACTIONS(1069),
    [anon_sym_var] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1069),
    [anon_sym_switch] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_await] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1069),
    [anon_sym_do] = ACTIONS(1069),
    [anon_sym_try] = ACTIONS(1069),
    [anon_sym_with] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1069),
    [anon_sym_continue] = ACTIONS(1069),
    [anon_sym_debugger] = ACTIONS(1069),
    [anon_sym_return] = ACTIONS(1069),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_case] = ACTIONS(1069),
    [anon_sym_yield] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_class] = ACTIONS(1069),
    [anon_sym_async] = ACTIONS(1069),
    [anon_sym_function] = ACTIONS(1069),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1069),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_void] = ACTIONS(1069),
    [anon_sym_delete] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_SQUOTE] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym_number] = ACTIONS(1067),
    [sym_this] = ACTIONS(1069),
    [sym_super] = ACTIONS(1069),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_null] = ACTIONS(1069),
    [sym_undefined] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_static] = ACTIONS(1069),
    [anon_sym_abstract] = ACTIONS(1069),
    [anon_sym_get] = ACTIONS(1069),
    [anon_sym_set] = ACTIONS(1069),
    [anon_sym_declare] = ACTIONS(1069),
    [anon_sym_public] = ACTIONS(1069),
    [anon_sym_private] = ACTIONS(1069),
    [anon_sym_protected] = ACTIONS(1069),
    [anon_sym_module] = ACTIONS(1069),
    [anon_sym_any] = ACTIONS(1069),
    [anon_sym_number] = ACTIONS(1069),
    [anon_sym_boolean] = ACTIONS(1069),
    [anon_sym_string] = ACTIONS(1069),
    [anon_sym_symbol] = ACTIONS(1069),
    [anon_sym_interface] = ACTIONS(1069),
    [anon_sym_enum] = ACTIONS(1069),
    [sym_readonly] = ACTIONS(1069),
    [sym__automatic_semicolon] = ACTIONS(1087),
  },
  [108] = {
    [ts_builtin_sym_end] = ACTIONS(1089),
    [sym_identifier] = ACTIONS(1091),
    [anon_sym_export] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_default] = ACTIONS(1091),
    [anon_sym_as] = ACTIONS(1093),
    [anon_sym_namespace] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_type] = ACTIONS(1091),
    [anon_sym_typeof] = ACTIONS(1091),
    [anon_sym_import] = ACTIONS(1091),
    [anon_sym_var] = ACTIONS(1091),
    [anon_sym_let] = ACTIONS(1091),
    [anon_sym_const] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_switch] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_try] = ACTIONS(1091),
    [anon_sym_with] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_continue] = ACTIONS(1091),
    [anon_sym_debugger] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_async] = ACTIONS(1091),
    [anon_sym_function] = ACTIONS(1091),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1093),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_TILDE] = ACTIONS(1089),
    [anon_sym_void] = ACTIONS(1091),
    [anon_sym_delete] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_SQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_number] = ACTIONS(1089),
    [sym_this] = ACTIONS(1091),
    [sym_super] = ACTIONS(1091),
    [sym_true] = ACTIONS(1091),
    [sym_false] = ACTIONS(1091),
    [sym_null] = ACTIONS(1091),
    [sym_undefined] = ACTIONS(1091),
    [anon_sym_AT] = ACTIONS(1089),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_abstract] = ACTIONS(1091),
    [anon_sym_get] = ACTIONS(1091),
    [anon_sym_set] = ACTIONS(1091),
    [anon_sym_declare] = ACTIONS(1091),
    [anon_sym_public] = ACTIONS(1091),
    [anon_sym_private] = ACTIONS(1091),
    [anon_sym_protected] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_any] = ACTIONS(1091),
    [anon_sym_number] = ACTIONS(1091),
    [anon_sym_boolean] = ACTIONS(1091),
    [anon_sym_string] = ACTIONS(1091),
    [anon_sym_symbol] = ACTIONS(1091),
    [anon_sym_interface] = ACTIONS(1091),
    [anon_sym_enum] = ACTIONS(1091),
    [sym_readonly] = ACTIONS(1091),
    [sym__automatic_semicolon] = ACTIONS(1097),
  },
  [109] = {
    [ts_builtin_sym_end] = ACTIONS(1099),
    [sym_identifier] = ACTIONS(1101),
    [anon_sym_export] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(1101),
    [anon_sym_as] = ACTIONS(1103),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_COMMA] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_type] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1101),
    [anon_sym_import] = ACTIONS(1101),
    [anon_sym_var] = ACTIONS(1101),
    [anon_sym_let] = ACTIONS(1101),
    [anon_sym_const] = ACTIONS(1101),
    [anon_sym_if] = ACTIONS(1101),
    [anon_sym_else] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1101),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_await] = ACTIONS(1101),
    [anon_sym_in] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1101),
    [anon_sym_do] = ACTIONS(1101),
    [anon_sym_try] = ACTIONS(1101),
    [anon_sym_with] = ACTIONS(1101),
    [anon_sym_break] = ACTIONS(1101),
    [anon_sym_continue] = ACTIONS(1101),
    [anon_sym_debugger] = ACTIONS(1101),
    [anon_sym_return] = ACTIONS(1101),
    [anon_sym_throw] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_yield] = ACTIONS(1101),
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1101),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1101),
    [anon_sym_DOT] = ACTIONS(1103),
    [anon_sym_class] = ACTIONS(1101),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1101),
    [anon_sym_new] = ACTIONS(1101),
    [anon_sym_QMARK] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [anon_sym_GT_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_CARET] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1105),
    [anon_sym_GT_EQ] = ACTIONS(1105),
    [anon_sym_instanceof] = ACTIONS(1103),
    [anon_sym_BANG] = ACTIONS(1101),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_void] = ACTIONS(1101),
    [anon_sym_delete] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [sym_number] = ACTIONS(1099),
    [sym_this] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_true] = ACTIONS(1101),
    [sym_false] = ACTIONS(1101),
    [sym_null] = ACTIONS(1101),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(1099),
    [anon_sym_static] = ACTIONS(1101),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_get] = ACTIONS(1101),
    [anon_sym_set] = ACTIONS(1101),
    [anon_sym_declare] = ACTIONS(1101),
    [anon_sym_public] = ACTIONS(1101),
    [anon_sym_private] = ACTIONS(1101),
    [anon_sym_protected] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(1101),
    [anon_sym_any] = ACTIONS(1101),
    [anon_sym_number] = ACTIONS(1101),
    [anon_sym_boolean] = ACTIONS(1101),
    [anon_sym_string] = ACTIONS(1101),
    [anon_sym_symbol] = ACTIONS(1101),
    [anon_sym_interface] = ACTIONS(1101),
    [anon_sym_enum] = ACTIONS(1101),
    [sym_readonly] = ACTIONS(1101),
    [sym__automatic_semicolon] = ACTIONS(1107),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(1109),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_default] = ACTIONS(1111),
    [anon_sym_as] = ACTIONS(1111),
    [anon_sym_namespace] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_type] = ACTIONS(1111),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1111),
    [anon_sym_var] = ACTIONS(1111),
    [anon_sym_let] = ACTIONS(1111),
    [anon_sym_const] = ACTIONS(1111),
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_else] = ACTIONS(1111),
    [anon_sym_switch] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_while] = ACTIONS(1111),
    [anon_sym_do] = ACTIONS(1111),
    [anon_sym_try] = ACTIONS(1111),
    [anon_sym_with] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1111),
    [anon_sym_continue] = ACTIONS(1111),
    [anon_sym_debugger] = ACTIONS(1111),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_throw] = ACTIONS(1111),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_case] = ACTIONS(1111),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1111),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_class] = ACTIONS(1111),
    [anon_sym_async] = ACTIONS(1111),
    [anon_sym_function] = ACTIONS(1111),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1111),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1111),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1111),
    [anon_sym_DASH] = ACTIONS(1111),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_TILDE] = ACTIONS(1109),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [sym_number] = ACTIONS(1109),
    [sym_this] = ACTIONS(1111),
    [sym_super] = ACTIONS(1111),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_null] = ACTIONS(1111),
    [sym_undefined] = ACTIONS(1111),
    [anon_sym_AT] = ACTIONS(1109),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_abstract] = ACTIONS(1111),
    [anon_sym_get] = ACTIONS(1111),
    [anon_sym_set] = ACTIONS(1111),
    [anon_sym_declare] = ACTIONS(1111),
    [anon_sym_public] = ACTIONS(1111),
    [anon_sym_private] = ACTIONS(1111),
    [anon_sym_protected] = ACTIONS(1111),
    [anon_sym_module] = ACTIONS(1111),
    [anon_sym_any] = ACTIONS(1111),
    [anon_sym_number] = ACTIONS(1111),
    [anon_sym_boolean] = ACTIONS(1111),
    [anon_sym_string] = ACTIONS(1111),
    [anon_sym_symbol] = ACTIONS(1111),
    [anon_sym_interface] = ACTIONS(1111),
    [anon_sym_enum] = ACTIONS(1111),
    [sym_readonly] = ACTIONS(1111),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(1115),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_default] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(1115),
    [anon_sym_namespace] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1115),
    [anon_sym_typeof] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1115),
    [anon_sym_var] = ACTIONS(1115),
    [anon_sym_let] = ACTIONS(1115),
    [anon_sym_const] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_switch] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_await] = ACTIONS(1115),
    [anon_sym_in] = ACTIONS(1115),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_do] = ACTIONS(1115),
    [anon_sym_try] = ACTIONS(1115),
    [anon_sym_with] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_debugger] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_throw] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1113),
    [anon_sym_case] = ACTIONS(1115),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_GT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_DOT] = ACTIONS(1115),
    [anon_sym_class] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_function] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_AMP_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1115),
    [anon_sym_GT_GT_GT] = ACTIONS(1113),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1113),
    [anon_sym_GT_EQ] = ACTIONS(1113),
    [anon_sym_instanceof] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_TILDE] = ACTIONS(1113),
    [anon_sym_void] = ACTIONS(1115),
    [anon_sym_delete] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym_number] = ACTIONS(1113),
    [sym_this] = ACTIONS(1115),
    [sym_super] = ACTIONS(1115),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_undefined] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1113),
    [anon_sym_static] = ACTIONS(1115),
    [anon_sym_abstract] = ACTIONS(1115),
    [anon_sym_get] = ACTIONS(1115),
    [anon_sym_set] = ACTIONS(1115),
    [anon_sym_declare] = ACTIONS(1115),
    [anon_sym_public] = ACTIONS(1115),
    [anon_sym_private] = ACTIONS(1115),
    [anon_sym_protected] = ACTIONS(1115),
    [anon_sym_module] = ACTIONS(1115),
    [anon_sym_any] = ACTIONS(1115),
    [anon_sym_number] = ACTIONS(1115),
    [anon_sym_boolean] = ACTIONS(1115),
    [anon_sym_string] = ACTIONS(1115),
    [anon_sym_symbol] = ACTIONS(1115),
    [anon_sym_interface] = ACTIONS(1115),
    [anon_sym_enum] = ACTIONS(1115),
    [sym_readonly] = ACTIONS(1115),
    [sym__automatic_semicolon] = ACTIONS(1113),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(1117),
    [sym_identifier] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_default] = ACTIONS(1119),
    [anon_sym_as] = ACTIONS(1121),
    [anon_sym_namespace] = ACTIONS(1119),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_type] = ACTIONS(1119),
    [anon_sym_typeof] = ACTIONS(1119),
    [anon_sym_import] = ACTIONS(1119),
    [anon_sym_var] = ACTIONS(1119),
    [anon_sym_let] = ACTIONS(1119),
    [anon_sym_const] = ACTIONS(1119),
    [anon_sym_if] = ACTIONS(1119),
    [anon_sym_else] = ACTIONS(1119),
    [anon_sym_switch] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1117),
    [anon_sym_await] = ACTIONS(1119),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_while] = ACTIONS(1119),
    [anon_sym_do] = ACTIONS(1119),
    [anon_sym_try] = ACTIONS(1119),
    [anon_sym_with] = ACTIONS(1119),
    [anon_sym_break] = ACTIONS(1119),
    [anon_sym_continue] = ACTIONS(1119),
    [anon_sym_debugger] = ACTIONS(1119),
    [anon_sym_return] = ACTIONS(1119),
    [anon_sym_throw] = ACTIONS(1119),
    [anon_sym_SEMI] = ACTIONS(1117),
    [anon_sym_case] = ACTIONS(1119),
    [anon_sym_yield] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(1121),
    [anon_sym_class] = ACTIONS(1119),
    [anon_sym_async] = ACTIONS(1119),
    [anon_sym_function] = ACTIONS(1119),
    [anon_sym_new] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1121),
    [anon_sym_BANG] = ACTIONS(1119),
    [anon_sym_TILDE] = ACTIONS(1117),
    [anon_sym_void] = ACTIONS(1119),
    [anon_sym_delete] = ACTIONS(1119),
    [anon_sym_PLUS_PLUS] = ACTIONS(1117),
    [anon_sym_DASH_DASH] = ACTIONS(1117),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1117),
    [sym_number] = ACTIONS(1117),
    [sym_this] = ACTIONS(1119),
    [sym_super] = ACTIONS(1119),
    [sym_true] = ACTIONS(1119),
    [sym_false] = ACTIONS(1119),
    [sym_null] = ACTIONS(1119),
    [sym_undefined] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1117),
    [anon_sym_static] = ACTIONS(1119),
    [anon_sym_abstract] = ACTIONS(1119),
    [anon_sym_get] = ACTIONS(1119),
    [anon_sym_set] = ACTIONS(1119),
    [anon_sym_declare] = ACTIONS(1119),
    [anon_sym_public] = ACTIONS(1119),
    [anon_sym_private] = ACTIONS(1119),
    [anon_sym_protected] = ACTIONS(1119),
    [anon_sym_module] = ACTIONS(1119),
    [anon_sym_any] = ACTIONS(1119),
    [anon_sym_number] = ACTIONS(1119),
    [anon_sym_boolean] = ACTIONS(1119),
    [anon_sym_string] = ACTIONS(1119),
    [anon_sym_symbol] = ACTIONS(1119),
    [anon_sym_interface] = ACTIONS(1119),
    [anon_sym_enum] = ACTIONS(1119),
    [sym_readonly] = ACTIONS(1119),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(1125),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1127),
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(1129),
    [anon_sym_namespace] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym_type] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(1127),
    [anon_sym_var] = ACTIONS(1127),
    [anon_sym_let] = ACTIONS(1127),
    [anon_sym_const] = ACTIONS(1127),
    [anon_sym_if] = ACTIONS(1127),
    [anon_sym_else] = ACTIONS(1127),
    [anon_sym_switch] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1125),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_in] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1127),
    [anon_sym_do] = ACTIONS(1127),
    [anon_sym_try] = ACTIONS(1127),
    [anon_sym_with] = ACTIONS(1127),
    [anon_sym_break] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1127),
    [anon_sym_debugger] = ACTIONS(1127),
    [anon_sym_return] = ACTIONS(1127),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1127),
    [anon_sym_yield] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1127),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(1129),
    [anon_sym_class] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1127),
    [anon_sym_function] = ACTIONS(1127),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1129),
    [anon_sym_BANG] = ACTIONS(1127),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_void] = ACTIONS(1127),
    [anon_sym_delete] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [sym_number] = ACTIONS(1125),
    [sym_this] = ACTIONS(1127),
    [sym_super] = ACTIONS(1127),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_null] = ACTIONS(1127),
    [sym_undefined] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1125),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_abstract] = ACTIONS(1127),
    [anon_sym_get] = ACTIONS(1127),
    [anon_sym_set] = ACTIONS(1127),
    [anon_sym_declare] = ACTIONS(1127),
    [anon_sym_public] = ACTIONS(1127),
    [anon_sym_private] = ACTIONS(1127),
    [anon_sym_protected] = ACTIONS(1127),
    [anon_sym_module] = ACTIONS(1127),
    [anon_sym_any] = ACTIONS(1127),
    [anon_sym_number] = ACTIONS(1127),
    [anon_sym_boolean] = ACTIONS(1127),
    [anon_sym_string] = ACTIONS(1127),
    [anon_sym_symbol] = ACTIONS(1127),
    [anon_sym_interface] = ACTIONS(1127),
    [anon_sym_enum] = ACTIONS(1127),
    [sym_readonly] = ACTIONS(1127),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1137),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1137),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1135),
    [anon_sym_PIPE_PIPE] = ACTIONS(1135),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_GT_GT_GT] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_instanceof] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
    [sym__automatic_semicolon] = ACTIONS(1139),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(1141),
    [sym_identifier] = ACTIONS(1143),
    [anon_sym_export] = ACTIONS(1143),
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_default] = ACTIONS(1143),
    [anon_sym_as] = ACTIONS(1145),
    [anon_sym_namespace] = ACTIONS(1143),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(1141),
    [anon_sym_type] = ACTIONS(1143),
    [anon_sym_typeof] = ACTIONS(1143),
    [anon_sym_import] = ACTIONS(1143),
    [anon_sym_var] = ACTIONS(1143),
    [anon_sym_let] = ACTIONS(1143),
    [anon_sym_const] = ACTIONS(1143),
    [anon_sym_if] = ACTIONS(1143),
    [anon_sym_else] = ACTIONS(1143),
    [anon_sym_switch] = ACTIONS(1143),
    [anon_sym_for] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_in] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1143),
    [anon_sym_do] = ACTIONS(1143),
    [anon_sym_try] = ACTIONS(1143),
    [anon_sym_with] = ACTIONS(1143),
    [anon_sym_break] = ACTIONS(1143),
    [anon_sym_continue] = ACTIONS(1143),
    [anon_sym_debugger] = ACTIONS(1143),
    [anon_sym_return] = ACTIONS(1143),
    [anon_sym_throw] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1141),
    [anon_sym_case] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1143),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(1143),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1143),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_class] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1143),
    [anon_sym_function] = ACTIONS(1143),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1147),
    [anon_sym_PIPE_PIPE] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(1145),
    [anon_sym_GT_GT_GT] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_PERCENT] = ACTIONS(1147),
    [anon_sym_STAR_STAR] = ACTIONS(1147),
    [anon_sym_LT_EQ] = ACTIONS(1147),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1147),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1147),
    [anon_sym_GT_EQ] = ACTIONS(1147),
    [anon_sym_instanceof] = ACTIONS(1145),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1143),
    [anon_sym_delete] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [sym_number] = ACTIONS(1141),
    [sym_this] = ACTIONS(1143),
    [sym_super] = ACTIONS(1143),
    [sym_true] = ACTIONS(1143),
    [sym_false] = ACTIONS(1143),
    [sym_null] = ACTIONS(1143),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(1141),
    [anon_sym_static] = ACTIONS(1143),
    [anon_sym_abstract] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(1143),
    [anon_sym_set] = ACTIONS(1143),
    [anon_sym_declare] = ACTIONS(1143),
    [anon_sym_public] = ACTIONS(1143),
    [anon_sym_private] = ACTIONS(1143),
    [anon_sym_protected] = ACTIONS(1143),
    [anon_sym_module] = ACTIONS(1143),
    [anon_sym_any] = ACTIONS(1143),
    [anon_sym_number] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(1143),
    [anon_sym_string] = ACTIONS(1143),
    [anon_sym_symbol] = ACTIONS(1143),
    [anon_sym_interface] = ACTIONS(1143),
    [anon_sym_enum] = ACTIONS(1143),
    [sym_readonly] = ACTIONS(1143),
    [sym__automatic_semicolon] = ACTIONS(1149),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(1151),
    [sym_identifier] = ACTIONS(1153),
    [anon_sym_export] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_default] = ACTIONS(1153),
    [anon_sym_as] = ACTIONS(1155),
    [anon_sym_namespace] = ACTIONS(1153),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym_type] = ACTIONS(1153),
    [anon_sym_typeof] = ACTIONS(1153),
    [anon_sym_import] = ACTIONS(1153),
    [anon_sym_var] = ACTIONS(1153),
    [anon_sym_let] = ACTIONS(1153),
    [anon_sym_const] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_else] = ACTIONS(1153),
    [anon_sym_switch] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_await] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(1155),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_do] = ACTIONS(1153),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_with] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [anon_sym_debugger] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_throw] = ACTIONS(1153),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_case] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_class] = ACTIONS(1153),
    [anon_sym_async] = ACTIONS(1153),
    [anon_sym_function] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(1153),
    [anon_sym_QMARK] = ACTIONS(1157),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1153),
    [anon_sym_DASH] = ACTIONS(1153),
    [anon_sym_PERCENT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(1157),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_instanceof] = ACTIONS(1155),
    [anon_sym_BANG] = ACTIONS(1153),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_void] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(1151),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1151),
    [sym_this] = ACTIONS(1153),
    [sym_super] = ACTIONS(1153),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_null] = ACTIONS(1153),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_abstract] = ACTIONS(1153),
    [anon_sym_get] = ACTIONS(1153),
    [anon_sym_set] = ACTIONS(1153),
    [anon_sym_declare] = ACTIONS(1153),
    [anon_sym_public] = ACTIONS(1153),
    [anon_sym_private] = ACTIONS(1153),
    [anon_sym_protected] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(1153),
    [anon_sym_number] = ACTIONS(1153),
    [anon_sym_boolean] = ACTIONS(1153),
    [anon_sym_string] = ACTIONS(1153),
    [anon_sym_symbol] = ACTIONS(1153),
    [anon_sym_interface] = ACTIONS(1153),
    [anon_sym_enum] = ACTIONS(1153),
    [sym_readonly] = ACTIONS(1153),
    [sym__automatic_semicolon] = ACTIONS(1159),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(1161),
    [sym_identifier] = ACTIONS(1163),
    [anon_sym_export] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_as] = ACTIONS(1165),
    [anon_sym_namespace] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1161),
    [anon_sym_type] = ACTIONS(1163),
    [anon_sym_typeof] = ACTIONS(1163),
    [anon_sym_import] = ACTIONS(1163),
    [anon_sym_var] = ACTIONS(1163),
    [anon_sym_let] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(1163),
    [anon_sym_else] = ACTIONS(1163),
    [anon_sym_switch] = ACTIONS(1163),
    [anon_sym_for] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_await] = ACTIONS(1163),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1163),
    [anon_sym_do] = ACTIONS(1163),
    [anon_sym_try] = ACTIONS(1163),
    [anon_sym_with] = ACTIONS(1163),
    [anon_sym_break] = ACTIONS(1163),
    [anon_sym_continue] = ACTIONS(1163),
    [anon_sym_debugger] = ACTIONS(1163),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1161),
    [anon_sym_case] = ACTIONS(1163),
    [anon_sym_yield] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(1163),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_class] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1163),
    [anon_sym_function] = ACTIONS(1163),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_void] = ACTIONS(1163),
    [anon_sym_delete] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_DQUOTE] = ACTIONS(1161),
    [anon_sym_SQUOTE] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1161),
    [sym_number] = ACTIONS(1161),
    [sym_this] = ACTIONS(1163),
    [sym_super] = ACTIONS(1163),
    [sym_true] = ACTIONS(1163),
    [sym_false] = ACTIONS(1163),
    [sym_null] = ACTIONS(1163),
    [sym_undefined] = ACTIONS(1163),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1163),
    [anon_sym_abstract] = ACTIONS(1163),
    [anon_sym_get] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1163),
    [anon_sym_declare] = ACTIONS(1163),
    [anon_sym_public] = ACTIONS(1163),
    [anon_sym_private] = ACTIONS(1163),
    [anon_sym_protected] = ACTIONS(1163),
    [anon_sym_module] = ACTIONS(1163),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_interface] = ACTIONS(1163),
    [anon_sym_enum] = ACTIONS(1163),
    [sym_readonly] = ACTIONS(1163),
    [sym__automatic_semicolon] = ACTIONS(1169),
  },
  [118] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1137),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1137),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1135),
    [anon_sym_PIPE_PIPE] = ACTIONS(1135),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_GT_GT_GT] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_instanceof] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
    [sym__automatic_semicolon] = ACTIONS(1135),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(1171),
    [sym_identifier] = ACTIONS(1173),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_STAR] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_typeof] = ACTIONS(1173),
    [anon_sym_import] = ACTIONS(1173),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_let] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_await] = ACTIONS(1173),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_try] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_debugger] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_throw] = ACTIONS(1173),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1173),
    [anon_sym_class] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1173),
    [anon_sym_new] = ACTIONS(1173),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_PIPE_PIPE] = ACTIONS(1171),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1171),
    [anon_sym_STAR_STAR] = ACTIONS(1171),
    [anon_sym_LT_EQ] = ACTIONS(1171),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1171),
    [anon_sym_GT_EQ] = ACTIONS(1171),
    [anon_sym_instanceof] = ACTIONS(1173),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_delete] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [sym_number] = ACTIONS(1171),
    [sym_this] = ACTIONS(1173),
    [sym_super] = ACTIONS(1173),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_AT] = ACTIONS(1171),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_abstract] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_interface] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [sym_readonly] = ACTIONS(1173),
    [sym__automatic_semicolon] = ACTIONS(1171),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(1175),
    [sym_identifier] = ACTIONS(1177),
    [anon_sym_export] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_default] = ACTIONS(1177),
    [anon_sym_as] = ACTIONS(1179),
    [anon_sym_namespace] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_type] = ACTIONS(1177),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym_import] = ACTIONS(1177),
    [anon_sym_var] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_const] = ACTIONS(1177),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_switch] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_await] = ACTIONS(1177),
    [anon_sym_in] = ACTIONS(1179),
    [anon_sym_while] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_try] = ACTIONS(1177),
    [anon_sym_with] = ACTIONS(1177),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1177),
    [anon_sym_debugger] = ACTIONS(1177),
    [anon_sym_return] = ACTIONS(1177),
    [anon_sym_throw] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_yield] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1177),
    [anon_sym_GT] = ACTIONS(1179),
    [anon_sym_SLASH] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(1179),
    [anon_sym_class] = ACTIONS(1177),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_function] = ACTIONS(1177),
    [anon_sym_new] = ACTIONS(1177),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1179),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1179),
    [anon_sym_BANG] = ACTIONS(1177),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_void] = ACTIONS(1177),
    [anon_sym_delete] = ACTIONS(1177),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1175),
    [sym_number] = ACTIONS(1175),
    [sym_this] = ACTIONS(1177),
    [sym_super] = ACTIONS(1177),
    [sym_true] = ACTIONS(1177),
    [sym_false] = ACTIONS(1177),
    [sym_null] = ACTIONS(1177),
    [sym_undefined] = ACTIONS(1177),
    [anon_sym_AT] = ACTIONS(1175),
    [anon_sym_static] = ACTIONS(1177),
    [anon_sym_abstract] = ACTIONS(1177),
    [anon_sym_get] = ACTIONS(1177),
    [anon_sym_set] = ACTIONS(1177),
    [anon_sym_declare] = ACTIONS(1177),
    [anon_sym_public] = ACTIONS(1177),
    [anon_sym_private] = ACTIONS(1177),
    [anon_sym_protected] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(1177),
    [anon_sym_any] = ACTIONS(1177),
    [anon_sym_number] = ACTIONS(1177),
    [anon_sym_boolean] = ACTIONS(1177),
    [anon_sym_string] = ACTIONS(1177),
    [anon_sym_symbol] = ACTIONS(1177),
    [anon_sym_interface] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(1177),
    [sym_readonly] = ACTIONS(1177),
    [sym__automatic_semicolon] = ACTIONS(1183),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [sym_identifier] = ACTIONS(1187),
    [anon_sym_export] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_as] = ACTIONS(1187),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1187),
    [anon_sym_import] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(1187),
    [anon_sym_let] = ACTIONS(1187),
    [anon_sym_const] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_for] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1187),
    [anon_sym_in] = ACTIONS(1187),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_do] = ACTIONS(1187),
    [anon_sym_try] = ACTIONS(1187),
    [anon_sym_with] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_continue] = ACTIONS(1187),
    [anon_sym_debugger] = ACTIONS(1187),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1187),
    [anon_sym_yield] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1187),
    [anon_sym_class] = ACTIONS(1187),
    [anon_sym_async] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(1187),
    [anon_sym_new] = ACTIONS(1187),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_instanceof] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_TILDE] = ACTIONS(1185),
    [anon_sym_void] = ACTIONS(1187),
    [anon_sym_delete] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym_number] = ACTIONS(1185),
    [sym_this] = ACTIONS(1187),
    [sym_super] = ACTIONS(1187),
    [sym_true] = ACTIONS(1187),
    [sym_false] = ACTIONS(1187),
    [sym_null] = ACTIONS(1187),
    [sym_undefined] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1187),
    [anon_sym_abstract] = ACTIONS(1187),
    [anon_sym_get] = ACTIONS(1187),
    [anon_sym_set] = ACTIONS(1187),
    [anon_sym_declare] = ACTIONS(1187),
    [anon_sym_public] = ACTIONS(1187),
    [anon_sym_private] = ACTIONS(1187),
    [anon_sym_protected] = ACTIONS(1187),
    [anon_sym_module] = ACTIONS(1187),
    [anon_sym_any] = ACTIONS(1187),
    [anon_sym_number] = ACTIONS(1187),
    [anon_sym_boolean] = ACTIONS(1187),
    [anon_sym_string] = ACTIONS(1187),
    [anon_sym_symbol] = ACTIONS(1187),
    [anon_sym_interface] = ACTIONS(1187),
    [anon_sym_enum] = ACTIONS(1187),
    [sym_readonly] = ACTIONS(1187),
    [sym__automatic_semicolon] = ACTIONS(1185),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(1191),
    [anon_sym_export] = ACTIONS(1191),
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_as] = ACTIONS(1193),
    [anon_sym_namespace] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_typeof] = ACTIONS(1191),
    [anon_sym_import] = ACTIONS(1191),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_let] = ACTIONS(1191),
    [anon_sym_const] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1191),
    [anon_sym_switch] = ACTIONS(1191),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_while] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(1191),
    [anon_sym_try] = ACTIONS(1191),
    [anon_sym_with] = ACTIONS(1191),
    [anon_sym_break] = ACTIONS(1191),
    [anon_sym_continue] = ACTIONS(1191),
    [anon_sym_debugger] = ACTIONS(1191),
    [anon_sym_return] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1191),
    [anon_sym_yield] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1191),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1191),
    [anon_sym_DOT] = ACTIONS(1193),
    [anon_sym_class] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(1191),
    [anon_sym_new] = ACTIONS(1191),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1191),
    [anon_sym_delete] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [sym_number] = ACTIONS(1189),
    [sym_this] = ACTIONS(1191),
    [sym_super] = ACTIONS(1191),
    [sym_true] = ACTIONS(1191),
    [sym_false] = ACTIONS(1191),
    [sym_null] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1191),
    [anon_sym_abstract] = ACTIONS(1191),
    [anon_sym_get] = ACTIONS(1191),
    [anon_sym_set] = ACTIONS(1191),
    [anon_sym_declare] = ACTIONS(1191),
    [anon_sym_public] = ACTIONS(1191),
    [anon_sym_private] = ACTIONS(1191),
    [anon_sym_protected] = ACTIONS(1191),
    [anon_sym_module] = ACTIONS(1191),
    [anon_sym_any] = ACTIONS(1191),
    [anon_sym_number] = ACTIONS(1191),
    [anon_sym_boolean] = ACTIONS(1191),
    [anon_sym_string] = ACTIONS(1191),
    [anon_sym_symbol] = ACTIONS(1191),
    [anon_sym_interface] = ACTIONS(1191),
    [anon_sym_enum] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(1191),
    [sym__automatic_semicolon] = ACTIONS(1197),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1203),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1203),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym_readonly] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1207),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1211),
    [anon_sym_STAR] = ACTIONS(1213),
    [anon_sym_default] = ACTIONS(1211),
    [anon_sym_as] = ACTIONS(1213),
    [anon_sym_namespace] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_type] = ACTIONS(1211),
    [anon_sym_typeof] = ACTIONS(1211),
    [anon_sym_import] = ACTIONS(1211),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1211),
    [anon_sym_const] = ACTIONS(1211),
    [anon_sym_if] = ACTIONS(1211),
    [anon_sym_else] = ACTIONS(1211),
    [anon_sym_switch] = ACTIONS(1211),
    [anon_sym_for] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_await] = ACTIONS(1211),
    [anon_sym_in] = ACTIONS(1213),
    [anon_sym_while] = ACTIONS(1211),
    [anon_sym_do] = ACTIONS(1211),
    [anon_sym_try] = ACTIONS(1211),
    [anon_sym_with] = ACTIONS(1211),
    [anon_sym_break] = ACTIONS(1211),
    [anon_sym_continue] = ACTIONS(1211),
    [anon_sym_debugger] = ACTIONS(1211),
    [anon_sym_return] = ACTIONS(1211),
    [anon_sym_throw] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1211),
    [anon_sym_yield] = ACTIONS(1211),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_DOT] = ACTIONS(1213),
    [anon_sym_class] = ACTIONS(1211),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_function] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1211),
    [anon_sym_QMARK] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1215),
    [anon_sym_PIPE_PIPE] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1213),
    [anon_sym_GT_GT_GT] = ACTIONS(1215),
    [anon_sym_LT_LT] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1213),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_PIPE] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1215),
    [anon_sym_STAR_STAR] = ACTIONS(1215),
    [anon_sym_LT_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1215),
    [anon_sym_instanceof] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_void] = ACTIONS(1211),
    [anon_sym_delete] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym_number] = ACTIONS(1209),
    [sym_this] = ACTIONS(1211),
    [sym_super] = ACTIONS(1211),
    [sym_true] = ACTIONS(1211),
    [sym_false] = ACTIONS(1211),
    [sym_null] = ACTIONS(1211),
    [sym_undefined] = ACTIONS(1211),
    [anon_sym_AT] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1211),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1211),
    [anon_sym_declare] = ACTIONS(1211),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_module] = ACTIONS(1211),
    [anon_sym_any] = ACTIONS(1211),
    [anon_sym_number] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1211),
    [anon_sym_symbol] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1211),
    [anon_sym_enum] = ACTIONS(1211),
    [sym_readonly] = ACTIONS(1211),
    [sym__automatic_semicolon] = ACTIONS(1217),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1221),
    [anon_sym_export] = ACTIONS(1221),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_default] = ACTIONS(1221),
    [anon_sym_as] = ACTIONS(1223),
    [anon_sym_namespace] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1219),
    [anon_sym_type] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1221),
    [anon_sym_import] = ACTIONS(1221),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1221),
    [anon_sym_const] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1221),
    [anon_sym_else] = ACTIONS(1221),
    [anon_sym_switch] = ACTIONS(1221),
    [anon_sym_for] = ACTIONS(1221),
    [anon_sym_LPAREN] = ACTIONS(1219),
    [anon_sym_await] = ACTIONS(1221),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1221),
    [anon_sym_do] = ACTIONS(1221),
    [anon_sym_try] = ACTIONS(1221),
    [anon_sym_with] = ACTIONS(1221),
    [anon_sym_break] = ACTIONS(1221),
    [anon_sym_continue] = ACTIONS(1221),
    [anon_sym_debugger] = ACTIONS(1221),
    [anon_sym_return] = ACTIONS(1221),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym_case] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1219),
    [anon_sym_LT] = ACTIONS(1221),
    [anon_sym_GT] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_class] = ACTIONS(1221),
    [anon_sym_async] = ACTIONS(1221),
    [anon_sym_function] = ACTIONS(1221),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_instanceof] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1221),
    [anon_sym_TILDE] = ACTIONS(1219),
    [anon_sym_void] = ACTIONS(1221),
    [anon_sym_delete] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1219),
    [anon_sym_DASH_DASH] = ACTIONS(1219),
    [anon_sym_DQUOTE] = ACTIONS(1219),
    [anon_sym_SQUOTE] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1219),
    [sym_number] = ACTIONS(1219),
    [sym_this] = ACTIONS(1221),
    [sym_super] = ACTIONS(1221),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [sym_null] = ACTIONS(1221),
    [sym_undefined] = ACTIONS(1221),
    [anon_sym_AT] = ACTIONS(1219),
    [anon_sym_static] = ACTIONS(1221),
    [anon_sym_abstract] = ACTIONS(1221),
    [anon_sym_get] = ACTIONS(1221),
    [anon_sym_set] = ACTIONS(1221),
    [anon_sym_declare] = ACTIONS(1221),
    [anon_sym_public] = ACTIONS(1221),
    [anon_sym_private] = ACTIONS(1221),
    [anon_sym_protected] = ACTIONS(1221),
    [anon_sym_module] = ACTIONS(1221),
    [anon_sym_any] = ACTIONS(1221),
    [anon_sym_number] = ACTIONS(1221),
    [anon_sym_boolean] = ACTIONS(1221),
    [anon_sym_string] = ACTIONS(1221),
    [anon_sym_symbol] = ACTIONS(1221),
    [anon_sym_interface] = ACTIONS(1221),
    [anon_sym_enum] = ACTIONS(1221),
    [sym_readonly] = ACTIONS(1221),
    [sym__automatic_semicolon] = ACTIONS(1227),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(1229),
    [sym_identifier] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1231),
    [anon_sym_as] = ACTIONS(1231),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1231),
    [anon_sym_typeof] = ACTIONS(1231),
    [anon_sym_import] = ACTIONS(1231),
    [anon_sym_var] = ACTIONS(1231),
    [anon_sym_let] = ACTIONS(1231),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_else] = ACTIONS(1231),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_await] = ACTIONS(1231),
    [anon_sym_in] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1231),
    [anon_sym_try] = ACTIONS(1231),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_break] = ACTIONS(1231),
    [anon_sym_continue] = ACTIONS(1231),
    [anon_sym_debugger] = ACTIONS(1231),
    [anon_sym_return] = ACTIONS(1231),
    [anon_sym_throw] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_class] = ACTIONS(1231),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_QMARK] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_STAR_STAR] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_instanceof] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_void] = ACTIONS(1231),
    [anon_sym_delete] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_number] = ACTIONS(1229),
    [sym_this] = ACTIONS(1231),
    [sym_super] = ACTIONS(1231),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_AT] = ACTIONS(1229),
    [anon_sym_static] = ACTIONS(1231),
    [anon_sym_abstract] = ACTIONS(1231),
    [anon_sym_get] = ACTIONS(1231),
    [anon_sym_set] = ACTIONS(1231),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_public] = ACTIONS(1231),
    [anon_sym_private] = ACTIONS(1231),
    [anon_sym_protected] = ACTIONS(1231),
    [anon_sym_module] = ACTIONS(1231),
    [anon_sym_any] = ACTIONS(1231),
    [anon_sym_number] = ACTIONS(1231),
    [anon_sym_boolean] = ACTIONS(1231),
    [anon_sym_string] = ACTIONS(1231),
    [anon_sym_symbol] = ACTIONS(1231),
    [anon_sym_interface] = ACTIONS(1231),
    [anon_sym_enum] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(1231),
    [sym__automatic_semicolon] = ACTIONS(1229),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1235),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_STAR] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym_readonly] = ACTIONS(1235),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(1237),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(1239),
    [anon_sym_as] = ACTIONS(1239),
    [anon_sym_namespace] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_type] = ACTIONS(1239),
    [anon_sym_typeof] = ACTIONS(1239),
    [anon_sym_import] = ACTIONS(1239),
    [anon_sym_var] = ACTIONS(1239),
    [anon_sym_let] = ACTIONS(1239),
    [anon_sym_const] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1239),
    [anon_sym_switch] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_do] = ACTIONS(1239),
    [anon_sym_try] = ACTIONS(1239),
    [anon_sym_with] = ACTIONS(1239),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1239),
    [anon_sym_debugger] = ACTIONS(1239),
    [anon_sym_return] = ACTIONS(1239),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_yield] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_class] = ACTIONS(1239),
    [anon_sym_async] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_new] = ACTIONS(1239),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1239),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1239),
    [anon_sym_delete] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [sym_number] = ACTIONS(1237),
    [sym_this] = ACTIONS(1239),
    [sym_super] = ACTIONS(1239),
    [sym_true] = ACTIONS(1239),
    [sym_false] = ACTIONS(1239),
    [sym_null] = ACTIONS(1239),
    [sym_undefined] = ACTIONS(1239),
    [anon_sym_AT] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1239),
    [anon_sym_abstract] = ACTIONS(1239),
    [anon_sym_get] = ACTIONS(1239),
    [anon_sym_set] = ACTIONS(1239),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_public] = ACTIONS(1239),
    [anon_sym_private] = ACTIONS(1239),
    [anon_sym_protected] = ACTIONS(1239),
    [anon_sym_module] = ACTIONS(1239),
    [anon_sym_any] = ACTIONS(1239),
    [anon_sym_number] = ACTIONS(1239),
    [anon_sym_boolean] = ACTIONS(1239),
    [anon_sym_string] = ACTIONS(1239),
    [anon_sym_symbol] = ACTIONS(1239),
    [anon_sym_interface] = ACTIONS(1239),
    [anon_sym_enum] = ACTIONS(1239),
    [sym_readonly] = ACTIONS(1239),
    [sym__automatic_semicolon] = ACTIONS(1237),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(1241),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(1243),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_default] = ACTIONS(1243),
    [anon_sym_as] = ACTIONS(1243),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(1243),
    [anon_sym_import] = ACTIONS(1243),
    [anon_sym_var] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1243),
    [anon_sym_const] = ACTIONS(1243),
    [anon_sym_if] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1243),
    [anon_sym_switch] = ACTIONS(1243),
    [anon_sym_for] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_await] = ACTIONS(1243),
    [anon_sym_in] = ACTIONS(1243),
    [anon_sym_while] = ACTIONS(1243),
    [anon_sym_do] = ACTIONS(1243),
    [anon_sym_try] = ACTIONS(1243),
    [anon_sym_with] = ACTIONS(1243),
    [anon_sym_break] = ACTIONS(1243),
    [anon_sym_continue] = ACTIONS(1243),
    [anon_sym_debugger] = ACTIONS(1243),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_throw] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_DOT] = ACTIONS(1243),
    [anon_sym_class] = ACTIONS(1243),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1243),
    [anon_sym_new] = ACTIONS(1243),
    [anon_sym_QMARK] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1243),
    [anon_sym_GT_GT_GT] = ACTIONS(1241),
    [anon_sym_LT_LT] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_CARET] = ACTIONS(1241),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_PERCENT] = ACTIONS(1241),
    [anon_sym_STAR_STAR] = ACTIONS(1241),
    [anon_sym_LT_EQ] = ACTIONS(1241),
    [anon_sym_EQ_EQ] = ACTIONS(1243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1241),
    [anon_sym_BANG_EQ] = ACTIONS(1243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1241),
    [anon_sym_GT_EQ] = ACTIONS(1241),
    [anon_sym_instanceof] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_TILDE] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1243),
    [anon_sym_delete] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1241),
    [anon_sym_SQUOTE] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_super] = ACTIONS(1243),
    [sym_true] = ACTIONS(1243),
    [sym_false] = ACTIONS(1243),
    [sym_null] = ACTIONS(1243),
    [sym_undefined] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1243),
    [anon_sym_abstract] = ACTIONS(1243),
    [anon_sym_get] = ACTIONS(1243),
    [anon_sym_set] = ACTIONS(1243),
    [anon_sym_declare] = ACTIONS(1243),
    [anon_sym_public] = ACTIONS(1243),
    [anon_sym_private] = ACTIONS(1243),
    [anon_sym_protected] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1243),
    [anon_sym_any] = ACTIONS(1243),
    [anon_sym_number] = ACTIONS(1243),
    [anon_sym_boolean] = ACTIONS(1243),
    [anon_sym_string] = ACTIONS(1243),
    [anon_sym_symbol] = ACTIONS(1243),
    [anon_sym_interface] = ACTIONS(1243),
    [anon_sym_enum] = ACTIONS(1243),
    [sym_readonly] = ACTIONS(1243),
    [sym__automatic_semicolon] = ACTIONS(1241),
  },
  [130] = {
    [sym_import] = STATE(1148),
    [sym_expression_statement] = STATE(149),
    [sym_variable_declaration] = STATE(149),
    [sym_lexical_declaration] = STATE(149),
    [sym_empty_statement] = STATE(149),
    [sym_parenthesized_expression] = STATE(834),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1260),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1148),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1148),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(834),
    [sym_subscript_expression] = STATE(834),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_internal_module] = STATE(1148),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(1245),
    [anon_sym_export] = ACTIONS(1247),
    [anon_sym_namespace] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1247),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(1251),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1255),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1257),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_get] = ACTIONS(1247),
    [anon_sym_set] = ACTIONS(1247),
    [anon_sym_declare] = ACTIONS(1247),
    [anon_sym_public] = ACTIONS(1247),
    [anon_sym_private] = ACTIONS(1247),
    [anon_sym_protected] = ACTIONS(1247),
    [anon_sym_module] = ACTIONS(1247),
    [anon_sym_any] = ACTIONS(1247),
    [anon_sym_number] = ACTIONS(1247),
    [anon_sym_boolean] = ACTIONS(1247),
    [anon_sym_string] = ACTIONS(1247),
    [anon_sym_symbol] = ACTIONS(1247),
    [sym_readonly] = ACTIONS(1247),
  },
  [131] = {
    [sym_import] = STATE(1148),
    [sym_expression_statement] = STATE(150),
    [sym_variable_declaration] = STATE(150),
    [sym_lexical_declaration] = STATE(150),
    [sym_empty_statement] = STATE(150),
    [sym_parenthesized_expression] = STATE(834),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1260),
    [sym_array] = STATE(1372),
    [sym_class] = STATE(1148),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1148),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(834),
    [sym_subscript_expression] = STATE(834),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_internal_module] = STATE(1148),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(1245),
    [anon_sym_export] = ACTIONS(1247),
    [anon_sym_namespace] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1247),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(1251),
    [anon_sym_let] = ACTIONS(1253),
    [anon_sym_const] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1255),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(1257),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_get] = ACTIONS(1247),
    [anon_sym_set] = ACTIONS(1247),
    [anon_sym_declare] = ACTIONS(1247),
    [anon_sym_public] = ACTIONS(1247),
    [anon_sym_private] = ACTIONS(1247),
    [anon_sym_protected] = ACTIONS(1247),
    [anon_sym_module] = ACTIONS(1247),
    [anon_sym_any] = ACTIONS(1247),
    [anon_sym_number] = ACTIONS(1247),
    [anon_sym_boolean] = ACTIONS(1247),
    [anon_sym_string] = ACTIONS(1247),
    [anon_sym_symbol] = ACTIONS(1247),
    [sym_readonly] = ACTIONS(1247),
  },
  [132] = {
    [sym_import] = STATE(1096),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1096),
    [sym_yield_expression] = STATE(1096),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1496),
    [sym_class] = STATE(1096),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1096),
    [sym_arrow_function] = STATE(1096),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1096),
    [sym_new_expression] = STATE(1096),
    [sym_await_expression] = STATE(1096),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1096),
    [sym_augmented_assignment_expression] = STATE(1096),
    [sym_ternary_expression] = STATE(1096),
    [sym_binary_expression] = STATE(1096),
    [sym_unary_expression] = STATE(1096),
    [sym_update_expression] = STATE(1096),
    [sym_sequence_expression] = STATE(2845),
    [sym_string] = STATE(1096),
    [sym_template_string] = STATE(1096),
    [sym_regex] = STATE(1096),
    [sym_meta_property] = STATE(1096),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_rest_parameter] = STATE(2461),
    [sym_non_null_expression] = STATE(1096),
    [sym_type_assertion] = STATE(1096),
    [sym_as_expression] = STATE(1096),
    [sym_internal_module] = STATE(1096),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(1259),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1263),
    [sym_this] = ACTIONS(1265),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(815),
    [sym_false] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [sym_undefined] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(805),
    [anon_sym_private] = ACTIONS(805),
    [anon_sym_protected] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(765),
    [anon_sym_number] = ACTIONS(765),
    [anon_sym_boolean] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_symbol] = ACTIONS(765),
    [sym_readonly] = ACTIONS(809),
  },
  [133] = {
    [sym_import] = STATE(1027),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1027),
    [sym_yield_expression] = STATE(1027),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1496),
    [sym_class] = STATE(1027),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1027),
    [sym_arrow_function] = STATE(1027),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1027),
    [sym_new_expression] = STATE(1027),
    [sym_await_expression] = STATE(1027),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1027),
    [sym_augmented_assignment_expression] = STATE(1027),
    [sym_ternary_expression] = STATE(1027),
    [sym_binary_expression] = STATE(1027),
    [sym_unary_expression] = STATE(1027),
    [sym_update_expression] = STATE(1027),
    [sym_sequence_expression] = STATE(2787),
    [sym_string] = STATE(1027),
    [sym_template_string] = STATE(1027),
    [sym_regex] = STATE(1027),
    [sym_meta_property] = STATE(1027),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_rest_parameter] = STATE(2461),
    [sym_non_null_expression] = STATE(1027),
    [sym_type_assertion] = STATE(1027),
    [sym_as_expression] = STATE(1027),
    [sym_internal_module] = STATE(1027),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(1259),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1267),
    [sym_this] = ACTIONS(1265),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(817),
    [sym_false] = ACTIONS(817),
    [sym_null] = ACTIONS(817),
    [sym_undefined] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(805),
    [anon_sym_private] = ACTIONS(805),
    [anon_sym_protected] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(765),
    [anon_sym_number] = ACTIONS(765),
    [anon_sym_boolean] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_symbol] = ACTIONS(765),
    [sym_readonly] = ACTIONS(809),
  },
  [134] = {
    [sym_import] = STATE(990),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(1497),
    [sym_array] = STATE(1496),
    [sym_class] = STATE(990),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(990),
    [sym_arrow_function] = STATE(990),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_sequence_expression] = STATE(2898),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_rest_parameter] = STATE(2461),
    [sym_non_null_expression] = STATE(990),
    [sym_type_assertion] = STATE(990),
    [sym_as_expression] = STATE(990),
    [sym_internal_module] = STATE(990),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(1670),
    [sym_identifier] = ACTIONS(1259),
    [anon_sym_export] = ACTIONS(765),
    [anon_sym_namespace] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(1261),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1269),
    [sym_this] = ACTIONS(1265),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(803),
    [sym_false] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [sym_undefined] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_get] = ACTIONS(765),
    [anon_sym_set] = ACTIONS(765),
    [anon_sym_declare] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(805),
    [anon_sym_private] = ACTIONS(805),
    [anon_sym_protected] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_any] = ACTIONS(765),
    [anon_sym_number] = ACTIONS(765),
    [anon_sym_boolean] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_symbol] = ACTIONS(765),
    [sym_readonly] = ACTIONS(809),
  },
  [135] = {
    [sym_import] = STATE(1183),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1183),
    [sym_yield_expression] = STATE(1183),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1183),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1183),
    [sym_arrow_function] = STATE(1183),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1183),
    [sym_new_expression] = STATE(1183),
    [sym_await_expression] = STATE(1183),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1183),
    [sym_augmented_assignment_expression] = STATE(1183),
    [sym_spread_element] = STATE(2492),
    [sym_ternary_expression] = STATE(1183),
    [sym_binary_expression] = STATE(1183),
    [sym_unary_expression] = STATE(1183),
    [sym_update_expression] = STATE(1183),
    [sym_string] = STATE(1183),
    [sym_template_string] = STATE(1183),
    [sym_regex] = STATE(1183),
    [sym_meta_property] = STATE(1183),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1183),
    [sym_type_assertion] = STATE(1183),
    [sym_as_expression] = STATE(1183),
    [sym_internal_module] = STATE(1183),
    [sym_mapped_type_clause] = STATE(2970),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2493),
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_export] = ACTIONS(1273),
    [anon_sym_namespace] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(1273),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1277),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(1279),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1281),
    [sym_this] = ACTIONS(1283),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1283),
    [sym_false] = ACTIONS(1283),
    [sym_null] = ACTIONS(1283),
    [sym_undefined] = ACTIONS(1283),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1273),
    [anon_sym_get] = ACTIONS(1273),
    [anon_sym_set] = ACTIONS(1273),
    [anon_sym_declare] = ACTIONS(1273),
    [anon_sym_public] = ACTIONS(1273),
    [anon_sym_private] = ACTIONS(1273),
    [anon_sym_protected] = ACTIONS(1273),
    [anon_sym_module] = ACTIONS(1273),
    [anon_sym_any] = ACTIONS(1273),
    [anon_sym_number] = ACTIONS(1273),
    [anon_sym_boolean] = ACTIONS(1273),
    [anon_sym_string] = ACTIONS(1273),
    [anon_sym_symbol] = ACTIONS(1273),
    [sym_readonly] = ACTIONS(1273),
  },
  [136] = {
    [sym_import] = STATE(1208),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1208),
    [sym_yield_expression] = STATE(1208),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1208),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1208),
    [sym_arrow_function] = STATE(1208),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1208),
    [sym_new_expression] = STATE(1208),
    [sym_await_expression] = STATE(1208),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1208),
    [sym_augmented_assignment_expression] = STATE(1208),
    [sym_spread_element] = STATE(2420),
    [sym_ternary_expression] = STATE(1208),
    [sym_binary_expression] = STATE(1208),
    [sym_unary_expression] = STATE(1208),
    [sym_update_expression] = STATE(1208),
    [sym_string] = STATE(1208),
    [sym_template_string] = STATE(1208),
    [sym_regex] = STATE(1208),
    [sym_meta_property] = STATE(1208),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1208),
    [sym_type_assertion] = STATE(1208),
    [sym_as_expression] = STATE(1208),
    [sym_internal_module] = STATE(1208),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2421),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1287),
    [sym_this] = ACTIONS(1289),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1289),
    [sym_false] = ACTIONS(1289),
    [sym_null] = ACTIONS(1289),
    [sym_undefined] = ACTIONS(1289),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [137] = {
    [sym_import] = STATE(1182),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1182),
    [sym_yield_expression] = STATE(1182),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1182),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1182),
    [sym_arrow_function] = STATE(1182),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1182),
    [sym_new_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1182),
    [sym_augmented_assignment_expression] = STATE(1182),
    [sym_spread_element] = STATE(2558),
    [sym_ternary_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_update_expression] = STATE(1182),
    [sym_string] = STATE(1182),
    [sym_template_string] = STATE(1182),
    [sym_regex] = STATE(1182),
    [sym_meta_property] = STATE(1182),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1182),
    [sym_type_assertion] = STATE(1182),
    [sym_as_expression] = STATE(1182),
    [sym_internal_module] = STATE(1182),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(1291),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1293),
    [sym_this] = ACTIONS(1295),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1295),
    [sym_false] = ACTIONS(1295),
    [sym_null] = ACTIONS(1295),
    [sym_undefined] = ACTIONS(1295),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [138] = {
    [sym_import] = STATE(1248),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1248),
    [sym_yield_expression] = STATE(1248),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1248),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1248),
    [sym_arrow_function] = STATE(1248),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1248),
    [sym_new_expression] = STATE(1248),
    [sym_await_expression] = STATE(1248),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1248),
    [sym_augmented_assignment_expression] = STATE(1248),
    [sym_spread_element] = STATE(2555),
    [sym_ternary_expression] = STATE(1248),
    [sym_binary_expression] = STATE(1248),
    [sym_unary_expression] = STATE(1248),
    [sym_update_expression] = STATE(1248),
    [sym_string] = STATE(1248),
    [sym_template_string] = STATE(1248),
    [sym_regex] = STATE(1248),
    [sym_meta_property] = STATE(1248),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1248),
    [sym_type_assertion] = STATE(1248),
    [sym_as_expression] = STATE(1248),
    [sym_internal_module] = STATE(1248),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2563),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1297),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1299),
    [sym_this] = ACTIONS(1301),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1301),
    [sym_false] = ACTIONS(1301),
    [sym_null] = ACTIONS(1301),
    [sym_undefined] = ACTIONS(1301),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [139] = {
    [sym_import] = STATE(1223),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1223),
    [sym_yield_expression] = STATE(1223),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1223),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1223),
    [sym_arrow_function] = STATE(1223),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1223),
    [sym_new_expression] = STATE(1223),
    [sym_await_expression] = STATE(1223),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1223),
    [sym_augmented_assignment_expression] = STATE(1223),
    [sym_spread_element] = STATE(2387),
    [sym_ternary_expression] = STATE(1223),
    [sym_binary_expression] = STATE(1223),
    [sym_unary_expression] = STATE(1223),
    [sym_update_expression] = STATE(1223),
    [sym_string] = STATE(1223),
    [sym_template_string] = STATE(1223),
    [sym_regex] = STATE(1223),
    [sym_meta_property] = STATE(1223),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1223),
    [sym_type_assertion] = STATE(1223),
    [sym_as_expression] = STATE(1223),
    [sym_internal_module] = STATE(1223),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2388),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1303),
    [sym_this] = ACTIONS(1305),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1305),
    [sym_false] = ACTIONS(1305),
    [sym_null] = ACTIONS(1305),
    [sym_undefined] = ACTIONS(1305),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [140] = {
    [sym_import] = STATE(1195),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1195),
    [sym_yield_expression] = STATE(1195),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1195),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1195),
    [sym_arrow_function] = STATE(1195),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1195),
    [sym_new_expression] = STATE(1195),
    [sym_await_expression] = STATE(1195),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1195),
    [sym_augmented_assignment_expression] = STATE(1195),
    [sym_spread_element] = STATE(2487),
    [sym_ternary_expression] = STATE(1195),
    [sym_binary_expression] = STATE(1195),
    [sym_unary_expression] = STATE(1195),
    [sym_update_expression] = STATE(1195),
    [sym_string] = STATE(1195),
    [sym_template_string] = STATE(1195),
    [sym_regex] = STATE(1195),
    [sym_meta_property] = STATE(1195),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1195),
    [sym_type_assertion] = STATE(1195),
    [sym_as_expression] = STATE(1195),
    [sym_internal_module] = STATE(1195),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2565),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1307),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1309),
    [sym_this] = ACTIONS(1311),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1311),
    [sym_false] = ACTIONS(1311),
    [sym_null] = ACTIONS(1311),
    [sym_undefined] = ACTIONS(1311),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [141] = {
    [sym_import] = STATE(1139),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1139),
    [sym_yield_expression] = STATE(1139),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1139),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1139),
    [sym_arrow_function] = STATE(1139),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1139),
    [sym_new_expression] = STATE(1139),
    [sym_await_expression] = STATE(1139),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1139),
    [sym_augmented_assignment_expression] = STATE(1139),
    [sym_spread_element] = STATE(2414),
    [sym_ternary_expression] = STATE(1139),
    [sym_binary_expression] = STATE(1139),
    [sym_unary_expression] = STATE(1139),
    [sym_update_expression] = STATE(1139),
    [sym_string] = STATE(1139),
    [sym_template_string] = STATE(1139),
    [sym_regex] = STATE(1139),
    [sym_meta_property] = STATE(1139),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1139),
    [sym_type_assertion] = STATE(1139),
    [sym_as_expression] = STATE(1139),
    [sym_internal_module] = STATE(1139),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2407),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(827),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1313),
    [sym_this] = ACTIONS(839),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_null] = ACTIONS(839),
    [sym_undefined] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [142] = {
    [sym_import] = STATE(1233),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1233),
    [sym_yield_expression] = STATE(1233),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1233),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1233),
    [sym_arrow_function] = STATE(1233),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1233),
    [sym_new_expression] = STATE(1233),
    [sym_await_expression] = STATE(1233),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1233),
    [sym_augmented_assignment_expression] = STATE(1233),
    [sym_spread_element] = STATE(2492),
    [sym_ternary_expression] = STATE(1233),
    [sym_binary_expression] = STATE(1233),
    [sym_unary_expression] = STATE(1233),
    [sym_update_expression] = STATE(1233),
    [sym_string] = STATE(1233),
    [sym_template_string] = STATE(1233),
    [sym_regex] = STATE(1233),
    [sym_meta_property] = STATE(1233),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1233),
    [sym_type_assertion] = STATE(1233),
    [sym_as_expression] = STATE(1233),
    [sym_internal_module] = STATE(1233),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2493),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1315),
    [sym_this] = ACTIONS(849),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(849),
    [sym_false] = ACTIONS(849),
    [sym_null] = ACTIONS(849),
    [sym_undefined] = ACTIONS(849),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [143] = {
    [sym_import] = STATE(1185),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1185),
    [sym_yield_expression] = STATE(1185),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1185),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1185),
    [sym_arrow_function] = STATE(1185),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1185),
    [sym_new_expression] = STATE(1185),
    [sym_await_expression] = STATE(1185),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1185),
    [sym_augmented_assignment_expression] = STATE(1185),
    [sym_spread_element] = STATE(2387),
    [sym_ternary_expression] = STATE(1185),
    [sym_binary_expression] = STATE(1185),
    [sym_unary_expression] = STATE(1185),
    [sym_update_expression] = STATE(1185),
    [sym_string] = STATE(1185),
    [sym_template_string] = STATE(1185),
    [sym_regex] = STATE(1185),
    [sym_meta_property] = STATE(1185),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1185),
    [sym_type_assertion] = STATE(1185),
    [sym_as_expression] = STATE(1185),
    [sym_internal_module] = STATE(1185),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2388),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1317),
    [sym_this] = ACTIONS(845),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(845),
    [sym_false] = ACTIONS(845),
    [sym_null] = ACTIONS(845),
    [sym_undefined] = ACTIONS(845),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [144] = {
    [sym_import] = STATE(1211),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1211),
    [sym_yield_expression] = STATE(1211),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1211),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1211),
    [sym_arrow_function] = STATE(1211),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1211),
    [sym_new_expression] = STATE(1211),
    [sym_await_expression] = STATE(1211),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1211),
    [sym_augmented_assignment_expression] = STATE(1211),
    [sym_spread_element] = STATE(2413),
    [sym_ternary_expression] = STATE(1211),
    [sym_binary_expression] = STATE(1211),
    [sym_unary_expression] = STATE(1211),
    [sym_update_expression] = STATE(1211),
    [sym_string] = STATE(1211),
    [sym_template_string] = STATE(1211),
    [sym_regex] = STATE(1211),
    [sym_meta_property] = STATE(1211),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1211),
    [sym_type_assertion] = STATE(1211),
    [sym_as_expression] = STATE(1211),
    [sym_internal_module] = STATE(1211),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2416),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1321),
    [sym_this] = ACTIONS(1323),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1323),
    [sym_false] = ACTIONS(1323),
    [sym_null] = ACTIONS(1323),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [145] = {
    [sym_import] = STATE(1226),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1226),
    [sym_yield_expression] = STATE(1226),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1226),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1226),
    [sym_arrow_function] = STATE(1226),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1226),
    [sym_new_expression] = STATE(1226),
    [sym_await_expression] = STATE(1226),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1226),
    [sym_augmented_assignment_expression] = STATE(1226),
    [sym_spread_element] = STATE(2520),
    [sym_ternary_expression] = STATE(1226),
    [sym_binary_expression] = STATE(1226),
    [sym_unary_expression] = STATE(1226),
    [sym_update_expression] = STATE(1226),
    [sym_string] = STATE(1226),
    [sym_template_string] = STATE(1226),
    [sym_regex] = STATE(1226),
    [sym_meta_property] = STATE(1226),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1226),
    [sym_type_assertion] = STATE(1226),
    [sym_as_expression] = STATE(1226),
    [sym_internal_module] = STATE(1226),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2521),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1325),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1327),
    [sym_this] = ACTIONS(1329),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1329),
    [sym_false] = ACTIONS(1329),
    [sym_null] = ACTIONS(1329),
    [sym_undefined] = ACTIONS(1329),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [146] = {
    [sym_import] = STATE(1218),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1218),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1218),
    [sym_arrow_function] = STATE(1218),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1218),
    [sym_new_expression] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_spread_element] = STATE(2530),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_string] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1218),
    [sym_type_assertion] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2531),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(851),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1331),
    [sym_this] = ACTIONS(853),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(853),
    [sym_false] = ACTIONS(853),
    [sym_null] = ACTIONS(853),
    [sym_undefined] = ACTIONS(853),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [147] = {
    [sym_import] = STATE(1366),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1366),
    [sym_yield_expression] = STATE(1366),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1366),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1366),
    [sym_arrow_function] = STATE(1366),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1366),
    [sym_new_expression] = STATE(1366),
    [sym_await_expression] = STATE(1366),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1366),
    [sym_augmented_assignment_expression] = STATE(1366),
    [sym_spread_element] = STATE(2558),
    [sym_ternary_expression] = STATE(1366),
    [sym_binary_expression] = STATE(1366),
    [sym_unary_expression] = STATE(1366),
    [sym_update_expression] = STATE(1366),
    [sym_sequence_expression] = STATE(2297),
    [sym_string] = STATE(1366),
    [sym_template_string] = STATE(1366),
    [sym_regex] = STATE(1366),
    [sym_meta_property] = STATE(1366),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1366),
    [sym_type_assertion] = STATE(1366),
    [sym_as_expression] = STATE(1366),
    [sym_internal_module] = STATE(1366),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(1291),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1291),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1333),
    [sym_this] = ACTIONS(1335),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1335),
    [sym_false] = ACTIONS(1335),
    [sym_null] = ACTIONS(1335),
    [sym_undefined] = ACTIONS(1335),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [148] = {
    [sym_import] = STATE(1203),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1203),
    [sym_yield_expression] = STATE(1203),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1203),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1203),
    [sym_arrow_function] = STATE(1203),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1203),
    [sym_new_expression] = STATE(1203),
    [sym_await_expression] = STATE(1203),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1203),
    [sym_augmented_assignment_expression] = STATE(1203),
    [sym_spread_element] = STATE(2492),
    [sym_ternary_expression] = STATE(1203),
    [sym_binary_expression] = STATE(1203),
    [sym_unary_expression] = STATE(1203),
    [sym_update_expression] = STATE(1203),
    [sym_string] = STATE(1203),
    [sym_template_string] = STATE(1203),
    [sym_regex] = STATE(1203),
    [sym_meta_property] = STATE(1203),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1203),
    [sym_type_assertion] = STATE(1203),
    [sym_as_expression] = STATE(1203),
    [sym_internal_module] = STATE(1203),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [aux_sym_array_repeat1] = STATE(2493),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(847),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1337),
    [sym_this] = ACTIONS(1339),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1339),
    [sym_false] = ACTIONS(1339),
    [sym_null] = ACTIONS(1339),
    [sym_undefined] = ACTIONS(1339),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [149] = {
    [sym_import] = STATE(1148),
    [sym_expression_statement] = STATE(160),
    [sym_empty_statement] = STATE(160),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1148),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_internal_module] = STATE(1148),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [150] = {
    [sym_import] = STATE(1148),
    [sym_expression_statement] = STATE(161),
    [sym_empty_statement] = STATE(161),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1148),
    [sym_yield_expression] = STATE(1148),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1148),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1148),
    [sym_arrow_function] = STATE(1148),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1148),
    [sym_new_expression] = STATE(1148),
    [sym_await_expression] = STATE(1148),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1148),
    [sym_augmented_assignment_expression] = STATE(1148),
    [sym_ternary_expression] = STATE(1148),
    [sym_binary_expression] = STATE(1148),
    [sym_unary_expression] = STATE(1148),
    [sym_update_expression] = STATE(1148),
    [sym_sequence_expression] = STATE(2692),
    [sym_string] = STATE(1148),
    [sym_template_string] = STATE(1148),
    [sym_regex] = STATE(1148),
    [sym_meta_property] = STATE(1148),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1148),
    [sym_type_assertion] = STATE(1148),
    [sym_as_expression] = STATE(1148),
    [sym_internal_module] = STATE(1148),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [sym_this] = ACTIONS(91),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(91),
    [sym_false] = ACTIONS(91),
    [sym_null] = ACTIONS(91),
    [sym_undefined] = ACTIONS(91),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [151] = {
    [sym_import] = STATE(1175),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1175),
    [sym_yield_expression] = STATE(1175),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_nested_identifier] = STATE(2888),
    [sym_class] = STATE(1175),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1175),
    [sym_arrow_function] = STATE(1175),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1175),
    [sym_new_expression] = STATE(1175),
    [sym_await_expression] = STATE(1175),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1175),
    [sym_augmented_assignment_expression] = STATE(1175),
    [sym_ternary_expression] = STATE(1175),
    [sym_binary_expression] = STATE(1175),
    [sym_unary_expression] = STATE(1175),
    [sym_update_expression] = STATE(1175),
    [sym_string] = STATE(1175),
    [sym_template_string] = STATE(1175),
    [sym_regex] = STATE(1175),
    [sym_meta_property] = STATE(1175),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1175),
    [sym_as_expression] = STATE(1175),
    [sym_internal_module] = STATE(1175),
    [sym_nested_type_identifier] = STATE(2162),
    [sym_generic_type] = STATE(2459),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(1341),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1345),
    [sym_this] = ACTIONS(1347),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1347),
    [sym_false] = ACTIONS(1347),
    [sym_null] = ACTIONS(1347),
    [sym_undefined] = ACTIONS(1347),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [152] = {
    [sym_export_clause] = STATE(2328),
    [sym__declaration] = STATE(550),
    [sym_variable_declaration] = STATE(550),
    [sym_lexical_declaration] = STATE(550),
    [sym_class_declaration] = STATE(550),
    [sym_function_declaration] = STATE(550),
    [sym_generator_function_declaration] = STATE(550),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(550),
    [sym_ambient_declaration] = STATE(550),
    [sym_abstract_class_declaration] = STATE(550),
    [sym_module] = STATE(550),
    [sym_internal_module] = STATE(550),
    [sym_import_alias] = STATE(550),
    [sym_interface_declaration] = STATE(550),
    [sym_enum_declaration] = STATE(550),
    [sym_type_alias_declaration] = STATE(550),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2396),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [153] = {
    [sym_import] = STATE(1126),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1126),
    [sym_yield_expression] = STATE(1126),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1126),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1126),
    [sym_arrow_function] = STATE(1126),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1126),
    [sym_new_expression] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1126),
    [sym_augmented_assignment_expression] = STATE(1126),
    [sym_ternary_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_unary_expression] = STATE(1126),
    [sym_update_expression] = STATE(1126),
    [sym_string] = STATE(1126),
    [sym_template_string] = STATE(1126),
    [sym_regex] = STATE(1126),
    [sym_meta_property] = STATE(1126),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1126),
    [sym_type_assertion] = STATE(1126),
    [sym_as_expression] = STATE(1126),
    [sym_internal_module] = STATE(1126),
    [sym_nested_type_identifier] = STATE(2055),
    [sym_generic_type] = STATE(2305),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1394),
    [sym_this] = ACTIONS(1396),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1396),
    [sym_false] = ACTIONS(1396),
    [sym_null] = ACTIONS(1396),
    [sym_undefined] = ACTIONS(1396),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [154] = {
    [sym_import] = STATE(1176),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1176),
    [sym_yield_expression] = STATE(1176),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1176),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1176),
    [sym_arrow_function] = STATE(1176),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1176),
    [sym_new_expression] = STATE(1176),
    [sym_await_expression] = STATE(1176),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1176),
    [sym_augmented_assignment_expression] = STATE(1176),
    [sym_ternary_expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_unary_expression] = STATE(1176),
    [sym_update_expression] = STATE(1176),
    [sym_sequence_expression] = STATE(2768),
    [sym_string] = STATE(1176),
    [sym_template_string] = STATE(1176),
    [sym_regex] = STATE(1176),
    [sym_meta_property] = STATE(1176),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1176),
    [sym_type_assertion] = STATE(1176),
    [sym_as_expression] = STATE(1176),
    [sym_internal_module] = STATE(1176),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1400),
    [sym_this] = ACTIONS(1402),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [sym_null] = ACTIONS(1402),
    [sym_undefined] = ACTIONS(1402),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
    [sym__automatic_semicolon] = ACTIONS(1398),
  },
  [155] = {
    [sym_import] = STATE(1083),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1083),
    [sym_yield_expression] = STATE(1083),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_nested_identifier] = STATE(2888),
    [sym_class] = STATE(1083),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1083),
    [sym_arrow_function] = STATE(1083),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1083),
    [sym_new_expression] = STATE(1083),
    [sym_await_expression] = STATE(1083),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1083),
    [sym_augmented_assignment_expression] = STATE(1083),
    [sym_ternary_expression] = STATE(1083),
    [sym_binary_expression] = STATE(1083),
    [sym_unary_expression] = STATE(1083),
    [sym_update_expression] = STATE(1083),
    [sym_string] = STATE(1083),
    [sym_template_string] = STATE(1083),
    [sym_regex] = STATE(1083),
    [sym_meta_property] = STATE(1083),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1083),
    [sym_type_assertion] = STATE(1083),
    [sym_as_expression] = STATE(1083),
    [sym_internal_module] = STATE(1083),
    [sym_nested_type_identifier] = STATE(2068),
    [sym_generic_type] = STATE(2355),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1406),
    [sym_this] = ACTIONS(1408),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1408),
    [sym_false] = ACTIONS(1408),
    [sym_null] = ACTIONS(1408),
    [sym_undefined] = ACTIONS(1408),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [156] = {
    [sym_import] = STATE(1173),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1173),
    [sym_yield_expression] = STATE(1173),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_nested_identifier] = STATE(2777),
    [sym_class] = STATE(1173),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1173),
    [sym_arrow_function] = STATE(1173),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1173),
    [sym_new_expression] = STATE(1173),
    [sym_await_expression] = STATE(1173),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1173),
    [sym_augmented_assignment_expression] = STATE(1173),
    [sym_ternary_expression] = STATE(1173),
    [sym_binary_expression] = STATE(1173),
    [sym_unary_expression] = STATE(1173),
    [sym_update_expression] = STATE(1173),
    [sym_string] = STATE(1173),
    [sym_template_string] = STATE(1173),
    [sym_regex] = STATE(1173),
    [sym_meta_property] = STATE(1173),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1173),
    [sym_type_assertion] = STATE(1173),
    [sym_as_expression] = STATE(1173),
    [sym_internal_module] = STATE(1173),
    [sym_nested_type_identifier] = STATE(2192),
    [sym_generic_type] = STATE(2488),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1410),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1412),
    [sym_this] = ACTIONS(1414),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1414),
    [sym_false] = ACTIONS(1414),
    [sym_null] = ACTIONS(1414),
    [sym_undefined] = ACTIONS(1414),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [157] = {
    [sym_import] = STATE(1548),
    [sym_parenthesized_expression] = STATE(897),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(1679),
    [sym_array] = STATE(1676),
    [sym_class] = STATE(1548),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1548),
    [sym_arrow_function] = STATE(1548),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(1548),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(897),
    [sym_subscript_expression] = STATE(897),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(1548),
    [sym_template_string] = STATE(1548),
    [sym_regex] = STATE(1548),
    [sym_meta_property] = STATE(1548),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1416),
    [anon_sym_export] = ACTIONS(1418),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1418),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_var] = ACTIONS(1422),
    [anon_sym_let] = ACTIONS(1422),
    [anon_sym_const] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1426),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1428),
    [sym_this] = ACTIONS(1430),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [sym_null] = ACTIONS(1430),
    [sym_undefined] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1418),
    [anon_sym_get] = ACTIONS(1418),
    [anon_sym_set] = ACTIONS(1418),
    [anon_sym_declare] = ACTIONS(1418),
    [anon_sym_public] = ACTIONS(1418),
    [anon_sym_private] = ACTIONS(1418),
    [anon_sym_protected] = ACTIONS(1418),
    [anon_sym_module] = ACTIONS(1418),
    [anon_sym_any] = ACTIONS(1418),
    [anon_sym_number] = ACTIONS(1418),
    [anon_sym_boolean] = ACTIONS(1418),
    [anon_sym_string] = ACTIONS(1418),
    [anon_sym_symbol] = ACTIONS(1418),
    [sym_readonly] = ACTIONS(1418),
  },
  [158] = {
    [sym_export_clause] = STATE(2328),
    [sym__declaration] = STATE(550),
    [sym_variable_declaration] = STATE(550),
    [sym_lexical_declaration] = STATE(550),
    [sym_class_declaration] = STATE(550),
    [sym_function_declaration] = STATE(550),
    [sym_generator_function_declaration] = STATE(550),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(550),
    [sym_ambient_declaration] = STATE(550),
    [sym_abstract_class_declaration] = STATE(550),
    [sym_module] = STATE(550),
    [sym_internal_module] = STATE(550),
    [sym_import_alias] = STATE(550),
    [sym_interface_declaration] = STATE(550),
    [sym_enum_declaration] = STATE(550),
    [sym_type_alias_declaration] = STATE(550),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2556),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [159] = {
    [sym_export_clause] = STATE(2328),
    [sym__declaration] = STATE(550),
    [sym_variable_declaration] = STATE(550),
    [sym_lexical_declaration] = STATE(550),
    [sym_class_declaration] = STATE(550),
    [sym_function_declaration] = STATE(550),
    [sym_generator_function_declaration] = STATE(550),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(550),
    [sym_ambient_declaration] = STATE(550),
    [sym_abstract_class_declaration] = STATE(550),
    [sym_module] = STATE(550),
    [sym_internal_module] = STATE(550),
    [sym_import_alias] = STATE(550),
    [sym_interface_declaration] = STATE(550),
    [sym_enum_declaration] = STATE(550),
    [sym_type_alias_declaration] = STATE(550),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2538),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [160] = {
    [sym_import] = STATE(1320),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1320),
    [sym_yield_expression] = STATE(1320),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1320),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1320),
    [sym_arrow_function] = STATE(1320),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1320),
    [sym_new_expression] = STATE(1320),
    [sym_await_expression] = STATE(1320),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1320),
    [sym_augmented_assignment_expression] = STATE(1320),
    [sym_ternary_expression] = STATE(1320),
    [sym_binary_expression] = STATE(1320),
    [sym_unary_expression] = STATE(1320),
    [sym_update_expression] = STATE(1320),
    [sym_sequence_expression] = STATE(2771),
    [sym_string] = STATE(1320),
    [sym_template_string] = STATE(1320),
    [sym_regex] = STATE(1320),
    [sym_meta_property] = STATE(1320),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1320),
    [sym_type_assertion] = STATE(1320),
    [sym_as_expression] = STATE(1320),
    [sym_internal_module] = STATE(1320),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1432),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1434),
    [sym_this] = ACTIONS(1436),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1436),
    [sym_false] = ACTIONS(1436),
    [sym_null] = ACTIONS(1436),
    [sym_undefined] = ACTIONS(1436),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [161] = {
    [sym_import] = STATE(1340),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1340),
    [sym_yield_expression] = STATE(1340),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1340),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1340),
    [sym_arrow_function] = STATE(1340),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1340),
    [sym_new_expression] = STATE(1340),
    [sym_await_expression] = STATE(1340),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1340),
    [sym_augmented_assignment_expression] = STATE(1340),
    [sym_ternary_expression] = STATE(1340),
    [sym_binary_expression] = STATE(1340),
    [sym_unary_expression] = STATE(1340),
    [sym_update_expression] = STATE(1340),
    [sym_sequence_expression] = STATE(2913),
    [sym_string] = STATE(1340),
    [sym_template_string] = STATE(1340),
    [sym_regex] = STATE(1340),
    [sym_meta_property] = STATE(1340),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1340),
    [sym_type_assertion] = STATE(1340),
    [sym_as_expression] = STATE(1340),
    [sym_internal_module] = STATE(1340),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_RPAREN] = ACTIONS(1438),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1440),
    [sym_this] = ACTIONS(1442),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [sym_null] = ACTIONS(1442),
    [sym_undefined] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [162] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_nested_identifier] = STATE(411),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [163] = {
    [sym_import] = STATE(959),
    [sym_parenthesized_expression] = STATE(648),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(931),
    [sym_array] = STATE(932),
    [sym_class] = STATE(959),
    [sym_function] = STATE(925),
    [sym_generator_function] = STATE(959),
    [sym_arrow_function] = STATE(959),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(959),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(959),
    [sym_template_string] = STATE(959),
    [sym_regex] = STATE(959),
    [sym_meta_property] = STATE(959),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2449),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2681),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1446),
    [anon_sym_export] = ACTIONS(1448),
    [anon_sym_namespace] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1454),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1456),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1458),
    [sym_this] = ACTIONS(1460),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_null] = ACTIONS(1460),
    [sym_undefined] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_get] = ACTIONS(1448),
    [anon_sym_set] = ACTIONS(1448),
    [anon_sym_declare] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym_protected] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(1448),
    [anon_sym_number] = ACTIONS(1448),
    [anon_sym_boolean] = ACTIONS(1448),
    [anon_sym_string] = ACTIONS(1448),
    [anon_sym_symbol] = ACTIONS(1448),
    [sym_readonly] = ACTIONS(1448),
  },
  [164] = {
    [sym_import] = STATE(949),
    [sym_statement_block] = STATE(1114),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(949),
    [sym_yield_expression] = STATE(949),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(949),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(949),
    [sym_arrow_function] = STATE(949),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(949),
    [sym_new_expression] = STATE(949),
    [sym_await_expression] = STATE(949),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(949),
    [sym_augmented_assignment_expression] = STATE(949),
    [sym_ternary_expression] = STATE(949),
    [sym_binary_expression] = STATE(949),
    [sym_unary_expression] = STATE(949),
    [sym_update_expression] = STATE(949),
    [sym_string] = STATE(949),
    [sym_template_string] = STATE(949),
    [sym_regex] = STATE(949),
    [sym_meta_property] = STATE(949),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(949),
    [sym_type_assertion] = STATE(949),
    [sym_as_expression] = STATE(949),
    [sym_internal_module] = STATE(949),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1464),
    [sym_this] = ACTIONS(1466),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1466),
    [sym_false] = ACTIONS(1466),
    [sym_null] = ACTIONS(1466),
    [sym_undefined] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [165] = {
    [sym_import] = STATE(959),
    [sym_parenthesized_expression] = STATE(648),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(931),
    [sym_array] = STATE(932),
    [sym_class] = STATE(959),
    [sym_function] = STATE(925),
    [sym_generator_function] = STATE(959),
    [sym_arrow_function] = STATE(959),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(959),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(959),
    [sym_template_string] = STATE(959),
    [sym_regex] = STATE(959),
    [sym_meta_property] = STATE(959),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_export] = ACTIONS(1470),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1470),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1476),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1458),
    [sym_this] = ACTIONS(1460),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_null] = ACTIONS(1460),
    [sym_undefined] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_get] = ACTIONS(1470),
    [anon_sym_set] = ACTIONS(1470),
    [anon_sym_declare] = ACTIONS(1470),
    [anon_sym_public] = ACTIONS(1470),
    [anon_sym_private] = ACTIONS(1470),
    [anon_sym_protected] = ACTIONS(1470),
    [anon_sym_module] = ACTIONS(1470),
    [anon_sym_any] = ACTIONS(1470),
    [anon_sym_number] = ACTIONS(1470),
    [anon_sym_boolean] = ACTIONS(1470),
    [anon_sym_string] = ACTIONS(1470),
    [anon_sym_symbol] = ACTIONS(1470),
    [sym_readonly] = ACTIONS(1470),
  },
  [166] = {
    [sym_import] = STATE(1000),
    [sym_statement_block] = STATE(1374),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1000),
    [sym_yield_expression] = STATE(1000),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1000),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1000),
    [sym_arrow_function] = STATE(1000),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1000),
    [sym_new_expression] = STATE(1000),
    [sym_await_expression] = STATE(1000),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1000),
    [sym_augmented_assignment_expression] = STATE(1000),
    [sym_ternary_expression] = STATE(1000),
    [sym_binary_expression] = STATE(1000),
    [sym_unary_expression] = STATE(1000),
    [sym_update_expression] = STATE(1000),
    [sym_string] = STATE(1000),
    [sym_template_string] = STATE(1000),
    [sym_regex] = STATE(1000),
    [sym_meta_property] = STATE(1000),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1000),
    [sym_type_assertion] = STATE(1000),
    [sym_as_expression] = STATE(1000),
    [sym_internal_module] = STATE(1000),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1480),
    [sym_this] = ACTIONS(1482),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1482),
    [sym_false] = ACTIONS(1482),
    [sym_null] = ACTIONS(1482),
    [sym_undefined] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [167] = {
    [sym_import] = STATE(952),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(952),
    [sym_yield_expression] = STATE(952),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(952),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(952),
    [sym_arrow_function] = STATE(952),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(952),
    [sym_new_expression] = STATE(952),
    [sym_await_expression] = STATE(952),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(952),
    [sym_augmented_assignment_expression] = STATE(952),
    [sym_ternary_expression] = STATE(952),
    [sym_binary_expression] = STATE(952),
    [sym_unary_expression] = STATE(952),
    [sym_update_expression] = STATE(952),
    [sym_sequence_expression] = STATE(2297),
    [sym_string] = STATE(952),
    [sym_template_string] = STATE(952),
    [sym_regex] = STATE(952),
    [sym_meta_property] = STATE(952),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(952),
    [sym_type_assertion] = STATE(952),
    [sym_as_expression] = STATE(952),
    [sym_internal_module] = STATE(952),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1484),
    [sym_this] = ACTIONS(1486),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1486),
    [sym_false] = ACTIONS(1486),
    [sym_null] = ACTIONS(1486),
    [sym_undefined] = ACTIONS(1486),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [168] = {
    [sym_import] = STATE(959),
    [sym_parenthesized_expression] = STATE(648),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(931),
    [sym_array] = STATE(932),
    [sym_class] = STATE(959),
    [sym_function] = STATE(925),
    [sym_generator_function] = STATE(959),
    [sym_arrow_function] = STATE(959),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(959),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(959),
    [sym_template_string] = STATE(959),
    [sym_regex] = STATE(959),
    [sym_meta_property] = STATE(959),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2449),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2681),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1490),
    [anon_sym_namespace] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1496),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1458),
    [sym_this] = ACTIONS(1460),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_null] = ACTIONS(1460),
    [sym_undefined] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_get] = ACTIONS(1490),
    [anon_sym_set] = ACTIONS(1490),
    [anon_sym_declare] = ACTIONS(1490),
    [anon_sym_public] = ACTIONS(1490),
    [anon_sym_private] = ACTIONS(1490),
    [anon_sym_protected] = ACTIONS(1490),
    [anon_sym_module] = ACTIONS(1490),
    [anon_sym_any] = ACTIONS(1490),
    [anon_sym_number] = ACTIONS(1490),
    [anon_sym_boolean] = ACTIONS(1490),
    [anon_sym_string] = ACTIONS(1490),
    [anon_sym_symbol] = ACTIONS(1490),
    [sym_readonly] = ACTIONS(1490),
  },
  [169] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_nested_identifier] = STATE(411),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1498),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [170] = {
    [sym_import] = STATE(1143),
    [sym_statement_block] = STATE(1024),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1143),
    [sym_yield_expression] = STATE(1143),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1143),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1143),
    [sym_arrow_function] = STATE(1143),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1143),
    [sym_new_expression] = STATE(1143),
    [sym_await_expression] = STATE(1143),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1143),
    [sym_augmented_assignment_expression] = STATE(1143),
    [sym_ternary_expression] = STATE(1143),
    [sym_binary_expression] = STATE(1143),
    [sym_unary_expression] = STATE(1143),
    [sym_update_expression] = STATE(1143),
    [sym_string] = STATE(1143),
    [sym_template_string] = STATE(1143),
    [sym_regex] = STATE(1143),
    [sym_meta_property] = STATE(1143),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1143),
    [sym_type_assertion] = STATE(1143),
    [sym_as_expression] = STATE(1143),
    [sym_internal_module] = STATE(1143),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1500),
    [sym_this] = ACTIONS(1502),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_null] = ACTIONS(1502),
    [sym_undefined] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [171] = {
    [sym_import] = STATE(1144),
    [sym_statement_block] = STATE(1028),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1144),
    [sym_yield_expression] = STATE(1144),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1144),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1144),
    [sym_arrow_function] = STATE(1144),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1144),
    [sym_new_expression] = STATE(1144),
    [sym_await_expression] = STATE(1144),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1144),
    [sym_augmented_assignment_expression] = STATE(1144),
    [sym_ternary_expression] = STATE(1144),
    [sym_binary_expression] = STATE(1144),
    [sym_unary_expression] = STATE(1144),
    [sym_update_expression] = STATE(1144),
    [sym_string] = STATE(1144),
    [sym_template_string] = STATE(1144),
    [sym_regex] = STATE(1144),
    [sym_meta_property] = STATE(1144),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1144),
    [sym_type_assertion] = STATE(1144),
    [sym_as_expression] = STATE(1144),
    [sym_internal_module] = STATE(1144),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1504),
    [sym_this] = ACTIONS(1506),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_null] = ACTIONS(1506),
    [sym_undefined] = ACTIONS(1506),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [172] = {
    [sym_import] = STATE(1020),
    [sym_statement_block] = STATE(1381),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1020),
    [sym_yield_expression] = STATE(1020),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1020),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1020),
    [sym_arrow_function] = STATE(1020),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1020),
    [sym_new_expression] = STATE(1020),
    [sym_await_expression] = STATE(1020),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1020),
    [sym_augmented_assignment_expression] = STATE(1020),
    [sym_ternary_expression] = STATE(1020),
    [sym_binary_expression] = STATE(1020),
    [sym_unary_expression] = STATE(1020),
    [sym_update_expression] = STATE(1020),
    [sym_string] = STATE(1020),
    [sym_template_string] = STATE(1020),
    [sym_regex] = STATE(1020),
    [sym_meta_property] = STATE(1020),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1020),
    [sym_type_assertion] = STATE(1020),
    [sym_as_expression] = STATE(1020),
    [sym_internal_module] = STATE(1020),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1508),
    [sym_this] = ACTIONS(1510),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1510),
    [sym_false] = ACTIONS(1510),
    [sym_null] = ACTIONS(1510),
    [sym_undefined] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [173] = {
    [sym_import] = STATE(1145),
    [sym_statement_block] = STATE(1031),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1145),
    [sym_yield_expression] = STATE(1145),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1145),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1145),
    [sym_arrow_function] = STATE(1145),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1145),
    [sym_new_expression] = STATE(1145),
    [sym_await_expression] = STATE(1145),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1145),
    [sym_augmented_assignment_expression] = STATE(1145),
    [sym_ternary_expression] = STATE(1145),
    [sym_binary_expression] = STATE(1145),
    [sym_unary_expression] = STATE(1145),
    [sym_update_expression] = STATE(1145),
    [sym_string] = STATE(1145),
    [sym_template_string] = STATE(1145),
    [sym_regex] = STATE(1145),
    [sym_meta_property] = STATE(1145),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1145),
    [sym_type_assertion] = STATE(1145),
    [sym_as_expression] = STATE(1145),
    [sym_internal_module] = STATE(1145),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1512),
    [sym_this] = ACTIONS(1514),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [sym_null] = ACTIONS(1514),
    [sym_undefined] = ACTIONS(1514),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [174] = {
    [sym_import] = STATE(1022),
    [sym_statement_block] = STATE(1382),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1022),
    [sym_yield_expression] = STATE(1022),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1022),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1022),
    [sym_arrow_function] = STATE(1022),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1022),
    [sym_new_expression] = STATE(1022),
    [sym_await_expression] = STATE(1022),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1022),
    [sym_augmented_assignment_expression] = STATE(1022),
    [sym_ternary_expression] = STATE(1022),
    [sym_binary_expression] = STATE(1022),
    [sym_unary_expression] = STATE(1022),
    [sym_update_expression] = STATE(1022),
    [sym_string] = STATE(1022),
    [sym_template_string] = STATE(1022),
    [sym_regex] = STATE(1022),
    [sym_meta_property] = STATE(1022),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1022),
    [sym_type_assertion] = STATE(1022),
    [sym_as_expression] = STATE(1022),
    [sym_internal_module] = STATE(1022),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1516),
    [sym_this] = ACTIONS(1518),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1518),
    [sym_false] = ACTIONS(1518),
    [sym_null] = ACTIONS(1518),
    [sym_undefined] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [175] = {
    [sym_import] = STATE(1263),
    [sym_statement_block] = STATE(1130),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1263),
    [sym_yield_expression] = STATE(1263),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1263),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1263),
    [sym_arrow_function] = STATE(1263),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1263),
    [sym_new_expression] = STATE(1263),
    [sym_await_expression] = STATE(1263),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1263),
    [sym_augmented_assignment_expression] = STATE(1263),
    [sym_ternary_expression] = STATE(1263),
    [sym_binary_expression] = STATE(1263),
    [sym_unary_expression] = STATE(1263),
    [sym_update_expression] = STATE(1263),
    [sym_string] = STATE(1263),
    [sym_template_string] = STATE(1263),
    [sym_regex] = STATE(1263),
    [sym_meta_property] = STATE(1263),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1263),
    [sym_type_assertion] = STATE(1263),
    [sym_as_expression] = STATE(1263),
    [sym_internal_module] = STATE(1263),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1520),
    [sym_this] = ACTIONS(1522),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1522),
    [sym_false] = ACTIONS(1522),
    [sym_null] = ACTIONS(1522),
    [sym_undefined] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [176] = {
    [sym_import] = STATE(1146),
    [sym_statement_block] = STATE(1130),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1146),
    [sym_yield_expression] = STATE(1146),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1146),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1146),
    [sym_arrow_function] = STATE(1146),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1146),
    [sym_new_expression] = STATE(1146),
    [sym_await_expression] = STATE(1146),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1146),
    [sym_augmented_assignment_expression] = STATE(1146),
    [sym_ternary_expression] = STATE(1146),
    [sym_binary_expression] = STATE(1146),
    [sym_unary_expression] = STATE(1146),
    [sym_update_expression] = STATE(1146),
    [sym_string] = STATE(1146),
    [sym_template_string] = STATE(1146),
    [sym_regex] = STATE(1146),
    [sym_meta_property] = STATE(1146),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1146),
    [sym_type_assertion] = STATE(1146),
    [sym_as_expression] = STATE(1146),
    [sym_internal_module] = STATE(1146),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1524),
    [sym_this] = ACTIONS(1526),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [sym_null] = ACTIONS(1526),
    [sym_undefined] = ACTIONS(1526),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [177] = {
    [sym_import] = STATE(1264),
    [sym_statement_block] = STATE(1031),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1264),
    [sym_yield_expression] = STATE(1264),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1264),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1264),
    [sym_arrow_function] = STATE(1264),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1264),
    [sym_new_expression] = STATE(1264),
    [sym_await_expression] = STATE(1264),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1264),
    [sym_augmented_assignment_expression] = STATE(1264),
    [sym_ternary_expression] = STATE(1264),
    [sym_binary_expression] = STATE(1264),
    [sym_unary_expression] = STATE(1264),
    [sym_update_expression] = STATE(1264),
    [sym_string] = STATE(1264),
    [sym_template_string] = STATE(1264),
    [sym_regex] = STATE(1264),
    [sym_meta_property] = STATE(1264),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1264),
    [sym_type_assertion] = STATE(1264),
    [sym_as_expression] = STATE(1264),
    [sym_internal_module] = STATE(1264),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1528),
    [sym_this] = ACTIONS(1530),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [sym_null] = ACTIONS(1530),
    [sym_undefined] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [178] = {
    [sym_import] = STATE(1548),
    [sym_variable_declarator] = STATE(2327),
    [sym_parenthesized_expression] = STATE(899),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(984),
    [sym_array] = STATE(983),
    [sym_class] = STATE(1548),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1548),
    [sym_arrow_function] = STATE(1548),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(1548),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(899),
    [sym_subscript_expression] = STATE(899),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(1548),
    [sym_template_string] = STATE(1548),
    [sym_regex] = STATE(1548),
    [sym_meta_property] = STATE(1548),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1538),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1428),
    [sym_this] = ACTIONS(1430),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [sym_null] = ACTIONS(1430),
    [sym_undefined] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [sym_readonly] = ACTIONS(1534),
  },
  [179] = {
    [sym_import] = STATE(1548),
    [sym_variable_declarator] = STATE(2363),
    [sym_parenthesized_expression] = STATE(899),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(984),
    [sym_array] = STATE(983),
    [sym_class] = STATE(1548),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1548),
    [sym_arrow_function] = STATE(1548),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(1548),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(899),
    [sym_subscript_expression] = STATE(899),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(1548),
    [sym_template_string] = STATE(1548),
    [sym_regex] = STATE(1548),
    [sym_meta_property] = STATE(1548),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1538),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1428),
    [sym_this] = ACTIONS(1430),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [sym_null] = ACTIONS(1430),
    [sym_undefined] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [sym_readonly] = ACTIONS(1534),
  },
  [180] = {
    [sym__declaration] = STATE(514),
    [sym_variable_declaration] = STATE(514),
    [sym_lexical_declaration] = STATE(514),
    [sym_class_declaration] = STATE(514),
    [sym_function_declaration] = STATE(514),
    [sym_generator_function_declaration] = STATE(514),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(514),
    [sym_ambient_declaration] = STATE(514),
    [sym_abstract_class_declaration] = STATE(514),
    [sym_module] = STATE(514),
    [sym_internal_module] = STATE(514),
    [sym_import_alias] = STATE(514),
    [sym_interface_declaration] = STATE(514),
    [sym_enum_declaration] = STATE(514),
    [sym_type_alias_declaration] = STATE(514),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2538),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_global] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [181] = {
    [sym_import] = STATE(1265),
    [sym_statement_block] = STATE(1028),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1265),
    [sym_yield_expression] = STATE(1265),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1265),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1265),
    [sym_arrow_function] = STATE(1265),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1265),
    [sym_new_expression] = STATE(1265),
    [sym_await_expression] = STATE(1265),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1265),
    [sym_augmented_assignment_expression] = STATE(1265),
    [sym_ternary_expression] = STATE(1265),
    [sym_binary_expression] = STATE(1265),
    [sym_unary_expression] = STATE(1265),
    [sym_update_expression] = STATE(1265),
    [sym_string] = STATE(1265),
    [sym_template_string] = STATE(1265),
    [sym_regex] = STATE(1265),
    [sym_meta_property] = STATE(1265),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1265),
    [sym_type_assertion] = STATE(1265),
    [sym_as_expression] = STATE(1265),
    [sym_internal_module] = STATE(1265),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1546),
    [sym_this] = ACTIONS(1548),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1548),
    [sym_false] = ACTIONS(1548),
    [sym_null] = ACTIONS(1548),
    [sym_undefined] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [182] = {
    [sym_import] = STATE(1266),
    [sym_statement_block] = STATE(1024),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1266),
    [sym_yield_expression] = STATE(1266),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1266),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1266),
    [sym_arrow_function] = STATE(1266),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1266),
    [sym_new_expression] = STATE(1266),
    [sym_await_expression] = STATE(1266),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1266),
    [sym_augmented_assignment_expression] = STATE(1266),
    [sym_ternary_expression] = STATE(1266),
    [sym_binary_expression] = STATE(1266),
    [sym_unary_expression] = STATE(1266),
    [sym_update_expression] = STATE(1266),
    [sym_string] = STATE(1266),
    [sym_template_string] = STATE(1266),
    [sym_regex] = STATE(1266),
    [sym_meta_property] = STATE(1266),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1266),
    [sym_type_assertion] = STATE(1266),
    [sym_as_expression] = STATE(1266),
    [sym_internal_module] = STATE(1266),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1550),
    [sym_this] = ACTIONS(1552),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1552),
    [sym_false] = ACTIONS(1552),
    [sym_null] = ACTIONS(1552),
    [sym_undefined] = ACTIONS(1552),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [183] = {
    [sym_import] = STATE(980),
    [sym_statement_block] = STATE(1019),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(980),
    [sym_yield_expression] = STATE(980),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(980),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(980),
    [sym_arrow_function] = STATE(980),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(980),
    [sym_new_expression] = STATE(980),
    [sym_await_expression] = STATE(980),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(980),
    [sym_augmented_assignment_expression] = STATE(980),
    [sym_ternary_expression] = STATE(980),
    [sym_binary_expression] = STATE(980),
    [sym_unary_expression] = STATE(980),
    [sym_update_expression] = STATE(980),
    [sym_string] = STATE(980),
    [sym_template_string] = STATE(980),
    [sym_regex] = STATE(980),
    [sym_meta_property] = STATE(980),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(980),
    [sym_type_assertion] = STATE(980),
    [sym_as_expression] = STATE(980),
    [sym_internal_module] = STATE(980),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1554),
    [sym_this] = ACTIONS(1556),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1556),
    [sym_false] = ACTIONS(1556),
    [sym_null] = ACTIONS(1556),
    [sym_undefined] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [184] = {
    [sym_import] = STATE(1119),
    [sym_statement_block] = STATE(1429),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1119),
    [sym_yield_expression] = STATE(1119),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1119),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1119),
    [sym_arrow_function] = STATE(1119),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1119),
    [sym_new_expression] = STATE(1119),
    [sym_await_expression] = STATE(1119),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1119),
    [sym_augmented_assignment_expression] = STATE(1119),
    [sym_ternary_expression] = STATE(1119),
    [sym_binary_expression] = STATE(1119),
    [sym_unary_expression] = STATE(1119),
    [sym_update_expression] = STATE(1119),
    [sym_string] = STATE(1119),
    [sym_template_string] = STATE(1119),
    [sym_regex] = STATE(1119),
    [sym_meta_property] = STATE(1119),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1119),
    [sym_type_assertion] = STATE(1119),
    [sym_as_expression] = STATE(1119),
    [sym_internal_module] = STATE(1119),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1558),
    [sym_this] = ACTIONS(1560),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1560),
    [sym_false] = ACTIONS(1560),
    [sym_null] = ACTIONS(1560),
    [sym_undefined] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [185] = {
    [sym_import] = STATE(963),
    [sym_statement_block] = STATE(1130),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(963),
    [sym_yield_expression] = STATE(963),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(963),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(963),
    [sym_arrow_function] = STATE(963),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(963),
    [sym_new_expression] = STATE(963),
    [sym_await_expression] = STATE(963),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(963),
    [sym_augmented_assignment_expression] = STATE(963),
    [sym_ternary_expression] = STATE(963),
    [sym_binary_expression] = STATE(963),
    [sym_unary_expression] = STATE(963),
    [sym_update_expression] = STATE(963),
    [sym_string] = STATE(963),
    [sym_template_string] = STATE(963),
    [sym_regex] = STATE(963),
    [sym_meta_property] = STATE(963),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(963),
    [sym_type_assertion] = STATE(963),
    [sym_as_expression] = STATE(963),
    [sym_internal_module] = STATE(963),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1562),
    [sym_this] = ACTIONS(1564),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_null] = ACTIONS(1564),
    [sym_undefined] = ACTIONS(1564),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [186] = {
    [sym_import] = STATE(1087),
    [sym_statement_block] = STATE(1469),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1087),
    [sym_yield_expression] = STATE(1087),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1087),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1087),
    [sym_arrow_function] = STATE(1087),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1087),
    [sym_new_expression] = STATE(1087),
    [sym_await_expression] = STATE(1087),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1087),
    [sym_augmented_assignment_expression] = STATE(1087),
    [sym_ternary_expression] = STATE(1087),
    [sym_binary_expression] = STATE(1087),
    [sym_unary_expression] = STATE(1087),
    [sym_update_expression] = STATE(1087),
    [sym_string] = STATE(1087),
    [sym_template_string] = STATE(1087),
    [sym_regex] = STATE(1087),
    [sym_meta_property] = STATE(1087),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1087),
    [sym_type_assertion] = STATE(1087),
    [sym_as_expression] = STATE(1087),
    [sym_internal_module] = STATE(1087),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1566),
    [sym_this] = ACTIONS(1568),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1568),
    [sym_false] = ACTIONS(1568),
    [sym_null] = ACTIONS(1568),
    [sym_undefined] = ACTIONS(1568),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [187] = {
    [sym_import] = STATE(1165),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1165),
    [sym_yield_expression] = STATE(1165),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_nested_identifier] = STATE(411),
    [sym_class] = STATE(1165),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1165),
    [sym_arrow_function] = STATE(1165),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1165),
    [sym_new_expression] = STATE(1165),
    [sym_await_expression] = STATE(1165),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1165),
    [sym_augmented_assignment_expression] = STATE(1165),
    [sym_ternary_expression] = STATE(1165),
    [sym_binary_expression] = STATE(1165),
    [sym_unary_expression] = STATE(1165),
    [sym_update_expression] = STATE(1165),
    [sym_string] = STATE(1165),
    [sym_template_string] = STATE(1165),
    [sym_regex] = STATE(1165),
    [sym_meta_property] = STATE(1165),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1165),
    [sym_as_expression] = STATE(1165),
    [sym_internal_module] = STATE(1165),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1570),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(754),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_undefined] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [188] = {
    [sym_import] = STATE(1157),
    [sym_statement_block] = STATE(1114),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1157),
    [sym_yield_expression] = STATE(1157),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1157),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1157),
    [sym_arrow_function] = STATE(1157),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1157),
    [sym_new_expression] = STATE(1157),
    [sym_await_expression] = STATE(1157),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1157),
    [sym_augmented_assignment_expression] = STATE(1157),
    [sym_ternary_expression] = STATE(1157),
    [sym_binary_expression] = STATE(1157),
    [sym_unary_expression] = STATE(1157),
    [sym_update_expression] = STATE(1157),
    [sym_string] = STATE(1157),
    [sym_template_string] = STATE(1157),
    [sym_regex] = STATE(1157),
    [sym_meta_property] = STATE(1157),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1157),
    [sym_type_assertion] = STATE(1157),
    [sym_as_expression] = STATE(1157),
    [sym_internal_module] = STATE(1157),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1572),
    [sym_this] = ACTIONS(1574),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1574),
    [sym_false] = ACTIONS(1574),
    [sym_null] = ACTIONS(1574),
    [sym_undefined] = ACTIONS(1574),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [189] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(411),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1576),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [190] = {
    [sym_import] = STATE(1285),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1285),
    [sym_yield_expression] = STATE(1285),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1285),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1285),
    [sym_arrow_function] = STATE(1285),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1285),
    [sym_new_expression] = STATE(1285),
    [sym_await_expression] = STATE(1285),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1285),
    [sym_augmented_assignment_expression] = STATE(1285),
    [sym_ternary_expression] = STATE(1285),
    [sym_binary_expression] = STATE(1285),
    [sym_unary_expression] = STATE(1285),
    [sym_update_expression] = STATE(1285),
    [sym_sequence_expression] = STATE(2879),
    [sym_string] = STATE(1285),
    [sym_template_string] = STATE(1285),
    [sym_regex] = STATE(1285),
    [sym_meta_property] = STATE(1285),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1285),
    [sym_as_expression] = STATE(1285),
    [sym_internal_module] = STATE(1285),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1578),
    [sym_this] = ACTIONS(1580),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1580),
    [sym_false] = ACTIONS(1580),
    [sym_null] = ACTIONS(1580),
    [sym_undefined] = ACTIONS(1580),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [191] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(411),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1582),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [192] = {
    [sym_import] = STATE(1442),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1562),
    [sym_yield_expression] = STATE(1562),
    [sym_object] = STATE(1276),
    [sym_array] = STATE(1274),
    [sym_class] = STATE(1442),
    [sym_function] = STATE(1231),
    [sym_generator_function] = STATE(1442),
    [sym_arrow_function] = STATE(1442),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1562),
    [sym_new_expression] = STATE(1442),
    [sym_await_expression] = STATE(1562),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1562),
    [sym_augmented_assignment_expression] = STATE(1562),
    [sym_ternary_expression] = STATE(1562),
    [sym_binary_expression] = STATE(1562),
    [sym_unary_expression] = STATE(1562),
    [sym_update_expression] = STATE(1562),
    [sym_string] = STATE(1442),
    [sym_template_string] = STATE(1442),
    [sym_regex] = STATE(1442),
    [sym_meta_property] = STATE(1442),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1562),
    [sym_type_assertion] = STATE(1562),
    [sym_as_expression] = STATE(1562),
    [sym_internal_module] = STATE(1562),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(1584),
    [anon_sym_export] = ACTIONS(1586),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(1590),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1594),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1596),
    [sym_this] = ACTIONS(1598),
    [sym_super] = ACTIONS(1600),
    [sym_true] = ACTIONS(1598),
    [sym_false] = ACTIONS(1598),
    [sym_null] = ACTIONS(1598),
    [sym_undefined] = ACTIONS(1598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1586),
    [anon_sym_get] = ACTIONS(1586),
    [anon_sym_set] = ACTIONS(1586),
    [anon_sym_declare] = ACTIONS(1586),
    [anon_sym_public] = ACTIONS(1586),
    [anon_sym_private] = ACTIONS(1586),
    [anon_sym_protected] = ACTIONS(1586),
    [anon_sym_module] = ACTIONS(1586),
    [anon_sym_any] = ACTIONS(1586),
    [anon_sym_number] = ACTIONS(1586),
    [anon_sym_boolean] = ACTIONS(1586),
    [anon_sym_string] = ACTIONS(1586),
    [anon_sym_symbol] = ACTIONS(1586),
    [sym_readonly] = ACTIONS(1586),
  },
  [193] = {
    [sym_import] = STATE(1315),
    [sym_parenthesized_expression] = STATE(808),
    [sym__expression] = STATE(1532),
    [sym_yield_expression] = STATE(1532),
    [sym_object] = STATE(1192),
    [sym_array] = STATE(1193),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(1059),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1532),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1532),
    [sym_member_expression] = STATE(808),
    [sym_subscript_expression] = STATE(808),
    [sym_assignment_expression] = STATE(1532),
    [sym_augmented_assignment_expression] = STATE(1532),
    [sym_ternary_expression] = STATE(1532),
    [sym_binary_expression] = STATE(1532),
    [sym_unary_expression] = STATE(1532),
    [sym_update_expression] = STATE(1532),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2449),
    [sym_non_null_expression] = STATE(1532),
    [sym_type_assertion] = STATE(1532),
    [sym_as_expression] = STATE(1532),
    [sym_internal_module] = STATE(1532),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2681),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(1602),
    [anon_sym_export] = ACTIONS(1604),
    [anon_sym_namespace] = ACTIONS(1606),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1604),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1608),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1610),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1612),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1614),
    [sym_this] = ACTIONS(1616),
    [sym_super] = ACTIONS(1618),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_undefined] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1604),
    [anon_sym_get] = ACTIONS(1604),
    [anon_sym_set] = ACTIONS(1604),
    [anon_sym_declare] = ACTIONS(1604),
    [anon_sym_public] = ACTIONS(1604),
    [anon_sym_private] = ACTIONS(1604),
    [anon_sym_protected] = ACTIONS(1604),
    [anon_sym_module] = ACTIONS(1604),
    [anon_sym_any] = ACTIONS(1604),
    [anon_sym_number] = ACTIONS(1604),
    [anon_sym_boolean] = ACTIONS(1604),
    [anon_sym_string] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1604),
    [sym_readonly] = ACTIONS(1604),
  },
  [194] = {
    [sym_import] = STATE(970),
    [sym_statement_block] = STATE(1031),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(970),
    [sym_yield_expression] = STATE(970),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(970),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(970),
    [sym_arrow_function] = STATE(970),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(970),
    [sym_new_expression] = STATE(970),
    [sym_await_expression] = STATE(970),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(970),
    [sym_augmented_assignment_expression] = STATE(970),
    [sym_ternary_expression] = STATE(970),
    [sym_binary_expression] = STATE(970),
    [sym_unary_expression] = STATE(970),
    [sym_update_expression] = STATE(970),
    [sym_string] = STATE(970),
    [sym_template_string] = STATE(970),
    [sym_regex] = STATE(970),
    [sym_meta_property] = STATE(970),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(970),
    [sym_type_assertion] = STATE(970),
    [sym_as_expression] = STATE(970),
    [sym_internal_module] = STATE(970),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1620),
    [sym_this] = ACTIONS(1622),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1622),
    [sym_false] = ACTIONS(1622),
    [sym_null] = ACTIONS(1622),
    [sym_undefined] = ACTIONS(1622),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [195] = {
    [sym_import] = STATE(971),
    [sym_statement_block] = STATE(1028),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(971),
    [sym_yield_expression] = STATE(971),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(971),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(971),
    [sym_arrow_function] = STATE(971),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(971),
    [sym_new_expression] = STATE(971),
    [sym_await_expression] = STATE(971),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(971),
    [sym_augmented_assignment_expression] = STATE(971),
    [sym_ternary_expression] = STATE(971),
    [sym_binary_expression] = STATE(971),
    [sym_unary_expression] = STATE(971),
    [sym_update_expression] = STATE(971),
    [sym_string] = STATE(971),
    [sym_template_string] = STATE(971),
    [sym_regex] = STATE(971),
    [sym_meta_property] = STATE(971),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(971),
    [sym_type_assertion] = STATE(971),
    [sym_as_expression] = STATE(971),
    [sym_internal_module] = STATE(971),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1624),
    [sym_this] = ACTIONS(1626),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1626),
    [sym_false] = ACTIONS(1626),
    [sym_null] = ACTIONS(1626),
    [sym_undefined] = ACTIONS(1626),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [196] = {
    [sym__declaration] = STATE(514),
    [sym_variable_declaration] = STATE(514),
    [sym_lexical_declaration] = STATE(514),
    [sym_class_declaration] = STATE(514),
    [sym_function_declaration] = STATE(514),
    [sym_generator_function_declaration] = STATE(514),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(514),
    [sym_ambient_declaration] = STATE(514),
    [sym_abstract_class_declaration] = STATE(514),
    [sym_module] = STATE(514),
    [sym_internal_module] = STATE(514),
    [sym_import_alias] = STATE(514),
    [sym_interface_declaration] = STATE(514),
    [sym_enum_declaration] = STATE(514),
    [sym_type_alias_declaration] = STATE(514),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2556),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_global] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [197] = {
    [sym_import] = STATE(972),
    [sym_statement_block] = STATE(1024),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(972),
    [sym_yield_expression] = STATE(972),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(972),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(972),
    [sym_arrow_function] = STATE(972),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(972),
    [sym_new_expression] = STATE(972),
    [sym_await_expression] = STATE(972),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(972),
    [sym_augmented_assignment_expression] = STATE(972),
    [sym_ternary_expression] = STATE(972),
    [sym_binary_expression] = STATE(972),
    [sym_unary_expression] = STATE(972),
    [sym_update_expression] = STATE(972),
    [sym_string] = STATE(972),
    [sym_template_string] = STATE(972),
    [sym_regex] = STATE(972),
    [sym_meta_property] = STATE(972),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(972),
    [sym_type_assertion] = STATE(972),
    [sym_as_expression] = STATE(972),
    [sym_internal_module] = STATE(972),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1628),
    [sym_this] = ACTIONS(1630),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1630),
    [sym_false] = ACTIONS(1630),
    [sym_null] = ACTIONS(1630),
    [sym_undefined] = ACTIONS(1630),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [198] = {
    [sym_import] = STATE(1247),
    [sym_statement_block] = STATE(1654),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1247),
    [sym_yield_expression] = STATE(1247),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1247),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1247),
    [sym_arrow_function] = STATE(1247),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1247),
    [sym_new_expression] = STATE(1247),
    [sym_await_expression] = STATE(1247),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1247),
    [sym_augmented_assignment_expression] = STATE(1247),
    [sym_ternary_expression] = STATE(1247),
    [sym_binary_expression] = STATE(1247),
    [sym_unary_expression] = STATE(1247),
    [sym_update_expression] = STATE(1247),
    [sym_string] = STATE(1247),
    [sym_template_string] = STATE(1247),
    [sym_regex] = STATE(1247),
    [sym_meta_property] = STATE(1247),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1247),
    [sym_type_assertion] = STATE(1247),
    [sym_as_expression] = STATE(1247),
    [sym_internal_module] = STATE(1247),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1634),
    [sym_this] = ACTIONS(1636),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1636),
    [sym_false] = ACTIONS(1636),
    [sym_null] = ACTIONS(1636),
    [sym_undefined] = ACTIONS(1636),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [199] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(1851),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1638),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [200] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_nested_identifier] = STATE(411),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1640),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [201] = {
    [sym_import] = STATE(959),
    [sym_parenthesized_expression] = STATE(648),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(931),
    [sym_array] = STATE(932),
    [sym_class] = STATE(959),
    [sym_function] = STATE(925),
    [sym_generator_function] = STATE(959),
    [sym_arrow_function] = STATE(959),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(959),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(959),
    [sym_template_string] = STATE(959),
    [sym_regex] = STATE(959),
    [sym_meta_property] = STATE(959),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1446),
    [anon_sym_export] = ACTIONS(1448),
    [anon_sym_namespace] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1454),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1456),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1458),
    [sym_this] = ACTIONS(1460),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_null] = ACTIONS(1460),
    [sym_undefined] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_get] = ACTIONS(1448),
    [anon_sym_set] = ACTIONS(1448),
    [anon_sym_declare] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym_protected] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(1448),
    [anon_sym_number] = ACTIONS(1448),
    [anon_sym_boolean] = ACTIONS(1448),
    [anon_sym_string] = ACTIONS(1448),
    [anon_sym_symbol] = ACTIONS(1448),
    [sym_readonly] = ACTIONS(1448),
  },
  [202] = {
    [sym_import] = STATE(1315),
    [sym_parenthesized_expression] = STATE(808),
    [sym__expression] = STATE(1532),
    [sym_yield_expression] = STATE(1532),
    [sym_object] = STATE(1192),
    [sym_array] = STATE(1193),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(1059),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1532),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1532),
    [sym_member_expression] = STATE(808),
    [sym_subscript_expression] = STATE(808),
    [sym_assignment_expression] = STATE(1532),
    [sym_augmented_assignment_expression] = STATE(1532),
    [sym_ternary_expression] = STATE(1532),
    [sym_binary_expression] = STATE(1532),
    [sym_unary_expression] = STATE(1532),
    [sym_update_expression] = STATE(1532),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1532),
    [sym_type_assertion] = STATE(1532),
    [sym_as_expression] = STATE(1532),
    [sym_internal_module] = STATE(1532),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(1642),
    [anon_sym_export] = ACTIONS(1644),
    [anon_sym_namespace] = ACTIONS(1646),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1644),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1608),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1650),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1614),
    [sym_this] = ACTIONS(1616),
    [sym_super] = ACTIONS(1618),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_undefined] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_get] = ACTIONS(1644),
    [anon_sym_set] = ACTIONS(1644),
    [anon_sym_declare] = ACTIONS(1644),
    [anon_sym_public] = ACTIONS(1644),
    [anon_sym_private] = ACTIONS(1644),
    [anon_sym_protected] = ACTIONS(1644),
    [anon_sym_module] = ACTIONS(1644),
    [anon_sym_any] = ACTIONS(1644),
    [anon_sym_number] = ACTIONS(1644),
    [anon_sym_boolean] = ACTIONS(1644),
    [anon_sym_string] = ACTIONS(1644),
    [anon_sym_symbol] = ACTIONS(1644),
    [sym_readonly] = ACTIONS(1644),
  },
  [203] = {
    [sym_import] = STATE(959),
    [sym_parenthesized_expression] = STATE(648),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(931),
    [sym_array] = STATE(932),
    [sym_class] = STATE(959),
    [sym_function] = STATE(925),
    [sym_generator_function] = STATE(959),
    [sym_arrow_function] = STATE(959),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(959),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(959),
    [sym_template_string] = STATE(959),
    [sym_regex] = STATE(959),
    [sym_meta_property] = STATE(959),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2440),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2580),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1446),
    [anon_sym_export] = ACTIONS(1448),
    [anon_sym_namespace] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1454),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1456),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1458),
    [sym_this] = ACTIONS(1460),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_null] = ACTIONS(1460),
    [sym_undefined] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1448),
    [anon_sym_get] = ACTIONS(1448),
    [anon_sym_set] = ACTIONS(1448),
    [anon_sym_declare] = ACTIONS(1448),
    [anon_sym_public] = ACTIONS(1448),
    [anon_sym_private] = ACTIONS(1448),
    [anon_sym_protected] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(1448),
    [anon_sym_number] = ACTIONS(1448),
    [anon_sym_boolean] = ACTIONS(1448),
    [anon_sym_string] = ACTIONS(1448),
    [anon_sym_symbol] = ACTIONS(1448),
    [sym_readonly] = ACTIONS(1448),
  },
  [204] = {
    [sym_import] = STATE(1442),
    [sym_parenthesized_expression] = STATE(853),
    [sym__expression] = STATE(1562),
    [sym_yield_expression] = STATE(1562),
    [sym_object] = STATE(1276),
    [sym_array] = STATE(1274),
    [sym_class] = STATE(1442),
    [sym_function] = STATE(1231),
    [sym_generator_function] = STATE(1442),
    [sym_arrow_function] = STATE(1442),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1562),
    [sym_new_expression] = STATE(1442),
    [sym_await_expression] = STATE(1562),
    [sym_member_expression] = STATE(853),
    [sym_subscript_expression] = STATE(853),
    [sym_assignment_expression] = STATE(1562),
    [sym_augmented_assignment_expression] = STATE(1562),
    [sym_ternary_expression] = STATE(1562),
    [sym_binary_expression] = STATE(1562),
    [sym_unary_expression] = STATE(1562),
    [sym_update_expression] = STATE(1562),
    [sym_string] = STATE(1442),
    [sym_template_string] = STATE(1442),
    [sym_regex] = STATE(1442),
    [sym_meta_property] = STATE(1442),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2449),
    [sym_non_null_expression] = STATE(1562),
    [sym_type_assertion] = STATE(1562),
    [sym_as_expression] = STATE(1562),
    [sym_internal_module] = STATE(1562),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2681),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(1584),
    [anon_sym_export] = ACTIONS(1586),
    [anon_sym_namespace] = ACTIONS(1588),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(1586),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_DOT] = ACTIONS(1590),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(1592),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1594),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1596),
    [sym_this] = ACTIONS(1598),
    [sym_super] = ACTIONS(1600),
    [sym_true] = ACTIONS(1598),
    [sym_false] = ACTIONS(1598),
    [sym_null] = ACTIONS(1598),
    [sym_undefined] = ACTIONS(1598),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1586),
    [anon_sym_get] = ACTIONS(1586),
    [anon_sym_set] = ACTIONS(1586),
    [anon_sym_declare] = ACTIONS(1586),
    [anon_sym_public] = ACTIONS(1586),
    [anon_sym_private] = ACTIONS(1586),
    [anon_sym_protected] = ACTIONS(1586),
    [anon_sym_module] = ACTIONS(1586),
    [anon_sym_any] = ACTIONS(1586),
    [anon_sym_number] = ACTIONS(1586),
    [anon_sym_boolean] = ACTIONS(1586),
    [anon_sym_string] = ACTIONS(1586),
    [anon_sym_symbol] = ACTIONS(1586),
    [sym_readonly] = ACTIONS(1586),
  },
  [205] = {
    [sym_import] = STATE(959),
    [sym_parenthesized_expression] = STATE(648),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(931),
    [sym_array] = STATE(932),
    [sym_class] = STATE(959),
    [sym_function] = STATE(925),
    [sym_generator_function] = STATE(959),
    [sym_arrow_function] = STATE(959),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(959),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(959),
    [sym_template_string] = STATE(959),
    [sym_regex] = STATE(959),
    [sym_meta_property] = STATE(959),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1488),
    [anon_sym_export] = ACTIONS(1490),
    [anon_sym_namespace] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1490),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1494),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1496),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1458),
    [sym_this] = ACTIONS(1460),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_null] = ACTIONS(1460),
    [sym_undefined] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1490),
    [anon_sym_get] = ACTIONS(1490),
    [anon_sym_set] = ACTIONS(1490),
    [anon_sym_declare] = ACTIONS(1490),
    [anon_sym_public] = ACTIONS(1490),
    [anon_sym_private] = ACTIONS(1490),
    [anon_sym_protected] = ACTIONS(1490),
    [anon_sym_module] = ACTIONS(1490),
    [anon_sym_any] = ACTIONS(1490),
    [anon_sym_number] = ACTIONS(1490),
    [anon_sym_boolean] = ACTIONS(1490),
    [anon_sym_string] = ACTIONS(1490),
    [anon_sym_symbol] = ACTIONS(1490),
    [sym_readonly] = ACTIONS(1490),
  },
  [206] = {
    [sym_import] = STATE(959),
    [sym_parenthesized_expression] = STATE(648),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(931),
    [sym_array] = STATE(932),
    [sym_class] = STATE(959),
    [sym_function] = STATE(925),
    [sym_generator_function] = STATE(959),
    [sym_arrow_function] = STATE(959),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(959),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(648),
    [sym_subscript_expression] = STATE(648),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(959),
    [sym_template_string] = STATE(959),
    [sym_regex] = STATE(959),
    [sym_meta_property] = STATE(959),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2449),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2681),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_export] = ACTIONS(1470),
    [anon_sym_namespace] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1470),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1474),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1476),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1458),
    [sym_this] = ACTIONS(1460),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_null] = ACTIONS(1460),
    [sym_undefined] = ACTIONS(1460),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1470),
    [anon_sym_get] = ACTIONS(1470),
    [anon_sym_set] = ACTIONS(1470),
    [anon_sym_declare] = ACTIONS(1470),
    [anon_sym_public] = ACTIONS(1470),
    [anon_sym_private] = ACTIONS(1470),
    [anon_sym_protected] = ACTIONS(1470),
    [anon_sym_module] = ACTIONS(1470),
    [anon_sym_any] = ACTIONS(1470),
    [anon_sym_number] = ACTIONS(1470),
    [anon_sym_boolean] = ACTIONS(1470),
    [anon_sym_string] = ACTIONS(1470),
    [anon_sym_symbol] = ACTIONS(1470),
    [sym_readonly] = ACTIONS(1470),
  },
  [207] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_nested_identifier] = STATE(411),
    [sym_class] = STATE(1222),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1222),
    [sym_arrow_function] = STATE(1222),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1222),
    [sym_new_expression] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_string] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1222),
    [sym_type_assertion] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(1652),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(716),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_undefined] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [208] = {
    [sym_import] = STATE(1152),
    [sym_statement_block] = STATE(1588),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1152),
    [sym_yield_expression] = STATE(1152),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1152),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1152),
    [sym_arrow_function] = STATE(1152),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1152),
    [sym_new_expression] = STATE(1152),
    [sym_await_expression] = STATE(1152),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1152),
    [sym_augmented_assignment_expression] = STATE(1152),
    [sym_ternary_expression] = STATE(1152),
    [sym_binary_expression] = STATE(1152),
    [sym_unary_expression] = STATE(1152),
    [sym_update_expression] = STATE(1152),
    [sym_string] = STATE(1152),
    [sym_template_string] = STATE(1152),
    [sym_regex] = STATE(1152),
    [sym_meta_property] = STATE(1152),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1152),
    [sym_type_assertion] = STATE(1152),
    [sym_as_expression] = STATE(1152),
    [sym_internal_module] = STATE(1152),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1654),
    [sym_this] = ACTIONS(1656),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1656),
    [sym_false] = ACTIONS(1656),
    [sym_null] = ACTIONS(1656),
    [sym_undefined] = ACTIONS(1656),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [209] = {
    [sym_import] = STATE(1151),
    [sym_statement_block] = STATE(1592),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1151),
    [sym_yield_expression] = STATE(1151),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1151),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1151),
    [sym_arrow_function] = STATE(1151),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1151),
    [sym_new_expression] = STATE(1151),
    [sym_await_expression] = STATE(1151),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1151),
    [sym_augmented_assignment_expression] = STATE(1151),
    [sym_ternary_expression] = STATE(1151),
    [sym_binary_expression] = STATE(1151),
    [sym_unary_expression] = STATE(1151),
    [sym_update_expression] = STATE(1151),
    [sym_string] = STATE(1151),
    [sym_template_string] = STATE(1151),
    [sym_regex] = STATE(1151),
    [sym_meta_property] = STATE(1151),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1151),
    [sym_type_assertion] = STATE(1151),
    [sym_as_expression] = STATE(1151),
    [sym_internal_module] = STATE(1151),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1658),
    [sym_this] = ACTIONS(1660),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1660),
    [sym_false] = ACTIONS(1660),
    [sym_null] = ACTIONS(1660),
    [sym_undefined] = ACTIONS(1660),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [210] = {
    [sym_import] = STATE(1315),
    [sym_parenthesized_expression] = STATE(808),
    [sym__expression] = STATE(1532),
    [sym_yield_expression] = STATE(1532),
    [sym_object] = STATE(1192),
    [sym_array] = STATE(1193),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(1059),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1532),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1532),
    [sym_member_expression] = STATE(808),
    [sym_subscript_expression] = STATE(808),
    [sym_assignment_expression] = STATE(1532),
    [sym_augmented_assignment_expression] = STATE(1532),
    [sym_ternary_expression] = STATE(1532),
    [sym_binary_expression] = STATE(1532),
    [sym_unary_expression] = STATE(1532),
    [sym_update_expression] = STATE(1532),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1532),
    [sym_type_assertion] = STATE(1532),
    [sym_as_expression] = STATE(1532),
    [sym_internal_module] = STATE(1532),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(1602),
    [anon_sym_export] = ACTIONS(1604),
    [anon_sym_namespace] = ACTIONS(1606),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1604),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1608),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1610),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1612),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1614),
    [sym_this] = ACTIONS(1616),
    [sym_super] = ACTIONS(1618),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_undefined] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1604),
    [anon_sym_get] = ACTIONS(1604),
    [anon_sym_set] = ACTIONS(1604),
    [anon_sym_declare] = ACTIONS(1604),
    [anon_sym_public] = ACTIONS(1604),
    [anon_sym_private] = ACTIONS(1604),
    [anon_sym_protected] = ACTIONS(1604),
    [anon_sym_module] = ACTIONS(1604),
    [anon_sym_any] = ACTIONS(1604),
    [anon_sym_number] = ACTIONS(1604),
    [anon_sym_boolean] = ACTIONS(1604),
    [anon_sym_string] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1604),
    [sym_readonly] = ACTIONS(1604),
  },
  [211] = {
    [sym_import] = STATE(1164),
    [sym_statement_block] = STATE(1019),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1164),
    [sym_yield_expression] = STATE(1164),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1164),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1164),
    [sym_arrow_function] = STATE(1164),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1164),
    [sym_new_expression] = STATE(1164),
    [sym_await_expression] = STATE(1164),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1164),
    [sym_augmented_assignment_expression] = STATE(1164),
    [sym_ternary_expression] = STATE(1164),
    [sym_binary_expression] = STATE(1164),
    [sym_unary_expression] = STATE(1164),
    [sym_update_expression] = STATE(1164),
    [sym_string] = STATE(1164),
    [sym_template_string] = STATE(1164),
    [sym_regex] = STATE(1164),
    [sym_meta_property] = STATE(1164),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1164),
    [sym_type_assertion] = STATE(1164),
    [sym_as_expression] = STATE(1164),
    [sym_internal_module] = STATE(1164),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1662),
    [sym_this] = ACTIONS(1664),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1664),
    [sym_false] = ACTIONS(1664),
    [sym_null] = ACTIONS(1664),
    [sym_undefined] = ACTIONS(1664),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [212] = {
    [sym_export_clause] = STATE(2328),
    [sym__declaration] = STATE(550),
    [sym_variable_declaration] = STATE(550),
    [sym_lexical_declaration] = STATE(550),
    [sym_class_declaration] = STATE(550),
    [sym_function_declaration] = STATE(550),
    [sym_generator_function_declaration] = STATE(550),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(550),
    [sym_ambient_declaration] = STATE(550),
    [sym_abstract_class_declaration] = STATE(550),
    [sym_module] = STATE(550),
    [sym_internal_module] = STATE(550),
    [sym_import_alias] = STATE(550),
    [sym_interface_declaration] = STATE(550),
    [sym_enum_declaration] = STATE(550),
    [sym_type_alias_declaration] = STATE(550),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_as] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1668),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [213] = {
    [sym_import] = STATE(1296),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1296),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1296),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1296),
    [sym_arrow_function] = STATE(1296),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1296),
    [sym_new_expression] = STATE(1296),
    [sym_await_expression] = STATE(1296),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1296),
    [sym_augmented_assignment_expression] = STATE(1296),
    [sym_ternary_expression] = STATE(1296),
    [sym_binary_expression] = STATE(1296),
    [sym_unary_expression] = STATE(1296),
    [sym_update_expression] = STATE(1296),
    [sym_sequence_expression] = STATE(2794),
    [sym_string] = STATE(1296),
    [sym_template_string] = STATE(1296),
    [sym_regex] = STATE(1296),
    [sym_meta_property] = STATE(1296),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1296),
    [sym_type_assertion] = STATE(1296),
    [sym_as_expression] = STATE(1296),
    [sym_internal_module] = STATE(1296),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1670),
    [sym_this] = ACTIONS(1672),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_null] = ACTIONS(1672),
    [sym_undefined] = ACTIONS(1672),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [214] = {
    [sym_import] = STATE(1150),
    [sym_statement_block] = STATE(1599),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1150),
    [sym_yield_expression] = STATE(1150),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1150),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1150),
    [sym_arrow_function] = STATE(1150),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1150),
    [sym_new_expression] = STATE(1150),
    [sym_await_expression] = STATE(1150),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1150),
    [sym_augmented_assignment_expression] = STATE(1150),
    [sym_ternary_expression] = STATE(1150),
    [sym_binary_expression] = STATE(1150),
    [sym_unary_expression] = STATE(1150),
    [sym_update_expression] = STATE(1150),
    [sym_string] = STATE(1150),
    [sym_template_string] = STATE(1150),
    [sym_regex] = STATE(1150),
    [sym_meta_property] = STATE(1150),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1150),
    [sym_type_assertion] = STATE(1150),
    [sym_as_expression] = STATE(1150),
    [sym_internal_module] = STATE(1150),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1674),
    [sym_this] = ACTIONS(1676),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1676),
    [sym_false] = ACTIONS(1676),
    [sym_null] = ACTIONS(1676),
    [sym_undefined] = ACTIONS(1676),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [215] = {
    [sym_import] = STATE(1270),
    [sym_statement_block] = STATE(1114),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1270),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1270),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1270),
    [sym_arrow_function] = STATE(1270),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_ternary_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_update_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_regex] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1270),
    [sym_type_assertion] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_internal_module] = STATE(1270),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1678),
    [sym_this] = ACTIONS(1680),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1680),
    [sym_false] = ACTIONS(1680),
    [sym_null] = ACTIONS(1680),
    [sym_undefined] = ACTIONS(1680),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [216] = {
    [sym__declaration] = STATE(514),
    [sym_variable_declaration] = STATE(514),
    [sym_lexical_declaration] = STATE(514),
    [sym_class_declaration] = STATE(514),
    [sym_function_declaration] = STATE(514),
    [sym_generator_function_declaration] = STATE(514),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(514),
    [sym_ambient_declaration] = STATE(514),
    [sym_abstract_class_declaration] = STATE(514),
    [sym_module] = STATE(514),
    [sym_internal_module] = STATE(514),
    [sym_import_alias] = STATE(514),
    [sym_interface_declaration] = STATE(514),
    [sym_enum_declaration] = STATE(514),
    [sym_type_alias_declaration] = STATE(514),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [aux_sym_object_repeat1] = STATE(2396),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_global] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [217] = {
    [sym_import] = STATE(1294),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1294),
    [sym_yield_expression] = STATE(1294),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1294),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1294),
    [sym_arrow_function] = STATE(1294),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1294),
    [sym_new_expression] = STATE(1294),
    [sym_await_expression] = STATE(1294),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1294),
    [sym_augmented_assignment_expression] = STATE(1294),
    [sym_ternary_expression] = STATE(1294),
    [sym_binary_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1294),
    [sym_update_expression] = STATE(1294),
    [sym_sequence_expression] = STATE(2820),
    [sym_string] = STATE(1294),
    [sym_template_string] = STATE(1294),
    [sym_regex] = STATE(1294),
    [sym_meta_property] = STATE(1294),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1294),
    [sym_type_assertion] = STATE(1294),
    [sym_as_expression] = STATE(1294),
    [sym_internal_module] = STATE(1294),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1682),
    [sym_this] = ACTIONS(1684),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1684),
    [sym_false] = ACTIONS(1684),
    [sym_null] = ACTIONS(1684),
    [sym_undefined] = ACTIONS(1684),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [218] = {
    [sym_import] = STATE(1180),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1180),
    [sym_yield_expression] = STATE(1180),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1180),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1180),
    [sym_arrow_function] = STATE(1180),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1180),
    [sym_new_expression] = STATE(1180),
    [sym_await_expression] = STATE(1180),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1180),
    [sym_augmented_assignment_expression] = STATE(1180),
    [sym_ternary_expression] = STATE(1180),
    [sym_binary_expression] = STATE(1180),
    [sym_unary_expression] = STATE(1180),
    [sym_update_expression] = STATE(1180),
    [sym_sequence_expression] = STATE(2766),
    [sym_string] = STATE(1180),
    [sym_template_string] = STATE(1180),
    [sym_regex] = STATE(1180),
    [sym_meta_property] = STATE(1180),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1180),
    [sym_type_assertion] = STATE(1180),
    [sym_as_expression] = STATE(1180),
    [sym_internal_module] = STATE(1180),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1686),
    [sym_this] = ACTIONS(1688),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_undefined] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [219] = {
    [sym_import] = STATE(1289),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1289),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1289),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1289),
    [sym_arrow_function] = STATE(1289),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1289),
    [sym_new_expression] = STATE(1289),
    [sym_await_expression] = STATE(1289),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1289),
    [sym_augmented_assignment_expression] = STATE(1289),
    [sym_ternary_expression] = STATE(1289),
    [sym_binary_expression] = STATE(1289),
    [sym_unary_expression] = STATE(1289),
    [sym_update_expression] = STATE(1289),
    [sym_sequence_expression] = STATE(2823),
    [sym_string] = STATE(1289),
    [sym_template_string] = STATE(1289),
    [sym_regex] = STATE(1289),
    [sym_meta_property] = STATE(1289),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1289),
    [sym_type_assertion] = STATE(1289),
    [sym_as_expression] = STATE(1289),
    [sym_internal_module] = STATE(1289),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1690),
    [sym_this] = ACTIONS(1692),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1692),
    [sym_false] = ACTIONS(1692),
    [sym_null] = ACTIONS(1692),
    [sym_undefined] = ACTIONS(1692),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [220] = {
    [sym_import] = STATE(1290),
    [sym_statement_block] = STATE(1469),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1290),
    [sym_yield_expression] = STATE(1290),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1290),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1290),
    [sym_arrow_function] = STATE(1290),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1290),
    [sym_new_expression] = STATE(1290),
    [sym_await_expression] = STATE(1290),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1290),
    [sym_augmented_assignment_expression] = STATE(1290),
    [sym_ternary_expression] = STATE(1290),
    [sym_binary_expression] = STATE(1290),
    [sym_unary_expression] = STATE(1290),
    [sym_update_expression] = STATE(1290),
    [sym_string] = STATE(1290),
    [sym_template_string] = STATE(1290),
    [sym_regex] = STATE(1290),
    [sym_meta_property] = STATE(1290),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1290),
    [sym_type_assertion] = STATE(1290),
    [sym_as_expression] = STATE(1290),
    [sym_internal_module] = STATE(1290),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1694),
    [sym_this] = ACTIONS(1696),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1696),
    [sym_false] = ACTIONS(1696),
    [sym_null] = ACTIONS(1696),
    [sym_undefined] = ACTIONS(1696),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [221] = {
    [sym_export_clause] = STATE(2328),
    [sym__declaration] = STATE(550),
    [sym_variable_declaration] = STATE(550),
    [sym_lexical_declaration] = STATE(550),
    [sym_class_declaration] = STATE(550),
    [sym_function_declaration] = STATE(550),
    [sym_generator_function_declaration] = STATE(550),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(550),
    [sym_ambient_declaration] = STATE(550),
    [sym_abstract_class_declaration] = STATE(550),
    [sym_module] = STATE(550),
    [sym_internal_module] = STATE(550),
    [sym_import_alias] = STATE(550),
    [sym_interface_declaration] = STATE(550),
    [sym_enum_declaration] = STATE(550),
    [sym_type_alias_declaration] = STATE(550),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_default] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1666),
    [anon_sym_as] = ACTIONS(1355),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [222] = {
    [sym_import] = STATE(1129),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1129),
    [sym_yield_expression] = STATE(1129),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1129),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1129),
    [sym_arrow_function] = STATE(1129),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1129),
    [sym_new_expression] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1129),
    [sym_augmented_assignment_expression] = STATE(1129),
    [sym_ternary_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_update_expression] = STATE(1129),
    [sym_sequence_expression] = STATE(2941),
    [sym_string] = STATE(1129),
    [sym_template_string] = STATE(1129),
    [sym_regex] = STATE(1129),
    [sym_meta_property] = STATE(1129),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1129),
    [sym_type_assertion] = STATE(1129),
    [sym_as_expression] = STATE(1129),
    [sym_internal_module] = STATE(1129),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1698),
    [sym_this] = ACTIONS(1700),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1700),
    [sym_false] = ACTIONS(1700),
    [sym_null] = ACTIONS(1700),
    [sym_undefined] = ACTIONS(1700),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [223] = {
    [sym_import] = STATE(1140),
    [sym_statement_block] = STATE(1653),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1140),
    [sym_yield_expression] = STATE(1140),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1140),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1140),
    [sym_arrow_function] = STATE(1140),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1140),
    [sym_new_expression] = STATE(1140),
    [sym_await_expression] = STATE(1140),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1140),
    [sym_augmented_assignment_expression] = STATE(1140),
    [sym_ternary_expression] = STATE(1140),
    [sym_binary_expression] = STATE(1140),
    [sym_unary_expression] = STATE(1140),
    [sym_update_expression] = STATE(1140),
    [sym_string] = STATE(1140),
    [sym_template_string] = STATE(1140),
    [sym_regex] = STATE(1140),
    [sym_meta_property] = STATE(1140),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1140),
    [sym_type_assertion] = STATE(1140),
    [sym_as_expression] = STATE(1140),
    [sym_internal_module] = STATE(1140),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1702),
    [sym_this] = ACTIONS(1704),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1704),
    [sym_false] = ACTIONS(1704),
    [sym_null] = ACTIONS(1704),
    [sym_undefined] = ACTIONS(1704),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [224] = {
    [sym_import] = STATE(1221),
    [sym_statement_block] = STATE(1545),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1221),
    [sym_yield_expression] = STATE(1221),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1221),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1221),
    [sym_arrow_function] = STATE(1221),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_await_expression] = STATE(1221),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1221),
    [sym_augmented_assignment_expression] = STATE(1221),
    [sym_ternary_expression] = STATE(1221),
    [sym_binary_expression] = STATE(1221),
    [sym_unary_expression] = STATE(1221),
    [sym_update_expression] = STATE(1221),
    [sym_string] = STATE(1221),
    [sym_template_string] = STATE(1221),
    [sym_regex] = STATE(1221),
    [sym_meta_property] = STATE(1221),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1221),
    [sym_type_assertion] = STATE(1221),
    [sym_as_expression] = STATE(1221),
    [sym_internal_module] = STATE(1221),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1632),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1706),
    [sym_this] = ACTIONS(1708),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1708),
    [sym_false] = ACTIONS(1708),
    [sym_null] = ACTIONS(1708),
    [sym_undefined] = ACTIONS(1708),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [225] = {
    [sym_import] = STATE(1105),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1105),
    [sym_yield_expression] = STATE(1105),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1105),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1105),
    [sym_arrow_function] = STATE(1105),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1105),
    [sym_new_expression] = STATE(1105),
    [sym_await_expression] = STATE(1105),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1105),
    [sym_augmented_assignment_expression] = STATE(1105),
    [sym_ternary_expression] = STATE(1105),
    [sym_binary_expression] = STATE(1105),
    [sym_unary_expression] = STATE(1105),
    [sym_update_expression] = STATE(1105),
    [sym_sequence_expression] = STATE(2861),
    [sym_string] = STATE(1105),
    [sym_template_string] = STATE(1105),
    [sym_regex] = STATE(1105),
    [sym_meta_property] = STATE(1105),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1105),
    [sym_type_assertion] = STATE(1105),
    [sym_as_expression] = STATE(1105),
    [sym_internal_module] = STATE(1105),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1710),
    [sym_this] = ACTIONS(1712),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1712),
    [sym_false] = ACTIONS(1712),
    [sym_null] = ACTIONS(1712),
    [sym_undefined] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [226] = {
    [sym_import] = STATE(1315),
    [sym_parenthesized_expression] = STATE(808),
    [sym__expression] = STATE(1532),
    [sym_yield_expression] = STATE(1532),
    [sym_object] = STATE(1192),
    [sym_array] = STATE(1193),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(1059),
    [sym_generator_function] = STATE(1315),
    [sym_arrow_function] = STATE(1315),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1532),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1532),
    [sym_member_expression] = STATE(808),
    [sym_subscript_expression] = STATE(808),
    [sym_assignment_expression] = STATE(1532),
    [sym_augmented_assignment_expression] = STATE(1532),
    [sym_ternary_expression] = STATE(1532),
    [sym_binary_expression] = STATE(1532),
    [sym_unary_expression] = STATE(1532),
    [sym_update_expression] = STATE(1532),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2449),
    [sym_non_null_expression] = STATE(1532),
    [sym_type_assertion] = STATE(1532),
    [sym_as_expression] = STATE(1532),
    [sym_internal_module] = STATE(1532),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2681),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(1642),
    [anon_sym_export] = ACTIONS(1644),
    [anon_sym_namespace] = ACTIONS(1646),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(1644),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_DOT] = ACTIONS(1608),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(1648),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1650),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1614),
    [sym_this] = ACTIONS(1616),
    [sym_super] = ACTIONS(1618),
    [sym_true] = ACTIONS(1616),
    [sym_false] = ACTIONS(1616),
    [sym_null] = ACTIONS(1616),
    [sym_undefined] = ACTIONS(1616),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1644),
    [anon_sym_get] = ACTIONS(1644),
    [anon_sym_set] = ACTIONS(1644),
    [anon_sym_declare] = ACTIONS(1644),
    [anon_sym_public] = ACTIONS(1644),
    [anon_sym_private] = ACTIONS(1644),
    [anon_sym_protected] = ACTIONS(1644),
    [anon_sym_module] = ACTIONS(1644),
    [anon_sym_any] = ACTIONS(1644),
    [anon_sym_number] = ACTIONS(1644),
    [anon_sym_boolean] = ACTIONS(1644),
    [anon_sym_string] = ACTIONS(1644),
    [anon_sym_symbol] = ACTIONS(1644),
    [sym_readonly] = ACTIONS(1644),
  },
  [227] = {
    [sym_import] = STATE(1301),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1301),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_nested_identifier] = STATE(411),
    [sym_class] = STATE(1301),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1301),
    [sym_arrow_function] = STATE(1301),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1301),
    [sym_new_expression] = STATE(1301),
    [sym_await_expression] = STATE(1301),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1301),
    [sym_augmented_assignment_expression] = STATE(1301),
    [sym_ternary_expression] = STATE(1301),
    [sym_binary_expression] = STATE(1301),
    [sym_unary_expression] = STATE(1301),
    [sym_update_expression] = STATE(1301),
    [sym_string] = STATE(1301),
    [sym_template_string] = STATE(1301),
    [sym_regex] = STATE(1301),
    [sym_meta_property] = STATE(1301),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1301),
    [sym_type_assertion] = STATE(1301),
    [sym_as_expression] = STATE(1301),
    [sym_internal_module] = STATE(1301),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(1714),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(662),
    [sym_this] = ACTIONS(664),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(664),
    [sym_false] = ACTIONS(664),
    [sym_null] = ACTIONS(664),
    [sym_undefined] = ACTIONS(664),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [228] = {
    [sym_import] = STATE(1346),
    [sym_statement_block] = STATE(1382),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1346),
    [sym_yield_expression] = STATE(1346),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1346),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1346),
    [sym_arrow_function] = STATE(1346),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1346),
    [sym_new_expression] = STATE(1346),
    [sym_await_expression] = STATE(1346),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1346),
    [sym_augmented_assignment_expression] = STATE(1346),
    [sym_ternary_expression] = STATE(1346),
    [sym_binary_expression] = STATE(1346),
    [sym_unary_expression] = STATE(1346),
    [sym_update_expression] = STATE(1346),
    [sym_string] = STATE(1346),
    [sym_template_string] = STATE(1346),
    [sym_regex] = STATE(1346),
    [sym_meta_property] = STATE(1346),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1346),
    [sym_type_assertion] = STATE(1346),
    [sym_as_expression] = STATE(1346),
    [sym_internal_module] = STATE(1346),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1716),
    [sym_this] = ACTIONS(1718),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1718),
    [sym_false] = ACTIONS(1718),
    [sym_null] = ACTIONS(1718),
    [sym_undefined] = ACTIONS(1718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [229] = {
    [sym_import] = STATE(1286),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1286),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1286),
    [sym_arrow_function] = STATE(1286),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1286),
    [sym_new_expression] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_sequence_expression] = STATE(2825),
    [sym_string] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1286),
    [sym_type_assertion] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1720),
    [sym_this] = ACTIONS(1722),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1722),
    [sym_false] = ACTIONS(1722),
    [sym_null] = ACTIONS(1722),
    [sym_undefined] = ACTIONS(1722),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [230] = {
    [sym_import] = STATE(1044),
    [sym_statement_block] = STATE(1395),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1044),
    [sym_yield_expression] = STATE(1044),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1044),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1044),
    [sym_arrow_function] = STATE(1044),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1044),
    [sym_new_expression] = STATE(1044),
    [sym_await_expression] = STATE(1044),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1044),
    [sym_augmented_assignment_expression] = STATE(1044),
    [sym_ternary_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_update_expression] = STATE(1044),
    [sym_string] = STATE(1044),
    [sym_template_string] = STATE(1044),
    [sym_regex] = STATE(1044),
    [sym_meta_property] = STATE(1044),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1044),
    [sym_type_assertion] = STATE(1044),
    [sym_as_expression] = STATE(1044),
    [sym_internal_module] = STATE(1044),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1724),
    [sym_this] = ACTIONS(1726),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1726),
    [sym_false] = ACTIONS(1726),
    [sym_null] = ACTIONS(1726),
    [sym_undefined] = ACTIONS(1726),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [231] = {
    [sym_import] = STATE(1342),
    [sym_statement_block] = STATE(1381),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1342),
    [sym_yield_expression] = STATE(1342),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1342),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1342),
    [sym_arrow_function] = STATE(1342),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1342),
    [sym_new_expression] = STATE(1342),
    [sym_await_expression] = STATE(1342),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1342),
    [sym_augmented_assignment_expression] = STATE(1342),
    [sym_ternary_expression] = STATE(1342),
    [sym_binary_expression] = STATE(1342),
    [sym_unary_expression] = STATE(1342),
    [sym_update_expression] = STATE(1342),
    [sym_string] = STATE(1342),
    [sym_template_string] = STATE(1342),
    [sym_regex] = STATE(1342),
    [sym_meta_property] = STATE(1342),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1342),
    [sym_type_assertion] = STATE(1342),
    [sym_as_expression] = STATE(1342),
    [sym_internal_module] = STATE(1342),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1728),
    [sym_this] = ACTIONS(1730),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_null] = ACTIONS(1730),
    [sym_undefined] = ACTIONS(1730),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [232] = {
    [sym_import] = STATE(1335),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1335),
    [sym_yield_expression] = STATE(1335),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1335),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1335),
    [sym_arrow_function] = STATE(1335),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1335),
    [sym_new_expression] = STATE(1335),
    [sym_await_expression] = STATE(1335),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1335),
    [sym_augmented_assignment_expression] = STATE(1335),
    [sym_ternary_expression] = STATE(1335),
    [sym_binary_expression] = STATE(1335),
    [sym_unary_expression] = STATE(1335),
    [sym_update_expression] = STATE(1335),
    [sym_sequence_expression] = STATE(2921),
    [sym_string] = STATE(1335),
    [sym_template_string] = STATE(1335),
    [sym_regex] = STATE(1335),
    [sym_meta_property] = STATE(1335),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1335),
    [sym_type_assertion] = STATE(1335),
    [sym_as_expression] = STATE(1335),
    [sym_internal_module] = STATE(1335),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1732),
    [sym_this] = ACTIONS(1734),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1734),
    [sym_false] = ACTIONS(1734),
    [sym_null] = ACTIONS(1734),
    [sym_undefined] = ACTIONS(1734),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [233] = {
    [sym_import] = STATE(1337),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1337),
    [sym_yield_expression] = STATE(1337),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1337),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1337),
    [sym_arrow_function] = STATE(1337),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1337),
    [sym_new_expression] = STATE(1337),
    [sym_await_expression] = STATE(1337),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1337),
    [sym_augmented_assignment_expression] = STATE(1337),
    [sym_ternary_expression] = STATE(1337),
    [sym_binary_expression] = STATE(1337),
    [sym_unary_expression] = STATE(1337),
    [sym_update_expression] = STATE(1337),
    [sym_sequence_expression] = STATE(2918),
    [sym_string] = STATE(1337),
    [sym_template_string] = STATE(1337),
    [sym_regex] = STATE(1337),
    [sym_meta_property] = STATE(1337),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1337),
    [sym_type_assertion] = STATE(1337),
    [sym_as_expression] = STATE(1337),
    [sym_internal_module] = STATE(1337),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1736),
    [sym_this] = ACTIONS(1738),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1738),
    [sym_false] = ACTIONS(1738),
    [sym_null] = ACTIONS(1738),
    [sym_undefined] = ACTIONS(1738),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [234] = {
    [sym_import] = STATE(1341),
    [sym_statement_block] = STATE(1374),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1341),
    [sym_yield_expression] = STATE(1341),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1341),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1341),
    [sym_arrow_function] = STATE(1341),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1341),
    [sym_new_expression] = STATE(1341),
    [sym_await_expression] = STATE(1341),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1341),
    [sym_augmented_assignment_expression] = STATE(1341),
    [sym_ternary_expression] = STATE(1341),
    [sym_binary_expression] = STATE(1341),
    [sym_unary_expression] = STATE(1341),
    [sym_update_expression] = STATE(1341),
    [sym_string] = STATE(1341),
    [sym_template_string] = STATE(1341),
    [sym_regex] = STATE(1341),
    [sym_meta_property] = STATE(1341),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1341),
    [sym_type_assertion] = STATE(1341),
    [sym_as_expression] = STATE(1341),
    [sym_internal_module] = STATE(1341),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1740),
    [sym_this] = ACTIONS(1742),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1742),
    [sym_false] = ACTIONS(1742),
    [sym_null] = ACTIONS(1742),
    [sym_undefined] = ACTIONS(1742),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [235] = {
    [sym_import] = STATE(1339),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1339),
    [sym_yield_expression] = STATE(1339),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1339),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1339),
    [sym_arrow_function] = STATE(1339),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1339),
    [sym_new_expression] = STATE(1339),
    [sym_await_expression] = STATE(1339),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1339),
    [sym_augmented_assignment_expression] = STATE(1339),
    [sym_ternary_expression] = STATE(1339),
    [sym_binary_expression] = STATE(1339),
    [sym_unary_expression] = STATE(1339),
    [sym_update_expression] = STATE(1339),
    [sym_sequence_expression] = STATE(2914),
    [sym_string] = STATE(1339),
    [sym_template_string] = STATE(1339),
    [sym_regex] = STATE(1339),
    [sym_meta_property] = STATE(1339),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1339),
    [sym_type_assertion] = STATE(1339),
    [sym_as_expression] = STATE(1339),
    [sym_internal_module] = STATE(1339),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1744),
    [sym_this] = ACTIONS(1746),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1746),
    [sym_false] = ACTIONS(1746),
    [sym_null] = ACTIONS(1746),
    [sym_undefined] = ACTIONS(1746),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [236] = {
    [sym_import] = STATE(1240),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1240),
    [sym_yield_expression] = STATE(1240),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1240),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1240),
    [sym_arrow_function] = STATE(1240),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1240),
    [sym_new_expression] = STATE(1240),
    [sym_await_expression] = STATE(1240),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1240),
    [sym_augmented_assignment_expression] = STATE(1240),
    [sym_ternary_expression] = STATE(1240),
    [sym_binary_expression] = STATE(1240),
    [sym_unary_expression] = STATE(1240),
    [sym_update_expression] = STATE(1240),
    [sym_sequence_expression] = STATE(2738),
    [sym_string] = STATE(1240),
    [sym_template_string] = STATE(1240),
    [sym_regex] = STATE(1240),
    [sym_meta_property] = STATE(1240),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1240),
    [sym_as_expression] = STATE(1240),
    [sym_internal_module] = STATE(1240),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1748),
    [sym_this] = ACTIONS(1750),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1750),
    [sym_false] = ACTIONS(1750),
    [sym_null] = ACTIONS(1750),
    [sym_undefined] = ACTIONS(1750),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [237] = {
    [sym_import] = STATE(1459),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1459),
    [sym_yield_expression] = STATE(1459),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1459),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1459),
    [sym_arrow_function] = STATE(1459),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1459),
    [sym_new_expression] = STATE(1459),
    [sym_await_expression] = STATE(1459),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1459),
    [sym_augmented_assignment_expression] = STATE(1459),
    [sym_ternary_expression] = STATE(1459),
    [sym_binary_expression] = STATE(1459),
    [sym_unary_expression] = STATE(1459),
    [sym_update_expression] = STATE(1459),
    [sym_string] = STATE(1459),
    [sym_template_string] = STATE(1459),
    [sym_regex] = STATE(1459),
    [sym_meta_property] = STATE(1459),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1459),
    [sym_type_assertion] = STATE(1459),
    [sym_as_expression] = STATE(1459),
    [sym_internal_module] = STATE(1459),
    [sym_mapped_type_clause] = STATE(2970),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1752),
    [anon_sym_export] = ACTIONS(1754),
    [anon_sym_namespace] = ACTIONS(1756),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1754),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1758),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1760),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1762),
    [sym_this] = ACTIONS(1764),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1764),
    [sym_false] = ACTIONS(1764),
    [sym_null] = ACTIONS(1764),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1754),
    [anon_sym_get] = ACTIONS(1754),
    [anon_sym_set] = ACTIONS(1754),
    [anon_sym_declare] = ACTIONS(1754),
    [anon_sym_public] = ACTIONS(1754),
    [anon_sym_private] = ACTIONS(1754),
    [anon_sym_protected] = ACTIONS(1754),
    [anon_sym_module] = ACTIONS(1754),
    [anon_sym_any] = ACTIONS(1754),
    [anon_sym_number] = ACTIONS(1754),
    [anon_sym_boolean] = ACTIONS(1754),
    [anon_sym_string] = ACTIONS(1754),
    [anon_sym_symbol] = ACTIONS(1754),
    [sym_readonly] = ACTIONS(1754),
  },
  [238] = {
    [sym_import] = STATE(1307),
    [sym_statement_block] = STATE(1429),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1307),
    [sym_yield_expression] = STATE(1307),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1307),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1307),
    [sym_arrow_function] = STATE(1307),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1307),
    [sym_new_expression] = STATE(1307),
    [sym_await_expression] = STATE(1307),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1307),
    [sym_augmented_assignment_expression] = STATE(1307),
    [sym_ternary_expression] = STATE(1307),
    [sym_binary_expression] = STATE(1307),
    [sym_unary_expression] = STATE(1307),
    [sym_update_expression] = STATE(1307),
    [sym_string] = STATE(1307),
    [sym_template_string] = STATE(1307),
    [sym_regex] = STATE(1307),
    [sym_meta_property] = STATE(1307),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1307),
    [sym_type_assertion] = STATE(1307),
    [sym_as_expression] = STATE(1307),
    [sym_internal_module] = STATE(1307),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1766),
    [sym_this] = ACTIONS(1768),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1768),
    [sym_false] = ACTIONS(1768),
    [sym_null] = ACTIONS(1768),
    [sym_undefined] = ACTIONS(1768),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [239] = {
    [sym_import] = STATE(1311),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1311),
    [sym_yield_expression] = STATE(1311),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1311),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1311),
    [sym_arrow_function] = STATE(1311),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1311),
    [sym_new_expression] = STATE(1311),
    [sym_await_expression] = STATE(1311),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1311),
    [sym_augmented_assignment_expression] = STATE(1311),
    [sym_ternary_expression] = STATE(1311),
    [sym_binary_expression] = STATE(1311),
    [sym_unary_expression] = STATE(1311),
    [sym_update_expression] = STATE(1311),
    [sym_sequence_expression] = STATE(2925),
    [sym_string] = STATE(1311),
    [sym_template_string] = STATE(1311),
    [sym_regex] = STATE(1311),
    [sym_meta_property] = STATE(1311),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(1311),
    [sym_as_expression] = STATE(1311),
    [sym_internal_module] = STATE(1311),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1770),
    [sym_this] = ACTIONS(1772),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1772),
    [sym_false] = ACTIONS(1772),
    [sym_null] = ACTIONS(1772),
    [sym_undefined] = ACTIONS(1772),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [240] = {
    [sym_import] = STATE(1333),
    [sym_statement_block] = STATE(1395),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1333),
    [sym_yield_expression] = STATE(1333),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1333),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1333),
    [sym_arrow_function] = STATE(1333),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_await_expression] = STATE(1333),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1333),
    [sym_augmented_assignment_expression] = STATE(1333),
    [sym_ternary_expression] = STATE(1333),
    [sym_binary_expression] = STATE(1333),
    [sym_unary_expression] = STATE(1333),
    [sym_update_expression] = STATE(1333),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1333),
    [sym_regex] = STATE(1333),
    [sym_meta_property] = STATE(1333),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1333),
    [sym_type_assertion] = STATE(1333),
    [sym_as_expression] = STATE(1333),
    [sym_internal_module] = STATE(1333),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1774),
    [sym_this] = ACTIONS(1776),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1776),
    [sym_false] = ACTIONS(1776),
    [sym_null] = ACTIONS(1776),
    [sym_undefined] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [241] = {
    [sym_import] = STATE(1272),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1272),
    [sym_yield_expression] = STATE(1272),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1272),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1272),
    [sym_arrow_function] = STATE(1272),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1272),
    [sym_new_expression] = STATE(1272),
    [sym_await_expression] = STATE(1272),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1272),
    [sym_augmented_assignment_expression] = STATE(1272),
    [sym_ternary_expression] = STATE(1272),
    [sym_binary_expression] = STATE(1272),
    [sym_unary_expression] = STATE(1272),
    [sym_update_expression] = STATE(1272),
    [sym_sequence_expression] = STATE(2948),
    [sym_string] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_regex] = STATE(1272),
    [sym_meta_property] = STATE(1272),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1272),
    [sym_type_assertion] = STATE(1272),
    [sym_as_expression] = STATE(1272),
    [sym_internal_module] = STATE(1272),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1778),
    [sym_this] = ACTIONS(1780),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1780),
    [sym_false] = ACTIONS(1780),
    [sym_null] = ACTIONS(1780),
    [sym_undefined] = ACTIONS(1780),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [242] = {
    [sym_import] = STATE(1283),
    [sym_statement_block] = STATE(1019),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1283),
    [sym_yield_expression] = STATE(1283),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1283),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1283),
    [sym_arrow_function] = STATE(1283),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1283),
    [sym_new_expression] = STATE(1283),
    [sym_await_expression] = STATE(1283),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1283),
    [sym_augmented_assignment_expression] = STATE(1283),
    [sym_ternary_expression] = STATE(1283),
    [sym_binary_expression] = STATE(1283),
    [sym_unary_expression] = STATE(1283),
    [sym_update_expression] = STATE(1283),
    [sym_string] = STATE(1283),
    [sym_template_string] = STATE(1283),
    [sym_regex] = STATE(1283),
    [sym_meta_property] = STATE(1283),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1283),
    [sym_type_assertion] = STATE(1283),
    [sym_as_expression] = STATE(1283),
    [sym_internal_module] = STATE(1283),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1782),
    [sym_this] = ACTIONS(1784),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1784),
    [sym_false] = ACTIONS(1784),
    [sym_null] = ACTIONS(1784),
    [sym_undefined] = ACTIONS(1784),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [243] = {
    [sym_import] = STATE(1267),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1267),
    [sym_yield_expression] = STATE(1267),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1267),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1267),
    [sym_arrow_function] = STATE(1267),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1267),
    [sym_new_expression] = STATE(1267),
    [sym_await_expression] = STATE(1267),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1267),
    [sym_augmented_assignment_expression] = STATE(1267),
    [sym_ternary_expression] = STATE(1267),
    [sym_binary_expression] = STATE(1267),
    [sym_unary_expression] = STATE(1267),
    [sym_update_expression] = STATE(1267),
    [sym_sequence_expression] = STATE(2951),
    [sym_string] = STATE(1267),
    [sym_template_string] = STATE(1267),
    [sym_regex] = STATE(1267),
    [sym_meta_property] = STATE(1267),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1267),
    [sym_type_assertion] = STATE(1267),
    [sym_as_expression] = STATE(1267),
    [sym_internal_module] = STATE(1267),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1786),
    [sym_this] = ACTIONS(1788),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1788),
    [sym_false] = ACTIONS(1788),
    [sym_null] = ACTIONS(1788),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [244] = {
    [sym_import] = STATE(1351),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1351),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1351),
    [sym_arrow_function] = STATE(1351),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1351),
    [sym_await_expression] = STATE(1351),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1351),
    [sym_augmented_assignment_expression] = STATE(1351),
    [sym_ternary_expression] = STATE(1351),
    [sym_binary_expression] = STATE(1351),
    [sym_unary_expression] = STATE(1351),
    [sym_update_expression] = STATE(1351),
    [sym_sequence_expression] = STATE(2927),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1351),
    [sym_as_expression] = STATE(1351),
    [sym_internal_module] = STATE(1351),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1790),
    [sym_this] = ACTIONS(1792),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1792),
    [sym_false] = ACTIONS(1792),
    [sym_null] = ACTIONS(1792),
    [sym_undefined] = ACTIONS(1792),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [245] = {
    [sym_import] = STATE(1353),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1353),
    [sym_yield_expression] = STATE(1353),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1353),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1353),
    [sym_arrow_function] = STATE(1353),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1353),
    [sym_new_expression] = STATE(1353),
    [sym_await_expression] = STATE(1353),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1353),
    [sym_augmented_assignment_expression] = STATE(1353),
    [sym_ternary_expression] = STATE(1353),
    [sym_binary_expression] = STATE(1353),
    [sym_unary_expression] = STATE(1353),
    [sym_update_expression] = STATE(1353),
    [sym_sequence_expression] = STATE(2907),
    [sym_string] = STATE(1353),
    [sym_template_string] = STATE(1353),
    [sym_regex] = STATE(1353),
    [sym_meta_property] = STATE(1353),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1353),
    [sym_type_assertion] = STATE(1353),
    [sym_as_expression] = STATE(1353),
    [sym_internal_module] = STATE(1353),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1794),
    [sym_this] = ACTIONS(1796),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1796),
    [sym_false] = ACTIONS(1796),
    [sym_null] = ACTIONS(1796),
    [sym_undefined] = ACTIONS(1796),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [246] = {
    [sym_import] = STATE(1051),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1051),
    [sym_arrow_function] = STATE(1051),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1051),
    [sym_type_assertion] = STATE(1051),
    [sym_as_expression] = STATE(1051),
    [sym_internal_module] = STATE(1051),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1798),
    [sym_this] = ACTIONS(1800),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1800),
    [sym_false] = ACTIONS(1800),
    [sym_null] = ACTIONS(1800),
    [sym_undefined] = ACTIONS(1800),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [247] = {
    [sym_import] = STATE(977),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(977),
    [sym_yield_expression] = STATE(977),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(977),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(977),
    [sym_arrow_function] = STATE(977),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(977),
    [sym_new_expression] = STATE(977),
    [sym_await_expression] = STATE(977),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(977),
    [sym_augmented_assignment_expression] = STATE(977),
    [sym_ternary_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_update_expression] = STATE(977),
    [sym_string] = STATE(977),
    [sym_template_string] = STATE(977),
    [sym_regex] = STATE(977),
    [sym_meta_property] = STATE(977),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(977),
    [sym_as_expression] = STATE(977),
    [sym_internal_module] = STATE(977),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1802),
    [sym_this] = ACTIONS(1804),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [sym_null] = ACTIONS(1804),
    [sym_undefined] = ACTIONS(1804),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [248] = {
    [sym_import] = STATE(1331),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1331),
    [sym_yield_expression] = STATE(1331),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1331),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1331),
    [sym_arrow_function] = STATE(1331),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1331),
    [sym_new_expression] = STATE(1331),
    [sym_await_expression] = STATE(1331),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1331),
    [sym_augmented_assignment_expression] = STATE(1331),
    [sym_ternary_expression] = STATE(1331),
    [sym_binary_expression] = STATE(1331),
    [sym_unary_expression] = STATE(1331),
    [sym_update_expression] = STATE(1331),
    [sym_string] = STATE(1331),
    [sym_template_string] = STATE(1331),
    [sym_regex] = STATE(1331),
    [sym_meta_property] = STATE(1331),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1331),
    [sym_type_assertion] = STATE(1331),
    [sym_as_expression] = STATE(1331),
    [sym_internal_module] = STATE(1331),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1806),
    [sym_this] = ACTIONS(1808),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1808),
    [sym_false] = ACTIONS(1808),
    [sym_null] = ACTIONS(1808),
    [sym_undefined] = ACTIONS(1808),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [249] = {
    [sym_import] = STATE(1330),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1330),
    [sym_yield_expression] = STATE(1330),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1330),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1330),
    [sym_arrow_function] = STATE(1330),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1330),
    [sym_new_expression] = STATE(1330),
    [sym_await_expression] = STATE(1330),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1330),
    [sym_augmented_assignment_expression] = STATE(1330),
    [sym_ternary_expression] = STATE(1330),
    [sym_binary_expression] = STATE(1330),
    [sym_unary_expression] = STATE(1330),
    [sym_update_expression] = STATE(1330),
    [sym_string] = STATE(1330),
    [sym_template_string] = STATE(1330),
    [sym_regex] = STATE(1330),
    [sym_meta_property] = STATE(1330),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1330),
    [sym_type_assertion] = STATE(1330),
    [sym_as_expression] = STATE(1330),
    [sym_internal_module] = STATE(1330),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1810),
    [sym_this] = ACTIONS(1812),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1812),
    [sym_false] = ACTIONS(1812),
    [sym_null] = ACTIONS(1812),
    [sym_undefined] = ACTIONS(1812),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [250] = {
    [sym_import] = STATE(1325),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1325),
    [sym_yield_expression] = STATE(1325),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1325),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1325),
    [sym_arrow_function] = STATE(1325),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1325),
    [sym_new_expression] = STATE(1325),
    [sym_await_expression] = STATE(1325),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1325),
    [sym_augmented_assignment_expression] = STATE(1325),
    [sym_ternary_expression] = STATE(1325),
    [sym_binary_expression] = STATE(1325),
    [sym_unary_expression] = STATE(1325),
    [sym_update_expression] = STATE(1325),
    [sym_string] = STATE(1325),
    [sym_template_string] = STATE(1325),
    [sym_regex] = STATE(1325),
    [sym_meta_property] = STATE(1325),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1325),
    [sym_type_assertion] = STATE(1325),
    [sym_as_expression] = STATE(1325),
    [sym_internal_module] = STATE(1325),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1814),
    [sym_this] = ACTIONS(1816),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1816),
    [sym_false] = ACTIONS(1816),
    [sym_null] = ACTIONS(1816),
    [sym_undefined] = ACTIONS(1816),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [251] = {
    [sym_import] = STATE(1322),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1322),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1322),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1322),
    [sym_arrow_function] = STATE(1322),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_ternary_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_update_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_template_string] = STATE(1322),
    [sym_regex] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1322),
    [sym_as_expression] = STATE(1322),
    [sym_internal_module] = STATE(1322),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1818),
    [sym_this] = ACTIONS(1820),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1820),
    [sym_false] = ACTIONS(1820),
    [sym_null] = ACTIONS(1820),
    [sym_undefined] = ACTIONS(1820),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [252] = {
    [sym_import] = STATE(1319),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1319),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1319),
    [sym_arrow_function] = STATE(1319),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1319),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1319),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1319),
    [sym_augmented_assignment_expression] = STATE(1319),
    [sym_ternary_expression] = STATE(1319),
    [sym_binary_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1319),
    [sym_update_expression] = STATE(1319),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1319),
    [sym_type_assertion] = STATE(1319),
    [sym_as_expression] = STATE(1319),
    [sym_internal_module] = STATE(1319),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1822),
    [sym_this] = ACTIONS(1824),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1824),
    [sym_false] = ACTIONS(1824),
    [sym_null] = ACTIONS(1824),
    [sym_undefined] = ACTIONS(1824),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [253] = {
    [sym_import] = STATE(1317),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1317),
    [sym_yield_expression] = STATE(1317),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1317),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1317),
    [sym_arrow_function] = STATE(1317),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1317),
    [sym_new_expression] = STATE(1317),
    [sym_await_expression] = STATE(1317),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1317),
    [sym_augmented_assignment_expression] = STATE(1317),
    [sym_ternary_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_unary_expression] = STATE(1317),
    [sym_update_expression] = STATE(1317),
    [sym_string] = STATE(1317),
    [sym_template_string] = STATE(1317),
    [sym_regex] = STATE(1317),
    [sym_meta_property] = STATE(1317),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1317),
    [sym_type_assertion] = STATE(1317),
    [sym_as_expression] = STATE(1317),
    [sym_internal_module] = STATE(1317),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1826),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [sym_undefined] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [254] = {
    [sym_import] = STATE(1458),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1458),
    [sym_yield_expression] = STATE(1458),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1458),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1458),
    [sym_arrow_function] = STATE(1458),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1458),
    [sym_new_expression] = STATE(1458),
    [sym_await_expression] = STATE(1458),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1458),
    [sym_augmented_assignment_expression] = STATE(1458),
    [sym_ternary_expression] = STATE(1458),
    [sym_binary_expression] = STATE(1458),
    [sym_unary_expression] = STATE(1458),
    [sym_update_expression] = STATE(1458),
    [sym_string] = STATE(1458),
    [sym_template_string] = STATE(1458),
    [sym_regex] = STATE(1458),
    [sym_meta_property] = STATE(1458),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1458),
    [sym_type_assertion] = STATE(1458),
    [sym_as_expression] = STATE(1458),
    [sym_internal_module] = STATE(1458),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1830),
    [sym_this] = ACTIONS(1832),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1832),
    [sym_false] = ACTIONS(1832),
    [sym_null] = ACTIONS(1832),
    [sym_undefined] = ACTIONS(1832),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [255] = {
    [sym_import] = STATE(1122),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1122),
    [sym_yield_expression] = STATE(1122),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1122),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1122),
    [sym_arrow_function] = STATE(1122),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1122),
    [sym_new_expression] = STATE(1122),
    [sym_await_expression] = STATE(1122),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1122),
    [sym_augmented_assignment_expression] = STATE(1122),
    [sym_ternary_expression] = STATE(1122),
    [sym_binary_expression] = STATE(1122),
    [sym_unary_expression] = STATE(1122),
    [sym_update_expression] = STATE(1122),
    [sym_string] = STATE(1122),
    [sym_template_string] = STATE(1122),
    [sym_regex] = STATE(1122),
    [sym_meta_property] = STATE(1122),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1122),
    [sym_type_assertion] = STATE(1122),
    [sym_as_expression] = STATE(1122),
    [sym_internal_module] = STATE(1122),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1834),
    [sym_this] = ACTIONS(1836),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1836),
    [sym_false] = ACTIONS(1836),
    [sym_null] = ACTIONS(1836),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [256] = {
    [sym_import] = STATE(1316),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1316),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1316),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1316),
    [sym_arrow_function] = STATE(1316),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1316),
    [sym_new_expression] = STATE(1316),
    [sym_await_expression] = STATE(1316),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1316),
    [sym_augmented_assignment_expression] = STATE(1316),
    [sym_ternary_expression] = STATE(1316),
    [sym_binary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1316),
    [sym_update_expression] = STATE(1316),
    [sym_string] = STATE(1316),
    [sym_template_string] = STATE(1316),
    [sym_regex] = STATE(1316),
    [sym_meta_property] = STATE(1316),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1316),
    [sym_type_assertion] = STATE(1316),
    [sym_as_expression] = STATE(1316),
    [sym_internal_module] = STATE(1316),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1838),
    [sym_this] = ACTIONS(899),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(899),
    [sym_false] = ACTIONS(899),
    [sym_null] = ACTIONS(899),
    [sym_undefined] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [257] = {
    [sym_import] = STATE(1118),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1118),
    [sym_yield_expression] = STATE(1118),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1118),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1118),
    [sym_arrow_function] = STATE(1118),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1118),
    [sym_new_expression] = STATE(1118),
    [sym_await_expression] = STATE(1118),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1118),
    [sym_augmented_assignment_expression] = STATE(1118),
    [sym_ternary_expression] = STATE(1118),
    [sym_binary_expression] = STATE(1118),
    [sym_unary_expression] = STATE(1118),
    [sym_update_expression] = STATE(1118),
    [sym_string] = STATE(1118),
    [sym_template_string] = STATE(1118),
    [sym_regex] = STATE(1118),
    [sym_meta_property] = STATE(1118),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1118),
    [sym_type_assertion] = STATE(1118),
    [sym_as_expression] = STATE(1118),
    [sym_internal_module] = STATE(1118),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1840),
    [sym_this] = ACTIONS(1842),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [sym_null] = ACTIONS(1842),
    [sym_undefined] = ACTIONS(1842),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [258] = {
    [sym_import] = STATE(1314),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1314),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1314),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1314),
    [sym_arrow_function] = STATE(1314),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1314),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_string] = STATE(1314),
    [sym_template_string] = STATE(1314),
    [sym_regex] = STATE(1314),
    [sym_meta_property] = STATE(1314),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1314),
    [sym_type_assertion] = STATE(1314),
    [sym_as_expression] = STATE(1314),
    [sym_internal_module] = STATE(1314),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1844),
    [sym_this] = ACTIONS(1846),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1846),
    [sym_false] = ACTIONS(1846),
    [sym_null] = ACTIONS(1846),
    [sym_undefined] = ACTIONS(1846),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [259] = {
    [sym_import] = STATE(1259),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1259),
    [sym_yield_expression] = STATE(1259),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1259),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1259),
    [sym_arrow_function] = STATE(1259),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1259),
    [sym_new_expression] = STATE(1259),
    [sym_await_expression] = STATE(1259),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1259),
    [sym_augmented_assignment_expression] = STATE(1259),
    [sym_ternary_expression] = STATE(1259),
    [sym_binary_expression] = STATE(1259),
    [sym_unary_expression] = STATE(1259),
    [sym_update_expression] = STATE(1259),
    [sym_string] = STATE(1259),
    [sym_template_string] = STATE(1259),
    [sym_regex] = STATE(1259),
    [sym_meta_property] = STATE(1259),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1259),
    [sym_type_assertion] = STATE(1259),
    [sym_as_expression] = STATE(1259),
    [sym_internal_module] = STATE(1259),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1848),
    [sym_this] = ACTIONS(1850),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1850),
    [sym_false] = ACTIONS(1850),
    [sym_null] = ACTIONS(1850),
    [sym_undefined] = ACTIONS(1850),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [260] = {
    [sym_import] = STATE(1160),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1160),
    [sym_yield_expression] = STATE(1160),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1160),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1160),
    [sym_arrow_function] = STATE(1160),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1160),
    [sym_new_expression] = STATE(1160),
    [sym_await_expression] = STATE(1160),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1160),
    [sym_augmented_assignment_expression] = STATE(1160),
    [sym_ternary_expression] = STATE(1160),
    [sym_binary_expression] = STATE(1160),
    [sym_unary_expression] = STATE(1160),
    [sym_update_expression] = STATE(1160),
    [sym_string] = STATE(1160),
    [sym_template_string] = STATE(1160),
    [sym_regex] = STATE(1160),
    [sym_meta_property] = STATE(1160),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1160),
    [sym_type_assertion] = STATE(1160),
    [sym_as_expression] = STATE(1160),
    [sym_internal_module] = STATE(1160),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1852),
    [sym_this] = ACTIONS(1854),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1854),
    [sym_false] = ACTIONS(1854),
    [sym_null] = ACTIONS(1854),
    [sym_undefined] = ACTIONS(1854),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [261] = {
    [sym_import] = STATE(1295),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1295),
    [sym_yield_expression] = STATE(1295),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1295),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1295),
    [sym_arrow_function] = STATE(1295),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1295),
    [sym_new_expression] = STATE(1295),
    [sym_await_expression] = STATE(1295),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1295),
    [sym_augmented_assignment_expression] = STATE(1295),
    [sym_ternary_expression] = STATE(1295),
    [sym_binary_expression] = STATE(1295),
    [sym_unary_expression] = STATE(1295),
    [sym_update_expression] = STATE(1295),
    [sym_string] = STATE(1295),
    [sym_template_string] = STATE(1295),
    [sym_regex] = STATE(1295),
    [sym_meta_property] = STATE(1295),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1295),
    [sym_type_assertion] = STATE(1295),
    [sym_as_expression] = STATE(1295),
    [sym_internal_module] = STATE(1295),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1856),
    [sym_this] = ACTIONS(1858),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1858),
    [sym_false] = ACTIONS(1858),
    [sym_null] = ACTIONS(1858),
    [sym_undefined] = ACTIONS(1858),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [262] = {
    [sym_import] = STATE(1249),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1249),
    [sym_yield_expression] = STATE(1249),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1249),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1249),
    [sym_arrow_function] = STATE(1249),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1249),
    [sym_new_expression] = STATE(1249),
    [sym_await_expression] = STATE(1249),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1249),
    [sym_augmented_assignment_expression] = STATE(1249),
    [sym_ternary_expression] = STATE(1249),
    [sym_binary_expression] = STATE(1249),
    [sym_unary_expression] = STATE(1249),
    [sym_update_expression] = STATE(1249),
    [sym_string] = STATE(1249),
    [sym_template_string] = STATE(1249),
    [sym_regex] = STATE(1249),
    [sym_meta_property] = STATE(1249),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1249),
    [sym_type_assertion] = STATE(1249),
    [sym_as_expression] = STATE(1249),
    [sym_internal_module] = STATE(1249),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1860),
    [sym_this] = ACTIONS(1862),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1862),
    [sym_false] = ACTIONS(1862),
    [sym_null] = ACTIONS(1862),
    [sym_undefined] = ACTIONS(1862),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [263] = {
    [sym_import] = STATE(1246),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1246),
    [sym_yield_expression] = STATE(1246),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1246),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1246),
    [sym_arrow_function] = STATE(1246),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1246),
    [sym_new_expression] = STATE(1246),
    [sym_await_expression] = STATE(1246),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1246),
    [sym_augmented_assignment_expression] = STATE(1246),
    [sym_ternary_expression] = STATE(1246),
    [sym_binary_expression] = STATE(1246),
    [sym_unary_expression] = STATE(1246),
    [sym_update_expression] = STATE(1246),
    [sym_string] = STATE(1246),
    [sym_template_string] = STATE(1246),
    [sym_regex] = STATE(1246),
    [sym_meta_property] = STATE(1246),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1246),
    [sym_type_assertion] = STATE(1246),
    [sym_as_expression] = STATE(1246),
    [sym_internal_module] = STATE(1246),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1864),
    [sym_this] = ACTIONS(1866),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1866),
    [sym_false] = ACTIONS(1866),
    [sym_null] = ACTIONS(1866),
    [sym_undefined] = ACTIONS(1866),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [264] = {
    [sym_import] = STATE(1198),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1198),
    [sym_yield_expression] = STATE(1198),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1198),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1198),
    [sym_arrow_function] = STATE(1198),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1198),
    [sym_new_expression] = STATE(1198),
    [sym_await_expression] = STATE(1198),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1198),
    [sym_augmented_assignment_expression] = STATE(1198),
    [sym_ternary_expression] = STATE(1198),
    [sym_binary_expression] = STATE(1198),
    [sym_unary_expression] = STATE(1198),
    [sym_update_expression] = STATE(1198),
    [sym_string] = STATE(1198),
    [sym_template_string] = STATE(1198),
    [sym_regex] = STATE(1198),
    [sym_meta_property] = STATE(1198),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1198),
    [sym_type_assertion] = STATE(1198),
    [sym_as_expression] = STATE(1198),
    [sym_internal_module] = STATE(1198),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1868),
    [sym_this] = ACTIONS(1870),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1870),
    [sym_false] = ACTIONS(1870),
    [sym_null] = ACTIONS(1870),
    [sym_undefined] = ACTIONS(1870),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [265] = {
    [sym_import] = STATE(1023),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1023),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1023),
    [sym_arrow_function] = STATE(1023),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1023),
    [sym_new_expression] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_string] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1023),
    [sym_type_assertion] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(483),
    [sym_this] = ACTIONS(485),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_null] = ACTIONS(485),
    [sym_undefined] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [266] = {
    [sym_import] = STATE(1548),
    [sym_parenthesized_expression] = STATE(899),
    [sym__expression] = STATE(1548),
    [sym_yield_expression] = STATE(1548),
    [sym_object] = STATE(1668),
    [sym_array] = STATE(1671),
    [sym_class] = STATE(1548),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1548),
    [sym_arrow_function] = STATE(1548),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1548),
    [sym_new_expression] = STATE(1548),
    [sym_await_expression] = STATE(1548),
    [sym_member_expression] = STATE(899),
    [sym_subscript_expression] = STATE(899),
    [sym_assignment_expression] = STATE(1548),
    [sym_augmented_assignment_expression] = STATE(1548),
    [sym_ternary_expression] = STATE(1548),
    [sym_binary_expression] = STATE(1548),
    [sym_unary_expression] = STATE(1548),
    [sym_update_expression] = STATE(1548),
    [sym_string] = STATE(1548),
    [sym_template_string] = STATE(1548),
    [sym_regex] = STATE(1548),
    [sym_meta_property] = STATE(1548),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1548),
    [sym_type_assertion] = STATE(1548),
    [sym_as_expression] = STATE(1548),
    [sym_internal_module] = STATE(1548),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(1872),
    [anon_sym_export] = ACTIONS(1534),
    [anon_sym_namespace] = ACTIONS(1536),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(1534),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(1538),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(1540),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1428),
    [sym_this] = ACTIONS(1430),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [sym_null] = ACTIONS(1430),
    [sym_undefined] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(1534),
    [anon_sym_get] = ACTIONS(1534),
    [anon_sym_set] = ACTIONS(1534),
    [anon_sym_declare] = ACTIONS(1534),
    [anon_sym_public] = ACTIONS(1534),
    [anon_sym_private] = ACTIONS(1534),
    [anon_sym_protected] = ACTIONS(1534),
    [anon_sym_module] = ACTIONS(1534),
    [anon_sym_any] = ACTIONS(1534),
    [anon_sym_number] = ACTIONS(1534),
    [anon_sym_boolean] = ACTIONS(1534),
    [anon_sym_string] = ACTIONS(1534),
    [anon_sym_symbol] = ACTIONS(1534),
    [sym_readonly] = ACTIONS(1534),
  },
  [267] = {
    [sym_import] = STATE(1509),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1509),
    [sym_yield_expression] = STATE(1509),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1509),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1509),
    [sym_arrow_function] = STATE(1509),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1509),
    [sym_new_expression] = STATE(1509),
    [sym_await_expression] = STATE(1509),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1509),
    [sym_augmented_assignment_expression] = STATE(1509),
    [sym_ternary_expression] = STATE(1509),
    [sym_binary_expression] = STATE(1509),
    [sym_unary_expression] = STATE(1509),
    [sym_update_expression] = STATE(1509),
    [sym_string] = STATE(1509),
    [sym_template_string] = STATE(1509),
    [sym_regex] = STATE(1509),
    [sym_meta_property] = STATE(1509),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1509),
    [sym_type_assertion] = STATE(1509),
    [sym_as_expression] = STATE(1509),
    [sym_internal_module] = STATE(1509),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1874),
    [sym_this] = ACTIONS(1876),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1876),
    [sym_false] = ACTIONS(1876),
    [sym_null] = ACTIONS(1876),
    [sym_undefined] = ACTIONS(1876),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [268] = {
    [sym_import] = STATE(1181),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1181),
    [sym_yield_expression] = STATE(1181),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1181),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1181),
    [sym_arrow_function] = STATE(1181),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1181),
    [sym_new_expression] = STATE(1181),
    [sym_await_expression] = STATE(1181),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1181),
    [sym_augmented_assignment_expression] = STATE(1181),
    [sym_ternary_expression] = STATE(1181),
    [sym_binary_expression] = STATE(1181),
    [sym_unary_expression] = STATE(1181),
    [sym_update_expression] = STATE(1181),
    [sym_string] = STATE(1181),
    [sym_template_string] = STATE(1181),
    [sym_regex] = STATE(1181),
    [sym_meta_property] = STATE(1181),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1181),
    [sym_type_assertion] = STATE(1181),
    [sym_as_expression] = STATE(1181),
    [sym_internal_module] = STATE(1181),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1878),
    [sym_this] = ACTIONS(1880),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1880),
    [sym_false] = ACTIONS(1880),
    [sym_null] = ACTIONS(1880),
    [sym_undefined] = ACTIONS(1880),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [269] = {
    [sym_import] = STATE(1041),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1041),
    [sym_yield_expression] = STATE(1041),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1041),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1041),
    [sym_arrow_function] = STATE(1041),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1041),
    [sym_new_expression] = STATE(1041),
    [sym_await_expression] = STATE(1041),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1041),
    [sym_augmented_assignment_expression] = STATE(1041),
    [sym_ternary_expression] = STATE(1041),
    [sym_binary_expression] = STATE(1041),
    [sym_unary_expression] = STATE(1041),
    [sym_update_expression] = STATE(1041),
    [sym_string] = STATE(1041),
    [sym_template_string] = STATE(1041),
    [sym_regex] = STATE(1041),
    [sym_meta_property] = STATE(1041),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1041),
    [sym_type_assertion] = STATE(1041),
    [sym_as_expression] = STATE(1041),
    [sym_internal_module] = STATE(1041),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1882),
    [sym_this] = ACTIONS(1884),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1884),
    [sym_false] = ACTIONS(1884),
    [sym_null] = ACTIONS(1884),
    [sym_undefined] = ACTIONS(1884),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [270] = {
    [sym_import] = STATE(1110),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1110),
    [sym_yield_expression] = STATE(1110),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1110),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1110),
    [sym_arrow_function] = STATE(1110),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1110),
    [sym_new_expression] = STATE(1110),
    [sym_await_expression] = STATE(1110),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1110),
    [sym_augmented_assignment_expression] = STATE(1110),
    [sym_ternary_expression] = STATE(1110),
    [sym_binary_expression] = STATE(1110),
    [sym_unary_expression] = STATE(1110),
    [sym_update_expression] = STATE(1110),
    [sym_string] = STATE(1110),
    [sym_template_string] = STATE(1110),
    [sym_regex] = STATE(1110),
    [sym_meta_property] = STATE(1110),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1110),
    [sym_type_assertion] = STATE(1110),
    [sym_as_expression] = STATE(1110),
    [sym_internal_module] = STATE(1110),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1886),
    [sym_this] = ACTIONS(1888),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1888),
    [sym_false] = ACTIONS(1888),
    [sym_null] = ACTIONS(1888),
    [sym_undefined] = ACTIONS(1888),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [271] = {
    [sym_import] = STATE(1032),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1032),
    [sym_yield_expression] = STATE(1032),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1032),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1032),
    [sym_arrow_function] = STATE(1032),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1032),
    [sym_new_expression] = STATE(1032),
    [sym_await_expression] = STATE(1032),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1032),
    [sym_augmented_assignment_expression] = STATE(1032),
    [sym_ternary_expression] = STATE(1032),
    [sym_binary_expression] = STATE(1032),
    [sym_unary_expression] = STATE(1032),
    [sym_update_expression] = STATE(1032),
    [sym_string] = STATE(1032),
    [sym_template_string] = STATE(1032),
    [sym_regex] = STATE(1032),
    [sym_meta_property] = STATE(1032),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1032),
    [sym_type_assertion] = STATE(1032),
    [sym_as_expression] = STATE(1032),
    [sym_internal_module] = STATE(1032),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1890),
    [sym_this] = ACTIONS(1892),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1892),
    [sym_false] = ACTIONS(1892),
    [sym_null] = ACTIONS(1892),
    [sym_undefined] = ACTIONS(1892),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [272] = {
    [sym_import] = STATE(927),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(927),
    [sym_yield_expression] = STATE(927),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(927),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(927),
    [sym_arrow_function] = STATE(927),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(927),
    [sym_new_expression] = STATE(927),
    [sym_await_expression] = STATE(927),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(927),
    [sym_augmented_assignment_expression] = STATE(927),
    [sym_ternary_expression] = STATE(927),
    [sym_binary_expression] = STATE(927),
    [sym_unary_expression] = STATE(927),
    [sym_update_expression] = STATE(927),
    [sym_string] = STATE(927),
    [sym_template_string] = STATE(927),
    [sym_regex] = STATE(927),
    [sym_meta_property] = STATE(927),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(927),
    [sym_type_assertion] = STATE(927),
    [sym_as_expression] = STATE(927),
    [sym_internal_module] = STATE(927),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1894),
    [sym_this] = ACTIONS(1896),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1896),
    [sym_false] = ACTIONS(1896),
    [sym_null] = ACTIONS(1896),
    [sym_undefined] = ACTIONS(1896),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [273] = {
    [sym_import] = STATE(1100),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1100),
    [sym_yield_expression] = STATE(1100),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1100),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1100),
    [sym_arrow_function] = STATE(1100),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1100),
    [sym_new_expression] = STATE(1100),
    [sym_await_expression] = STATE(1100),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1100),
    [sym_augmented_assignment_expression] = STATE(1100),
    [sym_ternary_expression] = STATE(1100),
    [sym_binary_expression] = STATE(1100),
    [sym_unary_expression] = STATE(1100),
    [sym_update_expression] = STATE(1100),
    [sym_string] = STATE(1100),
    [sym_template_string] = STATE(1100),
    [sym_regex] = STATE(1100),
    [sym_meta_property] = STATE(1100),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1100),
    [sym_type_assertion] = STATE(1100),
    [sym_as_expression] = STATE(1100),
    [sym_internal_module] = STATE(1100),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1898),
    [sym_this] = ACTIONS(931),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(931),
    [sym_false] = ACTIONS(931),
    [sym_null] = ACTIONS(931),
    [sym_undefined] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [274] = {
    [sym_import] = STATE(1239),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1239),
    [sym_yield_expression] = STATE(1239),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1239),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1239),
    [sym_arrow_function] = STATE(1239),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1239),
    [sym_new_expression] = STATE(1239),
    [sym_await_expression] = STATE(1239),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1239),
    [sym_augmented_assignment_expression] = STATE(1239),
    [sym_ternary_expression] = STATE(1239),
    [sym_binary_expression] = STATE(1239),
    [sym_unary_expression] = STATE(1239),
    [sym_update_expression] = STATE(1239),
    [sym_string] = STATE(1239),
    [sym_template_string] = STATE(1239),
    [sym_regex] = STATE(1239),
    [sym_meta_property] = STATE(1239),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1239),
    [sym_type_assertion] = STATE(1239),
    [sym_as_expression] = STATE(1239),
    [sym_internal_module] = STATE(1239),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1900),
    [sym_this] = ACTIONS(1902),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1902),
    [sym_false] = ACTIONS(1902),
    [sym_null] = ACTIONS(1902),
    [sym_undefined] = ACTIONS(1902),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [275] = {
    [sym_import] = STATE(1404),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1404),
    [sym_yield_expression] = STATE(1404),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1404),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1404),
    [sym_arrow_function] = STATE(1404),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1404),
    [sym_new_expression] = STATE(1404),
    [sym_await_expression] = STATE(1404),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1404),
    [sym_augmented_assignment_expression] = STATE(1404),
    [sym_ternary_expression] = STATE(1404),
    [sym_binary_expression] = STATE(1404),
    [sym_unary_expression] = STATE(1404),
    [sym_update_expression] = STATE(1404),
    [sym_string] = STATE(1404),
    [sym_template_string] = STATE(1404),
    [sym_regex] = STATE(1404),
    [sym_meta_property] = STATE(1404),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1404),
    [sym_type_assertion] = STATE(1404),
    [sym_as_expression] = STATE(1404),
    [sym_internal_module] = STATE(1404),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1904),
    [sym_this] = ACTIONS(1906),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1906),
    [sym_false] = ACTIONS(1906),
    [sym_null] = ACTIONS(1906),
    [sym_undefined] = ACTIONS(1906),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [276] = {
    [sym_import] = STATE(1066),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1066),
    [sym_yield_expression] = STATE(1066),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1066),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1066),
    [sym_arrow_function] = STATE(1066),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1066),
    [sym_new_expression] = STATE(1066),
    [sym_await_expression] = STATE(1066),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1066),
    [sym_augmented_assignment_expression] = STATE(1066),
    [sym_ternary_expression] = STATE(1066),
    [sym_binary_expression] = STATE(1066),
    [sym_unary_expression] = STATE(1066),
    [sym_update_expression] = STATE(1066),
    [sym_string] = STATE(1066),
    [sym_template_string] = STATE(1066),
    [sym_regex] = STATE(1066),
    [sym_meta_property] = STATE(1066),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1066),
    [sym_type_assertion] = STATE(1066),
    [sym_as_expression] = STATE(1066),
    [sym_internal_module] = STATE(1066),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1908),
    [sym_this] = ACTIONS(1910),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1910),
    [sym_false] = ACTIONS(1910),
    [sym_null] = ACTIONS(1910),
    [sym_undefined] = ACTIONS(1910),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [277] = {
    [sym_import] = STATE(1053),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1053),
    [sym_yield_expression] = STATE(1053),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1053),
    [sym_arrow_function] = STATE(1053),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1053),
    [sym_await_expression] = STATE(1053),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1053),
    [sym_augmented_assignment_expression] = STATE(1053),
    [sym_ternary_expression] = STATE(1053),
    [sym_binary_expression] = STATE(1053),
    [sym_unary_expression] = STATE(1053),
    [sym_update_expression] = STATE(1053),
    [sym_string] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1053),
    [sym_type_assertion] = STATE(1053),
    [sym_as_expression] = STATE(1053),
    [sym_internal_module] = STATE(1053),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1912),
    [sym_this] = ACTIONS(1914),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1914),
    [sym_false] = ACTIONS(1914),
    [sym_null] = ACTIONS(1914),
    [sym_undefined] = ACTIONS(1914),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [278] = {
    [sym_import] = STATE(1050),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1050),
    [sym_yield_expression] = STATE(1050),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1050),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1050),
    [sym_arrow_function] = STATE(1050),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1050),
    [sym_new_expression] = STATE(1050),
    [sym_await_expression] = STATE(1050),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1050),
    [sym_augmented_assignment_expression] = STATE(1050),
    [sym_ternary_expression] = STATE(1050),
    [sym_binary_expression] = STATE(1050),
    [sym_unary_expression] = STATE(1050),
    [sym_update_expression] = STATE(1050),
    [sym_string] = STATE(1050),
    [sym_template_string] = STATE(1050),
    [sym_regex] = STATE(1050),
    [sym_meta_property] = STATE(1050),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1050),
    [sym_type_assertion] = STATE(1050),
    [sym_as_expression] = STATE(1050),
    [sym_internal_module] = STATE(1050),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1916),
    [sym_this] = ACTIONS(1918),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1918),
    [sym_false] = ACTIONS(1918),
    [sym_null] = ACTIONS(1918),
    [sym_undefined] = ACTIONS(1918),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [279] = {
    [sym_import] = STATE(1049),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1049),
    [sym_yield_expression] = STATE(1049),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1049),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1049),
    [sym_arrow_function] = STATE(1049),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1049),
    [sym_new_expression] = STATE(1049),
    [sym_await_expression] = STATE(1049),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1049),
    [sym_augmented_assignment_expression] = STATE(1049),
    [sym_ternary_expression] = STATE(1049),
    [sym_binary_expression] = STATE(1049),
    [sym_unary_expression] = STATE(1049),
    [sym_update_expression] = STATE(1049),
    [sym_string] = STATE(1049),
    [sym_template_string] = STATE(1049),
    [sym_regex] = STATE(1049),
    [sym_meta_property] = STATE(1049),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1049),
    [sym_type_assertion] = STATE(1049),
    [sym_as_expression] = STATE(1049),
    [sym_internal_module] = STATE(1049),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1920),
    [sym_this] = ACTIONS(1922),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1922),
    [sym_false] = ACTIONS(1922),
    [sym_null] = ACTIONS(1922),
    [sym_undefined] = ACTIONS(1922),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [280] = {
    [sym_import] = STATE(1243),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1243),
    [sym_yield_expression] = STATE(1243),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1243),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1243),
    [sym_arrow_function] = STATE(1243),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1243),
    [sym_new_expression] = STATE(1243),
    [sym_await_expression] = STATE(1243),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1243),
    [sym_augmented_assignment_expression] = STATE(1243),
    [sym_ternary_expression] = STATE(1243),
    [sym_binary_expression] = STATE(1243),
    [sym_unary_expression] = STATE(1243),
    [sym_update_expression] = STATE(1243),
    [sym_string] = STATE(1243),
    [sym_template_string] = STATE(1243),
    [sym_regex] = STATE(1243),
    [sym_meta_property] = STATE(1243),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1243),
    [sym_type_assertion] = STATE(1243),
    [sym_as_expression] = STATE(1243),
    [sym_internal_module] = STATE(1243),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1924),
    [sym_this] = ACTIONS(873),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(873),
    [sym_false] = ACTIONS(873),
    [sym_null] = ACTIONS(873),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [281] = {
    [sym_import] = STATE(1293),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1293),
    [sym_yield_expression] = STATE(1293),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1293),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1293),
    [sym_arrow_function] = STATE(1293),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1293),
    [sym_new_expression] = STATE(1293),
    [sym_await_expression] = STATE(1293),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1293),
    [sym_augmented_assignment_expression] = STATE(1293),
    [sym_ternary_expression] = STATE(1293),
    [sym_binary_expression] = STATE(1293),
    [sym_unary_expression] = STATE(1293),
    [sym_update_expression] = STATE(1293),
    [sym_string] = STATE(1293),
    [sym_template_string] = STATE(1293),
    [sym_regex] = STATE(1293),
    [sym_meta_property] = STATE(1293),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1293),
    [sym_type_assertion] = STATE(1293),
    [sym_as_expression] = STATE(1293),
    [sym_internal_module] = STATE(1293),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1926),
    [sym_this] = ACTIONS(1928),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1928),
    [sym_false] = ACTIONS(1928),
    [sym_null] = ACTIONS(1928),
    [sym_undefined] = ACTIONS(1928),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [282] = {
    [sym_import] = STATE(1047),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1047),
    [sym_yield_expression] = STATE(1047),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1047),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1047),
    [sym_arrow_function] = STATE(1047),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1047),
    [sym_new_expression] = STATE(1047),
    [sym_await_expression] = STATE(1047),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1047),
    [sym_augmented_assignment_expression] = STATE(1047),
    [sym_ternary_expression] = STATE(1047),
    [sym_binary_expression] = STATE(1047),
    [sym_unary_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_string] = STATE(1047),
    [sym_template_string] = STATE(1047),
    [sym_regex] = STATE(1047),
    [sym_meta_property] = STATE(1047),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1047),
    [sym_type_assertion] = STATE(1047),
    [sym_as_expression] = STATE(1047),
    [sym_internal_module] = STATE(1047),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1930),
    [sym_this] = ACTIONS(1932),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1932),
    [sym_false] = ACTIONS(1932),
    [sym_null] = ACTIONS(1932),
    [sym_undefined] = ACTIONS(1932),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [283] = {
    [sym_import] = STATE(1045),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1045),
    [sym_yield_expression] = STATE(1045),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1045),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1045),
    [sym_arrow_function] = STATE(1045),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1045),
    [sym_new_expression] = STATE(1045),
    [sym_await_expression] = STATE(1045),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1045),
    [sym_augmented_assignment_expression] = STATE(1045),
    [sym_ternary_expression] = STATE(1045),
    [sym_binary_expression] = STATE(1045),
    [sym_unary_expression] = STATE(1045),
    [sym_update_expression] = STATE(1045),
    [sym_string] = STATE(1045),
    [sym_template_string] = STATE(1045),
    [sym_regex] = STATE(1045),
    [sym_meta_property] = STATE(1045),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1045),
    [sym_type_assertion] = STATE(1045),
    [sym_as_expression] = STATE(1045),
    [sym_internal_module] = STATE(1045),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1934),
    [sym_this] = ACTIONS(1936),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [sym_null] = ACTIONS(1936),
    [sym_undefined] = ACTIONS(1936),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [284] = {
    [sym_import] = STATE(1232),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1232),
    [sym_yield_expression] = STATE(1232),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1232),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1232),
    [sym_arrow_function] = STATE(1232),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1232),
    [sym_new_expression] = STATE(1232),
    [sym_await_expression] = STATE(1232),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1232),
    [sym_augmented_assignment_expression] = STATE(1232),
    [sym_ternary_expression] = STATE(1232),
    [sym_binary_expression] = STATE(1232),
    [sym_unary_expression] = STATE(1232),
    [sym_update_expression] = STATE(1232),
    [sym_string] = STATE(1232),
    [sym_template_string] = STATE(1232),
    [sym_regex] = STATE(1232),
    [sym_meta_property] = STATE(1232),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1232),
    [sym_type_assertion] = STATE(1232),
    [sym_as_expression] = STATE(1232),
    [sym_internal_module] = STATE(1232),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1938),
    [sym_this] = ACTIONS(1940),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1940),
    [sym_false] = ACTIONS(1940),
    [sym_null] = ACTIONS(1940),
    [sym_undefined] = ACTIONS(1940),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [285] = {
    [sym_import] = STATE(1242),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1242),
    [sym_yield_expression] = STATE(1242),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1242),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1242),
    [sym_arrow_function] = STATE(1242),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1242),
    [sym_new_expression] = STATE(1242),
    [sym_await_expression] = STATE(1242),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1242),
    [sym_augmented_assignment_expression] = STATE(1242),
    [sym_ternary_expression] = STATE(1242),
    [sym_binary_expression] = STATE(1242),
    [sym_unary_expression] = STATE(1242),
    [sym_update_expression] = STATE(1242),
    [sym_string] = STATE(1242),
    [sym_template_string] = STATE(1242),
    [sym_regex] = STATE(1242),
    [sym_meta_property] = STATE(1242),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1242),
    [sym_as_expression] = STATE(1242),
    [sym_internal_module] = STATE(1242),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1942),
    [sym_this] = ACTIONS(1944),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1944),
    [sym_false] = ACTIONS(1944),
    [sym_null] = ACTIONS(1944),
    [sym_undefined] = ACTIONS(1944),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [286] = {
    [sym_import] = STATE(926),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(926),
    [sym_yield_expression] = STATE(926),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(926),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(926),
    [sym_arrow_function] = STATE(926),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(926),
    [sym_new_expression] = STATE(926),
    [sym_await_expression] = STATE(926),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(926),
    [sym_augmented_assignment_expression] = STATE(926),
    [sym_ternary_expression] = STATE(926),
    [sym_binary_expression] = STATE(926),
    [sym_unary_expression] = STATE(926),
    [sym_update_expression] = STATE(926),
    [sym_string] = STATE(926),
    [sym_template_string] = STATE(926),
    [sym_regex] = STATE(926),
    [sym_meta_property] = STATE(926),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(926),
    [sym_type_assertion] = STATE(926),
    [sym_as_expression] = STATE(926),
    [sym_internal_module] = STATE(926),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1946),
    [sym_this] = ACTIONS(1948),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1948),
    [sym_false] = ACTIONS(1948),
    [sym_null] = ACTIONS(1948),
    [sym_undefined] = ACTIONS(1948),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [287] = {
    [sym_import] = STATE(1308),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1308),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1308),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1308),
    [sym_arrow_function] = STATE(1308),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1308),
    [sym_new_expression] = STATE(1308),
    [sym_await_expression] = STATE(1308),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1308),
    [sym_augmented_assignment_expression] = STATE(1308),
    [sym_ternary_expression] = STATE(1308),
    [sym_binary_expression] = STATE(1308),
    [sym_unary_expression] = STATE(1308),
    [sym_update_expression] = STATE(1308),
    [sym_string] = STATE(1308),
    [sym_template_string] = STATE(1308),
    [sym_regex] = STATE(1308),
    [sym_meta_property] = STATE(1308),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1308),
    [sym_type_assertion] = STATE(1308),
    [sym_as_expression] = STATE(1308),
    [sym_internal_module] = STATE(1308),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1950),
    [sym_this] = ACTIONS(1952),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1952),
    [sym_false] = ACTIONS(1952),
    [sym_null] = ACTIONS(1952),
    [sym_undefined] = ACTIONS(1952),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [288] = {
    [sym_import] = STATE(1209),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1209),
    [sym_yield_expression] = STATE(1209),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1209),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1209),
    [sym_arrow_function] = STATE(1209),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1209),
    [sym_new_expression] = STATE(1209),
    [sym_await_expression] = STATE(1209),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1209),
    [sym_augmented_assignment_expression] = STATE(1209),
    [sym_ternary_expression] = STATE(1209),
    [sym_binary_expression] = STATE(1209),
    [sym_unary_expression] = STATE(1209),
    [sym_update_expression] = STATE(1209),
    [sym_string] = STATE(1209),
    [sym_template_string] = STATE(1209),
    [sym_regex] = STATE(1209),
    [sym_meta_property] = STATE(1209),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1209),
    [sym_type_assertion] = STATE(1209),
    [sym_as_expression] = STATE(1209),
    [sym_internal_module] = STATE(1209),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1954),
    [sym_this] = ACTIONS(1956),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1956),
    [sym_false] = ACTIONS(1956),
    [sym_null] = ACTIONS(1956),
    [sym_undefined] = ACTIONS(1956),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [289] = {
    [sym_import] = STATE(1347),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1347),
    [sym_yield_expression] = STATE(1347),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1347),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1347),
    [sym_arrow_function] = STATE(1347),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1347),
    [sym_new_expression] = STATE(1347),
    [sym_await_expression] = STATE(1347),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1347),
    [sym_augmented_assignment_expression] = STATE(1347),
    [sym_ternary_expression] = STATE(1347),
    [sym_binary_expression] = STATE(1347),
    [sym_unary_expression] = STATE(1347),
    [sym_update_expression] = STATE(1347),
    [sym_string] = STATE(1347),
    [sym_template_string] = STATE(1347),
    [sym_regex] = STATE(1347),
    [sym_meta_property] = STATE(1347),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1347),
    [sym_type_assertion] = STATE(1347),
    [sym_as_expression] = STATE(1347),
    [sym_internal_module] = STATE(1347),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1958),
    [sym_this] = ACTIONS(1960),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1960),
    [sym_false] = ACTIONS(1960),
    [sym_null] = ACTIONS(1960),
    [sym_undefined] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [290] = {
    [sym_import] = STATE(1205),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1205),
    [sym_yield_expression] = STATE(1205),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1205),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1205),
    [sym_arrow_function] = STATE(1205),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1205),
    [sym_new_expression] = STATE(1205),
    [sym_await_expression] = STATE(1205),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1205),
    [sym_augmented_assignment_expression] = STATE(1205),
    [sym_ternary_expression] = STATE(1205),
    [sym_binary_expression] = STATE(1205),
    [sym_unary_expression] = STATE(1205),
    [sym_update_expression] = STATE(1205),
    [sym_string] = STATE(1205),
    [sym_template_string] = STATE(1205),
    [sym_regex] = STATE(1205),
    [sym_meta_property] = STATE(1205),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1205),
    [sym_type_assertion] = STATE(1205),
    [sym_as_expression] = STATE(1205),
    [sym_internal_module] = STATE(1205),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1962),
    [sym_this] = ACTIONS(1964),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1964),
    [sym_false] = ACTIONS(1964),
    [sym_null] = ACTIONS(1964),
    [sym_undefined] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [291] = {
    [sym_import] = STATE(1206),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1206),
    [sym_yield_expression] = STATE(1206),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1206),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1206),
    [sym_arrow_function] = STATE(1206),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1206),
    [sym_new_expression] = STATE(1206),
    [sym_await_expression] = STATE(1206),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1206),
    [sym_augmented_assignment_expression] = STATE(1206),
    [sym_ternary_expression] = STATE(1206),
    [sym_binary_expression] = STATE(1206),
    [sym_unary_expression] = STATE(1206),
    [sym_update_expression] = STATE(1206),
    [sym_string] = STATE(1206),
    [sym_template_string] = STATE(1206),
    [sym_regex] = STATE(1206),
    [sym_meta_property] = STATE(1206),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1206),
    [sym_type_assertion] = STATE(1206),
    [sym_as_expression] = STATE(1206),
    [sym_internal_module] = STATE(1206),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1966),
    [sym_this] = ACTIONS(1968),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [sym_null] = ACTIONS(1968),
    [sym_undefined] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [292] = {
    [sym_import] = STATE(1201),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1201),
    [sym_yield_expression] = STATE(1201),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1201),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1201),
    [sym_arrow_function] = STATE(1201),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1201),
    [sym_new_expression] = STATE(1201),
    [sym_await_expression] = STATE(1201),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1201),
    [sym_augmented_assignment_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(1201),
    [sym_binary_expression] = STATE(1201),
    [sym_unary_expression] = STATE(1201),
    [sym_update_expression] = STATE(1201),
    [sym_string] = STATE(1201),
    [sym_template_string] = STATE(1201),
    [sym_regex] = STATE(1201),
    [sym_meta_property] = STATE(1201),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1201),
    [sym_type_assertion] = STATE(1201),
    [sym_as_expression] = STATE(1201),
    [sym_internal_module] = STATE(1201),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1970),
    [sym_this] = ACTIONS(1005),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1005),
    [sym_false] = ACTIONS(1005),
    [sym_null] = ACTIONS(1005),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [293] = {
    [sym_import] = STATE(1288),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1288),
    [sym_yield_expression] = STATE(1288),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1288),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1288),
    [sym_arrow_function] = STATE(1288),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1288),
    [sym_new_expression] = STATE(1288),
    [sym_await_expression] = STATE(1288),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1288),
    [sym_augmented_assignment_expression] = STATE(1288),
    [sym_ternary_expression] = STATE(1288),
    [sym_binary_expression] = STATE(1288),
    [sym_unary_expression] = STATE(1288),
    [sym_update_expression] = STATE(1288),
    [sym_string] = STATE(1288),
    [sym_template_string] = STATE(1288),
    [sym_regex] = STATE(1288),
    [sym_meta_property] = STATE(1288),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1288),
    [sym_type_assertion] = STATE(1288),
    [sym_as_expression] = STATE(1288),
    [sym_internal_module] = STATE(1288),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1972),
    [sym_this] = ACTIONS(1974),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1974),
    [sym_false] = ACTIONS(1974),
    [sym_null] = ACTIONS(1974),
    [sym_undefined] = ACTIONS(1974),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [294] = {
    [sym_import] = STATE(1292),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1292),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1292),
    [sym_arrow_function] = STATE(1292),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1292),
    [sym_new_expression] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_string] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1292),
    [sym_type_assertion] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1976),
    [sym_this] = ACTIONS(1978),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1978),
    [sym_false] = ACTIONS(1978),
    [sym_null] = ACTIONS(1978),
    [sym_undefined] = ACTIONS(1978),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [295] = {
    [sym_import] = STATE(966),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(966),
    [sym_yield_expression] = STATE(966),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(966),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(966),
    [sym_arrow_function] = STATE(966),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(966),
    [sym_new_expression] = STATE(966),
    [sym_await_expression] = STATE(966),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(966),
    [sym_augmented_assignment_expression] = STATE(966),
    [sym_ternary_expression] = STATE(966),
    [sym_binary_expression] = STATE(966),
    [sym_unary_expression] = STATE(966),
    [sym_update_expression] = STATE(966),
    [sym_string] = STATE(966),
    [sym_template_string] = STATE(966),
    [sym_regex] = STATE(966),
    [sym_meta_property] = STATE(966),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(966),
    [sym_type_assertion] = STATE(966),
    [sym_as_expression] = STATE(966),
    [sym_internal_module] = STATE(966),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(585),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_null] = ACTIONS(587),
    [sym_undefined] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [296] = {
    [sym_import] = STATE(1329),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1329),
    [sym_yield_expression] = STATE(1329),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1329),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1329),
    [sym_arrow_function] = STATE(1329),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1329),
    [sym_new_expression] = STATE(1329),
    [sym_await_expression] = STATE(1329),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1329),
    [sym_augmented_assignment_expression] = STATE(1329),
    [sym_ternary_expression] = STATE(1329),
    [sym_binary_expression] = STATE(1329),
    [sym_unary_expression] = STATE(1329),
    [sym_update_expression] = STATE(1329),
    [sym_string] = STATE(1329),
    [sym_template_string] = STATE(1329),
    [sym_regex] = STATE(1329),
    [sym_meta_property] = STATE(1329),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1329),
    [sym_type_assertion] = STATE(1329),
    [sym_as_expression] = STATE(1329),
    [sym_internal_module] = STATE(1329),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1980),
    [sym_this] = ACTIONS(1982),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1982),
    [sym_false] = ACTIONS(1982),
    [sym_null] = ACTIONS(1982),
    [sym_undefined] = ACTIONS(1982),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [297] = {
    [sym_import] = STATE(1287),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1287),
    [sym_yield_expression] = STATE(1287),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1287),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1287),
    [sym_arrow_function] = STATE(1287),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1287),
    [sym_new_expression] = STATE(1287),
    [sym_await_expression] = STATE(1287),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1287),
    [sym_augmented_assignment_expression] = STATE(1287),
    [sym_ternary_expression] = STATE(1287),
    [sym_binary_expression] = STATE(1287),
    [sym_unary_expression] = STATE(1287),
    [sym_update_expression] = STATE(1287),
    [sym_string] = STATE(1287),
    [sym_template_string] = STATE(1287),
    [sym_regex] = STATE(1287),
    [sym_meta_property] = STATE(1287),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1287),
    [sym_type_assertion] = STATE(1287),
    [sym_as_expression] = STATE(1287),
    [sym_internal_module] = STATE(1287),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1984),
    [sym_this] = ACTIONS(1986),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1986),
    [sym_false] = ACTIONS(1986),
    [sym_null] = ACTIONS(1986),
    [sym_undefined] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [298] = {
    [sym_import] = STATE(1186),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1186),
    [sym_yield_expression] = STATE(1186),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1186),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1186),
    [sym_arrow_function] = STATE(1186),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1186),
    [sym_new_expression] = STATE(1186),
    [sym_await_expression] = STATE(1186),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1186),
    [sym_augmented_assignment_expression] = STATE(1186),
    [sym_ternary_expression] = STATE(1186),
    [sym_binary_expression] = STATE(1186),
    [sym_unary_expression] = STATE(1186),
    [sym_update_expression] = STATE(1186),
    [sym_string] = STATE(1186),
    [sym_template_string] = STATE(1186),
    [sym_regex] = STATE(1186),
    [sym_meta_property] = STATE(1186),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1186),
    [sym_type_assertion] = STATE(1186),
    [sym_as_expression] = STATE(1186),
    [sym_internal_module] = STATE(1186),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(1988),
    [sym_this] = ACTIONS(1990),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(1990),
    [sym_false] = ACTIONS(1990),
    [sym_null] = ACTIONS(1990),
    [sym_undefined] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [299] = {
    [sym_import] = STATE(1241),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1241),
    [sym_yield_expression] = STATE(1241),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1241),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1241),
    [sym_arrow_function] = STATE(1241),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1241),
    [sym_new_expression] = STATE(1241),
    [sym_await_expression] = STATE(1241),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1241),
    [sym_augmented_assignment_expression] = STATE(1241),
    [sym_ternary_expression] = STATE(1241),
    [sym_binary_expression] = STATE(1241),
    [sym_unary_expression] = STATE(1241),
    [sym_update_expression] = STATE(1241),
    [sym_string] = STATE(1241),
    [sym_template_string] = STATE(1241),
    [sym_regex] = STATE(1241),
    [sym_meta_property] = STATE(1241),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1241),
    [sym_type_assertion] = STATE(1241),
    [sym_as_expression] = STATE(1241),
    [sym_internal_module] = STATE(1241),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(1994),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1994),
    [sym_false] = ACTIONS(1994),
    [sym_null] = ACTIONS(1994),
    [sym_undefined] = ACTIONS(1994),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [300] = {
    [sym_import] = STATE(1137),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1137),
    [sym_yield_expression] = STATE(1137),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1137),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1137),
    [sym_arrow_function] = STATE(1137),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1137),
    [sym_new_expression] = STATE(1137),
    [sym_await_expression] = STATE(1137),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1137),
    [sym_augmented_assignment_expression] = STATE(1137),
    [sym_ternary_expression] = STATE(1137),
    [sym_binary_expression] = STATE(1137),
    [sym_unary_expression] = STATE(1137),
    [sym_update_expression] = STATE(1137),
    [sym_string] = STATE(1137),
    [sym_template_string] = STATE(1137),
    [sym_regex] = STATE(1137),
    [sym_meta_property] = STATE(1137),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1137),
    [sym_type_assertion] = STATE(1137),
    [sym_as_expression] = STATE(1137),
    [sym_internal_module] = STATE(1137),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1996),
    [sym_this] = ACTIONS(1998),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1998),
    [sym_false] = ACTIONS(1998),
    [sym_null] = ACTIONS(1998),
    [sym_undefined] = ACTIONS(1998),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [301] = {
    [sym_import] = STATE(1348),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1348),
    [sym_yield_expression] = STATE(1348),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1348),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1348),
    [sym_arrow_function] = STATE(1348),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1348),
    [sym_new_expression] = STATE(1348),
    [sym_await_expression] = STATE(1348),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1348),
    [sym_augmented_assignment_expression] = STATE(1348),
    [sym_ternary_expression] = STATE(1348),
    [sym_binary_expression] = STATE(1348),
    [sym_unary_expression] = STATE(1348),
    [sym_update_expression] = STATE(1348),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1348),
    [sym_regex] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1348),
    [sym_as_expression] = STATE(1348),
    [sym_internal_module] = STATE(1348),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2000),
    [sym_this] = ACTIONS(2002),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2002),
    [sym_false] = ACTIONS(2002),
    [sym_null] = ACTIONS(2002),
    [sym_undefined] = ACTIONS(2002),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [302] = {
    [sym_import] = STATE(1161),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1161),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1161),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1161),
    [sym_arrow_function] = STATE(1161),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1161),
    [sym_new_expression] = STATE(1161),
    [sym_await_expression] = STATE(1161),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1161),
    [sym_augmented_assignment_expression] = STATE(1161),
    [sym_ternary_expression] = STATE(1161),
    [sym_binary_expression] = STATE(1161),
    [sym_unary_expression] = STATE(1161),
    [sym_update_expression] = STATE(1161),
    [sym_string] = STATE(1161),
    [sym_template_string] = STATE(1161),
    [sym_regex] = STATE(1161),
    [sym_meta_property] = STATE(1161),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1161),
    [sym_type_assertion] = STATE(1161),
    [sym_as_expression] = STATE(1161),
    [sym_internal_module] = STATE(1161),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2004),
    [sym_this] = ACTIONS(2006),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2006),
    [sym_false] = ACTIONS(2006),
    [sym_null] = ACTIONS(2006),
    [sym_undefined] = ACTIONS(2006),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [303] = {
    [sym_import] = STATE(1169),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1169),
    [sym_yield_expression] = STATE(1169),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1169),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1169),
    [sym_arrow_function] = STATE(1169),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1169),
    [sym_new_expression] = STATE(1169),
    [sym_await_expression] = STATE(1169),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1169),
    [sym_augmented_assignment_expression] = STATE(1169),
    [sym_ternary_expression] = STATE(1169),
    [sym_binary_expression] = STATE(1169),
    [sym_unary_expression] = STATE(1169),
    [sym_update_expression] = STATE(1169),
    [sym_string] = STATE(1169),
    [sym_template_string] = STATE(1169),
    [sym_regex] = STATE(1169),
    [sym_meta_property] = STATE(1169),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1169),
    [sym_type_assertion] = STATE(1169),
    [sym_as_expression] = STATE(1169),
    [sym_internal_module] = STATE(1169),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2008),
    [sym_this] = ACTIONS(2010),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2010),
    [sym_false] = ACTIONS(2010),
    [sym_null] = ACTIONS(2010),
    [sym_undefined] = ACTIONS(2010),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [304] = {
    [sym_import] = STATE(1149),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1149),
    [sym_yield_expression] = STATE(1149),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1149),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1149),
    [sym_arrow_function] = STATE(1149),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1149),
    [sym_new_expression] = STATE(1149),
    [sym_await_expression] = STATE(1149),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1149),
    [sym_augmented_assignment_expression] = STATE(1149),
    [sym_ternary_expression] = STATE(1149),
    [sym_binary_expression] = STATE(1149),
    [sym_unary_expression] = STATE(1149),
    [sym_update_expression] = STATE(1149),
    [sym_string] = STATE(1149),
    [sym_template_string] = STATE(1149),
    [sym_regex] = STATE(1149),
    [sym_meta_property] = STATE(1149),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1149),
    [sym_type_assertion] = STATE(1149),
    [sym_as_expression] = STATE(1149),
    [sym_internal_module] = STATE(1149),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2012),
    [sym_this] = ACTIONS(2014),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2014),
    [sym_false] = ACTIONS(2014),
    [sym_null] = ACTIONS(2014),
    [sym_undefined] = ACTIONS(2014),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [305] = {
    [sym_import] = STATE(1142),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1142),
    [sym_yield_expression] = STATE(1142),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1142),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1142),
    [sym_arrow_function] = STATE(1142),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1142),
    [sym_new_expression] = STATE(1142),
    [sym_await_expression] = STATE(1142),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1142),
    [sym_augmented_assignment_expression] = STATE(1142),
    [sym_ternary_expression] = STATE(1142),
    [sym_binary_expression] = STATE(1142),
    [sym_unary_expression] = STATE(1142),
    [sym_update_expression] = STATE(1142),
    [sym_string] = STATE(1142),
    [sym_template_string] = STATE(1142),
    [sym_regex] = STATE(1142),
    [sym_meta_property] = STATE(1142),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1142),
    [sym_type_assertion] = STATE(1142),
    [sym_as_expression] = STATE(1142),
    [sym_internal_module] = STATE(1142),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2016),
    [sym_this] = ACTIONS(2018),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2018),
    [sym_false] = ACTIONS(2018),
    [sym_null] = ACTIONS(2018),
    [sym_undefined] = ACTIONS(2018),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [306] = {
    [sym_import] = STATE(1197),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1197),
    [sym_yield_expression] = STATE(1197),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1197),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1197),
    [sym_arrow_function] = STATE(1197),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1197),
    [sym_new_expression] = STATE(1197),
    [sym_await_expression] = STATE(1197),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1197),
    [sym_augmented_assignment_expression] = STATE(1197),
    [sym_ternary_expression] = STATE(1197),
    [sym_binary_expression] = STATE(1197),
    [sym_unary_expression] = STATE(1197),
    [sym_update_expression] = STATE(1197),
    [sym_string] = STATE(1197),
    [sym_template_string] = STATE(1197),
    [sym_regex] = STATE(1197),
    [sym_meta_property] = STATE(1197),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1197),
    [sym_type_assertion] = STATE(1197),
    [sym_as_expression] = STATE(1197),
    [sym_internal_module] = STATE(1197),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2020),
    [sym_this] = ACTIONS(2022),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2022),
    [sym_false] = ACTIONS(2022),
    [sym_null] = ACTIONS(2022),
    [sym_undefined] = ACTIONS(2022),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [307] = {
    [sym_import] = STATE(1147),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1147),
    [sym_yield_expression] = STATE(1147),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1147),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1147),
    [sym_arrow_function] = STATE(1147),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1147),
    [sym_new_expression] = STATE(1147),
    [sym_await_expression] = STATE(1147),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1147),
    [sym_augmented_assignment_expression] = STATE(1147),
    [sym_ternary_expression] = STATE(1147),
    [sym_binary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym_update_expression] = STATE(1147),
    [sym_string] = STATE(1147),
    [sym_template_string] = STATE(1147),
    [sym_regex] = STATE(1147),
    [sym_meta_property] = STATE(1147),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1147),
    [sym_type_assertion] = STATE(1147),
    [sym_as_expression] = STATE(1147),
    [sym_internal_module] = STATE(1147),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2024),
    [sym_this] = ACTIONS(2026),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2026),
    [sym_false] = ACTIONS(2026),
    [sym_null] = ACTIONS(2026),
    [sym_undefined] = ACTIONS(2026),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [308] = {
    [sym_import] = STATE(926),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(926),
    [sym_yield_expression] = STATE(926),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(926),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(926),
    [sym_arrow_function] = STATE(926),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(926),
    [sym_new_expression] = STATE(926),
    [sym_await_expression] = STATE(926),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(926),
    [sym_augmented_assignment_expression] = STATE(926),
    [sym_ternary_expression] = STATE(926),
    [sym_binary_expression] = STATE(926),
    [sym_unary_expression] = STATE(926),
    [sym_update_expression] = STATE(926),
    [sym_string] = STATE(926),
    [sym_template_string] = STATE(926),
    [sym_regex] = STATE(926),
    [sym_meta_property] = STATE(926),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(926),
    [sym_type_assertion] = STATE(926),
    [sym_as_expression] = STATE(926),
    [sym_internal_module] = STATE(926),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1946),
    [sym_this] = ACTIONS(1948),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1948),
    [sym_false] = ACTIONS(1948),
    [sym_null] = ACTIONS(1948),
    [sym_undefined] = ACTIONS(1948),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [309] = {
    [sym_import] = STATE(927),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(927),
    [sym_yield_expression] = STATE(927),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(927),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(927),
    [sym_arrow_function] = STATE(927),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(927),
    [sym_new_expression] = STATE(927),
    [sym_await_expression] = STATE(927),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(927),
    [sym_augmented_assignment_expression] = STATE(927),
    [sym_ternary_expression] = STATE(927),
    [sym_binary_expression] = STATE(927),
    [sym_unary_expression] = STATE(927),
    [sym_update_expression] = STATE(927),
    [sym_string] = STATE(927),
    [sym_template_string] = STATE(927),
    [sym_regex] = STATE(927),
    [sym_meta_property] = STATE(927),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(927),
    [sym_type_assertion] = STATE(927),
    [sym_as_expression] = STATE(927),
    [sym_internal_module] = STATE(927),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1894),
    [sym_this] = ACTIONS(1896),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1896),
    [sym_false] = ACTIONS(1896),
    [sym_null] = ACTIONS(1896),
    [sym_undefined] = ACTIONS(1896),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [310] = {
    [sym_import] = STATE(1204),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1204),
    [sym_yield_expression] = STATE(1204),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1204),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1204),
    [sym_arrow_function] = STATE(1204),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1204),
    [sym_new_expression] = STATE(1204),
    [sym_await_expression] = STATE(1204),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1204),
    [sym_augmented_assignment_expression] = STATE(1204),
    [sym_ternary_expression] = STATE(1204),
    [sym_binary_expression] = STATE(1204),
    [sym_unary_expression] = STATE(1204),
    [sym_update_expression] = STATE(1204),
    [sym_string] = STATE(1204),
    [sym_template_string] = STATE(1204),
    [sym_regex] = STATE(1204),
    [sym_meta_property] = STATE(1204),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1204),
    [sym_type_assertion] = STATE(1204),
    [sym_as_expression] = STATE(1204),
    [sym_internal_module] = STATE(1204),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2028),
    [sym_this] = ACTIONS(2030),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2030),
    [sym_false] = ACTIONS(2030),
    [sym_null] = ACTIONS(2030),
    [sym_undefined] = ACTIONS(2030),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [311] = {
    [sym_import] = STATE(1328),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1328),
    [sym_yield_expression] = STATE(1328),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1328),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1328),
    [sym_arrow_function] = STATE(1328),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_await_expression] = STATE(1328),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1328),
    [sym_augmented_assignment_expression] = STATE(1328),
    [sym_ternary_expression] = STATE(1328),
    [sym_binary_expression] = STATE(1328),
    [sym_unary_expression] = STATE(1328),
    [sym_update_expression] = STATE(1328),
    [sym_string] = STATE(1328),
    [sym_template_string] = STATE(1328),
    [sym_regex] = STATE(1328),
    [sym_meta_property] = STATE(1328),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1328),
    [sym_type_assertion] = STATE(1328),
    [sym_as_expression] = STATE(1328),
    [sym_internal_module] = STATE(1328),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2032),
    [sym_this] = ACTIONS(2034),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2034),
    [sym_false] = ACTIONS(2034),
    [sym_null] = ACTIONS(2034),
    [sym_undefined] = ACTIONS(2034),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [312] = {
    [sym_import] = STATE(967),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(967),
    [sym_yield_expression] = STATE(967),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(967),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(967),
    [sym_arrow_function] = STATE(967),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(967),
    [sym_new_expression] = STATE(967),
    [sym_await_expression] = STATE(967),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(967),
    [sym_augmented_assignment_expression] = STATE(967),
    [sym_ternary_expression] = STATE(967),
    [sym_binary_expression] = STATE(967),
    [sym_unary_expression] = STATE(967),
    [sym_update_expression] = STATE(967),
    [sym_string] = STATE(967),
    [sym_template_string] = STATE(967),
    [sym_regex] = STATE(967),
    [sym_meta_property] = STATE(967),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(967),
    [sym_type_assertion] = STATE(967),
    [sym_as_expression] = STATE(967),
    [sym_internal_module] = STATE(967),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2036),
    [sym_this] = ACTIONS(2038),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2038),
    [sym_false] = ACTIONS(2038),
    [sym_null] = ACTIONS(2038),
    [sym_undefined] = ACTIONS(2038),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [313] = {
    [sym_import] = STATE(1060),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1060),
    [sym_yield_expression] = STATE(1060),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1060),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1060),
    [sym_arrow_function] = STATE(1060),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1060),
    [sym_new_expression] = STATE(1060),
    [sym_await_expression] = STATE(1060),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_ternary_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_unary_expression] = STATE(1060),
    [sym_update_expression] = STATE(1060),
    [sym_string] = STATE(1060),
    [sym_template_string] = STATE(1060),
    [sym_regex] = STATE(1060),
    [sym_meta_property] = STATE(1060),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1060),
    [sym_type_assertion] = STATE(1060),
    [sym_as_expression] = STATE(1060),
    [sym_internal_module] = STATE(1060),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2040),
    [sym_this] = ACTIONS(2042),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2042),
    [sym_false] = ACTIONS(2042),
    [sym_null] = ACTIONS(2042),
    [sym_undefined] = ACTIONS(2042),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [314] = {
    [sym_import] = STATE(1061),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1061),
    [sym_yield_expression] = STATE(1061),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1061),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1061),
    [sym_arrow_function] = STATE(1061),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1061),
    [sym_new_expression] = STATE(1061),
    [sym_await_expression] = STATE(1061),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1061),
    [sym_augmented_assignment_expression] = STATE(1061),
    [sym_ternary_expression] = STATE(1061),
    [sym_binary_expression] = STATE(1061),
    [sym_unary_expression] = STATE(1061),
    [sym_update_expression] = STATE(1061),
    [sym_string] = STATE(1061),
    [sym_template_string] = STATE(1061),
    [sym_regex] = STATE(1061),
    [sym_meta_property] = STATE(1061),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1061),
    [sym_type_assertion] = STATE(1061),
    [sym_as_expression] = STATE(1061),
    [sym_internal_module] = STATE(1061),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2044),
    [sym_this] = ACTIONS(2046),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2046),
    [sym_false] = ACTIONS(2046),
    [sym_null] = ACTIONS(2046),
    [sym_undefined] = ACTIONS(2046),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [315] = {
    [sym_import] = STATE(1350),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1350),
    [sym_yield_expression] = STATE(1350),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1350),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1350),
    [sym_arrow_function] = STATE(1350),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1350),
    [sym_new_expression] = STATE(1350),
    [sym_await_expression] = STATE(1350),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1350),
    [sym_augmented_assignment_expression] = STATE(1350),
    [sym_ternary_expression] = STATE(1350),
    [sym_binary_expression] = STATE(1350),
    [sym_unary_expression] = STATE(1350),
    [sym_update_expression] = STATE(1350),
    [sym_string] = STATE(1350),
    [sym_template_string] = STATE(1350),
    [sym_regex] = STATE(1350),
    [sym_meta_property] = STATE(1350),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1350),
    [sym_type_assertion] = STATE(1350),
    [sym_as_expression] = STATE(1350),
    [sym_internal_module] = STATE(1350),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2048),
    [sym_this] = ACTIONS(2050),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2050),
    [sym_false] = ACTIONS(2050),
    [sym_null] = ACTIONS(2050),
    [sym_undefined] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [316] = {
    [sym_import] = STATE(1349),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1349),
    [sym_yield_expression] = STATE(1349),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1349),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1349),
    [sym_arrow_function] = STATE(1349),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1349),
    [sym_new_expression] = STATE(1349),
    [sym_await_expression] = STATE(1349),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1349),
    [sym_augmented_assignment_expression] = STATE(1349),
    [sym_ternary_expression] = STATE(1349),
    [sym_binary_expression] = STATE(1349),
    [sym_unary_expression] = STATE(1349),
    [sym_update_expression] = STATE(1349),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_regex] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1349),
    [sym_type_assertion] = STATE(1349),
    [sym_as_expression] = STATE(1349),
    [sym_internal_module] = STATE(1349),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2052),
    [sym_this] = ACTIONS(2054),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2054),
    [sym_false] = ACTIONS(2054),
    [sym_null] = ACTIONS(2054),
    [sym_undefined] = ACTIONS(2054),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [317] = {
    [sym_import] = STATE(1230),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1230),
    [sym_yield_expression] = STATE(1230),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1230),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1230),
    [sym_arrow_function] = STATE(1230),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1230),
    [sym_new_expression] = STATE(1230),
    [sym_await_expression] = STATE(1230),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1230),
    [sym_augmented_assignment_expression] = STATE(1230),
    [sym_ternary_expression] = STATE(1230),
    [sym_binary_expression] = STATE(1230),
    [sym_unary_expression] = STATE(1230),
    [sym_update_expression] = STATE(1230),
    [sym_string] = STATE(1230),
    [sym_template_string] = STATE(1230),
    [sym_regex] = STATE(1230),
    [sym_meta_property] = STATE(1230),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1230),
    [sym_type_assertion] = STATE(1230),
    [sym_as_expression] = STATE(1230),
    [sym_internal_module] = STATE(1230),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2056),
    [sym_this] = ACTIONS(2058),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2058),
    [sym_false] = ACTIONS(2058),
    [sym_null] = ACTIONS(2058),
    [sym_undefined] = ACTIONS(2058),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [318] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1002),
    [sym_type_assertion] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2062),
    [sym_this] = ACTIONS(2064),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [sym_null] = ACTIONS(2064),
    [sym_undefined] = ACTIONS(2064),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [319] = {
    [sym_import] = STATE(1062),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1062),
    [sym_yield_expression] = STATE(1062),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1062),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1062),
    [sym_arrow_function] = STATE(1062),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1062),
    [sym_new_expression] = STATE(1062),
    [sym_await_expression] = STATE(1062),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1062),
    [sym_augmented_assignment_expression] = STATE(1062),
    [sym_ternary_expression] = STATE(1062),
    [sym_binary_expression] = STATE(1062),
    [sym_unary_expression] = STATE(1062),
    [sym_update_expression] = STATE(1062),
    [sym_string] = STATE(1062),
    [sym_template_string] = STATE(1062),
    [sym_regex] = STATE(1062),
    [sym_meta_property] = STATE(1062),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1062),
    [sym_type_assertion] = STATE(1062),
    [sym_as_expression] = STATE(1062),
    [sym_internal_module] = STATE(1062),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2066),
    [sym_this] = ACTIONS(2068),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [sym_null] = ACTIONS(2068),
    [sym_undefined] = ACTIONS(2068),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [320] = {
    [sym_import] = STATE(1234),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1234),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1234),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1234),
    [sym_arrow_function] = STATE(1234),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1234),
    [sym_new_expression] = STATE(1234),
    [sym_await_expression] = STATE(1234),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1234),
    [sym_augmented_assignment_expression] = STATE(1234),
    [sym_ternary_expression] = STATE(1234),
    [sym_binary_expression] = STATE(1234),
    [sym_unary_expression] = STATE(1234),
    [sym_update_expression] = STATE(1234),
    [sym_string] = STATE(1234),
    [sym_template_string] = STATE(1234),
    [sym_regex] = STATE(1234),
    [sym_meta_property] = STATE(1234),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1234),
    [sym_type_assertion] = STATE(1234),
    [sym_as_expression] = STATE(1234),
    [sym_internal_module] = STATE(1234),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2070),
    [sym_this] = ACTIONS(2072),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [sym_null] = ACTIONS(2072),
    [sym_undefined] = ACTIONS(2072),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [321] = {
    [sym_import] = STATE(1245),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1245),
    [sym_yield_expression] = STATE(1245),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1245),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1245),
    [sym_arrow_function] = STATE(1245),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1245),
    [sym_new_expression] = STATE(1245),
    [sym_await_expression] = STATE(1245),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1245),
    [sym_augmented_assignment_expression] = STATE(1245),
    [sym_ternary_expression] = STATE(1245),
    [sym_binary_expression] = STATE(1245),
    [sym_unary_expression] = STATE(1245),
    [sym_update_expression] = STATE(1245),
    [sym_string] = STATE(1245),
    [sym_template_string] = STATE(1245),
    [sym_regex] = STATE(1245),
    [sym_meta_property] = STATE(1245),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1245),
    [sym_type_assertion] = STATE(1245),
    [sym_as_expression] = STATE(1245),
    [sym_internal_module] = STATE(1245),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2074),
    [sym_this] = ACTIONS(2076),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2076),
    [sym_false] = ACTIONS(2076),
    [sym_null] = ACTIONS(2076),
    [sym_undefined] = ACTIONS(2076),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [322] = {
    [sym_import] = STATE(1377),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1377),
    [sym_yield_expression] = STATE(1377),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1377),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1377),
    [sym_arrow_function] = STATE(1377),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1377),
    [sym_new_expression] = STATE(1377),
    [sym_await_expression] = STATE(1377),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1377),
    [sym_augmented_assignment_expression] = STATE(1377),
    [sym_ternary_expression] = STATE(1377),
    [sym_binary_expression] = STATE(1377),
    [sym_unary_expression] = STATE(1377),
    [sym_update_expression] = STATE(1377),
    [sym_string] = STATE(1377),
    [sym_template_string] = STATE(1377),
    [sym_regex] = STATE(1377),
    [sym_meta_property] = STATE(1377),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1377),
    [sym_type_assertion] = STATE(1377),
    [sym_as_expression] = STATE(1377),
    [sym_internal_module] = STATE(1377),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2078),
    [sym_this] = ACTIONS(2080),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2080),
    [sym_false] = ACTIONS(2080),
    [sym_null] = ACTIONS(2080),
    [sym_undefined] = ACTIONS(2080),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [323] = {
    [sym_import] = STATE(1236),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1236),
    [sym_yield_expression] = STATE(1236),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1236),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1236),
    [sym_arrow_function] = STATE(1236),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1236),
    [sym_new_expression] = STATE(1236),
    [sym_await_expression] = STATE(1236),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1236),
    [sym_augmented_assignment_expression] = STATE(1236),
    [sym_ternary_expression] = STATE(1236),
    [sym_binary_expression] = STATE(1236),
    [sym_unary_expression] = STATE(1236),
    [sym_update_expression] = STATE(1236),
    [sym_string] = STATE(1236),
    [sym_template_string] = STATE(1236),
    [sym_regex] = STATE(1236),
    [sym_meta_property] = STATE(1236),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1236),
    [sym_type_assertion] = STATE(1236),
    [sym_as_expression] = STATE(1236),
    [sym_internal_module] = STATE(1236),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2082),
    [sym_this] = ACTIONS(2084),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2084),
    [sym_false] = ACTIONS(2084),
    [sym_null] = ACTIONS(2084),
    [sym_undefined] = ACTIONS(2084),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [324] = {
    [sym_import] = STATE(1002),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1002),
    [sym_arrow_function] = STATE(1002),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1002),
    [sym_type_assertion] = STATE(1002),
    [sym_as_expression] = STATE(1002),
    [sym_internal_module] = STATE(1002),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2062),
    [sym_this] = ACTIONS(2064),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2064),
    [sym_false] = ACTIONS(2064),
    [sym_null] = ACTIONS(2064),
    [sym_undefined] = ACTIONS(2064),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [325] = {
    [sym_import] = STATE(1277),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1277),
    [sym_yield_expression] = STATE(1277),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1277),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1277),
    [sym_arrow_function] = STATE(1277),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1277),
    [sym_new_expression] = STATE(1277),
    [sym_await_expression] = STATE(1277),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1277),
    [sym_augmented_assignment_expression] = STATE(1277),
    [sym_ternary_expression] = STATE(1277),
    [sym_binary_expression] = STATE(1277),
    [sym_unary_expression] = STATE(1277),
    [sym_update_expression] = STATE(1277),
    [sym_string] = STATE(1277),
    [sym_template_string] = STATE(1277),
    [sym_regex] = STATE(1277),
    [sym_meta_property] = STATE(1277),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1277),
    [sym_type_assertion] = STATE(1277),
    [sym_as_expression] = STATE(1277),
    [sym_internal_module] = STATE(1277),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2086),
    [sym_this] = ACTIONS(2088),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2088),
    [sym_false] = ACTIONS(2088),
    [sym_null] = ACTIONS(2088),
    [sym_undefined] = ACTIONS(2088),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [326] = {
    [sym_import] = STATE(1278),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1278),
    [sym_yield_expression] = STATE(1278),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1278),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1278),
    [sym_arrow_function] = STATE(1278),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1278),
    [sym_new_expression] = STATE(1278),
    [sym_await_expression] = STATE(1278),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1278),
    [sym_augmented_assignment_expression] = STATE(1278),
    [sym_ternary_expression] = STATE(1278),
    [sym_binary_expression] = STATE(1278),
    [sym_unary_expression] = STATE(1278),
    [sym_update_expression] = STATE(1278),
    [sym_string] = STATE(1278),
    [sym_template_string] = STATE(1278),
    [sym_regex] = STATE(1278),
    [sym_meta_property] = STATE(1278),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1278),
    [sym_type_assertion] = STATE(1278),
    [sym_as_expression] = STATE(1278),
    [sym_internal_module] = STATE(1278),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2090),
    [sym_this] = ACTIONS(2092),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2092),
    [sym_false] = ACTIONS(2092),
    [sym_null] = ACTIONS(2092),
    [sym_undefined] = ACTIONS(2092),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [327] = {
    [sym_import] = STATE(1279),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1279),
    [sym_yield_expression] = STATE(1279),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1279),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1279),
    [sym_arrow_function] = STATE(1279),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1279),
    [sym_new_expression] = STATE(1279),
    [sym_await_expression] = STATE(1279),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1279),
    [sym_augmented_assignment_expression] = STATE(1279),
    [sym_ternary_expression] = STATE(1279),
    [sym_binary_expression] = STATE(1279),
    [sym_unary_expression] = STATE(1279),
    [sym_update_expression] = STATE(1279),
    [sym_string] = STATE(1279),
    [sym_template_string] = STATE(1279),
    [sym_regex] = STATE(1279),
    [sym_meta_property] = STATE(1279),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1279),
    [sym_type_assertion] = STATE(1279),
    [sym_as_expression] = STATE(1279),
    [sym_internal_module] = STATE(1279),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2094),
    [sym_this] = ACTIONS(2096),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2096),
    [sym_false] = ACTIONS(2096),
    [sym_null] = ACTIONS(2096),
    [sym_undefined] = ACTIONS(2096),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [328] = {
    [sym_import] = STATE(1235),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1235),
    [sym_yield_expression] = STATE(1235),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1235),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1235),
    [sym_arrow_function] = STATE(1235),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1235),
    [sym_new_expression] = STATE(1235),
    [sym_await_expression] = STATE(1235),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1235),
    [sym_augmented_assignment_expression] = STATE(1235),
    [sym_ternary_expression] = STATE(1235),
    [sym_binary_expression] = STATE(1235),
    [sym_unary_expression] = STATE(1235),
    [sym_update_expression] = STATE(1235),
    [sym_string] = STATE(1235),
    [sym_template_string] = STATE(1235),
    [sym_regex] = STATE(1235),
    [sym_meta_property] = STATE(1235),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1235),
    [sym_type_assertion] = STATE(1235),
    [sym_as_expression] = STATE(1235),
    [sym_internal_module] = STATE(1235),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2098),
    [sym_this] = ACTIONS(2100),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2100),
    [sym_false] = ACTIONS(2100),
    [sym_null] = ACTIONS(2100),
    [sym_undefined] = ACTIONS(2100),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [329] = {
    [sym_import] = STATE(1234),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1234),
    [sym_yield_expression] = STATE(1234),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1234),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1234),
    [sym_arrow_function] = STATE(1234),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1234),
    [sym_new_expression] = STATE(1234),
    [sym_await_expression] = STATE(1234),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1234),
    [sym_augmented_assignment_expression] = STATE(1234),
    [sym_ternary_expression] = STATE(1234),
    [sym_binary_expression] = STATE(1234),
    [sym_unary_expression] = STATE(1234),
    [sym_update_expression] = STATE(1234),
    [sym_string] = STATE(1234),
    [sym_template_string] = STATE(1234),
    [sym_regex] = STATE(1234),
    [sym_meta_property] = STATE(1234),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1234),
    [sym_type_assertion] = STATE(1234),
    [sym_as_expression] = STATE(1234),
    [sym_internal_module] = STATE(1234),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2102),
    [sym_this] = ACTIONS(2072),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2072),
    [sym_false] = ACTIONS(2072),
    [sym_null] = ACTIONS(2072),
    [sym_undefined] = ACTIONS(2072),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [330] = {
    [sym_import] = STATE(945),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(945),
    [sym_yield_expression] = STATE(945),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(945),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(945),
    [sym_arrow_function] = STATE(945),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(945),
    [sym_new_expression] = STATE(945),
    [sym_await_expression] = STATE(945),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(945),
    [sym_augmented_assignment_expression] = STATE(945),
    [sym_ternary_expression] = STATE(945),
    [sym_binary_expression] = STATE(945),
    [sym_unary_expression] = STATE(945),
    [sym_update_expression] = STATE(945),
    [sym_string] = STATE(945),
    [sym_template_string] = STATE(945),
    [sym_regex] = STATE(945),
    [sym_meta_property] = STATE(945),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(945),
    [sym_type_assertion] = STATE(945),
    [sym_as_expression] = STATE(945),
    [sym_internal_module] = STATE(945),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2104),
    [sym_this] = ACTIONS(2106),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2106),
    [sym_false] = ACTIONS(2106),
    [sym_null] = ACTIONS(2106),
    [sym_undefined] = ACTIONS(2106),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [331] = {
    [sym_import] = STATE(1252),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1252),
    [sym_yield_expression] = STATE(1252),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1252),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1252),
    [sym_arrow_function] = STATE(1252),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1252),
    [sym_new_expression] = STATE(1252),
    [sym_await_expression] = STATE(1252),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1252),
    [sym_augmented_assignment_expression] = STATE(1252),
    [sym_ternary_expression] = STATE(1252),
    [sym_binary_expression] = STATE(1252),
    [sym_unary_expression] = STATE(1252),
    [sym_update_expression] = STATE(1252),
    [sym_string] = STATE(1252),
    [sym_template_string] = STATE(1252),
    [sym_regex] = STATE(1252),
    [sym_meta_property] = STATE(1252),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1252),
    [sym_type_assertion] = STATE(1252),
    [sym_as_expression] = STATE(1252),
    [sym_internal_module] = STATE(1252),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2108),
    [sym_this] = ACTIONS(2110),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2110),
    [sym_false] = ACTIONS(2110),
    [sym_null] = ACTIONS(2110),
    [sym_undefined] = ACTIONS(2110),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [332] = {
    [sym_import] = STATE(1153),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1153),
    [sym_yield_expression] = STATE(1153),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1153),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1153),
    [sym_arrow_function] = STATE(1153),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1153),
    [sym_new_expression] = STATE(1153),
    [sym_await_expression] = STATE(1153),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1153),
    [sym_augmented_assignment_expression] = STATE(1153),
    [sym_ternary_expression] = STATE(1153),
    [sym_binary_expression] = STATE(1153),
    [sym_unary_expression] = STATE(1153),
    [sym_update_expression] = STATE(1153),
    [sym_string] = STATE(1153),
    [sym_template_string] = STATE(1153),
    [sym_regex] = STATE(1153),
    [sym_meta_property] = STATE(1153),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1153),
    [sym_type_assertion] = STATE(1153),
    [sym_as_expression] = STATE(1153),
    [sym_internal_module] = STATE(1153),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2112),
    [sym_this] = ACTIONS(2114),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2114),
    [sym_false] = ACTIONS(2114),
    [sym_null] = ACTIONS(2114),
    [sym_undefined] = ACTIONS(2114),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [333] = {
    [sym_import] = STATE(1352),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1352),
    [sym_yield_expression] = STATE(1352),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1352),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1352),
    [sym_arrow_function] = STATE(1352),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1352),
    [sym_new_expression] = STATE(1352),
    [sym_await_expression] = STATE(1352),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1352),
    [sym_augmented_assignment_expression] = STATE(1352),
    [sym_ternary_expression] = STATE(1352),
    [sym_binary_expression] = STATE(1352),
    [sym_unary_expression] = STATE(1352),
    [sym_update_expression] = STATE(1352),
    [sym_string] = STATE(1352),
    [sym_template_string] = STATE(1352),
    [sym_regex] = STATE(1352),
    [sym_meta_property] = STATE(1352),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1352),
    [sym_type_assertion] = STATE(1352),
    [sym_as_expression] = STATE(1352),
    [sym_internal_module] = STATE(1352),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2116),
    [sym_this] = ACTIONS(2118),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2118),
    [sym_false] = ACTIONS(2118),
    [sym_null] = ACTIONS(2118),
    [sym_undefined] = ACTIONS(2118),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [334] = {
    [sym_import] = STATE(1250),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1250),
    [sym_yield_expression] = STATE(1250),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1250),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1250),
    [sym_arrow_function] = STATE(1250),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1250),
    [sym_new_expression] = STATE(1250),
    [sym_await_expression] = STATE(1250),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1250),
    [sym_augmented_assignment_expression] = STATE(1250),
    [sym_ternary_expression] = STATE(1250),
    [sym_binary_expression] = STATE(1250),
    [sym_unary_expression] = STATE(1250),
    [sym_update_expression] = STATE(1250),
    [sym_string] = STATE(1250),
    [sym_template_string] = STATE(1250),
    [sym_regex] = STATE(1250),
    [sym_meta_property] = STATE(1250),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1250),
    [sym_type_assertion] = STATE(1250),
    [sym_as_expression] = STATE(1250),
    [sym_internal_module] = STATE(1250),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2120),
    [sym_this] = ACTIONS(2122),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2122),
    [sym_false] = ACTIONS(2122),
    [sym_null] = ACTIONS(2122),
    [sym_undefined] = ACTIONS(2122),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [335] = {
    [sym_import] = STATE(1161),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1161),
    [sym_yield_expression] = STATE(1161),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1161),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1161),
    [sym_arrow_function] = STATE(1161),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1161),
    [sym_new_expression] = STATE(1161),
    [sym_await_expression] = STATE(1161),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1161),
    [sym_augmented_assignment_expression] = STATE(1161),
    [sym_ternary_expression] = STATE(1161),
    [sym_binary_expression] = STATE(1161),
    [sym_unary_expression] = STATE(1161),
    [sym_update_expression] = STATE(1161),
    [sym_string] = STATE(1161),
    [sym_template_string] = STATE(1161),
    [sym_regex] = STATE(1161),
    [sym_meta_property] = STATE(1161),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1161),
    [sym_type_assertion] = STATE(1161),
    [sym_as_expression] = STATE(1161),
    [sym_internal_module] = STATE(1161),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2124),
    [sym_this] = ACTIONS(2006),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2006),
    [sym_false] = ACTIONS(2006),
    [sym_null] = ACTIONS(2006),
    [sym_undefined] = ACTIONS(2006),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [336] = {
    [sym_import] = STATE(977),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(977),
    [sym_yield_expression] = STATE(977),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(977),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(977),
    [sym_arrow_function] = STATE(977),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(977),
    [sym_new_expression] = STATE(977),
    [sym_await_expression] = STATE(977),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(977),
    [sym_augmented_assignment_expression] = STATE(977),
    [sym_ternary_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_update_expression] = STATE(977),
    [sym_string] = STATE(977),
    [sym_template_string] = STATE(977),
    [sym_regex] = STATE(977),
    [sym_meta_property] = STATE(977),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(977),
    [sym_as_expression] = STATE(977),
    [sym_internal_module] = STATE(977),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2126),
    [sym_this] = ACTIONS(1804),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [sym_null] = ACTIONS(1804),
    [sym_undefined] = ACTIONS(1804),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [337] = {
    [sym_import] = STATE(1220),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1220),
    [sym_arrow_function] = STATE(1220),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1220),
    [sym_type_assertion] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2128),
    [sym_this] = ACTIONS(2130),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2130),
    [sym_false] = ACTIONS(2130),
    [sym_null] = ACTIONS(2130),
    [sym_undefined] = ACTIONS(2130),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [338] = {
    [sym_import] = STATE(975),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(975),
    [sym_yield_expression] = STATE(975),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(975),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(975),
    [sym_arrow_function] = STATE(975),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(975),
    [sym_new_expression] = STATE(975),
    [sym_await_expression] = STATE(975),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(975),
    [sym_augmented_assignment_expression] = STATE(975),
    [sym_ternary_expression] = STATE(975),
    [sym_binary_expression] = STATE(975),
    [sym_unary_expression] = STATE(975),
    [sym_update_expression] = STATE(975),
    [sym_string] = STATE(975),
    [sym_template_string] = STATE(975),
    [sym_regex] = STATE(975),
    [sym_meta_property] = STATE(975),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(975),
    [sym_type_assertion] = STATE(975),
    [sym_as_expression] = STATE(975),
    [sym_internal_module] = STATE(975),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2132),
    [sym_this] = ACTIONS(2134),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [sym_null] = ACTIONS(2134),
    [sym_undefined] = ACTIONS(2134),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [339] = {
    [sym_import] = STATE(1076),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1076),
    [sym_yield_expression] = STATE(1076),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1076),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1076),
    [sym_arrow_function] = STATE(1076),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1076),
    [sym_new_expression] = STATE(1076),
    [sym_await_expression] = STATE(1076),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1076),
    [sym_augmented_assignment_expression] = STATE(1076),
    [sym_ternary_expression] = STATE(1076),
    [sym_binary_expression] = STATE(1076),
    [sym_unary_expression] = STATE(1076),
    [sym_update_expression] = STATE(1076),
    [sym_string] = STATE(1076),
    [sym_template_string] = STATE(1076),
    [sym_regex] = STATE(1076),
    [sym_meta_property] = STATE(1076),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1076),
    [sym_type_assertion] = STATE(1076),
    [sym_as_expression] = STATE(1076),
    [sym_internal_module] = STATE(1076),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2136),
    [sym_this] = ACTIONS(2138),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2138),
    [sym_false] = ACTIONS(2138),
    [sym_null] = ACTIONS(2138),
    [sym_undefined] = ACTIONS(2138),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [340] = {
    [sym_import] = STATE(1279),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1279),
    [sym_yield_expression] = STATE(1279),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1279),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1279),
    [sym_arrow_function] = STATE(1279),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1279),
    [sym_new_expression] = STATE(1279),
    [sym_await_expression] = STATE(1279),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1279),
    [sym_augmented_assignment_expression] = STATE(1279),
    [sym_ternary_expression] = STATE(1279),
    [sym_binary_expression] = STATE(1279),
    [sym_unary_expression] = STATE(1279),
    [sym_update_expression] = STATE(1279),
    [sym_string] = STATE(1279),
    [sym_template_string] = STATE(1279),
    [sym_regex] = STATE(1279),
    [sym_meta_property] = STATE(1279),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1279),
    [sym_type_assertion] = STATE(1279),
    [sym_as_expression] = STATE(1279),
    [sym_internal_module] = STATE(1279),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(2140),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2094),
    [sym_this] = ACTIONS(2096),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2096),
    [sym_false] = ACTIONS(2096),
    [sym_null] = ACTIONS(2096),
    [sym_undefined] = ACTIONS(2096),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [341] = {
    [sym_import] = STATE(998),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(998),
    [sym_yield_expression] = STATE(998),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(998),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(998),
    [sym_arrow_function] = STATE(998),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(998),
    [sym_new_expression] = STATE(998),
    [sym_await_expression] = STATE(998),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(998),
    [sym_augmented_assignment_expression] = STATE(998),
    [sym_ternary_expression] = STATE(998),
    [sym_binary_expression] = STATE(998),
    [sym_unary_expression] = STATE(998),
    [sym_update_expression] = STATE(998),
    [sym_string] = STATE(998),
    [sym_template_string] = STATE(998),
    [sym_regex] = STATE(998),
    [sym_meta_property] = STATE(998),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(998),
    [sym_type_assertion] = STATE(998),
    [sym_as_expression] = STATE(998),
    [sym_internal_module] = STATE(998),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2142),
    [sym_this] = ACTIONS(2144),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2144),
    [sym_false] = ACTIONS(2144),
    [sym_null] = ACTIONS(2144),
    [sym_undefined] = ACTIONS(2144),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [342] = {
    [sym_import] = STATE(948),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(948),
    [sym_yield_expression] = STATE(948),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(948),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(948),
    [sym_arrow_function] = STATE(948),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(948),
    [sym_new_expression] = STATE(948),
    [sym_await_expression] = STATE(948),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(948),
    [sym_augmented_assignment_expression] = STATE(948),
    [sym_ternary_expression] = STATE(948),
    [sym_binary_expression] = STATE(948),
    [sym_unary_expression] = STATE(948),
    [sym_update_expression] = STATE(948),
    [sym_string] = STATE(948),
    [sym_template_string] = STATE(948),
    [sym_regex] = STATE(948),
    [sym_meta_property] = STATE(948),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(948),
    [sym_type_assertion] = STATE(948),
    [sym_as_expression] = STATE(948),
    [sym_internal_module] = STATE(948),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2146),
    [sym_this] = ACTIONS(2148),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2148),
    [sym_false] = ACTIONS(2148),
    [sym_null] = ACTIONS(2148),
    [sym_undefined] = ACTIONS(2148),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [343] = {
    [sym_import] = STATE(1499),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1499),
    [sym_yield_expression] = STATE(1499),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1499),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1499),
    [sym_arrow_function] = STATE(1499),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1499),
    [sym_new_expression] = STATE(1499),
    [sym_await_expression] = STATE(1499),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1499),
    [sym_augmented_assignment_expression] = STATE(1499),
    [sym_ternary_expression] = STATE(1499),
    [sym_binary_expression] = STATE(1499),
    [sym_unary_expression] = STATE(1499),
    [sym_update_expression] = STATE(1499),
    [sym_string] = STATE(1499),
    [sym_template_string] = STATE(1499),
    [sym_regex] = STATE(1499),
    [sym_meta_property] = STATE(1499),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1499),
    [sym_type_assertion] = STATE(1499),
    [sym_as_expression] = STATE(1499),
    [sym_internal_module] = STATE(1499),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2150),
    [sym_this] = ACTIONS(2152),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_null] = ACTIONS(2152),
    [sym_undefined] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [344] = {
    [sym_import] = STATE(1256),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1256),
    [sym_yield_expression] = STATE(1256),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1256),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1256),
    [sym_arrow_function] = STATE(1256),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1256),
    [sym_new_expression] = STATE(1256),
    [sym_await_expression] = STATE(1256),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1256),
    [sym_augmented_assignment_expression] = STATE(1256),
    [sym_ternary_expression] = STATE(1256),
    [sym_binary_expression] = STATE(1256),
    [sym_unary_expression] = STATE(1256),
    [sym_update_expression] = STATE(1256),
    [sym_string] = STATE(1256),
    [sym_template_string] = STATE(1256),
    [sym_regex] = STATE(1256),
    [sym_meta_property] = STATE(1256),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1256),
    [sym_type_assertion] = STATE(1256),
    [sym_as_expression] = STATE(1256),
    [sym_internal_module] = STATE(1256),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2154),
    [sym_this] = ACTIONS(2156),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2156),
    [sym_false] = ACTIONS(2156),
    [sym_null] = ACTIONS(2156),
    [sym_undefined] = ACTIONS(2156),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [345] = {
    [sym_import] = STATE(950),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(950),
    [sym_yield_expression] = STATE(950),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(950),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(950),
    [sym_arrow_function] = STATE(950),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(950),
    [sym_new_expression] = STATE(950),
    [sym_await_expression] = STATE(950),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(950),
    [sym_augmented_assignment_expression] = STATE(950),
    [sym_ternary_expression] = STATE(950),
    [sym_binary_expression] = STATE(950),
    [sym_unary_expression] = STATE(950),
    [sym_update_expression] = STATE(950),
    [sym_string] = STATE(950),
    [sym_template_string] = STATE(950),
    [sym_regex] = STATE(950),
    [sym_meta_property] = STATE(950),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(950),
    [sym_type_assertion] = STATE(950),
    [sym_as_expression] = STATE(950),
    [sym_internal_module] = STATE(950),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2158),
    [sym_this] = ACTIONS(2160),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_null] = ACTIONS(2160),
    [sym_undefined] = ACTIONS(2160),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [346] = {
    [sym_import] = STATE(951),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(951),
    [sym_yield_expression] = STATE(951),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(951),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(951),
    [sym_arrow_function] = STATE(951),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(951),
    [sym_new_expression] = STATE(951),
    [sym_await_expression] = STATE(951),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(951),
    [sym_augmented_assignment_expression] = STATE(951),
    [sym_ternary_expression] = STATE(951),
    [sym_binary_expression] = STATE(951),
    [sym_unary_expression] = STATE(951),
    [sym_update_expression] = STATE(951),
    [sym_string] = STATE(951),
    [sym_template_string] = STATE(951),
    [sym_regex] = STATE(951),
    [sym_meta_property] = STATE(951),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(951),
    [sym_type_assertion] = STATE(951),
    [sym_as_expression] = STATE(951),
    [sym_internal_module] = STATE(951),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2162),
    [sym_this] = ACTIONS(2164),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2164),
    [sym_false] = ACTIONS(2164),
    [sym_null] = ACTIONS(2164),
    [sym_undefined] = ACTIONS(2164),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [347] = {
    [sym_import] = STATE(1099),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1099),
    [sym_yield_expression] = STATE(1099),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1099),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1099),
    [sym_arrow_function] = STATE(1099),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1099),
    [sym_new_expression] = STATE(1099),
    [sym_await_expression] = STATE(1099),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1099),
    [sym_augmented_assignment_expression] = STATE(1099),
    [sym_ternary_expression] = STATE(1099),
    [sym_binary_expression] = STATE(1099),
    [sym_unary_expression] = STATE(1099),
    [sym_update_expression] = STATE(1099),
    [sym_string] = STATE(1099),
    [sym_template_string] = STATE(1099),
    [sym_regex] = STATE(1099),
    [sym_meta_property] = STATE(1099),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1099),
    [sym_as_expression] = STATE(1099),
    [sym_internal_module] = STATE(1099),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2166),
    [sym_this] = ACTIONS(2168),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [sym_null] = ACTIONS(2168),
    [sym_undefined] = ACTIONS(2168),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [348] = {
    [sym_import] = STATE(1063),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1063),
    [sym_yield_expression] = STATE(1063),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1063),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1063),
    [sym_arrow_function] = STATE(1063),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1063),
    [sym_new_expression] = STATE(1063),
    [sym_await_expression] = STATE(1063),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1063),
    [sym_augmented_assignment_expression] = STATE(1063),
    [sym_ternary_expression] = STATE(1063),
    [sym_binary_expression] = STATE(1063),
    [sym_unary_expression] = STATE(1063),
    [sym_update_expression] = STATE(1063),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_regex] = STATE(1063),
    [sym_meta_property] = STATE(1063),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1063),
    [sym_type_assertion] = STATE(1063),
    [sym_as_expression] = STATE(1063),
    [sym_internal_module] = STATE(1063),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2170),
    [sym_this] = ACTIONS(2172),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2172),
    [sym_false] = ACTIONS(2172),
    [sym_null] = ACTIONS(2172),
    [sym_undefined] = ACTIONS(2172),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [349] = {
    [sym_import] = STATE(1297),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1297),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1297),
    [sym_arrow_function] = STATE(1297),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1297),
    [sym_new_expression] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_string] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1297),
    [sym_type_assertion] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2174),
    [sym_this] = ACTIONS(965),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(965),
    [sym_false] = ACTIONS(965),
    [sym_null] = ACTIONS(965),
    [sym_undefined] = ACTIONS(965),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [350] = {
    [sym_import] = STATE(1062),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1062),
    [sym_yield_expression] = STATE(1062),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1062),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1062),
    [sym_arrow_function] = STATE(1062),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1062),
    [sym_new_expression] = STATE(1062),
    [sym_await_expression] = STATE(1062),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1062),
    [sym_augmented_assignment_expression] = STATE(1062),
    [sym_ternary_expression] = STATE(1062),
    [sym_binary_expression] = STATE(1062),
    [sym_unary_expression] = STATE(1062),
    [sym_update_expression] = STATE(1062),
    [sym_string] = STATE(1062),
    [sym_template_string] = STATE(1062),
    [sym_regex] = STATE(1062),
    [sym_meta_property] = STATE(1062),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1062),
    [sym_type_assertion] = STATE(1062),
    [sym_as_expression] = STATE(1062),
    [sym_internal_module] = STATE(1062),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2066),
    [sym_this] = ACTIONS(2068),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2068),
    [sym_false] = ACTIONS(2068),
    [sym_null] = ACTIONS(2068),
    [sym_undefined] = ACTIONS(2068),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [351] = {
    [sym_import] = STATE(953),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(953),
    [sym_yield_expression] = STATE(953),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(953),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(953),
    [sym_arrow_function] = STATE(953),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(953),
    [sym_new_expression] = STATE(953),
    [sym_await_expression] = STATE(953),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(953),
    [sym_augmented_assignment_expression] = STATE(953),
    [sym_ternary_expression] = STATE(953),
    [sym_binary_expression] = STATE(953),
    [sym_unary_expression] = STATE(953),
    [sym_update_expression] = STATE(953),
    [sym_string] = STATE(953),
    [sym_template_string] = STATE(953),
    [sym_regex] = STATE(953),
    [sym_meta_property] = STATE(953),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(953),
    [sym_type_assertion] = STATE(953),
    [sym_as_expression] = STATE(953),
    [sym_internal_module] = STATE(953),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2176),
    [sym_this] = ACTIONS(911),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(911),
    [sym_false] = ACTIONS(911),
    [sym_null] = ACTIONS(911),
    [sym_undefined] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [352] = {
    [sym_import] = STATE(1255),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1255),
    [sym_yield_expression] = STATE(1255),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1255),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1255),
    [sym_arrow_function] = STATE(1255),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1255),
    [sym_new_expression] = STATE(1255),
    [sym_await_expression] = STATE(1255),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1255),
    [sym_augmented_assignment_expression] = STATE(1255),
    [sym_ternary_expression] = STATE(1255),
    [sym_binary_expression] = STATE(1255),
    [sym_unary_expression] = STATE(1255),
    [sym_update_expression] = STATE(1255),
    [sym_string] = STATE(1255),
    [sym_template_string] = STATE(1255),
    [sym_regex] = STATE(1255),
    [sym_meta_property] = STATE(1255),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1255),
    [sym_type_assertion] = STATE(1255),
    [sym_as_expression] = STATE(1255),
    [sym_internal_module] = STATE(1255),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2178),
    [sym_this] = ACTIONS(2180),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2180),
    [sym_false] = ACTIONS(2180),
    [sym_null] = ACTIONS(2180),
    [sym_undefined] = ACTIONS(2180),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [353] = {
    [sym_import] = STATE(1251),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1251),
    [sym_yield_expression] = STATE(1251),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1251),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1251),
    [sym_arrow_function] = STATE(1251),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1251),
    [sym_new_expression] = STATE(1251),
    [sym_await_expression] = STATE(1251),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1251),
    [sym_augmented_assignment_expression] = STATE(1251),
    [sym_ternary_expression] = STATE(1251),
    [sym_binary_expression] = STATE(1251),
    [sym_unary_expression] = STATE(1251),
    [sym_update_expression] = STATE(1251),
    [sym_string] = STATE(1251),
    [sym_template_string] = STATE(1251),
    [sym_regex] = STATE(1251),
    [sym_meta_property] = STATE(1251),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1251),
    [sym_type_assertion] = STATE(1251),
    [sym_as_expression] = STATE(1251),
    [sym_internal_module] = STATE(1251),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2182),
    [sym_this] = ACTIONS(2184),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2184),
    [sym_false] = ACTIONS(2184),
    [sym_null] = ACTIONS(2184),
    [sym_undefined] = ACTIONS(2184),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [354] = {
    [sym_import] = STATE(1312),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1312),
    [sym_yield_expression] = STATE(1312),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1312),
    [sym_arrow_function] = STATE(1312),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1312),
    [sym_await_expression] = STATE(1312),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1312),
    [sym_augmented_assignment_expression] = STATE(1312),
    [sym_ternary_expression] = STATE(1312),
    [sym_binary_expression] = STATE(1312),
    [sym_unary_expression] = STATE(1312),
    [sym_update_expression] = STATE(1312),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1312),
    [sym_type_assertion] = STATE(1312),
    [sym_as_expression] = STATE(1312),
    [sym_internal_module] = STATE(1312),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2186),
    [sym_this] = ACTIONS(2188),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2188),
    [sym_false] = ACTIONS(2188),
    [sym_null] = ACTIONS(2188),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [355] = {
    [sym_import] = STATE(954),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(954),
    [sym_yield_expression] = STATE(954),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(954),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(954),
    [sym_arrow_function] = STATE(954),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(954),
    [sym_new_expression] = STATE(954),
    [sym_await_expression] = STATE(954),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(954),
    [sym_augmented_assignment_expression] = STATE(954),
    [sym_ternary_expression] = STATE(954),
    [sym_binary_expression] = STATE(954),
    [sym_unary_expression] = STATE(954),
    [sym_update_expression] = STATE(954),
    [sym_string] = STATE(954),
    [sym_template_string] = STATE(954),
    [sym_regex] = STATE(954),
    [sym_meta_property] = STATE(954),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(954),
    [sym_type_assertion] = STATE(954),
    [sym_as_expression] = STATE(954),
    [sym_internal_module] = STATE(954),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2190),
    [sym_this] = ACTIONS(2192),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2192),
    [sym_false] = ACTIONS(2192),
    [sym_null] = ACTIONS(2192),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [356] = {
    [sym_import] = STATE(955),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(955),
    [sym_yield_expression] = STATE(955),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(955),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(955),
    [sym_arrow_function] = STATE(955),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(955),
    [sym_new_expression] = STATE(955),
    [sym_await_expression] = STATE(955),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(955),
    [sym_augmented_assignment_expression] = STATE(955),
    [sym_ternary_expression] = STATE(955),
    [sym_binary_expression] = STATE(955),
    [sym_unary_expression] = STATE(955),
    [sym_update_expression] = STATE(955),
    [sym_string] = STATE(955),
    [sym_template_string] = STATE(955),
    [sym_regex] = STATE(955),
    [sym_meta_property] = STATE(955),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(955),
    [sym_type_assertion] = STATE(955),
    [sym_as_expression] = STATE(955),
    [sym_internal_module] = STATE(955),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2194),
    [sym_this] = ACTIONS(2196),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2196),
    [sym_false] = ACTIONS(2196),
    [sym_null] = ACTIONS(2196),
    [sym_undefined] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [357] = {
    [sym_import] = STATE(1459),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1459),
    [sym_yield_expression] = STATE(1459),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1459),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1459),
    [sym_arrow_function] = STATE(1459),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1459),
    [sym_new_expression] = STATE(1459),
    [sym_await_expression] = STATE(1459),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1459),
    [sym_augmented_assignment_expression] = STATE(1459),
    [sym_ternary_expression] = STATE(1459),
    [sym_binary_expression] = STATE(1459),
    [sym_unary_expression] = STATE(1459),
    [sym_update_expression] = STATE(1459),
    [sym_string] = STATE(1459),
    [sym_template_string] = STATE(1459),
    [sym_regex] = STATE(1459),
    [sym_meta_property] = STATE(1459),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1459),
    [sym_type_assertion] = STATE(1459),
    [sym_as_expression] = STATE(1459),
    [sym_internal_module] = STATE(1459),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1762),
    [sym_this] = ACTIONS(1764),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1764),
    [sym_false] = ACTIONS(1764),
    [sym_null] = ACTIONS(1764),
    [sym_undefined] = ACTIONS(1764),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [358] = {
    [sym_import] = STATE(977),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(977),
    [sym_yield_expression] = STATE(977),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(977),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(977),
    [sym_arrow_function] = STATE(977),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(977),
    [sym_new_expression] = STATE(977),
    [sym_await_expression] = STATE(977),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(977),
    [sym_augmented_assignment_expression] = STATE(977),
    [sym_ternary_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_update_expression] = STATE(977),
    [sym_string] = STATE(977),
    [sym_template_string] = STATE(977),
    [sym_regex] = STATE(977),
    [sym_meta_property] = STATE(977),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(977),
    [sym_as_expression] = STATE(977),
    [sym_internal_module] = STATE(977),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2124),
    [sym_this] = ACTIONS(1804),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [sym_null] = ACTIONS(1804),
    [sym_undefined] = ACTIONS(1804),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [359] = {
    [sym_import] = STATE(957),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(957),
    [sym_yield_expression] = STATE(957),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(957),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(957),
    [sym_arrow_function] = STATE(957),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(957),
    [sym_new_expression] = STATE(957),
    [sym_await_expression] = STATE(957),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(957),
    [sym_augmented_assignment_expression] = STATE(957),
    [sym_ternary_expression] = STATE(957),
    [sym_binary_expression] = STATE(957),
    [sym_unary_expression] = STATE(957),
    [sym_update_expression] = STATE(957),
    [sym_string] = STATE(957),
    [sym_template_string] = STATE(957),
    [sym_regex] = STATE(957),
    [sym_meta_property] = STATE(957),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(957),
    [sym_type_assertion] = STATE(957),
    [sym_as_expression] = STATE(957),
    [sym_internal_module] = STATE(957),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2198),
    [sym_this] = ACTIONS(2200),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2200),
    [sym_false] = ACTIONS(2200),
    [sym_null] = ACTIONS(2200),
    [sym_undefined] = ACTIONS(2200),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [360] = {
    [sym_import] = STATE(1355),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1355),
    [sym_yield_expression] = STATE(1355),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1355),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1355),
    [sym_arrow_function] = STATE(1355),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1355),
    [sym_new_expression] = STATE(1355),
    [sym_await_expression] = STATE(1355),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1355),
    [sym_augmented_assignment_expression] = STATE(1355),
    [sym_ternary_expression] = STATE(1355),
    [sym_binary_expression] = STATE(1355),
    [sym_unary_expression] = STATE(1355),
    [sym_update_expression] = STATE(1355),
    [sym_string] = STATE(1355),
    [sym_template_string] = STATE(1355),
    [sym_regex] = STATE(1355),
    [sym_meta_property] = STATE(1355),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1355),
    [sym_type_assertion] = STATE(1355),
    [sym_as_expression] = STATE(1355),
    [sym_internal_module] = STATE(1355),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2202),
    [sym_this] = ACTIONS(2204),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [361] = {
    [sym_import] = STATE(977),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(977),
    [sym_yield_expression] = STATE(977),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(977),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(977),
    [sym_arrow_function] = STATE(977),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(977),
    [sym_new_expression] = STATE(977),
    [sym_await_expression] = STATE(977),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(977),
    [sym_augmented_assignment_expression] = STATE(977),
    [sym_ternary_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_update_expression] = STATE(977),
    [sym_string] = STATE(977),
    [sym_template_string] = STATE(977),
    [sym_regex] = STATE(977),
    [sym_meta_property] = STATE(977),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(977),
    [sym_as_expression] = STATE(977),
    [sym_internal_module] = STATE(977),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2206),
    [sym_this] = ACTIONS(1804),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [sym_null] = ACTIONS(1804),
    [sym_undefined] = ACTIONS(1804),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [362] = {
    [sym_import] = STATE(1213),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1213),
    [sym_yield_expression] = STATE(1213),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1213),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1213),
    [sym_arrow_function] = STATE(1213),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1213),
    [sym_new_expression] = STATE(1213),
    [sym_await_expression] = STATE(1213),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1213),
    [sym_augmented_assignment_expression] = STATE(1213),
    [sym_ternary_expression] = STATE(1213),
    [sym_binary_expression] = STATE(1213),
    [sym_unary_expression] = STATE(1213),
    [sym_update_expression] = STATE(1213),
    [sym_string] = STATE(1213),
    [sym_template_string] = STATE(1213),
    [sym_regex] = STATE(1213),
    [sym_meta_property] = STATE(1213),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1213),
    [sym_type_assertion] = STATE(1213),
    [sym_as_expression] = STATE(1213),
    [sym_internal_module] = STATE(1213),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2208),
    [sym_this] = ACTIONS(2210),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2210),
    [sym_false] = ACTIONS(2210),
    [sym_null] = ACTIONS(2210),
    [sym_undefined] = ACTIONS(2210),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [363] = {
    [sym_import] = STATE(960),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(960),
    [sym_yield_expression] = STATE(960),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(960),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(960),
    [sym_arrow_function] = STATE(960),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(960),
    [sym_new_expression] = STATE(960),
    [sym_await_expression] = STATE(960),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(960),
    [sym_augmented_assignment_expression] = STATE(960),
    [sym_ternary_expression] = STATE(960),
    [sym_binary_expression] = STATE(960),
    [sym_unary_expression] = STATE(960),
    [sym_update_expression] = STATE(960),
    [sym_string] = STATE(960),
    [sym_template_string] = STATE(960),
    [sym_regex] = STATE(960),
    [sym_meta_property] = STATE(960),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(960),
    [sym_type_assertion] = STATE(960),
    [sym_as_expression] = STATE(960),
    [sym_internal_module] = STATE(960),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2212),
    [sym_this] = ACTIONS(2214),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2214),
    [sym_false] = ACTIONS(2214),
    [sym_null] = ACTIONS(2214),
    [sym_undefined] = ACTIONS(2214),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [364] = {
    [sym_import] = STATE(1099),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1099),
    [sym_yield_expression] = STATE(1099),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1099),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1099),
    [sym_arrow_function] = STATE(1099),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1099),
    [sym_new_expression] = STATE(1099),
    [sym_await_expression] = STATE(1099),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1099),
    [sym_augmented_assignment_expression] = STATE(1099),
    [sym_ternary_expression] = STATE(1099),
    [sym_binary_expression] = STATE(1099),
    [sym_unary_expression] = STATE(1099),
    [sym_update_expression] = STATE(1099),
    [sym_string] = STATE(1099),
    [sym_template_string] = STATE(1099),
    [sym_regex] = STATE(1099),
    [sym_meta_property] = STATE(1099),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1099),
    [sym_type_assertion] = STATE(1099),
    [sym_as_expression] = STATE(1099),
    [sym_internal_module] = STATE(1099),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(2216),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2166),
    [sym_this] = ACTIONS(2168),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2168),
    [sym_false] = ACTIONS(2168),
    [sym_null] = ACTIONS(2168),
    [sym_undefined] = ACTIONS(2168),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [365] = {
    [sym_import] = STATE(1357),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1357),
    [sym_yield_expression] = STATE(1357),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1357),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1357),
    [sym_arrow_function] = STATE(1357),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1357),
    [sym_new_expression] = STATE(1357),
    [sym_await_expression] = STATE(1357),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1357),
    [sym_augmented_assignment_expression] = STATE(1357),
    [sym_ternary_expression] = STATE(1357),
    [sym_binary_expression] = STATE(1357),
    [sym_unary_expression] = STATE(1357),
    [sym_update_expression] = STATE(1357),
    [sym_string] = STATE(1357),
    [sym_template_string] = STATE(1357),
    [sym_regex] = STATE(1357),
    [sym_meta_property] = STATE(1357),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1357),
    [sym_type_assertion] = STATE(1357),
    [sym_as_expression] = STATE(1357),
    [sym_internal_module] = STATE(1357),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2218),
    [sym_this] = ACTIONS(2220),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2220),
    [sym_false] = ACTIONS(2220),
    [sym_null] = ACTIONS(2220),
    [sym_undefined] = ACTIONS(2220),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [366] = {
    [sym_import] = STATE(1326),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1326),
    [sym_arrow_function] = STATE(1326),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1326),
    [sym_type_assertion] = STATE(1326),
    [sym_as_expression] = STATE(1326),
    [sym_internal_module] = STATE(1326),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2222),
    [sym_this] = ACTIONS(2224),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2224),
    [sym_false] = ACTIONS(2224),
    [sym_null] = ACTIONS(2224),
    [sym_undefined] = ACTIONS(2224),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [367] = {
    [sym_import] = STATE(1309),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1309),
    [sym_yield_expression] = STATE(1309),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1309),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1309),
    [sym_arrow_function] = STATE(1309),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1309),
    [sym_new_expression] = STATE(1309),
    [sym_await_expression] = STATE(1309),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1309),
    [sym_augmented_assignment_expression] = STATE(1309),
    [sym_ternary_expression] = STATE(1309),
    [sym_binary_expression] = STATE(1309),
    [sym_unary_expression] = STATE(1309),
    [sym_update_expression] = STATE(1309),
    [sym_string] = STATE(1309),
    [sym_template_string] = STATE(1309),
    [sym_regex] = STATE(1309),
    [sym_meta_property] = STATE(1309),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1309),
    [sym_type_assertion] = STATE(1309),
    [sym_as_expression] = STATE(1309),
    [sym_internal_module] = STATE(1309),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2226),
    [sym_this] = ACTIONS(2228),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2228),
    [sym_false] = ACTIONS(2228),
    [sym_null] = ACTIONS(2228),
    [sym_undefined] = ACTIONS(2228),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [368] = {
    [sym_import] = STATE(988),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(988),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(988),
    [sym_arrow_function] = STATE(988),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(988),
    [sym_type_assertion] = STATE(988),
    [sym_as_expression] = STATE(988),
    [sym_internal_module] = STATE(988),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2230),
    [sym_this] = ACTIONS(2232),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2232),
    [sym_false] = ACTIONS(2232),
    [sym_null] = ACTIONS(2232),
    [sym_undefined] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [369] = {
    [sym_import] = STATE(1358),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1358),
    [sym_yield_expression] = STATE(1358),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1358),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1358),
    [sym_arrow_function] = STATE(1358),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1358),
    [sym_new_expression] = STATE(1358),
    [sym_await_expression] = STATE(1358),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1358),
    [sym_augmented_assignment_expression] = STATE(1358),
    [sym_ternary_expression] = STATE(1358),
    [sym_binary_expression] = STATE(1358),
    [sym_unary_expression] = STATE(1358),
    [sym_update_expression] = STATE(1358),
    [sym_string] = STATE(1358),
    [sym_template_string] = STATE(1358),
    [sym_regex] = STATE(1358),
    [sym_meta_property] = STATE(1358),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1358),
    [sym_type_assertion] = STATE(1358),
    [sym_as_expression] = STATE(1358),
    [sym_internal_module] = STATE(1358),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2234),
    [sym_this] = ACTIONS(2236),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2236),
    [sym_false] = ACTIONS(2236),
    [sym_null] = ACTIONS(2236),
    [sym_undefined] = ACTIONS(2236),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [370] = {
    [sym_import] = STATE(1308),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1308),
    [sym_yield_expression] = STATE(1308),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1308),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1308),
    [sym_arrow_function] = STATE(1308),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1308),
    [sym_new_expression] = STATE(1308),
    [sym_await_expression] = STATE(1308),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1308),
    [sym_augmented_assignment_expression] = STATE(1308),
    [sym_ternary_expression] = STATE(1308),
    [sym_binary_expression] = STATE(1308),
    [sym_unary_expression] = STATE(1308),
    [sym_update_expression] = STATE(1308),
    [sym_string] = STATE(1308),
    [sym_template_string] = STATE(1308),
    [sym_regex] = STATE(1308),
    [sym_meta_property] = STATE(1308),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1308),
    [sym_type_assertion] = STATE(1308),
    [sym_as_expression] = STATE(1308),
    [sym_internal_module] = STATE(1308),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2238),
    [sym_this] = ACTIONS(1952),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(1952),
    [sym_false] = ACTIONS(1952),
    [sym_null] = ACTIONS(1952),
    [sym_undefined] = ACTIONS(1952),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [371] = {
    [sym_import] = STATE(1302),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1302),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1302),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1302),
    [sym_arrow_function] = STATE(1302),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1302),
    [sym_new_expression] = STATE(1302),
    [sym_await_expression] = STATE(1302),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1302),
    [sym_augmented_assignment_expression] = STATE(1302),
    [sym_ternary_expression] = STATE(1302),
    [sym_binary_expression] = STATE(1302),
    [sym_unary_expression] = STATE(1302),
    [sym_update_expression] = STATE(1302),
    [sym_string] = STATE(1302),
    [sym_template_string] = STATE(1302),
    [sym_regex] = STATE(1302),
    [sym_meta_property] = STATE(1302),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1302),
    [sym_type_assertion] = STATE(1302),
    [sym_as_expression] = STATE(1302),
    [sym_internal_module] = STATE(1302),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2240),
    [sym_this] = ACTIONS(2242),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [sym_null] = ACTIONS(2242),
    [sym_undefined] = ACTIONS(2242),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [372] = {
    [sym_import] = STATE(926),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(926),
    [sym_yield_expression] = STATE(926),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(926),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(926),
    [sym_arrow_function] = STATE(926),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(926),
    [sym_new_expression] = STATE(926),
    [sym_await_expression] = STATE(926),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(926),
    [sym_augmented_assignment_expression] = STATE(926),
    [sym_ternary_expression] = STATE(926),
    [sym_binary_expression] = STATE(926),
    [sym_unary_expression] = STATE(926),
    [sym_update_expression] = STATE(926),
    [sym_string] = STATE(926),
    [sym_template_string] = STATE(926),
    [sym_regex] = STATE(926),
    [sym_meta_property] = STATE(926),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(926),
    [sym_type_assertion] = STATE(926),
    [sym_as_expression] = STATE(926),
    [sym_internal_module] = STATE(926),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1946),
    [sym_this] = ACTIONS(1948),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1948),
    [sym_false] = ACTIONS(1948),
    [sym_null] = ACTIONS(1948),
    [sym_undefined] = ACTIONS(1948),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [373] = {
    [sym_import] = STATE(1359),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1359),
    [sym_yield_expression] = STATE(1359),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1359),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1359),
    [sym_arrow_function] = STATE(1359),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1359),
    [sym_new_expression] = STATE(1359),
    [sym_await_expression] = STATE(1359),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1359),
    [sym_augmented_assignment_expression] = STATE(1359),
    [sym_ternary_expression] = STATE(1359),
    [sym_binary_expression] = STATE(1359),
    [sym_unary_expression] = STATE(1359),
    [sym_update_expression] = STATE(1359),
    [sym_string] = STATE(1359),
    [sym_template_string] = STATE(1359),
    [sym_regex] = STATE(1359),
    [sym_meta_property] = STATE(1359),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1359),
    [sym_type_assertion] = STATE(1359),
    [sym_as_expression] = STATE(1359),
    [sym_internal_module] = STATE(1359),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2244),
    [sym_this] = ACTIONS(1025),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1025),
    [sym_false] = ACTIONS(1025),
    [sym_null] = ACTIONS(1025),
    [sym_undefined] = ACTIONS(1025),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [374] = {
    [sym_import] = STATE(1301),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1301),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1301),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1301),
    [sym_arrow_function] = STATE(1301),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1301),
    [sym_new_expression] = STATE(1301),
    [sym_await_expression] = STATE(1301),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1301),
    [sym_augmented_assignment_expression] = STATE(1301),
    [sym_ternary_expression] = STATE(1301),
    [sym_binary_expression] = STATE(1301),
    [sym_unary_expression] = STATE(1301),
    [sym_update_expression] = STATE(1301),
    [sym_string] = STATE(1301),
    [sym_template_string] = STATE(1301),
    [sym_regex] = STATE(1301),
    [sym_meta_property] = STATE(1301),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1301),
    [sym_type_assertion] = STATE(1301),
    [sym_as_expression] = STATE(1301),
    [sym_internal_module] = STATE(1301),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(662),
    [sym_this] = ACTIONS(664),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(664),
    [sym_false] = ACTIONS(664),
    [sym_null] = ACTIONS(664),
    [sym_undefined] = ACTIONS(664),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [375] = {
    [sym_import] = STATE(961),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(961),
    [sym_yield_expression] = STATE(961),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(961),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(961),
    [sym_arrow_function] = STATE(961),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(961),
    [sym_new_expression] = STATE(961),
    [sym_await_expression] = STATE(961),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(961),
    [sym_augmented_assignment_expression] = STATE(961),
    [sym_ternary_expression] = STATE(961),
    [sym_binary_expression] = STATE(961),
    [sym_unary_expression] = STATE(961),
    [sym_update_expression] = STATE(961),
    [sym_string] = STATE(961),
    [sym_template_string] = STATE(961),
    [sym_regex] = STATE(961),
    [sym_meta_property] = STATE(961),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(961),
    [sym_type_assertion] = STATE(961),
    [sym_as_expression] = STATE(961),
    [sym_internal_module] = STATE(961),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2246),
    [sym_this] = ACTIONS(2248),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2248),
    [sym_false] = ACTIONS(2248),
    [sym_null] = ACTIONS(2248),
    [sym_undefined] = ACTIONS(2248),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [376] = {
    [sym_import] = STATE(927),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(927),
    [sym_yield_expression] = STATE(927),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(927),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(927),
    [sym_arrow_function] = STATE(927),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(927),
    [sym_new_expression] = STATE(927),
    [sym_await_expression] = STATE(927),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(927),
    [sym_augmented_assignment_expression] = STATE(927),
    [sym_ternary_expression] = STATE(927),
    [sym_binary_expression] = STATE(927),
    [sym_unary_expression] = STATE(927),
    [sym_update_expression] = STATE(927),
    [sym_string] = STATE(927),
    [sym_template_string] = STATE(927),
    [sym_regex] = STATE(927),
    [sym_meta_property] = STATE(927),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(927),
    [sym_type_assertion] = STATE(927),
    [sym_as_expression] = STATE(927),
    [sym_internal_module] = STATE(927),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(1894),
    [sym_this] = ACTIONS(1896),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1896),
    [sym_false] = ACTIONS(1896),
    [sym_null] = ACTIONS(1896),
    [sym_undefined] = ACTIONS(1896),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [377] = {
    [sym_import] = STATE(1360),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1360),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1360),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1360),
    [sym_arrow_function] = STATE(1360),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1360),
    [sym_new_expression] = STATE(1360),
    [sym_await_expression] = STATE(1360),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1360),
    [sym_augmented_assignment_expression] = STATE(1360),
    [sym_ternary_expression] = STATE(1360),
    [sym_binary_expression] = STATE(1360),
    [sym_unary_expression] = STATE(1360),
    [sym_update_expression] = STATE(1360),
    [sym_string] = STATE(1360),
    [sym_template_string] = STATE(1360),
    [sym_regex] = STATE(1360),
    [sym_meta_property] = STATE(1360),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1360),
    [sym_type_assertion] = STATE(1360),
    [sym_as_expression] = STATE(1360),
    [sym_internal_module] = STATE(1360),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2250),
    [sym_this] = ACTIONS(2252),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2252),
    [sym_false] = ACTIONS(2252),
    [sym_null] = ACTIONS(2252),
    [sym_undefined] = ACTIONS(2252),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [378] = {
    [sym_import] = STATE(1466),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1466),
    [sym_yield_expression] = STATE(1466),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1466),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1466),
    [sym_arrow_function] = STATE(1466),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1466),
    [sym_new_expression] = STATE(1466),
    [sym_await_expression] = STATE(1466),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1466),
    [sym_augmented_assignment_expression] = STATE(1466),
    [sym_ternary_expression] = STATE(1466),
    [sym_binary_expression] = STATE(1466),
    [sym_unary_expression] = STATE(1466),
    [sym_update_expression] = STATE(1466),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1466),
    [sym_regex] = STATE(1466),
    [sym_meta_property] = STATE(1466),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1466),
    [sym_type_assertion] = STATE(1466),
    [sym_as_expression] = STATE(1466),
    [sym_internal_module] = STATE(1466),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2254),
    [sym_this] = ACTIONS(2256),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2256),
    [sym_false] = ACTIONS(2256),
    [sym_null] = ACTIONS(2256),
    [sym_undefined] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [379] = {
    [sym_import] = STATE(1237),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1237),
    [sym_yield_expression] = STATE(1237),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1237),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1237),
    [sym_arrow_function] = STATE(1237),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1237),
    [sym_new_expression] = STATE(1237),
    [sym_await_expression] = STATE(1237),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1237),
    [sym_augmented_assignment_expression] = STATE(1237),
    [sym_ternary_expression] = STATE(1237),
    [sym_binary_expression] = STATE(1237),
    [sym_unary_expression] = STATE(1237),
    [sym_update_expression] = STATE(1237),
    [sym_string] = STATE(1237),
    [sym_template_string] = STATE(1237),
    [sym_regex] = STATE(1237),
    [sym_meta_property] = STATE(1237),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1237),
    [sym_type_assertion] = STATE(1237),
    [sym_as_expression] = STATE(1237),
    [sym_internal_module] = STATE(1237),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2258),
    [sym_this] = ACTIONS(2260),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2260),
    [sym_false] = ACTIONS(2260),
    [sym_null] = ACTIONS(2260),
    [sym_undefined] = ACTIONS(2260),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [380] = {
    [sym_import] = STATE(1134),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1134),
    [sym_yield_expression] = STATE(1134),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1134),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1134),
    [sym_arrow_function] = STATE(1134),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1134),
    [sym_new_expression] = STATE(1134),
    [sym_await_expression] = STATE(1134),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1134),
    [sym_augmented_assignment_expression] = STATE(1134),
    [sym_ternary_expression] = STATE(1134),
    [sym_binary_expression] = STATE(1134),
    [sym_unary_expression] = STATE(1134),
    [sym_update_expression] = STATE(1134),
    [sym_string] = STATE(1134),
    [sym_template_string] = STATE(1134),
    [sym_regex] = STATE(1134),
    [sym_meta_property] = STATE(1134),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1134),
    [sym_type_assertion] = STATE(1134),
    [sym_as_expression] = STATE(1134),
    [sym_internal_module] = STATE(1134),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2262),
    [sym_this] = ACTIONS(2264),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2264),
    [sym_false] = ACTIONS(2264),
    [sym_null] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [381] = {
    [sym_import] = STATE(1361),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1361),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1361),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1361),
    [sym_arrow_function] = STATE(1361),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1361),
    [sym_new_expression] = STATE(1361),
    [sym_await_expression] = STATE(1361),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1361),
    [sym_augmented_assignment_expression] = STATE(1361),
    [sym_ternary_expression] = STATE(1361),
    [sym_binary_expression] = STATE(1361),
    [sym_unary_expression] = STATE(1361),
    [sym_update_expression] = STATE(1361),
    [sym_string] = STATE(1361),
    [sym_template_string] = STATE(1361),
    [sym_regex] = STATE(1361),
    [sym_meta_property] = STATE(1361),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1361),
    [sym_type_assertion] = STATE(1361),
    [sym_as_expression] = STATE(1361),
    [sym_internal_module] = STATE(1361),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2266),
    [sym_this] = ACTIONS(2268),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2268),
    [sym_false] = ACTIONS(2268),
    [sym_null] = ACTIONS(2268),
    [sym_undefined] = ACTIONS(2268),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [382] = {
    [sym_import] = STATE(1076),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1076),
    [sym_yield_expression] = STATE(1076),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1076),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1076),
    [sym_arrow_function] = STATE(1076),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1076),
    [sym_new_expression] = STATE(1076),
    [sym_await_expression] = STATE(1076),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1076),
    [sym_augmented_assignment_expression] = STATE(1076),
    [sym_ternary_expression] = STATE(1076),
    [sym_binary_expression] = STATE(1076),
    [sym_unary_expression] = STATE(1076),
    [sym_update_expression] = STATE(1076),
    [sym_string] = STATE(1076),
    [sym_template_string] = STATE(1076),
    [sym_regex] = STATE(1076),
    [sym_meta_property] = STATE(1076),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1076),
    [sym_type_assertion] = STATE(1076),
    [sym_as_expression] = STATE(1076),
    [sym_internal_module] = STATE(1076),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2136),
    [sym_this] = ACTIONS(2138),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2138),
    [sym_false] = ACTIONS(2138),
    [sym_null] = ACTIONS(2138),
    [sym_undefined] = ACTIONS(2138),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [383] = {
    [sym_import] = STATE(1362),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1362),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1362),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1362),
    [sym_arrow_function] = STATE(1362),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1362),
    [sym_new_expression] = STATE(1362),
    [sym_await_expression] = STATE(1362),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1362),
    [sym_augmented_assignment_expression] = STATE(1362),
    [sym_ternary_expression] = STATE(1362),
    [sym_binary_expression] = STATE(1362),
    [sym_unary_expression] = STATE(1362),
    [sym_update_expression] = STATE(1362),
    [sym_string] = STATE(1362),
    [sym_template_string] = STATE(1362),
    [sym_regex] = STATE(1362),
    [sym_meta_property] = STATE(1362),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1362),
    [sym_type_assertion] = STATE(1362),
    [sym_as_expression] = STATE(1362),
    [sym_internal_module] = STATE(1362),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2270),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [384] = {
    [sym_import] = STATE(1324),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1324),
    [sym_arrow_function] = STATE(1324),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1324),
    [sym_type_assertion] = STATE(1324),
    [sym_as_expression] = STATE(1324),
    [sym_internal_module] = STATE(1324),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(531),
    [sym_this] = ACTIONS(533),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(533),
    [sym_false] = ACTIONS(533),
    [sym_null] = ACTIONS(533),
    [sym_undefined] = ACTIONS(533),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [385] = {
    [sym_import] = STATE(1079),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1079),
    [sym_yield_expression] = STATE(1079),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1079),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1079),
    [sym_arrow_function] = STATE(1079),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1079),
    [sym_new_expression] = STATE(1079),
    [sym_await_expression] = STATE(1079),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1079),
    [sym_augmented_assignment_expression] = STATE(1079),
    [sym_ternary_expression] = STATE(1079),
    [sym_binary_expression] = STATE(1079),
    [sym_unary_expression] = STATE(1079),
    [sym_update_expression] = STATE(1079),
    [sym_string] = STATE(1079),
    [sym_template_string] = STATE(1079),
    [sym_regex] = STATE(1079),
    [sym_meta_property] = STATE(1079),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1079),
    [sym_type_assertion] = STATE(1079),
    [sym_as_expression] = STATE(1079),
    [sym_internal_module] = STATE(1079),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(2276),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [sym_null] = ACTIONS(2276),
    [sym_undefined] = ACTIONS(2276),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [386] = {
    [sym_import] = STATE(1060),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1060),
    [sym_yield_expression] = STATE(1060),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1060),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1060),
    [sym_arrow_function] = STATE(1060),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1060),
    [sym_new_expression] = STATE(1060),
    [sym_await_expression] = STATE(1060),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1060),
    [sym_augmented_assignment_expression] = STATE(1060),
    [sym_ternary_expression] = STATE(1060),
    [sym_binary_expression] = STATE(1060),
    [sym_unary_expression] = STATE(1060),
    [sym_update_expression] = STATE(1060),
    [sym_string] = STATE(1060),
    [sym_template_string] = STATE(1060),
    [sym_regex] = STATE(1060),
    [sym_meta_property] = STATE(1060),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1060),
    [sym_type_assertion] = STATE(1060),
    [sym_as_expression] = STATE(1060),
    [sym_internal_module] = STATE(1060),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(1950),
    [sym_this] = ACTIONS(2042),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2042),
    [sym_false] = ACTIONS(2042),
    [sym_null] = ACTIONS(2042),
    [sym_undefined] = ACTIONS(2042),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [387] = {
    [sym_import] = STATE(962),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(962),
    [sym_yield_expression] = STATE(962),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(962),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(962),
    [sym_arrow_function] = STATE(962),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(962),
    [sym_new_expression] = STATE(962),
    [sym_await_expression] = STATE(962),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(962),
    [sym_augmented_assignment_expression] = STATE(962),
    [sym_ternary_expression] = STATE(962),
    [sym_binary_expression] = STATE(962),
    [sym_unary_expression] = STATE(962),
    [sym_update_expression] = STATE(962),
    [sym_string] = STATE(962),
    [sym_template_string] = STATE(962),
    [sym_regex] = STATE(962),
    [sym_meta_property] = STATE(962),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(962),
    [sym_type_assertion] = STATE(962),
    [sym_as_expression] = STATE(962),
    [sym_internal_module] = STATE(962),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2278),
    [sym_this] = ACTIONS(2280),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2280),
    [sym_false] = ACTIONS(2280),
    [sym_null] = ACTIONS(2280),
    [sym_undefined] = ACTIONS(2280),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [388] = {
    [sym_import] = STATE(1365),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1365),
    [sym_yield_expression] = STATE(1365),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1365),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1365),
    [sym_arrow_function] = STATE(1365),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1365),
    [sym_new_expression] = STATE(1365),
    [sym_await_expression] = STATE(1365),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1365),
    [sym_augmented_assignment_expression] = STATE(1365),
    [sym_ternary_expression] = STATE(1365),
    [sym_binary_expression] = STATE(1365),
    [sym_unary_expression] = STATE(1365),
    [sym_update_expression] = STATE(1365),
    [sym_string] = STATE(1365),
    [sym_template_string] = STATE(1365),
    [sym_regex] = STATE(1365),
    [sym_meta_property] = STATE(1365),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1365),
    [sym_type_assertion] = STATE(1365),
    [sym_as_expression] = STATE(1365),
    [sym_internal_module] = STATE(1365),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2282),
    [sym_this] = ACTIONS(2284),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [sym_null] = ACTIONS(2284),
    [sym_undefined] = ACTIONS(2284),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [389] = {
    [sym_import] = STATE(1300),
    [sym_parenthesized_expression] = STATE(882),
    [sym__expression] = STATE(1300),
    [sym_yield_expression] = STATE(1300),
    [sym_object] = STATE(1662),
    [sym_array] = STATE(1657),
    [sym_class] = STATE(1300),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1300),
    [sym_arrow_function] = STATE(1300),
    [sym__call_signature] = STATE(2909),
    [sym_call_expression] = STATE(1300),
    [sym_new_expression] = STATE(1300),
    [sym_await_expression] = STATE(1300),
    [sym_member_expression] = STATE(882),
    [sym_subscript_expression] = STATE(882),
    [sym_assignment_expression] = STATE(1300),
    [sym_augmented_assignment_expression] = STATE(1300),
    [sym_ternary_expression] = STATE(1300),
    [sym_binary_expression] = STATE(1300),
    [sym_unary_expression] = STATE(1300),
    [sym_update_expression] = STATE(1300),
    [sym_string] = STATE(1300),
    [sym_template_string] = STATE(1300),
    [sym_regex] = STATE(1300),
    [sym_meta_property] = STATE(1300),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1300),
    [sym_type_assertion] = STATE(1300),
    [sym_as_expression] = STATE(1300),
    [sym_internal_module] = STATE(1300),
    [sym_type_arguments] = STATE(339),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_export] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(634),
    [anon_sym_typeof] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(642),
    [anon_sym_yield] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_BANG] = ACTIONS(656),
    [anon_sym_TILDE] = ACTIONS(656),
    [anon_sym_void] = ACTIONS(658),
    [anon_sym_delete] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(660),
    [anon_sym_DASH_DASH] = ACTIONS(660),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2286),
    [sym_this] = ACTIONS(2288),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [sym_null] = ACTIONS(2288),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(634),
    [anon_sym_get] = ACTIONS(634),
    [anon_sym_set] = ACTIONS(634),
    [anon_sym_declare] = ACTIONS(634),
    [anon_sym_public] = ACTIONS(634),
    [anon_sym_private] = ACTIONS(634),
    [anon_sym_protected] = ACTIONS(634),
    [anon_sym_module] = ACTIONS(634),
    [anon_sym_any] = ACTIONS(634),
    [anon_sym_number] = ACTIONS(634),
    [anon_sym_boolean] = ACTIONS(634),
    [anon_sym_string] = ACTIONS(634),
    [anon_sym_symbol] = ACTIONS(634),
    [sym_readonly] = ACTIONS(634),
  },
  [390] = {
    [sym_import] = STATE(1370),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1370),
    [sym_yield_expression] = STATE(1370),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1370),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1370),
    [sym_arrow_function] = STATE(1370),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1370),
    [sym_new_expression] = STATE(1370),
    [sym_await_expression] = STATE(1370),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1370),
    [sym_augmented_assignment_expression] = STATE(1370),
    [sym_ternary_expression] = STATE(1370),
    [sym_binary_expression] = STATE(1370),
    [sym_unary_expression] = STATE(1370),
    [sym_update_expression] = STATE(1370),
    [sym_string] = STATE(1370),
    [sym_template_string] = STATE(1370),
    [sym_regex] = STATE(1370),
    [sym_meta_property] = STATE(1370),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1370),
    [sym_type_assertion] = STATE(1370),
    [sym_as_expression] = STATE(1370),
    [sym_internal_module] = STATE(1370),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2290),
    [sym_this] = ACTIONS(2292),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2292),
    [sym_false] = ACTIONS(2292),
    [sym_null] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [391] = {
    [sym_import] = STATE(977),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(977),
    [sym_yield_expression] = STATE(977),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(977),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(977),
    [sym_arrow_function] = STATE(977),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(977),
    [sym_new_expression] = STATE(977),
    [sym_await_expression] = STATE(977),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(977),
    [sym_augmented_assignment_expression] = STATE(977),
    [sym_ternary_expression] = STATE(977),
    [sym_binary_expression] = STATE(977),
    [sym_unary_expression] = STATE(977),
    [sym_update_expression] = STATE(977),
    [sym_string] = STATE(977),
    [sym_template_string] = STATE(977),
    [sym_regex] = STATE(977),
    [sym_meta_property] = STATE(977),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(977),
    [sym_type_assertion] = STATE(977),
    [sym_as_expression] = STATE(977),
    [sym_internal_module] = STATE(977),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2294),
    [sym_this] = ACTIONS(1804),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(1804),
    [sym_false] = ACTIONS(1804),
    [sym_null] = ACTIONS(1804),
    [sym_undefined] = ACTIONS(1804),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [392] = {
    [sym_import] = STATE(1079),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1079),
    [sym_yield_expression] = STATE(1079),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1079),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1079),
    [sym_arrow_function] = STATE(1079),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1079),
    [sym_new_expression] = STATE(1079),
    [sym_await_expression] = STATE(1079),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1079),
    [sym_augmented_assignment_expression] = STATE(1079),
    [sym_ternary_expression] = STATE(1079),
    [sym_binary_expression] = STATE(1079),
    [sym_unary_expression] = STATE(1079),
    [sym_update_expression] = STATE(1079),
    [sym_string] = STATE(1079),
    [sym_template_string] = STATE(1079),
    [sym_regex] = STATE(1079),
    [sym_meta_property] = STATE(1079),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1079),
    [sym_type_assertion] = STATE(1079),
    [sym_as_expression] = STATE(1079),
    [sym_internal_module] = STATE(1079),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(2060),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(2276),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2276),
    [sym_false] = ACTIONS(2276),
    [sym_null] = ACTIONS(2276),
    [sym_undefined] = ACTIONS(2276),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [393] = {
    [sym_import] = STATE(1507),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1507),
    [sym_yield_expression] = STATE(1507),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1507),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1507),
    [sym_arrow_function] = STATE(1507),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1507),
    [sym_new_expression] = STATE(1507),
    [sym_await_expression] = STATE(1507),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1507),
    [sym_augmented_assignment_expression] = STATE(1507),
    [sym_ternary_expression] = STATE(1507),
    [sym_binary_expression] = STATE(1507),
    [sym_unary_expression] = STATE(1507),
    [sym_update_expression] = STATE(1507),
    [sym_string] = STATE(1507),
    [sym_template_string] = STATE(1507),
    [sym_regex] = STATE(1507),
    [sym_meta_property] = STATE(1507),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1507),
    [sym_type_assertion] = STATE(1507),
    [sym_as_expression] = STATE(1507),
    [sym_internal_module] = STATE(1507),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2296),
    [sym_this] = ACTIONS(2298),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [sym_null] = ACTIONS(2298),
    [sym_undefined] = ACTIONS(2298),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [394] = {
    [sym_import] = STATE(1222),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1222),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1222),
    [sym_arrow_function] = STATE(1222),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1222),
    [sym_new_expression] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_string] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1222),
    [sym_type_assertion] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(716),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_undefined] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [395] = {
    [sym_import] = STATE(979),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(979),
    [sym_yield_expression] = STATE(979),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(979),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(979),
    [sym_arrow_function] = STATE(979),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(979),
    [sym_new_expression] = STATE(979),
    [sym_await_expression] = STATE(979),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(979),
    [sym_augmented_assignment_expression] = STATE(979),
    [sym_ternary_expression] = STATE(979),
    [sym_binary_expression] = STATE(979),
    [sym_unary_expression] = STATE(979),
    [sym_update_expression] = STATE(979),
    [sym_string] = STATE(979),
    [sym_template_string] = STATE(979),
    [sym_regex] = STATE(979),
    [sym_meta_property] = STATE(979),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(979),
    [sym_type_assertion] = STATE(979),
    [sym_as_expression] = STATE(979),
    [sym_internal_module] = STATE(979),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2300),
    [sym_this] = ACTIONS(2302),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2302),
    [sym_false] = ACTIONS(2302),
    [sym_null] = ACTIONS(2302),
    [sym_undefined] = ACTIONS(2302),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [396] = {
    [sym_import] = STATE(1163),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1163),
    [sym_yield_expression] = STATE(1163),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1163),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1163),
    [sym_arrow_function] = STATE(1163),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1163),
    [sym_new_expression] = STATE(1163),
    [sym_await_expression] = STATE(1163),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1163),
    [sym_augmented_assignment_expression] = STATE(1163),
    [sym_ternary_expression] = STATE(1163),
    [sym_binary_expression] = STATE(1163),
    [sym_unary_expression] = STATE(1163),
    [sym_update_expression] = STATE(1163),
    [sym_string] = STATE(1163),
    [sym_template_string] = STATE(1163),
    [sym_regex] = STATE(1163),
    [sym_meta_property] = STATE(1163),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1163),
    [sym_type_assertion] = STATE(1163),
    [sym_as_expression] = STATE(1163),
    [sym_internal_module] = STATE(1163),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2304),
    [sym_this] = ACTIONS(2306),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2306),
    [sym_false] = ACTIONS(2306),
    [sym_null] = ACTIONS(2306),
    [sym_undefined] = ACTIONS(2306),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [397] = {
    [sym_import] = STATE(1367),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1367),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1367),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1367),
    [sym_arrow_function] = STATE(1367),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1367),
    [sym_new_expression] = STATE(1367),
    [sym_await_expression] = STATE(1367),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1367),
    [sym_augmented_assignment_expression] = STATE(1367),
    [sym_ternary_expression] = STATE(1367),
    [sym_binary_expression] = STATE(1367),
    [sym_unary_expression] = STATE(1367),
    [sym_update_expression] = STATE(1367),
    [sym_string] = STATE(1367),
    [sym_template_string] = STATE(1367),
    [sym_regex] = STATE(1367),
    [sym_meta_property] = STATE(1367),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1367),
    [sym_type_assertion] = STATE(1367),
    [sym_as_expression] = STATE(1367),
    [sym_internal_module] = STATE(1367),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2308),
    [sym_this] = ACTIONS(2310),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [sym_null] = ACTIONS(2310),
    [sym_undefined] = ACTIONS(2310),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [398] = {
    [sym_import] = STATE(1165),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1165),
    [sym_yield_expression] = STATE(1165),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1165),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1165),
    [sym_arrow_function] = STATE(1165),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1165),
    [sym_new_expression] = STATE(1165),
    [sym_await_expression] = STATE(1165),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1165),
    [sym_augmented_assignment_expression] = STATE(1165),
    [sym_ternary_expression] = STATE(1165),
    [sym_binary_expression] = STATE(1165),
    [sym_unary_expression] = STATE(1165),
    [sym_update_expression] = STATE(1165),
    [sym_string] = STATE(1165),
    [sym_template_string] = STATE(1165),
    [sym_regex] = STATE(1165),
    [sym_meta_property] = STATE(1165),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1165),
    [sym_type_assertion] = STATE(1165),
    [sym_as_expression] = STATE(1165),
    [sym_internal_module] = STATE(1165),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(754),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_undefined] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [399] = {
    [sym_import] = STATE(1224),
    [sym_parenthesized_expression] = STATE(872),
    [sym__expression] = STATE(1224),
    [sym_yield_expression] = STATE(1224),
    [sym_object] = STATE(1452),
    [sym_array] = STATE(1451),
    [sym_class] = STATE(1224),
    [sym_function] = STATE(1202),
    [sym_generator_function] = STATE(1224),
    [sym_arrow_function] = STATE(1224),
    [sym__call_signature] = STATE(2901),
    [sym_call_expression] = STATE(1224),
    [sym_new_expression] = STATE(1224),
    [sym_await_expression] = STATE(1224),
    [sym_member_expression] = STATE(872),
    [sym_subscript_expression] = STATE(872),
    [sym_assignment_expression] = STATE(1224),
    [sym_augmented_assignment_expression] = STATE(1224),
    [sym_ternary_expression] = STATE(1224),
    [sym_binary_expression] = STATE(1224),
    [sym_unary_expression] = STATE(1224),
    [sym_update_expression] = STATE(1224),
    [sym_string] = STATE(1224),
    [sym_template_string] = STATE(1224),
    [sym_regex] = STATE(1224),
    [sym_meta_property] = STATE(1224),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1224),
    [sym_type_assertion] = STATE(1224),
    [sym_as_expression] = STATE(1224),
    [sym_internal_module] = STATE(1224),
    [sym_type_arguments] = STATE(321),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2329),
    [sym_identifier] = ACTIONS(666),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(672),
    [anon_sym_LBRACE] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_typeof] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_await] = ACTIONS(682),
    [anon_sym_yield] = ACTIONS(684),
    [anon_sym_LBRACK] = ACTIONS(686),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(692),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_new] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(704),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_void] = ACTIONS(706),
    [anon_sym_delete] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(708),
    [anon_sym_DASH_DASH] = ACTIONS(708),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(2312),
    [sym_this] = ACTIONS(2314),
    [sym_super] = ACTIONS(720),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [sym_null] = ACTIONS(2314),
    [sym_undefined] = ACTIONS(2314),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
  },
  [400] = {
    [sym_import] = STATE(1212),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(1212),
    [sym_yield_expression] = STATE(1212),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(1212),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1212),
    [sym_arrow_function] = STATE(1212),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(1212),
    [sym_new_expression] = STATE(1212),
    [sym_await_expression] = STATE(1212),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(1212),
    [sym_augmented_assignment_expression] = STATE(1212),
    [sym_ternary_expression] = STATE(1212),
    [sym_binary_expression] = STATE(1212),
    [sym_unary_expression] = STATE(1212),
    [sym_update_expression] = STATE(1212),
    [sym_string] = STATE(1212),
    [sym_template_string] = STATE(1212),
    [sym_regex] = STATE(1212),
    [sym_meta_property] = STATE(1212),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1212),
    [sym_type_assertion] = STATE(1212),
    [sym_as_expression] = STATE(1212),
    [sym_internal_module] = STATE(1212),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2316),
    [sym_this] = ACTIONS(2318),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [sym_null] = ACTIONS(2318),
    [sym_undefined] = ACTIONS(2318),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [401] = {
    [sym_import] = STATE(981),
    [sym_parenthesized_expression] = STATE(819),
    [sym__expression] = STATE(981),
    [sym_yield_expression] = STATE(981),
    [sym_object] = STATE(1257),
    [sym_array] = STATE(1258),
    [sym_class] = STATE(981),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(981),
    [sym_arrow_function] = STATE(981),
    [sym__call_signature] = STATE(2946),
    [sym_call_expression] = STATE(981),
    [sym_new_expression] = STATE(981),
    [sym_await_expression] = STATE(981),
    [sym_member_expression] = STATE(819),
    [sym_subscript_expression] = STATE(819),
    [sym_assignment_expression] = STATE(981),
    [sym_augmented_assignment_expression] = STATE(981),
    [sym_ternary_expression] = STATE(981),
    [sym_binary_expression] = STATE(981),
    [sym_unary_expression] = STATE(981),
    [sym_update_expression] = STATE(981),
    [sym_string] = STATE(981),
    [sym_template_string] = STATE(981),
    [sym_regex] = STATE(981),
    [sym_meta_property] = STATE(981),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(981),
    [sym_type_assertion] = STATE(981),
    [sym_as_expression] = STATE(981),
    [sym_internal_module] = STATE(981),
    [sym_type_arguments] = STATE(376),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(543),
    [anon_sym_namespace] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(543),
    [anon_sym_typeof] = ACTIONS(552),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(556),
    [anon_sym_yield] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(567),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(573),
    [anon_sym_DASH] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_void] = ACTIONS(579),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2320),
    [sym_this] = ACTIONS(2322),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [sym_null] = ACTIONS(2322),
    [sym_undefined] = ACTIONS(2322),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_get] = ACTIONS(543),
    [anon_sym_set] = ACTIONS(543),
    [anon_sym_declare] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_any] = ACTIONS(543),
    [anon_sym_number] = ACTIONS(543),
    [anon_sym_boolean] = ACTIONS(543),
    [anon_sym_string] = ACTIONS(543),
    [anon_sym_symbol] = ACTIONS(543),
    [sym_readonly] = ACTIONS(543),
  },
  [402] = {
    [sym_import] = STATE(1368),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1368),
    [sym_yield_expression] = STATE(1368),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1368),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1368),
    [sym_arrow_function] = STATE(1368),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1368),
    [sym_new_expression] = STATE(1368),
    [sym_await_expression] = STATE(1368),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1368),
    [sym_augmented_assignment_expression] = STATE(1368),
    [sym_ternary_expression] = STATE(1368),
    [sym_binary_expression] = STATE(1368),
    [sym_unary_expression] = STATE(1368),
    [sym_update_expression] = STATE(1368),
    [sym_string] = STATE(1368),
    [sym_template_string] = STATE(1368),
    [sym_regex] = STATE(1368),
    [sym_meta_property] = STATE(1368),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1368),
    [sym_type_assertion] = STATE(1368),
    [sym_as_expression] = STATE(1368),
    [sym_internal_module] = STATE(1368),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2324),
    [sym_this] = ACTIONS(2326),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [sym_null] = ACTIONS(2326),
    [sym_undefined] = ACTIONS(2326),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [403] = {
    [sym_import] = STATE(1328),
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(1328),
    [sym_yield_expression] = STATE(1328),
    [sym_object] = STATE(1650),
    [sym_array] = STATE(1656),
    [sym_class] = STATE(1328),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1328),
    [sym_arrow_function] = STATE(1328),
    [sym__call_signature] = STATE(2871),
    [sym_call_expression] = STATE(1328),
    [sym_new_expression] = STATE(1328),
    [sym_await_expression] = STATE(1328),
    [sym_member_expression] = STATE(889),
    [sym_subscript_expression] = STATE(889),
    [sym_assignment_expression] = STATE(1328),
    [sym_augmented_assignment_expression] = STATE(1328),
    [sym_ternary_expression] = STATE(1328),
    [sym_binary_expression] = STATE(1328),
    [sym_unary_expression] = STATE(1328),
    [sym_update_expression] = STATE(1328),
    [sym_string] = STATE(1328),
    [sym_template_string] = STATE(1328),
    [sym_regex] = STATE(1328),
    [sym_meta_property] = STATE(1328),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1328),
    [sym_type_assertion] = STATE(1328),
    [sym_as_expression] = STATE(1328),
    [sym_internal_module] = STATE(1328),
    [sym_type_arguments] = STATE(272),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_namespace] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(565),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(624),
    [anon_sym_DASH] = ACTIONS(624),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_void] = ACTIONS(525),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(628),
    [anon_sym_DASH_DASH] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2124),
    [sym_this] = ACTIONS(2034),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2034),
    [sym_false] = ACTIONS(2034),
    [sym_null] = ACTIONS(2034),
    [sym_undefined] = ACTIONS(2034),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [anon_sym_declare] = ACTIONS(489),
    [anon_sym_public] = ACTIONS(489),
    [anon_sym_private] = ACTIONS(489),
    [anon_sym_protected] = ACTIONS(489),
    [anon_sym_module] = ACTIONS(489),
    [anon_sym_any] = ACTIONS(489),
    [anon_sym_number] = ACTIONS(489),
    [anon_sym_boolean] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_symbol] = ACTIONS(489),
    [sym_readonly] = ACTIONS(489),
  },
  [404] = {
    [sym_import] = STATE(1090),
    [sym_parenthesized_expression] = STATE(835),
    [sym__expression] = STATE(1090),
    [sym_yield_expression] = STATE(1090),
    [sym_object] = STATE(1364),
    [sym_array] = STATE(1363),
    [sym_class] = STATE(1090),
    [sym_function] = STATE(1004),
    [sym_generator_function] = STATE(1090),
    [sym_arrow_function] = STATE(1090),
    [sym__call_signature] = STATE(2899),
    [sym_call_expression] = STATE(1090),
    [sym_new_expression] = STATE(1090),
    [sym_await_expression] = STATE(1090),
    [sym_member_expression] = STATE(835),
    [sym_subscript_expression] = STATE(835),
    [sym_assignment_expression] = STATE(1090),
    [sym_augmented_assignment_expression] = STATE(1090),
    [sym_ternary_expression] = STATE(1090),
    [sym_binary_expression] = STATE(1090),
    [sym_unary_expression] = STATE(1090),
    [sym_update_expression] = STATE(1090),
    [sym_string] = STATE(1090),
    [sym_template_string] = STATE(1090),
    [sym_regex] = STATE(1090),
    [sym_meta_property] = STATE(1090),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1090),
    [sym_type_assertion] = STATE(1090),
    [sym_as_expression] = STATE(1090),
    [sym_internal_module] = STATE(1090),
    [sym_type_arguments] = STATE(382),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(441),
    [anon_sym_export] = ACTIONS(443),
    [anon_sym_namespace] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(443),
    [anon_sym_typeof] = ACTIONS(19),
    [anon_sym_import] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(37),
    [anon_sym_yield] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(65),
    [anon_sym_class] = ACTIONS(466),
    [anon_sym_async] = ACTIONS(468),
    [anon_sym_function] = ACTIONS(470),
    [anon_sym_new] = ACTIONS(73),
    [anon_sym_PLUS] = ACTIONS(75),
    [anon_sym_DASH] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [anon_sym_void] = ACTIONS(481),
    [anon_sym_delete] = ACTIONS(19),
    [anon_sym_PLUS_PLUS] = ACTIONS(81),
    [anon_sym_DASH_DASH] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(2328),
    [sym_this] = ACTIONS(2330),
    [sym_super] = ACTIONS(93),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [sym_null] = ACTIONS(2330),
    [sym_undefined] = ACTIONS(2330),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_get] = ACTIONS(443),
    [anon_sym_set] = ACTIONS(443),
    [anon_sym_declare] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_any] = ACTIONS(443),
    [anon_sym_number] = ACTIONS(443),
    [anon_sym_boolean] = ACTIONS(443),
    [anon_sym_string] = ACTIONS(443),
    [anon_sym_symbol] = ACTIONS(443),
    [sym_readonly] = ACTIONS(443),
  },
  [405] = {
    [sym_import] = STATE(1244),
    [sym_parenthesized_expression] = STATE(859),
    [sym__expression] = STATE(1244),
    [sym_yield_expression] = STATE(1244),
    [sym_object] = STATE(1514),
    [sym_array] = STATE(1515),
    [sym_class] = STATE(1244),
    [sym_function] = STATE(924),
    [sym_generator_function] = STATE(1244),
    [sym_arrow_function] = STATE(1244),
    [sym__call_signature] = STATE(2799),
    [sym_call_expression] = STATE(1244),
    [sym_new_expression] = STATE(1244),
    [sym_await_expression] = STATE(1244),
    [sym_member_expression] = STATE(859),
    [sym_subscript_expression] = STATE(859),
    [sym_assignment_expression] = STATE(1244),
    [sym_augmented_assignment_expression] = STATE(1244),
    [sym_ternary_expression] = STATE(1244),
    [sym_binary_expression] = STATE(1244),
    [sym_unary_expression] = STATE(1244),
    [sym_update_expression] = STATE(1244),
    [sym_string] = STATE(1244),
    [sym_template_string] = STATE(1244),
    [sym_regex] = STATE(1244),
    [sym_meta_property] = STATE(1244),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2379),
    [sym_non_null_expression] = STATE(1244),
    [sym_type_assertion] = STATE(1244),
    [sym_as_expression] = STATE(1244),
    [sym_internal_module] = STATE(1244),
    [sym_type_arguments] = STATE(309),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_export_statement_repeat1] = STATE(2335),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_export] = ACTIONS(724),
    [anon_sym_namespace] = ACTIONS(728),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_type] = ACTIONS(724),
    [anon_sym_typeof] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(63),
    [anon_sym_SLASH] = ACTIONS(736),
    [anon_sym_class] = ACTIONS(511),
    [anon_sym_async] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(740),
    [anon_sym_PLUS] = ACTIONS(744),
    [anon_sym_DASH] = ACTIONS(744),
    [anon_sym_BANG] = ACTIONS(748),
    [anon_sym_TILDE] = ACTIONS(748),
    [anon_sym_void] = ACTIONS(750),
    [anon_sym_delete] = ACTIONS(730),
    [anon_sym_PLUS_PLUS] = ACTIONS(752),
    [anon_sym_DASH_DASH] = ACTIONS(752),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(2332),
    [sym_this] = ACTIONS(2334),
    [sym_super] = ACTIONS(535),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [sym_null] = ACTIONS(2334),
    [sym_undefined] = ACTIONS(2334),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(724),
    [anon_sym_get] = ACTIONS(724),
    [anon_sym_set] = ACTIONS(724),
    [anon_sym_declare] = ACTIONS(724),
    [anon_sym_public] = ACTIONS(724),
    [anon_sym_private] = ACTIONS(724),
    [anon_sym_protected] = ACTIONS(724),
    [anon_sym_module] = ACTIONS(724),
    [anon_sym_any] = ACTIONS(724),
    [anon_sym_number] = ACTIONS(724),
    [anon_sym_boolean] = ACTIONS(724),
    [anon_sym_string] = ACTIONS(724),
    [anon_sym_symbol] = ACTIONS(724),
    [sym_readonly] = ACTIONS(724),
  },
  [406] = {
    [ts_builtin_sym_end] = ACTIONS(1171),
    [sym_identifier] = ACTIONS(1173),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_default] = ACTIONS(1173),
    [anon_sym_EQ] = ACTIONS(1173),
    [anon_sym_namespace] = ACTIONS(1173),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_type] = ACTIONS(1173),
    [anon_sym_typeof] = ACTIONS(1173),
    [anon_sym_import] = ACTIONS(1173),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_let] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_else] = ACTIONS(1173),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_RPAREN] = ACTIONS(1171),
    [anon_sym_await] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_do] = ACTIONS(1173),
    [anon_sym_try] = ACTIONS(1173),
    [anon_sym_with] = ACTIONS(1173),
    [anon_sym_break] = ACTIONS(1173),
    [anon_sym_continue] = ACTIONS(1173),
    [anon_sym_debugger] = ACTIONS(1173),
    [anon_sym_return] = ACTIONS(1173),
    [anon_sym_throw] = ACTIONS(1173),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_COLON] = ACTIONS(1171),
    [anon_sym_case] = ACTIONS(1173),
    [anon_sym_yield] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_RBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1171),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_class] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_function] = ACTIONS(1173),
    [anon_sym_EQ_GT] = ACTIONS(1171),
    [anon_sym_new] = ACTIONS(1173),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1171),
    [anon_sym_PIPE] = ACTIONS(1171),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_BANG] = ACTIONS(1171),
    [anon_sym_TILDE] = ACTIONS(1171),
    [anon_sym_void] = ACTIONS(1173),
    [anon_sym_delete] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [sym_number] = ACTIONS(1171),
    [sym_this] = ACTIONS(1173),
    [sym_super] = ACTIONS(1173),
    [sym_true] = ACTIONS(1173),
    [sym_false] = ACTIONS(1173),
    [sym_null] = ACTIONS(1173),
    [sym_undefined] = ACTIONS(1173),
    [anon_sym_AT] = ACTIONS(1171),
    [anon_sym_static] = ACTIONS(1173),
    [anon_sym_abstract] = ACTIONS(1173),
    [anon_sym_get] = ACTIONS(1173),
    [anon_sym_set] = ACTIONS(1173),
    [anon_sym_declare] = ACTIONS(1173),
    [anon_sym_public] = ACTIONS(1173),
    [anon_sym_private] = ACTIONS(1173),
    [anon_sym_protected] = ACTIONS(1173),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_any] = ACTIONS(1173),
    [anon_sym_number] = ACTIONS(1173),
    [anon_sym_boolean] = ACTIONS(1173),
    [anon_sym_string] = ACTIONS(1173),
    [anon_sym_symbol] = ACTIONS(1173),
    [anon_sym_interface] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [sym_readonly] = ACTIONS(1173),
  },
  [407] = {
    [sym__declaration] = STATE(514),
    [sym_variable_declaration] = STATE(514),
    [sym_lexical_declaration] = STATE(514),
    [sym_class_declaration] = STATE(514),
    [sym_function_declaration] = STATE(514),
    [sym_generator_function_declaration] = STATE(514),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(514),
    [sym_ambient_declaration] = STATE(514),
    [sym_abstract_class_declaration] = STATE(514),
    [sym_module] = STATE(514),
    [sym_internal_module] = STATE(514),
    [sym_import_alias] = STATE(514),
    [sym_interface_declaration] = STATE(514),
    [sym_enum_declaration] = STATE(514),
    [sym_type_alias_declaration] = STATE(514),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1668),
    [anon_sym_module] = ACTIONS(2336),
    [anon_sym_global] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [408] = {
    [sym__declaration] = STATE(514),
    [sym_variable_declaration] = STATE(514),
    [sym_lexical_declaration] = STATE(514),
    [sym_class_declaration] = STATE(514),
    [sym_function_declaration] = STATE(514),
    [sym_generator_function_declaration] = STATE(514),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(514),
    [sym_ambient_declaration] = STATE(514),
    [sym_abstract_class_declaration] = STATE(514),
    [sym_module] = STATE(514),
    [sym_internal_module] = STATE(514),
    [sym_import_alias] = STATE(514),
    [sym_interface_declaration] = STATE(514),
    [sym_enum_declaration] = STATE(514),
    [sym_type_alias_declaration] = STATE(514),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_global] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(1109),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(1111),
    [anon_sym_default] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(1111),
    [anon_sym_namespace] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_type] = ACTIONS(1111),
    [anon_sym_typeof] = ACTIONS(1111),
    [anon_sym_import] = ACTIONS(1111),
    [anon_sym_var] = ACTIONS(1111),
    [anon_sym_let] = ACTIONS(1111),
    [anon_sym_const] = ACTIONS(1111),
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_else] = ACTIONS(1111),
    [anon_sym_switch] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_while] = ACTIONS(1111),
    [anon_sym_do] = ACTIONS(1111),
    [anon_sym_try] = ACTIONS(1111),
    [anon_sym_with] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1111),
    [anon_sym_continue] = ACTIONS(1111),
    [anon_sym_debugger] = ACTIONS(1111),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_throw] = ACTIONS(1111),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_case] = ACTIONS(1111),
    [anon_sym_yield] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_SLASH] = ACTIONS(1111),
    [anon_sym_class] = ACTIONS(1111),
    [anon_sym_async] = ACTIONS(1111),
    [anon_sym_function] = ACTIONS(1111),
    [anon_sym_EQ_GT] = ACTIONS(1109),
    [anon_sym_new] = ACTIONS(1111),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1109),
    [anon_sym_PLUS] = ACTIONS(1111),
    [anon_sym_DASH] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1109),
    [anon_sym_TILDE] = ACTIONS(1109),
    [anon_sym_void] = ACTIONS(1111),
    [anon_sym_delete] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [sym_number] = ACTIONS(1109),
    [sym_this] = ACTIONS(1111),
    [sym_super] = ACTIONS(1111),
    [sym_true] = ACTIONS(1111),
    [sym_false] = ACTIONS(1111),
    [sym_null] = ACTIONS(1111),
    [sym_undefined] = ACTIONS(1111),
    [anon_sym_AT] = ACTIONS(1109),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_abstract] = ACTIONS(1111),
    [anon_sym_get] = ACTIONS(1111),
    [anon_sym_set] = ACTIONS(1111),
    [anon_sym_declare] = ACTIONS(1111),
    [anon_sym_public] = ACTIONS(1111),
    [anon_sym_private] = ACTIONS(1111),
    [anon_sym_protected] = ACTIONS(1111),
    [anon_sym_module] = ACTIONS(1111),
    [anon_sym_any] = ACTIONS(1111),
    [anon_sym_number] = ACTIONS(1111),
    [anon_sym_boolean] = ACTIONS(1111),
    [anon_sym_string] = ACTIONS(1111),
    [anon_sym_symbol] = ACTIONS(1111),
    [anon_sym_interface] = ACTIONS(1111),
    [anon_sym_enum] = ACTIONS(1111),
    [sym_readonly] = ACTIONS(1111),
  },
  [410] = {
    [ts_builtin_sym_end] = ACTIONS(2338),
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_export] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_EQ] = ACTIONS(2340),
    [anon_sym_namespace] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_COMMA] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_type] = ACTIONS(2340),
    [anon_sym_typeof] = ACTIONS(2340),
    [anon_sym_import] = ACTIONS(2340),
    [anon_sym_var] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_switch] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_RPAREN] = ACTIONS(2338),
    [anon_sym_await] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_debugger] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_throw] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2340),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_RBRACK] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2338),
    [anon_sym_GT] = ACTIONS(2338),
    [anon_sym_SLASH] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_EQ_GT] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_PIPE] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2338),
    [anon_sym_TILDE] = ACTIONS(2338),
    [anon_sym_void] = ACTIONS(2340),
    [anon_sym_delete] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2338),
    [anon_sym_DQUOTE] = ACTIONS(2338),
    [anon_sym_SQUOTE] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2338),
    [sym_number] = ACTIONS(2338),
    [sym_this] = ACTIONS(2340),
    [sym_super] = ACTIONS(2340),
    [sym_true] = ACTIONS(2340),
    [sym_false] = ACTIONS(2340),
    [sym_null] = ACTIONS(2340),
    [sym_undefined] = ACTIONS(2340),
    [anon_sym_AT] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_abstract] = ACTIONS(2340),
    [anon_sym_get] = ACTIONS(2340),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_declare] = ACTIONS(2340),
    [anon_sym_public] = ACTIONS(2340),
    [anon_sym_private] = ACTIONS(2340),
    [anon_sym_protected] = ACTIONS(2340),
    [anon_sym_module] = ACTIONS(2340),
    [anon_sym_any] = ACTIONS(2340),
    [anon_sym_number] = ACTIONS(2340),
    [anon_sym_boolean] = ACTIONS(2340),
    [anon_sym_string] = ACTIONS(2340),
    [anon_sym_symbol] = ACTIONS(2340),
    [anon_sym_implements] = ACTIONS(2340),
    [anon_sym_interface] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
    [sym_readonly] = ACTIONS(2340),
  },
  [411] = {
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym_identifier] = ACTIONS(2344),
    [anon_sym_export] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2344),
    [anon_sym_namespace] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_type] = ACTIONS(2344),
    [anon_sym_typeof] = ACTIONS(2344),
    [anon_sym_import] = ACTIONS(2344),
    [anon_sym_var] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_switch] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_await] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_do] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [anon_sym_with] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_debugger] = ACTIONS(2344),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_throw] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_RBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2342),
    [anon_sym_GT] = ACTIONS(2342),
    [anon_sym_SLASH] = ACTIONS(2344),
    [anon_sym_DOT] = ACTIONS(2346),
    [anon_sym_class] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_function] = ACTIONS(2344),
    [anon_sym_EQ_GT] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_PIPE] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_TILDE] = ACTIONS(2342),
    [anon_sym_void] = ACTIONS(2344),
    [anon_sym_delete] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [anon_sym_DQUOTE] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2344),
    [sym_super] = ACTIONS(2344),
    [sym_true] = ACTIONS(2344),
    [sym_false] = ACTIONS(2344),
    [sym_null] = ACTIONS(2344),
    [sym_undefined] = ACTIONS(2344),
    [anon_sym_AT] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_abstract] = ACTIONS(2344),
    [anon_sym_get] = ACTIONS(2344),
    [anon_sym_set] = ACTIONS(2344),
    [anon_sym_declare] = ACTIONS(2344),
    [anon_sym_public] = ACTIONS(2344),
    [anon_sym_private] = ACTIONS(2344),
    [anon_sym_protected] = ACTIONS(2344),
    [anon_sym_module] = ACTIONS(2344),
    [anon_sym_any] = ACTIONS(2344),
    [anon_sym_number] = ACTIONS(2344),
    [anon_sym_boolean] = ACTIONS(2344),
    [anon_sym_string] = ACTIONS(2344),
    [anon_sym_symbol] = ACTIONS(2344),
    [anon_sym_interface] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
    [sym_readonly] = ACTIONS(2344),
  },
  [412] = {
    [ts_builtin_sym_end] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(2350),
    [anon_sym_export] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2350),
    [anon_sym_EQ] = ACTIONS(2350),
    [anon_sym_namespace] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2348),
    [anon_sym_type] = ACTIONS(2350),
    [anon_sym_typeof] = ACTIONS(2350),
    [anon_sym_import] = ACTIONS(2350),
    [anon_sym_var] = ACTIONS(2350),
    [anon_sym_let] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2350),
    [anon_sym_switch] = ACTIONS(2350),
    [anon_sym_for] = ACTIONS(2350),
    [anon_sym_LPAREN] = ACTIONS(2348),
    [anon_sym_RPAREN] = ACTIONS(2348),
    [anon_sym_await] = ACTIONS(2350),
    [anon_sym_while] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2350),
    [anon_sym_try] = ACTIONS(2350),
    [anon_sym_with] = ACTIONS(2350),
    [anon_sym_break] = ACTIONS(2350),
    [anon_sym_continue] = ACTIONS(2350),
    [anon_sym_debugger] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2350),
    [anon_sym_throw] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym_case] = ACTIONS(2350),
    [anon_sym_yield] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_RBRACK] = ACTIONS(2348),
    [anon_sym_LT] = ACTIONS(2348),
    [anon_sym_GT] = ACTIONS(2348),
    [anon_sym_SLASH] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2350),
    [anon_sym_async] = ACTIONS(2350),
    [anon_sym_function] = ACTIONS(2350),
    [anon_sym_EQ_GT] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_BANG] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2348),
    [anon_sym_void] = ACTIONS(2350),
    [anon_sym_delete] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [anon_sym_DQUOTE] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2348),
    [sym_number] = ACTIONS(2348),
    [sym_this] = ACTIONS(2350),
    [sym_super] = ACTIONS(2350),
    [sym_true] = ACTIONS(2350),
    [sym_false] = ACTIONS(2350),
    [sym_null] = ACTIONS(2350),
    [sym_undefined] = ACTIONS(2350),
    [anon_sym_AT] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2350),
    [anon_sym_abstract] = ACTIONS(2350),
    [anon_sym_get] = ACTIONS(2350),
    [anon_sym_set] = ACTIONS(2350),
    [anon_sym_declare] = ACTIONS(2350),
    [anon_sym_public] = ACTIONS(2350),
    [anon_sym_private] = ACTIONS(2350),
    [anon_sym_protected] = ACTIONS(2350),
    [anon_sym_module] = ACTIONS(2350),
    [anon_sym_any] = ACTIONS(2350),
    [anon_sym_number] = ACTIONS(2350),
    [anon_sym_boolean] = ACTIONS(2350),
    [anon_sym_string] = ACTIONS(2350),
    [anon_sym_symbol] = ACTIONS(2350),
    [anon_sym_implements] = ACTIONS(2350),
    [anon_sym_interface] = ACTIONS(2350),
    [anon_sym_enum] = ACTIONS(2350),
    [sym_readonly] = ACTIONS(2350),
  },
  [413] = {
    [sym__call_signature] = STATE(2789),
    [sym_string] = STATE(2013),
    [sym_formal_parameters] = STATE(2379),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2352),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2370),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2378),
    [anon_sym_set] = ACTIONS(2378),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [sym_readonly] = ACTIONS(2354),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(2380),
    [sym_identifier] = ACTIONS(2382),
    [anon_sym_export] = ACTIONS(2382),
    [anon_sym_default] = ACTIONS(2382),
    [anon_sym_EQ] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_COMMA] = ACTIONS(2380),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_type] = ACTIONS(2382),
    [anon_sym_typeof] = ACTIONS(2382),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_var] = ACTIONS(2382),
    [anon_sym_let] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_else] = ACTIONS(2382),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_LPAREN] = ACTIONS(2380),
    [anon_sym_RPAREN] = ACTIONS(2380),
    [anon_sym_await] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_do] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [anon_sym_with] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_debugger] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_throw] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_yield] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2380),
    [anon_sym_RBRACK] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(2380),
    [anon_sym_GT] = ACTIONS(2380),
    [anon_sym_SLASH] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_async] = ACTIONS(2382),
    [anon_sym_function] = ACTIONS(2382),
    [anon_sym_EQ_GT] = ACTIONS(2380),
    [anon_sym_new] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2380),
    [anon_sym_PIPE] = ACTIONS(2380),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_void] = ACTIONS(2382),
    [anon_sym_delete] = ACTIONS(2382),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2380),
    [sym_number] = ACTIONS(2380),
    [sym_this] = ACTIONS(2382),
    [sym_super] = ACTIONS(2382),
    [sym_true] = ACTIONS(2382),
    [sym_false] = ACTIONS(2382),
    [sym_null] = ACTIONS(2382),
    [sym_undefined] = ACTIONS(2382),
    [anon_sym_AT] = ACTIONS(2380),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_get] = ACTIONS(2382),
    [anon_sym_set] = ACTIONS(2382),
    [anon_sym_declare] = ACTIONS(2382),
    [anon_sym_public] = ACTIONS(2382),
    [anon_sym_private] = ACTIONS(2382),
    [anon_sym_protected] = ACTIONS(2382),
    [anon_sym_module] = ACTIONS(2382),
    [anon_sym_any] = ACTIONS(2382),
    [anon_sym_number] = ACTIONS(2382),
    [anon_sym_boolean] = ACTIONS(2382),
    [anon_sym_string] = ACTIONS(2382),
    [anon_sym_symbol] = ACTIONS(2382),
    [anon_sym_implements] = ACTIONS(2382),
    [anon_sym_interface] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [sym_readonly] = ACTIONS(2382),
  },
  [415] = {
    [ts_builtin_sym_end] = ACTIONS(2384),
    [sym_identifier] = ACTIONS(2386),
    [anon_sym_export] = ACTIONS(2386),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_EQ] = ACTIONS(2386),
    [anon_sym_namespace] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_COMMA] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_type] = ACTIONS(2386),
    [anon_sym_typeof] = ACTIONS(2386),
    [anon_sym_import] = ACTIONS(2386),
    [anon_sym_var] = ACTIONS(2386),
    [anon_sym_let] = ACTIONS(2386),
    [anon_sym_const] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2386),
    [anon_sym_switch] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_RPAREN] = ACTIONS(2384),
    [anon_sym_await] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_do] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [anon_sym_with] = ACTIONS(2386),
    [anon_sym_break] = ACTIONS(2386),
    [anon_sym_continue] = ACTIONS(2386),
    [anon_sym_debugger] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_throw] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2386),
    [anon_sym_yield] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_RBRACK] = ACTIONS(2384),
    [anon_sym_LT] = ACTIONS(2384),
    [anon_sym_GT] = ACTIONS(2384),
    [anon_sym_SLASH] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2386),
    [anon_sym_async] = ACTIONS(2386),
    [anon_sym_function] = ACTIONS(2386),
    [anon_sym_EQ_GT] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_PIPE] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_void] = ACTIONS(2386),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [anon_sym_DQUOTE] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2384),
    [sym_number] = ACTIONS(2384),
    [sym_this] = ACTIONS(2386),
    [sym_super] = ACTIONS(2386),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [sym_null] = ACTIONS(2386),
    [sym_undefined] = ACTIONS(2386),
    [anon_sym_AT] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2386),
    [anon_sym_abstract] = ACTIONS(2386),
    [anon_sym_get] = ACTIONS(2386),
    [anon_sym_set] = ACTIONS(2386),
    [anon_sym_declare] = ACTIONS(2386),
    [anon_sym_public] = ACTIONS(2386),
    [anon_sym_private] = ACTIONS(2386),
    [anon_sym_protected] = ACTIONS(2386),
    [anon_sym_module] = ACTIONS(2386),
    [anon_sym_any] = ACTIONS(2386),
    [anon_sym_number] = ACTIONS(2386),
    [anon_sym_boolean] = ACTIONS(2386),
    [anon_sym_string] = ACTIONS(2386),
    [anon_sym_symbol] = ACTIONS(2386),
    [anon_sym_implements] = ACTIONS(2386),
    [anon_sym_interface] = ACTIONS(2386),
    [anon_sym_enum] = ACTIONS(2386),
    [sym_readonly] = ACTIONS(2386),
  },
  [416] = {
    [ts_builtin_sym_end] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(2390),
    [anon_sym_export] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_EQ] = ACTIONS(2390),
    [anon_sym_namespace] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_type] = ACTIONS(2390),
    [anon_sym_typeof] = ACTIONS(2390),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_var] = ACTIONS(2390),
    [anon_sym_let] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_switch] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(2388),
    [anon_sym_await] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_do] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_debugger] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_throw] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_case] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_RBRACK] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_SLASH] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_function] = ACTIONS(2390),
    [anon_sym_EQ_GT] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_void] = ACTIONS(2390),
    [anon_sym_delete] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_DQUOTE] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [sym_number] = ACTIONS(2388),
    [sym_this] = ACTIONS(2390),
    [sym_super] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_null] = ACTIONS(2390),
    [sym_undefined] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_abstract] = ACTIONS(2390),
    [anon_sym_get] = ACTIONS(2390),
    [anon_sym_set] = ACTIONS(2390),
    [anon_sym_declare] = ACTIONS(2390),
    [anon_sym_public] = ACTIONS(2390),
    [anon_sym_private] = ACTIONS(2390),
    [anon_sym_protected] = ACTIONS(2390),
    [anon_sym_module] = ACTIONS(2390),
    [anon_sym_any] = ACTIONS(2390),
    [anon_sym_number] = ACTIONS(2390),
    [anon_sym_boolean] = ACTIONS(2390),
    [anon_sym_string] = ACTIONS(2390),
    [anon_sym_symbol] = ACTIONS(2390),
    [anon_sym_implements] = ACTIONS(2390),
    [anon_sym_interface] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
    [sym_readonly] = ACTIONS(2390),
  },
  [417] = {
    [ts_builtin_sym_end] = ACTIONS(2392),
    [sym_identifier] = ACTIONS(2394),
    [anon_sym_export] = ACTIONS(2394),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_EQ] = ACTIONS(2394),
    [anon_sym_namespace] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_type] = ACTIONS(2394),
    [anon_sym_typeof] = ACTIONS(2394),
    [anon_sym_import] = ACTIONS(2394),
    [anon_sym_var] = ACTIONS(2394),
    [anon_sym_let] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2394),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_RPAREN] = ACTIONS(2392),
    [anon_sym_await] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_do] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [anon_sym_with] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_debugger] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_throw] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_case] = ACTIONS(2394),
    [anon_sym_yield] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_RBRACK] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2392),
    [anon_sym_GT] = ACTIONS(2392),
    [anon_sym_SLASH] = ACTIONS(2394),
    [anon_sym_DOT] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2394),
    [anon_sym_async] = ACTIONS(2394),
    [anon_sym_function] = ACTIONS(2394),
    [anon_sym_EQ_GT] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_void] = ACTIONS(2394),
    [anon_sym_delete] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [sym_number] = ACTIONS(2392),
    [sym_this] = ACTIONS(2394),
    [sym_super] = ACTIONS(2394),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [sym_null] = ACTIONS(2394),
    [sym_undefined] = ACTIONS(2394),
    [anon_sym_AT] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_abstract] = ACTIONS(2394),
    [anon_sym_get] = ACTIONS(2394),
    [anon_sym_set] = ACTIONS(2394),
    [anon_sym_declare] = ACTIONS(2394),
    [anon_sym_public] = ACTIONS(2394),
    [anon_sym_private] = ACTIONS(2394),
    [anon_sym_protected] = ACTIONS(2394),
    [anon_sym_module] = ACTIONS(2394),
    [anon_sym_any] = ACTIONS(2394),
    [anon_sym_number] = ACTIONS(2394),
    [anon_sym_boolean] = ACTIONS(2394),
    [anon_sym_string] = ACTIONS(2394),
    [anon_sym_symbol] = ACTIONS(2394),
    [anon_sym_interface] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
    [sym_readonly] = ACTIONS(2394),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(2398),
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_export] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_EQ] = ACTIONS(2400),
    [anon_sym_namespace] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_typeof] = ACTIONS(2400),
    [anon_sym_import] = ACTIONS(2400),
    [anon_sym_var] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_else] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_RPAREN] = ACTIONS(2398),
    [anon_sym_await] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [anon_sym_do] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2400),
    [anon_sym_with] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_debugger] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_throw] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2400),
    [anon_sym_yield] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_RBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_GT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_class] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_function] = ACTIONS(2400),
    [anon_sym_EQ_GT] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2398),
    [anon_sym_void] = ACTIONS(2400),
    [anon_sym_delete] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [anon_sym_DQUOTE] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [sym_number] = ACTIONS(2398),
    [sym_this] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_true] = ACTIONS(2400),
    [sym_false] = ACTIONS(2400),
    [sym_null] = ACTIONS(2400),
    [sym_undefined] = ACTIONS(2400),
    [anon_sym_AT] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_abstract] = ACTIONS(2400),
    [anon_sym_get] = ACTIONS(2400),
    [anon_sym_set] = ACTIONS(2400),
    [anon_sym_declare] = ACTIONS(2400),
    [anon_sym_public] = ACTIONS(2400),
    [anon_sym_private] = ACTIONS(2400),
    [anon_sym_protected] = ACTIONS(2400),
    [anon_sym_module] = ACTIONS(2400),
    [anon_sym_any] = ACTIONS(2400),
    [anon_sym_number] = ACTIONS(2400),
    [anon_sym_boolean] = ACTIONS(2400),
    [anon_sym_string] = ACTIONS(2400),
    [anon_sym_symbol] = ACTIONS(2400),
    [anon_sym_implements] = ACTIONS(2400),
    [anon_sym_interface] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [sym_readonly] = ACTIONS(2400),
  },
  [419] = {
    [sym__call_signature] = STATE(2789),
    [sym_string] = STATE(2013),
    [sym_formal_parameters] = STATE(2379),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2352),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2370),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2378),
    [anon_sym_set] = ACTIONS(2378),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [sym_readonly] = ACTIONS(2354),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [sym_identifier] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_default] = ACTIONS(1235),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_namespace] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_type] = ACTIONS(1235),
    [anon_sym_typeof] = ACTIONS(1235),
    [anon_sym_import] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_let] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_await] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_do] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1235),
    [anon_sym_with] = ACTIONS(1235),
    [anon_sym_break] = ACTIONS(1235),
    [anon_sym_continue] = ACTIONS(1235),
    [anon_sym_debugger] = ACTIONS(1235),
    [anon_sym_return] = ACTIONS(1235),
    [anon_sym_throw] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_case] = ACTIONS(1235),
    [anon_sym_yield] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1233),
    [anon_sym_GT] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_class] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_function] = ACTIONS(1235),
    [anon_sym_EQ_GT] = ACTIONS(1233),
    [anon_sym_new] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1233),
    [anon_sym_TILDE] = ACTIONS(1233),
    [anon_sym_void] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym_number] = ACTIONS(1233),
    [sym_this] = ACTIONS(1235),
    [sym_super] = ACTIONS(1235),
    [sym_true] = ACTIONS(1235),
    [sym_false] = ACTIONS(1235),
    [sym_null] = ACTIONS(1235),
    [sym_undefined] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(1235),
    [anon_sym_set] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1235),
    [anon_sym_public] = ACTIONS(1235),
    [anon_sym_private] = ACTIONS(1235),
    [anon_sym_protected] = ACTIONS(1235),
    [anon_sym_module] = ACTIONS(1235),
    [anon_sym_any] = ACTIONS(1235),
    [anon_sym_number] = ACTIONS(1235),
    [anon_sym_boolean] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(1235),
    [anon_sym_symbol] = ACTIONS(1235),
    [anon_sym_interface] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [sym_readonly] = ACTIONS(1235),
  },
  [421] = {
    [sym__call_signature] = STATE(2789),
    [sym_string] = STATE(2013),
    [sym_formal_parameters] = STATE(2379),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [sym_type_parameters] = STATE(2654),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2352),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2359),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2370),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2378),
    [anon_sym_set] = ACTIONS(2378),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [sym_readonly] = ACTIONS(2354),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(2402),
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_EQ] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_typeof] = ACTIONS(2404),
    [anon_sym_import] = ACTIONS(2404),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2402),
    [anon_sym_await] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_with] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_debugger] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_yield] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_RBRACK] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_GT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2404),
    [anon_sym_EQ_GT] = ACTIONS(2402),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2402),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [sym_number] = ACTIONS(2402),
    [sym_this] = ACTIONS(2404),
    [sym_super] = ACTIONS(2404),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [sym_null] = ACTIONS(2404),
    [sym_undefined] = ACTIONS(2404),
    [anon_sym_AT] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_abstract] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2404),
    [anon_sym_set] = ACTIONS(2404),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [sym_readonly] = ACTIONS(2404),
  },
  [423] = {
    [ts_builtin_sym_end] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(2408),
    [anon_sym_export] = ACTIONS(2408),
    [anon_sym_default] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_namespace] = ACTIONS(2408),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_typeof] = ACTIONS(2408),
    [anon_sym_import] = ACTIONS(2408),
    [anon_sym_var] = ACTIONS(2408),
    [anon_sym_let] = ACTIONS(2408),
    [anon_sym_const] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2408),
    [anon_sym_else] = ACTIONS(2408),
    [anon_sym_switch] = ACTIONS(2408),
    [anon_sym_for] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_await] = ACTIONS(2408),
    [anon_sym_while] = ACTIONS(2408),
    [anon_sym_do] = ACTIONS(2408),
    [anon_sym_try] = ACTIONS(2408),
    [anon_sym_with] = ACTIONS(2408),
    [anon_sym_break] = ACTIONS(2408),
    [anon_sym_continue] = ACTIONS(2408),
    [anon_sym_debugger] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2408),
    [anon_sym_throw] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_case] = ACTIONS(2408),
    [anon_sym_yield] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_RBRACK] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2408),
    [anon_sym_class] = ACTIONS(2408),
    [anon_sym_async] = ACTIONS(2408),
    [anon_sym_function] = ACTIONS(2408),
    [anon_sym_EQ_GT] = ACTIONS(2406),
    [anon_sym_new] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_void] = ACTIONS(2408),
    [anon_sym_delete] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [sym_number] = ACTIONS(2406),
    [sym_this] = ACTIONS(2408),
    [sym_super] = ACTIONS(2408),
    [sym_true] = ACTIONS(2408),
    [sym_false] = ACTIONS(2408),
    [sym_null] = ACTIONS(2408),
    [sym_undefined] = ACTIONS(2408),
    [anon_sym_AT] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2408),
    [anon_sym_abstract] = ACTIONS(2408),
    [anon_sym_get] = ACTIONS(2408),
    [anon_sym_set] = ACTIONS(2408),
    [anon_sym_declare] = ACTIONS(2408),
    [anon_sym_public] = ACTIONS(2408),
    [anon_sym_private] = ACTIONS(2408),
    [anon_sym_protected] = ACTIONS(2408),
    [anon_sym_module] = ACTIONS(2408),
    [anon_sym_any] = ACTIONS(2408),
    [anon_sym_number] = ACTIONS(2408),
    [anon_sym_boolean] = ACTIONS(2408),
    [anon_sym_string] = ACTIONS(2408),
    [anon_sym_symbol] = ACTIONS(2408),
    [anon_sym_interface] = ACTIONS(2408),
    [anon_sym_enum] = ACTIONS(2408),
    [sym_readonly] = ACTIONS(2408),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_EQ] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_type] = ACTIONS(2414),
    [anon_sym_typeof] = ACTIONS(2414),
    [anon_sym_import] = ACTIONS(2414),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_await] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_with] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_debugger] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_yield] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_RBRACK] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2412),
    [anon_sym_GT] = ACTIONS(2412),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_async] = ACTIONS(2414),
    [anon_sym_function] = ACTIONS(2414),
    [anon_sym_EQ_GT] = ACTIONS(2412),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_void] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [sym_number] = ACTIONS(2412),
    [sym_this] = ACTIONS(2414),
    [sym_super] = ACTIONS(2414),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [sym_null] = ACTIONS(2414),
    [sym_undefined] = ACTIONS(2414),
    [anon_sym_AT] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_abstract] = ACTIONS(2414),
    [anon_sym_get] = ACTIONS(2414),
    [anon_sym_set] = ACTIONS(2414),
    [anon_sym_declare] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_module] = ACTIONS(2414),
    [anon_sym_any] = ACTIONS(2414),
    [anon_sym_number] = ACTIONS(2414),
    [anon_sym_boolean] = ACTIONS(2414),
    [anon_sym_string] = ACTIONS(2414),
    [anon_sym_symbol] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [sym_readonly] = ACTIONS(2414),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_export] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_EQ] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_type] = ACTIONS(2418),
    [anon_sym_typeof] = ACTIONS(2418),
    [anon_sym_import] = ACTIONS(2418),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [anon_sym_await] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_debugger] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_RBRACK] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2416),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_async] = ACTIONS(2418),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_EQ_GT] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_void] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [sym_number] = ACTIONS(2416),
    [sym_this] = ACTIONS(2418),
    [sym_super] = ACTIONS(2418),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [sym_null] = ACTIONS(2418),
    [sym_undefined] = ACTIONS(2418),
    [anon_sym_AT] = ACTIONS(2416),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_abstract] = ACTIONS(2418),
    [anon_sym_get] = ACTIONS(2418),
    [anon_sym_set] = ACTIONS(2418),
    [anon_sym_declare] = ACTIONS(2418),
    [anon_sym_public] = ACTIONS(2418),
    [anon_sym_private] = ACTIONS(2418),
    [anon_sym_protected] = ACTIONS(2418),
    [anon_sym_module] = ACTIONS(2418),
    [anon_sym_any] = ACTIONS(2418),
    [anon_sym_number] = ACTIONS(2418),
    [anon_sym_boolean] = ACTIONS(2418),
    [anon_sym_string] = ACTIONS(2418),
    [anon_sym_symbol] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [sym_readonly] = ACTIONS(2418),
  },
  [426] = {
    [ts_builtin_sym_end] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_export] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_type] = ACTIONS(2422),
    [anon_sym_typeof] = ACTIONS(2422),
    [anon_sym_import] = ACTIONS(2422),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_await] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_with] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_debugger] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2420),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_async] = ACTIONS(2422),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_EQ_GT] = ACTIONS(2420),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [sym_number] = ACTIONS(2420),
    [sym_this] = ACTIONS(2422),
    [sym_super] = ACTIONS(2422),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [sym_null] = ACTIONS(2422),
    [sym_undefined] = ACTIONS(2422),
    [anon_sym_AT] = ACTIONS(2420),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_abstract] = ACTIONS(2422),
    [anon_sym_get] = ACTIONS(2422),
    [anon_sym_set] = ACTIONS(2422),
    [anon_sym_declare] = ACTIONS(2422),
    [anon_sym_public] = ACTIONS(2422),
    [anon_sym_private] = ACTIONS(2422),
    [anon_sym_protected] = ACTIONS(2422),
    [anon_sym_module] = ACTIONS(2422),
    [anon_sym_any] = ACTIONS(2422),
    [anon_sym_number] = ACTIONS(2422),
    [anon_sym_boolean] = ACTIONS(2422),
    [anon_sym_string] = ACTIONS(2422),
    [anon_sym_symbol] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [sym_readonly] = ACTIONS(2422),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(2424),
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_export] = ACTIONS(2426),
    [anon_sym_default] = ACTIONS(2426),
    [anon_sym_EQ] = ACTIONS(2426),
    [anon_sym_namespace] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_type] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(2426),
    [anon_sym_import] = ACTIONS(2426),
    [anon_sym_var] = ACTIONS(2426),
    [anon_sym_let] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2426),
    [anon_sym_switch] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_await] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_with] = ACTIONS(2426),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2426),
    [anon_sym_debugger] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_throw] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_case] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2424),
    [anon_sym_GT] = ACTIONS(2424),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_function] = ACTIONS(2426),
    [anon_sym_EQ_GT] = ACTIONS(2424),
    [anon_sym_new] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2424),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_void] = ACTIONS(2426),
    [anon_sym_delete] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [sym_number] = ACTIONS(2424),
    [sym_this] = ACTIONS(2426),
    [sym_super] = ACTIONS(2426),
    [sym_true] = ACTIONS(2426),
    [sym_false] = ACTIONS(2426),
    [sym_null] = ACTIONS(2426),
    [sym_undefined] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2424),
    [anon_sym_static] = ACTIONS(2426),
    [anon_sym_abstract] = ACTIONS(2426),
    [anon_sym_get] = ACTIONS(2426),
    [anon_sym_set] = ACTIONS(2426),
    [anon_sym_declare] = ACTIONS(2426),
    [anon_sym_public] = ACTIONS(2426),
    [anon_sym_private] = ACTIONS(2426),
    [anon_sym_protected] = ACTIONS(2426),
    [anon_sym_module] = ACTIONS(2426),
    [anon_sym_any] = ACTIONS(2426),
    [anon_sym_number] = ACTIONS(2426),
    [anon_sym_boolean] = ACTIONS(2426),
    [anon_sym_string] = ACTIONS(2426),
    [anon_sym_symbol] = ACTIONS(2426),
    [anon_sym_interface] = ACTIONS(2426),
    [anon_sym_enum] = ACTIONS(2426),
    [sym_readonly] = ACTIONS(2426),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym_identifier] = ACTIONS(2430),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_default] = ACTIONS(2430),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_typeof] = ACTIONS(2430),
    [anon_sym_import] = ACTIONS(2430),
    [anon_sym_var] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_if] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2430),
    [anon_sym_switch] = ACTIONS(2430),
    [anon_sym_for] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_await] = ACTIONS(2430),
    [anon_sym_while] = ACTIONS(2430),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2430),
    [anon_sym_with] = ACTIONS(2430),
    [anon_sym_break] = ACTIONS(2430),
    [anon_sym_continue] = ACTIONS(2430),
    [anon_sym_debugger] = ACTIONS(2430),
    [anon_sym_return] = ACTIONS(2430),
    [anon_sym_throw] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_case] = ACTIONS(2430),
    [anon_sym_yield] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2428),
    [anon_sym_GT] = ACTIONS(2428),
    [anon_sym_SLASH] = ACTIONS(2430),
    [anon_sym_class] = ACTIONS(2430),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2430),
    [anon_sym_EQ_GT] = ACTIONS(2428),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2428),
    [anon_sym_void] = ACTIONS(2430),
    [anon_sym_delete] = ACTIONS(2430),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_DQUOTE] = ACTIONS(2428),
    [anon_sym_SQUOTE] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [sym_number] = ACTIONS(2428),
    [sym_this] = ACTIONS(2430),
    [sym_super] = ACTIONS(2430),
    [sym_true] = ACTIONS(2430),
    [sym_false] = ACTIONS(2430),
    [sym_null] = ACTIONS(2430),
    [sym_undefined] = ACTIONS(2430),
    [anon_sym_AT] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_abstract] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_interface] = ACTIONS(2430),
    [anon_sym_enum] = ACTIONS(2430),
    [sym_readonly] = ACTIONS(2430),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(2432),
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_export] = ACTIONS(2434),
    [anon_sym_default] = ACTIONS(2434),
    [anon_sym_EQ] = ACTIONS(2434),
    [anon_sym_namespace] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_type] = ACTIONS(2434),
    [anon_sym_typeof] = ACTIONS(2434),
    [anon_sym_import] = ACTIONS(2434),
    [anon_sym_var] = ACTIONS(2434),
    [anon_sym_let] = ACTIONS(2434),
    [anon_sym_const] = ACTIONS(2434),
    [anon_sym_if] = ACTIONS(2434),
    [anon_sym_else] = ACTIONS(2434),
    [anon_sym_switch] = ACTIONS(2434),
    [anon_sym_for] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_await] = ACTIONS(2434),
    [anon_sym_while] = ACTIONS(2434),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_try] = ACTIONS(2434),
    [anon_sym_with] = ACTIONS(2434),
    [anon_sym_break] = ACTIONS(2434),
    [anon_sym_continue] = ACTIONS(2434),
    [anon_sym_debugger] = ACTIONS(2434),
    [anon_sym_return] = ACTIONS(2434),
    [anon_sym_throw] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_case] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2432),
    [anon_sym_SLASH] = ACTIONS(2434),
    [anon_sym_class] = ACTIONS(2434),
    [anon_sym_async] = ACTIONS(2434),
    [anon_sym_function] = ACTIONS(2434),
    [anon_sym_EQ_GT] = ACTIONS(2432),
    [anon_sym_new] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_TILDE] = ACTIONS(2432),
    [anon_sym_void] = ACTIONS(2434),
    [anon_sym_delete] = ACTIONS(2434),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2432),
    [anon_sym_SQUOTE] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2432),
    [sym_number] = ACTIONS(2432),
    [sym_this] = ACTIONS(2434),
    [sym_super] = ACTIONS(2434),
    [sym_true] = ACTIONS(2434),
    [sym_false] = ACTIONS(2434),
    [sym_null] = ACTIONS(2434),
    [sym_undefined] = ACTIONS(2434),
    [anon_sym_AT] = ACTIONS(2432),
    [anon_sym_static] = ACTIONS(2434),
    [anon_sym_abstract] = ACTIONS(2434),
    [anon_sym_get] = ACTIONS(2434),
    [anon_sym_set] = ACTIONS(2434),
    [anon_sym_declare] = ACTIONS(2434),
    [anon_sym_public] = ACTIONS(2434),
    [anon_sym_private] = ACTIONS(2434),
    [anon_sym_protected] = ACTIONS(2434),
    [anon_sym_module] = ACTIONS(2434),
    [anon_sym_any] = ACTIONS(2434),
    [anon_sym_number] = ACTIONS(2434),
    [anon_sym_boolean] = ACTIONS(2434),
    [anon_sym_string] = ACTIONS(2434),
    [anon_sym_symbol] = ACTIONS(2434),
    [anon_sym_interface] = ACTIONS(2434),
    [anon_sym_enum] = ACTIONS(2434),
    [sym_readonly] = ACTIONS(2434),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(2436),
    [sym_identifier] = ACTIONS(2438),
    [anon_sym_export] = ACTIONS(2438),
    [anon_sym_default] = ACTIONS(2438),
    [anon_sym_EQ] = ACTIONS(2438),
    [anon_sym_namespace] = ACTIONS(2438),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_type] = ACTIONS(2438),
    [anon_sym_typeof] = ACTIONS(2438),
    [anon_sym_import] = ACTIONS(2438),
    [anon_sym_var] = ACTIONS(2438),
    [anon_sym_let] = ACTIONS(2438),
    [anon_sym_const] = ACTIONS(2438),
    [anon_sym_if] = ACTIONS(2438),
    [anon_sym_else] = ACTIONS(2438),
    [anon_sym_switch] = ACTIONS(2438),
    [anon_sym_for] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_await] = ACTIONS(2438),
    [anon_sym_while] = ACTIONS(2438),
    [anon_sym_do] = ACTIONS(2438),
    [anon_sym_try] = ACTIONS(2438),
    [anon_sym_with] = ACTIONS(2438),
    [anon_sym_break] = ACTIONS(2438),
    [anon_sym_continue] = ACTIONS(2438),
    [anon_sym_debugger] = ACTIONS(2438),
    [anon_sym_return] = ACTIONS(2438),
    [anon_sym_throw] = ACTIONS(2438),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_case] = ACTIONS(2438),
    [anon_sym_yield] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_RBRACK] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2436),
    [anon_sym_SLASH] = ACTIONS(2438),
    [anon_sym_class] = ACTIONS(2438),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_function] = ACTIONS(2438),
    [anon_sym_EQ_GT] = ACTIONS(2436),
    [anon_sym_new] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_TILDE] = ACTIONS(2436),
    [anon_sym_void] = ACTIONS(2438),
    [anon_sym_delete] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [anon_sym_DQUOTE] = ACTIONS(2436),
    [anon_sym_SQUOTE] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2436),
    [sym_number] = ACTIONS(2436),
    [sym_this] = ACTIONS(2438),
    [sym_super] = ACTIONS(2438),
    [sym_true] = ACTIONS(2438),
    [sym_false] = ACTIONS(2438),
    [sym_null] = ACTIONS(2438),
    [sym_undefined] = ACTIONS(2438),
    [anon_sym_AT] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2438),
    [anon_sym_abstract] = ACTIONS(2438),
    [anon_sym_get] = ACTIONS(2438),
    [anon_sym_set] = ACTIONS(2438),
    [anon_sym_declare] = ACTIONS(2438),
    [anon_sym_public] = ACTIONS(2438),
    [anon_sym_private] = ACTIONS(2438),
    [anon_sym_protected] = ACTIONS(2438),
    [anon_sym_module] = ACTIONS(2438),
    [anon_sym_any] = ACTIONS(2438),
    [anon_sym_number] = ACTIONS(2438),
    [anon_sym_boolean] = ACTIONS(2438),
    [anon_sym_string] = ACTIONS(2438),
    [anon_sym_symbol] = ACTIONS(2438),
    [anon_sym_interface] = ACTIONS(2438),
    [anon_sym_enum] = ACTIONS(2438),
    [sym_readonly] = ACTIONS(2438),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(589),
    [sym_identifier] = ACTIONS(2440),
    [anon_sym_export] = ACTIONS(2440),
    [anon_sym_default] = ACTIONS(2440),
    [anon_sym_EQ] = ACTIONS(2440),
    [anon_sym_namespace] = ACTIONS(2440),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_type] = ACTIONS(2440),
    [anon_sym_typeof] = ACTIONS(2440),
    [anon_sym_import] = ACTIONS(2440),
    [anon_sym_var] = ACTIONS(2440),
    [anon_sym_let] = ACTIONS(2440),
    [anon_sym_const] = ACTIONS(2440),
    [anon_sym_if] = ACTIONS(2440),
    [anon_sym_else] = ACTIONS(2440),
    [anon_sym_switch] = ACTIONS(2440),
    [anon_sym_for] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_await] = ACTIONS(2440),
    [anon_sym_while] = ACTIONS(2440),
    [anon_sym_do] = ACTIONS(2440),
    [anon_sym_try] = ACTIONS(2440),
    [anon_sym_with] = ACTIONS(2440),
    [anon_sym_break] = ACTIONS(2440),
    [anon_sym_continue] = ACTIONS(2440),
    [anon_sym_debugger] = ACTIONS(2440),
    [anon_sym_return] = ACTIONS(2440),
    [anon_sym_throw] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_case] = ACTIONS(2440),
    [anon_sym_yield] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_RBRACK] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(589),
    [anon_sym_GT] = ACTIONS(589),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_class] = ACTIONS(2440),
    [anon_sym_async] = ACTIONS(2440),
    [anon_sym_function] = ACTIONS(2440),
    [anon_sym_EQ_GT] = ACTIONS(589),
    [anon_sym_new] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(589),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [anon_sym_void] = ACTIONS(2440),
    [anon_sym_delete] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [anon_sym_DQUOTE] = ACTIONS(589),
    [anon_sym_SQUOTE] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(589),
    [sym_number] = ACTIONS(589),
    [sym_this] = ACTIONS(2440),
    [sym_super] = ACTIONS(2440),
    [sym_true] = ACTIONS(2440),
    [sym_false] = ACTIONS(2440),
    [sym_null] = ACTIONS(2440),
    [sym_undefined] = ACTIONS(2440),
    [anon_sym_AT] = ACTIONS(589),
    [anon_sym_static] = ACTIONS(2440),
    [anon_sym_abstract] = ACTIONS(2440),
    [anon_sym_get] = ACTIONS(2440),
    [anon_sym_set] = ACTIONS(2440),
    [anon_sym_declare] = ACTIONS(2440),
    [anon_sym_public] = ACTIONS(2440),
    [anon_sym_private] = ACTIONS(2440),
    [anon_sym_protected] = ACTIONS(2440),
    [anon_sym_module] = ACTIONS(2440),
    [anon_sym_any] = ACTIONS(2440),
    [anon_sym_number] = ACTIONS(2440),
    [anon_sym_boolean] = ACTIONS(2440),
    [anon_sym_string] = ACTIONS(2440),
    [anon_sym_symbol] = ACTIONS(2440),
    [anon_sym_interface] = ACTIONS(2440),
    [anon_sym_enum] = ACTIONS(2440),
    [sym_readonly] = ACTIONS(2440),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(2442),
    [sym_identifier] = ACTIONS(2444),
    [anon_sym_export] = ACTIONS(2444),
    [anon_sym_default] = ACTIONS(2444),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_namespace] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_type] = ACTIONS(2444),
    [anon_sym_typeof] = ACTIONS(2444),
    [anon_sym_import] = ACTIONS(2444),
    [anon_sym_var] = ACTIONS(2444),
    [anon_sym_let] = ACTIONS(2444),
    [anon_sym_const] = ACTIONS(2444),
    [anon_sym_if] = ACTIONS(2444),
    [anon_sym_else] = ACTIONS(2444),
    [anon_sym_switch] = ACTIONS(2444),
    [anon_sym_for] = ACTIONS(2444),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_await] = ACTIONS(2444),
    [anon_sym_while] = ACTIONS(2444),
    [anon_sym_do] = ACTIONS(2444),
    [anon_sym_try] = ACTIONS(2444),
    [anon_sym_with] = ACTIONS(2444),
    [anon_sym_break] = ACTIONS(2444),
    [anon_sym_continue] = ACTIONS(2444),
    [anon_sym_debugger] = ACTIONS(2444),
    [anon_sym_return] = ACTIONS(2444),
    [anon_sym_throw] = ACTIONS(2444),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_case] = ACTIONS(2444),
    [anon_sym_yield] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_RBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_GT] = ACTIONS(2442),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_class] = ACTIONS(2444),
    [anon_sym_async] = ACTIONS(2444),
    [anon_sym_function] = ACTIONS(2444),
    [anon_sym_EQ_GT] = ACTIONS(2442),
    [anon_sym_new] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_BANG] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2442),
    [anon_sym_void] = ACTIONS(2444),
    [anon_sym_delete] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_SQUOTE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [sym_number] = ACTIONS(2442),
    [sym_this] = ACTIONS(2444),
    [sym_super] = ACTIONS(2444),
    [sym_true] = ACTIONS(2444),
    [sym_false] = ACTIONS(2444),
    [sym_null] = ACTIONS(2444),
    [sym_undefined] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2442),
    [anon_sym_static] = ACTIONS(2444),
    [anon_sym_abstract] = ACTIONS(2444),
    [anon_sym_get] = ACTIONS(2444),
    [anon_sym_set] = ACTIONS(2444),
    [anon_sym_declare] = ACTIONS(2444),
    [anon_sym_public] = ACTIONS(2444),
    [anon_sym_private] = ACTIONS(2444),
    [anon_sym_protected] = ACTIONS(2444),
    [anon_sym_module] = ACTIONS(2444),
    [anon_sym_any] = ACTIONS(2444),
    [anon_sym_number] = ACTIONS(2444),
    [anon_sym_boolean] = ACTIONS(2444),
    [anon_sym_string] = ACTIONS(2444),
    [anon_sym_symbol] = ACTIONS(2444),
    [anon_sym_interface] = ACTIONS(2444),
    [anon_sym_enum] = ACTIONS(2444),
    [sym_readonly] = ACTIONS(2444),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(2446),
    [sym_identifier] = ACTIONS(2448),
    [anon_sym_export] = ACTIONS(2448),
    [anon_sym_default] = ACTIONS(2448),
    [anon_sym_EQ] = ACTIONS(2448),
    [anon_sym_namespace] = ACTIONS(2448),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_type] = ACTIONS(2448),
    [anon_sym_typeof] = ACTIONS(2448),
    [anon_sym_import] = ACTIONS(2448),
    [anon_sym_var] = ACTIONS(2448),
    [anon_sym_let] = ACTIONS(2448),
    [anon_sym_const] = ACTIONS(2448),
    [anon_sym_if] = ACTIONS(2448),
    [anon_sym_else] = ACTIONS(2448),
    [anon_sym_switch] = ACTIONS(2448),
    [anon_sym_for] = ACTIONS(2448),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_RPAREN] = ACTIONS(2446),
    [anon_sym_await] = ACTIONS(2448),
    [anon_sym_while] = ACTIONS(2448),
    [anon_sym_do] = ACTIONS(2448),
    [anon_sym_try] = ACTIONS(2448),
    [anon_sym_with] = ACTIONS(2448),
    [anon_sym_break] = ACTIONS(2448),
    [anon_sym_continue] = ACTIONS(2448),
    [anon_sym_debugger] = ACTIONS(2448),
    [anon_sym_return] = ACTIONS(2448),
    [anon_sym_throw] = ACTIONS(2448),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_case] = ACTIONS(2448),
    [anon_sym_yield] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_RBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2448),
    [anon_sym_class] = ACTIONS(2448),
    [anon_sym_async] = ACTIONS(2448),
    [anon_sym_function] = ACTIONS(2448),
    [anon_sym_EQ_GT] = ACTIONS(2446),
    [anon_sym_new] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_BANG] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2446),
    [anon_sym_void] = ACTIONS(2448),
    [anon_sym_delete] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [anon_sym_DQUOTE] = ACTIONS(2446),
    [anon_sym_SQUOTE] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [sym_number] = ACTIONS(2446),
    [sym_this] = ACTIONS(2448),
    [sym_super] = ACTIONS(2448),
    [sym_true] = ACTIONS(2448),
    [sym_false] = ACTIONS(2448),
    [sym_null] = ACTIONS(2448),
    [sym_undefined] = ACTIONS(2448),
    [anon_sym_AT] = ACTIONS(2446),
    [anon_sym_static] = ACTIONS(2448),
    [anon_sym_abstract] = ACTIONS(2448),
    [anon_sym_get] = ACTIONS(2448),
    [anon_sym_set] = ACTIONS(2448),
    [anon_sym_declare] = ACTIONS(2448),
    [anon_sym_public] = ACTIONS(2448),
    [anon_sym_private] = ACTIONS(2448),
    [anon_sym_protected] = ACTIONS(2448),
    [anon_sym_module] = ACTIONS(2448),
    [anon_sym_any] = ACTIONS(2448),
    [anon_sym_number] = ACTIONS(2448),
    [anon_sym_boolean] = ACTIONS(2448),
    [anon_sym_string] = ACTIONS(2448),
    [anon_sym_symbol] = ACTIONS(2448),
    [anon_sym_interface] = ACTIONS(2448),
    [anon_sym_enum] = ACTIONS(2448),
    [sym_readonly] = ACTIONS(2448),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(2450),
    [sym_identifier] = ACTIONS(2452),
    [anon_sym_export] = ACTIONS(2452),
    [anon_sym_default] = ACTIONS(2452),
    [anon_sym_EQ] = ACTIONS(2452),
    [anon_sym_namespace] = ACTIONS(2452),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_type] = ACTIONS(2452),
    [anon_sym_typeof] = ACTIONS(2452),
    [anon_sym_import] = ACTIONS(2452),
    [anon_sym_var] = ACTIONS(2452),
    [anon_sym_let] = ACTIONS(2452),
    [anon_sym_const] = ACTIONS(2452),
    [anon_sym_if] = ACTIONS(2452),
    [anon_sym_else] = ACTIONS(2452),
    [anon_sym_switch] = ACTIONS(2452),
    [anon_sym_for] = ACTIONS(2452),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_RPAREN] = ACTIONS(2450),
    [anon_sym_await] = ACTIONS(2452),
    [anon_sym_while] = ACTIONS(2452),
    [anon_sym_do] = ACTIONS(2452),
    [anon_sym_try] = ACTIONS(2452),
    [anon_sym_with] = ACTIONS(2452),
    [anon_sym_break] = ACTIONS(2452),
    [anon_sym_continue] = ACTIONS(2452),
    [anon_sym_debugger] = ACTIONS(2452),
    [anon_sym_return] = ACTIONS(2452),
    [anon_sym_throw] = ACTIONS(2452),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_case] = ACTIONS(2452),
    [anon_sym_yield] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_RBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_GT] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_class] = ACTIONS(2452),
    [anon_sym_async] = ACTIONS(2452),
    [anon_sym_function] = ACTIONS(2452),
    [anon_sym_EQ_GT] = ACTIONS(2450),
    [anon_sym_new] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_void] = ACTIONS(2452),
    [anon_sym_delete] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2450),
    [anon_sym_DASH_DASH] = ACTIONS(2450),
    [anon_sym_DQUOTE] = ACTIONS(2450),
    [anon_sym_SQUOTE] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [sym_number] = ACTIONS(2450),
    [sym_this] = ACTIONS(2452),
    [sym_super] = ACTIONS(2452),
    [sym_true] = ACTIONS(2452),
    [sym_false] = ACTIONS(2452),
    [sym_null] = ACTIONS(2452),
    [sym_undefined] = ACTIONS(2452),
    [anon_sym_AT] = ACTIONS(2450),
    [anon_sym_static] = ACTIONS(2452),
    [anon_sym_abstract] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2452),
    [anon_sym_set] = ACTIONS(2452),
    [anon_sym_declare] = ACTIONS(2452),
    [anon_sym_public] = ACTIONS(2452),
    [anon_sym_private] = ACTIONS(2452),
    [anon_sym_protected] = ACTIONS(2452),
    [anon_sym_module] = ACTIONS(2452),
    [anon_sym_any] = ACTIONS(2452),
    [anon_sym_number] = ACTIONS(2452),
    [anon_sym_boolean] = ACTIONS(2452),
    [anon_sym_string] = ACTIONS(2452),
    [anon_sym_symbol] = ACTIONS(2452),
    [anon_sym_interface] = ACTIONS(2452),
    [anon_sym_enum] = ACTIONS(2452),
    [sym_readonly] = ACTIONS(2452),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(2454),
    [sym_identifier] = ACTIONS(2456),
    [anon_sym_export] = ACTIONS(2456),
    [anon_sym_default] = ACTIONS(2456),
    [anon_sym_EQ] = ACTIONS(2456),
    [anon_sym_namespace] = ACTIONS(2456),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_type] = ACTIONS(2456),
    [anon_sym_typeof] = ACTIONS(2456),
    [anon_sym_import] = ACTIONS(2456),
    [anon_sym_var] = ACTIONS(2456),
    [anon_sym_let] = ACTIONS(2456),
    [anon_sym_const] = ACTIONS(2456),
    [anon_sym_if] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2456),
    [anon_sym_switch] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_await] = ACTIONS(2456),
    [anon_sym_while] = ACTIONS(2456),
    [anon_sym_do] = ACTIONS(2456),
    [anon_sym_try] = ACTIONS(2456),
    [anon_sym_with] = ACTIONS(2456),
    [anon_sym_break] = ACTIONS(2456),
    [anon_sym_continue] = ACTIONS(2456),
    [anon_sym_debugger] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2456),
    [anon_sym_throw] = ACTIONS(2456),
    [anon_sym_SEMI] = ACTIONS(2454),
    [anon_sym_case] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_RBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_GT] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2456),
    [anon_sym_class] = ACTIONS(2456),
    [anon_sym_async] = ACTIONS(2456),
    [anon_sym_function] = ACTIONS(2456),
    [anon_sym_EQ_GT] = ACTIONS(2454),
    [anon_sym_new] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_BANG] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2454),
    [anon_sym_void] = ACTIONS(2456),
    [anon_sym_delete] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [anon_sym_DQUOTE] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [sym_number] = ACTIONS(2454),
    [sym_this] = ACTIONS(2456),
    [sym_super] = ACTIONS(2456),
    [sym_true] = ACTIONS(2456),
    [sym_false] = ACTIONS(2456),
    [sym_null] = ACTIONS(2456),
    [sym_undefined] = ACTIONS(2456),
    [anon_sym_AT] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2456),
    [anon_sym_abstract] = ACTIONS(2456),
    [anon_sym_get] = ACTIONS(2456),
    [anon_sym_set] = ACTIONS(2456),
    [anon_sym_declare] = ACTIONS(2456),
    [anon_sym_public] = ACTIONS(2456),
    [anon_sym_private] = ACTIONS(2456),
    [anon_sym_protected] = ACTIONS(2456),
    [anon_sym_module] = ACTIONS(2456),
    [anon_sym_any] = ACTIONS(2456),
    [anon_sym_number] = ACTIONS(2456),
    [anon_sym_boolean] = ACTIONS(2456),
    [anon_sym_string] = ACTIONS(2456),
    [anon_sym_symbol] = ACTIONS(2456),
    [anon_sym_interface] = ACTIONS(2456),
    [anon_sym_enum] = ACTIONS(2456),
    [sym_readonly] = ACTIONS(2456),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(2458),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_export] = ACTIONS(2460),
    [anon_sym_default] = ACTIONS(2460),
    [anon_sym_EQ] = ACTIONS(2460),
    [anon_sym_namespace] = ACTIONS(2460),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2460),
    [anon_sym_import] = ACTIONS(2460),
    [anon_sym_var] = ACTIONS(2460),
    [anon_sym_let] = ACTIONS(2460),
    [anon_sym_const] = ACTIONS(2460),
    [anon_sym_if] = ACTIONS(2460),
    [anon_sym_else] = ACTIONS(2460),
    [anon_sym_switch] = ACTIONS(2460),
    [anon_sym_for] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_RPAREN] = ACTIONS(2458),
    [anon_sym_await] = ACTIONS(2460),
    [anon_sym_while] = ACTIONS(2460),
    [anon_sym_do] = ACTIONS(2460),
    [anon_sym_try] = ACTIONS(2460),
    [anon_sym_with] = ACTIONS(2460),
    [anon_sym_break] = ACTIONS(2460),
    [anon_sym_continue] = ACTIONS(2460),
    [anon_sym_debugger] = ACTIONS(2460),
    [anon_sym_return] = ACTIONS(2460),
    [anon_sym_throw] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2458),
    [anon_sym_case] = ACTIONS(2460),
    [anon_sym_yield] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_RBRACK] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_GT] = ACTIONS(2458),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_class] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2460),
    [anon_sym_function] = ACTIONS(2460),
    [anon_sym_EQ_GT] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_BANG] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2458),
    [anon_sym_void] = ACTIONS(2460),
    [anon_sym_delete] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2458),
    [anon_sym_DASH_DASH] = ACTIONS(2458),
    [anon_sym_DQUOTE] = ACTIONS(2458),
    [anon_sym_SQUOTE] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2458),
    [sym_number] = ACTIONS(2458),
    [sym_this] = ACTIONS(2460),
    [sym_super] = ACTIONS(2460),
    [sym_true] = ACTIONS(2460),
    [sym_false] = ACTIONS(2460),
    [sym_null] = ACTIONS(2460),
    [sym_undefined] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(2458),
    [anon_sym_static] = ACTIONS(2460),
    [anon_sym_abstract] = ACTIONS(2460),
    [anon_sym_get] = ACTIONS(2460),
    [anon_sym_set] = ACTIONS(2460),
    [anon_sym_declare] = ACTIONS(2460),
    [anon_sym_public] = ACTIONS(2460),
    [anon_sym_private] = ACTIONS(2460),
    [anon_sym_protected] = ACTIONS(2460),
    [anon_sym_module] = ACTIONS(2460),
    [anon_sym_any] = ACTIONS(2460),
    [anon_sym_number] = ACTIONS(2460),
    [anon_sym_boolean] = ACTIONS(2460),
    [anon_sym_string] = ACTIONS(2460),
    [anon_sym_symbol] = ACTIONS(2460),
    [anon_sym_interface] = ACTIONS(2460),
    [anon_sym_enum] = ACTIONS(2460),
    [sym_readonly] = ACTIONS(2460),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(2462),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_default] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_namespace] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_type] = ACTIONS(2464),
    [anon_sym_typeof] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_var] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_switch] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_await] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [anon_sym_do] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_with] = ACTIONS(2464),
    [anon_sym_break] = ACTIONS(2464),
    [anon_sym_continue] = ACTIONS(2464),
    [anon_sym_debugger] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_throw] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2464),
    [anon_sym_yield] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_RBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_GT] = ACTIONS(2462),
    [anon_sym_SLASH] = ACTIONS(2464),
    [anon_sym_class] = ACTIONS(2464),
    [anon_sym_async] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_EQ_GT] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2462),
    [anon_sym_void] = ACTIONS(2464),
    [anon_sym_delete] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2462),
    [anon_sym_SQUOTE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [sym_number] = ACTIONS(2462),
    [sym_this] = ACTIONS(2464),
    [sym_super] = ACTIONS(2464),
    [sym_true] = ACTIONS(2464),
    [sym_false] = ACTIONS(2464),
    [sym_null] = ACTIONS(2464),
    [sym_undefined] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_get] = ACTIONS(2464),
    [anon_sym_set] = ACTIONS(2464),
    [anon_sym_declare] = ACTIONS(2464),
    [anon_sym_public] = ACTIONS(2464),
    [anon_sym_private] = ACTIONS(2464),
    [anon_sym_protected] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_any] = ACTIONS(2464),
    [anon_sym_number] = ACTIONS(2464),
    [anon_sym_boolean] = ACTIONS(2464),
    [anon_sym_string] = ACTIONS(2464),
    [anon_sym_symbol] = ACTIONS(2464),
    [anon_sym_interface] = ACTIONS(2464),
    [anon_sym_enum] = ACTIONS(2464),
    [sym_readonly] = ACTIONS(2464),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(2466),
    [sym_identifier] = ACTIONS(2468),
    [anon_sym_export] = ACTIONS(2468),
    [anon_sym_default] = ACTIONS(2468),
    [anon_sym_EQ] = ACTIONS(2468),
    [anon_sym_namespace] = ACTIONS(2468),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_type] = ACTIONS(2468),
    [anon_sym_typeof] = ACTIONS(2468),
    [anon_sym_import] = ACTIONS(2468),
    [anon_sym_var] = ACTIONS(2468),
    [anon_sym_let] = ACTIONS(2468),
    [anon_sym_const] = ACTIONS(2468),
    [anon_sym_if] = ACTIONS(2468),
    [anon_sym_else] = ACTIONS(2468),
    [anon_sym_switch] = ACTIONS(2468),
    [anon_sym_for] = ACTIONS(2468),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_await] = ACTIONS(2468),
    [anon_sym_while] = ACTIONS(2468),
    [anon_sym_do] = ACTIONS(2468),
    [anon_sym_try] = ACTIONS(2468),
    [anon_sym_with] = ACTIONS(2468),
    [anon_sym_break] = ACTIONS(2468),
    [anon_sym_continue] = ACTIONS(2468),
    [anon_sym_debugger] = ACTIONS(2468),
    [anon_sym_return] = ACTIONS(2468),
    [anon_sym_throw] = ACTIONS(2468),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_case] = ACTIONS(2468),
    [anon_sym_yield] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_GT] = ACTIONS(2466),
    [anon_sym_SLASH] = ACTIONS(2468),
    [anon_sym_class] = ACTIONS(2468),
    [anon_sym_async] = ACTIONS(2468),
    [anon_sym_function] = ACTIONS(2468),
    [anon_sym_EQ_GT] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2466),
    [anon_sym_void] = ACTIONS(2468),
    [anon_sym_delete] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2466),
    [anon_sym_DQUOTE] = ACTIONS(2466),
    [anon_sym_SQUOTE] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2466),
    [sym_number] = ACTIONS(2466),
    [sym_this] = ACTIONS(2468),
    [sym_super] = ACTIONS(2468),
    [sym_true] = ACTIONS(2468),
    [sym_false] = ACTIONS(2468),
    [sym_null] = ACTIONS(2468),
    [sym_undefined] = ACTIONS(2468),
    [anon_sym_AT] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2468),
    [anon_sym_abstract] = ACTIONS(2468),
    [anon_sym_get] = ACTIONS(2468),
    [anon_sym_set] = ACTIONS(2468),
    [anon_sym_declare] = ACTIONS(2468),
    [anon_sym_public] = ACTIONS(2468),
    [anon_sym_private] = ACTIONS(2468),
    [anon_sym_protected] = ACTIONS(2468),
    [anon_sym_module] = ACTIONS(2468),
    [anon_sym_any] = ACTIONS(2468),
    [anon_sym_number] = ACTIONS(2468),
    [anon_sym_boolean] = ACTIONS(2468),
    [anon_sym_string] = ACTIONS(2468),
    [anon_sym_symbol] = ACTIONS(2468),
    [anon_sym_interface] = ACTIONS(2468),
    [anon_sym_enum] = ACTIONS(2468),
    [sym_readonly] = ACTIONS(2468),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(2470),
    [sym_identifier] = ACTIONS(2472),
    [anon_sym_export] = ACTIONS(2472),
    [anon_sym_default] = ACTIONS(2472),
    [anon_sym_EQ] = ACTIONS(2472),
    [anon_sym_namespace] = ACTIONS(2472),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2470),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_type] = ACTIONS(2472),
    [anon_sym_typeof] = ACTIONS(2472),
    [anon_sym_import] = ACTIONS(2472),
    [anon_sym_var] = ACTIONS(2472),
    [anon_sym_let] = ACTIONS(2472),
    [anon_sym_const] = ACTIONS(2472),
    [anon_sym_if] = ACTIONS(2472),
    [anon_sym_else] = ACTIONS(2472),
    [anon_sym_switch] = ACTIONS(2472),
    [anon_sym_for] = ACTIONS(2472),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_RPAREN] = ACTIONS(2470),
    [anon_sym_await] = ACTIONS(2472),
    [anon_sym_while] = ACTIONS(2472),
    [anon_sym_do] = ACTIONS(2472),
    [anon_sym_try] = ACTIONS(2472),
    [anon_sym_with] = ACTIONS(2472),
    [anon_sym_break] = ACTIONS(2472),
    [anon_sym_continue] = ACTIONS(2472),
    [anon_sym_debugger] = ACTIONS(2472),
    [anon_sym_return] = ACTIONS(2472),
    [anon_sym_throw] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2470),
    [anon_sym_case] = ACTIONS(2472),
    [anon_sym_yield] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_RBRACK] = ACTIONS(2470),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_GT] = ACTIONS(2470),
    [anon_sym_SLASH] = ACTIONS(2472),
    [anon_sym_class] = ACTIONS(2472),
    [anon_sym_async] = ACTIONS(2472),
    [anon_sym_function] = ACTIONS(2472),
    [anon_sym_EQ_GT] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_PIPE] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2470),
    [anon_sym_void] = ACTIONS(2472),
    [anon_sym_delete] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(2470),
    [anon_sym_DQUOTE] = ACTIONS(2470),
    [anon_sym_SQUOTE] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2470),
    [sym_number] = ACTIONS(2470),
    [sym_this] = ACTIONS(2472),
    [sym_super] = ACTIONS(2472),
    [sym_true] = ACTIONS(2472),
    [sym_false] = ACTIONS(2472),
    [sym_null] = ACTIONS(2472),
    [sym_undefined] = ACTIONS(2472),
    [anon_sym_AT] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2472),
    [anon_sym_abstract] = ACTIONS(2472),
    [anon_sym_get] = ACTIONS(2472),
    [anon_sym_set] = ACTIONS(2472),
    [anon_sym_declare] = ACTIONS(2472),
    [anon_sym_public] = ACTIONS(2472),
    [anon_sym_private] = ACTIONS(2472),
    [anon_sym_protected] = ACTIONS(2472),
    [anon_sym_module] = ACTIONS(2472),
    [anon_sym_any] = ACTIONS(2472),
    [anon_sym_number] = ACTIONS(2472),
    [anon_sym_boolean] = ACTIONS(2472),
    [anon_sym_string] = ACTIONS(2472),
    [anon_sym_symbol] = ACTIONS(2472),
    [anon_sym_interface] = ACTIONS(2472),
    [anon_sym_enum] = ACTIONS(2472),
    [sym_readonly] = ACTIONS(2472),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(2474),
    [sym_identifier] = ACTIONS(2476),
    [anon_sym_export] = ACTIONS(2476),
    [anon_sym_default] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(2476),
    [anon_sym_namespace] = ACTIONS(2476),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_type] = ACTIONS(2476),
    [anon_sym_typeof] = ACTIONS(2476),
    [anon_sym_import] = ACTIONS(2476),
    [anon_sym_var] = ACTIONS(2476),
    [anon_sym_let] = ACTIONS(2476),
    [anon_sym_const] = ACTIONS(2476),
    [anon_sym_if] = ACTIONS(2476),
    [anon_sym_else] = ACTIONS(2476),
    [anon_sym_switch] = ACTIONS(2476),
    [anon_sym_for] = ACTIONS(2476),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_RPAREN] = ACTIONS(2474),
    [anon_sym_await] = ACTIONS(2476),
    [anon_sym_while] = ACTIONS(2476),
    [anon_sym_do] = ACTIONS(2476),
    [anon_sym_try] = ACTIONS(2476),
    [anon_sym_with] = ACTIONS(2476),
    [anon_sym_break] = ACTIONS(2476),
    [anon_sym_continue] = ACTIONS(2476),
    [anon_sym_debugger] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2476),
    [anon_sym_throw] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(2476),
    [anon_sym_yield] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_RBRACK] = ACTIONS(2474),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_GT] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2476),
    [anon_sym_class] = ACTIONS(2476),
    [anon_sym_async] = ACTIONS(2476),
    [anon_sym_function] = ACTIONS(2476),
    [anon_sym_EQ_GT] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_PIPE] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2474),
    [anon_sym_void] = ACTIONS(2476),
    [anon_sym_delete] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2474),
    [anon_sym_DASH_DASH] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [anon_sym_SQUOTE] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2474),
    [sym_number] = ACTIONS(2474),
    [sym_this] = ACTIONS(2476),
    [sym_super] = ACTIONS(2476),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [sym_null] = ACTIONS(2476),
    [sym_undefined] = ACTIONS(2476),
    [anon_sym_AT] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_abstract] = ACTIONS(2476),
    [anon_sym_get] = ACTIONS(2476),
    [anon_sym_set] = ACTIONS(2476),
    [anon_sym_declare] = ACTIONS(2476),
    [anon_sym_public] = ACTIONS(2476),
    [anon_sym_private] = ACTIONS(2476),
    [anon_sym_protected] = ACTIONS(2476),
    [anon_sym_module] = ACTIONS(2476),
    [anon_sym_any] = ACTIONS(2476),
    [anon_sym_number] = ACTIONS(2476),
    [anon_sym_boolean] = ACTIONS(2476),
    [anon_sym_string] = ACTIONS(2476),
    [anon_sym_symbol] = ACTIONS(2476),
    [anon_sym_interface] = ACTIONS(2476),
    [anon_sym_enum] = ACTIONS(2476),
    [sym_readonly] = ACTIONS(2476),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_EQ] = ACTIONS(2480),
    [anon_sym_namespace] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_type] = ACTIONS(2480),
    [anon_sym_typeof] = ACTIONS(2480),
    [anon_sym_import] = ACTIONS(2480),
    [anon_sym_var] = ACTIONS(2480),
    [anon_sym_let] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_await] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_with] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_debugger] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_throw] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_yield] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_RBRACK] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_GT] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2480),
    [anon_sym_class] = ACTIONS(2480),
    [anon_sym_async] = ACTIONS(2480),
    [anon_sym_function] = ACTIONS(2480),
    [anon_sym_EQ_GT] = ACTIONS(2478),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_BANG] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2478),
    [anon_sym_void] = ACTIONS(2480),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [anon_sym_DQUOTE] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2478),
    [sym_number] = ACTIONS(2478),
    [sym_this] = ACTIONS(2480),
    [sym_super] = ACTIONS(2480),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_undefined] = ACTIONS(2480),
    [anon_sym_AT] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_abstract] = ACTIONS(2480),
    [anon_sym_get] = ACTIONS(2480),
    [anon_sym_set] = ACTIONS(2480),
    [anon_sym_declare] = ACTIONS(2480),
    [anon_sym_public] = ACTIONS(2480),
    [anon_sym_private] = ACTIONS(2480),
    [anon_sym_protected] = ACTIONS(2480),
    [anon_sym_module] = ACTIONS(2480),
    [anon_sym_any] = ACTIONS(2480),
    [anon_sym_number] = ACTIONS(2480),
    [anon_sym_boolean] = ACTIONS(2480),
    [anon_sym_string] = ACTIONS(2480),
    [anon_sym_symbol] = ACTIONS(2480),
    [anon_sym_interface] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [sym_readonly] = ACTIONS(2480),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2484),
    [anon_sym_export] = ACTIONS(2484),
    [anon_sym_default] = ACTIONS(2484),
    [anon_sym_EQ] = ACTIONS(2484),
    [anon_sym_namespace] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2484),
    [anon_sym_import] = ACTIONS(2484),
    [anon_sym_var] = ACTIONS(2484),
    [anon_sym_let] = ACTIONS(2484),
    [anon_sym_const] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2484),
    [anon_sym_else] = ACTIONS(2484),
    [anon_sym_switch] = ACTIONS(2484),
    [anon_sym_for] = ACTIONS(2484),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_RPAREN] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2484),
    [anon_sym_while] = ACTIONS(2484),
    [anon_sym_do] = ACTIONS(2484),
    [anon_sym_try] = ACTIONS(2484),
    [anon_sym_with] = ACTIONS(2484),
    [anon_sym_break] = ACTIONS(2484),
    [anon_sym_continue] = ACTIONS(2484),
    [anon_sym_debugger] = ACTIONS(2484),
    [anon_sym_return] = ACTIONS(2484),
    [anon_sym_throw] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym_case] = ACTIONS(2484),
    [anon_sym_yield] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_RBRACK] = ACTIONS(2482),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_GT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2484),
    [anon_sym_class] = ACTIONS(2484),
    [anon_sym_async] = ACTIONS(2484),
    [anon_sym_function] = ACTIONS(2484),
    [anon_sym_EQ_GT] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2482),
    [anon_sym_void] = ACTIONS(2484),
    [anon_sym_delete] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2482),
    [anon_sym_DASH_DASH] = ACTIONS(2482),
    [anon_sym_DQUOTE] = ACTIONS(2482),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2482),
    [sym_number] = ACTIONS(2482),
    [sym_this] = ACTIONS(2484),
    [sym_super] = ACTIONS(2484),
    [sym_true] = ACTIONS(2484),
    [sym_false] = ACTIONS(2484),
    [sym_null] = ACTIONS(2484),
    [sym_undefined] = ACTIONS(2484),
    [anon_sym_AT] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2484),
    [anon_sym_abstract] = ACTIONS(2484),
    [anon_sym_get] = ACTIONS(2484),
    [anon_sym_set] = ACTIONS(2484),
    [anon_sym_declare] = ACTIONS(2484),
    [anon_sym_public] = ACTIONS(2484),
    [anon_sym_private] = ACTIONS(2484),
    [anon_sym_protected] = ACTIONS(2484),
    [anon_sym_module] = ACTIONS(2484),
    [anon_sym_any] = ACTIONS(2484),
    [anon_sym_number] = ACTIONS(2484),
    [anon_sym_boolean] = ACTIONS(2484),
    [anon_sym_string] = ACTIONS(2484),
    [anon_sym_symbol] = ACTIONS(2484),
    [anon_sym_interface] = ACTIONS(2484),
    [anon_sym_enum] = ACTIONS(2484),
    [sym_readonly] = ACTIONS(2484),
  },
  [443] = {
    [sym_type_arguments] = STATE(416),
    [ts_builtin_sym_end] = ACTIONS(2486),
    [sym_identifier] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_type] = ACTIONS(2488),
    [anon_sym_typeof] = ACTIONS(2488),
    [anon_sym_import] = ACTIONS(2488),
    [anon_sym_var] = ACTIONS(2488),
    [anon_sym_let] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_else] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_await] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_with] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_debugger] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_yield] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(2490),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_async] = ACTIONS(2488),
    [anon_sym_function] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2486),
    [anon_sym_void] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [sym_number] = ACTIONS(2486),
    [sym_this] = ACTIONS(2488),
    [sym_super] = ACTIONS(2488),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [sym_null] = ACTIONS(2488),
    [sym_undefined] = ACTIONS(2488),
    [anon_sym_AT] = ACTIONS(2486),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_abstract] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2488),
    [anon_sym_set] = ACTIONS(2488),
    [anon_sym_declare] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_any] = ACTIONS(2488),
    [anon_sym_number] = ACTIONS(2488),
    [anon_sym_boolean] = ACTIONS(2488),
    [anon_sym_string] = ACTIONS(2488),
    [anon_sym_symbol] = ACTIONS(2488),
    [anon_sym_interface] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [sym_readonly] = ACTIONS(2488),
    [anon_sym_is] = ACTIONS(2493),
  },
  [444] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [445] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [446] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [447] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [448] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [449] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [450] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [451] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [452] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2363),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [453] = {
    [ts_builtin_sym_end] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(1069),
    [anon_sym_default] = ACTIONS(1069),
    [anon_sym_namespace] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1069),
    [anon_sym_typeof] = ACTIONS(1069),
    [anon_sym_import] = ACTIONS(1069),
    [anon_sym_var] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1069),
    [anon_sym_switch] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_await] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1069),
    [anon_sym_do] = ACTIONS(1069),
    [anon_sym_try] = ACTIONS(1069),
    [anon_sym_with] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1069),
    [anon_sym_continue] = ACTIONS(1069),
    [anon_sym_debugger] = ACTIONS(1069),
    [anon_sym_return] = ACTIONS(1069),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_case] = ACTIONS(1069),
    [anon_sym_catch] = ACTIONS(1069),
    [anon_sym_finally] = ACTIONS(1069),
    [anon_sym_yield] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_class] = ACTIONS(1069),
    [anon_sym_async] = ACTIONS(1069),
    [anon_sym_function] = ACTIONS(1069),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_void] = ACTIONS(1069),
    [anon_sym_delete] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_SQUOTE] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym_number] = ACTIONS(1067),
    [sym_this] = ACTIONS(1069),
    [sym_super] = ACTIONS(1069),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_null] = ACTIONS(1069),
    [sym_undefined] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_static] = ACTIONS(1069),
    [anon_sym_abstract] = ACTIONS(1069),
    [anon_sym_get] = ACTIONS(1069),
    [anon_sym_set] = ACTIONS(1069),
    [anon_sym_declare] = ACTIONS(1069),
    [anon_sym_public] = ACTIONS(1069),
    [anon_sym_private] = ACTIONS(1069),
    [anon_sym_protected] = ACTIONS(1069),
    [anon_sym_module] = ACTIONS(1069),
    [anon_sym_any] = ACTIONS(1069),
    [anon_sym_number] = ACTIONS(1069),
    [anon_sym_boolean] = ACTIONS(1069),
    [anon_sym_string] = ACTIONS(1069),
    [anon_sym_symbol] = ACTIONS(1069),
    [anon_sym_interface] = ACTIONS(1069),
    [anon_sym_enum] = ACTIONS(1069),
    [sym_readonly] = ACTIONS(1069),
    [sym__automatic_semicolon] = ACTIONS(1075),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_catch] = ACTIONS(1137),
    [anon_sym_finally] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
    [sym__automatic_semicolon] = ACTIONS(2503),
  },
  [455] = {
    [sym_catch_clause] = STATE(481),
    [sym_finally_clause] = STATE(540),
    [ts_builtin_sym_end] = ACTIONS(2505),
    [sym_identifier] = ACTIONS(2507),
    [anon_sym_export] = ACTIONS(2507),
    [anon_sym_default] = ACTIONS(2507),
    [anon_sym_namespace] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2505),
    [anon_sym_RBRACE] = ACTIONS(2505),
    [anon_sym_type] = ACTIONS(2507),
    [anon_sym_typeof] = ACTIONS(2507),
    [anon_sym_import] = ACTIONS(2507),
    [anon_sym_var] = ACTIONS(2507),
    [anon_sym_let] = ACTIONS(2507),
    [anon_sym_const] = ACTIONS(2507),
    [anon_sym_if] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2507),
    [anon_sym_switch] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2507),
    [anon_sym_LPAREN] = ACTIONS(2505),
    [anon_sym_await] = ACTIONS(2507),
    [anon_sym_while] = ACTIONS(2507),
    [anon_sym_do] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2507),
    [anon_sym_with] = ACTIONS(2507),
    [anon_sym_break] = ACTIONS(2507),
    [anon_sym_continue] = ACTIONS(2507),
    [anon_sym_debugger] = ACTIONS(2507),
    [anon_sym_return] = ACTIONS(2507),
    [anon_sym_throw] = ACTIONS(2507),
    [anon_sym_SEMI] = ACTIONS(2505),
    [anon_sym_case] = ACTIONS(2507),
    [anon_sym_catch] = ACTIONS(2509),
    [anon_sym_finally] = ACTIONS(2511),
    [anon_sym_yield] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2505),
    [anon_sym_LT] = ACTIONS(2505),
    [anon_sym_SLASH] = ACTIONS(2507),
    [anon_sym_class] = ACTIONS(2507),
    [anon_sym_async] = ACTIONS(2507),
    [anon_sym_function] = ACTIONS(2507),
    [anon_sym_new] = ACTIONS(2507),
    [anon_sym_PLUS] = ACTIONS(2507),
    [anon_sym_DASH] = ACTIONS(2507),
    [anon_sym_BANG] = ACTIONS(2505),
    [anon_sym_TILDE] = ACTIONS(2505),
    [anon_sym_void] = ACTIONS(2507),
    [anon_sym_delete] = ACTIONS(2507),
    [anon_sym_PLUS_PLUS] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2505),
    [anon_sym_DQUOTE] = ACTIONS(2505),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2505),
    [sym_number] = ACTIONS(2505),
    [sym_this] = ACTIONS(2507),
    [sym_super] = ACTIONS(2507),
    [sym_true] = ACTIONS(2507),
    [sym_false] = ACTIONS(2507),
    [sym_null] = ACTIONS(2507),
    [sym_undefined] = ACTIONS(2507),
    [anon_sym_AT] = ACTIONS(2505),
    [anon_sym_static] = ACTIONS(2507),
    [anon_sym_abstract] = ACTIONS(2507),
    [anon_sym_get] = ACTIONS(2507),
    [anon_sym_set] = ACTIONS(2507),
    [anon_sym_declare] = ACTIONS(2507),
    [anon_sym_public] = ACTIONS(2507),
    [anon_sym_private] = ACTIONS(2507),
    [anon_sym_protected] = ACTIONS(2507),
    [anon_sym_module] = ACTIONS(2507),
    [anon_sym_any] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2507),
    [anon_sym_string] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2507),
    [anon_sym_interface] = ACTIONS(2507),
    [anon_sym_enum] = ACTIONS(2507),
    [sym_readonly] = ACTIONS(2507),
  },
  [456] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2774),
    [sym_rest_parameter] = STATE(2461),
    [sym_nested_type_identifier] = STATE(1805),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym__type] = STATE(2404),
    [sym_constructor_type] = STATE(2404),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2404),
    [sym_intersection_type] = STATE(2404),
    [sym_function_type] = STATE(2404),
    [aux_sym_export_statement_repeat1] = STATE(1691),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(2531),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(2535),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2531),
    [anon_sym_number] = ACTIONS(2531),
    [anon_sym_boolean] = ACTIONS(2531),
    [anon_sym_string] = ACTIONS(2531),
    [anon_sym_symbol] = ACTIONS(2531),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [457] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2774),
    [sym_rest_parameter] = STATE(2461),
    [sym_nested_type_identifier] = STATE(1805),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym__type] = STATE(2466),
    [sym_constructor_type] = STATE(2466),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2466),
    [sym_intersection_type] = STATE(2466),
    [sym_function_type] = STATE(2466),
    [aux_sym_export_statement_repeat1] = STATE(1691),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(2531),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(2535),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2531),
    [anon_sym_number] = ACTIONS(2531),
    [anon_sym_boolean] = ACTIONS(2531),
    [anon_sym_string] = ACTIONS(2531),
    [anon_sym_symbol] = ACTIONS(2531),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [458] = {
    [sym__call_signature] = STATE(2935),
    [sym_arguments] = STATE(1108),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2543),
    [anon_sym_export] = ACTIONS(2545),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2545),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_void] = ACTIONS(2545),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_static] = ACTIONS(2545),
    [anon_sym_get] = ACTIONS(2545),
    [anon_sym_set] = ACTIONS(2545),
    [anon_sym_declare] = ACTIONS(2545),
    [anon_sym_public] = ACTIONS(2545),
    [anon_sym_private] = ACTIONS(2545),
    [anon_sym_protected] = ACTIONS(2545),
    [anon_sym_module] = ACTIONS(2545),
    [anon_sym_any] = ACTIONS(2545),
    [anon_sym_number] = ACTIONS(2545),
    [anon_sym_boolean] = ACTIONS(2545),
    [anon_sym_string] = ACTIONS(2545),
    [anon_sym_symbol] = ACTIONS(2545),
    [sym_readonly] = ACTIONS(2545),
  },
  [459] = {
    [sym_type_arguments] = STATE(412),
    [ts_builtin_sym_end] = ACTIONS(2551),
    [sym_identifier] = ACTIONS(2553),
    [anon_sym_export] = ACTIONS(2553),
    [anon_sym_default] = ACTIONS(2553),
    [anon_sym_namespace] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2551),
    [anon_sym_RBRACE] = ACTIONS(2551),
    [anon_sym_type] = ACTIONS(2553),
    [anon_sym_typeof] = ACTIONS(2553),
    [anon_sym_import] = ACTIONS(2553),
    [anon_sym_var] = ACTIONS(2553),
    [anon_sym_let] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_else] = ACTIONS(2553),
    [anon_sym_switch] = ACTIONS(2553),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_await] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_with] = ACTIONS(2553),
    [anon_sym_break] = ACTIONS(2553),
    [anon_sym_continue] = ACTIONS(2553),
    [anon_sym_debugger] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_throw] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_case] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2555),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_async] = ACTIONS(2553),
    [anon_sym_function] = ACTIONS(2553),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2551),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_BANG] = ACTIONS(2551),
    [anon_sym_TILDE] = ACTIONS(2551),
    [anon_sym_void] = ACTIONS(2553),
    [anon_sym_delete] = ACTIONS(2553),
    [anon_sym_PLUS_PLUS] = ACTIONS(2551),
    [anon_sym_DASH_DASH] = ACTIONS(2551),
    [anon_sym_DQUOTE] = ACTIONS(2551),
    [anon_sym_SQUOTE] = ACTIONS(2551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2551),
    [sym_number] = ACTIONS(2551),
    [sym_this] = ACTIONS(2553),
    [sym_super] = ACTIONS(2553),
    [sym_true] = ACTIONS(2553),
    [sym_false] = ACTIONS(2553),
    [sym_null] = ACTIONS(2553),
    [sym_undefined] = ACTIONS(2553),
    [anon_sym_AT] = ACTIONS(2551),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_abstract] = ACTIONS(2553),
    [anon_sym_get] = ACTIONS(2553),
    [anon_sym_set] = ACTIONS(2553),
    [anon_sym_declare] = ACTIONS(2553),
    [anon_sym_public] = ACTIONS(2553),
    [anon_sym_private] = ACTIONS(2553),
    [anon_sym_protected] = ACTIONS(2553),
    [anon_sym_module] = ACTIONS(2553),
    [anon_sym_any] = ACTIONS(2553),
    [anon_sym_number] = ACTIONS(2553),
    [anon_sym_boolean] = ACTIONS(2553),
    [anon_sym_string] = ACTIONS(2553),
    [anon_sym_symbol] = ACTIONS(2553),
    [anon_sym_interface] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [sym_readonly] = ACTIONS(2553),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(1241),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(1243),
    [anon_sym_default] = ACTIONS(1243),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(1243),
    [anon_sym_import] = ACTIONS(1243),
    [anon_sym_var] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1243),
    [anon_sym_const] = ACTIONS(1243),
    [anon_sym_if] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1243),
    [anon_sym_switch] = ACTIONS(1243),
    [anon_sym_for] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_await] = ACTIONS(1243),
    [anon_sym_while] = ACTIONS(1243),
    [anon_sym_do] = ACTIONS(1243),
    [anon_sym_try] = ACTIONS(1243),
    [anon_sym_with] = ACTIONS(1243),
    [anon_sym_break] = ACTIONS(1243),
    [anon_sym_continue] = ACTIONS(1243),
    [anon_sym_debugger] = ACTIONS(1243),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_throw] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_class] = ACTIONS(1243),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1243),
    [anon_sym_new] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1243),
    [anon_sym_delete] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1241),
    [anon_sym_SQUOTE] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_super] = ACTIONS(1243),
    [sym_true] = ACTIONS(1243),
    [sym_false] = ACTIONS(1243),
    [sym_null] = ACTIONS(1243),
    [sym_undefined] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1243),
    [anon_sym_abstract] = ACTIONS(1243),
    [anon_sym_get] = ACTIONS(1243),
    [anon_sym_set] = ACTIONS(1243),
    [anon_sym_declare] = ACTIONS(1243),
    [anon_sym_public] = ACTIONS(1243),
    [anon_sym_private] = ACTIONS(1243),
    [anon_sym_protected] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1243),
    [anon_sym_any] = ACTIONS(1243),
    [anon_sym_number] = ACTIONS(1243),
    [anon_sym_boolean] = ACTIONS(1243),
    [anon_sym_string] = ACTIONS(1243),
    [anon_sym_symbol] = ACTIONS(1243),
    [anon_sym_interface] = ACTIONS(1243),
    [anon_sym_enum] = ACTIONS(1243),
    [sym_readonly] = ACTIONS(1243),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1241),
    [sym__automatic_semicolon] = ACTIONS(1241),
  },
  [461] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2774),
    [sym_rest_parameter] = STATE(2461),
    [sym_nested_type_identifier] = STATE(1805),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym__type] = STATE(2513),
    [sym_constructor_type] = STATE(2513),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2513),
    [sym_intersection_type] = STATE(2513),
    [sym_function_type] = STATE(2513),
    [aux_sym_export_statement_repeat1] = STATE(1691),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(2531),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(2535),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2531),
    [anon_sym_number] = ACTIONS(2531),
    [anon_sym_boolean] = ACTIONS(2531),
    [anon_sym_string] = ACTIONS(2531),
    [anon_sym_symbol] = ACTIONS(2531),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(1069),
    [anon_sym_default] = ACTIONS(1069),
    [anon_sym_namespace] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1069),
    [anon_sym_typeof] = ACTIONS(1069),
    [anon_sym_import] = ACTIONS(1069),
    [anon_sym_var] = ACTIONS(1069),
    [anon_sym_let] = ACTIONS(1069),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1069),
    [anon_sym_switch] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_await] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1069),
    [anon_sym_do] = ACTIONS(1069),
    [anon_sym_try] = ACTIONS(1069),
    [anon_sym_with] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1069),
    [anon_sym_continue] = ACTIONS(1069),
    [anon_sym_debugger] = ACTIONS(1069),
    [anon_sym_return] = ACTIONS(1069),
    [anon_sym_throw] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_case] = ACTIONS(1069),
    [anon_sym_yield] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_class] = ACTIONS(1069),
    [anon_sym_async] = ACTIONS(1069),
    [anon_sym_function] = ACTIONS(1069),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_void] = ACTIONS(1069),
    [anon_sym_delete] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_SQUOTE] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym_number] = ACTIONS(1067),
    [sym_this] = ACTIONS(1069),
    [sym_super] = ACTIONS(1069),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_null] = ACTIONS(1069),
    [sym_undefined] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_static] = ACTIONS(1069),
    [anon_sym_abstract] = ACTIONS(1069),
    [anon_sym_get] = ACTIONS(1069),
    [anon_sym_set] = ACTIONS(1069),
    [anon_sym_declare] = ACTIONS(1069),
    [anon_sym_public] = ACTIONS(1069),
    [anon_sym_private] = ACTIONS(1069),
    [anon_sym_protected] = ACTIONS(1069),
    [anon_sym_module] = ACTIONS(1069),
    [anon_sym_any] = ACTIONS(1069),
    [anon_sym_number] = ACTIONS(1069),
    [anon_sym_boolean] = ACTIONS(1069),
    [anon_sym_string] = ACTIONS(1069),
    [anon_sym_symbol] = ACTIONS(1069),
    [anon_sym_interface] = ACTIONS(1069),
    [anon_sym_enum] = ACTIONS(1069),
    [sym_readonly] = ACTIONS(1069),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(2558),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(1115),
    [anon_sym_default] = ACTIONS(1115),
    [anon_sym_namespace] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1115),
    [anon_sym_typeof] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1115),
    [anon_sym_var] = ACTIONS(1115),
    [anon_sym_let] = ACTIONS(1115),
    [anon_sym_const] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_switch] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_await] = ACTIONS(1115),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_do] = ACTIONS(1115),
    [anon_sym_try] = ACTIONS(1115),
    [anon_sym_with] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_debugger] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_throw] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1113),
    [anon_sym_case] = ACTIONS(1115),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_class] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_function] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1113),
    [anon_sym_void] = ACTIONS(1115),
    [anon_sym_delete] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym_number] = ACTIONS(1113),
    [sym_this] = ACTIONS(1115),
    [sym_super] = ACTIONS(1115),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_undefined] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1113),
    [anon_sym_static] = ACTIONS(1115),
    [anon_sym_abstract] = ACTIONS(1115),
    [anon_sym_get] = ACTIONS(1115),
    [anon_sym_set] = ACTIONS(1115),
    [anon_sym_declare] = ACTIONS(1115),
    [anon_sym_public] = ACTIONS(1115),
    [anon_sym_private] = ACTIONS(1115),
    [anon_sym_protected] = ACTIONS(1115),
    [anon_sym_module] = ACTIONS(1115),
    [anon_sym_any] = ACTIONS(1115),
    [anon_sym_number] = ACTIONS(1115),
    [anon_sym_boolean] = ACTIONS(1115),
    [anon_sym_string] = ACTIONS(1115),
    [anon_sym_symbol] = ACTIONS(1115),
    [anon_sym_interface] = ACTIONS(1115),
    [anon_sym_enum] = ACTIONS(1115),
    [sym_readonly] = ACTIONS(1115),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1113),
    [sym__automatic_semicolon] = ACTIONS(1113),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(1229),
    [sym_identifier] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1231),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1231),
    [anon_sym_typeof] = ACTIONS(1231),
    [anon_sym_import] = ACTIONS(1231),
    [anon_sym_var] = ACTIONS(1231),
    [anon_sym_let] = ACTIONS(1231),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_else] = ACTIONS(1231),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_await] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1231),
    [anon_sym_try] = ACTIONS(1231),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_break] = ACTIONS(1231),
    [anon_sym_continue] = ACTIONS(1231),
    [anon_sym_debugger] = ACTIONS(1231),
    [anon_sym_return] = ACTIONS(1231),
    [anon_sym_throw] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_class] = ACTIONS(1231),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_void] = ACTIONS(1231),
    [anon_sym_delete] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_number] = ACTIONS(1229),
    [sym_this] = ACTIONS(1231),
    [sym_super] = ACTIONS(1231),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_AT] = ACTIONS(1229),
    [anon_sym_static] = ACTIONS(1231),
    [anon_sym_abstract] = ACTIONS(1231),
    [anon_sym_get] = ACTIONS(1231),
    [anon_sym_set] = ACTIONS(1231),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_public] = ACTIONS(1231),
    [anon_sym_private] = ACTIONS(1231),
    [anon_sym_protected] = ACTIONS(1231),
    [anon_sym_module] = ACTIONS(1231),
    [anon_sym_any] = ACTIONS(1231),
    [anon_sym_number] = ACTIONS(1231),
    [anon_sym_boolean] = ACTIONS(1231),
    [anon_sym_string] = ACTIONS(1231),
    [anon_sym_symbol] = ACTIONS(1231),
    [anon_sym_interface] = ACTIONS(1231),
    [anon_sym_enum] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(1231),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1229),
    [sym__automatic_semicolon] = ACTIONS(1229),
  },
  [465] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2774),
    [sym_rest_parameter] = STATE(2461),
    [sym_nested_type_identifier] = STATE(1805),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym__type] = STATE(2542),
    [sym_constructor_type] = STATE(2542),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2542),
    [sym_intersection_type] = STATE(2542),
    [sym_function_type] = STATE(2542),
    [aux_sym_export_statement_repeat1] = STATE(1691),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(2531),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(2535),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2531),
    [anon_sym_number] = ACTIONS(2531),
    [anon_sym_boolean] = ACTIONS(2531),
    [anon_sym_string] = ACTIONS(2531),
    [anon_sym_symbol] = ACTIONS(2531),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [466] = {
    [ts_builtin_sym_end] = ACTIONS(1229),
    [sym_identifier] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1231),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1231),
    [anon_sym_typeof] = ACTIONS(1231),
    [anon_sym_import] = ACTIONS(1231),
    [anon_sym_var] = ACTIONS(1231),
    [anon_sym_let] = ACTIONS(1231),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_else] = ACTIONS(1231),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_await] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1231),
    [anon_sym_try] = ACTIONS(1231),
    [anon_sym_with] = ACTIONS(1231),
    [anon_sym_break] = ACTIONS(1231),
    [anon_sym_continue] = ACTIONS(1231),
    [anon_sym_debugger] = ACTIONS(1231),
    [anon_sym_return] = ACTIONS(1231),
    [anon_sym_throw] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_catch] = ACTIONS(1231),
    [anon_sym_finally] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_class] = ACTIONS(1231),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_function] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_void] = ACTIONS(1231),
    [anon_sym_delete] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_number] = ACTIONS(1229),
    [sym_this] = ACTIONS(1231),
    [sym_super] = ACTIONS(1231),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_AT] = ACTIONS(1229),
    [anon_sym_static] = ACTIONS(1231),
    [anon_sym_abstract] = ACTIONS(1231),
    [anon_sym_get] = ACTIONS(1231),
    [anon_sym_set] = ACTIONS(1231),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_public] = ACTIONS(1231),
    [anon_sym_private] = ACTIONS(1231),
    [anon_sym_protected] = ACTIONS(1231),
    [anon_sym_module] = ACTIONS(1231),
    [anon_sym_any] = ACTIONS(1231),
    [anon_sym_number] = ACTIONS(1231),
    [anon_sym_boolean] = ACTIONS(1231),
    [anon_sym_string] = ACTIONS(1231),
    [anon_sym_symbol] = ACTIONS(1231),
    [anon_sym_interface] = ACTIONS(1231),
    [anon_sym_enum] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(1231),
  },
  [467] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_catch] = ACTIONS(1137),
    [anon_sym_finally] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(1135),
  },
  [469] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(2774),
    [sym_rest_parameter] = STATE(2461),
    [sym_nested_type_identifier] = STATE(1805),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [sym__type] = STATE(2406),
    [sym_constructor_type] = STATE(2406),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2406),
    [sym_intersection_type] = STATE(2406),
    [sym_function_type] = STATE(2406),
    [aux_sym_export_statement_repeat1] = STATE(1691),
    [sym_identifier] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(2531),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(2535),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2531),
    [anon_sym_number] = ACTIONS(2531),
    [anon_sym_boolean] = ACTIONS(2531),
    [anon_sym_string] = ACTIONS(2531),
    [anon_sym_symbol] = ACTIONS(2531),
    [sym_readonly] = ACTIONS(2541),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_default] = ACTIONS(1137),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_typeof] = ACTIONS(1137),
    [anon_sym_import] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_else] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_await] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_do] = ACTIONS(1137),
    [anon_sym_try] = ACTIONS(1137),
    [anon_sym_with] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [anon_sym_debugger] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_throw] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_case] = ACTIONS(1137),
    [anon_sym_yield] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_class] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_new] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_BANG] = ACTIONS(1135),
    [anon_sym_TILDE] = ACTIONS(1135),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_delete] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym_number] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(1137),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [anon_sym_interface] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(2560),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(2562),
    [sym_identifier] = ACTIONS(2564),
    [anon_sym_export] = ACTIONS(2564),
    [anon_sym_default] = ACTIONS(2564),
    [anon_sym_namespace] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_type] = ACTIONS(2564),
    [anon_sym_typeof] = ACTIONS(2564),
    [anon_sym_import] = ACTIONS(2564),
    [anon_sym_var] = ACTIONS(2564),
    [anon_sym_let] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2564),
    [anon_sym_else] = ACTIONS(2564),
    [anon_sym_switch] = ACTIONS(2564),
    [anon_sym_for] = ACTIONS(2564),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_await] = ACTIONS(2564),
    [anon_sym_while] = ACTIONS(2564),
    [anon_sym_do] = ACTIONS(2564),
    [anon_sym_try] = ACTIONS(2564),
    [anon_sym_with] = ACTIONS(2564),
    [anon_sym_break] = ACTIONS(2564),
    [anon_sym_continue] = ACTIONS(2564),
    [anon_sym_debugger] = ACTIONS(2564),
    [anon_sym_return] = ACTIONS(2564),
    [anon_sym_throw] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_case] = ACTIONS(2564),
    [anon_sym_yield] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_SLASH] = ACTIONS(2564),
    [anon_sym_class] = ACTIONS(2564),
    [anon_sym_async] = ACTIONS(2564),
    [anon_sym_function] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_DASH] = ACTIONS(2564),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_void] = ACTIONS(2564),
    [anon_sym_delete] = ACTIONS(2564),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [sym_number] = ACTIONS(2562),
    [sym_this] = ACTIONS(2564),
    [sym_super] = ACTIONS(2564),
    [sym_true] = ACTIONS(2564),
    [sym_false] = ACTIONS(2564),
    [sym_null] = ACTIONS(2564),
    [sym_undefined] = ACTIONS(2564),
    [anon_sym_AT] = ACTIONS(2562),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_abstract] = ACTIONS(2564),
    [anon_sym_get] = ACTIONS(2564),
    [anon_sym_set] = ACTIONS(2564),
    [anon_sym_declare] = ACTIONS(2564),
    [anon_sym_public] = ACTIONS(2564),
    [anon_sym_private] = ACTIONS(2564),
    [anon_sym_protected] = ACTIONS(2564),
    [anon_sym_module] = ACTIONS(2564),
    [anon_sym_any] = ACTIONS(2564),
    [anon_sym_number] = ACTIONS(2564),
    [anon_sym_boolean] = ACTIONS(2564),
    [anon_sym_string] = ACTIONS(2564),
    [anon_sym_symbol] = ACTIONS(2564),
    [anon_sym_interface] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [sym_readonly] = ACTIONS(2564),
  },
  [472] = {
    [sym__call_signature] = STATE(2789),
    [sym_arguments] = STATE(1440),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_async] = ACTIONS(2572),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_void] = ACTIONS(2572),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_get] = ACTIONS(2572),
    [anon_sym_set] = ACTIONS(2572),
    [anon_sym_declare] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_module] = ACTIONS(2572),
    [anon_sym_any] = ACTIONS(2572),
    [anon_sym_number] = ACTIONS(2572),
    [anon_sym_boolean] = ACTIONS(2572),
    [anon_sym_string] = ACTIONS(2572),
    [anon_sym_symbol] = ACTIONS(2572),
    [sym_readonly] = ACTIONS(2572),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [473] = {
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(2580),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_default] = ACTIONS(2582),
    [anon_sym_namespace] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_type] = ACTIONS(2582),
    [anon_sym_typeof] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_var] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_switch] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_await] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_with] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_continue] = ACTIONS(2582),
    [anon_sym_debugger] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_throw] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2580),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_async] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_new] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2580),
    [anon_sym_TILDE] = ACTIONS(2580),
    [anon_sym_void] = ACTIONS(2582),
    [anon_sym_delete] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2580),
    [anon_sym_DQUOTE] = ACTIONS(2580),
    [anon_sym_SQUOTE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2580),
    [sym_number] = ACTIONS(2580),
    [sym_this] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_null] = ACTIONS(2582),
    [sym_undefined] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_static] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_get] = ACTIONS(2582),
    [anon_sym_set] = ACTIONS(2582),
    [anon_sym_declare] = ACTIONS(2582),
    [anon_sym_public] = ACTIONS(2582),
    [anon_sym_private] = ACTIONS(2582),
    [anon_sym_protected] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_any] = ACTIONS(2582),
    [anon_sym_number] = ACTIONS(2582),
    [anon_sym_boolean] = ACTIONS(2582),
    [anon_sym_string] = ACTIONS(2582),
    [anon_sym_symbol] = ACTIONS(2582),
    [anon_sym_interface] = ACTIONS(2582),
    [anon_sym_enum] = ACTIONS(2582),
    [sym_readonly] = ACTIONS(2582),
  },
  [475] = {
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [476] = {
    [sym__call_signature] = STATE(2935),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2543),
    [anon_sym_export] = ACTIONS(2545),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2545),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2545),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2545),
    [anon_sym_get] = ACTIONS(2545),
    [anon_sym_set] = ACTIONS(2545),
    [anon_sym_declare] = ACTIONS(2545),
    [anon_sym_public] = ACTIONS(2545),
    [anon_sym_private] = ACTIONS(2545),
    [anon_sym_protected] = ACTIONS(2545),
    [anon_sym_module] = ACTIONS(2545),
    [anon_sym_any] = ACTIONS(2545),
    [anon_sym_number] = ACTIONS(2545),
    [anon_sym_boolean] = ACTIONS(2545),
    [anon_sym_string] = ACTIONS(2545),
    [anon_sym_symbol] = ACTIONS(2545),
    [sym_readonly] = ACTIONS(2545),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(2590),
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_default] = ACTIONS(2592),
    [anon_sym_namespace] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_type] = ACTIONS(2592),
    [anon_sym_typeof] = ACTIONS(2592),
    [anon_sym_import] = ACTIONS(2592),
    [anon_sym_var] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_else] = ACTIONS(2592),
    [anon_sym_switch] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_await] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_do] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_with] = ACTIONS(2592),
    [anon_sym_break] = ACTIONS(2592),
    [anon_sym_continue] = ACTIONS(2592),
    [anon_sym_debugger] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_throw] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_case] = ACTIONS(2592),
    [anon_sym_yield] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_class] = ACTIONS(2592),
    [anon_sym_async] = ACTIONS(2592),
    [anon_sym_function] = ACTIONS(2592),
    [anon_sym_new] = ACTIONS(2592),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2590),
    [anon_sym_void] = ACTIONS(2592),
    [anon_sym_delete] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [sym_number] = ACTIONS(2590),
    [sym_this] = ACTIONS(2592),
    [sym_super] = ACTIONS(2592),
    [sym_true] = ACTIONS(2592),
    [sym_false] = ACTIONS(2592),
    [sym_null] = ACTIONS(2592),
    [sym_undefined] = ACTIONS(2592),
    [anon_sym_AT] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_abstract] = ACTIONS(2592),
    [anon_sym_get] = ACTIONS(2592),
    [anon_sym_set] = ACTIONS(2592),
    [anon_sym_declare] = ACTIONS(2592),
    [anon_sym_public] = ACTIONS(2592),
    [anon_sym_private] = ACTIONS(2592),
    [anon_sym_protected] = ACTIONS(2592),
    [anon_sym_module] = ACTIONS(2592),
    [anon_sym_any] = ACTIONS(2592),
    [anon_sym_number] = ACTIONS(2592),
    [anon_sym_boolean] = ACTIONS(2592),
    [anon_sym_string] = ACTIONS(2592),
    [anon_sym_symbol] = ACTIONS(2592),
    [anon_sym_interface] = ACTIONS(2592),
    [anon_sym_enum] = ACTIONS(2592),
    [sym_readonly] = ACTIONS(2592),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(2594),
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_export] = ACTIONS(2596),
    [anon_sym_default] = ACTIONS(2596),
    [anon_sym_namespace] = ACTIONS(2596),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2596),
    [anon_sym_typeof] = ACTIONS(2596),
    [anon_sym_import] = ACTIONS(2596),
    [anon_sym_var] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_else] = ACTIONS(2596),
    [anon_sym_switch] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_await] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [anon_sym_do] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_with] = ACTIONS(2596),
    [anon_sym_break] = ACTIONS(2596),
    [anon_sym_continue] = ACTIONS(2596),
    [anon_sym_debugger] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_throw] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_case] = ACTIONS(2596),
    [anon_sym_yield] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_SLASH] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_async] = ACTIONS(2596),
    [anon_sym_function] = ACTIONS(2596),
    [anon_sym_new] = ACTIONS(2596),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_BANG] = ACTIONS(2594),
    [anon_sym_TILDE] = ACTIONS(2594),
    [anon_sym_void] = ACTIONS(2596),
    [anon_sym_delete] = ACTIONS(2596),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [anon_sym_DQUOTE] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2594),
    [sym_number] = ACTIONS(2594),
    [sym_this] = ACTIONS(2596),
    [sym_super] = ACTIONS(2596),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [sym_null] = ACTIONS(2596),
    [sym_undefined] = ACTIONS(2596),
    [anon_sym_AT] = ACTIONS(2594),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_abstract] = ACTIONS(2596),
    [anon_sym_get] = ACTIONS(2596),
    [anon_sym_set] = ACTIONS(2596),
    [anon_sym_declare] = ACTIONS(2596),
    [anon_sym_public] = ACTIONS(2596),
    [anon_sym_private] = ACTIONS(2596),
    [anon_sym_protected] = ACTIONS(2596),
    [anon_sym_module] = ACTIONS(2596),
    [anon_sym_any] = ACTIONS(2596),
    [anon_sym_number] = ACTIONS(2596),
    [anon_sym_boolean] = ACTIONS(2596),
    [anon_sym_string] = ACTIONS(2596),
    [anon_sym_symbol] = ACTIONS(2596),
    [anon_sym_interface] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [sym_readonly] = ACTIONS(2596),
  },
  [479] = {
    [ts_builtin_sym_end] = ACTIONS(2598),
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_type] = ACTIONS(2600),
    [anon_sym_typeof] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_var] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_else] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_await] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_do] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_with] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_debugger] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_throw] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_case] = ACTIONS(2600),
    [anon_sym_yield] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_class] = ACTIONS(2600),
    [anon_sym_async] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_new] = ACTIONS(2600),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_void] = ACTIONS(2600),
    [anon_sym_delete] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [sym_number] = ACTIONS(2598),
    [sym_this] = ACTIONS(2600),
    [sym_super] = ACTIONS(2600),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [sym_null] = ACTIONS(2600),
    [sym_undefined] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2598),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_get] = ACTIONS(2600),
    [anon_sym_set] = ACTIONS(2600),
    [anon_sym_declare] = ACTIONS(2600),
    [anon_sym_public] = ACTIONS(2600),
    [anon_sym_private] = ACTIONS(2600),
    [anon_sym_protected] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_any] = ACTIONS(2600),
    [anon_sym_number] = ACTIONS(2600),
    [anon_sym_boolean] = ACTIONS(2600),
    [anon_sym_string] = ACTIONS(2600),
    [anon_sym_symbol] = ACTIONS(2600),
    [anon_sym_interface] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [sym_readonly] = ACTIONS(2600),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(2602),
    [sym_identifier] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_type] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_var] = ACTIONS(2604),
    [anon_sym_let] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_else] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_await] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_with] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_debugger] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_yield] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_async] = ACTIONS(2604),
    [anon_sym_function] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_AMP] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_TILDE] = ACTIONS(2602),
    [anon_sym_void] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [sym_number] = ACTIONS(2602),
    [sym_this] = ACTIONS(2604),
    [sym_super] = ACTIONS(2604),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [sym_null] = ACTIONS(2604),
    [sym_undefined] = ACTIONS(2604),
    [anon_sym_AT] = ACTIONS(2602),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_abstract] = ACTIONS(2604),
    [anon_sym_get] = ACTIONS(2604),
    [anon_sym_set] = ACTIONS(2604),
    [anon_sym_declare] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_any] = ACTIONS(2604),
    [anon_sym_number] = ACTIONS(2604),
    [anon_sym_boolean] = ACTIONS(2604),
    [anon_sym_string] = ACTIONS(2604),
    [anon_sym_symbol] = ACTIONS(2604),
    [anon_sym_interface] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [sym_readonly] = ACTIONS(2604),
  },
  [481] = {
    [sym_finally_clause] = STATE(518),
    [ts_builtin_sym_end] = ACTIONS(2606),
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2606),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_with] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_finally] = ACTIONS(2511),
    [anon_sym_yield] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2606),
    [anon_sym_LT] = ACTIONS(2606),
    [anon_sym_SLASH] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2606),
    [sym_number] = ACTIONS(2606),
    [sym_this] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [sym_null] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2606),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [sym_readonly] = ACTIONS(2608),
  },
  [482] = {
    [sym_statement_block] = STATE(553),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_default] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_let] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_await] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_do] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_debugger] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_throw] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_case] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(2346),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_function] = ACTIONS(1061),
    [anon_sym_new] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym_number] = ACTIONS(1059),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(1061),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_abstract] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_interface] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
  },
  [483] = {
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [484] = {
    [sym__call_signature] = STATE(2802),
    [sym_arguments] = STATE(1108),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(2614),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2614),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2614),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_void] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_static] = ACTIONS(2614),
    [anon_sym_get] = ACTIONS(2614),
    [anon_sym_set] = ACTIONS(2614),
    [anon_sym_declare] = ACTIONS(2614),
    [anon_sym_public] = ACTIONS(2614),
    [anon_sym_private] = ACTIONS(2614),
    [anon_sym_protected] = ACTIONS(2614),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_any] = ACTIONS(2614),
    [anon_sym_number] = ACTIONS(2614),
    [anon_sym_boolean] = ACTIONS(2614),
    [anon_sym_string] = ACTIONS(2614),
    [anon_sym_symbol] = ACTIONS(2614),
    [anon_sym_implements] = ACTIONS(491),
    [sym_readonly] = ACTIONS(2614),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(1099),
    [sym_identifier] = ACTIONS(1101),
    [anon_sym_export] = ACTIONS(1101),
    [anon_sym_default] = ACTIONS(1101),
    [anon_sym_namespace] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_type] = ACTIONS(1101),
    [anon_sym_typeof] = ACTIONS(1101),
    [anon_sym_import] = ACTIONS(1101),
    [anon_sym_var] = ACTIONS(1101),
    [anon_sym_let] = ACTIONS(1101),
    [anon_sym_const] = ACTIONS(1101),
    [anon_sym_if] = ACTIONS(1101),
    [anon_sym_else] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1101),
    [anon_sym_for] = ACTIONS(1101),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_await] = ACTIONS(1101),
    [anon_sym_while] = ACTIONS(1101),
    [anon_sym_do] = ACTIONS(1101),
    [anon_sym_try] = ACTIONS(1101),
    [anon_sym_with] = ACTIONS(1101),
    [anon_sym_break] = ACTIONS(1101),
    [anon_sym_continue] = ACTIONS(1101),
    [anon_sym_debugger] = ACTIONS(1101),
    [anon_sym_return] = ACTIONS(1101),
    [anon_sym_throw] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_case] = ACTIONS(1101),
    [anon_sym_yield] = ACTIONS(1101),
    [anon_sym_LBRACK] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_SLASH] = ACTIONS(1101),
    [anon_sym_class] = ACTIONS(1101),
    [anon_sym_async] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1101),
    [anon_sym_new] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_void] = ACTIONS(1101),
    [anon_sym_delete] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [sym_number] = ACTIONS(1099),
    [sym_this] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_true] = ACTIONS(1101),
    [sym_false] = ACTIONS(1101),
    [sym_null] = ACTIONS(1101),
    [sym_undefined] = ACTIONS(1101),
    [anon_sym_AT] = ACTIONS(1099),
    [anon_sym_static] = ACTIONS(1101),
    [anon_sym_abstract] = ACTIONS(1101),
    [anon_sym_get] = ACTIONS(1101),
    [anon_sym_set] = ACTIONS(1101),
    [anon_sym_declare] = ACTIONS(1101),
    [anon_sym_public] = ACTIONS(1101),
    [anon_sym_private] = ACTIONS(1101),
    [anon_sym_protected] = ACTIONS(1101),
    [anon_sym_module] = ACTIONS(1101),
    [anon_sym_any] = ACTIONS(1101),
    [anon_sym_number] = ACTIONS(1101),
    [anon_sym_boolean] = ACTIONS(1101),
    [anon_sym_string] = ACTIONS(1101),
    [anon_sym_symbol] = ACTIONS(1101),
    [anon_sym_interface] = ACTIONS(1101),
    [anon_sym_enum] = ACTIONS(1101),
    [sym_readonly] = ACTIONS(1101),
    [sym__automatic_semicolon] = ACTIONS(1107),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(1209),
    [sym_identifier] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1211),
    [anon_sym_default] = ACTIONS(1211),
    [anon_sym_namespace] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_type] = ACTIONS(1211),
    [anon_sym_typeof] = ACTIONS(1211),
    [anon_sym_import] = ACTIONS(1211),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_let] = ACTIONS(1211),
    [anon_sym_const] = ACTIONS(1211),
    [anon_sym_if] = ACTIONS(1211),
    [anon_sym_else] = ACTIONS(1211),
    [anon_sym_switch] = ACTIONS(1211),
    [anon_sym_for] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_await] = ACTIONS(1211),
    [anon_sym_while] = ACTIONS(1211),
    [anon_sym_do] = ACTIONS(1211),
    [anon_sym_try] = ACTIONS(1211),
    [anon_sym_with] = ACTIONS(1211),
    [anon_sym_break] = ACTIONS(1211),
    [anon_sym_continue] = ACTIONS(1211),
    [anon_sym_debugger] = ACTIONS(1211),
    [anon_sym_return] = ACTIONS(1211),
    [anon_sym_throw] = ACTIONS(1211),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_case] = ACTIONS(1211),
    [anon_sym_yield] = ACTIONS(1211),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1209),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_class] = ACTIONS(1211),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_function] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1211),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_void] = ACTIONS(1211),
    [anon_sym_delete] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_DASH_DASH] = ACTIONS(1209),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_SQUOTE] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1209),
    [sym_number] = ACTIONS(1209),
    [sym_this] = ACTIONS(1211),
    [sym_super] = ACTIONS(1211),
    [sym_true] = ACTIONS(1211),
    [sym_false] = ACTIONS(1211),
    [sym_null] = ACTIONS(1211),
    [sym_undefined] = ACTIONS(1211),
    [anon_sym_AT] = ACTIONS(1209),
    [anon_sym_static] = ACTIONS(1211),
    [anon_sym_abstract] = ACTIONS(1211),
    [anon_sym_get] = ACTIONS(1211),
    [anon_sym_set] = ACTIONS(1211),
    [anon_sym_declare] = ACTIONS(1211),
    [anon_sym_public] = ACTIONS(1211),
    [anon_sym_private] = ACTIONS(1211),
    [anon_sym_protected] = ACTIONS(1211),
    [anon_sym_module] = ACTIONS(1211),
    [anon_sym_any] = ACTIONS(1211),
    [anon_sym_number] = ACTIONS(1211),
    [anon_sym_boolean] = ACTIONS(1211),
    [anon_sym_string] = ACTIONS(1211),
    [anon_sym_symbol] = ACTIONS(1211),
    [anon_sym_interface] = ACTIONS(1211),
    [anon_sym_enum] = ACTIONS(1211),
    [sym_readonly] = ACTIONS(1211),
    [sym__automatic_semicolon] = ACTIONS(1217),
  },
  [487] = {
    [sym__call_signature] = STATE(2789),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_async] = ACTIONS(2572),
    [anon_sym_function] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2572),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_get] = ACTIONS(2572),
    [anon_sym_set] = ACTIONS(2572),
    [anon_sym_declare] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_module] = ACTIONS(2572),
    [anon_sym_any] = ACTIONS(2572),
    [anon_sym_number] = ACTIONS(2572),
    [anon_sym_boolean] = ACTIONS(2572),
    [anon_sym_string] = ACTIONS(2572),
    [anon_sym_symbol] = ACTIONS(2572),
    [sym_readonly] = ACTIONS(2572),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(2618),
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_export] = ACTIONS(2620),
    [anon_sym_default] = ACTIONS(2620),
    [anon_sym_namespace] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_type] = ACTIONS(2620),
    [anon_sym_typeof] = ACTIONS(2620),
    [anon_sym_import] = ACTIONS(2620),
    [anon_sym_var] = ACTIONS(2620),
    [anon_sym_let] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2620),
    [anon_sym_switch] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2618),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_await] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_with] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_debugger] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_throw] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_yield] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_SLASH] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_async] = ACTIONS(2620),
    [anon_sym_function] = ACTIONS(2620),
    [anon_sym_new] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [anon_sym_void] = ACTIONS(2620),
    [anon_sym_delete] = ACTIONS(2620),
    [anon_sym_PLUS_PLUS] = ACTIONS(2618),
    [anon_sym_DASH_DASH] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2618),
    [anon_sym_SQUOTE] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2618),
    [sym_number] = ACTIONS(2618),
    [sym_this] = ACTIONS(2620),
    [sym_super] = ACTIONS(2620),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [sym_null] = ACTIONS(2620),
    [sym_undefined] = ACTIONS(2620),
    [anon_sym_AT] = ACTIONS(2618),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_abstract] = ACTIONS(2620),
    [anon_sym_get] = ACTIONS(2620),
    [anon_sym_set] = ACTIONS(2620),
    [anon_sym_declare] = ACTIONS(2620),
    [anon_sym_public] = ACTIONS(2620),
    [anon_sym_private] = ACTIONS(2620),
    [anon_sym_protected] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_any] = ACTIONS(2620),
    [anon_sym_number] = ACTIONS(2620),
    [anon_sym_boolean] = ACTIONS(2620),
    [anon_sym_string] = ACTIONS(2620),
    [anon_sym_symbol] = ACTIONS(2620),
    [anon_sym_interface] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [sym_readonly] = ACTIONS(2620),
  },
  [489] = {
    [sym__call_signature] = STATE(2789),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_async] = ACTIONS(2572),
    [anon_sym_function] = ACTIONS(2370),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2572),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_get] = ACTIONS(2572),
    [anon_sym_set] = ACTIONS(2572),
    [anon_sym_declare] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_module] = ACTIONS(2572),
    [anon_sym_any] = ACTIONS(2572),
    [anon_sym_number] = ACTIONS(2572),
    [anon_sym_boolean] = ACTIONS(2572),
    [anon_sym_string] = ACTIONS(2572),
    [anon_sym_symbol] = ACTIONS(2572),
    [sym_readonly] = ACTIONS(2572),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(2622),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_export] = ACTIONS(2624),
    [anon_sym_default] = ACTIONS(2624),
    [anon_sym_namespace] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2624),
    [anon_sym_typeof] = ACTIONS(2624),
    [anon_sym_import] = ACTIONS(2624),
    [anon_sym_var] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_switch] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_await] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_with] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_continue] = ACTIONS(2624),
    [anon_sym_debugger] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_throw] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_finally] = ACTIONS(2624),
    [anon_sym_yield] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_async] = ACTIONS(2624),
    [anon_sym_function] = ACTIONS(2624),
    [anon_sym_new] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_void] = ACTIONS(2624),
    [anon_sym_delete] = ACTIONS(2624),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [anon_sym_DQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2622),
    [sym_number] = ACTIONS(2622),
    [sym_this] = ACTIONS(2624),
    [sym_super] = ACTIONS(2624),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [sym_null] = ACTIONS(2624),
    [sym_undefined] = ACTIONS(2624),
    [anon_sym_AT] = ACTIONS(2622),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_abstract] = ACTIONS(2624),
    [anon_sym_get] = ACTIONS(2624),
    [anon_sym_set] = ACTIONS(2624),
    [anon_sym_declare] = ACTIONS(2624),
    [anon_sym_public] = ACTIONS(2624),
    [anon_sym_private] = ACTIONS(2624),
    [anon_sym_protected] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_any] = ACTIONS(2624),
    [anon_sym_number] = ACTIONS(2624),
    [anon_sym_boolean] = ACTIONS(2624),
    [anon_sym_string] = ACTIONS(2624),
    [anon_sym_symbol] = ACTIONS(2624),
    [anon_sym_interface] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [sym_readonly] = ACTIONS(2624),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(1199),
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_export] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(1201),
    [anon_sym_namespace] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_type] = ACTIONS(1201),
    [anon_sym_typeof] = ACTIONS(1201),
    [anon_sym_import] = ACTIONS(1201),
    [anon_sym_var] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_const] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1199),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1201),
    [anon_sym_with] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [anon_sym_debugger] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_throw] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1199),
    [anon_sym_case] = ACTIONS(1201),
    [anon_sym_yield] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1199),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(1201),
    [anon_sym_class] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_new] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_TILDE] = ACTIONS(1199),
    [anon_sym_void] = ACTIONS(1201),
    [anon_sym_delete] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1199),
    [anon_sym_DASH_DASH] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1199),
    [sym_number] = ACTIONS(1199),
    [sym_this] = ACTIONS(1201),
    [sym_super] = ACTIONS(1201),
    [sym_true] = ACTIONS(1201),
    [sym_false] = ACTIONS(1201),
    [sym_null] = ACTIONS(1201),
    [sym_undefined] = ACTIONS(1201),
    [anon_sym_AT] = ACTIONS(1199),
    [anon_sym_static] = ACTIONS(1201),
    [anon_sym_abstract] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1201),
    [anon_sym_declare] = ACTIONS(1201),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1201),
    [anon_sym_any] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1201),
    [anon_sym_enum] = ACTIONS(1201),
    [sym_readonly] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1207),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2628),
    [anon_sym_default] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_type] = ACTIONS(2628),
    [anon_sym_typeof] = ACTIONS(2628),
    [anon_sym_import] = ACTIONS(2628),
    [anon_sym_var] = ACTIONS(2628),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_switch] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_await] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_with] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_continue] = ACTIONS(2628),
    [anon_sym_debugger] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_throw] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_finally] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_LT] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2628),
    [anon_sym_function] = ACTIONS(2628),
    [anon_sym_new] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_DASH] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [anon_sym_void] = ACTIONS(2628),
    [anon_sym_delete] = ACTIONS(2628),
    [anon_sym_PLUS_PLUS] = ACTIONS(2626),
    [anon_sym_DASH_DASH] = ACTIONS(2626),
    [anon_sym_DQUOTE] = ACTIONS(2626),
    [anon_sym_SQUOTE] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2626),
    [sym_number] = ACTIONS(2626),
    [sym_this] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [sym_null] = ACTIONS(2628),
    [sym_undefined] = ACTIONS(2628),
    [anon_sym_AT] = ACTIONS(2626),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_abstract] = ACTIONS(2628),
    [anon_sym_get] = ACTIONS(2628),
    [anon_sym_set] = ACTIONS(2628),
    [anon_sym_declare] = ACTIONS(2628),
    [anon_sym_public] = ACTIONS(2628),
    [anon_sym_private] = ACTIONS(2628),
    [anon_sym_protected] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_any] = ACTIONS(2628),
    [anon_sym_number] = ACTIONS(2628),
    [anon_sym_boolean] = ACTIONS(2628),
    [anon_sym_string] = ACTIONS(2628),
    [anon_sym_symbol] = ACTIONS(2628),
    [anon_sym_interface] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [sym_readonly] = ACTIONS(2628),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(2632),
    [anon_sym_default] = ACTIONS(2632),
    [anon_sym_namespace] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_type] = ACTIONS(2632),
    [anon_sym_typeof] = ACTIONS(2632),
    [anon_sym_import] = ACTIONS(2632),
    [anon_sym_var] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_switch] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_await] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_with] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_continue] = ACTIONS(2632),
    [anon_sym_debugger] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_throw] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_finally] = ACTIONS(2632),
    [anon_sym_yield] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_async] = ACTIONS(2632),
    [anon_sym_function] = ACTIONS(2632),
    [anon_sym_new] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_void] = ACTIONS(2632),
    [anon_sym_delete] = ACTIONS(2632),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2630),
    [sym_number] = ACTIONS(2630),
    [sym_this] = ACTIONS(2632),
    [sym_super] = ACTIONS(2632),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [sym_null] = ACTIONS(2632),
    [sym_undefined] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_abstract] = ACTIONS(2632),
    [anon_sym_get] = ACTIONS(2632),
    [anon_sym_set] = ACTIONS(2632),
    [anon_sym_declare] = ACTIONS(2632),
    [anon_sym_public] = ACTIONS(2632),
    [anon_sym_private] = ACTIONS(2632),
    [anon_sym_protected] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_any] = ACTIONS(2632),
    [anon_sym_number] = ACTIONS(2632),
    [anon_sym_boolean] = ACTIONS(2632),
    [anon_sym_string] = ACTIONS(2632),
    [anon_sym_symbol] = ACTIONS(2632),
    [anon_sym_interface] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [sym_readonly] = ACTIONS(2632),
  },
  [494] = {
    [ts_builtin_sym_end] = ACTIONS(1089),
    [sym_identifier] = ACTIONS(1091),
    [anon_sym_export] = ACTIONS(1091),
    [anon_sym_default] = ACTIONS(1091),
    [anon_sym_namespace] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_type] = ACTIONS(1091),
    [anon_sym_typeof] = ACTIONS(1091),
    [anon_sym_import] = ACTIONS(1091),
    [anon_sym_var] = ACTIONS(1091),
    [anon_sym_let] = ACTIONS(1091),
    [anon_sym_const] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_switch] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_await] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_do] = ACTIONS(1091),
    [anon_sym_try] = ACTIONS(1091),
    [anon_sym_with] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_continue] = ACTIONS(1091),
    [anon_sym_debugger] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_throw] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_case] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1089),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_async] = ACTIONS(1091),
    [anon_sym_function] = ACTIONS(1091),
    [anon_sym_new] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [anon_sym_void] = ACTIONS(1091),
    [anon_sym_delete] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_SQUOTE] = ACTIONS(1089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1089),
    [sym_number] = ACTIONS(1089),
    [sym_this] = ACTIONS(1091),
    [sym_super] = ACTIONS(1091),
    [sym_true] = ACTIONS(1091),
    [sym_false] = ACTIONS(1091),
    [sym_null] = ACTIONS(1091),
    [sym_undefined] = ACTIONS(1091),
    [anon_sym_AT] = ACTIONS(1089),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_abstract] = ACTIONS(1091),
    [anon_sym_get] = ACTIONS(1091),
    [anon_sym_set] = ACTIONS(1091),
    [anon_sym_declare] = ACTIONS(1091),
    [anon_sym_public] = ACTIONS(1091),
    [anon_sym_private] = ACTIONS(1091),
    [anon_sym_protected] = ACTIONS(1091),
    [anon_sym_module] = ACTIONS(1091),
    [anon_sym_any] = ACTIONS(1091),
    [anon_sym_number] = ACTIONS(1091),
    [anon_sym_boolean] = ACTIONS(1091),
    [anon_sym_string] = ACTIONS(1091),
    [anon_sym_symbol] = ACTIONS(1091),
    [anon_sym_interface] = ACTIONS(1091),
    [anon_sym_enum] = ACTIONS(1091),
    [sym_readonly] = ACTIONS(1091),
    [sym__automatic_semicolon] = ACTIONS(1097),
  },
  [495] = {
    [ts_builtin_sym_end] = ACTIONS(1151),
    [sym_identifier] = ACTIONS(1153),
    [anon_sym_export] = ACTIONS(1153),
    [anon_sym_default] = ACTIONS(1153),
    [anon_sym_namespace] = ACTIONS(1153),
    [anon_sym_LBRACE] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym_type] = ACTIONS(1153),
    [anon_sym_typeof] = ACTIONS(1153),
    [anon_sym_import] = ACTIONS(1153),
    [anon_sym_var] = ACTIONS(1153),
    [anon_sym_let] = ACTIONS(1153),
    [anon_sym_const] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_else] = ACTIONS(1153),
    [anon_sym_switch] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_await] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_do] = ACTIONS(1153),
    [anon_sym_try] = ACTIONS(1153),
    [anon_sym_with] = ACTIONS(1153),
    [anon_sym_break] = ACTIONS(1153),
    [anon_sym_continue] = ACTIONS(1153),
    [anon_sym_debugger] = ACTIONS(1153),
    [anon_sym_return] = ACTIONS(1153),
    [anon_sym_throw] = ACTIONS(1153),
    [anon_sym_SEMI] = ACTIONS(1151),
    [anon_sym_case] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [anon_sym_LT] = ACTIONS(1151),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_class] = ACTIONS(1153),
    [anon_sym_async] = ACTIONS(1153),
    [anon_sym_function] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(1153),
    [anon_sym_DASH] = ACTIONS(1153),
    [anon_sym_BANG] = ACTIONS(1151),
    [anon_sym_TILDE] = ACTIONS(1151),
    [anon_sym_void] = ACTIONS(1153),
    [anon_sym_delete] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1151),
    [anon_sym_DASH_DASH] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(1151),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1151),
    [sym_number] = ACTIONS(1151),
    [sym_this] = ACTIONS(1153),
    [sym_super] = ACTIONS(1153),
    [sym_true] = ACTIONS(1153),
    [sym_false] = ACTIONS(1153),
    [sym_null] = ACTIONS(1153),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(1151),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_abstract] = ACTIONS(1153),
    [anon_sym_get] = ACTIONS(1153),
    [anon_sym_set] = ACTIONS(1153),
    [anon_sym_declare] = ACTIONS(1153),
    [anon_sym_public] = ACTIONS(1153),
    [anon_sym_private] = ACTIONS(1153),
    [anon_sym_protected] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(1153),
    [anon_sym_number] = ACTIONS(1153),
    [anon_sym_boolean] = ACTIONS(1153),
    [anon_sym_string] = ACTIONS(1153),
    [anon_sym_symbol] = ACTIONS(1153),
    [anon_sym_interface] = ACTIONS(1153),
    [anon_sym_enum] = ACTIONS(1153),
    [sym_readonly] = ACTIONS(1153),
    [sym__automatic_semicolon] = ACTIONS(1159),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1175),
    [sym_identifier] = ACTIONS(1177),
    [anon_sym_export] = ACTIONS(1177),
    [anon_sym_default] = ACTIONS(1177),
    [anon_sym_namespace] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_type] = ACTIONS(1177),
    [anon_sym_typeof] = ACTIONS(1177),
    [anon_sym_import] = ACTIONS(1177),
    [anon_sym_var] = ACTIONS(1177),
    [anon_sym_let] = ACTIONS(1177),
    [anon_sym_const] = ACTIONS(1177),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_switch] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_await] = ACTIONS(1177),
    [anon_sym_while] = ACTIONS(1177),
    [anon_sym_do] = ACTIONS(1177),
    [anon_sym_try] = ACTIONS(1177),
    [anon_sym_with] = ACTIONS(1177),
    [anon_sym_break] = ACTIONS(1177),
    [anon_sym_continue] = ACTIONS(1177),
    [anon_sym_debugger] = ACTIONS(1177),
    [anon_sym_return] = ACTIONS(1177),
    [anon_sym_throw] = ACTIONS(1177),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_case] = ACTIONS(1177),
    [anon_sym_yield] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1177),
    [anon_sym_class] = ACTIONS(1177),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_function] = ACTIONS(1177),
    [anon_sym_new] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_BANG] = ACTIONS(1175),
    [anon_sym_TILDE] = ACTIONS(1175),
    [anon_sym_void] = ACTIONS(1177),
    [anon_sym_delete] = ACTIONS(1177),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_DASH_DASH] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1175),
    [sym_number] = ACTIONS(1175),
    [sym_this] = ACTIONS(1177),
    [sym_super] = ACTIONS(1177),
    [sym_true] = ACTIONS(1177),
    [sym_false] = ACTIONS(1177),
    [sym_null] = ACTIONS(1177),
    [sym_undefined] = ACTIONS(1177),
    [anon_sym_AT] = ACTIONS(1175),
    [anon_sym_static] = ACTIONS(1177),
    [anon_sym_abstract] = ACTIONS(1177),
    [anon_sym_get] = ACTIONS(1177),
    [anon_sym_set] = ACTIONS(1177),
    [anon_sym_declare] = ACTIONS(1177),
    [anon_sym_public] = ACTIONS(1177),
    [anon_sym_private] = ACTIONS(1177),
    [anon_sym_protected] = ACTIONS(1177),
    [anon_sym_module] = ACTIONS(1177),
    [anon_sym_any] = ACTIONS(1177),
    [anon_sym_number] = ACTIONS(1177),
    [anon_sym_boolean] = ACTIONS(1177),
    [anon_sym_string] = ACTIONS(1177),
    [anon_sym_symbol] = ACTIONS(1177),
    [anon_sym_interface] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(1177),
    [sym_readonly] = ACTIONS(1177),
    [sym__automatic_semicolon] = ACTIONS(1183),
  },
  [497] = {
    [sym__call_signature] = STATE(2789),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_async] = ACTIONS(2572),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2572),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_get] = ACTIONS(2572),
    [anon_sym_set] = ACTIONS(2572),
    [anon_sym_declare] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_module] = ACTIONS(2572),
    [anon_sym_any] = ACTIONS(2572),
    [anon_sym_number] = ACTIONS(2572),
    [anon_sym_boolean] = ACTIONS(2572),
    [anon_sym_string] = ACTIONS(2572),
    [anon_sym_symbol] = ACTIONS(2572),
    [sym_readonly] = ACTIONS(2572),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(1141),
    [sym_identifier] = ACTIONS(1143),
    [anon_sym_export] = ACTIONS(1143),
    [anon_sym_default] = ACTIONS(1143),
    [anon_sym_namespace] = ACTIONS(1143),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1141),
    [anon_sym_type] = ACTIONS(1143),
    [anon_sym_typeof] = ACTIONS(1143),
    [anon_sym_import] = ACTIONS(1143),
    [anon_sym_var] = ACTIONS(1143),
    [anon_sym_let] = ACTIONS(1143),
    [anon_sym_const] = ACTIONS(1143),
    [anon_sym_if] = ACTIONS(1143),
    [anon_sym_else] = ACTIONS(1143),
    [anon_sym_switch] = ACTIONS(1143),
    [anon_sym_for] = ACTIONS(1143),
    [anon_sym_LPAREN] = ACTIONS(1141),
    [anon_sym_await] = ACTIONS(1143),
    [anon_sym_while] = ACTIONS(1143),
    [anon_sym_do] = ACTIONS(1143),
    [anon_sym_try] = ACTIONS(1143),
    [anon_sym_with] = ACTIONS(1143),
    [anon_sym_break] = ACTIONS(1143),
    [anon_sym_continue] = ACTIONS(1143),
    [anon_sym_debugger] = ACTIONS(1143),
    [anon_sym_return] = ACTIONS(1143),
    [anon_sym_throw] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(1141),
    [anon_sym_case] = ACTIONS(1143),
    [anon_sym_yield] = ACTIONS(1143),
    [anon_sym_LBRACK] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(1141),
    [anon_sym_SLASH] = ACTIONS(1143),
    [anon_sym_class] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1143),
    [anon_sym_function] = ACTIONS(1143),
    [anon_sym_new] = ACTIONS(1143),
    [anon_sym_PLUS] = ACTIONS(1143),
    [anon_sym_DASH] = ACTIONS(1143),
    [anon_sym_BANG] = ACTIONS(1141),
    [anon_sym_TILDE] = ACTIONS(1141),
    [anon_sym_void] = ACTIONS(1143),
    [anon_sym_delete] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1141),
    [anon_sym_DASH_DASH] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1141),
    [anon_sym_SQUOTE] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [sym_number] = ACTIONS(1141),
    [sym_this] = ACTIONS(1143),
    [sym_super] = ACTIONS(1143),
    [sym_true] = ACTIONS(1143),
    [sym_false] = ACTIONS(1143),
    [sym_null] = ACTIONS(1143),
    [sym_undefined] = ACTIONS(1143),
    [anon_sym_AT] = ACTIONS(1141),
    [anon_sym_static] = ACTIONS(1143),
    [anon_sym_abstract] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(1143),
    [anon_sym_set] = ACTIONS(1143),
    [anon_sym_declare] = ACTIONS(1143),
    [anon_sym_public] = ACTIONS(1143),
    [anon_sym_private] = ACTIONS(1143),
    [anon_sym_protected] = ACTIONS(1143),
    [anon_sym_module] = ACTIONS(1143),
    [anon_sym_any] = ACTIONS(1143),
    [anon_sym_number] = ACTIONS(1143),
    [anon_sym_boolean] = ACTIONS(1143),
    [anon_sym_string] = ACTIONS(1143),
    [anon_sym_symbol] = ACTIONS(1143),
    [anon_sym_interface] = ACTIONS(1143),
    [anon_sym_enum] = ACTIONS(1143),
    [sym_readonly] = ACTIONS(1143),
    [sym__automatic_semicolon] = ACTIONS(1149),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(1191),
    [anon_sym_export] = ACTIONS(1191),
    [anon_sym_default] = ACTIONS(1191),
    [anon_sym_namespace] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(1191),
    [anon_sym_typeof] = ACTIONS(1191),
    [anon_sym_import] = ACTIONS(1191),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_let] = ACTIONS(1191),
    [anon_sym_const] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1191),
    [anon_sym_switch] = ACTIONS(1191),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_await] = ACTIONS(1191),
    [anon_sym_while] = ACTIONS(1191),
    [anon_sym_do] = ACTIONS(1191),
    [anon_sym_try] = ACTIONS(1191),
    [anon_sym_with] = ACTIONS(1191),
    [anon_sym_break] = ACTIONS(1191),
    [anon_sym_continue] = ACTIONS(1191),
    [anon_sym_debugger] = ACTIONS(1191),
    [anon_sym_return] = ACTIONS(1191),
    [anon_sym_throw] = ACTIONS(1191),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_case] = ACTIONS(1191),
    [anon_sym_yield] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1191),
    [anon_sym_class] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_function] = ACTIONS(1191),
    [anon_sym_new] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1189),
    [anon_sym_TILDE] = ACTIONS(1189),
    [anon_sym_void] = ACTIONS(1191),
    [anon_sym_delete] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1189),
    [anon_sym_DASH_DASH] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1189),
    [sym_number] = ACTIONS(1189),
    [sym_this] = ACTIONS(1191),
    [sym_super] = ACTIONS(1191),
    [sym_true] = ACTIONS(1191),
    [sym_false] = ACTIONS(1191),
    [sym_null] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(1189),
    [anon_sym_static] = ACTIONS(1191),
    [anon_sym_abstract] = ACTIONS(1191),
    [anon_sym_get] = ACTIONS(1191),
    [anon_sym_set] = ACTIONS(1191),
    [anon_sym_declare] = ACTIONS(1191),
    [anon_sym_public] = ACTIONS(1191),
    [anon_sym_private] = ACTIONS(1191),
    [anon_sym_protected] = ACTIONS(1191),
    [anon_sym_module] = ACTIONS(1191),
    [anon_sym_any] = ACTIONS(1191),
    [anon_sym_number] = ACTIONS(1191),
    [anon_sym_boolean] = ACTIONS(1191),
    [anon_sym_string] = ACTIONS(1191),
    [anon_sym_symbol] = ACTIONS(1191),
    [anon_sym_interface] = ACTIONS(1191),
    [anon_sym_enum] = ACTIONS(1191),
    [sym_readonly] = ACTIONS(1191),
    [sym__automatic_semicolon] = ACTIONS(1197),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2636),
    [anon_sym_default] = ACTIONS(2636),
    [anon_sym_namespace] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_type] = ACTIONS(2636),
    [anon_sym_typeof] = ACTIONS(2636),
    [anon_sym_import] = ACTIONS(2636),
    [anon_sym_var] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2636),
    [anon_sym_switch] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_await] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_with] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_continue] = ACTIONS(2636),
    [anon_sym_debugger] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_throw] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_finally] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_async] = ACTIONS(2636),
    [anon_sym_function] = ACTIONS(2636),
    [anon_sym_new] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_void] = ACTIONS(2636),
    [anon_sym_delete] = ACTIONS(2636),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2634),
    [sym_number] = ACTIONS(2634),
    [sym_this] = ACTIONS(2636),
    [sym_super] = ACTIONS(2636),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [sym_null] = ACTIONS(2636),
    [sym_undefined] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2634),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_abstract] = ACTIONS(2636),
    [anon_sym_get] = ACTIONS(2636),
    [anon_sym_set] = ACTIONS(2636),
    [anon_sym_declare] = ACTIONS(2636),
    [anon_sym_public] = ACTIONS(2636),
    [anon_sym_private] = ACTIONS(2636),
    [anon_sym_protected] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_any] = ACTIONS(2636),
    [anon_sym_number] = ACTIONS(2636),
    [anon_sym_boolean] = ACTIONS(2636),
    [anon_sym_string] = ACTIONS(2636),
    [anon_sym_symbol] = ACTIONS(2636),
    [anon_sym_interface] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [sym_readonly] = ACTIONS(2636),
  },
  [501] = {
    [sym__call_signature] = STATE(2789),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2572),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_async] = ACTIONS(2572),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2572),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_get] = ACTIONS(2572),
    [anon_sym_set] = ACTIONS(2572),
    [anon_sym_declare] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_module] = ACTIONS(2572),
    [anon_sym_any] = ACTIONS(2572),
    [anon_sym_number] = ACTIONS(2572),
    [anon_sym_boolean] = ACTIONS(2572),
    [anon_sym_string] = ACTIONS(2572),
    [anon_sym_symbol] = ACTIONS(2572),
    [sym_readonly] = ACTIONS(2572),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1161),
    [sym_identifier] = ACTIONS(1163),
    [anon_sym_export] = ACTIONS(1163),
    [anon_sym_default] = ACTIONS(1163),
    [anon_sym_namespace] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1161),
    [anon_sym_RBRACE] = ACTIONS(1161),
    [anon_sym_type] = ACTIONS(1163),
    [anon_sym_typeof] = ACTIONS(1163),
    [anon_sym_import] = ACTIONS(1163),
    [anon_sym_var] = ACTIONS(1163),
    [anon_sym_let] = ACTIONS(1163),
    [anon_sym_const] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(1163),
    [anon_sym_else] = ACTIONS(1163),
    [anon_sym_switch] = ACTIONS(1163),
    [anon_sym_for] = ACTIONS(1163),
    [anon_sym_LPAREN] = ACTIONS(1161),
    [anon_sym_await] = ACTIONS(1163),
    [anon_sym_while] = ACTIONS(1163),
    [anon_sym_do] = ACTIONS(1163),
    [anon_sym_try] = ACTIONS(1163),
    [anon_sym_with] = ACTIONS(1163),
    [anon_sym_break] = ACTIONS(1163),
    [anon_sym_continue] = ACTIONS(1163),
    [anon_sym_debugger] = ACTIONS(1163),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_throw] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1161),
    [anon_sym_case] = ACTIONS(1163),
    [anon_sym_yield] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1161),
    [anon_sym_LT] = ACTIONS(1161),
    [anon_sym_SLASH] = ACTIONS(1163),
    [anon_sym_class] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1163),
    [anon_sym_function] = ACTIONS(1163),
    [anon_sym_new] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_void] = ACTIONS(1163),
    [anon_sym_delete] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_DQUOTE] = ACTIONS(1161),
    [anon_sym_SQUOTE] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1161),
    [sym_number] = ACTIONS(1161),
    [sym_this] = ACTIONS(1163),
    [sym_super] = ACTIONS(1163),
    [sym_true] = ACTIONS(1163),
    [sym_false] = ACTIONS(1163),
    [sym_null] = ACTIONS(1163),
    [sym_undefined] = ACTIONS(1163),
    [anon_sym_AT] = ACTIONS(1161),
    [anon_sym_static] = ACTIONS(1163),
    [anon_sym_abstract] = ACTIONS(1163),
    [anon_sym_get] = ACTIONS(1163),
    [anon_sym_set] = ACTIONS(1163),
    [anon_sym_declare] = ACTIONS(1163),
    [anon_sym_public] = ACTIONS(1163),
    [anon_sym_private] = ACTIONS(1163),
    [anon_sym_protected] = ACTIONS(1163),
    [anon_sym_module] = ACTIONS(1163),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_interface] = ACTIONS(1163),
    [anon_sym_enum] = ACTIONS(1163),
    [sym_readonly] = ACTIONS(1163),
    [sym__automatic_semicolon] = ACTIONS(1169),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1221),
    [anon_sym_export] = ACTIONS(1221),
    [anon_sym_default] = ACTIONS(1221),
    [anon_sym_namespace] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1219),
    [anon_sym_RBRACE] = ACTIONS(1219),
    [anon_sym_type] = ACTIONS(1221),
    [anon_sym_typeof] = ACTIONS(1221),
    [anon_sym_import] = ACTIONS(1221),
    [anon_sym_var] = ACTIONS(1221),
    [anon_sym_let] = ACTIONS(1221),
    [anon_sym_const] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1221),
    [anon_sym_else] = ACTIONS(1221),
    [anon_sym_switch] = ACTIONS(1221),
    [anon_sym_for] = ACTIONS(1221),
    [anon_sym_LPAREN] = ACTIONS(1219),
    [anon_sym_await] = ACTIONS(1221),
    [anon_sym_while] = ACTIONS(1221),
    [anon_sym_do] = ACTIONS(1221),
    [anon_sym_try] = ACTIONS(1221),
    [anon_sym_with] = ACTIONS(1221),
    [anon_sym_break] = ACTIONS(1221),
    [anon_sym_continue] = ACTIONS(1221),
    [anon_sym_debugger] = ACTIONS(1221),
    [anon_sym_return] = ACTIONS(1221),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym_case] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1219),
    [anon_sym_LT] = ACTIONS(1219),
    [anon_sym_SLASH] = ACTIONS(1221),
    [anon_sym_class] = ACTIONS(1221),
    [anon_sym_async] = ACTIONS(1221),
    [anon_sym_function] = ACTIONS(1221),
    [anon_sym_new] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1221),
    [anon_sym_DASH] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1219),
    [anon_sym_TILDE] = ACTIONS(1219),
    [anon_sym_void] = ACTIONS(1221),
    [anon_sym_delete] = ACTIONS(1221),
    [anon_sym_PLUS_PLUS] = ACTIONS(1219),
    [anon_sym_DASH_DASH] = ACTIONS(1219),
    [anon_sym_DQUOTE] = ACTIONS(1219),
    [anon_sym_SQUOTE] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1219),
    [sym_number] = ACTIONS(1219),
    [sym_this] = ACTIONS(1221),
    [sym_super] = ACTIONS(1221),
    [sym_true] = ACTIONS(1221),
    [sym_false] = ACTIONS(1221),
    [sym_null] = ACTIONS(1221),
    [sym_undefined] = ACTIONS(1221),
    [anon_sym_AT] = ACTIONS(1219),
    [anon_sym_static] = ACTIONS(1221),
    [anon_sym_abstract] = ACTIONS(1221),
    [anon_sym_get] = ACTIONS(1221),
    [anon_sym_set] = ACTIONS(1221),
    [anon_sym_declare] = ACTIONS(1221),
    [anon_sym_public] = ACTIONS(1221),
    [anon_sym_private] = ACTIONS(1221),
    [anon_sym_protected] = ACTIONS(1221),
    [anon_sym_module] = ACTIONS(1221),
    [anon_sym_any] = ACTIONS(1221),
    [anon_sym_number] = ACTIONS(1221),
    [anon_sym_boolean] = ACTIONS(1221),
    [anon_sym_string] = ACTIONS(1221),
    [anon_sym_symbol] = ACTIONS(1221),
    [anon_sym_interface] = ACTIONS(1221),
    [anon_sym_enum] = ACTIONS(1221),
    [sym_readonly] = ACTIONS(1221),
    [sym__automatic_semicolon] = ACTIONS(1227),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1125),
    [sym_identifier] = ACTIONS(1127),
    [anon_sym_export] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(1127),
    [anon_sym_namespace] = ACTIONS(1127),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym_type] = ACTIONS(1127),
    [anon_sym_typeof] = ACTIONS(1127),
    [anon_sym_import] = ACTIONS(1127),
    [anon_sym_var] = ACTIONS(1127),
    [anon_sym_let] = ACTIONS(1127),
    [anon_sym_const] = ACTIONS(1127),
    [anon_sym_if] = ACTIONS(1127),
    [anon_sym_else] = ACTIONS(1127),
    [anon_sym_switch] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1127),
    [anon_sym_LPAREN] = ACTIONS(1125),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_while] = ACTIONS(1127),
    [anon_sym_do] = ACTIONS(1127),
    [anon_sym_try] = ACTIONS(1127),
    [anon_sym_with] = ACTIONS(1127),
    [anon_sym_break] = ACTIONS(1127),
    [anon_sym_continue] = ACTIONS(1127),
    [anon_sym_debugger] = ACTIONS(1127),
    [anon_sym_return] = ACTIONS(1127),
    [anon_sym_throw] = ACTIONS(1127),
    [anon_sym_SEMI] = ACTIONS(1125),
    [anon_sym_case] = ACTIONS(1127),
    [anon_sym_yield] = ACTIONS(1127),
    [anon_sym_LBRACK] = ACTIONS(1125),
    [anon_sym_LT] = ACTIONS(1125),
    [anon_sym_SLASH] = ACTIONS(1127),
    [anon_sym_class] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1127),
    [anon_sym_function] = ACTIONS(1127),
    [anon_sym_new] = ACTIONS(1127),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_BANG] = ACTIONS(1125),
    [anon_sym_TILDE] = ACTIONS(1125),
    [anon_sym_void] = ACTIONS(1127),
    [anon_sym_delete] = ACTIONS(1127),
    [anon_sym_PLUS_PLUS] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1125),
    [sym_number] = ACTIONS(1125),
    [sym_this] = ACTIONS(1127),
    [sym_super] = ACTIONS(1127),
    [sym_true] = ACTIONS(1127),
    [sym_false] = ACTIONS(1127),
    [sym_null] = ACTIONS(1127),
    [sym_undefined] = ACTIONS(1127),
    [anon_sym_AT] = ACTIONS(1125),
    [anon_sym_static] = ACTIONS(1127),
    [anon_sym_abstract] = ACTIONS(1127),
    [anon_sym_get] = ACTIONS(1127),
    [anon_sym_set] = ACTIONS(1127),
    [anon_sym_declare] = ACTIONS(1127),
    [anon_sym_public] = ACTIONS(1127),
    [anon_sym_private] = ACTIONS(1127),
    [anon_sym_protected] = ACTIONS(1127),
    [anon_sym_module] = ACTIONS(1127),
    [anon_sym_any] = ACTIONS(1127),
    [anon_sym_number] = ACTIONS(1127),
    [anon_sym_boolean] = ACTIONS(1127),
    [anon_sym_string] = ACTIONS(1127),
    [anon_sym_symbol] = ACTIONS(1127),
    [anon_sym_interface] = ACTIONS(1127),
    [anon_sym_enum] = ACTIONS(1127),
    [sym_readonly] = ACTIONS(1127),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [505] = {
    [sym__call_signature] = STATE(2891),
    [sym_arguments] = STATE(1568),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_export] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2642),
    [anon_sym_async] = ACTIONS(2640),
    [anon_sym_function] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_void] = ACTIONS(2640),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_get] = ACTIONS(2640),
    [anon_sym_set] = ACTIONS(2640),
    [anon_sym_declare] = ACTIONS(2640),
    [anon_sym_public] = ACTIONS(2640),
    [anon_sym_private] = ACTIONS(2640),
    [anon_sym_protected] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_any] = ACTIONS(2640),
    [anon_sym_number] = ACTIONS(2640),
    [anon_sym_boolean] = ACTIONS(2640),
    [anon_sym_string] = ACTIONS(2640),
    [anon_sym_symbol] = ACTIONS(2640),
    [sym_readonly] = ACTIONS(2640),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [506] = {
    [sym_statement_block] = STATE(553),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_default] = ACTIONS(1061),
    [anon_sym_namespace] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_type] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_let] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_await] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_do] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_debugger] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_throw] = ACTIONS(1061),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_case] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_function] = ACTIONS(1061),
    [anon_sym_new] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_void] = ACTIONS(1061),
    [anon_sym_delete] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_SQUOTE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym_number] = ACTIONS(1059),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(1061),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_abstract] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [anon_sym_declare] = ACTIONS(1061),
    [anon_sym_public] = ACTIONS(1061),
    [anon_sym_private] = ACTIONS(1061),
    [anon_sym_protected] = ACTIONS(1061),
    [anon_sym_module] = ACTIONS(1061),
    [anon_sym_any] = ACTIONS(1061),
    [anon_sym_number] = ACTIONS(1061),
    [anon_sym_boolean] = ACTIONS(1061),
    [anon_sym_string] = ACTIONS(1061),
    [anon_sym_symbol] = ACTIONS(1061),
    [anon_sym_interface] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [sym_readonly] = ACTIONS(1061),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_default] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_type] = ACTIONS(2648),
    [anon_sym_typeof] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_var] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_else] = ACTIONS(2648),
    [anon_sym_switch] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2646),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_await] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_do] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_with] = ACTIONS(2648),
    [anon_sym_break] = ACTIONS(2648),
    [anon_sym_continue] = ACTIONS(2648),
    [anon_sym_debugger] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_throw] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_case] = ACTIONS(2648),
    [anon_sym_yield] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LT] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_class] = ACTIONS(2648),
    [anon_sym_async] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_new] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [anon_sym_void] = ACTIONS(2648),
    [anon_sym_delete] = ACTIONS(2648),
    [anon_sym_PLUS_PLUS] = ACTIONS(2646),
    [anon_sym_DASH_DASH] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [anon_sym_SQUOTE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [sym_number] = ACTIONS(2646),
    [sym_this] = ACTIONS(2648),
    [sym_super] = ACTIONS(2648),
    [sym_true] = ACTIONS(2648),
    [sym_false] = ACTIONS(2648),
    [sym_null] = ACTIONS(2648),
    [sym_undefined] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(2646),
    [anon_sym_static] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_get] = ACTIONS(2648),
    [anon_sym_set] = ACTIONS(2648),
    [anon_sym_declare] = ACTIONS(2648),
    [anon_sym_public] = ACTIONS(2648),
    [anon_sym_private] = ACTIONS(2648),
    [anon_sym_protected] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_any] = ACTIONS(2648),
    [anon_sym_number] = ACTIONS(2648),
    [anon_sym_boolean] = ACTIONS(2648),
    [anon_sym_string] = ACTIONS(2648),
    [anon_sym_symbol] = ACTIONS(2648),
    [anon_sym_interface] = ACTIONS(2648),
    [anon_sym_enum] = ACTIONS(2648),
    [sym_readonly] = ACTIONS(2648),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1077),
    [sym_identifier] = ACTIONS(1079),
    [anon_sym_export] = ACTIONS(1079),
    [anon_sym_default] = ACTIONS(1079),
    [anon_sym_namespace] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_type] = ACTIONS(1079),
    [anon_sym_typeof] = ACTIONS(1079),
    [anon_sym_import] = ACTIONS(1079),
    [anon_sym_var] = ACTIONS(1079),
    [anon_sym_let] = ACTIONS(1079),
    [anon_sym_const] = ACTIONS(1079),
    [anon_sym_if] = ACTIONS(1079),
    [anon_sym_else] = ACTIONS(1079),
    [anon_sym_switch] = ACTIONS(1079),
    [anon_sym_for] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(1079),
    [anon_sym_while] = ACTIONS(1079),
    [anon_sym_do] = ACTIONS(1079),
    [anon_sym_try] = ACTIONS(1079),
    [anon_sym_with] = ACTIONS(1079),
    [anon_sym_break] = ACTIONS(1079),
    [anon_sym_continue] = ACTIONS(1079),
    [anon_sym_debugger] = ACTIONS(1079),
    [anon_sym_return] = ACTIONS(1079),
    [anon_sym_throw] = ACTIONS(1079),
    [anon_sym_SEMI] = ACTIONS(1077),
    [anon_sym_case] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1079),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1079),
    [anon_sym_class] = ACTIONS(1079),
    [anon_sym_async] = ACTIONS(1079),
    [anon_sym_function] = ACTIONS(1079),
    [anon_sym_new] = ACTIONS(1079),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [anon_sym_void] = ACTIONS(1079),
    [anon_sym_delete] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1077),
    [anon_sym_DASH_DASH] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1077),
    [anon_sym_SQUOTE] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1077),
    [sym_number] = ACTIONS(1077),
    [sym_this] = ACTIONS(1079),
    [sym_super] = ACTIONS(1079),
    [sym_true] = ACTIONS(1079),
    [sym_false] = ACTIONS(1079),
    [sym_null] = ACTIONS(1079),
    [sym_undefined] = ACTIONS(1079),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_static] = ACTIONS(1079),
    [anon_sym_abstract] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(1079),
    [anon_sym_set] = ACTIONS(1079),
    [anon_sym_declare] = ACTIONS(1079),
    [anon_sym_public] = ACTIONS(1079),
    [anon_sym_private] = ACTIONS(1079),
    [anon_sym_protected] = ACTIONS(1079),
    [anon_sym_module] = ACTIONS(1079),
    [anon_sym_any] = ACTIONS(1079),
    [anon_sym_number] = ACTIONS(1079),
    [anon_sym_boolean] = ACTIONS(1079),
    [anon_sym_string] = ACTIONS(1079),
    [anon_sym_symbol] = ACTIONS(1079),
    [anon_sym_interface] = ACTIONS(1079),
    [anon_sym_enum] = ACTIONS(1079),
    [sym_readonly] = ACTIONS(1079),
    [sym__automatic_semicolon] = ACTIONS(1085),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(2650),
    [sym_identifier] = ACTIONS(2652),
    [anon_sym_export] = ACTIONS(2652),
    [anon_sym_default] = ACTIONS(2652),
    [anon_sym_namespace] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_type] = ACTIONS(2652),
    [anon_sym_typeof] = ACTIONS(2652),
    [anon_sym_import] = ACTIONS(2652),
    [anon_sym_var] = ACTIONS(2652),
    [anon_sym_let] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_if] = ACTIONS(2652),
    [anon_sym_else] = ACTIONS(2652),
    [anon_sym_switch] = ACTIONS(2652),
    [anon_sym_for] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(2650),
    [anon_sym_await] = ACTIONS(2652),
    [anon_sym_while] = ACTIONS(2652),
    [anon_sym_do] = ACTIONS(2652),
    [anon_sym_try] = ACTIONS(2652),
    [anon_sym_with] = ACTIONS(2652),
    [anon_sym_break] = ACTIONS(2652),
    [anon_sym_continue] = ACTIONS(2652),
    [anon_sym_debugger] = ACTIONS(2652),
    [anon_sym_return] = ACTIONS(2652),
    [anon_sym_throw] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym_case] = ACTIONS(2652),
    [anon_sym_yield] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2650),
    [anon_sym_LT] = ACTIONS(2650),
    [anon_sym_SLASH] = ACTIONS(2652),
    [anon_sym_class] = ACTIONS(2652),
    [anon_sym_async] = ACTIONS(2652),
    [anon_sym_function] = ACTIONS(2652),
    [anon_sym_new] = ACTIONS(2652),
    [anon_sym_PLUS] = ACTIONS(2652),
    [anon_sym_DASH] = ACTIONS(2652),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_TILDE] = ACTIONS(2650),
    [anon_sym_void] = ACTIONS(2652),
    [anon_sym_delete] = ACTIONS(2652),
    [anon_sym_PLUS_PLUS] = ACTIONS(2650),
    [anon_sym_DASH_DASH] = ACTIONS(2650),
    [anon_sym_DQUOTE] = ACTIONS(2650),
    [anon_sym_SQUOTE] = ACTIONS(2650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2650),
    [sym_number] = ACTIONS(2650),
    [sym_this] = ACTIONS(2652),
    [sym_super] = ACTIONS(2652),
    [sym_true] = ACTIONS(2652),
    [sym_false] = ACTIONS(2652),
    [sym_null] = ACTIONS(2652),
    [sym_undefined] = ACTIONS(2652),
    [anon_sym_AT] = ACTIONS(2650),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_abstract] = ACTIONS(2652),
    [anon_sym_get] = ACTIONS(2652),
    [anon_sym_set] = ACTIONS(2652),
    [anon_sym_declare] = ACTIONS(2652),
    [anon_sym_public] = ACTIONS(2652),
    [anon_sym_private] = ACTIONS(2652),
    [anon_sym_protected] = ACTIONS(2652),
    [anon_sym_module] = ACTIONS(2652),
    [anon_sym_any] = ACTIONS(2652),
    [anon_sym_number] = ACTIONS(2652),
    [anon_sym_boolean] = ACTIONS(2652),
    [anon_sym_string] = ACTIONS(2652),
    [anon_sym_symbol] = ACTIONS(2652),
    [anon_sym_interface] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [sym_readonly] = ACTIONS(2652),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(2654),
    [sym_identifier] = ACTIONS(2656),
    [anon_sym_export] = ACTIONS(2656),
    [anon_sym_default] = ACTIONS(2656),
    [anon_sym_namespace] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_type] = ACTIONS(2656),
    [anon_sym_typeof] = ACTIONS(2656),
    [anon_sym_import] = ACTIONS(2656),
    [anon_sym_var] = ACTIONS(2656),
    [anon_sym_let] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2656),
    [anon_sym_else] = ACTIONS(2656),
    [anon_sym_switch] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2654),
    [anon_sym_await] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(2656),
    [anon_sym_do] = ACTIONS(2656),
    [anon_sym_try] = ACTIONS(2656),
    [anon_sym_with] = ACTIONS(2656),
    [anon_sym_break] = ACTIONS(2656),
    [anon_sym_continue] = ACTIONS(2656),
    [anon_sym_debugger] = ACTIONS(2656),
    [anon_sym_return] = ACTIONS(2656),
    [anon_sym_throw] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym_case] = ACTIONS(2656),
    [anon_sym_yield] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_function] = ACTIONS(2656),
    [anon_sym_new] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2656),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2654),
    [anon_sym_void] = ACTIONS(2656),
    [anon_sym_delete] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2654),
    [anon_sym_DASH_DASH] = ACTIONS(2654),
    [anon_sym_DQUOTE] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2654),
    [sym_number] = ACTIONS(2654),
    [sym_this] = ACTIONS(2656),
    [sym_super] = ACTIONS(2656),
    [sym_true] = ACTIONS(2656),
    [sym_false] = ACTIONS(2656),
    [sym_null] = ACTIONS(2656),
    [sym_undefined] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2654),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_abstract] = ACTIONS(2656),
    [anon_sym_get] = ACTIONS(2656),
    [anon_sym_set] = ACTIONS(2656),
    [anon_sym_declare] = ACTIONS(2656),
    [anon_sym_public] = ACTIONS(2656),
    [anon_sym_private] = ACTIONS(2656),
    [anon_sym_protected] = ACTIONS(2656),
    [anon_sym_module] = ACTIONS(2656),
    [anon_sym_any] = ACTIONS(2656),
    [anon_sym_number] = ACTIONS(2656),
    [anon_sym_boolean] = ACTIONS(2656),
    [anon_sym_string] = ACTIONS(2656),
    [anon_sym_symbol] = ACTIONS(2656),
    [anon_sym_interface] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [sym_readonly] = ACTIONS(2656),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(2658),
    [sym_identifier] = ACTIONS(2660),
    [anon_sym_export] = ACTIONS(2660),
    [anon_sym_default] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2658),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_type] = ACTIONS(2660),
    [anon_sym_typeof] = ACTIONS(2660),
    [anon_sym_import] = ACTIONS(2660),
    [anon_sym_var] = ACTIONS(2660),
    [anon_sym_let] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2660),
    [anon_sym_else] = ACTIONS(2660),
    [anon_sym_switch] = ACTIONS(2660),
    [anon_sym_for] = ACTIONS(2660),
    [anon_sym_LPAREN] = ACTIONS(2658),
    [anon_sym_await] = ACTIONS(2660),
    [anon_sym_while] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_try] = ACTIONS(2660),
    [anon_sym_with] = ACTIONS(2660),
    [anon_sym_break] = ACTIONS(2660),
    [anon_sym_continue] = ACTIONS(2660),
    [anon_sym_debugger] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(2660),
    [anon_sym_throw] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_case] = ACTIONS(2660),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2658),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_async] = ACTIONS(2660),
    [anon_sym_function] = ACTIONS(2660),
    [anon_sym_new] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2660),
    [anon_sym_DASH] = ACTIONS(2660),
    [anon_sym_BANG] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_void] = ACTIONS(2660),
    [anon_sym_delete] = ACTIONS(2660),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2658),
    [sym_number] = ACTIONS(2658),
    [sym_this] = ACTIONS(2660),
    [sym_super] = ACTIONS(2660),
    [sym_true] = ACTIONS(2660),
    [sym_false] = ACTIONS(2660),
    [sym_null] = ACTIONS(2660),
    [sym_undefined] = ACTIONS(2660),
    [anon_sym_AT] = ACTIONS(2658),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_abstract] = ACTIONS(2660),
    [anon_sym_get] = ACTIONS(2660),
    [anon_sym_set] = ACTIONS(2660),
    [anon_sym_declare] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2660),
    [anon_sym_private] = ACTIONS(2660),
    [anon_sym_protected] = ACTIONS(2660),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_any] = ACTIONS(2660),
    [anon_sym_number] = ACTIONS(2660),
    [anon_sym_boolean] = ACTIONS(2660),
    [anon_sym_string] = ACTIONS(2660),
    [anon_sym_symbol] = ACTIONS(2660),
    [anon_sym_interface] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [sym_readonly] = ACTIONS(2660),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(2662),
    [sym_identifier] = ACTIONS(2664),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_default] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_type] = ACTIONS(2664),
    [anon_sym_typeof] = ACTIONS(2664),
    [anon_sym_import] = ACTIONS(2664),
    [anon_sym_var] = ACTIONS(2664),
    [anon_sym_let] = ACTIONS(2664),
    [anon_sym_const] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_else] = ACTIONS(2664),
    [anon_sym_switch] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_LPAREN] = ACTIONS(2662),
    [anon_sym_await] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_do] = ACTIONS(2664),
    [anon_sym_try] = ACTIONS(2664),
    [anon_sym_with] = ACTIONS(2664),
    [anon_sym_break] = ACTIONS(2664),
    [anon_sym_continue] = ACTIONS(2664),
    [anon_sym_debugger] = ACTIONS(2664),
    [anon_sym_return] = ACTIONS(2664),
    [anon_sym_throw] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym_case] = ACTIONS(2664),
    [anon_sym_yield] = ACTIONS(2664),
    [anon_sym_LBRACK] = ACTIONS(2662),
    [anon_sym_LT] = ACTIONS(2662),
    [anon_sym_SLASH] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2664),
    [anon_sym_async] = ACTIONS(2664),
    [anon_sym_function] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2664),
    [anon_sym_PLUS] = ACTIONS(2664),
    [anon_sym_DASH] = ACTIONS(2664),
    [anon_sym_BANG] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_void] = ACTIONS(2664),
    [anon_sym_delete] = ACTIONS(2664),
    [anon_sym_PLUS_PLUS] = ACTIONS(2662),
    [anon_sym_DASH_DASH] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [sym_number] = ACTIONS(2662),
    [sym_this] = ACTIONS(2664),
    [sym_super] = ACTIONS(2664),
    [sym_true] = ACTIONS(2664),
    [sym_false] = ACTIONS(2664),
    [sym_null] = ACTIONS(2664),
    [sym_undefined] = ACTIONS(2664),
    [anon_sym_AT] = ACTIONS(2662),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_abstract] = ACTIONS(2664),
    [anon_sym_get] = ACTIONS(2664),
    [anon_sym_set] = ACTIONS(2664),
    [anon_sym_declare] = ACTIONS(2664),
    [anon_sym_public] = ACTIONS(2664),
    [anon_sym_private] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(2664),
    [anon_sym_number] = ACTIONS(2664),
    [anon_sym_boolean] = ACTIONS(2664),
    [anon_sym_string] = ACTIONS(2664),
    [anon_sym_symbol] = ACTIONS(2664),
    [anon_sym_interface] = ACTIONS(2664),
    [anon_sym_enum] = ACTIONS(2664),
    [sym_readonly] = ACTIONS(2664),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(2666),
    [sym_identifier] = ACTIONS(2668),
    [anon_sym_export] = ACTIONS(2668),
    [anon_sym_default] = ACTIONS(2668),
    [anon_sym_namespace] = ACTIONS(2668),
    [anon_sym_LBRACE] = ACTIONS(2666),
    [anon_sym_RBRACE] = ACTIONS(2666),
    [anon_sym_type] = ACTIONS(2668),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_import] = ACTIONS(2668),
    [anon_sym_var] = ACTIONS(2668),
    [anon_sym_let] = ACTIONS(2668),
    [anon_sym_const] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_else] = ACTIONS(2668),
    [anon_sym_switch] = ACTIONS(2668),
    [anon_sym_for] = ACTIONS(2668),
    [anon_sym_LPAREN] = ACTIONS(2666),
    [anon_sym_await] = ACTIONS(2668),
    [anon_sym_while] = ACTIONS(2668),
    [anon_sym_do] = ACTIONS(2668),
    [anon_sym_try] = ACTIONS(2668),
    [anon_sym_with] = ACTIONS(2668),
    [anon_sym_break] = ACTIONS(2668),
    [anon_sym_continue] = ACTIONS(2668),
    [anon_sym_debugger] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2668),
    [anon_sym_throw] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_case] = ACTIONS(2668),
    [anon_sym_yield] = ACTIONS(2668),
    [anon_sym_LBRACK] = ACTIONS(2666),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_SLASH] = ACTIONS(2668),
    [anon_sym_class] = ACTIONS(2668),
    [anon_sym_async] = ACTIONS(2668),
    [anon_sym_function] = ACTIONS(2668),
    [anon_sym_new] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2666),
    [anon_sym_TILDE] = ACTIONS(2666),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2666),
    [anon_sym_DASH_DASH] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2666),
    [sym_number] = ACTIONS(2666),
    [sym_this] = ACTIONS(2668),
    [sym_super] = ACTIONS(2668),
    [sym_true] = ACTIONS(2668),
    [sym_false] = ACTIONS(2668),
    [sym_null] = ACTIONS(2668),
    [sym_undefined] = ACTIONS(2668),
    [anon_sym_AT] = ACTIONS(2666),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_abstract] = ACTIONS(2668),
    [anon_sym_get] = ACTIONS(2668),
    [anon_sym_set] = ACTIONS(2668),
    [anon_sym_declare] = ACTIONS(2668),
    [anon_sym_public] = ACTIONS(2668),
    [anon_sym_private] = ACTIONS(2668),
    [anon_sym_protected] = ACTIONS(2668),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_any] = ACTIONS(2668),
    [anon_sym_number] = ACTIONS(2668),
    [anon_sym_boolean] = ACTIONS(2668),
    [anon_sym_string] = ACTIONS(2668),
    [anon_sym_symbol] = ACTIONS(2668),
    [anon_sym_interface] = ACTIONS(2668),
    [anon_sym_enum] = ACTIONS(2668),
    [sym_readonly] = ACTIONS(2668),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(2670),
    [sym_identifier] = ACTIONS(2672),
    [anon_sym_export] = ACTIONS(2672),
    [anon_sym_default] = ACTIONS(2672),
    [anon_sym_namespace] = ACTIONS(2672),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_type] = ACTIONS(2672),
    [anon_sym_typeof] = ACTIONS(2672),
    [anon_sym_import] = ACTIONS(2672),
    [anon_sym_var] = ACTIONS(2672),
    [anon_sym_let] = ACTIONS(2672),
    [anon_sym_const] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2672),
    [anon_sym_else] = ACTIONS(2672),
    [anon_sym_switch] = ACTIONS(2672),
    [anon_sym_for] = ACTIONS(2672),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_await] = ACTIONS(2672),
    [anon_sym_while] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2672),
    [anon_sym_with] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2672),
    [anon_sym_continue] = ACTIONS(2672),
    [anon_sym_debugger] = ACTIONS(2672),
    [anon_sym_return] = ACTIONS(2672),
    [anon_sym_throw] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_case] = ACTIONS(2672),
    [anon_sym_yield] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2670),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_SLASH] = ACTIONS(2672),
    [anon_sym_class] = ACTIONS(2672),
    [anon_sym_async] = ACTIONS(2672),
    [anon_sym_function] = ACTIONS(2672),
    [anon_sym_new] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2672),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_void] = ACTIONS(2672),
    [anon_sym_delete] = ACTIONS(2672),
    [anon_sym_PLUS_PLUS] = ACTIONS(2670),
    [anon_sym_DASH_DASH] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2670),
    [sym_number] = ACTIONS(2670),
    [sym_this] = ACTIONS(2672),
    [sym_super] = ACTIONS(2672),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [sym_null] = ACTIONS(2672),
    [sym_undefined] = ACTIONS(2672),
    [anon_sym_AT] = ACTIONS(2670),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_abstract] = ACTIONS(2672),
    [anon_sym_get] = ACTIONS(2672),
    [anon_sym_set] = ACTIONS(2672),
    [anon_sym_declare] = ACTIONS(2672),
    [anon_sym_public] = ACTIONS(2672),
    [anon_sym_private] = ACTIONS(2672),
    [anon_sym_protected] = ACTIONS(2672),
    [anon_sym_module] = ACTIONS(2672),
    [anon_sym_any] = ACTIONS(2672),
    [anon_sym_number] = ACTIONS(2672),
    [anon_sym_boolean] = ACTIONS(2672),
    [anon_sym_string] = ACTIONS(2672),
    [anon_sym_symbol] = ACTIONS(2672),
    [anon_sym_interface] = ACTIONS(2672),
    [anon_sym_enum] = ACTIONS(2672),
    [sym_readonly] = ACTIONS(2672),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(2674),
    [sym_identifier] = ACTIONS(2676),
    [anon_sym_export] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2674),
    [anon_sym_RBRACE] = ACTIONS(2674),
    [anon_sym_type] = ACTIONS(2676),
    [anon_sym_typeof] = ACTIONS(2676),
    [anon_sym_import] = ACTIONS(2676),
    [anon_sym_var] = ACTIONS(2676),
    [anon_sym_let] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_else] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_LPAREN] = ACTIONS(2674),
    [anon_sym_await] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_with] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_debugger] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_yield] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2674),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_SLASH] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_async] = ACTIONS(2676),
    [anon_sym_function] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_BANG] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_void] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_PLUS_PLUS] = ACTIONS(2674),
    [anon_sym_DASH_DASH] = ACTIONS(2674),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2674),
    [sym_number] = ACTIONS(2674),
    [sym_this] = ACTIONS(2676),
    [sym_super] = ACTIONS(2676),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [sym_null] = ACTIONS(2676),
    [sym_undefined] = ACTIONS(2676),
    [anon_sym_AT] = ACTIONS(2674),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_abstract] = ACTIONS(2676),
    [anon_sym_get] = ACTIONS(2676),
    [anon_sym_set] = ACTIONS(2676),
    [anon_sym_declare] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2676),
    [anon_sym_any] = ACTIONS(2676),
    [anon_sym_number] = ACTIONS(2676),
    [anon_sym_boolean] = ACTIONS(2676),
    [anon_sym_string] = ACTIONS(2676),
    [anon_sym_symbol] = ACTIONS(2676),
    [anon_sym_interface] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [sym_readonly] = ACTIONS(2676),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(2678),
    [sym_identifier] = ACTIONS(2680),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_default] = ACTIONS(2680),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2680),
    [anon_sym_import] = ACTIONS(2680),
    [anon_sym_var] = ACTIONS(2680),
    [anon_sym_let] = ACTIONS(2680),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2680),
    [anon_sym_switch] = ACTIONS(2680),
    [anon_sym_for] = ACTIONS(2680),
    [anon_sym_LPAREN] = ACTIONS(2678),
    [anon_sym_await] = ACTIONS(2680),
    [anon_sym_while] = ACTIONS(2680),
    [anon_sym_do] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(2680),
    [anon_sym_with] = ACTIONS(2680),
    [anon_sym_break] = ACTIONS(2680),
    [anon_sym_continue] = ACTIONS(2680),
    [anon_sym_debugger] = ACTIONS(2680),
    [anon_sym_return] = ACTIONS(2680),
    [anon_sym_throw] = ACTIONS(2680),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_case] = ACTIONS(2680),
    [anon_sym_yield] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2680),
    [anon_sym_class] = ACTIONS(2680),
    [anon_sym_async] = ACTIONS(2680),
    [anon_sym_function] = ACTIONS(2680),
    [anon_sym_new] = ACTIONS(2680),
    [anon_sym_PLUS] = ACTIONS(2680),
    [anon_sym_DASH] = ACTIONS(2680),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_void] = ACTIONS(2680),
    [anon_sym_delete] = ACTIONS(2680),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2678),
    [sym_number] = ACTIONS(2678),
    [sym_this] = ACTIONS(2680),
    [sym_super] = ACTIONS(2680),
    [sym_true] = ACTIONS(2680),
    [sym_false] = ACTIONS(2680),
    [sym_null] = ACTIONS(2680),
    [sym_undefined] = ACTIONS(2680),
    [anon_sym_AT] = ACTIONS(2678),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_abstract] = ACTIONS(2680),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
    [anon_sym_declare] = ACTIONS(2680),
    [anon_sym_public] = ACTIONS(2680),
    [anon_sym_private] = ACTIONS(2680),
    [anon_sym_protected] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_any] = ACTIONS(2680),
    [anon_sym_number] = ACTIONS(2680),
    [anon_sym_boolean] = ACTIONS(2680),
    [anon_sym_string] = ACTIONS(2680),
    [anon_sym_symbol] = ACTIONS(2680),
    [anon_sym_interface] = ACTIONS(2680),
    [anon_sym_enum] = ACTIONS(2680),
    [sym_readonly] = ACTIONS(2680),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(2682),
    [sym_identifier] = ACTIONS(2684),
    [anon_sym_export] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2684),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_RBRACE] = ACTIONS(2682),
    [anon_sym_type] = ACTIONS(2684),
    [anon_sym_typeof] = ACTIONS(2684),
    [anon_sym_import] = ACTIONS(2684),
    [anon_sym_var] = ACTIONS(2684),
    [anon_sym_let] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2684),
    [anon_sym_else] = ACTIONS(2684),
    [anon_sym_switch] = ACTIONS(2684),
    [anon_sym_for] = ACTIONS(2684),
    [anon_sym_LPAREN] = ACTIONS(2682),
    [anon_sym_await] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2684),
    [anon_sym_do] = ACTIONS(2684),
    [anon_sym_try] = ACTIONS(2684),
    [anon_sym_with] = ACTIONS(2684),
    [anon_sym_break] = ACTIONS(2684),
    [anon_sym_continue] = ACTIONS(2684),
    [anon_sym_debugger] = ACTIONS(2684),
    [anon_sym_return] = ACTIONS(2684),
    [anon_sym_throw] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym_case] = ACTIONS(2684),
    [anon_sym_yield] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2682),
    [anon_sym_LT] = ACTIONS(2682),
    [anon_sym_SLASH] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_async] = ACTIONS(2684),
    [anon_sym_function] = ACTIONS(2684),
    [anon_sym_new] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2684),
    [anon_sym_DASH] = ACTIONS(2684),
    [anon_sym_BANG] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2682),
    [anon_sym_void] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(2684),
    [anon_sym_PLUS_PLUS] = ACTIONS(2682),
    [anon_sym_DASH_DASH] = ACTIONS(2682),
    [anon_sym_DQUOTE] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2682),
    [sym_number] = ACTIONS(2682),
    [sym_this] = ACTIONS(2684),
    [sym_super] = ACTIONS(2684),
    [sym_true] = ACTIONS(2684),
    [sym_false] = ACTIONS(2684),
    [sym_null] = ACTIONS(2684),
    [sym_undefined] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2682),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_abstract] = ACTIONS(2684),
    [anon_sym_get] = ACTIONS(2684),
    [anon_sym_set] = ACTIONS(2684),
    [anon_sym_declare] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2684),
    [anon_sym_any] = ACTIONS(2684),
    [anon_sym_number] = ACTIONS(2684),
    [anon_sym_boolean] = ACTIONS(2684),
    [anon_sym_string] = ACTIONS(2684),
    [anon_sym_symbol] = ACTIONS(2684),
    [anon_sym_interface] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [sym_readonly] = ACTIONS(2684),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(2686),
    [sym_identifier] = ACTIONS(2688),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_default] = ACTIONS(2688),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_LBRACE] = ACTIONS(2686),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_type] = ACTIONS(2688),
    [anon_sym_typeof] = ACTIONS(2688),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_var] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(2688),
    [anon_sym_const] = ACTIONS(2688),
    [anon_sym_if] = ACTIONS(2688),
    [anon_sym_else] = ACTIONS(2688),
    [anon_sym_switch] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2688),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [anon_sym_await] = ACTIONS(2688),
    [anon_sym_while] = ACTIONS(2688),
    [anon_sym_do] = ACTIONS(2688),
    [anon_sym_try] = ACTIONS(2688),
    [anon_sym_with] = ACTIONS(2688),
    [anon_sym_break] = ACTIONS(2688),
    [anon_sym_continue] = ACTIONS(2688),
    [anon_sym_debugger] = ACTIONS(2688),
    [anon_sym_return] = ACTIONS(2688),
    [anon_sym_throw] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_case] = ACTIONS(2688),
    [anon_sym_yield] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(2686),
    [anon_sym_LT] = ACTIONS(2686),
    [anon_sym_SLASH] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2688),
    [anon_sym_async] = ACTIONS(2688),
    [anon_sym_function] = ACTIONS(2688),
    [anon_sym_new] = ACTIONS(2688),
    [anon_sym_PLUS] = ACTIONS(2688),
    [anon_sym_DASH] = ACTIONS(2688),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_void] = ACTIONS(2688),
    [anon_sym_delete] = ACTIONS(2688),
    [anon_sym_PLUS_PLUS] = ACTIONS(2686),
    [anon_sym_DASH_DASH] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2686),
    [sym_number] = ACTIONS(2686),
    [sym_this] = ACTIONS(2688),
    [sym_super] = ACTIONS(2688),
    [sym_true] = ACTIONS(2688),
    [sym_false] = ACTIONS(2688),
    [sym_null] = ACTIONS(2688),
    [sym_undefined] = ACTIONS(2688),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_abstract] = ACTIONS(2688),
    [anon_sym_get] = ACTIONS(2688),
    [anon_sym_set] = ACTIONS(2688),
    [anon_sym_declare] = ACTIONS(2688),
    [anon_sym_public] = ACTIONS(2688),
    [anon_sym_private] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(2688),
    [anon_sym_number] = ACTIONS(2688),
    [anon_sym_boolean] = ACTIONS(2688),
    [anon_sym_string] = ACTIONS(2688),
    [anon_sym_symbol] = ACTIONS(2688),
    [anon_sym_interface] = ACTIONS(2688),
    [anon_sym_enum] = ACTIONS(2688),
    [sym_readonly] = ACTIONS(2688),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_export] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2690),
    [anon_sym_RBRACE] = ACTIONS(2690),
    [anon_sym_type] = ACTIONS(2692),
    [anon_sym_typeof] = ACTIONS(2692),
    [anon_sym_import] = ACTIONS(2692),
    [anon_sym_var] = ACTIONS(2692),
    [anon_sym_let] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_else] = ACTIONS(2692),
    [anon_sym_switch] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_LPAREN] = ACTIONS(2690),
    [anon_sym_await] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_with] = ACTIONS(2692),
    [anon_sym_break] = ACTIONS(2692),
    [anon_sym_continue] = ACTIONS(2692),
    [anon_sym_debugger] = ACTIONS(2692),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_throw] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_yield] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_SLASH] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_async] = ACTIONS(2692),
    [anon_sym_function] = ACTIONS(2692),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_BANG] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [anon_sym_void] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2690),
    [sym_number] = ACTIONS(2690),
    [sym_this] = ACTIONS(2692),
    [sym_super] = ACTIONS(2692),
    [sym_true] = ACTIONS(2692),
    [sym_false] = ACTIONS(2692),
    [sym_null] = ACTIONS(2692),
    [sym_undefined] = ACTIONS(2692),
    [anon_sym_AT] = ACTIONS(2690),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_abstract] = ACTIONS(2692),
    [anon_sym_get] = ACTIONS(2692),
    [anon_sym_set] = ACTIONS(2692),
    [anon_sym_declare] = ACTIONS(2692),
    [anon_sym_public] = ACTIONS(2692),
    [anon_sym_private] = ACTIONS(2692),
    [anon_sym_protected] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_any] = ACTIONS(2692),
    [anon_sym_number] = ACTIONS(2692),
    [anon_sym_boolean] = ACTIONS(2692),
    [anon_sym_string] = ACTIONS(2692),
    [anon_sym_symbol] = ACTIONS(2692),
    [anon_sym_interface] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [sym_readonly] = ACTIONS(2692),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(2694),
    [sym_identifier] = ACTIONS(2696),
    [anon_sym_export] = ACTIONS(2696),
    [anon_sym_default] = ACTIONS(2696),
    [anon_sym_namespace] = ACTIONS(2696),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_type] = ACTIONS(2696),
    [anon_sym_typeof] = ACTIONS(2696),
    [anon_sym_import] = ACTIONS(2696),
    [anon_sym_var] = ACTIONS(2696),
    [anon_sym_let] = ACTIONS(2696),
    [anon_sym_const] = ACTIONS(2696),
    [anon_sym_if] = ACTIONS(2696),
    [anon_sym_else] = ACTIONS(2696),
    [anon_sym_switch] = ACTIONS(2696),
    [anon_sym_for] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(2694),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_while] = ACTIONS(2696),
    [anon_sym_do] = ACTIONS(2696),
    [anon_sym_try] = ACTIONS(2696),
    [anon_sym_with] = ACTIONS(2696),
    [anon_sym_break] = ACTIONS(2696),
    [anon_sym_continue] = ACTIONS(2696),
    [anon_sym_debugger] = ACTIONS(2696),
    [anon_sym_return] = ACTIONS(2696),
    [anon_sym_throw] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym_case] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2694),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_SLASH] = ACTIONS(2696),
    [anon_sym_class] = ACTIONS(2696),
    [anon_sym_async] = ACTIONS(2696),
    [anon_sym_function] = ACTIONS(2696),
    [anon_sym_new] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2696),
    [anon_sym_BANG] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2694),
    [anon_sym_void] = ACTIONS(2696),
    [anon_sym_delete] = ACTIONS(2696),
    [anon_sym_PLUS_PLUS] = ACTIONS(2694),
    [anon_sym_DASH_DASH] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [anon_sym_SQUOTE] = ACTIONS(2694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2694),
    [sym_number] = ACTIONS(2694),
    [sym_this] = ACTIONS(2696),
    [sym_super] = ACTIONS(2696),
    [sym_true] = ACTIONS(2696),
    [sym_false] = ACTIONS(2696),
    [sym_null] = ACTIONS(2696),
    [sym_undefined] = ACTIONS(2696),
    [anon_sym_AT] = ACTIONS(2694),
    [anon_sym_static] = ACTIONS(2696),
    [anon_sym_abstract] = ACTIONS(2696),
    [anon_sym_get] = ACTIONS(2696),
    [anon_sym_set] = ACTIONS(2696),
    [anon_sym_declare] = ACTIONS(2696),
    [anon_sym_public] = ACTIONS(2696),
    [anon_sym_private] = ACTIONS(2696),
    [anon_sym_protected] = ACTIONS(2696),
    [anon_sym_module] = ACTIONS(2696),
    [anon_sym_any] = ACTIONS(2696),
    [anon_sym_number] = ACTIONS(2696),
    [anon_sym_boolean] = ACTIONS(2696),
    [anon_sym_string] = ACTIONS(2696),
    [anon_sym_symbol] = ACTIONS(2696),
    [anon_sym_interface] = ACTIONS(2696),
    [anon_sym_enum] = ACTIONS(2696),
    [sym_readonly] = ACTIONS(2696),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(2698),
    [sym_identifier] = ACTIONS(2700),
    [anon_sym_export] = ACTIONS(2700),
    [anon_sym_default] = ACTIONS(2700),
    [anon_sym_namespace] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [anon_sym_type] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2700),
    [anon_sym_import] = ACTIONS(2700),
    [anon_sym_var] = ACTIONS(2700),
    [anon_sym_let] = ACTIONS(2700),
    [anon_sym_const] = ACTIONS(2700),
    [anon_sym_if] = ACTIONS(2700),
    [anon_sym_else] = ACTIONS(2700),
    [anon_sym_switch] = ACTIONS(2700),
    [anon_sym_for] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_await] = ACTIONS(2700),
    [anon_sym_while] = ACTIONS(2700),
    [anon_sym_do] = ACTIONS(2700),
    [anon_sym_try] = ACTIONS(2700),
    [anon_sym_with] = ACTIONS(2700),
    [anon_sym_break] = ACTIONS(2700),
    [anon_sym_continue] = ACTIONS(2700),
    [anon_sym_debugger] = ACTIONS(2700),
    [anon_sym_return] = ACTIONS(2700),
    [anon_sym_throw] = ACTIONS(2700),
    [anon_sym_SEMI] = ACTIONS(2698),
    [anon_sym_case] = ACTIONS(2700),
    [anon_sym_yield] = ACTIONS(2700),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_class] = ACTIONS(2700),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(2700),
    [anon_sym_new] = ACTIONS(2700),
    [anon_sym_PLUS] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2700),
    [anon_sym_BANG] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2698),
    [anon_sym_void] = ACTIONS(2700),
    [anon_sym_delete] = ACTIONS(2700),
    [anon_sym_PLUS_PLUS] = ACTIONS(2698),
    [anon_sym_DASH_DASH] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(2698),
    [anon_sym_SQUOTE] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2698),
    [sym_number] = ACTIONS(2698),
    [sym_this] = ACTIONS(2700),
    [sym_super] = ACTIONS(2700),
    [sym_true] = ACTIONS(2700),
    [sym_false] = ACTIONS(2700),
    [sym_null] = ACTIONS(2700),
    [sym_undefined] = ACTIONS(2700),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_static] = ACTIONS(2700),
    [anon_sym_abstract] = ACTIONS(2700),
    [anon_sym_get] = ACTIONS(2700),
    [anon_sym_set] = ACTIONS(2700),
    [anon_sym_declare] = ACTIONS(2700),
    [anon_sym_public] = ACTIONS(2700),
    [anon_sym_private] = ACTIONS(2700),
    [anon_sym_protected] = ACTIONS(2700),
    [anon_sym_module] = ACTIONS(2700),
    [anon_sym_any] = ACTIONS(2700),
    [anon_sym_number] = ACTIONS(2700),
    [anon_sym_boolean] = ACTIONS(2700),
    [anon_sym_string] = ACTIONS(2700),
    [anon_sym_symbol] = ACTIONS(2700),
    [anon_sym_interface] = ACTIONS(2700),
    [anon_sym_enum] = ACTIONS(2700),
    [sym_readonly] = ACTIONS(2700),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(2702),
    [sym_identifier] = ACTIONS(2704),
    [anon_sym_export] = ACTIONS(2704),
    [anon_sym_default] = ACTIONS(2704),
    [anon_sym_namespace] = ACTIONS(2704),
    [anon_sym_LBRACE] = ACTIONS(2702),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_type] = ACTIONS(2704),
    [anon_sym_typeof] = ACTIONS(2704),
    [anon_sym_import] = ACTIONS(2704),
    [anon_sym_var] = ACTIONS(2704),
    [anon_sym_let] = ACTIONS(2704),
    [anon_sym_const] = ACTIONS(2704),
    [anon_sym_if] = ACTIONS(2704),
    [anon_sym_else] = ACTIONS(2704),
    [anon_sym_switch] = ACTIONS(2704),
    [anon_sym_for] = ACTIONS(2704),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_await] = ACTIONS(2704),
    [anon_sym_while] = ACTIONS(2704),
    [anon_sym_do] = ACTIONS(2704),
    [anon_sym_try] = ACTIONS(2704),
    [anon_sym_with] = ACTIONS(2704),
    [anon_sym_break] = ACTIONS(2704),
    [anon_sym_continue] = ACTIONS(2704),
    [anon_sym_debugger] = ACTIONS(2704),
    [anon_sym_return] = ACTIONS(2704),
    [anon_sym_throw] = ACTIONS(2704),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_case] = ACTIONS(2704),
    [anon_sym_yield] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(2702),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_SLASH] = ACTIONS(2704),
    [anon_sym_class] = ACTIONS(2704),
    [anon_sym_async] = ACTIONS(2704),
    [anon_sym_function] = ACTIONS(2704),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_BANG] = ACTIONS(2702),
    [anon_sym_TILDE] = ACTIONS(2702),
    [anon_sym_void] = ACTIONS(2704),
    [anon_sym_delete] = ACTIONS(2704),
    [anon_sym_PLUS_PLUS] = ACTIONS(2702),
    [anon_sym_DASH_DASH] = ACTIONS(2702),
    [anon_sym_DQUOTE] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2702),
    [sym_number] = ACTIONS(2702),
    [sym_this] = ACTIONS(2704),
    [sym_super] = ACTIONS(2704),
    [sym_true] = ACTIONS(2704),
    [sym_false] = ACTIONS(2704),
    [sym_null] = ACTIONS(2704),
    [sym_undefined] = ACTIONS(2704),
    [anon_sym_AT] = ACTIONS(2702),
    [anon_sym_static] = ACTIONS(2704),
    [anon_sym_abstract] = ACTIONS(2704),
    [anon_sym_get] = ACTIONS(2704),
    [anon_sym_set] = ACTIONS(2704),
    [anon_sym_declare] = ACTIONS(2704),
    [anon_sym_public] = ACTIONS(2704),
    [anon_sym_private] = ACTIONS(2704),
    [anon_sym_protected] = ACTIONS(2704),
    [anon_sym_module] = ACTIONS(2704),
    [anon_sym_any] = ACTIONS(2704),
    [anon_sym_number] = ACTIONS(2704),
    [anon_sym_boolean] = ACTIONS(2704),
    [anon_sym_string] = ACTIONS(2704),
    [anon_sym_symbol] = ACTIONS(2704),
    [anon_sym_interface] = ACTIONS(2704),
    [anon_sym_enum] = ACTIONS(2704),
    [sym_readonly] = ACTIONS(2704),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(2706),
    [sym_identifier] = ACTIONS(2708),
    [anon_sym_export] = ACTIONS(2708),
    [anon_sym_default] = ACTIONS(2708),
    [anon_sym_namespace] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(2706),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_type] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2708),
    [anon_sym_import] = ACTIONS(2708),
    [anon_sym_var] = ACTIONS(2708),
    [anon_sym_let] = ACTIONS(2708),
    [anon_sym_const] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2708),
    [anon_sym_else] = ACTIONS(2708),
    [anon_sym_switch] = ACTIONS(2708),
    [anon_sym_for] = ACTIONS(2708),
    [anon_sym_LPAREN] = ACTIONS(2706),
    [anon_sym_await] = ACTIONS(2708),
    [anon_sym_while] = ACTIONS(2708),
    [anon_sym_do] = ACTIONS(2708),
    [anon_sym_try] = ACTIONS(2708),
    [anon_sym_with] = ACTIONS(2708),
    [anon_sym_break] = ACTIONS(2708),
    [anon_sym_continue] = ACTIONS(2708),
    [anon_sym_debugger] = ACTIONS(2708),
    [anon_sym_return] = ACTIONS(2708),
    [anon_sym_throw] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2706),
    [anon_sym_case] = ACTIONS(2708),
    [anon_sym_yield] = ACTIONS(2708),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_LT] = ACTIONS(2706),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_class] = ACTIONS(2708),
    [anon_sym_async] = ACTIONS(2708),
    [anon_sym_function] = ACTIONS(2708),
    [anon_sym_new] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_BANG] = ACTIONS(2706),
    [anon_sym_TILDE] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2708),
    [anon_sym_delete] = ACTIONS(2708),
    [anon_sym_PLUS_PLUS] = ACTIONS(2706),
    [anon_sym_DASH_DASH] = ACTIONS(2706),
    [anon_sym_DQUOTE] = ACTIONS(2706),
    [anon_sym_SQUOTE] = ACTIONS(2706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2706),
    [sym_number] = ACTIONS(2706),
    [sym_this] = ACTIONS(2708),
    [sym_super] = ACTIONS(2708),
    [sym_true] = ACTIONS(2708),
    [sym_false] = ACTIONS(2708),
    [sym_null] = ACTIONS(2708),
    [sym_undefined] = ACTIONS(2708),
    [anon_sym_AT] = ACTIONS(2706),
    [anon_sym_static] = ACTIONS(2708),
    [anon_sym_abstract] = ACTIONS(2708),
    [anon_sym_get] = ACTIONS(2708),
    [anon_sym_set] = ACTIONS(2708),
    [anon_sym_declare] = ACTIONS(2708),
    [anon_sym_public] = ACTIONS(2708),
    [anon_sym_private] = ACTIONS(2708),
    [anon_sym_protected] = ACTIONS(2708),
    [anon_sym_module] = ACTIONS(2708),
    [anon_sym_any] = ACTIONS(2708),
    [anon_sym_number] = ACTIONS(2708),
    [anon_sym_boolean] = ACTIONS(2708),
    [anon_sym_string] = ACTIONS(2708),
    [anon_sym_symbol] = ACTIONS(2708),
    [anon_sym_interface] = ACTIONS(2708),
    [anon_sym_enum] = ACTIONS(2708),
    [sym_readonly] = ACTIONS(2708),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_export] = ACTIONS(2712),
    [anon_sym_default] = ACTIONS(2712),
    [anon_sym_namespace] = ACTIONS(2712),
    [anon_sym_LBRACE] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_type] = ACTIONS(2712),
    [anon_sym_typeof] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2712),
    [anon_sym_var] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_else] = ACTIONS(2712),
    [anon_sym_switch] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [anon_sym_do] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [anon_sym_with] = ACTIONS(2712),
    [anon_sym_break] = ACTIONS(2712),
    [anon_sym_continue] = ACTIONS(2712),
    [anon_sym_debugger] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_throw] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2710),
    [anon_sym_case] = ACTIONS(2712),
    [anon_sym_yield] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2710),
    [anon_sym_LT] = ACTIONS(2710),
    [anon_sym_SLASH] = ACTIONS(2712),
    [anon_sym_class] = ACTIONS(2712),
    [anon_sym_async] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(2712),
    [anon_sym_new] = ACTIONS(2712),
    [anon_sym_PLUS] = ACTIONS(2712),
    [anon_sym_DASH] = ACTIONS(2712),
    [anon_sym_BANG] = ACTIONS(2710),
    [anon_sym_TILDE] = ACTIONS(2710),
    [anon_sym_void] = ACTIONS(2712),
    [anon_sym_delete] = ACTIONS(2712),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [anon_sym_SQUOTE] = ACTIONS(2710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2710),
    [sym_number] = ACTIONS(2710),
    [sym_this] = ACTIONS(2712),
    [sym_super] = ACTIONS(2712),
    [sym_true] = ACTIONS(2712),
    [sym_false] = ACTIONS(2712),
    [sym_null] = ACTIONS(2712),
    [sym_undefined] = ACTIONS(2712),
    [anon_sym_AT] = ACTIONS(2710),
    [anon_sym_static] = ACTIONS(2712),
    [anon_sym_abstract] = ACTIONS(2712),
    [anon_sym_get] = ACTIONS(2712),
    [anon_sym_set] = ACTIONS(2712),
    [anon_sym_declare] = ACTIONS(2712),
    [anon_sym_public] = ACTIONS(2712),
    [anon_sym_private] = ACTIONS(2712),
    [anon_sym_protected] = ACTIONS(2712),
    [anon_sym_module] = ACTIONS(2712),
    [anon_sym_any] = ACTIONS(2712),
    [anon_sym_number] = ACTIONS(2712),
    [anon_sym_boolean] = ACTIONS(2712),
    [anon_sym_string] = ACTIONS(2712),
    [anon_sym_symbol] = ACTIONS(2712),
    [anon_sym_interface] = ACTIONS(2712),
    [anon_sym_enum] = ACTIONS(2712),
    [sym_readonly] = ACTIONS(2712),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(2714),
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_default] = ACTIONS(2716),
    [anon_sym_namespace] = ACTIONS(2716),
    [anon_sym_LBRACE] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_var] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_else] = ACTIONS(2716),
    [anon_sym_switch] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_await] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [anon_sym_do] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_with] = ACTIONS(2716),
    [anon_sym_break] = ACTIONS(2716),
    [anon_sym_continue] = ACTIONS(2716),
    [anon_sym_debugger] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_throw] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_case] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2716),
    [anon_sym_class] = ACTIONS(2716),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [anon_sym_new] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_BANG] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2714),
    [anon_sym_void] = ACTIONS(2716),
    [anon_sym_delete] = ACTIONS(2716),
    [anon_sym_PLUS_PLUS] = ACTIONS(2714),
    [anon_sym_DASH_DASH] = ACTIONS(2714),
    [anon_sym_DQUOTE] = ACTIONS(2714),
    [anon_sym_SQUOTE] = ACTIONS(2714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2714),
    [sym_number] = ACTIONS(2714),
    [sym_this] = ACTIONS(2716),
    [sym_super] = ACTIONS(2716),
    [sym_true] = ACTIONS(2716),
    [sym_false] = ACTIONS(2716),
    [sym_null] = ACTIONS(2716),
    [sym_undefined] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2714),
    [anon_sym_static] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_get] = ACTIONS(2716),
    [anon_sym_set] = ACTIONS(2716),
    [anon_sym_declare] = ACTIONS(2716),
    [anon_sym_public] = ACTIONS(2716),
    [anon_sym_private] = ACTIONS(2716),
    [anon_sym_protected] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_any] = ACTIONS(2716),
    [anon_sym_number] = ACTIONS(2716),
    [anon_sym_boolean] = ACTIONS(2716),
    [anon_sym_string] = ACTIONS(2716),
    [anon_sym_symbol] = ACTIONS(2716),
    [anon_sym_interface] = ACTIONS(2716),
    [anon_sym_enum] = ACTIONS(2716),
    [sym_readonly] = ACTIONS(2716),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(2718),
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_default] = ACTIONS(2720),
    [anon_sym_namespace] = ACTIONS(2720),
    [anon_sym_LBRACE] = ACTIONS(2718),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2720),
    [anon_sym_typeof] = ACTIONS(2720),
    [anon_sym_import] = ACTIONS(2720),
    [anon_sym_var] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_else] = ACTIONS(2720),
    [anon_sym_switch] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_LPAREN] = ACTIONS(2718),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [anon_sym_do] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [anon_sym_with] = ACTIONS(2720),
    [anon_sym_break] = ACTIONS(2720),
    [anon_sym_continue] = ACTIONS(2720),
    [anon_sym_debugger] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_throw] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2718),
    [anon_sym_case] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_LT] = ACTIONS(2718),
    [anon_sym_SLASH] = ACTIONS(2720),
    [anon_sym_class] = ACTIONS(2720),
    [anon_sym_async] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(2720),
    [anon_sym_new] = ACTIONS(2720),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_DASH] = ACTIONS(2720),
    [anon_sym_BANG] = ACTIONS(2718),
    [anon_sym_TILDE] = ACTIONS(2718),
    [anon_sym_void] = ACTIONS(2720),
    [anon_sym_delete] = ACTIONS(2720),
    [anon_sym_PLUS_PLUS] = ACTIONS(2718),
    [anon_sym_DASH_DASH] = ACTIONS(2718),
    [anon_sym_DQUOTE] = ACTIONS(2718),
    [anon_sym_SQUOTE] = ACTIONS(2718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2718),
    [sym_number] = ACTIONS(2718),
    [sym_this] = ACTIONS(2720),
    [sym_super] = ACTIONS(2720),
    [sym_true] = ACTIONS(2720),
    [sym_false] = ACTIONS(2720),
    [sym_null] = ACTIONS(2720),
    [sym_undefined] = ACTIONS(2720),
    [anon_sym_AT] = ACTIONS(2718),
    [anon_sym_static] = ACTIONS(2720),
    [anon_sym_abstract] = ACTIONS(2720),
    [anon_sym_get] = ACTIONS(2720),
    [anon_sym_set] = ACTIONS(2720),
    [anon_sym_declare] = ACTIONS(2720),
    [anon_sym_public] = ACTIONS(2720),
    [anon_sym_private] = ACTIONS(2720),
    [anon_sym_protected] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_any] = ACTIONS(2720),
    [anon_sym_number] = ACTIONS(2720),
    [anon_sym_boolean] = ACTIONS(2720),
    [anon_sym_string] = ACTIONS(2720),
    [anon_sym_symbol] = ACTIONS(2720),
    [anon_sym_interface] = ACTIONS(2720),
    [anon_sym_enum] = ACTIONS(2720),
    [sym_readonly] = ACTIONS(2720),
  },
  [527] = {
    [sym__call_signature] = STATE(2935),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2543),
    [anon_sym_export] = ACTIONS(2545),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2545),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2545),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2545),
    [anon_sym_get] = ACTIONS(2545),
    [anon_sym_set] = ACTIONS(2545),
    [anon_sym_declare] = ACTIONS(2545),
    [anon_sym_public] = ACTIONS(2545),
    [anon_sym_private] = ACTIONS(2545),
    [anon_sym_protected] = ACTIONS(2545),
    [anon_sym_module] = ACTIONS(2545),
    [anon_sym_any] = ACTIONS(2545),
    [anon_sym_number] = ACTIONS(2545),
    [anon_sym_boolean] = ACTIONS(2545),
    [anon_sym_string] = ACTIONS(2545),
    [anon_sym_symbol] = ACTIONS(2545),
    [sym_readonly] = ACTIONS(2545),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(2722),
    [sym_identifier] = ACTIONS(2724),
    [anon_sym_export] = ACTIONS(2724),
    [anon_sym_default] = ACTIONS(2724),
    [anon_sym_namespace] = ACTIONS(2724),
    [anon_sym_LBRACE] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_type] = ACTIONS(2724),
    [anon_sym_typeof] = ACTIONS(2724),
    [anon_sym_import] = ACTIONS(2724),
    [anon_sym_var] = ACTIONS(2724),
    [anon_sym_let] = ACTIONS(2724),
    [anon_sym_const] = ACTIONS(2724),
    [anon_sym_if] = ACTIONS(2724),
    [anon_sym_else] = ACTIONS(2724),
    [anon_sym_switch] = ACTIONS(2724),
    [anon_sym_for] = ACTIONS(2724),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_await] = ACTIONS(2724),
    [anon_sym_while] = ACTIONS(2724),
    [anon_sym_do] = ACTIONS(2724),
    [anon_sym_try] = ACTIONS(2724),
    [anon_sym_with] = ACTIONS(2724),
    [anon_sym_break] = ACTIONS(2724),
    [anon_sym_continue] = ACTIONS(2724),
    [anon_sym_debugger] = ACTIONS(2724),
    [anon_sym_return] = ACTIONS(2724),
    [anon_sym_throw] = ACTIONS(2724),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_case] = ACTIONS(2724),
    [anon_sym_yield] = ACTIONS(2724),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_SLASH] = ACTIONS(2724),
    [anon_sym_class] = ACTIONS(2724),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(2724),
    [anon_sym_new] = ACTIONS(2724),
    [anon_sym_PLUS] = ACTIONS(2724),
    [anon_sym_DASH] = ACTIONS(2724),
    [anon_sym_BANG] = ACTIONS(2722),
    [anon_sym_TILDE] = ACTIONS(2722),
    [anon_sym_void] = ACTIONS(2724),
    [anon_sym_delete] = ACTIONS(2724),
    [anon_sym_PLUS_PLUS] = ACTIONS(2722),
    [anon_sym_DASH_DASH] = ACTIONS(2722),
    [anon_sym_DQUOTE] = ACTIONS(2722),
    [anon_sym_SQUOTE] = ACTIONS(2722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2722),
    [sym_number] = ACTIONS(2722),
    [sym_this] = ACTIONS(2724),
    [sym_super] = ACTIONS(2724),
    [sym_true] = ACTIONS(2724),
    [sym_false] = ACTIONS(2724),
    [sym_null] = ACTIONS(2724),
    [sym_undefined] = ACTIONS(2724),
    [anon_sym_AT] = ACTIONS(2722),
    [anon_sym_static] = ACTIONS(2724),
    [anon_sym_abstract] = ACTIONS(2724),
    [anon_sym_get] = ACTIONS(2724),
    [anon_sym_set] = ACTIONS(2724),
    [anon_sym_declare] = ACTIONS(2724),
    [anon_sym_public] = ACTIONS(2724),
    [anon_sym_private] = ACTIONS(2724),
    [anon_sym_protected] = ACTIONS(2724),
    [anon_sym_module] = ACTIONS(2724),
    [anon_sym_any] = ACTIONS(2724),
    [anon_sym_number] = ACTIONS(2724),
    [anon_sym_boolean] = ACTIONS(2724),
    [anon_sym_string] = ACTIONS(2724),
    [anon_sym_symbol] = ACTIONS(2724),
    [anon_sym_interface] = ACTIONS(2724),
    [anon_sym_enum] = ACTIONS(2724),
    [sym_readonly] = ACTIONS(2724),
  },
  [529] = {
    [sym__call_signature] = STATE(2935),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2543),
    [anon_sym_export] = ACTIONS(2545),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2545),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2545),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2545),
    [anon_sym_get] = ACTIONS(2545),
    [anon_sym_set] = ACTIONS(2545),
    [anon_sym_declare] = ACTIONS(2545),
    [anon_sym_public] = ACTIONS(2545),
    [anon_sym_private] = ACTIONS(2545),
    [anon_sym_protected] = ACTIONS(2545),
    [anon_sym_module] = ACTIONS(2545),
    [anon_sym_any] = ACTIONS(2545),
    [anon_sym_number] = ACTIONS(2545),
    [anon_sym_boolean] = ACTIONS(2545),
    [anon_sym_string] = ACTIONS(2545),
    [anon_sym_symbol] = ACTIONS(2545),
    [sym_readonly] = ACTIONS(2545),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(2726),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_default] = ACTIONS(2728),
    [anon_sym_namespace] = ACTIONS(2728),
    [anon_sym_LBRACE] = ACTIONS(2726),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_typeof] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_var] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_else] = ACTIONS(2728),
    [anon_sym_switch] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_await] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [anon_sym_do] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_with] = ACTIONS(2728),
    [anon_sym_break] = ACTIONS(2728),
    [anon_sym_continue] = ACTIONS(2728),
    [anon_sym_debugger] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_throw] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_case] = ACTIONS(2728),
    [anon_sym_yield] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2726),
    [anon_sym_SLASH] = ACTIONS(2728),
    [anon_sym_class] = ACTIONS(2728),
    [anon_sym_async] = ACTIONS(2728),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2726),
    [anon_sym_TILDE] = ACTIONS(2726),
    [anon_sym_void] = ACTIONS(2728),
    [anon_sym_delete] = ACTIONS(2728),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_DQUOTE] = ACTIONS(2726),
    [anon_sym_SQUOTE] = ACTIONS(2726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [sym_number] = ACTIONS(2726),
    [sym_this] = ACTIONS(2728),
    [sym_super] = ACTIONS(2728),
    [sym_true] = ACTIONS(2728),
    [sym_false] = ACTIONS(2728),
    [sym_null] = ACTIONS(2728),
    [sym_undefined] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2726),
    [anon_sym_static] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_get] = ACTIONS(2728),
    [anon_sym_set] = ACTIONS(2728),
    [anon_sym_declare] = ACTIONS(2728),
    [anon_sym_public] = ACTIONS(2728),
    [anon_sym_private] = ACTIONS(2728),
    [anon_sym_protected] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_any] = ACTIONS(2728),
    [anon_sym_number] = ACTIONS(2728),
    [anon_sym_boolean] = ACTIONS(2728),
    [anon_sym_string] = ACTIONS(2728),
    [anon_sym_symbol] = ACTIONS(2728),
    [anon_sym_interface] = ACTIONS(2728),
    [anon_sym_enum] = ACTIONS(2728),
    [sym_readonly] = ACTIONS(2728),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(2730),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_default] = ACTIONS(2732),
    [anon_sym_namespace] = ACTIONS(2732),
    [anon_sym_LBRACE] = ACTIONS(2730),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_type] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2732),
    [anon_sym_import] = ACTIONS(2732),
    [anon_sym_var] = ACTIONS(2732),
    [anon_sym_let] = ACTIONS(2732),
    [anon_sym_const] = ACTIONS(2732),
    [anon_sym_if] = ACTIONS(2732),
    [anon_sym_else] = ACTIONS(2732),
    [anon_sym_switch] = ACTIONS(2732),
    [anon_sym_for] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(2730),
    [anon_sym_await] = ACTIONS(2732),
    [anon_sym_while] = ACTIONS(2732),
    [anon_sym_do] = ACTIONS(2732),
    [anon_sym_try] = ACTIONS(2732),
    [anon_sym_with] = ACTIONS(2732),
    [anon_sym_break] = ACTIONS(2732),
    [anon_sym_continue] = ACTIONS(2732),
    [anon_sym_debugger] = ACTIONS(2732),
    [anon_sym_return] = ACTIONS(2732),
    [anon_sym_throw] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2730),
    [anon_sym_case] = ACTIONS(2732),
    [anon_sym_yield] = ACTIONS(2732),
    [anon_sym_LBRACK] = ACTIONS(2730),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_SLASH] = ACTIONS(2732),
    [anon_sym_class] = ACTIONS(2732),
    [anon_sym_async] = ACTIONS(2732),
    [anon_sym_function] = ACTIONS(2732),
    [anon_sym_new] = ACTIONS(2732),
    [anon_sym_PLUS] = ACTIONS(2732),
    [anon_sym_DASH] = ACTIONS(2732),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_TILDE] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2732),
    [anon_sym_delete] = ACTIONS(2732),
    [anon_sym_PLUS_PLUS] = ACTIONS(2730),
    [anon_sym_DASH_DASH] = ACTIONS(2730),
    [anon_sym_DQUOTE] = ACTIONS(2730),
    [anon_sym_SQUOTE] = ACTIONS(2730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2730),
    [sym_number] = ACTIONS(2730),
    [sym_this] = ACTIONS(2732),
    [sym_super] = ACTIONS(2732),
    [sym_true] = ACTIONS(2732),
    [sym_false] = ACTIONS(2732),
    [sym_null] = ACTIONS(2732),
    [sym_undefined] = ACTIONS(2732),
    [anon_sym_AT] = ACTIONS(2730),
    [anon_sym_static] = ACTIONS(2732),
    [anon_sym_abstract] = ACTIONS(2732),
    [anon_sym_get] = ACTIONS(2732),
    [anon_sym_set] = ACTIONS(2732),
    [anon_sym_declare] = ACTIONS(2732),
    [anon_sym_public] = ACTIONS(2732),
    [anon_sym_private] = ACTIONS(2732),
    [anon_sym_protected] = ACTIONS(2732),
    [anon_sym_module] = ACTIONS(2732),
    [anon_sym_any] = ACTIONS(2732),
    [anon_sym_number] = ACTIONS(2732),
    [anon_sym_boolean] = ACTIONS(2732),
    [anon_sym_string] = ACTIONS(2732),
    [anon_sym_symbol] = ACTIONS(2732),
    [anon_sym_interface] = ACTIONS(2732),
    [anon_sym_enum] = ACTIONS(2732),
    [sym_readonly] = ACTIONS(2732),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(2734),
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_default] = ACTIONS(2736),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_typeof] = ACTIONS(2736),
    [anon_sym_import] = ACTIONS(2736),
    [anon_sym_var] = ACTIONS(2736),
    [anon_sym_let] = ACTIONS(2736),
    [anon_sym_const] = ACTIONS(2736),
    [anon_sym_if] = ACTIONS(2736),
    [anon_sym_else] = ACTIONS(2736),
    [anon_sym_switch] = ACTIONS(2736),
    [anon_sym_for] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [anon_sym_await] = ACTIONS(2736),
    [anon_sym_while] = ACTIONS(2736),
    [anon_sym_do] = ACTIONS(2736),
    [anon_sym_try] = ACTIONS(2736),
    [anon_sym_with] = ACTIONS(2736),
    [anon_sym_break] = ACTIONS(2736),
    [anon_sym_continue] = ACTIONS(2736),
    [anon_sym_debugger] = ACTIONS(2736),
    [anon_sym_return] = ACTIONS(2736),
    [anon_sym_throw] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_case] = ACTIONS(2736),
    [anon_sym_yield] = ACTIONS(2736),
    [anon_sym_LBRACK] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2736),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2736),
    [anon_sym_new] = ACTIONS(2736),
    [anon_sym_PLUS] = ACTIONS(2736),
    [anon_sym_DASH] = ACTIONS(2736),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_TILDE] = ACTIONS(2734),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_delete] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [sym_number] = ACTIONS(2734),
    [sym_this] = ACTIONS(2736),
    [sym_super] = ACTIONS(2736),
    [sym_true] = ACTIONS(2736),
    [sym_false] = ACTIONS(2736),
    [sym_null] = ACTIONS(2736),
    [sym_undefined] = ACTIONS(2736),
    [anon_sym_AT] = ACTIONS(2734),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_abstract] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
    [anon_sym_interface] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2736),
    [sym_readonly] = ACTIONS(2736),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(2738),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2740),
    [anon_sym_default] = ACTIONS(2740),
    [anon_sym_namespace] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_type] = ACTIONS(2740),
    [anon_sym_typeof] = ACTIONS(2740),
    [anon_sym_import] = ACTIONS(2740),
    [anon_sym_var] = ACTIONS(2740),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2740),
    [anon_sym_if] = ACTIONS(2740),
    [anon_sym_else] = ACTIONS(2740),
    [anon_sym_switch] = ACTIONS(2740),
    [anon_sym_for] = ACTIONS(2740),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_await] = ACTIONS(2740),
    [anon_sym_while] = ACTIONS(2740),
    [anon_sym_do] = ACTIONS(2740),
    [anon_sym_try] = ACTIONS(2740),
    [anon_sym_with] = ACTIONS(2740),
    [anon_sym_break] = ACTIONS(2740),
    [anon_sym_continue] = ACTIONS(2740),
    [anon_sym_debugger] = ACTIONS(2740),
    [anon_sym_return] = ACTIONS(2740),
    [anon_sym_throw] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_case] = ACTIONS(2740),
    [anon_sym_yield] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2738),
    [anon_sym_LT] = ACTIONS(2738),
    [anon_sym_SLASH] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_async] = ACTIONS(2740),
    [anon_sym_function] = ACTIONS(2740),
    [anon_sym_new] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2740),
    [anon_sym_DASH] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2738),
    [anon_sym_TILDE] = ACTIONS(2738),
    [anon_sym_void] = ACTIONS(2740),
    [anon_sym_delete] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2738),
    [anon_sym_DASH_DASH] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [sym_number] = ACTIONS(2738),
    [sym_this] = ACTIONS(2740),
    [sym_super] = ACTIONS(2740),
    [sym_true] = ACTIONS(2740),
    [sym_false] = ACTIONS(2740),
    [sym_null] = ACTIONS(2740),
    [sym_undefined] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(2738),
    [anon_sym_static] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2740),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2740),
    [anon_sym_public] = ACTIONS(2740),
    [anon_sym_private] = ACTIONS(2740),
    [anon_sym_protected] = ACTIONS(2740),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_any] = ACTIONS(2740),
    [anon_sym_number] = ACTIONS(2740),
    [anon_sym_boolean] = ACTIONS(2740),
    [anon_sym_string] = ACTIONS(2740),
    [anon_sym_symbol] = ACTIONS(2740),
    [anon_sym_interface] = ACTIONS(2740),
    [anon_sym_enum] = ACTIONS(2740),
    [sym_readonly] = ACTIONS(2740),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_default] = ACTIONS(2744),
    [anon_sym_namespace] = ACTIONS(2744),
    [anon_sym_LBRACE] = ACTIONS(2742),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_type] = ACTIONS(2744),
    [anon_sym_typeof] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_var] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_switch] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2742),
    [anon_sym_await] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [anon_sym_do] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_with] = ACTIONS(2744),
    [anon_sym_break] = ACTIONS(2744),
    [anon_sym_continue] = ACTIONS(2744),
    [anon_sym_debugger] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_throw] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2744),
    [anon_sym_yield] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2744),
    [anon_sym_class] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2744),
    [anon_sym_BANG] = ACTIONS(2742),
    [anon_sym_TILDE] = ACTIONS(2742),
    [anon_sym_void] = ACTIONS(2744),
    [anon_sym_delete] = ACTIONS(2744),
    [anon_sym_PLUS_PLUS] = ACTIONS(2742),
    [anon_sym_DASH_DASH] = ACTIONS(2742),
    [anon_sym_DQUOTE] = ACTIONS(2742),
    [anon_sym_SQUOTE] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2742),
    [sym_number] = ACTIONS(2742),
    [sym_this] = ACTIONS(2744),
    [sym_super] = ACTIONS(2744),
    [sym_true] = ACTIONS(2744),
    [sym_false] = ACTIONS(2744),
    [sym_null] = ACTIONS(2744),
    [sym_undefined] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2742),
    [anon_sym_static] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_get] = ACTIONS(2744),
    [anon_sym_set] = ACTIONS(2744),
    [anon_sym_declare] = ACTIONS(2744),
    [anon_sym_public] = ACTIONS(2744),
    [anon_sym_private] = ACTIONS(2744),
    [anon_sym_protected] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_any] = ACTIONS(2744),
    [anon_sym_number] = ACTIONS(2744),
    [anon_sym_boolean] = ACTIONS(2744),
    [anon_sym_string] = ACTIONS(2744),
    [anon_sym_symbol] = ACTIONS(2744),
    [anon_sym_interface] = ACTIONS(2744),
    [anon_sym_enum] = ACTIONS(2744),
    [sym_readonly] = ACTIONS(2744),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_export] = ACTIONS(2748),
    [anon_sym_default] = ACTIONS(2748),
    [anon_sym_namespace] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_type] = ACTIONS(2748),
    [anon_sym_typeof] = ACTIONS(2748),
    [anon_sym_import] = ACTIONS(2748),
    [anon_sym_var] = ACTIONS(2748),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_const] = ACTIONS(2748),
    [anon_sym_if] = ACTIONS(2748),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_switch] = ACTIONS(2748),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_await] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_break] = ACTIONS(2748),
    [anon_sym_continue] = ACTIONS(2748),
    [anon_sym_debugger] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_throw] = ACTIONS(2748),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_case] = ACTIONS(2748),
    [anon_sym_yield] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2746),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_SLASH] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2748),
    [anon_sym_async] = ACTIONS(2748),
    [anon_sym_function] = ACTIONS(2748),
    [anon_sym_new] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_void] = ACTIONS(2748),
    [anon_sym_delete] = ACTIONS(2748),
    [anon_sym_PLUS_PLUS] = ACTIONS(2746),
    [anon_sym_DASH_DASH] = ACTIONS(2746),
    [anon_sym_DQUOTE] = ACTIONS(2746),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2746),
    [sym_number] = ACTIONS(2746),
    [sym_this] = ACTIONS(2748),
    [sym_super] = ACTIONS(2748),
    [sym_true] = ACTIONS(2748),
    [sym_false] = ACTIONS(2748),
    [sym_null] = ACTIONS(2748),
    [sym_undefined] = ACTIONS(2748),
    [anon_sym_AT] = ACTIONS(2746),
    [anon_sym_static] = ACTIONS(2748),
    [anon_sym_abstract] = ACTIONS(2748),
    [anon_sym_get] = ACTIONS(2748),
    [anon_sym_set] = ACTIONS(2748),
    [anon_sym_declare] = ACTIONS(2748),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_module] = ACTIONS(2748),
    [anon_sym_any] = ACTIONS(2748),
    [anon_sym_number] = ACTIONS(2748),
    [anon_sym_boolean] = ACTIONS(2748),
    [anon_sym_string] = ACTIONS(2748),
    [anon_sym_symbol] = ACTIONS(2748),
    [anon_sym_interface] = ACTIONS(2748),
    [anon_sym_enum] = ACTIONS(2748),
    [sym_readonly] = ACTIONS(2748),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(2752),
    [anon_sym_export] = ACTIONS(2752),
    [anon_sym_default] = ACTIONS(2752),
    [anon_sym_namespace] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_type] = ACTIONS(2752),
    [anon_sym_typeof] = ACTIONS(2752),
    [anon_sym_import] = ACTIONS(2752),
    [anon_sym_var] = ACTIONS(2752),
    [anon_sym_let] = ACTIONS(2752),
    [anon_sym_const] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2752),
    [anon_sym_else] = ACTIONS(2752),
    [anon_sym_switch] = ACTIONS(2752),
    [anon_sym_for] = ACTIONS(2752),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_await] = ACTIONS(2752),
    [anon_sym_while] = ACTIONS(2752),
    [anon_sym_do] = ACTIONS(2752),
    [anon_sym_try] = ACTIONS(2752),
    [anon_sym_with] = ACTIONS(2752),
    [anon_sym_break] = ACTIONS(2752),
    [anon_sym_continue] = ACTIONS(2752),
    [anon_sym_debugger] = ACTIONS(2752),
    [anon_sym_return] = ACTIONS(2752),
    [anon_sym_throw] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_case] = ACTIONS(2752),
    [anon_sym_yield] = ACTIONS(2752),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [anon_sym_LT] = ACTIONS(2750),
    [anon_sym_SLASH] = ACTIONS(2752),
    [anon_sym_class] = ACTIONS(2752),
    [anon_sym_async] = ACTIONS(2752),
    [anon_sym_function] = ACTIONS(2752),
    [anon_sym_new] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2752),
    [anon_sym_DASH] = ACTIONS(2752),
    [anon_sym_BANG] = ACTIONS(2750),
    [anon_sym_TILDE] = ACTIONS(2750),
    [anon_sym_void] = ACTIONS(2752),
    [anon_sym_delete] = ACTIONS(2752),
    [anon_sym_PLUS_PLUS] = ACTIONS(2750),
    [anon_sym_DASH_DASH] = ACTIONS(2750),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2750),
    [sym_number] = ACTIONS(2750),
    [sym_this] = ACTIONS(2752),
    [sym_super] = ACTIONS(2752),
    [sym_true] = ACTIONS(2752),
    [sym_false] = ACTIONS(2752),
    [sym_null] = ACTIONS(2752),
    [sym_undefined] = ACTIONS(2752),
    [anon_sym_AT] = ACTIONS(2750),
    [anon_sym_static] = ACTIONS(2752),
    [anon_sym_abstract] = ACTIONS(2752),
    [anon_sym_get] = ACTIONS(2752),
    [anon_sym_set] = ACTIONS(2752),
    [anon_sym_declare] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2752),
    [anon_sym_private] = ACTIONS(2752),
    [anon_sym_protected] = ACTIONS(2752),
    [anon_sym_module] = ACTIONS(2752),
    [anon_sym_any] = ACTIONS(2752),
    [anon_sym_number] = ACTIONS(2752),
    [anon_sym_boolean] = ACTIONS(2752),
    [anon_sym_string] = ACTIONS(2752),
    [anon_sym_symbol] = ACTIONS(2752),
    [anon_sym_interface] = ACTIONS(2752),
    [anon_sym_enum] = ACTIONS(2752),
    [sym_readonly] = ACTIONS(2752),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(2754),
    [sym_identifier] = ACTIONS(2756),
    [anon_sym_export] = ACTIONS(2756),
    [anon_sym_default] = ACTIONS(2756),
    [anon_sym_namespace] = ACTIONS(2756),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2754),
    [anon_sym_type] = ACTIONS(2756),
    [anon_sym_typeof] = ACTIONS(2756),
    [anon_sym_import] = ACTIONS(2756),
    [anon_sym_var] = ACTIONS(2756),
    [anon_sym_let] = ACTIONS(2756),
    [anon_sym_const] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2756),
    [anon_sym_else] = ACTIONS(2756),
    [anon_sym_switch] = ACTIONS(2756),
    [anon_sym_for] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_await] = ACTIONS(2756),
    [anon_sym_while] = ACTIONS(2756),
    [anon_sym_do] = ACTIONS(2756),
    [anon_sym_try] = ACTIONS(2756),
    [anon_sym_with] = ACTIONS(2756),
    [anon_sym_break] = ACTIONS(2756),
    [anon_sym_continue] = ACTIONS(2756),
    [anon_sym_debugger] = ACTIONS(2756),
    [anon_sym_return] = ACTIONS(2756),
    [anon_sym_throw] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_case] = ACTIONS(2756),
    [anon_sym_yield] = ACTIONS(2756),
    [anon_sym_LBRACK] = ACTIONS(2754),
    [anon_sym_LT] = ACTIONS(2754),
    [anon_sym_SLASH] = ACTIONS(2756),
    [anon_sym_class] = ACTIONS(2756),
    [anon_sym_async] = ACTIONS(2756),
    [anon_sym_function] = ACTIONS(2756),
    [anon_sym_new] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(2756),
    [anon_sym_BANG] = ACTIONS(2754),
    [anon_sym_TILDE] = ACTIONS(2754),
    [anon_sym_void] = ACTIONS(2756),
    [anon_sym_delete] = ACTIONS(2756),
    [anon_sym_PLUS_PLUS] = ACTIONS(2754),
    [anon_sym_DASH_DASH] = ACTIONS(2754),
    [anon_sym_DQUOTE] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2754),
    [sym_number] = ACTIONS(2754),
    [sym_this] = ACTIONS(2756),
    [sym_super] = ACTIONS(2756),
    [sym_true] = ACTIONS(2756),
    [sym_false] = ACTIONS(2756),
    [sym_null] = ACTIONS(2756),
    [sym_undefined] = ACTIONS(2756),
    [anon_sym_AT] = ACTIONS(2754),
    [anon_sym_static] = ACTIONS(2756),
    [anon_sym_abstract] = ACTIONS(2756),
    [anon_sym_get] = ACTIONS(2756),
    [anon_sym_set] = ACTIONS(2756),
    [anon_sym_declare] = ACTIONS(2756),
    [anon_sym_public] = ACTIONS(2756),
    [anon_sym_private] = ACTIONS(2756),
    [anon_sym_protected] = ACTIONS(2756),
    [anon_sym_module] = ACTIONS(2756),
    [anon_sym_any] = ACTIONS(2756),
    [anon_sym_number] = ACTIONS(2756),
    [anon_sym_boolean] = ACTIONS(2756),
    [anon_sym_string] = ACTIONS(2756),
    [anon_sym_symbol] = ACTIONS(2756),
    [anon_sym_interface] = ACTIONS(2756),
    [anon_sym_enum] = ACTIONS(2756),
    [sym_readonly] = ACTIONS(2756),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(2758),
    [sym_identifier] = ACTIONS(2760),
    [anon_sym_export] = ACTIONS(2760),
    [anon_sym_default] = ACTIONS(2760),
    [anon_sym_namespace] = ACTIONS(2760),
    [anon_sym_LBRACE] = ACTIONS(2758),
    [anon_sym_RBRACE] = ACTIONS(2758),
    [anon_sym_type] = ACTIONS(2760),
    [anon_sym_typeof] = ACTIONS(2760),
    [anon_sym_import] = ACTIONS(2760),
    [anon_sym_var] = ACTIONS(2760),
    [anon_sym_let] = ACTIONS(2760),
    [anon_sym_const] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2760),
    [anon_sym_else] = ACTIONS(2760),
    [anon_sym_switch] = ACTIONS(2760),
    [anon_sym_for] = ACTIONS(2760),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_await] = ACTIONS(2760),
    [anon_sym_while] = ACTIONS(2760),
    [anon_sym_do] = ACTIONS(2760),
    [anon_sym_try] = ACTIONS(2760),
    [anon_sym_with] = ACTIONS(2760),
    [anon_sym_break] = ACTIONS(2760),
    [anon_sym_continue] = ACTIONS(2760),
    [anon_sym_debugger] = ACTIONS(2760),
    [anon_sym_return] = ACTIONS(2760),
    [anon_sym_throw] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_case] = ACTIONS(2760),
    [anon_sym_yield] = ACTIONS(2760),
    [anon_sym_LBRACK] = ACTIONS(2758),
    [anon_sym_LT] = ACTIONS(2758),
    [anon_sym_SLASH] = ACTIONS(2760),
    [anon_sym_class] = ACTIONS(2760),
    [anon_sym_async] = ACTIONS(2760),
    [anon_sym_function] = ACTIONS(2760),
    [anon_sym_new] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2760),
    [anon_sym_DASH] = ACTIONS(2760),
    [anon_sym_BANG] = ACTIONS(2758),
    [anon_sym_TILDE] = ACTIONS(2758),
    [anon_sym_void] = ACTIONS(2760),
    [anon_sym_delete] = ACTIONS(2760),
    [anon_sym_PLUS_PLUS] = ACTIONS(2758),
    [anon_sym_DASH_DASH] = ACTIONS(2758),
    [anon_sym_DQUOTE] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2758),
    [sym_number] = ACTIONS(2758),
    [sym_this] = ACTIONS(2760),
    [sym_super] = ACTIONS(2760),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_null] = ACTIONS(2760),
    [sym_undefined] = ACTIONS(2760),
    [anon_sym_AT] = ACTIONS(2758),
    [anon_sym_static] = ACTIONS(2760),
    [anon_sym_abstract] = ACTIONS(2760),
    [anon_sym_get] = ACTIONS(2760),
    [anon_sym_set] = ACTIONS(2760),
    [anon_sym_declare] = ACTIONS(2760),
    [anon_sym_public] = ACTIONS(2760),
    [anon_sym_private] = ACTIONS(2760),
    [anon_sym_protected] = ACTIONS(2760),
    [anon_sym_module] = ACTIONS(2760),
    [anon_sym_any] = ACTIONS(2760),
    [anon_sym_number] = ACTIONS(2760),
    [anon_sym_boolean] = ACTIONS(2760),
    [anon_sym_string] = ACTIONS(2760),
    [anon_sym_symbol] = ACTIONS(2760),
    [anon_sym_interface] = ACTIONS(2760),
    [anon_sym_enum] = ACTIONS(2760),
    [sym_readonly] = ACTIONS(2760),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(2762),
    [sym_identifier] = ACTIONS(2764),
    [anon_sym_export] = ACTIONS(2764),
    [anon_sym_default] = ACTIONS(2764),
    [anon_sym_namespace] = ACTIONS(2764),
    [anon_sym_LBRACE] = ACTIONS(2762),
    [anon_sym_RBRACE] = ACTIONS(2762),
    [anon_sym_type] = ACTIONS(2764),
    [anon_sym_typeof] = ACTIONS(2764),
    [anon_sym_import] = ACTIONS(2764),
    [anon_sym_var] = ACTIONS(2764),
    [anon_sym_let] = ACTIONS(2764),
    [anon_sym_const] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_else] = ACTIONS(2764),
    [anon_sym_switch] = ACTIONS(2764),
    [anon_sym_for] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_await] = ACTIONS(2764),
    [anon_sym_while] = ACTIONS(2764),
    [anon_sym_do] = ACTIONS(2764),
    [anon_sym_try] = ACTIONS(2764),
    [anon_sym_with] = ACTIONS(2764),
    [anon_sym_break] = ACTIONS(2764),
    [anon_sym_continue] = ACTIONS(2764),
    [anon_sym_debugger] = ACTIONS(2764),
    [anon_sym_return] = ACTIONS(2764),
    [anon_sym_throw] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_case] = ACTIONS(2764),
    [anon_sym_yield] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2762),
    [anon_sym_LT] = ACTIONS(2762),
    [anon_sym_SLASH] = ACTIONS(2764),
    [anon_sym_class] = ACTIONS(2764),
    [anon_sym_async] = ACTIONS(2764),
    [anon_sym_function] = ACTIONS(2764),
    [anon_sym_new] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2764),
    [anon_sym_BANG] = ACTIONS(2762),
    [anon_sym_TILDE] = ACTIONS(2762),
    [anon_sym_void] = ACTIONS(2764),
    [anon_sym_delete] = ACTIONS(2764),
    [anon_sym_PLUS_PLUS] = ACTIONS(2762),
    [anon_sym_DASH_DASH] = ACTIONS(2762),
    [anon_sym_DQUOTE] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2762),
    [sym_number] = ACTIONS(2762),
    [sym_this] = ACTIONS(2764),
    [sym_super] = ACTIONS(2764),
    [sym_true] = ACTIONS(2764),
    [sym_false] = ACTIONS(2764),
    [sym_null] = ACTIONS(2764),
    [sym_undefined] = ACTIONS(2764),
    [anon_sym_AT] = ACTIONS(2762),
    [anon_sym_static] = ACTIONS(2764),
    [anon_sym_abstract] = ACTIONS(2764),
    [anon_sym_get] = ACTIONS(2764),
    [anon_sym_set] = ACTIONS(2764),
    [anon_sym_declare] = ACTIONS(2764),
    [anon_sym_public] = ACTIONS(2764),
    [anon_sym_private] = ACTIONS(2764),
    [anon_sym_protected] = ACTIONS(2764),
    [anon_sym_module] = ACTIONS(2764),
    [anon_sym_any] = ACTIONS(2764),
    [anon_sym_number] = ACTIONS(2764),
    [anon_sym_boolean] = ACTIONS(2764),
    [anon_sym_string] = ACTIONS(2764),
    [anon_sym_symbol] = ACTIONS(2764),
    [anon_sym_interface] = ACTIONS(2764),
    [anon_sym_enum] = ACTIONS(2764),
    [sym_readonly] = ACTIONS(2764),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(2766),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_export] = ACTIONS(2768),
    [anon_sym_default] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2766),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_typeof] = ACTIONS(2768),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_var] = ACTIONS(2768),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(2768),
    [anon_sym_if] = ACTIONS(2768),
    [anon_sym_else] = ACTIONS(2768),
    [anon_sym_switch] = ACTIONS(2768),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_await] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_break] = ACTIONS(2768),
    [anon_sym_continue] = ACTIONS(2768),
    [anon_sym_debugger] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_throw] = ACTIONS(2768),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_case] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2766),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_SLASH] = ACTIONS(2768),
    [anon_sym_class] = ACTIONS(2768),
    [anon_sym_async] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_BANG] = ACTIONS(2766),
    [anon_sym_TILDE] = ACTIONS(2766),
    [anon_sym_void] = ACTIONS(2768),
    [anon_sym_delete] = ACTIONS(2768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2766),
    [anon_sym_DASH_DASH] = ACTIONS(2766),
    [anon_sym_DQUOTE] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2766),
    [sym_number] = ACTIONS(2766),
    [sym_this] = ACTIONS(2768),
    [sym_super] = ACTIONS(2768),
    [sym_true] = ACTIONS(2768),
    [sym_false] = ACTIONS(2768),
    [sym_null] = ACTIONS(2768),
    [sym_undefined] = ACTIONS(2768),
    [anon_sym_AT] = ACTIONS(2766),
    [anon_sym_static] = ACTIONS(2768),
    [anon_sym_abstract] = ACTIONS(2768),
    [anon_sym_get] = ACTIONS(2768),
    [anon_sym_set] = ACTIONS(2768),
    [anon_sym_declare] = ACTIONS(2768),
    [anon_sym_public] = ACTIONS(2768),
    [anon_sym_private] = ACTIONS(2768),
    [anon_sym_protected] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_any] = ACTIONS(2768),
    [anon_sym_number] = ACTIONS(2768),
    [anon_sym_boolean] = ACTIONS(2768),
    [anon_sym_string] = ACTIONS(2768),
    [anon_sym_symbol] = ACTIONS(2768),
    [anon_sym_interface] = ACTIONS(2768),
    [anon_sym_enum] = ACTIONS(2768),
    [sym_readonly] = ACTIONS(2768),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_default] = ACTIONS(2772),
    [anon_sym_namespace] = ACTIONS(2772),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_type] = ACTIONS(2772),
    [anon_sym_typeof] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_var] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2772),
    [anon_sym_switch] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_await] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [anon_sym_do] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_with] = ACTIONS(2772),
    [anon_sym_break] = ACTIONS(2772),
    [anon_sym_continue] = ACTIONS(2772),
    [anon_sym_debugger] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_throw] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_case] = ACTIONS(2772),
    [anon_sym_yield] = ACTIONS(2772),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [anon_sym_LT] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2772),
    [anon_sym_class] = ACTIONS(2772),
    [anon_sym_async] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_new] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_DASH] = ACTIONS(2772),
    [anon_sym_BANG] = ACTIONS(2770),
    [anon_sym_TILDE] = ACTIONS(2770),
    [anon_sym_void] = ACTIONS(2772),
    [anon_sym_delete] = ACTIONS(2772),
    [anon_sym_PLUS_PLUS] = ACTIONS(2770),
    [anon_sym_DASH_DASH] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2770),
    [sym_number] = ACTIONS(2770),
    [sym_this] = ACTIONS(2772),
    [sym_super] = ACTIONS(2772),
    [sym_true] = ACTIONS(2772),
    [sym_false] = ACTIONS(2772),
    [sym_null] = ACTIONS(2772),
    [sym_undefined] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2770),
    [anon_sym_static] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_get] = ACTIONS(2772),
    [anon_sym_set] = ACTIONS(2772),
    [anon_sym_declare] = ACTIONS(2772),
    [anon_sym_public] = ACTIONS(2772),
    [anon_sym_private] = ACTIONS(2772),
    [anon_sym_protected] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_any] = ACTIONS(2772),
    [anon_sym_number] = ACTIONS(2772),
    [anon_sym_boolean] = ACTIONS(2772),
    [anon_sym_string] = ACTIONS(2772),
    [anon_sym_symbol] = ACTIONS(2772),
    [anon_sym_interface] = ACTIONS(2772),
    [anon_sym_enum] = ACTIONS(2772),
    [sym_readonly] = ACTIONS(2772),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(2774),
    [sym_identifier] = ACTIONS(2776),
    [anon_sym_export] = ACTIONS(2776),
    [anon_sym_default] = ACTIONS(2776),
    [anon_sym_namespace] = ACTIONS(2776),
    [anon_sym_LBRACE] = ACTIONS(2774),
    [anon_sym_RBRACE] = ACTIONS(2774),
    [anon_sym_type] = ACTIONS(2776),
    [anon_sym_typeof] = ACTIONS(2776),
    [anon_sym_import] = ACTIONS(2776),
    [anon_sym_var] = ACTIONS(2776),
    [anon_sym_let] = ACTIONS(2776),
    [anon_sym_const] = ACTIONS(2776),
    [anon_sym_if] = ACTIONS(2776),
    [anon_sym_else] = ACTIONS(2776),
    [anon_sym_switch] = ACTIONS(2776),
    [anon_sym_for] = ACTIONS(2776),
    [anon_sym_LPAREN] = ACTIONS(2774),
    [anon_sym_await] = ACTIONS(2776),
    [anon_sym_while] = ACTIONS(2776),
    [anon_sym_do] = ACTIONS(2776),
    [anon_sym_try] = ACTIONS(2776),
    [anon_sym_with] = ACTIONS(2776),
    [anon_sym_break] = ACTIONS(2776),
    [anon_sym_continue] = ACTIONS(2776),
    [anon_sym_debugger] = ACTIONS(2776),
    [anon_sym_return] = ACTIONS(2776),
    [anon_sym_throw] = ACTIONS(2776),
    [anon_sym_SEMI] = ACTIONS(2774),
    [anon_sym_case] = ACTIONS(2776),
    [anon_sym_yield] = ACTIONS(2776),
    [anon_sym_LBRACK] = ACTIONS(2774),
    [anon_sym_LT] = ACTIONS(2774),
    [anon_sym_SLASH] = ACTIONS(2776),
    [anon_sym_class] = ACTIONS(2776),
    [anon_sym_async] = ACTIONS(2776),
    [anon_sym_function] = ACTIONS(2776),
    [anon_sym_new] = ACTIONS(2776),
    [anon_sym_PLUS] = ACTIONS(2776),
    [anon_sym_DASH] = ACTIONS(2776),
    [anon_sym_BANG] = ACTIONS(2774),
    [anon_sym_TILDE] = ACTIONS(2774),
    [anon_sym_void] = ACTIONS(2776),
    [anon_sym_delete] = ACTIONS(2776),
    [anon_sym_PLUS_PLUS] = ACTIONS(2774),
    [anon_sym_DASH_DASH] = ACTIONS(2774),
    [anon_sym_DQUOTE] = ACTIONS(2774),
    [anon_sym_SQUOTE] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2774),
    [sym_number] = ACTIONS(2774),
    [sym_this] = ACTIONS(2776),
    [sym_super] = ACTIONS(2776),
    [sym_true] = ACTIONS(2776),
    [sym_false] = ACTIONS(2776),
    [sym_null] = ACTIONS(2776),
    [sym_undefined] = ACTIONS(2776),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_static] = ACTIONS(2776),
    [anon_sym_abstract] = ACTIONS(2776),
    [anon_sym_get] = ACTIONS(2776),
    [anon_sym_set] = ACTIONS(2776),
    [anon_sym_declare] = ACTIONS(2776),
    [anon_sym_public] = ACTIONS(2776),
    [anon_sym_private] = ACTIONS(2776),
    [anon_sym_protected] = ACTIONS(2776),
    [anon_sym_module] = ACTIONS(2776),
    [anon_sym_any] = ACTIONS(2776),
    [anon_sym_number] = ACTIONS(2776),
    [anon_sym_boolean] = ACTIONS(2776),
    [anon_sym_string] = ACTIONS(2776),
    [anon_sym_symbol] = ACTIONS(2776),
    [anon_sym_interface] = ACTIONS(2776),
    [anon_sym_enum] = ACTIONS(2776),
    [sym_readonly] = ACTIONS(2776),
  },
  [543] = {
    [ts_builtin_sym_end] = ACTIONS(2778),
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_export] = ACTIONS(2780),
    [anon_sym_default] = ACTIONS(2780),
    [anon_sym_namespace] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2778),
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_type] = ACTIONS(2780),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_import] = ACTIONS(2780),
    [anon_sym_var] = ACTIONS(2780),
    [anon_sym_let] = ACTIONS(2780),
    [anon_sym_const] = ACTIONS(2780),
    [anon_sym_if] = ACTIONS(2780),
    [anon_sym_else] = ACTIONS(2780),
    [anon_sym_switch] = ACTIONS(2780),
    [anon_sym_for] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2778),
    [anon_sym_await] = ACTIONS(2780),
    [anon_sym_while] = ACTIONS(2780),
    [anon_sym_do] = ACTIONS(2780),
    [anon_sym_try] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2780),
    [anon_sym_break] = ACTIONS(2780),
    [anon_sym_continue] = ACTIONS(2780),
    [anon_sym_debugger] = ACTIONS(2780),
    [anon_sym_return] = ACTIONS(2780),
    [anon_sym_throw] = ACTIONS(2780),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_case] = ACTIONS(2780),
    [anon_sym_yield] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2778),
    [anon_sym_LT] = ACTIONS(2778),
    [anon_sym_SLASH] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_function] = ACTIONS(2780),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2778),
    [anon_sym_TILDE] = ACTIONS(2778),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_delete] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2778),
    [anon_sym_DASH_DASH] = ACTIONS(2778),
    [anon_sym_DQUOTE] = ACTIONS(2778),
    [anon_sym_SQUOTE] = ACTIONS(2778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2778),
    [sym_number] = ACTIONS(2778),
    [sym_this] = ACTIONS(2780),
    [sym_super] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_AT] = ACTIONS(2778),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_abstract] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2780),
    [anon_sym_set] = ACTIONS(2780),
    [anon_sym_declare] = ACTIONS(2780),
    [anon_sym_public] = ACTIONS(2780),
    [anon_sym_private] = ACTIONS(2780),
    [anon_sym_protected] = ACTIONS(2780),
    [anon_sym_module] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_interface] = ACTIONS(2780),
    [anon_sym_enum] = ACTIONS(2780),
    [sym_readonly] = ACTIONS(2780),
  },
  [544] = {
    [sym__call_signature] = STATE(2935),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2543),
    [anon_sym_export] = ACTIONS(2545),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2545),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2545),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2545),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2545),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2545),
    [anon_sym_get] = ACTIONS(2545),
    [anon_sym_set] = ACTIONS(2545),
    [anon_sym_declare] = ACTIONS(2545),
    [anon_sym_public] = ACTIONS(2545),
    [anon_sym_private] = ACTIONS(2545),
    [anon_sym_protected] = ACTIONS(2545),
    [anon_sym_module] = ACTIONS(2545),
    [anon_sym_any] = ACTIONS(2545),
    [anon_sym_number] = ACTIONS(2545),
    [anon_sym_boolean] = ACTIONS(2545),
    [anon_sym_string] = ACTIONS(2545),
    [anon_sym_symbol] = ACTIONS(2545),
    [sym_readonly] = ACTIONS(2545),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(2782),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2784),
    [anon_sym_default] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(2784),
    [anon_sym_import] = ACTIONS(2784),
    [anon_sym_var] = ACTIONS(2784),
    [anon_sym_let] = ACTIONS(2784),
    [anon_sym_const] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2784),
    [anon_sym_switch] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_do] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2784),
    [anon_sym_with] = ACTIONS(2784),
    [anon_sym_break] = ACTIONS(2784),
    [anon_sym_continue] = ACTIONS(2784),
    [anon_sym_debugger] = ACTIONS(2784),
    [anon_sym_return] = ACTIONS(2784),
    [anon_sym_throw] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym_case] = ACTIONS(2784),
    [anon_sym_yield] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2784),
    [anon_sym_class] = ACTIONS(2784),
    [anon_sym_async] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2784),
    [anon_sym_new] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2784),
    [anon_sym_delete] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2784),
    [sym_super] = ACTIONS(2784),
    [sym_true] = ACTIONS(2784),
    [sym_false] = ACTIONS(2784),
    [sym_null] = ACTIONS(2784),
    [sym_undefined] = ACTIONS(2784),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2784),
    [anon_sym_get] = ACTIONS(2784),
    [anon_sym_set] = ACTIONS(2784),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2784),
    [anon_sym_private] = ACTIONS(2784),
    [anon_sym_protected] = ACTIONS(2784),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2784),
    [anon_sym_enum] = ACTIONS(2784),
    [sym_readonly] = ACTIONS(2784),
  },
  [546] = {
    [ts_builtin_sym_end] = ACTIONS(1237),
    [sym_identifier] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(1239),
    [anon_sym_namespace] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_type] = ACTIONS(1239),
    [anon_sym_typeof] = ACTIONS(1239),
    [anon_sym_import] = ACTIONS(1239),
    [anon_sym_var] = ACTIONS(1239),
    [anon_sym_let] = ACTIONS(1239),
    [anon_sym_const] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1239),
    [anon_sym_switch] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_do] = ACTIONS(1239),
    [anon_sym_try] = ACTIONS(1239),
    [anon_sym_with] = ACTIONS(1239),
    [anon_sym_break] = ACTIONS(1239),
    [anon_sym_continue] = ACTIONS(1239),
    [anon_sym_debugger] = ACTIONS(1239),
    [anon_sym_return] = ACTIONS(1239),
    [anon_sym_throw] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_yield] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_class] = ACTIONS(1239),
    [anon_sym_async] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_new] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_TILDE] = ACTIONS(1237),
    [anon_sym_void] = ACTIONS(1239),
    [anon_sym_delete] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [sym_number] = ACTIONS(1237),
    [sym_this] = ACTIONS(1239),
    [sym_super] = ACTIONS(1239),
    [sym_true] = ACTIONS(1239),
    [sym_false] = ACTIONS(1239),
    [sym_null] = ACTIONS(1239),
    [sym_undefined] = ACTIONS(1239),
    [anon_sym_AT] = ACTIONS(1237),
    [anon_sym_static] = ACTIONS(1239),
    [anon_sym_abstract] = ACTIONS(1239),
    [anon_sym_get] = ACTIONS(1239),
    [anon_sym_set] = ACTIONS(1239),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_public] = ACTIONS(1239),
    [anon_sym_private] = ACTIONS(1239),
    [anon_sym_protected] = ACTIONS(1239),
    [anon_sym_module] = ACTIONS(1239),
    [anon_sym_any] = ACTIONS(1239),
    [anon_sym_number] = ACTIONS(1239),
    [anon_sym_boolean] = ACTIONS(1239),
    [anon_sym_string] = ACTIONS(1239),
    [anon_sym_symbol] = ACTIONS(1239),
    [anon_sym_interface] = ACTIONS(1239),
    [anon_sym_enum] = ACTIONS(1239),
    [sym_readonly] = ACTIONS(1239),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(2786),
    [sym_identifier] = ACTIONS(2788),
    [anon_sym_export] = ACTIONS(2788),
    [anon_sym_default] = ACTIONS(2788),
    [anon_sym_namespace] = ACTIONS(2788),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2788),
    [anon_sym_typeof] = ACTIONS(2788),
    [anon_sym_import] = ACTIONS(2788),
    [anon_sym_var] = ACTIONS(2788),
    [anon_sym_let] = ACTIONS(2788),
    [anon_sym_const] = ACTIONS(2788),
    [anon_sym_if] = ACTIONS(2788),
    [anon_sym_else] = ACTIONS(2788),
    [anon_sym_switch] = ACTIONS(2788),
    [anon_sym_for] = ACTIONS(2788),
    [anon_sym_LPAREN] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2788),
    [anon_sym_while] = ACTIONS(2788),
    [anon_sym_do] = ACTIONS(2788),
    [anon_sym_try] = ACTIONS(2788),
    [anon_sym_with] = ACTIONS(2788),
    [anon_sym_break] = ACTIONS(2788),
    [anon_sym_continue] = ACTIONS(2788),
    [anon_sym_debugger] = ACTIONS(2788),
    [anon_sym_return] = ACTIONS(2788),
    [anon_sym_throw] = ACTIONS(2788),
    [anon_sym_SEMI] = ACTIONS(2786),
    [anon_sym_case] = ACTIONS(2788),
    [anon_sym_yield] = ACTIONS(2788),
    [anon_sym_LBRACK] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2788),
    [anon_sym_class] = ACTIONS(2788),
    [anon_sym_async] = ACTIONS(2788),
    [anon_sym_function] = ACTIONS(2788),
    [anon_sym_new] = ACTIONS(2788),
    [anon_sym_PLUS] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_TILDE] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2788),
    [anon_sym_delete] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2786),
    [sym_number] = ACTIONS(2786),
    [sym_this] = ACTIONS(2788),
    [sym_super] = ACTIONS(2788),
    [sym_true] = ACTIONS(2788),
    [sym_false] = ACTIONS(2788),
    [sym_null] = ACTIONS(2788),
    [sym_undefined] = ACTIONS(2788),
    [anon_sym_AT] = ACTIONS(2786),
    [anon_sym_static] = ACTIONS(2788),
    [anon_sym_abstract] = ACTIONS(2788),
    [anon_sym_get] = ACTIONS(2788),
    [anon_sym_set] = ACTIONS(2788),
    [anon_sym_declare] = ACTIONS(2788),
    [anon_sym_public] = ACTIONS(2788),
    [anon_sym_private] = ACTIONS(2788),
    [anon_sym_protected] = ACTIONS(2788),
    [anon_sym_module] = ACTIONS(2788),
    [anon_sym_any] = ACTIONS(2788),
    [anon_sym_number] = ACTIONS(2788),
    [anon_sym_boolean] = ACTIONS(2788),
    [anon_sym_string] = ACTIONS(2788),
    [anon_sym_symbol] = ACTIONS(2788),
    [anon_sym_interface] = ACTIONS(2788),
    [anon_sym_enum] = ACTIONS(2788),
    [sym_readonly] = ACTIONS(2788),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(1241),
    [sym_identifier] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(1243),
    [anon_sym_default] = ACTIONS(1243),
    [anon_sym_namespace] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_type] = ACTIONS(1243),
    [anon_sym_typeof] = ACTIONS(1243),
    [anon_sym_import] = ACTIONS(1243),
    [anon_sym_var] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1243),
    [anon_sym_const] = ACTIONS(1243),
    [anon_sym_if] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1243),
    [anon_sym_switch] = ACTIONS(1243),
    [anon_sym_for] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_await] = ACTIONS(1243),
    [anon_sym_while] = ACTIONS(1243),
    [anon_sym_do] = ACTIONS(1243),
    [anon_sym_try] = ACTIONS(1243),
    [anon_sym_with] = ACTIONS(1243),
    [anon_sym_break] = ACTIONS(1243),
    [anon_sym_continue] = ACTIONS(1243),
    [anon_sym_debugger] = ACTIONS(1243),
    [anon_sym_return] = ACTIONS(1243),
    [anon_sym_throw] = ACTIONS(1243),
    [anon_sym_SEMI] = ACTIONS(1241),
    [anon_sym_case] = ACTIONS(1243),
    [anon_sym_yield] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_class] = ACTIONS(1243),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_function] = ACTIONS(1243),
    [anon_sym_new] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1241),
    [anon_sym_TILDE] = ACTIONS(1241),
    [anon_sym_void] = ACTIONS(1243),
    [anon_sym_delete] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(1241),
    [anon_sym_SQUOTE] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [sym_number] = ACTIONS(1241),
    [sym_this] = ACTIONS(1243),
    [sym_super] = ACTIONS(1243),
    [sym_true] = ACTIONS(1243),
    [sym_false] = ACTIONS(1243),
    [sym_null] = ACTIONS(1243),
    [sym_undefined] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
    [anon_sym_static] = ACTIONS(1243),
    [anon_sym_abstract] = ACTIONS(1243),
    [anon_sym_get] = ACTIONS(1243),
    [anon_sym_set] = ACTIONS(1243),
    [anon_sym_declare] = ACTIONS(1243),
    [anon_sym_public] = ACTIONS(1243),
    [anon_sym_private] = ACTIONS(1243),
    [anon_sym_protected] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1243),
    [anon_sym_any] = ACTIONS(1243),
    [anon_sym_number] = ACTIONS(1243),
    [anon_sym_boolean] = ACTIONS(1243),
    [anon_sym_string] = ACTIONS(1243),
    [anon_sym_symbol] = ACTIONS(1243),
    [anon_sym_interface] = ACTIONS(1243),
    [anon_sym_enum] = ACTIONS(1243),
    [sym_readonly] = ACTIONS(1243),
  },
  [549] = {
    [sym_object] = STATE(2082),
    [sym_array] = STATE(2170),
    [sym_identifier] = ACTIONS(2790),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [sym_readonly] = ACTIONS(2792),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(2799),
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_export] = ACTIONS(2801),
    [anon_sym_default] = ACTIONS(2801),
    [anon_sym_namespace] = ACTIONS(2801),
    [anon_sym_LBRACE] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_type] = ACTIONS(2801),
    [anon_sym_typeof] = ACTIONS(2801),
    [anon_sym_import] = ACTIONS(2801),
    [anon_sym_var] = ACTIONS(2801),
    [anon_sym_let] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_else] = ACTIONS(2801),
    [anon_sym_switch] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_LPAREN] = ACTIONS(2799),
    [anon_sym_await] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [anon_sym_do] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_with] = ACTIONS(2801),
    [anon_sym_break] = ACTIONS(2801),
    [anon_sym_continue] = ACTIONS(2801),
    [anon_sym_debugger] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_throw] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2801),
    [anon_sym_yield] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_LT] = ACTIONS(2799),
    [anon_sym_SLASH] = ACTIONS(2801),
    [anon_sym_class] = ACTIONS(2801),
    [anon_sym_async] = ACTIONS(2801),
    [anon_sym_function] = ACTIONS(2801),
    [anon_sym_new] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_void] = ACTIONS(2801),
    [anon_sym_delete] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2799),
    [anon_sym_DQUOTE] = ACTIONS(2799),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2799),
    [sym_number] = ACTIONS(2799),
    [sym_this] = ACTIONS(2801),
    [sym_super] = ACTIONS(2801),
    [sym_true] = ACTIONS(2801),
    [sym_false] = ACTIONS(2801),
    [sym_null] = ACTIONS(2801),
    [sym_undefined] = ACTIONS(2801),
    [anon_sym_AT] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2801),
    [anon_sym_abstract] = ACTIONS(2801),
    [anon_sym_get] = ACTIONS(2801),
    [anon_sym_set] = ACTIONS(2801),
    [anon_sym_declare] = ACTIONS(2801),
    [anon_sym_public] = ACTIONS(2801),
    [anon_sym_private] = ACTIONS(2801),
    [anon_sym_protected] = ACTIONS(2801),
    [anon_sym_module] = ACTIONS(2801),
    [anon_sym_any] = ACTIONS(2801),
    [anon_sym_number] = ACTIONS(2801),
    [anon_sym_boolean] = ACTIONS(2801),
    [anon_sym_string] = ACTIONS(2801),
    [anon_sym_symbol] = ACTIONS(2801),
    [anon_sym_interface] = ACTIONS(2801),
    [anon_sym_enum] = ACTIONS(2801),
    [sym_readonly] = ACTIONS(2801),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(2803),
    [sym_identifier] = ACTIONS(2805),
    [anon_sym_export] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_type] = ACTIONS(2805),
    [anon_sym_typeof] = ACTIONS(2805),
    [anon_sym_import] = ACTIONS(2805),
    [anon_sym_var] = ACTIONS(2805),
    [anon_sym_let] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_else] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [anon_sym_await] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_with] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_debugger] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_yield] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_LT] = ACTIONS(2803),
    [anon_sym_SLASH] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_async] = ACTIONS(2805),
    [anon_sym_function] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [anon_sym_void] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [anon_sym_DQUOTE] = ACTIONS(2803),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2803),
    [sym_number] = ACTIONS(2803),
    [sym_this] = ACTIONS(2805),
    [sym_super] = ACTIONS(2805),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [sym_null] = ACTIONS(2805),
    [sym_undefined] = ACTIONS(2805),
    [anon_sym_AT] = ACTIONS(2803),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_abstract] = ACTIONS(2805),
    [anon_sym_get] = ACTIONS(2805),
    [anon_sym_set] = ACTIONS(2805),
    [anon_sym_declare] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_module] = ACTIONS(2805),
    [anon_sym_any] = ACTIONS(2805),
    [anon_sym_number] = ACTIONS(2805),
    [anon_sym_boolean] = ACTIONS(2805),
    [anon_sym_string] = ACTIONS(2805),
    [anon_sym_symbol] = ACTIONS(2805),
    [anon_sym_interface] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [sym_readonly] = ACTIONS(2805),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(2807),
    [sym_identifier] = ACTIONS(2809),
    [anon_sym_export] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_type] = ACTIONS(2809),
    [anon_sym_typeof] = ACTIONS(2809),
    [anon_sym_import] = ACTIONS(2809),
    [anon_sym_var] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_else] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_await] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_debugger] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_yield] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LT] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_async] = ACTIONS(2809),
    [anon_sym_function] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_void] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2807),
    [sym_number] = ACTIONS(2807),
    [sym_this] = ACTIONS(2809),
    [sym_super] = ACTIONS(2809),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [sym_null] = ACTIONS(2809),
    [sym_undefined] = ACTIONS(2809),
    [anon_sym_AT] = ACTIONS(2807),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_abstract] = ACTIONS(2809),
    [anon_sym_get] = ACTIONS(2809),
    [anon_sym_set] = ACTIONS(2809),
    [anon_sym_declare] = ACTIONS(2809),
    [anon_sym_public] = ACTIONS(2809),
    [anon_sym_private] = ACTIONS(2809),
    [anon_sym_protected] = ACTIONS(2809),
    [anon_sym_module] = ACTIONS(2809),
    [anon_sym_any] = ACTIONS(2809),
    [anon_sym_number] = ACTIONS(2809),
    [anon_sym_boolean] = ACTIONS(2809),
    [anon_sym_string] = ACTIONS(2809),
    [anon_sym_symbol] = ACTIONS(2809),
    [anon_sym_interface] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [sym_readonly] = ACTIONS(2809),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [sym_identifier] = ACTIONS(1187),
    [anon_sym_export] = ACTIONS(1187),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_namespace] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_type] = ACTIONS(1187),
    [anon_sym_typeof] = ACTIONS(1187),
    [anon_sym_import] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(1187),
    [anon_sym_let] = ACTIONS(1187),
    [anon_sym_const] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_for] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1187),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_do] = ACTIONS(1187),
    [anon_sym_try] = ACTIONS(1187),
    [anon_sym_with] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_continue] = ACTIONS(1187),
    [anon_sym_debugger] = ACTIONS(1187),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1187),
    [anon_sym_yield] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_class] = ACTIONS(1187),
    [anon_sym_async] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(1187),
    [anon_sym_new] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1185),
    [anon_sym_TILDE] = ACTIONS(1185),
    [anon_sym_void] = ACTIONS(1187),
    [anon_sym_delete] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym_number] = ACTIONS(1185),
    [sym_this] = ACTIONS(1187),
    [sym_super] = ACTIONS(1187),
    [sym_true] = ACTIONS(1187),
    [sym_false] = ACTIONS(1187),
    [sym_null] = ACTIONS(1187),
    [sym_undefined] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
    [anon_sym_static] = ACTIONS(1187),
    [anon_sym_abstract] = ACTIONS(1187),
    [anon_sym_get] = ACTIONS(1187),
    [anon_sym_set] = ACTIONS(1187),
    [anon_sym_declare] = ACTIONS(1187),
    [anon_sym_public] = ACTIONS(1187),
    [anon_sym_private] = ACTIONS(1187),
    [anon_sym_protected] = ACTIONS(1187),
    [anon_sym_module] = ACTIONS(1187),
    [anon_sym_any] = ACTIONS(1187),
    [anon_sym_number] = ACTIONS(1187),
    [anon_sym_boolean] = ACTIONS(1187),
    [anon_sym_string] = ACTIONS(1187),
    [anon_sym_symbol] = ACTIONS(1187),
    [anon_sym_interface] = ACTIONS(1187),
    [anon_sym_enum] = ACTIONS(1187),
    [sym_readonly] = ACTIONS(1187),
  },
  [554] = {
    [sym_object] = STATE(2082),
    [sym_array] = STATE(2170),
    [sym_identifier] = ACTIONS(2790),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(2796),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [sym_readonly] = ACTIONS(2792),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(2813),
    [anon_sym_export] = ACTIONS(2813),
    [anon_sym_default] = ACTIONS(2813),
    [anon_sym_namespace] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_type] = ACTIONS(2813),
    [anon_sym_typeof] = ACTIONS(2813),
    [anon_sym_import] = ACTIONS(2813),
    [anon_sym_var] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_const] = ACTIONS(2813),
    [anon_sym_if] = ACTIONS(2813),
    [anon_sym_else] = ACTIONS(2813),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_for] = ACTIONS(2813),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_await] = ACTIONS(2813),
    [anon_sym_while] = ACTIONS(2813),
    [anon_sym_do] = ACTIONS(2813),
    [anon_sym_try] = ACTIONS(2813),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_break] = ACTIONS(2813),
    [anon_sym_continue] = ACTIONS(2813),
    [anon_sym_debugger] = ACTIONS(2813),
    [anon_sym_return] = ACTIONS(2813),
    [anon_sym_throw] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_case] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LT] = ACTIONS(2811),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_class] = ACTIONS(2813),
    [anon_sym_async] = ACTIONS(2813),
    [anon_sym_function] = ACTIONS(2813),
    [anon_sym_new] = ACTIONS(2813),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_void] = ACTIONS(2813),
    [anon_sym_delete] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2811),
    [sym_number] = ACTIONS(2811),
    [sym_this] = ACTIONS(2813),
    [sym_super] = ACTIONS(2813),
    [sym_true] = ACTIONS(2813),
    [sym_false] = ACTIONS(2813),
    [sym_null] = ACTIONS(2813),
    [sym_undefined] = ACTIONS(2813),
    [anon_sym_AT] = ACTIONS(2811),
    [anon_sym_static] = ACTIONS(2813),
    [anon_sym_abstract] = ACTIONS(2813),
    [anon_sym_get] = ACTIONS(2813),
    [anon_sym_set] = ACTIONS(2813),
    [anon_sym_declare] = ACTIONS(2813),
    [anon_sym_public] = ACTIONS(2813),
    [anon_sym_private] = ACTIONS(2813),
    [anon_sym_protected] = ACTIONS(2813),
    [anon_sym_module] = ACTIONS(2813),
    [anon_sym_any] = ACTIONS(2813),
    [anon_sym_number] = ACTIONS(2813),
    [anon_sym_boolean] = ACTIONS(2813),
    [anon_sym_string] = ACTIONS(2813),
    [anon_sym_symbol] = ACTIONS(2813),
    [anon_sym_interface] = ACTIONS(2813),
    [anon_sym_enum] = ACTIONS(2813),
    [sym_readonly] = ACTIONS(2813),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(2815),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_default] = ACTIONS(2817),
    [anon_sym_namespace] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_type] = ACTIONS(2817),
    [anon_sym_typeof] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_var] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_else] = ACTIONS(2817),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_await] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [anon_sym_do] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_with] = ACTIONS(2817),
    [anon_sym_break] = ACTIONS(2817),
    [anon_sym_continue] = ACTIONS(2817),
    [anon_sym_debugger] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_throw] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_case] = ACTIONS(2817),
    [anon_sym_yield] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LT] = ACTIONS(2815),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_class] = ACTIONS(2817),
    [anon_sym_async] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_new] = ACTIONS(2817),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2815),
    [anon_sym_void] = ACTIONS(2817),
    [anon_sym_delete] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_DQUOTE] = ACTIONS(2815),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2815),
    [sym_number] = ACTIONS(2815),
    [sym_this] = ACTIONS(2817),
    [sym_super] = ACTIONS(2817),
    [sym_true] = ACTIONS(2817),
    [sym_false] = ACTIONS(2817),
    [sym_null] = ACTIONS(2817),
    [sym_undefined] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2815),
    [anon_sym_static] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_get] = ACTIONS(2817),
    [anon_sym_set] = ACTIONS(2817),
    [anon_sym_declare] = ACTIONS(2817),
    [anon_sym_public] = ACTIONS(2817),
    [anon_sym_private] = ACTIONS(2817),
    [anon_sym_protected] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_any] = ACTIONS(2817),
    [anon_sym_number] = ACTIONS(2817),
    [anon_sym_boolean] = ACTIONS(2817),
    [anon_sym_string] = ACTIONS(2817),
    [anon_sym_symbol] = ACTIONS(2817),
    [anon_sym_interface] = ACTIONS(2817),
    [anon_sym_enum] = ACTIONS(2817),
    [sym_readonly] = ACTIONS(2817),
  },
  [557] = {
    [sym__call_signature] = STATE(2802),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2614),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2614),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2614),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2614),
    [anon_sym_get] = ACTIONS(2614),
    [anon_sym_set] = ACTIONS(2614),
    [anon_sym_declare] = ACTIONS(2614),
    [anon_sym_public] = ACTIONS(2614),
    [anon_sym_private] = ACTIONS(2614),
    [anon_sym_protected] = ACTIONS(2614),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_any] = ACTIONS(2614),
    [anon_sym_number] = ACTIONS(2614),
    [anon_sym_boolean] = ACTIONS(2614),
    [anon_sym_string] = ACTIONS(2614),
    [anon_sym_symbol] = ACTIONS(2614),
    [anon_sym_implements] = ACTIONS(445),
    [sym_readonly] = ACTIONS(2614),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(2819),
    [sym_identifier] = ACTIONS(2821),
    [anon_sym_export] = ACTIONS(2821),
    [anon_sym_default] = ACTIONS(2821),
    [anon_sym_namespace] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_type] = ACTIONS(2821),
    [anon_sym_typeof] = ACTIONS(2821),
    [anon_sym_import] = ACTIONS(2821),
    [anon_sym_var] = ACTIONS(2821),
    [anon_sym_let] = ACTIONS(2821),
    [anon_sym_const] = ACTIONS(2821),
    [anon_sym_if] = ACTIONS(2821),
    [anon_sym_else] = ACTIONS(2821),
    [anon_sym_switch] = ACTIONS(2821),
    [anon_sym_for] = ACTIONS(2821),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_await] = ACTIONS(2821),
    [anon_sym_while] = ACTIONS(2821),
    [anon_sym_do] = ACTIONS(2821),
    [anon_sym_try] = ACTIONS(2821),
    [anon_sym_with] = ACTIONS(2821),
    [anon_sym_break] = ACTIONS(2821),
    [anon_sym_continue] = ACTIONS(2821),
    [anon_sym_debugger] = ACTIONS(2821),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_throw] = ACTIONS(2821),
    [anon_sym_SEMI] = ACTIONS(2819),
    [anon_sym_case] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2821),
    [anon_sym_LBRACK] = ACTIONS(2819),
    [anon_sym_LT] = ACTIONS(2819),
    [anon_sym_SLASH] = ACTIONS(2821),
    [anon_sym_class] = ACTIONS(2821),
    [anon_sym_async] = ACTIONS(2821),
    [anon_sym_function] = ACTIONS(2821),
    [anon_sym_new] = ACTIONS(2821),
    [anon_sym_PLUS] = ACTIONS(2821),
    [anon_sym_DASH] = ACTIONS(2821),
    [anon_sym_BANG] = ACTIONS(2819),
    [anon_sym_TILDE] = ACTIONS(2819),
    [anon_sym_void] = ACTIONS(2821),
    [anon_sym_delete] = ACTIONS(2821),
    [anon_sym_PLUS_PLUS] = ACTIONS(2819),
    [anon_sym_DASH_DASH] = ACTIONS(2819),
    [anon_sym_DQUOTE] = ACTIONS(2819),
    [anon_sym_SQUOTE] = ACTIONS(2819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2819),
    [sym_number] = ACTIONS(2819),
    [sym_this] = ACTIONS(2821),
    [sym_super] = ACTIONS(2821),
    [sym_true] = ACTIONS(2821),
    [sym_false] = ACTIONS(2821),
    [sym_null] = ACTIONS(2821),
    [sym_undefined] = ACTIONS(2821),
    [anon_sym_AT] = ACTIONS(2819),
    [anon_sym_static] = ACTIONS(2821),
    [anon_sym_abstract] = ACTIONS(2821),
    [anon_sym_get] = ACTIONS(2821),
    [anon_sym_set] = ACTIONS(2821),
    [anon_sym_declare] = ACTIONS(2821),
    [anon_sym_public] = ACTIONS(2821),
    [anon_sym_private] = ACTIONS(2821),
    [anon_sym_protected] = ACTIONS(2821),
    [anon_sym_module] = ACTIONS(2821),
    [anon_sym_any] = ACTIONS(2821),
    [anon_sym_number] = ACTIONS(2821),
    [anon_sym_boolean] = ACTIONS(2821),
    [anon_sym_string] = ACTIONS(2821),
    [anon_sym_symbol] = ACTIONS(2821),
    [anon_sym_interface] = ACTIONS(2821),
    [anon_sym_enum] = ACTIONS(2821),
    [sym_readonly] = ACTIONS(2821),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1113),
    [sym_identifier] = ACTIONS(1115),
    [anon_sym_export] = ACTIONS(1115),
    [anon_sym_default] = ACTIONS(1115),
    [anon_sym_namespace] = ACTIONS(1115),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1115),
    [anon_sym_typeof] = ACTIONS(1115),
    [anon_sym_import] = ACTIONS(1115),
    [anon_sym_var] = ACTIONS(1115),
    [anon_sym_let] = ACTIONS(1115),
    [anon_sym_const] = ACTIONS(1115),
    [anon_sym_if] = ACTIONS(1115),
    [anon_sym_else] = ACTIONS(1115),
    [anon_sym_switch] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_await] = ACTIONS(1115),
    [anon_sym_while] = ACTIONS(1115),
    [anon_sym_do] = ACTIONS(1115),
    [anon_sym_try] = ACTIONS(1115),
    [anon_sym_with] = ACTIONS(1115),
    [anon_sym_break] = ACTIONS(1115),
    [anon_sym_continue] = ACTIONS(1115),
    [anon_sym_debugger] = ACTIONS(1115),
    [anon_sym_return] = ACTIONS(1115),
    [anon_sym_throw] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1113),
    [anon_sym_case] = ACTIONS(1115),
    [anon_sym_yield] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1113),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_class] = ACTIONS(1115),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_function] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_BANG] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1113),
    [anon_sym_void] = ACTIONS(1115),
    [anon_sym_delete] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1113),
    [anon_sym_SQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym_number] = ACTIONS(1113),
    [sym_this] = ACTIONS(1115),
    [sym_super] = ACTIONS(1115),
    [sym_true] = ACTIONS(1115),
    [sym_false] = ACTIONS(1115),
    [sym_null] = ACTIONS(1115),
    [sym_undefined] = ACTIONS(1115),
    [anon_sym_AT] = ACTIONS(1113),
    [anon_sym_static] = ACTIONS(1115),
    [anon_sym_abstract] = ACTIONS(1115),
    [anon_sym_get] = ACTIONS(1115),
    [anon_sym_set] = ACTIONS(1115),
    [anon_sym_declare] = ACTIONS(1115),
    [anon_sym_public] = ACTIONS(1115),
    [anon_sym_private] = ACTIONS(1115),
    [anon_sym_protected] = ACTIONS(1115),
    [anon_sym_module] = ACTIONS(1115),
    [anon_sym_any] = ACTIONS(1115),
    [anon_sym_number] = ACTIONS(1115),
    [anon_sym_boolean] = ACTIONS(1115),
    [anon_sym_string] = ACTIONS(1115),
    [anon_sym_symbol] = ACTIONS(1115),
    [anon_sym_interface] = ACTIONS(1115),
    [anon_sym_enum] = ACTIONS(1115),
    [sym_readonly] = ACTIONS(1115),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(2823),
    [sym_identifier] = ACTIONS(2825),
    [anon_sym_export] = ACTIONS(2825),
    [anon_sym_default] = ACTIONS(2825),
    [anon_sym_namespace] = ACTIONS(2825),
    [anon_sym_LBRACE] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_type] = ACTIONS(2825),
    [anon_sym_typeof] = ACTIONS(2825),
    [anon_sym_import] = ACTIONS(2825),
    [anon_sym_var] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2825),
    [anon_sym_const] = ACTIONS(2825),
    [anon_sym_if] = ACTIONS(2825),
    [anon_sym_else] = ACTIONS(2825),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_for] = ACTIONS(2825),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_await] = ACTIONS(2825),
    [anon_sym_while] = ACTIONS(2825),
    [anon_sym_do] = ACTIONS(2825),
    [anon_sym_try] = ACTIONS(2825),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_continue] = ACTIONS(2825),
    [anon_sym_debugger] = ACTIONS(2825),
    [anon_sym_return] = ACTIONS(2825),
    [anon_sym_throw] = ACTIONS(2825),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_case] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LT] = ACTIONS(2823),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_class] = ACTIONS(2825),
    [anon_sym_async] = ACTIONS(2825),
    [anon_sym_function] = ACTIONS(2825),
    [anon_sym_new] = ACTIONS(2825),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_BANG] = ACTIONS(2823),
    [anon_sym_TILDE] = ACTIONS(2823),
    [anon_sym_void] = ACTIONS(2825),
    [anon_sym_delete] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_DQUOTE] = ACTIONS(2823),
    [anon_sym_SQUOTE] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2823),
    [sym_number] = ACTIONS(2823),
    [sym_this] = ACTIONS(2825),
    [sym_super] = ACTIONS(2825),
    [sym_true] = ACTIONS(2825),
    [sym_false] = ACTIONS(2825),
    [sym_null] = ACTIONS(2825),
    [sym_undefined] = ACTIONS(2825),
    [anon_sym_AT] = ACTIONS(2823),
    [anon_sym_static] = ACTIONS(2825),
    [anon_sym_abstract] = ACTIONS(2825),
    [anon_sym_get] = ACTIONS(2825),
    [anon_sym_set] = ACTIONS(2825),
    [anon_sym_declare] = ACTIONS(2825),
    [anon_sym_public] = ACTIONS(2825),
    [anon_sym_private] = ACTIONS(2825),
    [anon_sym_protected] = ACTIONS(2825),
    [anon_sym_module] = ACTIONS(2825),
    [anon_sym_any] = ACTIONS(2825),
    [anon_sym_number] = ACTIONS(2825),
    [anon_sym_boolean] = ACTIONS(2825),
    [anon_sym_string] = ACTIONS(2825),
    [anon_sym_symbol] = ACTIONS(2825),
    [anon_sym_interface] = ACTIONS(2825),
    [anon_sym_enum] = ACTIONS(2825),
    [sym_readonly] = ACTIONS(2825),
  },
  [561] = {
    [sym__call_signature] = STATE(2874),
    [sym_arguments] = STATE(1108),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_void] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2829),
    [anon_sym_set] = ACTIONS(2829),
    [anon_sym_declare] = ACTIONS(2829),
    [anon_sym_public] = ACTIONS(2829),
    [anon_sym_private] = ACTIONS(2829),
    [anon_sym_protected] = ACTIONS(2829),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_any] = ACTIONS(2829),
    [anon_sym_number] = ACTIONS(2829),
    [anon_sym_boolean] = ACTIONS(2829),
    [anon_sym_string] = ACTIONS(2829),
    [anon_sym_symbol] = ACTIONS(2829),
    [sym_readonly] = ACTIONS(2829),
  },
  [562] = {
    [sym__call_signature] = STATE(2920),
    [sym_arguments] = STATE(1440),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_void] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [sym_readonly] = ACTIONS(2833),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_default] = ACTIONS(2837),
    [anon_sym_namespace] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_type] = ACTIONS(2837),
    [anon_sym_typeof] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_var] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_else] = ACTIONS(2837),
    [anon_sym_switch] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_await] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [anon_sym_do] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_with] = ACTIONS(2837),
    [anon_sym_break] = ACTIONS(2837),
    [anon_sym_continue] = ACTIONS(2837),
    [anon_sym_debugger] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_throw] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_case] = ACTIONS(2837),
    [anon_sym_yield] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2835),
    [anon_sym_SLASH] = ACTIONS(2837),
    [anon_sym_class] = ACTIONS(2837),
    [anon_sym_async] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_new] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2837),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [anon_sym_void] = ACTIONS(2837),
    [anon_sym_delete] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_DQUOTE] = ACTIONS(2835),
    [anon_sym_SQUOTE] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2835),
    [sym_number] = ACTIONS(2835),
    [sym_this] = ACTIONS(2837),
    [sym_super] = ACTIONS(2837),
    [sym_true] = ACTIONS(2837),
    [sym_false] = ACTIONS(2837),
    [sym_null] = ACTIONS(2837),
    [sym_undefined] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2835),
    [anon_sym_static] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_get] = ACTIONS(2837),
    [anon_sym_set] = ACTIONS(2837),
    [anon_sym_declare] = ACTIONS(2837),
    [anon_sym_public] = ACTIONS(2837),
    [anon_sym_private] = ACTIONS(2837),
    [anon_sym_protected] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_any] = ACTIONS(2837),
    [anon_sym_number] = ACTIONS(2837),
    [anon_sym_boolean] = ACTIONS(2837),
    [anon_sym_string] = ACTIONS(2837),
    [anon_sym_symbol] = ACTIONS(2837),
    [anon_sym_interface] = ACTIONS(2837),
    [anon_sym_enum] = ACTIONS(2837),
    [sym_readonly] = ACTIONS(2837),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(2839),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_export] = ACTIONS(2841),
    [anon_sym_default] = ACTIONS(2841),
    [anon_sym_namespace] = ACTIONS(2841),
    [anon_sym_LBRACE] = ACTIONS(2839),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_type] = ACTIONS(2841),
    [anon_sym_typeof] = ACTIONS(2841),
    [anon_sym_import] = ACTIONS(2841),
    [anon_sym_var] = ACTIONS(2841),
    [anon_sym_let] = ACTIONS(2841),
    [anon_sym_const] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2841),
    [anon_sym_else] = ACTIONS(2841),
    [anon_sym_switch] = ACTIONS(2841),
    [anon_sym_for] = ACTIONS(2841),
    [anon_sym_LPAREN] = ACTIONS(2839),
    [anon_sym_await] = ACTIONS(2841),
    [anon_sym_while] = ACTIONS(2841),
    [anon_sym_do] = ACTIONS(2841),
    [anon_sym_try] = ACTIONS(2841),
    [anon_sym_with] = ACTIONS(2841),
    [anon_sym_break] = ACTIONS(2841),
    [anon_sym_continue] = ACTIONS(2841),
    [anon_sym_debugger] = ACTIONS(2841),
    [anon_sym_return] = ACTIONS(2841),
    [anon_sym_throw] = ACTIONS(2841),
    [anon_sym_SEMI] = ACTIONS(2839),
    [anon_sym_case] = ACTIONS(2841),
    [anon_sym_yield] = ACTIONS(2841),
    [anon_sym_LBRACK] = ACTIONS(2839),
    [anon_sym_LT] = ACTIONS(2839),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_class] = ACTIONS(2841),
    [anon_sym_async] = ACTIONS(2841),
    [anon_sym_function] = ACTIONS(2841),
    [anon_sym_new] = ACTIONS(2841),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_void] = ACTIONS(2841),
    [anon_sym_delete] = ACTIONS(2841),
    [anon_sym_PLUS_PLUS] = ACTIONS(2839),
    [anon_sym_DASH_DASH] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2839),
    [sym_number] = ACTIONS(2839),
    [sym_this] = ACTIONS(2841),
    [sym_super] = ACTIONS(2841),
    [sym_true] = ACTIONS(2841),
    [sym_false] = ACTIONS(2841),
    [sym_null] = ACTIONS(2841),
    [sym_undefined] = ACTIONS(2841),
    [anon_sym_AT] = ACTIONS(2839),
    [anon_sym_static] = ACTIONS(2841),
    [anon_sym_abstract] = ACTIONS(2841),
    [anon_sym_get] = ACTIONS(2841),
    [anon_sym_set] = ACTIONS(2841),
    [anon_sym_declare] = ACTIONS(2841),
    [anon_sym_public] = ACTIONS(2841),
    [anon_sym_private] = ACTIONS(2841),
    [anon_sym_protected] = ACTIONS(2841),
    [anon_sym_module] = ACTIONS(2841),
    [anon_sym_any] = ACTIONS(2841),
    [anon_sym_number] = ACTIONS(2841),
    [anon_sym_boolean] = ACTIONS(2841),
    [anon_sym_string] = ACTIONS(2841),
    [anon_sym_symbol] = ACTIONS(2841),
    [anon_sym_interface] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2841),
    [sym_readonly] = ACTIONS(2841),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(2843),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_export] = ACTIONS(2845),
    [anon_sym_default] = ACTIONS(2845),
    [anon_sym_namespace] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(2843),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_type] = ACTIONS(2845),
    [anon_sym_typeof] = ACTIONS(2845),
    [anon_sym_import] = ACTIONS(2845),
    [anon_sym_var] = ACTIONS(2845),
    [anon_sym_let] = ACTIONS(2845),
    [anon_sym_const] = ACTIONS(2845),
    [anon_sym_if] = ACTIONS(2845),
    [anon_sym_else] = ACTIONS(2845),
    [anon_sym_switch] = ACTIONS(2845),
    [anon_sym_for] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2843),
    [anon_sym_await] = ACTIONS(2845),
    [anon_sym_while] = ACTIONS(2845),
    [anon_sym_do] = ACTIONS(2845),
    [anon_sym_try] = ACTIONS(2845),
    [anon_sym_with] = ACTIONS(2845),
    [anon_sym_break] = ACTIONS(2845),
    [anon_sym_continue] = ACTIONS(2845),
    [anon_sym_debugger] = ACTIONS(2845),
    [anon_sym_return] = ACTIONS(2845),
    [anon_sym_throw] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(2843),
    [anon_sym_case] = ACTIONS(2845),
    [anon_sym_yield] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(2843),
    [anon_sym_SLASH] = ACTIONS(2845),
    [anon_sym_class] = ACTIONS(2845),
    [anon_sym_async] = ACTIONS(2845),
    [anon_sym_function] = ACTIONS(2845),
    [anon_sym_new] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_TILDE] = ACTIONS(2843),
    [anon_sym_void] = ACTIONS(2845),
    [anon_sym_delete] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2843),
    [anon_sym_DASH_DASH] = ACTIONS(2843),
    [anon_sym_DQUOTE] = ACTIONS(2843),
    [anon_sym_SQUOTE] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2843),
    [sym_number] = ACTIONS(2843),
    [sym_this] = ACTIONS(2845),
    [sym_super] = ACTIONS(2845),
    [sym_true] = ACTIONS(2845),
    [sym_false] = ACTIONS(2845),
    [sym_null] = ACTIONS(2845),
    [sym_undefined] = ACTIONS(2845),
    [anon_sym_AT] = ACTIONS(2843),
    [anon_sym_static] = ACTIONS(2845),
    [anon_sym_abstract] = ACTIONS(2845),
    [anon_sym_get] = ACTIONS(2845),
    [anon_sym_set] = ACTIONS(2845),
    [anon_sym_declare] = ACTIONS(2845),
    [anon_sym_public] = ACTIONS(2845),
    [anon_sym_private] = ACTIONS(2845),
    [anon_sym_protected] = ACTIONS(2845),
    [anon_sym_module] = ACTIONS(2845),
    [anon_sym_any] = ACTIONS(2845),
    [anon_sym_number] = ACTIONS(2845),
    [anon_sym_boolean] = ACTIONS(2845),
    [anon_sym_string] = ACTIONS(2845),
    [anon_sym_symbol] = ACTIONS(2845),
    [anon_sym_interface] = ACTIONS(2845),
    [anon_sym_enum] = ACTIONS(2845),
    [sym_readonly] = ACTIONS(2845),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_export] = ACTIONS(2849),
    [anon_sym_default] = ACTIONS(2849),
    [anon_sym_namespace] = ACTIONS(2849),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_type] = ACTIONS(2849),
    [anon_sym_typeof] = ACTIONS(2849),
    [anon_sym_import] = ACTIONS(2849),
    [anon_sym_var] = ACTIONS(2849),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2849),
    [anon_sym_if] = ACTIONS(2849),
    [anon_sym_else] = ACTIONS(2849),
    [anon_sym_switch] = ACTIONS(2849),
    [anon_sym_for] = ACTIONS(2849),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_await] = ACTIONS(2849),
    [anon_sym_while] = ACTIONS(2849),
    [anon_sym_do] = ACTIONS(2849),
    [anon_sym_try] = ACTIONS(2849),
    [anon_sym_with] = ACTIONS(2849),
    [anon_sym_break] = ACTIONS(2849),
    [anon_sym_continue] = ACTIONS(2849),
    [anon_sym_debugger] = ACTIONS(2849),
    [anon_sym_return] = ACTIONS(2849),
    [anon_sym_throw] = ACTIONS(2849),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_case] = ACTIONS(2849),
    [anon_sym_yield] = ACTIONS(2849),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2847),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_class] = ACTIONS(2849),
    [anon_sym_async] = ACTIONS(2849),
    [anon_sym_function] = ACTIONS(2849),
    [anon_sym_new] = ACTIONS(2849),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2847),
    [anon_sym_TILDE] = ACTIONS(2847),
    [anon_sym_void] = ACTIONS(2849),
    [anon_sym_delete] = ACTIONS(2849),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_SQUOTE] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2847),
    [sym_number] = ACTIONS(2847),
    [sym_this] = ACTIONS(2849),
    [sym_super] = ACTIONS(2849),
    [sym_true] = ACTIONS(2849),
    [sym_false] = ACTIONS(2849),
    [sym_null] = ACTIONS(2849),
    [sym_undefined] = ACTIONS(2849),
    [anon_sym_AT] = ACTIONS(2847),
    [anon_sym_static] = ACTIONS(2849),
    [anon_sym_abstract] = ACTIONS(2849),
    [anon_sym_get] = ACTIONS(2849),
    [anon_sym_set] = ACTIONS(2849),
    [anon_sym_declare] = ACTIONS(2849),
    [anon_sym_public] = ACTIONS(2849),
    [anon_sym_private] = ACTIONS(2849),
    [anon_sym_protected] = ACTIONS(2849),
    [anon_sym_module] = ACTIONS(2849),
    [anon_sym_any] = ACTIONS(2849),
    [anon_sym_number] = ACTIONS(2849),
    [anon_sym_boolean] = ACTIONS(2849),
    [anon_sym_string] = ACTIONS(2849),
    [anon_sym_symbol] = ACTIONS(2849),
    [anon_sym_interface] = ACTIONS(2849),
    [anon_sym_enum] = ACTIONS(2849),
    [sym_readonly] = ACTIONS(2849),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(2851),
    [sym_identifier] = ACTIONS(2853),
    [anon_sym_export] = ACTIONS(2853),
    [anon_sym_default] = ACTIONS(2853),
    [anon_sym_namespace] = ACTIONS(2853),
    [anon_sym_LBRACE] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_type] = ACTIONS(2853),
    [anon_sym_typeof] = ACTIONS(2853),
    [anon_sym_import] = ACTIONS(2853),
    [anon_sym_var] = ACTIONS(2853),
    [anon_sym_let] = ACTIONS(2853),
    [anon_sym_const] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2853),
    [anon_sym_else] = ACTIONS(2853),
    [anon_sym_switch] = ACTIONS(2853),
    [anon_sym_for] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_await] = ACTIONS(2853),
    [anon_sym_while] = ACTIONS(2853),
    [anon_sym_do] = ACTIONS(2853),
    [anon_sym_try] = ACTIONS(2853),
    [anon_sym_with] = ACTIONS(2853),
    [anon_sym_break] = ACTIONS(2853),
    [anon_sym_continue] = ACTIONS(2853),
    [anon_sym_debugger] = ACTIONS(2853),
    [anon_sym_return] = ACTIONS(2853),
    [anon_sym_throw] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_case] = ACTIONS(2853),
    [anon_sym_yield] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_SLASH] = ACTIONS(2853),
    [anon_sym_class] = ACTIONS(2853),
    [anon_sym_async] = ACTIONS(2853),
    [anon_sym_function] = ACTIONS(2853),
    [anon_sym_new] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2853),
    [anon_sym_BANG] = ACTIONS(2851),
    [anon_sym_TILDE] = ACTIONS(2851),
    [anon_sym_void] = ACTIONS(2853),
    [anon_sym_delete] = ACTIONS(2853),
    [anon_sym_PLUS_PLUS] = ACTIONS(2851),
    [anon_sym_DASH_DASH] = ACTIONS(2851),
    [anon_sym_DQUOTE] = ACTIONS(2851),
    [anon_sym_SQUOTE] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2851),
    [sym_number] = ACTIONS(2851),
    [sym_this] = ACTIONS(2853),
    [sym_super] = ACTIONS(2853),
    [sym_true] = ACTIONS(2853),
    [sym_false] = ACTIONS(2853),
    [sym_null] = ACTIONS(2853),
    [sym_undefined] = ACTIONS(2853),
    [anon_sym_AT] = ACTIONS(2851),
    [anon_sym_static] = ACTIONS(2853),
    [anon_sym_abstract] = ACTIONS(2853),
    [anon_sym_get] = ACTIONS(2853),
    [anon_sym_set] = ACTIONS(2853),
    [anon_sym_declare] = ACTIONS(2853),
    [anon_sym_public] = ACTIONS(2853),
    [anon_sym_private] = ACTIONS(2853),
    [anon_sym_protected] = ACTIONS(2853),
    [anon_sym_module] = ACTIONS(2853),
    [anon_sym_any] = ACTIONS(2853),
    [anon_sym_number] = ACTIONS(2853),
    [anon_sym_boolean] = ACTIONS(2853),
    [anon_sym_string] = ACTIONS(2853),
    [anon_sym_symbol] = ACTIONS(2853),
    [anon_sym_interface] = ACTIONS(2853),
    [anon_sym_enum] = ACTIONS(2853),
    [sym_readonly] = ACTIONS(2853),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(2855),
    [sym_identifier] = ACTIONS(2857),
    [anon_sym_export] = ACTIONS(2857),
    [anon_sym_default] = ACTIONS(2857),
    [anon_sym_namespace] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_type] = ACTIONS(2857),
    [anon_sym_typeof] = ACTIONS(2857),
    [anon_sym_import] = ACTIONS(2857),
    [anon_sym_var] = ACTIONS(2857),
    [anon_sym_let] = ACTIONS(2857),
    [anon_sym_const] = ACTIONS(2857),
    [anon_sym_if] = ACTIONS(2857),
    [anon_sym_else] = ACTIONS(2857),
    [anon_sym_switch] = ACTIONS(2857),
    [anon_sym_for] = ACTIONS(2857),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_await] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2857),
    [anon_sym_do] = ACTIONS(2857),
    [anon_sym_try] = ACTIONS(2857),
    [anon_sym_with] = ACTIONS(2857),
    [anon_sym_break] = ACTIONS(2857),
    [anon_sym_continue] = ACTIONS(2857),
    [anon_sym_debugger] = ACTIONS(2857),
    [anon_sym_return] = ACTIONS(2857),
    [anon_sym_throw] = ACTIONS(2857),
    [anon_sym_SEMI] = ACTIONS(2855),
    [anon_sym_case] = ACTIONS(2857),
    [anon_sym_yield] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2857),
    [anon_sym_class] = ACTIONS(2857),
    [anon_sym_async] = ACTIONS(2857),
    [anon_sym_function] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2857),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_DASH] = ACTIONS(2857),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_TILDE] = ACTIONS(2855),
    [anon_sym_void] = ACTIONS(2857),
    [anon_sym_delete] = ACTIONS(2857),
    [anon_sym_PLUS_PLUS] = ACTIONS(2855),
    [anon_sym_DASH_DASH] = ACTIONS(2855),
    [anon_sym_DQUOTE] = ACTIONS(2855),
    [anon_sym_SQUOTE] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [sym_number] = ACTIONS(2855),
    [sym_this] = ACTIONS(2857),
    [sym_super] = ACTIONS(2857),
    [sym_true] = ACTIONS(2857),
    [sym_false] = ACTIONS(2857),
    [sym_null] = ACTIONS(2857),
    [sym_undefined] = ACTIONS(2857),
    [anon_sym_AT] = ACTIONS(2855),
    [anon_sym_static] = ACTIONS(2857),
    [anon_sym_abstract] = ACTIONS(2857),
    [anon_sym_get] = ACTIONS(2857),
    [anon_sym_set] = ACTIONS(2857),
    [anon_sym_declare] = ACTIONS(2857),
    [anon_sym_public] = ACTIONS(2857),
    [anon_sym_private] = ACTIONS(2857),
    [anon_sym_protected] = ACTIONS(2857),
    [anon_sym_module] = ACTIONS(2857),
    [anon_sym_any] = ACTIONS(2857),
    [anon_sym_number] = ACTIONS(2857),
    [anon_sym_boolean] = ACTIONS(2857),
    [anon_sym_string] = ACTIONS(2857),
    [anon_sym_symbol] = ACTIONS(2857),
    [anon_sym_interface] = ACTIONS(2857),
    [anon_sym_enum] = ACTIONS(2857),
    [sym_readonly] = ACTIONS(2857),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(2859),
    [sym_identifier] = ACTIONS(2861),
    [anon_sym_export] = ACTIONS(2861),
    [anon_sym_default] = ACTIONS(2861),
    [anon_sym_namespace] = ACTIONS(2861),
    [anon_sym_LBRACE] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_type] = ACTIONS(2861),
    [anon_sym_typeof] = ACTIONS(2861),
    [anon_sym_import] = ACTIONS(2861),
    [anon_sym_var] = ACTIONS(2861),
    [anon_sym_let] = ACTIONS(2861),
    [anon_sym_const] = ACTIONS(2861),
    [anon_sym_if] = ACTIONS(2861),
    [anon_sym_else] = ACTIONS(2863),
    [anon_sym_switch] = ACTIONS(2861),
    [anon_sym_for] = ACTIONS(2861),
    [anon_sym_LPAREN] = ACTIONS(2859),
    [anon_sym_await] = ACTIONS(2861),
    [anon_sym_while] = ACTIONS(2861),
    [anon_sym_do] = ACTIONS(2861),
    [anon_sym_try] = ACTIONS(2861),
    [anon_sym_with] = ACTIONS(2861),
    [anon_sym_break] = ACTIONS(2861),
    [anon_sym_continue] = ACTIONS(2861),
    [anon_sym_debugger] = ACTIONS(2861),
    [anon_sym_return] = ACTIONS(2861),
    [anon_sym_throw] = ACTIONS(2861),
    [anon_sym_SEMI] = ACTIONS(2859),
    [anon_sym_case] = ACTIONS(2861),
    [anon_sym_yield] = ACTIONS(2861),
    [anon_sym_LBRACK] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2859),
    [anon_sym_SLASH] = ACTIONS(2861),
    [anon_sym_class] = ACTIONS(2861),
    [anon_sym_async] = ACTIONS(2861),
    [anon_sym_function] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2861),
    [anon_sym_PLUS] = ACTIONS(2861),
    [anon_sym_DASH] = ACTIONS(2861),
    [anon_sym_BANG] = ACTIONS(2859),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_void] = ACTIONS(2861),
    [anon_sym_delete] = ACTIONS(2861),
    [anon_sym_PLUS_PLUS] = ACTIONS(2859),
    [anon_sym_DASH_DASH] = ACTIONS(2859),
    [anon_sym_DQUOTE] = ACTIONS(2859),
    [anon_sym_SQUOTE] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_number] = ACTIONS(2859),
    [sym_this] = ACTIONS(2861),
    [sym_super] = ACTIONS(2861),
    [sym_true] = ACTIONS(2861),
    [sym_false] = ACTIONS(2861),
    [sym_null] = ACTIONS(2861),
    [sym_undefined] = ACTIONS(2861),
    [anon_sym_AT] = ACTIONS(2859),
    [anon_sym_static] = ACTIONS(2861),
    [anon_sym_abstract] = ACTIONS(2861),
    [anon_sym_get] = ACTIONS(2861),
    [anon_sym_set] = ACTIONS(2861),
    [anon_sym_declare] = ACTIONS(2861),
    [anon_sym_public] = ACTIONS(2861),
    [anon_sym_private] = ACTIONS(2861),
    [anon_sym_protected] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(2861),
    [anon_sym_any] = ACTIONS(2861),
    [anon_sym_number] = ACTIONS(2861),
    [anon_sym_boolean] = ACTIONS(2861),
    [anon_sym_string] = ACTIONS(2861),
    [anon_sym_symbol] = ACTIONS(2861),
    [anon_sym_interface] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2861),
    [sym_readonly] = ACTIONS(2861),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(2865),
    [sym_identifier] = ACTIONS(2867),
    [anon_sym_export] = ACTIONS(2867),
    [anon_sym_default] = ACTIONS(2867),
    [anon_sym_namespace] = ACTIONS(2867),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_type] = ACTIONS(2867),
    [anon_sym_typeof] = ACTIONS(2867),
    [anon_sym_import] = ACTIONS(2867),
    [anon_sym_var] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_const] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_else] = ACTIONS(2867),
    [anon_sym_switch] = ACTIONS(2867),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym_await] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_continue] = ACTIONS(2867),
    [anon_sym_debugger] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_throw] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym_case] = ACTIONS(2867),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2867),
    [anon_sym_async] = ACTIONS(2867),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_void] = ACTIONS(2867),
    [anon_sym_delete] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [sym_number] = ACTIONS(2865),
    [sym_this] = ACTIONS(2867),
    [sym_super] = ACTIONS(2867),
    [sym_true] = ACTIONS(2867),
    [sym_false] = ACTIONS(2867),
    [sym_null] = ACTIONS(2867),
    [sym_undefined] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2865),
    [anon_sym_static] = ACTIONS(2867),
    [anon_sym_abstract] = ACTIONS(2867),
    [anon_sym_get] = ACTIONS(2867),
    [anon_sym_set] = ACTIONS(2867),
    [anon_sym_declare] = ACTIONS(2867),
    [anon_sym_public] = ACTIONS(2867),
    [anon_sym_private] = ACTIONS(2867),
    [anon_sym_protected] = ACTIONS(2867),
    [anon_sym_module] = ACTIONS(2867),
    [anon_sym_any] = ACTIONS(2867),
    [anon_sym_number] = ACTIONS(2867),
    [anon_sym_boolean] = ACTIONS(2867),
    [anon_sym_string] = ACTIONS(2867),
    [anon_sym_symbol] = ACTIONS(2867),
    [anon_sym_interface] = ACTIONS(2867),
    [anon_sym_enum] = ACTIONS(2867),
    [sym_readonly] = ACTIONS(2867),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(2869),
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_default] = ACTIONS(2871),
    [anon_sym_namespace] = ACTIONS(2871),
    [anon_sym_LBRACE] = ACTIONS(2869),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_type] = ACTIONS(2871),
    [anon_sym_typeof] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_var] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_switch] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2869),
    [anon_sym_await] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [anon_sym_do] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_with] = ACTIONS(2871),
    [anon_sym_break] = ACTIONS(2871),
    [anon_sym_continue] = ACTIONS(2871),
    [anon_sym_debugger] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_throw] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2869),
    [anon_sym_case] = ACTIONS(2871),
    [anon_sym_yield] = ACTIONS(2871),
    [anon_sym_LBRACK] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2869),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_class] = ACTIONS(2871),
    [anon_sym_async] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_new] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_DASH] = ACTIONS(2871),
    [anon_sym_BANG] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2869),
    [anon_sym_void] = ACTIONS(2871),
    [anon_sym_delete] = ACTIONS(2871),
    [anon_sym_PLUS_PLUS] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2869),
    [anon_sym_SQUOTE] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2869),
    [sym_number] = ACTIONS(2869),
    [sym_this] = ACTIONS(2871),
    [sym_super] = ACTIONS(2871),
    [sym_true] = ACTIONS(2871),
    [sym_false] = ACTIONS(2871),
    [sym_null] = ACTIONS(2871),
    [sym_undefined] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_static] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_get] = ACTIONS(2871),
    [anon_sym_set] = ACTIONS(2871),
    [anon_sym_declare] = ACTIONS(2871),
    [anon_sym_public] = ACTIONS(2871),
    [anon_sym_private] = ACTIONS(2871),
    [anon_sym_protected] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_any] = ACTIONS(2871),
    [anon_sym_number] = ACTIONS(2871),
    [anon_sym_boolean] = ACTIONS(2871),
    [anon_sym_string] = ACTIONS(2871),
    [anon_sym_symbol] = ACTIONS(2871),
    [anon_sym_interface] = ACTIONS(2871),
    [anon_sym_enum] = ACTIONS(2871),
    [sym_readonly] = ACTIONS(2871),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(2873),
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_export] = ACTIONS(2875),
    [anon_sym_default] = ACTIONS(2875),
    [anon_sym_namespace] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_RBRACE] = ACTIONS(2873),
    [anon_sym_type] = ACTIONS(2875),
    [anon_sym_typeof] = ACTIONS(2875),
    [anon_sym_import] = ACTIONS(2875),
    [anon_sym_var] = ACTIONS(2875),
    [anon_sym_let] = ACTIONS(2875),
    [anon_sym_const] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(2875),
    [anon_sym_else] = ACTIONS(2875),
    [anon_sym_switch] = ACTIONS(2875),
    [anon_sym_for] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2873),
    [anon_sym_await] = ACTIONS(2875),
    [anon_sym_while] = ACTIONS(2875),
    [anon_sym_do] = ACTIONS(2875),
    [anon_sym_try] = ACTIONS(2875),
    [anon_sym_with] = ACTIONS(2875),
    [anon_sym_break] = ACTIONS(2875),
    [anon_sym_continue] = ACTIONS(2875),
    [anon_sym_debugger] = ACTIONS(2875),
    [anon_sym_return] = ACTIONS(2875),
    [anon_sym_throw] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_yield] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2873),
    [anon_sym_SLASH] = ACTIONS(2875),
    [anon_sym_class] = ACTIONS(2875),
    [anon_sym_async] = ACTIONS(2875),
    [anon_sym_function] = ACTIONS(2875),
    [anon_sym_new] = ACTIONS(2875),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2873),
    [anon_sym_TILDE] = ACTIONS(2873),
    [anon_sym_void] = ACTIONS(2875),
    [anon_sym_delete] = ACTIONS(2875),
    [anon_sym_PLUS_PLUS] = ACTIONS(2873),
    [anon_sym_DASH_DASH] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2873),
    [anon_sym_SQUOTE] = ACTIONS(2873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [sym_number] = ACTIONS(2873),
    [sym_this] = ACTIONS(2875),
    [sym_super] = ACTIONS(2875),
    [sym_true] = ACTIONS(2875),
    [sym_false] = ACTIONS(2875),
    [sym_null] = ACTIONS(2875),
    [sym_undefined] = ACTIONS(2875),
    [anon_sym_AT] = ACTIONS(2873),
    [anon_sym_static] = ACTIONS(2875),
    [anon_sym_abstract] = ACTIONS(2875),
    [anon_sym_get] = ACTIONS(2875),
    [anon_sym_set] = ACTIONS(2875),
    [anon_sym_declare] = ACTIONS(2875),
    [anon_sym_public] = ACTIONS(2875),
    [anon_sym_private] = ACTIONS(2875),
    [anon_sym_protected] = ACTIONS(2875),
    [anon_sym_module] = ACTIONS(2875),
    [anon_sym_any] = ACTIONS(2875),
    [anon_sym_number] = ACTIONS(2875),
    [anon_sym_boolean] = ACTIONS(2875),
    [anon_sym_string] = ACTIONS(2875),
    [anon_sym_symbol] = ACTIONS(2875),
    [anon_sym_interface] = ACTIONS(2875),
    [anon_sym_enum] = ACTIONS(2875),
    [sym_readonly] = ACTIONS(2875),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(2877),
    [sym_identifier] = ACTIONS(2879),
    [anon_sym_export] = ACTIONS(2879),
    [anon_sym_default] = ACTIONS(2879),
    [anon_sym_namespace] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(2877),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_type] = ACTIONS(2879),
    [anon_sym_typeof] = ACTIONS(2879),
    [anon_sym_import] = ACTIONS(2879),
    [anon_sym_var] = ACTIONS(2879),
    [anon_sym_let] = ACTIONS(2879),
    [anon_sym_const] = ACTIONS(2879),
    [anon_sym_if] = ACTIONS(2879),
    [anon_sym_else] = ACTIONS(2879),
    [anon_sym_switch] = ACTIONS(2879),
    [anon_sym_for] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2877),
    [anon_sym_await] = ACTIONS(2879),
    [anon_sym_while] = ACTIONS(2879),
    [anon_sym_do] = ACTIONS(2879),
    [anon_sym_try] = ACTIONS(2879),
    [anon_sym_with] = ACTIONS(2879),
    [anon_sym_break] = ACTIONS(2879),
    [anon_sym_continue] = ACTIONS(2879),
    [anon_sym_debugger] = ACTIONS(2879),
    [anon_sym_return] = ACTIONS(2879),
    [anon_sym_throw] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2877),
    [anon_sym_case] = ACTIONS(2879),
    [anon_sym_yield] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2877),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2879),
    [anon_sym_class] = ACTIONS(2879),
    [anon_sym_async] = ACTIONS(2879),
    [anon_sym_function] = ACTIONS(2879),
    [anon_sym_new] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2879),
    [anon_sym_BANG] = ACTIONS(2877),
    [anon_sym_TILDE] = ACTIONS(2877),
    [anon_sym_void] = ACTIONS(2879),
    [anon_sym_delete] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2877),
    [anon_sym_DASH_DASH] = ACTIONS(2877),
    [anon_sym_DQUOTE] = ACTIONS(2877),
    [anon_sym_SQUOTE] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2877),
    [sym_number] = ACTIONS(2877),
    [sym_this] = ACTIONS(2879),
    [sym_super] = ACTIONS(2879),
    [sym_true] = ACTIONS(2879),
    [sym_false] = ACTIONS(2879),
    [sym_null] = ACTIONS(2879),
    [sym_undefined] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2877),
    [anon_sym_static] = ACTIONS(2879),
    [anon_sym_abstract] = ACTIONS(2879),
    [anon_sym_get] = ACTIONS(2879),
    [anon_sym_set] = ACTIONS(2879),
    [anon_sym_declare] = ACTIONS(2879),
    [anon_sym_public] = ACTIONS(2879),
    [anon_sym_private] = ACTIONS(2879),
    [anon_sym_protected] = ACTIONS(2879),
    [anon_sym_module] = ACTIONS(2879),
    [anon_sym_any] = ACTIONS(2879),
    [anon_sym_number] = ACTIONS(2879),
    [anon_sym_boolean] = ACTIONS(2879),
    [anon_sym_string] = ACTIONS(2879),
    [anon_sym_symbol] = ACTIONS(2879),
    [anon_sym_interface] = ACTIONS(2879),
    [anon_sym_enum] = ACTIONS(2879),
    [sym_readonly] = ACTIONS(2879),
  },
  [574] = {
    [sym__call_signature] = STATE(2891),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_export] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2642),
    [anon_sym_async] = ACTIONS(2640),
    [anon_sym_function] = ACTIONS(2644),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2640),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_get] = ACTIONS(2640),
    [anon_sym_set] = ACTIONS(2640),
    [anon_sym_declare] = ACTIONS(2640),
    [anon_sym_public] = ACTIONS(2640),
    [anon_sym_private] = ACTIONS(2640),
    [anon_sym_protected] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_any] = ACTIONS(2640),
    [anon_sym_number] = ACTIONS(2640),
    [anon_sym_boolean] = ACTIONS(2640),
    [anon_sym_string] = ACTIONS(2640),
    [anon_sym_symbol] = ACTIONS(2640),
    [sym_readonly] = ACTIONS(2640),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(2881),
    [sym_identifier] = ACTIONS(2883),
    [anon_sym_export] = ACTIONS(2883),
    [anon_sym_default] = ACTIONS(2883),
    [anon_sym_namespace] = ACTIONS(2883),
    [anon_sym_LBRACE] = ACTIONS(2881),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_type] = ACTIONS(2883),
    [anon_sym_typeof] = ACTIONS(2883),
    [anon_sym_import] = ACTIONS(2883),
    [anon_sym_var] = ACTIONS(2883),
    [anon_sym_let] = ACTIONS(2883),
    [anon_sym_const] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2883),
    [anon_sym_else] = ACTIONS(2883),
    [anon_sym_switch] = ACTIONS(2883),
    [anon_sym_for] = ACTIONS(2883),
    [anon_sym_LPAREN] = ACTIONS(2881),
    [anon_sym_await] = ACTIONS(2883),
    [anon_sym_while] = ACTIONS(2883),
    [anon_sym_do] = ACTIONS(2883),
    [anon_sym_try] = ACTIONS(2883),
    [anon_sym_with] = ACTIONS(2883),
    [anon_sym_break] = ACTIONS(2883),
    [anon_sym_continue] = ACTIONS(2883),
    [anon_sym_debugger] = ACTIONS(2883),
    [anon_sym_return] = ACTIONS(2883),
    [anon_sym_throw] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym_case] = ACTIONS(2883),
    [anon_sym_yield] = ACTIONS(2883),
    [anon_sym_LBRACK] = ACTIONS(2881),
    [anon_sym_LT] = ACTIONS(2881),
    [anon_sym_SLASH] = ACTIONS(2883),
    [anon_sym_class] = ACTIONS(2883),
    [anon_sym_async] = ACTIONS(2883),
    [anon_sym_function] = ACTIONS(2883),
    [anon_sym_new] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2881),
    [anon_sym_TILDE] = ACTIONS(2881),
    [anon_sym_void] = ACTIONS(2883),
    [anon_sym_delete] = ACTIONS(2883),
    [anon_sym_PLUS_PLUS] = ACTIONS(2881),
    [anon_sym_DASH_DASH] = ACTIONS(2881),
    [anon_sym_DQUOTE] = ACTIONS(2881),
    [anon_sym_SQUOTE] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2881),
    [sym_number] = ACTIONS(2881),
    [sym_this] = ACTIONS(2883),
    [sym_super] = ACTIONS(2883),
    [sym_true] = ACTIONS(2883),
    [sym_false] = ACTIONS(2883),
    [sym_null] = ACTIONS(2883),
    [sym_undefined] = ACTIONS(2883),
    [anon_sym_AT] = ACTIONS(2881),
    [anon_sym_static] = ACTIONS(2883),
    [anon_sym_abstract] = ACTIONS(2883),
    [anon_sym_get] = ACTIONS(2883),
    [anon_sym_set] = ACTIONS(2883),
    [anon_sym_declare] = ACTIONS(2883),
    [anon_sym_public] = ACTIONS(2883),
    [anon_sym_private] = ACTIONS(2883),
    [anon_sym_protected] = ACTIONS(2883),
    [anon_sym_module] = ACTIONS(2883),
    [anon_sym_any] = ACTIONS(2883),
    [anon_sym_number] = ACTIONS(2883),
    [anon_sym_boolean] = ACTIONS(2883),
    [anon_sym_string] = ACTIONS(2883),
    [anon_sym_symbol] = ACTIONS(2883),
    [anon_sym_interface] = ACTIONS(2883),
    [anon_sym_enum] = ACTIONS(2883),
    [sym_readonly] = ACTIONS(2883),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(2885),
    [sym_identifier] = ACTIONS(2887),
    [anon_sym_export] = ACTIONS(2887),
    [anon_sym_default] = ACTIONS(2887),
    [anon_sym_namespace] = ACTIONS(2887),
    [anon_sym_LBRACE] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_type] = ACTIONS(2887),
    [anon_sym_typeof] = ACTIONS(2887),
    [anon_sym_import] = ACTIONS(2887),
    [anon_sym_var] = ACTIONS(2887),
    [anon_sym_let] = ACTIONS(2887),
    [anon_sym_const] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2887),
    [anon_sym_else] = ACTIONS(2887),
    [anon_sym_switch] = ACTIONS(2887),
    [anon_sym_for] = ACTIONS(2887),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_await] = ACTIONS(2887),
    [anon_sym_while] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2887),
    [anon_sym_try] = ACTIONS(2887),
    [anon_sym_with] = ACTIONS(2887),
    [anon_sym_break] = ACTIONS(2887),
    [anon_sym_continue] = ACTIONS(2887),
    [anon_sym_debugger] = ACTIONS(2887),
    [anon_sym_return] = ACTIONS(2887),
    [anon_sym_throw] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_case] = ACTIONS(2887),
    [anon_sym_yield] = ACTIONS(2887),
    [anon_sym_LBRACK] = ACTIONS(2885),
    [anon_sym_LT] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2887),
    [anon_sym_class] = ACTIONS(2887),
    [anon_sym_async] = ACTIONS(2887),
    [anon_sym_function] = ACTIONS(2887),
    [anon_sym_new] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2887),
    [anon_sym_DASH] = ACTIONS(2887),
    [anon_sym_BANG] = ACTIONS(2885),
    [anon_sym_TILDE] = ACTIONS(2885),
    [anon_sym_void] = ACTIONS(2887),
    [anon_sym_delete] = ACTIONS(2887),
    [anon_sym_PLUS_PLUS] = ACTIONS(2885),
    [anon_sym_DASH_DASH] = ACTIONS(2885),
    [anon_sym_DQUOTE] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2885),
    [sym_number] = ACTIONS(2885),
    [sym_this] = ACTIONS(2887),
    [sym_super] = ACTIONS(2887),
    [sym_true] = ACTIONS(2887),
    [sym_false] = ACTIONS(2887),
    [sym_null] = ACTIONS(2887),
    [sym_undefined] = ACTIONS(2887),
    [anon_sym_AT] = ACTIONS(2885),
    [anon_sym_static] = ACTIONS(2887),
    [anon_sym_abstract] = ACTIONS(2887),
    [anon_sym_get] = ACTIONS(2887),
    [anon_sym_set] = ACTIONS(2887),
    [anon_sym_declare] = ACTIONS(2887),
    [anon_sym_public] = ACTIONS(2887),
    [anon_sym_private] = ACTIONS(2887),
    [anon_sym_protected] = ACTIONS(2887),
    [anon_sym_module] = ACTIONS(2887),
    [anon_sym_any] = ACTIONS(2887),
    [anon_sym_number] = ACTIONS(2887),
    [anon_sym_boolean] = ACTIONS(2887),
    [anon_sym_string] = ACTIONS(2887),
    [anon_sym_symbol] = ACTIONS(2887),
    [anon_sym_interface] = ACTIONS(2887),
    [anon_sym_enum] = ACTIONS(2887),
    [sym_readonly] = ACTIONS(2887),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(2889),
    [sym_identifier] = ACTIONS(2891),
    [anon_sym_export] = ACTIONS(2891),
    [anon_sym_default] = ACTIONS(2891),
    [anon_sym_namespace] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_type] = ACTIONS(2891),
    [anon_sym_typeof] = ACTIONS(2891),
    [anon_sym_import] = ACTIONS(2891),
    [anon_sym_var] = ACTIONS(2891),
    [anon_sym_let] = ACTIONS(2891),
    [anon_sym_const] = ACTIONS(2891),
    [anon_sym_if] = ACTIONS(2891),
    [anon_sym_else] = ACTIONS(2891),
    [anon_sym_switch] = ACTIONS(2891),
    [anon_sym_for] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_await] = ACTIONS(2891),
    [anon_sym_while] = ACTIONS(2891),
    [anon_sym_do] = ACTIONS(2891),
    [anon_sym_try] = ACTIONS(2891),
    [anon_sym_with] = ACTIONS(2891),
    [anon_sym_break] = ACTIONS(2891),
    [anon_sym_continue] = ACTIONS(2891),
    [anon_sym_debugger] = ACTIONS(2891),
    [anon_sym_return] = ACTIONS(2891),
    [anon_sym_throw] = ACTIONS(2891),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_case] = ACTIONS(2891),
    [anon_sym_yield] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2889),
    [anon_sym_LT] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2891),
    [anon_sym_class] = ACTIONS(2891),
    [anon_sym_async] = ACTIONS(2891),
    [anon_sym_function] = ACTIONS(2891),
    [anon_sym_new] = ACTIONS(2891),
    [anon_sym_PLUS] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [anon_sym_BANG] = ACTIONS(2889),
    [anon_sym_TILDE] = ACTIONS(2889),
    [anon_sym_void] = ACTIONS(2891),
    [anon_sym_delete] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2889),
    [anon_sym_DASH_DASH] = ACTIONS(2889),
    [anon_sym_DQUOTE] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2889),
    [sym_number] = ACTIONS(2889),
    [sym_this] = ACTIONS(2891),
    [sym_super] = ACTIONS(2891),
    [sym_true] = ACTIONS(2891),
    [sym_false] = ACTIONS(2891),
    [sym_null] = ACTIONS(2891),
    [sym_undefined] = ACTIONS(2891),
    [anon_sym_AT] = ACTIONS(2889),
    [anon_sym_static] = ACTIONS(2891),
    [anon_sym_abstract] = ACTIONS(2891),
    [anon_sym_get] = ACTIONS(2891),
    [anon_sym_set] = ACTIONS(2891),
    [anon_sym_declare] = ACTIONS(2891),
    [anon_sym_public] = ACTIONS(2891),
    [anon_sym_private] = ACTIONS(2891),
    [anon_sym_protected] = ACTIONS(2891),
    [anon_sym_module] = ACTIONS(2891),
    [anon_sym_any] = ACTIONS(2891),
    [anon_sym_number] = ACTIONS(2891),
    [anon_sym_boolean] = ACTIONS(2891),
    [anon_sym_string] = ACTIONS(2891),
    [anon_sym_symbol] = ACTIONS(2891),
    [anon_sym_interface] = ACTIONS(2891),
    [anon_sym_enum] = ACTIONS(2891),
    [sym_readonly] = ACTIONS(2891),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(2893),
    [sym_identifier] = ACTIONS(2895),
    [anon_sym_export] = ACTIONS(2895),
    [anon_sym_default] = ACTIONS(2895),
    [anon_sym_namespace] = ACTIONS(2895),
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_type] = ACTIONS(2895),
    [anon_sym_typeof] = ACTIONS(2895),
    [anon_sym_import] = ACTIONS(2895),
    [anon_sym_var] = ACTIONS(2895),
    [anon_sym_let] = ACTIONS(2895),
    [anon_sym_const] = ACTIONS(2895),
    [anon_sym_if] = ACTIONS(2895),
    [anon_sym_else] = ACTIONS(2895),
    [anon_sym_switch] = ACTIONS(2895),
    [anon_sym_for] = ACTIONS(2895),
    [anon_sym_LPAREN] = ACTIONS(2893),
    [anon_sym_await] = ACTIONS(2895),
    [anon_sym_while] = ACTIONS(2895),
    [anon_sym_do] = ACTIONS(2895),
    [anon_sym_try] = ACTIONS(2895),
    [anon_sym_with] = ACTIONS(2895),
    [anon_sym_break] = ACTIONS(2895),
    [anon_sym_continue] = ACTIONS(2895),
    [anon_sym_debugger] = ACTIONS(2895),
    [anon_sym_return] = ACTIONS(2895),
    [anon_sym_throw] = ACTIONS(2895),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_case] = ACTIONS(2895),
    [anon_sym_yield] = ACTIONS(2895),
    [anon_sym_LBRACK] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2895),
    [anon_sym_class] = ACTIONS(2895),
    [anon_sym_async] = ACTIONS(2895),
    [anon_sym_function] = ACTIONS(2895),
    [anon_sym_new] = ACTIONS(2895),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_DASH] = ACTIONS(2895),
    [anon_sym_BANG] = ACTIONS(2893),
    [anon_sym_TILDE] = ACTIONS(2893),
    [anon_sym_void] = ACTIONS(2895),
    [anon_sym_delete] = ACTIONS(2895),
    [anon_sym_PLUS_PLUS] = ACTIONS(2893),
    [anon_sym_DASH_DASH] = ACTIONS(2893),
    [anon_sym_DQUOTE] = ACTIONS(2893),
    [anon_sym_SQUOTE] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2893),
    [sym_number] = ACTIONS(2893),
    [sym_this] = ACTIONS(2895),
    [sym_super] = ACTIONS(2895),
    [sym_true] = ACTIONS(2895),
    [sym_false] = ACTIONS(2895),
    [sym_null] = ACTIONS(2895),
    [sym_undefined] = ACTIONS(2895),
    [anon_sym_AT] = ACTIONS(2893),
    [anon_sym_static] = ACTIONS(2895),
    [anon_sym_abstract] = ACTIONS(2895),
    [anon_sym_get] = ACTIONS(2895),
    [anon_sym_set] = ACTIONS(2895),
    [anon_sym_declare] = ACTIONS(2895),
    [anon_sym_public] = ACTIONS(2895),
    [anon_sym_private] = ACTIONS(2895),
    [anon_sym_protected] = ACTIONS(2895),
    [anon_sym_module] = ACTIONS(2895),
    [anon_sym_any] = ACTIONS(2895),
    [anon_sym_number] = ACTIONS(2895),
    [anon_sym_boolean] = ACTIONS(2895),
    [anon_sym_string] = ACTIONS(2895),
    [anon_sym_symbol] = ACTIONS(2895),
    [anon_sym_interface] = ACTIONS(2895),
    [anon_sym_enum] = ACTIONS(2895),
    [sym_readonly] = ACTIONS(2895),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(2897),
    [sym_identifier] = ACTIONS(2899),
    [anon_sym_export] = ACTIONS(2899),
    [anon_sym_default] = ACTIONS(2899),
    [anon_sym_namespace] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_type] = ACTIONS(2899),
    [anon_sym_typeof] = ACTIONS(2899),
    [anon_sym_import] = ACTIONS(2899),
    [anon_sym_var] = ACTIONS(2899),
    [anon_sym_let] = ACTIONS(2899),
    [anon_sym_const] = ACTIONS(2899),
    [anon_sym_if] = ACTIONS(2899),
    [anon_sym_else] = ACTIONS(2899),
    [anon_sym_switch] = ACTIONS(2899),
    [anon_sym_for] = ACTIONS(2899),
    [anon_sym_LPAREN] = ACTIONS(2897),
    [anon_sym_await] = ACTIONS(2899),
    [anon_sym_while] = ACTIONS(2899),
    [anon_sym_do] = ACTIONS(2899),
    [anon_sym_try] = ACTIONS(2899),
    [anon_sym_with] = ACTIONS(2899),
    [anon_sym_break] = ACTIONS(2899),
    [anon_sym_continue] = ACTIONS(2899),
    [anon_sym_debugger] = ACTIONS(2899),
    [anon_sym_return] = ACTIONS(2899),
    [anon_sym_throw] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2897),
    [anon_sym_case] = ACTIONS(2899),
    [anon_sym_yield] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2899),
    [anon_sym_class] = ACTIONS(2899),
    [anon_sym_async] = ACTIONS(2899),
    [anon_sym_function] = ACTIONS(2899),
    [anon_sym_new] = ACTIONS(2899),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2897),
    [anon_sym_TILDE] = ACTIONS(2897),
    [anon_sym_void] = ACTIONS(2899),
    [anon_sym_delete] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2897),
    [anon_sym_DASH_DASH] = ACTIONS(2897),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [anon_sym_SQUOTE] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2897),
    [sym_number] = ACTIONS(2897),
    [sym_this] = ACTIONS(2899),
    [sym_super] = ACTIONS(2899),
    [sym_true] = ACTIONS(2899),
    [sym_false] = ACTIONS(2899),
    [sym_null] = ACTIONS(2899),
    [sym_undefined] = ACTIONS(2899),
    [anon_sym_AT] = ACTIONS(2897),
    [anon_sym_static] = ACTIONS(2899),
    [anon_sym_abstract] = ACTIONS(2899),
    [anon_sym_get] = ACTIONS(2899),
    [anon_sym_set] = ACTIONS(2899),
    [anon_sym_declare] = ACTIONS(2899),
    [anon_sym_public] = ACTIONS(2899),
    [anon_sym_private] = ACTIONS(2899),
    [anon_sym_protected] = ACTIONS(2899),
    [anon_sym_module] = ACTIONS(2899),
    [anon_sym_any] = ACTIONS(2899),
    [anon_sym_number] = ACTIONS(2899),
    [anon_sym_boolean] = ACTIONS(2899),
    [anon_sym_string] = ACTIONS(2899),
    [anon_sym_symbol] = ACTIONS(2899),
    [anon_sym_interface] = ACTIONS(2899),
    [anon_sym_enum] = ACTIONS(2899),
    [sym_readonly] = ACTIONS(2899),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(2901),
    [sym_identifier] = ACTIONS(2903),
    [anon_sym_export] = ACTIONS(2903),
    [anon_sym_default] = ACTIONS(2903),
    [anon_sym_namespace] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_type] = ACTIONS(2903),
    [anon_sym_typeof] = ACTIONS(2903),
    [anon_sym_import] = ACTIONS(2903),
    [anon_sym_var] = ACTIONS(2903),
    [anon_sym_let] = ACTIONS(2903),
    [anon_sym_const] = ACTIONS(2903),
    [anon_sym_if] = ACTIONS(2903),
    [anon_sym_else] = ACTIONS(2903),
    [anon_sym_switch] = ACTIONS(2903),
    [anon_sym_for] = ACTIONS(2903),
    [anon_sym_LPAREN] = ACTIONS(2901),
    [anon_sym_await] = ACTIONS(2903),
    [anon_sym_while] = ACTIONS(2903),
    [anon_sym_do] = ACTIONS(2903),
    [anon_sym_try] = ACTIONS(2903),
    [anon_sym_with] = ACTIONS(2903),
    [anon_sym_break] = ACTIONS(2903),
    [anon_sym_continue] = ACTIONS(2903),
    [anon_sym_debugger] = ACTIONS(2903),
    [anon_sym_return] = ACTIONS(2903),
    [anon_sym_throw] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_case] = ACTIONS(2903),
    [anon_sym_yield] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2901),
    [anon_sym_SLASH] = ACTIONS(2903),
    [anon_sym_class] = ACTIONS(2903),
    [anon_sym_async] = ACTIONS(2903),
    [anon_sym_function] = ACTIONS(2903),
    [anon_sym_new] = ACTIONS(2903),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2901),
    [anon_sym_TILDE] = ACTIONS(2901),
    [anon_sym_void] = ACTIONS(2903),
    [anon_sym_delete] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_DQUOTE] = ACTIONS(2901),
    [anon_sym_SQUOTE] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2901),
    [sym_number] = ACTIONS(2901),
    [sym_this] = ACTIONS(2903),
    [sym_super] = ACTIONS(2903),
    [sym_true] = ACTIONS(2903),
    [sym_false] = ACTIONS(2903),
    [sym_null] = ACTIONS(2903),
    [sym_undefined] = ACTIONS(2903),
    [anon_sym_AT] = ACTIONS(2901),
    [anon_sym_static] = ACTIONS(2903),
    [anon_sym_abstract] = ACTIONS(2903),
    [anon_sym_get] = ACTIONS(2903),
    [anon_sym_set] = ACTIONS(2903),
    [anon_sym_declare] = ACTIONS(2903),
    [anon_sym_public] = ACTIONS(2903),
    [anon_sym_private] = ACTIONS(2903),
    [anon_sym_protected] = ACTIONS(2903),
    [anon_sym_module] = ACTIONS(2903),
    [anon_sym_any] = ACTIONS(2903),
    [anon_sym_number] = ACTIONS(2903),
    [anon_sym_boolean] = ACTIONS(2903),
    [anon_sym_string] = ACTIONS(2903),
    [anon_sym_symbol] = ACTIONS(2903),
    [anon_sym_interface] = ACTIONS(2903),
    [anon_sym_enum] = ACTIONS(2903),
    [sym_readonly] = ACTIONS(2903),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(2905),
    [sym_identifier] = ACTIONS(2907),
    [anon_sym_export] = ACTIONS(2907),
    [anon_sym_default] = ACTIONS(2907),
    [anon_sym_namespace] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_type] = ACTIONS(2907),
    [anon_sym_typeof] = ACTIONS(2907),
    [anon_sym_import] = ACTIONS(2907),
    [anon_sym_var] = ACTIONS(2907),
    [anon_sym_let] = ACTIONS(2907),
    [anon_sym_const] = ACTIONS(2907),
    [anon_sym_if] = ACTIONS(2907),
    [anon_sym_else] = ACTIONS(2907),
    [anon_sym_switch] = ACTIONS(2907),
    [anon_sym_for] = ACTIONS(2907),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_await] = ACTIONS(2907),
    [anon_sym_while] = ACTIONS(2907),
    [anon_sym_do] = ACTIONS(2907),
    [anon_sym_try] = ACTIONS(2907),
    [anon_sym_with] = ACTIONS(2907),
    [anon_sym_break] = ACTIONS(2907),
    [anon_sym_continue] = ACTIONS(2907),
    [anon_sym_debugger] = ACTIONS(2907),
    [anon_sym_return] = ACTIONS(2907),
    [anon_sym_throw] = ACTIONS(2907),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_case] = ACTIONS(2907),
    [anon_sym_yield] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_LT] = ACTIONS(2905),
    [anon_sym_SLASH] = ACTIONS(2907),
    [anon_sym_class] = ACTIONS(2907),
    [anon_sym_async] = ACTIONS(2907),
    [anon_sym_function] = ACTIONS(2907),
    [anon_sym_new] = ACTIONS(2907),
    [anon_sym_PLUS] = ACTIONS(2907),
    [anon_sym_DASH] = ACTIONS(2907),
    [anon_sym_BANG] = ACTIONS(2905),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_void] = ACTIONS(2907),
    [anon_sym_delete] = ACTIONS(2907),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_DQUOTE] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2905),
    [sym_number] = ACTIONS(2905),
    [sym_this] = ACTIONS(2907),
    [sym_super] = ACTIONS(2907),
    [sym_true] = ACTIONS(2907),
    [sym_false] = ACTIONS(2907),
    [sym_null] = ACTIONS(2907),
    [sym_undefined] = ACTIONS(2907),
    [anon_sym_AT] = ACTIONS(2905),
    [anon_sym_static] = ACTIONS(2907),
    [anon_sym_abstract] = ACTIONS(2907),
    [anon_sym_get] = ACTIONS(2907),
    [anon_sym_set] = ACTIONS(2907),
    [anon_sym_declare] = ACTIONS(2907),
    [anon_sym_public] = ACTIONS(2907),
    [anon_sym_private] = ACTIONS(2907),
    [anon_sym_protected] = ACTIONS(2907),
    [anon_sym_module] = ACTIONS(2907),
    [anon_sym_any] = ACTIONS(2907),
    [anon_sym_number] = ACTIONS(2907),
    [anon_sym_boolean] = ACTIONS(2907),
    [anon_sym_string] = ACTIONS(2907),
    [anon_sym_symbol] = ACTIONS(2907),
    [anon_sym_interface] = ACTIONS(2907),
    [anon_sym_enum] = ACTIONS(2907),
    [sym_readonly] = ACTIONS(2907),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(2909),
    [sym_identifier] = ACTIONS(2911),
    [anon_sym_export] = ACTIONS(2911),
    [anon_sym_default] = ACTIONS(2911),
    [anon_sym_namespace] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2909),
    [anon_sym_RBRACE] = ACTIONS(2909),
    [anon_sym_type] = ACTIONS(2911),
    [anon_sym_typeof] = ACTIONS(2911),
    [anon_sym_import] = ACTIONS(2911),
    [anon_sym_var] = ACTIONS(2911),
    [anon_sym_let] = ACTIONS(2911),
    [anon_sym_const] = ACTIONS(2911),
    [anon_sym_if] = ACTIONS(2911),
    [anon_sym_else] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_for] = ACTIONS(2911),
    [anon_sym_LPAREN] = ACTIONS(2909),
    [anon_sym_await] = ACTIONS(2911),
    [anon_sym_while] = ACTIONS(2911),
    [anon_sym_do] = ACTIONS(2911),
    [anon_sym_try] = ACTIONS(2911),
    [anon_sym_with] = ACTIONS(2911),
    [anon_sym_break] = ACTIONS(2911),
    [anon_sym_continue] = ACTIONS(2911),
    [anon_sym_debugger] = ACTIONS(2911),
    [anon_sym_return] = ACTIONS(2911),
    [anon_sym_throw] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2909),
    [anon_sym_case] = ACTIONS(2911),
    [anon_sym_yield] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2909),
    [anon_sym_LT] = ACTIONS(2909),
    [anon_sym_SLASH] = ACTIONS(2911),
    [anon_sym_class] = ACTIONS(2911),
    [anon_sym_async] = ACTIONS(2911),
    [anon_sym_function] = ACTIONS(2911),
    [anon_sym_new] = ACTIONS(2911),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_BANG] = ACTIONS(2909),
    [anon_sym_TILDE] = ACTIONS(2909),
    [anon_sym_void] = ACTIONS(2911),
    [anon_sym_delete] = ACTIONS(2911),
    [anon_sym_PLUS_PLUS] = ACTIONS(2909),
    [anon_sym_DASH_DASH] = ACTIONS(2909),
    [anon_sym_DQUOTE] = ACTIONS(2909),
    [anon_sym_SQUOTE] = ACTIONS(2909),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2909),
    [sym_number] = ACTIONS(2909),
    [sym_this] = ACTIONS(2911),
    [sym_super] = ACTIONS(2911),
    [sym_true] = ACTIONS(2911),
    [sym_false] = ACTIONS(2911),
    [sym_null] = ACTIONS(2911),
    [sym_undefined] = ACTIONS(2911),
    [anon_sym_AT] = ACTIONS(2909),
    [anon_sym_static] = ACTIONS(2911),
    [anon_sym_abstract] = ACTIONS(2911),
    [anon_sym_get] = ACTIONS(2911),
    [anon_sym_set] = ACTIONS(2911),
    [anon_sym_declare] = ACTIONS(2911),
    [anon_sym_public] = ACTIONS(2911),
    [anon_sym_private] = ACTIONS(2911),
    [anon_sym_protected] = ACTIONS(2911),
    [anon_sym_module] = ACTIONS(2911),
    [anon_sym_any] = ACTIONS(2911),
    [anon_sym_number] = ACTIONS(2911),
    [anon_sym_boolean] = ACTIONS(2911),
    [anon_sym_string] = ACTIONS(2911),
    [anon_sym_symbol] = ACTIONS(2911),
    [anon_sym_interface] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2911),
    [sym_readonly] = ACTIONS(2911),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(2913),
    [sym_identifier] = ACTIONS(2915),
    [anon_sym_export] = ACTIONS(2915),
    [anon_sym_default] = ACTIONS(2915),
    [anon_sym_namespace] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_type] = ACTIONS(2915),
    [anon_sym_typeof] = ACTIONS(2915),
    [anon_sym_import] = ACTIONS(2915),
    [anon_sym_var] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_const] = ACTIONS(2915),
    [anon_sym_if] = ACTIONS(2915),
    [anon_sym_else] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_for] = ACTIONS(2915),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_await] = ACTIONS(2915),
    [anon_sym_while] = ACTIONS(2915),
    [anon_sym_do] = ACTIONS(2915),
    [anon_sym_try] = ACTIONS(2915),
    [anon_sym_with] = ACTIONS(2915),
    [anon_sym_break] = ACTIONS(2915),
    [anon_sym_continue] = ACTIONS(2915),
    [anon_sym_debugger] = ACTIONS(2915),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_throw] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_case] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_LT] = ACTIONS(2913),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_class] = ACTIONS(2915),
    [anon_sym_async] = ACTIONS(2915),
    [anon_sym_function] = ACTIONS(2915),
    [anon_sym_new] = ACTIONS(2915),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_BANG] = ACTIONS(2913),
    [anon_sym_TILDE] = ACTIONS(2913),
    [anon_sym_void] = ACTIONS(2915),
    [anon_sym_delete] = ACTIONS(2915),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_SQUOTE] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2913),
    [sym_number] = ACTIONS(2913),
    [sym_this] = ACTIONS(2915),
    [sym_super] = ACTIONS(2915),
    [sym_true] = ACTIONS(2915),
    [sym_false] = ACTIONS(2915),
    [sym_null] = ACTIONS(2915),
    [sym_undefined] = ACTIONS(2915),
    [anon_sym_AT] = ACTIONS(2913),
    [anon_sym_static] = ACTIONS(2915),
    [anon_sym_abstract] = ACTIONS(2915),
    [anon_sym_get] = ACTIONS(2915),
    [anon_sym_set] = ACTIONS(2915),
    [anon_sym_declare] = ACTIONS(2915),
    [anon_sym_public] = ACTIONS(2915),
    [anon_sym_private] = ACTIONS(2915),
    [anon_sym_protected] = ACTIONS(2915),
    [anon_sym_module] = ACTIONS(2915),
    [anon_sym_any] = ACTIONS(2915),
    [anon_sym_number] = ACTIONS(2915),
    [anon_sym_boolean] = ACTIONS(2915),
    [anon_sym_string] = ACTIONS(2915),
    [anon_sym_symbol] = ACTIONS(2915),
    [anon_sym_interface] = ACTIONS(2915),
    [anon_sym_enum] = ACTIONS(2915),
    [sym_readonly] = ACTIONS(2915),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(2917),
    [sym_identifier] = ACTIONS(2919),
    [anon_sym_export] = ACTIONS(2919),
    [anon_sym_default] = ACTIONS(2919),
    [anon_sym_namespace] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_type] = ACTIONS(2919),
    [anon_sym_typeof] = ACTIONS(2919),
    [anon_sym_import] = ACTIONS(2919),
    [anon_sym_var] = ACTIONS(2919),
    [anon_sym_let] = ACTIONS(2919),
    [anon_sym_const] = ACTIONS(2919),
    [anon_sym_if] = ACTIONS(2919),
    [anon_sym_else] = ACTIONS(2919),
    [anon_sym_switch] = ACTIONS(2919),
    [anon_sym_for] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_await] = ACTIONS(2919),
    [anon_sym_while] = ACTIONS(2919),
    [anon_sym_do] = ACTIONS(2919),
    [anon_sym_try] = ACTIONS(2919),
    [anon_sym_with] = ACTIONS(2919),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_continue] = ACTIONS(2919),
    [anon_sym_debugger] = ACTIONS(2919),
    [anon_sym_return] = ACTIONS(2919),
    [anon_sym_throw] = ACTIONS(2919),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_case] = ACTIONS(2919),
    [anon_sym_yield] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [anon_sym_LT] = ACTIONS(2917),
    [anon_sym_SLASH] = ACTIONS(2919),
    [anon_sym_class] = ACTIONS(2919),
    [anon_sym_async] = ACTIONS(2919),
    [anon_sym_function] = ACTIONS(2919),
    [anon_sym_new] = ACTIONS(2919),
    [anon_sym_PLUS] = ACTIONS(2919),
    [anon_sym_DASH] = ACTIONS(2919),
    [anon_sym_BANG] = ACTIONS(2917),
    [anon_sym_TILDE] = ACTIONS(2917),
    [anon_sym_void] = ACTIONS(2919),
    [anon_sym_delete] = ACTIONS(2919),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_DQUOTE] = ACTIONS(2917),
    [anon_sym_SQUOTE] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2917),
    [sym_number] = ACTIONS(2917),
    [sym_this] = ACTIONS(2919),
    [sym_super] = ACTIONS(2919),
    [sym_true] = ACTIONS(2919),
    [sym_false] = ACTIONS(2919),
    [sym_null] = ACTIONS(2919),
    [sym_undefined] = ACTIONS(2919),
    [anon_sym_AT] = ACTIONS(2917),
    [anon_sym_static] = ACTIONS(2919),
    [anon_sym_abstract] = ACTIONS(2919),
    [anon_sym_get] = ACTIONS(2919),
    [anon_sym_set] = ACTIONS(2919),
    [anon_sym_declare] = ACTIONS(2919),
    [anon_sym_public] = ACTIONS(2919),
    [anon_sym_private] = ACTIONS(2919),
    [anon_sym_protected] = ACTIONS(2919),
    [anon_sym_module] = ACTIONS(2919),
    [anon_sym_any] = ACTIONS(2919),
    [anon_sym_number] = ACTIONS(2919),
    [anon_sym_boolean] = ACTIONS(2919),
    [anon_sym_string] = ACTIONS(2919),
    [anon_sym_symbol] = ACTIONS(2919),
    [anon_sym_interface] = ACTIONS(2919),
    [anon_sym_enum] = ACTIONS(2919),
    [sym_readonly] = ACTIONS(2919),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(2921),
    [sym_identifier] = ACTIONS(2923),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_default] = ACTIONS(2923),
    [anon_sym_namespace] = ACTIONS(2923),
    [anon_sym_LBRACE] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_type] = ACTIONS(2923),
    [anon_sym_typeof] = ACTIONS(2923),
    [anon_sym_import] = ACTIONS(2923),
    [anon_sym_var] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2923),
    [anon_sym_switch] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_await] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_with] = ACTIONS(2923),
    [anon_sym_break] = ACTIONS(2923),
    [anon_sym_continue] = ACTIONS(2923),
    [anon_sym_debugger] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_throw] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_case] = ACTIONS(2923),
    [anon_sym_yield] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2921),
    [anon_sym_LT] = ACTIONS(2921),
    [anon_sym_SLASH] = ACTIONS(2923),
    [anon_sym_class] = ACTIONS(2923),
    [anon_sym_async] = ACTIONS(2923),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_new] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [anon_sym_BANG] = ACTIONS(2921),
    [anon_sym_TILDE] = ACTIONS(2921),
    [anon_sym_void] = ACTIONS(2923),
    [anon_sym_delete] = ACTIONS(2923),
    [anon_sym_PLUS_PLUS] = ACTIONS(2921),
    [anon_sym_DASH_DASH] = ACTIONS(2921),
    [anon_sym_DQUOTE] = ACTIONS(2921),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2921),
    [sym_number] = ACTIONS(2921),
    [sym_this] = ACTIONS(2923),
    [sym_super] = ACTIONS(2923),
    [sym_true] = ACTIONS(2923),
    [sym_false] = ACTIONS(2923),
    [sym_null] = ACTIONS(2923),
    [sym_undefined] = ACTIONS(2923),
    [anon_sym_AT] = ACTIONS(2921),
    [anon_sym_static] = ACTIONS(2923),
    [anon_sym_abstract] = ACTIONS(2923),
    [anon_sym_get] = ACTIONS(2923),
    [anon_sym_set] = ACTIONS(2923),
    [anon_sym_declare] = ACTIONS(2923),
    [anon_sym_public] = ACTIONS(2923),
    [anon_sym_private] = ACTIONS(2923),
    [anon_sym_protected] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_any] = ACTIONS(2923),
    [anon_sym_number] = ACTIONS(2923),
    [anon_sym_boolean] = ACTIONS(2923),
    [anon_sym_string] = ACTIONS(2923),
    [anon_sym_symbol] = ACTIONS(2923),
    [anon_sym_interface] = ACTIONS(2923),
    [anon_sym_enum] = ACTIONS(2923),
    [sym_readonly] = ACTIONS(2923),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(2925),
    [sym_identifier] = ACTIONS(2927),
    [anon_sym_export] = ACTIONS(2927),
    [anon_sym_default] = ACTIONS(2927),
    [anon_sym_namespace] = ACTIONS(2927),
    [anon_sym_LBRACE] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_type] = ACTIONS(2927),
    [anon_sym_typeof] = ACTIONS(2927),
    [anon_sym_import] = ACTIONS(2927),
    [anon_sym_var] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_switch] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_await] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [anon_sym_do] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_with] = ACTIONS(2927),
    [anon_sym_break] = ACTIONS(2927),
    [anon_sym_continue] = ACTIONS(2927),
    [anon_sym_debugger] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_throw] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2927),
    [anon_sym_yield] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2925),
    [anon_sym_LT] = ACTIONS(2925),
    [anon_sym_SLASH] = ACTIONS(2927),
    [anon_sym_class] = ACTIONS(2927),
    [anon_sym_async] = ACTIONS(2927),
    [anon_sym_function] = ACTIONS(2927),
    [anon_sym_new] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_DASH] = ACTIONS(2927),
    [anon_sym_BANG] = ACTIONS(2925),
    [anon_sym_TILDE] = ACTIONS(2925),
    [anon_sym_void] = ACTIONS(2927),
    [anon_sym_delete] = ACTIONS(2927),
    [anon_sym_PLUS_PLUS] = ACTIONS(2925),
    [anon_sym_DASH_DASH] = ACTIONS(2925),
    [anon_sym_DQUOTE] = ACTIONS(2925),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2925),
    [sym_number] = ACTIONS(2925),
    [sym_this] = ACTIONS(2927),
    [sym_super] = ACTIONS(2927),
    [sym_true] = ACTIONS(2927),
    [sym_false] = ACTIONS(2927),
    [sym_null] = ACTIONS(2927),
    [sym_undefined] = ACTIONS(2927),
    [anon_sym_AT] = ACTIONS(2925),
    [anon_sym_static] = ACTIONS(2927),
    [anon_sym_abstract] = ACTIONS(2927),
    [anon_sym_get] = ACTIONS(2927),
    [anon_sym_set] = ACTIONS(2927),
    [anon_sym_declare] = ACTIONS(2927),
    [anon_sym_public] = ACTIONS(2927),
    [anon_sym_private] = ACTIONS(2927),
    [anon_sym_protected] = ACTIONS(2927),
    [anon_sym_module] = ACTIONS(2927),
    [anon_sym_any] = ACTIONS(2927),
    [anon_sym_number] = ACTIONS(2927),
    [anon_sym_boolean] = ACTIONS(2927),
    [anon_sym_string] = ACTIONS(2927),
    [anon_sym_symbol] = ACTIONS(2927),
    [anon_sym_interface] = ACTIONS(2927),
    [anon_sym_enum] = ACTIONS(2927),
    [sym_readonly] = ACTIONS(2927),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(2929),
    [sym_identifier] = ACTIONS(2931),
    [anon_sym_export] = ACTIONS(2931),
    [anon_sym_default] = ACTIONS(2931),
    [anon_sym_namespace] = ACTIONS(2931),
    [anon_sym_LBRACE] = ACTIONS(2929),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_type] = ACTIONS(2931),
    [anon_sym_typeof] = ACTIONS(2931),
    [anon_sym_import] = ACTIONS(2931),
    [anon_sym_var] = ACTIONS(2931),
    [anon_sym_let] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_else] = ACTIONS(2931),
    [anon_sym_switch] = ACTIONS(2931),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(2929),
    [anon_sym_await] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [anon_sym_do] = ACTIONS(2931),
    [anon_sym_try] = ACTIONS(2931),
    [anon_sym_with] = ACTIONS(2931),
    [anon_sym_break] = ACTIONS(2931),
    [anon_sym_continue] = ACTIONS(2931),
    [anon_sym_debugger] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2931),
    [anon_sym_throw] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_case] = ACTIONS(2931),
    [anon_sym_yield] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2929),
    [anon_sym_LT] = ACTIONS(2929),
    [anon_sym_SLASH] = ACTIONS(2931),
    [anon_sym_class] = ACTIONS(2931),
    [anon_sym_async] = ACTIONS(2931),
    [anon_sym_function] = ACTIONS(2931),
    [anon_sym_new] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_DASH] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(2929),
    [anon_sym_TILDE] = ACTIONS(2929),
    [anon_sym_void] = ACTIONS(2931),
    [anon_sym_delete] = ACTIONS(2931),
    [anon_sym_PLUS_PLUS] = ACTIONS(2929),
    [anon_sym_DASH_DASH] = ACTIONS(2929),
    [anon_sym_DQUOTE] = ACTIONS(2929),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2929),
    [sym_number] = ACTIONS(2929),
    [sym_this] = ACTIONS(2931),
    [sym_super] = ACTIONS(2931),
    [sym_true] = ACTIONS(2931),
    [sym_false] = ACTIONS(2931),
    [sym_null] = ACTIONS(2931),
    [sym_undefined] = ACTIONS(2931),
    [anon_sym_AT] = ACTIONS(2929),
    [anon_sym_static] = ACTIONS(2931),
    [anon_sym_abstract] = ACTIONS(2931),
    [anon_sym_get] = ACTIONS(2931),
    [anon_sym_set] = ACTIONS(2931),
    [anon_sym_declare] = ACTIONS(2931),
    [anon_sym_public] = ACTIONS(2931),
    [anon_sym_private] = ACTIONS(2931),
    [anon_sym_protected] = ACTIONS(2931),
    [anon_sym_module] = ACTIONS(2931),
    [anon_sym_any] = ACTIONS(2931),
    [anon_sym_number] = ACTIONS(2931),
    [anon_sym_boolean] = ACTIONS(2931),
    [anon_sym_string] = ACTIONS(2931),
    [anon_sym_symbol] = ACTIONS(2931),
    [anon_sym_interface] = ACTIONS(2931),
    [anon_sym_enum] = ACTIONS(2931),
    [sym_readonly] = ACTIONS(2931),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(2933),
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_default] = ACTIONS(2935),
    [anon_sym_namespace] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(2933),
    [anon_sym_type] = ACTIONS(2935),
    [anon_sym_typeof] = ACTIONS(2935),
    [anon_sym_import] = ACTIONS(2935),
    [anon_sym_var] = ACTIONS(2935),
    [anon_sym_let] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_else] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2933),
    [anon_sym_await] = ACTIONS(2935),
    [anon_sym_while] = ACTIONS(2935),
    [anon_sym_do] = ACTIONS(2935),
    [anon_sym_try] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2935),
    [anon_sym_break] = ACTIONS(2935),
    [anon_sym_continue] = ACTIONS(2935),
    [anon_sym_debugger] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_throw] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_case] = ACTIONS(2935),
    [anon_sym_yield] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2935),
    [anon_sym_class] = ACTIONS(2935),
    [anon_sym_async] = ACTIONS(2935),
    [anon_sym_function] = ACTIONS(2935),
    [anon_sym_new] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2935),
    [anon_sym_DASH] = ACTIONS(2935),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [anon_sym_void] = ACTIONS(2935),
    [anon_sym_delete] = ACTIONS(2935),
    [anon_sym_PLUS_PLUS] = ACTIONS(2933),
    [anon_sym_DASH_DASH] = ACTIONS(2933),
    [anon_sym_DQUOTE] = ACTIONS(2933),
    [anon_sym_SQUOTE] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2933),
    [sym_number] = ACTIONS(2933),
    [sym_this] = ACTIONS(2935),
    [sym_super] = ACTIONS(2935),
    [sym_true] = ACTIONS(2935),
    [sym_false] = ACTIONS(2935),
    [sym_null] = ACTIONS(2935),
    [sym_undefined] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(2933),
    [anon_sym_static] = ACTIONS(2935),
    [anon_sym_abstract] = ACTIONS(2935),
    [anon_sym_get] = ACTIONS(2935),
    [anon_sym_set] = ACTIONS(2935),
    [anon_sym_declare] = ACTIONS(2935),
    [anon_sym_public] = ACTIONS(2935),
    [anon_sym_private] = ACTIONS(2935),
    [anon_sym_protected] = ACTIONS(2935),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_any] = ACTIONS(2935),
    [anon_sym_number] = ACTIONS(2935),
    [anon_sym_boolean] = ACTIONS(2935),
    [anon_sym_string] = ACTIONS(2935),
    [anon_sym_symbol] = ACTIONS(2935),
    [anon_sym_interface] = ACTIONS(2935),
    [anon_sym_enum] = ACTIONS(2935),
    [sym_readonly] = ACTIONS(2935),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(2937),
    [sym_identifier] = ACTIONS(2939),
    [anon_sym_export] = ACTIONS(2939),
    [anon_sym_default] = ACTIONS(2939),
    [anon_sym_namespace] = ACTIONS(2939),
    [anon_sym_LBRACE] = ACTIONS(2937),
    [anon_sym_RBRACE] = ACTIONS(2937),
    [anon_sym_type] = ACTIONS(2939),
    [anon_sym_typeof] = ACTIONS(2939),
    [anon_sym_import] = ACTIONS(2939),
    [anon_sym_var] = ACTIONS(2939),
    [anon_sym_let] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(2939),
    [anon_sym_else] = ACTIONS(2939),
    [anon_sym_switch] = ACTIONS(2939),
    [anon_sym_for] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2937),
    [anon_sym_await] = ACTIONS(2939),
    [anon_sym_while] = ACTIONS(2939),
    [anon_sym_do] = ACTIONS(2939),
    [anon_sym_try] = ACTIONS(2939),
    [anon_sym_with] = ACTIONS(2939),
    [anon_sym_break] = ACTIONS(2939),
    [anon_sym_continue] = ACTIONS(2939),
    [anon_sym_debugger] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2939),
    [anon_sym_throw] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym_case] = ACTIONS(2939),
    [anon_sym_yield] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2937),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2939),
    [anon_sym_class] = ACTIONS(2939),
    [anon_sym_async] = ACTIONS(2939),
    [anon_sym_function] = ACTIONS(2939),
    [anon_sym_new] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2939),
    [anon_sym_DASH] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_TILDE] = ACTIONS(2937),
    [anon_sym_void] = ACTIONS(2939),
    [anon_sym_delete] = ACTIONS(2939),
    [anon_sym_PLUS_PLUS] = ACTIONS(2937),
    [anon_sym_DASH_DASH] = ACTIONS(2937),
    [anon_sym_DQUOTE] = ACTIONS(2937),
    [anon_sym_SQUOTE] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2937),
    [sym_number] = ACTIONS(2937),
    [sym_this] = ACTIONS(2939),
    [sym_super] = ACTIONS(2939),
    [sym_true] = ACTIONS(2939),
    [sym_false] = ACTIONS(2939),
    [sym_null] = ACTIONS(2939),
    [sym_undefined] = ACTIONS(2939),
    [anon_sym_AT] = ACTIONS(2937),
    [anon_sym_static] = ACTIONS(2939),
    [anon_sym_abstract] = ACTIONS(2939),
    [anon_sym_get] = ACTIONS(2939),
    [anon_sym_set] = ACTIONS(2939),
    [anon_sym_declare] = ACTIONS(2939),
    [anon_sym_public] = ACTIONS(2939),
    [anon_sym_private] = ACTIONS(2939),
    [anon_sym_protected] = ACTIONS(2939),
    [anon_sym_module] = ACTIONS(2939),
    [anon_sym_any] = ACTIONS(2939),
    [anon_sym_number] = ACTIONS(2939),
    [anon_sym_boolean] = ACTIONS(2939),
    [anon_sym_string] = ACTIONS(2939),
    [anon_sym_symbol] = ACTIONS(2939),
    [anon_sym_interface] = ACTIONS(2939),
    [anon_sym_enum] = ACTIONS(2939),
    [sym_readonly] = ACTIONS(2939),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(2941),
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_export] = ACTIONS(2943),
    [anon_sym_default] = ACTIONS(2943),
    [anon_sym_namespace] = ACTIONS(2943),
    [anon_sym_LBRACE] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2941),
    [anon_sym_type] = ACTIONS(2943),
    [anon_sym_typeof] = ACTIONS(2943),
    [anon_sym_import] = ACTIONS(2943),
    [anon_sym_var] = ACTIONS(2943),
    [anon_sym_let] = ACTIONS(2943),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_else] = ACTIONS(2943),
    [anon_sym_switch] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2941),
    [anon_sym_await] = ACTIONS(2943),
    [anon_sym_while] = ACTIONS(2943),
    [anon_sym_do] = ACTIONS(2943),
    [anon_sym_try] = ACTIONS(2943),
    [anon_sym_with] = ACTIONS(2943),
    [anon_sym_break] = ACTIONS(2943),
    [anon_sym_continue] = ACTIONS(2943),
    [anon_sym_debugger] = ACTIONS(2943),
    [anon_sym_return] = ACTIONS(2943),
    [anon_sym_throw] = ACTIONS(2943),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym_case] = ACTIONS(2943),
    [anon_sym_yield] = ACTIONS(2943),
    [anon_sym_LBRACK] = ACTIONS(2941),
    [anon_sym_LT] = ACTIONS(2941),
    [anon_sym_SLASH] = ACTIONS(2943),
    [anon_sym_class] = ACTIONS(2943),
    [anon_sym_async] = ACTIONS(2943),
    [anon_sym_function] = ACTIONS(2943),
    [anon_sym_new] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_DASH] = ACTIONS(2943),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_TILDE] = ACTIONS(2941),
    [anon_sym_void] = ACTIONS(2943),
    [anon_sym_delete] = ACTIONS(2943),
    [anon_sym_PLUS_PLUS] = ACTIONS(2941),
    [anon_sym_DASH_DASH] = ACTIONS(2941),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [anon_sym_SQUOTE] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2941),
    [sym_number] = ACTIONS(2941),
    [sym_this] = ACTIONS(2943),
    [sym_super] = ACTIONS(2943),
    [sym_true] = ACTIONS(2943),
    [sym_false] = ACTIONS(2943),
    [sym_null] = ACTIONS(2943),
    [sym_undefined] = ACTIONS(2943),
    [anon_sym_AT] = ACTIONS(2941),
    [anon_sym_static] = ACTIONS(2943),
    [anon_sym_abstract] = ACTIONS(2943),
    [anon_sym_get] = ACTIONS(2943),
    [anon_sym_set] = ACTIONS(2943),
    [anon_sym_declare] = ACTIONS(2943),
    [anon_sym_public] = ACTIONS(2943),
    [anon_sym_private] = ACTIONS(2943),
    [anon_sym_protected] = ACTIONS(2943),
    [anon_sym_module] = ACTIONS(2943),
    [anon_sym_any] = ACTIONS(2943),
    [anon_sym_number] = ACTIONS(2943),
    [anon_sym_boolean] = ACTIONS(2943),
    [anon_sym_string] = ACTIONS(2943),
    [anon_sym_symbol] = ACTIONS(2943),
    [anon_sym_interface] = ACTIONS(2943),
    [anon_sym_enum] = ACTIONS(2943),
    [sym_readonly] = ACTIONS(2943),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(2945),
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(2947),
    [anon_sym_default] = ACTIONS(2947),
    [anon_sym_namespace] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_type] = ACTIONS(2947),
    [anon_sym_typeof] = ACTIONS(2947),
    [anon_sym_import] = ACTIONS(2947),
    [anon_sym_var] = ACTIONS(2947),
    [anon_sym_let] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_else] = ACTIONS(2947),
    [anon_sym_switch] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2945),
    [anon_sym_await] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_try] = ACTIONS(2947),
    [anon_sym_with] = ACTIONS(2947),
    [anon_sym_break] = ACTIONS(2947),
    [anon_sym_continue] = ACTIONS(2947),
    [anon_sym_debugger] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_throw] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym_case] = ACTIONS(2947),
    [anon_sym_yield] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_class] = ACTIONS(2947),
    [anon_sym_async] = ACTIONS(2947),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_new] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_TILDE] = ACTIONS(2945),
    [anon_sym_void] = ACTIONS(2947),
    [anon_sym_delete] = ACTIONS(2947),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2945),
    [sym_number] = ACTIONS(2945),
    [sym_this] = ACTIONS(2947),
    [sym_super] = ACTIONS(2947),
    [sym_true] = ACTIONS(2947),
    [sym_false] = ACTIONS(2947),
    [sym_null] = ACTIONS(2947),
    [sym_undefined] = ACTIONS(2947),
    [anon_sym_AT] = ACTIONS(2945),
    [anon_sym_static] = ACTIONS(2947),
    [anon_sym_abstract] = ACTIONS(2947),
    [anon_sym_get] = ACTIONS(2947),
    [anon_sym_set] = ACTIONS(2947),
    [anon_sym_declare] = ACTIONS(2947),
    [anon_sym_public] = ACTIONS(2947),
    [anon_sym_private] = ACTIONS(2947),
    [anon_sym_protected] = ACTIONS(2947),
    [anon_sym_module] = ACTIONS(2947),
    [anon_sym_any] = ACTIONS(2947),
    [anon_sym_number] = ACTIONS(2947),
    [anon_sym_boolean] = ACTIONS(2947),
    [anon_sym_string] = ACTIONS(2947),
    [anon_sym_symbol] = ACTIONS(2947),
    [anon_sym_interface] = ACTIONS(2947),
    [anon_sym_enum] = ACTIONS(2947),
    [sym_readonly] = ACTIONS(2947),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(2949),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_export] = ACTIONS(2951),
    [anon_sym_default] = ACTIONS(2951),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_LBRACE] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2949),
    [anon_sym_type] = ACTIONS(2951),
    [anon_sym_typeof] = ACTIONS(2951),
    [anon_sym_import] = ACTIONS(2951),
    [anon_sym_var] = ACTIONS(2951),
    [anon_sym_let] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_else] = ACTIONS(2951),
    [anon_sym_switch] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2949),
    [anon_sym_await] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2951),
    [anon_sym_do] = ACTIONS(2951),
    [anon_sym_try] = ACTIONS(2951),
    [anon_sym_with] = ACTIONS(2951),
    [anon_sym_break] = ACTIONS(2951),
    [anon_sym_continue] = ACTIONS(2951),
    [anon_sym_debugger] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_throw] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym_case] = ACTIONS(2951),
    [anon_sym_yield] = ACTIONS(2951),
    [anon_sym_LBRACK] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2951),
    [anon_sym_class] = ACTIONS(2951),
    [anon_sym_async] = ACTIONS(2951),
    [anon_sym_function] = ACTIONS(2951),
    [anon_sym_new] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_DASH] = ACTIONS(2951),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_TILDE] = ACTIONS(2949),
    [anon_sym_void] = ACTIONS(2951),
    [anon_sym_delete] = ACTIONS(2951),
    [anon_sym_PLUS_PLUS] = ACTIONS(2949),
    [anon_sym_DASH_DASH] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2949),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2949),
    [sym_number] = ACTIONS(2949),
    [sym_this] = ACTIONS(2951),
    [sym_super] = ACTIONS(2951),
    [sym_true] = ACTIONS(2951),
    [sym_false] = ACTIONS(2951),
    [sym_null] = ACTIONS(2951),
    [sym_undefined] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(2949),
    [anon_sym_static] = ACTIONS(2951),
    [anon_sym_abstract] = ACTIONS(2951),
    [anon_sym_get] = ACTIONS(2951),
    [anon_sym_set] = ACTIONS(2951),
    [anon_sym_declare] = ACTIONS(2951),
    [anon_sym_public] = ACTIONS(2951),
    [anon_sym_private] = ACTIONS(2951),
    [anon_sym_protected] = ACTIONS(2951),
    [anon_sym_module] = ACTIONS(2951),
    [anon_sym_any] = ACTIONS(2951),
    [anon_sym_number] = ACTIONS(2951),
    [anon_sym_boolean] = ACTIONS(2951),
    [anon_sym_string] = ACTIONS(2951),
    [anon_sym_symbol] = ACTIONS(2951),
    [anon_sym_interface] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2951),
    [sym_readonly] = ACTIONS(2951),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(2953),
    [sym_identifier] = ACTIONS(2955),
    [anon_sym_export] = ACTIONS(2955),
    [anon_sym_default] = ACTIONS(2955),
    [anon_sym_namespace] = ACTIONS(2955),
    [anon_sym_LBRACE] = ACTIONS(2953),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_type] = ACTIONS(2955),
    [anon_sym_typeof] = ACTIONS(2955),
    [anon_sym_import] = ACTIONS(2955),
    [anon_sym_var] = ACTIONS(2955),
    [anon_sym_let] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2955),
    [anon_sym_else] = ACTIONS(2955),
    [anon_sym_switch] = ACTIONS(2955),
    [anon_sym_for] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2953),
    [anon_sym_await] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2955),
    [anon_sym_do] = ACTIONS(2955),
    [anon_sym_try] = ACTIONS(2955),
    [anon_sym_with] = ACTIONS(2955),
    [anon_sym_break] = ACTIONS(2955),
    [anon_sym_continue] = ACTIONS(2955),
    [anon_sym_debugger] = ACTIONS(2955),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_throw] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2953),
    [anon_sym_case] = ACTIONS(2955),
    [anon_sym_yield] = ACTIONS(2955),
    [anon_sym_LBRACK] = ACTIONS(2953),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_SLASH] = ACTIONS(2955),
    [anon_sym_class] = ACTIONS(2955),
    [anon_sym_async] = ACTIONS(2955),
    [anon_sym_function] = ACTIONS(2955),
    [anon_sym_new] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_DASH] = ACTIONS(2955),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_TILDE] = ACTIONS(2953),
    [anon_sym_void] = ACTIONS(2955),
    [anon_sym_delete] = ACTIONS(2955),
    [anon_sym_PLUS_PLUS] = ACTIONS(2953),
    [anon_sym_DASH_DASH] = ACTIONS(2953),
    [anon_sym_DQUOTE] = ACTIONS(2953),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2953),
    [sym_number] = ACTIONS(2953),
    [sym_this] = ACTIONS(2955),
    [sym_super] = ACTIONS(2955),
    [sym_true] = ACTIONS(2955),
    [sym_false] = ACTIONS(2955),
    [sym_null] = ACTIONS(2955),
    [sym_undefined] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(2953),
    [anon_sym_static] = ACTIONS(2955),
    [anon_sym_abstract] = ACTIONS(2955),
    [anon_sym_get] = ACTIONS(2955),
    [anon_sym_set] = ACTIONS(2955),
    [anon_sym_declare] = ACTIONS(2955),
    [anon_sym_public] = ACTIONS(2955),
    [anon_sym_private] = ACTIONS(2955),
    [anon_sym_protected] = ACTIONS(2955),
    [anon_sym_module] = ACTIONS(2955),
    [anon_sym_any] = ACTIONS(2955),
    [anon_sym_number] = ACTIONS(2955),
    [anon_sym_boolean] = ACTIONS(2955),
    [anon_sym_string] = ACTIONS(2955),
    [anon_sym_symbol] = ACTIONS(2955),
    [anon_sym_interface] = ACTIONS(2955),
    [anon_sym_enum] = ACTIONS(2955),
    [sym_readonly] = ACTIONS(2955),
  },
  [594] = {
    [sym__call_signature] = STATE(2920),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2831),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2833),
    [anon_sym_type] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_async] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_PLUS_EQ] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(650),
    [anon_sym_STAR_EQ] = ACTIONS(650),
    [anon_sym_SLASH_EQ] = ACTIONS(650),
    [anon_sym_PERCENT_EQ] = ACTIONS(650),
    [anon_sym_CARET_EQ] = ACTIONS(650),
    [anon_sym_AMP_EQ] = ACTIONS(650),
    [anon_sym_PIPE_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_LT_LT_EQ] = ACTIONS(650),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2833),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_declare] = ACTIONS(2833),
    [anon_sym_public] = ACTIONS(2833),
    [anon_sym_private] = ACTIONS(2833),
    [anon_sym_protected] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_any] = ACTIONS(2833),
    [anon_sym_number] = ACTIONS(2833),
    [anon_sym_boolean] = ACTIONS(2833),
    [anon_sym_string] = ACTIONS(2833),
    [anon_sym_symbol] = ACTIONS(2833),
    [sym_readonly] = ACTIONS(2833),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [595] = {
    [sym__call_signature] = STATE(2874),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2829),
    [anon_sym_set] = ACTIONS(2829),
    [anon_sym_declare] = ACTIONS(2829),
    [anon_sym_public] = ACTIONS(2829),
    [anon_sym_private] = ACTIONS(2829),
    [anon_sym_protected] = ACTIONS(2829),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_any] = ACTIONS(2829),
    [anon_sym_number] = ACTIONS(2829),
    [anon_sym_boolean] = ACTIONS(2829),
    [anon_sym_string] = ACTIONS(2829),
    [anon_sym_symbol] = ACTIONS(2829),
    [sym_readonly] = ACTIONS(2829),
  },
  [596] = {
    [sym__call_signature] = STATE(2874),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2829),
    [anon_sym_set] = ACTIONS(2829),
    [anon_sym_declare] = ACTIONS(2829),
    [anon_sym_public] = ACTIONS(2829),
    [anon_sym_private] = ACTIONS(2829),
    [anon_sym_protected] = ACTIONS(2829),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_any] = ACTIONS(2829),
    [anon_sym_number] = ACTIONS(2829),
    [anon_sym_boolean] = ACTIONS(2829),
    [anon_sym_string] = ACTIONS(2829),
    [anon_sym_symbol] = ACTIONS(2829),
    [sym_readonly] = ACTIONS(2829),
  },
  [597] = {
    [sym__call_signature] = STATE(2874),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2829),
    [anon_sym_set] = ACTIONS(2829),
    [anon_sym_declare] = ACTIONS(2829),
    [anon_sym_public] = ACTIONS(2829),
    [anon_sym_private] = ACTIONS(2829),
    [anon_sym_protected] = ACTIONS(2829),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_any] = ACTIONS(2829),
    [anon_sym_number] = ACTIONS(2829),
    [anon_sym_boolean] = ACTIONS(2829),
    [anon_sym_string] = ACTIONS(2829),
    [anon_sym_symbol] = ACTIONS(2829),
    [sym_readonly] = ACTIONS(2829),
  },
  [598] = {
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
  },
  [599] = {
    [sym__call_signature] = STATE(2874),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2829),
    [anon_sym_type] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_of] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(2587),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2829),
    [anon_sym_function] = ACTIONS(2549),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2829),
    [anon_sym_set] = ACTIONS(2829),
    [anon_sym_declare] = ACTIONS(2829),
    [anon_sym_public] = ACTIONS(2829),
    [anon_sym_private] = ACTIONS(2829),
    [anon_sym_protected] = ACTIONS(2829),
    [anon_sym_module] = ACTIONS(2829),
    [anon_sym_any] = ACTIONS(2829),
    [anon_sym_number] = ACTIONS(2829),
    [anon_sym_boolean] = ACTIONS(2829),
    [anon_sym_string] = ACTIONS(2829),
    [anon_sym_symbol] = ACTIONS(2829),
    [sym_readonly] = ACTIONS(2829),
  },
  [600] = {
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym_this] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
  },
  [601] = {
    [sym_identifier] = ACTIONS(2957),
    [anon_sym_export] = ACTIONS(2957),
    [anon_sym_namespace] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_type] = ACTIONS(2957),
    [anon_sym_typeof] = ACTIONS(2957),
    [anon_sym_import] = ACTIONS(2957),
    [anon_sym_var] = ACTIONS(2957),
    [anon_sym_let] = ACTIONS(2957),
    [anon_sym_const] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2957),
    [anon_sym_switch] = ACTIONS(2957),
    [anon_sym_for] = ACTIONS(2957),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [anon_sym_await] = ACTIONS(2957),
    [anon_sym_while] = ACTIONS(2957),
    [anon_sym_do] = ACTIONS(2957),
    [anon_sym_try] = ACTIONS(2957),
    [anon_sym_with] = ACTIONS(2957),
    [anon_sym_break] = ACTIONS(2957),
    [anon_sym_continue] = ACTIONS(2957),
    [anon_sym_debugger] = ACTIONS(2957),
    [anon_sym_return] = ACTIONS(2957),
    [anon_sym_throw] = ACTIONS(2957),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_yield] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_LT] = ACTIONS(2959),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_class] = ACTIONS(2957),
    [anon_sym_async] = ACTIONS(2957),
    [anon_sym_function] = ACTIONS(2957),
    [anon_sym_new] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2959),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_void] = ACTIONS(2957),
    [anon_sym_delete] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2959),
    [sym_number] = ACTIONS(2959),
    [sym_this] = ACTIONS(2957),
    [sym_super] = ACTIONS(2957),
    [sym_true] = ACTIONS(2957),
    [sym_false] = ACTIONS(2957),
    [sym_null] = ACTIONS(2957),
    [sym_undefined] = ACTIONS(2957),
    [anon_sym_AT] = ACTIONS(2959),
    [anon_sym_static] = ACTIONS(2957),
    [anon_sym_abstract] = ACTIONS(2957),
    [anon_sym_get] = ACTIONS(2957),
    [anon_sym_set] = ACTIONS(2957),
    [anon_sym_declare] = ACTIONS(2957),
    [anon_sym_public] = ACTIONS(2957),
    [anon_sym_private] = ACTIONS(2957),
    [anon_sym_protected] = ACTIONS(2957),
    [anon_sym_module] = ACTIONS(2957),
    [anon_sym_any] = ACTIONS(2957),
    [anon_sym_number] = ACTIONS(2957),
    [anon_sym_boolean] = ACTIONS(2957),
    [anon_sym_string] = ACTIONS(2957),
    [anon_sym_symbol] = ACTIONS(2957),
    [anon_sym_interface] = ACTIONS(2957),
    [anon_sym_enum] = ACTIONS(2957),
    [sym_readonly] = ACTIONS(2957),
  },
  [602] = {
    [sym_identifier] = ACTIONS(2961),
    [anon_sym_export] = ACTIONS(2961),
    [anon_sym_namespace] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_type] = ACTIONS(2961),
    [anon_sym_typeof] = ACTIONS(2961),
    [anon_sym_import] = ACTIONS(2961),
    [anon_sym_var] = ACTIONS(2961),
    [anon_sym_let] = ACTIONS(2961),
    [anon_sym_const] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_switch] = ACTIONS(2961),
    [anon_sym_for] = ACTIONS(2961),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_await] = ACTIONS(2961),
    [anon_sym_while] = ACTIONS(2961),
    [anon_sym_do] = ACTIONS(2961),
    [anon_sym_try] = ACTIONS(2961),
    [anon_sym_with] = ACTIONS(2961),
    [anon_sym_break] = ACTIONS(2961),
    [anon_sym_continue] = ACTIONS(2961),
    [anon_sym_debugger] = ACTIONS(2961),
    [anon_sym_return] = ACTIONS(2961),
    [anon_sym_throw] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_yield] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_LT] = ACTIONS(2963),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_class] = ACTIONS(2961),
    [anon_sym_async] = ACTIONS(2961),
    [anon_sym_function] = ACTIONS(2961),
    [anon_sym_new] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2963),
    [anon_sym_TILDE] = ACTIONS(2963),
    [anon_sym_void] = ACTIONS(2961),
    [anon_sym_delete] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2963),
    [anon_sym_DASH_DASH] = ACTIONS(2963),
    [anon_sym_DQUOTE] = ACTIONS(2963),
    [anon_sym_SQUOTE] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2963),
    [sym_number] = ACTIONS(2963),
    [sym_this] = ACTIONS(2961),
    [sym_super] = ACTIONS(2961),
    [sym_true] = ACTIONS(2961),
    [sym_false] = ACTIONS(2961),
    [sym_null] = ACTIONS(2961),
    [sym_undefined] = ACTIONS(2961),
    [anon_sym_AT] = ACTIONS(2963),
    [anon_sym_static] = ACTIONS(2961),
    [anon_sym_abstract] = ACTIONS(2961),
    [anon_sym_get] = ACTIONS(2961),
    [anon_sym_set] = ACTIONS(2961),
    [anon_sym_declare] = ACTIONS(2961),
    [anon_sym_public] = ACTIONS(2961),
    [anon_sym_private] = ACTIONS(2961),
    [anon_sym_protected] = ACTIONS(2961),
    [anon_sym_module] = ACTIONS(2961),
    [anon_sym_any] = ACTIONS(2961),
    [anon_sym_number] = ACTIONS(2961),
    [anon_sym_boolean] = ACTIONS(2961),
    [anon_sym_string] = ACTIONS(2961),
    [anon_sym_symbol] = ACTIONS(2961),
    [anon_sym_interface] = ACTIONS(2961),
    [anon_sym_enum] = ACTIONS(2961),
    [sym_readonly] = ACTIONS(2961),
  },
  [603] = {
    [sym_identifier] = ACTIONS(2965),
    [anon_sym_export] = ACTIONS(2965),
    [anon_sym_namespace] = ACTIONS(2965),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_type] = ACTIONS(2965),
    [anon_sym_typeof] = ACTIONS(2965),
    [anon_sym_import] = ACTIONS(2965),
    [anon_sym_var] = ACTIONS(2965),
    [anon_sym_let] = ACTIONS(2965),
    [anon_sym_const] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2965),
    [anon_sym_switch] = ACTIONS(2965),
    [anon_sym_for] = ACTIONS(2965),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_await] = ACTIONS(2965),
    [anon_sym_while] = ACTIONS(2965),
    [anon_sym_do] = ACTIONS(2965),
    [anon_sym_try] = ACTIONS(2965),
    [anon_sym_with] = ACTIONS(2965),
    [anon_sym_break] = ACTIONS(2965),
    [anon_sym_continue] = ACTIONS(2965),
    [anon_sym_debugger] = ACTIONS(2965),
    [anon_sym_return] = ACTIONS(2965),
    [anon_sym_throw] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_yield] = ACTIONS(2965),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_class] = ACTIONS(2965),
    [anon_sym_async] = ACTIONS(2965),
    [anon_sym_function] = ACTIONS(2965),
    [anon_sym_new] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2967),
    [anon_sym_void] = ACTIONS(2965),
    [anon_sym_delete] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_DQUOTE] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2967),
    [sym_number] = ACTIONS(2967),
    [sym_this] = ACTIONS(2965),
    [sym_super] = ACTIONS(2965),
    [sym_true] = ACTIONS(2965),
    [sym_false] = ACTIONS(2965),
    [sym_null] = ACTIONS(2965),
    [sym_undefined] = ACTIONS(2965),
    [anon_sym_AT] = ACTIONS(2967),
    [anon_sym_static] = ACTIONS(2965),
    [anon_sym_abstract] = ACTIONS(2965),
    [anon_sym_get] = ACTIONS(2965),
    [anon_sym_set] = ACTIONS(2965),
    [anon_sym_declare] = ACTIONS(2965),
    [anon_sym_public] = ACTIONS(2965),
    [anon_sym_private] = ACTIONS(2965),
    [anon_sym_protected] = ACTIONS(2965),
    [anon_sym_module] = ACTIONS(2965),
    [anon_sym_any] = ACTIONS(2965),
    [anon_sym_number] = ACTIONS(2965),
    [anon_sym_boolean] = ACTIONS(2965),
    [anon_sym_string] = ACTIONS(2965),
    [anon_sym_symbol] = ACTIONS(2965),
    [anon_sym_interface] = ACTIONS(2965),
    [anon_sym_enum] = ACTIONS(2965),
    [sym_readonly] = ACTIONS(2965),
  },
  [604] = {
    [sym_identifier] = ACTIONS(2969),
    [anon_sym_export] = ACTIONS(2969),
    [anon_sym_namespace] = ACTIONS(2969),
    [anon_sym_LBRACE] = ACTIONS(2971),
    [anon_sym_type] = ACTIONS(2969),
    [anon_sym_typeof] = ACTIONS(2969),
    [anon_sym_import] = ACTIONS(2969),
    [anon_sym_var] = ACTIONS(2969),
    [anon_sym_let] = ACTIONS(2969),
    [anon_sym_const] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2969),
    [anon_sym_switch] = ACTIONS(2969),
    [anon_sym_for] = ACTIONS(2969),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_await] = ACTIONS(2969),
    [anon_sym_while] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2969),
    [anon_sym_try] = ACTIONS(2969),
    [anon_sym_with] = ACTIONS(2969),
    [anon_sym_break] = ACTIONS(2969),
    [anon_sym_continue] = ACTIONS(2969),
    [anon_sym_debugger] = ACTIONS(2969),
    [anon_sym_return] = ACTIONS(2969),
    [anon_sym_throw] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2971),
    [anon_sym_yield] = ACTIONS(2969),
    [anon_sym_LBRACK] = ACTIONS(2971),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_class] = ACTIONS(2969),
    [anon_sym_async] = ACTIONS(2969),
    [anon_sym_function] = ACTIONS(2969),
    [anon_sym_new] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2969),
    [anon_sym_DASH] = ACTIONS(2969),
    [anon_sym_BANG] = ACTIONS(2971),
    [anon_sym_TILDE] = ACTIONS(2971),
    [anon_sym_void] = ACTIONS(2969),
    [anon_sym_delete] = ACTIONS(2969),
    [anon_sym_PLUS_PLUS] = ACTIONS(2971),
    [anon_sym_DASH_DASH] = ACTIONS(2971),
    [anon_sym_DQUOTE] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2971),
    [sym_number] = ACTIONS(2971),
    [sym_this] = ACTIONS(2969),
    [sym_super] = ACTIONS(2969),
    [sym_true] = ACTIONS(2969),
    [sym_false] = ACTIONS(2969),
    [sym_null] = ACTIONS(2969),
    [sym_undefined] = ACTIONS(2969),
    [anon_sym_AT] = ACTIONS(2971),
    [anon_sym_static] = ACTIONS(2969),
    [anon_sym_abstract] = ACTIONS(2969),
    [anon_sym_get] = ACTIONS(2969),
    [anon_sym_set] = ACTIONS(2969),
    [anon_sym_declare] = ACTIONS(2969),
    [anon_sym_public] = ACTIONS(2969),
    [anon_sym_private] = ACTIONS(2969),
    [anon_sym_protected] = ACTIONS(2969),
    [anon_sym_module] = ACTIONS(2969),
    [anon_sym_any] = ACTIONS(2969),
    [anon_sym_number] = ACTIONS(2969),
    [anon_sym_boolean] = ACTIONS(2969),
    [anon_sym_string] = ACTIONS(2969),
    [anon_sym_symbol] = ACTIONS(2969),
    [anon_sym_interface] = ACTIONS(2969),
    [anon_sym_enum] = ACTIONS(2969),
    [sym_readonly] = ACTIONS(2969),
  },
  [605] = {
    [sym_identifier] = ACTIONS(2973),
    [anon_sym_export] = ACTIONS(2973),
    [anon_sym_namespace] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2975),
    [anon_sym_type] = ACTIONS(2973),
    [anon_sym_typeof] = ACTIONS(2973),
    [anon_sym_import] = ACTIONS(2973),
    [anon_sym_var] = ACTIONS(2973),
    [anon_sym_let] = ACTIONS(2973),
    [anon_sym_const] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_switch] = ACTIONS(2973),
    [anon_sym_for] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_await] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_try] = ACTIONS(2973),
    [anon_sym_with] = ACTIONS(2973),
    [anon_sym_break] = ACTIONS(2973),
    [anon_sym_continue] = ACTIONS(2973),
    [anon_sym_debugger] = ACTIONS(2973),
    [anon_sym_return] = ACTIONS(2973),
    [anon_sym_throw] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(2975),
    [anon_sym_yield] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_class] = ACTIONS(2973),
    [anon_sym_async] = ACTIONS(2973),
    [anon_sym_function] = ACTIONS(2973),
    [anon_sym_new] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_DASH] = ACTIONS(2973),
    [anon_sym_BANG] = ACTIONS(2975),
    [anon_sym_TILDE] = ACTIONS(2975),
    [anon_sym_void] = ACTIONS(2973),
    [anon_sym_delete] = ACTIONS(2973),
    [anon_sym_PLUS_PLUS] = ACTIONS(2975),
    [anon_sym_DASH_DASH] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2975),
    [sym_number] = ACTIONS(2975),
    [sym_this] = ACTIONS(2973),
    [sym_super] = ACTIONS(2973),
    [sym_true] = ACTIONS(2973),
    [sym_false] = ACTIONS(2973),
    [sym_null] = ACTIONS(2973),
    [sym_undefined] = ACTIONS(2973),
    [anon_sym_AT] = ACTIONS(2975),
    [anon_sym_static] = ACTIONS(2973),
    [anon_sym_abstract] = ACTIONS(2973),
    [anon_sym_get] = ACTIONS(2973),
    [anon_sym_set] = ACTIONS(2973),
    [anon_sym_declare] = ACTIONS(2973),
    [anon_sym_public] = ACTIONS(2973),
    [anon_sym_private] = ACTIONS(2973),
    [anon_sym_protected] = ACTIONS(2973),
    [anon_sym_module] = ACTIONS(2973),
    [anon_sym_any] = ACTIONS(2973),
    [anon_sym_number] = ACTIONS(2973),
    [anon_sym_boolean] = ACTIONS(2973),
    [anon_sym_string] = ACTIONS(2973),
    [anon_sym_symbol] = ACTIONS(2973),
    [anon_sym_interface] = ACTIONS(2973),
    [anon_sym_enum] = ACTIONS(2973),
    [sym_readonly] = ACTIONS(2973),
  },
  [606] = {
    [sym_identifier] = ACTIONS(2977),
    [anon_sym_export] = ACTIONS(2977),
    [anon_sym_namespace] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_type] = ACTIONS(2977),
    [anon_sym_typeof] = ACTIONS(2977),
    [anon_sym_import] = ACTIONS(2977),
    [anon_sym_var] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_const] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_for] = ACTIONS(2977),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_await] = ACTIONS(2977),
    [anon_sym_while] = ACTIONS(2977),
    [anon_sym_do] = ACTIONS(2977),
    [anon_sym_try] = ACTIONS(2977),
    [anon_sym_with] = ACTIONS(2977),
    [anon_sym_break] = ACTIONS(2977),
    [anon_sym_continue] = ACTIONS(2977),
    [anon_sym_debugger] = ACTIONS(2977),
    [anon_sym_return] = ACTIONS(2977),
    [anon_sym_throw] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2979),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_class] = ACTIONS(2977),
    [anon_sym_async] = ACTIONS(2977),
    [anon_sym_function] = ACTIONS(2977),
    [anon_sym_new] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2979),
    [anon_sym_TILDE] = ACTIONS(2979),
    [anon_sym_void] = ACTIONS(2977),
    [anon_sym_delete] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_DQUOTE] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2979),
    [sym_number] = ACTIONS(2979),
    [sym_this] = ACTIONS(2977),
    [sym_super] = ACTIONS(2977),
    [sym_true] = ACTIONS(2977),
    [sym_false] = ACTIONS(2977),
    [sym_null] = ACTIONS(2977),
    [sym_undefined] = ACTIONS(2977),
    [anon_sym_AT] = ACTIONS(2979),
    [anon_sym_static] = ACTIONS(2977),
    [anon_sym_abstract] = ACTIONS(2977),
    [anon_sym_get] = ACTIONS(2977),
    [anon_sym_set] = ACTIONS(2977),
    [anon_sym_declare] = ACTIONS(2977),
    [anon_sym_public] = ACTIONS(2977),
    [anon_sym_private] = ACTIONS(2977),
    [anon_sym_protected] = ACTIONS(2977),
    [anon_sym_module] = ACTIONS(2977),
    [anon_sym_any] = ACTIONS(2977),
    [anon_sym_number] = ACTIONS(2977),
    [anon_sym_boolean] = ACTIONS(2977),
    [anon_sym_string] = ACTIONS(2977),
    [anon_sym_symbol] = ACTIONS(2977),
    [anon_sym_interface] = ACTIONS(2977),
    [anon_sym_enum] = ACTIONS(2977),
    [sym_readonly] = ACTIONS(2977),
  },
  [607] = {
    [sym_identifier] = ACTIONS(2981),
    [anon_sym_export] = ACTIONS(2981),
    [anon_sym_namespace] = ACTIONS(2981),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_type] = ACTIONS(2981),
    [anon_sym_typeof] = ACTIONS(2981),
    [anon_sym_import] = ACTIONS(2981),
    [anon_sym_var] = ACTIONS(2981),
    [anon_sym_let] = ACTIONS(2981),
    [anon_sym_const] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2981),
    [anon_sym_switch] = ACTIONS(2981),
    [anon_sym_for] = ACTIONS(2981),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_await] = ACTIONS(2981),
    [anon_sym_while] = ACTIONS(2981),
    [anon_sym_do] = ACTIONS(2981),
    [anon_sym_try] = ACTIONS(2981),
    [anon_sym_with] = ACTIONS(2981),
    [anon_sym_break] = ACTIONS(2981),
    [anon_sym_continue] = ACTIONS(2981),
    [anon_sym_debugger] = ACTIONS(2981),
    [anon_sym_return] = ACTIONS(2981),
    [anon_sym_throw] = ACTIONS(2981),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_yield] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_class] = ACTIONS(2981),
    [anon_sym_async] = ACTIONS(2981),
    [anon_sym_function] = ACTIONS(2981),
    [anon_sym_new] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_BANG] = ACTIONS(2983),
    [anon_sym_TILDE] = ACTIONS(2983),
    [anon_sym_void] = ACTIONS(2981),
    [anon_sym_delete] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [anon_sym_DQUOTE] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2983),
    [sym_number] = ACTIONS(2983),
    [sym_this] = ACTIONS(2981),
    [sym_super] = ACTIONS(2981),
    [sym_true] = ACTIONS(2981),
    [sym_false] = ACTIONS(2981),
    [sym_null] = ACTIONS(2981),
    [sym_undefined] = ACTIONS(2981),
    [anon_sym_AT] = ACTIONS(2983),
    [anon_sym_static] = ACTIONS(2981),
    [anon_sym_abstract] = ACTIONS(2981),
    [anon_sym_get] = ACTIONS(2981),
    [anon_sym_set] = ACTIONS(2981),
    [anon_sym_declare] = ACTIONS(2981),
    [anon_sym_public] = ACTIONS(2981),
    [anon_sym_private] = ACTIONS(2981),
    [anon_sym_protected] = ACTIONS(2981),
    [anon_sym_module] = ACTIONS(2981),
    [anon_sym_any] = ACTIONS(2981),
    [anon_sym_number] = ACTIONS(2981),
    [anon_sym_boolean] = ACTIONS(2981),
    [anon_sym_string] = ACTIONS(2981),
    [anon_sym_symbol] = ACTIONS(2981),
    [anon_sym_interface] = ACTIONS(2981),
    [anon_sym_enum] = ACTIONS(2981),
    [sym_readonly] = ACTIONS(2981),
  },
  [608] = {
    [sym_identifier] = ACTIONS(2985),
    [anon_sym_export] = ACTIONS(2985),
    [anon_sym_namespace] = ACTIONS(2985),
    [anon_sym_LBRACE] = ACTIONS(2987),
    [anon_sym_type] = ACTIONS(2985),
    [anon_sym_typeof] = ACTIONS(2985),
    [anon_sym_import] = ACTIONS(2985),
    [anon_sym_var] = ACTIONS(2985),
    [anon_sym_let] = ACTIONS(2985),
    [anon_sym_const] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2985),
    [anon_sym_switch] = ACTIONS(2985),
    [anon_sym_for] = ACTIONS(2985),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_await] = ACTIONS(2985),
    [anon_sym_while] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2985),
    [anon_sym_try] = ACTIONS(2985),
    [anon_sym_with] = ACTIONS(2985),
    [anon_sym_break] = ACTIONS(2985),
    [anon_sym_continue] = ACTIONS(2985),
    [anon_sym_debugger] = ACTIONS(2985),
    [anon_sym_return] = ACTIONS(2985),
    [anon_sym_throw] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_yield] = ACTIONS(2985),
    [anon_sym_LBRACK] = ACTIONS(2987),
    [anon_sym_LT] = ACTIONS(2987),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_class] = ACTIONS(2985),
    [anon_sym_async] = ACTIONS(2985),
    [anon_sym_function] = ACTIONS(2985),
    [anon_sym_new] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_DASH] = ACTIONS(2985),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_void] = ACTIONS(2985),
    [anon_sym_delete] = ACTIONS(2985),
    [anon_sym_PLUS_PLUS] = ACTIONS(2987),
    [anon_sym_DASH_DASH] = ACTIONS(2987),
    [anon_sym_DQUOTE] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2987),
    [sym_number] = ACTIONS(2987),
    [sym_this] = ACTIONS(2985),
    [sym_super] = ACTIONS(2985),
    [sym_true] = ACTIONS(2985),
    [sym_false] = ACTIONS(2985),
    [sym_null] = ACTIONS(2985),
    [sym_undefined] = ACTIONS(2985),
    [anon_sym_AT] = ACTIONS(2987),
    [anon_sym_static] = ACTIONS(2985),
    [anon_sym_abstract] = ACTIONS(2985),
    [anon_sym_get] = ACTIONS(2985),
    [anon_sym_set] = ACTIONS(2985),
    [anon_sym_declare] = ACTIONS(2985),
    [anon_sym_public] = ACTIONS(2985),
    [anon_sym_private] = ACTIONS(2985),
    [anon_sym_protected] = ACTIONS(2985),
    [anon_sym_module] = ACTIONS(2985),
    [anon_sym_any] = ACTIONS(2985),
    [anon_sym_number] = ACTIONS(2985),
    [anon_sym_boolean] = ACTIONS(2985),
    [anon_sym_string] = ACTIONS(2985),
    [anon_sym_symbol] = ACTIONS(2985),
    [anon_sym_interface] = ACTIONS(2985),
    [anon_sym_enum] = ACTIONS(2985),
    [sym_readonly] = ACTIONS(2985),
  },
  [609] = {
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(2989),
    [anon_sym_namespace] = ACTIONS(2989),
    [anon_sym_LBRACE] = ACTIONS(2991),
    [anon_sym_type] = ACTIONS(2989),
    [anon_sym_typeof] = ACTIONS(2989),
    [anon_sym_import] = ACTIONS(2989),
    [anon_sym_var] = ACTIONS(2989),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_const] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_for] = ACTIONS(2989),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_await] = ACTIONS(2989),
    [anon_sym_while] = ACTIONS(2989),
    [anon_sym_do] = ACTIONS(2989),
    [anon_sym_try] = ACTIONS(2989),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_break] = ACTIONS(2989),
    [anon_sym_continue] = ACTIONS(2989),
    [anon_sym_debugger] = ACTIONS(2989),
    [anon_sym_return] = ACTIONS(2989),
    [anon_sym_throw] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_yield] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_LT] = ACTIONS(2991),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_class] = ACTIONS(2989),
    [anon_sym_async] = ACTIONS(2989),
    [anon_sym_function] = ACTIONS(2989),
    [anon_sym_new] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2991),
    [anon_sym_TILDE] = ACTIONS(2991),
    [anon_sym_void] = ACTIONS(2989),
    [anon_sym_delete] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2991),
    [sym_number] = ACTIONS(2991),
    [sym_this] = ACTIONS(2989),
    [sym_super] = ACTIONS(2989),
    [sym_true] = ACTIONS(2989),
    [sym_false] = ACTIONS(2989),
    [sym_null] = ACTIONS(2989),
    [sym_undefined] = ACTIONS(2989),
    [anon_sym_AT] = ACTIONS(2991),
    [anon_sym_static] = ACTIONS(2989),
    [anon_sym_abstract] = ACTIONS(2989),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_declare] = ACTIONS(2989),
    [anon_sym_public] = ACTIONS(2989),
    [anon_sym_private] = ACTIONS(2989),
    [anon_sym_protected] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2989),
    [anon_sym_any] = ACTIONS(2989),
    [anon_sym_number] = ACTIONS(2989),
    [anon_sym_boolean] = ACTIONS(2989),
    [anon_sym_string] = ACTIONS(2989),
    [anon_sym_symbol] = ACTIONS(2989),
    [anon_sym_interface] = ACTIONS(2989),
    [anon_sym_enum] = ACTIONS(2989),
    [sym_readonly] = ACTIONS(2989),
  },
  [610] = {
    [sym_identifier] = ACTIONS(2993),
    [anon_sym_export] = ACTIONS(2993),
    [anon_sym_namespace] = ACTIONS(2993),
    [anon_sym_LBRACE] = ACTIONS(2995),
    [anon_sym_type] = ACTIONS(2993),
    [anon_sym_typeof] = ACTIONS(2993),
    [anon_sym_import] = ACTIONS(2993),
    [anon_sym_var] = ACTIONS(2993),
    [anon_sym_let] = ACTIONS(2993),
    [anon_sym_const] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_for] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_await] = ACTIONS(2993),
    [anon_sym_while] = ACTIONS(2993),
    [anon_sym_do] = ACTIONS(2993),
    [anon_sym_try] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2993),
    [anon_sym_break] = ACTIONS(2993),
    [anon_sym_continue] = ACTIONS(2993),
    [anon_sym_debugger] = ACTIONS(2993),
    [anon_sym_return] = ACTIONS(2993),
    [anon_sym_throw] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym_yield] = ACTIONS(2993),
    [anon_sym_LBRACK] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_SLASH] = ACTIONS(2993),
    [anon_sym_class] = ACTIONS(2993),
    [anon_sym_async] = ACTIONS(2993),
    [anon_sym_function] = ACTIONS(2993),
    [anon_sym_new] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2993),
    [anon_sym_DASH] = ACTIONS(2993),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_TILDE] = ACTIONS(2995),
    [anon_sym_void] = ACTIONS(2993),
    [anon_sym_delete] = ACTIONS(2993),
    [anon_sym_PLUS_PLUS] = ACTIONS(2995),
    [anon_sym_DASH_DASH] = ACTIONS(2995),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [sym_number] = ACTIONS(2995),
    [sym_this] = ACTIONS(2993),
    [sym_super] = ACTIONS(2993),
    [sym_true] = ACTIONS(2993),
    [sym_false] = ACTIONS(2993),
    [sym_null] = ACTIONS(2993),
    [sym_undefined] = ACTIONS(2993),
    [anon_sym_AT] = ACTIONS(2995),
    [anon_sym_static] = ACTIONS(2993),
    [anon_sym_abstract] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2993),
    [anon_sym_set] = ACTIONS(2993),
    [anon_sym_declare] = ACTIONS(2993),
    [anon_sym_public] = ACTIONS(2993),
    [anon_sym_private] = ACTIONS(2993),
    [anon_sym_protected] = ACTIONS(2993),
    [anon_sym_module] = ACTIONS(2993),
    [anon_sym_any] = ACTIONS(2993),
    [anon_sym_number] = ACTIONS(2993),
    [anon_sym_boolean] = ACTIONS(2993),
    [anon_sym_string] = ACTIONS(2993),
    [anon_sym_symbol] = ACTIONS(2993),
    [anon_sym_interface] = ACTIONS(2993),
    [anon_sym_enum] = ACTIONS(2993),
    [sym_readonly] = ACTIONS(2993),
  },
  [611] = {
    [sym_nested_identifier] = STATE(482),
    [sym_string] = STATE(506),
    [sym__module] = STATE(517),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [612] = {
    [sym_nested_identifier] = STATE(482),
    [sym_string] = STATE(506),
    [sym__module] = STATE(517),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [613] = {
    [sym_nested_identifier] = STATE(103),
    [sym_string] = STATE(104),
    [sym__module] = STATE(128),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [614] = {
    [sym_nested_identifier] = STATE(103),
    [sym_string] = STATE(104),
    [sym__module] = STATE(128),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [615] = {
    [sym_nested_identifier] = STATE(103),
    [sym_string] = STATE(104),
    [sym__module] = STATE(128),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [616] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym_arguments] = STATE(1108),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
  },
  [617] = {
    [sym_nested_identifier] = STATE(482),
    [sym_string] = STATE(506),
    [sym__module] = STATE(517),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [618] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym_arguments] = STATE(1440),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [619] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [620] = {
    [sym_nested_identifier] = STATE(103),
    [sym_string] = STATE(104),
    [sym__module] = STATE(128),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(3001),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [621] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym_arguments] = STATE(1108),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_implements] = ACTIONS(491),
  },
  [622] = {
    [sym_nested_identifier] = STATE(982),
    [sym_string] = STATE(985),
    [sym__module] = STATE(1217),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [623] = {
    [sym_nested_identifier] = STATE(982),
    [sym_string] = STATE(985),
    [sym__module] = STATE(1217),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [624] = {
    [sym_export_statement] = STATE(2075),
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2484),
    [sym_array] = STATE(2846),
    [sym__call_signature] = STATE(2133),
    [sym_spread_element] = STATE(2484),
    [sym_string] = STATE(1815),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym_method_definition] = STATE(2484),
    [sym_pair] = STATE(2484),
    [sym__property_name] = STATE(1815),
    [sym_computed_property_name] = STATE(1815),
    [sym_method_signature] = STATE(2075),
    [sym_accessibility_modifier] = STATE(1766),
    [sym_call_signature] = STATE(2075),
    [sym_property_signature] = STATE(2075),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2075),
    [sym_index_signature] = STATE(2075),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [aux_sym_object_repeat1] = STATE(2486),
    [sym_identifier] = ACTIONS(3013),
    [anon_sym_export] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3021),
    [anon_sym_type] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3013),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3039),
    [anon_sym_get] = ACTIONS(3041),
    [anon_sym_set] = ACTIONS(3041),
    [anon_sym_declare] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3043),
    [anon_sym_private] = ACTIONS(3043),
    [anon_sym_protected] = ACTIONS(3043),
    [anon_sym_module] = ACTIONS(3013),
    [anon_sym_any] = ACTIONS(3013),
    [anon_sym_number] = ACTIONS(3013),
    [anon_sym_boolean] = ACTIONS(3013),
    [anon_sym_string] = ACTIONS(3013),
    [anon_sym_symbol] = ACTIONS(3013),
    [sym_readonly] = ACTIONS(3045),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3047),
  },
  [625] = {
    [sym_export_statement] = STATE(2012),
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2432),
    [sym_array] = STATE(2846),
    [sym__call_signature] = STATE(2133),
    [sym_spread_element] = STATE(2432),
    [sym_string] = STATE(1815),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym_method_definition] = STATE(2432),
    [sym_pair] = STATE(2432),
    [sym__property_name] = STATE(1815),
    [sym_computed_property_name] = STATE(1815),
    [sym_method_signature] = STATE(2012),
    [sym_accessibility_modifier] = STATE(1766),
    [sym_call_signature] = STATE(2012),
    [sym_property_signature] = STATE(2012),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2012),
    [sym_index_signature] = STATE(2012),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [aux_sym_object_repeat1] = STATE(2431),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_RBRACE] = ACTIONS(3055),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3059),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3061),
    [anon_sym_get] = ACTIONS(3063),
    [anon_sym_set] = ACTIONS(3063),
    [anon_sym_declare] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3065),
    [anon_sym_private] = ACTIONS(3065),
    [anon_sym_protected] = ACTIONS(3065),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_any] = ACTIONS(3049),
    [anon_sym_number] = ACTIONS(3049),
    [anon_sym_boolean] = ACTIONS(3049),
    [anon_sym_string] = ACTIONS(3049),
    [anon_sym_symbol] = ACTIONS(3049),
    [sym_readonly] = ACTIONS(3067),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3069),
  },
  [626] = {
    [sym_nested_identifier] = STATE(982),
    [sym_string] = STATE(985),
    [sym__module] = STATE(1217),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [627] = {
    [sym_export_statement] = STATE(2075),
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2432),
    [sym_array] = STATE(2846),
    [sym__call_signature] = STATE(2133),
    [sym_spread_element] = STATE(2432),
    [sym_string] = STATE(1815),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym_method_definition] = STATE(2432),
    [sym_pair] = STATE(2432),
    [sym__property_name] = STATE(1815),
    [sym_computed_property_name] = STATE(1815),
    [sym_method_signature] = STATE(2075),
    [sym_accessibility_modifier] = STATE(1766),
    [sym_call_signature] = STATE(2075),
    [sym_property_signature] = STATE(2075),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2075),
    [sym_index_signature] = STATE(2075),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [aux_sym_object_repeat1] = STATE(2431),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3059),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3061),
    [anon_sym_get] = ACTIONS(3063),
    [anon_sym_set] = ACTIONS(3063),
    [anon_sym_declare] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3065),
    [anon_sym_private] = ACTIONS(3065),
    [anon_sym_protected] = ACTIONS(3065),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_any] = ACTIONS(3049),
    [anon_sym_number] = ACTIONS(3049),
    [anon_sym_boolean] = ACTIONS(3049),
    [anon_sym_string] = ACTIONS(3049),
    [anon_sym_symbol] = ACTIONS(3049),
    [sym_readonly] = ACTIONS(3067),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3047),
  },
  [628] = {
    [sym_nested_identifier] = STATE(482),
    [sym_string] = STATE(506),
    [sym__module] = STATE(517),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [629] = {
    [sym_export_statement] = STATE(2075),
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2526),
    [sym_array] = STATE(2846),
    [sym__call_signature] = STATE(2133),
    [sym_spread_element] = STATE(2526),
    [sym_string] = STATE(1815),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym_method_definition] = STATE(2526),
    [sym_pair] = STATE(2526),
    [sym__property_name] = STATE(1815),
    [sym_computed_property_name] = STATE(1815),
    [sym_method_signature] = STATE(2075),
    [sym_accessibility_modifier] = STATE(1766),
    [sym_call_signature] = STATE(2075),
    [sym_property_signature] = STATE(2075),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2075),
    [sym_index_signature] = STATE(2075),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [aux_sym_object_repeat1] = STATE(2527),
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_type] = ACTIONS(3073),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3081),
    [anon_sym_get] = ACTIONS(3083),
    [anon_sym_set] = ACTIONS(3083),
    [anon_sym_declare] = ACTIONS(3073),
    [anon_sym_public] = ACTIONS(3085),
    [anon_sym_private] = ACTIONS(3085),
    [anon_sym_protected] = ACTIONS(3085),
    [anon_sym_module] = ACTIONS(3073),
    [anon_sym_any] = ACTIONS(3073),
    [anon_sym_number] = ACTIONS(3073),
    [anon_sym_boolean] = ACTIONS(3073),
    [anon_sym_string] = ACTIONS(3073),
    [anon_sym_symbol] = ACTIONS(3073),
    [sym_readonly] = ACTIONS(3087),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3047),
  },
  [630] = {
    [sym_export_statement] = STATE(2075),
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2432),
    [sym_array] = STATE(2846),
    [sym__call_signature] = STATE(2133),
    [sym_spread_element] = STATE(2432),
    [sym_string] = STATE(1815),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym_method_definition] = STATE(2432),
    [sym_pair] = STATE(2432),
    [sym__property_name] = STATE(1815),
    [sym_computed_property_name] = STATE(1815),
    [sym_method_signature] = STATE(2075),
    [sym_accessibility_modifier] = STATE(1766),
    [sym_call_signature] = STATE(2075),
    [sym_property_signature] = STATE(2075),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2075),
    [sym_index_signature] = STATE(2075),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [aux_sym_object_repeat1] = STATE(2431),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3089),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3059),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3061),
    [anon_sym_get] = ACTIONS(3063),
    [anon_sym_set] = ACTIONS(3063),
    [anon_sym_declare] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3065),
    [anon_sym_private] = ACTIONS(3065),
    [anon_sym_protected] = ACTIONS(3065),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_any] = ACTIONS(3049),
    [anon_sym_number] = ACTIONS(3049),
    [anon_sym_boolean] = ACTIONS(3049),
    [anon_sym_string] = ACTIONS(3049),
    [anon_sym_symbol] = ACTIONS(3049),
    [sym_readonly] = ACTIONS(3067),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3047),
  },
  [631] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym_arguments] = STATE(1568),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2642),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [632] = {
    [sym_export_statement] = STATE(2075),
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2500),
    [sym_array] = STATE(2846),
    [sym__call_signature] = STATE(2133),
    [sym_spread_element] = STATE(2500),
    [sym_string] = STATE(1815),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym_method_definition] = STATE(2500),
    [sym_pair] = STATE(2500),
    [sym__property_name] = STATE(1815),
    [sym_computed_property_name] = STATE(1815),
    [sym_method_signature] = STATE(2075),
    [sym_accessibility_modifier] = STATE(1766),
    [sym_call_signature] = STATE(2075),
    [sym_property_signature] = STATE(2075),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2075),
    [sym_index_signature] = STATE(2075),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_export] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3097),
    [anon_sym_type] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3099),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3101),
    [anon_sym_get] = ACTIONS(3103),
    [anon_sym_set] = ACTIONS(3103),
    [anon_sym_declare] = ACTIONS(3093),
    [anon_sym_public] = ACTIONS(3105),
    [anon_sym_private] = ACTIONS(3105),
    [anon_sym_protected] = ACTIONS(3105),
    [anon_sym_module] = ACTIONS(3093),
    [anon_sym_any] = ACTIONS(3093),
    [anon_sym_number] = ACTIONS(3093),
    [anon_sym_boolean] = ACTIONS(3093),
    [anon_sym_string] = ACTIONS(3093),
    [anon_sym_symbol] = ACTIONS(3093),
    [sym_readonly] = ACTIONS(3107),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3047),
  },
  [633] = {
    [sym_export_statement] = STATE(2075),
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2432),
    [sym_array] = STATE(2846),
    [sym__call_signature] = STATE(2133),
    [sym_spread_element] = STATE(2432),
    [sym_string] = STATE(1815),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym_method_definition] = STATE(2432),
    [sym_pair] = STATE(2432),
    [sym__property_name] = STATE(1815),
    [sym_computed_property_name] = STATE(1815),
    [sym_method_signature] = STATE(2075),
    [sym_accessibility_modifier] = STATE(1766),
    [sym_call_signature] = STATE(2075),
    [sym_property_signature] = STATE(2075),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2075),
    [sym_index_signature] = STATE(2075),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [aux_sym_object_repeat1] = STATE(2431),
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3109),
    [anon_sym_type] = ACTIONS(3049),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3059),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3049),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3061),
    [anon_sym_get] = ACTIONS(3063),
    [anon_sym_set] = ACTIONS(3063),
    [anon_sym_declare] = ACTIONS(3049),
    [anon_sym_public] = ACTIONS(3065),
    [anon_sym_private] = ACTIONS(3065),
    [anon_sym_protected] = ACTIONS(3065),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_any] = ACTIONS(3049),
    [anon_sym_number] = ACTIONS(3049),
    [anon_sym_boolean] = ACTIONS(3049),
    [anon_sym_string] = ACTIONS(3049),
    [anon_sym_symbol] = ACTIONS(3049),
    [sym_readonly] = ACTIONS(3067),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3047),
  },
  [634] = {
    [sym_nested_identifier] = STATE(482),
    [sym_string] = STATE(506),
    [sym__module] = STATE(517),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [635] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [636] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [637] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [638] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_implements] = ACTIONS(445),
  },
  [639] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym_arguments] = STATE(1440),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [640] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym_arguments] = STATE(1108),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(491),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
  },
  [641] = {
    [sym_nested_identifier] = STATE(1434),
    [sym_string] = STATE(1435),
    [sym__module] = STATE(1637),
    [sym_identifier] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2642),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [642] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [643] = {
    [sym_nested_identifier] = STATE(982),
    [sym_string] = STATE(985),
    [sym__module] = STATE(1217),
    [sym_identifier] = ACTIONS(3011),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_PLUS_EQ] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(650),
    [anon_sym_STAR_EQ] = ACTIONS(650),
    [anon_sym_SLASH_EQ] = ACTIONS(650),
    [anon_sym_PERCENT_EQ] = ACTIONS(650),
    [anon_sym_CARET_EQ] = ACTIONS(650),
    [anon_sym_AMP_EQ] = ACTIONS(650),
    [anon_sym_PIPE_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_LT_LT_EQ] = ACTIONS(650),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [644] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [645] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_template_string] = STATE(1413),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1411),
    [sym_constructor_type] = STATE(1411),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1411),
    [sym_intersection_type] = STATE(1411),
    [sym_function_type] = STATE(1411),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [646] = {
    [sym_export_statement] = STATE(2007),
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2586),
    [sym_array] = STATE(2846),
    [sym__call_signature] = STATE(2133),
    [sym_spread_element] = STATE(2586),
    [sym_string] = STATE(1815),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym_method_definition] = STATE(2586),
    [sym_pair] = STATE(2586),
    [sym__property_name] = STATE(1815),
    [sym_computed_property_name] = STATE(1815),
    [sym_method_signature] = STATE(2007),
    [sym_accessibility_modifier] = STATE(1766),
    [sym_call_signature] = STATE(2007),
    [sym_property_signature] = STATE(2007),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2007),
    [sym_index_signature] = STATE(2007),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3147),
    [anon_sym_export] = ACTIONS(3149),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3147),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3151),
    [anon_sym_RBRACE] = ACTIONS(3151),
    [anon_sym_type] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3153),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3147),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3155),
    [anon_sym_get] = ACTIONS(3157),
    [anon_sym_set] = ACTIONS(3157),
    [anon_sym_declare] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(3159),
    [anon_sym_private] = ACTIONS(3159),
    [anon_sym_protected] = ACTIONS(3159),
    [anon_sym_module] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3147),
    [anon_sym_number] = ACTIONS(3147),
    [anon_sym_boolean] = ACTIONS(3147),
    [anon_sym_string] = ACTIONS(3147),
    [anon_sym_symbol] = ACTIONS(3147),
    [sym_readonly] = ACTIONS(3161),
  },
  [647] = {
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [648] = {
    [sym_arguments] = STATE(1111),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3169),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_RBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_implements] = ACTIONS(3169),
  },
  [649] = {
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_EQ] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_of] = ACTIONS(2983),
    [anon_sym_COLON] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_DOT] = ACTIONS(2983),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2981),
    [anon_sym_STAR_STAR] = ACTIONS(2981),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2981),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2981),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_instanceof] = ACTIONS(2983),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2983),
    [anon_sym_implements] = ACTIONS(2983),
  },
  [650] = {
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [651] = {
    [sym__initializer] = STATE(2391),
    [sym_type_annotation] = STATE(2101),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3173),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3175),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3177),
    [anon_sym_of] = ACTIONS(3180),
    [anon_sym_SEMI] = ACTIONS(3175),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3186),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(3175),
  },
  [652] = {
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_of] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2979),
    [anon_sym_PLUS_EQ] = ACTIONS(2979),
    [anon_sym_DASH_EQ] = ACTIONS(2979),
    [anon_sym_STAR_EQ] = ACTIONS(2979),
    [anon_sym_SLASH_EQ] = ACTIONS(2979),
    [anon_sym_PERCENT_EQ] = ACTIONS(2979),
    [anon_sym_CARET_EQ] = ACTIONS(2979),
    [anon_sym_AMP_EQ] = ACTIONS(2979),
    [anon_sym_PIPE_EQ] = ACTIONS(2979),
    [anon_sym_GT_GT_EQ] = ACTIONS(2979),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_LT_EQ] = ACTIONS(2979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_STAR_STAR] = ACTIONS(2977),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_instanceof] = ACTIONS(2979),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2979),
    [anon_sym_implements] = ACTIONS(2979),
  },
  [653] = {
    [sym_type_arguments] = STATE(1856),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(3190),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_LT] = ACTIONS(3193),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3196),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_is] = ACTIONS(3205),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2486),
    [sym__automatic_semicolon] = ACTIONS(2486),
  },
  [654] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3209),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_RPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_of] = ACTIONS(3209),
    [anon_sym_COLON] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_RBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3209),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_implements] = ACTIONS(3209),
  },
  [655] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_of] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [656] = {
    [sym_export_statement] = STATE(2005),
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2586),
    [sym_array] = STATE(2846),
    [sym__call_signature] = STATE(2133),
    [sym_spread_element] = STATE(2586),
    [sym_string] = STATE(1815),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym_method_definition] = STATE(2586),
    [sym_pair] = STATE(2586),
    [sym__property_name] = STATE(1815),
    [sym_computed_property_name] = STATE(1815),
    [sym_method_signature] = STATE(2005),
    [sym_accessibility_modifier] = STATE(1766),
    [sym_call_signature] = STATE(2005),
    [sym_property_signature] = STATE(2005),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2005),
    [sym_index_signature] = STATE(2005),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3147),
    [anon_sym_export] = ACTIONS(3149),
    [anon_sym_STAR] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3147),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3151),
    [anon_sym_RBRACE] = ACTIONS(3151),
    [anon_sym_type] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3027),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3153),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3147),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3155),
    [anon_sym_get] = ACTIONS(3157),
    [anon_sym_set] = ACTIONS(3157),
    [anon_sym_declare] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(3159),
    [anon_sym_private] = ACTIONS(3159),
    [anon_sym_protected] = ACTIONS(3159),
    [anon_sym_module] = ACTIONS(3147),
    [anon_sym_any] = ACTIONS(3147),
    [anon_sym_number] = ACTIONS(3147),
    [anon_sym_boolean] = ACTIONS(3147),
    [anon_sym_string] = ACTIONS(3147),
    [anon_sym_symbol] = ACTIONS(3147),
    [sym_readonly] = ACTIONS(3161),
  },
  [657] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_template_string] = STATE(1531),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1529),
    [sym_constructor_type] = STATE(1529),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1529),
    [sym_intersection_type] = STATE(1529),
    [sym_function_type] = STATE(1529),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [658] = {
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_EQ] = ACTIONS(3245),
    [anon_sym_as] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_COMMA] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_RPAREN] = ACTIONS(3247),
    [anon_sym_in] = ACTIONS(3245),
    [anon_sym_of] = ACTIONS(3247),
    [anon_sym_COLON] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_RBRACK] = ACTIONS(3247),
    [anon_sym_LT] = ACTIONS(3245),
    [anon_sym_GT] = ACTIONS(3245),
    [anon_sym_SLASH] = ACTIONS(3245),
    [anon_sym_DOT] = ACTIONS(3247),
    [anon_sym_PLUS_EQ] = ACTIONS(3247),
    [anon_sym_DASH_EQ] = ACTIONS(3247),
    [anon_sym_STAR_EQ] = ACTIONS(3247),
    [anon_sym_SLASH_EQ] = ACTIONS(3247),
    [anon_sym_PERCENT_EQ] = ACTIONS(3247),
    [anon_sym_CARET_EQ] = ACTIONS(3247),
    [anon_sym_AMP_EQ] = ACTIONS(3247),
    [anon_sym_PIPE_EQ] = ACTIONS(3247),
    [anon_sym_GT_GT_EQ] = ACTIONS(3247),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3247),
    [anon_sym_LT_LT_EQ] = ACTIONS(3247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3247),
    [anon_sym_QMARK] = ACTIONS(3247),
    [anon_sym_AMP_AMP] = ACTIONS(3247),
    [anon_sym_PIPE_PIPE] = ACTIONS(3247),
    [anon_sym_GT_GT] = ACTIONS(3245),
    [anon_sym_GT_GT_GT] = ACTIONS(3245),
    [anon_sym_LT_LT] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym_CARET] = ACTIONS(3245),
    [anon_sym_PIPE] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_PERCENT] = ACTIONS(3245),
    [anon_sym_STAR_STAR] = ACTIONS(3245),
    [anon_sym_LT_EQ] = ACTIONS(3247),
    [anon_sym_EQ_EQ] = ACTIONS(3245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3247),
    [anon_sym_BANG_EQ] = ACTIONS(3245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3247),
    [anon_sym_GT_EQ] = ACTIONS(3247),
    [anon_sym_instanceof] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3247),
    [anon_sym_implements] = ACTIONS(3247),
  },
  [659] = {
    [sym_nested_identifier] = STATE(969),
    [sym_string] = STATE(968),
    [sym__module] = STATE(1003),
    [sym_identifier] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [660] = {
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [661] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_template_string] = STATE(1120),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1123),
    [sym_constructor_type] = STATE(1123),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1123),
    [sym_intersection_type] = STATE(1123),
    [sym_function_type] = STATE(1123),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [662] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_RPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_of] = ACTIONS(3285),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_RBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_implements] = ACTIONS(3285),
  },
  [663] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3290),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_is] = ACTIONS(3292),
  },
  [664] = {
    [aux_sym_object_repeat1] = STATE(2538),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [665] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3300),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [666] = {
    [aux_sym_object_repeat1] = STATE(2538),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [667] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3320),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [668] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [669] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2553),
    [sym_constructor_type] = STATE(2553),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2553),
    [sym_intersection_type] = STATE(2553),
    [sym_function_type] = STATE(2553),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_RBRACK] = ACTIONS(3324),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [670] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [671] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_RPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_RBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_implements] = ACTIONS(3285),
  },
  [672] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3337),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [673] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3339),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [674] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3341),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [675] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3343),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [676] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3345),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [677] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2090),
    [sym_constructor_type] = STATE(2090),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_type_parameter] = STATE(2399),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2090),
    [sym_intersection_type] = STATE(2090),
    [sym_function_type] = STATE(2090),
    [sym_identifier] = ACTIONS(3347),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [678] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2544),
    [sym_constructor_type] = STATE(2544),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2544),
    [sym_intersection_type] = STATE(2544),
    [sym_function_type] = STATE(2544),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_RBRACK] = ACTIONS(3349),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [679] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3353),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_is] = ACTIONS(3292),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [680] = {
    [aux_sym_object_repeat1] = STATE(2556),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [681] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2523),
    [sym_constructor_type] = STATE(2523),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2523),
    [sym_intersection_type] = STATE(2523),
    [sym_function_type] = STATE(2523),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_RBRACK] = ACTIONS(3355),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [682] = {
    [sym_arguments] = STATE(1111),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3169),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_RBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
  },
  [683] = {
    [aux_sym_object_repeat1] = STATE(2556),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [684] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3357),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [685] = {
    [aux_sym_object_repeat1] = STATE(2396),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3306),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3311),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [686] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2477),
    [sym_constructor_type] = STATE(2477),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2477),
    [sym_intersection_type] = STATE(2477),
    [sym_function_type] = STATE(2477),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_RBRACK] = ACTIONS(3359),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [687] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3361),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [688] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_RPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_RBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_implements] = ACTIONS(3285),
  },
  [689] = {
    [sym_arguments] = STATE(1108),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(499),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
  },
  [690] = {
    [aux_sym_object_repeat1] = STATE(2396),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(447),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(476),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [691] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2438),
    [sym_constructor_type] = STATE(2438),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2438),
    [sym_intersection_type] = STATE(2438),
    [sym_function_type] = STATE(2438),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_RBRACK] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [692] = {
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_EQ] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_COMMA] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_RPAREN] = ACTIONS(3370),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_RBRACK] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_DOT] = ACTIONS(3370),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_PIPE_PIPE] = ACTIONS(3370),
    [anon_sym_GT_GT] = ACTIONS(3368),
    [anon_sym_GT_GT_GT] = ACTIONS(3368),
    [anon_sym_LT_LT] = ACTIONS(3368),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_CARET] = ACTIONS(3368),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3368),
    [anon_sym_STAR_STAR] = ACTIONS(3368),
    [anon_sym_LT_EQ] = ACTIONS(3370),
    [anon_sym_EQ_EQ] = ACTIONS(3368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3370),
    [anon_sym_BANG_EQ] = ACTIONS(3368),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3370),
    [anon_sym_GT_EQ] = ACTIONS(3370),
    [anon_sym_instanceof] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [anon_sym_implements] = ACTIONS(3370),
  },
  [693] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(3372),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [694] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(442),
    [sym_constructor_type] = STATE(442),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(442),
    [sym_intersection_type] = STATE(442),
    [sym_function_type] = STATE(442),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [695] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1069),
    [sym_constructor_type] = STATE(1069),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1069),
    [sym_intersection_type] = STATE(1069),
    [sym_function_type] = STATE(1069),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [696] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(435),
    [sym_constructor_type] = STATE(435),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(435),
    [sym_intersection_type] = STATE(435),
    [sym_function_type] = STATE(435),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [697] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(430),
    [sym_constructor_type] = STATE(430),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(430),
    [sym_intersection_type] = STATE(430),
    [sym_function_type] = STATE(430),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [698] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2404),
    [sym_constructor_type] = STATE(2404),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2404),
    [sym_intersection_type] = STATE(2404),
    [sym_function_type] = STATE(2404),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [699] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1895),
    [sym_constructor_type] = STATE(1895),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1895),
    [sym_intersection_type] = STATE(1895),
    [sym_function_type] = STATE(1895),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [700] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(1991),
    [sym_constructor_type] = STATE(1991),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(1991),
    [sym_intersection_type] = STATE(1991),
    [sym_function_type] = STATE(1991),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [701] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1893),
    [sym_constructor_type] = STATE(1893),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1893),
    [sym_intersection_type] = STATE(1893),
    [sym_function_type] = STATE(1893),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [702] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2313),
    [sym_constructor_type] = STATE(2313),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2313),
    [sym_intersection_type] = STATE(2313),
    [sym_function_type] = STATE(2313),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [703] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1859),
    [sym_constructor_type] = STATE(1859),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1859),
    [sym_intersection_type] = STATE(1859),
    [sym_function_type] = STATE(1859),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [704] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1861),
    [sym_constructor_type] = STATE(1861),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1861),
    [sym_intersection_type] = STATE(1861),
    [sym_function_type] = STATE(1861),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [705] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1385),
    [sym_constructor_type] = STATE(1385),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1385),
    [sym_intersection_type] = STATE(1385),
    [sym_function_type] = STATE(1385),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [706] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1386),
    [sym_constructor_type] = STATE(1386),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1386),
    [sym_intersection_type] = STATE(1386),
    [sym_function_type] = STATE(1386),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [707] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2245),
    [sym_constructor_type] = STATE(2245),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2245),
    [sym_intersection_type] = STATE(2245),
    [sym_function_type] = STATE(2245),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [708] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(1834),
    [sym_constructor_type] = STATE(1834),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(1834),
    [sym_intersection_type] = STATE(1834),
    [sym_function_type] = STATE(1834),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [709] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(2368),
    [sym_constructor_type] = STATE(2368),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(2368),
    [sym_intersection_type] = STATE(2368),
    [sym_function_type] = STATE(2368),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [710] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(439),
    [sym_constructor_type] = STATE(439),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(439),
    [sym_intersection_type] = STATE(439),
    [sym_function_type] = STATE(439),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [711] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2090),
    [sym_constructor_type] = STATE(2090),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2090),
    [sym_intersection_type] = STATE(2090),
    [sym_function_type] = STATE(2090),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [712] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(2322),
    [sym_constructor_type] = STATE(2322),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(2322),
    [sym_intersection_type] = STATE(2322),
    [sym_function_type] = STATE(2322),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [713] = {
    [sym_arguments] = STATE(1438),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [sym__automatic_semicolon] = ACTIONS(3169),
  },
  [714] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(1830),
    [sym_constructor_type] = STATE(1830),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(1830),
    [sym_intersection_type] = STATE(1830),
    [sym_function_type] = STATE(1830),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [715] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(3412),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3416),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_is] = ACTIONS(3292),
  },
  [716] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1877),
    [sym_constructor_type] = STATE(1877),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1877),
    [sym_intersection_type] = STATE(1877),
    [sym_function_type] = STATE(1877),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [717] = {
    [sym_type_arguments] = STATE(416),
    [aux_sym_extends_clause_repeat1] = STATE(2370),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(3420),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3424),
    [anon_sym_EQ_GT] = ACTIONS(3426),
    [anon_sym_PLUS_EQ] = ACTIONS(3428),
    [anon_sym_DASH_EQ] = ACTIONS(3428),
    [anon_sym_STAR_EQ] = ACTIONS(3428),
    [anon_sym_SLASH_EQ] = ACTIONS(3428),
    [anon_sym_PERCENT_EQ] = ACTIONS(3428),
    [anon_sym_CARET_EQ] = ACTIONS(3428),
    [anon_sym_AMP_EQ] = ACTIONS(3428),
    [anon_sym_PIPE_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_LT_LT_EQ] = ACTIONS(3428),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3428),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(3420),
  },
  [718] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(1828),
    [sym_constructor_type] = STATE(1828),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(1828),
    [sym_intersection_type] = STATE(1828),
    [sym_function_type] = STATE(1828),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [719] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1887),
    [sym_constructor_type] = STATE(1887),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1887),
    [sym_intersection_type] = STATE(1887),
    [sym_function_type] = STATE(1887),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [720] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [721] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2224),
    [sym_constructor_type] = STATE(2224),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2224),
    [sym_intersection_type] = STATE(2224),
    [sym_function_type] = STATE(2224),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [722] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1858),
    [sym_constructor_type] = STATE(1858),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1858),
    [sym_intersection_type] = STATE(1858),
    [sym_function_type] = STATE(1858),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [723] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2542),
    [sym_constructor_type] = STATE(2542),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2542),
    [sym_intersection_type] = STATE(2542),
    [sym_function_type] = STATE(2542),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [724] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3430),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3432),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3436),
    [anon_sym_DASH_EQ] = ACTIONS(3436),
    [anon_sym_STAR_EQ] = ACTIONS(3436),
    [anon_sym_SLASH_EQ] = ACTIONS(3436),
    [anon_sym_PERCENT_EQ] = ACTIONS(3436),
    [anon_sym_CARET_EQ] = ACTIONS(3436),
    [anon_sym_AMP_EQ] = ACTIONS(3436),
    [anon_sym_PIPE_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_LT_LT_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3436),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_is] = ACTIONS(3292),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [725] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2256),
    [sym_constructor_type] = STATE(2256),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2256),
    [sym_intersection_type] = STATE(2256),
    [sym_function_type] = STATE(2256),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [726] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2513),
    [sym_constructor_type] = STATE(2513),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2513),
    [sym_intersection_type] = STATE(2513),
    [sym_function_type] = STATE(2513),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [727] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2285),
    [sym_constructor_type] = STATE(2285),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2285),
    [sym_intersection_type] = STATE(2285),
    [sym_function_type] = STATE(2285),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [728] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1648),
    [sym_constructor_type] = STATE(1648),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1648),
    [sym_intersection_type] = STATE(1648),
    [sym_function_type] = STATE(1648),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [729] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1663),
    [sym_constructor_type] = STATE(1663),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1663),
    [sym_intersection_type] = STATE(1663),
    [sym_function_type] = STATE(1663),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [730] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1535),
    [sym_constructor_type] = STATE(1535),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1535),
    [sym_intersection_type] = STATE(1535),
    [sym_function_type] = STATE(1535),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [731] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_PIPE_RBRACE] = ACTIONS(589),
    [sym__automatic_semicolon] = ACTIONS(589),
  },
  [732] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(2340),
    [sym_constructor_type] = STATE(2340),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(2340),
    [sym_intersection_type] = STATE(2340),
    [sym_function_type] = STATE(2340),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [733] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1626),
    [sym_constructor_type] = STATE(1626),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1626),
    [sym_intersection_type] = STATE(1626),
    [sym_function_type] = STATE(1626),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [734] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2406),
    [sym_constructor_type] = STATE(2406),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2406),
    [sym_intersection_type] = STATE(2406),
    [sym_function_type] = STATE(2406),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [735] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1854),
    [sym_constructor_type] = STATE(1854),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1854),
    [sym_intersection_type] = STATE(1854),
    [sym_function_type] = STATE(1854),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [736] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2298),
    [sym_constructor_type] = STATE(2298),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2298),
    [sym_intersection_type] = STATE(2298),
    [sym_function_type] = STATE(2298),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [737] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1622),
    [sym_constructor_type] = STATE(1622),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1622),
    [sym_intersection_type] = STATE(1622),
    [sym_function_type] = STATE(1622),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [738] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1587),
    [sym_constructor_type] = STATE(1587),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1587),
    [sym_intersection_type] = STATE(1587),
    [sym_function_type] = STATE(1587),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [739] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1591),
    [sym_constructor_type] = STATE(1591),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1591),
    [sym_intersection_type] = STATE(1591),
    [sym_function_type] = STATE(1591),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [740] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1464),
    [sym_constructor_type] = STATE(1464),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1464),
    [sym_intersection_type] = STATE(1464),
    [sym_function_type] = STATE(1464),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [741] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2095),
    [sym_constructor_type] = STATE(2095),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2095),
    [sym_intersection_type] = STATE(2095),
    [sym_function_type] = STATE(2095),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [742] = {
    [sym_arguments] = STATE(1440),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [743] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(2303),
    [sym_constructor_type] = STATE(2303),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(2303),
    [sym_intersection_type] = STATE(2303),
    [sym_function_type] = STATE(2303),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [744] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1853),
    [sym_constructor_type] = STATE(1853),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1853),
    [sym_intersection_type] = STATE(1853),
    [sym_function_type] = STATE(1853),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [745] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [746] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2171),
    [sym_constructor_type] = STATE(2171),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2171),
    [sym_intersection_type] = STATE(2171),
    [sym_function_type] = STATE(2171),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [747] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(474),
    [sym_constructor_type] = STATE(474),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(474),
    [sym_intersection_type] = STATE(474),
    [sym_function_type] = STATE(474),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [748] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(478),
    [sym_constructor_type] = STATE(478),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(478),
    [sym_intersection_type] = STATE(478),
    [sym_function_type] = STATE(478),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [749] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3440),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2342),
    [sym__automatic_semicolon] = ACTIONS(2342),
  },
  [750] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1942),
    [sym_constructor_type] = STATE(1942),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1942),
    [sym_intersection_type] = STATE(1942),
    [sym_function_type] = STATE(1942),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [751] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(471),
    [sym_constructor_type] = STATE(471),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(471),
    [sym_intersection_type] = STATE(471),
    [sym_function_type] = STATE(471),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [752] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2006),
    [sym_constructor_type] = STATE(2006),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2006),
    [sym_intersection_type] = STATE(2006),
    [sym_function_type] = STATE(2006),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [753] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [754] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1521),
    [sym_constructor_type] = STATE(1521),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1521),
    [sym_intersection_type] = STATE(1521),
    [sym_function_type] = STATE(1521),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [755] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(1840),
    [sym_constructor_type] = STATE(1840),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(1840),
    [sym_intersection_type] = STATE(1840),
    [sym_function_type] = STATE(1840),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [756] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1518),
    [sym_constructor_type] = STATE(1518),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1518),
    [sym_intersection_type] = STATE(1518),
    [sym_function_type] = STATE(1518),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [757] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(480),
    [sym_constructor_type] = STATE(480),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(480),
    [sym_intersection_type] = STATE(480),
    [sym_function_type] = STATE(480),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [758] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2243),
    [sym_constructor_type] = STATE(2243),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2243),
    [sym_intersection_type] = STATE(2243),
    [sym_function_type] = STATE(2243),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [759] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2279),
    [sym_constructor_type] = STATE(2279),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2279),
    [sym_intersection_type] = STATE(2279),
    [sym_function_type] = STATE(2279),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [760] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_formal_parameters] = STATE(2896),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__type] = STATE(1899),
    [sym_constructor_type] = STATE(1899),
    [sym__primary_type] = STATE(1876),
    [sym_generic_type] = STATE(1876),
    [sym_type_predicate] = STATE(1876),
    [sym_type_query] = STATE(1876),
    [sym_index_type_query] = STATE(1876),
    [sym_lookup_type] = STATE(1876),
    [sym_literal_type] = STATE(1876),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1876),
    [sym_flow_maybe_type] = STATE(1876),
    [sym_parenthesized_type] = STATE(1876),
    [sym_predefined_type] = STATE(1876),
    [sym_object_type] = STATE(1876),
    [sym_type_parameters] = STATE(2621),
    [sym_array_type] = STATE(1876),
    [sym_tuple_type] = STATE(1876),
    [sym_union_type] = STATE(1899),
    [sym_intersection_type] = STATE(1899),
    [sym_function_type] = STATE(1899),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3402),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [761] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2230),
    [sym_constructor_type] = STATE(2230),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2230),
    [sym_intersection_type] = STATE(2230),
    [sym_function_type] = STATE(2230),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [762] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3444),
    [anon_sym_EQ_GT] = ACTIONS(3446),
    [anon_sym_PLUS_EQ] = ACTIONS(3448),
    [anon_sym_DASH_EQ] = ACTIONS(3448),
    [anon_sym_STAR_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_PERCENT_EQ] = ACTIONS(3448),
    [anon_sym_CARET_EQ] = ACTIONS(3448),
    [anon_sym_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_LT_LT_EQ] = ACTIONS(3448),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3448),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_is] = ACTIONS(3292),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [763] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1021),
    [sym_constructor_type] = STATE(1021),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1021),
    [sym_intersection_type] = STATE(1021),
    [sym_function_type] = STATE(1021),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [764] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(439),
    [sym_constructor_type] = STATE(439),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(439),
    [sym_intersection_type] = STATE(439),
    [sym_function_type] = STATE(439),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [765] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1025),
    [sym_constructor_type] = STATE(1025),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1025),
    [sym_intersection_type] = STATE(1025),
    [sym_function_type] = STATE(1025),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [766] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [767] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [768] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2111),
    [sym_constructor_type] = STATE(2111),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2111),
    [sym_intersection_type] = STATE(2111),
    [sym_function_type] = STATE(2111),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [769] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(442),
    [sym_constructor_type] = STATE(442),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(442),
    [sym_intersection_type] = STATE(442),
    [sym_function_type] = STATE(442),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [770] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(477),
    [sym_constructor_type] = STATE(477),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(477),
    [sym_intersection_type] = STATE(477),
    [sym_function_type] = STATE(477),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [771] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(1831),
    [sym_constructor_type] = STATE(1831),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(1831),
    [sym_intersection_type] = STATE(1831),
    [sym_function_type] = STATE(1831),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [772] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2842),
    [sym_nested_type_identifier] = STATE(459),
    [sym__type] = STATE(479),
    [sym_constructor_type] = STATE(479),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2765),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(479),
    [sym_intersection_type] = STATE(479),
    [sym_function_type] = STATE(479),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3376),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [773] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [774] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2116),
    [sym_constructor_type] = STATE(2116),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2116),
    [sym_intersection_type] = STATE(2116),
    [sym_function_type] = STATE(2116),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [775] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1071),
    [sym_constructor_type] = STATE(1071),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1071),
    [sym_intersection_type] = STATE(1071),
    [sym_function_type] = STATE(1071),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [776] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1078),
    [sym_constructor_type] = STATE(1078),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1078),
    [sym_intersection_type] = STATE(1078),
    [sym_function_type] = STATE(1078),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [777] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1080),
    [sym_constructor_type] = STATE(1080),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1080),
    [sym_intersection_type] = STATE(1080),
    [sym_function_type] = STATE(1080),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [778] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3450),
    [anon_sym_EQ_GT] = ACTIONS(3186),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_is] = ACTIONS(3292),
  },
  [779] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1578),
    [sym_constructor_type] = STATE(1578),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1578),
    [sym_intersection_type] = STATE(1578),
    [sym_function_type] = STATE(1578),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [780] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2501),
    [sym_constructor_type] = STATE(2501),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2501),
    [sym_intersection_type] = STATE(2501),
    [sym_function_type] = STATE(2501),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [781] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3290),
    [anon_sym_EQ_GT] = ACTIONS(3426),
    [anon_sym_PLUS_EQ] = ACTIONS(3428),
    [anon_sym_DASH_EQ] = ACTIONS(3428),
    [anon_sym_STAR_EQ] = ACTIONS(3428),
    [anon_sym_SLASH_EQ] = ACTIONS(3428),
    [anon_sym_PERCENT_EQ] = ACTIONS(3428),
    [anon_sym_CARET_EQ] = ACTIONS(3428),
    [anon_sym_AMP_EQ] = ACTIONS(3428),
    [anon_sym_PIPE_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_LT_LT_EQ] = ACTIONS(3428),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3428),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(1123),
    [anon_sym_is] = ACTIONS(3292),
  },
  [782] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_formal_parameters] = STATE(2830),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__type] = STATE(1573),
    [sym_constructor_type] = STATE(1573),
    [sym__primary_type] = STATE(1542),
    [sym_generic_type] = STATE(1542),
    [sym_type_predicate] = STATE(1542),
    [sym_type_query] = STATE(1542),
    [sym_index_type_query] = STATE(1542),
    [sym_lookup_type] = STATE(1542),
    [sym_literal_type] = STATE(1542),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1542),
    [sym_flow_maybe_type] = STATE(1542),
    [sym_parenthesized_type] = STATE(1542),
    [sym_predefined_type] = STATE(1542),
    [sym_object_type] = STATE(1542),
    [sym_type_parameters] = STATE(2759),
    [sym_array_type] = STATE(1542),
    [sym_tuple_type] = STATE(1542),
    [sym_union_type] = STATE(1573),
    [sym_intersection_type] = STATE(1573),
    [sym_function_type] = STATE(1573),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_AMP] = ACTIONS(3227),
    [anon_sym_PIPE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3237),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [783] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2097),
    [sym_constructor_type] = STATE(2097),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2097),
    [sym_intersection_type] = STATE(2097),
    [sym_function_type] = STATE(2097),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [784] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(435),
    [sym_constructor_type] = STATE(435),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(435),
    [sym_intersection_type] = STATE(435),
    [sym_function_type] = STATE(435),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [785] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(430),
    [sym_constructor_type] = STATE(430),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(430),
    [sym_intersection_type] = STATE(430),
    [sym_function_type] = STATE(430),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [786] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1088),
    [sym_constructor_type] = STATE(1088),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1088),
    [sym_intersection_type] = STATE(1088),
    [sym_function_type] = STATE(1088),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [787] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1094),
    [sym_constructor_type] = STATE(1094),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1094),
    [sym_intersection_type] = STATE(1094),
    [sym_function_type] = STATE(1094),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [788] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_formal_parameters] = STATE(2774),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__type] = STATE(2466),
    [sym_constructor_type] = STATE(2466),
    [sym__primary_type] = STATE(425),
    [sym_generic_type] = STATE(425),
    [sym_type_predicate] = STATE(425),
    [sym_type_query] = STATE(425),
    [sym_index_type_query] = STATE(425),
    [sym_lookup_type] = STATE(425),
    [sym_literal_type] = STATE(425),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(425),
    [sym_flow_maybe_type] = STATE(425),
    [sym_parenthesized_type] = STATE(425),
    [sym_predefined_type] = STATE(425),
    [sym_object_type] = STATE(425),
    [sym_type_parameters] = STATE(2749),
    [sym_array_type] = STATE(425),
    [sym_tuple_type] = STATE(425),
    [sym_union_type] = STATE(2466),
    [sym_intersection_type] = STATE(2466),
    [sym_function_type] = STATE(2466),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(2521),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_AMP] = ACTIONS(789),
    [anon_sym_PIPE] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3304),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [789] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_formal_parameters] = STATE(2857),
    [sym_nested_type_identifier] = STATE(942),
    [sym__type] = STATE(1098),
    [sym_constructor_type] = STATE(1098),
    [sym__primary_type] = STATE(1010),
    [sym_generic_type] = STATE(1010),
    [sym_type_predicate] = STATE(1010),
    [sym_type_query] = STATE(1010),
    [sym_index_type_query] = STATE(1010),
    [sym_lookup_type] = STATE(1010),
    [sym_literal_type] = STATE(1010),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1010),
    [sym_flow_maybe_type] = STATE(1010),
    [sym_parenthesized_type] = STATE(1010),
    [sym_predefined_type] = STATE(1010),
    [sym_object_type] = STATE(1010),
    [sym_type_parameters] = STATE(2741),
    [sym_array_type] = STATE(1010),
    [sym_tuple_type] = STATE(1010),
    [sym_union_type] = STATE(1098),
    [sym_intersection_type] = STATE(1098),
    [sym_function_type] = STATE(1098),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_AMP] = ACTIONS(3265),
    [anon_sym_PIPE] = ACTIONS(3267),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3275),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [790] = {
    [sym_type_arguments] = STATE(2452),
    [aux_sym_extends_clause_repeat1] = STATE(2332),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3430),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(3452),
    [anon_sym_COMMA] = ACTIONS(3454),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3436),
    [anon_sym_DASH_EQ] = ACTIONS(3436),
    [anon_sym_STAR_EQ] = ACTIONS(3436),
    [anon_sym_SLASH_EQ] = ACTIONS(3436),
    [anon_sym_PERCENT_EQ] = ACTIONS(3436),
    [anon_sym_CARET_EQ] = ACTIONS(3436),
    [anon_sym_AMP_EQ] = ACTIONS(3436),
    [anon_sym_PIPE_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_LT_LT_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3436),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3420),
  },
  [791] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1481),
    [sym_constructor_type] = STATE(1481),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1481),
    [sym_intersection_type] = STATE(1481),
    [sym_function_type] = STATE(1481),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [792] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1480),
    [sym_constructor_type] = STATE(1480),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1480),
    [sym_intersection_type] = STATE(1480),
    [sym_function_type] = STATE(1480),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [793] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1478),
    [sym_constructor_type] = STATE(1478),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1478),
    [sym_intersection_type] = STATE(1478),
    [sym_function_type] = STATE(1478),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [794] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_formal_parameters] = STATE(2939),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__type] = STATE(1477),
    [sym_constructor_type] = STATE(1477),
    [sym__primary_type] = STATE(1400),
    [sym_generic_type] = STATE(1400),
    [sym_type_predicate] = STATE(1400),
    [sym_type_query] = STATE(1400),
    [sym_index_type_query] = STATE(1400),
    [sym_lookup_type] = STATE(1400),
    [sym_literal_type] = STATE(1400),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1400),
    [sym_flow_maybe_type] = STATE(1400),
    [sym_parenthesized_type] = STATE(1400),
    [sym_predefined_type] = STATE(1400),
    [sym_object_type] = STATE(1400),
    [sym_type_parameters] = STATE(2569),
    [sym_array_type] = STATE(1400),
    [sym_tuple_type] = STATE(1400),
    [sym_union_type] = STATE(1477),
    [sym_intersection_type] = STATE(1477),
    [sym_function_type] = STATE(1477),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_new] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3139),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [795] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [796] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1233),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [797] = {
    [sym_arguments] = STATE(1557),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3169),
  },
  [798] = {
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_of] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2979),
    [anon_sym_PLUS_EQ] = ACTIONS(2979),
    [anon_sym_DASH_EQ] = ACTIONS(2979),
    [anon_sym_STAR_EQ] = ACTIONS(2979),
    [anon_sym_SLASH_EQ] = ACTIONS(2979),
    [anon_sym_PERCENT_EQ] = ACTIONS(2979),
    [anon_sym_CARET_EQ] = ACTIONS(2979),
    [anon_sym_AMP_EQ] = ACTIONS(2979),
    [anon_sym_PIPE_EQ] = ACTIONS(2979),
    [anon_sym_GT_GT_EQ] = ACTIONS(2979),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_LT_EQ] = ACTIONS(2979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_STAR_STAR] = ACTIONS(2977),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_instanceof] = ACTIONS(2979),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2979),
    [sym__automatic_semicolon] = ACTIONS(2979),
  },
  [799] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [800] = {
    [sym_arguments] = STATE(1568),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2642),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(499),
  },
  [801] = {
    [sym_type_annotation] = STATE(2678),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3463),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(3463),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [802] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(3468),
  },
  [803] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(3470),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3424),
    [anon_sym_EQ_GT] = ACTIONS(3426),
    [anon_sym_PLUS_EQ] = ACTIONS(3428),
    [anon_sym_DASH_EQ] = ACTIONS(3428),
    [anon_sym_STAR_EQ] = ACTIONS(3428),
    [anon_sym_SLASH_EQ] = ACTIONS(3428),
    [anon_sym_PERCENT_EQ] = ACTIONS(3428),
    [anon_sym_CARET_EQ] = ACTIONS(3428),
    [anon_sym_AMP_EQ] = ACTIONS(3428),
    [anon_sym_PIPE_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_LT_LT_EQ] = ACTIONS(3428),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3428),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(3470),
  },
  [804] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(3472),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [805] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [806] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2338),
    [sym__automatic_semicolon] = ACTIONS(2338),
  },
  [807] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [808] = {
    [sym_arguments] = STATE(1438),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [sym__automatic_semicolon] = ACTIONS(3169),
  },
  [809] = {
    [sym_arguments] = STATE(1108),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [anon_sym_implements] = ACTIONS(499),
  },
  [810] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(591),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_PLUS_EQ] = ACTIONS(474),
    [anon_sym_DASH_EQ] = ACTIONS(474),
    [anon_sym_STAR_EQ] = ACTIONS(474),
    [anon_sym_SLASH_EQ] = ACTIONS(474),
    [anon_sym_PERCENT_EQ] = ACTIONS(474),
    [anon_sym_CARET_EQ] = ACTIONS(474),
    [anon_sym_AMP_EQ] = ACTIONS(474),
    [anon_sym_PIPE_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_LT_EQ] = ACTIONS(474),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [811] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(3474),
  },
  [812] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [813] = {
    [sym_arguments] = STATE(1111),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3426),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_implements] = ACTIONS(3169),
  },
  [814] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_of] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym__automatic_semicolon] = ACTIONS(3285),
  },
  [815] = {
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_EQ] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_of] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_DOT] = ACTIONS(2983),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2981),
    [anon_sym_STAR_STAR] = ACTIONS(2981),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2981),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2981),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_instanceof] = ACTIONS(2983),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2983),
    [sym__automatic_semicolon] = ACTIONS(2983),
  },
  [816] = {
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_EQ] = ACTIONS(3245),
    [anon_sym_as] = ACTIONS(3247),
    [anon_sym_COMMA] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_in] = ACTIONS(3245),
    [anon_sym_of] = ACTIONS(3247),
    [anon_sym_SEMI] = ACTIONS(3247),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LT] = ACTIONS(3245),
    [anon_sym_GT] = ACTIONS(3245),
    [anon_sym_SLASH] = ACTIONS(3245),
    [anon_sym_DOT] = ACTIONS(3247),
    [anon_sym_PLUS_EQ] = ACTIONS(3247),
    [anon_sym_DASH_EQ] = ACTIONS(3247),
    [anon_sym_STAR_EQ] = ACTIONS(3247),
    [anon_sym_SLASH_EQ] = ACTIONS(3247),
    [anon_sym_PERCENT_EQ] = ACTIONS(3247),
    [anon_sym_CARET_EQ] = ACTIONS(3247),
    [anon_sym_AMP_EQ] = ACTIONS(3247),
    [anon_sym_PIPE_EQ] = ACTIONS(3247),
    [anon_sym_GT_GT_EQ] = ACTIONS(3247),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3247),
    [anon_sym_LT_LT_EQ] = ACTIONS(3247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3247),
    [anon_sym_QMARK] = ACTIONS(3247),
    [anon_sym_AMP_AMP] = ACTIONS(3247),
    [anon_sym_PIPE_PIPE] = ACTIONS(3247),
    [anon_sym_GT_GT] = ACTIONS(3245),
    [anon_sym_GT_GT_GT] = ACTIONS(3245),
    [anon_sym_LT_LT] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym_CARET] = ACTIONS(3245),
    [anon_sym_PIPE] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_PERCENT] = ACTIONS(3245),
    [anon_sym_STAR_STAR] = ACTIONS(3245),
    [anon_sym_LT_EQ] = ACTIONS(3247),
    [anon_sym_EQ_EQ] = ACTIONS(3245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3247),
    [anon_sym_BANG_EQ] = ACTIONS(3245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3247),
    [anon_sym_GT_EQ] = ACTIONS(3247),
    [anon_sym_instanceof] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3247),
    [sym__automatic_semicolon] = ACTIONS(3247),
  },
  [817] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3476),
    [anon_sym_of] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [818] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3481),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [819] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [820] = {
    [sym_type_arguments] = STATE(2452),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3430),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(3483),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3459),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3436),
    [anon_sym_DASH_EQ] = ACTIONS(3436),
    [anon_sym_STAR_EQ] = ACTIONS(3436),
    [anon_sym_SLASH_EQ] = ACTIONS(3436),
    [anon_sym_PERCENT_EQ] = ACTIONS(3436),
    [anon_sym_CARET_EQ] = ACTIONS(3436),
    [anon_sym_AMP_EQ] = ACTIONS(3436),
    [anon_sym_PIPE_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_LT_LT_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3436),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3470),
  },
  [821] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_COMMA] = ACTIONS(3209),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_of] = ACTIONS(3209),
    [anon_sym_SEMI] = ACTIONS(3209),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3209),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [sym__automatic_semicolon] = ACTIONS(3209),
  },
  [822] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3190),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(3190),
    [anon_sym_RBRACK] = ACTIONS(3190),
    [anon_sym_LT] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3485),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_is] = ACTIONS(3292),
  },
  [823] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [824] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym__automatic_semicolon] = ACTIONS(3285),
  },
  [825] = {
    [sym_arguments] = STATE(1438),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3446),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [sym__automatic_semicolon] = ACTIONS(3169),
  },
  [826] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [827] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [828] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3430),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3487),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3436),
    [anon_sym_DASH_EQ] = ACTIONS(3436),
    [anon_sym_STAR_EQ] = ACTIONS(3436),
    [anon_sym_SLASH_EQ] = ACTIONS(3436),
    [anon_sym_PERCENT_EQ] = ACTIONS(3436),
    [anon_sym_CARET_EQ] = ACTIONS(3436),
    [anon_sym_AMP_EQ] = ACTIONS(3436),
    [anon_sym_PIPE_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_LT_LT_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3436),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [829] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_COLON] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [830] = {
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_EQ] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(3370),
    [anon_sym_COMMA] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_DOT] = ACTIONS(3370),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_PIPE_PIPE] = ACTIONS(3370),
    [anon_sym_GT_GT] = ACTIONS(3368),
    [anon_sym_GT_GT_GT] = ACTIONS(3368),
    [anon_sym_LT_LT] = ACTIONS(3368),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_CARET] = ACTIONS(3368),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3368),
    [anon_sym_STAR_STAR] = ACTIONS(3368),
    [anon_sym_LT_EQ] = ACTIONS(3370),
    [anon_sym_EQ_EQ] = ACTIONS(3368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3370),
    [anon_sym_BANG_EQ] = ACTIONS(3368),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3370),
    [anon_sym_GT_EQ] = ACTIONS(3370),
    [anon_sym_instanceof] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [sym__automatic_semicolon] = ACTIONS(3370),
  },
  [831] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2642),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [832] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3493),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [833] = {
    [sym_arguments] = STATE(1440),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [834] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3476),
    [anon_sym_of] = ACTIONS(3479),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [835] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3351),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_PLUS_EQ] = ACTIONS(3318),
    [anon_sym_DASH_EQ] = ACTIONS(3318),
    [anon_sym_STAR_EQ] = ACTIONS(3318),
    [anon_sym_SLASH_EQ] = ACTIONS(3318),
    [anon_sym_PERCENT_EQ] = ACTIONS(3318),
    [anon_sym_CARET_EQ] = ACTIONS(3318),
    [anon_sym_AMP_EQ] = ACTIONS(3318),
    [anon_sym_PIPE_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3318),
    [anon_sym_LT_LT_EQ] = ACTIONS(3318),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [836] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [837] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym__automatic_semicolon] = ACTIONS(3285),
  },
  [838] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3426),
    [anon_sym_PLUS_EQ] = ACTIONS(3428),
    [anon_sym_DASH_EQ] = ACTIONS(3428),
    [anon_sym_STAR_EQ] = ACTIONS(3428),
    [anon_sym_SLASH_EQ] = ACTIONS(3428),
    [anon_sym_PERCENT_EQ] = ACTIONS(3428),
    [anon_sym_CARET_EQ] = ACTIONS(3428),
    [anon_sym_AMP_EQ] = ACTIONS(3428),
    [anon_sym_PIPE_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_LT_LT_EQ] = ACTIONS(3428),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3428),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [839] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3426),
    [anon_sym_PLUS_EQ] = ACTIONS(3428),
    [anon_sym_DASH_EQ] = ACTIONS(3428),
    [anon_sym_STAR_EQ] = ACTIONS(3428),
    [anon_sym_SLASH_EQ] = ACTIONS(3428),
    [anon_sym_PERCENT_EQ] = ACTIONS(3428),
    [anon_sym_CARET_EQ] = ACTIONS(3428),
    [anon_sym_AMP_EQ] = ACTIONS(3428),
    [anon_sym_PIPE_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_LT_LT_EQ] = ACTIONS(3428),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3428),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [840] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3495),
    [anon_sym_EQ_GT] = ACTIONS(3446),
    [anon_sym_PLUS_EQ] = ACTIONS(3448),
    [anon_sym_DASH_EQ] = ACTIONS(3448),
    [anon_sym_STAR_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_PERCENT_EQ] = ACTIONS(3448),
    [anon_sym_CARET_EQ] = ACTIONS(3448),
    [anon_sym_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_LT_LT_EQ] = ACTIONS(3448),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3448),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [841] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(670),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2642),
    [anon_sym_EQ_GT] = ACTIONS(622),
    [anon_sym_PLUS_EQ] = ACTIONS(698),
    [anon_sym_DASH_EQ] = ACTIONS(698),
    [anon_sym_STAR_EQ] = ACTIONS(698),
    [anon_sym_SLASH_EQ] = ACTIONS(698),
    [anon_sym_PERCENT_EQ] = ACTIONS(698),
    [anon_sym_CARET_EQ] = ACTIONS(698),
    [anon_sym_AMP_EQ] = ACTIONS(698),
    [anon_sym_PIPE_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(698),
    [anon_sym_LT_LT_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(698),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_LBRACE_PIPE] = ACTIONS(453),
  },
  [842] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_implements] = ACTIONS(453),
  },
  [843] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_PLUS_EQ] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(650),
    [anon_sym_STAR_EQ] = ACTIONS(650),
    [anon_sym_SLASH_EQ] = ACTIONS(650),
    [anon_sym_PERCENT_EQ] = ACTIONS(650),
    [anon_sym_CARET_EQ] = ACTIONS(650),
    [anon_sym_AMP_EQ] = ACTIONS(650),
    [anon_sym_PIPE_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_LT_LT_EQ] = ACTIONS(650),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [844] = {
    [sym_arguments] = STATE(1111),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_RBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3186),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
  },
  [845] = {
    [sym_arguments] = STATE(1108),
    [anon_sym_STAR] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_RBRACK] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(491),
    [anon_sym_GT] = ACTIONS(491),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(499),
    [anon_sym_PIPE_PIPE] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(491),
    [anon_sym_GT_GT_GT] = ACTIONS(491),
    [anon_sym_LT_LT] = ACTIONS(491),
    [anon_sym_AMP] = ACTIONS(491),
    [anon_sym_CARET] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_PERCENT] = ACTIONS(491),
    [anon_sym_STAR_STAR] = ACTIONS(491),
    [anon_sym_LT_EQ] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(499),
    [anon_sym_BANG_EQ] = ACTIONS(491),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(499),
    [anon_sym_GT_EQ] = ACTIONS(499),
    [anon_sym_instanceof] = ACTIONS(499),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(499),
  },
  [846] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3430),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [anon_sym_PLUS_EQ] = ACTIONS(3436),
    [anon_sym_DASH_EQ] = ACTIONS(3436),
    [anon_sym_STAR_EQ] = ACTIONS(3436),
    [anon_sym_SLASH_EQ] = ACTIONS(3436),
    [anon_sym_PERCENT_EQ] = ACTIONS(3436),
    [anon_sym_CARET_EQ] = ACTIONS(3436),
    [anon_sym_AMP_EQ] = ACTIONS(3436),
    [anon_sym_PIPE_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_LT_LT_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3436),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [847] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [848] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(3409),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [849] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3497),
    [anon_sym_EQ_GT] = ACTIONS(3186),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [850] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(726),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(612),
    [anon_sym_PLUS_EQ] = ACTIONS(742),
    [anon_sym_DASH_EQ] = ACTIONS(742),
    [anon_sym_STAR_EQ] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(742),
    [anon_sym_PERCENT_EQ] = ACTIONS(742),
    [anon_sym_CARET_EQ] = ACTIONS(742),
    [anon_sym_AMP_EQ] = ACTIONS(742),
    [anon_sym_PIPE_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(742),
    [anon_sym_LT_LT_EQ] = ACTIONS(742),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(742),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [anon_sym_implements] = ACTIONS(453),
  },
  [851] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(605),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [852] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3406),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(3409),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [853] = {
    [sym_arguments] = STATE(1557),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3165),
    [anon_sym_STAR_STAR] = ACTIONS(3165),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3169),
  },
  [854] = {
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_EQ] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_COMMA] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_DOT] = ACTIONS(3370),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_PIPE_PIPE] = ACTIONS(3370),
    [anon_sym_GT_GT] = ACTIONS(3368),
    [anon_sym_GT_GT_GT] = ACTIONS(3368),
    [anon_sym_LT_LT] = ACTIONS(3368),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_CARET] = ACTIONS(3368),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3368),
    [anon_sym_STAR_STAR] = ACTIONS(3368),
    [anon_sym_LT_EQ] = ACTIONS(3370),
    [anon_sym_EQ_EQ] = ACTIONS(3368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3370),
    [anon_sym_BANG_EQ] = ACTIONS(3368),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3370),
    [anon_sym_GT_EQ] = ACTIONS(3370),
    [anon_sym_instanceof] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3370),
  },
  [855] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [856] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(1374),
    [anon_sym_EQ_GT] = ACTIONS(614),
    [anon_sym_PLUS_EQ] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(650),
    [anon_sym_STAR_EQ] = ACTIONS(650),
    [anon_sym_SLASH_EQ] = ACTIONS(650),
    [anon_sym_PERCENT_EQ] = ACTIONS(650),
    [anon_sym_CARET_EQ] = ACTIONS(650),
    [anon_sym_AMP_EQ] = ACTIONS(650),
    [anon_sym_PIPE_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_LT_LT_EQ] = ACTIONS(650),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(650),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
    [sym__automatic_semicolon] = ACTIONS(453),
  },
  [857] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3186),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [858] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3285),
  },
  [859] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3418),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_PLUS_EQ] = ACTIONS(3428),
    [anon_sym_DASH_EQ] = ACTIONS(3428),
    [anon_sym_STAR_EQ] = ACTIONS(3428),
    [anon_sym_SLASH_EQ] = ACTIONS(3428),
    [anon_sym_PERCENT_EQ] = ACTIONS(3428),
    [anon_sym_CARET_EQ] = ACTIONS(3428),
    [anon_sym_AMP_EQ] = ACTIONS(3428),
    [anon_sym_PIPE_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3428),
    [anon_sym_LT_LT_EQ] = ACTIONS(3428),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3428),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [860] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_RPAREN] = ACTIONS(3334),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
  },
  [861] = {
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2979),
    [anon_sym_LBRACE] = ACTIONS(2977),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2979),
    [anon_sym_PLUS_EQ] = ACTIONS(2979),
    [anon_sym_DASH_EQ] = ACTIONS(2979),
    [anon_sym_STAR_EQ] = ACTIONS(2979),
    [anon_sym_SLASH_EQ] = ACTIONS(2979),
    [anon_sym_PERCENT_EQ] = ACTIONS(2979),
    [anon_sym_CARET_EQ] = ACTIONS(2979),
    [anon_sym_AMP_EQ] = ACTIONS(2979),
    [anon_sym_PIPE_EQ] = ACTIONS(2979),
    [anon_sym_GT_GT_EQ] = ACTIONS(2979),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_LT_EQ] = ACTIONS(2979),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_GT_GT_GT] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_STAR_STAR] = ACTIONS(2977),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_EQ_EQ] = ACTIONS(2977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_instanceof] = ACTIONS(2979),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2979),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2979),
  },
  [862] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_RBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [863] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_COMMA] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3285),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3285),
  },
  [864] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3331),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3328),
  },
  [865] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym__automatic_semicolon] = ACTIONS(3285),
  },
  [866] = {
    [anon_sym_STAR] = ACTIONS(2981),
    [anon_sym_EQ] = ACTIONS(2981),
    [anon_sym_as] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2981),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2981),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_LT] = ACTIONS(2981),
    [anon_sym_GT] = ACTIONS(2981),
    [anon_sym_SLASH] = ACTIONS(2981),
    [anon_sym_DOT] = ACTIONS(2983),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2981),
    [anon_sym_GT_GT_GT] = ACTIONS(2981),
    [anon_sym_LT_LT] = ACTIONS(2981),
    [anon_sym_AMP] = ACTIONS(2981),
    [anon_sym_CARET] = ACTIONS(2981),
    [anon_sym_PIPE] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2981),
    [anon_sym_DASH] = ACTIONS(2981),
    [anon_sym_PERCENT] = ACTIONS(2981),
    [anon_sym_STAR_STAR] = ACTIONS(2981),
    [anon_sym_LT_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2981),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_BANG_EQ] = ACTIONS(2981),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2983),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_instanceof] = ACTIONS(2983),
    [anon_sym_BANG] = ACTIONS(2981),
    [anon_sym_PLUS_PLUS] = ACTIONS(2983),
    [anon_sym_DASH_DASH] = ACTIONS(2983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2983),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2983),
  },
  [867] = {
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_EQ] = ACTIONS(3245),
    [anon_sym_as] = ACTIONS(3247),
    [anon_sym_LBRACE] = ACTIONS(3245),
    [anon_sym_COMMA] = ACTIONS(3247),
    [anon_sym_LPAREN] = ACTIONS(3247),
    [anon_sym_in] = ACTIONS(3245),
    [anon_sym_LBRACK] = ACTIONS(3247),
    [anon_sym_LT] = ACTIONS(3245),
    [anon_sym_GT] = ACTIONS(3245),
    [anon_sym_SLASH] = ACTIONS(3245),
    [anon_sym_DOT] = ACTIONS(3247),
    [anon_sym_PLUS_EQ] = ACTIONS(3247),
    [anon_sym_DASH_EQ] = ACTIONS(3247),
    [anon_sym_STAR_EQ] = ACTIONS(3247),
    [anon_sym_SLASH_EQ] = ACTIONS(3247),
    [anon_sym_PERCENT_EQ] = ACTIONS(3247),
    [anon_sym_CARET_EQ] = ACTIONS(3247),
    [anon_sym_AMP_EQ] = ACTIONS(3247),
    [anon_sym_PIPE_EQ] = ACTIONS(3247),
    [anon_sym_GT_GT_EQ] = ACTIONS(3247),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3247),
    [anon_sym_LT_LT_EQ] = ACTIONS(3247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3247),
    [anon_sym_QMARK] = ACTIONS(3247),
    [anon_sym_AMP_AMP] = ACTIONS(3247),
    [anon_sym_PIPE_PIPE] = ACTIONS(3247),
    [anon_sym_GT_GT] = ACTIONS(3245),
    [anon_sym_GT_GT_GT] = ACTIONS(3245),
    [anon_sym_LT_LT] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3245),
    [anon_sym_CARET] = ACTIONS(3245),
    [anon_sym_PIPE] = ACTIONS(3245),
    [anon_sym_PLUS] = ACTIONS(3245),
    [anon_sym_DASH] = ACTIONS(3245),
    [anon_sym_PERCENT] = ACTIONS(3245),
    [anon_sym_STAR_STAR] = ACTIONS(3245),
    [anon_sym_LT_EQ] = ACTIONS(3247),
    [anon_sym_EQ_EQ] = ACTIONS(3245),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3247),
    [anon_sym_BANG_EQ] = ACTIONS(3245),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3247),
    [anon_sym_GT_EQ] = ACTIONS(3247),
    [anon_sym_instanceof] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3245),
    [anon_sym_PLUS_PLUS] = ACTIONS(3247),
    [anon_sym_DASH_DASH] = ACTIONS(3247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3247),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3247),
  },
  [868] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3489),
    [anon_sym_COLON] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3186),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [869] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(2338),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_RBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
  },
  [870] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(2338),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3331),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [sym__automatic_semicolon] = ACTIONS(3285),
  },
  [871] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(545),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(549),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [anon_sym_DASH_EQ] = ACTIONS(571),
    [anon_sym_STAR_EQ] = ACTIONS(571),
    [anon_sym_SLASH_EQ] = ACTIONS(571),
    [anon_sym_PERCENT_EQ] = ACTIONS(571),
    [anon_sym_CARET_EQ] = ACTIONS(571),
    [anon_sym_AMP_EQ] = ACTIONS(571),
    [anon_sym_PIPE_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(571),
    [anon_sym_LT_LT_EQ] = ACTIONS(571),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(571),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [872] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3430),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_PLUS_EQ] = ACTIONS(3436),
    [anon_sym_DASH_EQ] = ACTIONS(3436),
    [anon_sym_STAR_EQ] = ACTIONS(3436),
    [anon_sym_SLASH_EQ] = ACTIONS(3436),
    [anon_sym_PERCENT_EQ] = ACTIONS(3436),
    [anon_sym_CARET_EQ] = ACTIONS(3436),
    [anon_sym_AMP_EQ] = ACTIONS(3436),
    [anon_sym_PIPE_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3436),
    [anon_sym_LT_LT_EQ] = ACTIONS(3436),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3436),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [873] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_RBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
  },
  [874] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
  },
  [875] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_EQ_GT] = ACTIONS(3446),
    [anon_sym_PLUS_EQ] = ACTIONS(3448),
    [anon_sym_DASH_EQ] = ACTIONS(3448),
    [anon_sym_STAR_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_PERCENT_EQ] = ACTIONS(3448),
    [anon_sym_CARET_EQ] = ACTIONS(3448),
    [anon_sym_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_LT_LT_EQ] = ACTIONS(3448),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3448),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [876] = {
    [anon_sym_STAR] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3207),
    [anon_sym_as] = ACTIONS(3209),
    [anon_sym_LBRACE] = ACTIONS(3207),
    [anon_sym_COMMA] = ACTIONS(3209),
    [anon_sym_LPAREN] = ACTIONS(3209),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_SLASH] = ACTIONS(3207),
    [anon_sym_DOT] = ACTIONS(3209),
    [anon_sym_PLUS_EQ] = ACTIONS(3209),
    [anon_sym_DASH_EQ] = ACTIONS(3209),
    [anon_sym_STAR_EQ] = ACTIONS(3209),
    [anon_sym_SLASH_EQ] = ACTIONS(3209),
    [anon_sym_PERCENT_EQ] = ACTIONS(3209),
    [anon_sym_CARET_EQ] = ACTIONS(3209),
    [anon_sym_AMP_EQ] = ACTIONS(3209),
    [anon_sym_PIPE_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3209),
    [anon_sym_LT_LT_EQ] = ACTIONS(3209),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(3209),
    [anon_sym_AMP_AMP] = ACTIONS(3209),
    [anon_sym_PIPE_PIPE] = ACTIONS(3209),
    [anon_sym_GT_GT] = ACTIONS(3207),
    [anon_sym_GT_GT_GT] = ACTIONS(3207),
    [anon_sym_LT_LT] = ACTIONS(3207),
    [anon_sym_AMP] = ACTIONS(3207),
    [anon_sym_CARET] = ACTIONS(3207),
    [anon_sym_PIPE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_DASH] = ACTIONS(3207),
    [anon_sym_PERCENT] = ACTIONS(3207),
    [anon_sym_STAR_STAR] = ACTIONS(3207),
    [anon_sym_LT_EQ] = ACTIONS(3209),
    [anon_sym_EQ_EQ] = ACTIONS(3207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3209),
    [anon_sym_BANG_EQ] = ACTIONS(3207),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3209),
    [anon_sym_GT_EQ] = ACTIONS(3209),
    [anon_sym_instanceof] = ACTIONS(3209),
    [anon_sym_BANG] = ACTIONS(3207),
    [anon_sym_PLUS_PLUS] = ACTIONS(3209),
    [anon_sym_DASH_DASH] = ACTIONS(3209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3209),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3209),
  },
  [877] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_COMMA] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3363),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3285),
  },
  [878] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3188),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_RBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3501),
    [anon_sym_EQ_GT] = ACTIONS(3198),
    [anon_sym_PLUS_EQ] = ACTIONS(3200),
    [anon_sym_DASH_EQ] = ACTIONS(3200),
    [anon_sym_STAR_EQ] = ACTIONS(3200),
    [anon_sym_SLASH_EQ] = ACTIONS(3200),
    [anon_sym_PERCENT_EQ] = ACTIONS(3200),
    [anon_sym_CARET_EQ] = ACTIONS(3200),
    [anon_sym_AMP_EQ] = ACTIONS(3200),
    [anon_sym_PIPE_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3200),
    [anon_sym_LT_LT_EQ] = ACTIONS(3200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3200),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [879] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
    [anon_sym_implements] = ACTIONS(3328),
  },
  [880] = {
    [sym_export_statement] = STATE(2036),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2036),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2036),
    [sym_property_signature] = STATE(2036),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2036),
    [sym_index_signature] = STATE(2036),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3509),
    [anon_sym_RBRACE] = ACTIONS(3511),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3509),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3511),
  },
  [881] = {
    [sym_export_clause] = STATE(2360),
    [sym__declaration] = STATE(2137),
    [sym_variable_declaration] = STATE(2137),
    [sym_lexical_declaration] = STATE(2137),
    [sym_class_declaration] = STATE(2137),
    [sym_function_declaration] = STATE(2137),
    [sym_generator_function_declaration] = STATE(2137),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(2137),
    [sym_ambient_declaration] = STATE(2137),
    [sym_abstract_class_declaration] = STATE(2137),
    [sym_module] = STATE(2137),
    [sym_internal_module] = STATE(2137),
    [sym_import_alias] = STATE(2137),
    [sym_interface_declaration] = STATE(2137),
    [sym_enum_declaration] = STATE(2137),
    [sym_type_alias_declaration] = STATE(2137),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2507),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_EQ] = ACTIONS(3531),
    [anon_sym_as] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_function] = ACTIONS(3553),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_declare] = ACTIONS(3557),
    [anon_sym_module] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [882] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3442),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_PLUS_EQ] = ACTIONS(3448),
    [anon_sym_DASH_EQ] = ACTIONS(3448),
    [anon_sym_STAR_EQ] = ACTIONS(3448),
    [anon_sym_SLASH_EQ] = ACTIONS(3448),
    [anon_sym_PERCENT_EQ] = ACTIONS(3448),
    [anon_sym_CARET_EQ] = ACTIONS(3448),
    [anon_sym_AMP_EQ] = ACTIONS(3448),
    [anon_sym_PIPE_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3448),
    [anon_sym_LT_LT_EQ] = ACTIONS(3448),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3448),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [883] = {
    [sym_export_clause] = STATE(2360),
    [sym__declaration] = STATE(2137),
    [sym_variable_declaration] = STATE(2137),
    [sym_lexical_declaration] = STATE(2137),
    [sym_class_declaration] = STATE(2137),
    [sym_function_declaration] = STATE(2137),
    [sym_generator_function_declaration] = STATE(2137),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(2137),
    [sym_ambient_declaration] = STATE(2137),
    [sym_abstract_class_declaration] = STATE(2137),
    [sym_module] = STATE(2137),
    [sym_internal_module] = STATE(2137),
    [sym_import_alias] = STATE(2137),
    [sym_interface_declaration] = STATE(2137),
    [sym_enum_declaration] = STATE(2137),
    [sym_type_alias_declaration] = STATE(2137),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2396),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_EQ] = ACTIONS(3531),
    [anon_sym_as] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_function] = ACTIONS(3553),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_declare] = ACTIONS(3557),
    [anon_sym_module] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [884] = {
    [sym_export_clause] = STATE(2360),
    [sym__declaration] = STATE(2137),
    [sym_variable_declaration] = STATE(2137),
    [sym_lexical_declaration] = STATE(2137),
    [sym_class_declaration] = STATE(2137),
    [sym_function_declaration] = STATE(2137),
    [sym_generator_function_declaration] = STATE(2137),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(2137),
    [sym_ambient_declaration] = STATE(2137),
    [sym_abstract_class_declaration] = STATE(2137),
    [sym_module] = STATE(2137),
    [sym_internal_module] = STATE(2137),
    [sym_import_alias] = STATE(2137),
    [sym_interface_declaration] = STATE(2137),
    [sym_enum_declaration] = STATE(2137),
    [sym_type_alias_declaration] = STATE(2137),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2556),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_EQ] = ACTIONS(3531),
    [anon_sym_as] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_function] = ACTIONS(3553),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_declare] = ACTIONS(3557),
    [anon_sym_module] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [885] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(758),
    [anon_sym_of] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [886] = {
    [sym_export_statement] = STATE(2075),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2075),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2075),
    [sym_property_signature] = STATE(2075),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2075),
    [sym_index_signature] = STATE(2075),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3047),
  },
  [887] = {
    [sym_export_statement] = STATE(2029),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2029),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2029),
    [sym_property_signature] = STATE(2029),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2029),
    [sym_index_signature] = STATE(2029),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3567),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3567),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3569),
  },
  [888] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_RBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3331),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3331),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3331),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
  },
  [889] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [890] = {
    [sym_export_statement] = STATE(2012),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2012),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2012),
    [sym_property_signature] = STATE(2012),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2012),
    [sym_index_signature] = STATE(2012),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3069),
  },
  [891] = {
    [anon_sym_STAR] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3334),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_in] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3334),
    [anon_sym_RBRACK] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3285),
    [anon_sym_DASH_EQ] = ACTIONS(3285),
    [anon_sym_STAR_EQ] = ACTIONS(3285),
    [anon_sym_SLASH_EQ] = ACTIONS(3285),
    [anon_sym_PERCENT_EQ] = ACTIONS(3285),
    [anon_sym_CARET_EQ] = ACTIONS(3285),
    [anon_sym_AMP_EQ] = ACTIONS(3285),
    [anon_sym_PIPE_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3285),
    [anon_sym_LT_LT_EQ] = ACTIONS(3285),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3285),
    [anon_sym_PIPE_PIPE] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3283),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3363),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3363),
    [anon_sym_PLUS] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3285),
    [anon_sym_EQ_EQ] = ACTIONS(3283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3285),
  },
  [892] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3476),
    [anon_sym_of] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3186),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [893] = {
    [sym_export_statement] = STATE(2065),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2065),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2065),
    [sym_property_signature] = STATE(2065),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2065),
    [sym_index_signature] = STATE(2065),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3571),
    [anon_sym_RBRACE] = ACTIONS(3573),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3573),
  },
  [894] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3177),
    [anon_sym_of] = ACTIONS(3180),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_EQ_GT] = ACTIONS(3186),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [895] = {
    [sym_export_clause] = STATE(2360),
    [sym__declaration] = STATE(2137),
    [sym_variable_declaration] = STATE(2137),
    [sym_lexical_declaration] = STATE(2137),
    [sym_class_declaration] = STATE(2137),
    [sym_function_declaration] = STATE(2137),
    [sym_generator_function_declaration] = STATE(2137),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(2137),
    [sym_ambient_declaration] = STATE(2137),
    [sym_abstract_class_declaration] = STATE(2137),
    [sym_module] = STATE(2137),
    [sym_internal_module] = STATE(2137),
    [sym_import_alias] = STATE(2137),
    [sym_interface_declaration] = STATE(2137),
    [sym_enum_declaration] = STATE(2137),
    [sym_type_alias_declaration] = STATE(2137),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [aux_sym_object_repeat1] = STATE(2538),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_EQ] = ACTIONS(3531),
    [anon_sym_as] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_function] = ACTIONS(3553),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_declare] = ACTIONS(3557),
    [anon_sym_module] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [896] = {
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(493),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_of] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(2547),
    [anon_sym_EQ_GT] = ACTIONS(616),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
    [anon_sym_STAR_EQ] = ACTIONS(521),
    [anon_sym_SLASH_EQ] = ACTIONS(521),
    [anon_sym_PERCENT_EQ] = ACTIONS(521),
    [anon_sym_CARET_EQ] = ACTIONS(521),
    [anon_sym_AMP_EQ] = ACTIONS(521),
    [anon_sym_PIPE_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(521),
    [anon_sym_LT_LT_EQ] = ACTIONS(521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_GT_GT_GT] = ACTIONS(445),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_STAR_STAR] = ACTIONS(445),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(445),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(453),
  },
  [897] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3476),
    [anon_sym_of] = ACTIONS(3479),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [898] = {
    [sym_export_clause] = STATE(2360),
    [sym__declaration] = STATE(2137),
    [sym_variable_declaration] = STATE(2137),
    [sym_lexical_declaration] = STATE(2137),
    [sym_class_declaration] = STATE(2137),
    [sym_function_declaration] = STATE(2137),
    [sym_generator_function_declaration] = STATE(2137),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(2137),
    [sym_ambient_declaration] = STATE(2137),
    [sym_abstract_class_declaration] = STATE(2137),
    [sym_module] = STATE(2137),
    [sym_internal_module] = STATE(2137),
    [sym_import_alias] = STATE(2137),
    [sym_interface_declaration] = STATE(2137),
    [sym_enum_declaration] = STATE(2137),
    [sym_type_alias_declaration] = STATE(2137),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_EQ] = ACTIONS(3575),
    [anon_sym_as] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_function] = ACTIONS(3553),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_declare] = ACTIONS(3557),
    [anon_sym_module] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [899] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3177),
    [anon_sym_of] = ACTIONS(3180),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_PLUS_EQ] = ACTIONS(3171),
    [anon_sym_DASH_EQ] = ACTIONS(3171),
    [anon_sym_STAR_EQ] = ACTIONS(3171),
    [anon_sym_SLASH_EQ] = ACTIONS(3171),
    [anon_sym_PERCENT_EQ] = ACTIONS(3171),
    [anon_sym_CARET_EQ] = ACTIONS(3171),
    [anon_sym_AMP_EQ] = ACTIONS(3171),
    [anon_sym_PIPE_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3171),
    [anon_sym_LT_LT_EQ] = ACTIONS(3171),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [900] = {
    [sym_export_clause] = STATE(2360),
    [sym__declaration] = STATE(2137),
    [sym_variable_declaration] = STATE(2137),
    [sym_lexical_declaration] = STATE(2137),
    [sym_class_declaration] = STATE(2137),
    [sym_function_declaration] = STATE(2137),
    [sym_generator_function_declaration] = STATE(2137),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(2137),
    [sym_ambient_declaration] = STATE(2137),
    [sym_abstract_class_declaration] = STATE(2137),
    [sym_module] = STATE(2137),
    [sym_internal_module] = STATE(2137),
    [sym_import_alias] = STATE(2137),
    [sym_interface_declaration] = STATE(2137),
    [sym_enum_declaration] = STATE(2137),
    [sym_type_alias_declaration] = STATE(2137),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [anon_sym_STAR] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_EQ] = ACTIONS(3531),
    [anon_sym_as] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_LBRACE] = ACTIONS(1359),
    [anon_sym_COMMA] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_function] = ACTIONS(3553),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_declare] = ACTIONS(3557),
    [anon_sym_module] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3563),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [901] = {
    [sym_import_clause] = STATE(2587),
    [sym_namespace_import] = STATE(2833),
    [sym_named_imports] = STATE(2833),
    [sym_string] = STATE(2590),
    [sym_import_require_clause] = STATE(2590),
    [sym_identifier] = ACTIONS(3580),
    [anon_sym_STAR] = ACTIONS(3582),
    [anon_sym_as] = ACTIONS(3584),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_COMMA] = ACTIONS(3588),
    [anon_sym_type] = ACTIONS(3590),
    [anon_sym_typeof] = ACTIONS(3590),
    [anon_sym_LPAREN] = ACTIONS(3588),
    [anon_sym_in] = ACTIONS(3584),
    [anon_sym_SEMI] = ACTIONS(3588),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(3584),
    [anon_sym_GT] = ACTIONS(3584),
    [anon_sym_SLASH] = ACTIONS(3584),
    [anon_sym_DOT] = ACTIONS(3588),
    [anon_sym_QMARK] = ACTIONS(3588),
    [anon_sym_AMP_AMP] = ACTIONS(3588),
    [anon_sym_PIPE_PIPE] = ACTIONS(3588),
    [anon_sym_GT_GT] = ACTIONS(3584),
    [anon_sym_GT_GT_GT] = ACTIONS(3588),
    [anon_sym_LT_LT] = ACTIONS(3588),
    [anon_sym_AMP] = ACTIONS(3584),
    [anon_sym_CARET] = ACTIONS(3588),
    [anon_sym_PIPE] = ACTIONS(3584),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_DASH] = ACTIONS(3584),
    [anon_sym_PERCENT] = ACTIONS(3588),
    [anon_sym_STAR_STAR] = ACTIONS(3588),
    [anon_sym_LT_EQ] = ACTIONS(3588),
    [anon_sym_EQ_EQ] = ACTIONS(3584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3588),
    [anon_sym_BANG_EQ] = ACTIONS(3584),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3588),
    [anon_sym_GT_EQ] = ACTIONS(3588),
    [anon_sym_instanceof] = ACTIONS(3584),
    [anon_sym_BANG] = ACTIONS(3584),
    [anon_sym_PLUS_PLUS] = ACTIONS(3588),
    [anon_sym_DASH_DASH] = ACTIONS(3588),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3588),
    [sym__automatic_semicolon] = ACTIONS(3588),
  },
  [902] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3592),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3592),
  },
  [903] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3594),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3594),
  },
  [904] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3596),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3596),
  },
  [905] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3598),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3598),
  },
  [906] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3600),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3600),
  },
  [907] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3602),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3602),
  },
  [908] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3604),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3604),
  },
  [909] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3606),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3606),
  },
  [910] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3608),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3608),
  },
  [911] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3610),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3610),
  },
  [912] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3612),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3612),
  },
  [913] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3614),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3614),
  },
  [914] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
  },
  [915] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3618),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3618),
  },
  [916] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(3620),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3620),
  },
  [917] = {
    [sym_export_statement] = STATE(2007),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2007),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2007),
    [sym_property_signature] = STATE(2007),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2007),
    [sym_index_signature] = STATE(2007),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
  },
  [918] = {
    [sym_export_statement] = STATE(2005),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2005),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2005),
    [sym_property_signature] = STATE(2005),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2005),
    [sym_index_signature] = STATE(2005),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
  },
  [919] = {
    [sym_export_statement] = STATE(2145),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2145),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2145),
    [sym_property_signature] = STATE(2145),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2145),
    [sym_index_signature] = STATE(2145),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
  },
  [920] = {
    [sym_export_statement] = STATE(2030),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2030),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2030),
    [sym_property_signature] = STATE(2030),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2030),
    [sym_index_signature] = STATE(2030),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
  },
  [921] = {
    [sym_export_statement] = STATE(2038),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2038),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2038),
    [sym_property_signature] = STATE(2038),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2038),
    [sym_index_signature] = STATE(2038),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
  },
  [922] = {
    [sym_export_statement] = STATE(2052),
    [sym__call_signature] = STATE(2133),
    [sym_string] = STATE(1817),
    [sym_decorator] = STATE(1798),
    [sym_formal_parameters] = STATE(1918),
    [sym__property_name] = STATE(1817),
    [sym_computed_property_name] = STATE(1817),
    [sym_method_signature] = STATE(2052),
    [sym_accessibility_modifier] = STATE(1771),
    [sym_call_signature] = STATE(2052),
    [sym_property_signature] = STATE(2052),
    [sym_type_parameters] = STATE(2689),
    [sym_construct_signature] = STATE(2052),
    [sym_index_signature] = STATE(2052),
    [aux_sym_export_statement_repeat1] = STATE(2371),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3505),
    [anon_sym_STAR] = ACTIONS(3507),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_async] = ACTIONS(3515),
    [anon_sym_new] = ACTIONS(3031),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(3519),
    [anon_sym_get] = ACTIONS(3521),
    [anon_sym_set] = ACTIONS(3521),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3525),
  },
  [923] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [924] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [925] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1112),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_RPAREN] = ACTIONS(3169),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_RBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_implements] = ACTIONS(3169),
  },
  [926] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3626),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3630),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_RPAREN] = ACTIONS(3630),
    [anon_sym_in] = ACTIONS(3626),
    [anon_sym_COLON] = ACTIONS(3630),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3626),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3630),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_GT_GT] = ACTIONS(3626),
    [anon_sym_GT_GT_GT] = ACTIONS(3630),
    [anon_sym_LT_LT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_CARET] = ACTIONS(3630),
    [anon_sym_PIPE] = ACTIONS(3626),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_DASH] = ACTIONS(3626),
    [anon_sym_PERCENT] = ACTIONS(3630),
    [anon_sym_STAR_STAR] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3626),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3630),
    [anon_sym_implements] = ACTIONS(3630),
  },
  [927] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(3634),
    [anon_sym_LBRACE] = ACTIONS(3634),
    [anon_sym_COMMA] = ACTIONS(3634),
    [anon_sym_RBRACE] = ACTIONS(3634),
    [anon_sym_LPAREN] = ACTIONS(3634),
    [anon_sym_RPAREN] = ACTIONS(3634),
    [anon_sym_in] = ACTIONS(3632),
    [anon_sym_COLON] = ACTIONS(3634),
    [anon_sym_LBRACK] = ACTIONS(3634),
    [anon_sym_RBRACK] = ACTIONS(3634),
    [anon_sym_LT] = ACTIONS(3632),
    [anon_sym_GT] = ACTIONS(3632),
    [anon_sym_SLASH] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(3634),
    [anon_sym_QMARK] = ACTIONS(3634),
    [anon_sym_AMP_AMP] = ACTIONS(3634),
    [anon_sym_PIPE_PIPE] = ACTIONS(3634),
    [anon_sym_GT_GT] = ACTIONS(3632),
    [anon_sym_GT_GT_GT] = ACTIONS(3634),
    [anon_sym_LT_LT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_CARET] = ACTIONS(3634),
    [anon_sym_PIPE] = ACTIONS(3632),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_PERCENT] = ACTIONS(3634),
    [anon_sym_STAR_STAR] = ACTIONS(3634),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_EQ_EQ] = ACTIONS(3632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3634),
    [anon_sym_BANG_EQ] = ACTIONS(3632),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3634),
    [anon_sym_instanceof] = ACTIONS(3634),
    [anon_sym_BANG] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3634),
    [anon_sym_DASH_DASH] = ACTIONS(3634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3634),
    [anon_sym_implements] = ACTIONS(3634),
  },
  [928] = {
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_RBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1069),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_implements] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(3636),
  },
  [929] = {
    [sym_type_arguments] = STATE(1033),
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_RPAREN] = ACTIONS(2486),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_COLON] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_RBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(3638),
    [anon_sym_GT] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2486),
    [anon_sym_GT_GT] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2486),
    [anon_sym_LT_LT] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_CARET] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2486),
    [anon_sym_STAR_STAR] = ACTIONS(2486),
    [anon_sym_LT_EQ] = ACTIONS(2486),
    [anon_sym_EQ_EQ] = ACTIONS(2488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2486),
    [anon_sym_BANG_EQ] = ACTIONS(2488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2486),
    [anon_sym_GT_EQ] = ACTIONS(2486),
    [anon_sym_instanceof] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [anon_sym_implements] = ACTIONS(2486),
    [anon_sym_is] = ACTIONS(3643),
  },
  [930] = {
    [anon_sym_STAR] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_else] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_COLON] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1171),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_PIPE_PIPE] = ACTIONS(1171),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1171),
    [anon_sym_STAR_STAR] = ACTIONS(1171),
    [anon_sym_LT_EQ] = ACTIONS(1171),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1171),
    [anon_sym_GT_EQ] = ACTIONS(1171),
    [anon_sym_instanceof] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1171),
    [sym__automatic_semicolon] = ACTIONS(1171),
  },
  [931] = {
    [sym_arguments] = STATE(1111),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3645),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3169),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_RBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_implements] = ACTIONS(3169),
  },
  [932] = {
    [sym_arguments] = STATE(1111),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3647),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3169),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_RBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_implements] = ACTIONS(3169),
  },
  [933] = {
    [anon_sym_STAR] = ACTIONS(3649),
    [anon_sym_EQ] = ACTIONS(3649),
    [anon_sym_as] = ACTIONS(3651),
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_COMMA] = ACTIONS(3651),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_LPAREN] = ACTIONS(3651),
    [anon_sym_RPAREN] = ACTIONS(3651),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_of] = ACTIONS(3651),
    [anon_sym_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK] = ACTIONS(3651),
    [anon_sym_RBRACK] = ACTIONS(3651),
    [anon_sym_LT] = ACTIONS(3649),
    [anon_sym_GT] = ACTIONS(3649),
    [anon_sym_SLASH] = ACTIONS(3649),
    [anon_sym_DOT] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_PIPE_PIPE] = ACTIONS(3651),
    [anon_sym_GT_GT] = ACTIONS(3649),
    [anon_sym_GT_GT_GT] = ACTIONS(3651),
    [anon_sym_LT_LT] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_CARET] = ACTIONS(3651),
    [anon_sym_PIPE] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PERCENT] = ACTIONS(3651),
    [anon_sym_STAR_STAR] = ACTIONS(3651),
    [anon_sym_LT_EQ] = ACTIONS(3651),
    [anon_sym_EQ_EQ] = ACTIONS(3649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3651),
    [anon_sym_BANG_EQ] = ACTIONS(3649),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3651),
    [anon_sym_GT_EQ] = ACTIONS(3651),
    [anon_sym_instanceof] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3649),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3651),
    [anon_sym_implements] = ACTIONS(3651),
  },
  [934] = {
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_EQ] = ACTIONS(3653),
    [anon_sym_as] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(3655),
    [anon_sym_RBRACE] = ACTIONS(3655),
    [anon_sym_LPAREN] = ACTIONS(3655),
    [anon_sym_RPAREN] = ACTIONS(3655),
    [anon_sym_in] = ACTIONS(3653),
    [anon_sym_of] = ACTIONS(3655),
    [anon_sym_COLON] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_RBRACK] = ACTIONS(3655),
    [anon_sym_LT] = ACTIONS(3653),
    [anon_sym_GT] = ACTIONS(3653),
    [anon_sym_SLASH] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3655),
    [anon_sym_QMARK] = ACTIONS(3655),
    [anon_sym_AMP_AMP] = ACTIONS(3655),
    [anon_sym_PIPE_PIPE] = ACTIONS(3655),
    [anon_sym_GT_GT] = ACTIONS(3653),
    [anon_sym_GT_GT_GT] = ACTIONS(3655),
    [anon_sym_LT_LT] = ACTIONS(3655),
    [anon_sym_AMP] = ACTIONS(3653),
    [anon_sym_CARET] = ACTIONS(3655),
    [anon_sym_PIPE] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [anon_sym_PERCENT] = ACTIONS(3655),
    [anon_sym_STAR_STAR] = ACTIONS(3655),
    [anon_sym_LT_EQ] = ACTIONS(3655),
    [anon_sym_EQ_EQ] = ACTIONS(3653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3655),
    [anon_sym_BANG_EQ] = ACTIONS(3653),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3655),
    [anon_sym_GT_EQ] = ACTIONS(3655),
    [anon_sym_instanceof] = ACTIONS(3655),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3655),
    [anon_sym_implements] = ACTIONS(3655),
  },
  [935] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_of] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_RBRACK] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_implements] = ACTIONS(1073),
  },
  [936] = {
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_else] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_while] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1111),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1111),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1111),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1111),
    [anon_sym_DASH] = ACTIONS(1111),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1109),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [937] = {
    [anon_sym_STAR] = ACTIONS(3657),
    [anon_sym_EQ] = ACTIONS(3657),
    [anon_sym_as] = ACTIONS(3659),
    [anon_sym_LBRACE] = ACTIONS(3659),
    [anon_sym_COMMA] = ACTIONS(3659),
    [anon_sym_RBRACE] = ACTIONS(3659),
    [anon_sym_LPAREN] = ACTIONS(3659),
    [anon_sym_RPAREN] = ACTIONS(3659),
    [anon_sym_in] = ACTIONS(3657),
    [anon_sym_of] = ACTIONS(3659),
    [anon_sym_COLON] = ACTIONS(3659),
    [anon_sym_LBRACK] = ACTIONS(3659),
    [anon_sym_RBRACK] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3657),
    [anon_sym_GT] = ACTIONS(3657),
    [anon_sym_SLASH] = ACTIONS(3657),
    [anon_sym_DOT] = ACTIONS(3659),
    [anon_sym_QMARK] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_GT_GT_GT] = ACTIONS(3659),
    [anon_sym_LT_LT] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3657),
    [anon_sym_CARET] = ACTIONS(3659),
    [anon_sym_PIPE] = ACTIONS(3657),
    [anon_sym_PLUS] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(3657),
    [anon_sym_PERCENT] = ACTIONS(3659),
    [anon_sym_STAR_STAR] = ACTIONS(3659),
    [anon_sym_LT_EQ] = ACTIONS(3659),
    [anon_sym_EQ_EQ] = ACTIONS(3657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3659),
    [anon_sym_BANG_EQ] = ACTIONS(3657),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3659),
    [anon_sym_GT_EQ] = ACTIONS(3659),
    [anon_sym_instanceof] = ACTIONS(3659),
    [anon_sym_BANG] = ACTIONS(3657),
    [anon_sym_PLUS_PLUS] = ACTIONS(3659),
    [anon_sym_DASH_DASH] = ACTIONS(3659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [anon_sym_implements] = ACTIONS(3659),
  },
  [938] = {
    [anon_sym_STAR] = ACTIONS(3661),
    [anon_sym_EQ] = ACTIONS(3661),
    [anon_sym_as] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3663),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN] = ACTIONS(3663),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_of] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_RBRACK] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(3661),
    [anon_sym_GT] = ACTIONS(3661),
    [anon_sym_SLASH] = ACTIONS(3661),
    [anon_sym_DOT] = ACTIONS(3663),
    [anon_sym_QMARK] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_GT_GT] = ACTIONS(3661),
    [anon_sym_GT_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_LT] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_CARET] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3661),
    [anon_sym_PLUS] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(3661),
    [anon_sym_PERCENT] = ACTIONS(3663),
    [anon_sym_STAR_STAR] = ACTIONS(3663),
    [anon_sym_LT_EQ] = ACTIONS(3663),
    [anon_sym_EQ_EQ] = ACTIONS(3661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3663),
    [anon_sym_BANG_EQ] = ACTIONS(3661),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3663),
    [anon_sym_GT_EQ] = ACTIONS(3663),
    [anon_sym_instanceof] = ACTIONS(3663),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_PLUS_PLUS] = ACTIONS(3663),
    [anon_sym_DASH_DASH] = ACTIONS(3663),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_implements] = ACTIONS(3663),
  },
  [939] = {
    [anon_sym_STAR] = ACTIONS(3665),
    [anon_sym_EQ] = ACTIONS(3665),
    [anon_sym_as] = ACTIONS(3667),
    [anon_sym_LBRACE] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_LPAREN] = ACTIONS(3667),
    [anon_sym_RPAREN] = ACTIONS(3667),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_of] = ACTIONS(3667),
    [anon_sym_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK] = ACTIONS(3667),
    [anon_sym_RBRACK] = ACTIONS(3667),
    [anon_sym_LT] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_SLASH] = ACTIONS(3665),
    [anon_sym_DOT] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_PIPE_PIPE] = ACTIONS(3667),
    [anon_sym_GT_GT] = ACTIONS(3665),
    [anon_sym_GT_GT_GT] = ACTIONS(3667),
    [anon_sym_LT_LT] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_CARET] = ACTIONS(3667),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PERCENT] = ACTIONS(3667),
    [anon_sym_STAR_STAR] = ACTIONS(3667),
    [anon_sym_LT_EQ] = ACTIONS(3667),
    [anon_sym_EQ_EQ] = ACTIONS(3665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3667),
    [anon_sym_BANG_EQ] = ACTIONS(3665),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3667),
    [anon_sym_GT_EQ] = ACTIONS(3667),
    [anon_sym_instanceof] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3665),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3667),
    [anon_sym_implements] = ACTIONS(3667),
  },
  [940] = {
    [anon_sym_STAR] = ACTIONS(3669),
    [anon_sym_EQ] = ACTIONS(3669),
    [anon_sym_as] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_RPAREN] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_of] = ACTIONS(3671),
    [anon_sym_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_RBRACK] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3669),
    [anon_sym_GT] = ACTIONS(3669),
    [anon_sym_SLASH] = ACTIONS(3669),
    [anon_sym_DOT] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE] = ACTIONS(3671),
    [anon_sym_GT_GT] = ACTIONS(3669),
    [anon_sym_GT_GT_GT] = ACTIONS(3671),
    [anon_sym_LT_LT] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_CARET] = ACTIONS(3671),
    [anon_sym_PIPE] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PERCENT] = ACTIONS(3671),
    [anon_sym_STAR_STAR] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_EQ_EQ] = ACTIONS(3669),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3669),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3671),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_instanceof] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3669),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3671),
    [anon_sym_implements] = ACTIONS(3671),
  },
  [941] = {
    [anon_sym_STAR] = ACTIONS(3673),
    [anon_sym_EQ] = ACTIONS(3673),
    [anon_sym_as] = ACTIONS(3675),
    [anon_sym_LBRACE] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_RPAREN] = ACTIONS(3675),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_of] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_RBRACK] = ACTIONS(3675),
    [anon_sym_LT] = ACTIONS(3673),
    [anon_sym_GT] = ACTIONS(3673),
    [anon_sym_SLASH] = ACTIONS(3673),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3673),
    [anon_sym_GT_GT_GT] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_CARET] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_STAR_STAR] = ACTIONS(3675),
    [anon_sym_LT_EQ] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3673),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3673),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3675),
    [anon_sym_instanceof] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3673),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3675),
    [anon_sym_implements] = ACTIONS(3675),
  },
  [942] = {
    [sym_type_arguments] = STATE(1040),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_as] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(2551),
    [anon_sym_RBRACE] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_RPAREN] = ACTIONS(2551),
    [anon_sym_in] = ACTIONS(2553),
    [anon_sym_COLON] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_RBRACK] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(3677),
    [anon_sym_GT] = ACTIONS(2553),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2551),
    [anon_sym_QMARK] = ACTIONS(2551),
    [anon_sym_AMP_AMP] = ACTIONS(2551),
    [anon_sym_PIPE_PIPE] = ACTIONS(2551),
    [anon_sym_GT_GT] = ACTIONS(2553),
    [anon_sym_GT_GT_GT] = ACTIONS(2551),
    [anon_sym_LT_LT] = ACTIONS(2551),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_CARET] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2551),
    [anon_sym_STAR_STAR] = ACTIONS(2551),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_EQ_EQ] = ACTIONS(2553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(2553),
    [anon_sym_PLUS_PLUS] = ACTIONS(2551),
    [anon_sym_DASH_DASH] = ACTIONS(2551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2551),
    [anon_sym_implements] = ACTIONS(2551),
  },
  [943] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_string] = STATE(1008),
    [sym_nested_type_identifier] = STATE(942),
    [sym__primary_type] = STATE(1018),
    [sym_generic_type] = STATE(1018),
    [sym_type_predicate] = STATE(1018),
    [sym_type_query] = STATE(1018),
    [sym_index_type_query] = STATE(1018),
    [sym_lookup_type] = STATE(1018),
    [sym_literal_type] = STATE(1018),
    [sym__number] = STATE(1008),
    [sym_existential_type] = STATE(1018),
    [sym_flow_maybe_type] = STATE(1018),
    [sym_parenthesized_type] = STATE(1018),
    [sym_predefined_type] = STATE(1018),
    [sym_object_type] = STATE(1018),
    [sym_array_type] = STATE(1018),
    [sym_tuple_type] = STATE(1018),
    [sym_identifier] = ACTIONS(3249),
    [anon_sym_STAR] = ACTIONS(3251),
    [anon_sym_LBRACE] = ACTIONS(3253),
    [anon_sym_typeof] = ACTIONS(3255),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(3263),
    [anon_sym_PLUS] = ACTIONS(3269),
    [anon_sym_DASH] = ACTIONS(3269),
    [anon_sym_void] = ACTIONS(3271),
    [anon_sym_DQUOTE] = ACTIONS(527),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3273),
    [sym_this] = ACTIONS(3682),
    [sym_true] = ACTIONS(3277),
    [sym_false] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(3271),
    [anon_sym_number] = ACTIONS(3271),
    [anon_sym_boolean] = ACTIONS(3271),
    [anon_sym_string] = ACTIONS(3271),
    [anon_sym_symbol] = ACTIONS(3271),
    [anon_sym_keyof] = ACTIONS(3279),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3281),
  },
  [944] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_annotation] = STATE(2886),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2525),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3688),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [945] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3716),
    [anon_sym_RBRACE] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3716),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [946] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_nested_type_identifier] = STATE(1805),
    [sym__primary_type] = STATE(423),
    [sym_generic_type] = STATE(423),
    [sym_type_predicate] = STATE(423),
    [sym_type_query] = STATE(423),
    [sym_index_type_query] = STATE(423),
    [sym_lookup_type] = STATE(423),
    [sym_literal_type] = STATE(423),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(423),
    [sym_flow_maybe_type] = STATE(423),
    [sym_parenthesized_type] = STATE(423),
    [sym_predefined_type] = STATE(423),
    [sym_object_type] = STATE(423),
    [sym_array_type] = STATE(423),
    [sym_tuple_type] = STATE(423),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_QMARK] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3720),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [947] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_string] = STATE(1401),
    [sym_nested_type_identifier] = STATE(1299),
    [sym__primary_type] = STATE(1384),
    [sym_generic_type] = STATE(1384),
    [sym_type_predicate] = STATE(1384),
    [sym_type_query] = STATE(1384),
    [sym_index_type_query] = STATE(1384),
    [sym_lookup_type] = STATE(1384),
    [sym_literal_type] = STATE(1384),
    [sym__number] = STATE(1401),
    [sym_existential_type] = STATE(1384),
    [sym_flow_maybe_type] = STATE(1384),
    [sym_parenthesized_type] = STATE(1384),
    [sym_predefined_type] = STATE(1384),
    [sym_object_type] = STATE(1384),
    [sym_array_type] = STATE(1384),
    [sym_tuple_type] = STATE(1384),
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_typeof] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_PLUS] = ACTIONS(3133),
    [anon_sym_DASH] = ACTIONS(3133),
    [anon_sym_void] = ACTIONS(3135),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3137),
    [sym_this] = ACTIONS(3724),
    [sym_true] = ACTIONS(3141),
    [sym_false] = ACTIONS(3141),
    [anon_sym_any] = ACTIONS(3135),
    [anon_sym_number] = ACTIONS(3135),
    [anon_sym_boolean] = ACTIONS(3135),
    [anon_sym_string] = ACTIONS(3135),
    [anon_sym_symbol] = ACTIONS(3135),
    [anon_sym_keyof] = ACTIONS(3143),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3145),
  },
  [948] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_RBRACE] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3726),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [949] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_RBRACE] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3728),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [950] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_RBRACE] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3730),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [951] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [952] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3741),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3741),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [953] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [954] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [955] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [956] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_annotation] = STATE(2886),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2383),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3743),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [957] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [958] = {
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_RPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_RBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1069),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_implements] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(3636),
  },
  [959] = {
    [sym_arguments] = STATE(1111),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3169),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_RBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_implements] = ACTIONS(3169),
  },
  [960] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3734),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(3736),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(3734),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [961] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3745),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3745),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3745),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3745),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [962] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3747),
    [anon_sym_RBRACE] = ACTIONS(3747),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3747),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3747),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [963] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3749),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3749),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [964] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_string] = STATE(429),
    [sym_nested_type_identifier] = STATE(459),
    [sym__primary_type] = STATE(423),
    [sym_generic_type] = STATE(423),
    [sym_type_predicate] = STATE(423),
    [sym_type_query] = STATE(423),
    [sym_index_type_query] = STATE(423),
    [sym_lookup_type] = STATE(423),
    [sym_literal_type] = STATE(423),
    [sym__number] = STATE(429),
    [sym_existential_type] = STATE(423),
    [sym_flow_maybe_type] = STATE(423),
    [sym_parenthesized_type] = STATE(423),
    [sym_predefined_type] = STATE(423),
    [sym_object_type] = STATE(423),
    [sym_array_type] = STATE(423),
    [sym_tuple_type] = STATE(423),
    [sym_identifier] = ACTIONS(3374),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_typeof] = ACTIONS(2519),
    [anon_sym_LPAREN] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3298),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2529),
    [anon_sym_void] = ACTIONS(3302),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2533),
    [sym_this] = ACTIONS(3720),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [anon_sym_any] = ACTIONS(3302),
    [anon_sym_number] = ACTIONS(3302),
    [anon_sym_boolean] = ACTIONS(3302),
    [anon_sym_string] = ACTIONS(3302),
    [anon_sym_symbol] = ACTIONS(3302),
    [anon_sym_keyof] = ACTIONS(811),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [965] = {
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_RPAREN] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_RBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1135),
    [anon_sym_PIPE_PIPE] = ACTIONS(1135),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_GT_GT_GT] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [anon_sym_implements] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(3751),
  },
  [966] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3755),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3755),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [967] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3760),
    [anon_sym_RBRACE] = ACTIONS(3760),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3760),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [968] = {
    [sym_statement_block] = STATE(1014),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_implements] = ACTIONS(1059),
  },
  [969] = {
    [sym_statement_block] = STATE(1014),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_COLON] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(3764),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_implements] = ACTIONS(1059),
  },
  [970] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3766),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [971] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_RBRACE] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3768),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [972] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3770),
    [anon_sym_RBRACE] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3770),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3770),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [973] = {
    [anon_sym_STAR] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_RBRACE] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_in] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_RBRACK] = ACTIONS(3774),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_GT] = ACTIONS(3772),
    [anon_sym_SLASH] = ACTIONS(3772),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_EQ_GT] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_GT_GT] = ACTIONS(3772),
    [anon_sym_GT_GT_GT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3772),
    [anon_sym_CARET] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3774),
    [anon_sym_EQ_EQ] = ACTIONS(3772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3772),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3774),
    [anon_sym_GT_EQ] = ACTIONS(3774),
    [anon_sym_instanceof] = ACTIONS(3774),
    [anon_sym_BANG] = ACTIONS(3772),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3774),
    [anon_sym_implements] = ACTIONS(3774),
  },
  [974] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_RBRACE] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3778),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [975] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_RBRACE] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3780),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [976] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_RBRACK] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_implements] = ACTIONS(1073),
  },
  [977] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3755),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3755),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [978] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_string] = STATE(1543),
    [sym_nested_type_identifier] = STATE(1437),
    [sym__primary_type] = STATE(1565),
    [sym_generic_type] = STATE(1565),
    [sym_type_predicate] = STATE(1565),
    [sym_type_query] = STATE(1565),
    [sym_index_type_query] = STATE(1565),
    [sym_lookup_type] = STATE(1565),
    [sym_literal_type] = STATE(1565),
    [sym__number] = STATE(1543),
    [sym_existential_type] = STATE(1565),
    [sym_flow_maybe_type] = STATE(1565),
    [sym_parenthesized_type] = STATE(1565),
    [sym_predefined_type] = STATE(1565),
    [sym_object_type] = STATE(1565),
    [sym_array_type] = STATE(1565),
    [sym_tuple_type] = STATE(1565),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3215),
    [anon_sym_typeof] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_QMARK] = ACTIONS(3225),
    [anon_sym_PLUS] = ACTIONS(3231),
    [anon_sym_DASH] = ACTIONS(3231),
    [anon_sym_void] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [anon_sym_SQUOTE] = ACTIONS(712),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3235),
    [sym_this] = ACTIONS(3784),
    [sym_true] = ACTIONS(3239),
    [sym_false] = ACTIONS(3239),
    [anon_sym_any] = ACTIONS(3233),
    [anon_sym_number] = ACTIONS(3233),
    [anon_sym_boolean] = ACTIONS(3233),
    [anon_sym_string] = ACTIONS(3233),
    [anon_sym_symbol] = ACTIONS(3233),
    [anon_sym_keyof] = ACTIONS(3241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3243),
  },
  [979] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3786),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3786),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3786),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [980] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [981] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3790),
    [anon_sym_RBRACE] = ACTIONS(3790),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3790),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3790),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [982] = {
    [sym_statement_block] = STATE(1253),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym__automatic_semicolon] = ACTIONS(1059),
  },
  [983] = {
    [sym__initializer] = STATE(2441),
    [sym_type_annotation] = STATE(2152),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3796),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_of] = ACTIONS(3803),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(3798),
  },
  [984] = {
    [sym__initializer] = STATE(2433),
    [sym_type_annotation] = STATE(2136),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3805),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3807),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3809),
    [anon_sym_of] = ACTIONS(3812),
    [anon_sym_SEMI] = ACTIONS(3807),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(3807),
  },
  [985] = {
    [sym_statement_block] = STATE(1253),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym__automatic_semicolon] = ACTIONS(1059),
  },
  [986] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_annotation] = STATE(2886),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2422),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3686),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3814),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [987] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_string] = STATE(1878),
    [sym_nested_type_identifier] = STATE(1835),
    [sym__primary_type] = STATE(1862),
    [sym_generic_type] = STATE(1862),
    [sym_type_predicate] = STATE(1862),
    [sym_type_query] = STATE(1862),
    [sym_index_type_query] = STATE(1862),
    [sym_lookup_type] = STATE(1862),
    [sym_literal_type] = STATE(1862),
    [sym__number] = STATE(1878),
    [sym_existential_type] = STATE(1862),
    [sym_flow_maybe_type] = STATE(1862),
    [sym_parenthesized_type] = STATE(1862),
    [sym_predefined_type] = STATE(1862),
    [sym_object_type] = STATE(1862),
    [sym_array_type] = STATE(1862),
    [sym_tuple_type] = STATE(1862),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_typeof] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_QMARK] = ACTIONS(949),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3400),
    [sym_this] = ACTIONS(3818),
    [sym_true] = ACTIONS(3404),
    [sym_false] = ACTIONS(3404),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_keyof] = ACTIONS(969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [988] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3755),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3755),
    [anon_sym_LT] = ACTIONS(3757),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [989] = {
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_as] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_RPAREN] = ACTIONS(1241),
    [anon_sym_in] = ACTIONS(1243),
    [anon_sym_COLON] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_RBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_DOT] = ACTIONS(1241),
    [anon_sym_QMARK] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1243),
    [anon_sym_GT_GT_GT] = ACTIONS(1241),
    [anon_sym_LT_LT] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_CARET] = ACTIONS(1241),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_PERCENT] = ACTIONS(1241),
    [anon_sym_STAR_STAR] = ACTIONS(1241),
    [anon_sym_LT_EQ] = ACTIONS(1241),
    [anon_sym_EQ_EQ] = ACTIONS(1243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1241),
    [anon_sym_BANG_EQ] = ACTIONS(1243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1241),
    [anon_sym_GT_EQ] = ACTIONS(1241),
    [anon_sym_instanceof] = ACTIONS(1241),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [anon_sym_implements] = ACTIONS(1241),
  },
  [990] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_annotation] = STATE(2886),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [991] = {
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_STAR] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1233),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [992] = {
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_as] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_in] = ACTIONS(1129),
    [anon_sym_COLON] = ACTIONS(1131),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_RBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_implements] = ACTIONS(1131),
  },
  [993] = {
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_RBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [anon_sym_implements] = ACTIONS(1205),
  },
  [994] = {
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_COLON] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_RBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_implements] = ACTIONS(1095),
  },
  [995] = {
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(1167),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_RBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [anon_sym_implements] = ACTIONS(1167),
  },
  [996] = {
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_as] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3824),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_RBRACE] = ACTIONS(3824),
    [anon_sym_LPAREN] = ACTIONS(3824),
    [anon_sym_RPAREN] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3822),
    [anon_sym_COLON] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_RBRACK] = ACTIONS(3824),
    [anon_sym_LT] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3822),
    [anon_sym_DOT] = ACTIONS(3824),
    [anon_sym_QMARK] = ACTIONS(3824),
    [anon_sym_AMP_AMP] = ACTIONS(3824),
    [anon_sym_PIPE_PIPE] = ACTIONS(3824),
    [anon_sym_GT_GT] = ACTIONS(3822),
    [anon_sym_GT_GT_GT] = ACTIONS(3824),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_CARET] = ACTIONS(3824),
    [anon_sym_PIPE] = ACTIONS(3822),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3822),
    [anon_sym_PERCENT] = ACTIONS(3824),
    [anon_sym_STAR_STAR] = ACTIONS(3824),
    [anon_sym_LT_EQ] = ACTIONS(3824),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3824),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3824),
    [anon_sym_GT_EQ] = ACTIONS(3824),
    [anon_sym_instanceof] = ACTIONS(3824),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3824),
    [anon_sym_implements] = ACTIONS(3824),
  },
  [997] = {
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_as] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3828),
    [anon_sym_RBRACE] = ACTIONS(3828),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_RPAREN] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3826),
    [anon_sym_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_RBRACK] = ACTIONS(3828),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_GT] = ACTIONS(3826),
    [anon_sym_SLASH] = ACTIONS(3826),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_GT_GT] = ACTIONS(3826),
    [anon_sym_GT_GT_GT] = ACTIONS(3828),
    [anon_sym_LT_LT] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3826),
    [anon_sym_CARET] = ACTIONS(3828),
    [anon_sym_PIPE] = ACTIONS(3826),
    [anon_sym_PLUS] = ACTIONS(3826),
    [anon_sym_DASH] = ACTIONS(3826),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_STAR_STAR] = ACTIONS(3828),
    [anon_sym_LT_EQ] = ACTIONS(3828),
    [anon_sym_EQ_EQ] = ACTIONS(3826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3828),
    [anon_sym_GT_EQ] = ACTIONS(3828),
    [anon_sym_instanceof] = ACTIONS(3828),
    [anon_sym_BANG] = ACTIONS(3826),
    [anon_sym_PLUS_PLUS] = ACTIONS(3828),
    [anon_sym_DASH_DASH] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3828),
    [anon_sym_implements] = ACTIONS(3828),
  },
  [998] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3726),
  },
  [999] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1000] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3766),
  },
  [1001] = {
    [anon_sym_STAR] = ACTIONS(3665),
    [anon_sym_EQ] = ACTIONS(3665),
    [anon_sym_as] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_LPAREN] = ACTIONS(3667),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_of] = ACTIONS(3667),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym_COLON] = ACTIONS(3667),
    [anon_sym_LBRACK] = ACTIONS(3667),
    [anon_sym_LT] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_SLASH] = ACTIONS(3665),
    [anon_sym_DOT] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_PIPE_PIPE] = ACTIONS(3667),
    [anon_sym_GT_GT] = ACTIONS(3665),
    [anon_sym_GT_GT_GT] = ACTIONS(3667),
    [anon_sym_LT_LT] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_CARET] = ACTIONS(3667),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PERCENT] = ACTIONS(3667),
    [anon_sym_STAR_STAR] = ACTIONS(3667),
    [anon_sym_LT_EQ] = ACTIONS(3667),
    [anon_sym_EQ_EQ] = ACTIONS(3665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3667),
    [anon_sym_BANG_EQ] = ACTIONS(3665),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3667),
    [anon_sym_GT_EQ] = ACTIONS(3667),
    [anon_sym_instanceof] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3665),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3667),
    [sym__automatic_semicolon] = ACTIONS(3667),
  },
  [1002] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3867),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3790),
  },
  [1003] = {
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_as] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_in] = ACTIONS(1239),
    [anon_sym_COLON] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_RBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1239),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_implements] = ACTIONS(1237),
  },
  [1004] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1005] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [1006] = {
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_as] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_in] = ACTIONS(2444),
    [anon_sym_COLON] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_RBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_DOT] = ACTIONS(2442),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_GT_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_PERCENT] = ACTIONS(2442),
    [anon_sym_STAR_STAR] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_instanceof] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_implements] = ACTIONS(2442),
  },
  [1007] = {
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_as] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_in] = ACTIONS(2440),
    [anon_sym_COLON] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_RBRACK] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2440),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_DOT] = ACTIONS(589),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(589),
    [anon_sym_PIPE_PIPE] = ACTIONS(589),
    [anon_sym_GT_GT] = ACTIONS(2440),
    [anon_sym_GT_GT_GT] = ACTIONS(589),
    [anon_sym_LT_LT] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_CARET] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_PERCENT] = ACTIONS(589),
    [anon_sym_STAR_STAR] = ACTIONS(589),
    [anon_sym_LT_EQ] = ACTIONS(589),
    [anon_sym_EQ_EQ] = ACTIONS(2440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(589),
    [anon_sym_BANG_EQ] = ACTIONS(2440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(589),
    [anon_sym_GT_EQ] = ACTIONS(589),
    [anon_sym_instanceof] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(589),
    [anon_sym_implements] = ACTIONS(589),
  },
  [1008] = {
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_as] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_in] = ACTIONS(2434),
    [anon_sym_COLON] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2434),
    [anon_sym_DOT] = ACTIONS(2432),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_AMP_AMP] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(2432),
    [anon_sym_GT_GT] = ACTIONS(2434),
    [anon_sym_GT_GT_GT] = ACTIONS(2432),
    [anon_sym_LT_LT] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_CARET] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_PERCENT] = ACTIONS(2432),
    [anon_sym_STAR_STAR] = ACTIONS(2432),
    [anon_sym_LT_EQ] = ACTIONS(2432),
    [anon_sym_EQ_EQ] = ACTIONS(2434),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ] = ACTIONS(2434),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2432),
    [anon_sym_GT_EQ] = ACTIONS(2432),
    [anon_sym_instanceof] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2432),
    [anon_sym_implements] = ACTIONS(2432),
  },
  [1009] = {
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_as] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_COMMA] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_RPAREN] = ACTIONS(3370),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_COLON] = ACTIONS(3370),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_RBRACK] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_DOT] = ACTIONS(3370),
    [anon_sym_QMARK] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_PIPE_PIPE] = ACTIONS(3370),
    [anon_sym_GT_GT] = ACTIONS(3368),
    [anon_sym_GT_GT_GT] = ACTIONS(3370),
    [anon_sym_LT_LT] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_CARET] = ACTIONS(3370),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3370),
    [anon_sym_STAR_STAR] = ACTIONS(3370),
    [anon_sym_LT_EQ] = ACTIONS(3370),
    [anon_sym_EQ_EQ] = ACTIONS(3368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3370),
    [anon_sym_BANG_EQ] = ACTIONS(3368),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3370),
    [anon_sym_GT_EQ] = ACTIONS(3370),
    [anon_sym_instanceof] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [anon_sym_implements] = ACTIONS(3370),
  },
  [1010] = {
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_as] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(3870),
    [anon_sym_RBRACK] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_implements] = ACTIONS(2416),
  },
  [1011] = {
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2500),
    [sym_array] = STATE(2846),
    [sym_spread_element] = STATE(2500),
    [sym_string] = STATE(1984),
    [sym_method_definition] = STATE(2500),
    [sym_pair] = STATE(2500),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_accessibility_modifier] = STATE(1769),
    [aux_sym_object_repeat1] = STATE(2515),
    [sym_identifier] = ACTIONS(3872),
    [anon_sym_export] = ACTIONS(3872),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_type] = ACTIONS(3872),
    [anon_sym_LBRACK] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(3878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(3872),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(3882),
    [anon_sym_get] = ACTIONS(3884),
    [anon_sym_set] = ACTIONS(3884),
    [anon_sym_declare] = ACTIONS(3872),
    [anon_sym_public] = ACTIONS(3886),
    [anon_sym_private] = ACTIONS(3886),
    [anon_sym_protected] = ACTIONS(3886),
    [anon_sym_module] = ACTIONS(3872),
    [anon_sym_any] = ACTIONS(3872),
    [anon_sym_number] = ACTIONS(3872),
    [anon_sym_boolean] = ACTIONS(3872),
    [anon_sym_string] = ACTIONS(3872),
    [anon_sym_symbol] = ACTIONS(3872),
    [sym_readonly] = ACTIONS(3888),
  },
  [1012] = {
    [anon_sym_STAR] = ACTIONS(3890),
    [anon_sym_as] = ACTIONS(3892),
    [anon_sym_LBRACE] = ACTIONS(3892),
    [anon_sym_COMMA] = ACTIONS(3892),
    [anon_sym_RBRACE] = ACTIONS(3892),
    [anon_sym_LPAREN] = ACTIONS(3892),
    [anon_sym_RPAREN] = ACTIONS(3892),
    [anon_sym_in] = ACTIONS(3890),
    [anon_sym_COLON] = ACTIONS(3892),
    [anon_sym_LBRACK] = ACTIONS(3892),
    [anon_sym_RBRACK] = ACTIONS(3892),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_GT] = ACTIONS(3890),
    [anon_sym_SLASH] = ACTIONS(3890),
    [anon_sym_DOT] = ACTIONS(3892),
    [anon_sym_QMARK] = ACTIONS(3892),
    [anon_sym_AMP_AMP] = ACTIONS(3892),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_GT_GT] = ACTIONS(3890),
    [anon_sym_GT_GT_GT] = ACTIONS(3892),
    [anon_sym_LT_LT] = ACTIONS(3892),
    [anon_sym_AMP] = ACTIONS(3890),
    [anon_sym_CARET] = ACTIONS(3892),
    [anon_sym_PIPE] = ACTIONS(3890),
    [anon_sym_PLUS] = ACTIONS(3890),
    [anon_sym_DASH] = ACTIONS(3890),
    [anon_sym_PERCENT] = ACTIONS(3892),
    [anon_sym_STAR_STAR] = ACTIONS(3892),
    [anon_sym_LT_EQ] = ACTIONS(3892),
    [anon_sym_EQ_EQ] = ACTIONS(3890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3892),
    [anon_sym_BANG_EQ] = ACTIONS(3890),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3892),
    [anon_sym_GT_EQ] = ACTIONS(3892),
    [anon_sym_instanceof] = ACTIONS(3892),
    [anon_sym_BANG] = ACTIONS(3890),
    [anon_sym_PLUS_PLUS] = ACTIONS(3892),
    [anon_sym_DASH_DASH] = ACTIONS(3892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3892),
    [anon_sym_implements] = ACTIONS(3892),
  },
  [1013] = {
    [anon_sym_STAR] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_RPAREN] = ACTIONS(1171),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_COLON] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_RBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1171),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_PIPE_PIPE] = ACTIONS(1171),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1171),
    [anon_sym_STAR_STAR] = ACTIONS(1171),
    [anon_sym_LT_EQ] = ACTIONS(1171),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1171),
    [anon_sym_GT_EQ] = ACTIONS(1171),
    [anon_sym_instanceof] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [anon_sym_implements] = ACTIONS(1171),
  },
  [1014] = {
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_as] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_RPAREN] = ACTIONS(1185),
    [anon_sym_in] = ACTIONS(1187),
    [anon_sym_COLON] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_RBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_instanceof] = ACTIONS(1185),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [anon_sym_implements] = ACTIONS(1185),
  },
  [1015] = {
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_RPAREN] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_RBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1135),
    [anon_sym_PIPE_PIPE] = ACTIONS(1135),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_GT_GT_GT] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [anon_sym_implements] = ACTIONS(1135),
  },
  [1016] = {
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_as] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_RPAREN] = ACTIONS(2450),
    [anon_sym_in] = ACTIONS(2452),
    [anon_sym_COLON] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_RBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_DOT] = ACTIONS(2450),
    [anon_sym_QMARK] = ACTIONS(2450),
    [anon_sym_AMP_AMP] = ACTIONS(2450),
    [anon_sym_PIPE_PIPE] = ACTIONS(2450),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_STAR_STAR] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_EQ_EQ] = ACTIONS(2452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG_EQ] = ACTIONS(2452),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2450),
    [anon_sym_DASH_DASH] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [anon_sym_implements] = ACTIONS(2450),
  },
  [1017] = {
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_as] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(2344),
    [anon_sym_COLON] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_RBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(2344),
    [anon_sym_DOT] = ACTIONS(3764),
    [anon_sym_QMARK] = ACTIONS(2342),
    [anon_sym_AMP_AMP] = ACTIONS(2342),
    [anon_sym_PIPE_PIPE] = ACTIONS(2342),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_GT_GT_GT] = ACTIONS(2342),
    [anon_sym_LT_LT] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(2342),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_PERCENT] = ACTIONS(2342),
    [anon_sym_STAR_STAR] = ACTIONS(2342),
    [anon_sym_LT_EQ] = ACTIONS(2342),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2342),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2342),
    [anon_sym_GT_EQ] = ACTIONS(2342),
    [anon_sym_instanceof] = ACTIONS(2342),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [anon_sym_implements] = ACTIONS(2342),
  },
  [1018] = {
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_as] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_in] = ACTIONS(2408),
    [anon_sym_COLON] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(3870),
    [anon_sym_RBRACK] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_SLASH] = ACTIONS(2408),
    [anon_sym_DOT] = ACTIONS(2406),
    [anon_sym_QMARK] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_GT_GT] = ACTIONS(2408),
    [anon_sym_GT_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_CARET] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_PERCENT] = ACTIONS(2406),
    [anon_sym_STAR_STAR] = ACTIONS(2406),
    [anon_sym_LT_EQ] = ACTIONS(2406),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2406),
    [anon_sym_BANG_EQ] = ACTIONS(2408),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2406),
    [anon_sym_GT_EQ] = ACTIONS(2406),
    [anon_sym_instanceof] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_implements] = ACTIONS(2406),
  },
  [1019] = {
    [anon_sym_STAR] = ACTIONS(3894),
    [anon_sym_as] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3788),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3788),
    [anon_sym_RPAREN] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3894),
    [anon_sym_COLON] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3788),
    [anon_sym_RBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3894),
    [anon_sym_GT] = ACTIONS(3894),
    [anon_sym_SLASH] = ACTIONS(3894),
    [anon_sym_DOT] = ACTIONS(3788),
    [anon_sym_QMARK] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_GT_GT] = ACTIONS(3894),
    [anon_sym_GT_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_LT] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_CARET] = ACTIONS(3788),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_PLUS] = ACTIONS(3894),
    [anon_sym_DASH] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(3788),
    [anon_sym_STAR_STAR] = ACTIONS(3788),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_EQ_EQ] = ACTIONS(3894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3788),
    [anon_sym_BANG_EQ] = ACTIONS(3894),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3788),
    [anon_sym_instanceof] = ACTIONS(3788),
    [anon_sym_BANG] = ACTIONS(3894),
    [anon_sym_PLUS_PLUS] = ACTIONS(3788),
    [anon_sym_DASH_DASH] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_implements] = ACTIONS(3788),
  },
  [1020] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_RBRACE] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3768),
  },
  [1021] = {
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_as] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_in] = ACTIONS(2438),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_RBRACK] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_GT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2438),
    [anon_sym_DOT] = ACTIONS(2436),
    [anon_sym_QMARK] = ACTIONS(2436),
    [anon_sym_AMP_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2436),
    [anon_sym_GT_GT] = ACTIONS(2438),
    [anon_sym_GT_GT_GT] = ACTIONS(2436),
    [anon_sym_LT_LT] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_CARET] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_STAR_STAR] = ACTIONS(2436),
    [anon_sym_LT_EQ] = ACTIONS(2436),
    [anon_sym_EQ_EQ] = ACTIONS(2438),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2436),
    [anon_sym_BANG_EQ] = ACTIONS(2438),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2436),
    [anon_sym_GT_EQ] = ACTIONS(2436),
    [anon_sym_instanceof] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2436),
    [anon_sym_implements] = ACTIONS(2436),
  },
  [1022] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3770),
    [anon_sym_RBRACE] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3770),
  },
  [1023] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3896),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3755),
  },
  [1024] = {
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3770),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3770),
    [anon_sym_RBRACE] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_RPAREN] = ACTIONS(3770),
    [anon_sym_in] = ACTIONS(3899),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_RBRACK] = ACTIONS(3770),
    [anon_sym_LT] = ACTIONS(3899),
    [anon_sym_GT] = ACTIONS(3899),
    [anon_sym_SLASH] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_GT_GT] = ACTIONS(3899),
    [anon_sym_GT_GT_GT] = ACTIONS(3770),
    [anon_sym_LT_LT] = ACTIONS(3770),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_CARET] = ACTIONS(3770),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_STAR_STAR] = ACTIONS(3770),
    [anon_sym_LT_EQ] = ACTIONS(3770),
    [anon_sym_EQ_EQ] = ACTIONS(3899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3770),
    [anon_sym_GT_EQ] = ACTIONS(3770),
    [anon_sym_instanceof] = ACTIONS(3770),
    [anon_sym_BANG] = ACTIONS(3899),
    [anon_sym_PLUS_PLUS] = ACTIONS(3770),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3770),
    [anon_sym_implements] = ACTIONS(3770),
  },
  [1025] = {
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_as] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_in] = ACTIONS(2456),
    [anon_sym_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_RBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_SLASH] = ACTIONS(2456),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_GT_GT] = ACTIONS(2456),
    [anon_sym_GT_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_STAR_STAR] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_instanceof] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_implements] = ACTIONS(2454),
  },
  [1026] = {
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(2468),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2468),
    [anon_sym_GT_GT_GT] = ACTIONS(2466),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_STAR_STAR] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2466),
    [anon_sym_GT_EQ] = ACTIONS(2466),
    [anon_sym_instanceof] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2466),
    [anon_sym_implements] = ACTIONS(2466),
  },
  [1027] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_annotation] = STATE(2862),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3901),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1028] = {
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_as] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3768),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_RBRACE] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3768),
    [anon_sym_RPAREN] = ACTIONS(3768),
    [anon_sym_in] = ACTIONS(3903),
    [anon_sym_COLON] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_RBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_SLASH] = ACTIONS(3903),
    [anon_sym_DOT] = ACTIONS(3768),
    [anon_sym_QMARK] = ACTIONS(3768),
    [anon_sym_AMP_AMP] = ACTIONS(3768),
    [anon_sym_PIPE_PIPE] = ACTIONS(3768),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_GT_GT_GT] = ACTIONS(3768),
    [anon_sym_LT_LT] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3903),
    [anon_sym_CARET] = ACTIONS(3768),
    [anon_sym_PIPE] = ACTIONS(3903),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_PERCENT] = ACTIONS(3768),
    [anon_sym_STAR_STAR] = ACTIONS(3768),
    [anon_sym_LT_EQ] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3768),
    [anon_sym_BANG_EQ] = ACTIONS(3903),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3768),
    [anon_sym_GT_EQ] = ACTIONS(3768),
    [anon_sym_instanceof] = ACTIONS(3768),
    [anon_sym_BANG] = ACTIONS(3903),
    [anon_sym_PLUS_PLUS] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3768),
    [anon_sym_implements] = ACTIONS(3768),
  },
  [1029] = {
    [anon_sym_STAR] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3907),
    [anon_sym_LBRACE] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3907),
    [anon_sym_RBRACE] = ACTIONS(3907),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_RPAREN] = ACTIONS(3907),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_RBRACK] = ACTIONS(3907),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3907),
    [anon_sym_LT_LT] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_CARET] = ACTIONS(3907),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_STAR_STAR] = ACTIONS(3907),
    [anon_sym_LT_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ] = ACTIONS(3905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3905),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3907),
    [anon_sym_GT_EQ] = ACTIONS(3907),
    [anon_sym_instanceof] = ACTIONS(3907),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3907),
    [anon_sym_DASH_DASH] = ACTIONS(3907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [anon_sym_implements] = ACTIONS(3907),
  },
  [1030] = {
    [anon_sym_STAR] = ACTIONS(3909),
    [anon_sym_as] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3911),
    [anon_sym_RBRACE] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_RPAREN] = ACTIONS(3911),
    [anon_sym_in] = ACTIONS(3909),
    [anon_sym_COLON] = ACTIONS(3911),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_RBRACK] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_DOT] = ACTIONS(3911),
    [anon_sym_QMARK] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_STAR_STAR] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3909),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_instanceof] = ACTIONS(3911),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_implements] = ACTIONS(3911),
  },
  [1031] = {
    [anon_sym_STAR] = ACTIONS(3913),
    [anon_sym_as] = ACTIONS(3766),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_RPAREN] = ACTIONS(3766),
    [anon_sym_in] = ACTIONS(3913),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_RBRACK] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_SLASH] = ACTIONS(3913),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3913),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3913),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_PLUS] = ACTIONS(3913),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3913),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3913),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_instanceof] = ACTIONS(3766),
    [anon_sym_BANG] = ACTIONS(3913),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3766),
    [anon_sym_implements] = ACTIONS(3766),
  },
  [1032] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3760),
    [anon_sym_RBRACE] = ACTIONS(3760),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3760),
  },
  [1033] = {
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_as] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(2388),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_COLON] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_RBRACK] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_GT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2390),
    [anon_sym_DOT] = ACTIONS(2388),
    [anon_sym_QMARK] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_PIPE_PIPE] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2390),
    [anon_sym_GT_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_CARET] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PERCENT] = ACTIONS(2388),
    [anon_sym_STAR_STAR] = ACTIONS(2388),
    [anon_sym_LT_EQ] = ACTIONS(2388),
    [anon_sym_EQ_EQ] = ACTIONS(2390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2388),
    [anon_sym_BANG_EQ] = ACTIONS(2390),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2388),
    [anon_sym_GT_EQ] = ACTIONS(2388),
    [anon_sym_instanceof] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [anon_sym_implements] = ACTIONS(2388),
  },
  [1034] = {
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_as] = ACTIONS(3917),
    [anon_sym_LBRACE] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3917),
    [anon_sym_RBRACE] = ACTIONS(3917),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_RPAREN] = ACTIONS(3917),
    [anon_sym_in] = ACTIONS(3915),
    [anon_sym_COLON] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_RBRACK] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3915),
    [anon_sym_SLASH] = ACTIONS(3915),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_GT_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3915),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3915),
    [anon_sym_PLUS] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3915),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_STAR_STAR] = ACTIONS(3917),
    [anon_sym_LT_EQ] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3915),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3917),
    [anon_sym_GT_EQ] = ACTIONS(3917),
    [anon_sym_instanceof] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3915),
    [anon_sym_PLUS_PLUS] = ACTIONS(3917),
    [anon_sym_DASH_DASH] = ACTIONS(3917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_implements] = ACTIONS(3917),
  },
  [1035] = {
    [anon_sym_STAR] = ACTIONS(3919),
    [anon_sym_as] = ACTIONS(3921),
    [anon_sym_LBRACE] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3921),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_RPAREN] = ACTIONS(3921),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_COLON] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_RBRACK] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_SLASH] = ACTIONS(3919),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_GT_GT] = ACTIONS(3919),
    [anon_sym_GT_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_CARET] = ACTIONS(3921),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_PLUS] = ACTIONS(3919),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_STAR_STAR] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3919),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3921),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_instanceof] = ACTIONS(3921),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_implements] = ACTIONS(3921),
  },
  [1036] = {
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_as] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_RPAREN] = ACTIONS(2392),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_COLON] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_RBRACK] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2394),
    [anon_sym_DOT] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_PIPE_PIPE] = ACTIONS(2392),
    [anon_sym_GT_GT] = ACTIONS(2394),
    [anon_sym_GT_GT_GT] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_STAR_STAR] = ACTIONS(2392),
    [anon_sym_LT_EQ] = ACTIONS(2392),
    [anon_sym_EQ_EQ] = ACTIONS(2394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2392),
    [anon_sym_BANG_EQ] = ACTIONS(2394),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2392),
    [anon_sym_GT_EQ] = ACTIONS(2392),
    [anon_sym_instanceof] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [anon_sym_implements] = ACTIONS(2392),
  },
  [1037] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_RBRACE] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3778),
  },
  [1038] = {
    [anon_sym_STAR] = ACTIONS(3649),
    [anon_sym_EQ] = ACTIONS(3649),
    [anon_sym_as] = ACTIONS(3651),
    [anon_sym_COMMA] = ACTIONS(3651),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_LPAREN] = ACTIONS(3651),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_of] = ACTIONS(3651),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym_COLON] = ACTIONS(3651),
    [anon_sym_LBRACK] = ACTIONS(3651),
    [anon_sym_LT] = ACTIONS(3649),
    [anon_sym_GT] = ACTIONS(3649),
    [anon_sym_SLASH] = ACTIONS(3649),
    [anon_sym_DOT] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_PIPE_PIPE] = ACTIONS(3651),
    [anon_sym_GT_GT] = ACTIONS(3649),
    [anon_sym_GT_GT_GT] = ACTIONS(3651),
    [anon_sym_LT_LT] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_CARET] = ACTIONS(3651),
    [anon_sym_PIPE] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PERCENT] = ACTIONS(3651),
    [anon_sym_STAR_STAR] = ACTIONS(3651),
    [anon_sym_LT_EQ] = ACTIONS(3651),
    [anon_sym_EQ_EQ] = ACTIONS(3649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3651),
    [anon_sym_BANG_EQ] = ACTIONS(3649),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3651),
    [anon_sym_GT_EQ] = ACTIONS(3651),
    [anon_sym_instanceof] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3649),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3651),
    [sym__automatic_semicolon] = ACTIONS(3651),
  },
  [1039] = {
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_COLON] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_implements] = ACTIONS(2424),
  },
  [1040] = {
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_as] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2348),
    [anon_sym_RPAREN] = ACTIONS(2348),
    [anon_sym_in] = ACTIONS(2350),
    [anon_sym_COLON] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_RBRACK] = ACTIONS(2348),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_GT] = ACTIONS(2350),
    [anon_sym_SLASH] = ACTIONS(2350),
    [anon_sym_DOT] = ACTIONS(2348),
    [anon_sym_QMARK] = ACTIONS(2348),
    [anon_sym_AMP_AMP] = ACTIONS(2348),
    [anon_sym_PIPE_PIPE] = ACTIONS(2348),
    [anon_sym_GT_GT] = ACTIONS(2350),
    [anon_sym_GT_GT_GT] = ACTIONS(2348),
    [anon_sym_LT_LT] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_CARET] = ACTIONS(2348),
    [anon_sym_PIPE] = ACTIONS(2350),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_PERCENT] = ACTIONS(2348),
    [anon_sym_STAR_STAR] = ACTIONS(2348),
    [anon_sym_LT_EQ] = ACTIONS(2348),
    [anon_sym_EQ_EQ] = ACTIONS(2350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2348),
    [anon_sym_BANG_EQ] = ACTIONS(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2348),
    [anon_sym_GT_EQ] = ACTIONS(2348),
    [anon_sym_instanceof] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2348),
    [anon_sym_implements] = ACTIONS(2348),
  },
  [1041] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_RBRACE] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3780),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3780),
  },
  [1042] = {
    [anon_sym_STAR] = ACTIONS(3923),
    [anon_sym_as] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_RBRACE] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_RPAREN] = ACTIONS(3925),
    [anon_sym_in] = ACTIONS(3923),
    [anon_sym_COLON] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_RBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_SLASH] = ACTIONS(3923),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3923),
    [anon_sym_GT_GT_GT] = ACTIONS(3925),
    [anon_sym_LT_LT] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_CARET] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_STAR_STAR] = ACTIONS(3925),
    [anon_sym_LT_EQ] = ACTIONS(3925),
    [anon_sym_EQ_EQ] = ACTIONS(3923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3923),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3925),
    [anon_sym_GT_EQ] = ACTIONS(3925),
    [anon_sym_instanceof] = ACTIONS(3925),
    [anon_sym_BANG] = ACTIONS(3923),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_implements] = ACTIONS(3925),
  },
  [1043] = {
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_as] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_RPAREN] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2400),
    [anon_sym_COLON] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_RBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2400),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_DOT] = ACTIONS(2398),
    [anon_sym_QMARK] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_PIPE_PIPE] = ACTIONS(2398),
    [anon_sym_GT_GT] = ACTIONS(2400),
    [anon_sym_GT_GT_GT] = ACTIONS(2398),
    [anon_sym_LT_LT] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_CARET] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_STAR_STAR] = ACTIONS(2398),
    [anon_sym_LT_EQ] = ACTIONS(2398),
    [anon_sym_EQ_EQ] = ACTIONS(2400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2398),
    [anon_sym_BANG_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2398),
    [anon_sym_GT_EQ] = ACTIONS(2398),
    [anon_sym_instanceof] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [anon_sym_implements] = ACTIONS(2398),
  },
  [1044] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3749),
  },
  [1045] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3747),
    [anon_sym_RBRACE] = ACTIONS(3747),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3747),
  },
  [1046] = {
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_RBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1111),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1111),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1111),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1111),
    [anon_sym_DASH] = ACTIONS(1111),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_implements] = ACTIONS(1109),
  },
  [1047] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3745),
    [anon_sym_RBRACE] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3745),
  },
  [1048] = {
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_RPAREN] = ACTIONS(3929),
    [anon_sym_in] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_RBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [anon_sym_GT_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3929),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_STAR_STAR] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3927),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_implements] = ACTIONS(3929),
  },
  [1049] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(3734),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1050] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1051] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3934),
    [anon_sym_RBRACE] = ACTIONS(3937),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3745),
  },
  [1052] = {
    [anon_sym_STAR] = ACTIONS(3939),
    [anon_sym_as] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_RPAREN] = ACTIONS(3941),
    [anon_sym_in] = ACTIONS(3939),
    [anon_sym_COLON] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_RBRACK] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3939),
    [anon_sym_SLASH] = ACTIONS(3939),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_GT_GT_GT] = ACTIONS(3941),
    [anon_sym_LT_LT] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3939),
    [anon_sym_CARET] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3939),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_DASH] = ACTIONS(3939),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_STAR_STAR] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ_EQ] = ACTIONS(3939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3939),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_instanceof] = ACTIONS(3941),
    [anon_sym_BANG] = ACTIONS(3939),
    [anon_sym_PLUS_PLUS] = ACTIONS(3941),
    [anon_sym_DASH_DASH] = ACTIONS(3941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3941),
    [anon_sym_implements] = ACTIONS(3941),
  },
  [1053] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1054] = {
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_COLON] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_STAR] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1233),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [anon_sym_implements] = ACTIONS(1233),
  },
  [1055] = {
    [anon_sym_STAR] = ACTIONS(3669),
    [anon_sym_EQ] = ACTIONS(3669),
    [anon_sym_as] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_of] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_COLON] = ACTIONS(3671),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3669),
    [anon_sym_GT] = ACTIONS(3669),
    [anon_sym_SLASH] = ACTIONS(3669),
    [anon_sym_DOT] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE] = ACTIONS(3671),
    [anon_sym_GT_GT] = ACTIONS(3669),
    [anon_sym_GT_GT_GT] = ACTIONS(3671),
    [anon_sym_LT_LT] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_CARET] = ACTIONS(3671),
    [anon_sym_PIPE] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PERCENT] = ACTIONS(3671),
    [anon_sym_STAR_STAR] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_EQ_EQ] = ACTIONS(3669),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3669),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3671),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_instanceof] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3669),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3671),
    [sym__automatic_semicolon] = ACTIONS(3671),
  },
  [1056] = {
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_as] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_in] = ACTIONS(1231),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_DOT] = ACTIONS(1229),
    [anon_sym_QMARK] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_STAR_STAR] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_instanceof] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [anon_sym_implements] = ACTIONS(1229),
  },
  [1057] = {
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_as] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2402),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_COLON] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_RBRACK] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_GT] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_DOT] = ACTIONS(2402),
    [anon_sym_QMARK] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_PIPE_PIPE] = ACTIONS(2402),
    [anon_sym_GT_GT] = ACTIONS(2404),
    [anon_sym_GT_GT_GT] = ACTIONS(2402),
    [anon_sym_LT_LT] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_CARET] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PERCENT] = ACTIONS(2402),
    [anon_sym_STAR_STAR] = ACTIONS(2402),
    [anon_sym_LT_EQ] = ACTIONS(2402),
    [anon_sym_EQ_EQ] = ACTIONS(2404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2402),
    [anon_sym_BANG_EQ] = ACTIONS(2404),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2402),
    [anon_sym_GT_EQ] = ACTIONS(2402),
    [anon_sym_instanceof] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [anon_sym_implements] = ACTIONS(2402),
  },
  [1058] = {
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2420),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_GT_GT_GT] = ACTIONS(2420),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_STAR_STAR] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2420),
    [anon_sym_EQ_EQ] = ACTIONS(2422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2420),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_instanceof] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [anon_sym_implements] = ACTIONS(2420),
  },
  [1059] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1433),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [sym__automatic_semicolon] = ACTIONS(3169),
  },
  [1060] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3896),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3755),
  },
  [1061] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3896),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3755),
  },
  [1062] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3626),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_in] = ACTIONS(3626),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3626),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3630),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_GT_GT] = ACTIONS(3626),
    [anon_sym_GT_GT_GT] = ACTIONS(3630),
    [anon_sym_LT_LT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_CARET] = ACTIONS(3630),
    [anon_sym_PIPE] = ACTIONS(3626),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_DASH] = ACTIONS(3626),
    [anon_sym_PERCENT] = ACTIONS(3630),
    [anon_sym_STAR_STAR] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3626),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3630),
    [sym__automatic_semicolon] = ACTIONS(3630),
  },
  [1063] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3943),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3747),
  },
  [1064] = {
    [anon_sym_STAR] = ACTIONS(3948),
    [anon_sym_as] = ACTIONS(3950),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3950),
    [anon_sym_RBRACE] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_RPAREN] = ACTIONS(3950),
    [anon_sym_in] = ACTIONS(3948),
    [anon_sym_COLON] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_RBRACK] = ACTIONS(3950),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_SLASH] = ACTIONS(3948),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_GT_GT] = ACTIONS(3948),
    [anon_sym_GT_GT_GT] = ACTIONS(3950),
    [anon_sym_LT_LT] = ACTIONS(3950),
    [anon_sym_AMP] = ACTIONS(3948),
    [anon_sym_CARET] = ACTIONS(3950),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_PLUS] = ACTIONS(3948),
    [anon_sym_DASH] = ACTIONS(3948),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_STAR_STAR] = ACTIONS(3950),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3948),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3948),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3948),
    [anon_sym_PLUS_PLUS] = ACTIONS(3950),
    [anon_sym_DASH_DASH] = ACTIONS(3950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3950),
    [anon_sym_implements] = ACTIONS(3950),
  },
  [1065] = {
    [anon_sym_STAR] = ACTIONS(2480),
    [anon_sym_as] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_COLON] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_RBRACK] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(2480),
    [anon_sym_GT] = ACTIONS(2480),
    [anon_sym_SLASH] = ACTIONS(2480),
    [anon_sym_DOT] = ACTIONS(2478),
    [anon_sym_QMARK] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2480),
    [anon_sym_GT_GT_GT] = ACTIONS(2478),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_CARET] = ACTIONS(2478),
    [anon_sym_PIPE] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_STAR_STAR] = ACTIONS(2478),
    [anon_sym_LT_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ] = ACTIONS(2480),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2478),
    [anon_sym_GT_EQ] = ACTIONS(2478),
    [anon_sym_instanceof] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2478),
    [anon_sym_implements] = ACTIONS(2478),
  },
  [1066] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1067] = {
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_as] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3954),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_RPAREN] = ACTIONS(3954),
    [anon_sym_in] = ACTIONS(3952),
    [anon_sym_COLON] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_RBRACK] = ACTIONS(3954),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_GT] = ACTIONS(3952),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_GT_GT] = ACTIONS(3952),
    [anon_sym_GT_GT_GT] = ACTIONS(3954),
    [anon_sym_LT_LT] = ACTIONS(3954),
    [anon_sym_AMP] = ACTIONS(3952),
    [anon_sym_CARET] = ACTIONS(3954),
    [anon_sym_PIPE] = ACTIONS(3952),
    [anon_sym_PLUS] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3954),
    [anon_sym_LT_EQ] = ACTIONS(3954),
    [anon_sym_EQ_EQ] = ACTIONS(3952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3952),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3954),
    [anon_sym_GT_EQ] = ACTIONS(3954),
    [anon_sym_instanceof] = ACTIONS(3954),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_PLUS_PLUS] = ACTIONS(3954),
    [anon_sym_DASH_DASH] = ACTIONS(3954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3954),
    [anon_sym_implements] = ACTIONS(3954),
  },
  [1068] = {
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_as] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_COMMA] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_RPAREN] = ACTIONS(2338),
    [anon_sym_in] = ACTIONS(2340),
    [anon_sym_COLON] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_RBRACK] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_GT] = ACTIONS(2340),
    [anon_sym_SLASH] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(3956),
    [anon_sym_QMARK] = ACTIONS(2338),
    [anon_sym_AMP_AMP] = ACTIONS(2338),
    [anon_sym_PIPE_PIPE] = ACTIONS(2338),
    [anon_sym_GT_GT] = ACTIONS(2340),
    [anon_sym_GT_GT_GT] = ACTIONS(2338),
    [anon_sym_LT_LT] = ACTIONS(2338),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_PIPE] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2338),
    [anon_sym_STAR_STAR] = ACTIONS(2338),
    [anon_sym_LT_EQ] = ACTIONS(2338),
    [anon_sym_EQ_EQ] = ACTIONS(2340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2338),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2338),
    [anon_sym_GT_EQ] = ACTIONS(2338),
    [anon_sym_instanceof] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2338),
    [anon_sym_implements] = ACTIONS(2338),
  },
  [1069] = {
    [anon_sym_STAR] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_RPAREN] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_RBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2598),
    [anon_sym_QMARK] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_GT_GT_GT] = ACTIONS(2598),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2598),
    [anon_sym_STAR_STAR] = ACTIONS(2598),
    [anon_sym_LT_EQ] = ACTIONS(2598),
    [anon_sym_EQ_EQ] = ACTIONS(2600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2598),
    [anon_sym_BANG_EQ] = ACTIONS(2600),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2598),
    [anon_sym_GT_EQ] = ACTIONS(2598),
    [anon_sym_instanceof] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [anon_sym_implements] = ACTIONS(2598),
  },
  [1070] = {
    [anon_sym_STAR] = ACTIONS(3963),
    [anon_sym_as] = ACTIONS(3965),
    [anon_sym_LBRACE] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3965),
    [anon_sym_RBRACE] = ACTIONS(3965),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_RPAREN] = ACTIONS(3965),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_RBRACK] = ACTIONS(3965),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_GT] = ACTIONS(3963),
    [anon_sym_SLASH] = ACTIONS(3963),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_GT_GT] = ACTIONS(3963),
    [anon_sym_GT_GT_GT] = ACTIONS(3965),
    [anon_sym_LT_LT] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_CARET] = ACTIONS(3965),
    [anon_sym_PIPE] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3965),
    [anon_sym_EQ_EQ] = ACTIONS(3963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3963),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3965),
    [anon_sym_GT_EQ] = ACTIONS(3965),
    [anon_sym_instanceof] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3963),
    [anon_sym_PLUS_PLUS] = ACTIONS(3965),
    [anon_sym_DASH_DASH] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3965),
    [anon_sym_implements] = ACTIONS(3965),
  },
  [1071] = {
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_as] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_COLON] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_RBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2592),
    [anon_sym_GT] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_GT_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_STAR_STAR] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2590),
    [anon_sym_instanceof] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [anon_sym_implements] = ACTIONS(2590),
  },
  [1072] = {
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_as] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_instanceof] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [anon_sym_implements] = ACTIONS(1225),
  },
  [1073] = {
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_as] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1083),
    [anon_sym_RPAREN] = ACTIONS(1083),
    [anon_sym_in] = ACTIONS(1081),
    [anon_sym_COLON] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1083),
    [anon_sym_RBRACK] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_STAR_STAR] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1083),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [anon_sym_implements] = ACTIONS(1083),
  },
  [1074] = {
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_as] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_COMMA] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_RPAREN] = ACTIONS(2384),
    [anon_sym_in] = ACTIONS(2386),
    [anon_sym_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_RBRACK] = ACTIONS(2384),
    [anon_sym_LT] = ACTIONS(2386),
    [anon_sym_GT] = ACTIONS(2386),
    [anon_sym_SLASH] = ACTIONS(2386),
    [anon_sym_DOT] = ACTIONS(2384),
    [anon_sym_QMARK] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_PIPE_PIPE] = ACTIONS(2384),
    [anon_sym_GT_GT] = ACTIONS(2386),
    [anon_sym_GT_GT_GT] = ACTIONS(2384),
    [anon_sym_LT_LT] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_CARET] = ACTIONS(2384),
    [anon_sym_PIPE] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_PERCENT] = ACTIONS(2384),
    [anon_sym_STAR_STAR] = ACTIONS(2384),
    [anon_sym_LT_EQ] = ACTIONS(2384),
    [anon_sym_EQ_EQ] = ACTIONS(2386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2384),
    [anon_sym_BANG_EQ] = ACTIONS(2386),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2384),
    [anon_sym_GT_EQ] = ACTIONS(2384),
    [anon_sym_instanceof] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2384),
    [anon_sym_implements] = ACTIONS(2384),
  },
  [1075] = {
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_RPAREN] = ACTIONS(3969),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_RBRACK] = ACTIONS(3969),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3967),
    [anon_sym_GT_GT_GT] = ACTIONS(3969),
    [anon_sym_LT_LT] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3969),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_instanceof] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3967),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [anon_sym_implements] = ACTIONS(3969),
  },
  [1076] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(3634),
    [anon_sym_COMMA] = ACTIONS(3634),
    [anon_sym_RBRACE] = ACTIONS(3634),
    [anon_sym_LPAREN] = ACTIONS(3634),
    [anon_sym_in] = ACTIONS(3632),
    [anon_sym_SEMI] = ACTIONS(3634),
    [anon_sym_LBRACK] = ACTIONS(3634),
    [anon_sym_LT] = ACTIONS(3632),
    [anon_sym_GT] = ACTIONS(3632),
    [anon_sym_SLASH] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(3634),
    [anon_sym_QMARK] = ACTIONS(3634),
    [anon_sym_AMP_AMP] = ACTIONS(3634),
    [anon_sym_PIPE_PIPE] = ACTIONS(3634),
    [anon_sym_GT_GT] = ACTIONS(3632),
    [anon_sym_GT_GT_GT] = ACTIONS(3634),
    [anon_sym_LT_LT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_CARET] = ACTIONS(3634),
    [anon_sym_PIPE] = ACTIONS(3632),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_PERCENT] = ACTIONS(3634),
    [anon_sym_STAR_STAR] = ACTIONS(3634),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_EQ_EQ] = ACTIONS(3632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3634),
    [anon_sym_BANG_EQ] = ACTIONS(3632),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3634),
    [anon_sym_instanceof] = ACTIONS(3634),
    [anon_sym_BANG] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3634),
    [anon_sym_DASH_DASH] = ACTIONS(3634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3634),
    [sym__automatic_semicolon] = ACTIONS(3634),
  },
  [1077] = {
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_RPAREN] = ACTIONS(1113),
    [anon_sym_in] = ACTIONS(1115),
    [anon_sym_COLON] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_RBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_GT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_DOT] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_AMP_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1115),
    [anon_sym_GT_GT_GT] = ACTIONS(1113),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1113),
    [anon_sym_GT_EQ] = ACTIONS(1113),
    [anon_sym_instanceof] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [anon_sym_implements] = ACTIONS(1113),
  },
  [1078] = {
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_as] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_RPAREN] = ACTIONS(2482),
    [anon_sym_in] = ACTIONS(2484),
    [anon_sym_COLON] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_RBRACK] = ACTIONS(2482),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_GT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2484),
    [anon_sym_DOT] = ACTIONS(2482),
    [anon_sym_QMARK] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(2482),
    [anon_sym_PIPE_PIPE] = ACTIONS(2482),
    [anon_sym_GT_GT] = ACTIONS(2484),
    [anon_sym_GT_GT_GT] = ACTIONS(2482),
    [anon_sym_LT_LT] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_CARET] = ACTIONS(2482),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_PERCENT] = ACTIONS(2482),
    [anon_sym_STAR_STAR] = ACTIONS(2482),
    [anon_sym_LT_EQ] = ACTIONS(2482),
    [anon_sym_EQ_EQ] = ACTIONS(2484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2482),
    [anon_sym_BANG_EQ] = ACTIONS(2484),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2482),
    [anon_sym_GT_EQ] = ACTIONS(2482),
    [anon_sym_instanceof] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2482),
    [anon_sym_DASH_DASH] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2482),
    [anon_sym_implements] = ACTIONS(2482),
  },
  [1079] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3790),
    [anon_sym_RBRACE] = ACTIONS(3790),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3790),
  },
  [1080] = {
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_as] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2470),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_RPAREN] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2472),
    [anon_sym_COLON] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_RBRACK] = ACTIONS(2470),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2472),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_GT_GT] = ACTIONS(2472),
    [anon_sym_GT_GT_GT] = ACTIONS(2470),
    [anon_sym_LT_LT] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_PIPE] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2472),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2470),
    [anon_sym_LT_EQ] = ACTIONS(2470),
    [anon_sym_EQ_EQ] = ACTIONS(2472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2470),
    [anon_sym_GT_EQ] = ACTIONS(2470),
    [anon_sym_instanceof] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2470),
    [anon_sym_implements] = ACTIONS(2470),
  },
  [1081] = {
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_as] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_RPAREN] = ACTIONS(1181),
    [anon_sym_in] = ACTIONS(1179),
    [anon_sym_COLON] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1179),
    [anon_sym_GT] = ACTIONS(1179),
    [anon_sym_SLASH] = ACTIONS(1179),
    [anon_sym_DOT] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1179),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_PLUS] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [anon_sym_implements] = ACTIONS(1181),
  },
  [1082] = {
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_as] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_RBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_GT_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_STAR_STAR] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_instanceof] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_implements] = ACTIONS(2462),
  },
  [1083] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [aux_sym_extends_clause_repeat1] = STATE(2336),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3454),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
  },
  [1084] = {
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_as] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_RPAREN] = ACTIONS(2446),
    [anon_sym_in] = ACTIONS(2448),
    [anon_sym_COLON] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_RBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(2448),
    [anon_sym_DOT] = ACTIONS(2446),
    [anon_sym_QMARK] = ACTIONS(2446),
    [anon_sym_AMP_AMP] = ACTIONS(2446),
    [anon_sym_PIPE_PIPE] = ACTIONS(2446),
    [anon_sym_GT_GT] = ACTIONS(2448),
    [anon_sym_GT_GT_GT] = ACTIONS(2446),
    [anon_sym_LT_LT] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PERCENT] = ACTIONS(2446),
    [anon_sym_STAR_STAR] = ACTIONS(2446),
    [anon_sym_LT_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2446),
    [anon_sym_GT_EQ] = ACTIONS(2446),
    [anon_sym_instanceof] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [anon_sym_implements] = ACTIONS(2446),
  },
  [1085] = {
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_as] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_RPAREN] = ACTIONS(2412),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_RBRACK] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_DOT] = ACTIONS(2412),
    [anon_sym_QMARK] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_GT_GT] = ACTIONS(2414),
    [anon_sym_GT_GT_GT] = ACTIONS(2412),
    [anon_sym_LT_LT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_CARET] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2412),
    [anon_sym_STAR_STAR] = ACTIONS(2412),
    [anon_sym_LT_EQ] = ACTIONS(2412),
    [anon_sym_EQ_EQ] = ACTIONS(2414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2412),
    [anon_sym_BANG_EQ] = ACTIONS(2414),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2412),
    [anon_sym_GT_EQ] = ACTIONS(2412),
    [anon_sym_instanceof] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [anon_sym_implements] = ACTIONS(2412),
  },
  [1086] = {
    [anon_sym_STAR] = ACTIONS(4007),
    [anon_sym_as] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4009),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_RBRACE] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4009),
    [anon_sym_RPAREN] = ACTIONS(4009),
    [anon_sym_in] = ACTIONS(4007),
    [anon_sym_COLON] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(4009),
    [anon_sym_RBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4007),
    [anon_sym_GT] = ACTIONS(4007),
    [anon_sym_SLASH] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(4009),
    [anon_sym_AMP_AMP] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4007),
    [anon_sym_GT_GT_GT] = ACTIONS(4009),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_PIPE] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_STAR_STAR] = ACTIONS(4009),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_EQ_EQ] = ACTIONS(4007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4009),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4009),
    [anon_sym_instanceof] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_PLUS_PLUS] = ACTIONS(4009),
    [anon_sym_DASH_DASH] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4009),
    [anon_sym_implements] = ACTIONS(4009),
  },
  [1087] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3788),
  },
  [1088] = {
    [anon_sym_STAR] = ACTIONS(2604),
    [anon_sym_as] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_COLON] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_RBRACK] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_DOT] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_GT_GT_GT] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(2602),
    [anon_sym_STAR_STAR] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2602),
    [anon_sym_instanceof] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_implements] = ACTIONS(2602),
  },
  [1089] = {
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_as] = ACTIONS(4013),
    [anon_sym_LBRACE] = ACTIONS(4013),
    [anon_sym_COMMA] = ACTIONS(4013),
    [anon_sym_RBRACE] = ACTIONS(4013),
    [anon_sym_LPAREN] = ACTIONS(4013),
    [anon_sym_RPAREN] = ACTIONS(4013),
    [anon_sym_in] = ACTIONS(4011),
    [anon_sym_COLON] = ACTIONS(4013),
    [anon_sym_LBRACK] = ACTIONS(4013),
    [anon_sym_RBRACK] = ACTIONS(4013),
    [anon_sym_LT] = ACTIONS(4011),
    [anon_sym_GT] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4013),
    [anon_sym_QMARK] = ACTIONS(4013),
    [anon_sym_AMP_AMP] = ACTIONS(4013),
    [anon_sym_PIPE_PIPE] = ACTIONS(4013),
    [anon_sym_GT_GT] = ACTIONS(4011),
    [anon_sym_GT_GT_GT] = ACTIONS(4013),
    [anon_sym_LT_LT] = ACTIONS(4013),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_CARET] = ACTIONS(4013),
    [anon_sym_PIPE] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4013),
    [anon_sym_STAR_STAR] = ACTIONS(4013),
    [anon_sym_LT_EQ] = ACTIONS(4013),
    [anon_sym_EQ_EQ] = ACTIONS(4011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4013),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4013),
    [anon_sym_GT_EQ] = ACTIONS(4013),
    [anon_sym_instanceof] = ACTIONS(4013),
    [anon_sym_BANG] = ACTIONS(4011),
    [anon_sym_PLUS_PLUS] = ACTIONS(4013),
    [anon_sym_DASH_DASH] = ACTIONS(4013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4013),
    [anon_sym_implements] = ACTIONS(4013),
  },
  [1090] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3786),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3786),
  },
  [1091] = {
    [anon_sym_STAR] = ACTIONS(2382),
    [anon_sym_as] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_COMMA] = ACTIONS(2380),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2380),
    [anon_sym_RPAREN] = ACTIONS(2380),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2380),
    [anon_sym_RBRACK] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_GT] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(2382),
    [anon_sym_DOT] = ACTIONS(2380),
    [anon_sym_QMARK] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_PIPE_PIPE] = ACTIONS(2380),
    [anon_sym_GT_GT] = ACTIONS(2382),
    [anon_sym_GT_GT_GT] = ACTIONS(2380),
    [anon_sym_LT_LT] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_CARET] = ACTIONS(2380),
    [anon_sym_PIPE] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_PERCENT] = ACTIONS(2380),
    [anon_sym_STAR_STAR] = ACTIONS(2380),
    [anon_sym_LT_EQ] = ACTIONS(2380),
    [anon_sym_EQ_EQ] = ACTIONS(2382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2380),
    [anon_sym_BANG_EQ] = ACTIONS(2382),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2380),
    [anon_sym_instanceof] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2380),
    [anon_sym_implements] = ACTIONS(2380),
  },
  [1092] = {
    [anon_sym_STAR] = ACTIONS(3661),
    [anon_sym_EQ] = ACTIONS(3661),
    [anon_sym_as] = ACTIONS(3663),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_LPAREN] = ACTIONS(3663),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_of] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(3661),
    [anon_sym_GT] = ACTIONS(3661),
    [anon_sym_SLASH] = ACTIONS(3661),
    [anon_sym_DOT] = ACTIONS(3663),
    [anon_sym_QMARK] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_GT_GT] = ACTIONS(3661),
    [anon_sym_GT_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_LT] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_CARET] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3661),
    [anon_sym_PLUS] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(3661),
    [anon_sym_PERCENT] = ACTIONS(3663),
    [anon_sym_STAR_STAR] = ACTIONS(3663),
    [anon_sym_LT_EQ] = ACTIONS(3663),
    [anon_sym_EQ_EQ] = ACTIONS(3661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3663),
    [anon_sym_BANG_EQ] = ACTIONS(3661),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3663),
    [anon_sym_GT_EQ] = ACTIONS(3663),
    [anon_sym_instanceof] = ACTIONS(3663),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_PLUS_PLUS] = ACTIONS(3663),
    [anon_sym_DASH_DASH] = ACTIONS(3663),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [sym__automatic_semicolon] = ACTIONS(3663),
  },
  [1093] = {
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_implements] = ACTIONS(2428),
  },
  [1094] = {
    [anon_sym_STAR] = ACTIONS(2564),
    [anon_sym_as] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_RBRACK] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_GT] = ACTIONS(2564),
    [anon_sym_SLASH] = ACTIONS(2564),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_GT_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_DASH] = ACTIONS(2564),
    [anon_sym_PERCENT] = ACTIONS(2562),
    [anon_sym_STAR_STAR] = ACTIONS(2562),
    [anon_sym_LT_EQ] = ACTIONS(2562),
    [anon_sym_EQ_EQ] = ACTIONS(2564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2562),
    [anon_sym_BANG_EQ] = ACTIONS(2564),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2562),
    [anon_sym_GT_EQ] = ACTIONS(2562),
    [anon_sym_instanceof] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2564),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_implements] = ACTIONS(2562),
  },
  [1095] = {
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_as] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_RPAREN] = ACTIONS(2458),
    [anon_sym_in] = ACTIONS(2460),
    [anon_sym_COLON] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_RBRACK] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_GT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_DOT] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2458),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_CARET] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_PERCENT] = ACTIONS(2458),
    [anon_sym_STAR_STAR] = ACTIONS(2458),
    [anon_sym_LT_EQ] = ACTIONS(2458),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2458),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2458),
    [anon_sym_GT_EQ] = ACTIONS(2458),
    [anon_sym_instanceof] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2458),
    [anon_sym_DASH_DASH] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2458),
    [anon_sym_implements] = ACTIONS(2458),
  },
  [1096] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_annotation] = STATE(2840),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4015),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1097] = {
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2526),
    [sym_array] = STATE(2846),
    [sym_spread_element] = STATE(2526),
    [sym_string] = STATE(1984),
    [sym_method_definition] = STATE(2526),
    [sym_pair] = STATE(2526),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_accessibility_modifier] = STATE(1769),
    [aux_sym_object_repeat1] = STATE(2527),
    [sym_identifier] = ACTIONS(4017),
    [anon_sym_export] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4017),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4019),
    [anon_sym_type] = ACTIONS(4017),
    [anon_sym_LBRACK] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(4021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4017),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(4023),
    [anon_sym_get] = ACTIONS(4025),
    [anon_sym_set] = ACTIONS(4025),
    [anon_sym_declare] = ACTIONS(4017),
    [anon_sym_public] = ACTIONS(4027),
    [anon_sym_private] = ACTIONS(4027),
    [anon_sym_protected] = ACTIONS(4027),
    [anon_sym_module] = ACTIONS(4017),
    [anon_sym_any] = ACTIONS(4017),
    [anon_sym_number] = ACTIONS(4017),
    [anon_sym_boolean] = ACTIONS(4017),
    [anon_sym_string] = ACTIONS(4017),
    [anon_sym_symbol] = ACTIONS(4017),
    [sym_readonly] = ACTIONS(4029),
  },
  [1098] = {
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_as] = ACTIONS(2580),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_COLON] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_GT_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(3959),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(3961),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2582),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_BANG_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2580),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_instanceof] = ACTIONS(2580),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2580),
    [anon_sym_implements] = ACTIONS(2580),
  },
  [1099] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(4031),
    [anon_sym_RBRACE] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4031),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4031),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1100] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1101] = {
    [anon_sym_STAR] = ACTIONS(3584),
    [anon_sym_as] = ACTIONS(3588),
    [anon_sym_LBRACE] = ACTIONS(3588),
    [anon_sym_COMMA] = ACTIONS(3588),
    [anon_sym_RBRACE] = ACTIONS(3588),
    [anon_sym_LPAREN] = ACTIONS(3588),
    [anon_sym_RPAREN] = ACTIONS(3588),
    [anon_sym_in] = ACTIONS(3584),
    [anon_sym_COLON] = ACTIONS(3588),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_RBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(3584),
    [anon_sym_GT] = ACTIONS(3584),
    [anon_sym_SLASH] = ACTIONS(3584),
    [anon_sym_DOT] = ACTIONS(3588),
    [anon_sym_QMARK] = ACTIONS(3588),
    [anon_sym_AMP_AMP] = ACTIONS(3588),
    [anon_sym_PIPE_PIPE] = ACTIONS(3588),
    [anon_sym_GT_GT] = ACTIONS(3584),
    [anon_sym_GT_GT_GT] = ACTIONS(3588),
    [anon_sym_LT_LT] = ACTIONS(3588),
    [anon_sym_AMP] = ACTIONS(3584),
    [anon_sym_CARET] = ACTIONS(3588),
    [anon_sym_PIPE] = ACTIONS(3584),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_DASH] = ACTIONS(3584),
    [anon_sym_PERCENT] = ACTIONS(3588),
    [anon_sym_STAR_STAR] = ACTIONS(3588),
    [anon_sym_LT_EQ] = ACTIONS(3588),
    [anon_sym_EQ_EQ] = ACTIONS(3584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3588),
    [anon_sym_BANG_EQ] = ACTIONS(3584),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3588),
    [anon_sym_GT_EQ] = ACTIONS(3588),
    [anon_sym_instanceof] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3584),
    [anon_sym_PLUS_PLUS] = ACTIONS(3588),
    [anon_sym_DASH_DASH] = ACTIONS(3588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3588),
    [anon_sym_implements] = ACTIONS(3588),
  },
  [1102] = {
    [anon_sym_STAR] = ACTIONS(3657),
    [anon_sym_EQ] = ACTIONS(3657),
    [anon_sym_as] = ACTIONS(3659),
    [anon_sym_COMMA] = ACTIONS(3659),
    [anon_sym_RBRACE] = ACTIONS(3659),
    [anon_sym_LPAREN] = ACTIONS(3659),
    [anon_sym_in] = ACTIONS(3657),
    [anon_sym_of] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_COLON] = ACTIONS(3659),
    [anon_sym_LBRACK] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3657),
    [anon_sym_GT] = ACTIONS(3657),
    [anon_sym_SLASH] = ACTIONS(3657),
    [anon_sym_DOT] = ACTIONS(3659),
    [anon_sym_QMARK] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_GT_GT_GT] = ACTIONS(3659),
    [anon_sym_LT_LT] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3657),
    [anon_sym_CARET] = ACTIONS(3659),
    [anon_sym_PIPE] = ACTIONS(3657),
    [anon_sym_PLUS] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(3657),
    [anon_sym_PERCENT] = ACTIONS(3659),
    [anon_sym_STAR_STAR] = ACTIONS(3659),
    [anon_sym_LT_EQ] = ACTIONS(3659),
    [anon_sym_EQ_EQ] = ACTIONS(3657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3659),
    [anon_sym_BANG_EQ] = ACTIONS(3657),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3659),
    [anon_sym_GT_EQ] = ACTIONS(3659),
    [anon_sym_instanceof] = ACTIONS(3659),
    [anon_sym_BANG] = ACTIONS(3657),
    [anon_sym_PLUS_PLUS] = ACTIONS(3659),
    [anon_sym_DASH_DASH] = ACTIONS(3659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [sym__automatic_semicolon] = ACTIONS(3659),
  },
  [1103] = {
    [anon_sym_STAR] = ACTIONS(2476),
    [anon_sym_as] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_RPAREN] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2476),
    [anon_sym_COLON] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_RBRACK] = ACTIONS(2474),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_GT] = ACTIONS(2476),
    [anon_sym_SLASH] = ACTIONS(2476),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_GT_GT] = ACTIONS(2476),
    [anon_sym_GT_GT_GT] = ACTIONS(2474),
    [anon_sym_LT_LT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_CARET] = ACTIONS(2474),
    [anon_sym_PIPE] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_LT_EQ] = ACTIONS(2474),
    [anon_sym_EQ_EQ] = ACTIONS(2476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2474),
    [anon_sym_GT_EQ] = ACTIONS(2474),
    [anon_sym_instanceof] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2474),
    [anon_sym_DASH_DASH] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2474),
    [anon_sym_implements] = ACTIONS(2474),
  },
  [1104] = {
    [anon_sym_STAR] = ACTIONS(4033),
    [anon_sym_as] = ACTIONS(4035),
    [anon_sym_LBRACE] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LPAREN] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4035),
    [anon_sym_in] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_RBRACK] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4033),
    [anon_sym_GT] = ACTIONS(4033),
    [anon_sym_SLASH] = ACTIONS(4033),
    [anon_sym_DOT] = ACTIONS(4035),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_GT_GT_GT] = ACTIONS(4035),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4033),
    [anon_sym_CARET] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4033),
    [anon_sym_DASH] = ACTIONS(4033),
    [anon_sym_PERCENT] = ACTIONS(4035),
    [anon_sym_STAR_STAR] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4035),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_instanceof] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4035),
    [anon_sym_implements] = ACTIONS(4035),
  },
  [1105] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_annotation] = STATE(2854),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4037),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1106] = {
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2484),
    [sym_array] = STATE(2846),
    [sym_spread_element] = STATE(2484),
    [sym_string] = STATE(1984),
    [sym_method_definition] = STATE(2484),
    [sym_pair] = STATE(2484),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_accessibility_modifier] = STATE(1769),
    [aux_sym_object_repeat1] = STATE(2486),
    [sym_identifier] = ACTIONS(4039),
    [anon_sym_export] = ACTIONS(4039),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4039),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_type] = ACTIONS(4039),
    [anon_sym_LBRACK] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(4043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4039),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(4045),
    [anon_sym_get] = ACTIONS(4047),
    [anon_sym_set] = ACTIONS(4047),
    [anon_sym_declare] = ACTIONS(4039),
    [anon_sym_public] = ACTIONS(4049),
    [anon_sym_private] = ACTIONS(4049),
    [anon_sym_protected] = ACTIONS(4049),
    [anon_sym_module] = ACTIONS(4039),
    [anon_sym_any] = ACTIONS(4039),
    [anon_sym_number] = ACTIONS(4039),
    [anon_sym_boolean] = ACTIONS(4039),
    [anon_sym_string] = ACTIONS(4039),
    [anon_sym_symbol] = ACTIONS(4039),
    [sym_readonly] = ACTIONS(4051),
  },
  [1107] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_of] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(1073),
  },
  [1108] = {
    [anon_sym_STAR] = ACTIONS(4053),
    [anon_sym_as] = ACTIONS(4055),
    [anon_sym_LBRACE] = ACTIONS(4055),
    [anon_sym_COMMA] = ACTIONS(4055),
    [anon_sym_RBRACE] = ACTIONS(4055),
    [anon_sym_LPAREN] = ACTIONS(4055),
    [anon_sym_RPAREN] = ACTIONS(4055),
    [anon_sym_in] = ACTIONS(4053),
    [anon_sym_COLON] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(4055),
    [anon_sym_RBRACK] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4053),
    [anon_sym_GT] = ACTIONS(4053),
    [anon_sym_SLASH] = ACTIONS(4053),
    [anon_sym_DOT] = ACTIONS(4055),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_AMP_AMP] = ACTIONS(4055),
    [anon_sym_PIPE_PIPE] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_GT_GT_GT] = ACTIONS(4055),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_CARET] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_PERCENT] = ACTIONS(4055),
    [anon_sym_STAR_STAR] = ACTIONS(4055),
    [anon_sym_LT_EQ] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4055),
    [anon_sym_BANG_EQ] = ACTIONS(4053),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4055),
    [anon_sym_GT_EQ] = ACTIONS(4055),
    [anon_sym_instanceof] = ACTIONS(4055),
    [anon_sym_BANG] = ACTIONS(4053),
    [anon_sym_PLUS_PLUS] = ACTIONS(4055),
    [anon_sym_DASH_DASH] = ACTIONS(4055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4055),
    [anon_sym_implements] = ACTIONS(4055),
  },
  [1109] = {
    [anon_sym_STAR] = ACTIONS(4057),
    [anon_sym_as] = ACTIONS(4059),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_COMMA] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(4059),
    [anon_sym_RPAREN] = ACTIONS(4059),
    [anon_sym_in] = ACTIONS(4057),
    [anon_sym_COLON] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4059),
    [anon_sym_RBRACK] = ACTIONS(4059),
    [anon_sym_LT] = ACTIONS(4057),
    [anon_sym_GT] = ACTIONS(4057),
    [anon_sym_SLASH] = ACTIONS(4057),
    [anon_sym_DOT] = ACTIONS(4059),
    [anon_sym_QMARK] = ACTIONS(4059),
    [anon_sym_AMP_AMP] = ACTIONS(4059),
    [anon_sym_PIPE_PIPE] = ACTIONS(4059),
    [anon_sym_GT_GT] = ACTIONS(4057),
    [anon_sym_GT_GT_GT] = ACTIONS(4059),
    [anon_sym_LT_LT] = ACTIONS(4059),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_CARET] = ACTIONS(4059),
    [anon_sym_PIPE] = ACTIONS(4057),
    [anon_sym_PLUS] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4057),
    [anon_sym_PERCENT] = ACTIONS(4059),
    [anon_sym_STAR_STAR] = ACTIONS(4059),
    [anon_sym_LT_EQ] = ACTIONS(4059),
    [anon_sym_EQ_EQ] = ACTIONS(4057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4059),
    [anon_sym_BANG_EQ] = ACTIONS(4057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4059),
    [anon_sym_GT_EQ] = ACTIONS(4059),
    [anon_sym_instanceof] = ACTIONS(4059),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_PLUS_PLUS] = ACTIONS(4059),
    [anon_sym_DASH_DASH] = ACTIONS(4059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4059),
    [anon_sym_implements] = ACTIONS(4059),
  },
  [1110] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3931),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1111] = {
    [anon_sym_STAR] = ACTIONS(4061),
    [anon_sym_as] = ACTIONS(4063),
    [anon_sym_LBRACE] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [anon_sym_LPAREN] = ACTIONS(4063),
    [anon_sym_RPAREN] = ACTIONS(4063),
    [anon_sym_in] = ACTIONS(4061),
    [anon_sym_COLON] = ACTIONS(4063),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_RBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(4061),
    [anon_sym_GT] = ACTIONS(4061),
    [anon_sym_SLASH] = ACTIONS(4061),
    [anon_sym_DOT] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(4063),
    [anon_sym_AMP_AMP] = ACTIONS(4063),
    [anon_sym_PIPE_PIPE] = ACTIONS(4063),
    [anon_sym_GT_GT] = ACTIONS(4061),
    [anon_sym_GT_GT_GT] = ACTIONS(4063),
    [anon_sym_LT_LT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4061),
    [anon_sym_CARET] = ACTIONS(4063),
    [anon_sym_PIPE] = ACTIONS(4061),
    [anon_sym_PLUS] = ACTIONS(4061),
    [anon_sym_DASH] = ACTIONS(4061),
    [anon_sym_PERCENT] = ACTIONS(4063),
    [anon_sym_STAR_STAR] = ACTIONS(4063),
    [anon_sym_LT_EQ] = ACTIONS(4063),
    [anon_sym_EQ_EQ] = ACTIONS(4061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4063),
    [anon_sym_BANG_EQ] = ACTIONS(4061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4063),
    [anon_sym_GT_EQ] = ACTIONS(4063),
    [anon_sym_instanceof] = ACTIONS(4063),
    [anon_sym_BANG] = ACTIONS(4061),
    [anon_sym_PLUS_PLUS] = ACTIONS(4063),
    [anon_sym_DASH_DASH] = ACTIONS(4063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4063),
    [anon_sym_implements] = ACTIONS(4063),
  },
  [1112] = {
    [anon_sym_STAR] = ACTIONS(4061),
    [anon_sym_as] = ACTIONS(4063),
    [anon_sym_LBRACE] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [anon_sym_LPAREN] = ACTIONS(4063),
    [anon_sym_RPAREN] = ACTIONS(4063),
    [anon_sym_in] = ACTIONS(4061),
    [anon_sym_COLON] = ACTIONS(4063),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_RBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(4061),
    [anon_sym_GT] = ACTIONS(4061),
    [anon_sym_SLASH] = ACTIONS(4061),
    [anon_sym_DOT] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(4063),
    [anon_sym_AMP_AMP] = ACTIONS(4063),
    [anon_sym_PIPE_PIPE] = ACTIONS(4063),
    [anon_sym_GT_GT] = ACTIONS(4061),
    [anon_sym_GT_GT_GT] = ACTIONS(4063),
    [anon_sym_LT_LT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4061),
    [anon_sym_CARET] = ACTIONS(4063),
    [anon_sym_PIPE] = ACTIONS(4061),
    [anon_sym_PLUS] = ACTIONS(4061),
    [anon_sym_DASH] = ACTIONS(4061),
    [anon_sym_PERCENT] = ACTIONS(4063),
    [anon_sym_STAR_STAR] = ACTIONS(4063),
    [anon_sym_LT_EQ] = ACTIONS(4063),
    [anon_sym_EQ_EQ] = ACTIONS(4061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4063),
    [anon_sym_BANG_EQ] = ACTIONS(4061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4063),
    [anon_sym_GT_EQ] = ACTIONS(4063),
    [anon_sym_instanceof] = ACTIONS(4063),
    [anon_sym_BANG] = ACTIONS(4061),
    [anon_sym_PLUS_PLUS] = ACTIONS(4063),
    [anon_sym_DASH_DASH] = ACTIONS(4063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4063),
    [anon_sym_implements] = ACTIONS(4063),
  },
  [1113] = {
    [anon_sym_STAR] = ACTIONS(4065),
    [anon_sym_as] = ACTIONS(4067),
    [anon_sym_LBRACE] = ACTIONS(4067),
    [anon_sym_COMMA] = ACTIONS(4067),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(4067),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [anon_sym_in] = ACTIONS(4065),
    [anon_sym_COLON] = ACTIONS(4067),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_RBRACK] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4065),
    [anon_sym_GT] = ACTIONS(4065),
    [anon_sym_SLASH] = ACTIONS(4065),
    [anon_sym_DOT] = ACTIONS(4067),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_GT_GT] = ACTIONS(4065),
    [anon_sym_GT_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_CARET] = ACTIONS(4067),
    [anon_sym_PIPE] = ACTIONS(4065),
    [anon_sym_PLUS] = ACTIONS(4065),
    [anon_sym_DASH] = ACTIONS(4065),
    [anon_sym_PERCENT] = ACTIONS(4067),
    [anon_sym_STAR_STAR] = ACTIONS(4067),
    [anon_sym_LT_EQ] = ACTIONS(4067),
    [anon_sym_EQ_EQ] = ACTIONS(4065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4067),
    [anon_sym_BANG_EQ] = ACTIONS(4065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4067),
    [anon_sym_GT_EQ] = ACTIONS(4067),
    [anon_sym_instanceof] = ACTIONS(4067),
    [anon_sym_BANG] = ACTIONS(4065),
    [anon_sym_PLUS_PLUS] = ACTIONS(4067),
    [anon_sym_DASH_DASH] = ACTIONS(4067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_implements] = ACTIONS(4067),
  },
  [1114] = {
    [anon_sym_STAR] = ACTIONS(4069),
    [anon_sym_as] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_RBRACE] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_RPAREN] = ACTIONS(3728),
    [anon_sym_in] = ACTIONS(4069),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_RBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_SLASH] = ACTIONS(4069),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_GT_GT_GT] = ACTIONS(3728),
    [anon_sym_LT_LT] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(4069),
    [anon_sym_CARET] = ACTIONS(3728),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_STAR_STAR] = ACTIONS(3728),
    [anon_sym_LT_EQ] = ACTIONS(3728),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3728),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_instanceof] = ACTIONS(3728),
    [anon_sym_BANG] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3728),
    [anon_sym_DASH_DASH] = ACTIONS(3728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3728),
    [anon_sym_implements] = ACTIONS(3728),
  },
  [1115] = {
    [anon_sym_STAR] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_RBRACE] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_in] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_RBRACK] = ACTIONS(3774),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_GT] = ACTIONS(3772),
    [anon_sym_SLASH] = ACTIONS(3772),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_GT_GT] = ACTIONS(3772),
    [anon_sym_GT_GT_GT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3772),
    [anon_sym_CARET] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3774),
    [anon_sym_EQ_EQ] = ACTIONS(3772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3772),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3774),
    [anon_sym_GT_EQ] = ACTIONS(3774),
    [anon_sym_instanceof] = ACTIONS(3774),
    [anon_sym_BANG] = ACTIONS(3772),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3774),
    [anon_sym_implements] = ACTIONS(3774),
  },
  [1116] = {
    [anon_sym_STAR] = ACTIONS(4071),
    [anon_sym_as] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4073),
    [anon_sym_COMMA] = ACTIONS(4073),
    [anon_sym_RBRACE] = ACTIONS(4073),
    [anon_sym_LPAREN] = ACTIONS(4073),
    [anon_sym_RPAREN] = ACTIONS(4073),
    [anon_sym_in] = ACTIONS(4071),
    [anon_sym_COLON] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [anon_sym_RBRACK] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_SLASH] = ACTIONS(4071),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(4073),
    [anon_sym_AMP_AMP] = ACTIONS(4073),
    [anon_sym_PIPE_PIPE] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_GT_GT_GT] = ACTIONS(4073),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_AMP] = ACTIONS(4071),
    [anon_sym_CARET] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_PERCENT] = ACTIONS(4073),
    [anon_sym_STAR_STAR] = ACTIONS(4073),
    [anon_sym_LT_EQ] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4073),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4073),
    [anon_sym_GT_EQ] = ACTIONS(4073),
    [anon_sym_instanceof] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4073),
    [anon_sym_DASH_DASH] = ACTIONS(4073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4073),
    [anon_sym_implements] = ACTIONS(4073),
  },
  [1117] = {
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_as] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RBRACE] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [anon_sym_in] = ACTIONS(1155),
    [anon_sym_COLON] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_RBRACK] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_QMARK] = ACTIONS(1157),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(1157),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_instanceof] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1157),
    [anon_sym_implements] = ACTIONS(1157),
  },
  [1118] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_RBRACE] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3730),
  },
  [1119] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_RBRACE] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3728),
  },
  [1120] = {
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_LBRACE] = ACTIONS(4077),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_RPAREN] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
    [anon_sym_COLON] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(4077),
    [anon_sym_RBRACK] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4075),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [anon_sym_implements] = ACTIONS(4077),
  },
  [1121] = {
    [anon_sym_STAR] = ACTIONS(1213),
    [anon_sym_as] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_COMMA] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [anon_sym_RPAREN] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1213),
    [anon_sym_COLON] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1215),
    [anon_sym_RBRACK] = ACTIONS(1215),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_GT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_QMARK] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1215),
    [anon_sym_PIPE_PIPE] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1213),
    [anon_sym_GT_GT_GT] = ACTIONS(1215),
    [anon_sym_LT_LT] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1213),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_PIPE] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_PERCENT] = ACTIONS(1215),
    [anon_sym_STAR_STAR] = ACTIONS(1215),
    [anon_sym_LT_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1215),
    [anon_sym_instanceof] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [anon_sym_implements] = ACTIONS(1215),
  },
  [1122] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_RBRACE] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3726),
  },
  [1123] = {
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_LBRACE] = ACTIONS(4077),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_RPAREN] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
    [anon_sym_COLON] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(4077),
    [anon_sym_RBRACK] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4075),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [anon_sym_implements] = ACTIONS(4077),
  },
  [1124] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4079),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(4079),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [1125] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4088),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4088),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4088),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [1126] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_extends_clause_repeat1] = STATE(2372),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(4005),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(4005),
  },
  [1127] = {
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_EQ] = ACTIONS(3653),
    [anon_sym_as] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(3655),
    [anon_sym_RBRACE] = ACTIONS(3655),
    [anon_sym_LPAREN] = ACTIONS(3655),
    [anon_sym_in] = ACTIONS(3653),
    [anon_sym_of] = ACTIONS(3655),
    [anon_sym_SEMI] = ACTIONS(3655),
    [anon_sym_COLON] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_LT] = ACTIONS(3653),
    [anon_sym_GT] = ACTIONS(3653),
    [anon_sym_SLASH] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3655),
    [anon_sym_QMARK] = ACTIONS(3655),
    [anon_sym_AMP_AMP] = ACTIONS(3655),
    [anon_sym_PIPE_PIPE] = ACTIONS(3655),
    [anon_sym_GT_GT] = ACTIONS(3653),
    [anon_sym_GT_GT_GT] = ACTIONS(3655),
    [anon_sym_LT_LT] = ACTIONS(3655),
    [anon_sym_AMP] = ACTIONS(3653),
    [anon_sym_CARET] = ACTIONS(3655),
    [anon_sym_PIPE] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [anon_sym_PERCENT] = ACTIONS(3655),
    [anon_sym_STAR_STAR] = ACTIONS(3655),
    [anon_sym_LT_EQ] = ACTIONS(3655),
    [anon_sym_EQ_EQ] = ACTIONS(3653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3655),
    [anon_sym_BANG_EQ] = ACTIONS(3653),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3655),
    [anon_sym_GT_EQ] = ACTIONS(3655),
    [anon_sym_instanceof] = ACTIONS(3655),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3655),
    [sym__automatic_semicolon] = ACTIONS(3655),
  },
  [1128] = {
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2395),
    [sym_array] = STATE(2846),
    [sym_spread_element] = STATE(2395),
    [sym_string] = STATE(1984),
    [sym_method_definition] = STATE(2395),
    [sym_pair] = STATE(2395),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_accessibility_modifier] = STATE(1769),
    [aux_sym_object_repeat1] = STATE(2401),
    [sym_identifier] = ACTIONS(4115),
    [anon_sym_export] = ACTIONS(4115),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4115),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4117),
    [anon_sym_type] = ACTIONS(4115),
    [anon_sym_LBRACK] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(4119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4115),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(4121),
    [anon_sym_get] = ACTIONS(4123),
    [anon_sym_set] = ACTIONS(4123),
    [anon_sym_declare] = ACTIONS(4115),
    [anon_sym_public] = ACTIONS(4125),
    [anon_sym_private] = ACTIONS(4125),
    [anon_sym_protected] = ACTIONS(4125),
    [anon_sym_module] = ACTIONS(4115),
    [anon_sym_any] = ACTIONS(4115),
    [anon_sym_number] = ACTIONS(4115),
    [anon_sym_boolean] = ACTIONS(4115),
    [anon_sym_string] = ACTIONS(4115),
    [anon_sym_symbol] = ACTIONS(4115),
    [sym_readonly] = ACTIONS(4127),
  },
  [1129] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_annotation] = STATE(2931),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4129),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1130] = {
    [anon_sym_STAR] = ACTIONS(4131),
    [anon_sym_as] = ACTIONS(3749),
    [anon_sym_LBRACE] = ACTIONS(3749),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3749),
    [anon_sym_RPAREN] = ACTIONS(3749),
    [anon_sym_in] = ACTIONS(4131),
    [anon_sym_COLON] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_RBRACK] = ACTIONS(3749),
    [anon_sym_LT] = ACTIONS(4131),
    [anon_sym_GT] = ACTIONS(4131),
    [anon_sym_SLASH] = ACTIONS(4131),
    [anon_sym_DOT] = ACTIONS(3749),
    [anon_sym_QMARK] = ACTIONS(3749),
    [anon_sym_AMP_AMP] = ACTIONS(3749),
    [anon_sym_PIPE_PIPE] = ACTIONS(3749),
    [anon_sym_GT_GT] = ACTIONS(4131),
    [anon_sym_GT_GT_GT] = ACTIONS(3749),
    [anon_sym_LT_LT] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(4131),
    [anon_sym_CARET] = ACTIONS(3749),
    [anon_sym_PIPE] = ACTIONS(4131),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(3749),
    [anon_sym_STAR_STAR] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(3749),
    [anon_sym_EQ_EQ] = ACTIONS(4131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3749),
    [anon_sym_BANG_EQ] = ACTIONS(4131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3749),
    [anon_sym_GT_EQ] = ACTIONS(3749),
    [anon_sym_instanceof] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(4131),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3749),
    [anon_sym_implements] = ACTIONS(3749),
  },
  [1131] = {
    [anon_sym_STAR] = ACTIONS(3673),
    [anon_sym_EQ] = ACTIONS(3673),
    [anon_sym_as] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_of] = ACTIONS(3675),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LT] = ACTIONS(3673),
    [anon_sym_GT] = ACTIONS(3673),
    [anon_sym_SLASH] = ACTIONS(3673),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3673),
    [anon_sym_GT_GT_GT] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_CARET] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_STAR_STAR] = ACTIONS(3675),
    [anon_sym_LT_EQ] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3673),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3673),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3675),
    [anon_sym_instanceof] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3673),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3675),
    [sym__automatic_semicolon] = ACTIONS(3675),
  },
  [1132] = {
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_RPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_COLON] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_RBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [anon_sym_implements] = ACTIONS(1195),
  },
  [1133] = {
    [anon_sym_STAR] = ACTIONS(1103),
    [anon_sym_as] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [anon_sym_COMMA] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1103),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [anon_sym_RBRACK] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [anon_sym_GT_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_CARET] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1105),
    [anon_sym_GT_EQ] = ACTIONS(1105),
    [anon_sym_instanceof] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_PLUS_PLUS] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(1105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_implements] = ACTIONS(1105),
  },
  [1134] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3716),
    [anon_sym_RBRACE] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3716),
  },
  [1135] = {
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2432),
    [sym_array] = STATE(2846),
    [sym_spread_element] = STATE(2432),
    [sym_string] = STATE(1984),
    [sym_method_definition] = STATE(2432),
    [sym_pair] = STATE(2432),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_accessibility_modifier] = STATE(1769),
    [aux_sym_object_repeat1] = STATE(2431),
    [sym_identifier] = ACTIONS(4133),
    [anon_sym_export] = ACTIONS(4133),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4133),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4135),
    [anon_sym_type] = ACTIONS(4133),
    [anon_sym_LBRACK] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(4137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4133),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(4139),
    [anon_sym_get] = ACTIONS(4141),
    [anon_sym_set] = ACTIONS(4141),
    [anon_sym_declare] = ACTIONS(4133),
    [anon_sym_public] = ACTIONS(4143),
    [anon_sym_private] = ACTIONS(4143),
    [anon_sym_protected] = ACTIONS(4143),
    [anon_sym_module] = ACTIONS(4133),
    [anon_sym_any] = ACTIONS(4133),
    [anon_sym_number] = ACTIONS(4133),
    [anon_sym_boolean] = ACTIONS(4133),
    [anon_sym_string] = ACTIONS(4133),
    [anon_sym_symbol] = ACTIONS(4133),
    [sym_readonly] = ACTIONS(4145),
  },
  [1136] = {
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1147),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_RPAREN] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1145),
    [anon_sym_COLON] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_RBRACK] = ACTIONS(1147),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1147),
    [anon_sym_PIPE_PIPE] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(1145),
    [anon_sym_GT_GT_GT] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_PERCENT] = ACTIONS(1147),
    [anon_sym_STAR_STAR] = ACTIONS(1147),
    [anon_sym_LT_EQ] = ACTIONS(1147),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1147),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1147),
    [anon_sym_GT_EQ] = ACTIONS(1147),
    [anon_sym_instanceof] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [anon_sym_implements] = ACTIONS(1147),
  },
  [1137] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4147),
  },
  [1138] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1168),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1168),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4151),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1139] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2402),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4165),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1140] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4131),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3749),
  },
  [1141] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4175),
    [anon_sym_set] = ACTIONS(4175),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1142] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(4177),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(3734),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
  },
  [1143] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3770),
  },
  [1144] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3768),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3768),
  },
  [1145] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3766),
  },
  [1146] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3749),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3749),
  },
  [1147] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4180),
    [anon_sym_COMMA] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
  },
  [1148] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4184),
  },
  [1149] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(4177),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
  },
  [1150] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3913),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3766),
  },
  [1151] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
  },
  [1152] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3770),
  },
  [1153] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4186),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3780),
  },
  [1154] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4196),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1155] = {
    [sym_object] = STATE(2844),
    [sym_assignment_pattern] = STATE(2586),
    [sym_array] = STATE(2846),
    [sym_spread_element] = STATE(2586),
    [sym_string] = STATE(1984),
    [sym_method_definition] = STATE(2586),
    [sym_pair] = STATE(2586),
    [sym__property_name] = STATE(1984),
    [sym_computed_property_name] = STATE(1984),
    [sym_accessibility_modifier] = STATE(1769),
    [sym_identifier] = ACTIONS(4198),
    [anon_sym_export] = ACTIONS(4198),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_namespace] = ACTIONS(4198),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(3151),
    [anon_sym_RBRACE] = ACTIONS(3151),
    [anon_sym_type] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(4200),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(127),
    [anon_sym_void] = ACTIONS(4198),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(4202),
    [anon_sym_get] = ACTIONS(4204),
    [anon_sym_set] = ACTIONS(4204),
    [anon_sym_declare] = ACTIONS(4198),
    [anon_sym_public] = ACTIONS(4206),
    [anon_sym_private] = ACTIONS(4206),
    [anon_sym_protected] = ACTIONS(4206),
    [anon_sym_module] = ACTIONS(4198),
    [anon_sym_any] = ACTIONS(4198),
    [anon_sym_number] = ACTIONS(4198),
    [anon_sym_boolean] = ACTIONS(4198),
    [anon_sym_string] = ACTIONS(4198),
    [anon_sym_symbol] = ACTIONS(4198),
    [sym_readonly] = ACTIONS(4208),
  },
  [1156] = {
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1135),
    [anon_sym_PIPE_PIPE] = ACTIONS(1135),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_GT_GT_GT] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(4210),
  },
  [1157] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3728),
  },
  [1158] = {
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_else] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1135),
    [anon_sym_PIPE_PIPE] = ACTIONS(1135),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_GT_GT_GT] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(1135),
  },
  [1159] = {
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_as] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_else] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_in] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1229),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_DOT] = ACTIONS(1229),
    [anon_sym_QMARK] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_STAR_STAR] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_instanceof] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym__automatic_semicolon] = ACTIONS(1229),
  },
  [1160] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3755),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3755),
  },
  [1161] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3755),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3755),
  },
  [1162] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3778),
  },
  [1163] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3760),
    [anon_sym_COMMA] = ACTIONS(3760),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3760),
  },
  [1164] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3788),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3788),
  },
  [1165] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3755),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4212),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3755),
  },
  [1166] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1167] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1168] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1168),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1168),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_export] = ACTIONS(4215),
    [anon_sym_STAR] = ACTIONS(4218),
    [anon_sym_namespace] = ACTIONS(4215),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [anon_sym_type] = ACTIONS(4215),
    [anon_sym_LBRACK] = ACTIONS(4223),
    [anon_sym_async] = ACTIONS(4226),
    [anon_sym_void] = ACTIONS(4215),
    [anon_sym_DQUOTE] = ACTIONS(4229),
    [anon_sym_SQUOTE] = ACTIONS(4232),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4235),
    [anon_sym_AT] = ACTIONS(4238),
    [anon_sym_static] = ACTIONS(4241),
    [anon_sym_abstract] = ACTIONS(4244),
    [anon_sym_get] = ACTIONS(4247),
    [anon_sym_set] = ACTIONS(4247),
    [anon_sym_declare] = ACTIONS(4215),
    [anon_sym_public] = ACTIONS(4250),
    [anon_sym_private] = ACTIONS(4250),
    [anon_sym_protected] = ACTIONS(4250),
    [anon_sym_module] = ACTIONS(4215),
    [anon_sym_any] = ACTIONS(4215),
    [anon_sym_number] = ACTIONS(4215),
    [anon_sym_boolean] = ACTIONS(4215),
    [anon_sym_string] = ACTIONS(4215),
    [anon_sym_symbol] = ACTIONS(4215),
    [sym_readonly] = ACTIONS(4253),
  },
  [1169] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
  },
  [1170] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4196),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1171] = {
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_as] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_in] = ACTIONS(1243),
    [anon_sym_while] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_DOT] = ACTIONS(1241),
    [anon_sym_QMARK] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1243),
    [anon_sym_GT_GT_GT] = ACTIONS(1241),
    [anon_sym_LT_LT] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_CARET] = ACTIONS(1241),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_PERCENT] = ACTIONS(1241),
    [anon_sym_STAR_STAR] = ACTIONS(1241),
    [anon_sym_LT_EQ] = ACTIONS(1241),
    [anon_sym_EQ_EQ] = ACTIONS(1243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1241),
    [anon_sym_BANG_EQ] = ACTIONS(1243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1241),
    [anon_sym_GT_EQ] = ACTIONS(1241),
    [anon_sym_instanceof] = ACTIONS(1241),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [sym__automatic_semicolon] = ACTIONS(1241),
  },
  [1172] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4175),
    [anon_sym_set] = ACTIONS(4175),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1173] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(4256),
    [anon_sym_COMMA] = ACTIONS(4256),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(4256),
  },
  [1174] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1175] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4258),
    [anon_sym_COMMA] = ACTIONS(4256),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4256),
  },
  [1176] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(4260),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4260),
  },
  [1177] = {
    [anon_sym_STAR] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_RBRACE] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_in] = ACTIONS(3772),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym_COLON] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_GT] = ACTIONS(3772),
    [anon_sym_SLASH] = ACTIONS(3772),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_EQ_GT] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_GT_GT] = ACTIONS(3772),
    [anon_sym_GT_GT_GT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3772),
    [anon_sym_CARET] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3774),
    [anon_sym_EQ_EQ] = ACTIONS(3772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3772),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3774),
    [anon_sym_GT_EQ] = ACTIONS(3774),
    [anon_sym_instanceof] = ACTIONS(3774),
    [anon_sym_BANG] = ACTIONS(3772),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3774),
    [sym__automatic_semicolon] = ACTIONS(3774),
  },
  [1178] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4196),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1179] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4175),
    [anon_sym_set] = ACTIONS(4175),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1180] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(4262),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4262),
  },
  [1181] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3734),
  },
  [1182] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4264),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1183] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2510),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4266),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1184] = {
    [sym_type_arguments] = STATE(1389),
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(4268),
    [anon_sym_GT] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(4271),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2486),
    [anon_sym_GT_GT] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2486),
    [anon_sym_LT_LT] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_CARET] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2486),
    [anon_sym_STAR_STAR] = ACTIONS(2486),
    [anon_sym_LT_EQ] = ACTIONS(2486),
    [anon_sym_EQ_EQ] = ACTIONS(2488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2486),
    [anon_sym_BANG_EQ] = ACTIONS(2488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2486),
    [anon_sym_GT_EQ] = ACTIONS(2486),
    [anon_sym_instanceof] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [anon_sym_is] = ACTIONS(4273),
    [sym__automatic_semicolon] = ACTIONS(2486),
  },
  [1185] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2471),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4275),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1186] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
  },
  [1187] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1219),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1219),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4277),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1188] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1189] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4196),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1190] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4175),
    [anon_sym_set] = ACTIONS(4175),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1191] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1168),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1168),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4279),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1192] = {
    [sym_arguments] = STATE(1438),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3645),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [sym__automatic_semicolon] = ACTIONS(3169),
  },
  [1193] = {
    [sym_arguments] = STATE(1438),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3647),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [sym__automatic_semicolon] = ACTIONS(3169),
  },
  [1194] = {
    [anon_sym_STAR] = ACTIONS(4281),
    [anon_sym_as] = ACTIONS(4281),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_RBRACE] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_RPAREN] = ACTIONS(4283),
    [anon_sym_in] = ACTIONS(4281),
    [anon_sym_COLON] = ACTIONS(4283),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_RBRACK] = ACTIONS(4283),
    [anon_sym_LT] = ACTIONS(4281),
    [anon_sym_GT] = ACTIONS(4281),
    [anon_sym_SLASH] = ACTIONS(4281),
    [anon_sym_DOT] = ACTIONS(4283),
    [anon_sym_QMARK] = ACTIONS(4283),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4281),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_AMP] = ACTIONS(4281),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4281),
    [anon_sym_DASH] = ACTIONS(4281),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_STAR_STAR] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4281),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_instanceof] = ACTIONS(4281),
    [anon_sym_BANG] = ACTIONS(4281),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4283),
    [sym_regex_flags] = ACTIONS(4285),
  },
  [1195] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2383),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4287),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1196] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1191),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1191),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4289),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1197] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4147),
  },
  [1198] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4291),
    [anon_sym_COMMA] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3716),
  },
  [1199] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1168),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1168),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4293),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1200] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [1201] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
  },
  [1202] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [1203] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2510),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4295),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1204] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4297),
    [anon_sym_COMMA] = ACTIONS(3747),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3747),
  },
  [1205] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3732),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(4177),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3734),
  },
  [1206] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4147),
  },
  [1207] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1138),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1138),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4299),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1208] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2442),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4301),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1209] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4303),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3730),
  },
  [1210] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1199),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1199),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4305),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1211] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2464),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4307),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1212] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4147),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1213] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3790),
    [anon_sym_COMMA] = ACTIONS(3790),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3790),
  },
  [1214] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1168),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1168),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4309),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1215] = {
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_else] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_in] = ACTIONS(1115),
    [anon_sym_while] = ACTIONS(1113),
    [anon_sym_SEMI] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_GT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_DOT] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_AMP_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1115),
    [anon_sym_GT_GT_GT] = ACTIONS(1113),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1113),
    [anon_sym_GT_EQ] = ACTIONS(1113),
    [anon_sym_instanceof] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym__automatic_semicolon] = ACTIONS(1113),
  },
  [1216] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1214),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1214),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4311),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1217] = {
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_as] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_in] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1239),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [sym__automatic_semicolon] = ACTIONS(1237),
  },
  [1218] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2541),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4313),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1219] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1168),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1168),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4315),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1220] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_COMMA] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3786),
  },
  [1221] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4069),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
  },
  [1222] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(4317),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3755),
  },
  [1223] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2471),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4320),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1224] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4322),
    [anon_sym_COMMA] = ACTIONS(3760),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3760),
  },
  [1225] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4324),
    [anon_sym_COMMA] = ACTIONS(3778),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3778),
  },
  [1226] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2525),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4326),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1227] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2450),
    [sym__automatic_semicolon] = ACTIONS(2450),
  },
  [1228] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1168),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1168),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4328),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1229] = {
    [sym_string] = STATE(1804),
    [sym_decorator] = STATE(1228),
    [sym_public_field_definition] = STATE(2505),
    [sym_method_definition] = STATE(1752),
    [sym__property_name] = STATE(1804),
    [sym_computed_property_name] = STATE(1804),
    [sym_method_signature] = STATE(2505),
    [sym_abstract_method_signature] = STATE(2505),
    [sym_accessibility_modifier] = STATE(1758),
    [sym_index_signature] = STATE(2505),
    [aux_sym_class_body_repeat1] = STATE(1228),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4149),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_RBRACE] = ACTIONS(4330),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(4153),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4155),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(4157),
    [anon_sym_abstract] = ACTIONS(4159),
    [anon_sym_get] = ACTIONS(4161),
    [anon_sym_set] = ACTIONS(4161),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3523),
    [anon_sym_private] = ACTIONS(3523),
    [anon_sym_protected] = ACTIONS(3523),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4163),
  },
  [1230] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3716),
    [anon_sym_COMMA] = ACTIONS(3716),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3716),
  },
  [1231] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1553),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3169),
  },
  [1232] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3726),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3726),
  },
  [1233] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2510),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4332),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1234] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(4317),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3755),
  },
  [1235] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_COMMA] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(4317),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3755),
  },
  [1236] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3626),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3626),
    [anon_sym_COMMA] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3630),
    [anon_sym_in] = ACTIONS(3626),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3626),
    [anon_sym_GT] = ACTIONS(3626),
    [anon_sym_SLASH] = ACTIONS(3626),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3630),
    [anon_sym_AMP_AMP] = ACTIONS(3630),
    [anon_sym_PIPE_PIPE] = ACTIONS(3630),
    [anon_sym_GT_GT] = ACTIONS(3626),
    [anon_sym_GT_GT_GT] = ACTIONS(3630),
    [anon_sym_LT_LT] = ACTIONS(3630),
    [anon_sym_AMP] = ACTIONS(3626),
    [anon_sym_CARET] = ACTIONS(3630),
    [anon_sym_PIPE] = ACTIONS(3626),
    [anon_sym_PLUS] = ACTIONS(3626),
    [anon_sym_DASH] = ACTIONS(3626),
    [anon_sym_PERCENT] = ACTIONS(3630),
    [anon_sym_STAR_STAR] = ACTIONS(3630),
    [anon_sym_LT_EQ] = ACTIONS(3630),
    [anon_sym_EQ_EQ] = ACTIONS(3626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3630),
    [anon_sym_BANG_EQ] = ACTIONS(3626),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3630),
    [anon_sym_GT_EQ] = ACTIONS(3630),
    [anon_sym_instanceof] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3626),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3630),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3630),
  },
  [1237] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4147),
  },
  [1238] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_while] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(1075),
  },
  [1239] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4334),
    [anon_sym_COMMA] = ACTIONS(3726),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3726),
  },
  [1240] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3839),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3843),
    [anon_sym_GT] = ACTIONS(3839),
    [anon_sym_SLASH] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3845),
    [anon_sym_AMP_AMP] = ACTIONS(3847),
    [anon_sym_PIPE_PIPE] = ACTIONS(3849),
    [anon_sym_GT_GT] = ACTIONS(3830),
    [anon_sym_GT_GT_GT] = ACTIONS(3851),
    [anon_sym_LT_LT] = ACTIONS(3851),
    [anon_sym_AMP] = ACTIONS(3853),
    [anon_sym_CARET] = ACTIONS(3849),
    [anon_sym_PIPE] = ACTIONS(3855),
    [anon_sym_PLUS] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3857),
    [anon_sym_PERCENT] = ACTIONS(3851),
    [anon_sym_STAR_STAR] = ACTIONS(3859),
    [anon_sym_LT_EQ] = ACTIONS(3861),
    [anon_sym_EQ_EQ] = ACTIONS(3839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3861),
    [anon_sym_BANG_EQ] = ACTIONS(3839),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3861),
    [anon_sym_GT_EQ] = ACTIONS(3861),
    [anon_sym_instanceof] = ACTIONS(3861),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3741),
  },
  [1241] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_COMMA] = ACTIONS(3730),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3730),
  },
  [1242] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4336),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3734),
  },
  [1243] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3734),
  },
  [1244] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3780),
    [anon_sym_COMMA] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3780),
  },
  [1245] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3632),
    [anon_sym_as] = ACTIONS(3634),
    [anon_sym_LBRACE] = ACTIONS(3632),
    [anon_sym_COMMA] = ACTIONS(3634),
    [anon_sym_LPAREN] = ACTIONS(3634),
    [anon_sym_in] = ACTIONS(3632),
    [anon_sym_LBRACK] = ACTIONS(3634),
    [anon_sym_LT] = ACTIONS(3632),
    [anon_sym_GT] = ACTIONS(3632),
    [anon_sym_SLASH] = ACTIONS(3632),
    [anon_sym_DOT] = ACTIONS(3634),
    [anon_sym_QMARK] = ACTIONS(3634),
    [anon_sym_AMP_AMP] = ACTIONS(3634),
    [anon_sym_PIPE_PIPE] = ACTIONS(3634),
    [anon_sym_GT_GT] = ACTIONS(3632),
    [anon_sym_GT_GT_GT] = ACTIONS(3634),
    [anon_sym_LT_LT] = ACTIONS(3634),
    [anon_sym_AMP] = ACTIONS(3632),
    [anon_sym_CARET] = ACTIONS(3634),
    [anon_sym_PIPE] = ACTIONS(3632),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_PERCENT] = ACTIONS(3634),
    [anon_sym_STAR_STAR] = ACTIONS(3634),
    [anon_sym_LT_EQ] = ACTIONS(3634),
    [anon_sym_EQ_EQ] = ACTIONS(3632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3634),
    [anon_sym_BANG_EQ] = ACTIONS(3632),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3634),
    [anon_sym_GT_EQ] = ACTIONS(3634),
    [anon_sym_instanceof] = ACTIONS(3634),
    [anon_sym_BANG] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3634),
    [anon_sym_DASH_DASH] = ACTIONS(3634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3634),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3634),
  },
  [1246] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4339),
    [anon_sym_COMMA] = ACTIONS(3790),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3790),
  },
  [1247] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(3894),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
  },
  [1248] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [aux_sym_array_repeat1] = STATE(2422),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4341),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1249] = {
    [sym_template_string] = STATE(1659),
    [sym_arguments] = STATE(1659),
    [sym_type_arguments] = STATE(2374),
    [anon_sym_STAR] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3973),
    [anon_sym_LBRACE] = ACTIONS(4343),
    [anon_sym_COMMA] = ACTIONS(3786),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3977),
    [anon_sym_SLASH] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3985),
    [anon_sym_PIPE_PIPE] = ACTIONS(3987),
    [anon_sym_GT_GT] = ACTIONS(3971),
    [anon_sym_GT_GT_GT] = ACTIONS(3989),
    [anon_sym_LT_LT] = ACTIONS(3989),
    [anon_sym_AMP] = ACTIONS(3991),
    [anon_sym_CARET] = ACTIONS(3987),
    [anon_sym_PIPE] = ACTIONS(3993),
    [anon_sym_PLUS] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3995),
    [anon_sym_PERCENT] = ACTIONS(3989),
    [anon_sym_STAR_STAR] = ACTIONS(3997),
    [anon_sym_LT_EQ] = ACTIONS(3999),
    [anon_sym_EQ_EQ] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3999),
    [anon_sym_BANG_EQ] = ACTIONS(3977),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3999),
    [anon_sym_GT_EQ] = ACTIONS(3999),
    [anon_sym_instanceof] = ACTIONS(3999),
    [anon_sym_BANG] = ACTIONS(4001),
    [anon_sym_PLUS_PLUS] = ACTIONS(4003),
    [anon_sym_DASH_DASH] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3786),
  },
  [1250] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3734),
  },
  [1251] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3747),
    [anon_sym_COMMA] = ACTIONS(3747),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3747),
  },
  [1252] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4336),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3734),
  },
  [1253] = {
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_as] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_else] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_in] = ACTIONS(1187),
    [anon_sym_while] = ACTIONS(1185),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_instanceof] = ACTIONS(1185),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym__automatic_semicolon] = ACTIONS(1185),
  },
  [1254] = {
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_else] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1067),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1069),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(4345),
  },
  [1255] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4091),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [anon_sym_COMMA] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4093),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4095),
    [anon_sym_GT] = ACTIONS(4093),
    [anon_sym_SLASH] = ACTIONS(4091),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4097),
    [anon_sym_AMP_AMP] = ACTIONS(4099),
    [anon_sym_PIPE_PIPE] = ACTIONS(4101),
    [anon_sym_GT_GT] = ACTIONS(4091),
    [anon_sym_GT_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
    [anon_sym_CARET] = ACTIONS(4101),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_PLUS] = ACTIONS(4109),
    [anon_sym_DASH] = ACTIONS(4109),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_STAR_STAR] = ACTIONS(4111),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_EQ_EQ] = ACTIONS(4093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4113),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_instanceof] = ACTIONS(4113),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3745),
  },
  [1256] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LBRACE] = ACTIONS(3734),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4336),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(3734),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_implements] = ACTIONS(3734),
  },
  [1257] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4347),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1258] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4349),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1259] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3730),
  },
  [1260] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4375),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(4377),
    [anon_sym_of] = ACTIONS(4380),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1261] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_else] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_while] = ACTIONS(1117),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1262] = {
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_as] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_else] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_instanceof] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym__automatic_semicolon] = ACTIONS(1227),
  },
  [1263] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3749),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1264] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1265] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1266] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3770),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1267] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4406),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1268] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1269] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2466),
    [sym__automatic_semicolon] = ACTIONS(2466),
  },
  [1270] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1271] = {
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1069),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(4408),
  },
  [1272] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1273] = {
    [sym_type_arguments] = STATE(1651),
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_as] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(4412),
    [anon_sym_GT] = ACTIONS(2488),
    [anon_sym_SLASH] = ACTIONS(2488),
    [anon_sym_DOT] = ACTIONS(4415),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2486),
    [anon_sym_GT_GT] = ACTIONS(2488),
    [anon_sym_GT_GT_GT] = ACTIONS(2486),
    [anon_sym_LT_LT] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_CARET] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2486),
    [anon_sym_STAR_STAR] = ACTIONS(2486),
    [anon_sym_LT_EQ] = ACTIONS(2486),
    [anon_sym_EQ_EQ] = ACTIONS(2488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2486),
    [anon_sym_BANG_EQ] = ACTIONS(2488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2486),
    [anon_sym_GT_EQ] = ACTIONS(2486),
    [anon_sym_instanceof] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2486),
    [anon_sym_is] = ACTIONS(4417),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2486),
  },
  [1274] = {
    [sym_arguments] = STATE(1557),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3647),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3169),
  },
  [1275] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4088),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4088),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2551),
    [sym__automatic_semicolon] = ACTIONS(2551),
  },
  [1276] = {
    [sym_arguments] = STATE(1557),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3645),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3169),
  },
  [1277] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3946),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1278] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3937),
    [anon_sym_RBRACE] = ACTIONS(3937),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1279] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3837),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1280] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4079),
    [anon_sym_RBRACE] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(4079),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2432),
    [sym__automatic_semicolon] = ACTIONS(2432),
  },
  [1281] = {
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1069),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(4345),
  },
  [1282] = {
    [sym_string] = STATE(1809),
    [sym__property_name] = STATE(1809),
    [sym_computed_property_name] = STATE(1809),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4419),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4421),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4423),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_abstract] = ACTIONS(4425),
    [anon_sym_get] = ACTIONS(4427),
    [anon_sym_set] = ACTIONS(4427),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1283] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1284] = {
    [anon_sym_STAR] = ACTIONS(4281),
    [anon_sym_as] = ACTIONS(4281),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_RBRACE] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_in] = ACTIONS(4281),
    [anon_sym_SEMI] = ACTIONS(4283),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LT] = ACTIONS(4281),
    [anon_sym_GT] = ACTIONS(4281),
    [anon_sym_SLASH] = ACTIONS(4281),
    [anon_sym_DOT] = ACTIONS(4283),
    [anon_sym_QMARK] = ACTIONS(4283),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4281),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_AMP] = ACTIONS(4281),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4281),
    [anon_sym_DASH] = ACTIONS(4281),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_STAR_STAR] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4281),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_instanceof] = ACTIONS(4281),
    [anon_sym_BANG] = ACTIONS(4281),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4283),
    [sym_regex_flags] = ACTIONS(4429),
    [sym__automatic_semicolon] = ACTIONS(4283),
  },
  [1285] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4431),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1286] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4433),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1287] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(4435),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4435),
  },
  [1288] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3790),
  },
  [1289] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4437),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1290] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3788),
  },
  [1291] = {
    [anon_sym_STAR] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_LBRACE] = ACTIONS(3772),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_in] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_GT] = ACTIONS(3772),
    [anon_sym_SLASH] = ACTIONS(3772),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_EQ_GT] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_GT_GT] = ACTIONS(3772),
    [anon_sym_GT_GT_GT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3772),
    [anon_sym_CARET] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3774),
    [anon_sym_EQ_EQ] = ACTIONS(3772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3772),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3774),
    [anon_sym_GT_EQ] = ACTIONS(3774),
    [anon_sym_instanceof] = ACTIONS(3774),
    [anon_sym_BANG] = ACTIONS(3772),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3774),
  },
  [1292] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3786),
  },
  [1293] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3716),
  },
  [1294] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4439),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1295] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3726),
  },
  [1296] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4441),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1297] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(4443),
    [anon_sym_RBRACE] = ACTIONS(4443),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1298] = {
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_else] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1147),
    [anon_sym_PIPE_PIPE] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(1145),
    [anon_sym_GT_GT_GT] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_PERCENT] = ACTIONS(1147),
    [anon_sym_STAR_STAR] = ACTIONS(1147),
    [anon_sym_LT_EQ] = ACTIONS(1147),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1147),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1147),
    [anon_sym_GT_EQ] = ACTIONS(1147),
    [anon_sym_instanceof] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [sym__automatic_semicolon] = ACTIONS(1149),
  },
  [1299] = {
    [sym_type_arguments] = STATE(1393),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_as] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(2551),
    [anon_sym_RBRACE] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_in] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(4445),
    [anon_sym_GT] = ACTIONS(2553),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2551),
    [anon_sym_QMARK] = ACTIONS(2551),
    [anon_sym_AMP_AMP] = ACTIONS(2551),
    [anon_sym_PIPE_PIPE] = ACTIONS(2551),
    [anon_sym_GT_GT] = ACTIONS(2553),
    [anon_sym_GT_GT_GT] = ACTIONS(2551),
    [anon_sym_LT_LT] = ACTIONS(2551),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_CARET] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2551),
    [anon_sym_STAR_STAR] = ACTIONS(2551),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_EQ_EQ] = ACTIONS(2553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(2553),
    [anon_sym_PLUS_PLUS] = ACTIONS(2551),
    [anon_sym_DASH_DASH] = ACTIONS(2551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2551),
    [sym__automatic_semicolon] = ACTIONS(2551),
  },
  [1300] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(4448),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4448),
  },
  [1301] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4450),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3755),
  },
  [1302] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3760),
  },
  [1303] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3778),
  },
  [1304] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(1073),
  },
  [1305] = {
    [anon_sym_STAR] = ACTIONS(1213),
    [anon_sym_as] = ACTIONS(1215),
    [anon_sym_COMMA] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1209),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1213),
    [anon_sym_while] = ACTIONS(1209),
    [anon_sym_SEMI] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1215),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_GT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_QMARK] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1215),
    [anon_sym_PIPE_PIPE] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1213),
    [anon_sym_GT_GT_GT] = ACTIONS(1215),
    [anon_sym_LT_LT] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1213),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_PIPE] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_PERCENT] = ACTIONS(1215),
    [anon_sym_STAR_STAR] = ACTIONS(1215),
    [anon_sym_LT_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1215),
    [anon_sym_instanceof] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [sym__automatic_semicolon] = ACTIONS(1217),
  },
  [1306] = {
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_as] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_else] = ACTIONS(1151),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_in] = ACTIONS(1155),
    [anon_sym_while] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_QMARK] = ACTIONS(1157),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(1157),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_instanceof] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1157),
    [sym__automatic_semicolon] = ACTIONS(1159),
  },
  [1307] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3728),
  },
  [1308] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4450),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3755),
  },
  [1309] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_SEMI] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4450),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3755),
  },
  [1310] = {
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_else] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym__automatic_semicolon] = ACTIONS(1169),
  },
  [1311] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1312] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4455),
  },
  [1313] = {
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_while] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym__automatic_semicolon] = ACTIONS(1097),
  },
  [1314] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4457),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1315] = {
    [sym_arguments] = STATE(1438),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [sym__automatic_semicolon] = ACTIONS(3169),
  },
  [1316] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1317] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1318] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1319] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1320] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4460),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1321] = {
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_as] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_else] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_in] = ACTIONS(1179),
    [anon_sym_while] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1179),
    [anon_sym_GT] = ACTIONS(1179),
    [anon_sym_SLASH] = ACTIONS(1179),
    [anon_sym_DOT] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1179),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_PLUS] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [sym__automatic_semicolon] = ACTIONS(1183),
  },
  [1322] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4457),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1323] = {
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_as] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1083),
    [anon_sym_else] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1083),
    [anon_sym_in] = ACTIONS(1081),
    [anon_sym_while] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_STAR_STAR] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1083),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym__automatic_semicolon] = ACTIONS(1085),
  },
  [1324] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3755),
    [anon_sym_LT] = ACTIONS(4462),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1325] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_SEMI] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4457),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(3734),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3734),
  },
  [1326] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1327] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3778),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3778),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1328] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3755),
    [anon_sym_LT] = ACTIONS(4462),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1329] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3753),
    [anon_sym_COLON] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3755),
    [anon_sym_LT] = ACTIONS(4462),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3755),
    [anon_sym_PIPE_PIPE] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3753),
    [anon_sym_GT_GT_GT] = ACTIONS(3755),
    [anon_sym_LT_LT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3755),
    [anon_sym_STAR_STAR] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3755),
    [anon_sym_EQ_EQ] = ACTIONS(3753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3753),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1330] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3745),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3745),
  },
  [1331] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3747),
  },
  [1332] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4175),
    [anon_sym_set] = ACTIONS(4175),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1333] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3749),
  },
  [1334] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4196),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1335] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_COLON] = ACTIONS(4465),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1336] = {
    [sym_string] = STATE(1811),
    [sym__property_name] = STATE(1811),
    [sym_computed_property_name] = STATE(1811),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4469),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4471),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_abstract] = ACTIONS(4473),
    [anon_sym_get] = ACTIONS(4475),
    [anon_sym_set] = ACTIONS(4475),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1337] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4477),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1338] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1339] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4479),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1340] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4481),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1341] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3766),
  },
  [1342] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3768),
  },
  [1343] = {
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_while] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym__automatic_semicolon] = ACTIONS(1197),
  },
  [1344] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1345] = {
    [anon_sym_STAR] = ACTIONS(1103),
    [anon_sym_as] = ACTIONS(1105),
    [anon_sym_COMMA] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [anon_sym_GT_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_CARET] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1105),
    [anon_sym_GT_EQ] = ACTIONS(1105),
    [anon_sym_instanceof] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_PLUS_PLUS] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(1105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [sym__automatic_semicolon] = ACTIONS(1107),
  },
  [1346] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3770),
  },
  [1347] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(4483),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(4483),
  },
  [1348] = {
    [sym_template_string] = STATE(1488),
    [sym_arguments] = STATE(1488),
    [sym_type_arguments] = STATE(2350),
    [anon_sym_STAR] = ACTIONS(4351),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(4353),
    [anon_sym_SEMI] = ACTIONS(3780),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4355),
    [anon_sym_GT] = ACTIONS(4353),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4357),
    [anon_sym_AMP_AMP] = ACTIONS(4359),
    [anon_sym_PIPE_PIPE] = ACTIONS(4361),
    [anon_sym_GT_GT] = ACTIONS(4351),
    [anon_sym_GT_GT_GT] = ACTIONS(4363),
    [anon_sym_LT_LT] = ACTIONS(4363),
    [anon_sym_AMP] = ACTIONS(4365),
    [anon_sym_CARET] = ACTIONS(4361),
    [anon_sym_PIPE] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4369),
    [anon_sym_DASH] = ACTIONS(4369),
    [anon_sym_PERCENT] = ACTIONS(4363),
    [anon_sym_STAR_STAR] = ACTIONS(4371),
    [anon_sym_LT_EQ] = ACTIONS(4373),
    [anon_sym_EQ_EQ] = ACTIONS(4353),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4373),
    [anon_sym_BANG_EQ] = ACTIONS(4353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4373),
    [anon_sym_GT_EQ] = ACTIONS(4373),
    [anon_sym_instanceof] = ACTIONS(4373),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [sym__automatic_semicolon] = ACTIONS(3780),
  },
  [1349] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3790),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1350] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3786),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3786),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1351] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4485),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1352] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3716),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1353] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4487),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1354] = {
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_else] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [sym__automatic_semicolon] = ACTIONS(1207),
  },
  [1355] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3726),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3726),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1356] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1357] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3730),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1358] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(4489),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1359] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1360] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1361] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1362] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(4489),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1363] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4492),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1364] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4375),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1365] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3732),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3732),
    [anon_sym_COLON] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_LT] = ACTIONS(4489),
    [anon_sym_GT] = ACTIONS(3732),
    [anon_sym_SLASH] = ACTIONS(3732),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3734),
    [anon_sym_AMP_AMP] = ACTIONS(3734),
    [anon_sym_PIPE_PIPE] = ACTIONS(3734),
    [anon_sym_GT_GT] = ACTIONS(3732),
    [anon_sym_GT_GT_GT] = ACTIONS(3734),
    [anon_sym_LT_LT] = ACTIONS(3734),
    [anon_sym_AMP] = ACTIONS(3732),
    [anon_sym_CARET] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(3732),
    [anon_sym_PLUS] = ACTIONS(3732),
    [anon_sym_DASH] = ACTIONS(3732),
    [anon_sym_PERCENT] = ACTIONS(3734),
    [anon_sym_STAR_STAR] = ACTIONS(3734),
    [anon_sym_LT_EQ] = ACTIONS(3734),
    [anon_sym_EQ_EQ] = ACTIONS(3732),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3734),
    [anon_sym_BANG_EQ] = ACTIONS(3732),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3734),
    [anon_sym_GT_EQ] = ACTIONS(3734),
    [anon_sym_instanceof] = ACTIONS(3734),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1366] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(3684),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_COMMA] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(4264),
    [anon_sym_in] = ACTIONS(3690),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3690),
    [anon_sym_SLASH] = ACTIONS(3684),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3684),
    [anon_sym_GT_GT_GT] = ACTIONS(3700),
    [anon_sym_LT_LT] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_CARET] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [anon_sym_STAR_STAR] = ACTIONS(3708),
    [anon_sym_LT_EQ] = ACTIONS(3710),
    [anon_sym_EQ_EQ] = ACTIONS(3690),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3710),
    [anon_sym_BANG_EQ] = ACTIONS(3690),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3710),
    [anon_sym_GT_EQ] = ACTIONS(3710),
    [anon_sym_instanceof] = ACTIONS(3710),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1367] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3745),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3745),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1368] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3747),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1369] = {
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_EQ] = ACTIONS(3653),
    [anon_sym_as] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(3655),
    [anon_sym_LPAREN] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(3653),
    [anon_sym_SEMI] = ACTIONS(3655),
    [anon_sym_COLON] = ACTIONS(4497),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_LT] = ACTIONS(4499),
    [anon_sym_GT] = ACTIONS(3653),
    [anon_sym_SLASH] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3655),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(3655),
    [anon_sym_PIPE_PIPE] = ACTIONS(3655),
    [anon_sym_GT_GT] = ACTIONS(3653),
    [anon_sym_GT_GT_GT] = ACTIONS(3655),
    [anon_sym_LT_LT] = ACTIONS(3655),
    [anon_sym_AMP] = ACTIONS(3653),
    [anon_sym_CARET] = ACTIONS(3655),
    [anon_sym_PIPE] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [anon_sym_PERCENT] = ACTIONS(3655),
    [anon_sym_STAR_STAR] = ACTIONS(3655),
    [anon_sym_LT_EQ] = ACTIONS(3655),
    [anon_sym_EQ_EQ] = ACTIONS(3653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3655),
    [anon_sym_BANG_EQ] = ACTIONS(3653),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3655),
    [anon_sym_GT_EQ] = ACTIONS(3655),
    [anon_sym_instanceof] = ACTIONS(3655),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3655),
    [sym__automatic_semicolon] = ACTIONS(3655),
  },
  [1370] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1371] = {
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_as] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_else] = ACTIONS(1125),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_in] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [sym__automatic_semicolon] = ACTIONS(1133),
  },
  [1372] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4492),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(4502),
    [anon_sym_of] = ACTIONS(4505),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1373] = {
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [sym__automatic_semicolon] = ACTIONS(1205),
  },
  [1374] = {
    [anon_sym_STAR] = ACTIONS(3913),
    [anon_sym_as] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_in] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_SLASH] = ACTIONS(3913),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3913),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3913),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_PLUS] = ACTIONS(3913),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3913),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3913),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_instanceof] = ACTIONS(3766),
    [anon_sym_BANG] = ACTIONS(3913),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3766),
    [sym__automatic_semicolon] = ACTIONS(3766),
  },
  [1375] = {
    [anon_sym_STAR] = ACTIONS(3923),
    [anon_sym_as] = ACTIONS(3925),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_RBRACE] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_in] = ACTIONS(3923),
    [anon_sym_SEMI] = ACTIONS(3925),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_SLASH] = ACTIONS(3923),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3923),
    [anon_sym_GT_GT_GT] = ACTIONS(3925),
    [anon_sym_LT_LT] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_CARET] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_STAR_STAR] = ACTIONS(3925),
    [anon_sym_LT_EQ] = ACTIONS(3925),
    [anon_sym_EQ_EQ] = ACTIONS(3923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3923),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3925),
    [anon_sym_GT_EQ] = ACTIONS(3925),
    [anon_sym_instanceof] = ACTIONS(3925),
    [anon_sym_BANG] = ACTIONS(3923),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [sym__automatic_semicolon] = ACTIONS(3925),
  },
  [1376] = {
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_as] = ACTIONS(3370),
    [anon_sym_COMMA] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_DOT] = ACTIONS(3370),
    [anon_sym_QMARK] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_PIPE_PIPE] = ACTIONS(3370),
    [anon_sym_GT_GT] = ACTIONS(3368),
    [anon_sym_GT_GT_GT] = ACTIONS(3370),
    [anon_sym_LT_LT] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_CARET] = ACTIONS(3370),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3370),
    [anon_sym_STAR_STAR] = ACTIONS(3370),
    [anon_sym_LT_EQ] = ACTIONS(3370),
    [anon_sym_EQ_EQ] = ACTIONS(3368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3370),
    [anon_sym_BANG_EQ] = ACTIONS(3368),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3370),
    [anon_sym_GT_EQ] = ACTIONS(3370),
    [anon_sym_instanceof] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [sym__automatic_semicolon] = ACTIONS(3370),
  },
  [1377] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4507),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1378] = {
    [anon_sym_STAR] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3907),
    [anon_sym_RBRACE] = ACTIONS(3907),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3907),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3907),
    [anon_sym_LT_LT] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_CARET] = ACTIONS(3907),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_STAR_STAR] = ACTIONS(3907),
    [anon_sym_LT_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ] = ACTIONS(3905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3905),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3907),
    [anon_sym_GT_EQ] = ACTIONS(3907),
    [anon_sym_instanceof] = ACTIONS(3907),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3907),
    [anon_sym_DASH_DASH] = ACTIONS(3907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [sym__automatic_semicolon] = ACTIONS(3907),
  },
  [1379] = {
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_as] = ACTIONS(2450),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_in] = ACTIONS(2452),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_DOT] = ACTIONS(2450),
    [anon_sym_QMARK] = ACTIONS(2450),
    [anon_sym_AMP_AMP] = ACTIONS(2450),
    [anon_sym_PIPE_PIPE] = ACTIONS(2450),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_STAR_STAR] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_EQ_EQ] = ACTIONS(2452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG_EQ] = ACTIONS(2452),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2450),
    [anon_sym_DASH_DASH] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [sym__automatic_semicolon] = ACTIONS(2450),
  },
  [1380] = {
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_as] = ACTIONS(2342),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(2344),
    [anon_sym_DOT] = ACTIONS(3794),
    [anon_sym_QMARK] = ACTIONS(2342),
    [anon_sym_AMP_AMP] = ACTIONS(2342),
    [anon_sym_PIPE_PIPE] = ACTIONS(2342),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_GT_GT_GT] = ACTIONS(2342),
    [anon_sym_LT_LT] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(2342),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_PERCENT] = ACTIONS(2342),
    [anon_sym_STAR_STAR] = ACTIONS(2342),
    [anon_sym_LT_EQ] = ACTIONS(2342),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2342),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2342),
    [anon_sym_GT_EQ] = ACTIONS(2342),
    [anon_sym_instanceof] = ACTIONS(2342),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [sym__automatic_semicolon] = ACTIONS(2342),
  },
  [1381] = {
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_as] = ACTIONS(3768),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_RBRACE] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3768),
    [anon_sym_in] = ACTIONS(3903),
    [anon_sym_SEMI] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_SLASH] = ACTIONS(3903),
    [anon_sym_DOT] = ACTIONS(3768),
    [anon_sym_QMARK] = ACTIONS(3768),
    [anon_sym_AMP_AMP] = ACTIONS(3768),
    [anon_sym_PIPE_PIPE] = ACTIONS(3768),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_GT_GT_GT] = ACTIONS(3768),
    [anon_sym_LT_LT] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3903),
    [anon_sym_CARET] = ACTIONS(3768),
    [anon_sym_PIPE] = ACTIONS(3903),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_PERCENT] = ACTIONS(3768),
    [anon_sym_STAR_STAR] = ACTIONS(3768),
    [anon_sym_LT_EQ] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3768),
    [anon_sym_BANG_EQ] = ACTIONS(3903),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3768),
    [anon_sym_GT_EQ] = ACTIONS(3768),
    [anon_sym_instanceof] = ACTIONS(3768),
    [anon_sym_BANG] = ACTIONS(3903),
    [anon_sym_PLUS_PLUS] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3768),
    [sym__automatic_semicolon] = ACTIONS(3768),
  },
  [1382] = {
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3770),
    [anon_sym_COMMA] = ACTIONS(3770),
    [anon_sym_RBRACE] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_in] = ACTIONS(3899),
    [anon_sym_SEMI] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LT] = ACTIONS(3899),
    [anon_sym_GT] = ACTIONS(3899),
    [anon_sym_SLASH] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_GT_GT] = ACTIONS(3899),
    [anon_sym_GT_GT_GT] = ACTIONS(3770),
    [anon_sym_LT_LT] = ACTIONS(3770),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_CARET] = ACTIONS(3770),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_STAR_STAR] = ACTIONS(3770),
    [anon_sym_LT_EQ] = ACTIONS(3770),
    [anon_sym_EQ_EQ] = ACTIONS(3899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3770),
    [anon_sym_GT_EQ] = ACTIONS(3770),
    [anon_sym_instanceof] = ACTIONS(3770),
    [anon_sym_BANG] = ACTIONS(3899),
    [anon_sym_PLUS_PLUS] = ACTIONS(3770),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3770),
    [sym__automatic_semicolon] = ACTIONS(3770),
  },
  [1383] = {
    [anon_sym_STAR] = ACTIONS(3890),
    [anon_sym_as] = ACTIONS(3892),
    [anon_sym_COMMA] = ACTIONS(3892),
    [anon_sym_RBRACE] = ACTIONS(3892),
    [anon_sym_LPAREN] = ACTIONS(3892),
    [anon_sym_in] = ACTIONS(3890),
    [anon_sym_SEMI] = ACTIONS(3892),
    [anon_sym_LBRACK] = ACTIONS(3892),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_GT] = ACTIONS(3890),
    [anon_sym_SLASH] = ACTIONS(3890),
    [anon_sym_DOT] = ACTIONS(3892),
    [anon_sym_QMARK] = ACTIONS(3892),
    [anon_sym_AMP_AMP] = ACTIONS(3892),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_GT_GT] = ACTIONS(3890),
    [anon_sym_GT_GT_GT] = ACTIONS(3892),
    [anon_sym_LT_LT] = ACTIONS(3892),
    [anon_sym_AMP] = ACTIONS(3890),
    [anon_sym_CARET] = ACTIONS(3892),
    [anon_sym_PIPE] = ACTIONS(3890),
    [anon_sym_PLUS] = ACTIONS(3890),
    [anon_sym_DASH] = ACTIONS(3890),
    [anon_sym_PERCENT] = ACTIONS(3892),
    [anon_sym_STAR_STAR] = ACTIONS(3892),
    [anon_sym_LT_EQ] = ACTIONS(3892),
    [anon_sym_EQ_EQ] = ACTIONS(3890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3892),
    [anon_sym_BANG_EQ] = ACTIONS(3890),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3892),
    [anon_sym_GT_EQ] = ACTIONS(3892),
    [anon_sym_instanceof] = ACTIONS(3892),
    [anon_sym_BANG] = ACTIONS(3890),
    [anon_sym_PLUS_PLUS] = ACTIONS(3892),
    [anon_sym_DASH_DASH] = ACTIONS(3892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3892),
    [sym__automatic_semicolon] = ACTIONS(3892),
  },
  [1384] = {
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_as] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_in] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(4509),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_SLASH] = ACTIONS(2408),
    [anon_sym_DOT] = ACTIONS(2406),
    [anon_sym_QMARK] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_GT_GT] = ACTIONS(2408),
    [anon_sym_GT_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_CARET] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_PERCENT] = ACTIONS(2406),
    [anon_sym_STAR_STAR] = ACTIONS(2406),
    [anon_sym_LT_EQ] = ACTIONS(2406),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2406),
    [anon_sym_BANG_EQ] = ACTIONS(2408),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2406),
    [anon_sym_GT_EQ] = ACTIONS(2406),
    [anon_sym_instanceof] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [sym__automatic_semicolon] = ACTIONS(2406),
  },
  [1385] = {
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_as] = ACTIONS(2436),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_in] = ACTIONS(2438),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_GT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2438),
    [anon_sym_DOT] = ACTIONS(2436),
    [anon_sym_QMARK] = ACTIONS(2436),
    [anon_sym_AMP_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2436),
    [anon_sym_GT_GT] = ACTIONS(2438),
    [anon_sym_GT_GT_GT] = ACTIONS(2436),
    [anon_sym_LT_LT] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_CARET] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_STAR_STAR] = ACTIONS(2436),
    [anon_sym_LT_EQ] = ACTIONS(2436),
    [anon_sym_EQ_EQ] = ACTIONS(2438),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2436),
    [anon_sym_BANG_EQ] = ACTIONS(2438),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2436),
    [anon_sym_GT_EQ] = ACTIONS(2436),
    [anon_sym_instanceof] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2436),
    [sym__automatic_semicolon] = ACTIONS(2436),
  },
  [1386] = {
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_as] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_in] = ACTIONS(2456),
    [anon_sym_SEMI] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_SLASH] = ACTIONS(2456),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_GT_GT] = ACTIONS(2456),
    [anon_sym_GT_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_STAR_STAR] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_instanceof] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [sym__automatic_semicolon] = ACTIONS(2454),
  },
  [1387] = {
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(2468),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2468),
    [anon_sym_GT_GT_GT] = ACTIONS(2466),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_STAR_STAR] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2466),
    [anon_sym_GT_EQ] = ACTIONS(2466),
    [anon_sym_instanceof] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2466),
    [sym__automatic_semicolon] = ACTIONS(2466),
  },
  [1388] = {
    [anon_sym_STAR] = ACTIONS(3669),
    [anon_sym_EQ] = ACTIONS(3669),
    [anon_sym_as] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3669),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3669),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3669),
    [anon_sym_GT] = ACTIONS(3669),
    [anon_sym_SLASH] = ACTIONS(3669),
    [anon_sym_DOT] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE] = ACTIONS(3671),
    [anon_sym_GT_GT] = ACTIONS(3669),
    [anon_sym_GT_GT_GT] = ACTIONS(3671),
    [anon_sym_LT_LT] = ACTIONS(3671),
    [anon_sym_AMP] = ACTIONS(3669),
    [anon_sym_CARET] = ACTIONS(3671),
    [anon_sym_PIPE] = ACTIONS(3669),
    [anon_sym_PLUS] = ACTIONS(3669),
    [anon_sym_DASH] = ACTIONS(3669),
    [anon_sym_PERCENT] = ACTIONS(3671),
    [anon_sym_STAR_STAR] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_EQ_EQ] = ACTIONS(3669),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3669),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3671),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_instanceof] = ACTIONS(3671),
    [anon_sym_BANG] = ACTIONS(3669),
    [anon_sym_PLUS_PLUS] = ACTIONS(3671),
    [anon_sym_DASH_DASH] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3671),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3671),
  },
  [1389] = {
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_as] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_GT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2390),
    [anon_sym_DOT] = ACTIONS(2388),
    [anon_sym_QMARK] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_PIPE_PIPE] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2390),
    [anon_sym_GT_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_CARET] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PERCENT] = ACTIONS(2388),
    [anon_sym_STAR_STAR] = ACTIONS(2388),
    [anon_sym_LT_EQ] = ACTIONS(2388),
    [anon_sym_EQ_EQ] = ACTIONS(2390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2388),
    [anon_sym_BANG_EQ] = ACTIONS(2390),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2388),
    [anon_sym_GT_EQ] = ACTIONS(2388),
    [anon_sym_instanceof] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [sym__automatic_semicolon] = ACTIONS(2388),
  },
  [1390] = {
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_as] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2394),
    [anon_sym_DOT] = ACTIONS(4271),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_PIPE_PIPE] = ACTIONS(2392),
    [anon_sym_GT_GT] = ACTIONS(2394),
    [anon_sym_GT_GT_GT] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_STAR_STAR] = ACTIONS(2392),
    [anon_sym_LT_EQ] = ACTIONS(2392),
    [anon_sym_EQ_EQ] = ACTIONS(2394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2392),
    [anon_sym_BANG_EQ] = ACTIONS(2394),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2392),
    [anon_sym_GT_EQ] = ACTIONS(2392),
    [anon_sym_instanceof] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [sym__automatic_semicolon] = ACTIONS(2392),
  },
  [1391] = {
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [sym__automatic_semicolon] = ACTIONS(2424),
  },
  [1392] = {
    [sym_string] = STATE(1811),
    [sym__property_name] = STATE(1811),
    [sym_computed_property_name] = STATE(1811),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4469),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4471),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4475),
    [anon_sym_set] = ACTIONS(4475),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4511),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1393] = {
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_as] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2348),
    [anon_sym_in] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_GT] = ACTIONS(2350),
    [anon_sym_SLASH] = ACTIONS(2350),
    [anon_sym_DOT] = ACTIONS(2348),
    [anon_sym_QMARK] = ACTIONS(2348),
    [anon_sym_AMP_AMP] = ACTIONS(2348),
    [anon_sym_PIPE_PIPE] = ACTIONS(2348),
    [anon_sym_GT_GT] = ACTIONS(2350),
    [anon_sym_GT_GT_GT] = ACTIONS(2348),
    [anon_sym_LT_LT] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_CARET] = ACTIONS(2348),
    [anon_sym_PIPE] = ACTIONS(2350),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_PERCENT] = ACTIONS(2348),
    [anon_sym_STAR_STAR] = ACTIONS(2348),
    [anon_sym_LT_EQ] = ACTIONS(2348),
    [anon_sym_EQ_EQ] = ACTIONS(2350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2348),
    [anon_sym_BANG_EQ] = ACTIONS(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2348),
    [anon_sym_GT_EQ] = ACTIONS(2348),
    [anon_sym_instanceof] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2348),
    [sym__automatic_semicolon] = ACTIONS(2348),
  },
  [1394] = {
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_as] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2400),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_DOT] = ACTIONS(2398),
    [anon_sym_QMARK] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_PIPE_PIPE] = ACTIONS(2398),
    [anon_sym_GT_GT] = ACTIONS(2400),
    [anon_sym_GT_GT_GT] = ACTIONS(2398),
    [anon_sym_LT_LT] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_CARET] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_STAR_STAR] = ACTIONS(2398),
    [anon_sym_LT_EQ] = ACTIONS(2398),
    [anon_sym_EQ_EQ] = ACTIONS(2400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2398),
    [anon_sym_BANG_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2398),
    [anon_sym_GT_EQ] = ACTIONS(2398),
    [anon_sym_instanceof] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [sym__automatic_semicolon] = ACTIONS(2398),
  },
  [1395] = {
    [anon_sym_STAR] = ACTIONS(4131),
    [anon_sym_as] = ACTIONS(3749),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3749),
    [anon_sym_in] = ACTIONS(4131),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_LT] = ACTIONS(4131),
    [anon_sym_GT] = ACTIONS(4131),
    [anon_sym_SLASH] = ACTIONS(4131),
    [anon_sym_DOT] = ACTIONS(3749),
    [anon_sym_QMARK] = ACTIONS(3749),
    [anon_sym_AMP_AMP] = ACTIONS(3749),
    [anon_sym_PIPE_PIPE] = ACTIONS(3749),
    [anon_sym_GT_GT] = ACTIONS(4131),
    [anon_sym_GT_GT_GT] = ACTIONS(3749),
    [anon_sym_LT_LT] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(4131),
    [anon_sym_CARET] = ACTIONS(3749),
    [anon_sym_PIPE] = ACTIONS(4131),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(3749),
    [anon_sym_STAR_STAR] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(3749),
    [anon_sym_EQ_EQ] = ACTIONS(4131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3749),
    [anon_sym_BANG_EQ] = ACTIONS(4131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3749),
    [anon_sym_GT_EQ] = ACTIONS(3749),
    [anon_sym_instanceof] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(4131),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3749),
    [sym__automatic_semicolon] = ACTIONS(3749),
  },
  [1396] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4513),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(4515),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4088),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4088),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1397] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1398] = {
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_as] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3828),
    [anon_sym_RBRACE] = ACTIONS(3828),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3826),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_GT] = ACTIONS(3826),
    [anon_sym_SLASH] = ACTIONS(3826),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_GT_GT] = ACTIONS(3826),
    [anon_sym_GT_GT_GT] = ACTIONS(3828),
    [anon_sym_LT_LT] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3826),
    [anon_sym_CARET] = ACTIONS(3828),
    [anon_sym_PIPE] = ACTIONS(3826),
    [anon_sym_PLUS] = ACTIONS(3826),
    [anon_sym_DASH] = ACTIONS(3826),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_STAR_STAR] = ACTIONS(3828),
    [anon_sym_LT_EQ] = ACTIONS(3828),
    [anon_sym_EQ_EQ] = ACTIONS(3826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3828),
    [anon_sym_GT_EQ] = ACTIONS(3828),
    [anon_sym_instanceof] = ACTIONS(3828),
    [anon_sym_BANG] = ACTIONS(3826),
    [anon_sym_PLUS_PLUS] = ACTIONS(3828),
    [anon_sym_DASH_DASH] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3828),
    [sym__automatic_semicolon] = ACTIONS(3828),
  },
  [1399] = {
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_as] = ACTIONS(3824),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_RBRACE] = ACTIONS(3824),
    [anon_sym_LPAREN] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3822),
    [anon_sym_SEMI] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_LT] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3822),
    [anon_sym_DOT] = ACTIONS(3824),
    [anon_sym_QMARK] = ACTIONS(3824),
    [anon_sym_AMP_AMP] = ACTIONS(3824),
    [anon_sym_PIPE_PIPE] = ACTIONS(3824),
    [anon_sym_GT_GT] = ACTIONS(3822),
    [anon_sym_GT_GT_GT] = ACTIONS(3824),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_CARET] = ACTIONS(3824),
    [anon_sym_PIPE] = ACTIONS(3822),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3822),
    [anon_sym_PERCENT] = ACTIONS(3824),
    [anon_sym_STAR_STAR] = ACTIONS(3824),
    [anon_sym_LT_EQ] = ACTIONS(3824),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3824),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3824),
    [anon_sym_GT_EQ] = ACTIONS(3824),
    [anon_sym_instanceof] = ACTIONS(3824),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3824),
    [sym__automatic_semicolon] = ACTIONS(3824),
  },
  [1400] = {
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_as] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(4509),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [sym__automatic_semicolon] = ACTIONS(2416),
  },
  [1401] = {
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_as] = ACTIONS(2432),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_in] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2434),
    [anon_sym_DOT] = ACTIONS(2432),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_AMP_AMP] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(2432),
    [anon_sym_GT_GT] = ACTIONS(2434),
    [anon_sym_GT_GT_GT] = ACTIONS(2432),
    [anon_sym_LT_LT] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_CARET] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_PERCENT] = ACTIONS(2432),
    [anon_sym_STAR_STAR] = ACTIONS(2432),
    [anon_sym_LT_EQ] = ACTIONS(2432),
    [anon_sym_EQ_EQ] = ACTIONS(2434),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ] = ACTIONS(2434),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2432),
    [anon_sym_GT_EQ] = ACTIONS(2432),
    [anon_sym_instanceof] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2432),
    [sym__automatic_semicolon] = ACTIONS(2432),
  },
  [1402] = {
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_as] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_in] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2440),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_DOT] = ACTIONS(589),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(589),
    [anon_sym_PIPE_PIPE] = ACTIONS(589),
    [anon_sym_GT_GT] = ACTIONS(2440),
    [anon_sym_GT_GT_GT] = ACTIONS(589),
    [anon_sym_LT_LT] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_CARET] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_PERCENT] = ACTIONS(589),
    [anon_sym_STAR_STAR] = ACTIONS(589),
    [anon_sym_LT_EQ] = ACTIONS(589),
    [anon_sym_EQ_EQ] = ACTIONS(2440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(589),
    [anon_sym_BANG_EQ] = ACTIONS(2440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(589),
    [anon_sym_GT_EQ] = ACTIONS(589),
    [anon_sym_instanceof] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(589),
    [sym__automatic_semicolon] = ACTIONS(589),
  },
  [1403] = {
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_as] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_in] = ACTIONS(2444),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_DOT] = ACTIONS(2442),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_GT_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_PERCENT] = ACTIONS(2442),
    [anon_sym_STAR_STAR] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_instanceof] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [sym__automatic_semicolon] = ACTIONS(2442),
  },
  [1404] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(4519),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1405] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4521),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4524),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(4524),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(4527),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(4524),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1406] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4529),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(4535),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1407] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4088),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4088),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4088),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1408] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4513),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(3409),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1409] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4079),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(4079),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1410] = {
    [anon_sym_STAR] = ACTIONS(3649),
    [anon_sym_EQ] = ACTIONS(3649),
    [anon_sym_as] = ACTIONS(3651),
    [anon_sym_LBRACE] = ACTIONS(3649),
    [anon_sym_COMMA] = ACTIONS(3651),
    [anon_sym_LPAREN] = ACTIONS(3651),
    [anon_sym_in] = ACTIONS(3649),
    [anon_sym_LBRACK] = ACTIONS(3651),
    [anon_sym_LT] = ACTIONS(3649),
    [anon_sym_GT] = ACTIONS(3649),
    [anon_sym_SLASH] = ACTIONS(3649),
    [anon_sym_DOT] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3651),
    [anon_sym_AMP_AMP] = ACTIONS(3651),
    [anon_sym_PIPE_PIPE] = ACTIONS(3651),
    [anon_sym_GT_GT] = ACTIONS(3649),
    [anon_sym_GT_GT_GT] = ACTIONS(3651),
    [anon_sym_LT_LT] = ACTIONS(3651),
    [anon_sym_AMP] = ACTIONS(3649),
    [anon_sym_CARET] = ACTIONS(3651),
    [anon_sym_PIPE] = ACTIONS(3649),
    [anon_sym_PLUS] = ACTIONS(3649),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_PERCENT] = ACTIONS(3651),
    [anon_sym_STAR_STAR] = ACTIONS(3651),
    [anon_sym_LT_EQ] = ACTIONS(3651),
    [anon_sym_EQ_EQ] = ACTIONS(3649),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3651),
    [anon_sym_BANG_EQ] = ACTIONS(3649),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3651),
    [anon_sym_GT_EQ] = ACTIONS(3651),
    [anon_sym_instanceof] = ACTIONS(3651),
    [anon_sym_BANG] = ACTIONS(3649),
    [anon_sym_PLUS_PLUS] = ACTIONS(3651),
    [anon_sym_DASH_DASH] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3651),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3651),
  },
  [1411] = {
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
    [anon_sym_SEMI] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4075),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [sym__automatic_semicolon] = ACTIONS(4077),
  },
  [1412] = {
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [sym__automatic_semicolon] = ACTIONS(1167),
  },
  [1413] = {
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
    [anon_sym_SEMI] = ACTIONS(4077),
    [anon_sym_LBRACK] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4075),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [sym__automatic_semicolon] = ACTIONS(4077),
  },
  [1414] = {
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [sym__automatic_semicolon] = ACTIONS(1095),
  },
  [1415] = {
    [anon_sym_STAR] = ACTIONS(4281),
    [anon_sym_as] = ACTIONS(4281),
    [anon_sym_LBRACE] = ACTIONS(4283),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_in] = ACTIONS(4281),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LT] = ACTIONS(4281),
    [anon_sym_GT] = ACTIONS(4281),
    [anon_sym_SLASH] = ACTIONS(4281),
    [anon_sym_DOT] = ACTIONS(4283),
    [anon_sym_QMARK] = ACTIONS(4283),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4281),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_AMP] = ACTIONS(4281),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4281),
    [anon_sym_DASH] = ACTIONS(4281),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_STAR_STAR] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4281),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_instanceof] = ACTIONS(4281),
    [anon_sym_BANG] = ACTIONS(4281),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4283),
    [sym_regex_flags] = ACTIONS(4285),
    [anon_sym_implements] = ACTIONS(4281),
  },
  [1416] = {
    [anon_sym_STAR] = ACTIONS(3661),
    [anon_sym_EQ] = ACTIONS(3661),
    [anon_sym_as] = ACTIONS(3663),
    [anon_sym_LBRACE] = ACTIONS(3661),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_LPAREN] = ACTIONS(3663),
    [anon_sym_in] = ACTIONS(3661),
    [anon_sym_LBRACK] = ACTIONS(3663),
    [anon_sym_LT] = ACTIONS(3661),
    [anon_sym_GT] = ACTIONS(3661),
    [anon_sym_SLASH] = ACTIONS(3661),
    [anon_sym_DOT] = ACTIONS(3663),
    [anon_sym_QMARK] = ACTIONS(3663),
    [anon_sym_AMP_AMP] = ACTIONS(3663),
    [anon_sym_PIPE_PIPE] = ACTIONS(3663),
    [anon_sym_GT_GT] = ACTIONS(3661),
    [anon_sym_GT_GT_GT] = ACTIONS(3663),
    [anon_sym_LT_LT] = ACTIONS(3663),
    [anon_sym_AMP] = ACTIONS(3661),
    [anon_sym_CARET] = ACTIONS(3663),
    [anon_sym_PIPE] = ACTIONS(3661),
    [anon_sym_PLUS] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(3661),
    [anon_sym_PERCENT] = ACTIONS(3663),
    [anon_sym_STAR_STAR] = ACTIONS(3663),
    [anon_sym_LT_EQ] = ACTIONS(3663),
    [anon_sym_EQ_EQ] = ACTIONS(3661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3663),
    [anon_sym_BANG_EQ] = ACTIONS(3661),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3663),
    [anon_sym_GT_EQ] = ACTIONS(3663),
    [anon_sym_instanceof] = ACTIONS(3663),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_PLUS_PLUS] = ACTIONS(3663),
    [anon_sym_DASH_DASH] = ACTIONS(3663),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3663),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3663),
  },
  [1417] = {
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1147),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1147),
    [anon_sym_PIPE_PIPE] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(1145),
    [anon_sym_GT_GT_GT] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_PERCENT] = ACTIONS(1147),
    [anon_sym_STAR_STAR] = ACTIONS(1147),
    [anon_sym_LT_EQ] = ACTIONS(1147),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1147),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1147),
    [anon_sym_GT_EQ] = ACTIONS(1147),
    [anon_sym_instanceof] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [sym__automatic_semicolon] = ACTIONS(1147),
  },
  [1418] = {
    [anon_sym_STAR] = ACTIONS(3657),
    [anon_sym_EQ] = ACTIONS(3657),
    [anon_sym_as] = ACTIONS(3659),
    [anon_sym_LBRACE] = ACTIONS(3657),
    [anon_sym_COMMA] = ACTIONS(3659),
    [anon_sym_LPAREN] = ACTIONS(3659),
    [anon_sym_in] = ACTIONS(3657),
    [anon_sym_LBRACK] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3657),
    [anon_sym_GT] = ACTIONS(3657),
    [anon_sym_SLASH] = ACTIONS(3657),
    [anon_sym_DOT] = ACTIONS(3659),
    [anon_sym_QMARK] = ACTIONS(3659),
    [anon_sym_AMP_AMP] = ACTIONS(3659),
    [anon_sym_PIPE_PIPE] = ACTIONS(3659),
    [anon_sym_GT_GT] = ACTIONS(3657),
    [anon_sym_GT_GT_GT] = ACTIONS(3659),
    [anon_sym_LT_LT] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3657),
    [anon_sym_CARET] = ACTIONS(3659),
    [anon_sym_PIPE] = ACTIONS(3657),
    [anon_sym_PLUS] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(3657),
    [anon_sym_PERCENT] = ACTIONS(3659),
    [anon_sym_STAR_STAR] = ACTIONS(3659),
    [anon_sym_LT_EQ] = ACTIONS(3659),
    [anon_sym_EQ_EQ] = ACTIONS(3657),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3659),
    [anon_sym_BANG_EQ] = ACTIONS(3657),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3659),
    [anon_sym_GT_EQ] = ACTIONS(3659),
    [anon_sym_instanceof] = ACTIONS(3659),
    [anon_sym_BANG] = ACTIONS(3657),
    [anon_sym_PLUS_PLUS] = ACTIONS(3659),
    [anon_sym_DASH_DASH] = ACTIONS(3659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3659),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3659),
  },
  [1419] = {
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1135),
    [anon_sym_PIPE_PIPE] = ACTIONS(1135),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_GT_GT_GT] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1135),
    [sym__automatic_semicolon] = ACTIONS(4537),
  },
  [1420] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1071),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1073),
  },
  [1421] = {
    [anon_sym_STAR] = ACTIONS(3653),
    [anon_sym_EQ] = ACTIONS(3653),
    [anon_sym_as] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_COMMA] = ACTIONS(3655),
    [anon_sym_LPAREN] = ACTIONS(3655),
    [anon_sym_in] = ACTIONS(3653),
    [anon_sym_LBRACK] = ACTIONS(3655),
    [anon_sym_LT] = ACTIONS(3653),
    [anon_sym_GT] = ACTIONS(3653),
    [anon_sym_SLASH] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3655),
    [anon_sym_QMARK] = ACTIONS(3655),
    [anon_sym_AMP_AMP] = ACTIONS(3655),
    [anon_sym_PIPE_PIPE] = ACTIONS(3655),
    [anon_sym_GT_GT] = ACTIONS(3653),
    [anon_sym_GT_GT_GT] = ACTIONS(3655),
    [anon_sym_LT_LT] = ACTIONS(3655),
    [anon_sym_AMP] = ACTIONS(3653),
    [anon_sym_CARET] = ACTIONS(3655),
    [anon_sym_PIPE] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3653),
    [anon_sym_PERCENT] = ACTIONS(3655),
    [anon_sym_STAR_STAR] = ACTIONS(3655),
    [anon_sym_LT_EQ] = ACTIONS(3655),
    [anon_sym_EQ_EQ] = ACTIONS(3653),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3655),
    [anon_sym_BANG_EQ] = ACTIONS(3653),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3655),
    [anon_sym_GT_EQ] = ACTIONS(3655),
    [anon_sym_instanceof] = ACTIONS(3655),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3655),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3655),
  },
  [1422] = {
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_as] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_in] = ACTIONS(1129),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [sym__automatic_semicolon] = ACTIONS(1131),
  },
  [1423] = {
    [anon_sym_STAR] = ACTIONS(4071),
    [anon_sym_as] = ACTIONS(4073),
    [anon_sym_COMMA] = ACTIONS(4073),
    [anon_sym_RBRACE] = ACTIONS(4073),
    [anon_sym_LPAREN] = ACTIONS(4073),
    [anon_sym_in] = ACTIONS(4071),
    [anon_sym_SEMI] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_SLASH] = ACTIONS(4071),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(4073),
    [anon_sym_AMP_AMP] = ACTIONS(4073),
    [anon_sym_PIPE_PIPE] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_GT_GT_GT] = ACTIONS(4073),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_AMP] = ACTIONS(4071),
    [anon_sym_CARET] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_PERCENT] = ACTIONS(4073),
    [anon_sym_STAR_STAR] = ACTIONS(4073),
    [anon_sym_LT_EQ] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4073),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4073),
    [anon_sym_GT_EQ] = ACTIONS(4073),
    [anon_sym_instanceof] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4073),
    [anon_sym_DASH_DASH] = ACTIONS(4073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4073),
    [sym__automatic_semicolon] = ACTIONS(4073),
  },
  [1424] = {
    [anon_sym_STAR] = ACTIONS(3665),
    [anon_sym_EQ] = ACTIONS(3665),
    [anon_sym_as] = ACTIONS(3667),
    [anon_sym_LBRACE] = ACTIONS(3665),
    [anon_sym_COMMA] = ACTIONS(3667),
    [anon_sym_LPAREN] = ACTIONS(3667),
    [anon_sym_in] = ACTIONS(3665),
    [anon_sym_LBRACK] = ACTIONS(3667),
    [anon_sym_LT] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_SLASH] = ACTIONS(3665),
    [anon_sym_DOT] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(3667),
    [anon_sym_AMP_AMP] = ACTIONS(3667),
    [anon_sym_PIPE_PIPE] = ACTIONS(3667),
    [anon_sym_GT_GT] = ACTIONS(3665),
    [anon_sym_GT_GT_GT] = ACTIONS(3667),
    [anon_sym_LT_LT] = ACTIONS(3667),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_CARET] = ACTIONS(3667),
    [anon_sym_PIPE] = ACTIONS(3665),
    [anon_sym_PLUS] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(3665),
    [anon_sym_PERCENT] = ACTIONS(3667),
    [anon_sym_STAR_STAR] = ACTIONS(3667),
    [anon_sym_LT_EQ] = ACTIONS(3667),
    [anon_sym_EQ_EQ] = ACTIONS(3665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3667),
    [anon_sym_BANG_EQ] = ACTIONS(3665),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3667),
    [anon_sym_GT_EQ] = ACTIONS(3667),
    [anon_sym_instanceof] = ACTIONS(3667),
    [anon_sym_BANG] = ACTIONS(3665),
    [anon_sym_PLUS_PLUS] = ACTIONS(3667),
    [anon_sym_DASH_DASH] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3667),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3667),
  },
  [1425] = {
    [sym_string] = STATE(1816),
    [sym__property_name] = STATE(1816),
    [sym_computed_property_name] = STATE(1816),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4539),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4541),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4543),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4545),
    [anon_sym_set] = ACTIONS(4545),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1426] = {
    [anon_sym_STAR] = ACTIONS(3673),
    [anon_sym_EQ] = ACTIONS(3673),
    [anon_sym_as] = ACTIONS(3675),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_LPAREN] = ACTIONS(3675),
    [anon_sym_in] = ACTIONS(3673),
    [anon_sym_LBRACK] = ACTIONS(3675),
    [anon_sym_LT] = ACTIONS(3673),
    [anon_sym_GT] = ACTIONS(3673),
    [anon_sym_SLASH] = ACTIONS(3673),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3673),
    [anon_sym_GT_GT_GT] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3673),
    [anon_sym_CARET] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3673),
    [anon_sym_PLUS] = ACTIONS(3673),
    [anon_sym_DASH] = ACTIONS(3673),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_STAR_STAR] = ACTIONS(3675),
    [anon_sym_LT_EQ] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3673),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3675),
    [anon_sym_BANG_EQ] = ACTIONS(3673),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3675),
    [anon_sym_instanceof] = ACTIONS(3675),
    [anon_sym_BANG] = ACTIONS(3673),
    [anon_sym_PLUS_PLUS] = ACTIONS(3675),
    [anon_sym_DASH_DASH] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3675),
  },
  [1427] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(2450),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
  },
  [1428] = {
    [anon_sym_STAR] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_RBRACE] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_in] = ACTIONS(3772),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_GT] = ACTIONS(3772),
    [anon_sym_SLASH] = ACTIONS(3772),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_GT_GT] = ACTIONS(3772),
    [anon_sym_GT_GT_GT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3772),
    [anon_sym_CARET] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3774),
    [anon_sym_EQ_EQ] = ACTIONS(3772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3772),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3774),
    [anon_sym_GT_EQ] = ACTIONS(3774),
    [anon_sym_instanceof] = ACTIONS(3774),
    [anon_sym_BANG] = ACTIONS(3772),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3774),
    [sym__automatic_semicolon] = ACTIONS(3774),
  },
  [1429] = {
    [anon_sym_STAR] = ACTIONS(4069),
    [anon_sym_as] = ACTIONS(3728),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_RBRACE] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_in] = ACTIONS(4069),
    [anon_sym_SEMI] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_SLASH] = ACTIONS(4069),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_GT_GT_GT] = ACTIONS(3728),
    [anon_sym_LT_LT] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(4069),
    [anon_sym_CARET] = ACTIONS(3728),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_STAR_STAR] = ACTIONS(3728),
    [anon_sym_LT_EQ] = ACTIONS(3728),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3728),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_instanceof] = ACTIONS(3728),
    [anon_sym_BANG] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3728),
    [anon_sym_DASH_DASH] = ACTIONS(3728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3728),
    [sym__automatic_semicolon] = ACTIONS(3728),
  },
  [1430] = {
    [sym_string] = STATE(1811),
    [sym__property_name] = STATE(1811),
    [sym_computed_property_name] = STATE(1811),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4469),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4471),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4475),
    [anon_sym_set] = ACTIONS(4475),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1431] = {
    [anon_sym_STAR] = ACTIONS(4065),
    [anon_sym_as] = ACTIONS(4067),
    [anon_sym_COMMA] = ACTIONS(4067),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(4067),
    [anon_sym_in] = ACTIONS(4065),
    [anon_sym_SEMI] = ACTIONS(4067),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4065),
    [anon_sym_GT] = ACTIONS(4065),
    [anon_sym_SLASH] = ACTIONS(4065),
    [anon_sym_DOT] = ACTIONS(4067),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_GT_GT] = ACTIONS(4065),
    [anon_sym_GT_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_CARET] = ACTIONS(4067),
    [anon_sym_PIPE] = ACTIONS(4065),
    [anon_sym_PLUS] = ACTIONS(4065),
    [anon_sym_DASH] = ACTIONS(4065),
    [anon_sym_PERCENT] = ACTIONS(4067),
    [anon_sym_STAR_STAR] = ACTIONS(4067),
    [anon_sym_LT_EQ] = ACTIONS(4067),
    [anon_sym_EQ_EQ] = ACTIONS(4065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4067),
    [anon_sym_BANG_EQ] = ACTIONS(4065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4067),
    [anon_sym_GT_EQ] = ACTIONS(4067),
    [anon_sym_instanceof] = ACTIONS(4067),
    [anon_sym_BANG] = ACTIONS(4065),
    [anon_sym_PLUS_PLUS] = ACTIONS(4067),
    [anon_sym_DASH_DASH] = ACTIONS(4067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [sym__automatic_semicolon] = ACTIONS(4067),
  },
  [1432] = {
    [sym_string] = STATE(2025),
    [sym__property_name] = STATE(2025),
    [sym_computed_property_name] = STATE(2025),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4467),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4547),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4549),
    [anon_sym_set] = ACTIONS(4549),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1433] = {
    [anon_sym_STAR] = ACTIONS(4061),
    [anon_sym_as] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [anon_sym_LPAREN] = ACTIONS(4063),
    [anon_sym_in] = ACTIONS(4061),
    [anon_sym_SEMI] = ACTIONS(4063),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(4061),
    [anon_sym_GT] = ACTIONS(4061),
    [anon_sym_SLASH] = ACTIONS(4061),
    [anon_sym_DOT] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(4063),
    [anon_sym_AMP_AMP] = ACTIONS(4063),
    [anon_sym_PIPE_PIPE] = ACTIONS(4063),
    [anon_sym_GT_GT] = ACTIONS(4061),
    [anon_sym_GT_GT_GT] = ACTIONS(4063),
    [anon_sym_LT_LT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4061),
    [anon_sym_CARET] = ACTIONS(4063),
    [anon_sym_PIPE] = ACTIONS(4061),
    [anon_sym_PLUS] = ACTIONS(4061),
    [anon_sym_DASH] = ACTIONS(4061),
    [anon_sym_PERCENT] = ACTIONS(4063),
    [anon_sym_STAR_STAR] = ACTIONS(4063),
    [anon_sym_LT_EQ] = ACTIONS(4063),
    [anon_sym_EQ_EQ] = ACTIONS(4061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4063),
    [anon_sym_BANG_EQ] = ACTIONS(4061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4063),
    [anon_sym_GT_EQ] = ACTIONS(4063),
    [anon_sym_instanceof] = ACTIONS(4063),
    [anon_sym_BANG] = ACTIONS(4061),
    [anon_sym_PLUS_PLUS] = ACTIONS(4063),
    [anon_sym_DASH_DASH] = ACTIONS(4063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4063),
    [sym__automatic_semicolon] = ACTIONS(4063),
  },
  [1434] = {
    [sym_statement_block] = STATE(1639),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(4553),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1059),
  },
  [1435] = {
    [sym_statement_block] = STATE(1639),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_as] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(4551),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_in] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1059),
    [anon_sym_QMARK] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_GT_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1059),
    [anon_sym_STAR_STAR] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1059),
    [anon_sym_BANG_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_instanceof] = ACTIONS(1059),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1059),
  },
  [1436] = {
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_as] = ACTIONS(3954),
    [anon_sym_COMMA] = ACTIONS(3954),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_in] = ACTIONS(3952),
    [anon_sym_SEMI] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_GT] = ACTIONS(3952),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_GT_GT] = ACTIONS(3952),
    [anon_sym_GT_GT_GT] = ACTIONS(3954),
    [anon_sym_LT_LT] = ACTIONS(3954),
    [anon_sym_AMP] = ACTIONS(3952),
    [anon_sym_CARET] = ACTIONS(3954),
    [anon_sym_PIPE] = ACTIONS(3952),
    [anon_sym_PLUS] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3954),
    [anon_sym_LT_EQ] = ACTIONS(3954),
    [anon_sym_EQ_EQ] = ACTIONS(3952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3952),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3954),
    [anon_sym_GT_EQ] = ACTIONS(3954),
    [anon_sym_instanceof] = ACTIONS(3954),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_PLUS_PLUS] = ACTIONS(3954),
    [anon_sym_DASH_DASH] = ACTIONS(3954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3954),
    [sym__automatic_semicolon] = ACTIONS(3954),
  },
  [1437] = {
    [sym_type_arguments] = STATE(1649),
    [anon_sym_STAR] = ACTIONS(2553),
    [anon_sym_as] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(2553),
    [anon_sym_COMMA] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(2551),
    [anon_sym_in] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(4555),
    [anon_sym_GT] = ACTIONS(2553),
    [anon_sym_SLASH] = ACTIONS(2553),
    [anon_sym_DOT] = ACTIONS(2551),
    [anon_sym_QMARK] = ACTIONS(2551),
    [anon_sym_AMP_AMP] = ACTIONS(2551),
    [anon_sym_PIPE_PIPE] = ACTIONS(2551),
    [anon_sym_GT_GT] = ACTIONS(2553),
    [anon_sym_GT_GT_GT] = ACTIONS(2551),
    [anon_sym_LT_LT] = ACTIONS(2551),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_CARET] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PERCENT] = ACTIONS(2551),
    [anon_sym_STAR_STAR] = ACTIONS(2551),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_EQ_EQ] = ACTIONS(2553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG_EQ] = ACTIONS(2553),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(2553),
    [anon_sym_PLUS_PLUS] = ACTIONS(2551),
    [anon_sym_DASH_DASH] = ACTIONS(2551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2551),
  },
  [1438] = {
    [anon_sym_STAR] = ACTIONS(4061),
    [anon_sym_as] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [anon_sym_LPAREN] = ACTIONS(4063),
    [anon_sym_in] = ACTIONS(4061),
    [anon_sym_SEMI] = ACTIONS(4063),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(4061),
    [anon_sym_GT] = ACTIONS(4061),
    [anon_sym_SLASH] = ACTIONS(4061),
    [anon_sym_DOT] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(4063),
    [anon_sym_AMP_AMP] = ACTIONS(4063),
    [anon_sym_PIPE_PIPE] = ACTIONS(4063),
    [anon_sym_GT_GT] = ACTIONS(4061),
    [anon_sym_GT_GT_GT] = ACTIONS(4063),
    [anon_sym_LT_LT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4061),
    [anon_sym_CARET] = ACTIONS(4063),
    [anon_sym_PIPE] = ACTIONS(4061),
    [anon_sym_PLUS] = ACTIONS(4061),
    [anon_sym_DASH] = ACTIONS(4061),
    [anon_sym_PERCENT] = ACTIONS(4063),
    [anon_sym_STAR_STAR] = ACTIONS(4063),
    [anon_sym_LT_EQ] = ACTIONS(4063),
    [anon_sym_EQ_EQ] = ACTIONS(4061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4063),
    [anon_sym_BANG_EQ] = ACTIONS(4061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4063),
    [anon_sym_GT_EQ] = ACTIONS(4063),
    [anon_sym_instanceof] = ACTIONS(4063),
    [anon_sym_BANG] = ACTIONS(4061),
    [anon_sym_PLUS_PLUS] = ACTIONS(4063),
    [anon_sym_DASH_DASH] = ACTIONS(4063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4063),
    [sym__automatic_semicolon] = ACTIONS(4063),
  },
  [1439] = {
    [anon_sym_STAR] = ACTIONS(4057),
    [anon_sym_as] = ACTIONS(4059),
    [anon_sym_COMMA] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(4059),
    [anon_sym_in] = ACTIONS(4057),
    [anon_sym_SEMI] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4059),
    [anon_sym_LT] = ACTIONS(4057),
    [anon_sym_GT] = ACTIONS(4057),
    [anon_sym_SLASH] = ACTIONS(4057),
    [anon_sym_DOT] = ACTIONS(4059),
    [anon_sym_QMARK] = ACTIONS(4059),
    [anon_sym_AMP_AMP] = ACTIONS(4059),
    [anon_sym_PIPE_PIPE] = ACTIONS(4059),
    [anon_sym_GT_GT] = ACTIONS(4057),
    [anon_sym_GT_GT_GT] = ACTIONS(4059),
    [anon_sym_LT_LT] = ACTIONS(4059),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_CARET] = ACTIONS(4059),
    [anon_sym_PIPE] = ACTIONS(4057),
    [anon_sym_PLUS] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4057),
    [anon_sym_PERCENT] = ACTIONS(4059),
    [anon_sym_STAR_STAR] = ACTIONS(4059),
    [anon_sym_LT_EQ] = ACTIONS(4059),
    [anon_sym_EQ_EQ] = ACTIONS(4057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4059),
    [anon_sym_BANG_EQ] = ACTIONS(4057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4059),
    [anon_sym_GT_EQ] = ACTIONS(4059),
    [anon_sym_instanceof] = ACTIONS(4059),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_PLUS_PLUS] = ACTIONS(4059),
    [anon_sym_DASH_DASH] = ACTIONS(4059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4059),
    [sym__automatic_semicolon] = ACTIONS(4059),
  },
  [1440] = {
    [anon_sym_STAR] = ACTIONS(4053),
    [anon_sym_as] = ACTIONS(4055),
    [anon_sym_COMMA] = ACTIONS(4055),
    [anon_sym_RBRACE] = ACTIONS(4055),
    [anon_sym_LPAREN] = ACTIONS(4055),
    [anon_sym_in] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4053),
    [anon_sym_GT] = ACTIONS(4053),
    [anon_sym_SLASH] = ACTIONS(4053),
    [anon_sym_DOT] = ACTIONS(4055),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_AMP_AMP] = ACTIONS(4055),
    [anon_sym_PIPE_PIPE] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_GT_GT_GT] = ACTIONS(4055),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_CARET] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_PERCENT] = ACTIONS(4055),
    [anon_sym_STAR_STAR] = ACTIONS(4055),
    [anon_sym_LT_EQ] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4055),
    [anon_sym_BANG_EQ] = ACTIONS(4053),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4055),
    [anon_sym_GT_EQ] = ACTIONS(4055),
    [anon_sym_instanceof] = ACTIONS(4055),
    [anon_sym_BANG] = ACTIONS(4053),
    [anon_sym_PLUS_PLUS] = ACTIONS(4055),
    [anon_sym_DASH_DASH] = ACTIONS(4055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4055),
    [sym__automatic_semicolon] = ACTIONS(4055),
  },
  [1441] = {
    [anon_sym_STAR] = ACTIONS(4033),
    [anon_sym_as] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LPAREN] = ACTIONS(4035),
    [anon_sym_in] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4033),
    [anon_sym_GT] = ACTIONS(4033),
    [anon_sym_SLASH] = ACTIONS(4033),
    [anon_sym_DOT] = ACTIONS(4035),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_GT_GT_GT] = ACTIONS(4035),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4033),
    [anon_sym_CARET] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4033),
    [anon_sym_DASH] = ACTIONS(4033),
    [anon_sym_PERCENT] = ACTIONS(4035),
    [anon_sym_STAR_STAR] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4035),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_instanceof] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4035),
    [sym__automatic_semicolon] = ACTIONS(4035),
  },
  [1442] = {
    [sym_arguments] = STATE(1557),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_as] = ACTIONS(3169),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_LT] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_GT_GT] = ACTIONS(3165),
    [anon_sym_GT_GT_GT] = ACTIONS(3169),
    [anon_sym_LT_LT] = ACTIONS(3169),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3169),
    [anon_sym_PIPE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_STAR_STAR] = ACTIONS(3169),
    [anon_sym_LT_EQ] = ACTIONS(3169),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3169),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3169),
    [anon_sym_GT_EQ] = ACTIONS(3169),
    [anon_sym_instanceof] = ACTIONS(3169),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3169),
    [anon_sym_DASH_DASH] = ACTIONS(3169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3169),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3169),
  },
  [1443] = {
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_as] = ACTIONS(4013),
    [anon_sym_COMMA] = ACTIONS(4013),
    [anon_sym_RBRACE] = ACTIONS(4013),
    [anon_sym_LPAREN] = ACTIONS(4013),
    [anon_sym_in] = ACTIONS(4011),
    [anon_sym_SEMI] = ACTIONS(4013),
    [anon_sym_LBRACK] = ACTIONS(4013),
    [anon_sym_LT] = ACTIONS(4011),
    [anon_sym_GT] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4013),
    [anon_sym_QMARK] = ACTIONS(4013),
    [anon_sym_AMP_AMP] = ACTIONS(4013),
    [anon_sym_PIPE_PIPE] = ACTIONS(4013),
    [anon_sym_GT_GT] = ACTIONS(4011),
    [anon_sym_GT_GT_GT] = ACTIONS(4013),
    [anon_sym_LT_LT] = ACTIONS(4013),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_CARET] = ACTIONS(4013),
    [anon_sym_PIPE] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4013),
    [anon_sym_STAR_STAR] = ACTIONS(4013),
    [anon_sym_LT_EQ] = ACTIONS(4013),
    [anon_sym_EQ_EQ] = ACTIONS(4011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4013),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4013),
    [anon_sym_GT_EQ] = ACTIONS(4013),
    [anon_sym_instanceof] = ACTIONS(4013),
    [anon_sym_BANG] = ACTIONS(4011),
    [anon_sym_PLUS_PLUS] = ACTIONS(4013),
    [anon_sym_DASH_DASH] = ACTIONS(4013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4013),
    [sym__automatic_semicolon] = ACTIONS(4013),
  },
  [1444] = {
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_COMMA] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_in] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_LT] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1069),
    [anon_sym_SLASH] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_QMARK] = ACTIONS(1067),
    [anon_sym_AMP_AMP] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1069),
    [anon_sym_GT_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1067),
    [anon_sym_BANG_EQ] = ACTIONS(1069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1067),
    [anon_sym_GT_EQ] = ACTIONS(1067),
    [anon_sym_instanceof] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1067),
    [anon_sym_DASH_DASH] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1067),
    [sym__automatic_semicolon] = ACTIONS(4408),
  },
  [1445] = {
    [anon_sym_STAR] = ACTIONS(4007),
    [anon_sym_as] = ACTIONS(4009),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_RBRACE] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4009),
    [anon_sym_in] = ACTIONS(4007),
    [anon_sym_SEMI] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4007),
    [anon_sym_GT] = ACTIONS(4007),
    [anon_sym_SLASH] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(4009),
    [anon_sym_AMP_AMP] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4007),
    [anon_sym_GT_GT_GT] = ACTIONS(4009),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_PIPE] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_STAR_STAR] = ACTIONS(4009),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_EQ_EQ] = ACTIONS(4007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4009),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4009),
    [anon_sym_instanceof] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_PLUS_PLUS] = ACTIONS(4009),
    [anon_sym_DASH_DASH] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4009),
    [sym__automatic_semicolon] = ACTIONS(4009),
  },
  [1446] = {
    [sym_string] = STATE(2047),
    [sym__property_name] = STATE(2047),
    [sym_computed_property_name] = STATE(2047),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4419),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4558),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4560),
    [anon_sym_set] = ACTIONS(4560),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1447] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1073),
  },
  [1448] = {
    [sym_string] = STATE(1809),
    [sym__property_name] = STATE(1809),
    [sym_computed_property_name] = STATE(1809),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4419),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4421),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4423),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4427),
    [anon_sym_set] = ACTIONS(4427),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4562),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1449] = {
    [sym_string] = STATE(1819),
    [sym__property_name] = STATE(1819),
    [sym_computed_property_name] = STATE(1819),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4564),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4566),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4568),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4570),
    [anon_sym_set] = ACTIONS(4570),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1450] = {
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_abstract] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1451] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4572),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [1452] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4574),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [1453] = {
    [sym_string] = STATE(1819),
    [sym__property_name] = STATE(1819),
    [sym_computed_property_name] = STATE(1819),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4564),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4566),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4568),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4570),
    [anon_sym_set] = ACTIONS(4570),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4576),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1454] = {
    [sym_string] = STATE(2046),
    [sym__property_name] = STATE(2046),
    [sym_computed_property_name] = STATE(2046),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4578),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4580),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4582),
    [anon_sym_set] = ACTIONS(4582),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1455] = {
    [sym_string] = STATE(1814),
    [sym__property_name] = STATE(1814),
    [sym_computed_property_name] = STATE(1814),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4578),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4586),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4588),
    [anon_sym_set] = ACTIONS(4588),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1456] = {
    [anon_sym_STAR] = ACTIONS(2476),
    [anon_sym_as] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2476),
    [anon_sym_SEMI] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_GT] = ACTIONS(2476),
    [anon_sym_SLASH] = ACTIONS(2476),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_GT_GT] = ACTIONS(2476),
    [anon_sym_GT_GT_GT] = ACTIONS(2474),
    [anon_sym_LT_LT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_CARET] = ACTIONS(2474),
    [anon_sym_PIPE] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_LT_EQ] = ACTIONS(2474),
    [anon_sym_EQ_EQ] = ACTIONS(2476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2474),
    [anon_sym_GT_EQ] = ACTIONS(2474),
    [anon_sym_instanceof] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2474),
    [anon_sym_DASH_DASH] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2474),
    [sym__automatic_semicolon] = ACTIONS(2474),
  },
  [1457] = {
    [sym_string] = STATE(2003),
    [sym__property_name] = STATE(2003),
    [sym_computed_property_name] = STATE(2003),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4564),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4590),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4592),
    [anon_sym_set] = ACTIONS(4592),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1458] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(4594),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1459] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_RBRACK] = ACTIONS(4596),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1460] = {
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_SEMI] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [sym__automatic_semicolon] = ACTIONS(1195),
  },
  [1461] = {
    [anon_sym_STAR] = ACTIONS(1103),
    [anon_sym_as] = ACTIONS(1105),
    [anon_sym_COMMA] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1103),
    [anon_sym_SEMI] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [anon_sym_GT_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_CARET] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1105),
    [anon_sym_GT_EQ] = ACTIONS(1105),
    [anon_sym_instanceof] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_PLUS_PLUS] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(1105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [sym__automatic_semicolon] = ACTIONS(1105),
  },
  [1462] = {
    [anon_sym_STAR] = ACTIONS(4281),
    [anon_sym_as] = ACTIONS(4281),
    [anon_sym_LBRACE] = ACTIONS(4281),
    [anon_sym_COMMA] = ACTIONS(4283),
    [anon_sym_LPAREN] = ACTIONS(4283),
    [anon_sym_in] = ACTIONS(4281),
    [anon_sym_LBRACK] = ACTIONS(4283),
    [anon_sym_LT] = ACTIONS(4281),
    [anon_sym_GT] = ACTIONS(4281),
    [anon_sym_SLASH] = ACTIONS(4281),
    [anon_sym_DOT] = ACTIONS(4283),
    [anon_sym_QMARK] = ACTIONS(4283),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_PIPE_PIPE] = ACTIONS(4283),
    [anon_sym_GT_GT] = ACTIONS(4281),
    [anon_sym_GT_GT_GT] = ACTIONS(4283),
    [anon_sym_LT_LT] = ACTIONS(4283),
    [anon_sym_AMP] = ACTIONS(4281),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_PIPE] = ACTIONS(4281),
    [anon_sym_PLUS] = ACTIONS(4281),
    [anon_sym_DASH] = ACTIONS(4281),
    [anon_sym_PERCENT] = ACTIONS(4283),
    [anon_sym_STAR_STAR] = ACTIONS(4283),
    [anon_sym_LT_EQ] = ACTIONS(4283),
    [anon_sym_EQ_EQ] = ACTIONS(4281),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4283),
    [anon_sym_BANG_EQ] = ACTIONS(4281),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4283),
    [anon_sym_GT_EQ] = ACTIONS(4283),
    [anon_sym_instanceof] = ACTIONS(4281),
    [anon_sym_BANG] = ACTIONS(4281),
    [anon_sym_PLUS_PLUS] = ACTIONS(4283),
    [anon_sym_DASH_DASH] = ACTIONS(4283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4283),
    [sym_regex_flags] = ACTIONS(4598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4283),
  },
  [1463] = {
    [sym_string] = STATE(2061),
    [sym__property_name] = STATE(2061),
    [sym_computed_property_name] = STATE(2061),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4600),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4602),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4604),
    [anon_sym_set] = ACTIONS(4604),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1464] = {
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_as] = ACTIONS(2580),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_GT_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2582),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_BANG_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2580),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_instanceof] = ACTIONS(2580),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2580),
    [sym__automatic_semicolon] = ACTIONS(2580),
  },
  [1465] = {
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_as] = ACTIONS(2458),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_in] = ACTIONS(2460),
    [anon_sym_SEMI] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_GT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_DOT] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2458),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_CARET] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_PERCENT] = ACTIONS(2458),
    [anon_sym_STAR_STAR] = ACTIONS(2458),
    [anon_sym_LT_EQ] = ACTIONS(2458),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2458),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2458),
    [anon_sym_GT_EQ] = ACTIONS(2458),
    [anon_sym_instanceof] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2458),
    [anon_sym_DASH_DASH] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2458),
    [sym__automatic_semicolon] = ACTIONS(2458),
  },
  [1466] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(4610),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1467] = {
    [sym_string] = STATE(1820),
    [sym__property_name] = STATE(1820),
    [sym_computed_property_name] = STATE(1820),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4612),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4614),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4616),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4618),
    [anon_sym_set] = ACTIONS(4618),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1468] = {
    [sym_string] = STATE(2057),
    [sym__property_name] = STATE(2057),
    [sym_computed_property_name] = STATE(2057),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4622),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4624),
    [anon_sym_set] = ACTIONS(4624),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1469] = {
    [anon_sym_STAR] = ACTIONS(3894),
    [anon_sym_as] = ACTIONS(3788),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3894),
    [anon_sym_SEMI] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3894),
    [anon_sym_GT] = ACTIONS(3894),
    [anon_sym_SLASH] = ACTIONS(3894),
    [anon_sym_DOT] = ACTIONS(3788),
    [anon_sym_QMARK] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_GT_GT] = ACTIONS(3894),
    [anon_sym_GT_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_LT] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_CARET] = ACTIONS(3788),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_PLUS] = ACTIONS(3894),
    [anon_sym_DASH] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(3788),
    [anon_sym_STAR_STAR] = ACTIONS(3788),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_EQ_EQ] = ACTIONS(3894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3788),
    [anon_sym_BANG_EQ] = ACTIONS(3894),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3788),
    [anon_sym_instanceof] = ACTIONS(3788),
    [anon_sym_BANG] = ACTIONS(3894),
    [anon_sym_PLUS_PLUS] = ACTIONS(3788),
    [anon_sym_DASH_DASH] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [sym__automatic_semicolon] = ACTIONS(3788),
  },
  [1470] = {
    [anon_sym_STAR] = ACTIONS(1213),
    [anon_sym_as] = ACTIONS(1215),
    [anon_sym_COMMA] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1213),
    [anon_sym_SEMI] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1215),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_GT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_QMARK] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1215),
    [anon_sym_PIPE_PIPE] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1213),
    [anon_sym_GT_GT_GT] = ACTIONS(1215),
    [anon_sym_LT_LT] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1213),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_PIPE] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_PERCENT] = ACTIONS(1215),
    [anon_sym_STAR_STAR] = ACTIONS(1215),
    [anon_sym_LT_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1215),
    [anon_sym_instanceof] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [sym__automatic_semicolon] = ACTIONS(1215),
  },
  [1471] = {
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_as] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_GT] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_DOT] = ACTIONS(2402),
    [anon_sym_QMARK] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_PIPE_PIPE] = ACTIONS(2402),
    [anon_sym_GT_GT] = ACTIONS(2404),
    [anon_sym_GT_GT_GT] = ACTIONS(2402),
    [anon_sym_LT_LT] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_CARET] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PERCENT] = ACTIONS(2402),
    [anon_sym_STAR_STAR] = ACTIONS(2402),
    [anon_sym_LT_EQ] = ACTIONS(2402),
    [anon_sym_EQ_EQ] = ACTIONS(2404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2402),
    [anon_sym_BANG_EQ] = ACTIONS(2404),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2402),
    [anon_sym_GT_EQ] = ACTIONS(2402),
    [anon_sym_instanceof] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [sym__automatic_semicolon] = ACTIONS(2402),
  },
  [1472] = {
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_as] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3917),
    [anon_sym_RBRACE] = ACTIONS(3917),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_in] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3915),
    [anon_sym_SLASH] = ACTIONS(3915),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_GT_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3915),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3915),
    [anon_sym_PLUS] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3915),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_STAR_STAR] = ACTIONS(3917),
    [anon_sym_LT_EQ] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3915),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3917),
    [anon_sym_GT_EQ] = ACTIONS(3917),
    [anon_sym_instanceof] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3915),
    [anon_sym_PLUS_PLUS] = ACTIONS(3917),
    [anon_sym_DASH_DASH] = ACTIONS(3917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [sym__automatic_semicolon] = ACTIONS(3917),
  },
  [1473] = {
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2420),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_GT_GT_GT] = ACTIONS(2420),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_STAR_STAR] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2420),
    [anon_sym_EQ_EQ] = ACTIONS(2422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2420),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_instanceof] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [sym__automatic_semicolon] = ACTIONS(2420),
  },
  [1474] = {
    [anon_sym_STAR] = ACTIONS(2480),
    [anon_sym_as] = ACTIONS(2478),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(2480),
    [anon_sym_GT] = ACTIONS(2480),
    [anon_sym_SLASH] = ACTIONS(2480),
    [anon_sym_DOT] = ACTIONS(2478),
    [anon_sym_QMARK] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2480),
    [anon_sym_GT_GT_GT] = ACTIONS(2478),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_CARET] = ACTIONS(2478),
    [anon_sym_PIPE] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_STAR_STAR] = ACTIONS(2478),
    [anon_sym_LT_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ] = ACTIONS(2480),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2478),
    [anon_sym_GT_EQ] = ACTIONS(2478),
    [anon_sym_instanceof] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2478),
    [sym__automatic_semicolon] = ACTIONS(2478),
  },
  [1475] = {
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_as] = ACTIONS(1157),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RBRACE] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_in] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_QMARK] = ACTIONS(1157),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(1157),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_instanceof] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1157),
    [sym__automatic_semicolon] = ACTIONS(1157),
  },
  [1476] = {
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_as] = ACTIONS(2338),
    [anon_sym_COMMA] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_in] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_GT] = ACTIONS(2340),
    [anon_sym_SLASH] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(3956),
    [anon_sym_QMARK] = ACTIONS(2338),
    [anon_sym_AMP_AMP] = ACTIONS(2338),
    [anon_sym_PIPE_PIPE] = ACTIONS(2338),
    [anon_sym_GT_GT] = ACTIONS(2340),
    [anon_sym_GT_GT_GT] = ACTIONS(2338),
    [anon_sym_LT_LT] = ACTIONS(2338),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_PIPE] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2338),
    [anon_sym_STAR_STAR] = ACTIONS(2338),
    [anon_sym_LT_EQ] = ACTIONS(2338),
    [anon_sym_EQ_EQ] = ACTIONS(2340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2338),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2338),
    [anon_sym_GT_EQ] = ACTIONS(2338),
    [anon_sym_instanceof] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2338),
    [sym__automatic_semicolon] = ACTIONS(2338),
  },
  [1477] = {
    [anon_sym_STAR] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2598),
    [anon_sym_QMARK] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_GT_GT_GT] = ACTIONS(2598),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2598),
    [anon_sym_STAR_STAR] = ACTIONS(2598),
    [anon_sym_LT_EQ] = ACTIONS(2598),
    [anon_sym_EQ_EQ] = ACTIONS(2600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2598),
    [anon_sym_BANG_EQ] = ACTIONS(2600),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2598),
    [anon_sym_GT_EQ] = ACTIONS(2598),
    [anon_sym_instanceof] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [sym__automatic_semicolon] = ACTIONS(2598),
  },
  [1478] = {
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_as] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2592),
    [anon_sym_GT] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_GT_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_STAR_STAR] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2590),
    [anon_sym_instanceof] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [sym__automatic_semicolon] = ACTIONS(2590),
  },
  [1479] = {
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_as] = ACTIONS(2384),
    [anon_sym_COMMA] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_in] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_LT] = ACTIONS(2386),
    [anon_sym_GT] = ACTIONS(2386),
    [anon_sym_SLASH] = ACTIONS(2386),
    [anon_sym_DOT] = ACTIONS(2384),
    [anon_sym_QMARK] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_PIPE_PIPE] = ACTIONS(2384),
    [anon_sym_GT_GT] = ACTIONS(2386),
    [anon_sym_GT_GT_GT] = ACTIONS(2384),
    [anon_sym_LT_LT] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_CARET] = ACTIONS(2384),
    [anon_sym_PIPE] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_PERCENT] = ACTIONS(2384),
    [anon_sym_STAR_STAR] = ACTIONS(2384),
    [anon_sym_LT_EQ] = ACTIONS(2384),
    [anon_sym_EQ_EQ] = ACTIONS(2386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2384),
    [anon_sym_BANG_EQ] = ACTIONS(2386),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2384),
    [anon_sym_GT_EQ] = ACTIONS(2384),
    [anon_sym_instanceof] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2384),
    [sym__automatic_semicolon] = ACTIONS(2384),
  },
  [1480] = {
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_as] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_in] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_GT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2484),
    [anon_sym_DOT] = ACTIONS(2482),
    [anon_sym_QMARK] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(2482),
    [anon_sym_PIPE_PIPE] = ACTIONS(2482),
    [anon_sym_GT_GT] = ACTIONS(2484),
    [anon_sym_GT_GT_GT] = ACTIONS(2482),
    [anon_sym_LT_LT] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_CARET] = ACTIONS(2482),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_PERCENT] = ACTIONS(2482),
    [anon_sym_STAR_STAR] = ACTIONS(2482),
    [anon_sym_LT_EQ] = ACTIONS(2482),
    [anon_sym_EQ_EQ] = ACTIONS(2484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2482),
    [anon_sym_BANG_EQ] = ACTIONS(2484),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2482),
    [anon_sym_GT_EQ] = ACTIONS(2482),
    [anon_sym_instanceof] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2482),
    [anon_sym_DASH_DASH] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2482),
    [sym__automatic_semicolon] = ACTIONS(2482),
  },
  [1481] = {
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_as] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2470),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2472),
    [anon_sym_SEMI] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2472),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_GT_GT] = ACTIONS(2472),
    [anon_sym_GT_GT_GT] = ACTIONS(2470),
    [anon_sym_LT_LT] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_PIPE] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2472),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2470),
    [anon_sym_LT_EQ] = ACTIONS(2470),
    [anon_sym_EQ_EQ] = ACTIONS(2472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2470),
    [anon_sym_GT_EQ] = ACTIONS(2470),
    [anon_sym_instanceof] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2470),
    [sym__automatic_semicolon] = ACTIONS(2470),
  },
  [1482] = {
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_as] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_GT_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_STAR_STAR] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_instanceof] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [sym__automatic_semicolon] = ACTIONS(2462),
  },
  [1483] = {
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_as] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_in] = ACTIONS(1179),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1179),
    [anon_sym_GT] = ACTIONS(1179),
    [anon_sym_SLASH] = ACTIONS(1179),
    [anon_sym_DOT] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1179),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_PLUS] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [sym__automatic_semicolon] = ACTIONS(1181),
  },
  [1484] = {
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_as] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1083),
    [anon_sym_in] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_STAR_STAR] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1083),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [sym__automatic_semicolon] = ACTIONS(1083),
  },
  [1485] = {
    [anon_sym_STAR] = ACTIONS(3919),
    [anon_sym_as] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3921),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_SLASH] = ACTIONS(3919),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_GT_GT] = ACTIONS(3919),
    [anon_sym_GT_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_CARET] = ACTIONS(3921),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_PLUS] = ACTIONS(3919),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_STAR_STAR] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3919),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3921),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_instanceof] = ACTIONS(3921),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [sym__automatic_semicolon] = ACTIONS(3921),
  },
  [1486] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1487] = {
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_as] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_instanceof] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [sym__automatic_semicolon] = ACTIONS(1225),
  },
  [1488] = {
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_in] = ACTIONS(3927),
    [anon_sym_SEMI] = ACTIONS(3929),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [anon_sym_GT_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3929),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_STAR_STAR] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3927),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [sym__automatic_semicolon] = ACTIONS(3929),
  },
  [1489] = {
    [anon_sym_STAR] = ACTIONS(3939),
    [anon_sym_as] = ACTIONS(3941),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_in] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3939),
    [anon_sym_SLASH] = ACTIONS(3939),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_GT_GT_GT] = ACTIONS(3941),
    [anon_sym_LT_LT] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3939),
    [anon_sym_CARET] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3939),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_DASH] = ACTIONS(3939),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_STAR_STAR] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ_EQ] = ACTIONS(3939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3939),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_instanceof] = ACTIONS(3941),
    [anon_sym_BANG] = ACTIONS(3939),
    [anon_sym_PLUS_PLUS] = ACTIONS(3941),
    [anon_sym_DASH_DASH] = ACTIONS(3941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3941),
    [sym__automatic_semicolon] = ACTIONS(3941),
  },
  [1490] = {
    [sym_string] = STATE(2019),
    [sym__property_name] = STATE(2019),
    [sym_computed_property_name] = STATE(2019),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4626),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4628),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4630),
    [anon_sym_set] = ACTIONS(4630),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1491] = {
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3967),
    [anon_sym_GT_GT_GT] = ACTIONS(3969),
    [anon_sym_LT_LT] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3969),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_instanceof] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3967),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [sym__automatic_semicolon] = ACTIONS(3969),
  },
  [1492] = {
    [anon_sym_STAR] = ACTIONS(3963),
    [anon_sym_as] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3965),
    [anon_sym_RBRACE] = ACTIONS(3965),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_GT] = ACTIONS(3963),
    [anon_sym_SLASH] = ACTIONS(3963),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_GT_GT] = ACTIONS(3963),
    [anon_sym_GT_GT_GT] = ACTIONS(3965),
    [anon_sym_LT_LT] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_CARET] = ACTIONS(3965),
    [anon_sym_PIPE] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3965),
    [anon_sym_EQ_EQ] = ACTIONS(3963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3963),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3965),
    [anon_sym_GT_EQ] = ACTIONS(3965),
    [anon_sym_instanceof] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3963),
    [anon_sym_PLUS_PLUS] = ACTIONS(3965),
    [anon_sym_DASH_DASH] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3965),
    [sym__automatic_semicolon] = ACTIONS(3965),
  },
  [1493] = {
    [sym_string] = STATE(1813),
    [sym__property_name] = STATE(1813),
    [sym_computed_property_name] = STATE(1813),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4626),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4632),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4634),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4636),
    [anon_sym_set] = ACTIONS(4636),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1494] = {
    [anon_sym_STAR] = ACTIONS(3948),
    [anon_sym_as] = ACTIONS(3950),
    [anon_sym_COMMA] = ACTIONS(3950),
    [anon_sym_RBRACE] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_in] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3950),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_SLASH] = ACTIONS(3948),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_GT_GT] = ACTIONS(3948),
    [anon_sym_GT_GT_GT] = ACTIONS(3950),
    [anon_sym_LT_LT] = ACTIONS(3950),
    [anon_sym_AMP] = ACTIONS(3948),
    [anon_sym_CARET] = ACTIONS(3950),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_PLUS] = ACTIONS(3948),
    [anon_sym_DASH] = ACTIONS(3948),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_STAR_STAR] = ACTIONS(3950),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3948),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3948),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3948),
    [anon_sym_PLUS_PLUS] = ACTIONS(3950),
    [anon_sym_DASH_DASH] = ACTIONS(3950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3950),
    [sym__automatic_semicolon] = ACTIONS(3950),
  },
  [1495] = {
    [anon_sym_STAR] = ACTIONS(3909),
    [anon_sym_as] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3911),
    [anon_sym_RBRACE] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_in] = ACTIONS(3909),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_DOT] = ACTIONS(3911),
    [anon_sym_QMARK] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_STAR_STAR] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3909),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_instanceof] = ACTIONS(3911),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [sym__automatic_semicolon] = ACTIONS(3911),
  },
  [1496] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4521),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4524),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(4524),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(4524),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(4524),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1497] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4529),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4532),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(4532),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1498] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4513),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(3409),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(3409),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1499] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1500] = {
    [sym_string] = STATE(1812),
    [sym__property_name] = STATE(1812),
    [sym_computed_property_name] = STATE(1812),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4640),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4642),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4644),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4646),
    [anon_sym_set] = ACTIONS(4646),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1501] = {
    [sym_string] = STATE(1814),
    [sym__property_name] = STATE(1814),
    [sym_computed_property_name] = STATE(1814),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4578),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4584),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4586),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4588),
    [anon_sym_set] = ACTIONS(4588),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4648),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1502] = {
    [anon_sym_STAR] = ACTIONS(3584),
    [anon_sym_as] = ACTIONS(3588),
    [anon_sym_COMMA] = ACTIONS(3588),
    [anon_sym_RBRACE] = ACTIONS(3588),
    [anon_sym_LPAREN] = ACTIONS(3588),
    [anon_sym_in] = ACTIONS(3584),
    [anon_sym_SEMI] = ACTIONS(3588),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(3584),
    [anon_sym_GT] = ACTIONS(3584),
    [anon_sym_SLASH] = ACTIONS(3584),
    [anon_sym_DOT] = ACTIONS(3588),
    [anon_sym_QMARK] = ACTIONS(3588),
    [anon_sym_AMP_AMP] = ACTIONS(3588),
    [anon_sym_PIPE_PIPE] = ACTIONS(3588),
    [anon_sym_GT_GT] = ACTIONS(3584),
    [anon_sym_GT_GT_GT] = ACTIONS(3588),
    [anon_sym_LT_LT] = ACTIONS(3588),
    [anon_sym_AMP] = ACTIONS(3584),
    [anon_sym_CARET] = ACTIONS(3588),
    [anon_sym_PIPE] = ACTIONS(3584),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_DASH] = ACTIONS(3584),
    [anon_sym_PERCENT] = ACTIONS(3588),
    [anon_sym_STAR_STAR] = ACTIONS(3588),
    [anon_sym_LT_EQ] = ACTIONS(3588),
    [anon_sym_EQ_EQ] = ACTIONS(3584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3588),
    [anon_sym_BANG_EQ] = ACTIONS(3584),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3588),
    [anon_sym_GT_EQ] = ACTIONS(3588),
    [anon_sym_instanceof] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3584),
    [anon_sym_PLUS_PLUS] = ACTIONS(3588),
    [anon_sym_DASH_DASH] = ACTIONS(3588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3588),
    [sym__automatic_semicolon] = ACTIONS(3588),
  },
  [1503] = {
    [anon_sym_STAR] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_RPAREN] = ACTIONS(3774),
    [anon_sym_in] = ACTIONS(3772),
    [anon_sym_COLON] = ACTIONS(3774),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_GT] = ACTIONS(3772),
    [anon_sym_SLASH] = ACTIONS(3772),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_EQ_GT] = ACTIONS(3776),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_GT_GT] = ACTIONS(3772),
    [anon_sym_GT_GT_GT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3772),
    [anon_sym_CARET] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3774),
    [anon_sym_EQ_EQ] = ACTIONS(3772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3772),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3774),
    [anon_sym_GT_EQ] = ACTIONS(3774),
    [anon_sym_instanceof] = ACTIONS(3774),
    [anon_sym_BANG] = ACTIONS(3772),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3774),
  },
  [1504] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4650),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1505] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4652),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1506] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(4657),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(4659),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(4654),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1507] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(4662),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1508] = {
    [sym_string] = STATE(2008),
    [sym__property_name] = STATE(2008),
    [sym_computed_property_name] = STATE(2008),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4640),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4664),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4666),
    [anon_sym_set] = ACTIONS(4666),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1509] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_COLON] = ACTIONS(4668),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1510] = {
    [sym_string] = STATE(2072),
    [sym__property_name] = STATE(2072),
    [sym_computed_property_name] = STATE(2072),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4612),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4670),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4672),
    [anon_sym_set] = ACTIONS(4672),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1511] = {
    [sym_string] = STATE(2073),
    [sym__property_name] = STATE(2073),
    [sym_computed_property_name] = STATE(2073),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4539),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4674),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4676),
    [anon_sym_set] = ACTIONS(4676),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1512] = {
    [sym_string] = STATE(2079),
    [sym__property_name] = STATE(2079),
    [sym_computed_property_name] = STATE(2079),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4678),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4680),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4682),
    [anon_sym_set] = ACTIONS(4682),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1513] = {
    [sym_string] = STATE(1820),
    [sym__property_name] = STATE(1820),
    [sym_computed_property_name] = STATE(1820),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4612),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4614),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4616),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4618),
    [anon_sym_set] = ACTIONS(4618),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4684),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1514] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4686),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [1515] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4688),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_implements] = ACTIONS(1123),
  },
  [1516] = {
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_as] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_in] = ACTIONS(2448),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(2448),
    [anon_sym_DOT] = ACTIONS(2446),
    [anon_sym_QMARK] = ACTIONS(2446),
    [anon_sym_AMP_AMP] = ACTIONS(2446),
    [anon_sym_PIPE_PIPE] = ACTIONS(2446),
    [anon_sym_GT_GT] = ACTIONS(2448),
    [anon_sym_GT_GT_GT] = ACTIONS(2446),
    [anon_sym_LT_LT] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PERCENT] = ACTIONS(2446),
    [anon_sym_STAR_STAR] = ACTIONS(2446),
    [anon_sym_LT_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2446),
    [anon_sym_GT_EQ] = ACTIONS(2446),
    [anon_sym_instanceof] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [sym__automatic_semicolon] = ACTIONS(2446),
  },
  [1517] = {
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_as] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_DOT] = ACTIONS(2412),
    [anon_sym_QMARK] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_GT_GT] = ACTIONS(2414),
    [anon_sym_GT_GT_GT] = ACTIONS(2412),
    [anon_sym_LT_LT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_CARET] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2412),
    [anon_sym_STAR_STAR] = ACTIONS(2412),
    [anon_sym_LT_EQ] = ACTIONS(2412),
    [anon_sym_EQ_EQ] = ACTIONS(2414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2412),
    [anon_sym_BANG_EQ] = ACTIONS(2414),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2412),
    [anon_sym_GT_EQ] = ACTIONS(2412),
    [anon_sym_instanceof] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [sym__automatic_semicolon] = ACTIONS(2412),
  },
  [1518] = {
    [anon_sym_STAR] = ACTIONS(2604),
    [anon_sym_as] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_DOT] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_GT_GT_GT] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(2602),
    [anon_sym_STAR_STAR] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2602),
    [anon_sym_instanceof] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [sym__automatic_semicolon] = ACTIONS(2602),
  },
  [1519] = {
    [anon_sym_STAR] = ACTIONS(2382),
    [anon_sym_as] = ACTIONS(2380),
    [anon_sym_COMMA] = ACTIONS(2380),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2380),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_GT] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(2382),
    [anon_sym_DOT] = ACTIONS(2380),
    [anon_sym_QMARK] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_PIPE_PIPE] = ACTIONS(2380),
    [anon_sym_GT_GT] = ACTIONS(2382),
    [anon_sym_GT_GT_GT] = ACTIONS(2380),
    [anon_sym_LT_LT] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_CARET] = ACTIONS(2380),
    [anon_sym_PIPE] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_PERCENT] = ACTIONS(2380),
    [anon_sym_STAR_STAR] = ACTIONS(2380),
    [anon_sym_LT_EQ] = ACTIONS(2380),
    [anon_sym_EQ_EQ] = ACTIONS(2382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2380),
    [anon_sym_BANG_EQ] = ACTIONS(2382),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2380),
    [anon_sym_instanceof] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2380),
    [sym__automatic_semicolon] = ACTIONS(2380),
  },
  [1520] = {
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [sym__automatic_semicolon] = ACTIONS(2428),
  },
  [1521] = {
    [anon_sym_STAR] = ACTIONS(2564),
    [anon_sym_as] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_GT] = ACTIONS(2564),
    [anon_sym_SLASH] = ACTIONS(2564),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_GT_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(4606),
    [anon_sym_CARET] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_DASH] = ACTIONS(2564),
    [anon_sym_PERCENT] = ACTIONS(2562),
    [anon_sym_STAR_STAR] = ACTIONS(2562),
    [anon_sym_LT_EQ] = ACTIONS(2562),
    [anon_sym_EQ_EQ] = ACTIONS(2564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2562),
    [anon_sym_BANG_EQ] = ACTIONS(2564),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2562),
    [anon_sym_GT_EQ] = ACTIONS(2562),
    [anon_sym_instanceof] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2564),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [sym__automatic_semicolon] = ACTIONS(2562),
  },
  [1522] = {
    [sym_string] = STATE(2025),
    [sym__property_name] = STATE(2025),
    [sym_computed_property_name] = STATE(2025),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4547),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1523] = {
    [anon_sym_STAR] = ACTIONS(3584),
    [anon_sym_as] = ACTIONS(3588),
    [anon_sym_LBRACE] = ACTIONS(3584),
    [anon_sym_COMMA] = ACTIONS(3588),
    [anon_sym_LPAREN] = ACTIONS(3588),
    [anon_sym_in] = ACTIONS(3584),
    [anon_sym_LBRACK] = ACTIONS(3588),
    [anon_sym_LT] = ACTIONS(3584),
    [anon_sym_GT] = ACTIONS(3584),
    [anon_sym_SLASH] = ACTIONS(3584),
    [anon_sym_DOT] = ACTIONS(3588),
    [anon_sym_QMARK] = ACTIONS(3588),
    [anon_sym_AMP_AMP] = ACTIONS(3588),
    [anon_sym_PIPE_PIPE] = ACTIONS(3588),
    [anon_sym_GT_GT] = ACTIONS(3584),
    [anon_sym_GT_GT_GT] = ACTIONS(3588),
    [anon_sym_LT_LT] = ACTIONS(3588),
    [anon_sym_AMP] = ACTIONS(3584),
    [anon_sym_CARET] = ACTIONS(3588),
    [anon_sym_PIPE] = ACTIONS(3584),
    [anon_sym_PLUS] = ACTIONS(3584),
    [anon_sym_DASH] = ACTIONS(3584),
    [anon_sym_PERCENT] = ACTIONS(3588),
    [anon_sym_STAR_STAR] = ACTIONS(3588),
    [anon_sym_LT_EQ] = ACTIONS(3588),
    [anon_sym_EQ_EQ] = ACTIONS(3584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3588),
    [anon_sym_BANG_EQ] = ACTIONS(3584),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3588),
    [anon_sym_GT_EQ] = ACTIONS(3588),
    [anon_sym_instanceof] = ACTIONS(3588),
    [anon_sym_BANG] = ACTIONS(3584),
    [anon_sym_PLUS_PLUS] = ACTIONS(3588),
    [anon_sym_DASH_DASH] = ACTIONS(3588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3588),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3588),
  },
  [1524] = {
    [sym_string] = STATE(2003),
    [sym__property_name] = STATE(2003),
    [sym_computed_property_name] = STATE(2003),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4590),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1525] = {
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_as] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_in] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(2452),
    [anon_sym_GT] = ACTIONS(2452),
    [anon_sym_SLASH] = ACTIONS(2452),
    [anon_sym_DOT] = ACTIONS(2450),
    [anon_sym_QMARK] = ACTIONS(2450),
    [anon_sym_AMP_AMP] = ACTIONS(2450),
    [anon_sym_PIPE_PIPE] = ACTIONS(2450),
    [anon_sym_GT_GT] = ACTIONS(2452),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2452),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_STAR_STAR] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2450),
    [anon_sym_EQ_EQ] = ACTIONS(2452),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2450),
    [anon_sym_BANG_EQ] = ACTIONS(2452),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2450),
    [anon_sym_GT_EQ] = ACTIONS(2450),
    [anon_sym_instanceof] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2450),
    [anon_sym_DASH_DASH] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2450),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2450),
  },
  [1526] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1527] = {
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1528] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1529] = {
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_LBRACE] = ACTIONS(4075),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
    [anon_sym_LBRACK] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4075),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4077),
  },
  [1530] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
  },
  [1531] = {
    [anon_sym_STAR] = ACTIONS(4075),
    [anon_sym_as] = ACTIONS(4077),
    [anon_sym_LBRACE] = ACTIONS(4075),
    [anon_sym_COMMA] = ACTIONS(4077),
    [anon_sym_LPAREN] = ACTIONS(4077),
    [anon_sym_in] = ACTIONS(4075),
    [anon_sym_LBRACK] = ACTIONS(4077),
    [anon_sym_LT] = ACTIONS(4075),
    [anon_sym_GT] = ACTIONS(4075),
    [anon_sym_SLASH] = ACTIONS(4075),
    [anon_sym_DOT] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4077),
    [anon_sym_AMP_AMP] = ACTIONS(4077),
    [anon_sym_PIPE_PIPE] = ACTIONS(4077),
    [anon_sym_GT_GT] = ACTIONS(4075),
    [anon_sym_GT_GT_GT] = ACTIONS(4077),
    [anon_sym_LT_LT] = ACTIONS(4077),
    [anon_sym_AMP] = ACTIONS(4075),
    [anon_sym_CARET] = ACTIONS(4077),
    [anon_sym_PIPE] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(4075),
    [anon_sym_DASH] = ACTIONS(4075),
    [anon_sym_PERCENT] = ACTIONS(4077),
    [anon_sym_STAR_STAR] = ACTIONS(4077),
    [anon_sym_LT_EQ] = ACTIONS(4077),
    [anon_sym_EQ_EQ] = ACTIONS(4075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4077),
    [anon_sym_BANG_EQ] = ACTIONS(4075),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4077),
    [anon_sym_GT_EQ] = ACTIONS(4077),
    [anon_sym_instanceof] = ACTIONS(4077),
    [anon_sym_BANG] = ACTIONS(4075),
    [anon_sym_PLUS_PLUS] = ACTIONS(4077),
    [anon_sym_DASH_DASH] = ACTIONS(4077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4077),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4077),
  },
  [1532] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1533] = {
    [sym_string] = STATE(2019),
    [sym__property_name] = STATE(2019),
    [sym_computed_property_name] = STATE(2019),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4628),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1534] = {
    [sym_string] = STATE(1913),
    [sym__property_name] = STATE(1913),
    [sym_computed_property_name] = STATE(1913),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4692),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(3503),
    [anon_sym_set] = ACTIONS(3503),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1535] = {
    [anon_sym_STAR] = ACTIONS(2604),
    [anon_sym_as] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_LT] = ACTIONS(2604),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_SLASH] = ACTIONS(2604),
    [anon_sym_DOT] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2604),
    [anon_sym_GT_GT_GT] = ACTIONS(2602),
    [anon_sym_LT_LT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(4694),
    [anon_sym_CARET] = ACTIONS(2602),
    [anon_sym_PIPE] = ACTIONS(4696),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(2602),
    [anon_sym_STAR_STAR] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2602),
    [anon_sym_EQ_EQ] = ACTIONS(2604),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2604),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2602),
    [anon_sym_instanceof] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2604),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2602),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2602),
  },
  [1536] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1537] = {
    [anon_sym_STAR] = ACTIONS(3909),
    [anon_sym_as] = ACTIONS(3911),
    [anon_sym_LBRACE] = ACTIONS(3909),
    [anon_sym_COMMA] = ACTIONS(3911),
    [anon_sym_LPAREN] = ACTIONS(3911),
    [anon_sym_in] = ACTIONS(3909),
    [anon_sym_LBRACK] = ACTIONS(3911),
    [anon_sym_LT] = ACTIONS(3909),
    [anon_sym_GT] = ACTIONS(3909),
    [anon_sym_SLASH] = ACTIONS(3909),
    [anon_sym_DOT] = ACTIONS(3911),
    [anon_sym_QMARK] = ACTIONS(3911),
    [anon_sym_AMP_AMP] = ACTIONS(3911),
    [anon_sym_PIPE_PIPE] = ACTIONS(3911),
    [anon_sym_GT_GT] = ACTIONS(3909),
    [anon_sym_GT_GT_GT] = ACTIONS(3911),
    [anon_sym_LT_LT] = ACTIONS(3911),
    [anon_sym_AMP] = ACTIONS(3909),
    [anon_sym_CARET] = ACTIONS(3911),
    [anon_sym_PIPE] = ACTIONS(3909),
    [anon_sym_PLUS] = ACTIONS(3909),
    [anon_sym_DASH] = ACTIONS(3909),
    [anon_sym_PERCENT] = ACTIONS(3911),
    [anon_sym_STAR_STAR] = ACTIONS(3911),
    [anon_sym_LT_EQ] = ACTIONS(3911),
    [anon_sym_EQ_EQ] = ACTIONS(3909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3911),
    [anon_sym_BANG_EQ] = ACTIONS(3909),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3911),
    [anon_sym_GT_EQ] = ACTIONS(3911),
    [anon_sym_instanceof] = ACTIONS(3911),
    [anon_sym_BANG] = ACTIONS(3909),
    [anon_sym_PLUS_PLUS] = ACTIONS(3911),
    [anon_sym_DASH_DASH] = ACTIONS(3911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3911),
  },
  [1538] = {
    [anon_sym_STAR] = ACTIONS(4071),
    [anon_sym_as] = ACTIONS(4073),
    [anon_sym_LBRACE] = ACTIONS(4071),
    [anon_sym_COMMA] = ACTIONS(4073),
    [anon_sym_LPAREN] = ACTIONS(4073),
    [anon_sym_in] = ACTIONS(4071),
    [anon_sym_LBRACK] = ACTIONS(4073),
    [anon_sym_LT] = ACTIONS(4071),
    [anon_sym_GT] = ACTIONS(4071),
    [anon_sym_SLASH] = ACTIONS(4071),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(4073),
    [anon_sym_AMP_AMP] = ACTIONS(4073),
    [anon_sym_PIPE_PIPE] = ACTIONS(4073),
    [anon_sym_GT_GT] = ACTIONS(4071),
    [anon_sym_GT_GT_GT] = ACTIONS(4073),
    [anon_sym_LT_LT] = ACTIONS(4073),
    [anon_sym_AMP] = ACTIONS(4071),
    [anon_sym_CARET] = ACTIONS(4073),
    [anon_sym_PIPE] = ACTIONS(4071),
    [anon_sym_PLUS] = ACTIONS(4071),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_PERCENT] = ACTIONS(4073),
    [anon_sym_STAR_STAR] = ACTIONS(4073),
    [anon_sym_LT_EQ] = ACTIONS(4073),
    [anon_sym_EQ_EQ] = ACTIONS(4071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4073),
    [anon_sym_BANG_EQ] = ACTIONS(4071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4073),
    [anon_sym_GT_EQ] = ACTIONS(4073),
    [anon_sym_instanceof] = ACTIONS(4073),
    [anon_sym_BANG] = ACTIONS(4071),
    [anon_sym_PLUS_PLUS] = ACTIONS(4073),
    [anon_sym_DASH_DASH] = ACTIONS(4073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4073),
  },
  [1539] = {
    [anon_sym_STAR] = ACTIONS(3963),
    [anon_sym_as] = ACTIONS(3965),
    [anon_sym_LBRACE] = ACTIONS(3963),
    [anon_sym_COMMA] = ACTIONS(3965),
    [anon_sym_LPAREN] = ACTIONS(3965),
    [anon_sym_in] = ACTIONS(3963),
    [anon_sym_LBRACK] = ACTIONS(3965),
    [anon_sym_LT] = ACTIONS(3963),
    [anon_sym_GT] = ACTIONS(3963),
    [anon_sym_SLASH] = ACTIONS(3963),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_AMP_AMP] = ACTIONS(3965),
    [anon_sym_PIPE_PIPE] = ACTIONS(3965),
    [anon_sym_GT_GT] = ACTIONS(3963),
    [anon_sym_GT_GT_GT] = ACTIONS(3965),
    [anon_sym_LT_LT] = ACTIONS(3965),
    [anon_sym_AMP] = ACTIONS(3963),
    [anon_sym_CARET] = ACTIONS(3965),
    [anon_sym_PIPE] = ACTIONS(3963),
    [anon_sym_PLUS] = ACTIONS(3963),
    [anon_sym_DASH] = ACTIONS(3963),
    [anon_sym_PERCENT] = ACTIONS(3965),
    [anon_sym_STAR_STAR] = ACTIONS(3965),
    [anon_sym_LT_EQ] = ACTIONS(3965),
    [anon_sym_EQ_EQ] = ACTIONS(3963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3965),
    [anon_sym_BANG_EQ] = ACTIONS(3963),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3965),
    [anon_sym_GT_EQ] = ACTIONS(3965),
    [anon_sym_instanceof] = ACTIONS(3965),
    [anon_sym_BANG] = ACTIONS(3963),
    [anon_sym_PLUS_PLUS] = ACTIONS(3965),
    [anon_sym_DASH_DASH] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3965),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3965),
  },
  [1540] = {
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_as] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1223),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_in] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1223),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1225),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_AMP_AMP] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_GT_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1223),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1223),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_instanceof] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_DASH_DASH] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1225),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1225),
  },
  [1541] = {
    [sym_string] = STATE(2008),
    [sym__property_name] = STATE(2008),
    [sym_computed_property_name] = STATE(2008),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4664),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1542] = {
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_as] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(4698),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2416),
  },
  [1543] = {
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_as] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_in] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2434),
    [anon_sym_DOT] = ACTIONS(2432),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_AMP_AMP] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(2432),
    [anon_sym_GT_GT] = ACTIONS(2434),
    [anon_sym_GT_GT_GT] = ACTIONS(2432),
    [anon_sym_LT_LT] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_CARET] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_PERCENT] = ACTIONS(2432),
    [anon_sym_STAR_STAR] = ACTIONS(2432),
    [anon_sym_LT_EQ] = ACTIONS(2432),
    [anon_sym_EQ_EQ] = ACTIONS(2434),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2432),
    [anon_sym_BANG_EQ] = ACTIONS(2434),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2432),
    [anon_sym_GT_EQ] = ACTIONS(2432),
    [anon_sym_instanceof] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2432),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2432),
  },
  [1544] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1545] = {
    [anon_sym_STAR] = ACTIONS(4069),
    [anon_sym_as] = ACTIONS(3728),
    [anon_sym_LBRACE] = ACTIONS(4069),
    [anon_sym_COMMA] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3728),
    [anon_sym_in] = ACTIONS(4069),
    [anon_sym_LBRACK] = ACTIONS(3728),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_SLASH] = ACTIONS(4069),
    [anon_sym_DOT] = ACTIONS(3728),
    [anon_sym_QMARK] = ACTIONS(3728),
    [anon_sym_AMP_AMP] = ACTIONS(3728),
    [anon_sym_PIPE_PIPE] = ACTIONS(3728),
    [anon_sym_GT_GT] = ACTIONS(4069),
    [anon_sym_GT_GT_GT] = ACTIONS(3728),
    [anon_sym_LT_LT] = ACTIONS(3728),
    [anon_sym_AMP] = ACTIONS(4069),
    [anon_sym_CARET] = ACTIONS(3728),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_PERCENT] = ACTIONS(3728),
    [anon_sym_STAR_STAR] = ACTIONS(3728),
    [anon_sym_LT_EQ] = ACTIONS(3728),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3728),
    [anon_sym_BANG_EQ] = ACTIONS(4069),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3728),
    [anon_sym_GT_EQ] = ACTIONS(3728),
    [anon_sym_instanceof] = ACTIONS(3728),
    [anon_sym_BANG] = ACTIONS(4069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3728),
    [anon_sym_DASH_DASH] = ACTIONS(3728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3728),
  },
  [1546] = {
    [anon_sym_STAR] = ACTIONS(4065),
    [anon_sym_as] = ACTIONS(4067),
    [anon_sym_LBRACE] = ACTIONS(4065),
    [anon_sym_COMMA] = ACTIONS(4067),
    [anon_sym_LPAREN] = ACTIONS(4067),
    [anon_sym_in] = ACTIONS(4065),
    [anon_sym_LBRACK] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4065),
    [anon_sym_GT] = ACTIONS(4065),
    [anon_sym_SLASH] = ACTIONS(4065),
    [anon_sym_DOT] = ACTIONS(4067),
    [anon_sym_QMARK] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_GT_GT] = ACTIONS(4065),
    [anon_sym_GT_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4065),
    [anon_sym_CARET] = ACTIONS(4067),
    [anon_sym_PIPE] = ACTIONS(4065),
    [anon_sym_PLUS] = ACTIONS(4065),
    [anon_sym_DASH] = ACTIONS(4065),
    [anon_sym_PERCENT] = ACTIONS(4067),
    [anon_sym_STAR_STAR] = ACTIONS(4067),
    [anon_sym_LT_EQ] = ACTIONS(4067),
    [anon_sym_EQ_EQ] = ACTIONS(4065),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4067),
    [anon_sym_BANG_EQ] = ACTIONS(4065),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4067),
    [anon_sym_GT_EQ] = ACTIONS(4067),
    [anon_sym_instanceof] = ACTIONS(4067),
    [anon_sym_BANG] = ACTIONS(4065),
    [anon_sym_PLUS_PLUS] = ACTIONS(4067),
    [anon_sym_DASH_DASH] = ACTIONS(4067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4067),
  },
  [1547] = {
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_as] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1083),
    [anon_sym_in] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1083),
    [anon_sym_LT] = ACTIONS(1081),
    [anon_sym_GT] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(1083),
    [anon_sym_QMARK] = ACTIONS(1083),
    [anon_sym_AMP_AMP] = ACTIONS(1083),
    [anon_sym_PIPE_PIPE] = ACTIONS(1083),
    [anon_sym_GT_GT] = ACTIONS(1081),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_STAR_STAR] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1083),
    [anon_sym_GT_EQ] = ACTIONS(1083),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1083),
    [anon_sym_DASH_DASH] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1083),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1083),
  },
  [1548] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_LBRACK] = ACTIONS(3622),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1549] = {
    [sym_string] = STATE(2072),
    [sym__property_name] = STATE(2072),
    [sym_computed_property_name] = STATE(2072),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4670),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1550] = {
    [anon_sym_STAR] = ACTIONS(1129),
    [anon_sym_as] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1129),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_in] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_SLASH] = ACTIONS(1129),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_PLUS] = ACTIONS(1129),
    [anon_sym_DASH] = ACTIONS(1129),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_STAR_STAR] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1131),
    [anon_sym_BANG] = ACTIONS(1129),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1131),
  },
  [1551] = {
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_in] = ACTIONS(1203),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_AMP_AMP] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_GT_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1203),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_instanceof] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_DASH_DASH] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1205),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1205),
  },
  [1552] = {
    [sym_string] = STATE(2073),
    [sym__property_name] = STATE(2073),
    [sym_computed_property_name] = STATE(2073),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4674),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1553] = {
    [anon_sym_STAR] = ACTIONS(4061),
    [anon_sym_as] = ACTIONS(4063),
    [anon_sym_LBRACE] = ACTIONS(4061),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_LPAREN] = ACTIONS(4063),
    [anon_sym_in] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(4061),
    [anon_sym_GT] = ACTIONS(4061),
    [anon_sym_SLASH] = ACTIONS(4061),
    [anon_sym_DOT] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(4063),
    [anon_sym_AMP_AMP] = ACTIONS(4063),
    [anon_sym_PIPE_PIPE] = ACTIONS(4063),
    [anon_sym_GT_GT] = ACTIONS(4061),
    [anon_sym_GT_GT_GT] = ACTIONS(4063),
    [anon_sym_LT_LT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4061),
    [anon_sym_CARET] = ACTIONS(4063),
    [anon_sym_PIPE] = ACTIONS(4061),
    [anon_sym_PLUS] = ACTIONS(4061),
    [anon_sym_DASH] = ACTIONS(4061),
    [anon_sym_PERCENT] = ACTIONS(4063),
    [anon_sym_STAR_STAR] = ACTIONS(4063),
    [anon_sym_LT_EQ] = ACTIONS(4063),
    [anon_sym_EQ_EQ] = ACTIONS(4061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4063),
    [anon_sym_BANG_EQ] = ACTIONS(4061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4063),
    [anon_sym_GT_EQ] = ACTIONS(4063),
    [anon_sym_instanceof] = ACTIONS(4063),
    [anon_sym_BANG] = ACTIONS(4061),
    [anon_sym_PLUS_PLUS] = ACTIONS(4063),
    [anon_sym_DASH_DASH] = ACTIONS(4063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1554] = {
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_as] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_in] = ACTIONS(2440),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(2440),
    [anon_sym_GT] = ACTIONS(2440),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_DOT] = ACTIONS(589),
    [anon_sym_QMARK] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(589),
    [anon_sym_PIPE_PIPE] = ACTIONS(589),
    [anon_sym_GT_GT] = ACTIONS(2440),
    [anon_sym_GT_GT_GT] = ACTIONS(589),
    [anon_sym_LT_LT] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_CARET] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(2440),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_DASH] = ACTIONS(2440),
    [anon_sym_PERCENT] = ACTIONS(589),
    [anon_sym_STAR_STAR] = ACTIONS(589),
    [anon_sym_LT_EQ] = ACTIONS(589),
    [anon_sym_EQ_EQ] = ACTIONS(2440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(589),
    [anon_sym_BANG_EQ] = ACTIONS(2440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(589),
    [anon_sym_GT_EQ] = ACTIONS(589),
    [anon_sym_instanceof] = ACTIONS(589),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(589),
    [anon_sym_LBRACE_PIPE] = ACTIONS(589),
  },
  [1555] = {
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_as] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_GT_GT_GT] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1093),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1095),
    [anon_sym_instanceof] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_PLUS_PLUS] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1095),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1095),
  },
  [1556] = {
    [sym_string] = STATE(2079),
    [sym__property_name] = STATE(2079),
    [sym_computed_property_name] = STATE(2079),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4680),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1557] = {
    [anon_sym_STAR] = ACTIONS(4061),
    [anon_sym_as] = ACTIONS(4063),
    [anon_sym_LBRACE] = ACTIONS(4061),
    [anon_sym_COMMA] = ACTIONS(4063),
    [anon_sym_LPAREN] = ACTIONS(4063),
    [anon_sym_in] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_LT] = ACTIONS(4061),
    [anon_sym_GT] = ACTIONS(4061),
    [anon_sym_SLASH] = ACTIONS(4061),
    [anon_sym_DOT] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(4063),
    [anon_sym_AMP_AMP] = ACTIONS(4063),
    [anon_sym_PIPE_PIPE] = ACTIONS(4063),
    [anon_sym_GT_GT] = ACTIONS(4061),
    [anon_sym_GT_GT_GT] = ACTIONS(4063),
    [anon_sym_LT_LT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4061),
    [anon_sym_CARET] = ACTIONS(4063),
    [anon_sym_PIPE] = ACTIONS(4061),
    [anon_sym_PLUS] = ACTIONS(4061),
    [anon_sym_DASH] = ACTIONS(4061),
    [anon_sym_PERCENT] = ACTIONS(4063),
    [anon_sym_STAR_STAR] = ACTIONS(4063),
    [anon_sym_LT_EQ] = ACTIONS(4063),
    [anon_sym_EQ_EQ] = ACTIONS(4061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4063),
    [anon_sym_BANG_EQ] = ACTIONS(4061),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4063),
    [anon_sym_GT_EQ] = ACTIONS(4063),
    [anon_sym_instanceof] = ACTIONS(4063),
    [anon_sym_BANG] = ACTIONS(4061),
    [anon_sym_PLUS_PLUS] = ACTIONS(4063),
    [anon_sym_DASH_DASH] = ACTIONS(4063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4063),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4063),
  },
  [1558] = {
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_as] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_in] = ACTIONS(2444),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_SLASH] = ACTIONS(2444),
    [anon_sym_DOT] = ACTIONS(2442),
    [anon_sym_QMARK] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_GT_GT] = ACTIONS(2444),
    [anon_sym_GT_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_PERCENT] = ACTIONS(2442),
    [anon_sym_STAR_STAR] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2442),
    [anon_sym_BANG_EQ] = ACTIONS(2444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_instanceof] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2442),
  },
  [1559] = {
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1560] = {
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_as] = ACTIONS(1167),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_in] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_AMP_AMP] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_GT_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1165),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_instanceof] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_DASH_DASH] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1167),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1167),
  },
  [1561] = {
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_as] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_LPAREN] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3822),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_LT] = ACTIONS(3822),
    [anon_sym_GT] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3822),
    [anon_sym_DOT] = ACTIONS(3824),
    [anon_sym_QMARK] = ACTIONS(3824),
    [anon_sym_AMP_AMP] = ACTIONS(3824),
    [anon_sym_PIPE_PIPE] = ACTIONS(3824),
    [anon_sym_GT_GT] = ACTIONS(3822),
    [anon_sym_GT_GT_GT] = ACTIONS(3824),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_CARET] = ACTIONS(3824),
    [anon_sym_PIPE] = ACTIONS(3822),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_DASH] = ACTIONS(3822),
    [anon_sym_PERCENT] = ACTIONS(3824),
    [anon_sym_STAR_STAR] = ACTIONS(3824),
    [anon_sym_LT_EQ] = ACTIONS(3824),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3824),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3824),
    [anon_sym_GT_EQ] = ACTIONS(3824),
    [anon_sym_instanceof] = ACTIONS(3824),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3824),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3824),
  },
  [1562] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_as] = ACTIONS(3628),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(4384),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(4386),
    [anon_sym_GT] = ACTIONS(4384),
    [anon_sym_SLASH] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(4388),
    [anon_sym_AMP_AMP] = ACTIONS(4390),
    [anon_sym_PIPE_PIPE] = ACTIONS(4392),
    [anon_sym_GT_GT] = ACTIONS(4382),
    [anon_sym_GT_GT_GT] = ACTIONS(4394),
    [anon_sym_LT_LT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4396),
    [anon_sym_CARET] = ACTIONS(4392),
    [anon_sym_PIPE] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4394),
    [anon_sym_STAR_STAR] = ACTIONS(4402),
    [anon_sym_LT_EQ] = ACTIONS(4404),
    [anon_sym_EQ_EQ] = ACTIONS(4384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4404),
    [anon_sym_BANG_EQ] = ACTIONS(4384),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4404),
    [anon_sym_GT_EQ] = ACTIONS(4404),
    [anon_sym_instanceof] = ACTIONS(4404),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_PLUS_PLUS] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1563] = {
    [anon_sym_STAR] = ACTIONS(3826),
    [anon_sym_as] = ACTIONS(3828),
    [anon_sym_LBRACE] = ACTIONS(3826),
    [anon_sym_COMMA] = ACTIONS(3828),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(3826),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_GT] = ACTIONS(3826),
    [anon_sym_SLASH] = ACTIONS(3826),
    [anon_sym_DOT] = ACTIONS(3828),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3828),
    [anon_sym_PIPE_PIPE] = ACTIONS(3828),
    [anon_sym_GT_GT] = ACTIONS(3826),
    [anon_sym_GT_GT_GT] = ACTIONS(3828),
    [anon_sym_LT_LT] = ACTIONS(3828),
    [anon_sym_AMP] = ACTIONS(3826),
    [anon_sym_CARET] = ACTIONS(3828),
    [anon_sym_PIPE] = ACTIONS(3826),
    [anon_sym_PLUS] = ACTIONS(3826),
    [anon_sym_DASH] = ACTIONS(3826),
    [anon_sym_PERCENT] = ACTIONS(3828),
    [anon_sym_STAR_STAR] = ACTIONS(3828),
    [anon_sym_LT_EQ] = ACTIONS(3828),
    [anon_sym_EQ_EQ] = ACTIONS(3826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3826),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3828),
    [anon_sym_GT_EQ] = ACTIONS(3828),
    [anon_sym_instanceof] = ACTIONS(3828),
    [anon_sym_BANG] = ACTIONS(3826),
    [anon_sym_PLUS_PLUS] = ACTIONS(3828),
    [anon_sym_DASH_DASH] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3828),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3828),
  },
  [1564] = {
    [anon_sym_STAR] = ACTIONS(3948),
    [anon_sym_as] = ACTIONS(3950),
    [anon_sym_LBRACE] = ACTIONS(3948),
    [anon_sym_COMMA] = ACTIONS(3950),
    [anon_sym_LPAREN] = ACTIONS(3950),
    [anon_sym_in] = ACTIONS(3948),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_LT] = ACTIONS(3948),
    [anon_sym_GT] = ACTIONS(3948),
    [anon_sym_SLASH] = ACTIONS(3948),
    [anon_sym_DOT] = ACTIONS(3950),
    [anon_sym_QMARK] = ACTIONS(3950),
    [anon_sym_AMP_AMP] = ACTIONS(3950),
    [anon_sym_PIPE_PIPE] = ACTIONS(3950),
    [anon_sym_GT_GT] = ACTIONS(3948),
    [anon_sym_GT_GT_GT] = ACTIONS(3950),
    [anon_sym_LT_LT] = ACTIONS(3950),
    [anon_sym_AMP] = ACTIONS(3948),
    [anon_sym_CARET] = ACTIONS(3950),
    [anon_sym_PIPE] = ACTIONS(3948),
    [anon_sym_PLUS] = ACTIONS(3948),
    [anon_sym_DASH] = ACTIONS(3948),
    [anon_sym_PERCENT] = ACTIONS(3950),
    [anon_sym_STAR_STAR] = ACTIONS(3950),
    [anon_sym_LT_EQ] = ACTIONS(3950),
    [anon_sym_EQ_EQ] = ACTIONS(3948),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3950),
    [anon_sym_BANG_EQ] = ACTIONS(3948),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3950),
    [anon_sym_GT_EQ] = ACTIONS(3950),
    [anon_sym_instanceof] = ACTIONS(3950),
    [anon_sym_BANG] = ACTIONS(3948),
    [anon_sym_PLUS_PLUS] = ACTIONS(3950),
    [anon_sym_DASH_DASH] = ACTIONS(3950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3950),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3950),
  },
  [1565] = {
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_as] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_COMMA] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_in] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(4698),
    [anon_sym_LT] = ACTIONS(2408),
    [anon_sym_GT] = ACTIONS(2408),
    [anon_sym_SLASH] = ACTIONS(2408),
    [anon_sym_DOT] = ACTIONS(2406),
    [anon_sym_QMARK] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_PIPE_PIPE] = ACTIONS(2406),
    [anon_sym_GT_GT] = ACTIONS(2408),
    [anon_sym_GT_GT_GT] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_CARET] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2408),
    [anon_sym_PLUS] = ACTIONS(2408),
    [anon_sym_DASH] = ACTIONS(2408),
    [anon_sym_PERCENT] = ACTIONS(2406),
    [anon_sym_STAR_STAR] = ACTIONS(2406),
    [anon_sym_LT_EQ] = ACTIONS(2406),
    [anon_sym_EQ_EQ] = ACTIONS(2408),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2406),
    [anon_sym_BANG_EQ] = ACTIONS(2408),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2406),
    [anon_sym_GT_EQ] = ACTIONS(2406),
    [anon_sym_instanceof] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2406),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2406),
  },
  [1566] = {
    [anon_sym_STAR] = ACTIONS(4057),
    [anon_sym_as] = ACTIONS(4059),
    [anon_sym_LBRACE] = ACTIONS(4057),
    [anon_sym_COMMA] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(4059),
    [anon_sym_in] = ACTIONS(4057),
    [anon_sym_LBRACK] = ACTIONS(4059),
    [anon_sym_LT] = ACTIONS(4057),
    [anon_sym_GT] = ACTIONS(4057),
    [anon_sym_SLASH] = ACTIONS(4057),
    [anon_sym_DOT] = ACTIONS(4059),
    [anon_sym_QMARK] = ACTIONS(4059),
    [anon_sym_AMP_AMP] = ACTIONS(4059),
    [anon_sym_PIPE_PIPE] = ACTIONS(4059),
    [anon_sym_GT_GT] = ACTIONS(4057),
    [anon_sym_GT_GT_GT] = ACTIONS(4059),
    [anon_sym_LT_LT] = ACTIONS(4059),
    [anon_sym_AMP] = ACTIONS(4057),
    [anon_sym_CARET] = ACTIONS(4059),
    [anon_sym_PIPE] = ACTIONS(4057),
    [anon_sym_PLUS] = ACTIONS(4057),
    [anon_sym_DASH] = ACTIONS(4057),
    [anon_sym_PERCENT] = ACTIONS(4059),
    [anon_sym_STAR_STAR] = ACTIONS(4059),
    [anon_sym_LT_EQ] = ACTIONS(4059),
    [anon_sym_EQ_EQ] = ACTIONS(4057),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4059),
    [anon_sym_BANG_EQ] = ACTIONS(4057),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4059),
    [anon_sym_GT_EQ] = ACTIONS(4059),
    [anon_sym_instanceof] = ACTIONS(4059),
    [anon_sym_BANG] = ACTIONS(4057),
    [anon_sym_PLUS_PLUS] = ACTIONS(4059),
    [anon_sym_DASH_DASH] = ACTIONS(4059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4059),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4059),
  },
  [1567] = {
    [sym_string] = STATE(2018),
    [sym__property_name] = STATE(2018),
    [sym_computed_property_name] = STATE(2018),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4702),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1568] = {
    [anon_sym_STAR] = ACTIONS(4053),
    [anon_sym_as] = ACTIONS(4055),
    [anon_sym_LBRACE] = ACTIONS(4053),
    [anon_sym_COMMA] = ACTIONS(4055),
    [anon_sym_LPAREN] = ACTIONS(4055),
    [anon_sym_in] = ACTIONS(4053),
    [anon_sym_LBRACK] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4053),
    [anon_sym_GT] = ACTIONS(4053),
    [anon_sym_SLASH] = ACTIONS(4053),
    [anon_sym_DOT] = ACTIONS(4055),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_AMP_AMP] = ACTIONS(4055),
    [anon_sym_PIPE_PIPE] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_GT_GT_GT] = ACTIONS(4055),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_AMP] = ACTIONS(4053),
    [anon_sym_CARET] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4053),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_PERCENT] = ACTIONS(4055),
    [anon_sym_STAR_STAR] = ACTIONS(4055),
    [anon_sym_LT_EQ] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4055),
    [anon_sym_BANG_EQ] = ACTIONS(4053),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4055),
    [anon_sym_GT_EQ] = ACTIONS(4055),
    [anon_sym_instanceof] = ACTIONS(4055),
    [anon_sym_BANG] = ACTIONS(4053),
    [anon_sym_PLUS_PLUS] = ACTIONS(4055),
    [anon_sym_DASH_DASH] = ACTIONS(4055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4055),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4055),
  },
  [1569] = {
    [anon_sym_STAR] = ACTIONS(4033),
    [anon_sym_as] = ACTIONS(4035),
    [anon_sym_LBRACE] = ACTIONS(4033),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN] = ACTIONS(4035),
    [anon_sym_in] = ACTIONS(4033),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_LT] = ACTIONS(4033),
    [anon_sym_GT] = ACTIONS(4033),
    [anon_sym_SLASH] = ACTIONS(4033),
    [anon_sym_DOT] = ACTIONS(4035),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_GT_GT_GT] = ACTIONS(4035),
    [anon_sym_LT_LT] = ACTIONS(4035),
    [anon_sym_AMP] = ACTIONS(4033),
    [anon_sym_CARET] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4033),
    [anon_sym_DASH] = ACTIONS(4033),
    [anon_sym_PERCENT] = ACTIONS(4035),
    [anon_sym_STAR_STAR] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4035),
    [anon_sym_EQ_EQ] = ACTIONS(4033),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4033),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4035),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_instanceof] = ACTIONS(4035),
    [anon_sym_BANG] = ACTIONS(4033),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4035),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4035),
  },
  [1570] = {
    [anon_sym_STAR] = ACTIONS(4011),
    [anon_sym_as] = ACTIONS(4013),
    [anon_sym_LBRACE] = ACTIONS(4011),
    [anon_sym_COMMA] = ACTIONS(4013),
    [anon_sym_LPAREN] = ACTIONS(4013),
    [anon_sym_in] = ACTIONS(4011),
    [anon_sym_LBRACK] = ACTIONS(4013),
    [anon_sym_LT] = ACTIONS(4011),
    [anon_sym_GT] = ACTIONS(4011),
    [anon_sym_SLASH] = ACTIONS(4011),
    [anon_sym_DOT] = ACTIONS(4013),
    [anon_sym_QMARK] = ACTIONS(4013),
    [anon_sym_AMP_AMP] = ACTIONS(4013),
    [anon_sym_PIPE_PIPE] = ACTIONS(4013),
    [anon_sym_GT_GT] = ACTIONS(4011),
    [anon_sym_GT_GT_GT] = ACTIONS(4013),
    [anon_sym_LT_LT] = ACTIONS(4013),
    [anon_sym_AMP] = ACTIONS(4011),
    [anon_sym_CARET] = ACTIONS(4013),
    [anon_sym_PIPE] = ACTIONS(4011),
    [anon_sym_PLUS] = ACTIONS(4011),
    [anon_sym_DASH] = ACTIONS(4011),
    [anon_sym_PERCENT] = ACTIONS(4013),
    [anon_sym_STAR_STAR] = ACTIONS(4013),
    [anon_sym_LT_EQ] = ACTIONS(4013),
    [anon_sym_EQ_EQ] = ACTIONS(4011),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4013),
    [anon_sym_BANG_EQ] = ACTIONS(4011),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4013),
    [anon_sym_GT_EQ] = ACTIONS(4013),
    [anon_sym_instanceof] = ACTIONS(4013),
    [anon_sym_BANG] = ACTIONS(4011),
    [anon_sym_PLUS_PLUS] = ACTIONS(4013),
    [anon_sym_DASH_DASH] = ACTIONS(4013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4013),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4013),
  },
  [1571] = {
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_as] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1179),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_in] = ACTIONS(1179),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1179),
    [anon_sym_GT] = ACTIONS(1179),
    [anon_sym_SLASH] = ACTIONS(1179),
    [anon_sym_DOT] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_AMP_AMP] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_GT_GT] = ACTIONS(1179),
    [anon_sym_GT_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1179),
    [anon_sym_PLUS] = ACTIONS(1179),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1179),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1179),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_instanceof] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_DASH_DASH] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1181),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1181),
  },
  [1572] = {
    [anon_sym_STAR] = ACTIONS(4007),
    [anon_sym_as] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_COMMA] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4009),
    [anon_sym_in] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4007),
    [anon_sym_GT] = ACTIONS(4007),
    [anon_sym_SLASH] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4009),
    [anon_sym_QMARK] = ACTIONS(4009),
    [anon_sym_AMP_AMP] = ACTIONS(4009),
    [anon_sym_PIPE_PIPE] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4007),
    [anon_sym_GT_GT_GT] = ACTIONS(4009),
    [anon_sym_LT_LT] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4007),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_PIPE] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4009),
    [anon_sym_STAR_STAR] = ACTIONS(4009),
    [anon_sym_LT_EQ] = ACTIONS(4009),
    [anon_sym_EQ_EQ] = ACTIONS(4007),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4009),
    [anon_sym_BANG_EQ] = ACTIONS(4007),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4009),
    [anon_sym_instanceof] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_PLUS_PLUS] = ACTIONS(4009),
    [anon_sym_DASH_DASH] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(4009),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4009),
  },
  [1573] = {
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_as] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_in] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_GT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2438),
    [anon_sym_DOT] = ACTIONS(2436),
    [anon_sym_QMARK] = ACTIONS(2436),
    [anon_sym_AMP_AMP] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2436),
    [anon_sym_GT_GT] = ACTIONS(2438),
    [anon_sym_GT_GT_GT] = ACTIONS(2436),
    [anon_sym_LT_LT] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_CARET] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_STAR_STAR] = ACTIONS(2436),
    [anon_sym_LT_EQ] = ACTIONS(2436),
    [anon_sym_EQ_EQ] = ACTIONS(2438),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2436),
    [anon_sym_BANG_EQ] = ACTIONS(2438),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2436),
    [anon_sym_GT_EQ] = ACTIONS(2436),
    [anon_sym_instanceof] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2436),
  },
  [1574] = {
    [sym_string] = STATE(2046),
    [sym__property_name] = STATE(2046),
    [sym_computed_property_name] = STATE(2046),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4580),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1575] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
  },
  [1576] = {
    [sym_string] = STATE(1904),
    [sym__property_name] = STATE(1904),
    [sym_computed_property_name] = STATE(1904),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(3503),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4704),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(3503),
    [anon_sym_set] = ACTIONS(3503),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1577] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1578] = {
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_as] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_in] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_LT] = ACTIONS(2456),
    [anon_sym_GT] = ACTIONS(2456),
    [anon_sym_SLASH] = ACTIONS(2456),
    [anon_sym_DOT] = ACTIONS(2454),
    [anon_sym_QMARK] = ACTIONS(2454),
    [anon_sym_AMP_AMP] = ACTIONS(2454),
    [anon_sym_PIPE_PIPE] = ACTIONS(2454),
    [anon_sym_GT_GT] = ACTIONS(2456),
    [anon_sym_GT_GT_GT] = ACTIONS(2454),
    [anon_sym_LT_LT] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_CARET] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2456),
    [anon_sym_DASH] = ACTIONS(2456),
    [anon_sym_PERCENT] = ACTIONS(2454),
    [anon_sym_STAR_STAR] = ACTIONS(2454),
    [anon_sym_LT_EQ] = ACTIONS(2454),
    [anon_sym_EQ_EQ] = ACTIONS(2456),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2454),
    [anon_sym_BANG_EQ] = ACTIONS(2456),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2454),
    [anon_sym_GT_EQ] = ACTIONS(2454),
    [anon_sym_instanceof] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2454),
    [anon_sym_DASH_DASH] = ACTIONS(2454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2454),
  },
  [1579] = {
    [anon_sym_STAR] = ACTIONS(3890),
    [anon_sym_as] = ACTIONS(3892),
    [anon_sym_LBRACE] = ACTIONS(3890),
    [anon_sym_COMMA] = ACTIONS(3892),
    [anon_sym_LPAREN] = ACTIONS(3892),
    [anon_sym_in] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3892),
    [anon_sym_LT] = ACTIONS(3890),
    [anon_sym_GT] = ACTIONS(3890),
    [anon_sym_SLASH] = ACTIONS(3890),
    [anon_sym_DOT] = ACTIONS(3892),
    [anon_sym_QMARK] = ACTIONS(3892),
    [anon_sym_AMP_AMP] = ACTIONS(3892),
    [anon_sym_PIPE_PIPE] = ACTIONS(3892),
    [anon_sym_GT_GT] = ACTIONS(3890),
    [anon_sym_GT_GT_GT] = ACTIONS(3892),
    [anon_sym_LT_LT] = ACTIONS(3892),
    [anon_sym_AMP] = ACTIONS(3890),
    [anon_sym_CARET] = ACTIONS(3892),
    [anon_sym_PIPE] = ACTIONS(3890),
    [anon_sym_PLUS] = ACTIONS(3890),
    [anon_sym_DASH] = ACTIONS(3890),
    [anon_sym_PERCENT] = ACTIONS(3892),
    [anon_sym_STAR_STAR] = ACTIONS(3892),
    [anon_sym_LT_EQ] = ACTIONS(3892),
    [anon_sym_EQ_EQ] = ACTIONS(3890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3892),
    [anon_sym_BANG_EQ] = ACTIONS(3890),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3892),
    [anon_sym_GT_EQ] = ACTIONS(3892),
    [anon_sym_instanceof] = ACTIONS(3892),
    [anon_sym_BANG] = ACTIONS(3890),
    [anon_sym_PLUS_PLUS] = ACTIONS(3892),
    [anon_sym_DASH_DASH] = ACTIONS(3892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3892),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3892),
  },
  [1580] = {
    [sym_string] = STATE(2057),
    [sym__property_name] = STATE(2057),
    [sym_computed_property_name] = STATE(2057),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4622),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1581] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [1582] = {
    [sym_string] = STATE(2061),
    [sym__property_name] = STATE(2061),
    [sym_computed_property_name] = STATE(2061),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4602),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1583] = {
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_as] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1243),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_in] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_DOT] = ACTIONS(1241),
    [anon_sym_QMARK] = ACTIONS(1241),
    [anon_sym_AMP_AMP] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1241),
    [anon_sym_GT_GT] = ACTIONS(1243),
    [anon_sym_GT_GT_GT] = ACTIONS(1241),
    [anon_sym_LT_LT] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_CARET] = ACTIONS(1241),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_PERCENT] = ACTIONS(1241),
    [anon_sym_STAR_STAR] = ACTIONS(1241),
    [anon_sym_LT_EQ] = ACTIONS(1241),
    [anon_sym_EQ_EQ] = ACTIONS(1243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1241),
    [anon_sym_BANG_EQ] = ACTIONS(1243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1241),
    [anon_sym_GT_EQ] = ACTIONS(1241),
    [anon_sym_instanceof] = ACTIONS(1241),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_DASH_DASH] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1241),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1241),
  },
  [1584] = {
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_as] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2468),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_SLASH] = ACTIONS(2468),
    [anon_sym_DOT] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_GT_GT] = ACTIONS(2468),
    [anon_sym_GT_GT_GT] = ACTIONS(2466),
    [anon_sym_LT_LT] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_PERCENT] = ACTIONS(2466),
    [anon_sym_STAR_STAR] = ACTIONS(2466),
    [anon_sym_LT_EQ] = ACTIONS(2466),
    [anon_sym_EQ_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2466),
    [anon_sym_BANG_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2466),
    [anon_sym_GT_EQ] = ACTIONS(2466),
    [anon_sym_instanceof] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2466),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2466),
  },
  [1585] = {
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_as] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_COMMA] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_in] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_LT] = ACTIONS(2386),
    [anon_sym_GT] = ACTIONS(2386),
    [anon_sym_SLASH] = ACTIONS(2386),
    [anon_sym_DOT] = ACTIONS(2384),
    [anon_sym_QMARK] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_PIPE_PIPE] = ACTIONS(2384),
    [anon_sym_GT_GT] = ACTIONS(2386),
    [anon_sym_GT_GT_GT] = ACTIONS(2384),
    [anon_sym_LT_LT] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_CARET] = ACTIONS(2384),
    [anon_sym_PIPE] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_PERCENT] = ACTIONS(2384),
    [anon_sym_STAR_STAR] = ACTIONS(2384),
    [anon_sym_LT_EQ] = ACTIONS(2384),
    [anon_sym_EQ_EQ] = ACTIONS(2386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2384),
    [anon_sym_BANG_EQ] = ACTIONS(2386),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2384),
    [anon_sym_GT_EQ] = ACTIONS(2384),
    [anon_sym_instanceof] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2384),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2384),
  },
  [1586] = {
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_as] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2394),
    [anon_sym_DOT] = ACTIONS(4415),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_PIPE_PIPE] = ACTIONS(2392),
    [anon_sym_GT_GT] = ACTIONS(2394),
    [anon_sym_GT_GT_GT] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_STAR_STAR] = ACTIONS(2392),
    [anon_sym_LT_EQ] = ACTIONS(2392),
    [anon_sym_EQ_EQ] = ACTIONS(2394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2392),
    [anon_sym_BANG_EQ] = ACTIONS(2394),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2392),
    [anon_sym_GT_EQ] = ACTIONS(2392),
    [anon_sym_instanceof] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2392),
  },
  [1587] = {
    [anon_sym_STAR] = ACTIONS(2592),
    [anon_sym_as] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2590),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2592),
    [anon_sym_GT] = ACTIONS(2592),
    [anon_sym_SLASH] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2592),
    [anon_sym_GT_GT_GT] = ACTIONS(2590),
    [anon_sym_LT_LT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(4694),
    [anon_sym_CARET] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(4696),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PERCENT] = ACTIONS(2590),
    [anon_sym_STAR_STAR] = ACTIONS(2590),
    [anon_sym_LT_EQ] = ACTIONS(2590),
    [anon_sym_EQ_EQ] = ACTIONS(2592),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2590),
    [anon_sym_BANG_EQ] = ACTIONS(2592),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2590),
    [anon_sym_instanceof] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2590),
  },
  [1588] = {
    [anon_sym_STAR] = ACTIONS(3899),
    [anon_sym_as] = ACTIONS(3770),
    [anon_sym_LBRACE] = ACTIONS(3899),
    [anon_sym_COMMA] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [anon_sym_in] = ACTIONS(3899),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [anon_sym_LT] = ACTIONS(3899),
    [anon_sym_GT] = ACTIONS(3899),
    [anon_sym_SLASH] = ACTIONS(3899),
    [anon_sym_DOT] = ACTIONS(3770),
    [anon_sym_QMARK] = ACTIONS(3770),
    [anon_sym_AMP_AMP] = ACTIONS(3770),
    [anon_sym_PIPE_PIPE] = ACTIONS(3770),
    [anon_sym_GT_GT] = ACTIONS(3899),
    [anon_sym_GT_GT_GT] = ACTIONS(3770),
    [anon_sym_LT_LT] = ACTIONS(3770),
    [anon_sym_AMP] = ACTIONS(3899),
    [anon_sym_CARET] = ACTIONS(3770),
    [anon_sym_PIPE] = ACTIONS(3899),
    [anon_sym_PLUS] = ACTIONS(3899),
    [anon_sym_DASH] = ACTIONS(3899),
    [anon_sym_PERCENT] = ACTIONS(3770),
    [anon_sym_STAR_STAR] = ACTIONS(3770),
    [anon_sym_LT_EQ] = ACTIONS(3770),
    [anon_sym_EQ_EQ] = ACTIONS(3899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3770),
    [anon_sym_BANG_EQ] = ACTIONS(3899),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3770),
    [anon_sym_GT_EQ] = ACTIONS(3770),
    [anon_sym_instanceof] = ACTIONS(3770),
    [anon_sym_BANG] = ACTIONS(3899),
    [anon_sym_PLUS_PLUS] = ACTIONS(3770),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3770),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3770),
  },
  [1589] = {
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
  },
  [1590] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2447),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4706),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1591] = {
    [anon_sym_STAR] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2600),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2598),
    [anon_sym_QMARK] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_GT_GT_GT] = ACTIONS(2598),
    [anon_sym_LT_LT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(4694),
    [anon_sym_CARET] = ACTIONS(2598),
    [anon_sym_PIPE] = ACTIONS(4696),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2598),
    [anon_sym_STAR_STAR] = ACTIONS(2598),
    [anon_sym_LT_EQ] = ACTIONS(2598),
    [anon_sym_EQ_EQ] = ACTIONS(2600),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2598),
    [anon_sym_BANG_EQ] = ACTIONS(2600),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2598),
    [anon_sym_GT_EQ] = ACTIONS(2598),
    [anon_sym_instanceof] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2598),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2598),
  },
  [1592] = {
    [anon_sym_STAR] = ACTIONS(3903),
    [anon_sym_as] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3903),
    [anon_sym_COMMA] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3768),
    [anon_sym_in] = ACTIONS(3903),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(3903),
    [anon_sym_SLASH] = ACTIONS(3903),
    [anon_sym_DOT] = ACTIONS(3768),
    [anon_sym_QMARK] = ACTIONS(3768),
    [anon_sym_AMP_AMP] = ACTIONS(3768),
    [anon_sym_PIPE_PIPE] = ACTIONS(3768),
    [anon_sym_GT_GT] = ACTIONS(3903),
    [anon_sym_GT_GT_GT] = ACTIONS(3768),
    [anon_sym_LT_LT] = ACTIONS(3768),
    [anon_sym_AMP] = ACTIONS(3903),
    [anon_sym_CARET] = ACTIONS(3768),
    [anon_sym_PIPE] = ACTIONS(3903),
    [anon_sym_PLUS] = ACTIONS(3903),
    [anon_sym_DASH] = ACTIONS(3903),
    [anon_sym_PERCENT] = ACTIONS(3768),
    [anon_sym_STAR_STAR] = ACTIONS(3768),
    [anon_sym_LT_EQ] = ACTIONS(3768),
    [anon_sym_EQ_EQ] = ACTIONS(3903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3768),
    [anon_sym_BANG_EQ] = ACTIONS(3903),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3768),
    [anon_sym_GT_EQ] = ACTIONS(3768),
    [anon_sym_instanceof] = ACTIONS(3768),
    [anon_sym_BANG] = ACTIONS(3903),
    [anon_sym_PLUS_PLUS] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3768),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3768),
  },
  [1593] = {
    [anon_sym_STAR] = ACTIONS(3905),
    [anon_sym_as] = ACTIONS(3907),
    [anon_sym_LBRACE] = ACTIONS(3905),
    [anon_sym_COMMA] = ACTIONS(3907),
    [anon_sym_LPAREN] = ACTIONS(3907),
    [anon_sym_in] = ACTIONS(3905),
    [anon_sym_LBRACK] = ACTIONS(3907),
    [anon_sym_LT] = ACTIONS(3905),
    [anon_sym_GT] = ACTIONS(3905),
    [anon_sym_SLASH] = ACTIONS(3905),
    [anon_sym_DOT] = ACTIONS(3907),
    [anon_sym_QMARK] = ACTIONS(3907),
    [anon_sym_AMP_AMP] = ACTIONS(3907),
    [anon_sym_PIPE_PIPE] = ACTIONS(3907),
    [anon_sym_GT_GT] = ACTIONS(3905),
    [anon_sym_GT_GT_GT] = ACTIONS(3907),
    [anon_sym_LT_LT] = ACTIONS(3907),
    [anon_sym_AMP] = ACTIONS(3905),
    [anon_sym_CARET] = ACTIONS(3907),
    [anon_sym_PIPE] = ACTIONS(3905),
    [anon_sym_PLUS] = ACTIONS(3905),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_PERCENT] = ACTIONS(3907),
    [anon_sym_STAR_STAR] = ACTIONS(3907),
    [anon_sym_LT_EQ] = ACTIONS(3907),
    [anon_sym_EQ_EQ] = ACTIONS(3905),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3907),
    [anon_sym_BANG_EQ] = ACTIONS(3905),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3907),
    [anon_sym_GT_EQ] = ACTIONS(3907),
    [anon_sym_instanceof] = ACTIONS(3907),
    [anon_sym_BANG] = ACTIONS(3905),
    [anon_sym_PLUS_PLUS] = ACTIONS(3907),
    [anon_sym_DASH_DASH] = ACTIONS(3907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3907),
  },
  [1594] = {
    [anon_sym_STAR] = ACTIONS(1155),
    [anon_sym_as] = ACTIONS(1157),
    [anon_sym_LBRACE] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1157),
    [anon_sym_in] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1157),
    [anon_sym_QMARK] = ACTIONS(1157),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1157),
    [anon_sym_STAR_STAR] = ACTIONS(1157),
    [anon_sym_LT_EQ] = ACTIONS(1157),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1157),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1157),
    [anon_sym_GT_EQ] = ACTIONS(1157),
    [anon_sym_instanceof] = ACTIONS(1157),
    [anon_sym_BANG] = ACTIONS(1155),
    [anon_sym_PLUS_PLUS] = ACTIONS(1157),
    [anon_sym_DASH_DASH] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1157),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1157),
  },
  [1595] = {
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_as] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2338),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_in] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_GT] = ACTIONS(2340),
    [anon_sym_SLASH] = ACTIONS(2340),
    [anon_sym_DOT] = ACTIONS(3956),
    [anon_sym_QMARK] = ACTIONS(2338),
    [anon_sym_AMP_AMP] = ACTIONS(2338),
    [anon_sym_PIPE_PIPE] = ACTIONS(2338),
    [anon_sym_GT_GT] = ACTIONS(2340),
    [anon_sym_GT_GT_GT] = ACTIONS(2338),
    [anon_sym_LT_LT] = ACTIONS(2338),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_PIPE] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_PERCENT] = ACTIONS(2338),
    [anon_sym_STAR_STAR] = ACTIONS(2338),
    [anon_sym_LT_EQ] = ACTIONS(2338),
    [anon_sym_EQ_EQ] = ACTIONS(2340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2338),
    [anon_sym_BANG_EQ] = ACTIONS(2340),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2338),
    [anon_sym_GT_EQ] = ACTIONS(2338),
    [anon_sym_instanceof] = ACTIONS(2338),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2338),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2338),
  },
  [1596] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1597] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
  },
  [1598] = {
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_as] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_STAR] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1233),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1233),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1233),
  },
  [1599] = {
    [anon_sym_STAR] = ACTIONS(3913),
    [anon_sym_as] = ACTIONS(3766),
    [anon_sym_LBRACE] = ACTIONS(3913),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_in] = ACTIONS(3913),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3913),
    [anon_sym_GT] = ACTIONS(3913),
    [anon_sym_SLASH] = ACTIONS(3913),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3913),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3913),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_PIPE] = ACTIONS(3913),
    [anon_sym_PLUS] = ACTIONS(3913),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_STAR_STAR] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3913),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3913),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_instanceof] = ACTIONS(3766),
    [anon_sym_BANG] = ACTIONS(3913),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3766),
  },
  [1600] = {
    [anon_sym_STAR] = ACTIONS(3923),
    [anon_sym_as] = ACTIONS(3925),
    [anon_sym_LBRACE] = ACTIONS(3923),
    [anon_sym_COMMA] = ACTIONS(3925),
    [anon_sym_LPAREN] = ACTIONS(3925),
    [anon_sym_in] = ACTIONS(3923),
    [anon_sym_LBRACK] = ACTIONS(3925),
    [anon_sym_LT] = ACTIONS(3923),
    [anon_sym_GT] = ACTIONS(3923),
    [anon_sym_SLASH] = ACTIONS(3923),
    [anon_sym_DOT] = ACTIONS(3925),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_AMP_AMP] = ACTIONS(3925),
    [anon_sym_PIPE_PIPE] = ACTIONS(3925),
    [anon_sym_GT_GT] = ACTIONS(3923),
    [anon_sym_GT_GT_GT] = ACTIONS(3925),
    [anon_sym_LT_LT] = ACTIONS(3925),
    [anon_sym_AMP] = ACTIONS(3923),
    [anon_sym_CARET] = ACTIONS(3925),
    [anon_sym_PIPE] = ACTIONS(3923),
    [anon_sym_PLUS] = ACTIONS(3923),
    [anon_sym_DASH] = ACTIONS(3923),
    [anon_sym_PERCENT] = ACTIONS(3925),
    [anon_sym_STAR_STAR] = ACTIONS(3925),
    [anon_sym_LT_EQ] = ACTIONS(3925),
    [anon_sym_EQ_EQ] = ACTIONS(3923),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3925),
    [anon_sym_BANG_EQ] = ACTIONS(3923),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3925),
    [anon_sym_GT_EQ] = ACTIONS(3925),
    [anon_sym_instanceof] = ACTIONS(3925),
    [anon_sym_BANG] = ACTIONS(3923),
    [anon_sym_PLUS_PLUS] = ACTIONS(3925),
    [anon_sym_DASH_DASH] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3925),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3925),
  },
  [1601] = {
    [anon_sym_STAR] = ACTIONS(3952),
    [anon_sym_as] = ACTIONS(3954),
    [anon_sym_LBRACE] = ACTIONS(3952),
    [anon_sym_COMMA] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3954),
    [anon_sym_in] = ACTIONS(3952),
    [anon_sym_LBRACK] = ACTIONS(3954),
    [anon_sym_LT] = ACTIONS(3952),
    [anon_sym_GT] = ACTIONS(3952),
    [anon_sym_SLASH] = ACTIONS(3952),
    [anon_sym_DOT] = ACTIONS(3954),
    [anon_sym_QMARK] = ACTIONS(3954),
    [anon_sym_AMP_AMP] = ACTIONS(3954),
    [anon_sym_PIPE_PIPE] = ACTIONS(3954),
    [anon_sym_GT_GT] = ACTIONS(3952),
    [anon_sym_GT_GT_GT] = ACTIONS(3954),
    [anon_sym_LT_LT] = ACTIONS(3954),
    [anon_sym_AMP] = ACTIONS(3952),
    [anon_sym_CARET] = ACTIONS(3954),
    [anon_sym_PIPE] = ACTIONS(3952),
    [anon_sym_PLUS] = ACTIONS(3952),
    [anon_sym_DASH] = ACTIONS(3952),
    [anon_sym_PERCENT] = ACTIONS(3954),
    [anon_sym_STAR_STAR] = ACTIONS(3954),
    [anon_sym_LT_EQ] = ACTIONS(3954),
    [anon_sym_EQ_EQ] = ACTIONS(3952),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3954),
    [anon_sym_BANG_EQ] = ACTIONS(3952),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3954),
    [anon_sym_GT_EQ] = ACTIONS(3954),
    [anon_sym_instanceof] = ACTIONS(3954),
    [anon_sym_BANG] = ACTIONS(3952),
    [anon_sym_PLUS_PLUS] = ACTIONS(3954),
    [anon_sym_DASH_DASH] = ACTIONS(3954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3954),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3954),
  },
  [1602] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(4079),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1603] = {
    [anon_sym_STAR] = ACTIONS(1213),
    [anon_sym_as] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1215),
    [anon_sym_in] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1215),
    [anon_sym_LT] = ACTIONS(1213),
    [anon_sym_GT] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_QMARK] = ACTIONS(1215),
    [anon_sym_AMP_AMP] = ACTIONS(1215),
    [anon_sym_PIPE_PIPE] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1213),
    [anon_sym_GT_GT_GT] = ACTIONS(1215),
    [anon_sym_LT_LT] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1213),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_PIPE] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1213),
    [anon_sym_DASH] = ACTIONS(1213),
    [anon_sym_PERCENT] = ACTIONS(1215),
    [anon_sym_STAR_STAR] = ACTIONS(1215),
    [anon_sym_LT_EQ] = ACTIONS(1215),
    [anon_sym_EQ_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1215),
    [anon_sym_BANG_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1215),
    [anon_sym_instanceof] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1213),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1215),
  },
  [1604] = {
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_as] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_in] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1111),
    [anon_sym_GT] = ACTIONS(1111),
    [anon_sym_SLASH] = ACTIONS(1111),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP_AMP] = ACTIONS(1109),
    [anon_sym_PIPE_PIPE] = ACTIONS(1109),
    [anon_sym_GT_GT] = ACTIONS(1111),
    [anon_sym_GT_GT_GT] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1111),
    [anon_sym_CARET] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1111),
    [anon_sym_DASH] = ACTIONS(1111),
    [anon_sym_PERCENT] = ACTIONS(1109),
    [anon_sym_STAR_STAR] = ACTIONS(1109),
    [anon_sym_LT_EQ] = ACTIONS(1109),
    [anon_sym_EQ_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1109),
    [anon_sym_BANG_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1109),
    [anon_sym_GT_EQ] = ACTIONS(1109),
    [anon_sym_instanceof] = ACTIONS(1109),
    [anon_sym_BANG] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(1109),
    [anon_sym_DASH_DASH] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1109),
  },
  [1605] = {
    [sym_string] = STATE(2047),
    [sym__property_name] = STATE(2047),
    [sym_computed_property_name] = STATE(2047),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4558),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1606] = {
    [anon_sym_STAR] = ACTIONS(1103),
    [anon_sym_as] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_COMMA] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_SLASH] = ACTIONS(1103),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_QMARK] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [anon_sym_GT_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_CARET] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [anon_sym_STAR_STAR] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1105),
    [anon_sym_BANG_EQ] = ACTIONS(1103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1105),
    [anon_sym_GT_EQ] = ACTIONS(1105),
    [anon_sym_instanceof] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1103),
    [anon_sym_PLUS_PLUS] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(1105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1105),
  },
  [1607] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1608] = {
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_as] = ACTIONS(3370),
    [anon_sym_LBRACE] = ACTIONS(3368),
    [anon_sym_COMMA] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_DOT] = ACTIONS(3370),
    [anon_sym_QMARK] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_PIPE_PIPE] = ACTIONS(3370),
    [anon_sym_GT_GT] = ACTIONS(3368),
    [anon_sym_GT_GT_GT] = ACTIONS(3370),
    [anon_sym_LT_LT] = ACTIONS(3370),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_CARET] = ACTIONS(3370),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3370),
    [anon_sym_STAR_STAR] = ACTIONS(3370),
    [anon_sym_LT_EQ] = ACTIONS(3370),
    [anon_sym_EQ_EQ] = ACTIONS(3368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3370),
    [anon_sym_BANG_EQ] = ACTIONS(3368),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3370),
    [anon_sym_GT_EQ] = ACTIONS(3370),
    [anon_sym_instanceof] = ACTIONS(3370),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3370),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3370),
  },
  [1609] = {
    [anon_sym_STAR] = ACTIONS(1193),
    [anon_sym_as] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_in] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1193),
    [anon_sym_GT] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_QMARK] = ACTIONS(1195),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_GT_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1193),
    [anon_sym_DASH] = ACTIONS(1193),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1195),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1195),
    [anon_sym_GT_EQ] = ACTIONS(1195),
    [anon_sym_instanceof] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1193),
    [anon_sym_PLUS_PLUS] = ACTIONS(1195),
    [anon_sym_DASH_DASH] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1195),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1195),
  },
  [1610] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_RPAREN] = ACTIONS(4079),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(4079),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1611] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4088),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4088),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4088),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1612] = {
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_in] = ACTIONS(1115),
    [anon_sym_LBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_GT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_DOT] = ACTIONS(1113),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_AMP_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1115),
    [anon_sym_GT_GT_GT] = ACTIONS(1113),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1113),
    [anon_sym_GT_EQ] = ACTIONS(1113),
    [anon_sym_instanceof] = ACTIONS(1113),
    [anon_sym_BANG] = ACTIONS(1115),
    [anon_sym_PLUS_PLUS] = ACTIONS(1113),
    [anon_sym_DASH_DASH] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1113),
  },
  [1613] = {
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_as] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2344),
    [anon_sym_GT] = ACTIONS(2344),
    [anon_sym_SLASH] = ACTIONS(2344),
    [anon_sym_DOT] = ACTIONS(4553),
    [anon_sym_QMARK] = ACTIONS(2342),
    [anon_sym_AMP_AMP] = ACTIONS(2342),
    [anon_sym_PIPE_PIPE] = ACTIONS(2342),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_GT_GT_GT] = ACTIONS(2342),
    [anon_sym_LT_LT] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_CARET] = ACTIONS(2342),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_PERCENT] = ACTIONS(2342),
    [anon_sym_STAR_STAR] = ACTIONS(2342),
    [anon_sym_LT_EQ] = ACTIONS(2342),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2342),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2342),
    [anon_sym_GT_EQ] = ACTIONS(2342),
    [anon_sym_instanceof] = ACTIONS(2342),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2342),
  },
  [1614] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2447),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4706),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
  },
  [1615] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2447),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4706),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1616] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(4079),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [1617] = {
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_as] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_GT] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2404),
    [anon_sym_DOT] = ACTIONS(2402),
    [anon_sym_QMARK] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_PIPE_PIPE] = ACTIONS(2402),
    [anon_sym_GT_GT] = ACTIONS(2404),
    [anon_sym_GT_GT_GT] = ACTIONS(2402),
    [anon_sym_LT_LT] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_CARET] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PERCENT] = ACTIONS(2402),
    [anon_sym_STAR_STAR] = ACTIONS(2402),
    [anon_sym_LT_EQ] = ACTIONS(2402),
    [anon_sym_EQ_EQ] = ACTIONS(2404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2402),
    [anon_sym_BANG_EQ] = ACTIONS(2404),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2402),
    [anon_sym_GT_EQ] = ACTIONS(2402),
    [anon_sym_instanceof] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2402),
  },
  [1618] = {
    [sym_string] = STATE(2027),
    [sym__property_name] = STATE(2027),
    [sym_computed_property_name] = STATE(2027),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4708),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1619] = {
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_as] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_DOT] = ACTIONS(2420),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_GT_GT_GT] = ACTIONS(2420),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_STAR_STAR] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2420),
    [anon_sym_EQ_EQ] = ACTIONS(2422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2420),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_instanceof] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
  },
  [1620] = {
    [anon_sym_STAR] = ACTIONS(2480),
    [anon_sym_as] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2478),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_LT] = ACTIONS(2480),
    [anon_sym_GT] = ACTIONS(2480),
    [anon_sym_SLASH] = ACTIONS(2480),
    [anon_sym_DOT] = ACTIONS(2478),
    [anon_sym_QMARK] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [anon_sym_GT_GT] = ACTIONS(2480),
    [anon_sym_GT_GT_GT] = ACTIONS(2478),
    [anon_sym_LT_LT] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_CARET] = ACTIONS(2478),
    [anon_sym_PIPE] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_STAR_STAR] = ACTIONS(2478),
    [anon_sym_LT_EQ] = ACTIONS(2478),
    [anon_sym_EQ_EQ] = ACTIONS(2480),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2478),
    [anon_sym_BANG_EQ] = ACTIONS(2480),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2478),
    [anon_sym_GT_EQ] = ACTIONS(2478),
    [anon_sym_instanceof] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_PLUS_PLUS] = ACTIONS(2478),
    [anon_sym_DASH_DASH] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2478),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2478),
  },
  [1621] = {
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_as] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_LT] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2400),
    [anon_sym_SLASH] = ACTIONS(2400),
    [anon_sym_DOT] = ACTIONS(2398),
    [anon_sym_QMARK] = ACTIONS(2398),
    [anon_sym_AMP_AMP] = ACTIONS(2398),
    [anon_sym_PIPE_PIPE] = ACTIONS(2398),
    [anon_sym_GT_GT] = ACTIONS(2400),
    [anon_sym_GT_GT_GT] = ACTIONS(2398),
    [anon_sym_LT_LT] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_CARET] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2400),
    [anon_sym_PERCENT] = ACTIONS(2398),
    [anon_sym_STAR_STAR] = ACTIONS(2398),
    [anon_sym_LT_EQ] = ACTIONS(2398),
    [anon_sym_EQ_EQ] = ACTIONS(2400),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2398),
    [anon_sym_BANG_EQ] = ACTIONS(2400),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2398),
    [anon_sym_GT_EQ] = ACTIONS(2398),
    [anon_sym_instanceof] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2398),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2398),
  },
  [1622] = {
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_as] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_in] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_LT] = ACTIONS(2484),
    [anon_sym_GT] = ACTIONS(2484),
    [anon_sym_SLASH] = ACTIONS(2484),
    [anon_sym_DOT] = ACTIONS(2482),
    [anon_sym_QMARK] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(2482),
    [anon_sym_PIPE_PIPE] = ACTIONS(2482),
    [anon_sym_GT_GT] = ACTIONS(2484),
    [anon_sym_GT_GT_GT] = ACTIONS(2482),
    [anon_sym_LT_LT] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_CARET] = ACTIONS(2482),
    [anon_sym_PIPE] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_PERCENT] = ACTIONS(2482),
    [anon_sym_STAR_STAR] = ACTIONS(2482),
    [anon_sym_LT_EQ] = ACTIONS(2482),
    [anon_sym_EQ_EQ] = ACTIONS(2484),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2482),
    [anon_sym_BANG_EQ] = ACTIONS(2484),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2482),
    [anon_sym_GT_EQ] = ACTIONS(2482),
    [anon_sym_instanceof] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2482),
    [anon_sym_DASH_DASH] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2482),
  },
  [1623] = {
    [anon_sym_STAR] = ACTIONS(2382),
    [anon_sym_as] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_COMMA] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2380),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_GT] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(2382),
    [anon_sym_DOT] = ACTIONS(2380),
    [anon_sym_QMARK] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_PIPE_PIPE] = ACTIONS(2380),
    [anon_sym_GT_GT] = ACTIONS(2382),
    [anon_sym_GT_GT_GT] = ACTIONS(2380),
    [anon_sym_LT_LT] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_CARET] = ACTIONS(2380),
    [anon_sym_PIPE] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_PERCENT] = ACTIONS(2380),
    [anon_sym_STAR_STAR] = ACTIONS(2380),
    [anon_sym_LT_EQ] = ACTIONS(2380),
    [anon_sym_EQ_EQ] = ACTIONS(2382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2380),
    [anon_sym_BANG_EQ] = ACTIONS(2382),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2380),
    [anon_sym_GT_EQ] = ACTIONS(2380),
    [anon_sym_instanceof] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2380),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2380),
  },
  [1624] = {
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_as] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1231),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_in] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_DOT] = ACTIONS(1229),
    [anon_sym_QMARK] = ACTIONS(1229),
    [anon_sym_AMP_AMP] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_GT_GT_GT] = ACTIONS(1229),
    [anon_sym_LT_LT] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_STAR_STAR] = ACTIONS(1229),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1231),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1231),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_instanceof] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1229),
  },
  [1625] = {
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1626] = {
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_as] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_COMMA] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2472),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_LT] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(2472),
    [anon_sym_SLASH] = ACTIONS(2472),
    [anon_sym_DOT] = ACTIONS(2470),
    [anon_sym_QMARK] = ACTIONS(2470),
    [anon_sym_AMP_AMP] = ACTIONS(2470),
    [anon_sym_PIPE_PIPE] = ACTIONS(2470),
    [anon_sym_GT_GT] = ACTIONS(2472),
    [anon_sym_GT_GT_GT] = ACTIONS(2470),
    [anon_sym_LT_LT] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_CARET] = ACTIONS(2470),
    [anon_sym_PIPE] = ACTIONS(2472),
    [anon_sym_PLUS] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2472),
    [anon_sym_PERCENT] = ACTIONS(2470),
    [anon_sym_STAR_STAR] = ACTIONS(2470),
    [anon_sym_LT_EQ] = ACTIONS(2470),
    [anon_sym_EQ_EQ] = ACTIONS(2472),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2470),
    [anon_sym_BANG_EQ] = ACTIONS(2472),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2470),
    [anon_sym_GT_EQ] = ACTIONS(2470),
    [anon_sym_instanceof] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2470),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2470),
  },
  [1627] = {
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_as] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_LT] = ACTIONS(2464),
    [anon_sym_GT] = ACTIONS(2464),
    [anon_sym_SLASH] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(2462),
    [anon_sym_QMARK] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [anon_sym_GT_GT] = ACTIONS(2464),
    [anon_sym_GT_GT_GT] = ACTIONS(2462),
    [anon_sym_LT_LT] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2464),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_STAR_STAR] = ACTIONS(2462),
    [anon_sym_LT_EQ] = ACTIONS(2462),
    [anon_sym_EQ_EQ] = ACTIONS(2464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2462),
    [anon_sym_BANG_EQ] = ACTIONS(2464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2462),
    [anon_sym_GT_EQ] = ACTIONS(2462),
    [anon_sym_instanceof] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2462),
  },
  [1628] = {
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_as] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_in] = ACTIONS(2448),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2448),
    [anon_sym_GT] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(2448),
    [anon_sym_DOT] = ACTIONS(2446),
    [anon_sym_QMARK] = ACTIONS(2446),
    [anon_sym_AMP_AMP] = ACTIONS(2446),
    [anon_sym_PIPE_PIPE] = ACTIONS(2446),
    [anon_sym_GT_GT] = ACTIONS(2448),
    [anon_sym_GT_GT_GT] = ACTIONS(2446),
    [anon_sym_LT_LT] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PERCENT] = ACTIONS(2446),
    [anon_sym_STAR_STAR] = ACTIONS(2446),
    [anon_sym_LT_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ] = ACTIONS(2448),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ] = ACTIONS(2448),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2446),
    [anon_sym_GT_EQ] = ACTIONS(2446),
    [anon_sym_instanceof] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2446),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2446),
  },
  [1629] = {
    [anon_sym_STAR] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(1071),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_RBRACK] = ACTIONS(2450),
    [anon_sym_LT] = ACTIONS(1071),
    [anon_sym_GT] = ACTIONS(1071),
    [anon_sym_SLASH] = ACTIONS(1071),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1071),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1071),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1071),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1073),
  },
  [1630] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4088),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4088),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4088),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1123),
  },
  [1631] = {
    [anon_sym_STAR] = ACTIONS(2414),
    [anon_sym_as] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_DOT] = ACTIONS(2412),
    [anon_sym_QMARK] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_PIPE_PIPE] = ACTIONS(2412),
    [anon_sym_GT_GT] = ACTIONS(2414),
    [anon_sym_GT_GT_GT] = ACTIONS(2412),
    [anon_sym_LT_LT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_CARET] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2412),
    [anon_sym_STAR_STAR] = ACTIONS(2412),
    [anon_sym_LT_EQ] = ACTIONS(2412),
    [anon_sym_EQ_EQ] = ACTIONS(2414),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2412),
    [anon_sym_BANG_EQ] = ACTIONS(2414),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2412),
    [anon_sym_GT_EQ] = ACTIONS(2412),
    [anon_sym_instanceof] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2412),
  },
  [1632] = {
    [anon_sym_STAR] = ACTIONS(1137),
    [anon_sym_as] = ACTIONS(1135),
    [anon_sym_LBRACE] = ACTIONS(1137),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_in] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_AMP_AMP] = ACTIONS(1135),
    [anon_sym_PIPE_PIPE] = ACTIONS(1135),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_GT_GT_GT] = ACTIONS(1135),
    [anon_sym_LT_LT] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1135),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1137),
    [anon_sym_DASH] = ACTIONS(1137),
    [anon_sym_PERCENT] = ACTIONS(1135),
    [anon_sym_STAR_STAR] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1135),
    [anon_sym_EQ_EQ] = ACTIONS(1137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1135),
    [anon_sym_BANG_EQ] = ACTIONS(1137),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1135),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_instanceof] = ACTIONS(1135),
    [anon_sym_BANG] = ACTIONS(1137),
    [anon_sym_PLUS_PLUS] = ACTIONS(1135),
    [anon_sym_DASH_DASH] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1135),
  },
  [1633] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1634] = {
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2428),
  },
  [1635] = {
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_as] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2458),
    [anon_sym_in] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_LT] = ACTIONS(2460),
    [anon_sym_GT] = ACTIONS(2460),
    [anon_sym_SLASH] = ACTIONS(2460),
    [anon_sym_DOT] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2458),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2458),
    [anon_sym_GT_GT] = ACTIONS(2460),
    [anon_sym_GT_GT_GT] = ACTIONS(2458),
    [anon_sym_LT_LT] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_CARET] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2460),
    [anon_sym_PLUS] = ACTIONS(2460),
    [anon_sym_DASH] = ACTIONS(2460),
    [anon_sym_PERCENT] = ACTIONS(2458),
    [anon_sym_STAR_STAR] = ACTIONS(2458),
    [anon_sym_LT_EQ] = ACTIONS(2458),
    [anon_sym_EQ_EQ] = ACTIONS(2460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2458),
    [anon_sym_BANG_EQ] = ACTIONS(2460),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2458),
    [anon_sym_GT_EQ] = ACTIONS(2458),
    [anon_sym_instanceof] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2458),
    [anon_sym_DASH_DASH] = ACTIONS(2458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2458),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2458),
  },
  [1636] = {
    [anon_sym_STAR] = ACTIONS(2476),
    [anon_sym_as] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_COMMA] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_LT] = ACTIONS(2476),
    [anon_sym_GT] = ACTIONS(2476),
    [anon_sym_SLASH] = ACTIONS(2476),
    [anon_sym_DOT] = ACTIONS(2474),
    [anon_sym_QMARK] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(2474),
    [anon_sym_PIPE_PIPE] = ACTIONS(2474),
    [anon_sym_GT_GT] = ACTIONS(2476),
    [anon_sym_GT_GT_GT] = ACTIONS(2474),
    [anon_sym_LT_LT] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_CARET] = ACTIONS(2474),
    [anon_sym_PIPE] = ACTIONS(2476),
    [anon_sym_PLUS] = ACTIONS(2476),
    [anon_sym_DASH] = ACTIONS(2476),
    [anon_sym_PERCENT] = ACTIONS(2474),
    [anon_sym_STAR_STAR] = ACTIONS(2474),
    [anon_sym_LT_EQ] = ACTIONS(2474),
    [anon_sym_EQ_EQ] = ACTIONS(2476),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2474),
    [anon_sym_BANG_EQ] = ACTIONS(2476),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2474),
    [anon_sym_GT_EQ] = ACTIONS(2474),
    [anon_sym_instanceof] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2474),
    [anon_sym_DASH_DASH] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2474),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2474),
  },
  [1637] = {
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_as] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_in] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1239),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1237),
  },
  [1638] = {
    [anon_sym_STAR] = ACTIONS(1173),
    [anon_sym_as] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1173),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1171),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_PIPE_PIPE] = ACTIONS(1171),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1171),
    [anon_sym_STAR_STAR] = ACTIONS(1171),
    [anon_sym_LT_EQ] = ACTIONS(1171),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1171),
    [anon_sym_GT_EQ] = ACTIONS(1171),
    [anon_sym_instanceof] = ACTIONS(1171),
    [anon_sym_BANG] = ACTIONS(1173),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1171),
  },
  [1639] = {
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_as] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1187),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_in] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_AMP_AMP] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_GT_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1187),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_instanceof] = ACTIONS(1185),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1185),
  },
  [1640] = {
    [anon_sym_STAR] = ACTIONS(3967),
    [anon_sym_as] = ACTIONS(3969),
    [anon_sym_LBRACE] = ACTIONS(3967),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [anon_sym_in] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [anon_sym_LT] = ACTIONS(3967),
    [anon_sym_GT] = ACTIONS(3967),
    [anon_sym_SLASH] = ACTIONS(3967),
    [anon_sym_DOT] = ACTIONS(3969),
    [anon_sym_QMARK] = ACTIONS(3969),
    [anon_sym_AMP_AMP] = ACTIONS(3969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3969),
    [anon_sym_GT_GT] = ACTIONS(3967),
    [anon_sym_GT_GT_GT] = ACTIONS(3969),
    [anon_sym_LT_LT] = ACTIONS(3969),
    [anon_sym_AMP] = ACTIONS(3967),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_PIPE] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_PERCENT] = ACTIONS(3969),
    [anon_sym_STAR_STAR] = ACTIONS(3969),
    [anon_sym_LT_EQ] = ACTIONS(3969),
    [anon_sym_EQ_EQ] = ACTIONS(3967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3969),
    [anon_sym_BANG_EQ] = ACTIONS(3967),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3969),
    [anon_sym_GT_EQ] = ACTIONS(3969),
    [anon_sym_instanceof] = ACTIONS(3969),
    [anon_sym_BANG] = ACTIONS(3967),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3969),
  },
  [1641] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1642] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
  },
  [1643] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1644] = {
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1645] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4088),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4088),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4088),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1646] = {
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_LBRACE] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_in] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_LT] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_AMP_AMP] = ACTIONS(1147),
    [anon_sym_PIPE_PIPE] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(1145),
    [anon_sym_GT_GT_GT] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_PERCENT] = ACTIONS(1147),
    [anon_sym_STAR_STAR] = ACTIONS(1147),
    [anon_sym_LT_EQ] = ACTIONS(1147),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1147),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1147),
    [anon_sym_GT_EQ] = ACTIONS(1147),
    [anon_sym_instanceof] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_PLUS_PLUS] = ACTIONS(1147),
    [anon_sym_DASH_DASH] = ACTIONS(1147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1147),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1147),
  },
  [1647] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(4079),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(4082),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1648] = {
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_as] = ACTIONS(2580),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_GT_GT] = ACTIONS(2582),
    [anon_sym_GT_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(4694),
    [anon_sym_CARET] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(4696),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2582),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2580),
    [anon_sym_LT_EQ] = ACTIONS(2580),
    [anon_sym_EQ_EQ] = ACTIONS(2582),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2580),
    [anon_sym_BANG_EQ] = ACTIONS(2582),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2580),
    [anon_sym_GT_EQ] = ACTIONS(2580),
    [anon_sym_instanceof] = ACTIONS(2580),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2580),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2580),
  },
  [1649] = {
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_as] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_COMMA] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2348),
    [anon_sym_in] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_GT] = ACTIONS(2350),
    [anon_sym_SLASH] = ACTIONS(2350),
    [anon_sym_DOT] = ACTIONS(2348),
    [anon_sym_QMARK] = ACTIONS(2348),
    [anon_sym_AMP_AMP] = ACTIONS(2348),
    [anon_sym_PIPE_PIPE] = ACTIONS(2348),
    [anon_sym_GT_GT] = ACTIONS(2350),
    [anon_sym_GT_GT_GT] = ACTIONS(2348),
    [anon_sym_LT_LT] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_CARET] = ACTIONS(2348),
    [anon_sym_PIPE] = ACTIONS(2350),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_PERCENT] = ACTIONS(2348),
    [anon_sym_STAR_STAR] = ACTIONS(2348),
    [anon_sym_LT_EQ] = ACTIONS(2348),
    [anon_sym_EQ_EQ] = ACTIONS(2350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2348),
    [anon_sym_BANG_EQ] = ACTIONS(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2348),
    [anon_sym_GT_EQ] = ACTIONS(2348),
    [anon_sym_instanceof] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2348),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2348),
  },
  [1650] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3645),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1651] = {
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_as] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_GT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2390),
    [anon_sym_DOT] = ACTIONS(2388),
    [anon_sym_QMARK] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_PIPE_PIPE] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2390),
    [anon_sym_GT_GT_GT] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_CARET] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PERCENT] = ACTIONS(2388),
    [anon_sym_STAR_STAR] = ACTIONS(2388),
    [anon_sym_LT_EQ] = ACTIONS(2388),
    [anon_sym_EQ_EQ] = ACTIONS(2390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2388),
    [anon_sym_BANG_EQ] = ACTIONS(2390),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2388),
    [anon_sym_GT_EQ] = ACTIONS(2388),
    [anon_sym_instanceof] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2388),
  },
  [1652] = {
    [anon_sym_STAR] = ACTIONS(3772),
    [anon_sym_as] = ACTIONS(3774),
    [anon_sym_LBRACE] = ACTIONS(3772),
    [anon_sym_COMMA] = ACTIONS(3774),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_in] = ACTIONS(3772),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_LT] = ACTIONS(3772),
    [anon_sym_GT] = ACTIONS(3772),
    [anon_sym_SLASH] = ACTIONS(3772),
    [anon_sym_DOT] = ACTIONS(3774),
    [anon_sym_QMARK] = ACTIONS(3774),
    [anon_sym_AMP_AMP] = ACTIONS(3774),
    [anon_sym_PIPE_PIPE] = ACTIONS(3774),
    [anon_sym_GT_GT] = ACTIONS(3772),
    [anon_sym_GT_GT_GT] = ACTIONS(3774),
    [anon_sym_LT_LT] = ACTIONS(3774),
    [anon_sym_AMP] = ACTIONS(3772),
    [anon_sym_CARET] = ACTIONS(3774),
    [anon_sym_PIPE] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_PERCENT] = ACTIONS(3774),
    [anon_sym_STAR_STAR] = ACTIONS(3774),
    [anon_sym_LT_EQ] = ACTIONS(3774),
    [anon_sym_EQ_EQ] = ACTIONS(3772),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(3772),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3774),
    [anon_sym_GT_EQ] = ACTIONS(3774),
    [anon_sym_instanceof] = ACTIONS(3774),
    [anon_sym_BANG] = ACTIONS(3772),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3774),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3774),
  },
  [1653] = {
    [anon_sym_STAR] = ACTIONS(4131),
    [anon_sym_as] = ACTIONS(3749),
    [anon_sym_LBRACE] = ACTIONS(4131),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3749),
    [anon_sym_in] = ACTIONS(4131),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_LT] = ACTIONS(4131),
    [anon_sym_GT] = ACTIONS(4131),
    [anon_sym_SLASH] = ACTIONS(4131),
    [anon_sym_DOT] = ACTIONS(3749),
    [anon_sym_QMARK] = ACTIONS(3749),
    [anon_sym_AMP_AMP] = ACTIONS(3749),
    [anon_sym_PIPE_PIPE] = ACTIONS(3749),
    [anon_sym_GT_GT] = ACTIONS(4131),
    [anon_sym_GT_GT_GT] = ACTIONS(3749),
    [anon_sym_LT_LT] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(4131),
    [anon_sym_CARET] = ACTIONS(3749),
    [anon_sym_PIPE] = ACTIONS(4131),
    [anon_sym_PLUS] = ACTIONS(4131),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_PERCENT] = ACTIONS(3749),
    [anon_sym_STAR_STAR] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(3749),
    [anon_sym_EQ_EQ] = ACTIONS(4131),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3749),
    [anon_sym_BANG_EQ] = ACTIONS(4131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3749),
    [anon_sym_GT_EQ] = ACTIONS(3749),
    [anon_sym_instanceof] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(4131),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3749),
  },
  [1654] = {
    [anon_sym_STAR] = ACTIONS(3894),
    [anon_sym_as] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(3894),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3788),
    [anon_sym_in] = ACTIONS(3894),
    [anon_sym_LBRACK] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3894),
    [anon_sym_GT] = ACTIONS(3894),
    [anon_sym_SLASH] = ACTIONS(3894),
    [anon_sym_DOT] = ACTIONS(3788),
    [anon_sym_QMARK] = ACTIONS(3788),
    [anon_sym_AMP_AMP] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3788),
    [anon_sym_GT_GT] = ACTIONS(3894),
    [anon_sym_GT_GT_GT] = ACTIONS(3788),
    [anon_sym_LT_LT] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3894),
    [anon_sym_CARET] = ACTIONS(3788),
    [anon_sym_PIPE] = ACTIONS(3894),
    [anon_sym_PLUS] = ACTIONS(3894),
    [anon_sym_DASH] = ACTIONS(3894),
    [anon_sym_PERCENT] = ACTIONS(3788),
    [anon_sym_STAR_STAR] = ACTIONS(3788),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_EQ_EQ] = ACTIONS(3894),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3788),
    [anon_sym_BANG_EQ] = ACTIONS(3894),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3788),
    [anon_sym_instanceof] = ACTIONS(3788),
    [anon_sym_BANG] = ACTIONS(3894),
    [anon_sym_PLUS_PLUS] = ACTIONS(3788),
    [anon_sym_DASH_DASH] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3788),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3788),
  },
  [1655] = {
    [anon_sym_STAR] = ACTIONS(3939),
    [anon_sym_as] = ACTIONS(3941),
    [anon_sym_LBRACE] = ACTIONS(3939),
    [anon_sym_COMMA] = ACTIONS(3941),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_in] = ACTIONS(3939),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [anon_sym_LT] = ACTIONS(3939),
    [anon_sym_GT] = ACTIONS(3939),
    [anon_sym_SLASH] = ACTIONS(3939),
    [anon_sym_DOT] = ACTIONS(3941),
    [anon_sym_QMARK] = ACTIONS(3941),
    [anon_sym_AMP_AMP] = ACTIONS(3941),
    [anon_sym_PIPE_PIPE] = ACTIONS(3941),
    [anon_sym_GT_GT] = ACTIONS(3939),
    [anon_sym_GT_GT_GT] = ACTIONS(3941),
    [anon_sym_LT_LT] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(3939),
    [anon_sym_CARET] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(3939),
    [anon_sym_PLUS] = ACTIONS(3939),
    [anon_sym_DASH] = ACTIONS(3939),
    [anon_sym_PERCENT] = ACTIONS(3941),
    [anon_sym_STAR_STAR] = ACTIONS(3941),
    [anon_sym_LT_EQ] = ACTIONS(3941),
    [anon_sym_EQ_EQ] = ACTIONS(3939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3941),
    [anon_sym_BANG_EQ] = ACTIONS(3939),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3941),
    [anon_sym_GT_EQ] = ACTIONS(3941),
    [anon_sym_instanceof] = ACTIONS(3941),
    [anon_sym_BANG] = ACTIONS(3939),
    [anon_sym_PLUS_PLUS] = ACTIONS(3941),
    [anon_sym_DASH_DASH] = ACTIONS(3941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3941),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3941),
  },
  [1656] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3647),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_RBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1657] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4710),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1658] = {
    [anon_sym_STAR] = ACTIONS(3915),
    [anon_sym_as] = ACTIONS(3917),
    [anon_sym_LBRACE] = ACTIONS(3915),
    [anon_sym_COMMA] = ACTIONS(3917),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_in] = ACTIONS(3915),
    [anon_sym_LBRACK] = ACTIONS(3917),
    [anon_sym_LT] = ACTIONS(3915),
    [anon_sym_GT] = ACTIONS(3915),
    [anon_sym_SLASH] = ACTIONS(3915),
    [anon_sym_DOT] = ACTIONS(3917),
    [anon_sym_QMARK] = ACTIONS(3917),
    [anon_sym_AMP_AMP] = ACTIONS(3917),
    [anon_sym_PIPE_PIPE] = ACTIONS(3917),
    [anon_sym_GT_GT] = ACTIONS(3915),
    [anon_sym_GT_GT_GT] = ACTIONS(3917),
    [anon_sym_LT_LT] = ACTIONS(3917),
    [anon_sym_AMP] = ACTIONS(3915),
    [anon_sym_CARET] = ACTIONS(3917),
    [anon_sym_PIPE] = ACTIONS(3915),
    [anon_sym_PLUS] = ACTIONS(3915),
    [anon_sym_DASH] = ACTIONS(3915),
    [anon_sym_PERCENT] = ACTIONS(3917),
    [anon_sym_STAR_STAR] = ACTIONS(3917),
    [anon_sym_LT_EQ] = ACTIONS(3917),
    [anon_sym_EQ_EQ] = ACTIONS(3915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3917),
    [anon_sym_BANG_EQ] = ACTIONS(3915),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3917),
    [anon_sym_GT_EQ] = ACTIONS(3917),
    [anon_sym_instanceof] = ACTIONS(3917),
    [anon_sym_BANG] = ACTIONS(3915),
    [anon_sym_PLUS_PLUS] = ACTIONS(3917),
    [anon_sym_DASH_DASH] = ACTIONS(3917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3917),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3917),
  },
  [1659] = {
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_as] = ACTIONS(3929),
    [anon_sym_LBRACE] = ACTIONS(3927),
    [anon_sym_COMMA] = ACTIONS(3929),
    [anon_sym_LPAREN] = ACTIONS(3929),
    [anon_sym_in] = ACTIONS(3927),
    [anon_sym_LBRACK] = ACTIONS(3929),
    [anon_sym_LT] = ACTIONS(3927),
    [anon_sym_GT] = ACTIONS(3927),
    [anon_sym_SLASH] = ACTIONS(3927),
    [anon_sym_DOT] = ACTIONS(3929),
    [anon_sym_QMARK] = ACTIONS(3929),
    [anon_sym_AMP_AMP] = ACTIONS(3929),
    [anon_sym_PIPE_PIPE] = ACTIONS(3929),
    [anon_sym_GT_GT] = ACTIONS(3927),
    [anon_sym_GT_GT_GT] = ACTIONS(3929),
    [anon_sym_LT_LT] = ACTIONS(3929),
    [anon_sym_AMP] = ACTIONS(3927),
    [anon_sym_CARET] = ACTIONS(3929),
    [anon_sym_PIPE] = ACTIONS(3927),
    [anon_sym_PLUS] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3929),
    [anon_sym_STAR_STAR] = ACTIONS(3929),
    [anon_sym_LT_EQ] = ACTIONS(3929),
    [anon_sym_EQ_EQ] = ACTIONS(3927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3929),
    [anon_sym_BANG_EQ] = ACTIONS(3927),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3929),
    [anon_sym_GT_EQ] = ACTIONS(3929),
    [anon_sym_instanceof] = ACTIONS(3929),
    [anon_sym_BANG] = ACTIONS(3927),
    [anon_sym_PLUS_PLUS] = ACTIONS(3929),
    [anon_sym_DASH_DASH] = ACTIONS(3929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3929),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3929),
  },
  [1660] = {
    [sym_template_string] = STATE(1048),
    [sym_arguments] = STATE(1048),
    [sym_type_arguments] = STATE(2361),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(3624),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(3314),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [1661] = {
    [anon_sym_STAR] = ACTIONS(3919),
    [anon_sym_as] = ACTIONS(3921),
    [anon_sym_LBRACE] = ACTIONS(3919),
    [anon_sym_COMMA] = ACTIONS(3921),
    [anon_sym_LPAREN] = ACTIONS(3921),
    [anon_sym_in] = ACTIONS(3919),
    [anon_sym_LBRACK] = ACTIONS(3921),
    [anon_sym_LT] = ACTIONS(3919),
    [anon_sym_GT] = ACTIONS(3919),
    [anon_sym_SLASH] = ACTIONS(3919),
    [anon_sym_DOT] = ACTIONS(3921),
    [anon_sym_QMARK] = ACTIONS(3921),
    [anon_sym_AMP_AMP] = ACTIONS(3921),
    [anon_sym_PIPE_PIPE] = ACTIONS(3921),
    [anon_sym_GT_GT] = ACTIONS(3919),
    [anon_sym_GT_GT_GT] = ACTIONS(3921),
    [anon_sym_LT_LT] = ACTIONS(3921),
    [anon_sym_AMP] = ACTIONS(3919),
    [anon_sym_CARET] = ACTIONS(3921),
    [anon_sym_PIPE] = ACTIONS(3919),
    [anon_sym_PLUS] = ACTIONS(3919),
    [anon_sym_DASH] = ACTIONS(3919),
    [anon_sym_PERCENT] = ACTIONS(3921),
    [anon_sym_STAR_STAR] = ACTIONS(3921),
    [anon_sym_LT_EQ] = ACTIONS(3921),
    [anon_sym_EQ_EQ] = ACTIONS(3919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3921),
    [anon_sym_BANG_EQ] = ACTIONS(3919),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3921),
    [anon_sym_GT_EQ] = ACTIONS(3921),
    [anon_sym_instanceof] = ACTIONS(3921),
    [anon_sym_BANG] = ACTIONS(3919),
    [anon_sym_PLUS_PLUS] = ACTIONS(3921),
    [anon_sym_DASH_DASH] = ACTIONS(3921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3921),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3921),
  },
  [1662] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(4712),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [sym__automatic_semicolon] = ACTIONS(1123),
  },
  [1663] = {
    [anon_sym_STAR] = ACTIONS(2564),
    [anon_sym_as] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_GT] = ACTIONS(2564),
    [anon_sym_SLASH] = ACTIONS(2564),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_GT_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(4694),
    [anon_sym_CARET] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(4696),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_DASH] = ACTIONS(2564),
    [anon_sym_PERCENT] = ACTIONS(2562),
    [anon_sym_STAR_STAR] = ACTIONS(2562),
    [anon_sym_LT_EQ] = ACTIONS(2562),
    [anon_sym_EQ_EQ] = ACTIONS(2564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2562),
    [anon_sym_BANG_EQ] = ACTIONS(2564),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2562),
    [anon_sym_GT_EQ] = ACTIONS(2562),
    [anon_sym_instanceof] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2564),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2562),
  },
  [1664] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [anon_sym_RBRACK] = ACTIONS(4085),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4088),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4088),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1665] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2447),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4706),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1666] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1667] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2461),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2461),
    [sym_optional_parameter] = STATE(2461),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1691),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(777),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1668] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3645),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3809),
    [anon_sym_of] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1669] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2755),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2755),
    [sym_optional_parameter] = STATE(2755),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1696),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(4718),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1670] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2537),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2537),
    [sym_optional_parameter] = STATE(2537),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_class] = ACTIONS(4720),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1671] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3647),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_of] = ACTIONS(3803),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1672] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(4079),
    [anon_sym_RBRACK] = ACTIONS(4079),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(4082),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(4082),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1673] = {
    [sym_arguments] = STATE(1709),
    [sym_identifier] = ACTIONS(4722),
    [anon_sym_export] = ACTIONS(4722),
    [anon_sym_STAR] = ACTIONS(4724),
    [anon_sym_namespace] = ACTIONS(4722),
    [anon_sym_LBRACE] = ACTIONS(4724),
    [anon_sym_RBRACE] = ACTIONS(4724),
    [anon_sym_type] = ACTIONS(4722),
    [anon_sym_LPAREN] = ACTIONS(4726),
    [anon_sym_LBRACK] = ACTIONS(4724),
    [anon_sym_DOT] = ACTIONS(4728),
    [anon_sym_class] = ACTIONS(4722),
    [anon_sym_async] = ACTIONS(4722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4724),
    [anon_sym_void] = ACTIONS(4722),
    [anon_sym_DQUOTE] = ACTIONS(4724),
    [anon_sym_SQUOTE] = ACTIONS(4724),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4724),
    [sym_this] = ACTIONS(4722),
    [anon_sym_AT] = ACTIONS(4724),
    [anon_sym_static] = ACTIONS(4722),
    [anon_sym_abstract] = ACTIONS(4722),
    [anon_sym_get] = ACTIONS(4722),
    [anon_sym_set] = ACTIONS(4722),
    [anon_sym_declare] = ACTIONS(4722),
    [anon_sym_public] = ACTIONS(4722),
    [anon_sym_private] = ACTIONS(4722),
    [anon_sym_protected] = ACTIONS(4722),
    [anon_sym_module] = ACTIONS(4722),
    [anon_sym_any] = ACTIONS(4722),
    [anon_sym_number] = ACTIONS(4722),
    [anon_sym_boolean] = ACTIONS(4722),
    [anon_sym_string] = ACTIONS(4722),
    [anon_sym_symbol] = ACTIONS(4722),
    [sym_readonly] = ACTIONS(4722),
  },
  [1674] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2755),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2755),
    [sym_optional_parameter] = STATE(2755),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1696),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(4730),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1675] = {
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1676] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3647),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(4502),
    [anon_sym_of] = ACTIONS(4505),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1677] = {
    [sym_arguments] = STATE(1713),
    [sym_identifier] = ACTIONS(4732),
    [anon_sym_export] = ACTIONS(4732),
    [anon_sym_STAR] = ACTIONS(4734),
    [anon_sym_namespace] = ACTIONS(4732),
    [anon_sym_LBRACE] = ACTIONS(4734),
    [anon_sym_RBRACE] = ACTIONS(4734),
    [anon_sym_type] = ACTIONS(4732),
    [anon_sym_LPAREN] = ACTIONS(4726),
    [anon_sym_LBRACK] = ACTIONS(4734),
    [anon_sym_DOT] = ACTIONS(4736),
    [anon_sym_class] = ACTIONS(4732),
    [anon_sym_async] = ACTIONS(4732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4734),
    [anon_sym_void] = ACTIONS(4732),
    [anon_sym_DQUOTE] = ACTIONS(4734),
    [anon_sym_SQUOTE] = ACTIONS(4734),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4734),
    [sym_this] = ACTIONS(4732),
    [anon_sym_AT] = ACTIONS(4734),
    [anon_sym_static] = ACTIONS(4732),
    [anon_sym_abstract] = ACTIONS(4732),
    [anon_sym_get] = ACTIONS(4732),
    [anon_sym_set] = ACTIONS(4732),
    [anon_sym_declare] = ACTIONS(4732),
    [anon_sym_public] = ACTIONS(4732),
    [anon_sym_private] = ACTIONS(4732),
    [anon_sym_protected] = ACTIONS(4732),
    [anon_sym_module] = ACTIONS(4732),
    [anon_sym_any] = ACTIONS(4732),
    [anon_sym_number] = ACTIONS(4732),
    [anon_sym_boolean] = ACTIONS(4732),
    [anon_sym_string] = ACTIONS(4732),
    [anon_sym_symbol] = ACTIONS(4732),
    [sym_readonly] = ACTIONS(4732),
  },
  [1678] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2755),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2755),
    [sym_optional_parameter] = STATE(2755),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1696),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(4738),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1679] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(3645),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(4377),
    [anon_sym_of] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1121),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1680] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2755),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2755),
    [sym_optional_parameter] = STATE(2755),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1696),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(4740),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1681] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_as] = ACTIONS(1123),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(1123),
    [anon_sym_in] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_LT] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_DOT] = ACTIONS(1123),
    [anon_sym_QMARK] = ACTIONS(1123),
    [anon_sym_AMP_AMP] = ACTIONS(1123),
    [anon_sym_PIPE_PIPE] = ACTIONS(1123),
    [anon_sym_GT_GT] = ACTIONS(1121),
    [anon_sym_GT_GT_GT] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_PLUS] = ACTIONS(1121),
    [anon_sym_DASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_STAR_STAR] = ACTIONS(1123),
    [anon_sym_LT_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1123),
    [anon_sym_GT_EQ] = ACTIONS(1123),
    [anon_sym_instanceof] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1123),
  },
  [1682] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(4742),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1683] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2755),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2755),
    [sym_optional_parameter] = STATE(2755),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1696),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(4744),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1684] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1685] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(4742),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
  },
  [1686] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2755),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2755),
    [sym_optional_parameter] = STATE(2755),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1696),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(4746),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1687] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1688] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2403),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2403),
    [sym_optional_parameter] = STATE(2403),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1697),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(4748),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1689] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(4742),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1690] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1691] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2537),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2537),
    [sym_optional_parameter] = STATE(2537),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1692] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(4742),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1693] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2755),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2755),
    [sym_optional_parameter] = STATE(2755),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1696),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1694] = {
    [sym_identifier] = ACTIONS(4750),
    [anon_sym_export] = ACTIONS(4750),
    [anon_sym_STAR] = ACTIONS(4752),
    [anon_sym_namespace] = ACTIONS(4750),
    [anon_sym_LBRACE] = ACTIONS(4752),
    [anon_sym_RBRACE] = ACTIONS(4752),
    [anon_sym_type] = ACTIONS(4750),
    [anon_sym_LPAREN] = ACTIONS(4752),
    [anon_sym_LBRACK] = ACTIONS(4752),
    [anon_sym_DOT] = ACTIONS(4750),
    [anon_sym_class] = ACTIONS(4750),
    [anon_sym_async] = ACTIONS(4750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4752),
    [anon_sym_void] = ACTIONS(4750),
    [anon_sym_DQUOTE] = ACTIONS(4752),
    [anon_sym_SQUOTE] = ACTIONS(4752),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4752),
    [sym_this] = ACTIONS(4750),
    [anon_sym_AT] = ACTIONS(4752),
    [anon_sym_static] = ACTIONS(4750),
    [anon_sym_abstract] = ACTIONS(4750),
    [anon_sym_get] = ACTIONS(4750),
    [anon_sym_set] = ACTIONS(4750),
    [anon_sym_declare] = ACTIONS(4750),
    [anon_sym_public] = ACTIONS(4750),
    [anon_sym_private] = ACTIONS(4750),
    [anon_sym_protected] = ACTIONS(4750),
    [anon_sym_module] = ACTIONS(4750),
    [anon_sym_any] = ACTIONS(4750),
    [anon_sym_number] = ACTIONS(4750),
    [anon_sym_boolean] = ACTIONS(4750),
    [anon_sym_string] = ACTIONS(4750),
    [anon_sym_symbol] = ACTIONS(4750),
    [sym_readonly] = ACTIONS(4750),
  },
  [1695] = {
    [sym_identifier] = ACTIONS(4754),
    [anon_sym_export] = ACTIONS(4754),
    [anon_sym_STAR] = ACTIONS(4756),
    [anon_sym_namespace] = ACTIONS(4754),
    [anon_sym_LBRACE] = ACTIONS(4756),
    [anon_sym_RBRACE] = ACTIONS(4756),
    [anon_sym_type] = ACTIONS(4754),
    [anon_sym_LPAREN] = ACTIONS(4756),
    [anon_sym_LBRACK] = ACTIONS(4756),
    [anon_sym_DOT] = ACTIONS(4754),
    [anon_sym_class] = ACTIONS(4754),
    [anon_sym_async] = ACTIONS(4754),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4756),
    [anon_sym_void] = ACTIONS(4754),
    [anon_sym_DQUOTE] = ACTIONS(4756),
    [anon_sym_SQUOTE] = ACTIONS(4756),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4756),
    [sym_this] = ACTIONS(4754),
    [anon_sym_AT] = ACTIONS(4756),
    [anon_sym_static] = ACTIONS(4754),
    [anon_sym_abstract] = ACTIONS(4754),
    [anon_sym_get] = ACTIONS(4754),
    [anon_sym_set] = ACTIONS(4754),
    [anon_sym_declare] = ACTIONS(4754),
    [anon_sym_public] = ACTIONS(4754),
    [anon_sym_private] = ACTIONS(4754),
    [anon_sym_protected] = ACTIONS(4754),
    [anon_sym_module] = ACTIONS(4754),
    [anon_sym_any] = ACTIONS(4754),
    [anon_sym_number] = ACTIONS(4754),
    [anon_sym_boolean] = ACTIONS(4754),
    [anon_sym_string] = ACTIONS(4754),
    [anon_sym_symbol] = ACTIONS(4754),
    [sym_readonly] = ACTIONS(4754),
  },
  [1696] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2661),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2661),
    [sym_optional_parameter] = STATE(2661),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1697] = {
    [sym_object] = STATE(2271),
    [sym_array] = STATE(2269),
    [sym_decorator] = STATE(1798),
    [sym_rest_parameter] = STATE(2457),
    [sym_accessibility_modifier] = STATE(1799),
    [sym_required_parameter] = STATE(2457),
    [sym_optional_parameter] = STATE(2457),
    [sym__parameter_name] = STATE(1947),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [sym_identifier] = ACTIONS(4714),
    [anon_sym_export] = ACTIONS(2515),
    [anon_sym_namespace] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2515),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(785),
    [anon_sym_void] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4714),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_static] = ACTIONS(2515),
    [anon_sym_get] = ACTIONS(2515),
    [anon_sym_set] = ACTIONS(2515),
    [anon_sym_declare] = ACTIONS(2515),
    [anon_sym_public] = ACTIONS(2539),
    [anon_sym_private] = ACTIONS(2539),
    [anon_sym_protected] = ACTIONS(2539),
    [anon_sym_module] = ACTIONS(2515),
    [anon_sym_any] = ACTIONS(2515),
    [anon_sym_number] = ACTIONS(2515),
    [anon_sym_boolean] = ACTIONS(2515),
    [anon_sym_string] = ACTIONS(2515),
    [anon_sym_symbol] = ACTIONS(2515),
    [sym_readonly] = ACTIONS(2541),
  },
  [1698] = {
    [sym__declaration] = STATE(514),
    [sym_variable_declaration] = STATE(514),
    [sym_lexical_declaration] = STATE(514),
    [sym_class_declaration] = STATE(514),
    [sym_function_declaration] = STATE(514),
    [sym_generator_function_declaration] = STATE(514),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(514),
    [sym_ambient_declaration] = STATE(514),
    [sym_abstract_class_declaration] = STATE(514),
    [sym_module] = STATE(514),
    [sym_internal_module] = STATE(514),
    [sym_import_alias] = STATE(514),
    [sym_interface_declaration] = STATE(514),
    [sym_enum_declaration] = STATE(514),
    [sym_type_alias_declaration] = STATE(514),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1542),
    [anon_sym_global] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
  },
  [1699] = {
    [aux_sym_object_repeat1] = STATE(2538),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
  },
  [1700] = {
    [aux_sym_object_repeat1] = STATE(2507),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
  },
  [1701] = {
    [aux_sym_object_repeat1] = STATE(2556),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
  },
  [1702] = {
    [sym__declaration] = STATE(2134),
    [sym_variable_declaration] = STATE(2134),
    [sym_lexical_declaration] = STATE(2134),
    [sym_class_declaration] = STATE(2134),
    [sym_function_declaration] = STATE(2134),
    [sym_generator_function_declaration] = STATE(2134),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(2134),
    [sym_ambient_declaration] = STATE(2134),
    [sym_abstract_class_declaration] = STATE(2134),
    [sym_module] = STATE(2134),
    [sym_internal_module] = STATE(2134),
    [sym_import_alias] = STATE(2134),
    [sym_interface_declaration] = STATE(2134),
    [sym_enum_declaration] = STATE(2134),
    [sym_type_alias_declaration] = STATE(2134),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_function] = ACTIONS(3553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_declare] = ACTIONS(3557),
    [anon_sym_module] = ACTIONS(4758),
    [anon_sym_global] = ACTIONS(4760),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3563),
  },
  [1703] = {
    [aux_sym_object_repeat1] = STATE(2396),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
  },
  [1704] = {
    [sym__declaration] = STATE(514),
    [sym_variable_declaration] = STATE(514),
    [sym_lexical_declaration] = STATE(514),
    [sym_class_declaration] = STATE(514),
    [sym_function_declaration] = STATE(514),
    [sym_generator_function_declaration] = STATE(514),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(514),
    [sym_ambient_declaration] = STATE(514),
    [sym_abstract_class_declaration] = STATE(514),
    [sym_module] = STATE(514),
    [sym_internal_module] = STATE(514),
    [sym_import_alias] = STATE(514),
    [sym_interface_declaration] = STATE(514),
    [sym_enum_declaration] = STATE(514),
    [sym_type_alias_declaration] = STATE(514),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1668),
    [anon_sym_module] = ACTIONS(2336),
    [anon_sym_global] = ACTIONS(1544),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
  },
  [1705] = {
    [sym__declaration] = STATE(590),
    [sym_variable_declaration] = STATE(590),
    [sym_lexical_declaration] = STATE(590),
    [sym_class_declaration] = STATE(590),
    [sym_function_declaration] = STATE(590),
    [sym_generator_function_declaration] = STATE(590),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(590),
    [sym_ambient_declaration] = STATE(590),
    [sym_abstract_class_declaration] = STATE(590),
    [sym_module] = STATE(590),
    [sym_internal_module] = STATE(590),
    [sym_import_alias] = STATE(590),
    [sym_interface_declaration] = STATE(590),
    [sym_enum_declaration] = STATE(590),
    [sym_type_alias_declaration] = STATE(590),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [anon_sym_default] = ACTIONS(4762),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1668),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
  },
  [1706] = {
    [sym__declaration] = STATE(590),
    [sym_variable_declaration] = STATE(590),
    [sym_lexical_declaration] = STATE(590),
    [sym_class_declaration] = STATE(590),
    [sym_function_declaration] = STATE(590),
    [sym_generator_function_declaration] = STATE(590),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(590),
    [sym_ambient_declaration] = STATE(590),
    [sym_abstract_class_declaration] = STATE(590),
    [sym_module] = STATE(590),
    [sym_internal_module] = STATE(590),
    [sym_import_alias] = STATE(590),
    [sym_interface_declaration] = STATE(590),
    [sym_enum_declaration] = STATE(590),
    [sym_type_alias_declaration] = STATE(590),
    [aux_sym_export_statement_repeat1] = STATE(2307),
    [anon_sym_default] = ACTIONS(4762),
    [anon_sym_namespace] = ACTIONS(1357),
    [anon_sym_type] = ACTIONS(1361),
    [anon_sym_import] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1365),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(1376),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_function] = ACTIONS(1380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(1382),
    [anon_sym_declare] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1386),
    [anon_sym_interface] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1390),
  },
  [1707] = {
    [aux_sym_object_repeat1] = STATE(2447),
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4706),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
  },
  [1708] = {
    [sym__declaration] = STATE(2183),
    [sym_variable_declaration] = STATE(2183),
    [sym_lexical_declaration] = STATE(2183),
    [sym_class_declaration] = STATE(2183),
    [sym_function_declaration] = STATE(2183),
    [sym_generator_function_declaration] = STATE(2183),
    [sym_decorator] = STATE(1798),
    [sym_function_signature] = STATE(2183),
    [sym_ambient_declaration] = STATE(2183),
    [sym_abstract_class_declaration] = STATE(2183),
    [sym_module] = STATE(2183),
    [sym_internal_module] = STATE(2183),
    [sym_import_alias] = STATE(2183),
    [sym_interface_declaration] = STATE(2183),
    [sym_enum_declaration] = STATE(2183),
    [sym_type_alias_declaration] = STATE(2183),
    [aux_sym_export_statement_repeat1] = STATE(2312),
    [anon_sym_default] = ACTIONS(4764),
    [anon_sym_namespace] = ACTIONS(3535),
    [anon_sym_type] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3543),
    [anon_sym_let] = ACTIONS(3545),
    [anon_sym_const] = ACTIONS(3547),
    [anon_sym_class] = ACTIONS(3549),
    [anon_sym_async] = ACTIONS(3551),
    [anon_sym_function] = ACTIONS(3553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
    [anon_sym_abstract] = ACTIONS(3555),
    [anon_sym_declare] = ACTIONS(3557),
    [anon_sym_module] = ACTIONS(3559),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3563),
  },
  [1709] = {
    [sym_identifier] = ACTIONS(4766),
    [anon_sym_export] = ACTIONS(4766),
    [anon_sym_STAR] = ACTIONS(4768),
    [anon_sym_namespace] = ACTIONS(4766),
    [anon_sym_LBRACE] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_type] = ACTIONS(4766),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_class] = ACTIONS(4766),
    [anon_sym_async] = ACTIONS(4766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4768),
    [anon_sym_void] = ACTIONS(4766),
    [anon_sym_DQUOTE] = ACTIONS(4768),
    [anon_sym_SQUOTE] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4768),
    [sym_this] = ACTIONS(4766),
    [anon_sym_AT] = ACTIONS(4768),
    [anon_sym_static] = ACTIONS(4766),
    [anon_sym_abstract] = ACTIONS(4766),
    [anon_sym_get] = ACTIONS(4766),
    [anon_sym_set] = ACTIONS(4766),
    [anon_sym_declare] = ACTIONS(4766),
    [anon_sym_public] = ACTIONS(4766),
    [anon_sym_private] = ACTIONS(4766),
    [anon_sym_protected] = ACTIONS(4766),
    [anon_sym_module] = ACTIONS(4766),
    [anon_sym_any] = ACTIONS(4766),
    [anon_sym_number] = ACTIONS(4766),
    [anon_sym_boolean] = ACTIONS(4766),
    [anon_sym_string] = ACTIONS(4766),
    [anon_sym_symbol] = ACTIONS(4766),
    [sym_readonly] = ACTIONS(4766),
  },
  [1710] = {
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(4742),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2578),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
  },
  [1711] = {
    [sym_identifier] = ACTIONS(3772),
    [anon_sym_export] = ACTIONS(3772),
    [anon_sym_STAR] = ACTIONS(3774),
    [anon_sym_namespace] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_RBRACE] = ACTIONS(3774),
    [anon_sym_type] = ACTIONS(3772),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_class] = ACTIONS(3772),
    [anon_sym_async] = ACTIONS(3772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3774),
    [anon_sym_void] = ACTIONS(3772),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_SQUOTE] = ACTIONS(3774),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3774),
    [sym_this] = ACTIONS(3772),
    [anon_sym_AT] = ACTIONS(3774),
    [anon_sym_static] = ACTIONS(3772),
    [anon_sym_abstract] = ACTIONS(3772),
    [anon_sym_get] = ACTIONS(3772),
    [anon_sym_set] = ACTIONS(3772),
    [anon_sym_declare] = ACTIONS(3772),
    [anon_sym_public] = ACTIONS(3772),
    [anon_sym_private] = ACTIONS(3772),
    [anon_sym_protected] = ACTIONS(3772),
    [anon_sym_module] = ACTIONS(3772),
    [anon_sym_any] = ACTIONS(3772),
    [anon_sym_number] = ACTIONS(3772),
    [anon_sym_boolean] = ACTIONS(3772),
    [anon_sym_string] = ACTIONS(3772),
    [anon_sym_symbol] = ACTIONS(3772),
    [sym_readonly] = ACTIONS(3772),
  },
  [1712] = {
    [sym_identifier] = ACTIONS(3368),
    [anon_sym_export] = ACTIONS(3368),
    [anon_sym_STAR] = ACTIONS(3370),
    [anon_sym_namespace] = ACTIONS(3368),
    [anon_sym_LBRACE] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_type] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_class] = ACTIONS(3368),
    [anon_sym_async] = ACTIONS(3368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3370),
    [anon_sym_void] = ACTIONS(3368),
    [anon_sym_DQUOTE] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3370),
    [sym_this] = ACTIONS(3368),
    [anon_sym_AT] = ACTIONS(3370),
    [anon_sym_static] = ACTIONS(3368),
    [anon_sym_abstract] = ACTIONS(3368),
    [anon_sym_get] = ACTIONS(3368),
    [anon_sym_set] = ACTIONS(3368),
    [anon_sym_declare] = ACTIONS(3368),
    [anon_sym_public] = ACTIONS(3368),
    [anon_sym_private] = ACTIONS(3368),
    [anon_sym_protected] = ACTIONS(3368),
    [anon_sym_module] = ACTIONS(3368),
    [anon_sym_any] = ACTIONS(3368),
    [anon_sym_number] = ACTIONS(3368),
    [anon_sym_boolean] = ACTIONS(3368),
    [anon_sym_string] = ACTIONS(3368),
    [anon_sym_symbol] = ACTIONS(3368),
    [sym_readonly] = ACTIONS(3368),
  },
  [1713] = {
    [sym_identifier] = ACTIONS(4770),
    [anon_sym_export] = ACTIONS(4770),
    [anon_sym_STAR] = ACTIONS(4772),
    [anon_sym_namespace] = ACTIONS(4770),
    [anon_sym_LBRACE] = ACTIONS(4772),
    [anon_sym_RBRACE] = ACTIONS(4772),
    [anon_sym_type] = ACTIONS(4770),
    [anon_sym_LBRACK] = ACTIONS(4772),
    [anon_sym_class] = ACTIONS(4770),
    [anon_sym_async] = ACTIONS(4770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4772),
    [anon_sym_void] = ACTIONS(4770),
    [anon_sym_DQUOTE] = ACTIONS(4772),
    [anon_sym_SQUOTE] = ACTIONS(4772),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4772),
    [sym_this] = ACTIONS(4770),
    [anon_sym_AT] = ACTIONS(4772),
    [anon_sym_static] = ACTIONS(4770),
    [anon_sym_abstract] = ACTIONS(4770),
    [anon_sym_get] = ACTIONS(4770),
    [anon_sym_set] = ACTIONS(4770),
    [anon_sym_declare] = ACTIONS(4770),
    [anon_sym_public] = ACTIONS(4770),
    [anon_sym_private] = ACTIONS(4770),
    [anon_sym_protected] = ACTIONS(4770),
    [anon_sym_module] = ACTIONS(4770),
    [anon_sym_any] = ACTIONS(4770),
    [anon_sym_number] = ACTIONS(4770),
    [anon_sym_boolean] = ACTIONS(4770),
    [anon_sym_string] = ACTIONS(4770),
    [anon_sym_symbol] = ACTIONS(4770),
    [sym_readonly] = ACTIONS(4770),
  },
  [1714] = {
    [sym_identifier] = ACTIONS(4732),
    [anon_sym_export] = ACTIONS(4732),
    [anon_sym_STAR] = ACTIONS(4734),
    [anon_sym_namespace] = ACTIONS(4732),
    [anon_sym_LBRACE] = ACTIONS(4734),
    [anon_sym_RBRACE] = ACTIONS(4734),
    [anon_sym_type] = ACTIONS(4732),
    [anon_sym_LBRACK] = ACTIONS(4734),
    [anon_sym_class] = ACTIONS(4732),
    [anon_sym_async] = ACTIONS(4732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4734),
    [anon_sym_void] = ACTIONS(4732),
    [anon_sym_DQUOTE] = ACTIONS(4734),
    [anon_sym_SQUOTE] = ACTIONS(4734),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4734),
    [sym_this] = ACTIONS(4732),
    [anon_sym_AT] = ACTIONS(4734),
    [anon_sym_static] = ACTIONS(4732),
    [anon_sym_abstract] = ACTIONS(4732),
    [anon_sym_get] = ACTIONS(4732),
    [anon_sym_set] = ACTIONS(4732),
    [anon_sym_declare] = ACTIONS(4732),
    [anon_sym_public] = ACTIONS(4732),
    [anon_sym_private] = ACTIONS(4732),
    [anon_sym_protected] = ACTIONS(4732),
    [anon_sym_module] = ACTIONS(4732),
    [anon_sym_any] = ACTIONS(4732),
    [anon_sym_number] = ACTIONS(4732),
    [anon_sym_boolean] = ACTIONS(4732),
    [anon_sym_string] = ACTIONS(4732),
    [anon_sym_symbol] = ACTIONS(4732),
    [sym_readonly] = ACTIONS(4732),
  },
  [1715] = {
    [sym_identifier] = ACTIONS(3948),
    [anon_sym_export] = ACTIONS(3948),
    [anon_sym_STAR] = ACTIONS(3950),
    [anon_sym_namespace] = ACTIONS(3948),
    [anon_sym_LBRACE] = ACTIONS(3950),
    [anon_sym_RBRACE] = ACTIONS(3950),
    [anon_sym_type] = ACTIONS(3948),
    [anon_sym_LBRACK] = ACTIONS(3950),
    [anon_sym_class] = ACTIONS(3948),
    [anon_sym_async] = ACTIONS(3948),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3950),
    [anon_sym_void] = ACTIONS(3948),
    [anon_sym_DQUOTE] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(3950),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(3950),
    [sym_this] = ACTIONS(3948),
    [anon_sym_AT] = ACTIONS(3950),
    [anon_sym_static] = ACTIONS(3948),
    [anon_sym_abstract] = ACTIONS(3948),
    [anon_sym_get] = ACTIONS(3948),
    [anon_sym_set] = ACTIONS(3948),
    [anon_sym_declare] = ACTIONS(3948),
    [anon_sym_public] = ACTIONS(3948),
    [anon_sym_private] = ACTIONS(3948),
    [anon_sym_protected] = ACTIONS(3948),
    [anon_sym_module] = ACTIONS(3948),
    [anon_sym_any] = ACTIONS(3948),
    [anon_sym_number] = ACTIONS(3948),
    [anon_sym_boolean] = ACTIONS(3948),
    [anon_sym_string] = ACTIONS(3948),
    [anon_sym_symbol] = ACTIONS(3948),
    [sym_readonly] = ACTIONS(3948),
  },
  [1716] = {
    [sym_string] = STATE(2078),
    [sym__property_name] = STATE(2078),
    [sym_computed_property_name] = STATE(2078),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4774),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4776),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4778),
    [anon_sym_set] = ACTIONS(4778),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1717] = {
    [sym_string] = STATE(2060),
    [sym__property_name] = STATE(2060),
    [sym_computed_property_name] = STATE(2060),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4780),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4782),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4784),
    [anon_sym_set] = ACTIONS(4784),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1718] = {
    [sym_string] = STATE(2042),
    [sym__property_name] = STATE(2042),
    [sym_computed_property_name] = STATE(2042),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4786),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4788),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4790),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4792),
    [anon_sym_set] = ACTIONS(4792),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(4794),
  },
  [1719] = {
    [sym_string] = STATE(2078),
    [sym__property_name] = STATE(2078),
    [sym_computed_property_name] = STATE(2078),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4774),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4796),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4776),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4778),
    [anon_sym_set] = ACTIONS(4778),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1720] = {
    [sym_string] = STATE(2042),
    [sym__property_name] = STATE(2042),
    [sym_computed_property_name] = STATE(2042),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_EQ_GT] = ACTIONS(4798),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4790),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1721] = {
    [sym_string] = STATE(2042),
    [sym__property_name] = STATE(2042),
    [sym_computed_property_name] = STATE(2042),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4786),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4790),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4792),
    [anon_sym_set] = ACTIONS(4792),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1722] = {
    [sym_string] = STATE(2042),
    [sym__property_name] = STATE(2042),
    [sym_computed_property_name] = STATE(2042),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4786),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(4788),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4790),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(4792),
    [anon_sym_set] = ACTIONS(4792),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1723] = {
    [sym_identifier] = ACTIONS(4800),
    [anon_sym_export] = ACTIONS(4800),
    [anon_sym_STAR] = ACTIONS(4802),
    [anon_sym_namespace] = ACTIONS(4800),
    [anon_sym_RBRACE] = ACTIONS(4802),
    [anon_sym_type] = ACTIONS(4800),
    [anon_sym_SEMI] = ACTIONS(4802),
    [anon_sym_LBRACK] = ACTIONS(4802),
    [anon_sym_async] = ACTIONS(4800),
    [anon_sym_void] = ACTIONS(4800),
    [anon_sym_DQUOTE] = ACTIONS(4802),
    [anon_sym_SQUOTE] = ACTIONS(4802),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4802),
    [anon_sym_AT] = ACTIONS(4802),
    [anon_sym_static] = ACTIONS(4800),
    [anon_sym_abstract] = ACTIONS(4800),
    [anon_sym_get] = ACTIONS(4800),
    [anon_sym_set] = ACTIONS(4800),
    [anon_sym_declare] = ACTIONS(4800),
    [anon_sym_public] = ACTIONS(4800),
    [anon_sym_private] = ACTIONS(4800),
    [anon_sym_protected] = ACTIONS(4800),
    [anon_sym_module] = ACTIONS(4800),
    [anon_sym_any] = ACTIONS(4800),
    [anon_sym_number] = ACTIONS(4800),
    [anon_sym_boolean] = ACTIONS(4800),
    [anon_sym_string] = ACTIONS(4800),
    [anon_sym_symbol] = ACTIONS(4800),
    [sym_readonly] = ACTIONS(4800),
    [sym__automatic_semicolon] = ACTIONS(4802),
  },
  [1724] = {
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
    [sym__automatic_semicolon] = ACTIONS(1135),
  },
  [1725] = {
    [sym_string] = STATE(2079),
    [sym__property_name] = STATE(2079),
    [sym_computed_property_name] = STATE(2079),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4680),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1726] = {
    [sym_string] = STATE(2045),
    [sym__property_name] = STATE(2045),
    [sym_computed_property_name] = STATE(2045),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4804),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1727] = {
    [sym_string] = STATE(2019),
    [sym__property_name] = STATE(2019),
    [sym_computed_property_name] = STATE(2019),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4628),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1728] = {
    [sym_string] = STATE(2060),
    [sym__property_name] = STATE(2060),
    [sym_computed_property_name] = STATE(2060),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4782),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1729] = {
    [sym_string] = STATE(2073),
    [sym__property_name] = STATE(2073),
    [sym_computed_property_name] = STATE(2073),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4674),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1730] = {
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_namespace] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym_type] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [anon_sym_async] = ACTIONS(1069),
    [anon_sym_void] = ACTIONS(1069),
    [anon_sym_DQUOTE] = ACTIONS(1067),
    [anon_sym_SQUOTE] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_static] = ACTIONS(1069),
    [anon_sym_abstract] = ACTIONS(1069),
    [anon_sym_get] = ACTIONS(1069),
    [anon_sym_set] = ACTIONS(1069),
    [anon_sym_declare] = ACTIONS(1069),
    [anon_sym_public] = ACTIONS(1069),
    [anon_sym_private] = ACTIONS(1069),
    [anon_sym_protected] = ACTIONS(1069),
    [anon_sym_module] = ACTIONS(1069),
    [anon_sym_any] = ACTIONS(1069),
    [anon_sym_number] = ACTIONS(1069),
    [anon_sym_boolean] = ACTIONS(1069),
    [anon_sym_string] = ACTIONS(1069),
    [anon_sym_symbol] = ACTIONS(1069),
    [sym_readonly] = ACTIONS(1069),
    [sym__automatic_semicolon] = ACTIONS(4806),
  },
  [1731] = {
    [sym_identifier] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1229),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_type] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_void] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1229),
    [anon_sym_AT] = ACTIONS(1229),
    [anon_sym_static] = ACTIONS(1231),
    [anon_sym_abstract] = ACTIONS(1231),
    [anon_sym_get] = ACTIONS(1231),
    [anon_sym_set] = ACTIONS(1231),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_public] = ACTIONS(1231),
    [anon_sym_private] = ACTIONS(1231),
    [anon_sym_protected] = ACTIONS(1231),
    [anon_sym_module] = ACTIONS(1231),
    [anon_sym_any] = ACTIONS(1231),
    [anon_sym_number] = ACTIONS(1231),
    [anon_sym_boolean] = ACTIONS(1231),
    [anon_sym_string] = ACTIONS(1231),
    [anon_sym_symbol] = ACTIONS(1231),
    [sym_readonly] = ACTIONS(1231),
    [sym__automatic_semicolon] = ACTIONS(1229),
  },
  [1732] = {
    [sym_identifier] = ACTIONS(4808),
    [anon_sym_export] = ACTIONS(4808),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_namespace] = ACTIONS(4808),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [anon_sym_type] = ACTIONS(4808),
    [anon_sym_SEMI] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_async] = ACTIONS(4808),
    [anon_sym_void] = ACTIONS(4808),
    [anon_sym_DQUOTE] = ACTIONS(4810),
    [anon_sym_SQUOTE] = ACTIONS(4810),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4810),
    [anon_sym_AT] = ACTIONS(4810),
    [anon_sym_static] = ACTIONS(4808),
    [anon_sym_abstract] = ACTIONS(4808),
    [anon_sym_get] = ACTIONS(4808),
    [anon_sym_set] = ACTIONS(4808),
    [anon_sym_declare] = ACTIONS(4808),
    [anon_sym_public] = ACTIONS(4808),
    [anon_sym_private] = ACTIONS(4808),
    [anon_sym_protected] = ACTIONS(4808),
    [anon_sym_module] = ACTIONS(4808),
    [anon_sym_any] = ACTIONS(4808),
    [anon_sym_number] = ACTIONS(4808),
    [anon_sym_boolean] = ACTIONS(4808),
    [anon_sym_string] = ACTIONS(4808),
    [anon_sym_symbol] = ACTIONS(4808),
    [sym_readonly] = ACTIONS(4808),
    [sym__automatic_semicolon] = ACTIONS(4810),
  },
  [1733] = {
    [sym_identifier] = ACTIONS(4812),
    [anon_sym_export] = ACTIONS(4812),
    [anon_sym_STAR] = ACTIONS(4814),
    [anon_sym_namespace] = ACTIONS(4812),
    [anon_sym_RBRACE] = ACTIONS(4814),
    [anon_sym_type] = ACTIONS(4812),
    [anon_sym_SEMI] = ACTIONS(4814),
    [anon_sym_LBRACK] = ACTIONS(4814),
    [anon_sym_async] = ACTIONS(4812),
    [anon_sym_void] = ACTIONS(4812),
    [anon_sym_DQUOTE] = ACTIONS(4814),
    [anon_sym_SQUOTE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4814),
    [anon_sym_AT] = ACTIONS(4814),
    [anon_sym_static] = ACTIONS(4812),
    [anon_sym_abstract] = ACTIONS(4812),
    [anon_sym_get] = ACTIONS(4812),
    [anon_sym_set] = ACTIONS(4812),
    [anon_sym_declare] = ACTIONS(4812),
    [anon_sym_public] = ACTIONS(4812),
    [anon_sym_private] = ACTIONS(4812),
    [anon_sym_protected] = ACTIONS(4812),
    [anon_sym_module] = ACTIONS(4812),
    [anon_sym_any] = ACTIONS(4812),
    [anon_sym_number] = ACTIONS(4812),
    [anon_sym_boolean] = ACTIONS(4812),
    [anon_sym_string] = ACTIONS(4812),
    [anon_sym_symbol] = ACTIONS(4812),
    [sym_readonly] = ACTIONS(4812),
    [sym__automatic_semicolon] = ACTIONS(4814),
  },
  [1734] = {
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_STAR] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1137),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1137),
    [anon_sym_SEMI] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_void] = ACTIONS(1137),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(1135),
    [anon_sym_AT] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1137),
    [anon_sym_abstract] = ACTIONS(1137),
    [anon_sym_get] = ACTIONS(1137),
    [anon_sym_set] = ACTIONS(1137),
    [anon_sym_declare] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1137),
    [anon_sym_private] = ACTIONS(1137),
    [anon_sym_protected] = ACTIONS(1137),
    [anon_sym_module] = ACTIONS(1137),
    [anon_sym_any] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_boolean] = ACTIONS(1137),
    [anon_sym_string] = ACTIONS(1137),
    [anon_sym_symbol] = ACTIONS(1137),
    [sym_readonly] = ACTIONS(1137),
    [sym__automatic_semicolon] = ACTIONS(4816),
  },
  [1735] = {
    [sym_string] = STATE(2042),
    [sym__property_name] = STATE(2042),
    [sym_computed_property_name] = STATE(2042),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4790),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1736] = {
    [sym_identifier] = ACTIONS(4818),
    [anon_sym_export] = ACTIONS(4818),
    [anon_sym_STAR] = ACTIONS(4820),
    [anon_sym_namespace] = ACTIONS(4818),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_type] = ACTIONS(4818),
    [anon_sym_SEMI] = ACTIONS(4820),
    [anon_sym_LBRACK] = ACTIONS(4820),
    [anon_sym_async] = ACTIONS(4818),
    [anon_sym_void] = ACTIONS(4818),
    [anon_sym_DQUOTE] = ACTIONS(4820),
    [anon_sym_SQUOTE] = ACTIONS(4820),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4820),
    [anon_sym_AT] = ACTIONS(4820),
    [anon_sym_static] = ACTIONS(4818),
    [anon_sym_abstract] = ACTIONS(4818),
    [anon_sym_get] = ACTIONS(4818),
    [anon_sym_set] = ACTIONS(4818),
    [anon_sym_declare] = ACTIONS(4818),
    [anon_sym_public] = ACTIONS(4818),
    [anon_sym_private] = ACTIONS(4818),
    [anon_sym_protected] = ACTIONS(4818),
    [anon_sym_module] = ACTIONS(4818),
    [anon_sym_any] = ACTIONS(4818),
    [anon_sym_number] = ACTIONS(4818),
    [anon_sym_boolean] = ACTIONS(4818),
    [anon_sym_string] = ACTIONS(4818),
    [anon_sym_symbol] = ACTIONS(4818),
    [sym_readonly] = ACTIONS(4818),
    [sym__automatic_semicolon] = ACTIONS(4820),
  },
  [1737] = {
    [sym_string] = STATE(2010),
    [sym__property_name] = STATE(2010),
    [sym_computed_property_name] = STATE(2010),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4822),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1738] = {
    [sym_string] = STATE(2044),
    [sym__property_name] = STATE(2044),
    [sym_computed_property_name] = STATE(2044),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4824),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1739] = {
    [sym_object] = STATE(2126),
    [sym_array] = STATE(2118),
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_export] = ACTIONS(4828),
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_namespace] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(4830),
    [anon_sym_type] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4830),
    [anon_sym_COLON] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(4828),
    [anon_sym_QMARK] = ACTIONS(4830),
    [anon_sym_void] = ACTIONS(4828),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4826),
    [anon_sym_static] = ACTIONS(4828),
    [anon_sym_get] = ACTIONS(4828),
    [anon_sym_set] = ACTIONS(4828),
    [anon_sym_declare] = ACTIONS(4828),
    [anon_sym_public] = ACTIONS(4828),
    [anon_sym_private] = ACTIONS(4828),
    [anon_sym_protected] = ACTIONS(4828),
    [anon_sym_module] = ACTIONS(4828),
    [anon_sym_any] = ACTIONS(4828),
    [anon_sym_number] = ACTIONS(4828),
    [anon_sym_boolean] = ACTIONS(4828),
    [anon_sym_string] = ACTIONS(4828),
    [anon_sym_symbol] = ACTIONS(4828),
    [sym_readonly] = ACTIONS(4828),
  },
  [1740] = {
    [sym_identifier] = ACTIONS(4832),
    [anon_sym_export] = ACTIONS(4832),
    [anon_sym_STAR] = ACTIONS(4834),
    [anon_sym_namespace] = ACTIONS(4832),
    [anon_sym_RBRACE] = ACTIONS(4834),
    [anon_sym_type] = ACTIONS(4832),
    [anon_sym_SEMI] = ACTIONS(4834),
    [anon_sym_LBRACK] = ACTIONS(4834),
    [anon_sym_async] = ACTIONS(4832),
    [anon_sym_void] = ACTIONS(4832),
    [anon_sym_DQUOTE] = ACTIONS(4834),
    [anon_sym_SQUOTE] = ACTIONS(4834),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4834),
    [anon_sym_AT] = ACTIONS(4834),
    [anon_sym_static] = ACTIONS(4832),
    [anon_sym_abstract] = ACTIONS(4832),
    [anon_sym_get] = ACTIONS(4832),
    [anon_sym_set] = ACTIONS(4832),
    [anon_sym_declare] = ACTIONS(4832),
    [anon_sym_public] = ACTIONS(4832),
    [anon_sym_private] = ACTIONS(4832),
    [anon_sym_protected] = ACTIONS(4832),
    [anon_sym_module] = ACTIONS(4832),
    [anon_sym_any] = ACTIONS(4832),
    [anon_sym_number] = ACTIONS(4832),
    [anon_sym_boolean] = ACTIONS(4832),
    [anon_sym_string] = ACTIONS(4832),
    [anon_sym_symbol] = ACTIONS(4832),
    [sym_readonly] = ACTIONS(4832),
    [sym__automatic_semicolon] = ACTIONS(4834),
  },
  [1741] = {
    [sym_identifier] = ACTIONS(4836),
    [anon_sym_export] = ACTIONS(4836),
    [anon_sym_STAR] = ACTIONS(4838),
    [anon_sym_namespace] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4838),
    [anon_sym_type] = ACTIONS(4836),
    [anon_sym_SEMI] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(4838),
    [anon_sym_async] = ACTIONS(4836),
    [anon_sym_void] = ACTIONS(4836),
    [anon_sym_DQUOTE] = ACTIONS(4838),
    [anon_sym_SQUOTE] = ACTIONS(4838),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4838),
    [anon_sym_AT] = ACTIONS(4838),
    [anon_sym_static] = ACTIONS(4836),
    [anon_sym_abstract] = ACTIONS(4836),
    [anon_sym_get] = ACTIONS(4836),
    [anon_sym_set] = ACTIONS(4836),
    [anon_sym_declare] = ACTIONS(4836),
    [anon_sym_public] = ACTIONS(4836),
    [anon_sym_private] = ACTIONS(4836),
    [anon_sym_protected] = ACTIONS(4836),
    [anon_sym_module] = ACTIONS(4836),
    [anon_sym_any] = ACTIONS(4836),
    [anon_sym_number] = ACTIONS(4836),
    [anon_sym_boolean] = ACTIONS(4836),
    [anon_sym_string] = ACTIONS(4836),
    [anon_sym_symbol] = ACTIONS(4836),
    [sym_readonly] = ACTIONS(4836),
    [sym__automatic_semicolon] = ACTIONS(4838),
  },
  [1742] = {
    [sym_string] = STATE(2078),
    [sym__property_name] = STATE(2078),
    [sym_computed_property_name] = STATE(2078),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4776),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1743] = {
    [sym_string] = STATE(2025),
    [sym__property_name] = STATE(2025),
    [sym_computed_property_name] = STATE(2025),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4547),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1744] = {
    [sym_identifier] = ACTIONS(4840),
    [anon_sym_export] = ACTIONS(4840),
    [anon_sym_STAR] = ACTIONS(4842),
    [anon_sym_namespace] = ACTIONS(4840),
    [anon_sym_RBRACE] = ACTIONS(4842),
    [anon_sym_type] = ACTIONS(4840),
    [anon_sym_SEMI] = ACTIONS(4842),
    [anon_sym_LBRACK] = ACTIONS(4842),
    [anon_sym_async] = ACTIONS(4840),
    [anon_sym_void] = ACTIONS(4840),
    [anon_sym_DQUOTE] = ACTIONS(4842),
    [anon_sym_SQUOTE] = ACTIONS(4842),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4842),
    [anon_sym_AT] = ACTIONS(4842),
    [anon_sym_static] = ACTIONS(4840),
    [anon_sym_abstract] = ACTIONS(4840),
    [anon_sym_get] = ACTIONS(4840),
    [anon_sym_set] = ACTIONS(4840),
    [anon_sym_declare] = ACTIONS(4840),
    [anon_sym_public] = ACTIONS(4840),
    [anon_sym_private] = ACTIONS(4840),
    [anon_sym_protected] = ACTIONS(4840),
    [anon_sym_module] = ACTIONS(4840),
    [anon_sym_any] = ACTIONS(4840),
    [anon_sym_number] = ACTIONS(4840),
    [anon_sym_boolean] = ACTIONS(4840),
    [anon_sym_string] = ACTIONS(4840),
    [anon_sym_symbol] = ACTIONS(4840),
    [sym_readonly] = ACTIONS(4840),
    [sym__automatic_semicolon] = ACTIONS(4842),
  },
  [1745] = {
    [sym_object] = STATE(2082),
    [sym_array] = STATE(2170),
    [sym_identifier] = ACTIONS(2790),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_EQ] = ACTIONS(618),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(618),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_RPAREN] = ACTIONS(618),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_QMARK] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(2792),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [sym_readonly] = ACTIONS(2792),
  },
  [1746] = {
    [sym_identifier] = ACTIONS(4844),
    [anon_sym_export] = ACTIONS(4844),
    [anon_sym_STAR] = ACTIONS(4846),
    [anon_sym_namespace] = ACTIONS(4844),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [anon_sym_type] = ACTIONS(4844),
    [anon_sym_SEMI] = ACTIONS(4846),
    [anon_sym_LBRACK] = ACTIONS(4846),
    [anon_sym_async] = ACTIONS(4844),
    [anon_sym_void] = ACTIONS(4844),
    [anon_sym_DQUOTE] = ACTIONS(4846),
    [anon_sym_SQUOTE] = ACTIONS(4846),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4846),
    [anon_sym_AT] = ACTIONS(4846),
    [anon_sym_static] = ACTIONS(4844),
    [anon_sym_abstract] = ACTIONS(4844),
    [anon_sym_get] = ACTIONS(4844),
    [anon_sym_set] = ACTIONS(4844),
    [anon_sym_declare] = ACTIONS(4844),
    [anon_sym_public] = ACTIONS(4844),
    [anon_sym_private] = ACTIONS(4844),
    [anon_sym_protected] = ACTIONS(4844),
    [anon_sym_module] = ACTIONS(4844),
    [anon_sym_any] = ACTIONS(4844),
    [anon_sym_number] = ACTIONS(4844),
    [anon_sym_boolean] = ACTIONS(4844),
    [anon_sym_string] = ACTIONS(4844),
    [anon_sym_symbol] = ACTIONS(4844),
    [sym_readonly] = ACTIONS(4844),
    [sym__automatic_semicolon] = ACTIONS(4846),
  },
  [1747] = {
    [sym_identifier] = ACTIONS(4848),
    [anon_sym_export] = ACTIONS(4848),
    [anon_sym_STAR] = ACTIONS(4850),
    [anon_sym_namespace] = ACTIONS(4848),
    [anon_sym_RBRACE] = ACTIONS(4850),
    [anon_sym_type] = ACTIONS(4848),
    [anon_sym_SEMI] = ACTIONS(4850),
    [anon_sym_LBRACK] = ACTIONS(4850),
    [anon_sym_async] = ACTIONS(4848),
    [anon_sym_void] = ACTIONS(4848),
    [anon_sym_DQUOTE] = ACTIONS(4850),
    [anon_sym_SQUOTE] = ACTIONS(4850),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4850),
    [anon_sym_AT] = ACTIONS(4850),
    [anon_sym_static] = ACTIONS(4848),
    [anon_sym_abstract] = ACTIONS(4848),
    [anon_sym_get] = ACTIONS(4848),
    [anon_sym_set] = ACTIONS(4848),
    [anon_sym_declare] = ACTIONS(4848),
    [anon_sym_public] = ACTIONS(4848),
    [anon_sym_private] = ACTIONS(4848),
    [anon_sym_protected] = ACTIONS(4848),
    [anon_sym_module] = ACTIONS(4848),
    [anon_sym_any] = ACTIONS(4848),
    [anon_sym_number] = ACTIONS(4848),
    [anon_sym_boolean] = ACTIONS(4848),
    [anon_sym_string] = ACTIONS(4848),
    [anon_sym_symbol] = ACTIONS(4848),
    [sym_readonly] = ACTIONS(4848),
    [sym__automatic_semicolon] = ACTIONS(4850),
  },
  [1748] = {
    [sym_identifier] = ACTIONS(4852),
    [anon_sym_export] = ACTIONS(4852),
    [anon_sym_STAR] = ACTIONS(4854),
    [anon_sym_namespace] = ACTIONS(4852),
    [anon_sym_RBRACE] = ACTIONS(4854),
    [anon_sym_type] = ACTIONS(4852),
    [anon_sym_SEMI] = ACTIONS(4854),
    [anon_sym_LBRACK] = ACTIONS(4854),
    [anon_sym_async] = ACTIONS(4852),
    [anon_sym_void] = ACTIONS(4852),
    [anon_sym_DQUOTE] = ACTIONS(4854),
    [anon_sym_SQUOTE] = ACTIONS(4854),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4854),
    [anon_sym_AT] = ACTIONS(4854),
    [anon_sym_static] = ACTIONS(4852),
    [anon_sym_abstract] = ACTIONS(4852),
    [anon_sym_get] = ACTIONS(4852),
    [anon_sym_set] = ACTIONS(4852),
    [anon_sym_declare] = ACTIONS(4852),
    [anon_sym_public] = ACTIONS(4852),
    [anon_sym_private] = ACTIONS(4852),
    [anon_sym_protected] = ACTIONS(4852),
    [anon_sym_module] = ACTIONS(4852),
    [anon_sym_any] = ACTIONS(4852),
    [anon_sym_number] = ACTIONS(4852),
    [anon_sym_boolean] = ACTIONS(4852),
    [anon_sym_string] = ACTIONS(4852),
    [anon_sym_symbol] = ACTIONS(4852),
    [sym_readonly] = ACTIONS(4852),
    [sym__automatic_semicolon] = ACTIONS(4854),
  },
  [1749] = {
    [sym_identifier] = ACTIONS(4856),
    [anon_sym_export] = ACTIONS(4856),
    [anon_sym_STAR] = ACTIONS(4858),
    [anon_sym_namespace] = ACTIONS(4856),
    [anon_sym_RBRACE] = ACTIONS(4858),
    [anon_sym_type] = ACTIONS(4856),
    [anon_sym_SEMI] = ACTIONS(4858),
    [anon_sym_LBRACK] = ACTIONS(4858),
    [anon_sym_async] = ACTIONS(4856),
    [anon_sym_void] = ACTIONS(4856),
    [anon_sym_DQUOTE] = ACTIONS(4858),
    [anon_sym_SQUOTE] = ACTIONS(4858),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4858),
    [anon_sym_AT] = ACTIONS(4858),
    [anon_sym_static] = ACTIONS(4856),
    [anon_sym_abstract] = ACTIONS(4856),
    [anon_sym_get] = ACTIONS(4856),
    [anon_sym_set] = ACTIONS(4856),
    [anon_sym_declare] = ACTIONS(4856),
    [anon_sym_public] = ACTIONS(4856),
    [anon_sym_private] = ACTIONS(4856),
    [anon_sym_protected] = ACTIONS(4856),
    [anon_sym_module] = ACTIONS(4856),
    [anon_sym_any] = ACTIONS(4856),
    [anon_sym_number] = ACTIONS(4856),
    [anon_sym_boolean] = ACTIONS(4856),
    [anon_sym_string] = ACTIONS(4856),
    [anon_sym_symbol] = ACTIONS(4856),
    [sym_readonly] = ACTIONS(4856),
    [sym__automatic_semicolon] = ACTIONS(4858),
  },
  [1750] = {
    [sym_string] = STATE(2057),
    [sym__property_name] = STATE(2057),
    [sym_computed_property_name] = STATE(2057),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4622),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1751] = {
    [sym_identifier] = ACTIONS(4860),
    [anon_sym_export] = ACTIONS(4860),
    [anon_sym_STAR] = ACTIONS(4862),
    [anon_sym_namespace] = ACTIONS(4860),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [anon_sym_type] = ACTIONS(4860),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4862),
    [anon_sym_async] = ACTIONS(4860),
    [anon_sym_void] = ACTIONS(4860),
    [anon_sym_DQUOTE] = ACTIONS(4862),
    [anon_sym_SQUOTE] = ACTIONS(4862),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4862),
    [anon_sym_AT] = ACTIONS(4862),
    [anon_sym_static] = ACTIONS(4860),
    [anon_sym_abstract] = ACTIONS(4860),
    [anon_sym_get] = ACTIONS(4860),
    [anon_sym_set] = ACTIONS(4860),
    [anon_sym_declare] = ACTIONS(4860),
    [anon_sym_public] = ACTIONS(4860),
    [anon_sym_private] = ACTIONS(4860),
    [anon_sym_protected] = ACTIONS(4860),
    [anon_sym_module] = ACTIONS(4860),
    [anon_sym_any] = ACTIONS(4860),
    [anon_sym_number] = ACTIONS(4860),
    [anon_sym_boolean] = ACTIONS(4860),
    [anon_sym_string] = ACTIONS(4860),
    [anon_sym_symbol] = ACTIONS(4860),
    [sym_readonly] = ACTIONS(4860),
    [sym__automatic_semicolon] = ACTIONS(4862),
  },
  [1752] = {
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_export] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_namespace] = ACTIONS(4864),
    [anon_sym_RBRACE] = ACTIONS(4866),
    [anon_sym_type] = ACTIONS(4864),
    [anon_sym_SEMI] = ACTIONS(4868),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_async] = ACTIONS(4864),
    [anon_sym_void] = ACTIONS(4864),
    [anon_sym_DQUOTE] = ACTIONS(4866),
    [anon_sym_SQUOTE] = ACTIONS(4866),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4866),
    [anon_sym_AT] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4864),
    [anon_sym_abstract] = ACTIONS(4864),
    [anon_sym_get] = ACTIONS(4864),
    [anon_sym_set] = ACTIONS(4864),
    [anon_sym_declare] = ACTIONS(4864),
    [anon_sym_public] = ACTIONS(4864),
    [anon_sym_private] = ACTIONS(4864),
    [anon_sym_protected] = ACTIONS(4864),
    [anon_sym_module] = ACTIONS(4864),
    [anon_sym_any] = ACTIONS(4864),
    [anon_sym_number] = ACTIONS(4864),
    [anon_sym_boolean] = ACTIONS(4864),
    [anon_sym_string] = ACTIONS(4864),
    [anon_sym_symbol] = ACTIONS(4864),
    [sym_readonly] = ACTIONS(4864),
    [sym__automatic_semicolon] = ACTIONS(4868),
  },
  [1753] = {
    [sym_string] = STATE(2046),
    [sym__property_name] = STATE(2046),
    [sym_computed_property_name] = STATE(2046),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4580),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1754] = {
    [sym_string] = STATE(2061),
    [sym__property_name] = STATE(2061),
    [sym_computed_property_name] = STATE(2061),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4602),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1755] = {
    [sym_string] = STATE(2072),
    [sym__property_name] = STATE(2072),
    [sym_computed_property_name] = STATE(2072),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4670),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1756] = {
    [sym_string] = STATE(2008),
    [sym__property_name] = STATE(2008),
    [sym_computed_property_name] = STATE(2008),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4664),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1757] = {
    [sym_string] = STATE(2080),
    [sym__property_name] = STATE(2080),
    [sym_computed_property_name] = STATE(2080),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4870),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1758] = {
    [sym_string] = STATE(1809),
    [sym__property_name] = STATE(1809),
    [sym_computed_property_name] = STATE(1809),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4419),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_async] = ACTIONS(4421),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4423),
    [anon_sym_static] = ACTIONS(4872),
    [anon_sym_abstract] = ACTIONS(4874),
    [anon_sym_get] = ACTIONS(4427),
    [anon_sym_set] = ACTIONS(4427),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4876),
  },
  [1759] = {
    [sym_string] = STATE(2326),
    [sym__property_name] = STATE(2326),
    [sym_computed_property_name] = STATE(2326),
    [sym_enum_assignment] = STATE(2659),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(4878),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4880),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1760] = {
    [sym_string] = STATE(2135),
    [sym__property_name] = STATE(2135),
    [sym_computed_property_name] = STATE(2135),
    [sym_enum_assignment] = STATE(2434),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(4882),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4884),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1761] = {
    [sym_string] = STATE(2257),
    [sym__property_name] = STATE(2257),
    [sym_computed_property_name] = STATE(2257),
    [sym_enum_assignment] = STATE(2535),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(4886),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4888),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1762] = {
    [sym_string] = STATE(2326),
    [sym__property_name] = STATE(2326),
    [sym_computed_property_name] = STATE(2326),
    [sym_enum_assignment] = STATE(2659),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(4890),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4880),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1763] = {
    [sym_string] = STATE(2326),
    [sym__property_name] = STATE(2326),
    [sym_computed_property_name] = STATE(2326),
    [sym_enum_assignment] = STATE(2659),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(4892),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4880),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1764] = {
    [sym_string] = STATE(2326),
    [sym__property_name] = STATE(2326),
    [sym_computed_property_name] = STATE(2326),
    [sym_enum_assignment] = STATE(2659),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(4894),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4880),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1765] = {
    [sym_identifier] = ACTIONS(4896),
    [anon_sym_export] = ACTIONS(4896),
    [anon_sym_STAR] = ACTIONS(4221),
    [anon_sym_namespace] = ACTIONS(4896),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [anon_sym_type] = ACTIONS(4896),
    [anon_sym_LBRACK] = ACTIONS(4221),
    [anon_sym_async] = ACTIONS(4896),
    [anon_sym_void] = ACTIONS(4896),
    [anon_sym_DQUOTE] = ACTIONS(4221),
    [anon_sym_SQUOTE] = ACTIONS(4221),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4221),
    [anon_sym_AT] = ACTIONS(4221),
    [anon_sym_static] = ACTIONS(4896),
    [anon_sym_abstract] = ACTIONS(4896),
    [anon_sym_get] = ACTIONS(4896),
    [anon_sym_set] = ACTIONS(4896),
    [anon_sym_declare] = ACTIONS(4896),
    [anon_sym_public] = ACTIONS(4896),
    [anon_sym_private] = ACTIONS(4896),
    [anon_sym_protected] = ACTIONS(4896),
    [anon_sym_module] = ACTIONS(4896),
    [anon_sym_any] = ACTIONS(4896),
    [anon_sym_number] = ACTIONS(4896),
    [anon_sym_boolean] = ACTIONS(4896),
    [anon_sym_string] = ACTIONS(4896),
    [anon_sym_symbol] = ACTIONS(4896),
    [sym_readonly] = ACTIONS(4896),
  },
  [1766] = {
    [sym_string] = STATE(1818),
    [sym__property_name] = STATE(1818),
    [sym_computed_property_name] = STATE(1818),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4167),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_async] = ACTIONS(4190),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(4898),
    [anon_sym_get] = ACTIONS(4194),
    [anon_sym_set] = ACTIONS(4194),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4196),
  },
  [1767] = {
    [sym_decorator] = STATE(1798),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [sym_identifier] = ACTIONS(4900),
    [anon_sym_export] = ACTIONS(4900),
    [anon_sym_namespace] = ACTIONS(4900),
    [anon_sym_LBRACE] = ACTIONS(4902),
    [anon_sym_type] = ACTIONS(4900),
    [anon_sym_LBRACK] = ACTIONS(4902),
    [anon_sym_class] = ACTIONS(4900),
    [anon_sym_async] = ACTIONS(4900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4902),
    [anon_sym_void] = ACTIONS(4900),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4900),
    [anon_sym_AT] = ACTIONS(4904),
    [anon_sym_static] = ACTIONS(4900),
    [anon_sym_get] = ACTIONS(4900),
    [anon_sym_set] = ACTIONS(4900),
    [anon_sym_declare] = ACTIONS(4900),
    [anon_sym_public] = ACTIONS(4900),
    [anon_sym_private] = ACTIONS(4900),
    [anon_sym_protected] = ACTIONS(4900),
    [anon_sym_module] = ACTIONS(4900),
    [anon_sym_any] = ACTIONS(4900),
    [anon_sym_number] = ACTIONS(4900),
    [anon_sym_boolean] = ACTIONS(4900),
    [anon_sym_string] = ACTIONS(4900),
    [anon_sym_symbol] = ACTIONS(4900),
    [sym_readonly] = ACTIONS(4900),
  },
  [1768] = {
    [sym_string] = STATE(2326),
    [sym__property_name] = STATE(2326),
    [sym_computed_property_name] = STATE(2326),
    [sym_enum_assignment] = STATE(2659),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4880),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1769] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(4690),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(4907),
    [anon_sym_get] = ACTIONS(2499),
    [anon_sym_set] = ACTIONS(2499),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2501),
  },
  [1770] = {
    [sym_identifier] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(618),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(618),
    [anon_sym_type] = ACTIONS(2576),
    [anon_sym_RPAREN] = ACTIONS(618),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(2578),
    [anon_sym_async] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(618),
    [anon_sym_void] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_get] = ACTIONS(2576),
    [anon_sym_set] = ACTIONS(2576),
    [anon_sym_declare] = ACTIONS(2576),
    [anon_sym_public] = ACTIONS(2576),
    [anon_sym_private] = ACTIONS(2576),
    [anon_sym_protected] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_any] = ACTIONS(2576),
    [anon_sym_number] = ACTIONS(2576),
    [anon_sym_boolean] = ACTIONS(2576),
    [anon_sym_string] = ACTIONS(2576),
    [anon_sym_symbol] = ACTIONS(2576),
    [sym_readonly] = ACTIONS(2576),
  },
  [1771] = {
    [sym_string] = STATE(1819),
    [sym__property_name] = STATE(1819),
    [sym_computed_property_name] = STATE(1819),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4564),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_async] = ACTIONS(4566),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4568),
    [anon_sym_static] = ACTIONS(4909),
    [anon_sym_get] = ACTIONS(4570),
    [anon_sym_set] = ACTIONS(4570),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4576),
  },
  [1772] = {
    [sym_string] = STATE(1806),
    [sym__property_name] = STATE(1806),
    [sym_computed_property_name] = STATE(1806),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4911),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_async] = ACTIONS(3503),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4913),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4915),
    [anon_sym_set] = ACTIONS(4915),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4917),
  },
  [1773] = {
    [sym_string] = STATE(1810),
    [sym__property_name] = STATE(1810),
    [sym_computed_property_name] = STATE(1810),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_STAR] = ACTIONS(4919),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_async] = ACTIONS(3503),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4921),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(4923),
    [anon_sym_set] = ACTIONS(4923),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(4925),
  },
  [1774] = {
    [sym_string] = STATE(2057),
    [sym__property_name] = STATE(2057),
    [sym_computed_property_name] = STATE(2057),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4622),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1775] = {
    [sym_string] = STATE(2018),
    [sym__property_name] = STATE(2018),
    [sym_computed_property_name] = STATE(2018),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4702),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1776] = {
    [sym_string] = STATE(2008),
    [sym__property_name] = STATE(2008),
    [sym_computed_property_name] = STATE(2008),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4664),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1777] = {
    [sym_string] = STATE(2078),
    [sym__property_name] = STATE(2078),
    [sym_computed_property_name] = STATE(2078),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4776),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1778] = {
    [sym_string] = STATE(2027),
    [sym__property_name] = STATE(2027),
    [sym_computed_property_name] = STATE(2027),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4708),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1779] = {
    [sym_string] = STATE(2079),
    [sym__property_name] = STATE(2079),
    [sym_computed_property_name] = STATE(2079),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4680),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1780] = {
    [sym_string] = STATE(2013),
    [sym__property_name] = STATE(2013),
    [sym_computed_property_name] = STATE(2013),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1781] = {
    [sym_string] = STATE(2080),
    [sym__property_name] = STATE(2080),
    [sym_computed_property_name] = STATE(2080),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4870),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1782] = {
    [sym_string] = STATE(2010),
    [sym__property_name] = STATE(2010),
    [sym_computed_property_name] = STATE(2010),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4822),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1783] = {
    [sym_string] = STATE(2042),
    [sym__property_name] = STATE(2042),
    [sym_computed_property_name] = STATE(2042),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4790),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1784] = {
    [sym_string] = STATE(2045),
    [sym__property_name] = STATE(2045),
    [sym_computed_property_name] = STATE(2045),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4804),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1785] = {
    [sym_string] = STATE(2046),
    [sym__property_name] = STATE(2046),
    [sym_computed_property_name] = STATE(2046),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4580),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1786] = {
    [sym_string] = STATE(2073),
    [sym__property_name] = STATE(2073),
    [sym_computed_property_name] = STATE(2073),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4674),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1787] = {
    [sym_string] = STATE(2044),
    [sym__property_name] = STATE(2044),
    [sym_computed_property_name] = STATE(2044),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4824),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1788] = {
    [sym_string] = STATE(2069),
    [sym__property_name] = STATE(2069),
    [sym_computed_property_name] = STATE(2069),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4173),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1789] = {
    [sym_string] = STATE(2072),
    [sym__property_name] = STATE(2072),
    [sym_computed_property_name] = STATE(2072),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4670),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1790] = {
    [sym_string] = STATE(1913),
    [sym__property_name] = STATE(1913),
    [sym_computed_property_name] = STATE(1913),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_async] = ACTIONS(3503),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4692),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(3503),
    [anon_sym_set] = ACTIONS(3503),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
  },
  [1791] = {
    [sym_string] = STATE(2060),
    [sym__property_name] = STATE(2060),
    [sym_computed_property_name] = STATE(2060),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4782),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1792] = {
    [sym_string] = STATE(2025),
    [sym__property_name] = STATE(2025),
    [sym_computed_property_name] = STATE(2025),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4547),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1793] = {
    [sym_string] = STATE(2061),
    [sym__property_name] = STATE(2061),
    [sym_computed_property_name] = STATE(2061),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4602),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1794] = {
    [sym_string] = STATE(2003),
    [sym__property_name] = STATE(2003),
    [sym_computed_property_name] = STATE(2003),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4590),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1795] = {
    [sym_string] = STATE(2019),
    [sym__property_name] = STATE(2019),
    [sym_computed_property_name] = STATE(2019),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4628),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1796] = {
    [sym_string] = STATE(1904),
    [sym__property_name] = STATE(1904),
    [sym_computed_property_name] = STATE(1904),
    [sym_identifier] = ACTIONS(3503),
    [anon_sym_export] = ACTIONS(3503),
    [anon_sym_namespace] = ACTIONS(3503),
    [anon_sym_type] = ACTIONS(3503),
    [anon_sym_LBRACK] = ACTIONS(4188),
    [anon_sym_async] = ACTIONS(3503),
    [anon_sym_void] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4704),
    [anon_sym_static] = ACTIONS(3503),
    [anon_sym_get] = ACTIONS(3503),
    [anon_sym_set] = ACTIONS(3503),
    [anon_sym_declare] = ACTIONS(3503),
    [anon_sym_public] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(3503),
    [anon_sym_protected] = ACTIONS(3503),
    [anon_sym_module] = ACTIONS(3503),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_symbol] = ACTIONS(3503),
    [sym_readonly] = ACTIONS(3503),
  },
  [1797] = {
    [sym_string] = STATE(2047),
    [sym__property_name] = STATE(2047),
    [sym_computed_property_name] = STATE(2047),
    [sym_identifier] = ACTIONS(2495),
    [anon_sym_export] = ACTIONS(2495),
    [anon_sym_namespace] = ACTIONS(2495),
    [anon_sym_type] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(4171),
    [anon_sym_async] = ACTIONS(2495),
    [anon_sym_void] = ACTIONS(2495),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(4558),
    [anon_sym_static] = ACTIONS(2495),
    [anon_sym_get] = ACTIONS(2495),
    [anon_sym_set] = ACTIONS(2495),
    [anon_sym_declare] = ACTIONS(2495),
    [anon_sym_public] = ACTIONS(2495),
    [anon_sym_private] = ACTIONS(2495),
    [anon_sym_protected] = ACTIONS(2495),
    [anon_sym_module] = ACTIONS(2495),
    [anon_sym_any] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2495),
    [anon_sym_string] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2495),
    [sym_readonly] = ACTIONS(2495),
  },
  [1798] = {
    [sym_identifier] = ACTIONS(4927),
    [anon_sym_export] = ACTIONS(4927),
    [anon_sym_namespace] = ACTIONS(4927),
    [anon_sym_LBRACE] = ACTIONS(4929),
    [anon_sym_type] = ACTIONS(4927),
    [anon_sym_LBRACK] = ACTIONS(4929),
    [anon_sym_class] = ACTIONS(4927),
    [anon_sym_async] = ACTIONS(4927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4929),
    [anon_sym_void] = ACTIONS(4927),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(4927),
    [anon_sym_AT] = ACTIONS(4929),
    [anon_sym_static] = ACTIONS(4927),
    [anon_sym_get] = ACTIONS(4927),
    [anon_sym_set] = ACTIONS(4927),
    [anon_sym_declare] = ACTIONS(4927),
    [anon_sym_public] = ACTIONS(4927),
    [anon_sym_private] = ACTIONS(4927),
    [anon_sym_protected] = ACTIONS(4927),
    [anon_sym_module] = ACTIONS(4927),
    [anon_sym_any] = ACTIONS(4927),
    [anon_sym_number] = ACTIONS(4927),
    [anon_sym_boolean] = ACTIONS(4927),
    [anon_sym_string] = ACTIONS(4927),
    [anon_sym_symbol] = ACTIONS(4927),
    [sym_readonly] = ACTIONS(4927),
  },
  [1799] = {
    [sym_object] = STATE(2082),
    [sym_array] = STATE(2170),
    [sym_identifier] = ACTIONS(2790),
    [anon_sym_export] = ACTIONS(2792),
    [anon_sym_namespace] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_async] = ACTIONS(2792),
    [anon_sym_void] = ACTIONS(2792),
    [sym_comment] = ACTIONS(3),
    [sym_this] = ACTIONS(2790),
    [anon_sym_static] = ACTIONS(2792),
    [anon_sym_get] = ACTIONS(2792),
    [anon_sym_set] = ACTIONS(2792),
    [anon_sym_declare] = ACTIONS(2792),
    [anon_sym_public] = ACTIONS(2792),
    [anon_sym_private] = ACTIONS(2792),
    [anon_sym_protected] = ACTIONS(2792),
    [anon_sym_module] = ACTIONS(2792),
    [anon_sym_any] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2792),
    [anon_sym_string] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2792),
    [sym_readonly] = ACTIONS(4931),
  },
  [1800] = {
    [sym_decorator_member_expression] = STATE(1677),
    [sym_decorator_call_expression] = STATE(1714),
    [sym_identifier] = ACTIONS(4933),
    [anon_sym_export] = ACTIONS(4935),
    [anon_sym_namespace] = ACTIONS(4935),
    [anon_sym_type] = ACTIONS(4935),
    [anon_sym_async] = ACTIONS(4935),
    [anon_sym_void] = ACTIONS(4935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(4935),
    [anon_sym_get] = ACTIONS(4935),
    [anon_sym_set] = ACTIONS(4935),
    [anon_sym_declare] = ACTIONS(4935),
    [anon_sym_public] = ACTIONS(4935),
    [anon_sym_private] = ACTIONS(4935),
    [anon_sym_protected] = ACTIONS(4935),
    [anon_sym_module] = ACTIONS(4935),
    [anon_sym_any] = ACTIONS(4935),
    [anon_sym_number] = ACTIONS(4935),
    [anon_sym_boolean] = ACTIONS(4935),
    [anon_sym_string] = ACTIONS(4935),
    [anon_sym_symbol] = ACTIONS(4935),
    [sym_readonly] = ACTIONS(4935),
  },
  [1801] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_else] = ACTIONS(2486),
    [anon_sym_RPAREN] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_RBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(4937),
    [anon_sym_GT] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_EQ_GT] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3292),
  },
  [1802] = {
    [anon_sym_EQ] = ACTIONS(1109),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(1109),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_BANG] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1109),
    [sym__automatic_semicolon] = ACTIONS(1109),
  },
  [1803] = {
    [anon_sym_EQ] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_COLON] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1171),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1171),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_BANG] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1171),
    [sym__automatic_semicolon] = ACTIONS(1171),
  },
  [1804] = {
    [sym__call_signature] = STATE(2153),
    [sym__initializer] = STATE(2446),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2147),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4943),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4945),
    [anon_sym_BANG] = ACTIONS(4947),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4943),
  },
  [1805] = {
    [sym_type_arguments] = STATE(412),
    [anon_sym_EQ] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(2551),
    [anon_sym_else] = ACTIONS(2551),
    [anon_sym_RPAREN] = ACTIONS(2551),
    [anon_sym_while] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_RBRACK] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(4937),
    [anon_sym_GT] = ACTIONS(2551),
    [anon_sym_EQ_GT] = ACTIONS(2551),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2551),
    [sym_comment] = ACTIONS(3),
  },
  [1806] = {
    [sym__call_signature] = STATE(2524),
    [sym__initializer] = STATE(2496),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2288),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4949),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4951),
    [anon_sym_BANG] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4949),
  },
  [1807] = {
    [sym_type_arguments] = STATE(416),
    [sym_default_type] = STATE(2758),
    [sym_constraint] = STATE(2324),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_COMMA] = ACTIONS(4957),
    [anon_sym_COLON] = ACTIONS(4960),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(4937),
    [anon_sym_GT] = ACTIONS(4957),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(4960),
    [anon_sym_is] = ACTIONS(3292),
  },
  [1808] = {
    [sym_type_arguments] = STATE(1856),
    [anon_sym_EQ] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(4962),
    [anon_sym_DOT] = ACTIONS(4964),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3205),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2486),
    [sym__automatic_semicolon] = ACTIONS(2486),
  },
  [1809] = {
    [sym__call_signature] = STATE(2160),
    [sym__initializer] = STATE(2496),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2288),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4949),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4949),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4966),
    [anon_sym_BANG] = ACTIONS(4953),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4949),
  },
  [1810] = {
    [sym__call_signature] = STATE(2415),
    [sym__initializer] = STATE(2425),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2125),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4968),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4968),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4968),
  },
  [1811] = {
    [sym__call_signature] = STATE(2176),
    [sym__initializer] = STATE(2425),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2125),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4968),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4968),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4974),
    [anon_sym_BANG] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4968),
  },
  [1812] = {
    [sym__call_signature] = STATE(2190),
    [sym__initializer] = STATE(2443),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2141),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4976),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4976),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4978),
    [anon_sym_BANG] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4976),
  },
  [1813] = {
    [sym__call_signature] = STATE(2210),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2204),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4982),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4982),
    [sym__automatic_semicolon] = ACTIONS(4982),
  },
  [1814] = {
    [sym__call_signature] = STATE(2231),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2202),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4986),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4986),
    [sym__automatic_semicolon] = ACTIONS(4986),
  },
  [1815] = {
    [sym__call_signature] = STATE(1963),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2163),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_RBRACE] = ACTIONS(4990),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym_COLON] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4990),
    [sym__automatic_semicolon] = ACTIONS(4990),
  },
  [1816] = {
    [sym__call_signature] = STATE(1978),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2204),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(4982),
    [anon_sym_RBRACE] = ACTIONS(4982),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4982),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4982),
    [sym__automatic_semicolon] = ACTIONS(4982),
  },
  [1817] = {
    [sym__call_signature] = STATE(2182),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2163),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_RBRACE] = ACTIONS(4990),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4990),
    [sym__automatic_semicolon] = ACTIONS(4990),
  },
  [1818] = {
    [sym__call_signature] = STATE(1970),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2121),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5000),
    [anon_sym_RBRACE] = ACTIONS(5000),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5000),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5000),
    [sym__automatic_semicolon] = ACTIONS(5000),
  },
  [1819] = {
    [sym__call_signature] = STATE(2275),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2121),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5000),
    [anon_sym_RBRACE] = ACTIONS(5000),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5000),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5004),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5000),
    [sym__automatic_semicolon] = ACTIONS(5000),
  },
  [1820] = {
    [sym__call_signature] = STATE(1975),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2202),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_RBRACE] = ACTIONS(4986),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(4986),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4986),
    [sym__automatic_semicolon] = ACTIONS(4986),
  },
  [1821] = {
    [sym__call_signature] = STATE(1974),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2197),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5008),
    [anon_sym_RBRACE] = ACTIONS(5008),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5008),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5008),
    [sym__automatic_semicolon] = ACTIONS(5008),
  },
  [1822] = {
    [sym__call_signature] = STATE(2179),
    [sym__initializer] = STATE(2419),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2115),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5010),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5010),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5010),
  },
  [1823] = {
    [sym__call_signature] = STATE(2217),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2287),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5012),
    [anon_sym_RBRACE] = ACTIONS(5012),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5012),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5012),
    [sym__automatic_semicolon] = ACTIONS(5012),
  },
  [1824] = {
    [sym__call_signature] = STATE(1972),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2084),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5014),
    [anon_sym_RBRACE] = ACTIONS(5014),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5014),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5014),
    [sym__automatic_semicolon] = ACTIONS(5014),
  },
  [1825] = {
    [anon_sym_EQ] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_COMMA] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2338),
    [anon_sym_DOT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_PIPE] = ACTIONS(2340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2338),
    [sym__automatic_semicolon] = ACTIONS(2338),
  },
  [1826] = {
    [sym__call_signature] = STATE(2194),
    [sym__initializer] = STATE(2485),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2181),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5016),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5016),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5016),
  },
  [1827] = {
    [sym__call_signature] = STATE(1977),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2208),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RBRACE] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5018),
    [sym__automatic_semicolon] = ACTIONS(5018),
  },
  [1828] = {
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_else] = ACTIONS(2580),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_GT] = ACTIONS(2580),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [1829] = {
    [sym_type_arguments] = STATE(416),
    [anon_sym_EQ] = ACTIONS(3499),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_RPAREN] = ACTIONS(5024),
    [anon_sym_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_LT] = ACTIONS(4937),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_QMARK] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(2486),
    [anon_sym_PIPE] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(3292),
  },
  [1830] = {
    [anon_sym_EQ] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_else] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_RBRACK] = ACTIONS(2590),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_EQ_GT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [1831] = {
    [anon_sym_EQ] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_else] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_RBRACK] = ACTIONS(2562),
    [anon_sym_GT] = ACTIONS(2562),
    [anon_sym_EQ_GT] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [1832] = {
    [sym__call_signature] = STATE(2220),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2208),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_RBRACE] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5018),
    [sym__automatic_semicolon] = ACTIONS(5018),
  },
  [1833] = {
    [sym__call_signature] = STATE(2265),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2197),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5008),
    [anon_sym_RBRACE] = ACTIONS(5008),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5008),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5008),
    [sym__automatic_semicolon] = ACTIONS(5008),
  },
  [1834] = {
    [anon_sym_EQ] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_else] = ACTIONS(2598),
    [anon_sym_RPAREN] = ACTIONS(2598),
    [anon_sym_while] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_RBRACK] = ACTIONS(2598),
    [anon_sym_GT] = ACTIONS(2598),
    [anon_sym_EQ_GT] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [1835] = {
    [sym_type_arguments] = STATE(1870),
    [anon_sym_EQ] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(2551),
    [anon_sym_COMMA] = ACTIONS(2551),
    [anon_sym_RBRACE] = ACTIONS(2551),
    [anon_sym_SEMI] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(4962),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2551),
    [sym__automatic_semicolon] = ACTIONS(2551),
  },
  [1836] = {
    [sym__call_signature] = STATE(2424),
    [sym__initializer] = STATE(2419),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2115),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5010),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5010),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5010),
  },
  [1837] = {
    [sym__call_signature] = STATE(2174),
    [sym__initializer] = STATE(2427),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2167),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5027),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5027),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5027),
  },
  [1838] = {
    [sym__call_signature] = STATE(2451),
    [sym__initializer] = STATE(2485),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2181),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5016),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5016),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5016),
  },
  [1839] = {
    [sym__call_signature] = STATE(2086),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2084),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5014),
    [anon_sym_RBRACE] = ACTIONS(5014),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5014),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5014),
    [sym__automatic_semicolon] = ACTIONS(5014),
  },
  [1840] = {
    [anon_sym_EQ] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_else] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_while] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_RBRACK] = ACTIONS(2602),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_EQ_GT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [1841] = {
    [sym__call_signature] = STATE(2264),
    [sym__initializer] = STATE(2533),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2248),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5029),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5029),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5029),
  },
  [1842] = {
    [sym__call_signature] = STATE(1980),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_annotation] = STATE(2287),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_COMMA] = ACTIONS(5012),
    [anon_sym_RBRACE] = ACTIONS(5012),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(5012),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5012),
    [sym__automatic_semicolon] = ACTIONS(5012),
  },
  [1843] = {
    [anon_sym_EQ] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1233),
    [sym__automatic_semicolon] = ACTIONS(1233),
  },
  [1844] = {
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_BANG] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1845] = {
    [aux_sym_object_repeat1] = STATE(2556),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1846] = {
    [aux_sym_object_repeat1] = STATE(2538),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1847] = {
    [aux_sym_object_repeat1] = STATE(2507),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1848] = {
    [aux_sym_object_repeat1] = STATE(2396),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1849] = {
    [anon_sym_EQ] = ACTIONS(4497),
    [anon_sym_COMMA] = ACTIONS(4497),
    [anon_sym_RBRACE] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4497),
    [anon_sym_SEMI] = ACTIONS(4497),
    [anon_sym_COLON] = ACTIONS(4497),
    [anon_sym_LT] = ACTIONS(4497),
    [anon_sym_QMARK] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(4497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4497),
    [sym__automatic_semicolon] = ACTIONS(4497),
  },
  [1850] = {
    [anon_sym_EQ] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_DOT] = ACTIONS(4964),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2392),
    [sym__automatic_semicolon] = ACTIONS(2392),
  },
  [1851] = {
    [anon_sym_EQ] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_COMMA] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_DOT] = ACTIONS(5031),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_PIPE] = ACTIONS(2344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2342),
    [sym__automatic_semicolon] = ACTIONS(2342),
  },
  [1852] = {
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(3577),
    [anon_sym_RBRACE] = ACTIONS(3577),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3537),
    [sym__automatic_semicolon] = ACTIONS(3537),
  },
  [1853] = {
    [anon_sym_EQ] = ACTIONS(2580),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2580),
    [sym__automatic_semicolon] = ACTIONS(2580),
  },
  [1854] = {
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2562),
    [sym__automatic_semicolon] = ACTIONS(2562),
  },
  [1855] = {
    [anon_sym_EQ] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2424),
    [sym__automatic_semicolon] = ACTIONS(2424),
  },
  [1856] = {
    [anon_sym_EQ] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2388),
    [sym__automatic_semicolon] = ACTIONS(2388),
  },
  [1857] = {
    [anon_sym_EQ] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_PIPE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2466),
    [sym__automatic_semicolon] = ACTIONS(2466),
  },
  [1858] = {
    [anon_sym_EQ] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2602),
    [sym__automatic_semicolon] = ACTIONS(2602),
  },
  [1859] = {
    [anon_sym_EQ] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [anon_sym_COMMA] = ACTIONS(2454),
    [anon_sym_RBRACE] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [anon_sym_AMP] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2454),
    [sym__automatic_semicolon] = ACTIONS(2454),
  },
  [1860] = {
    [sym_class_heritage] = STATE(2640),
    [sym_class_body] = STATE(1445),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1926),
    [sym_identifier] = ACTIONS(5037),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1861] = {
    [anon_sym_EQ] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2436),
    [sym__automatic_semicolon] = ACTIONS(2436),
  },
  [1862] = {
    [anon_sym_EQ] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2406),
    [sym__automatic_semicolon] = ACTIONS(2406),
  },
  [1863] = {
    [anon_sym_EQ] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2450),
    [anon_sym_COMMA] = ACTIONS(2450),
    [anon_sym_RBRACE] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2450),
    [sym__automatic_semicolon] = ACTIONS(2450),
  },
  [1864] = {
    [anon_sym_EQ] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2412),
    [sym__automatic_semicolon] = ACTIONS(2412),
  },
  [1865] = {
    [anon_sym_EQ] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2446),
    [sym__automatic_semicolon] = ACTIONS(2446),
  },
  [1866] = {
    [anon_sym_EQ] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2428),
    [sym__automatic_semicolon] = ACTIONS(2428),
  },
  [1867] = {
    [anon_sym_EQ] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_COMMA] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2398),
    [sym__automatic_semicolon] = ACTIONS(2398),
  },
  [1868] = {
    [sym_class_heritage] = STATE(2724),
    [sym_class_body] = STATE(1075),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1929),
    [sym_identifier] = ACTIONS(5047),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1869] = {
    [sym_class_heritage] = STATE(2640),
    [sym_class_body] = STATE(1445),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1926),
    [sym_identifier] = ACTIONS(5051),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1870] = {
    [anon_sym_EQ] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_PIPE] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2348),
    [sym__automatic_semicolon] = ACTIONS(2348),
  },
  [1871] = {
    [anon_sym_EQ] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2458),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_RBRACE] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2458),
    [anon_sym_AMP] = ACTIONS(2458),
    [anon_sym_PIPE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2458),
    [sym__automatic_semicolon] = ACTIONS(2458),
  },
  [1872] = {
    [sym_class_heritage] = STATE(2630),
    [sym_class_body] = STATE(1086),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1948),
    [sym_identifier] = ACTIONS(5053),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1873] = {
    [anon_sym_EQ] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2474),
    [anon_sym_COMMA] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_PIPE] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2474),
    [sym__automatic_semicolon] = ACTIONS(2474),
  },
  [1874] = {
    [sym_class_heritage] = STATE(2744),
    [sym_class_body] = STATE(1491),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1937),
    [sym_identifier] = ACTIONS(5055),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1875] = {
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2462),
    [anon_sym_COMMA] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_PIPE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2462),
    [sym__automatic_semicolon] = ACTIONS(2462),
  },
  [1876] = {
    [anon_sym_EQ] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(5045),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2416),
    [sym__automatic_semicolon] = ACTIONS(2416),
  },
  [1877] = {
    [anon_sym_EQ] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2470),
    [anon_sym_COMMA] = ACTIONS(2470),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_PIPE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2470),
    [sym__automatic_semicolon] = ACTIONS(2470),
  },
  [1878] = {
    [anon_sym_EQ] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2432),
    [sym__automatic_semicolon] = ACTIONS(2432),
  },
  [1879] = {
    [anon_sym_EQ] = ACTIONS(589),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_COMMA] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(589),
    [sym__automatic_semicolon] = ACTIONS(589),
  },
  [1880] = {
    [anon_sym_EQ] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_COMMA] = ACTIONS(2380),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2380),
    [anon_sym_PIPE] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2380),
    [sym__automatic_semicolon] = ACTIONS(2380),
  },
  [1881] = {
    [sym_import_clause] = STATE(2743),
    [sym_namespace_import] = STATE(2833),
    [sym_named_imports] = STATE(2833),
    [sym_string] = STATE(2745),
    [sym_import_require_clause] = STATE(2745),
    [sym_identifier] = ACTIONS(5057),
    [anon_sym_STAR] = ACTIONS(5059),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
  },
  [1882] = {
    [anon_sym_EQ] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2442),
    [anon_sym_COMMA] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2442),
    [sym__automatic_semicolon] = ACTIONS(2442),
  },
  [1883] = {
    [sym_class_heritage] = STATE(2764),
    [sym_class_body] = STATE(1640),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1992),
    [sym_identifier] = ACTIONS(5061),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1884] = {
    [sym_class_heritage] = STATE(2744),
    [sym_class_body] = STATE(1491),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1937),
    [sym_identifier] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1885] = {
    [sym_class_heritage] = STATE(2731),
    [sym_class_body] = STATE(1572),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1995),
    [sym_identifier] = ACTIONS(5067),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1886] = {
    [anon_sym_EQ] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(4497),
    [anon_sym_RBRACE] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4497),
    [anon_sym_SEMI] = ACTIONS(4497),
    [anon_sym_COLON] = ACTIONS(4497),
    [anon_sym_LT] = ACTIONS(4497),
    [anon_sym_QMARK] = ACTIONS(4497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4497),
    [sym__automatic_semicolon] = ACTIONS(4497),
  },
  [1887] = {
    [anon_sym_EQ] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2482),
    [anon_sym_PIPE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2482),
    [sym__automatic_semicolon] = ACTIONS(2482),
  },
  [1888] = {
    [anon_sym_EQ] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_COMMA] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_PIPE] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2384),
    [sym__automatic_semicolon] = ACTIONS(2384),
  },
  [1889] = {
    [sym_class_heritage] = STATE(2640),
    [sym_class_body] = STATE(1445),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1926),
    [sym_identifier] = ACTIONS(5069),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1890] = {
    [anon_sym_EQ] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2402),
    [sym__automatic_semicolon] = ACTIONS(2402),
  },
  [1891] = {
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2420),
    [sym__automatic_semicolon] = ACTIONS(2420),
  },
  [1892] = {
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2478),
    [anon_sym_COMMA] = ACTIONS(2478),
    [anon_sym_RBRACE] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2478),
    [anon_sym_PIPE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2478),
    [sym__automatic_semicolon] = ACTIONS(2478),
  },
  [1893] = {
    [anon_sym_EQ] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2598),
    [sym__automatic_semicolon] = ACTIONS(2598),
  },
  [1894] = {
    [sym_class_heritage] = STATE(2744),
    [sym_class_body] = STATE(1491),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1937),
    [sym_identifier] = ACTIONS(5071),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5041),
    [anon_sym_extends] = ACTIONS(5043),
  },
  [1895] = {
    [anon_sym_EQ] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2590),
    [sym__automatic_semicolon] = ACTIONS(2590),
  },
  [1896] = {
    [sym_class_heritage] = STATE(2594),
    [sym_class_body] = STATE(992),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1968),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1897] = {
    [sym_class_heritage] = STATE(2713),
    [sym_class_body] = STATE(498),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1931),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1898] = {
    [sym_class_heritage] = STATE(2622),
    [sym_class_body] = STATE(1417),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1946),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1899] = {
    [anon_sym_EQ] = ACTIONS(5079),
    [anon_sym_LBRACE] = ACTIONS(5079),
    [anon_sym_COMMA] = ACTIONS(5079),
    [anon_sym_RBRACE] = ACTIONS(5079),
    [anon_sym_SEMI] = ACTIONS(5079),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5079),
    [sym__automatic_semicolon] = ACTIONS(5079),
  },
  [1900] = {
    [sym_class_heritage] = STATE(2746),
    [sym_class_body] = STATE(532),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1993),
    [anon_sym_LBRACE] = ACTIONS(5081),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1901] = {
    [sym_class_heritage] = STATE(2763),
    [sym_class_body] = STATE(113),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1987),
    [anon_sym_LBRACE] = ACTIONS(5083),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1902] = {
    [sym_class_heritage] = STATE(2723),
    [sym_class_body] = STATE(115),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1949),
    [anon_sym_LBRACE] = ACTIONS(5083),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1903] = {
    [sym_class_heritage] = STATE(2610),
    [sym_class_body] = STATE(2123),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1965),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1904] = {
    [sym__initializer] = STATE(2425),
    [sym_type_annotation] = STATE(2125),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4968),
    [anon_sym_SEMI] = ACTIONS(4968),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_QMARK] = ACTIONS(4972),
    [anon_sym_BANG] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4968),
  },
  [1905] = {
    [sym_class_heritage] = STATE(2674),
    [sym_class_body] = STATE(504),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1951),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1906] = {
    [sym_class_heritage] = STATE(2694),
    [sym_class_body] = STATE(1550),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1997),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1907] = {
    [sym_class_heritage] = STATE(2730),
    [sym_class_body] = STATE(1646),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1996),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1908] = {
    [sym_class_heritage] = STATE(2655),
    [sym_class_body] = STATE(1298),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1943),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1909] = {
    [sym_class_heritage] = STATE(2619),
    [sym_class_body] = STATE(1422),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1962),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1910] = {
    [sym_class_heritage] = STATE(2608),
    [sym_class_body] = STATE(2221),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1956),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1911] = {
    [sym_class_heritage] = STATE(2578),
    [sym_class_body] = STATE(1371),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1967),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1912] = {
    [sym_class_heritage] = STATE(2570),
    [sym_class_body] = STATE(2158),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1927),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1913] = {
    [sym__initializer] = STATE(2443),
    [sym_type_annotation] = STATE(2141),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4976),
    [anon_sym_SEMI] = ACTIONS(4976),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_QMARK] = ACTIONS(4980),
    [anon_sym_BANG] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4976),
  },
  [1914] = {
    [sym_class_heritage] = STATE(2604),
    [sym_class_body] = STATE(1136),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [sym_type_parameters] = STATE(1957),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1915] = {
    [aux_sym_object_repeat1] = STATE(2538),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
  },
  [1916] = {
    [aux_sym_object_repeat1] = STATE(2507),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
  },
  [1917] = {
    [aux_sym_object_repeat1] = STATE(2447),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(4706),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
  },
  [1918] = {
    [sym_type_annotation] = STATE(2026),
    [anon_sym_LBRACE] = ACTIONS(5085),
    [anon_sym_COMMA] = ACTIONS(5085),
    [anon_sym_RBRACE] = ACTIONS(5085),
    [anon_sym_SEMI] = ACTIONS(5085),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5085),
    [sym__automatic_semicolon] = ACTIONS(5085),
  },
  [1919] = {
    [aux_sym_object_repeat1] = STATE(2396),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
  },
  [1920] = {
    [sym_statement_block] = STATE(2164),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1059),
    [anon_sym_DOT] = ACTIONS(5031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1059),
    [sym__automatic_semicolon] = ACTIONS(1059),
  },
  [1921] = {
    [anon_sym_EQ] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(2450),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(2450),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_AMP] = ACTIONS(2450),
    [anon_sym_PIPE] = ACTIONS(2450),
    [sym_comment] = ACTIONS(3),
  },
  [1922] = {
    [sym_type_annotation] = STATE(2017),
    [anon_sym_LBRACE] = ACTIONS(5089),
    [anon_sym_COMMA] = ACTIONS(5089),
    [anon_sym_RBRACE] = ACTIONS(5089),
    [anon_sym_SEMI] = ACTIONS(5089),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5089),
    [sym__automatic_semicolon] = ACTIONS(5089),
  },
  [1923] = {
    [anon_sym_EQ] = ACTIONS(618),
    [anon_sym_COMMA] = ACTIONS(618),
    [anon_sym_RPAREN] = ACTIONS(5091),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(589),
    [anon_sym_QMARK] = ACTIONS(618),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_PIPE] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
  },
  [1924] = {
    [aux_sym_object_repeat1] = STATE(2556),
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
  },
  [1925] = {
    [anon_sym_EQ] = ACTIONS(3499),
    [anon_sym_COMMA] = ACTIONS(3499),
    [anon_sym_RPAREN] = ACTIONS(5094),
    [anon_sym_COLON] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(2551),
    [anon_sym_QMARK] = ACTIONS(3499),
    [anon_sym_AMP] = ACTIONS(2551),
    [anon_sym_PIPE] = ACTIONS(2551),
    [sym_comment] = ACTIONS(3),
  },
  [1926] = {
    [sym_class_heritage] = STATE(2589),
    [sym_class_body] = STATE(1399),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1927] = {
    [sym_class_heritage] = STATE(2603),
    [sym_class_body] = STATE(2227),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1928] = {
    [sym_default_type] = STATE(2758),
    [sym_constraint] = STATE(2324),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_COMMA] = ACTIONS(5097),
    [anon_sym_COLON] = ACTIONS(4960),
    [anon_sym_GT] = ACTIONS(5097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(4960),
  },
  [1929] = {
    [sym_class_heritage] = STATE(2652),
    [sym_class_body] = STATE(1089),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1930] = {
    [sym__call_signature] = STATE(2711),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5099),
    [anon_sym_STAR] = ACTIONS(5101),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [1931] = {
    [sym_class_heritage] = STATE(2606),
    [sym_class_body] = STATE(494),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1932] = {
    [sym_nested_identifier] = STATE(1920),
    [sym_string] = STATE(1936),
    [sym__module] = STATE(2130),
    [sym_identifier] = ACTIONS(5105),
    [anon_sym_DOT] = ACTIONS(5107),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
  },
  [1933] = {
    [sym_extends_clause] = STATE(2511),
    [sym_object_type] = STATE(2225),
    [sym_type_parameters] = STATE(2198),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_LT] = ACTIONS(5109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [1934] = {
    [anon_sym_LBRACE] = ACTIONS(5113),
    [anon_sym_COMMA] = ACTIONS(5113),
    [anon_sym_RBRACE] = ACTIONS(5113),
    [anon_sym_SEMI] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5113),
    [sym__automatic_semicolon] = ACTIONS(5113),
  },
  [1935] = {
    [anon_sym_LBRACE] = ACTIONS(3776),
    [anon_sym_COMMA] = ACTIONS(3776),
    [anon_sym_RBRACE] = ACTIONS(3776),
    [anon_sym_SEMI] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3776),
    [sym__automatic_semicolon] = ACTIONS(3776),
  },
  [1936] = {
    [sym_statement_block] = STATE(2164),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [anon_sym_COMMA] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1059),
    [sym__automatic_semicolon] = ACTIONS(1059),
  },
  [1937] = {
    [sym_class_heritage] = STATE(2585),
    [sym_class_body] = STATE(1443),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1938] = {
    [sym__initializer] = STATE(2427),
    [sym_type_annotation] = STATE(2167),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5027),
    [anon_sym_SEMI] = ACTIONS(5027),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5027),
  },
  [1939] = {
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_COMMA] = ACTIONS(5115),
    [anon_sym_RBRACE] = ACTIONS(5115),
    [anon_sym_SEMI] = ACTIONS(5115),
    [anon_sym_COLON] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5115),
    [sym__automatic_semicolon] = ACTIONS(5115),
  },
  [1940] = {
    [sym__call_signature] = STATE(2650),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5117),
    [anon_sym_STAR] = ACTIONS(5119),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [1941] = {
    [sym__initializer] = STATE(2533),
    [sym_type_annotation] = STATE(2248),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5029),
    [anon_sym_SEMI] = ACTIONS(5029),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5029),
  },
  [1942] = {
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5035),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2594),
    [sym__automatic_semicolon] = ACTIONS(2594),
  },
  [1943] = {
    [sym_class_heritage] = STATE(2574),
    [sym_class_body] = STATE(1313),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1944] = {
    [sym__call_signature] = STATE(2651),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_STAR] = ACTIONS(5123),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [1945] = {
    [sym_nested_identifier] = STATE(482),
    [sym_string] = STATE(506),
    [sym__module] = STATE(517),
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT] = ACTIONS(5127),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
  },
  [1946] = {
    [sym_class_heritage] = STATE(2626),
    [sym_class_body] = STATE(1414),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1947] = {
    [sym__initializer] = STATE(2568),
    [sym_type_annotation] = STATE(2314),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5131),
    [anon_sym_RPAREN] = ACTIONS(5131),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_QMARK] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
  },
  [1948] = {
    [sym_class_heritage] = STATE(2577),
    [sym_class_body] = STATE(996),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1949] = {
    [sym_class_heritage] = STATE(2696),
    [sym_class_body] = STATE(108),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1950] = {
    [sym_nested_identifier] = STATE(482),
    [sym_string] = STATE(506),
    [sym__module] = STATE(517),
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DOT] = ACTIONS(5135),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
  },
  [1951] = {
    [sym_class_heritage] = STATE(2707),
    [sym_class_body] = STATE(486),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1952] = {
    [sym_type_annotation] = STATE(2218),
    [anon_sym_COMMA] = ACTIONS(5137),
    [anon_sym_RBRACE] = ACTIONS(5137),
    [anon_sym_SEMI] = ACTIONS(5137),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5137),
    [sym__automatic_semicolon] = ACTIONS(5137),
  },
  [1953] = {
    [sym__call_signature] = STATE(2719),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5139),
    [anon_sym_STAR] = ACTIONS(5141),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [1954] = {
    [sym__call_signature] = STATE(2638),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5143),
    [anon_sym_STAR] = ACTIONS(5145),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [1955] = {
    [sym_variable_declarator] = STATE(2376),
    [sym_object] = STATE(1959),
    [sym_array] = STATE(1958),
    [sym_identifier] = ACTIONS(5147),
    [anon_sym_LBRACE] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(5153),
  },
  [1956] = {
    [sym_class_heritage] = STATE(2573),
    [sym_class_body] = STATE(2150),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1957] = {
    [sym_class_heritage] = STATE(2618),
    [sym_class_body] = STATE(994),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1958] = {
    [sym__initializer] = STATE(2441),
    [sym_type_annotation] = STATE(2152),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3798),
  },
  [1959] = {
    [sym__initializer] = STATE(2433),
    [sym_type_annotation] = STATE(2136),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(3807),
    [anon_sym_SEMI] = ACTIONS(3807),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3807),
  },
  [1960] = {
    [sym__call_signature] = STATE(2739),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5155),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [1961] = {
    [sym__call_signature] = STATE(2650),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5159),
    [anon_sym_STAR] = ACTIONS(5161),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [1962] = {
    [sym_class_heritage] = STATE(2665),
    [sym_class_body] = STATE(1470),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1963] = {
    [sym_statement_block] = STATE(2667),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_SEMI] = ACTIONS(5163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5163),
    [sym__automatic_semicolon] = ACTIONS(5163),
  },
  [1964] = {
    [sym__initializer] = STATE(2391),
    [sym_type_annotation] = STATE(2101),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(3175),
    [anon_sym_SEMI] = ACTIONS(3175),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3175),
  },
  [1965] = {
    [sym_class_heritage] = STATE(2600),
    [sym_class_body] = STATE(2186),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1966] = {
    [sym_predefined_type] = STATE(2860),
    [anon_sym_void] = ACTIONS(5165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(5165),
    [anon_sym_number] = ACTIONS(5165),
    [anon_sym_boolean] = ACTIONS(5165),
    [anon_sym_string] = ACTIONS(5165),
    [anon_sym_symbol] = ACTIONS(5165),
  },
  [1967] = {
    [sym_class_heritage] = STATE(2591),
    [sym_class_body] = STATE(1305),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1968] = {
    [sym_class_heritage] = STATE(2679),
    [sym_class_body] = STATE(1121),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1969] = {
    [sym_extends_clause] = STATE(2436),
    [sym_object_type] = STATE(568),
    [sym_type_parameters] = STATE(2120),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_LT] = ACTIONS(5109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [1970] = {
    [sym_statement_block] = STATE(2690),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [anon_sym_SEMI] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5167),
    [sym__automatic_semicolon] = ACTIONS(5167),
  },
  [1971] = {
    [anon_sym_EQ] = ACTIONS(4169),
    [anon_sym_COMMA] = ACTIONS(4742),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_COLON] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
  },
  [1972] = {
    [sym_statement_block] = STATE(2733),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5169),
    [anon_sym_RBRACE] = ACTIONS(5169),
    [anon_sym_SEMI] = ACTIONS(5169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5169),
    [sym__automatic_semicolon] = ACTIONS(5169),
  },
  [1973] = {
    [anon_sym_LBRACE] = ACTIONS(5171),
    [anon_sym_COMMA] = ACTIONS(5171),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym_SEMI] = ACTIONS(5171),
    [anon_sym_COLON] = ACTIONS(5171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5171),
    [sym__automatic_semicolon] = ACTIONS(5171),
  },
  [1974] = {
    [sym_statement_block] = STATE(2582),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5173),
    [anon_sym_RBRACE] = ACTIONS(5173),
    [anon_sym_SEMI] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5173),
    [sym__automatic_semicolon] = ACTIONS(5173),
  },
  [1975] = {
    [sym_statement_block] = STATE(2697),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5175),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [anon_sym_SEMI] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5175),
    [sym__automatic_semicolon] = ACTIONS(5175),
  },
  [1976] = {
    [anon_sym_LBRACE] = ACTIONS(5177),
    [anon_sym_COMMA] = ACTIONS(5177),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_SEMI] = ACTIONS(5177),
    [anon_sym_COLON] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5177),
    [sym__automatic_semicolon] = ACTIONS(5177),
  },
  [1977] = {
    [sym_statement_block] = STATE(2646),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5179),
    [anon_sym_RBRACE] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5179),
    [sym__automatic_semicolon] = ACTIONS(5179),
  },
  [1978] = {
    [sym_statement_block] = STATE(2643),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_SEMI] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5181),
    [sym__automatic_semicolon] = ACTIONS(5181),
  },
  [1979] = {
    [sym__call_signature] = STATE(2711),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5183),
    [anon_sym_STAR] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [1980] = {
    [sym_statement_block] = STATE(2717),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_SEMI] = ACTIONS(5187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5187),
    [sym__automatic_semicolon] = ACTIONS(5187),
  },
  [1981] = {
    [sym_statement_block] = STATE(2701),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5189),
    [anon_sym_RBRACE] = ACTIONS(5189),
    [anon_sym_SEMI] = ACTIONS(5189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5189),
    [sym__automatic_semicolon] = ACTIONS(5189),
  },
  [1982] = {
    [sym_statement_block] = STATE(2680),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5191),
    [anon_sym_RBRACE] = ACTIONS(5191),
    [anon_sym_SEMI] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5191),
    [sym__automatic_semicolon] = ACTIONS(5191),
  },
  [1983] = {
    [sym_statement_block] = STATE(2639),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5193),
    [anon_sym_RBRACE] = ACTIONS(5193),
    [anon_sym_SEMI] = ACTIONS(5193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5193),
    [sym__automatic_semicolon] = ACTIONS(5193),
  },
  [1984] = {
    [sym__call_signature] = STATE(2627),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_COLON] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5197),
    [sym_comment] = ACTIONS(3),
  },
  [1985] = {
    [sym_statement_block] = STATE(2588),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_RBRACE] = ACTIONS(5199),
    [anon_sym_SEMI] = ACTIONS(5199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5199),
    [sym__automatic_semicolon] = ACTIONS(5199),
  },
  [1986] = {
    [sym__initializer] = STATE(2485),
    [sym_type_annotation] = STATE(2181),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5016),
    [anon_sym_SEMI] = ACTIONS(5016),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5016),
  },
  [1987] = {
    [sym_class_heritage] = STATE(2754),
    [sym_class_body] = STATE(124),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1988] = {
    [sym__initializer] = STATE(2419),
    [sym_type_annotation] = STATE(2115),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5010),
    [anon_sym_SEMI] = ACTIONS(5010),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5010),
  },
  [1989] = {
    [sym__call_signature] = STATE(2711),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5201),
    [anon_sym_STAR] = ACTIONS(5203),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [1990] = {
    [sym_type_annotation] = STATE(2185),
    [anon_sym_COMMA] = ACTIONS(5205),
    [anon_sym_RBRACE] = ACTIONS(5205),
    [anon_sym_SEMI] = ACTIONS(5205),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5205),
    [sym__automatic_semicolon] = ACTIONS(5205),
  },
  [1991] = {
    [anon_sym_EQ] = ACTIONS(5207),
    [anon_sym_LBRACE] = ACTIONS(5079),
    [anon_sym_COMMA] = ACTIONS(5079),
    [anon_sym_RPAREN] = ACTIONS(5079),
    [anon_sym_EQ_GT] = ACTIONS(5079),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [1992] = {
    [sym_class_heritage] = STATE(2740),
    [sym_class_body] = STATE(1570),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1993] = {
    [sym_class_heritage] = STATE(2672),
    [sym_class_body] = STATE(545),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1994] = {
    [sym_predefined_type] = STATE(2851),
    [anon_sym_void] = ACTIONS(5165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(5165),
    [anon_sym_number] = ACTIONS(5165),
    [anon_sym_boolean] = ACTIONS(5165),
    [anon_sym_string] = ACTIONS(5165),
    [anon_sym_symbol] = ACTIONS(5165),
  },
  [1995] = {
    [sym_class_heritage] = STATE(2703),
    [sym_class_body] = STATE(1561),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1996] = {
    [sym_class_heritage] = STATE(2700),
    [sym_class_body] = STATE(1555),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1997] = {
    [sym_class_heritage] = STATE(2684),
    [sym_class_body] = STATE(1603),
    [sym_implements_clause] = STATE(2770),
    [sym_extends_clause] = STATE(2405),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
    [anon_sym_extends] = ACTIONS(5075),
  },
  [1998] = {
    [sym_variable_declarator] = STATE(2327),
    [sym_object] = STATE(1959),
    [sym_array] = STATE(1958),
    [sym_identifier] = ACTIONS(5147),
    [anon_sym_LBRACE] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_enum] = ACTIONS(5209),
  },
  [1999] = {
    [sym__call_signature] = STATE(2650),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5211),
    [anon_sym_STAR] = ACTIONS(5213),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2000] = {
    [sym_nested_identifier] = STATE(482),
    [sym_string] = STATE(506),
    [sym__module] = STATE(517),
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
  },
  [2001] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5215),
    [anon_sym_RBRACE] = ACTIONS(3610),
    [anon_sym_SEMI] = ACTIONS(5215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3610),
    [sym__automatic_semicolon] = ACTIONS(5215),
  },
  [2002] = {
    [sym__call_signature] = STATE(2687),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5217),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2003] = {
    [sym__call_signature] = STATE(2275),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5219),
    [sym_comment] = ACTIONS(3),
  },
  [2004] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5221),
    [anon_sym_RBRACE] = ACTIONS(3612),
    [anon_sym_SEMI] = ACTIONS(5221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3612),
    [sym__automatic_semicolon] = ACTIONS(5221),
  },
  [2005] = {
    [aux_sym_object_type_repeat1] = STATE(2001),
    [anon_sym_COMMA] = ACTIONS(5221),
    [anon_sym_RBRACE] = ACTIONS(3612),
    [anon_sym_SEMI] = ACTIONS(5221),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3612),
    [sym__automatic_semicolon] = ACTIONS(5221),
  },
  [2006] = {
    [anon_sym_LBRACE] = ACTIONS(5223),
    [anon_sym_COMMA] = ACTIONS(5223),
    [anon_sym_RBRACK] = ACTIONS(5223),
    [anon_sym_GT] = ACTIONS(5223),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2007] = {
    [aux_sym_object_type_repeat1] = STATE(2035),
    [anon_sym_COMMA] = ACTIONS(5225),
    [anon_sym_RBRACE] = ACTIONS(3598),
    [anon_sym_SEMI] = ACTIONS(5225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3598),
    [sym__automatic_semicolon] = ACTIONS(5225),
  },
  [2008] = {
    [sym__call_signature] = STATE(2190),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5227),
    [sym_comment] = ACTIONS(3),
  },
  [2009] = {
    [sym__import_export_specifier] = STATE(2495),
    [sym_identifier] = ACTIONS(5229),
    [anon_sym_COMMA] = ACTIONS(5231),
    [anon_sym_RBRACE] = ACTIONS(5233),
    [anon_sym_type] = ACTIONS(5235),
    [anon_sym_typeof] = ACTIONS(5235),
    [sym_comment] = ACTIONS(3),
  },
  [2010] = {
    [sym__call_signature] = STATE(2242),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5237),
    [sym_comment] = ACTIONS(3),
  },
  [2011] = {
    [sym_nested_identifier] = STATE(482),
    [sym_string] = STATE(506),
    [sym__module] = STATE(546),
    [sym_identifier] = ACTIONS(5125),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
  },
  [2012] = {
    [aux_sym_object_type_repeat1] = STATE(2004),
    [anon_sym_COMMA] = ACTIONS(5239),
    [anon_sym_RBRACE] = ACTIONS(5241),
    [anon_sym_SEMI] = ACTIONS(5239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5241),
    [sym__automatic_semicolon] = ACTIONS(5239),
  },
  [2013] = {
    [sym__call_signature] = STATE(2736),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5243),
    [sym_comment] = ACTIONS(3),
  },
  [2014] = {
    [sym_template_substitution] = STATE(2028),
    [aux_sym_template_string_repeat1] = STATE(2028),
    [sym_escape_sequence] = ACTIONS(5245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5249),
    [sym__template_chars] = ACTIONS(5245),
  },
  [2015] = {
    [sym_variable_declarator] = STATE(2327),
    [sym_object] = STATE(1959),
    [sym_array] = STATE(1958),
    [sym_identifier] = ACTIONS(5251),
    [anon_sym_LBRACE] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [sym_comment] = ACTIONS(3),
  },
  [2016] = {
    [sym_variable_declarator] = STATE(2499),
    [sym_object] = STATE(1959),
    [sym_array] = STATE(1958),
    [sym_identifier] = ACTIONS(5251),
    [anon_sym_LBRACE] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [sym_comment] = ACTIONS(3),
  },
  [2017] = {
    [anon_sym_LBRACE] = ACTIONS(5253),
    [anon_sym_COMMA] = ACTIONS(5253),
    [anon_sym_RBRACE] = ACTIONS(5253),
    [anon_sym_SEMI] = ACTIONS(5253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5253),
    [sym__automatic_semicolon] = ACTIONS(5253),
  },
  [2018] = {
    [sym__call_signature] = STATE(2428),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5255),
    [sym_comment] = ACTIONS(3),
  },
  [2019] = {
    [sym__call_signature] = STATE(2210),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5257),
    [sym_comment] = ACTIONS(3),
  },
  [2020] = {
    [sym_template_substitution] = STATE(2014),
    [aux_sym_template_string_repeat1] = STATE(2014),
    [sym_escape_sequence] = ACTIONS(5259),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5249),
    [sym__template_chars] = ACTIONS(5259),
  },
  [2021] = {
    [sym_switch_case] = STATE(2024),
    [sym_switch_default] = STATE(2024),
    [aux_sym_switch_body_repeat1] = STATE(2024),
    [anon_sym_default] = ACTIONS(5263),
    [anon_sym_RBRACE] = ACTIONS(5265),
    [anon_sym_case] = ACTIONS(5267),
    [sym_comment] = ACTIONS(3),
  },
  [2022] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5225),
    [anon_sym_RBRACE] = ACTIONS(3598),
    [anon_sym_SEMI] = ACTIONS(5225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3598),
    [sym__automatic_semicolon] = ACTIONS(5225),
  },
  [2023] = {
    [sym__initializer] = STATE(2748),
    [sym_type_annotation] = STATE(2358),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5269),
    [anon_sym_RPAREN] = ACTIONS(5269),
    [anon_sym_COLON] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
  },
  [2024] = {
    [sym_switch_case] = STATE(2071),
    [sym_switch_default] = STATE(2071),
    [aux_sym_switch_body_repeat1] = STATE(2071),
    [anon_sym_default] = ACTIONS(5263),
    [anon_sym_RBRACE] = ACTIONS(5271),
    [anon_sym_case] = ACTIONS(5267),
    [sym_comment] = ACTIONS(3),
  },
  [2025] = {
    [sym__call_signature] = STATE(2176),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5273),
    [sym_comment] = ACTIONS(3),
  },
  [2026] = {
    [anon_sym_LBRACE] = ACTIONS(5275),
    [anon_sym_COMMA] = ACTIONS(5275),
    [anon_sym_RBRACE] = ACTIONS(5275),
    [anon_sym_SEMI] = ACTIONS(5275),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5275),
    [sym__automatic_semicolon] = ACTIONS(5275),
  },
  [2027] = {
    [sym__call_signature] = STATE(2415),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5277),
    [sym_comment] = ACTIONS(3),
  },
  [2028] = {
    [sym_template_substitution] = STATE(2028),
    [aux_sym_template_string_repeat1] = STATE(2028),
    [sym_escape_sequence] = ACTIONS(5279),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5284),
    [sym__template_chars] = ACTIONS(5279),
  },
  [2029] = {
    [aux_sym_object_type_repeat1] = STATE(2031),
    [anon_sym_COMMA] = ACTIONS(5287),
    [anon_sym_RBRACE] = ACTIONS(5289),
    [anon_sym_SEMI] = ACTIONS(5287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5289),
    [sym__automatic_semicolon] = ACTIONS(5287),
  },
  [2030] = {
    [aux_sym_object_type_repeat1] = STATE(2032),
    [anon_sym_COMMA] = ACTIONS(5291),
    [anon_sym_RBRACE] = ACTIONS(3602),
    [anon_sym_SEMI] = ACTIONS(5291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3602),
    [sym__automatic_semicolon] = ACTIONS(5291),
  },
  [2031] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5291),
    [anon_sym_RBRACE] = ACTIONS(3602),
    [anon_sym_SEMI] = ACTIONS(5291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3602),
    [sym__automatic_semicolon] = ACTIONS(5291),
  },
  [2032] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5293),
    [anon_sym_RBRACE] = ACTIONS(3604),
    [anon_sym_SEMI] = ACTIONS(5293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3604),
    [sym__automatic_semicolon] = ACTIONS(5293),
  },
  [2033] = {
    [sym_variable_declarator] = STATE(2363),
    [sym_object] = STATE(1959),
    [sym_array] = STATE(1958),
    [sym_identifier] = ACTIONS(5251),
    [anon_sym_LBRACE] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [sym_comment] = ACTIONS(3),
  },
  [2034] = {
    [sym__call_signature] = STATE(2642),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5295),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2035] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5297),
    [anon_sym_RBRACE] = ACTIONS(3620),
    [anon_sym_SEMI] = ACTIONS(5297),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3620),
    [sym__automatic_semicolon] = ACTIONS(5297),
  },
  [2036] = {
    [aux_sym_object_type_repeat1] = STATE(2039),
    [anon_sym_COMMA] = ACTIONS(5299),
    [anon_sym_RBRACE] = ACTIONS(5301),
    [anon_sym_SEMI] = ACTIONS(5299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5301),
    [sym__automatic_semicolon] = ACTIONS(5299),
  },
  [2037] = {
    [sym__import_export_specifier] = STATE(2411),
    [sym_identifier] = ACTIONS(5229),
    [anon_sym_COMMA] = ACTIONS(5303),
    [anon_sym_RBRACE] = ACTIONS(5305),
    [anon_sym_type] = ACTIONS(5235),
    [anon_sym_typeof] = ACTIONS(5235),
    [sym_comment] = ACTIONS(3),
  },
  [2038] = {
    [aux_sym_object_type_repeat1] = STATE(2043),
    [anon_sym_COMMA] = ACTIONS(5307),
    [anon_sym_RBRACE] = ACTIONS(3614),
    [anon_sym_SEMI] = ACTIONS(5307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3614),
    [sym__automatic_semicolon] = ACTIONS(5307),
  },
  [2039] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5307),
    [anon_sym_RBRACE] = ACTIONS(3614),
    [anon_sym_SEMI] = ACTIONS(5307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3614),
    [sym__automatic_semicolon] = ACTIONS(5307),
  },
  [2040] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5309),
    [anon_sym_RBRACE] = ACTIONS(3600),
    [anon_sym_SEMI] = ACTIONS(5309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3600),
    [sym__automatic_semicolon] = ACTIONS(5309),
  },
  [2041] = {
    [anon_sym_EQ] = ACTIONS(3537),
    [anon_sym_COMMA] = ACTIONS(3537),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
  },
  [2042] = {
    [sym__call_signature] = STATE(2753),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5311),
    [sym_comment] = ACTIONS(3),
  },
  [2043] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5313),
    [anon_sym_RBRACE] = ACTIONS(3592),
    [anon_sym_SEMI] = ACTIONS(5313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3592),
    [sym__automatic_semicolon] = ACTIONS(5313),
  },
  [2044] = {
    [sym__call_signature] = STATE(2273),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5315),
    [sym_comment] = ACTIONS(3),
  },
  [2045] = {
    [sym__call_signature] = STATE(2614),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5317),
    [sym_comment] = ACTIONS(3),
  },
  [2046] = {
    [sym__call_signature] = STATE(2231),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
  },
  [2047] = {
    [sym__call_signature] = STATE(2160),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5321),
    [sym_comment] = ACTIONS(3),
  },
  [2048] = {
    [sym__call_signature] = STATE(2721),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5323),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2049] = {
    [sym__call_signature] = STATE(2732),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5325),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2050] = {
    [sym__call_signature] = STATE(2687),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2051] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(5329),
  },
  [2052] = {
    [aux_sym_object_type_repeat1] = STATE(2040),
    [anon_sym_COMMA] = ACTIONS(5329),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_SEMI] = ACTIONS(5329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3616),
    [sym__automatic_semicolon] = ACTIONS(5329),
  },
  [2053] = {
    [sym_variable_declarator] = STATE(2378),
    [sym_object] = STATE(1959),
    [sym_array] = STATE(1958),
    [sym_identifier] = ACTIONS(5251),
    [anon_sym_LBRACE] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [sym_comment] = ACTIONS(3),
  },
  [2054] = {
    [sym_variable_declarator] = STATE(2376),
    [sym_object] = STATE(1959),
    [sym_array] = STATE(1958),
    [sym_identifier] = ACTIONS(5251),
    [anon_sym_LBRACE] = ACTIONS(5149),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [sym_comment] = ACTIONS(3),
  },
  [2055] = {
    [sym_type_arguments] = STATE(412),
    [aux_sym_extends_clause_repeat1] = STATE(2372),
    [anon_sym_LBRACE] = ACTIONS(4005),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_LT] = ACTIONS(4937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4005),
  },
  [2056] = {
    [anon_sym_EQ] = ACTIONS(4497),
    [anon_sym_COMMA] = ACTIONS(4497),
    [anon_sym_RBRACE] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4497),
    [anon_sym_LT] = ACTIONS(4497),
    [anon_sym_QMARK] = ACTIONS(4497),
    [sym_comment] = ACTIONS(3),
  },
  [2057] = {
    [sym__call_signature] = STATE(2260),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5331),
    [sym_comment] = ACTIONS(3),
  },
  [2058] = {
    [sym__call_signature] = STATE(2642),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5333),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2059] = {
    [sym_template_substitution] = STATE(2028),
    [aux_sym_template_string_repeat1] = STATE(2028),
    [sym_escape_sequence] = ACTIONS(5245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5249),
    [sym__template_chars] = ACTIONS(5245),
  },
  [2060] = {
    [sym__call_signature] = STATE(2599),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5337),
    [sym_comment] = ACTIONS(3),
  },
  [2061] = {
    [sym__call_signature] = STATE(2087),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5339),
    [sym_comment] = ACTIONS(3),
  },
  [2062] = {
    [sym__call_signature] = STATE(2648),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5341),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2063] = {
    [sym__call_signature] = STATE(2642),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5343),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2064] = {
    [sym__call_signature] = STATE(2687),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5345),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2065] = {
    [aux_sym_object_type_repeat1] = STATE(2051),
    [anon_sym_COMMA] = ACTIONS(5347),
    [anon_sym_RBRACE] = ACTIONS(5349),
    [anon_sym_SEMI] = ACTIONS(5347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5349),
    [sym__automatic_semicolon] = ACTIONS(5347),
  },
  [2066] = {
    [sym__call_signature] = STATE(2616),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [sym_identifier] = ACTIONS(5351),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2067] = {
    [sym_template_substitution] = STATE(2076),
    [aux_sym_template_string_repeat1] = STATE(2076),
    [sym_escape_sequence] = ACTIONS(5353),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5249),
    [sym__template_chars] = ACTIONS(5353),
  },
  [2068] = {
    [sym_type_arguments] = STATE(2478),
    [aux_sym_extends_clause_repeat1] = STATE(2336),
    [anon_sym_LBRACE] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3454),
    [anon_sym_LT] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
  },
  [2069] = {
    [sym__call_signature] = STATE(1970),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5359),
    [sym_comment] = ACTIONS(3),
  },
  [2070] = {
    [sym_nested_identifier] = STATE(1920),
    [sym_string] = STATE(1936),
    [sym__module] = STATE(2114),
    [sym_identifier] = ACTIONS(5105),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
  },
  [2071] = {
    [sym_switch_case] = STATE(2071),
    [sym_switch_default] = STATE(2071),
    [aux_sym_switch_body_repeat1] = STATE(2071),
    [anon_sym_default] = ACTIONS(5361),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_case] = ACTIONS(5366),
    [sym_comment] = ACTIONS(3),
  },
  [2072] = {
    [sym__call_signature] = STATE(1975),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5369),
    [sym_comment] = ACTIONS(3),
  },
  [2073] = {
    [sym__call_signature] = STATE(1978),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5371),
    [sym_comment] = ACTIONS(3),
  },
  [2074] = {
    [sym_nested_identifier] = STATE(1920),
    [sym_string] = STATE(1936),
    [sym__module] = STATE(2130),
    [sym_identifier] = ACTIONS(5105),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
  },
  [2075] = {
    [aux_sym_object_type_repeat1] = STATE(2022),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_RBRACE] = ACTIONS(5375),
    [anon_sym_SEMI] = ACTIONS(5373),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5375),
    [sym__automatic_semicolon] = ACTIONS(5373),
  },
  [2076] = {
    [sym_template_substitution] = STATE(2028),
    [aux_sym_template_string_repeat1] = STATE(2028),
    [sym_escape_sequence] = ACTIONS(5245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5249),
    [sym__template_chars] = ACTIONS(5245),
  },
  [2077] = {
    [sym_template_substitution] = STATE(2059),
    [aux_sym_template_string_repeat1] = STATE(2059),
    [sym_escape_sequence] = ACTIONS(5379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5249),
    [sym__template_chars] = ACTIONS(5379),
  },
  [2078] = {
    [sym__call_signature] = STATE(2691),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5383),
    [sym_comment] = ACTIONS(3),
  },
  [2079] = {
    [sym__call_signature] = STATE(1981),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5385),
    [sym_comment] = ACTIONS(3),
  },
  [2080] = {
    [sym__call_signature] = STATE(1983),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(5387),
    [sym_comment] = ACTIONS(3),
  },
  [2081] = {
    [aux_sym_object_type_repeat1] = STATE(2081),
    [anon_sym_COMMA] = ACTIONS(5389),
    [anon_sym_RBRACE] = ACTIONS(5392),
    [anon_sym_SEMI] = ACTIONS(5389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5392),
    [sym__automatic_semicolon] = ACTIONS(5389),
  },
  [2082] = {
    [anon_sym_EQ] = ACTIONS(5394),
    [anon_sym_COMMA] = ACTIONS(5394),
    [anon_sym_RPAREN] = ACTIONS(5394),
    [anon_sym_COLON] = ACTIONS(5394),
    [anon_sym_QMARK] = ACTIONS(5394),
    [sym_comment] = ACTIONS(3),
  },
  [2083] = {
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2889),
    [sym__automatic_semicolon] = ACTIONS(2889),
  },
  [2084] = {
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5396),
    [anon_sym_SEMI] = ACTIONS(5396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5396),
    [sym__automatic_semicolon] = ACTIONS(5396),
  },
  [2085] = {
    [anon_sym_EQ] = ACTIONS(5398),
    [anon_sym_LBRACE] = ACTIONS(5398),
    [anon_sym_LPAREN] = ACTIONS(5398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5398),
    [anon_sym_extends] = ACTIONS(5398),
  },
  [2086] = {
    [anon_sym_COMMA] = ACTIONS(5169),
    [anon_sym_RBRACE] = ACTIONS(5169),
    [anon_sym_SEMI] = ACTIONS(5169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5169),
    [sym__automatic_semicolon] = ACTIONS(5169),
  },
  [2087] = {
    [sym_statement_block] = STATE(1746),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5189),
    [anon_sym_SEMI] = ACTIONS(5189),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5189),
  },
  [2088] = {
    [sym__call_signature] = STATE(2451),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2089] = {
    [anon_sym_COMMA] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_SEMI] = ACTIONS(2722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2722),
    [sym__automatic_semicolon] = ACTIONS(2722),
  },
  [2090] = {
    [aux_sym_implements_clause_repeat1] = STATE(2389),
    [anon_sym_COMMA] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5404),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2091] = {
    [sym__call_signature] = STATE(2330),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2092] = {
    [anon_sym_COMMA] = ACTIONS(2718),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_SEMI] = ACTIONS(2718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2718),
    [sym__automatic_semicolon] = ACTIONS(2718),
  },
  [2093] = {
    [anon_sym_COMMA] = ACTIONS(2710),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_SEMI] = ACTIONS(2710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2710),
    [sym__automatic_semicolon] = ACTIONS(2710),
  },
  [2094] = {
    [sym__call_signature] = STATE(2656),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2095] = {
    [aux_sym_implements_clause_repeat1] = STATE(2412),
    [anon_sym_COMMA] = ACTIONS(5406),
    [anon_sym_GT] = ACTIONS(5408),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2096] = {
    [sym_decorator] = STATE(1798),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [anon_sym_export] = ACTIONS(5410),
    [anon_sym_class] = ACTIONS(5412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2097] = {
    [aux_sym_implements_clause_repeat1] = STATE(2564),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(5416),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2098] = {
    [sym__call_signature] = STATE(2664),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2099] = {
    [sym__import_export_specifier] = STATE(2718),
    [sym_identifier] = ACTIONS(5229),
    [anon_sym_RBRACE] = ACTIONS(5418),
    [anon_sym_type] = ACTIONS(5235),
    [anon_sym_typeof] = ACTIONS(5235),
    [sym_comment] = ACTIONS(3),
  },
  [2100] = {
    [sym__call_signature] = STATE(2734),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2101] = {
    [sym__initializer] = STATE(2502),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(5420),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5420),
  },
  [2102] = {
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2925),
    [sym__automatic_semicolon] = ACTIONS(2925),
  },
  [2103] = {
    [sym__call_signature] = STATE(1985),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2104] = {
    [anon_sym_COMMA] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_SEMI] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2905),
    [sym__automatic_semicolon] = ACTIONS(2905),
  },
  [2105] = {
    [sym__call_signature] = STATE(2676),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2106] = {
    [sym__call_signature] = STATE(1982),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2107] = {
    [sym__call_signature] = STATE(1980),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2108] = {
    [anon_sym_EQ] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_COLON] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3671),
  },
  [2109] = {
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_RBRACE] = ACTIONS(5199),
    [anon_sym_SEMI] = ACTIONS(5199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5199),
    [sym__automatic_semicolon] = ACTIONS(5199),
  },
  [2110] = {
    [sym__call_signature] = STATE(2686),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2111] = {
    [aux_sym_implements_clause_repeat1] = STATE(2435),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(5422),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2112] = {
    [sym__call_signature] = STATE(1977),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2113] = {
    [sym__call_signature] = STATE(1974),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2114] = {
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1237),
    [sym__automatic_semicolon] = ACTIONS(1237),
  },
  [2115] = {
    [sym__initializer] = STATE(2460),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5424),
    [anon_sym_SEMI] = ACTIONS(5424),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5424),
  },
  [2116] = {
    [aux_sym_implements_clause_repeat1] = STATE(2467),
    [anon_sym_COMMA] = ACTIONS(5426),
    [anon_sym_GT] = ACTIONS(5428),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2117] = {
    [sym__call_signature] = STATE(2628),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2118] = {
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_COMMA] = ACTIONS(5430),
    [anon_sym_RPAREN] = ACTIONS(5430),
    [anon_sym_COLON] = ACTIONS(5430),
    [anon_sym_QMARK] = ACTIONS(5430),
    [sym_comment] = ACTIONS(3),
  },
  [2119] = {
    [sym__call_signature] = STATE(2581),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2120] = {
    [sym_extends_clause] = STATE(2423),
    [sym_object_type] = STATE(526),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [2121] = {
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_RBRACE] = ACTIONS(5432),
    [anon_sym_SEMI] = ACTIONS(5432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5432),
    [sym__automatic_semicolon] = ACTIONS(5432),
  },
  [2122] = {
    [anon_sym_COMMA] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2851),
    [sym__automatic_semicolon] = ACTIONS(2851),
  },
  [2123] = {
    [anon_sym_COMMA] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_SEMI] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2734),
    [sym__automatic_semicolon] = ACTIONS(2734),
  },
  [2124] = {
    [sym__call_signature] = STATE(2605),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2125] = {
    [sym__initializer] = STATE(2465),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5434),
    [anon_sym_SEMI] = ACTIONS(5434),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5434),
  },
  [2126] = {
    [anon_sym_EQ] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_RPAREN] = ACTIONS(5436),
    [anon_sym_COLON] = ACTIONS(5436),
    [anon_sym_QMARK] = ACTIONS(5436),
    [sym_comment] = ACTIONS(3),
  },
  [2127] = {
    [sym__call_signature] = STATE(2617),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2128] = {
    [sym__call_signature] = STATE(2698),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2129] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_LBRACE] = ACTIONS(5223),
    [anon_sym_COMMA] = ACTIONS(5438),
    [anon_sym_RBRACK] = ACTIONS(5223),
    [anon_sym_GT] = ACTIONS(5223),
    [sym_comment] = ACTIONS(3),
  },
  [2130] = {
    [anon_sym_COMMA] = ACTIONS(2682),
    [anon_sym_RBRACE] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2682),
    [sym__automatic_semicolon] = ACTIONS(2682),
  },
  [2131] = {
    [sym__call_signature] = STATE(2299),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2132] = {
    [sym__call_signature] = STATE(2179),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2133] = {
    [anon_sym_COMMA] = ACTIONS(5441),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_SEMI] = ACTIONS(5441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5441),
    [sym__automatic_semicolon] = ACTIONS(5441),
  },
  [2134] = {
    [anon_sym_COMMA] = ACTIONS(2670),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_SEMI] = ACTIONS(2670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2670),
    [sym__automatic_semicolon] = ACTIONS(2670),
  },
  [2135] = {
    [sym__initializer] = STATE(2767),
    [aux_sym_enum_body_repeat1] = STATE(2385),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5443),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
  },
  [2136] = {
    [sym__initializer] = STATE(2483),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5447),
    [anon_sym_SEMI] = ACTIONS(5447),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5447),
  },
  [2137] = {
    [anon_sym_COMMA] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2799),
    [sym__automatic_semicolon] = ACTIONS(2799),
  },
  [2138] = {
    [sym__call_signature] = STATE(2352),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2139] = {
    [sym__call_signature] = STATE(2613),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2140] = {
    [sym__call_signature] = STATE(2458),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2141] = {
    [sym__initializer] = STATE(2455),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5449),
    [anon_sym_SEMI] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5449),
  },
  [2142] = {
    [sym__call_signature] = STATE(2311),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2143] = {
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2662),
    [sym__automatic_semicolon] = ACTIONS(2662),
  },
  [2144] = {
    [sym__call_signature] = STATE(2602),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2145] = {
    [anon_sym_COMMA] = ACTIONS(5392),
    [anon_sym_RBRACE] = ACTIONS(5392),
    [anon_sym_SEMI] = ACTIONS(5392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5392),
    [sym__automatic_semicolon] = ACTIONS(5392),
  },
  [2146] = {
    [sym__call_signature] = STATE(2306),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2147] = {
    [sym__initializer] = STATE(2540),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5451),
    [anon_sym_SEMI] = ACTIONS(5451),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5451),
  },
  [2148] = {
    [anon_sym_COMMA] = ACTIONS(1161),
    [anon_sym_RBRACE] = ACTIONS(1161),
    [anon_sym_SEMI] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1161),
    [sym__automatic_semicolon] = ACTIONS(1161),
  },
  [2149] = {
    [sym__call_signature] = STATE(2729),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2150] = {
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1089),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1089),
    [sym__automatic_semicolon] = ACTIONS(1089),
  },
  [2151] = {
    [sym__call_signature] = STATE(2645),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2152] = {
    [sym__initializer] = STATE(2482),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5453),
    [anon_sym_SEMI] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5453),
  },
  [2153] = {
    [sym_statement_block] = STATE(1736),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_SEMI] = ACTIONS(5163),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5163),
  },
  [2154] = {
    [sym__call_signature] = STATE(2634),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2155] = {
    [anon_sym_EQ] = ACTIONS(5455),
    [anon_sym_COMMA] = ACTIONS(5455),
    [anon_sym_RPAREN] = ACTIONS(5455),
    [anon_sym_COLON] = ACTIONS(5455),
    [anon_sym_QMARK] = ACTIONS(5455),
    [sym_comment] = ACTIONS(3),
  },
  [2156] = {
    [anon_sym_EQ] = ACTIONS(5457),
    [anon_sym_COMMA] = ACTIONS(5457),
    [anon_sym_RPAREN] = ACTIONS(5457),
    [anon_sym_COLON] = ACTIONS(5457),
    [anon_sym_QMARK] = ACTIONS(5457),
    [sym_comment] = ACTIONS(3),
  },
  [2157] = {
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_COMMA] = ACTIONS(4830),
    [anon_sym_RPAREN] = ACTIONS(4830),
    [anon_sym_COLON] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4830),
    [sym_comment] = ACTIONS(3),
  },
  [2158] = {
    [anon_sym_COMMA] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1125),
    [sym__automatic_semicolon] = ACTIONS(1125),
  },
  [2159] = {
    [anon_sym_EQ] = ACTIONS(5459),
    [anon_sym_COMMA] = ACTIONS(5459),
    [anon_sym_RPAREN] = ACTIONS(5459),
    [anon_sym_COLON] = ACTIONS(5459),
    [anon_sym_QMARK] = ACTIONS(5459),
    [sym_comment] = ACTIONS(3),
  },
  [2160] = {
    [sym_statement_block] = STATE(1740),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_SEMI] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5167),
  },
  [2161] = {
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2786),
    [anon_sym_SEMI] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2786),
    [sym__automatic_semicolon] = ACTIONS(2786),
  },
  [2162] = {
    [sym_type_arguments] = STATE(2478),
    [anon_sym_LBRACE] = ACTIONS(4258),
    [anon_sym_COMMA] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4256),
  },
  [2163] = {
    [anon_sym_COMMA] = ACTIONS(5461),
    [anon_sym_RBRACE] = ACTIONS(5461),
    [anon_sym_SEMI] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5461),
    [sym__automatic_semicolon] = ACTIONS(5461),
  },
  [2164] = {
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_SEMI] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1185),
    [sym__automatic_semicolon] = ACTIONS(1185),
  },
  [2165] = {
    [anon_sym_COMMA] = ACTIONS(2869),
    [anon_sym_RBRACE] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2869),
    [sym__automatic_semicolon] = ACTIONS(2869),
  },
  [2166] = {
    [anon_sym_EQ] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(3667),
    [anon_sym_RPAREN] = ACTIONS(3667),
    [anon_sym_COLON] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
  },
  [2167] = {
    [sym__initializer] = STATE(2550),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5463),
    [anon_sym_SEMI] = ACTIONS(5463),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5463),
  },
  [2168] = {
    [sym__call_signature] = STATE(2331),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2169] = {
    [anon_sym_COMMA] = ACTIONS(2730),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_SEMI] = ACTIONS(2730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2730),
    [sym__automatic_semicolon] = ACTIONS(2730),
  },
  [2170] = {
    [anon_sym_EQ] = ACTIONS(5465),
    [anon_sym_COMMA] = ACTIONS(5465),
    [anon_sym_RPAREN] = ACTIONS(5465),
    [anon_sym_COLON] = ACTIONS(5465),
    [anon_sym_QMARK] = ACTIONS(5465),
    [sym_comment] = ACTIONS(3),
  },
  [2171] = {
    [aux_sym_implements_clause_repeat1] = STATE(2547),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(5467),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2172] = {
    [anon_sym_EQ] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_RPAREN] = ACTIONS(3671),
    [anon_sym_COLON] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
  },
  [2173] = {
    [sym_object] = STATE(2903),
    [sym_array] = STATE(2843),
    [sym_identifier] = ACTIONS(5469),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [sym_comment] = ACTIONS(3),
  },
  [2174] = {
    [sym_statement_block] = STATE(1744),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_SEMI] = ACTIONS(5187),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5187),
  },
  [2175] = {
    [anon_sym_EQ] = ACTIONS(5471),
    [anon_sym_LBRACE] = ACTIONS(5471),
    [anon_sym_LPAREN] = ACTIONS(5471),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5471),
    [anon_sym_extends] = ACTIONS(5471),
  },
  [2176] = {
    [sym_statement_block] = STATE(1733),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5175),
    [anon_sym_SEMI] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5175),
  },
  [2177] = {
    [sym__call_signature] = STATE(2194),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2178] = {
    [anon_sym_COMMA] = ACTIONS(2666),
    [anon_sym_RBRACE] = ACTIONS(2666),
    [anon_sym_SEMI] = ACTIONS(2666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2666),
    [sym__automatic_semicolon] = ACTIONS(2666),
  },
  [2179] = {
    [sym_statement_block] = STATE(1732),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5173),
    [anon_sym_SEMI] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5173),
  },
  [2180] = {
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_RPAREN] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_QMARK] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
  },
  [2181] = {
    [sym__initializer] = STATE(2410),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5473),
    [anon_sym_SEMI] = ACTIONS(5473),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5473),
  },
  [2182] = {
    [anon_sym_COMMA] = ACTIONS(5163),
    [anon_sym_RBRACE] = ACTIONS(5163),
    [anon_sym_SEMI] = ACTIONS(5163),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5163),
    [sym__automatic_semicolon] = ACTIONS(5163),
  },
  [2183] = {
    [anon_sym_COMMA] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2941),
    [anon_sym_SEMI] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2941),
    [sym__automatic_semicolon] = ACTIONS(2941),
  },
  [2184] = {
    [anon_sym_COMMA] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_SEMI] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2738),
    [sym__automatic_semicolon] = ACTIONS(2738),
  },
  [2185] = {
    [anon_sym_COMMA] = ACTIONS(5137),
    [anon_sym_RBRACE] = ACTIONS(5137),
    [anon_sym_SEMI] = ACTIONS(5137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5137),
    [sym__automatic_semicolon] = ACTIONS(5137),
  },
  [2186] = {
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_SEMI] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2782),
    [sym__automatic_semicolon] = ACTIONS(2782),
  },
  [2187] = {
    [sym__call_signature] = STATE(2316),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2188] = {
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2807),
    [sym__automatic_semicolon] = ACTIONS(2807),
  },
  [2189] = {
    [anon_sym_COMMA] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2949),
    [sym__automatic_semicolon] = ACTIONS(2949),
  },
  [2190] = {
    [sym_statement_block] = STATE(1723),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_SEMI] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5181),
  },
  [2191] = {
    [sym__call_signature] = STATE(2174),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2192] = {
    [sym_type_arguments] = STATE(412),
    [anon_sym_LBRACE] = ACTIONS(4256),
    [anon_sym_COMMA] = ACTIONS(4256),
    [anon_sym_LT] = ACTIONS(4937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4256),
  },
  [2193] = {
    [anon_sym_COMMA] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_SEMI] = ACTIONS(2865),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2865),
    [sym__automatic_semicolon] = ACTIONS(2865),
  },
  [2194] = {
    [sym_statement_block] = STATE(1741),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5179),
  },
  [2195] = {
    [sym__call_signature] = STATE(2657),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2196] = {
    [sym__import_export_specifier] = STATE(2576),
    [sym_identifier] = ACTIONS(5229),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [anon_sym_type] = ACTIONS(5235),
    [anon_sym_typeof] = ACTIONS(5235),
    [sym_comment] = ACTIONS(3),
  },
  [2197] = {
    [anon_sym_COMMA] = ACTIONS(5477),
    [anon_sym_RBRACE] = ACTIONS(5477),
    [anon_sym_SEMI] = ACTIONS(5477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5477),
    [sym__automatic_semicolon] = ACTIONS(5477),
  },
  [2198] = {
    [sym_extends_clause] = STATE(2536),
    [sym_object_type] = STATE(2092),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [2199] = {
    [anon_sym_EQ] = ACTIONS(3651),
    [anon_sym_COMMA] = ACTIONS(3651),
    [anon_sym_RPAREN] = ACTIONS(3651),
    [anon_sym_COLON] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
  },
  [2200] = {
    [sym__call_signature] = STATE(2683),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2201] = {
    [sym__call_signature] = STATE(2720),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2202] = {
    [anon_sym_COMMA] = ACTIONS(5479),
    [anon_sym_RBRACE] = ACTIONS(5479),
    [anon_sym_SEMI] = ACTIONS(5479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5479),
    [sym__automatic_semicolon] = ACTIONS(5479),
  },
  [2203] = {
    [anon_sym_COMMA] = ACTIONS(2885),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2885),
    [sym__automatic_semicolon] = ACTIONS(2885),
  },
  [2204] = {
    [anon_sym_COMMA] = ACTIONS(5481),
    [anon_sym_RBRACE] = ACTIONS(5481),
    [anon_sym_SEMI] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5481),
    [sym__automatic_semicolon] = ACTIONS(5481),
  },
  [2205] = {
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2933),
    [sym__automatic_semicolon] = ACTIONS(2933),
  },
  [2206] = {
    [sym__call_signature] = STATE(2725),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2207] = {
    [sym__call_signature] = STATE(2323),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2208] = {
    [anon_sym_COMMA] = ACTIONS(5483),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_SEMI] = ACTIONS(5483),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5483),
    [sym__automatic_semicolon] = ACTIONS(5483),
  },
  [2209] = {
    [anon_sym_EQ] = ACTIONS(3651),
    [anon_sym_COMMA] = ACTIONS(3651),
    [anon_sym_SEMI] = ACTIONS(3651),
    [anon_sym_COLON] = ACTIONS(3651),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3651),
  },
  [2210] = {
    [anon_sym_COMMA] = ACTIONS(5181),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_SEMI] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5181),
    [sym__automatic_semicolon] = ACTIONS(5181),
  },
  [2211] = {
    [sym__call_signature] = STATE(2217),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2212] = {
    [sym__import_export_specifier] = STATE(2718),
    [sym_identifier] = ACTIONS(5229),
    [anon_sym_RBRACE] = ACTIONS(5485),
    [anon_sym_type] = ACTIONS(5235),
    [anon_sym_typeof] = ACTIONS(5235),
    [sym_comment] = ACTIONS(3),
  },
  [2213] = {
    [sym__call_signature] = STATE(2728),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2214] = {
    [sym__call_signature] = STATE(2699),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2215] = {
    [sym__call_signature] = STATE(2695),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2216] = {
    [anon_sym_COMMA] = ACTIONS(1219),
    [anon_sym_RBRACE] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1219),
    [sym__automatic_semicolon] = ACTIONS(1219),
  },
  [2217] = {
    [anon_sym_COMMA] = ACTIONS(5187),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_SEMI] = ACTIONS(5187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5187),
    [sym__automatic_semicolon] = ACTIONS(5187),
  },
  [2218] = {
    [anon_sym_COMMA] = ACTIONS(5487),
    [anon_sym_RBRACE] = ACTIONS(5487),
    [anon_sym_SEMI] = ACTIONS(5487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5487),
    [sym__automatic_semicolon] = ACTIONS(5487),
  },
  [2219] = {
    [anon_sym_COMMA] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_SEMI] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2847),
    [sym__automatic_semicolon] = ACTIONS(2847),
  },
  [2220] = {
    [anon_sym_COMMA] = ACTIONS(5179),
    [anon_sym_RBRACE] = ACTIONS(5179),
    [anon_sym_SEMI] = ACTIONS(5179),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5179),
    [sym__automatic_semicolon] = ACTIONS(5179),
  },
  [2221] = {
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_RBRACE] = ACTIONS(1141),
    [anon_sym_SEMI] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1141),
    [sym__automatic_semicolon] = ACTIONS(1141),
  },
  [2222] = {
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2953),
    [sym__automatic_semicolon] = ACTIONS(2953),
  },
  [2223] = {
    [anon_sym_COMMA] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_SEMI] = ACTIONS(2650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2650),
    [sym__automatic_semicolon] = ACTIONS(2650),
  },
  [2224] = {
    [aux_sym_implements_clause_repeat1] = STATE(2562),
    [anon_sym_COMMA] = ACTIONS(5489),
    [anon_sym_GT] = ACTIONS(5491),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2225] = {
    [anon_sym_COMMA] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2855),
    [sym__automatic_semicolon] = ACTIONS(2855),
  },
  [2226] = {
    [anon_sym_COMMA] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym_SEMI] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1151),
    [sym__automatic_semicolon] = ACTIONS(1151),
  },
  [2227] = {
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_SEMI] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1209),
    [sym__automatic_semicolon] = ACTIONS(1209),
  },
  [2228] = {
    [anon_sym_EQ] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(3655),
    [anon_sym_SEMI] = ACTIONS(3655),
    [anon_sym_COLON] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3655),
  },
  [2229] = {
    [sym_statement_block] = STATE(1749),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5199),
    [anon_sym_SEMI] = ACTIONS(5199),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5199),
  },
  [2230] = {
    [aux_sym_implements_clause_repeat1] = STATE(2430),
    [anon_sym_LBRACE] = ACTIONS(5493),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2231] = {
    [anon_sym_COMMA] = ACTIONS(5175),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [anon_sym_SEMI] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5175),
    [sym__automatic_semicolon] = ACTIONS(5175),
  },
  [2232] = {
    [anon_sym_COMMA] = ACTIONS(5495),
    [anon_sym_RBRACE] = ACTIONS(5495),
    [anon_sym_SEMI] = ACTIONS(5495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5495),
    [sym__automatic_semicolon] = ACTIONS(5495),
  },
  [2233] = {
    [sym__call_signature] = STATE(2220),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2234] = {
    [sym__call_signature] = STATE(2685),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2235] = {
    [anon_sym_COMMA] = ACTIONS(5497),
    [anon_sym_RBRACE] = ACTIONS(5497),
    [anon_sym_SEMI] = ACTIONS(5497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5497),
    [sym__automatic_semicolon] = ACTIONS(5497),
  },
  [2236] = {
    [sym__call_signature] = STATE(2670),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2237] = {
    [sym__import_export_specifier] = STATE(2576),
    [sym_identifier] = ACTIONS(5229),
    [anon_sym_RBRACE] = ACTIONS(5499),
    [anon_sym_type] = ACTIONS(5235),
    [anon_sym_typeof] = ACTIONS(5235),
    [sym_comment] = ACTIONS(3),
  },
  [2238] = {
    [anon_sym_COMMA] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2714),
    [sym__automatic_semicolon] = ACTIONS(2714),
  },
  [2239] = {
    [anon_sym_COMMA] = ACTIONS(5501),
    [anon_sym_RBRACE] = ACTIONS(5501),
    [anon_sym_SEMI] = ACTIONS(5501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5501),
    [sym__automatic_semicolon] = ACTIONS(5501),
  },
  [2240] = {
    [sym__call_signature] = STATE(2716),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2241] = {
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3675),
  },
  [2242] = {
    [sym_statement_block] = STATE(1748),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5193),
    [anon_sym_SEMI] = ACTIONS(5193),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5193),
  },
  [2243] = {
    [aux_sym_implements_clause_repeat1] = STATE(2552),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(5503),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2244] = {
    [sym__call_signature] = STATE(2254),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2245] = {
    [anon_sym_EQ] = ACTIONS(5505),
    [anon_sym_COMMA] = ACTIONS(5505),
    [anon_sym_GT] = ACTIONS(5505),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2246] = {
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_COMMA] = ACTIONS(2338),
    [anon_sym_LT] = ACTIONS(2338),
    [anon_sym_DOT] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2338),
  },
  [2247] = {
    [anon_sym_EQ] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(1073),
  },
  [2248] = {
    [sym__initializer] = STATE(2429),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5507),
    [anon_sym_SEMI] = ACTIONS(5507),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5507),
  },
  [2249] = {
    [sym__call_signature] = STATE(2229),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2250] = {
    [anon_sym_EQ] = ACTIONS(618),
    [anon_sym_COMMA] = ACTIONS(618),
    [anon_sym_RPAREN] = ACTIONS(618),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_QMARK] = ACTIONS(618),
    [sym_comment] = ACTIONS(3),
  },
  [2251] = {
    [sym_decorator] = STATE(1798),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [anon_sym_export] = ACTIONS(5509),
    [anon_sym_class] = ACTIONS(5511),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2252] = {
    [anon_sym_COMMA] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_SEMI] = ACTIONS(2694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2694),
    [sym__automatic_semicolon] = ACTIONS(2694),
  },
  [2253] = {
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_SEMI] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(3663),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3663),
  },
  [2254] = {
    [sym_statement_block] = STATE(1747),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5191),
    [anon_sym_SEMI] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5191),
  },
  [2255] = {
    [anon_sym_EQ] = ACTIONS(5513),
    [anon_sym_LBRACE] = ACTIONS(5513),
    [anon_sym_LPAREN] = ACTIONS(5513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5513),
    [anon_sym_extends] = ACTIONS(5513),
  },
  [2256] = {
    [aux_sym_implements_clause_repeat1] = STATE(2546),
    [anon_sym_COMMA] = ACTIONS(5515),
    [anon_sym_GT] = ACTIONS(5517),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2257] = {
    [sym__initializer] = STATE(2767),
    [aux_sym_enum_body_repeat1] = STATE(2518),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5519),
    [anon_sym_RBRACE] = ACTIONS(5521),
    [sym_comment] = ACTIONS(3),
  },
  [2258] = {
    [anon_sym_COMMA] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_SEMI] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2835),
    [sym__automatic_semicolon] = ACTIONS(2835),
  },
  [2259] = {
    [sym__call_signature] = STATE(2284),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2260] = {
    [anon_sym_COMMA] = ACTIONS(5189),
    [anon_sym_RBRACE] = ACTIONS(5189),
    [anon_sym_SEMI] = ACTIONS(5189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5189),
    [sym__automatic_semicolon] = ACTIONS(5189),
  },
  [2261] = {
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_SEMI] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2897),
    [sym__automatic_semicolon] = ACTIONS(2897),
  },
  [2262] = {
    [anon_sym_COMMA] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_SEMI] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1199),
    [sym__automatic_semicolon] = ACTIONS(5523),
  },
  [2263] = {
    [anon_sym_COMMA] = ACTIONS(2937),
    [anon_sym_RBRACE] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2937),
    [sym__automatic_semicolon] = ACTIONS(2937),
  },
  [2264] = {
    [sym_statement_block] = STATE(1751),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5169),
    [anon_sym_SEMI] = ACTIONS(5169),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5169),
  },
  [2265] = {
    [anon_sym_COMMA] = ACTIONS(5173),
    [anon_sym_RBRACE] = ACTIONS(5173),
    [anon_sym_SEMI] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5173),
    [sym__automatic_semicolon] = ACTIONS(5173),
  },
  [2266] = {
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_SEMI] = ACTIONS(2803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2803),
    [sym__automatic_semicolon] = ACTIONS(2803),
  },
  [2267] = {
    [anon_sym_COMMA] = ACTIONS(2674),
    [anon_sym_RBRACE] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2674),
    [sym__automatic_semicolon] = ACTIONS(2674),
  },
  [2268] = {
    [anon_sym_EQ] = ACTIONS(3659),
    [anon_sym_COMMA] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3659),
    [anon_sym_COLON] = ACTIONS(3659),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3659),
  },
  [2269] = {
    [anon_sym_EQ] = ACTIONS(4527),
    [anon_sym_COMMA] = ACTIONS(4527),
    [anon_sym_RPAREN] = ACTIONS(4527),
    [anon_sym_COLON] = ACTIONS(4527),
    [anon_sym_QMARK] = ACTIONS(4527),
    [sym_comment] = ACTIONS(3),
  },
  [2270] = {
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_SEMI] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2917),
    [sym__automatic_semicolon] = ACTIONS(2917),
  },
  [2271] = {
    [anon_sym_EQ] = ACTIONS(4535),
    [anon_sym_COMMA] = ACTIONS(4535),
    [anon_sym_RPAREN] = ACTIONS(4535),
    [anon_sym_COLON] = ACTIONS(4535),
    [anon_sym_QMARK] = ACTIONS(4535),
    [sym_comment] = ACTIONS(3),
  },
  [2272] = {
    [anon_sym_EQ] = ACTIONS(3663),
    [anon_sym_COMMA] = ACTIONS(3663),
    [anon_sym_RPAREN] = ACTIONS(3663),
    [anon_sym_COLON] = ACTIONS(3663),
    [anon_sym_QMARK] = ACTIONS(3663),
    [sym_comment] = ACTIONS(3),
  },
  [2273] = {
    [anon_sym_COMMA] = ACTIONS(5193),
    [anon_sym_RBRACE] = ACTIONS(5193),
    [anon_sym_SEMI] = ACTIONS(5193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5193),
    [sym__automatic_semicolon] = ACTIONS(5193),
  },
  [2274] = {
    [anon_sym_EQ] = ACTIONS(3659),
    [anon_sym_COMMA] = ACTIONS(3659),
    [anon_sym_RPAREN] = ACTIONS(3659),
    [anon_sym_COLON] = ACTIONS(3659),
    [anon_sym_QMARK] = ACTIONS(3659),
    [sym_comment] = ACTIONS(3),
  },
  [2275] = {
    [anon_sym_COMMA] = ACTIONS(5167),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [anon_sym_SEMI] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5167),
    [sym__automatic_semicolon] = ACTIONS(5167),
  },
  [2276] = {
    [sym__call_signature] = STATE(2265),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2277] = {
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2921),
    [sym__automatic_semicolon] = ACTIONS(2921),
  },
  [2278] = {
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1189),
    [sym__automatic_semicolon] = ACTIONS(1189),
  },
  [2279] = {
    [aux_sym_implements_clause_repeat1] = STATE(2522),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(5525),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2280] = {
    [sym__call_signature] = STATE(2668),
    [sym_formal_parameters] = STATE(2379),
    [sym_type_parameters] = STATE(2654),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2281] = {
    [anon_sym_COMMA] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_SEMI] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1077),
    [sym__automatic_semicolon] = ACTIONS(5527),
  },
  [2282] = {
    [anon_sym_COMMA] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1175),
    [sym__automatic_semicolon] = ACTIONS(5529),
  },
  [2283] = {
    [sym__call_signature] = STATE(2109),
    [sym_formal_parameters] = STATE(1918),
    [sym_type_parameters] = STATE(2689),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2284] = {
    [anon_sym_COMMA] = ACTIONS(5191),
    [anon_sym_RBRACE] = ACTIONS(5191),
    [anon_sym_SEMI] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5191),
    [sym__automatic_semicolon] = ACTIONS(5191),
  },
  [2285] = {
    [aux_sym_implements_clause_repeat1] = STATE(2517),
    [anon_sym_COMMA] = ACTIONS(5531),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2286] = {
    [anon_sym_EQ] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_QMARK] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
  },
  [2287] = {
    [anon_sym_COMMA] = ACTIONS(5535),
    [anon_sym_RBRACE] = ACTIONS(5535),
    [anon_sym_SEMI] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5535),
    [sym__automatic_semicolon] = ACTIONS(5535),
  },
  [2288] = {
    [sym__initializer] = STATE(2397),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(5537),
    [anon_sym_SEMI] = ACTIONS(5537),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5537),
  },
  [2289] = {
    [anon_sym_COMMA] = ACTIONS(1099),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_SEMI] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1099),
    [sym__automatic_semicolon] = ACTIONS(5539),
  },
  [2290] = {
    [anon_sym_EQ] = ACTIONS(3655),
    [anon_sym_LPAREN] = ACTIONS(4497),
    [anon_sym_COLON] = ACTIONS(4497),
    [anon_sym_LT] = ACTIONS(4497),
    [anon_sym_QMARK] = ACTIONS(4497),
    [sym_comment] = ACTIONS(3),
  },
  [2291] = {
    [anon_sym_EQ] = ACTIONS(3667),
    [anon_sym_COMMA] = ACTIONS(3667),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym_COLON] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3667),
  },
  [2292] = {
    [anon_sym_EQ] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(3655),
    [anon_sym_RPAREN] = ACTIONS(3655),
    [anon_sym_COLON] = ACTIONS(3655),
    [anon_sym_QMARK] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
  },
  [2293] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2309),
    [anon_sym_COMMA] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5543),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5543),
  },
  [2294] = {
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_EQ_GT] = ACTIONS(4798),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
  },
  [2295] = {
    [aux_sym_string_repeat2] = STATE(2333),
    [anon_sym_SQUOTE] = ACTIONS(5545),
    [aux_sym_string_token2] = ACTIONS(5547),
    [sym_escape_sequence] = ACTIONS(5549),
    [sym_comment] = ACTIONS(5551),
  },
  [2296] = {
    [aux_sym_string_repeat1] = STATE(2339),
    [anon_sym_DQUOTE] = ACTIONS(5545),
    [aux_sym_string_token1] = ACTIONS(5553),
    [sym_escape_sequence] = ACTIONS(5555),
    [sym_comment] = ACTIONS(5551),
  },
  [2297] = {
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_RPAREN] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3741),
    [anon_sym_RBRACK] = ACTIONS(3741),
    [sym_comment] = ACTIONS(3),
  },
  [2298] = {
    [anon_sym_else] = ACTIONS(2594),
    [anon_sym_while] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2299] = {
    [sym_statement_block] = STATE(2281),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [anon_sym_SEMI] = ACTIONS(5557),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5557),
  },
  [2300] = {
    [aux_sym_string_repeat2] = STATE(2310),
    [anon_sym_SQUOTE] = ACTIONS(5559),
    [aux_sym_string_token2] = ACTIONS(5561),
    [sym_escape_sequence] = ACTIONS(5563),
    [sym_comment] = ACTIONS(5551),
  },
  [2301] = {
    [anon_sym_LPAREN] = ACTIONS(3537),
    [anon_sym_LT] = ACTIONS(3537),
    [anon_sym_EQ_GT] = ACTIONS(5565),
    [anon_sym_QMARK] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
  },
  [2302] = {
    [sym_decorator] = STATE(1798),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [anon_sym_class] = ACTIONS(5567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2303] = {
    [anon_sym_SEMI] = ACTIONS(5569),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5571),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5569),
  },
  [2304] = {
    [aux_sym_string_repeat1] = STATE(2308),
    [anon_sym_DQUOTE] = ACTIONS(5559),
    [aux_sym_string_token1] = ACTIONS(5573),
    [sym_escape_sequence] = ACTIONS(5575),
    [sym_comment] = ACTIONS(5551),
  },
  [2305] = {
    [aux_sym_extends_clause_repeat1] = STATE(2372),
    [anon_sym_LBRACE] = ACTIONS(4005),
    [anon_sym_COMMA] = ACTIONS(3422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4005),
  },
  [2306] = {
    [sym_statement_block] = STATE(2262),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [anon_sym_SEMI] = ACTIONS(5577),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5577),
  },
  [2307] = {
    [sym_decorator] = STATE(1798),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [anon_sym_class] = ACTIONS(5579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2308] = {
    [aux_sym_string_repeat1] = STATE(2339),
    [anon_sym_DQUOTE] = ACTIONS(5581),
    [aux_sym_string_token1] = ACTIONS(5553),
    [sym_escape_sequence] = ACTIONS(5555),
    [sym_comment] = ACTIONS(5551),
  },
  [2309] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2309),
    [anon_sym_COMMA] = ACTIONS(5583),
    [anon_sym_SEMI] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5586),
  },
  [2310] = {
    [aux_sym_string_repeat2] = STATE(2333),
    [anon_sym_SQUOTE] = ACTIONS(5581),
    [aux_sym_string_token2] = ACTIONS(5547),
    [sym_escape_sequence] = ACTIONS(5549),
    [sym_comment] = ACTIONS(5551),
  },
  [2311] = {
    [sym_statement_block] = STATE(1323),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(5588),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5588),
  },
  [2312] = {
    [sym_decorator] = STATE(1798),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [anon_sym_class] = ACTIONS(5590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2313] = {
    [anon_sym_COMMA] = ACTIONS(5592),
    [anon_sym_GT] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2314] = {
    [sym__initializer] = STATE(2726),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
  },
  [2315] = {
    [aux_sym_string_repeat1] = STATE(2320),
    [anon_sym_DQUOTE] = ACTIONS(5596),
    [aux_sym_string_token1] = ACTIONS(5598),
    [sym_escape_sequence] = ACTIONS(5600),
    [sym_comment] = ACTIONS(5551),
  },
  [2316] = {
    [sym_statement_block] = STATE(106),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(5588),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5588),
  },
  [2317] = {
    [aux_sym_string_repeat2] = STATE(2295),
    [anon_sym_SQUOTE] = ACTIONS(5602),
    [aux_sym_string_token2] = ACTIONS(5604),
    [sym_escape_sequence] = ACTIONS(5606),
    [sym_comment] = ACTIONS(5551),
  },
  [2318] = {
    [aux_sym_string_repeat1] = STATE(2296),
    [anon_sym_DQUOTE] = ACTIONS(5602),
    [aux_sym_string_token1] = ACTIONS(5608),
    [sym_escape_sequence] = ACTIONS(5610),
    [sym_comment] = ACTIONS(5551),
  },
  [2319] = {
    [aux_sym_string_repeat2] = STATE(2321),
    [anon_sym_SQUOTE] = ACTIONS(5596),
    [aux_sym_string_token2] = ACTIONS(5612),
    [sym_escape_sequence] = ACTIONS(5614),
    [sym_comment] = ACTIONS(5551),
  },
  [2320] = {
    [aux_sym_string_repeat1] = STATE(2339),
    [anon_sym_DQUOTE] = ACTIONS(5616),
    [aux_sym_string_token1] = ACTIONS(5553),
    [sym_escape_sequence] = ACTIONS(5555),
    [sym_comment] = ACTIONS(5551),
  },
  [2321] = {
    [aux_sym_string_repeat2] = STATE(2333),
    [anon_sym_SQUOTE] = ACTIONS(5616),
    [aux_sym_string_token2] = ACTIONS(5547),
    [sym_escape_sequence] = ACTIONS(5549),
    [sym_comment] = ACTIONS(5551),
  },
  [2322] = {
    [anon_sym_SEMI] = ACTIONS(5618),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5571),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5618),
  },
  [2323] = {
    [sym_statement_block] = STATE(491),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [anon_sym_SEMI] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5620),
  },
  [2324] = {
    [sym_default_type] = STATE(2682),
    [anon_sym_EQ] = ACTIONS(4955),
    [anon_sym_COMMA] = ACTIONS(5622),
    [anon_sym_GT] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
  },
  [2325] = {
    [sym_formal_parameters] = STATE(2885),
    [sym_type_parameters] = STATE(2612),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2326] = {
    [sym__initializer] = STATE(2767),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [sym_comment] = ACTIONS(3),
  },
  [2327] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2356),
    [anon_sym_COMMA] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5626),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5626),
  },
  [2328] = {
    [sym__from_clause] = STATE(2649),
    [anon_sym_from] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5630),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5630),
  },
  [2329] = {
    [sym_decorator] = STATE(1798),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [anon_sym_class] = ACTIONS(5632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2330] = {
    [sym_statement_block] = STATE(508),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [anon_sym_SEMI] = ACTIONS(5588),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5588),
  },
  [2331] = {
    [sym_statement_block] = STATE(1354),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5620),
  },
  [2332] = {
    [aux_sym_extends_clause_repeat1] = STATE(2349),
    [anon_sym_LBRACE] = ACTIONS(5634),
    [anon_sym_COMMA] = ACTIONS(3454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5636),
  },
  [2333] = {
    [aux_sym_string_repeat2] = STATE(2333),
    [anon_sym_SQUOTE] = ACTIONS(5638),
    [aux_sym_string_token2] = ACTIONS(5640),
    [sym_escape_sequence] = ACTIONS(5643),
    [sym_comment] = ACTIONS(5551),
  },
  [2334] = {
    [sym_type_annotation] = STATE(2653),
    [anon_sym_LBRACE] = ACTIONS(5089),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(5089),
    [sym_comment] = ACTIONS(3),
  },
  [2335] = {
    [sym_decorator] = STATE(1798),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [anon_sym_class] = ACTIONS(5646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2336] = {
    [aux_sym_extends_clause_repeat1] = STATE(2349),
    [anon_sym_LBRACE] = ACTIONS(5648),
    [anon_sym_COMMA] = ACTIONS(3454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5650),
  },
  [2337] = {
    [aux_sym_extends_clause_repeat1] = STATE(2337),
    [anon_sym_LBRACE] = ACTIONS(4256),
    [anon_sym_COMMA] = ACTIONS(5652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4256),
  },
  [2338] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(5655),
    [anon_sym_RPAREN] = ACTIONS(4264),
    [anon_sym_RBRACK] = ACTIONS(4264),
    [sym_comment] = ACTIONS(3),
  },
  [2339] = {
    [aux_sym_string_repeat1] = STATE(2339),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [aux_sym_string_token1] = ACTIONS(5660),
    [sym_escape_sequence] = ACTIONS(5663),
    [sym_comment] = ACTIONS(5551),
  },
  [2340] = {
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5571),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5666),
  },
  [2341] = {
    [sym__import_export_specifier] = STATE(2718),
    [sym_identifier] = ACTIONS(5229),
    [anon_sym_type] = ACTIONS(5235),
    [anon_sym_typeof] = ACTIONS(5235),
    [sym_comment] = ACTIONS(3),
  },
  [2342] = {
    [aux_sym_string_repeat1] = STATE(2365),
    [anon_sym_DQUOTE] = ACTIONS(5668),
    [aux_sym_string_token1] = ACTIONS(5670),
    [sym_escape_sequence] = ACTIONS(5672),
    [sym_comment] = ACTIONS(5551),
  },
  [2343] = {
    [aux_sym_string_repeat1] = STATE(2380),
    [anon_sym_DQUOTE] = ACTIONS(5674),
    [aux_sym_string_token1] = ACTIONS(5676),
    [sym_escape_sequence] = ACTIONS(5678),
    [sym_comment] = ACTIONS(5551),
  },
  [2344] = {
    [aux_sym_string_repeat2] = STATE(2381),
    [anon_sym_SQUOTE] = ACTIONS(5674),
    [aux_sym_string_token2] = ACTIONS(5680),
    [sym_escape_sequence] = ACTIONS(5682),
    [sym_comment] = ACTIONS(5551),
  },
  [2345] = {
    [sym_formal_parameters] = STATE(2930),
    [sym_type_parameters] = STATE(2704),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2346] = {
    [sym_escape_sequence] = ACTIONS(5684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(5684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5684),
    [sym__template_chars] = ACTIONS(5684),
  },
  [2347] = {
    [sym_formal_parameters] = STATE(1990),
    [sym_type_parameters] = STATE(2658),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2348] = {
    [aux_sym_string_repeat2] = STATE(2364),
    [anon_sym_SQUOTE] = ACTIONS(5668),
    [aux_sym_string_token2] = ACTIONS(5686),
    [sym_escape_sequence] = ACTIONS(5688),
    [sym_comment] = ACTIONS(5551),
  },
  [2349] = {
    [aux_sym_extends_clause_repeat1] = STATE(2349),
    [anon_sym_LBRACE] = ACTIONS(4258),
    [anon_sym_COMMA] = ACTIONS(5690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4256),
  },
  [2350] = {
    [sym_template_string] = STATE(1423),
    [sym_arguments] = STATE(1423),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(87),
  },
  [2351] = {
    [sym_type_annotation] = STATE(2678),
    [anon_sym_COMMA] = ACTIONS(5693),
    [anon_sym_RPAREN] = ACTIONS(5693),
    [anon_sym_COLON] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
  },
  [2352] = {
    [sym_statement_block] = STATE(123),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5620),
  },
  [2353] = {
    [sym_formal_parameters] = STATE(2839),
    [sym_type_parameters] = STATE(2762),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2354] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2309),
    [anon_sym_COMMA] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5695),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5695),
  },
  [2355] = {
    [aux_sym_extends_clause_repeat1] = STATE(2336),
    [anon_sym_LBRACE] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3454),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4005),
  },
  [2356] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2309),
    [anon_sym_COMMA] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5697),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5697),
  },
  [2357] = {
    [aux_sym_string_repeat2] = STATE(2333),
    [anon_sym_SQUOTE] = ACTIONS(5699),
    [aux_sym_string_token2] = ACTIONS(5547),
    [sym_escape_sequence] = ACTIONS(5549),
    [sym_comment] = ACTIONS(5551),
  },
  [2358] = {
    [sym__initializer] = STATE(2663),
    [anon_sym_EQ] = ACTIONS(5129),
    [anon_sym_COMMA] = ACTIONS(5701),
    [anon_sym_RPAREN] = ACTIONS(5701),
    [sym_comment] = ACTIONS(3),
  },
  [2359] = {
    [aux_sym_string_repeat1] = STATE(2339),
    [anon_sym_DQUOTE] = ACTIONS(5699),
    [aux_sym_string_token1] = ACTIONS(5553),
    [sym_escape_sequence] = ACTIONS(5555),
    [sym_comment] = ACTIONS(5551),
  },
  [2360] = {
    [sym__from_clause] = STATE(2706),
    [anon_sym_from] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5703),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5703),
  },
  [2361] = {
    [sym_template_string] = STATE(1116),
    [sym_arguments] = STATE(1116),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(583),
  },
  [2362] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2309),
    [anon_sym_COMMA] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5705),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5705),
  },
  [2363] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2362),
    [anon_sym_COMMA] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5707),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5707),
  },
  [2364] = {
    [aux_sym_string_repeat2] = STATE(2333),
    [anon_sym_SQUOTE] = ACTIONS(5709),
    [aux_sym_string_token2] = ACTIONS(5547),
    [sym_escape_sequence] = ACTIONS(5549),
    [sym_comment] = ACTIONS(5551),
  },
  [2365] = {
    [aux_sym_string_repeat1] = STATE(2339),
    [anon_sym_DQUOTE] = ACTIONS(5709),
    [aux_sym_string_token1] = ACTIONS(5553),
    [sym_escape_sequence] = ACTIONS(5555),
    [sym_comment] = ACTIONS(5551),
  },
  [2366] = {
    [aux_sym_string_repeat2] = STATE(2357),
    [anon_sym_SQUOTE] = ACTIONS(5711),
    [aux_sym_string_token2] = ACTIONS(5713),
    [sym_escape_sequence] = ACTIONS(5715),
    [sym_comment] = ACTIONS(5551),
  },
  [2367] = {
    [aux_sym_string_repeat1] = STATE(2359),
    [anon_sym_DQUOTE] = ACTIONS(5711),
    [aux_sym_string_token1] = ACTIONS(5717),
    [sym_escape_sequence] = ACTIONS(5719),
    [sym_comment] = ACTIONS(5551),
  },
  [2368] = {
    [anon_sym_SEMI] = ACTIONS(5721),
    [anon_sym_AMP] = ACTIONS(5033),
    [anon_sym_PIPE] = ACTIONS(5571),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5721),
  },
  [2369] = {
    [sym_formal_parameters] = STATE(2853),
    [sym_type_parameters] = STATE(2742),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2370] = {
    [aux_sym_extends_clause_repeat1] = STATE(2337),
    [anon_sym_LBRACE] = ACTIONS(5636),
    [anon_sym_COMMA] = ACTIONS(3422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5636),
  },
  [2371] = {
    [sym_decorator] = STATE(1798),
    [aux_sym_export_statement_repeat1] = STATE(1767),
    [anon_sym_export] = ACTIONS(5723),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(95),
  },
  [2372] = {
    [aux_sym_extends_clause_repeat1] = STATE(2337),
    [anon_sym_LBRACE] = ACTIONS(5650),
    [anon_sym_COMMA] = ACTIONS(3422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5650),
  },
  [2373] = {
    [sym__import_export_specifier] = STATE(2576),
    [sym_identifier] = ACTIONS(5229),
    [anon_sym_type] = ACTIONS(5235),
    [anon_sym_typeof] = ACTIONS(5235),
    [sym_comment] = ACTIONS(3),
  },
  [2374] = {
    [sym_template_string] = STATE(1538),
    [sym_arguments] = STATE(1538),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(714),
  },
  [2375] = {
    [sym_namespace_import] = STATE(2967),
    [sym_named_imports] = STATE(2967),
    [anon_sym_STAR] = ACTIONS(5059),
    [anon_sym_LBRACE] = ACTIONS(3586),
    [sym_comment] = ACTIONS(3),
  },
  [2376] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2293),
    [anon_sym_COMMA] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5725),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5725),
  },
  [2377] = {
    [sym_formal_parameters] = STATE(2827),
    [sym_type_parameters] = STATE(2751),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2378] = {
    [aux_sym_variable_declaration_repeat1] = STATE(2354),
    [anon_sym_COMMA] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5727),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5727),
  },
  [2379] = {
    [sym_type_annotation] = STATE(2662),
    [anon_sym_LBRACE] = ACTIONS(5085),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(5085),
    [sym_comment] = ACTIONS(3),
  },
  [2380] = {
    [aux_sym_string_repeat1] = STATE(2339),
    [anon_sym_DQUOTE] = ACTIONS(5729),
    [aux_sym_string_token1] = ACTIONS(5553),
    [sym_escape_sequence] = ACTIONS(5555),
    [sym_comment] = ACTIONS(5551),
  },
  [2381] = {
    [aux_sym_string_repeat2] = STATE(2333),
    [anon_sym_SQUOTE] = ACTIONS(5729),
    [aux_sym_string_token2] = ACTIONS(5547),
    [sym_escape_sequence] = ACTIONS(5549),
    [sym_comment] = ACTIONS(5551),
  },
  [2382] = {
    [sym_formal_parameters] = STATE(2942),
    [sym_type_parameters] = STATE(2756),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2383] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(5731),
    [sym_comment] = ACTIONS(3),
  },
  [2384] = {
    [sym__for_header] = STATE(34),
    [anon_sym_LPAREN] = ACTIONS(5733),
    [anon_sym_await] = ACTIONS(5735),
    [sym_comment] = ACTIONS(3),
  },
  [2385] = {
    [aux_sym_enum_body_repeat1] = STATE(2481),
    [anon_sym_COMMA] = ACTIONS(5737),
    [anon_sym_RBRACE] = ACTIONS(4878),
    [sym_comment] = ACTIONS(3),
  },
  [2386] = {
    [sym_type_annotation] = STATE(2653),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(5739),
    [sym_comment] = ACTIONS(3),
  },
  [2387] = {
    [aux_sym_array_repeat1] = STATE(2471),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4275),
    [sym_comment] = ACTIONS(3),
  },
  [2388] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4275),
    [sym_comment] = ACTIONS(3),
  },
  [2389] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(5742),
    [anon_sym_GT] = ACTIONS(3361),
    [sym_comment] = ACTIONS(3),
  },
  [2390] = {
    [sym_nested_identifier] = STATE(2777),
    [sym_nested_type_identifier] = STATE(427),
    [sym_identifier] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
  },
  [2391] = {
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_SEMI] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5746),
  },
  [2392] = {
    [sym_type_annotation] = STATE(2653),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(5748),
    [sym_comment] = ACTIONS(3),
  },
  [2393] = {
    [sym_nested_identifier] = STATE(2812),
    [sym_nested_type_identifier] = STATE(1855),
    [sym_identifier] = ACTIONS(5751),
    [sym_comment] = ACTIONS(3),
  },
  [2394] = {
    [sym_nested_identifier] = STATE(2519),
    [sym_identifier] = ACTIONS(5753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_require] = ACTIONS(5755),
  },
  [2395] = {
    [aux_sym_object_repeat1] = STATE(2450),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5757),
    [sym_comment] = ACTIONS(3),
  },
  [2396] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5759),
    [sym_comment] = ACTIONS(3),
  },
  [2397] = {
    [anon_sym_COMMA] = ACTIONS(5761),
    [anon_sym_SEMI] = ACTIONS(5761),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5761),
  },
  [2398] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5763),
    [sym_comment] = ACTIONS(3),
  },
  [2399] = {
    [aux_sym_type_parameters_repeat1] = STATE(2439),
    [anon_sym_COMMA] = ACTIONS(5765),
    [anon_sym_GT] = ACTIONS(5767),
    [sym_comment] = ACTIONS(3),
  },
  [2400] = {
    [anon_sym_from] = ACTIONS(5769),
    [anon_sym_SEMI] = ACTIONS(5769),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5769),
  },
  [2401] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5757),
    [sym_comment] = ACTIONS(3),
  },
  [2402] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(5771),
    [sym_comment] = ACTIONS(3),
  },
  [2403] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2454),
    [anon_sym_COMMA] = ACTIONS(5773),
    [anon_sym_RPAREN] = ACTIONS(5775),
    [sym_comment] = ACTIONS(3),
  },
  [2404] = {
    [anon_sym_RPAREN] = ACTIONS(5777),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2405] = {
    [sym_implements_clause] = STATE(2947),
    [anon_sym_LBRACE] = ACTIONS(5779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(5073),
  },
  [2406] = {
    [anon_sym_RPAREN] = ACTIONS(5781),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2407] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4165),
    [sym_comment] = ACTIONS(3),
  },
  [2408] = {
    [aux_sym_named_imports_repeat1] = STATE(2408),
    [anon_sym_COMMA] = ACTIONS(5783),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [sym_comment] = ACTIONS(3),
  },
  [2409] = {
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_from] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
  },
  [2410] = {
    [anon_sym_COMMA] = ACTIONS(5794),
    [anon_sym_SEMI] = ACTIONS(5794),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5794),
  },
  [2411] = {
    [aux_sym_named_imports_repeat1] = STATE(2426),
    [anon_sym_COMMA] = ACTIONS(5796),
    [anon_sym_RBRACE] = ACTIONS(5798),
    [sym_comment] = ACTIONS(3),
  },
  [2412] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(5800),
    [anon_sym_GT] = ACTIONS(3320),
    [sym_comment] = ACTIONS(3),
  },
  [2413] = {
    [aux_sym_array_repeat1] = STATE(2464),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4307),
    [sym_comment] = ACTIONS(3),
  },
  [2414] = {
    [aux_sym_array_repeat1] = STATE(2402),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4165),
    [sym_comment] = ACTIONS(3),
  },
  [2415] = {
    [anon_sym_COMMA] = ACTIONS(5802),
    [anon_sym_SEMI] = ACTIONS(5802),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5802),
  },
  [2416] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4307),
    [sym_comment] = ACTIONS(3),
  },
  [2417] = {
    [sym_nested_identifier] = STATE(2790),
    [sym_nested_type_identifier] = STATE(1391),
    [sym_identifier] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
  },
  [2418] = {
    [aux_sym_type_parameters_repeat1] = STATE(2476),
    [anon_sym_COMMA] = ACTIONS(5806),
    [anon_sym_GT] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
  },
  [2419] = {
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_SEMI] = ACTIONS(5810),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5810),
  },
  [2420] = {
    [aux_sym_array_repeat1] = STATE(2442),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(4301),
    [sym_comment] = ACTIONS(3),
  },
  [2421] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(4301),
    [sym_comment] = ACTIONS(3),
  },
  [2422] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(5812),
    [sym_comment] = ACTIONS(3),
  },
  [2423] = {
    [sym_object_type] = STATE(552),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [2424] = {
    [anon_sym_COMMA] = ACTIONS(5814),
    [anon_sym_SEMI] = ACTIONS(5814),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5814),
  },
  [2425] = {
    [anon_sym_COMMA] = ACTIONS(5816),
    [anon_sym_SEMI] = ACTIONS(5816),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5816),
  },
  [2426] = {
    [aux_sym_named_imports_repeat1] = STATE(2408),
    [anon_sym_COMMA] = ACTIONS(5818),
    [anon_sym_RBRACE] = ACTIONS(5485),
    [sym_comment] = ACTIONS(3),
  },
  [2427] = {
    [anon_sym_COMMA] = ACTIONS(5820),
    [anon_sym_SEMI] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5820),
  },
  [2428] = {
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_SEMI] = ACTIONS(5822),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5822),
  },
  [2429] = {
    [anon_sym_COMMA] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5824),
  },
  [2430] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_LBRACE] = ACTIONS(5826),
    [anon_sym_COMMA] = ACTIONS(5414),
    [sym_comment] = ACTIONS(3),
  },
  [2431] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
  },
  [2432] = {
    [aux_sym_object_repeat1] = STATE(2398),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
  },
  [2433] = {
    [anon_sym_COMMA] = ACTIONS(5830),
    [anon_sym_SEMI] = ACTIONS(5830),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5830),
  },
  [2434] = {
    [aux_sym_enum_body_repeat1] = STATE(2385),
    [anon_sym_COMMA] = ACTIONS(5443),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
  },
  [2435] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(5832),
    [sym_comment] = ACTIONS(3),
  },
  [2436] = {
    [sym_object_type] = STATE(528),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
  },
  [2437] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2456),
    [anon_sym_COMMA] = ACTIONS(5834),
    [anon_sym_RPAREN] = ACTIONS(4744),
    [sym_comment] = ACTIONS(3),
  },
  [2438] = {
    [anon_sym_RBRACK] = ACTIONS(5836),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2439] = {
    [aux_sym_type_parameters_repeat1] = STATE(2470),
    [anon_sym_COMMA] = ACTIONS(5838),
    [anon_sym_GT] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
  },
  [2440] = {
    [sym_type_annotation] = STATE(2662),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(5842),
    [sym_comment] = ACTIONS(3),
  },
  [2441] = {
    [anon_sym_COMMA] = ACTIONS(5845),
    [anon_sym_SEMI] = ACTIONS(5845),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5845),
  },
  [2442] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(5847),
    [sym_comment] = ACTIONS(3),
  },
  [2443] = {
    [anon_sym_COMMA] = ACTIONS(5849),
    [anon_sym_SEMI] = ACTIONS(5849),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5849),
  },
  [2444] = {
    [sym_identifier] = ACTIONS(5851),
    [anon_sym_SEMI] = ACTIONS(5853),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5853),
  },
  [2445] = {
    [sym_type_annotation] = STATE(2653),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(5855),
    [sym_comment] = ACTIONS(3),
  },
  [2446] = {
    [anon_sym_COMMA] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5858),
  },
  [2447] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [sym_comment] = ACTIONS(3),
  },
  [2448] = {
    [anon_sym_LBRACE] = ACTIONS(5862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5513),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5513),
  },
  [2449] = {
    [sym_type_annotation] = STATE(2662),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(5864),
    [sym_comment] = ACTIONS(3),
  },
  [2450] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5867),
    [sym_comment] = ACTIONS(3),
  },
  [2451] = {
    [anon_sym_COMMA] = ACTIONS(5869),
    [anon_sym_SEMI] = ACTIONS(5869),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5869),
  },
  [2452] = {
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_COMMA] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2388),
  },
  [2453] = {
    [anon_sym_LBRACE] = ACTIONS(5871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5398),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5398),
  },
  [2454] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2456),
    [anon_sym_COMMA] = ACTIONS(5873),
    [anon_sym_RPAREN] = ACTIONS(4740),
    [sym_comment] = ACTIONS(3),
  },
  [2455] = {
    [anon_sym_COMMA] = ACTIONS(5875),
    [anon_sym_SEMI] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5875),
  },
  [2456] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2456),
    [anon_sym_COMMA] = ACTIONS(5877),
    [anon_sym_RPAREN] = ACTIONS(5880),
    [sym_comment] = ACTIONS(3),
  },
  [2457] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2557),
    [anon_sym_COMMA] = ACTIONS(5873),
    [anon_sym_RPAREN] = ACTIONS(4740),
    [sym_comment] = ACTIONS(3),
  },
  [2458] = {
    [anon_sym_COMMA] = ACTIONS(5882),
    [anon_sym_SEMI] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5882),
  },
  [2459] = {
    [anon_sym_LBRACE] = ACTIONS(4258),
    [anon_sym_COMMA] = ACTIONS(4256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4256),
  },
  [2460] = {
    [anon_sym_COMMA] = ACTIONS(5884),
    [anon_sym_SEMI] = ACTIONS(5884),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5884),
  },
  [2461] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2512),
    [anon_sym_COMMA] = ACTIONS(5886),
    [anon_sym_RPAREN] = ACTIONS(5888),
    [sym_comment] = ACTIONS(3),
  },
  [2462] = {
    [anon_sym_LBRACE] = ACTIONS(5113),
    [anon_sym_COLON] = ACTIONS(5113),
    [anon_sym_EQ_GT] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
  },
  [2463] = {
    [anon_sym_LBRACE] = ACTIONS(5171),
    [anon_sym_COLON] = ACTIONS(5171),
    [anon_sym_EQ_GT] = ACTIONS(5171),
    [sym_comment] = ACTIONS(3),
  },
  [2464] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(5890),
    [sym_comment] = ACTIONS(3),
  },
  [2465] = {
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_SEMI] = ACTIONS(5892),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5892),
  },
  [2466] = {
    [anon_sym_RPAREN] = ACTIONS(5894),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2467] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(5896),
    [anon_sym_GT] = ACTIONS(3300),
    [sym_comment] = ACTIONS(3),
  },
  [2468] = {
    [sym_type_annotation] = STATE(2662),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
  },
  [2469] = {
    [sym_type_parameter] = STATE(2675),
    [sym_identifier] = ACTIONS(5901),
    [anon_sym_GT] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
  },
  [2470] = {
    [aux_sym_type_parameters_repeat1] = STATE(2470),
    [anon_sym_COMMA] = ACTIONS(5905),
    [anon_sym_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
  },
  [2471] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(5910),
    [sym_comment] = ACTIONS(3),
  },
  [2472] = {
    [anon_sym_LBRACE] = ACTIONS(5115),
    [anon_sym_COLON] = ACTIONS(5115),
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
  },
  [2473] = {
    [anon_sym_from] = ACTIONS(5912),
    [anon_sym_SEMI] = ACTIONS(5912),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5912),
  },
  [2474] = {
    [sym_type_parameter] = STATE(2675),
    [sym_identifier] = ACTIONS(5901),
    [anon_sym_GT] = ACTIONS(5914),
    [sym_comment] = ACTIONS(3),
  },
  [2475] = {
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_COMMA] = ACTIONS(2380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2380),
  },
  [2476] = {
    [aux_sym_type_parameters_repeat1] = STATE(2470),
    [anon_sym_COMMA] = ACTIONS(5916),
    [anon_sym_GT] = ACTIONS(5914),
    [sym_comment] = ACTIONS(3),
  },
  [2477] = {
    [anon_sym_RBRACK] = ACTIONS(5918),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2478] = {
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_COMMA] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2348),
  },
  [2479] = {
    [aux_sym_export_clause_repeat1] = STATE(2551),
    [anon_sym_COMMA] = ACTIONS(5920),
    [anon_sym_RBRACE] = ACTIONS(5475),
    [sym_comment] = ACTIONS(3),
  },
  [2480] = {
    [sym_string] = STATE(2669),
    [anon_sym_DQUOTE] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [sym_comment] = ACTIONS(3),
  },
  [2481] = {
    [aux_sym_enum_body_repeat1] = STATE(2481),
    [anon_sym_COMMA] = ACTIONS(5922),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [sym_comment] = ACTIONS(3),
  },
  [2482] = {
    [anon_sym_COMMA] = ACTIONS(5925),
    [anon_sym_SEMI] = ACTIONS(5925),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5925),
  },
  [2483] = {
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_SEMI] = ACTIONS(5927),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5927),
  },
  [2484] = {
    [aux_sym_object_repeat1] = STATE(2508),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5929),
    [sym_comment] = ACTIONS(3),
  },
  [2485] = {
    [anon_sym_COMMA] = ACTIONS(5931),
    [anon_sym_SEMI] = ACTIONS(5931),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5931),
  },
  [2486] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5929),
    [sym_comment] = ACTIONS(3),
  },
  [2487] = {
    [aux_sym_array_repeat1] = STATE(2383),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(4287),
    [sym_comment] = ACTIONS(3),
  },
  [2488] = {
    [anon_sym_LBRACE] = ACTIONS(4256),
    [anon_sym_COMMA] = ACTIONS(4256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_implements] = ACTIONS(4256),
  },
  [2489] = {
    [anon_sym_LBRACE] = ACTIONS(3776),
    [anon_sym_COLON] = ACTIONS(3776),
    [anon_sym_EQ_GT] = ACTIONS(3776),
    [sym_comment] = ACTIONS(3),
  },
  [2490] = {
    [anon_sym_from] = ACTIONS(5933),
    [anon_sym_SEMI] = ACTIONS(5933),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5933),
  },
  [2491] = {
    [sym_type_parameter] = STATE(2675),
    [sym_identifier] = ACTIONS(5901),
    [anon_sym_GT] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
  },
  [2492] = {
    [aux_sym_array_repeat1] = STATE(2510),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4332),
    [sym_comment] = ACTIONS(3),
  },
  [2493] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4332),
    [sym_comment] = ACTIONS(3),
  },
  [2494] = {
    [anon_sym_as] = ACTIONS(5935),
    [anon_sym_COMMA] = ACTIONS(5937),
    [anon_sym_RBRACE] = ACTIONS(5937),
    [sym_comment] = ACTIONS(3),
  },
  [2495] = {
    [aux_sym_export_clause_repeat1] = STATE(2479),
    [anon_sym_COMMA] = ACTIONS(5939),
    [anon_sym_RBRACE] = ACTIONS(5941),
    [sym_comment] = ACTIONS(3),
  },
  [2496] = {
    [anon_sym_COMMA] = ACTIONS(5943),
    [anon_sym_SEMI] = ACTIONS(5943),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5943),
  },
  [2497] = {
    [sym_nested_identifier] = STATE(2880),
    [sym_nested_type_identifier] = STATE(1039),
    [sym_identifier] = ACTIONS(5945),
    [sym_comment] = ACTIONS(3),
  },
  [2498] = {
    [sym_type_annotation] = STATE(2653),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(3),
  },
  [2499] = {
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_SEMI] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5586),
  },
  [2500] = {
    [aux_sym_object_repeat1] = STATE(2514),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5950),
    [sym_comment] = ACTIONS(3),
  },
  [2501] = {
    [anon_sym_RBRACK] = ACTIONS(5952),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2502] = {
    [anon_sym_COMMA] = ACTIONS(5954),
    [anon_sym_SEMI] = ACTIONS(5954),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5954),
  },
  [2503] = {
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2398),
  },
  [2504] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(5956),
    [anon_sym_RBRACE] = ACTIONS(5959),
    [sym_comment] = ACTIONS(3),
  },
  [2505] = {
    [anon_sym_COMMA] = ACTIONS(4868),
    [anon_sym_SEMI] = ACTIONS(4868),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4868),
  },
  [2506] = {
    [sym__for_header] = STATE(35),
    [anon_sym_LPAREN] = ACTIONS(5961),
    [anon_sym_await] = ACTIONS(5963),
    [sym_comment] = ACTIONS(3),
  },
  [2507] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5965),
    [sym_comment] = ACTIONS(3),
  },
  [2508] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5967),
    [sym_comment] = ACTIONS(3),
  },
  [2509] = {
    [sym_identifier] = ACTIONS(5969),
    [anon_sym_SEMI] = ACTIONS(5971),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5971),
  },
  [2510] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(5973),
    [sym_comment] = ACTIONS(3),
  },
  [2511] = {
    [sym_object_type] = STATE(2089),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [2512] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2456),
    [anon_sym_COMMA] = ACTIONS(5975),
    [anon_sym_RPAREN] = ACTIONS(4746),
    [sym_comment] = ACTIONS(3),
  },
  [2513] = {
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2514] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5979),
    [sym_comment] = ACTIONS(3),
  },
  [2515] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5950),
    [sym_comment] = ACTIONS(3),
  },
  [2516] = {
    [sym_type_parameters] = STATE(2859),
    [anon_sym_EQ] = ACTIONS(5981),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2517] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(5983),
    [anon_sym_GT] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
  },
  [2518] = {
    [aux_sym_enum_body_repeat1] = STATE(2481),
    [anon_sym_COMMA] = ACTIONS(5985),
    [anon_sym_RBRACE] = ACTIONS(4892),
    [sym_comment] = ACTIONS(3),
  },
  [2519] = {
    [anon_sym_SEMI] = ACTIONS(5987),
    [anon_sym_DOT] = ACTIONS(5031),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5987),
  },
  [2520] = {
    [aux_sym_array_repeat1] = STATE(2525),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(4326),
    [sym_comment] = ACTIONS(3),
  },
  [2521] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(4326),
    [sym_comment] = ACTIONS(3),
  },
  [2522] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(5989),
    [sym_comment] = ACTIONS(3),
  },
  [2523] = {
    [anon_sym_RBRACK] = ACTIONS(5991),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2524] = {
    [anon_sym_COMMA] = ACTIONS(5993),
    [anon_sym_SEMI] = ACTIONS(5993),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5993),
  },
  [2525] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(5995),
    [sym_comment] = ACTIONS(3),
  },
  [2526] = {
    [aux_sym_object_repeat1] = STATE(2539),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [2527] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
  },
  [2528] = {
    [anon_sym_from] = ACTIONS(5999),
    [anon_sym_SEMI] = ACTIONS(5999),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(5999),
  },
  [2529] = {
    [anon_sym_LBRACE] = ACTIONS(5177),
    [anon_sym_COLON] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
  },
  [2530] = {
    [aux_sym_array_repeat1] = STATE(2541),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4313),
    [sym_comment] = ACTIONS(3),
  },
  [2531] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(4313),
    [sym_comment] = ACTIONS(3),
  },
  [2532] = {
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_COMMA] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2384),
  },
  [2533] = {
    [anon_sym_COMMA] = ACTIONS(6001),
    [anon_sym_SEMI] = ACTIONS(6001),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6001),
  },
  [2534] = {
    [sym_nested_identifier] = STATE(2894),
    [sym_nested_type_identifier] = STATE(1589),
    [sym_identifier] = ACTIONS(6003),
    [sym_comment] = ACTIONS(3),
  },
  [2535] = {
    [aux_sym_enum_body_repeat1] = STATE(2518),
    [anon_sym_COMMA] = ACTIONS(5519),
    [anon_sym_RBRACE] = ACTIONS(5521),
    [sym_comment] = ACTIONS(3),
  },
  [2536] = {
    [sym_object_type] = STATE(2188),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE_PIPE] = ACTIONS(971),
  },
  [2537] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2437),
    [anon_sym_COMMA] = ACTIONS(5975),
    [anon_sym_RPAREN] = ACTIONS(4746),
    [sym_comment] = ACTIONS(3),
  },
  [2538] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6005),
    [sym_comment] = ACTIONS(3),
  },
  [2539] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6007),
    [sym_comment] = ACTIONS(3),
  },
  [2540] = {
    [anon_sym_COMMA] = ACTIONS(6009),
    [anon_sym_SEMI] = ACTIONS(6009),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6009),
  },
  [2541] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(6011),
    [sym_comment] = ACTIONS(3),
  },
  [2542] = {
    [anon_sym_RPAREN] = ACTIONS(6013),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2543] = {
    [sym_type_parameter] = STATE(2675),
    [sym_identifier] = ACTIONS(5901),
    [anon_sym_GT] = ACTIONS(6015),
    [sym_comment] = ACTIONS(3),
  },
  [2544] = {
    [anon_sym_RBRACK] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2545] = {
    [sym_statement_block] = STATE(500),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_LPAREN] = ACTIONS(6019),
    [sym_comment] = ACTIONS(3),
  },
  [2546] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(6021),
    [anon_sym_GT] = ACTIONS(3337),
    [sym_comment] = ACTIONS(3),
  },
  [2547] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(6023),
    [sym_comment] = ACTIONS(3),
  },
  [2548] = {
    [anon_sym_EQ] = ACTIONS(6025),
    [anon_sym_COMMA] = ACTIONS(5790),
    [anon_sym_from] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
  },
  [2549] = {
    [sym_type_parameters] = STATE(2926),
    [anon_sym_EQ] = ACTIONS(6027),
    [anon_sym_LT] = ACTIONS(2525),
    [sym_comment] = ACTIONS(3),
  },
  [2550] = {
    [anon_sym_COMMA] = ACTIONS(6029),
    [anon_sym_SEMI] = ACTIONS(6029),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6029),
  },
  [2551] = {
    [aux_sym_export_clause_repeat1] = STATE(2551),
    [anon_sym_COMMA] = ACTIONS(6031),
    [anon_sym_RBRACE] = ACTIONS(6034),
    [sym_comment] = ACTIONS(3),
  },
  [2552] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(6036),
    [sym_comment] = ACTIONS(3),
  },
  [2553] = {
    [anon_sym_RBRACK] = ACTIONS(6038),
    [anon_sym_AMP] = ACTIONS(5020),
    [anon_sym_PIPE] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
  },
  [2554] = {
    [sym_string] = STATE(2792),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
  },
  [2555] = {
    [aux_sym_array_repeat1] = STATE(2422),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(4341),
    [sym_comment] = ACTIONS(3),
  },
  [2556] = {
    [aux_sym_object_repeat1] = STATE(2504),
    [anon_sym_COMMA] = ACTIONS(117),
    [anon_sym_RBRACE] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [2557] = {
    [aux_sym_formal_parameters_repeat1] = STATE(2456),
    [anon_sym_COMMA] = ACTIONS(6042),
    [anon_sym_RPAREN] = ACTIONS(4730),
    [sym_comment] = ACTIONS(3),
  },
  [2558] = {
    [anon_sym_COMMA] = ACTIONS(4264),
    [anon_sym_RPAREN] = ACTIONS(4264),
    [anon_sym_RBRACK] = ACTIONS(4264),
    [sym_comment] = ACTIONS(3),
  },
  [2559] = {
    [anon_sym_SEMI] = ACTIONS(6044),
    [anon_sym_DOT] = ACTIONS(5031),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6044),
  },
  [2560] = {
    [anon_sym_from] = ACTIONS(6046),
    [anon_sym_SEMI] = ACTIONS(6046),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6046),
  },
  [2561] = {
    [anon_sym_LBRACE] = ACTIONS(6048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_extends] = ACTIONS(5471),
    [anon_sym_LBRACE_PIPE] = ACTIONS(5471),
  },
  [2562] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(6050),
    [anon_sym_GT] = ACTIONS(3343),
    [sym_comment] = ACTIONS(3),
  },
  [2563] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(4341),
    [sym_comment] = ACTIONS(3),
  },
  [2564] = {
    [aux_sym_implements_clause_repeat1] = STATE(2129),
    [anon_sym_COMMA] = ACTIONS(5414),
    [anon_sym_RBRACK] = ACTIONS(6052),
    [sym_comment] = ACTIONS(3),
  },
  [2565] = {
    [aux_sym_array_repeat1] = STATE(2338),
    [anon_sym_COMMA] = ACTIONS(823),
    [anon_sym_RPAREN] = ACTIONS(4287),
    [sym_comment] = ACTIONS(3),
  },
  [2566] = {
    [sym_type_annotation] = STATE(2662),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(6054),
    [sym_comment] = ACTIONS(3),
  },
  [2567] = {
    [anon_sym_as] = ACTIONS(6057),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [sym_comment] = ACTIONS(3),
  },
  [2568] = {
    [anon_sym_COMMA] = ACTIONS(6061),
    [anon_sym_RPAREN] = ACTIONS(6061),
    [sym_comment] = ACTIONS(3),
  },
  [2569] = {
    [sym_formal_parameters] = STATE(2928),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2570] = {
    [sym_class_body] = STATE(2226),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2571] = {
    [sym_identifier] = ACTIONS(6063),
    [anon_sym_STAR] = ACTIONS(6065),
    [sym_comment] = ACTIONS(3),
  },
  [2572] = {
    [sym_parenthesized_expression] = STATE(2705),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [sym_comment] = ACTIONS(3),
  },
  [2573] = {
    [sym_class_body] = STATE(2216),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2574] = {
    [sym_class_body] = STATE(1262),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2575] = {
    [sym_statement_block] = STATE(493),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2576] = {
    [anon_sym_COMMA] = ACTIONS(6069),
    [anon_sym_RBRACE] = ACTIONS(6069),
    [sym_comment] = ACTIONS(3),
  },
  [2577] = {
    [sym_class_body] = STATE(1070),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
  },
  [2578] = {
    [sym_class_body] = STATE(1306),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2579] = {
    [sym_parenthesized_expression] = STATE(2636),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2580] = {
    [sym_formal_parameters] = STATE(2498),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2581] = {
    [sym_statement_block] = STATE(1345),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2582] = {
    [anon_sym_COMMA] = ACTIONS(4810),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [sym_comment] = ACTIONS(3),
  },
  [2583] = {
    [sym_statement_block] = STATE(492),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2584] = {
    [sym_statement_block] = STATE(490),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2585] = {
    [sym_class_body] = STATE(1375),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2586] = {
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_RBRACE] = ACTIONS(5959),
    [sym_comment] = ACTIONS(3),
  },
  [2587] = {
    [sym__from_clause] = STATE(2745),
    [anon_sym_from] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
  },
  [2588] = {
    [anon_sym_COMMA] = ACTIONS(4858),
    [anon_sym_RBRACE] = ACTIONS(4858),
    [sym_comment] = ACTIONS(3),
  },
  [2589] = {
    [sym_class_body] = STATE(1492),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2590] = {
    [anon_sym_SEMI] = ACTIONS(6073),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6073),
  },
  [2591] = {
    [sym_class_body] = STATE(1343),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2592] = {
    [anon_sym_SEMI] = ACTIONS(6075),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6075),
  },
  [2593] = {
    [anon_sym_SEMI] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6077),
  },
  [2594] = {
    [sym_class_body] = STATE(1117),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
  },
  [2595] = {
    [sym_statement_block] = STATE(560),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2596] = {
    [sym_type_annotation] = STATE(2232),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
  },
  [2597] = {
    [sym_type_annotation] = STATE(2235),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
  },
  [2598] = {
    [sym_nested_identifier] = STATE(1613),
    [sym_identifier] = ACTIONS(6079),
    [sym_comment] = ACTIONS(3),
  },
  [2599] = {
    [sym_statement_block] = STATE(2701),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2600] = {
    [sym_class_body] = STATE(2270),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2601] = {
    [sym_type_annotation] = STATE(2239),
    [anon_sym_COLON] = ACTIONS(3182),
    [sym_comment] = ACTIONS(3),
  },
  [2602] = {
    [sym_statement_block] = STATE(993),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(3),
  },
  [2603] = {
    [sym_class_body] = STATE(2278),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2604] = {
    [sym_class_body] = STATE(995),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
  },
  [2605] = {
    [sym_statement_block] = STATE(1081),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(3),
  },
  [2606] = {
    [sym_class_body] = STATE(503),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2607] = {
    [sym_formal_parameters] = STATE(2445),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2608] = {
    [sym_class_body] = STATE(2148),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2609] = {
    [anon_sym_SEMI] = ACTIONS(6081),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6081),
  },
  [2610] = {
    [sym_class_body] = STATE(2184),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2611] = {
    [anon_sym_COMMA] = ACTIONS(6083),
    [anon_sym_RBRACE] = ACTIONS(6083),
    [sym_comment] = ACTIONS(3),
  },
  [2612] = {
    [sym_formal_parameters] = STATE(2868),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2613] = {
    [sym_statement_block] = STATE(1321),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2614] = {
    [sym_statement_block] = STATE(2639),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2615] = {
    [anon_sym_SEMI] = ACTIONS(6085),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6085),
  },
  [2616] = {
    [sym_statement_block] = STATE(1030),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(3),
  },
  [2617] = {
    [sym_statement_block] = STATE(1073),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(3),
  },
  [2618] = {
    [sym_class_body] = STATE(1072),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
  },
  [2619] = {
    [sym_class_body] = STATE(1475),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2620] = {
    [sym_parenthesized_expression] = STATE(43),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2621] = {
    [sym_formal_parameters] = STATE(2881),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2622] = {
    [sym_class_body] = STATE(1412),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2623] = {
    [sym_formal_parameters] = STATE(2392),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2624] = {
    [sym_nested_identifier] = STATE(1017),
    [sym_identifier] = ACTIONS(6087),
    [sym_comment] = ACTIONS(3),
  },
  [2625] = {
    [sym_identifier] = ACTIONS(6089),
    [anon_sym_STAR] = ACTIONS(6091),
    [sym_comment] = ACTIONS(3),
  },
  [2626] = {
    [sym_class_body] = STATE(1487),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2627] = {
    [sym_statement_block] = STATE(2667),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2628] = {
    [sym_statement_block] = STATE(1133),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(3),
  },
  [2629] = {
    [sym_parenthesized_expression] = STATE(39),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2630] = {
    [sym_class_body] = STATE(997),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
  },
  [2631] = {
    [anon_sym_SEMI] = ACTIONS(6093),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6093),
  },
  [2632] = {
    [sym_parenthesized_expression] = STATE(45),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2633] = {
    [sym_parenthesized_expression] = STATE(38),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2634] = {
    [sym_statement_block] = STATE(1373),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2635] = {
    [sym_parenthesized_expression] = STATE(40),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2636] = {
    [sym_switch_body] = STATE(578),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [sym_comment] = ACTIONS(3),
  },
  [2637] = {
    [anon_sym_SEMI] = ACTIONS(2983),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(2983),
  },
  [2638] = {
    [sym_statement_block] = STATE(1569),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2639] = {
    [anon_sym_COMMA] = ACTIONS(4854),
    [anon_sym_RBRACE] = ACTIONS(4854),
    [sym_comment] = ACTIONS(3),
  },
  [2640] = {
    [sym_class_body] = STATE(1398),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2641] = {
    [sym__for_header] = STATE(42),
    [anon_sym_LPAREN] = ACTIONS(6099),
    [sym_comment] = ACTIONS(3),
  },
  [2642] = {
    [sym_statement_block] = STATE(1495),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2643] = {
    [anon_sym_COMMA] = ACTIONS(4802),
    [anon_sym_RBRACE] = ACTIONS(4802),
    [sym_comment] = ACTIONS(3),
  },
  [2644] = {
    [sym__from_clause] = STATE(2706),
    [anon_sym_from] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
  },
  [2645] = {
    [sym_statement_block] = STATE(2717),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2646] = {
    [anon_sym_COMMA] = ACTIONS(4838),
    [anon_sym_RBRACE] = ACTIONS(4838),
    [sym_comment] = ACTIONS(3),
  },
  [2647] = {
    [sym_identifier] = ACTIONS(6101),
    [anon_sym_STAR] = ACTIONS(6103),
    [sym_comment] = ACTIONS(3),
  },
  [2648] = {
    [sym_statement_block] = STATE(1012),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(3),
  },
  [2649] = {
    [anon_sym_SEMI] = ACTIONS(3468),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3468),
  },
  [2650] = {
    [sym_statement_block] = STATE(1378),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2651] = {
    [sym_statement_block] = STATE(1029),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(3),
  },
  [2652] = {
    [sym_class_body] = STATE(1042),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
  },
  [2653] = {
    [anon_sym_LBRACE] = ACTIONS(5253),
    [anon_sym_EQ_GT] = ACTIONS(5253),
    [sym_comment] = ACTIONS(3),
  },
  [2654] = {
    [sym_formal_parameters] = STATE(2334),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2655] = {
    [sym_class_body] = STATE(1310),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2656] = {
    [sym_statement_block] = STATE(496),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
  },
  [2657] = {
    [sym_statement_block] = STATE(120),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
  },
  [2658] = {
    [sym_formal_parameters] = STATE(1952),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
  },
  [2659] = {
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [sym_comment] = ACTIONS(3),
  },
  [2660] = {
    [sym__for_header] = STATE(37),
    [anon_sym_LPAREN] = ACTIONS(6099),
    [sym_comment] = ACTIONS(3),
  },
  [2661] = {
    [anon_sym_COMMA] = ACTIONS(6105),
    [anon_sym_RPAREN] = ACTIONS(6105),
    [sym_comment] = ACTIONS(3),
  },
  [2662] = {
    [anon_sym_LBRACE] = ACTIONS(5275),
    [anon_sym_EQ_GT] = ACTIONS(5275),
    [sym_comment] = ACTIONS(3),
  },
  [2663] = {
    [anon_sym_COMMA] = ACTIONS(6107),
    [anon_sym_RPAREN] = ACTIONS(6107),
    [sym_comment] = ACTIONS(3),
  },
  [2664] = {
    [sym_statement_block] = STATE(109),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
  },
  [2665] = {
    [sym_class_body] = STATE(1460),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2666] = {
    [sym_type_parameter] = STATE(2418),
    [sym_identifier] = ACTIONS(5901),
    [sym_comment] = ACTIONS(3),
  },
  [2667] = {
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [sym_comment] = ACTIONS(3),
  },
  [2668] = {
    [sym_statement_block] = STATE(2733),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2669] = {
    [anon_sym_SEMI] = ACTIONS(6109),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6109),
  },
  [2670] = {
    [sym_statement_block] = STATE(2588),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2671] = {
    [sym_enum_body] = STATE(571),
    [anon_sym_LBRACE] = ACTIONS(6111),
    [sym_comment] = ACTIONS(3),
  },
  [2672] = {
    [sym_class_body] = STATE(584),
    [anon_sym_LBRACE] = ACTIONS(5081),
    [sym_comment] = ACTIONS(3),
  },
  [2673] = {
    [sym_statement_block] = STATE(566),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2674] = {
    [sym_class_body] = STATE(495),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2675] = {
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
  },
  [2676] = {
    [sym_statement_block] = STATE(1461),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2677] = {
    [anon_sym_SEMI] = ACTIONS(2979),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(2979),
  },
  [2678] = {
    [anon_sym_COMMA] = ACTIONS(6113),
    [anon_sym_RPAREN] = ACTIONS(6113),
    [sym_comment] = ACTIONS(3),
  },
  [2679] = {
    [sym_class_body] = STATE(1132),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
  },
  [2680] = {
    [anon_sym_COMMA] = ACTIONS(4850),
    [anon_sym_RBRACE] = ACTIONS(4850),
    [sym_comment] = ACTIONS(3),
  },
  [2681] = {
    [sym_formal_parameters] = STATE(2386),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2682] = {
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_GT] = ACTIONS(6115),
    [sym_comment] = ACTIONS(3),
  },
  [2683] = {
    [sym_statement_block] = STATE(1484),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2684] = {
    [sym_class_body] = STATE(1609),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2685] = {
    [sym_statement_block] = STATE(1606),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2686] = {
    [sym_statement_block] = STATE(2582),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2687] = {
    [sym_statement_block] = STATE(1383),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2688] = {
    [sym_enum_body] = STATE(2258),
    [anon_sym_LBRACE] = ACTIONS(6117),
    [sym_comment] = ACTIONS(3),
  },
  [2689] = {
    [sym_formal_parameters] = STATE(1922),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [sym_comment] = ACTIONS(3),
  },
  [2690] = {
    [anon_sym_COMMA] = ACTIONS(4834),
    [anon_sym_RBRACE] = ACTIONS(4834),
    [sym_comment] = ACTIONS(3),
  },
  [2691] = {
    [sym_statement_block] = STATE(2643),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2692] = {
    [anon_sym_SEMI] = ACTIONS(4184),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4184),
  },
  [2693] = {
    [sym_enum_body] = STATE(563),
    [anon_sym_LBRACE] = ACTIONS(6111),
    [sym_comment] = ACTIONS(3),
  },
  [2694] = {
    [sym_class_body] = STATE(1594),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2695] = {
    [sym_statement_block] = STATE(1571),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2696] = {
    [sym_class_body] = STATE(125),
    [anon_sym_LBRACE] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
  },
  [2697] = {
    [anon_sym_COMMA] = ACTIONS(4814),
    [anon_sym_RBRACE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
  },
  [2698] = {
    [sym_statement_block] = STATE(2646),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2699] = {
    [sym_statement_block] = STATE(1547),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2700] = {
    [sym_class_body] = STATE(1540),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2701] = {
    [anon_sym_COMMA] = ACTIONS(4846),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [sym_comment] = ACTIONS(3),
  },
  [2702] = {
    [anon_sym_else] = ACTIONS(6119),
    [anon_sym_while] = ACTIONS(2859),
    [sym_comment] = ACTIONS(3),
  },
  [2703] = {
    [sym_class_body] = STATE(1539),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2704] = {
    [sym_formal_parameters] = STATE(2915),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2705] = {
    [anon_sym_SEMI] = ACTIONS(6121),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6121),
  },
  [2706] = {
    [anon_sym_SEMI] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3474),
  },
  [2707] = {
    [sym_class_body] = STATE(499),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2708] = {
    [anon_sym_SEMI] = ACTIONS(6123),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6123),
  },
  [2709] = {
    [sym_nested_identifier] = STATE(2519),
    [sym_identifier] = ACTIONS(6125),
    [sym_comment] = ACTIONS(3),
  },
  [2710] = {
    [anon_sym_SEMI] = ACTIONS(6127),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6127),
  },
  [2711] = {
    [sym_statement_block] = STATE(1441),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2712] = {
    [sym_enum_body] = STATE(2165),
    [anon_sym_LBRACE] = ACTIONS(6117),
    [sym_comment] = ACTIONS(3),
  },
  [2713] = {
    [sym_class_body] = STATE(502),
    [anon_sym_LBRACE] = ACTIONS(5077),
    [sym_comment] = ACTIONS(3),
  },
  [2714] = {
    [sym_statement_block] = STATE(2219),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
  },
  [2715] = {
    [sym_nested_identifier] = STATE(2559),
    [sym_identifier] = ACTIONS(6129),
    [sym_comment] = ACTIONS(3),
  },
  [2716] = {
    [sym_statement_block] = STATE(2680),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2717] = {
    [anon_sym_COMMA] = ACTIONS(4842),
    [anon_sym_RBRACE] = ACTIONS(4842),
    [sym_comment] = ACTIONS(3),
  },
  [2718] = {
    [anon_sym_COMMA] = ACTIONS(6131),
    [anon_sym_RBRACE] = ACTIONS(6131),
    [sym_comment] = ACTIONS(3),
  },
  [2719] = {
    [sym_statement_block] = STATE(1104),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(3),
  },
  [2720] = {
    [sym_statement_block] = STATE(1483),
    [anon_sym_LBRACE] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [2721] = {
    [sym_statement_block] = STATE(1537),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2722] = {
    [sym_identifier] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
  },
  [2723] = {
    [sym_class_body] = STATE(117),
    [anon_sym_LBRACE] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
  },
  [2724] = {
    [sym_class_body] = STATE(1086),
    [anon_sym_LBRACE] = ACTIONS(5049),
    [sym_comment] = ACTIONS(3),
  },
  [2725] = {
    [sym_statement_block] = STATE(485),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
  },
  [2726] = {
    [anon_sym_COMMA] = ACTIONS(6137),
    [anon_sym_RPAREN] = ACTIONS(6137),
    [sym_comment] = ACTIONS(3),
  },
  [2727] = {
    [sym_statement_block] = STATE(455),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2728] = {
    [sym_statement_block] = STATE(1551),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2729] = {
    [sym_statement_block] = STATE(2282),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
  },
  [2730] = {
    [sym_class_body] = STATE(1560),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2731] = {
    [sym_class_body] = STATE(1563),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2732] = {
    [sym_statement_block] = STATE(1579),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2733] = {
    [anon_sym_COMMA] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [sym_comment] = ACTIONS(3),
  },
  [2734] = {
    [sym_statement_block] = STATE(2289),
    [anon_sym_LBRACE] = ACTIONS(5087),
    [sym_comment] = ACTIONS(3),
  },
  [2735] = {
    [sym_type_parameter] = STATE(2675),
    [sym_identifier] = ACTIONS(5901),
    [sym_comment] = ACTIONS(3),
  },
  [2736] = {
    [sym_statement_block] = STATE(2690),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2737] = {
    [sym_nested_identifier] = STATE(1380),
    [sym_identifier] = ACTIONS(6139),
    [sym_comment] = ACTIONS(3),
  },
  [2738] = {
    [anon_sym_SEMI] = ACTIONS(3741),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(3741),
  },
  [2739] = {
    [sym_statement_block] = STATE(1593),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2740] = {
    [sym_class_body] = STATE(1600),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2741] = {
    [sym_formal_parameters] = STATE(2850),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2742] = {
    [sym_formal_parameters] = STATE(2849),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2743] = {
    [sym__from_clause] = STATE(2592),
    [anon_sym_from] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
  },
  [2744] = {
    [sym_class_body] = STATE(1445),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [sym_comment] = ACTIONS(3),
  },
  [2745] = {
    [anon_sym_SEMI] = ACTIONS(6141),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(6141),
  },
  [2746] = {
    [sym_class_body] = STATE(533),
    [anon_sym_LBRACE] = ACTIONS(5081),
    [sym_comment] = ACTIONS(3),
  },
  [2747] = {
    [sym__from_clause] = STATE(2649),
    [anon_sym_from] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
  },
  [2748] = {
    [anon_sym_COMMA] = ACTIONS(6143),
    [anon_sym_RPAREN] = ACTIONS(6143),
    [sym_comment] = ACTIONS(3),
  },
  [2749] = {
    [sym_formal_parameters] = STATE(2923),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2750] = {
    [sym_nested_identifier] = STATE(1851),
    [sym_identifier] = ACTIONS(6145),
    [sym_comment] = ACTIONS(3),
  },
  [2751] = {
    [sym_formal_parameters] = STATE(2821),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2752] = {
    [anon_sym_COMMA] = ACTIONS(6147),
    [anon_sym_RBRACE] = ACTIONS(6147),
    [sym_comment] = ACTIONS(3),
  },
  [2753] = {
    [sym_statement_block] = STATE(2697),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [2754] = {
    [sym_class_body] = STATE(122),
    [anon_sym_LBRACE] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
  },
  [2755] = {
    [anon_sym_COMMA] = ACTIONS(6149),
    [anon_sym_RPAREN] = ACTIONS(6149),
    [sym_comment] = ACTIONS(3),
  },
  [2756] = {
    [sym_formal_parameters] = STATE(2958),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2757] = {
    [sym_parenthesized_expression] = STATE(46),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
  },
  [2758] = {
    [anon_sym_COMMA] = ACTIONS(5622),
    [anon_sym_GT] = ACTIONS(5622),
    [sym_comment] = ACTIONS(3),
  },
  [2759] = {
    [sym_formal_parameters] = STATE(2824),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2760] = {
    [sym_type_parameter] = STATE(2399),
    [sym_identifier] = ACTIONS(5901),
    [sym_comment] = ACTIONS(3),
  },
  [2761] = {
    [sym_nested_identifier] = STATE(411),
    [sym_identifier] = ACTIONS(6151),
    [sym_comment] = ACTIONS(3),
  },
  [2762] = {
    [sym_formal_parameters] = STATE(2835),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2763] = {
    [sym_class_body] = STATE(116),
    [anon_sym_LBRACE] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
  },
  [2764] = {
    [sym_class_body] = STATE(1572),
    [anon_sym_LBRACE] = ACTIONS(5063),
    [sym_comment] = ACTIONS(3),
  },
  [2765] = {
    [sym_formal_parameters] = STATE(2836),
    [anon_sym_LPAREN] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2766] = {
    [anon_sym_SEMI] = ACTIONS(4262),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4262),
  },
  [2767] = {
    [anon_sym_COMMA] = ACTIONS(6153),
    [anon_sym_RBRACE] = ACTIONS(6153),
    [sym_comment] = ACTIONS(3),
  },
  [2768] = {
    [anon_sym_SEMI] = ACTIONS(4260),
    [sym_comment] = ACTIONS(3),
    [sym__automatic_semicolon] = ACTIONS(4260),
  },
  [2769] = {
    [sym_identifier] = ACTIONS(6155),
    [sym_comment] = ACTIONS(3),
  },
  [2770] = {
    [anon_sym_LBRACE] = ACTIONS(5779),
    [sym_comment] = ACTIONS(3),
  },
  [2771] = {
    [anon_sym_RPAREN] = ACTIONS(4460),
    [sym_comment] = ACTIONS(3),
  },
  [2772] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6157),
  },
  [2773] = {
    [sym_identifier] = ACTIONS(6159),
    [sym_comment] = ACTIONS(3),
  },
  [2774] = {
    [anon_sym_EQ_GT] = ACTIONS(6161),
    [sym_comment] = ACTIONS(3),
  },
  [2775] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6163),
  },
  [2776] = {
    [anon_sym_EQ_GT] = ACTIONS(5565),
    [sym_comment] = ACTIONS(3),
  },
  [2777] = {
    [anon_sym_DOT] = ACTIONS(4939),
    [sym_comment] = ACTIONS(3),
  },
  [2778] = {
    [anon_sym_EQ_GT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(3),
  },
  [2779] = {
    [sym_identifier] = ACTIONS(6165),
    [sym_comment] = ACTIONS(3),
  },
  [2780] = {
    [sym_identifier] = ACTIONS(6167),
    [sym_comment] = ACTIONS(3),
  },
  [2781] = {
    [anon_sym_while] = ACTIONS(6169),
    [sym_comment] = ACTIONS(3),
  },
  [2782] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_target] = ACTIONS(6171),
  },
  [2783] = {
    [sym_identifier] = ACTIONS(6173),
    [sym_comment] = ACTIONS(3),
  },
  [2784] = {
    [sym_identifier] = ACTIONS(6175),
    [sym_comment] = ACTIONS(3),
  },
  [2785] = {
    [sym_identifier] = ACTIONS(6177),
    [sym_comment] = ACTIONS(3),
  },
  [2786] = {
    [sym_identifier] = ACTIONS(6179),
    [sym_comment] = ACTIONS(3),
  },
  [2787] = {
    [anon_sym_RPAREN] = ACTIONS(3901),
    [sym_comment] = ACTIONS(3),
  },
  [2788] = {
    [sym_identifier] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
  },
  [2789] = {
    [anon_sym_EQ_GT] = ACTIONS(6183),
    [sym_comment] = ACTIONS(3),
  },
  [2790] = {
    [anon_sym_DOT] = ACTIONS(4271),
    [sym_comment] = ACTIONS(3),
  },
  [2791] = {
    [anon_sym_from] = ACTIONS(6185),
    [sym_comment] = ACTIONS(3),
  },
  [2792] = {
    [anon_sym_RPAREN] = ACTIONS(6187),
    [sym_comment] = ACTIONS(3),
  },
  [2793] = {
    [sym_identifier] = ACTIONS(6189),
    [sym_comment] = ACTIONS(3),
  },
  [2794] = {
    [anon_sym_RPAREN] = ACTIONS(4441),
    [sym_comment] = ACTIONS(3),
  },
  [2795] = {
    [sym_identifier] = ACTIONS(6191),
    [sym_comment] = ACTIONS(3),
  },
  [2796] = {
    [sym_identifier] = ACTIONS(6193),
    [sym_comment] = ACTIONS(3),
  },
  [2797] = {
    [sym_identifier] = ACTIONS(6195),
    [sym_comment] = ACTIONS(3),
  },
  [2798] = {
    [sym_identifier] = ACTIONS(6197),
    [sym_comment] = ACTIONS(3),
  },
  [2799] = {
    [anon_sym_EQ_GT] = ACTIONS(6199),
    [sym_comment] = ACTIONS(3),
  },
  [2800] = {
    [anon_sym_EQ_GT] = ACTIONS(6201),
    [sym_comment] = ACTIONS(3),
  },
  [2801] = {
    [anon_sym_EQ_GT] = ACTIONS(6203),
    [sym_comment] = ACTIONS(3),
  },
  [2802] = {
    [anon_sym_EQ_GT] = ACTIONS(6205),
    [sym_comment] = ACTIONS(3),
  },
  [2803] = {
    [sym_identifier] = ACTIONS(6207),
    [sym_comment] = ACTIONS(3),
  },
  [2804] = {
    [anon_sym_RBRACE] = ACTIONS(6209),
    [sym_comment] = ACTIONS(3),
  },
  [2805] = {
    [sym_identifier] = ACTIONS(6211),
    [sym_comment] = ACTIONS(3),
  },
  [2806] = {
    [sym_comment] = ACTIONS(5551),
    [sym_regex_pattern] = ACTIONS(6213),
  },
  [2807] = {
    [anon_sym_EQ] = ACTIONS(6215),
    [sym_comment] = ACTIONS(3),
  },
  [2808] = {
    [sym_comment] = ACTIONS(5551),
    [sym_regex_pattern] = ACTIONS(6217),
  },
  [2809] = {
    [sym_identifier] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
  },
  [2810] = {
    [sym_identifier] = ACTIONS(6221),
    [sym_comment] = ACTIONS(3),
  },
  [2811] = {
    [sym_identifier] = ACTIONS(6223),
    [sym_comment] = ACTIONS(3),
  },
  [2812] = {
    [anon_sym_DOT] = ACTIONS(4964),
    [sym_comment] = ACTIONS(3),
  },
  [2813] = {
    [sym_identifier] = ACTIONS(6225),
    [sym_comment] = ACTIONS(3),
  },
  [2814] = {
    [sym_identifier] = ACTIONS(6227),
    [sym_comment] = ACTIONS(3),
  },
  [2815] = {
    [sym_identifier] = ACTIONS(6229),
    [sym_comment] = ACTIONS(3),
  },
  [2816] = {
    [sym_identifier] = ACTIONS(6231),
    [sym_comment] = ACTIONS(3),
  },
  [2817] = {
    [sym_identifier] = ACTIONS(6233),
    [sym_comment] = ACTIONS(3),
  },
  [2818] = {
    [sym_identifier] = ACTIONS(6235),
    [sym_comment] = ACTIONS(3),
  },
  [2819] = {
    [sym_identifier] = ACTIONS(6237),
    [sym_comment] = ACTIONS(3),
  },
  [2820] = {
    [anon_sym_RPAREN] = ACTIONS(4439),
    [sym_comment] = ACTIONS(3),
  },
  [2821] = {
    [anon_sym_EQ_GT] = ACTIONS(6239),
    [sym_comment] = ACTIONS(3),
  },
  [2822] = {
    [sym_identifier] = ACTIONS(6241),
    [sym_comment] = ACTIONS(3),
  },
  [2823] = {
    [anon_sym_RPAREN] = ACTIONS(4437),
    [sym_comment] = ACTIONS(3),
  },
  [2824] = {
    [anon_sym_EQ_GT] = ACTIONS(6243),
    [sym_comment] = ACTIONS(3),
  },
  [2825] = {
    [anon_sym_RPAREN] = ACTIONS(4433),
    [sym_comment] = ACTIONS(3),
  },
  [2826] = {
    [sym_identifier] = ACTIONS(6245),
    [sym_comment] = ACTIONS(3),
  },
  [2827] = {
    [anon_sym_EQ_GT] = ACTIONS(6247),
    [sym_comment] = ACTIONS(3),
  },
  [2828] = {
    [sym_identifier] = ACTIONS(6249),
    [sym_comment] = ACTIONS(3),
  },
  [2829] = {
    [sym_identifier] = ACTIONS(6251),
    [sym_comment] = ACTIONS(3),
  },
  [2830] = {
    [anon_sym_EQ_GT] = ACTIONS(6253),
    [sym_comment] = ACTIONS(3),
  },
  [2831] = {
    [sym_identifier] = ACTIONS(6255),
    [sym_comment] = ACTIONS(3),
  },
  [2832] = {
    [sym_identifier] = ACTIONS(6257),
    [sym_comment] = ACTIONS(3),
  },
  [2833] = {
    [anon_sym_from] = ACTIONS(5792),
    [sym_comment] = ACTIONS(3),
  },
  [2834] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6259),
  },
  [2835] = {
    [anon_sym_EQ_GT] = ACTIONS(6261),
    [sym_comment] = ACTIONS(3),
  },
  [2836] = {
    [anon_sym_EQ_GT] = ACTIONS(6263),
    [sym_comment] = ACTIONS(3),
  },
  [2837] = {
    [sym_identifier] = ACTIONS(6265),
    [sym_comment] = ACTIONS(3),
  },
  [2838] = {
    [anon_sym_as] = ACTIONS(6267),
    [sym_comment] = ACTIONS(3),
  },
  [2839] = {
    [anon_sym_EQ_GT] = ACTIONS(6269),
    [sym_comment] = ACTIONS(3),
  },
  [2840] = {
    [anon_sym_RPAREN] = ACTIONS(6271),
    [sym_comment] = ACTIONS(3),
  },
  [2841] = {
    [sym_identifier] = ACTIONS(6273),
    [sym_comment] = ACTIONS(3),
  },
  [2842] = {
    [anon_sym_EQ_GT] = ACTIONS(6275),
    [sym_comment] = ACTIONS(3),
  },
  [2843] = {
    [anon_sym_RPAREN] = ACTIONS(6277),
    [sym_comment] = ACTIONS(3),
  },
  [2844] = {
    [anon_sym_EQ] = ACTIONS(6279),
    [sym_comment] = ACTIONS(3),
  },
  [2845] = {
    [anon_sym_RPAREN] = ACTIONS(4015),
    [sym_comment] = ACTIONS(3),
  },
  [2846] = {
    [anon_sym_EQ] = ACTIONS(6281),
    [sym_comment] = ACTIONS(3),
  },
  [2847] = {
    [sym_identifier] = ACTIONS(6283),
    [sym_comment] = ACTIONS(3),
  },
  [2848] = {
    [sym_identifier] = ACTIONS(6285),
    [sym_comment] = ACTIONS(3),
  },
  [2849] = {
    [anon_sym_EQ_GT] = ACTIONS(6287),
    [sym_comment] = ACTIONS(3),
  },
  [2850] = {
    [anon_sym_EQ_GT] = ACTIONS(6289),
    [sym_comment] = ACTIONS(3),
  },
  [2851] = {
    [anon_sym_RBRACK] = ACTIONS(6291),
    [sym_comment] = ACTIONS(3),
  },
  [2852] = {
    [sym_identifier] = ACTIONS(6293),
    [sym_comment] = ACTIONS(3),
  },
  [2853] = {
    [anon_sym_EQ_GT] = ACTIONS(6295),
    [sym_comment] = ACTIONS(3),
  },
  [2854] = {
    [anon_sym_RPAREN] = ACTIONS(6297),
    [sym_comment] = ACTIONS(3),
  },
  [2855] = {
    [sym_identifier] = ACTIONS(6299),
    [sym_comment] = ACTIONS(3),
  },
  [2856] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6301),
  },
  [2857] = {
    [anon_sym_EQ_GT] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
  },
  [2858] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6305),
  },
  [2859] = {
    [anon_sym_EQ] = ACTIONS(6307),
    [sym_comment] = ACTIONS(3),
  },
  [2860] = {
    [anon_sym_RBRACK] = ACTIONS(6309),
    [sym_comment] = ACTIONS(3),
  },
  [2861] = {
    [anon_sym_RPAREN] = ACTIONS(4037),
    [sym_comment] = ACTIONS(3),
  },
  [2862] = {
    [anon_sym_RPAREN] = ACTIONS(6311),
    [sym_comment] = ACTIONS(3),
  },
  [2863] = {
    [sym_identifier] = ACTIONS(6313),
    [sym_comment] = ACTIONS(3),
  },
  [2864] = {
    [anon_sym_COLON] = ACTIONS(6315),
    [sym_comment] = ACTIONS(3),
  },
  [2865] = {
    [anon_sym_function] = ACTIONS(6317),
    [sym_comment] = ACTIONS(3),
  },
  [2866] = {
    [sym_identifier] = ACTIONS(6319),
    [sym_comment] = ACTIONS(3),
  },
  [2867] = {
    [sym_identifier] = ACTIONS(6321),
    [sym_comment] = ACTIONS(3),
  },
  [2868] = {
    [anon_sym_EQ_GT] = ACTIONS(6323),
    [sym_comment] = ACTIONS(3),
  },
  [2869] = {
    [sym_identifier] = ACTIONS(6325),
    [sym_comment] = ACTIONS(3),
  },
  [2870] = {
    [sym_identifier] = ACTIONS(6327),
    [sym_comment] = ACTIONS(3),
  },
  [2871] = {
    [anon_sym_EQ_GT] = ACTIONS(6329),
    [sym_comment] = ACTIONS(3),
  },
  [2872] = {
    [anon_sym_EQ_GT] = ACTIONS(6331),
    [sym_comment] = ACTIONS(3),
  },
  [2873] = {
    [anon_sym_EQ_GT] = ACTIONS(6333),
    [sym_comment] = ACTIONS(3),
  },
  [2874] = {
    [anon_sym_EQ_GT] = ACTIONS(6335),
    [sym_comment] = ACTIONS(3),
  },
  [2875] = {
    [sym_identifier] = ACTIONS(6337),
    [sym_comment] = ACTIONS(3),
  },
  [2876] = {
    [sym_comment] = ACTIONS(5551),
    [sym_regex_pattern] = ACTIONS(6339),
  },
  [2877] = {
    [sym_identifier] = ACTIONS(6341),
    [sym_comment] = ACTIONS(3),
  },
  [2878] = {
    [anon_sym_RBRACE] = ACTIONS(6343),
    [sym_comment] = ACTIONS(3),
  },
  [2879] = {
    [anon_sym_RBRACK] = ACTIONS(4431),
    [sym_comment] = ACTIONS(3),
  },
  [2880] = {
    [anon_sym_DOT] = ACTIONS(3641),
    [sym_comment] = ACTIONS(3),
  },
  [2881] = {
    [anon_sym_EQ_GT] = ACTIONS(6345),
    [sym_comment] = ACTIONS(3),
  },
  [2882] = {
    [anon_sym_from] = ACTIONS(6347),
    [sym_comment] = ACTIONS(3),
  },
  [2883] = {
    [anon_sym_namespace] = ACTIONS(6349),
    [sym_comment] = ACTIONS(3),
  },
  [2884] = {
    [sym_identifier] = ACTIONS(6351),
    [sym_comment] = ACTIONS(3),
  },
  [2885] = {
    [anon_sym_EQ_GT] = ACTIONS(6353),
    [sym_comment] = ACTIONS(3),
  },
  [2886] = {
    [anon_sym_RPAREN] = ACTIONS(6355),
    [sym_comment] = ACTIONS(3),
  },
  [2887] = {
    [sym_identifier] = ACTIONS(6357),
    [sym_comment] = ACTIONS(3),
  },
  [2888] = {
    [anon_sym_DOT] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
  },
  [2889] = {
    [sym_identifier] = ACTIONS(6361),
    [sym_comment] = ACTIONS(3),
  },
  [2890] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_target] = ACTIONS(6363),
  },
  [2891] = {
    [anon_sym_EQ_GT] = ACTIONS(6365),
    [sym_comment] = ACTIONS(3),
  },
  [2892] = {
    [anon_sym_EQ_GT] = ACTIONS(6367),
    [sym_comment] = ACTIONS(3),
  },
  [2893] = {
    [anon_sym_EQ_GT] = ACTIONS(6369),
    [sym_comment] = ACTIONS(3),
  },
  [2894] = {
    [anon_sym_DOT] = ACTIONS(4415),
    [sym_comment] = ACTIONS(3),
  },
  [2895] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6371),
  },
  [2896] = {
    [anon_sym_EQ_GT] = ACTIONS(6373),
    [sym_comment] = ACTIONS(3),
  },
  [2897] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6375),
  },
  [2898] = {
    [anon_sym_RPAREN] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
  },
  [2899] = {
    [anon_sym_EQ_GT] = ACTIONS(6377),
    [sym_comment] = ACTIONS(3),
  },
  [2900] = {
    [sym_identifier] = ACTIONS(6379),
    [sym_comment] = ACTIONS(3),
  },
  [2901] = {
    [anon_sym_EQ_GT] = ACTIONS(6381),
    [sym_comment] = ACTIONS(3),
  },
  [2902] = {
    [sym_identifier] = ACTIONS(6383),
    [sym_comment] = ACTIONS(3),
  },
  [2903] = {
    [anon_sym_RPAREN] = ACTIONS(6385),
    [sym_comment] = ACTIONS(3),
  },
  [2904] = {
    [anon_sym_RPAREN] = ACTIONS(6387),
    [sym_comment] = ACTIONS(3),
  },
  [2905] = {
    [anon_sym_class] = ACTIONS(6389),
    [sym_comment] = ACTIONS(3),
  },
  [2906] = {
    [ts_builtin_sym_end] = ACTIONS(6391),
    [sym_comment] = ACTIONS(3),
  },
  [2907] = {
    [anon_sym_RPAREN] = ACTIONS(4487),
    [sym_comment] = ACTIONS(3),
  },
  [2908] = {
    [sym_identifier] = ACTIONS(6393),
    [sym_comment] = ACTIONS(3),
  },
  [2909] = {
    [anon_sym_EQ_GT] = ACTIONS(6395),
    [sym_comment] = ACTIONS(3),
  },
  [2910] = {
    [sym_identifier] = ACTIONS(6397),
    [sym_comment] = ACTIONS(3),
  },
  [2911] = {
    [anon_sym_COLON] = ACTIONS(6399),
    [sym_comment] = ACTIONS(3),
  },
  [2912] = {
    [anon_sym_namespace] = ACTIONS(6401),
    [sym_comment] = ACTIONS(3),
  },
  [2913] = {
    [anon_sym_RPAREN] = ACTIONS(4481),
    [sym_comment] = ACTIONS(3),
  },
  [2914] = {
    [anon_sym_RPAREN] = ACTIONS(4479),
    [sym_comment] = ACTIONS(3),
  },
  [2915] = {
    [anon_sym_EQ_GT] = ACTIONS(6403),
    [sym_comment] = ACTIONS(3),
  },
  [2916] = {
    [sym_identifier] = ACTIONS(6405),
    [sym_comment] = ACTIONS(3),
  },
  [2917] = {
    [anon_sym_EQ_GT] = ACTIONS(6407),
    [sym_comment] = ACTIONS(3),
  },
  [2918] = {
    [anon_sym_RPAREN] = ACTIONS(4477),
    [sym_comment] = ACTIONS(3),
  },
  [2919] = {
    [anon_sym_EQ_GT] = ACTIONS(6409),
    [sym_comment] = ACTIONS(3),
  },
  [2920] = {
    [anon_sym_EQ_GT] = ACTIONS(6411),
    [sym_comment] = ACTIONS(3),
  },
  [2921] = {
    [anon_sym_COLON] = ACTIONS(4465),
    [sym_comment] = ACTIONS(3),
  },
  [2922] = {
    [anon_sym_class] = ACTIONS(6413),
    [sym_comment] = ACTIONS(3),
  },
  [2923] = {
    [anon_sym_EQ_GT] = ACTIONS(6415),
    [sym_comment] = ACTIONS(3),
  },
  [2924] = {
    [anon_sym_EQ] = ACTIONS(6417),
    [sym_comment] = ACTIONS(3),
  },
  [2925] = {
    [anon_sym_RBRACK] = ACTIONS(4453),
    [sym_comment] = ACTIONS(3),
  },
  [2926] = {
    [anon_sym_EQ] = ACTIONS(6419),
    [sym_comment] = ACTIONS(3),
  },
  [2927] = {
    [anon_sym_RPAREN] = ACTIONS(4485),
    [sym_comment] = ACTIONS(3),
  },
  [2928] = {
    [anon_sym_EQ_GT] = ACTIONS(6421),
    [sym_comment] = ACTIONS(3),
  },
  [2929] = {
    [sym_identifier] = ACTIONS(6423),
    [sym_comment] = ACTIONS(3),
  },
  [2930] = {
    [anon_sym_EQ_GT] = ACTIONS(6425),
    [sym_comment] = ACTIONS(3),
  },
  [2931] = {
    [anon_sym_RPAREN] = ACTIONS(6427),
    [sym_comment] = ACTIONS(3),
  },
  [2932] = {
    [sym_identifier] = ACTIONS(6429),
    [sym_comment] = ACTIONS(3),
  },
  [2933] = {
    [sym_identifier] = ACTIONS(6431),
    [sym_comment] = ACTIONS(3),
  },
  [2934] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_target] = ACTIONS(6433),
  },
  [2935] = {
    [anon_sym_EQ_GT] = ACTIONS(6435),
    [sym_comment] = ACTIONS(3),
  },
  [2936] = {
    [anon_sym_EQ_GT] = ACTIONS(6437),
    [sym_comment] = ACTIONS(3),
  },
  [2937] = {
    [anon_sym_EQ_GT] = ACTIONS(6439),
    [sym_comment] = ACTIONS(3),
  },
  [2938] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH2] = ACTIONS(6441),
  },
  [2939] = {
    [anon_sym_EQ_GT] = ACTIONS(6443),
    [sym_comment] = ACTIONS(3),
  },
  [2940] = {
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(6445),
  },
  [2941] = {
    [anon_sym_RPAREN] = ACTIONS(4129),
    [sym_comment] = ACTIONS(3),
  },
  [2942] = {
    [anon_sym_EQ_GT] = ACTIONS(6447),
    [sym_comment] = ACTIONS(3),
  },
  [2943] = {
    [sym_identifier] = ACTIONS(6449),
    [sym_comment] = ACTIONS(3),
  },
  [2944] = {
    [sym_identifier] = ACTIONS(6451),
    [sym_comment] = ACTIONS(3),
  },
  [2945] = {
    [sym_identifier] = ACTIONS(6453),
    [sym_comment] = ACTIONS(3),
  },
  [2946] = {
    [anon_sym_EQ_GT] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
  },
  [2947] = {
    [anon_sym_LBRACE] = ACTIONS(6457),
    [sym_comment] = ACTIONS(3),
  },
  [2948] = {
    [anon_sym_RBRACE] = ACTIONS(4410),
    [sym_comment] = ACTIONS(3),
  },
  [2949] = {
    [anon_sym_from] = ACTIONS(6459),
    [sym_comment] = ACTIONS(3),
  },
  [2950] = {
    [sym_comment] = ACTIONS(5551),
    [sym_regex_pattern] = ACTIONS(6461),
  },
  [2951] = {
    [anon_sym_RBRACK] = ACTIONS(4406),
    [sym_comment] = ACTIONS(3),
  },
  [2952] = {
    [sym_identifier] = ACTIONS(6463),
    [sym_comment] = ACTIONS(3),
  },
  [2953] = {
    [sym_identifier] = ACTIONS(6465),
    [sym_comment] = ACTIONS(3),
  },
  [2954] = {
    [sym_identifier] = ACTIONS(6467),
    [sym_comment] = ACTIONS(3),
  },
  [2955] = {
    [anon_sym_COLON] = ACTIONS(6469),
    [sym_comment] = ACTIONS(3),
  },
  [2956] = {
    [sym_identifier] = ACTIONS(6471),
    [sym_comment] = ACTIONS(3),
  },
  [2957] = {
    [sym_identifier] = ACTIONS(6473),
    [sym_comment] = ACTIONS(3),
  },
  [2958] = {
    [anon_sym_EQ_GT] = ACTIONS(6475),
    [sym_comment] = ACTIONS(3),
  },
  [2959] = {
    [anon_sym_from] = ACTIONS(6477),
    [sym_comment] = ACTIONS(3),
  },
  [2960] = {
    [anon_sym_from] = ACTIONS(6479),
    [sym_comment] = ACTIONS(3),
  },
  [2961] = {
    [anon_sym_from] = ACTIONS(6481),
    [sym_comment] = ACTIONS(3),
  },
  [2962] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_require] = ACTIONS(6483),
  },
  [2963] = {
    [anon_sym_LPAREN] = ACTIONS(6485),
    [sym_comment] = ACTIONS(3),
  },
  [2964] = {
    [sym_identifier] = ACTIONS(6487),
    [sym_comment] = ACTIONS(3),
  },
  [2965] = {
    [sym_identifier] = ACTIONS(6489),
    [sym_comment] = ACTIONS(3),
  },
  [2966] = {
    [anon_sym_function] = ACTIONS(6491),
    [sym_comment] = ACTIONS(3),
  },
  [2967] = {
    [anon_sym_from] = ACTIONS(6493),
    [sym_comment] = ACTIONS(3),
  },
  [2968] = {
    [anon_sym_COLON] = ACTIONS(6495),
    [sym_comment] = ACTIONS(3),
  },
  [2969] = {
    [sym_identifier] = ACTIONS(6497),
    [sym_comment] = ACTIONS(3),
  },
  [2970] = {
    [anon_sym_RBRACK] = ACTIONS(6499),
    [sym_comment] = ACTIONS(3),
  },
  [2971] = {
    [sym_identifier] = ACTIONS(6501),
    [sym_comment] = ACTIONS(3),
  },
  [2972] = {
    [sym_identifier] = ACTIONS(6503),
    [sym_comment] = ACTIONS(3),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(823),
  [9] = {.count = 1, .reusable = true}, SHIFT(16),
  [11] = {.count = 1, .reusable = false}, SHIFT(221),
  [13] = {.count = 1, .reusable = false}, SHIFT(620),
  [15] = {.count = 1, .reusable = true}, SHIFT(3),
  [17] = {.count = 1, .reusable = false}, SHIFT(767),
  [19] = {.count = 1, .reusable = false}, SHIFT(265),
  [21] = {.count = 1, .reusable = false}, SHIFT(901),
  [23] = {.count = 1, .reusable = false}, SHIFT(2033),
  [25] = {.count = 1, .reusable = false}, SHIFT(2015),
  [27] = {.count = 1, .reusable = false}, SHIFT(1998),
  [29] = {.count = 1, .reusable = false}, SHIFT(2635),
  [31] = {.count = 1, .reusable = false}, SHIFT(2579),
  [33] = {.count = 1, .reusable = false}, SHIFT(2384),
  [35] = {.count = 1, .reusable = true}, SHIFT(133),
  [37] = {.count = 1, .reusable = false}, SHIFT(271),
  [39] = {.count = 1, .reusable = false}, SHIFT(2620),
  [41] = {.count = 1, .reusable = false}, SHIFT(47),
  [43] = {.count = 1, .reusable = false}, SHIFT(2727),
  [45] = {.count = 1, .reusable = false}, SHIFT(2757),
  [47] = {.count = 1, .reusable = false}, SHIFT(2444),
  [49] = {.count = 1, .reusable = false}, SHIFT(2509),
  [51] = {.count = 1, .reusable = false}, SHIFT(2631),
  [53] = {.count = 1, .reusable = false}, SHIFT(154),
  [55] = {.count = 1, .reusable = false}, SHIFT(218),
  [57] = {.count = 1, .reusable = true}, SHIFT(488),
  [59] = {.count = 1, .reusable = false}, SHIFT(98),
  [61] = {.count = 1, .reusable = true}, SHIFT(143),
  [63] = {.count = 1, .reusable = true}, SHIFT(677),
  [65] = {.count = 1, .reusable = false}, SHIFT(2950),
  [67] = {.count = 1, .reusable = false}, SHIFT(1894),
  [69] = {.count = 1, .reusable = false}, SHIFT(489),
  [71] = {.count = 1, .reusable = false}, SHIFT(1930),
  [73] = {.count = 1, .reusable = false}, SHIFT(210),
  [75] = {.count = 1, .reusable = false}, SHIFT(313),
  [77] = {.count = 1, .reusable = true}, SHIFT(314),
  [79] = {.count = 1, .reusable = false}, SHIFT(59),
  [81] = {.count = 1, .reusable = true}, SHIFT(319),
  [83] = {.count = 1, .reusable = true}, SHIFT(2367),
  [85] = {.count = 1, .reusable = true}, SHIFT(2366),
  [87] = {.count = 1, .reusable = true}, SHIFT(2077),
  [89] = {.count = 1, .reusable = true}, SHIFT(1148),
  [91] = {.count = 1, .reusable = false}, SHIFT(1148),
  [93] = {.count = 1, .reusable = false}, SHIFT(999),
  [95] = {.count = 1, .reusable = true}, SHIFT(1800),
  [97] = {.count = 1, .reusable = false}, SHIFT(799),
  [99] = {.count = 1, .reusable = false}, SHIFT(2922),
  [101] = {.count = 1, .reusable = false}, SHIFT(408),
  [103] = {.count = 1, .reusable = false}, SHIFT(628),
  [105] = {.count = 1, .reusable = false}, SHIFT(2916),
  [107] = {.count = 1, .reusable = false}, SHIFT(2910),
  [109] = {.count = 1, .reusable = false}, SHIFT(680),
  [111] = {.count = 1, .reusable = false}, SHIFT(158),
  [113] = {.count = 1, .reusable = true}, SHIFT(1780),
  [115] = {.count = 1, .reusable = false}, SHIFT(615),
  [117] = {.count = 1, .reusable = true}, SHIFT(1155),
  [119] = {.count = 1, .reusable = true}, SHIFT(1238),
  [121] = {.count = 1, .reusable = false}, SHIFT(650),
  [123] = {.count = 1, .reusable = true}, SHIFT(139),
  [125] = {.count = 1, .reusable = false}, SHIFT(413),
  [127] = {.count = 1, .reusable = true}, SHIFT(347),
  [129] = {.count = 1, .reusable = false}, SHIFT(50),
  [131] = {.count = 1, .reusable = true}, SHIFT(1506),
  [133] = {.count = 1, .reusable = false}, SHIFT(448),
  [135] = {.count = 1, .reusable = false}, SHIFT(446),
  [137] = {.count = 1, .reusable = false}, SHIFT(196),
  [139] = {.count = 1, .reusable = false}, SHIFT(473),
  [141] = {.count = 1, .reusable = false}, SHIFT(611),
  [143] = {.count = 1, .reusable = false}, SHIFT(683),
  [145] = {.count = 1, .reusable = false}, SHIFT(451),
  [147] = {.count = 1, .reusable = true}, SHIFT(105),
  [149] = {.count = 1, .reusable = false}, SHIFT(685),
  [151] = {.count = 1, .reusable = false}, SHIFT(152),
  [153] = {.count = 1, .reusable = false}, SHIFT(613),
  [155] = {.count = 1, .reusable = true}, SHIFT(928),
  [157] = {.count = 1, .reusable = false}, SHIFT(647),
  [159] = {.count = 1, .reusable = false}, SHIFT(419),
  [161] = {.count = 1, .reusable = false}, SHIFT(51),
  [163] = {.count = 1, .reusable = false}, SHIFT(449),
  [165] = {.count = 1, .reusable = false}, SHIFT(452),
  [167] = {.count = 1, .reusable = false}, SHIFT(216),
  [169] = {.count = 1, .reusable = false}, SHIFT(483),
  [171] = {.count = 1, .reusable = false}, SHIFT(617),
  [173] = {.count = 1, .reusable = false}, SHIFT(690),
  [175] = {.count = 1, .reusable = false}, SHIFT(447),
  [177] = {.count = 1, .reusable = true}, SHIFT(1281),
  [179] = {.count = 1, .reusable = false}, SHIFT(666),
  [181] = {.count = 1, .reusable = false}, SHIFT(159),
  [183] = {.count = 1, .reusable = false}, SHIFT(614),
  [185] = {.count = 1, .reusable = true}, SHIFT(1271),
  [187] = {.count = 1, .reusable = false}, SHIFT(660),
  [189] = {.count = 1, .reusable = false}, SHIFT(421),
  [191] = {.count = 1, .reusable = false}, SHIFT(48),
  [193] = {.count = 1, .reusable = false}, SHIFT(445),
  [195] = {.count = 1, .reusable = false}, SHIFT(444),
  [197] = {.count = 1, .reusable = false}, SHIFT(180),
  [199] = {.count = 1, .reusable = false}, SHIFT(475),
  [201] = {.count = 1, .reusable = false}, SHIFT(612),
  [203] = {.count = 1, .reusable = false}, SHIFT(664),
  [205] = {.count = 1, .reusable = false}, SHIFT(450),
  [207] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [209] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(823),
  [212] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(221),
  [215] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [217] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(620),
  [220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [223] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(767),
  [226] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(265),
  [229] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(901),
  [232] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2033),
  [235] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2015),
  [238] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1998),
  [241] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2635),
  [244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2579),
  [247] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2384),
  [250] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(133),
  [253] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(271),
  [256] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2620),
  [259] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(47),
  [262] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2727),
  [265] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2757),
  [268] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2444),
  [271] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2509),
  [274] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2631),
  [277] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(154),
  [280] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(218),
  [283] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(488),
  [286] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(98),
  [289] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(143),
  [292] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(677),
  [295] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2950),
  [298] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1894),
  [301] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(489),
  [304] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1930),
  [307] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(210),
  [310] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(313),
  [313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(314),
  [316] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(59),
  [319] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(319),
  [322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2367),
  [325] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2366),
  [328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2077),
  [331] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1148),
  [334] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1148),
  [337] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(999),
  [340] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1800),
  [343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(799),
  [346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2922),
  [349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(408),
  [352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(628),
  [355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2916),
  [358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2910),
  [361] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [363] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [365] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3, .production_id = 76),
  [367] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3, .production_id = 76),
  [369] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4, .production_id = 76),
  [371] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4, .production_id = 76),
  [373] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [375] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [377] = {.count = 1, .reusable = true}, SHIFT(1734),
  [379] = {.count = 1, .reusable = true}, SHIFT(107),
  [381] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [383] = {.count = 1, .reusable = true}, SHIFT(114),
  [385] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [387] = {.count = 1, .reusable = true}, SHIFT(1156),
  [389] = {.count = 1, .reusable = true}, SHIFT(453),
  [391] = {.count = 1, .reusable = true}, SHIFT(1254),
  [393] = {.count = 1, .reusable = true}, SHIFT(965),
  [395] = {.count = 1, .reusable = true}, SHIFT(462),
  [397] = {.count = 1, .reusable = true}, SHIFT(470),
  [399] = {.count = 1, .reusable = true}, SHIFT(454),
  [401] = {.count = 1, .reusable = true}, SHIFT(1419),
  [403] = {.count = 1, .reusable = true}, SHIFT(1730),
  [405] = {.count = 1, .reusable = true}, SHIFT(958),
  [407] = {.count = 1, .reusable = true}, SHIFT(1444),
  [409] = {.count = 1, .reusable = false}, SHIFT(812),
  [411] = {.count = 1, .reusable = false}, SHIFT(212),
  [413] = {.count = 1, .reusable = false}, SHIFT(623),
  [415] = {.count = 1, .reusable = true}, SHIFT(2),
  [417] = {.count = 1, .reusable = false}, SHIFT(720),
  [419] = {.count = 1, .reusable = false}, SHIFT(2629),
  [421] = {.count = 1, .reusable = false}, SHIFT(2506),
  [423] = {.count = 1, .reusable = false}, SHIFT(2632),
  [425] = {.count = 1, .reusable = false}, SHIFT(2633),
  [427] = {.count = 1, .reusable = false}, SHIFT(1874),
  [429] = {.count = 1, .reusable = false}, SHIFT(487),
  [431] = {.count = 1, .reusable = false}, SHIFT(1989),
  [433] = {.count = 1, .reusable = false}, SHIFT(58),
  [435] = {.count = 1, .reusable = false}, SHIFT(807),
  [437] = {.count = 1, .reusable = false}, SHIFT(407),
  [439] = {.count = 1, .reusable = false}, SHIFT(634),
  [441] = {.count = 1, .reusable = false}, SHIFT(805),
  [443] = {.count = 1, .reusable = false}, SHIFT(795),
  [445] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [447] = {.count = 1, .reusable = false}, SHIFT(324),
  [449] = {.count = 1, .reusable = false}, SHIFT(622),
  [451] = {.count = 1, .reusable = true}, SHIFT(1011),
  [453] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [455] = {.count = 1, .reusable = true}, SHIFT(1416),
  [457] = {.count = 1, .reusable = false}, SHIFT(1502),
  [459] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(44),
  [462] = {.count = 1, .reusable = false}, SHIFT(677),
  [464] = {.count = 1, .reusable = false}, SHIFT(2869),
  [466] = {.count = 1, .reusable = false}, SHIFT(1884),
  [468] = {.count = 1, .reusable = false}, SHIFT(497),
  [470] = {.count = 1, .reusable = false}, SHIFT(1979),
  [472] = {.count = 1, .reusable = true}, SHIFT(186),
  [474] = {.count = 1, .reusable = true}, SHIFT(404),
  [476] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [479] = {.count = 1, .reusable = false}, SHIFT(314),
  [481] = {.count = 1, .reusable = false}, SHIFT(57),
  [483] = {.count = 1, .reusable = true}, SHIFT(1023),
  [485] = {.count = 1, .reusable = false}, SHIFT(1023),
  [487] = {.count = 1, .reusable = false}, SHIFT(857),
  [489] = {.count = 1, .reusable = false}, SHIFT(855),
  [491] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [493] = {.count = 1, .reusable = false}, SHIFT(316),
  [495] = {.count = 1, .reusable = false}, SHIFT(642),
  [497] = {.count = 1, .reusable = true}, SHIFT(1135),
  [499] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 15),
  [501] = {.count = 1, .reusable = false}, SHIFT(384),
  [503] = {.count = 1, .reusable = false}, SHIFT(1101),
  [505] = {.count = 1, .reusable = false}, SHIFT(366),
  [507] = {.count = 1, .reusable = false}, SHIFT(99),
  [509] = {.count = 1, .reusable = false}, SHIFT(2945),
  [511] = {.count = 1, .reusable = false}, SHIFT(1868),
  [513] = {.count = 1, .reusable = false}, SHIFT(595),
  [515] = {.count = 1, .reusable = false}, SHIFT(1953),
  [517] = {.count = 1, .reusable = true}, SHIFT(183),
  [519] = {.count = 1, .reusable = false}, SHIFT(205),
  [521] = {.count = 1, .reusable = true}, SHIFT(315),
  [523] = {.count = 1, .reusable = true}, SHIFT(296),
  [525] = {.count = 1, .reusable = false}, SHIFT(73),
  [527] = {.count = 1, .reusable = true}, SHIFT(2318),
  [529] = {.count = 1, .reusable = true}, SHIFT(2317),
  [531] = {.count = 1, .reusable = true}, SHIFT(1324),
  [533] = {.count = 1, .reusable = false}, SHIFT(1324),
  [535] = {.count = 1, .reusable = false}, SHIFT(923),
  [537] = {.count = 1, .reusable = true}, SHIFT(1092),
  [539] = {.count = 1, .reusable = true}, SHIFT(938),
  [541] = {.count = 1, .reusable = false}, SHIFT(766),
  [543] = {.count = 1, .reusable = false}, SHIFT(753),
  [545] = {.count = 1, .reusable = false}, SHIFT(401),
  [547] = {.count = 1, .reusable = false}, SHIFT(619),
  [549] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [552] = {.count = 1, .reusable = false}, SHIFT(295),
  [554] = {.count = 1, .reusable = true}, SHIFT(134),
  [556] = {.count = 1, .reusable = false}, SHIFT(312),
  [558] = {.count = 1, .reusable = false}, SHIFT(95),
  [560] = {.count = 1, .reusable = true}, SHIFT(141),
  [562] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [565] = {.count = 1, .reusable = false}, SHIFT(2808),
  [567] = {.count = 1, .reusable = false}, SHIFT(476),
  [569] = {.count = 1, .reusable = false}, SHIFT(201),
  [571] = {.count = 1, .reusable = true}, SHIFT(395),
  [573] = {.count = 1, .reusable = false}, SHIFT(247),
  [575] = {.count = 1, .reusable = false}, SHIFT(368),
  [577] = {.count = 1, .reusable = true}, SHIFT(368),
  [579] = {.count = 1, .reusable = false}, SHIFT(53),
  [581] = {.count = 1, .reusable = true}, SHIFT(372),
  [583] = {.count = 1, .reusable = true}, SHIFT(2067),
  [585] = {.count = 1, .reusable = true}, SHIFT(966),
  [587] = {.count = 1, .reusable = false}, SHIFT(966),
  [589] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [591] = {.count = 1, .reusable = false}, SHIFT(385),
  [593] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(233),
  [596] = {.count = 1, .reusable = false}, SHIFT(233),
  [598] = {.count = 1, .reusable = true}, SHIFT(36),
  [600] = {.count = 1, .reusable = true}, SHIFT(44),
  [602] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(401),
  [605] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [608] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [612] = {.count = 1, .reusable = true}, SHIFT(211),
  [614] = {.count = 1, .reusable = true}, SHIFT(220),
  [616] = {.count = 1, .reusable = true}, SHIFT(242),
  [618] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [620] = {.count = 1, .reusable = false}, SHIFT(2900),
  [622] = {.count = 1, .reusable = true}, SHIFT(198),
  [624] = {.count = 1, .reusable = false}, SHIFT(311),
  [626] = {.count = 1, .reusable = false}, SHIFT(296),
  [628] = {.count = 1, .reusable = true}, SHIFT(286),
  [630] = {.count = 1, .reusable = true}, SHIFT(1994),
  [632] = {.count = 1, .reusable = false}, SHIFT(875),
  [634] = {.count = 1, .reusable = false}, SHIFT(856),
  [636] = {.count = 1, .reusable = false}, SHIFT(293),
  [638] = {.count = 1, .reusable = false}, SHIFT(643),
  [640] = {.count = 1, .reusable = false}, SHIFT(374),
  [642] = {.count = 1, .reusable = false}, SHIFT(371),
  [644] = {.count = 1, .reusable = false}, SHIFT(101),
  [646] = {.count = 1, .reusable = false}, SHIFT(594),
  [648] = {.count = 1, .reusable = false}, SHIFT(202),
  [650] = {.count = 1, .reusable = true}, SHIFT(294),
  [652] = {.count = 1, .reusable = false}, SHIFT(370),
  [654] = {.count = 1, .reusable = false}, SHIFT(367),
  [656] = {.count = 1, .reusable = true}, SHIFT(367),
  [658] = {.count = 1, .reusable = false}, SHIFT(74),
  [660] = {.count = 1, .reusable = true}, SHIFT(350),
  [662] = {.count = 1, .reusable = true}, SHIFT(1301),
  [664] = {.count = 1, .reusable = false}, SHIFT(1301),
  [666] = {.count = 1, .reusable = false}, SHIFT(846),
  [668] = {.count = 1, .reusable = false}, SHIFT(841),
  [670] = {.count = 1, .reusable = false}, SHIFT(263),
  [672] = {.count = 1, .reusable = false}, SHIFT(641),
  [674] = {.count = 1, .reusable = false}, SHIFT(1097),
  [676] = {.count = 1, .reusable = false}, SHIFT(394),
  [678] = {.count = 1, .reusable = false}, SHIFT(1523),
  [680] = {.count = 1, .reusable = true}, SHIFT(132),
  [682] = {.count = 1, .reusable = false}, SHIFT(399),
  [684] = {.count = 1, .reusable = false}, SHIFT(100),
  [686] = {.count = 1, .reusable = true}, SHIFT(146),
  [688] = {.count = 1, .reusable = false}, SHIFT(2876),
  [690] = {.count = 1, .reusable = false}, SHIFT(1883),
  [692] = {.count = 1, .reusable = false}, SHIFT(574),
  [694] = {.count = 1, .reusable = false}, SHIFT(1954),
  [696] = {.count = 1, .reusable = false}, SHIFT(192),
  [698] = {.count = 1, .reusable = true}, SHIFT(262),
  [700] = {.count = 1, .reusable = false}, SHIFT(329),
  [702] = {.count = 1, .reusable = false}, SHIFT(328),
  [704] = {.count = 1, .reusable = true}, SHIFT(328),
  [706] = {.count = 1, .reusable = false}, SHIFT(76),
  [708] = {.count = 1, .reusable = true}, SHIFT(323),
  [710] = {.count = 1, .reusable = true}, SHIFT(2315),
  [712] = {.count = 1, .reusable = true}, SHIFT(2319),
  [714] = {.count = 1, .reusable = true}, SHIFT(2020),
  [716] = {.count = 1, .reusable = true}, SHIFT(1222),
  [718] = {.count = 1, .reusable = false}, SHIFT(1222),
  [720] = {.count = 1, .reusable = false}, SHIFT(1200),
  [722] = {.count = 1, .reusable = false}, SHIFT(838),
  [724] = {.count = 1, .reusable = false}, SHIFT(842),
  [726] = {.count = 1, .reusable = false}, SHIFT(362),
  [728] = {.count = 1, .reusable = false}, SHIFT(638),
  [730] = {.count = 1, .reusable = false}, SHIFT(398),
  [732] = {.count = 1, .reusable = false}, SHIFT(396),
  [734] = {.count = 1, .reusable = false}, SHIFT(102),
  [736] = {.count = 1, .reusable = false}, SHIFT(2806),
  [738] = {.count = 1, .reusable = false}, SHIFT(557),
  [740] = {.count = 1, .reusable = false}, SHIFT(165),
  [742] = {.count = 1, .reusable = true}, SHIFT(337),
  [744] = {.count = 1, .reusable = false}, SHIFT(302),
  [746] = {.count = 1, .reusable = false}, SHIFT(260),
  [748] = {.count = 1, .reusable = true}, SHIFT(260),
  [750] = {.count = 1, .reusable = false}, SHIFT(78),
  [752] = {.count = 1, .reusable = true}, SHIFT(308),
  [754] = {.count = 1, .reusable = true}, SHIFT(1165),
  [756] = {.count = 1, .reusable = false}, SHIFT(1165),
  [758] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(213),
  [761] = {.count = 1, .reusable = false}, SHIFT(213),
  [763] = {.count = 1, .reusable = false}, SHIFT(715),
  [765] = {.count = 1, .reusable = false}, SHIFT(847),
  [767] = {.count = 1, .reusable = true}, SHIFT(432),
  [769] = {.count = 1, .reusable = false}, SHIFT(636),
  [771] = {.count = 1, .reusable = false}, SHIFT(633),
  [773] = {.count = 1, .reusable = false}, SHIFT(189),
  [775] = {.count = 1, .reusable = true}, SHIFT(82),
  [777] = {.count = 1, .reusable = true}, SHIFT(2489),
  [779] = {.count = 1, .reusable = true}, SHIFT(86),
  [781] = {.count = 1, .reusable = false}, SHIFT(544),
  [783] = {.count = 1, .reusable = false}, SHIFT(163),
  [785] = {.count = 1, .reusable = true}, SHIFT(2797),
  [787] = {.count = 1, .reusable = true}, SHIFT(946),
  [789] = {.count = 1, .reusable = true}, SHIFT(785),
  [791] = {.count = 1, .reusable = true}, SHIFT(784),
  [793] = {.count = 1, .reusable = false}, SHIFT(361),
  [795] = {.count = 1, .reusable = false}, SHIFT(61),
  [797] = {.count = 1, .reusable = true}, SHIFT(1610),
  [799] = {.count = 1, .reusable = false}, SHIFT(1396),
  [801] = {.count = 1, .reusable = false}, SHIFT(1610),
  [803] = {.count = 1, .reusable = false}, SHIFT(990),
  [805] = {.count = 1, .reusable = false}, SHIFT(600),
  [807] = {.count = 1, .reusable = false}, SHIFT(836),
  [809] = {.count = 1, .reusable = false}, SHIFT(554),
  [811] = {.count = 1, .reusable = false}, SHIFT(2390),
  [813] = {.count = 1, .reusable = true}, SHIFT(886),
  [815] = {.count = 1, .reusable = false}, SHIFT(1096),
  [817] = {.count = 1, .reusable = false}, SHIFT(1027),
  [819] = {.count = 1, .reusable = false}, SHIFT(822),
  [821] = {.count = 1, .reusable = false}, SHIFT(627),
  [823] = {.count = 1, .reusable = true}, SHIFT(137),
  [825] = {.count = 1, .reusable = false}, SHIFT(191),
  [827] = {.count = 1, .reusable = true}, SHIFT(933),
  [829] = {.count = 1, .reusable = false}, SHIFT(391),
  [831] = {.count = 1, .reusable = false}, SHIFT(77),
  [833] = {.count = 1, .reusable = true}, SHIFT(1672),
  [835] = {.count = 1, .reusable = false}, SHIFT(1664),
  [837] = {.count = 1, .reusable = false}, SHIFT(1672),
  [839] = {.count = 1, .reusable = false}, SHIFT(1139),
  [841] = {.count = 1, .reusable = false}, SHIFT(871),
  [843] = {.count = 1, .reusable = true}, SHIFT(1038),
  [845] = {.count = 1, .reusable = false}, SHIFT(1185),
  [847] = {.count = 1, .reusable = true}, SHIFT(2199),
  [849] = {.count = 1, .reusable = false}, SHIFT(1233),
  [851] = {.count = 1, .reusable = true}, SHIFT(1410),
  [853] = {.count = 1, .reusable = false}, SHIFT(1218),
  [855] = {.count = 1, .reusable = false}, SHIFT(781),
  [857] = {.count = 1, .reusable = false}, SHIFT(630),
  [859] = {.count = 1, .reusable = false}, SHIFT(187),
  [861] = {.count = 1, .reusable = false}, SHIFT(206),
  [863] = {.count = 1, .reusable = false}, SHIFT(335),
  [865] = {.count = 1, .reusable = false}, SHIFT(72),
  [867] = {.count = 1, .reusable = true}, SHIFT(1124),
  [869] = {.count = 1, .reusable = false}, SHIFT(1125),
  [871] = {.count = 1, .reusable = false}, SHIFT(1124),
  [873] = {.count = 1, .reusable = false}, SHIFT(1243),
  [875] = {.count = 1, .reusable = false}, SHIFT(850),
  [877] = {.count = 1, .reusable = false}, SHIFT(762),
  [879] = {.count = 1, .reusable = false}, SHIFT(632),
  [881] = {.count = 1, .reusable = false}, SHIFT(227),
  [883] = {.count = 1, .reusable = true}, SHIFT(84),
  [885] = {.count = 1, .reusable = true}, SHIFT(87),
  [887] = {.count = 1, .reusable = false}, SHIFT(226),
  [889] = {.count = 1, .reusable = false}, SHIFT(287),
  [891] = {.count = 1, .reusable = false}, SHIFT(70),
  [893] = {.count = 1, .reusable = true}, SHIFT(1602),
  [895] = {.count = 1, .reusable = false}, SHIFT(1611),
  [897] = {.count = 1, .reusable = false}, SHIFT(1602),
  [899] = {.count = 1, .reusable = false}, SHIFT(1316),
  [901] = {.count = 1, .reusable = false}, SHIFT(843),
  [903] = {.count = 1, .reusable = false}, SHIFT(663),
  [905] = {.count = 1, .reusable = false}, SHIFT(200),
  [907] = {.count = 1, .reusable = false}, SHIFT(358),
  [909] = {.count = 1, .reusable = false}, SHIFT(52),
  [911] = {.count = 1, .reusable = false}, SHIFT(953),
  [913] = {.count = 1, .reusable = false}, SHIFT(773),
  [915] = {.count = 1, .reusable = false}, SHIFT(679),
  [917] = {.count = 1, .reusable = false}, SHIFT(162),
  [919] = {.count = 1, .reusable = false}, SHIFT(193),
  [921] = {.count = 1, .reusable = false}, SHIFT(386),
  [923] = {.count = 1, .reusable = false}, SHIFT(60),
  [925] = {.count = 1, .reusable = true}, SHIFT(1409),
  [927] = {.count = 1, .reusable = false}, SHIFT(1407),
  [929] = {.count = 1, .reusable = false}, SHIFT(1409),
  [931] = {.count = 1, .reusable = false}, SHIFT(1100),
  [933] = {.count = 1, .reusable = false}, SHIFT(810),
  [935] = {.count = 1, .reusable = false}, SHIFT(653),
  [937] = {.count = 1, .reusable = true}, SHIFT(1882),
  [939] = {.count = 1, .reusable = false}, SHIFT(625),
  [941] = {.count = 1, .reusable = false}, SHIFT(199),
  [943] = {.count = 1, .reusable = true}, SHIFT(81),
  [945] = {.count = 1, .reusable = true}, SHIFT(85),
  [947] = {.count = 1, .reusable = false}, SHIFT(203),
  [949] = {.count = 1, .reusable = true}, SHIFT(987),
  [951] = {.count = 1, .reusable = true}, SHIFT(704),
  [953] = {.count = 1, .reusable = true}, SHIFT(703),
  [955] = {.count = 1, .reusable = false}, SHIFT(336),
  [957] = {.count = 1, .reusable = false}, SHIFT(55),
  [959] = {.count = 1, .reusable = true}, SHIFT(1280),
  [961] = {.count = 1, .reusable = false}, SHIFT(1275),
  [963] = {.count = 1, .reusable = false}, SHIFT(1280),
  [965] = {.count = 1, .reusable = false}, SHIFT(1297),
  [967] = {.count = 1, .reusable = false}, SHIFT(731),
  [969] = {.count = 1, .reusable = false}, SHIFT(2393),
  [971] = {.count = 1, .reusable = true}, SHIFT(890),
  [973] = {.count = 1, .reusable = false}, SHIFT(330),
  [975] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [977] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [979] = {.count = 1, .reusable = true}, SHIFT(974),
  [981] = {.count = 1, .reusable = false}, SHIFT(974),
  [983] = {.count = 1, .reusable = false}, SHIFT(724),
  [985] = {.count = 1, .reusable = false}, SHIFT(629),
  [987] = {.count = 1, .reusable = false}, SHIFT(207),
  [989] = {.count = 1, .reusable = true}, SHIFT(83),
  [991] = {.count = 1, .reusable = true}, SHIFT(89),
  [993] = {.count = 1, .reusable = false}, SHIFT(204),
  [995] = {.count = 1, .reusable = false}, SHIFT(320),
  [997] = {.count = 1, .reusable = false}, SHIFT(71),
  [999] = {.count = 1, .reusable = true}, SHIFT(1616),
  [1001] = {.count = 1, .reusable = false}, SHIFT(1630),
  [1003] = {.count = 1, .reusable = false}, SHIFT(1616),
  [1005] = {.count = 1, .reusable = false}, SHIFT(1201),
  [1007] = {.count = 1, .reusable = false}, SHIFT(831),
  [1009] = {.count = 1, .reusable = false}, SHIFT(778),
  [1011] = {.count = 1, .reusable = false}, SHIFT(169),
  [1013] = {.count = 1, .reusable = false}, SHIFT(168),
  [1015] = {.count = 1, .reusable = false}, SHIFT(403),
  [1017] = {.count = 1, .reusable = false}, SHIFT(67),
  [1019] = {.count = 1, .reusable = true}, SHIFT(1647),
  [1021] = {.count = 1, .reusable = false}, SHIFT(1645),
  [1023] = {.count = 1, .reusable = false}, SHIFT(1647),
  [1025] = {.count = 1, .reusable = false}, SHIFT(1359),
  [1027] = {.count = 1, .reusable = false}, SHIFT(826),
  [1029] = {.count = 1, .reusable = false}, SHIFT(380),
  [1031] = {.count = 1, .reusable = true}, SHIFT(1037),
  [1033] = {.count = 1, .reusable = false}, SHIFT(1037),
  [1035] = {.count = 1, .reusable = false}, SHIFT(333),
  [1037] = {.count = 1, .reusable = true}, SHIFT(1327),
  [1039] = {.count = 1, .reusable = false}, SHIFT(1327),
  [1041] = {.count = 1, .reusable = false}, SHIFT(264),
  [1043] = {.count = 1, .reusable = true}, SHIFT(1225),
  [1045] = {.count = 1, .reusable = false}, SHIFT(1225),
  [1047] = {.count = 1, .reusable = false}, SHIFT(281),
  [1049] = {.count = 1, .reusable = true}, SHIFT(1303),
  [1051] = {.count = 1, .reusable = false}, SHIFT(1303),
  [1053] = {.count = 1, .reusable = false}, SHIFT(317),
  [1055] = {.count = 1, .reusable = true}, SHIFT(1162),
  [1057] = {.count = 1, .reusable = false}, SHIFT(1162),
  [1059] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1, .production_id = 5),
  [1061] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1, .production_id = 5),
  [1063] = {.count = 1, .reusable = true}, SHIFT(13),
  [1065] = {.count = 1, .reusable = false}, SHIFT(2831),
  [1067] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1069] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1071] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1073] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1075] = {.count = 1, .reusable = true}, SHIFT(467),
  [1077] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 122),
  [1079] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 122),
  [1081] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5, .production_id = 122),
  [1083] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5, .production_id = 122),
  [1085] = {.count = 1, .reusable = true}, SHIFT(551),
  [1087] = {.count = 1, .reusable = true}, SHIFT(118),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 91),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 91),
  [1093] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 91),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 91),
  [1097] = {.count = 1, .reusable = true}, SHIFT(523),
  [1099] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 147),
  [1101] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 147),
  [1103] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 6, .production_id = 147),
  [1105] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 6, .production_id = 147),
  [1107] = {.count = 1, .reusable = true}, SHIFT(509),
  [1109] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1111] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1113] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [1115] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [1117] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [1119] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [1121] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [1123] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [1125] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 101),
  [1127] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 101),
  [1129] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 101),
  [1131] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 101),
  [1133] = {.count = 1, .reusable = true}, SHIFT(582),
  [1135] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [1137] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [1139] = {.count = 1, .reusable = true}, SHIFT(126),
  [1141] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 3, .production_id = 49),
  [1143] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 3, .production_id = 49),
  [1145] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 49),
  [1147] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 49),
  [1149] = {.count = 1, .reusable = true}, SHIFT(573),
  [1151] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 127),
  [1153] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 127),
  [1155] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 127),
  [1157] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 127),
  [1159] = {.count = 1, .reusable = true}, SHIFT(556),
  [1161] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 90),
  [1163] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 90),
  [1165] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 90),
  [1167] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 90),
  [1169] = {.count = 1, .reusable = true}, SHIFT(530),
  [1171] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1173] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1175] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 5, .production_id = 122),
  [1177] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 5, .production_id = 122),
  [1179] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 122),
  [1181] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 122),
  [1183] = {.count = 1, .reusable = true}, SHIFT(515),
  [1185] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2, .production_id = 27),
  [1187] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2, .production_id = 27),
  [1189] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1191] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [1193] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .production_id = 150),
  [1195] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .production_id = 150),
  [1197] = {.count = 1, .reusable = true}, SHIFT(591),
  [1199] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 4, .production_id = 98),
  [1201] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 4, .production_id = 98),
  [1203] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 98),
  [1205] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 98),
  [1207] = {.count = 1, .reusable = true}, SHIFT(513),
  [1209] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [1211] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [1213] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 128),
  [1215] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 128),
  [1217] = {.count = 1, .reusable = true}, SHIFT(541),
  [1219] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 119),
  [1221] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 119),
  [1223] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 119),
  [1225] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 119),
  [1227] = {.count = 1, .reusable = true}, SHIFT(583),
  [1229] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 4),
  [1231] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 4),
  [1233] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [1235] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [1237] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1239] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2, .production_id = 6),
  [1241] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [1243] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [1245] = {.count = 1, .reusable = false}, SHIFT(817),
  [1247] = {.count = 1, .reusable = false}, SHIFT(804),
  [1249] = {.count = 1, .reusable = false}, SHIFT(626),
  [1251] = {.count = 1, .reusable = false}, SHIFT(179),
  [1253] = {.count = 1, .reusable = false}, SHIFT(178),
  [1255] = {.count = 1, .reusable = false}, SHIFT(501),
  [1257] = {.count = 1, .reusable = false}, SHIFT(56),
  [1259] = {.count = 1, .reusable = false}, SHIFT(848),
  [1261] = {.count = 1, .reusable = false}, SHIFT(69),
  [1263] = {.count = 1, .reusable = true}, SHIFT(1096),
  [1265] = {.count = 1, .reusable = false}, SHIFT(1498),
  [1267] = {.count = 1, .reusable = true}, SHIFT(1027),
  [1269] = {.count = 1, .reusable = true}, SHIFT(990),
  [1271] = {.count = 1, .reusable = false}, SHIFT(829),
  [1273] = {.count = 1, .reusable = false}, SHIFT(827),
  [1275] = {.count = 1, .reusable = false}, SHIFT(635),
  [1277] = {.count = 1, .reusable = false}, SHIFT(529),
  [1279] = {.count = 1, .reusable = false}, SHIFT(68),
  [1281] = {.count = 1, .reusable = true}, SHIFT(1183),
  [1283] = {.count = 1, .reusable = false}, SHIFT(1183),
  [1285] = {.count = 1, .reusable = true}, SHIFT(1711),
  [1287] = {.count = 1, .reusable = true}, SHIFT(1208),
  [1289] = {.count = 1, .reusable = false}, SHIFT(1208),
  [1291] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [1293] = {.count = 1, .reusable = true}, SHIFT(1182),
  [1295] = {.count = 1, .reusable = false}, SHIFT(1182),
  [1297] = {.count = 1, .reusable = true}, SHIFT(1428),
  [1299] = {.count = 1, .reusable = true}, SHIFT(1248),
  [1301] = {.count = 1, .reusable = false}, SHIFT(1248),
  [1303] = {.count = 1, .reusable = true}, SHIFT(1223),
  [1305] = {.count = 1, .reusable = false}, SHIFT(1223),
  [1307] = {.count = 1, .reusable = true}, SHIFT(1115),
  [1309] = {.count = 1, .reusable = true}, SHIFT(1195),
  [1311] = {.count = 1, .reusable = false}, SHIFT(1195),
  [1313] = {.count = 1, .reusable = true}, SHIFT(1139),
  [1315] = {.count = 1, .reusable = true}, SHIFT(1233),
  [1317] = {.count = 1, .reusable = true}, SHIFT(1185),
  [1319] = {.count = 1, .reusable = true}, SHIFT(2209),
  [1321] = {.count = 1, .reusable = true}, SHIFT(1211),
  [1323] = {.count = 1, .reusable = false}, SHIFT(1211),
  [1325] = {.count = 1, .reusable = true}, SHIFT(1652),
  [1327] = {.count = 1, .reusable = true}, SHIFT(1226),
  [1329] = {.count = 1, .reusable = false}, SHIFT(1226),
  [1331] = {.count = 1, .reusable = true}, SHIFT(1218),
  [1333] = {.count = 1, .reusable = true}, SHIFT(1366),
  [1335] = {.count = 1, .reusable = false}, SHIFT(1366),
  [1337] = {.count = 1, .reusable = true}, SHIFT(1203),
  [1339] = {.count = 1, .reusable = false}, SHIFT(1203),
  [1341] = {.count = 1, .reusable = false}, SHIFT(820),
  [1343] = {.count = 1, .reusable = true}, SHIFT(1097),
  [1345] = {.count = 1, .reusable = true}, SHIFT(1175),
  [1347] = {.count = 1, .reusable = false}, SHIFT(1175),
  [1349] = {.count = 1, .reusable = false}, SHIFT(2747),
  [1351] = {.count = 1, .reusable = true}, SHIFT(389),
  [1353] = {.count = 1, .reusable = false}, SHIFT(318),
  [1355] = {.count = 1, .reusable = false}, SHIFT(2883),
  [1357] = {.count = 1, .reusable = true}, SHIFT(2011),
  [1359] = {.count = 1, .reusable = true}, SHIFT(2009),
  [1361] = {.count = 1, .reusable = true}, SHIFT(2877),
  [1363] = {.count = 1, .reusable = true}, SHIFT(2870),
  [1365] = {.count = 1, .reusable = true}, SHIFT(2033),
  [1367] = {.count = 1, .reusable = true}, SHIFT(2015),
  [1369] = {.count = 1, .reusable = true}, SHIFT(1998),
  [1371] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [1374] = {.count = 1, .reusable = true}, SHIFT(2869),
  [1376] = {.count = 1, .reusable = true}, SHIFT(2866),
  [1378] = {.count = 1, .reusable = true}, SHIFT(2865),
  [1380] = {.count = 1, .reusable = true}, SHIFT(2722),
  [1382] = {.count = 1, .reusable = true}, SHIFT(2922),
  [1384] = {.count = 1, .reusable = true}, SHIFT(1698),
  [1386] = {.count = 1, .reusable = true}, SHIFT(2000),
  [1388] = {.count = 1, .reusable = true}, SHIFT(2916),
  [1390] = {.count = 1, .reusable = true}, SHIFT(2910),
  [1392] = {.count = 1, .reusable = false}, SHIFT(717),
  [1394] = {.count = 1, .reusable = true}, SHIFT(1126),
  [1396] = {.count = 1, .reusable = false}, SHIFT(1126),
  [1398] = {.count = 1, .reusable = true}, SHIFT(575),
  [1400] = {.count = 1, .reusable = true}, SHIFT(1176),
  [1402] = {.count = 1, .reusable = false}, SHIFT(1176),
  [1404] = {.count = 1, .reusable = false}, SHIFT(790),
  [1406] = {.count = 1, .reusable = true}, SHIFT(1083),
  [1408] = {.count = 1, .reusable = false}, SHIFT(1083),
  [1410] = {.count = 1, .reusable = false}, SHIFT(803),
  [1412] = {.count = 1, .reusable = true}, SHIFT(1173),
  [1414] = {.count = 1, .reusable = false}, SHIFT(1173),
  [1416] = {.count = 1, .reusable = false}, SHIFT(892),
  [1418] = {.count = 1, .reusable = false}, SHIFT(896),
  [1420] = {.count = 1, .reusable = false}, SHIFT(659),
  [1422] = {.count = 1, .reusable = false}, SHIFT(266),
  [1424] = {.count = 1, .reusable = false}, SHIFT(597),
  [1426] = {.count = 1, .reusable = false}, SHIFT(79),
  [1428] = {.count = 1, .reusable = true}, SHIFT(1548),
  [1430] = {.count = 1, .reusable = false}, SHIFT(1548),
  [1432] = {.count = 1, .reusable = true}, SHIFT(29),
  [1434] = {.count = 1, .reusable = true}, SHIFT(1320),
  [1436] = {.count = 1, .reusable = false}, SHIFT(1320),
  [1438] = {.count = 1, .reusable = true}, SHIFT(32),
  [1440] = {.count = 1, .reusable = true}, SHIFT(1340),
  [1442] = {.count = 1, .reusable = false}, SHIFT(1340),
  [1444] = {.count = 1, .reusable = false}, SHIFT(818),
  [1446] = {.count = 1, .reusable = false}, SHIFT(682),
  [1448] = {.count = 1, .reusable = false}, SHIFT(689),
  [1450] = {.count = 1, .reusable = false}, SHIFT(616),
  [1452] = {.count = 1, .reusable = false}, SHIFT(2934),
  [1454] = {.count = 1, .reusable = false}, SHIFT(458),
  [1456] = {.count = 1, .reusable = false}, SHIFT(49),
  [1458] = {.count = 1, .reusable = true}, SHIFT(959),
  [1460] = {.count = 1, .reusable = false}, SHIFT(959),
  [1462] = {.count = 1, .reusable = true}, SHIFT(4),
  [1464] = {.count = 1, .reusable = true}, SHIFT(949),
  [1466] = {.count = 1, .reusable = false}, SHIFT(949),
  [1468] = {.count = 1, .reusable = false}, SHIFT(813),
  [1470] = {.count = 1, .reusable = false}, SHIFT(809),
  [1472] = {.count = 1, .reusable = false}, SHIFT(621),
  [1474] = {.count = 1, .reusable = false}, SHIFT(484),
  [1476] = {.count = 1, .reusable = false}, SHIFT(62),
  [1478] = {.count = 1, .reusable = true}, SHIFT(5),
  [1480] = {.count = 1, .reusable = true}, SHIFT(1000),
  [1482] = {.count = 1, .reusable = false}, SHIFT(1000),
  [1484] = {.count = 1, .reusable = true}, SHIFT(952),
  [1486] = {.count = 1, .reusable = false}, SHIFT(952),
  [1488] = {.count = 1, .reusable = false}, SHIFT(844),
  [1490] = {.count = 1, .reusable = false}, SHIFT(845),
  [1492] = {.count = 1, .reusable = false}, SHIFT(640),
  [1494] = {.count = 1, .reusable = false}, SHIFT(561),
  [1496] = {.count = 1, .reusable = false}, SHIFT(64),
  [1498] = {.count = 1, .reusable = false}, SHIFT(849),
  [1500] = {.count = 1, .reusable = true}, SHIFT(1143),
  [1502] = {.count = 1, .reusable = false}, SHIFT(1143),
  [1504] = {.count = 1, .reusable = true}, SHIFT(1144),
  [1506] = {.count = 1, .reusable = false}, SHIFT(1144),
  [1508] = {.count = 1, .reusable = true}, SHIFT(1020),
  [1510] = {.count = 1, .reusable = false}, SHIFT(1020),
  [1512] = {.count = 1, .reusable = true}, SHIFT(1145),
  [1514] = {.count = 1, .reusable = false}, SHIFT(1145),
  [1516] = {.count = 1, .reusable = true}, SHIFT(1022),
  [1518] = {.count = 1, .reusable = false}, SHIFT(1022),
  [1520] = {.count = 1, .reusable = true}, SHIFT(1263),
  [1522] = {.count = 1, .reusable = false}, SHIFT(1263),
  [1524] = {.count = 1, .reusable = true}, SHIFT(1146),
  [1526] = {.count = 1, .reusable = false}, SHIFT(1146),
  [1528] = {.count = 1, .reusable = true}, SHIFT(1264),
  [1530] = {.count = 1, .reusable = false}, SHIFT(1264),
  [1532] = {.count = 1, .reusable = false}, SHIFT(651),
  [1534] = {.count = 1, .reusable = false}, SHIFT(885),
  [1536] = {.count = 1, .reusable = false}, SHIFT(655),
  [1538] = {.count = 1, .reusable = false}, SHIFT(599),
  [1540] = {.count = 1, .reusable = false}, SHIFT(80),
  [1542] = {.count = 1, .reusable = true}, SHIFT(1950),
  [1544] = {.count = 1, .reusable = true}, SHIFT(2673),
  [1546] = {.count = 1, .reusable = true}, SHIFT(1265),
  [1548] = {.count = 1, .reusable = false}, SHIFT(1265),
  [1550] = {.count = 1, .reusable = true}, SHIFT(1266),
  [1552] = {.count = 1, .reusable = false}, SHIFT(1266),
  [1554] = {.count = 1, .reusable = true}, SHIFT(980),
  [1556] = {.count = 1, .reusable = false}, SHIFT(980),
  [1558] = {.count = 1, .reusable = true}, SHIFT(1119),
  [1560] = {.count = 1, .reusable = false}, SHIFT(1119),
  [1562] = {.count = 1, .reusable = true}, SHIFT(963),
  [1564] = {.count = 1, .reusable = false}, SHIFT(963),
  [1566] = {.count = 1, .reusable = true}, SHIFT(1087),
  [1568] = {.count = 1, .reusable = false}, SHIFT(1087),
  [1570] = {.count = 1, .reusable = false}, SHIFT(839),
  [1572] = {.count = 1, .reusable = true}, SHIFT(1157),
  [1574] = {.count = 1, .reusable = false}, SHIFT(1157),
  [1576] = {.count = 1, .reusable = false}, SHIFT(832),
  [1578] = {.count = 1, .reusable = true}, SHIFT(1285),
  [1580] = {.count = 1, .reusable = false}, SHIFT(1285),
  [1582] = {.count = 1, .reusable = false}, SHIFT(878),
  [1584] = {.count = 1, .reusable = false}, SHIFT(797),
  [1586] = {.count = 1, .reusable = false}, SHIFT(800),
  [1588] = {.count = 1, .reusable = false}, SHIFT(631),
  [1590] = {.count = 1, .reusable = false}, SHIFT(2890),
  [1592] = {.count = 1, .reusable = false}, SHIFT(505),
  [1594] = {.count = 1, .reusable = false}, SHIFT(66),
  [1596] = {.count = 1, .reusable = true}, SHIFT(1442),
  [1598] = {.count = 1, .reusable = false}, SHIFT(1442),
  [1600] = {.count = 1, .reusable = false}, SHIFT(1528),
  [1602] = {.count = 1, .reusable = false}, SHIFT(713),
  [1604] = {.count = 1, .reusable = false}, SHIFT(742),
  [1606] = {.count = 1, .reusable = false}, SHIFT(618),
  [1608] = {.count = 1, .reusable = false}, SHIFT(2782),
  [1610] = {.count = 1, .reusable = false}, SHIFT(472),
  [1612] = {.count = 1, .reusable = false}, SHIFT(54),
  [1614] = {.count = 1, .reusable = true}, SHIFT(1315),
  [1616] = {.count = 1, .reusable = false}, SHIFT(1315),
  [1618] = {.count = 1, .reusable = false}, SHIFT(1660),
  [1620] = {.count = 1, .reusable = true}, SHIFT(970),
  [1622] = {.count = 1, .reusable = false}, SHIFT(970),
  [1624] = {.count = 1, .reusable = true}, SHIFT(971),
  [1626] = {.count = 1, .reusable = false}, SHIFT(971),
  [1628] = {.count = 1, .reusable = true}, SHIFT(972),
  [1630] = {.count = 1, .reusable = false}, SHIFT(972),
  [1632] = {.count = 1, .reusable = true}, SHIFT(6),
  [1634] = {.count = 1, .reusable = true}, SHIFT(1247),
  [1636] = {.count = 1, .reusable = false}, SHIFT(1247),
  [1638] = {.count = 1, .reusable = false}, SHIFT(749),
  [1640] = {.count = 1, .reusable = false}, SHIFT(745),
  [1642] = {.count = 1, .reusable = false}, SHIFT(825),
  [1644] = {.count = 1, .reusable = false}, SHIFT(833),
  [1646] = {.count = 1, .reusable = false}, SHIFT(639),
  [1648] = {.count = 1, .reusable = false}, SHIFT(562),
  [1650] = {.count = 1, .reusable = false}, SHIFT(63),
  [1652] = {.count = 1, .reusable = false}, SHIFT(828),
  [1654] = {.count = 1, .reusable = true}, SHIFT(1152),
  [1656] = {.count = 1, .reusable = false}, SHIFT(1152),
  [1658] = {.count = 1, .reusable = true}, SHIFT(1151),
  [1660] = {.count = 1, .reusable = false}, SHIFT(1151),
  [1662] = {.count = 1, .reusable = true}, SHIFT(1164),
  [1664] = {.count = 1, .reusable = false}, SHIFT(1164),
  [1666] = {.count = 1, .reusable = false}, SHIFT(392),
  [1668] = {.count = 1, .reusable = true}, SHIFT(1704),
  [1670] = {.count = 1, .reusable = true}, SHIFT(1296),
  [1672] = {.count = 1, .reusable = false}, SHIFT(1296),
  [1674] = {.count = 1, .reusable = true}, SHIFT(1150),
  [1676] = {.count = 1, .reusable = false}, SHIFT(1150),
  [1678] = {.count = 1, .reusable = true}, SHIFT(1270),
  [1680] = {.count = 1, .reusable = false}, SHIFT(1270),
  [1682] = {.count = 1, .reusable = true}, SHIFT(1294),
  [1684] = {.count = 1, .reusable = false}, SHIFT(1294),
  [1686] = {.count = 1, .reusable = true}, SHIFT(1180),
  [1688] = {.count = 1, .reusable = false}, SHIFT(1180),
  [1690] = {.count = 1, .reusable = true}, SHIFT(1289),
  [1692] = {.count = 1, .reusable = false}, SHIFT(1289),
  [1694] = {.count = 1, .reusable = true}, SHIFT(1290),
  [1696] = {.count = 1, .reusable = false}, SHIFT(1290),
  [1698] = {.count = 1, .reusable = true}, SHIFT(1129),
  [1700] = {.count = 1, .reusable = false}, SHIFT(1129),
  [1702] = {.count = 1, .reusable = true}, SHIFT(1140),
  [1704] = {.count = 1, .reusable = false}, SHIFT(1140),
  [1706] = {.count = 1, .reusable = true}, SHIFT(1221),
  [1708] = {.count = 1, .reusable = false}, SHIFT(1221),
  [1710] = {.count = 1, .reusable = true}, SHIFT(1105),
  [1712] = {.count = 1, .reusable = false}, SHIFT(1105),
  [1714] = {.count = 1, .reusable = false}, SHIFT(840),
  [1716] = {.count = 1, .reusable = true}, SHIFT(1346),
  [1718] = {.count = 1, .reusable = false}, SHIFT(1346),
  [1720] = {.count = 1, .reusable = true}, SHIFT(1286),
  [1722] = {.count = 1, .reusable = false}, SHIFT(1286),
  [1724] = {.count = 1, .reusable = true}, SHIFT(1044),
  [1726] = {.count = 1, .reusable = false}, SHIFT(1044),
  [1728] = {.count = 1, .reusable = true}, SHIFT(1342),
  [1730] = {.count = 1, .reusable = false}, SHIFT(1342),
  [1732] = {.count = 1, .reusable = true}, SHIFT(1335),
  [1734] = {.count = 1, .reusable = false}, SHIFT(1335),
  [1736] = {.count = 1, .reusable = true}, SHIFT(1337),
  [1738] = {.count = 1, .reusable = false}, SHIFT(1337),
  [1740] = {.count = 1, .reusable = true}, SHIFT(1341),
  [1742] = {.count = 1, .reusable = false}, SHIFT(1341),
  [1744] = {.count = 1, .reusable = true}, SHIFT(1339),
  [1746] = {.count = 1, .reusable = false}, SHIFT(1339),
  [1748] = {.count = 1, .reusable = true}, SHIFT(1240),
  [1750] = {.count = 1, .reusable = false}, SHIFT(1240),
  [1752] = {.count = 1, .reusable = false}, SHIFT(868),
  [1754] = {.count = 1, .reusable = false}, SHIFT(862),
  [1756] = {.count = 1, .reusable = false}, SHIFT(644),
  [1758] = {.count = 1, .reusable = false}, SHIFT(596),
  [1760] = {.count = 1, .reusable = false}, SHIFT(75),
  [1762] = {.count = 1, .reusable = true}, SHIFT(1459),
  [1764] = {.count = 1, .reusable = false}, SHIFT(1459),
  [1766] = {.count = 1, .reusable = true}, SHIFT(1307),
  [1768] = {.count = 1, .reusable = false}, SHIFT(1307),
  [1770] = {.count = 1, .reusable = true}, SHIFT(1311),
  [1772] = {.count = 1, .reusable = false}, SHIFT(1311),
  [1774] = {.count = 1, .reusable = true}, SHIFT(1333),
  [1776] = {.count = 1, .reusable = false}, SHIFT(1333),
  [1778] = {.count = 1, .reusable = true}, SHIFT(1272),
  [1780] = {.count = 1, .reusable = false}, SHIFT(1272),
  [1782] = {.count = 1, .reusable = true}, SHIFT(1283),
  [1784] = {.count = 1, .reusable = false}, SHIFT(1283),
  [1786] = {.count = 1, .reusable = true}, SHIFT(1267),
  [1788] = {.count = 1, .reusable = false}, SHIFT(1267),
  [1790] = {.count = 1, .reusable = true}, SHIFT(1351),
  [1792] = {.count = 1, .reusable = false}, SHIFT(1351),
  [1794] = {.count = 1, .reusable = true}, SHIFT(1353),
  [1796] = {.count = 1, .reusable = false}, SHIFT(1353),
  [1798] = {.count = 1, .reusable = true}, SHIFT(1051),
  [1800] = {.count = 1, .reusable = false}, SHIFT(1051),
  [1802] = {.count = 1, .reusable = true}, SHIFT(977),
  [1804] = {.count = 1, .reusable = false}, SHIFT(977),
  [1806] = {.count = 1, .reusable = true}, SHIFT(1331),
  [1808] = {.count = 1, .reusable = false}, SHIFT(1331),
  [1810] = {.count = 1, .reusable = true}, SHIFT(1330),
  [1812] = {.count = 1, .reusable = false}, SHIFT(1330),
  [1814] = {.count = 1, .reusable = true}, SHIFT(1325),
  [1816] = {.count = 1, .reusable = false}, SHIFT(1325),
  [1818] = {.count = 1, .reusable = true}, SHIFT(1322),
  [1820] = {.count = 1, .reusable = false}, SHIFT(1322),
  [1822] = {.count = 1, .reusable = true}, SHIFT(1319),
  [1824] = {.count = 1, .reusable = false}, SHIFT(1319),
  [1826] = {.count = 1, .reusable = true}, SHIFT(1317),
  [1828] = {.count = 1, .reusable = false}, SHIFT(1317),
  [1830] = {.count = 1, .reusable = true}, SHIFT(1458),
  [1832] = {.count = 1, .reusable = false}, SHIFT(1458),
  [1834] = {.count = 1, .reusable = true}, SHIFT(1122),
  [1836] = {.count = 1, .reusable = false}, SHIFT(1122),
  [1838] = {.count = 1, .reusable = true}, SHIFT(1316),
  [1840] = {.count = 1, .reusable = true}, SHIFT(1118),
  [1842] = {.count = 1, .reusable = false}, SHIFT(1118),
  [1844] = {.count = 1, .reusable = true}, SHIFT(1314),
  [1846] = {.count = 1, .reusable = false}, SHIFT(1314),
  [1848] = {.count = 1, .reusable = true}, SHIFT(1259),
  [1850] = {.count = 1, .reusable = false}, SHIFT(1259),
  [1852] = {.count = 1, .reusable = true}, SHIFT(1160),
  [1854] = {.count = 1, .reusable = false}, SHIFT(1160),
  [1856] = {.count = 1, .reusable = true}, SHIFT(1295),
  [1858] = {.count = 1, .reusable = false}, SHIFT(1295),
  [1860] = {.count = 1, .reusable = true}, SHIFT(1249),
  [1862] = {.count = 1, .reusable = false}, SHIFT(1249),
  [1864] = {.count = 1, .reusable = true}, SHIFT(1246),
  [1866] = {.count = 1, .reusable = false}, SHIFT(1246),
  [1868] = {.count = 1, .reusable = true}, SHIFT(1198),
  [1870] = {.count = 1, .reusable = false}, SHIFT(1198),
  [1872] = {.count = 1, .reusable = false}, SHIFT(894),
  [1874] = {.count = 1, .reusable = true}, SHIFT(1509),
  [1876] = {.count = 1, .reusable = false}, SHIFT(1509),
  [1878] = {.count = 1, .reusable = true}, SHIFT(1181),
  [1880] = {.count = 1, .reusable = false}, SHIFT(1181),
  [1882] = {.count = 1, .reusable = true}, SHIFT(1041),
  [1884] = {.count = 1, .reusable = false}, SHIFT(1041),
  [1886] = {.count = 1, .reusable = true}, SHIFT(1110),
  [1888] = {.count = 1, .reusable = false}, SHIFT(1110),
  [1890] = {.count = 1, .reusable = true}, SHIFT(1032),
  [1892] = {.count = 1, .reusable = false}, SHIFT(1032),
  [1894] = {.count = 1, .reusable = true}, SHIFT(927),
  [1896] = {.count = 1, .reusable = false}, SHIFT(927),
  [1898] = {.count = 1, .reusable = true}, SHIFT(1100),
  [1900] = {.count = 1, .reusable = true}, SHIFT(1239),
  [1902] = {.count = 1, .reusable = false}, SHIFT(1239),
  [1904] = {.count = 1, .reusable = true}, SHIFT(1404),
  [1906] = {.count = 1, .reusable = false}, SHIFT(1404),
  [1908] = {.count = 1, .reusable = true}, SHIFT(1066),
  [1910] = {.count = 1, .reusable = false}, SHIFT(1066),
  [1912] = {.count = 1, .reusable = true}, SHIFT(1053),
  [1914] = {.count = 1, .reusable = false}, SHIFT(1053),
  [1916] = {.count = 1, .reusable = true}, SHIFT(1050),
  [1918] = {.count = 1, .reusable = false}, SHIFT(1050),
  [1920] = {.count = 1, .reusable = true}, SHIFT(1049),
  [1922] = {.count = 1, .reusable = false}, SHIFT(1049),
  [1924] = {.count = 1, .reusable = true}, SHIFT(1243),
  [1926] = {.count = 1, .reusable = true}, SHIFT(1293),
  [1928] = {.count = 1, .reusable = false}, SHIFT(1293),
  [1930] = {.count = 1, .reusable = true}, SHIFT(1047),
  [1932] = {.count = 1, .reusable = false}, SHIFT(1047),
  [1934] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1936] = {.count = 1, .reusable = false}, SHIFT(1045),
  [1938] = {.count = 1, .reusable = true}, SHIFT(1232),
  [1940] = {.count = 1, .reusable = false}, SHIFT(1232),
  [1942] = {.count = 1, .reusable = true}, SHIFT(1242),
  [1944] = {.count = 1, .reusable = false}, SHIFT(1242),
  [1946] = {.count = 1, .reusable = true}, SHIFT(926),
  [1948] = {.count = 1, .reusable = false}, SHIFT(926),
  [1950] = {.count = 1, .reusable = true}, SHIFT(1397),
  [1952] = {.count = 1, .reusable = false}, SHIFT(1308),
  [1954] = {.count = 1, .reusable = true}, SHIFT(1209),
  [1956] = {.count = 1, .reusable = false}, SHIFT(1209),
  [1958] = {.count = 1, .reusable = true}, SHIFT(1347),
  [1960] = {.count = 1, .reusable = false}, SHIFT(1347),
  [1962] = {.count = 1, .reusable = true}, SHIFT(1205),
  [1964] = {.count = 1, .reusable = false}, SHIFT(1205),
  [1966] = {.count = 1, .reusable = true}, SHIFT(1206),
  [1968] = {.count = 1, .reusable = false}, SHIFT(1206),
  [1970] = {.count = 1, .reusable = true}, SHIFT(1201),
  [1972] = {.count = 1, .reusable = true}, SHIFT(1288),
  [1974] = {.count = 1, .reusable = false}, SHIFT(1288),
  [1976] = {.count = 1, .reusable = true}, SHIFT(1292),
  [1978] = {.count = 1, .reusable = false}, SHIFT(1292),
  [1980] = {.count = 1, .reusable = true}, SHIFT(1329),
  [1982] = {.count = 1, .reusable = false}, SHIFT(1329),
  [1984] = {.count = 1, .reusable = true}, SHIFT(1287),
  [1986] = {.count = 1, .reusable = false}, SHIFT(1287),
  [1988] = {.count = 1, .reusable = true}, SHIFT(1186),
  [1990] = {.count = 1, .reusable = false}, SHIFT(1186),
  [1992] = {.count = 1, .reusable = true}, SHIFT(1241),
  [1994] = {.count = 1, .reusable = false}, SHIFT(1241),
  [1996] = {.count = 1, .reusable = true}, SHIFT(1137),
  [1998] = {.count = 1, .reusable = false}, SHIFT(1137),
  [2000] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2002] = {.count = 1, .reusable = false}, SHIFT(1348),
  [2004] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2006] = {.count = 1, .reusable = false}, SHIFT(1161),
  [2008] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2010] = {.count = 1, .reusable = false}, SHIFT(1169),
  [2012] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2014] = {.count = 1, .reusable = false}, SHIFT(1149),
  [2016] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2018] = {.count = 1, .reusable = false}, SHIFT(1142),
  [2020] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2022] = {.count = 1, .reusable = false}, SHIFT(1197),
  [2024] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2026] = {.count = 1, .reusable = false}, SHIFT(1147),
  [2028] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2030] = {.count = 1, .reusable = false}, SHIFT(1204),
  [2032] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2034] = {.count = 1, .reusable = false}, SHIFT(1328),
  [2036] = {.count = 1, .reusable = true}, SHIFT(967),
  [2038] = {.count = 1, .reusable = false}, SHIFT(967),
  [2040] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2042] = {.count = 1, .reusable = false}, SHIFT(1060),
  [2044] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2046] = {.count = 1, .reusable = false}, SHIFT(1061),
  [2048] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2050] = {.count = 1, .reusable = false}, SHIFT(1350),
  [2052] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2054] = {.count = 1, .reusable = false}, SHIFT(1349),
  [2056] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2058] = {.count = 1, .reusable = false}, SHIFT(1230),
  [2060] = {.count = 1, .reusable = false}, SHIFT(802),
  [2062] = {.count = 1, .reusable = true}, SHIFT(1002),
  [2064] = {.count = 1, .reusable = false}, SHIFT(1002),
  [2066] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2068] = {.count = 1, .reusable = false}, SHIFT(1062),
  [2070] = {.count = 1, .reusable = true}, SHIFT(1581),
  [2072] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2074] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2076] = {.count = 1, .reusable = false}, SHIFT(1245),
  [2078] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2080] = {.count = 1, .reusable = false}, SHIFT(1377),
  [2082] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2084] = {.count = 1, .reusable = false}, SHIFT(1236),
  [2086] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2088] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2090] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2092] = {.count = 1, .reusable = false}, SHIFT(1278),
  [2094] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2096] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2098] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2100] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2102] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2104] = {.count = 1, .reusable = true}, SHIFT(945),
  [2106] = {.count = 1, .reusable = false}, SHIFT(945),
  [2108] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2110] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2112] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2114] = {.count = 1, .reusable = false}, SHIFT(1153),
  [2116] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2118] = {.count = 1, .reusable = false}, SHIFT(1352),
  [2120] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2122] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2124] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2126] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2128] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2130] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2132] = {.count = 1, .reusable = true}, SHIFT(975),
  [2134] = {.count = 1, .reusable = false}, SHIFT(975),
  [2136] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2138] = {.count = 1, .reusable = false}, SHIFT(1076),
  [2140] = {.count = 1, .reusable = false}, SHIFT(811),
  [2142] = {.count = 1, .reusable = true}, SHIFT(998),
  [2144] = {.count = 1, .reusable = false}, SHIFT(998),
  [2146] = {.count = 1, .reusable = true}, SHIFT(948),
  [2148] = {.count = 1, .reusable = false}, SHIFT(948),
  [2150] = {.count = 1, .reusable = true}, SHIFT(1499),
  [2152] = {.count = 1, .reusable = false}, SHIFT(1499),
  [2154] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2156] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2158] = {.count = 1, .reusable = true}, SHIFT(950),
  [2160] = {.count = 1, .reusable = false}, SHIFT(950),
  [2162] = {.count = 1, .reusable = true}, SHIFT(951),
  [2164] = {.count = 1, .reusable = false}, SHIFT(951),
  [2166] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2168] = {.count = 1, .reusable = false}, SHIFT(1099),
  [2170] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2172] = {.count = 1, .reusable = false}, SHIFT(1063),
  [2174] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2176] = {.count = 1, .reusable = true}, SHIFT(953),
  [2178] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2180] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2182] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2184] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2186] = {.count = 1, .reusable = true}, SHIFT(1312),
  [2188] = {.count = 1, .reusable = false}, SHIFT(1312),
  [2190] = {.count = 1, .reusable = true}, SHIFT(954),
  [2192] = {.count = 1, .reusable = false}, SHIFT(954),
  [2194] = {.count = 1, .reusable = true}, SHIFT(955),
  [2196] = {.count = 1, .reusable = false}, SHIFT(955),
  [2198] = {.count = 1, .reusable = true}, SHIFT(957),
  [2200] = {.count = 1, .reusable = false}, SHIFT(957),
  [2202] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2204] = {.count = 1, .reusable = false}, SHIFT(1355),
  [2206] = {.count = 1, .reusable = true}, SHIFT(1607),
  [2208] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2210] = {.count = 1, .reusable = false}, SHIFT(1213),
  [2212] = {.count = 1, .reusable = true}, SHIFT(960),
  [2214] = {.count = 1, .reusable = false}, SHIFT(960),
  [2216] = {.count = 1, .reusable = false}, SHIFT(801),
  [2218] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2220] = {.count = 1, .reusable = false}, SHIFT(1357),
  [2222] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2224] = {.count = 1, .reusable = false}, SHIFT(1326),
  [2226] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2228] = {.count = 1, .reusable = false}, SHIFT(1309),
  [2230] = {.count = 1, .reusable = true}, SHIFT(988),
  [2232] = {.count = 1, .reusable = false}, SHIFT(988),
  [2234] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2236] = {.count = 1, .reusable = false}, SHIFT(1358),
  [2238] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2240] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2242] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2244] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2246] = {.count = 1, .reusable = true}, SHIFT(961),
  [2248] = {.count = 1, .reusable = false}, SHIFT(961),
  [2250] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2252] = {.count = 1, .reusable = false}, SHIFT(1360),
  [2254] = {.count = 1, .reusable = true}, SHIFT(1466),
  [2256] = {.count = 1, .reusable = false}, SHIFT(1466),
  [2258] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2260] = {.count = 1, .reusable = false}, SHIFT(1237),
  [2262] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2264] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2266] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2268] = {.count = 1, .reusable = false}, SHIFT(1361),
  [2270] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2272] = {.count = 1, .reusable = false}, SHIFT(1362),
  [2274] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2276] = {.count = 1, .reusable = false}, SHIFT(1079),
  [2278] = {.count = 1, .reusable = true}, SHIFT(962),
  [2280] = {.count = 1, .reusable = false}, SHIFT(962),
  [2282] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2284] = {.count = 1, .reusable = false}, SHIFT(1365),
  [2286] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2288] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2290] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2292] = {.count = 1, .reusable = false}, SHIFT(1370),
  [2294] = {.count = 1, .reusable = true}, SHIFT(1681),
  [2296] = {.count = 1, .reusable = true}, SHIFT(1507),
  [2298] = {.count = 1, .reusable = false}, SHIFT(1507),
  [2300] = {.count = 1, .reusable = true}, SHIFT(979),
  [2302] = {.count = 1, .reusable = false}, SHIFT(979),
  [2304] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2306] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2308] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2310] = {.count = 1, .reusable = false}, SHIFT(1367),
  [2312] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2314] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2316] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2318] = {.count = 1, .reusable = false}, SHIFT(1212),
  [2320] = {.count = 1, .reusable = true}, SHIFT(981),
  [2322] = {.count = 1, .reusable = false}, SHIFT(981),
  [2324] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2326] = {.count = 1, .reusable = false}, SHIFT(1368),
  [2328] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2330] = {.count = 1, .reusable = false}, SHIFT(1090),
  [2332] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2334] = {.count = 1, .reusable = false}, SHIFT(1244),
  [2336] = {.count = 1, .reusable = true}, SHIFT(1945),
  [2338] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [2340] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [2342] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [2344] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [2346] = {.count = 1, .reusable = false}, SHIFT(2932),
  [2348] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [2350] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [2352] = {.count = 1, .reusable = false}, SHIFT(2301),
  [2354] = {.count = 1, .reusable = false}, SHIFT(2294),
  [2356] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1783),
  [2359] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(1667),
  [2363] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(322),
  [2366] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 7), SHIFT(2760),
  [2370] = {.count = 1, .reusable = false}, SHIFT(1940),
  [2372] = {.count = 1, .reusable = true}, SHIFT(2304),
  [2374] = {.count = 1, .reusable = true}, SHIFT(2300),
  [2376] = {.count = 1, .reusable = true}, SHIFT(2013),
  [2378] = {.count = 1, .reusable = false}, SHIFT(1720),
  [2380] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [2382] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [2384] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [2386] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [2388] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2390] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .production_id = 14),
  [2392] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .production_id = 47),
  [2394] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .production_id = 47),
  [2396] = {.count = 1, .reusable = false}, SHIFT(2943),
  [2398] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [2400] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [2402] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [2404] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [2406] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [2408] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [2410] = {.count = 1, .reusable = true}, SHIFT(686),
  [2412] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [2414] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [2416] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [2418] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [2420] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [2422] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [2424] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [2426] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [2428] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [2430] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [2432] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [2434] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [2436] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [2438] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [2440] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [2442] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [2444] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [2446] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [2448] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [2450] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [2452] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [2454] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [2456] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [2458] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [2460] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [2462] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [2464] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [2466] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2),
  [2468] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2),
  [2470] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [2472] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [2474] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6),
  [2476] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6),
  [2478] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [2480] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [2482] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [2484] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [2486] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2488] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14),
  [2490] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(711),
  [2493] = {.count = 1, .reusable = false}, SHIFT(772),
  [2495] = {.count = 1, .reusable = false}, SHIFT(2041),
  [2497] = {.count = 1, .reusable = false}, SHIFT(1721),
  [2499] = {.count = 1, .reusable = false}, SHIFT(1735),
  [2501] = {.count = 1, .reusable = false}, SHIFT(1722),
  [2503] = {.count = 1, .reusable = true}, SHIFT(466),
  [2505] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2507] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2, .production_id = 13),
  [2509] = {.count = 1, .reusable = false}, SHIFT(2545),
  [2511] = {.count = 1, .reusable = false}, SHIFT(2595),
  [2513] = {.count = 1, .reusable = false}, SHIFT(1829),
  [2515] = {.count = 1, .reusable = false}, SHIFT(2250),
  [2517] = {.count = 1, .reusable = false}, SHIFT(624),
  [2519] = {.count = 1, .reusable = false}, SHIFT(2761),
  [2521] = {.count = 1, .reusable = true}, SHIFT(456),
  [2523] = {.count = 1, .reusable = true}, SHIFT(88),
  [2525] = {.count = 1, .reusable = true}, SHIFT(2760),
  [2527] = {.count = 1, .reusable = false}, SHIFT(2382),
  [2529] = {.count = 1, .reusable = true}, SHIFT(2772),
  [2531] = {.count = 1, .reusable = false}, SHIFT(1923),
  [2533] = {.count = 1, .reusable = true}, SHIFT(429),
  [2535] = {.count = 1, .reusable = false}, SHIFT(1925),
  [2537] = {.count = 1, .reusable = false}, SHIFT(429),
  [2539] = {.count = 1, .reusable = false}, SHIFT(1770),
  [2541] = {.count = 1, .reusable = false}, SHIFT(1745),
  [2543] = {.count = 1, .reusable = false}, SHIFT(2936),
  [2545] = {.count = 1, .reusable = false}, SHIFT(2937),
  [2547] = {.count = 1, .reusable = true}, SHIFT(2945),
  [2549] = {.count = 1, .reusable = false}, SHIFT(1944),
  [2551] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [2553] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [2555] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(711),
  [2558] = {.count = 1, .reusable = true}, SHIFT(468),
  [2560] = {.count = 1, .reusable = true}, SHIFT(464),
  [2562] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [2564] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [2566] = {.count = 1, .reusable = true}, SHIFT(769),
  [2568] = {.count = 1, .reusable = true}, SHIFT(764),
  [2570] = {.count = 1, .reusable = false}, SHIFT(2776),
  [2572] = {.count = 1, .reusable = false}, SHIFT(2778),
  [2574] = {.count = 1, .reusable = false}, SHIFT(1999),
  [2576] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [2578] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [2580] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [2582] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [2584] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(1667),
  [2587] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(2760),
  [2590] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [2592] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [2594] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .production_id = 149),
  [2596] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .production_id = 149),
  [2598] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [2600] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [2602] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [2604] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [2606] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2608] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 42),
  [2610] = {.count = 1, .reusable = true}, SHIFT(18),
  [2612] = {.count = 1, .reusable = false}, SHIFT(2801),
  [2614] = {.count = 1, .reusable = false}, SHIFT(2800),
  [2616] = {.count = 1, .reusable = false}, SHIFT(1961),
  [2618] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [2620] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [2622] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 157),
  [2624] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 157),
  [2626] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 158),
  [2628] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 158),
  [2630] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 159),
  [2632] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 159),
  [2634] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2636] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2, .production_id = 13),
  [2638] = {.count = 1, .reusable = false}, SHIFT(2892),
  [2640] = {.count = 1, .reusable = false}, SHIFT(2893),
  [2642] = {.count = 1, .reusable = true}, SHIFT(2900),
  [2644] = {.count = 1, .reusable = false}, SHIFT(1960),
  [2646] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [2648] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [2650] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 7, .production_id = 147),
  [2652] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 7, .production_id = 147),
  [2654] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [2656] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [2658] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2660] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 24),
  [2662] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [2664] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [2666] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 98),
  [2668] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 98),
  [2670] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [2672] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [2674] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 122),
  [2676] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 122),
  [2678] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2680] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2682] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2, .production_id = 6),
  [2684] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2, .production_id = 6),
  [2686] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 86),
  [2688] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 86),
  [2690] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 4, .production_id = 81),
  [2692] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 4, .production_id = 81),
  [2694] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [2696] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [2698] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 156),
  [2700] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 156),
  [2702] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [2704] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [2706] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [2708] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [2710] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [2712] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [2714] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .production_id = 132),
  [2716] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .production_id = 132),
  [2718] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 91),
  [2720] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 91),
  [2722] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 90),
  [2724] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 90),
  [2726] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [2728] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 90),
  [2730] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5, .production_id = 121),
  [2732] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5, .production_id = 121),
  [2734] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 100),
  [2736] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 100),
  [2738] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 123),
  [2740] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 123),
  [2742] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [2744] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [2746] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [2748] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [2750] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [2752] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [2754] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2756] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .production_id = 45),
  [2758] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2760] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .production_id = 45),
  [2762] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2764] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3, .production_id = 44),
  [2766] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2768] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 43),
  [2770] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [2772] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [2774] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [2776] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [2778] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2780] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3, .production_id = 41),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 124),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 124),
  [2786] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4, .production_id = 97),
  [2788] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4, .production_id = 97),
  [2790] = {.count = 1, .reusable = false}, SHIFT(2159),
  [2792] = {.count = 1, .reusable = false}, SHIFT(2157),
  [2794] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2796] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(142),
  [2799] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2801] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2, .production_id = 4),
  [2803] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 6, .production_id = 122),
  [2805] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 6, .production_id = 122),
  [2807] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .production_id = 119),
  [2809] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .production_id = 119),
  [2811] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 135),
  [2813] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 135),
  [2815] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [2817] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [2819] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 108),
  [2821] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 108),
  [2823] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2825] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2, .production_id = 13),
  [2827] = {.count = 1, .reusable = false}, SHIFT(2873),
  [2829] = {.count = 1, .reusable = false}, SHIFT(2872),
  [2831] = {.count = 1, .reusable = false}, SHIFT(2919),
  [2833] = {.count = 1, .reusable = false}, SHIFT(2917),
  [2835] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4, .production_id = 80),
  [2837] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4, .production_id = 80),
  [2839] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [2841] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 3, .production_id = 37),
  [2843] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [2845] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [2847] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2849] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2851] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [2853] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [2855] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 49),
  [2857] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 49),
  [2859] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [2861] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3, .production_id = 35),
  [2863] = {.count = 1, .reusable = false}, SHIFT(30),
  [2865] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .production_id = 106),
  [2867] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .production_id = 106),
  [2869] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2871] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3, .production_id = 60),
  [2873] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5, .production_id = 107),
  [2875] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5, .production_id = 107),
  [2877] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 49),
  [2879] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 49),
  [2881] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [2883] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [2885] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 69),
  [2887] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 69),
  [2889] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 68),
  [2891] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 68),
  [2893] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [2895] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3, .production_id = 36),
  [2897] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2899] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2901] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5, .production_id = 112),
  [2903] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5, .production_id = 112),
  [2905] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [2907] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [2909] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2911] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 101),
  [2913] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 119),
  [2915] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 119),
  [2917] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 148),
  [2919] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 148),
  [2921] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [2923] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [2925] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [2927] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [2929] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [2931] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [2933] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2935] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [2937] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [2939] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [2941] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3, .production_id = 66),
  [2943] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3, .production_id = 66),
  [2945] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [2947] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [2949] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [2951] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [2953] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [2955] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [2957] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 155),
  [2959] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 155),
  [2961] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 154),
  [2963] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 154),
  [2965] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 152),
  [2967] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 152),
  [2969] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 137),
  [2971] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 137),
  [2973] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 153),
  [2975] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 153),
  [2977] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [2979] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [2981] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2983] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2985] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 133),
  [2987] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 133),
  [2989] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 134),
  [2991] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 134),
  [2993] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 136),
  [2995] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 136),
  [2997] = {.count = 1, .reusable = false}, SHIFT(482),
  [2999] = {.count = 1, .reusable = false}, SHIFT(103),
  [3001] = {.count = 1, .reusable = true}, SHIFT(2342),
  [3003] = {.count = 1, .reusable = true}, SHIFT(2348),
  [3005] = {.count = 1, .reusable = false}, SHIFT(969),
  [3007] = {.count = 1, .reusable = true}, SHIFT(140),
  [3009] = {.count = 1, .reusable = true}, SHIFT(138),
  [3011] = {.count = 1, .reusable = false}, SHIFT(982),
  [3013] = {.count = 1, .reusable = false}, SHIFT(1847),
  [3015] = {.count = 1, .reusable = false}, SHIFT(881),
  [3017] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3019] = {.count = 1, .reusable = true}, SHIFT(646),
  [3021] = {.count = 1, .reusable = true}, SHIFT(1921),
  [3023] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3025] = {.count = 1, .reusable = true}, SHIFT(917),
  [3027] = {.count = 1, .reusable = true}, SHIFT(135),
  [3029] = {.count = 1, .reusable = false}, SHIFT(1141),
  [3031] = {.count = 1, .reusable = false}, SHIFT(2347),
  [3033] = {.count = 1, .reusable = true}, SHIFT(2343),
  [3035] = {.count = 1, .reusable = true}, SHIFT(2344),
  [3037] = {.count = 1, .reusable = true}, SHIFT(1815),
  [3039] = {.count = 1, .reusable = false}, SHIFT(1154),
  [3041] = {.count = 1, .reusable = false}, SHIFT(1356),
  [3043] = {.count = 1, .reusable = false}, SHIFT(1527),
  [3045] = {.count = 1, .reusable = false}, SHIFT(1167),
  [3047] = {.count = 1, .reusable = true}, SHIFT(434),
  [3049] = {.count = 1, .reusable = false}, SHIFT(1848),
  [3051] = {.count = 1, .reusable = false}, SHIFT(883),
  [3053] = {.count = 1, .reusable = true}, SHIFT(656),
  [3055] = {.count = 1, .reusable = true}, SHIFT(1227),
  [3057] = {.count = 1, .reusable = true}, SHIFT(918),
  [3059] = {.count = 1, .reusable = false}, SHIFT(1190),
  [3061] = {.count = 1, .reusable = false}, SHIFT(1189),
  [3063] = {.count = 1, .reusable = false}, SHIFT(1318),
  [3065] = {.count = 1, .reusable = false}, SHIFT(1559),
  [3067] = {.count = 1, .reusable = false}, SHIFT(1188),
  [3069] = {.count = 1, .reusable = true}, SHIFT(1863),
  [3071] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3073] = {.count = 1, .reusable = false}, SHIFT(1846),
  [3075] = {.count = 1, .reusable = false}, SHIFT(895),
  [3077] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3079] = {.count = 1, .reusable = false}, SHIFT(1172),
  [3081] = {.count = 1, .reusable = false}, SHIFT(1170),
  [3083] = {.count = 1, .reusable = false}, SHIFT(1344),
  [3085] = {.count = 1, .reusable = false}, SHIFT(1625),
  [3087] = {.count = 1, .reusable = false}, SHIFT(1166),
  [3089] = {.count = 1, .reusable = true}, SHIFT(976),
  [3091] = {.count = 1, .reusable = true}, SHIFT(145),
  [3093] = {.count = 1, .reusable = false}, SHIFT(1845),
  [3095] = {.count = 1, .reusable = false}, SHIFT(884),
  [3097] = {.count = 1, .reusable = true}, SHIFT(1304),
  [3099] = {.count = 1, .reusable = false}, SHIFT(1179),
  [3101] = {.count = 1, .reusable = false}, SHIFT(1178),
  [3103] = {.count = 1, .reusable = false}, SHIFT(1338),
  [3105] = {.count = 1, .reusable = false}, SHIFT(1644),
  [3107] = {.count = 1, .reusable = false}, SHIFT(1174),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3111] = {.count = 1, .reusable = false}, SHIFT(1434),
  [3113] = {.count = 1, .reusable = false}, SHIFT(1184),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1403),
  [3117] = {.count = 1, .reusable = false}, SHIFT(893),
  [3119] = {.count = 1, .reusable = false}, SHIFT(2737),
  [3121] = {.count = 1, .reusable = true}, SHIFT(457),
  [3123] = {.count = 1, .reusable = true}, SHIFT(746),
  [3125] = {.count = 1, .reusable = false}, SHIFT(2345),
  [3127] = {.count = 1, .reusable = true}, SHIFT(947),
  [3129] = {.count = 1, .reusable = true}, SHIFT(705),
  [3131] = {.count = 1, .reusable = true}, SHIFT(706),
  [3133] = {.count = 1, .reusable = true}, SHIFT(2940),
  [3135] = {.count = 1, .reusable = false}, SHIFT(1402),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1401),
  [3139] = {.count = 1, .reusable = false}, SHIFT(1400),
  [3141] = {.count = 1, .reusable = false}, SHIFT(1401),
  [3143] = {.count = 1, .reusable = false}, SHIFT(2417),
  [3145] = {.count = 1, .reusable = true}, SHIFT(893),
  [3147] = {.count = 1, .reusable = false}, SHIFT(1852),
  [3149] = {.count = 1, .reusable = false}, SHIFT(900),
  [3151] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [3153] = {.count = 1, .reusable = false}, SHIFT(1332),
  [3155] = {.count = 1, .reusable = false}, SHIFT(1334),
  [3157] = {.count = 1, .reusable = false}, SHIFT(1486),
  [3159] = {.count = 1, .reusable = false}, SHIFT(1675),
  [3161] = {.count = 1, .reusable = false}, SHIFT(1268),
  [3163] = {.count = 1, .reusable = false}, SHIFT(2516),
  [3165] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3167] = {.count = 1, .reusable = false}, SHIFT(360),
  [3169] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [3171] = {.count = 1, .reusable = true}, SHIFT(365),
  [3173] = {.count = 1, .reusable = false}, SHIFT(306),
  [3175] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [3177] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(217),
  [3180] = {.count = 1, .reusable = true}, SHIFT(217),
  [3182] = {.count = 1, .reusable = true}, SHIFT(760),
  [3184] = {.count = 1, .reusable = true}, SHIFT(2933),
  [3186] = {.count = 1, .reusable = true}, SHIFT(215),
  [3188] = {.count = 1, .reusable = false}, SHIFT(342),
  [3190] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3193] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(741),
  [3196] = {.count = 1, .reusable = true}, SHIFT(2813),
  [3198] = {.count = 1, .reusable = true}, SHIFT(164),
  [3200] = {.count = 1, .reusable = true}, SHIFT(345),
  [3202] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3205] = {.count = 1, .reusable = true}, SHIFT(701),
  [3207] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4, .production_id = 99),
  [3209] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4, .production_id = 99),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1273),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3215] = {.count = 1, .reusable = false}, SHIFT(880),
  [3217] = {.count = 1, .reusable = false}, SHIFT(2598),
  [3219] = {.count = 1, .reusable = true}, SHIFT(465),
  [3221] = {.count = 1, .reusable = true}, SHIFT(758),
  [3223] = {.count = 1, .reusable = false}, SHIFT(2377),
  [3225] = {.count = 1, .reusable = true}, SHIFT(978),
  [3227] = {.count = 1, .reusable = true}, SHIFT(782),
  [3229] = {.count = 1, .reusable = true}, SHIFT(779),
  [3231] = {.count = 1, .reusable = true}, SHIFT(2834),
  [3233] = {.count = 1, .reusable = false}, SHIFT(1554),
  [3235] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3237] = {.count = 1, .reusable = false}, SHIFT(1542),
  [3239] = {.count = 1, .reusable = false}, SHIFT(1543),
  [3241] = {.count = 1, .reusable = false}, SHIFT(2534),
  [3243] = {.count = 1, .reusable = true}, SHIFT(880),
  [3245] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [3247] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 25),
  [3249] = {.count = 1, .reusable = false}, SHIFT(929),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1006),
  [3253] = {.count = 1, .reusable = false}, SHIFT(887),
  [3255] = {.count = 1, .reusable = false}, SHIFT(2624),
  [3257] = {.count = 1, .reusable = true}, SHIFT(461),
  [3259] = {.count = 1, .reusable = true}, SHIFT(759),
  [3261] = {.count = 1, .reusable = false}, SHIFT(2369),
  [3263] = {.count = 1, .reusable = true}, SHIFT(943),
  [3265] = {.count = 1, .reusable = true}, SHIFT(763),
  [3267] = {.count = 1, .reusable = true}, SHIFT(765),
  [3269] = {.count = 1, .reusable = true}, SHIFT(2858),
  [3271] = {.count = 1, .reusable = false}, SHIFT(1007),
  [3273] = {.count = 1, .reusable = true}, SHIFT(1008),
  [3275] = {.count = 1, .reusable = false}, SHIFT(1010),
  [3277] = {.count = 1, .reusable = false}, SHIFT(1008),
  [3279] = {.count = 1, .reusable = false}, SHIFT(2497),
  [3281] = {.count = 1, .reusable = true}, SHIFT(887),
  [3283] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 56),
  [3285] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 56),
  [3287] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(711),
  [3290] = {.count = 1, .reusable = true}, SHIFT(2867),
  [3292] = {.count = 1, .reusable = true}, SHIFT(708),
  [3294] = {.count = 1, .reusable = false}, SHIFT(1801),
  [3296] = {.count = 1, .reusable = false}, SHIFT(886),
  [3298] = {.count = 1, .reusable = true}, SHIFT(783),
  [3300] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3302] = {.count = 1, .reusable = false}, SHIFT(431),
  [3304] = {.count = 1, .reusable = false}, SHIFT(425),
  [3306] = {.count = 1, .reusable = false}, SHIFT(341),
  [3308] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3311] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 7),
  [3314] = {.count = 1, .reusable = true}, SHIFT(2785),
  [3316] = {.count = 1, .reusable = true}, SHIFT(184),
  [3318] = {.count = 1, .reusable = true}, SHIFT(257),
  [3320] = {.count = 1, .reusable = true}, SHIFT(1888),
  [3322] = {.count = 1, .reusable = true}, SHIFT(1880),
  [3324] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3326] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3328] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 56), REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [3331] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 56), REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [3334] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 56),
  [3337] = {.count = 1, .reusable = true}, SHIFT(2532),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1091),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3345] = {.count = 1, .reusable = true}, SHIFT(414),
  [3347] = {.count = 1, .reusable = false}, SHIFT(1807),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3351] = {.count = 1, .reusable = false}, SHIFT(255),
  [3353] = {.count = 1, .reusable = true}, SHIFT(2769),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1082),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1074),
  [3359] = {.count = 1, .reusable = true}, SHIFT(437),
  [3361] = {.count = 1, .reusable = true}, SHIFT(415),
  [3363] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 56),
  [3366] = {.count = 1, .reusable = true}, SHIFT(1875),
  [3368] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [3370] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [3372] = {.count = 1, .reusable = true}, SHIFT(2475),
  [3374] = {.count = 1, .reusable = false}, SHIFT(443),
  [3376] = {.count = 1, .reusable = false}, SHIFT(2353),
  [3378] = {.count = 1, .reusable = true}, SHIFT(964),
  [3380] = {.count = 1, .reusable = true}, SHIFT(697),
  [3382] = {.count = 1, .reusable = true}, SHIFT(696),
  [3384] = {.count = 1, .reusable = false}, SHIFT(1808),
  [3386] = {.count = 1, .reusable = false}, SHIFT(890),
  [3388] = {.count = 1, .reusable = false}, SHIFT(2750),
  [3390] = {.count = 1, .reusable = true}, SHIFT(469),
  [3392] = {.count = 1, .reusable = true}, SHIFT(768),
  [3394] = {.count = 1, .reusable = false}, SHIFT(2325),
  [3396] = {.count = 1, .reusable = true}, SHIFT(2897),
  [3398] = {.count = 1, .reusable = false}, SHIFT(1879),
  [3400] = {.count = 1, .reusable = true}, SHIFT(1878),
  [3402] = {.count = 1, .reusable = false}, SHIFT(1876),
  [3404] = {.count = 1, .reusable = false}, SHIFT(1878),
  [3406] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1), SHIFT(342),
  [3409] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [3412] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [3416] = {.count = 1, .reusable = true}, SHIFT(2817),
  [3418] = {.count = 1, .reusable = false}, SHIFT(284),
  [3420] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2, .production_id = 47),
  [3422] = {.count = 1, .reusable = true}, SHIFT(156),
  [3424] = {.count = 1, .reusable = true}, SHIFT(2956),
  [3426] = {.count = 1, .reusable = true}, SHIFT(188),
  [3428] = {.count = 1, .reusable = true}, SHIFT(299),
  [3430] = {.count = 1, .reusable = false}, SHIFT(274),
  [3432] = {.count = 1, .reusable = true}, SHIFT(2811),
  [3434] = {.count = 1, .reusable = true}, SHIFT(224),
  [3436] = {.count = 1, .reusable = true}, SHIFT(288),
  [3438] = {.count = 1, .reusable = true}, SHIFT(2908),
  [3440] = {.count = 1, .reusable = true}, SHIFT(2816),
  [3442] = {.count = 1, .reusable = false}, SHIFT(261),
  [3444] = {.count = 1, .reusable = true}, SHIFT(2815),
  [3446] = {.count = 1, .reusable = true}, SHIFT(238),
  [3448] = {.count = 1, .reusable = true}, SHIFT(259),
  [3450] = {.count = 1, .reusable = true}, SHIFT(2779),
  [3452] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2, .production_id = 47),
  [3454] = {.count = 1, .reusable = true}, SHIFT(151),
  [3456] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(725),
  [3459] = {.count = 1, .reusable = true}, SHIFT(2819),
  [3461] = {.count = 1, .reusable = true}, SHIFT(2889),
  [3463] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3466] = {.count = 1, .reusable = true}, SHIFT(700),
  [3468] = {.count = 1, .reusable = true}, SHIFT(577),
  [3470] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 47),
  [3472] = {.count = 1, .reusable = true}, SHIFT(233),
  [3474] = {.count = 1, .reusable = true}, SHIFT(2083),
  [3476] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(235),
  [3479] = {.count = 1, .reusable = true}, SHIFT(235),
  [3481] = {.count = 1, .reusable = true}, SHIFT(2773),
  [3483] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 47),
  [3485] = {.count = 1, .reusable = true}, SHIFT(2848),
  [3487] = {.count = 1, .reusable = true}, SHIFT(2814),
  [3489] = {.count = 1, .reusable = false}, SHIFT(780),
  [3491] = {.count = 1, .reusable = true}, SHIFT(1966),
  [3493] = {.count = 1, .reusable = true}, SHIFT(2832),
  [3495] = {.count = 1, .reusable = true}, SHIFT(2818),
  [3497] = {.count = 1, .reusable = true}, SHIFT(2847),
  [3499] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1),
  [3501] = {.count = 1, .reusable = true}, SHIFT(2863),
  [3503] = {.count = 1, .reusable = false}, SHIFT(1844),
  [3505] = {.count = 1, .reusable = false}, SHIFT(898),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3509] = {.count = 1, .reusable = true}, SHIFT(921),
  [3511] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3513] = {.count = 1, .reusable = true}, SHIFT(237),
  [3515] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3517] = {.count = 1, .reusable = true}, SHIFT(1817),
  [3519] = {.count = 1, .reusable = false}, SHIFT(1453),
  [3521] = {.count = 1, .reusable = false}, SHIFT(1524),
  [3523] = {.count = 1, .reusable = false}, SHIFT(1450),
  [3525] = {.count = 1, .reusable = false}, SHIFT(1449),
  [3527] = {.count = 1, .reusable = true}, SHIFT(2644),
  [3529] = {.count = 1, .reusable = true}, SHIFT(297),
  [3531] = {.count = 1, .reusable = true}, SHIFT(340),
  [3533] = {.count = 1, .reusable = false}, SHIFT(2912),
  [3535] = {.count = 1, .reusable = true}, SHIFT(2070),
  [3537] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7),
  [3539] = {.count = 1, .reusable = true}, SHIFT(2964),
  [3541] = {.count = 1, .reusable = true}, SHIFT(2965),
  [3543] = {.count = 1, .reusable = true}, SHIFT(2053),
  [3545] = {.count = 1, .reusable = true}, SHIFT(2054),
  [3547] = {.count = 1, .reusable = true}, SHIFT(1955),
  [3549] = {.count = 1, .reusable = true}, SHIFT(2795),
  [3551] = {.count = 1, .reusable = true}, SHIFT(2966),
  [3553] = {.count = 1, .reusable = true}, SHIFT(2571),
  [3555] = {.count = 1, .reusable = true}, SHIFT(2905),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3559] = {.count = 1, .reusable = true}, SHIFT(2074),
  [3561] = {.count = 1, .reusable = true}, SHIFT(2803),
  [3563] = {.count = 1, .reusable = true}, SHIFT(2798),
  [3565] = {.count = 1, .reusable = true}, SHIFT(213),
  [3567] = {.count = 1, .reusable = true}, SHIFT(920),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1016),
  [3571] = {.count = 1, .reusable = true}, SHIFT(922),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1379),
  [3575] = {.count = 1, .reusable = true}, SHIFT(2969),
  [3577] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 7), REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [3580] = {.count = 1, .reusable = false}, SHIFT(2548),
  [3582] = {.count = 1, .reusable = false}, SHIFT(2838),
  [3584] = {.count = 1, .reusable = false}, REDUCE(sym_import, 1),
  [3586] = {.count = 1, .reusable = true}, SHIFT(2037),
  [3588] = {.count = 1, .reusable = true}, REDUCE(sym_import, 1),
  [3590] = {.count = 1, .reusable = false}, SHIFT(1881),
  [3592] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3594] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3596] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3598] = {.count = 1, .reusable = true}, SHIFT(433),
  [3600] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3602] = {.count = 1, .reusable = true}, SHIFT(1084),
  [3604] = {.count = 1, .reusable = true}, SHIFT(1095),
  [3606] = {.count = 1, .reusable = true}, SHIFT(1103),
  [3608] = {.count = 1, .reusable = true}, SHIFT(1873),
  [3610] = {.count = 1, .reusable = true}, SHIFT(1871),
  [3612] = {.count = 1, .reusable = true}, SHIFT(1865),
  [3614] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3616] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3618] = {.count = 1, .reusable = true}, SHIFT(440),
  [3620] = {.count = 1, .reusable = true}, SHIFT(436),
  [3622] = {.count = 1, .reusable = true}, SHIFT(239),
  [3624] = {.count = 1, .reusable = false}, SHIFT(711),
  [3626] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3628] = {.count = 1, .reusable = true}, SHIFT(661),
  [3630] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 8),
  [3632] = {.count = 1, .reusable = false}, REDUCE(sym_type_assertion, 2),
  [3634] = {.count = 1, .reusable = true}, REDUCE(sym_type_assertion, 2),
  [3636] = {.count = 1, .reusable = true}, SHIFT(1015),
  [3638] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(727),
  [3641] = {.count = 1, .reusable = true}, SHIFT(2852),
  [3643] = {.count = 1, .reusable = true}, SHIFT(695),
  [3645] = {.count = 1, .reusable = false}, SHIFT(397),
  [3647] = {.count = 1, .reusable = false}, SHIFT(402),
  [3649] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [3651] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [3653] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [3655] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [3657] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [3659] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [3661] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .production_id = 28),
  [3663] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .production_id = 28),
  [3665] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .production_id = 28),
  [3667] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .production_id = 28),
  [3669] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [3671] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [3673] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [3675] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [3677] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(727),
  [3680] = {.count = 1, .reusable = true}, SHIFT(726),
  [3682] = {.count = 1, .reusable = false}, SHIFT(1018),
  [3684] = {.count = 1, .reusable = false}, SHIFT(346),
  [3686] = {.count = 1, .reusable = true}, SHIFT(147),
  [3688] = {.count = 1, .reusable = true}, SHIFT(854),
  [3690] = {.count = 1, .reusable = false}, SHIFT(351),
  [3692] = {.count = 1, .reusable = false}, SHIFT(92),
  [3694] = {.count = 1, .reusable = true}, SHIFT(254),
  [3696] = {.count = 1, .reusable = true}, SHIFT(355),
  [3698] = {.count = 1, .reusable = true}, SHIFT(356),
  [3700] = {.count = 1, .reusable = true}, SHIFT(346),
  [3702] = {.count = 1, .reusable = false}, SHIFT(355),
  [3704] = {.count = 1, .reusable = false}, SHIFT(356),
  [3706] = {.count = 1, .reusable = false}, SHIFT(359),
  [3708] = {.count = 1, .reusable = true}, SHIFT(363),
  [3710] = {.count = 1, .reusable = true}, SHIFT(351),
  [3712] = {.count = 1, .reusable = false}, SHIFT(1035),
  [3714] = {.count = 1, .reusable = true}, SHIFT(1034),
  [3716] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 3),
  [3718] = {.count = 1, .reusable = true}, SHIFT(698),
  [3720] = {.count = 1, .reusable = false}, SHIFT(423),
  [3722] = {.count = 1, .reusable = true}, SHIFT(788),
  [3724] = {.count = 1, .reusable = false}, SHIFT(1384),
  [3726] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 55),
  [3728] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 57),
  [3730] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 55),
  [3732] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3734] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3, .production_id = 61),
  [3736] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(92),
  [3739] = {.count = 1, .reusable = true}, SHIFT(167),
  [3741] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3, .production_id = 55),
  [3743] = {.count = 1, .reusable = true}, SHIFT(692),
  [3745] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3747] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [3749] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 64),
  [3751] = {.count = 1, .reusable = true}, SHIFT(1056),
  [3753] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3755] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2, .production_id = 8),
  [3757] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(92),
  [3760] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [3762] = {.count = 1, .reusable = true}, SHIFT(27),
  [3764] = {.count = 1, .reusable = true}, SHIFT(2855),
  [3766] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 93),
  [3768] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 95),
  [3770] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 96),
  [3772] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [3774] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [3776] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [3778] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [3780] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5, .production_id = 125),
  [3782] = {.count = 1, .reusable = true}, SHIFT(723),
  [3784] = {.count = 1, .reusable = false}, SHIFT(1565),
  [3786] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 23),
  [3788] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [3790] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3792] = {.count = 1, .reusable = true}, SHIFT(19),
  [3794] = {.count = 1, .reusable = true}, SHIFT(2887),
  [3796] = {.count = 1, .reusable = false}, SHIFT(291),
  [3798] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 10),
  [3800] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(229),
  [3803] = {.count = 1, .reusable = true}, SHIFT(229),
  [3805] = {.count = 1, .reusable = false}, SHIFT(300),
  [3807] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 9),
  [3809] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(219),
  [3812] = {.count = 1, .reusable = true}, SHIFT(219),
  [3814] = {.count = 1, .reusable = true}, SHIFT(830),
  [3816] = {.count = 1, .reusable = true}, SHIFT(734),
  [3818] = {.count = 1, .reusable = false}, SHIFT(1862),
  [3820] = {.count = 1, .reusable = true}, SHIFT(649),
  [3822] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 103),
  [3824] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 103),
  [3826] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 102),
  [3828] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 102),
  [3830] = {.count = 1, .reusable = false}, SHIFT(270),
  [3832] = {.count = 1, .reusable = true}, SHIFT(645),
  [3834] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 72), REDUCE(sym_assignment_expression, 3, .production_id = 55),
  [3837] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 72),
  [3839] = {.count = 1, .reusable = false}, SHIFT(273),
  [3841] = {.count = 1, .reusable = true}, SHIFT(243),
  [3843] = {.count = 1, .reusable = false}, SHIFT(93),
  [3845] = {.count = 1, .reusable = true}, SHIFT(275),
  [3847] = {.count = 1, .reusable = true}, SHIFT(276),
  [3849] = {.count = 1, .reusable = true}, SHIFT(277),
  [3851] = {.count = 1, .reusable = true}, SHIFT(270),
  [3853] = {.count = 1, .reusable = false}, SHIFT(276),
  [3855] = {.count = 1, .reusable = false}, SHIFT(277),
  [3857] = {.count = 1, .reusable = false}, SHIFT(278),
  [3859] = {.count = 1, .reusable = true}, SHIFT(279),
  [3861] = {.count = 1, .reusable = true}, SHIFT(273),
  [3863] = {.count = 1, .reusable = false}, SHIFT(1485),
  [3865] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3867] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 72), REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [3870] = {.count = 1, .reusable = true}, SHIFT(681),
  [3872] = {.count = 1, .reusable = false}, SHIFT(1924),
  [3874] = {.count = 1, .reusable = true}, SHIFT(1107),
  [3876] = {.count = 1, .reusable = true}, SHIFT(148),
  [3878] = {.count = 1, .reusable = false}, SHIFT(1596),
  [3880] = {.count = 1, .reusable = true}, SHIFT(1984),
  [3882] = {.count = 1, .reusable = false}, SHIFT(1597),
  [3884] = {.count = 1, .reusable = false}, SHIFT(1690),
  [3886] = {.count = 1, .reusable = false}, SHIFT(1701),
  [3888] = {.count = 1, .reusable = false}, SHIFT(1633),
  [3890] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4, .production_id = 94),
  [3892] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4, .production_id = 94),
  [3894] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 26),
  [3896] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(93),
  [3899] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 96),
  [3901] = {.count = 1, .reusable = true}, SHIFT(815),
  [3903] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 95),
  [3905] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 94),
  [3907] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 94),
  [3909] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 120),
  [3911] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 120),
  [3913] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 93),
  [3915] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [3917] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [3919] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [3921] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [3923] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 92),
  [3925] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 92),
  [3927] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [3929] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2, .production_id = 17),
  [3931] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(93),
  [3934] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 62), REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [3937] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 62),
  [3939] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [3941] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [3943] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 63), REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [3946] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 63),
  [3948] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [3950] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [3952] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4, .production_id = 89),
  [3954] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4, .production_id = 89),
  [3956] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 88),
  [3959] = {.count = 1, .reusable = false}, SHIFT(776),
  [3961] = {.count = 1, .reusable = false}, SHIFT(777),
  [3963] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 129),
  [3965] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 129),
  [3967] = {.count = 1, .reusable = false}, REDUCE(sym_class, 2, .production_id = 13),
  [3969] = {.count = 1, .reusable = true}, REDUCE(sym_class, 2, .production_id = 13),
  [3971] = {.count = 1, .reusable = false}, SHIFT(290),
  [3973] = {.count = 1, .reusable = true}, SHIFT(657),
  [3975] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [3977] = {.count = 1, .reusable = false}, SHIFT(292),
  [3979] = {.count = 1, .reusable = true}, SHIFT(190),
  [3981] = {.count = 1, .reusable = false}, SHIFT(96),
  [3983] = {.count = 1, .reusable = true}, SHIFT(378),
  [3985] = {.count = 1, .reusable = true}, SHIFT(298),
  [3987] = {.count = 1, .reusable = true}, SHIFT(303),
  [3989] = {.count = 1, .reusable = true}, SHIFT(290),
  [3991] = {.count = 1, .reusable = false}, SHIFT(298),
  [3993] = {.count = 1, .reusable = false}, SHIFT(303),
  [3995] = {.count = 1, .reusable = false}, SHIFT(304),
  [3997] = {.count = 1, .reusable = true}, SHIFT(305),
  [3999] = {.count = 1, .reusable = true}, SHIFT(292),
  [4001] = {.count = 1, .reusable = false}, SHIFT(1661),
  [4003] = {.count = 1, .reusable = true}, SHIFT(1658),
  [4005] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [4007] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 50),
  [4009] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 50),
  [4011] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 51),
  [4013] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 51),
  [4015] = {.count = 1, .reusable = true}, SHIFT(866),
  [4017] = {.count = 1, .reusable = false}, SHIFT(1915),
  [4019] = {.count = 1, .reusable = true}, SHIFT(1420),
  [4021] = {.count = 1, .reusable = false}, SHIFT(1536),
  [4023] = {.count = 1, .reusable = false}, SHIFT(1530),
  [4025] = {.count = 1, .reusable = false}, SHIFT(1666),
  [4027] = {.count = 1, .reusable = false}, SHIFT(1699),
  [4029] = {.count = 1, .reusable = false}, SHIFT(1526),
  [4031] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [4033] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3, .production_id = 52),
  [4035] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3, .production_id = 52),
  [4037] = {.count = 1, .reusable = true}, SHIFT(2637),
  [4039] = {.count = 1, .reusable = false}, SHIFT(1916),
  [4041] = {.count = 1, .reusable = true}, SHIFT(2286),
  [4043] = {.count = 1, .reusable = false}, SHIFT(1544),
  [4045] = {.count = 1, .reusable = false}, SHIFT(1575),
  [4047] = {.count = 1, .reusable = false}, SHIFT(1687),
  [4049] = {.count = 1, .reusable = false}, SHIFT(1700),
  [4051] = {.count = 1, .reusable = false}, SHIFT(1577),
  [4053] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [4055] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 53),
  [4057] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [4059] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [4061] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [4063] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 54),
  [4065] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [4067] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [4069] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 57),
  [4071] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3, .production_id = 58),
  [4073] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3, .production_id = 58),
  [4075] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [4077] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [4079] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4082] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [4085] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [4088] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [4091] = {.count = 1, .reusable = false}, SHIFT(285),
  [4093] = {.count = 1, .reusable = false}, SHIFT(280),
  [4095] = {.count = 1, .reusable = false}, SHIFT(90),
  [4097] = {.count = 1, .reusable = true}, SHIFT(393),
  [4099] = {.count = 1, .reusable = true}, SHIFT(268),
  [4101] = {.count = 1, .reusable = true}, SHIFT(334),
  [4103] = {.count = 1, .reusable = true}, SHIFT(285),
  [4105] = {.count = 1, .reusable = false}, SHIFT(268),
  [4107] = {.count = 1, .reusable = false}, SHIFT(334),
  [4109] = {.count = 1, .reusable = false}, SHIFT(331),
  [4111] = {.count = 1, .reusable = true}, SHIFT(344),
  [4113] = {.count = 1, .reusable = true}, SHIFT(280),
  [4115] = {.count = 1, .reusable = false}, SHIFT(1917),
  [4117] = {.count = 1, .reusable = true}, SHIFT(2247),
  [4119] = {.count = 1, .reusable = false}, SHIFT(1615),
  [4121] = {.count = 1, .reusable = false}, SHIFT(1614),
  [4123] = {.count = 1, .reusable = false}, SHIFT(1665),
  [4125] = {.count = 1, .reusable = false}, SHIFT(1707),
  [4127] = {.count = 1, .reusable = false}, SHIFT(1590),
  [4129] = {.count = 1, .reusable = true}, SHIFT(607),
  [4131] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 64),
  [4133] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4135] = {.count = 1, .reusable = true}, SHIFT(935),
  [4137] = {.count = 1, .reusable = false}, SHIFT(1643),
  [4139] = {.count = 1, .reusable = false}, SHIFT(1642),
  [4141] = {.count = 1, .reusable = false}, SHIFT(1684),
  [4143] = {.count = 1, .reusable = false}, SHIFT(1703),
  [4145] = {.count = 1, .reusable = false}, SHIFT(1641),
  [4147] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2, .production_id = 76),
  [4149] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4151] = {.count = 1, .reusable = true}, SHIFT(1583),
  [4153] = {.count = 1, .reusable = false}, SHIFT(1446),
  [4155] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4157] = {.count = 1, .reusable = false}, SHIFT(1448),
  [4159] = {.count = 1, .reusable = false}, SHIFT(1772),
  [4161] = {.count = 1, .reusable = false}, SHIFT(1605),
  [4163] = {.count = 1, .reusable = false}, SHIFT(1282),
  [4165] = {.count = 1, .reusable = true}, SHIFT(934),
  [4167] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4169] = {.count = 1, .reusable = true}, SHIFT(327),
  [4171] = {.count = 1, .reusable = true}, SHIFT(322),
  [4173] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4175] = {.count = 1, .reusable = false}, SHIFT(1755),
  [4177] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(96),
  [4180] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 62),
  [4182] = {.count = 1, .reusable = true}, SHIFT(236),
  [4184] = {.count = 1, .reusable = true}, SHIFT(507),
  [4186] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5, .production_id = 125),
  [4188] = {.count = 1, .reusable = true}, SHIFT(357),
  [4190] = {.count = 1, .reusable = false}, SHIFT(1510),
  [4192] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4194] = {.count = 1, .reusable = false}, SHIFT(1549),
  [4196] = {.count = 1, .reusable = false}, SHIFT(1467),
  [4198] = {.count = 1, .reusable = false}, SHIFT(1971),
  [4200] = {.count = 1, .reusable = false}, SHIFT(1682),
  [4202] = {.count = 1, .reusable = false}, SHIFT(1685),
  [4204] = {.count = 1, .reusable = false}, SHIFT(1692),
  [4206] = {.count = 1, .reusable = false}, SHIFT(1710),
  [4208] = {.count = 1, .reusable = false}, SHIFT(1689),
  [4210] = {.count = 1, .reusable = true}, SHIFT(1159),
  [4212] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(90),
  [4215] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1844),
  [4218] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1797),
  [4221] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4223] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(237),
  [4226] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1446),
  [4229] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2343),
  [4232] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2344),
  [4235] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1804),
  [4238] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1800),
  [4241] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1448),
  [4244] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1772),
  [4247] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1605),
  [4250] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1450),
  [4253] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1282),
  [4256] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4258] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [4260] = {.count = 1, .reusable = true}, SHIFT(536),
  [4262] = {.count = 1, .reusable = true}, SHIFT(534),
  [4264] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [4266] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4268] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(774),
  [4271] = {.count = 1, .reusable = true}, SHIFT(2929),
  [4273] = {.count = 1, .reusable = true}, SHIFT(794),
  [4275] = {.count = 1, .reusable = true}, SHIFT(1127),
  [4277] = {.count = 1, .reusable = true}, SHIFT(1215),
  [4279] = {.count = 1, .reusable = true}, SHIFT(129),
  [4281] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 48),
  [4283] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 48),
  [4285] = {.count = 1, .reusable = false}, SHIFT(1067),
  [4287] = {.count = 1, .reusable = true}, SHIFT(1009),
  [4289] = {.count = 1, .reusable = true}, SHIFT(111),
  [4291] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 3),
  [4293] = {.count = 1, .reusable = true}, SHIFT(989),
  [4295] = {.count = 1, .reusable = true}, SHIFT(2290),
  [4297] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 63),
  [4299] = {.count = 1, .reusable = true}, SHIFT(1612),
  [4301] = {.count = 1, .reusable = true}, SHIFT(1712),
  [4303] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 55),
  [4305] = {.count = 1, .reusable = true}, SHIFT(1077),
  [4307] = {.count = 1, .reusable = true}, SHIFT(2228),
  [4309] = {.count = 1, .reusable = true}, SHIFT(548),
  [4311] = {.count = 1, .reusable = true}, SHIFT(559),
  [4313] = {.count = 1, .reusable = true}, SHIFT(1421),
  [4315] = {.count = 1, .reusable = true}, SHIFT(1171),
  [4317] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(96),
  [4320] = {.count = 1, .reusable = true}, SHIFT(1369),
  [4322] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [4324] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [4326] = {.count = 1, .reusable = true}, SHIFT(1608),
  [4328] = {.count = 1, .reusable = true}, SHIFT(460),
  [4330] = {.count = 1, .reusable = true}, SHIFT(463),
  [4332] = {.count = 1, .reusable = true}, SHIFT(2292),
  [4334] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 55),
  [4336] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(90),
  [4339] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [4341] = {.count = 1, .reusable = true}, SHIFT(1376),
  [4343] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 23),
  [4345] = {.count = 1, .reusable = true}, SHIFT(1158),
  [4347] = {.count = 1, .reusable = false}, SHIFT(375),
  [4349] = {.count = 1, .reusable = false}, SHIFT(387),
  [4351] = {.count = 1, .reusable = false}, SHIFT(258),
  [4353] = {.count = 1, .reusable = false}, SHIFT(256),
  [4355] = {.count = 1, .reusable = false}, SHIFT(91),
  [4357] = {.count = 1, .reusable = true}, SHIFT(267),
  [4359] = {.count = 1, .reusable = true}, SHIFT(253),
  [4361] = {.count = 1, .reusable = true}, SHIFT(252),
  [4363] = {.count = 1, .reusable = true}, SHIFT(258),
  [4365] = {.count = 1, .reusable = false}, SHIFT(253),
  [4367] = {.count = 1, .reusable = false}, SHIFT(252),
  [4369] = {.count = 1, .reusable = false}, SHIFT(251),
  [4371] = {.count = 1, .reusable = true}, SHIFT(250),
  [4373] = {.count = 1, .reusable = true}, SHIFT(256),
  [4375] = {.count = 1, .reusable = false}, SHIFT(282),
  [4377] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(244),
  [4380] = {.count = 1, .reusable = true}, SHIFT(244),
  [4382] = {.count = 1, .reusable = false}, SHIFT(369),
  [4384] = {.count = 1, .reusable = false}, SHIFT(373),
  [4386] = {.count = 1, .reusable = false}, SHIFT(97),
  [4388] = {.count = 1, .reusable = true}, SHIFT(343),
  [4390] = {.count = 1, .reusable = true}, SHIFT(377),
  [4392] = {.count = 1, .reusable = true}, SHIFT(381),
  [4394] = {.count = 1, .reusable = true}, SHIFT(369),
  [4396] = {.count = 1, .reusable = false}, SHIFT(377),
  [4398] = {.count = 1, .reusable = false}, SHIFT(381),
  [4400] = {.count = 1, .reusable = false}, SHIFT(383),
  [4402] = {.count = 1, .reusable = true}, SHIFT(388),
  [4404] = {.count = 1, .reusable = true}, SHIFT(373),
  [4406] = {.count = 1, .reusable = true}, SHIFT(821),
  [4408] = {.count = 1, .reusable = true}, SHIFT(1632),
  [4410] = {.count = 1, .reusable = true}, SHIFT(2346),
  [4412] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 14), SHIFT(721),
  [4415] = {.count = 1, .reusable = true}, SHIFT(2826),
  [4417] = {.count = 1, .reusable = true}, SHIFT(739),
  [4419] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4421] = {.count = 1, .reusable = false}, SHIFT(1432),
  [4423] = {.count = 1, .reusable = true}, SHIFT(1809),
  [4425] = {.count = 1, .reusable = false}, SHIFT(1796),
  [4427] = {.count = 1, .reusable = false}, SHIFT(1522),
  [4429] = {.count = 1, .reusable = false}, SHIFT(1436),
  [4431] = {.count = 1, .reusable = true}, SHIFT(876),
  [4433] = {.count = 1, .reusable = true}, SHIFT(601),
  [4435] = {.count = 1, .reusable = true}, SHIFT(2203),
  [4437] = {.count = 1, .reusable = true}, SHIFT(602),
  [4439] = {.count = 1, .reusable = true}, SHIFT(605),
  [4441] = {.count = 1, .reusable = true}, SHIFT(603),
  [4443] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 73),
  [4445] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(774),
  [4448] = {.count = 1, .reusable = true}, SHIFT(576),
  [4450] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(91),
  [4453] = {.count = 1, .reusable = true}, SHIFT(654),
  [4455] = {.count = 1, .reusable = true}, SHIFT(588),
  [4457] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(91),
  [4460] = {.count = 1, .reusable = true}, SHIFT(31),
  [4462] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 8), SHIFT(97),
  [4465] = {.count = 1, .reusable = true}, SHIFT(9),
  [4467] = {.count = 1, .reusable = true}, SHIFT(1776),
  [4469] = {.count = 1, .reusable = false}, SHIFT(1508),
  [4471] = {.count = 1, .reusable = true}, SHIFT(1811),
  [4473] = {.count = 1, .reusable = false}, SHIFT(1790),
  [4475] = {.count = 1, .reusable = false}, SHIFT(1541),
  [4477] = {.count = 1, .reusable = true}, SHIFT(608),
  [4479] = {.count = 1, .reusable = true}, SHIFT(609),
  [4481] = {.count = 1, .reusable = true}, SHIFT(41),
  [4483] = {.count = 1, .reusable = true}, SHIFT(2205),
  [4485] = {.count = 1, .reusable = true}, SHIFT(610),
  [4487] = {.count = 1, .reusable = true}, SHIFT(604),
  [4489] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 61), SHIFT(97),
  [4492] = {.count = 1, .reusable = false}, SHIFT(283),
  [4494] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4497] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [4499] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [4502] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(245),
  [4505] = {.count = 1, .reusable = true}, SHIFT(245),
  [4507] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4509] = {.count = 1, .reusable = true}, SHIFT(678),
  [4511] = {.count = 1, .reusable = false}, SHIFT(1500),
  [4513] = {.count = 1, .reusable = false}, REDUCE(sym__parameter_name, 1),
  [4515] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [4519] = {.count = 1, .reusable = true}, SHIFT(269),
  [4521] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 12), SHIFT(387),
  [4524] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4527] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 12),
  [4529] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 11), SHIFT(375),
  [4532] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4535] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 11),
  [4537] = {.count = 1, .reusable = true}, SHIFT(1624),
  [4539] = {.count = 1, .reusable = true}, SHIFT(1779),
  [4541] = {.count = 1, .reusable = false}, SHIFT(1512),
  [4543] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4545] = {.count = 1, .reusable = false}, SHIFT(1556),
  [4547] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4549] = {.count = 1, .reusable = false}, SHIFT(1756),
  [4551] = {.count = 1, .reusable = false}, SHIFT(28),
  [4553] = {.count = 1, .reusable = true}, SHIFT(2828),
  [4555] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(721),
  [4558] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4560] = {.count = 1, .reusable = false}, SHIFT(1743),
  [4562] = {.count = 1, .reusable = false}, SHIFT(1430),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4566] = {.count = 1, .reusable = false}, SHIFT(1454),
  [4568] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4570] = {.count = 1, .reusable = false}, SHIFT(1574),
  [4572] = {.count = 1, .reusable = false}, SHIFT(310),
  [4574] = {.count = 1, .reusable = false}, SHIFT(307),
  [4576] = {.count = 1, .reusable = false}, SHIFT(1455),
  [4578] = {.count = 1, .reusable = true}, SHIFT(1795),
  [4580] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4582] = {.count = 1, .reusable = false}, SHIFT(1727),
  [4584] = {.count = 1, .reusable = false}, SHIFT(1490),
  [4586] = {.count = 1, .reusable = true}, SHIFT(1814),
  [4588] = {.count = 1, .reusable = false}, SHIFT(1533),
  [4590] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4592] = {.count = 1, .reusable = false}, SHIFT(1753),
  [4594] = {.count = 1, .reusable = true}, SHIFT(338),
  [4596] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4598] = {.count = 1, .reusable = false}, SHIFT(1601),
  [4600] = {.count = 1, .reusable = true}, SHIFT(1782),
  [4602] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4604] = {.count = 1, .reusable = false}, SHIFT(1737),
  [4606] = {.count = 1, .reusable = false}, SHIFT(792),
  [4608] = {.count = 1, .reusable = false}, SHIFT(791),
  [4610] = {.count = 1, .reusable = true}, SHIFT(332),
  [4612] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4614] = {.count = 1, .reusable = false}, SHIFT(1511),
  [4616] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4618] = {.count = 1, .reusable = false}, SHIFT(1552),
  [4620] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4622] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4624] = {.count = 1, .reusable = false}, SHIFT(1738),
  [4626] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4628] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4630] = {.count = 1, .reusable = false}, SHIFT(1750),
  [4632] = {.count = 1, .reusable = false}, SHIFT(1468),
  [4634] = {.count = 1, .reusable = true}, SHIFT(1813),
  [4636] = {.count = 1, .reusable = false}, SHIFT(1580),
  [4638] = {.count = 1, .reusable = true}, SHIFT(390),
  [4640] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4642] = {.count = 1, .reusable = false}, SHIFT(1463),
  [4644] = {.count = 1, .reusable = true}, SHIFT(1812),
  [4646] = {.count = 1, .reusable = false}, SHIFT(1582),
  [4648] = {.count = 1, .reusable = false}, SHIFT(1493),
  [4650] = {.count = 1, .reusable = false}, SHIFT(348),
  [4652] = {.count = 1, .reusable = false}, SHIFT(246),
  [4654] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4657] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [4659] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [4662] = {.count = 1, .reusable = true}, SHIFT(405),
  [4664] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4666] = {.count = 1, .reusable = false}, SHIFT(1754),
  [4668] = {.count = 1, .reusable = true}, SHIFT(301),
  [4670] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4672] = {.count = 1, .reusable = false}, SHIFT(1729),
  [4674] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4676] = {.count = 1, .reusable = false}, SHIFT(1725),
  [4678] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4680] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4682] = {.count = 1, .reusable = false}, SHIFT(1757),
  [4684] = {.count = 1, .reusable = false}, SHIFT(1425),
  [4686] = {.count = 1, .reusable = false}, SHIFT(352),
  [4688] = {.count = 1, .reusable = false}, SHIFT(353),
  [4690] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4692] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4694] = {.count = 1, .reusable = false}, SHIFT(737),
  [4696] = {.count = 1, .reusable = false}, SHIFT(733),
  [4698] = {.count = 1, .reusable = true}, SHIFT(669),
  [4700] = {.count = 1, .reusable = true}, SHIFT(2272),
  [4702] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4704] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4706] = {.count = 1, .reusable = true}, SHIFT(2253),
  [4708] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4710] = {.count = 1, .reusable = false}, SHIFT(248),
  [4712] = {.count = 1, .reusable = false}, SHIFT(249),
  [4714] = {.count = 1, .reusable = false}, SHIFT(1947),
  [4716] = {.count = 1, .reusable = true}, SHIFT(142),
  [4718] = {.count = 1, .reusable = true}, SHIFT(1976),
  [4720] = {.count = 1, .reusable = false}, SHIFT(1872),
  [4722] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4724] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2, .production_id = 18),
  [4726] = {.count = 1, .reusable = true}, SHIFT(136),
  [4728] = {.count = 1, .reusable = false}, SHIFT(2952),
  [4730] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4732] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [4734] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [4736] = {.count = 1, .reusable = false}, SHIFT(2944),
  [4738] = {.count = 1, .reusable = true}, SHIFT(2529),
  [4740] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4742] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 28),
  [4744] = {.count = 1, .reusable = true}, SHIFT(2472),
  [4746] = {.count = 1, .reusable = true}, SHIFT(2463),
  [4748] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4750] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 56),
  [4752] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 56),
  [4754] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 25),
  [4756] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 25),
  [4758] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4760] = {.count = 1, .reusable = true}, SHIFT(2714),
  [4762] = {.count = 1, .reusable = true}, SHIFT(354),
  [4764] = {.count = 1, .reusable = true}, SHIFT(289),
  [4766] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 59),
  [4768] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 59),
  [4770] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4772] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 17),
  [4774] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4776] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4778] = {.count = 1, .reusable = false}, SHIFT(1728),
  [4780] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4782] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4784] = {.count = 1, .reusable = false}, SHIFT(1726),
  [4786] = {.count = 1, .reusable = true}, SHIFT(1777),
  [4788] = {.count = 1, .reusable = false}, SHIFT(1716),
  [4790] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4792] = {.count = 1, .reusable = false}, SHIFT(1742),
  [4794] = {.count = 1, .reusable = false}, SHIFT(1719),
  [4796] = {.count = 1, .reusable = false}, SHIFT(1717),
  [4798] = {.count = 1, .reusable = true}, SHIFT(166),
  [4800] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 147),
  [4802] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 147),
  [4804] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4806] = {.count = 1, .reusable = true}, SHIFT(1724),
  [4808] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4810] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 131),
  [4812] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 122),
  [4814] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 122),
  [4816] = {.count = 1, .reusable = true}, SHIFT(1731),
  [4818] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3, .production_id = 74),
  [4820] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3, .production_id = 74),
  [4822] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4826] = {.count = 1, .reusable = false}, SHIFT(2155),
  [4828] = {.count = 1, .reusable = false}, SHIFT(2156),
  [4830] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 18),
  [4832] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 98),
  [4834] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 98),
  [4836] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 151),
  [4838] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 151),
  [4840] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 168),
  [4842] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 168),
  [4844] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 169),
  [4846] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 169),
  [4848] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 176),
  [4850] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 176),
  [4852] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 177),
  [4854] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 177),
  [4856] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9, .production_id = 181),
  [4858] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9, .production_id = 181),
  [4860] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 105),
  [4862] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 105),
  [4864] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4866] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [4868] = {.count = 1, .reusable = true}, SHIFT(1765),
  [4870] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4872] = {.count = 1, .reusable = false}, SHIFT(1392),
  [4874] = {.count = 1, .reusable = false}, SHIFT(1773),
  [4876] = {.count = 1, .reusable = false}, SHIFT(1336),
  [4878] = {.count = 1, .reusable = true}, SHIFT(585),
  [4880] = {.count = 1, .reusable = true}, SHIFT(2326),
  [4882] = {.count = 1, .reusable = true}, SHIFT(524),
  [4884] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4886] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4888] = {.count = 1, .reusable = true}, SHIFT(2257),
  [4890] = {.count = 1, .reusable = true}, SHIFT(2222),
  [4892] = {.count = 1, .reusable = true}, SHIFT(2277),
  [4894] = {.count = 1, .reusable = true}, SHIFT(593),
  [4896] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [4898] = {.count = 1, .reusable = false}, SHIFT(1513),
  [4900] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [4902] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [4904] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22), SHIFT_REPEAT(1800),
  [4907] = {.count = 1, .reusable = false}, SHIFT(1718),
  [4909] = {.count = 1, .reusable = false}, SHIFT(1501),
  [4911] = {.count = 1, .reusable = true}, SHIFT(1778),
  [4913] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4915] = {.count = 1, .reusable = false}, SHIFT(1618),
  [4917] = {.count = 1, .reusable = false}, SHIFT(1576),
  [4919] = {.count = 1, .reusable = true}, SHIFT(1775),
  [4921] = {.count = 1, .reusable = true}, SHIFT(1810),
  [4923] = {.count = 1, .reusable = false}, SHIFT(1567),
  [4925] = {.count = 1, .reusable = false}, SHIFT(1534),
  [4927] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4929] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [4931] = {.count = 1, .reusable = false}, SHIFT(1739),
  [4933] = {.count = 1, .reusable = false}, SHIFT(1677),
  [4935] = {.count = 1, .reusable = false}, SHIFT(1673),
  [4937] = {.count = 1, .reusable = true}, SHIFT(711),
  [4939] = {.count = 1, .reusable = true}, SHIFT(2943),
  [4941] = {.count = 1, .reusable = true}, SHIFT(379),
  [4943] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1, .production_id = 5),
  [4945] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4947] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4949] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 70),
  [4951] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4953] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4955] = {.count = 1, .reusable = true}, SHIFT(702),
  [4957] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 14), REDUCE(sym_type_parameter, 1, .production_id = 14),
  [4960] = {.count = 1, .reusable = true}, SHIFT(707),
  [4962] = {.count = 1, .reusable = true}, SHIFT(741),
  [4964] = {.count = 1, .reusable = true}, SHIFT(2884),
  [4966] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4968] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 113),
  [4970] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4972] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4974] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4976] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 142),
  [4978] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4980] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4982] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 142),
  [4984] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4986] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 113),
  [4988] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4990] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1, .production_id = 5),
  [4992] = {.count = 1, .reusable = true}, SHIFT(94),
  [4994] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4996] = {.count = 1, .reusable = true}, SHIFT(1842),
  [4998] = {.count = 1, .reusable = true}, SHIFT(1839),
  [5000] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 70),
  [5002] = {.count = 1, .reusable = true}, SHIFT(1821),
  [5004] = {.count = 1, .reusable = true}, SHIFT(1833),
  [5006] = {.count = 1, .reusable = true}, SHIFT(1827),
  [5008] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 70),
  [5010] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 70),
  [5012] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 142),
  [5014] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 5),
  [5016] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 113),
  [5018] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 113),
  [5020] = {.count = 1, .reusable = true}, SHIFT(694),
  [5022] = {.count = 1, .reusable = true}, SHIFT(710),
  [5024] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 14),
  [5027] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 142),
  [5029] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 5),
  [5031] = {.count = 1, .reusable = true}, SHIFT(2841),
  [5033] = {.count = 1, .reusable = true}, SHIFT(719),
  [5035] = {.count = 1, .reusable = false}, SHIFT(716),
  [5037] = {.count = 1, .reusable = false}, SHIFT(1911),
  [5039] = {.count = 1, .reusable = true}, SHIFT(1187),
  [5041] = {.count = 1, .reusable = false}, SHIFT(761),
  [5043] = {.count = 1, .reusable = false}, SHIFT(153),
  [5045] = {.count = 1, .reusable = true}, SHIFT(691),
  [5047] = {.count = 1, .reusable = false}, SHIFT(1914),
  [5049] = {.count = 1, .reusable = true}, SHIFT(1210),
  [5051] = {.count = 1, .reusable = false}, SHIFT(1901),
  [5053] = {.count = 1, .reusable = false}, SHIFT(1896),
  [5055] = {.count = 1, .reusable = false}, SHIFT(1908),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5059] = {.count = 1, .reusable = true}, SHIFT(2838),
  [5061] = {.count = 1, .reusable = false}, SHIFT(1907),
  [5063] = {.count = 1, .reusable = true}, SHIFT(1207),
  [5065] = {.count = 1, .reusable = false}, SHIFT(1898),
  [5067] = {.count = 1, .reusable = false}, SHIFT(1906),
  [5069] = {.count = 1, .reusable = false}, SHIFT(1909),
  [5071] = {.count = 1, .reusable = false}, SHIFT(1902),
  [5073] = {.count = 1, .reusable = true}, SHIFT(761),
  [5075] = {.count = 1, .reusable = true}, SHIFT(153),
  [5077] = {.count = 1, .reusable = true}, SHIFT(1229),
  [5079] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [5081] = {.count = 1, .reusable = true}, SHIFT(1216),
  [5083] = {.count = 1, .reusable = true}, SHIFT(1196),
  [5085] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3),
  [5087] = {.count = 1, .reusable = true}, SHIFT(21),
  [5089] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [5091] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [5094] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [5097] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 14),
  [5099] = {.count = 1, .reusable = true}, SHIFT(2138),
  [5101] = {.count = 1, .reusable = true}, SHIFT(2064),
  [5103] = {.count = 1, .reusable = true}, SHIFT(1667),
  [5105] = {.count = 1, .reusable = true}, SHIFT(1920),
  [5107] = {.count = 1, .reusable = true}, SHIFT(2822),
  [5109] = {.count = 1, .reusable = true}, SHIFT(2666),
  [5111] = {.count = 1, .reusable = true}, SHIFT(155),
  [5113] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [5115] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5, .production_id = 110),
  [5117] = {.count = 1, .reusable = true}, SHIFT(2187),
  [5119] = {.count = 1, .reusable = true}, SHIFT(2034),
  [5121] = {.count = 1, .reusable = true}, SHIFT(2127),
  [5123] = {.count = 1, .reusable = true}, SHIFT(2066),
  [5125] = {.count = 1, .reusable = true}, SHIFT(482),
  [5127] = {.count = 1, .reusable = true}, SHIFT(2780),
  [5129] = {.count = 1, .reusable = true}, SHIFT(400),
  [5131] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [5133] = {.count = 1, .reusable = true}, SHIFT(2023),
  [5135] = {.count = 1, .reusable = true}, SHIFT(2954),
  [5137] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [5139] = {.count = 1, .reusable = true}, SHIFT(2144),
  [5141] = {.count = 1, .reusable = true}, SHIFT(2062),
  [5143] = {.count = 1, .reusable = true}, SHIFT(2213),
  [5145] = {.count = 1, .reusable = true}, SHIFT(2049),
  [5147] = {.count = 1, .reusable = false}, SHIFT(1964),
  [5149] = {.count = 1, .reusable = true}, SHIFT(1128),
  [5151] = {.count = 1, .reusable = true}, SHIFT(144),
  [5153] = {.count = 1, .reusable = false}, SHIFT(2793),
  [5155] = {.count = 1, .reusable = true}, SHIFT(2214),
  [5157] = {.count = 1, .reusable = true}, SHIFT(2048),
  [5159] = {.count = 1, .reusable = true}, SHIFT(2142),
  [5161] = {.count = 1, .reusable = true}, SHIFT(2063),
  [5163] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2, .production_id = 87),
  [5165] = {.count = 1, .reusable = true}, SHIFT(431),
  [5167] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 97),
  [5169] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 115),
  [5171] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [5173] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 139),
  [5175] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 121),
  [5177] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6, .production_id = 138),
  [5179] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 160),
  [5181] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 161),
  [5183] = {.count = 1, .reusable = true}, SHIFT(2154),
  [5185] = {.count = 1, .reusable = true}, SHIFT(2002),
  [5187] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 170),
  [5189] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 171),
  [5191] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 178),
  [5193] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 179),
  [5195] = {.count = 1, .reusable = true}, SHIFT(349),
  [5197] = {.count = 1, .reusable = true}, SHIFT(2280),
  [5199] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8, .production_id = 182),
  [5201] = {.count = 1, .reusable = true}, SHIFT(2168),
  [5203] = {.count = 1, .reusable = true}, SHIFT(2050),
  [5205] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [5207] = {.count = 1, .reusable = false}, REDUCE(sym_type_annotation, 2),
  [5209] = {.count = 1, .reusable = false}, SHIFT(2809),
  [5211] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5213] = {.count = 1, .reusable = true}, SHIFT(2058),
  [5215] = {.count = 1, .reusable = true}, SHIFT(910),
  [5217] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5219] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5221] = {.count = 1, .reusable = true}, SHIFT(911),
  [5223] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [5225] = {.count = 1, .reusable = true}, SHIFT(916),
  [5227] = {.count = 1, .reusable = true}, SHIFT(2191),
  [5229] = {.count = 1, .reusable = false}, SHIFT(2494),
  [5231] = {.count = 1, .reusable = true}, SHIFT(2804),
  [5233] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5235] = {.count = 1, .reusable = false}, SHIFT(2805),
  [5237] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5239] = {.count = 1, .reusable = true}, SHIFT(912),
  [5241] = {.count = 1, .reusable = true}, SHIFT(1890),
  [5243] = {.count = 1, .reusable = true}, SHIFT(2110),
  [5245] = {.count = 1, .reusable = true}, SHIFT(2028),
  [5247] = {.count = 1, .reusable = true}, SHIFT(1546),
  [5249] = {.count = 1, .reusable = true}, SHIFT(241),
  [5251] = {.count = 1, .reusable = true}, SHIFT(1964),
  [5253] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 3, .production_id = 65),
  [5255] = {.count = 1, .reusable = true}, SHIFT(2140),
  [5257] = {.count = 1, .reusable = true}, SHIFT(2211),
  [5259] = {.count = 1, .reusable = true}, SHIFT(2014),
  [5261] = {.count = 1, .reusable = true}, SHIFT(1655),
  [5263] = {.count = 1, .reusable = true}, SHIFT(2968),
  [5265] = {.count = 1, .reusable = true}, SHIFT(542),
  [5267] = {.count = 1, .reusable = true}, SHIFT(232),
  [5269] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [5271] = {.count = 1, .reusable = true}, SHIFT(535),
  [5273] = {.count = 1, .reusable = true}, SHIFT(2177),
  [5275] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [5277] = {.count = 1, .reusable = true}, SHIFT(2088),
  [5279] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(2028),
  [5282] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [5284] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(241),
  [5287] = {.count = 1, .reusable = true}, SHIFT(907),
  [5289] = {.count = 1, .reusable = true}, SHIFT(1057),
  [5291] = {.count = 1, .reusable = true}, SHIFT(908),
  [5293] = {.count = 1, .reusable = true}, SHIFT(909),
  [5295] = {.count = 1, .reusable = true}, SHIFT(2098),
  [5297] = {.count = 1, .reusable = true}, SHIFT(915),
  [5299] = {.count = 1, .reusable = true}, SHIFT(913),
  [5301] = {.count = 1, .reusable = true}, SHIFT(1617),
  [5303] = {.count = 1, .reusable = true}, SHIFT(2878),
  [5305] = {.count = 1, .reusable = true}, SHIFT(2882),
  [5307] = {.count = 1, .reusable = true}, SHIFT(902),
  [5309] = {.count = 1, .reusable = true}, SHIFT(904),
  [5311] = {.count = 1, .reusable = true}, SHIFT(2128),
  [5313] = {.count = 1, .reusable = true}, SHIFT(903),
  [5315] = {.count = 1, .reusable = true}, SHIFT(2283),
  [5317] = {.count = 1, .reusable = true}, SHIFT(2236),
  [5319] = {.count = 1, .reusable = true}, SHIFT(2233),
  [5321] = {.count = 1, .reusable = true}, SHIFT(2132),
  [5323] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5325] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5327] = {.count = 1, .reusable = true}, SHIFT(2139),
  [5329] = {.count = 1, .reusable = true}, SHIFT(906),
  [5331] = {.count = 1, .reusable = true}, SHIFT(2259),
  [5333] = {.count = 1, .reusable = true}, SHIFT(2105),
  [5335] = {.count = 1, .reusable = true}, SHIFT(1431),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5339] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5341] = {.count = 1, .reusable = true}, SHIFT(2124),
  [5343] = {.count = 1, .reusable = true}, SHIFT(2119),
  [5345] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5347] = {.count = 1, .reusable = true}, SHIFT(914),
  [5349] = {.count = 1, .reusable = true}, SHIFT(1471),
  [5351] = {.count = 1, .reusable = true}, SHIFT(2117),
  [5353] = {.count = 1, .reusable = true}, SHIFT(2076),
  [5355] = {.count = 1, .reusable = true}, SHIFT(1052),
  [5357] = {.count = 1, .reusable = true}, SHIFT(725),
  [5359] = {.count = 1, .reusable = true}, SHIFT(2113),
  [5361] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(2968),
  [5364] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [5366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(232),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2112),
  [5371] = {.count = 1, .reusable = true}, SHIFT(2107),
  [5373] = {.count = 1, .reusable = true}, SHIFT(905),
  [5375] = {.count = 1, .reusable = true}, SHIFT(422),
  [5377] = {.count = 1, .reusable = true}, SHIFT(1113),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2059),
  [5381] = {.count = 1, .reusable = true}, SHIFT(1489),
  [5383] = {.count = 1, .reusable = true}, SHIFT(2151),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2106),
  [5387] = {.count = 1, .reusable = true}, SHIFT(2103),
  [5389] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(919),
  [5392] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [5394] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 38),
  [5396] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 116),
  [5398] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [5400] = {.count = 1, .reusable = true}, SHIFT(26),
  [5402] = {.count = 1, .reusable = true}, SHIFT(687),
  [5404] = {.count = 1, .reusable = true}, SHIFT(418),
  [5406] = {.count = 1, .reusable = true}, SHIFT(667),
  [5408] = {.count = 1, .reusable = true}, SHIFT(1867),
  [5410] = {.count = 1, .reusable = true}, SHIFT(1706),
  [5412] = {.count = 1, .reusable = true}, SHIFT(1869),
  [5414] = {.count = 1, .reusable = true}, SHIFT(752),
  [5416] = {.count = 1, .reusable = true}, SHIFT(441),
  [5418] = {.count = 1, .reusable = true}, SHIFT(2791),
  [5420] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 30),
  [5422] = {.count = 1, .reusable = true}, SHIFT(1892),
  [5424] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 141),
  [5426] = {.count = 1, .reusable = true}, SHIFT(665),
  [5428] = {.count = 1, .reusable = true}, SHIFT(1394),
  [5430] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 84),
  [5432] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 114),
  [5434] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 140),
  [5436] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 83),
  [5438] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(752),
  [5441] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 1, .production_id = 46),
  [5443] = {.count = 1, .reusable = true}, SHIFT(1759),
  [5445] = {.count = 1, .reusable = true}, SHIFT(592),
  [5447] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [5449] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 163),
  [5451] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 30),
  [5453] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [5455] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3),
  [5457] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 82),
  [5459] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2),
  [5461] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 30),
  [5463] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 172),
  [5465] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 39),
  [5467] = {.count = 1, .reusable = true}, SHIFT(1474),
  [5469] = {.count = 1, .reusable = true}, SHIFT(2904),
  [5471] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [5473] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 162),
  [5475] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5477] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 141),
  [5479] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 140),
  [5481] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 163),
  [5483] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 162),
  [5485] = {.count = 1, .reusable = true}, SHIFT(2949),
  [5487] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [5489] = {.count = 1, .reusable = true}, SHIFT(675),
  [5491] = {.count = 1, .reusable = true}, SHIFT(1621),
  [5493] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [5495] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .production_id = 18),
  [5497] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [5499] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5501] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [5503] = {.count = 1, .reusable = true}, SHIFT(1620),
  [5505] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [5507] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 116),
  [5509] = {.count = 1, .reusable = true}, SHIFT(1705),
  [5511] = {.count = 1, .reusable = true}, SHIFT(1860),
  [5513] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [5515] = {.count = 1, .reusable = true}, SHIFT(672),
  [5517] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5519] = {.count = 1, .reusable = true}, SHIFT(1763),
  [5521] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5523] = {.count = 1, .reusable = true}, SHIFT(2178),
  [5525] = {.count = 1, .reusable = true}, SHIFT(1065),
  [5527] = {.count = 1, .reusable = true}, SHIFT(2266),
  [5529] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5531] = {.count = 1, .reusable = true}, SHIFT(684),
  [5533] = {.count = 1, .reusable = true}, SHIFT(1043),
  [5535] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6, .production_id = 172),
  [5537] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 114),
  [5539] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2016),
  [5543] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5545] = {.count = 1, .reusable = false}, SHIFT(1046),
  [5547] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5549] = {.count = 1, .reusable = false}, SHIFT(2333),
  [5551] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5553] = {.count = 1, .reusable = true}, SHIFT(2339),
  [5555] = {.count = 1, .reusable = false}, SHIFT(2339),
  [5557] = {.count = 1, .reusable = true}, SHIFT(2169),
  [5559] = {.count = 1, .reusable = false}, SHIFT(406),
  [5561] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5563] = {.count = 1, .reusable = false}, SHIFT(2310),
  [5565] = {.count = 1, .reusable = true}, SHIFT(172),
  [5567] = {.count = 1, .reusable = true}, SHIFT(1889),
  [5569] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5571] = {.count = 1, .reusable = true}, SHIFT(716),
  [5573] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5575] = {.count = 1, .reusable = false}, SHIFT(2308),
  [5577] = {.count = 1, .reusable = true}, SHIFT(2161),
  [5579] = {.count = 1, .reusable = true}, SHIFT(2829),
  [5581] = {.count = 1, .reusable = false}, SHIFT(409),
  [5583] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2016),
  [5586] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [5588] = {.count = 1, .reusable = true}, SHIFT(531),
  [5590] = {.count = 1, .reusable = true}, SHIFT(2783),
  [5592] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [5594] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [5596] = {.count = 1, .reusable = false}, SHIFT(1638),
  [5598] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5600] = {.count = 1, .reusable = false}, SHIFT(2320),
  [5602] = {.count = 1, .reusable = false}, SHIFT(1013),
  [5604] = {.count = 1, .reusable = true}, SHIFT(2295),
  [5606] = {.count = 1, .reusable = false}, SHIFT(2295),
  [5608] = {.count = 1, .reusable = true}, SHIFT(2296),
  [5610] = {.count = 1, .reusable = false}, SHIFT(2296),
  [5612] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5614] = {.count = 1, .reusable = false}, SHIFT(2321),
  [5616] = {.count = 1, .reusable = false}, SHIFT(1604),
  [5618] = {.count = 1, .reusable = true}, SHIFT(2193),
  [5620] = {.count = 1, .reusable = true}, SHIFT(547),
  [5622] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .production_id = 14),
  [5624] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [5626] = {.count = 1, .reusable = true}, SHIFT(581),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5630] = {.count = 1, .reusable = true}, SHIFT(520),
  [5632] = {.count = 1, .reusable = true}, SHIFT(1885),
  [5634] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3, .production_id = 47),
  [5636] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3, .production_id = 47),
  [5638] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [5640] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2333),
  [5643] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(2333),
  [5646] = {.count = 1, .reusable = true}, SHIFT(1872),
  [5648] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [5650] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [5652] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(156),
  [5655] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(137),
  [5658] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [5660] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2339),
  [5663] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2339),
  [5666] = {.count = 1, .reusable = true}, SHIFT(570),
  [5668] = {.count = 1, .reusable = false}, SHIFT(119),
  [5670] = {.count = 1, .reusable = true}, SHIFT(2365),
  [5672] = {.count = 1, .reusable = false}, SHIFT(2365),
  [5674] = {.count = 1, .reusable = false}, SHIFT(1803),
  [5676] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5678] = {.count = 1, .reusable = false}, SHIFT(2380),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2381),
  [5682] = {.count = 1, .reusable = false}, SHIFT(2381),
  [5684] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [5686] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5688] = {.count = 1, .reusable = false}, SHIFT(2364),
  [5690] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(151),
  [5693] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [5695] = {.count = 1, .reusable = true}, SHIFT(2263),
  [5697] = {.count = 1, .reusable = true}, SHIFT(579),
  [5699] = {.count = 1, .reusable = false}, SHIFT(936),
  [5701] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [5703] = {.count = 1, .reusable = true}, SHIFT(2252),
  [5705] = {.count = 1, .reusable = true}, SHIFT(589),
  [5707] = {.count = 1, .reusable = true}, SHIFT(586),
  [5709] = {.count = 1, .reusable = false}, SHIFT(110),
  [5711] = {.count = 1, .reusable = false}, SHIFT(930),
  [5713] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5715] = {.count = 1, .reusable = false}, SHIFT(2357),
  [5717] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5719] = {.count = 1, .reusable = false}, SHIFT(2359),
  [5721] = {.count = 1, .reusable = true}, SHIFT(525),
  [5723] = {.count = 1, .reusable = true}, SHIFT(1708),
  [5725] = {.count = 1, .reusable = true}, SHIFT(2104),
  [5727] = {.count = 1, .reusable = true}, SHIFT(2102),
  [5729] = {.count = 1, .reusable = false}, SHIFT(1802),
  [5731] = {.count = 1, .reusable = true}, SHIFT(1064),
  [5733] = {.count = 1, .reusable = true}, SHIFT(131),
  [5735] = {.count = 1, .reusable = true}, SHIFT(2641),
  [5737] = {.count = 1, .reusable = true}, SHIFT(1764),
  [5739] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(718),
  [5742] = {.count = 1, .reusable = true}, SHIFT(676),
  [5744] = {.count = 1, .reusable = true}, SHIFT(417),
  [5746] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 29),
  [5748] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(735),
  [5751] = {.count = 1, .reusable = true}, SHIFT(1850),
  [5753] = {.count = 1, .reusable = false}, SHIFT(2519),
  [5755] = {.count = 1, .reusable = false}, SHIFT(2963),
  [5757] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5759] = {.count = 1, .reusable = true}, SHIFT(939),
  [5761] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 145),
  [5763] = {.count = 1, .reusable = true}, SHIFT(940),
  [5765] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5767] = {.count = 1, .reusable = true}, SHIFT(2255),
  [5769] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .production_id = 71),
  [5771] = {.count = 1, .reusable = true}, SHIFT(941),
  [5773] = {.count = 1, .reusable = true}, SHIFT(1680),
  [5775] = {.count = 1, .reusable = true}, SHIFT(1934),
  [5777] = {.count = 1, .reusable = true}, SHIFT(426),
  [5779] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [5781] = {.count = 1, .reusable = true}, SHIFT(1891),
  [5783] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(2341),
  [5786] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [5788] = {.count = 1, .reusable = true}, SHIFT(2962),
  [5790] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5792] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [5794] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 173),
  [5796] = {.count = 1, .reusable = true}, SHIFT(2212),
  [5798] = {.count = 1, .reusable = true}, SHIFT(2961),
  [5800] = {.count = 1, .reusable = true}, SHIFT(668),
  [5802] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 121),
  [5804] = {.count = 1, .reusable = true}, SHIFT(1390),
  [5806] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5808] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5810] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 144),
  [5812] = {.count = 1, .reusable = true}, SHIFT(1494),
  [5814] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 139),
  [5816] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 143),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2099),
  [5820] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 174),
  [5822] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 161),
  [5824] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 146),
  [5826] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [5828] = {.count = 1, .reusable = true}, SHIFT(937),
  [5830] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 31),
  [5832] = {.count = 1, .reusable = true}, SHIFT(1864),
  [5834] = {.count = 1, .reusable = true}, SHIFT(1678),
  [5836] = {.count = 1, .reusable = true}, SHIFT(1866),
  [5838] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5840] = {.count = 1, .reusable = true}, SHIFT(2175),
  [5842] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(722),
  [5845] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [5847] = {.count = 1, .reusable = true}, SHIFT(1715),
  [5849] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 167),
  [5851] = {.count = 1, .reusable = true}, SHIFT(2708),
  [5853] = {.count = 1, .reusable = true}, SHIFT(565),
  [5855] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(771),
  [5858] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 29),
  [5860] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5862] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [5864] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(755),
  [5867] = {.count = 1, .reusable = true}, SHIFT(2108),
  [5869] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 160),
  [5871] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [5873] = {.count = 1, .reusable = true}, SHIFT(1674),
  [5875] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 175),
  [5877] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(1693),
  [5880] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22),
  [5882] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6, .production_id = 170),
  [5884] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 166),
  [5886] = {.count = 1, .reusable = true}, SHIFT(1686),
  [5888] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5890] = {.count = 1, .reusable = true}, SHIFT(2241),
  [5892] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 165),
  [5894] = {.count = 1, .reusable = true}, SHIFT(1473),
  [5896] = {.count = 1, .reusable = true}, SHIFT(670),
  [5898] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(699),
  [5901] = {.count = 1, .reusable = true}, SHIFT(1928),
  [5903] = {.count = 1, .reusable = true}, SHIFT(2085),
  [5905] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(2735),
  [5908] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [5910] = {.count = 1, .reusable = true}, SHIFT(1131),
  [5912] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .production_id = 71),
  [5914] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5916] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5918] = {.count = 1, .reusable = true}, SHIFT(428),
  [5920] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5922] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1768),
  [5925] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 79),
  [5927] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 78),
  [5929] = {.count = 1, .reusable = true}, SHIFT(2274),
  [5931] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 164),
  [5933] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [5935] = {.count = 1, .reusable = true}, SHIFT(2953),
  [5937] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [5939] = {.count = 1, .reusable = true}, SHIFT(2196),
  [5941] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5943] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 117),
  [5945] = {.count = 1, .reusable = true}, SHIFT(1036),
  [5947] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21), SHIFT(744),
  [5950] = {.count = 1, .reusable = true}, SHIFT(1102),
  [5952] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type_clause, 3, .production_id = 14),
  [5954] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 77),
  [5956] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1155),
  [5959] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [5961] = {.count = 1, .reusable = true}, SHIFT(130),
  [5963] = {.count = 1, .reusable = true}, SHIFT(2660),
  [5965] = {.count = 1, .reusable = true}, SHIFT(2166),
  [5967] = {.count = 1, .reusable = true}, SHIFT(2172),
  [5969] = {.count = 1, .reusable = true}, SHIFT(2710),
  [5971] = {.count = 1, .reusable = true}, SHIFT(522),
  [5973] = {.count = 1, .reusable = true}, SHIFT(2180),
  [5975] = {.count = 1, .reusable = true}, SHIFT(1683),
  [5977] = {.count = 1, .reusable = true}, SHIFT(1058),
  [5979] = {.count = 1, .reusable = true}, SHIFT(1055),
  [5981] = {.count = 1, .reusable = true}, SHIFT(732),
  [5983] = {.count = 1, .reusable = true}, SHIFT(673),
  [5985] = {.count = 1, .reusable = true}, SHIFT(1762),
  [5987] = {.count = 1, .reusable = true}, SHIFT(567),
  [5989] = {.count = 1, .reusable = true}, SHIFT(1085),
  [5991] = {.count = 1, .reusable = true}, SHIFT(1093),
  [5993] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3, .production_id = 97),
  [5995] = {.count = 1, .reusable = true}, SHIFT(1564),
  [5997] = {.count = 1, .reusable = true}, SHIFT(1418),
  [5999] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .production_id = 71),
  [6001] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 118),
  [6003] = {.count = 1, .reusable = true}, SHIFT(1586),
  [6005] = {.count = 1, .reusable = true}, SHIFT(1424),
  [6007] = {.count = 1, .reusable = true}, SHIFT(1388),
  [6009] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 77),
  [6011] = {.count = 1, .reusable = true}, SHIFT(1426),
  [6013] = {.count = 1, .reusable = true}, SHIFT(1619),
  [6015] = {.count = 1, .reusable = true}, SHIFT(2453),
  [6017] = {.count = 1, .reusable = true}, SHIFT(1520),
  [6019] = {.count = 1, .reusable = true}, SHIFT(2173),
  [6021] = {.count = 1, .reusable = true}, SHIFT(693),
  [6023] = {.count = 1, .reusable = true}, SHIFT(1517),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2394),
  [6027] = {.count = 1, .reusable = true}, SHIFT(712),
  [6029] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7, .production_id = 180),
  [6031] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(2373),
  [6034] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [6036] = {.count = 1, .reusable = true}, SHIFT(1631),
  [6038] = {.count = 1, .reusable = true}, SHIFT(1634),
  [6040] = {.count = 1, .reusable = true}, SHIFT(1001),
  [6042] = {.count = 1, .reusable = true}, SHIFT(1669),
  [6044] = {.count = 1, .reusable = true}, SHIFT(2122),
  [6046] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [6048] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [6050] = {.count = 1, .reusable = true}, SHIFT(674),
  [6052] = {.count = 1, .reusable = true}, SHIFT(424),
  [6054] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 3), SHIFT(714),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2902),
  [6059] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2, .production_id = 70),
  [6061] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 40),
  [6063] = {.count = 1, .reusable = true}, SHIFT(2146),
  [6065] = {.count = 1, .reusable = true}, SHIFT(2971),
  [6067] = {.count = 1, .reusable = true}, SHIFT(225),
  [6069] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 71),
  [6071] = {.count = 1, .reusable = true}, SHIFT(222),
  [6073] = {.count = 1, .reusable = true}, SHIFT(587),
  [6075] = {.count = 1, .reusable = true}, SHIFT(572),
  [6077] = {.count = 1, .reusable = true}, SHIFT(512),
  [6079] = {.count = 1, .reusable = true}, SHIFT(1613),
  [6081] = {.count = 1, .reusable = true}, SHIFT(2143),
  [6083] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3, .production_id = 104),
  [6085] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [6087] = {.count = 1, .reusable = true}, SHIFT(1017),
  [6089] = {.count = 1, .reusable = true}, SHIFT(2091),
  [6091] = {.count = 1, .reusable = true}, SHIFT(2957),
  [6093] = {.count = 1, .reusable = true}, SHIFT(510),
  [6095] = {.count = 1, .reusable = true}, SHIFT(2021),
  [6097] = {.count = 1, .reusable = true}, SHIFT(28),
  [6099] = {.count = 1, .reusable = true}, SHIFT(157),
  [6101] = {.count = 1, .reusable = true}, SHIFT(2131),
  [6103] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6105] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 109),
  [6107] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 111),
  [6109] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2, .production_id = 67),
  [6111] = {.count = 1, .reusable = true}, SHIFT(1760),
  [6113] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [6115] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .production_id = 14),
  [6117] = {.count = 1, .reusable = true}, SHIFT(1761),
  [6119] = {.count = 1, .reusable = true}, SHIFT(33),
  [6121] = {.count = 1, .reusable = true}, SHIFT(580),
  [6123] = {.count = 1, .reusable = true}, SHIFT(538),
  [6125] = {.count = 1, .reusable = true}, SHIFT(2519),
  [6127] = {.count = 1, .reusable = true}, SHIFT(537),
  [6129] = {.count = 1, .reusable = true}, SHIFT(2559),
  [6131] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 75),
  [6133] = {.count = 1, .reusable = true}, SHIFT(2207),
  [6135] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6137] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 85),
  [6139] = {.count = 1, .reusable = true}, SHIFT(1380),
  [6141] = {.count = 1, .reusable = true}, SHIFT(516),
  [6143] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 85),
  [6145] = {.count = 1, .reusable = true}, SHIFT(1851),
  [6147] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4, .production_id = 130),
  [6149] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [6151] = {.count = 1, .reusable = true}, SHIFT(411),
  [6153] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2, .production_id = 40),
  [6155] = {.count = 1, .reusable = true}, SHIFT(824),
  [6157] = {.count = 1, .reusable = true}, SHIFT(438),
  [6159] = {.count = 1, .reusable = true}, SHIFT(837),
  [6161] = {.count = 1, .reusable = true}, SHIFT(714),
  [6163] = {.count = 1, .reusable = false}, SHIFT(1284),
  [6165] = {.count = 1, .reusable = true}, SHIFT(869),
  [6167] = {.count = 1, .reusable = true}, SHIFT(2911),
  [6169] = {.count = 1, .reusable = true}, SHIFT(2572),
  [6171] = {.count = 1, .reusable = true}, SHIFT(1439),
  [6173] = {.count = 1, .reusable = true}, SHIFT(1912),
  [6175] = {.count = 1, .reusable = true}, SHIFT(2609),
  [6177] = {.count = 1, .reusable = true}, SHIFT(814),
  [6179] = {.count = 1, .reusable = true}, SHIFT(1903),
  [6181] = {.count = 1, .reusable = true}, SHIFT(1900),
  [6183] = {.count = 1, .reusable = true}, SHIFT(174),
  [6185] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .production_id = 75),
  [6187] = {.count = 1, .reusable = true}, SHIFT(2615),
  [6189] = {.count = 1, .reusable = true}, SHIFT(2688),
  [6191] = {.count = 1, .reusable = true}, SHIFT(1910),
  [6193] = {.count = 1, .reusable = true}, SHIFT(2593),
  [6195] = {.count = 1, .reusable = true}, SHIFT(2351),
  [6197] = {.count = 1, .reusable = true}, SHIFT(2712),
  [6199] = {.count = 1, .reusable = true}, SHIFT(176),
  [6201] = {.count = 1, .reusable = true}, SHIFT(173),
  [6203] = {.count = 1, .reusable = true}, SHIFT(171),
  [6205] = {.count = 1, .reusable = true}, SHIFT(170),
  [6207] = {.count = 1, .reusable = true}, SHIFT(1933),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2560),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2567),
  [6213] = {.count = 1, .reusable = false}, SHIFT(2895),
  [6215] = {.count = 1, .reusable = true}, SHIFT(2709),
  [6217] = {.count = 1, .reusable = false}, SHIFT(2938),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2693),
  [6221] = {.count = 1, .reusable = true}, SHIFT(2094),
  [6223] = {.count = 1, .reusable = true}, SHIFT(858),
  [6225] = {.count = 1, .reusable = true}, SHIFT(806),
  [6227] = {.count = 1, .reusable = true}, SHIFT(877),
  [6229] = {.count = 1, .reusable = true}, SHIFT(870),
  [6231] = {.count = 1, .reusable = true}, SHIFT(796),
  [6233] = {.count = 1, .reusable = true}, SHIFT(874),
  [6235] = {.count = 1, .reusable = true}, SHIFT(865),
  [6237] = {.count = 1, .reusable = true}, SHIFT(864),
  [6239] = {.count = 1, .reusable = true}, SHIFT(728),
  [6241] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6243] = {.count = 1, .reusable = true}, SHIFT(729),
  [6245] = {.count = 1, .reusable = true}, SHIFT(1595),
  [6247] = {.count = 1, .reusable = true}, SHIFT(730),
  [6249] = {.count = 1, .reusable = true}, SHIFT(1598),
  [6251] = {.count = 1, .reusable = true}, SHIFT(1905),
  [6253] = {.count = 1, .reusable = true}, SHIFT(738),
  [6255] = {.count = 1, .reusable = true}, SHIFT(127),
  [6257] = {.count = 1, .reusable = true}, SHIFT(860),
  [6259] = {.count = 1, .reusable = true}, SHIFT(1584),
  [6261] = {.count = 1, .reusable = true}, SHIFT(747),
  [6263] = {.count = 1, .reusable = true}, SHIFT(751),
  [6265] = {.count = 1, .reusable = true}, SHIFT(2246),
  [6267] = {.count = 1, .reusable = true}, SHIFT(2875),
  [6269] = {.count = 1, .reusable = true}, SHIFT(757),
  [6271] = {.count = 1, .reusable = true}, SHIFT(861),
  [6273] = {.count = 1, .reusable = true}, SHIFT(1843),
  [6275] = {.count = 1, .reusable = true}, SHIFT(770),
  [6277] = {.count = 1, .reusable = true}, SHIFT(2575),
  [6279] = {.count = 1, .reusable = true}, SHIFT(326),
  [6281] = {.count = 1, .reusable = true}, SHIFT(325),
  [6283] = {.count = 1, .reusable = true}, SHIFT(873),
  [6285] = {.count = 1, .reusable = true}, SHIFT(888),
  [6287] = {.count = 1, .reusable = true}, SHIFT(789),
  [6289] = {.count = 1, .reusable = true}, SHIFT(787),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2596),
  [6293] = {.count = 1, .reusable = true}, SHIFT(1068),
  [6295] = {.count = 1, .reusable = true}, SHIFT(786),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2677),
  [6299] = {.count = 1, .reusable = true}, SHIFT(1054),
  [6301] = {.count = 1, .reusable = false}, SHIFT(1462),
  [6303] = {.count = 1, .reusable = true}, SHIFT(775),
  [6305] = {.count = 1, .reusable = true}, SHIFT(1026),
  [6307] = {.count = 1, .reusable = true}, SHIFT(709),
  [6309] = {.count = 1, .reusable = true}, SHIFT(2597),
  [6311] = {.count = 1, .reusable = true}, SHIFT(798),
  [6313] = {.count = 1, .reusable = true}, SHIFT(891),
  [6315] = {.count = 1, .reusable = true}, SHIFT(750),
  [6317] = {.count = 1, .reusable = true}, SHIFT(2625),
  [6319] = {.count = 1, .reusable = true}, SHIFT(1897),
  [6321] = {.count = 1, .reusable = true}, SHIFT(671),
  [6323] = {.count = 1, .reusable = true}, SHIFT(744),
  [6325] = {.count = 1, .reusable = true}, SHIFT(816),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2807),
  [6329] = {.count = 1, .reusable = true}, SHIFT(175),
  [6331] = {.count = 1, .reusable = true}, SHIFT(177),
  [6333] = {.count = 1, .reusable = true}, SHIFT(181),
  [6335] = {.count = 1, .reusable = true}, SHIFT(182),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2959),
  [6339] = {.count = 1, .reusable = false}, SHIFT(2856),
  [6341] = {.count = 1, .reusable = true}, SHIFT(2516),
  [6343] = {.count = 1, .reusable = true}, SHIFT(2960),
  [6345] = {.count = 1, .reusable = true}, SHIFT(735),
  [6347] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [6349] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6351] = {.count = 1, .reusable = true}, SHIFT(1825),
  [6353] = {.count = 1, .reusable = true}, SHIFT(722),
  [6355] = {.count = 1, .reusable = true}, SHIFT(652),
  [6357] = {.count = 1, .reusable = true}, SHIFT(991),
  [6359] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6361] = {.count = 1, .reusable = true}, SHIFT(863),
  [6363] = {.count = 1, .reusable = true}, SHIFT(1566),
  [6365] = {.count = 1, .reusable = true}, SHIFT(208),
  [6367] = {.count = 1, .reusable = true}, SHIFT(209),
  [6369] = {.count = 1, .reusable = true}, SHIFT(214),
  [6371] = {.count = 1, .reusable = false}, SHIFT(1415),
  [6373] = {.count = 1, .reusable = true}, SHIFT(699),
  [6375] = {.count = 1, .reusable = true}, SHIFT(1857),
  [6377] = {.count = 1, .reusable = true}, SHIFT(230),
  [6379] = {.count = 1, .reusable = true}, SHIFT(867),
  [6381] = {.count = 1, .reusable = true}, SHIFT(223),
  [6383] = {.count = 1, .reusable = true}, SHIFT(2752),
  [6385] = {.count = 1, .reusable = true}, SHIFT(2583),
  [6387] = {.count = 1, .reusable = true}, SHIFT(2584),
  [6389] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6391] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [6393] = {.count = 1, .reusable = true}, SHIFT(688),
  [6395] = {.count = 1, .reusable = true}, SHIFT(240),
  [6397] = {.count = 1, .reusable = true}, SHIFT(2671),
  [6399] = {.count = 1, .reusable = true}, SHIFT(736),
  [6401] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6403] = {.count = 1, .reusable = true}, SHIFT(740),
  [6405] = {.count = 1, .reusable = true}, SHIFT(1969),
  [6407] = {.count = 1, .reusable = true}, SHIFT(234),
  [6409] = {.count = 1, .reusable = true}, SHIFT(231),
  [6411] = {.count = 1, .reusable = true}, SHIFT(228),
  [6413] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6415] = {.count = 1, .reusable = true}, SHIFT(771),
  [6417] = {.count = 1, .reusable = true}, SHIFT(2715),
  [6419] = {.count = 1, .reusable = true}, SHIFT(743),
  [6421] = {.count = 1, .reusable = true}, SHIFT(754),
  [6423] = {.count = 1, .reusable = true}, SHIFT(1476),
  [6425] = {.count = 1, .reusable = true}, SHIFT(756),
  [6427] = {.count = 1, .reusable = true}, SHIFT(606),
  [6429] = {.count = 1, .reusable = true}, SHIFT(420),
  [6431] = {.count = 1, .reusable = true}, SHIFT(662),
  [6433] = {.count = 1, .reusable = true}, SHIFT(1109),
  [6435] = {.count = 1, .reusable = true}, SHIFT(197),
  [6437] = {.count = 1, .reusable = true}, SHIFT(195),
  [6439] = {.count = 1, .reusable = true}, SHIFT(194),
  [6441] = {.count = 1, .reusable = false}, SHIFT(1194),
  [6443] = {.count = 1, .reusable = true}, SHIFT(793),
  [6445] = {.count = 1, .reusable = true}, SHIFT(1387),
  [6447] = {.count = 1, .reusable = true}, SHIFT(755),
  [6449] = {.count = 1, .reusable = true}, SHIFT(410),
  [6451] = {.count = 1, .reusable = true}, SHIFT(1694),
  [6453] = {.count = 1, .reusable = true}, SHIFT(658),
  [6455] = {.count = 1, .reusable = true}, SHIFT(185),
  [6457] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [6459] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .production_id = 75),
  [6461] = {.count = 1, .reusable = false}, SHIFT(2775),
  [6463] = {.count = 1, .reusable = true}, SHIFT(1695),
  [6465] = {.count = 1, .reusable = true}, SHIFT(2611),
  [6467] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6469] = {.count = 1, .reusable = true}, SHIFT(748),
  [6471] = {.count = 1, .reusable = true}, SHIFT(879),
  [6473] = {.count = 1, .reusable = true}, SHIFT(2206),
  [6475] = {.count = 1, .reusable = true}, SHIFT(718),
  [6477] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [6479] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [6481] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .production_id = 75),
  [6483] = {.count = 1, .reusable = true}, SHIFT(2963),
  [6485] = {.count = 1, .reusable = true}, SHIFT(2554),
  [6487] = {.count = 1, .reusable = true}, SHIFT(2549),
  [6489] = {.count = 1, .reusable = true}, SHIFT(2924),
  [6491] = {.count = 1, .reusable = true}, SHIFT(2647),
  [6493] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [6495] = {.count = 1, .reusable = true}, SHIFT(8),
  [6497] = {.count = 1, .reusable = true}, SHIFT(2706),
  [6499] = {.count = 1, .reusable = true}, SHIFT(2601),
  [6501] = {.count = 1, .reusable = true}, SHIFT(2149),
  [6503] = {.count = 1, .reusable = true}, SHIFT(2100),
};

void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
